-- MySQL dump 10.13  Distrib 8.0.33, for Linux (x86_64)
--
-- Host: localhost    Database: 
-- ------------------------------------------------------
-- Server version	8.0.33

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!50503 SET NAMES utf8mb4 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!50606 SET @OLD_INNODB_STATS_AUTO_RECALC=@@INNODB_STATS_AUTO_RECALC */;
/*!50606 SET GLOBAL INNODB_STATS_AUTO_RECALC=OFF */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Current Database: `mysql`
--

CREATE DATABASE /*!32312 IF NOT EXISTS*/ `mysql` /*!40100 DEFAULT CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci */ /*!80016 DEFAULT ENCRYPTION='N' */;

USE `mysql`;

--
-- Table structure for table `columns_priv`
--

DROP TABLE IF EXISTS `columns_priv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `columns_priv` (
  `Host` char(255) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL DEFAULT '',
  `Db` char(64) COLLATE utf8mb3_bin NOT NULL DEFAULT '',
  `User` char(32) COLLATE utf8mb3_bin NOT NULL DEFAULT '',
  `Table_name` char(64) COLLATE utf8mb3_bin NOT NULL DEFAULT '',
  `Column_name` char(64) COLLATE utf8mb3_bin NOT NULL DEFAULT '',
  `Timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `Column_priv` set('Select','Insert','Update','References') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`Host`,`User`,`Db`,`Table_name`,`Column_name`)
) /*!50100 TABLESPACE `mysql` */ ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_bin STATS_PERSISTENT=0 ROW_FORMAT=DYNAMIC COMMENT='Column privileges';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `columns_priv`
--

LOCK TABLES `columns_priv` WRITE;
/*!40000 ALTER TABLE `columns_priv` DISABLE KEYS */;
/*!40000 ALTER TABLE `columns_priv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `component`
--

DROP TABLE IF EXISTS `component`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `component` (
  `component_id` int unsigned NOT NULL AUTO_INCREMENT,
  `component_group_id` int unsigned NOT NULL,
  `component_urn` text NOT NULL,
  PRIMARY KEY (`component_id`)
) /*!50100 TABLESPACE `mysql` */ ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 ROW_FORMAT=DYNAMIC COMMENT='Components';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `component`
--

LOCK TABLES `component` WRITE;
/*!40000 ALTER TABLE `component` DISABLE KEYS */;
/*!40000 ALTER TABLE `component` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `db`
--

DROP TABLE IF EXISTS `db`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `db` (
  `Host` char(255) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL DEFAULT '',
  `Db` char(64) COLLATE utf8mb3_bin NOT NULL DEFAULT '',
  `User` char(32) COLLATE utf8mb3_bin NOT NULL DEFAULT '',
  `Select_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Insert_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Update_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Delete_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Create_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Drop_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Grant_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `References_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Index_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Alter_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Create_tmp_table_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Lock_tables_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Create_view_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Show_view_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Create_routine_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Alter_routine_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Execute_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Event_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Trigger_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  PRIMARY KEY (`Host`,`User`,`Db`),
  KEY `User` (`User`)
) /*!50100 TABLESPACE `mysql` */ ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_bin STATS_PERSISTENT=0 ROW_FORMAT=DYNAMIC COMMENT='Database privileges';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `db`
--

LOCK TABLES `db` WRITE;
/*!40000 ALTER TABLE `db` DISABLE KEYS */;
INSERT INTO `db` VALUES ('%','wordpress','wordpress','Y','Y','Y','Y','Y','Y','N','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y'),('localhost','performance_schema','mysql.session','Y','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N'),('localhost','sys','mysql.sys','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','Y');
/*!40000 ALTER TABLE `db` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `default_roles`
--

DROP TABLE IF EXISTS `default_roles`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `default_roles` (
  `HOST` char(255) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL DEFAULT '',
  `USER` char(32) COLLATE utf8mb3_bin NOT NULL DEFAULT '',
  `DEFAULT_ROLE_HOST` char(255) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL DEFAULT '%',
  `DEFAULT_ROLE_USER` char(32) COLLATE utf8mb3_bin NOT NULL DEFAULT '',
  PRIMARY KEY (`HOST`,`USER`,`DEFAULT_ROLE_HOST`,`DEFAULT_ROLE_USER`)
) /*!50100 TABLESPACE `mysql` */ ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_bin STATS_PERSISTENT=0 ROW_FORMAT=DYNAMIC COMMENT='Default roles';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `default_roles`
--

LOCK TABLES `default_roles` WRITE;
/*!40000 ALTER TABLE `default_roles` DISABLE KEYS */;
/*!40000 ALTER TABLE `default_roles` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `engine_cost`
--

DROP TABLE IF EXISTS `engine_cost`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `engine_cost` (
  `engine_name` varchar(64) NOT NULL,
  `device_type` int NOT NULL,
  `cost_name` varchar(64) NOT NULL,
  `cost_value` float DEFAULT NULL,
  `last_update` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `comment` varchar(1024) DEFAULT NULL,
  `default_value` float GENERATED ALWAYS AS ((case `cost_name` when _utf8mb3'io_block_read_cost' then 1.0 when _utf8mb3'memory_block_read_cost' then 0.25 else NULL end)) VIRTUAL,
  PRIMARY KEY (`cost_name`,`engine_name`,`device_type`)
) /*!50100 TABLESPACE `mysql` */ ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 STATS_PERSISTENT=0 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `engine_cost`
--

LOCK TABLES `engine_cost` WRITE;
/*!40000 ALTER TABLE `engine_cost` DISABLE KEYS */;
INSERT INTO `engine_cost` (`engine_name`, `device_type`, `cost_name`, `cost_value`, `last_update`, `comment`) VALUES ('default',0,'io_block_read_cost',NULL,'2023-07-24 15:19:58',NULL),('default',0,'memory_block_read_cost',NULL,'2023-07-24 15:19:58',NULL);
/*!40000 ALTER TABLE `engine_cost` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `func`
--

DROP TABLE IF EXISTS `func`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `func` (
  `name` char(64) COLLATE utf8mb3_bin NOT NULL DEFAULT '',
  `ret` tinyint NOT NULL DEFAULT '0',
  `dl` char(128) COLLATE utf8mb3_bin NOT NULL DEFAULT '',
  `type` enum('function','aggregate') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL,
  PRIMARY KEY (`name`)
) /*!50100 TABLESPACE `mysql` */ ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_bin STATS_PERSISTENT=0 ROW_FORMAT=DYNAMIC COMMENT='User defined functions';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `func`
--

LOCK TABLES `func` WRITE;
/*!40000 ALTER TABLE `func` DISABLE KEYS */;
/*!40000 ALTER TABLE `func` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `global_grants`
--

DROP TABLE IF EXISTS `global_grants`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `global_grants` (
  `USER` char(32) COLLATE utf8mb3_bin NOT NULL DEFAULT '',
  `HOST` char(255) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL DEFAULT '',
  `PRIV` char(32) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT '',
  `WITH_GRANT_OPTION` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  PRIMARY KEY (`USER`,`HOST`,`PRIV`)
) /*!50100 TABLESPACE `mysql` */ ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_bin STATS_PERSISTENT=0 ROW_FORMAT=DYNAMIC COMMENT='Extended global grants';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `global_grants`
--

LOCK TABLES `global_grants` WRITE;
/*!40000 ALTER TABLE `global_grants` DISABLE KEYS */;
INSERT INTO `global_grants` VALUES ('mysql.infoschema','localhost','AUDIT_ABORT_EXEMPT','N'),('mysql.infoschema','localhost','FIREWALL_EXEMPT','N'),('mysql.infoschema','localhost','SYSTEM_USER','N'),('mysql.session','localhost','AUDIT_ABORT_EXEMPT','N'),('mysql.session','localhost','AUTHENTICATION_POLICY_ADMIN','N'),('mysql.session','localhost','BACKUP_ADMIN','N'),('mysql.session','localhost','CLONE_ADMIN','N'),('mysql.session','localhost','CONNECTION_ADMIN','N'),('mysql.session','localhost','FIREWALL_EXEMPT','N'),('mysql.session','localhost','PERSIST_RO_VARIABLES_ADMIN','N'),('mysql.session','localhost','SESSION_VARIABLES_ADMIN','N'),('mysql.session','localhost','SYSTEM_USER','N'),('mysql.session','localhost','SYSTEM_VARIABLES_ADMIN','N'),('mysql.sys','localhost','AUDIT_ABORT_EXEMPT','N'),('mysql.sys','localhost','FIREWALL_EXEMPT','N'),('mysql.sys','localhost','SYSTEM_USER','N'),('root','%','APPLICATION_PASSWORD_ADMIN','Y'),('root','%','AUDIT_ABORT_EXEMPT','Y'),('root','%','AUDIT_ADMIN','Y'),('root','%','AUTHENTICATION_POLICY_ADMIN','Y'),('root','%','BACKUP_ADMIN','Y'),('root','%','BINLOG_ADMIN','Y'),('root','%','BINLOG_ENCRYPTION_ADMIN','Y'),('root','%','CLONE_ADMIN','Y'),('root','%','CONNECTION_ADMIN','Y'),('root','%','ENCRYPTION_KEY_ADMIN','Y'),('root','%','FIREWALL_EXEMPT','Y'),('root','%','FLUSH_OPTIMIZER_COSTS','Y'),('root','%','FLUSH_STATUS','Y'),('root','%','FLUSH_TABLES','Y'),('root','%','FLUSH_USER_RESOURCES','Y'),('root','%','GROUP_REPLICATION_ADMIN','Y'),('root','%','GROUP_REPLICATION_STREAM','Y'),('root','%','INNODB_REDO_LOG_ARCHIVE','Y'),('root','%','INNODB_REDO_LOG_ENABLE','Y'),('root','%','PASSWORDLESS_USER_ADMIN','Y'),('root','%','PERSIST_RO_VARIABLES_ADMIN','Y'),('root','%','REPLICATION_APPLIER','Y'),('root','%','REPLICATION_SLAVE_ADMIN','Y'),('root','%','RESOURCE_GROUP_ADMIN','Y'),('root','%','RESOURCE_GROUP_USER','Y'),('root','%','ROLE_ADMIN','Y'),('root','%','SENSITIVE_VARIABLES_OBSERVER','Y'),('root','%','SERVICE_CONNECTION_ADMIN','Y'),('root','%','SESSION_VARIABLES_ADMIN','Y'),('root','%','SET_USER_ID','Y'),('root','%','SHOW_ROUTINE','Y'),('root','%','SYSTEM_USER','Y'),('root','%','SYSTEM_VARIABLES_ADMIN','Y'),('root','%','TABLE_ENCRYPTION_ADMIN','Y'),('root','%','TELEMETRY_LOG_ADMIN','Y'),('root','%','XA_RECOVER_ADMIN','Y'),('root','localhost','APPLICATION_PASSWORD_ADMIN','Y'),('root','localhost','AUDIT_ABORT_EXEMPT','Y'),('root','localhost','AUDIT_ADMIN','Y'),('root','localhost','AUTHENTICATION_POLICY_ADMIN','Y'),('root','localhost','BACKUP_ADMIN','Y'),('root','localhost','BINLOG_ADMIN','Y'),('root','localhost','BINLOG_ENCRYPTION_ADMIN','Y'),('root','localhost','CLONE_ADMIN','Y'),('root','localhost','CONNECTION_ADMIN','Y'),('root','localhost','ENCRYPTION_KEY_ADMIN','Y'),('root','localhost','FIREWALL_EXEMPT','Y'),('root','localhost','FLUSH_OPTIMIZER_COSTS','Y'),('root','localhost','FLUSH_STATUS','Y'),('root','localhost','FLUSH_TABLES','Y'),('root','localhost','FLUSH_USER_RESOURCES','Y'),('root','localhost','GROUP_REPLICATION_ADMIN','Y'),('root','localhost','GROUP_REPLICATION_STREAM','Y'),('root','localhost','INNODB_REDO_LOG_ARCHIVE','Y'),('root','localhost','INNODB_REDO_LOG_ENABLE','Y'),('root','localhost','PASSWORDLESS_USER_ADMIN','Y'),('root','localhost','PERSIST_RO_VARIABLES_ADMIN','Y'),('root','localhost','REPLICATION_APPLIER','Y'),('root','localhost','REPLICATION_SLAVE_ADMIN','Y'),('root','localhost','RESOURCE_GROUP_ADMIN','Y'),('root','localhost','RESOURCE_GROUP_USER','Y'),('root','localhost','ROLE_ADMIN','Y'),('root','localhost','SENSITIVE_VARIABLES_OBSERVER','Y'),('root','localhost','SERVICE_CONNECTION_ADMIN','Y'),('root','localhost','SESSION_VARIABLES_ADMIN','Y'),('root','localhost','SET_USER_ID','Y'),('root','localhost','SHOW_ROUTINE','Y'),('root','localhost','SYSTEM_USER','Y'),('root','localhost','SYSTEM_VARIABLES_ADMIN','Y'),('root','localhost','TABLE_ENCRYPTION_ADMIN','Y'),('root','localhost','TELEMETRY_LOG_ADMIN','Y'),('root','localhost','XA_RECOVER_ADMIN','Y');
/*!40000 ALTER TABLE `global_grants` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `gtid_executed`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `gtid_executed` (
  `source_uuid` char(36) NOT NULL COMMENT 'uuid of the source where the transaction was originally executed.',
  `interval_start` bigint NOT NULL COMMENT 'First number of interval.',
  `interval_end` bigint NOT NULL COMMENT 'Last number of interval.',
  PRIMARY KEY (`source_uuid`,`interval_start`)
) /*!50100 TABLESPACE `mysql` */ ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci STATS_PERSISTENT=0 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `help_category`
--

DROP TABLE IF EXISTS `help_category`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `help_category` (
  `help_category_id` smallint unsigned NOT NULL,
  `name` char(64) NOT NULL,
  `parent_category_id` smallint unsigned DEFAULT NULL,
  `url` text NOT NULL,
  PRIMARY KEY (`help_category_id`),
  UNIQUE KEY `name` (`name`)
) /*!50100 TABLESPACE `mysql` */ ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 STATS_PERSISTENT=0 ROW_FORMAT=DYNAMIC COMMENT='help categories';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `help_category`
--

LOCK TABLES `help_category` WRITE;
/*!40000 ALTER TABLE `help_category` DISABLE KEYS */;
INSERT INTO `help_category` VALUES (0,'Contents',0,''),(1,'Help Metadata',0,''),(2,'Data Types',0,''),(3,'Administration',0,''),(4,'Functions',0,''),(5,'Enterprise Encryption Functions',4,''),(6,'Language Structure',0,''),(7,'Geographic Features',0,''),(8,'MBR',7,''),(9,'WKT',7,''),(10,'Comparison Operators',4,''),(11,'Logical Operators',4,''),(12,'Flow Control Functions',4,''),(13,'Numeric Functions',4,''),(14,'Date and Time Functions',4,''),(15,'String Functions',4,''),(16,'Cast Functions and Operators',4,''),(17,'XML',4,''),(18,'Bit Functions',4,''),(19,'Encryption Functions',4,''),(20,'Locking Functions',4,''),(21,'Information Functions',4,''),(22,'Spatial Functions',4,''),(23,'WKT Functions',22,''),(24,'WKB Functions',22,''),(25,'Geometry Constructors',22,''),(26,'Geometry Property Functions',22,''),(27,'Point Property Functions',22,''),(28,'LineString Property Functions',22,''),(29,'Polygon Property Functions',22,''),(30,'GeometryCollection Property Functions',22,''),(31,'Geometry Relation Functions',22,''),(32,'MBR Functions',22,''),(33,'GTID',4,''),(34,'Aggregate Functions and Modifiers',4,''),(35,'GROUP BY Functions and Modifiers',4,''),(36,'Window Functions',4,''),(37,'Performance Schema Functions',4,''),(38,'Internal Functions',4,''),(39,'Miscellaneous Functions',4,''),(40,'Data Definition',0,''),(41,'Data Manipulation',0,''),(42,'Transactions',0,''),(43,'Replication Statements',0,''),(44,'Prepared Statements',0,''),(45,'Compound Statements',0,''),(46,'Account Management',0,''),(47,'Table Maintenance',0,''),(48,'Loadable Functions',0,''),(49,'Components',0,''),(50,'Plugins',0,''),(51,'Utility',0,''),(52,'Storage Engines',0,'');
/*!40000 ALTER TABLE `help_category` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `help_keyword`
--

DROP TABLE IF EXISTS `help_keyword`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `help_keyword` (
  `help_keyword_id` int unsigned NOT NULL,
  `name` char(64) NOT NULL,
  PRIMARY KEY (`help_keyword_id`),
  UNIQUE KEY `name` (`name`)
) /*!50100 TABLESPACE `mysql` */ ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 STATS_PERSISTENT=0 ROW_FORMAT=DYNAMIC COMMENT='help keywords';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `help_keyword`
--

LOCK TABLES `help_keyword` WRITE;
/*!40000 ALTER TABLE `help_keyword` DISABLE KEYS */;
INSERT INTO `help_keyword` VALUES (108,'%'),(264,'&'),(422,'(JSON'),(86,'*'),(84,'+'),(85,'-'),(423,'->'),(425,'->>'),(87,'/'),(75,':='),(59,'<'),(266,'<<'),(58,'<='),(56,'<=>'),(57,'<>'),(55,'='),(61,'>'),(60,'>='),(267,'>>'),(90,'ABS'),(881,'ACCOUNT'),(91,'ACOS'),(659,'ACTION'),(49,'ADD'),(120,'ADDDATE'),(121,'ADDTIME'),(915,'ADMIN'),(270,'AES_DECRYPT'),(271,'AES_ENCRYPT'),(581,'AFTER'),(247,'AGAINST'),(936,'AGGREGATE'),(582,'ALGORITHM'),(695,'ALL'),(50,'ALTER'),(583,'ANALYZE'),(62,'AND'),(526,'ANY_VALUE'),(660,'ARCHIVE'),(254,'ARRAY'),(724,'AS'),(464,'ASC'),(185,'ASCII'),(92,'ASIN'),(776,'ASSIGN_GTIDS_TO_ANONYMOUS_TRANSACTIONS'),(6,'ASYMMETRIC_DECRYPT'),(13,'ASYMMETRIC_DERIVE'),(7,'ASYMMETRIC_ENCRYPT'),(8,'ASYMMETRIC_SIGN'),(9,'ASYMMETRIC_VERIFY'),(643,'AT'),(93,'ATAN'),(94,'ATAN2'),(882,'ATTRIBUTE'),(913,'AUTHENTICATION'),(745,'AUTOCOMMIT'),(584,'AUTOEXTEND_SIZE'),(585,'AUTO_INCREMENT'),(458,'AVG'),(586,'AVG_ROW_LENGTH'),(757,'BACKUP'),(771,'BEFORE'),(746,'BEGIN'),(288,'BENCHMARK'),(63,'BETWEEN'),(186,'BIN'),(253,'BINARY'),(563,'BINLOG'),(527,'BIN_TO_UUID'),(460,'BIT_AND'),(269,'BIT_COUNT'),(187,'BIT_LENGTH'),(461,'BIT_OR'),(462,'BIT_XOR'),(17,'BOOL'),(18,'BOOLEAN'),(230,'BOTH'),(647,'BTREE'),(465,'BY'),(42,'BYTE'),(971,'CACHE'),(689,'CALL'),(497,'CAN_ACCESS_COLUMN'),(498,'CAN_ACCESS_DATABASE'),(499,'CAN_ACCESS_TABLE'),(500,'CAN_ACCESS_USER'),(501,'CAN_ACCESS_VIEW'),(661,'CASCADE'),(76,'CASE'),(255,'CAST'),(862,'CATALOG_NAME'),(95,'CEIL'),(96,'CEILING'),(747,'CHAIN'),(883,'CHALLENGE_RESPONSE'),(587,'CHANGE'),(564,'CHANNEL'),(43,'CHAR'),(39,'CHARACTER'),(189,'CHARACTER_LENGTH'),(289,'CHARSET'),(188,'CHAR_LENGTH'),(588,'CHECK'),(589,'CHECKSUM'),(884,'CIPHER'),(863,'CLASS_ORIGIN'),(916,'CLIENT'),(944,'CLONE'),(697,'CLOSE'),(65,'COALESCE'),(965,'CODE'),(290,'COERCIBILITY'),(546,'COLLATE'),(291,'COLLATION'),(590,'COLUMN'),(591,'COLUMNS'),(864,'COLUMN_NAME'),(551,'COMMENT'),(748,'COMMIT'),(760,'COMMITTED'),(662,'COMPACT'),(552,'COMPLETION'),(940,'COMPONENT'),(272,'COMPRESS'),(663,'COMPRESSED'),(592,'COMPRESSION'),(190,'CONCAT'),(191,'CONCAT_WS'),(711,'CONCURRENT'),(859,'CONDITION'),(593,'CONNECTION'),(292,'CONNECTION_ID'),(749,'CONSISTENT'),(594,'CONSTRAINT'),(865,'CONSTRAINT_CATALOG'),(866,'CONSTRAINT_NAME'),(867,'CONSTRAINT_SCHEMA'),(860,'CONTINUE'),(97,'CONV'),(260,'CONVERT'),(122,'CONVERT_TZ'),(98,'COS'),(99,'COT'),(463,'COUNT'),(100,'CRC32'),(51,'CREATE'),(10,'CREATE_ASYMMETRIC_PRIV_KEY'),(11,'CREATE_ASYMMETRIC_PUB_KEY'),(14,'CREATE_DH_PARAMETERS'),(12,'CREATE_DIGEST'),(740,'CROSS'),(664,'CSV'),(482,'CUME_DIST'),(123,'CURDATE'),(885,'CURRENT'),(124,'CURRENT_DATE'),(293,'CURRENT_ROLE'),(125,'CURRENT_TIME'),(126,'CURRENT_TIMESTAMP'),(294,'CURRENT_USER'),(857,'CURSOR'),(868,'CURSOR_NAME'),(127,'CURTIME'),(595,'DATA'),(295,'DATABASE'),(949,'DATABASES'),(636,'DATAFILE'),(36,'DATE'),(128,'DATEDIFF'),(256,'DATETIME'),(129,'DATE_ADD'),(144,'DATE_FORMAT'),(130,'DATE_SUB'),(131,'DAY'),(145,'DAYNAME'),(146,'DAYOFMONTH'),(147,'DAYOFWEEK'),(148,'DAYOFYEAR'),(132,'DAY_HOUR'),(133,'DAY_MINUTE'),(134,'DAY_SECOND'),(848,'DEALLOCATE'),(28,'DEC'),(31,'DECIMAL'),(849,'DECLARE'),(2,'DEFAULT'),(839,'DEFAULT_AUTH'),(553,'DEFINER'),(653,'DEFINITION'),(101,'DEGREES'),(703,'DELAYED'),(596,'DELAY_KEY_WRITE'),(665,'DELETE'),(483,'DENSE_RANK'),(466,'DESC'),(982,'DESCRIBE'),(654,'DESCRIPTION'),(869,'DIAGNOSTICS'),(597,'DIRECTORY'),(554,'DISABLE'),(598,'DISCARD'),(459,'DISTINCT'),(725,'DISTINCTROW'),(88,'DIV'),(555,'DO'),(599,'DROP'),(739,'DUAL'),(726,'DUMPFILE'),(704,'DUPLICATE'),(666,'DYNAMIC'),(77,'ELSE'),(850,'ELSEIF'),(192,'ELT'),(556,'ENABLE'),(712,'ENCLOSED'),(547,'ENCRYPTION'),(78,'END'),(644,'ENDS'),(600,'ENGINE'),(950,'ENGINES'),(565,'ERROR'),(951,'ERRORS'),(239,'ESCAPE'),(713,'ESCAPED'),(557,'EVENT'),(963,'EVENTS'),(645,'EVERY'),(696,'EXCEPT'),(601,'EXCHANGE'),(847,'EXECUTE'),(642,'EXISTS'),(861,'EXIT'),(102,'EXP'),(248,'EXPANSION'),(886,'EXPIRE'),(983,'EXPLAIN'),(972,'EXPORT'),(193,'EXPORT_SET'),(934,'EXTENDED'),(682,'EXTENT_SIZE'),(149,'EXTRACT'),(424,'EXTRACTION)'),(261,'EXTRACTVALUE'),(887,'FACTOR'),(888,'FAILED_LOGIN_ATTEMPTS'),(15,'FALSE'),(932,'FAST'),(667,'FEDERATED'),(858,'FETCH'),(194,'FIELD'),(714,'FIELDS'),(917,'FILE'),(683,'FILE_BLOCK_SIZE'),(805,'FILTER'),(195,'FIND_IN_SET'),(889,'FINISH'),(602,'FIRST'),(484,'FIRST_VALUE'),(29,'FIXED'),(32,'FLOAT4'),(33,'FLOAT8'),(103,'FLOOR'),(973,'FLUSH'),(566,'FOR'),(741,'FORCE'),(603,'FOREIGN'),(196,'FORMAT'),(493,'FORMAT_BYTES'),(494,'FORMAT_PICO_TIME'),(296,'FOUND_ROWS'),(231,'FROM'),(197,'FROM_BASE64'),(150,'FROM_DAYS'),(151,'FROM_UNIXTIME'),(668,'FULL'),(604,'FULLTEXT'),(169,'FUNCTION'),(974,'GENERAL'),(336,'GEOMCOLLECTION'),(337,'GEOMETRYCOLLECTION'),(870,'GET'),(502,'GET_DD_COLUMN_PRIVILEGES'),(503,'GET_DD_CREATE_OPTIONS'),(504,'GET_DD_INDEX_SUB_PART_LENGTH'),(152,'GET_FORMAT'),(283,'GET_LOCK'),(761,'GLOBAL'),(918,'GRANT'),(952,'GRANTS'),(66,'GREATEST'),(576,'GROUP'),(528,'GROUPING'),(467,'GROUP_CONCAT'),(454,'GTID_SUBSET'),(455,'GTID_SUBTRACT'),(698,'HANDLER'),(727,'HAVING'),(669,'HEAP'),(5,'HELP'),(0,'HELP_DATE'),(1,'HELP_VERSION'),(198,'HEX'),(705,'HIGH_PRIORITY'),(890,'HISTORY'),(648,'HOST'),(953,'HOSTS'),(135,'HOUR'),(136,'HOUR_MINUTE'),(137,'HOUR_SECOND'),(297,'ICU_VERSION'),(722,'IDENTIFIED'),(81,'IF'),(82,'IFNULL'),(706,'IGNORE'),(777,'IGNORE_SERVER_IDS'),(605,'IMPORT'),(67,'IN'),(52,'INDEX'),(954,'INDEXES'),(531,'INET6_ATON'),(532,'INET6_NTOA'),(529,'INET_ATON'),(530,'INET_NTOA'),(715,'INFILE'),(914,'INITIAL'),(637,'INITIAL_SIZE'),(891,'INITIATE'),(426,'INLINE'),(742,'INNER'),(567,'INNODB'),(199,'INSERT'),(606,'INSERT_METHOD'),(941,'INSTALL'),(568,'INSTANCE'),(200,'INSTR'),(19,'INT1'),(22,'INT2'),(23,'INT3'),(25,'INT4'),(27,'INT8'),(26,'INTEGER'),(505,'INTERNAL_AUTO_INCREMENT'),(506,'INTERNAL_AVG_ROW_LENGTH'),(508,'INTERNAL_CHECKSUM'),(507,'INTERNAL_CHECK_TIME'),(509,'INTERNAL_DATA_FREE'),(510,'INTERNAL_DATA_LENGTH'),(511,'INTERNAL_DD_CHAR_LENGTH'),(512,'INTERNAL_GET_COMMENT_OR_ERROR'),(513,'INTERNAL_GET_ENABLED_ROLE_JSON'),(514,'INTERNAL_GET_HOSTNAME'),(515,'INTERNAL_GET_USERNAME'),(516,'INTERNAL_GET_VIEW_WARNING_OR_ERROR'),(517,'INTERNAL_INDEX_COLUMN_CARDINALITY'),(518,'INTERNAL_INDEX_LENGTH'),(519,'INTERNAL_IS_ENABLED_ROLE'),(520,'INTERNAL_IS_MANDATORY_ROLE'),(521,'INTERNAL_KEYS_DISABLED'),(522,'INTERNAL_MAX_DATA_LENGTH'),(523,'INTERNAL_TABLE_ROWS'),(524,'INTERNAL_UPDATE_TIME'),(710,'INTERSECT'),(68,'INTERVAL'),(707,'INTO'),(607,'INVISIBLE'),(840,'IO_THREAD'),(69,'IS'),(71,'ISNULL'),(762,'ISOLATION'),(892,'ISSUER'),(284,'IS_FREE_LOCK'),(533,'IS_IPV4'),(534,'IS_IPV4_COMPAT'),(535,'IS_IPV4_MAPPED'),(536,'IS_IPV6'),(285,'IS_USED_LOCK'),(537,'IS_UUID'),(525,'IS_VISIBLE_DD_OBJECT'),(851,'ITERATE'),(728,'JOIN'),(257,'JSON'),(416,'JSON_ARRAY'),(470,'JSON_ARRAYAGG'),(434,'JSON_ARRAY_APPEND'),(435,'JSON_ARRAY_INSERT'),(419,'JSON_CONTAINS'),(420,'JSON_CONTAINS_PATH'),(444,'JSON_DEPTH'),(421,'JSON_EXTRACT'),(436,'JSON_INSERT'),(428,'JSON_KEYS'),(445,'JSON_LENGTH'),(437,'JSON_MERGE'),(438,'JSON_MERGE_PATCH'),(439,'JSON_MERGE_PRESERVE'),(417,'JSON_OBJECT'),(471,'JSON_OBJECTAGG'),(429,'JSON_OVERLAPS'),(451,'JSON_PRETTY'),(418,'JSON_QUOTE'),(440,'JSON_REMOVE'),(441,'JSON_REPLACE'),(449,'JSON_SCHEMA_VALID'),(450,'JSON_SCHEMA_VALIDATION_REPORT'),(430,'JSON_SEARCH'),(442,'JSON_SET'),(452,'JSON_STORAGE_FREE'),(453,'JSON_STORAGE_SIZE'),(448,'JSON_TABLE'),(446,'JSON_TYPE'),(443,'JSON_UNQUOTE'),(447,'JSON_VALID'),(431,'JSON_VALUE'),(53,'KEY'),(569,'KEYRING'),(608,'KEYS'),(609,'KEY_BLOCK_SIZE'),(979,'KILL'),(485,'LAG'),(699,'LAST'),(153,'LAST_DAY'),(298,'LAST_INSERT_ID'),(486,'LAST_VALUE'),(201,'LCASE'),(487,'LEAD'),(232,'LEADING'),(72,'LEAST'),(852,'LEAVE'),(980,'LEAVES'),(202,'LEFT'),(203,'LENGTH'),(763,'LEVEL'),(223,'LIKE'),(690,'LIMIT'),(716,'LINES'),(338,'LINESTRING'),(104,'LN'),(717,'LOAD'),(204,'LOAD_FILE'),(718,'LOCAL'),(154,'LOCALTIME'),(155,'LOCALTIMESTAMP'),(205,'LOCATE'),(610,'LOCK'),(105,'LOG'),(107,'LOG10'),(106,'LOG2'),(577,'LOGFILE'),(772,'LOGS'),(47,'LONG'),(48,'LONGBINARY'),(853,'LOOP'),(206,'LOWER'),(691,'LOW_PRIORITY'),(207,'LPAD'),(208,'LTRIM'),(156,'MAKEDATE'),(157,'MAKETIME'),(209,'MAKE_SET'),(570,'MASTER'),(778,'MASTER_AUTO_POSITION'),(779,'MASTER_BIND'),(780,'MASTER_COMPRESSION_ALGORITHMS'),(781,'MASTER_CONNECT_RETRY'),(782,'MASTER_HEARTBEAT_PERIOD'),(783,'MASTER_HOST'),(784,'MASTER_LOG_FILE'),(785,'MASTER_LOG_POS'),(786,'MASTER_PASSWORD'),(787,'MASTER_PORT'),(538,'MASTER_POS_WAIT'),(788,'MASTER_RETRY_COUNT'),(789,'MASTER_SSL'),(790,'MASTER_SSL_CA'),(791,'MASTER_SSL_CERT'),(792,'MASTER_SSL_CIPHER'),(793,'MASTER_SSL_CRL'),(794,'MASTER_SSL_CRLPATH'),(795,'MASTER_SSL_KEY'),(796,'MASTER_SSL_VERIFY_SERVER_CERT'),(797,'MASTER_TLS_CIPHERSUITES'),(798,'MASTER_TLS_VERSION'),(799,'MASTER_USER'),(800,'MASTER_ZSTD_COMPRESSION_LEVEL'),(249,'MATCH'),(472,'MAX'),(893,'MAX_CONNECTIONS_PER_HOUR'),(894,'MAX_QUERIES_PER_HOUR'),(611,'MAX_ROWS'),(684,'MAX_SIZE'),(895,'MAX_UPDATES_PER_HOUR'),(896,'MAX_USER_CONNECTIONS'),(395,'MBRCONTAINS'),(396,'MBRCOVEREDBY'),(397,'MBRCOVERS'),(398,'MBRDISJOINT'),(399,'MBREQUALS'),(400,'MBRINTERSECTS'),(401,'MBROVERLAPS'),(402,'MBRTOUCHES'),(403,'MBRWITHIN'),(273,'MD5'),(933,'MEDIUM'),(432,'MEMBER'),(729,'MEMORY'),(670,'MERGE'),(871,'MESSAGE_TEXT'),(158,'MICROSECOND'),(210,'MID'),(24,'MIDDLEINT'),(473,'MIN'),(138,'MINUTE'),(139,'MINUTE_SECOND'),(612,'MIN_ROWS'),(89,'MOD'),(250,'MODE'),(613,'MODIFY'),(140,'MONTH'),(159,'MONTHNAME'),(671,'MRG_MYISAM'),(339,'MULTILINESTRING'),(340,'MULTIPOINT'),(341,'MULTIPOLYGON'),(955,'MUTEX'),(672,'MYISAM'),(872,'MYSQL_ERRNO'),(655,'NAME'),(948,'NAMES'),(539,'NAME_CONST'),(40,'NATIONAL'),(743,'NATURAL'),(41,'NCHAR'),(673,'NDB'),(674,'NDBCLUSTER'),(801,'NETWORK_NAMESPACE'),(897,'NEVER'),(700,'NEXT'),(571,'NO'),(685,'NODEGROUP'),(898,'NONE'),(64,'NOT'),(160,'NOW'),(931,'NO_WRITE_TO_BINLOG'),(488,'NTH_VALUE'),(489,'NTILE'),(70,'NULL'),(83,'NULLIF'),(873,'NUMBER'),(30,'NUMERIC'),(44,'NVARCHAR'),(211,'OCT'),(212,'OCTET_LENGTH'),(433,'OF'),(730,'OFFSET'),(899,'OLD'),(558,'ON'),(548,'ONLY'),(701,'OPEN'),(614,'OPTIMIZE'),(975,'OPTIMIZER_COSTS'),(919,'OPTION'),(900,'OPTIONAL'),(719,'OPTIONALLY'),(579,'OPTIONS'),(73,'OR'),(213,'ORD'),(468,'ORDER'),(656,'ORGANIZATION'),(744,'OUTER'),(731,'OUTFILE'),(649,'OWNER'),(615,'PACK_KEYS'),(616,'PARSER'),(675,'PARTIAL'),(617,'PARTITION'),(618,'PARTITIONING'),(619,'PASSWORD'),(901,'PASSWORD_LOCK_TIME'),(427,'PATH)'),(490,'PERCENT_RANK'),(161,'PERIOD_ADD'),(162,'PERIOD_DIFF'),(945,'PERSIST'),(946,'PERSIST_ONLY'),(109,'PI'),(942,'PLUGIN'),(966,'PLUGINS'),(841,'PLUGIN_DIR'),(342,'POINT'),(343,'POLYGON'),(650,'PORT'),(214,'POSITION'),(110,'POW'),(111,'POWER'),(34,'PRECISION'),(768,'PREPARE'),(559,'PRESERVE'),(702,'PREV'),(620,'PRIMARY'),(920,'PRIVILEGES'),(802,'PRIVILEGE_CHECKS_USER'),(578,'PROCEDURE'),(921,'PROCESS'),(956,'PROCESSLIST'),(967,'PROFILE'),(968,'PROFILES'),(925,'PROXY'),(495,'PS_CURRENT_THREAD_ID'),(496,'PS_THREAD_ID'),(773,'PURGE'),(163,'QUARTER'),(251,'QUERY'),(692,'QUICK'),(215,'QUOTE'),(112,'RADIANS'),(113,'RAND'),(902,'RANDOM'),(274,'RANDOM_BYTES'),(491,'RANK'),(549,'READ'),(35,'REAL'),(621,'REBUILD'),(769,'RECOVER'),(572,'REDO_LOG'),(676,'REDUNDANT'),(657,'REFERENCE'),(677,'REFERENCES'),(241,'REGEXP'),(243,'REGEXP_INSTR'),(244,'REGEXP_LIKE'),(245,'REGEXP_REPLACE'),(246,'REGEXP_SUBSTR'),(903,'REGISTRATION'),(976,'RELAY'),(969,'RELAYLOG'),(803,'RELAY_LOG_FILE'),(804,'RELAY_LOG_POS'),(750,'RELEASE'),(286,'RELEASE_ALL_LOCKS'),(287,'RELEASE_LOCK'),(573,'RELOAD'),(622,'REMOVE'),(560,'RENAME'),(623,'REORGANIZE'),(624,'REPAIR'),(216,'REPEAT'),(764,'REPEATABLE'),(217,'REPLACE'),(838,'REPLICA'),(970,'REPLICAS'),(806,'REPLICATE_DO_DB'),(807,'REPLICATE_DO_TABLE'),(808,'REPLICATE_IGNORE_DB'),(809,'REPLICATE_IGNORE_TABLE'),(810,'REPLICATE_REWRITE_DB'),(811,'REPLICATE_WILD_DO_TABLE'),(812,'REPLICATE_WILD_IGNORE_TABLE'),(813,'REPLICATION'),(904,'REQUIRE'),(774,'RESET'),(878,'RESIGNAL'),(928,'RESOURCE'),(981,'RESTART'),(680,'RESTRICT'),(905,'RETAIN'),(855,'RETURN'),(874,'RETURNED_SQLSTATE'),(937,'RETURNS'),(906,'REUSE'),(218,'REVERSE'),(926,'REVOKE'),(219,'RIGHT'),(242,'RLIKE'),(907,'ROLE'),(299,'ROLES_GRAPHML'),(574,'ROLLBACK'),(114,'ROUND'),(708,'ROW'),(723,'ROWS'),(300,'ROW_COUNT'),(625,'ROW_FORMAT'),(492,'ROW_NUMBER'),(220,'RPAD'),(221,'RTRIM'),(756,'SAVEPOINT'),(561,'SCHEDULE'),(301,'SCHEMA'),(957,'SCHEMAS'),(875,'SCHEMA_NAME'),(141,'SECOND'),(164,'SEC_TO_TIME'),(709,'SELECT'),(469,'SEPARATOR'),(3,'SERIAL'),(765,'SERIALIZABLE'),(580,'SERVER'),(766,'SESSION'),(302,'SESSION_USER'),(550,'SET'),(275,'SHA'),(276,'SHA1'),(277,'SHA2'),(732,'SHARE'),(958,'SHOW'),(922,'SHUTDOWN'),(115,'SIGN'),(880,'SIGNAL'),(258,'SIGNED'),(116,'SIN'),(562,'SLAVE'),(540,'SLEEP'),(977,'SLOW'),(751,'SNAPSHOT'),(651,'SOCKET'),(938,'SONAME'),(222,'SOUNDEX'),(224,'SOUNDS'),(814,'SOURCE'),(815,'SOURCE_AUTO_POSITION'),(816,'SOURCE_BIND'),(817,'SOURCE_COMPRESSION_ALGORITHMS'),(818,'SOURCE_CONNECT_RETRY'),(819,'SOURCE_HEARTBEAT_PERIOD'),(820,'SOURCE_HOST'),(821,'SOURCE_LOG_FILE'),(822,'SOURCE_LOG_POS'),(823,'SOURCE_PASSWORD'),(824,'SOURCE_PORT'),(541,'SOURCE_POS_WAIT'),(825,'SOURCE_RETRY_COUNT'),(826,'SOURCE_SSL'),(827,'SOURCE_SSL_CA'),(828,'SOURCE_SSL_CERT'),(829,'SOURCE_SSL_CIPHER'),(830,'SOURCE_SSL_CRL'),(831,'SOURCE_SSL_CRLPATH'),(832,'SOURCE_SSL_KEY'),(833,'SOURCE_SSL_VERIFY_SERVER_CERT'),(834,'SOURCE_TLS_CIPHERSUITES'),(835,'SOURCE_TLS_VERSION'),(836,'SOURCE_USER'),(837,'SOURCE_ZSTD_COMPRESSION_LEVEL'),(225,'SPACE'),(626,'SPATIAL'),(879,'SQLSTATE'),(842,'SQL_AFTER_GTIDS'),(843,'SQL_AFTER_MTS_GAPS'),(844,'SQL_BEFORE_GTIDS'),(733,'SQL_BIG_RESULT'),(734,'SQL_BUFFER_RESULT'),(735,'SQL_CALC_FOUND_ROWS'),(775,'SQL_LOG_BIN'),(736,'SQL_NO_CACHE'),(737,'SQL_SMALL_RESULT'),(845,'SQL_THREAD'),(117,'SQRT'),(908,'SSL'),(752,'START'),(720,'STARTING'),(646,'STARTS'),(278,'STATEMENT_DIGEST'),(279,'STATEMENT_DIGEST_TEXT'),(627,'STATS_AUTO_RECALC'),(628,'STATS_PERSISTENT'),(629,'STATS_SAMPLE_PAGES'),(959,'STATUS'),(474,'STD'),(475,'STDDEV'),(476,'STDDEV_POP'),(477,'STDDEV_SAMP'),(846,'STOP'),(964,'STORAGE'),(678,'STORED'),(738,'STRAIGHT_JOIN'),(240,'STRCMP'),(939,'STRING'),(165,'STR_TO_DATE'),(365,'ST_AREA'),(344,'ST_ASBINARY'),(408,'ST_ASGEOJSON'),(346,'ST_ASTEXT'),(345,'ST_ASWKB'),(347,'ST_ASWKT'),(373,'ST_BUFFER'),(374,'ST_BUFFER_STRATEGY'),(366,'ST_CENTROID'),(410,'ST_COLLECT'),(384,'ST_CONTAINS'),(375,'ST_CONVEXHULL'),(385,'ST_CROSSES'),(376,'ST_DIFFERENCE'),(349,'ST_DIMENSION'),(386,'ST_DISJOINT'),(387,'ST_DISTANCE'),(411,'ST_DISTANCE_SPHERE'),(359,'ST_ENDPOINT'),(350,'ST_ENVELOPE'),(388,'ST_EQUALS'),(367,'ST_EXTERIORRING'),(389,'ST_FRECHETDISTANCE'),(404,'ST_GEOHASH'),(306,'ST_GEOMCOLLFROMTEXT'),(321,'ST_GEOMCOLLFROMWKB'),(307,'ST_GEOMETRYCOLLECTIONFROMTEXT'),(322,'ST_GEOMETRYCOLLECTIONFROMWKB'),(308,'ST_GEOMETRYFROMTEXT'),(323,'ST_GEOMETRYFROMWKB'),(371,'ST_GEOMETRYN'),(351,'ST_GEOMETRYTYPE'),(409,'ST_GEOMFROMGEOJSON'),(309,'ST_GEOMFROMTEXT'),(324,'ST_GEOMFROMWKB'),(390,'ST_HAUSDORFFDISTANCE'),(368,'ST_INTERIORRINGN'),(377,'ST_INTERSECTION'),(391,'ST_INTERSECTS'),(360,'ST_ISCLOSED'),(352,'ST_ISEMPTY'),(353,'ST_ISSIMPLE'),(412,'ST_ISVALID'),(405,'ST_LATFROMGEOHASH'),(355,'ST_LATITUDE'),(361,'ST_LENGTH'),(310,'ST_LINEFROMTEXT'),(325,'ST_LINEFROMWKB'),(378,'ST_LINEINTERPOLATEPOINT'),(379,'ST_LINEINTERPOLATEPOINTS'),(311,'ST_LINESTRINGFROMTEXT'),(326,'ST_LINESTRINGFROMWKB'),(406,'ST_LONGFROMGEOHASH'),(356,'ST_LONGITUDE'),(413,'ST_MAKEENVELOPE'),(312,'ST_MLINEFROMTEXT'),(327,'ST_MLINEFROMWKB'),(314,'ST_MPOINTFROMTEXT'),(329,'ST_MPOINTFROMWKB'),(316,'ST_MPOLYFROMTEXT'),(331,'ST_MPOLYFROMWKB'),(313,'ST_MULTILINESTRINGFROMTEXT'),(328,'ST_MULTILINESTRINGFROMWKB'),(315,'ST_MULTIPOINTFROMTEXT'),(330,'ST_MULTIPOINTFROMWKB'),(317,'ST_MULTIPOLYGONFROMTEXT'),(332,'ST_MULTIPOLYGONFROMWKB'),(372,'ST_NUMGEOMETRIES'),(369,'ST_NUMINTERIORRING'),(370,'ST_NUMINTERIORRINGS'),(362,'ST_NUMPOINTS'),(392,'ST_OVERLAPS'),(380,'ST_POINTATDISTANCE'),(407,'ST_POINTFROMGEOHASH'),(318,'ST_POINTFROMTEXT'),(333,'ST_POINTFROMWKB'),(363,'ST_POINTN'),(319,'ST_POLYFROMTEXT'),(334,'ST_POLYFROMWKB'),(320,'ST_POLYGONFROMTEXT'),(335,'ST_POLYGONFROMWKB'),(414,'ST_SIMPLIFY'),(354,'ST_SRID'),(364,'ST_STARTPOINT'),(348,'ST_SWAPXY'),(381,'ST_SYMDIFFERENCE'),(393,'ST_TOUCHES'),(382,'ST_TRANSFORM'),(383,'ST_UNION'),(415,'ST_VALIDATE'),(394,'ST_WITHIN'),(357,'ST_X'),(358,'ST_Y'),(876,'SUBCLASS_ORIGIN'),(166,'SUBDATE'),(909,'SUBJECT'),(226,'SUBSTR'),(227,'SUBSTRING'),(228,'SUBSTRING_INDEX'),(167,'SUBTIME'),(478,'SUM'),(923,'SUPER'),(168,'SYSDATE'),(658,'SYSTEM'),(303,'SYSTEM_USER'),(54,'TABLE'),(759,'TABLES'),(630,'TABLESPACE'),(877,'TABLE_NAME'),(118,'TAN'),(688,'TEMPORARY'),(721,'TERMINATED'),(79,'THEN'),(929,'THREAD_PRIORITY'),(38,'TIME'),(170,'TIMEDIFF'),(37,'TIMESTAMP'),(171,'TIMESTAMPADD'),(172,'TIMESTAMPDIFF'),(259,'TIMEZONE'),(173,'TIME_FORMAT'),(174,'TIME_TO_SEC'),(575,'TLS'),(638,'TO'),(229,'TO_BASE64'),(175,'TO_DAYS'),(176,'TO_SECONDS'),(984,'TRADITIONAL'),(233,'TRAILING'),(753,'TRANSACTION'),(985,'TREE'),(687,'TRIGGER'),(960,'TRIGGERS'),(234,'TRIM'),(16,'TRUE'),(119,'TRUNCATE'),(631,'TYPE'),(235,'UCASE'),(910,'UNBOUNDED'),(767,'UNCOMMITTED'),(280,'UNCOMPRESS'),(281,'UNCOMPRESSED_LENGTH'),(639,'UNDO'),(236,'UNHEX'),(943,'UNINSTALL'),(632,'UNION'),(633,'UNIQUE'),(177,'UNIX_TIMESTAMP'),(927,'UNKNOWN'),(758,'UNLOCK'),(911,'UNREGISTER'),(20,'UNSIGNED'),(854,'UNTIL'),(681,'UPDATE'),(262,'UPDATEXML'),(634,'UPGRADE'),(237,'UPPER'),(924,'USAGE'),(686,'USE'),(304,'USER'),(978,'USER_RESOURCES'),(935,'USE_FRM'),(693,'USING'),(178,'UTC_DATE'),(179,'UTC_TIME'),(180,'UTC_TIMESTAMP'),(542,'UUID'),(543,'UUID_SHORT'),(544,'UUID_TO_BIN'),(282,'VALIDATE_PASSWORD_STRENGTH'),(4,'VALUE'),(545,'VALUES'),(45,'VARCHARACTER'),(947,'VARIABLE'),(961,'VARIABLES'),(481,'VARIANCE'),(46,'VARYING'),(479,'VAR_POP'),(480,'VAR_SAMP'),(930,'VCPU'),(305,'VERSION'),(641,'VIEW'),(679,'VIRTUAL'),(635,'VISIBLE'),(640,'WAIT'),(456,'WAIT_FOR_EXECUTED_GTID_SET'),(457,'WAIT_UNTIL_SQL_THREAD_AFTER_GTIDS'),(962,'WARNINGS'),(181,'WEEK'),(182,'WEEKDAY'),(183,'WEEKOFYEAR'),(238,'WEIGHT_STRING'),(80,'WHEN'),(694,'WHERE'),(856,'WHILE'),(252,'WITH'),(754,'WORK'),(652,'WRAPPER'),(755,'WRITE'),(912,'X509'),(770,'XA'),(74,'XOR'),(142,'YEAR'),(184,'YEARWEEK'),(143,'YEAR_MONTH'),(21,'ZEROFILL'),(265,'^'),(263,'|'),(268,'~');
/*!40000 ALTER TABLE `help_keyword` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `help_relation`
--

DROP TABLE IF EXISTS `help_relation`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `help_relation` (
  `help_topic_id` int unsigned NOT NULL,
  `help_keyword_id` int unsigned NOT NULL,
  PRIMARY KEY (`help_keyword_id`,`help_topic_id`)
) /*!50100 TABLESPACE `mysql` */ ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 STATS_PERSISTENT=0 ROW_FORMAT=DYNAMIC COMMENT='keyword-topic relation';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `help_relation`
--

LOCK TABLES `help_relation` WRITE;
/*!40000 ALTER TABLE `help_relation` DISABLE KEYS */;
INSERT INTO `help_relation` VALUES (0,0),(1,1),(2,2),(483,2),(502,2),(503,2),(510,2),(513,2),(514,2),(522,2),(523,2),(547,2),(554,2),(592,2),(610,2),(612,2),(618,2),(620,2),(2,3),(522,3),(2,4),(547,4),(554,4),(608,4),(609,4),(3,5),(700,5),(4,6),(5,7),(6,8),(7,9),(8,10),(9,11),(10,12),(11,13),(12,14),(13,15),(14,15),(13,16),(14,16),(16,17),(17,17),(16,18),(240,18),(16,19),(16,20),(20,20),(22,20),(23,20),(25,20),(26,20),(242,20),(16,21),(20,21),(22,21),(23,21),(25,21),(26,21),(18,22),(19,23),(19,24),(20,25),(20,26),(242,26),(630,26),(22,27),(23,28),(23,29),(522,29),(23,30),(24,31),(242,31),(630,31),(25,32),(26,33),(26,34),(26,35),(630,35),(28,36),(129,36),(131,36),(242,36),(30,37),(165,37),(31,38),(163,38),(242,38),(33,39),(35,39),(502,39),(503,39),(510,39),(513,39),(514,39),(522,39),(551,39),(552,39),(555,39),(638,39),(639,39),(641,39),(645,39),(33,40),(35,40),(33,41),(34,42),(34,43),(184,43),(242,43),(35,44),(35,45),(35,46),(44,47),(44,48),(53,49),(510,49),(511,49),(524,49),(610,49),(53,50),(502,50),(503,50),(504,50),(505,50),(506,50),(507,50),(508,50),(509,50),(510,50),(511,50),(512,50),(610,50),(615,50),(621,50),(53,51),(513,51),(514,51),(515,51),(516,51),(517,51),(518,51),(519,51),(520,51),(521,51),(522,51),(524,51),(525,51),(526,51),(611,51),(612,51),(622,51),(630,51),(641,51),(649,51),(650,51),(651,51),(652,51),(653,51),(654,51),(656,51),(53,52),(510,52),(516,52),(522,52),(530,52),(557,52),(641,52),(667,52),(689,52),(692,52),(53,53),(510,53),(522,53),(523,53),(547,53),(53,54),(510,54),(522,54),(535,54),(539,54),(540,54),(546,54),(548,54),(558,54),(625,54),(626,54),(627,54),(628,54),(629,54),(641,54),(654,54),(683,54),(54,55),(79,55),(55,56),(56,57),(57,58),(58,59),(59,60),(60,61),(61,62),(75,62),(61,63),(62,63),(62,64),(66,64),(69,64),(71,64),(74,64),(232,64),(234,64),(513,64),(514,64),(515,64),(521,64),(611,64),(612,64),(63,65),(510,65),(64,66),(65,67),(66,67),(240,67),(555,67),(644,67),(647,67),(648,67),(667,67),(677,67),(67,68),(131,68),(515,68),(610,68),(612,68),(68,69),(69,69),(70,69),(71,69),(70,70),(71,70),(523,70),(72,71),(73,72),(76,73),(521,73),(77,74),(78,75),(80,76),(593,76),(80,77),(593,77),(80,78),(572,78),(590,78),(593,78),(594,78),(597,78),(598,78),(600,78),(80,79),(593,79),(594,79),(80,80),(593,80),(81,81),(513,81),(514,81),(515,81),(521,81),(527,81),(528,81),(529,81),(533,81),(534,81),(535,81),(538,81),(594,81),(610,81),(611,81),(612,81),(613,81),(614,81),(617,81),(631,81),(694,81),(82,82),(83,83),(84,84),(85,85),(86,85),(87,86),(88,87),(89,88),(90,89),(109,89),(91,90),(92,91),(93,92),(94,93),(95,94),(96,95),(97,96),(98,97),(99,98),(100,99),(101,100),(102,101),(103,102),(104,103),(105,104),(106,105),(107,106),(108,107),(109,108),(110,109),(111,110),(112,111),(113,112),(114,113),(115,114),(116,115),(117,116),(118,117),(119,118),(120,119),(510,119),(540,119),(121,120),(122,121),(123,122),(124,123),(125,124),(126,125),(127,126),(128,127),(130,128),(131,129),(131,130),(133,130),(131,131),(134,131),(610,131),(612,131),(131,132),(131,133),(131,134),(131,135),(143,135),(131,136),(131,137),(131,138),(150,138),(131,139),(131,140),(151,140),(131,141),(157,141),(131,142),(179,142),(242,142),(131,143),(132,144),(135,145),(136,146),(137,147),(138,148),(139,149),(140,150),(141,151),(142,152),(144,153),(145,154),(146,155),(147,156),(148,157),(149,158),(152,159),(153,160),(154,161),(155,162),(156,163),(158,164),(159,165),(160,166),(161,167),(162,168),(163,169),(165,169),(214,169),(505,169),(518,169),(519,169),(531,169),(532,169),(630,169),(631,169),(641,169),(652,169),(664,169),(665,169),(164,170),(166,171),(167,172),(168,173),(169,174),(170,175),(171,176),(172,177),(173,178),(174,179),(175,180),(176,181),(177,182),(178,183),(180,184),(181,185),(182,186),(183,187),(185,188),(186,189),(187,190),(188,191),(189,192),(190,193),(191,194),(192,195),(193,196),(697,196),(698,196),(699,196),(194,197),(195,198),(196,199),(547,199),(548,199),(549,199),(197,200),(198,201),(199,202),(557,202),(200,203),(201,204),(202,205),(203,206),(204,207),(205,208),(206,209),(207,210),(208,211),(209,212),(210,213),(211,214),(212,215),(213,216),(598,216),(214,217),(521,217),(551,217),(552,217),(554,217),(610,217),(619,217),(215,218),(216,219),(557,219),(217,220),(218,221),(219,222),(220,223),(232,223),(641,223),(647,223),(648,223),(220,224),(221,225),(222,226),(223,227),(224,228),(225,229),(226,230),(226,231),(542,231),(546,231),(555,231),(641,231),(644,231),(647,231),(648,231),(667,231),(677,231),(226,232),(226,233),(226,234),(227,235),(228,236),(229,237),(230,238),(231,239),(233,240),(234,241),(235,242),(236,243),(237,244),(238,245),(239,246),(240,247),(240,248),(240,249),(240,250),(555,250),(240,251),(691,251),(240,252),(510,252),(516,252),(522,252),(610,252),(612,252),(615,252),(690,252),(241,253),(242,253),(573,253),(574,253),(642,253),(643,253),(690,253),(242,254),(242,255),(242,256),(242,257),(697,257),(698,257),(699,257),(242,258),(242,259),(243,260),(244,261),(245,262),(246,263),(247,264),(248,265),(249,266),(250,267),(251,268),(252,269),(253,270),(254,271),(255,272),(256,273),(257,274),(258,275),(258,276),(259,277),(260,278),(261,279),(262,280),(263,281),(264,282),(265,283),(266,284),(267,285),(268,286),(269,287),(270,288),(271,289),(638,289),(639,289),(272,290),(273,291),(641,291),(646,291),(274,292),(275,293),(276,294),(504,294),(515,294),(277,295),(502,295),(503,295),(513,295),(514,295),(520,295),(527,295),(528,295),(641,295),(649,295),(650,295),(278,296),(279,297),(280,298),(281,299),(282,300),(607,300),(283,301),(502,301),(503,301),(513,301),(514,301),(527,301),(528,301),(641,301),(649,301),(650,301),(284,302),(285,303),(286,304),(520,304),(582,304),(583,304),(610,304),(612,304),(614,304),(616,304),(617,304),(622,304),(656,304),(287,305),(288,306),(288,307),(289,308),(289,309),(290,310),(290,311),(291,312),(291,313),(292,314),(292,315),(293,316),(293,317),(294,318),(295,319),(295,320),(296,321),(296,322),(297,323),(297,324),(298,325),(298,326),(299,327),(299,328),(300,329),(300,330),(301,331),(301,332),(302,333),(303,334),(303,335),(304,336),(305,337),(306,338),(307,339),(308,340),(309,341),(310,342),(311,343),(312,344),(312,345),(313,346),(313,347),(314,348),(315,349),(316,350),(317,351),(318,352),(319,353),(320,354),(321,355),(322,356),(323,357),(324,358),(325,359),(326,360),(327,361),(328,362),(329,363),(330,364),(331,365),(332,366),(333,367),(334,368),(335,369),(335,370),(336,371),(337,372),(338,373),(339,374),(340,375),(341,376),(342,377),(343,378),(344,379),(345,380),(346,381),(347,382),(348,383),(349,384),(350,385),(351,386),(352,387),(353,388),(354,389),(355,390),(356,391),(357,392),(358,393),(359,394),(360,395),(361,396),(362,397),(363,398),(364,399),(365,400),(366,401),(367,402),(368,403),(369,404),(370,405),(371,406),(372,407),(373,408),(374,409),(375,410),(376,411),(377,412),(378,413),(379,414),(380,415),(381,416),(382,417),(383,418),(384,419),(385,420),(386,421),(387,422),(388,422),(387,423),(387,424),(388,425),(388,426),(388,427),(389,428),(390,429),(391,430),(392,431),(393,432),(393,433),(394,434),(395,435),(396,436),(397,437),(398,438),(399,439),(400,440),(401,441),(402,442),(403,443),(404,444),(405,445),(406,446),(407,447),(408,448),(409,449),(410,450),(411,451),(412,452),(413,453),(414,454),(415,455),(416,456),(417,457),(418,458),(418,459),(423,459),(424,459),(427,459),(428,459),(433,459),(544,459),(550,459),(555,459),(560,459),(419,460),(420,461),(421,462),(422,463),(423,463),(662,463),(687,463),(424,464),(555,464),(424,465),(510,465),(522,465),(542,465),(551,465),(552,465),(553,465),(555,465),(559,465),(610,465),(612,465),(424,466),(555,466),(697,466),(698,466),(699,466),(424,467),(424,468),(510,468),(542,468),(553,468),(555,468),(558,468),(559,468),(561,468),(424,469),(425,470),(426,471),(427,472),(428,473),(429,474),(430,475),(431,476),(432,477),(433,478),(434,479),(435,480),(436,481),(437,482),(438,483),(439,484),(440,485),(441,486),(442,487),(443,488),(444,489),(445,490),(446,491),(447,492),(448,493),(449,494),(450,495),(451,496),(452,497),(453,498),(454,499),(455,500),(456,501),(457,502),(458,503),(459,504),(460,505),(461,506),(462,507),(463,508),(464,509),(465,510),(466,511),(467,512),(468,513),(469,514),(470,515),(471,516),(472,517),(473,518),(474,519),(475,520),(476,521),(477,522),(478,523),(479,524),(480,525),(481,526),(482,527),(484,528),(485,529),(486,530),(487,531),(488,532),(489,533),(490,534),(491,535),(492,536),(493,537),(494,538),(495,539),(496,540),(497,541),(498,542),(499,543),(500,544),(501,545),(547,545),(554,545),(561,545),(502,546),(503,546),(510,546),(513,546),(514,546),(522,546),(502,547),(503,547),(510,547),(513,547),(514,547),(522,547),(502,548),(503,548),(562,548),(563,548),(564,548),(565,548),(571,548),(572,548),(502,549),(503,549),(545,549),(562,549),(563,549),(564,549),(565,549),(570,549),(571,549),(572,549),(690,549),(502,550),(503,550),(510,550),(513,550),(514,550),(522,550),(523,550),(547,550),(551,550),(552,550),(554,550),(555,550),(559,550),(562,550),(563,550),(564,550),(565,550),(576,550),(608,550),(609,550),(610,550),(618,550),(619,550),(620,550),(624,550),(637,550),(638,550),(639,550),(640,550),(641,550),(645,550),(504,551),(510,551),(515,551),(516,551),(522,551),(524,551),(610,551),(612,551),(504,552),(515,552),(504,553),(515,553),(504,554),(510,554),(515,554),(621,554),(622,554),(504,555),(515,555),(543,555),(600,555),(504,556),(510,556),(515,556),(621,556),(622,556),(504,557),(515,557),(529,557),(651,557),(504,558),(506,558),(515,558),(523,558),(557,558),(504,559),(515,559),(504,560),(510,560),(511,560),(539,560),(616,560),(504,561),(515,561),(504,562),(515,562),(581,562),(583,562),(585,562),(679,562),(681,562),(693,562),(506,563),(644,563),(688,563),(506,564),(577,564),(579,564),(580,564),(581,564),(582,564),(583,564),(584,564),(585,564),(677,564),(680,564),(681,564),(690,564),(506,565),(690,565),(506,566),(555,566),(577,566),(579,566),(580,566),(581,566),(582,566),(583,566),(584,566),(585,566),(602,566),(605,566),(606,566),(619,566),(624,566),(641,566),(677,566),(680,566),(681,566),(690,566),(697,566),(698,566),(699,566),(506,567),(522,567),(641,567),(506,568),(569,568),(506,569),(506,570),(573,570),(574,570),(575,570),(577,570),(642,570),(643,570),(668,570),(693,570),(506,571),(522,571),(523,571),(506,572),(506,573),(615,573),(506,574),(562,574),(563,574),(564,574),(565,574),(566,574),(567,574),(568,574),(572,574),(506,575),(507,576),(517,576),(524,576),(555,576),(621,576),(622,576),(623,576),(624,576),(507,577),(517,577),(524,577),(508,578),(518,578),(519,578),(531,578),(532,578),(641,578),(653,578),(672,578),(673,578),(509,579),(520,579),(509,580),(520,580),(533,580),(510,581),(510,582),(510,583),(625,583),(697,583),(698,583),(699,583),(510,584),(511,584),(522,584),(524,584),(510,585),(510,586),(522,586),(510,587),(577,587),(578,587),(579,587),(510,588),(522,588),(626,588),(510,589),(522,589),(627,589),(510,590),(510,591),(522,591),(551,591),(641,591),(647,591),(648,591),(510,592),(522,592),(510,593),(522,593),(691,593),(697,593),(698,593),(699,593),(510,594),(522,594),(510,595),(520,595),(522,595),(551,595),(510,596),(522,596),(510,597),(522,597),(510,598),(610,598),(510,599),(511,599),(527,599),(528,599),(529,599),(530,599),(531,599),(532,599),(533,599),(534,599),(535,599),(536,599),(537,599),(538,599),(588,599),(589,599),(610,599),(613,599),(614,599),(623,599),(631,599),(510,600),(511,600),(522,600),(524,600),(536,600),(641,600),(660,600),(690,600),(510,601),(510,602),(522,602),(545,602),(510,603),(520,603),(522,603),(523,603),(510,604),(516,604),(522,604),(510,605),(546,605),(551,605),(510,606),(522,606),(510,607),(516,607),(522,607),(510,608),(641,608),(667,608),(510,609),(522,609),(510,610),(555,610),(569,610),(570,610),(610,610),(612,610),(690,610),(510,611),(522,611),(510,612),(522,612),(510,613),(610,613),(510,614),(628,614),(510,615),(522,615),(510,616),(516,616),(522,616),(510,617),(522,617),(542,617),(547,617),(551,617),(554,617),(555,617),(557,617),(689,617),(692,617),(510,618),(510,619),(520,619),(582,619),(583,619),(610,619),(612,619),(619,619),(510,620),(510,621),(510,622),(510,623),(510,624),(629,624),(510,625),(522,625),(510,626),(516,626),(521,626),(534,626),(510,627),(522,627),(510,628),(522,628),(510,629),(522,629),(510,630),(511,630),(524,630),(536,630),(510,631),(622,631),(510,632),(553,632),(560,632),(510,633),(510,634),(626,634),(510,635),(516,635),(522,635),(511,636),(524,636),(511,637),(524,637),(511,638),(566,638),(567,638),(568,638),(573,638),(574,638),(577,638),(579,638),(619,638),(511,639),(524,639),(536,639),(606,639),(511,640),(524,640),(512,641),(526,641),(538,641),(513,642),(514,642),(515,642),(521,642),(527,642),(528,642),(529,642),(533,642),(534,642),(535,642),(538,642),(610,642),(611,642),(612,642),(613,642),(614,642),(617,642),(631,642),(694,642),(515,643),(515,644),(515,645),(515,646),(516,647),(520,648),(520,649),(520,650),(520,651),(520,652),(521,653),(521,654),(521,655),(521,656),(521,657),(534,657),(521,658),(534,658),(622,658),(522,659),(523,659),(522,660),(522,661),(523,661),(535,661),(538,661),(522,662),(522,663),(522,664),(551,664),(522,665),(523,665),(542,665),(522,666),(522,667),(522,668),(641,668),(647,668),(648,668),(674,668),(684,668),(522,669),(522,670),(522,671),(522,672),(522,673),(522,674),(522,675),(522,676),(522,677),(523,677),(615,677),(522,678),(522,679),(523,680),(535,680),(538,680),(523,681),(547,681),(555,681),(559,681),(524,682),(524,683),(524,684),(524,685),(524,686),(557,686),(701,686),(525,687),(537,687),(641,687),(535,688),(541,689),(542,690),(545,690),(553,690),(555,690),(558,690),(559,690),(561,690),(644,690),(677,690),(542,691),(547,691),(551,691),(552,691),(554,691),(559,691),(570,691),(542,692),(626,692),(629,692),(542,693),(557,693),(587,693),(666,693),(542,694),(545,694),(559,694),(647,694),(648,694),(667,694),(544,695),(550,695),(555,695),(560,695),(580,695),(581,695),(610,695),(615,695),(617,695),(618,695),(620,695),(689,695),(692,695),(544,696),(553,696),(620,696),(545,697),(601,697),(545,698),(606,698),(545,699),(545,700),(545,701),(604,701),(641,701),(669,701),(545,702),(547,703),(549,703),(554,703),(547,704),(547,705),(555,705),(547,706),(551,706),(552,706),(555,706),(557,706),(559,706),(617,706),(692,706),(547,707),(553,707),(554,707),(555,707),(692,707),(547,708),(561,708),(547,709),(548,709),(553,709),(554,709),(555,709),(697,709),(698,709),(699,709),(550,710),(553,710),(551,711),(552,711),(551,712),(551,713),(551,714),(641,714),(647,714),(648,714),(551,715),(552,715),(551,716),(552,716),(551,717),(692,717),(551,718),(552,718),(570,718),(625,718),(628,718),(629,718),(690,718),(551,719),(551,720),(551,721),(552,722),(610,722),(612,722),(552,723),(555,724),(557,724),(570,724),(610,724),(612,724),(615,724),(555,725),(555,726),(555,727),(555,728),(557,728),(555,729),(555,730),(555,731),(555,732),(555,733),(555,734),(555,735),(555,736),(555,737),(555,738),(557,738),(556,739),(557,740),(557,741),(621,741),(623,741),(557,742),(557,743),(557,744),(562,745),(563,745),(564,745),(565,745),(562,746),(563,746),(564,746),(565,746),(572,746),(590,746),(562,747),(563,747),(564,747),(565,747),(562,748),(563,748),(564,748),(565,748),(572,748),(562,749),(563,749),(564,749),(565,749),(572,749),(562,750),(563,750),(564,750),(565,750),(566,750),(567,750),(568,750),(572,750),(562,751),(563,751),(564,751),(565,751),(572,751),(562,752),(563,752),(564,752),(565,752),(572,752),(582,752),(583,752),(562,753),(563,753),(564,753),(565,753),(571,753),(562,754),(563,754),(564,754),(565,754),(562,755),(563,755),(564,755),(565,755),(570,755),(571,755),(572,755),(566,756),(567,756),(568,756),(569,757),(569,758),(570,758),(610,758),(612,758),(570,759),(641,759),(669,759),(684,759),(690,759),(571,760),(571,761),(637,761),(682,761),(686,761),(571,762),(571,763),(571,764),(571,765),(571,766),(637,766),(682,766),(686,766),(571,767),(572,768),(586,768),(588,768),(589,768),(572,769),(572,770),(573,771),(574,771),(573,772),(574,772),(641,772),(642,772),(643,772),(690,772),(573,773),(574,773),(575,774),(580,774),(581,774),(693,774),(694,774),(576,775),(577,776),(579,776),(577,777),(579,777),(577,778),(577,779),(577,780),(577,781),(577,782),(577,783),(577,784),(577,785),(577,786),(577,787),(577,788),(577,789),(577,790),(577,791),(577,792),(577,793),(577,794),(577,795),(577,796),(577,797),(577,798),(577,799),(577,800),(577,801),(579,801),(577,802),(579,802),(577,803),(579,803),(577,804),(579,804),(578,805),(578,806),(578,807),(578,808),(578,809),(578,810),(578,811),(578,812),(578,813),(579,813),(615,813),(579,814),(579,815),(579,816),(579,817),(579,818),(579,819),(579,820),(579,821),(579,822),(579,823),(579,824),(579,825),(579,826),(579,827),(579,828),(579,829),(579,830),(579,831),(579,832),(579,833),(579,834),(579,835),(579,836),(579,837),(580,838),(582,838),(584,838),(680,838),(693,838),(582,839),(583,839),(582,840),(583,840),(584,840),(585,840),(582,841),(583,841),(582,842),(583,842),(582,843),(583,843),(582,844),(583,844),(582,845),(583,845),(584,845),(585,845),(584,846),(585,846),(587,847),(615,847),(588,848),(589,848),(592,849),(602,849),(605,849),(606,849),(594,850),(595,851),(596,852),(597,853),(598,854),(599,855),(600,856),(602,857),(603,858),(605,859),(606,860),(606,861),(607,862),(608,862),(609,862),(607,863),(608,863),(609,863),(607,864),(608,864),(609,864),(607,865),(608,865),(609,865),(607,866),(608,866),(609,866),(607,867),(608,867),(609,867),(607,868),(608,868),(609,868),(607,869),(607,870),(607,871),(608,871),(609,871),(607,872),(608,872),(609,872),(607,873),(607,874),(607,875),(608,875),(609,875),(607,876),(608,876),(609,876),(607,877),(608,877),(609,877),(608,878),(608,879),(609,879),(609,880),(610,881),(612,881),(610,882),(612,882),(610,883),(610,884),(612,884),(610,885),(612,885),(619,885),(610,886),(612,886),(610,887),(610,888),(612,888),(610,889),(610,890),(612,890),(610,891),(610,892),(612,892),(610,893),(612,893),(610,894),(612,894),(610,895),(612,895),(610,896),(612,896),(610,897),(612,897),(610,898),(615,898),(618,898),(620,898),(610,899),(610,900),(612,900),(610,901),(612,901),(610,902),(612,902),(619,902),(610,903),(610,904),(612,904),(610,905),(619,905),(610,906),(612,906),(610,907),(611,907),(612,907),(613,907),(615,907),(618,907),(620,907),(610,908),(612,908),(610,909),(612,909),(610,910),(612,910),(610,911),(610,912),(612,912),(612,913),(612,914),(615,915),(615,916),(615,917),(615,918),(617,918),(615,919),(617,919),(615,920),(617,920),(671,920),(690,920),(615,921),(615,922),(696,922),(615,923),(615,924),(617,925),(617,926),(617,927),(621,928),(622,928),(623,928),(624,928),(621,929),(622,929),(621,930),(622,930),(625,931),(628,931),(629,931),(690,931),(626,932),(626,933),(629,934),(647,934),(648,934),(667,934),(684,934),(629,935),(630,936),(630,937),(630,938),(630,939),(632,940),(634,940),(632,941),(633,941),(633,942),(635,942),(641,942),(634,943),(635,943),(636,944),(637,945),(694,945),(637,946),(637,947),(640,948),(641,949),(658,949),(659,949),(641,950),(661,950),(641,951),(662,951),(641,952),(666,952),(641,953),(679,953),(690,953),(641,954),(641,955),(660,955),(641,956),(674,956),(641,957),(658,957),(659,957),(641,958),(642,958),(643,958),(644,958),(645,958),(646,958),(647,958),(648,958),(649,958),(650,958),(651,958),(652,958),(653,958),(654,958),(656,958),(658,958),(659,958),(660,958),(661,958),(662,958),(663,958),(664,958),(665,958),(666,958),(667,958),(668,958),(669,958),(670,958),(671,958),(672,958),(673,958),(674,958),(675,958),(676,958),(677,958),(678,958),(679,958),(680,958),(681,958),(682,958),(683,958),(684,958),(685,958),(686,958),(687,958),(641,959),(660,959),(665,959),(668,959),(673,959),(680,959),(681,959),(682,959),(683,959),(690,959),(641,960),(685,960),(641,961),(686,961),(641,962),(687,962),(644,963),(663,963),(677,963),(661,964),(664,965),(672,965),(670,966),(675,967),(676,968),(677,969),(678,970),(689,971),(692,971),(690,972),(690,973),(690,974),(690,975),(690,976),(690,977),(690,978),(691,979),(692,980),(695,981),(697,982),(698,982),(699,982),(697,983),(698,983),(699,983),(697,984),(698,984),(699,984),(697,985),(698,985),(699,985);
/*!40000 ALTER TABLE `help_relation` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `help_topic`
--

DROP TABLE IF EXISTS `help_topic`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `help_topic` (
  `help_topic_id` int unsigned NOT NULL,
  `name` char(64) NOT NULL,
  `help_category_id` smallint unsigned NOT NULL,
  `description` text NOT NULL,
  `example` text NOT NULL,
  `url` text NOT NULL,
  PRIMARY KEY (`help_topic_id`),
  UNIQUE KEY `name` (`name`)
) /*!50100 TABLESPACE `mysql` */ ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 STATS_PERSISTENT=0 ROW_FORMAT=DYNAMIC COMMENT='help topics';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `help_topic`
--

LOCK TABLES `help_topic` WRITE;
/*!40000 ALTER TABLE `help_topic` DISABLE KEYS */;
INSERT INTO `help_topic` VALUES (0,'HELP_DATE',1,'This help information was generated from the MySQL 8.0 Reference Manual\non: 2023-03-03\n','',''),(1,'HELP_VERSION',1,'This help information was generated from the MySQL 8.0 Reference Manual\non: 2023-03-03 (revision: 75101)\n\nThis information applies to MySQL 8.0 through 8.0.32.\n','',''),(2,'AUTO_INCREMENT',2,'The AUTO_INCREMENT attribute can be used to generate a unique identity\nfor new rows:\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/example-auto-increment.html\n\n','CREATE TABLE animals (\n     id MEDIUMINT NOT NULL AUTO_INCREMENT,\n     name CHAR(30) NOT NULL,\n     PRIMARY KEY (id)\n);\n\nINSERT INTO animals (name) VALUES\n    (\'dog\'),(\'cat\'),(\'penguin\'),\n    (\'lax\'),(\'whale\'),(\'ostrich\');\n\nSELECT * FROM animals;\n','https://dev.mysql.com/doc/refman/8.0/en/example-auto-increment.html'),(3,'HELP COMMAND',3,'Syntax:\nmysql> help search_string\n\nIf you provide an argument to the help command, mysql uses it as a\nsearch string to access server-side help from the contents of the MySQL\nReference Manual. The proper operation of this command requires that\nthe help tables in the mysql database be initialized with help topic\ninformation (see\nhttps://dev.mysql.com/doc/refman/8.0/en/server-side-help-support.html).\n\nIf there is no match for the search string, the search fails:\n\nmysql> help me\n\nNothing found\nPlease try to run \'help contents\' for a list of all accessible topics\n\nUse help contents to see a list of the help categories:\n\nmysql> help contents\nYou asked for help about help category: \"Contents\"\nFor more information, type \'help <item>\', where <item> is one of the\nfollowing categories:\n   Account Management\n   Administration\n   Data Definition\n   Data Manipulation\n   Data Types\n   Functions\n   Functions and Modifiers for Use with GROUP BY\n   Geographic Features\n   Language Structure\n   Plugins\n   Storage Engines\n   Stored Routines\n   Table Maintenance\n   Transactions\n   Triggers\n\nIf the search string matches multiple items, mysql shows a list of\nmatching topics:\n\nmysql> help logs\nMany help items for your request exist.\nTo make a more specific request, please type \'help <item>\',\nwhere <item> is one of the following topics:\n   SHOW\n   SHOW BINARY LOGS\n   SHOW ENGINE\n   SHOW LOGS\n\nUse a topic as the search string to see the help entry for that topic:\n\nmysql> help show binary logs\nName: \'SHOW BINARY LOGS\'\nDescription:\nSyntax:\nSHOW BINARY LOGS\nSHOW MASTER LOGS\n\nLists the binary log files on the server. This statement is used as\npart of the procedure described in [purge-binary-logs], that shows how\nto determine which logs can be purged.\n\nmysql> SHOW BINARY LOGS;\n+---------------+-----------+-----------+\n| Log_name      | File_size | Encrypted |\n+---------------+-----------+-----------+\n| binlog.000015 |    724935 | Yes       |\n| binlog.000016 |    733481 | Yes       |\n+---------------+-----------+-----------+\n\nThe search string can contain the wildcard characters % and _. These\nhave the same meaning as for pattern-matching operations performed with\nthe LIKE operator. For example, HELP rep% returns a list of topics that\nbegin with rep:\n\nmysql> HELP rep%\nMany help items for your request exist.\nTo make a more specific request, please type \'help <item>\',\nwhere <item> is one of the following\ntopics:\n   REPAIR TABLE\n   REPEAT FUNCTION\n   REPEAT LOOP\n   REPLACE\n   REPLACE FUNCTION\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/mysql-server-side-help.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/mysql-server-side-help.html'),(4,'ASYMMETRIC_DECRYPT',5,'Syntax:\nasymmetric_decrypt(algorithm, data_str, priv_key_str)\n\nDecrypts an encrypted string using the given algorithm and key string,\nand returns the resulting plaintext as a binary string. If decryption\nfails, the result is NULL.\n\nFor the legacy version of this function in use before MySQL 8.0.29, see\nhttps://dev.mysql.com/doc/refman/8.0/en/enterprise-encryption-functions\n-legacy.html.\n\nBy default, the component_enterprise_encryption function assumes that\nencrypted text uses the RSAES-OAEP padding scheme. The function\nsupports decryption for content encrypted by the legacy openssl_udf\nshared library functions if the system variable\nenterprise_encryption.rsa_support_legacy_padding is set to ON (the\ndefault is OFF). When ON is set, the function also supports the\nRSAES-PKCS1-v1_5 padding scheme, as used by the legacy openssl_udf\nshared library functions. When OFF is set, content encrypted by the\nlegacy functions cannot be decrypted, and the function returns null\noutput for such content.\n\nalgorithm is the encryption algorithm used to create the key. The\nsupported algorithm value is \'RSA\'.\n\ndata_str is the encrypted string to decrypt, which was encrypted with\nasymmetric_encrypt().\n\npriv_key_str is a valid PEM encoded RSA private key. For successful\ndecryption, the key string must correspond to the public key string\nused with asymmetric_encrypt() to produce the encrypted string. The\nasymmetric_encrypt() component function only supports encryption using\na public key, so decryption takes place with the corresponding private\nkey.\n\nFor a usage example, see the description of asymmetric_encrypt().\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/enterprise-encryption-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/enterprise-encryption-functions.html'),(5,'ASYMMETRIC_ENCRYPT',5,'Syntax:\nasymmetric_encrypt(algorithm, data_str, pub_key_str)\n\nEncrypts a string using the given algorithm and key string, and returns\nthe resulting ciphertext as a binary string. If encryption fails, the\nresult is NULL.\n\nFor the legacy version of this function in use before MySQL 8.0.29, see\nhttps://dev.mysql.com/doc/refman/8.0/en/enterprise-encryption-functions\n-legacy.html.\n\nalgorithm is the encryption algorithm used to create the key. The\nsupported algorithm value is \'RSA\'.\n\ndata_str is the string to encrypt. The length of this string cannot be\ngreater than the key string length in bytes, minus 42 (to account for\nthe padding).\n\npub_key_str is a valid PEM encoded RSA public key. The\nasymmetric_encrypt() component function only supports encryption using\na public key.\n\nTo recover the original unencrypted string, pass the encrypted string\nto asymmetric_decrypt(), along with the other part of the key pair used\nfor encryption, as in the following example:\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/enterprise-encryption-functions.html\n\n','-- Generate private/public key pair\nSET @priv = create_asymmetric_priv_key(\'RSA\', 2048);\nSET @pub = create_asymmetric_pub_key(\'RSA\', @priv);\n\n-- Encrypt using public key, decrypt using private key\nSET @ciphertext = asymmetric_encrypt(\'RSA\', \'The quick brown fox\', @pub);\nSET @plaintext = asymmetric_decrypt(\'RSA\', @ciphertext, @priv);\n','https://dev.mysql.com/doc/refman/8.0/en/enterprise-encryption-functions.html'),(6,'ASYMMETRIC_SIGN',5,'Syntax:\nasymmetric_sign(algorithm, text, priv_key_str, digest_type)\n\nSigns a digest string or data string using a private key, and returns\nthe signature as a binary string. If signing fails, the result is NULL.\n\nFor the legacy version of this function in use before MySQL 8.0.29, see\nhttps://dev.mysql.com/doc/refman/8.0/en/enterprise-encryption-functions\n-legacy.html.\n\nalgorithm is the encryption algorithm used to create the key. The\nsupported algorithm value is \'RSA\'.\n\ntext is a data string or digest string. The function accepts digests\nbut does not require them, as it is also capable of handling data\nstrings of an arbitrary length. A digest string can be generated by\ncalling create_digest().\n\npriv_key_str is the private key string to use for signing the digest\nstring. It must be a valid PEM encoded RSA private key.\n\ndigest_type is the algorithm to be used to sign the data. The supported\ndigest_type values are \'SHA224\', \'SHA256\', \'SHA384\', and \'SHA512\' when\nOpenSSL 1.0.1 is in use. If OpenSSL 1.1.1 is in use, the additional\ndigest_type values \'SHA3-224\', \'SHA3-256\', \'SHA3-384\', and \'SHA3-512\'\nare available.\n\nFor a usage example, see the description of asymmetric_verify().\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/enterprise-encryption-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/enterprise-encryption-functions.html'),(7,'ASYMMETRIC_VERIFY',5,'Syntax:\nasymmetric_verify(algorithm, text, sig_str, pub_key_str, digest_type)\n\nVerifies whether the signature string matches the digest string, and\nreturns 1 or 0 to indicate whether verification succeeded or failed. If\nverification fails, the result is NULL.\n\nFor the legacy version of this function in use before MySQL 8.0.29, see\nhttps://dev.mysql.com/doc/refman/8.0/en/enterprise-encryption-functions\n-legacy.html.\n\nBy default, the component_enterprise_encryption function assumes that\nsignatures use the RSASSA-PSS signature scheme. The function supports\nverification for signatures produced by the legacy openssl_udf shared\nlibrary functions if the system variable\nenterprise_encryption.rsa_support_legacy_padding is set to ON (the\ndefault is OFF). When ON is set, the function also supports the\nRSASSA-PKCS1-v1_5 signature scheme, as used by the legacy openssl_udf\nshared library functions. When OFF is set, signatures produced by the\nlegacy functions cannot be verified, and the function returns null\noutput for such content.\n\nalgorithm is the encryption algorithm used to create the key. The\nsupported algorithm value is \'RSA\'.\n\ntext is a data string or digest string. The component function accepts\ndigests but does not require them, as it is also capable of handling\ndata strings of an arbitrary length. A digest string can be generated\nby calling create_digest().\n\nsig_str is the signature string to be verified. A signature string can\nbe generated by calling asymmetric_sign().\n\npub_key_str is the public key string of the signer. It corresponds to\nthe private key passed to asymmetric_sign() to generate the signature\nstring. It must be a valid PEM encoded RSA public key.\n\ndigest_type is the algorithm that was used to sign the data. The\nsupported digest_type values are \'SHA224\', \'SHA256\', \'SHA384\', and\n\'SHA512\' when OpenSSL 1.0.1 is in use. If OpenSSL 1.1.1 is in use, the\nadditional digest_type values \'SHA3-224\', \'SHA3-256\', \'SHA3-384\', and\n\'SHA3-512\' are available.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/enterprise-encryption-functions.html\n\n','-- Set the encryption algorithm and digest type\nSET @algo = \'RSA\';\nSET @dig_type = \'SHA512\';\n\n-- Create private/public key pair\nSET @priv = create_asymmetric_priv_key(@algo, 2048);\nSET @pub = create_asymmetric_pub_key(@algo, @priv);\n\n-- Generate digest from string\nSET @dig = create_digest(@dig_type, \'The quick brown fox\');\n\n-- Generate signature for digest and verify signature against digest\nSET @sig = asymmetric_sign(@algo, @dig, @priv, @dig_type);\nSET @verf = asymmetric_verify(@algo, @dig, @sig, @pub, @dig_type);\n','https://dev.mysql.com/doc/refman/8.0/en/enterprise-encryption-functions.html'),(8,'CREATE_ASYMMETRIC_PRIV_KEY',5,'Syntax:\ncreate_asymmetric_priv_key(algorithm, key_length)\n\nCreates a private key using the given algorithm and key length, and\nreturns the key as a binary string in PEM format. The key is in PKCS #8\nformat. If key generation fails, the result is NULL.\n\nFor the legacy version of this function in use before MySQL 8.0.29, see\nhttps://dev.mysql.com/doc/refman/8.0/en/enterprise-encryption-functions\n-legacy.html.\n\nalgorithm is the encryption algorithm used to create the key. The\nsupported algorithm value is \'RSA\'.\n\nkey_length is the key length in bits. If you exceed the maximum allowed\nkey length or specify less than the minimum, key generation fails and\nthe result is null output. The minimum allowed key length in bits is\n2048. The maximum allowed key length is the value of the\nenterprise_encryption.maximum_rsa_key_size system variable, which\ndefaults to 4096. It has a maximum setting of 16384, which is the\nmaximum key length allowed for the RSA algorithm. See\nhttps://dev.mysql.com/doc/refman/8.0/en/enterprise-encryption-configuri\nng.html.\n\n*Note*:\n\nGenerating longer keys can consume significant CPU resources. Limiting\nthe key length using the enterprise_encryption.maximum_rsa_key_size\nsystem variable lets you provide adequate security for your\nrequirements while balancing this with resource usage.\n\nThis example creates a 2048-bit RSA private key, then derives a public\nkey from the private key:\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/enterprise-encryption-functions.html\n\n','SET @priv = create_asymmetric_priv_key(\'RSA\', 2048);\nSET @pub = create_asymmetric_pub_key(\'RSA\', @priv);\n','https://dev.mysql.com/doc/refman/8.0/en/enterprise-encryption-functions.html'),(9,'CREATE_ASYMMETRIC_PUB_KEY',5,'Syntax:\ncreate_asymmetric_pub_key(algorithm, priv_key_str)\n\nDerives a public key from the given private key using the given\nalgorithm, and returns the key as a binary string in PEM format. The\nkey is in PKCS #8 format. If key derivation fails, the result is NULL.\n\nFor the legacy version of this function in use before MySQL 8.0.29, see\nhttps://dev.mysql.com/doc/refman/8.0/en/enterprise-encryption-functions\n-legacy.html.\n\nalgorithm is the encryption algorithm used to create the key. The\nsupported algorithm value is \'RSA\'.\n\npriv_key_str is a valid PEM encoded RSA private key.\n\nFor a usage example, see the description of\ncreate_asymmetric_priv_key().\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/enterprise-encryption-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/enterprise-encryption-functions.html'),(10,'CREATE_DIGEST',5,'Syntax:\ncreate_digest(digest_type, str)\n\nCreates a digest from the given string using the given digest type, and\nreturns the digest as a binary string. If digest generation fails, the\nresult is NULL.\n\nFor the legacy version of this function in use before MySQL 8.0.29, see\nhttps://dev.mysql.com/doc/refman/8.0/en/enterprise-encryption-functions\n-legacy.html.\n\nThe resulting digest string is suitable for use with asymmetric_sign()\nand asymmetric_verify(). The component versions of these functions\naccept digests but do not require them, as they are capable of handling\ndata of an arbitrary length.\n\ndigest_type is the digest algorithm to be used to generate the digest\nstring. The supported digest_type values are \'SHA224\', \'SHA256\',\n\'SHA384\', and \'SHA512\' when OpenSSL 1.0.1 is in use. If OpenSSL 1.1.1\nis in use, the additional digest_type values \'SHA3-224\', \'SHA3-256\',\n\'SHA3-384\', and \'SHA3-512\' are available.\n\nstr is the non-null data string for which the digest is to be\ngenerated.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/enterprise-encryption-functions.html\n\n','SET @dig = create_digest(\'SHA512\', \'The quick brown fox\');\n','https://dev.mysql.com/doc/refman/8.0/en/enterprise-encryption-functions.html'),(11,'ASYMMETRIC_DERIVE',5,'Syntax:\nasymmetric_derive(pub_key_str, priv_key_str)\n\nDerives a symmetric key using the private key of one party and the\npublic key of another, and returns the resulting key as a binary\nstring. If key derivation fails, the result is NULL.\n\npub_key_str and priv_key_str are valid PEM encoded key strings that\nwere created using the DH algorithm.\n\nSuppose that you have two pairs of public and private keys:\n\nSET @dhp = create_dh_parameters(1024);\nSET @priv1 = create_asymmetric_priv_key(\'DH\', @dhp);\nSET @pub1 = create_asymmetric_pub_key(\'DH\', @priv1);\nSET @priv2 = create_asymmetric_priv_key(\'DH\', @dhp);\nSET @pub2 = create_asymmetric_pub_key(\'DH\', @priv2);\n\nSuppose further that you use the private key from one pair and the\npublic key from the other pair to create a symmetric key string. Then\nthis symmetric key identity relationship holds:\n\nasymmetric_derive(@pub1, @priv2) = asymmetric_derive(@pub2, @priv1)\n\nThis example requires DH private/public keys as inputs, created using a\nshared symmetric secret. Create the secret by passing the key length to\ncreate_dh_parameters(), then pass the secret as the \"key length\" to\ncreate_asymmetric_priv_key().\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/enterprise-encryption-functions-legacy.html\n\n','-- Generate DH shared symmetric secret\nSET @dhp = create_dh_parameters(1024);\n-- Generate DH key pairs\nSET @algo = \'DH\';\nSET @priv1 = create_asymmetric_priv_key(@algo, @dhp);\nSET @pub1 = create_asymmetric_pub_key(@algo, @priv1);\nSET @priv2 = create_asymmetric_priv_key(@algo, @dhp);\nSET @pub2 = create_asymmetric_pub_key(@algo, @priv2);\n\n-- Generate symmetric key using public key of first party,\n-- private key of second party\nSET @sym1 = asymmetric_derive(@pub1, @priv2);\n\n-- Or use public key of second party, private key of first party\nSET @sym2 = asymmetric_derive(@pub2, @priv1);\n','https://dev.mysql.com/doc/refman/8.0/en/enterprise-encryption-functions-legacy.html'),(12,'CREATE_DH_PARAMETERS',5,'create_dh_parameters(key_len)\n\nCreates a shared secret for generating a DH private/public key pair and\nreturns a binary string that can be passed to\ncreate_asymmetric_priv_key(). If secret generation fails, the result is\nNULL.\n\nkey_len is the key length. The minimum and maximum key lengths in bits\nare 1,024 and 10,000. These key-length limits are constraints imposed\nby OpenSSL. Server administrators can impose additional limits on\nmaximum key length by setting the MYSQL_OPENSSL_UDF_RSA_BITS_THRESHOLD,\nMYSQL_OPENSSL_UDF_DSA_BITS_THRESHOLD, and\nMYSQL_OPENSSL_UDF_DH_BITS_THRESHOLD environment variables. See\nhttps://dev.mysql.com/doc/refman/8.0/en/enterprise-encryption-configuri\nng.html.\n\nFor an example showing how to use the return value for generating\nsymmetric keys, see the description of asymmetric_derive().\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/enterprise-encryption-functions-legacy.html\n\n','SET @dhp = create_dh_parameters(1024);\n','https://dev.mysql.com/doc/refman/8.0/en/enterprise-encryption-functions-legacy.html'),(13,'TRUE',6,'The constants TRUE and FALSE evaluate to 1 and 0, respectively. The\nconstant names can be written in any lettercase.\n\nmysql> SELECT TRUE, true, FALSE, false;\n        -> 1, 1, 0, 0\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/boolean-literals.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/boolean-literals.html'),(14,'FALSE',6,'The constants TRUE and FALSE evaluate to 1 and 0, respectively. The\nconstant names can be written in any lettercase.\n\nmysql> SELECT TRUE, true, FALSE, false;\n        -> 1, 1, 0, 0\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/boolean-literals.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/boolean-literals.html'),(15,'BIT',2,'BIT[(M)]\n\nA bit-value type. M indicates the number of bits per value, from 1 to\n64. The default is 1 if M is omitted.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/numeric-type-syntax.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/numeric-type-syntax.html'),(16,'TINYINT',2,'TINYINT[(M)] [UNSIGNED] [ZEROFILL]\n\nA very small integer. The signed range is -128 to 127. The unsigned\nrange is 0 to 255.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/numeric-type-syntax.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/numeric-type-syntax.html'),(17,'BOOLEAN',2,'BOOL, BOOLEAN\n\nThese types are synonyms for TINYINT(1). A value of zero is considered\nfalse. Nonzero values are considered true:\n\nmysql> SELECT IF(0, \'true\', \'false\');\n+------------------------+\n| IF(0, \'true\', \'false\') |\n+------------------------+\n| false                  |\n+------------------------+\n\nmysql> SELECT IF(1, \'true\', \'false\');\n+------------------------+\n| IF(1, \'true\', \'false\') |\n+------------------------+\n| true                   |\n+------------------------+\n\nmysql> SELECT IF(2, \'true\', \'false\');\n+------------------------+\n| IF(2, \'true\', \'false\') |\n+------------------------+\n| true                   |\n+------------------------+\n\nHowever, the values TRUE and FALSE are merely aliases for 1 and 0,\nrespectively, as shown here:\n\nmysql> SELECT IF(0 = FALSE, \'true\', \'false\');\n+--------------------------------+\n| IF(0 = FALSE, \'true\', \'false\') |\n+--------------------------------+\n| true                           |\n+--------------------------------+\n\nmysql> SELECT IF(1 = TRUE, \'true\', \'false\');\n+-------------------------------+\n| IF(1 = TRUE, \'true\', \'false\') |\n+-------------------------------+\n| true                          |\n+-------------------------------+\n\nmysql> SELECT IF(2 = TRUE, \'true\', \'false\');\n+-------------------------------+\n| IF(2 = TRUE, \'true\', \'false\') |\n+-------------------------------+\n| false                         |\n+-------------------------------+\n\nmysql> SELECT IF(2 = FALSE, \'true\', \'false\');\n+--------------------------------+\n| IF(2 = FALSE, \'true\', \'false\') |\n+--------------------------------+\n| false                          |\n+--------------------------------+\n\nThe last two statements display the results shown because 2 is equal to\nneither 1 nor 0.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/numeric-type-syntax.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/numeric-type-syntax.html'),(18,'SMALLINT',2,'SMALLINT[(M)] [UNSIGNED] [ZEROFILL]\n\nA small integer. The signed range is -32768 to 32767. The unsigned\nrange is 0 to 65535.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/numeric-type-syntax.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/numeric-type-syntax.html'),(19,'MEDIUMINT',2,'MEDIUMINT[(M)] [UNSIGNED] [ZEROFILL]\n\nA medium-sized integer. The signed range is -8388608 to 8388607. The\nunsigned range is 0 to 16777215.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/numeric-type-syntax.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/numeric-type-syntax.html'),(20,'INT',2,'INT[(M)] [UNSIGNED] [ZEROFILL]\n\nA normal-size integer. The signed range is -2147483648 to 2147483647.\nThe unsigned range is 0 to 4294967295.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/numeric-type-syntax.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/numeric-type-syntax.html'),(21,'INTEGER',2,'INTEGER[(M)] [UNSIGNED] [ZEROFILL]\n\nThis type is a synonym for INT.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/numeric-type-syntax.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/numeric-type-syntax.html'),(22,'BIGINT',2,'BIGINT[(M)] [UNSIGNED] [ZEROFILL]\n\nA large integer. The signed range is -9223372036854775808 to\n9223372036854775807. The unsigned range is 0 to 18446744073709551615.\n\nSERIAL is an alias for BIGINT UNSIGNED NOT NULL AUTO_INCREMENT UNIQUE.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/numeric-type-syntax.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/numeric-type-syntax.html'),(23,'DECIMAL',2,'DECIMAL[(M[,D])] [UNSIGNED] [ZEROFILL]\n\nA packed \"exact\" fixed-point number. M is the total number of digits\n(the precision) and D is the number of digits after the decimal point\n(the scale). The decimal point and (for negative numbers) the - sign\nare not counted in M. If D is 0, values have no decimal point or\nfractional part. The maximum number of digits (M) for DECIMAL is 65.\nThe maximum number of supported decimals (D) is 30. If D is omitted,\nthe default is 0. If M is omitted, the default is 10. (There is also a\nlimit on how long the text of DECIMAL literals can be; see\nhttps://dev.mysql.com/doc/refman/8.0/en/precision-math-expressions.html\n.)\n\nUNSIGNED, if specified, disallows negative values. As of MySQL 8.0.17,\nthe UNSIGNED attribute is deprecated for columns of type DECIMAL (and\nany synonyms); you should expect support for it to be removed in a\nfuture version of MySQL. Consider using a simple CHECK constraint\ninstead for such columns.\n\nAll basic calculations (+, -, *, /) with DECIMAL columns are done with\na precision of 65 digits.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/numeric-type-syntax.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/numeric-type-syntax.html'),(24,'DEC',2,'DEC[(M[,D])] [UNSIGNED] [ZEROFILL], NUMERIC[(M[,D])] [UNSIGNED]\n[ZEROFILL], FIXED[(M[,D])] [UNSIGNED] [ZEROFILL]\n\nThese types are synonyms for DECIMAL. The FIXED synonym is available\nfor compatibility with other database systems.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/numeric-type-syntax.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/numeric-type-syntax.html'),(25,'FLOAT',2,'FLOAT[(M,D)] [UNSIGNED] [ZEROFILL]\n\nA small (single-precision) floating-point number. Permissible values\nare -3.402823466E+38 to -1.175494351E-38, 0, and 1.175494351E-38 to\n3.402823466E+38. These are the theoretical limits, based on the IEEE\nstandard. The actual range might be slightly smaller depending on your\nhardware or operating system.\n\nM is the total number of digits and D is the number of digits following\nthe decimal point. If M and D are omitted, values are stored to the\nlimits permitted by the hardware. A single-precision floating-point\nnumber is accurate to approximately 7 decimal places.\n\nFLOAT(M,D) is a nonstandard MySQL extension. As of MySQL 8.0.17, this\nsyntax is deprecated, and you should expect support for it to be\nremoved in a future version of MySQL.\n\nUNSIGNED, if specified, disallows negative values. As of MySQL 8.0.17,\nthe UNSIGNED attribute is deprecated for columns of type FLOAT (and any\nsynonyms) and you should expect support for it to be removed in a\nfuture version of MySQL. Consider using a simple CHECK constraint\ninstead for such columns.\n\nUsing FLOAT might give you some unexpected problems because all\ncalculations in MySQL are done with double precision. See\nhttps://dev.mysql.com/doc/refman/8.0/en/no-matching-rows.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/numeric-type-syntax.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/numeric-type-syntax.html'),(26,'DOUBLE',2,'DOUBLE[(M,D)] [UNSIGNED] [ZEROFILL]\n\nA normal-size (double-precision) floating-point number. Permissible\nvalues are -1.7976931348623157E+308 to -2.2250738585072014E-308, 0, and\n2.2250738585072014E-308 to 1.7976931348623157E+308. These are the\ntheoretical limits, based on the IEEE standard. The actual range might\nbe slightly smaller depending on your hardware or operating system.\n\nM is the total number of digits and D is the number of digits following\nthe decimal point. If M and D are omitted, values are stored to the\nlimits permitted by the hardware. A double-precision floating-point\nnumber is accurate to approximately 15 decimal places.\n\nDOUBLE(M,D) is a nonstandard MySQL extension. As of MySQL 8.0.17, this\nsyntax is deprecated and you should expect support for it to be removed\nin a future version of MySQL.\n\nUNSIGNED, if specified, disallows negative values. As of MySQL 8.0.17,\nthe UNSIGNED attribute is deprecated for columns of type DOUBLE (and\nany synonyms) and you should expect support for it to be removed in a\nfuture version of MySQL. Consider using a simple CHECK constraint\ninstead for such columns.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/numeric-type-syntax.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/numeric-type-syntax.html'),(27,'DOUBLE PRECISION',2,'DOUBLE PRECISION[(M,D)] [UNSIGNED] [ZEROFILL], REAL[(M,D)] [UNSIGNED]\n[ZEROFILL]\n\nThese types are synonyms for DOUBLE. Exception: If the REAL_AS_FLOAT\nSQL mode is enabled, REAL is a synonym for FLOAT rather than DOUBLE.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/numeric-type-syntax.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/numeric-type-syntax.html'),(28,'DATE',2,'DATE\n\nA date. The supported range is \'1000-01-01\' to \'9999-12-31\'. MySQL\ndisplays DATE values in \'YYYY-MM-DD\' format, but permits assignment of\nvalues to DATE columns using either strings or numbers.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-type-syntax.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-type-syntax.html'),(29,'DATETIME',2,'DATETIME[(fsp)]\n\nA date and time combination. The supported range is \'1000-01-01\n00:00:00.000000\' to \'9999-12-31 23:59:59.999999\'. MySQL displays\nDATETIME values in \'YYYY-MM-DD hh:mm:ss[.fraction]\' format, but permits\nassignment of values to DATETIME columns using either strings or\nnumbers.\n\nAn optional fsp value in the range from 0 to 6 may be given to specify\nfractional seconds precision. A value of 0 signifies that there is no\nfractional part. If omitted, the default precision is 0.\n\nAutomatic initialization and updating to the current date and time for\nDATETIME columns can be specified using DEFAULT and ON UPDATE column\ndefinition clauses, as described in\nhttps://dev.mysql.com/doc/refman/8.0/en/timestamp-initialization.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-type-syntax.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-type-syntax.html'),(30,'TIMESTAMP',2,'TIMESTAMP[(fsp)]\n\nA timestamp. The range is \'1970-01-01 00:00:01.000000\' UTC to\n\'2038-01-19 03:14:07.999999\' UTC. TIMESTAMP values are stored as the\nnumber of seconds since the epoch (\'1970-01-01 00:00:00\' UTC). A\nTIMESTAMP cannot represent the value \'1970-01-01 00:00:00\' because that\nis equivalent to 0 seconds from the epoch and the value 0 is reserved\nfor representing \'0000-00-00 00:00:00\', the \"zero\" TIMESTAMP value.\n\nAn optional fsp value in the range from 0 to 6 may be given to specify\nfractional seconds precision. A value of 0 signifies that there is no\nfractional part. If omitted, the default precision is 0.\n\nThe way the server handles TIMESTAMP definitions depends on the value\nof the explicit_defaults_for_timestamp system variable (see\nhttps://dev.mysql.com/doc/refman/8.0/en/server-system-variables.html).\n\nIf explicit_defaults_for_timestamp is enabled, there is no automatic\nassignment of the DEFAULT CURRENT_TIMESTAMP or ON UPDATE\nCURRENT_TIMESTAMP attributes to any TIMESTAMP column. They must be\nincluded explicitly in the column definition. Also, any TIMESTAMP not\nexplicitly declared as NOT NULL permits NULL values.\n\nIf explicit_defaults_for_timestamp is disabled, the server handles\nTIMESTAMP as follows:\n\nUnless specified otherwise, the first TIMESTAMP column in a table is\ndefined to be automatically set to the date and time of the most recent\nmodification if not explicitly assigned a value. This makes TIMESTAMP\nuseful for recording the timestamp of an INSERT or UPDATE operation.\nYou can also set any TIMESTAMP column to the current date and time by\nassigning it a NULL value, unless it has been defined with the NULL\nattribute to permit NULL values.\n\nAutomatic initialization and updating to the current date and time can\nbe specified using DEFAULT CURRENT_TIMESTAMP and ON UPDATE\nCURRENT_TIMESTAMP column definition clauses. By default, the first\nTIMESTAMP column has these properties, as previously noted. However,\nany TIMESTAMP column in a table can be defined to have these\nproperties.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-type-syntax.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-type-syntax.html'),(31,'TIME',2,'TIME[(fsp)]\n\nA time. The range is \'-838:59:59.000000\' to \'838:59:59.000000\'. MySQL\ndisplays TIME values in \'hh:mm:ss[.fraction]\' format, but permits\nassignment of values to TIME columns using either strings or numbers.\n\nAn optional fsp value in the range from 0 to 6 may be given to specify\nfractional seconds precision. A value of 0 signifies that there is no\nfractional part. If omitted, the default precision is 0.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-type-syntax.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-type-syntax.html'),(32,'YEAR DATA TYPE',2,'YEAR[(4)]\n\nA year in 4-digit format. MySQL displays YEAR values in YYYY format,\nbut permits assignment of values to YEAR columns using either strings\nor numbers. Values display as 1901 to 2155, or 0000.\n\nFor additional information about YEAR display format and interpretation\nof input values, see https://dev.mysql.com/doc/refman/8.0/en/year.html.\n\n*Note*:\n\nAs of MySQL 8.0.19, the YEAR(4) data type with an explicit display\nwidth is deprecated; you should expect support for it to be removed in\na future version of MySQL. Instead, use YEAR without a display width,\nwhich has the same meaning.\n\nMySQL 8.0 does not support the 2-digit YEAR(2) data type permitted in\nolder versions of MySQL. For instructions on converting to 4-digit\nYEAR, see 2-Digit YEAR(2) Limitations and Migrating to 4-Digit YEAR\n(https://dev.mysql.com/doc/refman/5.7/en/migrating-from-year2.html), in\nMySQL 5.7 Reference Manual (https://dev.mysql.com/doc/refman/5.7/en/).\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-type-syntax.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-type-syntax.html'),(33,'CHAR',2,'[NATIONAL] CHAR[(M)] [CHARACTER SET charset_name] [COLLATE\ncollation_name]\n\nA fixed-length string that is always right-padded with spaces to the\nspecified length when stored. M represents the column length in\ncharacters. The range of M is 0 to 255. If M is omitted, the length is\n1.\n\n*Note*:\n\nTrailing spaces are removed when CHAR values are retrieved unless the\nPAD_CHAR_TO_FULL_LENGTH SQL mode is enabled.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-type-syntax.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/string-type-syntax.html'),(34,'CHAR BYTE',2,'The CHAR BYTE data type is an alias for the BINARY data type. This is a\ncompatibility feature.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-type-syntax.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/string-type-syntax.html'),(35,'VARCHAR',2,'[NATIONAL] VARCHAR(M) [CHARACTER SET charset_name] [COLLATE\ncollation_name]\n\nA variable-length string. M represents the maximum column length in\ncharacters. The range of M is 0 to 65,535. The effective maximum length\nof a VARCHAR is subject to the maximum row size (65,535 bytes, which is\nshared among all columns) and the character set used. For example,\nutf8mb3 characters can require up to three bytes per character, so a\nVARCHAR column that uses the utf8mb3 character set can be declared to\nbe a maximum of 21,844 characters. See\nhttps://dev.mysql.com/doc/refman/8.0/en/column-count-limit.html.\n\nMySQL stores VARCHAR values as a 1-byte or 2-byte length prefix plus\ndata. The length prefix indicates the number of bytes in the value. A\nVARCHAR column uses one length byte if values require no more than 255\nbytes, two length bytes if values may require more than 255 bytes.\n\n*Note*:\n\nMySQL follows the standard SQL specification, and does not remove\ntrailing spaces from VARCHAR values.\n\nVARCHAR is shorthand for CHARACTER VARYING. NATIONAL VARCHAR is the\nstandard SQL way to define that a VARCHAR column should use some\npredefined character set. MySQL uses utf8mb3 as this predefined\ncharacter set.\nhttps://dev.mysql.com/doc/refman/8.0/en/charset-national.html. NVARCHAR\nis shorthand for NATIONAL VARCHAR.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-type-syntax.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/string-type-syntax.html'),(36,'BINARY',2,'BINARY[(M)]\n\nThe BINARY type is similar to the CHAR type, but stores binary byte\nstrings rather than nonbinary character strings. An optional length M\nrepresents the column length in bytes. If omitted, M defaults to 1.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-type-syntax.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/string-type-syntax.html'),(37,'VARBINARY',2,'VARBINARY(M)\n\nThe VARBINARY type is similar to the VARCHAR type, but stores binary\nbyte strings rather than nonbinary character strings. M represents the\nmaximum column length in bytes.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-type-syntax.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/string-type-syntax.html'),(38,'TINYBLOB',2,'TINYBLOB\n\nA BLOB column with a maximum length of 255 (28 − 1) bytes. Each\nTINYBLOB value is stored using a 1-byte length prefix that indicates\nthe number of bytes in the value.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-type-syntax.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/string-type-syntax.html'),(39,'TINYTEXT',2,'TINYTEXT [CHARACTER SET charset_name] [COLLATE collation_name]\n\nA TEXT column with a maximum length of 255 (28 − 1) characters. The\neffective maximum length is less if the value contains multibyte\ncharacters. Each TINYTEXT value is stored using a 1-byte length prefix\nthat indicates the number of bytes in the value.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-type-syntax.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/string-type-syntax.html'),(40,'BLOB',2,'BLOB[(M)]\n\nA BLOB column with a maximum length of 65,535 (216 − 1) bytes. Each\nBLOB value is stored using a 2-byte length prefix that indicates the\nnumber of bytes in the value.\n\nAn optional length M can be given for this type. If this is done, MySQL\ncreates the column as the smallest BLOB type large enough to hold\nvalues M bytes long.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-type-syntax.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/string-type-syntax.html'),(41,'TEXT',2,'TEXT[(M)] [CHARACTER SET charset_name] [COLLATE collation_name]\n\nA TEXT column with a maximum length of 65,535 (216 − 1) characters.\nThe effective maximum length is less if the value contains multibyte\ncharacters. Each TEXT value is stored using a 2-byte length prefix that\nindicates the number of bytes in the value.\n\nAn optional length M can be given for this type. If this is done, MySQL\ncreates the column as the smallest TEXT type large enough to hold\nvalues M characters long.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-type-syntax.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/string-type-syntax.html'),(42,'MEDIUMBLOB',2,'MEDIUMBLOB\n\nA BLOB column with a maximum length of 16,777,215 (224 − 1) bytes.\nEach MEDIUMBLOB value is stored using a 3-byte length prefix that\nindicates the number of bytes in the value.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-type-syntax.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/string-type-syntax.html'),(43,'MEDIUMTEXT',2,'MEDIUMTEXT [CHARACTER SET charset_name] [COLLATE collation_name]\n\nA TEXT column with a maximum length of 16,777,215 (224 − 1)\ncharacters. The effective maximum length is less if the value contains\nmultibyte characters. Each MEDIUMTEXT value is stored using a 3-byte\nlength prefix that indicates the number of bytes in the value.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-type-syntax.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/string-type-syntax.html'),(44,'LONGBLOB',2,'LONGBLOB\n\nA BLOB column with a maximum length of 4,294,967,295 or 4GB (232 − 1)\nbytes. The effective maximum length of LONGBLOB columns depends on the\nconfigured maximum packet size in the client/server protocol and\navailable memory. Each LONGBLOB value is stored using a 4-byte length\nprefix that indicates the number of bytes in the value.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-type-syntax.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/string-type-syntax.html'),(45,'LONGTEXT',2,'LONGTEXT [CHARACTER SET charset_name] [COLLATE collation_name]\n\nA TEXT column with a maximum length of 4,294,967,295 or 4GB (232 − 1)\ncharacters. The effective maximum length is less if the value contains\nmultibyte characters. The effective maximum length of LONGTEXT columns\nalso depends on the configured maximum packet size in the client/server\nprotocol and available memory. Each LONGTEXT value is stored using a\n4-byte length prefix that indicates the number of bytes in the value.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-type-syntax.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/string-type-syntax.html'),(46,'ENUM',2,'ENUM(\'value1\',\'value2\',...) [CHARACTER SET charset_name] [COLLATE\ncollation_name]\n\nAn enumeration. A string object that can have only one value, chosen\nfrom the list of values \'value1\', \'value2\', ..., NULL or the special \'\'\nerror value. ENUM values are represented internally as integers.\n\nAn ENUM column can have a maximum of 65,535 distinct elements.\n\nThe maximum supported length of an individual ENUM element is M <= 255\nand (M x w) <= 1020, where M is the element literal length and w is the\nnumber of bytes required for the maximum-length character in the\ncharacter set.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-type-syntax.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/string-type-syntax.html'),(47,'SET DATA TYPE',2,'SET(\'value1\',\'value2\',...) [CHARACTER SET charset_name] [COLLATE\ncollation_name]\n\nA set. A string object that can have zero or more values, each of which\nmust be chosen from the list of values \'value1\', \'value2\', ... SET\nvalues are represented internally as integers.\n\nA SET column can have a maximum of 64 distinct members.\n\nThe maximum supported length of an individual SET element is M <= 255\nand (M x w) <= 1020, where M is the element literal length and w is the\nnumber of bytes required for the maximum-length character in the\ncharacter set.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-type-syntax.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/string-type-syntax.html'),(48,'BLOB DATA TYPE',2,'A BLOB is a binary large object that can hold a variable amount of\ndata. The four BLOB types are TINYBLOB, BLOB, MEDIUMBLOB, and LONGBLOB.\nThese differ only in the maximum length of the values they can hold.\nThe four TEXT types are TINYTEXT, TEXT, MEDIUMTEXT, and LONGTEXT. These\ncorrespond to the four BLOB types and have the same maximum lengths and\nstorage requirements. See\nhttps://dev.mysql.com/doc/refman/8.0/en/storage-requirements.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/blob.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/blob.html'),(49,'GEOMETRY HIERARCHY',7,'Geometry is the base class. It is an abstract class. The instantiable\nsubclasses of Geometry are restricted to zero-, one-, and\ntwo-dimensional geometric objects that exist in two-dimensional\ncoordinate space. All instantiable geometry classes are defined so that\nvalid instances of a geometry class are topologically closed (that is,\nall defined geometries include their boundary).\n\nThe base Geometry class has subclasses for Point, Curve, Surface, and\nGeometryCollection:\n\no Point represents zero-dimensional objects.\n\no Curve represents one-dimensional objects, and has subclass\n  LineString, with sub-subclasses Line and LinearRing.\n\no Surface is designed for two-dimensional objects and has subclass\n  Polygon.\n\no GeometryCollection has specialized zero-, one-, and two-dimensional\n  collection classes named MultiPoint, MultiLineString, and\n  MultiPolygon for modeling geometries corresponding to collections of\n  Points, LineStrings, and Polygons, respectively. MultiCurve and\n  MultiSurface are introduced as abstract superclasses that generalize\n  the collection interfaces to handle Curves and Surfaces.\n\nGeometry, Curve, Surface, MultiCurve, and MultiSurface are defined as\nnoninstantiable classes. They define a common set of methods for their\nsubclasses and are included for extensibility.\n\nPoint, LineString, Polygon, GeometryCollection, MultiPoint,\nMultiLineString, and MultiPolygon are instantiable classes.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-geometry-class-hierarchy.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/gis-geometry-class-hierarchy.html'),(50,'MBR DEFINITION',8,'Its MBR (minimum bounding rectangle), or envelope. This is the bounding\ngeometry, formed by the minimum and maximum (X,Y) coordinates:\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-class-geometry.html\n\n','((MINX MINY, MAXX MINY, MAXX MAXY, MINX MAXY, MINX MINY))\n','https://dev.mysql.com/doc/refman/8.0/en/gis-class-geometry.html'),(51,'WKT DEFINITION',9,'The Well-Known Text (WKT) representation of geometry values is designed\nfor exchanging geometry data in ASCII form. The OpenGIS specification\nprovides a Backus-Naur grammar that specifies the formal production\nrules for writing WKT values (see\nhttps://dev.mysql.com/doc/refman/8.0/en/spatial-types.html).\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-data-formats.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/gis-data-formats.html'),(52,'SPATIAL COLUMNS',7,'MySQL provides a standard way of creating spatial columns for geometry\ntypes, for example, with CREATE TABLE or ALTER TABLE. Spatial columns\nare supported for MyISAM, InnoDB, NDB, and ARCHIVE tables. See also the\nnotes about spatial indexes under [HELP SPATIAL indexes].\n\nColumns with a spatial data type can have an SRID attribute, to\nexplicitly indicate the spatial reference system (SRS) for values\nstored in the column. For implications of an SRID-restricted column,\nsee https://dev.mysql.com/doc/refman/8.0/en/spatial-type-overview.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/creating-spatial-columns.html\n\n','CREATE TABLE geom (g GEOMETRY);\n','https://dev.mysql.com/doc/refman/8.0/en/creating-spatial-columns.html'),(53,'SPATIAL INDEXES',7,'For InnoDB and MyISAM tables, MySQL can create spatial indexes using\nsyntax similar to that for creating regular indexes, but using the\nSPATIAL keyword. Columns in spatial indexes must be declared NOT NULL.\nThe following examples demonstrate how to create spatial indexes:\n\no With CREATE TABLE:\n\nCREATE TABLE geom (g GEOMETRY NOT NULL SRID 4326, SPATIAL INDEX(g));\n\no With ALTER TABLE:\n\nCREATE TABLE geom (g GEOMETRY NOT NULL SRID 4326);\nALTER TABLE geom ADD SPATIAL INDEX(g);\n\no With CREATE INDEX:\n\nCREATE TABLE geom (g GEOMETRY NOT NULL SRID 4326);\nCREATE SPATIAL INDEX g ON geom (g);\n\nSPATIAL INDEX creates an R-tree index. For storage engines that support\nnonspatial indexing of spatial columns, the engine creates a B-tree\nindex. A B-tree index on spatial values is useful for exact-value\nlookups, but not for range scans.\n\nThe optimizer can use spatial indexes defined on columns that are\nSRID-restricted. For more information, see\nhttps://dev.mysql.com/doc/refman/8.0/en/spatial-type-overview.html, and\nhttps://dev.mysql.com/doc/refman/8.0/en/spatial-index-optimization.html\n.\n\nFor more information on indexing spatial columns, see [HELP CREATE\nINDEX].\n\nTo drop spatial indexes, use ALTER TABLE or DROP INDEX:\n\no With ALTER TABLE:\n\nALTER TABLE geom DROP INDEX g;\n\no With DROP INDEX:\n\nDROP INDEX g ON geom;\n\nExample: Suppose that a table geom contains more than 32,000\ngeometries, which are stored in the column g of type GEOMETRY. The\ntable also has an AUTO_INCREMENT column fid for storing object ID\nvalues.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/creating-spatial-indexes.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/creating-spatial-indexes.html'),(54,'=',10,'=\n\nEqual:\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/comparison-operators.html\n\n','mysql> SELECT 1 = 0;\n        -> 0\nmysql> SELECT \'0\' = 0;\n        -> 1\nmysql> SELECT \'0.0\' = 0;\n        -> 1\nmysql> SELECT \'0.01\' = 0;\n        -> 0\nmysql> SELECT \'.01\' = 0.01;\n        -> 1\n','https://dev.mysql.com/doc/refman/8.0/en/comparison-operators.html'),(55,'<=>',10,'Syntax:\n<=>\n\nNULL-safe equal. This operator performs an equality comparison like the\n= operator, but returns 1 rather than NULL if both operands are NULL,\nand 0 rather than NULL if one operand is NULL.\n\nThe <=> operator is equivalent to the standard SQL IS NOT DISTINCT FROM\noperator.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/comparison-operators.html\n\n','mysql> SELECT 1 <=> 1, NULL <=> NULL, 1 <=> NULL;\n        -> 1, 1, 0\nmysql> SELECT 1 = 1, NULL = NULL, 1 = NULL;\n        -> 1, NULL, NULL\n','https://dev.mysql.com/doc/refman/8.0/en/comparison-operators.html'),(56,'!=',10,'Syntax:\n<>, !=\n\nNot equal:\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/comparison-operators.html\n\n','mysql> SELECT \'.01\' <> \'0.01\';\n        -> 1\nmysql> SELECT .01 <> \'0.01\';\n        -> 0\nmysql> SELECT \'zapp\' <> \'zappp\';\n        -> 1\n','https://dev.mysql.com/doc/refman/8.0/en/comparison-operators.html'),(57,'<=',10,'Syntax:\n<=\n\nLess than or equal:\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/comparison-operators.html\n\n','mysql> SELECT 0.1 <= 2;\n        -> 1\n','https://dev.mysql.com/doc/refman/8.0/en/comparison-operators.html'),(58,'<',10,'Syntax:\n<\n\nLess than:\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/comparison-operators.html\n\n','mysql> SELECT 2 < 2;\n        -> 0\n','https://dev.mysql.com/doc/refman/8.0/en/comparison-operators.html'),(59,'>=',10,'Syntax:\n>=\n\nGreater than or equal:\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/comparison-operators.html\n\n','mysql> SELECT 2 >= 2;\n        -> 1\n','https://dev.mysql.com/doc/refman/8.0/en/comparison-operators.html'),(60,'>',10,'Syntax:\n>\n\nGreater than:\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/comparison-operators.html\n\n','mysql> SELECT 2 > 2;\n        -> 0\n','https://dev.mysql.com/doc/refman/8.0/en/comparison-operators.html'),(61,'BETWEEN AND',10,'Syntax:\nexpr BETWEEN min AND max\n\nIf expr is greater than or equal to min and expr is less than or equal\nto max, BETWEEN returns 1, otherwise it returns 0. This is equivalent\nto the expression (min <= expr AND expr <= max) if all the arguments\nare of the same type. Otherwise type conversion takes place according\nto the rules described in\nhttps://dev.mysql.com/doc/refman/8.0/en/type-conversion.html, but\napplied to all the three arguments.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/comparison-operators.html\n\n','mysql> SELECT 2 BETWEEN 1 AND 3, 2 BETWEEN 3 and 1;\n        -> 1, 0\nmysql> SELECT 1 BETWEEN 2 AND 3;\n        -> 0\nmysql> SELECT \'b\' BETWEEN \'a\' AND \'c\';\n        -> 1\nmysql> SELECT 2 BETWEEN 2 AND \'3\';\n        -> 1\nmysql> SELECT 2 BETWEEN 2 AND \'x-3\';\n        -> 0\n','https://dev.mysql.com/doc/refman/8.0/en/comparison-operators.html'),(62,'NOT BETWEEN',10,'Syntax:\nexpr NOT BETWEEN min AND max\n\nThis is the same as NOT (expr BETWEEN min AND max).\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/comparison-operators.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/comparison-operators.html'),(63,'COALESCE',10,'Syntax:\nCOALESCE(value,...)\n\nReturns the first non-NULL value in the list, or NULL if there are no\nnon-NULL values.\n\nThe return type of COALESCE() is the aggregated type of the argument\ntypes.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/comparison-operators.html\n\n','mysql> SELECT COALESCE(NULL,1);\n        -> 1\nmysql> SELECT COALESCE(NULL,NULL,NULL);\n        -> NULL\n','https://dev.mysql.com/doc/refman/8.0/en/comparison-operators.html'),(64,'GREATEST',10,'Syntax:\nGREATEST(value1,value2,...)\n\nWith two or more arguments, returns the largest (maximum-valued)\nargument. The arguments are compared using the same rules as for\nLEAST().\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/comparison-operators.html\n\n','mysql> SELECT GREATEST(2,0);\n        -> 2\nmysql> SELECT GREATEST(34.0,3.0,5.0,767.0);\n        -> 767.0\nmysql> SELECT GREATEST(\'B\',\'A\',\'C\');\n        -> \'C\'\n','https://dev.mysql.com/doc/refman/8.0/en/comparison-operators.html'),(65,'IN',10,'Syntax:\nexpr IN (value,...)\n\nReturns 1 (true) if expr is equal to any of the values in the IN()\nlist, else returns 0 (false).\n\nType conversion takes place according to the rules described in\nhttps://dev.mysql.com/doc/refman/8.0/en/type-conversion.html, applied\nto all the arguments. If no type conversion is needed for the values in\nthe IN() list, they are all non-JSON constants of the same type, and\nexpr can be compared to each of them as a value of the same type\n(possibly after type conversion), an optimization takes place. The\nvalues the list are sorted and the search for expr is done using a\nbinary search, which makes the IN() operation very quick.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/comparison-operators.html\n\n','mysql> SELECT 2 IN (0,3,5,7);\n        -> 0\nmysql> SELECT \'wefwf\' IN (\'wee\',\'wefwf\',\'weg\');\n        -> 1\n','https://dev.mysql.com/doc/refman/8.0/en/comparison-operators.html'),(66,'NOT IN',10,'Syntax:\nexpr NOT IN (value,...)\n\nThis is the same as NOT (expr IN (value,...)).\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/comparison-operators.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/comparison-operators.html'),(67,'INTERVAL',10,'Syntax:\nINTERVAL(N,N1,N2,N3,...)\n\nReturns 0 if N < N1, 1 if N < N2 and so on or -1 if N is NULL. All\narguments are treated as integers. It is required that N1 < N2 < N3 <\n... < Nn for this function to work correctly. This is because a binary\nsearch is used (very fast).\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/comparison-operators.html\n\n','mysql> SELECT INTERVAL(23, 1, 15, 17, 30, 44, 200);\n        -> 3\nmysql> SELECT INTERVAL(10, 1, 10, 100, 1000);\n        -> 2\nmysql> SELECT INTERVAL(22, 23, 30, 44, 200);\n        -> 0\n','https://dev.mysql.com/doc/refman/8.0/en/comparison-operators.html'),(68,'IS',10,'Syntax:\nIS boolean_value\n\nTests a value against a boolean value, where boolean_value can be TRUE,\nFALSE, or UNKNOWN.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/comparison-operators.html\n\n','mysql> SELECT 1 IS TRUE, 0 IS FALSE, NULL IS UNKNOWN;\n        -> 1, 1, 1\n','https://dev.mysql.com/doc/refman/8.0/en/comparison-operators.html'),(69,'IS NOT',10,'Syntax:\nIS NOT boolean_value\n\nTests a value against a boolean value, where boolean_value can be TRUE,\nFALSE, or UNKNOWN.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/comparison-operators.html\n\n','mysql> SELECT 1 IS NOT UNKNOWN, 0 IS NOT UNKNOWN, NULL IS NOT UNKNOWN;\n        -> 1, 1, 0\n','https://dev.mysql.com/doc/refman/8.0/en/comparison-operators.html'),(70,'IS NULL',10,'Syntax:\nIS NULL\n\nTests whether a value is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/comparison-operators.html\n\n','mysql> SELECT 1 IS NULL, 0 IS NULL, NULL IS NULL;\n        -> 0, 0, 1\n','https://dev.mysql.com/doc/refman/8.0/en/comparison-operators.html'),(71,'IS NOT NULL',10,'Syntax:\nIS NOT NULL\n\nTests whether a value is not NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/comparison-operators.html\n\n','mysql> SELECT 1 IS NOT NULL, 0 IS NOT NULL, NULL IS NOT NULL;\n        -> 1, 1, 0\n','https://dev.mysql.com/doc/refman/8.0/en/comparison-operators.html'),(72,'ISNULL',10,'Syntax:\nISNULL(expr)\n\nIf expr is NULL, ISNULL() returns 1, otherwise it returns 0.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/comparison-operators.html\n\n','mysql> SELECT ISNULL(1+1);\n        -> 0\nmysql> SELECT ISNULL(1/0);\n        -> 1\n','https://dev.mysql.com/doc/refman/8.0/en/comparison-operators.html'),(73,'LEAST',10,'Syntax:\nLEAST(value1,value2,...)\n\nWith two or more arguments, returns the smallest (minimum-valued)\nargument. The arguments are compared using the following rules:\n\no If any argument is NULL, the result is NULL. No comparison is needed.\n\no If all arguments are integer-valued, they are compared as integers.\n\no If at least one argument is double precision, they are compared as\n  double-precision values. Otherwise, if at least one argument is a\n  DECIMAL value, they are compared as DECIMAL values.\n\no If the arguments comprise a mix of numbers and strings, they are\n  compared as strings.\n\no If any argument is a nonbinary (character) string, the arguments are\n  compared as nonbinary strings.\n\no In all other cases, the arguments are compared as binary strings.\n\nThe return type of LEAST() is the aggregated type of the comparison\nargument types.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/comparison-operators.html\n\n','mysql> SELECT LEAST(2,0);\n        -> 0\nmysql> SELECT LEAST(34.0,3.0,5.0,767.0);\n        -> 3.0\nmysql> SELECT LEAST(\'B\',\'A\',\'C\');\n        -> \'A\'\n','https://dev.mysql.com/doc/refman/8.0/en/comparison-operators.html'),(74,'!',11,'Syntax:\nNOT, !\n\nLogical NOT. Evaluates to 1 if the operand is 0, to 0 if the operand is\nnonzero, and NOT NULL returns NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/logical-operators.html\n\n','mysql> SELECT NOT 10;\n        -> 0\nmysql> SELECT NOT 0;\n        -> 1\nmysql> SELECT NOT NULL;\n        -> NULL\nmysql> SELECT ! (1+1);\n        -> 0\nmysql> SELECT ! 1+1;\n        -> 1\n','https://dev.mysql.com/doc/refman/8.0/en/logical-operators.html'),(75,'AND',11,'Syntax:\nAND, &&\n\nLogical AND. Evaluates to 1 if all operands are nonzero and not NULL,\nto 0 if one or more operands are 0, otherwise NULL is returned.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/logical-operators.html\n\n','mysql> SELECT 1 AND 1;\n        -> 1\nmysql> SELECT 1 AND 0;\n        -> 0\nmysql> SELECT 1 AND NULL;\n        -> NULL\nmysql> SELECT 0 AND NULL;\n        -> 0\nmysql> SELECT NULL AND 0;\n        -> 0\n','https://dev.mysql.com/doc/refman/8.0/en/logical-operators.html'),(76,'OR',11,'Syntax:\nOR, ||\n\nLogical OR. When both operands are non-NULL, the result is 1 if any\noperand is nonzero, and 0 otherwise. With a NULL operand, the result is\n1 if the other operand is nonzero, and NULL otherwise. If both operands\nare NULL, the result is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/logical-operators.html\n\n','mysql> SELECT 1 OR 1;\n        -> 1\nmysql> SELECT 1 OR 0;\n        -> 1\nmysql> SELECT 0 OR 0;\n        -> 0\nmysql> SELECT 0 OR NULL;\n        -> NULL\nmysql> SELECT 1 OR NULL;\n        -> 1\n','https://dev.mysql.com/doc/refman/8.0/en/logical-operators.html'),(77,'XOR',11,'Syntax:\nXOR\n\nLogical XOR. Returns NULL if either operand is NULL. For non-NULL\noperands, evaluates to 1 if an odd number of operands is nonzero,\notherwise 0 is returned.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/logical-operators.html\n\n','mysql> SELECT 1 XOR 1;\n        -> 0\nmysql> SELECT 1 XOR 0;\n        -> 1\nmysql> SELECT 1 XOR NULL;\n        -> NULL\nmysql> SELECT 1 XOR 1 XOR 1;\n        -> 1\n','https://dev.mysql.com/doc/refman/8.0/en/logical-operators.html'),(78,'ASSIGN-VALUE',11,'Syntax:\n:=\n\nAssignment operator. Causes the user variable on the left hand side of\nthe operator to take on the value to its right. The value on the right\nhand side may be a literal value, another variable storing a value, or\nany legal expression that yields a scalar value, including the result\nof a query (provided that this value is a scalar value). You can\nperform multiple assignments in the same SET statement. You can perform\nmultiple assignments in the same statement.\n\nUnlike =, the := operator is never interpreted as a comparison\noperator. This means you can use := in any valid SQL statement (not\njust in SET statements) to assign a value to a variable.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/assignment-operators.html\n\n','mysql> SELECT @var1, @var2;\n        -> NULL, NULL\nmysql> SELECT @var1 := 1, @var2;\n        -> 1, NULL\nmysql> SELECT @var1, @var2;\n        -> 1, NULL\nmysql> SELECT @var1, @var2 := @var1;\n        -> 1, 1\nmysql> SELECT @var1, @var2;\n        -> 1, 1\n\nmysql> SELECT @var1:=COUNT(*) FROM t1;\n        -> 4\nmysql> SELECT @var1;\n        -> 4\n','https://dev.mysql.com/doc/refman/8.0/en/assignment-operators.html'),(79,'ASSIGN-EQUAL',11,'Syntax:\n=\n\nThis operator is used to perform value assignments in two cases,\ndescribed in the next two paragraphs.\n\nWithin a SET statement, = is treated as an assignment operator that\ncauses the user variable on the left hand side of the operator to take\non the value to its right. (In other words, when used in a SET\nstatement, = is treated identically to :=.) The value on the right hand\nside may be a literal value, another variable storing a value, or any\nlegal expression that yields a scalar value, including the result of a\nquery (provided that this value is a scalar value). You can perform\nmultiple assignments in the same SET statement.\n\nIn the SET clause of an UPDATE statement, = also acts as an assignment\noperator; in this case, however, it causes the column named on the left\nhand side of the operator to assume the value given to the right,\nprovided any WHERE conditions that are part of the UPDATE are met. You\ncan make multiple assignments in the same SET clause of an UPDATE\nstatement.\n\nIn any other context, = is treated as a comparison operator.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/assignment-operators.html\n\n','mysql> SELECT @var1, @var2;\n        -> NULL, NULL\nmysql> SELECT @var1 := 1, @var2;\n        -> 1, NULL\nmysql> SELECT @var1, @var2;\n        -> 1, NULL\nmysql> SELECT @var1, @var2 := @var1;\n        -> 1, 1\nmysql> SELECT @var1, @var2;\n        -> 1, 1\n','https://dev.mysql.com/doc/refman/8.0/en/assignment-operators.html'),(80,'CASE OPERATOR',12,'Syntax:\nCASE value WHEN compare_value THEN result [WHEN compare_value THEN\nresult ...] [ELSE result] END\n\nCASE WHEN condition THEN result [WHEN condition THEN result ...] [ELSE\nresult] END\n\nThe first CASE syntax returns the result for the first\nvalue=compare_value comparison that is true. The second syntax returns\nthe result for the first condition that is true. If no comparison or\ncondition is true, the result after ELSE is returned, or NULL if there\nis no ELSE part.\n\n*Note*:\n\nThe syntax of the CASE operator described here differs slightly from\nthat of the SQL CASE statement described in [HELP CASE statement], for\nuse inside stored programs. The CASE statement cannot have an ELSE NULL\nclause, and it is terminated with END CASE instead of END.\n\nThe return type of a CASE expression result is the aggregated type of\nall result values:\n\no If all types are numeric, the aggregated type is also numeric:\n\n  o If at least one argument is double precision, the result is double\n    precision.\n\n  o Otherwise, if at least one argument is DECIMAL, the result is\n    DECIMAL.\n\n  o Otherwise, the result is an integer type (with one exception):\n\n    o If all integer types are all signed or all unsigned, the result\n      is the same sign and the precision is the highest of all\n      specified integer types (that is, TINYINT, SMALLINT, MEDIUMINT,\n      INT, or BIGINT).\n\n    o If there is a combination of signed and unsigned integer types,\n      the result is signed and the precision may be higher. For\n      example, if the types are signed INT and unsigned INT, the result\n      is signed BIGINT.\n\n    o The exception is unsigned BIGINT combined with any signed integer\n      type. The result is DECIMAL with sufficient precision and scale\n      0.\n\no If all types are BIT, the result is BIT. Otherwise, BIT arguments are\n  treated similar to BIGINT.\n\no If all types are YEAR, the result is YEAR. Otherwise, YEAR arguments\n  are treated similar to INT.\n\no If all types are character string (CHAR or VARCHAR), the result is\n  VARCHAR with maximum length determined by the longest character\n  length of the operands.\n\no If all types are character or binary string, the result is VARBINARY.\n\no SET and ENUM are treated similar to VARCHAR; the result is VARCHAR.\n\no If all types are JSON, the result is JSON.\n\no If all types are temporal, the result is temporal:\n\n  o If all temporal types are DATE, TIME, or TIMESTAMP, the result is\n    DATE, TIME, or TIMESTAMP, respectively.\n\n  o Otherwise, for a mix of temporal types, the result is DATETIME.\n\no If all types are GEOMETRY, the result is GEOMETRY.\n\no If any type is BLOB, the result is BLOB.\n\no For all other type combinations, the result is VARCHAR.\n\no Literal NULL operands are ignored for type aggregation.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/flow-control-functions.html\n\n','mysql> SELECT CASE 1 WHEN 1 THEN \'one\'\n    ->     WHEN 2 THEN \'two\' ELSE \'more\' END;\n        -> \'one\'\nmysql> SELECT CASE WHEN 1>0 THEN \'true\' ELSE \'false\' END;\n        -> \'true\'\nmysql> SELECT CASE BINARY \'B\'\n    ->     WHEN \'a\' THEN 1 WHEN \'b\' THEN 2 END;\n        -> NULL\n','https://dev.mysql.com/doc/refman/8.0/en/flow-control-functions.html'),(81,'IF FUNCTION',12,'Syntax:\nIF(expr1,expr2,expr3)\n\nIf expr1 is TRUE (expr1 <> 0 and expr1 IS NOT NULL), IF() returns\nexpr2. Otherwise, it returns expr3.\n\n*Note*:\n\nThere is also an IF statement, which differs from the IF() function\ndescribed here. See [HELP IF statement].\n\nIf only one of expr2 or expr3 is explicitly NULL, the result type of\nthe IF() function is the type of the non-NULL expression.\n\nThe default return type of IF() (which may matter when it is stored\ninto a temporary table) is calculated as follows:\n\no If expr2 or expr3 produce a string, the result is a string.\n\n  If expr2 and expr3 are both strings, the result is case-sensitive if\n  either string is case-sensitive.\n\no If expr2 or expr3 produce a floating-point value, the result is a\n  floating-point value.\n\no If expr2 or expr3 produce an integer, the result is an integer.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/flow-control-functions.html\n\n','mysql> SELECT IF(1>2,2,3);\n        -> 3\nmysql> SELECT IF(1<2,\'yes\',\'no\');\n        -> \'yes\'\nmysql> SELECT IF(STRCMP(\'test\',\'test1\'),\'no\',\'yes\');\n        -> \'no\'\n','https://dev.mysql.com/doc/refman/8.0/en/flow-control-functions.html'),(82,'IFNULL',12,'Syntax:\nIFNULL(expr1,expr2)\n\nIf expr1 is not NULL, IFNULL() returns expr1; otherwise it returns\nexpr2.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/flow-control-functions.html\n\n','mysql> SELECT IFNULL(1,0);\n        -> 1\nmysql> SELECT IFNULL(NULL,10);\n        -> 10\nmysql> SELECT IFNULL(1/0,10);\n        -> 10\nmysql> SELECT IFNULL(1/0,\'yes\');\n        -> \'yes\'\n','https://dev.mysql.com/doc/refman/8.0/en/flow-control-functions.html'),(83,'NULLIF',12,'Syntax:\nNULLIF(expr1,expr2)\n\nReturns NULL if expr1 = expr2 is true, otherwise returns expr1. This is\nthe same as CASE WHEN expr1 = expr2 THEN NULL ELSE expr1 END.\n\nThe return value has the same type as the first argument.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/flow-control-functions.html\n\n','mysql> SELECT NULLIF(1,1);\n        -> NULL\nmysql> SELECT NULLIF(1,2);\n        -> 1\n','https://dev.mysql.com/doc/refman/8.0/en/flow-control-functions.html'),(84,'+',13,'Syntax:\n+\n\nAddition:\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/arithmetic-functions.html\n\n','mysql> SELECT 3+5;\n        -> 8\n','https://dev.mysql.com/doc/refman/8.0/en/arithmetic-functions.html'),(85,'- BINARY',13,'Syntax:\n-\n\nSubtraction:\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/arithmetic-functions.html\n\n','mysql> SELECT 3-5;\n        -> -2\n','https://dev.mysql.com/doc/refman/8.0/en/arithmetic-functions.html'),(86,'- UNARY',13,'Syntax:\n-\n\nUnary minus. This operator changes the sign of the operand.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/arithmetic-functions.html\n\n','mysql> SELECT - 2;\n        -> -2\n','https://dev.mysql.com/doc/refman/8.0/en/arithmetic-functions.html'),(87,'*',13,'Syntax:\n*\n\nMultiplication:\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/arithmetic-functions.html\n\n','mysql> SELECT 3*5;\n        -> 15\nmysql> SELECT 18014398509481984*18014398509481984.0;\n        -> 324518553658426726783156020576256.0\nmysql> SELECT 18014398509481984*18014398509481984;\n        -> out-of-range error\n','https://dev.mysql.com/doc/refman/8.0/en/arithmetic-functions.html'),(88,'/',13,'Syntax:\n/\n\nDivision:\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/arithmetic-functions.html\n\n','mysql> SELECT 3/5;\n        -> 0.60\n','https://dev.mysql.com/doc/refman/8.0/en/arithmetic-functions.html'),(89,'DIV',13,'Syntax:\nDIV\n\nInteger division. Discards from the division result any fractional part\nto the right of the decimal point.\n\nIf either operand has a noninteger type, the operands are converted to\nDECIMAL and divided using DECIMAL arithmetic before converting the\nresult to BIGINT. If the result exceeds BIGINT range, an error occurs.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/arithmetic-functions.html\n\n','mysql> SELECT 5 DIV 2, -5 DIV 2, 5 DIV -2, -5 DIV -2;\n        -> 2, -2, -2, 2\n','https://dev.mysql.com/doc/refman/8.0/en/arithmetic-functions.html'),(90,'%',13,'Syntax:\nN % M, N MOD M\n\nModulo operation. Returns the remainder of N divided by M. For more\ninformation, see the description for the MOD() function in\nhttps://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/arithmetic-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/arithmetic-functions.html'),(91,'ABS',13,'Syntax:\nABS(X)\n\nReturns the absolute value of X, or NULL if X is NULL.\n\nThe result type is derived from the argument type. An implication of\nthis is that ABS(-9223372036854775808) produces an error because the\nresult cannot be stored in a signed BIGINT value.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html\n\n','mysql> SELECT ABS(2);\n        -> 2\nmysql> SELECT ABS(-32);\n        -> 32\n','https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html'),(92,'ACOS',13,'Syntax:\nACOS(X)\n\nReturns the arc cosine of X, that is, the value whose cosine is X.\nReturns NULL if X is not in the range -1 to 1, or if X is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html\n\n','mysql> SELECT ACOS(1);\n        -> 0\nmysql> SELECT ACOS(1.0001);\n        -> NULL\nmysql> SELECT ACOS(0);\n        -> 1.5707963267949\n','https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html'),(93,'ASIN',13,'Syntax:\nASIN(X)\n\nReturns the arc sine of X, that is, the value whose sine is X. Returns\nNULL if X is not in the range -1 to 1, or if X is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html\n\n','mysql> SELECT ASIN(0.2);\n        -> 0.20135792079033\nmysql> SELECT ASIN(\'foo\');\n\n+-------------+\n| ASIN(\'foo\') |\n+-------------+\n|           0 |\n+-------------+\n1 row in set, 1 warning (0.00 sec)\n\nmysql> SHOW WARNINGS;\n+---------+------+-----------------------------------------+\n| Level   | Code | Message                                 |\n+---------+------+-----------------------------------------+\n| Warning | 1292 | Truncated incorrect DOUBLE value: \'foo\' |\n+---------+------+-----------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html'),(94,'ATAN',13,'Syntax:\nATAN(X)\n\nReturns the arc tangent of X, that is, the value whose tangent is X.\nReturns NULL if X is NULL\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html\n\n','mysql> SELECT ATAN(2);\n        -> 1.1071487177941\nmysql> SELECT ATAN(-2);\n        -> -1.1071487177941\n','https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html'),(95,'ATAN2',13,'Syntax:\nATAN(Y,X), ATAN2(Y,X)\n\nReturns the arc tangent of the two variables X and Y. It is similar to\ncalculating the arc tangent of Y / X, except that the signs of both\narguments are used to determine the quadrant of the result. Returns\nNULL if X or Y is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html\n\n','mysql> SELECT ATAN(-2,2);\n        -> -0.78539816339745\nmysql> SELECT ATAN2(PI(),0);\n        -> 1.5707963267949\n','https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html'),(96,'CEIL',13,'Syntax:\nCEIL(X)\n\nCEIL() is a synonym for CEILING().\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html'),(97,'CEILING',13,'Syntax:\nCEILING(X)\n\nReturns the smallest integer value not less than X. Returns NULL if X\nis NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html\n\n','mysql> SELECT CEILING(1.23);\n        -> 2\nmysql> SELECT CEILING(-1.23);\n        -> -1\n','https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html'),(98,'CONV',13,'Syntax:\nCONV(N,from_base,to_base)\n\nConverts numbers between different number bases. Returns a string\nrepresentation of the number N, converted from base from_base to base\nto_base. Returns NULL if any argument is NULL. The argument N is\ninterpreted as an integer, but may be specified as an integer or a\nstring. The minimum base is 2 and the maximum base is 36. If from_base\nis a negative number, N is regarded as a signed number. Otherwise, N is\ntreated as unsigned. CONV() works with 64-bit precision.\n\nCONV() returns NULL if any of its arguments are NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html\n\n','mysql> SELECT CONV(\'a\',16,2);\n        -> \'1010\'\nmysql> SELECT CONV(\'6E\',18,8);\n        -> \'172\'\nmysql> SELECT CONV(-17,10,-18);\n        -> \'-H\'\nmysql> SELECT CONV(10+\'10\'+\'10\'+X\'0a\',10,10);\n        -> \'40\'\n','https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html'),(99,'COS',13,'Syntax:\nCOS(X)\n\nReturns the cosine of X, where X is given in radians. Returns NULL if X\nis NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html\n\n','mysql> SELECT COS(PI());\n        -> -1\n','https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html'),(100,'COT',13,'Syntax:\nCOT(X)\n\nReturns the cotangent of X. Returns NULL if X is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html\n\n','mysql> SELECT COT(12);\n        -> -1.5726734063977\nmysql> SELECT COT(0);\n        -> out-of-range error\n','https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html'),(101,'CRC32',13,'Syntax:\nCRC32(expr)\n\nComputes a cyclic redundancy check value and returns a 32-bit unsigned\nvalue. The result is NULL if the argument is NULL. The argument is\nexpected to be a string and (if possible) is treated as one if it is\nnot.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html\n\n','mysql> SELECT CRC32(\'MySQL\');\n        -> 3259397556\nmysql> SELECT CRC32(\'mysql\');\n        -> 2501908538\n','https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html'),(102,'DEGREES',13,'Syntax:\nDEGREES(X)\n\nReturns the argument X, converted from radians to degrees. Returns NULL\nif X is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html\n\n','mysql> SELECT DEGREES(PI());\n        -> 180\nmysql> SELECT DEGREES(PI() / 2);\n        -> 90\n','https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html'),(103,'EXP',13,'Syntax:\nEXP(X)\n\nReturns the value of e (the base of natural logarithms) raised to the\npower of X. The inverse of this function is LOG() (using a single\nargument only) or LN().\n\nIf X is NULL, this function returns NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html\n\n','mysql> SELECT EXP(2);\n        -> 7.3890560989307\nmysql> SELECT EXP(-2);\n        -> 0.13533528323661\nmysql> SELECT EXP(0);\n        -> 1\n','https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html'),(104,'FLOOR',13,'Syntax:\nFLOOR(X)\n\nReturns the largest integer value not greater than X. Returns NULL if X\nis NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html\n\n','mysql> SELECT FLOOR(1.23), FLOOR(-1.23);\n        -> 1, -2\n','https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html'),(105,'LN',13,'Syntax:\nLN(X)\n\nReturns the natural logarithm of X; that is, the base-e logarithm of X.\nIf X is less than or equal to 0.0E0, the function returns NULL and a\nwarning \"Invalid argument for logarithm\" is reported. Returns NULL if X\nis NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html\n\n','mysql> SELECT LN(2);\n        -> 0.69314718055995\nmysql> SELECT LN(-2);\n        -> NULL\n','https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html'),(106,'LOG',13,'Syntax:\nLOG(X), LOG(B,X)\n\nIf called with one parameter, this function returns the natural\nlogarithm of X. If X is less than or equal to 0.0E0, the function\nreturns NULL and a warning \"Invalid argument for logarithm\" is\nreported. Returns NULL if X or B is NULL.\n\nThe inverse of this function (when called with a single argument) is\nthe EXP() function.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html\n\n','mysql> SELECT LOG(2);\n        -> 0.69314718055995\nmysql> SELECT LOG(-2);\n        -> NULL\n','https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html'),(107,'LOG2',13,'Syntax:\nLOG2(X)\n\nReturns the base-2 logarithm of X. If X is less than or equal to 0.0E0,\nthe function returns NULL and a warning \"Invalid argument for\nlogarithm\" is reported. Returns NULL if X is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html\n\n','mysql> SELECT LOG2(65536);\n        -> 16\nmysql> SELECT LOG2(-100);\n        -> NULL\n','https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html'),(108,'LOG10',13,'Syntax:\nLOG10(X)\n\nReturns the base-10 logarithm of X. If X is less than or equal to\n0.0E0, the function returns NULL and a warning \"Invalid argument for\nlogarithm\" is reported. Returns NULL if X is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html\n\n','mysql> SELECT LOG10(2);\n        -> 0.30102999566398\nmysql> SELECT LOG10(100);\n        -> 2\nmysql> SELECT LOG10(-100);\n        -> NULL\n','https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html'),(109,'MOD',13,'Syntax:\nMOD(N,M), N % M, N MOD M\n\nModulo operation. Returns the remainder of N divided by M. Returns NULL\nif M or N is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html\n\n','mysql> SELECT MOD(234, 10);\n        -> 4\nmysql> SELECT 253 % 7;\n        -> 1\nmysql> SELECT MOD(29,9);\n        -> 2\nmysql> SELECT 29 MOD 9;\n        -> 2\n','https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html'),(110,'PI',13,'Syntax:\nPI()\n\nReturns the value of π (pi). The default number of decimal places\ndisplayed is seven, but MySQL uses the full double-precision value\ninternally.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html\n\n','mysql> SELECT PI();\n        -> 3.141593\nmysql> SELECT PI()+0.000000000000000000;\n        -> 3.141592653589793116\n','https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html'),(111,'POW',13,'Syntax:\nPOW(X,Y)\n\nReturns the value of X raised to the power of Y. Returns NULL if X or Y\nis NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html\n\n','mysql> SELECT POW(2,2);\n        -> 4\nmysql> SELECT POW(2,-2);\n        -> 0.25\n','https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html'),(112,'POWER',13,'Syntax:\nPOWER(X,Y)\n\nThis is a synonym for POW().\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html'),(113,'RADIANS',13,'Syntax:\nRADIANS(X)\n\nReturns the argument X, converted from degrees to radians. (Note that\nπ radians equals 180 degrees.) Returns NULL if X is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html\n\n','mysql> SELECT RADIANS(90);\n        -> 1.5707963267949\n','https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html'),(114,'RAND',13,'Syntax:\nRAND([N])\n\nReturns a random floating-point value v in the range 0 <= v < 1.0. To\nobtain a random integer R in the range i <= R < j, use the expression\nFLOOR(i + RAND() * (j − i)). For example, to obtain a random integer\nin the range the range 7 <= R < 12, use the following statement:\n\nSELECT FLOOR(7 + (RAND() * 5));\n\nIf an integer argument N is specified, it is used as the seed value:\n\no With a constant initializer argument, the seed is initialized once\n  when the statement is prepared, prior to execution.\n\no With a nonconstant initializer argument (such as a column name), the\n  seed is initialized with the value for each invocation of RAND().\n\nOne implication of this behavior is that for equal argument values,\nRAND(N) returns the same value each time, and thus produces a\nrepeatable sequence of column values. In the following example, the\nsequence of values produced by RAND(3) is the same both places it\noccurs.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html\n\n','mysql> CREATE TABLE t (i INT);\nQuery OK, 0 rows affected (0.42 sec)\n\nmysql> INSERT INTO t VALUES(1),(2),(3);\nQuery OK, 3 rows affected (0.00 sec)\nRecords: 3  Duplicates: 0  Warnings: 0\n\nmysql> SELECT i, RAND() FROM t;\n+------+------------------+\n| i    | RAND()           |\n+------+------------------+\n|    1 | 0.61914388706828 |\n|    2 | 0.93845168309142 |\n|    3 | 0.83482678498591 |\n+------+------------------+\n3 rows in set (0.00 sec)\n\nmysql> SELECT i, RAND(3) FROM t;\n+------+------------------+\n| i    | RAND(3)          |\n+------+------------------+\n|    1 | 0.90576975597606 |\n|    2 | 0.37307905813035 |\n|    3 | 0.14808605345719 |\n+------+------------------+\n3 rows in set (0.00 sec)\n\nmysql> SELECT i, RAND() FROM t;\n+------+------------------+\n| i    | RAND()           |\n+------+------------------+\n|    1 | 0.35877890638893 |\n|    2 | 0.28941420772058 |\n|    3 | 0.37073435016976 |\n+------+------------------+\n3 rows in set (0.00 sec)\n\nmysql> SELECT i, RAND(3) FROM t;\n+------+------------------+\n| i    | RAND(3)          |\n+------+------------------+\n|    1 | 0.90576975597606 |\n|    2 | 0.37307905813035 |\n|    3 | 0.14808605345719 |\n+------+------------------+\n3 rows in set (0.01 sec)\n','https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html'),(115,'ROUND',13,'Syntax:\nROUND(X), ROUND(X,D)\n\nRounds the argument X to D decimal places. The rounding algorithm\ndepends on the data type of X. D defaults to 0 if not specified. D can\nbe negative to cause D digits left of the decimal point of the value X\nto become zero. The maximum absolute value for D is 30; any digits in\nexcess of 30 (or -30) are truncated. If X or D is NULL, the function\nreturns NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html\n\n','mysql> SELECT ROUND(-1.23);\n        -> -1\nmysql> SELECT ROUND(-1.58);\n        -> -2\nmysql> SELECT ROUND(1.58);\n        -> 2\nmysql> SELECT ROUND(1.298, 1);\n        -> 1.3\nmysql> SELECT ROUND(1.298, 0);\n        -> 1\nmysql> SELECT ROUND(23.298, -1);\n        -> 20\nmysql> SELECT ROUND(.12345678901234567890123456789012345, 35);\n        -> 0.123456789012345678901234567890\n','https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html'),(116,'SIGN',13,'Syntax:\nSIGN(X)\n\nReturns the sign of the argument as -1, 0, or 1, depending on whether X\nis negative, zero, or positive. Returns NULL if X is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html\n\n','mysql> SELECT SIGN(-32);\n        -> -1\nmysql> SELECT SIGN(0);\n        -> 0\nmysql> SELECT SIGN(234);\n        -> 1\n','https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html'),(117,'SIN',13,'Syntax:\nSIN(X)\n\nReturns the sine of X, where X is given in radians. Returns NULL if X\nis NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html\n\n','mysql> SELECT SIN(PI());\n        -> 1.2246063538224e-16\nmysql> SELECT ROUND(SIN(PI()));\n        -> 0\n','https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html'),(118,'SQRT',13,'Syntax:\nSQRT(X)\n\nReturns the square root of a nonnegative number X. If X is NULL, the\nfunction returns NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html\n\n','mysql> SELECT SQRT(4);\n        -> 2\nmysql> SELECT SQRT(20);\n        -> 4.4721359549996\nmysql> SELECT SQRT(-16);\n        -> NULL\n','https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html'),(119,'TAN',13,'Syntax:\nTAN(X)\n\nReturns the tangent of X, where X is given in radians. Returns NULL if\nX is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html\n\n','mysql> SELECT TAN(PI());\n        -> -1.2246063538224e-16\nmysql> SELECT TAN(PI()+1);\n        -> 1.5574077246549\n','https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html'),(120,'TRUNCATE',13,'Syntax:\nTRUNCATE(X,D)\n\nReturns the number X, truncated to D decimal places. If D is 0, the\nresult has no decimal point or fractional part. D can be negative to\ncause D digits left of the decimal point of the value X to become zero.\nIf X or D is NULL, the function returns NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html\n\n','mysql> SELECT TRUNCATE(1.223,1);\n        -> 1.2\nmysql> SELECT TRUNCATE(1.999,1);\n        -> 1.9\nmysql> SELECT TRUNCATE(1.999,0);\n        -> 1\nmysql> SELECT TRUNCATE(-1.999,1);\n        -> -1.9\nmysql> SELECT TRUNCATE(122,-2);\n       -> 100\nmysql> SELECT TRUNCATE(10.28*100,0);\n       -> 1028\n','https://dev.mysql.com/doc/refman/8.0/en/mathematical-functions.html'),(121,'ADDDATE',14,'Syntax:\nADDDATE(date,INTERVAL expr unit), ADDDATE(date,days)\n\nWhen invoked with the INTERVAL form of the second argument, ADDDATE()\nis a synonym for DATE_ADD(). The related function SUBDATE() is a\nsynonym for DATE_SUB(). For information on the INTERVAL unit argument,\nsee\nhttps://dev.mysql.com/doc/refman/8.0/en/expressions.html#temporal-inter\nvals.\n\nmysql> SELECT DATE_ADD(\'2008-01-02\', INTERVAL 31 DAY);\n        -> \'2008-02-02\'\nmysql> SELECT ADDDATE(\'2008-01-02\', INTERVAL 31 DAY);\n        -> \'2008-02-02\'\n\nWhen invoked with the days form of the second argument, MySQL treats it\nas an integer number of days to be added to expr.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT ADDDATE(\'2008-01-02\', 31);\n        -> \'2008-02-02\'\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(122,'ADDTIME',14,'Syntax:\nADDTIME(expr1,expr2)\n\nADDTIME() adds expr2 to expr1 and returns the result. expr1 is a time\nor datetime expression, and expr2 is a time expression. Returns NULL if\nexpr1or expr2 is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT ADDTIME(\'2007-12-31 23:59:59.999999\', \'1 1:1:1.000002\');\n        -> \'2008-01-02 01:01:01.000001\'\nmysql> SELECT ADDTIME(\'01:00:00.999999\', \'02:00:00.999998\');\n        -> \'03:00:01.999997\'\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(123,'CONVERT_TZ',14,'Syntax:\nCONVERT_TZ(dt,from_tz,to_tz)\n\nCONVERT_TZ() converts a datetime value dt from the time zone given by\nfrom_tz to the time zone given by to_tz and returns the resulting\nvalue. Time zones are specified as described in\nhttps://dev.mysql.com/doc/refman/8.0/en/time-zone-support.html. This\nfunction returns NULL if any of the arguments are invalid, or if any of\nthem are NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT CONVERT_TZ(\'2004-01-01 12:00:00\',\'GMT\',\'MET\');\n        -> \'2004-01-01 13:00:00\'\nmysql> SELECT CONVERT_TZ(\'2004-01-01 12:00:00\',\'+00:00\',\'+10:00\');\n        -> \'2004-01-01 22:00:00\'\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(124,'CURDATE',14,'Syntax:\nCURDATE()\n\nReturns the current date as a value in \'YYYY-MM-DD\' or YYYYMMDD format,\ndepending on whether the function is used in string or numeric context.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT CURDATE();\n        -> \'2008-06-13\'\nmysql> SELECT CURDATE() + 0;\n        -> 20080613\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(125,'CURRENT_DATE',14,'Syntax:\nCURRENT_DATE, CURRENT_DATE()\n\nCURRENT_DATE and CURRENT_DATE() are synonyms for CURDATE().\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(126,'CURRENT_TIME',14,'Syntax:\nCURRENT_TIME, CURRENT_TIME([fsp])\n\nCURRENT_TIME and CURRENT_TIME() are synonyms for CURTIME().\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(127,'CURRENT_TIMESTAMP',14,'Syntax:\nCURRENT_TIMESTAMP, CURRENT_TIMESTAMP([fsp])\n\nCURRENT_TIMESTAMP and CURRENT_TIMESTAMP() are synonyms for NOW().\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(128,'CURTIME',14,'Syntax:\nCURTIME([fsp])\n\nReturns the current time as a value in \'hh:mm:ss\' or hhmmss format,\ndepending on whether the function is used in string or numeric context.\nThe value is expressed in the session time zone.\n\nIf the fsp argument is given to specify a fractional seconds precision\nfrom 0 to 6, the return value includes a fractional seconds part of\nthat many digits.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT CURTIME();\n+-----------+\n| CURTIME() |\n+-----------+\n| 19:25:37  |\n+-----------+\n\nmysql> SELECT CURTIME() + 0;\n+---------------+\n| CURTIME() + 0 |\n+---------------+\n|        192537 |\n+---------------+\n\nmysql> SELECT CURTIME(3);\n+--------------+\n| CURTIME(3)   |\n+--------------+\n| 19:25:37.840 |\n+--------------+\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(129,'DATE FUNCTION',14,'Syntax:\nDATE(expr)\n\nExtracts the date part of the date or datetime expression expr. Returns\nNULL if expr is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT DATE(\'2003-12-31 01:02:03\');\n        -> \'2003-12-31\'\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(130,'DATEDIFF',14,'Syntax:\nDATEDIFF(expr1,expr2)\n\nDATEDIFF() returns expr1 − expr2 expressed as a value in days from\none date to the other. expr1 and expr2 are date or date-and-time\nexpressions. Only the date parts of the values are used in the\ncalculation.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT DATEDIFF(\'2007-12-31 23:59:59\',\'2007-12-30\');\n        -> 1\nmysql> SELECT DATEDIFF(\'2010-11-30 23:59:59\',\'2010-12-31\');\n        -> -31\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(131,'DATE_ADD',14,'Syntax:\nDATE_ADD(date,INTERVAL expr unit), DATE_SUB(date,INTERVAL expr unit)\n\nThese functions perform date arithmetic. The date argument specifies\nthe starting date or datetime value. expr is an expression specifying\nthe interval value to be added or subtracted from the starting date.\nexpr is evaluated as a string; it may start with a - for negative\nintervals. unit is a keyword indicating the units in which the\nexpression should be interpreted.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT DATE_ADD(\'2018-05-01\',INTERVAL 1 DAY);\n        -> \'2018-05-02\'\nmysql> SELECT DATE_SUB(\'2018-05-01\',INTERVAL 1 YEAR);\n        -> \'2017-05-01\'\nmysql> SELECT DATE_ADD(\'2020-12-31 23:59:59\',\n    ->                 INTERVAL 1 SECOND);\n        -> \'2021-01-01 00:00:00\'\nmysql> SELECT DATE_ADD(\'2018-12-31 23:59:59\',\n    ->                 INTERVAL 1 DAY);\n        -> \'2019-01-01 23:59:59\'\nmysql> SELECT DATE_ADD(\'2100-12-31 23:59:59\',\n    ->                 INTERVAL \'1:1\' MINUTE_SECOND);\n        -> \'2101-01-01 00:01:00\'\nmysql> SELECT DATE_SUB(\'2025-01-01 00:00:00\',\n    ->                 INTERVAL \'1 1:1:1\' DAY_SECOND);\n        -> \'2024-12-30 22:58:59\'\nmysql> SELECT DATE_ADD(\'1900-01-01 00:00:00\',\n    ->                 INTERVAL \'-1 10\' DAY_HOUR);\n        -> \'1899-12-30 14:00:00\'\nmysql> SELECT DATE_SUB(\'1998-01-02\', INTERVAL 31 DAY);\n        -> \'1997-12-02\'\nmysql> SELECT DATE_ADD(\'1992-12-31 23:59:59.000002\',\n    ->            INTERVAL \'1.999999\' SECOND_MICROSECOND);\n        -> \'1993-01-01 00:00:01.000001\'\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(132,'DATE_FORMAT',14,'Syntax:\nDATE_FORMAT(date,format)\n\nFormats the date value according to the format string. If either\nargument is NULL, the function returns NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT DATE_FORMAT(\'2009-10-04 22:23:00\', \'%W %M %Y\');\n        -> \'Sunday October 2009\'\nmysql> SELECT DATE_FORMAT(\'2007-10-04 22:23:00\', \'%H:%i:%s\');\n        -> \'22:23:00\'\nmysql> SELECT DATE_FORMAT(\'1900-10-04 22:23:00\',\n    ->                 \'%D %y %a %d %m %b %j\');\n        -> \'4th 00 Thu 04 10 Oct 277\'\nmysql> SELECT DATE_FORMAT(\'1997-10-04 22:23:00\',\n    ->                 \'%H %k %I %r %T %S %w\');\n        -> \'22 22 10 10:23:00 PM 22:23:00 00 6\'\nmysql> SELECT DATE_FORMAT(\'1999-01-01\', \'%X %V\');\n        -> \'1998 52\'\nmysql> SELECT DATE_FORMAT(\'2006-06-00\', \'%d\');\n        -> \'00\'\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(133,'DATE_SUB',14,'Syntax:\nDATE_SUB(date,INTERVAL expr unit)\n\nSee the description for DATE_ADD().\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(134,'DAY',14,'Syntax:\nDAY(date)\n\nDAY() is a synonym for DAYOFMONTH().\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(135,'DAYNAME',14,'Syntax:\nDAYNAME(date)\n\nReturns the name of the weekday for date. The language used for the\nname is controlled by the value of the lc_time_names system variable\n(see https://dev.mysql.com/doc/refman/8.0/en/locale-support.html).\nReturns NULL if date is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT DAYNAME(\'2007-02-03\');\n        -> \'Saturday\'\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(136,'DAYOFMONTH',14,'Syntax:\nDAYOFMONTH(date)\n\nReturns the day of the month for date, in the range 1 to 31, or 0 for\ndates such as \'0000-00-00\' or \'2008-00-00\' that have a zero day part.\nReturns NULL if date is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT DAYOFMONTH(\'2007-02-03\');\n        -> 3\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(137,'DAYOFWEEK',14,'Syntax:\nDAYOFWEEK(date)\n\nReturns the weekday index for date (1 = Sunday, 2 = Monday, ..., 7 =\nSaturday). These index values correspond to the ODBC standard. Returns\nNULL if date is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT DAYOFWEEK(\'2007-02-03\');\n        -> 7\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(138,'DAYOFYEAR',14,'Syntax:\nDAYOFYEAR(date)\n\nReturns the day of the year for date, in the range 1 to 366. Returns\nNULL if date is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT DAYOFYEAR(\'2007-02-03\');\n        -> 34\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(139,'EXTRACT',14,'Syntax:\nEXTRACT(unit FROM date)\n\nThe EXTRACT() function uses the same kinds of unit specifiers as\nDATE_ADD() or DATE_SUB(), but extracts parts from the date rather than\nperforming date arithmetic. For information on the unit argument, see\nhttps://dev.mysql.com/doc/refman/8.0/en/expressions.html#temporal-inter\nvals. Returns NULL if date is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT EXTRACT(YEAR FROM \'2019-07-02\');\n        -> 2019\nmysql> SELECT EXTRACT(YEAR_MONTH FROM \'2019-07-02 01:02:03\');\n        -> 201907\nmysql> SELECT EXTRACT(DAY_MINUTE FROM \'2019-07-02 01:02:03\');\n        -> 20102\nmysql> SELECT EXTRACT(MICROSECOND\n    ->                FROM \'2003-01-02 10:30:00.000123\');\n        -> 123\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(140,'FROM_DAYS',14,'Syntax:\nFROM_DAYS(N)\n\nGiven a day number N, returns a DATE value. Returns NULL if N is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT FROM_DAYS(730669);\n        -> \'2000-07-03\'\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(141,'FROM_UNIXTIME',14,'Syntax:\nFROM_UNIXTIME(unix_timestamp[,format])\n\nReturns a representation of unix_timestamp as a datetime or character\nstring value. The value returned is expressed using the session time\nzone. (Clients can set the session time zone as described in\nhttps://dev.mysql.com/doc/refman/8.0/en/time-zone-support.html.)\nunix_timestamp is an internal timestamp value representing seconds\nsince \'1970-01-01 00:00:00\' UTC, such as produced by the\nUNIX_TIMESTAMP() function.\n\nIf format is omitted, this function returns a DATETIME value.\n\nIf unix_timestamp or format is NULL, this function returns NULL.\n\nIf unix_timestamp is an integer, the fractional seconds precision of\nthe DATETIME is zero. When unix_timestamp is a decimal value, the\nfractional seconds precision of the DATETIME is the same as the\nprecision of the decimal value, up to a maximum of 6. When\nunix_timestamp is a floating point number, the fractional seconds\nprecision of the datetime is 6.\n\nOn 32-bit platforms, the maximum useful value for unix_timestamp is\n2147483647.999999, which returns \'2038-01-19 03:14:07.999999\' UTC. On\n64-bit platforms running MySQL 8.0.28 or later, the effective maximum\nis 32536771199.999999, which returns \'3001-01-18 23:59:59.999999\' UTC.\nRegardless of platform or version, a greater value for unix_timestamp\nthan the effective maximum returns 0.\n\nformat is used to format the result in the same way as the format\nstring used for the DATE_FORMAT() function. If format is supplied, the\nvalue returned is a VARCHAR.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT FROM_UNIXTIME(1447430881);\n        -> \'2015-11-13 10:08:01\'\nmysql> SELECT FROM_UNIXTIME(1447430881) + 0;\n        -> 20151113100801\nmysql> SELECT FROM_UNIXTIME(1447430881,\n    ->                      \'%Y %D %M %h:%i:%s %x\');\n        -> \'2015 13th November 10:08:01 2015\'\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(142,'GET_FORMAT',14,'Syntax:\nGET_FORMAT({DATE|TIME|DATETIME}, {\'EUR\'|\'USA\'|\'JIS\'|\'ISO\'|\'INTERNAL\'})\n\nReturns a format string. This function is useful in combination with\nthe DATE_FORMAT() and the STR_TO_DATE() functions.\n\nIf format is NULL, this function returns NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT DATE_FORMAT(\'2003-10-03\',GET_FORMAT(DATE,\'EUR\'));\n        -> \'03.10.2003\'\nmysql> SELECT STR_TO_DATE(\'10.31.2003\',GET_FORMAT(DATE,\'USA\'));\n        -> \'2003-10-31\'\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(143,'HOUR',14,'Syntax:\nHOUR(time)\n\nReturns the hour for time. The range of the return value is 0 to 23 for\ntime-of-day values. However, the range of TIME values actually is much\nlarger, so HOUR can return values greater than 23. Returns NULL if time\nis NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT HOUR(\'10:05:03\');\n        -> 10\nmysql> SELECT HOUR(\'272:59:59\');\n        -> 272\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(144,'LAST_DAY',14,'Syntax:\nLAST_DAY(date)\n\nTakes a date or datetime value and returns the corresponding value for\nthe last day of the month. Returns NULL if the argument is invalid or\nNULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT LAST_DAY(\'2003-02-05\');\n        -> \'2003-02-28\'\nmysql> SELECT LAST_DAY(\'2004-02-05\');\n        -> \'2004-02-29\'\nmysql> SELECT LAST_DAY(\'2004-01-01 01:01:01\');\n        -> \'2004-01-31\'\nmysql> SELECT LAST_DAY(\'2003-03-32\');\n        -> NULL\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(145,'LOCALTIME',14,'Syntax:\nLOCALTIME, LOCALTIME([fsp])\n\nLOCALTIME and LOCALTIME() are synonyms for NOW().\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(146,'LOCALTIMESTAMP',14,'Syntax:\nLOCALTIMESTAMP, LOCALTIMESTAMP([fsp])\n\nLOCALTIMESTAMP and LOCALTIMESTAMP() are synonyms for NOW().\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(147,'MAKEDATE',14,'Syntax:\nMAKEDATE(year,dayofyear)\n\nReturns a date, given year and day-of-year values. dayofyear must be\ngreater than 0 or the result is NULL. The result is also NULL if either\nargument is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT MAKEDATE(2011,31), MAKEDATE(2011,32);\n        -> \'2011-01-31\', \'2011-02-01\'\nmysql> SELECT MAKEDATE(2011,365), MAKEDATE(2014,365);\n        -> \'2011-12-31\', \'2014-12-31\'\nmysql> SELECT MAKEDATE(2011,0);\n        -> NULL\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(148,'MAKETIME',14,'Syntax:\nMAKETIME(hour,minute,second)\n\nReturns a time value calculated from the hour, minute, and second\narguments. Returns NULL if any of its arguments are NULL.\n\nThe second argument can have a fractional part.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT MAKETIME(12,15,30);\n        -> \'12:15:30\'\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(149,'MICROSECOND',14,'Syntax:\nMICROSECOND(expr)\n\nReturns the microseconds from the time or datetime expression expr as a\nnumber in the range from 0 to 999999. Returns NULL if expr is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT MICROSECOND(\'12:00:00.123456\');\n        -> 123456\nmysql> SELECT MICROSECOND(\'2019-12-31 23:59:59.000010\');\n        -> 10\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(150,'MINUTE',14,'Syntax:\nMINUTE(time)\n\nReturns the minute for time, in the range 0 to 59, or NULL if time is\nNULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT MINUTE(\'2008-02-03 10:05:03\');\n        -> 5\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(151,'MONTH',14,'Syntax:\nMONTH(date)\n\nReturns the month for date, in the range 1 to 12 for January to\nDecember, or 0 for dates such as \'0000-00-00\' or \'2008-00-00\' that have\na zero month part. Returns NULL if date is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT MONTH(\'2008-02-03\');\n        -> 2\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(152,'MONTHNAME',14,'Syntax:\nMONTHNAME(date)\n\nReturns the full name of the month for date. The language used for the\nname is controlled by the value of the lc_time_names system variable\n(https://dev.mysql.com/doc/refman/8.0/en/locale-support.html). Returns\nNULL if date is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT MONTHNAME(\'2008-02-03\');\n        -> \'February\'\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(153,'NOW',14,'Syntax:\nNOW([fsp])\n\nReturns the current date and time as a value in \'YYYY-MM-DD hh:mm:ss\'\nor YYYYMMDDhhmmss format, depending on whether the function is used in\nstring or numeric context. The value is expressed in the session time\nzone.\n\nIf the fsp argument is given to specify a fractional seconds precision\nfrom 0 to 6, the return value includes a fractional seconds part of\nthat many digits.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT NOW();\n        -> \'2007-12-15 23:50:26\'\nmysql> SELECT NOW() + 0;\n        -> 20071215235026.000000\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(154,'PERIOD_ADD',14,'Syntax:\nPERIOD_ADD(P,N)\n\nAdds N months to period P (in the format YYMM or YYYYMM). Returns a\nvalue in the format YYYYMM.\n\n*Note*:\n\nThe period argument P is not a date value.\n\nThis function returns NULL if P or N is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT PERIOD_ADD(200801,2);\n        -> 200803\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(155,'PERIOD_DIFF',14,'Syntax:\nPERIOD_DIFF(P1,P2)\n\nReturns the number of months between periods P1 and P2. P1 and P2\nshould be in the format YYMM or YYYYMM. Note that the period arguments\nP1 and P2 are not date values.\n\nThis function returns NULL if P1 or P2 is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT PERIOD_DIFF(200802,200703);\n        -> 11\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(156,'QUARTER',14,'Syntax:\nQUARTER(date)\n\nReturns the quarter of the year for date, in the range 1 to 4, or NULL\nif date is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT QUARTER(\'2008-04-01\');\n        -> 2\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(157,'SECOND',14,'Syntax:\nSECOND(time)\n\nReturns the second for time, in the range 0 to 59, or NULL if time is\nNULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT SECOND(\'10:05:03\');\n        -> 3\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(158,'SEC_TO_TIME',14,'Syntax:\nSEC_TO_TIME(seconds)\n\nReturns the seconds argument, converted to hours, minutes, and seconds,\nas a TIME value. The range of the result is constrained to that of the\nTIME data type. A warning occurs if the argument corresponds to a value\noutside that range.\n\nThe function returns NULL if seconds is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT SEC_TO_TIME(2378);\n        -> \'00:39:38\'\nmysql> SELECT SEC_TO_TIME(2378) + 0;\n        -> 3938\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(159,'STR_TO_DATE',14,'Syntax:\nSTR_TO_DATE(str,format)\n\nThis is the inverse of the DATE_FORMAT() function. It takes a string\nstr and a format string format. STR_TO_DATE() returns a DATETIME value\nif the format string contains both date and time parts, or a DATE or\nTIME value if the string contains only date or time parts. If str or\nformat is NULL, the function returns NULL. If the date, time, or\ndatetime value extracted from str is illegal, STR_TO_DATE() returns\nNULL and produces a warning.\n\nThe server scans str attempting to match format to it. The format\nstring can contain literal characters and format specifiers beginning\nwith %. Literal characters in format must match literally in str.\nFormat specifiers in format must match a date or time part in str. For\nthe specifiers that can be used in format, see the DATE_FORMAT()\nfunction description.\n\nmysql> SELECT STR_TO_DATE(\'01,5,2013\',\'%d,%m,%Y\');\n        -> \'2013-05-01\'\nmysql> SELECT STR_TO_DATE(\'May 1, 2013\',\'%M %d,%Y\');\n        -> \'2013-05-01\'\n\nScanning starts at the beginning of str and fails if format is found\nnot to match. Extra characters at the end of str are ignored.\n\nmysql> SELECT STR_TO_DATE(\'a09:30:17\',\'a%h:%i:%s\');\n        -> \'09:30:17\'\nmysql> SELECT STR_TO_DATE(\'a09:30:17\',\'%h:%i:%s\');\n        -> NULL\nmysql> SELECT STR_TO_DATE(\'09:30:17a\',\'%h:%i:%s\');\n        -> \'09:30:17\'\n\nUnspecified date or time parts have a value of 0, so incompletely\nspecified values in str produce a result with some or all parts set to\n0:\n\nmysql> SELECT STR_TO_DATE(\'abc\',\'abc\');\n        -> \'0000-00-00\'\nmysql> SELECT STR_TO_DATE(\'9\',\'%m\');\n        -> \'0000-09-00\'\nmysql> SELECT STR_TO_DATE(\'9\',\'%s\');\n        -> \'00:00:09\'\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(160,'SUBDATE',14,'Syntax:\nSUBDATE(date,INTERVAL expr unit), SUBDATE(expr,days)\n\nWhen invoked with the INTERVAL form of the second argument, SUBDATE()\nis a synonym for DATE_SUB(). For information on the INTERVAL unit\nargument, see the discussion for DATE_ADD().\n\nmysql> SELECT DATE_SUB(\'2008-01-02\', INTERVAL 31 DAY);\n        -> \'2007-12-02\'\nmysql> SELECT SUBDATE(\'2008-01-02\', INTERVAL 31 DAY);\n        -> \'2007-12-02\'\n\nThe second form enables the use of an integer value for days. In such\ncases, it is interpreted as the number of days to be subtracted from\nthe date or datetime expression expr.\n\nmysql> SELECT SUBDATE(\'2008-01-02 12:00:00\', 31);\n        -> \'2007-12-02 12:00:00\'\n\nThis function returns NULL if any of its arguments are NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(161,'SUBTIME',14,'Syntax:\nSUBTIME(expr1,expr2)\n\nSUBTIME() returns expr1 − expr2 expressed as a value in the same\nformat as expr1. expr1 is a time or datetime expression, and expr2 is a\ntime expression.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT SUBTIME(\'2007-12-31 23:59:59.999999\',\'1 1:1:1.000002\');\n        -> \'2007-12-30 22:58:58.999997\'\nmysql> SELECT SUBTIME(\'01:00:00.999999\', \'02:00:00.999998\');\n        -> \'-00:59:59.999999\'\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(162,'SYSDATE',14,'Syntax:\nSYSDATE([fsp])\n\nReturns the current date and time as a value in \'YYYY-MM-DD hh:mm:ss\'\nor YYYYMMDDhhmmss format, depending on whether the function is used in\nstring or numeric context.\n\nIf the fsp argument is given to specify a fractional seconds precision\nfrom 0 to 6, the return value includes a fractional seconds part of\nthat many digits.\n\nSYSDATE() returns the time at which it executes. This differs from the\nbehavior for NOW(), which returns a constant time that indicates the\ntime at which the statement began to execute. (Within a stored function\nor trigger, NOW() returns the time at which the function or triggering\nstatement began to execute.)\n\nmysql> SELECT NOW(), SLEEP(2), NOW();\n+---------------------+----------+---------------------+\n| NOW()               | SLEEP(2) | NOW()               |\n+---------------------+----------+---------------------+\n| 2006-04-12 13:47:36 |        0 | 2006-04-12 13:47:36 |\n+---------------------+----------+---------------------+\n\nmysql> SELECT SYSDATE(), SLEEP(2), SYSDATE();\n+---------------------+----------+---------------------+\n| SYSDATE()           | SLEEP(2) | SYSDATE()           |\n+---------------------+----------+---------------------+\n| 2006-04-12 13:47:44 |        0 | 2006-04-12 13:47:46 |\n+---------------------+----------+---------------------+\n\nIn addition, the SET TIMESTAMP statement affects the value returned by\nNOW() but not by SYSDATE(). This means that timestamp settings in the\nbinary log have no effect on invocations of SYSDATE().\n\nBecause SYSDATE() can return different values even within the same\nstatement, and is not affected by SET TIMESTAMP, it is nondeterministic\nand therefore unsafe for replication if statement-based binary logging\nis used. If that is a problem, you can use row-based logging.\n\nAlternatively, you can use the --sysdate-is-now option to cause\nSYSDATE() to be an alias for NOW(). This works if the option is used on\nboth the replication source server and the replica.\n\nThe nondeterministic nature of SYSDATE() also means that indexes cannot\nbe used for evaluating expressions that refer to it.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(163,'TIME FUNCTION',14,'Syntax:\nTIME(expr)\n\nExtracts the time part of the time or datetime expression expr and\nreturns it as a string. Returns NULL if expr is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT TIME(\'2003-12-31 01:02:03\');\n        -> \'01:02:03\'\nmysql> SELECT TIME(\'2003-12-31 01:02:03.000123\');\n        -> \'01:02:03.000123\'\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(164,'TIMEDIFF',14,'Syntax:\nTIMEDIFF(expr1,expr2)\n\nTIMEDIFF() returns expr1 − expr2 expressed as a time value. expr1 and\nexpr2 are strings which are converted to TIME or DATETIME expressions;\nthese must be of the same type following conversion. Returns NULL if\nexpr1 or expr2 is NULL.\n\nThe result returned by TIMEDIFF() is limited to the range allowed for\nTIME values. Alternatively, you can use either of the functions\nTIMESTAMPDIFF() and UNIX_TIMESTAMP(), both of which return integers.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT TIMEDIFF(\'2000-01-01 00:00:00\',\n    ->                 \'2000-01-01 00:00:00.000001\');\n        -> \'-00:00:00.000001\'\nmysql> SELECT TIMEDIFF(\'2008-12-31 23:59:59.000001\',\n    ->                 \'2008-12-30 01:01:01.000002\');\n        -> \'46:58:57.999999\'\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(165,'TIMESTAMP FUNCTION',14,'Syntax:\nTIMESTAMP(expr), TIMESTAMP(expr1,expr2)\n\nWith a single argument, this function returns the date or datetime\nexpression expr as a datetime value. With two arguments, it adds the\ntime expression expr2 to the date or datetime expression expr1 and\nreturns the result as a datetime value. Returns NULL if expr, expr1, or\nexpr2 is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT TIMESTAMP(\'2003-12-31\');\n        -> \'2003-12-31 00:00:00\'\nmysql> SELECT TIMESTAMP(\'2003-12-31 12:00:00\',\'12:00:00\');\n        -> \'2004-01-01 00:00:00\'\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(166,'TIMESTAMPADD',14,'Syntax:\nTIMESTAMPADD(unit,interval,datetime_expr)\n\nAdds the integer expression interval to the date or datetime expression\ndatetime_expr. The unit for interval is given by the unit argument,\nwhich should be one of the following values: MICROSECOND\n(microseconds), SECOND, MINUTE, HOUR, DAY, WEEK, MONTH, QUARTER, or\nYEAR.\n\nThe unit value may be specified using one of keywords as shown, or with\na prefix of SQL_TSI_. For example, DAY and SQL_TSI_DAY both are legal.\n\nThis function returns NULL if interval or datetime_expr is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT TIMESTAMPADD(MINUTE, 1, \'2003-01-02\');\n        -> \'2003-01-02 00:01:00\'\nmysql> SELECT TIMESTAMPADD(WEEK,1,\'2003-01-02\');\n        -> \'2003-01-09\'\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(167,'TIMESTAMPDIFF',14,'Syntax:\nTIMESTAMPDIFF(unit,datetime_expr1,datetime_expr2)\n\nReturns datetime_expr2 − datetime_expr1, where datetime_expr1 and\ndatetime_expr2 are date or datetime expressions. One expression may be\na date and the other a datetime; a date value is treated as a datetime\nhaving the time part \'00:00:00\' where necessary. The unit for the\nresult (an integer) is given by the unit argument. The legal values for\nunit are the same as those listed in the description of the\nTIMESTAMPADD() function.\n\nThis function returns NULL if datetime_expr1 or datetime_expr2 is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT TIMESTAMPDIFF(MONTH,\'2003-02-01\',\'2003-05-01\');\n        -> 3\nmysql> SELECT TIMESTAMPDIFF(YEAR,\'2002-05-01\',\'2001-01-01\');\n        -> -1\nmysql> SELECT TIMESTAMPDIFF(MINUTE,\'2003-02-01\',\'2003-05-01 12:05:55\');\n        -> 128885\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(168,'TIME_FORMAT',14,'Syntax:\nTIME_FORMAT(time,format)\n\nThis is used like the DATE_FORMAT() function, but the format string may\ncontain format specifiers only for hours, minutes, seconds, and\nmicroseconds. Other specifiers produce a NULL or 0. TIME_FORMAT()\nreturns NULL if time or format is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT TIME_FORMAT(\'100:00:00\', \'%H %k %h %I %l\');\n        -> \'100 100 04 04 4\'\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(169,'TIME_TO_SEC',14,'Syntax:\nTIME_TO_SEC(time)\n\nReturns the time argument, converted to seconds. Returns NULL if time\nis NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT TIME_TO_SEC(\'22:23:00\');\n        -> 80580\nmysql> SELECT TIME_TO_SEC(\'00:39:38\');\n        -> 2378\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(170,'TO_DAYS',14,'Syntax:\nTO_DAYS(date)\n\nGiven a date date, returns a day number (the number of days since year\n0). Returns NULL if date is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT TO_DAYS(950501);\n        -> 728779\nmysql> SELECT TO_DAYS(\'2007-10-07\');\n        -> 733321\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(171,'TO_SECONDS',14,'Syntax:\nTO_SECONDS(expr)\n\nGiven a date or datetime expr, returns the number of seconds since the\nyear 0. If expr is not a valid date or datetime value (including NULL),\nit returns NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT TO_SECONDS(950501);\n        -> 62966505600\nmysql> SELECT TO_SECONDS(\'2009-11-29\');\n        -> 63426672000\nmysql> SELECT TO_SECONDS(\'2009-11-29 13:43:32\');\n        -> 63426721412\nmysql> SELECT TO_SECONDS( NOW() );\n        -> 63426721458\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(172,'UNIX_TIMESTAMP',14,'Syntax:\nUNIX_TIMESTAMP([date])\n\nIf UNIX_TIMESTAMP() is called with no date argument, it returns a Unix\ntimestamp representing seconds since \'1970-01-01 00:00:00\' UTC.\n\nIf UNIX_TIMESTAMP() is called with a date argument, it returns the\nvalue of the argument as seconds since \'1970-01-01 00:00:00\' UTC. The\nserver interprets date as a value in the session time zone and converts\nit to an internal Unix timestamp value in UTC. (Clients can set the\nsession time zone as described in\nhttps://dev.mysql.com/doc/refman/8.0/en/time-zone-support.html.) The\ndate argument may be a DATE, DATETIME, or TIMESTAMP string, or a number\nin YYMMDD, YYMMDDhhmmss, YYYYMMDD, or YYYYMMDDhhmmss format. If the\nargument includes a time part, it may optionally include a fractional\nseconds part.\n\nThe return value is an integer if no argument is given or the argument\ndoes not include a fractional seconds part, or DECIMAL if an argument\nis given that includes a fractional seconds part.\n\nWhen the date argument is a TIMESTAMP column, UNIX_TIMESTAMP() returns\nthe internal timestamp value directly, with no implicit\n\"string-to-Unix-timestamp\" conversion.\n\nPrior to MySQL 8.0.28, the valid range of argument values is the same\nas for the TIMESTAMP data type: \'1970-01-01 00:00:01.000000\' UTC to\n\'2038-01-19 03:14:07.999999\' UTC. This is also the case in MySQL 8.0.28\nand later for 32-bit platforms. For MySQL 8.0.28 and later running on\n64-bit platforms, the valid range of argument values for\nUNIX_TIMESTAMP() is \'1970-01-01 00:00:01.000000\' UTC to \'3001-01-19\n03:14:07.999999\' UTC (corresponding to 32536771199.999999 seconds).\n\nRegardless of MySQL version or platform architecture, if you pass an\nout-of-range date to UNIX_TIMESTAMP(), it returns 0. If date is NULL,\nit returns NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT UNIX_TIMESTAMP();\n        -> 1447431666\nmysql> SELECT UNIX_TIMESTAMP(\'2015-11-13 10:20:19\');\n        -> 1447431619\nmysql> SELECT UNIX_TIMESTAMP(\'2015-11-13 10:20:19.012\');\n        -> 1447431619.012\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(173,'UTC_DATE',14,'Syntax:\nUTC_DATE, UTC_DATE()\n\nReturns the current UTC date as a value in \'YYYY-MM-DD\' or YYYYMMDD\nformat, depending on whether the function is used in string or numeric\ncontext.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT UTC_DATE(), UTC_DATE() + 0;\n        -> \'2003-08-14\', 20030814\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(174,'UTC_TIME',14,'Syntax:\nUTC_TIME, UTC_TIME([fsp])\n\nReturns the current UTC time as a value in \'hh:mm:ss\' or hhmmss format,\ndepending on whether the function is used in string or numeric context.\n\nIf the fsp argument is given to specify a fractional seconds precision\nfrom 0 to 6, the return value includes a fractional seconds part of\nthat many digits.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT UTC_TIME(), UTC_TIME() + 0;\n        -> \'18:07:53\', 180753.000000\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(175,'UTC_TIMESTAMP',14,'Syntax:\nUTC_TIMESTAMP, UTC_TIMESTAMP([fsp])\n\nReturns the current UTC date and time as a value in \'YYYY-MM-DD\nhh:mm:ss\' or YYYYMMDDhhmmss format, depending on whether the function\nis used in string or numeric context.\n\nIf the fsp argument is given to specify a fractional seconds precision\nfrom 0 to 6, the return value includes a fractional seconds part of\nthat many digits.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT UTC_TIMESTAMP(), UTC_TIMESTAMP() + 0;\n        -> \'2003-08-14 18:08:04\', 20030814180804.000000\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(176,'WEEK',14,'Syntax:\nWEEK(date[,mode])\n\nThis function returns the week number for date. The two-argument form\nof WEEK() enables you to specify whether the week starts on Sunday or\nMonday and whether the return value should be in the range from 0 to 53\nor from 1 to 53. If the mode argument is omitted, the value of the\ndefault_week_format system variable is used. See\nhttps://dev.mysql.com/doc/refman/8.0/en/server-system-variables.html.\nFor a NULL date value, the function returns NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT WEEK(\'2008-02-20\');\n        -> 7\nmysql> SELECT WEEK(\'2008-02-20\',0);\n        -> 7\nmysql> SELECT WEEK(\'2008-02-20\',1);\n        -> 8\nmysql> SELECT WEEK(\'2008-12-31\',1);\n        -> 53\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(177,'WEEKDAY',14,'Syntax:\nWEEKDAY(date)\n\nReturns the weekday index for date (0 = Monday, 1 = Tuesday, ... 6 =\nSunday). Returns NULL if date is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT WEEKDAY(\'2008-02-03 22:23:00\');\n        -> 6\nmysql> SELECT WEEKDAY(\'2007-11-06\');\n        -> 1\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(178,'WEEKOFYEAR',14,'Syntax:\nWEEKOFYEAR(date)\n\nReturns the calendar week of the date as a number in the range from 1\nto 53. Returns NULL if date is NULL.\n\nWEEKOFYEAR() is a compatibility function that is equivalent to\nWEEK(date,3).\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT WEEKOFYEAR(\'2008-02-20\');\n        -> 8\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(179,'YEAR',14,'Syntax:\nYEAR(date)\n\nReturns the year for date, in the range 1000 to 9999, or 0 for the\n\"zero\" date. Returns NULL if date is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT YEAR(\'1987-01-01\');\n        -> 1987\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(180,'YEARWEEK',14,'Syntax:\nYEARWEEK(date), YEARWEEK(date,mode)\n\nReturns year and week for a date. The year in the result may be\ndifferent from the year in the date argument for the first and the last\nweek of the year. Returns NULL if date is NULL.\n\nThe mode argument works exactly like the mode argument to WEEK(). For\nthe single-argument syntax, a mode value of 0 is used. Unlike WEEK(),\nthe value of default_week_format does not influence YEARWEEK().\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html\n\n','mysql> SELECT YEARWEEK(\'1987-01-01\');\n        -> 198652\n','https://dev.mysql.com/doc/refman/8.0/en/date-and-time-functions.html'),(181,'ASCII',15,'Syntax:\nASCII(str)\n\nReturns the numeric value of the leftmost character of the string str.\nReturns 0 if str is the empty string. Returns NULL if str is NULL.\nASCII() works for 8-bit characters.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','mysql> SELECT ASCII(\'2\');\n        -> 50\nmysql> SELECT ASCII(2);\n        -> 50\nmysql> SELECT ASCII(\'dx\');\n        -> 100\n','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(182,'BIN',15,'Syntax:\nBIN(N)\n\nReturns a string representation of the binary value of N, where N is a\nlonglong (BIGINT) number. This is equivalent to CONV(N,10,2). Returns\nNULL if N is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','mysql> SELECT BIN(12);\n        -> \'1100\'\n','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(183,'BIT_LENGTH',15,'Syntax:\nBIT_LENGTH(str)\n\nReturns the length of the string str in bits. Returns NULL if str is\nNULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','mysql> SELECT BIT_LENGTH(\'text\');\n        -> 32\n','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(184,'CHAR FUNCTION',15,'Syntax:\nCHAR(N,... [USING charset_name])\n\nCHAR() interprets each argument N as an integer and returns a string\nconsisting of the characters given by the code values of those\nintegers. NULL values are skipped.\n\nBy default, CHAR() returns a binary string. To produce a string in a\ngiven character set, use the optional USING clause:\n\nmysql> SELECT CHAR(77,121,83,81,\'76\' USING utf8mb4);\n+---------------------------------------+\n| CHAR(77,121,83,81,\'76\' USING utf8mb4) |\n+---------------------------------------+\n| MySQL                                 |\n+---------------------------------------+\n1 row in set (0.00 sec)\n\nmysql> SELECT CHAR(77,77.3,\'77.3\' USING utf8mb4);\n+------------------------------------+\n| CHAR(77,77.3,\'77.3\' USING utf8mb4) |\n+------------------------------------+\n| MMM                                |\n+------------------------------------+\n1 row in set, 1 warning (0.00 sec)\n\nmysql> SHOW WARNINGS;\n+---------+------+-------------------------------------------+\n| Level   | Code | Message                                   |\n+---------+------+-------------------------------------------+\n| Warning | 1292 | Truncated incorrect INTEGER value: \'77.3\' |\n+---------+------+-------------------------------------------+\n1 row in set (0.00 sec)\n\nIf USING is given and the result string is illegal for the given\ncharacter set, a warning is issued. Also, if strict SQL mode is\nenabled, the result from CHAR() becomes NULL.\n\nIf CHAR() is invoked from within the mysql client, binary strings\ndisplay using hexadecimal notation, depending on the value of the\n--binary-as-hex. For more information about that option, see\nhttps://dev.mysql.com/doc/refman/8.0/en/mysql.html.\n\nCHAR() arguments larger than 255 are converted into multiple result\nbytes. For example, CHAR(256) is equivalent to CHAR(1,0), and\nCHAR(256*256) is equivalent to CHAR(1,0,0):\n\nmysql> SELECT HEX(CHAR(1,0)), HEX(CHAR(256));\n+----------------+----------------+\n| HEX(CHAR(1,0)) | HEX(CHAR(256)) |\n+----------------+----------------+\n| 0100           | 0100           |\n+----------------+----------------+\n1 row in set (0.00 sec)\n\nmysql> SELECT HEX(CHAR(1,0,0)), HEX(CHAR(256*256));\n+------------------+--------------------+\n| HEX(CHAR(1,0,0)) | HEX(CHAR(256*256)) |\n+------------------+--------------------+\n| 010000           | 010000             |\n+------------------+--------------------+\n1 row in set (0.00 sec)\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','mysql> SELECT CHAR(77,121,83,81,\'76\');\n+--------------------------------------------------+\n| CHAR(77,121,83,81,\'76\')                          |\n+--------------------------------------------------+\n| 0x4D7953514C                                     |\n+--------------------------------------------------+\n1 row in set (0.00 sec)\n\nmysql> SELECT CHAR(77,77.3,\'77.3\');\n+--------------------------------------------+\n| CHAR(77,77.3,\'77.3\')                       |\n+--------------------------------------------+\n| 0x4D4D4D                                   |\n+--------------------------------------------+\n1 row in set (0.00 sec)\n','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(185,'CHAR_LENGTH',15,'Syntax:\nCHAR_LENGTH(str)\n\nReturns the length of the string str, measured in code points. A\nmultibyte character counts as a single code point. This means that, for\na string containing two 3-byte characters, LENGTH() returns 6, whereas\nCHAR_LENGTH() returns 2, as shown here:\n\nmysql> SET @dolphin:=\'海豚\';\nQuery OK, 0 rows affected (0.01 sec)\n\nmysql> SELECT LENGTH(@dolphin), CHAR_LENGTH(@dolphin);\n+------------------+-----------------------+\n| LENGTH(@dolphin) | CHAR_LENGTH(@dolphin) |\n+------------------+-----------------------+\n|                6 |                     2 |\n+------------------+-----------------------+\n1 row in set (0.00 sec)\n\nCHAR_LENGTH() returns NULL if str is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(186,'CHARACTER_LENGTH',15,'Syntax:\nCHARACTER_LENGTH(str)\n\nCHARACTER_LENGTH() is a synonym for CHAR_LENGTH().\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(187,'CONCAT',15,'Syntax:\nCONCAT(str1,str2,...)\n\nReturns the string that results from concatenating the arguments. May\nhave one or more arguments. If all arguments are nonbinary strings, the\nresult is a nonbinary string. If the arguments include any binary\nstrings, the result is a binary string. A numeric argument is converted\nto its equivalent nonbinary string form.\n\nCONCAT() returns NULL if any argument is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','mysql> SELECT CONCAT(\'My\', \'S\', \'QL\');\n        -> \'MySQL\'\nmysql> SELECT CONCAT(\'My\', NULL, \'QL\');\n        -> NULL\nmysql> SELECT CONCAT(14.3);\n        -> \'14.3\'\n','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(188,'CONCAT_WS',15,'Syntax:\nCONCAT_WS(separator,str1,str2,...)\n\nCONCAT_WS() stands for Concatenate With Separator and is a special form\nof CONCAT(). The first argument is the separator for the rest of the\narguments. The separator is added between the strings to be\nconcatenated. The separator can be a string, as can the rest of the\narguments. If the separator is NULL, the result is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','mysql> SELECT CONCAT_WS(\',\',\'First name\',\'Second name\',\'Last Name\');\n        -> \'First name,Second name,Last Name\'\nmysql> SELECT CONCAT_WS(\',\',\'First name\',NULL,\'Last Name\');\n        -> \'First name,Last Name\'\n','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(189,'ELT',15,'Syntax:\nELT(N,str1,str2,str3,...)\n\nELT() returns the Nth element of the list of strings: str1 if N = 1,\nstr2 if N = 2, and so on. Returns NULL if N is less than 1, greater\nthan the number of arguments, or NULL. ELT() is the complement of\nFIELD().\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','mysql> SELECT ELT(1, \'Aa\', \'Bb\', \'Cc\', \'Dd\');\n        -> \'Aa\'\nmysql> SELECT ELT(4, \'Aa\', \'Bb\', \'Cc\', \'Dd\');\n        -> \'Dd\'\n','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(190,'EXPORT_SET',15,'Syntax:\nEXPORT_SET(bits,on,off[,separator[,number_of_bits]])\n\nReturns a string such that for every bit set in the value bits, you get\nan on string and for every bit not set in the value, you get an off\nstring. Bits in bits are examined from right to left (from low-order to\nhigh-order bits). Strings are added to the result from left to right,\nseparated by the separator string (the default being the comma\ncharacter ,). The number of bits examined is given by number_of_bits,\nwhich has a default of 64 if not specified. number_of_bits is silently\nclipped to 64 if larger than 64. It is treated as an unsigned integer,\nso a value of −1 is effectively the same as 64.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','mysql> SELECT EXPORT_SET(5,\'Y\',\'N\',\',\',4);\n        -> \'Y,N,Y,N\'\nmysql> SELECT EXPORT_SET(6,\'1\',\'0\',\',\',10);\n        -> \'0,1,1,0,0,0,0,0,0,0\'\n','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(191,'FIELD',15,'Syntax:\nFIELD(str,str1,str2,str3,...)\n\nReturns the index (position) of str in the str1, str2, str3, ... list.\nReturns 0 if str is not found.\n\nIf all arguments to FIELD() are strings, all arguments are compared as\nstrings. If all arguments are numbers, they are compared as numbers.\nOtherwise, the arguments are compared as double.\n\nIf str is NULL, the return value is 0 because NULL fails equality\ncomparison with any value. FIELD() is the complement of ELT().\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','mysql> SELECT FIELD(\'Bb\', \'Aa\', \'Bb\', \'Cc\', \'Dd\', \'Ff\');\n        -> 2\nmysql> SELECT FIELD(\'Gg\', \'Aa\', \'Bb\', \'Cc\', \'Dd\', \'Ff\');\n        -> 0\n','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(192,'FIND_IN_SET',15,'Syntax:\nFIND_IN_SET(str,strlist)\n\nReturns a value in the range of 1 to N if the string str is in the\nstring list strlist consisting of N substrings. A string list is a\nstring composed of substrings separated by , characters. If the first\nargument is a constant string and the second is a column of type SET,\nthe FIND_IN_SET() function is optimized to use bit arithmetic. Returns\n0 if str is not in strlist or if strlist is the empty string. Returns\nNULL if either argument is NULL. This function does not work properly\nif the first argument contains a comma (,) character.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','mysql> SELECT FIND_IN_SET(\'b\',\'a,b,c,d\');\n        -> 2\n','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(193,'FORMAT',15,'Syntax:\nFORMAT(X,D[,locale])\n\nFormats the number X to a format like \'#,###,###.##\', rounded to D\ndecimal places, and returns the result as a string. If D is 0, the\nresult has no decimal point or fractional part. If X or D is NULL, the\nfunction returns NULL.\n\nThe optional third parameter enables a locale to be specified to be\nused for the result number\'s decimal point, thousands separator, and\ngrouping between separators. Permissible locale values are the same as\nthe legal values for the lc_time_names system variable (see\nhttps://dev.mysql.com/doc/refman/8.0/en/locale-support.html). If the\nlocale is NULL or not specified, the default locale is \'en_US\'.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','mysql> SELECT FORMAT(12332.123456, 4);\n        -> \'12,332.1235\'\nmysql> SELECT FORMAT(12332.1,4);\n        -> \'12,332.1000\'\nmysql> SELECT FORMAT(12332.2,0);\n        -> \'12,332\'\nmysql> SELECT FORMAT(12332.2,2,\'de_DE\');\n        -> \'12.332,20\'\n','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(194,'FROM_BASE64',15,'Syntax:\nFROM_BASE64(str)\n\nTakes a string encoded with the base-64 encoded rules used by\nTO_BASE64() and returns the decoded result as a binary string. The\nresult is NULL if the argument is NULL or not a valid base-64 string.\nSee the description of TO_BASE64() for details about the encoding and\ndecoding rules.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','mysql> SELECT TO_BASE64(\'abc\'), FROM_BASE64(TO_BASE64(\'abc\'));\n        -> \'JWJj\', \'abc\'\n','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(195,'HEX',15,'Syntax:\nHEX(str), HEX(N)\n\nFor a string argument str, HEX() returns a hexadecimal string\nrepresentation of str where each byte of each character in str is\nconverted to two hexadecimal digits. (Multibyte characters therefore\nbecome more than two digits.) The inverse of this operation is\nperformed by the UNHEX() function.\n\nFor a numeric argument N, HEX() returns a hexadecimal string\nrepresentation of the value of N treated as a longlong (BIGINT) number.\nThis is equivalent to CONV(N,10,16). The inverse of this operation is\nperformed by CONV(HEX(N),16,10).\n\nFor a NULL argument, this function returns NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','mysql> SELECT X\'616263\', HEX(\'abc\'), UNHEX(HEX(\'abc\'));\n        -> \'abc\', 616263, \'abc\'\nmysql> SELECT HEX(255), CONV(HEX(255),16,10);\n        -> \'FF\', 255\n','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(196,'INSERT FUNCTION',15,'Syntax:\nINSERT(str,pos,len,newstr)\n\nReturns the string str, with the substring beginning at position pos\nand len characters long replaced by the string newstr. Returns the\noriginal string if pos is not within the length of the string. Replaces\nthe rest of the string from position pos if len is not within the\nlength of the rest of the string. Returns NULL if any argument is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','mysql> SELECT INSERT(\'Quadratic\', 3, 4, \'What\');\n        -> \'QuWhattic\'\nmysql> SELECT INSERT(\'Quadratic\', -1, 4, \'What\');\n        -> \'Quadratic\'\nmysql> SELECT INSERT(\'Quadratic\', 3, 100, \'What\');\n        -> \'QuWhat\'\n','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(197,'INSTR',15,'Syntax:\nINSTR(str,substr)\n\nReturns the position of the first occurrence of substring substr in\nstring str. This is the same as the two-argument form of LOCATE(),\nexcept that the order of the arguments is reversed.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','mysql> SELECT INSTR(\'foobarbar\', \'bar\');\n        -> 4\nmysql> SELECT INSTR(\'xbar\', \'foobar\');\n        -> 0\n','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(198,'LCASE',15,'Syntax:\nLCASE(str)\n\nLCASE() is a synonym for LOWER().\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(199,'LEFT',15,'Syntax:\nLEFT(str,len)\n\nReturns the leftmost len characters from the string str, or NULL if any\nargument is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','mysql> SELECT LEFT(\'foobarbar\', 5);\n        -> \'fooba\'\n','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(200,'LENGTH',15,'Syntax:\nLENGTH(str)\n\nReturns the length of the string str, measured in bytes. A multibyte\ncharacter counts as multiple bytes. This means that for a string\ncontaining five 2-byte characters, LENGTH() returns 10, whereas\nCHAR_LENGTH() returns 5. Returns NULL if str is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','mysql> SELECT LENGTH(\'text\');\n        -> 4\n','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(201,'LOAD_FILE',15,'Syntax:\nLOAD_FILE(file_name)\n\nReads the file and returns the file contents as a string. To use this\nfunction, the file must be located on the server host, you must specify\nthe full path name to the file, and you must have the FILE privilege.\nThe file must be readable by the server and its size less than\nmax_allowed_packet bytes. If the secure_file_priv system variable is\nset to a nonempty directory name, the file to be loaded must be located\nin that directory. (Prior to MySQL 8.0.17, the file must be readable by\nall, not just readable by the server.)\n\nIf the file does not exist or cannot be read because one of the\npreceding conditions is not satisfied, the function returns NULL.\n\nThe character_set_filesystem system variable controls interpretation of\nfile names that are given as literal strings.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','mysql> UPDATE t\n            SET blob_col=LOAD_FILE(\'/tmp/picture\')\n            WHERE id=1;\n','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(202,'LOCATE',15,'Syntax:\nLOCATE(substr,str), LOCATE(substr,str,pos)\n\nThe first syntax returns the position of the first occurrence of\nsubstring substr in string str. The second syntax returns the position\nof the first occurrence of substring substr in string str, starting at\nposition pos. Returns 0 if substr is not in str. Returns NULL if any\nargument is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','mysql> SELECT LOCATE(\'bar\', \'foobarbar\');\n        -> 4\nmysql> SELECT LOCATE(\'xbar\', \'foobar\');\n        -> 0\nmysql> SELECT LOCATE(\'bar\', \'foobarbar\', 5);\n        -> 7\n','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(203,'LOWER',15,'Syntax:\nLOWER(str)\n\nReturns the string str with all characters changed to lowercase\naccording to the current character set mapping, or NULL if str is NULL.\nThe default character set is utf8mb4.\n\nmysql> SELECT LOWER(\'QUADRATICALLY\');\n        -> \'quadratically\'\n\nLOWER() (and UPPER()) are ineffective when applied to binary strings\n(BINARY, VARBINARY, BLOB). To perform lettercase conversion of a binary\nstring, first convert it to a nonbinary string using a character set\nappropriate for the data stored in the string:\n\nmysql> SET @str = BINARY \'New York\';\nmysql> SELECT LOWER(@str), LOWER(CONVERT(@str USING utf8mb4));\n+-------------+------------------------------------+\n| LOWER(@str) | LOWER(CONVERT(@str USING utf8mb4)) |\n+-------------+------------------------------------+\n| New York    | new york                           |\n+-------------+------------------------------------+\n\nFor collations of Unicode character sets, LOWER() and UPPER() work\naccording to the Unicode Collation Algorithm (UCA) version in the\ncollation name, if there is one, and UCA 4.0.0 if no version is\nspecified. For example, utf8mb4_0900_ai_ci and utf8mb3_unicode_520_ci\nwork according to UCA 9.0.0 and 5.2.0, respectively, whereas\nutf8mb3_unicode_ci works according to UCA 4.0.0. See\nhttps://dev.mysql.com/doc/refman/8.0/en/charset-unicode-sets.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(204,'LPAD',15,'Syntax:\nLPAD(str,len,padstr)\n\nReturns the string str, left-padded with the string padstr to a length\nof len characters. If str is longer than len, the return value is\nshortened to len characters.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','mysql> SELECT LPAD(\'hi\',4,\'??\');\n        -> \'??hi\'\nmysql> SELECT LPAD(\'hi\',1,\'??\');\n        -> \'h\'\n','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(205,'LTRIM',15,'Syntax:\nLTRIM(str)\n\nReturns the string str with leading space characters removed. Returns\nNULL if str is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','mysql> SELECT LTRIM(\'  barbar\');\n        -> \'barbar\'\n','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(206,'MAKE_SET',15,'Syntax:\nMAKE_SET(bits,str1,str2,...)\n\nReturns a set value (a string containing substrings separated by ,\ncharacters) consisting of the strings that have the corresponding bit\nin bits set. str1 corresponds to bit 0, str2 to bit 1, and so on. NULL\nvalues in str1, str2, ... are not appended to the result.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','mysql> SELECT MAKE_SET(1,\'a\',\'b\',\'c\');\n        -> \'a\'\nmysql> SELECT MAKE_SET(1 | 4,\'hello\',\'nice\',\'world\');\n        -> \'hello,world\'\nmysql> SELECT MAKE_SET(1 | 4,\'hello\',\'nice\',NULL,\'world\');\n        -> \'hello\'\nmysql> SELECT MAKE_SET(0,\'a\',\'b\',\'c\');\n        -> \'\'\n','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(207,'MID',15,'Syntax:\nMID(str,pos,len)\n\nMID(str,pos,len) is a synonym for SUBSTRING(str,pos,len).\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(208,'OCT',15,'Syntax:\nOCT(N)\n\nReturns a string representation of the octal value of N, where N is a\nlonglong (BIGINT) number. This is equivalent to CONV(N,10,8). Returns\nNULL if N is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','mysql> SELECT OCT(12);\n        -> \'14\'\n','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(209,'OCTET_LENGTH',15,'Syntax:\nOCTET_LENGTH(str)\n\nOCTET_LENGTH() is a synonym for LENGTH().\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(210,'ORD',15,'Syntax:\nORD(str)\n\nIf the leftmost character of the string str is a multibyte character,\nreturns the code for that character, calculated from the numeric values\nof its constituent bytes using this formula:\n\n  (1st byte code)\n+ (2nd byte code * 256)\n+ (3rd byte code * 256^2) ...\n\nIf the leftmost character is not a multibyte character, ORD() returns\nthe same value as the ASCII() function. The function returns NULL if\nstr is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','mysql> SELECT ORD(\'2\');\n        -> 50\n','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(211,'POSITION',15,'Syntax:\nPOSITION(substr IN str)\n\nPOSITION(substr IN str) is a synonym for LOCATE(substr,str).\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(212,'QUOTE',15,'Syntax:\nQUOTE(str)\n\nQuotes a string to produce a result that can be used as a properly\nescaped data value in an SQL statement. The string is returned enclosed\nby single quotation marks and with each instance of backslash (\\),\nsingle quote (\'), ASCII NUL, and Control+Z preceded by a backslash. If\nthe argument is NULL, the return value is the word \"NULL\" without\nenclosing single quotation marks.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','mysql> SELECT QUOTE(\'Don\\\'t!\');\n        -> \'Don\\\'t!\'\nmysql> SELECT QUOTE(NULL);\n        -> NULL\n','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(213,'REPEAT FUNCTION',15,'Syntax:\nREPEAT(str,count)\n\nReturns a string consisting of the string str repeated count times. If\ncount is less than 1, returns an empty string. Returns NULL if str or\ncount is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','mysql> SELECT REPEAT(\'MySQL\', 3);\n        -> \'MySQLMySQLMySQL\'\n','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(214,'REPLACE FUNCTION',15,'Syntax:\nREPLACE(str,from_str,to_str)\n\nReturns the string str with all occurrences of the string from_str\nreplaced by the string to_str. REPLACE() performs a case-sensitive\nmatch when searching for from_str.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','mysql> SELECT REPLACE(\'www.mysql.com\', \'w\', \'Ww\');\n        -> \'WwWwWw.mysql.com\'\n','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(215,'REVERSE',15,'Syntax:\nREVERSE(str)\n\nReturns the string str with the order of the characters reversed, or\nNULL if str is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','mysql> SELECT REVERSE(\'abc\');\n        -> \'cba\'\n','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(216,'RIGHT',15,'Syntax:\nRIGHT(str,len)\n\nReturns the rightmost len characters from the string str, or NULL if\nany argument is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','mysql> SELECT RIGHT(\'foobarbar\', 4);\n        -> \'rbar\'\n','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(217,'RPAD',15,'Syntax:\nRPAD(str,len,padstr)\n\nReturns the string str, right-padded with the string padstr to a length\nof len characters. If str is longer than len, the return value is\nshortened to len characters. If str, padstr, or len is NULL, the\nfunction returns NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','mysql> SELECT RPAD(\'hi\',5,\'?\');\n        -> \'hi???\'\nmysql> SELECT RPAD(\'hi\',1,\'?\');\n        -> \'h\'\n','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(218,'RTRIM',15,'Syntax:\nRTRIM(str)\n\nReturns the string str with trailing space characters removed.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','mysql> SELECT RTRIM(\'barbar   \');\n        -> \'barbar\'\n','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(219,'SOUNDEX',15,'Syntax:\nSOUNDEX(str)\n\nReturns a soundex string from str, or NULL if str is NULL. Two strings\nthat sound almost the same should have identical soundex strings. A\nstandard soundex string is four characters long, but the SOUNDEX()\nfunction returns an arbitrarily long string. You can use SUBSTRING() on\nthe result to get a standard soundex string. All nonalphabetic\ncharacters in str are ignored. All international alphabetic characters\noutside the A-Z range are treated as vowels.\n\n*Important*:\n\nWhen using SOUNDEX(), you should be aware of the following limitations:\n\no This function, as currently implemented, is intended to work well\n  with strings that are in the English language only. Strings in other\n  languages may not produce reliable results.\n\no This function is not guaranteed to provide consistent results with\n  strings that use multibyte character sets, including utf-8. See Bug\n  #22638 for more information.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','mysql> SELECT SOUNDEX(\'Hello\');\n        -> \'H400\'\nmysql> SELECT SOUNDEX(\'Quadratically\');\n        -> \'Q36324\'\n','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(220,'SOUNDS LIKE',15,'Syntax:\nexpr1 SOUNDS LIKE expr2\n\nThis is the same as SOUNDEX(expr1) = SOUNDEX(expr2).\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(221,'SPACE',15,'Syntax:\nSPACE(N)\n\nReturns a string consisting of N space characters, or NULL if N is\nNULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','mysql> SELECT SPACE(6);\n        -> \'      \'\n','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(222,'SUBSTR',15,'Syntax:\nSUBSTR(str,pos), SUBSTR(str FROM pos), SUBSTR(str,pos,len), SUBSTR(str\nFROM pos FOR len)\n\nSUBSTR() is a synonym for SUBSTRING().\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(223,'SUBSTRING',15,'Syntax:\nSUBSTRING(str,pos), SUBSTRING(str FROM pos), SUBSTRING(str,pos,len),\nSUBSTRING(str FROM pos FOR len)\n\nThe forms without a len argument return a substring from string str\nstarting at position pos. The forms with a len argument return a\nsubstring len characters long from string str, starting at position\npos. The forms that use FROM are standard SQL syntax. It is also\npossible to use a negative value for pos. In this case, the beginning\nof the substring is pos characters from the end of the string, rather\nthan the beginning. A negative value may be used for pos in any of the\nforms of this function. A value of 0 for pos returns an empty string.\n\nFor all forms of SUBSTRING(), the position of the first character in\nthe string from which the substring is to be extracted is reckoned as\n1.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','mysql> SELECT SUBSTRING(\'Quadratically\',5);\n        -> \'ratically\'\nmysql> SELECT SUBSTRING(\'foobarbar\' FROM 4);\n        -> \'barbar\'\nmysql> SELECT SUBSTRING(\'Quadratically\',5,6);\n        -> \'ratica\'\nmysql> SELECT SUBSTRING(\'Sakila\', -3);\n        -> \'ila\'\nmysql> SELECT SUBSTRING(\'Sakila\', -5, 3);\n        -> \'aki\'\nmysql> SELECT SUBSTRING(\'Sakila\' FROM -4 FOR 2);\n        -> \'ki\'\n','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(224,'SUBSTRING_INDEX',15,'Syntax:\nSUBSTRING_INDEX(str,delim,count)\n\nReturns the substring from string str before count occurrences of the\ndelimiter delim. If count is positive, everything to the left of the\nfinal delimiter (counting from the left) is returned. If count is\nnegative, everything to the right of the final delimiter (counting from\nthe right) is returned. SUBSTRING_INDEX() performs a case-sensitive\nmatch when searching for delim.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','mysql> SELECT SUBSTRING_INDEX(\'www.mysql.com\', \'.\', 2);\n        -> \'www.mysql\'\nmysql> SELECT SUBSTRING_INDEX(\'www.mysql.com\', \'.\', -2);\n        -> \'mysql.com\'\n','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(225,'TO_BASE64',15,'Syntax:\nTO_BASE64(str)\n\nConverts the string argument to base-64 encoded form and returns the\nresult as a character string with the connection character set and\ncollation. If the argument is not a string, it is converted to a string\nbefore conversion takes place. The result is NULL if the argument is\nNULL. Base-64 encoded strings can be decoded using the FROM_BASE64()\nfunction.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','mysql> SELECT TO_BASE64(\'abc\'), FROM_BASE64(TO_BASE64(\'abc\'));\n        -> \'JWJj\', \'abc\'\n','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(226,'TRIM',15,'Syntax:\nTRIM([{BOTH | LEADING | TRAILING} [remstr] FROM] str), TRIM([remstr\nFROM] str)\n\nReturns the string str with all remstr prefixes or suffixes removed. If\nnone of the specifiers BOTH, LEADING, or TRAILING is given, BOTH is\nassumed. remstr is optional and, if not specified, spaces are removed.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','mysql> SELECT TRIM(\'  bar   \');\n        -> \'bar\'\nmysql> SELECT TRIM(LEADING \'x\' FROM \'xxxbarxxx\');\n        -> \'barxxx\'\nmysql> SELECT TRIM(BOTH \'x\' FROM \'xxxbarxxx\');\n        -> \'bar\'\nmysql> SELECT TRIM(TRAILING \'xyz\' FROM \'barxxyz\');\n        -> \'barx\'\n','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(227,'UCASE',15,'Syntax:\nUCASE(str)\n\nUCASE() is a synonym for UPPER().\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(228,'UNHEX',15,'Syntax:\nUNHEX(str)\n\nFor a string argument str, UNHEX(str) interprets each pair of\ncharacters in the argument as a hexadecimal number and converts it to\nthe byte represented by the number. The return value is a binary\nstring.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','mysql> SELECT UNHEX(\'4D7953514C\');\n        -> \'MySQL\'\nmysql> SELECT X\'4D7953514C\';\n        -> \'MySQL\'\nmysql> SELECT UNHEX(HEX(\'string\'));\n        -> \'string\'\nmysql> SELECT HEX(UNHEX(\'1267\'));\n        -> \'1267\'\n','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(229,'UPPER',15,'Syntax:\nUPPER(str)\n\nReturns the string str with all characters changed to uppercase\naccording to the current character set mapping, or NULL if str is NULL.\nThe default character set is utf8mb4.\n\nmysql> SELECT UPPER(\'Hej\');\n        -> \'HEJ\'\n\nSee the description of LOWER() for information that also applies to\nUPPER(). This included information about how to perform lettercase\nconversion of binary strings (BINARY, VARBINARY, BLOB) for which these\nfunctions are ineffective, and information about case folding for\nUnicode character sets.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(230,'WEIGHT_STRING',15,'Syntax:\nWEIGHT_STRING(str [AS {CHAR|BINARY}(N)] [flags])\n\nThis function returns the weight string for the input string. The\nreturn value is a binary string that represents the comparison and\nsorting value of the string, or NULL if the argument is NULL. It has\nthese properties:\n\no If WEIGHT_STRING(str1) = WEIGHT_STRING(str2), then str1 = str2 (str1\n  and str2 are considered equal)\n\no If WEIGHT_STRING(str1) < WEIGHT_STRING(str2), then str1 < str2 (str1\n  sorts before str2)\n\nWEIGHT_STRING() is a debugging function intended for internal use. Its\nbehavior can change without notice between MySQL versions. It can be\nused for testing and debugging of collations, especially if you are\nadding a new collation. See\nhttps://dev.mysql.com/doc/refman/8.0/en/adding-collation.html.\n\nThis list briefly summarizes the arguments. More details are given in\nthe discussion following the list.\n\no str: The input string expression.\n\no AS clause: Optional; cast the input string to a given type and\n  length.\n\no flags: Optional; unused.\n\nThe input string, str, is a string expression. If the input is a\nnonbinary (character) string such as a CHAR, VARCHAR, or TEXT value,\nthe return value contains the collation weights for the string. If the\ninput is a binary (byte) string such as a BINARY, VARBINARY, or BLOB\nvalue, the return value is the same as the input (the weight for each\nbyte in a binary string is the byte value). If the input is NULL,\nWEIGHT_STRING() returns NULL.\n\nExamples:\n\nmysql> SET @s = _utf8mb4 \'AB\' COLLATE utf8mb4_0900_ai_ci;\nmysql> SELECT @s, HEX(@s), HEX(WEIGHT_STRING(@s));\n+------+---------+------------------------+\n| @s   | HEX(@s) | HEX(WEIGHT_STRING(@s)) |\n+------+---------+------------------------+\n| AB   | 4142    | 1C471C60               |\n+------+---------+------------------------+\n\nmysql> SET @s = _utf8mb4 \'ab\' COLLATE utf8mb4_0900_ai_ci;\nmysql> SELECT @s, HEX(@s), HEX(WEIGHT_STRING(@s));\n+------+---------+------------------------+\n| @s   | HEX(@s) | HEX(WEIGHT_STRING(@s)) |\n+------+---------+------------------------+\n| ab   | 6162    | 1C471C60               |\n+------+---------+------------------------+\n\nmysql> SET @s = CAST(\'AB\' AS BINARY);\nmysql> SELECT @s, HEX(@s), HEX(WEIGHT_STRING(@s));\n+------+---------+------------------------+\n| @s   | HEX(@s) | HEX(WEIGHT_STRING(@s)) |\n+------+---------+------------------------+\n| AB   | 4142    | 4142                   |\n+------+---------+------------------------+\n\nmysql> SET @s = CAST(\'ab\' AS BINARY);\nmysql> SELECT @s, HEX(@s), HEX(WEIGHT_STRING(@s));\n+------+---------+------------------------+\n| @s   | HEX(@s) | HEX(WEIGHT_STRING(@s)) |\n+------+---------+------------------------+\n| ab   | 6162    | 6162                   |\n+------+---------+------------------------+\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/string-functions.html'),(231,'LIKE',15,'Syntax:\nexpr LIKE pat [ESCAPE \'escape_char\']\n\nPattern matching using an SQL pattern. Returns 1 (TRUE) or 0 (FALSE).\nIf either expr or pat is NULL, the result is NULL.\n\nThe pattern need not be a literal string. For example, it can be\nspecified as a string expression or table column. In the latter case,\nthe column must be defined as one of the MySQL string types (see\nhttps://dev.mysql.com/doc/refman/8.0/en/string-types.html).\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-comparison-functions.html\n\n','mysql> SELECT \'David!\' LIKE \'David_\';\n        -> 1\nmysql> SELECT \'David!\' LIKE \'%D%v%\';\n        -> 1\n','https://dev.mysql.com/doc/refman/8.0/en/string-comparison-functions.html'),(232,'NOT LIKE',15,'Syntax:\nexpr NOT LIKE pat [ESCAPE \'escape_char\']\n\nThis is the same as NOT (expr LIKE pat [ESCAPE \'escape_char\']).\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-comparison-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/string-comparison-functions.html'),(233,'STRCMP',15,'Syntax:\nSTRCMP(expr1,expr2)\n\nSTRCMP() returns 0 if the strings are the same, -1 if the first\nargument is smaller than the second according to the current sort\norder, and NULL if either argument is NULL. It returns 1 otherwise.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/string-comparison-functions.html\n\n','mysql> SELECT STRCMP(\'text\', \'text2\');\n        -> -1\nmysql> SELECT STRCMP(\'text2\', \'text\');\n        -> 1\nmysql> SELECT STRCMP(\'text\', \'text\');\n        -> 0\n','https://dev.mysql.com/doc/refman/8.0/en/string-comparison-functions.html'),(234,'NOT REGEXP',15,'Syntax:\nexpr NOT REGEXP pat, expr NOT RLIKE pat\n\nThis is the same as NOT (expr REGEXP pat).\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/regexp.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/regexp.html'),(235,'REGEXP',15,'Syntax:\nexpr REGEXP pat, expr RLIKE pat\n\nReturns 1 if the string expr matches the regular expression specified\nby the pattern pat, 0 otherwise. If expr or pat is NULL, the return\nvalue is NULL.\n\nREGEXP and RLIKE are synonyms for REGEXP_LIKE().\n\nFor additional information about how matching occurs, see the\ndescription for REGEXP_LIKE().\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/regexp.html\n\n','mysql> SELECT \'Michael!\' REGEXP \'.*\';\n+------------------------+\n| \'Michael!\' REGEXP \'.*\' |\n+------------------------+\n|                      1 |\n+------------------------+\nmysql> SELECT \'new*\\n*line\' REGEXP \'new\\\\*.\\\\*line\';\n+---------------------------------------+\n| \'new*\\n*line\' REGEXP \'new\\\\*.\\\\*line\' |\n+---------------------------------------+\n|                                     0 |\n+---------------------------------------+\nmysql> SELECT \'a\' REGEXP \'^[a-d]\';\n+---------------------+\n| \'a\' REGEXP \'^[a-d]\' |\n+---------------------+\n|                   1 |\n+---------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/regexp.html'),(236,'REGEXP_INSTR',15,'REGEXP_INSTR(expr, pat[, pos[, occurrence[, return_option[,\nmatch_type]]]])\n\nReturns the starting index of the substring of the string expr that\nmatches the regular expression specified by the pattern pat, 0 if there\nis no match. If expr or pat is NULL, the return value is NULL.\nCharacter indexes begin at 1.\n\nREGEXP_INSTR() takes these optional arguments:\n\no pos: The position in expr at which to start the search. If omitted,\n  the default is 1.\n\no occurrence: Which occurrence of a match to search for. If omitted,\n  the default is 1.\n\no return_option: Which type of position to return. If this value is 0,\n  REGEXP_INSTR() returns the position of the matched substring\'s first\n  character. If this value is 1, REGEXP_INSTR() returns the position\n  following the matched substring. If omitted, the default is 0.\n\no match_type: A string that specifies how to perform matching. The\n  meaning is as described for REGEXP_LIKE().\n\nFor additional information about how matching occurs, see the\ndescription for REGEXP_LIKE().\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/regexp.html\n\n','mysql> SELECT REGEXP_INSTR(\'dog cat dog\', \'dog\');\n+------------------------------------+\n| REGEXP_INSTR(\'dog cat dog\', \'dog\') |\n+------------------------------------+\n|                                  1 |\n+------------------------------------+\nmysql> SELECT REGEXP_INSTR(\'dog cat dog\', \'dog\', 2);\n+---------------------------------------+\n| REGEXP_INSTR(\'dog cat dog\', \'dog\', 2) |\n+---------------------------------------+\n|                                     9 |\n+---------------------------------------+\nmysql> SELECT REGEXP_INSTR(\'aa aaa aaaa\', \'a{2}\');\n+-------------------------------------+\n| REGEXP_INSTR(\'aa aaa aaaa\', \'a{2}\') |\n+-------------------------------------+\n|                                   1 |\n+-------------------------------------+\nmysql> SELECT REGEXP_INSTR(\'aa aaa aaaa\', \'a{4}\');\n+-------------------------------------+\n| REGEXP_INSTR(\'aa aaa aaaa\', \'a{4}\') |\n+-------------------------------------+\n|                                   8 |\n+-------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/regexp.html'),(237,'REGEXP_LIKE',15,'REGEXP_LIKE(expr, pat[, match_type])\n\nReturns 1 if the string expr matches the regular expression specified\nby the pattern pat, 0 otherwise. If expr or pat is NULL, the return\nvalue is NULL.\n\nThe pattern can be an extended regular expression, the syntax for which\nis discussed in\nhttps://dev.mysql.com/doc/refman/8.0/en/regexp.html#regexp-syntax. The\npattern need not be a literal string. For example, it can be specified\nas a string expression or table column.\n\nThe optional match_type argument is a string that may contain any or\nall the following characters specifying how to perform matching:\n\no c: Case-sensitive matching.\n\no i: Case-insensitive matching.\n\no m: Multiple-line mode. Recognize line terminators within the string.\n  The default behavior is to match line terminators only at the start\n  and end of the string expression.\n\no n: The . character matches line terminators. The default is for .\n  matching to stop at the end of a line.\n\no u: Unix-only line endings. Only the newline character is recognized\n  as a line ending by the ., ^, and $ match operators.\n\nIf characters specifying contradictory options are specified within\nmatch_type, the rightmost one takes precedence.\n\nBy default, regular expression operations use the character set and\ncollation of the expr and pat arguments when deciding the type of a\ncharacter and performing the comparison. If the arguments have\ndifferent character sets or collations, coercibility rules apply as\ndescribed in\nhttps://dev.mysql.com/doc/refman/8.0/en/charset-collation-coercibility.\nhtml. Arguments may be specified with explicit collation indicators to\nchange comparison behavior.\n\nmysql> SELECT REGEXP_LIKE(\'CamelCase\', \'CAMELCASE\');\n+---------------------------------------+\n| REGEXP_LIKE(\'CamelCase\', \'CAMELCASE\') |\n+---------------------------------------+\n|                                     1 |\n+---------------------------------------+\nmysql> SELECT REGEXP_LIKE(\'CamelCase\', \'CAMELCASE\' COLLATE utf8mb4_0900_as_cs);\n+------------------------------------------------------------------+\n| REGEXP_LIKE(\'CamelCase\', \'CAMELCASE\' COLLATE utf8mb4_0900_as_cs) |\n+------------------------------------------------------------------+\n|                                                                0 |\n+------------------------------------------------------------------+\n\nmatch_type may be specified with the c or i characters to override the\ndefault case sensitivity. Exception: If either argument is a binary\nstring, the arguments are handled in case-sensitive fashion as binary\nstrings, even if match_type contains the i character.\n\n*Note*:\n\nMySQL uses C escape syntax in strings (for example, \\n to represent the\nnewline character). If you want your expr or pat argument to contain a\nliteral \\, you must double it. (Unless the NO_BACKSLASH_ESCAPES SQL\nmode is enabled, in which case no escape character is used.)\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/regexp.html\n\n','mysql> SELECT REGEXP_LIKE(\'Michael!\', \'.*\');\n+-------------------------------+\n| REGEXP_LIKE(\'Michael!\', \'.*\') |\n+-------------------------------+\n|                             1 |\n+-------------------------------+\nmysql> SELECT REGEXP_LIKE(\'new*\\n*line\', \'new\\\\*.\\\\*line\');\n+----------------------------------------------+\n| REGEXP_LIKE(\'new*\\n*line\', \'new\\\\*.\\\\*line\') |\n+----------------------------------------------+\n|                                            0 |\n+----------------------------------------------+\nmysql> SELECT REGEXP_LIKE(\'a\', \'^[a-d]\');\n+----------------------------+\n| REGEXP_LIKE(\'a\', \'^[a-d]\') |\n+----------------------------+\n|                          1 |\n+----------------------------+\n\nmysql> SELECT REGEXP_LIKE(\'abc\', \'ABC\');\n+---------------------------+\n| REGEXP_LIKE(\'abc\', \'ABC\') |\n+---------------------------+\n|                         1 |\n+---------------------------+\nmysql> SELECT REGEXP_LIKE(\'abc\', \'ABC\', \'c\');\n+--------------------------------+\n| REGEXP_LIKE(\'abc\', \'ABC\', \'c\') |\n+--------------------------------+\n|                              0 |\n+--------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/regexp.html'),(238,'REGEXP_REPLACE',15,'REGEXP_REPLACE(expr, pat, repl[, pos[, occurrence[, match_type]]])\n\nReplaces occurrences in the string expr that match the regular\nexpression specified by the pattern pat with the replacement string\nrepl, and returns the resulting string. If expr, pat, or repl is NULL,\nthe return value is NULL.\n\nREGEXP_REPLACE() takes these optional arguments:\n\no pos: The position in expr at which to start the search. If omitted,\n  the default is 1.\n\no occurrence: Which occurrence of a match to replace. If omitted, the\n  default is 0 (which means \"replace all occurrences\").\n\no match_type: A string that specifies how to perform matching. The\n  meaning is as described for REGEXP_LIKE().\n\nPrior to MySQL 8.0.17, the result returned by this function used the\nUTF-16 character set; in MySQL 8.0.17 and later, the character set and\ncollation of the expression searched for matches is used. (Bug #94203,\nBug #29308212)\n\nFor additional information about how matching occurs, see the\ndescription for REGEXP_LIKE().\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/regexp.html\n\n','mysql> SELECT REGEXP_REPLACE(\'a b c\', \'b\', \'X\');\n+-----------------------------------+\n| REGEXP_REPLACE(\'a b c\', \'b\', \'X\') |\n+-----------------------------------+\n| a X c                             |\n+-----------------------------------+\nmysql> SELECT REGEXP_REPLACE(\'abc def ghi\', \'[a-z]+\', \'X\', 1, 3);\n+----------------------------------------------------+\n| REGEXP_REPLACE(\'abc def ghi\', \'[a-z]+\', \'X\', 1, 3) |\n+----------------------------------------------------+\n| abc def X                                          |\n+----------------------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/regexp.html'),(239,'REGEXP_SUBSTR',15,'REGEXP_SUBSTR(expr, pat[, pos[, occurrence[, match_type]]])\n\nReturns the substring of the string expr that matches the regular\nexpression specified by the pattern pat, NULL if there is no match. If\nexpr or pat is NULL, the return value is NULL.\n\nREGEXP_SUBSTR() takes these optional arguments:\n\no pos: The position in expr at which to start the search. If omitted,\n  the default is 1.\n\no occurrence: Which occurrence of a match to search for. If omitted,\n  the default is 1.\n\no match_type: A string that specifies how to perform matching. The\n  meaning is as described for REGEXP_LIKE().\n\nPrior to MySQL 8.0.17, the result returned by this function used the\nUTF-16 character set; in MySQL 8.0.17 and later, the character set and\ncollation of the expression searched for matches is used. (Bug #94203,\nBug #29308212)\n\nFor additional information about how matching occurs, see the\ndescription for REGEXP_LIKE().\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/regexp.html\n\n','mysql> SELECT REGEXP_SUBSTR(\'abc def ghi\', \'[a-z]+\');\n+----------------------------------------+\n| REGEXP_SUBSTR(\'abc def ghi\', \'[a-z]+\') |\n+----------------------------------------+\n| abc                                    |\n+----------------------------------------+\nmysql> SELECT REGEXP_SUBSTR(\'abc def ghi\', \'[a-z]+\', 1, 3);\n+----------------------------------------------+\n| REGEXP_SUBSTR(\'abc def ghi\', \'[a-z]+\', 1, 3) |\n+----------------------------------------------+\n| ghi                                          |\n+----------------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/regexp.html'),(240,'MATCH AGAINST',15,'Syntax:\nMATCH (col1,col2,...) AGAINST (expr [search_modifier])\n\nMySQL has support for full-text indexing and searching:\n\no A full-text index in MySQL is an index of type FULLTEXT.\n\no Full-text indexes can be used only with InnoDB or MyISAM tables, and\n  can be created only for CHAR, VARCHAR, or TEXT columns.\n\no MySQL provides a built-in full-text ngram parser that supports\n  Chinese, Japanese, and Korean (CJK), and an installable MeCab\n  full-text parser plugin for Japanese. Parsing differences are\n  outlined in\n  https://dev.mysql.com/doc/refman/8.0/en/fulltext-search-ngram.html,\n  and\n  https://dev.mysql.com/doc/refman/8.0/en/fulltext-search-mecab.html.\n\no A FULLTEXT index definition can be given in the CREATE TABLE\n  statement when a table is created, or added later using ALTER TABLE\n  or CREATE INDEX.\n\no For large data sets, it is much faster to load your data into a table\n  that has no FULLTEXT index and then create the index after that, than\n  to load data into a table that has an existing FULLTEXT index.\n\nFull-text searching is performed using MATCH() AGAINST() syntax.\nMATCH() takes a comma-separated list that names the columns to be\nsearched. AGAINST takes a string to search for, and an optional\nmodifier that indicates what type of search to perform. The search\nstring must be a string value that is constant during query evaluation.\nThis rules out, for example, a table column because that can differ for\neach row.\n\nPreviously, MySQL permitted the use of a rollup column with MATCH(),\nbut queries employing this construct performed poorly and with\nunreliable results. (This is due to the fact that MATCH() is not\nimplemented as a function of its arguments, but rather as a function of\nthe row ID of the current row in the underlying scan of the base\ntable.) As of MySQL 8.0.28, MySQL no longer allows such queries; more\nspecifically, any query matching all of the criteria listed here is\nrejected with ER_FULLTEXT_WITH_ROLLUP\n(https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference.html\n#error_er_fulltext_with_rollup):\n\no MATCH() appears in the SELECT list, GROUP BY clause, HAVING clause,\n  or ORDER BY clause of a query block.\n\no The query block contains a GROUP BY ... WITH ROLLUP clause.\n\no The argument of the call to the MATCH() function is one of the\n  grouping columns.\n\nSome examples of such queries are shown here:\n\n# MATCH() in SELECT list...\nSELECT MATCH (a) AGAINST (\'abc\') FROM t GROUP BY a WITH ROLLUP;\nSELECT 1 FROM t GROUP BY a, MATCH (a) AGAINST (\'abc\') WITH ROLLUP;\n\n# ...in HAVING clause...\nSELECT 1 FROM t GROUP BY a WITH ROLLUP HAVING MATCH (a) AGAINST (\'abc\');\n\n# ...and in ORDER BY clause\nSELECT 1 FROM t GROUP BY a WITH ROLLUP ORDER BY MATCH (a) AGAINST (\'abc\');\n\nThe use of MATCH() with a rollup column in the WHERE clause is\npermitted.\n\nThere are three types of full-text searches:\n\no A natural language search interprets the search string as a phrase in\n  natural human language (a phrase in free text). There are no special\n  operators, with the exception of double quote (\") characters. The\n  stopword list applies. For more information about stopword lists, see\n  https://dev.mysql.com/doc/refman/8.0/en/fulltext-stopwords.html.\n\n  Full-text searches are natural language searches if the IN NATURAL\n  LANGUAGE MODE modifier is given or if no modifier is given. For more\n  information, see\n  https://dev.mysql.com/doc/refman/8.0/en/fulltext-natural-language.htm\n  l.\n\no A boolean search interprets the search string using the rules of a\n  special query language. The string contains the words to search for.\n  It can also contain operators that specify requirements such that a\n  word must be present or absent in matching rows, or that it should be\n  weighted higher or lower than usual. Certain common words (stopwords)\n  are omitted from the search index and do not match if present in the\n  search string. The IN BOOLEAN MODE modifier specifies a boolean\n  search. For more information, see\n  https://dev.mysql.com/doc/refman/8.0/en/fulltext-boolean.html.\n\no A query expansion search is a modification of a natural language\n  search. The search string is used to perform a natural language\n  search. Then words from the most relevant rows returned by the search\n  are added to the search string and the search is done again. The\n  query returns the rows from the second search. The IN NATURAL\n  LANGUAGE MODE WITH QUERY EXPANSION or WITH QUERY EXPANSION modifier\n  specifies a query expansion search. For more information, see\n  https://dev.mysql.com/doc/refman/8.0/en/fulltext-query-expansion.html\n  .\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/fulltext-search.html\n\n','mysql> SELECT id, body, MATCH (title,body)\n    ->   AGAINST (\'Security implications of running MySQL as root\'\n    ->   IN NATURAL LANGUAGE MODE) AS score\n    -> FROM articles\n    ->   WHERE MATCH (title,body) \n    ->   AGAINST(\'Security implications of running MySQL as root\'\n    ->   IN NATURAL LANGUAGE MODE);\n+----+-------------------------------------+-----------------+\n| id | body                                | score           |\n+----+-------------------------------------+-----------------+\n|  4 | 1. Never run mysqld as root. 2. ... | 1.5219271183014 |\n|  6 | When configured properly, MySQL ... | 1.3114095926285 |\n+----+-------------------------------------+-----------------+\n2 rows in set (0.00 sec)\n','https://dev.mysql.com/doc/refman/8.0/en/fulltext-search.html'),(241,'BINARY OPERATOR',16,'Syntax:\nBINARY expr\n\nThe BINARY operator converts the expression to a binary string (a\nstring that has the binary character set and binary collation). A\ncommon use for BINARY is to force a character string comparison to be\ndone byte by byte using numeric byte values rather than character by\ncharacter. The BINARY operator also causes trailing spaces in\ncomparisons to be significant. For information about the differences\nbetween the binary collation of the binary character set and the _bin\ncollations of nonbinary character sets, see\nhttps://dev.mysql.com/doc/refman/8.0/en/charset-binary-collations.html.\n\nThe BINARY operator is deprecated as of MySQL 8.0.27, and you should\nexpect its removal in a future version of MySQL. Use CAST(... AS\nBINARY) instead.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/cast-functions.html\n\n','mysql> SELECT \'a\' = \'A\';\n        -> 1\nmysql> SELECT BINARY \'a\' = \'A\';\n        -> 0\nmysql> SELECT \'a\' = \'a \';\n        -> 1\nmysql> SELECT BINARY \'a\' = \'a \';\n        -> 0\n','https://dev.mysql.com/doc/refman/8.0/en/cast-functions.html'),(242,'CAST',16,'Syntax:\nCAST(expr AS type [ARRAY])\n\nCAST(timestamp_value AT TIME ZONE timezone_specifier AS\nDATETIME[(precision)])\n\ntimezone_specifier: [INTERVAL] \'+00:00\' | \'UTC\'\n\nWith CAST(expr AS type syntax, the CAST() function takes an expression\nof any type and produces a result value of the specified type. This\noperation may also be expressed as CONVERT(expr, type), which is\nequivalent. If expr is NULL, CAST() returns NULL.\n\nThese type values are permitted:\n\no BINARY[(N)]\n\n  Produces a string with the VARBINARY data type, except that when the\n  expression expr is empty (zero length), the result type is BINARY(0).\n  If the optional length N is given, BINARY(N) causes the cast to use\n  no more than N bytes of the argument. Values shorter than N bytes are\n  padded with 0x00 bytes to a length of N. If the optional length N is\n  not given, MySQL calculates the maximum length from the expression.\n  If the supplied or calculated length is greater than an internal\n  threshold, the result type is BLOB. If the length is still too long,\n  the result type is LONGBLOB.\n\n  For a description of how casting to BINARY affects comparisons, see\n  https://dev.mysql.com/doc/refman/8.0/en/binary-varbinary.html.\n\no CHAR[(N)] [charset_info]\n\n  Produces a string with the VARCHAR data type. except that when the\n  expression expr is empty (zero length), the result type is CHAR(0).\n  If the optional length N is given, CHAR(N) causes the cast to use no\n  more than N characters of the argument. No padding occurs for values\n  shorter than N characters. If the optional length N is not given,\n  MySQL calculates the maximum length from the expression. If the\n  supplied or calculated length is greater than an internal threshold,\n  the result type is TEXT. If the length is still too long, the result\n  type is LONGTEXT.\n\n  With no charset_info clause, CHAR produces a string with the default\n  character set. To specify the character set explicitly, these\n  charset_info values are permitted:\n\n  o CHARACTER SET charset_name: Produces a string with the given\n    character set.\n\n  o ASCII: Shorthand for CHARACTER SET latin1.\n\n  o UNICODE: Shorthand for CHARACTER SET ucs2.\n\n  In all cases, the string has the character set default collation.\n\no DATE\n\n  Produces a DATE value.\n\no DATETIME[(M)]\n\n  Produces a DATETIME value. If the optional M value is given, it\n  specifies the fractional seconds precision.\n\no DECIMAL[(M[,D])]\n\n  Produces a DECIMAL value. If the optional M and D values are given,\n  they specify the maximum number of digits (the precision) and the\n  number of digits following the decimal point (the scale). If D is\n  omitted, 0 is assumed. If M is omitted, 10 is assumed.\n\no DOUBLE\n\n  Produces a DOUBLE result. Added in MySQL 8.0.17.\n\no FLOAT[(p)]\n\n  If the precision p is not specified, produces a result of type FLOAT.\n  If p is provided and 0 <= < p <= 24, the result is of type FLOAT. If\n  25 <= p <= 53, the result is of type DOUBLE. If p < 0 or p > 53, an\n  error is returned. Added in MySQL 8.0.17.\n\no JSON\n\n  Produces a JSON value. For details on the rules for conversion of\n  values between JSON and other types, see\n  https://dev.mysql.com/doc/refman/8.0/en/json.html#json-comparison.\n\no NCHAR[(N)]\n\n  Like CHAR, but produces a string with the national character set. See\n  https://dev.mysql.com/doc/refman/8.0/en/charset-national.html.\n\n  Unlike CHAR, NCHAR does not permit trailing character set information\n  to be specified.\n\no REAL\n\n  Produces a result of type REAL. This is actually FLOAT if the\n  REAL_AS_FLOAT SQL mode is enabled; otherwise the result is of type\n  DOUBLE.\n\no SIGNED [INTEGER]\n\n  Produces a signed BIGINT value.\n\no spatial_type\n\n  As of MySQL 8.0.24, CAST() and CONVERT() support casting geometry\n  values from one spatial type to another, for certain combinations of\n  spatial types. For details, see\n  https://dev.mysql.com/doc/refman/8.0/en/cast-functions.html#cast-spat\n  ial-types.\n\no TIME[(M)]\n\n  Produces a TIME value. If the optional M value is given, it specifies\n  the fractional seconds precision.\n\no UNSIGNED [INTEGER]\n\n  Produces an unsigned BIGINT value.\n\no YEAR\n\n  Produces a YEAR value. Added in MySQL 8.0.22. These rules govern\n  conversion to YEAR:\n\n  o For a four-digit number in the range 1901-2155 inclusive, or for a\n    string which can be interpreted as a four-digit number in this\n    range, return the corresponding YEAR value.\n\n  o For a number consisting of one or two digits, or for a string which\n    can be interpreted as such a number, return a YEAR value as\n    follows:\n\n    o If the number is in the range 1-69 inclusive, add 2000 and return\n      the sum.\n\n    o If the number is in the range 70-99 inclusive, add 1900 and\n      return the sum.\n\n  o For a string which evaluates to 0, return 2000.\n\n  o For the number 0, return 0.\n\n  o For a DATE, DATETIME, or TIMESTAMP value, return the YEAR portion\n    of the value. For a TIME value, return the current year.\n\n    If you do not specify the type of a TIME argument, you may get a\n    different result from what you expect, as shown here:\n\nmysql> SELECT CAST(\"11:35:00\" AS YEAR), CAST(TIME \"11:35:00\" AS YEAR);\n+--------------------------+-------------------------------+\n| CAST(\"11:35:00\" AS YEAR) | CAST(TIME \"11:35:00\" AS YEAR) |\n+--------------------------+-------------------------------+\n|                     2011 |                          2021 |\n+--------------------------+-------------------------------+\n\n  o If the argument is of type DECIMAL, DOUBLE, DECIMAL, or REAL, round\n    the value to the nearest integer, then attempt to cast the value to\n    YEAR using the rules for integer values, as shown here:\n\nmysql> SELECT CAST(1944.35 AS YEAR), CAST(1944.50 AS YEAR);\n+-----------------------+-----------------------+\n| CAST(1944.35 AS YEAR) | CAST(1944.50 AS YEAR) |\n+-----------------------+-----------------------+\n|                  1944 |                  1945 |\n+-----------------------+-----------------------+\n\nmysql> SELECT CAST(66.35 AS YEAR), CAST(66.50 AS YEAR);\n+---------------------+---------------------+\n| CAST(66.35 AS YEAR) | CAST(66.50 AS YEAR) |\n+---------------------+---------------------+\n|                2066 |                2067 |\n+---------------------+---------------------+\n\n  o An argument of type GEOMETRY cannot be converted to YEAR.\n\n  o For a value that cannot be successfully converted to YEAR, return\n    NULL.\n\n  A string value containing non-numeric characters which must be\n  truncated prior to conversion raises a warning, as shown here:\n\nmysql> SELECT CAST(\"1979aaa\" AS YEAR);\n+-------------------------+\n| CAST(\"1979aaa\" AS YEAR) |\n+-------------------------+\n|                    1979 |\n+-------------------------+\n1 row in set, 1 warning (0.00 sec)\n\nmysql> SHOW WARNINGS;\n+---------+------+-------------------------------------------+\n| Level   | Code | Message                                   |\n+---------+------+-------------------------------------------+\n| Warning | 1292 | Truncated incorrect YEAR value: \'1979aaa\' |\n+---------+------+-------------------------------------------+\n\nIn MySQL 8.0.17 and higher, InnoDB allows the use of an additional\nARRAY keyword for creating a multi-valued index on a JSON array as part\nof CREATE INDEX, CREATE TABLE, and ALTER TABLE statements. ARRAY is not\nsupported except when used to create a multi-valued index in one of\nthese statements, in which case it is required. The column being\nindexed must be a column of type JSON. With ARRAY, the type following\nthe AS keyword may specify any of the types supported by CAST(), with\nthe exceptions of BINARY, JSON, and YEAR. For syntax information and\nexamples, as well as other relevant information, see\nhttps://dev.mysql.com/doc/refman/8.0/en/create-index.html#create-index-\nmulti-valued.\n\n*Note*:\n\nCONVERT(), unlike CAST(), does not support multi-valued index creation\nor the ARRAY keyword.\n\nBeginning with MySQL 8.0.22, CAST() supports retrieval of a TIMESTAMP\nvalue as being in UTC, using the AT TIMEZONE operator. The only\nsupported time zone is UTC; this can be specified as either of \'+00:00\'\nor \'UTC\'. The only return type supported by this syntax is DATETIME,\nwith an optional precision specifier in the range of 0 to 6, inclusive.\n\nTIMESTAMP values that use timezone offsets are also supported.\n\nmysql> SELECT @@system_time_zone;\n+--------------------+\n| @@system_time_zone |\n+--------------------+\n| EDT                |\n+--------------------+\n1 row in set (0.00 sec)\n\nmysql> CREATE TABLE TZ (c TIMESTAMP);\nQuery OK, 0 rows affected (0.41 sec)\n\nmysql> INSERT INTO tz VALUES\n    ->     ROW(CURRENT_TIMESTAMP),\n    ->     ROW(\'2020-07-28 14:50:15+1:00\');\nQuery OK, 1 row affected (0.08 sec)\n\nmysql> TABLE tz;\n+---------------------+\n| c                   |\n+---------------------+\n| 2020-07-28 09:22:41 |\n| 2020-07-28 09:50:15 |\n+---------------------+\n2 rows in set (0.00 sec)\n\nmysql> SELECT CAST(c AT TIME ZONE \'+00:00\' AS DATETIME) AS u FROM tz;\n+---------------------+\n| u                   |\n+---------------------+\n| 2020-07-28 13:22:41 |\n| 2020-07-28 13:50:15 |\n+---------------------+\n2 rows in set (0.00 sec)\n\nmysql> SELECT CAST(c AT TIME ZONE \'UTC\' AS DATETIME(2)) AS u FROM tz;\n+------------------------+\n| u                      |\n+------------------------+\n| 2020-07-28 13:22:41.00 |\n| 2020-07-28 13:50:15.00 |\n+------------------------+\n2 rows in set (0.00 sec)\n\nIf you use \'UTC\' as the time zone specifier with this form of CAST(),\nand the server raises an error such as Unknown or incorrect time zone:\n\'UTC\', you may need to install the MySQL time zone tables (see\nhttps://dev.mysql.com/doc/refman/8.0/en/time-zone-support.html#time-zon\ne-installation).\n\nAT TIME ZONE does not support the ARRAY keyword, and is not supported\nby the CONVERT() function.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/cast-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/cast-functions.html'),(243,'CONVERT',16,'Syntax:\nCONVERT(expr USING transcoding_name)\n\nCONVERT(expr,type)\n\nCONVERT(expr USING transcoding_name) is standard SQL syntax. The\nnon-USING form of CONVERT() is ODBC syntax. Regardless of the syntax\nused, the function returns NULL if expr is NULL.\n\nCONVERT(expr USING transcoding_name) converts data between different\ncharacter sets. In MySQL, transcoding names are the same as the\ncorresponding character set names. For example, this statement converts\nthe string \'abc\' in the default character set to the corresponding\nstring in the utf8mb4 character set:\n\nSELECT CONVERT(\'abc\' USING utf8mb4);\n\nCONVERT(expr, type) syntax (without USING) takes an expression and a\ntype value specifying a result type, and produces a result value of the\nspecified type. This operation may also be expressed as CAST(expr AS\ntype), which is equivalent. For more information, see the description\nof CAST().\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/cast-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/cast-functions.html'),(244,'EXTRACTVALUE',17,'Syntax:\nExtractValue(xml_frag, xpath_expr)\n\nExtractValue() takes two string arguments, a fragment of XML markup\nxml_frag and an XPath expression xpath_expr (also known as a locator);\nit returns the text (CDATA) of the first text node which is a child of\nthe element or elements matched by the XPath expression.\n\nUsing this function is the equivalent of performing a match using the\nxpath_expr after appending /text(). In other words,\nExtractValue(\'<a><b>Sakila</b></a>\', \'/a/b\') and\nExtractValue(\'<a><b>Sakila</b></a>\', \'/a/b/text()\') produce the same\nresult. If xml_frag or xpath_expr is NULL, the function returns NULL.\n\nIf multiple matches are found, the content of the first child text node\nof each matching element is returned (in the order matched) as a\nsingle, space-delimited string.\n\nIf no matching text node is found for the expression (including the\nimplicit /text())---for whatever reason, as long as xpath_expr is\nvalid, and xml_frag consists of elements which are properly nested and\nclosed---an empty string is returned. No distinction is made between a\nmatch on an empty element and no match at all. This is by design.\n\nIf you need to determine whether no matching element was found in\nxml_frag or such an element was found but contained no child text\nnodes, you should test the result of an expression that uses the XPath\ncount() function. For example, both of these statements return an empty\nstring, as shown here:\n\nmysql> SELECT ExtractValue(\'<a><b/></a>\', \'/a/b\');\n+-------------------------------------+\n| ExtractValue(\'<a><b/></a>\', \'/a/b\') |\n+-------------------------------------+\n|                                     |\n+-------------------------------------+\n1 row in set (0.00 sec)\n\nmysql> SELECT ExtractValue(\'<a><c/></a>\', \'/a/b\');\n+-------------------------------------+\n| ExtractValue(\'<a><c/></a>\', \'/a/b\') |\n+-------------------------------------+\n|                                     |\n+-------------------------------------+\n1 row in set (0.00 sec)\n\nHowever, you can determine whether there was actually a matching\nelement using the following:\n\nmysql> SELECT ExtractValue(\'<a><b/></a>\', \'count(/a/b)\');\n+-------------------------------------+\n| ExtractValue(\'<a><b/></a>\', \'count(/a/b)\') |\n+-------------------------------------+\n| 1                                   |\n+-------------------------------------+\n1 row in set (0.00 sec)\n\nmysql> SELECT ExtractValue(\'<a><c/></a>\', \'count(/a/b)\');\n+-------------------------------------+\n| ExtractValue(\'<a><c/></a>\', \'count(/a/b)\') |\n+-------------------------------------+\n| 0                                   |\n+-------------------------------------+\n1 row in set (0.01 sec)\n\n*Important*:\n\nExtractValue() returns only CDATA, and does not return any tags that\nmight be contained within a matching tag, nor any of their content (see\nthe result returned as val1 in the following example).\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/xml-functions.html\n\n','mysql> SELECT\n    ->   ExtractValue(\'<a>ccc<b>ddd</b></a>\', \'/a\') AS val1,\n    ->   ExtractValue(\'<a>ccc<b>ddd</b></a>\', \'/a/b\') AS val2,\n    ->   ExtractValue(\'<a>ccc<b>ddd</b></a>\', \'//b\') AS val3,\n    ->   ExtractValue(\'<a>ccc<b>ddd</b></a>\', \'/b\') AS val4,\n    ->   ExtractValue(\'<a>ccc<b>ddd</b><b>eee</b></a>\', \'//b\') AS val5;\n\n+------+------+------+------+---------+\n| val1 | val2 | val3 | val4 | val5    |\n+------+------+------+------+---------+\n| ccc  | ddd  | ddd  |      | ddd eee |\n+------+------+------+------+---------+\n','https://dev.mysql.com/doc/refman/8.0/en/xml-functions.html'),(245,'UPDATEXML',17,'Syntax:\nUpdateXML(xml_target, xpath_expr, new_xml)\n\nThis function replaces a single portion of a given fragment of XML\nmarkup xml_target with a new XML fragment new_xml, and then returns the\nchanged XML. The portion of xml_target that is replaced matches an\nXPath expression xpath_expr supplied by the user.\n\nIf no expression matching xpath_expr is found, or if multiple matches\nare found, the function returns the original xml_target XML fragment.\nAll three arguments should be strings. If any of the arguments to\nUpdateXML() are NULL, the function returns NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/xml-functions.html\n\n','mysql> SELECT\n    ->   UpdateXML(\'<a><b>ccc</b><d></d></a>\', \'/a\', \'<e>fff</e>\') AS val1,\n    ->   UpdateXML(\'<a><b>ccc</b><d></d></a>\', \'/b\', \'<e>fff</e>\') AS val2,\n    ->   UpdateXML(\'<a><b>ccc</b><d></d></a>\', \'//b\', \'<e>fff</e>\') AS val3,\n    ->   UpdateXML(\'<a><b>ccc</b><d></d></a>\', \'/a/d\', \'<e>fff</e>\') AS val4,\n    ->   UpdateXML(\'<a><d></d><b>ccc</b><d></d></a>\', \'/a/d\', \'<e>fff</e>\') AS val5\n    -> \\G\n\n*************************** 1. row ***************************\nval1: <e>fff</e>\nval2: <a><b>ccc</b><d></d></a>\nval3: <a><e>fff</e><d></d></a>\nval4: <a><b>ccc</b><e>fff</e></a>\nval5: <a><d></d><b>ccc</b><d></d></a>\n','https://dev.mysql.com/doc/refman/8.0/en/xml-functions.html'),(246,'|',18,'Syntax:\n|\n\nBitwise OR.\n\nThe result type depends on whether the arguments are evaluated as\nbinary strings or numbers:\n\no Binary-string evaluation occurs when the arguments have a binary\n  string type, and at least one of them is not a hexadecimal literal,\n  bit literal, or NULL literal. Numeric evaluation occurs otherwise,\n  with argument conversion to unsigned 64-bit integers as necessary.\n\no Binary-string evaluation produces a binary string of the same length\n  as the arguments. If the arguments have unequal lengths, an\n  ER_INVALID_BITWISE_OPERANDS_SIZE\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_invalid_bitwise_operands_size) error occurs. Numeric\n  evaluation produces an unsigned 64-bit integer.\n\nFor more information, see the introductory discussion in this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/bit-functions.html\n\n','mysql> SELECT 29 | 15;\n        -> 31\nmysql> SELECT _binary X\'40404040\' | X\'01020304\';\n        -> \'ABCD\'\n','https://dev.mysql.com/doc/refman/8.0/en/bit-functions.html'),(247,'&',18,'Syntax:\n&\n\nBitwise AND.\n\nThe result type depends on whether the arguments are evaluated as\nbinary strings or numbers:\n\no Binary-string evaluation occurs when the arguments have a binary\n  string type, and at least one of them is not a hexadecimal literal,\n  bit literal, or NULL literal. Numeric evaluation occurs otherwise,\n  with argument conversion to unsigned 64-bit integers as necessary.\n\no Binary-string evaluation produces a binary string of the same length\n  as the arguments. If the arguments have unequal lengths, an\n  ER_INVALID_BITWISE_OPERANDS_SIZE\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_invalid_bitwise_operands_size) error occurs. Numeric\n  evaluation produces an unsigned 64-bit integer.\n\nFor more information, see the introductory discussion in this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/bit-functions.html\n\n','mysql> SELECT 29 & 15;\n        -> 13\nmysql> SELECT HEX(_binary X\'FF\' & b\'11110000\');\n        -> \'F0\'\n','https://dev.mysql.com/doc/refman/8.0/en/bit-functions.html'),(248,'^',18,'Syntax:\n^\n\nBitwise XOR.\n\nThe result type depends on whether the arguments are evaluated as\nbinary strings or numbers:\n\no Binary-string evaluation occurs when the arguments have a binary\n  string type, and at least one of them is not a hexadecimal literal,\n  bit literal, or NULL literal. Numeric evaluation occurs otherwise,\n  with argument conversion to unsigned 64-bit integers as necessary.\n\no Binary-string evaluation produces a binary string of the same length\n  as the arguments. If the arguments have unequal lengths, an\n  ER_INVALID_BITWISE_OPERANDS_SIZE\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_invalid_bitwise_operands_size) error occurs. Numeric\n  evaluation produces an unsigned 64-bit integer.\n\nFor more information, see the introductory discussion in this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/bit-functions.html\n\n','mysql> SELECT 1 ^ 1;\n        -> 0\nmysql> SELECT 1 ^ 0;\n        -> 1\nmysql> SELECT 11 ^ 3;\n        -> 8\nmysql> SELECT HEX(_binary X\'FEDC\' ^ X\'1111\');\n        -> \'EFCD\'\n','https://dev.mysql.com/doc/refman/8.0/en/bit-functions.html'),(249,'<<',18,'Syntax:\n<<\n\nShifts a longlong (BIGINT) number or binary string to the left.\n\nThe result type depends on whether the bit argument is evaluated as a\nbinary string or number:\n\no Binary-string evaluation occurs when the bit argument has a binary\n  string type, and is not a hexadecimal literal, bit literal, or NULL\n  literal. Numeric evaluation occurs otherwise, with argument\n  conversion to an unsigned 64-bit integer as necessary.\n\no Binary-string evaluation produces a binary string of the same length\n  as the bit argument. Numeric evaluation produces an unsigned 64-bit\n  integer.\n\nBits shifted off the end of the value are lost without warning,\nregardless of the argument type. In particular, if the shift count is\ngreater or equal to the number of bits in the bit argument, all bits in\nthe result are 0.\n\nFor more information, see the introductory discussion in this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/bit-functions.html\n\n','mysql> SELECT 1 << 2;\n        -> 4\nmysql> SELECT HEX(_binary X\'00FF00FF00FF\' << 8);\n        -> \'FF00FF00FF00\'\n','https://dev.mysql.com/doc/refman/8.0/en/bit-functions.html'),(250,'>>',18,'Syntax:\n>>\n\nShifts a longlong (BIGINT) number or binary string to the right.\n\nThe result type depends on whether the bit argument is evaluated as a\nbinary string or number:\n\no Binary-string evaluation occurs when the bit argument has a binary\n  string type, and is not a hexadecimal literal, bit literal, or NULL\n  literal. Numeric evaluation occurs otherwise, with argument\n  conversion to an unsigned 64-bit integer as necessary.\n\no Binary-string evaluation produces a binary string of the same length\n  as the bit argument. Numeric evaluation produces an unsigned 64-bit\n  integer.\n\nBits shifted off the end of the value are lost without warning,\nregardless of the argument type. In particular, if the shift count is\ngreater or equal to the number of bits in the bit argument, all bits in\nthe result are 0.\n\nFor more information, see the introductory discussion in this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/bit-functions.html\n\n','mysql> SELECT 4 >> 2;\n        -> 1\nmysql> SELECT HEX(_binary X\'00FF00FF00FF\' >> 8);\n        -> \'0000FF00FF00\'\n','https://dev.mysql.com/doc/refman/8.0/en/bit-functions.html'),(251,'~',18,'Syntax:\n~\n\nInvert all bits.\n\nThe result type depends on whether the bit argument is evaluated as a\nbinary string or number:\n\no Binary-string evaluation occurs when the bit argument has a binary\n  string type, and is not a hexadecimal literal, bit literal, or NULL\n  literal. Numeric evaluation occurs otherwise, with argument\n  conversion to an unsigned 64-bit integer as necessary.\n\no Binary-string evaluation produces a binary string of the same length\n  as the bit argument. Numeric evaluation produces an unsigned 64-bit\n  integer.\n\nFor more information, see the introductory discussion in this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/bit-functions.html\n\n','mysql> SELECT 5 & ~1;\n        -> 4\nmysql> SELECT HEX(~X\'0000FFFF1111EEEE\');\n        -> \'FFFF0000EEEE1111\'\n','https://dev.mysql.com/doc/refman/8.0/en/bit-functions.html'),(252,'BIT_COUNT',18,'Syntax:\nBIT_COUNT(N)\n\nReturns the number of bits that are set in the argument N as an\nunsigned 64-bit integer, or NULL if the argument is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/bit-functions.html\n\n','mysql> SELECT BIT_COUNT(64), BIT_COUNT(BINARY 64);\n        -> 1, 7\nmysql> SELECT BIT_COUNT(\'64\'), BIT_COUNT(_binary \'64\');\n        -> 1, 7\nmysql> SELECT BIT_COUNT(X\'40\'), BIT_COUNT(_binary X\'40\');\n        -> 1, 1\n','https://dev.mysql.com/doc/refman/8.0/en/bit-functions.html'),(253,'AES_DECRYPT',19,'Syntax:\nAES_DECRYPT(crypt_str,key_str[,init_vector][,kdf_name][,salt][,info |\niterations])\n\nThis function decrypts data using the official AES (Advanced Encryption\nStandard) algorithm. For more information, see the description of\nAES_ENCRYPT().\n\nStatements that use AES_DECRYPT() are unsafe for statement-based\nreplication.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/encryption-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/encryption-functions.html'),(254,'AES_ENCRYPT',19,'Syntax:\nAES_ENCRYPT(str,key_str[,init_vector][,kdf_name][,salt][,info |\niterations])\n\nAES_ENCRYPT() and AES_DECRYPT() implement encryption and decryption of\ndata using the official AES (Advanced Encryption Standard) algorithm,\npreviously known as \"Rijndael.\" The AES standard permits various key\nlengths. By default these functions implement AES with a 128-bit key\nlength. Key lengths of 196 or 256 bits can be used, as described later.\nThe key length is a trade off between performance and security.\n\nAES_ENCRYPT() encrypts the string str using the key string key_str, and\nreturns a binary string containing the encrypted output. AES_DECRYPT()\ndecrypts the encrypted string crypt_str using the key string key_str,\nand returns the original plaintext string. If either function argument\nis NULL, the function returns NULL. If AES_DECRYPT() detects invalid\ndata or incorrect padding, it returns NULL. However, it is possible for\nAES_DECRYPT() to return a non-NULL value (possibly garbage) if the\ninput data or the key is invalid.\n\nFrom MySQL 8.0.30, the functions support the use of a key derivation\nfunction (KDF) to create a cryptographically strong secret key from the\ninformation passed in key_str. The derived key is used to encrypt and\ndecrypt the data, and it remains in the MySQL Server instance and is\nnot accessible to users. Using a KDF is highly recommended, as it\nprovides better security than specifying your own premade key or\nderiving it by a simpler method as you use the function. The functions\nsupport HKDF (available from OpenSSL 1.1.0), for which you can specify\nan optional salt and context-specific information to include in the\nkeying material, and PBKDF2 (available from OpenSSL 1.0.2), for which\nyou can specify an optional salt and set the number of iterations used\nto produce the key.\n\nAES_ENCRYPT() and AES_DECRYPT() permit control of the block encryption\nmode. The block_encryption_mode system variable controls the mode for\nblock-based encryption algorithms. Its default value is aes-128-ecb,\nwhich signifies encryption using a key length of 128 bits and ECB mode.\nFor a description of the permitted values of this variable, see\nhttps://dev.mysql.com/doc/refman/8.0/en/server-system-variables.html.\nThe optional init_vector argument is used to provide an initialization\nvector for block encryption modes that require it.\n\nStatements that use AES_ENCRYPT() or AES_DECRYPT() are unsafe for\nstatement-based replication.\n\nIf AES_ENCRYPT() is invoked from within the mysql client, binary\nstrings display using hexadecimal notation, depending on the value of\nthe --binary-as-hex. For more information about that option, see\nhttps://dev.mysql.com/doc/refman/8.0/en/mysql.html.\n\nThe arguments for the AES_ENCRYPT() and AES_DECRYPT() functions are as\nfollows:\n\no str\n\n  The string for AES_ENCRYPT() to encrypt using the key string key_str,\n  or (from MySQL 8.0.30) the key derived from it by the specified KDF.\n  The string can be any length. Padding is automatically added to str\n  so it is a multiple of a block as required by block-based algorithms\n  such as AES. This padding is automatically removed by the\n  AES_DECRYPT() function.\n\no crypt_str\n\n  The encrypted string for AES_DECRYPT() to decrypt using the key\n  string key_str, or (from MySQL 8.0.30) the key derived from it by the\n  specified KDF. The string can be any length. The length of crypt_str\n  can be calculated from the length of the original string using this\n  formula:\n\n16 * (trunc(string_length / 16) + 1)\n\no key_str\n\n  The encryption key, or the input keying material that is used as the\n  basis for deriving a key using a key derivation function (KDF). For\n  the same instance of data, use the same value of key_str for\n  encryption with AES_ENCRYPT() and decryption with AES_DECRYPT().\n\n  If you are using a KDF, which you can from MySQL 8.0.30, key_str can\n  be any arbitrary information such as a password or passphrase. In the\n  further arguments for the function, you specify the KDF name, then\n  add further options to increase the security as appropriate for the\n  KDF.\n\n  When you use a KDF, the function creates a cryptographically strong\n  secret key from the information passed in key_str and any salt or\n  additional information that you provide in the other arguments. The\n  derived key is used to encrypt and decrypt the data, and it remains\n  in the MySQL Server instance and is not accessible to users. Using a\n  KDF is highly recommended, as it provides better security than\n  specifying your own premade key or deriving it by a simpler method as\n  you use the function.\n\n  If you are not using a KDF, for a key length of 128 bits, the most\n  secure way to pass a key to the key_str argument is to create a truly\n  random 128-bit value and pass it as a binary value. For example:\n\nINSERT INTO t\nVALUES (1,AES_ENCRYPT(\'text\',UNHEX(\'F3229A0B371ED2D9441B830D21A390C3\')));\n\n  A passphrase can be used to generate an AES key by hashing the\n  passphrase. For example:\n\nINSERT INTO t\nVALUES (1,AES_ENCRYPT(\'text\', UNHEX(SHA2(\'My secret passphrase\',512))));\n\n  If you exceed the maximum key length of 128 bits, a warning is\n  returned. If you are not using a KDF, do not pass a password or\n  passphrase directly to key_str, hash it first. Previous versions of\n  this documentation suggested the former approach, but it is no longer\n  recommended as the examples shown here are more secure.\n\no init_vector\n\n  An initialization vector, for block encryption modes that require it.\n  The block_encryption_mode system variable controls the mode. For the\n  same instance of data, use the same value of init_vector for\n  encryption with AES_ENCRYPT() and decryption with AES_DECRYPT().\n\n  *Note*:\n\n  If you are using a KDF, you must specify an initialization vector or\n  a null string for this argument, in order to access the later\n  arguments to define the KDF.\n\n  For modes that require an initialization vector, it must be 16 bytes\n  or longer (bytes in excess of 16 are ignored). An error occurs if\n  init_vector is missing. For modes that do not require an\n  initialization vector, it is ignored and a warning is generated if\n  init_vector is specified, unless you are using a KDF.\n\n  The default value for the block_encryption_mode system variable is\n  aes-128-ecb, or ECB mode, which does not require an initialization\n  vector. The alternative permitted block encryption modes CBC, CFB1,\n  CFB8, CFB128, and OFB all require an initialization vector.\n\n  A random string of bytes to use for the initialization vector can be\n  produced by calling RANDOM_BYTES(16).\n\no kdf_name\n\n  The name of the key derivation function (KDF) to create a key from\n  the input keying material passed in key_str, and other arguments as\n  appropriate for the KDF. This optional argument is available from\n  MySQL 8.0.30.\n\n  For the same instance of data, use the same value of kdf_name for\n  encryption with AES_ENCRYPT() and decryption with AES_DECRYPT(). When\n  you specify kdf_name, you must specify init_vector, using either a\n  valid initialization vector, or a null string if the encryption mode\n  does not require an initialization vector.\n\n  The following values are supported:\n\n  o hkdf\n\n    HKDF, which is available from OpenSSL 1.1.0. HKDF extracts a\n    pseudorandom key from the keying material then expands it into\n    additional keys. With HKDF, you can specify an optional salt (salt)\n    and context-specific information such as application details (info)\n    to include in the keying material.\n\n  o pbkdf2_hmac\n\n    PBKDF2, which is available from OpenSSL 1.0.2. PBKDF2 applies a\n    pseudorandom function to the keying material, and repeats this\n    process a large number of times to produce the key. With PBKDF2,\n    you can specify an optional salt (salt) to include in the keying\n    material, and set the number of iterations used to produce the key\n    (iterations).\n\n  In this example, HKDF is specified as the key derivation function,\n  and a salt and context information are provided. The argument for the\n  initialization vector is included but is the empty string:\n\nSELECT AES_ENCRYPT(\'mytext\',\'mykeystring\', \'\', \'hkdf\', \'salt\', \'info\');\n\n  In this example, PBKDF2 is specified as the key derivation function,\n  a salt is provided, and the number of iterations is doubled from the\n  recommended minimum:\n\nSELECT AES_ENCRYPT(\'mytext\',\'mykeystring\', \'\', \'pbkdf2_hmac\',\'salt\', \'2000\');\n\no salt\n\n  A salt to be passed to the key derivation function (KDF). This\n  optional argument is available from MySQL 8.0.30. Both HKDF and\n  PBKDF2 can use salts, and their use is recommended to help prevent\n  attacks based on dictionaries of common passwords or rainbow tables.\n\n  A salt consists of random data, which for security must be different\n  for each encryption operation. A random string of bytes to use for\n  the salt can be produced by calling RANDOM_BYTES(). This example\n  produces a 64-bit salt:\n\nSET @salt = RANDOM_BYTES(8);\n\n  For the same instance of data, use the same value of salt for\n  encryption with AES_ENCRYPT() and decryption with AES_DECRYPT(). The\n  salt can safely be stored along with the encrypted data.\n\no info\n\n  Context-specific information for HKDF to include in the keying\n  material, such as information about the application. This optional\n  argument is available from MySQL 8.0.30 when you specify hkdf as the\n  KDF name. HKDF adds this information to the keying material specified\n  in key_str and the salt specified in salt to produce the key.\n\n  For the same instance of data, use the same value of info for\n  encryption with AES_ENCRYPT() and decryption with AES_DECRYPT().\n\no iterations\n\n  The iteration count for PBKDF2 to use when producing the key. This\n  optional argument is available from MySQL 8.0.30 when you specify\n  pbkdf2_hmac as the KDF name. A higher count gives greater resistance\n  to brute-force attacks because it has a greater computational cost\n  for the attacker, but the same is necessarily true for the key\n  derivation process. The default if you do not specify this argument\n  is 1000, which is the minimum recommended by the OpenSSL standard.\n\n  For the same instance of data, use the same value of iterations for\n  encryption with AES_ENCRYPT() and decryption with AES_DECRYPT().\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/encryption-functions.html\n\n','mysql> SET block_encryption_mode = \'aes-256-cbc\';\nmysql> SET @key_str = SHA2(\'My secret passphrase\',512);\nmysql> SET @init_vector = RANDOM_BYTES(16);\nmysql> SET @crypt_str = AES_ENCRYPT(\'text\',@key_str,@init_vector);\nmysql> SELECT AES_DECRYPT(@crypt_str,@key_str,@init_vector);\n+-----------------------------------------------+\n| AES_DECRYPT(@crypt_str,@key_str,@init_vector) |\n+-----------------------------------------------+\n| text                                          |\n+-----------------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/encryption-functions.html'),(255,'COMPRESS',19,'Syntax:\nCOMPRESS(string_to_compress)\n\nCompresses a string and returns the result as a binary string. This\nfunction requires MySQL to have been compiled with a compression\nlibrary such as zlib. Otherwise, the return value is always NULL. The\nreturn value is also NULL if string_to_compress is NULL. The compressed\nstring can be uncompressed with UNCOMPRESS().\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/encryption-functions.html\n\n','mysql> SELECT LENGTH(COMPRESS(REPEAT(\'a\',1000)));\n        -> 21\nmysql> SELECT LENGTH(COMPRESS(\'\'));\n        -> 0\nmysql> SELECT LENGTH(COMPRESS(\'a\'));\n        -> 13\nmysql> SELECT LENGTH(COMPRESS(REPEAT(\'a\',16)));\n        -> 15\n','https://dev.mysql.com/doc/refman/8.0/en/encryption-functions.html'),(256,'MD5',19,'Syntax:\nMD5(str)\n\nCalculates an MD5 128-bit checksum for the string. The value is\nreturned as a string of 32 hexadecimal digits, or NULL if the argument\nwas NULL. The return value can, for example, be used as a hash key. See\nthe notes at the beginning of this section about storing hash values\nefficiently.\n\nThe return value is a string in the connection character set.\n\nIf FIPS mode is enabled, MD5() returns NULL. See\nhttps://dev.mysql.com/doc/refman/8.0/en/fips-mode.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/encryption-functions.html\n\n','mysql> SELECT MD5(\'testing\');\n        -> \'ae2b1fca515949e5d54fb22b8ed95575\'\n','https://dev.mysql.com/doc/refman/8.0/en/encryption-functions.html'),(257,'RANDOM_BYTES',19,'Syntax:\nRANDOM_BYTES(len)\n\nThis function returns a binary string of len random bytes generated\nusing the random number generator of the SSL library. Permitted values\nof len range from 1 to 1024. For values outside that range, an error\noccurs. Returns NULL if len is NULL.\n\nRANDOM_BYTES() can be used to provide the initialization vector for the\nAES_DECRYPT() and AES_ENCRYPT() functions. For use in that context, len\nmust be at least 16. Larger values are permitted, but bytes in excess\nof 16 are ignored.\n\nRANDOM_BYTES() generates a random value, which makes its result\nnondeterministic. Consequently, statements that use this function are\nunsafe for statement-based replication.\n\nIf RANDOM_BYTES() is invoked from within the mysql client, binary\nstrings display using hexadecimal notation, depending on the value of\nthe --binary-as-hex. For more information about that option, see\nhttps://dev.mysql.com/doc/refman/8.0/en/mysql.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/encryption-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/encryption-functions.html'),(258,'SHA1',19,'Syntax:\nSHA1(str), SHA(str)\n\nCalculates an SHA-1 160-bit checksum for the string, as described in\nRFC 3174 (Secure Hash Algorithm). The value is returned as a string of\n40 hexadecimal digits, or NULL if the argument is NULL. One of the\npossible uses for this function is as a hash key. See the notes at the\nbeginning of this section about storing hash values efficiently. SHA()\nis synonymous with SHA1().\n\nThe return value is a string in the connection character set.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/encryption-functions.html\n\n','mysql> SELECT SHA1(\'abc\');\n        -> \'a9993e364706816aba3e25717850c26c9cd0d89d\'\n','https://dev.mysql.com/doc/refman/8.0/en/encryption-functions.html'),(259,'SHA2',19,'Syntax:\nSHA2(str, hash_length)\n\nCalculates the SHA-2 family of hash functions (SHA-224, SHA-256,\nSHA-384, and SHA-512). The first argument is the plaintext string to be\nhashed. The second argument indicates the desired bit length of the\nresult, which must have a value of 224, 256, 384, 512, or 0 (which is\nequivalent to 256). If either argument is NULL or the hash length is\nnot one of the permitted values, the return value is NULL. Otherwise,\nthe function result is a hash value containing the desired number of\nbits. See the notes at the beginning of this section about storing hash\nvalues efficiently.\n\nThe return value is a string in the connection character set.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/encryption-functions.html\n\n','mysql> SELECT SHA2(\'abc\', 224);\n        -> \'23097d223405d8228642a477bda255b32aadbce4bda0b3f7e36c9da7\'\n','https://dev.mysql.com/doc/refman/8.0/en/encryption-functions.html'),(260,'STATEMENT_DIGEST',19,'STATEMENT_DIGEST(statement)\n\nGiven an SQL statement as a string, returns the statement digest hash\nvalue as a string in the connection character set, or NULL if the\nargument is NULL. The related STATEMENT_DIGEST_TEXT() function returns\nthe normalized statement digest. For information about statement\ndigesting, see\nhttps://dev.mysql.com/doc/refman/8.0/en/performance-schema-statement-di\ngests.html.\n\nBoth functions use the MySQL parser to parse the statement. If parsing\nfails, an error occurs. The error message includes the parse error only\nif the statement is provided as a literal string.\n\nThe max_digest_length system variable determines the maximum number of\nbytes available to these functions for computing normalized statement\ndigests.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/encryption-functions.html\n\n','mysql> SET @stmt = \'SELECT * FROM mytable WHERE cola = 10 AND colb = 20\';\nmysql> SELECT STATEMENT_DIGEST(@stmt);\n+------------------------------------------------------------------+\n| STATEMENT_DIGEST(@stmt)                                          |\n+------------------------------------------------------------------+\n| 3bb95eeade896657c4526e74ff2a2862039d0a0fe8a9e7155b5fe492cbd78387 |\n+------------------------------------------------------------------+\nmysql> SELECT STATEMENT_DIGEST_TEXT(@stmt);\n+----------------------------------------------------------+\n| STATEMENT_DIGEST_TEXT(@stmt)                             |\n+----------------------------------------------------------+\n| SELECT * FROM `mytable` WHERE `cola` = ? AND `colb` = ?  |\n+----------------------------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/encryption-functions.html'),(261,'STATEMENT_DIGEST_TEXT',19,'STATEMENT_DIGEST_TEXT(statement)\n\nGiven an SQL statement as a string, returns the normalized statement\ndigest as a string in the connection character set, or NULL if the\nargument is NULL. For additional discussion and examples, see the\ndescription of the related STATEMENT_DIGEST() function.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/encryption-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/encryption-functions.html'),(262,'UNCOMPRESS',19,'Syntax:\nUNCOMPRESS(string_to_uncompress)\n\nUncompresses a string compressed by the COMPRESS() function. If the\nargument is not a compressed value, the result is NULL; if\nstring_to_uncompress is NULL, the result is also NULL. This function\nrequires MySQL to have been compiled with a compression library such as\nzlib. Otherwise, the return value is always NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/encryption-functions.html\n\n','mysql> SELECT UNCOMPRESS(COMPRESS(\'any string\'));\n        -> \'any string\'\nmysql> SELECT UNCOMPRESS(\'any string\');\n        -> NULL\n','https://dev.mysql.com/doc/refman/8.0/en/encryption-functions.html'),(263,'UNCOMPRESSED_LENGTH',19,'Syntax:\nUNCOMPRESSED_LENGTH(compressed_string)\n\nReturns the length that the compressed string had before being\ncompressed. Returns NULL if compressed_string is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/encryption-functions.html\n\n','mysql> SELECT UNCOMPRESSED_LENGTH(COMPRESS(REPEAT(\'a\',30)));\n        -> 30\n','https://dev.mysql.com/doc/refman/8.0/en/encryption-functions.html'),(264,'VALIDATE_PASSWORD_STRENGTH',19,'Syntax:\nVALIDATE_PASSWORD_STRENGTH(str)\n\nGiven an argument representing a plaintext password, this function\nreturns an integer to indicate how strong the password is, or NULL if\nthe argument is NULL. The return value ranges from 0 (weak) to 100\n(strong).\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/encryption-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/encryption-functions.html'),(265,'GET_LOCK',20,'Syntax:\nGET_LOCK(str,timeout)\n\nTries to obtain a lock with a name given by the string str, using a\ntimeout of timeout seconds. A negative timeout value means infinite\ntimeout. The lock is exclusive. While held by one session, other\nsessions cannot obtain a lock of the same name.\n\nReturns 1 if the lock was obtained successfully, 0 if the attempt timed\nout (for example, because another client has previously locked the\nname), or NULL if an error occurred (such as running out of memory or\nthe thread was killed with mysqladmin kill).\n\nA lock obtained with GET_LOCK() is released explicitly by executing\nRELEASE_LOCK() or implicitly when your session terminates (either\nnormally or abnormally). Locks obtained with GET_LOCK() are not\nreleased when transactions commit or roll back.\n\nGET_LOCK() is implemented using the metadata locking (MDL) subsystem.\nMultiple simultaneous locks can be acquired and GET_LOCK() does not\nrelease any existing locks. For example, suppose that you execute these\nstatements:\n\nSELECT GET_LOCK(\'lock1\',10);\nSELECT GET_LOCK(\'lock2\',10);\nSELECT RELEASE_LOCK(\'lock2\');\nSELECT RELEASE_LOCK(\'lock1\');\n\nThe second GET_LOCK() acquires a second lock and both RELEASE_LOCK()\ncalls return 1 (success).\n\nIt is even possible for a given session to acquire multiple locks for\nthe same name. Other sessions cannot acquire a lock with that name\nuntil the acquiring session releases all its locks for the name.\n\nUniquely named locks acquired with GET_LOCK() appear in the Performance\nSchema metadata_locks table. The OBJECT_TYPE column says USER LEVEL\nLOCK and the OBJECT_NAME column indicates the lock name. In the case\nthat multiple locks are acquired for the same name, only the first lock\nfor the name registers a row in the metadata_locks table. Subsequent\nlocks for the name increment a counter in the lock but do not acquire\nadditional metadata locks. The metadata_locks row for the lock is\ndeleted when the last lock instance on the name is released.\n\nThe capability of acquiring multiple locks means there is the\npossibility of deadlock among clients. When this happens, the server\nchooses a caller and terminates its lock-acquisition request with an\nER_USER_LOCK_DEADLOCK\n(https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference.html\n#error_er_user_lock_deadlock) error. This error does not cause\ntransactions to roll back.\n\nMySQL enforces a maximum length on lock names of 64 characters.\n\nGET_LOCK() can be used to implement application locks or to simulate\nrecord locks. Names are locked on a server-wide basis. If a name has\nbeen locked within one session, GET_LOCK() blocks any request by\nanother session for a lock with the same name. This enables clients\nthat agree on a given lock name to use the name to perform cooperative\nadvisory locking. But be aware that it also enables a client that is\nnot among the set of cooperating clients to lock a name, either\ninadvertently or deliberately, and thus prevent any of the cooperating\nclients from locking that name. One way to reduce the likelihood of\nthis is to use lock names that are database-specific or\napplication-specific. For example, use lock names of the form\ndb_name.str or app_name.str.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/locking-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/locking-functions.html'),(266,'IS_FREE_LOCK',20,'Syntax:\nIS_FREE_LOCK(str)\n\nChecks whether the lock named str is free to use (that is, not locked).\nReturns 1 if the lock is free (no one is using the lock), 0 if the lock\nis in use, and NULL if an error occurs (such as an incorrect argument).\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/locking-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/locking-functions.html'),(267,'IS_USED_LOCK',20,'Syntax:\nIS_USED_LOCK(str)\n\nChecks whether the lock named str is in use (that is, locked). If so,\nit returns the connection identifier of the client session that holds\nthe lock. Otherwise, it returns NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/locking-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/locking-functions.html'),(268,'RELEASE_ALL_LOCKS',20,'Syntax:\nRELEASE_ALL_LOCKS()\n\nReleases all named locks held by the current session and returns the\nnumber of locks released (0 if there were none)\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/locking-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/locking-functions.html'),(269,'RELEASE_LOCK',20,'Syntax:\nRELEASE_LOCK(str)\n\nReleases the lock named by the string str that was obtained with\nGET_LOCK(). Returns 1 if the lock was released, 0 if the lock was not\nestablished by this thread (in which case the lock is not released),\nand NULL if the named lock did not exist. The lock does not exist if it\nwas never obtained by a call to GET_LOCK() or if it has previously been\nreleased.\n\nThe DO statement is convenient to use with RELEASE_LOCK(). See [HELP\nDO].\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/locking-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/locking-functions.html'),(270,'BENCHMARK',21,'Syntax:\nBENCHMARK(count,expr)\n\nThe BENCHMARK() function executes the expression expr repeatedly count\ntimes. It may be used to time how quickly MySQL processes the\nexpression. The result value is 0, or NULL for inappropriate arguments\nsuch as a NULL or negative repeat count.\n\nThe intended use is from within the mysql client, which reports query\nexecution times:\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/information-functions.html\n\n','mysql> SELECT BENCHMARK(1000000,AES_ENCRYPT(\'hello\',\'goodbye\'));\n+---------------------------------------------------+\n| BENCHMARK(1000000,AES_ENCRYPT(\'hello\',\'goodbye\')) |\n+---------------------------------------------------+\n|                                                 0 |\n+---------------------------------------------------+\n1 row in set (4.74 sec)\n','https://dev.mysql.com/doc/refman/8.0/en/information-functions.html'),(271,'CHARSET',21,'Syntax:\nCHARSET(str)\n\nReturns the character set of the string argument, or NULL if the\nargument is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/information-functions.html\n\n','mysql> SELECT CHARSET(\'abc\');\n        -> \'utf8mb3\'\nmysql> SELECT CHARSET(CONVERT(\'abc\' USING latin1));\n        -> \'latin1\'\nmysql> SELECT CHARSET(USER());\n        -> \'utf8mb3\'\n','https://dev.mysql.com/doc/refman/8.0/en/information-functions.html'),(272,'COERCIBILITY',21,'Syntax:\nCOERCIBILITY(str)\n\nReturns the collation coercibility value of the string argument.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/information-functions.html\n\n','mysql> SELECT COERCIBILITY(\'abc\' COLLATE utf8mb4_swedish_ci);\n        -> 0\nmysql> SELECT COERCIBILITY(USER());\n        -> 3\nmysql> SELECT COERCIBILITY(\'abc\');\n        -> 4\nmysql> SELECT COERCIBILITY(1000);\n        -> 5\n','https://dev.mysql.com/doc/refman/8.0/en/information-functions.html'),(273,'COLLATION',21,'Syntax:\nCOLLATION(str)\n\nReturns the collation of the string argument.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/information-functions.html\n\n','mysql> SELECT COLLATION(\'abc\');\n        -> \'utf8mb4_0900_ai_ci\'\nmysql> SELECT COLLATION(_utf8mb4\'abc\');\n        -> \'utf8mb4_0900_ai_ci\'\nmysql> SELECT COLLATION(_latin1\'abc\');\n        -> \'latin1_swedish_ci\'\n','https://dev.mysql.com/doc/refman/8.0/en/information-functions.html'),(274,'CONNECTION_ID',21,'Syntax:\nCONNECTION_ID()\n\nReturns the connection ID (thread ID) for the connection. Every\nconnection has an ID that is unique among the set of currently\nconnected clients.\n\nThe value returned by CONNECTION_ID() is the same type of value as\ndisplayed in the ID column of the Information Schema PROCESSLIST table,\nthe Id column of SHOW PROCESSLIST output, and the PROCESSLIST_ID column\nof the Performance Schema threads table.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/information-functions.html\n\n','mysql> SELECT CONNECTION_ID();\n        -> 23786\n','https://dev.mysql.com/doc/refman/8.0/en/information-functions.html'),(275,'CURRENT_ROLE',21,'CURRENT_ROLE()\n\nReturns a utf8mb3 string containing the current active roles for the\ncurrent session, separated by commas, or NONE if there are none. The\nvalue reflects the setting of the sql_quote_show_create system\nvariable.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/information-functions.html\n\n','GRANT \'r1\', \'r2\' TO \'u1\'@\'localhost\';\nSET DEFAULT ROLE ALL TO \'u1\'@\'localhost\';\n\nmysql> SELECT CURRENT_ROLE();\n+-------------------+\n| CURRENT_ROLE()    |\n+-------------------+\n| `r1`@`%`,`r2`@`%` |\n+-------------------+\nmysql> SET ROLE \'r1\'; SELECT CURRENT_ROLE();\n+----------------+\n| CURRENT_ROLE() |\n+----------------+\n| `r1`@`%`       |\n+----------------+\n','https://dev.mysql.com/doc/refman/8.0/en/information-functions.html'),(276,'CURRENT_USER',21,'Syntax:\nCURRENT_USER, CURRENT_USER()\n\nReturns the user name and host name combination for the MySQL account\nthat the server used to authenticate the current client. This account\ndetermines your access privileges. The return value is a string in the\nutf8mb3 character set.\n\nThe value of CURRENT_USER() can differ from the value of USER().\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/information-functions.html\n\n','mysql> SELECT USER();\n        -> \'davida@localhost\'\nmysql> SELECT * FROM mysql.user;\nERROR 1044: Access denied for user \'\'@\'localhost\' to\ndatabase \'mysql\'\nmysql> SELECT CURRENT_USER();\n        -> \'@localhost\'\n','https://dev.mysql.com/doc/refman/8.0/en/information-functions.html'),(277,'DATABASE',21,'Syntax:\nDATABASE()\n\nReturns the default (current) database name as a string in the utf8mb3\ncharacter set. If there is no default database, DATABASE() returns\nNULL. Within a stored routine, the default database is the database\nthat the routine is associated with, which is not necessarily the same\nas the database that is the default in the calling context.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/information-functions.html\n\n','mysql> SELECT DATABASE();\n        -> \'test\'\n','https://dev.mysql.com/doc/refman/8.0/en/information-functions.html'),(278,'FOUND_ROWS',21,'Syntax:\nFOUND_ROWS()\n\n*Note*:\n\nThe SQL_CALC_FOUND_ROWS query modifier and accompanying FOUND_ROWS()\nfunction are deprecated as of MySQL 8.0.17; expect them to be removed\nin a future version of MySQL. As a replacement, considering executing\nyour query with LIMIT, and then a second query with COUNT(*) and\nwithout LIMIT to determine whether there are additional rows. For\nexample, instead of these queries:\n\nSELECT SQL_CALC_FOUND_ROWS * FROM tbl_name WHERE id > 100 LIMIT 10;\nSELECT FOUND_ROWS();\n\nUse these queries instead:\n\nSELECT * FROM tbl_name WHERE id > 100 LIMIT 10;\nSELECT COUNT(*) FROM tbl_name WHERE id > 100;\n\nCOUNT(*) is subject to certain optimizations. SQL_CALC_FOUND_ROWS\ncauses some optimizations to be disabled.\n\nA SELECT statement may include a LIMIT clause to restrict the number of\nrows the server returns to the client. In some cases, it is desirable\nto know how many rows the statement would have returned without the\nLIMIT, but without running the statement again. To obtain this row\ncount, include an SQL_CALC_FOUND_ROWS option in the SELECT statement,\nand then invoke FOUND_ROWS() afterward:\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/information-functions.html\n\n','mysql> SELECT SQL_CALC_FOUND_ROWS * FROM tbl_name\n    -> WHERE id > 100 LIMIT 10;\nmysql> SELECT FOUND_ROWS();\n','https://dev.mysql.com/doc/refman/8.0/en/information-functions.html'),(279,'ICU_VERSION',21,'ICU_VERSION()\n\nThe version of the International Components for Unicode (ICU) library\nused to support regular expression operations (see\nhttps://dev.mysql.com/doc/refman/8.0/en/regexp.html). This function is\nprimarily intended for use in test cases.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/information-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/information-functions.html'),(280,'LAST_INSERT_ID',21,'Syntax:\nLAST_INSERT_ID(), LAST_INSERT_ID(expr)\n\nWith no argument, LAST_INSERT_ID() returns a BIGINT UNSIGNED (64-bit)\nvalue representing the first automatically generated value successfully\ninserted for an AUTO_INCREMENT column as a result of the most recently\nexecuted INSERT statement. The value of LAST_INSERT_ID() remains\nunchanged if no rows are successfully inserted.\n\nWith an argument, LAST_INSERT_ID() returns an unsigned integer, or NULL\nif the argument is NULL.\n\nFor example, after inserting a row that generates an AUTO_INCREMENT\nvalue, you can get the value like this:\n\nmysql> SELECT LAST_INSERT_ID();\n        -> 195\n\nThe currently executing statement does not affect the value of\nLAST_INSERT_ID(). Suppose that you generate an AUTO_INCREMENT value\nwith one statement, and then refer to LAST_INSERT_ID() in a\nmultiple-row INSERT statement that inserts rows into a table with its\nown AUTO_INCREMENT column. The value of LAST_INSERT_ID() remains stable\nin the second statement; its value for the second and later rows is not\naffected by the earlier row insertions. (You should be aware that, if\nyou mix references to LAST_INSERT_ID() and LAST_INSERT_ID(expr), the\neffect is undefined.)\n\nIf the previous statement returned an error, the value of\nLAST_INSERT_ID() is undefined. For transactional tables, if the\nstatement is rolled back due to an error, the value of LAST_INSERT_ID()\nis left undefined. For manual ROLLBACK, the value of LAST_INSERT_ID()\nis not restored to that before the transaction; it remains as it was at\nthe point of the ROLLBACK.\n\nWithin the body of a stored routine (procedure or function) or a\ntrigger, the value of LAST_INSERT_ID() changes the same way as for\nstatements executed outside the body of these kinds of objects. The\neffect of a stored routine or trigger upon the value of\nLAST_INSERT_ID() that is seen by following statements depends on the\nkind of routine:\n\no If a stored procedure executes statements that change the value of\n  LAST_INSERT_ID(), the changed value is seen by statements that follow\n  the procedure call.\n\no For stored functions and triggers that change the value, the value is\n  restored when the function or trigger ends, so statements coming\n  after it do not see a changed value.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/information-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/information-functions.html'),(281,'ROLES_GRAPHML',21,'ROLES_GRAPHML()\n\nReturns a utf8mb3 string containing a GraphML document representing\nmemory role subgraphs. The ROLE_ADMIN privilege (or the deprecated\nSUPER privilege) is required to see content in the <graphml> element.\nOtherwise, the result shows only an empty element:\n\nmysql> SELECT ROLES_GRAPHML();\n+---------------------------------------------------+\n| ROLES_GRAPHML()                                   |\n+---------------------------------------------------+\n| <?xml version=\"1.0\" encoding=\"UTF-8\"?><graphml /> |\n+---------------------------------------------------+\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/information-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/information-functions.html'),(282,'ROW_COUNT',21,'Syntax:\nROW_COUNT()\n\nROW_COUNT() returns a value as follows:\n\no DDL statements: 0. This applies to statements such as CREATE TABLE or\n  DROP TABLE.\n\no DML statements other than SELECT: The number of affected rows. This\n  applies to statements such as UPDATE, INSERT, or DELETE (as before),\n  but now also to statements such as ALTER TABLE and LOAD DATA.\n\no SELECT: -1 if the statement returns a result set, or the number of\n  rows \"affected\" if it does not. For example, for SELECT * FROM t1,\n  ROW_COUNT() returns -1. For SELECT * FROM t1 INTO OUTFILE\n  \'file_name\', ROW_COUNT() returns the number of rows written to the\n  file.\n\no SIGNAL statements: 0.\n\nFor UPDATE statements, the affected-rows value by default is the number\nof rows actually changed. If you specify the CLIENT_FOUND_ROWS flag to\nmysql_real_connect()\n(https://dev.mysql.com/doc/c-api/8.0/en/mysql-real-connect.html) when\nconnecting to mysqld, the affected-rows value is the number of rows\n\"found\"; that is, matched by the WHERE clause.\n\nFor REPLACE statements, the affected-rows value is 2 if the new row\nreplaced an old row, because in this case, one row was inserted after\nthe duplicate was deleted.\n\nFor INSERT ... ON DUPLICATE KEY UPDATE statements, the affected-rows\nvalue per row is 1 if the row is inserted as a new row, 2 if an\nexisting row is updated, and 0 if an existing row is set to its current\nvalues. If you specify the CLIENT_FOUND_ROWS flag, the affected-rows\nvalue is 1 (not 0) if an existing row is set to its current values.\n\nThe ROW_COUNT() value is similar to the value from the\nmysql_affected_rows()\n(https://dev.mysql.com/doc/c-api/8.0/en/mysql-affected-rows.html) C API\nfunction and the row count that the mysql client displays following\nstatement execution.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/information-functions.html\n\n','mysql> INSERT INTO t VALUES(1),(2),(3);\nQuery OK, 3 rows affected (0.00 sec)\nRecords: 3  Duplicates: 0  Warnings: 0\n\nmysql> SELECT ROW_COUNT();\n+-------------+\n| ROW_COUNT() |\n+-------------+\n|           3 |\n+-------------+\n1 row in set (0.00 sec)\n\nmysql> DELETE FROM t WHERE i IN(1,2);\nQuery OK, 2 rows affected (0.00 sec)\n\nmysql> SELECT ROW_COUNT();\n+-------------+\n| ROW_COUNT() |\n+-------------+\n|           2 |\n+-------------+\n1 row in set (0.00 sec)\n','https://dev.mysql.com/doc/refman/8.0/en/information-functions.html'),(283,'SCHEMA',21,'Syntax:\nSCHEMA()\n\nThis function is a synonym for DATABASE().\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/information-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/information-functions.html'),(284,'SESSION_USER',21,'Syntax:\nSESSION_USER()\n\nSESSION_USER() is a synonym for USER().\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/information-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/information-functions.html'),(285,'SYSTEM_USER',21,'Syntax:\nSYSTEM_USER()\n\nSYSTEM_USER() is a synonym for USER().\n\n*Note*:\n\nThe SYSTEM_USER() function is distinct from the SYSTEM_USER privilege.\nThe former returns the current MySQL account name. The latter\ndistinguishes the system user and regular user account categories (see\nhttps://dev.mysql.com/doc/refman/8.0/en/account-categories.html).\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/information-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/information-functions.html'),(286,'USER',21,'Syntax:\nUSER()\n\nReturns the current MySQL user name and host name as a string in the\nutf8mb3 character set.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/information-functions.html\n\n','mysql> SELECT USER();\n        -> \'davida@localhost\'\n','https://dev.mysql.com/doc/refman/8.0/en/information-functions.html'),(287,'VERSION',21,'Syntax:\nVERSION()\n\nReturns a string that indicates the MySQL server version. The string\nuses the utf8mb3 character set. The value might have a suffix in\naddition to the version number. See the description of the version\nsystem variable in\nhttps://dev.mysql.com/doc/refman/8.0/en/server-system-variables.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/information-functions.html\n\n','mysql> SELECT VERSION();\n        -> \'8.0.32-standard\'\n','https://dev.mysql.com/doc/refman/8.0/en/information-functions.html'),(288,'ST_GEOMCOLLFROMTEXT',23,'ST_GeomCollFromText(wkt [, srid [, options]]),\nST_GeometryCollectionFromText(wkt [, srid [, options]]),\nST_GeomCollFromTxt(wkt [, srid [, options]])\n\nConstructs a GeometryCollection value using its WKT representation and\nSRID.\n\nThese functions handle their arguments as described in the introduction\nto this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-wkt-functions.html\n\n','mysql> SET @g = \"MULTILINESTRING((10 10, 11 11), (9 9, 10 10))\";\nmysql> SELECT ST_AsText(ST_GeomCollFromText(@g));\n+--------------------------------------------+\n| ST_AsText(ST_GeomCollFromText(@g))         |\n+--------------------------------------------+\n| MULTILINESTRING((10 10,11 11),(9 9,10 10)) |\n+--------------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/gis-wkt-functions.html'),(289,'ST_GEOMFROMTEXT',23,'ST_GeomFromText(wkt [, srid [, options]]), ST_GeometryFromText(wkt [,\nsrid [, options]])\n\nConstructs a geometry value of any type using its WKT representation\nand SRID.\n\nThese functions handle their arguments as described in the introduction\nto this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-wkt-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/gis-wkt-functions.html'),(290,'ST_LINEFROMTEXT',23,'ST_LineFromText(wkt [, srid [, options]]), ST_LineStringFromText(wkt [,\nsrid [, options]])\n\nConstructs a LineString value using its WKT representation and SRID.\n\nThese functions handle their arguments as described in the introduction\nto this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-wkt-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/gis-wkt-functions.html'),(291,'ST_MLINEFROMTEXT',23,'ST_MLineFromText(wkt [, srid [, options]]),\nST_MultiLineStringFromText(wkt [, srid [, options]])\n\nConstructs a MultiLineString value using its WKT representation and\nSRID.\n\nThese functions handle their arguments as described in the introduction\nto this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-wkt-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/gis-wkt-functions.html'),(292,'ST_MPOINTFROMTEXT',23,'ST_MPointFromText(wkt [, srid [, options]]), ST_MultiPointFromText(wkt\n[, srid [, options]])\n\nConstructs a MultiPoint value using its WKT representation and SRID.\n\nThese functions handle their arguments as described in the introduction\nto this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-wkt-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/gis-wkt-functions.html'),(293,'ST_MPOLYFROMTEXT',23,'ST_MPolyFromText(wkt [, srid [, options]]), ST_MultiPolygonFromText(wkt\n[, srid [, options]])\n\nConstructs a MultiPolygon value using its WKT representation and SRID.\n\nThese functions handle their arguments as described in the introduction\nto this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-wkt-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/gis-wkt-functions.html'),(294,'ST_POINTFROMTEXT',23,'ST_PointFromText(wkt [, srid [, options]])\n\nConstructs a Point value using its WKT representation and SRID.\n\nST_PointFromText() handles its arguments as described in the\nintroduction to this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-wkt-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/gis-wkt-functions.html'),(295,'ST_POLYFROMTEXT',23,'ST_PolyFromText(wkt [, srid [, options]]), ST_PolygonFromText(wkt [,\nsrid [, options]])\n\nConstructs a Polygon value using its WKT representation and SRID.\n\nThese functions handle their arguments as described in the introduction\nto this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-wkt-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/gis-wkt-functions.html'),(296,'ST_GEOMCOLLFROMWKB',24,'ST_GeomCollFromWKB(wkb [, srid [, options]]),\nST_GeometryCollectionFromWKB(wkb [, srid [, options]])\n\nConstructs a GeometryCollection value using its WKB representation and\nSRID.\n\nThese functions handle their arguments as described in the introduction\nto this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-wkb-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/gis-wkb-functions.html'),(297,'ST_GEOMFROMWKB',24,'ST_GeomFromWKB(wkb [, srid [, options]]), ST_GeometryFromWKB(wkb [,\nsrid [, options]])\n\nConstructs a geometry value of any type using its WKB representation\nand SRID.\n\nThese functions handle their arguments as described in the introduction\nto this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-wkb-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/gis-wkb-functions.html'),(298,'ST_LINEFROMWKB',24,'ST_LineFromWKB(wkb [, srid [, options]]), ST_LineStringFromWKB(wkb [,\nsrid [, options]])\n\nConstructs a LineString value using its WKB representation and SRID.\n\nThese functions handle their arguments as described in the introduction\nto this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-wkb-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/gis-wkb-functions.html'),(299,'ST_MLINEFROMWKB',24,'ST_MLineFromWKB(wkb [, srid [, options]]),\nST_MultiLineStringFromWKB(wkb [, srid [, options]])\n\nConstructs a MultiLineString value using its WKB representation and\nSRID.\n\nThese functions handle their arguments as described in the introduction\nto this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-wkb-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/gis-wkb-functions.html'),(300,'ST_MPOINTFROMWKB',24,'ST_MPointFromWKB(wkb [, srid [, options]]), ST_MultiPointFromWKB(wkb [,\nsrid [, options]])\n\nConstructs a MultiPoint value using its WKB representation and SRID.\n\nThese functions handle their arguments as described in the introduction\nto this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-wkb-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/gis-wkb-functions.html'),(301,'ST_MPOLYFROMWKB',24,'ST_MPolyFromWKB(wkb [, srid [, options]]), ST_MultiPolygonFromWKB(wkb\n[, srid [, options]])\n\nConstructs a MultiPolygon value using its WKB representation and SRID.\n\nThese functions handle their arguments as described in the introduction\nto this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-wkb-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/gis-wkb-functions.html'),(302,'ST_POINTFROMWKB',24,'ST_PointFromWKB(wkb [, srid [, options]])\n\nConstructs a Point value using its WKB representation and SRID.\n\nST_PointFromWKB() handles its arguments as described in the\nintroduction to this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-wkb-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/gis-wkb-functions.html'),(303,'ST_POLYFROMWKB',24,'ST_PolyFromWKB(wkb [, srid [, options]]), ST_PolygonFromWKB(wkb [, srid\n[, options]])\n\nConstructs a Polygon value using its WKB representation and SRID.\n\nThese functions handle their arguments as described in the introduction\nto this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-wkb-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/gis-wkb-functions.html'),(304,'GEOMCOLLECTION',25,'GeomCollection(g [, g] ...)\n\nConstructs a GeomCollection value from the geometry arguments.\n\nGeomCollection() returns all the proper geometries contained in the\narguments even if a nonsupported geometry is present.\n\nGeomCollection() with no arguments is permitted as a way to create an\nempty geometry. Also, functions such as ST_GeomFromText() that accept\nWKT geometry collection arguments understand both OpenGIS\n\'GEOMETRYCOLLECTION EMPTY\' standard syntax and MySQL\n\'GEOMETRYCOLLECTION()\' nonstandard syntax.\n\nGeomCollection() and GeometryCollection() are synonymous, with\nGeomCollection() the preferred function.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-mysql-specific-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/gis-mysql-specific-functions.html'),(305,'GEOMETRYCOLLECTION',25,'GeometryCollection(g [, g] ...)\n\nConstructs a GeomCollection value from the geometry arguments.\n\nGeometryCollection() returns all the proper geometries contained in the\narguments even if a nonsupported geometry is present.\n\nGeometryCollection() with no arguments is permitted as a way to create\nan empty geometry. Also, functions such as ST_GeomFromText() that\naccept WKT geometry collection arguments understand both OpenGIS\n\'GEOMETRYCOLLECTION EMPTY\' standard syntax and MySQL\n\'GEOMETRYCOLLECTION()\' nonstandard syntax.\n\nGeomCollection() and GeometryCollection() are synonymous, with\nGeomCollection() the preferred function.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-mysql-specific-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/gis-mysql-specific-functions.html'),(306,'LINESTRING',25,'LineString(pt [, pt] ...)\n\nConstructs a LineString value from a number of Point or WKB Point\narguments. If the number of arguments is less than two, the return\nvalue is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-mysql-specific-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/gis-mysql-specific-functions.html'),(307,'MULTILINESTRING',25,'MultiLineString(ls [, ls] ...)\n\nConstructs a MultiLineString value using LineString or WKB LineString\narguments.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-mysql-specific-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/gis-mysql-specific-functions.html'),(308,'MULTIPOINT',25,'MultiPoint(pt [, pt2] ...)\n\nConstructs a MultiPoint value using Point or WKB Point arguments.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-mysql-specific-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/gis-mysql-specific-functions.html'),(309,'MULTIPOLYGON',25,'MultiPolygon(poly [, poly] ...)\n\nConstructs a MultiPolygon value from a set of Polygon or WKB Polygon\narguments.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-mysql-specific-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/gis-mysql-specific-functions.html'),(310,'POINT',25,'Point(x, y)\n\nConstructs a Point using its coordinates.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-mysql-specific-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/gis-mysql-specific-functions.html'),(311,'POLYGON',25,'Polygon(ls [, ls] ...)\n\nConstructs a Polygon value from a number of LineString or WKB\nLineString arguments. If any argument does not represent a LinearRing\n(that is, not a closed and simple LineString), the return value is\nNULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-mysql-specific-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/gis-mysql-specific-functions.html'),(312,'ST_ASBINARY',24,'ST_AsBinary(g [, options]), ST_AsWKB(g [, options])\n\nConverts a value in internal geometry format to its WKB representation\nand returns the binary result.\n\nThe function return value has geographic coordinates (latitude,\nlongitude) in the order specified by the spatial reference system that\napplies to the geometry argument. An optional options argument may be\ngiven to override the default axis order.\n\nST_AsBinary() and ST_AsWKB() handle their arguments as described in the\nintroduction to this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-format-conversion-functions.html\n\n','mysql> SET @g = ST_LineFromText(\'LINESTRING(0 5,5 10,10 15)\', 4326);\nmysql> SELECT ST_AsText(ST_GeomFromWKB(ST_AsWKB(@g)));\n+-----------------------------------------+\n| ST_AsText(ST_GeomFromWKB(ST_AsWKB(@g))) |\n+-----------------------------------------+\n| LINESTRING(5 0,10 5,15 10)              |\n+-----------------------------------------+\nmysql> SELECT ST_AsText(ST_GeomFromWKB(ST_AsWKB(@g, \'axis-order=long-lat\')));\n+----------------------------------------------------------------+\n| ST_AsText(ST_GeomFromWKB(ST_AsWKB(@g, \'axis-order=long-lat\'))) |\n+----------------------------------------------------------------+\n| LINESTRING(0 5,5 10,10 15)                                     |\n+----------------------------------------------------------------+\nmysql> SELECT ST_AsText(ST_GeomFromWKB(ST_AsWKB(@g, \'axis-order=lat-long\')));\n+----------------------------------------------------------------+\n| ST_AsText(ST_GeomFromWKB(ST_AsWKB(@g, \'axis-order=lat-long\'))) |\n+----------------------------------------------------------------+\n| LINESTRING(5 0,10 5,15 10)                                     |\n+----------------------------------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/gis-format-conversion-functions.html'),(313,'ST_ASTEXT',24,'ST_AsText(g [, options]), ST_AsWKT(g [, options])\n\nConverts a value in internal geometry format to its WKT representation\nand returns the string result.\n\nThe function return value has geographic coordinates (latitude,\nlongitude) in the order specified by the spatial reference system that\napplies to the geometry argument. An optional options argument may be\ngiven to override the default axis order.\n\nST_AsText() and ST_AsWKT() handle their arguments as described in the\nintroduction to this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-format-conversion-functions.html\n\n','mysql> SET @g = \'LineString(1 1,2 2,3 3)\';\nmysql> SELECT ST_AsText(ST_GeomFromText(@g));\n+--------------------------------+\n| ST_AsText(ST_GeomFromText(@g)) |\n+--------------------------------+\n| LINESTRING(1 1,2 2,3 3)        |\n+--------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/gis-format-conversion-functions.html'),(314,'ST_SWAPXY',24,'ST_SwapXY(g)\n\nAccepts an argument in internal geometry format, swaps the X and Y\nvalues of each coordinate pair within the geometry, and returns the\nresult.\n\nST_SwapXY() handles its arguments as described in the introduction to\nthis section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-format-conversion-functions.html\n\n','mysql> SET @g = ST_LineFromText(\'LINESTRING(0 5,5 10,10 15)\');\nmysql> SELECT ST_AsText(@g);\n+----------------------------+\n| ST_AsText(@g)              |\n+----------------------------+\n| LINESTRING(0 5,5 10,10 15) |\n+----------------------------+\nmysql> SELECT ST_AsText(ST_SwapXY(@g));\n+----------------------------+\n| ST_AsText(ST_SwapXY(@g))   |\n+----------------------------+\n| LINESTRING(5 0,10 5,15 10) |\n+----------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/gis-format-conversion-functions.html'),(315,'ST_DIMENSION',26,'ST_Dimension(g)\n\nReturns the inherent dimension of the geometry value g. The dimension\ncan be −1, 0, 1, or 2. The meaning of these values is given in\nhttps://dev.mysql.com/doc/refman/8.0/en/gis-class-geometry.html.\n\nST_Dimension() handles its arguments as described in the introduction\nto this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-general-property-functions.html\n\n','mysql> SELECT ST_Dimension(ST_GeomFromText(\'LineString(1 1,2 2)\'));\n+------------------------------------------------------+\n| ST_Dimension(ST_GeomFromText(\'LineString(1 1,2 2)\')) |\n+------------------------------------------------------+\n|                                                    1 |\n+------------------------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/gis-general-property-functions.html'),(316,'ST_ENVELOPE',26,'ST_Envelope(g)\n\nReturns the minimum bounding rectangle (MBR) for the geometry value g.\nThe result is returned as a Polygon value that is defined by the corner\npoints of the bounding box:\n\nPOLYGON((MINX MINY, MAXX MINY, MAXX MAXY, MINX MAXY, MINX MINY))\n\nmysql> SELECT ST_AsText(ST_Envelope(ST_GeomFromText(\'LineString(1 1,2 2)\')));\n+----------------------------------------------------------------+\n| ST_AsText(ST_Envelope(ST_GeomFromText(\'LineString(1 1,2 2)\'))) |\n+----------------------------------------------------------------+\n| POLYGON((1 1,2 1,2 2,1 2,1 1))                                 |\n+----------------------------------------------------------------+\n\nIf the argument is a point or a vertical or horizontal line segment,\nST_Envelope() returns the point or the line segment as its MBR rather\nthan returning an invalid polygon:\n\nmysql> SELECT ST_AsText(ST_Envelope(ST_GeomFromText(\'LineString(1 1,1 2)\')));\n+----------------------------------------------------------------+\n| ST_AsText(ST_Envelope(ST_GeomFromText(\'LineString(1 1,1 2)\'))) |\n+----------------------------------------------------------------+\n| LINESTRING(1 1,1 2)                                            |\n+----------------------------------------------------------------+\n\nST_Envelope() handles its arguments as described in the introduction to\nthis section, with this exception:\n\no If the geometry has an SRID value for a geographic spatial reference\n  system (SRS), an ER_NOT_IMPLEMENTED_FOR_GEOGRAPHIC_SRS\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_not_implemented_for_geographic_srs) error occurs.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-general-property-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/gis-general-property-functions.html'),(317,'ST_GEOMETRYTYPE',26,'ST_GeometryType(g)\n\nReturns a binary string indicating the name of the geometry type of\nwhich the geometry instance g is a member. The name corresponds to one\nof the instantiable Geometry subclasses.\n\nST_GeometryType() handles its arguments as described in the\nintroduction to this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-general-property-functions.html\n\n','mysql> SELECT ST_GeometryType(ST_GeomFromText(\'POINT(1 1)\'));\n+------------------------------------------------+\n| ST_GeometryType(ST_GeomFromText(\'POINT(1 1)\')) |\n+------------------------------------------------+\n| POINT                                          |\n+------------------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/gis-general-property-functions.html'),(318,'ST_ISEMPTY',26,'ST_IsEmpty(g)\n\nThis function is a placeholder that returns 1 for an empty geometry\ncollection value or 0 otherwise.\n\nThe only valid empty geometry is represented in the form of an empty\ngeometry collection value. MySQL does not support GIS EMPTY values such\nas POINT EMPTY.\n\nST_IsEmpty() handles its arguments as described in the introduction to\nthis section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-general-property-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/gis-general-property-functions.html'),(319,'ST_ISSIMPLE',26,'ST_IsSimple(g)\n\nReturns 1 if the geometry value g is simple according to the ISO SQL/MM\nPart 3: Spatial standard. ST_IsSimple() returns 0 if the argument is\nnot simple.\n\nThe descriptions of the instantiable geometric classes given under\nhttps://dev.mysql.com/doc/refman/8.0/en/opengis-geometry-model.html\ninclude the specific conditions that cause class instances to be\nclassified as not simple.\n\nST_IsSimple() handles its arguments as described in the introduction to\nthis section, with this exception:\n\no If the geometry has a geographic SRS with a longitude or latitude\n  that is out of range, an error occurs:\n\n  o If a longitude value is not in the range (−180, 180], an\n    ER_GEOMETRY_PARAM_LONGITUDE_OUT_OF_RANGE\n    (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-referen\n    ce.html#error_er_geometry_param_longitude_out_of_range) error\n    occurs (ER_LONGITUDE_OUT_OF_RANGE\n    (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-referen\n    ce.html#error_er_longitude_out_of_range) prior to MySQL 8.0.12).\n\n  o If a latitude value is not in the range [−90, 90], an\n    ER_GEOMETRY_PARAM_LATITUDE_OUT_OF_RANGE\n    (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-referen\n    ce.html#error_er_geometry_param_latitude_out_of_range) error occurs\n    (ER_LATITUDE_OUT_OF_RANGE\n    (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-referen\n    ce.html#error_er_latitude_out_of_range) prior to MySQL 8.0.12).\n\n  Ranges shown are in degrees. The exact range limits deviate slightly\n  due to floating-point arithmetic.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-general-property-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/gis-general-property-functions.html'),(320,'ST_SRID',26,'ST_SRID(g [, srid])\n\nWith a single argument representing a valid geometry object g,\nST_SRID() returns an integer indicating the ID of the spatial reference\nsystem (SRS) associated with g.\n\nWith the optional second argument representing a valid SRID value,\nST_SRID() returns an object with the same type as its first argument\nwith an SRID value equal to the second argument. This only sets the\nSRID value of the object; it does not perform any transformation of\ncoordinate values.\n\nST_SRID() handles its arguments as described in the introduction to\nthis section, with this exception:\n\no For the single-argument syntax, ST_SRID() returns the geometry SRID\n  even if it refers to an undefined SRS. An ER_SRS_NOT_FOUND\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_srs_not_found) error does not occur.\n\nST_SRID(g, target_srid) and ST_Transform(g, target_srid) differ as\nfollows:\n\no ST_SRID() changes the geometry SRID value without transforming its\n  coordinates.\n\no ST_Transform() transforms the geometry coordinates in addition to\n  changing its SRID value.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-general-property-functions.html\n\n','mysql> SET @g = ST_GeomFromText(\'LineString(1 1,2 2)\', 0);\nmysql> SELECT ST_SRID(@g);\n+-------------+\n| ST_SRID(@g) |\n+-------------+\n|           0 |\n+-------------+\nmysql> SET @g = ST_SRID(@g, 4326);\nmysql> SELECT ST_SRID(@g);\n+-------------+\n| ST_SRID(@g) |\n+-------------+\n|        4326 |\n+-------------+\n','https://dev.mysql.com/doc/refman/8.0/en/gis-general-property-functions.html'),(321,'ST_LATITUDE',27,'ST_Latitude(p [, new_latitude_val])\n\nWith a single argument representing a valid Point object p that has a\ngeographic spatial reference system (SRS), ST_Latitude() returns the\nlatitude value of p as a double-precision number.\n\nWith the optional second argument representing a valid latitude value,\nST_Latitude() returns a Point object like the first argument with its\nlatitude equal to the second argument.\n\nST_Latitude() handles its arguments as described in the introduction to\nthis section, with the addition that if the Point object is valid but\ndoes not have a geographic SRS, an ER_SRS_NOT_GEOGRAPHIC\n(https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference.html\n#error_er_srs_not_geographic) error occurs.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-point-property-functions.html\n\n','mysql> SET @pt = ST_GeomFromText(\'POINT(45 90)\', 4326);\nmysql> SELECT ST_Latitude(@pt);\n+------------------+\n| ST_Latitude(@pt) |\n+------------------+\n|               45 |\n+------------------+\nmysql> SELECT ST_AsText(ST_Latitude(@pt, 10));\n+---------------------------------+\n| ST_AsText(ST_Latitude(@pt, 10)) |\n+---------------------------------+\n| POINT(10 90)                    |\n+---------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/gis-point-property-functions.html'),(322,'ST_LONGITUDE',27,'ST_Longitude(p [, new_longitude_val])\n\nWith a single argument representing a valid Point object p that has a\ngeographic spatial reference system (SRS), ST_Longitude() returns the\nlongitude value of p as a double-precision number.\n\nWith the optional second argument representing a valid longitude value,\nST_Longitude() returns a Point object like the first argument with its\nlongitude equal to the second argument.\n\nST_Longitude() handles its arguments as described in the introduction\nto this section, with the addition that if the Point object is valid\nbut does not have a geographic SRS, an ER_SRS_NOT_GEOGRAPHIC\n(https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference.html\n#error_er_srs_not_geographic) error occurs.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-point-property-functions.html\n\n','mysql> SET @pt = ST_GeomFromText(\'POINT(45 90)\', 4326);\nmysql> SELECT ST_Longitude(@pt);\n+-------------------+\n| ST_Longitude(@pt) |\n+-------------------+\n|                90 |\n+-------------------+\nmysql> SELECT ST_AsText(ST_Longitude(@pt, 10));\n+----------------------------------+\n| ST_AsText(ST_Longitude(@pt, 10)) |\n+----------------------------------+\n| POINT(45 10)                     |\n+----------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/gis-point-property-functions.html'),(323,'ST_X',27,'ST_X(p [, new_x_val])\n\nWith a single argument representing a valid Point object p, ST_X()\nreturns the X-coordinate value of p as a double-precision number. As of\nMySQL 8.0.12, the X coordinate is considered to refer to the axis that\nappears first in the Point spatial reference system (SRS) definition.\n\nWith the optional second argument, ST_X() returns a Point object like\nthe first argument with its X coordinate equal to the second argument.\nAs of MySQL 8.0.12, if the Point object has a geographic SRS, the\nsecond argument must be in the proper range for longitude or latitude\nvalues.\n\nST_X() handles its arguments as described in the introduction to this\nsection.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-point-property-functions.html\n\n','mysql> SELECT ST_X(Point(56.7, 53.34));\n+--------------------------+\n| ST_X(Point(56.7, 53.34)) |\n+--------------------------+\n|                     56.7 |\n+--------------------------+\nmysql> SELECT ST_AsText(ST_X(Point(56.7, 53.34), 10.5));\n+-------------------------------------------+\n| ST_AsText(ST_X(Point(56.7, 53.34), 10.5)) |\n+-------------------------------------------+\n| POINT(10.5 53.34)                         |\n+-------------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/gis-point-property-functions.html'),(324,'ST_Y',27,'ST_Y(p [, new_y_val])\n\nWith a single argument representing a valid Point object p, ST_Y()\nreturns the Y-coordinate value of p as a double-precision number. As of\nMySQL 8.0.12, the Y coordinate is considered to refer to the axis that\nappears second in the Point spatial reference system (SRS) definition.\n\nWith the optional second argument, ST_Y() returns a Point object like\nthe first argument with its Y coordinate equal to the second argument.\nAs of MySQL 8.0.12, if the Point object has a geographic SRS, the\nsecond argument must be in the proper range for longitude or latitude\nvalues.\n\nST_Y() handles its arguments as described in the introduction to this\nsection.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-point-property-functions.html\n\n','mysql> SELECT ST_Y(Point(56.7, 53.34));\n+--------------------------+\n| ST_Y(Point(56.7, 53.34)) |\n+--------------------------+\n|                    53.34 |\n+--------------------------+\nmysql> SELECT ST_AsText(ST_Y(Point(56.7, 53.34), 10.5));\n+-------------------------------------------+\n| ST_AsText(ST_Y(Point(56.7, 53.34), 10.5)) |\n+-------------------------------------------+\n| POINT(56.7 10.5)                          |\n+-------------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/gis-point-property-functions.html'),(325,'ST_ENDPOINT',28,'ST_EndPoint(ls)\n\nReturns the Point that is the endpoint of the LineString value ls.\n\nST_EndPoint() handles its arguments as described in the introduction to\nthis section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-linestring-property-functions.html\n\n','mysql> SET @ls = \'LineString(1 1,2 2,3 3)\';\nmysql> SELECT ST_AsText(ST_EndPoint(ST_GeomFromText(@ls)));\n+----------------------------------------------+\n| ST_AsText(ST_EndPoint(ST_GeomFromText(@ls))) |\n+----------------------------------------------+\n| POINT(3 3)                                   |\n+----------------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/gis-linestring-property-functions.html'),(326,'ST_ISCLOSED',28,'ST_IsClosed(ls)\n\nFor a LineString value ls, ST_IsClosed() returns 1 if ls is closed\n(that is, its ST_StartPoint() and ST_EndPoint() values are the same).\n\nFor a MultiLineString value ls, ST_IsClosed() returns 1 if ls is closed\n(that is, the ST_StartPoint() and ST_EndPoint() values are the same for\neach LineString in ls).\n\nST_IsClosed() returns 0 if ls is not closed, and NULL if ls is NULL.\n\nST_IsClosed() handles its arguments as described in the introduction to\nthis section, with this exception:\n\no If the geometry has an SRID value for a geographic spatial reference\n  system (SRS), an ER_NOT_IMPLEMENTED_FOR_GEOGRAPHIC_SRS\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_not_implemented_for_geographic_srs) error occurs.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-linestring-property-functions.html\n\n','mysql> SET @ls1 = \'LineString(1 1,2 2,3 3,2 2)\';\nmysql> SET @ls2 = \'LineString(1 1,2 2,3 3,1 1)\';\n\nmysql> SELECT ST_IsClosed(ST_GeomFromText(@ls1));\n+------------------------------------+\n| ST_IsClosed(ST_GeomFromText(@ls1)) |\n+------------------------------------+\n|                                  0 |\n+------------------------------------+\n\nmysql> SELECT ST_IsClosed(ST_GeomFromText(@ls2));\n+------------------------------------+\n| ST_IsClosed(ST_GeomFromText(@ls2)) |\n+------------------------------------+\n|                                  1 |\n+------------------------------------+\n\nmysql> SET @ls3 = \'MultiLineString((1 1,2 2,3 3),(4 4,5 5))\';\n\nmysql> SELECT ST_IsClosed(ST_GeomFromText(@ls3));\n+------------------------------------+\n| ST_IsClosed(ST_GeomFromText(@ls3)) |\n+------------------------------------+\n|                                  0 |\n+------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/gis-linestring-property-functions.html'),(327,'ST_LENGTH',28,'ST_Length(ls [, unit])\n\nReturns a double-precision number indicating the length of the\nLineString or MultiLineString value ls in its associated spatial\nreference system. The length of a MultiLineString value is equal to the\nsum of the lengths of its elements.\n\nST_Length() computes a result as follows:\n\no If the geometry is a valid LineString in a Cartesian SRS, the return\n  value is the Cartesian length of the geometry.\n\no If the geometry is a valid MultiLineString in a Cartesian SRS, the\n  return value is the sum of the Cartesian lengths of its elements.\n\no If the geometry is a valid LineString in a geographic SRS, the return\n  value is the geodetic length of the geometry in that SRS, in meters.\n\no If the geometry is a valid MultiLineString in a geographic SRS, the\n  return value is the sum of the geodetic lengths of its elements in\n  that SRS, in meters.\n\nST_Length() handles its arguments as described in the introduction to\nthis section, with these exceptions:\n\no If the geometry is not a LineString or MultiLineString, the return\n  value is NULL.\n\no If the geometry is geometrically invalid, either the result is an\n  undefined length (that is, it can be any number), or an error occurs.\n\no If the length computation result is +inf, an ER_DATA_OUT_OF_RANGE\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_data_out_of_range) error occurs.\n\no If the geometry has a geographic SRS with a longitude or latitude\n  that is out of range, an error occurs:\n\n  o If a longitude value is not in the range (−180, 180], an\n    ER_GEOMETRY_PARAM_LONGITUDE_OUT_OF_RANGE\n    (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-referen\n    ce.html#error_er_geometry_param_longitude_out_of_range) error\n    occurs (ER_LONGITUDE_OUT_OF_RANGE\n    (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-referen\n    ce.html#error_er_longitude_out_of_range) prior to MySQL 8.0.12).\n\n  o If a latitude value is not in the range [−90, 90], an\n    ER_GEOMETRY_PARAM_LATITUDE_OUT_OF_RANGE\n    (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-referen\n    ce.html#error_er_geometry_param_latitude_out_of_range) error occurs\n    (ER_LATITUDE_OUT_OF_RANGE\n    (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-referen\n    ce.html#error_er_latitude_out_of_range) prior to MySQL 8.0.12).\n\n  Ranges shown are in degrees. The exact range limits deviate slightly\n  due to floating-point arithmetic.\n\nAs of MySQL 8.0.16, ST_Length() permits an optional unit argument that\nspecifies the linear unit for the returned length value. These rules\napply:\n\no If a unit is specified but not supported by MySQL, an\n  ER_UNIT_NOT_FOUND\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_unit_not_found) error occurs.\n\no If a supported linear unit is specified and the SRID is 0, an\n  ER_GEOMETRY_IN_UNKNOWN_LENGTH_UNIT\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_geometry_in_unknown_length_unit) error occurs.\n\no If a supported linear unit is specified and the SRID is not 0, the\n  result is in that unit.\n\no If a unit is not specified, the result is in the unit of the SRS of\n  the geometries, whether Cartesian or geographic. Currently, all MySQL\n  SRSs are expressed in meters.\n\nA unit is supported if it is found in the INFORMATION_SCHEMA\nST_UNITS_OF_MEASURE table. See\nhttps://dev.mysql.com/doc/refman/8.0/en/information-schema-st-units-of-\nmeasure-table.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-linestring-property-functions.html\n\n','mysql> SET @ls = ST_GeomFromText(\'LineString(1 1,2 2,3 3)\');\nmysql> SELECT ST_Length(@ls);\n+--------------------+\n| ST_Length(@ls)     |\n+--------------------+\n| 2.8284271247461903 |\n+--------------------+\n\nmysql> SET @mls = ST_GeomFromText(\'MultiLineString((1 1,2 2,3 3),(4 4,5 5))\');\nmysql> SELECT ST_Length(@mls);\n+-------------------+\n| ST_Length(@mls)   |\n+-------------------+\n| 4.242640687119286 |\n+-------------------+\n\nmysql> SET @ls = ST_GeomFromText(\'LineString(1 1,2 2,3 3)\', 4326);\nmysql> SELECT ST_Length(@ls);\n+-------------------+\n| ST_Length(@ls)    |\n+-------------------+\n| 313701.9623204328 |\n+-------------------+\nmysql> SELECT ST_Length(@ls, \'metre\');\n+-------------------------+\n| ST_Length(@ls, \'metre\') |\n+-------------------------+\n|       313701.9623204328 |\n+-------------------------+\nmysql> SELECT ST_Length(@ls, \'foot\');\n+------------------------+\n| ST_Length(@ls, \'foot\') |\n+------------------------+\n|     1029205.9131247795 |\n+------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/gis-linestring-property-functions.html'),(328,'ST_NUMPOINTS',28,'ST_NumPoints(ls)\n\nReturns the number of Point objects in the LineString value ls.\n\nST_NumPoints() handles its arguments as described in the introduction\nto this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-linestring-property-functions.html\n\n','mysql> SET @ls = \'LineString(1 1,2 2,3 3)\';\nmysql> SELECT ST_NumPoints(ST_GeomFromText(@ls));\n+------------------------------------+\n| ST_NumPoints(ST_GeomFromText(@ls)) |\n+------------------------------------+\n|                                  3 |\n+------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/gis-linestring-property-functions.html'),(329,'ST_POINTN',28,'ST_PointN(ls, N)\n\nReturns the N-th Point in the Linestring value ls. Points are numbered\nbeginning with 1.\n\nST_PointN() handles its arguments as described in the introduction to\nthis section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-linestring-property-functions.html\n\n','mysql> SET @ls = \'LineString(1 1,2 2,3 3)\';\nmysql> SELECT ST_AsText(ST_PointN(ST_GeomFromText(@ls),2));\n+----------------------------------------------+\n| ST_AsText(ST_PointN(ST_GeomFromText(@ls),2)) |\n+----------------------------------------------+\n| POINT(2 2)                                   |\n+----------------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/gis-linestring-property-functions.html'),(330,'ST_STARTPOINT',28,'ST_StartPoint(ls)\n\nReturns the Point that is the start point of the LineString value ls.\n\nST_StartPoint() handles its arguments as described in the introduction\nto this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-linestring-property-functions.html\n\n','mysql> SET @ls = \'LineString(1 1,2 2,3 3)\';\nmysql> SELECT ST_AsText(ST_StartPoint(ST_GeomFromText(@ls)));\n+------------------------------------------------+\n| ST_AsText(ST_StartPoint(ST_GeomFromText(@ls))) |\n+------------------------------------------------+\n| POINT(1 1)                                     |\n+------------------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/gis-linestring-property-functions.html'),(331,'ST_AREA',29,'ST_Area({poly|mpoly})\n\nReturns a double-precision number indicating the area of the Polygon or\nMultiPolygon argument, as measured in its spatial reference system.\n\nAs of MySQL 8.0.13, ST_Area() handles its arguments as described in the\nintroduction to this section, with these exceptions:\n\no If the geometry is geometrically invalid, either the result is an\n  undefined area (that is, it can be any number), or an error occurs.\n\no If the geometry is valid but is not a Polygon or MultiPolygon object,\n  an ER_UNEXPECTED_GEOMETRY_TYPE\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_unexpected_geometry_type) error occurs.\n\no If the geometry is a valid Polygon in a Cartesian SRS, the result is\n  the Cartesian area of the polygon.\n\no If the geometry is a valid MultiPolygon in a Cartesian SRS, the\n  result is the sum of the Cartesian area of the polygons.\n\no If the geometry is a valid Polygon in a geographic SRS, the result is\n  the geodetic area of the polygon in that SRS, in square meters.\n\no If the geometry is a valid MultiPolygon in a geographic SRS, the\n  result is the sum of geodetic area of the polygons in that SRS, in\n  square meters.\n\no If an area computation results in +inf, an ER_DATA_OUT_OF_RANGE\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_data_out_of_range) error occurs.\n\no If the geometry has a geographic SRS with a longitude or latitude\n  that is out of range, an error occurs:\n\n  o If a longitude value is not in the range (−180, 180], an\n    ER_GEOMETRY_PARAM_LONGITUDE_OUT_OF_RANGE\n    (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-referen\n    ce.html#error_er_geometry_param_longitude_out_of_range) error\n    occurs (ER_LONGITUDE_OUT_OF_RANGE\n    (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-referen\n    ce.html#error_er_longitude_out_of_range) prior to MySQL 8.0.12).\n\n  o If a latitude value is not in the range [−90, 90], an\n    ER_GEOMETRY_PARAM_LATITUDE_OUT_OF_RANGE\n    (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-referen\n    ce.html#error_er_geometry_param_latitude_out_of_range) error occurs\n    (ER_LATITUDE_OUT_OF_RANGE\n    (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-referen\n    ce.html#error_er_latitude_out_of_range) prior to MySQL 8.0.12).\n\n  Ranges shown are in degrees. The exact range limits deviate slightly\n  due to floating-point arithmetic.\n\nPrior to MySQL 8.0.13, ST_Area() handles its arguments as described in\nthe introduction to this section, with these exceptions:\n\no For arguments of dimension 0 or 1, the result is 0.\n\no If a geometry is empty, the return value is 0 rather than NULL.\n\no For a geometry collection, the result is the sum of the area values\n  of all components. If the geometry collection is empty, its area is\n  returned as 0.\n\no If the geometry has an SRID value for a geographic spatial reference\n  system (SRS), an ER_NOT_IMPLEMENTED_FOR_GEOGRAPHIC_SRS\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_not_implemented_for_geographic_srs) error occurs.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-polygon-property-functions.html\n\n','mysql> SET @poly =\n       \'Polygon((0 0,0 3,3 0,0 0),(1 1,1 2,2 1,1 1))\';\nmysql> SELECT ST_Area(ST_GeomFromText(@poly));\n+---------------------------------+\n| ST_Area(ST_GeomFromText(@poly)) |\n+---------------------------------+\n|                               4 |\n+---------------------------------+\n\nmysql> SET @mpoly =\n       \'MultiPolygon(((0 0,0 3,3 3,3 0,0 0),(1 1,1 2,2 2,2 1,1 1)))\';\nmysql> SELECT ST_Area(ST_GeomFromText(@mpoly));\n+----------------------------------+\n| ST_Area(ST_GeomFromText(@mpoly)) |\n+----------------------------------+\n|                                8 |\n+----------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/gis-polygon-property-functions.html'),(332,'ST_CENTROID',29,'ST_Centroid({poly|mpoly})\n\nReturns the mathematical centroid for the Polygon or MultiPolygon\nargument as a Point. The result is not guaranteed to be on the\nMultiPolygon.\n\nThis function processes geometry collections by computing the centroid\npoint for components of highest dimension in the collection. Such\ncomponents are extracted and made into a single MultiPolygon,\nMultiLineString, or MultiPoint for centroid computation.\n\nST_Centroid() handles its arguments as described in the introduction to\nthis section, with these exceptions:\n\no The return value is NULL for the additional condition that the\n  argument is an empty geometry collection.\n\no If the geometry has an SRID value for a geographic spatial reference\n  system (SRS), an ER_NOT_IMPLEMENTED_FOR_GEOGRAPHIC_SRS\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_not_implemented_for_geographic_srs) error occurs.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-polygon-property-functions.html\n\n','mysql> SET @poly =\n       ST_GeomFromText(\'POLYGON((0 0,10 0,10 10,0 10,0 0),(5 5,7 5,7 7,5 7,5 5))\');\nmysql> SELECT ST_GeometryType(@poly),ST_AsText(ST_Centroid(@poly));\n+------------------------+--------------------------------------------+\n| ST_GeometryType(@poly) | ST_AsText(ST_Centroid(@poly))              |\n+------------------------+--------------------------------------------+\n| POLYGON                | POINT(4.958333333333333 4.958333333333333) |\n+------------------------+--------------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/gis-polygon-property-functions.html'),(333,'ST_EXTERIORRING',29,'ST_ExteriorRing(poly)\n\nReturns the exterior ring of the Polygon value poly as a LineString.\n\nST_ExteriorRing() handles its arguments as described in the\nintroduction to this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-polygon-property-functions.html\n\n','mysql> SET @poly =\n       \'Polygon((0 0,0 3,3 3,3 0,0 0),(1 1,1 2,2 2,2 1,1 1))\';\nmysql> SELECT ST_AsText(ST_ExteriorRing(ST_GeomFromText(@poly)));\n+----------------------------------------------------+\n| ST_AsText(ST_ExteriorRing(ST_GeomFromText(@poly))) |\n+----------------------------------------------------+\n| LINESTRING(0 0,0 3,3 3,3 0,0 0)                    |\n+----------------------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/gis-polygon-property-functions.html'),(334,'ST_INTERIORRINGN',29,'ST_InteriorRingN(poly, N)\n\nReturns the N-th interior ring for the Polygon value poly as a\nLineString. Rings are numbered beginning with 1.\n\nST_InteriorRingN() handles its arguments as described in the\nintroduction to this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-polygon-property-functions.html\n\n','mysql> SET @poly =\n       \'Polygon((0 0,0 3,3 3,3 0,0 0),(1 1,1 2,2 2,2 1,1 1))\';\nmysql> SELECT ST_AsText(ST_InteriorRingN(ST_GeomFromText(@poly),1));\n+-------------------------------------------------------+\n| ST_AsText(ST_InteriorRingN(ST_GeomFromText(@poly),1)) |\n+-------------------------------------------------------+\n| LINESTRING(1 1,1 2,2 2,2 1,1 1)                       |\n+-------------------------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/gis-polygon-property-functions.html'),(335,'ST_NUMINTERIORRINGS',29,'ST_NumInteriorRing(poly), ST_NumInteriorRings(poly)\n\nReturns the number of interior rings in the Polygon value poly.\n\nST_NumInteriorRing() and ST_NuminteriorRings() handle their arguments\nas described in the introduction to this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-polygon-property-functions.html\n\n','mysql> SET @poly =\n       \'Polygon((0 0,0 3,3 3,3 0,0 0),(1 1,1 2,2 2,2 1,1 1))\';\nmysql> SELECT ST_NumInteriorRings(ST_GeomFromText(@poly));\n+---------------------------------------------+\n| ST_NumInteriorRings(ST_GeomFromText(@poly)) |\n+---------------------------------------------+\n|                                           1 |\n+---------------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/gis-polygon-property-functions.html'),(336,'ST_GEOMETRYN',30,'ST_GeometryN(gc, N)\n\nReturns the N-th geometry in the GeometryCollection value gc.\nGeometries are numbered beginning with 1.\n\nST_GeometryN() handles its arguments as described in the introduction\nto this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-geometrycollection-property-functions.html\n\n','mysql> SET @gc = \'GeometryCollection(Point(1 1),LineString(2 2, 3 3))\';\nmysql> SELECT ST_AsText(ST_GeometryN(ST_GeomFromText(@gc),1));\n+-------------------------------------------------+\n| ST_AsText(ST_GeometryN(ST_GeomFromText(@gc),1)) |\n+-------------------------------------------------+\n| POINT(1 1)                                      |\n+-------------------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/gis-geometrycollection-property-functions.html'),(337,'ST_NUMGEOMETRIES',30,'ST_NumGeometries(gc)\n\nReturns the number of geometries in the GeometryCollection value gc.\n\nST_NumGeometries() handles its arguments as described in the\nintroduction to this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gis-geometrycollection-property-functions.html\n\n','mysql> SET @gc = \'GeometryCollection(Point(1 1),LineString(2 2, 3 3))\';\nmysql> SELECT ST_NumGeometries(ST_GeomFromText(@gc));\n+----------------------------------------+\n| ST_NumGeometries(ST_GeomFromText(@gc)) |\n+----------------------------------------+\n|                                      2 |\n+----------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/gis-geometrycollection-property-functions.html'),(338,'ST_BUFFER',30,'ST_Buffer(g, d [, strategy1 [, strategy2 [, strategy3]]])\n\nReturns a geometry that represents all points whose distance from the\ngeometry value g is less than or equal to a distance of d. The result\nis in the same SRS as the geometry argument.\n\nIf the geometry argument is empty, ST_Buffer() returns an empty\ngeometry.\n\nIf the distance is 0, ST_Buffer() returns the geometry argument\nunchanged:\n\nmysql> SET @pt = ST_GeomFromText(\'POINT(0 0)\');\nmysql> SELECT ST_AsText(ST_Buffer(@pt, 0));\n+------------------------------+\n| ST_AsText(ST_Buffer(@pt, 0)) |\n+------------------------------+\n| POINT(0 0)                   |\n+------------------------------+\n\nIf the geometry argument is in a Cartesian SRS:\n\no ST_Buffer() supports negative distances for Polygon and MultiPolygon\n  values, and for geometry collections containing Polygon or\n  MultiPolygon values.\n\no If the result is reduced so much that it disappears, the result is an\n  empty geometry.\n\no An ER_WRONG_ARGUMENTS\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_wrong_arguments) error occurs for ST_Buffer() with a\n  negative distance for Point, MultiPoint, LineString, and\n  MultiLineString values, and for geometry collections not containing\n  any Polygon or MultiPolygon values.\n\nIf the geometry argument is in a geographic SRS:\n\no Prior to MySQL 8.0.26, an ER_NOT_IMPLEMENTED_FOR_GEOGRAPHIC_SRS\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_not_implemented_for_geographic_srs) error occurs.\n\no As of MySQL 8.0.26, Point geometries in a geographic SRS are\n  permitted. For non-Point geometries, an\n  ER_NOT_IMPLEMENTED_FOR_GEOGRAPHIC_SRS\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_not_implemented_for_geographic_srs) error still\n  occurs.\n\nFor MySQL versions that permit geographic Point geometries:\n\no If the distance is not negative and no strategies are specified, the\n  function returns the geographic buffer of the Point in its SRS. The\n  distance argument must be in the SRS distance unit (currently always\n  meters).\n\no If the distance is negative or any strategy (except NULL) is\n  specified, an ER_WRONG_ARGUMENTS\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_wrong_arguments) error occurs.\n\nST_Buffer() permits up to three optional strategy arguments following\nthe distance argument. Strategies influence buffer computation. These\narguments are byte string values produced by the ST_Buffer_Strategy()\nfunction, to be used for point, join, and end strategies:\n\no Point strategies apply to Point and MultiPoint geometries. If no\n  point strategy is specified, the default is\n  ST_Buffer_Strategy(\'point_circle\', 32).\n\no Join strategies apply to LineString, MultiLineString, Polygon, and\n  MultiPolygon geometries. If no join strategy is specified, the\n  default is ST_Buffer_Strategy(\'join_round\', 32).\n\no End strategies apply to LineString and MultiLineString geometries. If\n  no end strategy is specified, the default is\n  ST_Buffer_Strategy(\'end_round\', 32).\n\nUp to one strategy of each type may be specified, and they may be given\nin any order.\n\nIf the buffer strategies are invalid, an ER_WRONG_ARGUMENTS\n(https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference.html\n#error_er_wrong_arguments) error occurs. Strategies are invalid\nunder any of these circumstances:\n\no Multiple strategies of a given type (point, join, or end) are\n  specified.\n\no A value that is not a strategy (such as an arbitrary binary string or\n  a number) is passed as a strategy.\n\no A Point strategy is passed and the geometry contains no Point or\n  MultiPoint values.\n\no An end or join strategy is passed and the geometry contains no\n  LineString, Polygon, MultiLinestring or MultiPolygon values.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/spatial-operator-functions.html\n\n','mysql> SET @pt = ST_GeomFromText(\'POINT(0 0)\');\nmysql> SET @pt_strategy = ST_Buffer_Strategy(\'point_square\');\nmysql> SELECT ST_AsText(ST_Buffer(@pt, 2, @pt_strategy));\n+--------------------------------------------+\n| ST_AsText(ST_Buffer(@pt, 2, @pt_strategy)) |\n+--------------------------------------------+\n| POLYGON((-2 -2,2 -2,2 2,-2 2,-2 -2))       |\n+--------------------------------------------+\n\nmysql> SET @ls = ST_GeomFromText(\'LINESTRING(0 0,0 5,5 5)\');\nmysql> SET @end_strategy = ST_Buffer_Strategy(\'end_flat\');\nmysql> SET @join_strategy = ST_Buffer_Strategy(\'join_round\', 10);\nmysql> SELECT ST_AsText(ST_Buffer(@ls, 5, @end_strategy, @join_strategy))\n+---------------------------------------------------------------+\n| ST_AsText(ST_Buffer(@ls, 5, @end_strategy, @join_strategy))   |\n+---------------------------------------------------------------+\n| POLYGON((5 5,5 10,0 10,-3.5355339059327373 8.535533905932738, |\n| -5 5,-5 0,0 0,5 0,5 5))                                       |\n+---------------------------------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/spatial-operator-functions.html'),(339,'ST_BUFFER_STRATEGY',30,'ST_Buffer_Strategy(strategy [, points_per_circle])\n\nThis function returns a strategy byte string for use with ST_Buffer()\nto influence buffer computation.\n\nInformation about strategies is available at Boost.org\n(http://www.boost.org).\n\nThe first argument must be a string indicating a strategy option:\n\no For point strategies, permitted values are \'point_circle\' and\n  \'point_square\'.\n\no For join strategies, permitted values are \'join_round\' and\n  \'join_miter\'.\n\no For end strategies, permitted values are \'end_round\' and \'end_flat\'.\n\nIf the first argument is \'point_circle\', \'join_round\', \'join_miter\', or\n\'end_round\', the points_per_circle argument must be given as a positive\nnumeric value. The maximum points_per_circle value is the value of the\nmax_points_in_geometry system variable.\n\nFor examples, see the description of ST_Buffer().\n\nST_Buffer_Strategy() handles its arguments as described in the\nintroduction to this section, with these exceptions:\n\no If any argument is invalid, an ER_WRONG_ARGUMENTS\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_wrong_arguments) error occurs.\n\no If the first argument is \'point_square\' or \'end_flat\', the\n  points_per_circle argument must not be given or an ER_WRONG_ARGUMENTS\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_wrong_arguments) error occurs.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/spatial-operator-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/spatial-operator-functions.html'),(340,'ST_CONVEXHULL',30,'ST_ConvexHull(g)\n\nReturns a geometry that represents the convex hull of the geometry\nvalue g.\n\nThis function computes a geometry\'s convex hull by first checking\nwhether its vertex points are colinear. The function returns a linear\nhull if so, a polygon hull otherwise. This function processes geometry\ncollections by extracting all vertex points of all components of the\ncollection, creating a MultiPoint value from them, and computing its\nconvex hull.\n\nST_ConvexHull() handles its arguments as described in the introduction\nto this section, with this exception:\n\no The return value is NULL for the additional condition that the\n  argument is an empty geometry collection.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/spatial-operator-functions.html\n\n','mysql> SET @g = \'MULTIPOINT(5 0,25 0,15 10,15 25)\';\nmysql> SELECT ST_AsText(ST_ConvexHull(ST_GeomFromText(@g)));\n+-----------------------------------------------+\n| ST_AsText(ST_ConvexHull(ST_GeomFromText(@g))) |\n+-----------------------------------------------+\n| POLYGON((5 0,25 0,15 25,5 0))                 |\n+-----------------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/spatial-operator-functions.html'),(341,'ST_DIFFERENCE',30,'ST_Difference(g1, g2)\n\nReturns a geometry that represents the point set difference of the\ngeometry values g1 and g2. The result is in the same SRS as the\ngeometry arguments.\n\nAs of MySQL 8.0.26, ST_Difference() permits arguments in either a\nCartesian or a geographic SRS. Prior to MySQL 8.0.26, ST_Difference()\npermits arguments in a Cartesian SRS only; for arguments in a\ngeographic SRS, an ER_NOT_IMPLEMENTED_FOR_GEOGRAPHIC_SRS\n(https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference.html\n#error_er_not_implemented_for_geographic_srs) error occurs.\n\nST_Difference() handles its arguments as described in the introduction\nto this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/spatial-operator-functions.html\n\n','mysql> SET @g1 = Point(1,1), @g2 = Point(2,2);\nmysql> SELECT ST_AsText(ST_Difference(@g1, @g2));\n+------------------------------------+\n| ST_AsText(ST_Difference(@g1, @g2)) |\n+------------------------------------+\n| POINT(1 1)                         |\n+------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/spatial-operator-functions.html'),(342,'ST_INTERSECTION',30,'ST_Intersection(g1, g2)\n\nReturns a geometry that represents the point set intersection of the\ngeometry values g1 and g2. The result is in the same SRS as the\ngeometry arguments.\n\nAs of MySQL 8.0.27, ST_Intersection() permits arguments in either a\nCartesian or a geographic SRS. Prior to MySQL 8.0.27, ST_Intersection()\npermits arguments in a Cartesian SRS only; for arguments in a\ngeographic SRS, an ER_NOT_IMPLEMENTED_FOR_GEOGRAPHIC_SRS\n(https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference.html\n#error_er_not_implemented_for_geographic_srs) error occurs.\n\nST_Intersection() handles its arguments as described in the\nintroduction to this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/spatial-operator-functions.html\n\n','mysql> SET @g1 = ST_GeomFromText(\'LineString(1 1, 3 3)\');\nmysql> SET @g2 = ST_GeomFromText(\'LineString(1 3, 3 1)\');\nmysql> SELECT ST_AsText(ST_Intersection(@g1, @g2));\n+--------------------------------------+\n| ST_AsText(ST_Intersection(@g1, @g2)) |\n+--------------------------------------+\n| POINT(2 2)                           |\n+--------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/spatial-operator-functions.html'),(343,'ST_LINEINTERPOLATEPOINT',30,'ST_LineInterpolatePoint(ls, fractional_distance)\n\nThis function takes a LineString geometry and a fractional distance in\nthe range [0.0, 1.0] and returns the Point along the LineString at the\ngiven fraction of the distance from its start point to its endpoint. It\ncan be used to answer questions such as which Point lies halfway along\nthe road described by the geometry argument.\n\nThe function is implemented for LineString geometries in all spatial\nreference systems, both Cartesian and geographic.\n\nIf the fractional_distance argument is 1.0, the result may not be\nexactly the last point of the LineString argument but a point close to\nit due to numerical inaccuracies in approximate-value computations.\n\nA related function, ST_LineInterpolatePoints(), takes similar arguments\nbut returns a MultiPoint consisting of Point values along the\nLineString at each fraction of the distance from its start point to its\nendpoint. For examples of both functions, see the\nST_LineInterpolatePoints() description.\n\nST_LineInterpolatePoint() handles its arguments as described in the\nintroduction to this section, with these exceptions:\n\no If the geometry argument is not a LineString, an\n  ER_UNEXPECTED_GEOMETRY_TYPE\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_unexpected_geometry_type) error occurs.\n\no If the fractional distance argument is outside the range [0.0, 1.0],\n  an ER_DATA_OUT_OF_RANGE\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_data_out_of_range) error occurs.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/spatial-operator-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/spatial-operator-functions.html'),(344,'ST_LINEINTERPOLATEPOINTS',30,'ST_LineInterpolatePoints(ls, fractional_distance)\n\nThis function takes a LineString geometry and a fractional distance in\nthe range (0.0, 1.0] and returns the MultiPoint consisting of the\nLineString start point, plus Point values along the LineString at each\nfraction of the distance from its start point to its endpoint. It can\nbe used to answer questions such as which Point values lie every 10% of\nthe way along the road described by the geometry argument.\n\nThe function is implemented for LineString geometries in all spatial\nreference systems, both Cartesian and geographic.\n\nIf the fractional_distance argument divides 1.0 with zero remainder the\nresult may not contain the last point of the LineString argument but a\npoint close to it due to numerical inaccuracies in approximate-value\ncomputations.\n\nA related function, ST_LineInterpolatePoint(), takes similar arguments\nbut returns the Point along the LineString at the given fraction of the\ndistance from its start point to its endpoint.\n\nST_LineInterpolatePoints() handles its arguments as described in the\nintroduction to this section, with these exceptions:\n\no If the geometry argument is not a LineString, an\n  ER_UNEXPECTED_GEOMETRY_TYPE\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_unexpected_geometry_type) error occurs.\n\no If the fractional distance argument is outside the range [0.0, 1.0],\n  an ER_DATA_OUT_OF_RANGE\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_data_out_of_range) error occurs.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/spatial-operator-functions.html\n\n','mysql> SET @ls1 = ST_GeomFromText(\'LINESTRING(0 0,0 5,5 5)\');\nmysql> SELECT ST_AsText(ST_LineInterpolatePoint(@ls1, .5));\n+----------------------------------------------+\n| ST_AsText(ST_LineInterpolatePoint(@ls1, .5)) |\n+----------------------------------------------+\n| POINT(0 5)                                   |\n+----------------------------------------------+\nmysql> SELECT ST_AsText(ST_LineInterpolatePoint(@ls1, .75));\n+-----------------------------------------------+\n| ST_AsText(ST_LineInterpolatePoint(@ls1, .75)) |\n+-----------------------------------------------+\n| POINT(2.5 5)                                  |\n+-----------------------------------------------+\nmysql> SELECT ST_AsText(ST_LineInterpolatePoint(@ls1, 1));\n+---------------------------------------------+\n| ST_AsText(ST_LineInterpolatePoint(@ls1, 1)) |\n+---------------------------------------------+\n| POINT(5 5)                                  |\n+---------------------------------------------+\nmysql> SELECT ST_AsText(ST_LineInterpolatePoints(@ls1, .25));\n+------------------------------------------------+\n| ST_AsText(ST_LineInterpolatePoints(@ls1, .25)) |\n+------------------------------------------------+\n| MULTIPOINT((0 2.5),(0 5),(2.5 5),(5 5))        |\n+------------------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/spatial-operator-functions.html'),(345,'ST_POINTATDISTANCE',30,'ST_PointAtDistance(ls, distance)\n\nThis function takes a LineString geometry and a distance in the range\n[0.0, ST_Length(ls)] measured in the unit of the spatial reference\nsystem (SRS) of the LineString, and returns the Point along the\nLineString at that distance from its start point. It can be used to\nanswer questions such as which Point value is 400 meters from the start\nof the road described by the geometry argument.\n\nThe function is implemented for LineString geometries in all spatial\nreference systems, both Cartesian and geographic.\n\nST_PointAtDistance() handles its arguments as described in the\nintroduction to this section, with these exceptions:\n\no If the geometry argument is not a LineString, an\n  ER_UNEXPECTED_GEOMETRY_TYPE\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_unexpected_geometry_type) error occurs.\n\no If the fractional distance argument is outside the range [0.0,\n  ST_Length(ls)], an ER_DATA_OUT_OF_RANGE\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_data_out_of_range) error occurs.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/spatial-operator-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/spatial-operator-functions.html'),(346,'ST_SYMDIFFERENCE',30,'ST_SymDifference(g1, g2)\n\nReturns a geometry that represents the point set symmetric difference\nof the geometry values g1 and g2, which is defined as:\n\ng1 symdifference g2 := (g1 union g2) difference (g1 intersection g2)\n\nOr, in function call notation:\n\nST_SymDifference(g1, g2) = ST_Difference(ST_Union(g1, g2), ST_Intersection(g1, g2))\n\nThe result is in the same SRS as the geometry arguments.\n\nAs of MySQL 8.0.27, ST_SymDifference() permits arguments in either a\nCartesian or a geographic SRS. Prior to MySQL 8.0.27,\nST_SymDifference() permits arguments in a Cartesian SRS only; for\narguments in a geographic SRS, an ER_NOT_IMPLEMENTED_FOR_GEOGRAPHIC_SRS\n(https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference.html\n#error_er_not_implemented_for_geographic_srs) error occurs.\n\nST_SymDifference() handles its arguments as described in the\nintroduction to this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/spatial-operator-functions.html\n\n','mysql> SET @g1 = ST_GeomFromText(\'MULTIPOINT(5 0,15 10,15 25)\');\nmysql> SET @g2 = ST_GeomFromText(\'MULTIPOINT(1 1,15 10,15 25)\');\nmysql> SELECT ST_AsText(ST_SymDifference(@g1, @g2));\n+---------------------------------------+\n| ST_AsText(ST_SymDifference(@g1, @g2)) |\n+---------------------------------------+\n| MULTIPOINT((1 1),(5 0))               |\n+---------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/spatial-operator-functions.html'),(347,'ST_TRANSFORM',30,'ST_Transform(g, target_srid)\n\nTransforms a geometry from one spatial reference system (SRS) to\nanother. The return value is a geometry of the same type as the input\ngeometry with all coordinates transformed to the target SRID,\ntarget_srid. Prior to MySQL 8.0.30, transformation support was limited\nto geographic SRSs (unless the SRID of the geometry argument was the\nsame as the target SRID value, in which case the return value was the\ninput geometry for any valid SRS), and this function did not support\nCartesian SRSs. Beginning with MySQL 8.0.30, support is provided for\nthe Popular Visualisation Pseudo Mercator (EPSG 1024) projection\nmethod, used for WGS 84 Pseudo-Mercator (SRID 3857). In MySQL 8.0.32\nand later, support is extended to all SRSs defined by EPSG except for\nthose listed here:\n\no EPSG 1042 Krovak Modified\n\no EPSG 1043 Krovak Modified (North Orientated)\n\no EPSG 9816 Tunisia Mining Grid\n\no EPSG 9826 Lambert Conic Conformal (West Orientated)\n\nST_Transform() handles its arguments as described in the introduction\nto this section, with these exceptions:\n\no Geometry arguments that have an SRID value for a geographic SRS do\n  not produce an error.\n\no If the geometry or target SRID argument has an SRID value that refers\n  to an undefined spatial reference system (SRS), an ER_SRS_NOT_FOUND\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_srs_not_found) error occurs.\n\no If the geometry is in an SRS that ST_Transform() cannot transform\n  from, an ER_TRANSFORM_SOURCE_SRS_NOT_SUPPORTED\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_transform_source_srs_not_supported) error occurs.\n\no If the target SRID is in an SRS that ST_Transform() cannot transform\n  to, an ER_TRANSFORM_TARGET_SRS_NOT_SUPPORTED\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_transform_target_srs_not_supported) error occurs.\n\no If the geometry is in an SRS that is not WGS 84 and has no TOWGS84\n  clause, an ER_TRANSFORM_SOURCE_SRS_MISSING_TOWGS84\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_transform_source_srs_missing_towgs84) error occurs.\n\no If the target SRID is in an SRS that is not WGS 84 and has no TOWGS84\n  clause, an ER_TRANSFORM_TARGET_SRS_MISSING_TOWGS84\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_transform_target_srs_missing_towgs84) error occurs.\n\nST_SRID(g, target_srid) and ST_Transform(g, target_srid) differ as\nfollows:\n\no ST_SRID() changes the geometry SRID value without transforming its\n  coordinates.\n\no ST_Transform() transforms the geometry coordinates in addition to\n  changing its SRID value.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/spatial-operator-functions.html\n\n','mysql> SET @p = ST_GeomFromText(\'POINT(52.381389 13.064444)\', 4326);\nmysql> SELECT ST_AsText(@p);\n+----------------------------+\n| ST_AsText(@p)              |\n+----------------------------+\n| POINT(52.381389 13.064444) |\n+----------------------------+\nmysql> SET @p = ST_Transform(@p, 4230);\nmysql> SELECT ST_AsText(@p);\n+---------------------------------------------+\n| ST_AsText(@p)                               |\n+---------------------------------------------+\n| POINT(52.38208611407426 13.065520672345304) |\n+---------------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/spatial-operator-functions.html'),(348,'ST_UNION',30,'ST_Union(g1, g2)\n\nReturns a geometry that represents the point set union of the geometry\nvalues g1 and g2. The result is in the same SRS as the geometry\narguments.\n\nAs of MySQL 8.0.26, ST_Union() permits arguments in either a Cartesian\nor a geographic SRS. Prior to MySQL 8.0.26, ST_Union() permits\narguments in a Cartesian SRS only; for arguments in a geographic SRS,\nan ER_NOT_IMPLEMENTED_FOR_GEOGRAPHIC_SRS\n(https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference.html\n#error_er_not_implemented_for_geographic_srs) error occurs.\n\nST_Union() handles its arguments as described in the introduction to\nthis section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/spatial-operator-functions.html\n\n','mysql> SET @g1 = ST_GeomFromText(\'LineString(1 1, 3 3)\');\nmysql> SET @g2 = ST_GeomFromText(\'LineString(1 3, 3 1)\');\nmysql> SELECT ST_AsText(ST_Union(@g1, @g2));\n+--------------------------------------+\n| ST_AsText(ST_Union(@g1, @g2))        |\n+--------------------------------------+\n| MULTILINESTRING((1 1,3 3),(1 3,3 1)) |\n+--------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/spatial-operator-functions.html'),(349,'ST_CONTAINS',31,'ST_Contains(g1, g2)\n\nReturns 1 or 0 to indicate whether g1 completely contains g2. This\ntests the opposite relationship as ST_Within().\n\nST_Contains() handles its arguments as described in the introduction to\nthis section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/spatial-relation-functions-object-shapes.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/spatial-relation-functions-object-shapes.html'),(350,'ST_CROSSES',31,'ST_Crosses(g1, g2)\n\nTwo geometries spatially cross if their spatial relation has the\nfollowing properties:\n\no Unless g1 and g2 are both of dimension 1: g1 crosses g2 if the\n  interior of g2 has points in common with the interior of g1, but g2\n  does not cover the entire interior of g1.\n\no If both g1 and g2 are of dimension 1: If the lines cross each other\n  in a finite number of points (that is, no common line segments, only\n  single points in common).\n\nThis function returns 1 or 0 to indicate whether g1 spatially crosses\ng2.\n\nST_Crosses() handles its arguments as described in the introduction to\nthis section except that the return value is NULL for these additional\nconditions:\n\no g1 is of dimension 2 (Polygon or MultiPolygon).\n\no g2 is of dimension 1 (Point or MultiPoint).\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/spatial-relation-functions-object-shapes.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/spatial-relation-functions-object-shapes.html'),(351,'ST_DISJOINT',31,'ST_Disjoint(g1, g2)\n\nReturns 1 or 0 to indicate whether g1 is spatially disjoint from (does\nnot intersect) g2.\n\nST_Disjoint() handles its arguments as described in the introduction to\nthis section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/spatial-relation-functions-object-shapes.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/spatial-relation-functions-object-shapes.html'),(352,'ST_DISTANCE',31,'ST_Distance(g1, g2 [, unit])\n\nReturns the distance between g1 and g2, measured in the length unit of\nthe spatial reference system (SRS) of the geometry arguments, or in the\nunit of the optional unit argument if that is specified.\n\nThis function processes geometry collections by returning the shortest\ndistance among all combinations of the components of the two geometry\narguments.\n\nST_Distance() handles its geometry arguments as described in the\nintroduction to this section, with these exceptions:\n\no ST_Distance() detects arguments in a geographic (ellipsoidal) spatial\n  reference system and returns the geodetic distance on the ellipsoid.\n  As of MySQL 8.0.18, ST_Distance() supports distance calculations for\n  geographic SRS arguments of all geometry types. Prior to MySQL\n  8.0.18, the only permitted geographic argument types are Point and\n  Point, or Point and MultiPoint (in any argument order). If called\n  with other geometry type argument combinations in a geographic SRS,\n  an ER_NOT_IMPLEMENTED_FOR_GEOGRAPHIC_SRS\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_not_implemented_for_geographic_srs) error occurs.\n\no If any argument is geometrically invalid, either the result is an\n  undefined distance (that is, it can be any number), or an error\n  occurs.\n\no If an intermediate or final result produces NaN or a negative number,\n  an ER_GIS_INVALID_DATA\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_gis_invalid_data) error occurs.\n\nAs of MySQL 8.0.14, ST_Distance() permits an optional unit argument\nthat specifies the linear unit for the returned distance value.\nST_Distance() handles its unit argument as described in the\nintroduction to this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/spatial-relation-functions-object-shapes.html\n\n','mysql> SET @g1 = ST_GeomFromText(\'POINT(1 1)\');\nmysql> SET @g2 = ST_GeomFromText(\'POINT(2 2)\');\nmysql> SELECT ST_Distance(@g1, @g2);\n+-----------------------+\n| ST_Distance(@g1, @g2) |\n+-----------------------+\n|    1.4142135623730951 |\n+-----------------------+\n\nmysql> SET @g1 = ST_GeomFromText(\'POINT(1 1)\', 4326);\nmysql> SET @g2 = ST_GeomFromText(\'POINT(2 2)\', 4326);\nmysql> SELECT ST_Distance(@g1, @g2);\n+-----------------------+\n| ST_Distance(@g1, @g2) |\n+-----------------------+\n|     156874.3859490455 |\n+-----------------------+\nmysql> SELECT ST_Distance(@g1, @g2, \'metre\');\n+--------------------------------+\n| ST_Distance(@g1, @g2, \'metre\') |\n+--------------------------------+\n|              156874.3859490455 |\n+--------------------------------+\nmysql> SELECT ST_Distance(@g1, @g2, \'foot\');\n+-------------------------------+\n| ST_Distance(@g1, @g2, \'foot\') |\n+-------------------------------+\n|             514679.7439273146 |\n+-------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/spatial-relation-functions-object-shapes.html'),(353,'ST_EQUALS',31,'ST_Equals(g1, g2)\n\nReturns 1 or 0 to indicate whether g1 is spatially equal to g2.\n\nST_Equals() handles its arguments as described in the introduction to\nthis section, except that it does not return NULL for empty geometry\narguments.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/spatial-relation-functions-object-shapes.html\n\n','mysql> SET @g1 = Point(1,1), @g2 = Point(2,2);\nmysql> SELECT ST_Equals(@g1, @g1), ST_Equals(@g1, @g2);\n+---------------------+---------------------+\n| ST_Equals(@g1, @g1) | ST_Equals(@g1, @g2) |\n+---------------------+---------------------+\n|                   1 |                   0 |\n+---------------------+---------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/spatial-relation-functions-object-shapes.html'),(354,'ST_FRECHETDISTANCE',31,'ST_FrechetDistance(g1, g2 [, unit])\n\nReturns the discrete Fréchet distance between two geometries,\nreflecting how similar the geometries are. The result is a\ndouble-precision number measured in the length unit of the spatial\nreference system (SRS) of the geometry arguments, or in the length unit\nof the unit argument if that argument is given.\n\nThis function implements the discrete Fréchet distance, which means it\nis restricted to distances between the points of the geometries. For\nexample, given two LineString arguments, only the points explicitly\nmentioned in the geometries are considered. Points on the line segments\nbetween these points are not considered.\n\nST_FrechetDistance() handles its geometry arguments as described in the\nintroduction to this section, with these exceptions:\n\no The geometries may have a Cartesian or geographic SRS, but only\n  LineString values are supported. If the arguments are in the same\n  Cartesian or geographic SRS, but either is not a LineString, an\n  ER_NOT_IMPLEMENTED_FOR_CARTESIAN_SRS\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_not_implemented_for_cartesian_srs) or\n  ER_NOT_IMPLEMENTED_FOR_GEOGRAPHIC_SRS\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_not_implemented_for_geographic_srs) error occurs,\n  depending on the SRS type.\n\nST_FrechetDistance() handles its optional unit argument as described in\nthe introduction to this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/spatial-relation-functions-object-shapes.html\n\n','mysql> SET @ls1 = ST_GeomFromText(\'LINESTRING(0 0,0 5,5 5)\');\nmysql> SET @ls2 = ST_GeomFromText(\'LINESTRING(0 1,0 6,3 3,5 6)\');\nmysql> SELECT ST_FrechetDistance(@ls1, @ls2);\n+--------------------------------+\n| ST_FrechetDistance(@ls1, @ls2) |\n+--------------------------------+\n|             2.8284271247461903 |\n+--------------------------------+\n\nmysql> SET @ls1 = ST_GeomFromText(\'LINESTRING(0 0,0 5,5 5)\', 4326);\nmysql> SET @ls2 = ST_GeomFromText(\'LINESTRING(0 1,0 6,3 3,5 6)\', 4326);\nmysql> SELECT ST_FrechetDistance(@ls1, @ls2);\n+--------------------------------+\n| ST_FrechetDistance(@ls1, @ls2) |\n+--------------------------------+\n|              313421.1999416798 |\n+--------------------------------+\nmysql> SELECT ST_FrechetDistance(@ls1, @ls2, \'foot\');\n+----------------------------------------+\n| ST_FrechetDistance(@ls1, @ls2, \'foot\') |\n+----------------------------------------+\n|                     1028284.7767115477 |\n+----------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/spatial-relation-functions-object-shapes.html'),(355,'ST_HAUSDORFFDISTANCE',31,'ST_HausdorffDistance(g1, g2 [, unit])\n\nReturns the discrete Hausdorff distance between two geometries,\nreflecting how similar the geometries are. The result is a\ndouble-precision number measured in the length unit of the spatial\nreference system (SRS) of the geometry arguments, or in the length unit\nof the unit argument if that argument is given.\n\nThis function implements the discrete Hausdorff distance, which means\nit is restricted to distances between the points of the geometries. For\nexample, given two LineString arguments, only the points explicitly\nmentioned in the geometries are considered. Points on the line segments\nbetween these points are not considered.\n\nST_HausdorffDistance() handles its geometry arguments as described in\nthe introduction to this section, with these exceptions:\n\no If the geometry arguments are in the same Cartesian or geographic\n  SRS, but are not in a supported combination, an\n  ER_NOT_IMPLEMENTED_FOR_CARTESIAN_SRS\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_not_implemented_for_cartesian_srs) or\n  ER_NOT_IMPLEMENTED_FOR_GEOGRAPHIC_SRS\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_not_implemented_for_geographic_srs) error occurs,\n  depending on the SRS type. These combinations are supported:\n\n  o LineString and LineString\n\n  o Point and MultiPoint\n\n  o LineString and MultiLineString\n\n  o MultiPoint and MultiPoint\n\n  o MultiLineString and MultiLineString\n\nST_HausdorffDistance() handles its optional unit argument as described\nin the introduction to this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/spatial-relation-functions-object-shapes.html\n\n','mysql> SET @ls1 = ST_GeomFromText(\'LINESTRING(0 0,0 5,5 5)\');\nmysql> SET @ls2 = ST_GeomFromText(\'LINESTRING(0 1,0 6,3 3,5 6)\');\nmysql> SELECT ST_HausdorffDistance(@ls1, @ls2);\n+----------------------------------+\n| ST_HausdorffDistance(@ls1, @ls2) |\n+----------------------------------+\n|                                1 |\n+----------------------------------+\n\nmysql> SET @ls1 = ST_GeomFromText(\'LINESTRING(0 0,0 5,5 5)\', 4326);\nmysql> SET @ls2 = ST_GeomFromText(\'LINESTRING(0 1,0 6,3 3,5 6)\', 4326);\nmysql> SELECT ST_HausdorffDistance(@ls1, @ls2);\n+----------------------------------+\n| ST_HausdorffDistance(@ls1, @ls2) |\n+----------------------------------+\n|               111319.49079326246 |\n+----------------------------------+\nmysql> SELECT ST_HausdorffDistance(@ls1, @ls2, \'foot\');\n+------------------------------------------+\n| ST_HausdorffDistance(@ls1, @ls2, \'foot\') |\n+------------------------------------------+\n|                        365221.4264870815 |\n+------------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/spatial-relation-functions-object-shapes.html'),(356,'ST_INTERSECTS',31,'ST_Intersects(g1, g2)\n\nReturns 1 or 0 to indicate whether g1 spatially intersects g2.\n\nST_Intersects() handles its arguments as described in the introduction\nto this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/spatial-relation-functions-object-shapes.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/spatial-relation-functions-object-shapes.html'),(357,'ST_OVERLAPS',31,'ST_Overlaps(g1, g2)\n\nTwo geometries spatially overlap if they intersect and their\nintersection results in a geometry of the same dimension but not equal\nto either of the given geometries.\n\nThis function returns 1 or 0 to indicate whether g1 spatially overlaps\ng2.\n\nST_Overlaps() handles its arguments as described in the introduction to\nthis section except that the return value is NULL for the additional\ncondition that the dimensions of the two geometries are not equal.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/spatial-relation-functions-object-shapes.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/spatial-relation-functions-object-shapes.html'),(358,'ST_TOUCHES',31,'ST_Touches(g1, g2)\n\nTwo geometries spatially touch if their interiors do not intersect, but\nthe boundary of one of the geometries intersects either the boundary or\nthe interior of the other.\n\nThis function returns 1 or 0 to indicate whether g1 spatially touches\ng2.\n\nST_Touches() handles its arguments as described in the introduction to\nthis section except that the return value is NULL for the additional\ncondition that both geometries are of dimension 0 (Point or\nMultiPoint).\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/spatial-relation-functions-object-shapes.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/spatial-relation-functions-object-shapes.html'),(359,'ST_WITHIN',31,'ST_Within(g1, g2)\n\nReturns 1 or 0 to indicate whether g1 is spatially within g2. This\ntests the opposite relationship as ST_Contains().\n\nST_Within() handles its arguments as described in the introduction to\nthis section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/spatial-relation-functions-object-shapes.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/spatial-relation-functions-object-shapes.html'),(360,'MBRCONTAINS',32,'MBRContains(g1, g2)\n\nReturns 1 or 0 to indicate whether the minimum bounding rectangle of g1\ncontains the minimum bounding rectangle of g2. This tests the opposite\nrelationship as MBRWithin().\n\nMBRContains() handles its arguments as described in the introduction to\nthis section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/spatial-relation-functions-mbr.html\n\n','mysql> SET @g1 = ST_GeomFromText(\'Polygon((0 0,0 3,3 3,3 0,0 0))\');\nmysql> SET @g2 = ST_GeomFromText(\'Point(1 1)\');\nmysql> SELECT MBRContains(@g1,@g2), MBRWithin(@g2,@g1);\n+----------------------+--------------------+\n| MBRContains(@g1,@g2) | MBRWithin(@g2,@g1) |\n+----------------------+--------------------+\n|                    1 |                  1 |\n+----------------------+--------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/spatial-relation-functions-mbr.html'),(361,'MBRCOVEREDBY',32,'MBRCoveredBy(g1, g2)\n\nReturns 1 or 0 to indicate whether the minimum bounding rectangle of g1\nis covered by the minimum bounding rectangle of g2. This tests the\nopposite relationship as MBRCovers().\n\nMBRCoveredBy() handles its arguments as described in the introduction\nto this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/spatial-relation-functions-mbr.html\n\n','mysql> SET @g1 = ST_GeomFromText(\'Polygon((0 0,0 3,3 3,3 0,0 0))\');\nmysql> SET @g2 = ST_GeomFromText(\'Point(1 1)\');\nmysql> SELECT MBRCovers(@g1,@g2), MBRCoveredby(@g1,@g2);\n+--------------------+-----------------------+\n| MBRCovers(@g1,@g2) | MBRCoveredby(@g1,@g2) |\n+--------------------+-----------------------+\n|                  1 |                     0 |\n+--------------------+-----------------------+\nmysql> SELECT MBRCovers(@g2,@g1), MBRCoveredby(@g2,@g1);\n+--------------------+-----------------------+\n| MBRCovers(@g2,@g1) | MBRCoveredby(@g2,@g1) |\n+--------------------+-----------------------+\n|                  0 |                     1 |\n+--------------------+-----------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/spatial-relation-functions-mbr.html'),(362,'MBRCOVERS',32,'MBRCovers(g1, g2)\n\nReturns 1 or 0 to indicate whether the minimum bounding rectangle of g1\ncovers the minimum bounding rectangle of g2. This tests the opposite\nrelationship as MBRCoveredBy(). See the description of MBRCoveredBy()\nfor examples.\n\nMBRCovers() handles its arguments as described in the introduction to\nthis section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/spatial-relation-functions-mbr.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/spatial-relation-functions-mbr.html'),(363,'MBRDISJOINT',32,'MBRDisjoint(g1, g2)\n\nReturns 1 or 0 to indicate whether the minimum bounding rectangles of\nthe two geometries g1 and g2 are disjoint (do not intersect).\n\nMBRDisjoint() handles its arguments as described in the introduction to\nthis section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/spatial-relation-functions-mbr.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/spatial-relation-functions-mbr.html'),(364,'MBREQUALS',32,'MBREquals(g1, g2)\n\nReturns 1 or 0 to indicate whether the minimum bounding rectangles of\nthe two geometries g1 and g2 are the same.\n\nMBREquals() handles its arguments as described in the introduction to\nthis section, except that it does not return NULL for empty geometry\narguments.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/spatial-relation-functions-mbr.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/spatial-relation-functions-mbr.html'),(365,'MBRINTERSECTS',32,'MBRIntersects(g1, g2)\n\nReturns 1 or 0 to indicate whether the minimum bounding rectangles of\nthe two geometries g1 and g2 intersect.\n\nMBRIntersects() handles its arguments as described in the introduction\nto this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/spatial-relation-functions-mbr.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/spatial-relation-functions-mbr.html'),(366,'MBROVERLAPS',32,'MBROverlaps(g1, g2)\n\nTwo geometries spatially overlap if they intersect and their\nintersection results in a geometry of the same dimension but not equal\nto either of the given geometries.\n\nThis function returns 1 or 0 to indicate whether the minimum bounding\nrectangles of the two geometries g1 and g2 overlap.\n\nMBROverlaps() handles its arguments as described in the introduction to\nthis section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/spatial-relation-functions-mbr.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/spatial-relation-functions-mbr.html'),(367,'MBRTOUCHES',32,'MBRTouches(g1, g2)\n\nTwo geometries spatially touch if their interiors do not intersect, but\nthe boundary of one of the geometries intersects either the boundary or\nthe interior of the other.\n\nThis function returns 1 or 0 to indicate whether the minimum bounding\nrectangles of the two geometries g1 and g2 touch.\n\nMBRTouches() handles its arguments as described in the introduction to\nthis section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/spatial-relation-functions-mbr.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/spatial-relation-functions-mbr.html'),(368,'MBRWITHIN',32,'MBRWithin(g1, g2)\n\nReturns 1 or 0 to indicate whether the minimum bounding rectangle of g1\nis within the minimum bounding rectangle of g2. This tests the opposite\nrelationship as MBRContains().\n\nMBRWithin() handles its arguments as described in the introduction to\nthis section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/spatial-relation-functions-mbr.html\n\n','mysql> SET @g1 = ST_GeomFromText(\'Polygon((0 0,0 3,3 3,3 0,0 0))\');\nmysql> SET @g2 = ST_GeomFromText(\'Polygon((0 0,0 5,5 5,5 0,0 0))\');\nmysql> SELECT MBRWithin(@g1,@g2), MBRWithin(@g2,@g1);\n+--------------------+--------------------+\n| MBRWithin(@g1,@g2) | MBRWithin(@g2,@g1) |\n+--------------------+--------------------+\n|                  1 |                  0 |\n+--------------------+--------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/spatial-relation-functions-mbr.html'),(369,'ST_GEOHASH',32,'ST_GeoHash(longitude, latitude, max_length), ST_GeoHash(point,\nmax_length)\n\nReturns a geohash string in the connection character set and collation.\n\nFor the first syntax, the longitude must be a number in the range\n[−180, 180], and the latitude must be a number in the range [−90,\n90]. For the second syntax, a POINT value is required, where the X and\nY coordinates are in the valid ranges for longitude and latitude,\nrespectively.\n\nThe resulting string is no longer than max_length characters, which has\nan upper limit of 100. The string might be shorter than max_length\ncharacters because the algorithm that creates the geohash value\ncontinues until it has created a string that is either an exact\nrepresentation of the location or max_length characters, whichever\ncomes first.\n\nST_GeoHash() handles its arguments as described in the introduction to\nthis section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/spatial-geohash-functions.html\n\n','mysql> SELECT ST_GeoHash(180,0,10), ST_GeoHash(-180,-90,15);\n+----------------------+-------------------------+\n| ST_GeoHash(180,0,10) | ST_GeoHash(-180,-90,15) |\n+----------------------+-------------------------+\n| xbpbpbpbpb           | 000000000000000         |\n+----------------------+-------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/spatial-geohash-functions.html'),(370,'ST_LATFROMGEOHASH',32,'ST_LatFromGeoHash(geohash_str)\n\nReturns the latitude from a geohash string value, as a double-precision\nnumber in the range [−90, 90].\n\nThe ST_LatFromGeoHash() decoding function reads no more than 433\ncharacters from the geohash_str argument. That represents the upper\nlimit on information in the internal representation of coordinate\nvalues. Characters past the 433rd are ignored, even if they are\notherwise illegal and produce an error.\n\nST_LatFromGeoHash() handles its arguments as described in the\nintroduction to this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/spatial-geohash-functions.html\n\n','mysql> SELECT ST_LatFromGeoHash(ST_GeoHash(45,-20,10));\n+------------------------------------------+\n| ST_LatFromGeoHash(ST_GeoHash(45,-20,10)) |\n+------------------------------------------+\n|                                      -20 |\n+------------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/spatial-geohash-functions.html'),(371,'ST_LONGFROMGEOHASH',32,'ST_LongFromGeoHash(geohash_str)\n\nReturns the longitude from a geohash string value, as a\ndouble-precision number in the range [−180, 180].\n\nThe remarks in the description of ST_LatFromGeoHash() regarding the\nmaximum number of characters processed from the geohash_str argument\nalso apply to ST_LongFromGeoHash().\n\nST_LongFromGeoHash() handles its arguments as described in the\nintroduction to this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/spatial-geohash-functions.html\n\n','mysql> SELECT ST_LongFromGeoHash(ST_GeoHash(45,-20,10));\n+-------------------------------------------+\n| ST_LongFromGeoHash(ST_GeoHash(45,-20,10)) |\n+-------------------------------------------+\n|                                        45 |\n+-------------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/spatial-geohash-functions.html'),(372,'ST_POINTFROMGEOHASH',32,'ST_PointFromGeoHash(geohash_str, srid)\n\nReturns a POINT value containing the decoded geohash value, given a\ngeohash string value.\n\nThe X and Y coordinates of the point are the longitude in the range\n[−180, 180] and the latitude in the range [−90, 90], respectively.\n\nThe srid argument is an 32-bit unsigned integer.\n\nThe remarks in the description of ST_LatFromGeoHash() regarding the\nmaximum number of characters processed from the geohash_str argument\nalso apply to ST_PointFromGeoHash().\n\nST_PointFromGeoHash() handles its arguments as described in the\nintroduction to this section.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/spatial-geohash-functions.html\n\n','mysql> SET @gh = ST_GeoHash(45,-20,10);\nmysql> SELECT ST_AsText(ST_PointFromGeoHash(@gh,0));\n+---------------------------------------+\n| ST_AsText(ST_PointFromGeoHash(@gh,0)) |\n+---------------------------------------+\n| POINT(45 -20)                         |\n+---------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/spatial-geohash-functions.html'),(373,'ST_ASGEOJSON',32,'ST_AsGeoJSON(g [, max_dec_digits [, options]])\n\nGenerates a GeoJSON object from the geometry g. The object string has\nthe connection character set and collation.\n\nIf any argument is NULL, the return value is NULL. If any non-NULL\nargument is invalid, an error occurs.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/spatial-geojson-functions.html\n\n','mysql> SELECT ST_AsGeoJSON(ST_GeomFromText(\'POINT(11.11111 12.22222)\'),2);\n+-------------------------------------------------------------+\n| ST_AsGeoJSON(ST_GeomFromText(\'POINT(11.11111 12.22222)\'),2) |\n+-------------------------------------------------------------+\n| {\"type\": \"Point\", \"coordinates\": [11.11, 12.22]}            |\n+-------------------------------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/spatial-geojson-functions.html'),(374,'ST_GEOMFROMGEOJSON',32,'ST_GeomFromGeoJSON(str [, options [, srid]])\n\nParses a string str representing a GeoJSON object and returns a\ngeometry.\n\nIf any argument is NULL, the return value is NULL. If any non-NULL\nargument is invalid, an error occurs.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/spatial-geojson-functions.html\n\n','mysql> SET @json = \'{ \"type\": \"Point\", \"coordinates\": [102.0, 0.0]}\';\nmysql> SELECT ST_AsText(ST_GeomFromGeoJSON(@json));\n+--------------------------------------+\n| ST_AsText(ST_GeomFromGeoJSON(@json)) |\n+--------------------------------------+\n| POINT(0 102)                         |\n+--------------------------------------+\nmysql> SELECT ST_SRID(ST_GeomFromGeoJSON(@json));\n+------------------------------------+\n| ST_SRID(ST_GeomFromGeoJSON(@json)) |\n+------------------------------------+\n|                               4326 |\n+------------------------------------+\nmysql> SELECT ST_AsText(ST_SRID(ST_GeomFromGeoJSON(@json),0));\n+-------------------------------------------------+\n| ST_AsText(ST_SRID(ST_GeomFromGeoJSON(@json),0)) |\n+-------------------------------------------------+\n| POINT(102 0)                                    |\n+-------------------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/spatial-geojson-functions.html'),(375,'ST_COLLECT',32,'ST_Collect([DISTINCT] g) [over_clause]\n\nAggregates geometry values and returns a single geometry collection\nvalue. With the DISTINCT option, returns the aggregation of the\ndistinct geometry arguments.\n\nAs with other aggregate functions, GROUP BY may be used to group\narguments into subsets. ST_Collect() returns an aggregate value for\neach subset.\n\nThis function executes as a window function if over_clause is present.\nover_clause is as described in\nhttps://dev.mysql.com/doc/refman/8.0/en/window-functions-usage.html. In\ncontrast to most aggregate functions that support windowing,\nST_Collect() permits use of over_clause together with DISTINCT.\n\nST_Collect() handles its arguments as follows:\n\no NULL arguments are ignored.\n\no If all arguments are NULL or the aggregate result is empty, the\n  return value is NULL.\n\no If any geometry argument is not a syntactically well-formed geometry,\n  an ER_GIS_INVALID_DATA\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_gis_invalid_data) error occurs.\n\no If any geometry argument is a syntactically well-formed geometry in\n  an undefined spatial reference system (SRS), an ER_SRS_NOT_FOUND\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_srs_not_found) error occurs.\n\no If there are multiple geometry arguments and those arguments are in\n  the same SRS, the return value is in that SRS. If those arguments are\n  not in the same SRS, an ER_GIS_DIFFERENT_SRIDS_AGGREGATION\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_gis_different_srids_aggregation) error occurs.\n\no The result is the narrowest MultiXxx or GeometryCollection value\n  possible, with the result type determined from the non-NULL geometry\n  arguments as follows:\n\n  o If all arguments are Point values, the result is a MultiPoint\n    value.\n\n  o If all arguments are LineString values, the result is a\n    MultiLineString value.\n\n  o If all arguments are Polygon values, the result is a MultiPolygon\n    value.\n\n  o Otherwise, the arguments are a mix of geometry types and the result\n    is a GeometryCollection value.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/spatial-aggregate-functions.html\n\n','CREATE TABLE product (\n  year INTEGER,\n  product VARCHAR(256),\n  location Geometry\n);\n\nINSERT INTO product\n(year,  product,     location) VALUES\n(2000, \"Calculator\", ST_GeomFromText(\'point(60 -24)\',4326)),\n(2000, \"Computer\"  , ST_GeomFromText(\'point(28 -77)\',4326)),\n(2000, \"Abacus\"    , ST_GeomFromText(\'point(28 -77)\',4326)),\n(2000, \"TV\"        , ST_GeomFromText(\'point(38  60)\',4326)),\n(2001, \"Calculator\", ST_GeomFromText(\'point(60 -24)\',4326)),\n(2001, \"Computer\"  , ST_GeomFromText(\'point(28 -77)\',4326));\n\nmysql> SELECT ST_AsText(ST_Collect(location)) AS result\n       FROM product;\n+------------------------------------------------------------------+\n| result                                                           |\n+------------------------------------------------------------------+\n| MULTIPOINT((60 -24),(28 -77),(28 -77),(38 60),(60 -24),(28 -77)) |\n+------------------------------------------------------------------+\n\nmysql> SELECT ST_AsText(ST_Collect(DISTINCT location)) AS result\n       FROM product;\n+---------------------------------------+\n| result                                |\n+---------------------------------------+\n| MULTIPOINT((60 -24),(28 -77),(38 60)) |\n+---------------------------------------+\n\nmysql> SELECT year, ST_AsText(ST_Collect(location)) AS result\n       FROM product GROUP BY year;\n+------+------------------------------------------------+\n| year | result                                         |\n+------+------------------------------------------------+\n| 2000 | MULTIPOINT((60 -24),(28 -77),(28 -77),(38 60)) |\n| 2001 | MULTIPOINT((60 -24),(28 -77))                  |\n+------+------------------------------------------------+\n\nmysql> SELECT year, ST_AsText(ST_Collect(DISTINCT location)) AS result\n       FROM product GROUP BY year;\n+------+---------------------------------------+\n| year | result                                |\n+------+---------------------------------------+\n| 2000 | MULTIPOINT((60 -24),(28 -77),(38 60)) |\n| 2001 | MULTIPOINT((60 -24),(28 -77))         |\n+------+---------------------------------------+\n\n# selects nothing\nmysql> SELECT ST_Collect(location) AS result\n       FROM product WHERE year = 1999;\n+--------+\n| result |\n+--------+\n| NULL   |\n+--------+\n\nmysql> SELECT ST_AsText(ST_Collect(location)\n         OVER (ORDER BY year, product ROWS BETWEEN 1 PRECEDING AND CURRENT ROW))\n         AS result\n       FROM product;\n+-------------------------------+\n| result                        |\n+-------------------------------+\n| MULTIPOINT((28 -77))          |\n| MULTIPOINT((28 -77),(60 -24)) |\n| MULTIPOINT((60 -24),(28 -77)) |\n| MULTIPOINT((28 -77),(38 60))  |\n| MULTIPOINT((38 60),(60 -24))  |\n| MULTIPOINT((60 -24),(28 -77)) |\n+-------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/spatial-aggregate-functions.html'),(376,'ST_DISTANCE_SPHERE',32,'ST_Distance_Sphere(g1, g2 [, radius])\n\nReturns the minimum spherical distance between Point or MultiPoint\narguments on a sphere, in meters. (For general-purpose distance\ncalculations, see the ST_Distance() function.) The optional radius\nargument should be given in meters.\n\nIf both geometry parameters are valid Cartesian Point or MultiPoint\nvalues in SRID 0, the return value is shortest distance between the two\ngeometries on a sphere with the provided radius. If omitted, the\ndefault radius is 6,370,986 meters, Point X and Y coordinates are\ninterpreted as longitude and latitude, respectively, in degrees.\n\nIf both geometry parameters are valid Point or MultiPoint values in a\ngeographic spatial reference system (SRS), the return value is the\nshortest distance between the two geometries on a sphere with the\nprovided radius. If omitted, the default radius is equal to the mean\nradius, defined as (2a+b)/3, where a is the semi-major axis and b is\nthe semi-minor axis of the SRS.\n\nST_Distance_Sphere() handles its arguments as described in the\nintroduction to this section, with these exceptions:\n\no Supported geometry argument combinations are Point and Point, or\n  Point and MultiPoint (in any argument order). If at least one of the\n  geometries is neither Point nor MultiPoint, and its SRID is 0, an\n  ER_NOT_IMPLEMENTED_FOR_CARTESIAN_SRS\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_not_implemented_for_cartesian_srs) error occurs. If at\n  least one of the geometries is neither Point nor MultiPoint, and its\n  SRID refers to a geographic SRS, an\n  ER_NOT_IMPLEMENTED_FOR_GEOGRAPHIC_SRS\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_not_implemented_for_geographic_srs) error occurs. If\n  any geometry refers to a projected SRS, an\n  ER_NOT_IMPLEMENTED_FOR_PROJECTED_SRS\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_not_implemented_for_projected_srs) error occurs.\n\no If any argument has a longitude or latitude that is out of range, an\n  error occurs:\n\n  o If a longitude value is not in the range (−180, 180], an\n    ER_GEOMETRY_PARAM_LONGITUDE_OUT_OF_RANGE\n    (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-referen\n    ce.html#error_er_geometry_param_longitude_out_of_range) error\n    occurs (ER_LONGITUDE_OUT_OF_RANGE\n    (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-referen\n    ce.html#error_er_longitude_out_of_range) prior to MySQL 8.0.12).\n\n  o If a latitude value is not in the range [−90, 90], an\n    ER_GEOMETRY_PARAM_LATITUDE_OUT_OF_RANGE\n    (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-referen\n    ce.html#error_er_geometry_param_latitude_out_of_range) error occurs\n    (ER_LATITUDE_OUT_OF_RANGE\n    (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-referen\n    ce.html#error_er_latitude_out_of_range) prior to MySQL 8.0.12).\n\n  Ranges shown are in degrees. If an SRS uses another unit, the range\n  uses the corresponding values in its unit. The exact range limits\n  deviate slightly due to floating-point arithmetic.\n\no If the radius argument is present but not positive, an\n  ER_NONPOSITIVE_RADIUS\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_nonpositive_radius) error occurs.\n\no If the distance exceeds the range of a double-precision number, an\n  ER_STD_OVERFLOW_ERROR\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_std_overflow_error) error occurs.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/spatial-convenience-functions.html\n\n','mysql> SET @pt1 = ST_GeomFromText(\'POINT(0 0)\');\nmysql> SET @pt2 = ST_GeomFromText(\'POINT(180 0)\');\nmysql> SELECT ST_Distance_Sphere(@pt1, @pt2);\n+--------------------------------+\n| ST_Distance_Sphere(@pt1, @pt2) |\n+--------------------------------+\n|             20015042.813723423 |\n+--------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/spatial-convenience-functions.html'),(377,'ST_ISVALID',32,'ST_IsValid(g)\n\nReturns 1 if the argument is geometrically valid, 0 if the argument is\nnot geometrically valid. Geometry validity is defined by the OGC\nspecification.\n\nThe only valid empty geometry is represented in the form of an empty\ngeometry collection value. ST_IsValid() returns 1 in this case. MySQL\ndoes not support GIS EMPTY values such as POINT EMPTY.\n\nST_IsValid() handles its arguments as described in the introduction to\nthis section, with this exception:\n\no If the geometry has a geographic SRS with a longitude or latitude\n  that is out of range, an error occurs:\n\n  o If a longitude value is not in the range (−180, 180], an\n    ER_GEOMETRY_PARAM_LONGITUDE_OUT_OF_RANGE\n    (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-referen\n    ce.html#error_er_geometry_param_longitude_out_of_range) error\n    occurs (ER_LONGITUDE_OUT_OF_RANGE\n    (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-referen\n    ce.html#error_er_longitude_out_of_range) prior to MySQL 8.0.12).\n\n  o If a latitude value is not in the range [−90, 90], an\n    ER_GEOMETRY_PARAM_LATITUDE_OUT_OF_RANGE\n    (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-referen\n    ce.html#error_er_geometry_param_latitude_out_of_range) error occurs\n    (ER_LATITUDE_OUT_OF_RANGE\n    (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-referen\n    ce.html#error_er_latitude_out_of_range) prior to MySQL 8.0.12).\n\n  Ranges shown are in degrees. If an SRS uses another unit, the range\n  uses the corresponding values in its unit. The exact range limits\n  deviate slightly due to floating-point arithmetic.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/spatial-convenience-functions.html\n\n','mysql> SET @ls1 = ST_GeomFromText(\'LINESTRING(0 0,-0.00 0,0.0 0)\');\nmysql> SET @ls2 = ST_GeomFromText(\'LINESTRING(0 0, 1 1)\');\nmysql> SELECT ST_IsValid(@ls1);\n+------------------+\n| ST_IsValid(@ls1) |\n+------------------+\n|                0 |\n+------------------+\nmysql> SELECT ST_IsValid(@ls2);\n+------------------+\n| ST_IsValid(@ls2) |\n+------------------+\n|                1 |\n+------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/spatial-convenience-functions.html'),(378,'ST_MAKEENVELOPE',32,'ST_MakeEnvelope(pt1, pt2)\n\nReturns the rectangle that forms the envelope around two points, as a\nPoint, LineString, or Polygon.\n\nCalculations are done using the Cartesian coordinate system rather than\non a sphere, spheroid, or on earth.\n\nGiven two points pt1 and pt2, ST_MakeEnvelope() creates the result\ngeometry on an abstract plane like this:\n\no If pt1 and pt2 are equal, the result is the point pt1.\n\no Otherwise, if (pt1, pt2) is a vertical or horizontal line segment,\n  the result is the line segment (pt1, pt2).\n\no Otherwise, the result is a polygon using pt1 and pt2 as diagonal\n  points.\n\nThe result geometry has an SRID of 0.\n\nST_MakeEnvelope() handles its arguments as described in the\nintroduction to this section, with these exceptions:\n\no If the arguments are not Point values, an ER_WRONG_ARGUMENTS\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_wrong_arguments) error occurs.\n\no An ER_GIS_INVALID_DATA\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_gis_invalid_data) error occurs for the additional\n  condition that any coordinate value of the two points is infinite or\n  NaN.\n\no If any geometry has an SRID value for a geographic spatial reference\n  system (SRS), an ER_NOT_IMPLEMENTED_FOR_GEOGRAPHIC_SRS\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_not_implemented_for_geographic_srs) error occurs.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/spatial-convenience-functions.html\n\n','mysql> SET @pt1 = ST_GeomFromText(\'POINT(0 0)\');\nmysql> SET @pt2 = ST_GeomFromText(\'POINT(1 1)\');\nmysql> SELECT ST_AsText(ST_MakeEnvelope(@pt1, @pt2));\n+----------------------------------------+\n| ST_AsText(ST_MakeEnvelope(@pt1, @pt2)) |\n+----------------------------------------+\n| POLYGON((0 0,1 0,1 1,0 1,0 0))         |\n+----------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/spatial-convenience-functions.html'),(379,'ST_SIMPLIFY',32,'ST_Simplify(g, max_distance)\n\nSimplifies a geometry using the Douglas-Peucker algorithm and returns a\nsimplified value of the same type.\n\nThe geometry may be any geometry type, although the Douglas-Peucker\nalgorithm may not actually process every type. A geometry collection is\nprocessed by giving its components one by one to the simplification\nalgorithm, and the returned geometries are put into a geometry\ncollection as result.\n\nThe max_distance argument is the distance (in units of the input\ncoordinates) of a vertex to other segments to be removed. Vertices\nwithin this distance of the simplified linestring are removed.\n\nAccording to Boost.Geometry, geometries might become invalid as a\nresult of the simplification process, and the process might create\nself-intersections. To check the validity of the result, pass it to\nST_IsValid().\n\nST_Simplify() handles its arguments as described in the introduction to\nthis section, with this exception:\n\no If the max_distance argument is not positive, or is NaN, an\n  ER_WRONG_ARGUMENTS\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_wrong_arguments) error occurs.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/spatial-convenience-functions.html\n\n','mysql> SET @g = ST_GeomFromText(\'LINESTRING(0 0,0 1,1 1,1 2,2 2,2 3,3 3)\');\nmysql> SELECT ST_AsText(ST_Simplify(@g, 0.5));\n+---------------------------------+\n| ST_AsText(ST_Simplify(@g, 0.5)) |\n+---------------------------------+\n| LINESTRING(0 0,0 1,1 1,2 3,3 3) |\n+---------------------------------+\nmysql> SELECT ST_AsText(ST_Simplify(@g, 1.0));\n+---------------------------------+\n| ST_AsText(ST_Simplify(@g, 1.0)) |\n+---------------------------------+\n| LINESTRING(0 0,3 3)             |\n+---------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/spatial-convenience-functions.html'),(380,'ST_VALIDATE',32,'ST_Validate(g)\n\nValidates a geometry according to the OGC specification. A geometry can\nbe syntactically well-formed (WKB value plus SRID) but geometrically\ninvalid. For example, this polygon is geometrically invalid: POLYGON((0\n0, 0 0, 0 0, 0 0, 0 0))\n\nST_Validate() returns the geometry if it is syntactically well-formed\nand is geometrically valid, NULL if the argument is not syntactically\nwell-formed or is not geometrically valid or is NULL.\n\nST_Validate() can be used to filter out invalid geometry data, although\nat a cost. For applications that require more precise results not\ntainted by invalid data, this penalty may be worthwhile.\n\nIf the geometry argument is valid, it is returned as is, except that if\nan input Polygon or MultiPolygon has clockwise rings, those rings are\nreversed before checking for validity. If the geometry is valid, the\nvalue with the reversed rings is returned.\n\nThe only valid empty geometry is represented in the form of an empty\ngeometry collection value. ST_Validate() returns it directly without\nfurther checks in this case.\n\nAs of MySQL 8.0.13, ST_Validate() handles its arguments as described in\nthe introduction to this section, with these exceptions:\n\no If the geometry has a geographic SRS with a longitude or latitude\n  that is out of range, an error occurs:\n\n  o If a longitude value is not in the range (−180, 180], an\n    ER_GEOMETRY_PARAM_LONGITUDE_OUT_OF_RANGE\n    (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-referen\n    ce.html#error_er_geometry_param_longitude_out_of_range) error\n    occurs (ER_LONGITUDE_OUT_OF_RANGE\n    (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-referen\n    ce.html#error_er_longitude_out_of_range) prior to MySQL 8.0.12).\n\n  o If a latitude value is not in the range [−90, 90], an\n    ER_GEOMETRY_PARAM_LATITUDE_OUT_OF_RANGE\n    (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-referen\n    ce.html#error_er_geometry_param_latitude_out_of_range) error occurs\n    (ER_LATITUDE_OUT_OF_RANGE\n    (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-referen\n    ce.html#error_er_latitude_out_of_range) prior to MySQL 8.0.12).\n\n  Ranges shown are in degrees. The exact range limits deviate slightly\n  due to floating-point arithmetic.\n\nPrior to MySQL 8.0.13, ST_Validate() handles its arguments as described\nin the introduction to this section, with these exceptions:\n\no If the geometry is not syntactically well-formed, the return value is\n  NULL. An ER_GIS_INVALID_DATA\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_gis_invalid_data) error does not occur.\n\no If the geometry has an SRID value for a geographic spatial reference\n  system (SRS), an ER_NOT_IMPLEMENTED_FOR_GEOGRAPHIC_SRS\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_not_implemented_for_geographic_srs) error occurs.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/spatial-convenience-functions.html\n\n','mysql> SET @ls1 = ST_GeomFromText(\'LINESTRING(0 0)\');\nmysql> SET @ls2 = ST_GeomFromText(\'LINESTRING(0 0, 1 1)\');\nmysql> SELECT ST_AsText(ST_Validate(@ls1));\n+------------------------------+\n| ST_AsText(ST_Validate(@ls1)) |\n+------------------------------+\n| NULL                         |\n+------------------------------+\nmysql> SELECT ST_AsText(ST_Validate(@ls2));\n+------------------------------+\n| ST_AsText(ST_Validate(@ls2)) |\n+------------------------------+\n| LINESTRING(0 0,1 1)          |\n+------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/spatial-convenience-functions.html'),(381,'JSON_ARRAY',32,'Syntax:\nJSON_ARRAY([val[, val] ...])\n\nEvaluates a (possibly empty) list of values and returns a JSON array\ncontaining those values.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/json-creation-functions.html\n\n','mysql> SELECT JSON_ARRAY(1, \"abc\", NULL, TRUE, CURTIME());\n+---------------------------------------------+\n| JSON_ARRAY(1, \"abc\", NULL, TRUE, CURTIME()) |\n+---------------------------------------------+\n| [1, \"abc\", null, true, \"11:30:24.000000\"]   |\n+---------------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/json-creation-functions.html'),(382,'JSON_OBJECT',32,'Syntax:\nJSON_OBJECT([key, val[, key, val] ...])\n\nEvaluates a (possibly empty) list of key-value pairs and returns a JSON\nobject containing those pairs. An error occurs if any key name is NULL\nor the number of arguments is odd.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/json-creation-functions.html\n\n','mysql> SELECT JSON_OBJECT(\'id\', 87, \'name\', \'carrot\');\n+-----------------------------------------+\n| JSON_OBJECT(\'id\', 87, \'name\', \'carrot\') |\n+-----------------------------------------+\n| {\"id\": 87, \"name\": \"carrot\"}            |\n+-----------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/json-creation-functions.html'),(383,'JSON_QUOTE',32,'Syntax:\nJSON_QUOTE(string)\n\nQuotes a string as a JSON value by wrapping it with double quote\ncharacters and escaping interior quote and other characters, then\nreturning the result as a utf8mb4 string. Returns NULL if the argument\nis NULL.\n\nThis function is typically used to produce a valid JSON string literal\nfor inclusion within a JSON document.\n\nCertain special characters are escaped with backslashes per the escape\nsequences shown in\nhttps://dev.mysql.com/doc/refman/8.0/en/json-modification-functions.html\n#json-unquote-character-escape-sequences.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/json-creation-functions.html\n\n','mysql> SELECT JSON_QUOTE(\'null\'), JSON_QUOTE(\'\"null\"\');\n+--------------------+----------------------+\n| JSON_QUOTE(\'null\') | JSON_QUOTE(\'\"null\"\') |\n+--------------------+----------------------+\n| \"null\"             | \"\\\"null\\\"\"           |\n+--------------------+----------------------+\nmysql> SELECT JSON_QUOTE(\'[1, 2, 3]\');\n+-------------------------+\n| JSON_QUOTE(\'[1, 2, 3]\') |\n+-------------------------+\n| \"[1, 2, 3]\"             |\n+-------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/json-creation-functions.html'),(384,'JSON_CONTAINS',32,'Syntax:\nJSON_CONTAINS(target, candidate[, path])\n\nIndicates by returning 1 or 0 whether a given candidate JSON document\nis contained within a target JSON document, or---if a path argument was\nsupplied---whether the candidate is found at a specific path within the\ntarget. Returns NULL if any argument is NULL, or if the path argument\ndoes not identify a section of the target document. An error occurs if\ntarget or candidate is not a valid JSON document, or if the path\nargument is not a valid path expression or contains a * or ** wildcard.\n\nTo check only whether any data exists at the path, use\nJSON_CONTAINS_PATH() instead.\n\nThe following rules define containment:\n\no A candidate scalar is contained in a target scalar if and only if\n  they are comparable and are equal. Two scalar values are comparable\n  if they have the same JSON_TYPE() types, with the exception that\n  values of types INTEGER and DECIMAL are also comparable to each\n  other.\n\no A candidate array is contained in a target array if and only if every\n  element in the candidate is contained in some element of the target.\n\no A candidate nonarray is contained in a target array if and only if\n  the candidate is contained in some element of the target.\n\no A candidate object is contained in a target object if and only if for\n  each key in the candidate there is a key with the same name in the\n  target and the value associated with the candidate key is contained\n  in the value associated with the target key.\n\nOtherwise, the candidate value is not contained in the target document.\n\nStarting with MySQL 8.0.17, queries using JSON_CONTAINS() on InnoDB\ntables can be optimized using multi-valued indexes; see\nhttps://dev.mysql.com/doc/refman/8.0/en/create-index.html#create-index-\nmulti-valued, for more information.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/json-search-functions.html\n\n','mysql> SET @j = \'{\"a\": 1, \"b\": 2, \"c\": {\"d\": 4}}\';\nmysql> SET @j2 = \'1\';\nmysql> SELECT JSON_CONTAINS(@j, @j2, \'$.a\');\n+-------------------------------+\n| JSON_CONTAINS(@j, @j2, \'$.a\') |\n+-------------------------------+\n|                             1 |\n+-------------------------------+\nmysql> SELECT JSON_CONTAINS(@j, @j2, \'$.b\');\n+-------------------------------+\n| JSON_CONTAINS(@j, @j2, \'$.b\') |\n+-------------------------------+\n|                             0 |\n+-------------------------------+\n\nmysql> SET @j2 = \'{\"d\": 4}\';\nmysql> SELECT JSON_CONTAINS(@j, @j2, \'$.a\');\n+-------------------------------+\n| JSON_CONTAINS(@j, @j2, \'$.a\') |\n+-------------------------------+\n|                             0 |\n+-------------------------------+\nmysql> SELECT JSON_CONTAINS(@j, @j2, \'$.c\');\n+-------------------------------+\n| JSON_CONTAINS(@j, @j2, \'$.c\') |\n+-------------------------------+\n|                             1 |\n+-------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/json-search-functions.html'),(385,'JSON_CONTAINS_PATH',32,'Syntax:\nJSON_CONTAINS_PATH(json_doc, one_or_all, path[, path] ...)\n\nReturns 0 or 1 to indicate whether a JSON document contains data at a\ngiven path or paths. Returns NULL if any argument is NULL. An error\noccurs if the json_doc argument is not a valid JSON document, any path\nargument is not a valid path expression, or one_or_all is not \'one\' or\n\'all\'.\n\nTo check for a specific value at a path, use JSON_CONTAINS() instead.\n\nThe return value is 0 if no specified path exists within the document.\nOtherwise, the return value depends on the one_or_all argument:\n\no \'one\': 1 if at least one path exists within the document, 0\n  otherwise.\n\no \'all\': 1 if all paths exist within the document, 0 otherwise.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/json-search-functions.html\n\n','mysql> SET @j = \'{\"a\": 1, \"b\": 2, \"c\": {\"d\": 4}}\';\nmysql> SELECT JSON_CONTAINS_PATH(@j, \'one\', \'$.a\', \'$.e\');\n+---------------------------------------------+\n| JSON_CONTAINS_PATH(@j, \'one\', \'$.a\', \'$.e\') |\n+---------------------------------------------+\n|                                           1 |\n+---------------------------------------------+\nmysql> SELECT JSON_CONTAINS_PATH(@j, \'all\', \'$.a\', \'$.e\');\n+---------------------------------------------+\n| JSON_CONTAINS_PATH(@j, \'all\', \'$.a\', \'$.e\') |\n+---------------------------------------------+\n|                                           0 |\n+---------------------------------------------+\nmysql> SELECT JSON_CONTAINS_PATH(@j, \'one\', \'$.c.d\');\n+----------------------------------------+\n| JSON_CONTAINS_PATH(@j, \'one\', \'$.c.d\') |\n+----------------------------------------+\n|                                      1 |\n+----------------------------------------+\nmysql> SELECT JSON_CONTAINS_PATH(@j, \'one\', \'$.a.d\');\n+----------------------------------------+\n| JSON_CONTAINS_PATH(@j, \'one\', \'$.a.d\') |\n+----------------------------------------+\n|                                      0 |\n+----------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/json-search-functions.html'),(386,'JSON_EXTRACT',32,'Syntax:\nJSON_EXTRACT(json_doc, path[, path] ...)\n\nReturns data from a JSON document, selected from the parts of the\ndocument matched by the path arguments. Returns NULL if any argument is\nNULL or no paths locate a value in the document. An error occurs if the\njson_doc argument is not a valid JSON document or any path argument is\nnot a valid path expression.\n\nThe return value consists of all values matched by the path arguments.\nIf it is possible that those arguments could return multiple values,\nthe matched values are autowrapped as an array, in the order\ncorresponding to the paths that produced them. Otherwise, the return\nvalue is the single matched value.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/json-search-functions.html\n\n','mysql> SELECT JSON_EXTRACT(\'[10, 20, [30, 40]]\', \'$[1]\');\n+--------------------------------------------+\n| JSON_EXTRACT(\'[10, 20, [30, 40]]\', \'$[1]\') |\n+--------------------------------------------+\n| 20                                         |\n+--------------------------------------------+\nmysql> SELECT JSON_EXTRACT(\'[10, 20, [30, 40]]\', \'$[1]\', \'$[0]\');\n+----------------------------------------------------+\n| JSON_EXTRACT(\'[10, 20, [30, 40]]\', \'$[1]\', \'$[0]\') |\n+----------------------------------------------------+\n| [20, 10]                                           |\n+----------------------------------------------------+\nmysql> SELECT JSON_EXTRACT(\'[10, 20, [30, 40]]\', \'$[2][*]\');\n+-----------------------------------------------+\n| JSON_EXTRACT(\'[10, 20, [30, 40]]\', \'$[2][*]\') |\n+-----------------------------------------------+\n| [30, 40]                                      |\n+-----------------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/json-search-functions.html'),(387,'->',32,'Syntax:\ncolumn->path\n\nThe -> operator serves as an alias for the JSON_EXTRACT() function when\nused with two arguments, a column identifier on the left and a JSON\npath (a string literal) on the right that is evaluated against the JSON\ndocument (the column value). You can use such expressions in place of\ncolumn references wherever they occur in SQL statements.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/json-search-functions.html\n\n','mysql> SELECT c, JSON_EXTRACT(c, \"$.id\"), g\n     > FROM jemp\n     > WHERE JSON_EXTRACT(c, \"$.id\") > 1\n     > ORDER BY JSON_EXTRACT(c, \"$.name\");\n+-------------------------------+-----------+------+\n| c                             | c->\"$.id\" | g    |\n+-------------------------------+-----------+------+\n| {\"id\": \"3\", \"name\": \"Barney\"} | \"3\"       |    3 |\n| {\"id\": \"4\", \"name\": \"Betty\"}  | \"4\"       |    4 |\n| {\"id\": \"2\", \"name\": \"Wilma\"}  | \"2\"       |    2 |\n+-------------------------------+-----------+------+\n3 rows in set (0.00 sec)\n\nmysql> SELECT c, c->\"$.id\", g\n     > FROM jemp\n     > WHERE c->\"$.id\" > 1\n     > ORDER BY c->\"$.name\";\n+-------------------------------+-----------+------+\n| c                             | c->\"$.id\" | g    |\n+-------------------------------+-----------+------+\n| {\"id\": \"3\", \"name\": \"Barney\"} | \"3\"       |    3 |\n| {\"id\": \"4\", \"name\": \"Betty\"}  | \"4\"       |    4 |\n| {\"id\": \"2\", \"name\": \"Wilma\"}  | \"2\"       |    2 |\n+-------------------------------+-----------+------+\n3 rows in set (0.00 sec)\n\nmysql> ALTER TABLE jemp ADD COLUMN n INT;\nQuery OK, 0 rows affected (0.68 sec)\nRecords: 0  Duplicates: 0  Warnings: 0\n\nmysql> UPDATE jemp SET n=1 WHERE c->\"$.id\" = \"4\";\nQuery OK, 1 row affected (0.04 sec)\nRows matched: 1  Changed: 1  Warnings: 0\n\nmysql> SELECT c, c->\"$.id\", g, n\n     > FROM jemp\n     > WHERE JSON_EXTRACT(c, \"$.id\") > 1\n     > ORDER BY c->\"$.name\";\n+-------------------------------+-----------+------+------+\n| c                             | c->\"$.id\" | g    | n    |\n+-------------------------------+-----------+------+------+\n| {\"id\": \"3\", \"name\": \"Barney\"} | \"3\"       |    3 | NULL |\n| {\"id\": \"4\", \"name\": \"Betty\"}  | \"4\"       |    4 |    1 |\n| {\"id\": \"2\", \"name\": \"Wilma\"}  | \"2\"       |    2 | NULL |\n+-------------------------------+-----------+------+------+\n3 rows in set (0.00 sec)\n\nmysql> DELETE FROM jemp WHERE c->\"$.id\" = \"4\";\nQuery OK, 1 row affected (0.04 sec)\n\nmysql> SELECT c, c->\"$.id\", g, n\n     > FROM jemp\n     > WHERE JSON_EXTRACT(c, \"$.id\") > 1\n     > ORDER BY c->\"$.name\";\n+-------------------------------+-----------+------+------+\n| c                             | c->\"$.id\" | g    | n    |\n+-------------------------------+-----------+------+------+\n| {\"id\": \"3\", \"name\": \"Barney\"} | \"3\"       |    3 | NULL |\n| {\"id\": \"2\", \"name\": \"Wilma\"}  | \"2\"       |    2 | NULL |\n+-------------------------------+-----------+------+------+\n2 rows in set (0.00 sec)\n','https://dev.mysql.com/doc/refman/8.0/en/json-search-functions.html'),(388,'->>',32,'Syntax:\ncolumn->>path\n\nThis is an improved, unquoting extraction operator. Whereas the ->\noperator simply extracts a value, the ->> operator in addition unquotes\nthe extracted result. In other words, given a JSON column value column\nand a path expression path (a string literal), the following three\nexpressions return the same value:\n\no JSON_UNQUOTE( JSON_EXTRACT(column, path) )\n\no JSON_UNQUOTE(column -> path)\n\no column->>path\n\nThe ->> operator can be used wherever JSON_UNQUOTE(JSON_EXTRACT())\nwould be allowed. This includes (but is not limited to) SELECT lists,\nWHERE and HAVING clauses, and ORDER BY and GROUP BY clauses.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/json-search-functions.html\n\n','mysql> SELECT * FROM jemp WHERE g > 2;\n+-------------------------------+------+\n| c                             | g    |\n+-------------------------------+------+\n| {\"id\": \"3\", \"name\": \"Barney\"} |    3 |\n| {\"id\": \"4\", \"name\": \"Betty\"}  |    4 |\n+-------------------------------+------+\n2 rows in set (0.01 sec)\n\nmysql> SELECT c->\'$.name\' AS name\n    ->     FROM jemp WHERE g > 2;\n+----------+\n| name     |\n+----------+\n| \"Barney\" |\n| \"Betty\"  |\n+----------+\n2 rows in set (0.00 sec)\n\nmysql> SELECT JSON_UNQUOTE(c->\'$.name\') AS name\n    ->     FROM jemp WHERE g > 2;\n+--------+\n| name   |\n+--------+\n| Barney |\n| Betty  |\n+--------+\n2 rows in set (0.00 sec)\n\nmysql> SELECT c->>\'$.name\' AS name\n    ->     FROM jemp WHERE g > 2;\n+--------+\n| name   |\n+--------+\n| Barney |\n| Betty  |\n+--------+\n2 rows in set (0.00 sec)\n\nmysql> CREATE TABLE tj10 (a JSON, b INT);\nQuery OK, 0 rows affected (0.26 sec)\n\nmysql> INSERT INTO tj10 VALUES\n    ->     (\'[3,10,5,\"x\",44]\', 33),\n    ->     (\'[3,10,5,17,[22,\"y\",66]]\', 0);\nQuery OK, 2 rows affected (0.04 sec)\nRecords: 2  Duplicates: 0  Warnings: 0\n\nmysql> SELECT a->\"$[3]\", a->\"$[4][1]\" FROM tj10;\n+-----------+--------------+\n| a->\"$[3]\" | a->\"$[4][1]\" |\n+-----------+--------------+\n| \"x\"       | NULL         |\n| 17        | \"y\"          |\n+-----------+--------------+\n2 rows in set (0.00 sec)\n\nmysql> SELECT a->>\"$[3]\", a->>\"$[4][1]\" FROM tj10;\n+------------+---------------+\n| a->>\"$[3]\" | a->>\"$[4][1]\" |\n+------------+---------------+\n| x          | NULL          |\n| 17         | y             |\n+------------+---------------+\n2 rows in set (0.00 sec)\n\nmysql> EXPLAIN SELECT c->>\'$.name\' AS name\n    ->     FROM jemp WHERE g > 2\\G\n*************************** 1. row ***************************\n           id: 1\n  select_type: SIMPLE\n        table: jemp\n   partitions: NULL\n         type: range\npossible_keys: i\n          key: i\n      key_len: 5\n          ref: NULL\n         rows: 2\n     filtered: 100.00\n        Extra: Using where\n1 row in set, 1 warning (0.00 sec)\n\nmysql> SHOW WARNINGS\\G\n*************************** 1. row ***************************\n  Level: Note\n   Code: 1003\nMessage: /* select#1 */ select\njson_unquote(json_extract(`jtest`.`jemp`.`c`,\'$.name\')) AS `name` from\n`jtest`.`jemp` where (`jtest`.`jemp`.`g` > 2)\n1 row in set (0.00 sec)\n','https://dev.mysql.com/doc/refman/8.0/en/json-search-functions.html'),(389,'JSON_KEYS',32,'Syntax:\nJSON_KEYS(json_doc[, path])\n\nReturns the keys from the top-level value of a JSON object as a JSON\narray, or, if a path argument is given, the top-level keys from the\nselected path. Returns NULL if any argument is NULL, the json_doc\nargument is not an object, or path, if given, does not locate an\nobject. An error occurs if the json_doc argument is not a valid JSON\ndocument or the path argument is not a valid path expression or\ncontains a * or ** wildcard.\n\nThe result array is empty if the selected object is empty. If the\ntop-level value has nested subobjects, the return value does not\ninclude keys from those subobjects.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/json-search-functions.html\n\n','mysql> SELECT JSON_KEYS(\'{\"a\": 1, \"b\": {\"c\": 30}}\');\n+---------------------------------------+\n| JSON_KEYS(\'{\"a\": 1, \"b\": {\"c\": 30}}\') |\n+---------------------------------------+\n| [\"a\", \"b\"]                            |\n+---------------------------------------+\nmysql> SELECT JSON_KEYS(\'{\"a\": 1, \"b\": {\"c\": 30}}\', \'$.b\');\n+----------------------------------------------+\n| JSON_KEYS(\'{\"a\": 1, \"b\": {\"c\": 30}}\', \'$.b\') |\n+----------------------------------------------+\n| [\"c\"]                                        |\n+----------------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/json-search-functions.html'),(390,'JSON_OVERLAPS',32,'Syntax:\nJSON_OVERLAPS(json_doc1, json_doc2)\n\nCompares two JSON documents. Returns true (1) if the two document have\nany key-value pairs or array elements in common. If both arguments are\nscalars, the function performs a simple equality test. If either\nargument is NULL, the function returns NULL.\n\nThis function serves as counterpart to JSON_CONTAINS(), which requires\nall elements of the array searched for to be present in the array\nsearched in. Thus, JSON_CONTAINS() performs an AND operation on search\nkeys, while JSON_OVERLAPS() performs an OR operation.\n\nQueries on JSON columns of InnoDB tables using JSON_OVERLAPS() in the\nWHERE clause can be optimized using multi-valued indexes.\nhttps://dev.mysql.com/doc/refman/8.0/en/create-index.html#create-index-\nmulti-valued, provides detailed information and examples.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/json-search-functions.html\n\n','mysql> SELECT JSON_OVERLAPS(\"[1,3,5,7]\", \"[2,5,7]\");\n+---------------------------------------+\n| JSON_OVERLAPS(\"[1,3,5,7]\", \"[2,5,7]\") |\n+---------------------------------------+\n|                                     1 |\n+---------------------------------------+\n1 row in set (0.00 sec)\n\nmysql> SELECT JSON_OVERLAPS(\"[1,3,5,7]\", \"[2,6,7]\");\n+---------------------------------------+\n| JSON_OVERLAPS(\"[1,3,5,7]\", \"[2,6,7]\") |\n+---------------------------------------+\n|                                     1 |\n+---------------------------------------+\n1 row in set (0.00 sec)\n\nmysql> SELECT JSON_OVERLAPS(\"[1,3,5,7]\", \"[2,6,8]\");\n+---------------------------------------+\n| JSON_OVERLAPS(\"[1,3,5,7]\", \"[2,6,8]\") |\n+---------------------------------------+\n|                                     0 |\n+---------------------------------------+\n1 row in set (0.00 sec)\n\nmysql> SELECT JSON_OVERLAPS(\'[[1,2],[3,4],5]\', \'[1,[2,3],[4,5]]\');\n+-----------------------------------------------------+\n| JSON_OVERLAPS(\'[[1,2],[3,4],5]\', \'[1,[2,3],[4,5]]\') |\n+-----------------------------------------------------+\n|                                                   0 |\n+-----------------------------------------------------+\n1 row in set (0.00 sec)\n\nmysql> SELECT JSON_OVERLAPS(\'{\"a\":1,\"b\":10,\"d\":10}\', \'{\"c\":1,\"e\":10,\"f\":1,\"d\":10}\');\n+-----------------------------------------------------------------------+\n| JSON_OVERLAPS(\'{\"a\":1,\"b\":10,\"d\":10}\', \'{\"c\":1,\"e\":10,\"f\":1,\"d\":10}\') |\n+-----------------------------------------------------------------------+\n|                                                                     1 |\n+-----------------------------------------------------------------------+\n1 row in set (0.00 sec)\n\nmysql> SELECT JSON_OVERLAPS(\'{\"a\":1,\"b\":10,\"d\":10}\', \'{\"a\":5,\"e\":10,\"f\":1,\"d\":20}\');\n+-----------------------------------------------------------------------+\n| JSON_OVERLAPS(\'{\"a\":1,\"b\":10,\"d\":10}\', \'{\"a\":5,\"e\":10,\"f\":1,\"d\":20}\') |\n+-----------------------------------------------------------------------+\n|                                                                     0 |\n+-----------------------------------------------------------------------+\n1 row in set (0.00 sec)\n\nmysql> SELECT JSON_OVERLAPS(\'5\', \'5\');\n+-------------------------+\n| JSON_OVERLAPS(\'5\', \'5\') |\n+-------------------------+\n|                       1 |\n+-------------------------+\n1 row in set (0.00 sec)\n\nmysql> SELECT JSON_OVERLAPS(\'5\', \'6\');\n+-------------------------+\n| JSON_OVERLAPS(\'5\', \'6\') |\n+-------------------------+\n|                       0 |\n+-------------------------+\n1 row in set (0.00 sec)\n\nmysql> SELECT JSON_OVERLAPS(\'[4,5,6,7]\', \'6\');\n+---------------------------------+\n| JSON_OVERLAPS(\'[4,5,6,7]\', \'6\') |\n+---------------------------------+\n|                               1 |\n+---------------------------------+\n1 row in set (0.00 sec)\n\nmysql> SELECT JSON_OVERLAPS(\'[4,5,\"6\",7]\', \'6\');\n+-----------------------------------+\n| JSON_OVERLAPS(\'[4,5,\"6\",7]\', \'6\') |\n+-----------------------------------+\n|                                 0 |\n+-----------------------------------+\n1 row in set (0.00 sec)\n\nmysql> SELECT JSON_OVERLAPS(\'[4,5,6,7]\', \'\"6\"\');\n+-----------------------------------+\n| JSON_OVERLAPS(\'[4,5,6,7]\', \'\"6\"\') |\n+-----------------------------------+\n|                                 0 |\n+-----------------------------------+\n1 row in set (0.00 sec)\n','https://dev.mysql.com/doc/refman/8.0/en/json-search-functions.html'),(391,'JSON_SEARCH',32,'Syntax:\nJSON_SEARCH(json_doc, one_or_all, search_str[, escape_char[, path]\n...])\n\nReturns the path to the given string within a JSON document. Returns\nNULL if any of the json_doc, search_str, or path arguments are NULL; no\npath exists within the document; or search_str is not found. An error\noccurs if the json_doc argument is not a valid JSON document, any path\nargument is not a valid path expression, one_or_all is not \'one\' or\n\'all\', or escape_char is not a constant expression.\n\nThe one_or_all argument affects the search as follows:\n\no \'one\': The search terminates after the first match and returns one\n  path string. It is undefined which match is considered first.\n\no \'all\': The search returns all matching path strings such that no\n  duplicate paths are included. If there are multiple strings, they are\n  autowrapped as an array. The order of the array elements is\n  undefined.\n\nWithin the search_str search string argument, the % and _ characters\nwork as for the LIKE operator: % matches any number of characters\n(including zero characters), and _ matches exactly one character.\n\nTo specify a literal % or _ character in the search string, precede it\nby the escape character. The default is \\ if the escape_char argument\nis missing or NULL. Otherwise, escape_char must be a constant that is\nempty or one character.\n\nFor more information about matching and escape character behavior, see\nthe description of LIKE in\nhttps://dev.mysql.com/doc/refman/8.0/en/string-comparison-functions.html\n. For escape character handling, a difference from the LIKE behavior\nis that the escape character for JSON_SEARCH() must evaluate to a\nconstant at compile time, not just at execution time. For example, if\nJSON_SEARCH() is used in a prepared statement and the escape_char\nargument is supplied using a ? parameter, the parameter value might be\nconstant at execution time, but is not at compile time.\n\nsearch_str and path are always interpreted as utf8mb4 strings,\nregardless of their actual encoding. This is a known issue which is\nfixed in MySQL 8.0.24 ( Bug #32449181).\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/json-search-functions.html\n\n','mysql> SET @j = \'[\"abc\", [{\"k\": \"10\"}, \"def\"], {\"x\":\"abc\"}, {\"y\":\"bcd\"}]\';\n\nmysql> SELECT JSON_SEARCH(@j, \'one\', \'abc\');\n+-------------------------------+\n| JSON_SEARCH(@j, \'one\', \'abc\') |\n+-------------------------------+\n| \"$[0]\"                        |\n+-------------------------------+\n\nmysql> SELECT JSON_SEARCH(@j, \'all\', \'abc\');\n+-------------------------------+\n| JSON_SEARCH(@j, \'all\', \'abc\') |\n+-------------------------------+\n| [\"$[0]\", \"$[2].x\"]            |\n+-------------------------------+\n\nmysql> SELECT JSON_SEARCH(@j, \'all\', \'ghi\');\n+-------------------------------+\n| JSON_SEARCH(@j, \'all\', \'ghi\') |\n+-------------------------------+\n| NULL                          |\n+-------------------------------+\n\nmysql> SELECT JSON_SEARCH(@j, \'all\', \'10\');\n+------------------------------+\n| JSON_SEARCH(@j, \'all\', \'10\') |\n+------------------------------+\n| \"$[1][0].k\"                  |\n+------------------------------+\n\nmysql> SELECT JSON_SEARCH(@j, \'all\', \'10\', NULL, \'$\');\n+-----------------------------------------+\n| JSON_SEARCH(@j, \'all\', \'10\', NULL, \'$\') |\n+-----------------------------------------+\n| \"$[1][0].k\"                             |\n+-----------------------------------------+\n\nmysql> SELECT JSON_SEARCH(@j, \'all\', \'10\', NULL, \'$[*]\');\n+--------------------------------------------+\n| JSON_SEARCH(@j, \'all\', \'10\', NULL, \'$[*]\') |\n+--------------------------------------------+\n| \"$[1][0].k\"                                |\n+--------------------------------------------+\n\nmysql> SELECT JSON_SEARCH(@j, \'all\', \'10\', NULL, \'$**.k\');\n+---------------------------------------------+\n| JSON_SEARCH(@j, \'all\', \'10\', NULL, \'$**.k\') |\n+---------------------------------------------+\n| \"$[1][0].k\"                                 |\n+---------------------------------------------+\n\nmysql> SELECT JSON_SEARCH(@j, \'all\', \'10\', NULL, \'$[*][0].k\');\n+-------------------------------------------------+\n| JSON_SEARCH(@j, \'all\', \'10\', NULL, \'$[*][0].k\') |\n+-------------------------------------------------+\n| \"$[1][0].k\"                                     |\n+-------------------------------------------------+\n\nmysql> SELECT JSON_SEARCH(@j, \'all\', \'10\', NULL, \'$[1]\');\n+--------------------------------------------+\n| JSON_SEARCH(@j, \'all\', \'10\', NULL, \'$[1]\') |\n+--------------------------------------------+\n| \"$[1][0].k\"                                |\n+--------------------------------------------+\n\nmysql> SELECT JSON_SEARCH(@j, \'all\', \'10\', NULL, \'$[1][0]\');\n+-----------------------------------------------+\n| JSON_SEARCH(@j, \'all\', \'10\', NULL, \'$[1][0]\') |\n+-----------------------------------------------+\n| \"$[1][0].k\"                                   |\n+-----------------------------------------------+\n\nmysql> SELECT JSON_SEARCH(@j, \'all\', \'abc\', NULL, \'$[2]\');\n+---------------------------------------------+\n| JSON_SEARCH(@j, \'all\', \'abc\', NULL, \'$[2]\') |\n+---------------------------------------------+\n| \"$[2].x\"                                    |\n+---------------------------------------------+\n\nmysql> SELECT JSON_SEARCH(@j, \'all\', \'%a%\');\n+-------------------------------+\n| JSON_SEARCH(@j, \'all\', \'%a%\') |\n+-------------------------------+\n| [\"$[0]\", \"$[2].x\"]            |\n+-------------------------------+\n\nmysql> SELECT JSON_SEARCH(@j, \'all\', \'%b%\');\n+-------------------------------+\n| JSON_SEARCH(@j, \'all\', \'%b%\') |\n+-------------------------------+\n| [\"$[0]\", \"$[2].x\", \"$[3].y\"]  |\n+-------------------------------+\n\nmysql> SELECT JSON_SEARCH(@j, \'all\', \'%b%\', NULL, \'$[0]\');\n+---------------------------------------------+\n| JSON_SEARCH(@j, \'all\', \'%b%\', NULL, \'$[0]\') |\n+---------------------------------------------+\n| \"$[0]\"                                      |\n+---------------------------------------------+\n\nmysql> SELECT JSON_SEARCH(@j, \'all\', \'%b%\', NULL, \'$[2]\');\n+---------------------------------------------+\n| JSON_SEARCH(@j, \'all\', \'%b%\', NULL, \'$[2]\') |\n+---------------------------------------------+\n| \"$[2].x\"                                    |\n+---------------------------------------------+\n\nmysql> SELECT JSON_SEARCH(@j, \'all\', \'%b%\', NULL, \'$[1]\');\n+---------------------------------------------+\n| JSON_SEARCH(@j, \'all\', \'%b%\', NULL, \'$[1]\') |\n+---------------------------------------------+\n| NULL                                        |\n+---------------------------------------------+\n\nmysql> SELECT JSON_SEARCH(@j, \'all\', \'%b%\', \'\', \'$[1]\');\n+-------------------------------------------+\n| JSON_SEARCH(@j, \'all\', \'%b%\', \'\', \'$[1]\') |\n+-------------------------------------------+\n| NULL                                      |\n+-------------------------------------------+\n\nmysql> SELECT JSON_SEARCH(@j, \'all\', \'%b%\', \'\', \'$[3]\');\n+-------------------------------------------+\n| JSON_SEARCH(@j, \'all\', \'%b%\', \'\', \'$[3]\') |\n+-------------------------------------------+\n| \"$[3].y\"                                  |\n+-------------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/json-search-functions.html'),(392,'JSON_VALUE',32,'Syntax:\nJSON_VALUE(json_doc, path)\n\nExtracts a value from a JSON document at the path given in the\nspecified document, and returns the extracted value, optionally\nconverting it to a desired type. The complete syntax is shown here:\n\nJSON_VALUE(json_doc, path [RETURNING type] [on_empty] [on_error])\n\non_empty:\n    {NULL | ERROR | DEFAULT value} ON EMPTY\n\non_error:\n    {NULL | ERROR | DEFAULT value} ON ERROR\n\njson_doc is a valid JSON document. If this is NULL, the function\nreturns NULL.\n\npath is a JSON path pointing to a location in the document. This must\nbe a string literal value.\n\ntype is one of the following data types:\n\no FLOAT\n\no DOUBLE\n\no DECIMAL\n\no SIGNED\n\no UNSIGNED\n\no DATE\n\no TIME\n\no DATETIME\n\no YEAR (MySQL 8.0.22 and later)\n\n  YEAR values of one or two digits are not supported.\n\no CHAR\n\no JSON\n\nThe types just listed are the same as the (non-array) types supported\nby the CAST() function.\n\nIf not specified by a RETURNING clause, the JSON_VALUE() function\'s\nreturn type is VARCHAR(512). When no character set is specified for the\nreturn type, JSON_VALUE() uses utf8mb4 with the binary collation, which\nis case-sensitive; if utf8mb4 is specified as the character set for the\nresult, the server uses the default collation for this character set,\nwhich is not case-sensitive.\n\nWhen the data at the specified path consists of or resolves to a JSON\nnull literal, the function returns SQL NULL.\n\non_empty, if specified, determines how JSON_VALUE() behaves when no\ndata is found at the path given; this clause takes one of the following\nvalues:\n\no NULL ON EMPTY: The function returns NULL; this is the default ON\n  EMPTY behavior.\n\no DEFAULT value ON EMPTY: the provided value is returned. The value\'s\n  type must match that of the return type.\n\no ERROR ON EMPTY: The function throws an error.\n\nIf used, on_error takes one of the following values with the\ncorresponding outcome when an error occurs, as listed here:\n\no NULL ON ERROR: JSON_VALUE() returns NULL; this is the default\n  behavior if no ON ERROR clause is used.\n\no DEFAULT value ON ERROR: This is the value returned; its value must\n  match that of the return type.\n\no ERROR ON ERROR: An error is thrown.\n\nON EMPTY, if used, must precede any ON ERROR clause. Specifying them in\nthe wrong order results in a syntax error.\n\nError handling In general, errors are handled by JSON_VALUE() as\nfollows:\n\no All JSON input (document and path) is checked for validity. If any of\n  it is not valid, an SQL error is thrown without triggering the ON\n  ERROR clause.\n\no ON ERROR is triggered whenever any of the following events occur:\n\n  o Attempting to extract an object or an array, such as that resulting\n    from a path that resolves to multiple locations within the JSON\n    document\n\n  o Conversion errors, such as attempting to convert \'asdf\' to an\n    UNSIGNED value\n\n  o Truncation of values\n\no A conversion error always triggers a warning even if NULL ON ERROR or\n  DEFAULT ... ON ERROR is specified.\n\no The ON EMPTY clause is triggered when the source JSON document (expr)\n  contains no data at the specified location (path).\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/json-search-functions.html\n\n','mysql> SELECT JSON_VALUE(\'{\"fname\": \"Joe\", \"lname\": \"Palmer\"}\', \'$.fname\');\n+--------------------------------------------------------------+\n| JSON_VALUE(\'{\"fname\": \"Joe\", \"lname\": \"Palmer\"}\', \'$.fname\') |\n+--------------------------------------------------------------+\n| Joe                                                          |\n+--------------------------------------------------------------+\n\nmysql> SELECT JSON_VALUE(\'{\"item\": \"shoes\", \"price\": \"49.95\"}\', \'$.price\'\n    -> RETURNING DECIMAL(4,2)) AS price;\n+-------+\n| price |\n+-------+\n| 49.95 |\n+-------+\n\nSELECT CAST(\n    JSON_UNQUOTE( JSON_EXTRACT(json_doc, path) )\n    AS type\n);\n\nCREATE TABLE t1(\n    j JSON,\n    INDEX i1 ( (JSON_VALUE(j, \'$.id\' RETURNING UNSIGNED)) )\n);\n\nmysql> EXPLAIN SELECT * FROM t1\n    ->     WHERE JSON_VALUE(j, \'$.id\' RETURNING UNSIGNED) = 123\\G\n*************************** 1. row ***************************\n           id: 1\n  select_type: SIMPLE\n        table: t1\n   partitions: NULL\n         type: ref\npossible_keys: i1\n          key: i1\n      key_len: 9\n          ref: const\n         rows: 1\n     filtered: 100.00\n        Extra: NULL\n\nCREATE TABLE t2 (\n    j JSON,\n    g INT GENERATED ALWAYS AS (j->\"$.id\"),\n    INDEX i1 (j)\n);\n\nmysql> EXPLAIN SELECT * FROM t2 WHERE g  = 123\\G\n*************************** 1. row ***************************\n           id: 1\n  select_type: SIMPLE\n        table: t2\n   partitions: NULL\n         type: ref\npossible_keys: i1\n          key: i1\n      key_len: 5\n          ref: const\n         rows: 1\n     filtered: 100.00\n        Extra: NULL\n','https://dev.mysql.com/doc/refman/8.0/en/json-search-functions.html'),(393,'MEMBER OF',32,'Syntax:\nvalue MEMBER OF(json_array)\n\nReturns true (1) if value is an element of json_array, otherwise\nreturns false (0). value must be a scalar or a JSON document; if it is\na scalar, the operator attempts to treat it as an element of a JSON\narray. If value or json_array is NULL, the function returns NULL.\n\nQueries using MEMBER OF() on JSON columns of InnoDB tables in the WHERE\nclause can be optimized using multi-valued indexes. See\nhttps://dev.mysql.com/doc/refman/8.0/en/create-index.html#create-index-\nmulti-valued, for detailed information and examples.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/json-search-functions.html\n\n','mysql> SELECT 17 MEMBER OF(\'[23, \"abc\", 17, \"ab\", 10]\');\n+-------------------------------------------+\n| 17 MEMBER OF(\'[23, \"abc\", 17, \"ab\", 10]\') |\n+-------------------------------------------+\n|                                         1 |\n+-------------------------------------------+\n1 row in set (0.00 sec)\n\nmysql> SELECT \'ab\' MEMBER OF(\'[23, \"abc\", 17, \"ab\", 10]\');\n+---------------------------------------------+\n| \'ab\' MEMBER OF(\'[23, \"abc\", 17, \"ab\", 10]\') |\n+---------------------------------------------+\n|                                           1 |\n+---------------------------------------------+\n1 row in set (0.00 sec)\n\nmysql> SELECT 7 MEMBER OF(\'[23, \"abc\", 17, \"ab\", 10]\');\n+------------------------------------------+\n| 7 MEMBER OF(\'[23, \"abc\", 17, \"ab\", 10]\') |\n+------------------------------------------+\n|                                        0 |\n+------------------------------------------+\n1 row in set (0.00 sec)\n\nmysql> SELECT \'a\' MEMBER OF(\'[23, \"abc\", 17, \"ab\", 10]\');\n+--------------------------------------------+\n| \'a\' MEMBER OF(\'[23, \"abc\", 17, \"ab\", 10]\') |\n+--------------------------------------------+\n|                                          0 |\n+--------------------------------------------+\n1 row in set (0.00 sec)\n\nmysql> SELECT\n    -> 17 MEMBER OF(\'[23, \"abc\", \"17\", \"ab\", 10]\'),\n    -> \"17\" MEMBER OF(\'[23, \"abc\", 17, \"ab\", 10]\')\\G\n*************************** 1. row ***************************\n17 MEMBER OF(\'[23, \"abc\", \"17\", \"ab\", 10]\'): 0\n\"17\" MEMBER OF(\'[23, \"abc\", 17, \"ab\", 10]\'): 0\n1 row in set (0.00 sec)\n\nmysql> SELECT CAST(\'[4,5]\' AS JSON) MEMBER OF(\'[[3,4],[4,5]]\');\n+--------------------------------------------------+\n| CAST(\'[4,5]\' AS JSON) MEMBER OF(\'[[3,4],[4,5]]\') |\n+--------------------------------------------------+\n|                                                1 |\n+--------------------------------------------------+\n1 row in set (0.00 sec)\n\nmysql> SELECT JSON_ARRAY(4,5) MEMBER OF(\'[[3,4],[4,5]]\');\n+--------------------------------------------+\n| JSON_ARRAY(4,5) MEMBER OF(\'[[3,4],[4,5]]\') |\n+--------------------------------------------+\n|                                          1 |\n+--------------------------------------------+\n1 row in set (0.00 sec)\n\nmysql> SET @a = CAST(\'{\"a\":1}\' AS JSON);\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> SET @b = JSON_OBJECT(\"b\", 2);\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> SET @c = JSON_ARRAY(17, @b, \"abc\", @a, 23);\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> SELECT @a MEMBER OF(@c), @b MEMBER OF(@c);\n+------------------+------------------+\n| @a MEMBER OF(@c) | @b MEMBER OF(@c) |\n+------------------+------------------+\n|                1 |                1 |\n+------------------+------------------+\n1 row in set (0.00 sec)\n','https://dev.mysql.com/doc/refman/8.0/en/json-search-functions.html'),(394,'JSON_ARRAY_APPEND',32,'Syntax:\nJSON_ARRAY_APPEND(json_doc, path, val[, path, val] ...)\n\nAppends values to the end of the indicated arrays within a JSON\ndocument and returns the result. Returns NULL if any argument is NULL.\nAn error occurs if the json_doc argument is not a valid JSON document\nor any path argument is not a valid path expression or contains a * or\n** wildcard.\n\nThe path-value pairs are evaluated left to right. The document produced\nby evaluating one pair becomes the new value against which the next\npair is evaluated.\n\nIf a path selects a scalar or object value, that value is autowrapped\nwithin an array and the new value is added to that array. Pairs for\nwhich the path does not identify any value in the JSON document are\nignored.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/json-modification-functions.html\n\n','mysql> SET @j = \'[\"a\", [\"b\", \"c\"], \"d\"]\';\nmysql> SELECT JSON_ARRAY_APPEND(@j, \'$[1]\', 1);\n+----------------------------------+\n| JSON_ARRAY_APPEND(@j, \'$[1]\', 1) |\n+----------------------------------+\n| [\"a\", [\"b\", \"c\", 1], \"d\"]        |\n+----------------------------------+\nmysql> SELECT JSON_ARRAY_APPEND(@j, \'$[0]\', 2);\n+----------------------------------+\n| JSON_ARRAY_APPEND(@j, \'$[0]\', 2) |\n+----------------------------------+\n| [[\"a\", 2], [\"b\", \"c\"], \"d\"]      |\n+----------------------------------+\nmysql> SELECT JSON_ARRAY_APPEND(@j, \'$[1][0]\', 3);\n+-------------------------------------+\n| JSON_ARRAY_APPEND(@j, \'$[1][0]\', 3) |\n+-------------------------------------+\n| [\"a\", [[\"b\", 3], \"c\"], \"d\"]         |\n+-------------------------------------+\n\nmysql> SET @j = \'{\"a\": 1, \"b\": [2, 3], \"c\": 4}\';\nmysql> SELECT JSON_ARRAY_APPEND(@j, \'$.b\', \'x\');\n+------------------------------------+\n| JSON_ARRAY_APPEND(@j, \'$.b\', \'x\')  |\n+------------------------------------+\n| {\"a\": 1, \"b\": [2, 3, \"x\"], \"c\": 4} |\n+------------------------------------+\nmysql> SELECT JSON_ARRAY_APPEND(@j, \'$.c\', \'y\');\n+--------------------------------------+\n| JSON_ARRAY_APPEND(@j, \'$.c\', \'y\')    |\n+--------------------------------------+\n| {\"a\": 1, \"b\": [2, 3], \"c\": [4, \"y\"]} |\n+--------------------------------------+\n\nmysql> SET @j = \'{\"a\": 1}\';\nmysql> SELECT JSON_ARRAY_APPEND(@j, \'$\', \'z\');\n+---------------------------------+\n| JSON_ARRAY_APPEND(@j, \'$\', \'z\') |\n+---------------------------------+\n| [{\"a\": 1}, \"z\"]                 |\n+---------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/json-modification-functions.html'),(395,'JSON_ARRAY_INSERT',32,'Syntax:\nJSON_ARRAY_INSERT(json_doc, path, val[, path, val] ...)\n\nUpdates a JSON document, inserting into an array within the document\nand returning the modified document. Returns NULL if any argument is\nNULL. An error occurs if the json_doc argument is not a valid JSON\ndocument or any path argument is not a valid path expression or\ncontains a * or ** wildcard or does not end with an array element\nidentifier.\n\nThe path-value pairs are evaluated left to right. The document produced\nby evaluating one pair becomes the new value against which the next\npair is evaluated.\n\nPairs for which the path does not identify any array in the JSON\ndocument are ignored. If a path identifies an array element, the\ncorresponding value is inserted at that element position, shifting any\nfollowing values to the right. If a path identifies an array position\npast the end of an array, the value is inserted at the end of the\narray.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/json-modification-functions.html\n\n','mysql> SET @j = \'[\"a\", {\"b\": [1, 2]}, [3, 4]]\';\nmysql> SELECT JSON_ARRAY_INSERT(@j, \'$[1]\', \'x\');\n+------------------------------------+\n| JSON_ARRAY_INSERT(@j, \'$[1]\', \'x\') |\n+------------------------------------+\n| [\"a\", \"x\", {\"b\": [1, 2]}, [3, 4]]  |\n+------------------------------------+\nmysql> SELECT JSON_ARRAY_INSERT(@j, \'$[100]\', \'x\');\n+--------------------------------------+\n| JSON_ARRAY_INSERT(@j, \'$[100]\', \'x\') |\n+--------------------------------------+\n| [\"a\", {\"b\": [1, 2]}, [3, 4], \"x\"]    |\n+--------------------------------------+\nmysql> SELECT JSON_ARRAY_INSERT(@j, \'$[1].b[0]\', \'x\');\n+-----------------------------------------+\n| JSON_ARRAY_INSERT(@j, \'$[1].b[0]\', \'x\') |\n+-----------------------------------------+\n| [\"a\", {\"b\": [\"x\", 1, 2]}, [3, 4]]       |\n+-----------------------------------------+\nmysql> SELECT JSON_ARRAY_INSERT(@j, \'$[2][1]\', \'y\');\n+---------------------------------------+\n| JSON_ARRAY_INSERT(@j, \'$[2][1]\', \'y\') |\n+---------------------------------------+\n| [\"a\", {\"b\": [1, 2]}, [3, \"y\", 4]]     |\n+---------------------------------------+\nmysql> SELECT JSON_ARRAY_INSERT(@j, \'$[0]\', \'x\', \'$[2][1]\', \'y\');\n+----------------------------------------------------+\n| JSON_ARRAY_INSERT(@j, \'$[0]\', \'x\', \'$[2][1]\', \'y\') |\n+----------------------------------------------------+\n| [\"x\", \"a\", {\"b\": [1, 2]}, [3, 4]]                  |\n+----------------------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/json-modification-functions.html'),(396,'JSON_INSERT',32,'Syntax:\nJSON_INSERT(json_doc, path, val[, path, val] ...)\n\nInserts data into a JSON document and returns the result. Returns NULL\nif any argument is NULL. An error occurs if the json_doc argument is\nnot a valid JSON document or any path argument is not a valid path\nexpression or contains a * or ** wildcard.\n\nThe path-value pairs are evaluated left to right. The document produced\nby evaluating one pair becomes the new value against which the next\npair is evaluated.\n\nA path-value pair for an existing path in the document is ignored and\ndoes not overwrite the existing document value. A path-value pair for a\nnonexisting path in the document adds the value to the document if the\npath identifies one of these types of values:\n\no A member not present in an existing object. The member is added to\n  the object and associated with the new value.\n\no A position past the end of an existing array. The array is extended\n  with the new value. If the existing value is not an array, it is\n  autowrapped as an array, then extended with the new value.\n\nOtherwise, a path-value pair for a nonexisting path in the document is\nignored and has no effect.\n\nFor a comparison of JSON_INSERT(), JSON_REPLACE(), and JSON_SET(), see\nthe discussion of JSON_SET().\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/json-modification-functions.html\n\n','mysql> SET @j = \'{ \"a\": 1, \"b\": [2, 3]}\';\nmysql> SELECT JSON_INSERT(@j, \'$.a\', 10, \'$.c\', \'[true, false]\');\n+----------------------------------------------------+\n| JSON_INSERT(@j, \'$.a\', 10, \'$.c\', \'[true, false]\') |\n+----------------------------------------------------+\n| {\"a\": 1, \"b\": [2, 3], \"c\": \"[true, false]\"}        |\n+----------------------------------------------------+\n\nmysql> SELECT JSON_INSERT(@j, \'$.a\', 10, \'$.c\', CAST(\'[true, false]\' AS JSON));\n+------------------------------------------------------------------+\n| JSON_INSERT(@j, \'$.a\', 10, \'$.c\', CAST(\'[true, false]\' AS JSON)) |\n+------------------------------------------------------------------+\n| {\"a\": 1, \"b\": [2, 3], \"c\": [true, false]}                        |\n+------------------------------------------------------------------+\n1 row in set (0.00 sec)\n','https://dev.mysql.com/doc/refman/8.0/en/json-modification-functions.html'),(397,'JSON_MERGE',32,'Syntax:\nJSON_MERGE(json_doc, json_doc[, json_doc] ...)\n\nMerges two or more JSON documents. Synonym for JSON_MERGE_PRESERVE();\ndeprecated in MySQL 8.0.3 and subject to removal in a future release.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/json-modification-functions.html\n\n','mysql> SELECT JSON_MERGE(\'[1, 2]\', \'[true, false]\');\n+---------------------------------------+\n| JSON_MERGE(\'[1, 2]\', \'[true, false]\') |\n+---------------------------------------+\n| [1, 2, true, false]                   |\n+---------------------------------------+\n1 row in set, 1 warning (0.00 sec)\n\nmysql> SHOW WARNINGS\\G\n*************************** 1. row ***************************\n  Level: Warning\n   Code: 1287\nMessage: \'JSON_MERGE\' is deprecated and will be removed in a future release. \\\n Please use JSON_MERGE_PRESERVE/JSON_MERGE_PATCH instead\n1 row in set (0.00 sec)\n','https://dev.mysql.com/doc/refman/8.0/en/json-modification-functions.html'),(398,'JSON_MERGE_PATCH()',32,'Syntax:\nJSON_MERGE_PATCH(json_doc, json_doc[, json_doc] ...)\n\nPerforms an RFC 7396 (https://tools.ietf.org/html/rfc7396) compliant\nmerge of two or more JSON documents and returns the merged result,\nwithout preserving members having duplicate keys. Raises an error if at\nleast one of the documents passed as arguments to this function is not\nvalid.\n\n*Note*:\n\nFor an explanation and example of the differences between this function\nand JSON_MERGE_PRESERVE(), see\nhttps://dev.mysql.com/doc/refman/8.0/en/json-modification-functions.html\n#json-merge-patch-json-merge-preserve-compared.\n\nJSON_MERGE_PATCH() performs a merge as follows:\n\n1. If the first argument is not an object, the result of the merge is\n   the same as if an empty object had been merged with the second\n   argument.\n\n2. If the second argument is not an object, the result of the merge is\n   the second argument.\n\n3. If both arguments are objects, the result of the merge is an object\n   with the following members:\n\n  o All members of the first object which do not have a corresponding\n    member with the same key in the second object.\n\n  o All members of the second object which do not have a corresponding\n    key in the first object, and whose value is not the JSON null\n    literal.\n\n  o All members with a key that exists in both the first and the second\n    object, and whose value in the second object is not the JSON null\n    literal. The values of these members are the results of recursively\n    merging the value in the first object with the value in the second\n    object.\n\nFor additional information, see\nhttps://dev.mysql.com/doc/refman/8.0/en/json.html#json-normalization.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/json-modification-functions.html\n\n','mysql> SELECT JSON_MERGE_PATCH(\'[1, 2]\', \'[true, false]\');\n+---------------------------------------------+\n| JSON_MERGE_PATCH(\'[1, 2]\', \'[true, false]\') |\n+---------------------------------------------+\n| [true, false]                               |\n+---------------------------------------------+\n\nmysql> SELECT JSON_MERGE_PATCH(\'{\"name\": \"x\"}\', \'{\"id\": 47}\');\n+-------------------------------------------------+\n| JSON_MERGE_PATCH(\'{\"name\": \"x\"}\', \'{\"id\": 47}\') |\n+-------------------------------------------------+\n| {\"id\": 47, \"name\": \"x\"}                         |\n+-------------------------------------------------+\n\nmysql> SELECT JSON_MERGE_PATCH(\'1\', \'true\');\n+-------------------------------+\n| JSON_MERGE_PATCH(\'1\', \'true\') |\n+-------------------------------+\n| true                          |\n+-------------------------------+\n\nmysql> SELECT JSON_MERGE_PATCH(\'[1, 2]\', \'{\"id\": 47}\');\n+------------------------------------------+\n| JSON_MERGE_PATCH(\'[1, 2]\', \'{\"id\": 47}\') |\n+------------------------------------------+\n| {\"id\": 47}                               |\n+------------------------------------------+\n\nmysql> SELECT JSON_MERGE_PATCH(\'{ \"a\": 1, \"b\":2 }\',\n     >     \'{ \"a\": 3, \"c\":4 }\');\n+-----------------------------------------------------------+\n| JSON_MERGE_PATCH(\'{ \"a\": 1, \"b\":2 }\',\'{ \"a\": 3, \"c\":4 }\') |\n+-----------------------------------------------------------+\n| {\"a\": 3, \"b\": 2, \"c\": 4}                                  |\n+-----------------------------------------------------------+\n\nmysql> SELECT JSON_MERGE_PATCH(\'{ \"a\": 1, \"b\":2 }\',\'{ \"a\": 3, \"c\":4 }\',\n     >     \'{ \"a\": 5, \"d\":6 }\');\n+-------------------------------------------------------------------------------+\n| JSON_MERGE_PATCH(\'{ \"a\": 1, \"b\":2 }\',\'{ \"a\": 3, \"c\":4 }\',\'{ \"a\": 5, \"d\":6 }\') |\n+-------------------------------------------------------------------------------+\n| {\"a\": 5, \"b\": 2, \"c\": 4, \"d\": 6}                                              |\n+-------------------------------------------------------------------------------+\n\nmysql> SELECT JSON_MERGE_PATCH(\'{\"a\":1, \"b\":2}\', \'{\"b\":null}\');\n+--------------------------------------------------+\n| JSON_MERGE_PATCH(\'{\"a\":1, \"b\":2}\', \'{\"b\":null}\') |\n+--------------------------------------------------+\n| {\"a\": 1}                                         |\n+--------------------------------------------------+\n\nmysql> SELECT JSON_MERGE_PATCH(\'{\"a\":{\"x\":1}}\', \'{\"a\":{\"y\":2}}\');\n+----------------------------------------------------+\n| JSON_MERGE_PATCH(\'{\"a\":{\"x\":1}}\', \'{\"a\":{\"y\":2}}\') |\n+----------------------------------------------------+\n| {\"a\": {\"x\": 1, \"y\": 2}}                            |\n+----------------------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/json-modification-functions.html'),(399,'JSON_MERGE_PRESERVE()',32,'Syntax:\nJSON_MERGE_PRESERVE(json_doc, json_doc[, json_doc] ...)\n\nMerges two or more JSON documents and returns the merged result.\nReturns NULL if any argument is NULL. An error occurs if any argument\nis not a valid JSON document.\n\nMerging takes place according to the following rules. For additional\ninformation, see\nhttps://dev.mysql.com/doc/refman/8.0/en/json.html#json-normalization.\n\no Adjacent arrays are merged to a single array.\n\no Adjacent objects are merged to a single object.\n\no A scalar value is autowrapped as an array and merged as an array.\n\no An adjacent array and object are merged by autowrapping the object as\n  an array and merging the two arrays.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/json-modification-functions.html\n\n','mysql> SELECT JSON_MERGE_PRESERVE(\'[1, 2]\', \'[true, false]\');\n+------------------------------------------------+\n| JSON_MERGE_PRESERVE(\'[1, 2]\', \'[true, false]\') |\n+------------------------------------------------+\n| [1, 2, true, false]                            |\n+------------------------------------------------+\n\nmysql> SELECT JSON_MERGE_PRESERVE(\'{\"name\": \"x\"}\', \'{\"id\": 47}\');\n+----------------------------------------------------+\n| JSON_MERGE_PRESERVE(\'{\"name\": \"x\"}\', \'{\"id\": 47}\') |\n+----------------------------------------------------+\n| {\"id\": 47, \"name\": \"x\"}                            |\n+----------------------------------------------------+\n\nmysql> SELECT JSON_MERGE_PRESERVE(\'1\', \'true\');\n+----------------------------------+\n| JSON_MERGE_PRESERVE(\'1\', \'true\') |\n+----------------------------------+\n| [1, true]                        |\n+----------------------------------+\n\nmysql> SELECT JSON_MERGE_PRESERVE(\'[1, 2]\', \'{\"id\": 47}\');\n+---------------------------------------------+\n| JSON_MERGE_PRESERVE(\'[1, 2]\', \'{\"id\": 47}\') |\n+---------------------------------------------+\n| [1, 2, {\"id\": 47}]                          |\n+---------------------------------------------+\n\nmysql> SELECT JSON_MERGE_PRESERVE(\'{ \"a\": 1, \"b\": 2 }\',\n     >    \'{ \"a\": 3, \"c\": 4 }\');\n+--------------------------------------------------------------+\n| JSON_MERGE_PRESERVE(\'{ \"a\": 1, \"b\": 2 }\',\'{ \"a\": 3, \"c\":4 }\') |\n+--------------------------------------------------------------+\n| {\"a\": [1, 3], \"b\": 2, \"c\": 4}                                |\n+--------------------------------------------------------------+\n\nmysql> SELECT JSON_MERGE_PRESERVE(\'{ \"a\": 1, \"b\": 2 }\',\'{ \"a\": 3, \"c\": 4 }\',\n     >    \'{ \"a\": 5, \"d\": 6 }\');\n+----------------------------------------------------------------------------------+\n| JSON_MERGE_PRESERVE(\'{ \"a\": 1, \"b\": 2 }\',\'{ \"a\": 3, \"c\": 4 }\',\'{ \"a\": 5, \"d\": 6 }\') |\n+----------------------------------------------------------------------------------+\n| {\"a\": [1, 3, 5], \"b\": 2, \"c\": 4, \"d\": 6}                                         |\n+----------------------------------------------------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/json-modification-functions.html'),(400,'JSON_REMOVE',32,'Syntax:\nJSON_REMOVE(json_doc, path[, path] ...)\n\nRemoves data from a JSON document and returns the result. Returns NULL\nif any argument is NULL. An error occurs if the json_doc argument is\nnot a valid JSON document or any path argument is not a valid path\nexpression or is $ or contains a * or ** wildcard.\n\nThe path arguments are evaluated left to right. The document produced\nby evaluating one path becomes the new value against which the next\npath is evaluated.\n\nIt is not an error if the element to be removed does not exist in the\ndocument; in that case, the path does not affect the document.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/json-modification-functions.html\n\n','mysql> SET @j = \'[\"a\", [\"b\", \"c\"], \"d\"]\';\nmysql> SELECT JSON_REMOVE(@j, \'$[1]\');\n+-------------------------+\n| JSON_REMOVE(@j, \'$[1]\') |\n+-------------------------+\n| [\"a\", \"d\"]              |\n+-------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/json-modification-functions.html'),(401,'JSON_REPLACE',32,'Syntax:\nJSON_REPLACE(json_doc, path, val[, path, val] ...)\n\nReplaces existing values in a JSON document and returns the result.\nReturns NULL if any argument is NULL. An error occurs if the json_doc\nargument is not a valid JSON document or any path argument is not a\nvalid path expression or contains a * or ** wildcard.\n\nThe path-value pairs are evaluated left to right. The document produced\nby evaluating one pair becomes the new value against which the next\npair is evaluated.\n\nA path-value pair for an existing path in the document overwrites the\nexisting document value with the new value. A path-value pair for a\nnonexisting path in the document is ignored and has no effect.\n\nIn MySQL 8.0.4, the optimizer can perform a partial, in-place update of\na JSON column instead of removing the old document and writing the new\ndocument in its entirety to the column. This optimization can be\nperformed for an update statement that uses the JSON_REPLACE() function\nand meets the conditions outlined in\nhttps://dev.mysql.com/doc/refman/8.0/en/json.html#json-partial-updates.\n\nFor a comparison of JSON_INSERT(), JSON_REPLACE(), and JSON_SET(), see\nthe discussion of JSON_SET().\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/json-modification-functions.html\n\n','mysql> SET @j = \'{ \"a\": 1, \"b\": [2, 3]}\';\nmysql> SELECT JSON_REPLACE(@j, \'$.a\', 10, \'$.c\', \'[true, false]\');\n+-----------------------------------------------------+\n| JSON_REPLACE(@j, \'$.a\', 10, \'$.c\', \'[true, false]\') |\n+-----------------------------------------------------+\n| {\"a\": 10, \"b\": [2, 3]}                              |\n+-----------------------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/json-modification-functions.html'),(402,'JSON_SET',32,'Syntax:\nJSON_SET(json_doc, path, val[, path, val] ...)\n\nInserts or updates data in a JSON document and returns the result.\nReturns NULL if json_doc or path is NULL, or if path, when given, does\nnot locate an object. Otherwise, an error occurs if the json_doc\nargument is not a valid JSON document or any path argument is not a\nvalid path expression or contains a * or ** wildcard.\n\nThe path-value pairs are evaluated left to right. The document produced\nby evaluating one pair becomes the new value against which the next\npair is evaluated.\n\nA path-value pair for an existing path in the document overwrites the\nexisting document value with the new value. A path-value pair for a\nnonexisting path in the document adds the value to the document if the\npath identifies one of these types of values:\n\no A member not present in an existing object. The member is added to\n  the object and associated with the new value.\n\no A position past the end of an existing array. The array is extended\n  with the new value. If the existing value is not an array, it is\n  autowrapped as an array, then extended with the new value.\n\nOtherwise, a path-value pair for a nonexisting path in the document is\nignored and has no effect.\n\nIn MySQL 8.0.4, the optimizer can perform a partial, in-place update of\na JSON column instead of removing the old document and writing the new\ndocument in its entirety to the column. This optimization can be\nperformed for an update statement that uses the JSON_SET() function and\nmeets the conditions outlined in\nhttps://dev.mysql.com/doc/refman/8.0/en/json.html#json-partial-updates.\n\nThe JSON_SET(), JSON_INSERT(), and JSON_REPLACE() functions are\nrelated:\n\no JSON_SET() replaces existing values and adds nonexisting values.\n\no JSON_INSERT() inserts values without replacing existing values.\n\no JSON_REPLACE() replaces only existing values.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/json-modification-functions.html\n\n','mysql> SET @j = \'{ \"a\": 1, \"b\": [2, 3]}\';\nmysql> SELECT JSON_SET(@j, \'$.a\', 10, \'$.c\', \'[true, false]\');\n+-------------------------------------------------+\n| JSON_SET(@j, \'$.a\', 10, \'$.c\', \'[true, false]\') |\n+-------------------------------------------------+\n| {\"a\": 10, \"b\": [2, 3], \"c\": \"[true, false]\"}    |\n+-------------------------------------------------+\nmysql> SELECT JSON_INSERT(@j, \'$.a\', 10, \'$.c\', \'[true, false]\');\n+----------------------------------------------------+\n| JSON_INSERT(@j, \'$.a\', 10, \'$.c\', \'[true, false]\') |\n+----------------------------------------------------+\n| {\"a\": 1, \"b\": [2, 3], \"c\": \"[true, false]\"}        |\n+----------------------------------------------------+\nmysql> SELECT JSON_REPLACE(@j, \'$.a\', 10, \'$.c\', \'[true, false]\');\n+-----------------------------------------------------+\n| JSON_REPLACE(@j, \'$.a\', 10, \'$.c\', \'[true, false]\') |\n+-----------------------------------------------------+\n| {\"a\": 10, \"b\": [2, 3]}                              |\n+-----------------------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/json-modification-functions.html'),(403,'JSON_UNQUOTE',32,'Syntax:\nJSON_UNQUOTE(json_val)\n\nUnquotes JSON value and returns the result as a utf8mb4 string. Returns\nNULL if the argument is NULL. An error occurs if the value starts and\nends with double quotes but is not a valid JSON string literal.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/json-modification-functions.html\n\n','mysql> SET @j = \'\"abc\"\';\nmysql> SELECT @j, JSON_UNQUOTE(@j);\n+-------+------------------+\n| @j    | JSON_UNQUOTE(@j) |\n+-------+------------------+\n| \"abc\" | abc              |\n+-------+------------------+\nmysql> SET @j = \'[1, 2, 3]\';\nmysql> SELECT @j, JSON_UNQUOTE(@j);\n+-----------+------------------+\n| @j        | JSON_UNQUOTE(@j) |\n+-----------+------------------+\n| [1, 2, 3] | [1, 2, 3]        |\n+-----------+------------------+\n\nmysql> SELECT @@sql_mode;\n+------------+\n| @@sql_mode |\n+------------+\n|            |\n+------------+\n\nmysql> SELECT JSON_UNQUOTE(\'\"\\\\t\\\\u0032\"\');\n+------------------------------+\n| JSON_UNQUOTE(\'\"\\\\t\\\\u0032\"\') |\n+------------------------------+\n|       2                           |\n+------------------------------+\n\nmysql> SET @@sql_mode = \'NO_BACKSLASH_ESCAPES\';\nmysql> SELECT JSON_UNQUOTE(\'\"\\\\t\\\\u0032\"\');\n+------------------------------+\n| JSON_UNQUOTE(\'\"\\\\t\\\\u0032\"\') |\n+------------------------------+\n| \\t\\u0032                     |\n+------------------------------+\n\nmysql> SELECT JSON_UNQUOTE(\'\"\\t\\u0032\"\');\n+----------------------------+\n| JSON_UNQUOTE(\'\"\\t\\u0032\"\') |\n+----------------------------+\n|       2                         |\n+----------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/json-modification-functions.html'),(404,'JSON_DEPTH',32,'Syntax:\nJSON_DEPTH(json_doc)\n\nReturns the maximum depth of a JSON document. Returns NULL if the\nargument is NULL. An error occurs if the argument is not a valid JSON\ndocument.\n\nAn empty array, empty object, or scalar value has depth 1. A nonempty\narray containing only elements of depth 1 or nonempty object containing\nonly member values of depth 1 has depth 2. Otherwise, a JSON document\nhas depth greater than 2.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/json-attribute-functions.html\n\n','mysql> SELECT JSON_DEPTH(\'{}\'), JSON_DEPTH(\'[]\'), JSON_DEPTH(\'true\');\n+------------------+------------------+--------------------+\n| JSON_DEPTH(\'{}\') | JSON_DEPTH(\'[]\') | JSON_DEPTH(\'true\') |\n+------------------+------------------+--------------------+\n|                1 |                1 |                  1 |\n+------------------+------------------+--------------------+\nmysql> SELECT JSON_DEPTH(\'[10, 20]\'), JSON_DEPTH(\'[[], {}]\');\n+------------------------+------------------------+\n| JSON_DEPTH(\'[10, 20]\') | JSON_DEPTH(\'[[], {}]\') |\n+------------------------+------------------------+\n|                      2 |                      2 |\n+------------------------+------------------------+\nmysql> SELECT JSON_DEPTH(\'[10, {\"a\": 20}]\');\n+-------------------------------+\n| JSON_DEPTH(\'[10, {\"a\": 20}]\') |\n+-------------------------------+\n|                             3 |\n+-------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/json-attribute-functions.html'),(405,'JSON_LENGTH',32,'Syntax:\nJSON_LENGTH(json_doc[, path])\n\nReturns the length of a JSON document, or, if a path argument is given,\nthe length of the value within the document identified by the path.\nReturns NULL if any argument is NULL or the path argument does not\nidentify a value in the document. An error occurs if the json_doc\nargument is not a valid JSON document or the path argument is not a\nvalid path expression. Prior to MySQL 8.0.26, an error is also raised\nif the path expression contains a * or ** wildcard.\n\nThe length of a document is determined as follows:\n\no The length of a scalar is 1.\n\no The length of an array is the number of array elements.\n\no The length of an object is the number of object members.\n\no The length does not count the length of nested arrays or objects.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/json-attribute-functions.html\n\n','mysql> SELECT JSON_LENGTH(\'[1, 2, {\"a\": 3}]\');\n+---------------------------------+\n| JSON_LENGTH(\'[1, 2, {\"a\": 3}]\') |\n+---------------------------------+\n|                               3 |\n+---------------------------------+\nmysql> SELECT JSON_LENGTH(\'{\"a\": 1, \"b\": {\"c\": 30}}\');\n+-----------------------------------------+\n| JSON_LENGTH(\'{\"a\": 1, \"b\": {\"c\": 30}}\') |\n+-----------------------------------------+\n|                                       2 |\n+-----------------------------------------+\nmysql> SELECT JSON_LENGTH(\'{\"a\": 1, \"b\": {\"c\": 30}}\', \'$.b\');\n+------------------------------------------------+\n| JSON_LENGTH(\'{\"a\": 1, \"b\": {\"c\": 30}}\', \'$.b\') |\n+------------------------------------------------+\n|                                              1 |\n+------------------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/json-attribute-functions.html'),(406,'JSON_TYPE',32,'Syntax:\nJSON_TYPE(json_val)\n\nReturns a utf8mb4 string indicating the type of a JSON value. This can\nbe an object, an array, or a scalar type, as shown here:\n\nmysql> SET @j = \'{\"a\": [10, true]}\';\nmysql> SELECT JSON_TYPE(@j);\n+---------------+\n| JSON_TYPE(@j) |\n+---------------+\n| OBJECT        |\n+---------------+\nmysql> SELECT JSON_TYPE(JSON_EXTRACT(@j, \'$.a\'));\n+------------------------------------+\n| JSON_TYPE(JSON_EXTRACT(@j, \'$.a\')) |\n+------------------------------------+\n| ARRAY                              |\n+------------------------------------+\nmysql> SELECT JSON_TYPE(JSON_EXTRACT(@j, \'$.a[0]\'));\n+---------------------------------------+\n| JSON_TYPE(JSON_EXTRACT(@j, \'$.a[0]\')) |\n+---------------------------------------+\n| INTEGER                               |\n+---------------------------------------+\nmysql> SELECT JSON_TYPE(JSON_EXTRACT(@j, \'$.a[1]\'));\n+---------------------------------------+\n| JSON_TYPE(JSON_EXTRACT(@j, \'$.a[1]\')) |\n+---------------------------------------+\n| BOOLEAN                               |\n+---------------------------------------+\n\nJSON_TYPE() returns NULL if the argument is NULL:\n\nmysql> SELECT JSON_TYPE(NULL);\n+-----------------+\n| JSON_TYPE(NULL) |\n+-----------------+\n| NULL            |\n+-----------------+\n\nAn error occurs if the argument is not a valid JSON value:\n\nmysql> SELECT JSON_TYPE(1);\nERROR 3146 (22032): Invalid data type for JSON data in argument 1\nto function json_type; a JSON string or JSON type is required.\n\nFor a non-NULL, non-error result, the following list describes the\npossible JSON_TYPE() return values:\n\no Purely JSON types:\n\n  o OBJECT: JSON objects\n\n  o ARRAY: JSON arrays\n\n  o BOOLEAN: The JSON true and false literals\n\n  o NULL: The JSON null literal\n\no Numeric types:\n\n  o INTEGER: MySQL TINYINT, SMALLINT, MEDIUMINT and INT and BIGINT\n    scalars\n\n  o DOUBLE: MySQL DOUBLE FLOAT scalars\n\n  o DECIMAL: MySQL DECIMAL and NUMERIC scalars\n\no Temporal types:\n\n  o DATETIME: MySQL DATETIME and TIMESTAMP scalars\n\n  o DATE: MySQL DATE scalars\n\n  o TIME: MySQL TIME scalars\n\no String types:\n\n  o STRING: MySQL utf8mb3 character type scalars: CHAR, VARCHAR, TEXT,\n    ENUM, and SET\n\no Binary types:\n\n  o BLOB: MySQL binary type scalars including BINARY, VARBINARY, BLOB,\n    and BIT\n\no All other types:\n\n  o OPAQUE (raw bits)\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/json-attribute-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/json-attribute-functions.html'),(407,'JSON_VALID',32,'Syntax:\nJSON_VALID(val)\n\nReturns 0 or 1 to indicate whether a value is valid JSON. Returns NULL\nif the argument is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/json-attribute-functions.html\n\n','mysql> SELECT JSON_VALID(\'{\"a\": 1}\');\n+------------------------+\n| JSON_VALID(\'{\"a\": 1}\') |\n+------------------------+\n|                      1 |\n+------------------------+\nmysql> SELECT JSON_VALID(\'hello\'), JSON_VALID(\'\"hello\"\');\n+---------------------+-----------------------+\n| JSON_VALID(\'hello\') | JSON_VALID(\'\"hello\"\') |\n+---------------------+-----------------------+\n|                   0 |                     1 |\n+---------------------+-----------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/json-attribute-functions.html'),(408,'JSON_TABLE',32,'Syntax:\nJSON_TABLE(expr, path COLUMNS (column_list) [AS] alias)\n\nExtracts data from a JSON document and returns it as a relational table\nhaving the specified columns. The complete syntax for this function is\nshown here:\n\nJSON_TABLE(\n    expr,\n    path COLUMNS (column_list)\n)   [AS] alias\n\ncolumn_list:\n    column[, column][, ...]\n\ncolumn:\n    name FOR ORDINALITY\n    |  name type PATH string path [on_empty] [on_error]\n    |  name type EXISTS PATH string path\n    |  NESTED [PATH] path COLUMNS (column_list)\n\non_empty:\n    {NULL | DEFAULT json_string | ERROR} ON EMPTY\n\non_error:\n    {NULL | DEFAULT json_string | ERROR} ON ERROR\n\nexpr: This is an expression that returns JSON data. This can be a\nconstant (\'{\"a\":1}\'), a column (t1.json_data, given table t1 specified\nprior to JSON_TABLE() in the FROM clause), or a function call\n(JSON_EXTRACT(t1.json_data,\'$.post.comments\')).\n\npath: A JSON path expression, which is applied to the data source. We\nrefer to the JSON value matching the path as the row source; this is\nused to generate a row of relational data. The COLUMNS clause evaluates\nthe row source, finds specific JSON values within the row source, and\nreturns those JSON values as SQL values in individual columns of a row\nof relational data.\n\nThe alias is required. The usual rules for table aliases apply (see\nhttps://dev.mysql.com/doc/refman/8.0/en/identifiers.html).\n\nBeginning with MySQL 8.0.27, this function compares column names in\ncase-insensitive fashion.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/json-table-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/json-table-functions.html'),(409,'JSON_SCHEMA_VALID',32,'JSON_SCHEMA_VALID(schema,document)\n\nValidates a JSON document against a JSON schema. Both schema and\ndocument are required. The schema must be a valid JSON object; the\ndocument must be a valid JSON document. Provided that these conditions\nare met: If the document validates against the schema, the function\nreturns true (1); otherwise, it returns false (0).\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/json-validation-functions.html\n\n','mysql> SET @schema = \'{\n    \'>  \"id\": \"http://json-schema.org/geo\",\n    \'> \"$schema\": \"http://json-schema.org/draft-04/schema#\",\n    \'> \"description\": \"A geographical coordinate\",\n    \'> \"type\": \"object\",\n    \'> \"properties\": {\n    \'>   \"latitude\": {\n    \'>     \"type\": \"number\",\n    \'>     \"minimum\": -90,\n    \'>     \"maximum\": 90\n    \'>   },\n    \'>   \"longitude\": {\n    \'>     \"type\": \"number\",\n    \'>     \"minimum\": -180,\n    \'>     \"maximum\": 180\n    \'>   }\n    \'> },\n    \'> \"required\": [\"latitude\", \"longitude\"]\n    \'>}\';\nQuery OK, 0 rows affected (0.01 sec)\n\nmysql> SET @document = \'{\n    \'> \"latitude\": 63.444697,\n    \'> \"longitude\": 10.445118\n    \'>}\';\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> SELECT JSON_SCHEMA_VALID(@schema, @document);\n+---------------------------------------+\n| JSON_SCHEMA_VALID(@schema, @document) |\n+---------------------------------------+\n|                                     1 |\n+---------------------------------------+\n1 row in set (0.00 sec)\n\nmysql> SET @document = \'{}\';\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> SELECT JSON_SCHEMA_VALID(@schema, @document);\n+---------------------------------------+\n| JSON_SCHEMA_VALID(@schema, @document) |\n+---------------------------------------+\n|                                     0 |\n+---------------------------------------+\n1 row in set (0.00 sec)\n\nmysql> SET @schema = \'{\n    \'> \"id\": \"http://json-schema.org/geo\",\n    \'> \"$schema\": \"http://json-schema.org/draft-04/schema#\",\n    \'> \"description\": \"A geographical coordinate\",\n    \'> \"type\": \"object\",\n    \'> \"properties\": {\n    \'>   \"latitude\": {\n    \'>     \"type\": \"number\",\n    \'>     \"minimum\": -90,\n    \'>     \"maximum\": 90\n    \'>   },\n    \'>   \"longitude\": {\n    \'>     \"type\": \"number\",\n    \'>     \"minimum\": -180,\n    \'>     \"maximum\": 180\n    \'>   }\n    \'> }\n    \'>}\';\nQuery OK, 0 rows affected (0.00 sec)\n\n\nmysql> SELECT JSON_SCHEMA_VALID(@schema, @document);\n+---------------------------------------+\n| JSON_SCHEMA_VALID(@schema, @document) |\n+---------------------------------------+\n|                                     1 |\n+---------------------------------------+\n1 row in set (0.00 sec)\n\nmysql> CREATE TABLE geo (\n    ->     coordinate JSON,\n    ->     CHECK(\n    ->         JSON_SCHEMA_VALID(\n    ->             \'{\n    \'>                 \"type\":\"object\",\n    \'>                 \"properties\":{\n    \'>                       \"latitude\":{\"type\":\"number\", \"minimum\":-90, \"maximum\":90},\n    \'>                       \"longitude\":{\"type\":\"number\", \"minimum\":-180, \"maximum\":180}\n    \'>                 },\n    \'>                 \"required\": [\"latitude\", \"longitude\"]\n    \'>             }\',\n    ->             coordinate\n    ->         )\n    ->     )\n    -> );\nQuery OK, 0 rows affected (0.45 sec)\n\nmysql> SET @point1 = \'{\"latitude\":59, \"longitude\":18}\';\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> SET @point2 = \'{\"latitude\":91, \"longitude\":0}\';\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> SET @point3 = \'{\"longitude\":120}\';\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> INSERT INTO geo VALUES(@point1);\nQuery OK, 1 row affected (0.05 sec)\n\nmysql> INSERT INTO geo VALUES(@point2);\nERROR 3819 (HY000): Check constraint \'geo_chk_1\' is violated.\n\nmysql> SHOW WARNINGS\\G\n*************************** 1. row ***************************\n  Level: Error\n   Code: 3934\nMessage: The JSON document location \'#/latitude\' failed requirement \'maximum\' at\nJSON Schema location \'#/properties/latitude\'.\n*************************** 2. row ***************************\n  Level: Error\n   Code: 3819\nMessage: Check constraint \'geo_chk_1\' is violated.\n2 rows in set (0.00 sec)\n\nmysql> INSERT INTO geo VALUES(@point3);\nERROR 3819 (HY000): Check constraint \'geo_chk_1\' is violated.\nmysql> SHOW WARNINGS\\G\n*************************** 1. row ***************************\n  Level: Error\n   Code: 3934\nMessage: The JSON document location \'#\' failed requirement \'required\' at JSON\nSchema location \'#\'.\n*************************** 2. row ***************************\n  Level: Error\n   Code: 3819\nMessage: Check constraint \'geo_chk_1\' is violated.\n2 rows in set (0.00 sec)\n\nmysql> SELECT JSON_SCHEMA_VALID(\'{\"type\":\"string\",\"pattern\":\"(\"}\', \'\"abc\"\');\n+---------------------------------------------------------------+\n| JSON_SCHEMA_VALID(\'{\"type\":\"string\",\"pattern\":\"(\"}\', \'\"abc\"\') |\n+---------------------------------------------------------------+\n|                                                             1 |\n+---------------------------------------------------------------+\n1 row in set (0.04 sec)\n','https://dev.mysql.com/doc/refman/8.0/en/json-validation-functions.html'),(410,'JSON_SCHEMA_VALIDATION_REPORT',32,'JSON_SCHEMA_VALIDATION_REPORT(schema,document)\n\nValidates a JSON document against a JSON schema. Both schema and\ndocument are required. As with JSON_VALID_SCHEMA(), the schema must be\na valid JSON object, and the document must be a valid JSON document.\nProvided that these conditions are met, the function returns a report,\nas a JSON document, on the outcome of the validation. If the JSON\ndocument is considered valid according to the JSON Schema, the function\nreturns a JSON object with one property valid having the value \"true\".\nIf the JSON document fails validation, the function returns a JSON\nobject which includes the properties listed here:\n\no valid: Always \"false\" for a failed schema validation\n\no reason: A human-readable string containing the reason for the failure\n\no schema-location: A JSON pointer URI fragment identifier indicating\n  where in the JSON schema the validation failed (see Note following\n  this list)\n\no document-location: A JSON pointer URI fragment identifier indicating\n  where in the JSON document the validation failed (see Note following\n  this list)\n\no schema-failed-keyword: A string containing the name of the keyword or\n  property in the JSON schema that was violated\n\n*Note*:\n\nJSON pointer URI fragment identifiers are defined in RFC 6901 -\nJavaScript Object Notation (JSON) Pointer\n(https://tools.ietf.org/html/rfc6901#page-5). (These are not the same\nas the JSON path notation used by JSON_EXTRACT() and other MySQL JSON\nfunctions.) In this notation, # represents the entire document, and\n#/myprop represents the portion of the document included in the\ntop-level property named myprop. See the specification just cited and\nthe examples shown later in this section for more information.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/json-validation-functions.html\n\n','mysql> SET @schema = \'{\n    \'>  \"id\": \"http://json-schema.org/geo\",\n    \'> \"$schema\": \"http://json-schema.org/draft-04/schema#\",\n    \'> \"description\": \"A geographical coordinate\",\n    \'> \"type\": \"object\",\n    \'> \"properties\": {\n    \'>   \"latitude\": {\n    \'>     \"type\": \"number\",\n    \'>     \"minimum\": -90,\n    \'>     \"maximum\": 90\n    \'>   },\n    \'>   \"longitude\": {\n    \'>     \"type\": \"number\",\n    \'>     \"minimum\": -180,\n    \'>     \"maximum\": 180\n    \'>   }\n    \'> },\n    \'> \"required\": [\"latitude\", \"longitude\"]\n    \'>}\';\nQuery OK, 0 rows affected (0.01 sec)\n\nmysql> SET @document = \'{\n    \'> \"latitude\": 63.444697,\n    \'> \"longitude\": 10.445118\n    \'>}\';\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> SELECT JSON_SCHEMA_VALIDATION_REPORT(@schema, @document);\n+---------------------------------------------------+\n| JSON_SCHEMA_VALIDATION_REPORT(@schema, @document) |\n+---------------------------------------------------+\n| {\"valid\": true}                                   |\n+---------------------------------------------------+\n1 row in set (0.00 sec)\n\nmysql> SET @document = \'{\n    \'> \"latitude\": 63.444697,\n    \'> \"longitude\": 310.445118\n    \'> }\';\n\nmysql> SELECT JSON_PRETTY(JSON_SCHEMA_VALIDATION_REPORT(@schema, @document))\\G\n*************************** 1. row ***************************\nJSON_PRETTY(JSON_SCHEMA_VALIDATION_REPORT(@schema, @document)): {\n  \"valid\": false,\n  \"reason\": \"The JSON document location \'#/longitude\' failed requirement \'maximum\' at JSON Schema location \'#/properties/longitude\'\",\n  \"schema-location\": \"#/properties/longitude\",\n  \"document-location\": \"#/longitude\",\n  \"schema-failed-keyword\": \"maximum\"\n}\n1 row in set (0.00 sec)\n\nmysql> SET @document = \'{}\';\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> SELECT JSON_PRETTY(JSON_SCHEMA_VALIDATION_REPORT(@schema, @document))\\G\n*************************** 1. row ***************************\nJSON_PRETTY(JSON_SCHEMA_VALIDATION_REPORT(@schema, @document)): {\n  \"valid\": false,\n  \"reason\": \"The JSON document location \'#\' failed requirement \'required\' at JSON Schema location \'#\'\",\n  \"schema-location\": \"#\",\n  \"document-location\": \"#\",\n  \"schema-failed-keyword\": \"required\"\n}\n1 row in set (0.00 sec)\n\nmysql> SET @schema = \'{\n    \'> \"id\": \"http://json-schema.org/geo\",\n    \'> \"$schema\": \"http://json-schema.org/draft-04/schema#\",\n    \'> \"description\": \"A geographical coordinate\",\n    \'> \"type\": \"object\",\n    \'> \"properties\": {\n    \'>   \"latitude\": {\n    \'>     \"type\": \"number\",\n    \'>     \"minimum\": -90,\n    \'>     \"maximum\": 90\n    \'>   },\n    \'>   \"longitude\": {\n    \'>     \"type\": \"number\",\n    \'>     \"minimum\": -180,\n    \'>     \"maximum\": 180\n    \'>   }\n    \'> }\n    \'>}\';\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> SELECT JSON_SCHEMA_VALIDATION_REPORT(@schema, @document);\n+---------------------------------------------------+\n| JSON_SCHEMA_VALIDATION_REPORT(@schema, @document) |\n+---------------------------------------------------+\n| {\"valid\": true}                                   |\n+---------------------------------------------------+\n1 row in set (0.00 sec)\n','https://dev.mysql.com/doc/refman/8.0/en/json-validation-functions.html'),(411,'JSON_PRETTY',32,'JSON_PRETTY(json_val)\n\nProvides pretty-printing of JSON values similar to that implemented in\nPHP and by other languages and database systems. The value supplied\nmust be a JSON value or a valid string representation of a JSON value.\nExtraneous whitespaces and newlines present in this value have no\neffect on the output. For a NULL value, the function returns NULL. If\nthe value is not a JSON document, or if it cannot be parsed as one, the\nfunction fails with an error.\n\nFormatting of the output from this function adheres to the following\nrules:\n\no Each array element or object member appears on a separate line,\n  indented by one additional level as compared to its parent.\n\no Each level of indentation adds two leading spaces.\n\no A comma separating individual array elements or object members is\n  printed before the newline that separates the two elements or\n  members.\n\no The key and the value of an object member are separated by a colon\n  followed by a space (\': \').\n\no An empty object or array is printed on a single line. No space is\n  printed between the opening and closing brace.\n\no Special characters in string scalars and key names are escaped\n  employing the same rules used by the JSON_QUOTE() function.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/json-utility-functions.html\n\n','mysql> SELECT JSON_PRETTY(\'123\'); # scalar\n+--------------------+\n| JSON_PRETTY(\'123\') |\n+--------------------+\n| 123                |\n+--------------------+\n\nmysql> SELECT JSON_PRETTY(\"[1,3,5]\"); # array\n+------------------------+\n| JSON_PRETTY(\"[1,3,5]\") |\n+------------------------+\n| [\n  1,\n  3,\n  5\n]      |\n+------------------------+\n\nmysql> SELECT JSON_PRETTY(\'{\"a\":\"10\",\"b\":\"15\",\"x\":\"25\"}\'); # object\n+---------------------------------------------+\n| JSON_PRETTY(\'{\"a\":\"10\",\"b\":\"15\",\"x\":\"25\"}\') |\n+---------------------------------------------+\n| {\n  \"a\": \"10\",\n  \"b\": \"15\",\n  \"x\": \"25\"\n}   |\n+---------------------------------------------+\n\nmysql> SELECT JSON_PRETTY(\'[\"a\",1,{\"key1\":\n    \'>    \"value1\"},\"5\",     \"77\" ,\n    \'>       {\"key2\":[\"value3\",\"valueX\",\n    \'> \"valueY\"]},\"j\", \"2\"   ]\')\\G  # nested arrays and objects\n*************************** 1. row ***************************\nJSON_PRETTY(\'[\"a\",1,{\"key1\":\n             \"value1\"},\"5\",     \"77\" ,\n                {\"key2\":[\"value3\",\"valuex\",\n          \"valuey\"]},\"j\", \"2\"   ]\'): [\n  \"a\",\n  1,\n  {\n    \"key1\": \"value1\"\n  },\n  \"5\",\n  \"77\",\n  {\n    \"key2\": [\n      \"value3\",\n      \"valuex\",\n      \"valuey\"\n    ]\n  },\n  \"j\",\n  \"2\"\n]\n','https://dev.mysql.com/doc/refman/8.0/en/json-utility-functions.html'),(412,'JSON_STORAGE_FREE',32,'JSON_STORAGE_FREE(json_val)\n\nFor a JSON column value, this function shows how much storage space was\nfreed in its binary representation after it was updated in place using\nJSON_SET(), JSON_REPLACE(), or JSON_REMOVE(). The argument can also be\na valid JSON document or a string which can be parsed as one---either\nas a literal value or as the value of a user variable---in which case\nthe function returns 0. It returns a positive, nonzero value if the\nargument is a JSON column value which has been updated as described\npreviously, such that its binary representation takes up less space\nthan it did prior to the update. For a JSON column which has been\nupdated such that its binary representation is the same as or larger\nthan before, or if the update was not able to take advantage of a\npartial update, it returns 0; it returns NULL if the argument is NULL.\n\nIf json_val is not NULL, and neither is a valid JSON document nor can\nbe successfully parsed as one, an error results.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/json-utility-functions.html\n\n','mysql> CREATE TABLE jtable (jcol JSON);\nQuery OK, 0 rows affected (0.38 sec)\n\nmysql> INSERT INTO jtable VALUES\n    ->     (\'{\"a\": 10, \"b\": \"wxyz\", \"c\": \"[true, false]\"}\');\nQuery OK, 1 row affected (0.04 sec)\n\nmysql> SELECT * FROM jtable;\n+----------------------------------------------+\n| jcol                                         |\n+----------------------------------------------+\n| {\"a\": 10, \"b\": \"wxyz\", \"c\": \"[true, false]\"} |\n+----------------------------------------------+\n1 row in set (0.00 sec)\n\nmysql> UPDATE jtable\n    ->     SET jcol = JSON_SET(jcol, \"$.a\", 10, \"$.b\", \"wxyz\", \"$.c\", 1);\nQuery OK, 1 row affected (0.03 sec)\nRows matched: 1  Changed: 1  Warnings: 0\n\nmysql> SELECT * FROM jtable;\n+--------------------------------+\n| jcol                           |\n+--------------------------------+\n| {\"a\": 10, \"b\": \"wxyz\", \"c\": 1} |\n+--------------------------------+\n1 row in set (0.00 sec)\n\nmysql> SELECT JSON_STORAGE_FREE(jcol) FROM jtable;\n+-------------------------+\n| JSON_STORAGE_FREE(jcol) |\n+-------------------------+\n|                      14 |\n+-------------------------+\n1 row in set (0.00 sec)\n\nmysql> UPDATE jtable\n    ->     SET jcol = JSON_SET(jcol, \"$.a\", 10, \"$.b\", \"wx\", \"$.c\", 1);\nQuery OK, 1 row affected (0.03 sec)\nRows matched: 1  Changed: 1  Warnings: 0\n\nmysql> SELECT JSON_STORAGE_FREE(jcol) FROM jtable;\n+-------------------------+\n| JSON_STORAGE_FREE(jcol) |\n+-------------------------+\n|                      16 |\n+-------------------------+\n1 row in set (0.00 sec)\n\nmysql> UPDATE jtable SET jcol = \'{\"a\": 10, \"b\": 1}\';\nQuery OK, 1 row affected (0.05 sec)\nRows matched: 1  Changed: 1  Warnings: 0\n\nmysql> SELECT JSON_STORAGE_FREE(jcol) FROM jtable;\n+-------------------------+\n| JSON_STORAGE_FREE(jcol) |\n+-------------------------+\n|                       0 |\n+-------------------------+\n1 row in set (0.00 sec)\n\nmysql> SET @j = \'{\"a\": 10, \"b\": \"wxyz\", \"c\": \"[true, false]\"}\';\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> SET @j = JSON_SET(@j, \'$.a\', 10, \'$.b\', \'wxyz\', \'$.c\', \'1\');\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> SELECT @j, JSON_STORAGE_FREE(@j) AS Free;\n+----------------------------------+------+\n| @j                               | Free |\n+----------------------------------+------+\n| {\"a\": 10, \"b\": \"wxyz\", \"c\": \"1\"} |    0 |\n+----------------------------------+------+\n1 row in set (0.00 sec)\n\nmysql> SELECT JSON_STORAGE_FREE(\'{\"a\": 10, \"b\": \"wxyz\", \"c\": \"1\"}\') AS Free;\n+------+\n| Free |\n+------+\n|    0 |\n+------+\n1 row in set (0.00 sec)\n','https://dev.mysql.com/doc/refman/8.0/en/json-utility-functions.html'),(413,'JSON_STORAGE_SIZE',32,'JSON_STORAGE_SIZE(json_val)\n\nThis function returns the number of bytes used to store the binary\nrepresentation of a JSON document. When the argument is a JSON column,\nthis is the space used to store the JSON document as it was inserted\ninto the column, prior to any partial updates that may have been\nperformed on it afterwards. json_val must be a valid JSON document or a\nstring which can be parsed as one. In the case where it is string, the\nfunction returns the amount of storage space in the JSON binary\nrepresentation that is created by parsing the string as JSON and\nconverting it to binary. It returns NULL if the argument is NULL.\n\nAn error results when json_val is not NULL, and is not---or cannot be\nsuccessfully parsed as---a JSON document.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/json-utility-functions.html\n\n','mysql> CREATE TABLE jtable (jcol JSON);\nQuery OK, 0 rows affected (0.42 sec)\n\nmysql> INSERT INTO jtable VALUES\n    ->     (\'{\"a\": 1000, \"b\": \"wxyz\", \"c\": \"[1, 3, 5, 7]\"}\');\nQuery OK, 1 row affected (0.04 sec)\n\nmysql> SELECT\n    ->     jcol,\n    ->     JSON_STORAGE_SIZE(jcol) AS Size,\n    ->     JSON_STORAGE_FREE(jcol) AS Free\n    -> FROM jtable;\n+-----------------------------------------------+------+------+\n| jcol                                          | Size | Free |\n+-----------------------------------------------+------+------+\n| {\"a\": 1000, \"b\": \"wxyz\", \"c\": \"[1, 3, 5, 7]\"} |   47 |    0 |\n+-----------------------------------------------+------+------+\n1 row in set (0.00 sec)\n\nmysql> UPDATE jtable SET jcol = \n    ->     JSON_SET(jcol, \"$.b\", \"a\");\nQuery OK, 1 row affected (0.04 sec)\nRows matched: 1  Changed: 1  Warnings: 0\n\nmysql> SELECT\n    ->     jcol,\n    ->     JSON_STORAGE_SIZE(jcol) AS Size,\n    ->     JSON_STORAGE_FREE(jcol) AS Free\n    -> FROM jtable;\n+--------------------------------------------+------+------+\n| jcol                                       | Size | Free |\n+--------------------------------------------+------+------+\n| {\"a\": 1000, \"b\": \"a\", \"c\": \"[1, 3, 5, 7]\"} |   47 |    3 |\n+--------------------------------------------+------+------+\n1 row in set (0.00 sec)\n\nmysql> UPDATE jtable\nmysql>     SET jcol = \'{\"a\": 4.55, \"b\": \"wxyz\", \"c\": \"[true, false]\"}\';\nQuery OK, 1 row affected (0.04 sec)\nRows matched: 1  Changed: 1  Warnings: 0\n\nmysql> SELECT\n    ->     jcol,\n    ->     JSON_STORAGE_SIZE(jcol) AS Size,\n    ->     JSON_STORAGE_FREE(jcol) AS Free\n    -> FROM jtable;\n+------------------------------------------------+------+------+\n| jcol                                           | Size | Free |\n+------------------------------------------------+------+------+\n| {\"a\": 4.55, \"b\": \"wxyz\", \"c\": \"[true, false]\"} |   56 |    0 |\n+------------------------------------------------+------+------+\n1 row in set (0.00 sec)\n\nmysql> SET @j = \'[100, \"sakila\", [1, 3, 5], 425.05]\';\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> SELECT @j, JSON_STORAGE_SIZE(@j) AS Size;\n+------------------------------------+------+\n| @j                                 | Size |\n+------------------------------------+------+\n| [100, \"sakila\", [1, 3, 5], 425.05] |   45 |\n+------------------------------------+------+\n1 row in set (0.00 sec)\n\nmysql> SET @j = JSON_SET(@j, \'$[1]\', \"json\");\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> SELECT @j, JSON_STORAGE_SIZE(@j) AS Size;\n+----------------------------------+------+\n| @j                               | Size |\n+----------------------------------+------+\n| [100, \"json\", [1, 3, 5], 425.05] |   43 |\n+----------------------------------+------+\n1 row in set (0.00 sec)\n\nmysql> SET @j = JSON_SET(@j, \'$[2][0]\', JSON_ARRAY(10, 20, 30));\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> SELECT @j, JSON_STORAGE_SIZE(@j) AS Size;\n+---------------------------------------------+------+\n| @j                                          | Size |\n+---------------------------------------------+------+\n| [100, \"json\", [[10, 20, 30], 3, 5], 425.05] |   56 |\n+---------------------------------------------+------+\n1 row in set (0.00 sec)\n\nmysql> SELECT\n    ->     JSON_STORAGE_SIZE(\'[100, \"sakila\", [1, 3, 5], 425.05]\') AS A,\n    ->     JSON_STORAGE_SIZE(\'{\"a\": 1000, \"b\": \"a\", \"c\": \"[1, 3, 5, 7]\"}\') AS B,\n    ->     JSON_STORAGE_SIZE(\'{\"a\": 1000, \"b\": \"wxyz\", \"c\": \"[1, 3, 5, 7]\"}\') AS C,\n    ->     JSON_STORAGE_SIZE(\'[100, \"json\", [[10, 20, 30], 3, 5], 425.05]\') AS D;\n+----+----+----+----+\n| A  | B  | C  | D  |\n+----+----+----+----+\n| 45 | 44 | 47 | 56 |\n+----+----+----+----+\n1 row in set (0.00 sec)\n','https://dev.mysql.com/doc/refman/8.0/en/json-utility-functions.html'),(414,'GTID_SUBSET',33,'Syntax:\nGTID_SUBSET(set1,set2)\n\nGiven two sets of global transaction identifiers set1 and set2, returns\ntrue if all GTIDs in set1 are also in set2. Returns NULL if set1 or\nset2 is NULL. Returns false otherwise.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gtid-functions.html\n\n','mysql> SELECT GTID_SUBSET(\'3E11FA47-71CA-11E1-9E33-C80AA9429562:23\',\n    ->     \'3E11FA47-71CA-11E1-9E33-C80AA9429562:21-57\')\\G\n*************************** 1. row ***************************\nGTID_SUBSET(\'3E11FA47-71CA-11E1-9E33-C80AA9429562:23\',\n    \'3E11FA47-71CA-11E1-9E33-C80AA9429562:21-57\'): 1\n1 row in set (0.00 sec)\n\nmysql> SELECT GTID_SUBSET(\'3E11FA47-71CA-11E1-9E33-C80AA9429562:23-25\',\n    ->     \'3E11FA47-71CA-11E1-9E33-C80AA9429562:21-57\')\\G\n*************************** 1. row ***************************\nGTID_SUBSET(\'3E11FA47-71CA-11E1-9E33-C80AA9429562:23-25\',\n    \'3E11FA47-71CA-11E1-9E33-C80AA9429562:21-57\'): 1\n1 row in set (0.00 sec)\n\nmysql> SELECT GTID_SUBSET(\'3E11FA47-71CA-11E1-9E33-C80AA9429562:20-25\',\n    ->     \'3E11FA47-71CA-11E1-9E33-C80AA9429562:21-57\')\\G\n*************************** 1. row ***************************\nGTID_SUBSET(\'3E11FA47-71CA-11E1-9E33-C80AA9429562:20-25\',\n    \'3E11FA47-71CA-11E1-9E33-C80AA9429562:21-57\'): 0\n1 row in set (0.00 sec)\n','https://dev.mysql.com/doc/refman/8.0/en/gtid-functions.html'),(415,'GTID_SUBTRACT',33,'Syntax:\nGTID_SUBTRACT(set1,set2)\n\nGiven two sets of global transaction identifiers set1 and set2, returns\nonly those GTIDs from set1 that are not in set2. Returns NULL if set1\nor set2 is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gtid-functions.html\n\n','mysql> SELECT GTID_SUBTRACT(\'3E11FA47-71CA-11E1-9E33-C80AA9429562:21-57\',\n    ->     \'3E11FA47-71CA-11E1-9E33-C80AA9429562:21\')\\G\n*************************** 1. row ***************************\nGTID_SUBTRACT(\'3E11FA47-71CA-11E1-9E33-C80AA9429562:21-57\',\n    \'3E11FA47-71CA-11E1-9E33-C80AA9429562:21\'): 3e11fa47-71ca-11e1-9e33-c80aa9429562:22-57\n1 row in set (0.00 sec)\n\nmysql> SELECT GTID_SUBTRACT(\'3E11FA47-71CA-11E1-9E33-C80AA9429562:21-57\',\n    ->     \'3E11FA47-71CA-11E1-9E33-C80AA9429562:20-25\')\\G\n*************************** 1. row ***************************\nGTID_SUBTRACT(\'3E11FA47-71CA-11E1-9E33-C80AA9429562:21-57\',\n    \'3E11FA47-71CA-11E1-9E33-C80AA9429562:20-25\'): 3e11fa47-71ca-11e1-9e33-c80aa9429562:26-57\n1 row in set (0.00 sec)\n\nmysql> SELECT GTID_SUBTRACT(\'3E11FA47-71CA-11E1-9E33-C80AA9429562:21-57\',\n    ->     \'3E11FA47-71CA-11E1-9E33-C80AA9429562:23-24\')\\G\n*************************** 1. row ***************************\nGTID_SUBTRACT(\'3E11FA47-71CA-11E1-9E33-C80AA9429562:21-57\',\n    \'3E11FA47-71CA-11E1-9E33-C80AA9429562:23-24\'): 3e11fa47-71ca-11e1-9e33-c80aa9429562:21-22:25-57\n1 row in set (0.01 sec)\n','https://dev.mysql.com/doc/refman/8.0/en/gtid-functions.html'),(416,'WAIT_FOR_EXECUTED_GTID_SET',33,'Syntax:\nWAIT_FOR_EXECUTED_GTID_SET(gtid_set[, timeout])\n\nWait until the server has applied all of the transactions whose global\ntransaction identifiers are contained in gtid_set; that is, until the\ncondition GTID_SUBSET(gtid_subset, @@GLOBAL.gtid_executed) holds. See\nhttps://dev.mysql.com/doc/refman/8.0/en/replication-gtids-concepts.html\nfor a definition of GTID sets.\n\nIf a timeout is specified, and timeout seconds elapse before all of the\ntransactions in the GTID set have been applied, the function stops\nwaiting. timeout is optional, and the default timeout is 0 seconds, in\nwhich case the function always waits until all of the transactions in\nthe GTID set have been applied.\n\nWAIT_FOR_EXECUTED_GTID_SET() monitors all the GTIDs that are applied on\nthe server, including transactions that arrive from all replication\nchannels and user clients. It does not take into account whether\nreplication channels have been started or stopped.\n\nFor more information, see\nhttps://dev.mysql.com/doc/refman/8.0/en/replication-gtids.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gtid-functions.html\n\n','mysql> SELECT WAIT_FOR_EXECUTED_GTID_SET(\'3E11FA47-71CA-11E1-9E33-C80AA9429562:1-5\');\n        -> 0\n','https://dev.mysql.com/doc/refman/8.0/en/gtid-functions.html'),(417,'WAIT_UNTIL_SQL_THREAD_AFTER_GTIDS',33,'Syntax:\nWAIT_UNTIL_SQL_THREAD_AFTER_GTIDS(gtid_set[, timeout][,channel])\n\nWAIT_UNTIL_SQL_THREAD_AFTER_GTIDS() is deprecated. Use\nWAIT_FOR_EXECUTED_GTID_SET() instead, which works regardless of the\nreplication channel or user client through which the specified\ntransactions arrive on the server.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/gtid-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/gtid-functions.html'),(418,'AVG',34,'Syntax:\nAVG([DISTINCT] expr) [over_clause]\n\nReturns the average value of expr. The DISTINCT option can be used to\nreturn the average of the distinct values of expr.\n\nIf there are no matching rows, AVG() returns NULL. The function also\nreturns NULL if expr is NULL.\n\nThis function executes as a window function if over_clause is present.\nover_clause is as described in\nhttps://dev.mysql.com/doc/refman/8.0/en/window-functions-usage.html; it\ncannot be used with DISTINCT.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/aggregate-functions.html\n\n','mysql> SELECT student_name, AVG(test_score)\n       FROM student\n       GROUP BY student_name;\n','https://dev.mysql.com/doc/refman/8.0/en/aggregate-functions.html'),(419,'BIT_AND',34,'Syntax:\nBIT_AND(expr) [over_clause]\n\nReturns the bitwise AND of all bits in expr.\n\nThe result type depends on whether the function argument values are\nevaluated as binary strings or numbers:\n\no Binary-string evaluation occurs when the argument values have a\n  binary string type, and the argument is not a hexadecimal literal,\n  bit literal, or NULL literal. Numeric evaluation occurs otherwise,\n  with argument value conversion to unsigned 64-bit integers as\n  necessary.\n\no Binary-string evaluation produces a binary string of the same length\n  as the argument values. If argument values have unequal lengths, an\n  ER_INVALID_BITWISE_OPERANDS_SIZE\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_invalid_bitwise_operands_size) error occurs. If the\n  argument size exceeds 511 bytes, an\n  ER_INVALID_BITWISE_AGGREGATE_OPERANDS_SIZE\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_invalid_bitwise_aggregate_operands_size) error occurs.\n  Numeric evaluation produces an unsigned 64-bit integer.\n\nIf there are no matching rows, BIT_AND() returns a neutral value (all\nbits set to 1) having the same length as the argument values.\n\nNULL values do not affect the result unless all values are NULL. In\nthat case, the result is a neutral value having the same length as the\nargument values.\n\nFor more information discussion about argument evaluation and result\ntypes, see the introductory discussion in\nhttps://dev.mysql.com/doc/refman/8.0/en/bit-functions.html.\n\nIf BIT_AND() is invoked from within the mysql client, binary string\nresults display using hexadecimal notation, depending on the value of\nthe --binary-as-hex. For more information about that option, see\nhttps://dev.mysql.com/doc/refman/8.0/en/mysql.html.\n\nAs of MySQL 8.0.12, this function executes as a window function if\nover_clause is present. over_clause is as described in\nhttps://dev.mysql.com/doc/refman/8.0/en/window-functions-usage.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/aggregate-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/aggregate-functions.html'),(420,'BIT_OR',34,'Syntax:\nBIT_OR(expr) [over_clause]\n\nReturns the bitwise OR of all bits in expr.\n\nThe result type depends on whether the function argument values are\nevaluated as binary strings or numbers:\n\no Binary-string evaluation occurs when the argument values have a\n  binary string type, and the argument is not a hexadecimal literal,\n  bit literal, or NULL literal. Numeric evaluation occurs otherwise,\n  with argument value conversion to unsigned 64-bit integers as\n  necessary.\n\no Binary-string evaluation produces a binary string of the same length\n  as the argument values. If argument values have unequal lengths, an\n  ER_INVALID_BITWISE_OPERANDS_SIZE\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_invalid_bitwise_operands_size) error occurs. If the\n  argument size exceeds 511 bytes, an\n  ER_INVALID_BITWISE_AGGREGATE_OPERANDS_SIZE\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_invalid_bitwise_aggregate_operands_size) error occurs.\n  Numeric evaluation produces an unsigned 64-bit integer.\n\nIf there are no matching rows, BIT_OR() returns a neutral value (all\nbits set to 0) having the same length as the argument values.\n\nNULL values do not affect the result unless all values are NULL. In\nthat case, the result is a neutral value having the same length as the\nargument values.\n\nFor more information discussion about argument evaluation and result\ntypes, see the introductory discussion in\nhttps://dev.mysql.com/doc/refman/8.0/en/bit-functions.html.\n\nIf BIT_OR() is invoked from within the mysql client, binary string\nresults display using hexadecimal notation, depending on the value of\nthe --binary-as-hex. For more information about that option, see\nhttps://dev.mysql.com/doc/refman/8.0/en/mysql.html.\n\nAs of MySQL 8.0.12, this function executes as a window function if\nover_clause is present. over_clause is as described in\nhttps://dev.mysql.com/doc/refman/8.0/en/window-functions-usage.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/aggregate-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/aggregate-functions.html'),(421,'BIT_XOR',34,'Syntax:\nBIT_XOR(expr) [over_clause]\n\nReturns the bitwise XOR of all bits in expr.\n\nThe result type depends on whether the function argument values are\nevaluated as binary strings or numbers:\n\no Binary-string evaluation occurs when the argument values have a\n  binary string type, and the argument is not a hexadecimal literal,\n  bit literal, or NULL literal. Numeric evaluation occurs otherwise,\n  with argument value conversion to unsigned 64-bit integers as\n  necessary.\n\no Binary-string evaluation produces a binary string of the same length\n  as the argument values. If argument values have unequal lengths, an\n  ER_INVALID_BITWISE_OPERANDS_SIZE\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_invalid_bitwise_operands_size) error occurs. If the\n  argument size exceeds 511 bytes, an\n  ER_INVALID_BITWISE_AGGREGATE_OPERANDS_SIZE\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_invalid_bitwise_aggregate_operands_size) error occurs.\n  Numeric evaluation produces an unsigned 64-bit integer.\n\nIf there are no matching rows, BIT_XOR() returns a neutral value (all\nbits set to 0) having the same length as the argument values.\n\nNULL values do not affect the result unless all values are NULL. In\nthat case, the result is a neutral value having the same length as the\nargument values.\n\nFor more information discussion about argument evaluation and result\ntypes, see the introductory discussion in\nhttps://dev.mysql.com/doc/refman/8.0/en/bit-functions.html.\n\nIf BIT_XOR() is invoked from within the mysql client, binary string\nresults display using hexadecimal notation, depending on the value of\nthe --binary-as-hex. For more information about that option, see\nhttps://dev.mysql.com/doc/refman/8.0/en/mysql.html.\n\nAs of MySQL 8.0.12, this function executes as a window function if\nover_clause is present. over_clause is as described in\nhttps://dev.mysql.com/doc/refman/8.0/en/window-functions-usage.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/aggregate-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/aggregate-functions.html'),(422,'COUNT',34,'Syntax:\nCOUNT(expr) [over_clause]\n\nReturns a count of the number of non-NULL values of expr in the rows\nretrieved by a SELECT statement. The result is a BIGINT value.\n\nIf there are no matching rows, COUNT() returns 0. COUNT(NULL) returns\n0.\n\nThis function executes as a window function if over_clause is present.\nover_clause is as described in\nhttps://dev.mysql.com/doc/refman/8.0/en/window-functions-usage.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/aggregate-functions.html\n\n','mysql> SELECT student.student_name,COUNT(*)\n       FROM student,course\n       WHERE student.student_id=course.student_id\n       GROUP BY student_name;\n','https://dev.mysql.com/doc/refman/8.0/en/aggregate-functions.html'),(423,'COUNT DISTINCT',34,'Syntax:\nCOUNT(DISTINCT expr,[expr...])\n\nReturns a count of the number of rows with different non-NULL expr\nvalues.\n\nIf there are no matching rows, COUNT(DISTINCT) returns 0.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/aggregate-functions.html\n\n','mysql> SELECT COUNT(DISTINCT results) FROM student;\n','https://dev.mysql.com/doc/refman/8.0/en/aggregate-functions.html'),(424,'GROUP_CONCAT',34,'Syntax:\nGROUP_CONCAT(expr)\n\nThis function returns a string result with the concatenated non-NULL\nvalues from a group. It returns NULL if there are no non-NULL values.\nThe full syntax is as follows:\n\nGROUP_CONCAT([DISTINCT] expr [,expr ...]\n             [ORDER BY {unsigned_integer | col_name | expr}\n                 [ASC | DESC] [,col_name ...]]\n             [SEPARATOR str_val])\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/aggregate-functions.html\n\n','mysql> SELECT student_name,\n         GROUP_CONCAT(test_score)\n       FROM student\n       GROUP BY student_name;\n','https://dev.mysql.com/doc/refman/8.0/en/aggregate-functions.html'),(425,'JSON_ARRAYAGG',34,'Syntax:\nJSON_ARRAYAGG(col_or_expr) [over_clause]\n\nAggregates a result set as a single JSON array whose elements consist\nof the rows. The order of elements in this array is undefined. The\nfunction acts on a column or an expression that evaluates to a single\nvalue. Returns NULL if the result contains no rows, or in the event of\nan error. If col_or_expr is NULL, the function returns an array of JSON\n[null] elements.\n\nAs of MySQL 8.0.14, this function executes as a window function if\nover_clause is present. over_clause is as described in\nhttps://dev.mysql.com/doc/refman/8.0/en/window-functions-usage.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/aggregate-functions.html\n\n','mysql> SELECT o_id, attribute, value FROM t3;\n+------+-----------+-------+\n| o_id | attribute | value |\n+------+-----------+-------+\n|    2 | color     | red   |\n|    2 | fabric    | silk  |\n|    3 | color     | green |\n|    3 | shape     | square|\n+------+-----------+-------+\n4 rows in set (0.00 sec)\n\nmysql> SELECT o_id, JSON_ARRAYAGG(attribute) AS attributes\n    -> FROM t3 GROUP BY o_id;\n+------+---------------------+\n| o_id | attributes          |\n+------+---------------------+\n|    2 | [\"color\", \"fabric\"] |\n|    3 | [\"color\", \"shape\"]  |\n+------+---------------------+\n2 rows in set (0.00 sec)\n','https://dev.mysql.com/doc/refman/8.0/en/aggregate-functions.html'),(426,'JSON_OBJECTAGG',34,'Syntax:\nJSON_OBJECTAGG(key, value) [over_clause]\n\nTakes two column names or expressions as arguments, the first of these\nbeing used as a key and the second as a value, and returns a JSON\nobject containing key-value pairs. Returns NULL if the result contains\nno rows, or in the event of an error. An error occurs if any key name\nis NULL or the number of arguments is not equal to 2.\n\nAs of MySQL 8.0.14, this function executes as a window function if\nover_clause is present. over_clause is as described in\nhttps://dev.mysql.com/doc/refman/8.0/en/window-functions-usage.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/aggregate-functions.html\n\n','mysql> SELECT o_id, attribute, value FROM t3;\n+------+-----------+-------+\n| o_id | attribute | value |\n+------+-----------+-------+\n|    2 | color     | red   |\n|    2 | fabric    | silk  |\n|    3 | color     | green |\n|    3 | shape     | square|\n+------+-----------+-------+\n4 rows in set (0.00 sec)\n\nmysql> SELECT o_id, JSON_OBJECTAGG(attribute, value)\n    -> FROM t3 GROUP BY o_id;\n+------+---------------------------------------+\n| o_id | JSON_OBJECTAGG(attribute, value)      |\n+------+---------------------------------------+\n|    2 | {\"color\": \"red\", \"fabric\": \"silk\"}    |\n|    3 | {\"color\": \"green\", \"shape\": \"square\"} |\n+------+---------------------------------------+\n2 rows in set (0.00 sec)\n','https://dev.mysql.com/doc/refman/8.0/en/aggregate-functions.html'),(427,'MAX',34,'Syntax:\nMAX([DISTINCT] expr) [over_clause]\n\nReturns the maximum value of expr. MAX() may take a string argument; in\nsuch cases, it returns the maximum string value. See\nhttps://dev.mysql.com/doc/refman/8.0/en/mysql-indexes.html. The\nDISTINCT keyword can be used to find the maximum of the distinct values\nof expr, however, this produces the same result as omitting DISTINCT.\n\nIf there are no matching rows, or if expr is NULL, MAX() returns NULL.\n\nThis function executes as a window function if over_clause is present.\nover_clause is as described in\nhttps://dev.mysql.com/doc/refman/8.0/en/window-functions-usage.html; it\ncannot be used with DISTINCT.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/aggregate-functions.html\n\n','mysql> SELECT student_name, MIN(test_score), MAX(test_score)\n       FROM student\n       GROUP BY student_name;\n','https://dev.mysql.com/doc/refman/8.0/en/aggregate-functions.html'),(428,'MIN',34,'Syntax:\nMIN([DISTINCT] expr) [over_clause]\n\nReturns the minimum value of expr. MIN() may take a string argument; in\nsuch cases, it returns the minimum string value. See\nhttps://dev.mysql.com/doc/refman/8.0/en/mysql-indexes.html. The\nDISTINCT keyword can be used to find the minimum of the distinct values\nof expr, however, this produces the same result as omitting DISTINCT.\n\nIf there are no matching rows, or if expr is NULL, MIN() returns NULL.\n\nThis function executes as a window function if over_clause is present.\nover_clause is as described in\nhttps://dev.mysql.com/doc/refman/8.0/en/window-functions-usage.html; it\ncannot be used with DISTINCT.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/aggregate-functions.html\n\n','mysql> SELECT student_name, MIN(test_score), MAX(test_score)\n       FROM student\n       GROUP BY student_name;\n','https://dev.mysql.com/doc/refman/8.0/en/aggregate-functions.html'),(429,'STD',34,'Syntax:\nSTD(expr) [over_clause]\n\nReturns the population standard deviation of expr. STD() is a synonym\nfor the standard SQL function STDDEV_POP(), provided as a MySQL\nextension.\n\nIf there are no matching rows, or if expr is NULL, STD() returns NULL.\n\nThis function executes as a window function if over_clause is present.\nover_clause is as described in\nhttps://dev.mysql.com/doc/refman/8.0/en/window-functions-usage.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/aggregate-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/aggregate-functions.html'),(430,'STDDEV',34,'Syntax:\nSTDDEV(expr) [over_clause]\n\nReturns the population standard deviation of expr. STDDEV() is a\nsynonym for the standard SQL function STDDEV_POP(), provided for\ncompatibility with Oracle.\n\nIf there are no matching rows, or if expr is NULL, STDDEV() returns\nNULL.\n\nThis function executes as a window function if over_clause is present.\nover_clause is as described in\nhttps://dev.mysql.com/doc/refman/8.0/en/window-functions-usage.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/aggregate-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/aggregate-functions.html'),(431,'STDDEV_POP',34,'Syntax:\nSTDDEV_POP(expr) [over_clause]\n\nReturns the population standard deviation of expr (the square root of\nVAR_POP()). You can also use STD() or STDDEV(), which are equivalent\nbut not standard SQL.\n\nIf there are no matching rows, or if expr is NULL, STDDEV_POP() returns\nNULL.\n\nThis function executes as a window function if over_clause is present.\nover_clause is as described in\nhttps://dev.mysql.com/doc/refman/8.0/en/window-functions-usage.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/aggregate-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/aggregate-functions.html'),(432,'STDDEV_SAMP',34,'Syntax:\nSTDDEV_SAMP(expr) [over_clause]\n\nReturns the sample standard deviation of expr (the square root of\nVAR_SAMP().\n\nIf there are no matching rows, or if expr is NULL, STDDEV_SAMP()\nreturns NULL.\n\nThis function executes as a window function if over_clause is present.\nover_clause is as described in\nhttps://dev.mysql.com/doc/refman/8.0/en/window-functions-usage.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/aggregate-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/aggregate-functions.html'),(433,'SUM',34,'Syntax:\nSUM([DISTINCT] expr) [over_clause]\n\nReturns the sum of expr. If the return set has no rows, SUM() returns\nNULL. The DISTINCT keyword can be used to sum only the distinct values\nof expr.\n\nIf there are no matching rows, or if expr is NULL, SUM() returns NULL.\n\nThis function executes as a window function if over_clause is present.\nover_clause is as described in\nhttps://dev.mysql.com/doc/refman/8.0/en/window-functions-usage.html; it\ncannot be used with DISTINCT.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/aggregate-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/aggregate-functions.html'),(434,'VAR_POP',34,'Syntax:\nVAR_POP(expr) [over_clause]\n\nReturns the population standard variance of expr. It considers rows as\nthe whole population, not as a sample, so it has the number of rows as\nthe denominator. You can also use VARIANCE(), which is equivalent but\nis not standard SQL.\n\nIf there are no matching rows, or if expr is NULL, VAR_POP() returns\nNULL.\n\nThis function executes as a window function if over_clause is present.\nover_clause is as described in\nhttps://dev.mysql.com/doc/refman/8.0/en/window-functions-usage.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/aggregate-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/aggregate-functions.html'),(435,'VAR_SAMP',34,'Syntax:\nVAR_SAMP(expr) [over_clause]\n\nReturns the sample variance of expr. That is, the denominator is the\nnumber of rows minus one.\n\nIf there are no matching rows, or if expr is NULL, VAR_SAMP() returns\nNULL.\n\nThis function executes as a window function if over_clause is present.\nover_clause is as described in\nhttps://dev.mysql.com/doc/refman/8.0/en/window-functions-usage.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/aggregate-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/aggregate-functions.html'),(436,'VARIANCE',34,'Syntax:\nVARIANCE(expr) [over_clause]\n\nReturns the population standard variance of expr. VARIANCE() is a\nsynonym for the standard SQL function VAR_POP(), provided as a MySQL\nextension.\n\nIf there are no matching rows, or if expr is NULL, VARIANCE() returns\nNULL.\n\nThis function executes as a window function if over_clause is present.\nover_clause is as described in\nhttps://dev.mysql.com/doc/refman/8.0/en/window-functions-usage.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/aggregate-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/aggregate-functions.html'),(437,'CUME_DIST',36,'CUME_DIST() over_clause\n\nReturns the cumulative distribution of a value within a group of\nvalues; that is, the percentage of partition values less than or equal\nto the value in the current row. This represents the number of rows\npreceding or peer with the current row in the window ordering of the\nwindow partition divided by the total number of rows in the window\npartition. Return values range from 0 to 1.\n\nThis function should be used with ORDER BY to sort partition rows into\nthe desired order. Without ORDER BY, all rows are peers and have value\nN/N = 1, where N is the partition size.\n\nover_clause is as described in\nhttps://dev.mysql.com/doc/refman/8.0/en/window-functions-usage.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/window-function-descriptions.html\n\n','mysql> SELECT\n         val,\n         ROW_NUMBER()   OVER w AS \'row_number\',\n         CUME_DIST()    OVER w AS \'cume_dist\',\n         PERCENT_RANK() OVER w AS \'percent_rank\'\n       FROM numbers\n       WINDOW w AS (ORDER BY val);\n+------+------------+--------------------+--------------+\n| val  | row_number | cume_dist          | percent_rank |\n+------+------------+--------------------+--------------+\n|    1 |          1 | 0.2222222222222222 |            0 |\n|    1 |          2 | 0.2222222222222222 |            0 |\n|    2 |          3 | 0.3333333333333333 |         0.25 |\n|    3 |          4 | 0.6666666666666666 |        0.375 |\n|    3 |          5 | 0.6666666666666666 |        0.375 |\n|    3 |          6 | 0.6666666666666666 |        0.375 |\n|    4 |          7 | 0.8888888888888888 |         0.75 |\n|    4 |          8 | 0.8888888888888888 |         0.75 |\n|    5 |          9 |                  1 |            1 |\n+------+------------+--------------------+--------------+\n','https://dev.mysql.com/doc/refman/8.0/en/window-function-descriptions.html'),(438,'DENSE_RANK',36,'DENSE_RANK() over_clause\n\nReturns the rank of the current row within its partition, without gaps.\nPeers are considered ties and receive the same rank. This function\nassigns consecutive ranks to peer groups; the result is that groups of\nsize greater than one do not produce noncontiguous rank numbers. For an\nexample, see the RANK() function description.\n\nThis function should be used with ORDER BY to sort partition rows into\nthe desired order. Without ORDER BY, all rows are peers.\n\nover_clause is as described in\nhttps://dev.mysql.com/doc/refman/8.0/en/window-functions-usage.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/window-function-descriptions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/window-function-descriptions.html'),(439,'FIRST_VALUE',36,'FIRST_VALUE(expr) [null_treatment] over_clause\n\nReturns the value of expr from the first row of the window frame.\n\nover_clause is as described in\nhttps://dev.mysql.com/doc/refman/8.0/en/window-functions-usage.html.\nnull_treatment is as described in the section introduction.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/window-function-descriptions.html\n\n','mysql> SELECT\n         time, subject, val,\n         FIRST_VALUE(val)  OVER w AS \'first\',\n         LAST_VALUE(val)   OVER w AS \'last\',\n         NTH_VALUE(val, 2) OVER w AS \'second\',\n         NTH_VALUE(val, 4) OVER w AS \'fourth\'\n       FROM observations\n       WINDOW w AS (PARTITION BY subject ORDER BY time\n                    ROWS UNBOUNDED PRECEDING);\n+----------+---------+------+-------+------+--------+--------+\n| time     | subject | val  | first | last | second | fourth |\n+----------+---------+------+-------+------+--------+--------+\n| 07:00:00 | st113   |   10 |    10 |   10 |   NULL |   NULL |\n| 07:15:00 | st113   |    9 |    10 |    9 |      9 |   NULL |\n| 07:30:00 | st113   |   25 |    10 |   25 |      9 |   NULL |\n| 07:45:00 | st113   |   20 |    10 |   20 |      9 |     20 |\n| 07:00:00 | xh458   |    0 |     0 |    0 |   NULL |   NULL |\n| 07:15:00 | xh458   |   10 |     0 |   10 |     10 |   NULL |\n| 07:30:00 | xh458   |    5 |     0 |    5 |     10 |   NULL |\n| 07:45:00 | xh458   |   30 |     0 |   30 |     10 |     30 |\n| 08:00:00 | xh458   |   25 |     0 |   25 |     10 |     30 |\n+----------+---------+------+-------+------+--------+--------+\n','https://dev.mysql.com/doc/refman/8.0/en/window-function-descriptions.html'),(440,'LAG',36,'LAG(expr [, N[, default]]) [null_treatment] over_clause\n\nReturns the value of expr from the row that lags (precedes) the current\nrow by N rows within its partition. If there is no such row, the return\nvalue is default. For example, if N is 3, the return value is default\nfor the first three rows. If N or default are missing, the defaults are\n1 and NULL, respectively.\n\nN must be a literal nonnegative integer. If N is 0, expr is evaluated\nfor the current row.\n\nBeginning with MySQL 8.0.22, N cannot be NULL. In addition, it must now\nbe an integer in the range 1 to 263, inclusive, in any of the following\nforms:\n\no an unsigned integer constant literal\n\no a positional parameter marker (?)\n\no a user-defined variable\n\no a local variable in a stored routine\n\nover_clause is as described in\nhttps://dev.mysql.com/doc/refman/8.0/en/window-functions-usage.html.\nnull_treatment is as described in the section introduction.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/window-function-descriptions.html\n\n','mysql> SELECT\n         t, val,\n         LAG(val)        OVER w AS \'lag\',\n         LEAD(val)       OVER w AS \'lead\',\n         val - LAG(val)  OVER w AS \'lag diff\',\n         val - LEAD(val) OVER w AS \'lead diff\'\n       FROM series\n       WINDOW w AS (ORDER BY t);\n+----------+------+------+------+----------+-----------+\n| t        | val  | lag  | lead | lag diff | lead diff |\n+----------+------+------+------+----------+-----------+\n| 12:00:00 |  100 | NULL |  125 |     NULL |       -25 |\n| 13:00:00 |  125 |  100 |  132 |       25 |        -7 |\n| 14:00:00 |  132 |  125 |  145 |        7 |       -13 |\n| 15:00:00 |  145 |  132 |  140 |       13 |         5 |\n| 16:00:00 |  140 |  145 |  150 |       -5 |       -10 |\n| 17:00:00 |  150 |  140 |  200 |       10 |       -50 |\n| 18:00:00 |  200 |  150 | NULL |       50 |      NULL |\n+----------+------+------+------+----------+-----------+\n\nmysql> SELECT n FROM fib ORDER BY n;\n+------+\n| n    |\n+------+\n|    1 |\n|    1 |\n|    2 |\n|    3 |\n|    5 |\n|    8 |\n+------+\n\nmysql> SELECT\n         n,\n         LAG(n, 1, 0)      OVER w AS \'lag\',\n         LEAD(n, 1, 0)     OVER w AS \'lead\',\n         n + LAG(n, 1, 0)  OVER w AS \'next_n\',\n         n + LEAD(n, 1, 0) OVER w AS \'next_next_n\'\n       FROM fib\n       WINDOW w AS (ORDER BY n);\n+------+------+------+--------+-------------+\n| n    | lag  | lead | next_n | next_next_n |\n+------+------+------+--------+-------------+\n|    1 |    0 |    1 |      1 |           2 |\n|    1 |    1 |    2 |      2 |           3 |\n|    2 |    1 |    3 |      3 |           5 |\n|    3 |    2 |    5 |      5 |           8 |\n|    5 |    3 |    8 |      8 |          13 |\n|    8 |    5 |    0 |     13 |           8 |\n+------+------+------+--------+-------------+\n','https://dev.mysql.com/doc/refman/8.0/en/window-function-descriptions.html'),(441,'LAST_VALUE',36,'LAST_VALUE(expr) [null_treatment] over_clause\n\nReturns the value of expr from the last row of the window frame.\n\nover_clause is as described in\nhttps://dev.mysql.com/doc/refman/8.0/en/window-functions-usage.html.\nnull_treatment is as described in the section introduction.\n\nFor an example, see the FIRST_VALUE() function description.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/window-function-descriptions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/window-function-descriptions.html'),(442,'LEAD',36,'LEAD(expr [, N[, default]]) [null_treatment] over_clause\n\nReturns the value of expr from the row that leads (follows) the current\nrow by N rows within its partition. If there is no such row, the return\nvalue is default. For example, if N is 3, the return value is default\nfor the last three rows. If N or default are missing, the defaults are\n1 and NULL, respectively.\n\nN must be a literal nonnegative integer. If N is 0, expr is evaluated\nfor the current row.\n\nBeginning with MySQL 8.0.22, N cannot be NULL. In addition, it must now\nbe an integer in the range 1 to 263, inclusive, in any of the following\nforms:\n\no an unsigned integer constant literal\n\no a positional parameter marker (?)\n\no a user-defined variable\n\no a local variable in a stored routine\n\nover_clause is as described in\nhttps://dev.mysql.com/doc/refman/8.0/en/window-functions-usage.html.\nnull_treatment is as described in the section introduction.\n\nFor an example, see the LAG() function description.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/window-function-descriptions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/window-function-descriptions.html'),(443,'NTH_VALUE',36,'NTH_VALUE(expr, N) [from_first_last] [null_treatment] over_clause\n\nReturns the value of expr from the N-th row of the window frame. If\nthere is no such row, the return value is NULL.\n\nN must be a literal positive integer.\n\nfrom_first_last is part of the SQL standard, but the MySQL\nimplementation permits only FROM FIRST (which is also the default).\nThis means that calculations begin at the first row of the window. FROM\nLAST is parsed, but produces an error. To obtain the same effect as\nFROM LAST (begin calculations at the last row of the window), use ORDER\nBY to sort in reverse order.\n\nover_clause is as described in\nhttps://dev.mysql.com/doc/refman/8.0/en/window-functions-usage.html.\nnull_treatment is as described in the section introduction.\n\nFor an example, see the FIRST_VALUE() function description.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/window-function-descriptions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/window-function-descriptions.html'),(444,'NTILE',36,'NTILE(N) over_clause\n\nDivides a partition into N groups (buckets), assigns each row in the\npartition its bucket number, and returns the bucket number of the\ncurrent row within its partition. For example, if N is 4, NTILE()\ndivides rows into four buckets. If N is 100, NTILE() divides rows into\n100 buckets.\n\nN must be a literal positive integer. Bucket number return values range\nfrom 1 to N.\n\nBeginning with MySQL 8.0.22, N cannot be NULL. In addition, it must be\nan integer in the range 1 to 263, inclusive, in any of the following\nforms:\n\no an unsigned integer constant literal\n\no a positional parameter marker (?)\n\no a user-defined variable\n\no a local variable in a stored routine\n\nThis function should be used with ORDER BY to sort partition rows into\nthe desired order.\n\nover_clause is as described in\nhttps://dev.mysql.com/doc/refman/8.0/en/window-functions-usage.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/window-function-descriptions.html\n\n','mysql> SELECT\n         val,\n         ROW_NUMBER() OVER w AS \'row_number\',\n         NTILE(2)     OVER w AS \'ntile2\',\n         NTILE(4)     OVER w AS \'ntile4\'\n       FROM numbers\n       WINDOW w AS (ORDER BY val);\n+------+------------+--------+--------+\n| val  | row_number | ntile2 | ntile4 |\n+------+------------+--------+--------+\n|    1 |          1 |      1 |      1 |\n|    1 |          2 |      1 |      1 |\n|    2 |          3 |      1 |      1 |\n|    3 |          4 |      1 |      2 |\n|    3 |          5 |      1 |      2 |\n|    3 |          6 |      2 |      3 |\n|    4 |          7 |      2 |      3 |\n|    4 |          8 |      2 |      4 |\n|    5 |          9 |      2 |      4 |\n+------+------------+--------+--------+\n','https://dev.mysql.com/doc/refman/8.0/en/window-function-descriptions.html'),(445,'PERCENT_RANK',36,'PERCENT_RANK() over_clause\n\nReturns the percentage of partition values less than the value in the\ncurrent row, excluding the highest value. Return values range from 0 to\n1 and represent the row relative rank, calculated as the result of this\nformula, where rank is the row rank and rows is the number of partition\nrows:\n\n(rank - 1) / (rows - 1)\n\nThis function should be used with ORDER BY to sort partition rows into\nthe desired order. Without ORDER BY, all rows are peers.\n\nover_clause is as described in\nhttps://dev.mysql.com/doc/refman/8.0/en/window-functions-usage.html.\n\nFor an example, see the CUME_DIST() function description.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/window-function-descriptions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/window-function-descriptions.html'),(446,'RANK',36,'RANK() over_clause\n\nReturns the rank of the current row within its partition, with gaps.\nPeers are considered ties and receive the same rank. This function does\nnot assign consecutive ranks to peer groups if groups of size greater\nthan one exist; the result is noncontiguous rank numbers.\n\nThis function should be used with ORDER BY to sort partition rows into\nthe desired order. Without ORDER BY, all rows are peers.\n\nover_clause is as described in\nhttps://dev.mysql.com/doc/refman/8.0/en/window-functions-usage.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/window-function-descriptions.html\n\n','mysql> SELECT\n         val,\n         ROW_NUMBER() OVER w AS \'row_number\',\n         RANK()       OVER w AS \'rank\',\n         DENSE_RANK() OVER w AS \'dense_rank\'\n       FROM numbers\n       WINDOW w AS (ORDER BY val);\n+------+------------+------+------------+\n| val  | row_number | rank | dense_rank |\n+------+------------+------+------------+\n|    1 |          1 |    1 |          1 |\n|    1 |          2 |    1 |          1 |\n|    2 |          3 |    3 |          2 |\n|    3 |          4 |    4 |          3 |\n|    3 |          5 |    4 |          3 |\n|    3 |          6 |    4 |          3 |\n|    4 |          7 |    7 |          4 |\n|    4 |          8 |    7 |          4 |\n|    5 |          9 |    9 |          5 |\n+------+------------+------+------------+\n','https://dev.mysql.com/doc/refman/8.0/en/window-function-descriptions.html'),(447,'ROW_NUMBER',36,'ROW_NUMBER() over_clause\n\nReturns the number of the current row within its partition. Rows\nnumbers range from 1 to the number of partition rows.\n\nORDER BY affects the order in which rows are numbered. Without ORDER\nBY, row numbering is nondeterministic.\n\nROW_NUMBER() assigns peers different row numbers. To assign peers the\nsame value, use RANK() or DENSE_RANK(). For an example, see the RANK()\nfunction description.\n\nover_clause is as described in\nhttps://dev.mysql.com/doc/refman/8.0/en/window-functions-usage.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/window-function-descriptions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/window-function-descriptions.html'),(448,'FORMAT_BYTES',37,'FORMAT_BYTES(count)\n\nGiven a numeric byte count, converts it to human-readable format and\nreturns a string consisting of a value and a units indicator. The\nstring contains the number of bytes rounded to 2 decimal places and a\nminimum of 3 significant digits. Numbers less than 1024 bytes are\nrepresented as whole numbers and are not rounded. Returns NULL if count\nis NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/performance-schema-functions.html\n\n','mysql> SELECT FORMAT_BYTES(512), FORMAT_BYTES(18446644073709551615);\n+-------------------+------------------------------------+\n| FORMAT_BYTES(512) | FORMAT_BYTES(18446644073709551615) |\n+-------------------+------------------------------------+\n|  512 bytes        | 16.00 EiB                          |\n+-------------------+------------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/performance-schema-functions.html'),(449,'FORMAT_PICO_TIME',37,'FORMAT_PICO_TIME(time_val)\n\nGiven a numeric Performance Schema latency or wait time in picoseconds,\nconverts it to human-readable format and returns a string consisting of\na value and a units indicator. The string contains the decimal time\nrounded to 2 decimal places and a minimum of 3 significant digits.\nTimes under 1 nanosecond are represented as whole numbers and are not\nrounded.\n\nIf time_val is NULL, this function returns NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/performance-schema-functions.html\n\n','mysql> SELECT FORMAT_PICO_TIME(3501), FORMAT_PICO_TIME(188732396662000);\n+------------------------+-----------------------------------+\n| FORMAT_PICO_TIME(3501) | FORMAT_PICO_TIME(188732396662000) |\n+------------------------+-----------------------------------+\n| 3.50 ns                | 3.15 min                          |\n+------------------------+-----------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/performance-schema-functions.html'),(450,'PS_CURRENT_THREAD_ID',37,'PS_CURRENT_THREAD_ID()\n\nReturns a BIGINT UNSIGNED value representing the Performance Schema\nthread ID assigned to the current connection.\n\nThe thread ID return value is a value of the type given in the\nTHREAD_ID column of Performance Schema tables.\n\nPerformance Schema configuration affects PS_CURRENT_THREAD_ID() the\nsame way as for PS_THREAD_ID(). For details, see the description of\nthat function.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/performance-schema-functions.html\n\n','mysql> SELECT PS_CURRENT_THREAD_ID();\n+------------------------+\n| PS_CURRENT_THREAD_ID() |\n+------------------------+\n|                     52 |\n+------------------------+\nmysql> SELECT PS_THREAD_ID(CONNECTION_ID());\n+-------------------------------+\n| PS_THREAD_ID(CONNECTION_ID()) |\n+-------------------------------+\n|                            52 |\n+-------------------------------+\n','https://dev.mysql.com/doc/refman/8.0/en/performance-schema-functions.html'),(451,'PS_THREAD_ID',37,'PS_THREAD_ID(connection_id)\n\nGiven a connection ID, returns a BIGINT UNSIGNED value representing the\nPerformance Schema thread ID assigned to the connection ID, or NULL if\nno thread ID exists for the connection ID. The latter can occur for\nthreads that are not instrumented, or if connection_id is NULL.\n\nThe connection ID argument is a value of the type given in the\nPROCESSLIST_ID column of the Performance Schema threads table or the Id\ncolumn of SHOW PROCESSLIST output.\n\nThe thread ID return value is a value of the type given in the\nTHREAD_ID column of Performance Schema tables.\n\nPerformance Schema configuration affects PS_THREAD_ID() operation as\nfollows. (These remarks also apply to PS_CURRENT_THREAD_ID().)\n\no Disabling the thread_instrumentation consumer disables statistics\n  from being collected and aggregated at the thread level, but has no\n  effect on PS_THREAD_ID().\n\no If performance_schema_max_thread_instances is not 0, the Performance\n  Schema allocates memory for thread statistics and assigns an internal\n  ID to each thread for which instance memory is available. If there\n  are threads for which instance memory is not available,\n  PS_THREAD_ID() returns NULL; in this case,\n  Performance_schema_thread_instances_lost is nonzero.\n\no If performance_schema_max_thread_instances is 0, the Performance\n  Schema allocates no thread memory and PS_THREAD_ID() returns NULL.\n\no If the Performance Schema itself is disabled, PS_THREAD_ID() produces\n  an error.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/performance-schema-functions.html\n\n','mysql> SELECT PS_THREAD_ID(6);\n+-----------------+\n| PS_THREAD_ID(6) |\n+-----------------+\n|              45 |\n+-----------------+\n','https://dev.mysql.com/doc/refman/8.0/en/performance-schema-functions.html'),(452,'CAN_ACCESS_COLUMN',38,'CAN_ACCESS_COLUMN(ARGS)\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html'),(453,'CAN_ACCESS_DATABASE',38,'CAN_ACCESS_DATABASE(ARGS)\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html'),(454,'CAN_ACCESS_TABLE',38,'CAN_ACCESS_TABLE(ARGS)\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html'),(455,'CAN_ACCESS_USER',38,'CAN_ACCESS_USER(ARGS)\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html'),(456,'CAN_ACCESS_VIEW',38,'CAN_ACCESS_VIEW(ARGS)\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html'),(457,'GET_DD_COLUMN_PRIVILEGES',38,'GET_DD_COLUMN_PRIVILEGES(ARGS)\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html'),(458,'GET_DD_CREATE_OPTIONS',38,'GET_DD_CREATE_OPTIONS(ARGS)\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html'),(459,'GET_DD_INDEX_SUB_PART_LENGTH',38,'GET_DD_INDEX_SUB_PART_LENGTH(ARGS)\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html'),(460,'INTERNAL_AUTO_INCREMENT',38,'INTERNAL_AUTO_INCREMENT(ARGS)\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html'),(461,'INTERNAL_AVG_ROW_LENGTH',38,'INTERNAL_AVG_ROW_LENGTH(ARGS)\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html'),(462,'INTERNAL_CHECK_TIME',38,'INTERNAL_CHECK_TIME(ARGS)\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html'),(463,'INTERNAL_CHECKSUM',38,'INTERNAL_CHECKSUM(ARGS)\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html'),(464,'INTERNAL_DATA_FREE',38,'INTERNAL_DATA_FREE(ARGS)\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html'),(465,'INTERNAL_DATA_LENGTH',38,'INTERNAL_DATA_LENGTH(ARGS)\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html'),(466,'INTERNAL_DD_CHAR_LENGTH',38,'INTERNAL_DD_CHAR_LENGTH(ARGS)\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html'),(467,'INTERNAL_GET_COMMENT_OR_ERROR',38,'INTERNAL_GET_COMMENT_OR_ERROR(ARGS)\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html'),(468,'INTERNAL_GET_ENABLED_ROLE_JSON',38,'INTERNAL_GET_ENABLED_ROLE_JSON(ARGS)\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html'),(469,'INTERNAL_GET_HOSTNAME',38,'INTERNAL_GET_HOSTNAME(ARGS)\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html'),(470,'INTERNAL_GET_USERNAME',38,'INTERNAL_GET_USERNAME(ARGS)\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html'),(471,'INTERNAL_GET_VIEW_WARNING_OR_ERROR',38,'INTERNAL_GET_VIEW_WARNING_OR_ERROR(ARGS)\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html'),(472,'INTERNAL_INDEX_COLUMN_CARDINALITY',38,'INTERNAL_INDEX_COLUMN_CARDINALITY(ARGS)\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html'),(473,'INTERNAL_INDEX_LENGTH',38,'INTERNAL_INDEX_LENGTH(ARGS)\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html'),(474,'INTERNAL_IS_ENABLED_ROLE',38,'INTERNAL_IS_ENABLED_ROLE(ARGS)\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html'),(475,'INTERNAL_IS_MANDATORY_ROLE',38,'INTERNAL_IS_MANDATORY_ROLE(ARGS)\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html'),(476,'INTERNAL_KEYS_DISABLED',38,'INTERNAL_KEYS_DISABLED(ARGS)\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html'),(477,'INTERNAL_MAX_DATA_LENGTH',38,'INTERNAL_MAX_DATA_LENGTH(ARGS)\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html'),(478,'INTERNAL_TABLE_ROWS',38,'INTERNAL_TABLE_ROWS(ARGS)\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html'),(479,'INTERNAL_UPDATE_TIME',38,'INTERNAL_UPDATE_TIME(ARGS)\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html'),(480,'IS_VISIBLE_DD_OBJECT',38,'IS_VISIBLE_DD_OBJECT(ARGS)\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/internal-functions.html'),(481,'ANY_VALUE',39,'ANY_VALUE(arg)\n\nThis function is useful for GROUP BY queries when the\nONLY_FULL_GROUP_BY SQL mode is enabled, for cases when MySQL rejects a\nquery that you know is valid for reasons that MySQL cannot determine.\nThe function return value and type are the same as the return value and\ntype of its argument, but the function result is not checked for the\nONLY_FULL_GROUP_BY SQL mode.\n\nFor example, if name is a nonindexed column, the following query fails\nwith ONLY_FULL_GROUP_BY enabled:\n\nmysql> SELECT name, address, MAX(age) FROM t GROUP BY name;\nERROR 1055 (42000): Expression #2 of SELECT list is not in GROUP\nBY clause and contains nonaggregated column \'mydb.t.address\' which\nis not functionally dependent on columns in GROUP BY clause; this\nis incompatible with sql_mode=only_full_group_by\n\nThe failure occurs because address is a nonaggregated column that is\nneither named among GROUP BY columns nor functionally dependent on\nthem. As a result, the address value for rows within each name group is\nnondeterministic. There are multiple ways to cause MySQL to accept the\nquery:\n\no Alter the table to make name a primary key or a unique NOT NULL\n  column. This enables MySQL to determine that address is functionally\n  dependent on name; that is, address is uniquely determined by name.\n  (This technique is inapplicable if NULL must be permitted as a valid\n  name value.)\n\no Use ANY_VALUE() to refer to address:\n\nSELECT name, ANY_VALUE(address), MAX(age) FROM t GROUP BY name;\n\n  In this case, MySQL ignores the nondeterminism of address values\n  within each name group and accepts the query. This may be useful if\n  you simply do not care which value of a nonaggregated column is\n  chosen for each group. ANY_VALUE() is not an aggregate function,\n  unlike functions such as SUM() or COUNT(). It simply acts to suppress\n  the test for nondeterminism.\n\no Disable ONLY_FULL_GROUP_BY. This is equivalent to using ANY_VALUE()\n  with ONLY_FULL_GROUP_BY enabled, as described in the previous item.\n\nANY_VALUE() is also useful if functional dependence exists between\ncolumns but MySQL cannot determine it. The following query is valid\nbecause age is functionally dependent on the grouping column age-1, but\nMySQL cannot tell that and rejects the query with ONLY_FULL_GROUP_BY\nenabled:\n\nSELECT age FROM t GROUP BY age-1;\n\nTo cause MySQL to accept the query, use ANY_VALUE():\n\nSELECT ANY_VALUE(age) FROM t GROUP BY age-1;\n\nANY_VALUE() can be used for queries that refer to aggregate functions\nin the absence of a GROUP BY clause:\n\nmysql> SELECT name, MAX(age) FROM t;\nERROR 1140 (42000): In aggregated query without GROUP BY, expression\n#1 of SELECT list contains nonaggregated column \'mydb.t.name\'; this\nis incompatible with sql_mode=only_full_group_by\n\nWithout GROUP BY, there is a single group and it is nondeterministic\nwhich name value to choose for the group. ANY_VALUE() tells MySQL to\naccept the query:\n\nSELECT ANY_VALUE(name), MAX(age) FROM t;\n\nIt may be that, due to some property of a given data set, you know that\na selected nonaggregated column is effectively functionally dependent\non a GROUP BY column. For example, an application may enforce\nuniqueness of one column with respect to another. In this case, using\nANY_VALUE() for the effectively functionally dependent column may make\nsense.\n\nFor additional discussion, see\nhttps://dev.mysql.com/doc/refman/8.0/en/group-by-handling.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/miscellaneous-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/miscellaneous-functions.html'),(482,'BIN_TO_UUID',39,'BIN_TO_UUID(binary_uuid), BIN_TO_UUID(binary_uuid, swap_flag)\n\nBIN_TO_UUID() is the inverse of UUID_TO_BIN(). It converts a binary\nUUID to a string UUID and returns the result. The binary value should\nbe a UUID as a VARBINARY(16) value. The return value is a string of\nfive hexadecimal numbers separated by dashes. (For details about this\nformat, see the UUID() function description.) If the UUID argument is\nNULL, the return value is NULL. If any argument is invalid, an error\noccurs.\n\nBIN_TO_UUID() takes one or two arguments:\n\no The one-argument form takes a binary UUID value. The UUID value is\n  assumed not to have its time-low and time-high parts swapped. The\n  string result is in the same order as the binary argument.\n\no The two-argument form takes a binary UUID value and a swap-flag\n  value:\n\n  o If swap_flag is 0, the two-argument form is equivalent to the\n    one-argument form. The string result is in the same order as the\n    binary argument.\n\n  o If swap_flag is 1, the UUID value is assumed to have its time-low\n    and time-high parts swapped. These parts are swapped back to their\n    original position in the result value.\n\nFor usage examples and information about time-part swapping, see the\nUUID_TO_BIN() function description.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/miscellaneous-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/miscellaneous-functions.html'),(483,'DEFAULT',39,'Syntax:\nDEFAULT(col_name)\n\nReturns the default value for a table column. An error results if the\ncolumn has no default value.\n\nThe use of DEFAULT(col_name) to specify the default value for a named\ncolumn is permitted only for columns that have a literal default value,\nnot for columns that have an expression default value.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/miscellaneous-functions.html\n\n','mysql> UPDATE t SET i = DEFAULT(i)+1 WHERE id < 100;\n','https://dev.mysql.com/doc/refman/8.0/en/miscellaneous-functions.html'),(484,'GROUPING',39,'GROUPING(expr [, expr] ...)\n\nFor GROUP BY queries that include a WITH ROLLUP modifier, the ROLLUP\noperation produces super-aggregate output rows where NULL represents\nthe set of all values. The GROUPING() function enables you to\ndistinguish NULL values for super-aggregate rows from NULL values in\nregular grouped rows.\n\nGROUPING() is permitted in the select list, HAVING clause, and (as of\nMySQL 8.0.12) ORDER BY clause.\n\nEach argument to GROUPING() must be an expression that exactly matches\nan expression in the GROUP BY clause. The expression cannot be a\npositional specifier. For each expression, GROUPING() produces 1 if the\nexpression value in the current row is a NULL representing a\nsuper-aggregate value. Otherwise, GROUPING() produces 0, indicating\nthat the expression value is a NULL for a regular result row or is not\nNULL.\n\nSuppose that table t1 contains these rows, where NULL indicates\nsomething like \"other\" or \"unknown\":\n\nmysql> SELECT * FROM t1;\n+------+-------+----------+\n| name | size  | quantity |\n+------+-------+----------+\n| ball | small |       10 |\n| ball | large |       20 |\n| ball | NULL  |        5 |\n| hoop | small |       15 |\n| hoop | large |        5 |\n| hoop | NULL  |        3 |\n+------+-------+----------+\n\nA summary of the table without WITH ROLLUP looks like this:\n\nmysql> SELECT name, size, SUM(quantity) AS quantity\n       FROM t1\n       GROUP BY name, size;\n+------+-------+----------+\n| name | size  | quantity |\n+------+-------+----------+\n| ball | small |       10 |\n| ball | large |       20 |\n| ball | NULL  |        5 |\n| hoop | small |       15 |\n| hoop | large |        5 |\n| hoop | NULL  |        3 |\n+------+-------+----------+\n\nThe result contains NULL values, but those do not represent\nsuper-aggregate rows because the query does not include WITH ROLLUP.\n\nAdding WITH ROLLUP produces super-aggregate summary rows containing\nadditional NULL values. However, without comparing this result to the\nprevious one, it is not easy to see which NULL values occur in\nsuper-aggregate rows and which occur in regular grouped rows:\n\nmysql> SELECT name, size, SUM(quantity) AS quantity\n       FROM t1\n       GROUP BY name, size WITH ROLLUP;\n+------+-------+----------+\n| name | size  | quantity |\n+------+-------+----------+\n| ball | NULL  |        5 |\n| ball | large |       20 |\n| ball | small |       10 |\n| ball | NULL  |       35 |\n| hoop | NULL  |        3 |\n| hoop | large |        5 |\n| hoop | small |       15 |\n| hoop | NULL  |       23 |\n| NULL | NULL  |       58 |\n+------+-------+----------+\n\nTo distinguish NULL values in super-aggregate rows from those in\nregular grouped rows, use GROUPING(), which returns 1 only for\nsuper-aggregate NULL values:\n\nmysql> SELECT\n         name, size, SUM(quantity) AS quantity,\n         GROUPING(name) AS grp_name,\n         GROUPING(size) AS grp_size\n       FROM t1\n       GROUP BY name, size WITH ROLLUP;\n+------+-------+----------+----------+----------+\n| name | size  | quantity | grp_name | grp_size |\n+------+-------+----------+----------+----------+\n| ball | NULL  |        5 |        0 |        0 |\n| ball | large |       20 |        0 |        0 |\n| ball | small |       10 |        0 |        0 |\n| ball | NULL  |       35 |        0 |        1 |\n| hoop | NULL  |        3 |        0 |        0 |\n| hoop | large |        5 |        0 |        0 |\n| hoop | small |       15 |        0 |        0 |\n| hoop | NULL  |       23 |        0 |        1 |\n| NULL | NULL  |       58 |        1 |        1 |\n+------+-------+----------+----------+----------+\n\nCommon uses for GROUPING():\n\no Substitute a label for super-aggregate NULL values:\n\nmysql> SELECT\n         IF(GROUPING(name) = 1, \'All items\', name) AS name,\n         IF(GROUPING(size) = 1, \'All sizes\', size) AS size,\n         SUM(quantity) AS quantity\n       FROM t1\n       GROUP BY name, size WITH ROLLUP;\n+-----------+-----------+----------+\n| name      | size      | quantity |\n+-----------+-----------+----------+\n| ball      | NULL      |        5 |\n| ball      | large     |       20 |\n| ball      | small     |       10 |\n| ball      | All sizes |       35 |\n| hoop      | NULL      |        3 |\n| hoop      | large     |        5 |\n| hoop      | small     |       15 |\n| hoop      | All sizes |       23 |\n| All items | All sizes |       58 |\n+-----------+-----------+----------+\n\no Return only super-aggregate lines by filtering out the regular\n  grouped lines:\n\nmysql> SELECT name, size, SUM(quantity) AS quantity\n       FROM t1\n       GROUP BY name, size WITH ROLLUP\n       HAVING GROUPING(name) = 1 OR GROUPING(size) = 1;\n+------+------+----------+\n| name | size | quantity |\n+------+------+----------+\n| ball | NULL |       35 |\n| hoop | NULL |       23 |\n| NULL | NULL |       58 |\n+------+------+----------+\n\nGROUPING() permits multiple expression arguments. In this case, the\nGROUPING() return value represents a bitmask combined from the results\nfor each expression, where the lowest-order bit corresponds to the\nresult for the rightmost expression. For example, with three expression\narguments, GROUPING(expr1, expr2, expr3) is evaluated like this:\n\n  result for GROUPING(expr3)\n+ result for GROUPING(expr2) << 1\n+ result for GROUPING(expr1) << 2\n\nThe following query shows how GROUPING() results for single arguments\ncombine for a multiple-argument call to produce a bitmask value:\n\nmysql> SELECT\n         name, size, SUM(quantity) AS quantity,\n         GROUPING(name) AS grp_name,\n         GROUPING(size) AS grp_size,\n       GROUPING(name, size) AS grp_all\n       FROM t1\n       GROUP BY name, size WITH ROLLUP;\n+------+-------+----------+----------+----------+---------+\n| name | size  | quantity | grp_name | grp_size | grp_all |\n+------+-------+----------+----------+----------+---------+\n| ball | NULL  |        5 |        0 |        0 |       0 |\n| ball | large |       20 |        0 |        0 |       0 |\n| ball | small |       10 |        0 |        0 |       0 |\n| ball | NULL  |       35 |        0 |        1 |       1 |\n| hoop | NULL  |        3 |        0 |        0 |       0 |\n| hoop | large |        5 |        0 |        0 |       0 |\n| hoop | small |       15 |        0 |        0 |       0 |\n| hoop | NULL  |       23 |        0 |        1 |       1 |\n| NULL | NULL  |       58 |        1 |        1 |       3 |\n+------+-------+----------+----------+----------+---------+\n\nWith multiple expression arguments, the GROUPING() return value is\nnonzero if any expression represents a super-aggregate value.\nMultiple-argument GROUPING() syntax thus provides a simpler way to\nwrite the earlier query that returned only super-aggregate rows, by\nusing a single multiple-argument GROUPING() call rather than multiple\nsingle-argument calls:\n\nmysql> SELECT name, size, SUM(quantity) AS quantity\n       FROM t1\n       GROUP BY name, size WITH ROLLUP\n       HAVING GROUPING(name, size) <> 0;\n+------+------+----------+\n| name | size | quantity |\n+------+------+----------+\n| ball | NULL |       35 |\n| hoop | NULL |       23 |\n| NULL | NULL |       58 |\n+------+------+----------+\n\nUse of GROUPING() is subject to these limitations:\n\no Do not use subquery GROUP BY expressions as GROUPING() arguments\n  because matching might fail. For example, matching fails for this\n  query:\n\nmysql> SELECT GROUPING((SELECT MAX(name) FROM t1))\n       FROM t1\n       GROUP BY (SELECT MAX(name) FROM t1) WITH ROLLUP;\nERROR 3580 (HY000): Argument #1 of GROUPING function is not in GROUP BY\n\no GROUP BY literal expressions should not be used within a HAVING\n  clause as GROUPING() arguments. Due to differences between when the\n  optimizer evaluates GROUP BY and HAVING, matching may succeed but\n  GROUPING() evaluation does not produce the expected result. Consider\n  this query:\n\nSELECT a AS f1, \'w\' AS f2\nFROM t\nGROUP BY f1, f2 WITH ROLLUP\nHAVING GROUPING(f2) = 1;\n\n  GROUPING() is evaluated earlier for the literal constant expression\n  than for the HAVING clause as a whole and returns 0. To check whether\n  a query such as this is affected, use EXPLAIN and look for Impossible\n  having in the Extra column.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/miscellaneous-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/miscellaneous-functions.html'),(485,'INET_ATON',39,'Syntax:\nINET_ATON(expr)\n\nGiven the dotted-quad representation of an IPv4 network address as a\nstring, returns an integer that represents the numeric value of the\naddress in network byte order (big endian). INET_ATON() returns NULL if\nit does not understand its argument, or if expr is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/miscellaneous-functions.html\n\n','mysql> SELECT INET_ATON(\'10.0.5.9\');\n        -> 167773449\n','https://dev.mysql.com/doc/refman/8.0/en/miscellaneous-functions.html'),(486,'INET_NTOA',39,'Syntax:\nINET_NTOA(expr)\n\nGiven a numeric IPv4 network address in network byte order, returns the\ndotted-quad string representation of the address as a string in the\nconnection character set. INET_NTOA() returns NULL if it does not\nunderstand its argument.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/miscellaneous-functions.html\n\n','mysql> SELECT INET_NTOA(167773449);\n        -> \'10.0.5.9\'\n','https://dev.mysql.com/doc/refman/8.0/en/miscellaneous-functions.html'),(487,'INET6_ATON',39,'Syntax:\nINET6_ATON(expr)\n\nGiven an IPv6 or IPv4 network address as a string, returns a binary\nstring that represents the numeric value of the address in network byte\norder (big endian). Because numeric-format IPv6 addresses require more\nbytes than the largest integer type, the representation returned by\nthis function has the VARBINARY data type: VARBINARY(16) for IPv6\naddresses and VARBINARY(4) for IPv4 addresses. If the argument is not a\nvalid address, or if it is NULL, INET6_ATON() returns NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/miscellaneous-functions.html\n\n','mysql> SELECT HEX(INET6_ATON(\'fdfe::5a55:caff:fefa:9089\'));\n        -> \'FDFE0000000000005A55CAFFFEFA9089\'\nmysql> SELECT HEX(INET6_ATON(\'10.0.5.9\'));\n        -> \'0A000509\'\n','https://dev.mysql.com/doc/refman/8.0/en/miscellaneous-functions.html'),(488,'INET6_NTOA',39,'Syntax:\nINET6_NTOA(expr)\n\nGiven an IPv6 or IPv4 network address represented in numeric form as a\nbinary string, returns the string representation of the address as a\nstring in the connection character set. If the argument is not a valid\naddress, or if it is NULL, INET6_NTOA() returns NULL.\n\nINET6_NTOA() has these properties:\n\no It does not use operating system functions to perform conversions,\n  thus the output string is platform independent.\n\no The return string has a maximum length of 39 (4 x 8 + 7). Given this\n  statement:\n\nCREATE TABLE t AS SELECT INET6_NTOA(expr) AS c1;\n\n  The resulting table would have this definition:\n\nCREATE TABLE t (c1 VARCHAR(39) CHARACTER SET utf8mb3 DEFAULT NULL);\n\no The return string uses lowercase letters for IPv6 addresses.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/miscellaneous-functions.html\n\n','mysql> SELECT INET6_NTOA(INET6_ATON(\'fdfe::5a55:caff:fefa:9089\'));\n        -> \'fdfe::5a55:caff:fefa:9089\'\nmysql> SELECT INET6_NTOA(INET6_ATON(\'10.0.5.9\'));\n        -> \'10.0.5.9\'\n\nmysql> SELECT INET6_NTOA(UNHEX(\'FDFE0000000000005A55CAFFFEFA9089\'));\n        -> \'fdfe::5a55:caff:fefa:9089\'\nmysql> SELECT INET6_NTOA(UNHEX(\'0A000509\'));\n        -> \'10.0.5.9\'\n','https://dev.mysql.com/doc/refman/8.0/en/miscellaneous-functions.html'),(489,'IS_IPV4',39,'Syntax:\nIS_IPV4(expr)\n\nReturns 1 if the argument is a valid IPv4 address specified as a\nstring, 0 otherwise. Returns NULL if expr is NULL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/miscellaneous-functions.html\n\n','mysql> SELECT IS_IPV4(\'10.0.5.9\'), IS_IPV4(\'10.0.5.256\');\n        -> 1, 0\n','https://dev.mysql.com/doc/refman/8.0/en/miscellaneous-functions.html'),(490,'IS_IPV4_COMPAT',39,'Syntax:\nIS_IPV4_COMPAT(expr)\n\nThis function takes an IPv6 address represented in numeric form as a\nbinary string, as returned by INET6_ATON(). It returns 1 if the\nargument is a valid IPv4-compatible IPv6 address, 0 otherwise (unless\nexpr is NULL, in which case the function returns NULL). IPv4-compatible\naddresses have the form ::ipv4_address.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/miscellaneous-functions.html\n\n','mysql> SELECT IS_IPV4_COMPAT(INET6_ATON(\'::10.0.5.9\'));\n        -> 1\nmysql> SELECT IS_IPV4_COMPAT(INET6_ATON(\'::ffff:10.0.5.9\'));\n        -> 0\n','https://dev.mysql.com/doc/refman/8.0/en/miscellaneous-functions.html'),(491,'IS_IPV4_MAPPED',39,'Syntax:\nIS_IPV4_MAPPED(expr)\n\nThis function takes an IPv6 address represented in numeric form as a\nbinary string, as returned by INET6_ATON(). It returns 1 if the\nargument is a valid IPv4-mapped IPv6 address, 0 otherwise, unless expr\nis NULL, in which case the function returns NULL. IPv4-mapped addresses\nhave the form ::ffff:ipv4_address.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/miscellaneous-functions.html\n\n','mysql> SELECT IS_IPV4_MAPPED(INET6_ATON(\'::10.0.5.9\'));\n        -> 0\nmysql> SELECT IS_IPV4_MAPPED(INET6_ATON(\'::ffff:10.0.5.9\'));\n        -> 1\n','https://dev.mysql.com/doc/refman/8.0/en/miscellaneous-functions.html'),(492,'IS_IPV6',39,'Syntax:\nIS_IPV6(expr)\n\nReturns 1 if the argument is a valid IPv6 address specified as a\nstring, 0 otherwise, unless expr is NULL, in which case the function\nreturns NULL. This function does not consider IPv4 addresses to be\nvalid IPv6 addresses.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/miscellaneous-functions.html\n\n','mysql> SELECT IS_IPV6(\'10.0.5.9\'), IS_IPV6(\'::1\');\n        -> 0, 1\n','https://dev.mysql.com/doc/refman/8.0/en/miscellaneous-functions.html'),(493,'IS_UUID',39,'IS_UUID(string_uuid)\n\nReturns 1 if the argument is a valid string-format UUID, 0 if the\nargument is not a valid UUID, and NULL if the argument is NULL.\n\n\"Valid\" means that the value is in a format that can be parsed. That\nis, it has the correct length and contains only the permitted\ncharacters (hexadecimal digits in any lettercase and, optionally,\ndashes and curly braces). This format is most common:\n\naaaaaaaa-bbbb-cccc-dddd-eeeeeeeeeeee\n\nThese other formats are also permitted:\n\naaaaaaaabbbbccccddddeeeeeeeeeeee\n{aaaaaaaa-bbbb-cccc-dddd-eeeeeeeeeeee}\n\nFor the meanings of fields within the value, see the UUID() function\ndescription.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/miscellaneous-functions.html\n\n','mysql> SELECT IS_UUID(\'6ccd780c-baba-1026-9564-5b8c656024db\');\n+-------------------------------------------------+\n| IS_UUID(\'6ccd780c-baba-1026-9564-5b8c656024db\') |\n+-------------------------------------------------+\n|                                               1 |\n+-------------------------------------------------+\nmysql> SELECT IS_UUID(\'6CCD780C-BABA-1026-9564-5B8C656024DB\');\n+-------------------------------------------------+\n| IS_UUID(\'6CCD780C-BABA-1026-9564-5B8C656024DB\') |\n+-------------------------------------------------+\n|                                               1 |\n+-------------------------------------------------+\nmysql> SELECT IS_UUID(\'6ccd780cbaba102695645b8c656024db\');\n+---------------------------------------------+\n| IS_UUID(\'6ccd780cbaba102695645b8c656024db\') |\n+---------------------------------------------+\n|                                           1 |\n+---------------------------------------------+\nmysql> SELECT IS_UUID(\'{6ccd780c-baba-1026-9564-5b8c656024db}\');\n+---------------------------------------------------+\n| IS_UUID(\'{6ccd780c-baba-1026-9564-5b8c656024db}\') |\n+---------------------------------------------------+\n|                                                 1 |\n+---------------------------------------------------+\nmysql> SELECT IS_UUID(\'6ccd780c-baba-1026-9564-5b8c6560\');\n+---------------------------------------------+\n| IS_UUID(\'6ccd780c-baba-1026-9564-5b8c6560\') |\n+---------------------------------------------+\n|                                           0 |\n+---------------------------------------------+\nmysql> SELECT IS_UUID(RAND());\n+-----------------+\n| IS_UUID(RAND()) |\n+-----------------+\n|               0 |\n+-----------------+\n','https://dev.mysql.com/doc/refman/8.0/en/miscellaneous-functions.html'),(494,'MASTER_POS_WAIT',39,'Syntax:\nMASTER_POS_WAIT(log_name,log_pos[,timeout][,channel])\n\nThis function is for control of source/replica synchronization. It\nblocks until the replica has read and applied all updates up to the\nspecified position in the source\'s binary log. From MySQL 8.0.26,\nMASTER_POS_WAIT() is deprecated and the alias SOURCE_POS_WAIT() should\nbe used instead. In releases before MySQL 8.0.26, use\nMASTER_POS_WAIT().\n\nThe return value is the number of log events the replica had to wait\nfor to advance to the specified position. The function returns NULL if\nthe replication SQL thread is not started, the replica\'s source\ninformation is not initialized, the arguments are incorrect, or an\nerror occurs. It returns -1 if the timeout has been exceeded. If the\nreplication SQL thread stops while MASTER_POS_WAIT() is waiting, the\nfunction returns NULL. If the replica is past the specified position,\nthe function returns immediately.\n\nIf the binary log file position has been marked as invalid, the\nfunction waits until a valid file position is known. The binary log\nfile position can be marked as invalid when the CHANGE REPLICATION\nSOURCE TO option GTID_ONLY is set for the replication channel, and the\nserver is restarted or replication is stopped. The file position\nbecomes valid after a transaction is successfully applied past the\ngiven file position. If the applier does not reach the stated position,\nthe function waits until the timeout. Use a SHOW REPLICA STATUS\nstatement to check if the binary log file position has been marked as\ninvalid.\n\nOn a multithreaded replica, the function waits until expiry of the\nlimit set by the replica_checkpoint_group, slave_checkpoint_group,\nreplica_checkpoint_period or slave_checkpoint_period system variable,\nwhen the checkpoint operation is called to update the status of the\nreplica. Depending on the setting for the system variables, the\nfunction might therefore return some time after the specified position\nwas reached.\n\nIf binary log transaction compression is in use and the transaction\npayload at the specified position is compressed (as a\nTransaction_payload_event), the function waits until the whole\ntransaction has been read and applied, and the positions have updated.\n\nIf a timeout value is specified, MASTER_POS_WAIT() stops waiting when\ntimeout seconds have elapsed. timeout must be greater than 0; a zero or\nnegative timeout means no timeout.\n\nThe optional channel value enables you to name which replication\nchannel the function applies to. See\nhttps://dev.mysql.com/doc/refman/8.0/en/replication-channels.html for\nmore information.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/miscellaneous-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/miscellaneous-functions.html'),(495,'NAME_CONST',39,'Syntax:\nNAME_CONST(name,value)\n\nReturns the given value. When used to produce a result set column,\nNAME_CONST() causes the column to have the given name. The arguments\nshould be constants.\n\nmysql> SELECT NAME_CONST(\'myname\', 14);\n+--------+\n| myname |\n+--------+\n|     14 |\n+--------+\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/miscellaneous-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/miscellaneous-functions.html'),(496,'SLEEP',39,'Syntax:\nSLEEP(duration)\n\nSleeps (pauses) for the number of seconds given by the duration\nargument, then returns 0. The duration may have a fractional part. If\nthe argument is NULL or negative, SLEEP() produces a warning, or an\nerror in strict SQL mode.\n\nWhen sleep returns normally (without interruption), it returns 0:\n\nmysql> SELECT SLEEP(1000);\n+-------------+\n| SLEEP(1000) |\n+-------------+\n|           0 |\n+-------------+\n\nWhen SLEEP() is the only thing invoked by a query that is interrupted,\nit returns 1 and the query itself returns no error. This is true\nwhether the query is killed or times out:\n\no This statement is interrupted using KILL QUERY from another session:\n\nmysql> SELECT SLEEP(1000);\n+-------------+\n| SLEEP(1000) |\n+-------------+\n|           1 |\n+-------------+\n\no This statement is interrupted by timing out:\n\nmysql> SELECT /*+ MAX_EXECUTION_TIME(1) */ SLEEP(1000);\n+-------------+\n| SLEEP(1000) |\n+-------------+\n|           1 |\n+-------------+\n\nWhen SLEEP() is only part of a query that is interrupted, the query\nreturns an error:\n\no This statement is interrupted using KILL QUERY from another session:\n\nmysql> SELECT 1 FROM t1 WHERE SLEEP(1000);\nERROR 1317 (70100): Query execution was interrupted\n\no This statement is interrupted by timing out:\n\nmysql> SELECT /*+ MAX_EXECUTION_TIME(1000) */ 1 FROM t1 WHERE SLEEP(1000);\nERROR 3024 (HY000): Query execution was interrupted, maximum statement\nexecution time exceeded\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/miscellaneous-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/miscellaneous-functions.html'),(497,'SOURCE_POS_WAIT',39,'Syntax:\nSOURCE_POS_WAIT(log_name,log_pos[,timeout][,channel])\n\nThis function is for control of source/replica synchronization. It\nblocks until the replica has read and applied all updates up to the\nspecified position in the source\'s binary log. From MySQL 8.0.26, use\nSOURCE_POS_WAIT() in place of MASTER_POS_WAIT(), which is deprecated\nfrom that release. In releases before MySQL 8.0.26, use\nMASTER_POS_WAIT().\n\nThe return value is the number of log events the replica had to wait\nfor to advance to the specified position. The function returns NULL if\nthe replication SQL thread is not started, the replica\'s source\ninformation is not initialized, the arguments are incorrect, or an\nerror occurs. It returns -1 if the timeout has been exceeded. If the\nreplication SQL thread stops while SOURCE_POS_WAIT() is waiting, the\nfunction returns NULL. If the replica is past the specified position,\nthe function returns immediately.\n\nIf the binary log file position has been marked as invalid, the\nfunction waits until a valid file position is known. The binary log\nfile position can be marked as invalid when the CHANGE REPLICATION\nSOURCE TO option GTID_ONLY is set for the replication channel, and the\nserver is restarted or replication is stopped. The file position\nbecomes valid after a transaction is successfully applied past the\ngiven file position. If the applier does not reach the stated position,\nthe function waits until the timeout. Use a SHOW REPLICA STATUS\nstatement to check if the binary log file position has been marked as\ninvalid.\n\nOn a multithreaded replica, the function waits until expiry of the\nlimit set by the replica_checkpoint_group or replica_checkpoint_period\nsystem variable, when the checkpoint operation is called to update the\nstatus of the replica. Depending on the setting for the system\nvariables, the function might therefore return some time after the\nspecified position was reached.\n\nIf binary log transaction compression is in use and the transaction\npayload at the specified position is compressed (as a\nTransaction_payload_event), the function waits until the whole\ntransaction has been read and applied, and the positions have updated.\n\nIf a timeout value is specified, SOURCE_POS_WAIT() stops waiting when\ntimeout seconds have elapsed. timeout must be greater than 0; a zero or\nnegative timeout means no timeout.\n\nThe optional channel value enables you to name which replication\nchannel the function applies to. See\nhttps://dev.mysql.com/doc/refman/8.0/en/replication-channels.html for\nmore information.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/miscellaneous-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/miscellaneous-functions.html'),(498,'UUID',39,'Syntax:\nUUID()\n\nReturns a Universal Unique Identifier (UUID) generated according to RFC\n4122, \"A Universally Unique IDentifier (UUID) URN Namespace\"\n(http://www.ietf.org/rfc/rfc4122.txt).\n\nA UUID is designed as a number that is globally unique in space and\ntime. Two calls to UUID() are expected to generate two different\nvalues, even if these calls are performed on two separate devices not\nconnected to each other.\n\n*Warning*:\n\nAlthough UUID() values are intended to be unique, they are not\nnecessarily unguessable or unpredictable. If unpredictability is\nrequired, UUID values should be generated some other way.\n\nUUID() returns a value that conforms to UUID version 1 as described in\nRFC 4122. The value is a 128-bit number represented as a utf8mb3 string\nof five hexadecimal numbers in aaaaaaaa-bbbb-cccc-dddd-eeeeeeeeeeee\nformat:\n\no The first three numbers are generated from the low, middle, and high\n  parts of a timestamp. The high part also includes the UUID version\n  number.\n\no The fourth number preserves temporal uniqueness in case the timestamp\n  value loses monotonicity (for example, due to daylight saving time).\n\no The fifth number is an IEEE 802 node number that provides spatial\n  uniqueness. A random number is substituted if the latter is not\n  available (for example, because the host device has no Ethernet card,\n  or it is unknown how to find the hardware address of an interface on\n  the host operating system). In this case, spatial uniqueness cannot\n  be guaranteed. Nevertheless, a collision should have very low\n  probability.\n\n  The MAC address of an interface is taken into account only on\n  FreeBSD, Linux, and Windows. On other operating systems, MySQL uses a\n  randomly generated 48-bit number.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/miscellaneous-functions.html\n\n','mysql> SELECT UUID();\n        -> \'6ccd780c-baba-1026-9564-5b8c656024db\'\n','https://dev.mysql.com/doc/refman/8.0/en/miscellaneous-functions.html'),(499,'UUID_SHORT',39,'Syntax:\nUUID_SHORT()\n\nReturns a \"short\" universal identifier as a 64-bit unsigned integer.\nValues returned by UUID_SHORT() differ from the string-format 128-bit\nidentifiers returned by the UUID() function and have different\nuniqueness properties. The value of UUID_SHORT() is guaranteed to be\nunique if the following conditions hold:\n\no The server_id value of the current server is between 0 and 255 and is\n  unique among your set of source and replica servers\n\no You do not set back the system time for your server host between\n  mysqld restarts\n\no You invoke UUID_SHORT() on average fewer than 16 million times per\n  second between mysqld restarts\n\nThe UUID_SHORT() return value is constructed this way:\n\n  (server_id & 255) << 56\n+ (server_startup_time_in_seconds << 24)\n+ incremented_variable++;\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/miscellaneous-functions.html\n\n','mysql> SELECT UUID_SHORT();\n        -> 92395783831158784\n','https://dev.mysql.com/doc/refman/8.0/en/miscellaneous-functions.html'),(500,'UUID_TO_BIN',39,'Syntax:\nUUID_TO_BIN(string_uuid), UUID_TO_BIN(string_uuid, swap_flag)\n\nConverts a string UUID to a binary UUID and returns the result. (The\nIS_UUID() function description lists the permitted string UUID\nformats.) The return binary UUID is a VARBINARY(16) value. If the UUID\nargument is NULL, the return value is NULL. If any argument is invalid,\nan error occurs.\n\nUUID_TO_BIN() takes one or two arguments:\n\no The one-argument form takes a string UUID value. The binary result is\n  in the same order as the string argument.\n\no The two-argument form takes a string UUID value and a flag value:\n\n  o If swap_flag is 0, the two-argument form is equivalent to the\n    one-argument form. The binary result is in the same order as the\n    string argument.\n\n  o If swap_flag is 1, the format of the return value differs: The\n    time-low and time-high parts (the first and third groups of\n    hexadecimal digits, respectively) are swapped. This moves the more\n    rapidly varying part to the right and can improve indexing\n    efficiency if the result is stored in an indexed column.\n\nTime-part swapping assumes the use of UUID version 1 values, such as\nare generated by the UUID() function. For UUID values produced by other\nmeans that do not follow version 1 format, time-part swapping provides\nno benefit. For details about version 1 format, see the UUID() function\ndescription.\n\nSuppose that you have the following string UUID value:\n\nmysql> SET @uuid = \'6ccd780c-baba-1026-9564-5b8c656024db\';\n\nTo convert the string UUID to binary with or without time-part\nswapping, use UUID_TO_BIN():\n\nmysql> SELECT HEX(UUID_TO_BIN(@uuid));\n+----------------------------------+\n| HEX(UUID_TO_BIN(@uuid))          |\n+----------------------------------+\n| 6CCD780CBABA102695645B8C656024DB |\n+----------------------------------+\nmysql> SELECT HEX(UUID_TO_BIN(@uuid, 0));\n+----------------------------------+\n| HEX(UUID_TO_BIN(@uuid, 0))       |\n+----------------------------------+\n| 6CCD780CBABA102695645B8C656024DB |\n+----------------------------------+\nmysql> SELECT HEX(UUID_TO_BIN(@uuid, 1));\n+----------------------------------+\n| HEX(UUID_TO_BIN(@uuid, 1))       |\n+----------------------------------+\n| 1026BABA6CCD780C95645B8C656024DB |\n+----------------------------------+\n\nTo convert a binary UUID returned by UUID_TO_BIN() to a string UUID,\nuse BIN_TO_UUID(). If you produce a binary UUID by calling\nUUID_TO_BIN() with a second argument of 1 to swap time parts, you\nshould also pass a second argument of 1 to BIN_TO_UUID() to unswap the\ntime parts when converting the binary UUID back to a string UUID:\n\nmysql> SELECT BIN_TO_UUID(UUID_TO_BIN(@uuid));\n+--------------------------------------+\n| BIN_TO_UUID(UUID_TO_BIN(@uuid))      |\n+--------------------------------------+\n| 6ccd780c-baba-1026-9564-5b8c656024db |\n+--------------------------------------+\nmysql> SELECT BIN_TO_UUID(UUID_TO_BIN(@uuid,0),0);\n+--------------------------------------+\n| BIN_TO_UUID(UUID_TO_BIN(@uuid,0),0)  |\n+--------------------------------------+\n| 6ccd780c-baba-1026-9564-5b8c656024db |\n+--------------------------------------+\nmysql> SELECT BIN_TO_UUID(UUID_TO_BIN(@uuid,1),1);\n+--------------------------------------+\n| BIN_TO_UUID(UUID_TO_BIN(@uuid,1),1)  |\n+--------------------------------------+\n| 6ccd780c-baba-1026-9564-5b8c656024db |\n+--------------------------------------+\n\nIf the use of time-part swapping is not the same for the conversion in\nboth directions, the original UUID is not recovered properly:\n\nmysql> SELECT BIN_TO_UUID(UUID_TO_BIN(@uuid,0),1);\n+--------------------------------------+\n| BIN_TO_UUID(UUID_TO_BIN(@uuid,0),1)  |\n+--------------------------------------+\n| baba1026-780c-6ccd-9564-5b8c656024db |\n+--------------------------------------+\nmysql> SELECT BIN_TO_UUID(UUID_TO_BIN(@uuid,1),0);\n+--------------------------------------+\n| BIN_TO_UUID(UUID_TO_BIN(@uuid,1),0)  |\n+--------------------------------------+\n| 1026baba-6ccd-780c-9564-5b8c656024db |\n+--------------------------------------+\n\nIf UUID_TO_BIN() is invoked from within the mysql client, binary\nstrings display using hexadecimal notation, depending on the value of\nthe --binary-as-hex. For more information about that option, see\nhttps://dev.mysql.com/doc/refman/8.0/en/mysql.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/miscellaneous-functions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/miscellaneous-functions.html'),(501,'VALUES',39,'Syntax:\nVALUES(col_name)\n\nIn an INSERT ... ON DUPLICATE KEY UPDATE statement, you can use the\nVALUES(col_name) function in the UPDATE clause to refer to column\nvalues from the INSERT portion of the statement. In other words,\nVALUES(col_name) in the UPDATE clause refers to the value of col_name\nthat would be inserted, had no duplicate-key conflict occurred. This\nfunction is especially useful in multiple-row inserts. The VALUES()\nfunction is meaningful only in the ON DUPLICATE KEY UPDATE clause of\nINSERT statements and returns NULL otherwise. See\nhttps://dev.mysql.com/doc/refman/8.0/en/insert-on-duplicate.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/miscellaneous-functions.html\n\n','mysql> INSERT INTO table (a,b,c) VALUES (1,2,3),(4,5,6)\n    -> ON DUPLICATE KEY UPDATE c=VALUES(a)+VALUES(b);\n','https://dev.mysql.com/doc/refman/8.0/en/miscellaneous-functions.html'),(502,'ALTER DATABASE',40,'Syntax:\nALTER {DATABASE | SCHEMA} [db_name]\n    alter_option ...\n\nalter_option: {\n    [DEFAULT] CHARACTER SET [=] charset_name\n  | [DEFAULT] COLLATE [=] collation_name\n  | [DEFAULT] ENCRYPTION [=] {\'Y\' | \'N\'}\n  | READ ONLY [=] {DEFAULT | 0 | 1}\n}\n\nALTER DATABASE enables you to change the overall characteristics of a\ndatabase. These characteristics are stored in the data dictionary. This\nstatement requires the ALTER privilege on the database. ALTER SCHEMA is\na synonym for ALTER DATABASE.\n\nIf the database name is omitted, the statement applies to the default\ndatabase. In that case, an error occurs if there is no default\ndatabase.\n\nFor any alter_option omitted from the statement, the database retains\nits current option value, with the exception that changing the\ncharacter set may change the collation and vice versa.\n\no https://dev.mysql.com/doc/refman/8.0/en/alter-database.html#alter-dat\n  abase-charset\n\no https://dev.mysql.com/doc/refman/8.0/en/alter-database.html#alter-dat\n  abase-encryption\n\no https://dev.mysql.com/doc/refman/8.0/en/alter-database.html#alter-dat\n  abase-read-only\n\nCharacter Set and Collation Options\n\nThe CHARACTER SET option changes the default database character set.\nThe COLLATE option changes the default database collation. For\ninformation about character set and collation names, see\nhttps://dev.mysql.com/doc/refman/8.0/en/charset.html.\n\nTo see the available character sets and collations, use the SHOW\nCHARACTER SET and SHOW COLLATION statements, respectively. See [HELP\nSHOW CHARACTER SET], and [HELP SHOW COLLATION].\n\nA stored routine that uses the database defaults when the routine is\ncreated includes those defaults as part of its definition. (In a stored\nroutine, variables with character data types use the database defaults\nif the character set or collation are not specified explicitly. See\n[HELP CREATE PROCEDURE].) If you change the default character set or\ncollation for a database, any stored routines that are to use the new\ndefaults must be dropped and recreated.\n\nEncryption Option\n\nThe ENCRYPTION option, introduced in MySQL 8.0.16, defines the default\ndatabase encryption, which is inherited by tables created in the\ndatabase. The permitted values are \'Y\' (encryption enabled) and \'N\'\n(encryption disabled).\n\nThe mysql system schema cannot be set to default encryption. The\nexisting tables within it are part of the general mysql tablespace,\nwhich may be encrypted. The information_schema contains only views. It\nis not possible to create any tables within it. There is nothing on the\ndisk to encrypt. All tables in the performance_schema use the\nPERFORMANCE_SCHEMA engine, which is purely in-memory. It is not\npossible to create any other tables in it. There is nothing on the disk\nto encrypt.\n\nOnly newly created tables inherit the default database encryption. For\nexisting tables associated with the database, their encryption remains\nunchanged. If the table_encryption_privilege_check system variable is\nenabled, the TABLE_ENCRYPTION_ADMIN privilege is required to specify a\ndefault encryption setting that differs from the value of the\ndefault_table_encryption system variable. For more information, see\nhttps://dev.mysql.com/doc/refman/8.0/en/innodb-data-encryption.html#inn\nodb-schema-tablespace-encryption-default.\n\nRead Only Option\n\nThe READ ONLY option, introduced in MySQL 8.0.22, controls whether to\npermit modification of the database and objects within it. The\npermitted values are DEFAULT or 0 (not read only) and 1 (read only).\nThis option is useful for database migration because a database for\nwhich READ ONLY is enabled can be migrated to another MySQL instance\nwithout concern that the database might be changed during the\noperation.\n\nWith NDB Cluster, making a database read only on one mysqld server is\nsynchronized to other mysqld servers in the same cluster, so that the\ndatabase becomes read only on all mysqld servers.\n\nThe READ ONLY option, if enabled, is displayed in the\nINFORMATION_SCHEMA SCHEMATA_EXTENSIONS table. See\nhttps://dev.mysql.com/doc/refman/8.0/en/information-schema-schemata-ext\nensions-table.html.\n\nThe READ ONLY option cannot be enabled for these system schemas: mysql,\ninformation_schema, performance_schema.\n\nIn ALTER DATABASE statements, the READ ONLY option interacts with other\ninstances of itself and with other options as follows:\n\no An error occurs if multiple instances of READ ONLY conflict (for\n  example, READ ONLY = 1 READ ONLY = 0).\n\no An ALTER DATABASE statement that contains only (nonconflicting) READ\n  ONLY options is permitted even for a read-only database.\n\no A mix of (nonconflicting) READ ONLY options with other options is\n  permitted if the read-only state of the database either before or\n  after the statement permits modifications. If the read-only state\n  both before and after prohibits changes, an error occurs.\n\n  This statement succeeds whether or not the database is read only:\n\nALTER DATABASE mydb READ ONLY = 0 DEFAULT COLLATE utf8mb4_bin;\n\n  This statement succeeds if the database is not read only, but fails\n  if it is already read only:\n\nALTER DATABASE mydb READ ONLY = 1 DEFAULT COLLATE utf8mb4_bin;\n\nEnabling READ ONLY affects all users of the database, with these\nexceptions that are not subject to read-only checks:\n\no Statements executed by the server as part of server initialization,\n  restart, upgrade, or replication.\n\no Statements in a file named at server startup by the init_file system\n  variable.\n\no TEMPORARY tables; it is possible to create, alter, drop, and write to\n  TEMPORARY tables in a read-only database.\n\no NDB Cluster non-SQL inserts and updates.\n\nOther than for the excepted operations just listed, enabling READ ONLY\nprohibits write operations to the database and its objects, including\ntheir definitions, data, and metadata. The following list details\naffected SQL statements and operations:\n\no The database itself:\n\n  o CREATE DATABASE\n\n  o ALTER DATABASE (except to change the READ ONLY option)\n\n  o DROP DATABASE\n\no Views:\n\n  o CREATE VIEW\n\n  o ALTER VIEW\n\n  o DROP VIEW\n\n  o Selecting from views that invoke functions with side effects.\n\n  o Updating updatable views.\n\n  o Statements that create or drop objects in a writable database are\n    rejected if they affect metadata of a view in a read-only database\n    (for example, by making the view valid or invalid).\n\no Stored routines:\n\n  o CREATE PROCEDURE\n\n  o DROP PROCEDURE\n\n  o CALL (of procedures with side effects)\n\n  o CREATE FUNCTION\n\n  o DROP FUNCTION\n\n  o SELECT (of functions with side effects)\n\n  o For procedures and functions, read-only checks follow prelocking\n    behavior. For CALL statements, read-only checks are done on a\n    per-statement basis, so if some conditionally executed statement\n    writing to a read-only database does not actually execute, the call\n    still succeeds. On the other hand, for a function called within a\n    SELECT, execution of the function body happens in prelocked mode.\n    As long as a some statement within the function writes to a\n    read-only database, execution of the function fails with an error\n    regardless of whether the statement actually executes.\n\no Triggers:\n\n  o CREATE TRIGGER\n\n  o DROP TRIGGER\n\n  o Trigger invocation.\n\no Events:\n\n  o CREATE EVENT\n\n  o ALTER EVENT\n\n  o DROP EVENT\n\n  o Event execution:\n\n    o Executing an event in the database fails because that would\n      change the last-execution timestamp, which is event metadata\n      stored in the data dictionary. Failure of event execution also\n      has the effect of causing the event scheduler to stop.\n\n    o If an event writes to an object in a read-only database,\n      execution of the event fails with an error, but the event\n      scheduler is not stopped.\n\no Tables:\n\n  o CREATE TABLE\n\n  o ALTER TABLE\n\n  o CREATE INDEX\n\n  o DROP INDEX\n\n  o RENAME TABLE\n\n  o TRUNCATE TABLE\n\n  o DROP TABLE\n\n  o DELETE\n\n  o INSERT\n\n  o IMPORT TABLE\n\n  o LOAD DATA\n\n  o LOAD XML\n\n  o REPLACE\n\n  o UPDATE\n\n  o For cascading foreign keys where the child table is in a read-only\n    database, updates and deletes on the parent are rejected even if\n    the child table is not directly affected.\n\n  o For a MERGE table such as CREATE TABLE s1.t(i int) ENGINE MERGE\n    UNION (s2.t, s3.t), INSERT_METHOD=..., the following behavior\n    applies:\n\n    o Inserting into the MERGE table (INSERT into s1.t) fails if at\n      least one of s1, s2, s3 is read only, regardless of insert\n      method. The insert is refused even if it would actually end up in\n      a writable table.\n\n    o Dropping the MERGE table (DROP TABLE s1.t) succeeds as long as s1\n      is not read only. It is permitted to drop a MERGE table that\n      refers to a read-only database.\n\nAn ALTER DATABASE statement blocks until all concurrent transactions\nthat have already accessed an object in the database being altered have\ncommitted. Conversely, a write transaction accessing an object in a\ndatabase being altered in a concurrent ALTER DATABASE blocks until the\nALTER DATABASE has committed.\n\nIf the Clone plugin is used to clone a local or remote data directory,\nthe databases in the clone retain the read-only state they had in the\nsource data directory. The read-only state does not affect the cloning\nprocess itself. If it is not desirable to have the same database\nread-only state in the clone, the option must be changed explicitly for\nthe clone after the cloning process has finished, using ALTER DATABASE\noperations on the clone.\n\nWhen cloning from a donor to a recipient, if the recipient has a user\ndatabase that is read only, cloning fails with an error message.\nCloning may be retried after making the database writable.\n\nREAD ONLY is permitted for ALTER DATABASE, but not for CREATE DATABASE.\nHowever, for a read-only database, the statement produced by SHOW\nCREATE DATABASE does include READ ONLY=1 within a comment to indicate\nits read-only status:\n\nmysql> ALTER DATABASE mydb READ ONLY = 1;\nmysql> SHOW CREATE DATABASE mydb\\G\n*************************** 1. row ***************************\n       Database: mydb\nCreate Database: CREATE DATABASE `mydb`\n                 /*!40100 DEFAULT CHARACTER SET utf8mb4\n                          COLLATE utf8mb4_0900_ai_ci */\n                 /*!80016 DEFAULT ENCRYPTION=\'N\' */\n                 /* READ ONLY = 1 */\n\nIf the server executes a CREATE DATABASE statement containing such a\ncomment, the server ignores the comment and the READ ONLY option is not\nprocessed. This has implications for mysqldump and mysqlpump, which use\nSHOW CREATE DATABASE to produce CREATE DATABASE statements in dump\noutput:\n\no In a dump file, the CREATE DATABASE statement for a read-only\n  database contains the commented READ ONLY option.\n\no The dump file can be restored as usual, but because the server\n  ignores the commented READ ONLY option, the restored database is not\n  read only. If the database is to be read only after being restored,\n  you must execute ALTER DATABASE manually to make it so.\n\nSuppose that mydb is read only and you dump it as follows:\n\n$> mysqldump --databases mydb > mydb.sql\n\nA restore operation later must be followed by ALTER DATABASE if mydb\nshould still be read only:\n\n$> mysql\nmysql> SOURCE mydb.sql;\nmysql> ALTER DATABASE mydb READ ONLY = 1;\n\nMySQL Enterprise Backup is not subject to this issue. It backs up and\nrestores a read-only database like any other, but enables the READ ONLY\noption at restore time if it was enabled at backup time.\n\nALTER DATABASE is written to the binary log, so a change to the READ\nONLY option on a replication source server also affects replicas. To\nprevent this from happening, binary logging must be disabled prior to\nexecution of the ALTER DATABASE statement. For example, to prepare for\nmigrating a database without affecting replicas, perform these\noperations:\n\n1. Within a single session, disable binary logging and enable READ ONLY\n   for the database:\n\nmysql> SET sql_log_bin = OFF;\nmysql> ALTER DATABASE mydb READ ONLY = 1;\n\n2. Dump the database, for example, with mysqldump or mysqlpump:\n\n$> mysqldump --databases mydb > mydb.sql\n\n3. Within a single session, disable binary logging and disable READ\n   ONLY for the database:\n\nmysql> SET sql_log_bin = OFF;\nmysql> ALTER DATABASE mydb READ ONLY = 0;\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/alter-database.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/alter-database.html'),(503,'ALTER SCHEMA',40,'Syntax:\nALTER {DATABASE | SCHEMA} [db_name]\n    alter_option ...\n\nalter_option: {\n    [DEFAULT] CHARACTER SET [=] charset_name\n  | [DEFAULT] COLLATE [=] collation_name\n  | [DEFAULT] ENCRYPTION [=] {\'Y\' | \'N\'}\n  | READ ONLY [=] {DEFAULT | 0 | 1}\n}\n\nALTER DATABASE enables you to change the overall characteristics of a\ndatabase. These characteristics are stored in the data dictionary. This\nstatement requires the ALTER privilege on the database. ALTER SCHEMA is\na synonym for ALTER DATABASE.\n\nIf the database name is omitted, the statement applies to the default\ndatabase. In that case, an error occurs if there is no default\ndatabase.\n\nFor any alter_option omitted from the statement, the database retains\nits current option value, with the exception that changing the\ncharacter set may change the collation and vice versa.\n\no https://dev.mysql.com/doc/refman/8.0/en/alter-database.html#alter-dat\n  abase-charset\n\no https://dev.mysql.com/doc/refman/8.0/en/alter-database.html#alter-dat\n  abase-encryption\n\no https://dev.mysql.com/doc/refman/8.0/en/alter-database.html#alter-dat\n  abase-read-only\n\nCharacter Set and Collation Options\n\nThe CHARACTER SET option changes the default database character set.\nThe COLLATE option changes the default database collation. For\ninformation about character set and collation names, see\nhttps://dev.mysql.com/doc/refman/8.0/en/charset.html.\n\nTo see the available character sets and collations, use the SHOW\nCHARACTER SET and SHOW COLLATION statements, respectively. See [HELP\nSHOW CHARACTER SET], and [HELP SHOW COLLATION].\n\nA stored routine that uses the database defaults when the routine is\ncreated includes those defaults as part of its definition. (In a stored\nroutine, variables with character data types use the database defaults\nif the character set or collation are not specified explicitly. See\n[HELP CREATE PROCEDURE].) If you change the default character set or\ncollation for a database, any stored routines that are to use the new\ndefaults must be dropped and recreated.\n\nEncryption Option\n\nThe ENCRYPTION option, introduced in MySQL 8.0.16, defines the default\ndatabase encryption, which is inherited by tables created in the\ndatabase. The permitted values are \'Y\' (encryption enabled) and \'N\'\n(encryption disabled).\n\nThe mysql system schema cannot be set to default encryption. The\nexisting tables within it are part of the general mysql tablespace,\nwhich may be encrypted. The information_schema contains only views. It\nis not possible to create any tables within it. There is nothing on the\ndisk to encrypt. All tables in the performance_schema use the\nPERFORMANCE_SCHEMA engine, which is purely in-memory. It is not\npossible to create any other tables in it. There is nothing on the disk\nto encrypt.\n\nOnly newly created tables inherit the default database encryption. For\nexisting tables associated with the database, their encryption remains\nunchanged. If the table_encryption_privilege_check system variable is\nenabled, the TABLE_ENCRYPTION_ADMIN privilege is required to specify a\ndefault encryption setting that differs from the value of the\ndefault_table_encryption system variable. For more information, see\nhttps://dev.mysql.com/doc/refman/8.0/en/innodb-data-encryption.html#inn\nodb-schema-tablespace-encryption-default.\n\nRead Only Option\n\nThe READ ONLY option, introduced in MySQL 8.0.22, controls whether to\npermit modification of the database and objects within it. The\npermitted values are DEFAULT or 0 (not read only) and 1 (read only).\nThis option is useful for database migration because a database for\nwhich READ ONLY is enabled can be migrated to another MySQL instance\nwithout concern that the database might be changed during the\noperation.\n\nWith NDB Cluster, making a database read only on one mysqld server is\nsynchronized to other mysqld servers in the same cluster, so that the\ndatabase becomes read only on all mysqld servers.\n\nThe READ ONLY option, if enabled, is displayed in the\nINFORMATION_SCHEMA SCHEMATA_EXTENSIONS table. See\nhttps://dev.mysql.com/doc/refman/8.0/en/information-schema-schemata-ext\nensions-table.html.\n\nThe READ ONLY option cannot be enabled for these system schemas: mysql,\ninformation_schema, performance_schema.\n\nIn ALTER DATABASE statements, the READ ONLY option interacts with other\ninstances of itself and with other options as follows:\n\no An error occurs if multiple instances of READ ONLY conflict (for\n  example, READ ONLY = 1 READ ONLY = 0).\n\no An ALTER DATABASE statement that contains only (nonconflicting) READ\n  ONLY options is permitted even for a read-only database.\n\no A mix of (nonconflicting) READ ONLY options with other options is\n  permitted if the read-only state of the database either before or\n  after the statement permits modifications. If the read-only state\n  both before and after prohibits changes, an error occurs.\n\n  This statement succeeds whether or not the database is read only:\n\nALTER DATABASE mydb READ ONLY = 0 DEFAULT COLLATE utf8mb4_bin;\n\n  This statement succeeds if the database is not read only, but fails\n  if it is already read only:\n\nALTER DATABASE mydb READ ONLY = 1 DEFAULT COLLATE utf8mb4_bin;\n\nEnabling READ ONLY affects all users of the database, with these\nexceptions that are not subject to read-only checks:\n\no Statements executed by the server as part of server initialization,\n  restart, upgrade, or replication.\n\no Statements in a file named at server startup by the init_file system\n  variable.\n\no TEMPORARY tables; it is possible to create, alter, drop, and write to\n  TEMPORARY tables in a read-only database.\n\no NDB Cluster non-SQL inserts and updates.\n\nOther than for the excepted operations just listed, enabling READ ONLY\nprohibits write operations to the database and its objects, including\ntheir definitions, data, and metadata. The following list details\naffected SQL statements and operations:\n\no The database itself:\n\n  o CREATE DATABASE\n\n  o ALTER DATABASE (except to change the READ ONLY option)\n\n  o DROP DATABASE\n\no Views:\n\n  o CREATE VIEW\n\n  o ALTER VIEW\n\n  o DROP VIEW\n\n  o Selecting from views that invoke functions with side effects.\n\n  o Updating updatable views.\n\n  o Statements that create or drop objects in a writable database are\n    rejected if they affect metadata of a view in a read-only database\n    (for example, by making the view valid or invalid).\n\no Stored routines:\n\n  o CREATE PROCEDURE\n\n  o DROP PROCEDURE\n\n  o CALL (of procedures with side effects)\n\n  o CREATE FUNCTION\n\n  o DROP FUNCTION\n\n  o SELECT (of functions with side effects)\n\n  o For procedures and functions, read-only checks follow prelocking\n    behavior. For CALL statements, read-only checks are done on a\n    per-statement basis, so if some conditionally executed statement\n    writing to a read-only database does not actually execute, the call\n    still succeeds. On the other hand, for a function called within a\n    SELECT, execution of the function body happens in prelocked mode.\n    As long as a some statement within the function writes to a\n    read-only database, execution of the function fails with an error\n    regardless of whether the statement actually executes.\n\no Triggers:\n\n  o CREATE TRIGGER\n\n  o DROP TRIGGER\n\n  o Trigger invocation.\n\no Events:\n\n  o CREATE EVENT\n\n  o ALTER EVENT\n\n  o DROP EVENT\n\n  o Event execution:\n\n    o Executing an event in the database fails because that would\n      change the last-execution timestamp, which is event metadata\n      stored in the data dictionary. Failure of event execution also\n      has the effect of causing the event scheduler to stop.\n\n    o If an event writes to an object in a read-only database,\n      execution of the event fails with an error, but the event\n      scheduler is not stopped.\n\no Tables:\n\n  o CREATE TABLE\n\n  o ALTER TABLE\n\n  o CREATE INDEX\n\n  o DROP INDEX\n\n  o RENAME TABLE\n\n  o TRUNCATE TABLE\n\n  o DROP TABLE\n\n  o DELETE\n\n  o INSERT\n\n  o IMPORT TABLE\n\n  o LOAD DATA\n\n  o LOAD XML\n\n  o REPLACE\n\n  o UPDATE\n\n  o For cascading foreign keys where the child table is in a read-only\n    database, updates and deletes on the parent are rejected even if\n    the child table is not directly affected.\n\n  o For a MERGE table such as CREATE TABLE s1.t(i int) ENGINE MERGE\n    UNION (s2.t, s3.t), INSERT_METHOD=..., the following behavior\n    applies:\n\n    o Inserting into the MERGE table (INSERT into s1.t) fails if at\n      least one of s1, s2, s3 is read only, regardless of insert\n      method. The insert is refused even if it would actually end up in\n      a writable table.\n\n    o Dropping the MERGE table (DROP TABLE s1.t) succeeds as long as s1\n      is not read only. It is permitted to drop a MERGE table that\n      refers to a read-only database.\n\nAn ALTER DATABASE statement blocks until all concurrent transactions\nthat have already accessed an object in the database being altered have\ncommitted. Conversely, a write transaction accessing an object in a\ndatabase being altered in a concurrent ALTER DATABASE blocks until the\nALTER DATABASE has committed.\n\nIf the Clone plugin is used to clone a local or remote data directory,\nthe databases in the clone retain the read-only state they had in the\nsource data directory. The read-only state does not affect the cloning\nprocess itself. If it is not desirable to have the same database\nread-only state in the clone, the option must be changed explicitly for\nthe clone after the cloning process has finished, using ALTER DATABASE\noperations on the clone.\n\nWhen cloning from a donor to a recipient, if the recipient has a user\ndatabase that is read only, cloning fails with an error message.\nCloning may be retried after making the database writable.\n\nREAD ONLY is permitted for ALTER DATABASE, but not for CREATE DATABASE.\nHowever, for a read-only database, the statement produced by SHOW\nCREATE DATABASE does include READ ONLY=1 within a comment to indicate\nits read-only status:\n\nmysql> ALTER DATABASE mydb READ ONLY = 1;\nmysql> SHOW CREATE DATABASE mydb\\G\n*************************** 1. row ***************************\n       Database: mydb\nCreate Database: CREATE DATABASE `mydb`\n                 /*!40100 DEFAULT CHARACTER SET utf8mb4\n                          COLLATE utf8mb4_0900_ai_ci */\n                 /*!80016 DEFAULT ENCRYPTION=\'N\' */\n                 /* READ ONLY = 1 */\n\nIf the server executes a CREATE DATABASE statement containing such a\ncomment, the server ignores the comment and the READ ONLY option is not\nprocessed. This has implications for mysqldump and mysqlpump, which use\nSHOW CREATE DATABASE to produce CREATE DATABASE statements in dump\noutput:\n\no In a dump file, the CREATE DATABASE statement for a read-only\n  database contains the commented READ ONLY option.\n\no The dump file can be restored as usual, but because the server\n  ignores the commented READ ONLY option, the restored database is not\n  read only. If the database is to be read only after being restored,\n  you must execute ALTER DATABASE manually to make it so.\n\nSuppose that mydb is read only and you dump it as follows:\n\n$> mysqldump --databases mydb > mydb.sql\n\nA restore operation later must be followed by ALTER DATABASE if mydb\nshould still be read only:\n\n$> mysql\nmysql> SOURCE mydb.sql;\nmysql> ALTER DATABASE mydb READ ONLY = 1;\n\nMySQL Enterprise Backup is not subject to this issue. It backs up and\nrestores a read-only database like any other, but enables the READ ONLY\noption at restore time if it was enabled at backup time.\n\nALTER DATABASE is written to the binary log, so a change to the READ\nONLY option on a replication source server also affects replicas. To\nprevent this from happening, binary logging must be disabled prior to\nexecution of the ALTER DATABASE statement. For example, to prepare for\nmigrating a database without affecting replicas, perform these\noperations:\n\n1. Within a single session, disable binary logging and enable READ ONLY\n   for the database:\n\nmysql> SET sql_log_bin = OFF;\nmysql> ALTER DATABASE mydb READ ONLY = 1;\n\n2. Dump the database, for example, with mysqldump or mysqlpump:\n\n$> mysqldump --databases mydb > mydb.sql\n\n3. Within a single session, disable binary logging and disable READ\n   ONLY for the database:\n\nmysql> SET sql_log_bin = OFF;\nmysql> ALTER DATABASE mydb READ ONLY = 0;\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/alter-database.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/alter-database.html'),(504,'ALTER EVENT',40,'Syntax:\nALTER\n    [DEFINER = user]\n    EVENT event_name\n    [ON SCHEDULE schedule]\n    [ON COMPLETION [NOT] PRESERVE]\n    [RENAME TO new_event_name]\n    [ENABLE | DISABLE | DISABLE ON SLAVE]\n    [COMMENT \'string\']\n    [DO event_body]\n\nThe ALTER EVENT statement changes one or more of the characteristics of\nan existing event without the need to drop and recreate it. The syntax\nfor each of the DEFINER, ON SCHEDULE, ON COMPLETION, COMMENT, ENABLE /\nDISABLE, and DO clauses is exactly the same as when used with CREATE\nEVENT. (See [HELP CREATE EVENT].)\n\nAny user can alter an event defined on a database for which that user\nhas the EVENT privilege. When a user executes a successful ALTER EVENT\nstatement, that user becomes the definer for the affected event.\n\nALTER EVENT works only with an existing event:\n\nmysql> ALTER EVENT no_such_event \n     >     ON SCHEDULE \n     >       EVERY \'2:3\' DAY_HOUR;\nERROR 1517 (HY000): Unknown event \'no_such_event\'\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/alter-event.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/alter-event.html'),(505,'ALTER FUNCTION',40,'Syntax:\nALTER FUNCTION func_name [characteristic ...]\n\ncharacteristic: {\n    COMMENT \'string\'\n  | LANGUAGE SQL\n  | { CONTAINS SQL | NO SQL | READS SQL DATA | MODIFIES SQL DATA }\n  | SQL SECURITY { DEFINER | INVOKER }\n}\n\nThis statement can be used to change the characteristics of a stored\nfunction. More than one change may be specified in an ALTER FUNCTION\nstatement. However, you cannot change the parameters or body of a\nstored function using this statement; to make such changes, you must\ndrop and re-create the function using DROP FUNCTION and CREATE\nFUNCTION.\n\nYou must have the ALTER ROUTINE privilege for the function. (That\nprivilege is granted automatically to the function creator.) If binary\nlogging is enabled, the ALTER FUNCTION statement might also require the\nSUPER privilege, as described in\nhttps://dev.mysql.com/doc/refman/8.0/en/stored-programs-logging.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/alter-function.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/alter-function.html'),(506,'ALTER INSTANCE',40,'Syntax:\nALTER INSTANCE instance_action\n\ninstance_action: {\n  | {ENABLE|DISABLE} INNODB REDO_LOG\n  | ROTATE INNODB MASTER KEY\n  | ROTATE BINLOG MASTER KEY\n  | RELOAD TLS\n      [FOR CHANNEL {mysql_main | mysql_admin}]\n      [NO ROLLBACK ON ERROR]\n  | RELOAD KEYRING\n}\n\nALTER INSTANCE defines actions applicable to a MySQL server instance.\nThe statement supports these actions:\n\no ALTER INSTANCE {ENABLE | DISABLE} INNODB REDO_LOG\n\n  This action enables or disables InnoDB redo logging. Redo logging is\n  enabled by default. This feature is intended only for loading data\n  into a new MySQL instance. The statement is not written to the binary\n  log. This action was introduced in MySQL 8.0.21.\n\n  *Warning*:\n\n  Do not disable redo logging on a production system. While it is\n  permitted to shut down and restart the server while redo logging is\n  disabled, an unexpected server stoppage while redo logging is\n  disabled can cause data loss and instance corruption.\n\n  An ALTER INSTANCE [ENABLE|DISABLE] INNODB REDO_LOG operation requires\n  an exclusive backup lock, which prevents other ALTER INSTANCE\n  operations from executing concurrently. Other ALTER INSTANCE\n  operations must wait for the lock to be released before executing.\n\n  For more information, see\n  https://dev.mysql.com/doc/refman/8.0/en/innodb-redo-log.html#innodb-d\n  isable-redo-logging.\n\no ALTER INSTANCE ROTATE INNODB MASTER KEY\n\n  This action rotates the master encryption key used for InnoDB\n  tablespace encryption. Key rotation requires the ENCRYPTION_KEY_ADMIN\n  or SUPER privilege. To perform this action, a keyring plugin must be\n  installed and configured. For instructions, see\n  https://dev.mysql.com/doc/refman/8.0/en/keyring.html.\n\n  ALTER INSTANCE ROTATE INNODB MASTER KEY supports concurrent DML.\n  However, it cannot be run concurrently with CREATE TABLE ...\n  ENCRYPTION or ALTER TABLE ... ENCRYPTION operations, and locks are\n  taken to prevent conflicts that could arise from concurrent execution\n  of these statements. If one of the conflicting statements is running,\n  it must complete before another can proceed.\n\n  ALTER INSTANCE ROTATE INNODB MASTER KEY statements are written to the\n  binary log so that they can be executed on replicated servers.\n\n  For additional ALTER INSTANCE ROTATE INNODB MASTER KEY usage\n  information, see\n  https://dev.mysql.com/doc/refman/8.0/en/innodb-data-encryption.html.\n\no ALTER INSTANCE ROTATE BINLOG MASTER KEY\n\n  This action rotates the binary log master key used for binary log\n  encryption. Key rotation for the binary log master key requires the\n  BINLOG_ENCRYPTION_ADMIN or SUPER privilege. The statement cannot be\n  used if the binlog_encryption system variable is set to OFF. To\n  perform this action, a keyring plugin must be installed and\n  configured. For instructions, see\n  https://dev.mysql.com/doc/refman/8.0/en/keyring.html.\n\n  ALTER INSTANCE ROTATE BINLOG MASTER KEY actions are not written to\n  the binary log and are not executed on replicas. Binary log master\n  key rotation can therefore be carried out in replication environments\n  including a mix of MySQL versions. To schedule regular rotation of\n  the binary log master key on all applicable source and replica\n  servers, you can enable the MySQL Event Scheduler on each server and\n  issue the ALTER INSTANCE ROTATE BINLOG MASTER KEY statement using a\n  CREATE EVENT statement. If you rotate the binary log master key\n  because you suspect that the current or any of the previous binary\n  log master keys might have been compromised, issue the statement on\n  every applicable source and replica server, which enables you to\n  verify immediate compliance.\n\n  For additional ALTER INSTANCE ROTATE BINLOG MASTER KEY usage\n  information, including what to do if the process does not complete\n  correctly or is interrupted by an unexpected server halt, see\n  https://dev.mysql.com/doc/refman/8.0/en/replication-binlog-encryption\n  .html.\n\no ALTER INSTANCE RELOAD TLS\n\n  This action reconfigures a TLS context from the current values of the\n  system variables that define the context. It also updates the status\n  variables that reflect the active context values. This action\n  requires the CONNECTION_ADMIN privilege. For additional information\n  about reconfiguring the TLS context, including which system and\n  status variables are context-related, see\n  https://dev.mysql.com/doc/refman/8.0/en/using-encrypted-connections.h\n  tml#using-encrypted-connections-server-side-runtime-configuration.\n\n  By default, the statement reloads the TLS context for the main\n  connection interface. If the FOR CHANNEL clause (available as of\n  MySQL 8.0.21) is given, the statement reloads the TLS context for the\n  named channel: mysql_main for the main connection interface,\n  mysql_admin for the administrative connection interface. For\n  information about the different interfaces, see\n  https://dev.mysql.com/doc/refman/8.0/en/connection-interfaces.html.\n  The updated TLS context properties are exposed in the Performance\n  Schema tls_channel_status table. See\n  https://dev.mysql.com/doc/refman/8.0/en/performance-schema-tls-channe\n  l-status-table.html.\n\n  Updating the TLS context for the main interface may also affect the\n  administrative interface because unless some nondefault TLS value is\n  configured for that interface, it uses the same TLS context as the\n  main interface.\n\n  *Note*:\n\n  When you reload the TLS context, OpenSSL reloads the file containing\n  the CRL (certificate revocation list) as part of the process. If the\n  CRL file is large, the server allocates a large chunk of memory (ten\n  times the file size), which is doubled while the new instance is\n  being loaded and the old one has not yet been released. The process\n  resident memory is not immediately reduced after a large allocation\n  is freed, so if you issue the ALTER INSTANCE RELOAD TLS statement\n  repeatedly with a large CRL file, the process resident memory usage\n  may grow as a result of this.\n\n  By default, the RELOAD TLS action rolls back with an error and has no\n  effect if the configuration values do not permit creation of the new\n  TLS context. The previous context values continue to be used for new\n  connections. If the optional NO ROLLBACK ON ERROR clause is given and\n  the new context cannot be created, rollback does not occur. Instead,\n  a warning is generated and encryption is disabled for new connections\n  on the interface to which the statement applies.\n\n  ALTER INSTANCE RELOAD TLS statements are not written to the binary\n  log (and thus are not replicated). TLS configuration is local and\n  depends on local files not necessarily present on all servers\n  involved.\n\no ALTER INSTANCE RELOAD KEYRING\n\n  If a keyring component is installed, this action tells the component\n  to re-read its configuration file and reinitialize any keyring\n  in-memory data. If you modify the component configuration at runtime,\n  the new configuration does not take effect until you perform this\n  action. Keyring reloading requires the ENCRYPTION_KEY_ADMIN\n  privilege. This action was added in MySQL 8.0.24.\n\n  This action enables reconfiguring only the currently installed\n  keyring component. It does not enable changing which component is\n  installed. For example, if you change the configuration for the\n  installed keyring component, ALTER INSTANCE RELOAD KEYRING causes the\n  new configuration to take effect. On the other hand, if you change\n  the keyring component named in the server manifest file, ALTER\n  INSTANCE RELOAD KEYRING has no effect and the current component\n  remains installed.\n\n  ALTER INSTANCE RELOAD KEYRING statements are not written to the\n  binary log (and thus are not replicated).\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/alter-instance.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/alter-instance.html'),(507,'ALTER LOGFILE GROUP',40,'Syntax:\nALTER LOGFILE GROUP logfile_group\n    ADD UNDOFILE \'file_name\'\n    [INITIAL_SIZE [=] size]\n    [WAIT]\n    ENGINE [=] engine_name\n\nThis statement adds an UNDO file named \'file_name\' to an existing log\nfile group logfile_group. An ALTER LOGFILE GROUP statement has one and\nonly one ADD UNDOFILE clause. No DROP UNDOFILE clause is currently\nsupported.\n\n*Note*:\n\nAll NDB Cluster Disk Data objects share the same namespace. This means\nthat each Disk Data object must be uniquely named (and not merely each\nDisk Data object of a given type). For example, you cannot have a\ntablespace and an undo log file with the same name, or an undo log file\nand a data file with the same name.\n\nThe optional INITIAL_SIZE parameter sets the UNDO file\'s initial size\nin bytes; if not specified, the initial size defaults to 134217728 (128\nMB). You may optionally follow size with a one-letter abbreviation for\nan order of magnitude, similar to those used in my.cnf. Generally, this\nis one of the letters M (megabytes) or G (gigabytes). (Bug #13116514,\nBug #16104705, Bug #62858)\n\nOn 32-bit systems, the maximum supported value for INITIAL_SIZE is\n4294967296 (4 GB). (Bug #29186)\n\nThe minimum allowed value for INITIAL_SIZE is 1048576 (1 MB). (Bug\n#29574)\n\n*Note*:\n\nWAIT is parsed but otherwise ignored. This keyword currently has no\neffect, and is intended for future expansion.\n\nThe ENGINE parameter (required) determines the storage engine which is\nused by this log file group, with engine_name being the name of the\nstorage engine. Currently, the only accepted values for engine_name are\n\"NDBCLUSTER\" and \"NDB\". The two values are equivalent.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/alter-logfile-group.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/alter-logfile-group.html'),(508,'ALTER PROCEDURE',40,'Syntax:\nALTER PROCEDURE proc_name [characteristic ...]\n\ncharacteristic: {\n    COMMENT \'string\'\n  | LANGUAGE SQL\n  | { CONTAINS SQL | NO SQL | READS SQL DATA | MODIFIES SQL DATA }\n  | SQL SECURITY { DEFINER | INVOKER }\n}\n\nThis statement can be used to change the characteristics of a stored\nprocedure. More than one change may be specified in an ALTER PROCEDURE\nstatement. However, you cannot change the parameters or body of a\nstored procedure using this statement; to make such changes, you must\ndrop and re-create the procedure using DROP PROCEDURE and CREATE\nPROCEDURE.\n\nYou must have the ALTER ROUTINE privilege for the procedure. By\ndefault, that privilege is granted automatically to the procedure\ncreator. This behavior can be changed by disabling the\nautomatic_sp_privileges system variable. See\nhttps://dev.mysql.com/doc/refman/8.0/en/stored-routines-privileges.html\n.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/alter-procedure.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/alter-procedure.html'),(509,'ALTER SERVER',40,'Syntax:\nALTER SERVER  server_name\n    OPTIONS (option [, option] ...)\n\nAlters the server information for server_name, adjusting any of the\noptions permitted in the CREATE SERVER statement. The corresponding\nfields in the mysql.servers table are updated accordingly. This\nstatement requires the SUPER privilege.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/alter-server.html\n\n','ALTER SERVER s OPTIONS (USER \'sally\');\n','https://dev.mysql.com/doc/refman/8.0/en/alter-server.html'),(510,'ALTER TABLE',40,'Syntax:\nALTER TABLE tbl_name\n    [alter_option [, alter_option] ...]\n    [partition_options]\n\nalter_option: {\n    table_options\n  | ADD [COLUMN] col_name column_definition\n        [FIRST | AFTER col_name]\n  | ADD [COLUMN] (col_name column_definition,...)\n  | ADD {INDEX | KEY} [index_name]\n        [index_type] (key_part,...) [index_option] ...\n  | ADD {FULLTEXT | SPATIAL} [INDEX | KEY] [index_name]\n        (key_part,...) [index_option] ...\n  | ADD [CONSTRAINT [symbol]] PRIMARY KEY\n        [index_type] (key_part,...)\n        [index_option] ...\n  | ADD [CONSTRAINT [symbol]] UNIQUE [INDEX | KEY]\n        [index_name] [index_type] (key_part,...)\n        [index_option] ...\n  | ADD [CONSTRAINT [symbol]] FOREIGN KEY\n        [index_name] (col_name,...)\n        reference_definition\n  | ADD [CONSTRAINT [symbol]] CHECK (expr) [[NOT] ENFORCED]\n  | DROP {CHECK | CONSTRAINT} symbol\n  | ALTER {CHECK | CONSTRAINT} symbol [NOT] ENFORCED\n  | ALGORITHM [=] {DEFAULT | INSTANT | INPLACE | COPY}\n  | ALTER [COLUMN] col_name {\n        SET DEFAULT {literal | (expr)}\n      | SET {VISIBLE | INVISIBLE}\n      | DROP DEFAULT\n    }\n  | ALTER INDEX index_name {VISIBLE | INVISIBLE}\n  | CHANGE [COLUMN] old_col_name new_col_name column_definition\n        [FIRST | AFTER col_name]\n  | [DEFAULT] CHARACTER SET [=] charset_name [COLLATE [=] collation_name]\n  | CONVERT TO CHARACTER SET charset_name [COLLATE collation_name]\n  | {DISABLE | ENABLE} KEYS\n  | {DISCARD | IMPORT} TABLESPACE\n  | DROP [COLUMN] col_name\n  | DROP {INDEX | KEY} index_name\n  | DROP PRIMARY KEY\n  | DROP FOREIGN KEY fk_symbol\n  | FORCE\n  | LOCK [=] {DEFAULT | NONE | SHARED | EXCLUSIVE}\n  | MODIFY [COLUMN] col_name column_definition\n        [FIRST | AFTER col_name]\n  | ORDER BY col_name [, col_name] ...\n  | RENAME COLUMN old_col_name TO new_col_name\n  | RENAME {INDEX | KEY} old_index_name TO new_index_name\n  | RENAME [TO | AS] new_tbl_name\n  | {WITHOUT | WITH} VALIDATION\n}\n\npartition_options:\n    partition_option [partition_option] ...\n\npartition_option: {\n    ADD PARTITION (partition_definition)\n  | DROP PARTITION partition_names\n  | DISCARD PARTITION {partition_names | ALL} TABLESPACE\n  | IMPORT PARTITION {partition_names | ALL} TABLESPACE\n  | TRUNCATE PARTITION {partition_names | ALL}\n  | COALESCE PARTITION number\n  | REORGANIZE PARTITION partition_names INTO (partition_definitions)\n  | EXCHANGE PARTITION partition_name WITH TABLE tbl_name [{WITH | WITHOUT} VALIDATION]\n  | ANALYZE PARTITION {partition_names | ALL}\n  | CHECK PARTITION {partition_names | ALL}\n  | OPTIMIZE PARTITION {partition_names | ALL}\n  | REBUILD PARTITION {partition_names | ALL}\n  | REPAIR PARTITION {partition_names | ALL}\n  | REMOVE PARTITIONING\n}\n\nkey_part: {col_name [(length)] | (expr)} [ASC | DESC]\n\nindex_type:\n    USING {BTREE | HASH}\n\nindex_option: {\n    KEY_BLOCK_SIZE [=] value\n  | index_type\n  | WITH PARSER parser_name\n  | COMMENT \'string\'\n  | {VISIBLE | INVISIBLE}\n}\n\ntable_options:\n    table_option [[,] table_option] ...\n\ntable_option: {\n    AUTOEXTEND_SIZE [=] value\n  | AUTO_INCREMENT [=] value\n  | AVG_ROW_LENGTH [=] value\n  | [DEFAULT] CHARACTER SET [=] charset_name\n  | CHECKSUM [=] {0 | 1}\n  | [DEFAULT] COLLATE [=] collation_name\n  | COMMENT [=] \'string\'\n  | COMPRESSION [=] {\'ZLIB\' | \'LZ4\' | \'NONE\'}\n  | CONNECTION [=] \'connect_string\'\n  | {DATA | INDEX} DIRECTORY [=] \'absolute path to directory\'\n  | DELAY_KEY_WRITE [=] {0 | 1}\n  | ENCRYPTION [=] {\'Y\' | \'N\'}\n  | ENGINE [=] engine_name\n  | ENGINE_ATTRIBUTE [=] \'string\'\n  | INSERT_METHOD [=] { NO | FIRST | LAST }\n  | KEY_BLOCK_SIZE [=] value\n  | MAX_ROWS [=] value\n  | MIN_ROWS [=] value\n  | PACK_KEYS [=] {0 | 1 | DEFAULT}\n  | PASSWORD [=] \'string\'\n  | ROW_FORMAT [=] {DEFAULT | DYNAMIC | FIXED | COMPRESSED | REDUNDANT | COMPACT}\n  | SECONDARY_ENGINE_ATTRIBUTE [=] \'string\'\n  | STATS_AUTO_RECALC [=] {DEFAULT | 0 | 1}\n  | STATS_PERSISTENT [=] {DEFAULT | 0 | 1}\n  | STATS_SAMPLE_PAGES [=] value\n  | TABLESPACE tablespace_name [STORAGE {DISK | MEMORY}]\n  | UNION [=] (tbl_name[,tbl_name]...)\n}\n\npartition_options:\n    (see CREATE TABLE options)\n\nALTER TABLE changes the structure of a table. For example, you can add\nor delete columns, create or destroy indexes, change the type of\nexisting columns, or rename columns or the table itself. You can also\nchange characteristics such as the storage engine used for the table or\nthe table comment.\n\no To use ALTER TABLE, you need ALTER, CREATE, and INSERT privileges for\n  the table. Renaming a table requires ALTER and DROP on the old table,\n  ALTER, CREATE, and INSERT on the new table.\n\no Following the table name, specify the alterations to be made. If none\n  are given, ALTER TABLE does nothing.\n\no The syntax for many of the permissible alterations is similar to\n  clauses of the CREATE TABLE statement. column_definition clauses use\n  the same syntax for ADD and CHANGE as for CREATE TABLE. For more\n  information, see [HELP CREATE TABLE].\n\no The word COLUMN is optional and can be omitted, except for RENAME\n  COLUMN (to distinguish a column-renaming operation from the RENAME\n  table-renaming operation).\n\no Multiple ADD, ALTER, DROP, and CHANGE clauses are permitted in a\n  single ALTER TABLE statement, separated by commas. This is a MySQL\n  extension to standard SQL, which permits only one of each clause per\n  ALTER TABLE statement. For example, to drop multiple columns in a\n  single statement, do this:\n\nALTER TABLE t2 DROP COLUMN c, DROP COLUMN d;\n\no If a storage engine does not support an attempted ALTER TABLE\n  operation, a warning may result. Such warnings can be displayed with\n  SHOW WARNINGS. See [HELP SHOW WARNINGS]. For information on\n  troubleshooting ALTER TABLE, see\n  https://dev.mysql.com/doc/refman/8.0/en/alter-table-problems.html.\n\no For information about generated columns, see\n  https://dev.mysql.com/doc/refman/8.0/en/alter-table-generated-columns\n  .html.\n\no For usage examples, see\n  https://dev.mysql.com/doc/refman/8.0/en/alter-table-examples.html.\n\no InnoDB in MySQL 8.0.17 and later supports addition of multi-valued\n  indexes on JSON columns using a key_part specification can take the\n  form (CAST json_path AS type ARRAY). See\n  https://dev.mysql.com/doc/refman/8.0/en/create-index.html#create-inde\n  x-multi-valued, for detailed information regarding multi-valued index\n  creation and usage of, as well as restrictions and limitations on\n  multi-valued indexes.\n\no With the mysql_info()\n  (https://dev.mysql.com/doc/c-api/8.0/en/mysql-info.html) C API\n  function, you can find out how many rows were copied by ALTER TABLE.\n  See mysql_info()\n  (https://dev.mysql.com/doc/c-api/8.0/en/mysql-info.html).\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/alter-table.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/alter-table.html'),(511,'ALTER TABLESPACE',40,'Syntax:\nALTER [UNDO] TABLESPACE tablespace_name\n  NDB only:\n    {ADD | DROP} DATAFILE \'file_name\'\n    [INITIAL_SIZE [=] size]\n    [WAIT]\n  InnoDB and NDB:\n    [RENAME TO tablespace_name]\n  InnoDB only:\n    [AUTOEXTEND_SIZE [=] \'value\']\n    [SET {ACTIVE | INACTIVE}]\n    [ENCRYPTION [=] {\'Y\' | \'N\'}]\n  InnoDB and NDB:\n    [ENGINE [=] engine_name]\n  Reserved for future use:\n    [ENGINE_ATTRIBUTE [=] \'string\']\n\nThis statement is used with NDB and InnoDB tablespaces. It can be used\nto add a new data file to, or to drop a data file from an NDB\ntablespace. It can also be used to rename an NDB Cluster Disk Data\ntablespace, rename an InnoDB general tablespace, encrypt an InnoDB\ngeneral tablespace, or mark an InnoDB undo tablespace as active or\ninactive.\n\nThe UNDO keyword, introduced in MySQL 8.0.14, is used with the SET\n{ACTIVE | INACTIVE} clause to mark an InnoDB undo tablespace as active\nor inactive. For more information, see\nhttps://dev.mysql.com/doc/refman/8.0/en/innodb-undo-tablespaces.html.\n\nThe ADD DATAFILE variant enables you to specify an initial size for an\nNDB Disk Data tablespace using an INITIAL_SIZE clause, where size is\nmeasured in bytes; the default value is 134217728 (128 MB). You may\noptionally follow size with a one-letter abbreviation for an order of\nmagnitude, similar to those used in my.cnf. Generally, this is one of\nthe letters M (megabytes) or G (gigabytes).\n\nOn 32-bit systems, the maximum supported value for INITIAL_SIZE is\n4294967296 (4 GB). (Bug #29186)\n\nINITIAL_SIZE is rounded, explicitly, as for CREATE TABLESPACE.\n\nOnce a data file has been created, its size cannot be changed; however,\nyou can add more data files to an NDB tablespace using additional ALTER\nTABLESPACE ... ADD DATAFILE statements.\n\nWhen ALTER TABLESPACE ... ADD DATAFILE is used with ENGINE = NDB, a\ndata file is created on each Cluster data node, but only one row is\ngenerated in the Information Schema FILES table. See the description of\nthis table, as well as\nhttps://dev.mysql.com/doc/refman/8.0/en/mysql-cluster-disk-data-objects\n.html, for more information. ADD DATAFILE is not supported with InnoDB\ntablespaces.\n\nUsing DROP DATAFILE with ALTER TABLESPACE drops the data file\n\'file_name\' from an NDB tablespace. You cannot drop a data file from a\ntablespace which is in use by any table; in other words, the data file\nmust be empty (no extents used). See\nhttps://dev.mysql.com/doc/refman/8.0/en/mysql-cluster-disk-data-objects\n.html. In addition, any data file to be dropped must previously have\nbeen added to the tablespace with CREATE TABLESPACE or ALTER\nTABLESPACE. DROP DATAFILE is not supported with InnoDB tablespaces.\n\nWAIT is parsed but otherwise ignored. It is intended for future\nexpansion.\n\nThe ENGINE clause, which specifies the storage engine used by the\ntablespace, is deprecated; expect it to be removed in a future release.\nThe tablespace storage engine is known by the data dictionary, making\nthe ENGINE clause obsolete. If the storage engine is specified, it must\nmatch the tablespace storage engine defined in the data dictionary. The\nonly values for engine_name compatible with NDB tablespaces are NDB and\nNDBCLUSTER.\n\nRENAME TO operations are implicitly performed in autocommit mode,\nregardless of the autocommit setting.\n\nA RENAME TO operation cannot be performed while LOCK TABLES or FLUSH\nTABLES WITH READ LOCK is in effect for tables that reside in the\ntablespace.\n\nExclusive metadata locks are taken on tables that reside in a general\ntablespace while the tablespace is renamed, which prevents concurrent\nDDL. Concurrent DML is supported.\n\nThe CREATE TABLESPACE privilege is required to rename an InnoDB general\ntablespace.\n\nThe AUTOEXTEND_SIZE option defines the amount by which InnoDB extends\nthe size of a tablespace when it becomes full. Introduced in MySQL\n8.0.23. The setting must be a multiple of 4MB. The default setting is\n0, which causes the tablespace to be extended according to the implicit\ndefault behavior. For more information, see\nhttps://dev.mysql.com/doc/refman/8.0/en/innodb-tablespace-autoextend-si\nze.html.\n\nThe ENCRYPTION clause enables or disables page-level data encryption\nfor an InnoDB general tablespace or the mysql system tablespace.\nEncryption support for general tablespaces was introduced in MySQL\n8.0.13. Encryption support for the mysql system tablespace was\nintroduced in MySQL 8.0.16.\n\nA keyring plugin must be installed and configured before encryption can\nbe enabled.\n\nAs of MySQL 8.0.16, if the table_encryption_privilege_check variable is\nenabled, the TABLE_ENCRYPTION_ADMIN privilege is required to alter a\ngeneral tablespace with an ENCRYPTION clause setting that differs from\nthe default_table_encryption setting.\n\nEnabling encryption for a general tablespace fails if any table in the\ntablespace belongs to a schema defined with DEFAULT ENCRYPTION=\'N\'.\nSimilarly, disabling encryption fails if any table in the general\ntablespace belongs to a schema defined with DEFAULT ENCRYPTION=\'Y\'. The\nDEFAULT ENCRYPTION schema option was introduced in MySQL 8.0.16.\n\nIf an ALTER TABLESPACE statement executed on a general tablespace does\nnot include an ENCRYPTION clause, the tablespace retains its current\nencryption status, regardless of the default_table_encryption setting.\n\nWhen a general tablespace or the mysql system tablespace is encrypted,\nall tables residing in the tablespace are encrypted. Likewise, a table\ncreated in an encrypted tablespace is encrypted.\n\nThe INPLACE algorithm is used when altering the ENCRYPTION attribute of\na general tablespace or the mysql system tablespace. The INPLACE\nalgorithm permits concurrent DML on tables that reside in the\ntablespace. Concurrent DDL is blocked.\n\nFor more information, see\nhttps://dev.mysql.com/doc/refman/8.0/en/innodb-data-encryption.html.\n\nThe ENGINE_ATTRIBUTE option (available as of MySQL 8.0.21) is used to\nspecify tablespace attributes for primary storage engines. The option\nis reserved for future use.\n\nPermitted values are a string literal containing a valid JSON document\nor an empty string (\'\'). Invalid JSON is rejected.\n\nALTER TABLESPACE ts1 ENGINE_ATTRIBUTE=\'{\"key\":\"value\"}\';\n\nENGINE_ATTRIBUTE values can be repeated without error. In this case,\nthe last specified value is used.\n\nENGINE_ATTRIBUTE values are not checked by the server, nor are they\ncleared when the table\'s storage engine is changed.\n\nIt is not permitted to alter an individual element of a JSON attribute\nvalue. You can only add or replace an attribute.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/alter-tablespace.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/alter-tablespace.html'),(512,'ALTER VIEW',40,'Syntax:\nALTER\n    [ALGORITHM = {UNDEFINED | MERGE | TEMPTABLE}]\n    [DEFINER = user]\n    [SQL SECURITY { DEFINER | INVOKER }]\n    VIEW view_name [(column_list)]\n    AS select_statement\n    [WITH [CASCADED | LOCAL] CHECK OPTION]\n\nThis statement changes the definition of a view, which must exist. The\nsyntax is similar to that for CREATE VIEW see [HELP CREATE VIEW]). This\nstatement requires the CREATE VIEW and DROP privileges for the view,\nand some privilege for each column referred to in the SELECT statement.\nALTER VIEW is permitted only to the definer or users with the\nSET_USER_ID privilege (or the deprecated SUPER privilege).\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/alter-view.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/alter-view.html'),(513,'CREATE DATABASE',40,'Syntax:\nCREATE {DATABASE | SCHEMA} [IF NOT EXISTS] db_name\n    [create_option] ...\n\ncreate_option: [DEFAULT] {\n    CHARACTER SET [=] charset_name\n  | COLLATE [=] collation_name\n  | ENCRYPTION [=] {\'Y\' | \'N\'}\n}\n\nCREATE DATABASE creates a database with the given name. To use this\nstatement, you need the CREATE privilege for the database. CREATE\nSCHEMA is a synonym for CREATE DATABASE.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/create-database.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/create-database.html'),(514,'CREATE SCHEMA',40,'Syntax:\nCREATE {DATABASE | SCHEMA} [IF NOT EXISTS] db_name\n    [create_option] ...\n\ncreate_option: [DEFAULT] {\n    CHARACTER SET [=] charset_name\n  | COLLATE [=] collation_name\n  | ENCRYPTION [=] {\'Y\' | \'N\'}\n}\n\nCREATE DATABASE creates a database with the given name. To use this\nstatement, you need the CREATE privilege for the database. CREATE\nSCHEMA is a synonym for CREATE DATABASE.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/create-database.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/create-database.html'),(515,'CREATE EVENT',40,'Syntax:\nCREATE\n    [DEFINER = user]\n    EVENT\n    [IF NOT EXISTS]\n    event_name\n    ON SCHEDULE schedule\n    [ON COMPLETION [NOT] PRESERVE]\n    [ENABLE | DISABLE | DISABLE ON SLAVE]\n    [COMMENT \'string\']\n    DO event_body;\n\nschedule: {\n    AT timestamp [+ INTERVAL interval] ...\n  | EVERY interval\n    [STARTS timestamp [+ INTERVAL interval] ...]\n    [ENDS timestamp [+ INTERVAL interval] ...]\n}\n\ninterval:\n    quantity {YEAR | QUARTER | MONTH | DAY | HOUR | MINUTE |\n              WEEK | SECOND | YEAR_MONTH | DAY_HOUR | DAY_MINUTE |\n              DAY_SECOND | HOUR_MINUTE | HOUR_SECOND | MINUTE_SECOND}\n\nThis statement creates and schedules a new event. The event does not\nrun unless the Event Scheduler is enabled. For information about\nchecking Event Scheduler status and enabling it if necessary, see\nhttps://dev.mysql.com/doc/refman/8.0/en/events-configuration.html.\n\nCREATE EVENT requires the EVENT privilege for the schema in which the\nevent is to be created. If the DEFINER clause is present, the\nprivileges required depend on the user value, as discussed in\nhttps://dev.mysql.com/doc/refman/8.0/en/stored-objects-security.html.\n\nThe minimum requirements for a valid CREATE EVENT statement are as\nfollows:\n\no The keywords CREATE EVENT plus an event name, which uniquely\n  identifies the event in a database schema.\n\no An ON SCHEDULE clause, which determines when and how often the event\n  executes.\n\no A DO clause, which contains the SQL statement to be executed by an\n  event.\n\nThis is an example of a minimal CREATE EVENT statement:\n\nCREATE EVENT myevent\n    ON SCHEDULE AT CURRENT_TIMESTAMP + INTERVAL 1 HOUR\n    DO\n      UPDATE myschema.mytable SET mycol = mycol + 1;\n\nThe previous statement creates an event named myevent. This event\nexecutes once---one hour following its creation---by running an SQL\nstatement that increments the value of the myschema.mytable table\'s\nmycol column by 1.\n\nThe event_name must be a valid MySQL identifier with a maximum length\nof 64 characters. Event names are not case-sensitive, so you cannot\nhave two events named myevent and MyEvent in the same schema. In\ngeneral, the rules governing event names are the same as those for\nnames of stored routines. See\nhttps://dev.mysql.com/doc/refman/8.0/en/identifiers.html.\n\nAn event is associated with a schema. If no schema is indicated as part\nof event_name, the default (current) schema is assumed. To create an\nevent in a specific schema, qualify the event name with a schema using\nschema_name.event_name syntax.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/create-event.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/create-event.html'),(516,'CREATE INDEX',40,'Syntax:\nCREATE [UNIQUE | FULLTEXT | SPATIAL] INDEX index_name\n    [index_type]\n    ON tbl_name (key_part,...)\n    [index_option]\n    [algorithm_option | lock_option] ...\n\nkey_part: {col_name [(length)] | (expr)} [ASC | DESC]\n\nindex_option: {\n    KEY_BLOCK_SIZE [=] value\n  | index_type\n  | WITH PARSER parser_name\n  | COMMENT \'string\'\n  | {VISIBLE | INVISIBLE}\n  | ENGINE_ATTRIBUTE [=] \'string\'\n  | SECONDARY_ENGINE_ATTRIBUTE [=] \'string\'\n}\n\nindex_type:\n    USING {BTREE | HASH}\n\nalgorithm_option:\n    ALGORITHM [=] {DEFAULT | INPLACE | COPY}\n\nlock_option:\n    LOCK [=] {DEFAULT | NONE | SHARED | EXCLUSIVE}\n\nNormally, you create all indexes on a table at the time the table\nitself is created with CREATE TABLE. See [HELP CREATE TABLE]. This\nguideline is especially important for InnoDB tables, where the primary\nkey determines the physical layout of rows in the data file. CREATE\nINDEX enables you to add indexes to existing tables.\n\nCREATE INDEX is mapped to an ALTER TABLE statement to create indexes.\nSee [HELP ALTER TABLE]. CREATE INDEX cannot be used to create a PRIMARY\nKEY; use ALTER TABLE instead. For more information about indexes, see\nhttps://dev.mysql.com/doc/refman/8.0/en/mysql-indexes.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/create-index.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/create-index.html'),(517,'CREATE LOGFILE GROUP',40,'Syntax:\nCREATE LOGFILE GROUP logfile_group\n    ADD UNDOFILE \'undo_file\'\n    [INITIAL_SIZE [=] initial_size]\n    [UNDO_BUFFER_SIZE [=] undo_buffer_size]\n    [REDO_BUFFER_SIZE [=] redo_buffer_size]\n    [NODEGROUP [=] nodegroup_id]\n    [WAIT]\n    [COMMENT [=] \'string\']\n    ENGINE [=] engine_name\n\nThis statement creates a new log file group named logfile_group having\na single UNDO file named \'undo_file\'. A CREATE LOGFILE GROUP statement\nhas one and only one ADD UNDOFILE clause. For rules covering the naming\nof log file groups, see\nhttps://dev.mysql.com/doc/refman/8.0/en/identifiers.html.\n\n*Note*:\n\nAll NDB Cluster Disk Data objects share the same namespace. This means\nthat each Disk Data object must be uniquely named (and not merely each\nDisk Data object of a given type). For example, you cannot have a\ntablespace and a log file group with the same name, or a tablespace and\na data file with the same name.\n\nThere can be only one log file group per NDB Cluster instance at any\ngiven time.\n\nThe optional INITIAL_SIZE parameter sets the UNDO file\'s initial size;\nif not specified, it defaults to 128M (128 megabytes). The optional\nUNDO_BUFFER_SIZE parameter sets the size used by the UNDO buffer for\nthe log file group; The default value for UNDO_BUFFER_SIZE is 8M (eight\nmegabytes); this value cannot exceed the amount of system memory\navailable. Both of these parameters are specified in bytes. You may\noptionally follow either or both of these with a one-letter\nabbreviation for an order of magnitude, similar to those used in\nmy.cnf. Generally, this is one of the letters M (for megabytes) or G\n(for gigabytes).\n\nMemory used for UNDO_BUFFER_SIZE comes from the global pool whose size\nis determined by the value of the SharedGlobalMemory data node\nconfiguration parameter. This includes any default value implied for\nthis option by the setting of the InitialLogFileGroup data node\nconfiguration parameter.\n\nThe maximum permitted for UNDO_BUFFER_SIZE is 629145600 (600 MB).\n\nOn 32-bit systems, the maximum supported value for INITIAL_SIZE is\n4294967296 (4 GB). (Bug #29186)\n\nThe minimum allowed value for INITIAL_SIZE is 1048576 (1 MB).\n\nThe ENGINE option determines the storage engine to be used by this log\nfile group, with engine_name being the name of the storage engine. In\nMySQL 8.0, this must be NDB (or NDBCLUSTER). If ENGINE is not set,\nMySQL tries to use the engine specified by the default_storage_engine\nserver system variable (formerly storage_engine). In any case, if the\nengine is not specified as NDB or NDBCLUSTER, the CREATE LOGFILE GROUP\nstatement appears to succeed but actually fails to create the log file\ngroup, as shown here:\n\nmysql> CREATE LOGFILE GROUP lg1\n    ->     ADD UNDOFILE \'undo.dat\' INITIAL_SIZE = 10M;\nQuery OK, 0 rows affected, 1 warning (0.00 sec)\n\nmysql> SHOW WARNINGS;\n+-------+------+------------------------------------------------------------------------------------------------+\n| Level | Code | Message                                                                                        |\n+-------+------+------------------------------------------------------------------------------------------------+\n| Error | 1478 | Table storage engine \'InnoDB\' does not support the create option \'TABLESPACE or LOGFILE GROUP\' |\n+-------+------+------------------------------------------------------------------------------------------------+\n1 row in set (0.00 sec)\n\nmysql> DROP LOGFILE GROUP lg1 ENGINE = NDB;\nERROR 1529 (HY000): Failed to drop LOGFILE GROUP\n\nmysql> CREATE LOGFILE GROUP lg1\n    ->     ADD UNDOFILE \'undo.dat\' INITIAL_SIZE = 10M\n    ->     ENGINE = NDB;\nQuery OK, 0 rows affected (2.97 sec)\n\nThe fact that the CREATE LOGFILE GROUP statement does not actually\nreturn an error when a non-NDB storage engine is named, but rather\nappears to succeed, is a known issue which we hope to address in a\nfuture release of NDB Cluster.\n\nREDO_BUFFER_SIZE, NODEGROUP, WAIT, and COMMENT are parsed but ignored,\nand so have no effect in MySQL 8.0. These options are intended for\nfuture expansion.\n\nWhen used with ENGINE [=] NDB, a log file group and associated UNDO log\nfile are created on each Cluster data node. You can verify that the\nUNDO files were created and obtain information about them by querying\nthe Information Schema FILES table. For example:\n\nmysql> SELECT LOGFILE_GROUP_NAME, LOGFILE_GROUP_NUMBER, EXTRA\n    -> FROM INFORMATION_SCHEMA.FILES\n    -> WHERE FILE_NAME = \'undo_10.dat\';\n+--------------------+----------------------+----------------+\n| LOGFILE_GROUP_NAME | LOGFILE_GROUP_NUMBER | EXTRA          |\n+--------------------+----------------------+----------------+\n| lg_3               |                   11 | CLUSTER_NODE=3 |\n| lg_3               |                   11 | CLUSTER_NODE=4 |\n+--------------------+----------------------+----------------+\n2 rows in set (0.06 sec)\n\nCREATE LOGFILE GROUP is useful only with Disk Data storage for NDB\nCluster. See\nhttps://dev.mysql.com/doc/refman/8.0/en/mysql-cluster-disk-data.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/create-logfile-group.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/create-logfile-group.html'),(518,'CREATE PROCEDURE',40,'Syntax:\nCREATE\n    [DEFINER = user]\n    PROCEDURE [IF NOT EXISTS] sp_name ([proc_parameter[,...]])\n    [characteristic ...] routine_body\n\nCREATE\n    [DEFINER = user]\n    FUNCTION [IF NOT EXISTS] sp_name ([func_parameter[,...]])\n    RETURNS type\n    [characteristic ...] routine_body\n\nproc_parameter:\n    [ IN | OUT | INOUT ] param_name type\n\nfunc_parameter:\n    param_name type\n\ntype:\n    Any valid MySQL data type\n\ncharacteristic: {\n    COMMENT \'string\'\n  | LANGUAGE SQL\n  | [NOT] DETERMINISTIC\n  | { CONTAINS SQL | NO SQL | READS SQL DATA | MODIFIES SQL DATA }\n  | SQL SECURITY { DEFINER | INVOKER }\n}\n\nroutine_body:\n    Valid SQL routine statement\n\nThese statements are used to create a stored routine (a stored\nprocedure or function). That is, the specified routine becomes known to\nthe server. By default, a stored routine is associated with the default\ndatabase. To associate the routine explicitly with a given database,\nspecify the name as db_name.sp_name when you create it.\n\nThe CREATE FUNCTION statement is also used in MySQL to support loadable\nfunctions. See [HELP CREATE FUNCTION loadable function]. A loadable\nfunction can be regarded as an external stored function. Stored\nfunctions share their namespace with loadable functions. See\nhttps://dev.mysql.com/doc/refman/8.0/en/function-resolution.html, for\nthe rules describing how the server interprets references to different\nkinds of functions.\n\nTo invoke a stored procedure, use the CALL statement (see [HELP CALL]).\nTo invoke a stored function, refer to it in an expression. The function\nreturns a value during expression evaluation.\n\nCREATE PROCEDURE and CREATE FUNCTION require the CREATE ROUTINE\nprivilege. If the DEFINER clause is present, the privileges required\ndepend on the user value, as discussed in\nhttps://dev.mysql.com/doc/refman/8.0/en/stored-objects-security.html.\nIf binary logging is enabled, CREATE FUNCTION might require the SUPER\nprivilege, as discussed in\nhttps://dev.mysql.com/doc/refman/8.0/en/stored-programs-logging.html.\n\nBy default, MySQL automatically grants the ALTER ROUTINE and EXECUTE\nprivileges to the routine creator. This behavior can be changed by\ndisabling the automatic_sp_privileges system variable. See\nhttps://dev.mysql.com/doc/refman/8.0/en/stored-routines-privileges.html\n.\n\nThe DEFINER and SQL SECURITY clauses specify the security context to be\nused when checking access privileges at routine execution time, as\ndescribed later in this section.\n\nIf the routine name is the same as the name of a built-in SQL function,\na syntax error occurs unless you use a space between the name and the\nfollowing parenthesis when defining the routine or invoking it later.\nFor this reason, avoid using the names of existing SQL functions for\nyour own stored routines.\n\nThe IGNORE_SPACE SQL mode applies to built-in functions, not to stored\nroutines. It is always permissible to have spaces after a stored\nroutine name, regardless of whether IGNORE_SPACE is enabled.\n\nIF NOT EXISTS prevents an error from occurring if there already exists\na routine with the same name. This option is supported with both CREATE\nFUNCTION and CREATE PROCEDURE beginning with MySQL 8.0.29.\n\nIf a built-in function with the same name already exists, attempting to\ncreate a stored function with CREATE FUNCTION ... IF NOT EXISTS\nsucceeds with a warning indicating that it has the same name as a\nnative function; this is no different than when performing the same\nCREATE FUNCTION statement without specifying IF NOT EXISTS.\n\nIf a loadable function with the same name already exists, attempting to\ncreate a stored function using IF NOT EXISTS succeeds with a warning.\nThis is the same as without specifying IF NOT EXISTS.\n\nSee\nhttps://dev.mysql.com/doc/refman/8.0/en/function-resolution.html#functi\non-name-resolution, for more information.\n\nThe parameter list enclosed within parentheses must always be present.\nIf there are no parameters, an empty parameter list of () should be\nused. Parameter names are not case-sensitive.\n\nEach parameter is an IN parameter by default. To specify otherwise for\na parameter, use the keyword OUT or INOUT before the parameter name.\n\n*Note*:\n\nSpecifying a parameter as IN, OUT, or INOUT is valid only for a\nPROCEDURE. For a FUNCTION, parameters are always regarded as IN\nparameters.\n\nAn IN parameter passes a value into a procedure. The procedure might\nmodify the value, but the modification is not visible to the caller\nwhen the procedure returns. An OUT parameter passes a value from the\nprocedure back to the caller. Its initial value is NULL within the\nprocedure, and its value is visible to the caller when the procedure\nreturns. An INOUT parameter is initialized by the caller, can be\nmodified by the procedure, and any change made by the procedure is\nvisible to the caller when the procedure returns.\n\nFor each OUT or INOUT parameter, pass a user-defined variable in the\nCALL statement that invokes the procedure so that you can obtain its\nvalue when the procedure returns. If you are calling the procedure from\nwithin another stored procedure or function, you can also pass a\nroutine parameter or local routine variable as an OUT or INOUT\nparameter. If you are calling the procedure from within a trigger, you\ncan also pass NEW.col_name as an OUT or INOUT parameter.\n\nFor information about the effect of unhandled conditions on procedure\nparameters, see\nhttps://dev.mysql.com/doc/refman/8.0/en/conditions-and-parameters.html.\n\nRoutine parameters cannot be referenced in statements prepared within\nthe routine; see\nhttps://dev.mysql.com/doc/refman/8.0/en/stored-program-restrictions.html\n.\n\nThe following example shows a simple stored procedure that, given a\ncountry code, counts the number of cities for that country that appear\nin the city table of the world database. The country code is passed\nusing an IN parameter, and the city count is returned using an OUT\nparameter:\n\nmysql> delimiter //\n\nmysql> CREATE PROCEDURE citycount (IN country CHAR(3), OUT cities INT)\n       BEGIN\n         SELECT COUNT(*) INTO cities FROM world.city\n         WHERE CountryCode = country;\n       END//\nQuery OK, 0 rows affected (0.01 sec)\n\nmysql> delimiter ;\n\nmysql> CALL citycount(\'JPN\', @cities); -- cities in Japan\nQuery OK, 1 row affected (0.00 sec)\n\nmysql> SELECT @cities;\n+---------+\n| @cities |\n+---------+\n|     248 |\n+---------+\n1 row in set (0.00 sec)\n\nmysql> CALL citycount(\'FRA\', @cities); -- cities in France\nQuery OK, 1 row affected (0.00 sec)\n\nmysql> SELECT @cities;\n+---------+\n| @cities |\n+---------+\n|      40 |\n+---------+\n1 row in set (0.00 sec)\n\nThe example uses the mysql client delimiter command to change the\nstatement delimiter from ; to // while the procedure is being defined.\nThis enables the ; delimiter used in the procedure body to be passed\nthrough to the server rather than being interpreted by mysql itself.\nSee\nhttps://dev.mysql.com/doc/refman/8.0/en/stored-programs-defining.html.\n\nThe RETURNS clause may be specified only for a FUNCTION, for which it\nis mandatory. It indicates the return type of the function, and the\nfunction body must contain a RETURN value statement. If the RETURN\nstatement returns a value of a different type, the value is coerced to\nthe proper type. For example, if a function specifies an ENUM or SET\nvalue in the RETURNS clause, but the RETURN statement returns an\ninteger, the value returned from the function is the string for the\ncorresponding ENUM member of set of SET members.\n\nThe following example function takes a parameter, performs an operation\nusing an SQL function, and returns the result. In this case, it is\nunnecessary to use delimiter because the function definition contains\nno internal ; statement delimiters:\n\nmysql> CREATE FUNCTION hello (s CHAR(20))\nmysql> RETURNS CHAR(50) DETERMINISTIC\n       RETURN CONCAT(\'Hello, \',s,\'!\');\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> SELECT hello(\'world\');\n+----------------+\n| hello(\'world\') |\n+----------------+\n| Hello, world!  |\n+----------------+\n1 row in set (0.00 sec)\n\nParameter types and function return types can be declared to use any\nvalid data type. The COLLATE attribute can be used if preceded by a\nCHARACTER SET specification.\n\nThe routine_body consists of a valid SQL routine statement. This can be\na simple statement such as SELECT or INSERT, or a compound statement\nwritten using BEGIN and END. Compound statements can contain\ndeclarations, loops, and other control structure statements. The syntax\nfor these statements is described in\nhttps://dev.mysql.com/doc/refman/8.0/en/sql-compound-statements.html.\nIn practice, stored functions tend to use compound statements, unless\nthe body consists of a single RETURN statement.\n\nMySQL permits routines to contain DDL statements, such as CREATE and\nDROP. MySQL also permits stored procedures (but not stored functions)\nto contain SQL transaction statements such as COMMIT. Stored functions\nmay not contain statements that perform explicit or implicit commit or\nrollback. Support for these statements is not required by the SQL\nstandard, which states that each DBMS vendor may decide whether to\npermit them.\n\nStatements that return a result set can be used within a stored\nprocedure but not within a stored function. This prohibition includes\nSELECT statements that do not have an INTO var_list clause and other\nstatements such as SHOW, EXPLAIN, and CHECK TABLE. For statements that\ncan be determined at function definition time to return a result set, a\nNot allowed to return a result set from a function error occurs\n(ER_SP_NO_RETSET\n(https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference.html\n#error_er_sp_no_retset)). For statements that can be determined only\nat runtime to return a result set, a PROCEDURE %s can\'t return a result\nset in the given context error occurs (ER_SP_BADSELECT\n(https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference.html\n#error_er_sp_badselect)).\n\nUSE statements within stored routines are not permitted. When a routine\nis invoked, an implicit USE db_name is performed (and undone when the\nroutine terminates). The causes the routine to have the given default\ndatabase while it executes. References to objects in databases other\nthan the routine default database should be qualified with the\nappropriate database name.\n\nFor additional information about statements that are not permitted in\nstored routines, see\nhttps://dev.mysql.com/doc/refman/8.0/en/stored-program-restrictions.html\n.\n\nFor information about invoking stored procedures from within programs\nwritten in a language that has a MySQL interface, see [HELP CALL].\n\nMySQL stores the sql_mode system variable setting in effect when a\nroutine is created or altered, and always executes the routine with\nthis setting in force, regardless of the current server SQL mode when\nthe routine begins executing.\n\nThe switch from the SQL mode of the invoker to that of the routine\noccurs after evaluation of arguments and assignment of the resulting\nvalues to routine parameters. If you define a routine in strict SQL\nmode but invoke it in nonstrict mode, assignment of arguments to\nroutine parameters does not take place in strict mode. If you require\nthat expressions passed to a routine be assigned in strict SQL mode,\nyou should invoke the routine with strict mode in effect.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/create-procedure.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/create-procedure.html'),(519,'CREATE FUNCTION',40,'Syntax:\nCREATE\n    [DEFINER = user]\n    PROCEDURE [IF NOT EXISTS] sp_name ([proc_parameter[,...]])\n    [characteristic ...] routine_body\n\nCREATE\n    [DEFINER = user]\n    FUNCTION [IF NOT EXISTS] sp_name ([func_parameter[,...]])\n    RETURNS type\n    [characteristic ...] routine_body\n\nproc_parameter:\n    [ IN | OUT | INOUT ] param_name type\n\nfunc_parameter:\n    param_name type\n\ntype:\n    Any valid MySQL data type\n\ncharacteristic: {\n    COMMENT \'string\'\n  | LANGUAGE SQL\n  | [NOT] DETERMINISTIC\n  | { CONTAINS SQL | NO SQL | READS SQL DATA | MODIFIES SQL DATA }\n  | SQL SECURITY { DEFINER | INVOKER }\n}\n\nroutine_body:\n    Valid SQL routine statement\n\nThese statements are used to create a stored routine (a stored\nprocedure or function). That is, the specified routine becomes known to\nthe server. By default, a stored routine is associated with the default\ndatabase. To associate the routine explicitly with a given database,\nspecify the name as db_name.sp_name when you create it.\n\nThe CREATE FUNCTION statement is also used in MySQL to support loadable\nfunctions. See [HELP CREATE FUNCTION loadable function]. A loadable\nfunction can be regarded as an external stored function. Stored\nfunctions share their namespace with loadable functions. See\nhttps://dev.mysql.com/doc/refman/8.0/en/function-resolution.html, for\nthe rules describing how the server interprets references to different\nkinds of functions.\n\nTo invoke a stored procedure, use the CALL statement (see [HELP CALL]).\nTo invoke a stored function, refer to it in an expression. The function\nreturns a value during expression evaluation.\n\nCREATE PROCEDURE and CREATE FUNCTION require the CREATE ROUTINE\nprivilege. If the DEFINER clause is present, the privileges required\ndepend on the user value, as discussed in\nhttps://dev.mysql.com/doc/refman/8.0/en/stored-objects-security.html.\nIf binary logging is enabled, CREATE FUNCTION might require the SUPER\nprivilege, as discussed in\nhttps://dev.mysql.com/doc/refman/8.0/en/stored-programs-logging.html.\n\nBy default, MySQL automatically grants the ALTER ROUTINE and EXECUTE\nprivileges to the routine creator. This behavior can be changed by\ndisabling the automatic_sp_privileges system variable. See\nhttps://dev.mysql.com/doc/refman/8.0/en/stored-routines-privileges.html\n.\n\nThe DEFINER and SQL SECURITY clauses specify the security context to be\nused when checking access privileges at routine execution time, as\ndescribed later in this section.\n\nIf the routine name is the same as the name of a built-in SQL function,\na syntax error occurs unless you use a space between the name and the\nfollowing parenthesis when defining the routine or invoking it later.\nFor this reason, avoid using the names of existing SQL functions for\nyour own stored routines.\n\nThe IGNORE_SPACE SQL mode applies to built-in functions, not to stored\nroutines. It is always permissible to have spaces after a stored\nroutine name, regardless of whether IGNORE_SPACE is enabled.\n\nIF NOT EXISTS prevents an error from occurring if there already exists\na routine with the same name. This option is supported with both CREATE\nFUNCTION and CREATE PROCEDURE beginning with MySQL 8.0.29.\n\nIf a built-in function with the same name already exists, attempting to\ncreate a stored function with CREATE FUNCTION ... IF NOT EXISTS\nsucceeds with a warning indicating that it has the same name as a\nnative function; this is no different than when performing the same\nCREATE FUNCTION statement without specifying IF NOT EXISTS.\n\nIf a loadable function with the same name already exists, attempting to\ncreate a stored function using IF NOT EXISTS succeeds with a warning.\nThis is the same as without specifying IF NOT EXISTS.\n\nSee\nhttps://dev.mysql.com/doc/refman/8.0/en/function-resolution.html#functi\non-name-resolution, for more information.\n\nThe parameter list enclosed within parentheses must always be present.\nIf there are no parameters, an empty parameter list of () should be\nused. Parameter names are not case-sensitive.\n\nEach parameter is an IN parameter by default. To specify otherwise for\na parameter, use the keyword OUT or INOUT before the parameter name.\n\n*Note*:\n\nSpecifying a parameter as IN, OUT, or INOUT is valid only for a\nPROCEDURE. For a FUNCTION, parameters are always regarded as IN\nparameters.\n\nAn IN parameter passes a value into a procedure. The procedure might\nmodify the value, but the modification is not visible to the caller\nwhen the procedure returns. An OUT parameter passes a value from the\nprocedure back to the caller. Its initial value is NULL within the\nprocedure, and its value is visible to the caller when the procedure\nreturns. An INOUT parameter is initialized by the caller, can be\nmodified by the procedure, and any change made by the procedure is\nvisible to the caller when the procedure returns.\n\nFor each OUT or INOUT parameter, pass a user-defined variable in the\nCALL statement that invokes the procedure so that you can obtain its\nvalue when the procedure returns. If you are calling the procedure from\nwithin another stored procedure or function, you can also pass a\nroutine parameter or local routine variable as an OUT or INOUT\nparameter. If you are calling the procedure from within a trigger, you\ncan also pass NEW.col_name as an OUT or INOUT parameter.\n\nFor information about the effect of unhandled conditions on procedure\nparameters, see\nhttps://dev.mysql.com/doc/refman/8.0/en/conditions-and-parameters.html.\n\nRoutine parameters cannot be referenced in statements prepared within\nthe routine; see\nhttps://dev.mysql.com/doc/refman/8.0/en/stored-program-restrictions.html\n.\n\nThe following example shows a simple stored procedure that, given a\ncountry code, counts the number of cities for that country that appear\nin the city table of the world database. The country code is passed\nusing an IN parameter, and the city count is returned using an OUT\nparameter:\n\nmysql> delimiter //\n\nmysql> CREATE PROCEDURE citycount (IN country CHAR(3), OUT cities INT)\n       BEGIN\n         SELECT COUNT(*) INTO cities FROM world.city\n         WHERE CountryCode = country;\n       END//\nQuery OK, 0 rows affected (0.01 sec)\n\nmysql> delimiter ;\n\nmysql> CALL citycount(\'JPN\', @cities); -- cities in Japan\nQuery OK, 1 row affected (0.00 sec)\n\nmysql> SELECT @cities;\n+---------+\n| @cities |\n+---------+\n|     248 |\n+---------+\n1 row in set (0.00 sec)\n\nmysql> CALL citycount(\'FRA\', @cities); -- cities in France\nQuery OK, 1 row affected (0.00 sec)\n\nmysql> SELECT @cities;\n+---------+\n| @cities |\n+---------+\n|      40 |\n+---------+\n1 row in set (0.00 sec)\n\nThe example uses the mysql client delimiter command to change the\nstatement delimiter from ; to // while the procedure is being defined.\nThis enables the ; delimiter used in the procedure body to be passed\nthrough to the server rather than being interpreted by mysql itself.\nSee\nhttps://dev.mysql.com/doc/refman/8.0/en/stored-programs-defining.html.\n\nThe RETURNS clause may be specified only for a FUNCTION, for which it\nis mandatory. It indicates the return type of the function, and the\nfunction body must contain a RETURN value statement. If the RETURN\nstatement returns a value of a different type, the value is coerced to\nthe proper type. For example, if a function specifies an ENUM or SET\nvalue in the RETURNS clause, but the RETURN statement returns an\ninteger, the value returned from the function is the string for the\ncorresponding ENUM member of set of SET members.\n\nThe following example function takes a parameter, performs an operation\nusing an SQL function, and returns the result. In this case, it is\nunnecessary to use delimiter because the function definition contains\nno internal ; statement delimiters:\n\nmysql> CREATE FUNCTION hello (s CHAR(20))\nmysql> RETURNS CHAR(50) DETERMINISTIC\n       RETURN CONCAT(\'Hello, \',s,\'!\');\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> SELECT hello(\'world\');\n+----------------+\n| hello(\'world\') |\n+----------------+\n| Hello, world!  |\n+----------------+\n1 row in set (0.00 sec)\n\nParameter types and function return types can be declared to use any\nvalid data type. The COLLATE attribute can be used if preceded by a\nCHARACTER SET specification.\n\nThe routine_body consists of a valid SQL routine statement. This can be\na simple statement such as SELECT or INSERT, or a compound statement\nwritten using BEGIN and END. Compound statements can contain\ndeclarations, loops, and other control structure statements. The syntax\nfor these statements is described in\nhttps://dev.mysql.com/doc/refman/8.0/en/sql-compound-statements.html.\nIn practice, stored functions tend to use compound statements, unless\nthe body consists of a single RETURN statement.\n\nMySQL permits routines to contain DDL statements, such as CREATE and\nDROP. MySQL also permits stored procedures (but not stored functions)\nto contain SQL transaction statements such as COMMIT. Stored functions\nmay not contain statements that perform explicit or implicit commit or\nrollback. Support for these statements is not required by the SQL\nstandard, which states that each DBMS vendor may decide whether to\npermit them.\n\nStatements that return a result set can be used within a stored\nprocedure but not within a stored function. This prohibition includes\nSELECT statements that do not have an INTO var_list clause and other\nstatements such as SHOW, EXPLAIN, and CHECK TABLE. For statements that\ncan be determined at function definition time to return a result set, a\nNot allowed to return a result set from a function error occurs\n(ER_SP_NO_RETSET\n(https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference.html\n#error_er_sp_no_retset)). For statements that can be determined only\nat runtime to return a result set, a PROCEDURE %s can\'t return a result\nset in the given context error occurs (ER_SP_BADSELECT\n(https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference.html\n#error_er_sp_badselect)).\n\nUSE statements within stored routines are not permitted. When a routine\nis invoked, an implicit USE db_name is performed (and undone when the\nroutine terminates). The causes the routine to have the given default\ndatabase while it executes. References to objects in databases other\nthan the routine default database should be qualified with the\nappropriate database name.\n\nFor additional information about statements that are not permitted in\nstored routines, see\nhttps://dev.mysql.com/doc/refman/8.0/en/stored-program-restrictions.html\n.\n\nFor information about invoking stored procedures from within programs\nwritten in a language that has a MySQL interface, see [HELP CALL].\n\nMySQL stores the sql_mode system variable setting in effect when a\nroutine is created or altered, and always executes the routine with\nthis setting in force, regardless of the current server SQL mode when\nthe routine begins executing.\n\nThe switch from the SQL mode of the invoker to that of the routine\noccurs after evaluation of arguments and assignment of the resulting\nvalues to routine parameters. If you define a routine in strict SQL\nmode but invoke it in nonstrict mode, assignment of arguments to\nroutine parameters does not take place in strict mode. If you require\nthat expressions passed to a routine be assigned in strict SQL mode,\nyou should invoke the routine with strict mode in effect.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/create-procedure.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/create-procedure.html'),(520,'CREATE SERVER',40,'Syntax:\nCREATE SERVER server_name\n    FOREIGN DATA WRAPPER wrapper_name\n    OPTIONS (option [, option] ...)\n\noption: {\n    HOST character-literal\n  | DATABASE character-literal\n  | USER character-literal\n  | PASSWORD character-literal\n  | SOCKET character-literal\n  | OWNER character-literal\n  | PORT numeric-literal\n}\n\nThis statement creates the definition of a server for use with the\nFEDERATED storage engine. The CREATE SERVER statement creates a new row\nin the servers table in the mysql database. This statement requires the\nSUPER privilege.\n\nThe server_name should be a unique reference to the server. Server\ndefinitions are global within the scope of the server, it is not\npossible to qualify the server definition to a specific database.\nserver_name has a maximum length of 64 characters (names longer than 64\ncharacters are silently truncated), and is case-insensitive. You may\nspecify the name as a quoted string.\n\nThe wrapper_name is an identifier and may be quoted with single\nquotation marks.\n\nFor each option you must specify either a character literal or numeric\nliteral. Character literals are UTF-8, support a maximum length of 64\ncharacters and default to a blank (empty) string. String literals are\nsilently truncated to 64 characters. Numeric literals must be a number\nbetween 0 and 9999, default value is 0.\n\n*Note*:\n\nThe OWNER option is currently not applied, and has no effect on the\nownership or operation of the server connection that is created.\n\nThe CREATE SERVER statement creates an entry in the mysql.servers table\nthat can later be used with the CREATE TABLE statement when creating a\nFEDERATED table. The options that you specify are used to populate the\ncolumns in the mysql.servers table. The table columns are Server_name,\nHost, Db, Username, Password, Port and Socket.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/create-server.html\n\n','CREATE SERVER s\nFOREIGN DATA WRAPPER mysql\nOPTIONS (USER \'Remote\', HOST \'198.51.100.106\', DATABASE \'test\');\n','https://dev.mysql.com/doc/refman/8.0/en/create-server.html'),(521,'CREATE SPATIAL REFERENCE SYSTEM',40,'Syntax:\nCREATE OR REPLACE SPATIAL REFERENCE SYSTEM\n    srid srs_attribute ...\n\nCREATE SPATIAL REFERENCE SYSTEM\n    [IF NOT EXISTS]\n    srid srs_attribute ...\n\nsrs_attribute: {\n    NAME \'srs_name\'\n  | DEFINITION \'definition\'\n  | ORGANIZATION \'org_name\' IDENTIFIED BY org_id\n  | DESCRIPTION \'description\'\n}\n\nsrid, org_id: 32-bit unsigned integer\n\nThis statement creates a spatial reference system (SRS) definition and\nstores it in the data dictionary. It requires the SUPER privilege. The\nresulting data dictionary entry can be inspected using the\nINFORMATION_SCHEMA ST_SPATIAL_REFERENCE_SYSTEMS table.\n\nSRID values must be unique, so if neither OR REPLACE nor IF NOT EXISTS\nis specified, an error occurs if an SRS definition with the given srid\nvalue already exists.\n\nWith CREATE OR REPLACE syntax, any existing SRS definition with the\nsame SRID value is replaced, unless the SRID value is used by some\ncolumn in an existing table. In that case, an error occurs. For\nexample:\n\nmysql> CREATE OR REPLACE SPATIAL REFERENCE SYSTEM 4326 ...;\nERROR 3716 (SR005): Can\'t modify SRID 4326. There is at\nleast one column depending on it.\n\nTo identify which column or columns use the SRID, use this query,\nreplacing 4326 with the SRID of the definition you are trying to\ncreate:\n\nSELECT * FROM INFORMATION_SCHEMA.ST_GEOMETRY_COLUMNS WHERE SRS_ID=4326;\n\nWith CREATE ... IF NOT EXISTS syntax, any existing SRS definition with\nthe same SRID value causes the new definition to be ignored and a\nwarning occurs.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/create-spatial-reference-system.html\n\n','CREATE SPATIAL REFERENCE SYSTEM 4120\nNAME \'Greek\'\nORGANIZATION \'EPSG\' IDENTIFIED BY 4120\nDEFINITION\n  \'GEOGCS[\"Greek\",DATUM[\"Greek\",SPHEROID[\"Bessel 1841\",\n  6377397.155,299.1528128,AUTHORITY[\"EPSG\",\"7004\"]],\n  AUTHORITY[\"EPSG\",\"6120\"]],PRIMEM[\"Greenwich\",0,\n  AUTHORITY[\"EPSG\",\"8901\"]],UNIT[\"degree\",0.017453292519943278,\n  AUTHORITY[\"EPSG\",\"9122\"]],AXIS[\"Lat\",NORTH],AXIS[\"Lon\",EAST],\n  AUTHORITY[\"EPSG\",\"4120\"]]\';\n','https://dev.mysql.com/doc/refman/8.0/en/create-spatial-reference-system.html'),(522,'CREATE TABLE',40,'Syntax:\nCREATE [TEMPORARY] TABLE [IF NOT EXISTS] tbl_name\n    (create_definition,...)\n    [table_options]\n    [partition_options]\n\nCREATE [TEMPORARY] TABLE [IF NOT EXISTS] tbl_name\n    [(create_definition,...)]\n    [table_options]\n    [partition_options]\n    [IGNORE | REPLACE]\n    [AS] query_expression\n\nCREATE [TEMPORARY] TABLE [IF NOT EXISTS] tbl_name\n    { LIKE old_tbl_name | (LIKE old_tbl_name) }\n\ncreate_definition: {\n    col_name column_definition\n  | {INDEX | KEY} [index_name] [index_type] (key_part,...)\n      [index_option] ...\n  | {FULLTEXT | SPATIAL} [INDEX | KEY] [index_name] (key_part,...)\n      [index_option] ...\n  | [CONSTRAINT [symbol]] PRIMARY KEY\n      [index_type] (key_part,...)\n      [index_option] ...\n  | [CONSTRAINT [symbol]] UNIQUE [INDEX | KEY]\n      [index_name] [index_type] (key_part,...)\n      [index_option] ...\n  | [CONSTRAINT [symbol]] FOREIGN KEY\n      [index_name] (col_name,...)\n      reference_definition\n  | check_constraint_definition\n}\n\ncolumn_definition: {\n    data_type [NOT NULL | NULL] [DEFAULT {literal | (expr)} ]\n      [VISIBLE | INVISIBLE]\n      [AUTO_INCREMENT] [UNIQUE [KEY]] [[PRIMARY] KEY]\n      [COMMENT \'string\']\n      [COLLATE collation_name]\n      [COLUMN_FORMAT {FIXED | DYNAMIC | DEFAULT}]\n      [ENGINE_ATTRIBUTE [=] \'string\']\n      [SECONDARY_ENGINE_ATTRIBUTE [=] \'string\']\n      [STORAGE {DISK | MEMORY}]\n      [reference_definition]\n      [check_constraint_definition]\n  | data_type\n      [COLLATE collation_name]\n      [GENERATED ALWAYS] AS (expr)\n      [VIRTUAL | STORED] [NOT NULL | NULL]\n      [VISIBLE | INVISIBLE]\n      [UNIQUE [KEY]] [[PRIMARY] KEY]\n      [COMMENT \'string\']\n      [reference_definition]\n      [check_constraint_definition]\n}\n\ndata_type:\n    (see https://dev.mysql.com/doc/refman/8.0/en/data-types.html)\n\nkey_part: {col_name [(length)] | (expr)} [ASC | DESC]\n\nindex_type:\n    USING {BTREE | HASH}\n\nindex_option: {\n    KEY_BLOCK_SIZE [=] value\n  | index_type\n  | WITH PARSER parser_name\n  | COMMENT \'string\'\n  | {VISIBLE | INVISIBLE}\n  |ENGINE_ATTRIBUTE [=] \'string\'\n  |SECONDARY_ENGINE_ATTRIBUTE [=] \'string\'\n}\n\ncheck_constraint_definition:\n    [CONSTRAINT [symbol]] CHECK (expr) [[NOT] ENFORCED]\n\nreference_definition:\n    REFERENCES tbl_name (key_part,...)\n      [MATCH FULL | MATCH PARTIAL | MATCH SIMPLE]\n      [ON DELETE reference_option]\n      [ON UPDATE reference_option]\n\nreference_option:\n    RESTRICT | CASCADE | SET NULL | NO ACTION | SET DEFAULT\n\ntable_options:\n    table_option [[,] table_option] ...\n\ntable_option: {\n    AUTOEXTEND_SIZE [=] value\n  | AUTO_INCREMENT [=] value\n  | AVG_ROW_LENGTH [=] value\n  | [DEFAULT] CHARACTER SET [=] charset_name\n  | CHECKSUM [=] {0 | 1}\n  | [DEFAULT] COLLATE [=] collation_name\n  | COMMENT [=] \'string\'\n  | COMPRESSION [=] {\'ZLIB\' | \'LZ4\' | \'NONE\'}\n  | CONNECTION [=] \'connect_string\'\n  | {DATA | INDEX} DIRECTORY [=] \'absolute path to directory\'\n  | DELAY_KEY_WRITE [=] {0 | 1}\n  | ENCRYPTION [=] {\'Y\' | \'N\'}\n  | ENGINE [=] engine_name\n  | ENGINE_ATTRIBUTE [=] \'string\'\n  | INSERT_METHOD [=] { NO | FIRST | LAST }\n  | KEY_BLOCK_SIZE [=] value\n  | MAX_ROWS [=] value\n  | MIN_ROWS [=] value\n  | PACK_KEYS [=] {0 | 1 | DEFAULT}\n  | PASSWORD [=] \'string\'\n  | ROW_FORMAT [=] {DEFAULT | DYNAMIC | FIXED | COMPRESSED | REDUNDANT | COMPACT}\n  | START TRANSACTION \n  | SECONDARY_ENGINE_ATTRIBUTE [=] \'string\'\n  | STATS_AUTO_RECALC [=] {DEFAULT | 0 | 1}\n  | STATS_PERSISTENT [=] {DEFAULT | 0 | 1}\n  | STATS_SAMPLE_PAGES [=] value\n  | tablespace_option\n  | UNION [=] (tbl_name[,tbl_name]...)\n}\n\npartition_options:\n    PARTITION BY\n        { [LINEAR] HASH(expr)\n        | [LINEAR] KEY [ALGORITHM={1 | 2}] (column_list)\n        | RANGE{(expr) | COLUMNS(column_list)}\n        | LIST{(expr) | COLUMNS(column_list)} }\n    [PARTITIONS num]\n    [SUBPARTITION BY\n        { [LINEAR] HASH(expr)\n        | [LINEAR] KEY [ALGORITHM={1 | 2}] (column_list) }\n      [SUBPARTITIONS num]\n    ]\n    [(partition_definition [, partition_definition] ...)]\n\npartition_definition:\n    PARTITION partition_name\n        [VALUES\n            {LESS THAN {(expr | value_list) | MAXVALUE}\n            |\n            IN (value_list)}]\n        [[STORAGE] ENGINE [=] engine_name]\n        [COMMENT [=] \'string\' ]\n        [DATA DIRECTORY [=] \'data_dir\']\n        [INDEX DIRECTORY [=] \'index_dir\']\n        [MAX_ROWS [=] max_number_of_rows]\n        [MIN_ROWS [=] min_number_of_rows]\n        [TABLESPACE [=] tablespace_name]\n        [(subpartition_definition [, subpartition_definition] ...)]\n\nsubpartition_definition:\n    SUBPARTITION logical_name\n        [[STORAGE] ENGINE [=] engine_name]\n        [COMMENT [=] \'string\' ]\n        [DATA DIRECTORY [=] \'data_dir\']\n        [INDEX DIRECTORY [=] \'index_dir\']\n        [MAX_ROWS [=] max_number_of_rows]\n        [MIN_ROWS [=] min_number_of_rows]\n        [TABLESPACE [=] tablespace_name]\n\ntablespace_option:\n    TABLESPACE tablespace_name [STORAGE DISK]\n  | [TABLESPACE tablespace_name] STORAGE MEMORY\n\nquery_expression:\n    SELECT ...   (Some valid select or union statement)\n\nCREATE TABLE creates a table with the given name. You must have the\nCREATE privilege for the table.\n\nBy default, tables are created in the default database, using the\nInnoDB storage engine. An error occurs if the table exists, if there is\nno default database, or if the database does not exist.\n\nMySQL has no limit on the number of tables. The underlying file system\nmay have a limit on the number of files that represent tables.\nIndividual storage engines may impose engine-specific constraints.\nInnoDB permits up to 4 billion tables.\n\nFor information about the physical representation of a table, see\nhttps://dev.mysql.com/doc/refman/8.0/en/create-table-files.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/create-table.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/create-table.html'),(523,'FOREIGN KEY',40,'MySQL supports foreign keys, which permit cross-referencing related\ndata across tables, and foreign key constraints, which help keep the\nrelated data consistent.\n\nA foreign key relationship involves a parent table that holds the\ninitial column values, and a child table with column values that\nreference the parent column values. A foreign key constraint is defined\non the child table.\n\nThe essential syntax for a defining a foreign key constraint in a\nCREATE TABLE or ALTER TABLE statement includes the following:\n\n[CONSTRAINT [symbol]] FOREIGN KEY\n    [index_name] (col_name, ...)\n    REFERENCES tbl_name (col_name,...)\n    [ON DELETE reference_option]\n    [ON UPDATE reference_option]\n\nreference_option:\n    RESTRICT | CASCADE | SET NULL | NO ACTION | SET DEFAULT\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/create-table-foreign-keys.html\n\n','CREATE TABLE product (\n    category INT NOT NULL, id INT NOT NULL,\n    price DECIMAL,\n    PRIMARY KEY(category, id)\n)   ENGINE=INNODB;\n\nCREATE TABLE customer (\n    id INT NOT NULL,\n    PRIMARY KEY (id)\n)   ENGINE=INNODB;\n\nCREATE TABLE product_order (\n    no INT NOT NULL AUTO_INCREMENT,\n    product_category INT NOT NULL,\n    product_id INT NOT NULL,\n    customer_id INT NOT NULL,\n\n    PRIMARY KEY(no),\n    INDEX (product_category, product_id),\n    INDEX (customer_id),\n\n    FOREIGN KEY (product_category, product_id)\n      REFERENCES product(category, id)\n      ON UPDATE CASCADE ON DELETE RESTRICT,\n\n    FOREIGN KEY (customer_id)\n      REFERENCES customer(id)\n)   ENGINE=INNODB;\n','https://dev.mysql.com/doc/refman/8.0/en/create-table-foreign-keys.html'),(524,'CREATE TABLESPACE',40,'Syntax:\nCREATE [UNDO] TABLESPACE tablespace_name\n\n  InnoDB and NDB:\n    [ADD DATAFILE \'file_name\']\n    [AUTOEXTEND_SIZE [=] value]\n\n  InnoDB only:\n    [FILE_BLOCK_SIZE = value]\n    [ENCRYPTION [=] {\'Y\' | \'N\'}]\n\n  NDB only:\n    USE LOGFILE GROUP logfile_group\n    [EXTENT_SIZE [=] extent_size]\n    [INITIAL_SIZE [=] initial_size]\n    [MAX_SIZE [=] max_size]\n    [NODEGROUP [=] nodegroup_id]\n    [WAIT]\n    [COMMENT [=] \'string\']\n\n  InnoDB and NDB:\n    [ENGINE [=] engine_name]\n\n  Reserved for future use:\n    [ENGINE_ATTRIBUTE [=] \'string\']\n\nThis statement is used to create a tablespace. The precise syntax and\nsemantics depend on the storage engine used. In standard MySQL\nreleases, this is always an InnoDB tablespace. MySQL NDB Cluster also\nsupports tablespaces using the NDB storage engine.\n\no https://dev.mysql.com/doc/refman/8.0/en/create-tablespace.html#create\n  -tablespace-innodb\n\no https://dev.mysql.com/doc/refman/8.0/en/create-tablespace.html#create\n  -tablespace-ndb\n\no https://dev.mysql.com/doc/refman/8.0/en/create-tablespace.html#create\n  -tablespace-options\n\no https://dev.mysql.com/doc/refman/8.0/en/create-tablespace.html#create\n  -tablespace-notes\n\no https://dev.mysql.com/doc/refman/8.0/en/create-tablespace.html#create\n  -tablespace-innodb-examples\n\no https://dev.mysql.com/doc/refman/8.0/en/create-tablespace.html#create\n  -tablespace-ndb-examples\n\nConsiderations for InnoDB\n\nCREATE TABLESPACE syntax is used to create general tablespaces or undo\ntablespaces. The UNDO keyword, introduced in MySQL 8.0.14, must be\nspecified to create an undo tablespace.\n\nA general tablespace is a shared tablespace. It can hold multiple\ntables, and supports all table row formats. General tablespaces can be\ncreated in a location relative to or independent of the data directory.\n\nAfter creating an InnoDB general tablespace, use CREATE TABLE tbl_name\n... TABLESPACE [=] tablespace_name or ALTER TABLE tbl_name TABLESPACE\n[=] tablespace_name to add tables to the tablespace. For more\ninformation, see\nhttps://dev.mysql.com/doc/refman/8.0/en/general-tablespaces.html.\n\nUndo tablespaces contain undo logs. Undo tablespaces can be created in\na chosen location by specifying a fully qualified data file path. For\nmore information, see\nhttps://dev.mysql.com/doc/refman/8.0/en/innodb-undo-tablespaces.html.\n\nConsiderations for NDB Cluster\n\nThis statement is used to create a tablespace, which can contain one or\nmore data files, providing storage space for NDB Cluster Disk Data\ntables (see\nhttps://dev.mysql.com/doc/refman/8.0/en/mysql-cluster-disk-data.html).\nOne data file is created and added to the tablespace using this\nstatement. Additional data files may be added to the tablespace by\nusing the ALTER TABLESPACE statement (see [HELP ALTER TABLESPACE]).\n\n*Note*:\n\nAll NDB Cluster Disk Data objects share the same namespace. This means\nthat each Disk Data object must be uniquely named (and not merely each\nDisk Data object of a given type). For example, you cannot have a\ntablespace and a log file group with the same name, or a tablespace and\na data file with the same name.\n\nA log file group of one or more UNDO log files must be assigned to the\ntablespace to be created with the USE LOGFILE GROUP clause.\nlogfile_group must be an existing log file group created with CREATE\nLOGFILE GROUP (see [HELP CREATE LOGFILE GROUP]). Multiple tablespaces\nmay use the same log file group for UNDO logging.\n\nWhen setting EXTENT_SIZE or INITIAL_SIZE, you may optionally follow the\nnumber with a one-letter abbreviation for an order of magnitude,\nsimilar to those used in my.cnf. Generally, this is one of the letters\nM (for megabytes) or G (for gigabytes).\n\nINITIAL_SIZE and EXTENT_SIZE are subject to rounding as follows:\n\no EXTENT_SIZE is rounded up to the nearest whole multiple of 32K.\n\no INITIAL_SIZE is rounded down to the nearest whole multiple of 32K;\n  this result is rounded up to the nearest whole multiple of\n  EXTENT_SIZE (after any rounding).\n\n*Note*:\n\nNDB reserves 4% of a tablespace for data node restart operations. This\nreserved space cannot be used for data storage.\n\nThe rounding just described is done explicitly, and a warning is issued\nby the MySQL Server when any such rounding is performed. The rounded\nvalues are also used by the NDB kernel for calculating\nINFORMATION_SCHEMA.FILES column values and other purposes. However, to\navoid an unexpected result, we suggest that you always use whole\nmultiples of 32K in specifying these options.\n\nWhen CREATE TABLESPACE is used with ENGINE [=] NDB, a tablespace and\nassociated data file are created on each Cluster data node. You can\nverify that the data files were created and obtain information about\nthem by querying the Information Schema FILES table. (See the example\nlater in this section.)\n\n(See\nhttps://dev.mysql.com/doc/refman/8.0/en/information-schema-files-table.\nhtml.)\n\nOptions\n\no ADD DATAFILE: Defines the name of a tablespace data file. This option\n  is always required when creating an NDB tablespace; for InnoDB in\n  MySQL 8.0.14 and later, it is required only when creating an undo\n  tablespace. The file_name, including any specified path, must be\n  quoted with single or double quotation marks. File names (not\n  counting the file extension) and directory names must be at least one\n  byte in length. Zero length file names and directory names are not\n  supported.\n\n  Because there are considerable differences in how InnoDB and NDB\n  treat data files, the two storage engines are covered separately in\n  the discussion that follows.\n\n  InnoDB data files An InnoDB tablespace supports only a single data\n  file, whose name must include a .ibd extension.\n\n  To place an InnoDB general tablespace data file in a location outside\n  of the data directory, include a fully qualified path or a path\n  relative to the data directory. Only a fully qualified path is\n  permitted for undo tablespaces. If you do not specify a path, a\n  general tablespace is created in the data directory. An undo\n  tablespace created without specifying a path is created in the\n  directory defined by the innodb_undo_directory variable. If the\n  innodb_undo_directory variable is undefined, undo tablespaces are\n  created in the data directory.\n\n  To avoid conflicts with implicitly created file-per-table\n  tablespaces, creating an InnoDB general tablespace in a subdirectory\n  under the data directory is not supported. When creating a general\n  tablespace or undo tablespace outside of the data directory, the\n  directory must exist and must be known to InnoDB prior to creating\n  the tablespace. To make a directory known to InnoDB, add it to the\n  innodb_directories value or to one of the variables whose values are\n  appended to the innodb_directories value. innodb_directories is a\n  read-only variable. Configuring it requires restarting the server.\n\n  If the ADD DATAFILE clause is not specified when creating an InnoDB\n  tablespace, a tablespace data file with a unique file name is created\n  implicitly. The unique file name is a 128 bit UUID formatted into\n  five groups of hexadecimal numbers separated by dashes\n  (aaaaaaaa-bbbb-cccc-dddd-eeeeeeeeeeee). A file extension is added if\n  required by the storage engine. An .ibd file extension is added for\n  InnoDB general tablespace data files. In a replication environment,\n  the data file name created on the replication source server is not\n  the same as the data file name created on the replica.\n\n  As of MySQL 8.0.17, the ADD DATAFILE clause does not permit circular\n  directory references when creating an InnoDB tablespace. For example,\n  the circular directory reference (/../) in the following statement is\n  not permitted:\n\nCREATE TABLESPACE ts1 ADD DATAFILE ts1.ibd \'any_directory/../ts1.ibd\';\n\n  An exception to this restriction exists on Linux, where a circular\n  directory reference is permitted if the preceding directory is a\n  symbolic link. For example, the data file path in the example above\n  is permitted if any_directory is a symbolic link. (It is still\n  permitted for data file paths to begin with \'../\'.)\n\n  NDB data files An NDB tablespace supports multiple data files which\n  can have any legal file names; more data files can be added to an NDB\n  Cluster tablespace following its creation by using an ALTER\n  TABLESPACE statement.\n\n  An NDB tablespace data file is created by default in the data node\n  file system directory---that is, the directory named ndb_nodeid_fs/TS\n  under the data node\'s data directory (DataDir), where nodeid is the\n  data node\'s NodeId. To place the data file in a location other than\n  the default, include an absolute directory path or a path relative to\n  the default location. If the directory specified does not exist, NDB\n  attempts to create it; the system user account under which the data\n  node process is running must have the appropriate permissions to do\n  so.\n\n  *Note*:\n\n  When determining the path used for a data file, NDB does not expand\n  the ~ (tilde) character.\n\n  When multiple data nodes are run on the same physical host, the\n  following considerations apply:\n\n  o You cannot specify an absolute path when creating a data file.\n\n  o It is not possible to create tablespace data files outside the data\n    node file system directory, unless each data node has a separate\n    data directory.\n\n  o If each data node has its own data directory, data files can be\n    created anywhere within this directory.\n\n  o If each data node has its own data directory, it may also be\n    possible to create a data file outside the node\'s data directory\n    using a relative path, as long as this path resolves to a unique\n    location on the host file system for each data node running on that\n    host.\n\no FILE_BLOCK_SIZE: This option---which is specific to InnoDB general\n  tablespaces, and is ignored by NDB---defines the block size for the\n  tablespace data file. Values can be specified in bytes or kilobytes.\n  For example, an 8 kilobyte file block size can be specified as 8192\n  or 8K. If you do not specify this option, FILE_BLOCK_SIZE defaults to\n  the innodb_page_size value. FILE_BLOCK_SIZE is required when you\n  intend to use the tablespace for storing compressed InnoDB tables\n  (ROW_FORMAT=COMPRESSED). In this case, you must define the tablespace\n  FILE_BLOCK_SIZE when creating the tablespace.\n\n  If FILE_BLOCK_SIZE is equal the innodb_page_size value, the\n  tablespace can contain only tables having an uncompressed row format\n  (COMPACT, REDUNDANT, and DYNAMIC). Tables with a COMPRESSED row\n  format have a different physical page size than uncompressed tables.\n  Therefore, compressed tables cannot coexist in the same tablespace as\n  uncompressed tables.\n\n  For a general tablespace to contain compressed tables,\n  FILE_BLOCK_SIZE must be specified, and the FILE_BLOCK_SIZE value must\n  be a valid compressed page size in relation to the innodb_page_size\n  value. Also, the physical page size of the compressed table\n  (KEY_BLOCK_SIZE) must be equal to FILE_BLOCK_SIZE/1024. For example,\n  if innodb_page_size=16K, and FILE_BLOCK_SIZE=8K, the KEY_BLOCK_SIZE\n  of the table must be 8. For more information, see\n  https://dev.mysql.com/doc/refman/8.0/en/general-tablespaces.html.\n\no USE LOGFILE GROUP: Required for NDB, this is the name of a log file\n  group previously created using CREATE LOGFILE GROUP. Not supported\n  for InnoDB, where it fails with an error.\n\no EXTENT_SIZE: This option is specific to NDB, and is not supported by\n  InnoDB, where it fails with an error. EXTENT_SIZE sets the size, in\n  bytes, of the extents used by any files belonging to the tablespace.\n  The default value is 1M. The minimum size is 32K, and theoretical\n  maximum is 2G, although the practical maximum size depends on a\n  number of factors. In most cases, changing the extent size does not\n  have any measurable effect on performance, and the default value is\n  recommended for all but the most unusual situations.\n\n  An extent is a unit of disk space allocation. One extent is filled\n  with as much data as that extent can contain before another extent is\n  used. In theory, up to 65,535 (64K) extents may used per data file;\n  however, the recommended maximum is 32,768 (32K). The recommended\n  maximum size for a single data file is 32G---that is, 32K extents x 1\n  MB per extent. In addition, once an extent is allocated to a given\n  partition, it cannot be used to store data from a different\n  partition; an extent cannot store data from more than one partition.\n  This means, for example that a tablespace having a single datafile\n  whose INITIAL_SIZE (described in the following item) is 256 MB and\n  whose EXTENT_SIZE is 128M has just two extents, and so can be used to\n  store data from at most two different disk data table partitions.\n\n  You can see how many extents remain free in a given data file by\n  querying the Information Schema FILES table, and so derive an\n  estimate for how much space remains free in the file. For further\n  discussion and examples, see\n  https://dev.mysql.com/doc/refman/8.0/en/information-schema-files-tabl\n  e.html.\n\no INITIAL_SIZE: This option is specific to NDB, and is not supported by\n  InnoDB, where it fails with an error.\n\n  The INITIAL_SIZE parameter sets the total size in bytes of the data\n  file that was specific using ADD DATATFILE. Once this file has been\n  created, its size cannot be changed; however, you can add more data\n  files to the tablespace using ALTER TABLESPACE ... ADD DATAFILE.\n\n  INITIAL_SIZE is optional; its default value is 134217728 (128 MB).\n\n  On 32-bit systems, the maximum supported value for INITIAL_SIZE is\n  4294967296 (4 GB).\n\no AUTOEXTEND_SIZE: Ignored by MySQL prior to MySQL 8.0.23; From MySQL\n  8.0.23, defines the amount by which InnoDB extends the size of the\n  tablespace when it becomes full. The setting must be a multiple of\n  4MB. The default setting is 0, which causes the tablespace to be\n  extended according to the implicit default behavior. For more\n  information, see\n  https://dev.mysql.com/doc/refman/8.0/en/innodb-tablespace-autoextend-\n  size.html.\n\n  Has no effect in any release of MySQL NDB Cluster 8.0, regardless of\n  the storage engine used.\n\no MAX_SIZE: Currently ignored by MySQL; reserved for possible future\n  use. Has no effect in any release of MySQL 8.0 or MySQL NDB Cluster\n  8.0, regardless of the storage engine used.\n\no NODEGROUP: Currently ignored by MySQL; reserved for possible future\n  use. Has no effect in any release of MySQL 8.0 or MySQL NDB Cluster\n  8.0, regardless of the storage engine used.\n\no WAIT: Currently ignored by MySQL; reserved for possible future use.\n  Has no effect in any release of MySQL 8.0 or MySQL NDB Cluster 8.0,\n  regardless of the storage engine used.\n\no COMMENT: Currently ignored by MySQL; reserved for possible future\n  use. Has no effect in any release of MySQL 8.0 or MySQL NDB Cluster\n  8.0, regardless of the storage engine used.\n\no The ENCRYPTION clause enables or disables page-level data encryption\n  for an InnoDB general tablespace. Encryption support for general\n  tablespaces was introduced in MySQL 8.0.13.\n\n  As of MySQL 8.0.16, if the ENCRYPTION clause is not specified, the\n  default_table_encryption setting controls whether encryption is\n  enabled. The ENCRYPTION clause overrides the default_table_encryption\n  setting. However, if the table_encryption_privilege_check variable is\n  enabled, the TABLE_ENCRYPTION_ADMIN privilege is required to use an\n  ENCRYPTION clause setting that differs from the\n  default_table_encryption setting.\n\n  A keyring plugin must be installed and configured before an\n  encryption-enabled tablespace can be created.\n\n  When a general tablespace is encrypted, all tables residing in the\n  tablespace are encrypted. Likewise, a table created in an encrypted\n  tablespace is encrypted.\n\n  For more information, see\n  https://dev.mysql.com/doc/refman/8.0/en/innodb-data-encryption.html\n\no ENGINE: Defines the storage engine which uses the tablespace, where\n  engine_name is the name of the storage engine. Currently, only the\n  InnoDB storage engine is supported by standard MySQL 8.0 releases.\n  MySQL NDB Cluster supports both NDB and InnoDB tablespaces. The value\n  of the default_storage_engine system variable is used for ENGINE if\n  the option is not specified.\n\no The ENGINE_ATTRIBUTE option (available as of MySQL 8.0.21) is used to\n  specify tablespace attributes for primary storage engines. The option\n  is reserved for future use.\n\n  Permitted values are a string literal containing a valid JSON\n  document or an empty string (\'\'). Invalid JSON is rejected.\n\nCREATE TABLESPACE ts1 ENGINE_ATTRIBUTE=\'{\"key\":\"value\"}\';\n\n  ENGINE_ATTRIBUTE values can be repeated without error. In this case,\n  the last specified value is used.\n\n  ENGINE_ATTRIBUTE values are not checked by the server, nor are they\n  cleared when the table\'s storage engine is changed.\n\nNotes\n\no For the rules covering the naming of MySQL tablespaces, see\n  https://dev.mysql.com/doc/refman/8.0/en/identifiers.html. In addition\n  to these rules, the slash character (\"/\") is not permitted, nor can\n  you use names beginning with innodb_, as this prefix is reserved for\n  system use.\n\no Creation of temporary general tablespaces is not supported.\n\no General tablespaces do not support temporary tables.\n\no The TABLESPACE option may be used with CREATE TABLE or ALTER TABLE to\n  assign an InnoDB table partition or subpartition to a file-per-table\n  tablespace. All partitions must belong to the same storage engine.\n  Assigning table partitions to shared InnoDB tablespaces is not\n  supported. Shared tablespaces include the InnoDB system tablespace\n  and general tablespaces.\n\no General tablespaces support the addition of tables of any row format\n  using CREATE TABLE ... TABLESPACE. innodb_file_per_table does not\n  need to be enabled.\n\no innodb_strict_mode is not applicable to general tablespaces.\n  Tablespace management rules are strictly enforced independently of\n  innodb_strict_mode. If CREATE TABLESPACE parameters are incorrect or\n  incompatible, the operation fails regardless of the\n  innodb_strict_mode setting. When a table is added to a general\n  tablespace using CREATE TABLE ... TABLESPACE or ALTER TABLE ...\n  TABLESPACE, innodb_strict_mode is ignored but the statement is\n  evaluated as if innodb_strict_mode is enabled.\n\no Use DROP TABLESPACE to remove a tablespace. All tables must be\n  dropped from a tablespace using DROP TABLE prior to dropping the\n  tablespace. Before dropping an NDB Cluster tablespace you must also\n  remove all its data files using one or more ALTER TABLESPACE ... DROP\n  DATATFILE statements. See\n  https://dev.mysql.com/doc/refman/8.0/en/mysql-cluster-disk-data-objec\n  ts.html.\n\no All parts of an InnoDB table added to an InnoDB general tablespace\n  reside in the general tablespace, including indexes and BLOB pages.\n\n  For an NDB table assigned to a tablespace, only those columns which\n  are not indexed are stored on disk, and actually use the tablespace\n  data files. Indexes and indexed columns for all NDB tables are always\n  kept in memory.\n\no Similar to the system tablespace, truncating or dropping tables\n  stored in a general tablespace creates free space internally in the\n  general tablespace .ibd data file which can only be used for new\n  InnoDB data. Space is not released back to the operating system as it\n  is for file-per-table tablespaces.\n\no A general tablespace is not associated with any database or schema.\n\no ALTER TABLE ... DISCARD TABLESPACE and ALTER TABLE ...IMPORT\n  TABLESPACE are not supported for tables that belong to a general\n  tablespace.\n\no The server uses tablespace-level metadata locking for DDL that\n  references general tablespaces. By comparison, the server uses\n  table-level metadata locking for DDL that references file-per-table\n  tablespaces.\n\no A generated or existing tablespace cannot be changed to a general\n  tablespace.\n\no There is no conflict between general tablespace names and\n  file-per-table tablespace names. The \"/\" character, which is present\n  in file-per-table tablespace names, is not permitted in general\n  tablespace names.\n\no mysqldump and mysqlpump do not dump InnoDB CREATE TABLESPACE\n  statements.\n\nInnoDB Examples\n\nThis example demonstrates creating a general tablespace and adding\nthree uncompressed tables of different row formats.\n\nmysql> CREATE TABLESPACE `ts1` ADD DATAFILE \'ts1.ibd\' ENGINE=INNODB;\n\nmysql> CREATE TABLE t1 (c1 INT PRIMARY KEY) TABLESPACE ts1 ROW_FORMAT=REDUNDANT;\n\nmysql> CREATE TABLE t2 (c1 INT PRIMARY KEY) TABLESPACE ts1 ROW_FORMAT=COMPACT;\n\nmysql> CREATE TABLE t3 (c1 INT PRIMARY KEY) TABLESPACE ts1 ROW_FORMAT=DYNAMIC;\n\nThis example demonstrates creating a general tablespace and adding a\ncompressed table. The example assumes a default innodb_page_size value\nof 16K. The FILE_BLOCK_SIZE of 8192 requires that the compressed table\nhave a KEY_BLOCK_SIZE of 8.\n\nmysql> CREATE TABLESPACE `ts2` ADD DATAFILE \'ts2.ibd\' FILE_BLOCK_SIZE = 8192 Engine=InnoDB;\n\nmysql> CREATE TABLE t4 (c1 INT PRIMARY KEY) TABLESPACE ts2 ROW_FORMAT=COMPRESSED KEY_BLOCK_SIZE=8;\n\nThis example demonstrates creating a general tablespace without\nspecifying the ADD DATAFILE clause, which is optional as of MySQL\n8.0.14.\n\nmysql> CREATE TABLESPACE `ts3` ENGINE=INNODB;\n\nThis example demonstrates creating an undo tablespace.\n\nmysql> CREATE UNDO TABLESPACE undo_003 ADD DATAFILE \'undo_003.ibu\';\n\nNDB Example\n\nSuppose that you wish to create an NDB Cluster Disk Data tablespace\nnamed myts using a datafile named mydata-1.dat. An NDB tablespace\nalways requires the use of a log file group consisting of one or more\nundo log files. For this example, we first create a log file group\nnamed mylg that contains one undo long file named myundo-1.dat, using\nthe CREATE LOGFILE GROUP statement shown here:\n\nmysql> CREATE LOGFILE GROUP myg1\n    ->     ADD UNDOFILE \'myundo-1.dat\'\n    ->     ENGINE=NDB;\nQuery OK, 0 rows affected (3.29 sec)\n\nNow you can create the tablespace previously described using the\nfollowing statement:\n\nmysql> CREATE TABLESPACE myts\n    ->     ADD DATAFILE \'mydata-1.dat\'\n    ->     USE LOGFILE GROUP mylg\n    ->     ENGINE=NDB;\nQuery OK, 0 rows affected (2.98 sec)\n\nYou can now create a Disk Data table using a CREATE TABLE statement\nwith the TABLESPACE and STORAGE DISK options, similar to what is shown\nhere:\n\nmysql> CREATE TABLE mytable (\n    ->     id INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,\n    ->     lname VARCHAR(50) NOT NULL,\n    ->     fname VARCHAR(50) NOT NULL,\n    ->     dob DATE NOT NULL,\n    ->     joined DATE NOT NULL,\n    ->     INDEX(last_name, first_name)\n    -> )\n    ->     TABLESPACE myts STORAGE DISK\n    ->     ENGINE=NDB;\nQuery OK, 0 rows affected (1.41 sec)\n\nIt is important to note that only the dob and joined columns from\nmytable are actually stored on disk, due to the fact that the id,\nlname, and fname columns are all indexed.\n\nAs mentioned previously, when CREATE TABLESPACE is used with ENGINE [=]\nNDB, a tablespace and associated data file are created on each NDB\nCluster data node. You can verify that the data files were created and\nobtain information about them by querying the Information Schema FILES\ntable, as shown here:\n\nmysql> SELECT FILE_NAME, FILE_TYPE, LOGFILE_GROUP_NAME, STATUS, EXTRA\n    ->     FROM INFORMATION_SCHEMA.FILES\n    ->     WHERE TABLESPACE_NAME = \'myts\';\n\n+--------------+------------+--------------------+--------+----------------+\n| file_name    | file_type  | logfile_group_name | status | extra          |\n+--------------+------------+--------------------+--------+----------------+\n| mydata-1.dat | DATAFILE   | mylg               | NORMAL | CLUSTER_NODE=5 |\n| mydata-1.dat | DATAFILE   | mylg               | NORMAL | CLUSTER_NODE=6 |\n| NULL         | TABLESPACE | mylg               | NORMAL | NULL           |\n+--------------+------------+--------------------+--------+----------------+\n3 rows in set (0.01 sec)\n\nFor additional information and examples, see\nhttps://dev.mysql.com/doc/refman/8.0/en/mysql-cluster-disk-data-objects\n.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/create-tablespace.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/create-tablespace.html'),(525,'CREATE TRIGGER',40,'Syntax:\nCREATE\n    [DEFINER = user]\n    TRIGGER [IF NOT EXISTS] trigger_name\n    trigger_time trigger_event\n    ON tbl_name FOR EACH ROW\n    [trigger_order]\n    trigger_body\n\ntrigger_time: { BEFORE | AFTER }\n\ntrigger_event: { INSERT | UPDATE | DELETE }\n\ntrigger_order: { FOLLOWS | PRECEDES } other_trigger_name\n\nThis statement creates a new trigger. A trigger is a named database\nobject that is associated with a table, and that activates when a\nparticular event occurs for the table. The trigger becomes associated\nwith the table named tbl_name, which must refer to a permanent table.\nYou cannot associate a trigger with a TEMPORARY table or a view.\n\nTrigger names exist in the schema namespace, meaning that all triggers\nmust have unique names within a schema. Triggers in different schemas\ncan have the same name.\n\nIF NOT EXISTS prevents an error from occurring if a trigger having the\nsame name, on the same table, exists in the same schema. This option is\nsupported with CREATE TRIGGER beginning with MySQL 8.0.29.\n\nThis section describes CREATE TRIGGER syntax. For additional\ndiscussion, see\nhttps://dev.mysql.com/doc/refman/8.0/en/trigger-syntax.html.\n\nCREATE TRIGGER requires the TRIGGER privilege for the table associated\nwith the trigger. If the DEFINER clause is present, the privileges\nrequired depend on the user value, as discussed in\nhttps://dev.mysql.com/doc/refman/8.0/en/stored-objects-security.html.\nIf binary logging is enabled, CREATE TRIGGER might require the SUPER\nprivilege, as discussed in\nhttps://dev.mysql.com/doc/refman/8.0/en/stored-programs-logging.html.\n\nThe DEFINER clause determines the security context to be used when\nchecking access privileges at trigger activation time, as described\nlater in this section.\n\ntrigger_time is the trigger action time. It can be BEFORE or AFTER to\nindicate that the trigger activates before or after each row to be\nmodified.\n\nBasic column value checks occur prior to trigger activation, so you\ncannot use BEFORE triggers to convert values inappropriate for the\ncolumn type to valid values.\n\ntrigger_event indicates the kind of operation that activates the\ntrigger. These trigger_event values are permitted:\n\no INSERT: The trigger activates whenever a new row is inserted into the\n  table (for example, through INSERT, LOAD DATA, and REPLACE\n  statements).\n\no UPDATE: The trigger activates whenever a row is modified (for\n  example, through UPDATE statements).\n\no DELETE: The trigger activates whenever a row is deleted from the\n  table (for example, through DELETE and REPLACE statements). DROP\n  TABLE and TRUNCATE TABLE statements on the table do not activate this\n  trigger, because they do not use DELETE. Dropping a partition does\n  not activate DELETE triggers, either.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/create-trigger.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/create-trigger.html'),(526,'CREATE VIEW',40,'Syntax:\nCREATE\n    [OR REPLACE]\n    [ALGORITHM = {UNDEFINED | MERGE | TEMPTABLE}]\n    [DEFINER = user]\n    [SQL SECURITY { DEFINER | INVOKER }]\n    VIEW view_name [(column_list)]\n    AS select_statement\n    [WITH [CASCADED | LOCAL] CHECK OPTION]\n\nThe CREATE VIEW statement creates a new view, or replaces an existing\nview if the OR REPLACE clause is given. If the view does not exist,\nCREATE OR REPLACE VIEW is the same as CREATE VIEW. If the view does\nexist, CREATE OR REPLACE VIEW replaces it.\n\nFor information about restrictions on view use, see\nhttps://dev.mysql.com/doc/refman/8.0/en/view-restrictions.html.\n\nThe select_statement is a SELECT statement that provides the definition\nof the view. (Selecting from the view selects, in effect, using the\nSELECT statement.) The select_statement can select from base tables,\nother views. Beginning with MySQL 8.0.19, the SELECT statement can use\na VALUES statement as its source, or can be replaced with a TABLE\nstatement, as with CREATE TABLE ... SELECT.\n\nThe view definition is \"frozen\" at creation time and is not affected by\nsubsequent changes to the definitions of the underlying tables. For\nexample, if a view is defined as SELECT * on a table, new columns added\nto the table later do not become part of the view, and columns dropped\nfrom the table result in an error when selecting from the view.\n\nThe ALGORITHM clause affects how MySQL processes the view. The DEFINER\nand SQL SECURITY clauses specify the security context to be used when\nchecking access privileges at view invocation time. The WITH CHECK\nOPTION clause can be given to constrain inserts or updates to rows in\ntables referenced by the view. These clauses are described later in\nthis section.\n\nThe CREATE VIEW statement requires the CREATE VIEW privilege for the\nview, and some privilege for each column selected by the SELECT\nstatement. For columns used elsewhere in the SELECT statement, you must\nhave the SELECT privilege. If the OR REPLACE clause is present, you\nmust also have the DROP privilege for the view. If the DEFINER clause\nis present, the privileges required depend on the user value, as\ndiscussed in\nhttps://dev.mysql.com/doc/refman/8.0/en/stored-objects-security.html.\n\nWhen a view is referenced, privilege checking occurs as described later\nin this section.\n\nA view belongs to a database. By default, a new view is created in the\ndefault database. To create the view explicitly in a given database,\nuse db_name.view_name syntax to qualify the view name with the database\nname:\n\nCREATE VIEW test.v AS SELECT * FROM t;\n\nUnqualified table or view names in the SELECT statement are also\ninterpreted with respect to the default database. A view can refer to\ntables or views in other databases by qualifying the table or view name\nwith the appropriate database name.\n\nWithin a database, base tables and views share the same namespace, so a\nbase table and a view cannot have the same name.\n\nColumns retrieved by the SELECT statement can be simple references to\ntable columns, or expressions that use functions, constant values,\noperators, and so forth.\n\nA view must have unique column names with no duplicates, just like a\nbase table. By default, the names of the columns retrieved by the\nSELECT statement are used for the view column names. To define explicit\nnames for the view columns, specify the optional column_list clause as\na list of comma-separated identifiers. The number of names in\ncolumn_list must be the same as the number of columns retrieved by the\nSELECT statement.\n\nA view can be created from many kinds of SELECT statements. It can\nrefer to base tables or other views. It can use joins, UNION, and\nsubqueries. The SELECT need not even refer to any tables:\n\nCREATE VIEW v_today (today) AS SELECT CURRENT_DATE;\n\nThe following example defines a view that selects two columns from\nanother table as well as an expression calculated from those columns:\n\nmysql> CREATE TABLE t (qty INT, price INT);\nmysql> INSERT INTO t VALUES(3, 50);\nmysql> CREATE VIEW v AS SELECT qty, price, qty*price AS value FROM t;\nmysql> SELECT * FROM v;\n+------+-------+-------+\n| qty  | price | value |\n+------+-------+-------+\n|    3 |    50 |   150 |\n+------+-------+-------+\n\nA view definition is subject to the following restrictions:\n\no The SELECT statement cannot refer to system variables or user-defined\n  variables.\n\no Within a stored program, the SELECT statement cannot refer to program\n  parameters or local variables.\n\no The SELECT statement cannot refer to prepared statement parameters.\n\no Any table or view referred to in the definition must exist. If, after\n  the view has been created, a table or view that the definition refers\n  to is dropped, use of the view results in an error. To check a view\n  definition for problems of this kind, use the CHECK TABLE statement.\n\no The definition cannot refer to a TEMPORARY table, and you cannot\n  create a TEMPORARY view.\n\no You cannot associate a trigger with a view.\n\no Aliases for column names in the SELECT statement are checked against\n  the maximum column length of 64 characters (not the maximum alias\n  length of 256 characters).\n\nORDER BY is permitted in a view definition, but it is ignored if you\nselect from a view using a statement that has its own ORDER BY.\n\nFor other options or clauses in the definition, they are added to the\noptions or clauses of the statement that references the view, but the\neffect is undefined. For example, if a view definition includes a LIMIT\nclause, and you select from the view using a statement that has its own\nLIMIT clause, it is undefined which limit applies. This same principle\napplies to options such as ALL, DISTINCT, or SQL_SMALL_RESULT that\nfollow the SELECT keyword, and to clauses such as INTO, FOR UPDATE, FOR\nSHARE, LOCK IN SHARE MODE, and PROCEDURE.\n\nThe results obtained from a view may be affected if you change the\nquery processing environment by changing system variables:\n\nmysql> CREATE VIEW v (mycol) AS SELECT \'abc\';\nQuery OK, 0 rows affected (0.01 sec)\n\nmysql> SET sql_mode = \'\';\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> SELECT \"mycol\" FROM v;\n+-------+\n| mycol |\n+-------+\n| mycol |\n+-------+\n1 row in set (0.01 sec)\n\nmysql> SET sql_mode = \'ANSI_QUOTES\';\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> SELECT \"mycol\" FROM v;\n+-------+\n| mycol |\n+-------+\n| abc   |\n+-------+\n1 row in set (0.00 sec)\n\nThe DEFINER and SQL SECURITY clauses determine which MySQL account to\nuse when checking access privileges for the view when a statement is\nexecuted that references the view. The valid SQL SECURITY\ncharacteristic values are DEFINER (the default) and INVOKER. These\nindicate that the required privileges must be held by the user who\ndefined or invoked the view, respectively.\n\nIf the DEFINER clause is present, the user value should be a MySQL\naccount specified as \'user_name\'@\'host_name\', CURRENT_USER, or\nCURRENT_USER(). The permitted user values depend on the privileges you\nhold, as discussed in\nhttps://dev.mysql.com/doc/refman/8.0/en/stored-objects-security.html.\nAlso see that section for additional information about view security.\n\nIf the DEFINER clause is omitted, the default definer is the user who\nexecutes the CREATE VIEW statement. This is the same as specifying\nDEFINER = CURRENT_USER explicitly.\n\nWithin a view definition, the CURRENT_USER function returns the view\'s\nDEFINER value by default. For views defined with the SQL SECURITY\nINVOKER characteristic, CURRENT_USER returns the account for the view\'s\ninvoker. For information about user auditing within views, see\nhttps://dev.mysql.com/doc/refman/8.0/en/account-activity-auditing.html.\n\nWithin a stored routine that is defined with the SQL SECURITY DEFINER\ncharacteristic, CURRENT_USER returns the routine\'s DEFINER value. This\nalso affects a view defined within such a routine, if the view\ndefinition contains a DEFINER value of CURRENT_USER.\n\nMySQL checks view privileges like this:\n\no At view definition time, the view creator must have the privileges\n  needed to use the top-level objects accessed by the view. For\n  example, if the view definition refers to table columns, the creator\n  must have some privilege for each column in the select list of the\n  definition, and the SELECT privilege for each column used elsewhere\n  in the definition. If the definition refers to a stored function,\n  only the privileges needed to invoke the function can be checked. The\n  privileges required at function invocation time can be checked only\n  as it executes: For different invocations, different execution paths\n  within the function might be taken.\n\no The user who references a view must have appropriate privileges to\n  access it (SELECT to select from it, INSERT to insert into it, and so\n  forth.)\n\no When a view has been referenced, privileges for objects accessed by\n  the view are checked against the privileges held by the view DEFINER\n  account or invoker, depending on whether the SQL SECURITY\n  characteristic is DEFINER or INVOKER, respectively.\n\no If reference to a view causes execution of a stored function,\n  privilege checking for statements executed within the function depend\n  on whether the function SQL SECURITY characteristic is DEFINER or\n  INVOKER. If the security characteristic is DEFINER, the function runs\n  with the privileges of the DEFINER account. If the characteristic is\n  INVOKER, the function runs with the privileges determined by the\n  view\'s SQL SECURITY characteristic.\n\nExample: A view might depend on a stored function, and that function\nmight invoke other stored routines. For example, the following view\ninvokes a stored function f():\n\nCREATE VIEW v AS SELECT * FROM t WHERE t.id = f(t.name);\n\nSuppose that f() contains a statement such as this:\n\nIF name IS NULL then\n  CALL p1();\nELSE\n  CALL p2();\nEND IF;\n\nThe privileges required for executing statements within f() need to be\nchecked when f() executes. This might mean that privileges are needed\nfor p1() or p2(), depending on the execution path within f(). Those\nprivileges must be checked at runtime, and the user who must possess\nthe privileges is determined by the SQL SECURITY values of the view v\nand the function f().\n\nThe DEFINER and SQL SECURITY clauses for views are extensions to\nstandard SQL. In standard SQL, views are handled using the rules for\nSQL SECURITY DEFINER. The standard says that the definer of the view,\nwhich is the same as the owner of the view\'s schema, gets applicable\nprivileges on the view (for example, SELECT) and may grant them. MySQL\nhas no concept of a schema \"owner\", so MySQL adds a clause to identify\nthe definer. The DEFINER clause is an extension where the intent is to\nhave what the standard has; that is, a permanent record of who defined\nthe view. This is why the default DEFINER value is the account of the\nview creator.\n\nThe optional ALGORITHM clause is a MySQL extension to standard SQL. It\naffects how MySQL processes the view. ALGORITHM takes three values:\nMERGE, TEMPTABLE, or UNDEFINED. For more information, see\nhttps://dev.mysql.com/doc/refman/8.0/en/view-algorithms.html, as well\nas\nhttps://dev.mysql.com/doc/refman/8.0/en/derived-table-optimization.html\n.\n\nSome views are updatable. That is, you can use them in statements such\nas UPDATE, DELETE, or INSERT to update the contents of the underlying\ntable. For a view to be updatable, there must be a one-to-one\nrelationship between the rows in the view and the rows in the\nunderlying table. There are also certain other constructs that make a\nview nonupdatable.\n\nA generated column in a view is considered updatable because it is\npossible to assign to it. However, if such a column is updated\nexplicitly, the only permitted value is DEFAULT. For information about\ngenerated columns, see\nhttps://dev.mysql.com/doc/refman/8.0/en/create-table-generated-columns.\nhtml.\n\nThe WITH CHECK OPTION clause can be given for an updatable view to\nprevent inserts or updates to rows except those for which the WHERE\nclause in the select_statement is true.\n\nIn a WITH CHECK OPTION clause for an updatable view, the LOCAL and\nCASCADED keywords determine the scope of check testing when the view is\ndefined in terms of another view. The LOCAL keyword restricts the CHECK\nOPTION only to the view being defined. CASCADED causes the checks for\nunderlying views to be evaluated as well. When neither keyword is\ngiven, the default is CASCADED.\n\nFor more information about updatable views and the WITH CHECK OPTION\nclause, see\nhttps://dev.mysql.com/doc/refman/8.0/en/view-updatability.html, and\nhttps://dev.mysql.com/doc/refman/8.0/en/view-check-option.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/create-view.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/create-view.html'),(527,'DROP DATABASE',40,'Syntax:\nDROP {DATABASE | SCHEMA} [IF EXISTS] db_name\n\nDROP DATABASE drops all tables in the database and deletes the\ndatabase. Be very careful with this statement! To use DROP DATABASE,\nyou need the DROP privilege on the database. DROP SCHEMA is a synonym\nfor DROP DATABASE.\n\n*Important*:\n\nWhen a database is dropped, privileges granted specifically for the\ndatabase are not automatically dropped. They must be dropped manually.\nSee [HELP GRANT].\n\nIF EXISTS is used to prevent an error from occurring if the database\ndoes not exist.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/drop-database.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/drop-database.html'),(528,'DROP SCHEMA',40,'Syntax:\nDROP {DATABASE | SCHEMA} [IF EXISTS] db_name\n\nDROP DATABASE drops all tables in the database and deletes the\ndatabase. Be very careful with this statement! To use DROP DATABASE,\nyou need the DROP privilege on the database. DROP SCHEMA is a synonym\nfor DROP DATABASE.\n\n*Important*:\n\nWhen a database is dropped, privileges granted specifically for the\ndatabase are not automatically dropped. They must be dropped manually.\nSee [HELP GRANT].\n\nIF EXISTS is used to prevent an error from occurring if the database\ndoes not exist.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/drop-database.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/drop-database.html'),(529,'DROP EVENT',40,'Syntax:\nDROP EVENT [IF EXISTS] event_name\n\nThis statement drops the event named event_name. The event immediately\nceases being active, and is deleted completely from the server.\n\nIf the event does not exist, the error ERROR 1517 (HY000): Unknown\nevent \'event_name\' results. You can override this and cause the\nstatement to generate a warning for nonexistent events instead using IF\nEXISTS.\n\nThis statement requires the EVENT privilege for the schema to which the\nevent to be dropped belongs.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/drop-event.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/drop-event.html'),(530,'DROP INDEX',40,'Syntax:\nDROP INDEX index_name ON tbl_name\n    [algorithm_option | lock_option] ...\n\nalgorithm_option:\n    ALGORITHM [=] {DEFAULT | INPLACE | COPY}\n\nlock_option:\n    LOCK [=] {DEFAULT | NONE | SHARED | EXCLUSIVE}\n\nDROP INDEX drops the index named index_name from the table tbl_name.\nThis statement is mapped to an ALTER TABLE statement to drop the index.\nSee [HELP ALTER TABLE].\n\nTo drop a primary key, the index name is always PRIMARY, which must be\nspecified as a quoted identifier because PRIMARY is a reserved word:\n\nDROP INDEX `PRIMARY` ON t;\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/drop-index.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/drop-index.html'),(531,'DROP PROCEDURE',40,'Syntax:\nDROP {PROCEDURE | FUNCTION} [IF EXISTS] sp_name\n\nThese statements are used to drop a stored routine (a stored procedure\nor function). That is, the specified routine is removed from the\nserver. (DROP FUNCTION is also used to drop loadable functions; see\n[HELP DROP FUNCTION loadable function].)\n\nTo drop a stored routine, you must have the ALTER ROUTINE privilege for\nit. (If the automatic_sp_privileges system variable is enabled, that\nprivilege and EXECUTE are granted automatically to the routine creator\nwhen the routine is created and dropped from the creator when the\nroutine is dropped. See\nhttps://dev.mysql.com/doc/refman/8.0/en/stored-routines-privileges.html\n.)\n\nIn addition, if the definer of the routine has the SYSTEM_USER\nprivilege, the user dropping it must also have this privilege. This is\nenforced in MySQL 8.0.16 and later.\n\nThe IF EXISTS clause is a MySQL extension. It prevents an error from\noccurring if the procedure or function does not exist. A warning is\nproduced that can be viewed with SHOW WARNINGS.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/drop-procedure.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/drop-procedure.html'),(532,'DROP FUNCTION',40,'Syntax:\nDROP {PROCEDURE | FUNCTION} [IF EXISTS] sp_name\n\nThese statements are used to drop a stored routine (a stored procedure\nor function). That is, the specified routine is removed from the\nserver. (DROP FUNCTION is also used to drop loadable functions; see\n[HELP DROP FUNCTION loadable function].)\n\nTo drop a stored routine, you must have the ALTER ROUTINE privilege for\nit. (If the automatic_sp_privileges system variable is enabled, that\nprivilege and EXECUTE are granted automatically to the routine creator\nwhen the routine is created and dropped from the creator when the\nroutine is dropped. See\nhttps://dev.mysql.com/doc/refman/8.0/en/stored-routines-privileges.html\n.)\n\nIn addition, if the definer of the routine has the SYSTEM_USER\nprivilege, the user dropping it must also have this privilege. This is\nenforced in MySQL 8.0.16 and later.\n\nThe IF EXISTS clause is a MySQL extension. It prevents an error from\noccurring if the procedure or function does not exist. A warning is\nproduced that can be viewed with SHOW WARNINGS.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/drop-procedure.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/drop-procedure.html'),(533,'DROP SERVER',40,'Syntax:\nDROP SERVER [ IF EXISTS ] server_name\n\nDrops the server definition for the server named server_name. The\ncorresponding row in the mysql.servers table is deleted. This statement\nrequires the SUPER privilege.\n\nDropping a server for a table does not affect any FEDERATED tables that\nused this connection information when they were created. See [HELP\nCREATE SERVER].\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/drop-server.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/drop-server.html'),(534,'DROP SPATIAL REFERENCE SYSTEM',40,'Syntax:\nDROP SPATIAL REFERENCE SYSTEM\n    [IF EXISTS]\n    srid\n\nsrid: 32-bit unsigned integer\n\nThis statement removes a spatial reference system (SRS) definition from\nthe data dictionary. It requires the SUPER privilege.\n\nExample:\n\nDROP SPATIAL REFERENCE SYSTEM 4120;\n\nIf no SRS definition with the SRID value exists, an error occurs unless\nIF EXISTS is specified. In that case, a warning occurs rather than an\nerror.\n\nIf the SRID value is used by some column in an existing table, an error\noccurs. For example:\n\nmysql> DROP SPATIAL REFERENCE SYSTEM 4326;\nERROR 3716 (SR005): Can\'t modify SRID 4326. There is at\nleast one column depending on it.\n\nTo identify which column or columns use the SRID, use this query:\n\nSELECT * FROM INFORMATION_SCHEMA.ST_GEOMETRY_COLUMNS WHERE SRS_ID=4326;\n\nSRID values must be in the range of 32-bit unsigned integers, with\nthese restrictions:\n\no SRID 0 is a valid SRID but cannot be used with DROP SPATIAL REFERENCE\n  SYSTEM.\n\no If the value is in a reserved SRID range, a warning occurs. Reserved\n  ranges are [0, 32767] (reserved by EPSG), [60,000,000, 69,999,999]\n  (reserved by EPSG), and [2,000,000,000, 2,147,483,647] (reserved by\n  MySQL). EPSG stands for the European Petroleum Survey Group\n  (http://epsg.org).\n\no Users should not drop SRSs with SRIDs in the reserved ranges. If\n  system-installed SRSs are dropped, the SRS definitions may be\n  recreated for MySQL upgrades.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/drop-spatial-reference-system.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/drop-spatial-reference-system.html'),(535,'DROP TABLE',40,'Syntax:\nDROP [TEMPORARY] TABLE [IF EXISTS]\n    tbl_name [, tbl_name] ...\n    [RESTRICT | CASCADE]\n\nDROP TABLE removes one or more tables. You must have the DROP privilege\nfor each table.\n\nBe careful with this statement! For each table, it removes the table\ndefinition and all table data. If the table is partitioned, the\nstatement removes the table definition, all its partitions, all data\nstored in those partitions, and all partition definitions associated\nwith the dropped table.\n\nDropping a table also drops any triggers for the table.\n\nDROP TABLE causes an implicit commit, except when used with the\nTEMPORARY keyword. See\nhttps://dev.mysql.com/doc/refman/8.0/en/implicit-commit.html.\n\n*Important*:\n\nWhen a table is dropped, privileges granted specifically for the table\nare not automatically dropped. They must be dropped manually. See [HELP\nGRANT].\n\nIf any tables named in the argument list do not exist, DROP TABLE\nbehavior depends on whether the IF EXISTS clause is given:\n\no Without IF EXISTS, the statement fails with an error indicating which\n  nonexisting tables it was unable to drop, and no changes are made.\n\no With IF EXISTS, no error occurs for nonexisting tables. The statement\n  drops all named tables that do exist, and generates a NOTE diagnostic\n  for each nonexistent table. These notes can be displayed with SHOW\n  WARNINGS. See [HELP SHOW WARNINGS].\n\nIF EXISTS can also be useful for dropping tables in unusual\ncircumstances under which there is an entry in the data dictionary but\nno table managed by the storage engine. (For example, if an abnormal\nserver exit occurs after removal of the table from the storage engine\nbut before removal of the data dictionary entry.)\n\nThe TEMPORARY keyword has the following effects:\n\no The statement drops only TEMPORARY tables.\n\no The statement does not cause an implicit commit.\n\no No access rights are checked. A TEMPORARY table is visible only with\n  the session that created it, so no check is necessary.\n\nIncluding the TEMPORARY keyword is a good way to prevent accidentally\ndropping non-TEMPORARY tables.\n\nThe RESTRICT and CASCADE keywords do nothing. They are permitted to\nmake porting easier from other database systems.\n\nDROP TABLE is not supported with all innodb_force_recovery settings.\nSee\nhttps://dev.mysql.com/doc/refman/8.0/en/forcing-innodb-recovery.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/drop-table.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/drop-table.html'),(536,'DROP TABLESPACE',40,'Syntax:\nDROP [UNDO] TABLESPACE tablespace_name\n    [ENGINE [=] engine_name]\n\nThis statement drops a tablespace that was previously created using\nCREATE TABLESPACE. It is supported by the NDB and InnoDB storage\nengines.\n\nThe UNDO keyword, introduced in MySQL 8.0.14, must be specified to drop\nan undo tablespace. Only undo tablespaces created using CREATE UNDO\nTABLESPACE syntax can be dropped. An undo tablespace must be in an\nempty state before it can be dropped. For more information, see\nhttps://dev.mysql.com/doc/refman/8.0/en/innodb-undo-tablespaces.html.\n\nENGINE sets the storage engine that uses the tablespace, where\nengine_name is the name of the storage engine. Currently, the values\nInnoDB and NDB are supported. If not set, the value of\ndefault_storage_engine is used. If it is not the same as the storage\nengine used to create the tablespace, the DROP TABLESPACE statement\nfails.\n\ntablespace_name is a case-sensitive identifier in MySQL.\n\nFor an InnoDB general tablespace, all tables must be dropped from the\ntablespace prior to a DROP TABLESPACE operation. If the tablespace is\nnot empty, DROP TABLESPACE returns an error.\n\nAn NDB tablespace to be dropped must not contain any data files; in\nother words, before you can drop an NDB tablespace, you must first drop\neach of its data files using ALTER TABLESPACE ... DROP DATAFILE.\n\nNotes\n\no A general InnoDB tablespace is not deleted automatically when the\n  last table in the tablespace is dropped. The tablespace must be\n  dropped explicitly using DROP TABLESPACE tablespace_name.\n\no A DROP DATABASE operation can drop tables that belong to a general\n  tablespace but it cannot drop the tablespace, even if the operation\n  drops all tables that belong to the tablespace. The tablespace must\n  be dropped explicitly using DROP TABLESPACE tablespace_name.\n\no Similar to the system tablespace, truncating or dropping tables\n  stored in a general tablespace creates free space internally in the\n  general tablespace .ibd data file which can only be used for new\n  InnoDB data. Space is not released back to the operating system as it\n  is for file-per-table tablespaces.\n\nInnoDB Examples\n\nThis example demonstrates how to drop an InnoDB general tablespace. The\ngeneral tablespace ts1 is created with a single table. Before dropping\nthe tablespace, the table must be dropped.\n\nmysql> CREATE TABLESPACE `ts1` ADD DATAFILE \'ts1.ibd\' Engine=InnoDB;\n\nmysql> CREATE TABLE t1 (c1 INT PRIMARY KEY) TABLESPACE ts1 Engine=InnoDB;\n\nmysql> DROP TABLE t1;\n\nmysql> DROP TABLESPACE ts1;\n\nThis example demonstrates dropping an undo tablespace. An undo\ntablespace must be in an empty state before it can be dropped. For more\ninformation, see\nhttps://dev.mysql.com/doc/refman/8.0/en/innodb-undo-tablespaces.html.\n\nmysql> DROP UNDO TABLESPACE undo_003;\n\nNDB Example\n\nThis example shows how to drop an NDB tablespace myts having a data\nfile named mydata-1.dat after first creating the tablespace, and\nassumes the existence of a log file group named mylg (see [HELP CREATE\nLOGFILE GROUP]).\n\nmysql> CREATE TABLESPACE myts\n    ->     ADD DATAFILE \'mydata-1.dat\'\n    ->     USE LOGFILE GROUP mylg\n    ->     ENGINE=NDB;\n\nYou must remove all data files from the tablespace using ALTER\nTABLESPACE, as shown here, before it can be dropped:\n\nmysql> ALTER TABLESPACE myts\n    ->     DROP DATAFILE \'mydata-1.dat\'\n    ->     ENGINE=NDB;\n\nmysql> DROP TABLESPACE myts;\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/drop-tablespace.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/drop-tablespace.html'),(537,'DROP TRIGGER',40,'Syntax:\nDROP TRIGGER [IF EXISTS] [schema_name.]trigger_name\n\nThis statement drops a trigger. The schema (database) name is optional.\nIf the schema is omitted, the trigger is dropped from the default\nschema. DROP TRIGGER requires the TRIGGER privilege for the table\nassociated with the trigger.\n\nUse IF EXISTS to prevent an error from occurring for a trigger that\ndoes not exist. A NOTE is generated for a nonexistent trigger when\nusing IF EXISTS. See [HELP SHOW WARNINGS].\n\nTriggers for a table are also dropped if you drop the table.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/drop-trigger.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/drop-trigger.html'),(538,'DROP VIEW',40,'Syntax:\nDROP VIEW [IF EXISTS]\n    view_name [, view_name] ...\n    [RESTRICT | CASCADE]\n\nDROP VIEW removes one or more views. You must have the DROP privilege\nfor each view.\n\nIf any views named in the argument list do not exist, the statement\nfails with an error indicating by name which nonexisting views it was\nunable to drop, and no changes are made.\n\n*Note*:\n\nIn MySQL 5.7 and earlier, DROP VIEW returns an error if any views named\nin the argument list do not exist, but also drops all views in the list\nthat do exist. Due to the change in behavior in MySQL 8.0, a partially\ncompleted DROP VIEW operation on a MySQL 5.7 replication source server\nfails when replicated on a MySQL 8.0 replica. To avoid this failure\nscenario, use IF EXISTS syntax in DROP VIEW statements to prevent an\nerror from occurring for views that do not exist. For more information,\nsee https://dev.mysql.com/doc/refman/8.0/en/atomic-ddl.html.\n\nThe IF EXISTS clause prevents an error from occurring for views that\ndon\'t exist. When this clause is given, a NOTE is generated for each\nnonexistent view. See [HELP SHOW WARNINGS].\n\nRESTRICT and CASCADE, if given, are parsed and ignored.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/drop-view.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/drop-view.html'),(539,'RENAME TABLE',40,'Syntax:\nRENAME TABLE\n    tbl_name TO new_tbl_name\n    [, tbl_name2 TO new_tbl_name2] ...\n\nRENAME TABLE renames one or more tables. You must have ALTER and DROP\nprivileges for the original table, and CREATE and INSERT privileges for\nthe new table.\n\nFor example, to rename a table named old_table to new_table, use this\nstatement:\n\nRENAME TABLE old_table TO new_table;\n\nThat statement is equivalent to the following ALTER TABLE statement:\n\nALTER TABLE old_table RENAME new_table;\n\nRENAME TABLE, unlike ALTER TABLE, can rename multiple tables within a\nsingle statement:\n\nRENAME TABLE old_table1 TO new_table1,\n             old_table2 TO new_table2,\n             old_table3 TO new_table3;\n\nRenaming operations are performed left to right. Thus, to swap two\ntable names, do this (assuming that a table with the intermediary name\ntmp_table does not already exist):\n\nRENAME TABLE old_table TO tmp_table,\n             new_table TO old_table,\n             tmp_table TO new_table;\n\nMetadata locks on tables are acquired in name order, which in some\ncases can make a difference in operation outcome when multiple\ntransactions execute concurrently. See\nhttps://dev.mysql.com/doc/refman/8.0/en/metadata-locking.html.\n\nAs of MySQL 8.0.13, you can rename tables locked with a LOCK TABLES\nstatement, provided that they are locked with a WRITE lock or are the\nproduct of renaming WRITE-locked tables from earlier steps in a\nmultiple-table rename operation. For example, this is permitted:\n\nLOCK TABLE old_table1 WRITE;\nRENAME TABLE old_table1 TO new_table1,\n             new_table1 TO new_table2;\n\nThis is not permitted:\n\nLOCK TABLE old_table1 READ;\nRENAME TABLE old_table1 TO new_table1,\n             new_table1 TO new_table2;\n\nPrior to MySQL 8.0.13, to execute RENAME TABLE, there must be no tables\nlocked with LOCK TABLES.\n\nWith the transaction table locking conditions satisfied, the rename\noperation is done atomically; no other session can access any of the\ntables while the rename is in progress.\n\nIf any errors occur during a RENAME TABLE, the statement fails and no\nchanges are made.\n\nYou can use RENAME TABLE to move a table from one database to another:\n\nRENAME TABLE current_db.tbl_name TO other_db.tbl_name;\n\nUsing this method to move all tables from one database to a different\none in effect renames the database (an operation for which MySQL has no\nsingle statement), except that the original database continues to\nexist, albeit with no tables.\n\nLike RENAME TABLE, ALTER TABLE ... RENAME can also be used to move a\ntable to a different database. Regardless of the statement used, if the\nrename operation would move the table to a database located on a\ndifferent file system, the success of the outcome is platform specific\nand depends on the underlying operating system calls used to move table\nfiles.\n\nIf a table has triggers, attempts to rename the table into a different\ndatabase fail with a Trigger in wrong schema (ER_TRG_IN_WRONG_SCHEMA\n(https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference.html\n#error_er_trg_in_wrong_schema)) error.\n\nAn unencrypted table can be moved to an encryption-enabled database and\nvice versa. However, if the table_encryption_privilege_check variable\nis enabled, the TABLE_ENCRYPTION_ADMIN privilege is required if the\ntable encryption setting differs from the default database encryption.\n\nTo rename TEMPORARY tables, RENAME TABLE does not work. Use ALTER TABLE\ninstead.\n\nRENAME TABLE works for views, except that views cannot be renamed into\na different database.\n\nAny privileges granted specifically for a renamed table or view are not\nmigrated to the new name. They must be changed manually.\n\nRENAME TABLE tbl_name TO new_tbl_name changes internally generated\nforeign key constraint names and user-defined foreign key constraint\nnames that begin with the string \"tbl_name_ibfk_\" to reflect the new\ntable name. InnoDB interprets foreign key constraint names that begin\nwith the string \"tbl_name_ibfk_\" as internally generated names.\n\nForeign key constraint names that point to the renamed table are\nautomatically updated unless there is a conflict, in which case the\nstatement fails with an error. A conflict occurs if the renamed\nconstraint name already exists. In such cases, you must drop and\nre-create the foreign keys for them to function properly.\n\nRENAME TABLE tbl_name TO new_tbl_name changes internally generated and\nuser-defined CHECK constraint names that begin with the string\n\"tbl_name_chk_\" to reflect the new table name. MySQL interprets CHECK\nconstraint names that begin with the string \"tbl_name_chk_\" as\ninternally generated names. Example:\n\nmysql> SHOW CREATE TABLE t1\\G\n*************************** 1. row ***************************\n       Table: t1\nCreate Table: CREATE TABLE `t1` (\n  `i1` int(11) DEFAULT NULL,\n  `i2` int(11) DEFAULT NULL,\n  CONSTRAINT `t1_chk_1` CHECK ((`i1` > 0)),\n  CONSTRAINT `t1_chk_2` CHECK ((`i2` < 0))\n) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci\n1 row in set (0.02 sec)\n\nmysql> RENAME TABLE t1 TO t3;\nQuery OK, 0 rows affected (0.03 sec)\n\nmysql> SHOW CREATE TABLE t3\\G\n*************************** 1. row ***************************\n       Table: t3\nCreate Table: CREATE TABLE `t3` (\n  `i1` int(11) DEFAULT NULL,\n  `i2` int(11) DEFAULT NULL,\n  CONSTRAINT `t3_chk_1` CHECK ((`i1` > 0)),\n  CONSTRAINT `t3_chk_2` CHECK ((`i2` < 0))\n) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci\n1 row in set (0.01 sec)\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/rename-table.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/rename-table.html'),(540,'TRUNCATE TABLE',40,'Syntax:\nTRUNCATE [TABLE] tbl_name\n\nTRUNCATE TABLE empties a table completely. It requires the DROP\nprivilege. Logically, TRUNCATE TABLE is similar to a DELETE statement\nthat deletes all rows, or a sequence of DROP TABLE and CREATE TABLE\nstatements.\n\nTo achieve high performance, TRUNCATE TABLE bypasses the DML method of\ndeleting data. Thus, it does not cause ON DELETE triggers to fire, it\ncannot be performed for InnoDB tables with parent-child foreign key\nrelationships, and it cannot be rolled back like a DML operation.\nHowever, TRUNCATE TABLE operations on tables that use an atomic\nDDL-supported storage engine are either fully committed or rolled back\nif the server halts during their operation. For more information, see\nhttps://dev.mysql.com/doc/refman/8.0/en/atomic-ddl.html.\n\nAlthough TRUNCATE TABLE is similar to DELETE, it is classified as a DDL\nstatement rather than a DML statement. It differs from DELETE in the\nfollowing ways:\n\no Truncate operations drop and re-create the table, which is much\n  faster than deleting rows one by one, particularly for large tables.\n\no Truncate operations cause an implicit commit, and so cannot be rolled\n  back. See\n  https://dev.mysql.com/doc/refman/8.0/en/implicit-commit.html.\n\no Truncation operations cannot be performed if the session holds an\n  active table lock.\n\no TRUNCATE TABLE fails for an InnoDB table or NDB table if there are\n  any FOREIGN KEY constraints from other tables that reference the\n  table. Foreign key constraints between columns of the same table are\n  permitted.\n\no Truncation operations do not return a meaningful value for the number\n  of deleted rows. The usual result is \"0 rows affected,\" which should\n  be interpreted as \"no information.\"\n\no As long as the table definition is valid, the table can be re-created\n  as an empty table with TRUNCATE TABLE, even if the data or index\n  files have become corrupted.\n\no Any AUTO_INCREMENT value is reset to its start value. This is true\n  even for MyISAM and InnoDB, which normally do not reuse sequence\n  values.\n\no When used with partitioned tables, TRUNCATE TABLE preserves the\n  partitioning; that is, the data and index files are dropped and\n  re-created, while the partition definitions are unaffected.\n\no The TRUNCATE TABLE statement does not invoke ON DELETE triggers.\n\no Truncating a corrupted InnoDB table is supported.\n\nTRUNCATE TABLE is treated for purposes of binary logging and\nreplication as DDL rather than DML, and is always logged as a\nstatement.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/truncate-table.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/truncate-table.html'),(541,'CALL',41,'Syntax:\nCALL sp_name([parameter[,...]])\nCALL sp_name[()]\n\nThe CALL statement invokes a stored procedure that was defined\npreviously with CREATE PROCEDURE.\n\nStored procedures that take no arguments can be invoked without\nparentheses. That is, CALL p() and CALL p are equivalent.\n\nCALL can pass back values to its caller using parameters that are\ndeclared as OUT or INOUT parameters. When the procedure returns, a\nclient program can also obtain the number of rows affected for the\nfinal statement executed within the routine: At the SQL level, call the\nROW_COUNT() function; from the C API, call the mysql_affected_rows()\n(https://dev.mysql.com/doc/c-api/8.0/en/mysql-affected-rows.html)\nfunction.\n\nFor information about the effect of unhandled conditions on procedure\nparameters, see\nhttps://dev.mysql.com/doc/refman/8.0/en/conditions-and-parameters.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/call.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/call.html'),(542,'DELETE',41,'Syntax:\nDELETE is a DML statement that removes rows from a table.\n\nA DELETE statement can start with a WITH clause to define common table\nexpressions accessible within the DELETE. See\nhttps://dev.mysql.com/doc/refman/8.0/en/with.html.\n\nSingle-Table Syntax\n\nDELETE [LOW_PRIORITY] [QUICK] [IGNORE] FROM tbl_name [[AS] tbl_alias]\n    [PARTITION (partition_name [, partition_name] ...)]\n    [WHERE where_condition]\n    [ORDER BY ...]\n    [LIMIT row_count]\n\nThe DELETE statement deletes rows from tbl_name and returns the number\nof deleted rows. To check the number of deleted rows, call the\nROW_COUNT() function described in\nhttps://dev.mysql.com/doc/refman/8.0/en/information-functions.html.\n\nMain Clauses\n\nThe conditions in the optional WHERE clause identify which rows to\ndelete. With no WHERE clause, all rows are deleted.\n\nwhere_condition is an expression that evaluates to true for each row to\nbe deleted. It is specified as described in\nhttps://dev.mysql.com/doc/refman/8.0/en/select.html.\n\nIf the ORDER BY clause is specified, the rows are deleted in the order\nthat is specified. The LIMIT clause places a limit on the number of\nrows that can be deleted. These clauses apply to single-table deletes,\nbut not multi-table deletes.\n\nMultiple-Table Syntax\n\nDELETE [LOW_PRIORITY] [QUICK] [IGNORE]\n    tbl_name[.*] [, tbl_name[.*]] ...\n    FROM table_references\n    [WHERE where_condition]\n\nDELETE [LOW_PRIORITY] [QUICK] [IGNORE]\n    FROM tbl_name[.*] [, tbl_name[.*]] ...\n    USING table_references\n    [WHERE where_condition]\n\nPrivileges\n\nYou need the DELETE privilege on a table to delete rows from it. You\nneed only the SELECT privilege for any columns that are only read, such\nas those named in the WHERE clause.\n\nPerformance\n\nWhen you do not need to know the number of deleted rows, the TRUNCATE\nTABLE statement is a faster way to empty a table than a DELETE\nstatement with no WHERE clause. Unlike DELETE, TRUNCATE TABLE cannot be\nused within a transaction or if you have a lock on the table. See [HELP\nTRUNCATE TABLE] and [HELP LOCK TABLES].\n\nThe speed of delete operations may also be affected by factors\ndiscussed in\nhttps://dev.mysql.com/doc/refman/8.0/en/delete-optimization.html.\n\nTo ensure that a given DELETE statement does not take too much time,\nthe MySQL-specific LIMIT row_count clause for DELETE specifies the\nmaximum number of rows to be deleted. If the number of rows to delete\nis larger than the limit, repeat the DELETE statement until the number\nof affected rows is less than the LIMIT value.\n\nSubqueries\n\nYou cannot delete from a table and select from the same table in a\nsubquery.\n\nPartitioned Table Support\n\nDELETE supports explicit partition selection using the PARTITION\nclause, which takes a list of the comma-separated names of one or more\npartitions or subpartitions (or both) from which to select rows to be\ndropped. Partitions not included in the list are ignored. Given a\npartitioned table t with a partition named p0, executing the statement\nDELETE FROM t PARTITION (p0) has the same effect on the table as\nexecuting ALTER TABLE t TRUNCATE PARTITION (p0); in both cases, all\nrows in partition p0 are dropped.\n\nPARTITION can be used along with a WHERE condition, in which case the\ncondition is tested only on rows in the listed partitions. For example,\nDELETE FROM t PARTITION (p0) WHERE c < 5 deletes rows only from\npartition p0 for which the condition c < 5 is true; rows in any other\npartitions are not checked and thus not affected by the DELETE.\n\nThe PARTITION clause can also be used in multiple-table DELETE\nstatements. You can use up to one such option per table named in the\nFROM option.\n\nFor more information and examples, see\nhttps://dev.mysql.com/doc/refman/8.0/en/partitioning-selection.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/delete.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/delete.html'),(543,'DO',41,'Syntax:\nDO expr [, expr] ...\n\nDO executes the expressions but does not return any results. In most\nrespects, DO is shorthand for SELECT expr, ..., but has the advantage\nthat it is slightly faster when you do not care about the result.\n\nDO is useful primarily with functions that have side effects, such as\nRELEASE_LOCK().\n\nExample: This SELECT statement pauses, but also produces a result set:\n\nmysql> SELECT SLEEP(5);\n+----------+\n| SLEEP(5) |\n+----------+\n|        0 |\n+----------+\n1 row in set (5.02 sec)\n\nDO, on the other hand, pauses without producing a result set.:\n\nmysql> DO SLEEP(5);\nQuery OK, 0 rows affected (4.99 sec)\n\nThis could be useful, for example in a stored function or trigger,\nwhich prohibit statements that produce result sets.\n\nDO only executes expressions. It cannot be used in all cases where\nSELECT can be used. For example, DO id FROM t1 is invalid because it\nreferences a table.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/do.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/do.html'),(544,'EXCEPT',41,'Syntax:\nquery_expression_body EXCEPT [ALL | DISTINCT] query_expression_body\n    [EXCEPT [ALL | DISTINCT] query_expression_body]\n    [...]\n\nquery_expression_body:\n    See \n\nEXCEPT limits the result from the first query block to those rows which\nare (also) not found in the second. As with UNION and INTERSECT, either\nquery block can make use of any of SELECT, TABLE, or VALUES. An example\nusing the tables a, b, and c defined in [HELP INTERSECT], is shown\nhere:\n\nmysql> TABLE a EXCEPT TABLE b;\n+------+------+\n| m    | n    |\n+------+------+\n|    2 |    3 |\n+------+------+\n1 row in set (0.00 sec)\n\nmysql> TABLE a EXCEPT TABLE c;\n+------+------+\n| m    | n    |\n+------+------+\n|    1 |    2 |\n|    2 |    3 |\n+------+------+\n2 rows in set (0.00 sec)\n\nmysql> TABLE b EXCEPT TABLE c;\n+------+------+\n| m    | n    |\n+------+------+\n|    1 |    2 |\n+------+------+\n1 row in set (0.00 sec)\n\nAs with UNION and INTERSECT, if neither DISTINCT nor ALL is specified,\nthe default is DISTINCT.\n\nDISTINCT removes duplicates found on either side of the relation, as\nshown here:\n\nmysql> TABLE c EXCEPT DISTINCT TABLE a;\n+------+------+\n| m    | n    |\n+------+------+\n|    1 |    3 |\n+------+------+\n1 row in set (0.00 sec)\n\nmysql> TABLE c EXCEPT ALL TABLE a;\n+------+------+\n| m    | n    |\n+------+------+\n|    1 |    3 |\n|    1 |    3 |\n+------+------+\n2 rows in set (0.00 sec)\n\n(The first statement has the same effect as TABLE c EXCEPT TABLE a.)\n\nUnlike UNION or INTERSECT, EXCEPT is not commutative---that is, the\nresult depends on the order of the operands, as shown here:\n\nmysql> TABLE a EXCEPT TABLE c;\n+------+------+\n| m    | n    |\n+------+------+\n|    1 |    2 |\n|    2 |    3 |\n+------+------+\n2 rows in set (0.00 sec)\n\nmysql> TABLE c EXCEPT TABLE a;\n+------+------+\n| m    | n    |\n+------+------+\n|    1 |    3 |\n+------+------+\n1 row in set (0.00 sec)\n\nAs with UNION, the result sets to be compared must have the same number\nof columns. Result set column types are also determined as for UNION.\n\nEXCEPT was added in MySQL 8.0.31.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/except.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/except.html'),(545,'HANDLER',41,'Syntax:\nHANDLER tbl_name OPEN [ [AS] alias]\n\nHANDLER tbl_name READ index_name { = | <= | >= | < | > } (value1,value2,...)\n    [ WHERE where_condition ] [LIMIT ... ]\nHANDLER tbl_name READ index_name { FIRST | NEXT | PREV | LAST }\n    [ WHERE where_condition ] [LIMIT ... ]\nHANDLER tbl_name READ { FIRST | NEXT }\n    [ WHERE where_condition ] [LIMIT ... ]\n\nHANDLER tbl_name CLOSE\n\nThe HANDLER statement provides direct access to table storage engine\ninterfaces. It is available for InnoDB and MyISAM tables.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/handler.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/handler.html'),(546,'IMPORT TABLE',41,'Syntax:\nIMPORT TABLE FROM sdi_file [, sdi_file] ...\n\nThe IMPORT TABLE statement imports MyISAM tables based on information\ncontained in .sdi (serialized dictionary information) metadata files.\nIMPORT TABLE requires the FILE privilege to read the .sdi and table\ncontent files, and the CREATE privilege for the table to be created.\n\nTables can be exported from one server using mysqldump to write a file\nof SQL statements and imported into another server using mysql to\nprocess the dump file. IMPORT TABLE provides a faster alternative using\nthe \"raw\" table files.\n\nPrior to import, the files that provide the table content must be\nplaced in the appropriate schema directory for the import server, and\nthe .sdi file must be located in a directory accessible to the server.\nFor example, the .sdi file can be placed in the directory named by the\nsecure_file_priv system variable, or (if secure_file_priv is empty) in\na directory under the server data directory.\n\nThe following example describes how to export MyISAM tables named\nemployees and managers from the hr schema of one server and import them\ninto the hr schema of another server. The example uses these\nassumptions (to perform a similar operation on your own system, modify\nthe path names as appropriate):\n\no For the export server, export_basedir represents its base directory,\n  and its data directory is export_basedir/data.\n\no For the import server, import_basedir represents its base directory,\n  and its data directory is import_basedir/data.\n\no Table files are exported from the export server into the /tmp/export\n  directory and this directory is secure (not accessible to other\n  users).\n\no The import server uses /tmp/mysql-files as the directory named by its\n  secure_file_priv system variable.\n\nTo export tables from the export server, use this procedure:\n\n1. Ensure a consistent snapshot by executing this statement to lock the\n   tables so that they cannot be modified during export:\n\nmysql> FLUSH TABLES hr.employees, hr.managers WITH READ LOCK;\n\n   While the lock is in effect, the tables can still be used, but only\n   for read access.\n\n2. At the file system level, copy the .sdi and table content files from\n   the hr schema directory to the secure export directory:\n\n  o The .sdi file is located in the hr schema directory, but might not\n    have exactly the same basename as the table name. For example, the\n    .sdi files for the employees and managers tables might be named\n    employees_125.sdi and managers_238.sdi.\n\n  o For a MyISAM table, the content files are its .MYD data file and\n    .MYI index file.\n\n   Given those file names, the copy commands look like this:\n\n$> cd export_basedir/data/hr\n$> cp employees_125.sdi /tmp/export\n$> cp managers_238.sdi /tmp/export\n$> cp employees.{MYD,MYI} /tmp/export\n$> cp managers.{MYD,MYI} /tmp/export\n\n3. Unlock the tables:\n\nmysql> UNLOCK TABLES;\n\nTo import tables into the import server, use this procedure:\n\n1. The import schema must exist. If necessary, execute this statement\n   to create it:\n\nmysql> CREATE SCHEMA hr;\n\n2. At the file system level, copy the .sdi files to the import server\n   secure_file_priv directory, /tmp/mysql-files. Also, copy the table\n   content files to the hr schema directory:\n\n$> cd /tmp/export\n$> cp employees_125.sdi /tmp/mysql-files\n$> cp managers_238.sdi /tmp/mysql-files\n$> cp employees.{MYD,MYI} import_basedir/data/hr\n$> cp managers.{MYD,MYI} import_basedir/data/hr\n\n3. Import the tables by executing an IMPORT TABLE statement that names\n   the .sdi files:\n\nmysql> IMPORT TABLE FROM\n       \'/tmp/mysql-files/employees.sdi\',\n       \'/tmp/mysql-files/managers.sdi\';\n\nThe .sdi file need not be placed in the import server directory named\nby the secure_file_priv system variable if that variable is empty; it\ncan be in any directory accessible to the server, including the schema\ndirectory for the imported table. If the .sdi file is placed in that\ndirectory, however, it may be rewritten; the import operation creates a\nnew .sdi file for the table, which overwrites the old .sdi file if the\noperation uses the same file name for the new file.\n\nEach sdi_file value must be a string literal that names the .sdi file\nfor a table or is a pattern that matches .sdi files. If the string is a\npattern, any leading directory path and the .sdi file name suffix must\nbe given literally. Pattern characters are permitted only in the base\nname part of the file name:\n\no ? matches any single character\n\no * matches any sequence of characters, including no characters\n\nUsing a pattern, the previous IMPORT TABLE statement could have been\nwritten like this (assuming that the /tmp/mysql-files directory\ncontains no other .sdi files matching the pattern):\n\nIMPORT TABLE FROM \'/tmp/mysql-files/*.sdi\';\n\nTo interpret the location of .sdi file path names, the server uses the\nsame rules for IMPORT TABLE as the server-side rules for LOAD DATA\n(that is, the non-LOCAL rules). See [HELP LOAD DATA], paying particular\nattention to the rules used to interpret relative path names.\n\nIMPORT TABLE fails if the .sdi or table files cannot be located. After\nimporting a table, the server attempts to open it and reports as\nwarnings any problems detected. To attempt a repair to correct any\nreported issues, use REPAIR TABLE.\n\nIMPORT TABLE is not written to the binary log.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/import-table.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/import-table.html'),(547,'INSERT',41,'Syntax:\nINSERT [LOW_PRIORITY | DELAYED | HIGH_PRIORITY] [IGNORE]\n    [INTO] tbl_name\n    [PARTITION (partition_name [, partition_name] ...)]\n    [(col_name [, col_name] ...)]\n    { {VALUES | VALUE} (value_list) [, (value_list)] ... }\n    [AS row_alias[(col_alias [, col_alias] ...)]]\n    [ON DUPLICATE KEY UPDATE assignment_list]\n\nINSERT [LOW_PRIORITY | DELAYED | HIGH_PRIORITY] [IGNORE]\n    [INTO] tbl_name\n    [PARTITION (partition_name [, partition_name] ...)]\n    SET assignment_list\n    [AS row_alias[(col_alias [, col_alias] ...)]]\n    [ON DUPLICATE KEY UPDATE assignment_list]\n\nINSERT [LOW_PRIORITY | HIGH_PRIORITY] [IGNORE]\n    [INTO] tbl_name\n    [PARTITION (partition_name [, partition_name] ...)]\n    [(col_name [, col_name] ...)]\n    { SELECT ... \n      | TABLE table_name \n      | VALUES row_constructor_list\n    }\n    [ON DUPLICATE KEY UPDATE assignment_list]\n\nvalue:\n    {expr | DEFAULT}\n\nvalue_list:\n    value [, value] ...\n\nrow_constructor_list:\n    ROW(value_list)[, ROW(value_list)][, ...]\n\nassignment:\n    col_name = \n          value\n        | [row_alias.]col_name\n        | [tbl_name.]col_name\n        | [row_alias.]col_alias\n\nassignment_list:\n    assignment [, assignment] ...\n\nINSERT inserts new rows into an existing table. The INSERT ... VALUES,\nINSERT ... VALUES ROW(), and INSERT ... SET forms of the statement\ninsert rows based on explicitly specified values. The INSERT ... SELECT\nform inserts rows selected from another table or tables. You can also\nuse INSERT ... TABLE in MySQL 8.0.19 and later to insert rows from a\nsingle table. INSERT with an ON DUPLICATE KEY UPDATE clause enables\nexisting rows to be updated if a row to be inserted would cause a\nduplicate value in a UNIQUE index or PRIMARY KEY. In MySQL 8.0.19 and\nlater, a row alias with one or more optional column aliases can be used\nwith ON DUPLICATE KEY UPDATE to refer to the row to be inserted.\n\nFor additional information about INSERT ... SELECT and INSERT ... ON\nDUPLICATE KEY UPDATE, see [HELP INSERT SELECT], and\nhttps://dev.mysql.com/doc/refman/8.0/en/insert-on-duplicate.html.\n\nIn MySQL 8.0, the DELAYED keyword is accepted but ignored by the\nserver. For the reasons for this, see [HELP INSERT DELAYED],\n\nInserting into a table requires the INSERT privilege for the table. If\nthe ON DUPLICATE KEY UPDATE clause is used and a duplicate key causes\nan UPDATE to be performed instead, the statement requires the UPDATE\nprivilege for the columns to be updated. For columns that are read but\nnot modified you need only the SELECT privilege (such as for a column\nreferenced only on the right hand side of an col_name=expr assignment\nin an ON DUPLICATE KEY UPDATE clause).\n\nWhen inserting into a partitioned table, you can control which\npartitions and subpartitions accept new rows. The PARTITION clause\ntakes a list of the comma-separated names of one or more partitions or\nsubpartitions (or both) of the table. If any of the rows to be inserted\nby a given INSERT statement do not match one of the partitions listed,\nthe INSERT statement fails with the error Found a row not matching the\ngiven partition set. For more information and examples, see\nhttps://dev.mysql.com/doc/refman/8.0/en/partitioning-selection.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/insert.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/insert.html'),(548,'INSERT SELECT',41,'Syntax:\nINSERT [LOW_PRIORITY | HIGH_PRIORITY] [IGNORE]\n    [INTO] tbl_name\n    [PARTITION (partition_name [, partition_name] ...)]\n    [(col_name [, col_name] ...)]\n    {   SELECT ... \n      | TABLE table_name \n      | VALUES row_constructor_list\n    }\n    [ON DUPLICATE KEY UPDATE assignment_list]\n\n\nvalue:\n    {expr | DEFAULT}\n\nvalue_list:\n    value [, value] ...\n\nrow_constructor_list:\n    ROW(value_list)[, ROW(value_list)][, ...]\n\nassignment:\n    col_name = \n          value\n        | [row_alias.]col_name\n        | [tbl_name.]col_name\n        | [row_alias.]col_alias\n\nassignment_list:\n    assignment [, assignment] ...\n\nWith INSERT ... SELECT, you can quickly insert many rows into a table\nfrom the result of a SELECT statement, which can select from one or\nmany tables. For example:\n\nINSERT INTO tbl_temp2 (fld_id)\n  SELECT tbl_temp1.fld_order_id\n  FROM tbl_temp1 WHERE tbl_temp1.fld_order_id > 100;\n\nBeginning with MySQL 8.0.19, you can use a TABLE statement in place of\nSELECT, as shown here:\n\nINSERT INTO ta TABLE tb;\n\nTABLE tb is equivalent to SELECT * FROM tb. It can be useful when\ninserting all columns from the source table into the target table, and\nno filtering with WHERE is required. In addition, the rows from TABLE\ncan be ordered by one or more columns using ORDER BY, and the number of\nrows inserted can be limited using a LIMIT clause. For more\ninformation, see [HELP TABLE].\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/insert-select.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/insert-select.html'),(549,'INSERT DELAYED',41,'Syntax:\nINSERT DELAYED ...\n\nThe DELAYED option for the INSERT statement is a MySQL extension to\nstandard SQL. In previous versions of MySQL, it can be used for certain\nkinds of tables (such as MyISAM), such that when a client uses INSERT\nDELAYED, it gets an okay from the server at once, and the row is queued\nto be inserted when the table is not in use by any other thread.\n\nDELAYED inserts and replaces were deprecated in MySQL 5.6. In MySQL\n8.0, DELAYED is not supported. The server recognizes but ignores the\nDELAYED keyword, handles the insert as a nondelayed insert, and\ngenerates an ER_WARN_LEGACY_SYNTAX_CONVERTED warning: INSERT DELAYED is\nno longer supported. The statement was converted to INSERT. The DELAYED\nkeyword is scheduled for removal in a future release.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/insert-delayed.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/insert-delayed.html'),(550,'INTERSECT',41,'Syntax:\nquery_expression_body INTERSECT [ALL | DISTINCT] query_expression_body\n    [INTERSECT [ALL | DISTINCT] query_expression_body]\n    [...]\n\nquery_expression_body:\n    See \n\nINTERSECT limits the result from multiple query blocks to those rows\nwhich are common to all. Example:\n\nmysql> TABLE a;\n+------+------+\n| m    | n    |\n+------+------+\n|    1 |    2 |\n|    2 |    3 |\n|    3 |    4 |\n+------+------+\n3 rows in set (0.00 sec)\n\nmysql> TABLE b;\n+------+------+\n| m    | n    |\n+------+------+\n|    1 |    2 |\n|    1 |    3 |\n|    3 |    4 |\n+------+------+\n3 rows in set (0.00 sec)\n\nmysql> TABLE c;\n+------+------+\n| m    | n    |\n+------+------+\n|    1 |    3 |\n|    1 |    3 |\n|    3 |    4 |\n+------+------+\n3 rows in set (0.00 sec)\n\nmysql> TABLE a INTERSECT TABLE b;\n+------+------+\n| m    | n    |\n+------+------+\n|    1 |    2 |\n|    3 |    4 |\n+------+------+\n2 rows in set (0.00 sec)\n\nmysql> TABLE a INTERSECT TABLE c;\n+------+------+\n| m    | n    |\n+------+------+\n|    3 |    4 |\n+------+------+\n1 row in set (0.00 sec)\n\nAs with UNION and EXCEPT, if neither DISTINCT nor ALL is specified, the\ndefault is DISTINCT.\n\nDISTINCT can remove duplicates from either side of the intersection, as\nshown here:\n\nmysql> TABLE c INTERSECT DISTINCT TABLE c;\n+------+------+\n| m    | n    |\n+------+------+\n|    1 |    3 |\n|    3 |    4 |\n+------+------+\n2 rows in set (0.00 sec)\n\nmysql> TABLE c INTERSECT ALL TABLE c;\n+------+------+\n| m    | n    |\n+------+------+\n|    1 |    3 |\n|    1 |    3 |\n|    3 |    4 |\n+------+------+\n3 rows in set (0.00 sec)\n\n(TABLE c INTERSECT TABLE c is the equivalent of the first of the two\nstatements just shown.)\n\nAs with UNION, the operands must have the same number of columns.\nResult set column types are also determined as for UNION.\n\nINTERSECT has greater precedence than and is evaluated before UNION and\nEXCEPT, so that the two statements shown here are equivalent:\n\nTABLE r EXCEPT TABLE s INTERSECT TABLE t;\n\nTABLE r EXCEPT (TABLE s INTERSECT TABLE t);\n\nFor INTERSECT ALL, the maximum supported number of duplicates of any\nunique row in the left hand table is 4294967295.\n\nINTERSECT was added in MySQL 8.0.31.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/intersect.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/intersect.html'),(551,'LOAD DATA',41,'Syntax:\nLOAD DATA\n    [LOW_PRIORITY | CONCURRENT] [LOCAL]\n    INFILE \'file_name\'\n    [REPLACE | IGNORE]\n    INTO TABLE tbl_name\n    [PARTITION (partition_name [, partition_name] ...)]\n    [CHARACTER SET charset_name]\n    [{FIELDS | COLUMNS}\n        [TERMINATED BY \'string\']\n        [[OPTIONALLY] ENCLOSED BY \'char\']\n        [ESCAPED BY \'char\']\n    ]\n    [LINES\n        [STARTING BY \'string\']\n        [TERMINATED BY \'string\']\n    ]\n    [IGNORE number {LINES | ROWS}]\n    [(col_name_or_user_var\n        [, col_name_or_user_var] ...)]\n    [SET col_name={expr | DEFAULT}\n        [, col_name={expr | DEFAULT}] ...]\n\nThe LOAD DATA statement reads rows from a text file into a table at a\nvery high speed. The file can be read from the server host or the\nclient host, depending on whether the LOCAL modifier is given. LOCAL\nalso affects data interpretation and error handling.\n\nLOAD DATA is the complement of SELECT ... INTO OUTFILE. (See\nhttps://dev.mysql.com/doc/refman/8.0/en/select-into.html.) To write\ndata from a table to a file, use SELECT ... INTO OUTFILE. To read the\nfile back into a table, use LOAD DATA. The syntax of the FIELDS and\nLINES clauses is the same for both statements.\n\nThe mysqlimport utility provides another way to load data files; it\noperates by sending a LOAD DATA statement to the server. See\nhttps://dev.mysql.com/doc/refman/8.0/en/mysqlimport.html.\n\nFor information about the efficiency of INSERT versus LOAD DATA and\nspeeding up LOAD DATA, see\nhttps://dev.mysql.com/doc/refman/8.0/en/insert-optimization.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/load-data.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/load-data.html'),(552,'LOAD XML',41,'Syntax:\nLOAD XML\n    [LOW_PRIORITY | CONCURRENT] [LOCAL]\n    INFILE \'file_name\'\n    [REPLACE | IGNORE]\n    INTO TABLE [db_name.]tbl_name\n    [CHARACTER SET charset_name]\n    [ROWS IDENTIFIED BY \'<tagname>\']\n    [IGNORE number {LINES | ROWS}]\n    [(field_name_or_user_var\n        [, field_name_or_user_var] ...)]\n    [SET col_name={expr | DEFAULT}\n        [, col_name={expr | DEFAULT}] ...]\n\nThe LOAD XML statement reads data from an XML file into a table. The\nfile_name must be given as a literal string. The tagname in the\noptional ROWS IDENTIFIED BY clause must also be given as a literal\nstring, and must be surrounded by angle brackets (< and >).\n\nLOAD XML acts as the complement of running the mysql client in XML\noutput mode (that is, starting the client with the --xml option). To\nwrite data from a table to an XML file, you can invoke the mysql client\nwith the --xml and -e options from the system shell, as shown here:\n\n$> mysql --xml -e \'SELECT * FROM mydb.mytable\' > file.xml\n\nTo read the file back into a table, use LOAD XML. By default, the <row>\nelement is considered to be the equivalent of a database table row;\nthis can be changed using the ROWS IDENTIFIED BY clause.\n\nThis statement supports three different XML formats:\n\no Column names as attributes and column values as attribute values:\n\n<row column1=\"value1\" column2=\"value2\" .../>\n\no Column names as tags and column values as the content of these tags:\n\n<row>\n  <column1>value1</column1>\n  <column2>value2</column2>\n</row>\n\no Column names are the name attributes of <field> tags, and values are\n  the contents of these tags:\n\n<row>\n  <field name=\'column1\'>value1</field>\n  <field name=\'column2\'>value2</field>\n</row>\n\n  This is the format used by other MySQL tools, such as mysqldump.\n\nAll three formats can be used in the same XML file; the import routine\nautomatically detects the format for each row and interprets it\ncorrectly. Tags are matched based on the tag or attribute name and the\ncolumn name.\n\nPrior to MySQL 8.0.21, LOAD XML did not support CDATA sections in the\nsource XML. (Bug #30753708, Bug #98199)\n\nThe following clauses work essentially the same way for LOAD XML as\nthey do for LOAD DATA:\n\no LOW_PRIORITY or CONCURRENT\n\no LOCAL\n\no REPLACE or IGNORE\n\no CHARACTER SET\n\no SET\n\nSee [HELP LOAD DATA], for more information about these clauses.\n\n(field_name_or_user_var, ...) is a list of one or more comma-separated\nXML fields or user variables. The name of a user variable used for this\npurpose must match the name of a field from the XML file, prefixed with\n@. You can use field names to select only desired fields. User\nvariables can be employed to store the corresponding field values for\nsubsequent re-use.\n\nThe IGNORE number LINES or IGNORE number ROWS clause causes the first\nnumber rows in the XML file to be skipped. It is analogous to the LOAD\nDATA statement\'s IGNORE ... LINES clause.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/load-xml.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/load-xml.html'),(553,'PARENTHESIZED QUERY EXPRESSIONS',41,'Syntax:\nparenthesized_query_expression:\n    ( query_expression [order_by_clause] [limit_clause] )\n      [order_by_clause]\n      [limit_clause]\n      [into_clause]\n\nquery_expression:\n    query_block [set_op query_block [set_op query_block ...]]\n      [order_by_clause]\n      [limit_clause]\n      [into_clause]\n\nquery_block:\n    SELECT ... | TABLE | VALUES\n\norder_by_clause:\n    ORDER BY as for SELECT\n\nlimit_clause:\n    LIMIT as for SELECT\n\ninto_clause:\n    INTO as for SELECT\n\nset_op:\n    UNION | INTERSECT | EXCEPT\n\nMySQL 8.0.22 and higher supports parenthesized query expressions\naccording to the preceding syntax. At its simplest, a parenthesized\nquery expression contains a single SELECT or other statement returning\na result set and no following optional clauses:\n\n(SELECT 1);\n(SELECT * FROM INFORMATION_SCHEMA.SCHEMATA WHERE SCHEMA_NAME = \'mysql\');\n\nTABLE t;\n\nVALUES ROW(2, 3, 4), ROW(1, -2, 3);\n\n(Support for the TABLE and VALUES statements is available beginning\nwith MySQL 8.0.19.)\n\nA parenthesized query expression can also contain queries linked by one\nor more set operations such as UNION, and end with any or all of the\noptional clauses:\n\nmysql> (SELECT 1 AS result UNION SELECT 2);\n+--------+\n| result |\n+--------+\n|      1 |\n|      2 |\n+--------+\nmysql> (SELECT 1 AS result UNION SELECT 2) LIMIT 1;\n+--------+\n| result |\n+--------+\n|      1 |\n+--------+\nmysql> (SELECT 1 AS result UNION SELECT 2) LIMIT 1 OFFSET 1;\n+--------+\n| result |\n+--------+\n|      2 |\n+--------+\nmysql> (SELECT 1 AS result UNION SELECT 2)\n       ORDER BY result DESC LIMIT 1;\n+--------+\n| result |\n+--------+\n|      2 |\n+--------+\nmysql> (SELECT 1 AS result UNION SELECT 2)\n       ORDER BY result DESC LIMIT 1 OFFSET 1;\n+--------+\n| result |\n+--------+\n|      1 |\n+--------+\nmysql> (SELECT 1 AS result UNION SELECT 3 UNION SELECT 2)\n       ORDER BY result LIMIT 1 OFFSET 1 INTO @var;\nmysql> SELECT @var;\n+------+\n| @var |\n+------+\n|    2 |\n+------+\n\nIn addition to UNION, the INTERSECT and EXCEPT set operators are\navailable beginning with MySQL 8.0.31. INTERSECT acts before UNION and\nEXCEPT, so that the following two statements are equivalent:\n\nSELECT a FROM t1 EXCEPT SELECT b FROM t2 INTERSECT SELECT c FROM t3;\n\nSELECT a FROM t1 EXCEPT (SELECT b FROM t2 INTERSECT SELECT c FROM t3);\n\nParenthesized query expressions are also used as query expressions, so\na query expression, usually composed of query blocks, may also consist\nof parenthesized query expressions:\n\n(TABLE t1 ORDER BY a) UNION (TABLE t2 ORDER BY b) ORDER BY z;\n\nQuery blocks may have trailing ORDER BY and LIMIT clauses, which are\napplied before the outer set operation, ORDER BY, and LIMIT.\n\nYou cannot have a query block with a trailing ORDER BY or LIMIT without\nwrapping it in parentheses but parentheses may be used for enforcement\nin various ways:\n\no To enforce LIMIT on each query block:\n\n(SELECT 1 LIMIT 1) UNION (VALUES ROW(2) LIMIT 1);\n\n(VALUES ROW(1), ROW(2) LIMIT 2) EXCEPT (SELECT 2 LIMIT 1);\n\no To enforce LIMIT on both query blocks and the entire query\n  expression:\n\n(SELECT 1 LIMIT 1) UNION (SELECT 2 LIMIT 1) LIMIT 1;\n\no To enforce LIMIT on the entire query expression (with no\n  parentheses):\n\nVALUES ROW(1), ROW(2) INTERSECT VALUES ROW(2), ROW(1) LIMIT 1;\n\no Hybrid enforcement: LIMIT on the first query block and on the entire\n  query expression:\n\n(SELECT 1 LIMIT 1) UNION SELECT 2 LIMIT 1;\n\nThe syntax described in this section is subject to certain\nrestrictions:\n\no A trailing INTO clause for a query expression is not permitted if\n  there is another INTO clause inside parentheses.\n\no Prior to MySQL 8.0.31, when ORDER BY or LIMIT occurred within a\n  parenthesized query expression and was also applied in the outer\n  query, the result was undefined. This is not an issue in MySQL 8.0.31\n  and later, where this is handled in accordance with the SQL standard.\n\n  Prior to MySQL 8.0.31, parenthesized query expressions did not permit\n  multiple levels of ORDER BY or LIMIT operations, and statements\n  containing these were rejected with ER_NOT_SUPPORTED_YET\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_not_supported_yet). In MySQL 8.0.31 and later, this\n  restriction is lifted, and nested parenthesized query expressions are\n  permitted. The maximum level of nesting supported is 63; this is\n  after any simplifications or merges have been performed by the\n  parser.\n\n  An example of such a statement is shown here:\n\nmysql> (SELECT \'a\' UNION SELECT \'b\' LIMIT 2) LIMIT 3;\n+---+\n| a |\n+---+\n| a |\n| b |\n+---+\n2 rows in set (0.00 sec)\n\n  You should be aware that, in MySQL 8.0.31 and later, when collapsing\n  parenthesized expression bodies, MySQL follows SQL standard\n  semantics, so that a higher outer limit cannot override an inner\n  lower one. For example, (SELECT ... LIMIT 5) LIMIT 10 can return no\n  more than five rows.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/parenthesized-query-expressions.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/parenthesized-query-expressions.html'),(554,'REPLACE',41,'Syntax:\nREPLACE [LOW_PRIORITY | DELAYED]\n    [INTO] tbl_name\n    [PARTITION (partition_name [, partition_name] ...)]\n    [(col_name [, col_name] ...)]\n    { {VALUES | VALUE} (value_list) [, (value_list)] ...\n      |\n      VALUES row_constructor_list\n    }\n\nREPLACE [LOW_PRIORITY | DELAYED]\n    [INTO] tbl_name\n    [PARTITION (partition_name [, partition_name] ...)]\n    SET assignment_list\n\nREPLACE [LOW_PRIORITY | DELAYED]\n    [INTO] tbl_name\n    [PARTITION (partition_name [, partition_name] ...)]\n    [(col_name [, col_name] ...)]\n    {SELECT ... | TABLE table_name}\n\nvalue:\n    {expr | DEFAULT}\n\nvalue_list:\n    value [, value] ...\n\nrow_constructor_list:\n    ROW(value_list)[, ROW(value_list)][, ...]\n\nassignment:\n    col_name = value\n\nassignment_list:\n    assignment [, assignment] ...\n\nREPLACE works exactly like INSERT, except that if an old row in the\ntable has the same value as a new row for a PRIMARY KEY or a UNIQUE\nindex, the old row is deleted before the new row is inserted. See [HELP\nINSERT].\n\nREPLACE is a MySQL extension to the SQL standard. It either inserts, or\ndeletes and inserts. For another MySQL extension to standard SQL---that\neither inserts or updates---see\nhttps://dev.mysql.com/doc/refman/8.0/en/insert-on-duplicate.html.\n\nDELAYED inserts and replaces were deprecated in MySQL 5.6. In MySQL\n8.0, DELAYED is not supported. The server recognizes but ignores the\nDELAYED keyword, handles the replace as a nondelayed replace, and\ngenerates an ER_WARN_LEGACY_SYNTAX_CONVERTED warning: REPLACE DELAYED\nis no longer supported. The statement was converted to REPLACE. The\nDELAYED keyword is scheduled for removal in a future release. release.\n\n*Note*:\n\nREPLACE makes sense only if a table has a PRIMARY KEY or UNIQUE index.\nOtherwise, it becomes equivalent to INSERT, because there is no index\nto be used to determine whether a new row duplicates another.\n\nValues for all columns are taken from the values specified in the\nREPLACE statement. Any missing columns are set to their default values,\njust as happens for INSERT. You cannot refer to values from the current\nrow and use them in the new row. If you use an assignment such as SET\ncol_name = col_name + 1, the reference to the column name on the right\nhand side is treated as DEFAULT(col_name), so the assignment is\nequivalent to SET col_name = DEFAULT(col_name) + 1.\n\nIn MySQL 8.0.19 and later, you can specify the column values that\nREPLACE attempts to insert using VALUES ROW().\n\nTo use REPLACE, you must have both the INSERT and DELETE privileges for\nthe table.\n\nIf a generated column is replaced explicitly, the only permitted value\nis DEFAULT. For information about generated columns, see\nhttps://dev.mysql.com/doc/refman/8.0/en/create-table-generated-columns.\nhtml.\n\nREPLACE supports explicit partition selection using the PARTITION\nclause with a list of comma-separated names of partitions,\nsubpartitions, or both. As with INSERT, if it is not possible to insert\nthe new row into any of these partitions or subpartitions, the REPLACE\nstatement fails with the error Found a row not matching the given\npartition set. For more information and examples, see\nhttps://dev.mysql.com/doc/refman/8.0/en/partitioning-selection.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/replace.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/replace.html'),(555,'SELECT',41,'Syntax:\nSELECT\n    [ALL | DISTINCT | DISTINCTROW ]\n    [HIGH_PRIORITY]\n    [STRAIGHT_JOIN]\n    [SQL_SMALL_RESULT] [SQL_BIG_RESULT] [SQL_BUFFER_RESULT]\n    [SQL_NO_CACHE] [SQL_CALC_FOUND_ROWS]\n    select_expr [, select_expr] ...\n    [into_option]\n    [FROM table_references\n      [PARTITION partition_list]]\n    [WHERE where_condition]\n    [GROUP BY {col_name | expr | position}, ... [WITH ROLLUP]]\n    [HAVING where_condition]\n    [WINDOW window_name AS (window_spec)\n        [, window_name AS (window_spec)] ...]\n    [ORDER BY {col_name | expr | position}\n      [ASC | DESC], ... [WITH ROLLUP]]\n    [LIMIT {[offset,] row_count | row_count OFFSET offset}]\n    [into_option]\n    [FOR {UPDATE | SHARE}\n        [OF tbl_name [, tbl_name] ...]\n        [NOWAIT | SKIP LOCKED]\n      | LOCK IN SHARE MODE]\n    [into_option]\n\ninto_option: {\n    INTO OUTFILE \'file_name\'\n        [CHARACTER SET charset_name]\n        export_options\n  | INTO DUMPFILE \'file_name\'\n  | INTO var_name [, var_name] ...\n}\n\nSELECT is used to retrieve rows selected from one or more tables, and\ncan include UNION operations and subqueries. Beginning with MySQL\n8.0.31, INTERSECT and EXCEPT operations are also supported. The UNION,\nINTERSECT, and EXCEPT operators are described in more detail later in\nthis section. See also\nhttps://dev.mysql.com/doc/refman/8.0/en/subqueries.html.\n\nA SELECT statement can start with a WITH clause to define common table\nexpressions accessible within the SELECT. See\nhttps://dev.mysql.com/doc/refman/8.0/en/with.html.\n\nThe most commonly used clauses of SELECT statements are these:\n\no Each select_expr indicates a column that you want to retrieve. There\n  must be at least one select_expr.\n\no table_references indicates the table or tables from which to retrieve\n  rows. Its syntax is described in [HELP JOIN].\n\no SELECT supports explicit partition selection using the PARTITION\n  clause with a list of partitions or subpartitions (or both) following\n  the name of the table in a table_reference (see [HELP JOIN]). In this\n  case, rows are selected only from the partitions listed, and any\n  other partitions of the table are ignored. For more information and\n  examples, see\n  https://dev.mysql.com/doc/refman/8.0/en/partitioning-selection.html.\n\no The WHERE clause, if given, indicates the condition or conditions\n  that rows must satisfy to be selected. where_condition is an\n  expression that evaluates to true for each row to be selected. The\n  statement selects all rows if there is no WHERE clause.\n\n  In the WHERE expression, you can use any of the functions and\n  operators that MySQL supports, except for aggregate (group)\n  functions. See\n  https://dev.mysql.com/doc/refman/8.0/en/expressions.html, and\n  https://dev.mysql.com/doc/refman/8.0/en/functions.html.\n\nSELECT can also be used to retrieve rows computed without reference to\nany table.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/select.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/select.html'),(556,'DUAL',41,'You are permitted to specify DUAL as a dummy table name in situations\nwhere no tables are referenced:\n\nmysql> SELECT 1 + 1 FROM DUAL;\n        -> 2\n\nDUAL is purely for the convenience of people who require that all\nSELECT statements should have FROM and possibly other clauses. MySQL\nmay ignore the clauses. MySQL does not require FROM DUAL if no tables\nare referenced.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/select.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/select.html'),(557,'JOIN',41,'MySQL supports the following JOIN syntax for the table_references part\nof SELECT statements and multiple-table DELETE and UPDATE statements:\n\ntable_references:\n    escaped_table_reference [, escaped_table_reference] ...\n\nescaped_table_reference: {\n    table_reference\n  | { OJ table_reference }\n}\n\ntable_reference: {\n    table_factor\n  | joined_table\n}\n\ntable_factor: {\n    tbl_name [PARTITION (partition_names)]\n        [[AS] alias] [index_hint_list]\n  | [LATERAL] table_subquery [AS] alias [(col_list)]\n  | ( table_references )\n}\n\njoined_table: {\n    table_reference {[INNER | CROSS] JOIN | STRAIGHT_JOIN} table_factor [join_specification]\n  | table_reference {LEFT|RIGHT} [OUTER] JOIN table_reference join_specification\n  | table_reference NATURAL [INNER | {LEFT|RIGHT} [OUTER]] JOIN table_factor\n}\n\njoin_specification: {\n    ON search_condition\n  | USING (join_column_list)\n}\n\njoin_column_list:\n    column_name [, column_name] ...\n\nindex_hint_list:\n    index_hint [, index_hint] ...\n\nindex_hint: {\n    USE {INDEX|KEY}\n      [FOR {JOIN|ORDER BY|GROUP BY}] ([index_list])\n  | {IGNORE|FORCE} {INDEX|KEY}\n      [FOR {JOIN|ORDER BY|GROUP BY}] (index_list)\n}\n\nindex_list:\n    index_name [, index_name] ...\n\nA table reference is also known as a join expression.\n\nA table reference (when it refers to a partitioned table) may contain a\nPARTITION clause, including a list of comma-separated partitions,\nsubpartitions, or both. This option follows the name of the table and\nprecedes any alias declaration. The effect of this option is that rows\nare selected only from the listed partitions or subpartitions. Any\npartitions or subpartitions not named in the list are ignored. For more\ninformation and examples, see\nhttps://dev.mysql.com/doc/refman/8.0/en/partitioning-selection.html.\n\nThe syntax of table_factor is extended in MySQL in comparison with\nstandard SQL. The standard accepts only table_reference, not a list of\nthem inside a pair of parentheses.\n\nThis is a conservative extension if each comma in a list of\ntable_reference items is considered as equivalent to an inner join. For\nexample:\n\nSELECT * FROM t1 LEFT JOIN (t2, t3, t4)\n                 ON (t2.a = t1.a AND t3.b = t1.b AND t4.c = t1.c)\n\nis equivalent to:\n\nSELECT * FROM t1 LEFT JOIN (t2 CROSS JOIN t3 CROSS JOIN t4)\n                 ON (t2.a = t1.a AND t3.b = t1.b AND t4.c = t1.c)\n\nIn MySQL, JOIN, CROSS JOIN, and INNER JOIN are syntactic equivalents\n(they can replace each other). In standard SQL, they are not\nequivalent. INNER JOIN is used with an ON clause, CROSS JOIN is used\notherwise.\n\nIn general, parentheses can be ignored in join expressions containing\nonly inner join operations. MySQL also supports nested joins. See\nhttps://dev.mysql.com/doc/refman/8.0/en/nested-join-optimization.html.\n\nIndex hints can be specified to affect how the MySQL optimizer makes\nuse of indexes. For more information, see\nhttps://dev.mysql.com/doc/refman/8.0/en/index-hints.html. Optimizer\nhints and the optimizer_switch system variable are other ways to\ninfluence optimizer use of indexes. See\nhttps://dev.mysql.com/doc/refman/8.0/en/optimizer-hints.html, and\nhttps://dev.mysql.com/doc/refman/8.0/en/switchable-optimizations.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/join.html\n\n','SELECT left_tbl.*\n  FROM left_tbl LEFT JOIN right_tbl ON left_tbl.id = right_tbl.id\n  WHERE right_tbl.id IS NULL;\n','https://dev.mysql.com/doc/refman/8.0/en/join.html'),(558,'TABLE',41,'Syntax:\nTABLE is a DML statement introduced in MySQL 8.0.19 which returns rows\nand columns of the named table.\n\nTABLE table_name [ORDER BY column_name] [LIMIT number [OFFSET number]]\n\nThe TABLE statement in some ways acts like SELECT. Given the existence\nof a table named t, the following two statements produce identical\noutput:\n\nTABLE t;\n\nSELECT * FROM t;\n\nYou can order and limit the number of rows produced by TABLE using\nORDER BY and LIMIT clauses, respectively. These function identically to\nthe same clauses when used with SELECT (including an optional OFFSET\nclause with LIMIT), as you can see here:\n\nmysql> TABLE t;\n+----+----+\n| a  | b  |\n+----+----+\n|  1 |  2 |\n|  6 |  7 |\n|  9 |  5 |\n| 10 | -4 |\n| 11 | -1 |\n| 13 |  3 |\n| 14 |  6 |\n+----+----+\n7 rows in set (0.00 sec)\n\nmysql> TABLE t ORDER BY b;\n+----+----+\n| a  | b  |\n+----+----+\n| 10 | -4 |\n| 11 | -1 |\n|  1 |  2 |\n| 13 |  3 |\n|  9 |  5 |\n| 14 |  6 |\n|  6 |  7 |\n+----+----+\n7 rows in set (0.00 sec)\n\nmysql> TABLE t LIMIT 3;\n+---+---+\n| a | b |\n+---+---+\n| 1 | 2 |\n| 6 | 7 |\n| 9 | 5 |\n+---+---+\n3 rows in set (0.00 sec)\n\nmysql> TABLE t ORDER BY b LIMIT 3;\n+----+----+\n| a  | b  |\n+----+----+\n| 10 | -4 |\n| 11 | -1 |\n|  1 |  2 |\n+----+----+\n3 rows in set (0.00 sec)\n\nmysql> TABLE t ORDER BY b LIMIT 3 OFFSET 2;\n+----+----+\n| a  | b  |\n+----+----+\n|  1 |  2 |\n| 13 |  3 |\n|  9 |  5 |\n+----+----+\n3 rows in set (0.00 sec)\n\nTABLE differs from SELECT in two key respects:\n\no TABLE always displays all columns of the table.\n\n  Exception: The output of TABLE does not include invisible columns.\n  See https://dev.mysql.com/doc/refman/8.0/en/invisible-columns.html.\n\no TABLE does not allow for any arbitrary filtering of rows; that is,\n  TABLE does not support any WHERE clause.\n\nFor limiting which table columns are returned, filtering rows beyond\nwhat can be accomplished using ORDER BY and LIMIT, or both, use SELECT.\n\nTABLE can be used with temporary tables.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/table.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/table.html'),(559,'UPDATE',41,'Syntax:\nUPDATE is a DML statement that modifies rows in a table.\n\nAn UPDATE statement can start with a WITH clause to define common table\nexpressions accessible within the UPDATE. See\nhttps://dev.mysql.com/doc/refman/8.0/en/with.html.\n\nSingle-table syntax:\n\nUPDATE [LOW_PRIORITY] [IGNORE] table_reference\n    SET assignment_list\n    [WHERE where_condition]\n    [ORDER BY ...]\n    [LIMIT row_count]\n\nvalue:\n    {expr | DEFAULT}\n\nassignment:\n    col_name = value\n\nassignment_list:\n    assignment [, assignment] ...\n\nMultiple-table syntax:\n\nUPDATE [LOW_PRIORITY] [IGNORE] table_references\n    SET assignment_list\n    [WHERE where_condition]\n\nFor the single-table syntax, the UPDATE statement updates columns of\nexisting rows in the named table with new values. The SET clause\nindicates which columns to modify and the values they should be given.\nEach value can be given as an expression, or the keyword DEFAULT to set\na column explicitly to its default value. The WHERE clause, if given,\nspecifies the conditions that identify which rows to update. With no\nWHERE clause, all rows are updated. If the ORDER BY clause is\nspecified, the rows are updated in the order that is specified. The\nLIMIT clause places a limit on the number of rows that can be updated.\n\nFor the multiple-table syntax, UPDATE updates rows in each table named\nin table_references that satisfy the conditions. Each matching row is\nupdated once, even if it matches the conditions multiple times. For\nmultiple-table syntax, ORDER BY and LIMIT cannot be used.\n\nFor partitioned tables, both the single-single and multiple-table forms\nof this statement support the use of a PARTITION clause as part of a\ntable reference. This option takes a list of one or more partitions or\nsubpartitions (or both). Only the partitions (or subpartitions) listed\nare checked for matches, and a row that is not in any of these\npartitions or subpartitions is not updated, whether it satisfies the\nwhere_condition or not.\n\n*Note*:\n\nUnlike the case when using PARTITION with an INSERT or REPLACE\nstatement, an otherwise valid UPDATE ... PARTITION statement is\nconsidered successful even if no rows in the listed partitions (or\nsubpartitions) match the where_condition.\n\nFor more information and examples, see\nhttps://dev.mysql.com/doc/refman/8.0/en/partitioning-selection.html.\n\nwhere_condition is an expression that evaluates to true for each row to\nbe updated. For expression syntax, see\nhttps://dev.mysql.com/doc/refman/8.0/en/expressions.html.\n\ntable_references and where_condition are specified as described in\nhttps://dev.mysql.com/doc/refman/8.0/en/select.html.\n\nYou need the UPDATE privilege only for columns referenced in an UPDATE\nthat are actually updated. You need only the SELECT privilege for any\ncolumns that are read but not modified.\n\nThe UPDATE statement supports the following modifiers:\n\no With the LOW_PRIORITY modifier, execution of the UPDATE is delayed\n  until no other clients are reading from the table. This affects only\n  storage engines that use only table-level locking (such as MyISAM,\n  MEMORY, and MERGE).\n\no With the IGNORE modifier, the update statement does not abort even if\n  errors occur during the update. Rows for which duplicate-key\n  conflicts occur on a unique key value are not updated. Rows updated\n  to values that would cause data conversion errors are updated to the\n  closest valid values instead. For more information, see\n  https://dev.mysql.com/doc/refman/8.0/en/sql-mode.html#ignore-effect-o\n  n-execution.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/update.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/update.html'),(560,'UNION',41,'Syntax:\nquery_expression_body UNION [ALL | DISTINCT] query_block\n    [UNION [ALL | DISTINCT] query_expression_body]\n    [...]\n\nquery_expression_body:\n    See \n\nUNION combines the result from multiple query blocks into a single\nresult set. This example uses SELECT statements:\n\nmysql> SELECT 1, 2;\n+---+---+\n| 1 | 2 |\n+---+---+\n| 1 | 2 |\n+---+---+\nmysql> SELECT \'a\', \'b\';\n+---+---+\n| a | b |\n+---+---+\n| a | b |\n+---+---+\nmysql> SELECT 1, 2 UNION SELECT \'a\', \'b\';\n+---+---+\n| 1 | 2 |\n+---+---+\n| 1 | 2 |\n| a | b |\n+---+---+\n\nUNION Handing in MySQL 8.0 Compared to MySQL 5.7\n\nIn MySQL 8.0, the parser rules for SELECT and UNION were refactored to\nbe more consistent (the same SELECT syntax applies uniformly in each\nsuch context) and reduce duplication. Compared to MySQL 5.7, several\nuser-visible effects resulted from this work, which may require\nrewriting of certain statements:\n\no NATURAL JOIN permits an optional INNER keyword (NATURAL INNER JOIN),\n  in compliance with standard SQL.\n\no Right-deep joins without parentheses are permitted (for example, ...\n  JOIN ... JOIN ... ON ... ON), in compliance with standard SQL.\n\no STRAIGHT_JOIN now permits a USING clause, similar to other inner\n  joins.\n\no The parser accepts parentheses around query expressions. For example,\n  (SELECT ... UNION SELECT ...) is permitted. See also [HELP\n  parenthesized query expressions].\n\no The parser better conforms to the documented permitted placement of\n  the SQL_CACHE and SQL_NO_CACHE query modifiers.\n\no Left-hand nesting of unions, previously permitted only in subqueries,\n  is now permitted in top-level statements. For example, this statement\n  is now accepted as valid:\n\n(SELECT 1 UNION SELECT 1) UNION SELECT 1;\n\no Locking clauses (FOR UPDATE, LOCK IN SHARE MODE) are allowed only in\n  non-UNION queries. This means that parentheses must be used for\n  SELECT statements containing locking clauses. This statement is no\n  longer accepted as valid:\n\nSELECT 1 FOR UPDATE UNION SELECT 1 FOR UPDATE;\n\n  Instead, write the statement like this:\n\n(SELECT 1 FOR UPDATE) UNION (SELECT 1 FOR UPDATE);\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/union.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/union.html'),(561,'VALUES STATEMENT',41,'Syntax:\nVALUES row_constructor_list [ORDER BY column_designator] [LIMIT number]\n\nrow_constructor_list:\n    ROW(value_list)[, ROW(value_list)][, ...]\n\nvalue_list:\n    value[, value][, ...]\n\ncolumn_designator:\n    column_index\n\nThe VALUES statement consists of the VALUES keyword followed by a list\nof one or more row constructors, separated by commas. A row constructor\nconsists of the ROW() row constructor clause with a value list of one\nor more scalar values enclosed in the parentheses. A value can be a\nliteral of any MySQL data type or an expression that resolves to a\nscalar value.\n\nROW() cannot be empty (but each of the supplied scalar values can be\nNULL). Each ROW() in the same VALUES statement must have the same\nnumber of values in its value list.\n\nThe DEFAULT keyword is not supported by VALUES and causes a syntax\nerror, except when it is used to supply values in an INSERT statement.\n\nThe output of VALUES is a table:\n\nmysql> VALUES ROW(1,-2,3), ROW(5,7,9), ROW(4,6,8);\n+----------+----------+----------+\n| column_0 | column_1 | column_2 |\n+----------+----------+----------+\n|        1 |       -2 |        3 |\n|        5 |        7 |        9 |\n|        4 |        6 |        8 |\n+----------+----------+----------+\n3 rows in set (0.00 sec)\n\nThe columns of the table output from VALUES have the implicitly named\ncolumns column_0, column_1, column_2, and so on, always beginning with\n0. This fact can be used to order the rows by column using an optional\nORDER BY clause in the same way that this clause works with a SELECT\nstatement, as shown here:\n\nmysql> VALUES ROW(1,-2,3), ROW(5,7,9), ROW(4,6,8) ORDER BY column_1;\n+----------+----------+----------+\n| column_0 | column_1 | column_2 |\n+----------+----------+----------+\n|        1 |       -2 |        3 |\n|        4 |        6 |        8 |\n|        5 |        7 |        9 |\n+----------+----------+----------+\n3 rows in set (0.00 sec)\n\nIn MySQL 8.0.21 and later, the VALUES statement also supports a LIMIT\nclause for limiting the number of rows in the output. (Previously,\nLIMIT was allowed but did nothing.)\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/values.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/values.html'),(562,'START TRANSACTION',42,'Syntax:\nSTART TRANSACTION\n    [transaction_characteristic [, transaction_characteristic] ...]\n\ntransaction_characteristic: {\n    WITH CONSISTENT SNAPSHOT\n  | READ WRITE\n  | READ ONLY\n}\n\nBEGIN [WORK]\nCOMMIT [WORK] [AND [NO] CHAIN] [[NO] RELEASE]\nROLLBACK [WORK] [AND [NO] CHAIN] [[NO] RELEASE]\nSET autocommit = {0 | 1}\n\nThese statements provide control over use of transactions:\n\no START TRANSACTION or BEGIN start a new transaction.\n\no COMMIT commits the current transaction, making its changes permanent.\n\no ROLLBACK rolls back the current transaction, canceling its changes.\n\no SET autocommit disables or enables the default autocommit mode for\n  the current session.\n\nBy default, MySQL runs with autocommit mode enabled. This means that,\nwhen not otherwise inside a transaction, each statement is atomic, as\nif it were surrounded by START TRANSACTION and COMMIT. You cannot use\nROLLBACK to undo the effect; however, if an error occurs during\nstatement execution, the statement is rolled back.\n\nTo disable autocommit mode implicitly for a single series of\nstatements, use the START TRANSACTION statement:\n\nSTART TRANSACTION;\nSELECT @A:=SUM(salary) FROM table1 WHERE type=1;\nUPDATE table2 SET summary=@A WHERE type=1;\nCOMMIT;\n\nWith START TRANSACTION, autocommit remains disabled until you end the\ntransaction with COMMIT or ROLLBACK. The autocommit mode then reverts\nto its previous state.\n\nSTART TRANSACTION permits several modifiers that control transaction\ncharacteristics. To specify multiple modifiers, separate them by\ncommas.\n\no The WITH CONSISTENT SNAPSHOT modifier starts a consistent read for\n  storage engines that are capable of it. This applies only to InnoDB.\n  The effect is the same as issuing a START TRANSACTION followed by a\n  SELECT from any InnoDB table. See\n  https://dev.mysql.com/doc/refman/8.0/en/innodb-consistent-read.html.\n  The WITH CONSISTENT SNAPSHOT modifier does not change the current\n  transaction isolation level, so it provides a consistent snapshot\n  only if the current isolation level is one that permits a consistent\n  read. The only isolation level that permits a consistent read is\n  REPEATABLE READ. For all other isolation levels, the WITH CONSISTENT\n  SNAPSHOT clause is ignored. A warning is generated when the WITH\n  CONSISTENT SNAPSHOT clause is ignored.\n\no The READ WRITE and READ ONLY modifiers set the transaction access\n  mode. They permit or prohibit changes to tables used in the\n  transaction. The READ ONLY restriction prevents the transaction from\n  modifying or locking both transactional and nontransactional tables\n  that are visible to other transactions; the transaction can still\n  modify or lock temporary tables.\n\n  MySQL enables extra optimizations for queries on InnoDB tables when\n  the transaction is known to be read-only. Specifying READ ONLY\n  ensures these optimizations are applied in cases where the read-only\n  status cannot be determined automatically. See\n  https://dev.mysql.com/doc/refman/8.0/en/innodb-performance-ro-txn.htm\n  l for more information.\n\n  If no access mode is specified, the default mode applies. Unless the\n  default has been changed, it is read/write. It is not permitted to\n  specify both READ WRITE and READ ONLY in the same statement.\n\n  In read-only mode, it remains possible to change tables created with\n  the TEMPORARY keyword using DML statements. Changes made with DDL\n  statements are not permitted, just as with permanent tables.\n\n  For additional information about transaction access mode, including\n  ways to change the default mode, see [HELP SET TRANSACTION].\n\n  If the read_only system variable is enabled, explicitly starting a\n  transaction with START TRANSACTION READ WRITE requires the\n  CONNECTION_ADMIN privilege (or the deprecated SUPER privilege).\n\n*Important*:\n\nMany APIs used for writing MySQL client applications (such as JDBC)\nprovide their own methods for starting transactions that can (and\nsometimes should) be used instead of sending a START TRANSACTION\nstatement from the client. See\nhttps://dev.mysql.com/doc/refman/8.0/en/connectors-apis.html, or the\ndocumentation for your API, for more information.\n\nTo disable autocommit mode explicitly, use the following statement:\n\nSET autocommit=0;\n\nAfter disabling autocommit mode by setting the autocommit variable to\nzero, changes to transaction-safe tables (such as those for InnoDB or\nNDB) are not made permanent immediately. You must use COMMIT to store\nyour changes to disk or ROLLBACK to ignore the changes.\n\nautocommit is a session variable and must be set for each session. To\ndisable autocommit mode for each new connection, see the description of\nthe autocommit system variable at\nhttps://dev.mysql.com/doc/refman/8.0/en/server-system-variables.html.\n\nBEGIN and BEGIN WORK are supported as aliases of START TRANSACTION for\ninitiating a transaction. START TRANSACTION is standard SQL syntax, is\nthe recommended way to start an ad-hoc transaction, and permits\nmodifiers that BEGIN does not.\n\nThe BEGIN statement differs from the use of the BEGIN keyword that\nstarts a BEGIN ... END compound statement. The latter does not begin a\ntransaction. See [HELP BEGIN END].\n\n*Note*:\n\nWithin all stored programs (stored procedures and functions, triggers,\nand events), the parser treats BEGIN [WORK] as the beginning of a BEGIN\n... END block. Begin a transaction in this context with START\nTRANSACTION instead.\n\nThe optional WORK keyword is supported for COMMIT and ROLLBACK, as are\nthe CHAIN and RELEASE clauses. CHAIN and RELEASE can be used for\nadditional control over transaction completion. The value of the\ncompletion_type system variable determines the default completion\nbehavior. See\nhttps://dev.mysql.com/doc/refman/8.0/en/server-system-variables.html.\n\nThe AND CHAIN clause causes a new transaction to begin as soon as the\ncurrent one ends, and the new transaction has the same isolation level\nas the just-terminated transaction. The new transaction also uses the\nsame access mode (READ WRITE or READ ONLY) as the just-terminated\ntransaction. The RELEASE clause causes the server to disconnect the\ncurrent client session after terminating the current transaction.\nIncluding the NO keyword suppresses CHAIN or RELEASE completion, which\ncan be useful if the completion_type system variable is set to cause\nchaining or release completion by default.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/commit.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/commit.html'),(563,'BEGIN',42,'Syntax:\nSTART TRANSACTION\n    [transaction_characteristic [, transaction_characteristic] ...]\n\ntransaction_characteristic: {\n    WITH CONSISTENT SNAPSHOT\n  | READ WRITE\n  | READ ONLY\n}\n\nBEGIN [WORK]\nCOMMIT [WORK] [AND [NO] CHAIN] [[NO] RELEASE]\nROLLBACK [WORK] [AND [NO] CHAIN] [[NO] RELEASE]\nSET autocommit = {0 | 1}\n\nThese statements provide control over use of transactions:\n\no START TRANSACTION or BEGIN start a new transaction.\n\no COMMIT commits the current transaction, making its changes permanent.\n\no ROLLBACK rolls back the current transaction, canceling its changes.\n\no SET autocommit disables or enables the default autocommit mode for\n  the current session.\n\nBy default, MySQL runs with autocommit mode enabled. This means that,\nwhen not otherwise inside a transaction, each statement is atomic, as\nif it were surrounded by START TRANSACTION and COMMIT. You cannot use\nROLLBACK to undo the effect; however, if an error occurs during\nstatement execution, the statement is rolled back.\n\nTo disable autocommit mode implicitly for a single series of\nstatements, use the START TRANSACTION statement:\n\nSTART TRANSACTION;\nSELECT @A:=SUM(salary) FROM table1 WHERE type=1;\nUPDATE table2 SET summary=@A WHERE type=1;\nCOMMIT;\n\nWith START TRANSACTION, autocommit remains disabled until you end the\ntransaction with COMMIT or ROLLBACK. The autocommit mode then reverts\nto its previous state.\n\nSTART TRANSACTION permits several modifiers that control transaction\ncharacteristics. To specify multiple modifiers, separate them by\ncommas.\n\no The WITH CONSISTENT SNAPSHOT modifier starts a consistent read for\n  storage engines that are capable of it. This applies only to InnoDB.\n  The effect is the same as issuing a START TRANSACTION followed by a\n  SELECT from any InnoDB table. See\n  https://dev.mysql.com/doc/refman/8.0/en/innodb-consistent-read.html.\n  The WITH CONSISTENT SNAPSHOT modifier does not change the current\n  transaction isolation level, so it provides a consistent snapshot\n  only if the current isolation level is one that permits a consistent\n  read. The only isolation level that permits a consistent read is\n  REPEATABLE READ. For all other isolation levels, the WITH CONSISTENT\n  SNAPSHOT clause is ignored. A warning is generated when the WITH\n  CONSISTENT SNAPSHOT clause is ignored.\n\no The READ WRITE and READ ONLY modifiers set the transaction access\n  mode. They permit or prohibit changes to tables used in the\n  transaction. The READ ONLY restriction prevents the transaction from\n  modifying or locking both transactional and nontransactional tables\n  that are visible to other transactions; the transaction can still\n  modify or lock temporary tables.\n\n  MySQL enables extra optimizations for queries on InnoDB tables when\n  the transaction is known to be read-only. Specifying READ ONLY\n  ensures these optimizations are applied in cases where the read-only\n  status cannot be determined automatically. See\n  https://dev.mysql.com/doc/refman/8.0/en/innodb-performance-ro-txn.htm\n  l for more information.\n\n  If no access mode is specified, the default mode applies. Unless the\n  default has been changed, it is read/write. It is not permitted to\n  specify both READ WRITE and READ ONLY in the same statement.\n\n  In read-only mode, it remains possible to change tables created with\n  the TEMPORARY keyword using DML statements. Changes made with DDL\n  statements are not permitted, just as with permanent tables.\n\n  For additional information about transaction access mode, including\n  ways to change the default mode, see [HELP SET TRANSACTION].\n\n  If the read_only system variable is enabled, explicitly starting a\n  transaction with START TRANSACTION READ WRITE requires the\n  CONNECTION_ADMIN privilege (or the deprecated SUPER privilege).\n\n*Important*:\n\nMany APIs used for writing MySQL client applications (such as JDBC)\nprovide their own methods for starting transactions that can (and\nsometimes should) be used instead of sending a START TRANSACTION\nstatement from the client. See\nhttps://dev.mysql.com/doc/refman/8.0/en/connectors-apis.html, or the\ndocumentation for your API, for more information.\n\nTo disable autocommit mode explicitly, use the following statement:\n\nSET autocommit=0;\n\nAfter disabling autocommit mode by setting the autocommit variable to\nzero, changes to transaction-safe tables (such as those for InnoDB or\nNDB) are not made permanent immediately. You must use COMMIT to store\nyour changes to disk or ROLLBACK to ignore the changes.\n\nautocommit is a session variable and must be set for each session. To\ndisable autocommit mode for each new connection, see the description of\nthe autocommit system variable at\nhttps://dev.mysql.com/doc/refman/8.0/en/server-system-variables.html.\n\nBEGIN and BEGIN WORK are supported as aliases of START TRANSACTION for\ninitiating a transaction. START TRANSACTION is standard SQL syntax, is\nthe recommended way to start an ad-hoc transaction, and permits\nmodifiers that BEGIN does not.\n\nThe BEGIN statement differs from the use of the BEGIN keyword that\nstarts a BEGIN ... END compound statement. The latter does not begin a\ntransaction. See [HELP BEGIN END].\n\n*Note*:\n\nWithin all stored programs (stored procedures and functions, triggers,\nand events), the parser treats BEGIN [WORK] as the beginning of a BEGIN\n... END block. Begin a transaction in this context with START\nTRANSACTION instead.\n\nThe optional WORK keyword is supported for COMMIT and ROLLBACK, as are\nthe CHAIN and RELEASE clauses. CHAIN and RELEASE can be used for\nadditional control over transaction completion. The value of the\ncompletion_type system variable determines the default completion\nbehavior. See\nhttps://dev.mysql.com/doc/refman/8.0/en/server-system-variables.html.\n\nThe AND CHAIN clause causes a new transaction to begin as soon as the\ncurrent one ends, and the new transaction has the same isolation level\nas the just-terminated transaction. The new transaction also uses the\nsame access mode (READ WRITE or READ ONLY) as the just-terminated\ntransaction. The RELEASE clause causes the server to disconnect the\ncurrent client session after terminating the current transaction.\nIncluding the NO keyword suppresses CHAIN or RELEASE completion, which\ncan be useful if the completion_type system variable is set to cause\nchaining or release completion by default.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/commit.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/commit.html'),(564,'COMMIT',42,'Syntax:\nSTART TRANSACTION\n    [transaction_characteristic [, transaction_characteristic] ...]\n\ntransaction_characteristic: {\n    WITH CONSISTENT SNAPSHOT\n  | READ WRITE\n  | READ ONLY\n}\n\nBEGIN [WORK]\nCOMMIT [WORK] [AND [NO] CHAIN] [[NO] RELEASE]\nROLLBACK [WORK] [AND [NO] CHAIN] [[NO] RELEASE]\nSET autocommit = {0 | 1}\n\nThese statements provide control over use of transactions:\n\no START TRANSACTION or BEGIN start a new transaction.\n\no COMMIT commits the current transaction, making its changes permanent.\n\no ROLLBACK rolls back the current transaction, canceling its changes.\n\no SET autocommit disables or enables the default autocommit mode for\n  the current session.\n\nBy default, MySQL runs with autocommit mode enabled. This means that,\nwhen not otherwise inside a transaction, each statement is atomic, as\nif it were surrounded by START TRANSACTION and COMMIT. You cannot use\nROLLBACK to undo the effect; however, if an error occurs during\nstatement execution, the statement is rolled back.\n\nTo disable autocommit mode implicitly for a single series of\nstatements, use the START TRANSACTION statement:\n\nSTART TRANSACTION;\nSELECT @A:=SUM(salary) FROM table1 WHERE type=1;\nUPDATE table2 SET summary=@A WHERE type=1;\nCOMMIT;\n\nWith START TRANSACTION, autocommit remains disabled until you end the\ntransaction with COMMIT or ROLLBACK. The autocommit mode then reverts\nto its previous state.\n\nSTART TRANSACTION permits several modifiers that control transaction\ncharacteristics. To specify multiple modifiers, separate them by\ncommas.\n\no The WITH CONSISTENT SNAPSHOT modifier starts a consistent read for\n  storage engines that are capable of it. This applies only to InnoDB.\n  The effect is the same as issuing a START TRANSACTION followed by a\n  SELECT from any InnoDB table. See\n  https://dev.mysql.com/doc/refman/8.0/en/innodb-consistent-read.html.\n  The WITH CONSISTENT SNAPSHOT modifier does not change the current\n  transaction isolation level, so it provides a consistent snapshot\n  only if the current isolation level is one that permits a consistent\n  read. The only isolation level that permits a consistent read is\n  REPEATABLE READ. For all other isolation levels, the WITH CONSISTENT\n  SNAPSHOT clause is ignored. A warning is generated when the WITH\n  CONSISTENT SNAPSHOT clause is ignored.\n\no The READ WRITE and READ ONLY modifiers set the transaction access\n  mode. They permit or prohibit changes to tables used in the\n  transaction. The READ ONLY restriction prevents the transaction from\n  modifying or locking both transactional and nontransactional tables\n  that are visible to other transactions; the transaction can still\n  modify or lock temporary tables.\n\n  MySQL enables extra optimizations for queries on InnoDB tables when\n  the transaction is known to be read-only. Specifying READ ONLY\n  ensures these optimizations are applied in cases where the read-only\n  status cannot be determined automatically. See\n  https://dev.mysql.com/doc/refman/8.0/en/innodb-performance-ro-txn.htm\n  l for more information.\n\n  If no access mode is specified, the default mode applies. Unless the\n  default has been changed, it is read/write. It is not permitted to\n  specify both READ WRITE and READ ONLY in the same statement.\n\n  In read-only mode, it remains possible to change tables created with\n  the TEMPORARY keyword using DML statements. Changes made with DDL\n  statements are not permitted, just as with permanent tables.\n\n  For additional information about transaction access mode, including\n  ways to change the default mode, see [HELP SET TRANSACTION].\n\n  If the read_only system variable is enabled, explicitly starting a\n  transaction with START TRANSACTION READ WRITE requires the\n  CONNECTION_ADMIN privilege (or the deprecated SUPER privilege).\n\n*Important*:\n\nMany APIs used for writing MySQL client applications (such as JDBC)\nprovide their own methods for starting transactions that can (and\nsometimes should) be used instead of sending a START TRANSACTION\nstatement from the client. See\nhttps://dev.mysql.com/doc/refman/8.0/en/connectors-apis.html, or the\ndocumentation for your API, for more information.\n\nTo disable autocommit mode explicitly, use the following statement:\n\nSET autocommit=0;\n\nAfter disabling autocommit mode by setting the autocommit variable to\nzero, changes to transaction-safe tables (such as those for InnoDB or\nNDB) are not made permanent immediately. You must use COMMIT to store\nyour changes to disk or ROLLBACK to ignore the changes.\n\nautocommit is a session variable and must be set for each session. To\ndisable autocommit mode for each new connection, see the description of\nthe autocommit system variable at\nhttps://dev.mysql.com/doc/refman/8.0/en/server-system-variables.html.\n\nBEGIN and BEGIN WORK are supported as aliases of START TRANSACTION for\ninitiating a transaction. START TRANSACTION is standard SQL syntax, is\nthe recommended way to start an ad-hoc transaction, and permits\nmodifiers that BEGIN does not.\n\nThe BEGIN statement differs from the use of the BEGIN keyword that\nstarts a BEGIN ... END compound statement. The latter does not begin a\ntransaction. See [HELP BEGIN END].\n\n*Note*:\n\nWithin all stored programs (stored procedures and functions, triggers,\nand events), the parser treats BEGIN [WORK] as the beginning of a BEGIN\n... END block. Begin a transaction in this context with START\nTRANSACTION instead.\n\nThe optional WORK keyword is supported for COMMIT and ROLLBACK, as are\nthe CHAIN and RELEASE clauses. CHAIN and RELEASE can be used for\nadditional control over transaction completion. The value of the\ncompletion_type system variable determines the default completion\nbehavior. See\nhttps://dev.mysql.com/doc/refman/8.0/en/server-system-variables.html.\n\nThe AND CHAIN clause causes a new transaction to begin as soon as the\ncurrent one ends, and the new transaction has the same isolation level\nas the just-terminated transaction. The new transaction also uses the\nsame access mode (READ WRITE or READ ONLY) as the just-terminated\ntransaction. The RELEASE clause causes the server to disconnect the\ncurrent client session after terminating the current transaction.\nIncluding the NO keyword suppresses CHAIN or RELEASE completion, which\ncan be useful if the completion_type system variable is set to cause\nchaining or release completion by default.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/commit.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/commit.html'),(565,'ROLLBACK',42,'Syntax:\nSTART TRANSACTION\n    [transaction_characteristic [, transaction_characteristic] ...]\n\ntransaction_characteristic: {\n    WITH CONSISTENT SNAPSHOT\n  | READ WRITE\n  | READ ONLY\n}\n\nBEGIN [WORK]\nCOMMIT [WORK] [AND [NO] CHAIN] [[NO] RELEASE]\nROLLBACK [WORK] [AND [NO] CHAIN] [[NO] RELEASE]\nSET autocommit = {0 | 1}\n\nThese statements provide control over use of transactions:\n\no START TRANSACTION or BEGIN start a new transaction.\n\no COMMIT commits the current transaction, making its changes permanent.\n\no ROLLBACK rolls back the current transaction, canceling its changes.\n\no SET autocommit disables or enables the default autocommit mode for\n  the current session.\n\nBy default, MySQL runs with autocommit mode enabled. This means that,\nwhen not otherwise inside a transaction, each statement is atomic, as\nif it were surrounded by START TRANSACTION and COMMIT. You cannot use\nROLLBACK to undo the effect; however, if an error occurs during\nstatement execution, the statement is rolled back.\n\nTo disable autocommit mode implicitly for a single series of\nstatements, use the START TRANSACTION statement:\n\nSTART TRANSACTION;\nSELECT @A:=SUM(salary) FROM table1 WHERE type=1;\nUPDATE table2 SET summary=@A WHERE type=1;\nCOMMIT;\n\nWith START TRANSACTION, autocommit remains disabled until you end the\ntransaction with COMMIT or ROLLBACK. The autocommit mode then reverts\nto its previous state.\n\nSTART TRANSACTION permits several modifiers that control transaction\ncharacteristics. To specify multiple modifiers, separate them by\ncommas.\n\no The WITH CONSISTENT SNAPSHOT modifier starts a consistent read for\n  storage engines that are capable of it. This applies only to InnoDB.\n  The effect is the same as issuing a START TRANSACTION followed by a\n  SELECT from any InnoDB table. See\n  https://dev.mysql.com/doc/refman/8.0/en/innodb-consistent-read.html.\n  The WITH CONSISTENT SNAPSHOT modifier does not change the current\n  transaction isolation level, so it provides a consistent snapshot\n  only if the current isolation level is one that permits a consistent\n  read. The only isolation level that permits a consistent read is\n  REPEATABLE READ. For all other isolation levels, the WITH CONSISTENT\n  SNAPSHOT clause is ignored. A warning is generated when the WITH\n  CONSISTENT SNAPSHOT clause is ignored.\n\no The READ WRITE and READ ONLY modifiers set the transaction access\n  mode. They permit or prohibit changes to tables used in the\n  transaction. The READ ONLY restriction prevents the transaction from\n  modifying or locking both transactional and nontransactional tables\n  that are visible to other transactions; the transaction can still\n  modify or lock temporary tables.\n\n  MySQL enables extra optimizations for queries on InnoDB tables when\n  the transaction is known to be read-only. Specifying READ ONLY\n  ensures these optimizations are applied in cases where the read-only\n  status cannot be determined automatically. See\n  https://dev.mysql.com/doc/refman/8.0/en/innodb-performance-ro-txn.htm\n  l for more information.\n\n  If no access mode is specified, the default mode applies. Unless the\n  default has been changed, it is read/write. It is not permitted to\n  specify both READ WRITE and READ ONLY in the same statement.\n\n  In read-only mode, it remains possible to change tables created with\n  the TEMPORARY keyword using DML statements. Changes made with DDL\n  statements are not permitted, just as with permanent tables.\n\n  For additional information about transaction access mode, including\n  ways to change the default mode, see [HELP SET TRANSACTION].\n\n  If the read_only system variable is enabled, explicitly starting a\n  transaction with START TRANSACTION READ WRITE requires the\n  CONNECTION_ADMIN privilege (or the deprecated SUPER privilege).\n\n*Important*:\n\nMany APIs used for writing MySQL client applications (such as JDBC)\nprovide their own methods for starting transactions that can (and\nsometimes should) be used instead of sending a START TRANSACTION\nstatement from the client. See\nhttps://dev.mysql.com/doc/refman/8.0/en/connectors-apis.html, or the\ndocumentation for your API, for more information.\n\nTo disable autocommit mode explicitly, use the following statement:\n\nSET autocommit=0;\n\nAfter disabling autocommit mode by setting the autocommit variable to\nzero, changes to transaction-safe tables (such as those for InnoDB or\nNDB) are not made permanent immediately. You must use COMMIT to store\nyour changes to disk or ROLLBACK to ignore the changes.\n\nautocommit is a session variable and must be set for each session. To\ndisable autocommit mode for each new connection, see the description of\nthe autocommit system variable at\nhttps://dev.mysql.com/doc/refman/8.0/en/server-system-variables.html.\n\nBEGIN and BEGIN WORK are supported as aliases of START TRANSACTION for\ninitiating a transaction. START TRANSACTION is standard SQL syntax, is\nthe recommended way to start an ad-hoc transaction, and permits\nmodifiers that BEGIN does not.\n\nThe BEGIN statement differs from the use of the BEGIN keyword that\nstarts a BEGIN ... END compound statement. The latter does not begin a\ntransaction. See [HELP BEGIN END].\n\n*Note*:\n\nWithin all stored programs (stored procedures and functions, triggers,\nand events), the parser treats BEGIN [WORK] as the beginning of a BEGIN\n... END block. Begin a transaction in this context with START\nTRANSACTION instead.\n\nThe optional WORK keyword is supported for COMMIT and ROLLBACK, as are\nthe CHAIN and RELEASE clauses. CHAIN and RELEASE can be used for\nadditional control over transaction completion. The value of the\ncompletion_type system variable determines the default completion\nbehavior. See\nhttps://dev.mysql.com/doc/refman/8.0/en/server-system-variables.html.\n\nThe AND CHAIN clause causes a new transaction to begin as soon as the\ncurrent one ends, and the new transaction has the same isolation level\nas the just-terminated transaction. The new transaction also uses the\nsame access mode (READ WRITE or READ ONLY) as the just-terminated\ntransaction. The RELEASE clause causes the server to disconnect the\ncurrent client session after terminating the current transaction.\nIncluding the NO keyword suppresses CHAIN or RELEASE completion, which\ncan be useful if the completion_type system variable is set to cause\nchaining or release completion by default.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/commit.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/commit.html'),(566,'SAVEPOINT',42,'Syntax:\nSAVEPOINT identifier\nROLLBACK [WORK] TO [SAVEPOINT] identifier\nRELEASE SAVEPOINT identifier\n\nInnoDB supports the SQL statements SAVEPOINT, ROLLBACK TO SAVEPOINT,\nRELEASE SAVEPOINT and the optional WORK keyword for ROLLBACK.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/savepoint.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/savepoint.html'),(567,'ROLLBACK TO SAVEPOINT',42,'Syntax:\nSAVEPOINT identifier\nROLLBACK [WORK] TO [SAVEPOINT] identifier\nRELEASE SAVEPOINT identifier\n\nInnoDB supports the SQL statements SAVEPOINT, ROLLBACK TO SAVEPOINT,\nRELEASE SAVEPOINT and the optional WORK keyword for ROLLBACK.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/savepoint.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/savepoint.html'),(568,'RELEASE SAVEPOINT',42,'Syntax:\nSAVEPOINT identifier\nROLLBACK [WORK] TO [SAVEPOINT] identifier\nRELEASE SAVEPOINT identifier\n\nInnoDB supports the SQL statements SAVEPOINT, ROLLBACK TO SAVEPOINT,\nRELEASE SAVEPOINT and the optional WORK keyword for ROLLBACK.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/savepoint.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/savepoint.html'),(569,'LOCK INSTANCE FOR BACKUP',42,'Syntax:\nLOCK INSTANCE FOR BACKUP\n\nUNLOCK INSTANCE\n\nLOCK INSTANCE FOR BACKUP acquires an instance-level backup lock that\npermits DML during an online backup while preventing operations that\ncould result in an inconsistent snapshot.\n\nExecuting the LOCK INSTANCE FOR BACKUP statement requires the\nBACKUP_ADMIN privilege. The BACKUP_ADMIN privilege is automatically\ngranted to users with the RELOAD privilege when performing an in-place\nupgrade to MySQL 8.0 from an earlier version.\n\nMultiple sessions can hold a backup lock simultaneously.\n\nUNLOCK INSTANCE releases a backup lock held by the current session. A\nbackup lock held by a session is also released if the session is\nterminated.\n\nLOCK INSTANCE FOR BACKUP prevents files from being created, renamed, or\nremoved. REPAIR TABLE TRUNCATE TABLE, OPTIMIZE TABLE, and account\nmanagement statements are blocked. See\nhttps://dev.mysql.com/doc/refman/8.0/en/account-management-statements.html\n. Operations that modify InnoDB files that are not recorded in the\nInnoDB redo log are also blocked.\n\nLOCK INSTANCE FOR BACKUP permits DDL operations that only affect\nuser-created temporary tables. In effect, files that belong to\nuser-created temporary tables can be created, renamed, or removed while\na backup lock is held. Creation of binary log files is also permitted.\n\nPURGE BINARY LOGS should not be issued while a LOCK INSTANCE FOR BACKUP\nstatement is in effect for the instance, because it contravenes the\nrules of the backup lock by removing files from the server. From MySQL\n8.0.28, this is disallowed.\n\nA backup lock acquired by LOCK INSTANCE FOR BACKUP is independent of\ntransactional locks and locks taken by FLUSH TABLES tbl_name [,\ntbl_name] ... WITH READ LOCK, and the following sequences of statements\nare permitted:\n\nLOCK INSTANCE FOR BACKUP;\nFLUSH TABLES tbl_name [, tbl_name] ... WITH READ LOCK;\nUNLOCK TABLES;\nUNLOCK INSTANCE;\n\nFLUSH TABLES tbl_name [, tbl_name] ... WITH READ LOCK;\nLOCK INSTANCE FOR BACKUP;\nUNLOCK INSTANCE;\nUNLOCK TABLES;\n\nThe lock_wait_timeout setting defines the amount of time that a LOCK\nINSTANCE FOR BACKUP statement waits to acquire a lock before giving up.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/lock-instance-for-backup.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/lock-instance-for-backup.html'),(570,'LOCK TABLES',42,'Syntax:\nLOCK TABLES\n    tbl_name [[AS] alias] lock_type\n    [, tbl_name [[AS] alias] lock_type] ...\n\nlock_type: {\n    READ [LOCAL]\n  | [LOW_PRIORITY] WRITE\n}\n\nUNLOCK TABLES\n\nMySQL enables client sessions to acquire table locks explicitly for the\npurpose of cooperating with other sessions for access to tables, or to\nprevent other sessions from modifying tables during periods when a\nsession requires exclusive access to them. A session can acquire or\nrelease locks only for itself. One session cannot acquire locks for\nanother session or release locks held by another session.\n\nLocks may be used to emulate transactions or to get more speed when\nupdating tables. This is explained in more detail in\nhttps://dev.mysql.com/doc/refman/8.0/en/lock-tables.html#lock-tables-re\nstrictions.\n\nLOCK TABLES explicitly acquires table locks for the current client\nsession. Table locks can be acquired for base tables or views. You must\nhave the LOCK TABLES privilege, and the SELECT privilege for each\nobject to be locked.\n\nFor view locking, LOCK TABLES adds all base tables used in the view to\nthe set of tables to be locked and locks them automatically. For tables\nunderlying any view being locked, LOCK TABLES checks that the view\ndefiner (for SQL SECURITY DEFINER views) or invoker (for all views) has\nthe proper privileges on the tables.\n\nIf you lock a table explicitly with LOCK TABLES, any tables used in\ntriggers are also locked implicitly, as described in\nhttps://dev.mysql.com/doc/refman/8.0/en/lock-tables.html#lock-tables-an\nd-triggers.\n\nIf you lock a table explicitly with LOCK TABLES, any tables related by\na foreign key constraint are opened and locked implicitly. For foreign\nkey checks, a shared read-only lock (LOCK TABLES READ) is taken on\nrelated tables. For cascading updates, a shared-nothing write lock\n(LOCK TABLES WRITE) is taken on related tables that are involved in the\noperation.\n\nUNLOCK TABLES explicitly releases any table locks held by the current\nsession. LOCK TABLES implicitly releases any table locks held by the\ncurrent session before acquiring new locks.\n\nAnother use for UNLOCK TABLES is to release the global read lock\nacquired with the FLUSH TABLES WITH READ LOCK statement, which enables\nyou to lock all tables in all databases. See [HELP FLUSH]. (This is a\nvery convenient way to get backups if you have a file system such as\nVeritas that can take snapshots in time.)\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/lock-tables.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/lock-tables.html'),(571,'SET TRANSACTION',42,'Syntax:\nSET [GLOBAL | SESSION] TRANSACTION\n    transaction_characteristic [, transaction_characteristic] ...\n\ntransaction_characteristic: {\n    ISOLATION LEVEL level\n  | access_mode\n}\n\nlevel: {\n     REPEATABLE READ\n   | READ COMMITTED\n   | READ UNCOMMITTED\n   | SERIALIZABLE\n}\n\naccess_mode: {\n     READ WRITE\n   | READ ONLY\n}\n\nThis statement specifies transaction characteristics. It takes a list\nof one or more characteristic values separated by commas. Each\ncharacteristic value sets the transaction isolation level or access\nmode. The isolation level is used for operations on InnoDB tables. The\naccess mode specifies whether transactions operate in read/write or\nread-only mode.\n\nIn addition, SET TRANSACTION can include an optional GLOBAL or SESSION\nkeyword to indicate the scope of the statement.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/set-transaction.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/set-transaction.html'),(572,'XA',42,'Syntax:\nXA {START|BEGIN} xid [JOIN|RESUME]\n\nXA END xid [SUSPEND [FOR MIGRATE]]\n\nXA PREPARE xid\n\nXA COMMIT xid [ONE PHASE]\n\nXA ROLLBACK xid\n\nXA RECOVER [CONVERT XID]\n\nFor XA START, the JOIN and RESUME clauses are recognized but have no\neffect.\n\nFor XA END the SUSPEND [FOR MIGRATE] clause is recognized but has no\neffect.\n\nEach XA statement begins with the XA keyword, and most of them require\nan xid value. An xid is an XA transaction identifier. It indicates\nwhich transaction the statement applies to. xid values are supplied by\nthe client, or generated by the MySQL server. An xid value has from one\nto three parts:\n\nxid: gtrid [, bqual [, formatID ]]\n\ngtrid is a global transaction identifier, bqual is a branch qualifier,\nand formatID is a number that identifies the format used by the gtrid\nand bqual values. As indicated by the syntax, bqual and formatID are\noptional. The default bqual value is \'\' if not given. The default\nformatID value is 1 if not given.\n\ngtrid and bqual must be string literals, each up to 64 bytes (not\ncharacters) long. gtrid and bqual can be specified in several ways. You\ncan use a quoted string (\'ab\'), hex string (X\'6162\', 0x6162), or bit\nvalue (b\'nnnn\').\n\nformatID is an unsigned integer.\n\nThe gtrid and bqual values are interpreted in bytes by the MySQL\nserver\'s underlying XA support routines. However, while an SQL\nstatement containing an XA statement is being parsed, the server works\nwith some specific character set. To be safe, write gtrid and bqual as\nhex strings.\n\nxid values typically are generated by the Transaction Manager. Values\ngenerated by one TM must be different from values generated by other\nTMs. A given TM must be able to recognize its own xid values in a list\nof values returned by the XA RECOVER statement.\n\nXA START xid starts an XA transaction with the given xid value. Each XA\ntransaction must have a unique xid value, so the value must not\ncurrently be used by another XA transaction. Uniqueness is assessed\nusing the gtrid and bqual values. All following XA statements for the\nXA transaction must be specified using the same xid value as that given\nin the XA START statement. If you use any of those statements but\nspecify an xid value that does not correspond to some existing XA\ntransaction, an error occurs.\n\nBeginning with MySQL 8.0.31, XA START, XA BEGIN, XA END, XA COMMIT, and\nXA ROLLBACK statements are not filtered by the default database when\nthe server is running with --replicate-do-db or --replicate-ignore-db.\n\nOne or more XA transactions can be part of the same global transaction.\nAll XA transactions within a given global transaction must use the same\ngtrid value in the xid value. For this reason, gtrid values must be\nglobally unique so that there is no ambiguity about which global\ntransaction a given XA transaction is part of. The bqual part of the\nxid value must be different for each XA transaction within a global\ntransaction. (The requirement that bqual values be different is a\nlimitation of the current MySQL XA implementation. It is not part of\nthe XA specification.)\n\nThe XA RECOVER statement returns information for those XA transactions\non the MySQL server that are in the PREPARED state. (See\nhttps://dev.mysql.com/doc/refman/8.0/en/xa-states.html.) The output\nincludes a row for each such XA transaction on the server, regardless\nof which client started it.\n\nXA RECOVER requires the XA_RECOVER_ADMIN privilege. This privilege\nrequirement prevents users from discovering the XID values for\noutstanding prepared XA transactions other than their own. It does not\naffect normal commit or rollback of an XA transaction because the user\nwho started it knows its XID.\n\nXA RECOVER output rows look like this (for an example xid value\nconsisting of the parts \'abc\', \'def\', and 7):\n\nmysql> XA RECOVER;\n+----------+--------------+--------------+--------+\n| formatID | gtrid_length | bqual_length | data   |\n+----------+--------------+--------------+--------+\n|        7 |            3 |            3 | abcdef |\n+----------+--------------+--------------+--------+\n\nThe output columns have the following meanings:\n\no formatID is the formatID part of the transaction xid\n\no gtrid_length is the length in bytes of the gtrid part of the xid\n\no bqual_length is the length in bytes of the bqual part of the xid\n\no data is the concatenation of the gtrid and bqual parts of the xid\n\nXID values may contain nonprintable characters. XA RECOVER permits an\noptional CONVERT XID clause so that clients can request XID values in\nhexadecimal.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/xa-statements.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/xa-statements.html'),(573,'PURGE BINARY LOGS',43,'Syntax:\nPURGE { BINARY | MASTER } LOGS {\n    TO \'log_name\'\n  | BEFORE datetime_expr\n}\n\nThe binary log is a set of files that contain information about data\nmodifications made by the MySQL server. The log consists of a set of\nbinary log files, plus an index file (see\nhttps://dev.mysql.com/doc/refman/8.0/en/binary-log.html).\n\nThe PURGE BINARY LOGS statement deletes all the binary log files listed\nin the log index file prior to the specified log file name or date.\nBINARY and MASTER are synonyms. Deleted log files also are removed from\nthe list recorded in the index file, so that the given log file becomes\nthe first in the list.\n\nPURGE BINARY LOGS requires the BINLOG_ADMIN privilege. This statement\nhas no effect if the server was not started with the --log-bin option\nto enable binary logging.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/purge-binary-logs.html\n\n','PURGE BINARY LOGS TO \'mysql-bin.010\';\nPURGE BINARY LOGS BEFORE \'2019-04-02 22:46:26\';\n','https://dev.mysql.com/doc/refman/8.0/en/purge-binary-logs.html'),(574,'PURGE MASTER LOGS',43,'Syntax:\nPURGE { BINARY | MASTER } LOGS {\n    TO \'log_name\'\n  | BEFORE datetime_expr\n}\n\nThe binary log is a set of files that contain information about data\nmodifications made by the MySQL server. The log consists of a set of\nbinary log files, plus an index file (see\nhttps://dev.mysql.com/doc/refman/8.0/en/binary-log.html).\n\nThe PURGE BINARY LOGS statement deletes all the binary log files listed\nin the log index file prior to the specified log file name or date.\nBINARY and MASTER are synonyms. Deleted log files also are removed from\nthe list recorded in the index file, so that the given log file becomes\nthe first in the list.\n\nPURGE BINARY LOGS requires the BINLOG_ADMIN privilege. This statement\nhas no effect if the server was not started with the --log-bin option\nto enable binary logging.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/purge-binary-logs.html\n\n','PURGE BINARY LOGS TO \'mysql-bin.010\';\nPURGE BINARY LOGS BEFORE \'2019-04-02 22:46:26\';\n','https://dev.mysql.com/doc/refman/8.0/en/purge-binary-logs.html'),(575,'RESET MASTER',43,'Syntax:\nRESET MASTER [TO binary_log_file_index_number]\n\n*Warning*:\n\nUse this statement with caution to ensure you do not lose any wanted\nbinary log file data and GTID execution history.\n\nRESET MASTER requires the RELOAD privilege.\n\nFor a server where binary logging is enabled (log_bin is ON), RESET\nMASTER deletes all existing binary log files and resets the binary log\nindex file, resetting the server to its state before binary logging was\nstarted. A new empty binary log file is created so that binary logging\ncan be restarted.\n\nFor a server where GTIDs are in use (gtid_mode is ON), issuing RESET\nMASTER resets the GTID execution history. The value of the gtid_purged\nsystem variable is set to an empty string (\'\'), the global value (but\nnot the session value) of the gtid_executed system variable is set to\nan empty string, and the mysql.gtid_executed table is cleared (see\nhttps://dev.mysql.com/doc/refman/8.0/en/replication-gtids-concepts.html\n#replication-gtids-gtid-executed-table). If the GTID-enabled server has\nbinary logging enabled, RESET MASTER also resets the binary log as\ndescribed above. Note that RESET MASTER is the method to reset the GTID\nexecution history even if the GTID-enabled server is a replica where\nbinary logging is disabled; RESET REPLICA has no effect on the GTID\nexecution history. For more information on resetting the GTID execution\nhistory, see\nhttps://dev.mysql.com/doc/refman/8.0/en/replication-gtids-lifecycle.html\n#replication-gtids-execution-history.\n\nIssuing RESET MASTER without the optional TO clause deletes all binary\nlog files listed in the index file, resets the binary log index file to\nbe empty, and creates a new binary log file starting at 1. Use the\noptional TO clause to start the binary log file index from a number\nother than 1 after the reset.\n\nUsing RESET MASTER with the TO clause to specify a binary log file\nindex number to start from simplifies failover by providing a single\nstatement alternative to the FLUSH BINARY LOGS and PURGE BINARY LOGS TO\nstatements. Check that you are using a reasonable value for the index\nnumber. If you enter an incorrect value, you can correct this by\nissuing another RESET MASTER statement with or without the TO clause.\nIf you do not correct a value that is out of range, the server cannot\nbe restarted.\n\nThe following example demonstrates TO clause usage:\n\nRESET MASTER TO 1234;\n\nSHOW BINARY LOGS;\n+-------------------+-----------+-----------+\n| Log_name          | File_size | Encrypted |\n+-------------------+-----------+-----------+\n| source-bin.001234 |       154 | No        |\n+-------------------+-----------+-----------+\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/reset-master.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/reset-master.html'),(576,'SET SQL_LOG_BIN',43,'Syntax:\nSET sql_log_bin = {OFF|ON}\n\nThe sql_log_bin variable controls whether logging to the binary log is\nenabled for the current session (assuming that the binary log itself is\nenabled). The default value is ON. To disable or enable binary logging\nfor the current session, set the session sql_log_bin variable to OFF or\nON.\n\nSet this variable to OFF for a session to temporarily disable binary\nlogging while making changes to the source that you do not want\nreplicated to the replica.\n\nSetting the session value of this system variable is a restricted\noperation. The session user must have privileges sufficient to set\nrestricted session variables. See\nhttps://dev.mysql.com/doc/refman/8.0/en/system-variable-privileges.html\n.\n\nIt is not possible to set the session value of sql_log_bin within a\ntransaction or subquery.\n\nSetting this variable to OFF prevents new GTIDs from being assigned to\ntransactions in the binary log. If you are using GTIDs for replication,\nthis means that even when binary logging is later enabled again, the\nGTIDs written into the log from this point do not account for any\ntransactions that occurred in the meantime, so in effect those\ntransactions are lost.\n\nmysqldump adds a SET @@SESSION.sql_log_bin=0 statement to a dump file\nfrom a server where GTIDs are in use, which disables binary logging\nwhile the dump file is being reloaded. The statement prevents new GTIDs\nfrom being generated and assigned to the transactions in the dump file\nas they are executed, so that the original GTIDs for the transactions\nare used.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/set-sql-log-bin.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/set-sql-log-bin.html'),(577,'CHANGE MASTER TO',43,'Syntax:\nCHANGE MASTER TO option [, option] ... [ channel_option ]\n\noption: {\n    MASTER_BIND = \'interface_name\'\n  | MASTER_HOST = \'host_name\'\n  | MASTER_USER = \'user_name\'\n  | MASTER_PASSWORD = \'password\'\n  | MASTER_PORT = port_num\n  | PRIVILEGE_CHECKS_USER = {\'account\' | NULL}\n  | REQUIRE_ROW_FORMAT = {0|1}\n  | REQUIRE_TABLE_PRIMARY_KEY_CHECK = {STREAM | ON | OFF}\n  | ASSIGN_GTIDS_TO_ANONYMOUS_TRANSACTIONS = {OFF | LOCAL | uuid}\n  | MASTER_LOG_FILE = \'source_log_name\'\n  | MASTER_LOG_POS = source_log_pos\n  | MASTER_AUTO_POSITION = {0|1}\n  | RELAY_LOG_FILE = \'relay_log_name\'\n  | RELAY_LOG_POS = relay_log_pos\n  | MASTER_HEARTBEAT_PERIOD = interval\n  | MASTER_CONNECT_RETRY = interval\n  | MASTER_RETRY_COUNT = count\n  | SOURCE_CONNECTION_AUTO_FAILOVER = {0|1}\n  | MASTER_DELAY = interval\n  | MASTER_COMPRESSION_ALGORITHMS = \'algorithm[,algorithm][,algorithm]\'\n  | MASTER_ZSTD_COMPRESSION_LEVEL = level\n  | MASTER_SSL = {0|1}\n  | MASTER_SSL_CA = \'ca_file_name\'\n  | MASTER_SSL_CAPATH = \'ca_directory_name\'\n  | MASTER_SSL_CERT = \'cert_file_name\'\n  | MASTER_SSL_CRL = \'crl_file_name\'\n  | MASTER_SSL_CRLPATH = \'crl_directory_name\'\n  | MASTER_SSL_KEY = \'key_file_name\'\n  | MASTER_SSL_CIPHER = \'cipher_list\'\n  | MASTER_SSL_VERIFY_SERVER_CERT = {0|1}\n  | MASTER_TLS_VERSION = \'protocol_list\'\n  | MASTER_TLS_CIPHERSUITES = \'ciphersuite_list\'\n  | MASTER_PUBLIC_KEY_PATH = \'key_file_name\'\n  | GET_MASTER_PUBLIC_KEY = {0|1}\n  | NETWORK_NAMESPACE = \'namespace\'\n  | IGNORE_SERVER_IDS = (server_id_list),\n  | GTID_ONLY = {0|1}\n}\n\nchannel_option:\n    FOR CHANNEL channel\n\nserver_id_list:\n    [server_id [, server_id] ... ]\n\nCHANGE MASTER TO changes the parameters that the replica server uses\nfor connecting to the source and for reading data from the source. It\nalso updates the contents of the replication metadata repositories (see\nhttps://dev.mysql.com/doc/refman/8.0/en/replica-logs.html). From MySQL\n8.0.23, use CHANGE REPLICATION SOURCE TO in place of CHANGE MASTER TO,\nwhich is deprecated from that release. In releases before MySQL 8.0.23,\nuse CHANGE MASTER TO.\n\nCHANGE MASTER TO requires the REPLICATION_SLAVE_ADMIN privilege (or the\ndeprecated SUPER privilege).\n\nOptions that you do not specify on a CHANGE MASTER TO statement retain\ntheir value, except as indicated in the following discussion. In most\ncases, there is therefore no need to specify options that do not\nchange.\n\nValues used for SOURCE_HOST and other CHANGE REPLICATION SOURCE TO\noptions are checked for linefeed (\\n or 0x0A) characters. The presence\nof such characters in these values causes the statement to fail with an\nerror.\n\nThe optional FOR CHANNEL channel clause enables you to name which\nreplication channel the statement applies to. Providing a FOR CHANNEL\nchannel clause applies the CHANGE MASTER TO statement to a specific\nreplication channel, and is used to add a new channel or modify an\nexisting channel. For example, to add a new channel called channel2:\n\nCHANGE MASTER TO MASTER_HOST=host1, MASTER_PORT=3002 FOR CHANNEL \'channel2\'\n\nIf no clause is named and no extra channels exist, a CHANGE MASTER TO\nstatement applies to the default channel, whose name is the empty\nstring (\"\"). When you have set up multiple replication channels, every\nCHANGE MASTER TO statement must name a channel using the FOR CHANNEL\nchannel clause. See\nhttps://dev.mysql.com/doc/refman/8.0/en/replication-channels.html for\nmore information.\n\nFor some of the options of the CHANGE MASTER TO statement, you must\nissue a STOP SLAVE statement prior to issuing a CHANGE MASTER TO\nstatement (and a START SLAVE statement afterwards). Sometimes, you only\nneed to stop the replication SQL (applier) thread or the replication\nI/O (receiver) thread, not both:\n\no When the applier thread is stopped, you can execute CHANGE MASTER TO\n  using any combination that is otherwise allowed of RELAY_LOG_FILE,\n  RELAY_LOG_POS, and MASTER_DELAY options, even if the replication\n  receiver thread is running. No other options may be used with this\n  statement when the receiver thread is running.\n\no When the receiver thread is stopped, you can execute CHANGE MASTER TO\n  using any of the options for this statement (in any allowed\n  combination) except RELAY_LOG_FILE, RELAY_LOG_POS, MASTER_DELAY, or\n  MASTER_AUTO_POSITION = 1 even when the applier thread is running.\n\no Both the receiver thread and the applier thread must be stopped\n  before issuing a CHANGE MASTER TO statement that employs\n  MASTER_AUTO_POSITION = 1, GTID_ONLY = 1, or\n  ASSIGN_GTIDS_TO_ANONYMOUS_TRANSACTIONS.\n\nYou can check the current state of the replication applier thread and\nreplication receiver thread using SHOW SLAVE STATUS. Note that the\nGroup Replication applier channel (group_replication_applier) has no\nreceiver thread, only an applier thread.\n\nCHANGE MASTER TO statements have a number of side-effects and\ninteractions that you should be aware of beforehand:\n\no CHANGE MASTER TO causes an implicit commit of an ongoing transaction.\n  See https://dev.mysql.com/doc/refman/8.0/en/implicit-commit.html.\n\no CHANGE MASTER TO causes the previous values for MASTER_HOST,\n  MASTER_PORT, MASTER_LOG_FILE, and MASTER_LOG_POS to be written to the\n  error log, along with other information about the replica\'s state\n  prior to execution.\n\no If you are using statement-based replication and temporary tables, it\n  is possible for a CHANGE MASTER TO statement following a STOP SLAVE\n  statement to leave behind temporary tables on the replica. A warning\n  (ER_WARN_OPEN_TEMP_TABLES_MUST_BE_ZERO\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_warn_open_temp_tables_must_be_zero)) is issued\n  whenever this occurs. You can avoid this in such cases by making sure\n  that the value of the Replica_open_temp_tables or\n  Slave_open_temp_tables system status variable is equal to 0 prior to\n  executing such a CHANGE MASTER TO statement.\n\no When using a multithreaded replica (replica_parallel_workers > 0 or\n  slave_parallel_workers > 0), stopping the replica can cause gaps in\n  the sequence of transactions that have been executed from the relay\n  log, regardless of whether the replica was stopped intentionally or\n  otherwise. When such gaps exist, issuing CHANGE MASTER TO fails. The\n  solution in this situation is to issue START SLAVE UNTIL\n  SQL_AFTER_MTS_GAPS which ensures that the gaps are closed. From MySQL\n  8.0.26, the process of checking for gaps in the sequence of\n  transactions is skipped entirely when GTID-based replication and GTID\n  auto-positioning are in use, because gaps in transactions can be\n  resolved using GTID auto-positioning. In that situation, CHANGE\n  MASTER TO can still be used.\n\nThe following options are available for CHANGE MASTER TO statements:\n\no ASSIGN_GTIDS_TO_ANONYMOUS_TRANSACTIONS = {OFF | LOCAL | uuid}\n\n  Makes the replication channel assign a GTID to replicated\n  transactions that do not have one, enabling replication from a source\n  that does not use GTID-based replication, to a replica that does. For\n  a multi-source replica, you can have a mix of channels that use\n  ASSIGN_GTIDS_TO_ANONYMOUS_TRANSACTIONS, and channels that do not. The\n  default is OFF, meaning that the feature is not used.\n\n  LOCAL assigns a GTID including the replica\'s own UUID (the\n  server_uuid setting). uuid assigns a GTID including the specified\n  UUID, such as the server_uuid setting for the replication source\n  server. Using a nonlocal UUID lets you differentiate between\n  transactions that originated on the replica and transactions that\n  originated on the source, and for a multi-source replica, between\n  transactions that originated on different sources. The UUID you\n  choose only has significance for the replica\'s own use. If any of the\n  transactions sent by the source do have a GTID already, that GTID is\n  retained.\n\n  Channels specific to Group Replication cannot use\n  ASSIGN_GTIDS_TO_ANONYMOUS_TRANSACTIONS, but an asynchronous\n  replication channel for another source on a server instance that is a\n  Group Replication group member can do so. In that case, do not\n  specify the Group Replication group name as the UUID for creating the\n  GTIDs.\n\n  To set ASSIGN_GTIDS_TO_ANONYMOUS_TRANSACTIONS to LOCAL or uuid, the\n  replica must have gtid_mode=ON set, and this cannot be changed\n  afterwards. This option is for use with a source that has binary log\n  file position based replication, so MASTER_AUTO_POSITION=1 cannot be\n  set for the channel. Both the replication SQL thread and the\n  replication I/O (receiver) thread must be stopped before setting this\n  option.\n\n  *Important*:\n\n  A replica set up with ASSIGN_GTIDS_TO_ANONYMOUS_TRANSACTIONS on any\n  channel cannot be promoted to replace the replication source server\n  in the event that a failover is required, and a backup taken from the\n  replica cannot be used to restore the replication source server. The\n  same restriction applies to replacing or restoring other replicas\n  that use ASSIGN_GTIDS_TO_ANONYMOUS_TRANSACTIONS on any channel.\n\n  For further restrictions and information, see\n  https://dev.mysql.com/doc/refman/8.0/en/replication-gtids-assign-anon\n  .html.\n\no GET_MASTER_PUBLIC_KEY = {0|1}\n\n  Enables RSA key pair-based password exchange by requesting the public\n  key from the source. The option is disabled by default.\n\n  This option applies to replicas that authenticate with the\n  caching_sha2_password authentication plugin. For connections by\n  accounts that authenticate using this plugin, the source does not\n  send the public key unless requested, so it must be requested or\n  specified in the client. If MASTER_PUBLIC_KEY_PATH is given and\n  specifies a valid public key file, it takes precedence over\n  GET_MASTER_PUBLIC_KEY. If you are using a replication user account\n  that authenticates with the caching_sha2_password plugin (which is\n  the default from MySQL 8.0), and you are not using a secure\n  connection, you must specify either this option or the\n  MASTER_PUBLIC_KEY_PATH option to provide the RSA public key to the\n  replica.\n\no GTID_ONLY = {0|1}\n\n  Stops the replication channel persisting file names and file\n  positions in the replication metadata repositories. GTID_ONLY is\n  available as of MySQL 8.0.27. The GTID_ONLY option is disabled by\n  default for asynchronous replication channels, but it is enabled by\n  default for Group Replication channels, and it cannot be disabled for\n  them.\n\n  For replication channels with this setting, in-memory file positions\n  are still tracked, and file positions can still be observed for\n  debugging purposes in error messages and through interfaces such as\n  SHOW REPLICA STATUS statements (where they are shown as being invalid\n  if they are out of date). However, the writes and reads required to\n  persist and check the file positions are avoided in situations where\n  GTID-based replication does not actually require them, including the\n  transaction queuing and application process.\n\n  This option can be used only if both the replication SQL (applier)\n  thread and replication I/O (receiver) thread are stopped. To set\n  GTID_ONLY = 1 for a replication channel, GTIDs must be in use on the\n  server (gtid_mode = ON), and row-based binary logging must be in use\n  on the source (statement-based replication is not supported). The\n  options REQUIRE_ROW_FORMAT = 1 and SOURCE_AUTO_POSITION = 1 must be\n  set for the replication channel.\n\n  When GTID_ONLY = 1 is set, the replica uses\n  replica_parallel_workers=1 if that system variable is set to zero for\n  the server, so it is always technically a multi-threaded applier.\n  This is because a multi-threaded applier uses saved positions rather\n  than the replication metadata repositories to locate the start of a\n  transaction that it needs to reapply.\n\n  If you disable GTID_ONLY after setting it, the existing relay logs\n  are deleted and the existing known binary log file positions are\n  persisted, even if they are stale. The file positions for the binary\n  log and relay log in the replication metadata repositories might be\n  invalid, and a warning is returned if this is the case. Provided that\n  SOURCE_AUTO_POSITION is still enabled, GTID auto-positioning is used\n  to provide the correct positioning.\n\n  If you also disable SOURCE_AUTO_POSITION, the file positions for the\n  binary log and relay log in the replication metadata repositories are\n  used for positioning if they are valid. If they are marked as\n  invalid, you must provide a valid binary log file name and position\n  (SOURCE_LOG_FILE and SOURCE_LOG_POS). If you also provide a relay log\n  file name and position (RELAY_LOG_FILE and RELAY_LOG_POS), the relay\n  logs are preserved and the applier position is set to the stated\n  position. GTID auto-skip ensures that any transactions already\n  applied are skipped even if the eventual applier position is not\n  correct.\n\no IGNORE_SERVER_IDS = (server_id_list)\n\n  Makes the replica ignore events originating from the specified\n  servers. The option takes a comma-separated list of 0 or more server\n  IDs. Log rotation and deletion events from the servers are not\n  ignored, and are recorded in the relay log.\n\n  In circular replication, the originating server normally acts as the\n  terminator of its own events, so that they are not applied more than\n  once. Thus, this option is useful in circular replication when one of\n  the servers in the circle is removed. Suppose that you have a\n  circular replication setup with 4 servers, having server IDs 1, 2, 3,\n  and 4, and server 3 fails. When bridging the gap by starting\n  replication from server 2 to server 4, you can include\n  IGNORE_SERVER_IDS = (3) in the CHANGE MASTER TO statement that you\n  issue on server 4 to tell it to use server 2 as its source instead of\n  server 3. Doing so causes it to ignore and not to propagate any\n  statements that originated with the server that is no longer in use.\n\n  If IGNORE_SERVER_IDS contains the server\'s own ID and the server was\n  started with the --replicate-same-server-id option enabled, an error\n  results.\n\n  *Note*:\n\n  When global transaction identifiers (GTIDs) are used for replication,\n  transactions that have already been applied are automatically\n  ignored, so the IGNORE_SERVER_IDS function is not required and is\n  deprecated. If gtid_mode=ON is set for the server, a deprecation\n  warning is issued if you include the IGNORE_SERVER_IDS option in a\n  CHANGE MASTER TO statement.\n\n  The source metadata repository and the output of SHOW REPLICA STATUS\n  provide the list of servers that are currently ignored. For more\n  information, see\n  https://dev.mysql.com/doc/refman/8.0/en/replica-logs-status.html, and\n  [HELP SHOW REPLICA STATUS].\n\n  If a CHANGE MASTER TO statement is issued without any\n  IGNORE_SERVER_IDS option, any existing list is preserved. To clear\n  the list of ignored servers, it is necessary to use the option with\n  an empty list:\n\nCHANGE MASTER TO IGNORE_SERVER_IDS = ();\n\n  RESET REPLICA ALL clears IGNORE_SERVER_IDS.\n\n  *Note*:\n\n  A deprecation warning is issued if SET GTID_MODE=ON is issued when\n  any channel has existing server IDs set with IGNORE_SERVER_IDS.\n  Before starting GTID-based replication, check for and clear all\n  ignored server ID lists on the servers involved. The SHOW REPLICA\n  STATUS statement displays the list of ignored IDs, if there is one.\n  If you do receive the deprecation warning, you can still clear a list\n  after gtid_mode=ON is set by issuing a CHANGE MASTER TO statement\n  containing the IGNORE_SERVER_IDS option with an empty list.\n\no MASTER_AUTO_POSITION = {0|1}\n\n  Makes the replica attempt to connect to the source using the\n  auto-positioning feature of GTID-based replication, rather than a\n  binary log file based position. This option is used to start a\n  replica using GTID-based replication. The default is 0, meaning that\n  GTID auto-positioning and GTID-based replication are not used. This\n  option can be used with CHANGE MASTER TO only if both the replication\n  SQL (applier) thread and replication I/O (receiver) thread are\n  stopped.\n\n  Both the replica and the source must have GTIDs enabled\n  (GTID_MODE=ON, ON_PERMISSIVE, or OFF_PERMISSIVE on the replica, and\n  GTID_MODE=ON on the source). MASTER_LOG_FILE, MASTER_LOG_POS,\n  RELAY_LOG_FILE, and RELAY_LOG_POS cannot be specified together with\n  MASTER_AUTO_POSITION = 1. If multi-source replication is enabled on\n  the replica, you need to set the MASTER_AUTO_POSITION = 1 option for\n  each applicable replication channel.\n\n  With MASTER_AUTO_POSITION = 1 set, in the initial connection\n  handshake, the replica sends a GTID set containing the transactions\n  that it has already received, committed, or both. The source responds\n  by sending all transactions recorded in its binary log whose GTID is\n  not included in the GTID set sent by the replica. This exchange\n  ensures that the source only sends the transactions with a GTID that\n  the replica has not already recorded or committed. If the replica\n  receives transactions from more than one source, as in the case of a\n  diamond topology, the auto-skip function ensures that the\n  transactions are not applied twice. For details of how the GTID set\n  sent by the replica is computed, see\n  https://dev.mysql.com/doc/refman/8.0/en/replication-gtids-auto-positi\n  oning.html.\n\n  If any of the transactions that should be sent by the source have\n  been purged from the source\'s binary log, or added to the set of\n  GTIDs in the gtid_purged system variable by another method, the\n  source sends the error ER_MASTER_HAS_PURGED_REQUIRED_GTIDS\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_master_has_purged_required_gtids) to the replica, and\n  replication does not start. The GTIDs of the missing purged\n  transactions are identified and listed in the source\'s error log in\n  the warning message ER_FOUND_MISSING_GTIDS\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_found_missing_gtids). Also, if during the exchange of\n  transactions it is found that the replica has recorded or committed\n  transactions with the source\'s UUID in the GTID, but the source\n  itself has not committed them, the source sends the error\n  ER_SLAVE_HAS_MORE_GTIDS_THAN_MASTER\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_slave_has_more_gtids_than_master) to the replica and\n  replication does not start. For information on how to handle these\n  situations, see\n  https://dev.mysql.com/doc/refman/8.0/en/replication-gtids-auto-positi\n  oning.html.\n\n  You can see whether replication is running with GTID auto-positioning\n  enabled by checking the Performance Schema\n  replication_connection_status table or the output of SHOW REPLICA\n  STATUS. Disabling the MASTER_AUTO_POSITION option again makes the\n  replica revert to file-based replication.\n\no MASTER_BIND = \'interface_name\'\n\n  Determines which of the replica\'s network interfaces is chosen for\n  connecting to the source, for use on replicas that have multiple\n  network interfaces. Specify the IP address of the network interface.\n  The maximum length of the string value is 255 characters.\n\n  The IP address configured with this option, if any, can be seen in\n  the Master_Bind column of the output from SHOW REPLICA STATUS. In the\n  source metadata repository table mysql.slave_master_info, the value\n  can be seen as the Master_bind column. The ability to bind a replica\n  to a specific network interface is also supported by NDB Cluster.\n\no MASTER_COMPRESSION_ALGORITHMS = \'algorithm[,algorithm][,algorithm]\'\n\n  Specifies one, two, or three of the permitted compression algorithms\n  for connections to the replication source server, separated by\n  commas. The maximum length of the string value is 99 characters. The\n  default value is uncompressed.\n\n  The available algorithms are zlib, zstd, and uncompressed, the same\n  as for the protocol_compression_algorithms system variable. The\n  algorithms can be specified in any order, but it is not an order of\n  preference - the algorithm negotiation process attempts to use zlib,\n  then zstd, then uncompressed, if they are specified.\n  MASTER_COMPRESSION_ALGORITHMS is available as of MySQL 8.0.18.\n\n  The value of MASTER_COMPRESSION_ALGORITHMS applies only if the\n  replica_compressed_protocol or slave_compressed_protocol system\n  variable is disabled. If replica_compressed_protocol or\n  slave_compressed_protocol is enabled, it takes precedence over\n  MASTER_COMPRESSION_ALGORITHMS and connections to the source use zlib\n  compression if both source and replica support that algorithm. For\n  more information, see\n  https://dev.mysql.com/doc/refman/8.0/en/connection-compression-contro\n  l.html.\n\n  Binary log transaction compression (available as of MySQL 8.0.20),\n  which is activated by the binlog_transaction_compression system\n  variable, can also be used to save bandwidth. If you do this in\n  combination with connection compression, connection compression has\n  less opportunity to act on the data, but can still compress headers\n  and those events and transaction payloads that are uncompressed. For\n  more information on binary log transaction compression, see\n  https://dev.mysql.com/doc/refman/8.0/en/binary-log-transaction-compre\n  ssion.html.\n\no MASTER_CONNECT_RETRY = interval\n\n  Specifies the interval in seconds between the reconnection attempts\n  that the replica makes after the connection to the source times out.\n  The default interval is 60.\n\n  The attempts are limited by the MASTER_RETRY_COUNT option. If both\n  the default settings are used, the replica waits 60 seconds between\n  reconnection attempts (MASTER_CONNECT_RETRY=60), and keeps attempting\n  to reconnect at this rate for 60 days (MASTER_RETRY_COUNT=86400).\n  These values are recorded in the source metadata repository and shown\n  in the replication_connection_configuration Performance Schema table.\n\no MASTER_DELAY = interval\n\n  Specifies how many seconds behind the source the replica must lag. An\n  event received from the source is not executed until at least\n  interval seconds later than its execution on the source. interval\n  must be a nonnegative integer in the range from 0 to 231−1. The\n  default is 0. For more information, see\n  https://dev.mysql.com/doc/refman/8.0/en/replication-delayed.html.\n\n  A CHANGE MASTER TO statement employing the MASTER_DELAY option can be\n  executed on a running replica when the replication SQL thread is\n  stopped.\n\no MASTER_HEARTBEAT_PERIOD = interval\n\n  Controls the heartbeat interval, which stops the connection timeout\n  occurring in the absence of data if the connection is still good. A\n  heartbeat signal is sent to the replica after that number of seconds,\n  and the waiting period is reset whenever the source\'s binary log is\n  updated with an event. Heartbeats are therefore sent by the source\n  only if there are no unsent events in the binary log file for a\n  period longer than this.\n\n  The heartbeat interval interval is a decimal value having the range 0\n  to 4294967 seconds and a resolution in milliseconds; the smallest\n  nonzero value is 0.001. Setting interval to 0 disables heartbeats\n  altogether. The heartbeat interval defaults to half the value of the\n  replica_net_timeout or slave_net_timeout system variable. It is\n  recorded in the source metadata repository and shown in the\n  replication_connection_configuration Performance Schema table.\n  Issuing RESET REPLICA resets the heartbeat interval to the default\n  value.\n\n  The system variable replica_net_timeout (from MySQL 8.0.26) or\n  slave_net_timeout (before MySQL 8.0.26) specifies the number of\n  seconds that the replica waits for either more data or a heartbeat\n  signal from the source, before the replica considers the connection\n  broken, aborts the read, and tries to reconnect. The default value is\n  60 seconds (one minute). Note that a change to the value or default\n  setting of replica_net_timeout or slave_net_timeout does not\n  automatically change the heartbeat interval, whether that has been\n  set explicitly or is using a previously calculated default. A warning\n  is issued if you set the global value of replica_net_timeout or\n  slave_net_timeout to a value less than that of the current heartbeat\n  interval. If replica_net_timeout or slave_net_timeout is changed, you\n  must also issue CHANGE MASTER TO to adjust the heartbeat interval to\n  an appropriate value so that the heartbeat signal occurs before the\n  connection timeout. If you do not do this, the heartbeat signal has\n  no effect, and if no data is received from the source, the replica\n  can make repeated reconnection attempts, creating zombie dump\n  threads.\n\no MASTER_HOST = \'host_name\'\n\n  The host name or IP address of the replication source server. The\n  replica uses this to connect to the source. The maximum length of the\n  string value is 255 characters. Before MySQL 8.0.17 it was 60\n  characters.\n\n  If you specify MASTER_HOST or MASTER_PORT, the replica assumes that\n  the source server is different from before (even if the option value\n  is the same as its current value.) In this case, the old values for\n  the source\'s binary log file name and position are considered no\n  longer applicable, so if you do not specify MASTER_LOG_FILE and\n  MASTER_LOG_POS in the statement, MASTER_LOG_FILE=\'\' and\n  MASTER_LOG_POS=4 are silently appended to it.\n\n  Setting MASTER_HOST=\'\' (that is, setting its value explicitly to an\n  empty string) is not the same as not setting MASTER_HOST at all.\n  Trying to set MASTER_HOST to an empty string fails with an error.\n\no MASTER_LOG_FILE = \'source_log_name\', MASTER_LOG_POS = source_log_pos\n\n  The binary log file name, and the location in that file, at which the\n  replication I/O (receiver) thread begins reading from the source\'s\n  binary log the next time the thread starts. Specify these options if\n  you are using binary log file position based replication.\n\n  MASTER_LOG_FILE must include the numeric suffix of a specific binary\n  log file that is available on the source server, for example,\n  MASTER_LOG_FILE=\'binlog.000145\'. The maximum length of the string\n  value is 511 characters.\n\n  MASTER_LOG_POS is the numeric position for the replica to start\n  reading in that file. MASTER_LOG_POS=4 represents the start of the\n  events in a binary log file.\n\n  If you specify either of MASTER_LOG_FILE or MASTER_LOG_POS, you\n  cannot specify MASTER_AUTO_POSITION = 1, which is for GTID-based\n  replication.\n\n  If neither of MASTER_LOG_FILE or MASTER_LOG_POS is specified, the\n  replica uses the last coordinates of the replication SQL (applier)\n  thread before CHANGE MASTER TO was issued. This ensures that there is\n  no discontinuity in replication, even if the replication SQL\n  (applier) thread was late compared to the replication I/O (receiver)\n  thread.\n\no MASTER_PASSWORD = \'password\'\n\n  The password for the replication user account to use for connecting\n  to the replication source server. The maximum length of the string\n  value is 32 characters. If you specify MASTER_PASSWORD, MASTER_USER\n  is also required.\n\n  The password used for a replication user account in a CHANGE MASTER\n  TO statement is limited to 32 characters in length. Trying to use a\n  password of more than 32 characters causes CHANGE MASTER TO to fail.\n\n  The password is masked in MySQL Server\'s logs, Performance Schema\n  tables, and SHOW PROCESSLIST statements.\n\no MASTER_PORT = port_num\n\n  The TCP/IP port number that the replica uses to connect to the\n  replication source server.\n\n  *Note*:\n\n  Replication cannot use Unix socket files. You must be able to connect\n  to the replication source server using TCP/IP.\n\n  If you specify MASTER_HOST or MASTER_PORT, the replica assumes that\n  the source server is different from before (even if the option value\n  is the same as its current value). In this case, the old values for\n  the source\'s binary log file name and position are considered no\n  longer applicable, so if you do not specify MASTER_LOG_FILE and\n  MASTER_LOG_POS in the statement, MASTER_LOG_FILE=\'\' and\n  MASTER_LOG_POS=4 are silently appended to it.\n\no MASTER_PUBLIC_KEY_PATH = \'key_file_name\'\n\n  Enables RSA key pair-based password exchange by providing the path\n  name to a file containing a replica-side copy of the public key\n  required by the source. The file must be in PEM format. The maximum\n  length of the string value is 511 characters.\n\n  This option applies to replicas that authenticate with the\n  sha256_password or caching_sha2_password authentication plugin. (For\n  sha256_password, MASTER_PUBLIC_KEY_PATH can be used only if MySQL was\n  built using OpenSSL.) If you are using a replication user account\n  that authenticates with the caching_sha2_password plugin (which is\n  the default from MySQL 8.0), and you are not using a secure\n  connection, you must specify either this option or the\n  GET_MASTER_PUBLIC_KEY=1 option to provide the RSA public key to the\n  replica.\n\no MASTER_RETRY_COUNT = count\n\n  Sets the maximum number of reconnection attempts that the replica\n  makes after the connection to the source times out, as determined by\n  the replica_net_timeout or slave_net_timeout system variable. If the\n  replica does need to reconnect, the first retry occurs immediately\n  after the timeout. The default is 86400 attempts.\n\n  The interval between the attempts is specified by the\n  MASTER_CONNECT_RETRY option. If both the default settings are used,\n  the replica waits 60 seconds between reconnection attempts\n  (MASTER_CONNECT_RETRY=60), and keeps attempting to reconnect at this\n  rate for 60 days (MASTER_RETRY_COUNT=86400). A setting of 0 for\n  MASTER_RETRY_COUNT means that there is no limit on the number of\n  reconnection attempts, so the replica keeps trying to reconnect\n  indefinitely.\n\n  The values for MASTER_CONNECT_RETRY and MASTER_RETRY_COUNT are\n  recorded in the source metadata repository and shown in the\n  replication_connection_configuration Performance Schema table.\n  MASTER_RETRY_COUNT supersedes the --master-retry-count server startup\n  option.\n\no MASTER_SSL = {0|1}\n\n  Specify whether the replica encrypts the replication connection. The\n  default is 0, meaning that the replica does not encrypt the\n  replication connection. If you set MASTER_SSL=1, you can configure\n  the encryption using the MASTER_SSL_xxx and MASTER_TLS_xxx options.\n\n  Setting MASTER_SSL=1 for a replication connection and then setting no\n  further MASTER_SSL_xxx options corresponds to setting\n  --ssl-mode=REQUIRED for the client, as described in\n  https://dev.mysql.com/doc/refman/8.0/en/connection-options.html#encry\n  pted-connection-options. With MASTER_SSL=1, the connection attempt\n  only succeeds if an encrypted connection can be established. A\n  replication connection does not fall back to an unencrypted\n  connection, so there is no setting corresponding to the\n  --ssl-mode=PREFERRED setting for replication. If MASTER_SSL=0 is set,\n  this corresponds to --ssl-mode=DISABLED.\n\n  *Important*:\n\n  To help prevent sophisticated man-in-the-middle attacks, it is\n  important for the replica to verify the server\'s identity. You can\n  specify additional MASTER_SSL_xxx options to correspond to the\n  settings --ssl-mode=VERIFY_CA and --ssl-mode=VERIFY_IDENTITY, which\n  are a better choice than the default setting to help prevent this\n  type of attack. With these settings, the replica checks that the\n  server\'s certificate is valid, and checks that the host name the\n  replica is using matches the identity in the server\'s certificate. To\n  implement one of these levels of verification, you must first ensure\n  that the CA certificate for the server is reliably available to the\n  replica, otherwise availability issues will result. For this reason,\n  they are not the default setting.\n\no MASTER_SSL_xxx, MASTER_TLS_xxx\n\n  Specify how the replica uses encryption and ciphers to secure the\n  replication connection. These options can be changed even on replicas\n  that are compiled without SSL support. They are saved to the source\n  metadata repository, but are ignored if the replica does not have SSL\n  support enabled. The maximum length of the value for the\n  string-valued MASTER_SSL_xxx and MASTER_TLS_xxx options is 511\n  characters, with the exception of MASTER_TLS_CIPHERSUITES, for which\n  it is 4000 characters.\n\n  The MASTER_SSL_xxx and MASTER_TLS_xxx options perform the same\n  functions as the --ssl-xxx and --tls-xxx client options described in\n  https://dev.mysql.com/doc/refman/8.0/en/connection-options.html#encry\n  pted-connection-options. The correspondence between the two sets of\n  options, and the use of the MASTER_SSL_xxx and MASTER_TLS_xxx options\n  to set up a secure connection, is explained in\n  https://dev.mysql.com/doc/refman/8.0/en/replication-encrypted-connect\n  ions.html.\n\no MASTER_USER = \'user_name\'\n\n  The user name for the replication user account to use for connecting\n  to the replication source server. The maximum length of the string\n  value is 96 characters.\n\n  For Group Replication, this account must exist on every member of the\n  replication group. It is used for distributed recovery if the XCom\n  communication stack is in use for the group, and also used for group\n  communication connections if the MySQL communication stack is in use\n  for the group. With the MySQL communication stack, the account must\n  have the GROUP_REPLICATION_STREAM permission.\n\n  It is possible to set an empty user name by specifying\n  MASTER_USER=\'\', but the replication channel cannot be started with an\n  empty user name. In releases before MySQL 8.0.21, only set an empty\n  MASTER_USER user name if you need to clear previously used\n  credentials from the replication metadata repositories for security\n  purposes. Do not use the channel afterwards, due to a bug in these\n  releases that can substitute a default user name if an empty user\n  name is read from the repositories (for example, during an automatic\n  restart of a Group Replication channel). From MySQL 8.0.21, it is\n  valid to set an empty MASTER_USER user name and use the channel\n  afterwards if you always provide user credentials using the START\n  REPLICA statement or START GROUP_REPLICATION statement that starts\n  the replication channel. This approach means that the replication\n  channel always needs operator intervention to restart, but the user\n  credentials are not recorded in the replication metadata\n  repositories.\n\n  *Important*:\n\n  To connect to the source using a replication user account that\n  authenticates with the caching_sha2_password plugin, you must either\n  set up a secure connection as described in\n  https://dev.mysql.com/doc/refman/8.0/en/replication-encrypted-connect\n  ions.html, or enable the unencrypted connection to support password\n  exchange using an RSA key pair. The caching_sha2_password\n  authentication plugin is the default for new users created from MySQL\n  8.0 (for details, see\n  https://dev.mysql.com/doc/refman/8.0/en/caching-sha2-pluggable-authen\n  tication.html). If the user account that you create or use for\n  replication uses this authentication plugin, and you are not using a\n  secure connection, you must enable RSA key pair-based password\n  exchange for a successful connection. You can do this using either\n  the MASTER_PUBLIC_KEY_PATH option or the GET_MASTER_PUBLIC_KEY=1\n  option for this statement.\n\no MASTER_ZSTD_COMPRESSION_LEVEL = level\n\n  The compression level to use for connections to the replication\n  source server that use the zstd compression algorithm. The permitted\n  levels are from 1 to 22, with larger values indicating increasing\n  levels of compression. The default level is 3.\n  MASTER_ZSTD_COMPRESSION_LEVEL is available as of MySQL 8.0.18.\n\n  The compression level setting has no effect on connections that do\n  not use zstd compression. For more information, see\n  https://dev.mysql.com/doc/refman/8.0/en/connection-compression-contro\n  l.html.\n\no NETWORK_NAMESPACE = \'namespace\'\n\n  The network namespace to use for TCP/IP connections to the\n  replication source server or, if the MySQL communication stack is in\n  use, for Group Replication\'s group communication connections. The\n  maximum length of the string value is 64 characters. If this option\n  is omitted, connections from the replica use the default (global)\n  namespace. On platforms that do not implement network namespace\n  support, failure occurs when the replica attempts to connect to the\n  source. For information about network namespaces, see\n  https://dev.mysql.com/doc/refman/8.0/en/network-namespace-support.htm\n  l. NETWORK_NAMESPACE is available as of MySQL 8.0.22.\n\no PRIVILEGE_CHECKS_USER = {NULL | \'account\'}\n\n  Names a user account that supplies a security context for the\n  specified channel. NULL, which is the default, means no security\n  context is used. PRIVILEGE_CHECKS_USER is available as of MySQL\n  8.0.18.\n\n  The user name and host name for the user account must follow the\n  syntax described in\n  https://dev.mysql.com/doc/refman/8.0/en/account-names.html, and the\n  user must not be an anonymous user (with a blank user name) or the\n  CURRENT_USER. The account must have the REPLICATION_APPLIER\n  privilege, plus the required privileges to execute the transactions\n  replicated on the channel. For details of the privileges required by\n  the account, see\n  https://dev.mysql.com/doc/refman/8.0/en/replication-privilege-checks.\n  html. When you restart the replication channel, the privilege checks\n  are applied from that point on. If you do not specify a channel and\n  no other channels exist, the statement is applied to the default\n  channel.\n\n  The use of row-based binary logging is strongly recommended when\n  PRIVILEGE_CHECKS_USER is set, and you can set REQUIRE_ROW_FORMAT to\n  enforce this. For example, to start privilege checks on the channel\n  channel_1 on a running replica, issue the following statements:\n\nmysql> STOP REPLICA FOR CHANNEL \'channel_1\';\nmysql> CHANGE MASTER TO\n         PRIVILEGE_CHECKS_USER = \'priv_repl\'@\'%.example.com\',\n         REQUIRE_ROW_FORMAT = 1,\n         FOR CHANNEL \'channel_1\';\nmysql> START REPLICA FOR CHANNEL \'channel_1\';\n\n  For releases from MySQL 8.0.22, use START REPLICA and STOP REPLICA,\n  and for releases before MySQL 8.0.22, use START SLAVE and STOP SLAVE.\n  The statements work in the same way, only the terminology has\n  changed.\n\no RELAY_LOG_FILE = \'relay_log_file\' , RELAY_LOG_POS = \'relay_log_pos\'\n\n  The relay log file name, and the location in that file, at which the\n  replication SQL thread begins reading from the replica\'s relay log\n  the next time the thread starts. RELAY_LOG_FILE can use either an\n  absolute or relative path, and uses the same base name as\n  MASTER_LOG_FILE. The maximum length of the string value is 511\n  characters.\n\n  A CHANGE MASTER TO statement using RELAY_LOG_FILE, RELAY_LOG_POS, or\n  both options can be executed on a running replica when the\n  replication SQL thread is stopped. Relay logs are preserved if at\n  least one of the replication SQL (applier) thread and the replication\n  I/O (receiver) thread is running. If both threads are stopped, all\n  relay log files are deleted unless at least one of RELAY_LOG_FILE or\n  RELAY_LOG_POS is specified. For the Group Replication applier channel\n  (group_replication_applier), which only has an applier thread and no\n  receiver thread, this is the case if the applier thread is stopped,\n  but with that channel you cannot use the RELAY_LOG_FILE and\n  RELAY_LOG_POS options.\n\no REQUIRE_ROW_FORMAT = {0|1}\n\n  Permits only row-based replication events to be processed by the\n  replication channel. This option prevents the replication applier\n  from taking actions such as creating temporary tables and executing\n  LOAD DATA INFILE requests, which increases the security of the\n  channel. The REQUIRE_ROW_FORMAT option is disabled by default for\n  asynchronous replication channels, but it is enabled by default for\n  Group Replication channels, and it cannot be disabled for them. For\n  more information, see\n  https://dev.mysql.com/doc/refman/8.0/en/replication-privilege-checks.\n  html. REQUIRE_ROW_FORMAT is available as of MySQL 8.0.19.\n\no REQUIRE_TABLE_PRIMARY_KEY_CHECK = {STREAM | ON | OFF}\n\n  Enables a replica to select its own policy for primary key checks.\n  The default is STREAM. REQUIRE_TABLE_PRIMARY_KEY_CHECK is available\n  as of MySQL 8.0.20.\n\n  When the option is set to ON for a replication channel, the replica\n  always uses the value ON for the sql_require_primary_key system\n  variable in replication operations, requiring a primary key. When the\n  option is set to OFF, the replica always uses the value OFF for the\n  sql_require_primary_key system variable in replication operations, so\n  that a primary key is never required, even if the source required\n  one. When the REQUIRE_TABLE_PRIMARY_KEY_CHECK option is set to\n  STREAM, which is the default, the replica uses whatever value is\n  replicated from the source for each transaction.\n\n  For multisource replication, setting REQUIRE_TABLE_PRIMARY_KEY_CHECK\n  to ON or OFF enables a replica to normalize behavior across the\n  replication channels for different sources, and keep a consistent\n  setting for the sql_require_primary_key system variable. Using ON\n  safeguards against the accidental loss of primary keys when multiple\n  sources update the same set of tables. Using OFF allows sources that\n  can manipulate primary keys to work alongside sources that cannot.\n\n  When PRIVILEGE_CHECKS_USER is set, setting\n  REQUIRE_TABLE_PRIMARY_KEY_CHECK to ON or OFF means that the user\n  account does not need session administration level privileges to set\n  restricted session variables, which are required to change the value\n  of sql_require_primary_key to match the source\'s setting for each\n  transaction. For more information, see\n  https://dev.mysql.com/doc/refman/8.0/en/replication-privilege-checks.\n  html.\n\no SOURCE_CONNECTION_AUTO_FAILOVER = {0|1}\n\n  Activates the asynchronous connection failover mechanism for a\n  replication channel if one or more alternative replication source\n  servers are available (so when there are multiple MySQL servers or\n  groups of servers that share the replicated data).\n  SOURCE_CONNECTION_AUTO_FAILOVER is available as of MySQL 8.0.22. The\n  default is 0, meaning that the mechanism is not activated. For full\n  information and instructions to set up this feature, see\n  https://dev.mysql.com/doc/refman/8.0/en/replication-asynchronous-conn\n  ection-failover-replica.html.\n\n  The asynchronous connection failover mechanism takes over after the\n  reconnection attempts controlled by MASTER_CONNECT_RETRY and\n  MASTER_RETRY_COUNT are exhausted. It reconnects the replica to an\n  alternative source chosen from a specified source list, which you\n  manage using the asynchronous_connection_failover_add_source and\n  asynchronous_connection_failover_delete_source functions. To add and\n  remove managed groups of servers, use the\n  asynchronous_connection_failover_add_managed and\n  asynchronous_connection_failover_delete_managed functions instead.\n  For more information, see\n  https://dev.mysql.com/doc/refman/8.0/en/replication-asynchronous-conn\n  ection-failover.html.\n\n  *Important*:\n\n   1. You can only set SOURCE_CONNECTION_AUTO_FAILOVER = 1 when GTID\n      auto-positioning is in use (MASTER_AUTO_POSITION = 1).\n\n   2. When you set SOURCE_CONNECTION_AUTO_FAILOVER = 1, set\n      MASTER_RETRY_COUNT and MASTER_CONNECT_RETRY to minimal numbers\n      that just allow a few retry attempts with the same source in a\n      short time, in case the connection failure is caused by a\n      transient network outage. Otherwise the asynchronous connection\n      failover mechanism cannot be activated promptly. Suitable values\n      are MASTER_RETRY_COUNT=3 and MASTER_CONNECT_RETRY=10, which make\n      the replica retry the connection 3 times with 10-second intervals\n      between.\n\n   3. When you set SOURCE_CONNECTION_AUTO_FAILOVER = 1, the replication\n      metadata repositories must contain the credentials for a\n      replication user account that can be used to connect to all the\n      servers on the source list for the replication channel. These\n      credentials can be set using the CHANGE REPLICATION SOURCE TO\n      statement with the MASTER_USER and MASTER_PASSWORD options. For\n      more information, see\n      https://dev.mysql.com/doc/refman/8.0/en/replication-asynchronous-\n      connection-failover.html.\n\n   4. From MySQL 8.0.27, when you set SOURCE_CONNECTION_AUTO_FAILOVER =\n      1, asynchronous connection failover for replicas is automatically\n      activated if this replication channel is on a Group Replication\n      primary in a group in single-primary mode. With this function\n      active, if the primary that is replicating goes offline or into\n      an error state, the new primary starts replication on the same\n      channel when it is elected. If you want to use the function, this\n      replication channel must also be set up on all the secondary\n      servers in the replication group, and on any new joining members.\n      (If the servers are provisioned using MySQL\'s clone\n      functionality, this all happens automatically.) If you do not\n      want to use the function, disable it by using the\n      group_replication_disable_member_action function to disable the\n      Group Replication member action\n      mysql_start_failover_channels_if_primary, which is enabled by\n      default. For more information, see\n      https://dev.mysql.com/doc/refman/8.0/en/replication-asynchronous-\n      connection-failover-replica.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/change-master-to.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/change-master-to.html'),(578,'CHANGE REPLICATION FILTER',43,'Syntax:\nCHANGE REPLICATION FILTER filter[, filter]\n	[, ...] [FOR CHANNEL channel]\n\nfilter: {\n    REPLICATE_DO_DB = (db_list)\n  | REPLICATE_IGNORE_DB = (db_list)\n  | REPLICATE_DO_TABLE = (tbl_list)\n  | REPLICATE_IGNORE_TABLE = (tbl_list)\n  | REPLICATE_WILD_DO_TABLE = (wild_tbl_list)\n  | REPLICATE_WILD_IGNORE_TABLE = (wild_tbl_list)\n  | REPLICATE_REWRITE_DB = (db_pair_list)\n}\n\ndb_list:\n    db_name[, db_name][, ...]\n\ntbl_list:\n    db_name.table_name[, db_name.table_name][, ...]\nwild_tbl_list:\n    \'db_pattern.table_pattern\'[, \'db_pattern.table_pattern\'][, ...]\n\ndb_pair_list:\n    (db_pair)[, (db_pair)][, ...]\n\ndb_pair:\n    from_db, to_db\n\nCHANGE REPLICATION FILTER sets one or more replication filtering rules\non the replica in the same way as starting the replica mysqld with\nreplication filtering options such as --replicate-do-db or\n--replicate-wild-ignore-table. Filters set using this statement differ\nfrom those set using the server options in two key respects:\n\n1. The statement does not require restarting the server to take effect,\n   only that the replication SQL thread be stopped using STOP REPLICA\n   SQL_THREAD first (and restarted with START REPLICA SQL_THREAD\n   afterwards).\n\n2. The effects of the statement are not persistent; any filters set\n   using CHANGE REPLICATION FILTER are lost following a restart of the\n   replica mysqld.\n\nCHANGE REPLICATION FILTER requires the REPLICATION_SLAVE_ADMIN\nprivilege (or the deprecated SUPER privilege).\n\nUse the FOR CHANNEL channel clause to make a replication filter\nspecific to a replication channel, for example on a multi-source\nreplica. Filters applied without a specific FOR CHANNEL clause are\nconsidered global filters, meaning that they are applied to all\nreplication channels.\n\nGlobal replication filters cannot be set on a MySQL server instance\nthat is configured for Group Replication, because filtering\ntransactions on some servers would make the group unable to reach\nagreement on a consistent state. Channel specific replication filters\ncan be set on replication channels that are not directly involved with\nGroup Replication, such as where a group member also acts as a replica\nto a source that is outside the group. They cannot be set on the\ngroup_replication_applier or group_replication_recovery channels.\n\nThe following list shows the CHANGE REPLICATION FILTER options and how\nthey relate to --replicate-* server options:\n\no REPLICATE_DO_DB: Include updates based on database name. Equivalent\n  to --replicate-do-db.\n\no REPLICATE_IGNORE_DB: Exclude updates based on database name.\n  Equivalent to --replicate-ignore-db.\n\no REPLICATE_DO_TABLE: Include updates based on table name. Equivalent\n  to --replicate-do-table.\n\no REPLICATE_IGNORE_TABLE: Exclude updates based on table name.\n  Equivalent to --replicate-ignore-table.\n\no REPLICATE_WILD_DO_TABLE: Include updates based on wildcard pattern\n  matching table name. Equivalent to --replicate-wild-do-table.\n\no REPLICATE_WILD_IGNORE_TABLE: Exclude updates based on wildcard\n  pattern matching table name. Equivalent to\n  --replicate-wild-ignore-table.\n\no REPLICATE_REWRITE_DB: Perform updates on replica after substituting\n  new name on replica for specified database on source. Equivalent to\n  --replicate-rewrite-db.\n\nThe precise effects of REPLICATE_DO_DB and REPLICATE_IGNORE_DB filters\nare dependent on whether statement-based or row-based replication is in\neffect. See\nhttps://dev.mysql.com/doc/refman/8.0/en/replication-rules.html, for\nmore information.\n\nMultiple replication filtering rules can be created in a single CHANGE\nREPLICATION FILTER statement by separating the rules with commas, as\nshown here:\n\nCHANGE REPLICATION FILTER\n    REPLICATE_DO_DB = (d1), REPLICATE_IGNORE_DB = (d2);\n\nIssuing the statement just shown is equivalent to starting the replica\nmysqld with the options --replicate-do-db=d1 --replicate-ignore-db=d2.\n\nOn a multi-source replica, which uses multiple replication channels to\nprocess transaction from different sources, use the FOR CHANNEL channel\nclause to set a replication filter on a replication channel:\n\nCHANGE REPLICATION FILTER REPLICATE_DO_DB = (d1) FOR CHANNEL channel_1;\n\nThis enables you to create a channel specific replication filter to\nfilter out selected data from a source. When a FOR CHANNEL clause is\nprovided, the replication filter statement acts on that replication\nchannel, removing any existing replication filter which has the same\nfilter type as the specified replication filters, and replacing them\nwith the specified filter. Filter types not explicitly listed in the\nstatement are not modified. If issued against a replication channel\nwhich is not configured, the statement fails with an\nER_SLAVE_CONFIGURATION error. If issued against Group Replication\nchannels, the statement fails with an\nER_SLAVE_CHANNEL_OPERATION_NOT_ALLOWED error.\n\nOn a replica with multiple replication channels configured, issuing\nCHANGE REPLICATION FILTER with no FOR CHANNEL clause configures the\nreplication filter for every configured replication channel, and for\nthe global replication filters. For every filter type, if the filter\ntype is listed in the statement, then any existing filter rules of that\ntype are replaced by the filter rules specified in the most recently\nissued statement, otherwise the old value of the filter type is\nretained. For more information see\nhttps://dev.mysql.com/doc/refman/8.0/en/replication-rules-channel-based\n-filters.html.\n\nIf the same filtering rule is specified multiple times, only the last\nsuch rule is actually used. For example, the two statements shown here\nhave exactly the same effect, because the first REPLICATE_DO_DB rule in\nthe first statement is ignored:\n\nCHANGE REPLICATION FILTER\n    REPLICATE_DO_DB = (db1, db2), REPLICATE_DO_DB = (db3, db4);\n\nCHANGE REPLICATION FILTER\n    REPLICATE_DO_DB = (db3, db4);\n\n*Caution*:\n\nThis behavior differs from that of the --replicate-* filter options\nwhere specifying the same option multiple times causes the creation of\nmultiple filter rules.\n\nNames of tables and database not containing any special characters need\nnot be quoted. Values used with REPLICATION_WILD_TABLE and\nREPLICATION_WILD_IGNORE_TABLE are string expressions, possibly\ncontaining (special) wildcard characters, and so must be quoted. This\nis shown in the following example statements:\n\nCHANGE REPLICATION FILTER\n    REPLICATE_WILD_DO_TABLE = (\'db1.old%\');\n\nCHANGE REPLICATION FILTER\n    REPLICATE_WILD_IGNORE_TABLE = (\'db1.new%\', \'db2.new%\');\n\nValues used with REPLICATE_REWRITE_DB represent pairs of database\nnames; each such value must be enclosed in parentheses. The following\nstatement rewrites statements occurring on database db1 on the source\nto database db2 on the replica:\n\nCHANGE REPLICATION FILTER REPLICATE_REWRITE_DB = ((db1, db2));\n\nThe statement just shown contains two sets of parentheses, one\nenclosing the pair of database names, and the other enclosing the\nentire list. This is perhaps more easily seen in the following example,\nwhich creates two rewrite-db rules, one rewriting database dbA to dbB,\nand one rewriting database dbC to dbD:\n\nCHANGE REPLICATION FILTER\n  REPLICATE_REWRITE_DB = ((dbA, dbB), (dbC, dbD));\n\nThe CHANGE REPLICATION FILTER statement replaces replication filtering\nrules only for the filter types and replication channels affected by\nthe statement, and leaves other rules and channels unchanged. If you\nwant to unset all filters of a given type, set the filter\'s value to an\nexplicitly empty list, as shown in this example, which removes all\nexisting REPLICATE_DO_DB and REPLICATE_IGNORE_DB rules:\n\nCHANGE REPLICATION FILTER\n    REPLICATE_DO_DB = (), REPLICATE_IGNORE_DB = ();\n\nSetting a filter to empty in this way removes all existing rules, does\nnot create any new ones, and does not restore any rules set at mysqld\nstartup using --replicate-* options on the command line or in the\nconfiguration file.\n\nThe RESET REPLICA ALL statement removes channel specific replication\nfilters that were set on channels deleted by the statement. When the\ndeleted channel or channels are recreated, any global replication\nfilters specified for the replica are copied to them, and no channel\nspecific replication filters are applied.\n\nFor more information, see\nhttps://dev.mysql.com/doc/refman/8.0/en/replication-rules.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/change-replication-filter.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/change-replication-filter.html'),(579,'CHANGE REPLICATION SOURCE TO',43,'Syntax:\nCHANGE REPLICATION SOURCE TO option [, option] ... [ channel_option ]\n\noption: {\n    SOURCE_BIND = \'interface_name\'\n  | SOURCE_HOST = \'host_name\'\n  | SOURCE_USER = \'user_name\'\n  | SOURCE_PASSWORD = \'password\'\n  | SOURCE_PORT = port_num\n  | PRIVILEGE_CHECKS_USER = {NULL | \'account\'}\n  | REQUIRE_ROW_FORMAT = {0|1}\n  | REQUIRE_TABLE_PRIMARY_KEY_CHECK = {STREAM | ON | OFF | GENERATE}\n  | ASSIGN_GTIDS_TO_ANONYMOUS_TRANSACTIONS = {OFF | LOCAL | uuid}\n  | SOURCE_LOG_FILE = \'source_log_name\'\n  | SOURCE_LOG_POS = source_log_pos\n  | SOURCE_AUTO_POSITION = {0|1}\n  | RELAY_LOG_FILE = \'relay_log_name\'\n  | RELAY_LOG_POS = relay_log_pos\n  | SOURCE_HEARTBEAT_PERIOD = interval\n  | SOURCE_CONNECT_RETRY = interval\n  | SOURCE_RETRY_COUNT = count\n  | SOURCE_CONNECTION_AUTO_FAILOVER = {0|1}\n  | SOURCE_DELAY = interval\n  | SOURCE_COMPRESSION_ALGORITHMS = \'algorithm[,algorithm][,algorithm]\'\n  | SOURCE_ZSTD_COMPRESSION_LEVEL = level\n  | SOURCE_SSL = {0|1}\n  | SOURCE_SSL_CA = \'ca_file_name\'\n  | SOURCE_SSL_CAPATH = \'ca_directory_name\'\n  | SOURCE_SSL_CERT = \'cert_file_name\'\n  | SOURCE_SSL_CRL = \'crl_file_name\'\n  | SOURCE_SSL_CRLPATH = \'crl_directory_name\'\n  | SOURCE_SSL_KEY = \'key_file_name\'\n  | SOURCE_SSL_CIPHER = \'cipher_list\'\n  | SOURCE_SSL_VERIFY_SERVER_CERT = {0|1}\n  | SOURCE_TLS_VERSION = \'protocol_list\'\n  | SOURCE_TLS_CIPHERSUITES = \'ciphersuite_list\'\n  | SOURCE_PUBLIC_KEY_PATH = \'key_file_name\'\n  | GET_SOURCE_PUBLIC_KEY = {0|1}\n  | NETWORK_NAMESPACE = \'namespace\'\n  | IGNORE_SERVER_IDS = (server_id_list),\n  | GTID_ONLY = {0|1}\n}\n\nchannel_option:\n    FOR CHANNEL channel\n\nserver_id_list:\n    [server_id [, server_id] ... ]\n\nCHANGE REPLICATION SOURCE TO changes the parameters that the replica\nserver uses for connecting to the source and reading data from the\nsource. It also updates the contents of the replication metadata\nrepositories (see\nhttps://dev.mysql.com/doc/refman/8.0/en/replica-logs.html). In MySQL\n8.0.23 and later, use CHANGE REPLICATION SOURCE TO in place of the\ndeprecated CHANGE MASTER TO statement.\n\nCHANGE REPLICATION SOURCE TO requires the REPLICATION_SLAVE_ADMIN\nprivilege (or the deprecated SUPER privilege).\n\nOptions that you do not specify on a CHANGE REPLICATION SOURCE TO\nstatement retain their value, except as indicated in the following\ndiscussion. In most cases, there is therefore no need to specify\noptions that do not change.\n\nValues used for SOURCE_HOST and other CHANGE REPLICATION SOURCE TO\noptions are checked for linefeed (\\n or 0x0A) characters. The presence\nof such characters in these values causes the statement to fail with an\nerror.\n\nThe optional FOR CHANNEL channel clause lets you name which replication\nchannel the statement applies to. Providing a FOR CHANNEL channel\nclause applies the CHANGE REPLICATION SOURCE TO statement to a specific\nreplication channel, and is used to add a new channel or modify an\nexisting channel. For example, to add a new channel called channel2:\n\nCHANGE REPLICATION SOURCE TO SOURCE_HOST=host1, SOURCE_PORT=3002 FOR CHANNEL \'channel2\';\n\nIf no clause is named and no extra channels exist, a CHANGE REPLICATION\nSOURCE TO statement applies to the default channel, whose name is the\nempty string (\"\"). When you have set up multiple replication channels,\nevery CHANGE REPLICATION SOURCE TO statement must name a channel using\nthe FOR CHANNEL channel clause. See\nhttps://dev.mysql.com/doc/refman/8.0/en/replication-channels.html for\nmore information.\n\nFor some of the options of the CHANGE REPLICATION SOURCE TO statement,\nyou must issue a STOP REPLICA statement prior to issuing a CHANGE\nREPLICATION SOURCE TO statement (and a START REPLICA statement\nafterwards). Sometimes, you only need to stop the replication SQL\n(applier) thread or the replication I/O (receiver) thread, not both:\n\no When the applier thread is stopped, you can execute CHANGE\n  REPLICATION SOURCE TO using any combination that is otherwise allowed\n  of RELAY_LOG_FILE, RELAY_LOG_POS, and SOURCE_DELAY options, even if\n  the replication receiver thread is running. No other options may be\n  used with this statement when the receiver thread is running.\n\no When the receiver thread is stopped, you can execute CHANGE\n  REPLICATION SOURCE TO using any of the options for this statement (in\n  any allowed combination) except RELAY_LOG_FILE, RELAY_LOG_POS,\n  SOURCE_DELAY, or SOURCE_AUTO_POSITION = 1 even when the applier\n  thread is running.\n\no Both the receiver thread and the applier thread must be stopped\n  before issuing a CHANGE REPLICATION SOURCE TO statement that employs\n  SOURCE_AUTO_POSITION = 1, GTID_ONLY = 1, or\n  ASSIGN_GTIDS_TO_ANONYMOUS_TRANSACTIONS.\n\nYou can check the current state of the replication applier thread and\nreplication receiver thread using SHOW REPLICA STATUS. Note that the\nGroup Replication applier channel (group_replication_applier) has no\nreceiver thread, only an applier thread.\n\nCHANGE REPLICATION SOURCE TO statements have a number of side-effects\nand interactions that you should be aware of beforehand:\n\no CHANGE REPLICATION SOURCE TO causes an implicit commit of an ongoing\n  transaction. See\n  https://dev.mysql.com/doc/refman/8.0/en/implicit-commit.html.\n\no CHANGE REPLICATION SOURCE TO causes the previous values for\n  SOURCE_HOST, SOURCE_PORT, SOURCE_LOG_FILE, and SOURCE_LOG_POS to be\n  written to the error log, along with other information about the\n  replica\'s state prior to execution.\n\no If you are using statement-based replication and temporary tables, it\n  is possible for a CHANGE REPLICATION SOURCE TO statement following a\n  STOP REPLICA statement to leave behind temporary tables on the\n  replica. A warning (ER_WARN_OPEN_TEMP_TABLES_MUST_BE_ZERO\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_warn_open_temp_tables_must_be_zero)) is issued\n  whenever this occurs. You can avoid this in such cases by making sure\n  that the value of the Replica_open_temp_tables or\n  Slave_open_temp_tables system status variable is equal to 0 prior to\n  executing such a CHANGE REPLICATION SOURCE TO statement.\n\no When using a multithreaded replica (replica_parallel_workers > 0),\n  stopping the replica can cause gaps in the sequence of transactions\n  that have been executed from the relay log, regardless of whether the\n  replica was stopped intentionally or otherwise. When such gaps exist,\n  issuing CHANGE REPLICATION SOURCE TO fails. The solution in this\n  situation is to issue START REPLICA UNTIL SQL_AFTER_MTS_GAPS which\n  ensures that the gaps are closed. From MySQL 8.0.26, the process of\n  checking for gaps in the sequence of transactions is skipped entirely\n  when GTID-based replication and GTID auto-positioning are in use,\n  because gaps in transactions can be resolved using GTID\n  auto-positioning. In that situation, CHANGE REPLICATION SOURCE TO can\n  still be used.\n\nThe following options are available for CHANGE REPLICATION SOURCE TO\nstatements:\n\no ASSIGN_GTIDS_TO_ANONYMOUS_TRANSACTIONS = {OFF | LOCAL | uuid}\n\n  Makes the replication channel assign a GTID to replicated\n  transactions that do not have one, enabling replication from a source\n  that does not use GTID-based replication, to a replica that does. For\n  a multi-source replica, you can have a mix of channels that use\n  ASSIGN_GTIDS_TO_ANONYMOUS_TRANSACTIONS, and channels that do not. The\n  default is OFF, meaning that the feature is not used.\n\n  LOCAL assigns a GTID including the replica\'s own UUID (the\n  server_uuid setting). uuid assigns a GTID including the specified\n  UUID, such as the server_uuid setting for the replication source\n  server. Using a nonlocal UUID lets you differentiate between\n  transactions that originated on the replica and transactions that\n  originated on the source, and for a multi-source replica, between\n  transactions that originated on different sources. The UUID you\n  choose only has significance for the replica\'s own use. If any of the\n  transactions sent by the source do have a GTID already, that GTID is\n  retained.\n\n  Channels specific to Group Replication cannot use\n  ASSIGN_GTIDS_TO_ANONYMOUS_TRANSACTIONS, but an asynchronous\n  replication channel for another source on a server instance that is a\n  Group Replication group member can do so. In that case, do not\n  specify the Group Replication group name as the UUID for creating the\n  GTIDs.\n\n  To set ASSIGN_GTIDS_TO_ANONYMOUS_TRANSACTIONS to LOCAL or uuid, the\n  replica must have gtid_mode=ON set, and this cannot be changed\n  afterwards. This option is for use with a source that has binary log\n  file position based replication, so SOURCE_AUTO_POSITION=1 cannot be\n  set for the channel. Both the replication SQL thread and the\n  replication I/O (receiver) thread must be stopped before setting this\n  option.\n\n  *Important*:\n\n  A replica set up with ASSIGN_GTIDS_TO_ANONYMOUS_TRANSACTIONS on any\n  channel cannot be promoted to replace the replication source server\n  in the event that a failover is required, and a backup taken from the\n  replica cannot be used to restore the replication source server. The\n  same restriction applies to replacing or restoring other replicas\n  that use ASSIGN_GTIDS_TO_ANONYMOUS_TRANSACTIONS on any channel.\n\n  For further restrictions and information, see\n  https://dev.mysql.com/doc/refman/8.0/en/replication-gtids-assign-anon\n  .html.\n\no GET_SOURCE_PUBLIC_KEY = {0|1}\n\n  Enables RSA key pair-based password exchange by requesting the public\n  key from the source. The option is disabled by default.\n\n  This option applies to replicas that authenticate with the\n  caching_sha2_password authentication plugin. For connections by\n  accounts that authenticate using this plugin, the source does not\n  send the public key unless requested, so it must be requested or\n  specified in the client. If SOURCE_PUBLIC_KEY_PATH is given and\n  specifies a valid public key file, it takes precedence over\n  GET_SOURCE_PUBLIC_KEY. If you are using a replication user account\n  that authenticates with the caching_sha2_password plugin (which is\n  the default from MySQL 8.0), and you are not using a secure\n  connection, you must specify either this option or the\n  SOURCE_PUBLIC_KEY_PATH option to provide the RSA public key to the\n  replica.\n\no GTID_ONLY = {0|1}\n\n  Stops the replication channel persisting file names and file\n  positions in the replication metadata repositories. GTID_ONLY is\n  available as of MySQL 8.0.27. The GTID_ONLY option is disabled by\n  default for asynchronous replication channels, but it is enabled by\n  default for Group Replication channels, and it cannot be disabled for\n  them.\n\n  For replication channels with this setting, in-memory file positions\n  are still tracked, and file positions can still be observed for\n  debugging purposes in error messages and through interfaces such as\n  SHOW REPLICA STATUS statements (where they are shown as being invalid\n  if they are out of date). However, the writes and reads required to\n  persist and check the file positions are avoided in situations where\n  GTID-based replication does not actually require them, including the\n  transaction queuing and application process.\n\n  This option can be used only if both the replication SQL (applier)\n  thread and replication I/O (receiver) thread are stopped. To set\n  GTID_ONLY = 1 for a replication channel, GTIDs must be in use on the\n  server (gtid_mode = ON), and row-based binary logging must be in use\n  on the source (statement-based replication is not supported). The\n  options REQUIRE_ROW_FORMAT = 1 and SOURCE_AUTO_POSITION = 1 must be\n  set for the replication channel.\n\n  When GTID_ONLY = 1 is set, the replica uses\n  replica_parallel_workers=1 if that system variable is set to zero for\n  the server, so it is always technically a multi-threaded applier.\n  This is because a multi-threaded applier uses saved positions rather\n  than the replication metadata repositories to locate the start of a\n  transaction that it needs to reapply.\n\n  If you disable GTID_ONLY after setting it, the existing relay logs\n  are deleted and the existing known binary log file positions are\n  persisted, even if they are stale. The file positions for the binary\n  log and relay log in the replication metadata repositories might be\n  invalid, and a warning is returned if this is the case. Provided that\n  SOURCE_AUTO_POSITION is still enabled, GTID auto-positioning is used\n  to provide the correct positioning.\n\n  If you also disable SOURCE_AUTO_POSITION, the file positions for the\n  binary log and relay log in the replication metadata repositories are\n  used for positioning if they are valid. If they are marked as\n  invalid, you must provide a valid binary log file name and position\n  (SOURCE_LOG_FILE and SOURCE_LOG_POS). If you also provide a relay log\n  file name and position (RELAY_LOG_FILE and RELAY_LOG_POS), the relay\n  logs are preserved and the applier position is set to the stated\n  position. GTID auto-skip ensures that any transactions already\n  applied are skipped even if the eventual applier position is not\n  correct.\n\no IGNORE_SERVER_IDS = (server_id_list)\n\n  Makes the replica ignore events originating from the specified\n  servers. The option takes a comma-separated list of 0 or more server\n  IDs. Log rotation and deletion events from the servers are not\n  ignored, and are recorded in the relay log.\n\n  In circular replication, the originating server normally acts as the\n  terminator of its own events, so that they are not applied more than\n  once. Thus, this option is useful in circular replication when one of\n  the servers in the circle is removed. Suppose that you have a\n  circular replication setup with 4 servers, having server IDs 1, 2, 3,\n  and 4, and server 3 fails. When bridging the gap by starting\n  replication from server 2 to server 4, you can include\n  IGNORE_SERVER_IDS = (3) in the CHANGE REPLICATION SOURCE TO statement\n  that you issue on server 4 to tell it to use server 2 as its source\n  instead of server 3. Doing so causes it to ignore and not to\n  propagate any statements that originated with the server that is no\n  longer in use.\n\n  If IGNORE_SERVER_IDS contains the server\'s own ID and the server was\n  started with the --replicate-same-server-id option enabled, an error\n  results.\n\n  *Note*:\n\n  When global transaction identifiers (GTIDs) are used for replication,\n  transactions that have already been applied are automatically\n  ignored, so the IGNORE_SERVER_IDS function is not required and is\n  deprecated. If gtid_mode=ON is set for the server, a deprecation\n  warning is issued if you include the IGNORE_SERVER_IDS option in a\n  CHANGE REPLICATION SOURCE TO statement.\n\n  The source metadata repository and the output of SHOW REPLICA STATUS\n  provide the list of servers that are currently ignored. For more\n  information, see\n  https://dev.mysql.com/doc/refman/8.0/en/replica-logs-status.html, and\n  [HELP SHOW REPLICA STATUS].\n\n  If a CHANGE REPLICATION SOURCE TO statement is issued without any\n  IGNORE_SERVER_IDS option, any existing list is preserved. To clear\n  the list of ignored servers, it is necessary to use the option with\n  an empty list:\n\nCHANGE REPLICATION SOURCE TO IGNORE_SERVER_IDS = ();\n\n  RESET REPLICA ALL clears IGNORE_SERVER_IDS.\n\n  *Note*:\n\n  A deprecation warning is issued if SET GTID_MODE=ON is issued when\n  any channel has existing server IDs set with IGNORE_SERVER_IDS.\n  Before starting GTID-based replication, check for and clear all\n  ignored server ID lists on the servers involved. The SHOW REPLICA\n  STATUS statement displays the list of ignored IDs, if there is one.\n  If you do receive the deprecation warning, you can still clear a list\n  after gtid_mode=ON is set by issuing a CHANGE REPLICATION SOURCE TO\n  statement containing the IGNORE_SERVER_IDS option with an empty list.\n\no NETWORK_NAMESPACE = \'namespace\'\n\n  The network namespace to use for TCP/IP connections to the\n  replication source server or, if the MySQL communication stack is in\n  use, for Group Replication\'s group communication connections. The\n  maximum length of the string value is 64 characters. If this option\n  is omitted, connections from the replica use the default (global)\n  namespace. On platforms that do not implement network namespace\n  support, failure occurs when the replica attempts to connect to the\n  source. For information about network namespaces, see\n  https://dev.mysql.com/doc/refman/8.0/en/network-namespace-support.htm\n  l. NETWORK_NAMESPACE is available as of MySQL 8.0.22.\n\no PRIVILEGE_CHECKS_USER = {NULL | \'account\'}\n\n  Names a user account that supplies a security context for the\n  specified channel. NULL, which is the default, means no security\n  context is used. PRIVILEGE_CHECKS_USER is available as of MySQL\n  8.0.18.\n\n  The user name and host name for the user account must follow the\n  syntax described in\n  https://dev.mysql.com/doc/refman/8.0/en/account-names.html, and the\n  user must not be an anonymous user (with a blank user name) or the\n  CURRENT_USER. The account must have the REPLICATION_APPLIER\n  privilege, plus the required privileges to execute the transactions\n  replicated on the channel. For details of the privileges required by\n  the account, see\n  https://dev.mysql.com/doc/refman/8.0/en/replication-privilege-checks.\n  html. When you restart the replication channel, the privilege checks\n  are applied from that point on. If you do not specify a channel and\n  no other channels exist, the statement is applied to the default\n  channel.\n\n  The use of row-based binary logging is strongly recommended when\n  PRIVILEGE_CHECKS_USER is set, and you can set REQUIRE_ROW_FORMAT to\n  enforce this. For example, to start privilege checks on the channel\n  channel_1 on a running replica, issue the following statements:\n\nSTOP REPLICA FOR CHANNEL \'channel_1\';\n\nCHANGE REPLICATION SOURCE TO\n    PRIVILEGE_CHECKS_USER = \'user\'@\'host\',\n    REQUIRE_ROW_FORMAT = 1,\n    FOR CHANNEL \'channel_1\';\n\nSTART REPLICA FOR CHANNEL \'channel_1\';\n\no RELAY_LOG_FILE = \'relay_log_file\' , RELAY_LOG_POS = \'relay_log_pos\'\n\n  The relay log file name, and the location in that file, at which the\n  replication SQL thread begins reading from the replica\'s relay log\n  the next time the thread starts. RELAY_LOG_FILE can use either an\n  absolute or relative path, and uses the same base name as\n  SOURCE_LOG_FILE. The maximum length of the string value is 511\n  characters.\n\n  A CHANGE REPLICATION SOURCE TO statement using RELAY_LOG_FILE,\n  RELAY_LOG_POS, or both options can be executed on a running replica\n  when the replication SQL (applier) thread is stopped. Relay logs are\n  preserved if at least one of the replication applier thread and the\n  replication I/O (receiver) thread is running. If both threads are\n  stopped, all relay log files are deleted unless at least one of\n  RELAY_LOG_FILE or RELAY_LOG_POS is specified. For the Group\n  Replication applier channel (group_replication_applier), which only\n  has an applier thread and no receiver thread, this is the case if the\n  applier thread is stopped, but with that channel you cannot use the\n  RELAY_LOG_FILE and RELAY_LOG_POS options.\n\no REQUIRE_ROW_FORMAT = {0|1}\n\n  Permits only row-based replication events to be processed by the\n  replication channel. This option prevents the replication applier\n  from taking actions such as creating temporary tables and executing\n  LOAD DATA INFILE requests, which increases the security of the\n  channel. The REQUIRE_ROW_FORMAT option is disabled by default for\n  asynchronous replication channels, but it is enabled by default for\n  Group Replication channels, and it cannot be disabled for them. For\n  more information, see\n  https://dev.mysql.com/doc/refman/8.0/en/replication-privilege-checks.\n  html. REQUIRE_ROW_FORMAT is available as of MySQL 8.0.19.\n\no REQUIRE_TABLE_PRIMARY_KEY_CHECK = {STREAM | ON | OFF | GENERATE}\n\n  Available as of MySQL 8.0.20, this option lets a replica set its own\n  policy for primary key checks, as follows:\n\n  o ON: The replica sets sql_require_primary_key = ON; all tables on\n    the replica, including all replicated tables, require a primary\n    key.\n\n  o OFF: The replica sets sql_require_primary_key = OFF; a primary key\n    is never required on the replica, including replicated tables, even\n    if one is required on the source.\n\n  o STREAM: The replica uses whatever value of sql_require_primary_key\n    is replicated from the source for each transaction. This is the\n    default value, and the default behavior.\n\n  o GENERATE: Added in MySQL 8.0.32, this causes the replica to\n    generate an invisible primary key for any InnoDB table that, as\n    replicated, lacks a primary key. See\n    https://dev.mysql.com/doc/refman/8.0/en/create-table-gipks.html,\n    for more information.\n\n    GENERATE is not compatible with Group Replication; you can use ON,\n    OFF, or STREAM.\n\n  A divergence based on the presence of a generated invisible primary\n  key solely on a source or replica table is supported by MySQL\n  Replication as long as the source supports GIPKs (MySQL 8.0.30 and\n  later) and the replica uses MySQL version 8.0.32 or later. If you use\n  GIPKs on a replica and replicate from a source using a MySQL 8.0.29\n  or earlier, you should be aware that in this case such divergences in\n  schema are not supported and may result in replication errors.\n\n  For multisource replication, setting REQUIRE_TABLE_PRIMARY_KEY_CHECK\n  to ON or OFF lets the replica normalize behavior across replication\n  channels for different sources, and to keep a consistent setting for\n  sql_require_primary_key. Using ON safeguards against the accidental\n  loss of primary keys when multiple sources update the same set of\n  tables. Using OFF lets sources that can manipulate primary keys to\n  work alongside sources that cannot.\n\n  In the case of multiple replicas, when\n  REQUIRE_TABLE_PRIMARY_KEY_CHECK is set to GENERATE, the generated\n  invisible primary key added by a given replica is independent of any\n  such key added on any other replica. This means that, if generated\n  invisible primary keys are in use, the values in the generated\n  primary key columns on different replicas are not guaranteed to be\n  the same. This may be an issue when failing over to such a replica.\n\n  When PRIVILEGE_CHECKS_USER is NULL (the default), the user account\n  needs administration-level privileges to set restricted session\n  variables. Setting this option to a value other than NULL means that,\n  when REQUIRE_TABLE_PRIMARY_KEY_CHECK is ON or OFF, the user account\n  does not need session administration level privileges to set\n  restricted session variables, which are required to change the value\n  of sql_require_primary_key to match the setting on the source for\n  each transaction. (Such privileges are required when\n  PRIVILEGE_CHECKS_USER is STREAM.) For more information, see\n  https://dev.mysql.com/doc/refman/8.0/en/replication-privilege-checks.\n  html.\n\no SOURCE_AUTO_POSITION = {0|1}\n\n  Makes the replica attempt to connect to the source using the\n  auto-positioning feature of GTID-based replication, rather than a\n  binary log file based position. This option is used to start a\n  replica using GTID-based replication. The default is 0, meaning that\n  GTID auto-positioning and GTID-based replication are not used. This\n  option can be used with CHANGE REPLICATION SOURCE TO only if both the\n  replication SQL (applier) thread and replication I/O (receiver)\n  thread are stopped.\n\n  Both the replica and the source must have GTIDs enabled\n  (GTID_MODE=ON, ON_PERMISSIVE, or OFF_PERMISSIVE on the replica, and\n  GTID_MODE=ON on the source). SOURCE_LOG_FILE, SOURCE_LOG_POS,\n  RELAY_LOG_FILE, and RELAY_LOG_POS cannot be specified together with\n  SOURCE_AUTO_POSITION = 1. If multi-source replication is enabled on\n  the replica, you need to set the SOURCE_AUTO_POSITION = 1 option for\n  each applicable replication channel.\n\n  With SOURCE_AUTO_POSITION = 1 set, in the initial connection\n  handshake, the replica sends a GTID set containing the transactions\n  that it has already received, committed, or both. The source responds\n  by sending all transactions recorded in its binary log whose GTID is\n  not included in the GTID set sent by the replica. This exchange\n  ensures that the source only sends the transactions with a GTID that\n  the replica has not already recorded or committed. If the replica\n  receives transactions from more than one source, as in the case of a\n  diamond topology, the auto-skip function ensures that the\n  transactions are not applied twice. For details of how the GTID set\n  sent by the replica is computed, see\n  https://dev.mysql.com/doc/refman/8.0/en/replication-gtids-auto-positi\n  oning.html.\n\n  If any of the transactions that should be sent by the source have\n  been purged from the source\'s binary log, or added to the set of\n  GTIDs in the gtid_purged system variable by another method, the\n  source sends the error ER_MASTER_HAS_PURGED_REQUIRED_GTIDS\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_master_has_purged_required_gtids) to the replica, and\n  replication does not start. The GTIDs of the missing purged\n  transactions are identified and listed in the source\'s error log in\n  the warning message ER_FOUND_MISSING_GTIDS\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_found_missing_gtids). Also, if during the exchange of\n  transactions it is found that the replica has recorded or committed\n  transactions with the source\'s UUID in the GTID, but the source\n  itself has not committed them, the source sends the error\n  ER_SLAVE_HAS_MORE_GTIDS_THAN_MASTER\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html#error_er_slave_has_more_gtids_than_master) to the replica and\n  replication does not start. For information on how to handle these\n  situations, see\n  https://dev.mysql.com/doc/refman/8.0/en/replication-gtids-auto-positi\n  oning.html.\n\n  You can see whether replication is running with GTID auto-positioning\n  enabled by checking the Performance Schema\n  replication_connection_status table or the output of SHOW REPLICA\n  STATUS. Disabling the SOURCE_AUTO_POSITION option again makes the\n  replica revert to file-based replication.\n\no SOURCE_BIND = \'interface_name\'\n\n  Determines which of the replica\'s network interfaces is chosen for\n  connecting to the source, for use on replicas that have multiple\n  network interfaces. Specify the IP address of the network interface.\n  The maximum length of the string value is 255 characters.\n\n  The IP address configured with this option, if any, can be seen in\n  the Source_Bind column of the output from SHOW REPLICA STATUS. In the\n  source metadata repository table mysql.slave_master_info, the value\n  can be seen as the Source_bind column. The ability to bind a replica\n  to a specific network interface is also supported by NDB Cluster.\n\no SOURCE_COMPRESSION_ALGORITHMS = \'algorithm[,algorithm][,algorithm]\'\n\n  Specifies one, two, or three of the permitted compression algorithms\n  for connections to the replication source server, separated by\n  commas. The maximum length of the string value is 99 characters. The\n  default value is uncompressed.\n\n  The available algorithms are zlib, zstd, and uncompressed, the same\n  as for the protocol_compression_algorithms system variable. The\n  algorithms can be specified in any order, but it is not an order of\n  preference - the algorithm negotiation process attempts to use zlib,\n  then zstd, then uncompressed, if they are specified.\n  SOURCE_COMPRESSION_ALGORITHMS is available as of MySQL 8.0.18.\n\n  The value of SOURCE_COMPRESSION_ALGORITHMS applies only if the\n  replica_compressed_protocol or slave_compressed_protocol system\n  variable is disabled. If replica_compressed_protocol or\n  slave_compressed_protocol is enabled, it takes precedence over\n  SOURCE_COMPRESSION_ALGORITHMS and connections to the source use zlib\n  compression if both source and replica support that algorithm. For\n  more information, see\n  https://dev.mysql.com/doc/refman/8.0/en/connection-compression-contro\n  l.html.\n\n  Binary log transaction compression (available as of MySQL 8.0.20),\n  which is activated by the binlog_transaction_compression system\n  variable, can also be used to save bandwidth. If you do this in\n  combination with connection compression, connection compression has\n  less opportunity to act on the data, but can still compress headers\n  and those events and transaction payloads that are uncompressed. For\n  more information on binary log transaction compression, see\n  https://dev.mysql.com/doc/refman/8.0/en/binary-log-transaction-compre\n  ssion.html.\n\no SOURCE_CONNECT_RETRY = interval\n\n  Specifies the interval in seconds between the reconnection attempts\n  that the replica makes after the connection to the source times out.\n  The default interval is 60.\n\n  The number of attempts is limited by the SOURCE_RETRY_COUNT option.\n  If both the default settings are used, the replica waits 60 seconds\n  between reconnection attempts (SOURCE_CONNECT_RETRY=60), and keeps\n  attempting to reconnect at this rate for 60 days\n  (SOURCE_RETRY_COUNT=86400). These values are recorded in the source\n  metadata repository and shown in the\n  replication_connection_configuration Performance Schema table.\n\no SOURCE_CONNECTION_AUTO_FAILOVER = {0|1}\n\n  Activates the asynchronous connection failover mechanism for a\n  replication channel if one or more alternative replication source\n  servers are available (so when there are multiple MySQL servers or\n  groups of servers that share the replicated data).\n  SOURCE_CONNECTION_AUTO_FAILOVER is available as of MySQL 8.0.22. The\n  default is 0, meaning that the mechanism is not activated. For full\n  information and instructions to set up this feature, see\n  https://dev.mysql.com/doc/refman/8.0/en/replication-asynchronous-conn\n  ection-failover-replica.html.\n\n  The asynchronous connection failover mechanism takes over after the\n  reconnection attempts controlled by SOURCE_CONNECT_RETRY and\n  SOURCE_RETRY_COUNT are exhausted. It reconnects the replica to an\n  alternative source chosen from a specified source list, which you\n  manage using the asynchronous_connection_failover_add_source and\n  asynchronous_connection_failover_delete_source functions. To add and\n  remove managed groups of servers, use the\n  asynchronous_connection_failover_add_managed and\n  asynchronous_connection_failover_delete_managed functions instead.\n  For more information, see\n  https://dev.mysql.com/doc/refman/8.0/en/replication-asynchronous-conn\n  ection-failover.html.\n\n  *Important*:\n\n   1. You can only set SOURCE_CONNECTION_AUTO_FAILOVER = 1 when GTID\n      auto-positioning is in use (SOURCE_AUTO_POSITION = 1).\n\n   2. When you set SOURCE_CONNECTION_AUTO_FAILOVER = 1, set\n      SOURCE_RETRY_COUNT and SOURCE_CONNECT_RETRY to minimal numbers\n      that just allow a few retry attempts with the same source, in\n      case the connection failure is caused by a transient network\n      outage. Otherwise the asynchronous connection failover mechanism\n      cannot be activated promptly. Suitable values are\n      SOURCE_RETRY_COUNT=3 and SOURCE_CONNECT_RETRY=10, which make the\n      replica retry the connection 3 times with 10-second intervals\n      between.\n\n   3. When you set SOURCE_CONNECTION_AUTO_FAILOVER = 1, the replication\n      metadata repositories must contain the credentials for a\n      replication user account that can be used to connect to all the\n      servers on the source list for the replication channel. The\n      account must also have SELECT permissions on the Performance\n      Schema tables. These credentials can be set using the CHANGE\n      REPLICATION SOURCE TO statement with the SOURCE_USER and\n      SOURCE_PASSWORD options. For more information, see\n      https://dev.mysql.com/doc/refman/8.0/en/replication-asynchronous-\n      connection-failover.html.\n\n   4. From MySQL 8.0.27, when you set SOURCE_CONNECTION_AUTO_FAILOVER =\n      1, asynchronous connection failover for replicas is automatically\n      activated if this replication channel is on a Group Replication\n      primary in a group in single-primary mode. With this function\n      active, if the primary that is replicating goes offline or into\n      an error state, the new primary starts replication on the same\n      channel when it is elected. If you want to use the function, this\n      replication channel must also be set up on all the secondary\n      servers in the replication group, and on any new joining members.\n      (If the servers are provisioned using MySQL\'s clone\n      functionality, this all happens automatically.) If you do not\n      want to use the function, disable it by using the\n      group_replication_disable_member_action function to disable the\n      Group Replication member action\n      mysql_start_failover_channels_if_primary, which is enabled by\n      default. For more information, see\n      https://dev.mysql.com/doc/refman/8.0/en/replication-asynchronous-\n      connection-failover-replica.html.\n\no SOURCE_DELAY = interval\n\n  Specifies how many seconds behind the source the replica must lag. An\n  event received from the source is not executed until at least\n  interval seconds later than its execution on the source. interval\n  must be a nonnegative integer in the range from 0 to 231−1. The\n  default is 0. For more information, see\n  https://dev.mysql.com/doc/refman/8.0/en/replication-delayed.html.\n\n  A CHANGE REPLICATION SOURCE TO statement using the SOURCE_DELAY\n  option can be executed on a running replica when the replication SQL\n  thread is stopped.\n\no SOURCE_HEARTBEAT_PERIOD = interval\n\n  Controls the heartbeat interval, which stops the connection timeout\n  occurring in the absence of data if the connection is still good. A\n  heartbeat signal is sent to the replica after that number of seconds,\n  and the waiting period is reset whenever the source\'s binary log is\n  updated with an event. Heartbeats are therefore sent by the source\n  only if there are no unsent events in the binary log file for a\n  period longer than this.\n\n  The heartbeat interval interval is a decimal value having the range 0\n  to 4294967 seconds and a resolution in milliseconds; the smallest\n  nonzero value is 0.001. Setting interval to 0 disables heartbeats\n  altogether. The heartbeat interval defaults to half the value of the\n  replica_net_timeout or slave_net_timeout system variable. It is\n  recorded in the source metadata repository and shown in the\n  replication_connection_configuration Performance Schema table.\n  Issuing RESET REPLICA resets the heartbeat interval to the default\n  value.\n\n  The system variable replica_net_timeout (from MySQL 8.0.26) or\n  slave_net_timeout (before MySQL 8.0.26) specifies the number of\n  seconds that the replica waits for either more data or a heartbeat\n  signal from the source, before the replica considers the connection\n  broken, aborts the read, and tries to reconnect. The default value is\n  60 seconds (one minute). Note that a change to the value or default\n  setting of replica_net_timeout or slave_net_timeout does not\n  automatically change the heartbeat interval, whether that has been\n  set explicitly or is using a previously calculated default. A warning\n  is issued if you set the global value of replica_net_timeout or\n  slave_net_timeout to a value less than that of the current heartbeat\n  interval. If replica_net_timeout or slave_net_timeout is changed, you\n  must also issue CHANGE REPLICATION SOURCE TO to adjust the heartbeat\n  interval to an appropriate value so that the heartbeat signal occurs\n  before the connection timeout. If you do not do this, the heartbeat\n  signal has no effect, and if no data is received from the source, the\n  replica can make repeated reconnection attempts, creating zombie dump\n  threads.\n\no SOURCE_HOST = \'host_name\'\n\n  The host name or IP address of the replication source server. The\n  replica uses this to connect to the source. The maximum length of the\n  string value is 255 characters.\n\n  If you specify SOURCE_HOST or SOURCE_PORT, the replica assumes that\n  the source server is different from before (even if the option value\n  is the same as its current value.) In this case, the old values for\n  the source\'s binary log file name and position are considered no\n  longer applicable, so if you do not specify SOURCE_LOG_FILE and\n  SOURCE_LOG_POS in the statement, SOURCE_LOG_FILE=\'\' and\n  SOURCE_LOG_POS=4 are silently appended to it.\n\n  Setting SOURCE_HOST=\'\' (that is, setting its value explicitly to an\n  empty string) is not the same as not setting SOURCE_HOST at all.\n  Trying to set SOURCE_HOST to an empty string fails with an error.\n\no SOURCE_LOG_FILE = \'source_log_name\', SOURCE_LOG_POS = source_log_pos\n\n  The binary log file name, and the location in that file, at which the\n  replication I/O (receiver) thread begins reading from the source\'s\n  binary log the next time the thread starts. Specify these options if\n  you are using binary log file position based replication.\n\n  SOURCE_LOG_FILE must include the numeric suffix of a specific binary\n  log file that is available on the source server, for example,\n  SOURCE_LOG_FILE=\'binlog.000145\'. The maximum length of the string\n  value is 511 characters.\n\n  SOURCE_LOG_POS is the numeric position for the replica to start\n  reading in that file. SOURCE_LOG_POS=4 represents the start of the\n  events in a binary log file.\n\n  If you specify either of SOURCE_LOG_FILE or SOURCE_LOG_POS, you\n  cannot specify SOURCE_AUTO_POSITION = 1, which is for GTID-based\n  replication.\n\n  If neither of SOURCE_LOG_FILE or SOURCE_LOG_POS is specified, the\n  replica uses the last coordinates of the replication SQL thread\n  before CHANGE REPLICATION SOURCE TO was issued. This ensures that\n  there is no discontinuity in replication, even if the replication SQL\n  (applier) thread was late compared to the replication I/O (receiver)\n  thread.\n\no SOURCE_PASSWORD = \'password\'\n\n  The password for the replication user account to use for connecting\n  to the replication source server. The maximum length of the string\n  value is 32 characters. If you specify SOURCE_PASSWORD, SOURCE_USER\n  is also required.\n\n  The password used for a replication user account in a CHANGE\n  REPLICATION SOURCE TO statement is limited to 32 characters in\n  length. Trying to use a password of more than 32 characters causes\n  CHANGE REPLICATION SOURCE TO to fail.\n\n  The password is masked in MySQL Server\'s logs, Performance Schema\n  tables, and SHOW PROCESSLIST statements.\n\no SOURCE_PORT = port_num\n\n  The TCP/IP port number that the replica uses to connect to the\n  replication source server.\n\n  *Note*:\n\n  Replication cannot use Unix socket files. You must be able to connect\n  to the replication source server using TCP/IP.\n\n  If you specify SOURCE_HOST or SOURCE_PORT, the replica assumes that\n  the source server is different from before (even if the option value\n  is the same as its current value.) In this case, the old values for\n  the source\'s binary log file name and position are considered no\n  longer applicable, so if you do not specify SOURCE_LOG_FILE and\n  SOURCE_LOG_POS in the statement, SOURCE_LOG_FILE=\'\' and\n  SOURCE_LOG_POS=4 are silently appended to it.\n\no SOURCE_PUBLIC_KEY_PATH = \'key_file_name\'\n\n  Enables RSA key pair-based password exchange by providing the path\n  name to a file containing a replica-side copy of the public key\n  required by the source. The file must be in PEM format. The maximum\n  length of the string value is 511 characters.\n\n  This option applies to replicas that authenticate with the\n  sha256_password or caching_sha2_password authentication plugin. (For\n  sha256_password, SOURCE_PUBLIC_KEY_PATH can be used only if MySQL was\n  built using OpenSSL.) If you are using a replication user account\n  that authenticates with the caching_sha2_password plugin (which is\n  the default from MySQL 8.0), and you are not using a secure\n  connection, you must specify either this option or the\n  GET_SOURCE_PUBLIC_KEY=1 option to provide the RSA public key to the\n  replica.\n\no SOURCE_RETRY_COUNT = count\n\n  Sets the maximum number of reconnection attempts that the replica\n  makes after the connection to the source times out, as determined by\n  the replica_net_timeout or slave_net_timeout system variable. If the\n  replica does need to reconnect, the first retry occurs immediately\n  after the timeout. The default is 86400 attempts.\n\n  The interval between the attempts is specified by the\n  SOURCE_CONNECT_RETRY option. If both the default settings are used,\n  the replica waits 60 seconds between reconnection attempts\n  (SOURCE_CONNECT_RETRY=60), and keeps attempting to reconnect at this\n  rate for 60 days (SOURCE_RETRY_COUNT=86400). A setting of 0 for\n  SOURCE_RETRY_COUNT means that there is no limit on the number of\n  reconnection attempts, so the replica keeps trying to reconnect\n  indefinitely.\n\n  The values for SOURCE_CONNECT_RETRY and SOURCE_RETRY_COUNT are\n  recorded in the source metadata repository and shown in the\n  replication_connection_configuration Performance Schema table.\n  SOURCE_RETRY_COUNT supersedes the --master-retry-count server startup\n  option.\n\no SOURCE_SSL = {0|1}\n\n  Specify whether the replica encrypts the replication connection. The\n  default is 0, meaning that the replica does not encrypt the\n  replication connection. If you set SOURCE_SSL=1, you can configure\n  the encryption using the SOURCE_SSL_xxx and SOURCE_TLS_xxx options.\n\n  Setting SOURCE_SSL=1 for a replication connection and then setting no\n  further SOURCE_SSL_xxx options corresponds to setting\n  --ssl-mode=REQUIRED for the client, as described in\n  https://dev.mysql.com/doc/refman/8.0/en/connection-options.html#encry\n  pted-connection-options. With SOURCE_SSL=1, the connection attempt\n  only succeeds if an encrypted connection can be established. A\n  replication connection does not fall back to an unencrypted\n  connection, so there is no setting corresponding to the\n  --ssl-mode=PREFERRED setting for replication. If SOURCE_SSL=0 is set,\n  this corresponds to --ssl-mode=DISABLED.\n\n  *Important*:\n\n  To help prevent sophisticated man-in-the-middle attacks, it is\n  important for the replica to verify the server\'s identity. You can\n  specify additional SOURCE_SSL_xxx options to correspond to the\n  settings --ssl-mode=VERIFY_CA and --ssl-mode=VERIFY_IDENTITY, which\n  are a better choice than the default setting to help prevent this\n  type of attack. With these settings, the replica checks that the\n  server\'s certificate is valid, and checks that the host name the\n  replica is using matches the identity in the server\'s certificate. To\n  implement one of these levels of verification, you must first ensure\n  that the CA certificate for the server is reliably available to the\n  replica, otherwise availability issues will result. For this reason,\n  they are not the default setting.\n\no SOURCE_SSL_xxx, SOURCE_TLS_xxx\n\n  Specify how the replica uses encryption and ciphers to secure the\n  replication connection. These options can be changed even on replicas\n  that are compiled without SSL support. They are saved to the source\n  metadata repository, but are ignored if the replica does not have SSL\n  support enabled. The maximum length of the value for the\n  string-valued SOURCE_SSL_xxx and SOURCE_TLS_xxx options is 511\n  characters, with the exception of SOURCE_TLS_CIPHERSUITES, for which\n  it is 4000 characters.\n\n  The SOURCE_SSL_xxx and SOURCE_TLS_xxx options perform the same\n  functions as the --ssl-xxx and --tls-xxx client options described in\n  https://dev.mysql.com/doc/refman/8.0/en/connection-options.html#encry\n  pted-connection-options. The correspondence between the two sets of\n  options, and the use of the SOURCE_SSL_xxx and SOURCE_TLS_xxx options\n  to set up a secure connection, is explained in\n  https://dev.mysql.com/doc/refman/8.0/en/replication-encrypted-connect\n  ions.html.\n\no SOURCE_USER = \'user_name\'\n\n  The user name for the replication user account to use for connecting\n  to the replication source server. The maximum length of the string\n  value is 96 characters.\n\n  For Group Replication, this account must exist on every member of the\n  replication group. It is used for distributed recovery if the XCom\n  communication stack is in use for the group, and also used for group\n  communication connections if the MySQL communication stack is in use\n  for the group. With the MySQL communication stack, the account must\n  have the GROUP_REPLICATION_STREAM permission.\n\n  It is possible to set an empty user name by specifying\n  SOURCE_USER=\'\', but the replication channel cannot be started with an\n  empty user name. In releases before MySQL 8.0.21, only set an empty\n  SOURCE_USER user name if you need to clear previously used\n  credentials from the replication metadata repositories for security\n  purposes. Do not use the channel afterwards, due to a bug in these\n  releases that can substitute a default user name if an empty user\n  name is read from the repositories (for example, during an automatic\n  restart of a Group Replication channel). From MySQL 8.0.21, it is\n  valid to set an empty SOURCE_USER user name and use the channel\n  afterwards if you always provide user credentials using the START\n  REPLICA statement or START GROUP_REPLICATION statement that starts\n  the replication channel. This approach means that the replication\n  channel always needs operator intervention to restart, but the user\n  credentials are not recorded in the replication metadata\n  repositories.\n\n  *Important*:\n\n  To connect to the source using a replication user account that\n  authenticates with the caching_sha2_password plugin, you must either\n  set up a secure connection as described in\n  https://dev.mysql.com/doc/refman/8.0/en/replication-encrypted-connect\n  ions.html, or enable the unencrypted connection to support password\n  exchange using an RSA key pair. The caching_sha2_password\n  authentication plugin is the default for new users created from MySQL\n  8.0 (for details, see\n  https://dev.mysql.com/doc/refman/8.0/en/caching-sha2-pluggable-authen\n  tication.html). If the user account that you create or use for\n  replication uses this authentication plugin, and you are not using a\n  secure connection, you must enable RSA key pair-based password\n  exchange for a successful connection. You can do this using either\n  the SOURCE_PUBLIC_KEY_PATH option or the GET_SOURCE_PUBLIC_KEY=1\n  option for this statement.\n\no SOURCE_ZSTD_COMPRESSION_LEVEL = level\n\n  The compression level to use for connections to the replication\n  source server that use the zstd compression algorithm.\n  SOURCE_ZSTD_COMPRESSION_LEVEL is available as of MySQL 8.0.18. The\n  permitted levels are from 1 to 22, with larger values indicating\n  increasing levels of compression. The default level is 3.\n\n  The compression level setting has no effect on connections that do\n  not use zstd compression. For more information, see\n  https://dev.mysql.com/doc/refman/8.0/en/connection-compression-contro\n  l.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/change-replication-source-to.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/change-replication-source-to.html'),(580,'RESET REPLICA',43,'Syntax:\nRESET REPLICA [ALL] [channel_option]\n\nchannel_option:\n    FOR CHANNEL channel\n\nRESET REPLICA makes the replica forget its position in the source\'s\nbinary log. From MySQL 8.0.22, use RESET REPLICA in place of RESET\nSLAVE, which is deprecated from that release. In releases before MySQL\n8.0.22, use RESET SLAVE.\n\nThis statement is meant to be used for a clean start; it clears the\nreplication metadata repositories, deletes all the relay log files, and\nstarts a new relay log file. It also resets to 0 the replication delay\nspecified with the SOURCE_DELAY | MASTER_DELAY option of the CHANGE\nREPLICATION SOURCE TO statement (from MySQL 8.0.23) or CHANGE MASTER TO\nstatement (before MySQL 8.0.23).\n\n*Note*:\n\nAll relay log files are deleted, even if they have not been completely\nexecuted by the replication SQL thread. (This is a condition likely to\nexist on a replica if you have issued a STOP REPLICA statement or if\nthe replica is highly loaded.)\n\nFor a server where GTIDs are in use (gtid_mode is ON), issuing RESET\nREPLICA has no effect on the GTID execution history. The statement does\nnot change the values of gtid_executed or gtid_purged, or the\nmysql.gtid_executed table. If you need to reset the GTID execution\nhistory, use RESET MASTER, even if the GTID-enabled server is a replica\nwhere binary logging is disabled.\n\nRESET REPLICA requires the RELOAD privilege.\n\nTo use RESET REPLICA, the replication SQL thread and replication I/O\n(receiver) thread must be stopped, so on a running replica use STOP\nREPLICA before issuing RESET REPLICA. To use RESET REPLICA on a Group\nReplication group member, the member status must be OFFLINE, meaning\nthat the plugin is loaded but the member does not currently belong to\nany group. A group member can be taken offline by using a STOP GROUP\nREPLICATION statement.\n\nThe optional FOR CHANNEL channel clause enables you to name which\nreplication channel the statement applies to. Providing a FOR CHANNEL\nchannel clause applies the RESET REPLICA statement to a specific\nreplication channel. Combining a FOR CHANNEL channel clause with the\nALL option deletes the specified channel. If no channel is named and no\nextra channels exist, the statement applies to the default channel.\nIssuing a RESET REPLICA ALL statement without a FOR CHANNEL channel\nclause when multiple replication channels exist deletes all replication\nchannels and recreates only the default channel. See\nhttps://dev.mysql.com/doc/refman/8.0/en/replication-channels.html for\nmore information.\n\nRESET REPLICA does not change any replication connection parameters,\nwhich include the source\'s host name and port, the replication user\naccount and its password, the PRIVILEGE_CHECKS_USER account, the\nREQUIRE_ROW_FORMAT option, the REQUIRE_TABLE_PRIMARY_KEY_CHECK\noption,and the ASSIGN_GTIDS_TO_ANONYMOUS_TRANSACTIONS option. If you\nwant to change any of the replication connection parameters, you can do\nthis using a CHANGE REPLICATION SOURCE TO statement (from MySQL 8.0.23)\nor CHANGE MASTER TO statement (before MySQL 8.0.23) after the server\nstart. If you want to remove all of the replication connection\nparameters, use RESET REPLICA ALL. RESET REPLICA ALL also clears the\nIGNORE_SERVER_IDS list set by CHANGE REPLICATION SOURCE TO | CHANGE\nMASTER TO. When you have used RESET REPLICA ALL, if you want to use the\ninstance as a replica again, you need to issue a CHANGE REPLICATION\nSOURCE TO | CHANGE MASTER TO statement after the server start to\nspecify new connection parameters.\n\nFrom MySQL 8.0.27, you can set the GTID_ONLY option on the CHANGE\nREPLICATION SOURCE TO statement to stop a replication channel from\npersisting file names and file positions in the replication metadata\nrepositories. When you issue a RESET REPLICA statement, the replication\nmetadata repositories are synchronized. RESET REPLICA ALL deletes\nrather than updates the repositories, so they are synchronized\nimplicitly.\n\nIn the event of an unexpected server exit or deliberate restart after\nissuing RESET REPLICA but before issuing START REPLICA, retention of\nthe replication connection parameters depends on the repository used\nfor the replication metadata:\n\no When master_info_repository=TABLE and relay_log_info_repository=TABLE\n  are set on the server (which are the default settings from MySQL\n  8.0), replication connection parameters are preserved in the\n  crash-safe InnoDB tables mysql.slave_master_info and\n  mysql.slave_relay_log_info as part of the RESET REPLICA operation.\n  They are also retained in memory. In the event of an unexpected\n  server exit or deliberate restart after issuing RESET REPLICA but\n  before issuing START REPLICA, the replication connection parameters\n  are retrieved from the tables and reapplied to the channel. This\n  situation applies from MySQL 8.0.13 for the connection metadata\n  repository, and from MySQL 8.0.19 for the applier metadata\n  repository.\n\no If master_info_repository=FILE and relay_log_info_repository=FILE are\n  set on the server, which is deprecated from MySQL 8.0, or the MySQL\n  Server release is earlier than those specified above, replication\n  connection parameters are only retained in memory. If the replica\n  mysqld is restarted immediately after issuing RESET REPLICA due to an\n  unexpected server exit or deliberate restart, the connection\n  parameters are lost. In that case, you must issue a CHANGE\n  REPLICATION SOURCE TO statement (from MySQL 8.0.23) or CHANGE MASTER\n  TO statement (before MySQL 8.0.23) after the server start to\n  respecify the connection parameters before issuing START REPLICA.\n\nRESET REPLICA does not change any replication filter settings (such as\n--replicate-ignore-table) for channels affected by the statement.\nHowever, RESET REPLICA ALL removes the replication filters that were\nset on the channels deleted by the statement. When the deleted channel\nor channels are recreated, any global replication filters specified for\nthe replica are copied to them, and no channel specific replication\nfilters are applied. For more information see\nhttps://dev.mysql.com/doc/refman/8.0/en/replication-rules-channel-based\n-filters.html.\n\nRESET REPLICA causes an implicit commit of an ongoing transaction. See\nhttps://dev.mysql.com/doc/refman/8.0/en/implicit-commit.html.\n\nIf the replication SQL thread was in the middle of replicating\ntemporary tables when it was stopped, and RESET REPLICA is issued,\nthese replicated temporary tables are deleted on the replica.\n\nRESET REPLICA does not reset the heartbeat period or\nSSL_VERIFY_SERVER_CERT.\n\n*Note*:\n\nWhen used on an NDB Cluster replica SQL node, RESET REPLICA clears the\nmysql.ndb_apply_status table. You should keep in mind when using this\nstatement that ndb_apply_status uses the NDB storage engine and so is\nshared by all SQL nodes attached to the cluster.\n\nYou can override this behavior by issuing SET GLOBAL\n@@ndb_clear_apply_status=OFF prior to executing RESET REPLICA, which\nkeeps the replica from purging the ndb_apply_status table in such\ncases.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/reset-replica.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/reset-replica.html'),(581,'RESET SLAVE',43,'Syntax:\nRESET {SLAVE | REPLICA} [ALL] [channel_option]\n\nchannel_option:\n    FOR CHANNEL channel\n\nMakes the replica forget its position in the source\'s binary log. From\nMySQL 8.0.22, RESET SLAVE is deprecated and the alias RESET REPLICA\nshould be used instead. In releases before MySQL 8.0.22, use RESET\nSLAVE. The statement works in the same way as before, only the\nterminology used for the statement and its output has changed. Both\nversions of the statement update the same status variables when used.\nPlease see the documentation for RESET REPLICA for a description of the\nstatement.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/reset-slave.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/reset-slave.html'),(582,'START REPLICA',43,'Syntax:\nSTART REPLICA [thread_types] [until_option] [connection_options] [channel_option]\n\nthread_types:\n    [thread_type [, thread_type] ... ]\n\nthread_type:\n    IO_THREAD | SQL_THREAD\n\nuntil_option:\n    UNTIL {   {SQL_BEFORE_GTIDS | SQL_AFTER_GTIDS} = gtid_set\n          |   MASTER_LOG_FILE = \'log_name\', MASTER_LOG_POS = log_pos\n          |   SOURCE_LOG_FILE = \'log_name\', SOURCE_LOG_POS = log_pos\n          |   RELAY_LOG_FILE = \'log_name\', RELAY_LOG_POS = log_pos\n          |   SQL_AFTER_MTS_GAPS  }\n\nconnection_options:\n    [USER=\'user_name\'] [PASSWORD=\'user_pass\'] [DEFAULT_AUTH=\'plugin_name\'] [PLUGIN_DIR=\'plugin_dir\']\n\n\nchannel_option:\n    FOR CHANNEL channel\n\ngtid_set:\n    uuid_set [, uuid_set] ...\n    | \'\'\n\nuuid_set:\n    uuid:interval[:interval]...\n\nuuid:\n    hhhhhhhh-hhhh-hhhh-hhhh-hhhhhhhhhhhh\n\nh:\n    [0-9,A-F]\n\ninterval:\n    n[-n]\n\n    (n >= 1)\n\nSTART REPLICA starts the replication threads, either together or\nseparately. From MySQL 8.0.22, use START REPLICA in place of START\nSLAVE, which is deprecated from that release. In releases before MySQL\n8.0.22, use START SLAVE.\n\nSTART REPLICA requires the REPLICATION_SLAVE_ADMIN privilege (or the\ndeprecated SUPER privilege). START REPLICA causes an implicit commit of\nan ongoing transaction. See\nhttps://dev.mysql.com/doc/refman/8.0/en/implicit-commit.html.\n\nFor the thread type options, you can specify IO_THREAD, SQL_THREAD,\nboth of these, or neither of them. Only the threads that are started\nare affected by the statement.\n\no START REPLICA with no thread type options starts all of the\n  replication threads, and so does START REPLICA with both of the\n  thread type options.\n\no IO_THREAD starts the replication receiver thread, which reads events\n  from the source server and stores them in the relay log.\n\no SQL_THREAD starts the replication applier thread, which reads events\n  from the relay log and executes them. A multithreaded replica (with\n  replica_parallel_workers or slave_parallel_workers > 0) applies\n  transactions using a coordinator thread and multiple applier threads,\n  and SQL_THREAD starts all of these.\n\n*Important*:\n\nSTART REPLICA sends an acknowledgment to the user after all the\nreplication threads have started. However, the replication receiver\nthread might not yet have connected to the source successfully, or an\napplier thread might stop when applying an event right after starting.\nSTART REPLICA does not continue to monitor the threads after they are\nstarted, so it does not warn you if they subsequently stop or cannot\nconnect. You must check the replica\'s error log for error messages\ngenerated by the replication threads, or check that they are running\nsatisfactorily with SHOW REPLICA STATUS. A successful START REPLICA\nstatement causes SHOW REPLICA STATUS to show Replica_SQL_Running=Yes,\nbut it might or might not show Replica_IO_Running=Yes, because\nReplica_IO_Running=Yes is only shown if the receiver thread is both\nrunning and connected. For more information, see\nhttps://dev.mysql.com/doc/refman/8.0/en/replication-administration-stat\nus.html.\n\nThe optional FOR CHANNEL channel clause enables you to name which\nreplication channel the statement applies to. Providing a FOR CHANNEL\nchannel clause applies the START REPLICA statement to a specific\nreplication channel. If no clause is named and no extra channels exist,\nthe statement applies to the default channel. If a START REPLICA\nstatement does not have a channel defined when using multiple channels,\nthis statement starts the specified threads for all channels. See\nhttps://dev.mysql.com/doc/refman/8.0/en/replication-channels.html for\nmore information.\n\nThe replication channels for Group Replication\n(group_replication_applier and group_replication_recovery) are managed\nautomatically by the server instance. START REPLICA cannot be used at\nall with the group_replication_recovery channel, and should only be\nused with the group_replication_applier channel when Group Replication\nis not running. The group_replication_applier channel only has an\napplier thread and has no receiver thread, so it can be started if\nrequired by using the SQL_THREAD option without the IO_THREAD option.\n\nSTART REPLICA supports pluggable user-password authentication (see\nhttps://dev.mysql.com/doc/refman/8.0/en/pluggable-authentication.html)\nwith the USER, PASSWORD, DEFAULT_AUTH and PLUGIN_DIR options, as\ndescribed in the following list. When you use these options, you must\nstart the receiver thread (IO_THREAD option) or all the replication\nthreads - you cannot start the replication applier thread (SQL_THREAD\noption) alone.\n\no USER\n\n  The user name for the account. You must set this if PASSWORD is used.\n  The option cannot be set to an empty or null string.\n\no PASSWORD\n\n  The password for the named user account.\n\no DEFAULT_AUTH\n\n  The name of the authentication plugin. The default is MySQL native\n  authentication.\n\no PLUGIN_DIR\n\n  The location of the authentication plugin.\n\n*Important*:\n\nThe password that you set using START REPLICA is masked when it is\nwritten to MySQL Server\'s logs, Performance Schema tables, and SHOW\nPROCESSLIST statements. However, it is sent in plain text over the\nconnection to the replica server instance. To protect the password in\ntransit, use SSL/TLS encryption, an SSH tunnel, or another method of\nprotecting the connection from unauthorized viewing, for the connection\nbetween the replica server instance and the client that you use to\nissue START REPLICA.\n\nThe UNTIL clause makes the replica start replication, then process\ntransactions up to the point that you specify in the UNTIL clause, then\nstop again. The UNTIL clause can be used to make a replica proceed\nuntil just before the point where you want to skip a transaction that\nis unwanted, and then skip the transaction as described in\nhttps://dev.mysql.com/doc/refman/8.0/en/replication-administration-skip\n.html. To identify a transaction, you can use mysqlbinlog with the\nsource\'s binary log or the replica\'s relay log, or use a SHOW BINLOG\nEVENTS statement.\n\nYou can also use the UNTIL clause for debugging replication by\nprocessing transactions one at a time or in sections. If you are using\nthe UNTIL clause to do this, start the replica with the\n--skip-slave-start option, or from MySQL 8.0.24, the skip_slave_start\nsystem variable, to prevent the SQL thread from running when the\nreplica server starts. Remove the option or system variable setting\nafter the procedure is complete, so that it is not forgotten in the\nevent of an unexpected server restart.\n\nThe SHOW REPLICA STATUS statement includes output fields that display\nthe current values of the UNTIL condition. The UNTIL condition lasts\nfor as long as the affected threads are still running, and is removed\nwhen they stop.\n\nThe UNTIL clause operates on the replication applier thread (SQL_THREAD\noption). You can use the SQL_THREAD option or let the replica default\nto starting both threads. If you use the IO_THREAD option alone, the\nUNTIL clause is ignored because the applier thread is not started.\n\nThe point that you specify in the UNTIL clause can be any one (and only\none) of the following options:\n\no SOURCE_LOG_FILE and SOURCE_LOG_POS (from MySQL 8.0.23), or\n  MASTER_LOG_FILE and MASTER_LOG_POS (to MySQL 8.0.22)\n\n  These options make the replication applier process transactions up to\n  a position in its relay log, identified by the file name and file\n  position of the corresponding point in the binary log on the source\n  server. The applier thread finds the nearest transaction boundary at\n  or after the specified position, finishes applying the transaction,\n  and stops there. For compressed transaction payloads, specify the end\n  position of the compressed Transaction_payload_event.\n\n  These options can still be used when the GTID_ONLY option was set on\n  the CHANGE REPLICATION SOURCE TO statement to stop the replication\n  channel from persisting file names and file positions in the\n  replication metadata repositories. The file names and file positions\n  are tracked in memory.\n\no RELAY_LOG_FILE and RELAY_LOG_POS\n\n  These options make the replication applier process transactions up to\n  a position in the replica\'s relay log, identified by the relay log\n  file name and a position in that file. The applier thread finds the\n  nearest transaction boundary at or after the specified position,\n  finishes applying the transaction, and stops there. For compressed\n  transaction payloads, specify the end position of the compressed\n  Transaction_payload_event.\n\n  These options can still be used when the GTID_ONLY option was set on\n  the CHANGE REPLICATION SOURCE TO statement to stop the replication\n  channel from persisting file names and file positions in the\n  replication metadata repositories. The file names and file positions\n  are tracked in memory.\n\no SQL_BEFORE_GTIDS\n\n  This option makes the replication applier start processing\n  transactions and stop when it encounters any transaction that is in\n  the specified GTID set. The encountered transaction from the GTID set\n  is not applied, and nor are any of the other transactions in the GTID\n  set. The option takes a GTID set containing one or more global\n  transaction identifiers as an argument (see\n  https://dev.mysql.com/doc/refman/8.0/en/replication-gtids-concepts.ht\n  ml#replication-gtids-concepts-gtid-sets). Transactions in a GTID set\n  do not necessarily appear in the replication stream in the order of\n  their GTIDs, so the transaction before which the applier stops is not\n  necessarily the earliest.\n\no SQL_AFTER_GTIDS\n\n  This option makes the replication applier start processing\n  transactions and stop when it has processed all of the transactions\n  in a specified GTID set. The option takes a GTID set containing one\n  or more global transaction identifiers as an argument (see\n  https://dev.mysql.com/doc/refman/8.0/en/replication-gtids-concepts.ht\n  ml#replication-gtids-concepts-gtid-sets).\n\n  With SQL_AFTER_GTIDS, the replication threads stop when they have\n  processed the transactions in the GTID set and encounter the first\n  transaction whose GTID is not part of the GTID set. For example,\n  executing START REPLICA UNTIL SQL_AFTER_GTIDS =\n  3E11FA47-71CA-11E1-9E33-C80AA9429562:11-56 causes the replica to\n  obtain all transactions just mentioned from the source, including all\n  of the transactions having the sequence numbers 11 through 56, and\n  then to stop without processing any additional transactions.\n\no SQL_AFTER_MTS_GAPS\n\n  For a multithreaded replica only (with replica_parallel_workers or\n  slave_parallel_workers > 0), this option makes the replica process\n  transactions up to the point where there are no more gaps in the\n  sequence of transactions executed from the relay log. When using a\n  multithreaded replica, there is a chance of gaps occurring in the\n  following situations:\n\n  o The coordinator thread is stopped.\n\n  o An error occurs in the applier threads.\n\n  o mysqld shuts down unexpectedly.\n\n  When a replication channel has gaps, the replica\'s database is in a\n  state that might never have existed on the source. The replica tracks\n  the gaps internally and disallows CHANGE REPLICATION SOURCE TO\n  statements that would remove the gap information if they executed.\n\n  Before MySQL 8.0.26, issuing START REPLICA on a multithreaded replica\n  with gaps in the sequence of transactions executed from the relay log\n  generates a warning. To correct this situation, the solution is to\n  use START REPLICA UNTIL SQL_AFTER_MTS_GAPS. See\n  https://dev.mysql.com/doc/refman/8.0/en/replication-features-transact\n  ion-inconsistencies.html for more information.\n\n  From MySQL 8.0.26, the process of checking for gaps in the sequence\n  of transactions is skipped entirely when GTID-based replication and\n  GTID auto-positioning (SOURCE_AUTO_POSITION=1) are in use for the\n  channel, because gaps in transactions can be resolved using GTID\n  auto-positioning. In that situation, START REPLICA UNTIL\n  SQL_AFTER_MTS_GAPS just stops the applier thread when it finds the\n  first transaction to execute, and does not attempt to check for gaps\n  in the sequence of transactions. You can also continue to use CHANGE\n  REPLICATION SOURCE TO statements as normal, and relay log recovery is\n  possible for the channel.\n\n  From MySQL 8.0.27, all replicas are multithreaded by default. When\n  replica_preserve_commit_order=ON or slave_preserve_commit_order=ON is\n  set for the replica, which is also the default setting from MySQL\n  8.0.27, gaps should not occur except in the specific situations\n  listed in the description for replica_preserve_commit_order and\n  slave_preserve_commit_order. If replica_preserve_commit_order=OFF or\n  slave_preserve_commit_order=OFF is set for the replica, which is the\n  default before MySQL 8.0.27, the commit order of transactions is not\n  preserved, so the chance of gaps occurring is much larger.\n\n  If GTIDs are not in use and you need to change a failed multithreaded\n  replica to single-threaded mode, you can issue the following series\n  of statements, in the order shown:\n\nSTART SLAVE UNTIL SQL_AFTER_MTS_GAPS;\nSET @@GLOBAL.slave_parallel_workers = 0;\nSTART SLAVE SQL_THREAD;\n\nOr from MySQL 8.0.26:\nSTART REPLICA UNTIL SQL_AFTER_MTS_GAPS;\nSET @@GLOBAL.replica_parallel_workers = 0;\nSTART REPLICA SQL_THREAD;\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/start-replica.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/start-replica.html'),(583,'START SLAVE',43,'Syntax:\nSTART {SLAVE | REPLICA} [thread_types] [until_option] [connection_options] [channel_option]\n\nthread_types:\n    [thread_type [, thread_type] ... ]\n\nthread_type:\n    IO_THREAD | SQL_THREAD\n\nuntil_option:\n    UNTIL {   {SQL_BEFORE_GTIDS | SQL_AFTER_GTIDS} = gtid_set\n          |   MASTER_LOG_FILE = \'log_name\', MASTER_LOG_POS = log_pos\n          |   SOURCE_LOG_FILE = \'log_name\', SOURCE_LOG_POS = log_pos\n          |   RELAY_LOG_FILE = \'log_name\', RELAY_LOG_POS = log_pos\n          |   SQL_AFTER_MTS_GAPS  }\n\nconnection_options:\n    [USER=\'user_name\'] [PASSWORD=\'user_pass\'] [DEFAULT_AUTH=\'plugin_name\'] [PLUGIN_DIR=\'plugin_dir\']\n\n\nchannel_option:\n    FOR CHANNEL channel\n\ngtid_set:\n    uuid_set [, uuid_set] ...\n    | \'\'\n\nuuid_set:\n    uuid:interval[:interval]...\n\nuuid:\n    hhhhhhhh-hhhh-hhhh-hhhh-hhhhhhhhhhhh\n\nh:\n    [0-9,A-F]\n\ninterval:\n    n[-n]\n\n    (n >= 1)\n\nStarts the replication threads. From MySQL 8.0.22, START SLAVE is\ndeprecated and the alias START REPLICA should be used instead. The\nstatement works in the same way as before, only the terminology used\nfor the statement and its output has changed. Both versions of the\nstatement update the same status variables when used. Please see the\ndocumentation for START REPLICA for a description of the statement.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/start-slave.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/start-slave.html'),(584,'STOP REPLICA',43,'Syntax:\nSTOP REPLICA [thread_types] [channel_option]\n\nthread_types:\n    [thread_type [, thread_type] ... ]\n\nthread_type: IO_THREAD | SQL_THREAD\n\nchannel_option:\n    FOR CHANNEL channel\n\nStops the replication threads. From MySQL 8.0.22, use STOP REPLICA in\nplace of STOP SLAVE, which is now deprecated. In releases before MySQL\n8.0.22, use STOP SLAVE.\n\nSTOP REPLICA requires the REPLICATION_SLAVE_ADMIN privilege (or the\ndeprecated SUPER privilege). Recommended best practice is to execute\nSTOP REPLICA on the replica before stopping the replica server (see\nhttps://dev.mysql.com/doc/refman/8.0/en/server-shutdown.html, for more\ninformation).\n\nLike START REPLICA, this statement may be used with the IO_THREAD and\nSQL_THREAD options to name the replication thread or threads to be\nstopped. Note that the Group Replication applier channel\n(group_replication_applier) has no replication I/O (receiver) thread,\nonly a replication SQL (applier) thread. Using the SQL_THREAD option\ntherefore stops this channel completely.\n\nSTOP REPLICA causes an implicit commit of an ongoing transaction. See\nhttps://dev.mysql.com/doc/refman/8.0/en/implicit-commit.html.\n\ngtid_next must be set to AUTOMATIC before issuing this statement.\n\nYou can control how long STOP REPLICA waits before timing out by\nsetting the system variable rpl_stop_replica_timeout (from MySQL\n8.0.26) or rpl_stop_slave_timeout (before MySQL 8.0.26). This can be\nused to avoid deadlocks between STOP REPLICA and other SQL statements\nusing different client connections to the replica. When the timeout\nvalue is reached, the issuing client returns an error message and stops\nwaiting, but the STOP REPLICA instruction remains in effect. Once the\nreplication threads are no longer busy, the STOP REPLICA statement is\nexecuted and the replica stops.\n\nSome CHANGE REPLICATION SOURCE TO | CHANGE MASTER TO statements are\nallowed while the replica is running, depending on the states of the\nreplication threads. However, using STOP REPLICA prior to executing a\nCHANGE REPLICATION SOURCE TO | CHANGE MASTER TO statement in such cases\nis still supported. See [HELP CHANGE REPLICATION SOURCE TO], [HELP\nCHANGE MASTER TO], and\nhttps://dev.mysql.com/doc/refman/8.0/en/replication-solutions-switch.html\n, for more information.\n\nThe optional FOR CHANNEL channel clause enables you to name which\nreplication channel the statement applies to. Providing a FOR CHANNEL\nchannel clause applies the STOP REPLICA statement to a specific\nreplication channel. If no channel is named and no extra channels\nexist, the statement applies to the default channel. If a STOP REPLICA\nstatement does not name a channel when using multiple channels, this\nstatement stops the specified threads for all channels. See\nhttps://dev.mysql.com/doc/refman/8.0/en/replication-channels.html for\nmore information.\n\nThe replication channels for Group Replication\n(group_replication_applier and group_replication_recovery) are managed\nautomatically by the server instance. STOP REPLICA cannot be used at\nall with the group_replication_recovery channel, and should only be\nused with the group_replication_applier channel when Group Replication\nis not running. The group_replication_applier channel only has an\napplier thread and has no receiver thread, so it can be stopped if\nrequired by using the SQL_THREAD option without the IO_THREAD option.\n\nWhen the replica is multithreaded (replica_parallel_workers or\nslave_parallel_workers is a nonzero value), any gaps in the sequence of\ntransactions executed from the relay log are closed as part of stopping\nthe worker threads. If the replica is stopped unexpectedly (for example\ndue to an error in a worker thread, or another thread issuing KILL)\nwhile a STOP REPLICA statement is executing, the sequence of executed\ntransactions from the relay log may become inconsistent. See\nhttps://dev.mysql.com/doc/refman/8.0/en/replication-features-transactio\nn-inconsistencies.html, for more information.\n\nWhen the source is using the row-based binary logging format, you\nshould execute STOP REPLICA or STOP REPLICA SQL_THREAD on the replica\nprior to shutting down the replica server if you are replicating any\ntables that use a nontransactional storage engine. If the current\nreplication event group has modified one or more nontransactional\ntables, STOP REPLICA waits for up to 60 seconds for the event group to\ncomplete, unless you issue a KILL QUERY or KILL CONNECTION statement\nfor the replication SQL thread. If the event group remains incomplete\nafter the timeout, an error message is logged.\n\nWhen the source is using the statement-based binary logging format,\nchanging the source while it has open temporary tables is potentially\nunsafe. This is one of the reasons why statement-based replication of\ntemporary tables is not recommended. You can find out whether there are\nany temporary tables on the replica by checking the value of\nReplica_open_temp_tables or Slave_open_temp_tables. When using\nstatement-based replication, this value should be 0 before executing\nCHANGE REPLICATION SOURCE TO | CHANGE MASTER TO. If there are any\ntemporary tables open on the replica, issuing a CHANGE REPLICATION\nSOURCE TO | CHANGE MASTER TO statement after issuing a STOP REPLICA\ncauses an ER_WARN_OPEN_TEMP_TABLES_MUST_BE_ZERO\n(https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference.html\n#error_er_warn_open_temp_tables_must_be_zero) warning.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/stop-replica.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/stop-replica.html'),(585,'STOP SLAVE',43,'Syntax:\nSTOP {SLAVE | REPLICA} [thread_types] [channel_option]\n\nthread_types:\n    [thread_type [, thread_type] ... ]\n\nthread_type: IO_THREAD | SQL_THREAD\n\nchannel_option:\n    FOR CHANNEL channel\n\nStops the replication threads. From MySQL 8.0.22, STOP SLAVE is\ndeprecated and the alias STOP REPLICA should be used instead. The\nstatement works in the same way as before, only the terminology used\nfor the statement and its output has changed. Both versions of the\nstatement update the same status variables when used. Please see the\ndocumentation for STOP REPLICA for a description of the statement.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/stop-slave.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/stop-slave.html'),(586,'PREPARE',44,'Syntax:\nPREPARE stmt_name FROM preparable_stmt\n\nThe PREPARE statement prepares a SQL statement and assigns it a name,\nstmt_name, by which to refer to the statement later. The prepared\nstatement is executed with EXECUTE and released with DEALLOCATE\nPREPARE. For examples, see\nhttps://dev.mysql.com/doc/refman/8.0/en/sql-prepared-statements.html.\n\nStatement names are not case-sensitive. preparable_stmt is either a\nstring literal or a user variable that contains the text of the SQL\nstatement. The text must represent a single statement, not multiple\nstatements. Within the statement, ? characters can be used as parameter\nmarkers to indicate where data values are to be bound to the query\nlater when you execute it. The ? characters should not be enclosed\nwithin quotation marks, even if you intend to bind them to string\nvalues. Parameter markers can be used only where data values should\nappear, not for SQL keywords, identifiers, and so forth.\n\nIf a prepared statement with the given name already exists, it is\ndeallocated implicitly before the new statement is prepared. This means\nthat if the new statement contains an error and cannot be prepared, an\nerror is returned and no statement with the given name exists.\n\nThe scope of a prepared statement is the session within which it is\ncreated, which as several implications:\n\no A prepared statement created in one session is not available to other\n  sessions.\n\no When a session ends, whether normally or abnormally, its prepared\n  statements no longer exist. If auto-reconnect is enabled, the client\n  is not notified that the connection was lost. For this reason,\n  clients may wish to disable auto-reconnect. See Automatic\n  Reconnection Control\n  (https://dev.mysql.com/doc/c-api/8.0/en/c-api-auto-reconnect.html).\n\no A prepared statement created within a stored program continues to\n  exist after the program finishes executing and can be executed\n  outside the program later.\n\no A statement prepared in stored program context cannot refer to stored\n  procedure or function parameters or local variables because they go\n  out of scope when the program ends and would be unavailable were the\n  statement to be executed later outside the program. As a workaround,\n  refer instead to user-defined variables, which also have session\n  scope; see\n  https://dev.mysql.com/doc/refman/8.0/en/user-variables.html.\n\nBeginning with MySQL 8.0.22, a parameter used in a prepared statement\nhas its type determined when the statement is first prepared, and\nretains this type whenever EXECUTE is invoked for this prepared\nstatement (unless the statement is reprepared, as explained later in\nthis section). Rules for determining a parameter\'s type are listed\nhere:\n\no A parameter which is an operand of a binary arithmetic operator has\n  the same data type as the other operand.\n\no If both operands of a binary arithmetic operator are parameters, the\n  type of the parameters is decided by the context of the operator.\n\no If a parameter is the operand of a unary arithmetic operator, the\n  parameter\'s type is decided by the context of the operator.\n\no If an arithmetic operator has no type-determining context, the\n  derived type for any parameters involved is DOUBLE PRECISION. This\n  can happen, for example, when the parameter is a top-level node in a\n  SELECT list, or when it is part of a comparison operator.\n\no A parameter which is an operand of a character string operator has\n  the same derived type as the aggregated type of the other operands.\n  If all operands of the operator are parameters, the derived type is\n  VARCHAR; its collation is determined by the value of\n  collation_connection.\n\no A parameter which is an operand of a temporal operator has type\n  DATETIME if the operator returns a DATETIME, TIME if the operator\n  returns a TIME, and DATE if the operator returns a DATE.\n\no A parameter which is an operand of a binary comparison operator has\n  the same derived type as the other operand of the comparison.\n\no A parameter that is an operand of a ternary comparison operator such\n  as BETWEEN has the same derived type as the aggregated type of the\n  other operands.\n\no If all operands of a comparison operator are parameters, the derived\n  type for each of them is VARCHAR, with collation determined by the\n  value of collation_connection.\n\no A parameter that is an output operand of any of CASE, COALESCE, IF,\n  IFNULL, or NULLIF has the same derived type as the aggregated type of\n  the operator\'s other output operands.\n\no If all output operands of any of CASE, COALESCE, IF, IFNULL, or\n  NULLIF are parameters, or they are all NULL, the type of the\n  parameter is decided by the context of the operator.\n\no If the parameter is an operand of any of CASE, COALESCE(), IF, or\n  IFNULL, and has no type-determining context, the derived type for\n  each of the parameters involved is VARCHAR, and its collation is\n  determined by the value of collation_connection.\n\no A parameter which is the operand of a CAST() has the same type as\n  specified by the CAST().\n\no If a parameter is an immediate member of a SELECT list that is not\n  part of an INSERT statement, the derived type of the parameter is\n  VARCHAR, and its collation is determined by the value of\n  collation_connection.\n\no If a parameter is an immediate member of a SELECT list that is part\n  of an INSERT statement, the derived type of the parameter is the type\n  of the corresponding column into which the parameter is inserted.\n\no If a parameter is used as source for an assignment in a SET clause of\n  an UPDATE statement or in the ON DUPLICATE KEY UPDATE clause of an\n  INSERT statement, the derived type of the parameter is the type of\n  the corresponding column which is updated by the SET or ON DUPLICATE\n  KEY UPDATE clause.\n\no If a parameter is an argument of a function, the derived type depends\n  on the function\'s return type.\n\nFor some combinations of actual type and derived type, an automatic\nrepreparation of the statement is triggered, to ensure closer\ncompatibility with previous versions of MySQL. Repreparation does not\noccur if any of the following conditions are true:\n\no NULL is used as the actual parameter value.\n\no A parameter is an operand of a CAST(). (Instead, a cast to the\n  derived type is attempted, and an exception raised if the cast\n  fails.)\n\no A parameter is a string. (In this case, an implicit CAST(? AS\n  derived_type) is performed.)\n\no The derived type and actual type of the parameter are both INTEGER\n  and have the same sign.\n\no The parameter\'s derived type is DECIMAL and its actual type is either\n  DECIMAL or INTEGER.\n\no The derived type is DOUBLE and the actual type is any numeric type.\n\no Both the derived type and the actual type are string types.\n\no If the derived type is temporal and the actual type is temporal.\n  Exceptions: The derived type is TIME and the actual type is not TIME;\n  the derived type is DATE and the actual type is not DATE.\n\no The derived type is temporal and the actual type is numeric.\n\nFor cases other than those just listed, the statement is reprepared and\nthe actual parameter types are used instead of the derived parameter\ntypes.\n\nThese rules also apply to a user variable referenced in a prepared\nstatement.\n\nUsing a different data type for a given parameter or user variable\nwithin a prepared statement for executions of the statement subsequent\nto the first execution causes the statement to be reprepared. This is\nless efficient; it may also lead to the parameter\'s (or variable\'s)\nactual type to vary, and thus for results to be inconsistent, with\nsubsequent executions of the prepared statement. For these reasons, it\nis advisable to use the same data type for a given parameter when\nre-executing a prepared statement.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/prepare.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/prepare.html'),(587,'EXECUTE STATEMENT',44,'Syntax:\nEXECUTE stmt_name\n    [USING @var_name [, @var_name] ...]\n\nAfter preparing a statement with PREPARE, you execute it with an\nEXECUTE statement that refers to the prepared statement name. If the\nprepared statement contains any parameter markers, you must supply a\nUSING clause that lists user variables containing the values to be\nbound to the parameters. Parameter values can be supplied only by user\nvariables, and the USING clause must name exactly as many variables as\nthe number of parameter markers in the statement.\n\nYou can execute a given prepared statement multiple times, passing\ndifferent variables to it or setting the variables to different values\nbefore each execution.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/execute.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/execute.html'),(588,'DEALLOCATE PREPARE',44,'Syntax:\n{DEALLOCATE | DROP} PREPARE stmt_name\n\nTo deallocate a prepared statement produced with PREPARE, use a\nDEALLOCATE PREPARE statement that refers to the prepared statement\nname. Attempting to execute a prepared statement after deallocating it\nresults in an error. If too many prepared statements are created and\nnot deallocated by either the DEALLOCATE PREPARE statement or the end\nof the session, you might encounter the upper limit enforced by the\nmax_prepared_stmt_count system variable.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/deallocate-prepare.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/deallocate-prepare.html'),(589,'DROP PREPARE',44,'Syntax:\n{DEALLOCATE | DROP} PREPARE stmt_name\n\nTo deallocate a prepared statement produced with PREPARE, use a\nDEALLOCATE PREPARE statement that refers to the prepared statement\nname. Attempting to execute a prepared statement after deallocating it\nresults in an error. If too many prepared statements are created and\nnot deallocated by either the DEALLOCATE PREPARE statement or the end\nof the session, you might encounter the upper limit enforced by the\nmax_prepared_stmt_count system variable.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/deallocate-prepare.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/deallocate-prepare.html'),(590,'BEGIN END',45,'Syntax:\n[begin_label:] BEGIN\n    [statement_list]\nEND [end_label]\n\nBEGIN ... END syntax is used for writing compound statements, which can\nappear within stored programs (stored procedures and functions,\ntriggers, and events). A compound statement can contain multiple\nstatements, enclosed by the BEGIN and END keywords. statement_list\nrepresents a list of one or more statements, each terminated by a\nsemicolon (;) statement delimiter. The statement_list itself is\noptional, so the empty compound statement (BEGIN END) is legal.\n\nBEGIN ... END blocks can be nested.\n\nUse of multiple statements requires that a client is able to send\nstatement strings containing the ; statement delimiter. In the mysql\ncommand-line client, this is handled with the delimiter command.\nChanging the ; end-of-statement delimiter (for example, to //) permit ;\nto be used in a program body. For an example, see\nhttps://dev.mysql.com/doc/refman/8.0/en/stored-programs-defining.html.\n\nA BEGIN ... END block can be labeled. See [HELP labels].\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/begin-end.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/begin-end.html'),(591,'LABELS',45,'Syntax:\n[begin_label:] BEGIN\n    [statement_list]\nEND [end_label]\n\n[begin_label:] LOOP\n    statement_list\nEND LOOP [end_label]\n\n[begin_label:] REPEAT\n    statement_list\nUNTIL search_condition\nEND REPEAT [end_label]\n\n[begin_label:] WHILE search_condition DO\n    statement_list\nEND WHILE [end_label]\n\nLabels are permitted for BEGIN ... END blocks and for the LOOP, REPEAT,\nand WHILE statements. Label use for those statements follows these\nrules:\n\no begin_label must be followed by a colon.\n\no begin_label can be given without end_label. If end_label is present,\n  it must be the same as begin_label.\n\no end_label cannot be given without begin_label.\n\no Labels at the same nesting level must be distinct.\n\no Labels can be up to 16 characters long.\n\nTo refer to a label within the labeled construct, use an ITERATE or\nLEAVE statement. The following example uses those statements to\ncontinue iterating or terminate the loop:\n\nCREATE PROCEDURE doiterate(p1 INT)\nBEGIN\n  label1: LOOP\n    SET p1 = p1 + 1;\n    IF p1 < 10 THEN ITERATE label1; END IF;\n    LEAVE label1;\n  END LOOP label1;\nEND;\n\nThe scope of a block label does not include the code for handlers\ndeclared within the block. For details, see [HELP DECLARE HANDLER].\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/statement-labels.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/statement-labels.html'),(592,'DECLARE VARIABLE',45,'Syntax:\nDECLARE var_name [, var_name] ... type [DEFAULT value]\n\nThis statement declares local variables within stored programs. To\nprovide a default value for a variable, include a DEFAULT clause. The\nvalue can be specified as an expression; it need not be a constant. If\nthe DEFAULT clause is missing, the initial value is NULL.\n\nLocal variables are treated like stored routine parameters with respect\nto data type and overflow checking. See [HELP CREATE PROCEDURE].\n\nVariable declarations must appear before cursor or handler\ndeclarations.\n\nLocal variable names are not case-sensitive. Permissible characters and\nquoting rules are the same as for other identifiers, as described in\nhttps://dev.mysql.com/doc/refman/8.0/en/identifiers.html.\n\nThe scope of a local variable is the BEGIN ... END block within which\nit is declared. The variable can be referred to in blocks nested within\nthe declaring block, except those blocks that declare a variable with\nthe same name.\n\nFor examples of variable declarations, see\nhttps://dev.mysql.com/doc/refman/8.0/en/local-variable-scope.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/declare-local-variable.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/declare-local-variable.html'),(593,'CASE STATEMENT',45,'Syntax:\nCASE case_value\n    WHEN when_value THEN statement_list\n    [WHEN when_value THEN statement_list] ...\n    [ELSE statement_list]\nEND CASE\n\nOr:\n\nCASE\n    WHEN search_condition THEN statement_list\n    [WHEN search_condition THEN statement_list] ...\n    [ELSE statement_list]\nEND CASE\n\nThe CASE statement for stored programs implements a complex conditional\nconstruct.\n\n*Note*:\n\nThere is also a CASE operator, which differs from the CASE statement\ndescribed here. See\nhttps://dev.mysql.com/doc/refman/8.0/en/flow-control-functions.html.\nThe CASE statement cannot have an ELSE NULL clause, and it is\nterminated with END CASE instead of END.\n\nFor the first syntax, case_value is an expression. This value is\ncompared to the when_value expression in each WHEN clause until one of\nthem is equal. When an equal when_value is found, the corresponding\nTHEN clause statement_list executes. If no when_value is equal, the\nELSE clause statement_list executes, if there is one.\n\nThis syntax cannot be used to test for equality with NULL because NULL\n= NULL is false. See\nhttps://dev.mysql.com/doc/refman/8.0/en/working-with-null.html.\n\nFor the second syntax, each WHEN clause search_condition expression is\nevaluated until one is true, at which point its corresponding THEN\nclause statement_list executes. If no search_condition is equal, the\nELSE clause statement_list executes, if there is one.\n\nIf no when_value or search_condition matches the value tested and the\nCASE statement contains no ELSE clause, a Case not found for CASE\nstatement error results.\n\nEach statement_list consists of one or more SQL statements; an empty\nstatement_list is not permitted.\n\nTo handle situations where no value is matched by any WHEN clause, use\nan ELSE containing an empty BEGIN ... END block, as shown in this\nexample. (The indentation used here in the ELSE clause is for purposes\nof clarity only, and is not otherwise significant.)\n\nDELIMITER |\n\nCREATE PROCEDURE p()\n  BEGIN\n    DECLARE v INT DEFAULT 1;\n\n    CASE v\n      WHEN 2 THEN SELECT v;\n      WHEN 3 THEN SELECT 0;\n      ELSE\n        BEGIN\n        END;\n    END CASE;\n  END;\n  |\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/case.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/case.html'),(594,'IF STATEMENT',45,'Syntax:\nIF search_condition THEN statement_list\n    [ELSEIF search_condition THEN statement_list] ...\n    [ELSE statement_list]\nEND IF\n\nThe IF statement for stored programs implements a basic conditional\nconstruct.\n\n*Note*:\n\nThere is also an IF() function, which differs from the IF statement\ndescribed here. See\nhttps://dev.mysql.com/doc/refman/8.0/en/flow-control-functions.html.\nThe IF statement can have THEN, ELSE, and ELSEIF clauses, and it is\nterminated with END IF.\n\nIf a given search_condition evaluates to true, the corresponding THEN\nor ELSEIF clause statement_list executes. If no search_condition\nmatches, the ELSE clause statement_list executes.\n\nEach statement_list consists of one or more SQL statements; an empty\nstatement_list is not permitted.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/if.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/if.html'),(595,'ITERATE',45,'Syntax:\nITERATE label\n\nITERATE can appear only within LOOP, REPEAT, and WHILE statements.\nITERATE means \"start the loop again.\"\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/iterate.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/iterate.html'),(596,'LEAVE',45,'Syntax:\nLEAVE label\n\nThis statement is used to exit the flow control construct that has the\ngiven label. If the label is for the outermost stored program block,\nLEAVE exits the program.\n\nLEAVE can be used within BEGIN ... END or loop constructs (LOOP,\nREPEAT, WHILE).\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/leave.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/leave.html'),(597,'LOOP',45,'Syntax:\n[begin_label:] LOOP\n    statement_list\nEND LOOP [end_label]\n\nLOOP implements a simple loop construct, enabling repeated execution of\nthe statement list, which consists of one or more statements, each\nterminated by a semicolon (;) statement delimiter. The statements\nwithin the loop are repeated until the loop is terminated. Usually,\nthis is accomplished with a LEAVE statement. Within a stored function,\nRETURN can also be used, which exits the function entirely.\n\nNeglecting to include a loop-termination statement results in an\ninfinite loop.\n\nA LOOP statement can be labeled. For the rules regarding label use, see\n[HELP labels].\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/loop.html\n\n','CREATE PROCEDURE doiterate(p1 INT)\nBEGIN\n  label1: LOOP\n    SET p1 = p1 + 1;\n    IF p1 < 10 THEN\n      ITERATE label1;\n    END IF;\n    LEAVE label1;\n  END LOOP label1;\n  SET @x = p1;\nEND;\n','https://dev.mysql.com/doc/refman/8.0/en/loop.html'),(598,'REPEAT LOOP',45,'Syntax:\n[begin_label:] REPEAT\n    statement_list\nUNTIL search_condition\nEND REPEAT [end_label]\n\nThe statement list within a REPEAT statement is repeated until the\nsearch_condition expression is true. Thus, a REPEAT always enters the\nloop at least once. statement_list consists of one or more statements,\neach terminated by a semicolon (;) statement delimiter.\n\nA REPEAT statement can be labeled. For the rules regarding label use,\nsee [HELP labels].\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/repeat.html\n\n','mysql> delimiter //\n\nmysql> CREATE PROCEDURE dorepeat(p1 INT)\n       BEGIN\n         SET @x = 0;\n         REPEAT\n           SET @x = @x + 1;\n         UNTIL @x > p1 END REPEAT;\n       END\n       //\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> CALL dorepeat(1000)//\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> SELECT @x//\n+------+\n| @x   |\n+------+\n| 1001 |\n+------+\n1 row in set (0.00 sec)\n','https://dev.mysql.com/doc/refman/8.0/en/repeat.html'),(599,'RETURN',45,'Syntax:\nRETURN expr\n\nThe RETURN statement terminates execution of a stored function and\nreturns the value expr to the function caller. There must be at least\none RETURN statement in a stored function. There may be more than one\nif the function has multiple exit points.\n\nThis statement is not used in stored procedures, triggers, or events.\nThe LEAVE statement can be used to exit a stored program of those\ntypes.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/return.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/return.html'),(600,'WHILE',45,'Syntax:\n[begin_label:] WHILE search_condition DO\n    statement_list\nEND WHILE [end_label]\n\nThe statement list within a WHILE statement is repeated as long as the\nsearch_condition expression is true. statement_list consists of one or\nmore SQL statements, each terminated by a semicolon (;) statement\ndelimiter.\n\nA WHILE statement can be labeled. For the rules regarding label use,\nsee [HELP labels].\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/while.html\n\n','CREATE PROCEDURE dowhile()\nBEGIN\n  DECLARE v1 INT DEFAULT 5;\n\n  WHILE v1 > 0 DO\n    ...\n    SET v1 = v1 - 1;\n  END WHILE;\nEND;\n','https://dev.mysql.com/doc/refman/8.0/en/while.html'),(601,'CLOSE',45,'Syntax:\nCLOSE cursor_name\n\nThis statement closes a previously opened cursor. For an example, see\nhttps://dev.mysql.com/doc/refman/8.0/en/cursors.html.\n\nAn error occurs if the cursor is not open.\n\nIf not closed explicitly, a cursor is closed at the end of the BEGIN\n... END block in which it was declared.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/close.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/close.html'),(602,'DECLARE CURSOR',45,'Syntax:\nDECLARE cursor_name CURSOR FOR select_statement\n\nThis statement declares a cursor and associates it with a SELECT\nstatement that retrieves the rows to be traversed by the cursor. To\nfetch the rows later, use a FETCH statement. The number of columns\nretrieved by the SELECT statement must match the number of output\nvariables specified in the FETCH statement.\n\nThe SELECT statement cannot have an INTO clause.\n\nCursor declarations must appear before handler declarations and after\nvariable and condition declarations.\n\nA stored program may contain multiple cursor declarations, but each\ncursor declared in a given block must have a unique name. For an\nexample, see https://dev.mysql.com/doc/refman/8.0/en/cursors.html.\n\nFor information available through SHOW statements, it is possible in\nmany cases to obtain equivalent information by using a cursor with an\nINFORMATION_SCHEMA table.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/declare-cursor.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/declare-cursor.html'),(603,'FETCH',45,'Syntax:\nFETCH [[NEXT] FROM] cursor_name INTO var_name [, var_name] ...\n\nThis statement fetches the next row for the SELECT statement associated\nwith the specified cursor (which must be open), and advances the cursor\npointer. If a row exists, the fetched columns are stored in the named\nvariables. The number of columns retrieved by the SELECT statement must\nmatch the number of output variables specified in the FETCH statement.\n\nIf no more rows are available, a No Data condition occurs with SQLSTATE\nvalue \'02000\'. To detect this condition, you can set up a handler for\nit (or for a NOT FOUND condition). For an example, see\nhttps://dev.mysql.com/doc/refman/8.0/en/cursors.html.\n\nBe aware that another operation, such as a SELECT or another FETCH, may\nalso cause the handler to execute by raising the same condition. If it\nis necessary to distinguish which operation raised the condition, place\nthe operation within its own BEGIN ... END block so that it can be\nassociated with its own handler.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/fetch.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/fetch.html'),(604,'OPEN',45,'Syntax:\nOPEN cursor_name\n\nThis statement opens a previously declared cursor. For an example, see\nhttps://dev.mysql.com/doc/refman/8.0/en/cursors.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/open.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/open.html'),(605,'DECLARE CONDITION',45,'Syntax:\nDECLARE condition_name CONDITION FOR condition_value\n\ncondition_value: {\n    mysql_error_code\n  | SQLSTATE [VALUE] sqlstate_value\n}\n\nThe DECLARE ... CONDITION statement declares a named error condition,\nassociating a name with a condition that needs specific handling. The\nname can be referred to in a subsequent DECLARE ... HANDLER statement\n(see [HELP DECLARE HANDLER]).\n\nCondition declarations must appear before cursor or handler\ndeclarations.\n\nThe condition_value for DECLARE ... CONDITION indicates the specific\ncondition or class of conditions to associate with the condition name.\nIt can take the following forms:\n\no mysql_error_code: An integer literal indicating a MySQL error code.\n\n  Do not use MySQL error code 0 because that indicates success rather\n  than an error condition. For a list of MySQL error codes, see Server\n  Error Message Reference\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html).\n\no SQLSTATE [VALUE] sqlstate_value: A 5-character string literal\n  indicating an SQLSTATE value.\n\n  Do not use SQLSTATE values that begin with \'00\' because those\n  indicate success rather than an error condition. For a list of\n  SQLSTATE values, see Server Error Message Reference\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html).\n\nCondition names referred to in SIGNAL or use RESIGNAL statements must\nbe associated with SQLSTATE values, not MySQL error codes.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/declare-condition.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/declare-condition.html'),(606,'DECLARE HANDLER',45,'Syntax:\nDECLARE handler_action HANDLER\n    FOR condition_value [, condition_value] ...\n    statement\n\nhandler_action: {\n    CONTINUE\n  | EXIT\n  | UNDO\n}\n\ncondition_value: {\n    mysql_error_code\n  | SQLSTATE [VALUE] sqlstate_value\n  | condition_name\n  | SQLWARNING\n  | NOT FOUND\n  | SQLEXCEPTION\n}\n\nThe DECLARE ... HANDLER statement specifies a handler that deals with\none or more conditions. If one of these conditions occurs, the\nspecified statement executes. statement can be a simple statement such\nas SET var_name = value, or a compound statement written using BEGIN\nand END (see [HELP BEGIN END]).\n\nHandler declarations must appear after variable or condition\ndeclarations.\n\nThe handler_action value indicates what action the handler takes after\nexecution of the handler statement:\n\no CONTINUE: Execution of the current program continues.\n\no EXIT: Execution terminates for the BEGIN ... END compound statement\n  in which the handler is declared. This is true even if the condition\n  occurs in an inner block.\n\no UNDO: Not supported.\n\nThe condition_value for DECLARE ... HANDLER indicates the specific\ncondition or class of conditions that activates the handler. It can\ntake the following forms:\n\no mysql_error_code: An integer literal indicating a MySQL error code,\n  such as 1051 to specify \"unknown table\":\n\nDECLARE CONTINUE HANDLER FOR 1051\n  BEGIN\n    -- body of handler\n  END;\n\n  Do not use MySQL error code 0 because that indicates success rather\n  than an error condition. For a list of MySQL error codes, see Server\n  Error Message Reference\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html).\n\no SQLSTATE [VALUE] sqlstate_value: A 5-character string literal\n  indicating an SQLSTATE value, such as \'42S01\' to specify \"unknown\n  table\":\n\nDECLARE CONTINUE HANDLER FOR SQLSTATE \'42S02\'\n  BEGIN\n    -- body of handler\n  END;\n\n  Do not use SQLSTATE values that begin with \'00\' because those\n  indicate success rather than an error condition. For a list of\n  SQLSTATE values, see Server Error Message Reference\n  (https://dev.mysql.com/doc/mysql-errors/8.0/en/server-error-reference\n  .html).\n\no condition_name: A condition name previously specified with DECLARE\n  ... CONDITION. A condition name can be associated with a MySQL error\n  code or SQLSTATE value. See [HELP DECLARE CONDITION].\n\no SQLWARNING: Shorthand for the class of SQLSTATE values that begin\n  with \'01\'.\n\nDECLARE CONTINUE HANDLER FOR SQLWARNING\n  BEGIN\n    -- body of handler\n  END;\n\no NOT FOUND: Shorthand for the class of SQLSTATE values that begin with\n  \'02\'. This is relevant within the context of cursors and is used to\n  control what happens when a cursor reaches the end of a data set. If\n  no more rows are available, a No Data condition occurs with SQLSTATE\n  value \'02000\'. To detect this condition, you can set up a handler for\n  it or for a NOT FOUND condition.\n\nDECLARE CONTINUE HANDLER FOR NOT FOUND\n  BEGIN\n    -- body of handler\n  END;\n\n  For another example, see\n  https://dev.mysql.com/doc/refman/8.0/en/cursors.html. The NOT FOUND\n  condition also occurs for SELECT ... INTO var_list statements that\n  retrieve no rows.\n\no SQLEXCEPTION: Shorthand for the class of SQLSTATE values that do not\n  begin with \'00\', \'01\', or \'02\'.\n\nDECLARE CONTINUE HANDLER FOR SQLEXCEPTION\n  BEGIN\n    -- body of handler\n  END;\n\nFor information about how the server chooses handlers when a condition\noccurs, see https://dev.mysql.com/doc/refman/8.0/en/handler-scope.html.\n\nIf a condition occurs for which no handler has been declared, the\naction taken depends on the condition class:\n\no For SQLEXCEPTION conditions, the stored program terminates at the\n  statement that raised the condition, as if there were an EXIT\n  handler. If the program was called by another stored program, the\n  calling program handles the condition using the handler selection\n  rules applied to its own handlers.\n\no For SQLWARNING conditions, the program continues executing, as if\n  there were a CONTINUE handler.\n\no For NOT FOUND conditions, if the condition was raised normally, the\n  action is CONTINUE. If it was raised by SIGNAL or RESIGNAL, the\n  action is EXIT.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/declare-handler.html\n\n','mysql> CREATE TABLE test.t (s1 INT, PRIMARY KEY (s1));\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> delimiter //\n\nmysql> CREATE PROCEDURE handlerdemo ()\n       BEGIN\n         DECLARE CONTINUE HANDLER FOR SQLSTATE \'23000\' SET @x2 = 1;\n         SET @x = 1;\n         INSERT INTO test.t VALUES (1);\n         SET @x = 2;\n         INSERT INTO test.t VALUES (1);\n         SET @x = 3;\n       END;\n       //\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> CALL handlerdemo()//\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> SELECT @x//\n    +------+\n    | @x   |\n    +------+\n    | 3    |\n    +------+\n    1 row in set (0.00 sec)\n','https://dev.mysql.com/doc/refman/8.0/en/declare-handler.html'),(607,'GET DIAGNOSTICS',45,'Syntax:\nGET [CURRENT | STACKED] DIAGNOSTICS {\n    statement_information_item\n    [, statement_information_item] ...\n  | CONDITION condition_number\n    condition_information_item\n    [, condition_information_item] ...\n}\n\nstatement_information_item:\n    target = statement_information_item_name\n\ncondition_information_item:\n    target = condition_information_item_name\n\nstatement_information_item_name: {\n    NUMBER\n  | ROW_COUNT\n}\n\ncondition_information_item_name: {\n    CLASS_ORIGIN\n  | SUBCLASS_ORIGIN\n  | RETURNED_SQLSTATE\n  | MESSAGE_TEXT\n  | MYSQL_ERRNO\n  | CONSTRAINT_CATALOG\n  | CONSTRAINT_SCHEMA\n  | CONSTRAINT_NAME\n  | CATALOG_NAME\n  | SCHEMA_NAME\n  | TABLE_NAME\n  | COLUMN_NAME\n  | CURSOR_NAME\n}\n\ncondition_number, target:\n    (see following discussion)\n\nSQL statements produce diagnostic information that populates the\ndiagnostics area. The GET DIAGNOSTICS statement enables applications to\ninspect this information. (You can also use SHOW WARNINGS or SHOW\nERRORS to see conditions or errors.)\n\nNo special privileges are required to execute GET DIAGNOSTICS.\n\nThe keyword CURRENT means to retrieve information from the current\ndiagnostics area. The keyword STACKED means to retrieve information\nfrom the second diagnostics area, which is available only if the\ncurrent context is a condition handler. If neither keyword is given,\nthe default is to use the current diagnostics area.\n\nThe GET DIAGNOSTICS statement is typically used in a handler within a\nstored program. It is a MySQL extension that GET [CURRENT] DIAGNOSTICS\nis permitted outside handler context to check the execution of any SQL\nstatement. For example, if you invoke the mysql client program, you can\nenter these statements at the prompt:\n\nmysql> DROP TABLE test.no_such_table;\nERROR 1051 (42S02): Unknown table \'test.no_such_table\'\nmysql> GET DIAGNOSTICS CONDITION 1\n         @p1 = RETURNED_SQLSTATE, @p2 = MESSAGE_TEXT;\nmysql> SELECT @p1, @p2;\n+-------+------------------------------------+\n| @p1   | @p2                                |\n+-------+------------------------------------+\n| 42S02 | Unknown table \'test.no_such_table\' |\n+-------+------------------------------------+\n\nThis extension applies only to the current diagnostics area. It does\nnot apply to the second diagnostics area because GET STACKED\nDIAGNOSTICS is permitted only if the current context is a condition\nhandler. If that is not the case, a GET STACKED DIAGNOSTICS when\nhandler not active error occurs.\n\nFor a description of the diagnostics area, see\nhttps://dev.mysql.com/doc/refman/8.0/en/diagnostics-area.html. Briefly,\nit contains two kinds of information:\n\no Statement information, such as the number of conditions that occurred\n  or the affected-rows count.\n\no Condition information, such as the error code and message. If a\n  statement raises multiple conditions, this part of the diagnostics\n  area has a condition area for each one. If a statement raises no\n  conditions, this part of the diagnostics area is empty.\n\nFor a statement that produces three conditions, the diagnostics area\ncontains statement and condition information like this:\n\nStatement information:\n  row count\n  ... other statement information items ...\nCondition area list:\n  Condition area 1:\n    error code for condition 1\n    error message for condition 1\n    ... other condition information items ...\n  Condition area 2:\n    error code for condition 2:\n    error message for condition 2\n    ... other condition information items ...\n  Condition area 3:\n    error code for condition 3\n    error message for condition 3\n    ... other condition information items ...\n\nGET DIAGNOSTICS can obtain either statement or condition information,\nbut not both in the same statement:\n\no To obtain statement information, retrieve the desired statement items\n  into target variables. This instance of GET DIAGNOSTICS assigns the\n  number of available conditions and the rows-affected count to the\n  user variables @p1 and @p2:\n\nGET DIAGNOSTICS @p1 = NUMBER, @p2 = ROW_COUNT;\n\no To obtain condition information, specify the condition number and\n  retrieve the desired condition items into target variables. This\n  instance of GET DIAGNOSTICS assigns the SQLSTATE value and error\n  message to the user variables @p3 and @p4:\n\nGET DIAGNOSTICS CONDITION 1\n  @p3 = RETURNED_SQLSTATE, @p4 = MESSAGE_TEXT;\n\nThe retrieval list specifies one or more target = item_name\nassignments, separated by commas. Each assignment names a target\nvariable and either a statement_information_item_name or\ncondition_information_item_name designator, depending on whether the\nstatement retrieves statement or condition information.\n\nValid target designators for storing item information can be stored\nprocedure or function parameters, stored program local variables\ndeclared with DECLARE, or user-defined variables.\n\nValid condition_number designators can be stored procedure or function\nparameters, stored program local variables declared with DECLARE,\nuser-defined variables, system variables, or literals. A character\nliteral may include a _charset introducer. A warning occurs if the\ncondition number is not in the range from 1 to the number of condition\nareas that have information. In this case, the warning is added to the\ndiagnostics area without clearing it.\n\nWhen a condition occurs, MySQL does not populate all condition items\nrecognized by GET DIAGNOSTICS. For example:\n\nmysql> GET DIAGNOSTICS CONDITION 1\n         @p5 = SCHEMA_NAME, @p6 = TABLE_NAME;\nmysql> SELECT @p5, @p6;\n+------+------+\n| @p5  | @p6  |\n+------+------+\n|      |      |\n+------+------+\n\nIn standard SQL, if there are multiple conditions, the first condition\nrelates to the SQLSTATE value returned for the previous SQL statement.\nIn MySQL, this is not guaranteed. To get the main error, you cannot do\nthis:\n\nGET DIAGNOSTICS CONDITION 1 @errno = MYSQL_ERRNO;\n\nInstead, retrieve the condition count first, then use it to specify\nwhich condition number to inspect:\n\nGET DIAGNOSTICS @cno = NUMBER;\nGET DIAGNOSTICS CONDITION @cno @errno = MYSQL_ERRNO;\n\nFor information about permissible statement and condition information\nitems, and which ones are populated when a condition occurs, see\nhttps://dev.mysql.com/doc/refman/8.0/en/diagnostics-area.html#diagnosti\ncs-area-information-items.\n\nHere is an example that uses GET DIAGNOSTICS and an exception handler\nin stored procedure context to assess the outcome of an insert\noperation. If the insert was successful, the procedure uses GET\nDIAGNOSTICS to get the rows-affected count. This shows that you can use\nGET DIAGNOSTICS multiple times to retrieve information about a\nstatement as long as the current diagnostics area has not been cleared.\n\nCREATE PROCEDURE do_insert(value INT)\nBEGIN\n  -- Declare variables to hold diagnostics area information\n  DECLARE code CHAR(5) DEFAULT \'00000\';\n  DECLARE msg TEXT;\n  DECLARE nrows INT;\n  DECLARE result TEXT;\n  -- Declare exception handler for failed insert\n  DECLARE CONTINUE HANDLER FOR SQLEXCEPTION\n    BEGIN\n      GET DIAGNOSTICS CONDITION 1\n        code = RETURNED_SQLSTATE, msg = MESSAGE_TEXT;\n    END;\n\n  -- Perform the insert\n  INSERT INTO t1 (int_col) VALUES(value);\n  -- Check whether the insert was successful\n  IF code = \'00000\' THEN\n    GET DIAGNOSTICS nrows = ROW_COUNT;\n    SET result = CONCAT(\'insert succeeded, row count = \',nrows);\n  ELSE\n    SET result = CONCAT(\'insert failed, error = \',code,\', message = \',msg);\n  END IF;\n  -- Say what happened\n  SELECT result;\nEND;\n\nSuppose that t1.int_col is an integer column that is declared as NOT\nNULL. The procedure produces these results when invoked to insert\nnon-NULL and NULL values, respectively:\n\nmysql> CALL do_insert(1);\n+---------------------------------+\n| result                          |\n+---------------------------------+\n| insert succeeded, row count = 1 |\n+---------------------------------+\n\nmysql> CALL do_insert(NULL);\n+-------------------------------------------------------------------------+\n| result                                                                  |\n+-------------------------------------------------------------------------+\n| insert failed, error = 23000, message = Column \'int_col\' cannot be null |\n+-------------------------------------------------------------------------+\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/get-diagnostics.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/get-diagnostics.html'),(608,'RESIGNAL',45,'Syntax:\nRESIGNAL [condition_value]\n    [SET signal_information_item\n    [, signal_information_item] ...]\n\ncondition_value: {\n    SQLSTATE [VALUE] sqlstate_value\n  | condition_name\n}\n\nsignal_information_item:\n    condition_information_item_name = simple_value_specification\n\ncondition_information_item_name: {\n    CLASS_ORIGIN\n  | SUBCLASS_ORIGIN\n  | MESSAGE_TEXT\n  | MYSQL_ERRNO\n  | CONSTRAINT_CATALOG\n  | CONSTRAINT_SCHEMA\n  | CONSTRAINT_NAME\n  | CATALOG_NAME\n  | SCHEMA_NAME\n  | TABLE_NAME\n  | COLUMN_NAME\n  | CURSOR_NAME\n}\n\ncondition_name, simple_value_specification:\n    (see following discussion)\n\nRESIGNAL passes on the error condition information that is available\nduring execution of a condition handler within a compound statement\ninside a stored procedure or function, trigger, or event. RESIGNAL may\nchange some or all information before passing it on. RESIGNAL is\nrelated to SIGNAL, but instead of originating a condition as SIGNAL\ndoes, RESIGNAL relays existing condition information, possibly after\nmodifying it.\n\nRESIGNAL makes it possible to both handle an error and return the error\ninformation. Otherwise, by executing an SQL statement within the\nhandler, information that caused the handler\'s activation is destroyed.\nRESIGNAL also can make some procedures shorter if a given handler can\nhandle part of a situation, then pass the condition \"up the line\" to\nanother handler.\n\nNo privileges are required to execute the RESIGNAL statement.\n\nAll forms of RESIGNAL require that the current context be a condition\nhandler. Otherwise, RESIGNAL is illegal and a RESIGNAL when handler not\nactive error occurs.\n\nTo retrieve information from the diagnostics area, use the GET\nDIAGNOSTICS statement (see [HELP GET DIAGNOSTICS]). For information\nabout the diagnostics area, see\nhttps://dev.mysql.com/doc/refman/8.0/en/diagnostics-area.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/resignal.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/resignal.html'),(609,'SIGNAL',45,'Syntax:\nSIGNAL condition_value\n    [SET signal_information_item\n    [, signal_information_item] ...]\n\ncondition_value: {\n    SQLSTATE [VALUE] sqlstate_value\n  | condition_name\n}\n\nsignal_information_item:\n    condition_information_item_name = simple_value_specification\n\ncondition_information_item_name: {\n    CLASS_ORIGIN\n  | SUBCLASS_ORIGIN\n  | MESSAGE_TEXT\n  | MYSQL_ERRNO\n  | CONSTRAINT_CATALOG\n  | CONSTRAINT_SCHEMA\n  | CONSTRAINT_NAME\n  | CATALOG_NAME\n  | SCHEMA_NAME\n  | TABLE_NAME\n  | COLUMN_NAME\n  | CURSOR_NAME\n}\n\ncondition_name, simple_value_specification:\n    (see following discussion)\n\nSIGNAL is the way to \"return\" an error. SIGNAL provides error\ninformation to a handler, to an outer portion of the application, or to\nthe client. Also, it provides control over the error\'s characteristics\n(error number, SQLSTATE value, message). Without SIGNAL, it is\nnecessary to resort to workarounds such as deliberately referring to a\nnonexistent table to cause a routine to return an error.\n\nNo privileges are required to execute the SIGNAL statement.\n\nTo retrieve information from the diagnostics area, use the GET\nDIAGNOSTICS statement (see [HELP GET DIAGNOSTICS]). For information\nabout the diagnostics area, see\nhttps://dev.mysql.com/doc/refman/8.0/en/diagnostics-area.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/signal.html\n\n','CREATE PROCEDURE p (pval INT)\nBEGIN\n  DECLARE specialty CONDITION FOR SQLSTATE \'45000\';\n  IF pval = 0 THEN\n    SIGNAL SQLSTATE \'01000\';\n  ELSEIF pval = 1 THEN\n    SIGNAL SQLSTATE \'45000\'\n      SET MESSAGE_TEXT = \'An error occurred\';\n  ELSEIF pval = 2 THEN\n    SIGNAL specialty\n      SET MESSAGE_TEXT = \'An error occurred\';\n  ELSE\n    SIGNAL SQLSTATE \'01000\'\n      SET MESSAGE_TEXT = \'A warning occurred\', MYSQL_ERRNO = 1000;\n    SIGNAL SQLSTATE \'45000\'\n      SET MESSAGE_TEXT = \'An error occurred\', MYSQL_ERRNO = 1001;\n  END IF;\nEND;\n','https://dev.mysql.com/doc/refman/8.0/en/signal.html'),(610,'ALTER USER',46,'Syntax:\nALTER USER [IF EXISTS]\n    user [auth_option] [, user [auth_option]] ...\n    [REQUIRE {NONE | tls_option [[AND] tls_option] ...}]\n    [WITH resource_option [resource_option] ...]\n    [password_option | lock_option] ...\n    [COMMENT \'comment_string\' | ATTRIBUTE \'json_object\']\n\nALTER USER [IF EXISTS]\n    USER() user_func_auth_option\n\nALTER USER [IF EXISTS]\n    user [registration_option]\n\nALTER USER [IF EXISTS]\n    USER() [registration_option]\n\nALTER USER [IF EXISTS]\n    user DEFAULT ROLE\n    {NONE | ALL | role [, role ] ...}\n\nuser:\n    (see )\n\nauth_option: {\n    IDENTIFIED BY \'auth_string\'\n        [REPLACE \'current_auth_string\']\n        [RETAIN CURRENT PASSWORD]\n  | IDENTIFIED BY RANDOM PASSWORD\n        [REPLACE \'current_auth_string\']\n        [RETAIN CURRENT PASSWORD]\n  | IDENTIFIED WITH auth_plugin\n  | IDENTIFIED WITH auth_plugin BY \'auth_string\'\n        [REPLACE \'current_auth_string\']\n        [RETAIN CURRENT PASSWORD]\n  | IDENTIFIED WITH auth_plugin BY RANDOM PASSWORD\n        [REPLACE \'current_auth_string\']\n        [RETAIN CURRENT PASSWORD]\n  | IDENTIFIED WITH auth_plugin AS \'auth_string\'\n  | DISCARD OLD PASSWORD\n  | ADD factor factor_auth_option [ADD factor factor_auth_option]\n  | MODIFY factor factor_auth_option [MODIFY factor factor_auth_option]\n  | DROP factor [DROP factor]\n}\n\nuser_func_auth_option: {\n    IDENTIFIED BY \'auth_string\'\n        [REPLACE \'current_auth_string\']\n        [RETAIN CURRENT PASSWORD]\n  | DISCARD OLD PASSWORD\n}\n\nfactor_auth_option: {\n    IDENTIFIED BY \'auth_string\'\n  | IDENTIFIED BY RANDOM PASSWORD\n  | IDENTIFIED WITH auth_plugin BY \'auth_string\'\n  | IDENTIFIED WITH auth_plugin BY RANDOM PASSWORD\n  | IDENTIFIED WITH auth_plugin AS \'auth_string\'\n}\n\nregistration_option: {\n    factor INITIATE REGISTRATION\n  | factor FINISH REGISTRATION SET CHALLENGE_RESPONSE AS \'auth_string\'\n  | factor UNREGISTER\n}\n\nfactor: {2 | 3} FACTOR\n\ntls_option: {\n   SSL\n | X509\n | CIPHER \'cipher\'\n | ISSUER \'issuer\'\n | SUBJECT \'subject\'\n}\n\nresource_option: {\n    MAX_QUERIES_PER_HOUR count\n  | MAX_UPDATES_PER_HOUR count\n  | MAX_CONNECTIONS_PER_HOUR count\n  | MAX_USER_CONNECTIONS count\n}\n\npassword_option: {\n    PASSWORD EXPIRE [DEFAULT | NEVER | INTERVAL N DAY]\n  | PASSWORD HISTORY {DEFAULT | N}\n  | PASSWORD REUSE INTERVAL {DEFAULT | N DAY}\n  | PASSWORD REQUIRE CURRENT [DEFAULT | OPTIONAL]\n  | FAILED_LOGIN_ATTEMPTS N\n  | PASSWORD_LOCK_TIME {N | UNBOUNDED}\n}\n\nlock_option: {\n    ACCOUNT LOCK\n  | ACCOUNT UNLOCK\n}\n\nThe ALTER USER statement modifies MySQL accounts. It enables\nauthentication, role, SSL/TLS, resource-limit, password-management,\ncomment, and attribute properties to be modified for existing accounts.\nIt can also be used to lock and unlock accounts.\n\nIn most cases, ALTER USER requires the global CREATE USER privilege, or\nthe UPDATE privilege for the mysql system schema. The exceptions are:\n\no Any client who connects to the server using a nonanonymous account\n  can change the password for that account. (In particular, you can\n  change your own password.) To see which account the server\n  authenticated you as, invoke the CURRENT_USER() function:\n\nSELECT CURRENT_USER();\n\no For DEFAULT ROLE syntax, ALTER USER requires these privileges:\n\n  o Setting the default roles for another user requires the global\n    CREATE USER privilege, or the UPDATE privilege for the\n    mysql.default_roles system table.\n\n  o Setting the default roles for yourself requires no special\n    privileges, as long as the roles you want as the default have been\n    granted to you.\n\no Statements that modify secondary passwords require these privileges:\n\n  o The APPLICATION_PASSWORD_ADMIN privilege is required to use the\n    RETAIN CURRENT PASSWORD or DISCARD OLD PASSWORD clause for ALTER\n    USER statements that apply to your own account. The privilege is\n    required to manipulate your own secondary password because most\n    users require only one password.\n\n  o If an account is to be permitted to manipulate secondary passwords\n    for all accounts, it requires the CREATE USER privilege rather than\n    APPLICATION_PASSWORD_ADMIN.\n\nWhen the read_only system variable is enabled, ALTER USER additionally\nrequires the CONNECTION_ADMIN privilege (or the deprecated SUPER\nprivilege).\n\nAs of MySQL 8.0.27, these additional privilege considerations apply:\n\no The authentication_policy system variable places certain constraints\n  on how the authentication-related clauses of ALTER USER statements\n  may be used; for details, see the description of that variable. These\n  constraints do not apply if you have the AUTHENTICATION_POLICY_ADMIN\n  privilege.\n\no To modify an account that uses passwordless authentication, you must\n  have the PASSWORDLESS_USER_ADMIN privilege.\n\nBy default, an error occurs if you try to modify a user that does not\nexist. If the IF EXISTS clause is given, the statement produces a\nwarning for each named user that does not exist, rather than an error.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/alter-user.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/alter-user.html'),(611,'CREATE ROLE',46,'Syntax:\nCREATE ROLE [IF NOT EXISTS] role [, role ] ...\n\nCREATE ROLE creates one or more roles, which are named collections of\nprivileges. To use this statement, you must have the global CREATE ROLE\nor CREATE USER privilege. When the read_only system variable is\nenabled, CREATE ROLE additionally requires the CONNECTION_ADMIN\nprivilege (or the deprecated SUPER privilege).\n\nA role when created is locked, has no password, and is assigned the\ndefault authentication plugin. (These role attributes can be changed\nlater with the ALTER USER statement, by users who have the global\nCREATE USER privilege.)\n\nCREATE ROLE either succeeds for all named roles or rolls back and has\nno effect if any error occurs. By default, an error occurs if you try\nto create a role that already exists. If the IF NOT EXISTS clause is\ngiven, the statement produces a warning for each named role that\nalready exists, rather than an error.\n\nThe statement is written to the binary log if it succeeds, but not if\nit fails; in that case, rollback occurs and no changes are made. A\nstatement written to the binary log includes all named roles. If the IF\nNOT EXISTS clause is given, this includes even roles that already exist\nand were not created.\n\nEach role name uses the format described in\nhttps://dev.mysql.com/doc/refman/8.0/en/role-names.html. For example:\n\nCREATE ROLE \'admin\', \'developer\';\nCREATE ROLE \'webapp\'@\'localhost\';\n\nThe host name part of the role name, if omitted, defaults to \'%\'.\n\nFor role usage examples, see\nhttps://dev.mysql.com/doc/refman/8.0/en/roles.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/create-role.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/create-role.html'),(612,'CREATE USER',46,'Syntax:\nCREATE USER [IF NOT EXISTS]\n    user [auth_option] [, user [auth_option]] ...\n    DEFAULT ROLE role [, role ] ...\n    [REQUIRE {NONE | tls_option [[AND] tls_option] ...}]\n    [WITH resource_option [resource_option] ...]\n    [password_option | lock_option] ...\n    [COMMENT \'comment_string\' | ATTRIBUTE \'json_object\']\n\nuser:\n    (see )\n\nauth_option: {\n    IDENTIFIED BY \'auth_string\' [AND 2fa_auth_option]\n  | IDENTIFIED BY RANDOM PASSWORD [AND 2fa_auth_option]\n  | IDENTIFIED WITH auth_plugin [AND 2fa_auth_option]\n  | IDENTIFIED WITH auth_plugin BY \'auth_string\' [AND 2fa_auth_option]\n  | IDENTIFIED WITH auth_plugin BY RANDOM PASSWORD [AND 2fa_auth_option]\n  | IDENTIFIED WITH auth_plugin AS \'auth_string\' [AND 2fa_auth_option]\n  | IDENTIFIED WITH auth_plugin [initial_auth_option]\n}\n\n2fa_auth_option: {\n    IDENTIFIED BY \'auth_string\' [AND 3fa_auth_option]\n  | IDENTIFIED BY RANDOM PASSWORD [AND 3fa_auth_option]\n  | IDENTIFIED WITH auth_plugin [AND 3fa_auth_option]\n  | IDENTIFIED WITH auth_plugin BY \'auth_string\' [AND 3fa_auth_option]\n  | IDENTIFIED WITH auth_plugin BY RANDOM PASSWORD [AND 3fa_auth_option]\n  | IDENTIFIED WITH auth_plugin AS \'auth_string\' [AND 3fa_auth_option]\n}\n\n3fa_auth_option: {\n    IDENTIFIED BY \'auth_string\'\n  | IDENTIFIED BY RANDOM PASSWORD\n  | IDENTIFIED WITH auth_plugin\n  | IDENTIFIED WITH auth_plugin BY \'auth_string\'\n  | IDENTIFIED WITH auth_plugin BY RANDOM PASSWORD\n  | IDENTIFIED WITH auth_plugin AS \'auth_string\'\n}\n\ninitial_auth_option: {\n    INITIAL AUTHENTICATION IDENTIFIED BY {RANDOM PASSWORD | \'auth_string\'}\n  | INITIAL AUTHENTICATION IDENTIFIED WITH auth_plugin AS \'auth_string\'\n}\n\ntls_option: {\n   SSL\n | X509\n | CIPHER \'cipher\'\n | ISSUER \'issuer\'\n | SUBJECT \'subject\'\n}\n\nresource_option: {\n    MAX_QUERIES_PER_HOUR count\n  | MAX_UPDATES_PER_HOUR count\n  | MAX_CONNECTIONS_PER_HOUR count\n  | MAX_USER_CONNECTIONS count\n}\n\npassword_option: {\n    PASSWORD EXPIRE [DEFAULT | NEVER | INTERVAL N DAY]\n  | PASSWORD HISTORY {DEFAULT | N}\n  | PASSWORD REUSE INTERVAL {DEFAULT | N DAY}\n  | PASSWORD REQUIRE CURRENT [DEFAULT | OPTIONAL]\n  | FAILED_LOGIN_ATTEMPTS N\n  | PASSWORD_LOCK_TIME {N | UNBOUNDED}\n}\n\nlock_option: {\n    ACCOUNT LOCK\n  | ACCOUNT UNLOCK\n}\n\nThe CREATE USER statement creates new MySQL accounts. It enables\nauthentication, role, SSL/TLS, resource-limit, password-management,\ncomment, and attribute properties to be established for new accounts.\nIt also controls whether accounts are initially locked or unlocked.\n\nTo use CREATE USER, you must have the global CREATE USER privilege, or\nthe INSERT privilege for the mysql system schema. When the read_only\nsystem variable is enabled, CREATE USER additionally requires the\nCONNECTION_ADMIN privilege (or the deprecated SUPER privilege).\n\nAs of MySQL 8.0.27, these additional privilege considerations apply:\n\no The authentication_policy system variable places certain constraints\n  on how the authentication-related clauses of CREATE USER statements\n  may be used; for details, see the description of that variable. These\n  constraints do not apply if you have the AUTHENTICATION_POLICY_ADMIN\n  privilege.\n\no To create an account that uses passwordless authentication, you must\n  have the PASSWORDLESS_USER_ADMIN privilege.\n\nAs of MySQL 8.0.22, CREATE USER fails with an error if any account to\nbe created is named as the DEFINER attribute for any stored object.\n(That is, the statement fails if creating an account would cause the\naccount to adopt a currently orphaned stored object.) To perform the\noperation anyway, you must have the SET_USER_ID privilege; in this\ncase, the statement succeeds with a warning rather than failing with an\nerror. Without SET_USER_ID, to perform the user-creation operation,\ndrop the orphan objects, create the account and grant its privileges,\nand then re-create the dropped objects. For additional information,\nincluding how to identify which objects name a given account as the\nDEFINER attribute, see\nhttps://dev.mysql.com/doc/refman/8.0/en/stored-objects-security.html#st\nored-objects-security-orphan-objects.\n\nCREATE USER either succeeds for all named users or rolls back and has\nno effect if any error occurs. By default, an error occurs if you try\nto create a user that already exists. If the IF NOT EXISTS clause is\ngiven, the statement produces a warning for each named user that\nalready exists, rather than an error.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/create-user.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/create-user.html'),(613,'DROP ROLE',46,'Syntax:\nDROP ROLE [IF EXISTS] role [, role ] ...\n\nDROP ROLE removes one or more roles (named collections of privileges).\nTo use this statement, you must have the global DROP ROLE or CREATE\nUSER privilege. When the read_only system variable is enabled, DROP\nROLE additionally requires the CONNECTION_ADMIN privilege (or the\ndeprecated SUPER privilege).\n\nAs of MySQL 8.0.16, users who have the CREATE USER privilege can use\nthis statement to drop accounts that are locked or unlocked. Users who\nhave the DROP ROLE privilege can use this statement only to drop\naccounts that are locked (unlocked accounts are presumably user\naccounts used to log in to the server and not just as roles).\n\nRoles named in the mandatory_roles system variable value cannot be\ndropped.\n\nDROP ROLE either succeeds for all named roles or rolls back and has no\neffect if any error occurs. By default, an error occurs if you try to\ndrop a role that does not exist. If the IF EXISTS clause is given, the\nstatement produces a warning for each named role that does not exist,\nrather than an error.\n\nThe statement is written to the binary log if it succeeds, but not if\nit fails; in that case, rollback occurs and no changes are made. A\nstatement written to the binary log includes all named roles. If the IF\nEXISTS clause is given, this includes even roles that do not exist and\nwere not dropped.\n\nEach role name uses the format described in\nhttps://dev.mysql.com/doc/refman/8.0/en/role-names.html. For example:\n\nDROP ROLE \'admin\', \'developer\';\nDROP ROLE \'webapp\'@\'localhost\';\n\nThe host name part of the role name, if omitted, defaults to \'%\'.\n\nA dropped role is automatically revoked from any user account (or role)\nto which the role was granted. Within any current session for such an\naccount, its adjusted privileges apply beginning with the next\nstatement executed.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/drop-role.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/drop-role.html'),(614,'DROP USER',46,'Syntax:\nDROP USER [IF EXISTS] user [, user] ...\n\nThe DROP USER statement removes one or more MySQL accounts and their\nprivileges. It removes privilege rows for the account from all grant\ntables.\n\nRoles named in the mandatory_roles system variable value cannot be\ndropped.\n\nTo use DROP USER, you must have the global CREATE USER privilege, or\nthe DELETE privilege for the mysql system schema. When the read_only\nsystem variable is enabled, DROP USER additionally requires the\nCONNECTION_ADMIN privilege (or the deprecated SUPER privilege).\n\nAs of MySQL 8.0.22, DROP USER fails with an error if any account to be\ndropped is named as the DEFINER attribute for any stored object. (That\nis, the statement fails if dropping an account would cause a stored\nobject to become orphaned.) To perform the operation anyway, you must\nhave the SET_USER_ID privilege; in this case, the statement succeeds\nwith a warning rather than failing with an error. For additional\ninformation, including how to identify which objects name a given\naccount as the DEFINER attribute, see\nhttps://dev.mysql.com/doc/refman/8.0/en/stored-objects-security.html#st\nored-objects-security-orphan-objects.\n\nDROP USER either succeeds for all named users or rolls back and has no\neffect if any error occurs. By default, an error occurs if you try to\ndrop a user that does not exist. If the IF EXISTS clause is given, the\nstatement produces a warning for each named user that does not exist,\nrather than an error.\n\nThe statement is written to the binary log if it succeeds, but not if\nit fails; in that case, rollback occurs and no changes are made. A\nstatement written to the binary log includes all named users. If the IF\nEXISTS clause is given, this includes even users that do not exist and\nwere not dropped.\n\nEach account name uses the format described in\nhttps://dev.mysql.com/doc/refman/8.0/en/account-names.html. For\nexample:\n\nDROP USER \'jeffrey\'@\'localhost\';\n\nThe host name part of the account name, if omitted, defaults to \'%\'.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/drop-user.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/drop-user.html'),(615,'GRANT',46,'Syntax:\nGRANT\n    priv_type [(column_list)]\n      [, priv_type [(column_list)]] ...\n    ON [object_type] priv_level\n    TO user_or_role [, user_or_role] ...\n    [WITH GRANT OPTION]\n    [AS user\n        [WITH ROLE\n            DEFAULT\n          | NONE\n          | ALL\n          | ALL EXCEPT role [, role ] ...\n          | role [, role ] ...\n        ]\n    ]\n}\n\nGRANT PROXY ON user_or_role\n    TO user_or_role [, user_or_role] ...\n    [WITH GRANT OPTION]\n\nGRANT role [, role] ...\n    TO user_or_role [, user_or_role] ...\n    [WITH ADMIN OPTION]\n\nobject_type: {\n    TABLE\n  | FUNCTION\n  | PROCEDURE\n}\n\npriv_level: {\n    *\n  | *.*\n  | db_name.*\n  | db_name.tbl_name\n  | tbl_name\n  | db_name.routine_name\n}\n\nuser_or_role: {\n    user (see https://dev.mysql.com/doc/refman/8.0/en/account-names.html)\n  | role (see https://dev.mysql.com/doc/refman/8.0/en/role-names.html)\n}\n\nThe GRANT statement enables system administrators to grant privileges\nand roles, which can be granted to user accounts and roles. These\nsyntax restrictions apply:\n\no GRANT cannot mix granting both privileges and roles in the same\n  statement. A given GRANT statement must grant either privileges or\n  roles.\n\no The ON clause distinguishes whether the statement grants privileges\n  or roles:\n\n  o With ON, the statement grants privileges.\n\n  o Without ON, the statement grants roles.\n\n  o It is permitted to assign both privileges and roles to an account,\n    but you must use separate GRANT statements, each with syntax\n    appropriate to what is to be granted.\n\nFor more information about roles, see\nhttps://dev.mysql.com/doc/refman/8.0/en/roles.html.\n\nTo grant a privilege with GRANT, you must have the GRANT OPTION\nprivilege, and you must have the privileges that you are granting.\n(Alternatively, if you have the UPDATE privilege for the grant tables\nin the mysql system schema, you can grant any account any privilege.)\nWhen the read_only system variable is enabled, GRANT additionally\nrequires the CONNECTION_ADMIN privilege (or the deprecated SUPER\nprivilege).\n\nGRANT either succeeds for all named users and roles or rolls back and\nhas no effect if any error occurs. The statement is written to the\nbinary log only if it succeeds for all named users and roles.\n\nThe REVOKE statement is related to GRANT and enables administrators to\nremove account privileges. See [HELP REVOKE].\n\nEach account name uses the format described in\nhttps://dev.mysql.com/doc/refman/8.0/en/account-names.html. Each role\nname uses the format described in\nhttps://dev.mysql.com/doc/refman/8.0/en/role-names.html. For example:\n\nGRANT ALL ON db1.* TO \'jeffrey\'@\'localhost\';\nGRANT \'role1\', \'role2\' TO \'user1\'@\'localhost\', \'user2\'@\'localhost\';\nGRANT SELECT ON world.* TO \'role3\';\n\nThe host name part of the account or role name, if omitted, defaults to\n\'%\'.\n\nNormally, a database administrator first uses CREATE USER to create an\naccount and define its nonprivilege characteristics such as its\npassword, whether it uses secure connections, and limits on access to\nserver resources, then uses GRANT to define its privileges. ALTER USER\nmay be used to change the nonprivilege characteristics of existing\naccounts. For example:\n\nCREATE USER \'jeffrey\'@\'localhost\' IDENTIFIED BY \'password\';\nGRANT ALL ON db1.* TO \'jeffrey\'@\'localhost\';\nGRANT SELECT ON db2.invoice TO \'jeffrey\'@\'localhost\';\nALTER USER \'jeffrey\'@\'localhost\' WITH MAX_QUERIES_PER_HOUR 90;\n\nFrom the mysql program, GRANT responds with Query OK, 0 rows affected\nwhen executed successfully. To determine what privileges result from\nthe operation, use SHOW GRANTS. See [HELP SHOW GRANTS].\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/grant.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/grant.html'),(616,'RENAME USER',46,'Syntax:\nRENAME USER old_user TO new_user\n    [, old_user TO new_user] ...\n\nThe RENAME USER statement renames existing MySQL accounts. An error\noccurs for old accounts that do not exist or new accounts that already\nexist.\n\nTo use RENAME USER, you must have the global CREATE USER privilege, or\nthe UPDATE privilege for the mysql system schema. When the read_only\nsystem variable is enabled, RENAME USER additionally requires the\nCONNECTION_ADMIN privilege (or the deprecated SUPER privilege).\n\nAs of MySQL 8.0.22, RENAME USER fails with an error if any account to\nbe renamed is named as the DEFINER attribute for any stored object.\n(That is, the statement fails if renaming an account would cause a\nstored object to become orphaned.) To perform the operation anyway, you\nmust have the SET_USER_ID privilege; in this case, the statement\nsucceeds with a warning rather than failing with an error. For\nadditional information, including how to identify which objects name a\ngiven account as the DEFINER attribute, see\nhttps://dev.mysql.com/doc/refman/8.0/en/stored-objects-security.html#st\nored-objects-security-orphan-objects.\n\nEach account name uses the format described in\nhttps://dev.mysql.com/doc/refman/8.0/en/account-names.html. For\nexample:\n\nRENAME USER \'jeffrey\'@\'localhost\' TO \'jeff\'@\'127.0.0.1\';\n\nThe host name part of the account name, if omitted, defaults to \'%\'.\n\nRENAME USER causes the privileges held by the old user to be those held\nby the new user. However, RENAME USER does not automatically drop or\ninvalidate databases or objects within them that the old user created.\nThis includes stored programs or views for which the DEFINER attribute\nnames the old user. Attempts to access such objects may produce an\nerror if they execute in definer security context. (For information\nabout security context, see\nhttps://dev.mysql.com/doc/refman/8.0/en/stored-objects-security.html.)\n\nThe privilege changes take effect as indicated in\nhttps://dev.mysql.com/doc/refman/8.0/en/privilege-changes.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/rename-user.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/rename-user.html'),(617,'REVOKE',46,'Syntax:\nREVOKE [IF EXISTS]\n    priv_type [(column_list)]\n      [, priv_type [(column_list)]] ...\n    ON [object_type] priv_level\n    FROM user_or_role [, user_or_role] ...\n    [IGNORE UNKNOWN USER]\n\nREVOKE [IF EXISTS] ALL [PRIVILEGES], GRANT OPTION\n    FROM user_or_role [, user_or_role] ...\n    [IGNORE UNKNOWN USER]\n\nREVOKE [IF EXISTS] PROXY ON user_or_role\n    FROM user_or_role [, user_or_role] ...\n    [IGNORE UNKNOWN USER]\n\nREVOKE [IF EXISTS] role [, role ] ...\n    FROM user_or_role [, user_or_role ] ...\n    [IGNORE UNKNOWN USER]\n\nuser_or_role: {\n    user (see https://dev.mysql.com/doc/refman/8.0/en/account-names.html)\n  | role (see https://dev.mysql.com/doc/refman/8.0/en/role-names.html\n}\n\nThe REVOKE statement enables system administrators to revoke privileges\nand roles, which can be revoked from user accounts and roles.\n\nFor details on the levels at which privileges exist, the permissible\npriv_type, priv_level, and object_type values, and the syntax for\nspecifying users and passwords, see [HELP GRANT].\n\nFor information about roles, see\nhttps://dev.mysql.com/doc/refman/8.0/en/roles.html.\n\nWhen the read_only system variable is enabled, REVOKE requires the\nCONNECTION_ADMIN or privilege (or the deprecated SUPER privilege), in\naddition to any other required privileges described in the following\ndiscussion.\n\nBeginning with MySQL 8.0.30, all the forms shown for REVOKE support an\nIF EXISTS option as well as an IGNORE UNKNOWN USER option. With neither\nof these modifications, REVOKE either succeeds for all named users and\nroles, or rolls back and has no effect if any error occurs; the\nstatement is written to the binary log only if it succeeds for all\nnamed users and roles. The precise effects of IF EXISTS and IGNORE\nUNKNOWN USER are discussed later in this section.\n\nEach account name uses the format described in\nhttps://dev.mysql.com/doc/refman/8.0/en/account-names.html. Each role\nname uses the format described in\nhttps://dev.mysql.com/doc/refman/8.0/en/role-names.html. For example:\n\nREVOKE INSERT ON *.* FROM \'jeffrey\'@\'localhost\';\nREVOKE \'role1\', \'role2\' FROM \'user1\'@\'localhost\', \'user2\'@\'localhost\';\nREVOKE SELECT ON world.* FROM \'role3\';\n\nThe host name part of the account or role name, if omitted, defaults to\n\'%\'.\n\nTo use the first REVOKE syntax, you must have the GRANT OPTION\nprivilege, and you must have the privileges that you are revoking.\n\nTo revoke all privileges, use the second syntax, which drops all\nglobal, database, table, column, and routine privileges for the named\nusers or roles:\n\nREVOKE ALL PRIVILEGES, GRANT OPTION\n  FROM user_or_role [, user_or_role] ...\n\nREVOKE ALL PRIVILEGES, GRANT OPTION does not revoke any roles.\n\nTo use this REVOKE syntax, you must have the global CREATE USER\nprivilege, or the UPDATE privilege for the mysql system schema.\n\nThe syntax for which the REVOKE keyword is followed by one or more role\nnames takes a FROM clause indicating one or more users or roles from\nwhich to revoke the roles.\n\nThe IF EXISTS and IGNORE UNKNOWN USER options (MySQL 8.0.30 and later)\nhave the effects listed here:\n\no IF EXISTS means that, if the target user or role exists but no such\n  privilege or role is found assigned to the target for any reason, a\n  warning is raised, instead of an error; if no privilege or role named\n  by the statement is assigned to the target, the statement has no\n  (other) effect. Otherwise, REVOKE executes normally; if the user does\n  not exist, the statement raises an error.\n\n  Example: Given table t1 in database test, we execute the following\n  statements, with the results shown.\n\nmysql> CREATE USER jerry@localhost;\nQuery OK, 0 rows affected (0.01 sec)\n\nmysql> REVOKE SELECT ON test.t1 FROM jerry@localhost;\nERROR 1147 (42000): There is no such grant defined for user \'jerry\' on host\n\'localhost\' on table \'t1\' \nmysql> REVOKE IF EXISTS SELECT ON test.t1 FROM jerry@localhost;\nQuery OK, 0 rows affected, 1 warning (0.00 sec)\n\nmysql> SHOW WARNINGS\\G\n*************************** 1. row ***************************\n  Level: Warning\n   Code: 1147\nMessage: There is no such grant defined for user \'jerry\' on host \'localhost\' on\ntable \'t1\' \n1 row in set (0.00 sec)\n\n  IF EXISTS causes an error to be demoted to a warning even if the\n  privilege or role named does not exist, or the statement attempts to\n  assign it at the wrong level.\n\no If the REVOKE statement includes IGNORE UNKNOWN USER, the statement\n  raises a warning for any target user or role named in the statement\n  but not found; if no target named by the statement exists, REVOKE\n  succeeds but has no actual effect. Otherwise, the statement executes\n  as usual, and attempting to revoke a privilege not assigned to the\n  target for whatever reason raises an error, as expected.\n\n  Example (continuing from the previous example):\n\nmysql> DROP USER IF EXISTS jerry@localhost;\nQuery OK, 0 rows affected (0.01 sec)\n\nmysql> REVOKE SELECT ON test.t1 FROM jerry@localhost;\nERROR 1147 (42000): There is no such grant defined for user \'jerry\' on host\n\'localhost\' on table \'t1\' \nmysql> REVOKE SELECT ON test.t1 FROM jerry@localhost IGNORE UNKNOWN USER;\nQuery OK, 0 rows affected, 1 warning (0.01 sec)\n\nmysql> SHOW WARNINGS\\G\n*************************** 1. row ***************************\n  Level: Warning\n   Code: 3162\nMessage: Authorization ID jerry does not exist.\n1 row in set (0.00 sec)\n\no The combination of IF EXISTS and IGNORE UNKNOWN USER means that\n  REVOKE never raises an error for an unknown target user or role or\n  for an unassigned or unavailable privilege, and the statement as\n  whole in such cases succeeds; roles or privileges are removed from\n  existing target users or roles whenever possible, and any revocation\n  which is not possible raises a warning and executes as a NOOP.\n\n  Example (again continuing from example in the previous item):\n\n# No such user, no such role\nmysql> DROP ROLE IF EXISTS Bogus;\nQuery OK, 0 rows affected, 1 warning (0.02 sec)\n\nmysql> SHOW WARNINGS;\n+-------+------+----------------------------------------------+\n| Level | Code | Message                                      |\n+-------+------+----------------------------------------------+\n| Note  | 3162 | Authorization ID \'Bogus\'@\'%\' does not exist. |\n+-------+------+----------------------------------------------+\n1 row in set (0.00 sec)\n\n# This statement attempts to revoke a nonexistent role from a nonexistent user\nmysql> REVOKE Bogus ON test FROM jerry@localhost;\nERROR 3619 (HY000): Illegal privilege level specified for test\n\n# The same, with IF EXISTS\nmysql> REVOKE IF EXISTS Bogus ON test FROM jerry@localhost;\nERROR 1147 (42000): There is no such grant defined for user \'jerry\' on host\n\'localhost\' on table \'test\' \n\n# The same, with IGNORE UNKNOWN USER\nmysql> REVOKE Bogus ON test FROM jerry@localhost IGNORE UNKNOWN USER;\nERROR 3619 (HY000): Illegal privilege level specified for test\n\n# The same, with both options\nmysql> REVOKE IF EXISTS Bogus ON test FROM jerry@localhost IGNORE UNKNOWN USER;\nQuery OK, 0 rows affected, 2 warnings (0.01 sec)\n\nmysql> SHOW WARNINGS;\n+---------+------+--------------------------------------------+\n| Level   | Code | Message                                    |\n+---------+------+--------------------------------------------+\n| Warning | 3619 | Illegal privilege level specified for test |\n| Warning | 3162 | Authorization ID jerry does not exist.     |\n+---------+------+--------------------------------------------+\n2 rows in set (0.00 sec)\n\nRoles named in the mandatory_roles system variable value cannot be\nrevoked. When IF EXISTS and IGNORE UNKNOWN USER are used together in a\nstatement that tries to remove a mandatory privilege, the error\nnormally raised by attempting to do this is demoted to a warning; the\nstatement executes successfully, but does not make any changes.\n\nA revoked role immediately affects any user account from which it was\nrevoked, such that within any current session for the account, its\nprivileges are adjusted for the next statement executed.\n\nRevoking a role revokes the role itself, not the privileges that it\nrepresents. Suppose that an account is granted a role that includes a\ngiven privilege, and is also granted the privilege explicitly or\nanother role that includes the privilege. In this case, the account\nstill possesses that privilege if the first role is revoked. For\nexample, if an account is granted two roles that each include SELECT,\nthe account still can select after either role is revoked.\n\nREVOKE ALL ON *.* (at the global level) revokes all granted static\nglobal privileges and all granted dynamic privileges.\n\nA revoked privilege that is granted but not known to the server is\nrevoked with a warning. This situation can occur for dynamic\nprivileges. For example, a dynamic privilege can be granted while the\ncomponent that registers it is installed, but if that component is\nsubsequently uninstalled, the privilege becomes unregistered, although\naccounts that possess the privilege still possess it and it can be\nrevoked from them.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/revoke.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/revoke.html'),(618,'SET DEFAULT ROLE',46,'Syntax:\nSET DEFAULT ROLE\n    {NONE | ALL | role [, role ] ...}\n    TO user [, user ] ...\n\nFor each user named immediately after the TO keyword, this statement\ndefines which roles become active when the user connects to the server\nand authenticates, or when the user executes the SET ROLE DEFAULT\nstatement during a session.\n\nSET DEFAULT ROLE is alternative syntax for ALTER USER ... DEFAULT ROLE\n(see [HELP ALTER USER]). However, ALTER USER can set the default for\nonly a single user, whereas SET DEFAULT ROLE can set the default for\nmultiple users. On the other hand, you can specify CURRENT_USER as the\nuser name for the ALTER USER statement, whereas you cannot for SET\nDEFAULT ROLE.\n\nSET DEFAULT ROLE requires these privileges:\n\no Setting the default roles for another user requires the global CREATE\n  USER privilege, or the UPDATE privilege for the mysql.default_roles\n  system table.\n\no Setting the default roles for yourself requires no special\n  privileges, as long as the roles you want as the default have been\n  granted to you.\n\nEach role name uses the format described in\nhttps://dev.mysql.com/doc/refman/8.0/en/role-names.html. For example:\n\nSET DEFAULT ROLE \'admin\', \'developer\' TO \'joe\'@\'10.0.0.1\';\n\nThe host name part of the role name, if omitted, defaults to \'%\'.\n\nThe clause following the DEFAULT ROLE keywords permits these values:\n\no NONE: Set the default to NONE (no roles).\n\no ALL: Set the default to all roles granted to the account.\n\no role [, role ] ...: Set the default to the named roles, which must\n  exist and be granted to the account at the time SET DEFAULT ROLE is\n  executed.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/set-default-role.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/set-default-role.html'),(619,'SET PASSWORD',46,'Syntax:\nSET PASSWORD [FOR user] auth_option\n    [REPLACE \'current_auth_string\']\n    [RETAIN CURRENT PASSWORD]\n\nauth_option: {\n    = \'auth_string\'\n  | TO RANDOM\n}\n\nThe SET PASSWORD statement assigns a password to a MySQL user account.\nThe password may be either explicitly specified in the statement or\nrandomly generated by MySQL. The statement may also include a\npassword-verification clause that specifies the account current\npassword to be replaced, and a clause that manages whether an account\nhas a secondary password. \'auth_string\' and \'current_auth_string\' each\nrepresent a cleartext (unencrypted) password.\n\n*Note*:\n\nRather than using SET PASSWORD to assign passwords, ALTER USER is the\npreferred statement for account alterations, including assigning\npasswords. For example:\n\nALTER USER user IDENTIFIED BY \'auth_string\';\n\n*Note*:\n\nClauses for random password generation, password verification, and\nsecondary passwords apply only to accounts that use an authentication\nplugin that stores credentials internally to MySQL. For accounts that\nuse a plugin that performs authentication against a credentials system\nthat is external to MySQL, password management must be handled\nexternally against that system as well. For more information about\ninternal credentials storage, see\nhttps://dev.mysql.com/doc/refman/8.0/en/password-management.html.\n\nThe REPLACE \'current_auth_string\' clause performs password verification\nand is available as of MySQL 8.0.13. If given:\n\no REPLACE specifies the account current password to be replaced, as a\n  cleartext (unencrypted) string.\n\no The clause must be given if password changes for the account are\n  required to specify the current password, as verification that the\n  user attempting to make the change actually knows the current\n  password.\n\no The clause is optional if password changes for the account may but\n  need not specify the current password.\n\no The statement fails if the clause is given but does not match the\n  current password, even if the clause is optional.\n\no REPLACE can be specified only when changing the account password for\n  the current user.\n\nFor more information about password verification by specifying the\ncurrent password, see\nhttps://dev.mysql.com/doc/refman/8.0/en/password-management.html.\n\nThe RETAIN CURRENT PASSWORD clause implements dual-password capability\nand is available as of MySQL 8.0.14. If given:\n\no RETAIN CURRENT PASSWORD retains an account current password as its\n  secondary password, replacing any existing secondary password. The\n  new password becomes the primary password, but clients can use the\n  account to connect to the server using either the primary or\n  secondary password. (Exception: If the new password specified by the\n  SET PASSWORD statement is empty, the secondary password becomes empty\n  as well, even if RETAIN CURRENT PASSWORD is given.)\n\no If you specify RETAIN CURRENT PASSWORD for an account that has an\n  empty primary password, the statement fails.\n\no If an account has a secondary password and you change its primary\n  password without specifying RETAIN CURRENT PASSWORD, the secondary\n  password remains unchanged.\n\nFor more information about use of dual passwords, see\nhttps://dev.mysql.com/doc/refman/8.0/en/password-management.html.\n\nSET PASSWORD permits these auth_option syntaxes:\n\no = \'auth_string\'\n\n  Assigns the account the given literal password.\n\no TO RANDOM\n\n  Assigns the account a password randomly generated by MySQL. The\n  statement also returns the cleartext password in a result set to make\n  it available to the user or application executing the statement.\n\n  For details about the result set and characteristics of randomly\n  generated passwords, see\n  https://dev.mysql.com/doc/refman/8.0/en/password-management.html#rand\n  om-password-generation.\n\n  Random password generation is available as of MySQL 8.0.18.\n\n*Important*:\n\nUnder some circumstances, SET PASSWORD may be recorded in server logs\nor on the client side in a history file such as ~/.mysql_history, which\nmeans that cleartext passwords may be read by anyone having read access\nto that information. For information about the conditions under which\nthis occurs for the server logs and how to control it, see\nhttps://dev.mysql.com/doc/refman/8.0/en/password-logging.html. For\nsimilar information about client-side logging, see\nhttps://dev.mysql.com/doc/refman/8.0/en/mysql-logging.html.\n\nSET PASSWORD can be used with or without a FOR clause that explicitly\nnames a user account:\n\no With a FOR user clause, the statement sets the password for the named\n  account, which must exist:\n\nSET PASSWORD FOR \'jeffrey\'@\'localhost\' = \'auth_string\';\n\no With no FOR user clause, the statement sets the password for the\n  current user:\n\nSET PASSWORD = \'auth_string\';\n\n  Any client who connects to the server using a nonanonymous account\n  can change the password for that account. (In particular, you can\n  change your own password.) To see which account the server\n  authenticated you as, invoke the CURRENT_USER() function:\n\nSELECT CURRENT_USER();\n\nIf a FOR user clause is given, the account name uses the format\ndescribed in\nhttps://dev.mysql.com/doc/refman/8.0/en/account-names.html. For\nexample:\n\nSET PASSWORD FOR \'bob\'@\'%.example.org\' = \'auth_string\';\n\nThe host name part of the account name, if omitted, defaults to \'%\'.\n\nSET PASSWORD interprets the string as a cleartext string, passes it to\nthe authentication plugin associated with the account, and stores the\nresult returned by the plugin in the account row in the mysql.user\nsystem table. (The plugin is given the opportunity to hash the value\ninto the encryption format it expects. The plugin may use the value as\nspecified, in which case no hashing occurs.)\n\nSetting the password for a named account (with a FOR clause) requires\nthe UPDATE privilege for the mysql system schema. Setting the password\nfor yourself (for a nonanonymous account with no FOR clause) requires\nno special privileges.\n\nStatements that modify secondary passwords require these privileges:\n\no The APPLICATION_PASSWORD_ADMIN privilege is required to use the\n  RETAIN CURRENT PASSWORD clause for SET PASSWORD statements that apply\n  to your own account. The privilege is required to manipulate your own\n  secondary password because most users require only one password.\n\no If an account is to be permitted to manipulate secondary passwords\n  for all accounts, it should be granted the CREATE USER privilege\n  rather than APPLICATION_PASSWORD_ADMIN.\n\nWhen the read_only system variable is enabled, SET PASSWORD requires\nthe CONNECTION_ADMIN privilege (or the deprecated SUPER privilege), in\naddition to any other required privileges.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/set-password.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/set-password.html'),(620,'SET ROLE',46,'Syntax:\nSET ROLE {\n    DEFAULT\n  | NONE\n  | ALL\n  | ALL EXCEPT role [, role ] ...\n  | role [, role ] ...\n}\n\nSET ROLE modifies the current user\'s effective privileges within the\ncurrent session by specifying which of its granted roles are active.\nGranted roles include those granted explicitly to the user and those\nnamed in the mandatory_roles system variable value.\n\nExamples:\n\nSET ROLE DEFAULT;\nSET ROLE \'role1\', \'role2\';\nSET ROLE ALL;\nSET ROLE ALL EXCEPT \'role1\', \'role2\';\n\nEach role name uses the format described in\nhttps://dev.mysql.com/doc/refman/8.0/en/role-names.html. The host name\npart of the role name, if omitted, defaults to \'%\'.\n\nPrivileges that the user has been granted directly (rather than through\nroles) remain unaffected by changes to the active roles.\n\nThe statement permits these role specifiers:\n\no DEFAULT: Activate the account default roles. Default roles are those\n  specified with SET DEFAULT ROLE.\n\n  When a user connects to the server and authenticates successfully,\n  the server determines which roles to activate as the default roles.\n  If the activate_all_roles_on_login system variable is enabled, the\n  server activates all granted roles. Otherwise, the server executes\n  SET ROLE DEFAULT implicitly. The server activates only default roles\n  that can be activated. The server writes warnings to its error log\n  for default roles that cannot be activated, but the client receives\n  no warnings.\n\n  If a user executes SET ROLE DEFAULT during a session, an error occurs\n  if any default role cannot be activated (for example, if it does not\n  exist or is not granted to the user). In this case, the current\n  active roles are not changed.\n\no NONE: Set the active roles to NONE (no active roles).\n\no ALL: Activate all roles granted to the account.\n\no ALL EXCEPT role [, role ] ...: Activate all roles granted to the\n  account except those named. The named roles need not exist or be\n  granted to the account.\n\no role [, role ] ...: Activate the named roles, which must be granted\n  to the account.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/set-role.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/set-role.html'),(621,'ALTER RESOURCE GROUP',46,'Syntax:\nALTER RESOURCE GROUP group_name\n    [VCPU [=] vcpu_spec [, vcpu_spec] ...]\n    [THREAD_PRIORITY [=] N]\n    [ENABLE|DISABLE [FORCE]]\n\nvcpu_spec: {N | M - N}\n\nALTER RESOURCE GROUP is used for resource group management (see\nhttps://dev.mysql.com/doc/refman/8.0/en/resource-groups.html). This\nstatement alters modifiable attributes of an existing resource group.\nIt requires the RESOURCE_GROUP_ADMIN privilege.\n\ngroup_name identifies which resource group to alter. If the group does\nnot exist, an error occurs.\n\nThe attributes for CPU affinity, priority, and whether the group is\nenabled can be modified with ALTER RESOURCE GROUP. These attributes are\nspecified the same way as described for CREATE RESOURCE GROUP (see\n[HELP CREATE RESOURCE GROUP]). Only the attributes specified are\naltered. Unspecified attributes retain their current values.\n\nThe FORCE modifier is used with DISABLE. It determines statement\nbehavior if the resource group has any threads assigned to it:\n\no If FORCE is not given, existing threads in the group continue to run\n  until they terminate, but new threads cannot be assigned to the\n  group.\n\no If FORCE is given, existing threads in the group are moved to their\n  respective default group (system threads to SYS_default, user threads\n  to USR_default).\n\nThe name and type attributes are set at group creation time and cannot\nbe modified thereafter with ALTER RESOURCE GROUP.\n\nExamples:\n\no Alter a group CPU affinity:\n\nALTER RESOURCE GROUP rg1 VCPU = 0-63;\n\no Alter a group thread priority:\n\nALTER RESOURCE GROUP rg2 THREAD_PRIORITY = 5;\n\no Disable a group, moving any threads assigned to it to the default\n  groups:\n\nALTER RESOURCE GROUP rg3 DISABLE FORCE;\n\nResource group management is local to the server on which it occurs.\nALTER RESOURCE GROUP statements are not written to the binary log and\nare not replicated.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/alter-resource-group.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/alter-resource-group.html'),(622,'CREATE RESOURCE GROUP',46,'Syntax:\nCREATE RESOURCE GROUP group_name\n    TYPE = {SYSTEM|USER}\n    [VCPU [=] vcpu_spec [, vcpu_spec] ...]\n    [THREAD_PRIORITY [=] N]\n    [ENABLE|DISABLE]\n\nvcpu_spec: {N | M - N}\n\nCREATE RESOURCE GROUP is used for resource group management (see\nhttps://dev.mysql.com/doc/refman/8.0/en/resource-groups.html). This\nstatement creates a new resource group and assigns its initial\nattribute values. It requires the RESOURCE_GROUP_ADMIN privilege.\n\ngroup_name identifies which resource group to create. If the group\nalready exists, an error occurs.\n\nThe TYPE attribute is required. It should be SYSTEM for a system\nresource group, USER for a user resource group. The group type affects\npermitted THREAD_PRIORITY values, as described later.\n\nThe VCPU attribute indicates the CPU affinity; that is, the set of\nvirtual CPUs the group can use:\n\no If VCPU is not given, the resource group has no CPU affinity and can\n  use all available CPUs.\n\no If VCPU is given, the attribute value is a list of comma-separated\n  CPU numbers or ranges:\n\n  o Each number must be an integer in the range from 0 to the number of\n    CPUs − 1. For example, on a system with 64 CPUs, the number can\n    range from 0 to 63.\n\n  o A range is given in the form M − N, where M is less than or equal\n    to N and both numbers are in the CPU range.\n\n  o If a CPU number is an integer outside the permitted range or is not\n    an integer, an error occurs.\n\nExample VCPU specifiers (these are all equivalent):\n\nVCPU = 0,1,2,3,9,10\nVCPU = 0-3,9-10\nVCPU = 9,10,0-3\nVCPU = 0,10,1,9,3,2\n\nThe THREAD_PRIORITY attribute indicates the priority for threads\nassigned to the group:\n\no If THREAD_PRIORITY is not given, the default priority is 0.\n\no If THREAD_PRIORITY is given, the attribute value must be in the range\n  from -20 (highest priority) to 19 (lowest priority). The priority for\n  system resource groups must be in the range from -20 to 0. The\n  priority for user resource groups must be in the range from 0 to 19.\n  Use of different ranges for system and user groups ensures that user\n  threads never have a higher priority than system threads.\n\nENABLE and DISABLE specify that the resource group is initially enabled\nor disabled. If neither is specified, the group is enabled by default.\nA disabled group cannot have threads assigned to it.\n\nExamples:\n\no Create an enabled user group that has a single CPU and the lowest\n  priority:\n\nCREATE RESOURCE GROUP rg1\n  TYPE = USER\n  VCPU = 0\n  THREAD_PRIORITY = 19;\n\no Create a disabled system group that has no CPU affinity (can use all\n  CPUs) and the highest priority:\n\nCREATE RESOURCE GROUP rg2\n  TYPE = SYSTEM\n  THREAD_PRIORITY = -20\n  DISABLE;\n\nResource group management is local to the server on which it occurs.\nCREATE RESOURCE GROUP statements are not written to the binary log and\nare not replicated.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/create-resource-group.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/create-resource-group.html'),(623,'DROP RESOURCE GROUP',46,'Syntax:\nDROP RESOURCE GROUP group_name [FORCE]\n\nDROP RESOURCE GROUP is used for resource group management (see\nhttps://dev.mysql.com/doc/refman/8.0/en/resource-groups.html). This\nstatement drops a resource group. It requires the RESOURCE_GROUP_ADMIN\nprivilege.\n\ngroup_name identifies which resource group to drop. If the group does\nnot exist, an error occurs.\n\nThe FORCE modifier determines statement behavior if the resource group\nhas any threads assigned to it:\n\no If FORCE is not given and any threads are assigned to the group, an\n  error occurs.\n\no If FORCE is given, existing threads in the group are moved to their\n  respective default group (system threads to SYS_default, user threads\n  to USR_default).\n\nExamples:\n\no Drop a group, failing if the group contains any threads:\n\nDROP RESOURCE GROUP rg1;\n\no Drop a group and move existing threads to the default groups:\n\nDROP RESOURCE GROUP rg2 FORCE;\n\nResource group management is local to the server on which it occurs.\nDROP RESOURCE GROUP statements are not written to the binary log and\nare not replicated.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/drop-resource-group.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/drop-resource-group.html'),(624,'SET RESOURCE GROUP',46,'Syntax:\nSET RESOURCE GROUP group_name\n    [FOR thread_id [, thread_id] ...]\n\nSET RESOURCE GROUP is used for resource group management (see\nhttps://dev.mysql.com/doc/refman/8.0/en/resource-groups.html). This\nstatement assigns threads to a resource group. It requires the\nRESOURCE_GROUP_ADMIN or RESOURCE_GROUP_USER privilege.\n\ngroup_name identifies which resource group to be assigned. Any\nthread_id values indicate threads to assign to the group. Thread IDs\ncan be determined from the Performance Schema threads table. If the\nresource group or any named thread ID does not exist, an error occurs.\n\nWith no FOR clause, the statement assigns the current thread for the\nsession to the resource group.\n\nWith a FOR clause that names thread IDs, the statement assigns those\nthreads to the resource group.\n\nFor attempts to assign a system thread to a user resource group or a\nuser thread to a system resource group, a warning occurs.\n\nExamples:\n\no Assign the current session thread to a group:\n\nSET RESOURCE GROUP rg1;\n\no Assign the named threads to a group:\n\nSET RESOURCE GROUP rg2 FOR 14, 78, 4;\n\nResource group management is local to the server on which it occurs.\nSET RESOURCE GROUP statements are not written to the binary log and are\nnot replicated.\n\nAn alternative to SET RESOURCE GROUP is the RESOURCE_GROUP optimizer\nhint, which assigns individual statements to a resource group. See\nhttps://dev.mysql.com/doc/refman/8.0/en/optimizer-hints.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/set-resource-group.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/set-resource-group.html'),(625,'ANALYZE TABLE',47,'Syntax:\nANALYZE [NO_WRITE_TO_BINLOG | LOCAL]\n    TABLE tbl_name [, tbl_name] ...\n\nANALYZE [NO_WRITE_TO_BINLOG | LOCAL]\n    TABLE tbl_name\n    UPDATE HISTOGRAM ON col_name [, col_name] ...\n        [WITH N BUCKETS]\n\nANALYZE [NO_WRITE_TO_BINLOG | LOCAL] \n    TABLE tbl_name\n    UPDATE HISTOGRAM ON col_name [USING DATA \'json_data\']\n\nANALYZE [NO_WRITE_TO_BINLOG | LOCAL]\n    TABLE tbl_name\n    DROP HISTOGRAM ON col_name [, col_name] ...\n\nANALYZE TABLE generates table statistics:\n\no ANALYZE TABLE without either HISTOGRAM clause performs a key\n  distribution analysis and stores the distribution for the named table\n  or tables. For MyISAM tables, ANALYZE TABLE for key distribution\n  analysis is equivalent to using myisamchk --analyze.\n\no ANALYZE TABLE with the UPDATE HISTOGRAM clause generates histogram\n  statistics for the named table columns and stores them in the data\n  dictionary. Only one table name is permitted for this syntax. MySQL\n  8.0.31 and later also supports setting the histogram of a single\n  column to a user-defined JSON value.\n\no ANALYZE TABLE with the DROP HISTOGRAM clause removes histogram\n  statistics for the named table columns from the data dictionary. Only\n  one table name is permitted for this syntax.\n\nThis statement requires SELECT and INSERT privileges for the table.\n\nANALYZE TABLE works with InnoDB, NDB, and MyISAM tables. It does not\nwork with views.\n\nIf the innodb_read_only system variable is enabled, ANALYZE TABLE may\nfail because it cannot update statistics tables in the data dictionary,\nwhich use InnoDB. For ANALYZE TABLE operations that update the key\ndistribution, failure may occur even if the operation updates the table\nitself (for example, if it is a MyISAM table). To obtain the updated\ndistribution statistics, set information_schema_stats_expiry=0.\n\nANALYZE TABLE is supported for partitioned tables, and you can use\nALTER TABLE ... ANALYZE PARTITION to analyze one or more partitions;\nfor more information, see [HELP ALTER TABLE], and\nhttps://dev.mysql.com/doc/refman/8.0/en/partitioning-maintenance.html.\n\nDuring the analysis, the table is locked with a read lock for InnoDB\nand MyISAM.\n\nANALYZE TABLE removes the table from the table definition cache, which\nrequires a flush lock. If there are long running statements or\ntransactions still using the table, subsequent statements and\ntransactions must wait for those operations to finish before the flush\nlock is released. Because ANALYZE TABLE itself typically finishes\nquickly, it may not be apparent that delayed transactions or statements\ninvolving the same table are due to the remaining flush lock.\n\nBy default, the server writes ANALYZE TABLE statements to the binary\nlog so that they replicate to replicas. To suppress logging, specify\nthe optional NO_WRITE_TO_BINLOG keyword or its alias LOCAL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/analyze-table.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/analyze-table.html'),(626,'CHECK TABLE',47,'Syntax:\nCHECK TABLE tbl_name [, tbl_name] ... [option] ...\n\noption: {\n    FOR UPGRADE\n  | QUICK\n  | FAST\n  | MEDIUM\n  | EXTENDED\n  | CHANGED\n}\n\nCHECK TABLE checks a table or tables for errors. CHECK TABLE can also\ncheck views for problems, such as tables that are referenced in the\nview definition that no longer exist.\n\nTo check a table, you must have some privilege for it.\n\nCHECK TABLE works for InnoDB, MyISAM, ARCHIVE, and CSV tables.\n\nBefore running CHECK TABLE on InnoDB tables, see\nhttps://dev.mysql.com/doc/refman/8.0/en/check-table.html#check-table-in\nnodb.\n\nCHECK TABLE is supported for partitioned tables, and you can use ALTER\nTABLE ... CHECK PARTITION to check one or more partitions; for more\ninformation, see [HELP ALTER TABLE], and\nhttps://dev.mysql.com/doc/refman/8.0/en/partitioning-maintenance.html.\n\nCHECK TABLE ignores virtual generated columns that are not indexed.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/check-table.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/check-table.html'),(627,'CHECKSUM TABLE',47,'Syntax:\nCHECKSUM TABLE tbl_name [, tbl_name] ... [QUICK | EXTENDED]\n\nCHECKSUM TABLE reports a checksum for the contents of a table. You can\nuse this statement to verify that the contents are the same before and\nafter a backup, rollback, or other operation that is intended to put\nthe data back to a known state.\n\nThis statement requires the SELECT privilege for the table.\n\nThis statement is not supported for views. If you run CHECKSUM TABLE\nagainst a view, the Checksum value is always NULL, and a warning is\nreturned.\n\nFor a nonexistent table, CHECKSUM TABLE returns NULL and generates a\nwarning.\n\nDuring the checksum operation, the table is locked with a read lock for\nInnoDB and MyISAM.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/checksum-table.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/checksum-table.html'),(628,'OPTIMIZE TABLE',47,'Syntax:\nOPTIMIZE [NO_WRITE_TO_BINLOG | LOCAL]\n    TABLE tbl_name [, tbl_name] ...\n\nOPTIMIZE TABLE reorganizes the physical storage of table data and\nassociated index data, to reduce storage space and improve I/O\nefficiency when accessing the table. The exact changes made to each\ntable depend on the storage engine used by that table.\n\nUse OPTIMIZE TABLE in these cases, depending on the type of table:\n\no After doing substantial insert, update, or delete operations on an\n  InnoDB table that has its own .ibd file because it was created with\n  the innodb_file_per_table option enabled. The table and indexes are\n  reorganized, and disk space can be reclaimed for use by the operating\n  system.\n\no After doing substantial insert, update, or delete operations on\n  columns that are part of a FULLTEXT index in an InnoDB table. Set the\n  configuration option innodb_optimize_fulltext_only=1 first. To keep\n  the index maintenance period to a reasonable time, set the\n  innodb_ft_num_word_optimize option to specify how many words to\n  update in the search index, and run a sequence of OPTIMIZE TABLE\n  statements until the search index is fully updated.\n\no After deleting a large part of a MyISAM or ARCHIVE table, or making\n  many changes to a MyISAM or ARCHIVE table with variable-length rows\n  (tables that have VARCHAR, VARBINARY, BLOB, or TEXT columns). Deleted\n  rows are maintained in a linked list and subsequent INSERT operations\n  reuse old row positions. You can use OPTIMIZE TABLE to reclaim the\n  unused space and to defragment the data file. After extensive changes\n  to a table, this statement may also improve performance of statements\n  that use the table, sometimes significantly.\n\nThis statement requires SELECT and INSERT privileges for the table.\n\nOPTIMIZE TABLE works for InnoDB, MyISAM, and ARCHIVE tables. OPTIMIZE\nTABLE is also supported for dynamic columns of in-memory NDB tables. It\ndoes not work for fixed-width columns of in-memory tables, nor does it\nwork for Disk Data tables. The performance of OPTIMIZE on NDB Cluster\ntables can be tuned using --ndb-optimization-delay, which controls the\nlength of time to wait between processing batches of rows by OPTIMIZE\nTABLE. For more information, see\nhttps://dev.mysql.com/doc/refman/8.0/en/mysql-cluster-limitations-resol\nved.html.\n\nFor NDB Cluster tables, OPTIMIZE TABLE can be interrupted by (for\nexample) killing the SQL thread performing the OPTIMIZE operation.\n\nBy default, OPTIMIZE TABLE does not work for tables created using any\nother storage engine and returns a result indicating this lack of\nsupport. You can make OPTIMIZE TABLE work for other storage engines by\nstarting mysqld with the --skip-new option. In this case, OPTIMIZE\nTABLE is just mapped to ALTER TABLE.\n\nThis statement does not work with views.\n\nOPTIMIZE TABLE is supported for partitioned tables. For information\nabout using this statement with partitioned tables and table\npartitions, see\nhttps://dev.mysql.com/doc/refman/8.0/en/partitioning-maintenance.html.\n\nBy default, the server writes OPTIMIZE TABLE statements to the binary\nlog so that they replicate to replicas. To suppress logging, specify\nthe optional NO_WRITE_TO_BINLOG keyword or its alias LOCAL.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/optimize-table.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/optimize-table.html'),(629,'REPAIR TABLE',47,'Syntax:\nREPAIR [NO_WRITE_TO_BINLOG | LOCAL]\n    TABLE tbl_name [, tbl_name] ...\n    [QUICK] [EXTENDED] [USE_FRM]\n\nREPAIR TABLE repairs a possibly corrupted table, for certain storage\nengines only.\n\nThis statement requires SELECT and INSERT privileges for the table.\n\nAlthough normally you should never have to run REPAIR TABLE, if\ndisaster strikes, this statement is very likely to get back all your\ndata from a MyISAM table. If your tables become corrupted often, try to\nfind the reason for it, to eliminate the need to use REPAIR TABLE. See\nhttps://dev.mysql.com/doc/refman/8.0/en/crashing.html, and\nhttps://dev.mysql.com/doc/refman/8.0/en/myisam-table-problems.html.\n\nREPAIR TABLE checks the table to see whether an upgrade is required. If\nso, it performs the upgrade, following the same rules as CHECK TABLE\n... FOR UPGRADE. See [HELP CHECK TABLE], for more information.\n\n*Important*:\n\no Make a backup of a table before performing a table repair operation;\n  under some circumstances the operation might cause data loss.\n  Possible causes include but are not limited to file system errors.\n  See https://dev.mysql.com/doc/refman/8.0/en/backup-and-recovery.html.\n\no If the server exits during a REPAIR TABLE operation, it is essential\n  after restarting it that you immediately execute another REPAIR TABLE\n  statement for the table before performing any other operations on it.\n  In the worst case, you might have a new clean index file without\n  information about the data file, and then the next operation you\n  perform could overwrite the data file. This is an unlikely but\n  possible scenario that underscores the value of making a backup\n  first.\n\no In the event that a table on the source becomes corrupted and you run\n  REPAIR TABLE on it, any resulting changes to the original table are\n  not propagated to replicas.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/repair-table.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/repair-table.html');
INSERT INTO `help_topic` VALUES (630,'CREATE FUNCTION LOADABLE FUNCTION',48,'Syntax:\nCREATE [AGGREGATE] FUNCTION [IF NOT EXISTS] function_name\n    RETURNS {STRING|INTEGER|REAL|DECIMAL}\n    SONAME shared_library_name\n\nThis statement loads the loadable function named function_name. (CREATE\nFUNCTION is also used to created stored functions; see [HELP CREATE\nPROCEDURE].)\n\nA loadable function is a way to extend MySQL with a new function that\nworks like a native (built-in) MySQL function such as ABS() or\nCONCAT(). See Adding a Loadable Function\n(https://dev.mysql.com/doc/extending-mysql/8.0/en/adding-loadable-funct\nion.html).\n\nfunction_name is the name that should be used in SQL statements to\ninvoke the function. The RETURNS clause indicates the type of the\nfunction\'s return value. DECIMAL is a legal value after RETURNS, but\ncurrently DECIMAL functions return string values and should be written\nlike STRING functions.\n\nIF NOT EXISTS prevents an error from occurring if there already exists\na loadable function with the same name. It does not prevent an error\nfrom occurring if there already exists a built-in function having the\nsame name. IF NOT EXISTS is supported for CREATE FUNCTION statements\nbeginning with MySQL 8.0.29. See also\nhttps://dev.mysql.com/doc/refman/8.0/en/function-resolution.html#functi\non-name-resolution.\n\nThe AGGREGATE keyword, if given, signifies that the function is an\naggregate (group) function. An aggregate function works exactly like a\nnative MySQL aggregate function such as SUM() or COUNT().\n\nshared_library_name is the base name of the shared library file\ncontaining the code that implements the function. The file must be\nlocated in the plugin directory. This directory is given by the value\nof the plugin_dir system variable. For more information, see\nhttps://dev.mysql.com/doc/refman/8.0/en/function-loading.html.\n\nCREATE FUNCTION requires the INSERT privilege for the mysql system\nschema because it adds a row to the mysql.func system table to register\nthe function.\n\nCREATE FUNCTION also adds the function to the Performance Schema\nuser_defined_functions table that provides runtime information about\ninstalled loadable functions. See\nhttps://dev.mysql.com/doc/refman/8.0/en/performance-schema-user-defined\n-functions-table.html.\n\n*Note*:\n\nLike the mysql.func system table, the Performance Schema\nuser_defined_functions table lists loadable functions installed using\nCREATE FUNCTION. Unlike the mysql.func table, the\nuser_defined_functions table also lists loadable functions installed\nautomatically by server components or plugins. This difference makes\nuser_defined_functions preferable to mysql.func for checking which\nloadable functions are installed.\n\nDuring the normal startup sequence, the server loads functions\nregistered in the mysql.func table. If the server is started with the\n--skip-grant-tables option, functions registered in the table are not\nloaded and are unavailable.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/create-function-loadable.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/create-function-loadable.html'),(631,'DROP FUNCTION LOADABLE FUNCTION',48,'Syntax:\nDROP FUNCTION [IF EXISTS] function_name\n\nThis statement drops the loadable function named function_name. (DROP\nFUNCTION is also used to drop stored functions; see [HELP DROP\nPROCEDURE].)\n\nDROP FUNCTION is the complement of CREATE FUNCTION. It requires the\nDELETE privilege for the mysql system schema because it removes the row\nfrom the mysql.func system table that registers the function.\n\nDROP FUNCTION also removes the function from the Performance Schema\nuser_defined_functions table that provides runtime information about\ninstalled loadable functions. See\nhttps://dev.mysql.com/doc/refman/8.0/en/performance-schema-user-defined\n-functions-table.html.\n\nDuring the normal startup sequence, the server loads functions\nregistered in the mysql.func table. Because DROP FUNCTION removes the\nmysql.func row for the dropped function, the server does not load the\nfunction during subsequent restarts.\n\nDROP FUNCTION cannot be used to drop a loadable function that is\ninstalled automatically by components or plugins rather than by using\nCREATE FUNCTION. Such a function is also dropped automatically, when\nthe component or plugin that installed it is uninstalled.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/drop-function-loadable.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/drop-function-loadable.html'),(632,'INSTALL COMPONENT',49,'Syntax:\nINSTALL COMPONENT component_name [, component_name ] ...\n\nThis statement installs one or more components, which become active\nimmediately. A component provides services that are available to the\nserver and other components; see\nhttps://dev.mysql.com/doc/refman/8.0/en/components.html. INSTALL\nCOMPONENT requires the INSERT privilege for the mysql.component system\ntable because it adds a row to that table to register the component.\n\nExample:\n\nINSTALL COMPONENT \'file://component1\', \'file://component2\';\n\nA component is named using a URN that begins with file:// and indicates\nthe base name of the library file that implements the component,\nlocated in the directory named by the plugin_dir system variable.\nComponent names do not include any platform-dependent file name suffix\nsuch as .so or .dll. (These naming details are subject to change\nbecause component name interpretation is itself performed by a service\nand the component infrastructure makes it possible to replace the\ndefault service implementation with alternative implementations.)\n\nIf any error occurs, the statement fails and has no effect. For\nexample, this happens if a component name is erroneous, a named\ncomponent does not exist or is already installed, or component\ninitialization fails.\n\nA loader service handles component loading, which includes adding\ninstalled components to the mysql.component system table that serves as\na registry. For subsequent server restarts, any components listed in\nmysql.component are loaded by the loader service during the startup\nsequence. This occurs even if the server is started with the\n--skip-grant-tables option.\n\nIf a component depends on services not present in the registry and you\nattempt to install the component without also installing the component\nor components that provide the services on which it depends, an error\noccurs:\n\nERROR 3527 (HY000): Cannot satisfy dependency for service \'component_a\'\nrequired by component \'component_b\'.\n\nTo avoid this problem, either install all components in the same\nstatement, or install the dependent component after installing any\ncomponents on which it depends.\n\n*Note*:\n\nFor keyring components, do not use INSTALL COMPONENT. Instead,\nconfigure keyring component loading using a manifest file. See\nhttps://dev.mysql.com/doc/refman/8.0/en/keyring-component-installation.\nhtml.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/install-component.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/install-component.html'),(633,'INSTALL PLUGIN',50,'Syntax:\nINSTALL PLUGIN plugin_name SONAME \'shared_library_name\'\n\nThis statement installs a server plugin. It requires the INSERT\nprivilege for the mysql.plugin system table because it adds a row to\nthat table to register the plugin.\n\nplugin_name is the name of the plugin as defined in the plugin\ndescriptor structure contained in the library file (see Plugin Data\nStructures\n(https://dev.mysql.com/doc/extending-mysql/8.0/en/plugin-data-structure\ns.html)). Plugin names are not case-sensitive. For maximal\ncompatibility, plugin names should be limited to ASCII letters, digits,\nand underscore because they are used in C source files, shell command\nlines, M4 and Bourne shell scripts, and SQL environments.\n\nshared_library_name is the name of the shared library that contains the\nplugin code. The name includes the file name extension (for example,\nlibmyplugin.so, libmyplugin.dll, or libmyplugin.dylib).\n\nThe shared library must be located in the plugin directory (the\ndirectory named by the plugin_dir system variable). The library must be\nin the plugin directory itself, not in a subdirectory. By default,\nplugin_dir is the plugin directory under the directory named by the\npkglibdir configuration variable, but it can be changed by setting the\nvalue of plugin_dir at server startup. For example, set its value in a\nmy.cnf file:\n\n[mysqld]\nplugin_dir=/path/to/plugin/directory\n\nIf the value of plugin_dir is a relative path name, it is taken to be\nrelative to the MySQL base directory (the value of the basedir system\nvariable).\n\nINSTALL PLUGIN loads and initializes the plugin code to make the plugin\navailable for use. A plugin is initialized by executing its\ninitialization function, which handles any setup that the plugin must\nperform before it can be used. When the server shuts down, it executes\nthe deinitialization function for each plugin that is loaded so that\nthe plugin has a chance to perform any final cleanup.\n\nINSTALL PLUGIN also registers the plugin by adding a line that\nindicates the plugin name and library file name to the mysql.plugin\nsystem table. During the normal startup sequence, the server loads and\ninitializes plugins registered in mysql.plugin. This means that a\nplugin is installed with INSTALL PLUGIN only once, not every time the\nserver starts. If the server is started with the --skip-grant-tables\noption, plugins registered in the mysql.plugin table are not loaded and\nare unavailable.\n\nA plugin library can contain multiple plugins. For each of them to be\ninstalled, use a separate INSTALL PLUGIN statement. Each statement\nnames a different plugin, but all of them specify the same library\nname.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/install-plugin.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/install-plugin.html'),(634,'UNINSTALL COMPONENT',49,'Syntax:\nUNINSTALL COMPONENT component_name [, component_name ] ...\n\nThis statement deactivates and uninstalls one or more components. A\ncomponent provides services that are available to the server and other\ncomponents; see\nhttps://dev.mysql.com/doc/refman/8.0/en/components.html. UNINSTALL\nCOMPONENT is the complement of INSTALL COMPONENT. It requires the\nDELETE privilege for the mysql.component system table because it\nremoves the row from that table that registers the component.\n\nExample:\n\nUNINSTALL COMPONENT \'file://component1\', \'file://component2\';\n\nFor information about component naming, see [HELP INSTALL COMPONENT].\n\nIf any error occurs, the statement fails and has no effect. For\nexample, this happens if a component name is erroneous, a named\ncomponent is not installed, or cannot be uninstalled because other\ninstalled components depend on it.\n\nA loader service handles component unloading, which includes removing\nuninstalled components from the mysql.component system table that\nserves as a registry. As a result, unloaded components are not loaded\nduring the startup sequence for subsequent server restarts.\n\n*Note*:\n\nThis statement has no effect for keyring components, which are loaded\nusing a manifest file and cannot be uninstalled. See\nhttps://dev.mysql.com/doc/refman/8.0/en/keyring-component-installation.\nhtml.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/uninstall-component.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/uninstall-component.html'),(635,'UNINSTALL PLUGIN',49,'Syntax:\nUNINSTALL PLUGIN plugin_name\n\nThis statement removes an installed server plugin. UNINSTALL PLUGIN is\nthe complement of INSTALL PLUGIN. It requires the DELETE privilege for\nthe mysql.plugin system table because it removes the row from that\ntable that registers the plugin.\n\nplugin_name must be the name of some plugin that is listed in the\nmysql.plugin table. The server executes the plugin\'s deinitialization\nfunction and removes the row for the plugin from the mysql.plugin\nsystem table, so that subsequent server restarts do not load and\ninitialize the plugin. UNINSTALL PLUGIN does not remove the plugin\'s\nshared library file.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/uninstall-plugin.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/uninstall-plugin.html'),(636,'CLONE',49,'Syntax:\nCLONE clone_action\n\nclone_action: {\n    LOCAL DATA DIRECTORY [=] \'clone_dir\';\n  | INSTANCE FROM \'user\'@\'host\':port\n    IDENTIFIED BY \'password\'\n    [DATA DIRECTORY [=] \'clone_dir\']\n    [REQUIRE [NO] SSL]\n}\n\nThe CLONE statement is used to clone data locally or from a remote\nMySQL server instance. To use CLONE syntax, the clone plugin must be\ninstalled. See\nhttps://dev.mysql.com/doc/refman/8.0/en/clone-plugin.html.\n\nCLONE LOCAL DATA DIRECTORY syntax clones data from the local MySQL data\ndirectory to a directory on the same server or node where the MySQL\nserver instance runs. The \'clone_dir\' directory is the full path of the\nlocal directory that data is cloned to. An absolute path is required.\nThe specified directory must not exist, but the specified path must be\nan existent path. The MySQL server requires the necessary write access\nto create the specified directory. For more information, see\nhttps://dev.mysql.com/doc/refman/8.0/en/clone-plugin-local.html.\n\nCLONE INSTANCE syntax clones data from a remote MySQL server instance\n(the donor) and transfers it to the MySQL instance where the cloning\noperation was initiated (the recipient).\n\no user is the clone user on the donor MySQL server instance.\n\no host is the hostname address of the donor MySQL server instance.\n  Internet Protocol version 6 (IPv6) address format is not supported.\n  An alias to the IPv6 address can be used instead. An IPv4 address can\n  be used as is.\n\no port is the port number of the donor MySQL server instance. (The X\n  Protocol port specified by mysqlx_port is not supported. Connecting\n  to the donor MySQL server instance through MySQL Router is also not\n  supported.)\n\no IDENTIFIED BY \'password\' specifies the password of the clone user on\n  the donor MySQL server instance.\n\no DATA DIRECTORY [=] \'clone_dir\' is an optional clause used to specify\n  a directory on the recipient for the data you are cloning. Use this\n  option if you do not want to remove existing data in the recipient\n  data directory. An absolute path is required, and the directory must\n  not exist. The MySQL server must have the necessary write access to\n  create the directory.\n\n  When the optional DATA DIRECTORY [=] \'clone_dir\' clause is not used,\n  a cloning operation removes existing data in the recipient data\n  directory, replaces it with the cloned data, and automatically\n  restarts the server afterward.\n\no [REQUIRE [NO] SSL] explicitly specifies whether an encrypted\n  connection is to be used or not when transferring cloned data over\n  the network. An error is returned if the explicit specification\n  cannot be satisfied. If an SSL clause is not specified, clone\n  attempts to establish an encrypted connection by default, falling\n  back to an insecure connection if the secure connection attempt\n  fails. A secure connection is required when cloning encrypted data\n  regardless of whether this clause is specified. For more information,\n  see\n  https://dev.mysql.com/doc/refman/8.0/en/clone-plugin-remote.html#clon\n  e-plugin-remote-ssl.\n\nFor additional information about cloning data from a remote MySQL\nserver instance, see\nhttps://dev.mysql.com/doc/refman/8.0/en/clone-plugin-remote.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/clone.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/clone.html'),(637,'SET',3,'Syntax:\nSET variable = expr [, variable = expr] ...\n\nvariable: {\n    user_var_name\n  | param_name\n  | local_var_name\n  | {GLOBAL | @@GLOBAL.} system_var_name\n  | {PERSIST | @@PERSIST.} system_var_name\n  | {PERSIST_ONLY | @@PERSIST_ONLY.} system_var_name\n  | [SESSION | @@SESSION. | @@] system_var_name\n}\n\nSET syntax for variable assignment enables you to assign values to\ndifferent types of variables that affect the operation of the server or\nclients:\n\no User-defined variables. See\n  https://dev.mysql.com/doc/refman/8.0/en/user-variables.html.\n\no Stored procedure and function parameters, and stored program local\n  variables. See\n  https://dev.mysql.com/doc/refman/8.0/en/stored-program-variables.html\n  .\n\no System variables. See\n  https://dev.mysql.com/doc/refman/8.0/en/server-system-variables.html.\n  System variables also can be set at server startup, as described in\n  https://dev.mysql.com/doc/refman/8.0/en/using-system-variables.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/set-variable.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/set-variable.html'),(638,'SET CHARACTER SET',3,'Syntax:\nSET {CHARACTER SET | CHARSET}\n    {\'charset_name\' | DEFAULT}\n\nThis statement maps all strings sent between the server and the current\nclient with the given mapping. SET CHARACTER SET sets three session\nsystem variables: character_set_client and character_set_results are\nset to the given character set, and character_set_connection to the\nvalue of character_set_database. See\nhttps://dev.mysql.com/doc/refman/8.0/en/charset-connection.html.\n\ncharset_name may be quoted or unquoted.\n\nThe default character set mapping can be restored by using the value\nDEFAULT. The default depends on the server configuration.\n\nSome character sets cannot be used as the client character set.\nAttempting to use them with SET CHARACTER SET produces an error. See\nhttps://dev.mysql.com/doc/refman/8.0/en/charset-connection.html#charset\n-connection-impermissible-client-charset.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/set-character-set.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/set-character-set.html'),(639,'SET CHARSET',3,'Syntax:\nSET {CHARACTER SET | CHARSET}\n    {\'charset_name\' | DEFAULT}\n\nThis statement maps all strings sent between the server and the current\nclient with the given mapping. SET CHARACTER SET sets three session\nsystem variables: character_set_client and character_set_results are\nset to the given character set, and character_set_connection to the\nvalue of character_set_database. See\nhttps://dev.mysql.com/doc/refman/8.0/en/charset-connection.html.\n\ncharset_name may be quoted or unquoted.\n\nThe default character set mapping can be restored by using the value\nDEFAULT. The default depends on the server configuration.\n\nSome character sets cannot be used as the client character set.\nAttempting to use them with SET CHARACTER SET produces an error. See\nhttps://dev.mysql.com/doc/refman/8.0/en/charset-connection.html#charset\n-connection-impermissible-client-charset.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/set-character-set.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/set-character-set.html'),(640,'SET NAMES',3,'Syntax:\nSET NAMES {\'charset_name\'\n    [COLLATE \'collation_name\'] | DEFAULT}\n\nThis statement sets the three session system variables\ncharacter_set_client, character_set_connection, and\ncharacter_set_results to the given character set. Setting\ncharacter_set_connection to charset_name also sets collation_connection\nto the default collation for charset_name. See\nhttps://dev.mysql.com/doc/refman/8.0/en/charset-connection.html.\n\nThe optional COLLATE clause may be used to specify a collation\nexplicitly. If given, the collation must one of the permitted\ncollations for charset_name.\n\ncharset_name and collation_name may be quoted or unquoted.\n\nThe default mapping can be restored by using a value of DEFAULT. The\ndefault depends on the server configuration.\n\nSome character sets cannot be used as the client character set.\nAttempting to use them with SET NAMES produces an error. See\nhttps://dev.mysql.com/doc/refman/8.0/en/charset-connection.html#charset\n-connection-impermissible-client-charset.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/set-names.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/set-names.html'),(641,'SHOW',3,'SHOW has many forms that provide information about databases, tables,\ncolumns, or status information about the server. This section describes\nthose following:\n\nSHOW {BINARY | MASTER} LOGS\nSHOW BINLOG EVENTS [IN \'log_name\'] [FROM pos] [LIMIT [offset,] row_count]\nSHOW {CHARACTER SET | CHARSET} [like_or_where]\nSHOW COLLATION [like_or_where]\nSHOW [FULL] COLUMNS FROM tbl_name [FROM db_name] [like_or_where]\nSHOW CREATE DATABASE db_name\nSHOW CREATE EVENT event_name\nSHOW CREATE FUNCTION func_name\nSHOW CREATE PROCEDURE proc_name\nSHOW CREATE TABLE tbl_name\nSHOW CREATE TRIGGER trigger_name\nSHOW CREATE VIEW view_name\nSHOW DATABASES [like_or_where]\nSHOW ENGINE engine_name {STATUS | MUTEX}\nSHOW [STORAGE] ENGINES\nSHOW ERRORS [LIMIT [offset,] row_count]\nSHOW EVENTS\nSHOW FUNCTION CODE func_name\nSHOW FUNCTION STATUS [like_or_where]\nSHOW GRANTS FOR user\nSHOW INDEX FROM tbl_name [FROM db_name]\nSHOW MASTER STATUS\nSHOW OPEN TABLES [FROM db_name] [like_or_where]\nSHOW PLUGINS\nSHOW PROCEDURE CODE proc_name\nSHOW PROCEDURE STATUS [like_or_where]\nSHOW PRIVILEGES\nSHOW [FULL] PROCESSLIST\nSHOW PROFILE [types] [FOR QUERY n] [OFFSET n] [LIMIT n]\nSHOW PROFILES\nSHOW RELAYLOG EVENTS [IN \'log_name\'] [FROM pos] [LIMIT [offset,] row_count]\nSHOW {REPLICAS | SLAVE HOSTS}\nSHOW {REPLICA | SLAVE} STATUS [FOR CHANNEL channel]\nSHOW [GLOBAL | SESSION] STATUS [like_or_where]\nSHOW TABLE STATUS [FROM db_name] [like_or_where]\nSHOW [FULL] TABLES [FROM db_name] [like_or_where]\nSHOW TRIGGERS [FROM db_name] [like_or_where]\nSHOW [GLOBAL | SESSION] VARIABLES [like_or_where]\nSHOW WARNINGS [LIMIT [offset,] row_count]\n\nlike_or_where: {\n    LIKE \'pattern\'\n  | WHERE expr\n}\n\nIf the syntax for a given SHOW statement includes a LIKE \'pattern\'\npart, \'pattern\' is a string that can contain the SQL % and _ wildcard\ncharacters. The pattern is useful for restricting statement output to\nmatching values.\n\nSeveral SHOW statements also accept a WHERE clause that provides more\nflexibility in specifying which rows to display. See\nhttps://dev.mysql.com/doc/refman/8.0/en/extended-show.html.\n\nIn SHOW statement results, user names and host names are quoted using\nbackticks (`).\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/show.html'),(642,'SHOW BINARY LOGS',3,'Syntax:\nSHOW BINARY LOGS\nSHOW MASTER LOGS\n\nLists the binary log files on the server. This statement is used as\npart of the procedure described in [HELP PURGE BINARY LOGS], that shows\nhow to determine which logs can be purged. SHOW BINARY LOGS requires\nthe REPLICATION CLIENT privilege (or the deprecated SUPER privilege).\n\nEncrypted binary log files have a 512-byte file header that stores\ninformation required for encryption and decryption of the file. This is\nincluded in the file size displayed by SHOW BINARY LOGS. The Encrypted\ncolumn shows whether or not the binary log file is encrypted. Binary\nlog encryption is active if binlog_encryption=ON is set for the server.\nExisting binary log files are not encrypted or decrypted if binary log\nencryption is activated or deactivated while the server is running.\n\nmysql> SHOW BINARY LOGS;\n+---------------+-----------+-----------+\n| Log_name      | File_size | Encrypted |\n+---------------+-----------+-----------+\n| binlog.000015 |    724935 |       Yes |\n| binlog.000016 |    733481 |       Yes |\n+---------------+-----------+-----------+\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-binary-logs.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/show-binary-logs.html'),(643,'SHOW MASTER LOGS',3,'Syntax:\nSHOW BINARY LOGS\nSHOW MASTER LOGS\n\nLists the binary log files on the server. This statement is used as\npart of the procedure described in [HELP PURGE BINARY LOGS], that shows\nhow to determine which logs can be purged. SHOW BINARY LOGS requires\nthe REPLICATION CLIENT privilege (or the deprecated SUPER privilege).\n\nEncrypted binary log files have a 512-byte file header that stores\ninformation required for encryption and decryption of the file. This is\nincluded in the file size displayed by SHOW BINARY LOGS. The Encrypted\ncolumn shows whether or not the binary log file is encrypted. Binary\nlog encryption is active if binlog_encryption=ON is set for the server.\nExisting binary log files are not encrypted or decrypted if binary log\nencryption is activated or deactivated while the server is running.\n\nmysql> SHOW BINARY LOGS;\n+---------------+-----------+-----------+\n| Log_name      | File_size | Encrypted |\n+---------------+-----------+-----------+\n| binlog.000015 |    724935 |       Yes |\n| binlog.000016 |    733481 |       Yes |\n+---------------+-----------+-----------+\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-binary-logs.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/show-binary-logs.html'),(644,'SHOW BINLOG EVENTS',3,'Syntax:\nSHOW BINLOG EVENTS\n   [IN \'log_name\']\n   [FROM pos]\n   [LIMIT [offset,] row_count]\n\nShows the events in the binary log. If you do not specify \'log_name\',\nthe first binary log is displayed. SHOW BINLOG EVENTS requires the\nREPLICATION SLAVE privilege.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-binlog-events.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/show-binlog-events.html'),(645,'SHOW CHARACTER SET',3,'Syntax:\nSHOW {CHARACTER SET | CHARSET}\n    [LIKE \'pattern\' | WHERE expr]\n\nThe SHOW CHARACTER SET statement shows all available character sets.\nThe LIKE clause, if present, indicates which character set names to\nmatch. The WHERE clause can be given to select rows using more general\nconditions, as discussed in\nhttps://dev.mysql.com/doc/refman/8.0/en/extended-show.html. For\nexample:\n\nmysql> SHOW CHARACTER SET LIKE \'latin%\';\n+---------+-----------------------------+-------------------+--------+\n| Charset | Description                 | Default collation | Maxlen |\n+---------+-----------------------------+-------------------+--------+\n| latin1  | cp1252 West European        | latin1_swedish_ci |      1 |\n| latin2  | ISO 8859-2 Central European | latin2_general_ci |      1 |\n| latin5  | ISO 8859-9 Turkish          | latin5_turkish_ci |      1 |\n| latin7  | ISO 8859-13 Baltic          | latin7_general_ci |      1 |\n+---------+-----------------------------+-------------------+--------+\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-character-set.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/show-character-set.html'),(646,'SHOW COLLATION',3,'Syntax:\nSHOW COLLATION\n    [LIKE \'pattern\' | WHERE expr]\n\nThis statement lists collations supported by the server. By default,\nthe output from SHOW COLLATION includes all available collations. The\nLIKE clause, if present, indicates which collation names to match. The\nWHERE clause can be given to select rows using more general conditions,\nas discussed in\nhttps://dev.mysql.com/doc/refman/8.0/en/extended-show.html. For\nexample:\n\nmysql> SHOW COLLATION WHERE Charset = \'latin1\';\n+-------------------+---------+----+---------+----------+---------+\n| Collation         | Charset | Id | Default | Compiled | Sortlen |\n+-------------------+---------+----+---------+----------+---------+\n| latin1_german1_ci | latin1  |  5 |         | Yes      |       1 |\n| latin1_swedish_ci | latin1  |  8 | Yes     | Yes      |       1 |\n| latin1_danish_ci  | latin1  | 15 |         | Yes      |       1 |\n| latin1_german2_ci | latin1  | 31 |         | Yes      |       2 |\n| latin1_bin        | latin1  | 47 |         | Yes      |       1 |\n| latin1_general_ci | latin1  | 48 |         | Yes      |       1 |\n| latin1_general_cs | latin1  | 49 |         | Yes      |       1 |\n| latin1_spanish_ci | latin1  | 94 |         | Yes      |       1 |\n+-------------------+---------+----+---------+----------+---------+\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-collation.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/show-collation.html'),(647,'SHOW COLUMNS',3,'Syntax:\nSHOW [EXTENDED] [FULL] {COLUMNS | FIELDS}\n    {FROM | IN} tbl_name\n    [{FROM | IN} db_name]\n    [LIKE \'pattern\' | WHERE expr]\n\nSHOW COLUMNS displays information about the columns in a given table.\nIt also works for views. SHOW COLUMNS displays information only for\nthose columns for which you have some privilege.\n\nmysql> SHOW COLUMNS FROM City;\n+-------------+----------+------+-----+---------+----------------+\n| Field       | Type     | Null | Key | Default | Extra          |\n+-------------+----------+------+-----+---------+----------------+\n| ID          | int(11)  | NO   | PRI | NULL    | auto_increment |\n| Name        | char(35) | NO   |     |         |                |\n| CountryCode | char(3)  | NO   | MUL |         |                |\n| District    | char(20) | NO   |     |         |                |\n| Population  | int(11)  | NO   |     | 0       |                |\n+-------------+----------+------+-----+---------+----------------+\n\nAn alternative to tbl_name FROM db_name syntax is db_name.tbl_name.\nThese two statements are equivalent:\n\nSHOW COLUMNS FROM mytable FROM mydb;\nSHOW COLUMNS FROM mydb.mytable;\n\nThe optional EXTENDED keyword causes the output to include information\nabout hidden columns that MySQL uses internally and are not accessible\nby users.\n\nThe optional FULL keyword causes the output to include the column\ncollation and comments, as well as the privileges you have for each\ncolumn.\n\nThe LIKE clause, if present, indicates which column names to match. The\nWHERE clause can be given to select rows using more general conditions,\nas discussed in\nhttps://dev.mysql.com/doc/refman/8.0/en/extended-show.html.\n\nThe data types may differ from what you expect them to be based on a\nCREATE TABLE statement because MySQL sometimes changes data types when\nyou create or alter a table. The conditions under which this occurs are\ndescribed in\nhttps://dev.mysql.com/doc/refman/8.0/en/silent-column-changes.html.\n\nSHOW COLUMNS displays the following values for each table column:\n\no Field\n\n  The name of the column.\n\no Type\n\n  The column data type.\n\no Collation\n\n  The collation for nonbinary string columns, or NULL for other\n  columns. This value is displayed only if you use the FULL keyword.\n\no Null\n\n  The column nullability. The value is YES if NULL values can be stored\n  in the column, NO if not.\n\no Key\n\n  Whether the column is indexed:\n\n  o If Key is empty, the column either is not indexed or is indexed\n    only as a secondary column in a multiple-column, nonunique index.\n\n  o If Key is PRI, the column is a PRIMARY KEY or is one of the columns\n    in a multiple-column PRIMARY KEY.\n\n  o If Key is UNI, the column is the first column of a UNIQUE index. (A\n    UNIQUE index permits multiple NULL values, but you can tell whether\n    the column permits NULL by checking the Null field.)\n\n  o If Key is MUL, the column is the first column of a nonunique index\n    in which multiple occurrences of a given value are permitted within\n    the column.\n\n  If more than one of the Key values applies to a given column of a\n  table, Key displays the one with the highest priority, in the order\n  PRI, UNI, MUL.\n\n  A UNIQUE index may be displayed as PRI if it cannot contain NULL\n  values and there is no PRIMARY KEY in the table. A UNIQUE index may\n  display as MUL if several columns form a composite UNIQUE index;\n  although the combination of the columns is unique, each column can\n  still hold multiple occurrences of a given value.\n\no Default\n\n  The default value for the column. This is NULL if the column has an\n  explicit default of NULL, or if the column definition includes no\n  DEFAULT clause.\n\no Extra\n\n  Any additional information that is available about a given column.\n  The value is nonempty in these cases:\n\n  o auto_increment for columns that have the AUTO_INCREMENT attribute.\n\n  o on update CURRENT_TIMESTAMP for TIMESTAMP or DATETIME columns that\n    have the ON UPDATE CURRENT_TIMESTAMP attribute.\n\n  o VIRTUAL GENERATED or STORED GENERATED for generated columns.\n\n  o DEFAULT_GENERATED for columns that have an expression default\n    value.\n\no Privileges\n\n  The privileges you have for the column. This value is displayed only\n  if you use the FULL keyword.\n\no Comment\n\n  Any comment included in the column definition. This value is\n  displayed only if you use the FULL keyword.\n\nTable column information is also available from the INFORMATION_SCHEMA\nCOLUMNS table. See\nhttps://dev.mysql.com/doc/refman/8.0/en/information-schema-columns-tabl\ne.html. The extended information about hidden columns is available only\nusing SHOW EXTENDED COLUMNS; it cannot be obtained from the COLUMNS\ntable.\n\nYou can list a table\'s columns with the mysqlshow db_name tbl_name\ncommand.\n\nThe DESCRIBE statement provides information similar to SHOW COLUMNS.\nSee https://dev.mysql.com/doc/refman/8.0/en/describe.html.\n\nThe SHOW CREATE TABLE, SHOW TABLE STATUS, and SHOW INDEX statements\nalso provide information about tables. See [HELP SHOW].\n\nIn MySQL 8.0.30 and later, SHOW COLUMNS includes the table\'s generated\ninvisible primary key, if it has one, by default. You can cause this\ninformation to be suppressed in the statement\'s output by setting\nshow_gipk_in_create_table_and_information_schema = OFF. For more\ninformation, see\nhttps://dev.mysql.com/doc/refman/8.0/en/create-table-gipks.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-columns.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/show-columns.html'),(648,'SHOW FIELDS',3,'Syntax:\nSHOW [EXTENDED] [FULL] {COLUMNS | FIELDS}\n    {FROM | IN} tbl_name\n    [{FROM | IN} db_name]\n    [LIKE \'pattern\' | WHERE expr]\n\nSHOW COLUMNS displays information about the columns in a given table.\nIt also works for views. SHOW COLUMNS displays information only for\nthose columns for which you have some privilege.\n\nmysql> SHOW COLUMNS FROM City;\n+-------------+----------+------+-----+---------+----------------+\n| Field       | Type     | Null | Key | Default | Extra          |\n+-------------+----------+------+-----+---------+----------------+\n| ID          | int(11)  | NO   | PRI | NULL    | auto_increment |\n| Name        | char(35) | NO   |     |         |                |\n| CountryCode | char(3)  | NO   | MUL |         |                |\n| District    | char(20) | NO   |     |         |                |\n| Population  | int(11)  | NO   |     | 0       |                |\n+-------------+----------+------+-----+---------+----------------+\n\nAn alternative to tbl_name FROM db_name syntax is db_name.tbl_name.\nThese two statements are equivalent:\n\nSHOW COLUMNS FROM mytable FROM mydb;\nSHOW COLUMNS FROM mydb.mytable;\n\nThe optional EXTENDED keyword causes the output to include information\nabout hidden columns that MySQL uses internally and are not accessible\nby users.\n\nThe optional FULL keyword causes the output to include the column\ncollation and comments, as well as the privileges you have for each\ncolumn.\n\nThe LIKE clause, if present, indicates which column names to match. The\nWHERE clause can be given to select rows using more general conditions,\nas discussed in\nhttps://dev.mysql.com/doc/refman/8.0/en/extended-show.html.\n\nThe data types may differ from what you expect them to be based on a\nCREATE TABLE statement because MySQL sometimes changes data types when\nyou create or alter a table. The conditions under which this occurs are\ndescribed in\nhttps://dev.mysql.com/doc/refman/8.0/en/silent-column-changes.html.\n\nSHOW COLUMNS displays the following values for each table column:\n\no Field\n\n  The name of the column.\n\no Type\n\n  The column data type.\n\no Collation\n\n  The collation for nonbinary string columns, or NULL for other\n  columns. This value is displayed only if you use the FULL keyword.\n\no Null\n\n  The column nullability. The value is YES if NULL values can be stored\n  in the column, NO if not.\n\no Key\n\n  Whether the column is indexed:\n\n  o If Key is empty, the column either is not indexed or is indexed\n    only as a secondary column in a multiple-column, nonunique index.\n\n  o If Key is PRI, the column is a PRIMARY KEY or is one of the columns\n    in a multiple-column PRIMARY KEY.\n\n  o If Key is UNI, the column is the first column of a UNIQUE index. (A\n    UNIQUE index permits multiple NULL values, but you can tell whether\n    the column permits NULL by checking the Null field.)\n\n  o If Key is MUL, the column is the first column of a nonunique index\n    in which multiple occurrences of a given value are permitted within\n    the column.\n\n  If more than one of the Key values applies to a given column of a\n  table, Key displays the one with the highest priority, in the order\n  PRI, UNI, MUL.\n\n  A UNIQUE index may be displayed as PRI if it cannot contain NULL\n  values and there is no PRIMARY KEY in the table. A UNIQUE index may\n  display as MUL if several columns form a composite UNIQUE index;\n  although the combination of the columns is unique, each column can\n  still hold multiple occurrences of a given value.\n\no Default\n\n  The default value for the column. This is NULL if the column has an\n  explicit default of NULL, or if the column definition includes no\n  DEFAULT clause.\n\no Extra\n\n  Any additional information that is available about a given column.\n  The value is nonempty in these cases:\n\n  o auto_increment for columns that have the AUTO_INCREMENT attribute.\n\n  o on update CURRENT_TIMESTAMP for TIMESTAMP or DATETIME columns that\n    have the ON UPDATE CURRENT_TIMESTAMP attribute.\n\n  o VIRTUAL GENERATED or STORED GENERATED for generated columns.\n\n  o DEFAULT_GENERATED for columns that have an expression default\n    value.\n\no Privileges\n\n  The privileges you have for the column. This value is displayed only\n  if you use the FULL keyword.\n\no Comment\n\n  Any comment included in the column definition. This value is\n  displayed only if you use the FULL keyword.\n\nTable column information is also available from the INFORMATION_SCHEMA\nCOLUMNS table. See\nhttps://dev.mysql.com/doc/refman/8.0/en/information-schema-columns-tabl\ne.html. The extended information about hidden columns is available only\nusing SHOW EXTENDED COLUMNS; it cannot be obtained from the COLUMNS\ntable.\n\nYou can list a table\'s columns with the mysqlshow db_name tbl_name\ncommand.\n\nThe DESCRIBE statement provides information similar to SHOW COLUMNS.\nSee https://dev.mysql.com/doc/refman/8.0/en/describe.html.\n\nThe SHOW CREATE TABLE, SHOW TABLE STATUS, and SHOW INDEX statements\nalso provide information about tables. See [HELP SHOW].\n\nIn MySQL 8.0.30 and later, SHOW COLUMNS includes the table\'s generated\ninvisible primary key, if it has one, by default. You can cause this\ninformation to be suppressed in the statement\'s output by setting\nshow_gipk_in_create_table_and_information_schema = OFF. For more\ninformation, see\nhttps://dev.mysql.com/doc/refman/8.0/en/create-table-gipks.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-columns.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/show-columns.html'),(649,'SHOW CREATE DATABASE',3,'Syntax:\nSHOW CREATE {DATABASE | SCHEMA} [IF NOT EXISTS] db_name\n\nShows the CREATE DATABASE statement that creates the named database. If\nthe SHOW statement includes an IF NOT EXISTS clause, the output too\nincludes such a clause. SHOW CREATE SCHEMA is a synonym for SHOW CREATE\nDATABASE.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-create-database.html\n\n','mysql> SHOW CREATE DATABASE test\\G\n*************************** 1. row ***************************\n       Database: test\nCreate Database: CREATE DATABASE `test` /*!40100 DEFAULT CHARACTER SET utf8mb4\n                 COLLATE utf8mb4_0900_ai_ci */ /*!80014 DEFAULT ENCRYPTION=\'N\' */\n\nmysql> SHOW CREATE SCHEMA test\\G\n*************************** 1. row ***************************\n       Database: test\nCreate Database: CREATE DATABASE `test` /*!40100 DEFAULT CHARACTER SET utf8mb4\n                 COLLATE utf8mb4_0900_ai_ci */ /*!80014 DEFAULT ENCRYPTION=\'N\' */\n','https://dev.mysql.com/doc/refman/8.0/en/show-create-database.html'),(650,'SHOW CREATE SCHEMA',3,'Syntax:\nSHOW CREATE {DATABASE | SCHEMA} [IF NOT EXISTS] db_name\n\nShows the CREATE DATABASE statement that creates the named database. If\nthe SHOW statement includes an IF NOT EXISTS clause, the output too\nincludes such a clause. SHOW CREATE SCHEMA is a synonym for SHOW CREATE\nDATABASE.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-create-database.html\n\n','mysql> SHOW CREATE DATABASE test\\G\n*************************** 1. row ***************************\n       Database: test\nCreate Database: CREATE DATABASE `test` /*!40100 DEFAULT CHARACTER SET utf8mb4\n                 COLLATE utf8mb4_0900_ai_ci */ /*!80014 DEFAULT ENCRYPTION=\'N\' */\n\nmysql> SHOW CREATE SCHEMA test\\G\n*************************** 1. row ***************************\n       Database: test\nCreate Database: CREATE DATABASE `test` /*!40100 DEFAULT CHARACTER SET utf8mb4\n                 COLLATE utf8mb4_0900_ai_ci */ /*!80014 DEFAULT ENCRYPTION=\'N\' */\n','https://dev.mysql.com/doc/refman/8.0/en/show-create-database.html'),(651,'SHOW CREATE EVENT',3,'Syntax:\nSHOW CREATE EVENT event_name\n\nThis statement displays the CREATE EVENT statement needed to re-create\na given event. It requires the EVENT privilege for the database from\nwhich the event is to be shown. For example (using the same event\ne_daily defined and then altered in [HELP SHOW EVENTS]):\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-create-event.html\n\n','mysql> SHOW CREATE EVENT myschema.e_daily\\G\n*************************** 1. row ***************************\n               Event: e_daily\n            sql_mode: ONLY_FULL_GROUP_BY,STRICT_TRANS_TABLES,\n                      NO_ZERO_IN_DATE,NO_ZERO_DATE,\n                      ERROR_FOR_DIVISION_BY_ZERO,\n                      NO_ENGINE_SUBSTITUTION\n           time_zone: SYSTEM\n        Create Event: CREATE DEFINER=`jon`@`ghidora` EVENT `e_daily`\n                        ON SCHEDULE EVERY 1 DAY\n                        STARTS CURRENT_TIMESTAMP + INTERVAL 6 HOUR\n                        ON COMPLETION NOT PRESERVE\n                        ENABLE\n                        COMMENT \'Saves total number of sessions then\n                                clears the table each day\'\n                        DO BEGIN\n                          INSERT INTO site_activity.totals (time, total)\n                            SELECT CURRENT_TIMESTAMP, COUNT(*)\n                              FROM site_activity.sessions;\n                          DELETE FROM site_activity.sessions;\n                        END\ncharacter_set_client: utf8mb4\ncollation_connection: utf8mb4_0900_ai_ci\n  Database Collation: utf8mb4_0900_ai_ci\n','https://dev.mysql.com/doc/refman/8.0/en/show-create-event.html'),(652,'SHOW CREATE FUNCTION',3,'Syntax:\nSHOW CREATE FUNCTION func_name\n\nThis statement is similar to SHOW CREATE PROCEDURE but for stored\nfunctions. See [HELP SHOW CREATE PROCEDURE].\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-create-function.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/show-create-function.html'),(653,'SHOW CREATE PROCEDURE',3,'Syntax:\nSHOW CREATE PROCEDURE proc_name\n\nThis statement is a MySQL extension. It returns the exact string that\ncan be used to re-create the named stored procedure. A similar\nstatement, SHOW CREATE FUNCTION, displays information about stored\nfunctions (see [HELP SHOW CREATE FUNCTION]).\n\nTo use either statement, you must be the user named as the routine\nDEFINER, have the SHOW_ROUTINE privilege, have the SELECT privilege at\nthe global level, or have the CREATE ROUTINE, ALTER ROUTINE, or EXECUTE\nprivilege granted at a scope that includes the routine. The value\ndisplayed for the Create Procedure or Create Function field is NULL if\nyou have only CREATE ROUTINE, ALTER ROUTINE, or EXECUTE.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-create-procedure.html\n\n','mysql> SHOW CREATE PROCEDURE test.citycount\\G\n*************************** 1. row ***************************\n           Procedure: citycount\n            sql_mode: ONLY_FULL_GROUP_BY,STRICT_TRANS_TABLES,\n                      NO_ZERO_IN_DATE,NO_ZERO_DATE,\n                      ERROR_FOR_DIVISION_BY_ZERO,\n                      NO_ENGINE_SUBSTITUTION\n    Create Procedure: CREATE DEFINER=`me`@`localhost`\n                      PROCEDURE `citycount`(IN country CHAR(3), OUT cities INT)\n                      BEGIN\n                        SELECT COUNT(*) INTO cities FROM world.city\n                        WHERE CountryCode = country;\n                      END\ncharacter_set_client: utf8mb4\ncollation_connection: utf8mb4_0900_ai_ci\n  Database Collation: utf8mb4_0900_ai_ci\n\nmysql> SHOW CREATE FUNCTION test.hello\\G\n*************************** 1. row ***************************\n            Function: hello\n            sql_mode: ONLY_FULL_GROUP_BY,STRICT_TRANS_TABLES,\n                      NO_ZERO_IN_DATE,NO_ZERO_DATE,\n                      ERROR_FOR_DIVISION_BY_ZERO,\n                      NO_ENGINE_SUBSTITUTION\n     Create Function: CREATE DEFINER=`me`@`localhost`\n                      FUNCTION `hello`(s CHAR(20))\n                      RETURNS char(50) CHARSET utf8mb4\n                      DETERMINISTIC\n                      RETURN CONCAT(\'Hello, \',s,\'!\')\ncharacter_set_client: utf8mb4\ncollation_connection: utf8mb4_0900_ai_ci\n  Database Collation: utf8mb4_0900_ai_ci\n','https://dev.mysql.com/doc/refman/8.0/en/show-create-procedure.html'),(654,'SHOW CREATE TABLE',3,'Syntax:\nSHOW CREATE TABLE tbl_name\n\nShows the CREATE TABLE statement that creates the named table. To use\nthis statement, you must have some privilege for the table. This\nstatement also works with views.\n\nAs of MySQL 8.0.16, MySQL implements CHECK constraints and SHOW CREATE\nTABLE displays them. All CHECK constraints are displayed as table\nconstraints. That is, a CHECK constraint originally specified as part\nof a column definition displays as a separate clause not part of the\ncolumn definition. Example:\n\nmysql> CREATE TABLE t1 (\n         i1 INT CHECK (i1 <> 0),      -- column constraint\n         i2 INT,\n         CHECK (i2 > i1),             -- table constraint\n         CHECK (i2 <> 0) NOT ENFORCED -- table constraint, not enforced\n       );\n\nmysql> SHOW CREATE TABLE t1\\G\n*************************** 1. row ***************************\n       Table: t1\nCreate Table: CREATE TABLE `t1` (\n  `i1` int DEFAULT NULL,\n  `i2` int DEFAULT NULL,\n  CONSTRAINT `t1_chk_1` CHECK ((`i1` <> 0)),\n  CONSTRAINT `t1_chk_2` CHECK ((`i2` > `i1`)),\n  CONSTRAINT `t1_chk_3` CHECK ((`i2` <> 0)) /*!80016 NOT ENFORCED */\n) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci\n\nSHOW CREATE TABLE quotes table and column names according to the value\nof the sql_quote_show_create option. See\nhttps://dev.mysql.com/doc/refman/8.0/en/server-system-variables.html.\n\nWhen altering the storage engine of a table, table options that are not\napplicable to the new storage engine are retained in the table\ndefinition to enable reverting the table with its previously defined\noptions to the original storage engine, if necessary. For example, when\nchanging the storage engine from InnoDB to MyISAM, options specific to\nInnoDB, such as ROW_FORMAT=COMPACT, are retained, as shown here:\n\nmysql> CREATE TABLE t1 (c1 INT PRIMARY KEY) ROW_FORMAT=COMPACT ENGINE=InnoDB;\nmysql> ALTER TABLE t1 ENGINE=MyISAM;\nmysql> SHOW CREATE TABLE t1\\G\n*************************** 1. row ***************************\n       Table: t1\nCreate Table: CREATE TABLE `t1` (\n  `c1` int NOT NULL,\n  PRIMARY KEY (`c1`)\n) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci ROW_FORMAT=COMPACT\n\nWhen creating a table with strict mode disabled, the storage engine\'s\ndefault row format is used if the specified row format is not\nsupported. The actual row format of the table is reported in the\nRow_format column in response to SHOW TABLE STATUS. SHOW CREATE TABLE\nshows the row format that was specified in the CREATE TABLE statement.\n\nIn MySQL 8.0.30 and later, SHOW CREATE TABLE includes the definition of\nthe table\'s generated invisible primary key, if it has such a key, by\ndefault. You can cause this information to be suppressed in the\nstatement\'s output by setting\nshow_gipk_in_create_table_and_information_schema = OFF. For more\ninformation, see\nhttps://dev.mysql.com/doc/refman/8.0/en/create-table-gipks.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-create-table.html\n\n','mysql> SHOW CREATE TABLE t\\G\n*************************** 1. row ***************************\n       Table: t\nCreate Table: CREATE TABLE `t` (\n  `id` int NOT NULL AUTO_INCREMENT,\n  `s` char(60) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci\n','https://dev.mysql.com/doc/refman/8.0/en/show-create-table.html'),(655,'SHOW CREATE TRIGGER',3,'Syntax:\nSHOW CREATE TRIGGER trigger_name\n\nThis statement shows the CREATE TRIGGER statement that creates the\nnamed trigger. This statement requires the TRIGGER privilege for the\ntable associated with the trigger.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-create-trigger.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/show-create-trigger.html'),(656,'SHOW CREATE USER',3,'Syntax:\nSHOW CREATE USER user\n\nThis statement shows the CREATE USER statement that creates the named\nuser. An error occurs if the user does not exist. The statement\nrequires the SELECT privilege for the mysql system schema, except to\nsee information for the current user. For the current user, the SELECT\nprivilege for the mysql.user system table is required for display of\nthe password hash in the IDENTIFIED AS clause; otherwise, the hash\ndisplays as <secret>.\n\nTo name the account, use the format described in\nhttps://dev.mysql.com/doc/refman/8.0/en/account-names.html. The host\nname part of the account name, if omitted, defaults to \'%\'. It is also\npossible to specify CURRENT_USER or CURRENT_USER() to refer to the\naccount associated with the current session.\n\nPassword hash values displayed in the IDENTIFIED WITH clause of output\nfrom SHOW CREATE USER may contain unprintable characters that have\nadverse effects on terminal displays and in other environments.\nEnabling the print_identified_with_as_hex system variable (available as\nof MySQL 8.0.17) causes SHOW CREATE USER to display such hash values as\nhexadecimal strings rather than as regular string literals. Hash values\nthat do not contain unprintable characters still display as regular\nstring literals, even with this variable enabled.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-create-user.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/show-create-user.html'),(657,'SHOW CREATE VIEW',3,'Syntax:\nSHOW CREATE VIEW view_name\n\nThis statement shows the CREATE VIEW statement that creates the named\nview.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-create-view.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/show-create-view.html'),(658,'SHOW DATABASES',3,'Syntax:\nSHOW {DATABASES | SCHEMAS}\n    [LIKE \'pattern\' | WHERE expr]\n\nSHOW DATABASES lists the databases on the MySQL server host. SHOW\nSCHEMAS is a synonym for SHOW DATABASES. The LIKE clause, if present,\nindicates which database names to match. The WHERE clause can be given\nto select rows using more general conditions, as discussed in\nhttps://dev.mysql.com/doc/refman/8.0/en/extended-show.html.\n\nYou see only those databases for which you have some kind of privilege,\nunless you have the global SHOW DATABASES privilege. You can also get\nthis list using the mysqlshow command.\n\nIf the server was started with the --skip-show-database option, you\ncannot use this statement at all unless you have the SHOW DATABASES\nprivilege.\n\nMySQL implements databases as directories in the data directory, so\nthis statement simply lists directories in that location. However, the\noutput may include names of directories that do not correspond to\nactual databases.\n\nDatabase information is also available from the INFORMATION_SCHEMA\nSCHEMATA table. See\nhttps://dev.mysql.com/doc/refman/8.0/en/information-schema-schemata-tab\nle.html.\n\n*Caution*:\n\nBecause any static global privilege is considered a privilege for all\ndatabases, any static global privilege enables a user to see all\ndatabase names with SHOW DATABASES or by examining the SCHEMATA table\nof INFORMATION_SCHEMA, except databases that have been restricted at\nthe database level by partial revokes.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-databases.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/show-databases.html'),(659,'SHOW SCHEMAS',3,'Syntax:\nSHOW {DATABASES | SCHEMAS}\n    [LIKE \'pattern\' | WHERE expr]\n\nSHOW DATABASES lists the databases on the MySQL server host. SHOW\nSCHEMAS is a synonym for SHOW DATABASES. The LIKE clause, if present,\nindicates which database names to match. The WHERE clause can be given\nto select rows using more general conditions, as discussed in\nhttps://dev.mysql.com/doc/refman/8.0/en/extended-show.html.\n\nYou see only those databases for which you have some kind of privilege,\nunless you have the global SHOW DATABASES privilege. You can also get\nthis list using the mysqlshow command.\n\nIf the server was started with the --skip-show-database option, you\ncannot use this statement at all unless you have the SHOW DATABASES\nprivilege.\n\nMySQL implements databases as directories in the data directory, so\nthis statement simply lists directories in that location. However, the\noutput may include names of directories that do not correspond to\nactual databases.\n\nDatabase information is also available from the INFORMATION_SCHEMA\nSCHEMATA table. See\nhttps://dev.mysql.com/doc/refman/8.0/en/information-schema-schemata-tab\nle.html.\n\n*Caution*:\n\nBecause any static global privilege is considered a privilege for all\ndatabases, any static global privilege enables a user to see all\ndatabase names with SHOW DATABASES or by examining the SCHEMATA table\nof INFORMATION_SCHEMA, except databases that have been restricted at\nthe database level by partial revokes.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-databases.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/show-databases.html'),(660,'SHOW ENGINE',3,'Syntax:\nSHOW ENGINE engine_name {STATUS | MUTEX}\n\nSHOW ENGINE displays operational information about a storage engine. It\nrequires the PROCESS privilege. The statement has these variants:\n\nSHOW ENGINE INNODB STATUS\nSHOW ENGINE INNODB MUTEX\nSHOW ENGINE PERFORMANCE_SCHEMA STATUS\n\nSHOW ENGINE INNODB STATUS displays extensive information from the\nstandard InnoDB Monitor about the state of the InnoDB storage engine.\nFor information about the standard monitor and other InnoDB Monitors\nthat provide information about InnoDB processing, see\nhttps://dev.mysql.com/doc/refman/8.0/en/innodb-monitors.html.\n\nSHOW ENGINE INNODB MUTEX displays InnoDB mutex and rw-lock statistics.\n\n*Note*:\n\nInnoDB mutexes and rwlocks can also be monitored using Performance\nSchema tables. See\nhttps://dev.mysql.com/doc/refman/8.0/en/monitor-innodb-mutex-waits-perf\normance-schema.html.\n\nMutex statistics collection is configured dynamically using the\nfollowing options:\n\no To enable the collection of mutex statistics, run:\n\nSET GLOBAL innodb_monitor_enable=\'latch\';\n\no To reset mutex statistics, run:\n\nSET GLOBAL innodb_monitor_reset=\'latch\';\n\no To disable the collection of mutex statistics, run:\n\nSET GLOBAL innodb_monitor_disable=\'latch\';\n\nCollection of mutex statistics for SHOW ENGINE INNODB MUTEX can also be\nenabled by setting innodb_monitor_enable=\'all\', or disabled by setting\ninnodb_monitor_disable=\'all\'.\n\nSHOW ENGINE INNODB MUTEX output has these columns:\n\no Type\n\n  Always InnoDB.\n\no Name\n\n  For mutexes, the Name field reports only the mutex name. For rwlocks,\n  the Name field reports the source file where the rwlock is\n  implemented, and the line number in the file where the rwlock is\n  created. The line number is specific to your version of MySQL.\n\no Status\n\n  The mutex status. This field reports the number of spins, waits, and\n  calls. Statistics for low-level operating system mutexes, which are\n  implemented outside of InnoDB, are not reported.\n\n  o spins indicates the number of spins.\n\n  o waits indicates the number of mutex waits.\n\n  o calls indicates how many times the mutex was requested.\n\nSHOW ENGINE INNODB MUTEX does not list mutexes and rw-locks for each\nbuffer pool block, as the amount of output would be overwhelming on\nsystems with a large buffer pool. SHOW ENGINE INNODB MUTEX does,\nhowever, print aggregate BUF_BLOCK_MUTEX spin, wait, and call values\nfor buffer pool block mutexes and rw-locks. SHOW ENGINE INNODB MUTEX\nalso does not list any mutexes or rw-locks that have never been waited\non (os_waits=0). Thus, SHOW ENGINE INNODB MUTEX only displays\ninformation about mutexes and rw-locks outside of the buffer pool that\nhave caused at least one OS-level wait.\n\nUse SHOW ENGINE PERFORMANCE_SCHEMA STATUS to inspect the internal\noperation of the Performance Schema code:\n\nmysql> SHOW ENGINE PERFORMANCE_SCHEMA STATUS\\G\n...\n*************************** 3. row ***************************\n  Type: performance_schema\n  Name: events_waits_history.size\nStatus: 76\n*************************** 4. row ***************************\n  Type: performance_schema\n  Name: events_waits_history.count\nStatus: 10000\n*************************** 5. row ***************************\n  Type: performance_schema\n  Name: events_waits_history.memory\nStatus: 760000\n...\n*************************** 57. row ***************************\n  Type: performance_schema\n  Name: performance_schema.memory\nStatus: 26459600\n...\n\nThis statement is intended to help the DBA understand the effects that\ndifferent Performance Schema options have on memory requirements.\n\nName values consist of two parts, which name an internal buffer and a\nbuffer attribute, respectively. Interpret buffer names as follows:\n\no An internal buffer that is not exposed as a table is named within\n  parentheses. Examples: (pfs_cond_class).size,\n  (pfs_mutex_class).memory.\n\no An internal buffer that is exposed as a table in the\n  performance_schema database is named after the table, without\n  parentheses. Examples: events_waits_history.size,\n  mutex_instances.count.\n\no A value that applies to the Performance Schema as a whole begins with\n  performance_schema. Example: performance_schema.memory.\n\nBuffer attributes have these meanings:\n\no size is the size of the internal record used by the implementation,\n  such as the size of a row in a table. size values cannot be changed.\n\no count is the number of internal records, such as the number of rows\n  in a table. count values can be changed using Performance Schema\n  configuration options.\n\no For a table, tbl_name.memory is the product of size and count. For\n  the Performance Schema as a whole, performance_schema.memory is the\n  sum of all the memory used (the sum of all other memory values).\n\nIn some cases, there is a direct relationship between a Performance\nSchema configuration parameter and a SHOW ENGINE value. For example,\nevents_waits_history_long.count corresponds to\nperformance_schema_events_waits_history_long_size. In other cases, the\nrelationship is more complex. For example, events_waits_history.count\ncorresponds to performance_schema_events_waits_history_size (the number\nof rows per thread) multiplied by\nperformance_schema_max_thread_instances ( the number of threads).\n\nSHOW ENGINE NDB STATUS If the server has the NDB storage engine\nenabled, SHOW ENGINE NDB STATUS displays cluster status information\nsuch as the number of connected data nodes, the cluster connectstring,\nand cluster binary log epochs, as well as counts of various Cluster API\nobjects created by the MySQL Server when connected to the cluster.\nSample output from this statement is shown here:\n\nmysql> SHOW ENGINE NDB STATUS;\n+------------+-----------------------+--------------------------------------------------+\n| Type       | Name                  | Status                                           |\n+------------+-----------------------+--------------------------------------------------+\n| ndbcluster | connection            | cluster_node_id=7,\n  connected_host=198.51.100.103, connected_port=1186, number_of_data_nodes=4,\n  number_of_ready_data_nodes=3, connect_count=0                                         |\n| ndbcluster | NdbTransaction        | created=6, free=0, sizeof=212                    |\n| ndbcluster | NdbOperation          | created=8, free=8, sizeof=660                    |\n| ndbcluster | NdbIndexScanOperation | created=1, free=1, sizeof=744                    |\n| ndbcluster | NdbIndexOperation     | created=0, free=0, sizeof=664                    |\n| ndbcluster | NdbRecAttr            | created=1285, free=1285, sizeof=60               |\n| ndbcluster | NdbApiSignal          | created=16, free=16, sizeof=136                  |\n| ndbcluster | NdbLabel              | created=0, free=0, sizeof=196                    |\n| ndbcluster | NdbBranch             | created=0, free=0, sizeof=24                     |\n| ndbcluster | NdbSubroutine         | created=0, free=0, sizeof=68                     |\n| ndbcluster | NdbCall               | created=0, free=0, sizeof=16                     |\n| ndbcluster | NdbBlob               | created=1, free=1, sizeof=264                    |\n| ndbcluster | NdbReceiver           | created=4, free=0, sizeof=68                     |\n| ndbcluster | binlog                | latest_epoch=155467, latest_trans_epoch=148126,\n  latest_received_binlog_epoch=0, latest_handled_binlog_epoch=0,\n  latest_applied_binlog_epoch=0                                                         |\n+------------+-----------------------+--------------------------------------------------+\n\nThe Status column in each of these rows provides information about the\nMySQL server\'s connection to the cluster and about the cluster binary\nlog\'s status, respectively. The Status information is in the form of\ncomma-delimited set of name/value pairs.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-engine.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/show-engine.html'),(661,'SHOW ENGINES',3,'Syntax:\nSHOW [STORAGE] ENGINES\n\nSHOW ENGINES displays status information about the server\'s storage\nengines. This is particularly useful for checking whether a storage\nengine is supported, or to see what the default engine is.\n\nFor information about MySQL storage engines, see\nhttps://dev.mysql.com/doc/refman/8.0/en/innodb-storage-engine.html, and\nhttps://dev.mysql.com/doc/refman/8.0/en/storage-engines.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-engines.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/show-engines.html'),(662,'SHOW ERRORS',3,'Syntax:\nSHOW ERRORS [LIMIT [offset,] row_count]\nSHOW COUNT(*) ERRORS\n\nSHOW ERRORS is a diagnostic statement that is similar to SHOW WARNINGS,\nexcept that it displays information only for errors, rather than for\nerrors, warnings, and notes.\n\nThe LIMIT clause has the same syntax as for the SELECT statement. See\nhttps://dev.mysql.com/doc/refman/8.0/en/select.html.\n\nThe SHOW COUNT(*) ERRORS statement displays the number of errors. You\ncan also retrieve this number from the error_count variable:\n\nSHOW COUNT(*) ERRORS;\nSELECT @@error_count;\n\nSHOW ERRORS and error_count apply only to errors, not warnings or\nnotes. In other respects, they are similar to SHOW WARNINGS and\nwarning_count. In particular, SHOW ERRORS cannot display information\nfor more than max_error_count messages, and error_count can exceed the\nvalue of max_error_count if the number of errors exceeds\nmax_error_count.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-errors.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/show-errors.html'),(663,'SHOW EVENTS',3,'Syntax:\nSHOW EVENTS\n    [{FROM | IN} schema_name]\n    [LIKE \'pattern\' | WHERE expr]\n\nThis statement displays information about Event Manager events, which\nare discussed in\nhttps://dev.mysql.com/doc/refman/8.0/en/event-scheduler.html. It\nrequires the EVENT privilege for the database from which the events are\nto be shown.\n\nIn its simplest form, SHOW EVENTS lists all of the events in the\ncurrent schema:\n\nmysql> SELECT CURRENT_USER(), SCHEMA();\n+----------------+----------+\n| CURRENT_USER() | SCHEMA() |\n+----------------+----------+\n| jon@ghidora    | myschema |\n+----------------+----------+\n1 row in set (0.00 sec)\n\nmysql> SHOW EVENTS\\G\n*************************** 1. row ***************************\n                  Db: myschema\n                Name: e_daily\n             Definer: jon@ghidora\n           Time zone: SYSTEM\n                Type: RECURRING\n          Execute at: NULL\n      Interval value: 1\n      Interval field: DAY\n              Starts: 2018-08-08 11:06:34\n                Ends: NULL\n              Status: ENABLED\n          Originator: 1\ncharacter_set_client: utf8mb4\ncollation_connection: utf8mb4_0900_ai_ci\n  Database Collation: utf8mb4_0900_ai_ci\n\nTo see events for a specific schema, use the FROM clause. For example,\nto see events for the test schema, use the following statement:\n\nSHOW EVENTS FROM test;\n\nThe LIKE clause, if present, indicates which event names to match. The\nWHERE clause can be given to select rows using more general conditions,\nas discussed in\nhttps://dev.mysql.com/doc/refman/8.0/en/extended-show.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-events.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/show-events.html'),(664,'SHOW FUNCTION CODE',3,'Syntax:\nSHOW FUNCTION CODE func_name\n\nThis statement is similar to SHOW PROCEDURE CODE but for stored\nfunctions. See [HELP SHOW PROCEDURE CODE].\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-function-code.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/show-function-code.html'),(665,'SHOW FUNCTION STATUS',3,'Syntax:\nSHOW FUNCTION STATUS\n    [LIKE \'pattern\' | WHERE expr]\n\nThis statement is similar to SHOW PROCEDURE STATUS but for stored\nfunctions. See [HELP SHOW PROCEDURE STATUS].\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-function-status.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/show-function-status.html'),(666,'SHOW GRANTS',3,'Syntax:\nSHOW GRANTS\n    [FOR user_or_role\n        [USING role [, role] ...]]\n\nuser_or_role: {\n    user (see )\n  | role (see .\n}\n\nThis statement displays the privileges and roles that are assigned to a\nMySQL user account or role, in the form of GRANT statements that must\nbe executed to duplicate the privilege and role assignments.\n\n*Note*:\n\nTo display nonprivilege information for MySQL accounts, use the SHOW\nCREATE USER statement. See [HELP SHOW CREATE USER].\n\nSHOW GRANTS requires the SELECT privilege for the mysql system schema,\nexcept to display privileges and roles for the current user.\n\nTo name the account or role for SHOW GRANTS, use the same format as for\nthe GRANT statement (for example, \'jeffrey\'@\'localhost\'):\n\nmysql> SHOW GRANTS FOR \'jeffrey\'@\'localhost\';\n+------------------------------------------------------------------+\n| Grants for jeffrey@localhost                                     |\n+------------------------------------------------------------------+\n| GRANT USAGE ON *.* TO `jeffrey`@`localhost`                      |\n| GRANT SELECT, INSERT, UPDATE ON `db1`.* TO `jeffrey`@`localhost` |\n+------------------------------------------------------------------+\n\nThe host part, if omitted, defaults to \'%\'. For additional information\nabout specifying account and role names, see\nhttps://dev.mysql.com/doc/refman/8.0/en/account-names.html, and\nhttps://dev.mysql.com/doc/refman/8.0/en/role-names.html.\n\nTo display the privileges granted to the current user (the account you\nare using to connect to the server), you can use any of the following\nstatements:\n\nSHOW GRANTS;\nSHOW GRANTS FOR CURRENT_USER;\nSHOW GRANTS FOR CURRENT_USER();\n\nIf SHOW GRANTS FOR CURRENT_USER (or any equivalent syntax) is used in\ndefiner context, such as within a stored procedure that executes with\ndefiner rather than invoker privileges, the grants displayed are those\nof the definer and not the invoker.\n\nIn MySQL 8.0 compared to previous series, SHOW GRANTS no longer\ndisplays ALL PRIVILEGES in its global-privileges output because the\nmeaning of ALL PRIVILEGES at the global level varies depending on which\ndynamic privileges are defined. Instead, SHOW GRANTS explicitly lists\neach granted global privilege:\n\nmysql> SHOW GRANTS FOR \'root\'@\'localhost\';\n+---------------------------------------------------------------------+\n| Grants for root@localhost                                           |\n+---------------------------------------------------------------------+\n| GRANT SELECT, INSERT, UPDATE, DELETE, CREATE, DROP, RELOAD,         |\n| SHUTDOWN, PROCESS, FILE, REFERENCES, INDEX, ALTER, SHOW DATABASES,  |\n| SUPER, CREATE TEMPORARY TABLES, LOCK TABLES, EXECUTE, REPLICATION   |\n| SLAVE, REPLICATION CLIENT, CREATE VIEW, SHOW VIEW, CREATE ROUTINE,  |\n| ALTER ROUTINE, CREATE USER, EVENT, TRIGGER, CREATE TABLESPACE,      |\n| CREATE ROLE, DROP ROLE ON *.* TO `root`@`localhost` WITH GRANT      |\n| OPTION                                                              |\n| GRANT PROXY ON \'\'@\'\' TO `root`@`localhost` WITH GRANT OPTION        |\n+---------------------------------------------------------------------+\n\nApplications that process SHOW GRANTS output should be adjusted\naccordingly.\n\nAt the global level, GRANT OPTION applies to all granted static global\nprivileges if granted for any of them, but applies individually to\ngranted dynamic privileges. SHOW GRANTS displays global privileges this\nway:\n\no One line listing all granted static privileges, if there are any,\n  including WITH GRANT OPTION if appropriate.\n\no One line listing all granted dynamic privileges for which GRANT\n  OPTION is granted, if there are any, including WITH GRANT OPTION.\n\no One line listing all granted dynamic privileges for which GRANT\n  OPTION is not granted, if there are any, without WITH GRANT OPTION.\n\nWith the optional USING clause, SHOW GRANTS enables you to examine the\nprivileges associated with roles for the user. Each role named in the\nUSING clause must be granted to the user.\n\nSuppose that user u1 is assigned roles r1 and r2, as follows:\n\nCREATE ROLE \'r1\', \'r2\';\nGRANT SELECT ON db1.* TO \'r1\';\nGRANT INSERT, UPDATE, DELETE ON db1.* TO \'r2\';\nCREATE USER \'u1\'@\'localhost\' IDENTIFIED BY \'u1pass\';\nGRANT \'r1\', \'r2\' TO \'u1\'@\'localhost\';\n\nSHOW GRANTS without USING shows the granted roles:\n\nmysql> SHOW GRANTS FOR \'u1\'@\'localhost\';\n+---------------------------------------------+\n| Grants for u1@localhost                     |\n+---------------------------------------------+\n| GRANT USAGE ON *.* TO `u1`@`localhost`      |\n| GRANT `r1`@`%`,`r2`@`%` TO `u1`@`localhost` |\n+---------------------------------------------+\n\nAdding a USING clause causes the statement to also display the\nprivileges associated with each role named in the clause:\n\nmysql> SHOW GRANTS FOR \'u1\'@\'localhost\' USING \'r1\';\n+---------------------------------------------+\n| Grants for u1@localhost                     |\n+---------------------------------------------+\n| GRANT USAGE ON *.* TO `u1`@`localhost`      |\n| GRANT SELECT ON `db1`.* TO `u1`@`localhost` |\n| GRANT `r1`@`%`,`r2`@`%` TO `u1`@`localhost` |\n+---------------------------------------------+\nmysql> SHOW GRANTS FOR \'u1\'@\'localhost\' USING \'r2\';\n+-------------------------------------------------------------+\n| Grants for u1@localhost                                     |\n+-------------------------------------------------------------+\n| GRANT USAGE ON *.* TO `u1`@`localhost`                      |\n| GRANT INSERT, UPDATE, DELETE ON `db1`.* TO `u1`@`localhost` |\n| GRANT `r1`@`%`,`r2`@`%` TO `u1`@`localhost`                 |\n+-------------------------------------------------------------+\nmysql> SHOW GRANTS FOR \'u1\'@\'localhost\' USING \'r1\', \'r2\';\n+---------------------------------------------------------------------+\n| Grants for u1@localhost                                             |\n+---------------------------------------------------------------------+\n| GRANT USAGE ON *.* TO `u1`@`localhost`                              |\n| GRANT SELECT, INSERT, UPDATE, DELETE ON `db1`.* TO `u1`@`localhost` |\n| GRANT `r1`@`%`,`r2`@`%` TO `u1`@`localhost`                         |\n+---------------------------------------------------------------------+\n\n*Note*:\n\nA privilege granted to an account is always in effect, but a role is\nnot. The active roles for an account can differ across and within\nsessions, depending on the value of the activate_all_roles_on_login\nsystem variable, the account default roles, and whether SET ROLE has\nbeen executed within a session.\n\nMySQL 8.0.16 and higher supports partial revokes of global privileges,\nsuch that a global privilege can be restricted from applying to\nparticular schemas (see\nhttps://dev.mysql.com/doc/refman/8.0/en/partial-revokes.html). To\nindicate which global schema privileges have been revoked for\nparticular schemas, SHOW GRANTS output includes REVOKE statements:\n\nmysql> SET PERSIST partial_revokes = ON;\nmysql> CREATE USER u1;\nmysql> GRANT SELECT, INSERT, DELETE ON *.* TO u1;\nmysql> REVOKE SELECT, INSERT ON mysql.* FROM u1;\nmysql> REVOKE DELETE ON world.* FROM u1;\nmysql> SHOW GRANTS FOR u1;\n+--------------------------------------------------+\n| Grants for u1@%                                  |\n+--------------------------------------------------+\n| GRANT SELECT, INSERT, DELETE ON *.* TO `u1`@`%`  |\n| REVOKE SELECT, INSERT ON `mysql`.* FROM `u1`@`%` |\n| REVOKE DELETE ON `world`.* FROM `u1`@`%`         |\n+--------------------------------------------------+\n\nSHOW GRANTS does not display privileges that are available to the named\naccount but are granted to a different account. For example, if an\nanonymous account exists, the named account might be able to use its\nprivileges, but SHOW GRANTS does not display them.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-grants.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/show-grants.html'),(667,'SHOW INDEX',3,'Syntax:\nSHOW [EXTENDED] {INDEX | INDEXES | KEYS}\n    {FROM | IN} tbl_name\n    [{FROM | IN} db_name]\n    [WHERE expr]\n\nSHOW INDEX returns table index information. The format resembles that\nof the SQLStatistics call in ODBC. This statement requires some\nprivilege for any column in the table.\n\nmysql> SHOW INDEX FROM City\\G\n*************************** 1. row ***************************\n        Table: city\n   Non_unique: 0\n     Key_name: PRIMARY\n Seq_in_index: 1\n  Column_name: ID\n    Collation: A\n  Cardinality: 4188\n     Sub_part: NULL\n       Packed: NULL\n         Null:\n   Index_type: BTREE\n      Comment:\nIndex_comment:\n      Visible: YES\n   Expression: NULL\n*************************** 2. row ***************************\n        Table: city\n   Non_unique: 1\n     Key_name: CountryCode\n Seq_in_index: 1\n  Column_name: CountryCode\n    Collation: A\n  Cardinality: 232\n     Sub_part: NULL\n       Packed: NULL\n         Null:\n   Index_type: BTREE\n      Comment:\nIndex_comment:\n      Visible: YES\n   Expression: NULL\n\nAn alternative to tbl_name FROM db_name syntax is db_name.tbl_name.\nThese two statements are equivalent:\n\nSHOW INDEX FROM mytable FROM mydb;\nSHOW INDEX FROM mydb.mytable;\n\nThe optional EXTENDED keyword causes the output to include information\nabout hidden indexes that MySQL uses internally and are not accessible\nby users.\n\nThe WHERE clause can be given to select rows using more general\nconditions, as discussed in\nhttps://dev.mysql.com/doc/refman/8.0/en/extended-show.html.\n\nSHOW INDEX returns the following fields:\n\no Table\n\n  The name of the table.\n\no Non_unique\n\n  0 if the index cannot contain duplicates, 1 if it can.\n\no Key_name\n\n  The name of the index. If the index is the primary key, the name is\n  always PRIMARY.\n\no Seq_in_index\n\n  The column sequence number in the index, starting with 1.\n\no Column_name\n\n  The column name. See also the description for the Expression column.\n\no Collation\n\n  How the column is sorted in the index. This can have values A\n  (ascending), D (descending), or NULL (not sorted).\n\no Cardinality\n\n  An estimate of the number of unique values in the index. To update\n  this number, run ANALYZE TABLE or (for MyISAM tables) myisamchk -a.\n\n  Cardinality is counted based on statistics stored as integers, so the\n  value is not necessarily exact even for small tables. The higher the\n  cardinality, the greater the chance that MySQL uses the index when\n  doing joins.\n\no Sub_part\n\n  The index prefix. That is, the number of indexed characters if the\n  column is only partly indexed, NULL if the entire column is indexed.\n\n  *Note*:\n\n  Prefix limits are measured in bytes. However, prefix lengths for\n  index specifications in CREATE TABLE, ALTER TABLE, and CREATE INDEX\n  statements are interpreted as number of characters for nonbinary\n  string types (CHAR, VARCHAR, TEXT) and number of bytes for binary\n  string types (BINARY, VARBINARY, BLOB). Take this into account when\n  specifying a prefix length for a nonbinary string column that uses a\n  multibyte character set.\n\n  For additional information about index prefixes, see\n  https://dev.mysql.com/doc/refman/8.0/en/column-indexes.html, and\n  [HELP CREATE INDEX].\n\no Packed\n\n  Indicates how the key is packed. NULL if it is not.\n\no Null\n\n  Contains YES if the column may contain NULL values and \'\' if not.\n\no Index_type\n\n  The index method used (BTREE, FULLTEXT, HASH, RTREE).\n\no Comment\n\n  Information about the index not described in its own column, such as\n  disabled if the index is disabled.\n\no Index_comment\n\n  Any comment provided for the index with a COMMENT attribute when the\n  index was created.\n\no Visible\n\n  Whether the index is visible to the optimizer. See\n  https://dev.mysql.com/doc/refman/8.0/en/invisible-indexes.html.\n\no Expression\n\n  MySQL 8.0.13 and higher supports functional key parts (see\n  https://dev.mysql.com/doc/refman/8.0/en/create-index.html#create-inde\n  x-functional-key-parts), which affects both the Column_name and\n  Expression columns:\n\n  o For a nonfunctional key part, Column_name indicates the column\n    indexed by the key part and Expression is NULL.\n\n  o For a functional key part, Column_name column is NULL and\n    Expression indicates the expression for the key part.\n\nInformation about table indexes is also available from the\nINFORMATION_SCHEMA STATISTICS table. See\nhttps://dev.mysql.com/doc/refman/8.0/en/information-schema-statistics-t\nable.html. The extended information about hidden indexes is available\nonly using SHOW EXTENDED INDEX; it cannot be obtained from the\nSTATISTICS table.\n\nYou can list a table\'s indexes with the mysqlshow -k db_name tbl_name\ncommand.\n\nIn MySQL 8.0.30 and later, SHOW INDEX includes the table\'s generated\ninvisible key, if it has one, by default. You can cause this\ninformation to be suppressed in the statement\'s output by setting\nshow_gipk_in_create_table_and_information_schema = OFF. For more\ninformation, see\nhttps://dev.mysql.com/doc/refman/8.0/en/create-table-gipks.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-index.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/show-index.html'),(668,'SHOW MASTER STATUS',3,'Syntax:\nSHOW MASTER STATUS\n\nThis statement provides status information about the binary log files\nof the source server. It requires the REPLICATION CLIENT privilege (or\nthe deprecated SUPER privilege).\n\nExample:\n\nmysql> SHOW MASTER STATUS\\G\n*************************** 1. row ***************************\n             File: source-bin.000002\n         Position: 1307\n     Binlog_Do_DB: test\n Binlog_Ignore_DB: manual, mysql\nExecuted_Gtid_Set: 3E11FA47-71CA-11E1-9E33-C80AA9429562:1-5\n1 row in set (0.00 sec)\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-master-status.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/show-master-status.html'),(669,'SHOW OPEN TABLES',3,'Syntax:\nSHOW OPEN TABLES\n    [{FROM | IN} db_name]\n    [LIKE \'pattern\' | WHERE expr]\n\nSHOW OPEN TABLES lists the non-TEMPORARY tables that are currently open\nin the table cache. See\nhttps://dev.mysql.com/doc/refman/8.0/en/table-cache.html. The FROM\nclause, if present, restricts the tables shown to those present in the\ndb_name database. The LIKE clause, if present, indicates which table\nnames to match. The WHERE clause can be given to select rows using more\ngeneral conditions, as discussed in\nhttps://dev.mysql.com/doc/refman/8.0/en/extended-show.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-open-tables.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/show-open-tables.html'),(670,'SHOW PLUGINS',3,'Syntax:\nSHOW PLUGINS\n\nSHOW PLUGINS displays information about server plugins.\n\nExample of SHOW PLUGINS output:\n\nmysql> SHOW PLUGINS\\G\n*************************** 1. row ***************************\n   Name: binlog\n Status: ACTIVE\n   Type: STORAGE ENGINE\nLibrary: NULL\nLicense: GPL\n*************************** 2. row ***************************\n   Name: CSV\n Status: ACTIVE\n   Type: STORAGE ENGINE\nLibrary: NULL\nLicense: GPL\n*************************** 3. row ***************************\n   Name: MEMORY\n Status: ACTIVE\n   Type: STORAGE ENGINE\nLibrary: NULL\nLicense: GPL\n*************************** 4. row ***************************\n   Name: MyISAM\n Status: ACTIVE\n   Type: STORAGE ENGINE\nLibrary: NULL\nLicense: GPL\n...\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-plugins.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/show-plugins.html'),(671,'SHOW PRIVILEGES',3,'Syntax:\nSHOW PRIVILEGES\n\nSHOW PRIVILEGES shows the list of system privileges that the MySQL\nserver supports. The privileges displayed include all static\nprivileges, and all currently registered dynamic privileges.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-privileges.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/show-privileges.html'),(672,'SHOW PROCEDURE CODE',3,'Syntax:\nSHOW PROCEDURE CODE proc_name\n\nThis statement is a MySQL extension that is available only for servers\nthat have been built with debugging support. It displays a\nrepresentation of the internal implementation of the named stored\nprocedure. A similar statement, SHOW FUNCTION CODE, displays\ninformation about stored functions (see [HELP SHOW FUNCTION CODE]).\n\nTo use either statement, you must be the user named as the routine\nDEFINER, have the SHOW_ROUTINE privilege, or have the SELECT privilege\nat the global level.\n\nIf the named routine is available, each statement produces a result\nset. Each row in the result set corresponds to one \"instruction\" in the\nroutine. The first column is Pos, which is an ordinal number beginning\nwith 0. The second column is Instruction, which contains an SQL\nstatement (usually changed from the original source), or a directive\nwhich has meaning only to the stored-routine handler.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-procedure-code.html\n\n','mysql> DELIMITER //\nmysql> CREATE PROCEDURE p1 ()\n       BEGIN\n         DECLARE fanta INT DEFAULT 55;\n         DROP TABLE t2;\n         LOOP\n           INSERT INTO t3 VALUES (fanta);\n           END LOOP;\n         END//\nQuery OK, 0 rows affected (0.01 sec)\n\nmysql> SHOW PROCEDURE CODE p1//\n+-----+----------------------------------------+\n| Pos | Instruction                            |\n+-----+----------------------------------------+\n|   0 | set fanta@0 55                         |\n|   1 | stmt 9 \"DROP TABLE t2\"                 |\n|   2 | stmt 5 \"INSERT INTO t3 VALUES (fanta)\" |\n|   3 | jump 2                                 |\n+-----+----------------------------------------+\n4 rows in set (0.00 sec)\n\nmysql> CREATE FUNCTION test.hello (s CHAR(20))\n       RETURNS CHAR(50) DETERMINISTIC\n       RETURN CONCAT(\'Hello, \',s,\'!\');\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> SHOW FUNCTION CODE test.hello;\n+-----+---------------------------------------+\n| Pos | Instruction                           |\n+-----+---------------------------------------+\n|   0 | freturn 254 concat(\'Hello, \',s@0,\'!\') |\n+-----+---------------------------------------+\n1 row in set (0.00 sec)\n','https://dev.mysql.com/doc/refman/8.0/en/show-procedure-code.html'),(673,'SHOW PROCEDURE STATUS',3,'Syntax:\nSHOW PROCEDURE STATUS\n    [LIKE \'pattern\' | WHERE expr]\n\nThis statement is a MySQL extension. It returns characteristics of a\nstored procedure, such as the database, name, type, creator, creation\nand modification dates, and character set information. A similar\nstatement, SHOW FUNCTION STATUS, displays information about stored\nfunctions (see [HELP SHOW FUNCTION STATUS]).\n\nTo use either statement, you must be the user named as the routine\nDEFINER, have the SHOW_ROUTINE privilege, have the SELECT privilege at\nthe global level, or have the CREATE ROUTINE, ALTER ROUTINE, or EXECUTE\nprivilege granted at a scope that includes the routine.\n\nThe LIKE clause, if present, indicates which procedure or function\nnames to match. The WHERE clause can be given to select rows using more\ngeneral conditions, as discussed in\nhttps://dev.mysql.com/doc/refman/8.0/en/extended-show.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-procedure-status.html\n\n','mysql> SHOW PROCEDURE STATUS LIKE \'sp1\'\\G\n*************************** 1. row ***************************\n                  Db: test\n                Name: sp1\n                Type: PROCEDURE\n             Definer: testuser@localhost\n            Modified: 2018-08-08 13:54:11\n             Created: 2018-08-08 13:54:11\n       Security_type: DEFINER\n             Comment:\ncharacter_set_client: utf8mb4\ncollation_connection: utf8mb4_0900_ai_ci\n  Database Collation: utf8mb4_0900_ai_ci\n\nmysql> SHOW FUNCTION STATUS LIKE \'hello\'\\G\n*************************** 1. row ***************************\n                  Db: test\n                Name: hello\n                Type: FUNCTION\n             Definer: testuser@localhost\n            Modified: 2020-03-10 11:10:03\n             Created: 2020-03-10 11:10:03\n       Security_type: DEFINER\n             Comment:\ncharacter_set_client: utf8mb4\ncollation_connection: utf8mb4_0900_ai_ci\n  Database Collation: utf8mb4_0900_ai_ci\n','https://dev.mysql.com/doc/refman/8.0/en/show-procedure-status.html'),(674,'SHOW PROCESSLIST',3,'Syntax:\nSHOW [FULL] PROCESSLIST\n\nThe MySQL process list indicates the operations currently being\nperformed by the set of threads executing within the server. The SHOW\nPROCESSLIST statement is one source of process information. For a\ncomparison of this statement with other sources, see\nhttps://dev.mysql.com/doc/refman/8.0/en/processlist-access.html#process\nlist-sources.\n\n*Note*:\n\nAs of MySQL 8.0.22, an alternative implementation for SHOW PROCESSLIST\nis available based on the Performance Schema processlist table, which,\nunlike the default SHOW PROCESSLIST implementation, does not require a\nmutex and has better performance characteristics. For details, see\nhttps://dev.mysql.com/doc/refman/8.0/en/performance-schema-processlist-\ntable.html.\n\nIf you have the PROCESS privilege, you can see all threads, even those\nbelonging to other users. Otherwise (without the PROCESS privilege),\nnonanonymous users have access to information about their own threads\nbut not threads for other users, and anonymous users have no access to\nthread information.\n\nWithout the FULL keyword, SHOW PROCESSLIST displays only the first 100\ncharacters of each statement in the Info field.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-processlist.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/show-processlist.html'),(675,'SHOW PROFILE',3,'Syntax:\nSHOW PROFILE [type [, type] ... ]\n    [FOR QUERY n]\n    [LIMIT row_count [OFFSET offset]]\n\ntype: {\n    ALL\n  | BLOCK IO\n  | CONTEXT SWITCHES\n  | CPU\n  | IPC\n  | MEMORY\n  | PAGE FAULTS\n  | SOURCE\n  | SWAPS\n}\n\nThe SHOW PROFILE and SHOW PROFILES statements display profiling\ninformation that indicates resource usage for statements executed\nduring the course of the current session.\n\n*Note*:\n\nThe SHOW PROFILE and SHOW PROFILES statements are deprecated; expect\nthem to be removed in a future MySQL release. Use the Performance\nSchema instead; see\nhttps://dev.mysql.com/doc/refman/8.0/en/performance-schema-query-profil\ning.html.\n\nTo control profiling, use the profiling session variable, which has a\ndefault value of 0 (OFF). Enable profiling by setting profiling to 1 or\nON:\n\nmysql> SET profiling = 1;\n\nSHOW PROFILES displays a list of the most recent statements sent to the\nserver. The size of the list is controlled by the\nprofiling_history_size session variable, which has a default value of\n15. The maximum value is 100. Setting the value to 0 has the practical\neffect of disabling profiling.\n\nAll statements are profiled except SHOW PROFILE and SHOW PROFILES, so\nneither of those statements appears in the profile list. Malformed\nstatements are profiled. For example, SHOW PROFILING is an illegal\nstatement, and a syntax error occurs if you try to execute it, but it\nshows up in the profiling list.\n\nSHOW PROFILE displays detailed information about a single statement.\nWithout the FOR QUERY n clause, the output pertains to the most\nrecently executed statement. If FOR QUERY n is included, SHOW PROFILE\ndisplays information for statement n. The values of n correspond to the\nQuery_ID values displayed by SHOW PROFILES.\n\nThe LIMIT row_count clause may be given to limit the output to\nrow_count rows. If LIMIT is given, OFFSET offset may be added to begin\nthe output offset rows into the full set of rows.\n\nBy default, SHOW PROFILE displays Status and Duration columns. The\nStatus values are like the State values displayed by SHOW PROCESSLIST,\nalthough there might be some minor differences in interpretation for\nthe two statements for some status values (see\nhttps://dev.mysql.com/doc/refman/8.0/en/thread-information.html).\n\nOptional type values may be specified to display specific additional\ntypes of information:\n\no ALL displays all information\n\no BLOCK IO displays counts for block input and output operations\n\no CONTEXT SWITCHES displays counts for voluntary and involuntary\n  context switches\n\no CPU displays user and system CPU usage times\n\no IPC displays counts for messages sent and received\n\no MEMORY is not currently implemented\n\no PAGE FAULTS displays counts for major and minor page faults\n\no SOURCE displays the names of functions from the source code, together\n  with the name and line number of the file in which the function\n  occurs\n\no SWAPS displays swap counts\n\nProfiling is enabled per session. When a session ends, its profiling\ninformation is lost.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-profile.html\n\n','mysql> SELECT @@profiling;\n+-------------+\n| @@profiling |\n+-------------+\n|           0 |\n+-------------+\n1 row in set (0.00 sec)\n\nmysql> SET profiling = 1;\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> DROP TABLE IF EXISTS t1;\nQuery OK, 0 rows affected, 1 warning (0.00 sec)\n\nmysql> CREATE TABLE T1 (id INT);\nQuery OK, 0 rows affected (0.01 sec)\n\nmysql> SHOW PROFILES;\n+----------+----------+--------------------------+\n| Query_ID | Duration | Query                    |\n+----------+----------+--------------------------+\n|        0 | 0.000088 | SET PROFILING = 1        |\n|        1 | 0.000136 | DROP TABLE IF EXISTS t1  |\n|        2 | 0.011947 | CREATE TABLE t1 (id INT) |\n+----------+----------+--------------------------+\n3 rows in set (0.00 sec)\n\nmysql> SHOW PROFILE;\n+----------------------+----------+\n| Status               | Duration |\n+----------------------+----------+\n| checking permissions | 0.000040 |\n| creating table       | 0.000056 |\n| After create         | 0.011363 |\n| query end            | 0.000375 |\n| freeing items        | 0.000089 |\n| logging slow query   | 0.000019 |\n| cleaning up          | 0.000005 |\n+----------------------+----------+\n7 rows in set (0.00 sec)\n\nmysql> SHOW PROFILE FOR QUERY 1;\n+--------------------+----------+\n| Status             | Duration |\n+--------------------+----------+\n| query end          | 0.000107 |\n| freeing items      | 0.000008 |\n| logging slow query | 0.000015 |\n| cleaning up        | 0.000006 |\n+--------------------+----------+\n4 rows in set (0.00 sec)\n\nmysql> SHOW PROFILE CPU FOR QUERY 2;\n+----------------------+----------+----------+------------+\n| Status               | Duration | CPU_user | CPU_system |\n+----------------------+----------+----------+------------+\n| checking permissions | 0.000040 | 0.000038 |   0.000002 |\n| creating table       | 0.000056 | 0.000028 |   0.000028 |\n| After create         | 0.011363 | 0.000217 |   0.001571 |\n| query end            | 0.000375 | 0.000013 |   0.000028 |\n| freeing items        | 0.000089 | 0.000010 |   0.000014 |\n| logging slow query   | 0.000019 | 0.000009 |   0.000010 |\n| cleaning up          | 0.000005 | 0.000003 |   0.000002 |\n+----------------------+----------+----------+------------+\n7 rows in set (0.00 sec)\n','https://dev.mysql.com/doc/refman/8.0/en/show-profile.html'),(676,'SHOW PROFILES',3,'Syntax:\nSHOW PROFILES\n\nThe SHOW PROFILES statement, together with SHOW PROFILE, displays\nprofiling information that indicates resource usage for statements\nexecuted during the course of the current session. For more\ninformation, see [HELP SHOW PROFILE].\n\n*Note*:\n\nThe SHOW PROFILE and SHOW PROFILES statements are deprecated; expect it\nto be removed in a future MySQL release. Use the Performance Schema\ninstead; see\nhttps://dev.mysql.com/doc/refman/8.0/en/performance-schema-query-profil\ning.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-profiles.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/show-profiles.html'),(677,'SHOW RELAYLOG EVENTS',3,'Syntax:\nSHOW RELAYLOG EVENTS\n    [IN \'log_name\']\n    [FROM pos]\n    [LIMIT [offset,] row_count]\n    [channel_option]\n\nchannel_option:\n    FOR CHANNEL channel\n\nShows the events in the relay log of a replica. If you do not specify\n\'log_name\', the first relay log is displayed. This statement has no\neffect on the source. SHOW RELAYLOG EVENTS requires the REPLICATION\nSLAVE privilege.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-relaylog-events.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/show-relaylog-events.html'),(678,'SHOW REPLICAS',3,'Syntax:\n{SHOW REPLICAS}\n\nDisplays a list of replicas currently registered with the source. From\nMySQL 8.0.22, use SHOW REPLICAS in place of SHOW SLAVE HOSTS, which is\ndeprecated from that release. In releases before MySQL 8.0.22, use SHOW\nSLAVE HOSTS. SHOW REPLICAS requires the REPLICATION SLAVE privilege.\n\nSHOW REPLICAS should be executed on a server that acts as a replication\nsource. The statement displays information about servers that are or\nhave been connected as replicas, with each row of the result\ncorresponding to one replica server, as shown here:\n\nmysql> SHOW REPLICAS;\n+------------+-----------+------+-----------+--------------------------------------+\n| Server_id  | Host      | Port | Source_id | Replica_UUID                         |\n+------------+-----------+------+-----------+--------------------------------------+\n|         10 | iconnect2 | 3306 |         3 | 14cb6624-7f93-11e0-b2c0-c80aa9429562 |\n|         21 | athena    | 3306 |         3 | 07af4990-f41f-11df-a566-7ac56fdaf645 |\n+------------+-----------+------+-----------+--------------------------------------+\n\no Server_id: The unique server ID of the replica server, as configured\n  in the replica server\'s option file, or on the command line with\n  --server-id=value.\n\no Host: The host name of the replica server, as specified on the\n  replica with the --report-host option. This can differ from the\n  machine name as configured in the operating system.\n\no User: The replica server user name, as specified on the replica with\n  the --report-user option. Statement output includes this column only\n  if the source server is started with the --show-replica-auth-info or\n  --show-slave-auth-info option.\n\no Password: The replica server password, as specified on the replica\n  with the --report-password option. Statement output includes this\n  column only if the source server is started with the\n  --show-replica-auth-info or --show-slave-auth-info option.\n\no Port: The port on the source to which the replica server is\n  listening, as specified on the replica with the --report-port option.\n\n  A zero in this column means that the replica port (--report-port) was\n  not set.\n\no Source_id: The unique server ID of the source server that the replica\n  server is replicating from. This is the server ID of the server on\n  which SHOW REPLICAS is executed, so this same value is listed for\n  each row in the result.\n\no Replica_UUID: The globally unique ID of this replica, as generated on\n  the replica and found in the replica\'s auto.cnf file.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-replicas.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/show-replicas.html'),(679,'SHOW SLAVE HOSTS',3,'Syntax:\n{SHOW SLAVE HOSTS | SHOW REPLICAS}\n\nDisplays a list of replicas currently registered with the source. From\nMySQL 8.0.22, SHOW SLAVE HOSTS is deprecated and the alias SHOW\nREPLICAS should be used instead. The statement works in the same way as\nbefore, only the terminology used for the statement and its output has\nchanged. Both versions of the statement update the same status\nvariables when used. Please see the documentation for SHOW REPLICAS for\na description of the statement.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-slave-hosts.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/show-slave-hosts.html'),(680,'SHOW REPLICA STATUS',3,'Syntax:\nSHOW {REPLICA | SLAVE} STATUS [FOR CHANNEL channel]\n\nThis statement provides status information on essential parameters of\nthe replica threads. From MySQL 8.0.22, use SHOW REPLICA STATUS in\nplace of SHOW SLAVE STATUS, which is deprecated from that release. In\nreleases before MySQL 8.0.22, use SHOW SLAVE STATUS. The statement\nrequires the REPLICATION CLIENT privilege (or the deprecated SUPER\nprivilege).\n\nSHOW REPLICA STATUS is nonblocking. When run concurrently with STOP\nREPLICA, SHOW REPLICA STATUS returns without waiting for STOP REPLICA\nto finish shutting down the replication SQL (applier) thread or\nreplication I/O (receiver) thread (or both). This permits use in\nmonitoring and other applications where getting an immediate response\nfrom SHOW REPLICA STATUS is more important than ensuring that it\nreturned the latest data. The SLAVE keyword was replaced with REPLICA\nin MySQL 8.0.22.\n\nIf you issue this statement using the mysql client, you can use a \\G\nstatement terminator rather than a semicolon to obtain a more readable\nvertical layout:\n\nmysql> SHOW REPLICA STATUS\\G\n*************************** 1. row ***************************\n             Replica_IO_State: Waiting for source to send event\n                  Source_Host: localhost\n                  Source_User: repl\n                  Source_Port: 13000\n                Connect_Retry: 60\n              Source_Log_File: source-bin.000002\n          Read_Source_Log_Pos: 1307\n               Relay_Log_File: replica-relay-bin.000003\n                Relay_Log_Pos: 1508\n        Relay_Source_Log_File: source-bin.000002\n           Replica_IO_Running: Yes\n          Replica_SQL_Running: Yes\n              Replicate_Do_DB:\n          Replicate_Ignore_DB:\n           Replicate_Do_Table:\n       Replicate_Ignore_Table:\n      Replicate_Wild_Do_Table:\n  Replicate_Wild_Ignore_Table:\n                   Last_Errno: 0\n                   Last_Error:\n                 Skip_Counter: 0\n          Exec_Source_Log_Pos: 1307\n              Relay_Log_Space: 1858\n              Until_Condition: None\n               Until_Log_File:\n                Until_Log_Pos: 0\n           Source_SSL_Allowed: No\n           Source_SSL_CA_File:\n           Source_SSL_CA_Path:\n              Source_SSL_Cert:\n            Source_SSL_Cipher:\n               Source_SSL_Key:\n        Seconds_Behind_Source: 0\nSource_SSL_Verify_Server_Cert: No\n                Last_IO_Errno: 0\n                Last_IO_Error:\n               Last_SQL_Errno: 0\n               Last_SQL_Error:\n  Replicate_Ignore_Server_Ids:\n             Source_Server_Id: 1\n                  Source_UUID: 3e11fa47-71ca-11e1-9e33-c80aa9429562\n             Source_Info_File:\n                    SQL_Delay: 0\n          SQL_Remaining_Delay: NULL\n    Replica_SQL_Running_State: Reading event from the relay log\n           Source_Retry_Count: 10\n                  Source_Bind:\n      Last_IO_Error_Timestamp:\n     Last_SQL_Error_Timestamp:\n               Source_SSL_Crl:\n           Source_SSL_Crlpath:\n           Retrieved_Gtid_Set: 3e11fa47-71ca-11e1-9e33-c80aa9429562:1-5\n            Executed_Gtid_Set: 3e11fa47-71ca-11e1-9e33-c80aa9429562:1-5\n                Auto_Position: 1\n         Replicate_Rewrite_DB:\n                 Channel_name:\n           Source_TLS_Version: TLSv1.2\n       Source_public_key_path: public_key.pem\n        Get_source_public_key: 0\n            Network_Namespace:\n\nThe Performance Schema provides tables that expose replication\ninformation. This is similar to the information available from the SHOW\nREPLICA STATUS statement, but represented in table form. For details,\nsee\nhttps://dev.mysql.com/doc/refman/8.0/en/performance-schema-replication-\ntables.html.\n\nFrom MySQL 8.0.27, you can set the GTID_ONLY option on the CHANGE\nREPLICATION SOURCE TO statement to stop a replication channel from\npersisting file names and file positions in the replication metadata\nrepositories. With this setting, file positions for the source binary\nlog file and the relay log file are tracked in memory. The SHOW REPLICA\nSTATUS statement still displays file positions in normal use. However,\nbecause the file positions are not being regularly updated in the\nconnection metadata repository and the applier metadata repository\nexcept in a few situations, they are likely to be out of date if the\nserver is restarted.\n\nFor a replication channel with the GTID_ONLY setting after a server\nstart, the read and applied file positions for the source binary log\nfile (Read_Source_Log_Pos and Exec_Source_Log_Pos) are set to zero, and\nthe file names (Source_Log_File and Relay_Source_Log_File) are set to\nINVALID. The relay log file name (Relay_Log_File) is set according to\nthe relay_log_recovery setting, either a new file that was created at\nserver start or the first relay log file present. The file position\n(Relay_Log_Pos) is set to position 4, and GTID auto-skip is used to\nskip any transactions in the file that were already applied.\n\nWhen the receiver thread contacts the source and gets valid position\ninformation, the read position (Read_Source_Log_Pos) and file name\n(Source_Log_File) are updated with the correct data and become valid.\nWhen the applier thread applies a transaction from the source, or skips\nan already executed transaction, the executed position\n(Exec_Source_Log_Pos) and file name (Relay_Source_Log_File) are updated\nwith the correct data and become valid. The relay log file position\n(Relay_Log_Pos) is also updated at that time.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-replica-status.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/show-replica-status.html'),(681,'SHOW SLAVE STATUS',3,'Syntax:\nSHOW {SLAVE | REPLICA} STATUS [FOR CHANNEL channel]\n\nThis statement provides status information on essential parameters of\nthe replica threads. From MySQL 8.0.22, SHOW SLAVE STATUS is deprecated\nand the alias SHOW REPLICA STATUS should be used instead. The statement\nworks in the same way as before, only the terminology used for the\nstatement and its output has changed. Both versions of the statement\nupdate the same status variables when used. Please see the\ndocumentation for SHOW REPLICA STATUS for a description of the\nstatement.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-slave-status.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/show-slave-status.html'),(682,'SHOW STATUS',3,'Syntax:\nSHOW [GLOBAL | SESSION] STATUS\n    [LIKE \'pattern\' | WHERE expr]\n\nSHOW STATUS provides server status information (see\nhttps://dev.mysql.com/doc/refman/8.0/en/server-status-variables.html).\nThis statement does not require any privilege. It requires only the\nability to connect to the server.\n\nStatus variable information is also available from these sources:\n\no Performance Schema tables. See\n  https://dev.mysql.com/doc/refman/8.0/en/performance-schema-status-var\n  iable-tables.html.\n\no The mysqladmin extended-status command. See\n  https://dev.mysql.com/doc/refman/8.0/en/mysqladmin.html.\n\nFor SHOW STATUS, a LIKE clause, if present, indicates which variable\nnames to match. A WHERE clause can be given to select rows using more\ngeneral conditions, as discussed in\nhttps://dev.mysql.com/doc/refman/8.0/en/extended-show.html.\n\nSHOW STATUS accepts an optional GLOBAL or SESSION variable scope\nmodifier:\n\no With a GLOBAL modifier, the statement displays the global status\n  values. A global status variable may represent status for some aspect\n  of the server itself (for example, Aborted_connects), or the\n  aggregated status over all connections to MySQL (for example,\n  Bytes_received and Bytes_sent). If a variable has no global value,\n  the session value is displayed.\n\no With a SESSION modifier, the statement displays the status variable\n  values for the current connection. If a variable has no session\n  value, the global value is displayed. LOCAL is a synonym for SESSION.\n\no If no modifier is present, the default is SESSION.\n\nThe scope for each status variable is listed at\nhttps://dev.mysql.com/doc/refman/8.0/en/server-status-variables.html.\n\nEach invocation of the SHOW STATUS statement uses an internal temporary\ntable and increments the global Created_tmp_tables value.\n\nWith a LIKE clause, the statement displays only rows for those\nvariables with names that match the pattern:\n\nmysql> SHOW STATUS LIKE \'Key%\';\n+--------------------+----------+\n| Variable_name      | Value    |\n+--------------------+----------+\n| Key_blocks_used    | 14955    |\n| Key_read_requests  | 96854827 |\n| Key_reads          | 162040   |\n| Key_write_requests | 7589728  |\n| Key_writes         | 3813196  |\n+--------------------+----------+\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-status.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/show-status.html'),(683,'SHOW TABLE STATUS',3,'Syntax:\nSHOW TABLE STATUS\n    [{FROM | IN} db_name]\n    [LIKE \'pattern\' | WHERE expr]\n\nSHOW TABLE STATUS works likes SHOW TABLES, but provides a lot of\ninformation about each non-TEMPORARY table. You can also get this list\nusing the mysqlshow --status db_name command. The LIKE clause, if\npresent, indicates which table names to match. The WHERE clause can be\ngiven to select rows using more general conditions, as discussed in\nhttps://dev.mysql.com/doc/refman/8.0/en/extended-show.html.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-table-status.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/show-table-status.html'),(684,'SHOW TABLES',3,'Syntax:\nSHOW [EXTENDED] [FULL] TABLES\n    [{FROM | IN} db_name]\n    [LIKE \'pattern\' | WHERE expr]\n\nSHOW TABLES lists the non-TEMPORARY tables in a given database. You can\nalso get this list using the mysqlshow db_name command. The LIKE\nclause, if present, indicates which table names to match. The WHERE\nclause can be given to select rows using more general conditions, as\ndiscussed in\nhttps://dev.mysql.com/doc/refman/8.0/en/extended-show.html.\n\nMatching performed by the LIKE clause is dependent on the setting of\nthe lower_case_table_names system variable.\n\nThe optional EXTENDED modifier causes SHOW TABLES to list hidden tables\ncreated by failed ALTER TABLE statements. These temporary tables have\nnames beginning with #sql and can be dropped using DROP TABLE.\n\nThis statement also lists any views in the database. The optional FULL\nmodifier causes SHOW TABLES to display a second output column with\nvalues of BASE TABLE for a table, VIEW for a view, or SYSTEM VIEW for\nan INFORMATION_SCHEMA table.\n\nIf you have no privileges for a base table or view, it does not show up\nin the output from SHOW TABLES or mysqlshow db_name.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-tables.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/show-tables.html'),(685,'SHOW TRIGGERS',3,'Syntax:\nSHOW TRIGGERS\n    [{FROM | IN} db_name]\n    [LIKE \'pattern\' | WHERE expr]\n\nSHOW TRIGGERS lists the triggers currently defined for tables in a\ndatabase (the default database unless a FROM clause is given). This\nstatement returns results only for databases and tables for which you\nhave the TRIGGER privilege. The LIKE clause, if present, indicates\nwhich table names (not trigger names) to match and causes the statement\nto display triggers for those tables. The WHERE clause can be given to\nselect rows using more general conditions, as discussed in\nhttps://dev.mysql.com/doc/refman/8.0/en/extended-show.html.\n\nFor the ins_sum trigger defined in\nhttps://dev.mysql.com/doc/refman/8.0/en/triggers.html, the output of\nSHOW TRIGGERS is as shown here:\n\nmysql> SHOW TRIGGERS LIKE \'acc%\'\\G\n*************************** 1. row ***************************\n             Trigger: ins_sum\n               Event: INSERT\n               Table: account\n           Statement: SET @sum = @sum + NEW.amount\n              Timing: BEFORE\n             Created: 2018-08-08 10:10:12.61\n            sql_mode: ONLY_FULL_GROUP_BY,STRICT_TRANS_TABLES,\n                      NO_ZERO_IN_DATE,NO_ZERO_DATE,\n                      ERROR_FOR_DIVISION_BY_ZERO,\n                      NO_ENGINE_SUBSTITUTION\n             Definer: me@localhost\ncharacter_set_client: utf8mb4\ncollation_connection: utf8mb4_0900_ai_ci\n  Database Collation: utf8mb4_0900_ai_ci\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-triggers.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/show-triggers.html'),(686,'SHOW VARIABLES',3,'Syntax:\nSHOW [GLOBAL | SESSION] VARIABLES\n    [LIKE \'pattern\' | WHERE expr]\n\nSHOW VARIABLES shows the values of MySQL system variables (see\nhttps://dev.mysql.com/doc/refman/8.0/en/server-system-variables.html).\nThis statement does not require any privilege. It requires only the\nability to connect to the server.\n\nSystem variable information is also available from these sources:\n\no Performance Schema tables. See\n  https://dev.mysql.com/doc/refman/8.0/en/performance-schema-system-var\n  iable-tables.html.\n\no The mysqladmin variables command. See\n  https://dev.mysql.com/doc/refman/8.0/en/mysqladmin.html.\n\nFor SHOW VARIABLES, a LIKE clause, if present, indicates which variable\nnames to match. A WHERE clause can be given to select rows using more\ngeneral conditions, as discussed in\nhttps://dev.mysql.com/doc/refman/8.0/en/extended-show.html.\n\nSHOW VARIABLES accepts an optional GLOBAL or SESSION variable scope\nmodifier:\n\no With a GLOBAL modifier, the statement displays global system variable\n  values. These are the values used to initialize the corresponding\n  session variables for new connections to MySQL. If a variable has no\n  global value, no value is displayed.\n\no With a SESSION modifier, the statement displays the system variable\n  values that are in effect for the current connection. If a variable\n  has no session value, the global value is displayed. LOCAL is a\n  synonym for SESSION.\n\no If no modifier is present, the default is SESSION.\n\nThe scope for each system variable is listed at\nhttps://dev.mysql.com/doc/refman/8.0/en/server-system-variables.html.\n\nSHOW VARIABLES is subject to a version-dependent display-width limit.\nFor variables with very long values that are not completely displayed,\nuse SELECT as a workaround. For example:\n\nSELECT @@GLOBAL.innodb_data_file_path;\n\nMost system variables can be set at server startup (read-only variables\nsuch as version_comment are exceptions). Many can be changed at runtime\nwith the SET statement. See\nhttps://dev.mysql.com/doc/refman/8.0/en/using-system-variables.html,\nand [HELP SET].\n\nWith a LIKE clause, the statement displays only rows for those\nvariables with names that match the pattern. To obtain the row for a\nspecific variable, use a LIKE clause as shown:\n\nSHOW VARIABLES LIKE \'max_join_size\';\nSHOW SESSION VARIABLES LIKE \'max_join_size\';\n\nTo get a list of variables whose name match a pattern, use the %\nwildcard character in a LIKE clause:\n\nSHOW VARIABLES LIKE \'%size%\';\nSHOW GLOBAL VARIABLES LIKE \'%size%\';\n\nWildcard characters can be used in any position within the pattern to\nbe matched. Strictly speaking, because _ is a wildcard that matches any\nsingle character, you should escape it as \\_ to match it literally. In\npractice, this is rarely necessary.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-variables.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/show-variables.html'),(687,'SHOW WARNINGS',3,'Syntax:\nSHOW WARNINGS [LIMIT [offset,] row_count]\nSHOW COUNT(*) WARNINGS\n\nSHOW WARNINGS is a diagnostic statement that displays information about\nthe conditions (errors, warnings, and notes) resulting from executing a\nstatement in the current session. Warnings are generated for DML\nstatements such as INSERT, UPDATE, and LOAD DATA as well as DDL\nstatements such as CREATE TABLE and ALTER TABLE.\n\nThe LIMIT clause has the same syntax as for the SELECT statement. See\nhttps://dev.mysql.com/doc/refman/8.0/en/select.html.\n\nSHOW WARNINGS is also used following EXPLAIN, to display the extended\ninformation generated by EXPLAIN. See\nhttps://dev.mysql.com/doc/refman/8.0/en/explain-extended.html.\n\nSHOW WARNINGS displays information about the conditions resulting from\nexecution of the most recent nondiagnostic statement in the current\nsession. If the most recent statement resulted in an error during\nparsing, SHOW WARNINGS shows the resulting conditions, regardless of\nstatement type (diagnostic or nondiagnostic).\n\nThe SHOW COUNT(*) WARNINGS diagnostic statement displays the total\nnumber of errors, warnings, and notes. You can also retrieve this\nnumber from the warning_count system variable:\n\nSHOW COUNT(*) WARNINGS;\nSELECT @@warning_count;\n\nA difference in these statements is that the first is a diagnostic\nstatement that does not clear the message list. The second, because it\nis a SELECT statement is considered nondiagnostic and does clear the\nmessage list.\n\nA related diagnostic statement, SHOW ERRORS, shows only error\nconditions (it excludes warnings and notes), and SHOW COUNT(*) ERRORS\nstatement displays the total number of errors. See [HELP SHOW ERRORS].\nGET DIAGNOSTICS can be used to examine information for individual\nconditions. See [HELP GET DIAGNOSTICS].\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/show-warnings.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/show-warnings.html'),(688,'BINLOG',3,'Syntax:\nBINLOG \'str\'\n\nBINLOG is an internal-use statement. It is generated by the mysqlbinlog\nprogram as the printable representation of certain events in binary log\nfiles. (See https://dev.mysql.com/doc/refman/8.0/en/mysqlbinlog.html.)\nThe \'str\' value is a base 64-encoded string the that server decodes to\ndetermine the data change indicated by the corresponding event.\n\nTo execute BINLOG statements when applying mysqlbinlog output, a user\naccount requires the BINLOG_ADMIN privilege (or the deprecated SUPER\nprivilege), or the REPLICATION_APPLIER privilege plus the appropriate\nprivileges to execute each log event.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/binlog.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/binlog.html'),(689,'CACHE INDEX',3,'Syntax:\nCACHE INDEX {\n      tbl_index_list [, tbl_index_list] ...\n    | tbl_name PARTITION (partition_list)\n  }\n  IN key_cache_name\n\ntbl_index_list:\n  tbl_name [{INDEX|KEY} (index_name[, index_name] ...)]\n\npartition_list: {\n    partition_name[, partition_name] ...\n  | ALL\n}\n\nThe CACHE INDEX statement assigns table indexes to a specific key\ncache. It applies only to MyISAM tables, including partitioned MyISAM\ntables. After the indexes have been assigned, they can be preloaded\ninto the cache if desired with LOAD INDEX INTO CACHE.\n\nThe following statement assigns indexes from the tables t1, t2, and t3\nto the key cache named hot_cache:\n\nmysql> CACHE INDEX t1, t2, t3 IN hot_cache;\n+---------+--------------------+----------+----------+\n| Table   | Op                 | Msg_type | Msg_text |\n+---------+--------------------+----------+----------+\n| test.t1 | assign_to_keycache | status   | OK       |\n| test.t2 | assign_to_keycache | status   | OK       |\n| test.t3 | assign_to_keycache | status   | OK       |\n+---------+--------------------+----------+----------+\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/cache-index.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/cache-index.html'),(690,'FLUSH',3,'Syntax:\nFLUSH [NO_WRITE_TO_BINLOG | LOCAL] {\n    flush_option [, flush_option] ...\n  | tables_option\n}\n\nflush_option: {\n    BINARY LOGS\n  | ENGINE LOGS\n  | ERROR LOGS\n  | GENERAL LOGS\n  | HOSTS\n  | LOGS\n  | PRIVILEGES\n  | OPTIMIZER_COSTS\n  | RELAY LOGS [FOR CHANNEL channel]\n  | SLOW LOGS\n  | STATUS\n  | USER_RESOURCES\n}\n\ntables_option: {\n    TABLES\n  | TABLES tbl_name [, tbl_name] ...\n  | TABLES WITH READ LOCK\n  | TABLES tbl_name [, tbl_name] ... WITH READ LOCK\n  | TABLES tbl_name [, tbl_name] ... FOR EXPORT\n}\n\nThe FLUSH statement has several variant forms that clear or reload\nvarious internal caches, flush tables, or acquire locks. Each FLUSH\noperation requires the privileges indicated in its description.\n\n*Note*:\n\nIt is not possible to issue FLUSH statements within stored functions or\ntriggers. However, you may use FLUSH in stored procedures, so long as\nthese are not called from stored functions or triggers. See\nhttps://dev.mysql.com/doc/refman/8.0/en/stored-program-restrictions.html\n.\n\nBy default, the server writes FLUSH statements to the binary log so\nthat they replicate to replicas. To suppress logging, specify the\noptional NO_WRITE_TO_BINLOG keyword or its alias LOCAL.\n\n*Note*:\n\nFLUSH LOGS, FLUSH BINARY LOGS, FLUSH TABLES WITH READ LOCK (with or\nwithout a table list), and FLUSH TABLES tbl_name ... FOR EXPORT are not\nwritten to the binary log in any case because they would cause problems\nif replicated to a replica.\n\nThe FLUSH statement causes an implicit commit. See\nhttps://dev.mysql.com/doc/refman/8.0/en/implicit-commit.html.\n\nThe mysqladmin utility provides a command-line interface to some flush\noperations, using commands such as flush-hosts, flush-logs,\nflush-privileges, flush-status, and flush-tables. See\nhttps://dev.mysql.com/doc/refman/8.0/en/mysqladmin.html.\n\nSending a SIGHUP or SIGUSR1 signal to the server causes several flush\noperations to occur that are similar to various forms of the FLUSH\nstatement. Signals can be sent by the root system account or the system\naccount that owns the server process. This enables the flush operations\nto be performed without having to connect to the server, which requires\na MySQL account that has privileges sufficient for those operations.\nSee https://dev.mysql.com/doc/refman/8.0/en/unix-signal-response.html.\n\nThe RESET statement is similar to FLUSH. See [HELP RESET], for\ninformation about using RESET with replication.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/flush.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/flush.html'),(691,'KILL',3,'Syntax:\nKILL [CONNECTION | QUERY] processlist_id\n\nEach connection to mysqld runs in a separate thread. You can kill a\nthread with the KILL processlist_id statement.\n\nThread processlist identifiers can be determined from the ID column of\nthe INFORMATION_SCHEMA PROCESSLIST table, the Id column of SHOW\nPROCESSLIST output, and the PROCESSLIST_ID column of the Performance\nSchema threads table. The value for the current thread is returned by\nthe CONNECTION_ID() function.\n\nKILL permits an optional CONNECTION or QUERY modifier:\n\no KILL CONNECTION is the same as KILL with no modifier: It terminates\n  the connection associated with the given processlist_id, after\n  terminating any statement the connection is executing.\n\no KILL QUERY terminates the statement the connection is currently\n  executing, but leaves the connection itself intact.\n\nThe ability to see which threads are available to be killed depends on\nthe PROCESS privilege:\n\no Without PROCESS, you can see only your own threads.\n\no With PROCESS, you can see all threads.\n\nThe ability to kill threads and statements depends on the\nCONNECTION_ADMIN privilege and the deprecated SUPER privilege:\n\no Without CONNECTION_ADMIN or SUPER, you can kill only your own threads\n  and statements.\n\no With CONNECTION_ADMIN or SUPER, you can kill all threads and\n  statements, except that to affect a thread or statement that is\n  executing with the SYSTEM_USER privilege, your own session must\n  additionally have the SYSTEM_USER privilege.\n\nYou can also use the mysqladmin processlist and mysqladmin kill\ncommands to examine and kill threads.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/kill.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/kill.html'),(692,'LOAD INDEX',3,'Syntax:\nLOAD INDEX INTO CACHE\n  tbl_index_list [, tbl_index_list] ...\n\ntbl_index_list:\n  tbl_name\n    [PARTITION (partition_list)]\n    [{INDEX|KEY} (index_name[, index_name] ...)]\n    [IGNORE LEAVES]\n\npartition_list: {\n    partition_name[, partition_name] ...\n  | ALL\n}\n\nThe LOAD INDEX INTO CACHE statement preloads a table index into the key\ncache to which it has been assigned by an explicit CACHE INDEX\nstatement, or into the default key cache otherwise.\n\nLOAD INDEX INTO CACHE applies only to MyISAM tables, including\npartitioned MyISAM tables. In addition, indexes on partitioned tables\ncan be preloaded for one, several, or all partitions.\n\nThe IGNORE LEAVES modifier causes only blocks for the nonleaf nodes of\nthe index to be preloaded.\n\nIGNORE LEAVES is also supported for partitioned MyISAM tables.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/load-index.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/load-index.html'),(693,'RESET',3,'Syntax:\nRESET reset_option [, reset_option] ...\n\nreset_option: {\n    MASTER\n  | REPLICA\n  | SLAVE\n}\n\nThe RESET statement is used to clear the state of various server\noperations. You must have the RELOAD privilege to execute RESET.\n\nFor information about the RESET PERSIST statement that removes\npersisted global system variables, see [HELP RESET PERSIST].\n\nRESET acts as a stronger version of the FLUSH statement. See [HELP\nFLUSH].\n\nThe RESET statement causes an implicit commit. See\nhttps://dev.mysql.com/doc/refman/8.0/en/implicit-commit.html.\n\nThe following list describes the permitted RESET statement reset_option\nvalues:\n\no RESET MASTER\n\n  Deletes all binary logs listed in the index file, resets the binary\n  log index file to be empty, and creates a new binary log file.\n\no RESET REPLICA\n\n  Makes the replica forget its replication position in the source\n  binary logs. Also resets the relay log by deleting any existing relay\n  log files and beginning a new one. Use RESET REPLICA in place of\n  RESET SLAVE from MySQL 8.0.22.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/reset.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/reset.html'),(694,'RESET PERSIST',3,'Syntax:\nRESET PERSIST [[IF EXISTS] system_var_name]\n\nRESET PERSIST removes persisted global system variable settings from\nthe mysqld-auto.cnf option file in the data directory. Removing a\npersisted system variable causes the variable no longer to be\ninitialized from mysqld-auto.cnf at server startup. For more\ninformation about persisting system variables and the mysqld-auto.cnf\nfile, see\nhttps://dev.mysql.com/doc/refman/8.0/en/persisted-system-variables.html\n.\n\nPrior to MySQL 8.0.32, this statement did not work with variables whose\nname contained a dot character (.), such as MyISAM multiple key cache\nvariables and variables registered by components. (Bug #33417357)\n\nThe privileges required for RESET PERSIST depend on the type of system\nvariable to be removed:\n\no For dynamic system variables, this statement requires the\n  SYSTEM_VARIABLES_ADMIN privilege (or the deprecated SUPER privilege).\n\no For read-only system variables, this statement requires the\n  SYSTEM_VARIABLES_ADMIN and PERSIST_RO_VARIABLES_ADMIN privileges.\n\nSee\nhttps://dev.mysql.com/doc/refman/8.0/en/system-variable-privileges.html\n.\n\nDepending on whether the variable name and IF EXISTS clauses are\npresent, the RESET PERSIST statement has these forms:\n\no To remove all persisted variables from mysqld-auto.cnf, use RESET\n  PERSIST without naming any system variable:\n\nRESET PERSIST;\n\n  You must have privileges for removing both dynamic and read-only\n  system variables if mysqld-auto.cnf contains both kinds of variables.\n\no To remove a specific persisted variable from mysqld-auto.cnf, name it\n  in the statement:\n\nRESET PERSIST system_var_name;\n\n  This includes plugin system variables, even if the plugin is not\n  currently installed. If the variable is not present in the file, an\n  error occurs.\n\no To remove a specific persisted variable from mysqld-auto.cnf, but\n  produce a warning rather than an error if the variable is not present\n  in the file, add an IF EXISTS clause to the previous syntax:\n\nRESET PERSIST IF EXISTS system_var_name;\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/reset-persist.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/reset-persist.html'),(695,'RESTART',3,'Syntax:\nRESTART\n\nThis statement stops and restarts the MySQL server. It requires the\nSHUTDOWN privilege.\n\nOne use for RESTART is when it is not possible or convenient to gain\ncommand-line access to the MySQL server on the server host to restart\nit. For example, SET PERSIST_ONLY can be used at runtime to make\nconfiguration changes to system variables that can be set only at\nserver startup, but the server must still be restarted for those\nchanges to take effect. The RESTART statement provides a way to do so\nfrom within client sessions, without requiring command-line access on\nthe server host.\n\n*Note*:\n\nAfter executing a RESTART statement, the client can expect the current\nconnection to be lost. If auto-reconnect is enabled, the connection is\nreestablished after the server restarts. Otherwise, the connection must\nbe reestablished manually.\n\nA successful RESTART operation requires mysqld to be running in an\nenvironment that has a monitoring process available to detect a server\nshutdown performed for restart purposes:\n\no In the presence of a monitoring process, RESTART causes mysqld to\n  terminate such that the monitoring process can determine that it\n  should start a new mysqld instance.\n\no If no monitoring process is present, RESTART fails with an error.\n\nThese platforms provide the necessary monitoring support for the\nRESTART statement:\n\no Windows, when mysqld is started as a Windows service or standalone.\n  (mysqld forks, and one process acts as a monitor to the other, which\n  acts as the server.)\n\no Unix and Unix-like systems that use systemd or mysqld_safe to manage\n  mysqld.\n\nTo configure a monitoring environment such that mysqld enables the\nRESTART statement:\n\n1. Set the MYSQLD_PARENT_PID environment variable to the value of the\n   process ID of the process that starts mysqld, before starting\n   mysqld.\n\n2. When mysqld performs a shutdown due to use of the RESTART statement,\n   it returns exit code 16.\n\n3. When the monitoring process detects an exit code of 16, it starts\n   mysqld again. Otherwise, it exits.\n\nHere is a minimal example as implemented in the bash shell:\n\n#!/bin/bash\n\nexport MYSQLD_PARENT_PID=$$\n\nexport MYSQLD_RESTART_EXIT=16\n\nwhile true ; do\n  bin/mysqld mysqld options here\n  if [ $? -ne $MYSQLD_RESTART_EXIT ]; then\n    break\n  fi\ndone\n\nOn Windows, the forking used to implement RESTART makes determining the\nserver process to attach to for debugging more difficult. To alleviate\nthis, starting the server with --gdb suppresses forking, in addition to\nits other actions done to set up a debugging environment. In non-debug\nsettings, --no-monitor may be used for the sole purpose of suppressing\nforking the monitor process. For a server started with either --gdb or\n--no-monitor, executing RESTART causes the server to simply exit\nwithout restarting.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/restart.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/restart.html'),(696,'SHUTDOWN',3,'Syntax:\nSHUTDOWN\n\nThis statement stops the MySQL server. It requires the SHUTDOWN\nprivilege.\n\nSHUTDOWN provides an SQL-level interface to the same functionality\navailable using the mysqladmin shutdown command or the mysql_shutdown()\n(https://dev.mysql.com/doc/c-api/8.0/en/mysql-shutdown.html) C API\nfunction. A successful SHUTDOWN sequence consists of checking the\nprivileges, validating the arguments, and sending an OK packet to the\nclient. Then the server is shut down.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/shutdown.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/shutdown.html'),(697,'EXPLAIN',51,'Syntax:\n{EXPLAIN | DESCRIBE | DESC}\n    tbl_name [col_name | wild]\n\n{EXPLAIN | DESCRIBE | DESC}\n    [explain_type]\n    {explainable_stmt | FOR CONNECTION connection_id}\n\n{EXPLAIN | DESCRIBE | DESC} ANALYZE [FORMAT = TREE] select_statement\n\nexplain_type: {\n    FORMAT = format_name\n}\n\nformat_name: {\n    TRADITIONAL\n  | JSON\n  | TREE\n}\n\nexplainable_stmt: {\n    SELECT statement\n  | TABLE statement\n  | DELETE statement\n  | INSERT statement\n  | REPLACE statement\n  | UPDATE statement\n}\n\nThe DESCRIBE and EXPLAIN statements are synonyms. In practice, the\nDESCRIBE keyword is more often used to obtain information about table\nstructure, whereas EXPLAIN is used to obtain a query execution plan\n(that is, an explanation of how MySQL would execute a query).\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/explain.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/explain.html'),(698,'DESCRIBE',51,'Syntax:\n{EXPLAIN | DESCRIBE | DESC}\n    tbl_name [col_name | wild]\n\n{EXPLAIN | DESCRIBE | DESC}\n    [explain_type]\n    {explainable_stmt | FOR CONNECTION connection_id}\n\n{EXPLAIN | DESCRIBE | DESC} ANALYZE [FORMAT = TREE] select_statement\n\nexplain_type: {\n    FORMAT = format_name\n}\n\nformat_name: {\n    TRADITIONAL\n  | JSON\n  | TREE\n}\n\nexplainable_stmt: {\n    SELECT statement\n  | TABLE statement\n  | DELETE statement\n  | INSERT statement\n  | REPLACE statement\n  | UPDATE statement\n}\n\nThe DESCRIBE and EXPLAIN statements are synonyms. In practice, the\nDESCRIBE keyword is more often used to obtain information about table\nstructure, whereas EXPLAIN is used to obtain a query execution plan\n(that is, an explanation of how MySQL would execute a query).\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/explain.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/explain.html'),(699,'DESC',51,'Syntax:\n{EXPLAIN | DESCRIBE | DESC}\n    tbl_name [col_name | wild]\n\n{EXPLAIN | DESCRIBE | DESC}\n    [explain_type]\n    {explainable_stmt | FOR CONNECTION connection_id}\n\n{EXPLAIN | DESCRIBE | DESC} ANALYZE [FORMAT = TREE] select_statement\n\nexplain_type: {\n    FORMAT = format_name\n}\n\nformat_name: {\n    TRADITIONAL\n  | JSON\n  | TREE\n}\n\nexplainable_stmt: {\n    SELECT statement\n  | TABLE statement\n  | DELETE statement\n  | INSERT statement\n  | REPLACE statement\n  | UPDATE statement\n}\n\nThe DESCRIBE and EXPLAIN statements are synonyms. In practice, the\nDESCRIBE keyword is more often used to obtain information about table\nstructure, whereas EXPLAIN is used to obtain a query execution plan\n(that is, an explanation of how MySQL would execute a query).\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/explain.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/explain.html'),(700,'HELP STATEMENT',51,'Syntax:\nHELP \'search_string\'\n\nThe HELP statement returns online information from the MySQL Reference\nManual. Its proper operation requires that the help tables in the mysql\ndatabase be initialized with help topic information (see\nhttps://dev.mysql.com/doc/refman/8.0/en/server-side-help-support.html).\n\nThe HELP statement searches the help tables for the given search string\nand displays the result of the search. The search string is not\ncase-sensitive.\n\nThe search string can contain the wildcard characters % and _. These\nhave the same meaning as for pattern-matching operations performed with\nthe LIKE operator. For example, HELP \'rep%\' returns a list of topics\nthat begin with rep.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/help.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/help.html'),(701,'USE',51,'Syntax:\nUSE db_name\n\nThe USE statement tells MySQL to use the named database as the default\n(current) database for subsequent statements. This statement requires\nsome privilege for the database or some object within it.\n\nThe named database remains the default until the end of the session or\nanother USE statement is issued:\n\nUSE db1;\nSELECT COUNT(*) FROM mytable;   # selects from db1.mytable\nUSE db2;\nSELECT COUNT(*) FROM mytable;   # selects from db2.mytable\n\nThe database name must be specified on a single line. Newlines in\ndatabase names are not supported.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/use.html\n\n','','https://dev.mysql.com/doc/refman/8.0/en/use.html'),(702,'MERGE',52,'The MERGE storage engine, also known as the MRG_MyISAM engine, is a\ncollection of identical MyISAM tables that can be used as one.\n\"Identical\" means that all tables have identical column data types and\nindex information. You cannot merge MyISAM tables in which the columns\nare listed in a different order, do not have exactly the same data\ntypes in corresponding columns, or have the indexes in different order.\nHowever, any or all of the MyISAM tables can be compressed with\nmyisampack. See\nhttps://dev.mysql.com/doc/refman/8.0/en/myisampack.html. Differences\nbetween tables such as these do not matter:\n\no Names of corresponding columns and indexes can differ.\n\no Comments for tables, columns, and indexes can differ.\n\no Table options such as AVG_ROW_LENGTH, MAX_ROWS, or PACK_KEYS can\n  differ.\n\nURL: https://dev.mysql.com/doc/refman/8.0/en/merge-storage-engine.html\n\n','mysql> CREATE TABLE t1 (\n    ->    a INT NOT NULL AUTO_INCREMENT PRIMARY KEY,\n    ->    message CHAR(20)) ENGINE=MyISAM;\nmysql> CREATE TABLE t2 (\n    ->    a INT NOT NULL AUTO_INCREMENT PRIMARY KEY,\n    ->    message CHAR(20)) ENGINE=MyISAM;\nmysql> INSERT INTO t1 (message) VALUES (\'Testing\'),(\'table\'),(\'t1\');\nmysql> INSERT INTO t2 (message) VALUES (\'Testing\'),(\'table\'),(\'t2\');\nmysql> CREATE TABLE total (\n    ->    a INT NOT NULL AUTO_INCREMENT,\n    ->    message CHAR(20), INDEX(a))\n    ->    ENGINE=MERGE UNION=(t1,t2) INSERT_METHOD=LAST;\n','https://dev.mysql.com/doc/refman/8.0/en/merge-storage-engine.html');
/*!40000 ALTER TABLE `help_topic` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Dumping data for table `innodb_index_stats`
--

/*!40000 ALTER TABLE `innodb_index_stats` DISABLE KEYS */;
INSERT  IGNORE INTO `innodb_index_stats` VALUES ('mysql','component','PRIMARY','2023-07-24 15:19:57','n_diff_pfx01',0,1,'component_id'),('mysql','component','PRIMARY','2023-07-24 15:19:57','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('mysql','component','PRIMARY','2023-07-24 15:19:57','size',1,NULL,'Number of pages in the index'),('sys','sys_config','PRIMARY','2023-07-24 15:20:12','n_diff_pfx01',6,1,'variable'),('sys','sys_config','PRIMARY','2023-07-24 15:20:12','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('sys','sys_config','PRIMARY','2023-07-24 15:20:12','size',1,NULL,'Number of pages in the index'),('wordpress','wp_commentmeta','PRIMARY','2023-07-24 15:21:57','n_diff_pfx01',0,1,'meta_id'),('wordpress','wp_commentmeta','PRIMARY','2023-07-24 15:21:57','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('wordpress','wp_commentmeta','PRIMARY','2023-07-24 15:21:57','size',1,NULL,'Number of pages in the index'),('wordpress','wp_commentmeta','comment_id','2023-07-24 15:21:57','n_diff_pfx01',0,1,'comment_id'),('wordpress','wp_commentmeta','comment_id','2023-07-24 15:21:57','n_diff_pfx02',0,1,'comment_id,meta_id'),('wordpress','wp_commentmeta','comment_id','2023-07-24 15:21:57','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('wordpress','wp_commentmeta','comment_id','2023-07-24 15:21:57','size',1,NULL,'Number of pages in the index'),('wordpress','wp_commentmeta','meta_key','2023-07-24 15:21:57','n_diff_pfx01',0,1,'meta_key'),('wordpress','wp_commentmeta','meta_key','2023-07-24 15:21:57','n_diff_pfx02',0,1,'meta_key,meta_id'),('wordpress','wp_commentmeta','meta_key','2023-07-24 15:21:57','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('wordpress','wp_commentmeta','meta_key','2023-07-24 15:21:57','size',1,NULL,'Number of pages in the index'),('wordpress','wp_comments','PRIMARY','2023-07-24 15:21:58','n_diff_pfx01',0,1,'comment_ID'),('wordpress','wp_comments','PRIMARY','2023-07-24 15:21:58','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('wordpress','wp_comments','PRIMARY','2023-07-24 15:21:58','size',1,NULL,'Number of pages in the index'),('wordpress','wp_comments','comment_approved_date_gmt','2023-07-24 15:21:58','n_diff_pfx01',0,1,'comment_approved'),('wordpress','wp_comments','comment_approved_date_gmt','2023-07-24 15:21:58','n_diff_pfx02',0,1,'comment_approved,comment_date_gmt'),('wordpress','wp_comments','comment_approved_date_gmt','2023-07-24 15:21:58','n_diff_pfx03',0,1,'comment_approved,comment_date_gmt,comment_ID'),('wordpress','wp_comments','comment_approved_date_gmt','2023-07-24 15:21:58','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('wordpress','wp_comments','comment_approved_date_gmt','2023-07-24 15:21:58','size',1,NULL,'Number of pages in the index'),('wordpress','wp_comments','comment_author_email','2023-07-24 15:21:58','n_diff_pfx01',0,1,'comment_author_email'),('wordpress','wp_comments','comment_author_email','2023-07-24 15:21:58','n_diff_pfx02',0,1,'comment_author_email,comment_ID'),('wordpress','wp_comments','comment_author_email','2023-07-24 15:21:58','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('wordpress','wp_comments','comment_author_email','2023-07-24 15:21:58','size',1,NULL,'Number of pages in the index'),('wordpress','wp_comments','comment_date_gmt','2023-07-24 15:21:58','n_diff_pfx01',0,1,'comment_date_gmt'),('wordpress','wp_comments','comment_date_gmt','2023-07-24 15:21:58','n_diff_pfx02',0,1,'comment_date_gmt,comment_ID'),('wordpress','wp_comments','comment_date_gmt','2023-07-24 15:21:58','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('wordpress','wp_comments','comment_date_gmt','2023-07-24 15:21:58','size',1,NULL,'Number of pages in the index'),('wordpress','wp_comments','comment_parent','2023-07-24 15:21:58','n_diff_pfx01',0,1,'comment_parent'),('wordpress','wp_comments','comment_parent','2023-07-24 15:21:58','n_diff_pfx02',0,1,'comment_parent,comment_ID'),('wordpress','wp_comments','comment_parent','2023-07-24 15:21:58','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('wordpress','wp_comments','comment_parent','2023-07-24 15:21:58','size',1,NULL,'Number of pages in the index'),('wordpress','wp_comments','comment_post_ID','2023-07-24 15:21:58','n_diff_pfx01',0,1,'comment_post_ID'),('wordpress','wp_comments','comment_post_ID','2023-07-24 15:21:58','n_diff_pfx02',0,1,'comment_post_ID,comment_ID'),('wordpress','wp_comments','comment_post_ID','2023-07-24 15:21:58','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('wordpress','wp_comments','comment_post_ID','2023-07-24 15:21:58','size',1,NULL,'Number of pages in the index'),('wordpress','wp_links','PRIMARY','2023-07-24 15:21:58','n_diff_pfx01',0,1,'link_id'),('wordpress','wp_links','PRIMARY','2023-07-24 15:21:58','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('wordpress','wp_links','PRIMARY','2023-07-24 15:21:58','size',1,NULL,'Number of pages in the index'),('wordpress','wp_links','link_visible','2023-07-24 15:21:58','n_diff_pfx01',0,1,'link_visible'),('wordpress','wp_links','link_visible','2023-07-24 15:21:58','n_diff_pfx02',0,1,'link_visible,link_id'),('wordpress','wp_links','link_visible','2023-07-24 15:21:58','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('wordpress','wp_links','link_visible','2023-07-24 15:21:58','size',1,NULL,'Number of pages in the index'),('wordpress','wp_options','PRIMARY','2023-07-24 15:22:11','n_diff_pfx01',126,1,'option_id'),('wordpress','wp_options','PRIMARY','2023-07-24 15:22:11','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('wordpress','wp_options','PRIMARY','2023-07-24 15:22:11','size',1,NULL,'Number of pages in the index'),('wordpress','wp_options','autoload','2023-07-24 15:22:11','n_diff_pfx01',2,1,'autoload'),('wordpress','wp_options','autoload','2023-07-24 15:22:11','n_diff_pfx02',126,1,'autoload,option_id'),('wordpress','wp_options','autoload','2023-07-24 15:22:11','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('wordpress','wp_options','autoload','2023-07-24 15:22:11','size',1,NULL,'Number of pages in the index'),('wordpress','wp_options','option_name','2023-07-24 15:22:11','n_diff_pfx01',126,1,'option_name'),('wordpress','wp_options','option_name','2023-07-24 15:22:11','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('wordpress','wp_options','option_name','2023-07-24 15:22:11','size',1,NULL,'Number of pages in the index'),('wordpress','wp_postmeta','PRIMARY','2023-07-24 15:22:34','n_diff_pfx01',2,1,'meta_id'),('wordpress','wp_postmeta','PRIMARY','2023-07-24 15:22:34','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('wordpress','wp_postmeta','PRIMARY','2023-07-24 15:22:34','size',1,NULL,'Number of pages in the index'),('wordpress','wp_postmeta','meta_key','2023-07-24 15:22:34','n_diff_pfx01',1,1,'meta_key'),('wordpress','wp_postmeta','meta_key','2023-07-24 15:22:34','n_diff_pfx02',2,1,'meta_key,meta_id'),('wordpress','wp_postmeta','meta_key','2023-07-24 15:22:34','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('wordpress','wp_postmeta','meta_key','2023-07-24 15:22:34','size',1,NULL,'Number of pages in the index'),('wordpress','wp_postmeta','post_id','2023-07-24 15:22:34','n_diff_pfx01',2,1,'post_id'),('wordpress','wp_postmeta','post_id','2023-07-24 15:22:34','n_diff_pfx02',2,1,'post_id,meta_id'),('wordpress','wp_postmeta','post_id','2023-07-24 15:22:34','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('wordpress','wp_postmeta','post_id','2023-07-24 15:22:34','size',1,NULL,'Number of pages in the index'),('wordpress','wp_posts','PRIMARY','2023-07-24 15:22:13','n_diff_pfx01',3,1,'ID'),('wordpress','wp_posts','PRIMARY','2023-07-24 15:22:13','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('wordpress','wp_posts','PRIMARY','2023-07-24 15:22:13','size',1,NULL,'Number of pages in the index'),('wordpress','wp_posts','post_author','2023-07-24 15:22:13','n_diff_pfx01',1,1,'post_author'),('wordpress','wp_posts','post_author','2023-07-24 15:22:13','n_diff_pfx02',3,1,'post_author,ID'),('wordpress','wp_posts','post_author','2023-07-24 15:22:13','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('wordpress','wp_posts','post_author','2023-07-24 15:22:13','size',1,NULL,'Number of pages in the index'),('wordpress','wp_posts','post_name','2023-07-24 15:22:13','n_diff_pfx01',3,1,'post_name'),('wordpress','wp_posts','post_name','2023-07-24 15:22:13','n_diff_pfx02',3,1,'post_name,ID'),('wordpress','wp_posts','post_name','2023-07-24 15:22:13','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('wordpress','wp_posts','post_name','2023-07-24 15:22:13','size',1,NULL,'Number of pages in the index'),('wordpress','wp_posts','post_parent','2023-07-24 15:22:13','n_diff_pfx01',1,1,'post_parent'),('wordpress','wp_posts','post_parent','2023-07-24 15:22:13','n_diff_pfx02',3,1,'post_parent,ID'),('wordpress','wp_posts','post_parent','2023-07-24 15:22:13','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('wordpress','wp_posts','post_parent','2023-07-24 15:22:13','size',1,NULL,'Number of pages in the index'),('wordpress','wp_posts','type_status_date','2023-07-24 15:22:13','n_diff_pfx01',2,1,'post_type'),('wordpress','wp_posts','type_status_date','2023-07-24 15:22:13','n_diff_pfx02',3,1,'post_type,post_status'),('wordpress','wp_posts','type_status_date','2023-07-24 15:22:13','n_diff_pfx03',3,1,'post_type,post_status,post_date'),('wordpress','wp_posts','type_status_date','2023-07-24 15:22:13','n_diff_pfx04',3,1,'post_type,post_status,post_date,ID'),('wordpress','wp_posts','type_status_date','2023-07-24 15:22:13','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('wordpress','wp_posts','type_status_date','2023-07-24 15:22:13','size',1,NULL,'Number of pages in the index'),('wordpress','wp_term_relationships','PRIMARY','2023-07-24 15:21:57','n_diff_pfx01',0,1,'object_id'),('wordpress','wp_term_relationships','PRIMARY','2023-07-24 15:21:57','n_diff_pfx02',0,1,'object_id,term_taxonomy_id'),('wordpress','wp_term_relationships','PRIMARY','2023-07-24 15:21:57','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('wordpress','wp_term_relationships','PRIMARY','2023-07-24 15:21:57','size',1,NULL,'Number of pages in the index'),('wordpress','wp_term_relationships','term_taxonomy_id','2023-07-24 15:21:57','n_diff_pfx01',0,1,'term_taxonomy_id'),('wordpress','wp_term_relationships','term_taxonomy_id','2023-07-24 15:21:57','n_diff_pfx02',0,1,'term_taxonomy_id,object_id'),('wordpress','wp_term_relationships','term_taxonomy_id','2023-07-24 15:21:57','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('wordpress','wp_term_relationships','term_taxonomy_id','2023-07-24 15:21:57','size',1,NULL,'Number of pages in the index'),('wordpress','wp_term_taxonomy','PRIMARY','2023-07-24 15:21:56','n_diff_pfx01',0,1,'term_taxonomy_id'),('wordpress','wp_term_taxonomy','PRIMARY','2023-07-24 15:21:56','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('wordpress','wp_term_taxonomy','PRIMARY','2023-07-24 15:21:56','size',1,NULL,'Number of pages in the index'),('wordpress','wp_term_taxonomy','taxonomy','2023-07-24 15:21:56','n_diff_pfx01',0,1,'taxonomy'),('wordpress','wp_term_taxonomy','taxonomy','2023-07-24 15:21:56','n_diff_pfx02',0,1,'taxonomy,term_taxonomy_id'),('wordpress','wp_term_taxonomy','taxonomy','2023-07-24 15:21:56','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('wordpress','wp_term_taxonomy','taxonomy','2023-07-24 15:21:56','size',1,NULL,'Number of pages in the index'),('wordpress','wp_term_taxonomy','term_id_taxonomy','2023-07-24 15:21:56','n_diff_pfx01',0,1,'term_id'),('wordpress','wp_term_taxonomy','term_id_taxonomy','2023-07-24 15:21:56','n_diff_pfx02',0,1,'term_id,taxonomy'),('wordpress','wp_term_taxonomy','term_id_taxonomy','2023-07-24 15:21:56','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('wordpress','wp_term_taxonomy','term_id_taxonomy','2023-07-24 15:21:56','size',1,NULL,'Number of pages in the index'),('wordpress','wp_termmeta','PRIMARY','2023-07-24 15:21:55','n_diff_pfx01',0,1,'meta_id'),('wordpress','wp_termmeta','PRIMARY','2023-07-24 15:21:55','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('wordpress','wp_termmeta','PRIMARY','2023-07-24 15:21:55','size',1,NULL,'Number of pages in the index'),('wordpress','wp_termmeta','meta_key','2023-07-24 15:21:55','n_diff_pfx01',0,1,'meta_key'),('wordpress','wp_termmeta','meta_key','2023-07-24 15:21:55','n_diff_pfx02',0,1,'meta_key,meta_id'),('wordpress','wp_termmeta','meta_key','2023-07-24 15:21:55','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('wordpress','wp_termmeta','meta_key','2023-07-24 15:21:55','size',1,NULL,'Number of pages in the index'),('wordpress','wp_termmeta','term_id','2023-07-24 15:21:55','n_diff_pfx01',0,1,'term_id'),('wordpress','wp_termmeta','term_id','2023-07-24 15:21:55','n_diff_pfx02',0,1,'term_id,meta_id'),('wordpress','wp_termmeta','term_id','2023-07-24 15:21:55','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('wordpress','wp_termmeta','term_id','2023-07-24 15:21:55','size',1,NULL,'Number of pages in the index'),('wordpress','wp_terms','PRIMARY','2023-07-24 15:21:56','n_diff_pfx01',0,1,'term_id'),('wordpress','wp_terms','PRIMARY','2023-07-24 15:21:56','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('wordpress','wp_terms','PRIMARY','2023-07-24 15:21:56','size',1,NULL,'Number of pages in the index'),('wordpress','wp_terms','name','2023-07-24 15:21:56','n_diff_pfx01',0,1,'name'),('wordpress','wp_terms','name','2023-07-24 15:21:56','n_diff_pfx02',0,1,'name,term_id'),('wordpress','wp_terms','name','2023-07-24 15:21:56','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('wordpress','wp_terms','name','2023-07-24 15:21:56','size',1,NULL,'Number of pages in the index'),('wordpress','wp_terms','slug','2023-07-24 15:21:56','n_diff_pfx01',0,1,'slug'),('wordpress','wp_terms','slug','2023-07-24 15:21:56','n_diff_pfx02',0,1,'slug,term_id'),('wordpress','wp_terms','slug','2023-07-24 15:21:56','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('wordpress','wp_terms','slug','2023-07-24 15:21:56','size',1,NULL,'Number of pages in the index'),('wordpress','wp_usermeta','PRIMARY','2023-07-24 15:22:24','n_diff_pfx01',15,1,'umeta_id'),('wordpress','wp_usermeta','PRIMARY','2023-07-24 15:22:24','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('wordpress','wp_usermeta','PRIMARY','2023-07-24 15:22:24','size',1,NULL,'Number of pages in the index'),('wordpress','wp_usermeta','meta_key','2023-07-24 15:22:24','n_diff_pfx01',15,1,'meta_key'),('wordpress','wp_usermeta','meta_key','2023-07-24 15:22:24','n_diff_pfx02',15,1,'meta_key,umeta_id'),('wordpress','wp_usermeta','meta_key','2023-07-24 15:22:24','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('wordpress','wp_usermeta','meta_key','2023-07-24 15:22:24','size',1,NULL,'Number of pages in the index'),('wordpress','wp_usermeta','user_id','2023-07-24 15:22:24','n_diff_pfx01',1,1,'user_id'),('wordpress','wp_usermeta','user_id','2023-07-24 15:22:24','n_diff_pfx02',15,1,'user_id,umeta_id'),('wordpress','wp_usermeta','user_id','2023-07-24 15:22:24','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('wordpress','wp_usermeta','user_id','2023-07-24 15:22:24','size',1,NULL,'Number of pages in the index'),('wordpress','wp_users','PRIMARY','2023-07-24 15:21:54','n_diff_pfx01',0,1,'ID'),('wordpress','wp_users','PRIMARY','2023-07-24 15:21:54','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('wordpress','wp_users','PRIMARY','2023-07-24 15:21:54','size',1,NULL,'Number of pages in the index'),('wordpress','wp_users','user_email','2023-07-24 15:21:54','n_diff_pfx01',0,1,'user_email'),('wordpress','wp_users','user_email','2023-07-24 15:21:54','n_diff_pfx02',0,1,'user_email,ID'),('wordpress','wp_users','user_email','2023-07-24 15:21:54','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('wordpress','wp_users','user_email','2023-07-24 15:21:54','size',1,NULL,'Number of pages in the index'),('wordpress','wp_users','user_login_key','2023-07-24 15:21:54','n_diff_pfx01',0,1,'user_login'),('wordpress','wp_users','user_login_key','2023-07-24 15:21:54','n_diff_pfx02',0,1,'user_login,ID'),('wordpress','wp_users','user_login_key','2023-07-24 15:21:54','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('wordpress','wp_users','user_login_key','2023-07-24 15:21:54','size',1,NULL,'Number of pages in the index'),('wordpress','wp_users','user_nicename','2023-07-24 15:21:54','n_diff_pfx01',0,1,'user_nicename'),('wordpress','wp_users','user_nicename','2023-07-24 15:21:54','n_diff_pfx02',0,1,'user_nicename,ID'),('wordpress','wp_users','user_nicename','2023-07-24 15:21:54','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('wordpress','wp_users','user_nicename','2023-07-24 15:21:54','size',1,NULL,'Number of pages in the index');
/*!40000 ALTER TABLE `innodb_index_stats` ENABLE KEYS */;

--
-- Dumping data for table `innodb_table_stats`
--

/*!40000 ALTER TABLE `innodb_table_stats` DISABLE KEYS */;
INSERT  IGNORE INTO `innodb_table_stats` VALUES ('mysql','component','2023-07-24 15:19:57',0,1,0),('sys','sys_config','2023-07-24 15:20:12',6,1,0),('wordpress','wp_commentmeta','2023-07-24 15:21:57',0,1,2),('wordpress','wp_comments','2023-07-24 15:21:58',0,1,5),('wordpress','wp_links','2023-07-24 15:21:58',0,1,1),('wordpress','wp_options','2023-07-24 15:22:11',126,1,2),('wordpress','wp_postmeta','2023-07-24 15:22:34',2,1,2),('wordpress','wp_posts','2023-07-24 15:22:13',3,1,4),('wordpress','wp_term_relationships','2023-07-24 15:21:57',0,1,1),('wordpress','wp_term_taxonomy','2023-07-24 15:21:56',0,1,2),('wordpress','wp_termmeta','2023-07-24 15:21:55',0,1,2),('wordpress','wp_terms','2023-07-24 15:21:56',0,1,2),('wordpress','wp_usermeta','2023-07-24 15:22:24',15,1,2),('wordpress','wp_users','2023-07-24 15:21:54',0,1,3);
/*!40000 ALTER TABLE `innodb_table_stats` ENABLE KEYS */;

--
-- Table structure for table `ndb_binlog_index`
--

DROP TABLE IF EXISTS `ndb_binlog_index`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `ndb_binlog_index` (
  `Position` bigint unsigned NOT NULL,
  `File` varchar(255) NOT NULL,
  `epoch` bigint unsigned NOT NULL,
  `inserts` int unsigned NOT NULL,
  `updates` int unsigned NOT NULL,
  `deletes` int unsigned NOT NULL,
  `schemaops` int unsigned NOT NULL,
  `orig_server_id` int unsigned NOT NULL,
  `orig_epoch` bigint unsigned NOT NULL,
  `gci` int unsigned NOT NULL,
  `next_position` bigint unsigned NOT NULL,
  `next_file` varchar(255) NOT NULL,
  PRIMARY KEY (`epoch`,`orig_server_id`,`orig_epoch`)
) /*!50100 TABLESPACE `mysql` */ ENGINE=InnoDB DEFAULT CHARSET=latin1 STATS_PERSISTENT=0 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ndb_binlog_index`
--

LOCK TABLES `ndb_binlog_index` WRITE;
/*!40000 ALTER TABLE `ndb_binlog_index` DISABLE KEYS */;
/*!40000 ALTER TABLE `ndb_binlog_index` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `password_history`
--

DROP TABLE IF EXISTS `password_history`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `password_history` (
  `Host` char(255) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL DEFAULT '',
  `User` char(32) COLLATE utf8mb3_bin NOT NULL DEFAULT '',
  `Password_timestamp` timestamp(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6),
  `Password` text COLLATE utf8mb3_bin,
  PRIMARY KEY (`Host`,`User`,`Password_timestamp` DESC)
) /*!50100 TABLESPACE `mysql` */ ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_bin STATS_PERSISTENT=0 ROW_FORMAT=DYNAMIC COMMENT='Password history for user accounts';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `password_history`
--

LOCK TABLES `password_history` WRITE;
/*!40000 ALTER TABLE `password_history` DISABLE KEYS */;
/*!40000 ALTER TABLE `password_history` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `plugin`
--

DROP TABLE IF EXISTS `plugin`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `plugin` (
  `name` varchar(64) NOT NULL DEFAULT '',
  `dl` varchar(128) NOT NULL DEFAULT '',
  PRIMARY KEY (`name`)
) /*!50100 TABLESPACE `mysql` */ ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 STATS_PERSISTENT=0 ROW_FORMAT=DYNAMIC COMMENT='MySQL plugins';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `plugin`
--

LOCK TABLES `plugin` WRITE;
/*!40000 ALTER TABLE `plugin` DISABLE KEYS */;
/*!40000 ALTER TABLE `plugin` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `procs_priv`
--

DROP TABLE IF EXISTS `procs_priv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `procs_priv` (
  `Host` char(255) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL DEFAULT '',
  `Db` char(64) COLLATE utf8mb3_bin NOT NULL DEFAULT '',
  `User` char(32) COLLATE utf8mb3_bin NOT NULL DEFAULT '',
  `Routine_name` char(64) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT '',
  `Routine_type` enum('FUNCTION','PROCEDURE') COLLATE utf8mb3_bin NOT NULL,
  `Grantor` varchar(288) COLLATE utf8mb3_bin NOT NULL DEFAULT '',
  `Proc_priv` set('Execute','Alter Routine','Grant') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT '',
  `Timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`Host`,`User`,`Db`,`Routine_name`,`Routine_type`),
  KEY `Grantor` (`Grantor`)
) /*!50100 TABLESPACE `mysql` */ ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_bin STATS_PERSISTENT=0 ROW_FORMAT=DYNAMIC COMMENT='Procedure privileges';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `procs_priv`
--

LOCK TABLES `procs_priv` WRITE;
/*!40000 ALTER TABLE `procs_priv` DISABLE KEYS */;
/*!40000 ALTER TABLE `procs_priv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `proxies_priv`
--

DROP TABLE IF EXISTS `proxies_priv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `proxies_priv` (
  `Host` char(255) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL DEFAULT '',
  `User` char(32) COLLATE utf8mb3_bin NOT NULL DEFAULT '',
  `Proxied_host` char(255) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL DEFAULT '',
  `Proxied_user` char(32) COLLATE utf8mb3_bin NOT NULL DEFAULT '',
  `With_grant` tinyint(1) NOT NULL DEFAULT '0',
  `Grantor` varchar(288) COLLATE utf8mb3_bin NOT NULL DEFAULT '',
  `Timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`Host`,`User`,`Proxied_host`,`Proxied_user`),
  KEY `Grantor` (`Grantor`)
) /*!50100 TABLESPACE `mysql` */ ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_bin STATS_PERSISTENT=0 ROW_FORMAT=DYNAMIC COMMENT='User proxy privileges';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `proxies_priv`
--

LOCK TABLES `proxies_priv` WRITE;
/*!40000 ALTER TABLE `proxies_priv` DISABLE KEYS */;
INSERT INTO `proxies_priv` VALUES ('localhost','root','','',1,'boot@','2023-07-24 15:19:58');
/*!40000 ALTER TABLE `proxies_priv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `replication_asynchronous_connection_failover`
--

DROP TABLE IF EXISTS `replication_asynchronous_connection_failover`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `replication_asynchronous_connection_failover` (
  `Channel_name` char(64) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL COMMENT 'The replication channel name that connects source and replica.',
  `Host` char(255) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL COMMENT 'The source hostname that the replica will attempt to switch over the replication connection to in case of a failure.',
  `Port` int unsigned NOT NULL COMMENT 'The source port that the replica will attempt to switch over the replication connection to in case of a failure.',
  `Network_namespace` char(64) NOT NULL COMMENT 'The source network namespace that the replica will attempt to switch over the replication connection to in case of a failure. If its value is empty, connections use the default (global) namespace.',
  `Weight` tinyint unsigned NOT NULL COMMENT 'The order in which the replica shall try to switch the connection over to when there are failures. Weight can be set to a number between 1 and 100, where 100 is the highest weight and 1 the lowest.',
  `Managed_name` char(64) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT '' COMMENT 'The name of the group which this server belongs to.',
  PRIMARY KEY (`Channel_name`,`Host`,`Port`,`Network_namespace`,`Managed_name`),
  KEY `Channel_name` (`Channel_name`,`Managed_name`)
) /*!50100 TABLESPACE `mysql` */ ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 STATS_PERSISTENT=0 ROW_FORMAT=DYNAMIC COMMENT='The source configuration details';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `replication_asynchronous_connection_failover`
--

LOCK TABLES `replication_asynchronous_connection_failover` WRITE;
/*!40000 ALTER TABLE `replication_asynchronous_connection_failover` DISABLE KEYS */;
/*!40000 ALTER TABLE `replication_asynchronous_connection_failover` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `replication_asynchronous_connection_failover_managed`
--

DROP TABLE IF EXISTS `replication_asynchronous_connection_failover_managed`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `replication_asynchronous_connection_failover_managed` (
  `Channel_name` char(64) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL COMMENT 'The replication channel name that connects source and replica.',
  `Managed_name` char(64) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT '' COMMENT 'The name of the source which needs to be managed.',
  `Managed_type` char(64) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT '' COMMENT 'Determines the managed type.',
  `Configuration` json DEFAULT NULL COMMENT 'The data to help manage group. For Managed_type = GroupReplication, Configuration value should contain {"Primary_weight": 80, "Secondary_weight": 60}, so that it assigns weight=80 to PRIMARY of the group, and weight=60 for rest of the members in mysql.replication_asynchronous_connection_failover table.',
  PRIMARY KEY (`Channel_name`,`Managed_name`)
) /*!50100 TABLESPACE `mysql` */ ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 STATS_PERSISTENT=0 ROW_FORMAT=DYNAMIC COMMENT='The managed source configuration details';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `replication_asynchronous_connection_failover_managed`
--

LOCK TABLES `replication_asynchronous_connection_failover_managed` WRITE;
/*!40000 ALTER TABLE `replication_asynchronous_connection_failover_managed` DISABLE KEYS */;
/*!40000 ALTER TABLE `replication_asynchronous_connection_failover_managed` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `replication_group_configuration_version`
--

DROP TABLE IF EXISTS `replication_group_configuration_version`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `replication_group_configuration_version` (
  `name` char(255) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL COMMENT 'The configuration name.',
  `version` bigint unsigned NOT NULL COMMENT 'The version of the configuration name.',
  PRIMARY KEY (`name`)
) /*!50100 TABLESPACE `mysql` */ ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci STATS_PERSISTENT=0 ROW_FORMAT=DYNAMIC COMMENT='The group configuration version.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `replication_group_configuration_version`
--

LOCK TABLES `replication_group_configuration_version` WRITE;
/*!40000 ALTER TABLE `replication_group_configuration_version` DISABLE KEYS */;
INSERT INTO `replication_group_configuration_version` VALUES ('replication_group_member_actions',1);
/*!40000 ALTER TABLE `replication_group_configuration_version` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `replication_group_member_actions`
--

DROP TABLE IF EXISTS `replication_group_member_actions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `replication_group_member_actions` (
  `name` char(255) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL COMMENT 'The action name.',
  `event` char(64) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL COMMENT 'The event that will trigger the action.',
  `enabled` tinyint(1) NOT NULL COMMENT 'Whether the action is enabled.',
  `type` char(64) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL COMMENT 'The action type.',
  `priority` tinyint unsigned NOT NULL COMMENT 'The order on which the action will be run, value between 1 and 100, lower values first.',
  `error_handling` char(64) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL COMMENT 'On errors during the action will be handled: IGNORE, CRITICAL.',
  PRIMARY KEY (`name`,`event`),
  KEY `event` (`event`)
) /*!50100 TABLESPACE `mysql` */ ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci STATS_PERSISTENT=0 ROW_FORMAT=DYNAMIC COMMENT='The member actions configuration.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `replication_group_member_actions`
--

LOCK TABLES `replication_group_member_actions` WRITE;
/*!40000 ALTER TABLE `replication_group_member_actions` DISABLE KEYS */;
INSERT INTO `replication_group_member_actions` VALUES ('mysql_disable_super_read_only_if_primary','AFTER_PRIMARY_ELECTION',1,'INTERNAL',1,'IGNORE'),('mysql_start_failover_channels_if_primary','AFTER_PRIMARY_ELECTION',1,'INTERNAL',10,'CRITICAL');
/*!40000 ALTER TABLE `replication_group_member_actions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `role_edges`
--

DROP TABLE IF EXISTS `role_edges`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `role_edges` (
  `FROM_HOST` char(255) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL DEFAULT '',
  `FROM_USER` char(32) COLLATE utf8mb3_bin NOT NULL DEFAULT '',
  `TO_HOST` char(255) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL DEFAULT '',
  `TO_USER` char(32) COLLATE utf8mb3_bin NOT NULL DEFAULT '',
  `WITH_ADMIN_OPTION` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  PRIMARY KEY (`FROM_HOST`,`FROM_USER`,`TO_HOST`,`TO_USER`)
) /*!50100 TABLESPACE `mysql` */ ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_bin STATS_PERSISTENT=0 ROW_FORMAT=DYNAMIC COMMENT='Role hierarchy and role grants';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `role_edges`
--

LOCK TABLES `role_edges` WRITE;
/*!40000 ALTER TABLE `role_edges` DISABLE KEYS */;
/*!40000 ALTER TABLE `role_edges` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `server_cost`
--

DROP TABLE IF EXISTS `server_cost`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `server_cost` (
  `cost_name` varchar(64) NOT NULL,
  `cost_value` float DEFAULT NULL,
  `last_update` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `comment` varchar(1024) DEFAULT NULL,
  `default_value` float GENERATED ALWAYS AS ((case `cost_name` when _utf8mb3'disk_temptable_create_cost' then 20.0 when _utf8mb3'disk_temptable_row_cost' then 0.5 when _utf8mb3'key_compare_cost' then 0.05 when _utf8mb3'memory_temptable_create_cost' then 1.0 when _utf8mb3'memory_temptable_row_cost' then 0.1 when _utf8mb3'row_evaluate_cost' then 0.1 else NULL end)) VIRTUAL,
  PRIMARY KEY (`cost_name`)
) /*!50100 TABLESPACE `mysql` */ ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 STATS_PERSISTENT=0 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `server_cost`
--

LOCK TABLES `server_cost` WRITE;
/*!40000 ALTER TABLE `server_cost` DISABLE KEYS */;
INSERT INTO `server_cost` (`cost_name`, `cost_value`, `last_update`, `comment`) VALUES ('disk_temptable_create_cost',NULL,'2023-07-24 15:19:58',NULL),('disk_temptable_row_cost',NULL,'2023-07-24 15:19:58',NULL),('key_compare_cost',NULL,'2023-07-24 15:19:58',NULL),('memory_temptable_create_cost',NULL,'2023-07-24 15:19:58',NULL),('memory_temptable_row_cost',NULL,'2023-07-24 15:19:58',NULL),('row_evaluate_cost',NULL,'2023-07-24 15:19:58',NULL);
/*!40000 ALTER TABLE `server_cost` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `servers`
--

DROP TABLE IF EXISTS `servers`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `servers` (
  `Server_name` char(64) NOT NULL DEFAULT '',
  `Host` char(255) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL DEFAULT '',
  `Db` char(64) NOT NULL DEFAULT '',
  `Username` char(64) NOT NULL DEFAULT '',
  `Password` char(64) NOT NULL DEFAULT '',
  `Port` int NOT NULL DEFAULT '0',
  `Socket` char(64) NOT NULL DEFAULT '',
  `Wrapper` char(64) NOT NULL DEFAULT '',
  `Owner` char(64) NOT NULL DEFAULT '',
  PRIMARY KEY (`Server_name`)
) /*!50100 TABLESPACE `mysql` */ ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 STATS_PERSISTENT=0 ROW_FORMAT=DYNAMIC COMMENT='MySQL Foreign Servers table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `servers`
--

LOCK TABLES `servers` WRITE;
/*!40000 ALTER TABLE `servers` DISABLE KEYS */;
/*!40000 ALTER TABLE `servers` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `slave_master_info`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `slave_master_info` (
  `Number_of_lines` int unsigned NOT NULL COMMENT 'Number of lines in the file.',
  `Master_log_name` text CHARACTER SET utf8mb3 COLLATE utf8mb3_bin NOT NULL COMMENT 'The name of the master binary log currently being read from the master.',
  `Master_log_pos` bigint unsigned NOT NULL COMMENT 'The master log position of the last read event.',
  `Host` varchar(255) CHARACTER SET ascii COLLATE ascii_general_ci DEFAULT NULL COMMENT 'The host name of the source.',
  `User_name` text CHARACTER SET utf8mb3 COLLATE utf8mb3_bin COMMENT 'The user name used to connect to the master.',
  `User_password` text CHARACTER SET utf8mb3 COLLATE utf8mb3_bin COMMENT 'The password used to connect to the master.',
  `Port` int unsigned NOT NULL COMMENT 'The network port used to connect to the master.',
  `Connect_retry` int unsigned NOT NULL COMMENT 'The period (in seconds) that the slave will wait before trying to reconnect to the master.',
  `Enabled_ssl` tinyint(1) NOT NULL COMMENT 'Indicates whether the server supports SSL connections.',
  `Ssl_ca` text CHARACTER SET utf8mb3 COLLATE utf8mb3_bin COMMENT 'The file used for the Certificate Authority (CA) certificate.',
  `Ssl_capath` text CHARACTER SET utf8mb3 COLLATE utf8mb3_bin COMMENT 'The path to the Certificate Authority (CA) certificates.',
  `Ssl_cert` text CHARACTER SET utf8mb3 COLLATE utf8mb3_bin COMMENT 'The name of the SSL certificate file.',
  `Ssl_cipher` text CHARACTER SET utf8mb3 COLLATE utf8mb3_bin COMMENT 'The name of the cipher in use for the SSL connection.',
  `Ssl_key` text CHARACTER SET utf8mb3 COLLATE utf8mb3_bin COMMENT 'The name of the SSL key file.',
  `Ssl_verify_server_cert` tinyint(1) NOT NULL COMMENT 'Whether to verify the server certificate.',
  `Heartbeat` float NOT NULL,
  `Bind` text CHARACTER SET utf8mb3 COLLATE utf8mb3_bin COMMENT 'Displays which interface is employed when connecting to the MySQL server',
  `Ignored_server_ids` text CHARACTER SET utf8mb3 COLLATE utf8mb3_bin COMMENT 'The number of server IDs to be ignored, followed by the actual server IDs',
  `Uuid` text CHARACTER SET utf8mb3 COLLATE utf8mb3_bin COMMENT 'The master server uuid.',
  `Retry_count` bigint unsigned NOT NULL COMMENT 'Number of reconnect attempts, to the master, before giving up.',
  `Ssl_crl` text CHARACTER SET utf8mb3 COLLATE utf8mb3_bin COMMENT 'The file used for the Certificate Revocation List (CRL)',
  `Ssl_crlpath` text CHARACTER SET utf8mb3 COLLATE utf8mb3_bin COMMENT 'The path used for Certificate Revocation List (CRL) files',
  `Enabled_auto_position` tinyint(1) NOT NULL COMMENT 'Indicates whether GTIDs will be used to retrieve events from the master.',
  `Channel_name` varchar(64) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL COMMENT 'The channel on which the replica is connected to a source. Used in Multisource Replication',
  `Tls_version` text CHARACTER SET utf8mb3 COLLATE utf8mb3_bin COMMENT 'Tls version',
  `Public_key_path` text CHARACTER SET utf8mb3 COLLATE utf8mb3_bin COMMENT 'The file containing public key of master server.',
  `Get_public_key` tinyint(1) NOT NULL COMMENT 'Preference to get public key from master.',
  `Network_namespace` text CHARACTER SET utf8mb3 COLLATE utf8mb3_bin COMMENT 'Network namespace used for communication with the master server.',
  `Master_compression_algorithm` varchar(64) CHARACTER SET utf8mb3 COLLATE utf8mb3_bin NOT NULL COMMENT 'Compression algorithm supported for data transfer between source and replica.',
  `Master_zstd_compression_level` int unsigned NOT NULL COMMENT 'Compression level associated with zstd compression algorithm.',
  `Tls_ciphersuites` text CHARACTER SET utf8mb3 COLLATE utf8mb3_bin COMMENT 'Ciphersuites used for TLS 1.3 communication with the master server.',
  `Source_connection_auto_failover` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Indicates whether the channel connection failover is enabled.',
  `Gtid_only` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Indicates if this channel only uses GTIDs and does not persist positions.',
  PRIMARY KEY (`Channel_name`)
) /*!50100 TABLESPACE `mysql` */ ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 STATS_PERSISTENT=0 ROW_FORMAT=DYNAMIC COMMENT='Master Information';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `slave_relay_log_info`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `slave_relay_log_info` (
  `Number_of_lines` int unsigned NOT NULL COMMENT 'Number of lines in the file or rows in the table. Used to version table definitions.',
  `Relay_log_name` text CHARACTER SET utf8mb3 COLLATE utf8mb3_bin COMMENT 'The name of the current relay log file.',
  `Relay_log_pos` bigint unsigned DEFAULT NULL COMMENT 'The relay log position of the last executed event.',
  `Master_log_name` text CHARACTER SET utf8mb3 COLLATE utf8mb3_bin COMMENT 'The name of the master binary log file from which the events in the relay log file were read.',
  `Master_log_pos` bigint unsigned DEFAULT NULL COMMENT 'The master log position of the last executed event.',
  `Sql_delay` int DEFAULT NULL COMMENT 'The number of seconds that the slave must lag behind the master.',
  `Number_of_workers` int unsigned DEFAULT NULL,
  `Id` int unsigned DEFAULT NULL COMMENT 'Internal Id that uniquely identifies this record.',
  `Channel_name` varchar(64) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL COMMENT 'The channel on which the replica is connected to a source. Used in Multisource Replication',
  `Privilege_checks_username` varchar(32) CHARACTER SET utf8mb3 COLLATE utf8mb3_bin DEFAULT NULL COMMENT 'Username part of PRIVILEGE_CHECKS_USER.',
  `Privilege_checks_hostname` varchar(255) CHARACTER SET ascii COLLATE ascii_general_ci DEFAULT NULL COMMENT 'Hostname part of PRIVILEGE_CHECKS_USER.',
  `Require_row_format` tinyint(1) NOT NULL COMMENT 'Indicates whether the channel shall only accept row based events.',
  `Require_table_primary_key_check` enum('STREAM','ON','OFF','GENERATE') NOT NULL DEFAULT 'STREAM' COMMENT 'Indicates what is the channel policy regarding tables without primary keys on create and alter table queries',
  `Assign_gtids_to_anonymous_transactions_type` enum('OFF','LOCAL','UUID') NOT NULL DEFAULT 'OFF' COMMENT 'Indicates whether the channel will generate a new GTID for anonymous transactions. OFF means that anonymous transactions will remain anonymous. LOCAL means that anonymous transactions will be assigned a newly generated GTID based on server_uuid. UUID indicates that anonymous transactions will be assigned a newly generated GTID based on Assign_gtids_to_anonymous_transactions_value',
  `Assign_gtids_to_anonymous_transactions_value` text CHARACTER SET utf8mb3 COLLATE utf8mb3_bin COMMENT 'Indicates the UUID used while generating GTIDs for anonymous transactions',
  PRIMARY KEY (`Channel_name`)
) /*!50100 TABLESPACE `mysql` */ ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 STATS_PERSISTENT=0 ROW_FORMAT=DYNAMIC COMMENT='Relay Log Information';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `slave_worker_info`
--

DROP TABLE IF EXISTS `slave_worker_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `slave_worker_info` (
  `Id` int unsigned NOT NULL,
  `Relay_log_name` text CHARACTER SET utf8mb3 COLLATE utf8mb3_bin NOT NULL,
  `Relay_log_pos` bigint unsigned NOT NULL,
  `Master_log_name` text CHARACTER SET utf8mb3 COLLATE utf8mb3_bin NOT NULL,
  `Master_log_pos` bigint unsigned NOT NULL,
  `Checkpoint_relay_log_name` text CHARACTER SET utf8mb3 COLLATE utf8mb3_bin NOT NULL,
  `Checkpoint_relay_log_pos` bigint unsigned NOT NULL,
  `Checkpoint_master_log_name` text CHARACTER SET utf8mb3 COLLATE utf8mb3_bin NOT NULL,
  `Checkpoint_master_log_pos` bigint unsigned NOT NULL,
  `Checkpoint_seqno` int unsigned NOT NULL,
  `Checkpoint_group_size` int unsigned NOT NULL,
  `Checkpoint_group_bitmap` blob NOT NULL,
  `Channel_name` varchar(64) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL COMMENT 'The channel on which the replica is connected to a source. Used in Multisource Replication',
  PRIMARY KEY (`Channel_name`,`Id`)
) /*!50100 TABLESPACE `mysql` */ ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 STATS_PERSISTENT=0 ROW_FORMAT=DYNAMIC COMMENT='Worker Information';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `slave_worker_info`
--

LOCK TABLES `slave_worker_info` WRITE;
/*!40000 ALTER TABLE `slave_worker_info` DISABLE KEYS */;
/*!40000 ALTER TABLE `slave_worker_info` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tables_priv`
--

DROP TABLE IF EXISTS `tables_priv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `tables_priv` (
  `Host` char(255) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL DEFAULT '',
  `Db` char(64) COLLATE utf8mb3_bin NOT NULL DEFAULT '',
  `User` char(32) COLLATE utf8mb3_bin NOT NULL DEFAULT '',
  `Table_name` char(64) COLLATE utf8mb3_bin NOT NULL DEFAULT '',
  `Grantor` varchar(288) COLLATE utf8mb3_bin NOT NULL DEFAULT '',
  `Timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `Table_priv` set('Select','Insert','Update','Delete','Create','Drop','Grant','References','Index','Alter','Create View','Show view','Trigger') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT '',
  `Column_priv` set('Select','Insert','Update','References') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`Host`,`User`,`Db`,`Table_name`),
  KEY `Grantor` (`Grantor`)
) /*!50100 TABLESPACE `mysql` */ ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_bin STATS_PERSISTENT=0 ROW_FORMAT=DYNAMIC COMMENT='Table privileges';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `tables_priv`
--

LOCK TABLES `tables_priv` WRITE;
/*!40000 ALTER TABLE `tables_priv` DISABLE KEYS */;
INSERT INTO `tables_priv` VALUES ('localhost','mysql','mysql.session','user','boot@','2023-07-24 15:19:59','Select',''),('localhost','sys','mysql.sys','sys_config','root@localhost','2023-07-24 15:20:00','Select','');
/*!40000 ALTER TABLE `tables_priv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `time_zone`
--

DROP TABLE IF EXISTS `time_zone`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `time_zone` (
  `Time_zone_id` int unsigned NOT NULL AUTO_INCREMENT,
  `Use_leap_seconds` enum('Y','N') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  PRIMARY KEY (`Time_zone_id`)
) /*!50100 TABLESPACE `mysql` */ ENGINE=InnoDB AUTO_INCREMENT=1790 DEFAULT CHARSET=utf8mb3 STATS_PERSISTENT=0 ROW_FORMAT=DYNAMIC COMMENT='Time zones';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `time_zone`
--

LOCK TABLES `time_zone` WRITE;
/*!40000 ALTER TABLE `time_zone` DISABLE KEYS */;
INSERT INTO `time_zone` VALUES (1,'N'),(2,'N'),(3,'N'),(4,'N'),(5,'N'),(6,'N'),(7,'N'),(8,'N'),(9,'N'),(10,'N'),(11,'N'),(12,'N'),(13,'N'),(14,'N'),(15,'N'),(16,'N'),(17,'N'),(18,'N'),(19,'N'),(20,'N'),(21,'N'),(22,'N'),(23,'N'),(24,'N'),(25,'N'),(26,'N'),(27,'N'),(28,'N'),(29,'N'),(30,'N'),(31,'N'),(32,'N'),(33,'N'),(34,'N'),(35,'N'),(36,'N'),(37,'N'),(38,'N'),(39,'N'),(40,'N'),(41,'N'),(42,'N'),(43,'N'),(44,'N'),(45,'N'),(46,'N'),(47,'N'),(48,'N'),(49,'N'),(50,'N'),(51,'N'),(52,'N'),(53,'N'),(54,'N'),(55,'N'),(56,'N'),(57,'N'),(58,'N'),(59,'N'),(60,'N'),(61,'N'),(62,'N'),(63,'N'),(64,'N'),(65,'N'),(66,'N'),(67,'N'),(68,'N'),(69,'N'),(70,'N'),(71,'N'),(72,'N'),(73,'N'),(74,'N'),(75,'N'),(76,'N'),(77,'N'),(78,'N'),(79,'N'),(80,'N'),(81,'N'),(82,'N'),(83,'N'),(84,'N'),(85,'N'),(86,'N'),(87,'N'),(88,'N'),(89,'N'),(90,'N'),(91,'N'),(92,'N'),(93,'N'),(94,'N'),(95,'N'),(96,'N'),(97,'N'),(98,'N'),(99,'N'),(100,'N'),(101,'N'),(102,'N'),(103,'N'),(104,'N'),(105,'N'),(106,'N'),(107,'N'),(108,'N'),(109,'N'),(110,'N'),(111,'N'),(112,'N'),(113,'N'),(114,'N'),(115,'N'),(116,'N'),(117,'N'),(118,'N'),(119,'N'),(120,'N'),(121,'N'),(122,'N'),(123,'N'),(124,'N'),(125,'N'),(126,'N'),(127,'N'),(128,'N'),(129,'N'),(130,'N'),(131,'N'),(132,'N'),(133,'N'),(134,'N'),(135,'N'),(136,'N'),(137,'N'),(138,'N'),(139,'N'),(140,'N'),(141,'N'),(142,'N'),(143,'N'),(144,'N'),(145,'N'),(146,'N'),(147,'N'),(148,'N'),(149,'N'),(150,'N'),(151,'N'),(152,'N'),(153,'N'),(154,'N'),(155,'N'),(156,'N'),(157,'N'),(158,'N'),(159,'N'),(160,'N'),(161,'N'),(162,'N'),(163,'N'),(164,'N'),(165,'N'),(166,'N'),(167,'N'),(168,'N'),(169,'N'),(170,'N'),(171,'N'),(172,'N'),(173,'N'),(174,'N'),(175,'N'),(176,'N'),(177,'N'),(178,'N'),(179,'N'),(180,'N'),(181,'N'),(182,'N'),(183,'N'),(184,'N'),(185,'N'),(186,'N'),(187,'N'),(188,'N'),(189,'N'),(190,'N'),(191,'N'),(192,'N'),(193,'N'),(194,'N'),(195,'N'),(196,'N'),(197,'N'),(198,'N'),(199,'N'),(200,'N'),(201,'N'),(202,'N'),(203,'N'),(204,'N'),(205,'N'),(206,'N'),(207,'N'),(208,'N'),(209,'N'),(210,'N'),(211,'N'),(212,'N'),(213,'N'),(214,'N'),(215,'N'),(216,'N'),(217,'N'),(218,'N'),(219,'N'),(220,'N'),(221,'N'),(222,'N'),(223,'N'),(224,'N'),(225,'N'),(226,'N'),(227,'N'),(228,'N'),(229,'N'),(230,'N'),(231,'N'),(232,'N'),(233,'N'),(234,'N'),(235,'N'),(236,'N'),(237,'N'),(238,'N'),(239,'N'),(240,'N'),(241,'N'),(242,'N'),(243,'N'),(244,'N'),(245,'N'),(246,'N'),(247,'N'),(248,'N'),(249,'N'),(250,'N'),(251,'N'),(252,'N'),(253,'N'),(254,'N'),(255,'N'),(256,'N'),(257,'N'),(258,'N'),(259,'N'),(260,'N'),(261,'N'),(262,'N'),(263,'N'),(264,'N'),(265,'N'),(266,'N'),(267,'N'),(268,'N'),(269,'N'),(270,'N'),(271,'N'),(272,'N'),(273,'N'),(274,'N'),(275,'N'),(276,'N'),(277,'N'),(278,'N'),(279,'N'),(280,'N'),(281,'N'),(282,'N'),(283,'N'),(284,'N'),(285,'N'),(286,'N'),(287,'N'),(288,'N'),(289,'N'),(290,'N'),(291,'N'),(292,'N'),(293,'N'),(294,'N'),(295,'N'),(296,'N'),(297,'N'),(298,'N'),(299,'N'),(300,'N'),(301,'N'),(302,'N'),(303,'N'),(304,'N'),(305,'N'),(306,'N'),(307,'N'),(308,'N'),(309,'N'),(310,'N'),(311,'N'),(312,'N'),(313,'N'),(314,'N'),(315,'N'),(316,'N'),(317,'N'),(318,'N'),(319,'N'),(320,'N'),(321,'N'),(322,'N'),(323,'N'),(324,'N'),(325,'N'),(326,'N'),(327,'N'),(328,'N'),(329,'N'),(330,'N'),(331,'N'),(332,'N'),(333,'N'),(334,'N'),(335,'N'),(336,'N'),(337,'N'),(338,'N'),(339,'N'),(340,'N'),(341,'N'),(342,'N'),(343,'N'),(344,'N'),(345,'N'),(346,'N'),(347,'N'),(348,'N'),(349,'N'),(350,'N'),(351,'N'),(352,'N'),(353,'N'),(354,'N'),(355,'N'),(356,'N'),(357,'N'),(358,'N'),(359,'N'),(360,'N'),(361,'N'),(362,'N'),(363,'N'),(364,'N'),(365,'N'),(366,'N'),(367,'N'),(368,'N'),(369,'N'),(370,'N'),(371,'N'),(372,'N'),(373,'N'),(374,'N'),(375,'N'),(376,'N'),(377,'N'),(378,'N'),(379,'N'),(380,'N'),(381,'N'),(382,'N'),(383,'N'),(384,'N'),(385,'N'),(386,'N'),(387,'N'),(388,'N'),(389,'N'),(390,'N'),(391,'N'),(392,'N'),(393,'N'),(394,'N'),(395,'N'),(396,'N'),(397,'N'),(398,'N'),(399,'N'),(400,'N'),(401,'N'),(402,'N'),(403,'N'),(404,'N'),(405,'N'),(406,'N'),(407,'N'),(408,'N'),(409,'N'),(410,'N'),(411,'N'),(412,'N'),(413,'N'),(414,'N'),(415,'N'),(416,'N'),(417,'N'),(418,'N'),(419,'N'),(420,'N'),(421,'N'),(422,'N'),(423,'N'),(424,'N'),(425,'N'),(426,'N'),(427,'N'),(428,'N'),(429,'N'),(430,'N'),(431,'N'),(432,'N'),(433,'N'),(434,'N'),(435,'N'),(436,'N'),(437,'N'),(438,'N'),(439,'N'),(440,'N'),(441,'N'),(442,'N'),(443,'N'),(444,'N'),(445,'N'),(446,'N'),(447,'N'),(448,'N'),(449,'N'),(450,'N'),(451,'N'),(452,'N'),(453,'N'),(454,'N'),(455,'N'),(456,'N'),(457,'N'),(458,'N'),(459,'N'),(460,'N'),(461,'N'),(462,'N'),(463,'N'),(464,'N'),(465,'N'),(466,'N'),(467,'N'),(468,'N'),(469,'N'),(470,'N'),(471,'N'),(472,'N'),(473,'N'),(474,'N'),(475,'N'),(476,'N'),(477,'N'),(478,'N'),(479,'N'),(480,'N'),(481,'N'),(482,'N'),(483,'N'),(484,'N'),(485,'N'),(486,'N'),(487,'N'),(488,'N'),(489,'N'),(490,'N'),(491,'N'),(492,'N'),(493,'N'),(494,'N'),(495,'N'),(496,'N'),(497,'N'),(498,'N'),(499,'N'),(500,'N'),(501,'N'),(502,'N'),(503,'N'),(504,'N'),(505,'N'),(506,'N'),(507,'N'),(508,'N'),(509,'N'),(510,'N'),(511,'N'),(512,'N'),(513,'N'),(514,'N'),(515,'N'),(516,'N'),(517,'N'),(518,'N'),(519,'N'),(520,'N'),(521,'N'),(522,'N'),(523,'N'),(524,'N'),(525,'N'),(526,'N'),(527,'N'),(528,'N'),(529,'N'),(530,'N'),(531,'N'),(532,'N'),(533,'N'),(534,'N'),(535,'N'),(536,'N'),(537,'N'),(538,'N'),(539,'N'),(540,'N'),(541,'N'),(542,'N'),(543,'N'),(544,'N'),(545,'N'),(546,'N'),(547,'N'),(548,'N'),(549,'N'),(550,'N'),(551,'N'),(552,'N'),(553,'N'),(554,'N'),(555,'N'),(556,'N'),(557,'N'),(558,'N'),(559,'N'),(560,'N'),(561,'N'),(562,'N'),(563,'N'),(564,'N'),(565,'N'),(566,'N'),(567,'N'),(568,'N'),(569,'N'),(570,'N'),(571,'N'),(572,'N'),(573,'N'),(574,'N'),(575,'N'),(576,'N'),(577,'N'),(578,'N'),(579,'N'),(580,'N'),(581,'N'),(582,'N'),(583,'N'),(584,'N'),(585,'N'),(586,'N'),(587,'N'),(588,'N'),(589,'N'),(590,'N'),(591,'N'),(592,'N'),(593,'N'),(594,'N'),(595,'N'),(596,'N'),(597,'N'),(598,'N'),(599,'N'),(600,'N'),(601,'N'),(602,'N'),(603,'N'),(604,'N'),(605,'N'),(606,'N'),(607,'N'),(608,'N'),(609,'N'),(610,'N'),(611,'N'),(612,'N'),(613,'N'),(614,'N'),(615,'N'),(616,'N'),(617,'N'),(618,'N'),(619,'N'),(620,'N'),(621,'N'),(622,'N'),(623,'N'),(624,'N'),(625,'N'),(626,'N'),(627,'N'),(628,'N'),(629,'N'),(630,'N'),(631,'N'),(632,'N'),(633,'N'),(634,'N'),(635,'N'),(636,'N'),(637,'N'),(638,'N'),(639,'N'),(640,'N'),(641,'N'),(642,'N'),(643,'N'),(644,'N'),(645,'N'),(646,'N'),(647,'N'),(648,'N'),(649,'N'),(650,'N'),(651,'N'),(652,'N'),(653,'N'),(654,'N'),(655,'N'),(656,'N'),(657,'N'),(658,'N'),(659,'N'),(660,'N'),(661,'N'),(662,'N'),(663,'N'),(664,'N'),(665,'N'),(666,'N'),(667,'N'),(668,'N'),(669,'N'),(670,'N'),(671,'N'),(672,'N'),(673,'N'),(674,'N'),(675,'N'),(676,'N'),(677,'N'),(678,'N'),(679,'N'),(680,'N'),(681,'N'),(682,'N'),(683,'N'),(684,'N'),(685,'N'),(686,'N'),(687,'N'),(688,'N'),(689,'N'),(690,'N'),(691,'N'),(692,'N'),(693,'N'),(694,'N'),(695,'N'),(696,'N'),(697,'N'),(698,'N'),(699,'N'),(700,'N'),(701,'N'),(702,'N'),(703,'N'),(704,'N'),(705,'N'),(706,'N'),(707,'N'),(708,'N'),(709,'N'),(710,'N'),(711,'N'),(712,'N'),(713,'N'),(714,'N'),(715,'N'),(716,'N'),(717,'N'),(718,'N'),(719,'N'),(720,'N'),(721,'N'),(722,'N'),(723,'N'),(724,'N'),(725,'N'),(726,'N'),(727,'N'),(728,'N'),(729,'N'),(730,'N'),(731,'N'),(732,'N'),(733,'N'),(734,'N'),(735,'N'),(736,'N'),(737,'N'),(738,'N'),(739,'N'),(740,'N'),(741,'N'),(742,'N'),(743,'N'),(744,'N'),(745,'N'),(746,'N'),(747,'N'),(748,'N'),(749,'N'),(750,'N'),(751,'N'),(752,'N'),(753,'N'),(754,'N'),(755,'N'),(756,'N'),(757,'N'),(758,'N'),(759,'N'),(760,'N'),(761,'N'),(762,'N'),(763,'N'),(764,'N'),(765,'N'),(766,'N'),(767,'N'),(768,'N'),(769,'N'),(770,'N'),(771,'N'),(772,'N'),(773,'N'),(774,'N'),(775,'N'),(776,'N'),(777,'N'),(778,'N'),(779,'N'),(780,'N'),(781,'N'),(782,'N'),(783,'N'),(784,'N'),(785,'N'),(786,'N'),(787,'N'),(788,'N'),(789,'N'),(790,'N'),(791,'N'),(792,'N'),(793,'N'),(794,'N'),(795,'N'),(796,'N'),(797,'N'),(798,'N'),(799,'N'),(800,'N'),(801,'N'),(802,'N'),(803,'N'),(804,'N'),(805,'N'),(806,'N'),(807,'N'),(808,'N'),(809,'N'),(810,'N'),(811,'N'),(812,'N'),(813,'N'),(814,'N'),(815,'N'),(816,'N'),(817,'N'),(818,'N'),(819,'N'),(820,'N'),(821,'N'),(822,'N'),(823,'N'),(824,'N'),(825,'N'),(826,'N'),(827,'N'),(828,'N'),(829,'N'),(830,'N'),(831,'N'),(832,'N'),(833,'N'),(834,'N'),(835,'N'),(836,'N'),(837,'N'),(838,'N'),(839,'N'),(840,'N'),(841,'N'),(842,'N'),(843,'N'),(844,'N'),(845,'N'),(846,'N'),(847,'N'),(848,'N'),(849,'N'),(850,'N'),(851,'N'),(852,'N'),(853,'N'),(854,'N'),(855,'N'),(856,'N'),(857,'N'),(858,'N'),(859,'N'),(860,'N'),(861,'N'),(862,'N'),(863,'N'),(864,'N'),(865,'N'),(866,'N'),(867,'N'),(868,'N'),(869,'N'),(870,'N'),(871,'N'),(872,'N'),(873,'N'),(874,'N'),(875,'N'),(876,'N'),(877,'N'),(878,'N'),(879,'N'),(880,'N'),(881,'N'),(882,'N'),(883,'N'),(884,'N'),(885,'N'),(886,'N'),(887,'N'),(888,'N'),(889,'N'),(890,'N'),(891,'N'),(892,'N'),(893,'N'),(894,'N'),(895,'N'),(896,'N'),(897,'N'),(898,'N'),(899,'N'),(900,'N'),(901,'N'),(902,'N'),(903,'N'),(904,'N'),(905,'N'),(906,'N'),(907,'N'),(908,'N'),(909,'N'),(910,'N'),(911,'N'),(912,'N'),(913,'N'),(914,'N'),(915,'N'),(916,'N'),(917,'N'),(918,'N'),(919,'N'),(920,'N'),(921,'N'),(922,'N'),(923,'N'),(924,'N'),(925,'N'),(926,'N'),(927,'N'),(928,'N'),(929,'N'),(930,'N'),(931,'N'),(932,'N'),(933,'N'),(934,'N'),(935,'N'),(936,'N'),(937,'N'),(938,'N'),(939,'N'),(940,'N'),(941,'N'),(942,'N'),(943,'N'),(944,'N'),(945,'N'),(946,'N'),(947,'N'),(948,'N'),(949,'N'),(950,'N'),(951,'N'),(952,'N'),(953,'N'),(954,'N'),(955,'N'),(956,'N'),(957,'N'),(958,'N'),(959,'N'),(960,'N'),(961,'N'),(962,'N'),(963,'N'),(964,'N'),(965,'N'),(966,'N'),(967,'N'),(968,'N'),(969,'N'),(970,'N'),(971,'N'),(972,'N'),(973,'N'),(974,'N'),(975,'N'),(976,'N'),(977,'N'),(978,'N'),(979,'N'),(980,'N'),(981,'N'),(982,'N'),(983,'N'),(984,'N'),(985,'N'),(986,'N'),(987,'N'),(988,'N'),(989,'N'),(990,'N'),(991,'N'),(992,'N'),(993,'N'),(994,'N'),(995,'N'),(996,'N'),(997,'N'),(998,'N'),(999,'N'),(1000,'N'),(1001,'N'),(1002,'N'),(1003,'N'),(1004,'N'),(1005,'N'),(1006,'N'),(1007,'N'),(1008,'N'),(1009,'N'),(1010,'N'),(1011,'N'),(1012,'N'),(1013,'N'),(1014,'N'),(1015,'N'),(1016,'N'),(1017,'N'),(1018,'N'),(1019,'N'),(1020,'N'),(1021,'N'),(1022,'N'),(1023,'N'),(1024,'N'),(1025,'N'),(1026,'N'),(1027,'N'),(1028,'N'),(1029,'N'),(1030,'N'),(1031,'N'),(1032,'N'),(1033,'N'),(1034,'N'),(1035,'N'),(1036,'N'),(1037,'N'),(1038,'N'),(1039,'N'),(1040,'N'),(1041,'N'),(1042,'N'),(1043,'N'),(1044,'N'),(1045,'N'),(1046,'N'),(1047,'N'),(1048,'N'),(1049,'N'),(1050,'N'),(1051,'N'),(1052,'N'),(1053,'N'),(1054,'N'),(1055,'N'),(1056,'N'),(1057,'N'),(1058,'N'),(1059,'N'),(1060,'N'),(1061,'N'),(1062,'N'),(1063,'N'),(1064,'N'),(1065,'N'),(1066,'N'),(1067,'N'),(1068,'N'),(1069,'N'),(1070,'N'),(1071,'N'),(1072,'N'),(1073,'N'),(1074,'N'),(1075,'N'),(1076,'N'),(1077,'N'),(1078,'N'),(1079,'N'),(1080,'N'),(1081,'N'),(1082,'N'),(1083,'N'),(1084,'N'),(1085,'N'),(1086,'N'),(1087,'N'),(1088,'N'),(1089,'N'),(1090,'N'),(1091,'N'),(1092,'N'),(1093,'N'),(1094,'N'),(1095,'N'),(1096,'N'),(1097,'N'),(1098,'N'),(1099,'N'),(1100,'N'),(1101,'N'),(1102,'N'),(1103,'N'),(1104,'N'),(1105,'N'),(1106,'N'),(1107,'N'),(1108,'N'),(1109,'N'),(1110,'N'),(1111,'N'),(1112,'N'),(1113,'N'),(1114,'N'),(1115,'N'),(1116,'N'),(1117,'N'),(1118,'N'),(1119,'N'),(1120,'N'),(1121,'N'),(1122,'N'),(1123,'N'),(1124,'N'),(1125,'N'),(1126,'N'),(1127,'N'),(1128,'N'),(1129,'N'),(1130,'N'),(1131,'N'),(1132,'N'),(1133,'N'),(1134,'N'),(1135,'N'),(1136,'N'),(1137,'N'),(1138,'N'),(1139,'N'),(1140,'N'),(1141,'N'),(1142,'N'),(1143,'N'),(1144,'N'),(1145,'N'),(1146,'N'),(1147,'N'),(1148,'N'),(1149,'N'),(1150,'N'),(1151,'N'),(1152,'N'),(1153,'N'),(1154,'N'),(1155,'N'),(1156,'N'),(1157,'N'),(1158,'N'),(1159,'N'),(1160,'N'),(1161,'N'),(1162,'N'),(1163,'N'),(1164,'N'),(1165,'N'),(1166,'N'),(1167,'N'),(1168,'N'),(1169,'N'),(1170,'N'),(1171,'N'),(1172,'N'),(1173,'N'),(1174,'N'),(1175,'N'),(1176,'N'),(1177,'N'),(1178,'N'),(1179,'N'),(1180,'N'),(1181,'N'),(1182,'N'),(1183,'N'),(1184,'N'),(1185,'N'),(1186,'N'),(1187,'N'),(1188,'N'),(1189,'N'),(1190,'N'),(1191,'N'),(1192,'N'),(1193,'N'),(1194,'Y'),(1195,'Y'),(1196,'Y'),(1197,'Y'),(1198,'Y'),(1199,'Y'),(1200,'Y'),(1201,'Y'),(1202,'Y'),(1203,'Y'),(1204,'Y'),(1205,'Y'),(1206,'Y'),(1207,'Y'),(1208,'Y'),(1209,'Y'),(1210,'Y'),(1211,'Y'),(1212,'Y'),(1213,'Y'),(1214,'Y'),(1215,'Y'),(1216,'Y'),(1217,'Y'),(1218,'Y'),(1219,'Y'),(1220,'Y'),(1221,'Y'),(1222,'Y'),(1223,'Y'),(1224,'Y'),(1225,'Y'),(1226,'Y'),(1227,'Y'),(1228,'Y'),(1229,'Y'),(1230,'Y'),(1231,'Y'),(1232,'Y'),(1233,'Y'),(1234,'Y'),(1235,'Y'),(1236,'Y'),(1237,'Y'),(1238,'Y'),(1239,'Y'),(1240,'Y'),(1241,'Y'),(1242,'Y'),(1243,'Y'),(1244,'Y'),(1245,'Y'),(1246,'Y'),(1247,'Y'),(1248,'Y'),(1249,'Y'),(1250,'Y'),(1251,'Y'),(1252,'Y'),(1253,'Y'),(1254,'Y'),(1255,'Y'),(1256,'Y'),(1257,'Y'),(1258,'Y'),(1259,'Y'),(1260,'Y'),(1261,'Y'),(1262,'Y'),(1263,'Y'),(1264,'Y'),(1265,'Y'),(1266,'Y'),(1267,'Y'),(1268,'Y'),(1269,'Y'),(1270,'Y'),(1271,'Y'),(1272,'Y'),(1273,'Y'),(1274,'Y'),(1275,'Y'),(1276,'Y'),(1277,'Y'),(1278,'Y'),(1279,'Y'),(1280,'Y'),(1281,'Y'),(1282,'Y'),(1283,'Y'),(1284,'Y'),(1285,'Y'),(1286,'Y'),(1287,'Y'),(1288,'Y'),(1289,'Y'),(1290,'Y'),(1291,'Y'),(1292,'Y'),(1293,'Y'),(1294,'Y'),(1295,'Y'),(1296,'Y'),(1297,'Y'),(1298,'Y'),(1299,'Y'),(1300,'Y'),(1301,'Y'),(1302,'Y'),(1303,'Y'),(1304,'Y'),(1305,'Y'),(1306,'Y'),(1307,'Y'),(1308,'Y'),(1309,'Y'),(1310,'Y'),(1311,'Y'),(1312,'Y'),(1313,'Y'),(1314,'Y'),(1315,'Y'),(1316,'Y'),(1317,'Y'),(1318,'Y'),(1319,'Y'),(1320,'Y'),(1321,'Y'),(1322,'Y'),(1323,'Y'),(1324,'Y'),(1325,'Y'),(1326,'Y'),(1327,'Y'),(1328,'Y'),(1329,'Y'),(1330,'Y'),(1331,'Y'),(1332,'Y'),(1333,'Y'),(1334,'Y'),(1335,'Y'),(1336,'Y'),(1337,'Y'),(1338,'Y'),(1339,'Y'),(1340,'Y'),(1341,'Y'),(1342,'Y'),(1343,'Y'),(1344,'Y'),(1345,'Y'),(1346,'Y'),(1347,'Y'),(1348,'Y'),(1349,'Y'),(1350,'Y'),(1351,'Y'),(1352,'Y'),(1353,'Y'),(1354,'Y'),(1355,'Y'),(1356,'Y'),(1357,'Y'),(1358,'Y'),(1359,'Y'),(1360,'Y'),(1361,'Y'),(1362,'Y'),(1363,'Y'),(1364,'Y'),(1365,'Y'),(1366,'Y'),(1367,'Y'),(1368,'Y'),(1369,'Y'),(1370,'Y'),(1371,'Y'),(1372,'Y'),(1373,'Y'),(1374,'Y'),(1375,'Y'),(1376,'Y'),(1377,'Y'),(1378,'Y'),(1379,'Y'),(1380,'Y'),(1381,'Y'),(1382,'Y'),(1383,'Y'),(1384,'Y'),(1385,'Y'),(1386,'Y'),(1387,'Y'),(1388,'Y'),(1389,'Y'),(1390,'Y'),(1391,'Y'),(1392,'Y'),(1393,'Y'),(1394,'Y'),(1395,'Y'),(1396,'Y'),(1397,'Y'),(1398,'Y'),(1399,'Y'),(1400,'Y'),(1401,'Y'),(1402,'Y'),(1403,'Y'),(1404,'Y'),(1405,'Y'),(1406,'Y'),(1407,'Y'),(1408,'Y'),(1409,'Y'),(1410,'Y'),(1411,'Y'),(1412,'Y'),(1413,'Y'),(1414,'Y'),(1415,'Y'),(1416,'Y'),(1417,'Y'),(1418,'Y'),(1419,'Y'),(1420,'Y'),(1421,'Y'),(1422,'Y'),(1423,'Y'),(1424,'Y'),(1425,'Y'),(1426,'Y'),(1427,'Y'),(1428,'Y'),(1429,'Y'),(1430,'Y'),(1431,'Y'),(1432,'Y'),(1433,'Y'),(1434,'Y'),(1435,'Y'),(1436,'Y'),(1437,'Y'),(1438,'Y'),(1439,'Y'),(1440,'Y'),(1441,'Y'),(1442,'Y'),(1443,'Y'),(1444,'Y'),(1445,'Y'),(1446,'Y'),(1447,'Y'),(1448,'Y'),(1449,'Y'),(1450,'Y'),(1451,'Y'),(1452,'Y'),(1453,'Y'),(1454,'Y'),(1455,'Y'),(1456,'Y'),(1457,'Y'),(1458,'Y'),(1459,'Y'),(1460,'Y'),(1461,'Y'),(1462,'Y'),(1463,'Y'),(1464,'Y'),(1465,'Y'),(1466,'Y'),(1467,'Y'),(1468,'Y'),(1469,'Y'),(1470,'Y'),(1471,'Y'),(1472,'Y'),(1473,'Y'),(1474,'Y'),(1475,'Y'),(1476,'Y'),(1477,'Y'),(1478,'Y'),(1479,'Y'),(1480,'Y'),(1481,'Y'),(1482,'Y'),(1483,'Y'),(1484,'Y'),(1485,'Y'),(1486,'Y'),(1487,'Y'),(1488,'Y'),(1489,'Y'),(1490,'Y'),(1491,'Y'),(1492,'Y'),(1493,'Y'),(1494,'Y'),(1495,'Y'),(1496,'Y'),(1497,'Y'),(1498,'Y'),(1499,'Y'),(1500,'Y'),(1501,'Y'),(1502,'Y'),(1503,'Y'),(1504,'Y'),(1505,'Y'),(1506,'Y'),(1507,'Y'),(1508,'Y'),(1509,'Y'),(1510,'Y'),(1511,'Y'),(1512,'Y'),(1513,'Y'),(1514,'Y'),(1515,'Y'),(1516,'Y'),(1517,'Y'),(1518,'Y'),(1519,'Y'),(1520,'Y'),(1521,'Y'),(1522,'Y'),(1523,'Y'),(1524,'Y'),(1525,'Y'),(1526,'Y'),(1527,'Y'),(1528,'Y'),(1529,'Y'),(1530,'Y'),(1531,'Y'),(1532,'Y'),(1533,'Y'),(1534,'Y'),(1535,'Y'),(1536,'Y'),(1537,'Y'),(1538,'Y'),(1539,'Y'),(1540,'Y'),(1541,'Y'),(1542,'Y'),(1543,'Y'),(1544,'Y'),(1545,'Y'),(1546,'Y'),(1547,'Y'),(1548,'Y'),(1549,'Y'),(1550,'Y'),(1551,'Y'),(1552,'Y'),(1553,'Y'),(1554,'Y'),(1555,'Y'),(1556,'Y'),(1557,'Y'),(1558,'Y'),(1559,'Y'),(1560,'Y'),(1561,'Y'),(1562,'Y'),(1563,'Y'),(1564,'Y'),(1565,'Y'),(1566,'Y'),(1567,'Y'),(1568,'Y'),(1569,'Y'),(1570,'Y'),(1571,'Y'),(1572,'Y'),(1573,'Y'),(1574,'Y'),(1575,'Y'),(1576,'Y'),(1577,'Y'),(1578,'Y'),(1579,'Y'),(1580,'Y'),(1581,'Y'),(1582,'Y'),(1583,'Y'),(1584,'Y'),(1585,'Y'),(1586,'Y'),(1587,'Y'),(1588,'Y'),(1589,'Y'),(1590,'Y'),(1591,'Y'),(1592,'Y'),(1593,'Y'),(1594,'Y'),(1595,'Y'),(1596,'Y'),(1597,'Y'),(1598,'Y'),(1599,'Y'),(1600,'Y'),(1601,'Y'),(1602,'Y'),(1603,'Y'),(1604,'Y'),(1605,'Y'),(1606,'Y'),(1607,'Y'),(1608,'Y'),(1609,'Y'),(1610,'Y'),(1611,'Y'),(1612,'Y'),(1613,'Y'),(1614,'Y'),(1615,'Y'),(1616,'Y'),(1617,'Y'),(1618,'Y'),(1619,'Y'),(1620,'Y'),(1621,'Y'),(1622,'Y'),(1623,'Y'),(1624,'Y'),(1625,'Y'),(1626,'Y'),(1627,'Y'),(1628,'Y'),(1629,'Y'),(1630,'Y'),(1631,'Y'),(1632,'Y'),(1633,'Y'),(1634,'Y'),(1635,'Y'),(1636,'Y'),(1637,'Y'),(1638,'Y'),(1639,'Y'),(1640,'Y'),(1641,'Y'),(1642,'Y'),(1643,'Y'),(1644,'Y'),(1645,'Y'),(1646,'Y'),(1647,'Y'),(1648,'Y'),(1649,'Y'),(1650,'Y'),(1651,'Y'),(1652,'Y'),(1653,'Y'),(1654,'Y'),(1655,'Y'),(1656,'Y'),(1657,'Y'),(1658,'Y'),(1659,'Y'),(1660,'Y'),(1661,'Y'),(1662,'Y'),(1663,'Y'),(1664,'Y'),(1665,'Y'),(1666,'Y'),(1667,'Y'),(1668,'Y'),(1669,'Y'),(1670,'Y'),(1671,'Y'),(1672,'Y'),(1673,'Y'),(1674,'Y'),(1675,'Y'),(1676,'Y'),(1677,'Y'),(1678,'Y'),(1679,'Y'),(1680,'Y'),(1681,'Y'),(1682,'Y'),(1683,'Y'),(1684,'Y'),(1685,'Y'),(1686,'Y'),(1687,'Y'),(1688,'Y'),(1689,'Y'),(1690,'Y'),(1691,'Y'),(1692,'Y'),(1693,'Y'),(1694,'Y'),(1695,'Y'),(1696,'Y'),(1697,'Y'),(1698,'Y'),(1699,'Y'),(1700,'Y'),(1701,'Y'),(1702,'Y'),(1703,'Y'),(1704,'Y'),(1705,'Y'),(1706,'Y'),(1707,'Y'),(1708,'Y'),(1709,'Y'),(1710,'Y'),(1711,'Y'),(1712,'Y'),(1713,'Y'),(1714,'Y'),(1715,'Y'),(1716,'Y'),(1717,'Y'),(1718,'Y'),(1719,'Y'),(1720,'Y'),(1721,'Y'),(1722,'Y'),(1723,'Y'),(1724,'Y'),(1725,'Y'),(1726,'Y'),(1727,'Y'),(1728,'Y'),(1729,'Y'),(1730,'Y'),(1731,'Y'),(1732,'Y'),(1733,'Y'),(1734,'Y'),(1735,'Y'),(1736,'Y'),(1737,'Y'),(1738,'Y'),(1739,'Y'),(1740,'Y'),(1741,'Y'),(1742,'Y'),(1743,'Y'),(1744,'Y'),(1745,'Y'),(1746,'Y'),(1747,'Y'),(1748,'Y'),(1749,'Y'),(1750,'Y'),(1751,'Y'),(1752,'Y'),(1753,'Y'),(1754,'Y'),(1755,'Y'),(1756,'Y'),(1757,'Y'),(1758,'Y'),(1759,'Y'),(1760,'Y'),(1761,'Y'),(1762,'Y'),(1763,'Y'),(1764,'Y'),(1765,'Y'),(1766,'Y'),(1767,'Y'),(1768,'Y'),(1769,'Y'),(1770,'Y'),(1771,'Y'),(1772,'Y'),(1773,'Y'),(1774,'Y'),(1775,'Y'),(1776,'Y'),(1777,'Y'),(1778,'Y'),(1779,'Y'),(1780,'Y'),(1781,'Y'),(1782,'Y'),(1783,'Y'),(1784,'Y'),(1785,'Y'),(1786,'Y'),(1787,'Y'),(1788,'Y'),(1789,'Y');
/*!40000 ALTER TABLE `time_zone` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `time_zone_leap_second`
--

DROP TABLE IF EXISTS `time_zone_leap_second`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `time_zone_leap_second` (
  `Transition_time` bigint NOT NULL,
  `Correction` int NOT NULL,
  PRIMARY KEY (`Transition_time`)
) /*!50100 TABLESPACE `mysql` */ ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 STATS_PERSISTENT=0 ROW_FORMAT=DYNAMIC COMMENT='Leap seconds information for time zones';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `time_zone_leap_second`
--

LOCK TABLES `time_zone_leap_second` WRITE;
/*!40000 ALTER TABLE `time_zone_leap_second` DISABLE KEYS */;
/*!40000 ALTER TABLE `time_zone_leap_second` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `time_zone_name`
--

DROP TABLE IF EXISTS `time_zone_name`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `time_zone_name` (
  `Name` char(64) NOT NULL,
  `Time_zone_id` int unsigned NOT NULL,
  PRIMARY KEY (`Name`)
) /*!50100 TABLESPACE `mysql` */ ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 STATS_PERSISTENT=0 ROW_FORMAT=DYNAMIC COMMENT='Time zone names';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `time_zone_name`
--

LOCK TABLES `time_zone_name` WRITE;
/*!40000 ALTER TABLE `time_zone_name` DISABLE KEYS */;
INSERT INTO `time_zone_name` VALUES ('Africa/Abidjan',1),('Africa/Accra',2),('Africa/Addis_Ababa',3),('Africa/Algiers',4),('Africa/Asmara',5),('Africa/Asmera',6),('Africa/Bamako',7),('Africa/Bangui',8),('Africa/Banjul',9),('Africa/Bissau',10),('Africa/Blantyre',11),('Africa/Brazzaville',12),('Africa/Bujumbura',13),('Africa/Cairo',14),('Africa/Casablanca',15),('Africa/Ceuta',16),('Africa/Conakry',17),('Africa/Dakar',18),('Africa/Dar_es_Salaam',19),('Africa/Djibouti',20),('Africa/Douala',21),('Africa/El_Aaiun',22),('Africa/Freetown',23),('Africa/Gaborone',24),('Africa/Harare',25),('Africa/Johannesburg',26),('Africa/Juba',27),('Africa/Kampala',28),('Africa/Khartoum',29),('Africa/Kigali',30),('Africa/Kinshasa',31),('Africa/Lagos',32),('Africa/Libreville',33),('Africa/Lome',34),('Africa/Luanda',35),('Africa/Lubumbashi',36),('Africa/Lusaka',37),('Africa/Malabo',38),('Africa/Maputo',39),('Africa/Maseru',40),('Africa/Mbabane',41),('Africa/Mogadishu',42),('Africa/Monrovia',43),('Africa/Nairobi',44),('Africa/Ndjamena',45),('Africa/Niamey',46),('Africa/Nouakchott',47),('Africa/Ouagadougou',48),('Africa/Porto-Novo',49),('Africa/Sao_Tome',50),('Africa/Timbuktu',51),('Africa/Tripoli',52),('Africa/Tunis',53),('Africa/Windhoek',54),('America/Adak',55),('America/Anchorage',56),('America/Anguilla',57),('America/Antigua',58),('America/Araguaina',59),('America/Argentina/Buenos_Aires',60),('America/Argentina/Catamarca',61),('America/Argentina/ComodRivadavia',62),('America/Argentina/Cordoba',63),('America/Argentina/Jujuy',64),('America/Argentina/La_Rioja',65),('America/Argentina/Mendoza',66),('America/Argentina/Rio_Gallegos',67),('America/Argentina/Salta',68),('America/Argentina/San_Juan',69),('America/Argentina/San_Luis',70),('America/Argentina/Tucuman',71),('America/Argentina/Ushuaia',72),('America/Aruba',73),('America/Asuncion',74),('America/Atikokan',75),('America/Atka',76),('America/Bahia',77),('America/Bahia_Banderas',78),('America/Barbados',79),('America/Belem',80),('America/Belize',81),('America/Blanc-Sablon',82),('America/Boa_Vista',83),('America/Bogota',84),('America/Boise',85),('America/Buenos_Aires',86),('America/Cambridge_Bay',87),('America/Campo_Grande',88),('America/Cancun',89),('America/Caracas',90),('America/Catamarca',91),('America/Cayenne',92),('America/Cayman',93),('America/Chicago',94),('America/Chihuahua',95),('America/Ciudad_Juarez',96),('America/Coral_Harbour',97),('America/Cordoba',98),('America/Costa_Rica',99),('America/Creston',100),('America/Cuiaba',101),('America/Curacao',102),('America/Danmarkshavn',103),('America/Dawson',104),('America/Dawson_Creek',105),('America/Denver',106),('America/Detroit',107),('America/Dominica',108),('America/Edmonton',109),('America/Eirunepe',110),('America/El_Salvador',111),('America/Ensenada',112),('America/Fortaleza',115),('America/Fort_Nelson',113),('America/Fort_Wayne',114),('America/Glace_Bay',116),('America/Godthab',117),('America/Goose_Bay',118),('America/Grand_Turk',119),('America/Grenada',120),('America/Guadeloupe',121),('America/Guatemala',122),('America/Guayaquil',123),('America/Guyana',124),('America/Halifax',125),('America/Havana',126),('America/Hermosillo',127),('America/Indiana/Indianapolis',128),('America/Indiana/Knox',129),('America/Indiana/Marengo',130),('America/Indiana/Petersburg',131),('America/Indiana/Tell_City',132),('America/Indiana/Vevay',133),('America/Indiana/Vincennes',134),('America/Indiana/Winamac',135),('America/Indianapolis',136),('America/Inuvik',137),('America/Iqaluit',138),('America/Jamaica',139),('America/Jujuy',140),('America/Juneau',141),('America/Kentucky/Louisville',142),('America/Kentucky/Monticello',143),('America/Knox_IN',144),('America/Kralendijk',145),('America/La_Paz',146),('America/Lima',147),('America/Los_Angeles',148),('America/Louisville',149),('America/Lower_Princes',150),('America/Maceio',151),('America/Managua',152),('America/Manaus',153),('America/Marigot',154),('America/Martinique',155),('America/Matamoros',156),('America/Mazatlan',157),('America/Mendoza',158),('America/Menominee',159),('America/Merida',160),('America/Metlakatla',161),('America/Mexico_City',162),('America/Miquelon',163),('America/Moncton',164),('America/Monterrey',165),('America/Montevideo',166),('America/Montreal',167),('America/Montserrat',168),('America/Nassau',169),('America/New_York',170),('America/Nipigon',171),('America/Nome',172),('America/Noronha',173),('America/North_Dakota/Beulah',174),('America/North_Dakota/Center',175),('America/North_Dakota/New_Salem',176),('America/Nuuk',177),('America/Ojinaga',178),('America/Panama',179),('America/Pangnirtung',180),('America/Paramaribo',181),('America/Phoenix',182),('America/Port-au-Prince',183),('America/Porto_Acre',185),('America/Porto_Velho',186),('America/Port_of_Spain',184),('America/Puerto_Rico',187),('America/Punta_Arenas',188),('America/Rainy_River',189),('America/Rankin_Inlet',190),('America/Recife',191),('America/Regina',192),('America/Resolute',193),('America/Rio_Branco',194),('America/Rosario',195),('America/Santarem',197),('America/Santa_Isabel',196),('America/Santiago',198),('America/Santo_Domingo',199),('America/Sao_Paulo',200),('America/Scoresbysund',201),('America/Shiprock',202),('America/Sitka',203),('America/St_Barthelemy',204),('America/St_Johns',205),('America/St_Kitts',206),('America/St_Lucia',207),('America/St_Thomas',208),('America/St_Vincent',209),('America/Swift_Current',210),('America/Tegucigalpa',211),('America/Thule',212),('America/Thunder_Bay',213),('America/Tijuana',214),('America/Toronto',215),('America/Tortola',216),('America/Vancouver',217),('America/Virgin',218),('America/Whitehorse',219),('America/Winnipeg',220),('America/Yakutat',221),('America/Yellowknife',222),('Antarctica/Casey',223),('Antarctica/Davis',224),('Antarctica/DumontDUrville',225),('Antarctica/Macquarie',226),('Antarctica/Mawson',227),('Antarctica/McMurdo',228),('Antarctica/Palmer',229),('Antarctica/Rothera',230),('Antarctica/South_Pole',231),('Antarctica/Syowa',232),('Antarctica/Troll',233),('Antarctica/Vostok',234),('Arctic/Longyearbyen',235),('Asia/Aden',236),('Asia/Almaty',237),('Asia/Amman',238),('Asia/Anadyr',239),('Asia/Aqtau',240),('Asia/Aqtobe',241),('Asia/Ashgabat',242),('Asia/Ashkhabad',243),('Asia/Atyrau',244),('Asia/Baghdad',245),('Asia/Bahrain',246),('Asia/Baku',247),('Asia/Bangkok',248),('Asia/Barnaul',249),('Asia/Beirut',250),('Asia/Bishkek',251),('Asia/Brunei',252),('Asia/Calcutta',253),('Asia/Chita',254),('Asia/Choibalsan',255),('Asia/Chongqing',256),('Asia/Chungking',257),('Asia/Colombo',258),('Asia/Dacca',259),('Asia/Damascus',260),('Asia/Dhaka',261),('Asia/Dili',262),('Asia/Dubai',263),('Asia/Dushanbe',264),('Asia/Famagusta',265),('Asia/Gaza',266),('Asia/Harbin',267),('Asia/Hebron',268),('Asia/Hong_Kong',270),('Asia/Hovd',271),('Asia/Ho_Chi_Minh',269),('Asia/Irkutsk',272),('Asia/Istanbul',273),('Asia/Jakarta',274),('Asia/Jayapura',275),('Asia/Jerusalem',276),('Asia/Kabul',277),('Asia/Kamchatka',278),('Asia/Karachi',279),('Asia/Kashgar',280),('Asia/Kathmandu',281),('Asia/Katmandu',282),('Asia/Khandyga',283),('Asia/Kolkata',284),('Asia/Krasnoyarsk',285),('Asia/Kuala_Lumpur',286),('Asia/Kuching',287),('Asia/Kuwait',288),('Asia/Macao',289),('Asia/Macau',290),('Asia/Magadan',291),('Asia/Makassar',292),('Asia/Manila',293),('Asia/Muscat',294),('Asia/Nicosia',295),('Asia/Novokuznetsk',296),('Asia/Novosibirsk',297),('Asia/Omsk',298),('Asia/Oral',299),('Asia/Phnom_Penh',300),('Asia/Pontianak',301),('Asia/Pyongyang',302),('Asia/Qatar',303),('Asia/Qostanay',304),('Asia/Qyzylorda',305),('Asia/Rangoon',306),('Asia/Riyadh',307),('Asia/Saigon',308),('Asia/Sakhalin',309),('Asia/Samarkand',310),('Asia/Seoul',311),('Asia/Shanghai',312),('Asia/Singapore',313),('Asia/Srednekolymsk',314),('Asia/Taipei',315),('Asia/Tashkent',316),('Asia/Tbilisi',317),('Asia/Tehran',318),('Asia/Tel_Aviv',319),('Asia/Thimbu',320),('Asia/Thimphu',321),('Asia/Tokyo',322),('Asia/Tomsk',323),('Asia/Ujung_Pandang',324),('Asia/Ulaanbaatar',325),('Asia/Ulan_Bator',326),('Asia/Urumqi',327),('Asia/Ust-Nera',328),('Asia/Vientiane',329),('Asia/Vladivostok',330),('Asia/Yakutsk',331),('Asia/Yangon',332),('Asia/Yekaterinburg',333),('Asia/Yerevan',334),('Atlantic/Azores',335),('Atlantic/Bermuda',336),('Atlantic/Canary',337),('Atlantic/Cape_Verde',338),('Atlantic/Faeroe',339),('Atlantic/Faroe',340),('Atlantic/Jan_Mayen',341),('Atlantic/Madeira',342),('Atlantic/Reykjavik',343),('Atlantic/South_Georgia',344),('Atlantic/Stanley',346),('Atlantic/St_Helena',345),('Australia/ACT',347),('Australia/Adelaide',348),('Australia/Brisbane',349),('Australia/Broken_Hill',350),('Australia/Canberra',351),('Australia/Currie',352),('Australia/Darwin',353),('Australia/Eucla',354),('Australia/Hobart',355),('Australia/LHI',356),('Australia/Lindeman',357),('Australia/Lord_Howe',358),('Australia/Melbourne',359),('Australia/North',361),('Australia/NSW',360),('Australia/Perth',362),('Australia/Queensland',363),('Australia/South',364),('Australia/Sydney',365),('Australia/Tasmania',366),('Australia/Victoria',367),('Australia/West',368),('Australia/Yancowinna',369),('Brazil/Acre',370),('Brazil/DeNoronha',371),('Brazil/East',372),('Brazil/West',373),('Canada/Atlantic',376),('Canada/Central',377),('Canada/Eastern',378),('Canada/Mountain',379),('Canada/Newfoundland',380),('Canada/Pacific',381),('Canada/Saskatchewan',382),('Canada/Yukon',383),('CET',374),('Chile/Continental',384),('Chile/EasterIsland',385),('CST6CDT',375),('Cuba',386),('EET',387),('Egypt',390),('Eire',391),('EST',388),('EST5EDT',389),('Etc/GMT',392),('Etc/GMT+0',393),('Etc/GMT+1',394),('Etc/GMT+10',395),('Etc/GMT+11',396),('Etc/GMT+12',397),('Etc/GMT+2',398),('Etc/GMT+3',399),('Etc/GMT+4',400),('Etc/GMT+5',401),('Etc/GMT+6',402),('Etc/GMT+7',403),('Etc/GMT+8',404),('Etc/GMT+9',405),('Etc/GMT-0',406),('Etc/GMT-1',407),('Etc/GMT-10',408),('Etc/GMT-11',409),('Etc/GMT-12',410),('Etc/GMT-13',411),('Etc/GMT-14',412),('Etc/GMT-2',413),('Etc/GMT-3',414),('Etc/GMT-4',415),('Etc/GMT-5',416),('Etc/GMT-6',417),('Etc/GMT-7',418),('Etc/GMT-8',419),('Etc/GMT-9',420),('Etc/GMT0',421),('Etc/Greenwich',422),('Etc/UCT',423),('Etc/Universal',425),('Etc/UTC',424),('Etc/Zulu',426),('Europe/Amsterdam',427),('Europe/Andorra',428),('Europe/Astrakhan',429),('Europe/Athens',430),('Europe/Belfast',431),('Europe/Belgrade',432),('Europe/Berlin',433),('Europe/Bratislava',434),('Europe/Brussels',435),('Europe/Bucharest',436),('Europe/Budapest',437),('Europe/Busingen',438),('Europe/Chisinau',439),('Europe/Copenhagen',440),('Europe/Dublin',441),('Europe/Gibraltar',442),('Europe/Guernsey',443),('Europe/Helsinki',444),('Europe/Isle_of_Man',445),('Europe/Istanbul',446),('Europe/Jersey',447),('Europe/Kaliningrad',448),('Europe/Kiev',449),('Europe/Kirov',450),('Europe/Kyiv',451),('Europe/Lisbon',452),('Europe/Ljubljana',453),('Europe/London',454),('Europe/Luxembourg',455),('Europe/Madrid',456),('Europe/Malta',457),('Europe/Mariehamn',458),('Europe/Minsk',459),('Europe/Monaco',460),('Europe/Moscow',461),('Europe/Nicosia',462),('Europe/Oslo',463),('Europe/Paris',464),('Europe/Podgorica',465),('Europe/Prague',466),('Europe/Riga',467),('Europe/Rome',468),('Europe/Samara',469),('Europe/San_Marino',470),('Europe/Sarajevo',471),('Europe/Saratov',472),('Europe/Simferopol',473),('Europe/Skopje',474),('Europe/Sofia',475),('Europe/Stockholm',476),('Europe/Tallinn',477),('Europe/Tirane',478),('Europe/Tiraspol',479),('Europe/Ulyanovsk',480),('Europe/Uzhgorod',481),('Europe/Vaduz',482),('Europe/Vatican',483),('Europe/Vienna',484),('Europe/Vilnius',485),('Europe/Volgograd',486),('Europe/Warsaw',487),('Europe/Zagreb',488),('Europe/Zaporozhye',489),('Europe/Zurich',490),('GB',491),('GB-Eire',492),('GMT',493),('GMT+0',494),('GMT-0',495),('GMT0',496),('Greenwich',497),('Hongkong',499),('HST',498),('Iceland',500),('Indian/Antananarivo',501),('Indian/Chagos',502),('Indian/Christmas',503),('Indian/Cocos',504),('Indian/Comoro',505),('Indian/Kerguelen',506),('Indian/Mahe',507),('Indian/Maldives',508),('Indian/Mauritius',509),('Indian/Mayotte',510),('Indian/Reunion',511),('Iran',512),('Israel',513),('Jamaica',514),('Japan',515),('Kwajalein',516),('Libya',517),('MET',518),('Mexico/BajaNorte',521),('Mexico/BajaSur',522),('Mexico/General',523),('MST',519),('MST7MDT',520),('Navajo',526),('NZ',524),('NZ-CHAT',525),('Pacific/Apia',529),('Pacific/Auckland',530),('Pacific/Bougainville',531),('Pacific/Chatham',532),('Pacific/Chuuk',533),('Pacific/Easter',534),('Pacific/Efate',535),('Pacific/Enderbury',536),('Pacific/Fakaofo',537),('Pacific/Fiji',538),('Pacific/Funafuti',539),('Pacific/Galapagos',540),('Pacific/Gambier',541),('Pacific/Guadalcanal',542),('Pacific/Guam',543),('Pacific/Honolulu',544),('Pacific/Johnston',545),('Pacific/Kanton',546),('Pacific/Kiritimati',547),('Pacific/Kosrae',548),('Pacific/Kwajalein',549),('Pacific/Majuro',550),('Pacific/Marquesas',551),('Pacific/Midway',552),('Pacific/Nauru',553),('Pacific/Niue',554),('Pacific/Norfolk',555),('Pacific/Noumea',556),('Pacific/Pago_Pago',557),('Pacific/Palau',558),('Pacific/Pitcairn',559),('Pacific/Pohnpei',560),('Pacific/Ponape',561),('Pacific/Port_Moresby',562),('Pacific/Rarotonga',563),('Pacific/Saipan',564),('Pacific/Samoa',565),('Pacific/Tahiti',566),('Pacific/Tarawa',567),('Pacific/Tongatapu',568),('Pacific/Truk',569),('Pacific/Wake',570),('Pacific/Wallis',571),('Pacific/Yap',572),('Poland',573),('Portugal',574),('posix/Africa/Abidjan',597),('posix/Africa/Accra',598),('posix/Africa/Addis_Ababa',599),('posix/Africa/Algiers',600),('posix/Africa/Asmara',601),('posix/Africa/Asmera',602),('posix/Africa/Bamako',603),('posix/Africa/Bangui',604),('posix/Africa/Banjul',605),('posix/Africa/Bissau',606),('posix/Africa/Blantyre',607),('posix/Africa/Brazzaville',608),('posix/Africa/Bujumbura',609),('posix/Africa/Cairo',610),('posix/Africa/Casablanca',611),('posix/Africa/Ceuta',612),('posix/Africa/Conakry',613),('posix/Africa/Dakar',614),('posix/Africa/Dar_es_Salaam',615),('posix/Africa/Djibouti',616),('posix/Africa/Douala',617),('posix/Africa/El_Aaiun',618),('posix/Africa/Freetown',619),('posix/Africa/Gaborone',620),('posix/Africa/Harare',621),('posix/Africa/Johannesburg',622),('posix/Africa/Juba',623),('posix/Africa/Kampala',624),('posix/Africa/Khartoum',625),('posix/Africa/Kigali',626),('posix/Africa/Kinshasa',627),('posix/Africa/Lagos',628),('posix/Africa/Libreville',629),('posix/Africa/Lome',630),('posix/Africa/Luanda',631),('posix/Africa/Lubumbashi',632),('posix/Africa/Lusaka',633),('posix/Africa/Malabo',634),('posix/Africa/Maputo',635),('posix/Africa/Maseru',636),('posix/Africa/Mbabane',637),('posix/Africa/Mogadishu',638),('posix/Africa/Monrovia',639),('posix/Africa/Nairobi',640),('posix/Africa/Ndjamena',641),('posix/Africa/Niamey',642),('posix/Africa/Nouakchott',643),('posix/Africa/Ouagadougou',644),('posix/Africa/Porto-Novo',645),('posix/Africa/Sao_Tome',646),('posix/Africa/Timbuktu',647),('posix/Africa/Tripoli',648),('posix/Africa/Tunis',649),('posix/Africa/Windhoek',650),('posix/America/Adak',651),('posix/America/Anchorage',652),('posix/America/Anguilla',653),('posix/America/Antigua',654),('posix/America/Araguaina',655),('posix/America/Argentina/Buenos_Aires',656),('posix/America/Argentina/Catamarca',657),('posix/America/Argentina/ComodRivadavia',658),('posix/America/Argentina/Cordoba',659),('posix/America/Argentina/Jujuy',660),('posix/America/Argentina/La_Rioja',661),('posix/America/Argentina/Mendoza',662),('posix/America/Argentina/Rio_Gallegos',663),('posix/America/Argentina/Salta',664),('posix/America/Argentina/San_Juan',665),('posix/America/Argentina/San_Luis',666),('posix/America/Argentina/Tucuman',667),('posix/America/Argentina/Ushuaia',668),('posix/America/Aruba',669),('posix/America/Asuncion',670),('posix/America/Atikokan',671),('posix/America/Atka',672),('posix/America/Bahia',673),('posix/America/Bahia_Banderas',674),('posix/America/Barbados',675),('posix/America/Belem',676),('posix/America/Belize',677),('posix/America/Blanc-Sablon',678),('posix/America/Boa_Vista',679),('posix/America/Bogota',680),('posix/America/Boise',681),('posix/America/Buenos_Aires',682),('posix/America/Cambridge_Bay',683),('posix/America/Campo_Grande',684),('posix/America/Cancun',685),('posix/America/Caracas',686),('posix/America/Catamarca',687),('posix/America/Cayenne',688),('posix/America/Cayman',689),('posix/America/Chicago',690),('posix/America/Chihuahua',691),('posix/America/Ciudad_Juarez',692),('posix/America/Coral_Harbour',693),('posix/America/Cordoba',694),('posix/America/Costa_Rica',695),('posix/America/Creston',696),('posix/America/Cuiaba',697),('posix/America/Curacao',698),('posix/America/Danmarkshavn',699),('posix/America/Dawson',700),('posix/America/Dawson_Creek',701),('posix/America/Denver',702),('posix/America/Detroit',703),('posix/America/Dominica',704),('posix/America/Edmonton',705),('posix/America/Eirunepe',706),('posix/America/El_Salvador',707),('posix/America/Ensenada',708),('posix/America/Fortaleza',711),('posix/America/Fort_Nelson',709),('posix/America/Fort_Wayne',710),('posix/America/Glace_Bay',712),('posix/America/Godthab',713),('posix/America/Goose_Bay',714),('posix/America/Grand_Turk',715),('posix/America/Grenada',716),('posix/America/Guadeloupe',717),('posix/America/Guatemala',718),('posix/America/Guayaquil',719),('posix/America/Guyana',720),('posix/America/Halifax',721),('posix/America/Havana',722),('posix/America/Hermosillo',723),('posix/America/Indiana/Indianapolis',724),('posix/America/Indiana/Knox',725),('posix/America/Indiana/Marengo',726),('posix/America/Indiana/Petersburg',727),('posix/America/Indiana/Tell_City',728),('posix/America/Indiana/Vevay',729),('posix/America/Indiana/Vincennes',730),('posix/America/Indiana/Winamac',731),('posix/America/Indianapolis',732),('posix/America/Inuvik',733),('posix/America/Iqaluit',734),('posix/America/Jamaica',735),('posix/America/Jujuy',736),('posix/America/Juneau',737),('posix/America/Kentucky/Louisville',738),('posix/America/Kentucky/Monticello',739),('posix/America/Knox_IN',740),('posix/America/Kralendijk',741),('posix/America/La_Paz',742),('posix/America/Lima',743),('posix/America/Los_Angeles',744),('posix/America/Louisville',745),('posix/America/Lower_Princes',746),('posix/America/Maceio',747),('posix/America/Managua',748),('posix/America/Manaus',749),('posix/America/Marigot',750),('posix/America/Martinique',751),('posix/America/Matamoros',752),('posix/America/Mazatlan',753),('posix/America/Mendoza',754),('posix/America/Menominee',755),('posix/America/Merida',756),('posix/America/Metlakatla',757),('posix/America/Mexico_City',758),('posix/America/Miquelon',759),('posix/America/Moncton',760),('posix/America/Monterrey',761),('posix/America/Montevideo',762),('posix/America/Montreal',763),('posix/America/Montserrat',764),('posix/America/Nassau',765),('posix/America/New_York',766),('posix/America/Nipigon',767),('posix/America/Nome',768),('posix/America/Noronha',769),('posix/America/North_Dakota/Beulah',770),('posix/America/North_Dakota/Center',771),('posix/America/North_Dakota/New_Salem',772),('posix/America/Nuuk',773),('posix/America/Ojinaga',774),('posix/America/Panama',775),('posix/America/Pangnirtung',776),('posix/America/Paramaribo',777),('posix/America/Phoenix',778),('posix/America/Port-au-Prince',779),('posix/America/Porto_Acre',781),('posix/America/Porto_Velho',782),('posix/America/Port_of_Spain',780),('posix/America/Puerto_Rico',783),('posix/America/Punta_Arenas',784),('posix/America/Rainy_River',785),('posix/America/Rankin_Inlet',786),('posix/America/Recife',787),('posix/America/Regina',788),('posix/America/Resolute',789),('posix/America/Rio_Branco',790),('posix/America/Rosario',791),('posix/America/Santarem',793),('posix/America/Santa_Isabel',792),('posix/America/Santiago',794),('posix/America/Santo_Domingo',795),('posix/America/Sao_Paulo',796),('posix/America/Scoresbysund',797),('posix/America/Shiprock',798),('posix/America/Sitka',799),('posix/America/St_Barthelemy',800),('posix/America/St_Johns',801),('posix/America/St_Kitts',802),('posix/America/St_Lucia',803),('posix/America/St_Thomas',804),('posix/America/St_Vincent',805),('posix/America/Swift_Current',806),('posix/America/Tegucigalpa',807),('posix/America/Thule',808),('posix/America/Thunder_Bay',809),('posix/America/Tijuana',810),('posix/America/Toronto',811),('posix/America/Tortola',812),('posix/America/Vancouver',813),('posix/America/Virgin',814),('posix/America/Whitehorse',815),('posix/America/Winnipeg',816),('posix/America/Yakutat',817),('posix/America/Yellowknife',818),('posix/Antarctica/Casey',819),('posix/Antarctica/Davis',820),('posix/Antarctica/DumontDUrville',821),('posix/Antarctica/Macquarie',822),('posix/Antarctica/Mawson',823),('posix/Antarctica/McMurdo',824),('posix/Antarctica/Palmer',825),('posix/Antarctica/Rothera',826),('posix/Antarctica/South_Pole',827),('posix/Antarctica/Syowa',828),('posix/Antarctica/Troll',829),('posix/Antarctica/Vostok',830),('posix/Arctic/Longyearbyen',831),('posix/Asia/Aden',832),('posix/Asia/Almaty',833),('posix/Asia/Amman',834),('posix/Asia/Anadyr',835),('posix/Asia/Aqtau',836),('posix/Asia/Aqtobe',837),('posix/Asia/Ashgabat',838),('posix/Asia/Ashkhabad',839),('posix/Asia/Atyrau',840),('posix/Asia/Baghdad',841),('posix/Asia/Bahrain',842),('posix/Asia/Baku',843),('posix/Asia/Bangkok',844),('posix/Asia/Barnaul',845),('posix/Asia/Beirut',846),('posix/Asia/Bishkek',847),('posix/Asia/Brunei',848),('posix/Asia/Calcutta',849),('posix/Asia/Chita',850),('posix/Asia/Choibalsan',851),('posix/Asia/Chongqing',852),('posix/Asia/Chungking',853),('posix/Asia/Colombo',854),('posix/Asia/Dacca',855),('posix/Asia/Damascus',856),('posix/Asia/Dhaka',857),('posix/Asia/Dili',858),('posix/Asia/Dubai',859),('posix/Asia/Dushanbe',860),('posix/Asia/Famagusta',861),('posix/Asia/Gaza',862),('posix/Asia/Harbin',863),('posix/Asia/Hebron',864),('posix/Asia/Hong_Kong',866),('posix/Asia/Hovd',867),('posix/Asia/Ho_Chi_Minh',865),('posix/Asia/Irkutsk',868),('posix/Asia/Istanbul',869),('posix/Asia/Jakarta',870),('posix/Asia/Jayapura',871),('posix/Asia/Jerusalem',872),('posix/Asia/Kabul',873),('posix/Asia/Kamchatka',874),('posix/Asia/Karachi',875),('posix/Asia/Kashgar',876),('posix/Asia/Kathmandu',877),('posix/Asia/Katmandu',878),('posix/Asia/Khandyga',879),('posix/Asia/Kolkata',880),('posix/Asia/Krasnoyarsk',881),('posix/Asia/Kuala_Lumpur',882),('posix/Asia/Kuching',883),('posix/Asia/Kuwait',884),('posix/Asia/Macao',885),('posix/Asia/Macau',886),('posix/Asia/Magadan',887),('posix/Asia/Makassar',888),('posix/Asia/Manila',889),('posix/Asia/Muscat',890),('posix/Asia/Nicosia',891),('posix/Asia/Novokuznetsk',892),('posix/Asia/Novosibirsk',893),('posix/Asia/Omsk',894),('posix/Asia/Oral',895),('posix/Asia/Phnom_Penh',896),('posix/Asia/Pontianak',897),('posix/Asia/Pyongyang',898),('posix/Asia/Qatar',899),('posix/Asia/Qostanay',900),('posix/Asia/Qyzylorda',901),('posix/Asia/Rangoon',902),('posix/Asia/Riyadh',903),('posix/Asia/Saigon',904),('posix/Asia/Sakhalin',905),('posix/Asia/Samarkand',906),('posix/Asia/Seoul',907),('posix/Asia/Shanghai',908),('posix/Asia/Singapore',909),('posix/Asia/Srednekolymsk',910),('posix/Asia/Taipei',911),('posix/Asia/Tashkent',912),('posix/Asia/Tbilisi',913),('posix/Asia/Tehran',914),('posix/Asia/Tel_Aviv',915),('posix/Asia/Thimbu',916),('posix/Asia/Thimphu',917),('posix/Asia/Tokyo',918),('posix/Asia/Tomsk',919),('posix/Asia/Ujung_Pandang',920),('posix/Asia/Ulaanbaatar',921),('posix/Asia/Ulan_Bator',922),('posix/Asia/Urumqi',923),('posix/Asia/Ust-Nera',924),('posix/Asia/Vientiane',925),('posix/Asia/Vladivostok',926),('posix/Asia/Yakutsk',927),('posix/Asia/Yangon',928),('posix/Asia/Yekaterinburg',929),('posix/Asia/Yerevan',930),('posix/Atlantic/Azores',931),('posix/Atlantic/Bermuda',932),('posix/Atlantic/Canary',933),('posix/Atlantic/Cape_Verde',934),('posix/Atlantic/Faeroe',935),('posix/Atlantic/Faroe',936),('posix/Atlantic/Jan_Mayen',937),('posix/Atlantic/Madeira',938),('posix/Atlantic/Reykjavik',939),('posix/Atlantic/South_Georgia',940),('posix/Atlantic/Stanley',942),('posix/Atlantic/St_Helena',941),('posix/Australia/ACT',943),('posix/Australia/Adelaide',944),('posix/Australia/Brisbane',945),('posix/Australia/Broken_Hill',946),('posix/Australia/Canberra',947),('posix/Australia/Currie',948),('posix/Australia/Darwin',949),('posix/Australia/Eucla',950),('posix/Australia/Hobart',951),('posix/Australia/LHI',952),('posix/Australia/Lindeman',953),('posix/Australia/Lord_Howe',954),('posix/Australia/Melbourne',955),('posix/Australia/North',957),('posix/Australia/NSW',956),('posix/Australia/Perth',958),('posix/Australia/Queensland',959),('posix/Australia/South',960),('posix/Australia/Sydney',961),('posix/Australia/Tasmania',962),('posix/Australia/Victoria',963),('posix/Australia/West',964),('posix/Australia/Yancowinna',965),('posix/Brazil/Acre',966),('posix/Brazil/DeNoronha',967),('posix/Brazil/East',968),('posix/Brazil/West',969),('posix/Canada/Atlantic',972),('posix/Canada/Central',973),('posix/Canada/Eastern',974),('posix/Canada/Mountain',975),('posix/Canada/Newfoundland',976),('posix/Canada/Pacific',977),('posix/Canada/Saskatchewan',978),('posix/Canada/Yukon',979),('posix/CET',970),('posix/Chile/Continental',980),('posix/Chile/EasterIsland',981),('posix/CST6CDT',971),('posix/Cuba',982),('posix/EET',983),('posix/Egypt',986),('posix/Eire',987),('posix/EST',984),('posix/EST5EDT',985),('posix/Etc/GMT',988),('posix/Etc/GMT+0',989),('posix/Etc/GMT+1',990),('posix/Etc/GMT+10',991),('posix/Etc/GMT+11',992),('posix/Etc/GMT+12',993),('posix/Etc/GMT+2',994),('posix/Etc/GMT+3',995),('posix/Etc/GMT+4',996),('posix/Etc/GMT+5',997),('posix/Etc/GMT+6',998),('posix/Etc/GMT+7',999),('posix/Etc/GMT+8',1000),('posix/Etc/GMT+9',1001),('posix/Etc/GMT-0',1002),('posix/Etc/GMT-1',1003),('posix/Etc/GMT-10',1004),('posix/Etc/GMT-11',1005),('posix/Etc/GMT-12',1006),('posix/Etc/GMT-13',1007),('posix/Etc/GMT-14',1008),('posix/Etc/GMT-2',1009),('posix/Etc/GMT-3',1010),('posix/Etc/GMT-4',1011),('posix/Etc/GMT-5',1012),('posix/Etc/GMT-6',1013),('posix/Etc/GMT-7',1014),('posix/Etc/GMT-8',1015),('posix/Etc/GMT-9',1016),('posix/Etc/GMT0',1017),('posix/Etc/Greenwich',1018),('posix/Etc/UCT',1019),('posix/Etc/Universal',1021),('posix/Etc/UTC',1020),('posix/Etc/Zulu',1022),('posix/Europe/Amsterdam',1023),('posix/Europe/Andorra',1024),('posix/Europe/Astrakhan',1025),('posix/Europe/Athens',1026),('posix/Europe/Belfast',1027),('posix/Europe/Belgrade',1028),('posix/Europe/Berlin',1029),('posix/Europe/Bratislava',1030),('posix/Europe/Brussels',1031),('posix/Europe/Bucharest',1032),('posix/Europe/Budapest',1033),('posix/Europe/Busingen',1034),('posix/Europe/Chisinau',1035),('posix/Europe/Copenhagen',1036),('posix/Europe/Dublin',1037),('posix/Europe/Gibraltar',1038),('posix/Europe/Guernsey',1039),('posix/Europe/Helsinki',1040),('posix/Europe/Isle_of_Man',1041),('posix/Europe/Istanbul',1042),('posix/Europe/Jersey',1043),('posix/Europe/Kaliningrad',1044),('posix/Europe/Kiev',1045),('posix/Europe/Kirov',1046),('posix/Europe/Kyiv',1047),('posix/Europe/Lisbon',1048),('posix/Europe/Ljubljana',1049),('posix/Europe/London',1050),('posix/Europe/Luxembourg',1051),('posix/Europe/Madrid',1052),('posix/Europe/Malta',1053),('posix/Europe/Mariehamn',1054),('posix/Europe/Minsk',1055),('posix/Europe/Monaco',1056),('posix/Europe/Moscow',1057),('posix/Europe/Nicosia',1058),('posix/Europe/Oslo',1059),('posix/Europe/Paris',1060),('posix/Europe/Podgorica',1061),('posix/Europe/Prague',1062),('posix/Europe/Riga',1063),('posix/Europe/Rome',1064),('posix/Europe/Samara',1065),('posix/Europe/San_Marino',1066),('posix/Europe/Sarajevo',1067),('posix/Europe/Saratov',1068),('posix/Europe/Simferopol',1069),('posix/Europe/Skopje',1070),('posix/Europe/Sofia',1071),('posix/Europe/Stockholm',1072),('posix/Europe/Tallinn',1073),('posix/Europe/Tirane',1074),('posix/Europe/Tiraspol',1075),('posix/Europe/Ulyanovsk',1076),('posix/Europe/Uzhgorod',1077),('posix/Europe/Vaduz',1078),('posix/Europe/Vatican',1079),('posix/Europe/Vienna',1080),('posix/Europe/Vilnius',1081),('posix/Europe/Volgograd',1082),('posix/Europe/Warsaw',1083),('posix/Europe/Zagreb',1084),('posix/Europe/Zaporozhye',1085),('posix/Europe/Zurich',1086),('posix/GB',1087),('posix/GB-Eire',1088),('posix/GMT',1089),('posix/GMT+0',1090),('posix/GMT-0',1091),('posix/GMT0',1092),('posix/Greenwich',1093),('posix/Hongkong',1095),('posix/HST',1094),('posix/Iceland',1096),('posix/Indian/Antananarivo',1097),('posix/Indian/Chagos',1098),('posix/Indian/Christmas',1099),('posix/Indian/Cocos',1100),('posix/Indian/Comoro',1101),('posix/Indian/Kerguelen',1102),('posix/Indian/Mahe',1103),('posix/Indian/Maldives',1104),('posix/Indian/Mauritius',1105),('posix/Indian/Mayotte',1106),('posix/Indian/Reunion',1107),('posix/Iran',1108),('posix/Israel',1109),('posix/Jamaica',1110),('posix/Japan',1111),('posix/Kwajalein',1112),('posix/Libya',1113),('posix/MET',1114),('posix/Mexico/BajaNorte',1117),('posix/Mexico/BajaSur',1118),('posix/Mexico/General',1119),('posix/MST',1115),('posix/MST7MDT',1116),('posix/Navajo',1122),('posix/NZ',1120),('posix/NZ-CHAT',1121),('posix/Pacific/Apia',1125),('posix/Pacific/Auckland',1126),('posix/Pacific/Bougainville',1127),('posix/Pacific/Chatham',1128),('posix/Pacific/Chuuk',1129),('posix/Pacific/Easter',1130),('posix/Pacific/Efate',1131),('posix/Pacific/Enderbury',1132),('posix/Pacific/Fakaofo',1133),('posix/Pacific/Fiji',1134),('posix/Pacific/Funafuti',1135),('posix/Pacific/Galapagos',1136),('posix/Pacific/Gambier',1137),('posix/Pacific/Guadalcanal',1138),('posix/Pacific/Guam',1139),('posix/Pacific/Honolulu',1140),('posix/Pacific/Johnston',1141),('posix/Pacific/Kanton',1142),('posix/Pacific/Kiritimati',1143),('posix/Pacific/Kosrae',1144),('posix/Pacific/Kwajalein',1145),('posix/Pacific/Majuro',1146),('posix/Pacific/Marquesas',1147),('posix/Pacific/Midway',1148),('posix/Pacific/Nauru',1149),('posix/Pacific/Niue',1150),('posix/Pacific/Norfolk',1151),('posix/Pacific/Noumea',1152),('posix/Pacific/Pago_Pago',1153),('posix/Pacific/Palau',1154),('posix/Pacific/Pitcairn',1155),('posix/Pacific/Pohnpei',1156),('posix/Pacific/Ponape',1157),('posix/Pacific/Port_Moresby',1158),('posix/Pacific/Rarotonga',1159),('posix/Pacific/Saipan',1160),('posix/Pacific/Samoa',1161),('posix/Pacific/Tahiti',1162),('posix/Pacific/Tarawa',1163),('posix/Pacific/Tongatapu',1164),('posix/Pacific/Truk',1165),('posix/Pacific/Wake',1166),('posix/Pacific/Wallis',1167),('posix/Pacific/Yap',1168),('posix/Poland',1169),('posix/Portugal',1170),('posix/PRC',1123),('posix/PST8PDT',1124),('posix/ROC',1171),('posix/ROK',1172),('posix/Singapore',1173),('posix/Turkey',1174),('posix/UCT',1175),('posix/Universal',1189),('posix/US/Alaska',1176),('posix/US/Aleutian',1177),('posix/US/Arizona',1178),('posix/US/Central',1179),('posix/US/East-Indiana',1180),('posix/US/Eastern',1181),('posix/US/Hawaii',1182),('posix/US/Indiana-Starke',1183),('posix/US/Michigan',1184),('posix/US/Mountain',1185),('posix/US/Pacific',1186),('posix/US/Samoa',1187),('posix/UTC',1188),('posix/W-SU',1190),('posix/WET',1191),('posix/Zulu',1192),('posixrules',1193),('PRC',527),('PST8PDT',528),('right/Africa/Abidjan',1194),('right/Africa/Accra',1195),('right/Africa/Addis_Ababa',1196),('right/Africa/Algiers',1197),('right/Africa/Asmara',1198),('right/Africa/Asmera',1199),('right/Africa/Bamako',1200),('right/Africa/Bangui',1201),('right/Africa/Banjul',1202),('right/Africa/Bissau',1203),('right/Africa/Blantyre',1204),('right/Africa/Brazzaville',1205),('right/Africa/Bujumbura',1206),('right/Africa/Cairo',1207),('right/Africa/Casablanca',1208),('right/Africa/Ceuta',1209),('right/Africa/Conakry',1210),('right/Africa/Dakar',1211),('right/Africa/Dar_es_Salaam',1212),('right/Africa/Djibouti',1213),('right/Africa/Douala',1214),('right/Africa/El_Aaiun',1215),('right/Africa/Freetown',1216),('right/Africa/Gaborone',1217),('right/Africa/Harare',1218),('right/Africa/Johannesburg',1219),('right/Africa/Juba',1220),('right/Africa/Kampala',1221),('right/Africa/Khartoum',1222),('right/Africa/Kigali',1223),('right/Africa/Kinshasa',1224),('right/Africa/Lagos',1225),('right/Africa/Libreville',1226),('right/Africa/Lome',1227),('right/Africa/Luanda',1228),('right/Africa/Lubumbashi',1229),('right/Africa/Lusaka',1230),('right/Africa/Malabo',1231),('right/Africa/Maputo',1232),('right/Africa/Maseru',1233),('right/Africa/Mbabane',1234),('right/Africa/Mogadishu',1235),('right/Africa/Monrovia',1236),('right/Africa/Nairobi',1237),('right/Africa/Ndjamena',1238),('right/Africa/Niamey',1239),('right/Africa/Nouakchott',1240),('right/Africa/Ouagadougou',1241),('right/Africa/Porto-Novo',1242),('right/Africa/Sao_Tome',1243),('right/Africa/Timbuktu',1244),('right/Africa/Tripoli',1245),('right/Africa/Tunis',1246),('right/Africa/Windhoek',1247),('right/America/Adak',1248),('right/America/Anchorage',1249),('right/America/Anguilla',1250),('right/America/Antigua',1251),('right/America/Araguaina',1252),('right/America/Argentina/Buenos_Aires',1253),('right/America/Argentina/Catamarca',1254),('right/America/Argentina/ComodRivadavia',1255),('right/America/Argentina/Cordoba',1256),('right/America/Argentina/Jujuy',1257),('right/America/Argentina/La_Rioja',1258),('right/America/Argentina/Mendoza',1259),('right/America/Argentina/Rio_Gallegos',1260),('right/America/Argentina/Salta',1261),('right/America/Argentina/San_Juan',1262),('right/America/Argentina/San_Luis',1263),('right/America/Argentina/Tucuman',1264),('right/America/Argentina/Ushuaia',1265),('right/America/Aruba',1266),('right/America/Asuncion',1267),('right/America/Atikokan',1268),('right/America/Atka',1269),('right/America/Bahia',1270),('right/America/Bahia_Banderas',1271),('right/America/Barbados',1272),('right/America/Belem',1273),('right/America/Belize',1274),('right/America/Blanc-Sablon',1275),('right/America/Boa_Vista',1276),('right/America/Bogota',1277),('right/America/Boise',1278),('right/America/Buenos_Aires',1279),('right/America/Cambridge_Bay',1280),('right/America/Campo_Grande',1281),('right/America/Cancun',1282),('right/America/Caracas',1283),('right/America/Catamarca',1284),('right/America/Cayenne',1285),('right/America/Cayman',1286),('right/America/Chicago',1287),('right/America/Chihuahua',1288),('right/America/Ciudad_Juarez',1289),('right/America/Coral_Harbour',1290),('right/America/Cordoba',1291),('right/America/Costa_Rica',1292),('right/America/Creston',1293),('right/America/Cuiaba',1294),('right/America/Curacao',1295),('right/America/Danmarkshavn',1296),('right/America/Dawson',1297),('right/America/Dawson_Creek',1298),('right/America/Denver',1299),('right/America/Detroit',1300),('right/America/Dominica',1301),('right/America/Edmonton',1302),('right/America/Eirunepe',1303),('right/America/El_Salvador',1304),('right/America/Ensenada',1305),('right/America/Fortaleza',1308),('right/America/Fort_Nelson',1306),('right/America/Fort_Wayne',1307),('right/America/Glace_Bay',1309),('right/America/Godthab',1310),('right/America/Goose_Bay',1311),('right/America/Grand_Turk',1312),('right/America/Grenada',1313),('right/America/Guadeloupe',1314),('right/America/Guatemala',1315),('right/America/Guayaquil',1316),('right/America/Guyana',1317),('right/America/Halifax',1318),('right/America/Havana',1319),('right/America/Hermosillo',1320),('right/America/Indiana/Indianapolis',1321),('right/America/Indiana/Knox',1322),('right/America/Indiana/Marengo',1323),('right/America/Indiana/Petersburg',1324),('right/America/Indiana/Tell_City',1325),('right/America/Indiana/Vevay',1326),('right/America/Indiana/Vincennes',1327),('right/America/Indiana/Winamac',1328),('right/America/Indianapolis',1329),('right/America/Inuvik',1330),('right/America/Iqaluit',1331),('right/America/Jamaica',1332),('right/America/Jujuy',1333),('right/America/Juneau',1334),('right/America/Kentucky/Louisville',1335),('right/America/Kentucky/Monticello',1336),('right/America/Knox_IN',1337),('right/America/Kralendijk',1338),('right/America/La_Paz',1339),('right/America/Lima',1340),('right/America/Los_Angeles',1341),('right/America/Louisville',1342),('right/America/Lower_Princes',1343),('right/America/Maceio',1344),('right/America/Managua',1345),('right/America/Manaus',1346),('right/America/Marigot',1347),('right/America/Martinique',1348),('right/America/Matamoros',1349),('right/America/Mazatlan',1350),('right/America/Mendoza',1351),('right/America/Menominee',1352),('right/America/Merida',1353),('right/America/Metlakatla',1354),('right/America/Mexico_City',1355),('right/America/Miquelon',1356),('right/America/Moncton',1357),('right/America/Monterrey',1358),('right/America/Montevideo',1359),('right/America/Montreal',1360),('right/America/Montserrat',1361),('right/America/Nassau',1362),('right/America/New_York',1363),('right/America/Nipigon',1364),('right/America/Nome',1365),('right/America/Noronha',1366),('right/America/North_Dakota/Beulah',1367),('right/America/North_Dakota/Center',1368),('right/America/North_Dakota/New_Salem',1369),('right/America/Nuuk',1370),('right/America/Ojinaga',1371),('right/America/Panama',1372),('right/America/Pangnirtung',1373),('right/America/Paramaribo',1374),('right/America/Phoenix',1375),('right/America/Port-au-Prince',1376),('right/America/Porto_Acre',1378),('right/America/Porto_Velho',1379),('right/America/Port_of_Spain',1377),('right/America/Puerto_Rico',1380),('right/America/Punta_Arenas',1381),('right/America/Rainy_River',1382),('right/America/Rankin_Inlet',1383),('right/America/Recife',1384),('right/America/Regina',1385),('right/America/Resolute',1386),('right/America/Rio_Branco',1387),('right/America/Rosario',1388),('right/America/Santarem',1390),('right/America/Santa_Isabel',1389),('right/America/Santiago',1391),('right/America/Santo_Domingo',1392),('right/America/Sao_Paulo',1393),('right/America/Scoresbysund',1394),('right/America/Shiprock',1395),('right/America/Sitka',1396),('right/America/St_Barthelemy',1397),('right/America/St_Johns',1398),('right/America/St_Kitts',1399),('right/America/St_Lucia',1400),('right/America/St_Thomas',1401),('right/America/St_Vincent',1402),('right/America/Swift_Current',1403),('right/America/Tegucigalpa',1404),('right/America/Thule',1405),('right/America/Thunder_Bay',1406),('right/America/Tijuana',1407),('right/America/Toronto',1408),('right/America/Tortola',1409),('right/America/Vancouver',1410),('right/America/Virgin',1411),('right/America/Whitehorse',1412),('right/America/Winnipeg',1413),('right/America/Yakutat',1414),('right/America/Yellowknife',1415),('right/Antarctica/Casey',1416),('right/Antarctica/Davis',1417),('right/Antarctica/DumontDUrville',1418),('right/Antarctica/Macquarie',1419),('right/Antarctica/Mawson',1420),('right/Antarctica/McMurdo',1421),('right/Antarctica/Palmer',1422),('right/Antarctica/Rothera',1423),('right/Antarctica/South_Pole',1424),('right/Antarctica/Syowa',1425),('right/Antarctica/Troll',1426),('right/Antarctica/Vostok',1427),('right/Arctic/Longyearbyen',1428),('right/Asia/Aden',1429),('right/Asia/Almaty',1430),('right/Asia/Amman',1431),('right/Asia/Anadyr',1432),('right/Asia/Aqtau',1433),('right/Asia/Aqtobe',1434),('right/Asia/Ashgabat',1435),('right/Asia/Ashkhabad',1436),('right/Asia/Atyrau',1437),('right/Asia/Baghdad',1438),('right/Asia/Bahrain',1439),('right/Asia/Baku',1440),('right/Asia/Bangkok',1441),('right/Asia/Barnaul',1442),('right/Asia/Beirut',1443),('right/Asia/Bishkek',1444),('right/Asia/Brunei',1445),('right/Asia/Calcutta',1446),('right/Asia/Chita',1447),('right/Asia/Choibalsan',1448),('right/Asia/Chongqing',1449),('right/Asia/Chungking',1450),('right/Asia/Colombo',1451),('right/Asia/Dacca',1452),('right/Asia/Damascus',1453),('right/Asia/Dhaka',1454),('right/Asia/Dili',1455),('right/Asia/Dubai',1456),('right/Asia/Dushanbe',1457),('right/Asia/Famagusta',1458),('right/Asia/Gaza',1459),('right/Asia/Harbin',1460),('right/Asia/Hebron',1461),('right/Asia/Hong_Kong',1463),('right/Asia/Hovd',1464),('right/Asia/Ho_Chi_Minh',1462),('right/Asia/Irkutsk',1465),('right/Asia/Istanbul',1466),('right/Asia/Jakarta',1467),('right/Asia/Jayapura',1468),('right/Asia/Jerusalem',1469),('right/Asia/Kabul',1470),('right/Asia/Kamchatka',1471),('right/Asia/Karachi',1472),('right/Asia/Kashgar',1473),('right/Asia/Kathmandu',1474),('right/Asia/Katmandu',1475),('right/Asia/Khandyga',1476),('right/Asia/Kolkata',1477),('right/Asia/Krasnoyarsk',1478),('right/Asia/Kuala_Lumpur',1479),('right/Asia/Kuching',1480),('right/Asia/Kuwait',1481),('right/Asia/Macao',1482),('right/Asia/Macau',1483),('right/Asia/Magadan',1484),('right/Asia/Makassar',1485),('right/Asia/Manila',1486),('right/Asia/Muscat',1487),('right/Asia/Nicosia',1488),('right/Asia/Novokuznetsk',1489),('right/Asia/Novosibirsk',1490),('right/Asia/Omsk',1491),('right/Asia/Oral',1492),('right/Asia/Phnom_Penh',1493),('right/Asia/Pontianak',1494),('right/Asia/Pyongyang',1495),('right/Asia/Qatar',1496),('right/Asia/Qostanay',1497),('right/Asia/Qyzylorda',1498),('right/Asia/Rangoon',1499),('right/Asia/Riyadh',1500),('right/Asia/Saigon',1501),('right/Asia/Sakhalin',1502),('right/Asia/Samarkand',1503),('right/Asia/Seoul',1504),('right/Asia/Shanghai',1505),('right/Asia/Singapore',1506),('right/Asia/Srednekolymsk',1507),('right/Asia/Taipei',1508),('right/Asia/Tashkent',1509),('right/Asia/Tbilisi',1510),('right/Asia/Tehran',1511),('right/Asia/Tel_Aviv',1512),('right/Asia/Thimbu',1513),('right/Asia/Thimphu',1514),('right/Asia/Tokyo',1515),('right/Asia/Tomsk',1516),('right/Asia/Ujung_Pandang',1517),('right/Asia/Ulaanbaatar',1518),('right/Asia/Ulan_Bator',1519),('right/Asia/Urumqi',1520),('right/Asia/Ust-Nera',1521),('right/Asia/Vientiane',1522),('right/Asia/Vladivostok',1523),('right/Asia/Yakutsk',1524),('right/Asia/Yangon',1525),('right/Asia/Yekaterinburg',1526),('right/Asia/Yerevan',1527),('right/Atlantic/Azores',1528),('right/Atlantic/Bermuda',1529),('right/Atlantic/Canary',1530),('right/Atlantic/Cape_Verde',1531),('right/Atlantic/Faeroe',1532),('right/Atlantic/Faroe',1533),('right/Atlantic/Jan_Mayen',1534),('right/Atlantic/Madeira',1535),('right/Atlantic/Reykjavik',1536),('right/Atlantic/South_Georgia',1537),('right/Atlantic/Stanley',1539),('right/Atlantic/St_Helena',1538),('right/Australia/ACT',1540),('right/Australia/Adelaide',1541),('right/Australia/Brisbane',1542),('right/Australia/Broken_Hill',1543),('right/Australia/Canberra',1544),('right/Australia/Currie',1545),('right/Australia/Darwin',1546),('right/Australia/Eucla',1547),('right/Australia/Hobart',1548),('right/Australia/LHI',1549),('right/Australia/Lindeman',1550),('right/Australia/Lord_Howe',1551),('right/Australia/Melbourne',1552),('right/Australia/North',1554),('right/Australia/NSW',1553),('right/Australia/Perth',1555),('right/Australia/Queensland',1556),('right/Australia/South',1557),('right/Australia/Sydney',1558),('right/Australia/Tasmania',1559),('right/Australia/Victoria',1560),('right/Australia/West',1561),('right/Australia/Yancowinna',1562),('right/Brazil/Acre',1563),('right/Brazil/DeNoronha',1564),('right/Brazil/East',1565),('right/Brazil/West',1566),('right/Canada/Atlantic',1569),('right/Canada/Central',1570),('right/Canada/Eastern',1571),('right/Canada/Mountain',1572),('right/Canada/Newfoundland',1573),('right/Canada/Pacific',1574),('right/Canada/Saskatchewan',1575),('right/Canada/Yukon',1576),('right/CET',1567),('right/Chile/Continental',1577),('right/Chile/EasterIsland',1578),('right/CST6CDT',1568),('right/Cuba',1579),('right/EET',1580),('right/Egypt',1583),('right/Eire',1584),('right/EST',1581),('right/EST5EDT',1582),('right/Etc/GMT',1585),('right/Etc/GMT+0',1586),('right/Etc/GMT+1',1587),('right/Etc/GMT+10',1588),('right/Etc/GMT+11',1589),('right/Etc/GMT+12',1590),('right/Etc/GMT+2',1591),('right/Etc/GMT+3',1592),('right/Etc/GMT+4',1593),('right/Etc/GMT+5',1594),('right/Etc/GMT+6',1595),('right/Etc/GMT+7',1596),('right/Etc/GMT+8',1597),('right/Etc/GMT+9',1598),('right/Etc/GMT-0',1599),('right/Etc/GMT-1',1600),('right/Etc/GMT-10',1601),('right/Etc/GMT-11',1602),('right/Etc/GMT-12',1603),('right/Etc/GMT-13',1604),('right/Etc/GMT-14',1605),('right/Etc/GMT-2',1606),('right/Etc/GMT-3',1607),('right/Etc/GMT-4',1608),('right/Etc/GMT-5',1609),('right/Etc/GMT-6',1610),('right/Etc/GMT-7',1611),('right/Etc/GMT-8',1612),('right/Etc/GMT-9',1613),('right/Etc/GMT0',1614),('right/Etc/Greenwich',1615),('right/Etc/UCT',1616),('right/Etc/Universal',1618),('right/Etc/UTC',1617),('right/Etc/Zulu',1619),('right/Europe/Amsterdam',1620),('right/Europe/Andorra',1621),('right/Europe/Astrakhan',1622),('right/Europe/Athens',1623),('right/Europe/Belfast',1624),('right/Europe/Belgrade',1625),('right/Europe/Berlin',1626),('right/Europe/Bratislava',1627),('right/Europe/Brussels',1628),('right/Europe/Bucharest',1629),('right/Europe/Budapest',1630),('right/Europe/Busingen',1631),('right/Europe/Chisinau',1632),('right/Europe/Copenhagen',1633),('right/Europe/Dublin',1634),('right/Europe/Gibraltar',1635),('right/Europe/Guernsey',1636),('right/Europe/Helsinki',1637),('right/Europe/Isle_of_Man',1638),('right/Europe/Istanbul',1639),('right/Europe/Jersey',1640),('right/Europe/Kaliningrad',1641),('right/Europe/Kiev',1642),('right/Europe/Kirov',1643),('right/Europe/Kyiv',1644),('right/Europe/Lisbon',1645),('right/Europe/Ljubljana',1646),('right/Europe/London',1647),('right/Europe/Luxembourg',1648),('right/Europe/Madrid',1649),('right/Europe/Malta',1650),('right/Europe/Mariehamn',1651),('right/Europe/Minsk',1652),('right/Europe/Monaco',1653),('right/Europe/Moscow',1654),('right/Europe/Nicosia',1655),('right/Europe/Oslo',1656),('right/Europe/Paris',1657),('right/Europe/Podgorica',1658),('right/Europe/Prague',1659),('right/Europe/Riga',1660),('right/Europe/Rome',1661),('right/Europe/Samara',1662),('right/Europe/San_Marino',1663),('right/Europe/Sarajevo',1664),('right/Europe/Saratov',1665),('right/Europe/Simferopol',1666),('right/Europe/Skopje',1667),('right/Europe/Sofia',1668),('right/Europe/Stockholm',1669),('right/Europe/Tallinn',1670),('right/Europe/Tirane',1671),('right/Europe/Tiraspol',1672),('right/Europe/Ulyanovsk',1673),('right/Europe/Uzhgorod',1674),('right/Europe/Vaduz',1675),('right/Europe/Vatican',1676),('right/Europe/Vienna',1677),('right/Europe/Vilnius',1678),('right/Europe/Volgograd',1679),('right/Europe/Warsaw',1680),('right/Europe/Zagreb',1681),('right/Europe/Zaporozhye',1682),('right/Europe/Zurich',1683),('right/GB',1684),('right/GB-Eire',1685),('right/GMT',1686),('right/GMT+0',1687),('right/GMT-0',1688),('right/GMT0',1689),('right/Greenwich',1690),('right/Hongkong',1692),('right/HST',1691),('right/Iceland',1693),('right/Indian/Antananarivo',1694),('right/Indian/Chagos',1695),('right/Indian/Christmas',1696),('right/Indian/Cocos',1697),('right/Indian/Comoro',1698),('right/Indian/Kerguelen',1699),('right/Indian/Mahe',1700),('right/Indian/Maldives',1701),('right/Indian/Mauritius',1702),('right/Indian/Mayotte',1703),('right/Indian/Reunion',1704),('right/Iran',1705),('right/Israel',1706),('right/Jamaica',1707),('right/Japan',1708),('right/Kwajalein',1709),('right/Libya',1710),('right/MET',1711),('right/Mexico/BajaNorte',1714),('right/Mexico/BajaSur',1715),('right/Mexico/General',1716),('right/MST',1712),('right/MST7MDT',1713),('right/Navajo',1719),('right/NZ',1717),('right/NZ-CHAT',1718),('right/Pacific/Apia',1722),('right/Pacific/Auckland',1723),('right/Pacific/Bougainville',1724),('right/Pacific/Chatham',1725),('right/Pacific/Chuuk',1726),('right/Pacific/Easter',1727),('right/Pacific/Efate',1728),('right/Pacific/Enderbury',1729),('right/Pacific/Fakaofo',1730),('right/Pacific/Fiji',1731),('right/Pacific/Funafuti',1732),('right/Pacific/Galapagos',1733),('right/Pacific/Gambier',1734),('right/Pacific/Guadalcanal',1735),('right/Pacific/Guam',1736),('right/Pacific/Honolulu',1737),('right/Pacific/Johnston',1738),('right/Pacific/Kanton',1739),('right/Pacific/Kiritimati',1740),('right/Pacific/Kosrae',1741),('right/Pacific/Kwajalein',1742),('right/Pacific/Majuro',1743),('right/Pacific/Marquesas',1744),('right/Pacific/Midway',1745),('right/Pacific/Nauru',1746),('right/Pacific/Niue',1747),('right/Pacific/Norfolk',1748),('right/Pacific/Noumea',1749),('right/Pacific/Pago_Pago',1750),('right/Pacific/Palau',1751),('right/Pacific/Pitcairn',1752),('right/Pacific/Pohnpei',1753),('right/Pacific/Ponape',1754),('right/Pacific/Port_Moresby',1755),('right/Pacific/Rarotonga',1756),('right/Pacific/Saipan',1757),('right/Pacific/Samoa',1758),('right/Pacific/Tahiti',1759),('right/Pacific/Tarawa',1760),('right/Pacific/Tongatapu',1761),('right/Pacific/Truk',1762),('right/Pacific/Wake',1763),('right/Pacific/Wallis',1764),('right/Pacific/Yap',1765),('right/Poland',1766),('right/Portugal',1767),('right/PRC',1720),('right/PST8PDT',1721),('right/ROC',1768),('right/ROK',1769),('right/Singapore',1770),('right/Turkey',1771),('right/UCT',1772),('right/Universal',1786),('right/US/Alaska',1773),('right/US/Aleutian',1774),('right/US/Arizona',1775),('right/US/Central',1776),('right/US/East-Indiana',1777),('right/US/Eastern',1778),('right/US/Hawaii',1779),('right/US/Indiana-Starke',1780),('right/US/Michigan',1781),('right/US/Mountain',1782),('right/US/Pacific',1783),('right/US/Samoa',1784),('right/UTC',1785),('right/W-SU',1787),('right/WET',1788),('right/Zulu',1789),('ROC',575),('ROK',576),('Singapore',577),('Turkey',578),('UCT',579),('Universal',593),('US/Alaska',580),('US/Aleutian',581),('US/Arizona',582),('US/Central',583),('US/East-Indiana',584),('US/Eastern',585),('US/Hawaii',586),('US/Indiana-Starke',587),('US/Michigan',588),('US/Mountain',589),('US/Pacific',590),('US/Samoa',591),('UTC',592),('W-SU',594),('WET',595),('Zulu',596);
/*!40000 ALTER TABLE `time_zone_name` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `time_zone_transition`
--

DROP TABLE IF EXISTS `time_zone_transition`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `time_zone_transition` (
  `Time_zone_id` int unsigned NOT NULL,
  `Transition_time` bigint NOT NULL,
  `Transition_type_id` int unsigned NOT NULL,
  PRIMARY KEY (`Time_zone_id`,`Transition_time`)
) /*!50100 TABLESPACE `mysql` */ ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 STATS_PERSISTENT=0 ROW_FORMAT=DYNAMIC COMMENT='Time zone transitions';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `time_zone_transition`
--

LOCK TABLES `time_zone_transition` WRITE;
/*!40000 ALTER TABLE `time_zone_transition` DISABLE KEYS */;
INSERT INTO `time_zone_transition` VALUES (1,-2147483648,0),(1,-1830383032,1),(2,-2147483648,0),(2,-1830383032,1),(3,-2147483648,0),(3,-1946168836,1),(3,-1309746600,2),(3,-1261969200,1),(3,-1041388200,3),(3,-865305900,2),(4,-2147483648,1),(4,-1855958961,4),(4,-1689814800,2),(4,-1680397200,3),(4,-1665363600,2),(4,-1648342800,3),(4,-1635123600,2),(4,-1616893200,3),(4,-1604278800,2),(4,-1585443600,3),(4,-1574038800,2),(4,-1552266000,3),(4,-1539997200,2),(4,-1531443600,3),(4,-956365200,2),(4,-950486400,4),(4,-942012000,6),(4,-812502000,5),(4,-796262400,6),(4,-781052400,5),(4,-766630800,6),(4,-733280400,4),(4,-439430400,6),(4,-212029200,4),(4,41468400,2),(4,54774000,3),(4,231724800,7),(4,246236400,6),(4,259545600,5),(4,275274000,6),(4,309740400,4),(4,325468800,7),(4,341802000,4),(4,357523200,6),(5,-2147483648,0),(5,-1946168836,1),(5,-1309746600,2),(5,-1261969200,1),(5,-1041388200,3),(5,-865305900,2),(6,-2147483648,0),(6,-1946168836,1),(6,-1309746600,2),(6,-1261969200,1),(6,-1041388200,3),(6,-865305900,2),(7,-2147483648,0),(7,-1830383032,1),(8,-2147483648,0),(8,-2035584815,1),(8,-1940889600,0),(8,-1767226415,2),(8,-1588465800,3),(9,-2147483648,0),(9,-1830383032,1),(10,-2147483648,0),(10,-1830380400,1),(10,157770000,2),(11,-2147483648,0),(11,-2109291020,1),(12,-2147483648,0),(12,-2035584815,1),(12,-1940889600,0),(12,-1767226415,2),(12,-1588465800,3),(13,-2147483648,0),(13,-2109291020,1),(14,-2147483648,2),(14,-929844000,1),(14,-923108400,2),(14,-906170400,1),(14,-892868400,2),(14,-875844000,1),(14,-857790000,2),(14,-844308000,1),(14,-825822000,2),(14,-812685600,1),(14,-794199600,2),(14,-779853600,1),(14,-762663600,2),(14,-399088800,1),(14,-386650800,2),(14,-368330400,1),(14,-355114800,2),(14,-336790800,1),(14,-323654400,2),(14,-305168400,1),(14,-292032000,2),(14,-273632400,1),(14,-260496000,2),(14,-242096400,1),(14,-228960000,2),(14,-210560400,1),(14,-197424000,2),(14,-178938000,1),(14,-165801600,2),(14,-147402000,1),(14,-134265600,2),(14,-115866000,1),(14,-102643200,2),(14,-84330000,1),(14,-71107200,2),(14,-52707600,1),(14,-39484800,2),(14,-21171600,1),(14,-7948800,2),(14,10364400,1),(14,23587200,2),(14,41900400,1),(14,55123200,2),(14,73522800,1),(14,86745600,2),(14,105058800,1),(14,118281600,2),(14,136594800,1),(14,149817600,2),(14,168130800,1),(14,181353600,2),(14,199753200,1),(14,212976000,2),(14,231289200,1),(14,244512000,2),(14,262825200,1),(14,276048000,2),(14,294361200,1),(14,307584000,2),(14,325983600,1),(14,339206400,2),(14,357519600,1),(14,370742400,2),(14,396399600,1),(14,402278400,2),(14,426812400,1),(14,433814400,2),(14,452214000,1),(14,465436800,2),(14,483750000,1),(14,496972800,2),(14,515286000,1),(14,528508800,2),(14,546822000,1),(14,560044800,2),(14,578444400,1),(14,591667200,2),(14,610412400,1),(14,623203200,2),(14,641516400,1),(14,654739200,2),(14,673052400,1),(14,686275200,2),(14,704674800,1),(14,717897600,2),(14,736210800,1),(14,749433600,2),(14,767746800,1),(14,780969600,2),(14,799020000,3),(14,812322000,2),(14,830469600,3),(14,843771600,2),(14,861919200,3),(14,875221200,2),(14,893368800,3),(14,906670800,2),(14,925423200,3),(14,938725200,2),(14,956872800,3),(14,970174800,2),(14,988322400,3),(14,1001624400,2),(14,1019772000,3),(14,1033074000,2),(14,1051221600,3),(14,1064523600,2),(14,1083276000,3),(14,1096578000,2),(14,1114725600,3),(14,1128027600,2),(14,1146175200,3),(14,1158872400,2),(14,1177624800,3),(14,1189112400,2),(14,1209074400,3),(14,1219957200,2),(14,1240524000,3),(14,1250802000,2),(14,1272578400,3),(14,1281474000,2),(14,1284069600,1),(14,1285880400,2),(14,1400191200,1),(14,1403816400,2),(14,1406844000,1),(14,1411678800,2),(14,1682632800,1),(14,1698354000,2),(14,1714082400,1),(14,1730408400,2),(14,1745532000,1),(14,1761858000,2),(14,1776981600,1),(14,1793307600,2),(14,1809036000,1),(14,1824757200,2),(14,1840485600,1),(14,1856206800,2),(14,1871935200,1),(14,1887656400,2),(14,1903384800,1),(14,1919710800,2),(14,1934834400,1),(14,1951160400,2),(14,1966888800,1),(14,1982610000,2),(14,1998338400,1),(14,2014059600,2),(14,2029788000,1),(14,2045509200,2),(14,2061237600,1),(14,2076958800,2),(14,2092687200,1),(14,2109013200,2),(14,2124136800,1),(14,2140462800,2),(15,-2147483648,0),(15,-1773012580,2),(15,-956361600,1),(15,-950490000,2),(15,-942019200,1),(15,-761187600,2),(15,-617241600,1),(15,-605149200,2),(15,-81432000,1),(15,-71110800,2),(15,141264000,1),(15,147222000,2),(15,199756800,1),(15,207702000,2),(15,231292800,1),(15,244249200,2),(15,265507200,1),(15,271033200,2),(15,448243200,3),(15,504918000,2),(15,1212278400,1),(15,1220223600,2),(15,1243814400,1),(15,1250809200,2),(15,1272758400,1),(15,1281222000,2),(15,1301788800,1),(15,1312066800,2),(15,1335664800,1),(15,1342749600,2),(15,1345428000,1),(15,1348970400,2),(15,1367114400,1),(15,1373162400,2),(15,1376100000,1),(15,1382839200,2),(15,1396144800,1),(15,1403920800,2),(15,1406944800,1),(15,1414288800,2),(15,1427594400,1),(15,1434247200,2),(15,1437271200,1),(15,1445738400,2),(15,1459044000,1),(15,1465092000,2),(15,1468116000,1),(15,1477792800,2),(15,1490493600,1),(15,1495332000,2),(15,1498960800,1),(15,1509242400,2),(15,1521943200,1),(15,1526176800,2),(15,1529200800,1),(15,1557021600,2),(15,1560045600,1),(15,1587261600,2),(15,1590890400,1),(15,1618106400,2),(15,1621130400,1),(15,1648346400,2),(15,1651975200,1),(15,1679191200,2),(15,1682215200,1),(15,1710036000,2),(15,1713060000,1),(15,1740276000,2),(15,1743904800,1),(15,1771120800,2),(15,1774144800,1),(15,1801965600,2),(15,1804989600,1),(15,1832205600,2),(15,1835834400,1),(15,1863050400,2),(15,1866074400,1),(15,1893290400,2),(15,1896919200,1),(15,1924135200,2),(15,1927159200,1),(15,1954980000,2),(15,1958004000,1),(15,1985220000,2),(15,1988848800,1),(15,2016064800,2),(15,2019088800,1),(15,2046304800,2),(15,2049933600,1),(15,2077149600,2),(15,2080778400,1),(15,2107994400,2),(15,2111018400,1),(15,2138234400,2),(15,2141863200,1),(16,-2147483648,1),(16,-1630112400,2),(16,-1616810400,3),(16,-1442451600,2),(16,-1427673600,4),(16,-1379293200,2),(16,-1364774400,4),(16,-1348448400,2),(16,-1333324800,4),(16,-1316390400,2),(16,-1301270400,4),(16,-1293840000,3),(16,-81432000,2),(16,-71110800,3),(16,141264000,2),(16,147222000,3),(16,199756800,2),(16,207702000,3),(16,231292800,2),(16,244249200,3),(16,265507200,2),(16,271033200,3),(16,448243200,5),(16,512528400,6),(16,528253200,7),(16,543978000,6),(16,559702800,7),(16,575427600,6),(16,591152400,7),(16,606877200,6),(16,622602000,7),(16,638326800,6),(16,654656400,7),(16,670381200,6),(16,686106000,7),(16,701830800,6),(16,717555600,7),(16,733280400,6),(16,749005200,7),(16,764730000,6),(16,780454800,7),(16,796179600,6),(16,811904400,7),(16,828234000,6),(16,846378000,7),(16,859683600,6),(16,877827600,7),(16,891133200,6),(16,909277200,7),(16,922582800,6),(16,941331600,7),(16,954032400,6),(16,972781200,7),(16,985482000,6),(16,1004230800,7),(16,1017536400,6),(16,1035680400,7),(16,1048986000,6),(16,1067130000,7),(16,1080435600,6),(16,1099184400,7),(16,1111885200,6),(16,1130634000,7),(16,1143334800,6),(16,1162083600,7),(16,1174784400,6),(16,1193533200,7),(16,1206838800,6),(16,1224982800,7),(16,1238288400,6),(16,1256432400,7),(16,1269738000,6),(16,1288486800,7),(16,1301187600,6),(16,1319936400,7),(16,1332637200,6),(16,1351386000,7),(16,1364691600,6),(16,1382835600,7),(16,1396141200,6),(16,1414285200,7),(16,1427590800,6),(16,1445734800,7),(16,1459040400,6),(16,1477789200,7),(16,1490490000,6),(16,1509238800,7),(16,1521939600,6),(16,1540688400,7),(16,1553994000,6),(16,1572138000,7),(16,1585443600,6),(16,1603587600,7),(16,1616893200,6),(16,1635642000,7),(16,1648342800,6),(16,1667091600,7),(16,1679792400,6),(16,1698541200,7),(16,1711846800,6),(16,1729990800,7),(16,1743296400,6),(16,1761440400,7),(16,1774746000,6),(16,1792890000,7),(16,1806195600,6),(16,1824944400,7),(16,1837645200,6),(16,1856394000,7),(16,1869094800,6),(16,1887843600,7),(16,1901149200,6),(16,1919293200,7),(16,1932598800,6),(16,1950742800,7),(16,1964048400,6),(16,1982797200,7),(16,1995498000,6),(16,2014246800,7),(16,2026947600,6),(16,2045696400,7),(16,2058397200,6),(16,2077146000,7),(16,2090451600,6),(16,2108595600,7),(16,2121901200,6),(16,2140045200,7),(17,-2147483648,0),(17,-1830383032,1),(18,-2147483648,0),(18,-1830383032,1),(19,-2147483648,0),(19,-1946168836,1),(19,-1309746600,2),(19,-1261969200,1),(19,-1041388200,3),(19,-865305900,2),(20,-2147483648,0),(20,-1946168836,1),(20,-1309746600,2),(20,-1261969200,1),(20,-1041388200,3),(20,-865305900,2),(21,-2147483648,0),(21,-2035584815,1),(21,-1940889600,0),(21,-1767226415,2),(21,-1588465800,3),(22,-2147483648,0),(22,-1136070432,1),(22,198291600,3),(22,199756800,2),(22,207702000,3),(22,231292800,2),(22,244249200,3),(22,265507200,2),(22,271033200,3),(22,1212278400,2),(22,1220223600,3),(22,1243814400,2),(22,1250809200,3),(22,1272758400,2),(22,1281222000,3),(22,1301788800,2),(22,1312066800,3),(22,1335664800,2),(22,1342749600,3),(22,1345428000,2),(22,1348970400,3),(22,1367114400,2),(22,1373162400,3),(22,1376100000,2),(22,1382839200,3),(22,1396144800,2),(22,1403920800,3),(22,1406944800,2),(22,1414288800,3),(22,1427594400,2),(22,1434247200,3),(22,1437271200,2),(22,1445738400,3),(22,1459044000,2),(22,1465092000,3),(22,1468116000,2),(22,1477792800,3),(22,1490493600,2),(22,1495332000,3),(22,1498960800,2),(22,1509242400,3),(22,1521943200,2),(22,1526176800,3),(22,1529200800,2),(22,1557021600,3),(22,1560045600,2),(22,1587261600,3),(22,1590890400,2),(22,1618106400,3),(22,1621130400,2),(22,1648346400,3),(22,1651975200,2),(22,1679191200,3),(22,1682215200,2),(22,1710036000,3),(22,1713060000,2),(22,1740276000,3),(22,1743904800,2),(22,1771120800,3),(22,1774144800,2),(22,1801965600,3),(22,1804989600,2),(22,1832205600,3),(22,1835834400,2),(22,1863050400,3),(22,1866074400,2),(22,1893290400,3),(22,1896919200,2),(22,1924135200,3),(22,1927159200,2),(22,1954980000,3),(22,1958004000,2),(22,1985220000,3),(22,1988848800,2),(22,2016064800,3),(22,2019088800,2),(22,2046304800,3),(22,2049933600,2),(22,2077149600,3),(22,2080778400,2),(22,2107994400,3),(22,2111018400,2),(22,2138234400,3),(22,2141863200,2),(23,-2147483648,0),(23,-1830383032,1),(24,-2147483648,0),(24,-2109291020,1),(25,-2147483648,0),(25,-2109291020,1),(26,-2147483648,1),(26,-2109288600,3),(26,-860976000,2),(26,-845254800,3),(26,-829526400,2),(26,-813805200,3),(27,-2147483648,0),(27,-1230775588,2),(27,10360800,1),(27,24786000,2),(27,41810400,1),(27,56322000,2),(27,73432800,1),(27,87944400,2),(27,104882400,1),(27,119480400,2),(27,136332000,1),(27,151016400,2),(27,167781600,1),(27,182552400,2),(27,199231200,1),(27,214174800,2),(27,230680800,1),(27,245710800,2),(27,262735200,1),(27,277246800,2),(27,294184800,1),(27,308782800,2),(27,325634400,1),(27,340405200,2),(27,357084000,1),(27,371941200,2),(27,388533600,1),(27,403477200,2),(27,419983200,1),(27,435013200,2),(27,452037600,1),(27,466635600,2),(27,483487200,1),(27,498171600,2),(27,947930400,3),(27,1612126800,2),(28,-2147483648,0),(28,-1946168836,1),(28,-1309746600,2),(28,-1261969200,1),(28,-1041388200,3),(28,-865305900,2),(29,-2147483648,0),(29,-1230775808,2),(29,10360800,1),(29,24786000,2),(29,41810400,1),(29,56322000,2),(29,73432800,1),(29,87944400,2),(29,104882400,1),(29,119480400,2),(29,136332000,1),(29,151016400,2),(29,167781600,1),(29,182552400,2),(29,199231200,1),(29,214174800,2),(29,230680800,1),(29,245710800,2),(29,262735200,1),(29,277246800,2),(29,294184800,1),(29,308782800,2),(29,325634400,1),(29,340405200,2),(29,357084000,1),(29,371941200,2),(29,388533600,1),(29,403477200,2),(29,419983200,1),(29,435013200,2),(29,452037600,1),(29,466635600,2),(29,483487200,1),(29,498171600,2),(29,947930400,3),(29,1509483600,2),(30,-2147483648,0),(30,-2109291020,1),(31,-2147483648,0),(31,-2035584815,1),(31,-1940889600,0),(31,-1767226415,2),(31,-1588465800,3),(32,-2147483648,0),(32,-2035584815,1),(32,-1940889600,0),(32,-1767226415,2),(32,-1588465800,3),(33,-2147483648,0),(33,-2035584815,1),(33,-1940889600,0),(33,-1767226415,2),(33,-1588465800,3),(34,-2147483648,0),(34,-1830383032,1),(35,-2147483648,0),(35,-2035584815,1),(35,-1940889600,0),(35,-1767226415,2),(35,-1588465800,3),(36,-2147483648,0),(36,-2109291020,1),(37,-2147483648,0),(37,-2109291020,1),(38,-2147483648,0),(38,-2035584815,1),(38,-1940889600,0),(38,-1767226415,2),(38,-1588465800,3),(39,-2147483648,0),(39,-2109291020,1),(40,-2147483648,1),(40,-2109288600,3),(40,-860976000,2),(40,-845254800,3),(40,-829526400,2),(40,-813805200,3),(41,-2147483648,1),(41,-2109288600,3),(41,-860976000,2),(41,-845254800,3),(41,-829526400,2),(41,-813805200,3),(42,-2147483648,0),(42,-1946168836,1),(42,-1309746600,2),(42,-1261969200,1),(42,-1041388200,3),(42,-865305900,2),(43,-2147483648,1),(43,-1604359012,2),(43,63593070,3),(44,-2147483648,0),(44,-1946168836,1),(44,-1309746600,2),(44,-1261969200,1),(44,-1041388200,3),(44,-865305900,2),(45,-2147483648,0),(45,-1830387612,1),(45,308703600,2),(45,321314400,1),(46,-2147483648,0),(46,-2035584815,1),(46,-1940889600,0),(46,-1767226415,2),(46,-1588465800,3),(47,-2147483648,0),(47,-1830383032,1),(48,-2147483648,0),(48,-1830383032,1),(49,-2147483648,0),(49,-2035584815,1),(49,-1940889600,0),(49,-1767226415,2),(49,-1588465800,3),(50,-2147483648,1),(50,-1830384000,2),(50,1514768400,3),(50,1546304400,4),(51,-2147483648,0),(51,-1830383032,1),(52,-2147483648,0),(52,-1577926364,2),(52,-574902000,1),(52,-568087200,2),(52,-512175600,1),(52,-504928800,2),(52,-449888400,1),(52,-441856800,2),(52,-347158800,3),(52,378684000,2),(52,386463600,1),(52,402271200,2),(52,417999600,1),(52,433807200,2),(52,449622000,1),(52,465429600,2),(52,481590000,1),(52,496965600,2),(52,512953200,1),(52,528674400,2),(52,544230000,1),(52,560037600,2),(52,575852400,1),(52,591660000,2),(52,607388400,1),(52,623196000,2),(52,641775600,3),(52,844034400,2),(52,860108400,1),(52,875916000,3),(52,1352505600,2),(52,1364515200,1),(52,1382659200,3),(53,-2147483648,1),(53,-1855958961,4),(53,-969242400,2),(53,-950493600,3),(53,-941940000,2),(53,-891136800,4),(53,-877827600,5),(53,-857257200,4),(53,-844556400,5),(53,-842918400,4),(53,-842223600,5),(53,-828230400,4),(53,-812502000,5),(53,-796269600,4),(53,-781052400,5),(53,-766634400,4),(53,231202800,2),(53,243903600,3),(53,262825200,2),(53,276044400,3),(53,581122800,2),(53,591145200,3),(53,606870000,2),(53,622594800,3),(53,641516400,2),(53,654649200,3),(53,1114902000,2),(53,1128038400,3),(53,1143334800,2),(53,1162083600,3),(53,1174784400,2),(53,1193533200,3),(53,1206838800,2),(53,1224982800,3),(54,-2147483648,1),(54,-2109288600,2),(54,-860976000,3),(54,-845254800,2),(54,637970400,4),(54,764200800,5),(54,778640400,6),(54,796780800,5),(54,810090000,6),(54,828835200,5),(54,841539600,6),(54,860284800,5),(54,873594000,6),(54,891734400,5),(54,905043600,6),(54,923184000,5),(54,936493200,6),(54,954633600,5),(54,967942800,6),(54,986083200,5),(54,999392400,6),(54,1018137600,5),(54,1030842000,6),(54,1049587200,5),(54,1062896400,6),(54,1081036800,5),(54,1094346000,6),(54,1112486400,5),(54,1125795600,6),(54,1143936000,5),(54,1157245200,6),(54,1175385600,5),(54,1188694800,6),(54,1207440000,5),(54,1220749200,6),(54,1238889600,5),(54,1252198800,6),(54,1270339200,5),(54,1283648400,6),(54,1301788800,5),(54,1315098000,6),(54,1333238400,5),(54,1346547600,6),(54,1365292800,5),(54,1377997200,6),(54,1396742400,5),(54,1410051600,6),(54,1428192000,5),(54,1441501200,6),(54,1459641600,5),(54,1472950800,6),(54,1491091200,5),(54,1504400400,6),(54,1508796000,4),(55,-2147483648,1),(55,-880196400,2),(55,-769395600,3),(55,-765374400,1),(55,-86878800,4),(55,-21466800,5),(55,-5745600,4),(55,9982800,5),(55,25704000,4),(55,41432400,5),(55,57758400,4),(55,73486800,5),(55,89208000,4),(55,104936400,5),(55,120657600,4),(55,126709200,5),(55,152107200,4),(55,162392400,5),(55,183556800,4),(55,199285200,5),(55,215611200,4),(55,230734800,5),(55,247060800,4),(55,262789200,5),(55,278510400,4),(55,294238800,5),(55,309960000,4),(55,325688400,5),(55,341409600,4),(55,357138000,5),(55,372859200,4),(55,388587600,5),(55,404913600,4),(55,420037200,5),(55,436363200,6),(55,439034400,8),(55,452088000,7),(55,467809200,8),(55,483537600,7),(55,499258800,8),(55,514987200,7),(55,530708400,8),(55,544622400,7),(55,562158000,8),(55,576072000,7),(55,594212400,8),(55,607521600,7),(55,625662000,8),(55,638971200,7),(55,657111600,8),(55,671025600,7),(55,688561200,8),(55,702475200,7),(55,720010800,8),(55,733924800,7),(55,752065200,8),(55,765374400,7),(55,783514800,8),(55,796824000,7),(55,814964400,8),(55,828878400,7),(55,846414000,8),(55,860328000,7),(55,877863600,8),(55,891777600,7),(55,909313200,8),(55,923227200,7),(55,941367600,8),(55,954676800,7),(55,972817200,8),(55,986126400,7),(55,1004266800,8),(55,1018180800,7),(55,1035716400,8),(55,1049630400,7),(55,1067166000,8),(55,1081080000,7),(55,1099220400,8),(55,1112529600,7),(55,1130670000,8),(55,1143979200,7),(55,1162119600,8),(55,1173614400,7),(55,1194174000,8),(55,1205064000,7),(55,1225623600,8),(55,1236513600,7),(55,1257073200,8),(55,1268568000,7),(55,1289127600,8),(55,1300017600,7),(55,1320577200,8),(55,1331467200,7),(55,1352026800,8),(55,1362916800,7),(55,1383476400,8),(55,1394366400,7),(55,1414926000,8),(55,1425816000,7),(55,1446375600,8),(55,1457870400,7),(55,1478430000,8),(55,1489320000,7),(55,1509879600,8),(55,1520769600,7),(55,1541329200,8),(55,1552219200,7),(55,1572778800,8),(55,1583668800,7),(55,1604228400,8),(55,1615723200,7),(55,1636282800,8),(55,1647172800,7),(55,1667732400,8),(55,1678622400,7),(55,1699182000,8),(55,1710072000,7),(55,1730631600,8),(55,1741521600,7),(55,1762081200,8),(55,1772971200,7),(55,1793530800,8),(55,1805025600,7),(55,1825585200,8),(55,1836475200,7),(55,1857034800,8),(55,1867924800,7),(55,1888484400,8),(55,1899374400,7),(55,1919934000,8),(55,1930824000,7),(55,1951383600,8),(55,1962878400,7),(55,1983438000,8),(55,1994328000,7),(55,2014887600,8),(55,2025777600,7),(55,2046337200,8),(55,2057227200,7),(55,2077786800,8),(55,2088676800,7),(55,2109236400,8),(55,2120126400,7),(55,2140686000,8),(56,-2147483648,1),(56,-880200000,2),(56,-769395600,3),(56,-765378000,1),(56,-86882400,4),(56,-21470400,5),(56,-5749200,4),(56,9979200,5),(56,25700400,4),(56,41428800,5),(56,57754800,4),(56,73483200,5),(56,89204400,4),(56,104932800,5),(56,120654000,4),(56,126705600,5),(56,152103600,4),(56,162388800,5),(56,183553200,4),(56,199281600,5),(56,215607600,4),(56,230731200,5),(56,247057200,4),(56,262785600,5),(56,278506800,4),(56,294235200,5),(56,309956400,4),(56,325684800,5),(56,341406000,4),(56,357134400,5),(56,372855600,4),(56,388584000,5),(56,404910000,4),(56,420033600,5),(56,436359600,6),(56,439030800,8),(56,452084400,7),(56,467805600,8),(56,483534000,7),(56,499255200,8),(56,514983600,7),(56,530704800,8),(56,544618800,7),(56,562154400,8),(56,576068400,7),(56,594208800,8),(56,607518000,7),(56,625658400,8),(56,638967600,7),(56,657108000,8),(56,671022000,7),(56,688557600,8),(56,702471600,7),(56,720007200,8),(56,733921200,7),(56,752061600,8),(56,765370800,7),(56,783511200,8),(56,796820400,7),(56,814960800,8),(56,828874800,7),(56,846410400,8),(56,860324400,7),(56,877860000,8),(56,891774000,7),(56,909309600,8),(56,923223600,7),(56,941364000,8),(56,954673200,7),(56,972813600,8),(56,986122800,7),(56,1004263200,8),(56,1018177200,7),(56,1035712800,8),(56,1049626800,7),(56,1067162400,8),(56,1081076400,7),(56,1099216800,8),(56,1112526000,7),(56,1130666400,8),(56,1143975600,7),(56,1162116000,8),(56,1173610800,7),(56,1194170400,8),(56,1205060400,7),(56,1225620000,8),(56,1236510000,7),(56,1257069600,8),(56,1268564400,7),(56,1289124000,8),(56,1300014000,7),(56,1320573600,8),(56,1331463600,7),(56,1352023200,8),(56,1362913200,7),(56,1383472800,8),(56,1394362800,7),(56,1414922400,8),(56,1425812400,7),(56,1446372000,8),(56,1457866800,7),(56,1478426400,8),(56,1489316400,7),(56,1509876000,8),(56,1520766000,7),(56,1541325600,8),(56,1552215600,7),(56,1572775200,8),(56,1583665200,7),(56,1604224800,8),(56,1615719600,7),(56,1636279200,8),(56,1647169200,7),(56,1667728800,8),(56,1678618800,7),(56,1699178400,8),(56,1710068400,7),(56,1730628000,8),(56,1741518000,7),(56,1762077600,8),(56,1772967600,7),(56,1793527200,8),(56,1805022000,7),(56,1825581600,8),(56,1836471600,7),(56,1857031200,8),(56,1867921200,7),(56,1888480800,8),(56,1899370800,7),(56,1919930400,8),(56,1930820400,7),(56,1951380000,8),(56,1962874800,7),(56,1983434400,8),(56,1994324400,7),(56,2014884000,8),(56,2025774000,7),(56,2046333600,8),(56,2057223600,7),(56,2077783200,8),(56,2088673200,7),(56,2109232800,8),(56,2120122800,7),(56,2140682400,8),(57,-2147483648,1),(57,-873057600,3),(57,-769395600,2),(57,-765399600,1),(58,-2147483648,1),(58,-873057600,3),(58,-769395600,2),(58,-765399600,1),(59,-2147483648,0),(59,-1767214032,2),(59,-1206957600,1),(59,-1191362400,2),(59,-1175374800,1),(59,-1159826400,2),(59,-633819600,1),(59,-622069200,2),(59,-602283600,1),(59,-591832800,2),(59,-570747600,1),(59,-560210400,2),(59,-539125200,1),(59,-531352800,2),(59,-191365200,1),(59,-184197600,2),(59,-155163600,1),(59,-150069600,2),(59,-128898000,1),(59,-121125600,2),(59,-99954000,1),(59,-89589600,2),(59,-68418000,1),(59,-57967200,2),(59,499748400,1),(59,511236000,2),(59,530593200,1),(59,540266400,2),(59,562129200,1),(59,571197600,2),(59,592974000,1),(59,602042400,2),(59,624423600,1),(59,634701600,2),(59,813726000,1),(59,824004000,2),(59,844570800,1),(59,856058400,2),(59,876106800,1),(59,888717600,2),(59,908074800,1),(59,919562400,2),(59,938919600,1),(59,951616800,2),(59,970974000,1),(59,982461600,2),(59,1003028400,1),(59,1013911200,2),(59,1036292400,1),(59,1045360800,2),(59,1350788400,1),(59,1361066400,2),(59,2147483647,2),(60,-2147483648,1),(60,-1567453392,2),(60,-1233432000,3),(60,-1222981200,2),(60,-1205956800,3),(60,-1194037200,2),(60,-1172865600,3),(60,-1162501200,2),(60,-1141329600,3),(60,-1130965200,2),(60,-1109793600,3),(60,-1099429200,2),(60,-1078257600,3),(60,-1067806800,2),(60,-1046635200,3),(60,-1036270800,2),(60,-1015099200,3),(60,-1004734800,2),(60,-983563200,3),(60,-973198800,2),(60,-952027200,3),(60,-941576400,2),(60,-931032000,3),(60,-900882000,2),(60,-890337600,3),(60,-833749200,2),(60,-827265600,3),(60,-752274000,2),(60,-733780800,3),(60,-197326800,2),(60,-190843200,3),(60,-184194000,2),(60,-164491200,3),(60,-152658000,2),(60,-132955200,3),(60,-121122000,2),(60,-101419200,3),(60,-86821200,2),(60,-71092800,3),(60,-54766800,2),(60,-39038400,3),(60,-23317200,2),(60,-7588800,5),(60,128142000,4),(60,136605600,5),(60,596948400,4),(60,605066400,5),(60,624423600,4),(60,636516000,5),(60,656478000,4),(60,667965600,5),(60,687927600,4),(60,699415200,5),(60,719377200,4),(60,731469600,5),(60,938919600,3),(60,952052400,5),(60,1198983600,4),(60,1205632800,5),(60,1224385200,4),(60,1237082400,5),(60,2147483647,5),(61,-2147483648,1),(61,-1567453392,2),(61,-1233432000,3),(61,-1222981200,2),(61,-1205956800,3),(61,-1194037200,2),(61,-1172865600,3),(61,-1162501200,2),(61,-1141329600,3),(61,-1130965200,2),(61,-1109793600,3),(61,-1099429200,2),(61,-1078257600,3),(61,-1067806800,2),(61,-1046635200,3),(61,-1036270800,2),(61,-1015099200,3),(61,-1004734800,2),(61,-983563200,3),(61,-973198800,2),(61,-952027200,3),(61,-941576400,2),(61,-931032000,3),(61,-900882000,2),(61,-890337600,3),(61,-833749200,2),(61,-827265600,3),(61,-752274000,2),(61,-733780800,3),(61,-197326800,2),(61,-190843200,3),(61,-184194000,2),(61,-164491200,3),(61,-152658000,2),(61,-132955200,3),(61,-121122000,2),(61,-101419200,3),(61,-86821200,2),(61,-71092800,3),(61,-54766800,2),(61,-39038400,3),(61,-23317200,2),(61,-7588800,5),(61,128142000,4),(61,136605600,5),(61,596948400,4),(61,605066400,5),(61,624423600,4),(61,636516000,5),(61,656478000,4),(61,667965600,2),(61,687931200,4),(61,699415200,5),(61,719377200,4),(61,731469600,5),(61,938919600,3),(61,952052400,5),(61,1086058800,2),(61,1087704000,5),(61,1198983600,4),(61,1205632800,5),(61,2147483647,5),(62,-2147483648,1),(62,-1567453392,2),(62,-1233432000,3),(62,-1222981200,2),(62,-1205956800,3),(62,-1194037200,2),(62,-1172865600,3),(62,-1162501200,2),(62,-1141329600,3),(62,-1130965200,2),(62,-1109793600,3),(62,-1099429200,2),(62,-1078257600,3),(62,-1067806800,2),(62,-1046635200,3),(62,-1036270800,2),(62,-1015099200,3),(62,-1004734800,2),(62,-983563200,3),(62,-973198800,2),(62,-952027200,3),(62,-941576400,2),(62,-931032000,3),(62,-900882000,2),(62,-890337600,3),(62,-833749200,2),(62,-827265600,3),(62,-752274000,2),(62,-733780800,3),(62,-197326800,2),(62,-190843200,3),(62,-184194000,2),(62,-164491200,3),(62,-152658000,2),(62,-132955200,3),(62,-121122000,2),(62,-101419200,3),(62,-86821200,2),(62,-71092800,3),(62,-54766800,2),(62,-39038400,3),(62,-23317200,2),(62,-7588800,5),(62,128142000,4),(62,136605600,5),(62,596948400,4),(62,605066400,5),(62,624423600,4),(62,636516000,5),(62,656478000,4),(62,667965600,2),(62,687931200,4),(62,699415200,5),(62,719377200,4),(62,731469600,5),(62,938919600,3),(62,952052400,5),(62,1086058800,2),(62,1087704000,5),(62,1198983600,4),(62,1205632800,5),(62,2147483647,5),(63,-2147483648,1),(63,-1567453392,2),(63,-1233432000,3),(63,-1222981200,2),(63,-1205956800,3),(63,-1194037200,2),(63,-1172865600,3),(63,-1162501200,2),(63,-1141329600,3),(63,-1130965200,2),(63,-1109793600,3),(63,-1099429200,2),(63,-1078257600,3),(63,-1067806800,2),(63,-1046635200,3),(63,-1036270800,2),(63,-1015099200,3),(63,-1004734800,2),(63,-983563200,3),(63,-973198800,2),(63,-952027200,3),(63,-941576400,2),(63,-931032000,3),(63,-900882000,2),(63,-890337600,3),(63,-833749200,2),(63,-827265600,3),(63,-752274000,2),(63,-733780800,3),(63,-197326800,2),(63,-190843200,3),(63,-184194000,2),(63,-164491200,3),(63,-152658000,2),(63,-132955200,3),(63,-121122000,2),(63,-101419200,3),(63,-86821200,2),(63,-71092800,3),(63,-54766800,2),(63,-39038400,3),(63,-23317200,2),(63,-7588800,5),(63,128142000,4),(63,136605600,5),(63,596948400,4),(63,605066400,5),(63,624423600,4),(63,636516000,5),(63,656478000,4),(63,667965600,2),(63,687931200,4),(63,699415200,5),(63,719377200,4),(63,731469600,5),(63,938919600,3),(63,952052400,5),(63,1198983600,4),(63,1205632800,5),(63,1224385200,4),(63,1237082400,5),(63,2147483647,5),(64,-2147483648,1),(64,-1567453392,2),(64,-1233432000,3),(64,-1222981200,2),(64,-1205956800,3),(64,-1194037200,2),(64,-1172865600,3),(64,-1162501200,2),(64,-1141329600,3),(64,-1130965200,2),(64,-1109793600,3),(64,-1099429200,2),(64,-1078257600,3),(64,-1067806800,2),(64,-1046635200,3),(64,-1036270800,2),(64,-1015099200,3),(64,-1004734800,2),(64,-983563200,3),(64,-973198800,2),(64,-952027200,3),(64,-941576400,2),(64,-931032000,3),(64,-900882000,2),(64,-890337600,3),(64,-833749200,2),(64,-827265600,3),(64,-752274000,2),(64,-733780800,3),(64,-197326800,2),(64,-190843200,3),(64,-184194000,2),(64,-164491200,3),(64,-152658000,2),(64,-132955200,3),(64,-121122000,2),(64,-101419200,3),(64,-86821200,2),(64,-71092800,3),(64,-54766800,2),(64,-39038400,3),(64,-23317200,2),(64,-7588800,5),(64,128142000,4),(64,136605600,5),(64,596948400,4),(64,605066400,5),(64,624423600,4),(64,636516000,2),(64,657086400,3),(64,669178800,2),(64,686721600,4),(64,699415200,5),(64,719377200,4),(64,731469600,5),(64,938919600,3),(64,952052400,5),(64,1198983600,4),(64,1205632800,5),(64,2147483647,5),(65,-2147483648,1),(65,-1567453392,2),(65,-1233432000,3),(65,-1222981200,2),(65,-1205956800,3),(65,-1194037200,2),(65,-1172865600,3),(65,-1162501200,2),(65,-1141329600,3),(65,-1130965200,2),(65,-1109793600,3),(65,-1099429200,2),(65,-1078257600,3),(65,-1067806800,2),(65,-1046635200,3),(65,-1036270800,2),(65,-1015099200,3),(65,-1004734800,2),(65,-983563200,3),(65,-973198800,2),(65,-952027200,3),(65,-941576400,2),(65,-931032000,3),(65,-900882000,2),(65,-890337600,3),(65,-833749200,2),(65,-827265600,3),(65,-752274000,2),(65,-733780800,3),(65,-197326800,2),(65,-190843200,3),(65,-184194000,2),(65,-164491200,3),(65,-152658000,2),(65,-132955200,3),(65,-121122000,2),(65,-101419200,3),(65,-86821200,2),(65,-71092800,3),(65,-54766800,2),(65,-39038400,3),(65,-23317200,2),(65,-7588800,5),(65,128142000,4),(65,136605600,5),(65,596948400,4),(65,605066400,5),(65,624423600,4),(65,636516000,5),(65,656478000,4),(65,667792800,2),(65,673588800,5),(65,687927600,4),(65,699415200,5),(65,719377200,4),(65,731469600,5),(65,938919600,3),(65,952052400,5),(65,1086058800,2),(65,1087704000,5),(65,1198983600,4),(65,1205632800,5),(65,2147483647,5),(66,-2147483648,1),(66,-1567453392,2),(66,-1233432000,3),(66,-1222981200,2),(66,-1205956800,3),(66,-1194037200,2),(66,-1172865600,3),(66,-1162501200,2),(66,-1141329600,3),(66,-1130965200,2),(66,-1109793600,3),(66,-1099429200,2),(66,-1078257600,3),(66,-1067806800,2),(66,-1046635200,3),(66,-1036270800,2),(66,-1015099200,3),(66,-1004734800,2),(66,-983563200,3),(66,-973198800,2),(66,-952027200,3),(66,-941576400,2),(66,-931032000,3),(66,-900882000,2),(66,-890337600,3),(66,-833749200,2),(66,-827265600,3),(66,-752274000,2),(66,-733780800,3),(66,-197326800,2),(66,-190843200,3),(66,-184194000,2),(66,-164491200,3),(66,-152658000,2),(66,-132955200,3),(66,-121122000,2),(66,-101419200,3),(66,-86821200,2),(66,-71092800,3),(66,-54766800,2),(66,-39038400,3),(66,-23317200,2),(66,-7588800,5),(66,128142000,4),(66,136605600,5),(66,596948400,4),(66,605066400,5),(66,624423600,4),(66,636516000,2),(66,655963200,3),(66,667796400,2),(66,687499200,3),(66,699418800,2),(66,719380800,4),(66,731469600,5),(66,938919600,3),(66,952052400,5),(66,1085281200,2),(66,1096171200,5),(66,1198983600,4),(66,1205632800,5),(66,2147483647,5),(67,-2147483648,1),(67,-1567453392,2),(67,-1233432000,3),(67,-1222981200,2),(67,-1205956800,3),(67,-1194037200,2),(67,-1172865600,3),(67,-1162501200,2),(67,-1141329600,3),(67,-1130965200,2),(67,-1109793600,3),(67,-1099429200,2),(67,-1078257600,3),(67,-1067806800,2),(67,-1046635200,3),(67,-1036270800,2),(67,-1015099200,3),(67,-1004734800,2),(67,-983563200,3),(67,-973198800,2),(67,-952027200,3),(67,-941576400,2),(67,-931032000,3),(67,-900882000,2),(67,-890337600,3),(67,-833749200,2),(67,-827265600,3),(67,-752274000,2),(67,-733780800,3),(67,-197326800,2),(67,-190843200,3),(67,-184194000,2),(67,-164491200,3),(67,-152658000,2),(67,-132955200,3),(67,-121122000,2),(67,-101419200,3),(67,-86821200,2),(67,-71092800,3),(67,-54766800,2),(67,-39038400,3),(67,-23317200,2),(67,-7588800,5),(67,128142000,4),(67,136605600,5),(67,596948400,4),(67,605066400,5),(67,624423600,4),(67,636516000,5),(67,656478000,4),(67,667965600,5),(67,687927600,4),(67,699415200,5),(67,719377200,4),(67,731469600,5),(67,938919600,3),(67,952052400,5),(67,1086058800,2),(67,1087704000,5),(67,1198983600,4),(67,1205632800,5),(67,2147483647,5),(68,-2147483648,1),(68,-1567453392,2),(68,-1233432000,3),(68,-1222981200,2),(68,-1205956800,3),(68,-1194037200,2),(68,-1172865600,3),(68,-1162501200,2),(68,-1141329600,3),(68,-1130965200,2),(68,-1109793600,3),(68,-1099429200,2),(68,-1078257600,3),(68,-1067806800,2),(68,-1046635200,3),(68,-1036270800,2),(68,-1015099200,3),(68,-1004734800,2),(68,-983563200,3),(68,-973198800,2),(68,-952027200,3),(68,-941576400,2),(68,-931032000,3),(68,-900882000,2),(68,-890337600,3),(68,-833749200,2),(68,-827265600,3),(68,-752274000,2),(68,-733780800,3),(68,-197326800,2),(68,-190843200,3),(68,-184194000,2),(68,-164491200,3),(68,-152658000,2),(68,-132955200,3),(68,-121122000,2),(68,-101419200,3),(68,-86821200,2),(68,-71092800,3),(68,-54766800,2),(68,-39038400,3),(68,-23317200,2),(68,-7588800,5),(68,128142000,4),(68,136605600,5),(68,596948400,4),(68,605066400,5),(68,624423600,4),(68,636516000,5),(68,656478000,4),(68,667965600,2),(68,687931200,4),(68,699415200,5),(68,719377200,4),(68,731469600,5),(68,938919600,3),(68,952052400,5),(68,1198983600,4),(68,1205632800,5),(68,2147483647,5),(69,-2147483648,1),(69,-1567453392,2),(69,-1233432000,3),(69,-1222981200,2),(69,-1205956800,3),(69,-1194037200,2),(69,-1172865600,3),(69,-1162501200,2),(69,-1141329600,3),(69,-1130965200,2),(69,-1109793600,3),(69,-1099429200,2),(69,-1078257600,3),(69,-1067806800,2),(69,-1046635200,3),(69,-1036270800,2),(69,-1015099200,3),(69,-1004734800,2),(69,-983563200,3),(69,-973198800,2),(69,-952027200,3),(69,-941576400,2),(69,-931032000,3),(69,-900882000,2),(69,-890337600,3),(69,-833749200,2),(69,-827265600,3),(69,-752274000,2),(69,-733780800,3),(69,-197326800,2),(69,-190843200,3),(69,-184194000,2),(69,-164491200,3),(69,-152658000,2),(69,-132955200,3),(69,-121122000,2),(69,-101419200,3),(69,-86821200,2),(69,-71092800,3),(69,-54766800,2),(69,-39038400,3),(69,-23317200,2),(69,-7588800,5),(69,128142000,4),(69,136605600,5),(69,596948400,4),(69,605066400,5),(69,624423600,4),(69,636516000,5),(69,656478000,4),(69,667792800,2),(69,673588800,5),(69,687927600,4),(69,699415200,5),(69,719377200,4),(69,731469600,5),(69,938919600,3),(69,952052400,5),(69,1085972400,2),(69,1090728000,5),(69,1198983600,4),(69,1205632800,5),(69,2147483647,5),(70,-2147483648,1),(70,-1567453392,2),(70,-1233432000,3),(70,-1222981200,2),(70,-1205956800,3),(70,-1194037200,2),(70,-1172865600,3),(70,-1162501200,2),(70,-1141329600,3),(70,-1130965200,2),(70,-1109793600,3),(70,-1099429200,2),(70,-1078257600,3),(70,-1067806800,2),(70,-1046635200,3),(70,-1036270800,2),(70,-1015099200,3),(70,-1004734800,2),(70,-983563200,3),(70,-973198800,2),(70,-952027200,3),(70,-941576400,2),(70,-931032000,3),(70,-900882000,2),(70,-890337600,3),(70,-833749200,2),(70,-827265600,3),(70,-752274000,2),(70,-733780800,3),(70,-197326800,2),(70,-190843200,3),(70,-184194000,2),(70,-164491200,3),(70,-152658000,2),(70,-132955200,3),(70,-121122000,2),(70,-101419200,3),(70,-86821200,2),(70,-71092800,3),(70,-54766800,2),(70,-39038400,3),(70,-23317200,2),(70,-7588800,5),(70,128142000,4),(70,136605600,5),(70,596948400,4),(70,605066400,5),(70,624423600,4),(70,637380000,2),(70,655963200,3),(70,667796400,2),(70,675748800,5),(70,938919600,3),(70,952052400,5),(70,1085972400,2),(70,1090728000,5),(70,1198983600,4),(70,1200880800,3),(70,1205031600,2),(70,1223784000,3),(70,1236481200,2),(70,1255233600,5),(70,2147483647,5),(71,-2147483648,1),(71,-1567453392,2),(71,-1233432000,3),(71,-1222981200,2),(71,-1205956800,3),(71,-1194037200,2),(71,-1172865600,3),(71,-1162501200,2),(71,-1141329600,3),(71,-1130965200,2),(71,-1109793600,3),(71,-1099429200,2),(71,-1078257600,3),(71,-1067806800,2),(71,-1046635200,3),(71,-1036270800,2),(71,-1015099200,3),(71,-1004734800,2),(71,-983563200,3),(71,-973198800,2),(71,-952027200,3),(71,-941576400,2),(71,-931032000,3),(71,-900882000,2),(71,-890337600,3),(71,-833749200,2),(71,-827265600,3),(71,-752274000,2),(71,-733780800,3),(71,-197326800,2),(71,-190843200,3),(71,-184194000,2),(71,-164491200,3),(71,-152658000,2),(71,-132955200,3),(71,-121122000,2),(71,-101419200,3),(71,-86821200,2),(71,-71092800,3),(71,-54766800,2),(71,-39038400,3),(71,-23317200,2),(71,-7588800,5),(71,128142000,4),(71,136605600,5),(71,596948400,4),(71,605066400,5),(71,624423600,4),(71,636516000,5),(71,656478000,4),(71,667965600,2),(71,687931200,4),(71,699415200,5),(71,719377200,4),(71,731469600,5),(71,938919600,3),(71,952052400,5),(71,1086058800,2),(71,1087099200,5),(71,1198983600,4),(71,1205632800,5),(71,1224385200,4),(71,1237082400,5),(71,2147483647,5),(72,-2147483648,1),(72,-1567453392,2),(72,-1233432000,3),(72,-1222981200,2),(72,-1205956800,3),(72,-1194037200,2),(72,-1172865600,3),(72,-1162501200,2),(72,-1141329600,3),(72,-1130965200,2),(72,-1109793600,3),(72,-1099429200,2),(72,-1078257600,3),(72,-1067806800,2),(72,-1046635200,3),(72,-1036270800,2),(72,-1015099200,3),(72,-1004734800,2),(72,-983563200,3),(72,-973198800,2),(72,-952027200,3),(72,-941576400,2),(72,-931032000,3),(72,-900882000,2),(72,-890337600,3),(72,-833749200,2),(72,-827265600,3),(72,-752274000,2),(72,-733780800,3),(72,-197326800,2),(72,-190843200,3),(72,-184194000,2),(72,-164491200,3),(72,-152658000,2),(72,-132955200,3),(72,-121122000,2),(72,-101419200,3),(72,-86821200,2),(72,-71092800,3),(72,-54766800,2),(72,-39038400,3),(72,-23317200,2),(72,-7588800,5),(72,128142000,4),(72,136605600,5),(72,596948400,4),(72,605066400,5),(72,624423600,4),(72,636516000,5),(72,656478000,4),(72,667965600,5),(72,687927600,4),(72,699415200,5),(72,719377200,4),(72,731469600,5),(72,938919600,3),(72,952052400,5),(72,1085886000,2),(72,1087704000,5),(72,1198983600,4),(72,1205632800,5),(72,2147483647,5),(73,-2147483648,1),(73,-873057600,3),(73,-769395600,2),(73,-765399600,1),(74,-2147483648,1),(74,-1206389360,2),(74,86760000,3),(74,134017200,2),(74,181368000,4),(74,194497200,2),(74,212990400,4),(74,226033200,2),(74,244526400,4),(74,257569200,2),(74,276062400,4),(74,291783600,2),(74,307598400,4),(74,323406000,2),(74,339220800,4),(74,354942000,2),(74,370756800,4),(74,386478000,2),(74,402292800,4),(74,418014000,2),(74,433828800,4),(74,449636400,2),(74,465451200,4),(74,481172400,2),(74,496987200,4),(74,512708400,2),(74,528523200,4),(74,544244400,2),(74,560059200,4),(74,575866800,2),(74,591681600,4),(74,607402800,2),(74,625032000,4),(74,638938800,2),(74,654753600,4),(74,670474800,2),(74,686721600,4),(74,699418800,2),(74,718257600,4),(74,733546800,2),(74,749448000,4),(74,762318000,2),(74,780984000,4),(74,793767600,2),(74,812520000,4),(74,825649200,2),(74,844574400,4),(74,856666800,2),(74,876024000,4),(74,888721200,2),(74,907473600,4),(74,920775600,2),(74,938923200,4),(74,952225200,2),(74,970372800,4),(74,983674800,2),(74,1002427200,4),(74,1018148400,2),(74,1030852800,4),(74,1049598000,2),(74,1062907200,4),(74,1081047600,2),(74,1097985600,4),(74,1110682800,2),(74,1129435200,4),(74,1142132400,2),(74,1160884800,4),(74,1173582000,2),(74,1192939200,4),(74,1205031600,2),(74,1224388800,4),(74,1236481200,2),(74,1255838400,4),(74,1270954800,2),(74,1286078400,4),(74,1302404400,2),(74,1317528000,4),(74,1333854000,2),(74,1349582400,4),(74,1364094000,2),(74,1381032000,4),(74,1395543600,2),(74,1412481600,4),(74,1426993200,2),(74,1443931200,4),(74,1459047600,2),(74,1475380800,4),(74,1490497200,2),(74,1506830400,4),(74,1521946800,2),(74,1538884800,4),(74,1553396400,2),(74,1570334400,4),(74,1584846000,2),(74,1601784000,4),(74,1616900400,2),(74,1633233600,4),(74,1648350000,2),(74,1664683200,4),(74,1679799600,2),(74,1696132800,4),(74,1711249200,2),(74,1728187200,4),(74,1742698800,2),(74,1759636800,4),(74,1774148400,2),(74,1791086400,4),(74,1806202800,2),(74,1822536000,4),(74,1837652400,2),(74,1853985600,4),(74,1869102000,2),(74,1886040000,4),(74,1900551600,2),(74,1917489600,4),(74,1932001200,2),(74,1948939200,4),(74,1964055600,2),(74,1980388800,4),(74,1995505200,2),(74,2011838400,4),(74,2026954800,2),(74,2043288000,4),(74,2058404400,2),(74,2075342400,4),(74,2089854000,2),(74,2106792000,4),(74,2121303600,2),(74,2138241600,4),(74,2147483647,4),(75,-2147483648,1),(75,-1946918424,2),(76,-2147483648,1),(76,-880196400,2),(76,-769395600,3),(76,-765374400,1),(76,-86878800,4),(76,-21466800,5),(76,-5745600,4),(76,9982800,5),(76,25704000,4),(76,41432400,5),(76,57758400,4),(76,73486800,5),(76,89208000,4),(76,104936400,5),(76,120657600,4),(76,126709200,5),(76,152107200,4),(76,162392400,5),(76,183556800,4),(76,199285200,5),(76,215611200,4),(76,230734800,5),(76,247060800,4),(76,262789200,5),(76,278510400,4),(76,294238800,5),(76,309960000,4),(76,325688400,5),(76,341409600,4),(76,357138000,5),(76,372859200,4),(76,388587600,5),(76,404913600,4),(76,420037200,5),(76,436363200,6),(76,439034400,8),(76,452088000,7),(76,467809200,8),(76,483537600,7),(76,499258800,8),(76,514987200,7),(76,530708400,8),(76,544622400,7),(76,562158000,8),(76,576072000,7),(76,594212400,8),(76,607521600,7),(76,625662000,8),(76,638971200,7),(76,657111600,8),(76,671025600,7),(76,688561200,8),(76,702475200,7),(76,720010800,8),(76,733924800,7),(76,752065200,8),(76,765374400,7),(76,783514800,8),(76,796824000,7),(76,814964400,8),(76,828878400,7),(76,846414000,8),(76,860328000,7),(76,877863600,8),(76,891777600,7),(76,909313200,8),(76,923227200,7),(76,941367600,8),(76,954676800,7),(76,972817200,8),(76,986126400,7),(76,1004266800,8),(76,1018180800,7),(76,1035716400,8),(76,1049630400,7),(76,1067166000,8),(76,1081080000,7),(76,1099220400,8),(76,1112529600,7),(76,1130670000,8),(76,1143979200,7),(76,1162119600,8),(76,1173614400,7),(76,1194174000,8),(76,1205064000,7),(76,1225623600,8),(76,1236513600,7),(76,1257073200,8),(76,1268568000,7),(76,1289127600,8),(76,1300017600,7),(76,1320577200,8),(76,1331467200,7),(76,1352026800,8),(76,1362916800,7),(76,1383476400,8),(76,1394366400,7),(76,1414926000,8),(76,1425816000,7),(76,1446375600,8),(76,1457870400,7),(76,1478430000,8),(76,1489320000,7),(76,1509879600,8),(76,1520769600,7),(76,1541329200,8),(76,1552219200,7),(76,1572778800,8),(76,1583668800,7),(76,1604228400,8),(76,1615723200,7),(76,1636282800,8),(76,1647172800,7),(76,1667732400,8),(76,1678622400,7),(76,1699182000,8),(76,1710072000,7),(76,1730631600,8),(76,1741521600,7),(76,1762081200,8),(76,1772971200,7),(76,1793530800,8),(76,1805025600,7),(76,1825585200,8),(76,1836475200,7),(76,1857034800,8),(76,1867924800,7),(76,1888484400,8),(76,1899374400,7),(76,1919934000,8),(76,1930824000,7),(76,1951383600,8),(76,1962878400,7),(76,1983438000,8),(76,1994328000,7),(76,2014887600,8),(76,2025777600,7),(76,2046337200,8),(76,2057227200,7),(76,2077786800,8),(76,2088676800,7),(76,2109236400,8),(76,2120126400,7),(76,2140686000,8),(77,-2147483648,0),(77,-1767216356,2),(77,-1206957600,1),(77,-1191362400,2),(77,-1175374800,1),(77,-1159826400,2),(77,-633819600,1),(77,-622069200,2),(77,-602283600,1),(77,-591832800,2),(77,-570747600,1),(77,-560210400,2),(77,-539125200,1),(77,-531352800,2),(77,-191365200,1),(77,-184197600,2),(77,-155163600,1),(77,-150069600,2),(77,-128898000,1),(77,-121125600,2),(77,-99954000,1),(77,-89589600,2),(77,-68418000,1),(77,-57967200,2),(77,499748400,1),(77,511236000,2),(77,530593200,1),(77,540266400,2),(77,562129200,1),(77,571197600,2),(77,592974000,1),(77,602042400,2),(77,624423600,1),(77,634701600,2),(77,656478000,1),(77,666756000,2),(77,687927600,1),(77,697600800,2),(77,719982000,1),(77,728445600,2),(77,750826800,1),(77,761709600,2),(77,782276400,1),(77,793159200,2),(77,813726000,1),(77,824004000,2),(77,844570800,1),(77,856058400,2),(77,876106800,1),(77,888717600,2),(77,908074800,1),(77,919562400,2),(77,938919600,1),(77,951616800,2),(77,970974000,1),(77,982461600,2),(77,1003028400,1),(77,1013911200,2),(77,1036292400,1),(77,1045360800,2),(77,1318734000,1),(77,1330221600,2),(77,2147483647,2),(78,-2147483648,0),(78,-1514739600,1),(78,-1343066400,2),(78,-1234807200,4),(78,-1220292000,3),(78,-1207159200,4),(78,-1191344400,2),(78,-873828000,4),(78,-661539600,5),(78,28800,4),(78,828867600,3),(78,846403200,4),(78,860317200,3),(78,877852800,4),(78,891766800,3),(78,909302400,4),(78,923216400,3),(78,941356800,4),(78,954666000,3),(78,972806400,4),(78,989139600,3),(78,1001836800,4),(78,1018170000,3),(78,1035705600,4),(78,1049619600,3),(78,1067155200,4),(78,1081069200,3),(78,1099209600,4),(78,1112518800,3),(78,1130659200,4),(78,1143968400,3),(78,1162108800,4),(78,1175418000,3),(78,1193558400,4),(78,1207472400,3),(78,1225008000,4),(78,1238922000,3),(78,1256457600,4),(78,1270371600,6),(78,1288508400,2),(78,1301817600,6),(78,1319958000,2),(78,1333267200,6),(78,1351407600,2),(78,1365321600,6),(78,1382857200,2),(78,1396771200,6),(78,1414306800,2),(78,1428220800,6),(78,1445756400,2),(78,1459670400,6),(78,1477810800,2),(78,1491120000,6),(78,1509260400,2),(78,1522569600,6),(78,1540710000,2),(78,1554624000,6),(78,1572159600,2),(78,1586073600,6),(78,1603609200,2),(78,1617523200,6),(78,1635663600,2),(78,1648972800,6),(78,1667113200,2),(79,-2147483648,0),(79,-1841256091,3),(79,-874263600,1),(79,-862682400,2),(79,-841604400,1),(79,-830714400,2),(79,-820526400,3),(79,-811882800,4),(79,-798660000,2),(79,-788904000,3),(79,234943200,5),(79,244616400,3),(79,261554400,5),(79,276066000,3),(79,293004000,5),(79,307515600,3),(79,325058400,5),(79,338706000,3),(80,-2147483648,0),(80,-1767213964,2),(80,-1206957600,1),(80,-1191362400,2),(80,-1175374800,1),(80,-1159826400,2),(80,-633819600,1),(80,-622069200,2),(80,-602283600,1),(80,-591832800,2),(80,-570747600,1),(80,-560210400,2),(80,-539125200,1),(80,-531352800,2),(80,-191365200,1),(80,-184197600,2),(80,-155163600,1),(80,-150069600,2),(80,-128898000,1),(80,-121125600,2),(80,-99954000,1),(80,-89589600,2),(80,-68418000,1),(80,-57967200,2),(80,499748400,1),(80,511236000,2),(80,530593200,1),(80,540266400,2),(80,562129200,1),(80,571197600,2),(80,2147483647,2),(81,-2147483648,0),(81,-1822500432,2),(81,-1616954400,1),(81,-1606069800,2),(81,-1585504800,1),(81,-1574015400,2),(81,-1554055200,1),(81,-1542565800,2),(81,-1522605600,1),(81,-1511116200,2),(81,-1490551200,1),(81,-1479666600,2),(81,-1459101600,1),(81,-1448217000,2),(81,-1427652000,1),(81,-1416162600,2),(81,-1396202400,1),(81,-1384713000,2),(81,-1364752800,1),(81,-1353263400,2),(81,-1333303200,1),(81,-1321813800,2),(81,-1301248800,1),(81,-1290364200,2),(81,-1269799200,1),(81,-1258914600,2),(81,-1238349600,1),(81,-1226860200,2),(81,-1206900000,1),(81,-1195410600,2),(81,-1175450400,1),(81,-1163961000,2),(81,-1143396000,1),(81,-1132511400,2),(81,-1111946400,1),(81,-1101061800,2),(81,-1080496800,1),(81,-1069612200,2),(81,-1049047200,1),(81,-1037557800,2),(81,-1017597600,1),(81,-1006108200,2),(81,-986148000,1),(81,-974658600,2),(81,-954093600,1),(81,-943209000,2),(81,-922644000,1),(81,-911759400,2),(81,-891194400,1),(81,-879705000,2),(81,-868212000,3),(81,-769395600,4),(81,-758746800,2),(81,-701892000,1),(81,-690402600,2),(81,-670442400,1),(81,-658953000,2),(81,-638992800,1),(81,-627503400,2),(81,-606938400,1),(81,-596053800,2),(81,-575488800,1),(81,-564604200,2),(81,-544039200,1),(81,-532549800,2),(81,-512589600,1),(81,-501100200,2),(81,-481140000,1),(81,-469650600,2),(81,-449690400,1),(81,-438201000,2),(81,-417636000,1),(81,-406751400,2),(81,-386186400,1),(81,-375301800,2),(81,-354736800,1),(81,-343247400,2),(81,-323287200,1),(81,-311797800,2),(81,-291837600,1),(81,-280348200,2),(81,-259783200,1),(81,-248898600,2),(81,-228333600,1),(81,-217449000,2),(81,-196884000,1),(81,-185999400,2),(81,-165434400,1),(81,-153945000,2),(81,-133984800,1),(81,-122495400,2),(81,-102535200,1),(81,-91045800,2),(81,-70480800,1),(81,-59596200,2),(81,123919200,5),(81,129618000,2),(81,409039200,5),(81,413874000,2),(82,-2147483648,1),(82,-873057600,3),(82,-769395600,2),(82,-765399600,1),(83,-2147483648,0),(83,-1767211040,2),(83,-1206954000,1),(83,-1191358800,2),(83,-1175371200,1),(83,-1159822800,2),(83,-633816000,1),(83,-622065600,2),(83,-602280000,1),(83,-591829200,2),(83,-570744000,1),(83,-560206800,2),(83,-539121600,1),(83,-531349200,2),(83,-191361600,1),(83,-184194000,2),(83,-155160000,1),(83,-150066000,2),(83,-128894400,1),(83,-121122000,2),(83,-99950400,1),(83,-89586000,2),(83,-68414400,1),(83,-57963600,2),(83,499752000,1),(83,511239600,2),(83,530596800,1),(83,540270000,2),(83,562132800,1),(83,571201200,2),(83,938923200,1),(83,951620400,2),(83,970977600,1),(83,971578800,2),(83,2147483647,2),(84,-2147483648,1),(84,-1739041424,3),(84,704869200,2),(84,729057600,3),(84,2147483647,3),(85,-2147483648,3),(85,-1633269600,1),(85,-1615129200,2),(85,-1601820000,1),(85,-1583679600,2),(85,-1471788000,6),(85,-880210800,4),(85,-769395600,5),(85,-765388800,6),(85,-84380400,7),(85,-68659200,6),(85,-52930800,7),(85,-37209600,6),(85,-21481200,7),(85,-5760000,6),(85,9968400,7),(85,25689600,6),(85,41418000,7),(85,57744000,6),(85,73472400,7),(85,89193600,6),(85,104922000,7),(85,120643200,6),(85,129114000,7),(85,152092800,6),(85,162378000,7),(85,183542400,6),(85,199270800,7),(85,215596800,6),(85,230720400,7),(85,247046400,6),(85,262774800,7),(85,278496000,6),(85,294224400,7),(85,309945600,6),(85,325674000,7),(85,341395200,6),(85,357123600,7),(85,372844800,6),(85,388573200,7),(85,404899200,6),(85,420022800,7),(85,436348800,6),(85,452077200,7),(85,467798400,6),(85,483526800,7),(85,499248000,6),(85,514976400,7),(85,530697600,6),(85,544611600,7),(85,562147200,6),(85,576061200,7),(85,594201600,6),(85,607510800,7),(85,625651200,6),(85,638960400,7),(85,657100800,6),(85,671014800,7),(85,688550400,6),(85,702464400,7),(85,720000000,6),(85,733914000,7),(85,752054400,6),(85,765363600,7),(85,783504000,6),(85,796813200,7),(85,814953600,6),(85,828867600,7),(85,846403200,6),(85,860317200,7),(85,877852800,6),(85,891766800,7),(85,909302400,6),(85,923216400,7),(85,941356800,6),(85,954666000,7),(85,972806400,6),(85,986115600,7),(85,1004256000,6),(85,1018170000,7),(85,1035705600,6),(85,1049619600,7),(85,1067155200,6),(85,1081069200,7),(85,1099209600,6),(85,1112518800,7),(85,1130659200,6),(85,1143968400,7),(85,1162108800,6),(85,1173603600,7),(85,1194163200,6),(85,1205053200,7),(85,1225612800,6),(85,1236502800,7),(85,1257062400,6),(85,1268557200,7),(85,1289116800,6),(85,1300006800,7),(85,1320566400,6),(85,1331456400,7),(85,1352016000,6),(85,1362906000,7),(85,1383465600,6),(85,1394355600,7),(85,1414915200,6),(85,1425805200,7),(85,1446364800,6),(85,1457859600,7),(85,1478419200,6),(85,1489309200,7),(85,1509868800,6),(85,1520758800,7),(85,1541318400,6),(85,1552208400,7),(85,1572768000,6),(85,1583658000,7),(85,1604217600,6),(85,1615712400,7),(85,1636272000,6),(85,1647162000,7),(85,1667721600,6),(85,1678611600,7),(85,1699171200,6),(85,1710061200,7),(85,1730620800,6),(85,1741510800,7),(85,1762070400,6),(85,1772960400,7),(85,1793520000,6),(85,1805014800,7),(85,1825574400,6),(85,1836464400,7),(85,1857024000,6),(85,1867914000,7),(85,1888473600,6),(85,1899363600,7),(85,1919923200,6),(85,1930813200,7),(85,1951372800,6),(85,1962867600,7),(85,1983427200,6),(85,1994317200,7),(85,2014876800,6),(85,2025766800,7),(85,2046326400,6),(85,2057216400,7),(85,2077776000,6),(85,2088666000,7),(85,2109225600,6),(85,2120115600,7),(85,2140675200,6),(86,-2147483648,1),(86,-1567453392,2),(86,-1233432000,3),(86,-1222981200,2),(86,-1205956800,3),(86,-1194037200,2),(86,-1172865600,3),(86,-1162501200,2),(86,-1141329600,3),(86,-1130965200,2),(86,-1109793600,3),(86,-1099429200,2),(86,-1078257600,3),(86,-1067806800,2),(86,-1046635200,3),(86,-1036270800,2),(86,-1015099200,3),(86,-1004734800,2),(86,-983563200,3),(86,-973198800,2),(86,-952027200,3),(86,-941576400,2),(86,-931032000,3),(86,-900882000,2),(86,-890337600,3),(86,-833749200,2),(86,-827265600,3),(86,-752274000,2),(86,-733780800,3),(86,-197326800,2),(86,-190843200,3),(86,-184194000,2),(86,-164491200,3),(86,-152658000,2),(86,-132955200,3),(86,-121122000,2),(86,-101419200,3),(86,-86821200,2),(86,-71092800,3),(86,-54766800,2),(86,-39038400,3),(86,-23317200,2),(86,-7588800,5),(86,128142000,4),(86,136605600,5),(86,596948400,4),(86,605066400,5),(86,624423600,4),(86,636516000,5),(86,656478000,4),(86,667965600,5),(86,687927600,4),(86,699415200,5),(86,719377200,4),(86,731469600,5),(86,938919600,3),(86,952052400,5),(86,1198983600,4),(86,1205632800,5),(86,1224385200,4),(86,1237082400,5),(86,2147483647,5),(87,-2147483648,0),(87,-1577923200,3),(87,-880210800,1),(87,-769395600,2),(87,-765388800,3),(87,73472400,4),(87,89193600,3),(87,104922000,4),(87,120643200,3),(87,136371600,4),(87,152092800,3),(87,167821200,4),(87,183542400,3),(87,199270800,4),(87,215596800,3),(87,230720400,4),(87,247046400,3),(87,262774800,4),(87,278496000,3),(87,294224400,4),(87,309945600,3),(87,325674000,4),(87,341395200,3),(87,357123600,4),(87,372844800,3),(87,388573200,4),(87,404899200,3),(87,420022800,4),(87,436348800,3),(87,452077200,4),(87,467798400,3),(87,483526800,4),(87,499248000,3),(87,514976400,4),(87,530697600,3),(87,544611600,4),(87,562147200,3),(87,576061200,4),(87,594201600,3),(87,607510800,4),(87,625651200,3),(87,638960400,4),(87,657100800,3),(87,671014800,4),(87,688550400,3),(87,702464400,4),(87,720000000,3),(87,733914000,4),(87,752054400,3),(87,765363600,4),(87,783504000,3),(87,796813200,4),(87,814953600,3),(87,828867600,4),(87,846403200,3),(87,860317200,4),(87,877852800,3),(87,891766800,4),(87,909302400,3),(87,923216400,4),(87,941356800,6),(87,954662400,5),(87,972802800,7),(87,973400400,6),(87,986115600,4),(87,1004256000,3),(87,1018170000,4),(87,1035705600,3),(87,1049619600,4),(87,1067155200,3),(87,1081069200,4),(87,1099209600,3),(87,1112518800,4),(87,1130659200,3),(87,1143968400,4),(87,1162108800,3),(87,1173603600,4),(87,1194163200,3),(87,1205053200,4),(87,1225612800,3),(87,1236502800,4),(87,1257062400,3),(87,1268557200,4),(87,1289116800,3),(87,1300006800,4),(87,1320566400,3),(87,1331456400,4),(87,1352016000,3),(87,1362906000,4),(87,1383465600,3),(87,1394355600,4),(87,1414915200,3),(87,1425805200,4),(87,1446364800,3),(87,1457859600,4),(87,1478419200,3),(87,1489309200,4),(87,1509868800,3),(87,1520758800,4),(87,1541318400,3),(87,1552208400,4),(87,1572768000,3),(87,1583658000,4),(87,1604217600,3),(87,1615712400,4),(87,1636272000,3),(87,1647162000,4),(87,1667721600,3),(87,1678611600,4),(87,1699171200,3),(87,1710061200,4),(87,1730620800,3),(87,1741510800,4),(87,1762070400,3),(87,1772960400,4),(87,1793520000,3),(87,1805014800,4),(87,1825574400,3),(87,1836464400,4),(87,1857024000,3),(87,1867914000,4),(87,1888473600,3),(87,1899363600,4),(87,1919923200,3),(87,1930813200,4),(87,1951372800,3),(87,1962867600,4),(87,1983427200,3),(87,1994317200,4),(87,2014876800,3),(87,2025766800,4),(87,2046326400,3),(87,2057216400,4),(87,2077776000,3),(87,2088666000,4),(87,2109225600,3),(87,2120115600,4),(87,2140675200,3),(88,-2147483648,0),(88,-1767212492,2),(88,-1206954000,1),(88,-1191358800,2),(88,-1175371200,1),(88,-1159822800,2),(88,-633816000,1),(88,-622065600,2),(88,-602280000,1),(88,-591829200,2),(88,-570744000,1),(88,-560206800,2),(88,-539121600,1),(88,-531349200,2),(88,-191361600,1),(88,-184194000,2),(88,-155160000,1),(88,-150066000,2),(88,-128894400,1),(88,-121122000,2),(88,-99950400,1),(88,-89586000,2),(88,-68414400,1),(88,-57963600,2),(88,499752000,1),(88,511239600,2),(88,530596800,1),(88,540270000,2),(88,562132800,1),(88,571201200,2),(88,592977600,1),(88,602046000,2),(88,624427200,1),(88,634705200,2),(88,656481600,1),(88,666759600,2),(88,687931200,1),(88,697604400,2),(88,719985600,1),(88,728449200,2),(88,750830400,1),(88,761713200,2),(88,782280000,1),(88,793162800,2),(88,813729600,1),(88,824007600,2),(88,844574400,1),(88,856062000,2),(88,876110400,1),(88,888721200,2),(88,908078400,1),(88,919566000,2),(88,938923200,1),(88,951620400,2),(88,970977600,1),(88,982465200,2),(88,1003032000,1),(88,1013914800,2),(88,1036296000,1),(88,1045364400,2),(88,1066536000,1),(88,1076814000,2),(88,1099368000,1),(88,1108868400,2),(88,1129435200,1),(88,1140318000,2),(88,1162699200,1),(88,1172372400,2),(88,1192334400,1),(88,1203217200,2),(88,1224388800,1),(88,1234666800,2),(88,1255838400,1),(88,1266721200,2),(88,1287288000,1),(88,1298170800,2),(88,1318737600,1),(88,1330225200,2),(88,1350792000,1),(88,1361070000,2),(88,1382241600,1),(88,1392519600,2),(88,1413691200,1),(88,1424574000,2),(88,1445140800,1),(88,1456023600,2),(88,1476590400,1),(88,1487473200,2),(88,1508040000,1),(88,1518922800,2),(88,1541304000,1),(88,1550372400,2),(88,2147483647,2),(89,-2147483648,0),(89,-1514743200,1),(89,377935200,3),(89,828860400,2),(89,846396000,3),(89,860310000,2),(89,877845600,3),(89,891759600,2),(89,902037600,5),(89,909298800,4),(89,923212800,5),(89,941353200,4),(89,954662400,5),(89,972802800,4),(89,989136000,5),(89,1001833200,4),(89,1018166400,5),(89,1035702000,4),(89,1049616000,5),(89,1067151600,4),(89,1081065600,5),(89,1099206000,4),(89,1112515200,5),(89,1130655600,4),(89,1143964800,5),(89,1162105200,4),(89,1175414400,5),(89,1193554800,4),(89,1207468800,5),(89,1225004400,4),(89,1238918400,5),(89,1256454000,4),(89,1270368000,5),(89,1288508400,4),(89,1301817600,5),(89,1319958000,4),(89,1333267200,5),(89,1351407600,4),(89,1365321600,5),(89,1382857200,4),(89,1396771200,5),(89,1414306800,4),(89,1422777600,3),(90,-2147483648,1),(90,-1826739140,2),(90,-157750200,3),(90,1197183600,2),(90,1462086000,3),(90,2147483647,3),(91,-2147483648,1),(91,-1567453392,2),(91,-1233432000,3),(91,-1222981200,2),(91,-1205956800,3),(91,-1194037200,2),(91,-1172865600,3),(91,-1162501200,2),(91,-1141329600,3),(91,-1130965200,2),(91,-1109793600,3),(91,-1099429200,2),(91,-1078257600,3),(91,-1067806800,2),(91,-1046635200,3),(91,-1036270800,2),(91,-1015099200,3),(91,-1004734800,2),(91,-983563200,3),(91,-973198800,2),(91,-952027200,3),(91,-941576400,2),(91,-931032000,3),(91,-900882000,2),(91,-890337600,3),(91,-833749200,2),(91,-827265600,3),(91,-752274000,2),(91,-733780800,3),(91,-197326800,2),(91,-190843200,3),(91,-184194000,2),(91,-164491200,3),(91,-152658000,2),(91,-132955200,3),(91,-121122000,2),(91,-101419200,3),(91,-86821200,2),(91,-71092800,3),(91,-54766800,2),(91,-39038400,3),(91,-23317200,2),(91,-7588800,5),(91,128142000,4),(91,136605600,5),(91,596948400,4),(91,605066400,5),(91,624423600,4),(91,636516000,5),(91,656478000,4),(91,667965600,2),(91,687931200,4),(91,699415200,5),(91,719377200,4),(91,731469600,5),(91,938919600,3),(91,952052400,5),(91,1086058800,2),(91,1087704000,5),(91,1198983600,4),(91,1205632800,5),(91,2147483647,5),(92,-2147483648,0),(92,-1846269040,1),(92,-71092800,2),(92,2147483647,2),(93,-2147483648,1),(93,-1946918424,2),(94,-2147483648,3),(94,-1633276800,1),(94,-1615136400,2),(94,-1601827200,1),(94,-1583686800,2),(94,-1563724800,1),(94,-1551632400,2),(94,-1538928000,1),(94,-1520182800,2),(94,-1504454400,1),(94,-1491757200,2),(94,-1473004800,1),(94,-1459702800,2),(94,-1441555200,1),(94,-1428253200,2),(94,-1410105600,1),(94,-1396803600,2),(94,-1378656000,1),(94,-1365354000,2),(94,-1347206400,1),(94,-1333904400,2),(94,-1315152000,1),(94,-1301850000,2),(94,-1283702400,1),(94,-1270400400,2),(94,-1252252800,1),(94,-1238950800,2),(94,-1220803200,1),(94,-1207501200,2),(94,-1189353600,1),(94,-1176051600,2),(94,-1157299200,1),(94,-1144602000,2),(94,-1125849600,1),(94,-1112547600,2),(94,-1094400000,1),(94,-1081098000,2),(94,-1067788800,4),(94,-1045414800,2),(94,-1031500800,1),(94,-1018198800,2),(94,-1000051200,1),(94,-986749200,2),(94,-967996800,1),(94,-955299600,2),(94,-936547200,1),(94,-923245200,2),(94,-905097600,1),(94,-891795600,2),(94,-880214400,5),(94,-769395600,6),(94,-765392400,2),(94,-747244800,1),(94,-733942800,2),(94,-715795200,1),(94,-702493200,2),(94,-684345600,1),(94,-671043600,2),(94,-652896000,1),(94,-639594000,2),(94,-620841600,1),(94,-608144400,2),(94,-589392000,1),(94,-576090000,2),(94,-557942400,1),(94,-544640400,2),(94,-526492800,1),(94,-513190800,2),(94,-495043200,1),(94,-481741200,2),(94,-463593600,1),(94,-447267600,2),(94,-431539200,1),(94,-415818000,2),(94,-400089600,1),(94,-384368400,2),(94,-368640000,1),(94,-352918800,2),(94,-337190400,1),(94,-321469200,2),(94,-305740800,1),(94,-289414800,2),(94,-273686400,1),(94,-257965200,2),(94,-242236800,1),(94,-226515600,2),(94,-210787200,1),(94,-195066000,2),(94,-179337600,1),(94,-163616400,2),(94,-147888000,1),(94,-131562000,2),(94,-116438400,1),(94,-100112400,2),(94,-84384000,1),(94,-68662800,2),(94,-52934400,1),(94,-37213200,2),(94,-21484800,1),(94,-5763600,2),(94,9964800,1),(94,25686000,2),(94,41414400,1),(94,57740400,2),(94,73468800,1),(94,89190000,2),(94,104918400,1),(94,120639600,2),(94,126691200,1),(94,152089200,2),(94,162374400,1),(94,183538800,2),(94,199267200,1),(94,215593200,2),(94,230716800,1),(94,247042800,2),(94,262771200,1),(94,278492400,2),(94,294220800,1),(94,309942000,2),(94,325670400,1),(94,341391600,2),(94,357120000,1),(94,372841200,2),(94,388569600,1),(94,404895600,2),(94,420019200,1),(94,436345200,2),(94,452073600,1),(94,467794800,2),(94,483523200,1),(94,499244400,2),(94,514972800,1),(94,530694000,2),(94,544608000,1),(94,562143600,2),(94,576057600,1),(94,594198000,2),(94,607507200,1),(94,625647600,2),(94,638956800,1),(94,657097200,2),(94,671011200,1),(94,688546800,2),(94,702460800,1),(94,719996400,2),(94,733910400,1),(94,752050800,2),(94,765360000,1),(94,783500400,2),(94,796809600,1),(94,814950000,2),(94,828864000,1),(94,846399600,2),(94,860313600,1),(94,877849200,2),(94,891763200,1),(94,909298800,2),(94,923212800,1),(94,941353200,2),(94,954662400,1),(94,972802800,2),(94,986112000,1),(94,1004252400,2),(94,1018166400,1),(94,1035702000,2),(94,1049616000,1),(94,1067151600,2),(94,1081065600,1),(94,1099206000,2),(94,1112515200,1),(94,1130655600,2),(94,1143964800,1),(94,1162105200,2),(94,1173600000,1),(94,1194159600,2),(94,1205049600,1),(94,1225609200,2),(94,1236499200,1),(94,1257058800,2),(94,1268553600,1),(94,1289113200,2),(94,1300003200,1),(94,1320562800,2),(94,1331452800,1),(94,1352012400,2),(94,1362902400,1),(94,1383462000,2),(94,1394352000,1),(94,1414911600,2),(94,1425801600,1),(94,1446361200,2),(94,1457856000,1),(94,1478415600,2),(94,1489305600,1),(94,1509865200,2),(94,1520755200,1),(94,1541314800,2),(94,1552204800,1),(94,1572764400,2),(94,1583654400,1),(94,1604214000,2),(94,1615708800,1),(94,1636268400,2),(94,1647158400,1),(94,1667718000,2),(94,1678608000,1),(94,1699167600,2),(94,1710057600,1),(94,1730617200,2),(94,1741507200,1),(94,1762066800,2),(94,1772956800,1),(94,1793516400,2),(94,1805011200,1),(94,1825570800,2),(94,1836460800,1),(94,1857020400,2),(94,1867910400,1),(94,1888470000,2),(94,1899360000,1),(94,1919919600,2),(94,1930809600,1),(94,1951369200,2),(94,1962864000,1),(94,1983423600,2),(94,1994313600,1),(94,2014873200,2),(94,2025763200,1),(94,2046322800,2),(94,2057212800,1),(94,2077772400,2),(94,2088662400,1),(94,2109222000,2),(94,2120112000,1),(94,2140671600,2),(95,-2147483648,0),(95,-1514739600,1),(95,-1343066400,2),(95,-1234807200,4),(95,-1220292000,3),(95,-1207159200,4),(95,-1191344400,2),(95,828864000,5),(95,846399600,2),(95,860313600,5),(95,877849200,2),(95,891766800,3),(95,909302400,4),(95,923216400,3),(95,941356800,4),(95,954666000,3),(95,972806400,4),(95,989139600,3),(95,1001836800,4),(95,1018170000,3),(95,1035705600,4),(95,1049619600,3),(95,1067155200,4),(95,1081069200,3),(95,1099209600,4),(95,1112518800,3),(95,1130659200,4),(95,1143968400,3),(95,1162108800,4),(95,1175418000,3),(95,1193558400,4),(95,1207472400,3),(95,1225008000,4),(95,1238922000,3),(95,1256457600,4),(95,1270371600,3),(95,1288512000,4),(95,1301821200,3),(95,1319961600,4),(95,1333270800,3),(95,1351411200,4),(95,1365325200,3),(95,1382860800,4),(95,1396774800,3),(95,1414310400,4),(95,1428224400,3),(95,1445760000,4),(95,1459674000,3),(95,1477814400,4),(95,1491123600,3),(95,1509264000,4),(95,1522573200,3),(95,1540713600,4),(95,1554627600,3),(95,1572163200,4),(95,1586077200,3),(95,1603612800,4),(95,1617526800,3),(95,1635667200,4),(95,1648976400,3),(95,1667116800,2),(96,-2147483648,0),(96,-1514739600,1),(96,-1343066400,2),(96,-1234807200,4),(96,-1220292000,3),(96,-1207159200,4),(96,-1191344400,2),(96,828864000,5),(96,846399600,2),(96,860313600,5),(96,877849200,2),(96,891766800,3),(96,909302400,4),(96,923216400,3),(96,941356800,4),(96,954666000,3),(96,972806400,4),(96,989139600,3),(96,1001836800,4),(96,1018170000,3),(96,1035705600,4),(96,1049619600,3),(96,1067155200,4),(96,1081069200,3),(96,1099209600,4),(96,1112518800,3),(96,1130659200,4),(96,1143968400,3),(96,1162108800,4),(96,1175418000,3),(96,1193558400,4),(96,1207472400,3),(96,1225008000,4),(96,1238922000,3),(96,1256457600,4),(96,1268557200,3),(96,1289116800,4),(96,1300006800,3),(96,1320566400,4),(96,1331456400,3),(96,1352016000,4),(96,1362906000,3),(96,1383465600,4),(96,1394355600,3),(96,1414915200,4),(96,1425805200,3),(96,1446364800,4),(96,1457859600,3),(96,1478419200,4),(96,1489309200,3),(96,1509868800,4),(96,1520758800,3),(96,1541318400,4),(96,1552208400,3),(96,1572768000,4),(96,1583658000,3),(96,1604217600,4),(96,1615712400,3),(96,1636272000,4),(96,1647162000,3),(96,1667116800,2),(96,1669788000,4),(96,1678611600,3),(96,1699171200,4),(96,1710061200,3),(96,1730620800,4),(96,1741510800,3),(96,1762070400,4),(96,1772960400,3),(96,1793520000,4),(96,1805014800,3),(96,1825574400,4),(96,1836464400,3),(96,1857024000,4),(96,1867914000,3),(96,1888473600,4),(96,1899363600,3),(96,1919923200,4),(96,1930813200,3),(96,1951372800,4),(96,1962867600,3),(96,1983427200,4),(96,1994317200,3),(96,2014876800,4),(96,2025766800,3),(96,2046326400,4),(96,2057216400,3),(96,2077776000,4),(96,2088666000,3),(96,2109225600,4),(96,2120115600,3),(96,2140675200,4),(97,-2147483648,1),(97,-1946918424,2),(98,-2147483648,1),(98,-1567453392,2),(98,-1233432000,3),(98,-1222981200,2),(98,-1205956800,3),(98,-1194037200,2),(98,-1172865600,3),(98,-1162501200,2),(98,-1141329600,3),(98,-1130965200,2),(98,-1109793600,3),(98,-1099429200,2),(98,-1078257600,3),(98,-1067806800,2),(98,-1046635200,3),(98,-1036270800,2),(98,-1015099200,3),(98,-1004734800,2),(98,-983563200,3),(98,-973198800,2),(98,-952027200,3),(98,-941576400,2),(98,-931032000,3),(98,-900882000,2),(98,-890337600,3),(98,-833749200,2),(98,-827265600,3),(98,-752274000,2),(98,-733780800,3),(98,-197326800,2),(98,-190843200,3),(98,-184194000,2),(98,-164491200,3),(98,-152658000,2),(98,-132955200,3),(98,-121122000,2),(98,-101419200,3),(98,-86821200,2),(98,-71092800,3),(98,-54766800,2),(98,-39038400,3),(98,-23317200,2),(98,-7588800,5),(98,128142000,4),(98,136605600,5),(98,596948400,4),(98,605066400,5),(98,624423600,4),(98,636516000,5),(98,656478000,4),(98,667965600,2),(98,687931200,4),(98,699415200,5),(98,719377200,4),(98,731469600,5),(98,938919600,3),(98,952052400,5),(98,1198983600,4),(98,1205632800,5),(98,1224385200,4),(98,1237082400,5),(98,2147483647,5),(99,-2147483648,1),(99,-1545071027,3),(99,288770400,2),(99,297234000,3),(99,320220000,2),(99,328683600,3),(99,664264800,2),(99,678344400,3),(99,695714400,2),(99,700635600,3),(100,-2147483648,4),(100,-1633273200,1),(100,-1615132800,2),(100,-1601823600,1),(100,-1583683200,2),(100,-880210800,3),(100,-820519140,2),(100,-812653140,3),(100,-796845540,2),(100,-84380400,1),(100,-68659200,2),(101,-2147483648,0),(101,-1767212140,2),(101,-1206954000,1),(101,-1191358800,2),(101,-1175371200,1),(101,-1159822800,2),(101,-633816000,1),(101,-622065600,2),(101,-602280000,1),(101,-591829200,2),(101,-570744000,1),(101,-560206800,2),(101,-539121600,1),(101,-531349200,2),(101,-191361600,1),(101,-184194000,2),(101,-155160000,1),(101,-150066000,2),(101,-128894400,1),(101,-121122000,2),(101,-99950400,1),(101,-89586000,2),(101,-68414400,1),(101,-57963600,2),(101,499752000,1),(101,511239600,2),(101,530596800,1),(101,540270000,2),(101,562132800,1),(101,571201200,2),(101,592977600,1),(101,602046000,2),(101,624427200,1),(101,634705200,2),(101,656481600,1),(101,666759600,2),(101,687931200,1),(101,697604400,2),(101,719985600,1),(101,728449200,2),(101,750830400,1),(101,761713200,2),(101,782280000,1),(101,793162800,2),(101,813729600,1),(101,824007600,2),(101,844574400,1),(101,856062000,2),(101,876110400,1),(101,888721200,2),(101,908078400,1),(101,919566000,2),(101,938923200,1),(101,951620400,2),(101,970977600,1),(101,982465200,2),(101,1003032000,1),(101,1013914800,2),(101,1036296000,1),(101,1045364400,2),(101,1099368000,1),(101,1108868400,2),(101,1129435200,1),(101,1140318000,2),(101,1162699200,1),(101,1172372400,2),(101,1192334400,1),(101,1203217200,2),(101,1224388800,1),(101,1234666800,2),(101,1255838400,1),(101,1266721200,2),(101,1287288000,1),(101,1298170800,2),(101,1318737600,1),(101,1330225200,2),(101,1350792000,1),(101,1361070000,2),(101,1382241600,1),(101,1392519600,2),(101,1413691200,1),(101,1424574000,2),(101,1445140800,1),(101,1456023600,2),(101,1476590400,1),(101,1487473200,2),(101,1508040000,1),(101,1518922800,2),(101,1541304000,1),(101,1550372400,2),(101,2147483647,2),(102,-2147483648,1),(102,-873057600,3),(102,-769395600,2),(102,-765399600,1),(103,-2147483648,0),(103,-1686091520,1),(103,323845200,4),(103,338950800,2),(103,354675600,3),(103,370400400,2),(103,386125200,3),(103,401850000,2),(103,417574800,3),(103,433299600,2),(103,449024400,3),(103,465354000,2),(103,481078800,3),(103,496803600,2),(103,512528400,3),(103,528253200,2),(103,543978000,3),(103,559702800,2),(103,575427600,3),(103,591152400,2),(103,606877200,3),(103,622602000,2),(103,638326800,3),(103,654656400,2),(103,670381200,3),(103,686106000,2),(103,701830800,3),(103,717555600,2),(103,733280400,3),(103,749005200,2),(103,764730000,3),(103,780454800,2),(103,796179600,3),(103,811904400,2),(103,820465200,5),(104,-2147483648,2),(104,-1632056400,1),(104,-1615125600,2),(104,-1596978000,1),(104,-1583164800,2),(104,-880203600,3),(104,-769395600,4),(104,-765381600,2),(104,-147884400,5),(104,-131554800,2),(104,120646800,6),(104,325677600,7),(104,341398800,6),(104,357127200,7),(104,372848400,6),(104,388576800,7),(104,404902800,6),(104,420026400,7),(104,436352400,6),(104,452080800,7),(104,467802000,6),(104,483530400,7),(104,499251600,6),(104,514980000,7),(104,530701200,6),(104,544615200,7),(104,562150800,6),(104,576064800,7),(104,594205200,6),(104,607514400,7),(104,625654800,6),(104,638964000,7),(104,657104400,6),(104,671018400,7),(104,688554000,6),(104,702468000,7),(104,720003600,6),(104,733917600,7),(104,752058000,6),(104,765367200,7),(104,783507600,6),(104,796816800,7),(104,814957200,6),(104,828871200,7),(104,846406800,6),(104,860320800,7),(104,877856400,6),(104,891770400,7),(104,909306000,6),(104,923220000,7),(104,941360400,6),(104,954669600,7),(104,972810000,6),(104,986119200,7),(104,1004259600,6),(104,1018173600,7),(104,1035709200,6),(104,1049623200,7),(104,1067158800,6),(104,1081072800,7),(104,1099213200,6),(104,1112522400,7),(104,1130662800,6),(104,1143972000,7),(104,1162112400,6),(104,1173607200,7),(104,1194166800,6),(104,1205056800,7),(104,1225616400,6),(104,1236506400,7),(104,1257066000,6),(104,1268560800,7),(104,1289120400,6),(104,1300010400,7),(104,1320570000,6),(104,1331460000,7),(104,1352019600,6),(104,1362909600,7),(104,1383469200,6),(104,1394359200,7),(104,1414918800,6),(104,1425808800,7),(104,1446368400,6),(104,1457863200,7),(104,1478422800,6),(104,1489312800,7),(104,1509872400,6),(104,1520762400,7),(104,1541322000,6),(104,1552212000,7),(104,1572771600,6),(104,1583661600,7),(104,1604214000,8),(105,-2147483648,2),(105,-1632060000,1),(105,-1615129200,2),(105,-880207200,3),(105,-769395600,4),(105,-765385200,2),(105,-715788000,1),(105,-702486000,2),(105,-684338400,1),(105,-671036400,2),(105,-652888800,1),(105,-639586800,2),(105,-620834400,1),(105,-608137200,2),(105,-589384800,1),(105,-576082800,2),(105,-557935200,1),(105,-544633200,2),(105,-526485600,1),(105,-513183600,2),(105,-495036000,1),(105,-481734000,2),(105,-463586400,1),(105,-450284400,2),(105,-431532000,1),(105,-418230000,2),(105,-400082400,1),(105,-386780400,2),(105,-368632800,1),(105,-355330800,2),(105,-337183200,1),(105,-323881200,2),(105,-305733600,1),(105,-292431600,2),(105,-273679200,1),(105,-260982000,2),(105,-242229600,1),(105,-226508400,2),(105,-210780000,1),(105,-195058800,2),(105,-179330400,1),(105,-163609200,2),(105,-147880800,1),(105,-131554800,2),(105,-116431200,1),(105,-100105200,2),(105,-84376800,1),(105,-68655600,2),(105,-52927200,1),(105,-37206000,2),(105,-21477600,1),(105,-5756400,2),(105,9972000,1),(105,25693200,2),(105,41421600,1),(105,57747600,2),(105,73476000,1),(105,84013200,5),(106,-2147483648,3),(106,-1633273200,1),(106,-1615132800,2),(106,-1601823600,1),(106,-1583683200,2),(106,-1570374000,1),(106,-1551628800,2),(106,-1538924400,1),(106,-1534089600,2),(106,-880210800,4),(106,-769395600,5),(106,-765388800,2),(106,-147884400,1),(106,-131558400,2),(106,-116434800,1),(106,-100108800,2),(106,-84380400,1),(106,-68659200,2),(106,-52930800,1),(106,-37209600,2),(106,-21481200,1),(106,-5760000,2),(106,9968400,1),(106,25689600,2),(106,41418000,1),(106,57744000,2),(106,73472400,1),(106,89193600,2),(106,104922000,1),(106,120643200,2),(106,126694800,1),(106,152092800,2),(106,162378000,1),(106,183542400,2),(106,199270800,1),(106,215596800,2),(106,230720400,1),(106,247046400,2),(106,262774800,1),(106,278496000,2),(106,294224400,1),(106,309945600,2),(106,325674000,1),(106,341395200,2),(106,357123600,1),(106,372844800,2),(106,388573200,1),(106,404899200,2),(106,420022800,1),(106,436348800,2),(106,452077200,1),(106,467798400,2),(106,483526800,1),(106,499248000,2),(106,514976400,1),(106,530697600,2),(106,544611600,1),(106,562147200,2),(106,576061200,1),(106,594201600,2),(106,607510800,1),(106,625651200,2),(106,638960400,1),(106,657100800,2),(106,671014800,1),(106,688550400,2),(106,702464400,1),(106,720000000,2),(106,733914000,1),(106,752054400,2),(106,765363600,1),(106,783504000,2),(106,796813200,1),(106,814953600,2),(106,828867600,1),(106,846403200,2),(106,860317200,1),(106,877852800,2),(106,891766800,1),(106,909302400,2),(106,923216400,1),(106,941356800,2),(106,954666000,1),(106,972806400,2),(106,986115600,1),(106,1004256000,2),(106,1018170000,1),(106,1035705600,2),(106,1049619600,1),(106,1067155200,2),(106,1081069200,1),(106,1099209600,2),(106,1112518800,1),(106,1130659200,2),(106,1143968400,1),(106,1162108800,2),(106,1173603600,1),(106,1194163200,2),(106,1205053200,1),(106,1225612800,2),(106,1236502800,1),(106,1257062400,2),(106,1268557200,1),(106,1289116800,2),(106,1300006800,1),(106,1320566400,2),(106,1331456400,1),(106,1352016000,2),(106,1362906000,1),(106,1383465600,2),(106,1394355600,1),(106,1414915200,2),(106,1425805200,1),(106,1446364800,2),(106,1457859600,1),(106,1478419200,2),(106,1489309200,1),(106,1509868800,2),(106,1520758800,1),(106,1541318400,2),(106,1552208400,1),(106,1572768000,2),(106,1583658000,1),(106,1604217600,2),(106,1615712400,1),(106,1636272000,2),(106,1647162000,1),(106,1667721600,2),(106,1678611600,1),(106,1699171200,2),(106,1710061200,1),(106,1730620800,2),(106,1741510800,1),(106,1762070400,2),(106,1772960400,1),(106,1793520000,2),(106,1805014800,1),(106,1825574400,2),(106,1836464400,1),(106,1857024000,2),(106,1867914000,1),(106,1888473600,2),(106,1899363600,1),(106,1919923200,2),(106,1930813200,1),(106,1951372800,2),(106,1962867600,1),(106,1983427200,2),(106,1994317200,1),(106,2014876800,2),(106,2025766800,1),(106,2046326400,2),(106,2057216400,1),(106,2077776000,2),(106,2088666000,1),(106,2109225600,2),(106,2120115600,1),(106,2140675200,2),(107,-2147483648,0),(107,-2051202469,1),(107,-1724083200,2),(107,-880218000,3),(107,-769395600,4),(107,-765396000,2),(107,-684349200,5),(107,-671047200,2),(107,-80506740,5),(107,-68666400,2),(107,-52938000,5),(107,-37216800,2),(107,104914800,5),(107,120636000,2),(107,126687600,5),(107,152085600,2),(107,167814000,5),(107,183535200,2),(107,199263600,5),(107,215589600,2),(107,230713200,5),(107,247039200,2),(107,262767600,5),(107,278488800,2),(107,294217200,5),(107,309938400,2),(107,325666800,5),(107,341388000,2),(107,357116400,5),(107,372837600,2),(107,388566000,5),(107,404892000,2),(107,420015600,5),(107,436341600,2),(107,452070000,5),(107,467791200,2),(107,483519600,5),(107,499240800,2),(107,514969200,5),(107,530690400,2),(107,544604400,5),(107,562140000,2),(107,576054000,5),(107,594194400,2),(107,607503600,5),(107,625644000,2),(107,638953200,5),(107,657093600,2),(107,671007600,5),(107,688543200,2),(107,702457200,5),(107,719992800,2),(107,733906800,5),(107,752047200,2),(107,765356400,5),(107,783496800,2),(107,796806000,5),(107,814946400,2),(107,828860400,5),(107,846396000,2),(107,860310000,5),(107,877845600,2),(107,891759600,5),(107,909295200,2),(107,923209200,5),(107,941349600,2),(107,954658800,5),(107,972799200,2),(107,986108400,5),(107,1004248800,2),(107,1018162800,5),(107,1035698400,2),(107,1049612400,5),(107,1067148000,2),(107,1081062000,5),(107,1099202400,2),(107,1112511600,5),(107,1130652000,2),(107,1143961200,5),(107,1162101600,2),(107,1173596400,5),(107,1194156000,2),(107,1205046000,5),(107,1225605600,2),(107,1236495600,5),(107,1257055200,2),(107,1268550000,5),(107,1289109600,2),(107,1299999600,5),(107,1320559200,2),(107,1331449200,5),(107,1352008800,2),(107,1362898800,5),(107,1383458400,2),(107,1394348400,5),(107,1414908000,2),(107,1425798000,5),(107,1446357600,2),(107,1457852400,5),(107,1478412000,2),(107,1489302000,5),(107,1509861600,2),(107,1520751600,5),(107,1541311200,2),(107,1552201200,5),(107,1572760800,2),(107,1583650800,5),(107,1604210400,2),(107,1615705200,5),(107,1636264800,2),(107,1647154800,5),(107,1667714400,2),(107,1678604400,5),(107,1699164000,2),(107,1710054000,5),(107,1730613600,2),(107,1741503600,5),(107,1762063200,2),(107,1772953200,5),(107,1793512800,2),(107,1805007600,5),(107,1825567200,2),(107,1836457200,5),(107,1857016800,2),(107,1867906800,5),(107,1888466400,2),(107,1899356400,5),(107,1919916000,2),(107,1930806000,5),(107,1951365600,2),(107,1962860400,5),(107,1983420000,2),(107,1994310000,5),(107,2014869600,2),(107,2025759600,5),(107,2046319200,2),(107,2057209200,5),(107,2077768800,2),(107,2088658800,5),(107,2109218400,2),(107,2120108400,5),(107,2140668000,2),(108,-2147483648,1),(108,-873057600,3),(108,-769395600,2),(108,-765399600,1),(109,-2147483648,0),(109,-1998663968,2),(109,-1632063600,1),(109,-1615132800,2),(109,-1600614000,1),(109,-1596816000,2),(109,-1567954800,1),(109,-1551628800,2),(109,-1536505200,1),(109,-1523203200,2),(109,-1504450800,1),(109,-1491753600,2),(109,-1473001200,1),(109,-1459699200,2),(109,-880210800,3),(109,-769395600,4),(109,-765388800,2),(109,-715791600,1),(109,-702489600,2),(109,73472400,1),(109,89193600,2),(109,104922000,1),(109,120643200,2),(109,136371600,1),(109,152092800,2),(109,167821200,1),(109,183542400,2),(109,199270800,1),(109,215596800,2),(109,230720400,1),(109,247046400,2),(109,262774800,1),(109,278496000,2),(109,294224400,1),(109,309945600,2),(109,325674000,1),(109,341395200,2),(109,357123600,1),(109,372844800,2),(109,388573200,1),(109,404899200,2),(109,420022800,1),(109,436348800,2),(109,452077200,1),(109,467798400,2),(109,483526800,1),(109,499248000,2),(109,514976400,1),(109,530697600,2),(109,544611600,1),(109,562147200,2),(109,576061200,1),(109,594201600,2),(109,607510800,1),(109,625651200,2),(109,638960400,1),(109,657100800,2),(109,671014800,1),(109,688550400,2),(109,702464400,1),(109,720000000,2),(109,733914000,1),(109,752054400,2),(109,765363600,1),(109,783504000,2),(109,796813200,1),(109,814953600,2),(109,828867600,1),(109,846403200,2),(109,860317200,1),(109,877852800,2),(109,891766800,1),(109,909302400,2),(109,923216400,1),(109,941356800,2),(109,954666000,1),(109,972806400,2),(109,986115600,1),(109,1004256000,2),(109,1018170000,1),(109,1035705600,2),(109,1049619600,1),(109,1067155200,2),(109,1081069200,1),(109,1099209600,2),(109,1112518800,1),(109,1130659200,2),(109,1143968400,1),(109,1162108800,2),(109,1173603600,1),(109,1194163200,2),(109,1205053200,1),(109,1225612800,2),(109,1236502800,1),(109,1257062400,2),(109,1268557200,1),(109,1289116800,2),(109,1300006800,1),(109,1320566400,2),(109,1331456400,1),(109,1352016000,2),(109,1362906000,1),(109,1383465600,2),(109,1394355600,1),(109,1414915200,2),(109,1425805200,1),(109,1446364800,2),(109,1457859600,1),(109,1478419200,2),(109,1489309200,1),(109,1509868800,2),(109,1520758800,1),(109,1541318400,2),(109,1552208400,1),(109,1572768000,2),(109,1583658000,1),(109,1604217600,2),(109,1615712400,1),(109,1636272000,2),(109,1647162000,1),(109,1667721600,2),(109,1678611600,1),(109,1699171200,2),(109,1710061200,1),(109,1730620800,2),(109,1741510800,1),(109,1762070400,2),(109,1772960400,1),(109,1793520000,2),(109,1805014800,1),(109,1825574400,2),(109,1836464400,1),(109,1857024000,2),(109,1867914000,1),(109,1888473600,2),(109,1899363600,1),(109,1919923200,2),(109,1930813200,1),(109,1951372800,2),(109,1962867600,1),(109,1983427200,2),(109,1994317200,1),(109,2014876800,2),(109,2025766800,1),(109,2046326400,2),(109,2057216400,1),(109,2077776000,2),(109,2088666000,1),(109,2109225600,2),(109,2120115600,1),(109,2140675200,2),(110,-2147483648,0),(110,-1767208832,2),(110,-1206950400,1),(110,-1191355200,2),(110,-1175367600,1),(110,-1159819200,2),(110,-633812400,1),(110,-622062000,2),(110,-602276400,1),(110,-591825600,2),(110,-570740400,1),(110,-560203200,2),(110,-539118000,1),(110,-531345600,2),(110,-191358000,1),(110,-184190400,2),(110,-155156400,1),(110,-150062400,2),(110,-128890800,1),(110,-121118400,2),(110,-99946800,1),(110,-89582400,2),(110,-68410800,1),(110,-57960000,2),(110,499755600,1),(110,511243200,2),(110,530600400,1),(110,540273600,2),(110,562136400,1),(110,571204800,2),(110,750834000,1),(110,761716800,2),(110,1214283600,3),(110,1384056000,2),(110,2147483647,2),(111,-2147483648,0),(111,-1546279392,2),(111,547020000,1),(111,559717200,2),(111,578469600,1),(111,591166800,2),(112,-2147483648,0),(112,-1514739600,1),(112,-1451667600,2),(112,-1343062800,3),(112,-1234803600,2),(112,-1222963200,4),(112,-1207242000,2),(112,-873820800,5),(112,-769395600,6),(112,-761677200,2),(112,-686073600,4),(112,-661539600,2),(112,-495039600,4),(112,-481734000,2),(112,-463590000,4),(112,-450284400,2),(112,-431535600,4),(112,-418230000,2),(112,-400086000,4),(112,-386780400,2),(112,-368636400,4),(112,-355330800,2),(112,-337186800,4),(112,-323881200,2),(112,-305737200,4),(112,-292431600,2),(112,199274400,4),(112,215600400,2),(112,230724000,4),(112,247050000,2),(112,262778400,4),(112,278499600,2),(112,294228000,4),(112,309949200,2),(112,325677600,4),(112,341398800,2),(112,357127200,4),(112,372848400,2),(112,388576800,4),(112,404902800,2),(112,420026400,4),(112,436352400,2),(112,452080800,4),(112,467802000,2),(112,483530400,4),(112,499251600,2),(112,514980000,4),(112,530701200,2),(112,544615200,4),(112,562150800,2),(112,576064800,4),(112,594205200,2),(112,607514400,4),(112,625654800,2),(112,638964000,4),(112,657104400,2),(112,671018400,4),(112,688554000,2),(112,702468000,4),(112,720003600,2),(112,733917600,4),(112,752058000,2),(112,765367200,4),(112,783507600,2),(112,796816800,4),(112,814957200,2),(112,828871200,4),(112,846406800,2),(112,860320800,4),(112,877856400,2),(112,891770400,4),(112,909306000,2),(112,923220000,4),(112,941360400,2),(112,954669600,4),(112,972810000,2),(112,986119200,4),(112,1004259600,2),(112,1018173600,4),(112,1035709200,2),(112,1049623200,4),(112,1067158800,2),(112,1081072800,4),(112,1099213200,2),(112,1112522400,4),(112,1130662800,2),(112,1143972000,4),(112,1162112400,2),(112,1175421600,4),(112,1193562000,2),(112,1207476000,4),(112,1225011600,2),(112,1238925600,4),(112,1256461200,2),(112,1268560800,4),(112,1289120400,2),(112,1300010400,4),(112,1320570000,2),(112,1331460000,4),(112,1352019600,2),(112,1362909600,4),(112,1383469200,2),(112,1394359200,4),(112,1414918800,2),(112,1425808800,4),(112,1446368400,2),(112,1457863200,4),(112,1478422800,2),(112,1489312800,4),(112,1509872400,2),(112,1520762400,4),(112,1541322000,2),(112,1552212000,4),(112,1572771600,2),(112,1583661600,4),(112,1604221200,2),(112,1615716000,4),(112,1636275600,2),(112,1647165600,4),(112,1667725200,2),(112,1678615200,4),(112,1699174800,2),(112,1710064800,4),(112,1730624400,2),(112,1741514400,4),(112,1762074000,2),(112,1772964000,4),(112,1793523600,2),(112,1805018400,4),(112,1825578000,2),(112,1836468000,4),(112,1857027600,2),(112,1867917600,4),(112,1888477200,2),(112,1899367200,4),(112,1919926800,2),(112,1930816800,4),(112,1951376400,2),(112,1962871200,4),(112,1983430800,2),(112,1994320800,4),(112,2014880400,2),(112,2025770400,4),(112,2046330000,2),(112,2057220000,4),(112,2077779600,2),(112,2088669600,4),(112,2109229200,2),(112,2120119200,4),(112,2140678800,2),(113,-2147483648,2),(113,-1632060000,1),(113,-1615129200,2),(113,-880207200,3),(113,-769395600,4),(113,-765385200,2),(113,-715788000,1),(113,-702486000,2),(113,-684338400,1),(113,-671036400,2),(113,-652888800,1),(113,-639586800,2),(113,-620834400,1),(113,-608137200,2),(113,-589384800,1),(113,-576082800,2),(113,-557935200,1),(113,-544633200,2),(113,-526485600,1),(113,-513183600,2),(113,-495036000,1),(113,-481734000,2),(113,-463586400,1),(113,-450284400,2),(113,-431532000,1),(113,-418230000,2),(113,-400082400,1),(113,-386780400,2),(113,-368632800,1),(113,-355330800,2),(113,-337183200,1),(113,-323881200,2),(113,-305733600,1),(113,-292431600,2),(113,-273679200,1),(113,-260982000,2),(113,-242229600,1),(113,-226508400,2),(113,-210780000,1),(113,-195058800,2),(113,-179330400,1),(113,-163609200,2),(113,-147880800,1),(113,-131554800,2),(113,-116431200,1),(113,-100105200,2),(113,-84376800,1),(113,-68655600,2),(113,-52927200,1),(113,-37206000,2),(113,-21477600,1),(113,-5756400,2),(113,9972000,1),(113,25693200,2),(113,41421600,1),(113,57747600,2),(113,73476000,1),(113,89197200,2),(113,104925600,1),(113,120646800,2),(113,136375200,1),(113,152096400,2),(113,167824800,1),(113,183546000,2),(113,199274400,1),(113,215600400,2),(113,230724000,1),(113,247050000,2),(113,262778400,1),(113,278499600,2),(113,294228000,1),(113,309949200,2),(113,325677600,1),(113,341398800,2),(113,357127200,1),(113,372848400,2),(113,388576800,1),(113,404902800,2),(113,420026400,1),(113,436352400,2),(113,452080800,1),(113,467802000,2),(113,483530400,1),(113,499251600,2),(113,514980000,1),(113,530701200,2),(113,544615200,1),(113,562150800,2),(113,576064800,1),(113,594205200,2),(113,607514400,1),(113,625654800,2),(113,638964000,1),(113,657104400,2),(113,671018400,1),(113,688554000,2),(113,702468000,1),(113,720003600,2),(113,733917600,1),(113,752058000,2),(113,765367200,1),(113,783507600,2),(113,796816800,1),(113,814957200,2),(113,828871200,1),(113,846406800,2),(113,860320800,1),(113,877856400,2),(113,891770400,1),(113,909306000,2),(113,923220000,1),(113,941360400,2),(113,954669600,1),(113,972810000,2),(113,986119200,1),(113,1004259600,2),(113,1018173600,1),(113,1035709200,2),(113,1049623200,1),(113,1067158800,2),(113,1081072800,1),(113,1099213200,2),(113,1112522400,1),(113,1130662800,2),(113,1143972000,1),(113,1162112400,2),(113,1173607200,1),(113,1194166800,2),(113,1205056800,1),(113,1225616400,2),(113,1236506400,1),(113,1257066000,2),(113,1268560800,1),(113,1289120400,2),(113,1300010400,1),(113,1320570000,2),(113,1331460000,1),(113,1352019600,2),(113,1362909600,1),(113,1383469200,2),(113,1394359200,1),(113,1414918800,2),(113,1425808800,5),(114,-2147483648,3),(114,-1633276800,1),(114,-1615136400,2),(114,-1601827200,1),(114,-1583686800,2),(114,-900259200,1),(114,-891795600,2),(114,-880214400,4),(114,-769395600,5),(114,-765392400,2),(114,-747244800,1),(114,-733942800,2),(114,-715795200,1),(114,-702493200,2),(114,-684345600,1),(114,-671043600,2),(114,-652896000,1),(114,-639594000,2),(114,-620841600,1),(114,-608144400,2),(114,-589392000,1),(114,-576090000,2),(114,-557942400,1),(114,-544640400,2),(114,-526492800,1),(114,-513190800,2),(114,-495043200,1),(114,-481741200,2),(114,-463593600,6),(114,-386787600,2),(114,-368640000,6),(114,-21488400,7),(114,-5767200,6),(114,9961200,7),(114,25682400,6),(114,1143961200,7),(114,1162101600,6),(114,1173596400,7),(114,1194156000,6),(114,1205046000,7),(114,1225605600,6),(114,1236495600,7),(114,1257055200,6),(114,1268550000,7),(114,1289109600,6),(114,1299999600,7),(114,1320559200,6),(114,1331449200,7),(114,1352008800,6),(114,1362898800,7),(114,1383458400,6),(114,1394348400,7),(114,1414908000,6),(114,1425798000,7),(114,1446357600,6),(114,1457852400,7),(114,1478412000,6),(114,1489302000,7),(114,1509861600,6),(114,1520751600,7),(114,1541311200,6),(114,1552201200,7),(114,1572760800,6),(114,1583650800,7),(114,1604210400,6),(114,1615705200,7),(114,1636264800,6),(114,1647154800,7),(114,1667714400,6),(114,1678604400,7),(114,1699164000,6),(114,1710054000,7),(114,1730613600,6),(114,1741503600,7),(114,1762063200,6),(114,1772953200,7),(114,1793512800,6),(114,1805007600,7),(114,1825567200,6),(114,1836457200,7),(114,1857016800,6),(114,1867906800,7),(114,1888466400,6),(114,1899356400,7),(114,1919916000,6),(114,1930806000,7),(114,1951365600,6),(114,1962860400,7),(114,1983420000,6),(114,1994310000,7),(114,2014869600,6),(114,2025759600,7),(114,2046319200,6),(114,2057209200,7),(114,2077768800,6),(114,2088658800,7),(114,2109218400,6),(114,2120108400,7),(114,2140668000,6),(115,-2147483648,0),(115,-1767216360,2),(115,-1206957600,1),(115,-1191362400,2),(115,-1175374800,1),(115,-1159826400,2),(115,-633819600,1),(115,-622069200,2),(115,-602283600,1),(115,-591832800,2),(115,-570747600,1),(115,-560210400,2),(115,-539125200,1),(115,-531352800,2),(115,-191365200,1),(115,-184197600,2),(115,-155163600,1),(115,-150069600,2),(115,-128898000,1),(115,-121125600,2),(115,-99954000,1),(115,-89589600,2),(115,-68418000,1),(115,-57967200,2),(115,499748400,1),(115,511236000,2),(115,530593200,1),(115,540266400,2),(115,562129200,1),(115,571197600,2),(115,592974000,1),(115,602042400,2),(115,624423600,1),(115,634701600,2),(115,938919600,1),(115,951616800,2),(115,970974000,1),(115,972180000,2),(115,1003028400,1),(115,1013911200,2),(115,2147483647,2),(116,-2147483648,0),(116,-2131646412,2),(116,-1632074400,1),(116,-1615143600,2),(116,-880221600,3),(116,-769395600,4),(116,-765399600,2),(116,-526500000,1),(116,-513198000,2),(116,73461600,1),(116,89182800,2),(116,104911200,1),(116,120632400,2),(116,136360800,1),(116,152082000,2),(116,167810400,1),(116,183531600,2),(116,199260000,1),(116,215586000,2),(116,230709600,1),(116,247035600,2),(116,262764000,1),(116,278485200,2),(116,294213600,1),(116,309934800,2),(116,325663200,1),(116,341384400,2),(116,357112800,1),(116,372834000,2),(116,388562400,1),(116,404888400,2),(116,420012000,1),(116,436338000,2),(116,452066400,1),(116,467787600,2),(116,483516000,1),(116,499237200,2),(116,514965600,1),(116,530686800,2),(116,544600800,1),(116,562136400,2),(116,576050400,1),(116,594190800,2),(116,607500000,1),(116,625640400,2),(116,638949600,1),(116,657090000,2),(116,671004000,1),(116,688539600,2),(116,702453600,1),(116,719989200,2),(116,733903200,1),(116,752043600,2),(116,765352800,1),(116,783493200,2),(116,796802400,1),(116,814942800,2),(116,828856800,1),(116,846392400,2),(116,860306400,1),(116,877842000,2),(116,891756000,1),(116,909291600,2),(116,923205600,1),(116,941346000,2),(116,954655200,1),(116,972795600,2),(116,986104800,1),(116,1004245200,2),(116,1018159200,1),(116,1035694800,2),(116,1049608800,1),(116,1067144400,2),(116,1081058400,1),(116,1099198800,2),(116,1112508000,1),(116,1130648400,2),(116,1143957600,1),(116,1162098000,2),(116,1173592800,1),(116,1194152400,2),(116,1205042400,1),(116,1225602000,2),(116,1236492000,1),(116,1257051600,2),(116,1268546400,1),(116,1289106000,2),(116,1299996000,1),(116,1320555600,2),(116,1331445600,1),(116,1352005200,2),(116,1362895200,1),(116,1383454800,2),(116,1394344800,1),(116,1414904400,2),(116,1425794400,1),(116,1446354000,2),(116,1457848800,1),(116,1478408400,2),(116,1489298400,1),(116,1509858000,2),(116,1520748000,1),(116,1541307600,2),(116,1552197600,1),(116,1572757200,2),(116,1583647200,1),(116,1604206800,2),(116,1615701600,1),(116,1636261200,2),(116,1647151200,1),(116,1667710800,2),(116,1678600800,1),(116,1699160400,2),(116,1710050400,1),(116,1730610000,2),(116,1741500000,1),(116,1762059600,2),(116,1772949600,1),(116,1793509200,2),(116,1805004000,1),(116,1825563600,2),(116,1836453600,1),(116,1857013200,2),(116,1867903200,1),(116,1888462800,2),(116,1899352800,1),(116,1919912400,2),(116,1930802400,1),(116,1951362000,2),(116,1962856800,1),(116,1983416400,2),(116,1994306400,1),(116,2014866000,2),(116,2025756000,1),(116,2046315600,2),(116,2057205600,1),(116,2077765200,2),(116,2088655200,1),(116,2109214800,2),(116,2120104800,1),(116,2140664400,2),(117,-2147483648,0),(117,-1686083584,1),(117,323845200,4),(117,338950800,2),(117,354675600,3),(117,370400400,2),(117,386125200,3),(117,401850000,2),(117,417574800,3),(117,433299600,2),(117,449024400,3),(117,465354000,2),(117,481078800,3),(117,496803600,2),(117,512528400,3),(117,528253200,2),(117,543978000,3),(117,559702800,2),(117,575427600,3),(117,591152400,2),(117,606877200,3),(117,622602000,2),(117,638326800,3),(117,654656400,2),(117,670381200,3),(117,686106000,2),(117,701830800,3),(117,717555600,2),(117,733280400,3),(117,749005200,2),(117,764730000,3),(117,780454800,2),(117,796179600,3),(117,811904400,2),(117,828234000,3),(117,846378000,2),(117,859683600,3),(117,877827600,2),(117,891133200,3),(117,909277200,2),(117,922582800,3),(117,941331600,2),(117,954032400,3),(117,972781200,2),(117,985482000,3),(117,1004230800,2),(117,1017536400,3),(117,1035680400,2),(117,1048986000,3),(117,1067130000,2),(117,1080435600,3),(117,1099184400,2),(117,1111885200,3),(117,1130634000,2),(117,1143334800,3),(117,1162083600,2),(117,1174784400,3),(117,1193533200,2),(117,1206838800,3),(117,1224982800,2),(117,1238288400,3),(117,1256432400,2),(117,1269738000,3),(117,1288486800,2),(117,1301187600,3),(117,1319936400,2),(117,1332637200,3),(117,1351386000,2),(117,1364691600,3),(117,1382835600,2),(117,1396141200,3),(117,1414285200,2),(117,1427590800,3),(117,1445734800,2),(117,1459040400,3),(117,1477789200,2),(117,1490490000,3),(117,1509238800,2),(117,1521939600,3),(117,1540688400,2),(117,1553994000,3),(117,1572138000,2),(117,1585443600,3),(117,1603587600,2),(117,1616893200,3),(117,1635642000,2),(117,1648342800,3),(117,1667091600,2),(117,1679792400,3),(117,1698541200,5),(117,1711846800,6),(117,1729990800,5),(117,1743296400,6),(117,1761440400,5),(117,1774746000,6),(117,1792890000,5),(117,1806195600,6),(117,1824944400,5),(117,1837645200,6),(117,1856394000,5),(117,1869094800,6),(117,1887843600,5),(117,1901149200,6),(117,1919293200,5),(117,1932598800,6),(117,1950742800,5),(117,1964048400,6),(117,1982797200,5),(117,1995498000,6),(117,2014246800,5),(117,2026947600,6),(117,2045696400,5),(117,2058397200,6),(117,2077146000,5),(117,2090451600,6),(117,2108595600,5),(117,2121901200,6),(117,2140045200,5),(117,2147483647,5),(118,-2147483648,1),(118,-1632076148,2),(118,-1615145348,1),(118,-1096921748,3),(118,-1061670600,4),(118,-1048973400,3),(118,-1030221000,4),(118,-1017523800,3),(118,-998771400,4),(118,-986074200,3),(118,-966717000,4),(118,-954624600,3),(118,-935267400,4),(118,-922570200,3),(118,-903817800,4),(118,-891120600,3),(118,-872368200,6),(118,-769395600,5),(118,-765401400,3),(118,-746044200,4),(118,-733347000,3),(118,-714594600,4),(118,-701897400,3),(118,-683145000,4),(118,-670447800,3),(118,-651695400,4),(118,-638998200,3),(118,-619641000,4),(118,-606943800,3),(118,-589401000,4),(118,-576099000,3),(118,-557951400,4),(118,-544649400,3),(118,-526501800,4),(118,-513199800,3),(118,-495052200,4),(118,-481750200,3),(118,-463602600,4),(118,-450300600,3),(118,-431548200,4),(118,-418246200,3),(118,-400098600,4),(118,-386796600,3),(118,-368649000,4),(118,-355347000,3),(118,-337199400,4),(118,-323897400,3),(118,-305749800,4),(118,-289423800,3),(118,-273695400,4),(118,-257974200,3),(118,-242245800,4),(118,-226524600,3),(118,-210796200,4),(118,-195075000,3),(118,-179346600,4),(118,-163625400,3),(118,-147897000,4),(118,-131571000,3),(118,-119903400,8),(118,-116445600,7),(118,-100119600,8),(118,-84391200,7),(118,-68670000,8),(118,-52941600,7),(118,-37220400,8),(118,-21492000,7),(118,-5770800,8),(118,9957600,7),(118,25678800,8),(118,41407200,7),(118,57733200,8),(118,73461600,7),(118,89182800,8),(118,104911200,7),(118,120632400,8),(118,136360800,7),(118,152082000,8),(118,167810400,7),(118,183531600,8),(118,199260000,7),(118,215586000,8),(118,230709600,7),(118,247035600,8),(118,262764000,7),(118,278485200,8),(118,294213600,7),(118,309934800,8),(118,325663200,7),(118,341384400,8),(118,357112800,7),(118,372834000,8),(118,388562400,7),(118,404888400,8),(118,420012000,7),(118,436338000,8),(118,452066400,7),(118,467787600,8),(118,483516000,7),(118,499237200,8),(118,514965600,7),(118,530686800,8),(118,544593660,7),(118,562129260,8),(118,576043260,9),(118,594180060,8),(118,607492860,7),(118,625633260,8),(118,638942460,7),(118,657082860,8),(118,670996860,7),(118,688532460,8),(118,702446460,7),(118,719982060,8),(118,733896060,7),(118,752036460,8),(118,765345660,7),(118,783486060,8),(118,796795260,7),(118,814935660,8),(118,828849660,7),(118,846385260,8),(118,860299260,7),(118,877834860,8),(118,891748860,7),(118,909284460,8),(118,923198460,7),(118,941338860,8),(118,954648060,7),(118,972788460,8),(118,986097660,7),(118,1004238060,8),(118,1018152060,7),(118,1035687660,8),(118,1049601660,7),(118,1067137260,8),(118,1081051260,7),(118,1099191660,8),(118,1112500860,7),(118,1130641260,8),(118,1143950460,7),(118,1162090860,8),(118,1173585660,7),(118,1194145260,8),(118,1205035260,7),(118,1225594860,8),(118,1236484860,7),(118,1257044460,8),(118,1268539260,7),(118,1289098860,8),(118,1299988860,7),(118,1320555600,8),(118,1331445600,7),(118,1352005200,8),(118,1362895200,7),(118,1383454800,8),(118,1394344800,7),(118,1414904400,8),(118,1425794400,7),(118,1446354000,8),(118,1457848800,7),(118,1478408400,8),(118,1489298400,7),(118,1509858000,8),(118,1520748000,7),(118,1541307600,8),(118,1552197600,7),(118,1572757200,8),(118,1583647200,7),(118,1604206800,8),(118,1615701600,7),(118,1636261200,8),(118,1647151200,7),(118,1667710800,8),(118,1678600800,7),(118,1699160400,8),(118,1710050400,7),(118,1730610000,8),(118,1741500000,7),(118,1762059600,8),(118,1772949600,7),(118,1793509200,8),(118,1805004000,7),(118,1825563600,8),(118,1836453600,7),(118,1857013200,8),(118,1867903200,7),(118,1888462800,8),(118,1899352800,7),(118,1919912400,8),(118,1930802400,7),(118,1951362000,8),(118,1962856800,7),(118,1983416400,8),(118,1994306400,7),(118,2014866000,8),(118,2025756000,7),(118,2046315600,8),(118,2057205600,7),(118,2077765200,8),(118,2088655200,7),(118,2109214800,8),(118,2120104800,7),(118,2140664400,8),(119,-2147483648,1),(119,-1827687170,2),(119,294217200,3),(119,309938400,2),(119,325666800,3),(119,341388000,2),(119,357116400,3),(119,372837600,2),(119,388566000,3),(119,404892000,2),(119,420015600,3),(119,436341600,2),(119,452070000,3),(119,467791200,2),(119,483519600,3),(119,499240800,2),(119,514969200,3),(119,530690400,2),(119,544604400,3),(119,562140000,2),(119,576054000,3),(119,594194400,2),(119,607503600,3),(119,625644000,2),(119,638953200,3),(119,657093600,2),(119,671007600,3),(119,688543200,2),(119,702457200,3),(119,719992800,2),(119,733906800,3),(119,752047200,2),(119,765356400,3),(119,783496800,2),(119,796806000,3),(119,814946400,2),(119,828860400,3),(119,846396000,2),(119,860310000,3),(119,877845600,2),(119,891759600,3),(119,909295200,2),(119,923209200,3),(119,941349600,2),(119,954658800,3),(119,972799200,2),(119,986108400,3),(119,1004248800,2),(119,1018162800,3),(119,1035698400,2),(119,1049612400,3),(119,1067148000,2),(119,1081062000,3),(119,1099202400,2),(119,1112511600,3),(119,1130652000,2),(119,1143961200,3),(119,1162101600,2),(119,1173596400,3),(119,1194156000,2),(119,1205046000,3),(119,1225605600,2),(119,1236495600,3),(119,1257055200,2),(119,1268550000,3),(119,1289109600,2),(119,1299999600,3),(119,1320559200,2),(119,1331449200,3),(119,1352008800,2),(119,1362898800,3),(119,1383458400,2),(119,1394348400,3),(119,1414908000,2),(119,1425798000,4),(119,1520751600,3),(119,1541311200,2),(119,1552201200,3),(119,1572760800,2),(119,1583650800,3),(119,1604210400,2),(119,1615705200,3),(119,1636264800,2),(119,1647154800,3),(119,1667714400,2),(119,1678604400,3),(119,1699164000,2),(119,1710054000,3),(119,1730613600,2),(119,1741503600,3),(119,1762063200,2),(119,1772953200,3),(119,1793512800,2),(119,1805007600,3),(119,1825567200,2),(119,1836457200,3),(119,1857016800,2),(119,1867906800,3),(119,1888466400,2),(119,1899356400,3),(119,1919916000,2),(119,1930806000,3),(119,1951365600,2),(119,1962860400,3),(119,1983420000,2),(119,1994310000,3),(119,2014869600,2),(119,2025759600,3),(119,2046319200,2),(119,2057209200,3),(119,2077768800,2),(119,2088658800,3),(119,2109218400,2),(119,2120108400,3),(119,2140668000,2),(120,-2147483648,1),(120,-873057600,3),(120,-769395600,2),(120,-765399600,1),(121,-2147483648,1),(121,-873057600,3),(121,-769395600,2),(121,-765399600,1),(122,-2147483648,0),(122,-1617040676,2),(122,123055200,1),(122,130914000,2),(122,422344800,1),(122,433054800,2),(122,669708000,1),(122,684219600,2),(122,1146376800,1),(122,1159678800,2),(123,-2147483648,1),(123,-1230749160,3),(123,722926800,2),(123,728884800,3),(123,2147483647,3),(124,-2147483648,0),(124,-1843589241,1),(124,-1730577600,2),(124,176096700,3),(124,701841600,1),(124,2147483647,1),(125,-2147483648,0),(125,-2131645536,2),(125,-1696276800,1),(125,-1680469200,2),(125,-1632074400,1),(125,-1615143600,2),(125,-1566763200,1),(125,-1557090000,2),(125,-1535486400,1),(125,-1524949200,2),(125,-1504468800,1),(125,-1493413200,2),(125,-1472414400,1),(125,-1461963600,2),(125,-1440964800,1),(125,-1429390800,2),(125,-1409515200,1),(125,-1396731600,2),(125,-1376856000,1),(125,-1366491600,2),(125,-1346616000,1),(125,-1333832400,2),(125,-1313956800,1),(125,-1303678800,2),(125,-1282507200,1),(125,-1272661200,2),(125,-1251057600,1),(125,-1240088400,2),(125,-1219608000,1),(125,-1207429200,2),(125,-1188763200,1),(125,-1175979600,2),(125,-1157313600,1),(125,-1143925200,2),(125,-1124049600,1),(125,-1113771600,2),(125,-1091390400,1),(125,-1081026000,2),(125,-1059854400,1),(125,-1050786000,2),(125,-1030910400,1),(125,-1018126800,2),(125,-999460800,1),(125,-986677200,2),(125,-965592000,1),(125,-955227600,2),(125,-935956800,1),(125,-923173200,2),(125,-904507200,1),(125,-891723600,2),(125,-880221600,3),(125,-769395600,4),(125,-765399600,2),(125,-747252000,1),(125,-733950000,2),(125,-715802400,1),(125,-702500400,2),(125,-684352800,1),(125,-671050800,2),(125,-652903200,1),(125,-639601200,2),(125,-589399200,1),(125,-576097200,2),(125,-557949600,1),(125,-544647600,2),(125,-526500000,1),(125,-513198000,2),(125,-495050400,1),(125,-481748400,2),(125,-431546400,1),(125,-418244400,2),(125,-400096800,1),(125,-386794800,2),(125,-368647200,1),(125,-355345200,2),(125,-337197600,1),(125,-323895600,2),(125,-242244000,1),(125,-226522800,2),(125,-210794400,1),(125,-195073200,2),(125,-179344800,1),(125,-163623600,2),(125,-147895200,1),(125,-131569200,2),(125,-116445600,1),(125,-100119600,2),(125,-84391200,1),(125,-68670000,2),(125,-52941600,1),(125,-37220400,2),(125,-21492000,1),(125,-5770800,2),(125,9957600,1),(125,25678800,2),(125,41407200,1),(125,57733200,2),(125,73461600,1),(125,89182800,2),(125,104911200,1),(125,120632400,2),(125,136360800,1),(125,152082000,2),(125,167810400,1),(125,183531600,2),(125,199260000,1),(125,215586000,2),(125,230709600,1),(125,247035600,2),(125,262764000,1),(125,278485200,2),(125,294213600,1),(125,309934800,2),(125,325663200,1),(125,341384400,2),(125,357112800,1),(125,372834000,2),(125,388562400,1),(125,404888400,2),(125,420012000,1),(125,436338000,2),(125,452066400,1),(125,467787600,2),(125,483516000,1),(125,499237200,2),(125,514965600,1),(125,530686800,2),(125,544600800,1),(125,562136400,2),(125,576050400,1),(125,594190800,2),(125,607500000,1),(125,625640400,2),(125,638949600,1),(125,657090000,2),(125,671004000,1),(125,688539600,2),(125,702453600,1),(125,719989200,2),(125,733903200,1),(125,752043600,2),(125,765352800,1),(125,783493200,2),(125,796802400,1),(125,814942800,2),(125,828856800,1),(125,846392400,2),(125,860306400,1),(125,877842000,2),(125,891756000,1),(125,909291600,2),(125,923205600,1),(125,941346000,2),(125,954655200,1),(125,972795600,2),(125,986104800,1),(125,1004245200,2),(125,1018159200,1),(125,1035694800,2),(125,1049608800,1),(125,1067144400,2),(125,1081058400,1),(125,1099198800,2),(125,1112508000,1),(125,1130648400,2),(125,1143957600,1),(125,1162098000,2),(125,1173592800,1),(125,1194152400,2),(125,1205042400,1),(125,1225602000,2),(125,1236492000,1),(125,1257051600,2),(125,1268546400,1),(125,1289106000,2),(125,1299996000,1),(125,1320555600,2),(125,1331445600,1),(125,1352005200,2),(125,1362895200,1),(125,1383454800,2),(125,1394344800,1),(125,1414904400,2),(125,1425794400,1),(125,1446354000,2),(125,1457848800,1),(125,1478408400,2),(125,1489298400,1),(125,1509858000,2),(125,1520748000,1),(125,1541307600,2),(125,1552197600,1),(125,1572757200,2),(125,1583647200,1),(125,1604206800,2),(125,1615701600,1),(125,1636261200,2),(125,1647151200,1),(125,1667710800,2),(125,1678600800,1),(125,1699160400,2),(125,1710050400,1),(125,1730610000,2),(125,1741500000,1),(125,1762059600,2),(125,1772949600,1),(125,1793509200,2),(125,1805004000,1),(125,1825563600,2),(125,1836453600,1),(125,1857013200,2),(125,1867903200,1),(125,1888462800,2),(125,1899352800,1),(125,1919912400,2),(125,1930802400,1),(125,1951362000,2),(125,1962856800,1),(125,1983416400,2),(125,1994306400,1),(125,2014866000,2),(125,2025756000,1),(125,2046315600,2),(125,2057205600,1),(125,2077765200,2),(125,2088655200,1),(125,2109214800,2),(125,2120104800,1),(125,2140664400,2),(126,-2147483648,1),(126,-1402813824,3),(126,-1311534000,2),(126,-1300996800,3),(126,-933534000,2),(126,-925675200,3),(126,-902084400,2),(126,-893620800,3),(126,-870030000,2),(126,-862171200,3),(126,-775681200,2),(126,-767822400,3),(126,-744231600,2),(126,-736372800,3),(126,-144702000,2),(126,-134251200,3),(126,-113425200,2),(126,-102542400,3),(126,-86295600,2),(126,-72907200,3),(126,-54154800,2),(126,-41457600,3),(126,-21495600,2),(126,-5774400,3),(126,9954000,2),(126,25675200,3),(126,41403600,2),(126,57729600,3),(126,73458000,2),(126,87364800,3),(126,104907600,2),(126,118900800,3),(126,136357200,2),(126,150436800,3),(126,167806800,2),(126,183528000,3),(126,199256400,2),(126,215582400,3),(126,230706000,2),(126,247032000,3),(126,263365200,2),(126,276667200,3),(126,290581200,2),(126,308721600,3),(126,322030800,2),(126,340171200,3),(126,358318800,2),(126,371620800,3),(126,389768400,2),(126,403070400,3),(126,421218000,2),(126,434520000,3),(126,452667600,2),(126,466574400,3),(126,484117200,2),(126,498024000,3),(126,511333200,2),(126,529473600,3),(126,542782800,2),(126,560923200,3),(126,574837200,2),(126,592372800,3),(126,606286800,2),(126,623822400,3),(126,638946000,2),(126,655876800,3),(126,671000400,2),(126,687330000,4),(126,702450000,2),(126,718779600,4),(126,733899600,2),(126,750229200,4),(126,765349200,2),(126,781678800,4),(126,796798800,2),(126,813128400,4),(126,828853200,2),(126,844578000,4),(126,860302800,2),(126,876632400,4),(126,891147600,5),(126,909291600,4),(126,922597200,5),(126,941346000,4),(126,954651600,5),(126,972795600,4),(126,986101200,5),(126,1004245200,4),(126,1018155600,5),(126,1035694800,4),(126,1049605200,5),(126,1067144400,4),(126,1080450000,5),(126,1162098000,4),(126,1173589200,5),(126,1193547600,4),(126,1205643600,5),(126,1224997200,4),(126,1236488400,5),(126,1256446800,4),(126,1268542800,5),(126,1288501200,4),(126,1300597200,5),(126,1321160400,4),(126,1333256400,5),(126,1352005200,4),(126,1362891600,5),(126,1383454800,4),(126,1394341200,5),(126,1414904400,4),(126,1425790800,5),(126,1446354000,4),(126,1457845200,5),(126,1478408400,4),(126,1489294800,5),(126,1509858000,4),(126,1520744400,5),(126,1541307600,4),(126,1552194000,5),(126,1572757200,4),(126,1583643600,5),(126,1604206800,4),(126,1615698000,5),(126,1636261200,4),(126,1647147600,5),(126,1667710800,4),(126,1678597200,5),(126,1699160400,4),(126,1710046800,5),(126,1730610000,4),(126,1741496400,5),(126,1762059600,4),(126,1772946000,5),(126,1793509200,4),(126,1805000400,5),(126,1825563600,4),(126,1836450000,5),(126,1857013200,4),(126,1867899600,5),(126,1888462800,4),(126,1899349200,5),(126,1919912400,4),(126,1930798800,5),(126,1951362000,4),(126,1962853200,5),(126,1983416400,4),(126,1994302800,5),(126,2014866000,4),(126,2025752400,5),(126,2046315600,4),(126,2057202000,5),(126,2077765200,4),(126,2088651600,5),(126,2109214800,4),(126,2120101200,5),(126,2140664400,4),(127,-2147483648,0),(127,-1514739600,1),(127,-1343066400,2),(127,-1234807200,4),(127,-1220292000,3),(127,-1207159200,4),(127,-1191344400,2),(127,-873828000,4),(127,-661539600,5),(127,28800,4),(127,828867600,3),(127,846403200,4),(127,860317200,3),(127,877852800,4),(127,891766800,3),(127,909302400,4),(128,-2147483648,3),(128,-1633276800,1),(128,-1615136400,2),(128,-1601827200,1),(128,-1583686800,2),(128,-900259200,1),(128,-891795600,2),(128,-880214400,4),(128,-769395600,5),(128,-765392400,2),(128,-747244800,1),(128,-733942800,2),(128,-715795200,1),(128,-702493200,2),(128,-684345600,1),(128,-671043600,2),(128,-652896000,1),(128,-639594000,2),(128,-620841600,1),(128,-608144400,2),(128,-589392000,1),(128,-576090000,2),(128,-557942400,1),(128,-544640400,2),(128,-526492800,1),(128,-513190800,2),(128,-495043200,1),(128,-481741200,2),(128,-463593600,6),(128,-386787600,2),(128,-368640000,6),(128,-21488400,7),(128,-5767200,6),(128,9961200,7),(128,25682400,6),(128,1143961200,7),(128,1162101600,6),(128,1173596400,7),(128,1194156000,6),(128,1205046000,7),(128,1225605600,6),(128,1236495600,7),(128,1257055200,6),(128,1268550000,7),(128,1289109600,6),(128,1299999600,7),(128,1320559200,6),(128,1331449200,7),(128,1352008800,6),(128,1362898800,7),(128,1383458400,6),(128,1394348400,7),(128,1414908000,6),(128,1425798000,7),(128,1446357600,6),(128,1457852400,7),(128,1478412000,6),(128,1489302000,7),(128,1509861600,6),(128,1520751600,7),(128,1541311200,6),(128,1552201200,7),(128,1572760800,6),(128,1583650800,7),(128,1604210400,6),(128,1615705200,7),(128,1636264800,6),(128,1647154800,7),(128,1667714400,6),(128,1678604400,7),(128,1699164000,6),(128,1710054000,7),(128,1730613600,6),(128,1741503600,7),(128,1762063200,6),(128,1772953200,7),(128,1793512800,6),(128,1805007600,7),(128,1825567200,6),(128,1836457200,7),(128,1857016800,6),(128,1867906800,7),(128,1888466400,6),(128,1899356400,7),(128,1919916000,6),(128,1930806000,7),(128,1951365600,6),(128,1962860400,7),(128,1983420000,6),(128,1994310000,7),(128,2014869600,6),(128,2025759600,7),(128,2046319200,6),(128,2057209200,7),(128,2077768800,6),(128,2088658800,7),(128,2109218400,6),(128,2120108400,7),(128,2140668000,6),(129,-2147483648,5),(129,-1633276800,1),(129,-1615136400,2),(129,-1601827200,1),(129,-1583686800,2),(129,-880214400,3),(129,-769395600,4),(129,-765392400,2),(129,-715795200,1),(129,-702493200,2),(129,-684345600,1),(129,-671043600,2),(129,-652896000,1),(129,-639594000,2),(129,-620841600,1),(129,-608144400,2),(129,-589392000,1),(129,-576090000,2),(129,-557942400,1),(129,-544640400,2),(129,-526492800,1),(129,-513190800,2),(129,-495043200,1),(129,-481741200,2),(129,-463593600,1),(129,-447267600,2),(129,-431539200,1),(129,-415818000,2),(129,-400089600,1),(129,-386787600,2),(129,-368640000,1),(129,-355338000,2),(129,-337190400,1),(129,-321469200,2),(129,-305740800,1),(129,-289414800,2),(129,-273686400,1),(129,-257965200,2),(129,-242236800,6),(129,-195066000,2),(129,-84384000,1),(129,-68662800,2),(129,-52934400,1),(129,-37213200,2),(129,-21484800,1),(129,-5763600,2),(129,9964800,1),(129,25686000,2),(129,41414400,1),(129,57740400,2),(129,73468800,1),(129,89190000,2),(129,104918400,1),(129,120639600,2),(129,126691200,1),(129,152089200,2),(129,162374400,1),(129,183538800,2),(129,199267200,1),(129,215593200,2),(129,230716800,1),(129,247042800,2),(129,262771200,1),(129,278492400,2),(129,294220800,1),(129,309942000,2),(129,325670400,1),(129,341391600,2),(129,357120000,1),(129,372841200,2),(129,388569600,1),(129,404895600,2),(129,420019200,1),(129,436345200,2),(129,452073600,1),(129,467794800,2),(129,483523200,1),(129,499244400,2),(129,514972800,1),(129,530694000,2),(129,544608000,1),(129,562143600,2),(129,576057600,1),(129,594198000,2),(129,607507200,1),(129,625647600,2),(129,638956800,1),(129,657097200,2),(129,671011200,1),(129,688546800,6),(129,1143961200,1),(129,1162105200,2),(129,1173600000,1),(129,1194159600,2),(129,1205049600,1),(129,1225609200,2),(129,1236499200,1),(129,1257058800,2),(129,1268553600,1),(129,1289113200,2),(129,1300003200,1),(129,1320562800,2),(129,1331452800,1),(129,1352012400,2),(129,1362902400,1),(129,1383462000,2),(129,1394352000,1),(129,1414911600,2),(129,1425801600,1),(129,1446361200,2),(129,1457856000,1),(129,1478415600,2),(129,1489305600,1),(129,1509865200,2),(129,1520755200,1),(129,1541314800,2),(129,1552204800,1),(129,1572764400,2),(129,1583654400,1),(129,1604214000,2),(129,1615708800,1),(129,1636268400,2),(129,1647158400,1),(129,1667718000,2),(129,1678608000,1),(129,1699167600,2),(129,1710057600,1),(129,1730617200,2),(129,1741507200,1),(129,1762066800,2),(129,1772956800,1),(129,1793516400,2),(129,1805011200,1),(129,1825570800,2),(129,1836460800,1),(129,1857020400,2),(129,1867910400,1),(129,1888470000,2),(129,1899360000,1),(129,1919919600,2),(129,1930809600,1),(129,1951369200,2),(129,1962864000,1),(129,1983423600,2),(129,1994313600,1),(129,2014873200,2),(129,2025763200,1),(129,2046322800,2),(129,2057212800,1),(129,2077772400,2),(129,2088662400,1),(129,2109222000,2),(129,2120112000,1),(129,2140671600,2),(130,-2147483648,5),(130,-1633276800,1),(130,-1615136400,2),(130,-1601827200,1),(130,-1583686800,2),(130,-880214400,3),(130,-769395600,4),(130,-765392400,2),(130,-589392000,1),(130,-576090000,2),(130,-495043200,1),(130,-481741200,2),(130,-463593600,1),(130,-450291600,2),(130,-431539200,1),(130,-418237200,2),(130,-400089600,1),(130,-386787600,2),(130,-368640000,1),(130,-355338000,2),(130,-337190400,1),(130,-323888400,2),(130,-305740800,1),(130,-292438800,2),(130,-273686400,6),(130,-21488400,7),(130,-5767200,6),(130,9961200,7),(130,25682400,6),(130,41410800,7),(130,57736800,6),(130,73465200,7),(130,89186400,6),(130,104914800,7),(130,120636000,6),(130,126687600,1),(130,152089200,6),(130,162370800,7),(130,183535200,6),(130,1143961200,7),(130,1162101600,6),(130,1173596400,7),(130,1194156000,6),(130,1205046000,7),(130,1225605600,6),(130,1236495600,7),(130,1257055200,6),(130,1268550000,7),(130,1289109600,6),(130,1299999600,7),(130,1320559200,6),(130,1331449200,7),(130,1352008800,6),(130,1362898800,7),(130,1383458400,6),(130,1394348400,7),(130,1414908000,6),(130,1425798000,7),(130,1446357600,6),(130,1457852400,7),(130,1478412000,6),(130,1489302000,7),(130,1509861600,6),(130,1520751600,7),(130,1541311200,6),(130,1552201200,7),(130,1572760800,6),(130,1583650800,7),(130,1604210400,6),(130,1615705200,7),(130,1636264800,6),(130,1647154800,7),(130,1667714400,6),(130,1678604400,7),(130,1699164000,6),(130,1710054000,7),(130,1730613600,6),(130,1741503600,7),(130,1762063200,6),(130,1772953200,7),(130,1793512800,6),(130,1805007600,7),(130,1825567200,6),(130,1836457200,7),(130,1857016800,6),(130,1867906800,7),(130,1888466400,6),(130,1899356400,7),(130,1919916000,6),(130,1930806000,7),(130,1951365600,6),(130,1962860400,7),(130,1983420000,6),(130,1994310000,7),(130,2014869600,6),(130,2025759600,7),(130,2046319200,6),(130,2057209200,7),(130,2077768800,6),(130,2088658800,7),(130,2109218400,6),(130,2120108400,7),(130,2140668000,6),(131,-2147483648,5),(131,-1633276800,1),(131,-1615136400,2),(131,-1601827200,1),(131,-1583686800,2),(131,-880214400,3),(131,-769395600,4),(131,-765392400,2),(131,-462996000,1),(131,-450291600,2),(131,-431539200,1),(131,-418237200,2),(131,-400089600,1),(131,-386787600,2),(131,-368640000,1),(131,-355338000,2),(131,-337190400,1),(131,-323888400,2),(131,-305740800,1),(131,-292438800,2),(131,-273686400,1),(131,-257965200,2),(131,-242236800,1),(131,-226515600,2),(131,-210787200,1),(131,-195066000,2),(131,-179337600,1),(131,-163616400,2),(131,-147888000,6),(131,-100112400,2),(131,-84384000,1),(131,-68662800,2),(131,-52934400,1),(131,-37213200,2),(131,-21484800,1),(131,-5763600,2),(131,9964800,1),(131,25686000,2),(131,41414400,1),(131,57740400,2),(131,73468800,1),(131,89190000,2),(131,104918400,1),(131,120639600,2),(131,126691200,1),(131,152089200,2),(131,162374400,1),(131,183538800,2),(131,199267200,1),(131,215593200,2),(131,230716800,1),(131,247042800,6),(131,1143961200,1),(131,1162105200,2),(131,1173600000,1),(131,1194159600,6),(131,1205046000,7),(131,1225605600,6),(131,1236495600,7),(131,1257055200,6),(131,1268550000,7),(131,1289109600,6),(131,1299999600,7),(131,1320559200,6),(131,1331449200,7),(131,1352008800,6),(131,1362898800,7),(131,1383458400,6),(131,1394348400,7),(131,1414908000,6),(131,1425798000,7),(131,1446357600,6),(131,1457852400,7),(131,1478412000,6),(131,1489302000,7),(131,1509861600,6),(131,1520751600,7),(131,1541311200,6),(131,1552201200,7),(131,1572760800,6),(131,1583650800,7),(131,1604210400,6),(131,1615705200,7),(131,1636264800,6),(131,1647154800,7),(131,1667714400,6),(131,1678604400,7),(131,1699164000,6),(131,1710054000,7),(131,1730613600,6),(131,1741503600,7),(131,1762063200,6),(131,1772953200,7),(131,1793512800,6),(131,1805007600,7),(131,1825567200,6),(131,1836457200,7),(131,1857016800,6),(131,1867906800,7),(131,1888466400,6),(131,1899356400,7),(131,1919916000,6),(131,1930806000,7),(131,1951365600,6),(131,1962860400,7),(131,1983420000,6),(131,1994310000,7),(131,2014869600,6),(131,2025759600,7),(131,2046319200,6),(131,2057209200,7),(131,2077768800,6),(131,2088658800,7),(131,2109218400,6),(131,2120108400,7),(131,2140668000,6),(132,-2147483648,5),(132,-1633276800,1),(132,-1615136400,2),(132,-1601827200,1),(132,-1583686800,2),(132,-880214400,3),(132,-769395600,4),(132,-765392400,2),(132,-462996000,1),(132,-450291600,2),(132,-431539200,1),(132,-418237200,2),(132,-400089600,1),(132,-386787600,2),(132,-368640000,1),(132,-355338000,2),(132,-337190400,1),(132,-323888400,2),(132,-305740800,1),(132,-292438800,2),(132,-273686400,1),(132,-257965200,2),(132,-242236800,1),(132,-226515600,2),(132,-210787200,1),(132,-195066000,2),(132,-179337600,6),(132,-68662800,2),(132,-52934400,1),(132,-37213200,2),(132,-21484800,7),(132,-5767200,6),(132,9961200,7),(132,25682400,6),(132,1143961200,1),(132,1162105200,2),(132,1173600000,1),(132,1194159600,2),(132,1205049600,1),(132,1225609200,2),(132,1236499200,1),(132,1257058800,2),(132,1268553600,1),(132,1289113200,2),(132,1300003200,1),(132,1320562800,2),(132,1331452800,1),(132,1352012400,2),(132,1362902400,1),(132,1383462000,2),(132,1394352000,1),(132,1414911600,2),(132,1425801600,1),(132,1446361200,2),(132,1457856000,1),(132,1478415600,2),(132,1489305600,1),(132,1509865200,2),(132,1520755200,1),(132,1541314800,2),(132,1552204800,1),(132,1572764400,2),(132,1583654400,1),(132,1604214000,2),(132,1615708800,1),(132,1636268400,2),(132,1647158400,1),(132,1667718000,2),(132,1678608000,1),(132,1699167600,2),(132,1710057600,1),(132,1730617200,2),(132,1741507200,1),(132,1762066800,2),(132,1772956800,1),(132,1793516400,2),(132,1805011200,1),(132,1825570800,2),(132,1836460800,1),(132,1857020400,2),(132,1867910400,1),(132,1888470000,2),(132,1899360000,1),(132,1919919600,2),(132,1930809600,1),(132,1951369200,2),(132,1962864000,1),(132,1983423600,2),(132,1994313600,1),(132,2014873200,2),(132,2025763200,1),(132,2046322800,2),(132,2057212800,1),(132,2077772400,2),(132,2088662400,1),(132,2109222000,2),(132,2120112000,1),(132,2140671600,2),(133,-2147483648,5),(133,-1633276800,1),(133,-1615136400,2),(133,-1601827200,1),(133,-1583686800,2),(133,-880214400,3),(133,-769395600,4),(133,-765392400,2),(133,-495043200,6),(133,-21488400,7),(133,-5767200,6),(133,9961200,7),(133,25682400,6),(133,41410800,7),(133,57736800,6),(133,73465200,7),(133,89186400,6),(133,1143961200,7),(133,1162101600,6),(133,1173596400,7),(133,1194156000,6),(133,1205046000,7),(133,1225605600,6),(133,1236495600,7),(133,1257055200,6),(133,1268550000,7),(133,1289109600,6),(133,1299999600,7),(133,1320559200,6),(133,1331449200,7),(133,1352008800,6),(133,1362898800,7),(133,1383458400,6),(133,1394348400,7),(133,1414908000,6),(133,1425798000,7),(133,1446357600,6),(133,1457852400,7),(133,1478412000,6),(133,1489302000,7),(133,1509861600,6),(133,1520751600,7),(133,1541311200,6),(133,1552201200,7),(133,1572760800,6),(133,1583650800,7),(133,1604210400,6),(133,1615705200,7),(133,1636264800,6),(133,1647154800,7),(133,1667714400,6),(133,1678604400,7),(133,1699164000,6),(133,1710054000,7),(133,1730613600,6),(133,1741503600,7),(133,1762063200,6),(133,1772953200,7),(133,1793512800,6),(133,1805007600,7),(133,1825567200,6),(133,1836457200,7),(133,1857016800,6),(133,1867906800,7),(133,1888466400,6),(133,1899356400,7),(133,1919916000,6),(133,1930806000,7),(133,1951365600,6),(133,1962860400,7),(133,1983420000,6),(133,1994310000,7),(133,2014869600,6),(133,2025759600,7),(133,2046319200,6),(133,2057209200,7),(133,2077768800,6),(133,2088658800,7),(133,2109218400,6),(133,2120108400,7),(133,2140668000,6),(134,-2147483648,5),(134,-1633276800,1),(134,-1615136400,2),(134,-1601827200,1),(134,-1583686800,2),(134,-880214400,3),(134,-769395600,4),(134,-765392400,2),(134,-747244800,1),(134,-733942800,2),(134,-526492800,1),(134,-513190800,2),(134,-495043200,1),(134,-481741200,2),(134,-462996000,1),(134,-450291600,2),(134,-431539200,1),(134,-418237200,2),(134,-400089600,1),(134,-386787600,2),(134,-368640000,1),(134,-355338000,2),(134,-337190400,1),(134,-323888400,2),(134,-305740800,1),(134,-289414800,2),(134,-273686400,1),(134,-260989200,2),(134,-242236800,1),(134,-226515600,2),(134,-210787200,1),(134,-195066000,2),(134,-179337600,6),(134,-21488400,7),(134,-5767200,6),(134,9961200,7),(134,25682400,6),(134,1143961200,1),(134,1162105200,2),(134,1173600000,1),(134,1194159600,6),(134,1205046000,7),(134,1225605600,6),(134,1236495600,7),(134,1257055200,6),(134,1268550000,7),(134,1289109600,6),(134,1299999600,7),(134,1320559200,6),(134,1331449200,7),(134,1352008800,6),(134,1362898800,7),(134,1383458400,6),(134,1394348400,7),(134,1414908000,6),(134,1425798000,7),(134,1446357600,6),(134,1457852400,7),(134,1478412000,6),(134,1489302000,7),(134,1509861600,6),(134,1520751600,7),(134,1541311200,6),(134,1552201200,7),(134,1572760800,6),(134,1583650800,7),(134,1604210400,6),(134,1615705200,7),(134,1636264800,6),(134,1647154800,7),(134,1667714400,6),(134,1678604400,7),(134,1699164000,6),(134,1710054000,7),(134,1730613600,6),(134,1741503600,7),(134,1762063200,6),(134,1772953200,7),(134,1793512800,6),(134,1805007600,7),(134,1825567200,6),(134,1836457200,7),(134,1857016800,6),(134,1867906800,7),(134,1888466400,6),(134,1899356400,7),(134,1919916000,6),(134,1930806000,7),(134,1951365600,6),(134,1962860400,7),(134,1983420000,6),(134,1994310000,7),(134,2014869600,6),(134,2025759600,7),(134,2046319200,6),(134,2057209200,7),(134,2077768800,6),(134,2088658800,7),(134,2109218400,6),(134,2120108400,7),(134,2140668000,6),(135,-2147483648,5),(135,-1633276800,1),(135,-1615136400,2),(135,-1601827200,1),(135,-1583686800,2),(135,-880214400,3),(135,-769395600,4),(135,-765392400,2),(135,-747244800,1),(135,-733942800,2),(135,-715795200,1),(135,-702493200,2),(135,-684345600,1),(135,-671043600,2),(135,-652896000,1),(135,-639594000,2),(135,-620841600,1),(135,-608144400,2),(135,-589392000,1),(135,-576090000,2),(135,-557942400,1),(135,-544640400,2),(135,-526492800,1),(135,-513190800,2),(135,-495043200,1),(135,-481741200,2),(135,-463593600,1),(135,-447267600,2),(135,-431539200,1),(135,-415818000,2),(135,-400089600,1),(135,-386787600,2),(135,-368640000,1),(135,-355338000,2),(135,-337190400,1),(135,-323888400,2),(135,-305740800,1),(135,-292438800,2),(135,-273686400,6),(135,-21488400,7),(135,-5767200,6),(135,9961200,7),(135,25682400,6),(135,1143961200,1),(135,1162105200,2),(135,1173600000,7),(135,1194156000,6),(135,1205046000,7),(135,1225605600,6),(135,1236495600,7),(135,1257055200,6),(135,1268550000,7),(135,1289109600,6),(135,1299999600,7),(135,1320559200,6),(135,1331449200,7),(135,1352008800,6),(135,1362898800,7),(135,1383458400,6),(135,1394348400,7),(135,1414908000,6),(135,1425798000,7),(135,1446357600,6),(135,1457852400,7),(135,1478412000,6),(135,1489302000,7),(135,1509861600,6),(135,1520751600,7),(135,1541311200,6),(135,1552201200,7),(135,1572760800,6),(135,1583650800,7),(135,1604210400,6),(135,1615705200,7),(135,1636264800,6),(135,1647154800,7),(135,1667714400,6),(135,1678604400,7),(135,1699164000,6),(135,1710054000,7),(135,1730613600,6),(135,1741503600,7),(135,1762063200,6),(135,1772953200,7),(135,1793512800,6),(135,1805007600,7),(135,1825567200,6),(135,1836457200,7),(135,1857016800,6),(135,1867906800,7),(135,1888466400,6),(135,1899356400,7),(135,1919916000,6),(135,1930806000,7),(135,1951365600,6),(135,1962860400,7),(135,1983420000,6),(135,1994310000,7),(135,2014869600,6),(135,2025759600,7),(135,2046319200,6),(135,2057209200,7),(135,2077768800,6),(135,2088658800,7),(135,2109218400,6),(135,2120108400,7),(135,2140668000,6),(136,-2147483648,3),(136,-1633276800,1),(136,-1615136400,2),(136,-1601827200,1),(136,-1583686800,2),(136,-900259200,1),(136,-891795600,2),(136,-880214400,4),(136,-769395600,5),(136,-765392400,2),(136,-747244800,1),(136,-733942800,2),(136,-715795200,1),(136,-702493200,2),(136,-684345600,1),(136,-671043600,2),(136,-652896000,1),(136,-639594000,2),(136,-620841600,1),(136,-608144400,2),(136,-589392000,1),(136,-576090000,2),(136,-557942400,1),(136,-544640400,2),(136,-526492800,1),(136,-513190800,2),(136,-495043200,1),(136,-481741200,2),(136,-463593600,6),(136,-386787600,2),(136,-368640000,6),(136,-21488400,7),(136,-5767200,6),(136,9961200,7),(136,25682400,6),(136,1143961200,7),(136,1162101600,6),(136,1173596400,7),(136,1194156000,6),(136,1205046000,7),(136,1225605600,6),(136,1236495600,7),(136,1257055200,6),(136,1268550000,7),(136,1289109600,6),(136,1299999600,7),(136,1320559200,6),(136,1331449200,7),(136,1352008800,6),(136,1362898800,7),(136,1383458400,6),(136,1394348400,7),(136,1414908000,6),(136,1425798000,7),(136,1446357600,6),(136,1457852400,7),(136,1478412000,6),(136,1489302000,7),(136,1509861600,6),(136,1520751600,7),(136,1541311200,6),(136,1552201200,7),(136,1572760800,6),(136,1583650800,7),(136,1604210400,6),(136,1615705200,7),(136,1636264800,6),(136,1647154800,7),(136,1667714400,6),(136,1678604400,7),(136,1699164000,6),(136,1710054000,7),(136,1730613600,6),(136,1741503600,7),(136,1762063200,6),(136,1772953200,7),(136,1793512800,6),(136,1805007600,7),(136,1825567200,6),(136,1836457200,7),(136,1857016800,6),(136,1867906800,7),(136,1888466400,6),(136,1899356400,7),(136,1919916000,6),(136,1930806000,7),(136,1951365600,6),(136,1962860400,7),(136,1983420000,6),(136,1994310000,7),(136,2014869600,6),(136,2025759600,7),(136,2046319200,6),(136,2057209200,7),(136,2077768800,6),(136,2088658800,7),(136,2109218400,6),(136,2120108400,7),(136,2140668000,6),(137,-2147483648,0),(137,-536457600,2),(137,73476000,1),(137,89197200,2),(137,104925600,1),(137,120646800,2),(137,136375200,1),(137,152096400,2),(137,167824800,1),(137,183546000,2),(137,199274400,1),(137,215600400,2),(137,230724000,1),(137,247050000,2),(137,262778400,1),(137,278499600,2),(137,294228000,4),(137,309945600,3),(137,325674000,4),(137,341395200,3),(137,357123600,4),(137,372844800,3),(137,388573200,4),(137,404899200,3),(137,420022800,4),(137,436348800,3),(137,452077200,4),(137,467798400,3),(137,483526800,4),(137,499248000,3),(137,514976400,4),(137,530697600,3),(137,544611600,4),(137,562147200,3),(137,576061200,4),(137,594201600,3),(137,607510800,4),(137,625651200,3),(137,638960400,4),(137,657100800,3),(137,671014800,4),(137,688550400,3),(137,702464400,4),(137,720000000,3),(137,733914000,4),(137,752054400,3),(137,765363600,4),(137,783504000,3),(137,796813200,4),(137,814953600,3),(137,828867600,4),(137,846403200,3),(137,860317200,4),(137,877852800,3),(137,891766800,4),(137,909302400,3),(137,923216400,4),(137,941356800,3),(137,954666000,4),(137,972806400,3),(137,986115600,4),(137,1004256000,3),(137,1018170000,4),(137,1035705600,3),(137,1049619600,4),(137,1067155200,3),(137,1081069200,4),(137,1099209600,3),(137,1112518800,4),(137,1130659200,3),(137,1143968400,4),(137,1162108800,3),(137,1173603600,4),(137,1194163200,3),(137,1205053200,4),(137,1225612800,3),(137,1236502800,4),(137,1257062400,3),(137,1268557200,4),(137,1289116800,3),(137,1300006800,4),(137,1320566400,3),(137,1331456400,4),(137,1352016000,3),(137,1362906000,4),(137,1383465600,3),(137,1394355600,4),(137,1414915200,3),(137,1425805200,4),(137,1446364800,3),(137,1457859600,4),(137,1478419200,3),(137,1489309200,4),(137,1509868800,3),(137,1520758800,4),(137,1541318400,3),(137,1552208400,4),(137,1572768000,3),(137,1583658000,4),(137,1604217600,3),(137,1615712400,4),(137,1636272000,3),(137,1647162000,4),(137,1667721600,3),(137,1678611600,4),(137,1699171200,3),(137,1710061200,4),(137,1730620800,3),(137,1741510800,4),(137,1762070400,3),(137,1772960400,4),(137,1793520000,3),(137,1805014800,4),(137,1825574400,3),(137,1836464400,4),(137,1857024000,3),(137,1867914000,4),(137,1888473600,3),(137,1899363600,4),(137,1919923200,3),(137,1930813200,4),(137,1951372800,3),(137,1962867600,4),(137,1983427200,3),(137,1994317200,4),(137,2014876800,3),(137,2025766800,4),(137,2046326400,3),(137,2057216400,4),(137,2077776000,3),(137,2088666000,4),(137,2109225600,3),(137,2120115600,4),(137,2140675200,3),(138,-2147483648,0),(138,-865296000,4),(138,-769395600,1),(138,-765396000,2),(138,73465200,3),(138,89186400,2),(138,104914800,3),(138,120636000,2),(138,136364400,3),(138,152085600,2),(138,167814000,3),(138,183535200,2),(138,199263600,3),(138,215589600,2),(138,230713200,3),(138,247039200,2),(138,262767600,3),(138,278488800,2),(138,294217200,3),(138,309938400,2),(138,325666800,3),(138,341388000,2),(138,357116400,3),(138,372837600,2),(138,388566000,3),(138,404892000,2),(138,420015600,3),(138,436341600,2),(138,452070000,3),(138,467791200,2),(138,483519600,3),(138,499240800,2),(138,514969200,3),(138,530690400,2),(138,544604400,3),(138,562140000,2),(138,576054000,3),(138,594194400,2),(138,607503600,3),(138,625644000,2),(138,638953200,3),(138,657093600,2),(138,671007600,3),(138,688543200,2),(138,702457200,3),(138,719992800,2),(138,733906800,3),(138,752047200,2),(138,765356400,3),(138,783496800,2),(138,796806000,3),(138,814946400,2),(138,828860400,3),(138,846396000,2),(138,860310000,3),(138,877845600,2),(138,891759600,3),(138,909295200,2),(138,923209200,3),(138,941349600,5),(138,954662400,6),(138,972802800,2),(138,986108400,3),(138,1004248800,2),(138,1018162800,3),(138,1035698400,2),(138,1049612400,3),(138,1067148000,2),(138,1081062000,3),(138,1099202400,2),(138,1112511600,3),(138,1130652000,2),(138,1143961200,3),(138,1162101600,2),(138,1173596400,3),(138,1194156000,2),(138,1205046000,3),(138,1225605600,2),(138,1236495600,3),(138,1257055200,2),(138,1268550000,3),(138,1289109600,2),(138,1299999600,3),(138,1320559200,2),(138,1331449200,3),(138,1352008800,2),(138,1362898800,3),(138,1383458400,2),(138,1394348400,3),(138,1414908000,2),(138,1425798000,3),(138,1446357600,2),(138,1457852400,3),(138,1478412000,2),(138,1489302000,3),(138,1509861600,2),(138,1520751600,3),(138,1541311200,2),(138,1552201200,3),(138,1572760800,2),(138,1583650800,3),(138,1604210400,2),(138,1615705200,3),(138,1636264800,2),(138,1647154800,3),(138,1667714400,2),(138,1678604400,3),(138,1699164000,2),(138,1710054000,3),(138,1730613600,2),(138,1741503600,3),(138,1762063200,2),(138,1772953200,3),(138,1793512800,2),(138,1805007600,3),(138,1825567200,2),(138,1836457200,3),(138,1857016800,2),(138,1867906800,3),(138,1888466400,2),(138,1899356400,3),(138,1919916000,2),(138,1930806000,3),(138,1951365600,2),(138,1962860400,3),(138,1983420000,2),(138,1994310000,3),(138,2014869600,2),(138,2025759600,3),(138,2046319200,2),(138,2057209200,3),(138,2077768800,2),(138,2088658800,3),(138,2109218400,2),(138,2120108400,3),(138,2140668000,2),(139,-2147483648,1),(139,-1827687170,2),(139,126687600,3),(139,152085600,2),(139,162370800,3),(139,183535200,2),(139,199263600,3),(139,215589600,2),(139,230713200,3),(139,247039200,2),(139,262767600,3),(139,278488800,2),(139,294217200,3),(139,309938400,2),(139,325666800,3),(139,341388000,2),(139,357116400,3),(139,372837600,2),(139,388566000,3),(139,404892000,2),(139,420015600,3),(139,436341600,2),(140,-2147483648,1),(140,-1567453392,2),(140,-1233432000,3),(140,-1222981200,2),(140,-1205956800,3),(140,-1194037200,2),(140,-1172865600,3),(140,-1162501200,2),(140,-1141329600,3),(140,-1130965200,2),(140,-1109793600,3),(140,-1099429200,2),(140,-1078257600,3),(140,-1067806800,2),(140,-1046635200,3),(140,-1036270800,2),(140,-1015099200,3),(140,-1004734800,2),(140,-983563200,3),(140,-973198800,2),(140,-952027200,3),(140,-941576400,2),(140,-931032000,3),(140,-900882000,2),(140,-890337600,3),(140,-833749200,2),(140,-827265600,3),(140,-752274000,2),(140,-733780800,3),(140,-197326800,2),(140,-190843200,3),(140,-184194000,2),(140,-164491200,3),(140,-152658000,2),(140,-132955200,3),(140,-121122000,2),(140,-101419200,3),(140,-86821200,2),(140,-71092800,3),(140,-54766800,2),(140,-39038400,3),(140,-23317200,2),(140,-7588800,5),(140,128142000,4),(140,136605600,5),(140,596948400,4),(140,605066400,5),(140,624423600,4),(140,636516000,2),(140,657086400,3),(140,669178800,2),(140,686721600,4),(140,699415200,5),(140,719377200,4),(140,731469600,5),(140,938919600,3),(140,952052400,5),(140,1198983600,4),(140,1205632800,5),(140,2147483647,5),(141,-2147483648,1),(141,-880207200,2),(141,-769395600,3),(141,-765385200,1),(141,-21477600,4),(141,-5756400,1),(141,9972000,4),(141,25693200,1),(141,41421600,4),(141,57747600,1),(141,73476000,4),(141,89197200,1),(141,104925600,4),(141,120646800,1),(141,126698400,4),(141,152096400,1),(141,162381600,4),(141,183546000,1),(141,199274400,4),(141,215600400,1),(141,230724000,4),(141,247050000,1),(141,262778400,4),(141,278499600,1),(141,294228000,4),(141,309949200,1),(141,325677600,5),(141,341402400,1),(141,357127200,4),(141,372848400,1),(141,388576800,4),(141,404902800,1),(141,420026400,4),(141,436352400,6),(141,439030800,8),(141,452084400,7),(141,467805600,8),(141,483534000,7),(141,499255200,8),(141,514983600,7),(141,530704800,8),(141,544618800,7),(141,562154400,8),(141,576068400,7),(141,594208800,8),(141,607518000,7),(141,625658400,8),(141,638967600,7),(141,657108000,8),(141,671022000,7),(141,688557600,8),(141,702471600,7),(141,720007200,8),(141,733921200,7),(141,752061600,8),(141,765370800,7),(141,783511200,8),(141,796820400,7),(141,814960800,8),(141,828874800,7),(141,846410400,8),(141,860324400,7),(141,877860000,8),(141,891774000,7),(141,909309600,8),(141,923223600,7),(141,941364000,8),(141,954673200,7),(141,972813600,8),(141,986122800,7),(141,1004263200,8),(141,1018177200,7),(141,1035712800,8),(141,1049626800,7),(141,1067162400,8),(141,1081076400,7),(141,1099216800,8),(141,1112526000,7),(141,1130666400,8),(141,1143975600,7),(141,1162116000,8),(141,1173610800,7),(141,1194170400,8),(141,1205060400,7),(141,1225620000,8),(141,1236510000,7),(141,1257069600,8),(141,1268564400,7),(141,1289124000,8),(141,1300014000,7),(141,1320573600,8),(141,1331463600,7),(141,1352023200,8),(141,1362913200,7),(141,1383472800,8),(141,1394362800,7),(141,1414922400,8),(141,1425812400,7),(141,1446372000,8),(141,1457866800,7),(141,1478426400,8),(141,1489316400,7),(141,1509876000,8),(141,1520766000,7),(141,1541325600,8),(141,1552215600,7),(141,1572775200,8),(141,1583665200,7),(141,1604224800,8),(141,1615719600,7),(141,1636279200,8),(141,1647169200,7),(141,1667728800,8),(141,1678618800,7),(141,1699178400,8),(141,1710068400,7),(141,1730628000,8),(141,1741518000,7),(141,1762077600,8),(141,1772967600,7),(141,1793527200,8),(141,1805022000,7),(141,1825581600,8),(141,1836471600,7),(141,1857031200,8),(141,1867921200,7),(141,1888480800,8),(141,1899370800,7),(141,1919930400,8),(141,1930820400,7),(141,1951380000,8),(141,1962874800,7),(141,1983434400,8),(141,1994324400,7),(141,2014884000,8),(141,2025774000,7),(141,2046333600,8),(141,2057223600,7),(141,2077783200,8),(141,2088673200,7),(141,2109232800,8),(141,2120122800,7),(141,2140682400,8),(142,-2147483648,3),(142,-1633276800,1),(142,-1615136400,2),(142,-1601827200,1),(142,-1583686800,2),(142,-1535904000,1),(142,-1525280400,2),(142,-905097600,1),(142,-891795600,2),(142,-880214400,4),(142,-769395600,5),(142,-765392400,2),(142,-747251940,1),(142,-744224400,2),(142,-620841600,1),(142,-608144400,2),(142,-589392000,1),(142,-576090000,2),(142,-557942400,1),(142,-544640400,2),(142,-526492800,1),(142,-513190800,2),(142,-495043200,1),(142,-481741200,2),(142,-463593600,1),(142,-450291600,2),(142,-431539200,1),(142,-415818000,2),(142,-400089600,1),(142,-384368400,2),(142,-368640000,1),(142,-352918800,2),(142,-337190400,1),(142,-321469200,2),(142,-305740800,1),(142,-289414800,2),(142,-273686400,1),(142,-266432400,6),(142,-52938000,7),(142,-37216800,6),(142,-21488400,7),(142,-5767200,6),(142,9961200,7),(142,25682400,6),(142,41410800,7),(142,57736800,6),(142,73465200,7),(142,89186400,6),(142,104914800,7),(142,120636000,6),(142,126687600,1),(142,152089200,6),(142,162370800,7),(142,183535200,6),(142,199263600,7),(142,215589600,6),(142,230713200,7),(142,247039200,6),(142,262767600,7),(142,278488800,6),(142,294217200,7),(142,309938400,6),(142,325666800,7),(142,341388000,6),(142,357116400,7),(142,372837600,6),(142,388566000,7),(142,404892000,6),(142,420015600,7),(142,436341600,6),(142,452070000,7),(142,467791200,6),(142,483519600,7),(142,499240800,6),(142,514969200,7),(142,530690400,6),(142,544604400,7),(142,562140000,6),(142,576054000,7),(142,594194400,6),(142,607503600,7),(142,625644000,6),(142,638953200,7),(142,657093600,6),(142,671007600,7),(142,688543200,6),(142,702457200,7),(142,719992800,6),(142,733906800,7),(142,752047200,6),(142,765356400,7),(142,783496800,6),(142,796806000,7),(142,814946400,6),(142,828860400,7),(142,846396000,6),(142,860310000,7),(142,877845600,6),(142,891759600,7),(142,909295200,6),(142,923209200,7),(142,941349600,6),(142,954658800,7),(142,972799200,6),(142,986108400,7),(142,1004248800,6),(142,1018162800,7),(142,1035698400,6),(142,1049612400,7),(142,1067148000,6),(142,1081062000,7),(142,1099202400,6),(142,1112511600,7),(142,1130652000,6),(142,1143961200,7),(142,1162101600,6),(142,1173596400,7),(142,1194156000,6),(142,1205046000,7),(142,1225605600,6),(142,1236495600,7),(142,1257055200,6),(142,1268550000,7),(142,1289109600,6),(142,1299999600,7),(142,1320559200,6),(142,1331449200,7),(142,1352008800,6),(142,1362898800,7),(142,1383458400,6),(142,1394348400,7),(142,1414908000,6),(142,1425798000,7),(142,1446357600,6),(142,1457852400,7),(142,1478412000,6),(142,1489302000,7),(142,1509861600,6),(142,1520751600,7),(142,1541311200,6),(142,1552201200,7),(142,1572760800,6),(142,1583650800,7),(142,1604210400,6),(142,1615705200,7),(142,1636264800,6),(142,1647154800,7),(142,1667714400,6),(142,1678604400,7),(142,1699164000,6),(142,1710054000,7),(142,1730613600,6),(142,1741503600,7),(142,1762063200,6),(142,1772953200,7),(142,1793512800,6),(142,1805007600,7),(142,1825567200,6),(142,1836457200,7),(142,1857016800,6),(142,1867906800,7),(142,1888466400,6),(142,1899356400,7),(142,1919916000,6),(142,1930806000,7),(142,1951365600,6),(142,1962860400,7),(142,1983420000,6),(142,1994310000,7),(142,2014869600,6),(142,2025759600,7),(142,2046319200,6),(142,2057209200,7),(142,2077768800,6),(142,2088658800,7),(142,2109218400,6),(142,2120108400,7),(142,2140668000,6),(143,-2147483648,5),(143,-1633276800,1),(143,-1615136400,2),(143,-1601827200,1),(143,-1583686800,2),(143,-880214400,3),(143,-769395600,4),(143,-765392400,2),(143,-52934400,1),(143,-37213200,2),(143,-21484800,1),(143,-5763600,2),(143,9964800,1),(143,25686000,2),(143,41414400,1),(143,57740400,2),(143,73468800,1),(143,89190000,2),(143,104918400,1),(143,120639600,2),(143,126691200,1),(143,152089200,2),(143,162374400,1),(143,183538800,2),(143,199267200,1),(143,215593200,2),(143,230716800,1),(143,247042800,2),(143,262771200,1),(143,278492400,2),(143,294220800,1),(143,309942000,2),(143,325670400,1),(143,341391600,2),(143,357120000,1),(143,372841200,2),(143,388569600,1),(143,404895600,2),(143,420019200,1),(143,436345200,2),(143,452073600,1),(143,467794800,2),(143,483523200,1),(143,499244400,2),(143,514972800,1),(143,530694000,2),(143,544608000,1),(143,562143600,2),(143,576057600,1),(143,594198000,2),(143,607507200,1),(143,625647600,2),(143,638956800,1),(143,657097200,2),(143,671011200,1),(143,688546800,2),(143,702460800,1),(143,719996400,2),(143,733910400,1),(143,752050800,2),(143,765360000,1),(143,783500400,2),(143,796809600,1),(143,814950000,2),(143,828864000,1),(143,846399600,2),(143,860313600,1),(143,877849200,2),(143,891763200,1),(143,909298800,2),(143,923212800,1),(143,941353200,2),(143,954662400,1),(143,972802800,7),(143,986108400,6),(143,1004248800,7),(143,1018162800,6),(143,1035698400,7),(143,1049612400,6),(143,1067148000,7),(143,1081062000,6),(143,1099202400,7),(143,1112511600,6),(143,1130652000,7),(143,1143961200,6),(143,1162101600,7),(143,1173596400,6),(143,1194156000,7),(143,1205046000,6),(143,1225605600,7),(143,1236495600,6),(143,1257055200,7),(143,1268550000,6),(143,1289109600,7),(143,1299999600,6),(143,1320559200,7),(143,1331449200,6),(143,1352008800,7),(143,1362898800,6),(143,1383458400,7),(143,1394348400,6),(143,1414908000,7),(143,1425798000,6),(143,1446357600,7),(143,1457852400,6),(143,1478412000,7),(143,1489302000,6),(143,1509861600,7),(143,1520751600,6),(143,1541311200,7),(143,1552201200,6),(143,1572760800,7),(143,1583650800,6),(143,1604210400,7),(143,1615705200,6),(143,1636264800,7),(143,1647154800,6),(143,1667714400,7),(143,1678604400,6),(143,1699164000,7),(143,1710054000,6),(143,1730613600,7),(143,1741503600,6),(143,1762063200,7),(143,1772953200,6),(143,1793512800,7),(143,1805007600,6),(143,1825567200,7),(143,1836457200,6),(143,1857016800,7),(143,1867906800,6),(143,1888466400,7),(143,1899356400,6),(143,1919916000,7),(143,1930806000,6),(143,1951365600,7),(143,1962860400,6),(143,1983420000,7),(143,1994310000,6),(143,2014869600,7),(143,2025759600,6),(143,2046319200,7),(143,2057209200,6),(143,2077768800,7),(143,2088658800,6),(143,2109218400,7),(143,2120108400,6),(143,2140668000,7),(144,-2147483648,5),(144,-1633276800,1),(144,-1615136400,2),(144,-1601827200,1),(144,-1583686800,2),(144,-880214400,3),(144,-769395600,4),(144,-765392400,2),(144,-715795200,1),(144,-702493200,2),(144,-684345600,1),(144,-671043600,2),(144,-652896000,1),(144,-639594000,2),(144,-620841600,1),(144,-608144400,2),(144,-589392000,1),(144,-576090000,2),(144,-557942400,1),(144,-544640400,2),(144,-526492800,1),(144,-513190800,2),(144,-495043200,1),(144,-481741200,2),(144,-463593600,1),(144,-447267600,2),(144,-431539200,1),(144,-415818000,2),(144,-400089600,1),(144,-386787600,2),(144,-368640000,1),(144,-355338000,2),(144,-337190400,1),(144,-321469200,2),(144,-305740800,1),(144,-289414800,2),(144,-273686400,1),(144,-257965200,2),(144,-242236800,6),(144,-195066000,2),(144,-84384000,1),(144,-68662800,2),(144,-52934400,1),(144,-37213200,2),(144,-21484800,1),(144,-5763600,2),(144,9964800,1),(144,25686000,2),(144,41414400,1),(144,57740400,2),(144,73468800,1),(144,89190000,2),(144,104918400,1),(144,120639600,2),(144,126691200,1),(144,152089200,2),(144,162374400,1),(144,183538800,2),(144,199267200,1),(144,215593200,2),(144,230716800,1),(144,247042800,2),(144,262771200,1),(144,278492400,2),(144,294220800,1),(144,309942000,2),(144,325670400,1),(144,341391600,2),(144,357120000,1),(144,372841200,2),(144,388569600,1),(144,404895600,2),(144,420019200,1),(144,436345200,2),(144,452073600,1),(144,467794800,2),(144,483523200,1),(144,499244400,2),(144,514972800,1),(144,530694000,2),(144,544608000,1),(144,562143600,2),(144,576057600,1),(144,594198000,2),(144,607507200,1),(144,625647600,2),(144,638956800,1),(144,657097200,2),(144,671011200,1),(144,688546800,6),(144,1143961200,1),(144,1162105200,2),(144,1173600000,1),(144,1194159600,2),(144,1205049600,1),(144,1225609200,2),(144,1236499200,1),(144,1257058800,2),(144,1268553600,1),(144,1289113200,2),(144,1300003200,1),(144,1320562800,2),(144,1331452800,1),(144,1352012400,2),(144,1362902400,1),(144,1383462000,2),(144,1394352000,1),(144,1414911600,2),(144,1425801600,1),(144,1446361200,2),(144,1457856000,1),(144,1478415600,2),(144,1489305600,1),(144,1509865200,2),(144,1520755200,1),(144,1541314800,2),(144,1552204800,1),(144,1572764400,2),(144,1583654400,1),(144,1604214000,2),(144,1615708800,1),(144,1636268400,2),(144,1647158400,1),(144,1667718000,2),(144,1678608000,1),(144,1699167600,2),(144,1710057600,1),(144,1730617200,2),(144,1741507200,1),(144,1762066800,2),(144,1772956800,1),(144,1793516400,2),(144,1805011200,1),(144,1825570800,2),(144,1836460800,1),(144,1857020400,2),(144,1867910400,1),(144,1888470000,2),(144,1899360000,1),(144,1919919600,2),(144,1930809600,1),(144,1951369200,2),(144,1962864000,1),(144,1983423600,2),(144,1994313600,1),(144,2014873200,2),(144,2025763200,1),(144,2046322800,2),(144,2057212800,1),(144,2077772400,2),(144,2088662400,1),(144,2109222000,2),(144,2120112000,1),(144,2140671600,2),(145,-2147483648,1),(145,-873057600,3),(145,-769395600,2),(145,-765399600,1),(146,-2147483648,1),(146,-1205954844,2),(146,-1192307244,3),(146,2147483647,3),(147,-2147483648,1),(147,-1938538284,3),(147,-1009825200,2),(147,-1002052800,3),(147,-986756400,2),(147,-971035200,3),(147,-955306800,2),(147,-939585600,3),(147,504939600,2),(147,512712000,3),(147,536475600,2),(147,544248000,3),(147,631170000,2),(147,638942400,3),(147,757400400,2),(147,765172800,3),(147,2147483647,3),(148,-2147483648,5),(148,-1633269600,1),(148,-1615129200,2),(148,-1601820000,1),(148,-1583679600,2),(148,-880207200,3),(148,-769395600,4),(148,-765385200,2),(148,-687967140,1),(148,-662655600,2),(148,-620838000,1),(148,-608137200,2),(148,-589388400,1),(148,-576082800,2),(148,-557938800,1),(148,-544633200,2),(148,-526489200,1),(148,-513183600,2),(148,-495039600,1),(148,-481734000,2),(148,-463590000,1),(148,-450284400,2),(148,-431535600,1),(148,-418230000,2),(148,-400086000,1),(148,-386780400,2),(148,-368636400,1),(148,-355330800,2),(148,-337186800,1),(148,-323881200,2),(148,-305737200,1),(148,-292431600,2),(148,-273682800,1),(148,-260982000,2),(148,-242233200,1),(148,-226508400,2),(148,-210783600,1),(148,-195058800,2),(148,-179334000,1),(148,-163609200,2),(148,-147884400,1),(148,-131554800,2),(148,-116434800,1),(148,-100105200,2),(148,-84376800,1),(148,-68655600,2),(148,-52927200,1),(148,-37206000,2),(148,-21477600,1),(148,-5756400,2),(148,9972000,1),(148,25693200,2),(148,41421600,1),(148,57747600,2),(148,73476000,1),(148,89197200,2),(148,104925600,1),(148,120646800,2),(148,126698400,1),(148,152096400,2),(148,162381600,1),(148,183546000,2),(148,199274400,1),(148,215600400,2),(148,230724000,1),(148,247050000,2),(148,262778400,1),(148,278499600,2),(148,294228000,1),(148,309949200,2),(148,325677600,1),(148,341398800,2),(148,357127200,1),(148,372848400,2),(148,388576800,1),(148,404902800,2),(148,420026400,1),(148,436352400,2),(148,452080800,1),(148,467802000,2),(148,483530400,1),(148,499251600,2),(148,514980000,1),(148,530701200,2),(148,544615200,1),(148,562150800,2),(148,576064800,1),(148,594205200,2),(148,607514400,1),(148,625654800,2),(148,638964000,1),(148,657104400,2),(148,671018400,1),(148,688554000,2),(148,702468000,1),(148,720003600,2),(148,733917600,1),(148,752058000,2),(148,765367200,1),(148,783507600,2),(148,796816800,1),(148,814957200,2),(148,828871200,1),(148,846406800,2),(148,860320800,1),(148,877856400,2),(148,891770400,1),(148,909306000,2),(148,923220000,1),(148,941360400,2),(148,954669600,1),(148,972810000,2),(148,986119200,1),(148,1004259600,2),(148,1018173600,1),(148,1035709200,2),(148,1049623200,1),(148,1067158800,2),(148,1081072800,1),(148,1099213200,2),(148,1112522400,1),(148,1130662800,2),(148,1143972000,1),(148,1162112400,2),(148,1173607200,1),(148,1194166800,2),(148,1205056800,1),(148,1225616400,2),(148,1236506400,1),(148,1257066000,2),(148,1268560800,1),(148,1289120400,2),(148,1300010400,1),(148,1320570000,2),(148,1331460000,1),(148,1352019600,2),(148,1362909600,1),(148,1383469200,2),(148,1394359200,1),(148,1414918800,2),(148,1425808800,1),(148,1446368400,2),(148,1457863200,1),(148,1478422800,2),(148,1489312800,1),(148,1509872400,2),(148,1520762400,1),(148,1541322000,2),(148,1552212000,1),(148,1572771600,2),(148,1583661600,1),(148,1604221200,2),(148,1615716000,1),(148,1636275600,2),(148,1647165600,1),(148,1667725200,2),(148,1678615200,1),(148,1699174800,2),(148,1710064800,1),(148,1730624400,2),(148,1741514400,1),(148,1762074000,2),(148,1772964000,1),(148,1793523600,2),(148,1805018400,1),(148,1825578000,2),(148,1836468000,1),(148,1857027600,2),(148,1867917600,1),(148,1888477200,2),(148,1899367200,1),(148,1919926800,2),(148,1930816800,1),(148,1951376400,2),(148,1962871200,1),(148,1983430800,2),(148,1994320800,1),(148,2014880400,2),(148,2025770400,1),(148,2046330000,2),(148,2057220000,1),(148,2077779600,2),(148,2088669600,1),(148,2109229200,2),(148,2120119200,1),(148,2140678800,2),(149,-2147483648,3),(149,-1633276800,1),(149,-1615136400,2),(149,-1601827200,1),(149,-1583686800,2),(149,-1535904000,1),(149,-1525280400,2),(149,-905097600,1),(149,-891795600,2),(149,-880214400,4),(149,-769395600,5),(149,-765392400,2),(149,-747251940,1),(149,-744224400,2),(149,-620841600,1),(149,-608144400,2),(149,-589392000,1),(149,-576090000,2),(149,-557942400,1),(149,-544640400,2),(149,-526492800,1),(149,-513190800,2),(149,-495043200,1),(149,-481741200,2),(149,-463593600,1),(149,-450291600,2),(149,-431539200,1),(149,-415818000,2),(149,-400089600,1),(149,-384368400,2),(149,-368640000,1),(149,-352918800,2),(149,-337190400,1),(149,-321469200,2),(149,-305740800,1),(149,-289414800,2),(149,-273686400,1),(149,-266432400,6),(149,-52938000,7),(149,-37216800,6),(149,-21488400,7),(149,-5767200,6),(149,9961200,7),(149,25682400,6),(149,41410800,7),(149,57736800,6),(149,73465200,7),(149,89186400,6),(149,104914800,7),(149,120636000,6),(149,126687600,1),(149,152089200,6),(149,162370800,7),(149,183535200,6),(149,199263600,7),(149,215589600,6),(149,230713200,7),(149,247039200,6),(149,262767600,7),(149,278488800,6),(149,294217200,7),(149,309938400,6),(149,325666800,7),(149,341388000,6),(149,357116400,7),(149,372837600,6),(149,388566000,7),(149,404892000,6),(149,420015600,7),(149,436341600,6),(149,452070000,7),(149,467791200,6),(149,483519600,7),(149,499240800,6),(149,514969200,7),(149,530690400,6),(149,544604400,7),(149,562140000,6),(149,576054000,7),(149,594194400,6),(149,607503600,7),(149,625644000,6),(149,638953200,7),(149,657093600,6),(149,671007600,7),(149,688543200,6),(149,702457200,7),(149,719992800,6),(149,733906800,7),(149,752047200,6),(149,765356400,7),(149,783496800,6),(149,796806000,7),(149,814946400,6),(149,828860400,7),(149,846396000,6),(149,860310000,7),(149,877845600,6),(149,891759600,7),(149,909295200,6),(149,923209200,7),(149,941349600,6),(149,954658800,7),(149,972799200,6),(149,986108400,7),(149,1004248800,6),(149,1018162800,7),(149,1035698400,6),(149,1049612400,7),(149,1067148000,6),(149,1081062000,7),(149,1099202400,6),(149,1112511600,7),(149,1130652000,6),(149,1143961200,7),(149,1162101600,6),(149,1173596400,7),(149,1194156000,6),(149,1205046000,7),(149,1225605600,6),(149,1236495600,7),(149,1257055200,6),(149,1268550000,7),(149,1289109600,6),(149,1299999600,7),(149,1320559200,6),(149,1331449200,7),(149,1352008800,6),(149,1362898800,7),(149,1383458400,6),(149,1394348400,7),(149,1414908000,6),(149,1425798000,7),(149,1446357600,6),(149,1457852400,7),(149,1478412000,6),(149,1489302000,7),(149,1509861600,6),(149,1520751600,7),(149,1541311200,6),(149,1552201200,7),(149,1572760800,6),(149,1583650800,7),(149,1604210400,6),(149,1615705200,7),(149,1636264800,6),(149,1647154800,7),(149,1667714400,6),(149,1678604400,7),(149,1699164000,6),(149,1710054000,7),(149,1730613600,6),(149,1741503600,7),(149,1762063200,6),(149,1772953200,7),(149,1793512800,6),(149,1805007600,7),(149,1825567200,6),(149,1836457200,7),(149,1857016800,6),(149,1867906800,7),(149,1888466400,6),(149,1899356400,7),(149,1919916000,6),(149,1930806000,7),(149,1951365600,6),(149,1962860400,7),(149,1983420000,6),(149,1994310000,7),(149,2014869600,6),(149,2025759600,7),(149,2046319200,6),(149,2057209200,7),(149,2077768800,6),(149,2088658800,7),(149,2109218400,6),(149,2120108400,7),(149,2140668000,6),(150,-2147483648,1),(150,-873057600,3),(150,-769395600,2),(150,-765399600,1),(151,-2147483648,0),(151,-1767217028,2),(151,-1206957600,1),(151,-1191362400,2),(151,-1175374800,1),(151,-1159826400,2),(151,-633819600,1),(151,-622069200,2),(151,-602283600,1),(151,-591832800,2),(151,-570747600,1),(151,-560210400,2),(151,-539125200,1),(151,-531352800,2),(151,-191365200,1),(151,-184197600,2),(151,-155163600,1),(151,-150069600,2),(151,-128898000,1),(151,-121125600,2),(151,-99954000,1),(151,-89589600,2),(151,-68418000,1),(151,-57967200,2),(151,499748400,1),(151,511236000,2),(151,530593200,1),(151,540266400,2),(151,562129200,1),(151,571197600,2),(151,592974000,1),(151,602042400,2),(151,624423600,1),(151,634701600,2),(151,813726000,1),(151,824004000,2),(151,938919600,1),(151,951616800,2),(151,970974000,1),(151,972180000,2),(151,1003028400,1),(151,1013911200,2),(151,2147483647,2),(152,-2147483648,1),(152,-1121105688,2),(152,105084000,3),(152,161758800,2),(152,290584800,4),(152,299134800,2),(152,322034400,4),(152,330584400,2),(152,694260000,3),(152,717310800,2),(152,725868000,3),(152,852094800,2),(152,1113112800,4),(152,1128229200,2),(152,1146384000,4),(152,1159682400,2),(153,-2147483648,0),(153,-1767211196,2),(153,-1206954000,1),(153,-1191358800,2),(153,-1175371200,1),(153,-1159822800,2),(153,-633816000,1),(153,-622065600,2),(153,-602280000,1),(153,-591829200,2),(153,-570744000,1),(153,-560206800,2),(153,-539121600,1),(153,-531349200,2),(153,-191361600,1),(153,-184194000,2),(153,-155160000,1),(153,-150066000,2),(153,-128894400,1),(153,-121122000,2),(153,-99950400,1),(153,-89586000,2),(153,-68414400,1),(153,-57963600,2),(153,499752000,1),(153,511239600,2),(153,530596800,1),(153,540270000,2),(153,562132800,1),(153,571201200,2),(153,750830400,1),(153,761713200,2),(153,2147483647,2),(154,-2147483648,1),(154,-873057600,3),(154,-769395600,2),(154,-765399600,1),(155,-2147483648,1),(155,-1851537340,2),(155,323841600,3),(155,338958000,2),(156,-2147483648,0),(156,-1514743200,1),(156,568015200,3),(156,576057600,2),(156,594198000,3),(156,828864000,2),(156,846399600,3),(156,860313600,2),(156,877849200,3),(156,891763200,2),(156,909298800,3),(156,923212800,2),(156,941353200,3),(156,954662400,2),(156,972802800,3),(156,989136000,2),(156,1001833200,3),(156,1018166400,2),(156,1035702000,3),(156,1049616000,2),(156,1067151600,3),(156,1081065600,2),(156,1099206000,3),(156,1112515200,2),(156,1130655600,3),(156,1143964800,2),(156,1162105200,3),(156,1175414400,2),(156,1193554800,3),(156,1207468800,2),(156,1225004400,3),(156,1238918400,2),(156,1256454000,3),(156,1268553600,2),(156,1289113200,3),(156,1300003200,2),(156,1320562800,3),(156,1331452800,2),(156,1352012400,3),(156,1362902400,2),(156,1383462000,3),(156,1394352000,2),(156,1414911600,3),(156,1425801600,2),(156,1446361200,3),(156,1457856000,2),(156,1478415600,3),(156,1489305600,2),(156,1509865200,3),(156,1520755200,2),(156,1541314800,3),(156,1552204800,2),(156,1572764400,3),(156,1583654400,2),(156,1604214000,3),(156,1615708800,2),(156,1636268400,3),(156,1647158400,2),(156,1667718000,3),(156,1678608000,2),(156,1699167600,3),(156,1710057600,2),(156,1730617200,3),(156,1741507200,2),(156,1762066800,3),(156,1772956800,2),(156,1793516400,3),(156,1805011200,2),(156,1825570800,3),(156,1836460800,2),(156,1857020400,3),(156,1867910400,2),(156,1888470000,3),(156,1899360000,2),(156,1919919600,3),(156,1930809600,2),(156,1951369200,3),(156,1962864000,2),(156,1983423600,3),(156,1994313600,2),(156,2014873200,3),(156,2025763200,2),(156,2046322800,3),(156,2057212800,2),(156,2077772400,3),(156,2088662400,2),(156,2109222000,3),(156,2120112000,2),(156,2140671600,3),(157,-2147483648,0),(157,-1514739600,1),(157,-1343066400,2),(157,-1234807200,4),(157,-1220292000,3),(157,-1207159200,4),(157,-1191344400,2),(157,-873828000,4),(157,-661539600,5),(157,28800,4),(157,828867600,3),(157,846403200,4),(157,860317200,3),(157,877852800,4),(157,891766800,3),(157,909302400,4),(157,923216400,3),(157,941356800,4),(157,954666000,3),(157,972806400,4),(157,989139600,3),(157,1001836800,4),(157,1018170000,3),(157,1035705600,4),(157,1049619600,3),(157,1067155200,4),(157,1081069200,3),(157,1099209600,4),(157,1112518800,3),(157,1130659200,4),(157,1143968400,3),(157,1162108800,4),(157,1175418000,3),(157,1193558400,4),(157,1207472400,3),(157,1225008000,4),(157,1238922000,3),(157,1256457600,4),(157,1270371600,3),(157,1288512000,4),(157,1301821200,3),(157,1319961600,4),(157,1333270800,3),(157,1351411200,4),(157,1365325200,3),(157,1382860800,4),(157,1396774800,3),(157,1414310400,4),(157,1428224400,3),(157,1445760000,4),(157,1459674000,3),(157,1477814400,4),(157,1491123600,3),(157,1509264000,4),(157,1522573200,3),(157,1540713600,4),(157,1554627600,3),(157,1572163200,4),(157,1586077200,3),(157,1603612800,4),(157,1617526800,3),(157,1635667200,4),(157,1648976400,3),(157,1667116800,4),(158,-2147483648,1),(158,-1567453392,2),(158,-1233432000,3),(158,-1222981200,2),(158,-1205956800,3),(158,-1194037200,2),(158,-1172865600,3),(158,-1162501200,2),(158,-1141329600,3),(158,-1130965200,2),(158,-1109793600,3),(158,-1099429200,2),(158,-1078257600,3),(158,-1067806800,2),(158,-1046635200,3),(158,-1036270800,2),(158,-1015099200,3),(158,-1004734800,2),(158,-983563200,3),(158,-973198800,2),(158,-952027200,3),(158,-941576400,2),(158,-931032000,3),(158,-900882000,2),(158,-890337600,3),(158,-833749200,2),(158,-827265600,3),(158,-752274000,2),(158,-733780800,3),(158,-197326800,2),(158,-190843200,3),(158,-184194000,2),(158,-164491200,3),(158,-152658000,2),(158,-132955200,3),(158,-121122000,2),(158,-101419200,3),(158,-86821200,2),(158,-71092800,3),(158,-54766800,2),(158,-39038400,3),(158,-23317200,2),(158,-7588800,5),(158,128142000,4),(158,136605600,5),(158,596948400,4),(158,605066400,5),(158,624423600,4),(158,636516000,2),(158,655963200,3),(158,667796400,2),(158,687499200,3),(158,699418800,2),(158,719380800,4),(158,731469600,5),(158,938919600,3),(158,952052400,5),(158,1085281200,2),(158,1096171200,5),(158,1198983600,4),(158,1205632800,5),(158,2147483647,5),(159,-2147483648,2),(159,-1633276800,1),(159,-1615136400,2),(159,-1601827200,1),(159,-1583686800,2),(159,-880214400,3),(159,-769395600,4),(159,-765392400,2),(159,-747244800,1),(159,-733942800,2),(159,-116438400,1),(159,-100112400,2),(159,-21484800,5),(159,104914800,1),(159,120639600,2),(159,126691200,1),(159,152089200,2),(159,162374400,1),(159,183538800,2),(159,199267200,1),(159,215593200,2),(159,230716800,1),(159,247042800,2),(159,262771200,1),(159,278492400,2),(159,294220800,1),(159,309942000,2),(159,325670400,1),(159,341391600,2),(159,357120000,1),(159,372841200,2),(159,388569600,1),(159,404895600,2),(159,420019200,1),(159,436345200,2),(159,452073600,1),(159,467794800,2),(159,483523200,1),(159,499244400,2),(159,514972800,1),(159,530694000,2),(159,544608000,1),(159,562143600,2),(159,576057600,1),(159,594198000,2),(159,607507200,1),(159,625647600,2),(159,638956800,1),(159,657097200,2),(159,671011200,1),(159,688546800,2),(159,702460800,1),(159,719996400,2),(159,733910400,1),(159,752050800,2),(159,765360000,1),(159,783500400,2),(159,796809600,1),(159,814950000,2),(159,828864000,1),(159,846399600,2),(159,860313600,1),(159,877849200,2),(159,891763200,1),(159,909298800,2),(159,923212800,1),(159,941353200,2),(159,954662400,1),(159,972802800,2),(159,986112000,1),(159,1004252400,2),(159,1018166400,1),(159,1035702000,2),(159,1049616000,1),(159,1067151600,2),(159,1081065600,1),(159,1099206000,2),(159,1112515200,1),(159,1130655600,2),(159,1143964800,1),(159,1162105200,2),(159,1173600000,1),(159,1194159600,2),(159,1205049600,1),(159,1225609200,2),(159,1236499200,1),(159,1257058800,2),(159,1268553600,1),(159,1289113200,2),(159,1300003200,1),(159,1320562800,2),(159,1331452800,1),(159,1352012400,2),(159,1362902400,1),(159,1383462000,2),(159,1394352000,1),(159,1414911600,2),(159,1425801600,1),(159,1446361200,2),(159,1457856000,1),(159,1478415600,2),(159,1489305600,1),(159,1509865200,2),(159,1520755200,1),(159,1541314800,2),(159,1552204800,1),(159,1572764400,2),(159,1583654400,1),(159,1604214000,2),(159,1615708800,1),(159,1636268400,2),(159,1647158400,1),(159,1667718000,2),(159,1678608000,1),(159,1699167600,2),(159,1710057600,1),(159,1730617200,2),(159,1741507200,1),(159,1762066800,2),(159,1772956800,1),(159,1793516400,2),(159,1805011200,1),(159,1825570800,2),(159,1836460800,1),(159,1857020400,2),(159,1867910400,1),(159,1888470000,2),(159,1899360000,1),(159,1919919600,2),(159,1930809600,1),(159,1951369200,2),(159,1962864000,1),(159,1983423600,2),(159,1994313600,1),(159,2014873200,2),(159,2025763200,1),(159,2046322800,2),(159,2057212800,1),(159,2077772400,2),(159,2088662400,1),(159,2109222000,2),(159,2120112000,1),(159,2140671600,2),(160,-2147483648,0),(160,-1514743200,1),(160,377935200,2),(160,407653200,4),(160,828864000,3),(160,846399600,4),(160,860313600,3),(160,877849200,4),(160,891763200,3),(160,909298800,4),(160,923212800,3),(160,941353200,4),(160,954662400,3),(160,972802800,4),(160,989136000,3),(160,1001833200,4),(160,1018166400,3),(160,1035702000,4),(160,1049616000,3),(160,1067151600,4),(160,1081065600,3),(160,1099206000,4),(160,1112515200,3),(160,1130655600,4),(160,1143964800,3),(160,1162105200,4),(160,1175414400,3),(160,1193554800,4),(160,1207468800,3),(160,1225004400,4),(160,1238918400,3),(160,1256454000,4),(160,1270368000,3),(160,1288508400,4),(160,1301817600,3),(160,1319958000,4),(160,1333267200,3),(160,1351407600,4),(160,1365321600,3),(160,1382857200,4),(160,1396771200,3),(160,1414306800,4),(160,1428220800,3),(160,1445756400,4),(160,1459670400,3),(160,1477810800,4),(160,1491120000,3),(160,1509260400,4),(160,1522569600,3),(160,1540710000,4),(160,1554624000,3),(160,1572159600,4),(160,1586073600,3),(160,1603609200,4),(160,1617523200,3),(160,1635663600,4),(160,1648972800,3),(160,1667113200,4),(161,-2147483648,1),(161,-880207200,2),(161,-769395600,3),(161,-765385200,1),(161,-21477600,4),(161,-5756400,1),(161,9972000,4),(161,25693200,1),(161,41421600,4),(161,57747600,1),(161,73476000,4),(161,89197200,1),(161,104925600,4),(161,120646800,1),(161,126698400,4),(161,152096400,1),(161,162381600,4),(161,183546000,1),(161,199274400,4),(161,215600400,1),(161,230724000,4),(161,247050000,1),(161,262778400,4),(161,278499600,1),(161,294228000,4),(161,309949200,1),(161,325677600,4),(161,341398800,1),(161,357127200,4),(161,372848400,1),(161,388576800,4),(161,404902800,1),(161,420026400,4),(161,436352400,1),(161,1446372000,5),(161,1457866800,6),(161,1478426400,5),(161,1489316400,6),(161,1509876000,5),(161,1520766000,6),(161,1541325600,1),(161,1547978400,5),(161,1552215600,6),(161,1572775200,5),(161,1583665200,6),(161,1604224800,5),(161,1615719600,6),(161,1636279200,5),(161,1647169200,6),(161,1667728800,5),(161,1678618800,6),(161,1699178400,5),(161,1710068400,6),(161,1730628000,5),(161,1741518000,6),(161,1762077600,5),(161,1772967600,6),(161,1793527200,5),(161,1805022000,6),(161,1825581600,5),(161,1836471600,6),(161,1857031200,5),(161,1867921200,6),(161,1888480800,5),(161,1899370800,6),(161,1919930400,5),(161,1930820400,6),(161,1951380000,5),(161,1962874800,6),(161,1983434400,5),(161,1994324400,6),(161,2014884000,5),(161,2025774000,6),(161,2046333600,5),(161,2057223600,6),(161,2077783200,5),(161,2088673200,6),(161,2109232800,5),(161,2120122800,6),(161,2140682400,5),(162,-2147483648,0),(162,-1514739600,1),(162,-1343066400,2),(162,-1234807200,4),(162,-1220292000,3),(162,-1207159200,4),(162,-1191344400,2),(162,-975261600,5),(162,-963169200,2),(162,-917114400,5),(162,-907354800,2),(162,-821901600,6),(162,-810068400,2),(162,-627501600,5),(162,-612990000,2),(162,828864000,5),(162,846399600,2),(162,860313600,5),(162,877849200,2),(162,891763200,5),(162,909298800,2),(162,923212800,5),(162,941353200,2),(162,954662400,5),(162,972802800,2),(162,989136000,5),(162,1001833200,2),(162,1018166400,5),(162,1035702000,2),(162,1049616000,5),(162,1067151600,2),(162,1081065600,5),(162,1099206000,2),(162,1112515200,5),(162,1130655600,2),(162,1143964800,5),(162,1162105200,2),(162,1175414400,5),(162,1193554800,2),(162,1207468800,5),(162,1225004400,2),(162,1238918400,5),(162,1256454000,2),(162,1270368000,5),(162,1288508400,2),(162,1301817600,5),(162,1319958000,2),(162,1333267200,5),(162,1351407600,2),(162,1365321600,5),(162,1382857200,2),(162,1396771200,5),(162,1414306800,2),(162,1428220800,5),(162,1445756400,2),(162,1459670400,5),(162,1477810800,2),(162,1491120000,5),(162,1509260400,2),(162,1522569600,5),(162,1540710000,2),(162,1554624000,5),(162,1572159600,2),(162,1586073600,5),(162,1603609200,2),(162,1617523200,5),(162,1635663600,2),(162,1648972800,5),(162,1667113200,2),(163,-2147483648,0),(163,-1850328920,1),(163,326001600,2),(163,544597200,3),(163,562132800,2),(163,576046800,3),(163,594187200,2),(163,607496400,3),(163,625636800,2),(163,638946000,3),(163,657086400,2),(163,671000400,3),(163,688536000,2),(163,702450000,3),(163,719985600,2),(163,733899600,3),(163,752040000,2),(163,765349200,3),(163,783489600,2),(163,796798800,3),(163,814939200,2),(163,828853200,3),(163,846388800,2),(163,860302800,3),(163,877838400,2),(163,891752400,3),(163,909288000,2),(163,923202000,3),(163,941342400,2),(163,954651600,3),(163,972792000,2),(163,986101200,3),(163,1004241600,2),(163,1018155600,3),(163,1035691200,2),(163,1049605200,3),(163,1067140800,2),(163,1081054800,3),(163,1099195200,2),(163,1112504400,3),(163,1130644800,2),(163,1143954000,3),(163,1162094400,2),(163,1173589200,3),(163,1194148800,2),(163,1205038800,3),(163,1225598400,2),(163,1236488400,3),(163,1257048000,2),(163,1268542800,3),(163,1289102400,2),(163,1299992400,3),(163,1320552000,2),(163,1331442000,3),(163,1352001600,2),(163,1362891600,3),(163,1383451200,2),(163,1394341200,3),(163,1414900800,2),(163,1425790800,3),(163,1446350400,2),(163,1457845200,3),(163,1478404800,2),(163,1489294800,3),(163,1509854400,2),(163,1520744400,3),(163,1541304000,2),(163,1552194000,3),(163,1572753600,2),(163,1583643600,3),(163,1604203200,2),(163,1615698000,3),(163,1636257600,2),(163,1647147600,3),(163,1667707200,2),(163,1678597200,3),(163,1699156800,2),(163,1710046800,3),(163,1730606400,2),(163,1741496400,3),(163,1762056000,2),(163,1772946000,3),(163,1793505600,2),(163,1805000400,3),(163,1825560000,2),(163,1836450000,3),(163,1857009600,2),(163,1867899600,3),(163,1888459200,2),(163,1899349200,3),(163,1919908800,2),(163,1930798800,3),(163,1951358400,2),(163,1962853200,3),(163,1983412800,2),(163,1994302800,3),(163,2014862400,2),(163,2025752400,3),(163,2046312000,2),(163,2057202000,3),(163,2077761600,2),(163,2088651600,3),(163,2109211200,2),(163,2120101200,3),(163,2140660800,2),(163,2147483647,2),(164,-2147483648,1),(164,-2131642800,3),(164,-1632074400,2),(164,-1615143600,3),(164,-1153681200,2),(164,-1145822400,3),(164,-1122231600,2),(164,-1114372800,3),(164,-1090782000,2),(164,-1082923200,3),(164,-1059332400,2),(164,-1051473600,3),(164,-1027882800,2),(164,-1020024000,3),(164,-996433200,2),(164,-988574400,3),(164,-965674800,2),(164,-955396800,3),(164,-934743600,2),(164,-923947200,3),(164,-904503600,2),(164,-891892800,3),(164,-880221600,4),(164,-769395600,5),(164,-765399600,3),(164,-747252000,2),(164,-733950000,3),(164,-715802400,2),(164,-702500400,3),(164,-684352800,2),(164,-671050800,3),(164,-652903200,2),(164,-639601200,3),(164,-620848800,2),(164,-608151600,3),(164,-589399200,2),(164,-576097200,3),(164,-557949600,2),(164,-544647600,3),(164,-526500000,2),(164,-513198000,3),(164,-495050400,2),(164,-481748400,3),(164,-463600800,2),(164,-450298800,3),(164,-431546400,2),(164,-418244400,3),(164,-400096800,2),(164,-384375600,3),(164,-368647200,2),(164,-352926000,3),(164,-337197600,2),(164,-321476400,3),(164,-305748000,2),(164,-289422000,3),(164,-273693600,2),(164,-257972400,3),(164,-242244000,2),(164,-226522800,3),(164,-210794400,2),(164,-195073200,3),(164,-179344800,2),(164,-163623600,3),(164,-147895200,2),(164,-131569200,3),(164,-116445600,2),(164,-100119600,3),(164,-84391200,2),(164,-68670000,3),(164,-52941600,2),(164,-37220400,3),(164,-21492000,2),(164,-5770800,3),(164,9957600,2),(164,25678800,3),(164,41407200,2),(164,57733200,3),(164,73461600,2),(164,89182800,3),(164,136360800,2),(164,152082000,3),(164,167810400,2),(164,183531600,3),(164,199260000,2),(164,215586000,3),(164,230709600,2),(164,247035600,3),(164,262764000,2),(164,278485200,3),(164,294213600,2),(164,309934800,3),(164,325663200,2),(164,341384400,3),(164,357112800,2),(164,372834000,3),(164,388562400,2),(164,404888400,3),(164,420012000,2),(164,436338000,3),(164,452066400,2),(164,467787600,3),(164,483516000,2),(164,499237200,3),(164,514965600,2),(164,530686800,3),(164,544600800,2),(164,562136400,3),(164,576050400,2),(164,594190800,3),(164,607500000,2),(164,625640400,3),(164,638949600,2),(164,657090000,3),(164,671004000,2),(164,688539600,3),(164,702453600,2),(164,719989200,3),(164,733896060,2),(164,752036460,3),(164,765345660,2),(164,783486060,3),(164,796795260,2),(164,814935660,3),(164,828849660,2),(164,846385260,3),(164,860299260,2),(164,877834860,3),(164,891748860,2),(164,909284460,3),(164,923198460,2),(164,941338860,3),(164,954648060,2),(164,972788460,3),(164,986097660,2),(164,1004238060,3),(164,1018152060,2),(164,1035687660,3),(164,1049601660,2),(164,1067137260,3),(164,1081051260,2),(164,1099191660,3),(164,1112500860,2),(164,1130641260,3),(164,1143950460,2),(164,1162090860,3),(164,1173592800,2),(164,1194152400,3),(164,1205042400,2),(164,1225602000,3),(164,1236492000,2),(164,1257051600,3),(164,1268546400,2),(164,1289106000,3),(164,1299996000,2),(164,1320555600,3),(164,1331445600,2),(164,1352005200,3),(164,1362895200,2),(164,1383454800,3),(164,1394344800,2),(164,1414904400,3),(164,1425794400,2),(164,1446354000,3),(164,1457848800,2),(164,1478408400,3),(164,1489298400,2),(164,1509858000,3),(164,1520748000,2),(164,1541307600,3),(164,1552197600,2),(164,1572757200,3),(164,1583647200,2),(164,1604206800,3),(164,1615701600,2),(164,1636261200,3),(164,1647151200,2),(164,1667710800,3),(164,1678600800,2),(164,1699160400,3),(164,1710050400,2),(164,1730610000,3),(164,1741500000,2),(164,1762059600,3),(164,1772949600,2),(164,1793509200,3),(164,1805004000,2),(164,1825563600,3),(164,1836453600,2),(164,1857013200,3),(164,1867903200,2),(164,1888462800,3),(164,1899352800,2),(164,1919912400,3),(164,1930802400,2),(164,1951362000,3),(164,1962856800,2),(164,1983416400,3),(164,1994306400,2),(164,2014866000,3),(164,2025756000,2),(164,2046315600,3),(164,2057205600,2),(164,2077765200,3),(164,2088655200,2),(164,2109214800,3),(164,2120104800,2),(164,2140664400,3),(165,-2147483648,0),(165,-1514743200,1),(165,568015200,3),(165,576057600,2),(165,594198000,3),(165,828864000,2),(165,846399600,3),(165,860313600,2),(165,877849200,3),(165,891763200,2),(165,909298800,3),(165,923212800,2),(165,941353200,3),(165,954662400,2),(165,972802800,3),(165,989136000,2),(165,1001833200,3),(165,1018166400,2),(165,1035702000,3),(165,1049616000,2),(165,1067151600,3),(165,1081065600,2),(165,1099206000,3),(165,1112515200,2),(165,1130655600,3),(165,1143964800,2),(165,1162105200,3),(165,1175414400,2),(165,1193554800,3),(165,1207468800,2),(165,1225004400,3),(165,1238918400,2),(165,1256454000,3),(165,1270368000,2),(165,1288508400,3),(165,1301817600,2),(165,1319958000,3),(165,1333267200,2),(165,1351407600,3),(165,1365321600,2),(165,1382857200,3),(165,1396771200,2),(165,1414306800,3),(165,1428220800,2),(165,1445756400,3),(165,1459670400,2),(165,1477810800,3),(165,1491120000,2),(165,1509260400,3),(165,1522569600,2),(165,1540710000,3),(165,1554624000,2),(165,1572159600,3),(165,1586073600,2),(165,1603609200,3),(165,1617523200,2),(165,1635663600,3),(165,1648972800,2),(165,1667113200,3),(166,-2147483648,0),(166,-1942690509,1),(166,-1567455309,2),(166,-1459627200,4),(166,-1443819600,3),(166,-1428006600,4),(166,-1412283600,3),(166,-1396470600,4),(166,-1380747600,3),(166,-1141590600,4),(166,-1128286800,3),(166,-1110141000,4),(166,-1096837200,3),(166,-1078691400,4),(166,-1065387600,3),(166,-1047241800,4),(166,-1033938000,3),(166,-1015187400,4),(166,-1002488400,3),(166,-983737800,4),(166,-971038800,3),(166,-954707400,4),(166,-938984400,3),(166,-920838600,4),(166,-907534800,3),(166,-896819400,4),(166,-853621200,6),(166,-845847000,5),(166,-334789200,6),(166,-319671000,5),(166,-314226000,7),(166,-309996000,5),(166,-149720400,7),(166,-134604000,5),(166,-50446800,6),(166,-34205400,5),(166,9860400,7),(166,14176800,5),(166,72846000,7),(166,80100000,5),(166,127278000,8),(166,132111000,6),(166,147234600,5),(166,156913200,7),(166,165376800,5),(166,219812400,7),(166,226461600,5),(166,250052400,7),(166,257911200,5),(166,282711600,7),(166,289360800,5),(166,294202800,7),(166,322020000,5),(166,566449200,7),(166,573012000,5),(166,597812400,7),(166,605066400,5),(166,625633200,7),(166,635911200,5),(166,656478000,7),(166,667965600,5),(166,688532400,7),(166,699415200,5),(166,719377200,7),(166,730864800,5),(166,1095562800,7),(166,1111896000,5),(166,1128834000,7),(166,1142136000,5),(166,1159678800,7),(166,1173585600,5),(166,1191733200,7),(166,1205035200,5),(166,1223182800,7),(166,1236484800,5),(166,1254632400,7),(166,1268539200,5),(166,1286082000,7),(166,1299988800,5),(166,1317531600,7),(166,1331438400,5),(166,1349586000,7),(166,1362888000,5),(166,1381035600,7),(166,1394337600,5),(166,1412485200,7),(166,1425787200,5),(166,2147483647,5),(167,-2147483648,2),(167,-1632070800,1),(167,-1615140000,2),(167,-1601753400,1),(167,-1583697600,2),(167,-1567357200,1),(167,-1554667200,2),(167,-1534698000,1),(167,-1524074400,2),(167,-1503248400,1),(167,-1492365600,2),(167,-1471798800,1),(167,-1460916000,2),(167,-1440954000,1),(167,-1428861600,2),(167,-1409504400,1),(167,-1397412000,2),(167,-1378054800,1),(167,-1365962400,2),(167,-1346605200,1),(167,-1333908000,2),(167,-1315155600,1),(167,-1301853600,2),(167,-1283706000,1),(167,-1270404000,2),(167,-1252256400,1),(167,-1238954400,2),(167,-1220806800,1),(167,-1207504800,2),(167,-1188752400,1),(167,-1176055200,2),(167,-1157302800,1),(167,-1144000800,2),(167,-1125853200,1),(167,-1112551200,2),(167,-1094403600,1),(167,-1081101600,2),(167,-1062954000,1),(167,-1049652000,2),(167,-1031504400,1),(167,-1018202400,2),(167,-1000054800,1),(167,-986752800,2),(167,-968000400,1),(167,-955303200,2),(167,-936550800,1),(167,-880218000,3),(167,-769395600,4),(167,-765396000,2),(167,-747248400,1),(167,-733946400,2),(167,-715806000,1),(167,-702504000,2),(167,-684356400,1),(167,-671054400,2),(167,-652906800,1),(167,-634161600,2),(167,-620845200,1),(167,-602704800,2),(167,-589395600,1),(167,-576093600,2),(167,-557946000,1),(167,-544644000,2),(167,-526496400,1),(167,-513194400,2),(167,-495046800,1),(167,-481744800,2),(167,-463597200,1),(167,-450295200,2),(167,-431542800,1),(167,-418240800,2),(167,-400093200,1),(167,-384372000,2),(167,-368643600,1),(167,-352922400,2),(167,-337194000,1),(167,-321472800,2),(167,-305744400,1),(167,-289418400,2),(167,-273690000,1),(167,-257968800,2),(167,-242240400,1),(167,-226519200,2),(167,-210790800,1),(167,-195069600,2),(167,-179341200,1),(167,-163620000,2),(167,-147891600,1),(167,-131565600,2),(167,-116442000,1),(167,-100116000,2),(167,-84387600,1),(167,-68666400,2),(167,-52938000,1),(167,-37216800,2),(167,-21488400,1),(167,-5767200,2),(167,9961200,1),(167,25682400,2),(167,41410800,1),(167,57736800,2),(167,73465200,1),(167,89186400,2),(167,104914800,1),(167,120636000,2),(167,136364400,1),(167,152085600,2),(167,167814000,1),(167,183535200,2),(167,199263600,1),(167,215589600,2),(167,230713200,1),(167,247039200,2),(167,262767600,1),(167,278488800,2),(167,294217200,1),(167,309938400,2),(167,325666800,1),(167,341388000,2),(167,357116400,1),(167,372837600,2),(167,388566000,1),(167,404892000,2),(167,420015600,1),(167,436341600,2),(167,452070000,1),(167,467791200,2),(167,483519600,1),(167,499240800,2),(167,514969200,1),(167,530690400,2),(167,544604400,1),(167,562140000,2),(167,576054000,1),(167,594194400,2),(167,607503600,1),(167,625644000,2),(167,638953200,1),(167,657093600,2),(167,671007600,1),(167,688543200,2),(167,702457200,1),(167,719992800,2),(167,733906800,1),(167,752047200,2),(167,765356400,1),(167,783496800,2),(167,796806000,1),(167,814946400,2),(167,828860400,1),(167,846396000,2),(167,860310000,1),(167,877845600,2),(167,891759600,1),(167,909295200,2),(167,923209200,1),(167,941349600,2),(167,954658800,1),(167,972799200,2),(167,986108400,1),(167,1004248800,2),(167,1018162800,1),(167,1035698400,2),(167,1049612400,1),(167,1067148000,2),(167,1081062000,1),(167,1099202400,2),(167,1112511600,1),(167,1130652000,2),(167,1143961200,1),(167,1162101600,2),(167,1173596400,1),(167,1194156000,2),(167,1205046000,1),(167,1225605600,2),(167,1236495600,1),(167,1257055200,2),(167,1268550000,1),(167,1289109600,2),(167,1299999600,1),(167,1320559200,2),(167,1331449200,1),(167,1352008800,2),(167,1362898800,1),(167,1383458400,2),(167,1394348400,1),(167,1414908000,2),(167,1425798000,1),(167,1446357600,2),(167,1457852400,1),(167,1478412000,2),(167,1489302000,1),(167,1509861600,2),(167,1520751600,1),(167,1541311200,2),(167,1552201200,1),(167,1572760800,2),(167,1583650800,1),(167,1604210400,2),(167,1615705200,1),(167,1636264800,2),(167,1647154800,1),(167,1667714400,2),(167,1678604400,1),(167,1699164000,2),(167,1710054000,1),(167,1730613600,2),(167,1741503600,1),(167,1762063200,2),(167,1772953200,1),(167,1793512800,2),(167,1805007600,1),(167,1825567200,2),(167,1836457200,1),(167,1857016800,2),(167,1867906800,1),(167,1888466400,2),(167,1899356400,1),(167,1919916000,2),(167,1930806000,1),(167,1951365600,2),(167,1962860400,1),(167,1983420000,2),(167,1994310000,1),(167,2014869600,2),(167,2025759600,1),(167,2046319200,2),(167,2057209200,1),(167,2077768800,2),(167,2088658800,1),(167,2109218400,2),(167,2120108400,1),(167,2140668000,2),(168,-2147483648,1),(168,-873057600,3),(168,-769395600,2),(168,-765399600,1),(169,-2147483648,2),(169,-1632070800,1),(169,-1615140000,2),(169,-1601753400,1),(169,-1583697600,2),(169,-1567357200,1),(169,-1554667200,2),(169,-1534698000,1),(169,-1524074400,2),(169,-1503248400,1),(169,-1492365600,2),(169,-1471798800,1),(169,-1460916000,2),(169,-1440954000,1),(169,-1428861600,2),(169,-1409504400,1),(169,-1397412000,2),(169,-1378054800,1),(169,-1365962400,2),(169,-1346605200,1),(169,-1333908000,2),(169,-1315155600,1),(169,-1301853600,2),(169,-1283706000,1),(169,-1270404000,2),(169,-1252256400,1),(169,-1238954400,2),(169,-1220806800,1),(169,-1207504800,2),(169,-1188752400,1),(169,-1176055200,2),(169,-1157302800,1),(169,-1144000800,2),(169,-1125853200,1),(169,-1112551200,2),(169,-1094403600,1),(169,-1081101600,2),(169,-1062954000,1),(169,-1049652000,2),(169,-1031504400,1),(169,-1018202400,2),(169,-1000054800,1),(169,-986752800,2),(169,-968000400,1),(169,-955303200,2),(169,-936550800,1),(169,-880218000,3),(169,-769395600,4),(169,-765396000,2),(169,-747248400,1),(169,-733946400,2),(169,-715806000,1),(169,-702504000,2),(169,-684356400,1),(169,-671054400,2),(169,-652906800,1),(169,-634161600,2),(169,-620845200,1),(169,-602704800,2),(169,-589395600,1),(169,-576093600,2),(169,-557946000,1),(169,-544644000,2),(169,-526496400,1),(169,-513194400,2),(169,-495046800,1),(169,-481744800,2),(169,-463597200,1),(169,-450295200,2),(169,-431542800,1),(169,-418240800,2),(169,-400093200,1),(169,-384372000,2),(169,-368643600,1),(169,-352922400,2),(169,-337194000,1),(169,-321472800,2),(169,-305744400,1),(169,-289418400,2),(169,-273690000,1),(169,-257968800,2),(169,-242240400,1),(169,-226519200,2),(169,-210790800,1),(169,-195069600,2),(169,-179341200,1),(169,-163620000,2),(169,-147891600,1),(169,-131565600,2),(169,-116442000,1),(169,-100116000,2),(169,-84387600,1),(169,-68666400,2),(169,-52938000,1),(169,-37216800,2),(169,-21488400,1),(169,-5767200,2),(169,9961200,1),(169,25682400,2),(169,41410800,1),(169,57736800,2),(169,73465200,1),(169,89186400,2),(169,104914800,1),(169,120636000,2),(169,136364400,1),(169,152085600,2),(169,167814000,1),(169,183535200,2),(169,199263600,1),(169,215589600,2),(169,230713200,1),(169,247039200,2),(169,262767600,1),(169,278488800,2),(169,294217200,1),(169,309938400,2),(169,325666800,1),(169,341388000,2),(169,357116400,1),(169,372837600,2),(169,388566000,1),(169,404892000,2),(169,420015600,1),(169,436341600,2),(169,452070000,1),(169,467791200,2),(169,483519600,1),(169,499240800,2),(169,514969200,1),(169,530690400,2),(169,544604400,1),(169,562140000,2),(169,576054000,1),(169,594194400,2),(169,607503600,1),(169,625644000,2),(169,638953200,1),(169,657093600,2),(169,671007600,1),(169,688543200,2),(169,702457200,1),(169,719992800,2),(169,733906800,1),(169,752047200,2),(169,765356400,1),(169,783496800,2),(169,796806000,1),(169,814946400,2),(169,828860400,1),(169,846396000,2),(169,860310000,1),(169,877845600,2),(169,891759600,1),(169,909295200,2),(169,923209200,1),(169,941349600,2),(169,954658800,1),(169,972799200,2),(169,986108400,1),(169,1004248800,2),(169,1018162800,1),(169,1035698400,2),(169,1049612400,1),(169,1067148000,2),(169,1081062000,1),(169,1099202400,2),(169,1112511600,1),(169,1130652000,2),(169,1143961200,1),(169,1162101600,2),(169,1173596400,1),(169,1194156000,2),(169,1205046000,1),(169,1225605600,2),(169,1236495600,1),(169,1257055200,2),(169,1268550000,1),(169,1289109600,2),(169,1299999600,1),(169,1320559200,2),(169,1331449200,1),(169,1352008800,2),(169,1362898800,1),(169,1383458400,2),(169,1394348400,1),(169,1414908000,2),(169,1425798000,1),(169,1446357600,2),(169,1457852400,1),(169,1478412000,2),(169,1489302000,1),(169,1509861600,2),(169,1520751600,1),(169,1541311200,2),(169,1552201200,1),(169,1572760800,2),(169,1583650800,1),(169,1604210400,2),(169,1615705200,1),(169,1636264800,2),(169,1647154800,1),(169,1667714400,2),(169,1678604400,1),(169,1699164000,2),(169,1710054000,1),(169,1730613600,2),(169,1741503600,1),(169,1762063200,2),(169,1772953200,1),(169,1793512800,2),(169,1805007600,1),(169,1825567200,2),(169,1836457200,1),(169,1857016800,2),(169,1867906800,1),(169,1888466400,2),(169,1899356400,1),(169,1919916000,2),(169,1930806000,1),(169,1951365600,2),(169,1962860400,1),(169,1983420000,2),(169,1994310000,1),(169,2014869600,2),(169,2025759600,1),(169,2046319200,2),(169,2057209200,1),(169,2077768800,2),(169,2088658800,1),(169,2109218400,2),(169,2120108400,1),(169,2140668000,2),(170,-2147483648,3),(170,-1633280400,1),(170,-1615140000,2),(170,-1601830800,1),(170,-1583690400,2),(170,-1570381200,1),(170,-1551636000,2),(170,-1536512400,1),(170,-1523210400,2),(170,-1504458000,1),(170,-1491760800,2),(170,-1473008400,1),(170,-1459706400,2),(170,-1441558800,1),(170,-1428256800,2),(170,-1410109200,1),(170,-1396807200,2),(170,-1378659600,1),(170,-1365357600,2),(170,-1347210000,1),(170,-1333908000,2),(170,-1315155600,1),(170,-1301853600,2),(170,-1283706000,1),(170,-1270404000,2),(170,-1252256400,1),(170,-1238954400,2),(170,-1220806800,1),(170,-1207504800,2),(170,-1189357200,1),(170,-1176055200,2),(170,-1157302800,1),(170,-1144605600,2),(170,-1125853200,1),(170,-1112551200,2),(170,-1094403600,1),(170,-1081101600,2),(170,-1062954000,1),(170,-1049652000,2),(170,-1031504400,1),(170,-1018202400,2),(170,-1000054800,1),(170,-986752800,2),(170,-968000400,1),(170,-955303200,2),(170,-936550800,1),(170,-923248800,2),(170,-905101200,1),(170,-891799200,2),(170,-880218000,4),(170,-769395600,5),(170,-765396000,2),(170,-747248400,1),(170,-733946400,2),(170,-715798800,1),(170,-702496800,2),(170,-684349200,1),(170,-671047200,2),(170,-652899600,1),(170,-639597600,2),(170,-620845200,1),(170,-608148000,2),(170,-589395600,1),(170,-576093600,2),(170,-557946000,1),(170,-544644000,2),(170,-526496400,1),(170,-513194400,2),(170,-495046800,1),(170,-481744800,2),(170,-463597200,1),(170,-447271200,2),(170,-431542800,1),(170,-415821600,2),(170,-400093200,1),(170,-384372000,2),(170,-368643600,1),(170,-352922400,2),(170,-337194000,1),(170,-321472800,2),(170,-305744400,1),(170,-289418400,2),(170,-273690000,1),(170,-257968800,2),(170,-242240400,1),(170,-226519200,2),(170,-210790800,1),(170,-195069600,2),(170,-179341200,1),(170,-163620000,2),(170,-147891600,1),(170,-131565600,2),(170,-116442000,1),(170,-100116000,2),(170,-84387600,1),(170,-68666400,2),(170,-52938000,1),(170,-37216800,2),(170,-21488400,1),(170,-5767200,2),(170,9961200,1),(170,25682400,2),(170,41410800,1),(170,57736800,2),(170,73465200,1),(170,89186400,2),(170,104914800,1),(170,120636000,2),(170,126687600,1),(170,152085600,2),(170,162370800,1),(170,183535200,2),(170,199263600,1),(170,215589600,2),(170,230713200,1),(170,247039200,2),(170,262767600,1),(170,278488800,2),(170,294217200,1),(170,309938400,2),(170,325666800,1),(170,341388000,2),(170,357116400,1),(170,372837600,2),(170,388566000,1),(170,404892000,2),(170,420015600,1),(170,436341600,2),(170,452070000,1),(170,467791200,2),(170,483519600,1),(170,499240800,2),(170,514969200,1),(170,530690400,2),(170,544604400,1),(170,562140000,2),(170,576054000,1),(170,594194400,2),(170,607503600,1),(170,625644000,2),(170,638953200,1),(170,657093600,2),(170,671007600,1),(170,688543200,2),(170,702457200,1),(170,719992800,2),(170,733906800,1),(170,752047200,2),(170,765356400,1),(170,783496800,2),(170,796806000,1),(170,814946400,2),(170,828860400,1),(170,846396000,2),(170,860310000,1),(170,877845600,2),(170,891759600,1),(170,909295200,2),(170,923209200,1),(170,941349600,2),(170,954658800,1),(170,972799200,2),(170,986108400,1),(170,1004248800,2),(170,1018162800,1),(170,1035698400,2),(170,1049612400,1),(170,1067148000,2),(170,1081062000,1),(170,1099202400,2),(170,1112511600,1),(170,1130652000,2),(170,1143961200,1),(170,1162101600,2),(170,1173596400,1),(170,1194156000,2),(170,1205046000,1),(170,1225605600,2),(170,1236495600,1),(170,1257055200,2),(170,1268550000,1),(170,1289109600,2),(170,1299999600,1),(170,1320559200,2),(170,1331449200,1),(170,1352008800,2),(170,1362898800,1),(170,1383458400,2),(170,1394348400,1),(170,1414908000,2),(170,1425798000,1),(170,1446357600,2),(170,1457852400,1),(170,1478412000,2),(170,1489302000,1),(170,1509861600,2),(170,1520751600,1),(170,1541311200,2),(170,1552201200,1),(170,1572760800,2),(170,1583650800,1),(170,1604210400,2),(170,1615705200,1),(170,1636264800,2),(170,1647154800,1),(170,1667714400,2),(170,1678604400,1),(170,1699164000,2),(170,1710054000,1),(170,1730613600,2),(170,1741503600,1),(170,1762063200,2),(170,1772953200,1),(170,1793512800,2),(170,1805007600,1),(170,1825567200,2),(170,1836457200,1),(170,1857016800,2),(170,1867906800,1),(170,1888466400,2),(170,1899356400,1),(170,1919916000,2),(170,1930806000,1),(170,1951365600,2),(170,1962860400,1),(170,1983420000,2),(170,1994310000,1),(170,2014869600,2),(170,2025759600,1),(170,2046319200,2),(170,2057209200,1),(170,2077768800,2),(170,2088658800,1),(170,2109218400,2),(170,2120108400,1),(170,2140668000,2),(171,-2147483648,2),(171,-1632070800,1),(171,-1615140000,2),(171,-1601753400,1),(171,-1583697600,2),(171,-1567357200,1),(171,-1554667200,2),(171,-1534698000,1),(171,-1524074400,2),(171,-1503248400,1),(171,-1492365600,2),(171,-1471798800,1),(171,-1460916000,2),(171,-1440954000,1),(171,-1428861600,2),(171,-1409504400,1),(171,-1397412000,2),(171,-1378054800,1),(171,-1365962400,2),(171,-1346605200,1),(171,-1333908000,2),(171,-1315155600,1),(171,-1301853600,2),(171,-1283706000,1),(171,-1270404000,2),(171,-1252256400,1),(171,-1238954400,2),(171,-1220806800,1),(171,-1207504800,2),(171,-1188752400,1),(171,-1176055200,2),(171,-1157302800,1),(171,-1144000800,2),(171,-1125853200,1),(171,-1112551200,2),(171,-1094403600,1),(171,-1081101600,2),(171,-1062954000,1),(171,-1049652000,2),(171,-1031504400,1),(171,-1018202400,2),(171,-1000054800,1),(171,-986752800,2),(171,-968000400,1),(171,-955303200,2),(171,-936550800,1),(171,-880218000,3),(171,-769395600,4),(171,-765396000,2),(171,-747248400,1),(171,-733946400,2),(171,-715806000,1),(171,-702504000,2),(171,-684356400,1),(171,-671054400,2),(171,-652906800,1),(171,-634161600,2),(171,-620845200,1),(171,-602704800,2),(171,-589395600,1),(171,-576093600,2),(171,-557946000,1),(171,-544644000,2),(171,-526496400,1),(171,-513194400,2),(171,-495046800,1),(171,-481744800,2),(171,-463597200,1),(171,-450295200,2),(171,-431542800,1),(171,-418240800,2),(171,-400093200,1),(171,-384372000,2),(171,-368643600,1),(171,-352922400,2),(171,-337194000,1),(171,-321472800,2),(171,-305744400,1),(171,-289418400,2),(171,-273690000,1),(171,-257968800,2),(171,-242240400,1),(171,-226519200,2),(171,-210790800,1),(171,-195069600,2),(171,-179341200,1),(171,-163620000,2),(171,-147891600,1),(171,-131565600,2),(171,-116442000,1),(171,-100116000,2),(171,-84387600,1),(171,-68666400,2),(171,-52938000,1),(171,-37216800,2),(171,-21488400,1),(171,-5767200,2),(171,9961200,1),(171,25682400,2),(171,41410800,1),(171,57736800,2),(171,73465200,1),(171,89186400,2),(171,104914800,1),(171,120636000,2),(171,136364400,1),(171,152085600,2),(171,167814000,1),(171,183535200,2),(171,199263600,1),(171,215589600,2),(171,230713200,1),(171,247039200,2),(171,262767600,1),(171,278488800,2),(171,294217200,1),(171,309938400,2),(171,325666800,1),(171,341388000,2),(171,357116400,1),(171,372837600,2),(171,388566000,1),(171,404892000,2),(171,420015600,1),(171,436341600,2),(171,452070000,1),(171,467791200,2),(171,483519600,1),(171,499240800,2),(171,514969200,1),(171,530690400,2),(171,544604400,1),(171,562140000,2),(171,576054000,1),(171,594194400,2),(171,607503600,1),(171,625644000,2),(171,638953200,1),(171,657093600,2),(171,671007600,1),(171,688543200,2),(171,702457200,1),(171,719992800,2),(171,733906800,1),(171,752047200,2),(171,765356400,1),(171,783496800,2),(171,796806000,1),(171,814946400,2),(171,828860400,1),(171,846396000,2),(171,860310000,1),(171,877845600,2),(171,891759600,1),(171,909295200,2),(171,923209200,1),(171,941349600,2),(171,954658800,1),(171,972799200,2),(171,986108400,1),(171,1004248800,2),(171,1018162800,1),(171,1035698400,2),(171,1049612400,1),(171,1067148000,2),(171,1081062000,1),(171,1099202400,2),(171,1112511600,1),(171,1130652000,2),(171,1143961200,1),(171,1162101600,2),(171,1173596400,1),(171,1194156000,2),(171,1205046000,1),(171,1225605600,2),(171,1236495600,1),(171,1257055200,2),(171,1268550000,1),(171,1289109600,2),(171,1299999600,1),(171,1320559200,2),(171,1331449200,1),(171,1352008800,2),(171,1362898800,1),(171,1383458400,2),(171,1394348400,1),(171,1414908000,2),(171,1425798000,1),(171,1446357600,2),(171,1457852400,1),(171,1478412000,2),(171,1489302000,1),(171,1509861600,2),(171,1520751600,1),(171,1541311200,2),(171,1552201200,1),(171,1572760800,2),(171,1583650800,1),(171,1604210400,2),(171,1615705200,1),(171,1636264800,2),(171,1647154800,1),(171,1667714400,2),(171,1678604400,1),(171,1699164000,2),(171,1710054000,1),(171,1730613600,2),(171,1741503600,1),(171,1762063200,2),(171,1772953200,1),(171,1793512800,2),(171,1805007600,1),(171,1825567200,2),(171,1836457200,1),(171,1857016800,2),(171,1867906800,1),(171,1888466400,2),(171,1899356400,1),(171,1919916000,2),(171,1930806000,1),(171,1951365600,2),(171,1962860400,1),(171,1983420000,2),(171,1994310000,1),(171,2014869600,2),(171,2025759600,1),(171,2046319200,2),(171,2057209200,1),(171,2077768800,2),(171,2088658800,1),(171,2109218400,2),(171,2120108400,1),(171,2140668000,2),(172,-2147483648,1),(172,-880196400,2),(172,-769395600,3),(172,-765374400,1),(172,-86878800,4),(172,-21466800,5),(172,-5745600,4),(172,9982800,5),(172,25704000,4),(172,41432400,5),(172,57758400,4),(172,73486800,5),(172,89208000,4),(172,104936400,5),(172,120657600,4),(172,126709200,5),(172,152107200,4),(172,162392400,5),(172,183556800,4),(172,199285200,5),(172,215611200,4),(172,230734800,5),(172,247060800,4),(172,262789200,5),(172,278510400,4),(172,294238800,5),(172,309960000,4),(172,325688400,5),(172,341409600,4),(172,357138000,5),(172,372859200,4),(172,388587600,5),(172,404913600,4),(172,420037200,5),(172,436363200,6),(172,439030800,8),(172,452084400,7),(172,467805600,8),(172,483534000,7),(172,499255200,8),(172,514983600,7),(172,530704800,8),(172,544618800,7),(172,562154400,8),(172,576068400,7),(172,594208800,8),(172,607518000,7),(172,625658400,8),(172,638967600,7),(172,657108000,8),(172,671022000,7),(172,688557600,8),(172,702471600,7),(172,720007200,8),(172,733921200,7),(172,752061600,8),(172,765370800,7),(172,783511200,8),(172,796820400,7),(172,814960800,8),(172,828874800,7),(172,846410400,8),(172,860324400,7),(172,877860000,8),(172,891774000,7),(172,909309600,8),(172,923223600,7),(172,941364000,8),(172,954673200,7),(172,972813600,8),(172,986122800,7),(172,1004263200,8),(172,1018177200,7),(172,1035712800,8),(172,1049626800,7),(172,1067162400,8),(172,1081076400,7),(172,1099216800,8),(172,1112526000,7),(172,1130666400,8),(172,1143975600,7),(172,1162116000,8),(172,1173610800,7),(172,1194170400,8),(172,1205060400,7),(172,1225620000,8),(172,1236510000,7),(172,1257069600,8),(172,1268564400,7),(172,1289124000,8),(172,1300014000,7),(172,1320573600,8),(172,1331463600,7),(172,1352023200,8),(172,1362913200,7),(172,1383472800,8),(172,1394362800,7),(172,1414922400,8),(172,1425812400,7),(172,1446372000,8),(172,1457866800,7),(172,1478426400,8),(172,1489316400,7),(172,1509876000,8),(172,1520766000,7),(172,1541325600,8),(172,1552215600,7),(172,1572775200,8),(172,1583665200,7),(172,1604224800,8),(172,1615719600,7),(172,1636279200,8),(172,1647169200,7),(172,1667728800,8),(172,1678618800,7),(172,1699178400,8),(172,1710068400,7),(172,1730628000,8),(172,1741518000,7),(172,1762077600,8),(172,1772967600,7),(172,1793527200,8),(172,1805022000,7),(172,1825581600,8),(172,1836471600,7),(172,1857031200,8),(172,1867921200,7),(172,1888480800,8),(172,1899370800,7),(172,1919930400,8),(172,1930820400,7),(172,1951380000,8),(172,1962874800,7),(172,1983434400,8),(172,1994324400,7),(172,2014884000,8),(172,2025774000,7),(172,2046333600,8),(172,2057223600,7),(172,2077783200,8),(172,2088673200,7),(172,2109232800,8),(172,2120122800,7),(172,2140682400,8),(173,-2147483648,0),(173,-1767217820,2),(173,-1206961200,1),(173,-1191366000,2),(173,-1175378400,1),(173,-1159830000,2),(173,-633823200,1),(173,-622072800,2),(173,-602287200,1),(173,-591836400,2),(173,-570751200,1),(173,-560214000,2),(173,-539128800,1),(173,-531356400,2),(173,-191368800,1),(173,-184201200,2),(173,-155167200,1),(173,-150073200,2),(173,-128901600,1),(173,-121129200,2),(173,-99957600,1),(173,-89593200,2),(173,-68421600,1),(173,-57970800,2),(173,499744800,1),(173,511232400,2),(173,530589600,1),(173,540262800,2),(173,562125600,1),(173,571194000,2),(173,592970400,1),(173,602038800,2),(173,624420000,1),(173,634698000,2),(173,938916000,1),(173,951613200,2),(173,970970400,1),(173,971571600,2),(173,1003024800,1),(173,1013907600,2),(173,2147483647,2),(174,-2147483648,5),(174,-1633273200,1),(174,-1615132800,2),(174,-1601823600,1),(174,-1583683200,2),(174,-880210800,3),(174,-769395600,4),(174,-765388800,2),(174,-84380400,1),(174,-68659200,2),(174,-52930800,1),(174,-37209600,2),(174,-21481200,1),(174,-5760000,2),(174,9968400,1),(174,25689600,2),(174,41418000,1),(174,57744000,2),(174,73472400,1),(174,89193600,2),(174,104922000,1),(174,120643200,2),(174,126694800,1),(174,152092800,2),(174,162378000,1),(174,183542400,2),(174,199270800,1),(174,215596800,2),(174,230720400,1),(174,247046400,2),(174,262774800,1),(174,278496000,2),(174,294224400,1),(174,309945600,2),(174,325674000,1),(174,341395200,2),(174,357123600,1),(174,372844800,2),(174,388573200,1),(174,404899200,2),(174,420022800,1),(174,436348800,2),(174,452077200,1),(174,467798400,2),(174,483526800,1),(174,499248000,2),(174,514976400,1),(174,530697600,2),(174,544611600,1),(174,562147200,2),(174,576061200,1),(174,594201600,2),(174,607510800,1),(174,625651200,2),(174,638960400,1),(174,657100800,2),(174,671014800,1),(174,688550400,2),(174,702464400,1),(174,720000000,2),(174,733914000,1),(174,752054400,2),(174,765363600,1),(174,783504000,2),(174,796813200,1),(174,814953600,2),(174,828867600,1),(174,846403200,2),(174,860317200,1),(174,877852800,2),(174,891766800,1),(174,909302400,2),(174,923216400,1),(174,941356800,2),(174,954666000,1),(174,972806400,2),(174,986115600,1),(174,1004256000,2),(174,1018170000,1),(174,1035705600,2),(174,1049619600,1),(174,1067155200,2),(174,1081069200,1),(174,1099209600,2),(174,1112518800,1),(174,1130659200,2),(174,1143968400,1),(174,1162108800,2),(174,1173603600,1),(174,1194163200,2),(174,1205053200,1),(174,1225612800,2),(174,1236502800,1),(174,1257062400,2),(174,1268557200,1),(174,1289116800,7),(174,1300003200,6),(174,1320562800,7),(174,1331452800,6),(174,1352012400,7),(174,1362902400,6),(174,1383462000,7),(174,1394352000,6),(174,1414911600,7),(174,1425801600,6),(174,1446361200,7),(174,1457856000,6),(174,1478415600,7),(174,1489305600,6),(174,1509865200,7),(174,1520755200,6),(174,1541314800,7),(174,1552204800,6),(174,1572764400,7),(174,1583654400,6),(174,1604214000,7),(174,1615708800,6),(174,1636268400,7),(174,1647158400,6),(174,1667718000,7),(174,1678608000,6),(174,1699167600,7),(174,1710057600,6),(174,1730617200,7),(174,1741507200,6),(174,1762066800,7),(174,1772956800,6),(174,1793516400,7),(174,1805011200,6),(174,1825570800,7),(174,1836460800,6),(174,1857020400,7),(174,1867910400,6),(174,1888470000,7),(174,1899360000,6),(174,1919919600,7),(174,1930809600,6),(174,1951369200,7),(174,1962864000,6),(174,1983423600,7),(174,1994313600,6),(174,2014873200,7),(174,2025763200,6),(174,2046322800,7),(174,2057212800,6),(174,2077772400,7),(174,2088662400,6),(174,2109222000,7),(174,2120112000,6),(174,2140671600,7),(175,-2147483648,5),(175,-1633273200,1),(175,-1615132800,2),(175,-1601823600,1),(175,-1583683200,2),(175,-880210800,3),(175,-769395600,4),(175,-765388800,2),(175,-84380400,1),(175,-68659200,2),(175,-52930800,1),(175,-37209600,2),(175,-21481200,1),(175,-5760000,2),(175,9968400,1),(175,25689600,2),(175,41418000,1),(175,57744000,2),(175,73472400,1),(175,89193600,2),(175,104922000,1),(175,120643200,2),(175,126694800,1),(175,152092800,2),(175,162378000,1),(175,183542400,2),(175,199270800,1),(175,215596800,2),(175,230720400,1),(175,247046400,2),(175,262774800,1),(175,278496000,2),(175,294224400,1),(175,309945600,2),(175,325674000,1),(175,341395200,2),(175,357123600,1),(175,372844800,2),(175,388573200,1),(175,404899200,2),(175,420022800,1),(175,436348800,2),(175,452077200,1),(175,467798400,2),(175,483526800,1),(175,499248000,2),(175,514976400,1),(175,530697600,2),(175,544611600,1),(175,562147200,2),(175,576061200,1),(175,594201600,2),(175,607510800,1),(175,625651200,2),(175,638960400,1),(175,657100800,2),(175,671014800,1),(175,688550400,2),(175,702464400,1),(175,720000000,7),(175,733910400,6),(175,752050800,7),(175,765360000,6),(175,783500400,7),(175,796809600,6),(175,814950000,7),(175,828864000,6),(175,846399600,7),(175,860313600,6),(175,877849200,7),(175,891763200,6),(175,909298800,7),(175,923212800,6),(175,941353200,7),(175,954662400,6),(175,972802800,7),(175,986112000,6),(175,1004252400,7),(175,1018166400,6),(175,1035702000,7),(175,1049616000,6),(175,1067151600,7),(175,1081065600,6),(175,1099206000,7),(175,1112515200,6),(175,1130655600,7),(175,1143964800,6),(175,1162105200,7),(175,1173600000,6),(175,1194159600,7),(175,1205049600,6),(175,1225609200,7),(175,1236499200,6),(175,1257058800,7),(175,1268553600,6),(175,1289113200,7),(175,1300003200,6),(175,1320562800,7),(175,1331452800,6),(175,1352012400,7),(175,1362902400,6),(175,1383462000,7),(175,1394352000,6),(175,1414911600,7),(175,1425801600,6),(175,1446361200,7),(175,1457856000,6),(175,1478415600,7),(175,1489305600,6),(175,1509865200,7),(175,1520755200,6),(175,1541314800,7),(175,1552204800,6),(175,1572764400,7),(175,1583654400,6),(175,1604214000,7),(175,1615708800,6),(175,1636268400,7),(175,1647158400,6),(175,1667718000,7),(175,1678608000,6),(175,1699167600,7),(175,1710057600,6),(175,1730617200,7),(175,1741507200,6),(175,1762066800,7),(175,1772956800,6),(175,1793516400,7),(175,1805011200,6),(175,1825570800,7),(175,1836460800,6),(175,1857020400,7),(175,1867910400,6),(175,1888470000,7),(175,1899360000,6),(175,1919919600,7),(175,1930809600,6),(175,1951369200,7),(175,1962864000,6),(175,1983423600,7),(175,1994313600,6),(175,2014873200,7),(175,2025763200,6),(175,2046322800,7),(175,2057212800,6),(175,2077772400,7),(175,2088662400,6),(175,2109222000,7),(175,2120112000,6),(175,2140671600,7),(176,-2147483648,5),(176,-1633273200,1),(176,-1615132800,2),(176,-1601823600,1),(176,-1583683200,2),(176,-880210800,3),(176,-769395600,4),(176,-765388800,2),(176,-84380400,1),(176,-68659200,2),(176,-52930800,1),(176,-37209600,2),(176,-21481200,1),(176,-5760000,2),(176,9968400,1),(176,25689600,2),(176,41418000,1),(176,57744000,2),(176,73472400,1),(176,89193600,2),(176,104922000,1),(176,120643200,2),(176,126694800,1),(176,152092800,2),(176,162378000,1),(176,183542400,2),(176,199270800,1),(176,215596800,2),(176,230720400,1),(176,247046400,2),(176,262774800,1),(176,278496000,2),(176,294224400,1),(176,309945600,2),(176,325674000,1),(176,341395200,2),(176,357123600,1),(176,372844800,2),(176,388573200,1),(176,404899200,2),(176,420022800,1),(176,436348800,2),(176,452077200,1),(176,467798400,2),(176,483526800,1),(176,499248000,2),(176,514976400,1),(176,530697600,2),(176,544611600,1),(176,562147200,2),(176,576061200,1),(176,594201600,2),(176,607510800,1),(176,625651200,2),(176,638960400,1),(176,657100800,2),(176,671014800,1),(176,688550400,2),(176,702464400,1),(176,720000000,2),(176,733914000,1),(176,752054400,2),(176,765363600,1),(176,783504000,2),(176,796813200,1),(176,814953600,2),(176,828867600,1),(176,846403200,2),(176,860317200,1),(176,877852800,2),(176,891766800,1),(176,909302400,2),(176,923216400,1),(176,941356800,2),(176,954666000,1),(176,972806400,2),(176,986115600,1),(176,1004256000,2),(176,1018170000,1),(176,1035705600,2),(176,1049619600,1),(176,1067155200,7),(176,1081065600,6),(176,1099206000,7),(176,1112515200,6),(176,1130655600,7),(176,1143964800,6),(176,1162105200,7),(176,1173600000,6),(176,1194159600,7),(176,1205049600,6),(176,1225609200,7),(176,1236499200,6),(176,1257058800,7),(176,1268553600,6),(176,1289113200,7),(176,1300003200,6),(176,1320562800,7),(176,1331452800,6),(176,1352012400,7),(176,1362902400,6),(176,1383462000,7),(176,1394352000,6),(176,1414911600,7),(176,1425801600,6),(176,1446361200,7),(176,1457856000,6),(176,1478415600,7),(176,1489305600,6),(176,1509865200,7),(176,1520755200,6),(176,1541314800,7),(176,1552204800,6),(176,1572764400,7),(176,1583654400,6),(176,1604214000,7),(176,1615708800,6),(176,1636268400,7),(176,1647158400,6),(176,1667718000,7),(176,1678608000,6),(176,1699167600,7),(176,1710057600,6),(176,1730617200,7),(176,1741507200,6),(176,1762066800,7),(176,1772956800,6),(176,1793516400,7),(176,1805011200,6),(176,1825570800,7),(176,1836460800,6),(176,1857020400,7),(176,1867910400,6),(176,1888470000,7),(176,1899360000,6),(176,1919919600,7),(176,1930809600,6),(176,1951369200,7),(176,1962864000,6),(176,1983423600,7),(176,1994313600,6),(176,2014873200,7),(176,2025763200,6),(176,2046322800,7),(176,2057212800,6),(176,2077772400,7),(176,2088662400,6),(176,2109222000,7),(176,2120112000,6),(176,2140671600,7),(177,-2147483648,0),(177,-1686083584,1),(177,323845200,4),(177,338950800,2),(177,354675600,3),(177,370400400,2),(177,386125200,3),(177,401850000,2),(177,417574800,3),(177,433299600,2),(177,449024400,3),(177,465354000,2),(177,481078800,3),(177,496803600,2),(177,512528400,3),(177,528253200,2),(177,543978000,3),(177,559702800,2),(177,575427600,3),(177,591152400,2),(177,606877200,3),(177,622602000,2),(177,638326800,3),(177,654656400,2),(177,670381200,3),(177,686106000,2),(177,701830800,3),(177,717555600,2),(177,733280400,3),(177,749005200,2),(177,764730000,3),(177,780454800,2),(177,796179600,3),(177,811904400,2),(177,828234000,3),(177,846378000,2),(177,859683600,3),(177,877827600,2),(177,891133200,3),(177,909277200,2),(177,922582800,3),(177,941331600,2),(177,954032400,3),(177,972781200,2),(177,985482000,3),(177,1004230800,2),(177,1017536400,3),(177,1035680400,2),(177,1048986000,3),(177,1067130000,2),(177,1080435600,3),(177,1099184400,2),(177,1111885200,3),(177,1130634000,2),(177,1143334800,3),(177,1162083600,2),(177,1174784400,3),(177,1193533200,2),(177,1206838800,3),(177,1224982800,2),(177,1238288400,3),(177,1256432400,2),(177,1269738000,3),(177,1288486800,2),(177,1301187600,3),(177,1319936400,2),(177,1332637200,3),(177,1351386000,2),(177,1364691600,3),(177,1382835600,2),(177,1396141200,3),(177,1414285200,2),(177,1427590800,3),(177,1445734800,2),(177,1459040400,3),(177,1477789200,2),(177,1490490000,3),(177,1509238800,2),(177,1521939600,3),(177,1540688400,2),(177,1553994000,3),(177,1572138000,2),(177,1585443600,3),(177,1603587600,2),(177,1616893200,3),(177,1635642000,2),(177,1648342800,3),(177,1667091600,2),(177,1679792400,3),(177,1698541200,5),(177,1711846800,6),(177,1729990800,5),(177,1743296400,6),(177,1761440400,5),(177,1774746000,6),(177,1792890000,5),(177,1806195600,6),(177,1824944400,5),(177,1837645200,6),(177,1856394000,5),(177,1869094800,6),(177,1887843600,5),(177,1901149200,6),(177,1919293200,5),(177,1932598800,6),(177,1950742800,5),(177,1964048400,6),(177,1982797200,5),(177,1995498000,6),(177,2014246800,5),(177,2026947600,6),(177,2045696400,5),(177,2058397200,6),(177,2077146000,5),(177,2090451600,6),(177,2108595600,5),(177,2121901200,6),(177,2140045200,5),(177,2147483647,5),(178,-2147483648,0),(178,-1514739600,1),(178,-1343066400,2),(178,-1234807200,4),(178,-1220292000,3),(178,-1207159200,4),(178,-1191344400,2),(178,828864000,5),(178,846399600,2),(178,860313600,5),(178,877849200,2),(178,891766800,3),(178,909302400,4),(178,923216400,3),(178,941356800,4),(178,954666000,3),(178,972806400,4),(178,989139600,3),(178,1001836800,4),(178,1018170000,3),(178,1035705600,4),(178,1049619600,3),(178,1067155200,4),(178,1081069200,3),(178,1099209600,4),(178,1112518800,3),(178,1130659200,4),(178,1143968400,3),(178,1162108800,4),(178,1175418000,3),(178,1193558400,4),(178,1207472400,3),(178,1225008000,4),(178,1238922000,3),(178,1256457600,4),(178,1268557200,3),(178,1289116800,4),(178,1300006800,3),(178,1320566400,4),(178,1331456400,3),(178,1352016000,4),(178,1362906000,3),(178,1383465600,4),(178,1394355600,3),(178,1414915200,4),(178,1425805200,3),(178,1446364800,4),(178,1457859600,3),(178,1478419200,4),(178,1489309200,3),(178,1509868800,4),(178,1520758800,3),(178,1541318400,4),(178,1552208400,3),(178,1572768000,4),(178,1583658000,3),(178,1604217600,4),(178,1615712400,3),(178,1636272000,4),(178,1647162000,3),(178,1667116800,2),(178,1678608000,5),(178,1699167600,2),(178,1710057600,5),(178,1730617200,2),(178,1741507200,5),(178,1762066800,2),(178,1772956800,5),(178,1793516400,2),(178,1805011200,5),(178,1825570800,2),(178,1836460800,5),(178,1857020400,2),(178,1867910400,5),(178,1888470000,2),(178,1899360000,5),(178,1919919600,2),(178,1930809600,5),(178,1951369200,2),(178,1962864000,5),(178,1983423600,2),(178,1994313600,5),(178,2014873200,2),(178,2025763200,5),(178,2046322800,2),(178,2057212800,5),(178,2077772400,2),(178,2088662400,5),(178,2109222000,2),(178,2120112000,5),(178,2140671600,2),(179,-2147483648,1),(179,-1946918424,2),(180,-2147483648,0),(180,-865296000,4),(180,-769395600,1),(180,-765396000,2),(180,73465200,3),(180,89186400,2),(180,104914800,3),(180,120636000,2),(180,136364400,3),(180,152085600,2),(180,167814000,3),(180,183535200,2),(180,199263600,3),(180,215589600,2),(180,230713200,3),(180,247039200,2),(180,262767600,3),(180,278488800,2),(180,294217200,3),(180,309938400,2),(180,325666800,3),(180,341388000,2),(180,357116400,3),(180,372837600,2),(180,388566000,3),(180,404892000,2),(180,420015600,3),(180,436341600,2),(180,452070000,3),(180,467791200,2),(180,483519600,3),(180,499240800,2),(180,514969200,3),(180,530690400,2),(180,544604400,3),(180,562140000,2),(180,576054000,3),(180,594194400,2),(180,607503600,3),(180,625644000,2),(180,638953200,3),(180,657093600,2),(180,671007600,3),(180,688543200,2),(180,702457200,3),(180,719992800,2),(180,733906800,3),(180,752047200,2),(180,765356400,3),(180,783496800,2),(180,796806000,3),(180,814946400,2),(180,828860400,3),(180,846396000,2),(180,860310000,3),(180,877845600,2),(180,891759600,3),(180,909295200,2),(180,923209200,3),(180,941349600,5),(180,954662400,6),(180,972802800,2),(180,986108400,3),(180,1004248800,2),(180,1018162800,3),(180,1035698400,2),(180,1049612400,3),(180,1067148000,2),(180,1081062000,3),(180,1099202400,2),(180,1112511600,3),(180,1130652000,2),(180,1143961200,3),(180,1162101600,2),(180,1173596400,3),(180,1194156000,2),(180,1205046000,3),(180,1225605600,2),(180,1236495600,3),(180,1257055200,2),(180,1268550000,3),(180,1289109600,2),(180,1299999600,3),(180,1320559200,2),(180,1331449200,3),(180,1352008800,2),(180,1362898800,3),(180,1383458400,2),(180,1394348400,3),(180,1414908000,2),(180,1425798000,3),(180,1446357600,2),(180,1457852400,3),(180,1478412000,2),(180,1489302000,3),(180,1509861600,2),(180,1520751600,3),(180,1541311200,2),(180,1552201200,3),(180,1572760800,2),(180,1583650800,3),(180,1604210400,2),(180,1615705200,3),(180,1636264800,2),(180,1647154800,3),(180,1667714400,2),(180,1678604400,3),(180,1699164000,2),(180,1710054000,3),(180,1730613600,2),(180,1741503600,3),(180,1762063200,2),(180,1772953200,3),(180,1793512800,2),(180,1805007600,3),(180,1825567200,2),(180,1836457200,3),(180,1857016800,2),(180,1867906800,3),(180,1888466400,2),(180,1899356400,3),(180,1919916000,2),(180,1930806000,3),(180,1951365600,2),(180,1962860400,3),(180,1983420000,2),(180,1994310000,3),(180,2014869600,2),(180,2025759600,3),(180,2046319200,2),(180,2057209200,3),(180,2077768800,2),(180,2088658800,3),(180,2109218400,2),(180,2120108400,3),(180,2140668000,2),(181,-2147483648,0),(181,-1861906760,1),(181,-1104524348,2),(181,-765317964,3),(181,465449400,4),(181,2147483647,4),(182,-2147483648,4),(182,-1633273200,1),(182,-1615132800,2),(182,-1601823600,1),(182,-1583683200,2),(182,-880210800,3),(182,-820519140,2),(182,-812653140,3),(182,-796845540,2),(182,-84380400,1),(182,-68659200,2),(183,-2147483648,1),(183,-1670483460,3),(183,421218000,2),(183,436334400,3),(183,452062800,2),(183,467784000,3),(183,483512400,2),(183,499233600,3),(183,514962000,2),(183,530683200,3),(183,546411600,2),(183,562132800,3),(183,576050400,4),(183,594194400,5),(183,607500000,4),(183,625644000,5),(183,638949600,4),(183,657093600,5),(183,671004000,4),(183,688543200,5),(183,702453600,4),(183,719992800,5),(183,733903200,4),(183,752047200,5),(183,765352800,4),(183,783496800,5),(183,796802400,4),(183,814946400,5),(183,828856800,4),(183,846396000,5),(183,860306400,4),(183,877845600,5),(183,1112504400,2),(183,1130644800,3),(183,1143954000,2),(183,1162094400,3),(183,1331449200,2),(183,1352008800,3),(183,1362898800,2),(183,1383458400,3),(183,1394348400,2),(183,1414908000,3),(183,1425798000,2),(183,1446357600,3),(183,1489302000,2),(183,1509861600,3),(183,1520751600,2),(183,1541311200,3),(183,1552201200,2),(183,1572760800,3),(183,1583650800,2),(183,1604210400,3),(183,1615705200,2),(183,1636264800,3),(183,1647154800,2),(183,1667714400,3),(183,1678604400,2),(183,1699164000,3),(183,1710054000,2),(183,1730613600,3),(183,1741503600,2),(183,1762063200,3),(183,1772953200,2),(183,1793512800,3),(183,1805007600,2),(183,1825567200,3),(183,1836457200,2),(183,1857016800,3),(183,1867906800,2),(183,1888466400,3),(183,1899356400,2),(183,1919916000,3),(183,1930806000,2),(183,1951365600,3),(183,1962860400,2),(183,1983420000,3),(183,1994310000,2),(183,2014869600,3),(183,2025759600,2),(183,2046319200,3),(183,2057209200,2),(183,2077768800,3),(183,2088658800,2),(183,2109218400,3),(183,2120108400,2),(183,2140668000,3),(184,-2147483648,1),(184,-873057600,3),(184,-769395600,2),(184,-765399600,1),(185,-2147483648,0),(185,-1767209328,2),(185,-1206950400,1),(185,-1191355200,2),(185,-1175367600,1),(185,-1159819200,2),(185,-633812400,1),(185,-622062000,2),(185,-602276400,1),(185,-591825600,2),(185,-570740400,1),(185,-560203200,2),(185,-539118000,1),(185,-531345600,2),(185,-191358000,1),(185,-184190400,2),(185,-155156400,1),(185,-150062400,2),(185,-128890800,1),(185,-121118400,2),(185,-99946800,1),(185,-89582400,2),(185,-68410800,1),(185,-57960000,2),(185,499755600,1),(185,511243200,2),(185,530600400,1),(185,540273600,2),(185,562136400,1),(185,571204800,2),(185,1214283600,3),(185,1384056000,2),(185,2147483647,2),(186,-2147483648,0),(186,-1767210264,2),(186,-1206954000,1),(186,-1191358800,2),(186,-1175371200,1),(186,-1159822800,2),(186,-633816000,1),(186,-622065600,2),(186,-602280000,1),(186,-591829200,2),(186,-570744000,1),(186,-560206800,2),(186,-539121600,1),(186,-531349200,2),(186,-191361600,1),(186,-184194000,2),(186,-155160000,1),(186,-150066000,2),(186,-128894400,1),(186,-121122000,2),(186,-99950400,1),(186,-89586000,2),(186,-68414400,1),(186,-57963600,2),(186,499752000,1),(186,511239600,2),(186,530596800,1),(186,540270000,2),(186,562132800,1),(186,571201200,2),(186,2147483647,2),(187,-2147483648,1),(187,-873057600,3),(187,-769395600,2),(187,-765399600,1),(188,-2147483648,1),(188,-1892661435,2),(188,-1688410800,1),(188,-1619205435,3),(188,-1593806400,1),(188,-1335986235,4),(188,-1317585600,2),(188,-1304362800,4),(188,-1286049600,2),(188,-1272826800,4),(188,-1254513600,2),(188,-1241290800,4),(188,-1222977600,2),(188,-1209754800,4),(188,-1191355200,2),(188,-1178132400,3),(188,-870552000,2),(188,-865278000,3),(188,-736632000,4),(188,-718056000,2),(188,-713649600,3),(188,-36619200,5),(188,-23922000,6),(188,-3355200,5),(188,7527600,6),(188,24465600,5),(188,37767600,6),(188,55915200,5),(188,69217200,6),(188,87969600,5),(188,100666800,6),(188,118209600,5),(188,132116400,6),(188,150868800,5),(188,163566000,6),(188,182318400,5),(188,195620400,6),(188,213768000,5),(188,227070000,6),(188,245217600,5),(188,258519600,6),(188,277272000,5),(188,289969200,6),(188,308721600,5),(188,321418800,6),(188,340171200,5),(188,353473200,6),(188,371620800,5),(188,384922800,6),(188,403070400,5),(188,416372400,6),(188,434520000,5),(188,447822000,6),(188,466574400,5),(188,479271600,6),(188,498024000,5),(188,510721200,6),(188,529473600,5),(188,545194800,6),(188,560923200,5),(188,574225200,6),(188,592372800,5),(188,605674800,6),(188,624427200,5),(188,637124400,6),(188,653457600,5),(188,668574000,6),(188,687326400,5),(188,700628400,6),(188,718776000,5),(188,732078000,6),(188,750225600,5),(188,763527600,6),(188,781675200,5),(188,794977200,6),(188,813729600,5),(188,826426800,6),(188,845179200,5),(188,859690800,6),(188,876628800,5),(188,889930800,6),(188,906868800,5),(188,923194800,6),(188,939528000,5),(188,952830000,6),(188,971582400,5),(188,984279600,6),(188,1003032000,5),(188,1015729200,6),(188,1034481600,5),(188,1047178800,6),(188,1065931200,5),(188,1079233200,6),(188,1097380800,5),(188,1110682800,6),(188,1128830400,5),(188,1142132400,6),(188,1160884800,5),(188,1173582000,6),(188,1192334400,5),(188,1206846000,6),(188,1223784000,5),(188,1237086000,6),(188,1255233600,5),(188,1270350000,6),(188,1286683200,5),(188,1304823600,6),(188,1313899200,5),(188,1335668400,6),(188,1346558400,5),(188,1367118000,6),(188,1378612800,5),(188,1398567600,6),(188,1410062400,5),(188,1463281200,6),(188,1471147200,5),(188,1480820400,7),(188,2147483647,7),(189,-2147483648,2),(189,-1694368800,1),(189,-1681671600,2),(189,-1632067200,1),(189,-1615136400,2),(189,-1029686400,1),(189,-1018198800,2),(189,-880214400,3),(189,-769395600,4),(189,-765392400,2),(189,-746035200,1),(189,-732733200,2),(189,-715795200,1),(189,-702493200,2),(189,-684345600,1),(189,-671043600,2),(189,-652896000,1),(189,-639594000,2),(189,-620755200,1),(189,-607626000,2),(189,-589392000,1),(189,-576090000,2),(189,-557942400,1),(189,-544640400,2),(189,-526492800,1),(189,-513190800,2),(189,-495043200,1),(189,-481741200,2),(189,-463593600,1),(189,-450291600,2),(189,-431539200,1),(189,-418237200,2),(189,-400089600,1),(189,-386787600,2),(189,-368640000,1),(189,-355338000,2),(189,-337190400,1),(189,-321469200,2),(189,-305740800,1),(189,-292438800,2),(189,-210787200,1),(189,-198090000,2),(189,-116438400,5),(189,-100108800,6),(189,-84384000,5),(189,-68659200,6),(189,-52934400,5),(189,-37209600,6),(189,-21484800,5),(189,-5760000,6),(189,9964800,5),(189,25689600,6),(189,41414400,5),(189,57744000,6),(189,73468800,5),(189,89193600,6),(189,104918400,5),(189,120643200,6),(189,136368000,5),(189,152092800,6),(189,167817600,5),(189,183542400,6),(189,199267200,5),(189,215596800,6),(189,230716800,5),(189,247046400,6),(189,262771200,5),(189,278496000,6),(189,294220800,5),(189,309945600,6),(189,325670400,5),(189,341395200,6),(189,357120000,5),(189,372844800,6),(189,388569600,5),(189,404899200,6),(189,420019200,5),(189,436348800,6),(189,452073600,5),(189,467798400,6),(189,483523200,5),(189,499248000,6),(189,514972800,5),(189,530697600,6),(189,544608000,5),(189,562147200,6),(189,576057600,5),(189,594201600,6),(189,607507200,5),(189,625651200,6),(189,638956800,5),(189,657100800,6),(189,671011200,5),(189,688550400,6),(189,702460800,5),(189,720000000,6),(189,733910400,5),(189,752054400,6),(189,765360000,5),(189,783504000,6),(189,796809600,5),(189,814953600,6),(189,828864000,5),(189,846403200,6),(189,860313600,5),(189,877852800,6),(189,891763200,5),(189,909302400,6),(189,923212800,5),(189,941356800,6),(189,954662400,5),(189,972806400,6),(189,986112000,5),(189,1004256000,6),(189,1018166400,5),(189,1035705600,6),(189,1049616000,5),(189,1067155200,6),(189,1081065600,5),(189,1099209600,6),(189,1112515200,5),(189,1130659200,6),(189,1136095200,2),(189,1143964800,1),(189,1162105200,2),(189,1173600000,1),(189,1194159600,2),(189,1205049600,1),(189,1225609200,2),(189,1236499200,1),(189,1257058800,2),(189,1268553600,1),(189,1289113200,2),(189,1300003200,1),(189,1320562800,2),(189,1331452800,1),(189,1352012400,2),(189,1362902400,1),(189,1383462000,2),(189,1394352000,1),(189,1414911600,2),(189,1425801600,1),(189,1446361200,2),(189,1457856000,1),(189,1478415600,2),(189,1489305600,1),(189,1509865200,2),(189,1520755200,1),(189,1541314800,2),(189,1552204800,1),(189,1572764400,2),(189,1583654400,1),(189,1604214000,2),(189,1615708800,1),(189,1636268400,2),(189,1647158400,1),(189,1667718000,2),(189,1678608000,1),(189,1699167600,2),(189,1710057600,1),(189,1730617200,2),(189,1741507200,1),(189,1762066800,2),(189,1772956800,1),(189,1793516400,2),(189,1805011200,1),(189,1825570800,2),(189,1836460800,1),(189,1857020400,2),(189,1867910400,1),(189,1888470000,2),(189,1899360000,1),(189,1919919600,2),(189,1930809600,1),(189,1951369200,2),(189,1962864000,1),(189,1983423600,2),(189,1994313600,1),(189,2014873200,2),(189,2025763200,1),(189,2046322800,2),(189,2057212800,1),(189,2077772400,2),(189,2088662400,1),(189,2109222000,2),(189,2120112000,1),(189,2140671600,2),(190,-2147483648,0),(190,-410227200,2),(190,73468800,1),(190,89190000,2),(190,104918400,1),(190,120639600,2),(190,136368000,1),(190,152089200,2),(190,167817600,1),(190,183538800,2),(190,199267200,1),(190,215593200,2),(190,230716800,1),(190,247042800,2),(190,262771200,1),(190,278492400,2),(190,294220800,1),(190,309942000,2),(190,325670400,1),(190,341391600,2),(190,357120000,1),(190,372841200,2),(190,388569600,1),(190,404895600,2),(190,420019200,1),(190,436345200,2),(190,452073600,1),(190,467794800,2),(190,483523200,1),(190,499244400,2),(190,514972800,1),(190,530694000,2),(190,544608000,1),(190,562143600,2),(190,576057600,1),(190,594198000,2),(190,607507200,1),(190,625647600,2),(190,638956800,1),(190,657097200,2),(190,671011200,1),(190,688546800,2),(190,702460800,1),(190,719996400,2),(190,733910400,1),(190,752050800,2),(190,765360000,1),(190,783500400,2),(190,796809600,1),(190,814950000,2),(190,828864000,1),(190,846399600,2),(190,860313600,1),(190,877849200,2),(190,891763200,1),(190,909298800,2),(190,923212800,1),(190,941353200,2),(190,954662400,1),(190,972802800,3),(190,986112000,1),(190,1004252400,2),(190,1018166400,1),(190,1035702000,2),(190,1049616000,1),(190,1067151600,2),(190,1081065600,1),(190,1099206000,2),(190,1112515200,1),(190,1130655600,2),(190,1143964800,1),(190,1162105200,2),(190,1173600000,1),(190,1194159600,2),(190,1205049600,1),(190,1225609200,2),(190,1236499200,1),(190,1257058800,2),(190,1268553600,1),(190,1289113200,2),(190,1300003200,1),(190,1320562800,2),(190,1331452800,1),(190,1352012400,2),(190,1362902400,1),(190,1383462000,2),(190,1394352000,1),(190,1414911600,2),(190,1425801600,1),(190,1446361200,2),(190,1457856000,1),(190,1478415600,2),(190,1489305600,1),(190,1509865200,2),(190,1520755200,1),(190,1541314800,2),(190,1552204800,1),(190,1572764400,2),(190,1583654400,1),(190,1604214000,2),(190,1615708800,1),(190,1636268400,2),(190,1647158400,1),(190,1667718000,2),(190,1678608000,1),(190,1699167600,2),(190,1710057600,1),(190,1730617200,2),(190,1741507200,1),(190,1762066800,2),(190,1772956800,1),(190,1793516400,2),(190,1805011200,1),(190,1825570800,2),(190,1836460800,1),(190,1857020400,2),(190,1867910400,1),(190,1888470000,2),(190,1899360000,1),(190,1919919600,2),(190,1930809600,1),(190,1951369200,2),(190,1962864000,1),(190,1983423600,2),(190,1994313600,1),(190,2014873200,2),(190,2025763200,1),(190,2046322800,2),(190,2057212800,1),(190,2077772400,2),(190,2088662400,1),(190,2109222000,2),(190,2120112000,1),(190,2140671600,2),(191,-2147483648,0),(191,-1767217224,2),(191,-1206957600,1),(191,-1191362400,2),(191,-1175374800,1),(191,-1159826400,2),(191,-633819600,1),(191,-622069200,2),(191,-602283600,1),(191,-591832800,2),(191,-570747600,1),(191,-560210400,2),(191,-539125200,1),(191,-531352800,2),(191,-191365200,1),(191,-184197600,2),(191,-155163600,1),(191,-150069600,2),(191,-128898000,1),(191,-121125600,2),(191,-99954000,1),(191,-89589600,2),(191,-68418000,1),(191,-57967200,2),(191,499748400,1),(191,511236000,2),(191,530593200,1),(191,540266400,2),(191,562129200,1),(191,571197600,2),(191,592974000,1),(191,602042400,2),(191,624423600,1),(191,634701600,2),(191,938919600,1),(191,951616800,2),(191,970974000,1),(191,971575200,2),(191,1003028400,1),(191,1013911200,2),(191,2147483647,2),(192,-2147483648,0),(192,-2030202084,2),(192,-1632063600,1),(192,-1615132800,2),(192,-1251651600,1),(192,-1238349600,2),(192,-1220202000,1),(192,-1206900000,2),(192,-1188752400,1),(192,-1175450400,2),(192,-1156698000,1),(192,-1144000800,2),(192,-1125248400,1),(192,-1111946400,2),(192,-1032714000,1),(192,-1016992800,2),(192,-1001264400,1),(192,-986148000,2),(192,-969814800,1),(192,-954093600,2),(192,-937760400,1),(192,-922039200,2),(192,-906310800,1),(192,-890589600,2),(192,-880210800,3),(192,-769395600,4),(192,-765388800,2),(192,-748450800,1),(192,-732729600,2),(192,-715791600,1),(192,-702489600,2),(192,-684342000,1),(192,-671040000,2),(192,-652892400,1),(192,-639590400,2),(192,-620838000,1),(192,-608140800,2),(192,-589388400,1),(192,-576086400,2),(192,-557938800,1),(192,-544636800,2),(192,-526489200,1),(192,-513187200,2),(192,-495039600,1),(192,-481737600,2),(192,-463590000,1),(192,-450288000,2),(192,-431535600,1),(192,-418233600,2),(192,-400086000,1),(192,-386784000,2),(192,-337186800,1),(192,-321465600,2),(192,-305737200,5),(193,-2147483648,0),(193,-704937600,2),(193,73468800,1),(193,89190000,2),(193,104918400,1),(193,120639600,2),(193,136368000,1),(193,152089200,2),(193,167817600,1),(193,183538800,2),(193,199267200,1),(193,215593200,2),(193,230716800,1),(193,247042800,2),(193,262771200,1),(193,278492400,2),(193,294220800,1),(193,309942000,2),(193,325670400,1),(193,341391600,2),(193,357120000,1),(193,372841200,2),(193,388569600,1),(193,404895600,2),(193,420019200,1),(193,436345200,2),(193,452073600,1),(193,467794800,2),(193,483523200,1),(193,499244400,2),(193,514972800,1),(193,530694000,2),(193,544608000,1),(193,562143600,2),(193,576057600,1),(193,594198000,2),(193,607507200,1),(193,625647600,2),(193,638956800,1),(193,657097200,2),(193,671011200,1),(193,688546800,2),(193,702460800,1),(193,719996400,2),(193,733910400,1),(193,752050800,2),(193,765360000,1),(193,783500400,2),(193,796809600,1),(193,814950000,2),(193,828864000,1),(193,846399600,2),(193,860313600,1),(193,877849200,2),(193,891763200,1),(193,909298800,2),(193,923212800,1),(193,941353200,2),(193,954662400,1),(193,972802800,3),(193,986112000,1),(193,1004252400,2),(193,1018166400,1),(193,1035702000,2),(193,1049616000,1),(193,1067151600,2),(193,1081065600,1),(193,1099206000,2),(193,1112515200,1),(193,1130655600,2),(193,1143964800,1),(193,1162105200,3),(193,1173600000,1),(193,1194159600,2),(193,1205049600,1),(193,1225609200,2),(193,1236499200,1),(193,1257058800,2),(193,1268553600,1),(193,1289113200,2),(193,1300003200,1),(193,1320562800,2),(193,1331452800,1),(193,1352012400,2),(193,1362902400,1),(193,1383462000,2),(193,1394352000,1),(193,1414911600,2),(193,1425801600,1),(193,1446361200,2),(193,1457856000,1),(193,1478415600,2),(193,1489305600,1),(193,1509865200,2),(193,1520755200,1),(193,1541314800,2),(193,1552204800,1),(193,1572764400,2),(193,1583654400,1),(193,1604214000,2),(193,1615708800,1),(193,1636268400,2),(193,1647158400,1),(193,1667718000,2),(193,1678608000,1),(193,1699167600,2),(193,1710057600,1),(193,1730617200,2),(193,1741507200,1),(193,1762066800,2),(193,1772956800,1),(193,1793516400,2),(193,1805011200,1),(193,1825570800,2),(193,1836460800,1),(193,1857020400,2),(193,1867910400,1),(193,1888470000,2),(193,1899360000,1),(193,1919919600,2),(193,1930809600,1),(193,1951369200,2),(193,1962864000,1),(193,1983423600,2),(193,1994313600,1),(193,2014873200,2),(193,2025763200,1),(193,2046322800,2),(193,2057212800,1),(193,2077772400,2),(193,2088662400,1),(193,2109222000,2),(193,2120112000,1),(193,2140671600,2),(194,-2147483648,0),(194,-1767209328,2),(194,-1206950400,1),(194,-1191355200,2),(194,-1175367600,1),(194,-1159819200,2),(194,-633812400,1),(194,-622062000,2),(194,-602276400,1),(194,-591825600,2),(194,-570740400,1),(194,-560203200,2),(194,-539118000,1),(194,-531345600,2),(194,-191358000,1),(194,-184190400,2),(194,-155156400,1),(194,-150062400,2),(194,-128890800,1),(194,-121118400,2),(194,-99946800,1),(194,-89582400,2),(194,-68410800,1),(194,-57960000,2),(194,499755600,1),(194,511243200,2),(194,530600400,1),(194,540273600,2),(194,562136400,1),(194,571204800,2),(194,1214283600,3),(194,1384056000,2),(194,2147483647,2),(195,-2147483648,1),(195,-1567453392,2),(195,-1233432000,3),(195,-1222981200,2),(195,-1205956800,3),(195,-1194037200,2),(195,-1172865600,3),(195,-1162501200,2),(195,-1141329600,3),(195,-1130965200,2),(195,-1109793600,3),(195,-1099429200,2),(195,-1078257600,3),(195,-1067806800,2),(195,-1046635200,3),(195,-1036270800,2),(195,-1015099200,3),(195,-1004734800,2),(195,-983563200,3),(195,-973198800,2),(195,-952027200,3),(195,-941576400,2),(195,-931032000,3),(195,-900882000,2),(195,-890337600,3),(195,-833749200,2),(195,-827265600,3),(195,-752274000,2),(195,-733780800,3),(195,-197326800,2),(195,-190843200,3),(195,-184194000,2),(195,-164491200,3),(195,-152658000,2),(195,-132955200,3),(195,-121122000,2),(195,-101419200,3),(195,-86821200,2),(195,-71092800,3),(195,-54766800,2),(195,-39038400,3),(195,-23317200,2),(195,-7588800,5),(195,128142000,4),(195,136605600,5),(195,596948400,4),(195,605066400,5),(195,624423600,4),(195,636516000,5),(195,656478000,4),(195,667965600,2),(195,687931200,4),(195,699415200,5),(195,719377200,4),(195,731469600,5),(195,938919600,3),(195,952052400,5),(195,1198983600,4),(195,1205632800,5),(195,1224385200,4),(195,1237082400,5),(195,2147483647,5),(196,-2147483648,0),(196,-1514739600,1),(196,-1451667600,2),(196,-1343062800,3),(196,-1234803600,2),(196,-1222963200,4),(196,-1207242000,2),(196,-873820800,5),(196,-769395600,6),(196,-761677200,2),(196,-686073600,4),(196,-661539600,2),(196,-495039600,4),(196,-481734000,2),(196,-463590000,4),(196,-450284400,2),(196,-431535600,4),(196,-418230000,2),(196,-400086000,4),(196,-386780400,2),(196,-368636400,4),(196,-355330800,2),(196,-337186800,4),(196,-323881200,2),(196,-305737200,4),(196,-292431600,2),(196,199274400,4),(196,215600400,2),(196,230724000,4),(196,247050000,2),(196,262778400,4),(196,278499600,2),(196,294228000,4),(196,309949200,2),(196,325677600,4),(196,341398800,2),(196,357127200,4),(196,372848400,2),(196,388576800,4),(196,404902800,2),(196,420026400,4),(196,436352400,2),(196,452080800,4),(196,467802000,2),(196,483530400,4),(196,499251600,2),(196,514980000,4),(196,530701200,2),(196,544615200,4),(196,562150800,2),(196,576064800,4),(196,594205200,2),(196,607514400,4),(196,625654800,2),(196,638964000,4),(196,657104400,2),(196,671018400,4),(196,688554000,2),(196,702468000,4),(196,720003600,2),(196,733917600,4),(196,752058000,2),(196,765367200,4),(196,783507600,2),(196,796816800,4),(196,814957200,2),(196,828871200,4),(196,846406800,2),(196,860320800,4),(196,877856400,2),(196,891770400,4),(196,909306000,2),(196,923220000,4),(196,941360400,2),(196,954669600,4),(196,972810000,2),(196,986119200,4),(196,1004259600,2),(196,1018173600,4),(196,1035709200,2),(196,1049623200,4),(196,1067158800,2),(196,1081072800,4),(196,1099213200,2),(196,1112522400,4),(196,1130662800,2),(196,1143972000,4),(196,1162112400,2),(196,1175421600,4),(196,1193562000,2),(196,1207476000,4),(196,1225011600,2),(196,1238925600,4),(196,1256461200,2),(196,1268560800,4),(196,1289120400,2),(196,1300010400,4),(196,1320570000,2),(196,1331460000,4),(196,1352019600,2),(196,1362909600,4),(196,1383469200,2),(196,1394359200,4),(196,1414918800,2),(196,1425808800,4),(196,1446368400,2),(196,1457863200,4),(196,1478422800,2),(196,1489312800,4),(196,1509872400,2),(196,1520762400,4),(196,1541322000,2),(196,1552212000,4),(196,1572771600,2),(196,1583661600,4),(196,1604221200,2),(196,1615716000,4),(196,1636275600,2),(196,1647165600,4),(196,1667725200,2),(196,1678615200,4),(196,1699174800,2),(196,1710064800,4),(196,1730624400,2),(196,1741514400,4),(196,1762074000,2),(196,1772964000,4),(196,1793523600,2),(196,1805018400,4),(196,1825578000,2),(196,1836468000,4),(196,1857027600,2),(196,1867917600,4),(196,1888477200,2),(196,1899367200,4),(196,1919926800,2),(196,1930816800,4),(196,1951376400,2),(196,1962871200,4),(196,1983430800,2),(196,1994320800,4),(196,2014880400,2),(196,2025770400,4),(196,2046330000,2),(196,2057220000,4),(196,2077779600,2),(196,2088669600,4),(196,2109229200,2),(196,2120119200,4),(196,2140678800,2),(197,-2147483648,0),(197,-1767212472,2),(197,-1206954000,1),(197,-1191358800,2),(197,-1175371200,1),(197,-1159822800,2),(197,-633816000,1),(197,-622065600,2),(197,-602280000,1),(197,-591829200,2),(197,-570744000,1),(197,-560206800,2),(197,-539121600,1),(197,-531349200,2),(197,-191361600,1),(197,-184194000,2),(197,-155160000,1),(197,-150066000,2),(197,-128894400,1),(197,-121122000,2),(197,-99950400,1),(197,-89586000,2),(197,-68414400,1),(197,-57963600,2),(197,499752000,1),(197,511239600,2),(197,530596800,1),(197,540270000,2),(197,562132800,1),(197,571201200,2),(197,1214280000,3),(197,2147483647,3),(198,-2147483648,1),(198,-1892661435,2),(198,-1688410800,1),(198,-1619205435,3),(198,-1593806400,1),(198,-1335986235,4),(198,-1317585600,2),(198,-1304362800,4),(198,-1286049600,2),(198,-1272826800,4),(198,-1254513600,2),(198,-1241290800,4),(198,-1222977600,2),(198,-1209754800,4),(198,-1191355200,2),(198,-1178132400,3),(198,-870552000,2),(198,-865278000,3),(198,-740520000,5),(198,-736635600,4),(198,-718056000,2),(198,-713649600,3),(198,-36619200,6),(198,-23922000,7),(198,-3355200,6),(198,7527600,7),(198,24465600,6),(198,37767600,7),(198,55915200,6),(198,69217200,7),(198,87969600,6),(198,100666800,7),(198,118209600,6),(198,132116400,7),(198,150868800,6),(198,163566000,7),(198,182318400,6),(198,195620400,7),(198,213768000,6),(198,227070000,7),(198,245217600,6),(198,258519600,7),(198,277272000,6),(198,289969200,7),(198,308721600,6),(198,321418800,7),(198,340171200,6),(198,353473200,7),(198,371620800,6),(198,384922800,7),(198,403070400,6),(198,416372400,7),(198,434520000,6),(198,447822000,7),(198,466574400,6),(198,479271600,7),(198,498024000,6),(198,510721200,7),(198,529473600,6),(198,545194800,7),(198,560923200,6),(198,574225200,7),(198,592372800,6),(198,605674800,7),(198,624427200,6),(198,637124400,7),(198,653457600,6),(198,668574000,7),(198,687326400,6),(198,700628400,7),(198,718776000,6),(198,732078000,7),(198,750225600,6),(198,763527600,7),(198,781675200,6),(198,794977200,7),(198,813729600,6),(198,826426800,7),(198,845179200,6),(198,859690800,7),(198,876628800,6),(198,889930800,7),(198,906868800,6),(198,923194800,7),(198,939528000,6),(198,952830000,7),(198,971582400,6),(198,984279600,7),(198,1003032000,6),(198,1015729200,7),(198,1034481600,6),(198,1047178800,7),(198,1065931200,6),(198,1079233200,7),(198,1097380800,6),(198,1110682800,7),(198,1128830400,6),(198,1142132400,7),(198,1160884800,6),(198,1173582000,7),(198,1192334400,6),(198,1206846000,7),(198,1223784000,6),(198,1237086000,7),(198,1255233600,6),(198,1270350000,7),(198,1286683200,6),(198,1304823600,7),(198,1313899200,6),(198,1335668400,7),(198,1346558400,6),(198,1367118000,7),(198,1378612800,6),(198,1398567600,7),(198,1410062400,6),(198,1463281200,7),(198,1471147200,6),(198,1494730800,7),(198,1502596800,6),(198,1526180400,7),(198,1534046400,6),(198,1554606000,7),(198,1567915200,6),(198,1586055600,7),(198,1599364800,6),(198,1617505200,7),(198,1630814400,6),(198,1648954800,7),(198,1662868800,6),(198,1680404400,7),(198,1693713600,6),(198,1712458800,7),(198,1725768000,6),(198,1743908400,7),(198,1757217600,6),(198,1775358000,7),(198,1788667200,6),(198,1806807600,7),(198,1820116800,6),(198,1838257200,7),(198,1851566400,6),(198,1870311600,7),(198,1883016000,6),(198,1901761200,7),(198,1915070400,6),(198,1933210800,7),(198,1946520000,6),(198,1964660400,7),(198,1977969600,6),(198,1996110000,7),(198,2009419200,6),(198,2027559600,7),(198,2040868800,6),(198,2059614000,7),(198,2072318400,6),(198,2091063600,7),(198,2104372800,6),(198,2122513200,7),(198,2135822400,6),(198,2147483647,6),(199,-2147483648,1),(199,-1159773600,3),(199,-100119600,2),(199,-89668800,3),(199,-5770800,4),(199,4422600,3),(199,25678800,4),(199,33193800,3),(199,57733200,4),(199,64816200,3),(199,89182800,4),(199,96438600,3),(199,120632400,4),(199,127974600,3),(199,152082000,5),(199,972799200,3),(199,975823200,5),(200,-2147483648,0),(200,-1767214412,2),(200,-1206957600,1),(200,-1191362400,2),(200,-1175374800,1),(200,-1159826400,2),(200,-633819600,1),(200,-622069200,2),(200,-602283600,1),(200,-591832800,2),(200,-570747600,1),(200,-560210400,2),(200,-539125200,1),(200,-531352800,2),(200,-195426000,1),(200,-184197600,2),(200,-155163600,1),(200,-150069600,2),(200,-128898000,1),(200,-121125600,2),(200,-99954000,1),(200,-89589600,2),(200,-68418000,1),(200,-57967200,2),(200,499748400,1),(200,511236000,2),(200,530593200,1),(200,540266400,2),(200,562129200,1),(200,571197600,2),(200,592974000,1),(200,602042400,2),(200,624423600,1),(200,634701600,2),(200,656478000,1),(200,666756000,2),(200,687927600,1),(200,697600800,2),(200,719982000,1),(200,728445600,2),(200,750826800,1),(200,761709600,2),(200,782276400,1),(200,793159200,2),(200,813726000,1),(200,824004000,2),(200,844570800,1),(200,856058400,2),(200,876106800,1),(200,888717600,2),(200,908074800,1),(200,919562400,2),(200,938919600,1),(200,951616800,2),(200,970974000,1),(200,982461600,2),(200,1003028400,1),(200,1013911200,2),(200,1036292400,1),(200,1045360800,2),(200,1066532400,1),(200,1076810400,2),(200,1099364400,1),(200,1108864800,2),(200,1129431600,1),(200,1140314400,2),(200,1162695600,1),(200,1172368800,2),(200,1192330800,1),(200,1203213600,2),(200,1224385200,1),(200,1234663200,2),(200,1255834800,1),(200,1266717600,2),(200,1287284400,1),(200,1298167200,2),(200,1318734000,1),(200,1330221600,2),(200,1350788400,1),(200,1361066400,2),(200,1382238000,1),(200,1392516000,2),(200,1413687600,1),(200,1424570400,2),(200,1445137200,1),(200,1456020000,2),(200,1476586800,1),(200,1487469600,2),(200,1508036400,1),(200,1518919200,2),(200,1541300400,1),(200,1550368800,2),(200,2147483647,2),(201,-2147483648,0),(201,-1686090728,1),(201,323841600,2),(201,338961600,3),(201,354679200,6),(201,370400400,4),(201,386125200,5),(201,401850000,4),(201,417574800,5),(201,433299600,4),(201,449024400,5),(201,465354000,4),(201,481078800,5),(201,496803600,4),(201,512528400,5),(201,528253200,4),(201,543978000,5),(201,559702800,4),(201,575427600,5),(201,591152400,4),(201,606877200,5),(201,622602000,4),(201,638326800,5),(201,654656400,4),(201,670381200,5),(201,686106000,4),(201,701830800,5),(201,717555600,4),(201,733280400,5),(201,749005200,4),(201,764730000,5),(201,780454800,4),(201,796179600,5),(201,811904400,4),(201,828234000,5),(201,846378000,4),(201,859683600,5),(201,877827600,4),(201,891133200,5),(201,909277200,4),(201,922582800,5),(201,941331600,4),(201,954032400,5),(201,972781200,4),(201,985482000,5),(201,1004230800,4),(201,1017536400,5),(201,1035680400,4),(201,1048986000,5),(201,1067130000,4),(201,1080435600,5),(201,1099184400,4),(201,1111885200,5),(201,1130634000,4),(201,1143334800,5),(201,1162083600,4),(201,1174784400,5),(201,1193533200,4),(201,1206838800,5),(201,1224982800,4),(201,1238288400,5),(201,1256432400,4),(201,1269738000,5),(201,1288486800,4),(201,1301187600,5),(201,1319936400,4),(201,1332637200,5),(201,1351386000,4),(201,1364691600,5),(201,1382835600,4),(201,1396141200,5),(201,1414285200,4),(201,1427590800,5),(201,1445734800,4),(201,1459040400,5),(201,1477789200,4),(201,1490490000,5),(201,1509238800,4),(201,1521939600,5),(201,1540688400,4),(201,1553994000,5),(201,1572138000,4),(201,1585443600,5),(201,1603587600,4),(201,1616893200,5),(201,1635642000,4),(201,1648342800,5),(201,1667091600,4),(201,1679792400,5),(201,1698541200,4),(201,1711846800,5),(201,1729990800,4),(201,1743296400,5),(201,1761440400,4),(201,1774746000,5),(201,1792890000,4),(201,1806195600,5),(201,1824944400,4),(201,1837645200,5),(201,1856394000,4),(201,1869094800,5),(201,1887843600,4),(201,1901149200,5),(201,1919293200,4),(201,1932598800,5),(201,1950742800,4),(201,1964048400,5),(201,1982797200,4),(201,1995498000,5),(201,2014246800,4),(201,2026947600,5),(201,2045696400,4),(201,2058397200,5),(201,2077146000,4),(201,2090451600,5),(201,2108595600,4),(201,2121901200,5),(201,2140045200,4),(201,2147483647,4),(202,-2147483648,3),(202,-1633273200,1),(202,-1615132800,2),(202,-1601823600,1),(202,-1583683200,2),(202,-1570374000,1),(202,-1551628800,2),(202,-1538924400,1),(202,-1534089600,2),(202,-880210800,4),(202,-769395600,5),(202,-765388800,2),(202,-147884400,1),(202,-131558400,2),(202,-116434800,1),(202,-100108800,2),(202,-84380400,1),(202,-68659200,2),(202,-52930800,1),(202,-37209600,2),(202,-21481200,1),(202,-5760000,2),(202,9968400,1),(202,25689600,2),(202,41418000,1),(202,57744000,2),(202,73472400,1),(202,89193600,2),(202,104922000,1),(202,120643200,2),(202,126694800,1),(202,152092800,2),(202,162378000,1),(202,183542400,2),(202,199270800,1),(202,215596800,2),(202,230720400,1),(202,247046400,2),(202,262774800,1),(202,278496000,2),(202,294224400,1),(202,309945600,2),(202,325674000,1),(202,341395200,2),(202,357123600,1),(202,372844800,2),(202,388573200,1),(202,404899200,2),(202,420022800,1),(202,436348800,2),(202,452077200,1),(202,467798400,2),(202,483526800,1),(202,499248000,2),(202,514976400,1),(202,530697600,2),(202,544611600,1),(202,562147200,2),(202,576061200,1),(202,594201600,2),(202,607510800,1),(202,625651200,2),(202,638960400,1),(202,657100800,2),(202,671014800,1),(202,688550400,2),(202,702464400,1),(202,720000000,2),(202,733914000,1),(202,752054400,2),(202,765363600,1),(202,783504000,2),(202,796813200,1),(202,814953600,2),(202,828867600,1),(202,846403200,2),(202,860317200,1),(202,877852800,2),(202,891766800,1),(202,909302400,2),(202,923216400,1),(202,941356800,2),(202,954666000,1),(202,972806400,2),(202,986115600,1),(202,1004256000,2),(202,1018170000,1),(202,1035705600,2),(202,1049619600,1),(202,1067155200,2),(202,1081069200,1),(202,1099209600,2),(202,1112518800,1),(202,1130659200,2),(202,1143968400,1),(202,1162108800,2),(202,1173603600,1),(202,1194163200,2),(202,1205053200,1),(202,1225612800,2),(202,1236502800,1),(202,1257062400,2),(202,1268557200,1),(202,1289116800,2),(202,1300006800,1),(202,1320566400,2),(202,1331456400,1),(202,1352016000,2),(202,1362906000,1),(202,1383465600,2),(202,1394355600,1),(202,1414915200,2),(202,1425805200,1),(202,1446364800,2),(202,1457859600,1),(202,1478419200,2),(202,1489309200,1),(202,1509868800,2),(202,1520758800,1),(202,1541318400,2),(202,1552208400,1),(202,1572768000,2),(202,1583658000,1),(202,1604217600,2),(202,1615712400,1),(202,1636272000,2),(202,1647162000,1),(202,1667721600,2),(202,1678611600,1),(202,1699171200,2),(202,1710061200,1),(202,1730620800,2),(202,1741510800,1),(202,1762070400,2),(202,1772960400,1),(202,1793520000,2),(202,1805014800,1),(202,1825574400,2),(202,1836464400,1),(202,1857024000,2),(202,1867914000,1),(202,1888473600,2),(202,1899363600,1),(202,1919923200,2),(202,1930813200,1),(202,1951372800,2),(202,1962867600,1),(202,1983427200,2),(202,1994317200,1),(202,2014876800,2),(202,2025766800,1),(202,2046326400,2),(202,2057216400,1),(202,2077776000,2),(202,2088666000,1),(202,2109225600,2),(202,2120115600,1),(202,2140675200,2),(203,-2147483648,1),(203,-880207200,2),(203,-769395600,3),(203,-765385200,1),(203,-21477600,4),(203,-5756400,1),(203,9972000,4),(203,25693200,1),(203,41421600,4),(203,57747600,1),(203,73476000,4),(203,89197200,1),(203,104925600,4),(203,120646800,1),(203,126698400,4),(203,152096400,1),(203,162381600,4),(203,183546000,1),(203,199274400,4),(203,215600400,1),(203,230724000,4),(203,247050000,1),(203,262778400,4),(203,278499600,1),(203,294228000,4),(203,309949200,1),(203,325677600,4),(203,341398800,1),(203,357127200,4),(203,372848400,1),(203,388576800,4),(203,404902800,1),(203,420026400,4),(203,436352400,5),(203,439030800,7),(203,452084400,6),(203,467805600,7),(203,483534000,6),(203,499255200,7),(203,514983600,6),(203,530704800,7),(203,544618800,6),(203,562154400,7),(203,576068400,6),(203,594208800,7),(203,607518000,6),(203,625658400,7),(203,638967600,6),(203,657108000,7),(203,671022000,6),(203,688557600,7),(203,702471600,6),(203,720007200,7),(203,733921200,6),(203,752061600,7),(203,765370800,6),(203,783511200,7),(203,796820400,6),(203,814960800,7),(203,828874800,6),(203,846410400,7),(203,860324400,6),(203,877860000,7),(203,891774000,6),(203,909309600,7),(203,923223600,6),(203,941364000,7),(203,954673200,6),(203,972813600,7),(203,986122800,6),(203,1004263200,7),(203,1018177200,6),(203,1035712800,7),(203,1049626800,6),(203,1067162400,7),(203,1081076400,6),(203,1099216800,7),(203,1112526000,6),(203,1130666400,7),(203,1143975600,6),(203,1162116000,7),(203,1173610800,6),(203,1194170400,7),(203,1205060400,6),(203,1225620000,7),(203,1236510000,6),(203,1257069600,7),(203,1268564400,6),(203,1289124000,7),(203,1300014000,6),(203,1320573600,7),(203,1331463600,6),(203,1352023200,7),(203,1362913200,6),(203,1383472800,7),(203,1394362800,6),(203,1414922400,7),(203,1425812400,6),(203,1446372000,7),(203,1457866800,6),(203,1478426400,7),(203,1489316400,6),(203,1509876000,7),(203,1520766000,6),(203,1541325600,7),(203,1552215600,6),(203,1572775200,7),(203,1583665200,6),(203,1604224800,7),(203,1615719600,6),(203,1636279200,7),(203,1647169200,6),(203,1667728800,7),(203,1678618800,6),(203,1699178400,7),(203,1710068400,6),(203,1730628000,7),(203,1741518000,6),(203,1762077600,7),(203,1772967600,6),(203,1793527200,7),(203,1805022000,6),(203,1825581600,7),(203,1836471600,6),(203,1857031200,7),(203,1867921200,6),(203,1888480800,7),(203,1899370800,6),(203,1919930400,7),(203,1930820400,6),(203,1951380000,7),(203,1962874800,6),(203,1983434400,7),(203,1994324400,6),(203,2014884000,7),(203,2025774000,6),(203,2046333600,7),(203,2057223600,6),(203,2077783200,7),(203,2088673200,6),(203,2109232800,7),(203,2120122800,6),(203,2140682400,7),(204,-2147483648,1),(204,-873057600,3),(204,-769395600,2),(204,-765399600,1),(205,-2147483648,2),(205,-1664130548,1),(205,-1650137348,2),(205,-1632076148,1),(205,-1615145348,2),(205,-1598650148,1),(205,-1590100148,2),(205,-1567286948,1),(205,-1551565748,2),(205,-1535837348,1),(205,-1520116148,2),(205,-1503782948,1),(205,-1488666548,2),(205,-1472333348,1),(205,-1457216948,2),(205,-1440883748,1),(205,-1425767348,2),(205,-1409434148,1),(205,-1394317748,2),(205,-1377984548,1),(205,-1362263348,2),(205,-1346534948,1),(205,-1330813748,2),(205,-1314480548,1),(205,-1299364148,2),(205,-1283030948,1),(205,-1267914548,2),(205,-1251581348,1),(205,-1236464948,2),(205,-1220131748,1),(205,-1205015348,2),(205,-1188682148,1),(205,-1172960948,2),(205,-1156627748,1),(205,-1141511348,2),(205,-1125178148,1),(205,-1110061748,2),(205,-1096921748,4),(205,-1093728600,3),(205,-1078612200,4),(205,-1061670600,3),(205,-1048973400,4),(205,-1030221000,3),(205,-1017523800,4),(205,-998771400,3),(205,-986074200,4),(205,-966717000,3),(205,-954624600,4),(205,-935267400,3),(205,-922570200,4),(205,-903817800,3),(205,-891120600,4),(205,-872368200,6),(205,-769395600,5),(205,-765401400,4),(205,-746044200,3),(205,-733347000,4),(205,-714594600,3),(205,-701897400,4),(205,-683145000,3),(205,-670447800,4),(205,-651695400,3),(205,-638998200,4),(205,-619641000,3),(205,-606943800,4),(205,-589401000,3),(205,-576099000,4),(205,-557951400,3),(205,-544649400,4),(205,-526501800,3),(205,-513199800,4),(205,-495052200,3),(205,-481750200,4),(205,-463602600,3),(205,-450300600,4),(205,-431548200,3),(205,-418246200,4),(205,-400098600,3),(205,-386796600,4),(205,-368649000,3),(205,-355347000,4),(205,-337199400,3),(205,-323897400,4),(205,-305749800,3),(205,-289423800,4),(205,-273695400,3),(205,-257974200,4),(205,-242245800,3),(205,-226524600,4),(205,-210796200,3),(205,-195075000,4),(205,-179346600,3),(205,-163625400,4),(205,-147897000,3),(205,-131571000,4),(205,-116447400,3),(205,-100121400,4),(205,-84393000,3),(205,-68671800,4),(205,-52943400,3),(205,-37222200,4),(205,-21493800,3),(205,-5772600,4),(205,9955800,3),(205,25677000,4),(205,41405400,3),(205,57731400,4),(205,73459800,3),(205,89181000,4),(205,104909400,3),(205,120630600,4),(205,136359000,3),(205,152080200,4),(205,167808600,3),(205,183529800,4),(205,199258200,3),(205,215584200,4),(205,230707800,3),(205,247033800,4),(205,262762200,3),(205,278483400,4),(205,294211800,3),(205,309933000,4),(205,325661400,3),(205,341382600,4),(205,357111000,3),(205,372832200,4),(205,388560600,3),(205,404886600,4),(205,420010200,3),(205,436336200,4),(205,452064600,3),(205,467785800,4),(205,483514200,3),(205,499235400,4),(205,514963800,3),(205,530685000,4),(205,544591860,3),(205,562127460,4),(205,576041460,7),(205,594178260,4),(205,607491060,3),(205,625631460,4),(205,638940660,3),(205,657081060,4),(205,670995060,3),(205,688530660,4),(205,702444660,3),(205,719980260,4),(205,733894260,3),(205,752034660,4),(205,765343860,3),(205,783484260,4),(205,796793460,3),(205,814933860,4),(205,828847860,3),(205,846383460,4),(205,860297460,3),(205,877833060,4),(205,891747060,3),(205,909282660,4),(205,923196660,3),(205,941337060,4),(205,954646260,3),(205,972786660,4),(205,986095860,3),(205,1004236260,4),(205,1018150260,3),(205,1035685860,4),(205,1049599860,3),(205,1067135460,4),(205,1081049460,3),(205,1099189860,4),(205,1112499060,3),(205,1130639460,4),(205,1143948660,3),(205,1162089060,4),(205,1173583860,3),(205,1194143460,4),(205,1205033460,3),(205,1225593060,4),(205,1236483060,3),(205,1257042660,4),(205,1268537460,3),(205,1289097060,4),(205,1299987060,3),(205,1320553800,4),(205,1331443800,3),(205,1352003400,4),(205,1362893400,3),(205,1383453000,4),(205,1394343000,3),(205,1414902600,4),(205,1425792600,3),(205,1446352200,4),(205,1457847000,3),(205,1478406600,4),(205,1489296600,3),(205,1509856200,4),(205,1520746200,3),(205,1541305800,4),(205,1552195800,3),(205,1572755400,4),(205,1583645400,3),(205,1604205000,4),(205,1615699800,3),(205,1636259400,4),(205,1647149400,3),(205,1667709000,4),(205,1678599000,3),(205,1699158600,4),(205,1710048600,3),(205,1730608200,4),(205,1741498200,3),(205,1762057800,4),(205,1772947800,3),(205,1793507400,4),(205,1805002200,3),(205,1825561800,4),(205,1836451800,3),(205,1857011400,4),(205,1867901400,3),(205,1888461000,4),(205,1899351000,3),(205,1919910600,4),(205,1930800600,3),(205,1951360200,4),(205,1962855000,3),(205,1983414600,4),(205,1994304600,3),(205,2014864200,4),(205,2025754200,3),(205,2046313800,4),(205,2057203800,3),(205,2077763400,4),(205,2088653400,3),(205,2109213000,4),(205,2120103000,3),(205,2140662600,4),(206,-2147483648,1),(206,-873057600,3),(206,-769395600,2),(206,-765399600,1),(207,-2147483648,1),(207,-873057600,3),(207,-769395600,2),(207,-765399600,1),(208,-2147483648,1),(208,-873057600,3),(208,-769395600,2),(208,-765399600,1),(209,-2147483648,1),(209,-873057600,3),(209,-769395600,2),(209,-765399600,1),(210,-2147483648,0),(210,-2030201320,2),(210,-1632063600,1),(210,-1615132800,2),(210,-880210800,3),(210,-769395600,4),(210,-765388800,2),(210,-747241200,1),(210,-732729600,2),(210,-715791600,1),(210,-702489600,2),(210,-684342000,1),(210,-671040000,2),(210,-652892400,1),(210,-639590400,2),(210,-400086000,1),(210,-384364800,2),(210,-337186800,1),(210,-321465600,2),(210,-305737200,1),(210,-292435200,2),(210,-273682800,1),(210,-260985600,2),(210,73472400,5),(211,-2147483648,0),(211,-1538503868,2),(211,547020000,1),(211,559717200,2),(211,578469600,1),(211,591166800,2),(211,1146981600,1),(211,1154926800,2),(212,-2147483648,0),(212,-1686079492,2),(212,670399200,1),(212,686120400,2),(212,701848800,1),(212,717570000,2),(212,733903200,1),(212,752043600,2),(212,765352800,1),(212,783493200,2),(212,796802400,1),(212,814942800,2),(212,828856800,1),(212,846392400,2),(212,860306400,1),(212,877842000,2),(212,891756000,1),(212,909291600,2),(212,923205600,1),(212,941346000,2),(212,954655200,1),(212,972795600,2),(212,986104800,1),(212,1004245200,2),(212,1018159200,1),(212,1035694800,2),(212,1049608800,1),(212,1067144400,2),(212,1081058400,1),(212,1099198800,2),(212,1112508000,1),(212,1130648400,2),(212,1143957600,1),(212,1162098000,2),(212,1173592800,1),(212,1194152400,2),(212,1205042400,1),(212,1225602000,2),(212,1236492000,1),(212,1257051600,2),(212,1268546400,1),(212,1289106000,2),(212,1299996000,1),(212,1320555600,2),(212,1331445600,1),(212,1352005200,2),(212,1362895200,1),(212,1383454800,2),(212,1394344800,1),(212,1414904400,2),(212,1425794400,1),(212,1446354000,2),(212,1457848800,1),(212,1478408400,2),(212,1489298400,1),(212,1509858000,2),(212,1520748000,1),(212,1541307600,2),(212,1552197600,1),(212,1572757200,2),(212,1583647200,1),(212,1604206800,2),(212,1615701600,1),(212,1636261200,2),(212,1647151200,1),(212,1667710800,2),(212,1678600800,1),(212,1699160400,2),(212,1710050400,1),(212,1730610000,2),(212,1741500000,1),(212,1762059600,2),(212,1772949600,1),(212,1793509200,2),(212,1805004000,1),(212,1825563600,2),(212,1836453600,1),(212,1857013200,2),(212,1867903200,1),(212,1888462800,2),(212,1899352800,1),(212,1919912400,2),(212,1930802400,1),(212,1951362000,2),(212,1962856800,1),(212,1983416400,2),(212,1994306400,1),(212,2014866000,2),(212,2025756000,1),(212,2046315600,2),(212,2057205600,1),(212,2077765200,2),(212,2088655200,1),(212,2109214800,2),(212,2120104800,1),(212,2140664400,2),(213,-2147483648,2),(213,-1632070800,1),(213,-1615140000,2),(213,-1601753400,1),(213,-1583697600,2),(213,-1567357200,1),(213,-1554667200,2),(213,-1534698000,1),(213,-1524074400,2),(213,-1503248400,1),(213,-1492365600,2),(213,-1471798800,1),(213,-1460916000,2),(213,-1440954000,1),(213,-1428861600,2),(213,-1409504400,1),(213,-1397412000,2),(213,-1378054800,1),(213,-1365962400,2),(213,-1346605200,1),(213,-1333908000,2),(213,-1315155600,1),(213,-1301853600,2),(213,-1283706000,1),(213,-1270404000,2),(213,-1252256400,1),(213,-1238954400,2),(213,-1220806800,1),(213,-1207504800,2),(213,-1188752400,1),(213,-1176055200,2),(213,-1157302800,1),(213,-1144000800,2),(213,-1125853200,1),(213,-1112551200,2),(213,-1094403600,1),(213,-1081101600,2),(213,-1062954000,1),(213,-1049652000,2),(213,-1031504400,1),(213,-1018202400,2),(213,-1000054800,1),(213,-986752800,2),(213,-968000400,1),(213,-955303200,2),(213,-936550800,1),(213,-880218000,3),(213,-769395600,4),(213,-765396000,2),(213,-747248400,1),(213,-733946400,2),(213,-715806000,1),(213,-702504000,2),(213,-684356400,1),(213,-671054400,2),(213,-652906800,1),(213,-634161600,2),(213,-620845200,1),(213,-602704800,2),(213,-589395600,1),(213,-576093600,2),(213,-557946000,1),(213,-544644000,2),(213,-526496400,1),(213,-513194400,2),(213,-495046800,1),(213,-481744800,2),(213,-463597200,1),(213,-450295200,2),(213,-431542800,1),(213,-418240800,2),(213,-400093200,1),(213,-384372000,2),(213,-368643600,1),(213,-352922400,2),(213,-337194000,1),(213,-321472800,2),(213,-305744400,1),(213,-289418400,2),(213,-273690000,1),(213,-257968800,2),(213,-242240400,1),(213,-226519200,2),(213,-210790800,1),(213,-195069600,2),(213,-179341200,1),(213,-163620000,2),(213,-147891600,1),(213,-131565600,2),(213,-116442000,1),(213,-100116000,2),(213,-84387600,1),(213,-68666400,2),(213,-52938000,1),(213,-37216800,2),(213,-21488400,1),(213,-5767200,2),(213,9961200,1),(213,25682400,2),(213,41410800,1),(213,57736800,2),(213,73465200,1),(213,89186400,2),(213,104914800,1),(213,120636000,2),(213,136364400,1),(213,152085600,2),(213,167814000,1),(213,183535200,2),(213,199263600,1),(213,215589600,2),(213,230713200,1),(213,247039200,2),(213,262767600,1),(213,278488800,2),(213,294217200,1),(213,309938400,2),(213,325666800,1),(213,341388000,2),(213,357116400,1),(213,372837600,2),(213,388566000,1),(213,404892000,2),(213,420015600,1),(213,436341600,2),(213,452070000,1),(213,467791200,2),(213,483519600,1),(213,499240800,2),(213,514969200,1),(213,530690400,2),(213,544604400,1),(213,562140000,2),(213,576054000,1),(213,594194400,2),(213,607503600,1),(213,625644000,2),(213,638953200,1),(213,657093600,2),(213,671007600,1),(213,688543200,2),(213,702457200,1),(213,719992800,2),(213,733906800,1),(213,752047200,2),(213,765356400,1),(213,783496800,2),(213,796806000,1),(213,814946400,2),(213,828860400,1),(213,846396000,2),(213,860310000,1),(213,877845600,2),(213,891759600,1),(213,909295200,2),(213,923209200,1),(213,941349600,2),(213,954658800,1),(213,972799200,2),(213,986108400,1),(213,1004248800,2),(213,1018162800,1),(213,1035698400,2),(213,1049612400,1),(213,1067148000,2),(213,1081062000,1),(213,1099202400,2),(213,1112511600,1),(213,1130652000,2),(213,1143961200,1),(213,1162101600,2),(213,1173596400,1),(213,1194156000,2),(213,1205046000,1),(213,1225605600,2),(213,1236495600,1),(213,1257055200,2),(213,1268550000,1),(213,1289109600,2),(213,1299999600,1),(213,1320559200,2),(213,1331449200,1),(213,1352008800,2),(213,1362898800,1),(213,1383458400,2),(213,1394348400,1),(213,1414908000,2),(213,1425798000,1),(213,1446357600,2),(213,1457852400,1),(213,1478412000,2),(213,1489302000,1),(213,1509861600,2),(213,1520751600,1),(213,1541311200,2),(213,1552201200,1),(213,1572760800,2),(213,1583650800,1),(213,1604210400,2),(213,1615705200,1),(213,1636264800,2),(213,1647154800,1),(213,1667714400,2),(213,1678604400,1),(213,1699164000,2),(213,1710054000,1),(213,1730613600,2),(213,1741503600,1),(213,1762063200,2),(213,1772953200,1),(213,1793512800,2),(213,1805007600,1),(213,1825567200,2),(213,1836457200,1),(213,1857016800,2),(213,1867906800,1),(213,1888466400,2),(213,1899356400,1),(213,1919916000,2),(213,1930806000,1),(213,1951365600,2),(213,1962860400,1),(213,1983420000,2),(213,1994310000,1),(213,2014869600,2),(213,2025759600,1),(213,2046319200,2),(213,2057209200,1),(213,2077768800,2),(213,2088658800,1),(213,2109218400,2),(213,2120108400,1),(213,2140668000,2),(214,-2147483648,0),(214,-1514739600,1),(214,-1451667600,2),(214,-1343062800,3),(214,-1234803600,2),(214,-1222963200,4),(214,-1207242000,2),(214,-873820800,5),(214,-769395600,6),(214,-761677200,2),(214,-686073600,4),(214,-661539600,2),(214,-495039600,4),(214,-481734000,2),(214,-463590000,4),(214,-450284400,2),(214,-431535600,4),(214,-418230000,2),(214,-400086000,4),(214,-386780400,2),(214,-368636400,4),(214,-355330800,2),(214,-337186800,4),(214,-323881200,2),(214,-305737200,4),(214,-292431600,2),(214,199274400,4),(214,215600400,2),(214,230724000,4),(214,247050000,2),(214,262778400,4),(214,278499600,2),(214,294228000,4),(214,309949200,2),(214,325677600,4),(214,341398800,2),(214,357127200,4),(214,372848400,2),(214,388576800,4),(214,404902800,2),(214,420026400,4),(214,436352400,2),(214,452080800,4),(214,467802000,2),(214,483530400,4),(214,499251600,2),(214,514980000,4),(214,530701200,2),(214,544615200,4),(214,562150800,2),(214,576064800,4),(214,594205200,2),(214,607514400,4),(214,625654800,2),(214,638964000,4),(214,657104400,2),(214,671018400,4),(214,688554000,2),(214,702468000,4),(214,720003600,2),(214,733917600,4),(214,752058000,2),(214,765367200,4),(214,783507600,2),(214,796816800,4),(214,814957200,2),(214,828871200,4),(214,846406800,2),(214,860320800,4),(214,877856400,2),(214,891770400,4),(214,909306000,2),(214,923220000,4),(214,941360400,2),(214,954669600,4),(214,972810000,2),(214,986119200,4),(214,1004259600,2),(214,1018173600,4),(214,1035709200,2),(214,1049623200,4),(214,1067158800,2),(214,1081072800,4),(214,1099213200,2),(214,1112522400,4),(214,1130662800,2),(214,1143972000,4),(214,1162112400,2),(214,1175421600,4),(214,1193562000,2),(214,1207476000,4),(214,1225011600,2),(214,1238925600,4),(214,1256461200,2),(214,1268560800,4),(214,1289120400,2),(214,1300010400,4),(214,1320570000,2),(214,1331460000,4),(214,1352019600,2),(214,1362909600,4),(214,1383469200,2),(214,1394359200,4),(214,1414918800,2),(214,1425808800,4),(214,1446368400,2),(214,1457863200,4),(214,1478422800,2),(214,1489312800,4),(214,1509872400,2),(214,1520762400,4),(214,1541322000,2),(214,1552212000,4),(214,1572771600,2),(214,1583661600,4),(214,1604221200,2),(214,1615716000,4),(214,1636275600,2),(214,1647165600,4),(214,1667725200,2),(214,1678615200,4),(214,1699174800,2),(214,1710064800,4),(214,1730624400,2),(214,1741514400,4),(214,1762074000,2),(214,1772964000,4),(214,1793523600,2),(214,1805018400,4),(214,1825578000,2),(214,1836468000,4),(214,1857027600,2),(214,1867917600,4),(214,1888477200,2),(214,1899367200,4),(214,1919926800,2),(214,1930816800,4),(214,1951376400,2),(214,1962871200,4),(214,1983430800,2),(214,1994320800,4),(214,2014880400,2),(214,2025770400,4),(214,2046330000,2),(214,2057220000,4),(214,2077779600,2),(214,2088669600,4),(214,2109229200,2),(214,2120119200,4),(214,2140678800,2),(215,-2147483648,2),(215,-1632070800,1),(215,-1615140000,2),(215,-1601753400,1),(215,-1583697600,2),(215,-1567357200,1),(215,-1554667200,2),(215,-1534698000,1),(215,-1524074400,2),(215,-1503248400,1),(215,-1492365600,2),(215,-1471798800,1),(215,-1460916000,2),(215,-1440954000,1),(215,-1428861600,2),(215,-1409504400,1),(215,-1397412000,2),(215,-1378054800,1),(215,-1365962400,2),(215,-1346605200,1),(215,-1333908000,2),(215,-1315155600,1),(215,-1301853600,2),(215,-1283706000,1),(215,-1270404000,2),(215,-1252256400,1),(215,-1238954400,2),(215,-1220806800,1),(215,-1207504800,2),(215,-1188752400,1),(215,-1176055200,2),(215,-1157302800,1),(215,-1144000800,2),(215,-1125853200,1),(215,-1112551200,2),(215,-1094403600,1),(215,-1081101600,2),(215,-1062954000,1),(215,-1049652000,2),(215,-1031504400,1),(215,-1018202400,2),(215,-1000054800,1),(215,-986752800,2),(215,-968000400,1),(215,-955303200,2),(215,-936550800,1),(215,-880218000,3),(215,-769395600,4),(215,-765396000,2),(215,-747248400,1),(215,-733946400,2),(215,-715806000,1),(215,-702504000,2),(215,-684356400,1),(215,-671054400,2),(215,-652906800,1),(215,-634161600,2),(215,-620845200,1),(215,-602704800,2),(215,-589395600,1),(215,-576093600,2),(215,-557946000,1),(215,-544644000,2),(215,-526496400,1),(215,-513194400,2),(215,-495046800,1),(215,-481744800,2),(215,-463597200,1),(215,-450295200,2),(215,-431542800,1),(215,-418240800,2),(215,-400093200,1),(215,-384372000,2),(215,-368643600,1),(215,-352922400,2),(215,-337194000,1),(215,-321472800,2),(215,-305744400,1),(215,-289418400,2),(215,-273690000,1),(215,-257968800,2),(215,-242240400,1),(215,-226519200,2),(215,-210790800,1),(215,-195069600,2),(215,-179341200,1),(215,-163620000,2),(215,-147891600,1),(215,-131565600,2),(215,-116442000,1),(215,-100116000,2),(215,-84387600,1),(215,-68666400,2),(215,-52938000,1),(215,-37216800,2),(215,-21488400,1),(215,-5767200,2),(215,9961200,1),(215,25682400,2),(215,41410800,1),(215,57736800,2),(215,73465200,1),(215,89186400,2),(215,104914800,1),(215,120636000,2),(215,136364400,1),(215,152085600,2),(215,167814000,1),(215,183535200,2),(215,199263600,1),(215,215589600,2),(215,230713200,1),(215,247039200,2),(215,262767600,1),(215,278488800,2),(215,294217200,1),(215,309938400,2),(215,325666800,1),(215,341388000,2),(215,357116400,1),(215,372837600,2),(215,388566000,1),(215,404892000,2),(215,420015600,1),(215,436341600,2),(215,452070000,1),(215,467791200,2),(215,483519600,1),(215,499240800,2),(215,514969200,1),(215,530690400,2),(215,544604400,1),(215,562140000,2),(215,576054000,1),(215,594194400,2),(215,607503600,1),(215,625644000,2),(215,638953200,1),(215,657093600,2),(215,671007600,1),(215,688543200,2),(215,702457200,1),(215,719992800,2),(215,733906800,1),(215,752047200,2),(215,765356400,1),(215,783496800,2),(215,796806000,1),(215,814946400,2),(215,828860400,1),(215,846396000,2),(215,860310000,1),(215,877845600,2),(215,891759600,1),(215,909295200,2),(215,923209200,1),(215,941349600,2),(215,954658800,1),(215,972799200,2),(215,986108400,1),(215,1004248800,2),(215,1018162800,1),(215,1035698400,2),(215,1049612400,1),(215,1067148000,2),(215,1081062000,1),(215,1099202400,2),(215,1112511600,1),(215,1130652000,2),(215,1143961200,1),(215,1162101600,2),(215,1173596400,1),(215,1194156000,2),(215,1205046000,1),(215,1225605600,2),(215,1236495600,1),(215,1257055200,2),(215,1268550000,1),(215,1289109600,2),(215,1299999600,1),(215,1320559200,2),(215,1331449200,1),(215,1352008800,2),(215,1362898800,1),(215,1383458400,2),(215,1394348400,1),(215,1414908000,2),(215,1425798000,1),(215,1446357600,2),(215,1457852400,1),(215,1478412000,2),(215,1489302000,1),(215,1509861600,2),(215,1520751600,1),(215,1541311200,2),(215,1552201200,1),(215,1572760800,2),(215,1583650800,1),(215,1604210400,2),(215,1615705200,1),(215,1636264800,2),(215,1647154800,1),(215,1667714400,2),(215,1678604400,1),(215,1699164000,2),(215,1710054000,1),(215,1730613600,2),(215,1741503600,1),(215,1762063200,2),(215,1772953200,1),(215,1793512800,2),(215,1805007600,1),(215,1825567200,2),(215,1836457200,1),(215,1857016800,2),(215,1867906800,1),(215,1888466400,2),(215,1899356400,1),(215,1919916000,2),(215,1930806000,1),(215,1951365600,2),(215,1962860400,1),(215,1983420000,2),(215,1994310000,1),(215,2014869600,2),(215,2025759600,1),(215,2046319200,2),(215,2057209200,1),(215,2077768800,2),(215,2088658800,1),(215,2109218400,2),(215,2120108400,1),(215,2140668000,2),(216,-2147483648,1),(216,-873057600,3),(216,-769395600,2),(216,-765399600,1),(217,-2147483648,2),(217,-1632060000,1),(217,-1615129200,2),(217,-880207200,3),(217,-769395600,4),(217,-765385200,2),(217,-747237600,1),(217,-733935600,2),(217,-715788000,1),(217,-702486000,2),(217,-684338400,1),(217,-671036400,2),(217,-652888800,1),(217,-639586800,2),(217,-620834400,1),(217,-608137200,2),(217,-589384800,1),(217,-576082800,2),(217,-557935200,1),(217,-544633200,2),(217,-526485600,1),(217,-513183600,2),(217,-495036000,1),(217,-481734000,2),(217,-463586400,1),(217,-450284400,2),(217,-431532000,1),(217,-418230000,2),(217,-400082400,1),(217,-386780400,2),(217,-368632800,1),(217,-355330800,2),(217,-337183200,1),(217,-323881200,2),(217,-305733600,1),(217,-292431600,2),(217,-273679200,1),(217,-260982000,2),(217,-242229600,1),(217,-226508400,2),(217,-210780000,1),(217,-195058800,2),(217,-179330400,1),(217,-163609200,2),(217,-147880800,1),(217,-131554800,2),(217,-116431200,1),(217,-100105200,2),(217,-84376800,1),(217,-68655600,2),(217,-52927200,1),(217,-37206000,2),(217,-21477600,1),(217,-5756400,2),(217,9972000,1),(217,25693200,2),(217,41421600,1),(217,57747600,2),(217,73476000,1),(217,89197200,2),(217,104925600,1),(217,120646800,2),(217,136375200,1),(217,152096400,2),(217,167824800,1),(217,183546000,2),(217,199274400,1),(217,215600400,2),(217,230724000,1),(217,247050000,2),(217,262778400,1),(217,278499600,2),(217,294228000,1),(217,309949200,2),(217,325677600,1),(217,341398800,2),(217,357127200,1),(217,372848400,2),(217,388576800,1),(217,404902800,2),(217,420026400,1),(217,436352400,2),(217,452080800,1),(217,467802000,2),(217,483530400,1),(217,499251600,2),(217,514980000,1),(217,530701200,2),(217,544615200,1),(217,562150800,2),(217,576064800,1),(217,594205200,2),(217,607514400,1),(217,625654800,2),(217,638964000,1),(217,657104400,2),(217,671018400,1),(217,688554000,2),(217,702468000,1),(217,720003600,2),(217,733917600,1),(217,752058000,2),(217,765367200,1),(217,783507600,2),(217,796816800,1),(217,814957200,2),(217,828871200,1),(217,846406800,2),(217,860320800,1),(217,877856400,2),(217,891770400,1),(217,909306000,2),(217,923220000,1),(217,941360400,2),(217,954669600,1),(217,972810000,2),(217,986119200,1),(217,1004259600,2),(217,1018173600,1),(217,1035709200,2),(217,1049623200,1),(217,1067158800,2),(217,1081072800,1),(217,1099213200,2),(217,1112522400,1),(217,1130662800,2),(217,1143972000,1),(217,1162112400,2),(217,1173607200,1),(217,1194166800,2),(217,1205056800,1),(217,1225616400,2),(217,1236506400,1),(217,1257066000,2),(217,1268560800,1),(217,1289120400,2),(217,1300010400,1),(217,1320570000,2),(217,1331460000,1),(217,1352019600,2),(217,1362909600,1),(217,1383469200,2),(217,1394359200,1),(217,1414918800,2),(217,1425808800,1),(217,1446368400,2),(217,1457863200,1),(217,1478422800,2),(217,1489312800,1),(217,1509872400,2),(217,1520762400,1),(217,1541322000,2),(217,1552212000,1),(217,1572771600,2),(217,1583661600,1),(217,1604221200,2),(217,1615716000,1),(217,1636275600,2),(217,1647165600,1),(217,1667725200,2),(217,1678615200,1),(217,1699174800,2),(217,1710064800,1),(217,1730624400,2),(217,1741514400,1),(217,1762074000,2),(217,1772964000,1),(217,1793523600,2),(217,1805018400,1),(217,1825578000,2),(217,1836468000,1),(217,1857027600,2),(217,1867917600,1),(217,1888477200,2),(217,1899367200,1),(217,1919926800,2),(217,1930816800,1),(217,1951376400,2),(217,1962871200,1),(217,1983430800,2),(217,1994320800,1),(217,2014880400,2),(217,2025770400,1),(217,2046330000,2),(217,2057220000,1),(217,2077779600,2),(217,2088669600,1),(217,2109229200,2),(217,2120119200,1),(217,2140678800,2),(218,-2147483648,1),(218,-873057600,3),(218,-769395600,2),(218,-765399600,1),(219,-2147483648,2),(219,-1632056400,1),(219,-1615125600,2),(219,-1596978000,1),(219,-1583164800,2),(219,-880203600,3),(219,-769395600,4),(219,-765381600,2),(219,-147884400,5),(219,-131554800,2),(219,-121273200,6),(219,325677600,7),(219,341398800,6),(219,357127200,7),(219,372848400,6),(219,388576800,7),(219,404902800,6),(219,420026400,7),(219,436352400,6),(219,452080800,7),(219,467802000,6),(219,483530400,7),(219,499251600,6),(219,514980000,7),(219,530701200,6),(219,544615200,7),(219,562150800,6),(219,576064800,7),(219,594205200,6),(219,607514400,7),(219,625654800,6),(219,638964000,7),(219,657104400,6),(219,671018400,7),(219,688554000,6),(219,702468000,7),(219,720003600,6),(219,733917600,7),(219,752058000,6),(219,765367200,7),(219,783507600,6),(219,796816800,7),(219,814957200,6),(219,828871200,7),(219,846406800,6),(219,860320800,7),(219,877856400,6),(219,891770400,7),(219,909306000,6),(219,923220000,7),(219,941360400,6),(219,954669600,7),(219,972810000,6),(219,986119200,7),(219,1004259600,6),(219,1018173600,7),(219,1035709200,6),(219,1049623200,7),(219,1067158800,6),(219,1081072800,7),(219,1099213200,6),(219,1112522400,7),(219,1130662800,6),(219,1143972000,7),(219,1162112400,6),(219,1173607200,7),(219,1194166800,6),(219,1205056800,7),(219,1225616400,6),(219,1236506400,7),(219,1257066000,6),(219,1268560800,7),(219,1289120400,6),(219,1300010400,7),(219,1320570000,6),(219,1331460000,7),(219,1352019600,6),(219,1362909600,7),(219,1383469200,6),(219,1394359200,7),(219,1414918800,6),(219,1425808800,7),(219,1446368400,6),(219,1457863200,7),(219,1478422800,6),(219,1489312800,7),(219,1509872400,6),(219,1520762400,7),(219,1541322000,6),(219,1552212000,7),(219,1572771600,6),(219,1583661600,7),(219,1604214000,8),(220,-2147483648,2),(220,-1694368800,1),(220,-1681671600,2),(220,-1632067200,1),(220,-1615136400,2),(220,-1029686400,1),(220,-1018198800,2),(220,-880214400,3),(220,-769395600,4),(220,-765392400,2),(220,-746035200,1),(220,-732733200,2),(220,-715795200,1),(220,-702493200,2),(220,-684345600,1),(220,-671043600,2),(220,-652896000,1),(220,-639594000,2),(220,-620755200,1),(220,-607626000,2),(220,-589392000,1),(220,-576090000,2),(220,-557942400,1),(220,-544640400,2),(220,-526492800,1),(220,-513190800,2),(220,-495043200,1),(220,-481741200,2),(220,-463593600,1),(220,-450291600,2),(220,-431539200,1),(220,-418237200,2),(220,-400089600,1),(220,-386787600,2),(220,-368640000,1),(220,-355338000,2),(220,-337190400,1),(220,-321469200,2),(220,-305740800,1),(220,-292438800,2),(220,-210787200,1),(220,-198090000,2),(220,-116438400,5),(220,-100108800,6),(220,-84384000,5),(220,-68659200,6),(220,-52934400,5),(220,-37209600,6),(220,-21484800,5),(220,-5760000,6),(220,9964800,5),(220,25689600,6),(220,41414400,5),(220,57744000,6),(220,73468800,5),(220,89193600,6),(220,104918400,5),(220,120643200,6),(220,136368000,5),(220,152092800,6),(220,167817600,5),(220,183542400,6),(220,199267200,5),(220,215596800,6),(220,230716800,5),(220,247046400,6),(220,262771200,5),(220,278496000,6),(220,294220800,5),(220,309945600,6),(220,325670400,5),(220,341395200,6),(220,357120000,5),(220,372844800,6),(220,388569600,5),(220,404899200,6),(220,420019200,5),(220,436348800,6),(220,452073600,5),(220,467798400,6),(220,483523200,5),(220,499248000,6),(220,514972800,5),(220,530697600,6),(220,544608000,5),(220,562147200,6),(220,576057600,5),(220,594201600,6),(220,607507200,5),(220,625651200,6),(220,638956800,5),(220,657100800,6),(220,671011200,5),(220,688550400,6),(220,702460800,5),(220,720000000,6),(220,733910400,5),(220,752054400,6),(220,765360000,5),(220,783504000,6),(220,796809600,5),(220,814953600,6),(220,828864000,5),(220,846403200,6),(220,860313600,5),(220,877852800,6),(220,891763200,5),(220,909302400,6),(220,923212800,5),(220,941356800,6),(220,954662400,5),(220,972806400,6),(220,986112000,5),(220,1004256000,6),(220,1018166400,5),(220,1035705600,6),(220,1049616000,5),(220,1067155200,6),(220,1081065600,5),(220,1099209600,6),(220,1112515200,5),(220,1130659200,6),(220,1136095200,2),(220,1143964800,1),(220,1162105200,2),(220,1173600000,1),(220,1194159600,2),(220,1205049600,1),(220,1225609200,2),(220,1236499200,1),(220,1257058800,2),(220,1268553600,1),(220,1289113200,2),(220,1300003200,1),(220,1320562800,2),(220,1331452800,1),(220,1352012400,2),(220,1362902400,1),(220,1383462000,2),(220,1394352000,1),(220,1414911600,2),(220,1425801600,1),(220,1446361200,2),(220,1457856000,1),(220,1478415600,2),(220,1489305600,1),(220,1509865200,2),(220,1520755200,1),(220,1541314800,2),(220,1552204800,1),(220,1572764400,2),(220,1583654400,1),(220,1604214000,2),(220,1615708800,1),(220,1636268400,2),(220,1647158400,1),(220,1667718000,2),(220,1678608000,1),(220,1699167600,2),(220,1710057600,1),(220,1730617200,2),(220,1741507200,1),(220,1762066800,2),(220,1772956800,1),(220,1793516400,2),(220,1805011200,1),(220,1825570800,2),(220,1836460800,1),(220,1857020400,2),(220,1867910400,1),(220,1888470000,2),(220,1899360000,1),(220,1919919600,2),(220,1930809600,1),(220,1951369200,2),(220,1962864000,1),(220,1983423600,2),(220,1994313600,1),(220,2014873200,2),(220,2025763200,1),(220,2046322800,2),(220,2057212800,1),(220,2077772400,2),(220,2088662400,1),(220,2109222000,2),(220,2120112000,1),(220,2140671600,2),(221,-2147483648,1),(221,-880203600,2),(221,-769395600,3),(221,-765381600,1),(221,-21474000,4),(221,-5752800,1),(221,9975600,4),(221,25696800,1),(221,41425200,4),(221,57751200,1),(221,73479600,4),(221,89200800,1),(221,104929200,4),(221,120650400,1),(221,126702000,4),(221,152100000,1),(221,162385200,4),(221,183549600,1),(221,199278000,4),(221,215604000,1),(221,230727600,4),(221,247053600,1),(221,262782000,4),(221,278503200,1),(221,294231600,4),(221,309952800,1),(221,325681200,4),(221,341402400,1),(221,357130800,4),(221,372852000,1),(221,388580400,4),(221,404906400,1),(221,420030000,4),(221,436356000,1),(221,439030800,6),(221,452084400,5),(221,467805600,6),(221,483534000,5),(221,499255200,6),(221,514983600,5),(221,530704800,6),(221,544618800,5),(221,562154400,6),(221,576068400,5),(221,594208800,6),(221,607518000,5),(221,625658400,6),(221,638967600,5),(221,657108000,6),(221,671022000,5),(221,688557600,6),(221,702471600,5),(221,720007200,6),(221,733921200,5),(221,752061600,6),(221,765370800,5),(221,783511200,6),(221,796820400,5),(221,814960800,6),(221,828874800,5),(221,846410400,6),(221,860324400,5),(221,877860000,6),(221,891774000,5),(221,909309600,6),(221,923223600,5),(221,941364000,6),(221,954673200,5),(221,972813600,6),(221,986122800,5),(221,1004263200,6),(221,1018177200,5),(221,1035712800,6),(221,1049626800,5),(221,1067162400,6),(221,1081076400,5),(221,1099216800,6),(221,1112526000,5),(221,1130666400,6),(221,1143975600,5),(221,1162116000,6),(221,1173610800,5),(221,1194170400,6),(221,1205060400,5),(221,1225620000,6),(221,1236510000,5),(221,1257069600,6),(221,1268564400,5),(221,1289124000,6),(221,1300014000,5),(221,1320573600,6),(221,1331463600,5),(221,1352023200,6),(221,1362913200,5),(221,1383472800,6),(221,1394362800,5),(221,1414922400,6),(221,1425812400,5),(221,1446372000,6),(221,1457866800,5),(221,1478426400,6),(221,1489316400,5),(221,1509876000,6),(221,1520766000,5),(221,1541325600,6),(221,1552215600,5),(221,1572775200,6),(221,1583665200,5),(221,1604224800,6),(221,1615719600,5),(221,1636279200,6),(221,1647169200,5),(221,1667728800,6),(221,1678618800,5),(221,1699178400,6),(221,1710068400,5),(221,1730628000,6),(221,1741518000,5),(221,1762077600,6),(221,1772967600,5),(221,1793527200,6),(221,1805022000,5),(221,1825581600,6),(221,1836471600,5),(221,1857031200,6),(221,1867921200,5),(221,1888480800,6),(221,1899370800,5),(221,1919930400,6),(221,1930820400,5),(221,1951380000,6),(221,1962874800,5),(221,1983434400,6),(221,1994324400,5),(221,2014884000,6),(221,2025774000,5),(221,2046333600,6),(221,2057223600,5),(221,2077783200,6),(221,2088673200,5),(221,2109232800,6),(221,2120122800,5),(221,2140682400,6),(222,-2147483648,0),(222,-1998663968,2),(222,-1632063600,1),(222,-1615132800,2),(222,-1600614000,1),(222,-1596816000,2),(222,-1567954800,1),(222,-1551628800,2),(222,-1536505200,1),(222,-1523203200,2),(222,-1504450800,1),(222,-1491753600,2),(222,-1473001200,1),(222,-1459699200,2),(222,-880210800,3),(222,-769395600,4),(222,-765388800,2),(222,-715791600,1),(222,-702489600,2),(222,73472400,1),(222,89193600,2),(222,104922000,1),(222,120643200,2),(222,136371600,1),(222,152092800,2),(222,167821200,1),(222,183542400,2),(222,199270800,1),(222,215596800,2),(222,230720400,1),(222,247046400,2),(222,262774800,1),(222,278496000,2),(222,294224400,1),(222,309945600,2),(222,325674000,1),(222,341395200,2),(222,357123600,1),(222,372844800,2),(222,388573200,1),(222,404899200,2),(222,420022800,1),(222,436348800,2),(222,452077200,1),(222,467798400,2),(222,483526800,1),(222,499248000,2),(222,514976400,1),(222,530697600,2),(222,544611600,1),(222,562147200,2),(222,576061200,1),(222,594201600,2),(222,607510800,1),(222,625651200,2),(222,638960400,1),(222,657100800,2),(222,671014800,1),(222,688550400,2),(222,702464400,1),(222,720000000,2),(222,733914000,1),(222,752054400,2),(222,765363600,1),(222,783504000,2),(222,796813200,1),(222,814953600,2),(222,828867600,1),(222,846403200,2),(222,860317200,1),(222,877852800,2),(222,891766800,1),(222,909302400,2),(222,923216400,1),(222,941356800,2),(222,954666000,1),(222,972806400,2),(222,986115600,1),(222,1004256000,2),(222,1018170000,1),(222,1035705600,2),(222,1049619600,1),(222,1067155200,2),(222,1081069200,1),(222,1099209600,2),(222,1112518800,1),(222,1130659200,2),(222,1143968400,1),(222,1162108800,2),(222,1173603600,1),(222,1194163200,2),(222,1205053200,1),(222,1225612800,2),(222,1236502800,1),(222,1257062400,2),(222,1268557200,1),(222,1289116800,2),(222,1300006800,1),(222,1320566400,2),(222,1331456400,1),(222,1352016000,2),(222,1362906000,1),(222,1383465600,2),(222,1394355600,1),(222,1414915200,2),(222,1425805200,1),(222,1446364800,2),(222,1457859600,1),(222,1478419200,2),(222,1489309200,1),(222,1509868800,2),(222,1520758800,1),(222,1541318400,2),(222,1552208400,1),(222,1572768000,2),(222,1583658000,1),(222,1604217600,2),(222,1615712400,1),(222,1636272000,2),(222,1647162000,1),(222,1667721600,2),(222,1678611600,1),(222,1699171200,2),(222,1710061200,1),(222,1730620800,2),(222,1741510800,1),(222,1762070400,2),(222,1772960400,1),(222,1793520000,2),(222,1805014800,1),(222,1825574400,2),(222,1836464400,1),(222,1857024000,2),(222,1867914000,1),(222,1888473600,2),(222,1899363600,1),(222,1919923200,2),(222,1930813200,1),(222,1951372800,2),(222,1962867600,1),(222,1983427200,2),(222,1994317200,1),(222,2014876800,2),(222,2025766800,1),(222,2046326400,2),(222,2057216400,1),(222,2077776000,2),(222,2088666000,1),(222,2109225600,2),(222,2120115600,1),(222,2140675200,2),(223,-2147483648,0),(223,-31536000,1),(223,1255802400,2),(223,1267714800,1),(223,1319738400,2),(223,1329843600,3),(223,1477065600,2),(223,1520701200,1),(223,1538856000,2),(223,1552752000,1),(223,1570129200,2),(223,1583596800,1),(223,1601740860,2),(223,2147483647,2),(224,-2147483648,0),(224,-409190400,1),(224,-163062000,0),(224,-28857600,1),(224,1255806000,2),(224,1268251200,3),(224,1319742000,2),(224,1329854400,3),(224,2147483647,3),(225,-2147483648,1),(225,2147483647,1),(226,-2147483648,1),(226,-1680508800,2),(226,-1665388800,3),(226,-1601719200,4),(226,-687052800,1),(226,-71136000,5),(226,-55411200,3),(226,-37267200,5),(226,-25776000,3),(226,-5817600,5),(226,5673600,3),(226,25632000,5),(226,37728000,3),(226,57686400,5),(226,67968000,3),(226,89136000,5),(226,100022400,3),(226,120585600,5),(226,131472000,3),(226,152035200,5),(226,162921600,3),(226,183484800,5),(226,194976000,3),(226,215539200,5),(226,226425600,3),(226,246988800,5),(226,257875200,3),(226,278438400,5),(226,289324800,3),(226,309888000,5),(226,320774400,3),(226,341337600,5),(226,352224000,3),(226,372787200,5),(226,386092800,3),(226,404841600,5),(226,417542400,3),(226,436291200,5),(226,447177600,3),(226,467740800,5),(226,478627200,3),(226,499190400,5),(226,510076800,3),(226,530035200,5),(226,542736000,3),(226,562089600,5),(226,574790400,3),(226,594144000,5),(226,606240000,3),(226,625593600,5),(226,637689600,3),(226,657043200,5),(226,670348800,3),(226,686678400,5),(226,701798400,3),(226,718128000,5),(226,733248000,3),(226,749577600,5),(226,764697600,3),(226,781027200,5),(226,796147200,3),(226,812476800,5),(226,828201600,3),(226,844531200,5),(226,859651200,3),(226,875980800,5),(226,891100800,3),(226,907430400,5),(226,922550400,3),(226,938880000,5),(226,954000000,3),(226,967305600,5),(226,985449600,3),(226,1002384000,5),(226,1017504000,3),(226,1033833600,5),(226,1048953600,3),(226,1065283200,5),(226,1080403200,3),(226,1096732800,5),(226,1111852800,3),(226,1128182400,5),(226,1143907200,3),(226,1159632000,5),(226,1174752000,3),(226,1191686400,5),(226,1207411200,3),(226,1223136000,5),(226,1238860800,3),(226,1254585600,5),(226,1262264400,2),(226,1301760000,3),(226,1317484800,5),(226,1333209600,3),(226,1349539200,5),(226,1365264000,3),(226,1380988800,5),(226,1396713600,3),(226,1412438400,5),(226,1428163200,3),(226,1443888000,5),(226,1459612800,3),(226,1475337600,5),(226,1491062400,3),(226,1506787200,5),(226,1522512000,3),(226,1538841600,5),(226,1554566400,3),(226,1570291200,5),(226,1586016000,3),(226,1601740800,5),(226,1617465600,3),(226,1633190400,5),(226,1648915200,3),(226,1664640000,5),(226,1680364800,3),(226,1696089600,5),(226,1712419200,3),(226,1728144000,5),(226,1743868800,3),(226,1759593600,5),(226,1775318400,3),(226,1791043200,5),(226,1806768000,3),(226,1822492800,5),(226,1838217600,3),(226,1853942400,5),(226,1869667200,3),(226,1885996800,5),(226,1901721600,3),(226,1917446400,5),(226,1933171200,3),(226,1948896000,5),(226,1964620800,3),(226,1980345600,5),(226,1996070400,3),(226,2011795200,5),(226,2027520000,3),(226,2043244800,5),(226,2058969600,3),(226,2075299200,5),(226,2091024000,3),(226,2106748800,5),(226,2122473600,3),(226,2138198400,5),(227,-2147483648,0),(227,-501206400,1),(227,1255809600,2),(227,2147483647,2),(228,-2147483648,2),(228,-1330335000,1),(228,-1320057000,2),(228,-1300699800,3),(228,-1287396000,2),(228,-1269250200,3),(228,-1255946400,2),(228,-1237800600,3),(228,-1224496800,2),(228,-1206351000,3),(228,-1192442400,2),(228,-1174901400,3),(228,-1160992800,2),(228,-1143451800,3),(228,-1125914400,2),(228,-1112607000,3),(228,-1094464800,2),(228,-1081157400,3),(228,-1063015200,2),(228,-1049707800,3),(228,-1031565600,2),(228,-1018258200,3),(228,-1000116000,2),(228,-986808600,3),(228,-968061600,2),(228,-955359000,3),(228,-936612000,2),(228,-923304600,3),(228,-757425600,6),(228,152632800,4),(228,162309600,5),(228,183477600,4),(228,194968800,5),(228,215532000,4),(228,226418400,5),(228,246981600,4),(228,257868000,5),(228,278431200,4),(228,289317600,5),(228,309880800,4),(228,320767200,5),(228,341330400,4),(228,352216800,5),(228,372780000,4),(228,384271200,5),(228,404834400,4),(228,415720800,5),(228,436284000,4),(228,447170400,5),(228,467733600,4),(228,478620000,5),(228,499183200,4),(228,510069600,5),(228,530632800,4),(228,541519200,5),(228,562082400,4),(228,573573600,5),(228,594136800,4),(228,605023200,5),(228,623772000,4),(228,637682400,5),(228,655221600,4),(228,669132000,5),(228,686671200,4),(228,700581600,5),(228,718120800,4),(228,732636000,5),(228,749570400,4),(228,764085600,5),(228,781020000,4),(228,795535200,5),(228,812469600,4),(228,826984800,5),(228,844524000,4),(228,858434400,5),(228,875973600,4),(228,889884000,5),(228,907423200,4),(228,921938400,5),(228,938872800,4),(228,953388000,5),(228,970322400,4),(228,984837600,5),(228,1002376800,4),(228,1016287200,5),(228,1033826400,4),(228,1047736800,5),(228,1065276000,4),(228,1079791200,5),(228,1096725600,4),(228,1111240800,5),(228,1128175200,4),(228,1142690400,5),(228,1159624800,4),(228,1174140000,5),(228,1191074400,4),(228,1207404000,5),(228,1222524000,4),(228,1238853600,5),(228,1253973600,4),(228,1270303200,5),(228,1285423200,4),(228,1301752800,5),(228,1316872800,4),(228,1333202400,5),(228,1348927200,4),(228,1365256800,5),(228,1380376800,4),(228,1396706400,5),(228,1411826400,4),(228,1428156000,5),(228,1443276000,4),(228,1459605600,5),(228,1474725600,4),(228,1491055200,5),(228,1506175200,4),(228,1522504800,5),(228,1538229600,4),(228,1554559200,5),(228,1569679200,4),(228,1586008800,5),(228,1601128800,4),(228,1617458400,5),(228,1632578400,4),(228,1648908000,5),(228,1664028000,4),(228,1680357600,5),(228,1695477600,4),(228,1712412000,5),(228,1727532000,4),(228,1743861600,5),(228,1758981600,4),(228,1775311200,5),(228,1790431200,4),(228,1806760800,5),(228,1821880800,4),(228,1838210400,5),(228,1853330400,4),(228,1869660000,5),(228,1885384800,4),(228,1901714400,5),(228,1916834400,4),(228,1933164000,5),(228,1948284000,4),(228,1964613600,5),(228,1979733600,4),(228,1996063200,5),(228,2011183200,4),(228,2027512800,5),(228,2042632800,4),(228,2058962400,5),(228,2074687200,4),(228,2091016800,5),(228,2106136800,4),(228,2122466400,5),(228,2137586400,4),(229,-2147483648,0),(229,-157766400,2),(229,-152658000,1),(229,-132955200,2),(229,-121122000,1),(229,-101419200,2),(229,-86821200,1),(229,-71092800,2),(229,-54766800,1),(229,-39038400,2),(229,-23317200,1),(229,-7588800,4),(229,128142000,3),(229,136605600,4),(229,389070000,1),(229,403070400,5),(229,416372400,6),(229,434520000,5),(229,447822000,6),(229,466574400,5),(229,479271600,6),(229,498024000,5),(229,510721200,6),(229,529473600,5),(229,545194800,6),(229,560923200,5),(229,574225200,6),(229,592372800,5),(229,605674800,6),(229,624427200,5),(229,637124400,6),(229,653457600,5),(229,668574000,6),(229,687326400,5),(229,700628400,6),(229,718776000,5),(229,732078000,6),(229,750225600,5),(229,763527600,6),(229,781675200,5),(229,794977200,6),(229,813729600,5),(229,826426800,6),(229,845179200,5),(229,859690800,6),(229,876628800,5),(229,889930800,6),(229,906868800,5),(229,923194800,6),(229,939528000,5),(229,952830000,6),(229,971582400,5),(229,984279600,6),(229,1003032000,5),(229,1015729200,6),(229,1034481600,5),(229,1047178800,6),(229,1065931200,5),(229,1079233200,6),(229,1097380800,5),(229,1110682800,6),(229,1128830400,5),(229,1142132400,6),(229,1160884800,5),(229,1173582000,6),(229,1192334400,5),(229,1206846000,6),(229,1223784000,5),(229,1237086000,6),(229,1255233600,5),(229,1270350000,6),(229,1286683200,5),(229,1304823600,6),(229,1313899200,5),(229,1335668400,6),(229,1346558400,5),(229,1367118000,6),(229,1378612800,5),(229,1398567600,6),(229,1410062400,5),(229,1463281200,6),(229,1471147200,5),(229,1480820400,4),(229,2147483647,4),(230,-2147483648,0),(230,218246400,1),(230,2147483647,1),(231,-2147483648,2),(231,-1330335000,1),(231,-1320057000,2),(231,-1300699800,3),(231,-1287396000,2),(231,-1269250200,3),(231,-1255946400,2),(231,-1237800600,3),(231,-1224496800,2),(231,-1206351000,3),(231,-1192442400,2),(231,-1174901400,3),(231,-1160992800,2),(231,-1143451800,3),(231,-1125914400,2),(231,-1112607000,3),(231,-1094464800,2),(231,-1081157400,3),(231,-1063015200,2),(231,-1049707800,3),(231,-1031565600,2),(231,-1018258200,3),(231,-1000116000,2),(231,-986808600,3),(231,-968061600,2),(231,-955359000,3),(231,-936612000,2),(231,-923304600,3),(231,-757425600,6),(231,152632800,4),(231,162309600,5),(231,183477600,4),(231,194968800,5),(231,215532000,4),(231,226418400,5),(231,246981600,4),(231,257868000,5),(231,278431200,4),(231,289317600,5),(231,309880800,4),(231,320767200,5),(231,341330400,4),(231,352216800,5),(231,372780000,4),(231,384271200,5),(231,404834400,4),(231,415720800,5),(231,436284000,4),(231,447170400,5),(231,467733600,4),(231,478620000,5),(231,499183200,4),(231,510069600,5),(231,530632800,4),(231,541519200,5),(231,562082400,4),(231,573573600,5),(231,594136800,4),(231,605023200,5),(231,623772000,4),(231,637682400,5),(231,655221600,4),(231,669132000,5),(231,686671200,4),(231,700581600,5),(231,718120800,4),(231,732636000,5),(231,749570400,4),(231,764085600,5),(231,781020000,4),(231,795535200,5),(231,812469600,4),(231,826984800,5),(231,844524000,4),(231,858434400,5),(231,875973600,4),(231,889884000,5),(231,907423200,4),(231,921938400,5),(231,938872800,4),(231,953388000,5),(231,970322400,4),(231,984837600,5),(231,1002376800,4),(231,1016287200,5),(231,1033826400,4),(231,1047736800,5),(231,1065276000,4),(231,1079791200,5),(231,1096725600,4),(231,1111240800,5),(231,1128175200,4),(231,1142690400,5),(231,1159624800,4),(231,1174140000,5),(231,1191074400,4),(231,1207404000,5),(231,1222524000,4),(231,1238853600,5),(231,1253973600,4),(231,1270303200,5),(231,1285423200,4),(231,1301752800,5),(231,1316872800,4),(231,1333202400,5),(231,1348927200,4),(231,1365256800,5),(231,1380376800,4),(231,1396706400,5),(231,1411826400,4),(231,1428156000,5),(231,1443276000,4),(231,1459605600,5),(231,1474725600,4),(231,1491055200,5),(231,1506175200,4),(231,1522504800,5),(231,1538229600,4),(231,1554559200,5),(231,1569679200,4),(231,1586008800,5),(231,1601128800,4),(231,1617458400,5),(231,1632578400,4),(231,1648908000,5),(231,1664028000,4),(231,1680357600,5),(231,1695477600,4),(231,1712412000,5),(231,1727532000,4),(231,1743861600,5),(231,1758981600,4),(231,1775311200,5),(231,1790431200,4),(231,1806760800,5),(231,1821880800,4),(231,1838210400,5),(231,1853330400,4),(231,1869660000,5),(231,1885384800,4),(231,1901714400,5),(231,1916834400,4),(231,1933164000,5),(231,1948284000,4),(231,1964613600,5),(231,1979733600,4),(231,1996063200,5),(231,2011183200,4),(231,2027512800,5),(231,2042632800,4),(231,2058962400,5),(231,2074687200,4),(231,2091016800,5),(231,2106136800,4),(231,2122466400,5),(231,2137586400,4),(232,-2147483648,0),(232,-719636812,1),(232,2147483647,1),(233,-2147483648,0),(233,1108166400,3),(233,1111885200,1),(233,1130634000,2),(233,1143334800,1),(233,1162083600,2),(233,1174784400,1),(233,1193533200,2),(233,1206838800,1),(233,1224982800,2),(233,1238288400,1),(233,1256432400,2),(233,1269738000,1),(233,1288486800,2),(233,1301187600,1),(233,1319936400,2),(233,1332637200,1),(233,1351386000,2),(233,1364691600,1),(233,1382835600,2),(233,1396141200,1),(233,1414285200,2),(233,1427590800,1),(233,1445734800,2),(233,1459040400,1),(233,1477789200,2),(233,1490490000,1),(233,1509238800,2),(233,1521939600,1),(233,1540688400,2),(233,1553994000,1),(233,1572138000,2),(233,1585443600,1),(233,1603587600,2),(233,1616893200,1),(233,1635642000,2),(233,1648342800,1),(233,1667091600,2),(233,1679792400,1),(233,1698541200,2),(233,1711846800,1),(233,1729990800,2),(233,1743296400,1),(233,1761440400,2),(233,1774746000,1),(233,1792890000,2),(233,1806195600,1),(233,1824944400,2),(233,1837645200,1),(233,1856394000,2),(233,1869094800,1),(233,1887843600,2),(233,1901149200,1),(233,1919293200,2),(233,1932598800,1),(233,1950742800,2),(233,1964048400,1),(233,1982797200,2),(233,1995498000,1),(233,2014246800,2),(233,2026947600,1),(233,2045696400,2),(233,2058397200,1),(233,2077146000,2),(233,2090451600,1),(233,2108595600,2),(233,2121901200,1),(233,2140045200,2),(233,2147483647,2),(234,-2147483648,0),(234,-1325483420,1),(234,2147483647,1),(235,-2147483648,2),(235,-1693706400,1),(235,-1680483600,2),(235,-1663455600,3),(235,-1650150000,4),(235,-1632006000,3),(235,-1618700400,4),(235,-938905200,3),(235,-857257200,4),(235,-844556400,3),(235,-828226800,4),(235,-812502000,3),(235,-796777200,4),(235,-781052400,3),(235,-776563200,5),(235,-765936000,1),(235,-761180400,4),(235,-757386000,2),(235,-748479600,3),(235,-733273200,4),(235,-717631200,3),(235,-714610800,6),(235,-710380800,1),(235,-701910000,4),(235,-684975600,3),(235,-670460400,4),(235,-654130800,3),(235,-639010800,4),(235,315529200,2),(235,323830800,7),(235,338950800,8),(235,354675600,7),(235,370400400,8),(235,386125200,7),(235,401850000,8),(235,417574800,7),(235,433299600,8),(235,449024400,7),(235,465354000,8),(235,481078800,7),(235,496803600,8),(235,512528400,7),(235,528253200,8),(235,543978000,7),(235,559702800,8),(235,575427600,7),(235,591152400,8),(235,606877200,7),(235,622602000,8),(235,638326800,7),(235,654656400,8),(235,670381200,7),(235,686106000,8),(235,701830800,7),(235,717555600,8),(235,733280400,7),(235,749005200,8),(235,764730000,7),(235,780454800,8),(235,796179600,7),(235,811904400,8),(235,828234000,7),(235,846378000,8),(235,859683600,7),(235,877827600,8),(235,891133200,7),(235,909277200,8),(235,922582800,7),(235,941331600,8),(235,954032400,7),(235,972781200,8),(235,985482000,7),(235,1004230800,8),(235,1017536400,7),(235,1035680400,8),(235,1048986000,7),(235,1067130000,8),(235,1080435600,7),(235,1099184400,8),(235,1111885200,7),(235,1130634000,8),(235,1143334800,7),(235,1162083600,8),(235,1174784400,7),(235,1193533200,8),(235,1206838800,7),(235,1224982800,8),(235,1238288400,7),(235,1256432400,8),(235,1269738000,7),(235,1288486800,8),(235,1301187600,7),(235,1319936400,8),(235,1332637200,7),(235,1351386000,8),(235,1364691600,7),(235,1382835600,8),(235,1396141200,7),(235,1414285200,8),(235,1427590800,7),(235,1445734800,8),(235,1459040400,7),(235,1477789200,8),(235,1490490000,7),(235,1509238800,8),(235,1521939600,7),(235,1540688400,8),(235,1553994000,7),(235,1572138000,8),(235,1585443600,7),(235,1603587600,8),(235,1616893200,7),(235,1635642000,8),(235,1648342800,7),(235,1667091600,8),(235,1679792400,7),(235,1698541200,8),(235,1711846800,7),(235,1729990800,8),(235,1743296400,7),(235,1761440400,8),(235,1774746000,7),(235,1792890000,8),(235,1806195600,7),(235,1824944400,8),(235,1837645200,7),(235,1856394000,8),(235,1869094800,7),(235,1887843600,8),(235,1901149200,7),(235,1919293200,8),(235,1932598800,7),(235,1950742800,8),(235,1964048400,7),(235,1982797200,8),(235,1995498000,7),(235,2014246800,8),(235,2026947600,7),(235,2045696400,8),(235,2058397200,7),(235,2077146000,8),(235,2090451600,7),(235,2108595600,8),(235,2121901200,7),(235,2140045200,8),(236,-2147483648,0),(236,-719636812,1),(236,2147483647,1),(237,-2147483648,0),(237,-1441170468,1),(237,-1247547600,3),(237,354909600,2),(237,370717200,3),(237,386445600,2),(237,402253200,3),(237,417981600,2),(237,433789200,3),(237,449604000,2),(237,465336000,4),(237,481060800,5),(237,496785600,4),(237,512510400,5),(237,528235200,4),(237,543960000,5),(237,559684800,4),(237,575409600,5),(237,591134400,4),(237,606859200,5),(237,622584000,4),(237,638308800,5),(237,654638400,4),(237,670363200,6),(237,686091600,7),(237,695768400,4),(237,701812800,5),(237,717537600,4),(237,733262400,5),(237,748987200,4),(237,764712000,5),(237,780436800,4),(237,796161600,5),(237,811886400,4),(237,828216000,5),(237,846360000,4),(237,859665600,5),(237,877809600,4),(237,891115200,5),(237,909259200,4),(237,922564800,5),(237,941313600,4),(237,954014400,5),(237,972763200,4),(237,985464000,5),(237,1004212800,4),(237,1017518400,5),(237,1035662400,4),(237,1048968000,5),(237,1067112000,4),(237,1080417600,5),(237,1099166400,4),(237,2147483647,4),(238,-2147483648,0),(238,-1230776624,2),(238,108165600,1),(238,118270800,2),(238,136591200,1),(238,149806800,2),(238,168127200,1),(238,181342800,2),(238,199749600,1),(238,215643600,2),(238,231285600,1),(238,244501200,2),(238,262735200,1),(238,275950800,2),(238,481154400,1),(238,496962000,2),(238,512949600,1),(238,528670800,2),(238,544399200,1),(238,560120400,2),(238,575848800,1),(238,592174800,2),(238,610581600,1),(238,623624400,2),(238,641167200,1),(238,655074000,2),(238,671839200,1),(238,685918800,2),(238,702856800,1),(238,717973200,2),(238,733701600,1),(238,749422800,2),(238,765151200,1),(238,779662800,2),(238,797205600,1),(238,811116000,3),(238,828655200,1),(238,843170400,3),(238,860104800,1),(238,874620000,3),(238,891554400,1),(238,906069600,3),(238,930780000,4),(238,938124000,3),(238,954367200,4),(238,970178400,3),(238,985816800,4),(238,1001628000,3),(238,1017352800,1),(238,1033077600,3),(238,1048802400,1),(238,1066946400,3),(238,1080252000,1),(238,1097791200,3),(238,1112306400,1),(238,1128031200,3),(238,1143756000,1),(238,1161900000,3),(238,1175205600,1),(238,1193349600,3),(238,1206655200,1),(238,1225404000,3),(238,1238104800,1),(238,1256853600,3),(238,1269554400,1),(238,1288303200,3),(238,1301608800,1),(238,1319752800,3),(238,1333058400,1),(238,1387486800,2),(238,1395957600,1),(238,1414706400,3),(238,1427407200,1),(238,1446156000,3),(238,1459461600,1),(238,1477605600,3),(238,1490911200,1),(238,1509055200,3),(238,1522360800,1),(238,1540504800,3),(238,1553810400,1),(238,1571954400,3),(238,1585260000,1),(238,1604008800,3),(238,1616709600,1),(238,1635458400,3),(238,1645740000,1),(238,1666908000,5),(238,2147483647,5),(239,-2147483648,0),(239,-1441194596,1),(239,-1247572800,3),(239,354884400,2),(239,370692000,3),(239,386420400,4),(239,402231600,1),(239,417960000,4),(239,433767600,1),(239,449582400,4),(239,465314400,5),(239,481039200,6),(239,496764000,5),(239,512488800,6),(239,528213600,5),(239,543938400,6),(239,559663200,5),(239,575388000,6),(239,591112800,5),(239,606837600,6),(239,622562400,5),(239,638287200,6),(239,654616800,5),(239,670341600,7),(239,686070000,8),(239,695746800,5),(239,701791200,6),(239,717516000,5),(239,733240800,6),(239,748965600,5),(239,764690400,6),(239,780415200,5),(239,796140000,6),(239,811864800,5),(239,828194400,6),(239,846338400,5),(239,859644000,6),(239,877788000,5),(239,891093600,6),(239,909237600,5),(239,922543200,6),(239,941292000,5),(239,953992800,6),(239,972741600,5),(239,985442400,6),(239,1004191200,5),(239,1017496800,6),(239,1035640800,5),(239,1048946400,6),(239,1067090400,5),(239,1080396000,6),(239,1099144800,5),(239,1111845600,6),(239,1130594400,5),(239,1143295200,6),(239,1162044000,5),(239,1174744800,6),(239,1193493600,5),(239,1206799200,6),(239,1224943200,5),(239,1238248800,6),(239,1256392800,5),(239,1269698400,7),(239,1288450800,8),(239,1301151600,5),(239,2147483647,5),(240,-2147483648,0),(240,-1441164064,1),(240,-1247544000,2),(240,370724400,3),(240,386445600,4),(240,402256800,2),(240,417985200,4),(240,433792800,2),(240,449607600,4),(240,465339600,5),(240,481064400,6),(240,496789200,5),(240,512514000,6),(240,528238800,5),(240,543963600,6),(240,559688400,5),(240,575413200,6),(240,591138000,5),(240,606862800,6),(240,622587600,5),(240,638312400,6),(240,654642000,5),(240,670366800,7),(240,686095200,8),(240,695772000,5),(240,701816400,6),(240,717541200,5),(240,733266000,6),(240,748990800,5),(240,764715600,6),(240,780440400,8),(240,796168800,7),(240,811893600,8),(240,828223200,7),(240,846367200,8),(240,859672800,7),(240,877816800,8),(240,891122400,7),(240,909266400,8),(240,922572000,7),(240,941320800,8),(240,954021600,7),(240,972770400,8),(240,985471200,7),(240,1004220000,8),(240,1017525600,7),(240,1035669600,8),(240,1048975200,7),(240,1067119200,8),(240,1080424800,7),(240,1099173600,5),(240,2147483647,5),(241,-2147483648,0),(241,-1441165720,1),(241,-1247544000,2),(241,354913200,3),(241,370720800,4),(241,386445600,3),(241,402256800,2),(241,417985200,3),(241,433792800,2),(241,449607600,3),(241,465339600,5),(241,481064400,6),(241,496789200,5),(241,512514000,6),(241,528238800,5),(241,543963600,6),(241,559688400,5),(241,575413200,6),(241,591138000,5),(241,606862800,6),(241,622587600,5),(241,638312400,6),(241,654642000,5),(241,670366800,7),(241,686095200,8),(241,695772000,5),(241,701816400,6),(241,717541200,5),(241,733266000,6),(241,748990800,5),(241,764715600,6),(241,780440400,5),(241,796165200,6),(241,811890000,5),(241,828219600,6),(241,846363600,5),(241,859669200,6),(241,877813200,5),(241,891118800,6),(241,909262800,5),(241,922568400,6),(241,941317200,5),(241,954018000,6),(241,972766800,5),(241,985467600,6),(241,1004216400,5),(241,1017522000,6),(241,1035666000,5),(241,1048971600,6),(241,1067115600,5),(241,1080421200,6),(241,1099170000,5),(241,2147483647,5),(242,-2147483648,0),(242,-1441166012,1),(242,-1247544000,3),(242,354913200,2),(242,370720800,3),(242,386449200,2),(242,402256800,3),(242,417985200,2),(242,433792800,3),(242,449607600,2),(242,465339600,4),(242,481064400,5),(242,496789200,4),(242,512514000,5),(242,528238800,4),(242,543963600,5),(242,559688400,4),(242,575413200,5),(242,591138000,4),(242,606862800,5),(242,622587600,4),(242,638312400,5),(242,654642000,4),(242,670366800,6),(242,686095200,7),(242,695772000,3),(242,2147483647,3),(243,-2147483648,0),(243,-1441166012,1),(243,-1247544000,3),(243,354913200,2),(243,370720800,3),(243,386449200,2),(243,402256800,3),(243,417985200,2),(243,433792800,3),(243,449607600,2),(243,465339600,4),(243,481064400,5),(243,496789200,4),(243,512514000,5),(243,528238800,4),(243,543963600,5),(243,559688400,4),(243,575413200,5),(243,591138000,4),(243,606862800,5),(243,622587600,4),(243,638312400,5),(243,654642000,4),(243,670366800,6),(243,686095200,7),(243,695772000,3),(243,2147483647,3),(244,-2147483648,0),(244,-1441164464,1),(244,-1247540400,2),(244,370724400,3),(244,386445600,4),(244,402256800,2),(244,417985200,4),(244,433792800,2),(244,449607600,4),(244,465339600,5),(244,481064400,6),(244,496789200,5),(244,512514000,6),(244,528238800,5),(244,543963600,6),(244,559688400,5),(244,575413200,6),(244,591138000,5),(244,606862800,6),(244,622587600,5),(244,638312400,6),(244,654642000,5),(244,670366800,7),(244,686095200,8),(244,695772000,5),(244,701816400,6),(244,717541200,5),(244,733266000,6),(244,748990800,5),(244,764715600,6),(244,780440400,5),(244,796165200,6),(244,811890000,5),(244,828219600,6),(244,846363600,5),(244,859669200,6),(244,877813200,5),(244,891118800,6),(244,909262800,5),(244,922568400,7),(244,941320800,8),(244,954021600,7),(244,972770400,8),(244,985471200,7),(244,1004220000,8),(244,1017525600,7),(244,1035669600,8),(244,1048975200,7),(244,1067119200,8),(244,1080424800,7),(244,1099173600,5),(244,2147483647,5),(245,-2147483648,1),(245,-1641005856,2),(245,389048400,3),(245,402264000,2),(245,417906000,3),(245,433800000,2),(245,449614800,3),(245,465422400,2),(245,481150800,3),(245,496792800,4),(245,512517600,5),(245,528242400,4),(245,543967200,5),(245,559692000,4),(245,575416800,5),(245,591141600,4),(245,606866400,5),(245,622591200,4),(245,638316000,5),(245,654645600,4),(245,670464000,5),(245,686275200,4),(245,702086400,5),(245,717897600,4),(245,733622400,5),(245,749433600,4),(245,765158400,5),(245,780969600,4),(245,796694400,5),(245,812505600,4),(245,828316800,5),(245,844128000,4),(245,859852800,5),(245,875664000,4),(245,891388800,5),(245,907200000,4),(245,922924800,5),(245,938736000,4),(245,954547200,5),(245,970358400,4),(245,986083200,5),(245,1001894400,4),(245,1017619200,5),(245,1033430400,4),(245,1049155200,5),(245,1064966400,4),(245,1080777600,5),(245,1096588800,4),(245,1112313600,5),(245,1128124800,4),(245,1143849600,5),(245,1159660800,4),(245,1175385600,5),(245,1191196800,4),(245,2147483647,4),(246,-2147483648,0),(246,-1577935568,1),(246,76190400,2),(246,2147483647,2),(247,-2147483648,0),(247,-1441163964,1),(247,-405140400,3),(247,354916800,2),(247,370724400,3),(247,386452800,2),(247,402260400,3),(247,417988800,2),(247,433796400,3),(247,449611200,2),(247,465343200,4),(247,481068000,5),(247,496792800,4),(247,512517600,5),(247,528242400,4),(247,543967200,5),(247,559692000,4),(247,575416800,5),(247,591141600,4),(247,606866400,5),(247,622591200,4),(247,638316000,5),(247,654645600,4),(247,670370400,6),(247,686098800,7),(247,701823600,6),(247,717548400,4),(247,820440000,3),(247,828234000,8),(247,846378000,9),(247,852062400,3),(247,859680000,2),(247,877824000,3),(247,891129600,2),(247,909273600,3),(247,922579200,2),(247,941328000,3),(247,954028800,2),(247,972777600,3),(247,985478400,2),(247,1004227200,3),(247,1017532800,2),(247,1035676800,3),(247,1048982400,2),(247,1067126400,3),(247,1080432000,2),(247,1099180800,3),(247,1111881600,2),(247,1130630400,3),(247,1143331200,2),(247,1162080000,3),(247,1174780800,2),(247,1193529600,3),(247,1206835200,2),(247,1224979200,3),(247,1238284800,2),(247,1256428800,3),(247,1269734400,2),(247,1288483200,3),(247,1301184000,2),(247,1319932800,3),(247,1332633600,2),(247,1351382400,3),(247,1364688000,2),(247,1382832000,3),(247,1396137600,2),(247,1414281600,3),(247,1427587200,2),(247,1445731200,3),(247,2147483647,3),(248,-2147483648,1),(248,-1570084924,2),(248,2147483647,2),(249,-2147483648,0),(249,-1579844100,1),(249,-1247551200,3),(249,354906000,2),(249,370713600,3),(249,386442000,2),(249,402249600,3),(249,417978000,2),(249,433785600,3),(249,449600400,2),(249,465332400,4),(249,481057200,5),(249,496782000,4),(249,512506800,5),(249,528231600,4),(249,543956400,5),(249,559681200,4),(249,575406000,5),(249,591130800,4),(249,606855600,5),(249,622580400,4),(249,638305200,5),(249,654634800,4),(249,670359600,6),(249,686088000,7),(249,695764800,4),(249,701809200,5),(249,717534000,4),(249,733258800,5),(249,748983600,4),(249,764708400,5),(249,780433200,4),(249,796158000,5),(249,801590400,8),(249,811886400,7),(249,828216000,6),(249,846360000,7),(249,859665600,6),(249,877809600,7),(249,891115200,6),(249,909259200,7),(249,922564800,6),(249,941313600,7),(249,954014400,6),(249,972763200,7),(249,985464000,6),(249,1004212800,7),(249,1017518400,6),(249,1035662400,7),(249,1048968000,6),(249,1067112000,7),(249,1080417600,6),(249,1099166400,7),(249,1111867200,6),(249,1130616000,7),(249,1143316800,6),(249,1162065600,7),(249,1174766400,6),(249,1193515200,7),(249,1206820800,6),(249,1224964800,7),(249,1238270400,6),(249,1256414400,7),(249,1269720000,6),(249,1288468800,7),(249,1301169600,4),(249,1414263600,7),(249,1459022400,4),(249,2147483647,4),(250,-2147483648,2),(250,-1570413600,1),(250,-1552186800,2),(250,-1538359200,1),(250,-1522551600,2),(250,-1507514400,1),(250,-1490583600,2),(250,-1473645600,1),(250,-1460948400,2),(250,-399866400,1),(250,-386650800,2),(250,-368330400,1),(250,-355114800,2),(250,-336794400,1),(250,-323578800,2),(250,-305172000,1),(250,-291956400,2),(250,-273636000,1),(250,-260420400,2),(250,78012000,1),(250,86734800,2),(250,105055200,1),(250,118270800,2),(250,136591200,1),(250,149806800,2),(250,168127200,1),(250,181342800,2),(250,199749600,1),(250,212965200,2),(250,231285600,1),(250,244501200,2),(250,262735200,1),(250,275950800,2),(250,452210400,1),(250,466722000,2),(250,483746400,1),(250,498258000,2),(250,515282400,1),(250,529794000,2),(250,546818400,1),(250,561330000,2),(250,581119200,1),(250,592952400,2),(250,610754400,1),(250,624488400,2),(250,641512800,1),(250,656024400,2),(250,673048800,1),(250,687560400,2),(250,704671200,1),(250,718146000,2),(250,733269600,1),(250,748990800,2),(250,764719200,1),(250,780440400,2),(250,796168800,1),(250,811890000,2),(250,828223200,1),(250,843944400,2),(250,859672800,1),(250,875394000,2),(250,891122400,1),(250,906843600,2),(250,922572000,1),(250,941317200,2),(250,954021600,1),(250,972766800,2),(250,985471200,1),(250,1004216400,2),(250,1017525600,1),(250,1035666000,2),(250,1048975200,1),(250,1067115600,2),(250,1080424800,1),(250,1099170000,2),(250,1111874400,1),(250,1130619600,2),(250,1143324000,1),(250,1162069200,2),(250,1174773600,1),(250,1193518800,2),(250,1206828000,1),(250,1224968400,2),(250,1238277600,1),(250,1256418000,2),(250,1269727200,1),(250,1288472400,2),(250,1301176800,1),(250,1319922000,2),(250,1332626400,1),(250,1351371600,2),(250,1364680800,1),(250,1382821200,2),(250,1396130400,1),(250,1414270800,2),(250,1427580000,1),(250,1445720400,2),(250,1459029600,1),(250,1477774800,2),(250,1490479200,1),(250,1509224400,2),(250,1521928800,1),(250,1540674000,2),(250,1553983200,1),(250,1572123600,2),(250,1585432800,1),(250,1603573200,2),(250,1616882400,1),(250,1635627600,2),(250,1648332000,1),(250,1667077200,2),(250,1679781600,1),(250,1698526800,2),(250,1711836000,1),(250,1729976400,2),(250,1743285600,1),(250,1761426000,2),(250,1774735200,1),(250,1792875600,2),(250,1806184800,1),(250,1824930000,2),(250,1837634400,1),(250,1856379600,2),(250,1869084000,1),(250,1887829200,2),(250,1901138400,1),(250,1919278800,2),(250,1932588000,1),(250,1950728400,2),(250,1964037600,1),(250,1982782800,2),(250,1995487200,1),(250,2014232400,2),(250,2026936800,1),(250,2045682000,2),(250,2058386400,1),(250,2077131600,2),(250,2090440800,1),(250,2108581200,2),(250,2121890400,1),(250,2140030800,2),(251,-2147483648,0),(251,-1441169904,1),(251,-1247547600,3),(251,354909600,2),(251,370717200,3),(251,386445600,2),(251,402253200,3),(251,417981600,2),(251,433789200,3),(251,449604000,2),(251,465336000,4),(251,481060800,5),(251,496785600,4),(251,512510400,5),(251,528235200,4),(251,543960000,5),(251,559684800,4),(251,575409600,5),(251,591134400,4),(251,606859200,5),(251,622584000,4),(251,638308800,5),(251,654638400,4),(251,670363200,6),(251,683582400,1),(251,703018800,6),(251,717530400,1),(251,734468400,6),(251,748980000,1),(251,765918000,6),(251,780429600,1),(251,797367600,6),(251,811879200,1),(251,828817200,6),(251,843933600,1),(251,859671000,8),(251,877811400,1),(251,891120600,8),(251,909261000,1),(251,922570200,8),(251,941315400,1),(251,954019800,8),(251,972765000,1),(251,985469400,8),(251,1004214600,1),(251,1017523800,8),(251,1035664200,1),(251,1048973400,8),(251,1067113800,1),(251,1080423000,8),(251,1099168200,1),(251,1111872600,8),(251,1123783200,3),(251,2147483647,3),(252,-2147483648,0),(252,-1383463280,1),(252,-1167636600,3),(252,-1082448000,2),(252,-1074586800,3),(252,-1050825600,2),(252,-1042964400,3),(252,-1019289600,2),(252,-1011428400,3),(252,-987753600,2),(252,-979892400,3),(252,-956217600,2),(252,-948356400,3),(252,-924595200,2),(252,-916734000,3),(252,-893059200,2),(252,-885198000,3),(252,-879667200,4),(252,-767005200,3),(252,2147483647,3),(253,-2147483648,1),(253,-2019705670,2),(253,-891581400,3),(253,-872058600,2),(253,-862637400,3),(253,-764145000,2),(254,-2147483648,0),(254,-1579419232,1),(254,-1247558400,3),(254,354898800,2),(254,370706400,3),(254,386434800,2),(254,402242400,3),(254,417970800,2),(254,433778400,3),(254,449593200,2),(254,465325200,4),(254,481050000,5),(254,496774800,4),(254,512499600,5),(254,528224400,4),(254,543949200,5),(254,559674000,4),(254,575398800,5),(254,591123600,4),(254,606848400,5),(254,622573200,4),(254,638298000,5),(254,654627600,4),(254,670352400,6),(254,686080800,7),(254,695757600,4),(254,701802000,5),(254,717526800,4),(254,733251600,5),(254,748976400,4),(254,764701200,5),(254,780426000,4),(254,796150800,5),(254,811875600,4),(254,828205200,5),(254,846349200,4),(254,859654800,5),(254,877798800,4),(254,891104400,5),(254,909248400,4),(254,922554000,5),(254,941302800,4),(254,954003600,5),(254,972752400,4),(254,985453200,5),(254,1004202000,4),(254,1017507600,5),(254,1035651600,4),(254,1048957200,5),(254,1067101200,4),(254,1080406800,5),(254,1099155600,4),(254,1111856400,5),(254,1130605200,4),(254,1143306000,5),(254,1162054800,4),(254,1174755600,5),(254,1193504400,4),(254,1206810000,5),(254,1224954000,4),(254,1238259600,5),(254,1256403600,4),(254,1269709200,5),(254,1288458000,4),(254,1301158800,8),(254,1414252800,7),(254,1459015200,3),(254,2147483647,3),(255,-2147483648,0),(255,-2032933080,1),(255,252435600,2),(255,417974400,4),(255,433778400,3),(255,449593200,4),(255,465314400,3),(255,481042800,4),(255,496764000,3),(255,512492400,4),(255,528213600,3),(255,543942000,4),(255,559663200,3),(255,575391600,4),(255,591112800,3),(255,606841200,4),(255,622562400,3),(255,638290800,4),(255,654616800,3),(255,670345200,4),(255,686066400,3),(255,701794800,4),(255,717516000,3),(255,733244400,4),(255,748965600,3),(255,764694000,4),(255,780415200,3),(255,796143600,4),(255,811864800,3),(255,828198000,4),(255,843919200,3),(255,859647600,4),(255,875368800,3),(255,891097200,4),(255,906818400,3),(255,988390800,4),(255,1001692800,3),(255,1017421200,4),(255,1033142400,3),(255,1048870800,4),(255,1064592000,3),(255,1080320400,4),(255,1096041600,3),(255,1111770000,4),(255,1127491200,3),(255,1143219600,4),(255,1159545600,3),(255,1206889200,2),(255,1427479200,5),(255,1443193200,2),(255,1458928800,5),(255,1474642800,2),(255,2147483647,2),(256,-2147483648,2),(256,-1600675200,1),(256,-1585904400,2),(256,-933667200,1),(256,-922093200,2),(256,-908870400,1),(256,-888829200,2),(256,-881049600,1),(256,-767869200,2),(256,-745833600,1),(256,-733827600,2),(256,-716889600,1),(256,-699613200,2),(256,-683884800,1),(256,-670669200,2),(256,-652348800,1),(256,-650019600,2),(256,515527200,1),(256,527014800,2),(256,545162400,1),(256,558464400,2),(256,577216800,1),(256,589914000,2),(256,608666400,1),(256,621968400,2),(256,640116000,1),(256,653418000,2),(256,671565600,1),(256,684867600,2),(257,-2147483648,2),(257,-1600675200,1),(257,-1585904400,2),(257,-933667200,1),(257,-922093200,2),(257,-908870400,1),(257,-888829200,2),(257,-881049600,1),(257,-767869200,2),(257,-745833600,1),(257,-733827600,2),(257,-716889600,1),(257,-699613200,2),(257,-683884800,1),(257,-670669200,2),(257,-652348800,1),(257,-650019600,2),(257,515527200,1),(257,527014800,2),(257,545162400,1),(257,558464400,2),(257,577216800,1),(257,589914000,2),(257,608666400,1),(257,621968400,2),(257,640116000,1),(257,653418000,2),(257,671565600,1),(257,684867600,2),(258,-2147483648,1),(258,-2019705572,2),(258,-883287000,3),(258,-862639200,4),(258,-764051400,2),(258,832962600,5),(258,846266400,6),(258,1145039400,2),(258,2147483647,2),(259,-2147483648,1),(259,-891582800,2),(259,-872058600,3),(259,-862637400,2),(259,-576138600,4),(259,1245430800,5),(259,1262278800,4),(259,2147483647,4),(260,-2147483648,0),(260,-1577931912,2),(260,-1568592000,1),(260,-1554080400,2),(260,-1537142400,1),(260,-1522630800,2),(260,-1505692800,1),(260,-1491181200,2),(260,-1474243200,1),(260,-1459126800,2),(260,-242265600,1),(260,-228877200,2),(260,-210556800,1),(260,-197427600,2),(260,-178934400,1),(260,-165718800,2),(260,-147398400,1),(260,-134269200,2),(260,-116467200,1),(260,-102646800,2),(260,-84326400,1),(260,-71110800,2),(260,-52704000,1),(260,-39488400,2),(260,-21168000,1),(260,-7952400,2),(260,10368000,1),(260,23583600,2),(260,41904000,1),(260,55119600,2),(260,73526400,1),(260,86742000,2),(260,105062400,1),(260,118278000,2),(260,136598400,1),(260,149814000,2),(260,168134400,1),(260,181350000,2),(260,199756800,1),(260,212972400,2),(260,231292800,1),(260,241916400,2),(260,262828800,1),(260,273452400,2),(260,418694400,1),(260,433810800,2),(260,450316800,1),(260,465433200,2),(260,508896000,1),(260,529196400,2),(260,541555200,1),(260,562633200,2),(260,574387200,1),(260,594255600,2),(260,607305600,1),(260,623199600,2),(260,638928000,1),(260,654649200,2),(260,670456800,1),(260,686264400,2),(260,702684000,1),(260,717886800,2),(260,733096800,1),(260,748904400,2),(260,765151200,1),(260,780958800,2),(260,796687200,1),(260,812494800,2),(260,828309600,1),(260,844117200,2),(260,859759200,1),(260,875653200,2),(260,891208800,1),(260,907189200,2),(260,922917600,1),(260,938725200,2),(260,954540000,1),(260,970347600,2),(260,986076000,1),(260,1001883600,2),(260,1017612000,1),(260,1033419600,2),(260,1049148000,1),(260,1064955600,2),(260,1080770400,1),(260,1096578000,2),(260,1112306400,1),(260,1128114000,2),(260,1143842400,1),(260,1158872400,2),(260,1175205600,1),(260,1193950800,2),(260,1207260000,1),(260,1225486800,2),(260,1238104800,1),(260,1256850000,2),(260,1270159200,1),(260,1288299600,2),(260,1301608800,1),(260,1319749200,2),(260,1333058400,1),(260,1351198800,2),(260,1364508000,1),(260,1382648400,2),(260,1395957600,1),(260,1414702800,2),(260,1427407200,1),(260,1446152400,2),(260,1458856800,1),(260,1477602000,2),(260,1490911200,1),(260,1509051600,2),(260,1522360800,1),(260,1540501200,2),(260,1553810400,1),(260,1571950800,2),(260,1585260000,1),(260,1604005200,2),(260,1616709600,1),(260,1635454800,2),(260,1648159200,1),(260,1666904400,3),(260,2147483647,3),(261,-2147483648,1),(261,-891582800,2),(261,-872058600,3),(261,-862637400,2),(261,-576138600,4),(261,1245430800,5),(261,1262278800,4),(261,2147483647,4),(262,-2147483648,0),(262,-1830414140,1),(262,-879152400,2),(262,199897200,1),(262,969120000,2),(262,2147483647,2),(263,-2147483648,0),(263,-1577936472,1),(263,2147483647,1),(264,-2147483648,0),(264,-1441168512,1),(264,-1247547600,3),(264,354909600,2),(264,370717200,3),(264,386445600,2),(264,402253200,3),(264,417981600,2),(264,433789200,3),(264,449604000,2),(264,465336000,4),(264,481060800,5),(264,496785600,4),(264,512510400,5),(264,528235200,4),(264,543960000,5),(264,559684800,4),(264,575409600,5),(264,591134400,4),(264,606859200,5),(264,622584000,4),(264,638308800,5),(264,654638400,4),(264,670363200,6),(264,684363600,7),(264,2147483647,7),(265,-2147483648,0),(265,-1518920148,2),(265,166572000,1),(265,182293200,2),(265,200959200,1),(265,213829200,2),(265,228866400,1),(265,243982800,2),(265,260316000,1),(265,276123600,2),(265,291765600,1),(265,307486800,2),(265,323820000,1),(265,338936400,2),(265,354664800,1),(265,370386000,2),(265,386114400,1),(265,401835600,2),(265,417564000,1),(265,433285200,2),(265,449013600,1),(265,465339600,2),(265,481068000,1),(265,496789200,2),(265,512517600,1),(265,528238800,2),(265,543967200,1),(265,559688400,2),(265,575416800,1),(265,591138000,2),(265,606866400,1),(265,622587600,2),(265,638316000,1),(265,654642000,2),(265,670370400,1),(265,686091600,2),(265,701820000,1),(265,717541200,2),(265,733269600,1),(265,748990800,2),(265,764719200,1),(265,780440400,2),(265,796168800,1),(265,811890000,2),(265,828223200,1),(265,843944400,2),(265,859672800,1),(265,875394000,2),(265,891122400,1),(265,909277200,3),(265,922582800,4),(265,941331600,3),(265,954032400,4),(265,972781200,3),(265,985482000,4),(265,1004230800,3),(265,1017536400,4),(265,1035680400,3),(265,1048986000,4),(265,1067130000,3),(265,1080435600,4),(265,1099184400,3),(265,1111885200,4),(265,1130634000,3),(265,1143334800,4),(265,1162083600,3),(265,1174784400,4),(265,1193533200,3),(265,1206838800,4),(265,1224982800,3),(265,1238288400,4),(265,1256432400,3),(265,1269738000,4),(265,1288486800,3),(265,1301187600,4),(265,1319936400,3),(265,1332637200,4),(265,1351386000,3),(265,1364691600,4),(265,1382835600,3),(265,1396141200,4),(265,1414285200,3),(265,1427590800,4),(265,1445734800,3),(265,1459040400,4),(265,1473282000,5),(265,1509238800,3),(265,1521939600,4),(265,1540688400,3),(265,1553994000,4),(265,1572138000,3),(265,1585443600,4),(265,1603587600,3),(265,1616893200,4),(265,1635642000,3),(265,1648342800,4),(265,1667091600,3),(265,1679792400,4),(265,1698541200,3),(265,1711846800,4),(265,1729990800,3),(265,1743296400,4),(265,1761440400,3),(265,1774746000,4),(265,1792890000,3),(265,1806195600,4),(265,1824944400,3),(265,1837645200,4),(265,1856394000,3),(265,1869094800,4),(265,1887843600,3),(265,1901149200,4),(265,1919293200,3),(265,1932598800,4),(265,1950742800,3),(265,1964048400,4),(265,1982797200,3),(265,1995498000,4),(265,2014246800,3),(265,2026947600,4),(265,2045696400,3),(265,2058397200,4),(265,2077146000,3),(265,2090451600,4),(265,2108595600,3),(265,2121901200,4),(265,2140045200,3),(266,-2147483648,3),(266,-933638400,1),(266,-923097600,2),(266,-919036800,1),(266,-857347200,2),(266,-844300800,1),(266,-825811200,2),(266,-812678400,1),(266,-794188800,2),(266,-779846400,1),(266,-762652800,2),(266,-748310400,1),(266,-731116800,2),(266,-682653600,3),(266,-399088800,4),(266,-386650800,3),(266,-368330400,4),(266,-355114800,3),(266,-336790800,4),(266,-323654400,3),(266,-305168400,4),(266,-292032000,3),(266,-273632400,4),(266,-260496000,3),(266,-242096400,4),(266,-228960000,3),(266,-210560400,4),(266,-197424000,3),(266,-178938000,4),(266,-165801600,3),(266,-147402000,4),(266,-134265600,3),(266,-115866000,4),(266,-102643200,3),(266,-84330000,4),(266,-81313200,6),(266,142380000,5),(266,150843600,6),(266,167176800,5),(266,178664400,6),(266,334101600,7),(266,337730400,8),(266,452642400,7),(266,462319200,8),(266,482277600,5),(266,494370000,6),(266,516751200,5),(266,526424400,6),(266,545436000,5),(266,558478800,6),(266,576626400,5),(266,589323600,6),(266,609890400,5),(266,620773200,6),(266,638316000,5),(266,651618000,6),(266,669765600,5),(266,683672400,6),(266,701820000,5),(266,715726800,6),(266,733701600,5),(266,747176400,6),(266,765151200,5),(266,778021200,6),(266,796600800,5),(266,810075600,6),(266,820447200,3),(266,828655200,4),(266,843170400,9),(266,860104800,4),(266,874620000,9),(266,891554400,4),(266,906069600,9),(266,915141600,3),(266,924213600,4),(266,939934800,3),(266,956268000,4),(266,971989200,3),(266,987717600,4),(266,1003438800,3),(266,1019167200,4),(266,1034888400,3),(266,1050616800,4),(266,1066338000,3),(266,1082066400,4),(266,1096581600,3),(266,1113516000,4),(266,1128380400,3),(266,1143842400,4),(266,1158872400,3),(266,1175378400,4),(266,1189638000,3),(266,1206655200,4),(266,1219957200,3),(266,1238104800,4),(266,1252015200,3),(266,1269640860,4),(266,1281474000,3),(266,1301608860,4),(266,1312146000,3),(266,1333058400,4),(266,1348178400,3),(266,1364508000,4),(266,1380229200,3),(266,1395957600,4),(266,1414098000,3),(266,1427493600,4),(266,1445551200,3),(266,1458946800,4),(266,1477692000,3),(266,1490396400,4),(266,1509141600,3),(266,1521846000,4),(266,1540591200,3),(266,1553810400,4),(266,1572037200,3),(266,1585346400,4),(266,1603490400,3),(266,1616796000,4),(266,1635458400,3),(266,1648332000,4),(266,1666998000,3),(266,1682726400,4),(266,1698447600,3),(266,1712966400,4),(266,1729897200,3),(266,1743811200,4),(266,1761346800,3),(266,1774656000,4),(266,1792796400,3),(266,1806105600,4),(266,1824850800,3),(266,1837555200,4),(266,1856300400,3),(266,1869004800,4),(266,1887750000,3),(266,1901059200,4),(266,1919199600,3),(266,1932508800,4),(266,1950649200,3),(266,1963958400,4),(266,1982703600,3),(266,1995408000,4),(266,2014153200,3),(266,2026857600,4),(266,2045602800,3),(266,2058307200,4),(266,2077052400,3),(266,2090361600,4),(266,2107897200,3),(266,2121811200,4),(266,2138742000,3),(267,-2147483648,2),(267,-1600675200,1),(267,-1585904400,2),(267,-933667200,1),(267,-922093200,2),(267,-908870400,1),(267,-888829200,2),(267,-881049600,1),(267,-767869200,2),(267,-745833600,1),(267,-733827600,2),(267,-716889600,1),(267,-699613200,2),(267,-683884800,1),(267,-670669200,2),(267,-652348800,1),(267,-650019600,2),(267,515527200,1),(267,527014800,2),(267,545162400,1),(267,558464400,2),(267,577216800,1),(267,589914000,2),(267,608666400,1),(267,621968400,2),(267,640116000,1),(267,653418000,2),(267,671565600,1),(267,684867600,2),(268,-2147483648,3),(268,-933638400,1),(268,-923097600,2),(268,-919036800,1),(268,-857347200,2),(268,-844300800,1),(268,-825811200,2),(268,-812678400,1),(268,-794188800,2),(268,-779846400,1),(268,-762652800,2),(268,-748310400,1),(268,-731116800,2),(268,-682653600,3),(268,-399088800,4),(268,-386650800,3),(268,-368330400,4),(268,-355114800,3),(268,-336790800,4),(268,-323654400,3),(268,-305168400,4),(268,-292032000,3),(268,-273632400,4),(268,-260496000,3),(268,-242096400,4),(268,-228960000,3),(268,-210560400,4),(268,-197424000,3),(268,-178938000,4),(268,-165801600,3),(268,-147402000,4),(268,-134265600,3),(268,-115866000,4),(268,-102643200,3),(268,-84330000,4),(268,-81313200,6),(268,142380000,5),(268,150843600,6),(268,167176800,5),(268,178664400,6),(268,334101600,7),(268,337730400,8),(268,452642400,7),(268,462319200,8),(268,482277600,5),(268,494370000,6),(268,516751200,5),(268,526424400,6),(268,545436000,5),(268,558478800,6),(268,576626400,5),(268,589323600,6),(268,609890400,5),(268,620773200,6),(268,638316000,5),(268,651618000,6),(268,669765600,5),(268,683672400,6),(268,701820000,5),(268,715726800,6),(268,733701600,5),(268,747176400,6),(268,765151200,5),(268,778021200,6),(268,796600800,5),(268,810075600,6),(268,820447200,3),(268,828655200,4),(268,843170400,9),(268,860104800,4),(268,874620000,9),(268,891554400,4),(268,906069600,9),(268,915141600,3),(268,924213600,4),(268,939934800,3),(268,956268000,4),(268,971989200,3),(268,987717600,4),(268,1003438800,3),(268,1019167200,4),(268,1034888400,3),(268,1050616800,4),(268,1066338000,3),(268,1082066400,4),(268,1096581600,3),(268,1113516000,4),(268,1128380400,3),(268,1143842400,4),(268,1158872400,3),(268,1175378400,4),(268,1189638000,3),(268,1206655200,4),(268,1220216400,3),(268,1238104800,4),(268,1252015200,3),(268,1269554400,4),(268,1281474000,3),(268,1301608860,4),(268,1312146000,3),(268,1314655200,4),(268,1317330000,3),(268,1333058400,4),(268,1348178400,3),(268,1364508000,4),(268,1380229200,3),(268,1395957600,4),(268,1414098000,3),(268,1427493600,4),(268,1445551200,3),(268,1458946800,4),(268,1477692000,3),(268,1490396400,4),(268,1509141600,3),(268,1521846000,4),(268,1540591200,3),(268,1553810400,4),(268,1572037200,3),(268,1585346400,4),(268,1603490400,3),(268,1616796000,4),(268,1635458400,3),(268,1648332000,4),(268,1666998000,3),(268,1682726400,4),(268,1698447600,3),(268,1712966400,4),(268,1729897200,3),(268,1743811200,4),(268,1761346800,3),(268,1774656000,4),(268,1792796400,3),(268,1806105600,4),(268,1824850800,3),(268,1837555200,4),(268,1856300400,3),(268,1869004800,4),(268,1887750000,3),(268,1901059200,4),(268,1919199600,3),(268,1932508800,4),(268,1950649200,3),(268,1963958400,4),(268,1982703600,3),(268,1995408000,4),(268,2014153200,3),(268,2026857600,4),(268,2045602800,3),(268,2058307200,4),(268,2077052400,3),(268,2090361600,4),(268,2107897200,3),(268,2121811200,4),(268,2138742000,3),(269,-2147483648,0),(269,-2004073590,1),(269,-1851577590,2),(269,-852105600,3),(269,-782643600,4),(269,-767869200,2),(269,-718095600,3),(269,-457776000,2),(269,-315648000,3),(269,171820800,2),(269,2147483647,2),(270,-2147483648,0),(270,-2056690800,1),(270,-900910800,2),(270,-891579600,3),(270,-884248200,4),(270,-761209200,7),(270,-747907200,2),(270,-728541000,5),(270,-717049800,6),(270,-697091400,5),(270,-683785800,6),(270,-668061000,5),(270,-654755400,2),(270,-636611400,5),(270,-623305800,2),(270,-605161800,5),(270,-591856200,2),(270,-573712200,5),(270,-559801800,2),(270,-541657800,5),(270,-528352200,2),(270,-510211800,7),(270,-498112200,2),(270,-478762200,7),(270,-466662600,2),(270,-446707800,7),(270,-435213000,2),(270,-415258200,7),(270,-403158600,2),(270,-383808600,7),(270,-371709000,2),(270,-352359000,7),(270,-340259400,2),(270,-320909400,7),(270,-308809800,2),(270,-288855000,7),(270,-277360200,2),(270,-257405400,7),(270,-245910600,2),(270,-225955800,7),(270,-213856200,2),(270,-194506200,7),(270,-182406600,2),(270,-163056600,7),(270,-148537800,2),(270,-132816600,7),(270,-117088200,2),(270,-101367000,7),(270,-85638600,2),(270,-69312600,7),(270,-53584200,2),(270,-37863000,7),(270,-22134600,2),(270,-6413400,7),(270,9315000,2),(270,25036200,7),(270,40764600,2),(270,56485800,7),(270,72214200,2),(270,88540200,7),(270,104268600,2),(270,119989800,7),(270,126041400,2),(270,151439400,7),(270,167167800,2),(270,182889000,7),(270,198617400,2),(270,214338600,7),(270,295385400,2),(270,309292200,7),(271,-2147483648,0),(271,-2032927596,1),(271,252439200,3),(271,417978000,2),(271,433785600,3),(271,449600400,2),(271,465321600,3),(271,481050000,2),(271,496771200,3),(271,512499600,2),(271,528220800,3),(271,543949200,2),(271,559670400,3),(271,575398800,2),(271,591120000,3),(271,606848400,2),(271,622569600,3),(271,638298000,2),(271,654624000,3),(271,670352400,2),(271,686073600,3),(271,701802000,2),(271,717523200,3),(271,733251600,2),(271,748972800,3),(271,764701200,2),(271,780422400,3),(271,796150800,2),(271,811872000,3),(271,828205200,2),(271,843926400,3),(271,859654800,2),(271,875376000,3),(271,891104400,2),(271,906825600,3),(271,988398000,2),(271,1001700000,3),(271,1017428400,2),(271,1033149600,3),(271,1048878000,2),(271,1064599200,3),(271,1080327600,2),(271,1096048800,3),(271,1111777200,2),(271,1127498400,3),(271,1143226800,2),(271,1159552800,3),(271,1427482800,2),(271,1443196800,3),(271,1458932400,2),(271,1474646400,3),(271,2147483647,3),(272,-2147483648,1),(272,-1575874625,2),(272,-1247554800,4),(272,354902400,3),(272,370710000,4),(272,386438400,3),(272,402246000,4),(272,417974400,3),(272,433782000,4),(272,449596800,3),(272,465328800,5),(272,481053600,6),(272,496778400,5),(272,512503200,6),(272,528228000,5),(272,543952800,6),(272,559677600,5),(272,575402400,6),(272,591127200,5),(272,606852000,6),(272,622576800,5),(272,638301600,6),(272,654631200,5),(272,670356000,7),(272,686084400,8),(272,695761200,5),(272,701805600,6),(272,717530400,5),(272,733255200,6),(272,748980000,5),(272,764704800,6),(272,780429600,5),(272,796154400,6),(272,811879200,5),(272,828208800,6),(272,846352800,5),(272,859658400,6),(272,877802400,5),(272,891108000,6),(272,909252000,5),(272,922557600,6),(272,941306400,5),(272,954007200,6),(272,972756000,5),(272,985456800,6),(272,1004205600,5),(272,1017511200,6),(272,1035655200,5),(272,1048960800,6),(272,1067104800,5),(272,1080410400,6),(272,1099159200,5),(272,1111860000,6),(272,1130608800,5),(272,1143309600,6),(272,1162058400,5),(272,1174759200,6),(272,1193508000,5),(272,1206813600,6),(272,1224957600,5),(272,1238263200,6),(272,1256407200,5),(272,1269712800,6),(272,1288461600,5),(272,1301162400,9),(272,1414256400,5),(272,2147483647,5),(273,-2147483648,1),(273,-1869875816,3),(273,-1693706400,2),(273,-1680490800,3),(273,-1570413600,2),(273,-1552186800,3),(273,-1538359200,2),(273,-1522551600,3),(273,-1507514400,2),(273,-1490583600,3),(273,-1440208800,2),(273,-1428030000,3),(273,-1409709600,2),(273,-1396494000,3),(273,-931053600,2),(273,-922676400,3),(273,-917834400,2),(273,-892436400,3),(273,-875844000,2),(273,-764737200,3),(273,-744343200,2),(273,-733806000,3),(273,-716436000,2),(273,-701924400,3),(273,-684986400,2),(273,-670474800,3),(273,-654141600,2),(273,-639025200,3),(273,-622087200,2),(273,-606970800,3),(273,-590032800,2),(273,-575521200,3),(273,-235620000,2),(273,-194842800,3),(273,-177732000,2),(273,-165726000,3),(273,107910000,2),(273,121215600,3),(273,133920000,2),(273,152665200,3),(273,164678400,2),(273,184114800,3),(273,196214400,2),(273,215564400,3),(273,228873600,2),(273,245804400,3),(273,260323200,2),(273,267915600,4),(273,428454000,5),(273,433893600,4),(273,468111600,3),(273,482799600,6),(273,496710000,7),(273,512521200,6),(273,528246000,7),(273,543970800,6),(273,559695600,7),(273,575420400,6),(273,591145200,7),(273,606870000,6),(273,622594800,7),(273,638319600,6),(273,654649200,7),(273,670374000,6),(273,686098800,7),(273,701823600,6),(273,717548400,7),(273,733273200,6),(273,748998000,7),(273,764118000,6),(273,780447600,7),(273,796172400,6),(273,811897200,7),(273,828226800,6),(273,846370800,7),(273,859676400,6),(273,877820400,7),(273,891126000,6),(273,909270000,7),(273,922575600,6),(273,941324400,7),(273,954025200,6),(273,972774000,7),(273,985474800,6),(273,1004223600,7),(273,1017529200,6),(273,1035673200,7),(273,1048978800,6),(273,1067122800,7),(273,1080428400,6),(273,1099177200,7),(273,1111878000,6),(273,1130626800,7),(273,1143327600,6),(273,1162076400,7),(273,1167602400,3),(273,1174784400,8),(273,1193533200,9),(273,1206838800,8),(273,1224982800,9),(273,1238288400,8),(273,1256432400,9),(273,1269738000,8),(273,1288486800,9),(273,1301274000,8),(273,1319936400,9),(273,1332637200,8),(273,1351386000,9),(273,1364691600,8),(273,1382835600,9),(273,1396227600,8),(273,1414285200,9),(273,1427590800,8),(273,1446944400,9),(273,1459040400,8),(273,1473195600,4),(273,2147483647,4),(274,-2147483648,1),(274,-1451719200,2),(274,-1172906400,3),(274,-876641400,4),(274,-766054800,3),(274,-683883000,5),(274,-620812800,3),(274,-189415800,6),(275,-2147483648,0),(275,-1172913768,1),(275,-799491600,2),(275,-189423000,3),(276,-2147483648,1),(276,-1641003640,6),(276,-933638400,2),(276,-923097600,3),(276,-919036800,2),(276,-857347200,3),(276,-844300800,2),(276,-825811200,3),(276,-812678400,2),(276,-794188800,3),(276,-779846400,2),(276,-762652800,3),(276,-748310400,2),(276,-731116800,3),(276,-681955200,4),(276,-673228800,2),(276,-667958400,3),(276,-652320000,2),(276,-636422400,3),(276,-622080000,2),(276,-608947200,3),(276,-591840000,2),(276,-572486400,3),(276,-558576000,2),(276,-542851200,3),(276,-527731200,2),(276,-514425600,3),(276,-490838400,2),(276,-482976000,3),(276,-459388800,2),(276,-451526400,3),(276,-428544000,2),(276,-418262400,3),(276,-400118400,2),(276,-387417600,3),(276,142380000,5),(276,150843600,6),(276,167176800,5),(276,178664400,6),(276,334101600,7),(276,337730400,8),(276,452642400,7),(276,462319200,8),(276,482277600,5),(276,494370000,6),(276,516751200,5),(276,526424400,6),(276,545436000,5),(276,558478800,6),(276,576626400,5),(276,589323600,6),(276,609890400,5),(276,620773200,6),(276,638316000,5),(276,651618000,6),(276,669765600,5),(276,683672400,6),(276,701820000,5),(276,715726800,6),(276,733701600,5),(276,747176400,6),(276,765151200,5),(276,778021200,6),(276,796600800,5),(276,810075600,6),(276,826840800,5),(276,842821200,6),(276,858895200,5),(276,874184400,6),(276,890344800,5),(276,905029200,6),(276,923011200,5),(276,936313200,6),(276,955670400,5),(276,970783200,6),(276,986770800,5),(276,1001282400,6),(276,1017356400,5),(276,1033941600,6),(276,1048806000,5),(276,1065132000,6),(276,1081292400,5),(276,1095804000,6),(276,1112313600,5),(276,1128812400,6),(276,1143763200,5),(276,1159657200,6),(276,1175212800,5),(276,1189897200,6),(276,1206662400,5),(276,1223161200,6),(276,1238112000,5),(276,1254006000,6),(276,1269561600,5),(276,1284246000,6),(276,1301616000,5),(276,1317510000,6),(276,1333065600,5),(276,1348354800,6),(276,1364515200,5),(276,1382828400,6),(276,1395964800,5),(276,1414278000,6),(276,1427414400,5),(276,1445727600,6),(276,1458864000,5),(276,1477782000,6),(276,1490313600,5),(276,1509231600,6),(276,1521763200,5),(276,1540681200,6),(276,1553817600,5),(276,1572130800,6),(276,1585267200,5),(276,1603580400,6),(276,1616716800,5),(276,1635634800,6),(276,1648166400,5),(276,1667084400,6),(276,1679616000,5),(276,1698534000,6),(276,1711670400,5),(276,1729983600,6),(276,1743120000,5),(276,1761433200,6),(276,1774569600,5),(276,1792882800,6),(276,1806019200,5),(276,1824937200,6),(276,1837468800,5),(276,1856386800,6),(276,1868918400,5),(276,1887836400,6),(276,1900972800,5),(276,1919286000,6),(276,1932422400,5),(276,1950735600,6),(276,1963872000,5),(276,1982790000,6),(276,1995321600,5),(276,2014239600,6),(276,2026771200,5),(276,2045689200,6),(276,2058220800,5),(276,2077138800,6),(276,2090275200,5),(276,2108588400,6),(276,2121724800,5),(276,2140038000,6),(277,-2147483648,1),(277,-788932800,2),(277,2147483647,2),(278,-2147483648,0),(278,-1487759676,1),(278,-1247569200,3),(278,354888000,2),(278,370695600,3),(278,386424000,2),(278,402231600,3),(278,417960000,2),(278,433767600,3),(278,449582400,2),(278,465314400,4),(278,481039200,5),(278,496764000,4),(278,512488800,5),(278,528213600,4),(278,543938400,5),(278,559663200,4),(278,575388000,5),(278,591112800,4),(278,606837600,5),(278,622562400,4),(278,638287200,5),(278,654616800,4),(278,670341600,6),(278,686070000,7),(278,695746800,4),(278,701791200,5),(278,717516000,4),(278,733240800,5),(278,748965600,4),(278,764690400,5),(278,780415200,4),(278,796140000,5),(278,811864800,4),(278,828194400,5),(278,846338400,4),(278,859644000,5),(278,877788000,4),(278,891093600,5),(278,909237600,4),(278,922543200,5),(278,941292000,4),(278,953992800,5),(278,972741600,4),(278,985442400,5),(278,1004191200,4),(278,1017496800,5),(278,1035640800,4),(278,1048946400,5),(278,1067090400,4),(278,1080396000,5),(278,1099144800,4),(278,1111845600,5),(278,1130594400,4),(278,1143295200,5),(278,1162044000,4),(278,1174744800,5),(278,1193493600,4),(278,1206799200,5),(278,1224943200,4),(278,1238248800,5),(278,1256392800,4),(278,1269698400,6),(278,1288450800,7),(278,1301151600,4),(278,2147483647,4),(279,-2147483648,0),(279,-1988166492,1),(279,-862637400,2),(279,-764145000,1),(279,-576135000,3),(279,38775600,5),(279,1018119600,4),(279,1033840800,5),(279,1212260400,4),(279,1225476000,5),(279,1239735600,4),(279,1257012000,5),(280,-2147483648,0),(280,-1325483420,1),(280,2147483647,1),(281,-2147483648,0),(281,-1577943676,1),(281,504901800,2),(281,2147483647,2),(282,-2147483648,0),(282,-1577943676,1),(282,504901800,2),(282,2147483647,2),(283,-2147483648,0),(283,-1579424533,1),(283,-1247558400,3),(283,354898800,2),(283,370706400,3),(283,386434800,2),(283,402242400,3),(283,417970800,2),(283,433778400,3),(283,449593200,2),(283,465325200,4),(283,481050000,5),(283,496774800,4),(283,512499600,5),(283,528224400,4),(283,543949200,5),(283,559674000,4),(283,575398800,5),(283,591123600,4),(283,606848400,5),(283,622573200,4),(283,638298000,5),(283,654627600,4),(283,670352400,6),(283,686080800,7),(283,695757600,4),(283,701802000,5),(283,717526800,4),(283,733251600,5),(283,748976400,4),(283,764701200,5),(283,780426000,4),(283,796150800,5),(283,811875600,4),(283,828205200,5),(283,846349200,4),(283,859654800,5),(283,877798800,4),(283,891104400,5),(283,909248400,4),(283,922554000,5),(283,941302800,4),(283,954003600,5),(283,972752400,4),(283,985453200,5),(283,1004202000,4),(283,1017507600,5),(283,1035651600,4),(283,1048957200,5),(283,1067101200,4),(283,1072882800,10),(283,1080403200,8),(283,1099152000,9),(283,1111852800,8),(283,1130601600,9),(283,1143302400,8),(283,1162051200,9),(283,1174752000,8),(283,1193500800,9),(283,1206806400,8),(283,1224950400,9),(283,1238256000,8),(283,1256400000,9),(283,1269705600,8),(283,1288454400,9),(283,1301155200,11),(283,1315832400,9),(283,1414252800,4),(283,2147483647,4),(284,-2147483648,1),(284,-2019705670,2),(284,-891581400,3),(284,-872058600,2),(284,-862637400,3),(284,-764145000,2),(285,-2147483648,0),(285,-1577513486,1),(285,-1247551200,3),(285,354906000,2),(285,370713600,3),(285,386442000,2),(285,402249600,3),(285,417978000,2),(285,433785600,3),(285,449600400,2),(285,465332400,4),(285,481057200,5),(285,496782000,4),(285,512506800,5),(285,528231600,4),(285,543956400,5),(285,559681200,4),(285,575406000,5),(285,591130800,4),(285,606855600,5),(285,622580400,4),(285,638305200,5),(285,654634800,4),(285,670359600,6),(285,686088000,7),(285,695764800,4),(285,701809200,5),(285,717534000,4),(285,733258800,5),(285,748983600,4),(285,764708400,5),(285,780433200,4),(285,796158000,5),(285,811882800,4),(285,828212400,5),(285,846356400,4),(285,859662000,5),(285,877806000,4),(285,891111600,5),(285,909255600,4),(285,922561200,5),(285,941310000,4),(285,954010800,5),(285,972759600,4),(285,985460400,5),(285,1004209200,4),(285,1017514800,5),(285,1035658800,4),(285,1048964400,5),(285,1067108400,4),(285,1080414000,5),(285,1099162800,4),(285,1111863600,5),(285,1130612400,4),(285,1143313200,5),(285,1162062000,4),(285,1174762800,5),(285,1193511600,4),(285,1206817200,5),(285,1224961200,4),(285,1238266800,5),(285,1256410800,4),(285,1269716400,5),(285,1288465200,4),(285,1301166000,8),(285,1414260000,4),(285,2147483647,4),(286,-2147483648,1),(286,-2038200925,2),(286,-1167634800,3),(286,-1073028000,4),(286,-894180000,5),(286,-879665400,6),(286,-767005200,5),(286,378662400,7),(286,2147483647,7),(287,-2147483648,0),(287,-1383463280,1),(287,-1167636600,3),(287,-1082448000,2),(287,-1074586800,3),(287,-1050825600,2),(287,-1042964400,3),(287,-1019289600,2),(287,-1011428400,3),(287,-987753600,2),(287,-979892400,3),(287,-956217600,2),(287,-948356400,3),(287,-924595200,2),(287,-916734000,3),(287,-893059200,2),(287,-885198000,3),(287,-879667200,4),(287,-767005200,3),(287,2147483647,3),(288,-2147483648,0),(288,-719636812,1),(288,2147483647,1),(289,-2147483648,0),(289,-2056692850,1),(289,-884509200,3),(289,-873280800,2),(289,-855918000,3),(289,-841744800,2),(289,-828529200,3),(289,-765363600,1),(289,-747046800,4),(289,-733827600,5),(289,-716461200,4),(289,-697021200,5),(289,-683715600,4),(289,-667990800,5),(289,-654771600,4),(289,-636627600,5),(289,-623322000,4),(289,-605178000,5),(289,-591872400,4),(289,-573642000,5),(289,-559818000,4),(289,-541674000,5),(289,-528368400,4),(289,-510224400,5),(289,-498128400,4),(289,-478774800,5),(289,-466678800,4),(289,-446720400,5),(289,-435229200,4),(289,-415258200,1),(289,-403158600,6),(289,-383808600,1),(289,-371709000,6),(289,-352359000,1),(289,-340259400,6),(289,-320909400,1),(289,-308809800,6),(289,-288855000,1),(289,-277360200,6),(289,-257405400,1),(289,-245910600,6),(289,-225955800,1),(289,-213856200,6),(289,-194506200,1),(289,-182406600,6),(289,-163056600,1),(289,-148537800,6),(289,-132820200,1),(289,-117088200,6),(289,-101370600,1),(289,-85638600,6),(289,-69312600,1),(289,-53584200,6),(289,-37863000,1),(289,-22134600,6),(289,-6413400,1),(289,9315000,6),(289,25036200,1),(289,40764600,6),(289,56485800,1),(289,72214200,6),(289,88540200,1),(289,104268600,6),(289,119989800,1),(289,126041400,6),(289,151439400,1),(289,167167800,6),(289,182889000,1),(289,198617400,6),(289,214338600,1),(289,295385400,6),(289,309292200,1),(290,-2147483648,0),(290,-2056692850,1),(290,-884509200,3),(290,-873280800,2),(290,-855918000,3),(290,-841744800,2),(290,-828529200,3),(290,-765363600,1),(290,-747046800,4),(290,-733827600,5),(290,-716461200,4),(290,-697021200,5),(290,-683715600,4),(290,-667990800,5),(290,-654771600,4),(290,-636627600,5),(290,-623322000,4),(290,-605178000,5),(290,-591872400,4),(290,-573642000,5),(290,-559818000,4),(290,-541674000,5),(290,-528368400,4),(290,-510224400,5),(290,-498128400,4),(290,-478774800,5),(290,-466678800,4),(290,-446720400,5),(290,-435229200,4),(290,-415258200,1),(290,-403158600,6),(290,-383808600,1),(290,-371709000,6),(290,-352359000,1),(290,-340259400,6),(290,-320909400,1),(290,-308809800,6),(290,-288855000,1),(290,-277360200,6),(290,-257405400,1),(290,-245910600,6),(290,-225955800,1),(290,-213856200,6),(290,-194506200,1),(290,-182406600,6),(290,-163056600,1),(290,-148537800,6),(290,-132820200,1),(290,-117088200,6),(290,-101370600,1),(290,-85638600,6),(290,-69312600,1),(290,-53584200,6),(290,-37863000,1),(290,-22134600,6),(290,-6413400,1),(290,9315000,6),(290,25036200,1),(290,40764600,6),(290,56485800,1),(290,72214200,6),(290,88540200,1),(290,104268600,6),(290,119989800,1),(290,126041400,6),(290,151439400,1),(290,167167800,6),(290,182889000,1),(290,198617400,6),(290,214338600,1),(290,295385400,6),(290,309292200,1),(291,-2147483648,0),(291,-1441188192,1),(291,-1247565600,3),(291,354891600,2),(291,370699200,3),(291,386427600,2),(291,402235200,3),(291,417963600,2),(291,433771200,3),(291,449586000,2),(291,465318000,4),(291,481042800,5),(291,496767600,4),(291,512492400,5),(291,528217200,4),(291,543942000,5),(291,559666800,4),(291,575391600,5),(291,591116400,4),(291,606841200,5),(291,622566000,4),(291,638290800,5),(291,654620400,4),(291,670345200,6),(291,686073600,7),(291,695750400,4),(291,701794800,5),(291,717519600,4),(291,733244400,5),(291,748969200,4),(291,764694000,5),(291,780418800,4),(291,796143600,5),(291,811868400,4),(291,828198000,5),(291,846342000,4),(291,859647600,5),(291,877791600,4),(291,891097200,5),(291,909241200,4),(291,922546800,5),(291,941295600,4),(291,953996400,5),(291,972745200,4),(291,985446000,5),(291,1004194800,4),(291,1017500400,5),(291,1035644400,4),(291,1048950000,5),(291,1067094000,4),(291,1080399600,5),(291,1099148400,4),(291,1111849200,5),(291,1130598000,4),(291,1143298800,5),(291,1162047600,4),(291,1174748400,5),(291,1193497200,4),(291,1206802800,5),(291,1224946800,4),(291,1238252400,5),(291,1256396400,4),(291,1269702000,5),(291,1288450800,4),(291,1301151600,8),(291,1414245600,7),(291,1461427200,4),(291,2147483647,4),(292,-2147483648,0),(292,-1577951856,1),(292,-1172908656,2),(292,-880272000,3),(292,-766054800,4),(293,-2147483648,2),(293,-1046678400,1),(293,-1038733200,2),(293,-873273600,3),(293,-794221200,2),(293,-496224000,1),(293,-489315600,2),(293,259344000,1),(293,275151600,2),(294,-2147483648,0),(294,-1577936472,1),(294,2147483647,1),(295,-2147483648,0),(295,-1518920008,2),(295,166572000,1),(295,182293200,2),(295,200959200,1),(295,213829200,2),(295,228866400,1),(295,243982800,2),(295,260316000,1),(295,276123600,2),(295,291765600,1),(295,307486800,2),(295,323820000,1),(295,338936400,2),(295,354664800,1),(295,370386000,2),(295,386114400,1),(295,401835600,2),(295,417564000,1),(295,433285200,2),(295,449013600,1),(295,465339600,2),(295,481068000,1),(295,496789200,2),(295,512517600,1),(295,528238800,2),(295,543967200,1),(295,559688400,2),(295,575416800,1),(295,591138000,2),(295,606866400,1),(295,622587600,2),(295,638316000,1),(295,654642000,2),(295,670370400,1),(295,686091600,2),(295,701820000,1),(295,717541200,2),(295,733269600,1),(295,748990800,2),(295,764719200,1),(295,780440400,2),(295,796168800,1),(295,811890000,2),(295,828223200,1),(295,843944400,2),(295,859672800,1),(295,875394000,2),(295,891122400,1),(295,909277200,3),(295,922582800,4),(295,941331600,3),(295,954032400,4),(295,972781200,3),(295,985482000,4),(295,1004230800,3),(295,1017536400,4),(295,1035680400,3),(295,1048986000,4),(295,1067130000,3),(295,1080435600,4),(295,1099184400,3),(295,1111885200,4),(295,1130634000,3),(295,1143334800,4),(295,1162083600,3),(295,1174784400,4),(295,1193533200,3),(295,1206838800,4),(295,1224982800,3),(295,1238288400,4),(295,1256432400,3),(295,1269738000,4),(295,1288486800,3),(295,1301187600,4),(295,1319936400,3),(295,1332637200,4),(295,1351386000,3),(295,1364691600,4),(295,1382835600,3),(295,1396141200,4),(295,1414285200,3),(295,1427590800,4),(295,1445734800,3),(295,1459040400,4),(295,1477789200,3),(295,1490490000,4),(295,1509238800,3),(295,1521939600,4),(295,1540688400,3),(295,1553994000,4),(295,1572138000,3),(295,1585443600,4),(295,1603587600,3),(295,1616893200,4),(295,1635642000,3),(295,1648342800,4),(295,1667091600,3),(295,1679792400,4),(295,1698541200,3),(295,1711846800,4),(295,1729990800,3),(295,1743296400,4),(295,1761440400,3),(295,1774746000,4),(295,1792890000,3),(295,1806195600,4),(295,1824944400,3),(295,1837645200,4),(295,1856394000,3),(295,1869094800,4),(295,1887843600,3),(295,1901149200,4),(295,1919293200,3),(295,1932598800,4),(295,1950742800,3),(295,1964048400,4),(295,1982797200,3),(295,1995498000,4),(295,2014246800,3),(295,2026947600,4),(295,2045696400,3),(295,2058397200,4),(295,2077146000,3),(295,2090451600,4),(295,2108595600,3),(295,2121901200,4),(295,2140045200,3),(296,-2147483648,0),(296,-1441259328,1),(296,-1247551200,3),(296,354906000,2),(296,370713600,3),(296,386442000,2),(296,402249600,3),(296,417978000,2),(296,433785600,3),(296,449600400,2),(296,465332400,4),(296,481057200,5),(296,496782000,4),(296,512506800,5),(296,528231600,4),(296,543956400,5),(296,559681200,4),(296,575406000,5),(296,591130800,4),(296,606855600,5),(296,622580400,4),(296,638305200,5),(296,654634800,4),(296,670359600,6),(296,686088000,7),(296,695764800,4),(296,701809200,5),(296,717534000,4),(296,733258800,5),(296,748983600,4),(296,764708400,5),(296,780433200,4),(296,796158000,5),(296,811882800,4),(296,828212400,5),(296,846356400,4),(296,859662000,5),(296,877806000,4),(296,891111600,5),(296,909255600,4),(296,922561200,5),(296,941310000,4),(296,954010800,5),(296,972759600,4),(296,985460400,5),(296,1004209200,4),(296,1017514800,5),(296,1035658800,4),(296,1048964400,5),(296,1067108400,4),(296,1080414000,5),(296,1099162800,4),(296,1111863600,5),(296,1130612400,4),(296,1143313200,5),(296,1162062000,4),(296,1174762800,5),(296,1193511600,4),(296,1206817200,5),(296,1224961200,4),(296,1238266800,5),(296,1256410800,4),(296,1269716400,6),(296,1288468800,7),(296,1301169600,4),(296,2147483647,4),(297,-2147483648,0),(297,-1579476700,1),(297,-1247551200,3),(297,354906000,2),(297,370713600,3),(297,386442000,2),(297,402249600,3),(297,417978000,2),(297,433785600,3),(297,449600400,2),(297,465332400,4),(297,481057200,5),(297,496782000,4),(297,512506800,5),(297,528231600,4),(297,543956400,5),(297,559681200,4),(297,575406000,5),(297,591130800,4),(297,606855600,5),(297,622580400,4),(297,638305200,5),(297,654634800,4),(297,670359600,6),(297,686088000,7),(297,695764800,4),(297,701809200,5),(297,717534000,4),(297,733258800,5),(297,738086400,8),(297,748987200,7),(297,764712000,6),(297,780436800,7),(297,796161600,6),(297,811886400,7),(297,828216000,6),(297,846360000,7),(297,859665600,6),(297,877809600,7),(297,891115200,6),(297,909259200,7),(297,922564800,6),(297,941313600,7),(297,954014400,6),(297,972763200,7),(297,985464000,6),(297,1004212800,7),(297,1017518400,6),(297,1035662400,7),(297,1048968000,6),(297,1067112000,7),(297,1080417600,6),(297,1099166400,7),(297,1111867200,6),(297,1130616000,7),(297,1143316800,6),(297,1162065600,7),(297,1174766400,6),(297,1193515200,7),(297,1206820800,6),(297,1224964800,7),(297,1238270400,6),(297,1256414400,7),(297,1269720000,6),(297,1288468800,7),(297,1301169600,4),(297,1414263600,7),(297,1469304000,4),(297,2147483647,4),(298,-2147483648,0),(298,-1582088010,1),(298,-1247547600,3),(298,354909600,2),(298,370717200,3),(298,386445600,2),(298,402253200,3),(298,417981600,2),(298,433789200,3),(298,449604000,2),(298,465336000,4),(298,481060800,5),(298,496785600,4),(298,512510400,5),(298,528235200,4),(298,543960000,5),(298,559684800,4),(298,575409600,5),(298,591134400,4),(298,606859200,5),(298,622584000,4),(298,638308800,5),(298,654638400,4),(298,670363200,6),(298,686091600,7),(298,695768400,4),(298,701812800,5),(298,717537600,4),(298,733262400,5),(298,748987200,4),(298,764712000,5),(298,780436800,4),(298,796161600,5),(298,811886400,4),(298,828216000,5),(298,846360000,4),(298,859665600,5),(298,877809600,4),(298,891115200,5),(298,909259200,4),(298,922564800,5),(298,941313600,4),(298,954014400,5),(298,972763200,4),(298,985464000,5),(298,1004212800,4),(298,1017518400,5),(298,1035662400,4),(298,1048968000,5),(298,1067112000,4),(298,1080417600,5),(298,1099166400,4),(298,1111867200,5),(298,1130616000,4),(298,1143316800,5),(298,1162065600,4),(298,1174766400,5),(298,1193515200,4),(298,1206820800,5),(298,1224964800,4),(298,1238270400,5),(298,1256414400,4),(298,1269720000,5),(298,1288468800,4),(298,1301169600,8),(298,1414263600,4),(298,2147483647,4),(299,-2147483648,0),(299,-1441164324,1),(299,-1247540400,2),(299,354913200,3),(299,370720800,4),(299,386445600,3),(299,402256800,2),(299,417985200,3),(299,433792800,2),(299,449607600,3),(299,465339600,5),(299,481064400,6),(299,496789200,5),(299,512514000,6),(299,528238800,5),(299,543963600,6),(299,559688400,5),(299,575413200,6),(299,591138000,5),(299,606862800,7),(299,622591200,8),(299,638316000,7),(299,654645600,8),(299,670370400,7),(299,686095200,8),(299,695772000,5),(299,701816400,7),(299,717544800,8),(299,733269600,7),(299,748994400,8),(299,764719200,7),(299,780444000,8),(299,796168800,7),(299,811893600,8),(299,828223200,7),(299,846367200,8),(299,859672800,7),(299,877816800,8),(299,891122400,7),(299,909266400,8),(299,922572000,7),(299,941320800,8),(299,954021600,7),(299,972770400,8),(299,985471200,7),(299,1004220000,8),(299,1017525600,7),(299,1035669600,8),(299,1048975200,7),(299,1067119200,8),(299,1080424800,7),(299,1099173600,5),(299,2147483647,5),(300,-2147483648,1),(300,-1570084924,2),(300,2147483647,2),(301,-2147483648,0),(301,-1946186240,1),(301,-1172906240,2),(301,-881220600,3),(301,-766054800,2),(301,-683883000,4),(301,-620812800,2),(301,-189415800,5),(301,567964800,6),(302,-2147483648,0),(302,-1948782180,1),(302,-1830414600,2),(302,-768646800,3),(302,1439564400,1),(302,1525446000,3),(303,-2147483648,0),(303,-1577935568,1),(303,76190400,2),(303,2147483647,2),(304,-2147483648,0),(304,-1441167268,1),(304,-1247544000,2),(304,354913200,3),(304,370720800,4),(304,386445600,3),(304,402256800,2),(304,417985200,3),(304,433792800,2),(304,449607600,3),(304,465339600,5),(304,481064400,6),(304,496789200,5),(304,512514000,6),(304,528238800,5),(304,543963600,6),(304,559688400,5),(304,575413200,6),(304,591138000,5),(304,606862800,6),(304,622587600,5),(304,638312400,6),(304,654642000,5),(304,670366800,7),(304,686095200,8),(304,695772000,5),(304,701816400,6),(304,717541200,5),(304,733266000,6),(304,748990800,5),(304,764715600,6),(304,780440400,5),(304,796165200,6),(304,811890000,5),(304,828219600,6),(304,846363600,5),(304,859669200,6),(304,877813200,5),(304,891118800,6),(304,909262800,5),(304,922568400,6),(304,941317200,5),(304,954018000,6),(304,972766800,5),(304,985467600,6),(304,1004216400,5),(304,1017522000,6),(304,1035666000,5),(304,1048971600,6),(304,1067115600,5),(304,1080421200,6),(304,1099170000,9),(304,2147483647,9),(305,-2147483648,0),(305,-1441167712,1),(305,-1247544000,2),(305,354913200,3),(305,370720800,4),(305,386445600,3),(305,402256800,2),(305,417985200,3),(305,433792800,2),(305,449607600,3),(305,465339600,5),(305,481064400,6),(305,496789200,5),(305,512514000,6),(305,528238800,5),(305,543963600,6),(305,559688400,5),(305,575413200,6),(305,591138000,5),(305,606862800,6),(305,622587600,5),(305,638312400,6),(305,654642000,5),(305,670366800,7),(305,686095200,5),(305,695768400,9),(305,701812800,6),(305,717541200,5),(305,733266000,6),(305,748990800,5),(305,764715600,6),(305,780440400,5),(305,796165200,6),(305,811890000,5),(305,828219600,6),(305,846363600,5),(305,859669200,6),(305,877813200,5),(305,891118800,6),(305,909262800,5),(305,922568400,6),(305,941317200,5),(305,954018000,6),(305,972766800,5),(305,985467600,6),(305,1004216400,5),(305,1017522000,6),(305,1035666000,5),(305,1048971600,6),(305,1067115600,5),(305,1080421200,6),(305,1099170000,9),(305,1545328800,2),(305,2147483647,2),(306,-2147483648,1),(306,-1577946287,2),(306,-873268200,3),(306,-778410000,2),(306,2147483647,2),(307,-2147483648,0),(307,-719636812,1),(307,2147483647,1),(308,-2147483648,0),(308,-2004073590,1),(308,-1851577590,2),(308,-852105600,3),(308,-782643600,4),(308,-767869200,2),(308,-718095600,3),(308,-457776000,2),(308,-315648000,3),(308,171820800,2),(308,2147483647,2),(309,-2147483648,0),(309,-2031039048,1),(309,-768560400,3),(309,354891600,2),(309,370699200,3),(309,386427600,2),(309,402235200,3),(309,417963600,2),(309,433771200,3),(309,449586000,2),(309,465318000,4),(309,481042800,5),(309,496767600,4),(309,512492400,5),(309,528217200,4),(309,543942000,5),(309,559666800,4),(309,575391600,5),(309,591116400,4),(309,606841200,5),(309,622566000,4),(309,638290800,5),(309,654620400,4),(309,670345200,6),(309,686073600,7),(309,695750400,4),(309,701794800,5),(309,717519600,4),(309,733244400,5),(309,748969200,4),(309,764694000,5),(309,780418800,4),(309,796143600,5),(309,811868400,4),(309,828198000,5),(309,846342000,4),(309,859647600,6),(309,877795200,7),(309,891100800,6),(309,909244800,7),(309,922550400,6),(309,941299200,7),(309,954000000,6),(309,972748800,7),(309,985449600,6),(309,1004198400,7),(309,1017504000,6),(309,1035648000,7),(309,1048953600,6),(309,1067097600,7),(309,1080403200,6),(309,1099152000,7),(309,1111852800,6),(309,1130601600,7),(309,1143302400,6),(309,1162051200,7),(309,1174752000,6),(309,1193500800,7),(309,1206806400,6),(309,1224950400,7),(309,1238256000,6),(309,1256400000,7),(309,1269705600,6),(309,1288454400,7),(309,1301155200,4),(309,1414249200,7),(309,1459008000,4),(309,2147483647,4),(310,-2147483648,0),(310,-1441168073,1),(310,-1247544000,2),(310,354913200,3),(310,370720800,4),(310,386445600,3),(310,402256800,2),(310,417985200,3),(310,433792800,2),(310,449607600,3),(310,465339600,5),(310,481064400,6),(310,496789200,5),(310,512514000,6),(310,528238800,5),(310,543963600,6),(310,559688400,5),(310,575413200,6),(310,591138000,5),(310,606862800,6),(310,622587600,5),(310,638312400,6),(310,654642000,5),(310,670366800,6),(310,686091600,5),(310,694206000,2),(310,2147483647,2),(311,-2147483648,0),(311,-1948782472,1),(311,-1830414600,2),(311,-767350800,4),(311,-681210000,3),(311,-672228000,4),(311,-654771600,3),(311,-640864800,4),(311,-623408400,3),(311,-609415200,4),(311,-588848400,3),(311,-577965600,4),(311,-498128400,1),(311,-462702600,5),(311,-451733400,1),(311,-429784200,5),(311,-418296600,1),(311,-399544200,5),(311,-387451800,1),(311,-368094600,5),(311,-356002200,1),(311,-336645000,5),(311,-324552600,1),(311,-305195400,5),(311,-293103000,1),(311,-264933000,4),(311,547578000,3),(311,560883600,4),(311,579027600,3),(311,592333200,4),(312,-2147483648,2),(312,-1600675200,1),(312,-1585904400,2),(312,-933667200,1),(312,-922093200,2),(312,-908870400,1),(312,-888829200,2),(312,-881049600,1),(312,-767869200,2),(312,-745833600,1),(312,-733827600,2),(312,-716889600,1),(312,-699613200,2),(312,-683884800,1),(312,-670669200,2),(312,-652348800,1),(312,-650019600,2),(312,515527200,1),(312,527014800,2),(312,545162400,1),(312,558464400,2),(312,577216800,1),(312,589914000,2),(312,608666400,1),(312,621968400,2),(312,640116000,1),(312,653418000,2),(312,671565600,1),(312,684867600,2),(313,-2147483648,1),(313,-2038200925,2),(313,-1167634800,3),(313,-1073028000,4),(313,-894180000,5),(313,-879665400,6),(313,-767005200,5),(313,378662400,7),(313,2147483647,7),(314,-2147483648,0),(314,-1441188892,1),(314,-1247565600,3),(314,354891600,2),(314,370699200,3),(314,386427600,2),(314,402235200,3),(314,417963600,2),(314,433771200,3),(314,449586000,2),(314,465318000,4),(314,481042800,5),(314,496767600,4),(314,512492400,5),(314,528217200,4),(314,543942000,5),(314,559666800,4),(314,575391600,5),(314,591116400,4),(314,606841200,5),(314,622566000,4),(314,638290800,5),(314,654620400,4),(314,670345200,6),(314,686073600,7),(314,695750400,4),(314,701794800,5),(314,717519600,4),(314,733244400,5),(314,748969200,4),(314,764694000,5),(314,780418800,4),(314,796143600,5),(314,811868400,4),(314,828198000,5),(314,846342000,4),(314,859647600,5),(314,877791600,4),(314,891097200,5),(314,909241200,4),(314,922546800,5),(314,941295600,4),(314,953996400,5),(314,972745200,4),(314,985446000,5),(314,1004194800,4),(314,1017500400,5),(314,1035644400,4),(314,1048950000,5),(314,1067094000,4),(314,1080399600,5),(314,1099148400,4),(314,1111849200,5),(314,1130598000,4),(314,1143298800,5),(314,1162047600,4),(314,1174748400,5),(314,1193497200,4),(314,1206802800,5),(314,1224946800,4),(314,1238252400,5),(314,1256396400,4),(314,1269702000,5),(314,1288450800,4),(314,1301151600,8),(314,1414245600,4),(314,2147483647,4),(315,-2147483648,1),(315,-1017820800,2),(315,-766224000,1),(315,-745833600,3),(315,-733827600,1),(315,-716889600,3),(315,-699613200,1),(315,-683884800,3),(315,-670669200,1),(315,-652348800,3),(315,-639133200,1),(315,-620812800,3),(315,-607597200,1),(315,-589276800,3),(315,-576061200,1),(315,-562924800,3),(315,-541760400,1),(315,-528710400,3),(315,-510224400,1),(315,-497174400,3),(315,-478688400,1),(315,-465638400,3),(315,-449830800,1),(315,-434016000,3),(315,-418208400,1),(315,-402480000,3),(315,-386672400,1),(315,-370944000,3),(315,-355136400,1),(315,-339408000,3),(315,-323600400,1),(315,-302515200,3),(315,-291978000,1),(315,-270979200,3),(315,-260442000,1),(315,133977600,3),(315,149785200,1),(315,165513600,3),(315,181321200,1),(315,299606400,3),(315,307551600,1),(316,-2147483648,0),(316,-1441168631,1),(316,-1247547600,3),(316,354909600,2),(316,370717200,3),(316,386445600,2),(316,402253200,3),(316,417981600,2),(316,433789200,3),(316,449604000,2),(316,465336000,4),(316,481060800,5),(316,496785600,4),(316,512510400,5),(316,528235200,4),(316,543960000,5),(316,559684800,4),(316,575409600,5),(316,591134400,4),(316,606859200,5),(316,622584000,4),(316,638308800,5),(316,654638400,4),(316,670363200,6),(316,686091600,7),(316,694206000,1),(316,2147483647,1),(317,-2147483648,1),(317,-1441162751,2),(317,-405140400,4),(317,354916800,3),(317,370724400,4),(317,386452800,3),(317,402260400,4),(317,417988800,3),(317,433796400,4),(317,449611200,3),(317,465343200,5),(317,481068000,6),(317,496792800,5),(317,512517600,6),(317,528242400,5),(317,543967200,6),(317,559692000,5),(317,575416800,6),(317,591141600,5),(317,606866400,6),(317,622591200,5),(317,638316000,6),(317,654645600,5),(317,670370400,7),(317,686098800,8),(317,694213200,2),(317,701816400,9),(317,717537600,2),(317,733266000,9),(317,748987200,2),(317,764715600,9),(317,780436800,4),(317,796161600,3),(317,811882800,4),(317,828216000,3),(317,859662000,3),(317,877806000,4),(317,891115200,3),(317,909255600,4),(317,922564800,3),(317,941310000,4),(317,954014400,3),(317,972759600,4),(317,985464000,3),(317,1004209200,4),(317,1017518400,3),(317,1035658800,4),(317,1048968000,3),(317,1067108400,4),(317,1080417600,3),(317,1088276400,9),(317,1099177200,8),(317,1111878000,4),(317,2147483647,4),(318,-2147483648,0),(318,-1704165944,1),(318,-1090466744,3),(318,227820600,2),(318,246223800,5),(318,259617600,4),(318,271108800,5),(318,283982400,3),(318,296598600,2),(318,306531000,3),(318,322432200,2),(318,338499000,3),(318,673216200,2),(318,685481400,3),(318,701209800,2),(318,717103800,3),(318,732745800,2),(318,748639800,3),(318,764281800,2),(318,780175800,3),(318,795817800,2),(318,811711800,3),(318,827353800,2),(318,843247800,3),(318,858976200,2),(318,874870200,3),(318,890512200,2),(318,906406200,3),(318,922048200,2),(318,937942200,3),(318,953584200,2),(318,969478200,3),(318,985206600,2),(318,1001100600,3),(318,1016742600,2),(318,1032636600,3),(318,1048278600,2),(318,1064172600,3),(318,1079814600,2),(318,1095708600,3),(318,1111437000,2),(318,1127331000,3),(318,1206045000,2),(318,1221939000,3),(318,1237667400,2),(318,1253561400,3),(318,1269203400,2),(318,1285097400,3),(318,1300739400,2),(318,1316633400,3),(318,1332275400,2),(318,1348169400,3),(318,1363897800,2),(318,1379791800,3),(318,1395433800,2),(318,1411327800,3),(318,1426969800,2),(318,1442863800,3),(318,1458505800,2),(318,1474399800,3),(318,1490128200,2),(318,1506022200,3),(318,1521664200,2),(318,1537558200,3),(318,1553200200,2),(318,1569094200,3),(318,1584736200,2),(318,1600630200,3),(318,1616358600,2),(318,1632252600,3),(318,1647894600,2),(318,1663788600,3),(318,2147483647,3),(319,-2147483648,1),(319,-1641003640,6),(319,-933638400,2),(319,-923097600,3),(319,-919036800,2),(319,-857347200,3),(319,-844300800,2),(319,-825811200,3),(319,-812678400,2),(319,-794188800,3),(319,-779846400,2),(319,-762652800,3),(319,-748310400,2),(319,-731116800,3),(319,-681955200,4),(319,-673228800,2),(319,-667958400,3),(319,-652320000,2),(319,-636422400,3),(319,-622080000,2),(319,-608947200,3),(319,-591840000,2),(319,-572486400,3),(319,-558576000,2),(319,-542851200,3),(319,-527731200,2),(319,-514425600,3),(319,-490838400,2),(319,-482976000,3),(319,-459388800,2),(319,-451526400,3),(319,-428544000,2),(319,-418262400,3),(319,-400118400,2),(319,-387417600,3),(319,142380000,5),(319,150843600,6),(319,167176800,5),(319,178664400,6),(319,334101600,7),(319,337730400,8),(319,452642400,7),(319,462319200,8),(319,482277600,5),(319,494370000,6),(319,516751200,5),(319,526424400,6),(319,545436000,5),(319,558478800,6),(319,576626400,5),(319,589323600,6),(319,609890400,5),(319,620773200,6),(319,638316000,5),(319,651618000,6),(319,669765600,5),(319,683672400,6),(319,701820000,5),(319,715726800,6),(319,733701600,5),(319,747176400,6),(319,765151200,5),(319,778021200,6),(319,796600800,5),(319,810075600,6),(319,826840800,5),(319,842821200,6),(319,858895200,5),(319,874184400,6),(319,890344800,5),(319,905029200,6),(319,923011200,5),(319,936313200,6),(319,955670400,5),(319,970783200,6),(319,986770800,5),(319,1001282400,6),(319,1017356400,5),(319,1033941600,6),(319,1048806000,5),(319,1065132000,6),(319,1081292400,5),(319,1095804000,6),(319,1112313600,5),(319,1128812400,6),(319,1143763200,5),(319,1159657200,6),(319,1175212800,5),(319,1189897200,6),(319,1206662400,5),(319,1223161200,6),(319,1238112000,5),(319,1254006000,6),(319,1269561600,5),(319,1284246000,6),(319,1301616000,5),(319,1317510000,6),(319,1333065600,5),(319,1348354800,6),(319,1364515200,5),(319,1382828400,6),(319,1395964800,5),(319,1414278000,6),(319,1427414400,5),(319,1445727600,6),(319,1458864000,5),(319,1477782000,6),(319,1490313600,5),(319,1509231600,6),(319,1521763200,5),(319,1540681200,6),(319,1553817600,5),(319,1572130800,6),(319,1585267200,5),(319,1603580400,6),(319,1616716800,5),(319,1635634800,6),(319,1648166400,5),(319,1667084400,6),(319,1679616000,5),(319,1698534000,6),(319,1711670400,5),(319,1729983600,6),(319,1743120000,5),(319,1761433200,6),(319,1774569600,5),(319,1792882800,6),(319,1806019200,5),(319,1824937200,6),(319,1837468800,5),(319,1856386800,6),(319,1868918400,5),(319,1887836400,6),(319,1900972800,5),(319,1919286000,6),(319,1932422400,5),(319,1950735600,6),(319,1963872000,5),(319,1982790000,6),(319,1995321600,5),(319,2014239600,6),(319,2026771200,5),(319,2045689200,6),(319,2058220800,5),(319,2077138800,6),(319,2090275200,5),(319,2108588400,6),(319,2121724800,5),(319,2140038000,6),(320,-2147483648,0),(320,-706341516,1),(320,560025000,2),(320,2147483647,2),(321,-2147483648,0),(321,-706341516,1),(321,560025000,2),(321,2147483647,2),(322,-2147483648,3),(322,-683802000,1),(322,-672310800,2),(322,-654771600,1),(322,-640861200,2),(322,-620298000,1),(322,-609411600,2),(322,-588848400,1),(322,-577962000,2),(323,-2147483648,0),(323,-1578807591,1),(323,-1247551200,3),(323,354906000,2),(323,370713600,3),(323,386442000,2),(323,402249600,3),(323,417978000,2),(323,433785600,3),(323,449600400,2),(323,465332400,4),(323,481057200,5),(323,496782000,4),(323,512506800,5),(323,528231600,4),(323,543956400,5),(323,559681200,4),(323,575406000,5),(323,591130800,4),(323,606855600,5),(323,622580400,4),(323,638305200,5),(323,654634800,4),(323,670359600,6),(323,686088000,7),(323,695764800,4),(323,701809200,5),(323,717534000,4),(323,733258800,5),(323,748983600,4),(323,764708400,5),(323,780433200,4),(323,796158000,5),(323,811882800,4),(323,828212400,5),(323,846356400,4),(323,859662000,5),(323,877806000,4),(323,891111600,5),(323,909255600,4),(323,922561200,5),(323,941310000,4),(323,954010800,5),(323,972759600,4),(323,985460400,5),(323,1004209200,4),(323,1017514800,5),(323,1020193200,8),(323,1035662400,7),(323,1048968000,6),(323,1067112000,7),(323,1080417600,6),(323,1099166400,7),(323,1111867200,6),(323,1130616000,7),(323,1143316800,6),(323,1162065600,7),(323,1174766400,6),(323,1193515200,7),(323,1206820800,6),(323,1224964800,7),(323,1238270400,6),(323,1256414400,7),(323,1269720000,6),(323,1288468800,7),(323,1301169600,4),(323,1414263600,7),(323,1464465600,4),(323,2147483647,4),(324,-2147483648,0),(324,-1577951856,1),(324,-1172908656,2),(324,-880272000,3),(324,-766054800,4),(325,-2147483648,0),(325,-2032931252,1),(325,252435600,3),(325,417974400,2),(325,433782000,3),(325,449596800,2),(325,465318000,3),(325,481046400,2),(325,496767600,3),(325,512496000,2),(325,528217200,3),(325,543945600,2),(325,559666800,3),(325,575395200,2),(325,591116400,3),(325,606844800,2),(325,622566000,3),(325,638294400,2),(325,654620400,3),(325,670348800,2),(325,686070000,3),(325,701798400,2),(325,717519600,3),(325,733248000,2),(325,748969200,3),(325,764697600,2),(325,780418800,3),(325,796147200,2),(325,811868400,3),(325,828201600,2),(325,843922800,3),(325,859651200,2),(325,875372400,3),(325,891100800,2),(325,906822000,3),(325,988394400,2),(325,1001696400,3),(325,1017424800,2),(325,1033146000,3),(325,1048874400,2),(325,1064595600,3),(325,1080324000,2),(325,1096045200,3),(325,1111773600,2),(325,1127494800,3),(325,1143223200,2),(325,1159549200,3),(325,1427479200,2),(325,1443193200,3),(325,1458928800,2),(325,1474642800,3),(325,2147483647,3),(326,-2147483648,0),(326,-2032931252,1),(326,252435600,3),(326,417974400,2),(326,433782000,3),(326,449596800,2),(326,465318000,3),(326,481046400,2),(326,496767600,3),(326,512496000,2),(326,528217200,3),(326,543945600,2),(326,559666800,3),(326,575395200,2),(326,591116400,3),(326,606844800,2),(326,622566000,3),(326,638294400,2),(326,654620400,3),(326,670348800,2),(326,686070000,3),(326,701798400,2),(326,717519600,3),(326,733248000,2),(326,748969200,3),(326,764697600,2),(326,780418800,3),(326,796147200,2),(326,811868400,3),(326,828201600,2),(326,843922800,3),(326,859651200,2),(326,875372400,3),(326,891100800,2),(326,906822000,3),(326,988394400,2),(326,1001696400,3),(326,1017424800,2),(326,1033146000,3),(326,1048874400,2),(326,1064595600,3),(326,1080324000,2),(326,1096045200,3),(326,1111773600,2),(326,1127494800,3),(326,1143223200,2),(326,1159549200,3),(326,1427479200,2),(326,1443193200,3),(326,1458928800,2),(326,1474642800,3),(326,2147483647,3),(327,-2147483648,0),(327,-1325483420,1),(327,2147483647,1),(328,-2147483648,0),(328,-1579426374,1),(328,-1247558400,2),(328,354898800,4),(328,370699200,3),(328,386427600,4),(328,402235200,3),(328,417963600,4),(328,433771200,3),(328,449586000,4),(328,465318000,5),(328,481042800,6),(328,496767600,5),(328,512492400,6),(328,528217200,5),(328,543942000,6),(328,559666800,5),(328,575391600,6),(328,591116400,5),(328,606841200,6),(328,622566000,5),(328,638290800,6),(328,654620400,5),(328,670345200,7),(328,686073600,8),(328,695750400,5),(328,701794800,6),(328,717519600,5),(328,733244400,6),(328,748969200,5),(328,764694000,6),(328,780418800,5),(328,796143600,6),(328,811868400,5),(328,828198000,6),(328,846342000,5),(328,859647600,6),(328,877791600,5),(328,891097200,6),(328,909241200,5),(328,922546800,6),(328,941295600,5),(328,953996400,6),(328,972745200,5),(328,985446000,6),(328,1004194800,5),(328,1017500400,6),(328,1035644400,5),(328,1048950000,6),(328,1067094000,5),(328,1080399600,6),(328,1099148400,5),(328,1111849200,6),(328,1130598000,5),(328,1143298800,6),(328,1162047600,5),(328,1174748400,6),(328,1193497200,5),(328,1206802800,6),(328,1224946800,5),(328,1238252400,6),(328,1256396400,5),(328,1269702000,6),(328,1288450800,5),(328,1301151600,9),(328,1315828800,5),(328,1414249200,8),(328,2147483647,8),(329,-2147483648,1),(329,-1570084924,2),(329,2147483647,2),(330,-2147483648,0),(330,-1487321251,1),(330,-1247562000,3),(330,354895200,2),(330,370702800,3),(330,386431200,2),(330,402238800,3),(330,417967200,2),(330,433774800,3),(330,449589600,2),(330,465321600,4),(330,481046400,5),(330,496771200,4),(330,512496000,5),(330,528220800,4),(330,543945600,5),(330,559670400,4),(330,575395200,5),(330,591120000,4),(330,606844800,5),(330,622569600,4),(330,638294400,5),(330,654624000,4),(330,670348800,6),(330,686077200,7),(330,695754000,4),(330,701798400,5),(330,717523200,4),(330,733248000,5),(330,748972800,4),(330,764697600,5),(330,780422400,4),(330,796147200,5),(330,811872000,4),(330,828201600,5),(330,846345600,4),(330,859651200,5),(330,877795200,4),(330,891100800,5),(330,909244800,4),(330,922550400,5),(330,941299200,4),(330,954000000,5),(330,972748800,4),(330,985449600,5),(330,1004198400,4),(330,1017504000,5),(330,1035648000,4),(330,1048953600,5),(330,1067097600,4),(330,1080403200,5),(330,1099152000,4),(330,1111852800,5),(330,1130601600,4),(330,1143302400,5),(330,1162051200,4),(330,1174752000,5),(330,1193500800,4),(330,1206806400,5),(330,1224950400,4),(330,1238256000,5),(330,1256400000,4),(330,1269705600,5),(330,1288454400,4),(330,1301155200,8),(330,1414249200,4),(330,2147483647,4),(331,-2147483648,0),(331,-1579423138,1),(331,-1247558400,3),(331,354898800,2),(331,370706400,3),(331,386434800,2),(331,402242400,3),(331,417970800,2),(331,433778400,3),(331,449593200,2),(331,465325200,4),(331,481050000,5),(331,496774800,4),(331,512499600,5),(331,528224400,4),(331,543949200,5),(331,559674000,4),(331,575398800,5),(331,591123600,4),(331,606848400,5),(331,622573200,4),(331,638298000,5),(331,654627600,4),(331,670352400,6),(331,686080800,7),(331,695757600,4),(331,701802000,5),(331,717526800,4),(331,733251600,5),(331,748976400,4),(331,764701200,5),(331,780426000,4),(331,796150800,5),(331,811875600,4),(331,828205200,5),(331,846349200,4),(331,859654800,5),(331,877798800,4),(331,891104400,5),(331,909248400,4),(331,922554000,5),(331,941302800,4),(331,954003600,5),(331,972752400,4),(331,985453200,5),(331,1004202000,4),(331,1017507600,5),(331,1035651600,4),(331,1048957200,5),(331,1067101200,4),(331,1080406800,5),(331,1099155600,4),(331,1111856400,5),(331,1130605200,4),(331,1143306000,5),(331,1162054800,4),(331,1174755600,5),(331,1193504400,4),(331,1206810000,5),(331,1224954000,4),(331,1238259600,5),(331,1256403600,4),(331,1269709200,5),(331,1288458000,4),(331,1301158800,8),(331,1414252800,4),(331,2147483647,4),(332,-2147483648,1),(332,-1577946287,2),(332,-873268200,3),(332,-778410000,2),(332,2147483647,2),(333,-2147483648,0),(333,-1688270553,1),(333,-1592610305,2),(333,-1247544000,4),(333,354913200,3),(333,370720800,4),(333,386449200,3),(333,402256800,4),(333,417985200,3),(333,433792800,4),(333,449607600,3),(333,465339600,5),(333,481064400,6),(333,496789200,5),(333,512514000,6),(333,528238800,5),(333,543963600,6),(333,559688400,5),(333,575413200,6),(333,591138000,5),(333,606862800,6),(333,622587600,5),(333,638312400,6),(333,654642000,5),(333,670366800,7),(333,686095200,8),(333,695772000,5),(333,701816400,6),(333,717541200,5),(333,733266000,6),(333,748990800,5),(333,764715600,6),(333,780440400,5),(333,796165200,6),(333,811890000,5),(333,828219600,6),(333,846363600,5),(333,859669200,6),(333,877813200,5),(333,891118800,6),(333,909262800,5),(333,922568400,6),(333,941317200,5),(333,954018000,6),(333,972766800,5),(333,985467600,6),(333,1004216400,5),(333,1017522000,6),(333,1035666000,5),(333,1048971600,6),(333,1067115600,5),(333,1080421200,6),(333,1099170000,5),(333,1111870800,6),(333,1130619600,5),(333,1143320400,6),(333,1162069200,5),(333,1174770000,6),(333,1193518800,5),(333,1206824400,6),(333,1224968400,5),(333,1238274000,6),(333,1256418000,5),(333,1269723600,6),(333,1288472400,5),(333,1301173200,9),(333,1414267200,5),(333,2147483647,5),(334,-2147483648,0),(334,-1441162680,1),(334,-405140400,3),(334,354916800,2),(334,370724400,3),(334,386452800,2),(334,402260400,3),(334,417988800,2),(334,433796400,3),(334,449611200,2),(334,465343200,4),(334,481068000,5),(334,496792800,4),(334,512517600,5),(334,528242400,4),(334,543967200,5),(334,559692000,4),(334,575416800,5),(334,591141600,4),(334,606866400,5),(334,622591200,4),(334,638316000,5),(334,654645600,4),(334,670370400,6),(334,686098800,7),(334,701823600,6),(334,717548400,7),(334,733273200,6),(334,748998000,7),(334,764722800,6),(334,780447600,7),(334,796172400,6),(334,811897200,4),(334,852062400,3),(334,859672800,5),(334,877816800,4),(334,891122400,5),(334,909266400,4),(334,922572000,5),(334,941320800,4),(334,954021600,5),(334,972770400,4),(334,985471200,5),(334,1004220000,4),(334,1017525600,5),(334,1035669600,4),(334,1048975200,5),(334,1067119200,4),(334,1080424800,5),(334,1099173600,4),(334,1111874400,5),(334,1130623200,4),(334,1143324000,5),(334,1162072800,4),(334,1174773600,5),(334,1193522400,4),(334,1206828000,5),(334,1224972000,4),(334,1238277600,5),(334,1256421600,4),(334,1269727200,5),(334,1288476000,4),(334,1293825600,3),(334,1301176800,5),(334,1319925600,4),(334,2147483647,4),(335,-2147483648,1),(335,-1830376800,6),(335,-1689548400,2),(335,-1677794400,3),(335,-1667430000,4),(335,-1647730800,5),(335,-1635807600,4),(335,-1616194800,5),(335,-1604358000,4),(335,-1584658800,5),(335,-1572735600,4),(335,-1553036400,5),(335,-1541199600,4),(335,-1521500400,5),(335,-1442444400,4),(335,-1426806000,5),(335,-1379286000,4),(335,-1364770800,5),(335,-1348441200,4),(335,-1333321200,5),(335,-1316386800,4),(335,-1301266800,5),(335,-1284332400,4),(335,-1269817200,5),(335,-1221433200,4),(335,-1206918000,5),(335,-1191193200,4),(335,-1175468400,5),(335,-1127689200,4),(335,-1111964400,5),(335,-1096844400,4),(335,-1080514800,5),(335,-1063580400,4),(335,-1049065200,5),(335,-1033340400,4),(335,-1017615600,5),(335,-1002495600,4),(335,-986166000,5),(335,-969231600,4),(335,-950482800,5),(335,-942015600,4),(335,-922662000,5),(335,-906937200,4),(335,-891126000,5),(335,-877302000,4),(335,-873676800,7),(335,-864000000,4),(335,-857948400,5),(335,-845852400,4),(335,-842832000,7),(335,-831340800,4),(335,-825894000,5),(335,-814402800,4),(335,-810777600,7),(335,-799891200,4),(335,-794444400,5),(335,-782953200,4),(335,-779328000,7),(335,-768441600,4),(335,-762994800,5),(335,-749084400,4),(335,-733359600,5),(335,-717624000,4),(335,-701899200,5),(335,-686174400,4),(335,-670449600,5),(335,-654724800,4),(335,-639000000,5),(335,-623275200,4),(335,-607550400,5),(335,-591825600,4),(335,-575496000,5),(335,-559771200,4),(335,-544046400,5),(335,-528321600,4),(335,-512596800,5),(335,-496872000,4),(335,-481147200,5),(335,-465422400,4),(335,-449697600,5),(335,-433972800,4),(335,-417643200,5),(335,-401918400,4),(335,-386193600,5),(335,-370468800,4),(335,-354744000,5),(335,-339019200,4),(335,-323294400,5),(335,-307569600,4),(335,-291844800,5),(335,-276120000,4),(335,-260395200,5),(335,-244670400,4),(335,-228340800,5),(335,-212616000,4),(335,-196891200,5),(335,-181166400,4),(335,-165441600,5),(335,-149716800,4),(335,-133992000,5),(335,-118267200,9),(335,228272400,7),(335,243997200,8),(335,260326800,7),(335,276051600,8),(335,291776400,7),(335,307504800,8),(335,323226000,7),(335,338954400,8),(335,354679200,7),(335,370404000,8),(335,386128800,7),(335,401853600,8),(335,417582000,7),(335,433303200,8),(335,449028000,7),(335,465357600,8),(335,481082400,7),(335,496807200,8),(335,512532000,7),(335,528256800,8),(335,543981600,7),(335,559706400,8),(335,575431200,7),(335,591156000,8),(335,606880800,7),(335,622605600,8),(335,638330400,7),(335,654660000,8),(335,670384800,7),(335,686109600,8),(335,701834400,7),(335,717559200,10),(335,733280400,11),(335,749005200,12),(335,764730000,11),(335,780454800,12),(335,796179600,11),(335,811904400,12),(335,828234000,11),(335,846378000,12),(335,859683600,11),(335,877827600,12),(335,891133200,11),(335,909277200,12),(335,922582800,11),(335,941331600,12),(335,954032400,11),(335,972781200,12),(335,985482000,11),(335,1004230800,12),(335,1017536400,11),(335,1035680400,12),(335,1048986000,11),(335,1067130000,12),(335,1080435600,11),(335,1099184400,12),(335,1111885200,11),(335,1130634000,12),(335,1143334800,11),(335,1162083600,12),(335,1174784400,11),(335,1193533200,12),(335,1206838800,11),(335,1224982800,12),(335,1238288400,11),(335,1256432400,12),(335,1269738000,11),(335,1288486800,12),(335,1301187600,11),(335,1319936400,12),(335,1332637200,11),(335,1351386000,12),(335,1364691600,11),(335,1382835600,12),(335,1396141200,11),(335,1414285200,12),(335,1427590800,11),(335,1445734800,12),(335,1459040400,11),(335,1477789200,12),(335,1490490000,11),(335,1509238800,12),(335,1521939600,11),(335,1540688400,12),(335,1553994000,11),(335,1572138000,12),(335,1585443600,11),(335,1603587600,12),(335,1616893200,11),(335,1635642000,12),(335,1648342800,11),(335,1667091600,12),(335,1679792400,11),(335,1698541200,12),(335,1711846800,11),(335,1729990800,12),(335,1743296400,11),(335,1761440400,12),(335,1774746000,11),(335,1792890000,12),(335,1806195600,11),(335,1824944400,12),(335,1837645200,11),(335,1856394000,12),(335,1869094800,11),(335,1887843600,12),(335,1901149200,11),(335,1919293200,12),(335,1932598800,11),(335,1950742800,12),(335,1964048400,11),(335,1982797200,12),(335,1995498000,11),(335,2014246800,12),(335,2026947600,11),(335,2045696400,12),(335,2058397200,11),(335,2077146000,12),(335,2090451600,11),(335,2108595600,12),(335,2121901200,11),(335,2140045200,12),(335,2147483647,12),(336,-2147483648,2),(336,-1664307642,1),(336,-1648932042,2),(336,-1632080442,1),(336,-1618692042,2),(336,-1262281242,4),(336,-882727200,3),(336,-858538800,4),(336,-845229600,3),(336,-825879600,4),(336,-814384800,3),(336,-793825200,4),(336,-782935200,3),(336,-762375600,4),(336,-713988000,3),(336,-703710000,4),(336,-681933600,3),(336,-672865200,4),(336,-650484000,3),(336,-641415600,4),(336,-618429600,3),(336,-609966000,4),(336,-586980000,3),(336,-578516400,4),(336,-555530400,3),(336,-546462000,4),(336,-429127200,3),(336,-415825200,4),(336,136360800,3),(336,152082000,4),(336,167810400,3),(336,183531600,4),(336,199260000,3),(336,215586000,4),(336,230709600,3),(336,247035600,4),(336,262764000,3),(336,278485200,4),(336,294213600,3),(336,309934800,4),(336,325663200,3),(336,341384400,4),(336,357112800,3),(336,372834000,4),(336,388562400,3),(336,404888400,4),(336,420012000,3),(336,436338000,4),(336,452066400,3),(336,467787600,4),(336,483516000,3),(336,499237200,4),(336,514965600,3),(336,530686800,4),(336,544600800,3),(336,562136400,4),(336,576050400,3),(336,594190800,4),(336,607500000,3),(336,625640400,4),(336,638949600,3),(336,657090000,4),(336,671004000,3),(336,688539600,4),(336,702453600,3),(336,719989200,4),(336,733903200,3),(336,752043600,4),(336,765352800,3),(336,783493200,4),(336,796802400,3),(336,814942800,4),(336,828856800,3),(336,846392400,4),(336,860306400,3),(336,877842000,4),(336,891756000,3),(336,909291600,4),(336,923205600,3),(336,941346000,4),(336,954655200,3),(336,972795600,4),(336,986104800,3),(336,1004245200,4),(336,1018159200,3),(336,1035694800,4),(336,1049608800,3),(336,1067144400,4),(336,1081058400,3),(336,1099198800,4),(336,1112508000,3),(336,1130648400,4),(336,1143957600,3),(336,1162098000,4),(336,1173592800,3),(336,1194152400,4),(336,1205042400,3),(336,1225602000,4),(336,1236492000,3),(336,1257051600,4),(336,1268546400,3),(336,1289106000,4),(336,1299996000,3),(336,1320555600,4),(336,1331445600,3),(336,1352005200,4),(336,1362895200,3),(336,1383454800,4),(336,1394344800,3),(336,1414904400,4),(336,1425794400,3),(336,1446354000,4),(336,1457848800,3),(336,1478408400,4),(336,1489298400,3),(336,1509858000,4),(336,1520748000,3),(336,1541307600,4),(336,1552197600,3),(336,1572757200,4),(336,1583647200,3),(336,1604206800,4),(336,1615701600,3),(336,1636261200,4),(336,1647151200,3),(336,1667710800,4),(336,1678600800,3),(336,1699160400,4),(336,1710050400,3),(336,1730610000,4),(336,1741500000,3),(336,1762059600,4),(336,1772949600,3),(336,1793509200,4),(336,1805004000,3),(336,1825563600,4),(336,1836453600,3),(336,1857013200,4),(336,1867903200,3),(336,1888462800,4),(336,1899352800,3),(336,1919912400,4),(336,1930802400,3),(336,1951362000,4),(336,1962856800,3),(336,1983416400,4),(336,1994306400,3),(336,2014866000,4),(336,2025756000,3),(336,2046315600,4),(336,2057205600,3),(336,2077765200,4),(336,2088655200,3),(336,2109214800,4),(336,2120104800,3),(336,2140664400,4),(337,-2147483648,0),(337,-1509663504,1),(337,-733874400,2),(337,323827200,3),(337,338950800,4),(337,354675600,5),(337,370400400,4),(337,386125200,5),(337,401850000,4),(337,417574800,5),(337,433299600,4),(337,449024400,5),(337,465354000,4),(337,481078800,5),(337,496803600,4),(337,512528400,5),(337,528253200,4),(337,543978000,5),(337,559702800,4),(337,575427600,5),(337,591152400,4),(337,606877200,5),(337,622602000,4),(337,638326800,5),(337,654656400,4),(337,670381200,5),(337,686106000,4),(337,701830800,5),(337,717555600,4),(337,733280400,5),(337,749005200,4),(337,764730000,5),(337,780454800,4),(337,796179600,5),(337,811904400,4),(337,828234000,5),(337,846378000,4),(337,859683600,5),(337,877827600,4),(337,891133200,5),(337,909277200,4),(337,922582800,5),(337,941331600,4),(337,954032400,5),(337,972781200,4),(337,985482000,5),(337,1004230800,4),(337,1017536400,5),(337,1035680400,4),(337,1048986000,5),(337,1067130000,4),(337,1080435600,5),(337,1099184400,4),(337,1111885200,5),(337,1130634000,4),(337,1143334800,5),(337,1162083600,4),(337,1174784400,5),(337,1193533200,4),(337,1206838800,5),(337,1224982800,4),(337,1238288400,5),(337,1256432400,4),(337,1269738000,5),(337,1288486800,4),(337,1301187600,5),(337,1319936400,4),(337,1332637200,5),(337,1351386000,4),(337,1364691600,5),(337,1382835600,4),(337,1396141200,5),(337,1414285200,4),(337,1427590800,5),(337,1445734800,4),(337,1459040400,5),(337,1477789200,4),(337,1490490000,5),(337,1509238800,4),(337,1521939600,5),(337,1540688400,4),(337,1553994000,5),(337,1572138000,4),(337,1585443600,5),(337,1603587600,4),(337,1616893200,5),(337,1635642000,4),(337,1648342800,5),(337,1667091600,4),(337,1679792400,5),(337,1698541200,4),(337,1711846800,5),(337,1729990800,4),(337,1743296400,5),(337,1761440400,4),(337,1774746000,5),(337,1792890000,4),(337,1806195600,5),(337,1824944400,4),(337,1837645200,5),(337,1856394000,4),(337,1869094800,5),(337,1887843600,4),(337,1901149200,5),(337,1919293200,4),(337,1932598800,5),(337,1950742800,4),(337,1964048400,5),(337,1982797200,4),(337,1995498000,5),(337,2014246800,4),(337,2026947600,5),(337,2045696400,4),(337,2058397200,5),(337,2077146000,4),(337,2090451600,5),(337,2108595600,4),(337,2121901200,5),(337,2140045200,4),(338,-2147483648,0),(338,-1830376800,1),(338,-862610400,2),(338,-764118000,3),(338,186120000,4),(338,2147483647,4),(339,-2147483648,0),(339,-1955748776,1),(339,354675600,2),(339,370400400,3),(339,386125200,2),(339,401850000,3),(339,417574800,2),(339,433299600,3),(339,449024400,2),(339,465354000,3),(339,481078800,2),(339,496803600,3),(339,512528400,2),(339,528253200,3),(339,543978000,2),(339,559702800,3),(339,575427600,2),(339,591152400,3),(339,606877200,2),(339,622602000,3),(339,638326800,2),(339,654656400,3),(339,670381200,2),(339,686106000,3),(339,701830800,2),(339,717555600,3),(339,733280400,2),(339,749005200,3),(339,764730000,2),(339,780454800,3),(339,796179600,2),(339,811904400,3),(339,828234000,2),(339,846378000,3),(339,859683600,2),(339,877827600,3),(339,891133200,2),(339,909277200,3),(339,922582800,2),(339,941331600,3),(339,954032400,2),(339,972781200,3),(339,985482000,2),(339,1004230800,3),(339,1017536400,2),(339,1035680400,3),(339,1048986000,2),(339,1067130000,3),(339,1080435600,2),(339,1099184400,3),(339,1111885200,2),(339,1130634000,3),(339,1143334800,2),(339,1162083600,3),(339,1174784400,2),(339,1193533200,3),(339,1206838800,2),(339,1224982800,3),(339,1238288400,2),(339,1256432400,3),(339,1269738000,2),(339,1288486800,3),(339,1301187600,2),(339,1319936400,3),(339,1332637200,2),(339,1351386000,3),(339,1364691600,2),(339,1382835600,3),(339,1396141200,2),(339,1414285200,3),(339,1427590800,2),(339,1445734800,3),(339,1459040400,2),(339,1477789200,3),(339,1490490000,2),(339,1509238800,3),(339,1521939600,2),(339,1540688400,3),(339,1553994000,2),(339,1572138000,3),(339,1585443600,2),(339,1603587600,3),(339,1616893200,2),(339,1635642000,3),(339,1648342800,2),(339,1667091600,3),(339,1679792400,2),(339,1698541200,3),(339,1711846800,2),(339,1729990800,3),(339,1743296400,2),(339,1761440400,3),(339,1774746000,2),(339,1792890000,3),(339,1806195600,2),(339,1824944400,3),(339,1837645200,2),(339,1856394000,3),(339,1869094800,2),(339,1887843600,3),(339,1901149200,2),(339,1919293200,3),(339,1932598800,2),(339,1950742800,3),(339,1964048400,2),(339,1982797200,3),(339,1995498000,2),(339,2014246800,3),(339,2026947600,2),(339,2045696400,3),(339,2058397200,2),(339,2077146000,3),(339,2090451600,2),(339,2108595600,3),(339,2121901200,2),(339,2140045200,3),(340,-2147483648,0),(340,-1955748776,1),(340,354675600,2),(340,370400400,3),(340,386125200,2),(340,401850000,3),(340,417574800,2),(340,433299600,3),(340,449024400,2),(340,465354000,3),(340,481078800,2),(340,496803600,3),(340,512528400,2),(340,528253200,3),(340,543978000,2),(340,559702800,3),(340,575427600,2),(340,591152400,3),(340,606877200,2),(340,622602000,3),(340,638326800,2),(340,654656400,3),(340,670381200,2),(340,686106000,3),(340,701830800,2),(340,717555600,3),(340,733280400,2),(340,749005200,3),(340,764730000,2),(340,780454800,3),(340,796179600,2),(340,811904400,3),(340,828234000,2),(340,846378000,3),(340,859683600,2),(340,877827600,3),(340,891133200,2),(340,909277200,3),(340,922582800,2),(340,941331600,3),(340,954032400,2),(340,972781200,3),(340,985482000,2),(340,1004230800,3),(340,1017536400,2),(340,1035680400,3),(340,1048986000,2),(340,1067130000,3),(340,1080435600,2),(340,1099184400,3),(340,1111885200,2),(340,1130634000,3),(340,1143334800,2),(340,1162083600,3),(340,1174784400,2),(340,1193533200,3),(340,1206838800,2),(340,1224982800,3),(340,1238288400,2),(340,1256432400,3),(340,1269738000,2),(340,1288486800,3),(340,1301187600,2),(340,1319936400,3),(340,1332637200,2),(340,1351386000,3),(340,1364691600,2),(340,1382835600,3),(340,1396141200,2),(340,1414285200,3),(340,1427590800,2),(340,1445734800,3),(340,1459040400,2),(340,1477789200,3),(340,1490490000,2),(340,1509238800,3),(340,1521939600,2),(340,1540688400,3),(340,1553994000,2),(340,1572138000,3),(340,1585443600,2),(340,1603587600,3),(340,1616893200,2),(340,1635642000,3),(340,1648342800,2),(340,1667091600,3),(340,1679792400,2),(340,1698541200,3),(340,1711846800,2),(340,1729990800,3),(340,1743296400,2),(340,1761440400,3),(340,1774746000,2),(340,1792890000,3),(340,1806195600,2),(340,1824944400,3),(340,1837645200,2),(340,1856394000,3),(340,1869094800,2),(340,1887843600,3),(340,1901149200,2),(340,1919293200,3),(340,1932598800,2),(340,1950742800,3),(340,1964048400,2),(340,1982797200,3),(340,1995498000,2),(340,2014246800,3),(340,2026947600,2),(340,2045696400,3),(340,2058397200,2),(340,2077146000,3),(340,2090451600,2),(340,2108595600,3),(340,2121901200,2),(340,2140045200,3),(341,-2147483648,2),(341,-1693706400,1),(341,-1680483600,2),(341,-1663455600,3),(341,-1650150000,4),(341,-1632006000,3),(341,-1618700400,4),(341,-938905200,3),(341,-857257200,4),(341,-844556400,3),(341,-828226800,4),(341,-812502000,3),(341,-796777200,4),(341,-781052400,3),(341,-776563200,5),(341,-765936000,1),(341,-761180400,4),(341,-757386000,2),(341,-748479600,3),(341,-733273200,4),(341,-717631200,3),(341,-714610800,6),(341,-710380800,1),(341,-701910000,4),(341,-684975600,3),(341,-670460400,4),(341,-654130800,3),(341,-639010800,4),(341,315529200,2),(341,323830800,7),(341,338950800,8),(341,354675600,7),(341,370400400,8),(341,386125200,7),(341,401850000,8),(341,417574800,7),(341,433299600,8),(341,449024400,7),(341,465354000,8),(341,481078800,7),(341,496803600,8),(341,512528400,7),(341,528253200,8),(341,543978000,7),(341,559702800,8),(341,575427600,7),(341,591152400,8),(341,606877200,7),(341,622602000,8),(341,638326800,7),(341,654656400,8),(341,670381200,7),(341,686106000,8),(341,701830800,7),(341,717555600,8),(341,733280400,7),(341,749005200,8),(341,764730000,7),(341,780454800,8),(341,796179600,7),(341,811904400,8),(341,828234000,7),(341,846378000,8),(341,859683600,7),(341,877827600,8),(341,891133200,7),(341,909277200,8),(341,922582800,7),(341,941331600,8),(341,954032400,7),(341,972781200,8),(341,985482000,7),(341,1004230800,8),(341,1017536400,7),(341,1035680400,8),(341,1048986000,7),(341,1067130000,8),(341,1080435600,7),(341,1099184400,8),(341,1111885200,7),(341,1130634000,8),(341,1143334800,7),(341,1162083600,8),(341,1174784400,7),(341,1193533200,8),(341,1206838800,7),(341,1224982800,8),(341,1238288400,7),(341,1256432400,8),(341,1269738000,7),(341,1288486800,8),(341,1301187600,7),(341,1319936400,8),(341,1332637200,7),(341,1351386000,8),(341,1364691600,7),(341,1382835600,8),(341,1396141200,7),(341,1414285200,8),(341,1427590800,7),(341,1445734800,8),(341,1459040400,7),(341,1477789200,8),(341,1490490000,7),(341,1509238800,8),(341,1521939600,7),(341,1540688400,8),(341,1553994000,7),(341,1572138000,8),(341,1585443600,7),(341,1603587600,8),(341,1616893200,7),(341,1635642000,8),(341,1648342800,7),(341,1667091600,8),(341,1679792400,7),(341,1698541200,8),(341,1711846800,7),(341,1729990800,8),(341,1743296400,7),(341,1761440400,8),(341,1774746000,7),(341,1792890000,8),(341,1806195600,7),(341,1824944400,8),(341,1837645200,7),(341,1856394000,8),(341,1869094800,7),(341,1887843600,8),(341,1901149200,7),(341,1919293200,8),(341,1932598800,7),(341,1950742800,8),(341,1964048400,7),(341,1982797200,8),(341,1995498000,7),(341,2014246800,8),(341,2026947600,7),(341,2045696400,8),(341,2058397200,7),(341,2077146000,8),(341,2090451600,7),(341,2108595600,8),(341,2121901200,7),(341,2140045200,8),(342,-2147483648,1),(342,-1830380400,6),(342,-1689552000,2),(342,-1677798000,3),(342,-1667433600,4),(342,-1647734400,5),(342,-1635811200,4),(342,-1616198400,5),(342,-1604361600,4),(342,-1584662400,5),(342,-1572739200,4),(342,-1553040000,5),(342,-1541203200,4),(342,-1521504000,5),(342,-1442448000,4),(342,-1426809600,5),(342,-1379289600,4),(342,-1364774400,5),(342,-1348444800,4),(342,-1333324800,5),(342,-1316390400,4),(342,-1301270400,5),(342,-1284336000,4),(342,-1269820800,5),(342,-1221436800,4),(342,-1206921600,5),(342,-1191196800,4),(342,-1175472000,5),(342,-1127692800,4),(342,-1111968000,5),(342,-1096848000,4),(342,-1080518400,5),(342,-1063584000,4),(342,-1049068800,5),(342,-1033344000,4),(342,-1017619200,5),(342,-1002499200,4),(342,-986169600,5),(342,-969235200,4),(342,-950486400,5),(342,-942019200,4),(342,-922665600,5),(342,-906940800,4),(342,-891129600,5),(342,-877305600,4),(342,-873680400,7),(342,-864003600,4),(342,-857952000,5),(342,-845856000,4),(342,-842835600,7),(342,-831344400,4),(342,-825897600,5),(342,-814406400,4),(342,-810781200,7),(342,-799894800,4),(342,-794448000,5),(342,-782956800,4),(342,-779331600,7),(342,-768445200,4),(342,-762998400,5),(342,-749088000,4),(342,-733363200,5),(342,-717627600,4),(342,-701902800,5),(342,-686178000,4),(342,-670453200,5),(342,-654728400,4),(342,-639003600,5),(342,-623278800,4),(342,-607554000,5),(342,-591829200,4),(342,-575499600,5),(342,-559774800,4),(342,-544050000,5),(342,-528325200,4),(342,-512600400,5),(342,-496875600,4),(342,-481150800,5),(342,-465426000,4),(342,-449701200,5),(342,-433976400,4),(342,-417646800,5),(342,-401922000,4),(342,-386197200,5),(342,-370472400,4),(342,-354747600,5),(342,-339022800,4),(342,-323298000,5),(342,-307573200,4),(342,-291848400,5),(342,-276123600,4),(342,-260398800,5),(342,-244674000,4),(342,-228344400,5),(342,-212619600,4),(342,-196894800,5),(342,-181170000,4),(342,-165445200,5),(342,-149720400,4),(342,-133995600,5),(342,-118270800,10),(342,228268800,8),(342,243993600,9),(342,260323200,8),(342,276048000,9),(342,291772800,8),(342,307501200,9),(342,323222400,8),(342,338950800,9),(342,354675600,8),(342,370400400,9),(342,386125200,8),(342,401850000,9),(342,417578400,8),(342,433299600,11),(342,449024400,12),(342,465354000,11),(342,481078800,12),(342,496803600,11),(342,512528400,12),(342,528253200,11),(342,543978000,12),(342,559702800,11),(342,575427600,12),(342,591152400,11),(342,606877200,12),(342,622602000,11),(342,638326800,12),(342,654656400,11),(342,670381200,12),(342,686106000,11),(342,701830800,12),(342,717555600,11),(342,733280400,12),(342,749005200,11),(342,764730000,12),(342,780454800,11),(342,796179600,12),(342,811904400,11),(342,828234000,12),(342,846378000,11),(342,859683600,12),(342,877827600,11),(342,891133200,12),(342,909277200,11),(342,922582800,12),(342,941331600,11),(342,954032400,12),(342,972781200,11),(342,985482000,12),(342,1004230800,11),(342,1017536400,12),(342,1035680400,11),(342,1048986000,12),(342,1067130000,11),(342,1080435600,12),(342,1099184400,11),(342,1111885200,12),(342,1130634000,11),(342,1143334800,12),(342,1162083600,11),(342,1174784400,12),(342,1193533200,11),(342,1206838800,12),(342,1224982800,11),(342,1238288400,12),(342,1256432400,11),(342,1269738000,12),(342,1288486800,11),(342,1301187600,12),(342,1319936400,11),(342,1332637200,12),(342,1351386000,11),(342,1364691600,12),(342,1382835600,11),(342,1396141200,12),(342,1414285200,11),(342,1427590800,12),(342,1445734800,11),(342,1459040400,12),(342,1477789200,11),(342,1490490000,12),(342,1509238800,11),(342,1521939600,12),(342,1540688400,11),(342,1553994000,12),(342,1572138000,11),(342,1585443600,12),(342,1603587600,11),(342,1616893200,12),(342,1635642000,11),(342,1648342800,12),(342,1667091600,11),(342,1679792400,12),(342,1698541200,11),(342,1711846800,12),(342,1729990800,11),(342,1743296400,12),(342,1761440400,11),(342,1774746000,12),(342,1792890000,11),(342,1806195600,12),(342,1824944400,11),(342,1837645200,12),(342,1856394000,11),(342,1869094800,12),(342,1887843600,11),(342,1901149200,12),(342,1919293200,11),(342,1932598800,12),(342,1950742800,11),(342,1964048400,12),(342,1982797200,11),(342,1995498000,12),(342,2014246800,11),(342,2026947600,12),(342,2045696400,11),(342,2058397200,12),(342,2077146000,11),(342,2090451600,12),(342,2108595600,11),(342,2121901200,12),(342,2140045200,11),(343,-2147483648,0),(343,-1830383032,1),(344,-2147483648,1),(344,2147483647,1),(345,-2147483648,0),(345,-1830383032,1),(346,-2147483648,1),(346,-1824235716,3),(346,-1018209600,2),(346,-1003093200,3),(346,-986760000,2),(346,-971643600,3),(346,-954705600,2),(346,-939589200,3),(346,-923256000,2),(346,-908139600,3),(346,-891806400,2),(346,-876690000,3),(346,-860356800,2),(346,-852066000,3),(346,420609600,5),(346,433306800,4),(346,452052000,5),(346,464151600,4),(346,483501600,5),(346,495601200,2),(346,514350000,3),(346,527054400,2),(346,545799600,3),(346,558504000,2),(346,577249200,3),(346,589953600,2),(346,608698800,3),(346,621403200,2),(346,640753200,3),(346,652852800,2),(346,672202800,3),(346,684907200,2),(346,703652400,3),(346,716356800,2),(346,735102000,3),(346,747806400,2),(346,766551600,3),(346,779256000,2),(346,798001200,3),(346,810705600,2),(346,830055600,3),(346,842760000,2),(346,861505200,3),(346,874209600,2),(346,892954800,3),(346,905659200,2),(346,924404400,3),(346,937108800,2),(346,955854000,3),(346,968558400,2),(346,987310800,3),(346,999410400,2),(346,1019365200,3),(346,1030860000,2),(346,1050814800,3),(346,1062914400,2),(346,1082264400,3),(346,1094364000,2),(346,1113714000,3),(346,1125813600,2),(346,1145163600,3),(346,1157263200,2),(346,1176613200,3),(346,1188712800,2),(346,1208667600,3),(346,1220767200,2),(346,1240117200,3),(346,1252216800,2),(346,1271566800,3),(346,1283666400,5),(346,2147483647,5),(347,-2147483648,3),(347,-1672560000,1),(347,-1665388800,2),(347,-883641600,1),(347,-876124800,2),(347,-860400000,1),(347,-844675200,2),(347,-828345600,1),(347,-813225600,2),(347,31500000,3),(347,57686400,1),(347,67968000,2),(347,89136000,1),(347,100022400,2),(347,120585600,1),(347,131472000,2),(347,152035200,1),(347,162921600,2),(347,183484800,1),(347,194976000,2),(347,215539200,1),(347,226425600,2),(347,246988800,1),(347,257875200,2),(347,278438400,1),(347,289324800,2),(347,309888000,1),(347,320774400,2),(347,341337600,1),(347,352224000,2),(347,372787200,1),(347,386697600,2),(347,404841600,1),(347,415728000,2),(347,436291200,1),(347,447177600,2),(347,467740800,1),(347,478627200,2),(347,499190400,1),(347,511286400,2),(347,530035200,1),(347,542736000,2),(347,562089600,1),(347,574790400,2),(347,594144000,1),(347,606240000,2),(347,625593600,1),(347,636480000,2),(347,657043200,1),(347,667929600,2),(347,688492800,1),(347,699379200,2),(347,719942400,1),(347,731433600,2),(347,751996800,1),(347,762883200,2),(347,783446400,1),(347,794332800,2),(347,814896000,1),(347,828201600,2),(347,846345600,1),(347,859651200,2),(347,877795200,1),(347,891100800,2),(347,909244800,1),(347,922550400,2),(347,941299200,1),(347,954000000,2),(347,967305600,1),(347,985449600,2),(347,1004198400,1),(347,1017504000,2),(347,1035648000,1),(347,1048953600,2),(347,1067097600,1),(347,1080403200,2),(347,1099152000,1),(347,1111852800,2),(347,1130601600,1),(347,1143907200,2),(347,1162051200,1),(347,1174752000,2),(347,1193500800,1),(347,1207411200,2),(347,1223136000,1),(347,1238860800,2),(347,1254585600,1),(347,1270310400,2),(347,1286035200,1),(347,1301760000,2),(347,1317484800,1),(347,1333209600,2),(347,1349539200,1),(347,1365264000,2),(347,1380988800,1),(347,1396713600,2),(347,1412438400,1),(347,1428163200,2),(347,1443888000,1),(347,1459612800,2),(347,1475337600,1),(347,1491062400,2),(347,1506787200,1),(347,1522512000,2),(347,1538841600,1),(347,1554566400,2),(347,1570291200,1),(347,1586016000,2),(347,1601740800,1),(347,1617465600,2),(347,1633190400,1),(347,1648915200,2),(347,1664640000,1),(347,1680364800,2),(347,1696089600,1),(347,1712419200,2),(347,1728144000,1),(347,1743868800,2),(347,1759593600,1),(347,1775318400,2),(347,1791043200,1),(347,1806768000,2),(347,1822492800,1),(347,1838217600,2),(347,1853942400,1),(347,1869667200,2),(347,1885996800,1),(347,1901721600,2),(347,1917446400,1),(347,1933171200,2),(347,1948896000,1),(347,1964620800,2),(347,1980345600,1),(347,1996070400,2),(347,2011795200,1),(347,2027520000,2),(347,2043244800,1),(347,2058969600,2),(347,2075299200,1),(347,2091024000,2),(347,2106748800,1),(347,2122473600,2),(347,2138198400,1),(348,-2147483648,3),(348,-1672558200,1),(348,-1665387000,2),(348,-883639800,1),(348,-876123000,2),(348,-860398200,1),(348,-844673400,2),(348,-828343800,1),(348,-813223800,2),(348,31501800,3),(348,57688200,1),(348,67969800,2),(348,89137800,1),(348,100024200,2),(348,120587400,1),(348,131473800,2),(348,152037000,1),(348,162923400,2),(348,183486600,1),(348,194977800,2),(348,215541000,1),(348,226427400,2),(348,246990600,1),(348,257877000,2),(348,278440200,1),(348,289326600,2),(348,309889800,1),(348,320776200,2),(348,341339400,1),(348,352225800,2),(348,372789000,1),(348,384280200,2),(348,404843400,1),(348,415729800,2),(348,436293000,1),(348,447179400,2),(348,467742600,1),(348,478629000,2),(348,499192200,1),(348,511288200,2),(348,530037000,1),(348,542737800,2),(348,562091400,1),(348,574792200,2),(348,594145800,1),(348,606241800,2),(348,625595400,1),(348,637691400,2),(348,657045000,1),(348,667931400,2),(348,688494600,1),(348,701195400,2),(348,719944200,1),(348,731435400,2),(348,751998600,1),(348,764094600,2),(348,783448200,1),(348,796149000,2),(348,814897800,1),(348,828203400,2),(348,846347400,1),(348,859653000,2),(348,877797000,1),(348,891102600,2),(348,909246600,1),(348,922552200,2),(348,941301000,1),(348,954001800,2),(348,972750600,1),(348,985451400,2),(348,1004200200,1),(348,1017505800,2),(348,1035649800,1),(348,1048955400,2),(348,1067099400,1),(348,1080405000,2),(348,1099153800,1),(348,1111854600,2),(348,1130603400,1),(348,1143909000,2),(348,1162053000,1),(348,1174753800,2),(348,1193502600,1),(348,1207413000,2),(348,1223137800,1),(348,1238862600,2),(348,1254587400,1),(348,1270312200,2),(348,1286037000,1),(348,1301761800,2),(348,1317486600,1),(348,1333211400,2),(348,1349541000,1),(348,1365265800,2),(348,1380990600,1),(348,1396715400,2),(348,1412440200,1),(348,1428165000,2),(348,1443889800,1),(348,1459614600,2),(348,1475339400,1),(348,1491064200,2),(348,1506789000,1),(348,1522513800,2),(348,1538843400,1),(348,1554568200,2),(348,1570293000,1),(348,1586017800,2),(348,1601742600,1),(348,1617467400,2),(348,1633192200,1),(348,1648917000,2),(348,1664641800,1),(348,1680366600,2),(348,1696091400,1),(348,1712421000,2),(348,1728145800,1),(348,1743870600,2),(348,1759595400,1),(348,1775320200,2),(348,1791045000,1),(348,1806769800,2),(348,1822494600,1),(348,1838219400,2),(348,1853944200,1),(348,1869669000,2),(348,1885998600,1),(348,1901723400,2),(348,1917448200,1),(348,1933173000,2),(348,1948897800,1),(348,1964622600,2),(348,1980347400,1),(348,1996072200,2),(348,2011797000,1),(348,2027521800,2),(348,2043246600,1),(348,2058971400,2),(348,2075301000,1),(348,2091025800,2),(348,2106750600,1),(348,2122475400,2),(348,2138200200,1),(349,-2147483648,3),(349,-1672560000,1),(349,-1665388800,2),(349,-883641600,1),(349,-876124800,2),(349,-860400000,1),(349,-844675200,2),(349,-828345600,1),(349,-813225600,2),(349,31500000,3),(349,57686400,1),(349,67968000,2),(349,625593600,1),(349,636480000,2),(349,657043200,1),(349,667929600,2),(349,688492800,1),(349,699379200,2),(350,-2147483648,3),(350,-1672558200,1),(350,-1665387000,2),(350,-883639800,1),(350,-876123000,2),(350,-860398200,1),(350,-844673400,2),(350,-828343800,1),(350,-813223800,2),(350,31501800,3),(350,57688200,1),(350,67969800,2),(350,89137800,1),(350,100024200,2),(350,120587400,1),(350,131473800,2),(350,152037000,1),(350,162923400,2),(350,183486600,1),(350,194977800,2),(350,215541000,1),(350,226427400,2),(350,246990600,1),(350,257877000,2),(350,278440200,1),(350,289326600,2),(350,309889800,1),(350,320776200,2),(350,341339400,1),(350,352225800,2),(350,372789000,1),(350,386699400,2),(350,404843400,1),(350,415729800,2),(350,436293000,1),(350,447179400,2),(350,467742600,1),(350,478629000,2),(350,499192200,1),(350,511288200,2),(350,530037000,1),(350,542737800,2),(350,562091400,1),(350,574792200,2),(350,594145800,1),(350,606241800,2),(350,625595400,1),(350,636481800,2),(350,657045000,1),(350,667931400,2),(350,688494600,1),(350,699381000,2),(350,719944200,1),(350,731435400,2),(350,751998600,1),(350,762885000,2),(350,783448200,1),(350,794334600,2),(350,814897800,1),(350,828203400,2),(350,846347400,1),(350,859653000,2),(350,877797000,1),(350,891102600,2),(350,909246600,1),(350,922552200,2),(350,941301000,1),(350,946647000,4),(350,954001800,2),(350,972750600,1),(350,985451400,2),(350,1004200200,1),(350,1017505800,2),(350,1035649800,1),(350,1048955400,2),(350,1067099400,1),(350,1080405000,2),(350,1099153800,1),(350,1111854600,2),(350,1130603400,1),(350,1143909000,2),(350,1162053000,1),(350,1174753800,2),(350,1193502600,1),(350,1207413000,2),(350,1223137800,1),(350,1238862600,2),(350,1254587400,1),(350,1270312200,2),(350,1286037000,1),(350,1301761800,2),(350,1317486600,1),(350,1333211400,2),(350,1349541000,1),(350,1365265800,2),(350,1380990600,1),(350,1396715400,2),(350,1412440200,1),(350,1428165000,2),(350,1443889800,1),(350,1459614600,2),(350,1475339400,1),(350,1491064200,2),(350,1506789000,1),(350,1522513800,2),(350,1538843400,1),(350,1554568200,2),(350,1570293000,1),(350,1586017800,2),(350,1601742600,1),(350,1617467400,2),(350,1633192200,1),(350,1648917000,2),(350,1664641800,1),(350,1680366600,2),(350,1696091400,1),(350,1712421000,2),(350,1728145800,1),(350,1743870600,2),(350,1759595400,1),(350,1775320200,2),(350,1791045000,1),(350,1806769800,2),(350,1822494600,1),(350,1838219400,2),(350,1853944200,1),(350,1869669000,2),(350,1885998600,1),(350,1901723400,2),(350,1917448200,1),(350,1933173000,2),(350,1948897800,1),(350,1964622600,2),(350,1980347400,1),(350,1996072200,2),(350,2011797000,1),(350,2027521800,2),(350,2043246600,1),(350,2058971400,2),(350,2075301000,1),(350,2091025800,2),(350,2106750600,1),(350,2122475400,2),(350,2138200200,1),(351,-2147483648,3),(351,-1672560000,1),(351,-1665388800,2),(351,-883641600,1),(351,-876124800,2),(351,-860400000,1),(351,-844675200,2),(351,-828345600,1),(351,-813225600,2),(351,31500000,3),(351,57686400,1),(351,67968000,2),(351,89136000,1),(351,100022400,2),(351,120585600,1),(351,131472000,2),(351,152035200,1),(351,162921600,2),(351,183484800,1),(351,194976000,2),(351,215539200,1),(351,226425600,2),(351,246988800,1),(351,257875200,2),(351,278438400,1),(351,289324800,2),(351,309888000,1),(351,320774400,2),(351,341337600,1),(351,352224000,2),(351,372787200,1),(351,386697600,2),(351,404841600,1),(351,415728000,2),(351,436291200,1),(351,447177600,2),(351,467740800,1),(351,478627200,2),(351,499190400,1),(351,511286400,2),(351,530035200,1),(351,542736000,2),(351,562089600,1),(351,574790400,2),(351,594144000,1),(351,606240000,2),(351,625593600,1),(351,636480000,2),(351,657043200,1),(351,667929600,2),(351,688492800,1),(351,699379200,2),(351,719942400,1),(351,731433600,2),(351,751996800,1),(351,762883200,2),(351,783446400,1),(351,794332800,2),(351,814896000,1),(351,828201600,2),(351,846345600,1),(351,859651200,2),(351,877795200,1),(351,891100800,2),(351,909244800,1),(351,922550400,2),(351,941299200,1),(351,954000000,2),(351,967305600,1),(351,985449600,2),(351,1004198400,1),(351,1017504000,2),(351,1035648000,1),(351,1048953600,2),(351,1067097600,1),(351,1080403200,2),(351,1099152000,1),(351,1111852800,2),(351,1130601600,1),(351,1143907200,2),(351,1162051200,1),(351,1174752000,2),(351,1193500800,1),(351,1207411200,2),(351,1223136000,1),(351,1238860800,2),(351,1254585600,1),(351,1270310400,2),(351,1286035200,1),(351,1301760000,2),(351,1317484800,1),(351,1333209600,2),(351,1349539200,1),(351,1365264000,2),(351,1380988800,1),(351,1396713600,2),(351,1412438400,1),(351,1428163200,2),(351,1443888000,1),(351,1459612800,2),(351,1475337600,1),(351,1491062400,2),(351,1506787200,1),(351,1522512000,2),(351,1538841600,1),(351,1554566400,2),(351,1570291200,1),(351,1586016000,2),(351,1601740800,1),(351,1617465600,2),(351,1633190400,1),(351,1648915200,2),(351,1664640000,1),(351,1680364800,2),(351,1696089600,1),(351,1712419200,2),(351,1728144000,1),(351,1743868800,2),(351,1759593600,1),(351,1775318400,2),(351,1791043200,1),(351,1806768000,2),(351,1822492800,1),(351,1838217600,2),(351,1853942400,1),(351,1869667200,2),(351,1885996800,1),(351,1901721600,2),(351,1917446400,1),(351,1933171200,2),(351,1948896000,1),(351,1964620800,2),(351,1980345600,1),(351,1996070400,2),(351,2011795200,1),(351,2027520000,2),(351,2043244800,1),(351,2058969600,2),(351,2075299200,1),(351,2091024000,2),(351,2106748800,1),(351,2122473600,2),(351,2138198400,1),(352,-2147483648,3),(352,-1680508800,1),(352,-1665388800,2),(352,-1646640000,1),(352,-1635753600,2),(352,-1615190400,1),(352,-1604304000,2),(352,-1583920800,3),(352,-883641600,1),(352,-876124800,2),(352,-860400000,1),(352,-844675200,2),(352,-828345600,1),(352,-813225600,2),(352,-94730400,3),(352,-71136000,1),(352,-55411200,2),(352,-37267200,1),(352,-25776000,2),(352,-5817600,1),(352,5673600,2),(352,25632000,1),(352,37728000,2),(352,57686400,1),(352,67968000,2),(352,89136000,1),(352,100022400,2),(352,120585600,1),(352,131472000,2),(352,152035200,1),(352,162921600,2),(352,183484800,1),(352,194976000,2),(352,215539200,1),(352,226425600,2),(352,246988800,1),(352,257875200,2),(352,278438400,1),(352,289324800,2),(352,309888000,1),(352,320774400,2),(352,341337600,1),(352,352224000,2),(352,372787200,1),(352,386092800,2),(352,404841600,1),(352,417542400,2),(352,436291200,1),(352,447177600,2),(352,467740800,1),(352,478627200,2),(352,499190400,1),(352,510076800,2),(352,530035200,1),(352,542736000,2),(352,562089600,1),(352,574790400,2),(352,594144000,1),(352,606240000,2),(352,625593600,1),(352,637689600,2),(352,657043200,1),(352,670348800,2),(352,686678400,1),(352,701798400,2),(352,718128000,1),(352,733248000,2),(352,749577600,1),(352,764697600,2),(352,781027200,1),(352,796147200,2),(352,812476800,1),(352,828201600,2),(352,844531200,1),(352,859651200,2),(352,875980800,1),(352,891100800,2),(352,907430400,1),(352,922550400,2),(352,938880000,1),(352,954000000,2),(352,967305600,1),(352,985449600,2),(352,1002384000,1),(352,1017504000,2),(352,1033833600,1),(352,1048953600,2),(352,1065283200,1),(352,1080403200,2),(352,1096732800,1),(352,1111852800,2),(352,1128182400,1),(352,1143907200,2),(352,1159632000,1),(352,1174752000,2),(352,1191686400,1),(352,1207411200,2),(352,1223136000,1),(352,1238860800,2),(352,1254585600,1),(352,1270310400,2),(352,1286035200,1),(352,1301760000,2),(352,1317484800,1),(352,1333209600,2),(352,1349539200,1),(352,1365264000,2),(352,1380988800,1),(352,1396713600,2),(352,1412438400,1),(352,1428163200,2),(352,1443888000,1),(352,1459612800,2),(352,1475337600,1),(352,1491062400,2),(352,1506787200,1),(352,1522512000,2),(352,1538841600,1),(352,1554566400,2),(352,1570291200,1),(352,1586016000,2),(352,1601740800,1),(352,1617465600,2),(352,1633190400,1),(352,1648915200,2),(352,1664640000,1),(352,1680364800,2),(352,1696089600,1),(352,1712419200,2),(352,1728144000,1),(352,1743868800,2),(352,1759593600,1),(352,1775318400,2),(352,1791043200,1),(352,1806768000,2),(352,1822492800,1),(352,1838217600,2),(352,1853942400,1),(352,1869667200,2),(352,1885996800,1),(352,1901721600,2),(352,1917446400,1),(352,1933171200,2),(352,1948896000,1),(352,1964620800,2),(352,1980345600,1),(352,1996070400,2),(352,2011795200,1),(352,2027520000,2),(352,2043244800,1),(352,2058969600,2),(352,2075299200,1),(352,2091024000,2),(352,2106748800,1),(352,2122473600,2),(352,2138198400,1),(353,-2147483648,3),(353,-1672558200,1),(353,-1665387000,2),(353,-883639800,1),(353,-876123000,2),(353,-860398200,1),(353,-844673400,2),(353,-828343800,1),(353,-813223800,2),(354,-2147483648,3),(354,-1672555500,1),(354,-1665384300,2),(354,-883637100,1),(354,-876120300,2),(354,-860395500,1),(354,-844670700,2),(354,-836469900,3),(354,152039700,1),(354,162926100,2),(354,436295700,1),(354,447182100,2),(354,690311700,1),(354,699383700,2),(354,1165079700,1),(354,1174756500,2),(354,1193505300,1),(354,1206810900,2),(354,1224954900,1),(354,1238260500,2),(354,2147483647,2),(355,-2147483648,3),(355,-1680508800,1),(355,-1665388800,2),(355,-1646640000,1),(355,-1635753600,2),(355,-1615190400,1),(355,-1604304000,2),(355,-1583920800,3),(355,-883641600,1),(355,-876124800,2),(355,-860400000,1),(355,-844675200,2),(355,-828345600,1),(355,-813225600,2),(355,-94730400,3),(355,-71136000,1),(355,-55411200,2),(355,-37267200,1),(355,-25776000,2),(355,-5817600,1),(355,5673600,2),(355,25632000,1),(355,37728000,2),(355,57686400,1),(355,67968000,2),(355,89136000,1),(355,100022400,2),(355,120585600,1),(355,131472000,2),(355,152035200,1),(355,162921600,2),(355,183484800,1),(355,194976000,2),(355,215539200,1),(355,226425600,2),(355,246988800,1),(355,257875200,2),(355,278438400,1),(355,289324800,2),(355,309888000,1),(355,320774400,2),(355,341337600,1),(355,352224000,2),(355,372787200,1),(355,386092800,2),(355,404841600,1),(355,417542400,2),(355,436291200,1),(355,447177600,2),(355,467740800,1),(355,478627200,2),(355,499190400,1),(355,510076800,2),(355,530035200,1),(355,542736000,2),(355,562089600,1),(355,574790400,2),(355,594144000,1),(355,606240000,2),(355,625593600,1),(355,637689600,2),(355,657043200,1),(355,670348800,2),(355,686678400,1),(355,701798400,2),(355,718128000,1),(355,733248000,2),(355,749577600,1),(355,764697600,2),(355,781027200,1),(355,796147200,2),(355,812476800,1),(355,828201600,2),(355,844531200,1),(355,859651200,2),(355,875980800,1),(355,891100800,2),(355,907430400,1),(355,922550400,2),(355,938880000,1),(355,954000000,2),(355,967305600,1),(355,985449600,2),(355,1002384000,1),(355,1017504000,2),(355,1033833600,1),(355,1048953600,2),(355,1065283200,1),(355,1080403200,2),(355,1096732800,1),(355,1111852800,2),(355,1128182400,1),(355,1143907200,2),(355,1159632000,1),(355,1174752000,2),(355,1191686400,1),(355,1207411200,2),(355,1223136000,1),(355,1238860800,2),(355,1254585600,1),(355,1270310400,2),(355,1286035200,1),(355,1301760000,2),(355,1317484800,1),(355,1333209600,2),(355,1349539200,1),(355,1365264000,2),(355,1380988800,1),(355,1396713600,2),(355,1412438400,1),(355,1428163200,2),(355,1443888000,1),(355,1459612800,2),(355,1475337600,1),(355,1491062400,2),(355,1506787200,1),(355,1522512000,2),(355,1538841600,1),(355,1554566400,2),(355,1570291200,1),(355,1586016000,2),(355,1601740800,1),(355,1617465600,2),(355,1633190400,1),(355,1648915200,2),(355,1664640000,1),(355,1680364800,2),(355,1696089600,1),(355,1712419200,2),(355,1728144000,1),(355,1743868800,2),(355,1759593600,1),(355,1775318400,2),(355,1791043200,1),(355,1806768000,2),(355,1822492800,1),(355,1838217600,2),(355,1853942400,1),(355,1869667200,2),(355,1885996800,1),(355,1901721600,2),(355,1917446400,1),(355,1933171200,2),(355,1948896000,1),(355,1964620800,2),(355,1980345600,1),(355,1996070400,2),(355,2011795200,1),(355,2027520000,2),(355,2043244800,1),(355,2058969600,2),(355,2075299200,1),(355,2091024000,2),(355,2106748800,1),(355,2122473600,2),(355,2138198400,1),(356,-2147483648,1),(356,352216800,3),(356,372785400,2),(356,384273000,3),(356,404839800,2),(356,415722600,3),(356,436289400,2),(356,447172200,3),(356,467739000,2),(356,478621800,3),(356,499188600,4),(356,511282800,3),(356,530033400,4),(356,542732400,3),(356,562087800,4),(356,574786800,3),(356,594142200,4),(356,606236400,3),(356,625591800,4),(356,636476400,3),(356,657041400,4),(356,667926000,3),(356,688491000,4),(356,699375600,3),(356,719940600,4),(356,731430000,3),(356,751995000,4),(356,762879600,3),(356,783444600,4),(356,794329200,3),(356,814894200,4),(356,828198000,3),(356,846343800,4),(356,859647600,3),(356,877793400,4),(356,891097200,3),(356,909243000,4),(356,922546800,3),(356,941297400,4),(356,953996400,3),(356,967303800,4),(356,985446000,3),(356,1004196600,4),(356,1017500400,3),(356,1035646200,4),(356,1048950000,3),(356,1067095800,4),(356,1080399600,3),(356,1099150200,4),(356,1111849200,3),(356,1130599800,4),(356,1143903600,3),(356,1162049400,4),(356,1174748400,3),(356,1193499000,4),(356,1207407600,3),(356,1223134200,4),(356,1238857200,3),(356,1254583800,4),(356,1270306800,3),(356,1286033400,4),(356,1301756400,3),(356,1317483000,4),(356,1333206000,3),(356,1349537400,4),(356,1365260400,3),(356,1380987000,4),(356,1396710000,3),(356,1412436600,4),(356,1428159600,3),(356,1443886200,4),(356,1459609200,3),(356,1475335800,4),(356,1491058800,3),(356,1506785400,4),(356,1522508400,3),(356,1538839800,4),(356,1554562800,3),(356,1570289400,4),(356,1586012400,3),(356,1601739000,4),(356,1617462000,3),(356,1633188600,4),(356,1648911600,3),(356,1664638200,4),(356,1680361200,3),(356,1696087800,4),(356,1712415600,3),(356,1728142200,4),(356,1743865200,3),(356,1759591800,4),(356,1775314800,3),(356,1791041400,4),(356,1806764400,3),(356,1822491000,4),(356,1838214000,3),(356,1853940600,4),(356,1869663600,3),(356,1885995000,4),(356,1901718000,3),(356,1917444600,4),(356,1933167600,3),(356,1948894200,4),(356,1964617200,3),(356,1980343800,4),(356,1996066800,3),(356,2011793400,4),(356,2027516400,3),(356,2043243000,4),(356,2058966000,3),(356,2075297400,4),(356,2091020400,3),(356,2106747000,4),(356,2122470000,3),(356,2138196600,4),(356,2147483647,4),(357,-2147483648,3),(357,-1672560000,1),(357,-1665388800,2),(357,-883641600,1),(357,-876124800,2),(357,-860400000,1),(357,-844675200,2),(357,-828345600,1),(357,-813225600,2),(357,31500000,3),(357,57686400,1),(357,67968000,2),(357,625593600,1),(357,636480000,2),(357,657043200,1),(357,667929600,2),(357,688492800,1),(357,699379200,2),(357,709912800,3),(357,719942400,1),(357,731433600,2),(357,751996800,1),(357,762883200,2),(358,-2147483648,1),(358,352216800,3),(358,372785400,2),(358,384273000,3),(358,404839800,2),(358,415722600,3),(358,436289400,2),(358,447172200,3),(358,467739000,2),(358,478621800,3),(358,499188600,4),(358,511282800,3),(358,530033400,4),(358,542732400,3),(358,562087800,4),(358,574786800,3),(358,594142200,4),(358,606236400,3),(358,625591800,4),(358,636476400,3),(358,657041400,4),(358,667926000,3),(358,688491000,4),(358,699375600,3),(358,719940600,4),(358,731430000,3),(358,751995000,4),(358,762879600,3),(358,783444600,4),(358,794329200,3),(358,814894200,4),(358,828198000,3),(358,846343800,4),(358,859647600,3),(358,877793400,4),(358,891097200,3),(358,909243000,4),(358,922546800,3),(358,941297400,4),(358,953996400,3),(358,967303800,4),(358,985446000,3),(358,1004196600,4),(358,1017500400,3),(358,1035646200,4),(358,1048950000,3),(358,1067095800,4),(358,1080399600,3),(358,1099150200,4),(358,1111849200,3),(358,1130599800,4),(358,1143903600,3),(358,1162049400,4),(358,1174748400,3),(358,1193499000,4),(358,1207407600,3),(358,1223134200,4),(358,1238857200,3),(358,1254583800,4),(358,1270306800,3),(358,1286033400,4),(358,1301756400,3),(358,1317483000,4),(358,1333206000,3),(358,1349537400,4),(358,1365260400,3),(358,1380987000,4),(358,1396710000,3),(358,1412436600,4),(358,1428159600,3),(358,1443886200,4),(358,1459609200,3),(358,1475335800,4),(358,1491058800,3),(358,1506785400,4),(358,1522508400,3),(358,1538839800,4),(358,1554562800,3),(358,1570289400,4),(358,1586012400,3),(358,1601739000,4),(358,1617462000,3),(358,1633188600,4),(358,1648911600,3),(358,1664638200,4),(358,1680361200,3),(358,1696087800,4),(358,1712415600,3),(358,1728142200,4),(358,1743865200,3),(358,1759591800,4),(358,1775314800,3),(358,1791041400,4),(358,1806764400,3),(358,1822491000,4),(358,1838214000,3),(358,1853940600,4),(358,1869663600,3),(358,1885995000,4),(358,1901718000,3),(358,1917444600,4),(358,1933167600,3),(358,1948894200,4),(358,1964617200,3),(358,1980343800,4),(358,1996066800,3),(358,2011793400,4),(358,2027516400,3),(358,2043243000,4),(358,2058966000,3),(358,2075297400,4),(358,2091020400,3),(358,2106747000,4),(358,2122470000,3),(358,2138196600,4),(358,2147483647,4),(359,-2147483648,3),(359,-1672560000,1),(359,-1665388800,2),(359,-883641600,1),(359,-876124800,2),(359,-860400000,1),(359,-844675200,2),(359,-828345600,1),(359,-813225600,2),(359,31500000,3),(359,57686400,1),(359,67968000,2),(359,89136000,1),(359,100022400,2),(359,120585600,1),(359,131472000,2),(359,152035200,1),(359,162921600,2),(359,183484800,1),(359,194976000,2),(359,215539200,1),(359,226425600,2),(359,246988800,1),(359,257875200,2),(359,278438400,1),(359,289324800,2),(359,309888000,1),(359,320774400,2),(359,341337600,1),(359,352224000,2),(359,372787200,1),(359,384278400,2),(359,404841600,1),(359,415728000,2),(359,436291200,1),(359,447177600,2),(359,467740800,1),(359,478627200,2),(359,499190400,1),(359,511286400,2),(359,530035200,1),(359,542736000,2),(359,561484800,1),(359,574790400,2),(359,594144000,1),(359,606240000,2),(359,625593600,1),(359,637689600,2),(359,657043200,1),(359,667929600,2),(359,688492800,1),(359,699379200,2),(359,719942400,1),(359,731433600,2),(359,751996800,1),(359,762883200,2),(359,783446400,1),(359,796147200,2),(359,814896000,1),(359,828201600,2),(359,846345600,1),(359,859651200,2),(359,877795200,1),(359,891100800,2),(359,909244800,1),(359,922550400,2),(359,941299200,1),(359,954000000,2),(359,967305600,1),(359,985449600,2),(359,1004198400,1),(359,1017504000,2),(359,1035648000,1),(359,1048953600,2),(359,1067097600,1),(359,1080403200,2),(359,1099152000,1),(359,1111852800,2),(359,1130601600,1),(359,1143907200,2),(359,1162051200,1),(359,1174752000,2),(359,1193500800,1),(359,1207411200,2),(359,1223136000,1),(359,1238860800,2),(359,1254585600,1),(359,1270310400,2),(359,1286035200,1),(359,1301760000,2),(359,1317484800,1),(359,1333209600,2),(359,1349539200,1),(359,1365264000,2),(359,1380988800,1),(359,1396713600,2),(359,1412438400,1),(359,1428163200,2),(359,1443888000,1),(359,1459612800,2),(359,1475337600,1),(359,1491062400,2),(359,1506787200,1),(359,1522512000,2),(359,1538841600,1),(359,1554566400,2),(359,1570291200,1),(359,1586016000,2),(359,1601740800,1),(359,1617465600,2),(359,1633190400,1),(359,1648915200,2),(359,1664640000,1),(359,1680364800,2),(359,1696089600,1),(359,1712419200,2),(359,1728144000,1),(359,1743868800,2),(359,1759593600,1),(359,1775318400,2),(359,1791043200,1),(359,1806768000,2),(359,1822492800,1),(359,1838217600,2),(359,1853942400,1),(359,1869667200,2),(359,1885996800,1),(359,1901721600,2),(359,1917446400,1),(359,1933171200,2),(359,1948896000,1),(359,1964620800,2),(359,1980345600,1),(359,1996070400,2),(359,2011795200,1),(359,2027520000,2),(359,2043244800,1),(359,2058969600,2),(359,2075299200,1),(359,2091024000,2),(359,2106748800,1),(359,2122473600,2),(359,2138198400,1),(360,-2147483648,3),(360,-1672560000,1),(360,-1665388800,2),(360,-883641600,1),(360,-876124800,2),(360,-860400000,1),(360,-844675200,2),(360,-828345600,1),(360,-813225600,2),(360,31500000,3),(360,57686400,1),(360,67968000,2),(360,89136000,1),(360,100022400,2),(360,120585600,1),(360,131472000,2),(360,152035200,1),(360,162921600,2),(360,183484800,1),(360,194976000,2),(360,215539200,1),(360,226425600,2),(360,246988800,1),(360,257875200,2),(360,278438400,1),(360,289324800,2),(360,309888000,1),(360,320774400,2),(360,341337600,1),(360,352224000,2),(360,372787200,1),(360,386697600,2),(360,404841600,1),(360,415728000,2),(360,436291200,1),(360,447177600,2),(360,467740800,1),(360,478627200,2),(360,499190400,1),(360,511286400,2),(360,530035200,1),(360,542736000,2),(360,562089600,1),(360,574790400,2),(360,594144000,1),(360,606240000,2),(360,625593600,1),(360,636480000,2),(360,657043200,1),(360,667929600,2),(360,688492800,1),(360,699379200,2),(360,719942400,1),(360,731433600,2),(360,751996800,1),(360,762883200,2),(360,783446400,1),(360,794332800,2),(360,814896000,1),(360,828201600,2),(360,846345600,1),(360,859651200,2),(360,877795200,1),(360,891100800,2),(360,909244800,1),(360,922550400,2),(360,941299200,1),(360,954000000,2),(360,967305600,1),(360,985449600,2),(360,1004198400,1),(360,1017504000,2),(360,1035648000,1),(360,1048953600,2),(360,1067097600,1),(360,1080403200,2),(360,1099152000,1),(360,1111852800,2),(360,1130601600,1),(360,1143907200,2),(360,1162051200,1),(360,1174752000,2),(360,1193500800,1),(360,1207411200,2),(360,1223136000,1),(360,1238860800,2),(360,1254585600,1),(360,1270310400,2),(360,1286035200,1),(360,1301760000,2),(360,1317484800,1),(360,1333209600,2),(360,1349539200,1),(360,1365264000,2),(360,1380988800,1),(360,1396713600,2),(360,1412438400,1),(360,1428163200,2),(360,1443888000,1),(360,1459612800,2),(360,1475337600,1),(360,1491062400,2),(360,1506787200,1),(360,1522512000,2),(360,1538841600,1),(360,1554566400,2),(360,1570291200,1),(360,1586016000,2),(360,1601740800,1),(360,1617465600,2),(360,1633190400,1),(360,1648915200,2),(360,1664640000,1),(360,1680364800,2),(360,1696089600,1),(360,1712419200,2),(360,1728144000,1),(360,1743868800,2),(360,1759593600,1),(360,1775318400,2),(360,1791043200,1),(360,1806768000,2),(360,1822492800,1),(360,1838217600,2),(360,1853942400,1),(360,1869667200,2),(360,1885996800,1),(360,1901721600,2),(360,1917446400,1),(360,1933171200,2),(360,1948896000,1),(360,1964620800,2),(360,1980345600,1),(360,1996070400,2),(360,2011795200,1),(360,2027520000,2),(360,2043244800,1),(360,2058969600,2),(360,2075299200,1),(360,2091024000,2),(360,2106748800,1),(360,2122473600,2),(360,2138198400,1),(361,-2147483648,3),(361,-1672558200,1),(361,-1665387000,2),(361,-883639800,1),(361,-876123000,2),(361,-860398200,1),(361,-844673400,2),(361,-828343800,1),(361,-813223800,2),(362,-2147483648,3),(362,-1672552800,1),(362,-1665381600,2),(362,-883634400,1),(362,-876117600,2),(362,-860392800,1),(362,-844668000,2),(362,-836467200,3),(362,152042400,1),(362,162928800,2),(362,436298400,1),(362,447184800,2),(362,690314400,1),(362,699386400,2),(362,1165082400,1),(362,1174759200,2),(362,1193508000,1),(362,1206813600,2),(362,1224957600,1),(362,1238263200,2),(363,-2147483648,3),(363,-1672560000,1),(363,-1665388800,2),(363,-883641600,1),(363,-876124800,2),(363,-860400000,1),(363,-844675200,2),(363,-828345600,1),(363,-813225600,2),(363,31500000,3),(363,57686400,1),(363,67968000,2),(363,625593600,1),(363,636480000,2),(363,657043200,1),(363,667929600,2),(363,688492800,1),(363,699379200,2),(364,-2147483648,3),(364,-1672558200,1),(364,-1665387000,2),(364,-883639800,1),(364,-876123000,2),(364,-860398200,1),(364,-844673400,2),(364,-828343800,1),(364,-813223800,2),(364,31501800,3),(364,57688200,1),(364,67969800,2),(364,89137800,1),(364,100024200,2),(364,120587400,1),(364,131473800,2),(364,152037000,1),(364,162923400,2),(364,183486600,1),(364,194977800,2),(364,215541000,1),(364,226427400,2),(364,246990600,1),(364,257877000,2),(364,278440200,1),(364,289326600,2),(364,309889800,1),(364,320776200,2),(364,341339400,1),(364,352225800,2),(364,372789000,1),(364,384280200,2),(364,404843400,1),(364,415729800,2),(364,436293000,1),(364,447179400,2),(364,467742600,1),(364,478629000,2),(364,499192200,1),(364,511288200,2),(364,530037000,1),(364,542737800,2),(364,562091400,1),(364,574792200,2),(364,594145800,1),(364,606241800,2),(364,625595400,1),(364,637691400,2),(364,657045000,1),(364,667931400,2),(364,688494600,1),(364,701195400,2),(364,719944200,1),(364,731435400,2),(364,751998600,1),(364,764094600,2),(364,783448200,1),(364,796149000,2),(364,814897800,1),(364,828203400,2),(364,846347400,1),(364,859653000,2),(364,877797000,1),(364,891102600,2),(364,909246600,1),(364,922552200,2),(364,941301000,1),(364,954001800,2),(364,972750600,1),(364,985451400,2),(364,1004200200,1),(364,1017505800,2),(364,1035649800,1),(364,1048955400,2),(364,1067099400,1),(364,1080405000,2),(364,1099153800,1),(364,1111854600,2),(364,1130603400,1),(364,1143909000,2),(364,1162053000,1),(364,1174753800,2),(364,1193502600,1),(364,1207413000,2),(364,1223137800,1),(364,1238862600,2),(364,1254587400,1),(364,1270312200,2),(364,1286037000,1),(364,1301761800,2),(364,1317486600,1),(364,1333211400,2),(364,1349541000,1),(364,1365265800,2),(364,1380990600,1),(364,1396715400,2),(364,1412440200,1),(364,1428165000,2),(364,1443889800,1),(364,1459614600,2),(364,1475339400,1),(364,1491064200,2),(364,1506789000,1),(364,1522513800,2),(364,1538843400,1),(364,1554568200,2),(364,1570293000,1),(364,1586017800,2),(364,1601742600,1),(364,1617467400,2),(364,1633192200,1),(364,1648917000,2),(364,1664641800,1),(364,1680366600,2),(364,1696091400,1),(364,1712421000,2),(364,1728145800,1),(364,1743870600,2),(364,1759595400,1),(364,1775320200,2),(364,1791045000,1),(364,1806769800,2),(364,1822494600,1),(364,1838219400,2),(364,1853944200,1),(364,1869669000,2),(364,1885998600,1),(364,1901723400,2),(364,1917448200,1),(364,1933173000,2),(364,1948897800,1),(364,1964622600,2),(364,1980347400,1),(364,1996072200,2),(364,2011797000,1),(364,2027521800,2),(364,2043246600,1),(364,2058971400,2),(364,2075301000,1),(364,2091025800,2),(364,2106750600,1),(364,2122475400,2),(364,2138200200,1),(365,-2147483648,3),(365,-1672560000,1),(365,-1665388800,2),(365,-883641600,1),(365,-876124800,2),(365,-860400000,1),(365,-844675200,2),(365,-828345600,1),(365,-813225600,2),(365,31500000,3),(365,57686400,1),(365,67968000,2),(365,89136000,1),(365,100022400,2),(365,120585600,1),(365,131472000,2),(365,152035200,1),(365,162921600,2),(365,183484800,1),(365,194976000,2),(365,215539200,1),(365,226425600,2),(365,246988800,1),(365,257875200,2),(365,278438400,1),(365,289324800,2),(365,309888000,1),(365,320774400,2),(365,341337600,1),(365,352224000,2),(365,372787200,1),(365,386697600,2),(365,404841600,1),(365,415728000,2),(365,436291200,1),(365,447177600,2),(365,467740800,1),(365,478627200,2),(365,499190400,1),(365,511286400,2),(365,530035200,1),(365,542736000,2),(365,562089600,1),(365,574790400,2),(365,594144000,1),(365,606240000,2),(365,625593600,1),(365,636480000,2),(365,657043200,1),(365,667929600,2),(365,688492800,1),(365,699379200,2),(365,719942400,1),(365,731433600,2),(365,751996800,1),(365,762883200,2),(365,783446400,1),(365,794332800,2),(365,814896000,1),(365,828201600,2),(365,846345600,1),(365,859651200,2),(365,877795200,1),(365,891100800,2),(365,909244800,1),(365,922550400,2),(365,941299200,1),(365,954000000,2),(365,967305600,1),(365,985449600,2),(365,1004198400,1),(365,1017504000,2),(365,1035648000,1),(365,1048953600,2),(365,1067097600,1),(365,1080403200,2),(365,1099152000,1),(365,1111852800,2),(365,1130601600,1),(365,1143907200,2),(365,1162051200,1),(365,1174752000,2),(365,1193500800,1),(365,1207411200,2),(365,1223136000,1),(365,1238860800,2),(365,1254585600,1),(365,1270310400,2),(365,1286035200,1),(365,1301760000,2),(365,1317484800,1),(365,1333209600,2),(365,1349539200,1),(365,1365264000,2),(365,1380988800,1),(365,1396713600,2),(365,1412438400,1),(365,1428163200,2),(365,1443888000,1),(365,1459612800,2),(365,1475337600,1),(365,1491062400,2),(365,1506787200,1),(365,1522512000,2),(365,1538841600,1),(365,1554566400,2),(365,1570291200,1),(365,1586016000,2),(365,1601740800,1),(365,1617465600,2),(365,1633190400,1),(365,1648915200,2),(365,1664640000,1),(365,1680364800,2),(365,1696089600,1),(365,1712419200,2),(365,1728144000,1),(365,1743868800,2),(365,1759593600,1),(365,1775318400,2),(365,1791043200,1),(365,1806768000,2),(365,1822492800,1),(365,1838217600,2),(365,1853942400,1),(365,1869667200,2),(365,1885996800,1),(365,1901721600,2),(365,1917446400,1),(365,1933171200,2),(365,1948896000,1),(365,1964620800,2),(365,1980345600,1),(365,1996070400,2),(365,2011795200,1),(365,2027520000,2),(365,2043244800,1),(365,2058969600,2),(365,2075299200,1),(365,2091024000,2),(365,2106748800,1),(365,2122473600,2),(365,2138198400,1),(366,-2147483648,3),(366,-1680508800,1),(366,-1665388800,2),(366,-1646640000,1),(366,-1635753600,2),(366,-1615190400,1),(366,-1604304000,2),(366,-1583920800,3),(366,-883641600,1),(366,-876124800,2),(366,-860400000,1),(366,-844675200,2),(366,-828345600,1),(366,-813225600,2),(366,-94730400,3),(366,-71136000,1),(366,-55411200,2),(366,-37267200,1),(366,-25776000,2),(366,-5817600,1),(366,5673600,2),(366,25632000,1),(366,37728000,2),(366,57686400,1),(366,67968000,2),(366,89136000,1),(366,100022400,2),(366,120585600,1),(366,131472000,2),(366,152035200,1),(366,162921600,2),(366,183484800,1),(366,194976000,2),(366,215539200,1),(366,226425600,2),(366,246988800,1),(366,257875200,2),(366,278438400,1),(366,289324800,2),(366,309888000,1),(366,320774400,2),(366,341337600,1),(366,352224000,2),(366,372787200,1),(366,386092800,2),(366,404841600,1),(366,417542400,2),(366,436291200,1),(366,447177600,2),(366,467740800,1),(366,478627200,2),(366,499190400,1),(366,510076800,2),(366,530035200,1),(366,542736000,2),(366,562089600,1),(366,574790400,2),(366,594144000,1),(366,606240000,2),(366,625593600,1),(366,637689600,2),(366,657043200,1),(366,670348800,2),(366,686678400,1),(366,701798400,2),(366,718128000,1),(366,733248000,2),(366,749577600,1),(366,764697600,2),(366,781027200,1),(366,796147200,2),(366,812476800,1),(366,828201600,2),(366,844531200,1),(366,859651200,2),(366,875980800,1),(366,891100800,2),(366,907430400,1),(366,922550400,2),(366,938880000,1),(366,954000000,2),(366,967305600,1),(366,985449600,2),(366,1002384000,1),(366,1017504000,2),(366,1033833600,1),(366,1048953600,2),(366,1065283200,1),(366,1080403200,2),(366,1096732800,1),(366,1111852800,2),(366,1128182400,1),(366,1143907200,2),(366,1159632000,1),(366,1174752000,2),(366,1191686400,1),(366,1207411200,2),(366,1223136000,1),(366,1238860800,2),(366,1254585600,1),(366,1270310400,2),(366,1286035200,1),(366,1301760000,2),(366,1317484800,1),(366,1333209600,2),(366,1349539200,1),(366,1365264000,2),(366,1380988800,1),(366,1396713600,2),(366,1412438400,1),(366,1428163200,2),(366,1443888000,1),(366,1459612800,2),(366,1475337600,1),(366,1491062400,2),(366,1506787200,1),(366,1522512000,2),(366,1538841600,1),(366,1554566400,2),(366,1570291200,1),(366,1586016000,2),(366,1601740800,1),(366,1617465600,2),(366,1633190400,1),(366,1648915200,2),(366,1664640000,1),(366,1680364800,2),(366,1696089600,1),(366,1712419200,2),(366,1728144000,1),(366,1743868800,2),(366,1759593600,1),(366,1775318400,2),(366,1791043200,1),(366,1806768000,2),(366,1822492800,1),(366,1838217600,2),(366,1853942400,1),(366,1869667200,2),(366,1885996800,1),(366,1901721600,2),(366,1917446400,1),(366,1933171200,2),(366,1948896000,1),(366,1964620800,2),(366,1980345600,1),(366,1996070400,2),(366,2011795200,1),(366,2027520000,2),(366,2043244800,1),(366,2058969600,2),(366,2075299200,1),(366,2091024000,2),(366,2106748800,1),(366,2122473600,2),(366,2138198400,1),(367,-2147483648,3),(367,-1672560000,1),(367,-1665388800,2),(367,-883641600,1),(367,-876124800,2),(367,-860400000,1),(367,-844675200,2),(367,-828345600,1),(367,-813225600,2),(367,31500000,3),(367,57686400,1),(367,67968000,2),(367,89136000,1),(367,100022400,2),(367,120585600,1),(367,131472000,2),(367,152035200,1),(367,162921600,2),(367,183484800,1),(367,194976000,2),(367,215539200,1),(367,226425600,2),(367,246988800,1),(367,257875200,2),(367,278438400,1),(367,289324800,2),(367,309888000,1),(367,320774400,2),(367,341337600,1),(367,352224000,2),(367,372787200,1),(367,384278400,2),(367,404841600,1),(367,415728000,2),(367,436291200,1),(367,447177600,2),(367,467740800,1),(367,478627200,2),(367,499190400,1),(367,511286400,2),(367,530035200,1),(367,542736000,2),(367,561484800,1),(367,574790400,2),(367,594144000,1),(367,606240000,2),(367,625593600,1),(367,637689600,2),(367,657043200,1),(367,667929600,2),(367,688492800,1),(367,699379200,2),(367,719942400,1),(367,731433600,2),(367,751996800,1),(367,762883200,2),(367,783446400,1),(367,796147200,2),(367,814896000,1),(367,828201600,2),(367,846345600,1),(367,859651200,2),(367,877795200,1),(367,891100800,2),(367,909244800,1),(367,922550400,2),(367,941299200,1),(367,954000000,2),(367,967305600,1),(367,985449600,2),(367,1004198400,1),(367,1017504000,2),(367,1035648000,1),(367,1048953600,2),(367,1067097600,1),(367,1080403200,2),(367,1099152000,1),(367,1111852800,2),(367,1130601600,1),(367,1143907200,2),(367,1162051200,1),(367,1174752000,2),(367,1193500800,1),(367,1207411200,2),(367,1223136000,1),(367,1238860800,2),(367,1254585600,1),(367,1270310400,2),(367,1286035200,1),(367,1301760000,2),(367,1317484800,1),(367,1333209600,2),(367,1349539200,1),(367,1365264000,2),(367,1380988800,1),(367,1396713600,2),(367,1412438400,1),(367,1428163200,2),(367,1443888000,1),(367,1459612800,2),(367,1475337600,1),(367,1491062400,2),(367,1506787200,1),(367,1522512000,2),(367,1538841600,1),(367,1554566400,2),(367,1570291200,1),(367,1586016000,2),(367,1601740800,1),(367,1617465600,2),(367,1633190400,1),(367,1648915200,2),(367,1664640000,1),(367,1680364800,2),(367,1696089600,1),(367,1712419200,2),(367,1728144000,1),(367,1743868800,2),(367,1759593600,1),(367,1775318400,2),(367,1791043200,1),(367,1806768000,2),(367,1822492800,1),(367,1838217600,2),(367,1853942400,1),(367,1869667200,2),(367,1885996800,1),(367,1901721600,2),(367,1917446400,1),(367,1933171200,2),(367,1948896000,1),(367,1964620800,2),(367,1980345600,1),(367,1996070400,2),(367,2011795200,1),(367,2027520000,2),(367,2043244800,1),(367,2058969600,2),(367,2075299200,1),(367,2091024000,2),(367,2106748800,1),(367,2122473600,2),(367,2138198400,1),(368,-2147483648,3),(368,-1672552800,1),(368,-1665381600,2),(368,-883634400,1),(368,-876117600,2),(368,-860392800,1),(368,-844668000,2),(368,-836467200,3),(368,152042400,1),(368,162928800,2),(368,436298400,1),(368,447184800,2),(368,690314400,1),(368,699386400,2),(368,1165082400,1),(368,1174759200,2),(368,1193508000,1),(368,1206813600,2),(368,1224957600,1),(368,1238263200,2),(369,-2147483648,3),(369,-1672558200,1),(369,-1665387000,2),(369,-883639800,1),(369,-876123000,2),(369,-860398200,1),(369,-844673400,2),(369,-828343800,1),(369,-813223800,2),(369,31501800,3),(369,57688200,1),(369,67969800,2),(369,89137800,1),(369,100024200,2),(369,120587400,1),(369,131473800,2),(369,152037000,1),(369,162923400,2),(369,183486600,1),(369,194977800,2),(369,215541000,1),(369,226427400,2),(369,246990600,1),(369,257877000,2),(369,278440200,1),(369,289326600,2),(369,309889800,1),(369,320776200,2),(369,341339400,1),(369,352225800,2),(369,372789000,1),(369,386699400,2),(369,404843400,1),(369,415729800,2),(369,436293000,1),(369,447179400,2),(369,467742600,1),(369,478629000,2),(369,499192200,1),(369,511288200,2),(369,530037000,1),(369,542737800,2),(369,562091400,1),(369,574792200,2),(369,594145800,1),(369,606241800,2),(369,625595400,1),(369,636481800,2),(369,657045000,1),(369,667931400,2),(369,688494600,1),(369,699381000,2),(369,719944200,1),(369,731435400,2),(369,751998600,1),(369,762885000,2),(369,783448200,1),(369,794334600,2),(369,814897800,1),(369,828203400,2),(369,846347400,1),(369,859653000,2),(369,877797000,1),(369,891102600,2),(369,909246600,1),(369,922552200,2),(369,941301000,1),(369,946647000,4),(369,954001800,2),(369,972750600,1),(369,985451400,2),(369,1004200200,1),(369,1017505800,2),(369,1035649800,1),(369,1048955400,2),(369,1067099400,1),(369,1080405000,2),(369,1099153800,1),(369,1111854600,2),(369,1130603400,1),(369,1143909000,2),(369,1162053000,1),(369,1174753800,2),(369,1193502600,1),(369,1207413000,2),(369,1223137800,1),(369,1238862600,2),(369,1254587400,1),(369,1270312200,2),(369,1286037000,1),(369,1301761800,2),(369,1317486600,1),(369,1333211400,2),(369,1349541000,1),(369,1365265800,2),(369,1380990600,1),(369,1396715400,2),(369,1412440200,1),(369,1428165000,2),(369,1443889800,1),(369,1459614600,2),(369,1475339400,1),(369,1491064200,2),(369,1506789000,1),(369,1522513800,2),(369,1538843400,1),(369,1554568200,2),(369,1570293000,1),(369,1586017800,2),(369,1601742600,1),(369,1617467400,2),(369,1633192200,1),(369,1648917000,2),(369,1664641800,1),(369,1680366600,2),(369,1696091400,1),(369,1712421000,2),(369,1728145800,1),(369,1743870600,2),(369,1759595400,1),(369,1775320200,2),(369,1791045000,1),(369,1806769800,2),(369,1822494600,1),(369,1838219400,2),(369,1853944200,1),(369,1869669000,2),(369,1885998600,1),(369,1901723400,2),(369,1917448200,1),(369,1933173000,2),(369,1948897800,1),(369,1964622600,2),(369,1980347400,1),(369,1996072200,2),(369,2011797000,1),(369,2027521800,2),(369,2043246600,1),(369,2058971400,2),(369,2075301000,1),(369,2091025800,2),(369,2106750600,1),(369,2122475400,2),(369,2138200200,1),(370,-2147483648,0),(370,-1767209328,2),(370,-1206950400,1),(370,-1191355200,2),(370,-1175367600,1),(370,-1159819200,2),(370,-633812400,1),(370,-622062000,2),(370,-602276400,1),(370,-591825600,2),(370,-570740400,1),(370,-560203200,2),(370,-539118000,1),(370,-531345600,2),(370,-191358000,1),(370,-184190400,2),(370,-155156400,1),(370,-150062400,2),(370,-128890800,1),(370,-121118400,2),(370,-99946800,1),(370,-89582400,2),(370,-68410800,1),(370,-57960000,2),(370,499755600,1),(370,511243200,2),(370,530600400,1),(370,540273600,2),(370,562136400,1),(370,571204800,2),(370,1214283600,3),(370,1384056000,2),(370,2147483647,2),(371,-2147483648,0),(371,-1767217820,2),(371,-1206961200,1),(371,-1191366000,2),(371,-1175378400,1),(371,-1159830000,2),(371,-633823200,1),(371,-622072800,2),(371,-602287200,1),(371,-591836400,2),(371,-570751200,1),(371,-560214000,2),(371,-539128800,1),(371,-531356400,2),(371,-191368800,1),(371,-184201200,2),(371,-155167200,1),(371,-150073200,2),(371,-128901600,1),(371,-121129200,2),(371,-99957600,1),(371,-89593200,2),(371,-68421600,1),(371,-57970800,2),(371,499744800,1),(371,511232400,2),(371,530589600,1),(371,540262800,2),(371,562125600,1),(371,571194000,2),(371,592970400,1),(371,602038800,2),(371,624420000,1),(371,634698000,2),(371,938916000,1),(371,951613200,2),(371,970970400,1),(371,971571600,2),(371,1003024800,1),(371,1013907600,2),(371,2147483647,2),(372,-2147483648,0),(372,-1767214412,2),(372,-1206957600,1),(372,-1191362400,2),(372,-1175374800,1),(372,-1159826400,2),(372,-633819600,1),(372,-622069200,2),(372,-602283600,1),(372,-591832800,2),(372,-570747600,1),(372,-560210400,2),(372,-539125200,1),(372,-531352800,2),(372,-195426000,1),(372,-184197600,2),(372,-155163600,1),(372,-150069600,2),(372,-128898000,1),(372,-121125600,2),(372,-99954000,1),(372,-89589600,2),(372,-68418000,1),(372,-57967200,2),(372,499748400,1),(372,511236000,2),(372,530593200,1),(372,540266400,2),(372,562129200,1),(372,571197600,2),(372,592974000,1),(372,602042400,2),(372,624423600,1),(372,634701600,2),(372,656478000,1),(372,666756000,2),(372,687927600,1),(372,697600800,2),(372,719982000,1),(372,728445600,2),(372,750826800,1),(372,761709600,2),(372,782276400,1),(372,793159200,2),(372,813726000,1),(372,824004000,2),(372,844570800,1),(372,856058400,2),(372,876106800,1),(372,888717600,2),(372,908074800,1),(372,919562400,2),(372,938919600,1),(372,951616800,2),(372,970974000,1),(372,982461600,2),(372,1003028400,1),(372,1013911200,2),(372,1036292400,1),(372,1045360800,2),(372,1066532400,1),(372,1076810400,2),(372,1099364400,1),(372,1108864800,2),(372,1129431600,1),(372,1140314400,2),(372,1162695600,1),(372,1172368800,2),(372,1192330800,1),(372,1203213600,2),(372,1224385200,1),(372,1234663200,2),(372,1255834800,1),(372,1266717600,2),(372,1287284400,1),(372,1298167200,2),(372,1318734000,1),(372,1330221600,2),(372,1350788400,1),(372,1361066400,2),(372,1382238000,1),(372,1392516000,2),(372,1413687600,1),(372,1424570400,2),(372,1445137200,1),(372,1456020000,2),(372,1476586800,1),(372,1487469600,2),(372,1508036400,1),(372,1518919200,2),(372,1541300400,1),(372,1550368800,2),(372,2147483647,2),(373,-2147483648,0),(373,-1767211196,2),(373,-1206954000,1),(373,-1191358800,2),(373,-1175371200,1),(373,-1159822800,2),(373,-633816000,1),(373,-622065600,2),(373,-602280000,1),(373,-591829200,2),(373,-570744000,1),(373,-560206800,2),(373,-539121600,1),(373,-531349200,2),(373,-191361600,1),(373,-184194000,2),(373,-155160000,1),(373,-150066000,2),(373,-128894400,1),(373,-121122000,2),(373,-99950400,1),(373,-89586000,2),(373,-68414400,1),(373,-57963600,2),(373,499752000,1),(373,511239600,2),(373,530596800,1),(373,540270000,2),(373,562132800,1),(373,571201200,2),(373,750830400,1),(373,761713200,2),(373,2147483647,2),(374,-1693706400,0),(374,-1680483600,1),(374,-1663455600,2),(374,-1650150000,3),(374,-1632006000,2),(374,-1618700400,3),(374,-938905200,2),(374,-857257200,3),(374,-844556400,2),(374,-828226800,3),(374,-812502000,2),(374,-796777200,3),(374,-781052400,2),(374,-766623600,3),(374,228877200,2),(374,243997200,3),(374,260326800,2),(374,276051600,3),(374,291776400,2),(374,307501200,3),(374,323830800,2),(374,338950800,3),(374,354675600,2),(374,370400400,3),(374,386125200,2),(374,401850000,3),(374,417574800,2),(374,433299600,3),(374,449024400,2),(374,465354000,3),(374,481078800,2),(374,496803600,3),(374,512528400,2),(374,528253200,3),(374,543978000,2),(374,559702800,3),(374,575427600,2),(374,591152400,3),(374,606877200,2),(374,622602000,3),(374,638326800,2),(374,654656400,3),(374,670381200,2),(374,686106000,3),(374,701830800,2),(374,717555600,3),(374,733280400,2),(374,749005200,3),(374,764730000,2),(374,780454800,3),(374,796179600,2),(374,811904400,3),(374,828234000,2),(374,846378000,3),(374,859683600,2),(374,877827600,3),(374,891133200,2),(374,909277200,3),(374,922582800,2),(374,941331600,3),(374,954032400,2),(374,972781200,3),(374,985482000,2),(374,1004230800,3),(374,1017536400,2),(374,1035680400,3),(374,1048986000,2),(374,1067130000,3),(374,1080435600,2),(374,1099184400,3),(374,1111885200,2),(374,1130634000,3),(374,1143334800,2),(374,1162083600,3),(374,1174784400,2),(374,1193533200,3),(374,1206838800,2),(374,1224982800,3),(374,1238288400,2),(374,1256432400,3),(374,1269738000,2),(374,1288486800,3),(374,1301187600,2),(374,1319936400,3),(374,1332637200,2),(374,1351386000,3),(374,1364691600,2),(374,1382835600,3),(374,1396141200,2),(374,1414285200,3),(374,1427590800,2),(374,1445734800,3),(374,1459040400,2),(374,1477789200,3),(374,1490490000,2),(374,1509238800,3),(374,1521939600,2),(374,1540688400,3),(374,1553994000,2),(374,1572138000,3),(374,1585443600,2),(374,1603587600,3),(374,1616893200,2),(374,1635642000,3),(374,1648342800,2),(374,1667091600,3),(374,1679792400,2),(374,1698541200,3),(374,1711846800,2),(374,1729990800,3),(374,1743296400,2),(374,1761440400,3),(374,1774746000,2),(374,1792890000,3),(374,1806195600,2),(374,1824944400,3),(374,1837645200,2),(374,1856394000,3),(374,1869094800,2),(374,1887843600,3),(374,1901149200,2),(374,1919293200,3),(374,1932598800,2),(374,1950742800,3),(374,1964048400,2),(374,1982797200,3),(374,1995498000,2),(374,2014246800,3),(374,2026947600,2),(374,2045696400,3),(374,2058397200,2),(374,2077146000,3),(374,2090451600,2),(374,2108595600,3),(374,2121901200,2),(374,2140045200,3),(375,-1633276800,0),(375,-1615136400,1),(375,-1601827200,0),(375,-1583686800,1),(375,-880214400,2),(375,-769395600,3),(375,-765392400,1),(375,-84384000,0),(375,-68662800,1),(375,-52934400,0),(375,-37213200,1),(375,-21484800,0),(375,-5763600,1),(375,9964800,0),(375,25686000,1),(375,41414400,0),(375,57740400,1),(375,73468800,0),(375,89190000,1),(375,104918400,0),(375,120639600,1),(375,126691200,0),(375,152089200,1),(375,162374400,0),(375,183538800,1),(375,199267200,0),(375,215593200,1),(375,230716800,0),(375,247042800,1),(375,262771200,0),(375,278492400,1),(375,294220800,0),(375,309942000,1),(375,325670400,0),(375,341391600,1),(375,357120000,0),(375,372841200,1),(375,388569600,0),(375,404895600,1),(375,420019200,0),(375,436345200,1),(375,452073600,0),(375,467794800,1),(375,483523200,0),(375,499244400,1),(375,514972800,0),(375,530694000,1),(375,544608000,0),(375,562143600,1),(375,576057600,0),(375,594198000,1),(375,607507200,0),(375,625647600,1),(375,638956800,0),(375,657097200,1),(375,671011200,0),(375,688546800,1),(375,702460800,0),(375,719996400,1),(375,733910400,0),(375,752050800,1),(375,765360000,0),(375,783500400,1),(375,796809600,0),(375,814950000,1),(375,828864000,0),(375,846399600,1),(375,860313600,0),(375,877849200,1),(375,891763200,0),(375,909298800,1),(375,923212800,0),(375,941353200,1),(375,954662400,0),(375,972802800,1),(375,986112000,0),(375,1004252400,1),(375,1018166400,0),(375,1035702000,1),(375,1049616000,0),(375,1067151600,1),(375,1081065600,0),(375,1099206000,1),(375,1112515200,0),(375,1130655600,1),(375,1143964800,0),(375,1162105200,1),(375,1173600000,0),(375,1194159600,1),(375,1205049600,0),(375,1225609200,1),(375,1236499200,0),(375,1257058800,1),(375,1268553600,0),(375,1289113200,1),(375,1300003200,0),(375,1320562800,1),(375,1331452800,0),(375,1352012400,1),(375,1362902400,0),(375,1383462000,1),(375,1394352000,0),(375,1414911600,1),(375,1425801600,0),(375,1446361200,1),(375,1457856000,0),(375,1478415600,1),(375,1489305600,0),(375,1509865200,1),(375,1520755200,0),(375,1541314800,1),(375,1552204800,0),(375,1572764400,1),(375,1583654400,0),(375,1604214000,1),(375,1615708800,0),(375,1636268400,1),(375,1647158400,0),(375,1667718000,1),(375,1678608000,0),(375,1699167600,1),(375,1710057600,0),(375,1730617200,1),(375,1741507200,0),(375,1762066800,1),(375,1772956800,0),(375,1793516400,1),(375,1805011200,0),(375,1825570800,1),(375,1836460800,0),(375,1857020400,1),(375,1867910400,0),(375,1888470000,1),(375,1899360000,0),(375,1919919600,1),(375,1930809600,0),(375,1951369200,1),(375,1962864000,0),(375,1983423600,1),(375,1994313600,0),(375,2014873200,1),(375,2025763200,0),(375,2046322800,1),(375,2057212800,0),(375,2077772400,1),(375,2088662400,0),(375,2109222000,1),(375,2120112000,0),(375,2140671600,1),(376,-2147483648,0),(376,-2131645536,2),(376,-1696276800,1),(376,-1680469200,2),(376,-1632074400,1),(376,-1615143600,2),(376,-1566763200,1),(376,-1557090000,2),(376,-1535486400,1),(376,-1524949200,2),(376,-1504468800,1),(376,-1493413200,2),(376,-1472414400,1),(376,-1461963600,2),(376,-1440964800,1),(376,-1429390800,2),(376,-1409515200,1),(376,-1396731600,2),(376,-1376856000,1),(376,-1366491600,2),(376,-1346616000,1),(376,-1333832400,2),(376,-1313956800,1),(376,-1303678800,2),(376,-1282507200,1),(376,-1272661200,2),(376,-1251057600,1),(376,-1240088400,2),(376,-1219608000,1),(376,-1207429200,2),(376,-1188763200,1),(376,-1175979600,2),(376,-1157313600,1),(376,-1143925200,2),(376,-1124049600,1),(376,-1113771600,2),(376,-1091390400,1),(376,-1081026000,2),(376,-1059854400,1),(376,-1050786000,2),(376,-1030910400,1),(376,-1018126800,2),(376,-999460800,1),(376,-986677200,2),(376,-965592000,1),(376,-955227600,2),(376,-935956800,1),(376,-923173200,2),(376,-904507200,1),(376,-891723600,2),(376,-880221600,3),(376,-769395600,4),(376,-765399600,2),(376,-747252000,1),(376,-733950000,2),(376,-715802400,1),(376,-702500400,2),(376,-684352800,1),(376,-671050800,2),(376,-652903200,1),(376,-639601200,2),(376,-589399200,1),(376,-576097200,2),(376,-557949600,1),(376,-544647600,2),(376,-526500000,1),(376,-513198000,2),(376,-495050400,1),(376,-481748400,2),(376,-431546400,1),(376,-418244400,2),(376,-400096800,1),(376,-386794800,2),(376,-368647200,1),(376,-355345200,2),(376,-337197600,1),(376,-323895600,2),(376,-242244000,1),(376,-226522800,2),(376,-210794400,1),(376,-195073200,2),(376,-179344800,1),(376,-163623600,2),(376,-147895200,1),(376,-131569200,2),(376,-116445600,1),(376,-100119600,2),(376,-84391200,1),(376,-68670000,2),(376,-52941600,1),(376,-37220400,2),(376,-21492000,1),(376,-5770800,2),(376,9957600,1),(376,25678800,2),(376,41407200,1),(376,57733200,2),(376,73461600,1),(376,89182800,2),(376,104911200,1),(376,120632400,2),(376,136360800,1),(376,152082000,2),(376,167810400,1),(376,183531600,2),(376,199260000,1),(376,215586000,2),(376,230709600,1),(376,247035600,2),(376,262764000,1),(376,278485200,2),(376,294213600,1),(376,309934800,2),(376,325663200,1),(376,341384400,2),(376,357112800,1),(376,372834000,2),(376,388562400,1),(376,404888400,2),(376,420012000,1),(376,436338000,2),(376,452066400,1),(376,467787600,2),(376,483516000,1),(376,499237200,2),(376,514965600,1),(376,530686800,2),(376,544600800,1),(376,562136400,2),(376,576050400,1),(376,594190800,2),(376,607500000,1),(376,625640400,2),(376,638949600,1),(376,657090000,2),(376,671004000,1),(376,688539600,2),(376,702453600,1),(376,719989200,2),(376,733903200,1),(376,752043600,2),(376,765352800,1),(376,783493200,2),(376,796802400,1),(376,814942800,2),(376,828856800,1),(376,846392400,2),(376,860306400,1),(376,877842000,2),(376,891756000,1),(376,909291600,2),(376,923205600,1),(376,941346000,2),(376,954655200,1),(376,972795600,2),(376,986104800,1),(376,1004245200,2),(376,1018159200,1),(376,1035694800,2),(376,1049608800,1),(376,1067144400,2),(376,1081058400,1),(376,1099198800,2),(376,1112508000,1),(376,1130648400,2),(376,1143957600,1),(376,1162098000,2),(376,1173592800,1),(376,1194152400,2),(376,1205042400,1),(376,1225602000,2),(376,1236492000,1),(376,1257051600,2),(376,1268546400,1),(376,1289106000,2),(376,1299996000,1),(376,1320555600,2),(376,1331445600,1),(376,1352005200,2),(376,1362895200,1),(376,1383454800,2),(376,1394344800,1),(376,1414904400,2),(376,1425794400,1),(376,1446354000,2),(376,1457848800,1),(376,1478408400,2),(376,1489298400,1),(376,1509858000,2),(376,1520748000,1),(376,1541307600,2),(376,1552197600,1),(376,1572757200,2),(376,1583647200,1),(376,1604206800,2),(376,1615701600,1),(376,1636261200,2),(376,1647151200,1),(376,1667710800,2),(376,1678600800,1),(376,1699160400,2),(376,1710050400,1),(376,1730610000,2),(376,1741500000,1),(376,1762059600,2),(376,1772949600,1),(376,1793509200,2),(376,1805004000,1),(376,1825563600,2),(376,1836453600,1),(376,1857013200,2),(376,1867903200,1),(376,1888462800,2),(376,1899352800,1),(376,1919912400,2),(376,1930802400,1),(376,1951362000,2),(376,1962856800,1),(376,1983416400,2),(376,1994306400,1),(376,2014866000,2),(376,2025756000,1),(376,2046315600,2),(376,2057205600,1),(376,2077765200,2),(376,2088655200,1),(376,2109214800,2),(376,2120104800,1),(376,2140664400,2),(377,-2147483648,2),(377,-1694368800,1),(377,-1681671600,2),(377,-1632067200,1),(377,-1615136400,2),(377,-1029686400,1),(377,-1018198800,2),(377,-880214400,3),(377,-769395600,4),(377,-765392400,2),(377,-746035200,1),(377,-732733200,2),(377,-715795200,1),(377,-702493200,2),(377,-684345600,1),(377,-671043600,2),(377,-652896000,1),(377,-639594000,2),(377,-620755200,1),(377,-607626000,2),(377,-589392000,1),(377,-576090000,2),(377,-557942400,1),(377,-544640400,2),(377,-526492800,1),(377,-513190800,2),(377,-495043200,1),(377,-481741200,2),(377,-463593600,1),(377,-450291600,2),(377,-431539200,1),(377,-418237200,2),(377,-400089600,1),(377,-386787600,2),(377,-368640000,1),(377,-355338000,2),(377,-337190400,1),(377,-321469200,2),(377,-305740800,1),(377,-292438800,2),(377,-210787200,1),(377,-198090000,2),(377,-116438400,5),(377,-100108800,6),(377,-84384000,5),(377,-68659200,6),(377,-52934400,5),(377,-37209600,6),(377,-21484800,5),(377,-5760000,6),(377,9964800,5),(377,25689600,6),(377,41414400,5),(377,57744000,6),(377,73468800,5),(377,89193600,6),(377,104918400,5),(377,120643200,6),(377,136368000,5),(377,152092800,6),(377,167817600,5),(377,183542400,6),(377,199267200,5),(377,215596800,6),(377,230716800,5),(377,247046400,6),(377,262771200,5),(377,278496000,6),(377,294220800,5),(377,309945600,6),(377,325670400,5),(377,341395200,6),(377,357120000,5),(377,372844800,6),(377,388569600,5),(377,404899200,6),(377,420019200,5),(377,436348800,6),(377,452073600,5),(377,467798400,6),(377,483523200,5),(377,499248000,6),(377,514972800,5),(377,530697600,6),(377,544608000,5),(377,562147200,6),(377,576057600,5),(377,594201600,6),(377,607507200,5),(377,625651200,6),(377,638956800,5),(377,657100800,6),(377,671011200,5),(377,688550400,6),(377,702460800,5),(377,720000000,6),(377,733910400,5),(377,752054400,6),(377,765360000,5),(377,783504000,6),(377,796809600,5),(377,814953600,6),(377,828864000,5),(377,846403200,6),(377,860313600,5),(377,877852800,6),(377,891763200,5),(377,909302400,6),(377,923212800,5),(377,941356800,6),(377,954662400,5),(377,972806400,6),(377,986112000,5),(377,1004256000,6),(377,1018166400,5),(377,1035705600,6),(377,1049616000,5),(377,1067155200,6),(377,1081065600,5),(377,1099209600,6),(377,1112515200,5),(377,1130659200,6),(377,1136095200,2),(377,1143964800,1),(377,1162105200,2),(377,1173600000,1),(377,1194159600,2),(377,1205049600,1),(377,1225609200,2),(377,1236499200,1),(377,1257058800,2),(377,1268553600,1),(377,1289113200,2),(377,1300003200,1),(377,1320562800,2),(377,1331452800,1),(377,1352012400,2),(377,1362902400,1),(377,1383462000,2),(377,1394352000,1),(377,1414911600,2),(377,1425801600,1),(377,1446361200,2),(377,1457856000,1),(377,1478415600,2),(377,1489305600,1),(377,1509865200,2),(377,1520755200,1),(377,1541314800,2),(377,1552204800,1),(377,1572764400,2),(377,1583654400,1),(377,1604214000,2),(377,1615708800,1),(377,1636268400,2),(377,1647158400,1),(377,1667718000,2),(377,1678608000,1),(377,1699167600,2),(377,1710057600,1),(377,1730617200,2),(377,1741507200,1),(377,1762066800,2),(377,1772956800,1),(377,1793516400,2),(377,1805011200,1),(377,1825570800,2),(377,1836460800,1),(377,1857020400,2),(377,1867910400,1),(377,1888470000,2),(377,1899360000,1),(377,1919919600,2),(377,1930809600,1),(377,1951369200,2),(377,1962864000,1),(377,1983423600,2),(377,1994313600,1),(377,2014873200,2),(377,2025763200,1),(377,2046322800,2),(377,2057212800,1),(377,2077772400,2),(377,2088662400,1),(377,2109222000,2),(377,2120112000,1),(377,2140671600,2),(378,-2147483648,2),(378,-1632070800,1),(378,-1615140000,2),(378,-1601753400,1),(378,-1583697600,2),(378,-1567357200,1),(378,-1554667200,2),(378,-1534698000,1),(378,-1524074400,2),(378,-1503248400,1),(378,-1492365600,2),(378,-1471798800,1),(378,-1460916000,2),(378,-1440954000,1),(378,-1428861600,2),(378,-1409504400,1),(378,-1397412000,2),(378,-1378054800,1),(378,-1365962400,2),(378,-1346605200,1),(378,-1333908000,2),(378,-1315155600,1),(378,-1301853600,2),(378,-1283706000,1),(378,-1270404000,2),(378,-1252256400,1),(378,-1238954400,2),(378,-1220806800,1),(378,-1207504800,2),(378,-1188752400,1),(378,-1176055200,2),(378,-1157302800,1),(378,-1144000800,2),(378,-1125853200,1),(378,-1112551200,2),(378,-1094403600,1),(378,-1081101600,2),(378,-1062954000,1),(378,-1049652000,2),(378,-1031504400,1),(378,-1018202400,2),(378,-1000054800,1),(378,-986752800,2),(378,-968000400,1),(378,-955303200,2),(378,-936550800,1),(378,-880218000,3),(378,-769395600,4),(378,-765396000,2),(378,-747248400,1),(378,-733946400,2),(378,-715806000,1),(378,-702504000,2),(378,-684356400,1),(378,-671054400,2),(378,-652906800,1),(378,-634161600,2),(378,-620845200,1),(378,-602704800,2),(378,-589395600,1),(378,-576093600,2),(378,-557946000,1),(378,-544644000,2),(378,-526496400,1),(378,-513194400,2),(378,-495046800,1),(378,-481744800,2),(378,-463597200,1),(378,-450295200,2),(378,-431542800,1),(378,-418240800,2),(378,-400093200,1),(378,-384372000,2),(378,-368643600,1),(378,-352922400,2),(378,-337194000,1),(378,-321472800,2),(378,-305744400,1),(378,-289418400,2),(378,-273690000,1),(378,-257968800,2),(378,-242240400,1),(378,-226519200,2),(378,-210790800,1),(378,-195069600,2),(378,-179341200,1),(378,-163620000,2),(378,-147891600,1),(378,-131565600,2),(378,-116442000,1),(378,-100116000,2),(378,-84387600,1),(378,-68666400,2),(378,-52938000,1),(378,-37216800,2),(378,-21488400,1),(378,-5767200,2),(378,9961200,1),(378,25682400,2),(378,41410800,1),(378,57736800,2),(378,73465200,1),(378,89186400,2),(378,104914800,1),(378,120636000,2),(378,136364400,1),(378,152085600,2),(378,167814000,1),(378,183535200,2),(378,199263600,1),(378,215589600,2),(378,230713200,1),(378,247039200,2),(378,262767600,1),(378,278488800,2),(378,294217200,1),(378,309938400,2),(378,325666800,1),(378,341388000,2),(378,357116400,1),(378,372837600,2),(378,388566000,1),(378,404892000,2),(378,420015600,1),(378,436341600,2),(378,452070000,1),(378,467791200,2),(378,483519600,1),(378,499240800,2),(378,514969200,1),(378,530690400,2),(378,544604400,1),(378,562140000,2),(378,576054000,1),(378,594194400,2),(378,607503600,1),(378,625644000,2),(378,638953200,1),(378,657093600,2),(378,671007600,1),(378,688543200,2),(378,702457200,1),(378,719992800,2),(378,733906800,1),(378,752047200,2),(378,765356400,1),(378,783496800,2),(378,796806000,1),(378,814946400,2),(378,828860400,1),(378,846396000,2),(378,860310000,1),(378,877845600,2),(378,891759600,1),(378,909295200,2),(378,923209200,1),(378,941349600,2),(378,954658800,1),(378,972799200,2),(378,986108400,1),(378,1004248800,2),(378,1018162800,1),(378,1035698400,2),(378,1049612400,1),(378,1067148000,2),(378,1081062000,1),(378,1099202400,2),(378,1112511600,1),(378,1130652000,2),(378,1143961200,1),(378,1162101600,2),(378,1173596400,1),(378,1194156000,2),(378,1205046000,1),(378,1225605600,2),(378,1236495600,1),(378,1257055200,2),(378,1268550000,1),(378,1289109600,2),(378,1299999600,1),(378,1320559200,2),(378,1331449200,1),(378,1352008800,2),(378,1362898800,1),(378,1383458400,2),(378,1394348400,1),(378,1414908000,2),(378,1425798000,1),(378,1446357600,2),(378,1457852400,1),(378,1478412000,2),(378,1489302000,1),(378,1509861600,2),(378,1520751600,1),(378,1541311200,2),(378,1552201200,1),(378,1572760800,2),(378,1583650800,1),(378,1604210400,2),(378,1615705200,1),(378,1636264800,2),(378,1647154800,1),(378,1667714400,2),(378,1678604400,1),(378,1699164000,2),(378,1710054000,1),(378,1730613600,2),(378,1741503600,1),(378,1762063200,2),(378,1772953200,1),(378,1793512800,2),(378,1805007600,1),(378,1825567200,2),(378,1836457200,1),(378,1857016800,2),(378,1867906800,1),(378,1888466400,2),(378,1899356400,1),(378,1919916000,2),(378,1930806000,1),(378,1951365600,2),(378,1962860400,1),(378,1983420000,2),(378,1994310000,1),(378,2014869600,2),(378,2025759600,1),(378,2046319200,2),(378,2057209200,1),(378,2077768800,2),(378,2088658800,1),(378,2109218400,2),(378,2120108400,1),(378,2140668000,2),(379,-2147483648,0),(379,-1998663968,2),(379,-1632063600,1),(379,-1615132800,2),(379,-1600614000,1),(379,-1596816000,2),(379,-1567954800,1),(379,-1551628800,2),(379,-1536505200,1),(379,-1523203200,2),(379,-1504450800,1),(379,-1491753600,2),(379,-1473001200,1),(379,-1459699200,2),(379,-880210800,3),(379,-769395600,4),(379,-765388800,2),(379,-715791600,1),(379,-702489600,2),(379,73472400,1),(379,89193600,2),(379,104922000,1),(379,120643200,2),(379,136371600,1),(379,152092800,2),(379,167821200,1),(379,183542400,2),(379,199270800,1),(379,215596800,2),(379,230720400,1),(379,247046400,2),(379,262774800,1),(379,278496000,2),(379,294224400,1),(379,309945600,2),(379,325674000,1),(379,341395200,2),(379,357123600,1),(379,372844800,2),(379,388573200,1),(379,404899200,2),(379,420022800,1),(379,436348800,2),(379,452077200,1),(379,467798400,2),(379,483526800,1),(379,499248000,2),(379,514976400,1),(379,530697600,2),(379,544611600,1),(379,562147200,2),(379,576061200,1),(379,594201600,2),(379,607510800,1),(379,625651200,2),(379,638960400,1),(379,657100800,2),(379,671014800,1),(379,688550400,2),(379,702464400,1),(379,720000000,2),(379,733914000,1),(379,752054400,2),(379,765363600,1),(379,783504000,2),(379,796813200,1),(379,814953600,2),(379,828867600,1),(379,846403200,2),(379,860317200,1),(379,877852800,2),(379,891766800,1),(379,909302400,2),(379,923216400,1),(379,941356800,2),(379,954666000,1),(379,972806400,2),(379,986115600,1),(379,1004256000,2),(379,1018170000,1),(379,1035705600,2),(379,1049619600,1),(379,1067155200,2),(379,1081069200,1),(379,1099209600,2),(379,1112518800,1),(379,1130659200,2),(379,1143968400,1),(379,1162108800,2),(379,1173603600,1),(379,1194163200,2),(379,1205053200,1),(379,1225612800,2),(379,1236502800,1),(379,1257062400,2),(379,1268557200,1),(379,1289116800,2),(379,1300006800,1),(379,1320566400,2),(379,1331456400,1),(379,1352016000,2),(379,1362906000,1),(379,1383465600,2),(379,1394355600,1),(379,1414915200,2),(379,1425805200,1),(379,1446364800,2),(379,1457859600,1),(379,1478419200,2),(379,1489309200,1),(379,1509868800,2),(379,1520758800,1),(379,1541318400,2),(379,1552208400,1),(379,1572768000,2),(379,1583658000,1),(379,1604217600,2),(379,1615712400,1),(379,1636272000,2),(379,1647162000,1),(379,1667721600,2),(379,1678611600,1),(379,1699171200,2),(379,1710061200,1),(379,1730620800,2),(379,1741510800,1),(379,1762070400,2),(379,1772960400,1),(379,1793520000,2),(379,1805014800,1),(379,1825574400,2),(379,1836464400,1),(379,1857024000,2),(379,1867914000,1),(379,1888473600,2),(379,1899363600,1),(379,1919923200,2),(379,1930813200,1),(379,1951372800,2),(379,1962867600,1),(379,1983427200,2),(379,1994317200,1),(379,2014876800,2),(379,2025766800,1),(379,2046326400,2),(379,2057216400,1),(379,2077776000,2),(379,2088666000,1),(379,2109225600,2),(379,2120115600,1),(379,2140675200,2),(380,-2147483648,2),(380,-1664130548,1),(380,-1650137348,2),(380,-1632076148,1),(380,-1615145348,2),(380,-1598650148,1),(380,-1590100148,2),(380,-1567286948,1),(380,-1551565748,2),(380,-1535837348,1),(380,-1520116148,2),(380,-1503782948,1),(380,-1488666548,2),(380,-1472333348,1),(380,-1457216948,2),(380,-1440883748,1),(380,-1425767348,2),(380,-1409434148,1),(380,-1394317748,2),(380,-1377984548,1),(380,-1362263348,2),(380,-1346534948,1),(380,-1330813748,2),(380,-1314480548,1),(380,-1299364148,2),(380,-1283030948,1),(380,-1267914548,2),(380,-1251581348,1),(380,-1236464948,2),(380,-1220131748,1),(380,-1205015348,2),(380,-1188682148,1),(380,-1172960948,2),(380,-1156627748,1),(380,-1141511348,2),(380,-1125178148,1),(380,-1110061748,2),(380,-1096921748,4),(380,-1093728600,3),(380,-1078612200,4),(380,-1061670600,3),(380,-1048973400,4),(380,-1030221000,3),(380,-1017523800,4),(380,-998771400,3),(380,-986074200,4),(380,-966717000,3),(380,-954624600,4),(380,-935267400,3),(380,-922570200,4),(380,-903817800,3),(380,-891120600,4),(380,-872368200,6),(380,-769395600,5),(380,-765401400,4),(380,-746044200,3),(380,-733347000,4),(380,-714594600,3),(380,-701897400,4),(380,-683145000,3),(380,-670447800,4),(380,-651695400,3),(380,-638998200,4),(380,-619641000,3),(380,-606943800,4),(380,-589401000,3),(380,-576099000,4),(380,-557951400,3),(380,-544649400,4),(380,-526501800,3),(380,-513199800,4),(380,-495052200,3),(380,-481750200,4),(380,-463602600,3),(380,-450300600,4),(380,-431548200,3),(380,-418246200,4),(380,-400098600,3),(380,-386796600,4),(380,-368649000,3),(380,-355347000,4),(380,-337199400,3),(380,-323897400,4),(380,-305749800,3),(380,-289423800,4),(380,-273695400,3),(380,-257974200,4),(380,-242245800,3),(380,-226524600,4),(380,-210796200,3),(380,-195075000,4),(380,-179346600,3),(380,-163625400,4),(380,-147897000,3),(380,-131571000,4),(380,-116447400,3),(380,-100121400,4),(380,-84393000,3),(380,-68671800,4),(380,-52943400,3),(380,-37222200,4),(380,-21493800,3),(380,-5772600,4),(380,9955800,3),(380,25677000,4),(380,41405400,3),(380,57731400,4),(380,73459800,3),(380,89181000,4),(380,104909400,3),(380,120630600,4),(380,136359000,3),(380,152080200,4),(380,167808600,3),(380,183529800,4),(380,199258200,3),(380,215584200,4),(380,230707800,3),(380,247033800,4),(380,262762200,3),(380,278483400,4),(380,294211800,3),(380,309933000,4),(380,325661400,3),(380,341382600,4),(380,357111000,3),(380,372832200,4),(380,388560600,3),(380,404886600,4),(380,420010200,3),(380,436336200,4),(380,452064600,3),(380,467785800,4),(380,483514200,3),(380,499235400,4),(380,514963800,3),(380,530685000,4),(380,544591860,3),(380,562127460,4),(380,576041460,7),(380,594178260,4),(380,607491060,3),(380,625631460,4),(380,638940660,3),(380,657081060,4),(380,670995060,3),(380,688530660,4),(380,702444660,3),(380,719980260,4),(380,733894260,3),(380,752034660,4),(380,765343860,3),(380,783484260,4),(380,796793460,3),(380,814933860,4),(380,828847860,3),(380,846383460,4),(380,860297460,3),(380,877833060,4),(380,891747060,3),(380,909282660,4),(380,923196660,3),(380,941337060,4),(380,954646260,3),(380,972786660,4),(380,986095860,3),(380,1004236260,4),(380,1018150260,3),(380,1035685860,4),(380,1049599860,3),(380,1067135460,4),(380,1081049460,3),(380,1099189860,4),(380,1112499060,3),(380,1130639460,4),(380,1143948660,3),(380,1162089060,4),(380,1173583860,3),(380,1194143460,4),(380,1205033460,3),(380,1225593060,4),(380,1236483060,3),(380,1257042660,4),(380,1268537460,3),(380,1289097060,4),(380,1299987060,3),(380,1320553800,4),(380,1331443800,3),(380,1352003400,4),(380,1362893400,3),(380,1383453000,4),(380,1394343000,3),(380,1414902600,4),(380,1425792600,3),(380,1446352200,4),(380,1457847000,3),(380,1478406600,4),(380,1489296600,3),(380,1509856200,4),(380,1520746200,3),(380,1541305800,4),(380,1552195800,3),(380,1572755400,4),(380,1583645400,3),(380,1604205000,4),(380,1615699800,3),(380,1636259400,4),(380,1647149400,3),(380,1667709000,4),(380,1678599000,3),(380,1699158600,4),(380,1710048600,3),(380,1730608200,4),(380,1741498200,3),(380,1762057800,4),(380,1772947800,3),(380,1793507400,4),(380,1805002200,3),(380,1825561800,4),(380,1836451800,3),(380,1857011400,4),(380,1867901400,3),(380,1888461000,4),(380,1899351000,3),(380,1919910600,4),(380,1930800600,3),(380,1951360200,4),(380,1962855000,3),(380,1983414600,4),(380,1994304600,3),(380,2014864200,4),(380,2025754200,3),(380,2046313800,4),(380,2057203800,3),(380,2077763400,4),(380,2088653400,3),(380,2109213000,4),(380,2120103000,3),(380,2140662600,4),(381,-2147483648,2),(381,-1632060000,1),(381,-1615129200,2),(381,-880207200,3),(381,-769395600,4),(381,-765385200,2),(381,-747237600,1),(381,-733935600,2),(381,-715788000,1),(381,-702486000,2),(381,-684338400,1),(381,-671036400,2),(381,-652888800,1),(381,-639586800,2),(381,-620834400,1),(381,-608137200,2),(381,-589384800,1),(381,-576082800,2),(381,-557935200,1),(381,-544633200,2),(381,-526485600,1),(381,-513183600,2),(381,-495036000,1),(381,-481734000,2),(381,-463586400,1),(381,-450284400,2),(381,-431532000,1),(381,-418230000,2),(381,-400082400,1),(381,-386780400,2),(381,-368632800,1),(381,-355330800,2),(381,-337183200,1),(381,-323881200,2),(381,-305733600,1),(381,-292431600,2),(381,-273679200,1),(381,-260982000,2),(381,-242229600,1),(381,-226508400,2),(381,-210780000,1),(381,-195058800,2),(381,-179330400,1),(381,-163609200,2),(381,-147880800,1),(381,-131554800,2),(381,-116431200,1),(381,-100105200,2),(381,-84376800,1),(381,-68655600,2),(381,-52927200,1),(381,-37206000,2),(381,-21477600,1),(381,-5756400,2),(381,9972000,1),(381,25693200,2),(381,41421600,1),(381,57747600,2),(381,73476000,1),(381,89197200,2),(381,104925600,1),(381,120646800,2),(381,136375200,1),(381,152096400,2),(381,167824800,1),(381,183546000,2),(381,199274400,1),(381,215600400,2),(381,230724000,1),(381,247050000,2),(381,262778400,1),(381,278499600,2),(381,294228000,1),(381,309949200,2),(381,325677600,1),(381,341398800,2),(381,357127200,1),(381,372848400,2),(381,388576800,1),(381,404902800,2),(381,420026400,1),(381,436352400,2),(381,452080800,1),(381,467802000,2),(381,483530400,1),(381,499251600,2),(381,514980000,1),(381,530701200,2),(381,544615200,1),(381,562150800,2),(381,576064800,1),(381,594205200,2),(381,607514400,1),(381,625654800,2),(381,638964000,1),(381,657104400,2),(381,671018400,1),(381,688554000,2),(381,702468000,1),(381,720003600,2),(381,733917600,1),(381,752058000,2),(381,765367200,1),(381,783507600,2),(381,796816800,1),(381,814957200,2),(381,828871200,1),(381,846406800,2),(381,860320800,1),(381,877856400,2),(381,891770400,1),(381,909306000,2),(381,923220000,1),(381,941360400,2),(381,954669600,1),(381,972810000,2),(381,986119200,1),(381,1004259600,2),(381,1018173600,1),(381,1035709200,2),(381,1049623200,1),(381,1067158800,2),(381,1081072800,1),(381,1099213200,2),(381,1112522400,1),(381,1130662800,2),(381,1143972000,1),(381,1162112400,2),(381,1173607200,1),(381,1194166800,2),(381,1205056800,1),(381,1225616400,2),(381,1236506400,1),(381,1257066000,2),(381,1268560800,1),(381,1289120400,2),(381,1300010400,1),(381,1320570000,2),(381,1331460000,1),(381,1352019600,2),(381,1362909600,1),(381,1383469200,2),(381,1394359200,1),(381,1414918800,2),(381,1425808800,1),(381,1446368400,2),(381,1457863200,1),(381,1478422800,2),(381,1489312800,1),(381,1509872400,2),(381,1520762400,1),(381,1541322000,2),(381,1552212000,1),(381,1572771600,2),(381,1583661600,1),(381,1604221200,2),(381,1615716000,1),(381,1636275600,2),(381,1647165600,1),(381,1667725200,2),(381,1678615200,1),(381,1699174800,2),(381,1710064800,1),(381,1730624400,2),(381,1741514400,1),(381,1762074000,2),(381,1772964000,1),(381,1793523600,2),(381,1805018400,1),(381,1825578000,2),(381,1836468000,1),(381,1857027600,2),(381,1867917600,1),(381,1888477200,2),(381,1899367200,1),(381,1919926800,2),(381,1930816800,1),(381,1951376400,2),(381,1962871200,1),(381,1983430800,2),(381,1994320800,1),(381,2014880400,2),(381,2025770400,1),(381,2046330000,2),(381,2057220000,1),(381,2077779600,2),(381,2088669600,1),(381,2109229200,2),(381,2120119200,1),(381,2140678800,2),(382,-2147483648,0),(382,-2030202084,2),(382,-1632063600,1),(382,-1615132800,2),(382,-1251651600,1),(382,-1238349600,2),(382,-1220202000,1),(382,-1206900000,2),(382,-1188752400,1),(382,-1175450400,2),(382,-1156698000,1),(382,-1144000800,2),(382,-1125248400,1),(382,-1111946400,2),(382,-1032714000,1),(382,-1016992800,2),(382,-1001264400,1),(382,-986148000,2),(382,-969814800,1),(382,-954093600,2),(382,-937760400,1),(382,-922039200,2),(382,-906310800,1),(382,-890589600,2),(382,-880210800,3),(382,-769395600,4),(382,-765388800,2),(382,-748450800,1),(382,-732729600,2),(382,-715791600,1),(382,-702489600,2),(382,-684342000,1),(382,-671040000,2),(382,-652892400,1),(382,-639590400,2),(382,-620838000,1),(382,-608140800,2),(382,-589388400,1),(382,-576086400,2),(382,-557938800,1),(382,-544636800,2),(382,-526489200,1),(382,-513187200,2),(382,-495039600,1),(382,-481737600,2),(382,-463590000,1),(382,-450288000,2),(382,-431535600,1),(382,-418233600,2),(382,-400086000,1),(382,-386784000,2),(382,-337186800,1),(382,-321465600,2),(382,-305737200,5),(383,-2147483648,2),(383,-1632056400,1),(383,-1615125600,2),(383,-1596978000,1),(383,-1583164800,2),(383,-880203600,3),(383,-769395600,4),(383,-765381600,2),(383,-147884400,5),(383,-131554800,2),(383,-121273200,6),(383,325677600,7),(383,341398800,6),(383,357127200,7),(383,372848400,6),(383,388576800,7),(383,404902800,6),(383,420026400,7),(383,436352400,6),(383,452080800,7),(383,467802000,6),(383,483530400,7),(383,499251600,6),(383,514980000,7),(383,530701200,6),(383,544615200,7),(383,562150800,6),(383,576064800,7),(383,594205200,6),(383,607514400,7),(383,625654800,6),(383,638964000,7),(383,657104400,6),(383,671018400,7),(383,688554000,6),(383,702468000,7),(383,720003600,6),(383,733917600,7),(383,752058000,6),(383,765367200,7),(383,783507600,6),(383,796816800,7),(383,814957200,6),(383,828871200,7),(383,846406800,6),(383,860320800,7),(383,877856400,6),(383,891770400,7),(383,909306000,6),(383,923220000,7),(383,941360400,6),(383,954669600,7),(383,972810000,6),(383,986119200,7),(383,1004259600,6),(383,1018173600,7),(383,1035709200,6),(383,1049623200,7),(383,1067158800,6),(383,1081072800,7),(383,1099213200,6),(383,1112522400,7),(383,1130662800,6),(383,1143972000,7),(383,1162112400,6),(383,1173607200,7),(383,1194166800,6),(383,1205056800,7),(383,1225616400,6),(383,1236506400,7),(383,1257066000,6),(383,1268560800,7),(383,1289120400,6),(383,1300010400,7),(383,1320570000,6),(383,1331460000,7),(383,1352019600,6),(383,1362909600,7),(383,1383469200,6),(383,1394359200,7),(383,1414918800,6),(383,1425808800,7),(383,1446368400,6),(383,1457863200,7),(383,1478422800,6),(383,1489312800,7),(383,1509872400,6),(383,1520762400,7),(383,1541322000,6),(383,1552212000,7),(383,1572771600,6),(383,1583661600,7),(383,1604214000,8),(384,-2147483648,1),(384,-1892661435,2),(384,-1688410800,1),(384,-1619205435,3),(384,-1593806400,1),(384,-1335986235,4),(384,-1317585600,2),(384,-1304362800,4),(384,-1286049600,2),(384,-1272826800,4),(384,-1254513600,2),(384,-1241290800,4),(384,-1222977600,2),(384,-1209754800,4),(384,-1191355200,2),(384,-1178132400,3),(384,-870552000,2),(384,-865278000,3),(384,-740520000,5),(384,-736635600,4),(384,-718056000,2),(384,-713649600,3),(384,-36619200,6),(384,-23922000,7),(384,-3355200,6),(384,7527600,7),(384,24465600,6),(384,37767600,7),(384,55915200,6),(384,69217200,7),(384,87969600,6),(384,100666800,7),(384,118209600,6),(384,132116400,7),(384,150868800,6),(384,163566000,7),(384,182318400,6),(384,195620400,7),(384,213768000,6),(384,227070000,7),(384,245217600,6),(384,258519600,7),(384,277272000,6),(384,289969200,7),(384,308721600,6),(384,321418800,7),(384,340171200,6),(384,353473200,7),(384,371620800,6),(384,384922800,7),(384,403070400,6),(384,416372400,7),(384,434520000,6),(384,447822000,7),(384,466574400,6),(384,479271600,7),(384,498024000,6),(384,510721200,7),(384,529473600,6),(384,545194800,7),(384,560923200,6),(384,574225200,7),(384,592372800,6),(384,605674800,7),(384,624427200,6),(384,637124400,7),(384,653457600,6),(384,668574000,7),(384,687326400,6),(384,700628400,7),(384,718776000,6),(384,732078000,7),(384,750225600,6),(384,763527600,7),(384,781675200,6),(384,794977200,7),(384,813729600,6),(384,826426800,7),(384,845179200,6),(384,859690800,7),(384,876628800,6),(384,889930800,7),(384,906868800,6),(384,923194800,7),(384,939528000,6),(384,952830000,7),(384,971582400,6),(384,984279600,7),(384,1003032000,6),(384,1015729200,7),(384,1034481600,6),(384,1047178800,7),(384,1065931200,6),(384,1079233200,7),(384,1097380800,6),(384,1110682800,7),(384,1128830400,6),(384,1142132400,7),(384,1160884800,6),(384,1173582000,7),(384,1192334400,6),(384,1206846000,7),(384,1223784000,6),(384,1237086000,7),(384,1255233600,6),(384,1270350000,7),(384,1286683200,6),(384,1304823600,7),(384,1313899200,6),(384,1335668400,7),(384,1346558400,6),(384,1367118000,7),(384,1378612800,6),(384,1398567600,7),(384,1410062400,6),(384,1463281200,7),(384,1471147200,6),(384,1494730800,7),(384,1502596800,6),(384,1526180400,7),(384,1534046400,6),(384,1554606000,7),(384,1567915200,6),(384,1586055600,7),(384,1599364800,6),(384,1617505200,7),(384,1630814400,6),(384,1648954800,7),(384,1662868800,6),(384,1680404400,7),(384,1693713600,6),(384,1712458800,7),(384,1725768000,6),(384,1743908400,7),(384,1757217600,6),(384,1775358000,7),(384,1788667200,6),(384,1806807600,7),(384,1820116800,6),(384,1838257200,7),(384,1851566400,6),(384,1870311600,7),(384,1883016000,6),(384,1901761200,7),(384,1915070400,6),(384,1933210800,7),(384,1946520000,6),(384,1964660400,7),(384,1977969600,6),(384,1996110000,7),(384,2009419200,6),(384,2027559600,7),(384,2040868800,6),(384,2059614000,7),(384,2072318400,6),(384,2091063600,7),(384,2104372800,6),(384,2122513200,7),(384,2135822400,6),(384,2147483647,6),(385,-2147483648,1),(385,-1178124152,4),(385,-36619200,2),(385,-23922000,3),(385,-3355200,2),(385,7527600,3),(385,24465600,2),(385,37767600,3),(385,55915200,2),(385,69217200,3),(385,87969600,2),(385,100666800,3),(385,118209600,2),(385,132116400,3),(385,150868800,2),(385,163566000,3),(385,182318400,2),(385,195620400,3),(385,213768000,2),(385,227070000,3),(385,245217600,2),(385,258519600,3),(385,277272000,2),(385,289969200,3),(385,308721600,2),(385,321418800,3),(385,340171200,2),(385,353473200,3),(385,371620800,2),(385,384922800,5),(385,403070400,6),(385,416372400,5),(385,434520000,6),(385,447822000,5),(385,466574400,6),(385,479271600,5),(385,498024000,6),(385,510721200,5),(385,529473600,6),(385,545194800,5),(385,560923200,6),(385,574225200,5),(385,592372800,6),(385,605674800,5),(385,624427200,6),(385,637124400,5),(385,653457600,6),(385,668574000,5),(385,687326400,6),(385,700628400,5),(385,718776000,6),(385,732078000,5),(385,750225600,6),(385,763527600,5),(385,781675200,6),(385,794977200,5),(385,813729600,6),(385,826426800,5),(385,845179200,6),(385,859690800,5),(385,876628800,6),(385,889930800,5),(385,906868800,6),(385,923194800,5),(385,939528000,6),(385,952830000,5),(385,971582400,6),(385,984279600,5),(385,1003032000,6),(385,1015729200,5),(385,1034481600,6),(385,1047178800,5),(385,1065931200,6),(385,1079233200,5),(385,1097380800,6),(385,1110682800,5),(385,1128830400,6),(385,1142132400,5),(385,1160884800,6),(385,1173582000,5),(385,1192334400,6),(385,1206846000,5),(385,1223784000,6),(385,1237086000,5),(385,1255233600,6),(385,1270350000,5),(385,1286683200,6),(385,1304823600,5),(385,1313899200,6),(385,1335668400,5),(385,1346558400,6),(385,1367118000,5),(385,1378612800,6),(385,1398567600,5),(385,1410062400,6),(385,1463281200,5),(385,1471147200,6),(385,1494730800,5),(385,1502596800,6),(385,1526180400,5),(385,1534046400,6),(385,1554606000,5),(385,1567915200,6),(385,1586055600,5),(385,1599364800,6),(385,1617505200,5),(385,1630814400,6),(385,1648954800,5),(385,1662868800,6),(385,1680404400,5),(385,1693713600,6),(385,1712458800,5),(385,1725768000,6),(385,1743908400,5),(385,1757217600,6),(385,1775358000,5),(385,1788667200,6),(385,1806807600,5),(385,1820116800,6),(385,1838257200,5),(385,1851566400,6),(385,1870311600,5),(385,1883016000,6),(385,1901761200,5),(385,1915070400,6),(385,1933210800,5),(385,1946520000,6),(385,1964660400,5),(385,1977969600,6),(385,1996110000,5),(385,2009419200,6),(385,2027559600,5),(385,2040868800,6),(385,2059614000,5),(385,2072318400,6),(385,2091063600,5),(385,2104372800,6),(385,2122513200,5),(385,2135822400,6),(385,2147483647,6),(386,-2147483648,1),(386,-1402813824,3),(386,-1311534000,2),(386,-1300996800,3),(386,-933534000,2),(386,-925675200,3),(386,-902084400,2),(386,-893620800,3),(386,-870030000,2),(386,-862171200,3),(386,-775681200,2),(386,-767822400,3),(386,-744231600,2),(386,-736372800,3),(386,-144702000,2),(386,-134251200,3),(386,-113425200,2),(386,-102542400,3),(386,-86295600,2),(386,-72907200,3),(386,-54154800,2),(386,-41457600,3),(386,-21495600,2),(386,-5774400,3),(386,9954000,2),(386,25675200,3),(386,41403600,2),(386,57729600,3),(386,73458000,2),(386,87364800,3),(386,104907600,2),(386,118900800,3),(386,136357200,2),(386,150436800,3),(386,167806800,2),(386,183528000,3),(386,199256400,2),(386,215582400,3),(386,230706000,2),(386,247032000,3),(386,263365200,2),(386,276667200,3),(386,290581200,2),(386,308721600,3),(386,322030800,2),(386,340171200,3),(386,358318800,2),(386,371620800,3),(386,389768400,2),(386,403070400,3),(386,421218000,2),(386,434520000,3),(386,452667600,2),(386,466574400,3),(386,484117200,2),(386,498024000,3),(386,511333200,2),(386,529473600,3),(386,542782800,2),(386,560923200,3),(386,574837200,2),(386,592372800,3),(386,606286800,2),(386,623822400,3),(386,638946000,2),(386,655876800,3),(386,671000400,2),(386,687330000,4),(386,702450000,2),(386,718779600,4),(386,733899600,2),(386,750229200,4),(386,765349200,2),(386,781678800,4),(386,796798800,2),(386,813128400,4),(386,828853200,2),(386,844578000,4),(386,860302800,2),(386,876632400,4),(386,891147600,5),(386,909291600,4),(386,922597200,5),(386,941346000,4),(386,954651600,5),(386,972795600,4),(386,986101200,5),(386,1004245200,4),(386,1018155600,5),(386,1035694800,4),(386,1049605200,5),(386,1067144400,4),(386,1080450000,5),(386,1162098000,4),(386,1173589200,5),(386,1193547600,4),(386,1205643600,5),(386,1224997200,4),(386,1236488400,5),(386,1256446800,4),(386,1268542800,5),(386,1288501200,4),(386,1300597200,5),(386,1321160400,4),(386,1333256400,5),(386,1352005200,4),(386,1362891600,5),(386,1383454800,4),(386,1394341200,5),(386,1414904400,4),(386,1425790800,5),(386,1446354000,4),(386,1457845200,5),(386,1478408400,4),(386,1489294800,5),(386,1509858000,4),(386,1520744400,5),(386,1541307600,4),(386,1552194000,5),(386,1572757200,4),(386,1583643600,5),(386,1604206800,4),(386,1615698000,5),(386,1636261200,4),(386,1647147600,5),(386,1667710800,4),(386,1678597200,5),(386,1699160400,4),(386,1710046800,5),(386,1730610000,4),(386,1741496400,5),(386,1762059600,4),(386,1772946000,5),(386,1793509200,4),(386,1805000400,5),(386,1825563600,4),(386,1836450000,5),(386,1857013200,4),(386,1867899600,5),(386,1888462800,4),(386,1899349200,5),(386,1919912400,4),(386,1930798800,5),(386,1951362000,4),(386,1962853200,5),(386,1983416400,4),(386,1994302800,5),(386,2014866000,4),(386,2025752400,5),(386,2046315600,4),(386,2057202000,5),(386,2077765200,4),(386,2088651600,5),(386,2109214800,4),(386,2120101200,5),(386,2140664400,4),(387,228877200,0),(387,243997200,1),(387,260326800,0),(387,276051600,1),(387,291776400,0),(387,307501200,1),(387,323830800,0),(387,338950800,1),(387,354675600,0),(387,370400400,1),(387,386125200,0),(387,401850000,1),(387,417574800,0),(387,433299600,1),(387,449024400,0),(387,465354000,1),(387,481078800,0),(387,496803600,1),(387,512528400,0),(387,528253200,1),(387,543978000,0),(387,559702800,1),(387,575427600,0),(387,591152400,1),(387,606877200,0),(387,622602000,1),(387,638326800,0),(387,654656400,1),(387,670381200,0),(387,686106000,1),(387,701830800,0),(387,717555600,1),(387,733280400,0),(387,749005200,1),(387,764730000,0),(387,780454800,1),(387,796179600,0),(387,811904400,1),(387,828234000,0),(387,846378000,1),(387,859683600,0),(387,877827600,1),(387,891133200,0),(387,909277200,1),(387,922582800,0),(387,941331600,1),(387,954032400,0),(387,972781200,1),(387,985482000,0),(387,1004230800,1),(387,1017536400,0),(387,1035680400,1),(387,1048986000,0),(387,1067130000,1),(387,1080435600,0),(387,1099184400,1),(387,1111885200,0),(387,1130634000,1),(387,1143334800,0),(387,1162083600,1),(387,1174784400,0),(387,1193533200,1),(387,1206838800,0),(387,1224982800,1),(387,1238288400,0),(387,1256432400,1),(387,1269738000,0),(387,1288486800,1),(387,1301187600,0),(387,1319936400,1),(387,1332637200,0),(387,1351386000,1),(387,1364691600,0),(387,1382835600,1),(387,1396141200,0),(387,1414285200,1),(387,1427590800,0),(387,1445734800,1),(387,1459040400,0),(387,1477789200,1),(387,1490490000,0),(387,1509238800,1),(387,1521939600,0),(387,1540688400,1),(387,1553994000,0),(387,1572138000,1),(387,1585443600,0),(387,1603587600,1),(387,1616893200,0),(387,1635642000,1),(387,1648342800,0),(387,1667091600,1),(387,1679792400,0),(387,1698541200,1),(387,1711846800,0),(387,1729990800,1),(387,1743296400,0),(387,1761440400,1),(387,1774746000,0),(387,1792890000,1),(387,1806195600,0),(387,1824944400,1),(387,1837645200,0),(387,1856394000,1),(387,1869094800,0),(387,1887843600,1),(387,1901149200,0),(387,1919293200,1),(387,1932598800,0),(387,1950742800,1),(387,1964048400,0),(387,1982797200,1),(387,1995498000,0),(387,2014246800,1),(387,2026947600,0),(387,2045696400,1),(387,2058397200,0),(387,2077146000,1),(387,2090451600,0),(387,2108595600,1),(387,2121901200,0),(387,2140045200,1),(389,-1633280400,0),(389,-1615140000,1),(389,-1601830800,0),(389,-1583690400,1),(389,-880218000,2),(389,-769395600,3),(389,-765396000,1),(389,-84387600,0),(389,-68666400,1),(389,-52938000,0),(389,-37216800,1),(389,-21488400,0),(389,-5767200,1),(389,9961200,0),(389,25682400,1),(389,41410800,0),(389,57736800,1),(389,73465200,0),(389,89186400,1),(389,104914800,0),(389,120636000,1),(389,126687600,0),(389,152085600,1),(389,162370800,0),(389,183535200,1),(389,199263600,0),(389,215589600,1),(389,230713200,0),(389,247039200,1),(389,262767600,0),(389,278488800,1),(389,294217200,0),(389,309938400,1),(389,325666800,0),(389,341388000,1),(389,357116400,0),(389,372837600,1),(389,388566000,0),(389,404892000,1),(389,420015600,0),(389,436341600,1),(389,452070000,0),(389,467791200,1),(389,483519600,0),(389,499240800,1),(389,514969200,0),(389,530690400,1),(389,544604400,0),(389,562140000,1),(389,576054000,0),(389,594194400,1),(389,607503600,0),(389,625644000,1),(389,638953200,0),(389,657093600,1),(389,671007600,0),(389,688543200,1),(389,702457200,0),(389,719992800,1),(389,733906800,0),(389,752047200,1),(389,765356400,0),(389,783496800,1),(389,796806000,0),(389,814946400,1),(389,828860400,0),(389,846396000,1),(389,860310000,0),(389,877845600,1),(389,891759600,0),(389,909295200,1),(389,923209200,0),(389,941349600,1),(389,954658800,0),(389,972799200,1),(389,986108400,0),(389,1004248800,1),(389,1018162800,0),(389,1035698400,1),(389,1049612400,0),(389,1067148000,1),(389,1081062000,0),(389,1099202400,1),(389,1112511600,0),(389,1130652000,1),(389,1143961200,0),(389,1162101600,1),(389,1173596400,0),(389,1194156000,1),(389,1205046000,0),(389,1225605600,1),(389,1236495600,0),(389,1257055200,1),(389,1268550000,0),(389,1289109600,1),(389,1299999600,0),(389,1320559200,1),(389,1331449200,0),(389,1352008800,1),(389,1362898800,0),(389,1383458400,1),(389,1394348400,0),(389,1414908000,1),(389,1425798000,0),(389,1446357600,1),(389,1457852400,0),(389,1478412000,1),(389,1489302000,0),(389,1509861600,1),(389,1520751600,0),(389,1541311200,1),(389,1552201200,0),(389,1572760800,1),(389,1583650800,0),(389,1604210400,1),(389,1615705200,0),(389,1636264800,1),(389,1647154800,0),(389,1667714400,1),(389,1678604400,0),(389,1699164000,1),(389,1710054000,0),(389,1730613600,1),(389,1741503600,0),(389,1762063200,1),(389,1772953200,0),(389,1793512800,1),(389,1805007600,0),(389,1825567200,1),(389,1836457200,0),(389,1857016800,1),(389,1867906800,0),(389,1888466400,1),(389,1899356400,0),(389,1919916000,1),(389,1930806000,0),(389,1951365600,1),(389,1962860400,0),(389,1983420000,1),(389,1994310000,0),(389,2014869600,1),(389,2025759600,0),(389,2046319200,1),(389,2057209200,0),(389,2077768800,1),(389,2088658800,0),(389,2109218400,1),(389,2120108400,0),(389,2140668000,1),(390,-2147483648,2),(390,-929844000,1),(390,-923108400,2),(390,-906170400,1),(390,-892868400,2),(390,-875844000,1),(390,-857790000,2),(390,-844308000,1),(390,-825822000,2),(390,-812685600,1),(390,-794199600,2),(390,-779853600,1),(390,-762663600,2),(390,-399088800,1),(390,-386650800,2),(390,-368330400,1),(390,-355114800,2),(390,-336790800,1),(390,-323654400,2),(390,-305168400,1),(390,-292032000,2),(390,-273632400,1),(390,-260496000,2),(390,-242096400,1),(390,-228960000,2),(390,-210560400,1),(390,-197424000,2),(390,-178938000,1),(390,-165801600,2),(390,-147402000,1),(390,-134265600,2),(390,-115866000,1),(390,-102643200,2),(390,-84330000,1),(390,-71107200,2),(390,-52707600,1),(390,-39484800,2),(390,-21171600,1),(390,-7948800,2),(390,10364400,1),(390,23587200,2),(390,41900400,1),(390,55123200,2),(390,73522800,1),(390,86745600,2),(390,105058800,1),(390,118281600,2),(390,136594800,1),(390,149817600,2),(390,168130800,1),(390,181353600,2),(390,199753200,1),(390,212976000,2),(390,231289200,1),(390,244512000,2),(390,262825200,1),(390,276048000,2),(390,294361200,1),(390,307584000,2),(390,325983600,1),(390,339206400,2),(390,357519600,1),(390,370742400,2),(390,396399600,1),(390,402278400,2),(390,426812400,1),(390,433814400,2),(390,452214000,1),(390,465436800,2),(390,483750000,1),(390,496972800,2),(390,515286000,1),(390,528508800,2),(390,546822000,1),(390,560044800,2),(390,578444400,1),(390,591667200,2),(390,610412400,1),(390,623203200,2),(390,641516400,1),(390,654739200,2),(390,673052400,1),(390,686275200,2),(390,704674800,1),(390,717897600,2),(390,736210800,1),(390,749433600,2),(390,767746800,1),(390,780969600,2),(390,799020000,3),(390,812322000,2),(390,830469600,3),(390,843771600,2),(390,861919200,3),(390,875221200,2),(390,893368800,3),(390,906670800,2),(390,925423200,3),(390,938725200,2),(390,956872800,3),(390,970174800,2),(390,988322400,3),(390,1001624400,2),(390,1019772000,3),(390,1033074000,2),(390,1051221600,3),(390,1064523600,2),(390,1083276000,3),(390,1096578000,2),(390,1114725600,3),(390,1128027600,2),(390,1146175200,3),(390,1158872400,2),(390,1177624800,3),(390,1189112400,2),(390,1209074400,3),(390,1219957200,2),(390,1240524000,3),(390,1250802000,2),(390,1272578400,3),(390,1281474000,2),(390,1284069600,1),(390,1285880400,2),(390,1400191200,1),(390,1403816400,2),(390,1406844000,1),(390,1411678800,2),(390,1682632800,1),(390,1698354000,2),(390,1714082400,1),(390,1730408400,2),(390,1745532000,1),(390,1761858000,2),(390,1776981600,1),(390,1793307600,2),(390,1809036000,1),(390,1824757200,2),(390,1840485600,1),(390,1856206800,2),(390,1871935200,1),(390,1887656400,2),(390,1903384800,1),(390,1919710800,2),(390,1934834400,1),(390,1951160400,2),(390,1966888800,1),(390,1982610000,2),(390,1998338400,1),(390,2014059600,2),(390,2029788000,1),(390,2045509200,2),(390,2061237600,1),(390,2076958800,2),(390,2092687200,1),(390,2109013200,2),(390,2124136800,1),(390,2140462800,2),(391,-2147483648,1),(391,-1691962479,2),(391,-1680471279,4),(391,-1664143200,3),(391,-1650146400,4),(391,-1633903200,3),(391,-1617487200,4),(391,-1601848800,3),(391,-1586037600,4),(391,-1570399200,3),(391,-1552168800,4),(391,-1538344800,3),(391,-1522533600,4),(391,-1517011200,6),(391,-1507500000,5),(391,-1490565600,4),(391,-1473631200,5),(391,-1460930400,4),(391,-1442786400,5),(391,-1428876000,4),(391,-1410732000,5),(391,-1396216800,4),(391,-1379282400,5),(391,-1364767200,4),(391,-1348437600,5),(391,-1333317600,4),(391,-1315778400,5),(391,-1301263200,4),(391,-1284328800,5),(391,-1269813600,4),(391,-1253484000,5),(391,-1238364000,4),(391,-1221429600,5),(391,-1206914400,4),(391,-1189980000,5),(391,-1175464800,4),(391,-1159135200,5),(391,-1143410400,4),(391,-1126476000,5),(391,-1111960800,4),(391,-1095631200,5),(391,-1080511200,4),(391,-1063576800,5),(391,-1049061600,4),(391,-1032127200,5),(391,-1017612000,4),(391,-1001282400,5),(391,-986162400,4),(391,-969228000,5),(391,-950479200,4),(391,-942012000,5),(391,-733356000,4),(391,-719445600,5),(391,-699487200,4),(391,-684972000,5),(391,-668037600,4),(391,-654732000,5),(391,-636588000,4),(391,-622072800,5),(391,-605743200,4),(391,-590623200,5),(391,-574293600,4),(391,-558568800,5),(391,-542239200,4),(391,-527119200,5),(391,-512604000,4),(391,-496274400,5),(391,-481154400,4),(391,-464220000,5),(391,-449704800,4),(391,-432165600,5),(391,-417650400,4),(391,-401320800,5),(391,-386200800,4),(391,-369266400,5),(391,-354751200,4),(391,-337816800,5),(391,-323301600,4),(391,-306972000,5),(391,-291852000,4),(391,-276732000,5),(391,-257983200,4),(391,-245282400,5),(391,-226533600,4),(391,-213228000,5),(391,-195084000,4),(391,-182383200,5),(391,-163634400,4),(391,-150933600,5),(391,-132184800,4),(391,-119484000,5),(391,-100735200,4),(391,-88034400,5),(391,-68680800,4),(391,-59004000,5),(391,-37242000,7),(391,57722400,9),(391,69818400,5),(391,89172000,4),(391,101268000,5),(391,120621600,4),(391,132717600,5),(391,152071200,4),(391,164167200,5),(391,183520800,4),(391,196221600,5),(391,214970400,4),(391,227671200,5),(391,246420000,4),(391,259120800,5),(391,278474400,4),(391,290570400,5),(391,309924000,4),(391,322020000,5),(391,341373600,4),(391,354675600,8),(391,372819600,9),(391,386125200,8),(391,404269200,9),(391,417574800,8),(391,435718800,9),(391,449024400,8),(391,467773200,9),(391,481078800,8),(391,499222800,9),(391,512528400,8),(391,530672400,9),(391,543978000,8),(391,562122000,9),(391,575427600,8),(391,593571600,9),(391,606877200,8),(391,625626000,9),(391,638326800,8),(391,657075600,9),(391,670381200,8),(391,688525200,9),(391,701830800,8),(391,719974800,9),(391,733280400,8),(391,751424400,9),(391,764730000,8),(391,782874000,9),(391,796179600,8),(391,814323600,9),(391,820454400,6),(391,828234000,8),(391,846378000,9),(391,859683600,8),(391,877827600,9),(391,891133200,8),(391,909277200,9),(391,922582800,8),(391,941331600,9),(391,954032400,8),(391,972781200,9),(391,985482000,8),(391,1004230800,9),(391,1017536400,8),(391,1035680400,9),(391,1048986000,8),(391,1067130000,9),(391,1080435600,8),(391,1099184400,9),(391,1111885200,8),(391,1130634000,9),(391,1143334800,8),(391,1162083600,9),(391,1174784400,8),(391,1193533200,9),(391,1206838800,8),(391,1224982800,9),(391,1238288400,8),(391,1256432400,9),(391,1269738000,8),(391,1288486800,9),(391,1301187600,8),(391,1319936400,9),(391,1332637200,8),(391,1351386000,9),(391,1364691600,8),(391,1382835600,9),(391,1396141200,8),(391,1414285200,9),(391,1427590800,8),(391,1445734800,9),(391,1459040400,8),(391,1477789200,9),(391,1490490000,8),(391,1509238800,9),(391,1521939600,8),(391,1540688400,9),(391,1553994000,8),(391,1572138000,9),(391,1585443600,8),(391,1603587600,9),(391,1616893200,8),(391,1635642000,9),(391,1648342800,8),(391,1667091600,9),(391,1679792400,8),(391,1698541200,9),(391,1711846800,8),(391,1729990800,9),(391,1743296400,8),(391,1761440400,9),(391,1774746000,8),(391,1792890000,9),(391,1806195600,8),(391,1824944400,9),(391,1837645200,8),(391,1856394000,9),(391,1869094800,8),(391,1887843600,9),(391,1901149200,8),(391,1919293200,9),(391,1932598800,8),(391,1950742800,9),(391,1964048400,8),(391,1982797200,9),(391,1995498000,8),(391,2014246800,9),(391,2026947600,8),(391,2045696400,9),(391,2058397200,8),(391,2077146000,9),(391,2090451600,8),(391,2108595600,9),(391,2121901200,8),(391,2140045200,9),(394,-2147483648,0),(394,2147483647,0),(395,-2147483648,0),(395,2147483647,0),(396,-2147483648,0),(396,2147483647,0),(397,-2147483648,0),(397,2147483647,0),(398,-2147483648,0),(398,2147483647,0),(399,-2147483648,0),(399,2147483647,0),(400,-2147483648,0),(400,2147483647,0),(401,-2147483648,0),(401,2147483647,0),(402,-2147483648,0),(402,2147483647,0),(403,-2147483648,0),(403,2147483647,0),(404,-2147483648,0),(404,2147483647,0),(405,-2147483648,0),(405,2147483647,0),(407,-2147483648,0),(407,2147483647,0),(408,-2147483648,0),(408,2147483647,0),(409,-2147483648,0),(409,2147483647,0),(410,-2147483648,0),(410,2147483647,0),(411,-2147483648,0),(411,2147483647,0),(412,-2147483648,0),(412,2147483647,0),(413,-2147483648,0),(413,2147483647,0),(414,-2147483648,0),(414,2147483647,0),(415,-2147483648,0),(415,2147483647,0),(416,-2147483648,0),(416,2147483647,0),(417,-2147483648,0),(417,2147483647,0),(418,-2147483648,0),(418,2147483647,0),(419,-2147483648,0),(419,2147483647,0),(420,-2147483648,0),(420,2147483647,0),(427,-2147483648,1),(427,-1740355200,2),(427,-1693702800,5),(427,-1680483600,2),(427,-1663455600,3),(427,-1650150000,4),(427,-1632006000,3),(427,-1618700400,4),(427,-1613826000,8),(427,-1604278800,6),(427,-1585530000,7),(427,-1574038800,6),(427,-1552266000,7),(427,-1539997200,6),(427,-1520557200,7),(427,-1507510800,6),(427,-1490576400,7),(427,-1473642000,6),(427,-1459126800,7),(427,-1444006800,6),(427,-1427677200,7),(427,-1411952400,6),(427,-1396227600,7),(427,-1379293200,6),(427,-1364778000,7),(427,-1348448400,6),(427,-1333328400,7),(427,-1316394000,6),(427,-1301263200,7),(427,-1284328800,6),(427,-1269813600,7),(427,-1253484000,6),(427,-1238364000,7),(427,-1221429600,6),(427,-1206914400,7),(427,-1191189600,6),(427,-1175464800,7),(427,-1160344800,6),(427,-1143410400,7),(427,-1127685600,6),(427,-1111960800,7),(427,-1096840800,6),(427,-1080511200,7),(427,-1063576800,6),(427,-1049061600,7),(427,-1033336800,6),(427,-1017612000,7),(427,-1002492000,6),(427,-986162400,7),(427,-969228000,6),(427,-950479200,7),(427,-942012000,6),(427,-934668000,3),(427,-857257200,4),(427,-844556400,3),(427,-828226800,4),(427,-812502000,3),(427,-799293600,5),(427,-798073200,4),(427,-781052400,3),(427,-766623600,4),(427,-745455600,3),(427,-733273200,4),(427,220921200,2),(427,228877200,9),(427,243997200,10),(427,260326800,9),(427,276051600,10),(427,291776400,9),(427,307501200,10),(427,323830800,9),(427,338950800,10),(427,354675600,9),(427,370400400,10),(427,386125200,9),(427,401850000,10),(427,417574800,9),(427,433299600,10),(427,449024400,9),(427,465354000,10),(427,481078800,9),(427,496803600,10),(427,512528400,9),(427,528253200,10),(427,543978000,9),(427,559702800,10),(427,575427600,9),(427,591152400,10),(427,606877200,9),(427,622602000,10),(427,638326800,9),(427,654656400,10),(427,670381200,9),(427,686106000,10),(427,701830800,9),(427,717555600,10),(427,733280400,9),(427,749005200,10),(427,764730000,9),(427,780454800,10),(427,796179600,9),(427,811904400,10),(427,828234000,9),(427,846378000,10),(427,859683600,9),(427,877827600,10),(427,891133200,9),(427,909277200,10),(427,922582800,9),(427,941331600,10),(427,954032400,9),(427,972781200,10),(427,985482000,9),(427,1004230800,10),(427,1017536400,9),(427,1035680400,10),(427,1048986000,9),(427,1067130000,10),(427,1080435600,9),(427,1099184400,10),(427,1111885200,9),(427,1130634000,10),(427,1143334800,9),(427,1162083600,10),(427,1174784400,9),(427,1193533200,10),(427,1206838800,9),(427,1224982800,10),(427,1238288400,9),(427,1256432400,10),(427,1269738000,9),(427,1288486800,10),(427,1301187600,9),(427,1319936400,10),(427,1332637200,9),(427,1351386000,10),(427,1364691600,9),(427,1382835600,10),(427,1396141200,9),(427,1414285200,10),(427,1427590800,9),(427,1445734800,10),(427,1459040400,9),(427,1477789200,10),(427,1490490000,9),(427,1509238800,10),(427,1521939600,9),(427,1540688400,10),(427,1553994000,9),(427,1572138000,10),(427,1585443600,9),(427,1603587600,10),(427,1616893200,9),(427,1635642000,10),(427,1648342800,9),(427,1667091600,10),(427,1679792400,9),(427,1698541200,10),(427,1711846800,9),(427,1729990800,10),(427,1743296400,9),(427,1761440400,10),(427,1774746000,9),(427,1792890000,10),(427,1806195600,9),(427,1824944400,10),(427,1837645200,9),(427,1856394000,10),(427,1869094800,9),(427,1887843600,10),(427,1901149200,9),(427,1919293200,10),(427,1932598800,9),(427,1950742800,10),(427,1964048400,9),(427,1982797200,10),(427,1995498000,9),(427,2014246800,10),(427,2026947600,9),(427,2045696400,10),(427,2058397200,9),(427,2077146000,10),(427,2090451600,9),(427,2108595600,10),(427,2121901200,9),(427,2140045200,10),(428,-2147483648,1),(428,-733881600,2),(428,481078800,3),(428,496803600,4),(428,512528400,3),(428,528253200,4),(428,543978000,3),(428,559702800,4),(428,575427600,3),(428,591152400,4),(428,606877200,3),(428,622602000,4),(428,638326800,3),(428,654656400,4),(428,670381200,3),(428,686106000,4),(428,701830800,3),(428,717555600,4),(428,733280400,3),(428,749005200,4),(428,764730000,3),(428,780454800,4),(428,796179600,3),(428,811904400,4),(428,828234000,3),(428,846378000,4),(428,859683600,3),(428,877827600,4),(428,891133200,3),(428,909277200,4),(428,922582800,3),(428,941331600,4),(428,954032400,3),(428,972781200,4),(428,985482000,3),(428,1004230800,4),(428,1017536400,3),(428,1035680400,4),(428,1048986000,3),(428,1067130000,4),(428,1080435600,3),(428,1099184400,4),(428,1111885200,3),(428,1130634000,4),(428,1143334800,3),(428,1162083600,4),(428,1174784400,3),(428,1193533200,4),(428,1206838800,3),(428,1224982800,4),(428,1238288400,3),(428,1256432400,4),(428,1269738000,3),(428,1288486800,4),(428,1301187600,3),(428,1319936400,4),(428,1332637200,3),(428,1351386000,4),(428,1364691600,3),(428,1382835600,4),(428,1396141200,3),(428,1414285200,4),(428,1427590800,3),(428,1445734800,4),(428,1459040400,3),(428,1477789200,4),(428,1490490000,3),(428,1509238800,4),(428,1521939600,3),(428,1540688400,4),(428,1553994000,3),(428,1572138000,4),(428,1585443600,3),(428,1603587600,4),(428,1616893200,3),(428,1635642000,4),(428,1648342800,3),(428,1667091600,4),(428,1679792400,3),(428,1698541200,4),(428,1711846800,3),(428,1729990800,4),(428,1743296400,3),(428,1761440400,4),(428,1774746000,3),(428,1792890000,4),(428,1806195600,3),(428,1824944400,4),(428,1837645200,3),(428,1856394000,4),(428,1869094800,3),(428,1887843600,4),(428,1901149200,3),(428,1919293200,4),(428,1932598800,3),(428,1950742800,4),(428,1964048400,3),(428,1982797200,4),(428,1995498000,3),(428,2014246800,4),(428,2026947600,3),(428,2045696400,4),(428,2058397200,3),(428,2077146000,4),(428,2090451600,3),(428,2108595600,4),(428,2121901200,3),(428,2140045200,4),(429,-2147483648,0),(429,-1441249932,1),(429,-1247540400,3),(429,354916800,2),(429,370724400,3),(429,386452800,2),(429,402260400,3),(429,417988800,2),(429,433796400,3),(429,449611200,2),(429,465343200,4),(429,481068000,5),(429,496792800,4),(429,512517600,5),(429,528242400,4),(429,543967200,5),(429,559692000,4),(429,575416800,5),(429,591141600,4),(429,606866400,6),(429,622594800,7),(429,638319600,6),(429,654649200,7),(429,670374000,4),(429,701820000,6),(429,717548400,7),(429,733273200,6),(429,748998000,7),(429,764722800,6),(429,780447600,7),(429,796172400,6),(429,811897200,7),(429,828226800,6),(429,846370800,7),(429,859676400,6),(429,877820400,7),(429,891126000,6),(429,909270000,7),(429,922575600,6),(429,941324400,7),(429,954025200,6),(429,972774000,7),(429,985474800,6),(429,1004223600,7),(429,1017529200,6),(429,1035673200,7),(429,1048978800,6),(429,1067122800,7),(429,1080428400,6),(429,1099177200,7),(429,1111878000,6),(429,1130626800,7),(429,1143327600,6),(429,1162076400,7),(429,1174777200,6),(429,1193526000,7),(429,1206831600,6),(429,1224975600,7),(429,1238281200,6),(429,1256425200,7),(429,1269730800,6),(429,1288479600,7),(429,1301180400,4),(429,1414274400,7),(429,1459033200,4),(429,2147483647,4),(430,-2147483648,1),(430,-1686101632,3),(430,-1182996000,2),(430,-1178161200,3),(430,-906861600,2),(430,-904878000,5),(430,-857257200,4),(430,-844477200,5),(430,-828237600,4),(430,-812422800,3),(430,-552362400,2),(430,-541652400,3),(430,166485600,6),(430,186184800,7),(430,198028800,6),(430,213753600,7),(430,228873600,6),(430,244080000,7),(430,260323200,6),(430,275446800,3),(430,291798000,2),(430,307407600,3),(430,323388000,2),(430,338936400,3),(430,354675600,8),(430,370400400,9),(430,386125200,8),(430,401850000,9),(430,417574800,8),(430,433299600,9),(430,449024400,8),(430,465354000,9),(430,481078800,8),(430,496803600,9),(430,512528400,8),(430,528253200,9),(430,543978000,8),(430,559702800,9),(430,575427600,8),(430,591152400,9),(430,606877200,8),(430,622602000,9),(430,638326800,8),(430,654656400,9),(430,670381200,8),(430,686106000,9),(430,701830800,8),(430,717555600,9),(430,733280400,8),(430,749005200,9),(430,764730000,8),(430,780454800,9),(430,796179600,8),(430,811904400,9),(430,828234000,8),(430,846378000,9),(430,859683600,8),(430,877827600,9),(430,891133200,8),(430,909277200,9),(430,922582800,8),(430,941331600,9),(430,954032400,8),(430,972781200,9),(430,985482000,8),(430,1004230800,9),(430,1017536400,8),(430,1035680400,9),(430,1048986000,8),(430,1067130000,9),(430,1080435600,8),(430,1099184400,9),(430,1111885200,8),(430,1130634000,9),(430,1143334800,8),(430,1162083600,9),(430,1174784400,8),(430,1193533200,9),(430,1206838800,8),(430,1224982800,9),(430,1238288400,8),(430,1256432400,9),(430,1269738000,8),(430,1288486800,9),(430,1301187600,8),(430,1319936400,9),(430,1332637200,8),(430,1351386000,9),(430,1364691600,8),(430,1382835600,9),(430,1396141200,8),(430,1414285200,9),(430,1427590800,8),(430,1445734800,9),(430,1459040400,8),(430,1477789200,9),(430,1490490000,8),(430,1509238800,9),(430,1521939600,8),(430,1540688400,9),(430,1553994000,8),(430,1572138000,9),(430,1585443600,8),(430,1603587600,9),(430,1616893200,8),(430,1635642000,9),(430,1648342800,8),(430,1667091600,9),(430,1679792400,8),(430,1698541200,9),(430,1711846800,8),(430,1729990800,9),(430,1743296400,8),(430,1761440400,9),(430,1774746000,8),(430,1792890000,9),(430,1806195600,8),(430,1824944400,9),(430,1837645200,8),(430,1856394000,9),(430,1869094800,8),(430,1887843600,9),(430,1901149200,8),(430,1919293200,9),(430,1932598800,8),(430,1950742800,9),(430,1964048400,8),(430,1982797200,9),(430,1995498000,8),(430,2014246800,9),(430,2026947600,8),(430,2045696400,9),(430,2058397200,8),(430,2077146000,9),(430,2090451600,8),(430,2108595600,9),(430,2121901200,8),(430,2140045200,9),(431,-2147483648,4),(431,-1691964000,1),(431,-1680472800,2),(431,-1664143200,1),(431,-1650146400,2),(431,-1633903200,1),(431,-1617487200,2),(431,-1601848800,1),(431,-1586037600,2),(431,-1570399200,1),(431,-1552168800,2),(431,-1538344800,1),(431,-1522533600,2),(431,-1507500000,1),(431,-1490565600,2),(431,-1473631200,1),(431,-1460930400,2),(431,-1442786400,1),(431,-1428876000,2),(431,-1410732000,1),(431,-1396216800,2),(431,-1379282400,1),(431,-1364767200,2),(431,-1348437600,1),(431,-1333317600,2),(431,-1315778400,1),(431,-1301263200,2),(431,-1284328800,1),(431,-1269813600,2),(431,-1253484000,1),(431,-1238364000,2),(431,-1221429600,1),(431,-1206914400,2),(431,-1189980000,1),(431,-1175464800,2),(431,-1159135200,1),(431,-1143410400,2),(431,-1126476000,1),(431,-1111960800,2),(431,-1095631200,1),(431,-1080511200,2),(431,-1063576800,1),(431,-1049061600,2),(431,-1032127200,1),(431,-1017612000,2),(431,-1001282400,1),(431,-986162400,2),(431,-969228000,1),(431,-950479200,2),(431,-942012000,1),(431,-904518000,3),(431,-896050800,1),(431,-875487600,3),(431,-864601200,1),(431,-844038000,3),(431,-832546800,1),(431,-812588400,3),(431,-798073200,1),(431,-781052400,3),(431,-772066800,1),(431,-764805600,2),(431,-748476000,1),(431,-733356000,2),(431,-719445600,1),(431,-717030000,3),(431,-706748400,1),(431,-699487200,2),(431,-687996000,1),(431,-668037600,2),(431,-654732000,1),(431,-636588000,2),(431,-622072800,1),(431,-605743200,2),(431,-590623200,1),(431,-574293600,2),(431,-558568800,1),(431,-542239200,2),(431,-527119200,1),(431,-512604000,2),(431,-496274400,1),(431,-481154400,2),(431,-464220000,1),(431,-449704800,2),(431,-432165600,1),(431,-417650400,2),(431,-401320800,1),(431,-386200800,2),(431,-369266400,1),(431,-354751200,2),(431,-337816800,1),(431,-323301600,2),(431,-306972000,1),(431,-291852000,2),(431,-276732000,1),(431,-257983200,2),(431,-245282400,1),(431,-226533600,2),(431,-213228000,1),(431,-195084000,2),(431,-182383200,1),(431,-163634400,2),(431,-150933600,1),(431,-132184800,2),(431,-119484000,1),(431,-100735200,2),(431,-88034400,1),(431,-68680800,2),(431,-59004000,1),(431,-37242000,5),(431,57722400,7),(431,69818400,1),(431,89172000,2),(431,101268000,1),(431,120621600,2),(431,132717600,1),(431,152071200,2),(431,164167200,1),(431,183520800,2),(431,196221600,1),(431,214970400,2),(431,227671200,1),(431,246420000,2),(431,259120800,1),(431,278474400,2),(431,290570400,1),(431,309924000,2),(431,322020000,1),(431,341373600,2),(431,354675600,6),(431,372819600,7),(431,386125200,6),(431,404269200,7),(431,417574800,6),(431,435718800,7),(431,449024400,6),(431,467773200,7),(431,481078800,6),(431,499222800,7),(431,512528400,6),(431,530672400,7),(431,543978000,6),(431,562122000,7),(431,575427600,6),(431,593571600,7),(431,606877200,6),(431,625626000,7),(431,638326800,6),(431,657075600,7),(431,670381200,6),(431,688525200,7),(431,701830800,6),(431,719974800,7),(431,733280400,6),(431,751424400,7),(431,764730000,6),(431,782874000,7),(431,796179600,6),(431,814323600,7),(431,820454400,4),(431,828234000,6),(431,846378000,7),(431,859683600,6),(431,877827600,7),(431,891133200,6),(431,909277200,7),(431,922582800,6),(431,941331600,7),(431,954032400,6),(431,972781200,7),(431,985482000,6),(431,1004230800,7),(431,1017536400,6),(431,1035680400,7),(431,1048986000,6),(431,1067130000,7),(431,1080435600,6),(431,1099184400,7),(431,1111885200,6),(431,1130634000,7),(431,1143334800,6),(431,1162083600,7),(431,1174784400,6),(431,1193533200,7),(431,1206838800,6),(431,1224982800,7),(431,1238288400,6),(431,1256432400,7),(431,1269738000,6),(431,1288486800,7),(431,1301187600,6),(431,1319936400,7),(431,1332637200,6),(431,1351386000,7),(431,1364691600,6),(431,1382835600,7),(431,1396141200,6),(431,1414285200,7),(431,1427590800,6),(431,1445734800,7),(431,1459040400,6),(431,1477789200,7),(431,1490490000,6),(431,1509238800,7),(431,1521939600,6),(431,1540688400,7),(431,1553994000,6),(431,1572138000,7),(431,1585443600,6),(431,1603587600,7),(431,1616893200,6),(431,1635642000,7),(431,1648342800,6),(431,1667091600,7),(431,1679792400,6),(431,1698541200,7),(431,1711846800,6),(431,1729990800,7),(431,1743296400,6),(431,1761440400,7),(431,1774746000,6),(431,1792890000,7),(431,1806195600,6),(431,1824944400,7),(431,1837645200,6),(431,1856394000,7),(431,1869094800,6),(431,1887843600,7),(431,1901149200,6),(431,1919293200,7),(431,1932598800,6),(431,1950742800,7),(431,1964048400,6),(431,1982797200,7),(431,1995498000,6),(431,2014246800,7),(431,2026947600,6),(431,2045696400,7),(431,2058397200,6),(431,2077146000,7),(431,2090451600,6),(431,2108595600,7),(431,2121901200,6),(431,2140045200,7),(432,-2147483648,1),(432,-905824800,4),(432,-857257200,2),(432,-844556400,3),(432,-828226800,2),(432,-812502000,3),(432,-796777200,2),(432,-788922000,1),(432,-777942000,3),(432,-766623600,2),(432,407199600,1),(432,417574800,5),(432,433299600,6),(432,449024400,5),(432,465354000,6),(432,481078800,5),(432,496803600,6),(432,512528400,5),(432,528253200,6),(432,543978000,5),(432,559702800,6),(432,575427600,5),(432,591152400,6),(432,606877200,5),(432,622602000,6),(432,638326800,5),(432,654656400,6),(432,670381200,5),(432,686106000,6),(432,701830800,5),(432,717555600,6),(432,733280400,5),(432,749005200,6),(432,764730000,5),(432,780454800,6),(432,796179600,5),(432,811904400,6),(432,828234000,5),(432,846378000,6),(432,859683600,5),(432,877827600,6),(432,891133200,5),(432,909277200,6),(432,922582800,5),(432,941331600,6),(432,954032400,5),(432,972781200,6),(432,985482000,5),(432,1004230800,6),(432,1017536400,5),(432,1035680400,6),(432,1048986000,5),(432,1067130000,6),(432,1080435600,5),(432,1099184400,6),(432,1111885200,5),(432,1130634000,6),(432,1143334800,5),(432,1162083600,6),(432,1174784400,5),(432,1193533200,6),(432,1206838800,5),(432,1224982800,6),(432,1238288400,5),(432,1256432400,6),(432,1269738000,5),(432,1288486800,6),(432,1301187600,5),(432,1319936400,6),(432,1332637200,5),(432,1351386000,6),(432,1364691600,5),(432,1382835600,6),(432,1396141200,5),(432,1414285200,6),(432,1427590800,5),(432,1445734800,6),(432,1459040400,5),(432,1477789200,6),(432,1490490000,5),(432,1509238800,6),(432,1521939600,5),(432,1540688400,6),(432,1553994000,5),(432,1572138000,6),(432,1585443600,5),(432,1603587600,6),(432,1616893200,5),(432,1635642000,6),(432,1648342800,5),(432,1667091600,6),(432,1679792400,5),(432,1698541200,6),(432,1711846800,5),(432,1729990800,6),(432,1743296400,5),(432,1761440400,6),(432,1774746000,5),(432,1792890000,6),(432,1806195600,5),(432,1824944400,6),(432,1837645200,5),(432,1856394000,6),(432,1869094800,5),(432,1887843600,6),(432,1901149200,5),(432,1919293200,6),(432,1932598800,5),(432,1950742800,6),(432,1964048400,5),(432,1982797200,6),(432,1995498000,5),(432,2014246800,6),(432,2026947600,5),(432,2045696400,6),(432,2058397200,5),(432,2077146000,6),(432,2090451600,5),(432,2108595600,6),(432,2121901200,5),(432,2140045200,6),(433,-2147483648,2),(433,-1693706400,1),(433,-1680483600,2),(433,-1663455600,3),(433,-1650150000,4),(433,-1632006000,3),(433,-1618700400,4),(433,-938905200,3),(433,-857257200,4),(433,-844556400,3),(433,-828226800,4),(433,-812502000,3),(433,-796777200,4),(433,-781052400,3),(433,-776563200,5),(433,-765936000,1),(433,-761180400,4),(433,-757386000,2),(433,-748479600,3),(433,-733273200,4),(433,-717631200,3),(433,-714610800,6),(433,-710380800,1),(433,-701910000,4),(433,-684975600,3),(433,-670460400,4),(433,-654130800,3),(433,-639010800,4),(433,315529200,2),(433,323830800,7),(433,338950800,8),(433,354675600,7),(433,370400400,8),(433,386125200,7),(433,401850000,8),(433,417574800,7),(433,433299600,8),(433,449024400,7),(433,465354000,8),(433,481078800,7),(433,496803600,8),(433,512528400,7),(433,528253200,8),(433,543978000,7),(433,559702800,8),(433,575427600,7),(433,591152400,8),(433,606877200,7),(433,622602000,8),(433,638326800,7),(433,654656400,8),(433,670381200,7),(433,686106000,8),(433,701830800,7),(433,717555600,8),(433,733280400,7),(433,749005200,8),(433,764730000,7),(433,780454800,8),(433,796179600,7),(433,811904400,8),(433,828234000,7),(433,846378000,8),(433,859683600,7),(433,877827600,8),(433,891133200,7),(433,909277200,8),(433,922582800,7),(433,941331600,8),(433,954032400,7),(433,972781200,8),(433,985482000,7),(433,1004230800,8),(433,1017536400,7),(433,1035680400,8),(433,1048986000,7),(433,1067130000,8),(433,1080435600,7),(433,1099184400,8),(433,1111885200,7),(433,1130634000,8),(433,1143334800,7),(433,1162083600,8),(433,1174784400,7),(433,1193533200,8),(433,1206838800,7),(433,1224982800,8),(433,1238288400,7),(433,1256432400,8),(433,1269738000,7),(433,1288486800,8),(433,1301187600,7),(433,1319936400,8),(433,1332637200,7),(433,1351386000,8),(433,1364691600,7),(433,1382835600,8),(433,1396141200,7),(433,1414285200,8),(433,1427590800,7),(433,1445734800,8),(433,1459040400,7),(433,1477789200,8),(433,1490490000,7),(433,1509238800,8),(433,1521939600,7),(433,1540688400,8),(433,1553994000,7),(433,1572138000,8),(433,1585443600,7),(433,1603587600,8),(433,1616893200,7),(433,1635642000,8),(433,1648342800,7),(433,1667091600,8),(433,1679792400,7),(433,1698541200,8),(433,1711846800,7),(433,1729990800,8),(433,1743296400,7),(433,1761440400,8),(433,1774746000,7),(433,1792890000,8),(433,1806195600,7),(433,1824944400,8),(433,1837645200,7),(433,1856394000,8),(433,1869094800,7),(433,1887843600,8),(433,1901149200,7),(433,1919293200,8),(433,1932598800,7),(433,1950742800,8),(433,1964048400,7),(433,1982797200,8),(433,1995498000,7),(433,2014246800,8),(433,2026947600,7),(433,2045696400,8),(433,2058397200,7),(433,2077146000,8),(433,2090451600,7),(433,2108595600,8),(433,2121901200,7),(433,2140045200,8),(434,-2147483648,2),(434,-1693706400,1),(434,-1680483600,2),(434,-1663455600,3),(434,-1650150000,4),(434,-1632006000,3),(434,-1618700400,4),(434,-938905200,3),(434,-857257200,4),(434,-844556400,3),(434,-828226800,4),(434,-812502000,3),(434,-796777200,4),(434,-781052400,3),(434,-777866400,1),(434,-765327600,4),(434,-746578800,3),(434,-733359600,4),(434,-728517600,5),(434,-721260000,2),(434,-716425200,3),(434,-701910000,4),(434,-684975600,3),(434,-670460400,4),(434,-654217200,3),(434,-639010800,4),(434,283993200,2),(434,291776400,6),(434,307501200,7),(434,323830800,6),(434,338950800,7),(434,354675600,6),(434,370400400,7),(434,386125200,6),(434,401850000,7),(434,417574800,6),(434,433299600,7),(434,449024400,6),(434,465354000,7),(434,481078800,6),(434,496803600,7),(434,512528400,6),(434,528253200,7),(434,543978000,6),(434,559702800,7),(434,575427600,6),(434,591152400,7),(434,606877200,6),(434,622602000,7),(434,638326800,6),(434,654656400,7),(434,670381200,6),(434,686106000,7),(434,701830800,6),(434,717555600,7),(434,733280400,6),(434,749005200,7),(434,764730000,6),(434,780454800,7),(434,796179600,6),(434,811904400,7),(434,828234000,6),(434,846378000,7),(434,859683600,6),(434,877827600,7),(434,891133200,6),(434,909277200,7),(434,922582800,6),(434,941331600,7),(434,954032400,6),(434,972781200,7),(434,985482000,6),(434,1004230800,7),(434,1017536400,6),(434,1035680400,7),(434,1048986000,6),(434,1067130000,7),(434,1080435600,6),(434,1099184400,7),(434,1111885200,6),(434,1130634000,7),(434,1143334800,6),(434,1162083600,7),(434,1174784400,6),(434,1193533200,7),(434,1206838800,6),(434,1224982800,7),(434,1238288400,6),(434,1256432400,7),(434,1269738000,6),(434,1288486800,7),(434,1301187600,6),(434,1319936400,7),(434,1332637200,6),(434,1351386000,7),(434,1364691600,6),(434,1382835600,7),(434,1396141200,6),(434,1414285200,7),(434,1427590800,6),(434,1445734800,7),(434,1459040400,6),(434,1477789200,7),(434,1490490000,6),(434,1509238800,7),(434,1521939600,6),(434,1540688400,7),(434,1553994000,6),(434,1572138000,7),(434,1585443600,6),(434,1603587600,7),(434,1616893200,6),(434,1635642000,7),(434,1648342800,6),(434,1667091600,7),(434,1679792400,6),(434,1698541200,7),(434,1711846800,6),(434,1729990800,7),(434,1743296400,6),(434,1761440400,7),(434,1774746000,6),(434,1792890000,7),(434,1806195600,6),(434,1824944400,7),(434,1837645200,6),(434,1856394000,7),(434,1869094800,6),(434,1887843600,7),(434,1901149200,6),(434,1919293200,7),(434,1932598800,6),(434,1950742800,7),(434,1964048400,6),(434,1982797200,7),(434,1995498000,6),(434,2014246800,7),(434,2026947600,6),(434,2045696400,7),(434,2058397200,6),(434,2077146000,7),(434,2090451600,6),(434,2108595600,7),(434,2121901200,6),(434,2140045200,7),(435,-2147483648,1),(435,-1740355200,2),(435,-1693702800,5),(435,-1680483600,2),(435,-1663455600,3),(435,-1650150000,4),(435,-1632006000,3),(435,-1618700400,4),(435,-1613826000,8),(435,-1604278800,6),(435,-1585530000,7),(435,-1574038800,6),(435,-1552266000,7),(435,-1539997200,6),(435,-1520557200,7),(435,-1507510800,6),(435,-1490576400,7),(435,-1473642000,6),(435,-1459126800,7),(435,-1444006800,6),(435,-1427677200,7),(435,-1411952400,6),(435,-1396227600,7),(435,-1379293200,6),(435,-1364778000,7),(435,-1348448400,6),(435,-1333328400,7),(435,-1316394000,6),(435,-1301263200,7),(435,-1284328800,6),(435,-1269813600,7),(435,-1253484000,6),(435,-1238364000,7),(435,-1221429600,6),(435,-1206914400,7),(435,-1191189600,6),(435,-1175464800,7),(435,-1160344800,6),(435,-1143410400,7),(435,-1127685600,6),(435,-1111960800,7),(435,-1096840800,6),(435,-1080511200,7),(435,-1063576800,6),(435,-1049061600,7),(435,-1033336800,6),(435,-1017612000,7),(435,-1002492000,6),(435,-986162400,7),(435,-969228000,6),(435,-950479200,7),(435,-942012000,6),(435,-934668000,3),(435,-857257200,4),(435,-844556400,3),(435,-828226800,4),(435,-812502000,3),(435,-799293600,5),(435,-798073200,4),(435,-781052400,3),(435,-766623600,4),(435,-745455600,3),(435,-733273200,4),(435,220921200,2),(435,228877200,9),(435,243997200,10),(435,260326800,9),(435,276051600,10),(435,291776400,9),(435,307501200,10),(435,323830800,9),(435,338950800,10),(435,354675600,9),(435,370400400,10),(435,386125200,9),(435,401850000,10),(435,417574800,9),(435,433299600,10),(435,449024400,9),(435,465354000,10),(435,481078800,9),(435,496803600,10),(435,512528400,9),(435,528253200,10),(435,543978000,9),(435,559702800,10),(435,575427600,9),(435,591152400,10),(435,606877200,9),(435,622602000,10),(435,638326800,9),(435,654656400,10),(435,670381200,9),(435,686106000,10),(435,701830800,9),(435,717555600,10),(435,733280400,9),(435,749005200,10),(435,764730000,9),(435,780454800,10),(435,796179600,9),(435,811904400,10),(435,828234000,9),(435,846378000,10),(435,859683600,9),(435,877827600,10),(435,891133200,9),(435,909277200,10),(435,922582800,9),(435,941331600,10),(435,954032400,9),(435,972781200,10),(435,985482000,9),(435,1004230800,10),(435,1017536400,9),(435,1035680400,10),(435,1048986000,9),(435,1067130000,10),(435,1080435600,9),(435,1099184400,10),(435,1111885200,9),(435,1130634000,10),(435,1143334800,9),(435,1162083600,10),(435,1174784400,9),(435,1193533200,10),(435,1206838800,9),(435,1224982800,10),(435,1238288400,9),(435,1256432400,10),(435,1269738000,9),(435,1288486800,10),(435,1301187600,9),(435,1319936400,10),(435,1332637200,9),(435,1351386000,10),(435,1364691600,9),(435,1382835600,10),(435,1396141200,9),(435,1414285200,10),(435,1427590800,9),(435,1445734800,10),(435,1459040400,9),(435,1477789200,10),(435,1490490000,9),(435,1509238800,10),(435,1521939600,9),(435,1540688400,10),(435,1553994000,9),(435,1572138000,10),(435,1585443600,9),(435,1603587600,10),(435,1616893200,9),(435,1635642000,10),(435,1648342800,9),(435,1667091600,10),(435,1679792400,9),(435,1698541200,10),(435,1711846800,9),(435,1729990800,10),(435,1743296400,9),(435,1761440400,10),(435,1774746000,9),(435,1792890000,10),(435,1806195600,9),(435,1824944400,10),(435,1837645200,9),(435,1856394000,10),(435,1869094800,9),(435,1887843600,10),(435,1901149200,9),(435,1919293200,10),(435,1932598800,9),(435,1950742800,10),(435,1964048400,9),(435,1982797200,10),(435,1995498000,9),(435,2014246800,10),(435,2026947600,9),(435,2045696400,10),(435,2058397200,9),(435,2077146000,10),(435,2090451600,9),(435,2108595600,10),(435,2121901200,9),(435,2140045200,10),(436,-2147483648,1),(436,-1213148664,5),(436,-1187056800,2),(436,-1175479200,3),(436,-1159754400,2),(436,-1144029600,3),(436,-1127700000,2),(436,-1111975200,3),(436,-1096250400,2),(436,-1080525600,3),(436,-1064800800,2),(436,-1049076000,3),(436,-1033351200,2),(436,-1017626400,3),(436,-1001901600,2),(436,-986176800,3),(436,-970452000,2),(436,-954727200,3),(436,296604000,4),(436,307486800,5),(436,323816400,4),(436,338940000,5),(436,354672000,2),(436,370396800,3),(436,386121600,2),(436,401846400,3),(436,417571200,2),(436,433296000,3),(436,449020800,2),(436,465350400,3),(436,481075200,2),(436,496800000,3),(436,512524800,2),(436,528249600,3),(436,543974400,2),(436,559699200,3),(436,575424000,2),(436,591148800,3),(436,606873600,2),(436,622598400,3),(436,638323200,2),(436,654652800,3),(436,662680800,5),(436,670370400,2),(436,686095200,3),(436,701820000,2),(436,717544800,3),(436,733269600,2),(436,748994400,3),(436,757375200,5),(436,764719200,4),(436,780440400,5),(436,796168800,4),(436,811890000,5),(436,828223200,4),(436,846363600,5),(436,859683600,6),(436,877827600,7),(436,891133200,6),(436,909277200,7),(436,922582800,6),(436,941331600,7),(436,954032400,6),(436,972781200,7),(436,985482000,6),(436,1004230800,7),(436,1017536400,6),(436,1035680400,7),(436,1048986000,6),(436,1067130000,7),(436,1080435600,6),(436,1099184400,7),(436,1111885200,6),(436,1130634000,7),(436,1143334800,6),(436,1162083600,7),(436,1174784400,6),(436,1193533200,7),(436,1206838800,6),(436,1224982800,7),(436,1238288400,6),(436,1256432400,7),(436,1269738000,6),(436,1288486800,7),(436,1301187600,6),(436,1319936400,7),(436,1332637200,6),(436,1351386000,7),(436,1364691600,6),(436,1382835600,7),(436,1396141200,6),(436,1414285200,7),(436,1427590800,6),(436,1445734800,7),(436,1459040400,6),(436,1477789200,7),(436,1490490000,6),(436,1509238800,7),(436,1521939600,6),(436,1540688400,7),(436,1553994000,6),(436,1572138000,7),(436,1585443600,6),(436,1603587600,7),(436,1616893200,6),(436,1635642000,7),(436,1648342800,6),(436,1667091600,7),(436,1679792400,6),(436,1698541200,7),(436,1711846800,6),(436,1729990800,7),(436,1743296400,6),(436,1761440400,7),(436,1774746000,6),(436,1792890000,7),(436,1806195600,6),(436,1824944400,7),(436,1837645200,6),(436,1856394000,7),(436,1869094800,6),(436,1887843600,7),(436,1901149200,6),(436,1919293200,7),(436,1932598800,6),(436,1950742800,7),(436,1964048400,6),(436,1982797200,7),(436,1995498000,6),(436,2014246800,7),(436,2026947600,6),(436,2045696400,7),(436,2058397200,6),(436,2077146000,7),(436,2090451600,6),(436,2108595600,7),(436,2121901200,6),(436,2140045200,7),(437,-2147483648,2),(437,-1693706400,1),(437,-1680483600,2),(437,-1663455600,3),(437,-1650150000,4),(437,-1640998800,2),(437,-1632006000,1),(437,-1618700400,2),(437,-1600470000,1),(437,-1587250800,2),(437,-1569711600,1),(437,-1555196400,2),(437,-906775200,1),(437,-857257200,4),(437,-844556400,3),(437,-828226800,4),(437,-812502000,3),(437,-796777200,4),(437,-788922000,2),(437,-778471200,1),(437,-762656400,2),(437,-749689200,3),(437,-733276800,2),(437,-717634800,3),(437,-701910000,4),(437,-686185200,3),(437,-670460400,4),(437,-654130800,3),(437,-639010800,4),(437,-492656400,1),(437,-481168800,2),(437,-461199600,1),(437,-449708400,2),(437,-428540400,1),(437,-418258800,2),(437,-397090800,1),(437,-386809200,2),(437,323823600,1),(437,338943600,2),(437,354668400,1),(437,370393200,2),(437,386118000,1),(437,401842800,2),(437,417567600,1),(437,433292400,2),(437,449024400,5),(437,465354000,6),(437,481078800,5),(437,496803600,6),(437,512528400,5),(437,528253200,6),(437,543978000,5),(437,559702800,6),(437,575427600,5),(437,591152400,6),(437,606877200,5),(437,622602000,6),(437,638326800,5),(437,654656400,6),(437,670381200,5),(437,686106000,6),(437,701830800,5),(437,717555600,6),(437,733280400,5),(437,749005200,6),(437,764730000,5),(437,780454800,6),(437,796179600,5),(437,811904400,6),(437,828234000,5),(437,846378000,6),(437,859683600,5),(437,877827600,6),(437,891133200,5),(437,909277200,6),(437,922582800,5),(437,941331600,6),(437,954032400,5),(437,972781200,6),(437,985482000,5),(437,1004230800,6),(437,1017536400,5),(437,1035680400,6),(437,1048986000,5),(437,1067130000,6),(437,1080435600,5),(437,1099184400,6),(437,1111885200,5),(437,1130634000,6),(437,1143334800,5),(437,1162083600,6),(437,1174784400,5),(437,1193533200,6),(437,1206838800,5),(437,1224982800,6),(437,1238288400,5),(437,1256432400,6),(437,1269738000,5),(437,1288486800,6),(437,1301187600,5),(437,1319936400,6),(437,1332637200,5),(437,1351386000,6),(437,1364691600,5),(437,1382835600,6),(437,1396141200,5),(437,1414285200,6),(437,1427590800,5),(437,1445734800,6),(437,1459040400,5),(437,1477789200,6),(437,1490490000,5),(437,1509238800,6),(437,1521939600,5),(437,1540688400,6),(437,1553994000,5),(437,1572138000,6),(437,1585443600,5),(437,1603587600,6),(437,1616893200,5),(437,1635642000,6),(437,1648342800,5),(437,1667091600,6),(437,1679792400,5),(437,1698541200,6),(437,1711846800,5),(437,1729990800,6),(437,1743296400,5),(437,1761440400,6),(437,1774746000,5),(437,1792890000,6),(437,1806195600,5),(437,1824944400,6),(437,1837645200,5),(437,1856394000,6),(437,1869094800,5),(437,1887843600,6),(437,1901149200,5),(437,1919293200,6),(437,1932598800,5),(437,1950742800,6),(437,1964048400,5),(437,1982797200,6),(437,1995498000,5),(437,2014246800,6),(437,2026947600,5),(437,2045696400,6),(437,2058397200,5),(437,2077146000,6),(437,2090451600,5),(437,2108595600,6),(437,2121901200,5),(437,2140045200,6),(438,-2147483648,2),(438,-904435200,1),(438,-891129600,2),(438,-872985600,1),(438,-859680000,2),(438,354675600,3),(438,370400400,4),(438,386125200,3),(438,401850000,4),(438,417574800,3),(438,433299600,4),(438,449024400,3),(438,465354000,4),(438,481078800,3),(438,496803600,4),(438,512528400,3),(438,528253200,4),(438,543978000,3),(438,559702800,4),(438,575427600,3),(438,591152400,4),(438,606877200,3),(438,622602000,4),(438,638326800,3),(438,654656400,4),(438,670381200,3),(438,686106000,4),(438,701830800,3),(438,717555600,4),(438,733280400,3),(438,749005200,4),(438,764730000,3),(438,780454800,4),(438,796179600,3),(438,811904400,4),(438,828234000,3),(438,846378000,4),(438,859683600,3),(438,877827600,4),(438,891133200,3),(438,909277200,4),(438,922582800,3),(438,941331600,4),(438,954032400,3),(438,972781200,4),(438,985482000,3),(438,1004230800,4),(438,1017536400,3),(438,1035680400,4),(438,1048986000,3),(438,1067130000,4),(438,1080435600,3),(438,1099184400,4),(438,1111885200,3),(438,1130634000,4),(438,1143334800,3),(438,1162083600,4),(438,1174784400,3),(438,1193533200,4),(438,1206838800,3),(438,1224982800,4),(438,1238288400,3),(438,1256432400,4),(438,1269738000,3),(438,1288486800,4),(438,1301187600,3),(438,1319936400,4),(438,1332637200,3),(438,1351386000,4),(438,1364691600,3),(438,1382835600,4),(438,1396141200,3),(438,1414285200,4),(438,1427590800,3),(438,1445734800,4),(438,1459040400,3),(438,1477789200,4),(438,1490490000,3),(438,1509238800,4),(438,1521939600,3),(438,1540688400,4),(438,1553994000,3),(438,1572138000,4),(438,1585443600,3),(438,1603587600,4),(438,1616893200,3),(438,1635642000,4),(438,1648342800,3),(438,1667091600,4),(438,1679792400,3),(438,1698541200,4),(438,1711846800,3),(438,1729990800,4),(438,1743296400,3),(438,1761440400,4),(438,1774746000,3),(438,1792890000,4),(438,1806195600,3),(438,1824944400,4),(438,1837645200,3),(438,1856394000,4),(438,1869094800,3),(438,1887843600,4),(438,1901149200,3),(438,1919293200,4),(438,1932598800,3),(438,1950742800,4),(438,1964048400,3),(438,1982797200,4),(438,1995498000,3),(438,2014246800,4),(438,2026947600,3),(438,2045696400,4),(438,2058397200,3),(438,2077146000,4),(438,2090451600,3),(438,2108595600,4),(438,2121901200,3),(438,2140045200,4),(439,-2147483648,1),(439,-1637114100,2),(439,-1213148664,5),(439,-1187056800,3),(439,-1175479200,4),(439,-1159754400,3),(439,-1144029600,4),(439,-1127700000,3),(439,-1111975200,4),(439,-1096250400,3),(439,-1080525600,4),(439,-1064800800,3),(439,-1049076000,4),(439,-1033351200,3),(439,-1017626400,4),(439,-1001901600,3),(439,-986176800,4),(439,-970452000,3),(439,-954727200,4),(439,-927165600,6),(439,-898138800,9),(439,-857257200,7),(439,-844556400,8),(439,-828226800,7),(439,-812502000,8),(439,-800157600,11),(439,354920400,10),(439,370728000,11),(439,386456400,10),(439,402264000,11),(439,417992400,10),(439,433800000,11),(439,449614800,10),(439,465346800,12),(439,481071600,13),(439,496796400,12),(439,512521200,13),(439,528246000,12),(439,543970800,13),(439,559695600,12),(439,575420400,13),(439,591145200,12),(439,606870000,13),(439,622594800,12),(439,638319600,13),(439,641944800,6),(439,654652800,4),(439,670377600,3),(439,686102400,4),(439,694216800,5),(439,701820000,6),(439,717541200,5),(439,733269600,6),(439,748990800,5),(439,764719200,6),(439,780440400,5),(439,796168800,6),(439,811890000,5),(439,828223200,6),(439,846363600,5),(439,859680000,6),(439,877824000,5),(439,891129600,6),(439,909273600,5),(439,922579200,6),(439,941328000,5),(439,954028800,6),(439,972777600,5),(439,985478400,6),(439,1004227200,5),(439,1017532800,6),(439,1035676800,5),(439,1048982400,6),(439,1067126400,5),(439,1080432000,6),(439,1099180800,5),(439,1111881600,6),(439,1130630400,5),(439,1143331200,6),(439,1162080000,5),(439,1174780800,6),(439,1193529600,5),(439,1206835200,6),(439,1224979200,5),(439,1238284800,6),(439,1256428800,5),(439,1269734400,6),(439,1288483200,5),(439,1301184000,6),(439,1319932800,5),(439,1332633600,6),(439,1351382400,5),(439,1364688000,6),(439,1382832000,5),(439,1396137600,6),(439,1414281600,5),(439,1427587200,6),(439,1445731200,5),(439,1459036800,6),(439,1477785600,5),(439,1490486400,6),(439,1509235200,5),(439,1521936000,6),(439,1540684800,5),(439,1553990400,6),(439,1572134400,5),(439,1585440000,6),(439,1603584000,5),(439,1616889600,6),(439,1635638400,5),(439,1648339200,6),(439,1667088000,5),(439,1679788800,6),(439,1698537600,5),(439,1711843200,6),(439,1729987200,5),(439,1743292800,6),(439,1761436800,5),(439,1774742400,6),(439,1792886400,5),(439,1806192000,6),(439,1824940800,5),(439,1837641600,6),(439,1856390400,5),(439,1869091200,6),(439,1887840000,5),(439,1901145600,6),(439,1919289600,5),(439,1932595200,6),(439,1950739200,5),(439,1964044800,6),(439,1982793600,5),(439,1995494400,6),(439,2014243200,5),(439,2026944000,6),(439,2045692800,5),(439,2058393600,6),(439,2077142400,5),(439,2090448000,6),(439,2108592000,5),(439,2121897600,6),(439,2140041600,5),(440,-2147483648,2),(440,-1693706400,1),(440,-1680483600,2),(440,-1663455600,3),(440,-1650150000,4),(440,-1632006000,3),(440,-1618700400,4),(440,-938905200,3),(440,-857257200,4),(440,-844556400,3),(440,-828226800,4),(440,-812502000,3),(440,-796777200,4),(440,-781052400,3),(440,-776563200,5),(440,-765936000,1),(440,-761180400,4),(440,-757386000,2),(440,-748479600,3),(440,-733273200,4),(440,-717631200,3),(440,-714610800,6),(440,-710380800,1),(440,-701910000,4),(440,-684975600,3),(440,-670460400,4),(440,-654130800,3),(440,-639010800,4),(440,315529200,2),(440,323830800,7),(440,338950800,8),(440,354675600,7),(440,370400400,8),(440,386125200,7),(440,401850000,8),(440,417574800,7),(440,433299600,8),(440,449024400,7),(440,465354000,8),(440,481078800,7),(440,496803600,8),(440,512528400,7),(440,528253200,8),(440,543978000,7),(440,559702800,8),(440,575427600,7),(440,591152400,8),(440,606877200,7),(440,622602000,8),(440,638326800,7),(440,654656400,8),(440,670381200,7),(440,686106000,8),(440,701830800,7),(440,717555600,8),(440,733280400,7),(440,749005200,8),(440,764730000,7),(440,780454800,8),(440,796179600,7),(440,811904400,8),(440,828234000,7),(440,846378000,8),(440,859683600,7),(440,877827600,8),(440,891133200,7),(440,909277200,8),(440,922582800,7),(440,941331600,8),(440,954032400,7),(440,972781200,8),(440,985482000,7),(440,1004230800,8),(440,1017536400,7),(440,1035680400,8),(440,1048986000,7),(440,1067130000,8),(440,1080435600,7),(440,1099184400,8),(440,1111885200,7),(440,1130634000,8),(440,1143334800,7),(440,1162083600,8),(440,1174784400,7),(440,1193533200,8),(440,1206838800,7),(440,1224982800,8),(440,1238288400,7),(440,1256432400,8),(440,1269738000,7),(440,1288486800,8),(440,1301187600,7),(440,1319936400,8),(440,1332637200,7),(440,1351386000,8),(440,1364691600,7),(440,1382835600,8),(440,1396141200,7),(440,1414285200,8),(440,1427590800,7),(440,1445734800,8),(440,1459040400,7),(440,1477789200,8),(440,1490490000,7),(440,1509238800,8),(440,1521939600,7),(440,1540688400,8),(440,1553994000,7),(440,1572138000,8),(440,1585443600,7),(440,1603587600,8),(440,1616893200,7),(440,1635642000,8),(440,1648342800,7),(440,1667091600,8),(440,1679792400,7),(440,1698541200,8),(440,1711846800,7),(440,1729990800,8),(440,1743296400,7),(440,1761440400,8),(440,1774746000,7),(440,1792890000,8),(440,1806195600,7),(440,1824944400,8),(440,1837645200,7),(440,1856394000,8),(440,1869094800,7),(440,1887843600,8),(440,1901149200,7),(440,1919293200,8),(440,1932598800,7),(440,1950742800,8),(440,1964048400,7),(440,1982797200,8),(440,1995498000,7),(440,2014246800,8),(440,2026947600,7),(440,2045696400,8),(440,2058397200,7),(440,2077146000,8),(440,2090451600,7),(440,2108595600,8),(440,2121901200,7),(440,2140045200,8),(441,-2147483648,1),(441,-1691962479,2),(441,-1680471279,4),(441,-1664143200,3),(441,-1650146400,4),(441,-1633903200,3),(441,-1617487200,4),(441,-1601848800,3),(441,-1586037600,4),(441,-1570399200,3),(441,-1552168800,4),(441,-1538344800,3),(441,-1522533600,4),(441,-1517011200,6),(441,-1507500000,5),(441,-1490565600,4),(441,-1473631200,5),(441,-1460930400,4),(441,-1442786400,5),(441,-1428876000,4),(441,-1410732000,5),(441,-1396216800,4),(441,-1379282400,5),(441,-1364767200,4),(441,-1348437600,5),(441,-1333317600,4),(441,-1315778400,5),(441,-1301263200,4),(441,-1284328800,5),(441,-1269813600,4),(441,-1253484000,5),(441,-1238364000,4),(441,-1221429600,5),(441,-1206914400,4),(441,-1189980000,5),(441,-1175464800,4),(441,-1159135200,5),(441,-1143410400,4),(441,-1126476000,5),(441,-1111960800,4),(441,-1095631200,5),(441,-1080511200,4),(441,-1063576800,5),(441,-1049061600,4),(441,-1032127200,5),(441,-1017612000,4),(441,-1001282400,5),(441,-986162400,4),(441,-969228000,5),(441,-950479200,4),(441,-942012000,5),(441,-733356000,4),(441,-719445600,5),(441,-699487200,4),(441,-684972000,5),(441,-668037600,4),(441,-654732000,5),(441,-636588000,4),(441,-622072800,5),(441,-605743200,4),(441,-590623200,5),(441,-574293600,4),(441,-558568800,5),(441,-542239200,4),(441,-527119200,5),(441,-512604000,4),(441,-496274400,5),(441,-481154400,4),(441,-464220000,5),(441,-449704800,4),(441,-432165600,5),(441,-417650400,4),(441,-401320800,5),(441,-386200800,4),(441,-369266400,5),(441,-354751200,4),(441,-337816800,5),(441,-323301600,4),(441,-306972000,5),(441,-291852000,4),(441,-276732000,5),(441,-257983200,4),(441,-245282400,5),(441,-226533600,4),(441,-213228000,5),(441,-195084000,4),(441,-182383200,5),(441,-163634400,4),(441,-150933600,5),(441,-132184800,4),(441,-119484000,5),(441,-100735200,4),(441,-88034400,5),(441,-68680800,4),(441,-59004000,5),(441,-37242000,7),(441,57722400,9),(441,69818400,5),(441,89172000,4),(441,101268000,5),(441,120621600,4),(441,132717600,5),(441,152071200,4),(441,164167200,5),(441,183520800,4),(441,196221600,5),(441,214970400,4),(441,227671200,5),(441,246420000,4),(441,259120800,5),(441,278474400,4),(441,290570400,5),(441,309924000,4),(441,322020000,5),(441,341373600,4),(441,354675600,8),(441,372819600,9),(441,386125200,8),(441,404269200,9),(441,417574800,8),(441,435718800,9),(441,449024400,8),(441,467773200,9),(441,481078800,8),(441,499222800,9),(441,512528400,8),(441,530672400,9),(441,543978000,8),(441,562122000,9),(441,575427600,8),(441,593571600,9),(441,606877200,8),(441,625626000,9),(441,638326800,8),(441,657075600,9),(441,670381200,8),(441,688525200,9),(441,701830800,8),(441,719974800,9),(441,733280400,8),(441,751424400,9),(441,764730000,8),(441,782874000,9),(441,796179600,8),(441,814323600,9),(441,820454400,6),(441,828234000,8),(441,846378000,9),(441,859683600,8),(441,877827600,9),(441,891133200,8),(441,909277200,9),(441,922582800,8),(441,941331600,9),(441,954032400,8),(441,972781200,9),(441,985482000,8),(441,1004230800,9),(441,1017536400,8),(441,1035680400,9),(441,1048986000,8),(441,1067130000,9),(441,1080435600,8),(441,1099184400,9),(441,1111885200,8),(441,1130634000,9),(441,1143334800,8),(441,1162083600,9),(441,1174784400,8),(441,1193533200,9),(441,1206838800,8),(441,1224982800,9),(441,1238288400,8),(441,1256432400,9),(441,1269738000,8),(441,1288486800,9),(441,1301187600,8),(441,1319936400,9),(441,1332637200,8),(441,1351386000,9),(441,1364691600,8),(441,1382835600,9),(441,1396141200,8),(441,1414285200,9),(441,1427590800,8),(441,1445734800,9),(441,1459040400,8),(441,1477789200,9),(441,1490490000,8),(441,1509238800,9),(441,1521939600,8),(441,1540688400,9),(441,1553994000,8),(441,1572138000,9),(441,1585443600,8),(441,1603587600,9),(441,1616893200,8),(441,1635642000,9),(441,1648342800,8),(441,1667091600,9),(441,1679792400,8),(441,1698541200,9),(441,1711846800,8),(441,1729990800,9),(441,1743296400,8),(441,1761440400,9),(441,1774746000,8),(441,1792890000,9),(441,1806195600,8),(441,1824944400,9),(441,1837645200,8),(441,1856394000,9),(441,1869094800,8),(441,1887843600,9),(441,1901149200,8),(441,1919293200,9),(441,1932598800,8),(441,1950742800,9),(441,1964048400,8),(441,1982797200,9),(441,1995498000,8),(441,2014246800,9),(441,2026947600,8),(441,2045696400,9),(441,2058397200,8),(441,2077146000,9),(441,2090451600,8),(441,2108595600,9),(441,2121901200,8),(441,2140045200,9),(442,-2147483648,4),(442,-1691964000,1),(442,-1680472800,2),(442,-1664143200,1),(442,-1650146400,2),(442,-1633903200,1),(442,-1617487200,2),(442,-1601848800,1),(442,-1586037600,2),(442,-1570399200,1),(442,-1552168800,2),(442,-1538344800,1),(442,-1522533600,2),(442,-1507500000,1),(442,-1490565600,2),(442,-1473631200,1),(442,-1460930400,2),(442,-1442786400,1),(442,-1428876000,2),(442,-1410732000,1),(442,-1396216800,2),(442,-1379282400,1),(442,-1364767200,2),(442,-1348437600,1),(442,-1333317600,2),(442,-1315778400,1),(442,-1301263200,2),(442,-1284328800,1),(442,-1269813600,2),(442,-1253484000,1),(442,-1238364000,2),(442,-1221429600,1),(442,-1206914400,2),(442,-1189980000,1),(442,-1175464800,2),(442,-1159135200,1),(442,-1143410400,2),(442,-1126476000,1),(442,-1111960800,2),(442,-1095631200,1),(442,-1080511200,2),(442,-1063576800,1),(442,-1049061600,2),(442,-1032127200,1),(442,-1017612000,2),(442,-1001282400,1),(442,-986162400,2),(442,-969228000,1),(442,-950479200,2),(442,-942012000,1),(442,-904518000,3),(442,-896050800,1),(442,-875487600,3),(442,-864601200,1),(442,-844038000,3),(442,-832546800,1),(442,-812588400,3),(442,-798073200,1),(442,-781052400,3),(442,-772066800,1),(442,-764805600,2),(442,-748476000,1),(442,-733356000,2),(442,-719445600,1),(442,-717030000,3),(442,-706748400,1),(442,-699487200,2),(442,-687996000,1),(442,-668037600,2),(442,-654732000,1),(442,-636588000,2),(442,-622072800,1),(442,-605743200,2),(442,-590623200,1),(442,-574293600,2),(442,-558568800,1),(442,-542239200,2),(442,-527119200,1),(442,-512604000,2),(442,-496274400,1),(442,-481154400,2),(442,-464220000,1),(442,-449704800,2),(442,-432165600,1),(442,-417650400,2),(442,-401320800,5),(442,386125200,6),(442,401850000,7),(442,417574800,6),(442,433299600,7),(442,449024400,6),(442,465354000,7),(442,481078800,6),(442,496803600,7),(442,512528400,6),(442,528253200,7),(442,543978000,6),(442,559702800,7),(442,575427600,6),(442,591152400,7),(442,606877200,6),(442,622602000,7),(442,638326800,6),(442,654656400,7),(442,670381200,6),(442,686106000,7),(442,701830800,6),(442,717555600,7),(442,733280400,6),(442,749005200,7),(442,764730000,6),(442,780454800,7),(442,796179600,6),(442,811904400,7),(442,828234000,6),(442,846378000,7),(442,859683600,6),(442,877827600,7),(442,891133200,6),(442,909277200,7),(442,922582800,6),(442,941331600,7),(442,954032400,6),(442,972781200,7),(442,985482000,6),(442,1004230800,7),(442,1017536400,6),(442,1035680400,7),(442,1048986000,6),(442,1067130000,7),(442,1080435600,6),(442,1099184400,7),(442,1111885200,6),(442,1130634000,7),(442,1143334800,6),(442,1162083600,7),(442,1174784400,6),(442,1193533200,7),(442,1206838800,6),(442,1224982800,7),(442,1238288400,6),(442,1256432400,7),(442,1269738000,6),(442,1288486800,7),(442,1301187600,6),(442,1319936400,7),(442,1332637200,6),(442,1351386000,7),(442,1364691600,6),(442,1382835600,7),(442,1396141200,6),(442,1414285200,7),(442,1427590800,6),(442,1445734800,7),(442,1459040400,6),(442,1477789200,7),(442,1490490000,6),(442,1509238800,7),(442,1521939600,6),(442,1540688400,7),(442,1553994000,6),(442,1572138000,7),(442,1585443600,6),(442,1603587600,7),(442,1616893200,6),(442,1635642000,7),(442,1648342800,6),(442,1667091600,7),(442,1679792400,6),(442,1698541200,7),(442,1711846800,6),(442,1729990800,7),(442,1743296400,6),(442,1761440400,7),(442,1774746000,6),(442,1792890000,7),(442,1806195600,6),(442,1824944400,7),(442,1837645200,6),(442,1856394000,7),(442,1869094800,6),(442,1887843600,7),(442,1901149200,6),(442,1919293200,7),(442,1932598800,6),(442,1950742800,7),(442,1964048400,6),(442,1982797200,7),(442,1995498000,6),(442,2014246800,7),(442,2026947600,6),(442,2045696400,7),(442,2058397200,6),(442,2077146000,7),(442,2090451600,6),(442,2108595600,7),(442,2121901200,6),(442,2140045200,7),(443,-2147483648,4),(443,-1691964000,1),(443,-1680472800,2),(443,-1664143200,1),(443,-1650146400,2),(443,-1633903200,1),(443,-1617487200,2),(443,-1601848800,1),(443,-1586037600,2),(443,-1570399200,1),(443,-1552168800,2),(443,-1538344800,1),(443,-1522533600,2),(443,-1507500000,1),(443,-1490565600,2),(443,-1473631200,1),(443,-1460930400,2),(443,-1442786400,1),(443,-1428876000,2),(443,-1410732000,1),(443,-1396216800,2),(443,-1379282400,1),(443,-1364767200,2),(443,-1348437600,1),(443,-1333317600,2),(443,-1315778400,1),(443,-1301263200,2),(443,-1284328800,1),(443,-1269813600,2),(443,-1253484000,1),(443,-1238364000,2),(443,-1221429600,1),(443,-1206914400,2),(443,-1189980000,1),(443,-1175464800,2),(443,-1159135200,1),(443,-1143410400,2),(443,-1126476000,1),(443,-1111960800,2),(443,-1095631200,1),(443,-1080511200,2),(443,-1063576800,1),(443,-1049061600,2),(443,-1032127200,1),(443,-1017612000,2),(443,-1001282400,1),(443,-986162400,2),(443,-969228000,1),(443,-950479200,2),(443,-942012000,1),(443,-904518000,3),(443,-896050800,1),(443,-875487600,3),(443,-864601200,1),(443,-844038000,3),(443,-832546800,1),(443,-812588400,3),(443,-798073200,1),(443,-781052400,3),(443,-772066800,1),(443,-764805600,2),(443,-748476000,1),(443,-733356000,2),(443,-719445600,1),(443,-717030000,3),(443,-706748400,1),(443,-699487200,2),(443,-687996000,1),(443,-668037600,2),(443,-654732000,1),(443,-636588000,2),(443,-622072800,1),(443,-605743200,2),(443,-590623200,1),(443,-574293600,2),(443,-558568800,1),(443,-542239200,2),(443,-527119200,1),(443,-512604000,2),(443,-496274400,1),(443,-481154400,2),(443,-464220000,1),(443,-449704800,2),(443,-432165600,1),(443,-417650400,2),(443,-401320800,1),(443,-386200800,2),(443,-369266400,1),(443,-354751200,2),(443,-337816800,1),(443,-323301600,2),(443,-306972000,1),(443,-291852000,2),(443,-276732000,1),(443,-257983200,2),(443,-245282400,1),(443,-226533600,2),(443,-213228000,1),(443,-195084000,2),(443,-182383200,1),(443,-163634400,2),(443,-150933600,1),(443,-132184800,2),(443,-119484000,1),(443,-100735200,2),(443,-88034400,1),(443,-68680800,2),(443,-59004000,1),(443,-37242000,5),(443,57722400,7),(443,69818400,1),(443,89172000,2),(443,101268000,1),(443,120621600,2),(443,132717600,1),(443,152071200,2),(443,164167200,1),(443,183520800,2),(443,196221600,1),(443,214970400,2),(443,227671200,1),(443,246420000,2),(443,259120800,1),(443,278474400,2),(443,290570400,1),(443,309924000,2),(443,322020000,1),(443,341373600,2),(443,354675600,6),(443,372819600,7),(443,386125200,6),(443,404269200,7),(443,417574800,6),(443,435718800,7),(443,449024400,6),(443,467773200,7),(443,481078800,6),(443,499222800,7),(443,512528400,6),(443,530672400,7),(443,543978000,6),(443,562122000,7),(443,575427600,6),(443,593571600,7),(443,606877200,6),(443,625626000,7),(443,638326800,6),(443,657075600,7),(443,670381200,6),(443,688525200,7),(443,701830800,6),(443,719974800,7),(443,733280400,6),(443,751424400,7),(443,764730000,6),(443,782874000,7),(443,796179600,6),(443,814323600,7),(443,820454400,4),(443,828234000,6),(443,846378000,7),(443,859683600,6),(443,877827600,7),(443,891133200,6),(443,909277200,7),(443,922582800,6),(443,941331600,7),(443,954032400,6),(443,972781200,7),(443,985482000,6),(443,1004230800,7),(443,1017536400,6),(443,1035680400,7),(443,1048986000,6),(443,1067130000,7),(443,1080435600,6),(443,1099184400,7),(443,1111885200,6),(443,1130634000,7),(443,1143334800,6),(443,1162083600,7),(443,1174784400,6),(443,1193533200,7),(443,1206838800,6),(443,1224982800,7),(443,1238288400,6),(443,1256432400,7),(443,1269738000,6),(443,1288486800,7),(443,1301187600,6),(443,1319936400,7),(443,1332637200,6),(443,1351386000,7),(443,1364691600,6),(443,1382835600,7),(443,1396141200,6),(443,1414285200,7),(443,1427590800,6),(443,1445734800,7),(443,1459040400,6),(443,1477789200,7),(443,1490490000,6),(443,1509238800,7),(443,1521939600,6),(443,1540688400,7),(443,1553994000,6),(443,1572138000,7),(443,1585443600,6),(443,1603587600,7),(443,1616893200,6),(443,1635642000,7),(443,1648342800,6),(443,1667091600,7),(443,1679792400,6),(443,1698541200,7),(443,1711846800,6),(443,1729990800,7),(443,1743296400,6),(443,1761440400,7),(443,1774746000,6),(443,1792890000,7),(443,1806195600,6),(443,1824944400,7),(443,1837645200,6),(443,1856394000,7),(443,1869094800,6),(443,1887843600,7),(443,1901149200,6),(443,1919293200,7),(443,1932598800,6),(443,1950742800,7),(443,1964048400,6),(443,1982797200,7),(443,1995498000,6),(443,2014246800,7),(443,2026947600,6),(443,2045696400,7),(443,2058397200,6),(443,2077146000,7),(443,2090451600,6),(443,2108595600,7),(443,2121901200,6),(443,2140045200,7),(444,-2147483648,1),(444,-1535938789,3),(444,-875671200,2),(444,-859773600,3),(444,354672000,2),(444,370396800,3),(444,386121600,2),(444,401846400,3),(444,417574800,4),(444,433299600,5),(444,449024400,4),(444,465354000,5),(444,481078800,4),(444,496803600,5),(444,512528400,4),(444,528253200,5),(444,543978000,4),(444,559702800,5),(444,575427600,4),(444,591152400,5),(444,606877200,4),(444,622602000,5),(444,638326800,4),(444,654656400,5),(444,670381200,4),(444,686106000,5),(444,701830800,4),(444,717555600,5),(444,733280400,4),(444,749005200,5),(444,764730000,4),(444,780454800,5),(444,796179600,4),(444,811904400,5),(444,828234000,4),(444,846378000,5),(444,859683600,4),(444,877827600,5),(444,891133200,4),(444,909277200,5),(444,922582800,4),(444,941331600,5),(444,954032400,4),(444,972781200,5),(444,985482000,4),(444,1004230800,5),(444,1017536400,4),(444,1035680400,5),(444,1048986000,4),(444,1067130000,5),(444,1080435600,4),(444,1099184400,5),(444,1111885200,4),(444,1130634000,5),(444,1143334800,4),(444,1162083600,5),(444,1174784400,4),(444,1193533200,5),(444,1206838800,4),(444,1224982800,5),(444,1238288400,4),(444,1256432400,5),(444,1269738000,4),(444,1288486800,5),(444,1301187600,4),(444,1319936400,5),(444,1332637200,4),(444,1351386000,5),(444,1364691600,4),(444,1382835600,5),(444,1396141200,4),(444,1414285200,5),(444,1427590800,4),(444,1445734800,5),(444,1459040400,4),(444,1477789200,5),(444,1490490000,4),(444,1509238800,5),(444,1521939600,4),(444,1540688400,5),(444,1553994000,4),(444,1572138000,5),(444,1585443600,4),(444,1603587600,5),(444,1616893200,4),(444,1635642000,5),(444,1648342800,4),(444,1667091600,5),(444,1679792400,4),(444,1698541200,5),(444,1711846800,4),(444,1729990800,5),(444,1743296400,4),(444,1761440400,5),(444,1774746000,4),(444,1792890000,5),(444,1806195600,4),(444,1824944400,5),(444,1837645200,4),(444,1856394000,5),(444,1869094800,4),(444,1887843600,5),(444,1901149200,4),(444,1919293200,5),(444,1932598800,4),(444,1950742800,5),(444,1964048400,4),(444,1982797200,5),(444,1995498000,4),(444,2014246800,5),(444,2026947600,4),(444,2045696400,5),(444,2058397200,4),(444,2077146000,5),(444,2090451600,4),(444,2108595600,5),(444,2121901200,4),(444,2140045200,5),(445,-2147483648,4),(445,-1691964000,1),(445,-1680472800,2),(445,-1664143200,1),(445,-1650146400,2),(445,-1633903200,1),(445,-1617487200,2),(445,-1601848800,1),(445,-1586037600,2),(445,-1570399200,1),(445,-1552168800,2),(445,-1538344800,1),(445,-1522533600,2),(445,-1507500000,1),(445,-1490565600,2),(445,-1473631200,1),(445,-1460930400,2),(445,-1442786400,1),(445,-1428876000,2),(445,-1410732000,1),(445,-1396216800,2),(445,-1379282400,1),(445,-1364767200,2),(445,-1348437600,1),(445,-1333317600,2),(445,-1315778400,1),(445,-1301263200,2),(445,-1284328800,1),(445,-1269813600,2),(445,-1253484000,1),(445,-1238364000,2),(445,-1221429600,1),(445,-1206914400,2),(445,-1189980000,1),(445,-1175464800,2),(445,-1159135200,1),(445,-1143410400,2),(445,-1126476000,1),(445,-1111960800,2),(445,-1095631200,1),(445,-1080511200,2),(445,-1063576800,1),(445,-1049061600,2),(445,-1032127200,1),(445,-1017612000,2),(445,-1001282400,1),(445,-986162400,2),(445,-969228000,1),(445,-950479200,2),(445,-942012000,1),(445,-904518000,3),(445,-896050800,1),(445,-875487600,3),(445,-864601200,1),(445,-844038000,3),(445,-832546800,1),(445,-812588400,3),(445,-798073200,1),(445,-781052400,3),(445,-772066800,1),(445,-764805600,2),(445,-748476000,1),(445,-733356000,2),(445,-719445600,1),(445,-717030000,3),(445,-706748400,1),(445,-699487200,2),(445,-687996000,1),(445,-668037600,2),(445,-654732000,1),(445,-636588000,2),(445,-622072800,1),(445,-605743200,2),(445,-590623200,1),(445,-574293600,2),(445,-558568800,1),(445,-542239200,2),(445,-527119200,1),(445,-512604000,2),(445,-496274400,1),(445,-481154400,2),(445,-464220000,1),(445,-449704800,2),(445,-432165600,1),(445,-417650400,2),(445,-401320800,1),(445,-386200800,2),(445,-369266400,1),(445,-354751200,2),(445,-337816800,1),(445,-323301600,2),(445,-306972000,1),(445,-291852000,2),(445,-276732000,1),(445,-257983200,2),(445,-245282400,1),(445,-226533600,2),(445,-213228000,1),(445,-195084000,2),(445,-182383200,1),(445,-163634400,2),(445,-150933600,1),(445,-132184800,2),(445,-119484000,1),(445,-100735200,2),(445,-88034400,1),(445,-68680800,2),(445,-59004000,1),(445,-37242000,5),(445,57722400,7),(445,69818400,1),(445,89172000,2),(445,101268000,1),(445,120621600,2),(445,132717600,1),(445,152071200,2),(445,164167200,1),(445,183520800,2),(445,196221600,1),(445,214970400,2),(445,227671200,1),(445,246420000,2),(445,259120800,1),(445,278474400,2),(445,290570400,1),(445,309924000,2),(445,322020000,1),(445,341373600,2),(445,354675600,6),(445,372819600,7),(445,386125200,6),(445,404269200,7),(445,417574800,6),(445,435718800,7),(445,449024400,6),(445,467773200,7),(445,481078800,6),(445,499222800,7),(445,512528400,6),(445,530672400,7),(445,543978000,6),(445,562122000,7),(445,575427600,6),(445,593571600,7),(445,606877200,6),(445,625626000,7),(445,638326800,6),(445,657075600,7),(445,670381200,6),(445,688525200,7),(445,701830800,6),(445,719974800,7),(445,733280400,6),(445,751424400,7),(445,764730000,6),(445,782874000,7),(445,796179600,6),(445,814323600,7),(445,820454400,4),(445,828234000,6),(445,846378000,7),(445,859683600,6),(445,877827600,7),(445,891133200,6),(445,909277200,7),(445,922582800,6),(445,941331600,7),(445,954032400,6),(445,972781200,7),(445,985482000,6),(445,1004230800,7),(445,1017536400,6),(445,1035680400,7),(445,1048986000,6),(445,1067130000,7),(445,1080435600,6),(445,1099184400,7),(445,1111885200,6),(445,1130634000,7),(445,1143334800,6),(445,1162083600,7),(445,1174784400,6),(445,1193533200,7),(445,1206838800,6),(445,1224982800,7),(445,1238288400,6),(445,1256432400,7),(445,1269738000,6),(445,1288486800,7),(445,1301187600,6),(445,1319936400,7),(445,1332637200,6),(445,1351386000,7),(445,1364691600,6),(445,1382835600,7),(445,1396141200,6),(445,1414285200,7),(445,1427590800,6),(445,1445734800,7),(445,1459040400,6),(445,1477789200,7),(445,1490490000,6),(445,1509238800,7),(445,1521939600,6),(445,1540688400,7),(445,1553994000,6),(445,1572138000,7),(445,1585443600,6),(445,1603587600,7),(445,1616893200,6),(445,1635642000,7),(445,1648342800,6),(445,1667091600,7),(445,1679792400,6),(445,1698541200,7),(445,1711846800,6),(445,1729990800,7),(445,1743296400,6),(445,1761440400,7),(445,1774746000,6),(445,1792890000,7),(445,1806195600,6),(445,1824944400,7),(445,1837645200,6),(445,1856394000,7),(445,1869094800,6),(445,1887843600,7),(445,1901149200,6),(445,1919293200,7),(445,1932598800,6),(445,1950742800,7),(445,1964048400,6),(445,1982797200,7),(445,1995498000,6),(445,2014246800,7),(445,2026947600,6),(445,2045696400,7),(445,2058397200,6),(445,2077146000,7),(445,2090451600,6),(445,2108595600,7),(445,2121901200,6),(445,2140045200,7),(446,-2147483648,1),(446,-1869875816,3),(446,-1693706400,2),(446,-1680490800,3),(446,-1570413600,2),(446,-1552186800,3),(446,-1538359200,2),(446,-1522551600,3),(446,-1507514400,2),(446,-1490583600,3),(446,-1440208800,2),(446,-1428030000,3),(446,-1409709600,2),(446,-1396494000,3),(446,-931053600,2),(446,-922676400,3),(446,-917834400,2),(446,-892436400,3),(446,-875844000,2),(446,-764737200,3),(446,-744343200,2),(446,-733806000,3),(446,-716436000,2),(446,-701924400,3),(446,-684986400,2),(446,-670474800,3),(446,-654141600,2),(446,-639025200,3),(446,-622087200,2),(446,-606970800,3),(446,-590032800,2),(446,-575521200,3),(446,-235620000,2),(446,-194842800,3),(446,-177732000,2),(446,-165726000,3),(446,107910000,2),(446,121215600,3),(446,133920000,2),(446,152665200,3),(446,164678400,2),(446,184114800,3),(446,196214400,2),(446,215564400,3),(446,228873600,2),(446,245804400,3),(446,260323200,2),(446,267915600,4),(446,428454000,5),(446,433893600,4),(446,468111600,3),(446,482799600,6),(446,496710000,7),(446,512521200,6),(446,528246000,7),(446,543970800,6),(446,559695600,7),(446,575420400,6),(446,591145200,7),(446,606870000,6),(446,622594800,7),(446,638319600,6),(446,654649200,7),(446,670374000,6),(446,686098800,7),(446,701823600,6),(446,717548400,7),(446,733273200,6),(446,748998000,7),(446,764118000,6),(446,780447600,7),(446,796172400,6),(446,811897200,7),(446,828226800,6),(446,846370800,7),(446,859676400,6),(446,877820400,7),(446,891126000,6),(446,909270000,7),(446,922575600,6),(446,941324400,7),(446,954025200,6),(446,972774000,7),(446,985474800,6),(446,1004223600,7),(446,1017529200,6),(446,1035673200,7),(446,1048978800,6),(446,1067122800,7),(446,1080428400,6),(446,1099177200,7),(446,1111878000,6),(446,1130626800,7),(446,1143327600,6),(446,1162076400,7),(446,1167602400,3),(446,1174784400,8),(446,1193533200,9),(446,1206838800,8),(446,1224982800,9),(446,1238288400,8),(446,1256432400,9),(446,1269738000,8),(446,1288486800,9),(446,1301274000,8),(446,1319936400,9),(446,1332637200,8),(446,1351386000,9),(446,1364691600,8),(446,1382835600,9),(446,1396227600,8),(446,1414285200,9),(446,1427590800,8),(446,1446944400,9),(446,1459040400,8),(446,1473195600,4),(446,2147483647,4),(447,-2147483648,4),(447,-1691964000,1),(447,-1680472800,2),(447,-1664143200,1),(447,-1650146400,2),(447,-1633903200,1),(447,-1617487200,2),(447,-1601848800,1),(447,-1586037600,2),(447,-1570399200,1),(447,-1552168800,2),(447,-1538344800,1),(447,-1522533600,2),(447,-1507500000,1),(447,-1490565600,2),(447,-1473631200,1),(447,-1460930400,2),(447,-1442786400,1),(447,-1428876000,2),(447,-1410732000,1),(447,-1396216800,2),(447,-1379282400,1),(447,-1364767200,2),(447,-1348437600,1),(447,-1333317600,2),(447,-1315778400,1),(447,-1301263200,2),(447,-1284328800,1),(447,-1269813600,2),(447,-1253484000,1),(447,-1238364000,2),(447,-1221429600,1),(447,-1206914400,2),(447,-1189980000,1),(447,-1175464800,2),(447,-1159135200,1),(447,-1143410400,2),(447,-1126476000,1),(447,-1111960800,2),(447,-1095631200,1),(447,-1080511200,2),(447,-1063576800,1),(447,-1049061600,2),(447,-1032127200,1),(447,-1017612000,2),(447,-1001282400,1),(447,-986162400,2),(447,-969228000,1),(447,-950479200,2),(447,-942012000,1),(447,-904518000,3),(447,-896050800,1),(447,-875487600,3),(447,-864601200,1),(447,-844038000,3),(447,-832546800,1),(447,-812588400,3),(447,-798073200,1),(447,-781052400,3),(447,-772066800,1),(447,-764805600,2),(447,-748476000,1),(447,-733356000,2),(447,-719445600,1),(447,-717030000,3),(447,-706748400,1),(447,-699487200,2),(447,-687996000,1),(447,-668037600,2),(447,-654732000,1),(447,-636588000,2),(447,-622072800,1),(447,-605743200,2),(447,-590623200,1),(447,-574293600,2),(447,-558568800,1),(447,-542239200,2),(447,-527119200,1),(447,-512604000,2),(447,-496274400,1),(447,-481154400,2),(447,-464220000,1),(447,-449704800,2),(447,-432165600,1),(447,-417650400,2),(447,-401320800,1),(447,-386200800,2),(447,-369266400,1),(447,-354751200,2),(447,-337816800,1),(447,-323301600,2),(447,-306972000,1),(447,-291852000,2),(447,-276732000,1),(447,-257983200,2),(447,-245282400,1),(447,-226533600,2),(447,-213228000,1),(447,-195084000,2),(447,-182383200,1),(447,-163634400,2),(447,-150933600,1),(447,-132184800,2),(447,-119484000,1),(447,-100735200,2),(447,-88034400,1),(447,-68680800,2),(447,-59004000,1),(447,-37242000,5),(447,57722400,7),(447,69818400,1),(447,89172000,2),(447,101268000,1),(447,120621600,2),(447,132717600,1),(447,152071200,2),(447,164167200,1),(447,183520800,2),(447,196221600,1),(447,214970400,2),(447,227671200,1),(447,246420000,2),(447,259120800,1),(447,278474400,2),(447,290570400,1),(447,309924000,2),(447,322020000,1),(447,341373600,2),(447,354675600,6),(447,372819600,7),(447,386125200,6),(447,404269200,7),(447,417574800,6),(447,435718800,7),(447,449024400,6),(447,467773200,7),(447,481078800,6),(447,499222800,7),(447,512528400,6),(447,530672400,7),(447,543978000,6),(447,562122000,7),(447,575427600,6),(447,593571600,7),(447,606877200,6),(447,625626000,7),(447,638326800,6),(447,657075600,7),(447,670381200,6),(447,688525200,7),(447,701830800,6),(447,719974800,7),(447,733280400,6),(447,751424400,7),(447,764730000,6),(447,782874000,7),(447,796179600,6),(447,814323600,7),(447,820454400,4),(447,828234000,6),(447,846378000,7),(447,859683600,6),(447,877827600,7),(447,891133200,6),(447,909277200,7),(447,922582800,6),(447,941331600,7),(447,954032400,6),(447,972781200,7),(447,985482000,6),(447,1004230800,7),(447,1017536400,6),(447,1035680400,7),(447,1048986000,6),(447,1067130000,7),(447,1080435600,6),(447,1099184400,7),(447,1111885200,6),(447,1130634000,7),(447,1143334800,6),(447,1162083600,7),(447,1174784400,6),(447,1193533200,7),(447,1206838800,6),(447,1224982800,7),(447,1238288400,6),(447,1256432400,7),(447,1269738000,6),(447,1288486800,7),(447,1301187600,6),(447,1319936400,7),(447,1332637200,6),(447,1351386000,7),(447,1364691600,6),(447,1382835600,7),(447,1396141200,6),(447,1414285200,7),(447,1427590800,6),(447,1445734800,7),(447,1459040400,6),(447,1477789200,7),(447,1490490000,6),(447,1509238800,7),(447,1521939600,6),(447,1540688400,7),(447,1553994000,6),(447,1572138000,7),(447,1585443600,6),(447,1603587600,7),(447,1616893200,6),(447,1635642000,7),(447,1648342800,6),(447,1667091600,7),(447,1679792400,6),(447,1698541200,7),(447,1711846800,6),(447,1729990800,7),(447,1743296400,6),(447,1761440400,7),(447,1774746000,6),(447,1792890000,7),(447,1806195600,6),(447,1824944400,7),(447,1837645200,6),(447,1856394000,7),(447,1869094800,6),(447,1887843600,7),(447,1901149200,6),(447,1919293200,7),(447,1932598800,6),(447,1950742800,7),(447,1964048400,6),(447,1982797200,7),(447,1995498000,6),(447,2014246800,7),(447,2026947600,6),(447,2045696400,7),(447,2058397200,6),(447,2077146000,7),(447,2090451600,6),(447,2108595600,7),(447,2121901200,6),(447,2140045200,7),(448,-2147483648,2),(448,-1693706400,1),(448,-1680483600,2),(448,-1663455600,3),(448,-1650150000,4),(448,-1632006000,3),(448,-1618700400,4),(448,-938905200,3),(448,-857257200,4),(448,-844556400,3),(448,-828226800,4),(448,-812502000,3),(448,-796777200,4),(448,-781052400,3),(448,-780372000,6),(448,-778730400,5),(448,-762663600,6),(448,-749095200,8),(448,354920400,7),(448,370728000,8),(448,386456400,7),(448,402264000,8),(448,417992400,7),(448,433800000,8),(448,449614800,7),(448,465346800,9),(448,481071600,10),(448,496796400,9),(448,512521200,10),(448,528246000,9),(448,543970800,10),(448,559695600,9),(448,575420400,10),(448,591145200,9),(448,606870000,11),(448,622598400,12),(448,638323200,11),(448,654652800,12),(448,670377600,11),(448,686102400,12),(448,701827200,11),(448,717552000,12),(448,733276800,11),(448,749001600,12),(448,764726400,11),(448,780451200,12),(448,796176000,11),(448,811900800,12),(448,828230400,11),(448,846374400,12),(448,859680000,11),(448,877824000,12),(448,891129600,11),(448,909273600,12),(448,922579200,11),(448,941328000,12),(448,954028800,11),(448,972777600,12),(448,985478400,11),(448,1004227200,12),(448,1017532800,11),(448,1035676800,12),(448,1048982400,11),(448,1067126400,12),(448,1080432000,11),(448,1099180800,12),(448,1111881600,11),(448,1130630400,12),(448,1143331200,11),(448,1162080000,12),(448,1174780800,11),(448,1193529600,12),(448,1206835200,11),(448,1224979200,12),(448,1238284800,11),(448,1256428800,12),(448,1269734400,11),(448,1288483200,12),(448,1301184000,13),(448,1414278000,12),(449,-2147483648,1),(449,-1441159324,2),(449,-1247536800,3),(449,-892522800,6),(449,-857257200,4),(449,-844556400,5),(449,-828226800,4),(449,-825382800,3),(449,354920400,7),(449,370728000,3),(449,386456400,7),(449,402264000,3),(449,417992400,7),(449,433800000,3),(449,449614800,7),(449,465346800,8),(449,481071600,9),(449,496796400,8),(449,512521200,9),(449,528246000,8),(449,543970800,9),(449,559695600,8),(449,575420400,9),(449,591145200,8),(449,606870000,9),(449,622594800,8),(449,638319600,9),(449,646783200,10),(449,686102400,11),(449,701827200,12),(449,717552000,11),(449,733276800,12),(449,749001600,11),(449,764726400,12),(449,780451200,11),(449,796176000,12),(449,811900800,11),(449,828230400,12),(449,831934800,10),(449,846378000,13),(449,859683600,14),(449,877827600,13),(449,891133200,14),(449,909277200,13),(449,922582800,14),(449,941331600,13),(449,954032400,14),(449,972781200,13),(449,985482000,14),(449,1004230800,13),(449,1017536400,14),(449,1035680400,13),(449,1048986000,14),(449,1067130000,13),(449,1080435600,14),(449,1099184400,13),(449,1111885200,14),(449,1130634000,13),(449,1143334800,14),(449,1162083600,13),(449,1174784400,14),(449,1193533200,13),(449,1206838800,14),(449,1224982800,13),(449,1238288400,14),(449,1256432400,13),(449,1269738000,14),(449,1288486800,13),(449,1301187600,14),(449,1319936400,13),(449,1332637200,14),(449,1351386000,13),(449,1364691600,14),(449,1382835600,13),(449,1396141200,14),(449,1414285200,13),(449,1427590800,14),(449,1445734800,13),(449,1459040400,14),(449,1477789200,13),(449,1490490000,14),(449,1509238800,13),(449,1521939600,14),(449,1540688400,13),(449,1553994000,14),(449,1572138000,13),(449,1585443600,14),(449,1603587600,13),(449,1616893200,14),(449,1635642000,13),(449,1648342800,14),(449,1667091600,13),(449,1679792400,14),(449,1698541200,13),(449,1711846800,14),(449,1729990800,13),(449,1743296400,14),(449,1761440400,13),(449,1774746000,14),(449,1792890000,13),(449,1806195600,14),(449,1824944400,13),(449,1837645200,14),(449,1856394000,13),(449,1869094800,14),(449,1887843600,13),(449,1901149200,14),(449,1919293200,13),(449,1932598800,14),(449,1950742800,13),(449,1964048400,14),(449,1982797200,13),(449,1995498000,14),(449,2014246800,13),(449,2026947600,14),(449,2045696400,13),(449,2058397200,14),(449,2077146000,13),(449,2090451600,14),(449,2108595600,13),(449,2121901200,14),(449,2140045200,13),(450,-2147483648,0),(450,-1593820800,1),(450,-1247540400,3),(450,354916800,2),(450,370724400,3),(450,386452800,2),(450,402260400,3),(450,417988800,2),(450,433796400,3),(450,449611200,2),(450,465343200,4),(450,481068000,5),(450,496792800,4),(450,512517600,5),(450,528242400,4),(450,543967200,5),(450,559692000,4),(450,575416800,5),(450,591141600,4),(450,606866400,6),(450,622594800,7),(450,638319600,6),(450,654649200,7),(450,670374000,4),(450,701820000,6),(450,717548400,7),(450,733273200,6),(450,748998000,7),(450,764722800,6),(450,780447600,7),(450,796172400,6),(450,811897200,7),(450,828226800,6),(450,846370800,7),(450,859676400,6),(450,877820400,7),(450,891126000,6),(450,909270000,7),(450,922575600,6),(450,941324400,7),(450,954025200,6),(450,972774000,7),(450,985474800,6),(450,1004223600,7),(450,1017529200,6),(450,1035673200,7),(450,1048978800,6),(450,1067122800,7),(450,1080428400,6),(450,1099177200,7),(450,1111878000,6),(450,1130626800,7),(450,1143327600,6),(450,1162076400,7),(450,1174777200,6),(450,1193526000,7),(450,1206831600,6),(450,1224975600,7),(450,1238281200,6),(450,1256425200,7),(450,1269730800,6),(450,1288479600,7),(450,1301180400,8),(450,1414274400,7),(451,-2147483648,1),(451,-1441159324,2),(451,-1247536800,3),(451,-892522800,6),(451,-857257200,4),(451,-844556400,5),(451,-828226800,4),(451,-825382800,3),(451,354920400,7),(451,370728000,3),(451,386456400,7),(451,402264000,3),(451,417992400,7),(451,433800000,3),(451,449614800,7),(451,465346800,8),(451,481071600,9),(451,496796400,8),(451,512521200,9),(451,528246000,8),(451,543970800,9),(451,559695600,8),(451,575420400,9),(451,591145200,8),(451,606870000,9),(451,622594800,8),(451,638319600,9),(451,646783200,10),(451,686102400,11),(451,701827200,12),(451,717552000,11),(451,733276800,12),(451,749001600,11),(451,764726400,12),(451,780451200,11),(451,796176000,12),(451,811900800,11),(451,828230400,12),(451,831934800,10),(451,846378000,13),(451,859683600,14),(451,877827600,13),(451,891133200,14),(451,909277200,13),(451,922582800,14),(451,941331600,13),(451,954032400,14),(451,972781200,13),(451,985482000,14),(451,1004230800,13),(451,1017536400,14),(451,1035680400,13),(451,1048986000,14),(451,1067130000,13),(451,1080435600,14),(451,1099184400,13),(451,1111885200,14),(451,1130634000,13),(451,1143334800,14),(451,1162083600,13),(451,1174784400,14),(451,1193533200,13),(451,1206838800,14),(451,1224982800,13),(451,1238288400,14),(451,1256432400,13),(451,1269738000,14),(451,1288486800,13),(451,1301187600,14),(451,1319936400,13),(451,1332637200,14),(451,1351386000,13),(451,1364691600,14),(451,1382835600,13),(451,1396141200,14),(451,1414285200,13),(451,1427590800,14),(451,1445734800,13),(451,1459040400,14),(451,1477789200,13),(451,1490490000,14),(451,1509238800,13),(451,1521939600,14),(451,1540688400,13),(451,1553994000,14),(451,1572138000,13),(451,1585443600,14),(451,1603587600,13),(451,1616893200,14),(451,1635642000,13),(451,1648342800,14),(451,1667091600,13),(451,1679792400,14),(451,1698541200,13),(451,1711846800,14),(451,1729990800,13),(451,1743296400,14),(451,1761440400,13),(451,1774746000,14),(451,1792890000,13),(451,1806195600,14),(451,1824944400,13),(451,1837645200,14),(451,1856394000,13),(451,1869094800,14),(451,1887843600,13),(451,1901149200,14),(451,1919293200,13),(451,1932598800,14),(451,1950742800,13),(451,1964048400,14),(451,1982797200,13),(451,1995498000,14),(451,2014246800,13),(451,2026947600,14),(451,2045696400,13),(451,2058397200,14),(451,2077146000,13),(451,2090451600,14),(451,2108595600,13),(451,2121901200,14),(451,2140045200,13),(452,-2147483648,0),(452,-1830384000,6),(452,-1689555600,1),(452,-1677801600,2),(452,-1667437200,3),(452,-1647738000,4),(452,-1635814800,3),(452,-1616202000,4),(452,-1604365200,3),(452,-1584666000,4),(452,-1572742800,3),(452,-1553043600,4),(452,-1541206800,3),(452,-1521507600,4),(452,-1442451600,3),(452,-1426813200,4),(452,-1379293200,3),(452,-1364778000,4),(452,-1348448400,3),(452,-1333328400,4),(452,-1316394000,3),(452,-1301274000,4),(452,-1284339600,3),(452,-1269824400,4),(452,-1221440400,3),(452,-1206925200,4),(452,-1191200400,3),(452,-1175475600,4),(452,-1127696400,3),(452,-1111971600,4),(452,-1096851600,3),(452,-1080522000,4),(452,-1063587600,3),(452,-1049072400,4),(452,-1033347600,3),(452,-1017622800,4),(452,-1002502800,3),(452,-986173200,4),(452,-969238800,3),(452,-950490000,4),(452,-942022800,3),(452,-922669200,4),(452,-906944400,3),(452,-891133200,4),(452,-877309200,3),(452,-873684000,5),(452,-864007200,3),(452,-857955600,4),(452,-845859600,3),(452,-842839200,5),(452,-831348000,3),(452,-825901200,4),(452,-814410000,3),(452,-810784800,5),(452,-799898400,3),(452,-794451600,4),(452,-782960400,3),(452,-779335200,5),(452,-768448800,3),(452,-763002000,4),(452,-749091600,3),(452,-733366800,4),(452,-717631200,3),(452,-701906400,4),(452,-686181600,3),(452,-670456800,4),(452,-654732000,3),(452,-639007200,4),(452,-623282400,3),(452,-607557600,4),(452,-591832800,3),(452,-575503200,4),(452,-559778400,3),(452,-544053600,4),(452,-528328800,3),(452,-512604000,4),(452,-496879200,3),(452,-481154400,4),(452,-465429600,3),(452,-449704800,4),(452,-433980000,3),(452,-417650400,4),(452,-401925600,3),(452,-386200800,4),(452,-370476000,3),(452,-354751200,4),(452,-339026400,3),(452,-323301600,4),(452,-307576800,3),(452,-291852000,4),(452,-276127200,3),(452,-260402400,4),(452,-244677600,3),(452,-228348000,4),(452,-212623200,3),(452,-196898400,4),(452,-181173600,3),(452,-165448800,4),(452,-149724000,3),(452,-133999200,4),(452,-118274400,7),(452,212544000,2),(452,228268800,3),(452,243993600,4),(452,260323200,3),(452,276048000,4),(452,291772800,3),(452,307501200,4),(452,323222400,3),(452,338950800,4),(452,354675600,3),(452,370400400,4),(452,386125200,3),(452,401850000,4),(452,417578400,3),(452,433299600,4),(452,449024400,3),(452,465354000,4),(452,481078800,3),(452,496803600,4),(452,512528400,3),(452,528253200,4),(452,543978000,3),(452,559702800,4),(452,575427600,3),(452,591152400,4),(452,606877200,3),(452,622602000,4),(452,638326800,3),(452,654656400,4),(452,670381200,3),(452,686106000,4),(452,701830800,3),(452,717555600,8),(452,733280400,9),(452,749005200,8),(452,764730000,9),(452,780454800,8),(452,796179600,9),(452,811904400,8),(452,828234000,10),(452,846378000,6),(452,859683600,10),(452,877827600,6),(452,891133200,10),(452,909277200,6),(452,922582800,10),(452,941331600,6),(452,954032400,10),(452,972781200,6),(452,985482000,10),(452,1004230800,6),(452,1017536400,10),(452,1035680400,6),(452,1048986000,10),(452,1067130000,6),(452,1080435600,10),(452,1099184400,6),(452,1111885200,10),(452,1130634000,6),(452,1143334800,10),(452,1162083600,6),(452,1174784400,10),(452,1193533200,6),(452,1206838800,10),(452,1224982800,6),(452,1238288400,10),(452,1256432400,6),(452,1269738000,10),(452,1288486800,6),(452,1301187600,10),(452,1319936400,6),(452,1332637200,10),(452,1351386000,6),(452,1364691600,10),(452,1382835600,6),(452,1396141200,10),(452,1414285200,6),(452,1427590800,10),(452,1445734800,6),(452,1459040400,10),(452,1477789200,6),(452,1490490000,10),(452,1509238800,6),(452,1521939600,10),(452,1540688400,6),(452,1553994000,10),(452,1572138000,6),(452,1585443600,10),(452,1603587600,6),(452,1616893200,10),(452,1635642000,6),(452,1648342800,10),(452,1667091600,6),(452,1679792400,10),(452,1698541200,6),(452,1711846800,10),(452,1729990800,6),(452,1743296400,10),(452,1761440400,6),(452,1774746000,10),(452,1792890000,6),(452,1806195600,10),(452,1824944400,6),(452,1837645200,10),(452,1856394000,6),(452,1869094800,10),(452,1887843600,6),(452,1901149200,10),(452,1919293200,6),(452,1932598800,10),(452,1950742800,6),(452,1964048400,10),(452,1982797200,6),(452,1995498000,10),(452,2014246800,6),(452,2026947600,10),(452,2045696400,6),(452,2058397200,10),(452,2077146000,6),(452,2090451600,10),(452,2108595600,6),(452,2121901200,10),(452,2140045200,6),(453,-2147483648,1),(453,-905824800,4),(453,-857257200,2),(453,-844556400,3),(453,-828226800,2),(453,-812502000,3),(453,-796777200,2),(453,-788922000,1),(453,-777942000,3),(453,-766623600,2),(453,407199600,1),(453,417574800,5),(453,433299600,6),(453,449024400,5),(453,465354000,6),(453,481078800,5),(453,496803600,6),(453,512528400,5),(453,528253200,6),(453,543978000,5),(453,559702800,6),(453,575427600,5),(453,591152400,6),(453,606877200,5),(453,622602000,6),(453,638326800,5),(453,654656400,6),(453,670381200,5),(453,686106000,6),(453,701830800,5),(453,717555600,6),(453,733280400,5),(453,749005200,6),(453,764730000,5),(453,780454800,6),(453,796179600,5),(453,811904400,6),(453,828234000,5),(453,846378000,6),(453,859683600,5),(453,877827600,6),(453,891133200,5),(453,909277200,6),(453,922582800,5),(453,941331600,6),(453,954032400,5),(453,972781200,6),(453,985482000,5),(453,1004230800,6),(453,1017536400,5),(453,1035680400,6),(453,1048986000,5),(453,1067130000,6),(453,1080435600,5),(453,1099184400,6),(453,1111885200,5),(453,1130634000,6),(453,1143334800,5),(453,1162083600,6),(453,1174784400,5),(453,1193533200,6),(453,1206838800,5),(453,1224982800,6),(453,1238288400,5),(453,1256432400,6),(453,1269738000,5),(453,1288486800,6),(453,1301187600,5),(453,1319936400,6),(453,1332637200,5),(453,1351386000,6),(453,1364691600,5),(453,1382835600,6),(453,1396141200,5),(453,1414285200,6),(453,1427590800,5),(453,1445734800,6),(453,1459040400,5),(453,1477789200,6),(453,1490490000,5),(453,1509238800,6),(453,1521939600,5),(453,1540688400,6),(453,1553994000,5),(453,1572138000,6),(453,1585443600,5),(453,1603587600,6),(453,1616893200,5),(453,1635642000,6),(453,1648342800,5),(453,1667091600,6),(453,1679792400,5),(453,1698541200,6),(453,1711846800,5),(453,1729990800,6),(453,1743296400,5),(453,1761440400,6),(453,1774746000,5),(453,1792890000,6),(453,1806195600,5),(453,1824944400,6),(453,1837645200,5),(453,1856394000,6),(453,1869094800,5),(453,1887843600,6),(453,1901149200,5),(453,1919293200,6),(453,1932598800,5),(453,1950742800,6),(453,1964048400,5),(453,1982797200,6),(453,1995498000,5),(453,2014246800,6),(453,2026947600,5),(453,2045696400,6),(453,2058397200,5),(453,2077146000,6),(453,2090451600,5),(453,2108595600,6),(453,2121901200,5),(453,2140045200,6),(454,-2147483648,4),(454,-1691964000,1),(454,-1680472800,2),(454,-1664143200,1),(454,-1650146400,2),(454,-1633903200,1),(454,-1617487200,2),(454,-1601848800,1),(454,-1586037600,2),(454,-1570399200,1),(454,-1552168800,2),(454,-1538344800,1),(454,-1522533600,2),(454,-1507500000,1),(454,-1490565600,2),(454,-1473631200,1),(454,-1460930400,2),(454,-1442786400,1),(454,-1428876000,2),(454,-1410732000,1),(454,-1396216800,2),(454,-1379282400,1),(454,-1364767200,2),(454,-1348437600,1),(454,-1333317600,2),(454,-1315778400,1),(454,-1301263200,2),(454,-1284328800,1),(454,-1269813600,2),(454,-1253484000,1),(454,-1238364000,2),(454,-1221429600,1),(454,-1206914400,2),(454,-1189980000,1),(454,-1175464800,2),(454,-1159135200,1),(454,-1143410400,2),(454,-1126476000,1),(454,-1111960800,2),(454,-1095631200,1),(454,-1080511200,2),(454,-1063576800,1),(454,-1049061600,2),(454,-1032127200,1),(454,-1017612000,2),(454,-1001282400,1),(454,-986162400,2),(454,-969228000,1),(454,-950479200,2),(454,-942012000,1),(454,-904518000,3),(454,-896050800,1),(454,-875487600,3),(454,-864601200,1),(454,-844038000,3),(454,-832546800,1),(454,-812588400,3),(454,-798073200,1),(454,-781052400,3),(454,-772066800,1),(454,-764805600,2),(454,-748476000,1),(454,-733356000,2),(454,-719445600,1),(454,-717030000,3),(454,-706748400,1),(454,-699487200,2),(454,-687996000,1),(454,-668037600,2),(454,-654732000,1),(454,-636588000,2),(454,-622072800,1),(454,-605743200,2),(454,-590623200,1),(454,-574293600,2),(454,-558568800,1),(454,-542239200,2),(454,-527119200,1),(454,-512604000,2),(454,-496274400,1),(454,-481154400,2),(454,-464220000,1),(454,-449704800,2),(454,-432165600,1),(454,-417650400,2),(454,-401320800,1),(454,-386200800,2),(454,-369266400,1),(454,-354751200,2),(454,-337816800,1),(454,-323301600,2),(454,-306972000,1),(454,-291852000,2),(454,-276732000,1),(454,-257983200,2),(454,-245282400,1),(454,-226533600,2),(454,-213228000,1),(454,-195084000,2),(454,-182383200,1),(454,-163634400,2),(454,-150933600,1),(454,-132184800,2),(454,-119484000,1),(454,-100735200,2),(454,-88034400,1),(454,-68680800,2),(454,-59004000,1),(454,-37242000,5),(454,57722400,7),(454,69818400,1),(454,89172000,2),(454,101268000,1),(454,120621600,2),(454,132717600,1),(454,152071200,2),(454,164167200,1),(454,183520800,2),(454,196221600,1),(454,214970400,2),(454,227671200,1),(454,246420000,2),(454,259120800,1),(454,278474400,2),(454,290570400,1),(454,309924000,2),(454,322020000,1),(454,341373600,2),(454,354675600,6),(454,372819600,7),(454,386125200,6),(454,404269200,7),(454,417574800,6),(454,435718800,7),(454,449024400,6),(454,467773200,7),(454,481078800,6),(454,499222800,7),(454,512528400,6),(454,530672400,7),(454,543978000,6),(454,562122000,7),(454,575427600,6),(454,593571600,7),(454,606877200,6),(454,625626000,7),(454,638326800,6),(454,657075600,7),(454,670381200,6),(454,688525200,7),(454,701830800,6),(454,719974800,7),(454,733280400,6),(454,751424400,7),(454,764730000,6),(454,782874000,7),(454,796179600,6),(454,814323600,7),(454,820454400,4),(454,828234000,6),(454,846378000,7),(454,859683600,6),(454,877827600,7),(454,891133200,6),(454,909277200,7),(454,922582800,6),(454,941331600,7),(454,954032400,6),(454,972781200,7),(454,985482000,6),(454,1004230800,7),(454,1017536400,6),(454,1035680400,7),(454,1048986000,6),(454,1067130000,7),(454,1080435600,6),(454,1099184400,7),(454,1111885200,6),(454,1130634000,7),(454,1143334800,6),(454,1162083600,7),(454,1174784400,6),(454,1193533200,7),(454,1206838800,6),(454,1224982800,7),(454,1238288400,6),(454,1256432400,7),(454,1269738000,6),(454,1288486800,7),(454,1301187600,6),(454,1319936400,7),(454,1332637200,6),(454,1351386000,7),(454,1364691600,6),(454,1382835600,7),(454,1396141200,6),(454,1414285200,7),(454,1427590800,6),(454,1445734800,7),(454,1459040400,6),(454,1477789200,7),(454,1490490000,6),(454,1509238800,7),(454,1521939600,6),(454,1540688400,7),(454,1553994000,6),(454,1572138000,7),(454,1585443600,6),(454,1603587600,7),(454,1616893200,6),(454,1635642000,7),(454,1648342800,6),(454,1667091600,7),(454,1679792400,6),(454,1698541200,7),(454,1711846800,6),(454,1729990800,7),(454,1743296400,6),(454,1761440400,7),(454,1774746000,6),(454,1792890000,7),(454,1806195600,6),(454,1824944400,7),(454,1837645200,6),(454,1856394000,7),(454,1869094800,6),(454,1887843600,7),(454,1901149200,6),(454,1919293200,7),(454,1932598800,6),(454,1950742800,7),(454,1964048400,6),(454,1982797200,7),(454,1995498000,6),(454,2014246800,7),(454,2026947600,6),(454,2045696400,7),(454,2058397200,6),(454,2077146000,7),(454,2090451600,6),(454,2108595600,7),(454,2121901200,6),(454,2140045200,7),(455,-2147483648,1),(455,-1740355200,2),(455,-1693702800,5),(455,-1680483600,2),(455,-1663455600,3),(455,-1650150000,4),(455,-1632006000,3),(455,-1618700400,4),(455,-1613826000,8),(455,-1604278800,6),(455,-1585530000,7),(455,-1574038800,6),(455,-1552266000,7),(455,-1539997200,6),(455,-1520557200,7),(455,-1507510800,6),(455,-1490576400,7),(455,-1473642000,6),(455,-1459126800,7),(455,-1444006800,6),(455,-1427677200,7),(455,-1411952400,6),(455,-1396227600,7),(455,-1379293200,6),(455,-1364778000,7),(455,-1348448400,6),(455,-1333328400,7),(455,-1316394000,6),(455,-1301263200,7),(455,-1284328800,6),(455,-1269813600,7),(455,-1253484000,6),(455,-1238364000,7),(455,-1221429600,6),(455,-1206914400,7),(455,-1191189600,6),(455,-1175464800,7),(455,-1160344800,6),(455,-1143410400,7),(455,-1127685600,6),(455,-1111960800,7),(455,-1096840800,6),(455,-1080511200,7),(455,-1063576800,6),(455,-1049061600,7),(455,-1033336800,6),(455,-1017612000,7),(455,-1002492000,6),(455,-986162400,7),(455,-969228000,6),(455,-950479200,7),(455,-942012000,6),(455,-934668000,3),(455,-857257200,4),(455,-844556400,3),(455,-828226800,4),(455,-812502000,3),(455,-799293600,5),(455,-798073200,4),(455,-781052400,3),(455,-766623600,4),(455,-745455600,3),(455,-733273200,4),(455,220921200,2),(455,228877200,9),(455,243997200,10),(455,260326800,9),(455,276051600,10),(455,291776400,9),(455,307501200,10),(455,323830800,9),(455,338950800,10),(455,354675600,9),(455,370400400,10),(455,386125200,9),(455,401850000,10),(455,417574800,9),(455,433299600,10),(455,449024400,9),(455,465354000,10),(455,481078800,9),(455,496803600,10),(455,512528400,9),(455,528253200,10),(455,543978000,9),(455,559702800,10),(455,575427600,9),(455,591152400,10),(455,606877200,9),(455,622602000,10),(455,638326800,9),(455,654656400,10),(455,670381200,9),(455,686106000,10),(455,701830800,9),(455,717555600,10),(455,733280400,9),(455,749005200,10),(455,764730000,9),(455,780454800,10),(455,796179600,9),(455,811904400,10),(455,828234000,9),(455,846378000,10),(455,859683600,9),(455,877827600,10),(455,891133200,9),(455,909277200,10),(455,922582800,9),(455,941331600,10),(455,954032400,9),(455,972781200,10),(455,985482000,9),(455,1004230800,10),(455,1017536400,9),(455,1035680400,10),(455,1048986000,9),(455,1067130000,10),(455,1080435600,9),(455,1099184400,10),(455,1111885200,9),(455,1130634000,10),(455,1143334800,9),(455,1162083600,10),(455,1174784400,9),(455,1193533200,10),(455,1206838800,9),(455,1224982800,10),(455,1238288400,9),(455,1256432400,10),(455,1269738000,9),(455,1288486800,10),(455,1301187600,9),(455,1319936400,10),(455,1332637200,9),(455,1351386000,10),(455,1364691600,9),(455,1382835600,10),(455,1396141200,9),(455,1414285200,10),(455,1427590800,9),(455,1445734800,10),(455,1459040400,9),(455,1477789200,10),(455,1490490000,9),(455,1509238800,10),(455,1521939600,9),(455,1540688400,10),(455,1553994000,9),(455,1572138000,10),(455,1585443600,9),(455,1603587600,10),(455,1616893200,9),(455,1635642000,10),(455,1648342800,9),(455,1667091600,10),(455,1679792400,9),(455,1698541200,10),(455,1711846800,9),(455,1729990800,10),(455,1743296400,9),(455,1761440400,10),(455,1774746000,9),(455,1792890000,10),(455,1806195600,9),(455,1824944400,10),(455,1837645200,9),(455,1856394000,10),(455,1869094800,9),(455,1887843600,10),(455,1901149200,9),(455,1919293200,10),(455,1932598800,9),(455,1950742800,10),(455,1964048400,9),(455,1982797200,10),(455,1995498000,9),(455,2014246800,10),(455,2026947600,9),(455,2045696400,10),(455,2058397200,9),(455,2077146000,10),(455,2090451600,9),(455,2108595600,10),(455,2121901200,9),(455,2140045200,10),(456,-2147483648,4),(456,-1631926800,1),(456,-1616889600,2),(456,-1601168400,1),(456,-1585353600,2),(456,-1442451600,1),(456,-1427673600,2),(456,-1379293200,1),(456,-1364774400,2),(456,-1348448400,1),(456,-1333324800,2),(456,-1316390400,1),(456,-1301270400,2),(456,-1284339600,1),(456,-1269820800,2),(456,-1026954000,1),(456,-1017619200,2),(456,-1001898000,1),(456,-999482400,3),(456,-986090400,1),(456,-954115200,2),(456,-940208400,6),(456,-873079200,5),(456,-862621200,6),(456,-842839200,5),(456,-828320400,6),(456,-811389600,5),(456,-796870800,6),(456,-779940000,5),(456,-765421200,6),(456,-748490400,5),(456,-733971600,6),(456,-652327200,5),(456,-639018000,6),(456,135122400,5),(456,150246000,6),(456,166572000,5),(456,181695600,6),(456,196812000,5),(456,212540400,6),(456,228866400,5),(456,243990000,6),(456,260326800,7),(456,276051600,8),(456,283993200,6),(456,291776400,9),(456,307501200,10),(456,323830800,9),(456,338950800,10),(456,354675600,9),(456,370400400,10),(456,386125200,9),(456,401850000,10),(456,417574800,9),(456,433299600,10),(456,449024400,9),(456,465354000,10),(456,481078800,9),(456,496803600,10),(456,512528400,9),(456,528253200,10),(456,543978000,9),(456,559702800,10),(456,575427600,9),(456,591152400,10),(456,606877200,9),(456,622602000,10),(456,638326800,9),(456,654656400,10),(456,670381200,9),(456,686106000,10),(456,701830800,9),(456,717555600,10),(456,733280400,9),(456,749005200,10),(456,764730000,9),(456,780454800,10),(456,796179600,9),(456,811904400,10),(456,828234000,9),(456,846378000,10),(456,859683600,9),(456,877827600,10),(456,891133200,9),(456,909277200,10),(456,922582800,9),(456,941331600,10),(456,954032400,9),(456,972781200,10),(456,985482000,9),(456,1004230800,10),(456,1017536400,9),(456,1035680400,10),(456,1048986000,9),(456,1067130000,10),(456,1080435600,9),(456,1099184400,10),(456,1111885200,9),(456,1130634000,10),(456,1143334800,9),(456,1162083600,10),(456,1174784400,9),(456,1193533200,10),(456,1206838800,9),(456,1224982800,10),(456,1238288400,9),(456,1256432400,10),(456,1269738000,9),(456,1288486800,10),(456,1301187600,9),(456,1319936400,10),(456,1332637200,9),(456,1351386000,10),(456,1364691600,9),(456,1382835600,10),(456,1396141200,9),(456,1414285200,10),(456,1427590800,9),(456,1445734800,10),(456,1459040400,9),(456,1477789200,10),(456,1490490000,9),(456,1509238800,10),(456,1521939600,9),(456,1540688400,10),(456,1553994000,9),(456,1572138000,10),(456,1585443600,9),(456,1603587600,10),(456,1616893200,9),(456,1635642000,10),(456,1648342800,9),(456,1667091600,10),(456,1679792400,9),(456,1698541200,10),(456,1711846800,9),(456,1729990800,10),(456,1743296400,9),(456,1761440400,10),(456,1774746000,9),(456,1792890000,10),(456,1806195600,9),(456,1824944400,10),(456,1837645200,9),(456,1856394000,10),(456,1869094800,9),(456,1887843600,10),(456,1901149200,9),(456,1919293200,10),(456,1932598800,9),(456,1950742800,10),(456,1964048400,9),(456,1982797200,10),(456,1995498000,9),(456,2014246800,10),(456,2026947600,9),(456,2045696400,10),(456,2058397200,9),(456,2077146000,10),(456,2090451600,9),(456,2108595600,10),(456,2121901200,9),(456,2140045200,10),(457,-2147483648,2),(457,-1690765200,1),(457,-1680487200,2),(457,-1664758800,1),(457,-1648951200,2),(457,-1635123600,1),(457,-1616896800,2),(457,-1604278800,1),(457,-1585533600,2),(457,-1571014800,1),(457,-1555293600,2),(457,-932432400,1),(457,-857257200,3),(457,-844556400,4),(457,-828226800,3),(457,-812588400,4),(457,-798073200,3),(457,-781052400,1),(457,-766717200,2),(457,-750898800,4),(457,-733359600,3),(457,-719456400,4),(457,-701917200,3),(457,-689209200,4),(457,-670460400,3),(457,-114051600,4),(457,-103168800,2),(457,-81997200,4),(457,-71715600,3),(457,-50547600,4),(457,-40266000,3),(457,-18493200,4),(457,-8211600,3),(457,12956400,4),(457,23238000,3),(457,43801200,4),(457,54687600,3),(457,75855600,4),(457,86742000,3),(457,102380400,4),(457,118105200,3),(457,135730800,4),(457,148518000,3),(457,167187600,1),(457,180489600,2),(457,198637200,1),(457,211939200,2),(457,230086800,1),(457,243388800,2),(457,261536400,1),(457,274838400,2),(457,292986000,1),(457,306288000,2),(457,323312400,1),(457,338342400,2),(457,354675600,5),(457,370400400,6),(457,386125200,5),(457,401850000,6),(457,417574800,5),(457,433299600,6),(457,449024400,5),(457,465354000,6),(457,481078800,5),(457,496803600,6),(457,512528400,5),(457,528253200,6),(457,543978000,5),(457,559702800,6),(457,575427600,5),(457,591152400,6),(457,606877200,5),(457,622602000,6),(457,638326800,5),(457,654656400,6),(457,670381200,5),(457,686106000,6),(457,701830800,5),(457,717555600,6),(457,733280400,5),(457,749005200,6),(457,764730000,5),(457,780454800,6),(457,796179600,5),(457,811904400,6),(457,828234000,5),(457,846378000,6),(457,859683600,5),(457,877827600,6),(457,891133200,5),(457,909277200,6),(457,922582800,5),(457,941331600,6),(457,954032400,5),(457,972781200,6),(457,985482000,5),(457,1004230800,6),(457,1017536400,5),(457,1035680400,6),(457,1048986000,5),(457,1067130000,6),(457,1080435600,5),(457,1099184400,6),(457,1111885200,5),(457,1130634000,6),(457,1143334800,5),(457,1162083600,6),(457,1174784400,5),(457,1193533200,6),(457,1206838800,5),(457,1224982800,6),(457,1238288400,5),(457,1256432400,6),(457,1269738000,5),(457,1288486800,6),(457,1301187600,5),(457,1319936400,6),(457,1332637200,5),(457,1351386000,6),(457,1364691600,5),(457,1382835600,6),(457,1396141200,5),(457,1414285200,6),(457,1427590800,5),(457,1445734800,6),(457,1459040400,5),(457,1477789200,6),(457,1490490000,5),(457,1509238800,6),(457,1521939600,5),(457,1540688400,6),(457,1553994000,5),(457,1572138000,6),(457,1585443600,5),(457,1603587600,6),(457,1616893200,5),(457,1635642000,6),(457,1648342800,5),(457,1667091600,6),(457,1679792400,5),(457,1698541200,6),(457,1711846800,5),(457,1729990800,6),(457,1743296400,5),(457,1761440400,6),(457,1774746000,5),(457,1792890000,6),(457,1806195600,5),(457,1824944400,6),(457,1837645200,5),(457,1856394000,6),(457,1869094800,5),(457,1887843600,6),(457,1901149200,5),(457,1919293200,6),(457,1932598800,5),(457,1950742800,6),(457,1964048400,5),(457,1982797200,6),(457,1995498000,5),(457,2014246800,6),(457,2026947600,5),(457,2045696400,6),(457,2058397200,5),(457,2077146000,6),(457,2090451600,5),(457,2108595600,6),(457,2121901200,5),(457,2140045200,6),(458,-2147483648,1),(458,-1535938789,3),(458,-875671200,2),(458,-859773600,3),(458,354672000,2),(458,370396800,3),(458,386121600,2),(458,401846400,3),(458,417574800,4),(458,433299600,5),(458,449024400,4),(458,465354000,5),(458,481078800,4),(458,496803600,5),(458,512528400,4),(458,528253200,5),(458,543978000,4),(458,559702800,5),(458,575427600,4),(458,591152400,5),(458,606877200,4),(458,622602000,5),(458,638326800,4),(458,654656400,5),(458,670381200,4),(458,686106000,5),(458,701830800,4),(458,717555600,5),(458,733280400,4),(458,749005200,5),(458,764730000,4),(458,780454800,5),(458,796179600,4),(458,811904400,5),(458,828234000,4),(458,846378000,5),(458,859683600,4),(458,877827600,5),(458,891133200,4),(458,909277200,5),(458,922582800,4),(458,941331600,5),(458,954032400,4),(458,972781200,5),(458,985482000,4),(458,1004230800,5),(458,1017536400,4),(458,1035680400,5),(458,1048986000,4),(458,1067130000,5),(458,1080435600,4),(458,1099184400,5),(458,1111885200,4),(458,1130634000,5),(458,1143334800,4),(458,1162083600,5),(458,1174784400,4),(458,1193533200,5),(458,1206838800,4),(458,1224982800,5),(458,1238288400,4),(458,1256432400,5),(458,1269738000,4),(458,1288486800,5),(458,1301187600,4),(458,1319936400,5),(458,1332637200,4),(458,1351386000,5),(458,1364691600,4),(458,1382835600,5),(458,1396141200,4),(458,1414285200,5),(458,1427590800,4),(458,1445734800,5),(458,1459040400,4),(458,1477789200,5),(458,1490490000,4),(458,1509238800,5),(458,1521939600,4),(458,1540688400,5),(458,1553994000,4),(458,1572138000,5),(458,1585443600,4),(458,1603587600,5),(458,1616893200,4),(458,1635642000,5),(458,1648342800,4),(458,1667091600,5),(458,1679792400,4),(458,1698541200,5),(458,1711846800,4),(458,1729990800,5),(458,1743296400,4),(458,1761440400,5),(458,1774746000,4),(458,1792890000,5),(458,1806195600,4),(458,1824944400,5),(458,1837645200,4),(458,1856394000,5),(458,1869094800,4),(458,1887843600,5),(458,1901149200,4),(458,1919293200,5),(458,1932598800,4),(458,1950742800,5),(458,1964048400,4),(458,1982797200,5),(458,1995498000,4),(458,2014246800,5),(458,2026947600,4),(458,2045696400,5),(458,2058397200,4),(458,2077146000,5),(458,2090451600,4),(458,2108595600,5),(458,2121901200,4),(458,2140045200,5),(459,-2147483648,1),(459,-1441158600,2),(459,-1247536800,3),(459,-899780400,6),(459,-857257200,4),(459,-844556400,5),(459,-828226800,4),(459,-812502000,5),(459,-804650400,3),(459,354920400,7),(459,370728000,3),(459,386456400,7),(459,402264000,3),(459,417992400,7),(459,433800000,3),(459,449614800,7),(459,465346800,8),(459,481071600,9),(459,496796400,8),(459,512521200,9),(459,528246000,8),(459,543970800,9),(459,559695600,8),(459,575420400,9),(459,591145200,8),(459,606870000,9),(459,622594800,8),(459,631141200,3),(459,670374000,10),(459,686102400,11),(459,701827200,10),(459,717552000,11),(459,733276800,10),(459,749001600,11),(459,764726400,10),(459,780451200,11),(459,796176000,10),(459,811900800,11),(459,828230400,10),(459,846374400,11),(459,859680000,10),(459,877824000,11),(459,891129600,10),(459,909273600,11),(459,922579200,10),(459,941328000,11),(459,954028800,10),(459,972777600,11),(459,985478400,10),(459,1004227200,11),(459,1017532800,10),(459,1035676800,11),(459,1048982400,10),(459,1067126400,11),(459,1080432000,10),(459,1099180800,11),(459,1111881600,10),(459,1130630400,11),(459,1143331200,10),(459,1162080000,11),(459,1174780800,10),(459,1193529600,11),(459,1206835200,10),(459,1224979200,11),(459,1238284800,10),(459,1256428800,11),(459,1269734400,10),(459,1288483200,11),(459,1301184000,12),(459,2147483647,12),(460,-2147483648,1),(460,-1855958961,5),(460,-1689814800,2),(460,-1680397200,3),(460,-1665363600,2),(460,-1648342800,3),(460,-1635123600,2),(460,-1616893200,3),(460,-1604278800,2),(460,-1585443600,3),(460,-1574038800,2),(460,-1552266000,3),(460,-1539997200,2),(460,-1520557200,3),(460,-1507510800,2),(460,-1490576400,3),(460,-1470618000,2),(460,-1459126800,3),(460,-1444006800,2),(460,-1427677200,3),(460,-1411952400,2),(460,-1396227600,3),(460,-1379293200,2),(460,-1364778000,3),(460,-1348448400,2),(460,-1333328400,3),(460,-1316394000,2),(460,-1301274000,3),(460,-1284339600,2),(460,-1269824400,3),(460,-1253494800,2),(460,-1238374800,3),(460,-1221440400,2),(460,-1206925200,3),(460,-1191200400,2),(460,-1175475600,3),(460,-1160355600,2),(460,-1143421200,3),(460,-1127696400,2),(460,-1111971600,3),(460,-1096851600,2),(460,-1080522000,3),(460,-1063587600,2),(460,-1049072400,3),(460,-1033347600,2),(460,-1017622800,3),(460,-1002502800,2),(460,-986173200,3),(460,-969238800,2),(460,-950490000,3),(460,-942012000,4),(460,-932436000,8),(460,-857257200,6),(460,-844556400,7),(460,-828226800,6),(460,-812502000,7),(460,-800071200,9),(460,-796266000,4),(460,-781052400,9),(460,-766623600,10),(460,196819200,8),(460,212540400,10),(460,228877200,11),(460,243997200,12),(460,260326800,11),(460,276051600,12),(460,291776400,11),(460,307501200,12),(460,323830800,11),(460,338950800,12),(460,354675600,11),(460,370400400,12),(460,386125200,11),(460,401850000,12),(460,417574800,11),(460,433299600,12),(460,449024400,11),(460,465354000,12),(460,481078800,11),(460,496803600,12),(460,512528400,11),(460,528253200,12),(460,543978000,11),(460,559702800,12),(460,575427600,11),(460,591152400,12),(460,606877200,11),(460,622602000,12),(460,638326800,11),(460,654656400,12),(460,670381200,11),(460,686106000,12),(460,701830800,11),(460,717555600,12),(460,733280400,11),(460,749005200,12),(460,764730000,11),(460,780454800,12),(460,796179600,11),(460,811904400,12),(460,828234000,11),(460,846378000,12),(460,859683600,11),(460,877827600,12),(460,891133200,11),(460,909277200,12),(460,922582800,11),(460,941331600,12),(460,954032400,11),(460,972781200,12),(460,985482000,11),(460,1004230800,12),(460,1017536400,11),(460,1035680400,12),(460,1048986000,11),(460,1067130000,12),(460,1080435600,11),(460,1099184400,12),(460,1111885200,11),(460,1130634000,12),(460,1143334800,11),(460,1162083600,12),(460,1174784400,11),(460,1193533200,12),(460,1206838800,11),(460,1224982800,12),(460,1238288400,11),(460,1256432400,12),(460,1269738000,11),(460,1288486800,12),(460,1301187600,11),(460,1319936400,12),(460,1332637200,11),(460,1351386000,12),(460,1364691600,11),(460,1382835600,12),(460,1396141200,11),(460,1414285200,12),(460,1427590800,11),(460,1445734800,12),(460,1459040400,11),(460,1477789200,12),(460,1490490000,11),(460,1509238800,12),(460,1521939600,11),(460,1540688400,12),(460,1553994000,11),(460,1572138000,12),(460,1585443600,11),(460,1603587600,12),(460,1616893200,11),(460,1635642000,12),(460,1648342800,11),(460,1667091600,12),(460,1679792400,11),(460,1698541200,12),(460,1711846800,11),(460,1729990800,12),(460,1743296400,11),(460,1761440400,12),(460,1774746000,11),(460,1792890000,12),(460,1806195600,11),(460,1824944400,12),(460,1837645200,11),(460,1856394000,12),(460,1869094800,11),(460,1887843600,12),(460,1901149200,11),(460,1919293200,12),(460,1932598800,11),(460,1950742800,12),(460,1964048400,11),(460,1982797200,12),(460,1995498000,11),(460,2014246800,12),(460,2026947600,11),(460,2045696400,12),(460,2058397200,11),(460,2077146000,12),(460,2090451600,11),(460,2108595600,12),(460,2121901200,11),(460,2140045200,12),(461,-2147483648,1),(461,-1688265017,3),(461,-1656819079,2),(461,-1641353479,3),(461,-1627965079,4),(461,-1618716679,2),(461,-1596429079,4),(461,-1593820800,5),(461,-1589860800,6),(461,-1542427200,7),(461,-1539493200,8),(461,-1525323600,7),(461,-1522728000,6),(461,-1491188400,9),(461,-1247536800,6),(461,354920400,7),(461,370728000,6),(461,386456400,7),(461,402264000,6),(461,417992400,7),(461,433800000,6),(461,449614800,7),(461,465346800,10),(461,481071600,11),(461,496796400,10),(461,512521200,11),(461,528246000,10),(461,543970800,11),(461,559695600,10),(461,575420400,11),(461,591145200,10),(461,606870000,11),(461,622594800,10),(461,638319600,11),(461,654649200,10),(461,670374000,12),(461,686102400,13),(461,695779200,10),(461,701823600,11),(461,717548400,10),(461,733273200,11),(461,748998000,10),(461,764722800,11),(461,780447600,10),(461,796172400,11),(461,811897200,10),(461,828226800,11),(461,846370800,10),(461,859676400,11),(461,877820400,10),(461,891126000,11),(461,909270000,10),(461,922575600,11),(461,941324400,10),(461,954025200,11),(461,972774000,10),(461,985474800,11),(461,1004223600,10),(461,1017529200,11),(461,1035673200,10),(461,1048978800,11),(461,1067122800,10),(461,1080428400,11),(461,1099177200,10),(461,1111878000,11),(461,1130626800,10),(461,1143327600,11),(461,1162076400,10),(461,1174777200,11),(461,1193526000,10),(461,1206831600,11),(461,1224975600,10),(461,1238281200,11),(461,1256425200,10),(461,1269730800,11),(461,1288479600,10),(461,1301180400,14),(461,1414274400,10),(462,-2147483648,0),(462,-1518920008,2),(462,166572000,1),(462,182293200,2),(462,200959200,1),(462,213829200,2),(462,228866400,1),(462,243982800,2),(462,260316000,1),(462,276123600,2),(462,291765600,1),(462,307486800,2),(462,323820000,1),(462,338936400,2),(462,354664800,1),(462,370386000,2),(462,386114400,1),(462,401835600,2),(462,417564000,1),(462,433285200,2),(462,449013600,1),(462,465339600,2),(462,481068000,1),(462,496789200,2),(462,512517600,1),(462,528238800,2),(462,543967200,1),(462,559688400,2),(462,575416800,1),(462,591138000,2),(462,606866400,1),(462,622587600,2),(462,638316000,1),(462,654642000,2),(462,670370400,1),(462,686091600,2),(462,701820000,1),(462,717541200,2),(462,733269600,1),(462,748990800,2),(462,764719200,1),(462,780440400,2),(462,796168800,1),(462,811890000,2),(462,828223200,1),(462,843944400,2),(462,859672800,1),(462,875394000,2),(462,891122400,1),(462,909277200,3),(462,922582800,4),(462,941331600,3),(462,954032400,4),(462,972781200,3),(462,985482000,4),(462,1004230800,3),(462,1017536400,4),(462,1035680400,3),(462,1048986000,4),(462,1067130000,3),(462,1080435600,4),(462,1099184400,3),(462,1111885200,4),(462,1130634000,3),(462,1143334800,4),(462,1162083600,3),(462,1174784400,4),(462,1193533200,3),(462,1206838800,4),(462,1224982800,3),(462,1238288400,4),(462,1256432400,3),(462,1269738000,4),(462,1288486800,3),(462,1301187600,4),(462,1319936400,3),(462,1332637200,4),(462,1351386000,3),(462,1364691600,4),(462,1382835600,3),(462,1396141200,4),(462,1414285200,3),(462,1427590800,4),(462,1445734800,3),(462,1459040400,4),(462,1477789200,3),(462,1490490000,4),(462,1509238800,3),(462,1521939600,4),(462,1540688400,3),(462,1553994000,4),(462,1572138000,3),(462,1585443600,4),(462,1603587600,3),(462,1616893200,4),(462,1635642000,3),(462,1648342800,4),(462,1667091600,3),(462,1679792400,4),(462,1698541200,3),(462,1711846800,4),(462,1729990800,3),(462,1743296400,4),(462,1761440400,3),(462,1774746000,4),(462,1792890000,3),(462,1806195600,4),(462,1824944400,3),(462,1837645200,4),(462,1856394000,3),(462,1869094800,4),(462,1887843600,3),(462,1901149200,4),(462,1919293200,3),(462,1932598800,4),(462,1950742800,3),(462,1964048400,4),(462,1982797200,3),(462,1995498000,4),(462,2014246800,3),(462,2026947600,4),(462,2045696400,3),(462,2058397200,4),(462,2077146000,3),(462,2090451600,4),(462,2108595600,3),(462,2121901200,4),(462,2140045200,3),(463,-2147483648,2),(463,-1693706400,1),(463,-1680483600,2),(463,-1663455600,3),(463,-1650150000,4),(463,-1632006000,3),(463,-1618700400,4),(463,-938905200,3),(463,-857257200,4),(463,-844556400,3),(463,-828226800,4),(463,-812502000,3),(463,-796777200,4),(463,-781052400,3),(463,-776563200,5),(463,-765936000,1),(463,-761180400,4),(463,-757386000,2),(463,-748479600,3),(463,-733273200,4),(463,-717631200,3),(463,-714610800,6),(463,-710380800,1),(463,-701910000,4),(463,-684975600,3),(463,-670460400,4),(463,-654130800,3),(463,-639010800,4),(463,315529200,2),(463,323830800,7),(463,338950800,8),(463,354675600,7),(463,370400400,8),(463,386125200,7),(463,401850000,8),(463,417574800,7),(463,433299600,8),(463,449024400,7),(463,465354000,8),(463,481078800,7),(463,496803600,8),(463,512528400,7),(463,528253200,8),(463,543978000,7),(463,559702800,8),(463,575427600,7),(463,591152400,8),(463,606877200,7),(463,622602000,8),(463,638326800,7),(463,654656400,8),(463,670381200,7),(463,686106000,8),(463,701830800,7),(463,717555600,8),(463,733280400,7),(463,749005200,8),(463,764730000,7),(463,780454800,8),(463,796179600,7),(463,811904400,8),(463,828234000,7),(463,846378000,8),(463,859683600,7),(463,877827600,8),(463,891133200,7),(463,909277200,8),(463,922582800,7),(463,941331600,8),(463,954032400,7),(463,972781200,8),(463,985482000,7),(463,1004230800,8),(463,1017536400,7),(463,1035680400,8),(463,1048986000,7),(463,1067130000,8),(463,1080435600,7),(463,1099184400,8),(463,1111885200,7),(463,1130634000,8),(463,1143334800,7),(463,1162083600,8),(463,1174784400,7),(463,1193533200,8),(463,1206838800,7),(463,1224982800,8),(463,1238288400,7),(463,1256432400,8),(463,1269738000,7),(463,1288486800,8),(463,1301187600,7),(463,1319936400,8),(463,1332637200,7),(463,1351386000,8),(463,1364691600,7),(463,1382835600,8),(463,1396141200,7),(463,1414285200,8),(463,1427590800,7),(463,1445734800,8),(463,1459040400,7),(463,1477789200,8),(463,1490490000,7),(463,1509238800,8),(463,1521939600,7),(463,1540688400,8),(463,1553994000,7),(463,1572138000,8),(463,1585443600,7),(463,1603587600,8),(463,1616893200,7),(463,1635642000,8),(463,1648342800,7),(463,1667091600,8),(463,1679792400,7),(463,1698541200,8),(463,1711846800,7),(463,1729990800,8),(463,1743296400,7),(463,1761440400,8),(463,1774746000,7),(463,1792890000,8),(463,1806195600,7),(463,1824944400,8),(463,1837645200,7),(463,1856394000,8),(463,1869094800,7),(463,1887843600,8),(463,1901149200,7),(463,1919293200,8),(463,1932598800,7),(463,1950742800,8),(463,1964048400,7),(463,1982797200,8),(463,1995498000,7),(463,2014246800,8),(463,2026947600,7),(463,2045696400,8),(463,2058397200,7),(463,2077146000,8),(463,2090451600,7),(463,2108595600,8),(463,2121901200,7),(463,2140045200,8),(464,-2147483648,1),(464,-1855958961,5),(464,-1689814800,2),(464,-1680397200,3),(464,-1665363600,2),(464,-1648342800,3),(464,-1635123600,2),(464,-1616893200,3),(464,-1604278800,2),(464,-1585443600,3),(464,-1574038800,2),(464,-1552266000,3),(464,-1539997200,2),(464,-1520557200,3),(464,-1507510800,2),(464,-1490576400,3),(464,-1470618000,2),(464,-1459126800,3),(464,-1444006800,2),(464,-1427677200,3),(464,-1411952400,2),(464,-1396227600,3),(464,-1379293200,2),(464,-1364778000,3),(464,-1348448400,2),(464,-1333328400,3),(464,-1316394000,2),(464,-1301274000,3),(464,-1284339600,2),(464,-1269824400,3),(464,-1253494800,2),(464,-1238374800,3),(464,-1221440400,2),(464,-1206925200,3),(464,-1191200400,2),(464,-1175475600,3),(464,-1160355600,2),(464,-1143421200,3),(464,-1127696400,2),(464,-1111971600,3),(464,-1096851600,2),(464,-1080522000,3),(464,-1063587600,2),(464,-1049072400,3),(464,-1033347600,2),(464,-1017622800,3),(464,-1002502800,2),(464,-986173200,3),(464,-969238800,2),(464,-950490000,3),(464,-942012000,4),(464,-932436000,8),(464,-857257200,6),(464,-844556400,7),(464,-828226800,6),(464,-812502000,7),(464,-800071200,9),(464,-796266000,4),(464,-781052400,9),(464,-766623600,10),(464,196819200,8),(464,212540400,10),(464,228877200,11),(464,243997200,12),(464,260326800,11),(464,276051600,12),(464,291776400,11),(464,307501200,12),(464,323830800,11),(464,338950800,12),(464,354675600,11),(464,370400400,12),(464,386125200,11),(464,401850000,12),(464,417574800,11),(464,433299600,12),(464,449024400,11),(464,465354000,12),(464,481078800,11),(464,496803600,12),(464,512528400,11),(464,528253200,12),(464,543978000,11),(464,559702800,12),(464,575427600,11),(464,591152400,12),(464,606877200,11),(464,622602000,12),(464,638326800,11),(464,654656400,12),(464,670381200,11),(464,686106000,12),(464,701830800,11),(464,717555600,12),(464,733280400,11),(464,749005200,12),(464,764730000,11),(464,780454800,12),(464,796179600,11),(464,811904400,12),(464,828234000,11),(464,846378000,12),(464,859683600,11),(464,877827600,12),(464,891133200,11),(464,909277200,12),(464,922582800,11),(464,941331600,12),(464,954032400,11),(464,972781200,12),(464,985482000,11),(464,1004230800,12),(464,1017536400,11),(464,1035680400,12),(464,1048986000,11),(464,1067130000,12),(464,1080435600,11),(464,1099184400,12),(464,1111885200,11),(464,1130634000,12),(464,1143334800,11),(464,1162083600,12),(464,1174784400,11),(464,1193533200,12),(464,1206838800,11),(464,1224982800,12),(464,1238288400,11),(464,1256432400,12),(464,1269738000,11),(464,1288486800,12),(464,1301187600,11),(464,1319936400,12),(464,1332637200,11),(464,1351386000,12),(464,1364691600,11),(464,1382835600,12),(464,1396141200,11),(464,1414285200,12),(464,1427590800,11),(464,1445734800,12),(464,1459040400,11),(464,1477789200,12),(464,1490490000,11),(464,1509238800,12),(464,1521939600,11),(464,1540688400,12),(464,1553994000,11),(464,1572138000,12),(464,1585443600,11),(464,1603587600,12),(464,1616893200,11),(464,1635642000,12),(464,1648342800,11),(464,1667091600,12),(464,1679792400,11),(464,1698541200,12),(464,1711846800,11),(464,1729990800,12),(464,1743296400,11),(464,1761440400,12),(464,1774746000,11),(464,1792890000,12),(464,1806195600,11),(464,1824944400,12),(464,1837645200,11),(464,1856394000,12),(464,1869094800,11),(464,1887843600,12),(464,1901149200,11),(464,1919293200,12),(464,1932598800,11),(464,1950742800,12),(464,1964048400,11),(464,1982797200,12),(464,1995498000,11),(464,2014246800,12),(464,2026947600,11),(464,2045696400,12),(464,2058397200,11),(464,2077146000,12),(464,2090451600,11),(464,2108595600,12),(464,2121901200,11),(464,2140045200,12),(465,-2147483648,1),(465,-905824800,4),(465,-857257200,2),(465,-844556400,3),(465,-828226800,2),(465,-812502000,3),(465,-796777200,2),(465,-788922000,1),(465,-777942000,3),(465,-766623600,2),(465,407199600,1),(465,417574800,5),(465,433299600,6),(465,449024400,5),(465,465354000,6),(465,481078800,5),(465,496803600,6),(465,512528400,5),(465,528253200,6),(465,543978000,5),(465,559702800,6),(465,575427600,5),(465,591152400,6),(465,606877200,5),(465,622602000,6),(465,638326800,5),(465,654656400,6),(465,670381200,5),(465,686106000,6),(465,701830800,5),(465,717555600,6),(465,733280400,5),(465,749005200,6),(465,764730000,5),(465,780454800,6),(465,796179600,5),(465,811904400,6),(465,828234000,5),(465,846378000,6),(465,859683600,5),(465,877827600,6),(465,891133200,5),(465,909277200,6),(465,922582800,5),(465,941331600,6),(465,954032400,5),(465,972781200,6),(465,985482000,5),(465,1004230800,6),(465,1017536400,5),(465,1035680400,6),(465,1048986000,5),(465,1067130000,6),(465,1080435600,5),(465,1099184400,6),(465,1111885200,5),(465,1130634000,6),(465,1143334800,5),(465,1162083600,6),(465,1174784400,5),(465,1193533200,6),(465,1206838800,5),(465,1224982800,6),(465,1238288400,5),(465,1256432400,6),(465,1269738000,5),(465,1288486800,6),(465,1301187600,5),(465,1319936400,6),(465,1332637200,5),(465,1351386000,6),(465,1364691600,5),(465,1382835600,6),(465,1396141200,5),(465,1414285200,6),(465,1427590800,5),(465,1445734800,6),(465,1459040400,5),(465,1477789200,6),(465,1490490000,5),(465,1509238800,6),(465,1521939600,5),(465,1540688400,6),(465,1553994000,5),(465,1572138000,6),(465,1585443600,5),(465,1603587600,6),(465,1616893200,5),(465,1635642000,6),(465,1648342800,5),(465,1667091600,6),(465,1679792400,5),(465,1698541200,6),(465,1711846800,5),(465,1729990800,6),(465,1743296400,5),(465,1761440400,6),(465,1774746000,5),(465,1792890000,6),(465,1806195600,5),(465,1824944400,6),(465,1837645200,5),(465,1856394000,6),(465,1869094800,5),(465,1887843600,6),(465,1901149200,5),(465,1919293200,6),(465,1932598800,5),(465,1950742800,6),(465,1964048400,5),(465,1982797200,6),(465,1995498000,5),(465,2014246800,6),(465,2026947600,5),(465,2045696400,6),(465,2058397200,5),(465,2077146000,6),(465,2090451600,5),(465,2108595600,6),(465,2121901200,5),(465,2140045200,6),(466,-2147483648,2),(466,-1693706400,1),(466,-1680483600,2),(466,-1663455600,3),(466,-1650150000,4),(466,-1632006000,3),(466,-1618700400,4),(466,-938905200,3),(466,-857257200,4),(466,-844556400,3),(466,-828226800,4),(466,-812502000,3),(466,-796777200,4),(466,-781052400,3),(466,-777866400,1),(466,-765327600,4),(466,-746578800,3),(466,-733359600,4),(466,-728517600,5),(466,-721260000,2),(466,-716425200,3),(466,-701910000,4),(466,-684975600,3),(466,-670460400,4),(466,-654217200,3),(466,-639010800,4),(466,283993200,2),(466,291776400,6),(466,307501200,7),(466,323830800,6),(466,338950800,7),(466,354675600,6),(466,370400400,7),(466,386125200,6),(466,401850000,7),(466,417574800,6),(466,433299600,7),(466,449024400,6),(466,465354000,7),(466,481078800,6),(466,496803600,7),(466,512528400,6),(466,528253200,7),(466,543978000,6),(466,559702800,7),(466,575427600,6),(466,591152400,7),(466,606877200,6),(466,622602000,7),(466,638326800,6),(466,654656400,7),(466,670381200,6),(466,686106000,7),(466,701830800,6),(466,717555600,7),(466,733280400,6),(466,749005200,7),(466,764730000,6),(466,780454800,7),(466,796179600,6),(466,811904400,7),(466,828234000,6),(466,846378000,7),(466,859683600,6),(466,877827600,7),(466,891133200,6),(466,909277200,7),(466,922582800,6),(466,941331600,7),(466,954032400,6),(466,972781200,7),(466,985482000,6),(466,1004230800,7),(466,1017536400,6),(466,1035680400,7),(466,1048986000,6),(466,1067130000,7),(466,1080435600,6),(466,1099184400,7),(466,1111885200,6),(466,1130634000,7),(466,1143334800,6),(466,1162083600,7),(466,1174784400,6),(466,1193533200,7),(466,1206838800,6),(466,1224982800,7),(466,1238288400,6),(466,1256432400,7),(466,1269738000,6),(466,1288486800,7),(466,1301187600,6),(466,1319936400,7),(466,1332637200,6),(466,1351386000,7),(466,1364691600,6),(466,1382835600,7),(466,1396141200,6),(466,1414285200,7),(466,1427590800,6),(466,1445734800,7),(466,1459040400,6),(466,1477789200,7),(466,1490490000,6),(466,1509238800,7),(466,1521939600,6),(466,1540688400,7),(466,1553994000,6),(466,1572138000,7),(466,1585443600,6),(466,1603587600,7),(466,1616893200,6),(466,1635642000,7),(466,1648342800,6),(466,1667091600,7),(466,1679792400,6),(466,1698541200,7),(466,1711846800,6),(466,1729990800,7),(466,1743296400,6),(466,1761440400,7),(466,1774746000,6),(466,1792890000,7),(466,1806195600,6),(466,1824944400,7),(466,1837645200,6),(466,1856394000,7),(466,1869094800,6),(466,1887843600,7),(466,1901149200,6),(466,1919293200,7),(466,1932598800,6),(466,1950742800,7),(466,1964048400,6),(466,1982797200,7),(466,1995498000,6),(466,2014246800,7),(466,2026947600,6),(466,2045696400,7),(466,2058397200,6),(466,2077146000,7),(466,2090451600,6),(466,2108595600,7),(466,2121901200,6),(466,2140045200,7),(467,-2147483648,1),(467,-1632008194,2),(467,-1618702594,1),(467,-1601681794,2),(467,-1597275394,1),(467,-1377308194,3),(467,-928029600,4),(467,-899521200,7),(467,-857257200,5),(467,-844556400,6),(467,-828226800,5),(467,-812502000,6),(467,-796777200,5),(467,-795834000,4),(467,354920400,8),(467,370728000,4),(467,386456400,8),(467,402264000,4),(467,417992400,8),(467,433800000,4),(467,449614800,8),(467,465346800,9),(467,481071600,10),(467,496796400,9),(467,512521200,10),(467,528246000,9),(467,543970800,10),(467,559695600,9),(467,575420400,10),(467,591145200,9),(467,606870000,11),(467,622598400,12),(467,638323200,11),(467,654652800,12),(467,670377600,11),(467,686102400,12),(467,701827200,11),(467,717552000,12),(467,733276800,11),(467,749001600,12),(467,764726400,11),(467,780451200,12),(467,796176000,11),(467,811900800,12),(467,828230400,11),(467,843955200,12),(467,853797600,3),(467,859683600,13),(467,877827600,14),(467,891133200,13),(467,909277200,14),(467,922582800,13),(467,941331600,14),(467,951775200,3),(467,985482000,13),(467,1004230800,14),(467,1017536400,13),(467,1035680400,14),(467,1048986000,13),(467,1067130000,14),(467,1080435600,13),(467,1099184400,14),(467,1111885200,13),(467,1130634000,14),(467,1143334800,13),(467,1162083600,14),(467,1174784400,13),(467,1193533200,14),(467,1206838800,13),(467,1224982800,14),(467,1238288400,13),(467,1256432400,14),(467,1269738000,13),(467,1288486800,14),(467,1301187600,13),(467,1319936400,14),(467,1332637200,13),(467,1351386000,14),(467,1364691600,13),(467,1382835600,14),(467,1396141200,13),(467,1414285200,14),(467,1427590800,13),(467,1445734800,14),(467,1459040400,13),(467,1477789200,14),(467,1490490000,13),(467,1509238800,14),(467,1521939600,13),(467,1540688400,14),(467,1553994000,13),(467,1572138000,14),(467,1585443600,13),(467,1603587600,14),(467,1616893200,13),(467,1635642000,14),(467,1648342800,13),(467,1667091600,14),(467,1679792400,13),(467,1698541200,14),(467,1711846800,13),(467,1729990800,14),(467,1743296400,13),(467,1761440400,14),(467,1774746000,13),(467,1792890000,14),(467,1806195600,13),(467,1824944400,14),(467,1837645200,13),(467,1856394000,14),(467,1869094800,13),(467,1887843600,14),(467,1901149200,13),(467,1919293200,14),(467,1932598800,13),(467,1950742800,14),(467,1964048400,13),(467,1982797200,14),(467,1995498000,13),(467,2014246800,14),(467,2026947600,13),(467,2045696400,14),(467,2058397200,13),(467,2077146000,14),(467,2090451600,13),(467,2108595600,14),(467,2121901200,13),(467,2140045200,14),(468,-2147483648,5),(468,-1690765200,1),(468,-1680487200,2),(468,-1664758800,1),(468,-1648951200,2),(468,-1635123600,1),(468,-1616896800,2),(468,-1604278800,1),(468,-1585533600,2),(468,-1571014800,1),(468,-1555293600,2),(468,-932432400,1),(468,-857257200,3),(468,-844556400,4),(468,-830311200,1),(468,-828226800,3),(468,-812502000,4),(468,-807156000,1),(468,-798073200,3),(468,-781052400,1),(468,-766717200,2),(468,-750898800,4),(468,-733359600,3),(468,-719456400,4),(468,-701917200,3),(468,-689209200,4),(468,-670460400,3),(468,-114051600,4),(468,-103168800,2),(468,-81997200,4),(468,-71715600,3),(468,-50547600,4),(468,-40266000,3),(468,-18493200,4),(468,-8211600,3),(468,12956400,4),(468,23238000,3),(468,43801200,4),(468,54687600,3),(468,75855600,4),(468,86742000,3),(468,107910000,4),(468,118191600,3),(468,138754800,4),(468,149641200,3),(468,170809200,4),(468,181090800,3),(468,202258800,4),(468,212540400,3),(468,233103600,4),(468,243990000,3),(468,265158000,4),(468,276044400,3),(468,296607600,4),(468,307494000,3),(468,315529200,2),(468,323830800,6),(468,338950800,5),(468,354675600,6),(468,370400400,5),(468,386125200,6),(468,401850000,5),(468,417574800,6),(468,433299600,5),(468,449024400,6),(468,465354000,5),(468,481078800,6),(468,496803600,5),(468,512528400,6),(468,528253200,5),(468,543978000,6),(468,559702800,5),(468,575427600,6),(468,591152400,5),(468,606877200,6),(468,622602000,5),(468,638326800,6),(468,654656400,5),(468,670381200,6),(468,686106000,5),(468,701830800,6),(468,717555600,5),(468,733280400,6),(468,749005200,5),(468,764730000,6),(468,780454800,5),(468,796179600,6),(468,811904400,5),(468,828234000,6),(468,846378000,5),(468,859683600,6),(468,877827600,5),(468,891133200,6),(468,909277200,5),(468,922582800,6),(468,941331600,5),(468,954032400,6),(468,972781200,5),(468,985482000,6),(468,1004230800,5),(468,1017536400,6),(468,1035680400,5),(468,1048986000,6),(468,1067130000,5),(468,1080435600,6),(468,1099184400,5),(468,1111885200,6),(468,1130634000,5),(468,1143334800,6),(468,1162083600,5),(468,1174784400,6),(468,1193533200,5),(468,1206838800,6),(468,1224982800,5),(468,1238288400,6),(468,1256432400,5),(468,1269738000,6),(468,1288486800,5),(468,1301187600,6),(468,1319936400,5),(468,1332637200,6),(468,1351386000,5),(468,1364691600,6),(468,1382835600,5),(468,1396141200,6),(468,1414285200,5),(468,1427590800,6),(468,1445734800,5),(468,1459040400,6),(468,1477789200,5),(468,1490490000,6),(468,1509238800,5),(468,1521939600,6),(468,1540688400,5),(468,1553994000,6),(468,1572138000,5),(468,1585443600,6),(468,1603587600,5),(468,1616893200,6),(468,1635642000,5),(468,1648342800,6),(468,1667091600,5),(468,1679792400,6),(468,1698541200,5),(468,1711846800,6),(468,1729990800,5),(468,1743296400,6),(468,1761440400,5),(468,1774746000,6),(468,1792890000,5),(468,1806195600,6),(468,1824944400,5),(468,1837645200,6),(468,1856394000,5),(468,1869094800,6),(468,1887843600,5),(468,1901149200,6),(468,1919293200,5),(468,1932598800,6),(468,1950742800,5),(468,1964048400,6),(468,1982797200,5),(468,1995498000,6),(468,2014246800,5),(468,2026947600,6),(468,2045696400,5),(468,2058397200,6),(468,2077146000,5),(468,2090451600,6),(468,2108595600,5),(468,2121901200,6),(468,2140045200,5),(469,-2147483648,0),(469,-1593820800,1),(469,-1247540400,2),(469,354916800,3),(469,370724400,2),(469,386452800,3),(469,402260400,2),(469,417988800,3),(469,433796400,2),(469,449611200,3),(469,465343200,4),(469,481068000,5),(469,496792800,4),(469,512517600,5),(469,528242400,4),(469,543967200,5),(469,559692000,4),(469,575416800,5),(469,591141600,4),(469,606866400,6),(469,622594800,7),(469,638319600,6),(469,654649200,7),(469,670374000,8),(469,686102400,7),(469,687916800,2),(469,701820000,5),(469,717544800,4),(469,733269600,5),(469,748994400,4),(469,764719200,5),(469,780444000,4),(469,796168800,5),(469,811893600,4),(469,828223200,5),(469,846367200,4),(469,859672800,5),(469,877816800,4),(469,891122400,5),(469,909266400,4),(469,922572000,5),(469,941320800,4),(469,954021600,5),(469,972770400,4),(469,985471200,5),(469,1004220000,4),(469,1017525600,5),(469,1035669600,4),(469,1048975200,5),(469,1067119200,4),(469,1080424800,5),(469,1099173600,4),(469,1111874400,5),(469,1130623200,4),(469,1143324000,5),(469,1162072800,4),(469,1174773600,5),(469,1193522400,4),(469,1206828000,5),(469,1224972000,4),(469,1238277600,5),(469,1256421600,4),(469,1269727200,6),(469,1288479600,7),(469,1301180400,4),(469,2147483647,4),(470,-2147483648,5),(470,-1690765200,1),(470,-1680487200,2),(470,-1664758800,1),(470,-1648951200,2),(470,-1635123600,1),(470,-1616896800,2),(470,-1604278800,1),(470,-1585533600,2),(470,-1571014800,1),(470,-1555293600,2),(470,-932432400,1),(470,-857257200,3),(470,-844556400,4),(470,-830311200,1),(470,-828226800,3),(470,-812502000,4),(470,-807156000,1),(470,-798073200,3),(470,-781052400,1),(470,-766717200,2),(470,-750898800,4),(470,-733359600,3),(470,-719456400,4),(470,-701917200,3),(470,-689209200,4),(470,-670460400,3),(470,-114051600,4),(470,-103168800,2),(470,-81997200,4),(470,-71715600,3),(470,-50547600,4),(470,-40266000,3),(470,-18493200,4),(470,-8211600,3),(470,12956400,4),(470,23238000,3),(470,43801200,4),(470,54687600,3),(470,75855600,4),(470,86742000,3),(470,107910000,4),(470,118191600,3),(470,138754800,4),(470,149641200,3),(470,170809200,4),(470,181090800,3),(470,202258800,4),(470,212540400,3),(470,233103600,4),(470,243990000,3),(470,265158000,4),(470,276044400,3),(470,296607600,4),(470,307494000,3),(470,315529200,2),(470,323830800,6),(470,338950800,5),(470,354675600,6),(470,370400400,5),(470,386125200,6),(470,401850000,5),(470,417574800,6),(470,433299600,5),(470,449024400,6),(470,465354000,5),(470,481078800,6),(470,496803600,5),(470,512528400,6),(470,528253200,5),(470,543978000,6),(470,559702800,5),(470,575427600,6),(470,591152400,5),(470,606877200,6),(470,622602000,5),(470,638326800,6),(470,654656400,5),(470,670381200,6),(470,686106000,5),(470,701830800,6),(470,717555600,5),(470,733280400,6),(470,749005200,5),(470,764730000,6),(470,780454800,5),(470,796179600,6),(470,811904400,5),(470,828234000,6),(470,846378000,5),(470,859683600,6),(470,877827600,5),(470,891133200,6),(470,909277200,5),(470,922582800,6),(470,941331600,5),(470,954032400,6),(470,972781200,5),(470,985482000,6),(470,1004230800,5),(470,1017536400,6),(470,1035680400,5),(470,1048986000,6),(470,1067130000,5),(470,1080435600,6),(470,1099184400,5),(470,1111885200,6),(470,1130634000,5),(470,1143334800,6),(470,1162083600,5),(470,1174784400,6),(470,1193533200,5),(470,1206838800,6),(470,1224982800,5),(470,1238288400,6),(470,1256432400,5),(470,1269738000,6),(470,1288486800,5),(470,1301187600,6),(470,1319936400,5),(470,1332637200,6),(470,1351386000,5),(470,1364691600,6),(470,1382835600,5),(470,1396141200,6),(470,1414285200,5),(470,1427590800,6),(470,1445734800,5),(470,1459040400,6),(470,1477789200,5),(470,1490490000,6),(470,1509238800,5),(470,1521939600,6),(470,1540688400,5),(470,1553994000,6),(470,1572138000,5),(470,1585443600,6),(470,1603587600,5),(470,1616893200,6),(470,1635642000,5),(470,1648342800,6),(470,1667091600,5),(470,1679792400,6),(470,1698541200,5),(470,1711846800,6),(470,1729990800,5),(470,1743296400,6),(470,1761440400,5),(470,1774746000,6),(470,1792890000,5),(470,1806195600,6),(470,1824944400,5),(470,1837645200,6),(470,1856394000,5),(470,1869094800,6),(470,1887843600,5),(470,1901149200,6),(470,1919293200,5),(470,1932598800,6),(470,1950742800,5),(470,1964048400,6),(470,1982797200,5),(470,1995498000,6),(470,2014246800,5),(470,2026947600,6),(470,2045696400,5),(470,2058397200,6),(470,2077146000,5),(470,2090451600,6),(470,2108595600,5),(470,2121901200,6),(470,2140045200,5),(471,-2147483648,1),(471,-905824800,4),(471,-857257200,2),(471,-844556400,3),(471,-828226800,2),(471,-812502000,3),(471,-796777200,2),(471,-788922000,1),(471,-777942000,3),(471,-766623600,2),(471,407199600,1),(471,417574800,5),(471,433299600,6),(471,449024400,5),(471,465354000,6),(471,481078800,5),(471,496803600,6),(471,512528400,5),(471,528253200,6),(471,543978000,5),(471,559702800,6),(471,575427600,5),(471,591152400,6),(471,606877200,5),(471,622602000,6),(471,638326800,5),(471,654656400,6),(471,670381200,5),(471,686106000,6),(471,701830800,5),(471,717555600,6),(471,733280400,5),(471,749005200,6),(471,764730000,5),(471,780454800,6),(471,796179600,5),(471,811904400,6),(471,828234000,5),(471,846378000,6),(471,859683600,5),(471,877827600,6),(471,891133200,5),(471,909277200,6),(471,922582800,5),(471,941331600,6),(471,954032400,5),(471,972781200,6),(471,985482000,5),(471,1004230800,6),(471,1017536400,5),(471,1035680400,6),(471,1048986000,5),(471,1067130000,6),(471,1080435600,5),(471,1099184400,6),(471,1111885200,5),(471,1130634000,6),(471,1143334800,5),(471,1162083600,6),(471,1174784400,5),(471,1193533200,6),(471,1206838800,5),(471,1224982800,6),(471,1238288400,5),(471,1256432400,6),(471,1269738000,5),(471,1288486800,6),(471,1301187600,5),(471,1319936400,6),(471,1332637200,5),(471,1351386000,6),(471,1364691600,5),(471,1382835600,6),(471,1396141200,5),(471,1414285200,6),(471,1427590800,5),(471,1445734800,6),(471,1459040400,5),(471,1477789200,6),(471,1490490000,5),(471,1509238800,6),(471,1521939600,5),(471,1540688400,6),(471,1553994000,5),(471,1572138000,6),(471,1585443600,5),(471,1603587600,6),(471,1616893200,5),(471,1635642000,6),(471,1648342800,5),(471,1667091600,6),(471,1679792400,5),(471,1698541200,6),(471,1711846800,5),(471,1729990800,6),(471,1743296400,5),(471,1761440400,6),(471,1774746000,5),(471,1792890000,6),(471,1806195600,5),(471,1824944400,6),(471,1837645200,5),(471,1856394000,6),(471,1869094800,5),(471,1887843600,6),(471,1901149200,5),(471,1919293200,6),(471,1932598800,5),(471,1950742800,6),(471,1964048400,5),(471,1982797200,6),(471,1995498000,5),(471,2014246800,6),(471,2026947600,5),(471,2045696400,6),(471,2058397200,5),(471,2077146000,6),(471,2090451600,5),(471,2108595600,6),(471,2121901200,5),(471,2140045200,6),(472,-2147483648,0),(472,-1593820800,1),(472,-1247540400,3),(472,354916800,2),(472,370724400,3),(472,386452800,2),(472,402260400,3),(472,417988800,2),(472,433796400,3),(472,449611200,2),(472,465343200,4),(472,481068000,5),(472,496792800,4),(472,512517600,5),(472,528242400,4),(472,543967200,5),(472,559692000,4),(472,575416800,6),(472,591145200,7),(472,606870000,6),(472,622594800,7),(472,638319600,6),(472,654649200,7),(472,670374000,4),(472,701820000,6),(472,717548400,7),(472,733273200,6),(472,748998000,7),(472,764722800,6),(472,780447600,7),(472,796172400,6),(472,811897200,7),(472,828226800,6),(472,846370800,7),(472,859676400,6),(472,877820400,7),(472,891126000,6),(472,909270000,7),(472,922575600,6),(472,941324400,7),(472,954025200,6),(472,972774000,7),(472,985474800,6),(472,1004223600,7),(472,1017529200,6),(472,1035673200,7),(472,1048978800,6),(472,1067122800,7),(472,1080428400,6),(472,1099177200,7),(472,1111878000,6),(472,1130626800,7),(472,1143327600,6),(472,1162076400,7),(472,1174777200,6),(472,1193526000,7),(472,1206831600,6),(472,1224975600,7),(472,1238281200,6),(472,1256425200,7),(472,1269730800,6),(472,1288479600,7),(472,1301180400,4),(472,1414274400,7),(472,1480806000,4),(472,2147483647,4),(473,-2147483648,1),(473,-1441160160,2),(473,-1247536800,3),(473,-888894000,6),(473,-857257200,4),(473,-844556400,5),(473,-828226800,4),(473,-812502000,5),(473,-811648800,3),(473,354920400,7),(473,370728000,3),(473,386456400,7),(473,402264000,3),(473,417992400,7),(473,433800000,3),(473,449614800,7),(473,465346800,8),(473,481071600,9),(473,496796400,8),(473,512521200,9),(473,528246000,8),(473,543970800,9),(473,559695600,8),(473,575420400,9),(473,591145200,8),(473,606870000,9),(473,622594800,8),(473,631141200,3),(473,646786800,2),(473,701827200,10),(473,717552000,11),(473,733276800,10),(473,749001600,11),(473,764726400,10),(473,767739600,7),(473,780447600,8),(473,796172400,9),(473,811897200,8),(473,828219600,9),(473,846374400,8),(473,859683600,12),(473,877827600,13),(473,891133200,12),(473,909277200,13),(473,922582800,12),(473,941331600,13),(473,954032400,12),(473,972781200,13),(473,985482000,12),(473,1004230800,13),(473,1017536400,12),(473,1035680400,13),(473,1048986000,12),(473,1067130000,13),(473,1080435600,12),(473,1099184400,13),(473,1111885200,12),(473,1130634000,13),(473,1143334800,12),(473,1162083600,13),(473,1174784400,12),(473,1193533200,13),(473,1206838800,12),(473,1224982800,13),(473,1238288400,12),(473,1256432400,13),(473,1269738000,12),(473,1288486800,13),(473,1301187600,12),(473,1319936400,13),(473,1332637200,12),(473,1351386000,13),(473,1364691600,12),(473,1382835600,13),(473,1396137600,14),(473,1414274400,8),(474,-2147483648,1),(474,-905824800,4),(474,-857257200,2),(474,-844556400,3),(474,-828226800,2),(474,-812502000,3),(474,-796777200,2),(474,-788922000,1),(474,-777942000,3),(474,-766623600,2),(474,407199600,1),(474,417574800,5),(474,433299600,6),(474,449024400,5),(474,465354000,6),(474,481078800,5),(474,496803600,6),(474,512528400,5),(474,528253200,6),(474,543978000,5),(474,559702800,6),(474,575427600,5),(474,591152400,6),(474,606877200,5),(474,622602000,6),(474,638326800,5),(474,654656400,6),(474,670381200,5),(474,686106000,6),(474,701830800,5),(474,717555600,6),(474,733280400,5),(474,749005200,6),(474,764730000,5),(474,780454800,6),(474,796179600,5),(474,811904400,6),(474,828234000,5),(474,846378000,6),(474,859683600,5),(474,877827600,6),(474,891133200,5),(474,909277200,6),(474,922582800,5),(474,941331600,6),(474,954032400,5),(474,972781200,6),(474,985482000,5),(474,1004230800,6),(474,1017536400,5),(474,1035680400,6),(474,1048986000,5),(474,1067130000,6),(474,1080435600,5),(474,1099184400,6),(474,1111885200,5),(474,1130634000,6),(474,1143334800,5),(474,1162083600,6),(474,1174784400,5),(474,1193533200,6),(474,1206838800,5),(474,1224982800,6),(474,1238288400,5),(474,1256432400,6),(474,1269738000,5),(474,1288486800,6),(474,1301187600,5),(474,1319936400,6),(474,1332637200,5),(474,1351386000,6),(474,1364691600,5),(474,1382835600,6),(474,1396141200,5),(474,1414285200,6),(474,1427590800,5),(474,1445734800,6),(474,1459040400,5),(474,1477789200,6),(474,1490490000,5),(474,1509238800,6),(474,1521939600,5),(474,1540688400,6),(474,1553994000,5),(474,1572138000,6),(474,1585443600,5),(474,1603587600,6),(474,1616893200,5),(474,1635642000,6),(474,1648342800,5),(474,1667091600,6),(474,1679792400,5),(474,1698541200,6),(474,1711846800,5),(474,1729990800,6),(474,1743296400,5),(474,1761440400,6),(474,1774746000,5),(474,1792890000,6),(474,1806195600,5),(474,1824944400,6),(474,1837645200,5),(474,1856394000,6),(474,1869094800,5),(474,1887843600,6),(474,1901149200,5),(474,1919293200,6),(474,1932598800,5),(474,1950742800,6),(474,1964048400,5),(474,1982797200,6),(474,1995498000,5),(474,2014246800,6),(474,2026947600,5),(474,2045696400,6),(474,2058397200,5),(474,2077146000,6),(474,2090451600,5),(474,2108595600,6),(474,2121901200,5),(474,2140045200,6),(475,-2147483648,1),(475,-857257200,2),(475,-844556400,3),(475,-828226800,2),(475,-812502000,3),(475,-796777200,2),(475,-788922000,4),(475,-781048800,1),(475,291762000,5),(475,307576800,1),(475,323816400,5),(475,339026400,1),(475,355266000,5),(475,370393200,1),(475,386715600,5),(475,401846400,6),(475,417571200,7),(475,433296000,6),(475,449020800,7),(475,465350400,6),(475,481075200,7),(475,496800000,6),(475,512524800,7),(475,528249600,6),(475,543974400,7),(475,559699200,6),(475,575424000,7),(475,591148800,6),(475,606873600,7),(475,622598400,6),(475,638323200,7),(475,654652800,6),(475,662680800,1),(475,670370400,5),(475,686091600,1),(475,701820000,5),(475,717541200,1),(475,733269600,5),(475,748990800,1),(475,764719200,5),(475,780440400,1),(475,796168800,5),(475,811890000,1),(475,828223200,5),(475,846363600,1),(475,859683600,8),(475,877827600,9),(475,891133200,8),(475,909277200,9),(475,922582800,8),(475,941331600,9),(475,954032400,8),(475,972781200,9),(475,985482000,8),(475,1004230800,9),(475,1017536400,8),(475,1035680400,9),(475,1048986000,8),(475,1067130000,9),(475,1080435600,8),(475,1099184400,9),(475,1111885200,8),(475,1130634000,9),(475,1143334800,8),(475,1162083600,9),(475,1174784400,8),(475,1193533200,9),(475,1206838800,8),(475,1224982800,9),(475,1238288400,8),(475,1256432400,9),(475,1269738000,8),(475,1288486800,9),(475,1301187600,8),(475,1319936400,9),(475,1332637200,8),(475,1351386000,9),(475,1364691600,8),(475,1382835600,9),(475,1396141200,8),(475,1414285200,9),(475,1427590800,8),(475,1445734800,9),(475,1459040400,8),(475,1477789200,9),(475,1490490000,8),(475,1509238800,9),(475,1521939600,8),(475,1540688400,9),(475,1553994000,8),(475,1572138000,9),(475,1585443600,8),(475,1603587600,9),(475,1616893200,8),(475,1635642000,9),(475,1648342800,8),(475,1667091600,9),(475,1679792400,8),(475,1698541200,9),(475,1711846800,8),(475,1729990800,9),(475,1743296400,8),(475,1761440400,9),(475,1774746000,8),(475,1792890000,9),(475,1806195600,8),(475,1824944400,9),(475,1837645200,8),(475,1856394000,9),(475,1869094800,8),(475,1887843600,9),(475,1901149200,8),(475,1919293200,9),(475,1932598800,8),(475,1950742800,9),(475,1964048400,8),(475,1982797200,9),(475,1995498000,8),(475,2014246800,9),(475,2026947600,8),(475,2045696400,9),(475,2058397200,8),(475,2077146000,9),(475,2090451600,8),(475,2108595600,9),(475,2121901200,8),(475,2140045200,9),(476,-2147483648,2),(476,-1693706400,1),(476,-1680483600,2),(476,-1663455600,3),(476,-1650150000,4),(476,-1632006000,3),(476,-1618700400,4),(476,-938905200,3),(476,-857257200,4),(476,-844556400,3),(476,-828226800,4),(476,-812502000,3),(476,-796777200,4),(476,-781052400,3),(476,-776563200,5),(476,-765936000,1),(476,-761180400,4),(476,-757386000,2),(476,-748479600,3),(476,-733273200,4),(476,-717631200,3),(476,-714610800,6),(476,-710380800,1),(476,-701910000,4),(476,-684975600,3),(476,-670460400,4),(476,-654130800,3),(476,-639010800,4),(476,315529200,2),(476,323830800,7),(476,338950800,8),(476,354675600,7),(476,370400400,8),(476,386125200,7),(476,401850000,8),(476,417574800,7),(476,433299600,8),(476,449024400,7),(476,465354000,8),(476,481078800,7),(476,496803600,8),(476,512528400,7),(476,528253200,8),(476,543978000,7),(476,559702800,8),(476,575427600,7),(476,591152400,8),(476,606877200,7),(476,622602000,8),(476,638326800,7),(476,654656400,8),(476,670381200,7),(476,686106000,8),(476,701830800,7),(476,717555600,8),(476,733280400,7),(476,749005200,8),(476,764730000,7),(476,780454800,8),(476,796179600,7),(476,811904400,8),(476,828234000,7),(476,846378000,8),(476,859683600,7),(476,877827600,8),(476,891133200,7),(476,909277200,8),(476,922582800,7),(476,941331600,8),(476,954032400,7),(476,972781200,8),(476,985482000,7),(476,1004230800,8),(476,1017536400,7),(476,1035680400,8),(476,1048986000,7),(476,1067130000,8),(476,1080435600,7),(476,1099184400,8),(476,1111885200,7),(476,1130634000,8),(476,1143334800,7),(476,1162083600,8),(476,1174784400,7),(476,1193533200,8),(476,1206838800,7),(476,1224982800,8),(476,1238288400,7),(476,1256432400,8),(476,1269738000,7),(476,1288486800,8),(476,1301187600,7),(476,1319936400,8),(476,1332637200,7),(476,1351386000,8),(476,1364691600,7),(476,1382835600,8),(476,1396141200,7),(476,1414285200,8),(476,1427590800,7),(476,1445734800,8),(476,1459040400,7),(476,1477789200,8),(476,1490490000,7),(476,1509238800,8),(476,1521939600,7),(476,1540688400,8),(476,1553994000,7),(476,1572138000,8),(476,1585443600,7),(476,1603587600,8),(476,1616893200,7),(476,1635642000,8),(476,1648342800,7),(476,1667091600,8),(476,1679792400,7),(476,1698541200,8),(476,1711846800,7),(476,1729990800,8),(476,1743296400,7),(476,1761440400,8),(476,1774746000,7),(476,1792890000,8),(476,1806195600,7),(476,1824944400,8),(476,1837645200,7),(476,1856394000,8),(476,1869094800,7),(476,1887843600,8),(476,1901149200,7),(476,1919293200,8),(476,1932598800,7),(476,1950742800,8),(476,1964048400,7),(476,1982797200,8),(476,1995498000,7),(476,2014246800,8),(476,2026947600,7),(476,2045696400,8),(476,2058397200,7),(476,2077146000,8),(476,2090451600,7),(476,2108595600,8),(476,2121901200,7),(476,2140045200,8),(477,-2147483648,1),(477,-1638322740,4),(477,-1632006000,2),(477,-1618700400,3),(477,-1593824400,1),(477,-1535938740,5),(477,-927943200,6),(477,-892954800,7),(477,-857257200,3),(477,-844556400,2),(477,-828226800,3),(477,-812502000,2),(477,-797652000,6),(477,354920400,8),(477,370728000,6),(477,386456400,8),(477,402264000,6),(477,417992400,8),(477,433800000,6),(477,449614800,8),(477,465346800,9),(477,481071600,10),(477,496796400,9),(477,512521200,10),(477,528246000,9),(477,543970800,10),(477,559695600,9),(477,575420400,10),(477,591145200,9),(477,606870000,11),(477,622598400,12),(477,638323200,11),(477,654652800,12),(477,670377600,11),(477,686102400,12),(477,701827200,11),(477,717552000,12),(477,733276800,11),(477,749001600,12),(477,764726400,11),(477,780451200,12),(477,796176000,11),(477,811900800,12),(477,828230400,11),(477,846374400,12),(477,859680000,11),(477,877824000,12),(477,891129600,11),(477,906411600,15),(477,909277200,13),(477,922582800,14),(477,941331600,5),(477,1017536400,14),(477,1035680400,13),(477,1048986000,14),(477,1067130000,13),(477,1080435600,14),(477,1099184400,13),(477,1111885200,14),(477,1130634000,13),(477,1143334800,14),(477,1162083600,13),(477,1174784400,14),(477,1193533200,13),(477,1206838800,14),(477,1224982800,13),(477,1238288400,14),(477,1256432400,13),(477,1269738000,14),(477,1288486800,13),(477,1301187600,14),(477,1319936400,13),(477,1332637200,14),(477,1351386000,13),(477,1364691600,14),(477,1382835600,13),(477,1396141200,14),(477,1414285200,13),(477,1427590800,14),(477,1445734800,13),(477,1459040400,14),(477,1477789200,13),(477,1490490000,14),(477,1509238800,13),(477,1521939600,14),(477,1540688400,13),(477,1553994000,14),(477,1572138000,13),(477,1585443600,14),(477,1603587600,13),(477,1616893200,14),(477,1635642000,13),(477,1648342800,14),(477,1667091600,13),(477,1679792400,14),(477,1698541200,13),(477,1711846800,14),(477,1729990800,13),(477,1743296400,14),(477,1761440400,13),(477,1774746000,14),(477,1792890000,13),(477,1806195600,14),(477,1824944400,13),(477,1837645200,14),(477,1856394000,13),(477,1869094800,14),(477,1887843600,13),(477,1901149200,14),(477,1919293200,13),(477,1932598800,14),(477,1950742800,13),(477,1964048400,14),(477,1982797200,13),(477,1995498000,14),(477,2014246800,13),(477,2026947600,14),(477,2045696400,13),(477,2058397200,14),(477,2077146000,13),(477,2090451600,14),(477,2108595600,13),(477,2121901200,14),(477,2140045200,13),(478,-2147483648,0),(478,-1767230360,1),(478,-932346000,2),(478,-857257200,1),(478,-844556400,2),(478,-843519600,1),(478,136854000,2),(478,149896800,1),(478,168130800,2),(478,181432800,1),(478,199839600,2),(478,213141600,1),(478,231894000,2),(478,244591200,1),(478,263257200,2),(478,276040800,1),(478,294706800,2),(478,307490400,1),(478,326156400,2),(478,339458400,1),(478,357087600,2),(478,370389600,1),(478,389142000,2),(478,402444000,1),(478,419468400,2),(478,433807200,1),(478,449622000,2),(478,465354000,3),(478,481078800,4),(478,496803600,3),(478,512528400,4),(478,528253200,3),(478,543978000,4),(478,559702800,3),(478,575427600,4),(478,591152400,3),(478,606877200,4),(478,622602000,3),(478,638326800,4),(478,654656400,3),(478,670381200,4),(478,686106000,3),(478,701830800,4),(478,717555600,3),(478,733280400,4),(478,749005200,3),(478,764730000,4),(478,780454800,3),(478,796179600,4),(478,811904400,3),(478,828234000,4),(478,846378000,3),(478,859683600,4),(478,877827600,3),(478,891133200,4),(478,909277200,3),(478,922582800,4),(478,941331600,3),(478,954032400,4),(478,972781200,3),(478,985482000,4),(478,1004230800,3),(478,1017536400,4),(478,1035680400,3),(478,1048986000,4),(478,1067130000,3),(478,1080435600,4),(478,1099184400,3),(478,1111885200,4),(478,1130634000,3),(478,1143334800,4),(478,1162083600,3),(478,1174784400,4),(478,1193533200,3),(478,1206838800,4),(478,1224982800,3),(478,1238288400,4),(478,1256432400,3),(478,1269738000,4),(478,1288486800,3),(478,1301187600,4),(478,1319936400,3),(478,1332637200,4),(478,1351386000,3),(478,1364691600,4),(478,1382835600,3),(478,1396141200,4),(478,1414285200,3),(478,1427590800,4),(478,1445734800,3),(478,1459040400,4),(478,1477789200,3),(478,1490490000,4),(478,1509238800,3),(478,1521939600,4),(478,1540688400,3),(478,1553994000,4),(478,1572138000,3),(478,1585443600,4),(478,1603587600,3),(478,1616893200,4),(478,1635642000,3),(478,1648342800,4),(478,1667091600,3),(478,1679792400,4),(478,1698541200,3),(478,1711846800,4),(478,1729990800,3),(478,1743296400,4),(478,1761440400,3),(478,1774746000,4),(478,1792890000,3),(478,1806195600,4),(478,1824944400,3),(478,1837645200,4),(478,1856394000,3),(478,1869094800,4),(478,1887843600,3),(478,1901149200,4),(478,1919293200,3),(478,1932598800,4),(478,1950742800,3),(478,1964048400,4),(478,1982797200,3),(478,1995498000,4),(478,2014246800,3),(478,2026947600,4),(478,2045696400,3),(478,2058397200,4),(478,2077146000,3),(478,2090451600,4),(478,2108595600,3),(478,2121901200,4),(478,2140045200,3),(479,-2147483648,1),(479,-1637114100,2),(479,-1213148664,5),(479,-1187056800,3),(479,-1175479200,4),(479,-1159754400,3),(479,-1144029600,4),(479,-1127700000,3),(479,-1111975200,4),(479,-1096250400,3),(479,-1080525600,4),(479,-1064800800,3),(479,-1049076000,4),(479,-1033351200,3),(479,-1017626400,4),(479,-1001901600,3),(479,-986176800,4),(479,-970452000,3),(479,-954727200,4),(479,-927165600,6),(479,-898138800,9),(479,-857257200,7),(479,-844556400,8),(479,-828226800,7),(479,-812502000,8),(479,-800157600,11),(479,354920400,10),(479,370728000,11),(479,386456400,10),(479,402264000,11),(479,417992400,10),(479,433800000,11),(479,449614800,10),(479,465346800,12),(479,481071600,13),(479,496796400,12),(479,512521200,13),(479,528246000,12),(479,543970800,13),(479,559695600,12),(479,575420400,13),(479,591145200,12),(479,606870000,13),(479,622594800,12),(479,638319600,13),(479,641944800,6),(479,654652800,4),(479,670377600,3),(479,686102400,4),(479,694216800,5),(479,701820000,6),(479,717541200,5),(479,733269600,6),(479,748990800,5),(479,764719200,6),(479,780440400,5),(479,796168800,6),(479,811890000,5),(479,828223200,6),(479,846363600,5),(479,859680000,6),(479,877824000,5),(479,891129600,6),(479,909273600,5),(479,922579200,6),(479,941328000,5),(479,954028800,6),(479,972777600,5),(479,985478400,6),(479,1004227200,5),(479,1017532800,6),(479,1035676800,5),(479,1048982400,6),(479,1067126400,5),(479,1080432000,6),(479,1099180800,5),(479,1111881600,6),(479,1130630400,5),(479,1143331200,6),(479,1162080000,5),(479,1174780800,6),(479,1193529600,5),(479,1206835200,6),(479,1224979200,5),(479,1238284800,6),(479,1256428800,5),(479,1269734400,6),(479,1288483200,5),(479,1301184000,6),(479,1319932800,5),(479,1332633600,6),(479,1351382400,5),(479,1364688000,6),(479,1382832000,5),(479,1396137600,6),(479,1414281600,5),(479,1427587200,6),(479,1445731200,5),(479,1459036800,6),(479,1477785600,5),(479,1490486400,6),(479,1509235200,5),(479,1521936000,6),(479,1540684800,5),(479,1553990400,6),(479,1572134400,5),(479,1585440000,6),(479,1603584000,5),(479,1616889600,6),(479,1635638400,5),(479,1648339200,6),(479,1667088000,5),(479,1679788800,6),(479,1698537600,5),(479,1711843200,6),(479,1729987200,5),(479,1743292800,6),(479,1761436800,5),(479,1774742400,6),(479,1792886400,5),(479,1806192000,6),(479,1824940800,5),(479,1837641600,6),(479,1856390400,5),(479,1869091200,6),(479,1887840000,5),(479,1901145600,6),(479,1919289600,5),(479,1932595200,6),(479,1950739200,5),(479,1964044800,6),(479,1982793600,5),(479,1995494400,6),(479,2014243200,5),(479,2026944000,6),(479,2045692800,5),(479,2058393600,6),(479,2077142400,5),(479,2090448000,6),(479,2108592000,5),(479,2121897600,6),(479,2140041600,5),(480,-2147483648,0),(480,-1593820800,1),(480,-1247540400,3),(480,354916800,2),(480,370724400,3),(480,386452800,2),(480,402260400,3),(480,417988800,2),(480,433796400,3),(480,449611200,2),(480,465343200,4),(480,481068000,5),(480,496792800,4),(480,512517600,5),(480,528242400,4),(480,543967200,5),(480,559692000,4),(480,575416800,5),(480,591141600,4),(480,606866400,6),(480,622594800,7),(480,638319600,6),(480,654649200,7),(480,670374000,8),(480,686102400,9),(480,695779200,7),(480,701823600,6),(480,717548400,7),(480,733273200,6),(480,748998000,7),(480,764722800,6),(480,780447600,7),(480,796172400,6),(480,811897200,7),(480,828226800,6),(480,846370800,7),(480,859676400,6),(480,877820400,7),(480,891126000,6),(480,909270000,7),(480,922575600,6),(480,941324400,7),(480,954025200,6),(480,972774000,7),(480,985474800,6),(480,1004223600,7),(480,1017529200,6),(480,1035673200,7),(480,1048978800,6),(480,1067122800,7),(480,1080428400,6),(480,1099177200,7),(480,1111878000,6),(480,1130626800,7),(480,1143327600,6),(480,1162076400,7),(480,1174777200,6),(480,1193526000,7),(480,1206831600,6),(480,1224975600,7),(480,1238281200,6),(480,1256425200,7),(480,1269730800,6),(480,1288479600,7),(480,1301180400,4),(480,1414274400,7),(480,1459033200,4),(480,2147483647,4),(481,-2147483648,1),(481,-1441159324,2),(481,-1247536800,3),(481,-892522800,6),(481,-857257200,4),(481,-844556400,5),(481,-828226800,4),(481,-825382800,3),(481,354920400,7),(481,370728000,3),(481,386456400,7),(481,402264000,3),(481,417992400,7),(481,433800000,3),(481,449614800,7),(481,465346800,8),(481,481071600,9),(481,496796400,8),(481,512521200,9),(481,528246000,8),(481,543970800,9),(481,559695600,8),(481,575420400,9),(481,591145200,8),(481,606870000,9),(481,622594800,8),(481,638319600,9),(481,646783200,10),(481,686102400,11),(481,701827200,12),(481,717552000,11),(481,733276800,12),(481,749001600,11),(481,764726400,12),(481,780451200,11),(481,796176000,12),(481,811900800,11),(481,828230400,12),(481,831934800,10),(481,846378000,13),(481,859683600,14),(481,877827600,13),(481,891133200,14),(481,909277200,13),(481,922582800,14),(481,941331600,13),(481,954032400,14),(481,972781200,13),(481,985482000,14),(481,1004230800,13),(481,1017536400,14),(481,1035680400,13),(481,1048986000,14),(481,1067130000,13),(481,1080435600,14),(481,1099184400,13),(481,1111885200,14),(481,1130634000,13),(481,1143334800,14),(481,1162083600,13),(481,1174784400,14),(481,1193533200,13),(481,1206838800,14),(481,1224982800,13),(481,1238288400,14),(481,1256432400,13),(481,1269738000,14),(481,1288486800,13),(481,1301187600,14),(481,1319936400,13),(481,1332637200,14),(481,1351386000,13),(481,1364691600,14),(481,1382835600,13),(481,1396141200,14),(481,1414285200,13),(481,1427590800,14),(481,1445734800,13),(481,1459040400,14),(481,1477789200,13),(481,1490490000,14),(481,1509238800,13),(481,1521939600,14),(481,1540688400,13),(481,1553994000,14),(481,1572138000,13),(481,1585443600,14),(481,1603587600,13),(481,1616893200,14),(481,1635642000,13),(481,1648342800,14),(481,1667091600,13),(481,1679792400,14),(481,1698541200,13),(481,1711846800,14),(481,1729990800,13),(481,1743296400,14),(481,1761440400,13),(481,1774746000,14),(481,1792890000,13),(481,1806195600,14),(481,1824944400,13),(481,1837645200,14),(481,1856394000,13),(481,1869094800,14),(481,1887843600,13),(481,1901149200,14),(481,1919293200,13),(481,1932598800,14),(481,1950742800,13),(481,1964048400,14),(481,1982797200,13),(481,1995498000,14),(481,2014246800,13),(481,2026947600,14),(481,2045696400,13),(481,2058397200,14),(481,2077146000,13),(481,2090451600,14),(481,2108595600,13),(481,2121901200,14),(481,2140045200,13),(482,-2147483648,2),(482,-904435200,1),(482,-891129600,2),(482,-872985600,1),(482,-859680000,2),(482,354675600,3),(482,370400400,4),(482,386125200,3),(482,401850000,4),(482,417574800,3),(482,433299600,4),(482,449024400,3),(482,465354000,4),(482,481078800,3),(482,496803600,4),(482,512528400,3),(482,528253200,4),(482,543978000,3),(482,559702800,4),(482,575427600,3),(482,591152400,4),(482,606877200,3),(482,622602000,4),(482,638326800,3),(482,654656400,4),(482,670381200,3),(482,686106000,4),(482,701830800,3),(482,717555600,4),(482,733280400,3),(482,749005200,4),(482,764730000,3),(482,780454800,4),(482,796179600,3),(482,811904400,4),(482,828234000,3),(482,846378000,4),(482,859683600,3),(482,877827600,4),(482,891133200,3),(482,909277200,4),(482,922582800,3),(482,941331600,4),(482,954032400,3),(482,972781200,4),(482,985482000,3),(482,1004230800,4),(482,1017536400,3),(482,1035680400,4),(482,1048986000,3),(482,1067130000,4),(482,1080435600,3),(482,1099184400,4),(482,1111885200,3),(482,1130634000,4),(482,1143334800,3),(482,1162083600,4),(482,1174784400,3),(482,1193533200,4),(482,1206838800,3),(482,1224982800,4),(482,1238288400,3),(482,1256432400,4),(482,1269738000,3),(482,1288486800,4),(482,1301187600,3),(482,1319936400,4),(482,1332637200,3),(482,1351386000,4),(482,1364691600,3),(482,1382835600,4),(482,1396141200,3),(482,1414285200,4),(482,1427590800,3),(482,1445734800,4),(482,1459040400,3),(482,1477789200,4),(482,1490490000,3),(482,1509238800,4),(482,1521939600,3),(482,1540688400,4),(482,1553994000,3),(482,1572138000,4),(482,1585443600,3),(482,1603587600,4),(482,1616893200,3),(482,1635642000,4),(482,1648342800,3),(482,1667091600,4),(482,1679792400,3),(482,1698541200,4),(482,1711846800,3),(482,1729990800,4),(482,1743296400,3),(482,1761440400,4),(482,1774746000,3),(482,1792890000,4),(482,1806195600,3),(482,1824944400,4),(482,1837645200,3),(482,1856394000,4),(482,1869094800,3),(482,1887843600,4),(482,1901149200,3),(482,1919293200,4),(482,1932598800,3),(482,1950742800,4),(482,1964048400,3),(482,1982797200,4),(482,1995498000,3),(482,2014246800,4),(482,2026947600,3),(482,2045696400,4),(482,2058397200,3),(482,2077146000,4),(482,2090451600,3),(482,2108595600,4),(482,2121901200,3),(482,2140045200,4),(483,-2147483648,5),(483,-1690765200,1),(483,-1680487200,2),(483,-1664758800,1),(483,-1648951200,2),(483,-1635123600,1),(483,-1616896800,2),(483,-1604278800,1),(483,-1585533600,2),(483,-1571014800,1),(483,-1555293600,2),(483,-932432400,1),(483,-857257200,3),(483,-844556400,4),(483,-830311200,1),(483,-828226800,3),(483,-812502000,4),(483,-807156000,1),(483,-798073200,3),(483,-781052400,1),(483,-766717200,2),(483,-750898800,4),(483,-733359600,3),(483,-719456400,4),(483,-701917200,3),(483,-689209200,4),(483,-670460400,3),(483,-114051600,4),(483,-103168800,2),(483,-81997200,4),(483,-71715600,3),(483,-50547600,4),(483,-40266000,3),(483,-18493200,4),(483,-8211600,3),(483,12956400,4),(483,23238000,3),(483,43801200,4),(483,54687600,3),(483,75855600,4),(483,86742000,3),(483,107910000,4),(483,118191600,3),(483,138754800,4),(483,149641200,3),(483,170809200,4),(483,181090800,3),(483,202258800,4),(483,212540400,3),(483,233103600,4),(483,243990000,3),(483,265158000,4),(483,276044400,3),(483,296607600,4),(483,307494000,3),(483,315529200,2),(483,323830800,6),(483,338950800,5),(483,354675600,6),(483,370400400,5),(483,386125200,6),(483,401850000,5),(483,417574800,6),(483,433299600,5),(483,449024400,6),(483,465354000,5),(483,481078800,6),(483,496803600,5),(483,512528400,6),(483,528253200,5),(483,543978000,6),(483,559702800,5),(483,575427600,6),(483,591152400,5),(483,606877200,6),(483,622602000,5),(483,638326800,6),(483,654656400,5),(483,670381200,6),(483,686106000,5),(483,701830800,6),(483,717555600,5),(483,733280400,6),(483,749005200,5),(483,764730000,6),(483,780454800,5),(483,796179600,6),(483,811904400,5),(483,828234000,6),(483,846378000,5),(483,859683600,6),(483,877827600,5),(483,891133200,6),(483,909277200,5),(483,922582800,6),(483,941331600,5),(483,954032400,6),(483,972781200,5),(483,985482000,6),(483,1004230800,5),(483,1017536400,6),(483,1035680400,5),(483,1048986000,6),(483,1067130000,5),(483,1080435600,6),(483,1099184400,5),(483,1111885200,6),(483,1130634000,5),(483,1143334800,6),(483,1162083600,5),(483,1174784400,6),(483,1193533200,5),(483,1206838800,6),(483,1224982800,5),(483,1238288400,6),(483,1256432400,5),(483,1269738000,6),(483,1288486800,5),(483,1301187600,6),(483,1319936400,5),(483,1332637200,6),(483,1351386000,5),(483,1364691600,6),(483,1382835600,5),(483,1396141200,6),(483,1414285200,5),(483,1427590800,6),(483,1445734800,5),(483,1459040400,6),(483,1477789200,5),(483,1490490000,6),(483,1509238800,5),(483,1521939600,6),(483,1540688400,5),(483,1553994000,6),(483,1572138000,5),(483,1585443600,6),(483,1603587600,5),(483,1616893200,6),(483,1635642000,5),(483,1648342800,6),(483,1667091600,5),(483,1679792400,6),(483,1698541200,5),(483,1711846800,6),(483,1729990800,5),(483,1743296400,6),(483,1761440400,5),(483,1774746000,6),(483,1792890000,5),(483,1806195600,6),(483,1824944400,5),(483,1837645200,6),(483,1856394000,5),(483,1869094800,6),(483,1887843600,5),(483,1901149200,6),(483,1919293200,5),(483,1932598800,6),(483,1950742800,5),(483,1964048400,6),(483,1982797200,5),(483,1995498000,6),(483,2014246800,5),(483,2026947600,6),(483,2045696400,5),(483,2058397200,6),(483,2077146000,5),(483,2090451600,6),(483,2108595600,5),(483,2121901200,6),(483,2140045200,5),(484,-2147483648,2),(484,-1693706400,1),(484,-1680483600,2),(484,-1663455600,3),(484,-1650150000,4),(484,-1632006000,3),(484,-1618700400,4),(484,-1577926800,2),(484,-1569711600,3),(484,-1555801200,4),(484,-938905200,3),(484,-857257200,4),(484,-844556400,3),(484,-828226800,4),(484,-812502000,3),(484,-796777200,4),(484,-781052400,3),(484,-780188400,4),(484,-757386000,2),(484,-748479600,3),(484,-733273200,4),(484,-717634800,3),(484,-701910000,4),(484,-684975600,3),(484,-670460400,4),(484,323823600,1),(484,338940000,2),(484,354675600,5),(484,370400400,6),(484,386125200,5),(484,401850000,6),(484,417574800,5),(484,433299600,6),(484,449024400,5),(484,465354000,6),(484,481078800,5),(484,496803600,6),(484,512528400,5),(484,528253200,6),(484,543978000,5),(484,559702800,6),(484,575427600,5),(484,591152400,6),(484,606877200,5),(484,622602000,6),(484,638326800,5),(484,654656400,6),(484,670381200,5),(484,686106000,6),(484,701830800,5),(484,717555600,6),(484,733280400,5),(484,749005200,6),(484,764730000,5),(484,780454800,6),(484,796179600,5),(484,811904400,6),(484,828234000,5),(484,846378000,6),(484,859683600,5),(484,877827600,6),(484,891133200,5),(484,909277200,6),(484,922582800,5),(484,941331600,6),(484,954032400,5),(484,972781200,6),(484,985482000,5),(484,1004230800,6),(484,1017536400,5),(484,1035680400,6),(484,1048986000,5),(484,1067130000,6),(484,1080435600,5),(484,1099184400,6),(484,1111885200,5),(484,1130634000,6),(484,1143334800,5),(484,1162083600,6),(484,1174784400,5),(484,1193533200,6),(484,1206838800,5),(484,1224982800,6),(484,1238288400,5),(484,1256432400,6),(484,1269738000,5),(484,1288486800,6),(484,1301187600,5),(484,1319936400,6),(484,1332637200,5),(484,1351386000,6),(484,1364691600,5),(484,1382835600,6),(484,1396141200,5),(484,1414285200,6),(484,1427590800,5),(484,1445734800,6),(484,1459040400,5),(484,1477789200,6),(484,1490490000,5),(484,1509238800,6),(484,1521939600,5),(484,1540688400,6),(484,1553994000,5),(484,1572138000,6),(484,1585443600,5),(484,1603587600,6),(484,1616893200,5),(484,1635642000,6),(484,1648342800,5),(484,1667091600,6),(484,1679792400,5),(484,1698541200,6),(484,1711846800,5),(484,1729990800,6),(484,1743296400,5),(484,1761440400,6),(484,1774746000,5),(484,1792890000,6),(484,1806195600,5),(484,1824944400,6),(484,1837645200,5),(484,1856394000,6),(484,1869094800,5),(484,1887843600,6),(484,1901149200,5),(484,1919293200,6),(484,1932598800,5),(484,1950742800,6),(484,1964048400,5),(484,1982797200,6),(484,1995498000,5),(484,2014246800,6),(484,2026947600,5),(484,2045696400,6),(484,2058397200,5),(484,2077146000,6),(484,2090451600,5),(484,2108595600,6),(484,2121901200,5),(484,2140045200,6),(485,-2147483648,1),(485,-1672536240,2),(485,-1585100136,3),(485,-1561251600,4),(485,-1553565600,3),(485,-928198800,5),(485,-900126000,8),(485,-857257200,6),(485,-844556400,7),(485,-828226800,6),(485,-812502000,7),(485,-802144800,5),(485,354920400,9),(485,370728000,5),(485,386456400,9),(485,402264000,5),(485,417992400,9),(485,433800000,5),(485,449614800,9),(485,465346800,10),(485,481071600,11),(485,496796400,10),(485,512521200,11),(485,528246000,10),(485,543970800,11),(485,559695600,10),(485,575420400,11),(485,591145200,10),(485,606870000,12),(485,622598400,13),(485,638323200,12),(485,654652800,13),(485,670377600,12),(485,686102400,13),(485,701827200,12),(485,717552000,13),(485,733276800,12),(485,749001600,13),(485,764726400,12),(485,780451200,13),(485,796176000,12),(485,811900800,13),(485,828230400,12),(485,846374400,13),(485,859680000,12),(485,877824000,13),(485,883605600,4),(485,891133200,14),(485,909277200,15),(485,922582800,14),(485,941331600,16),(485,1041372000,4),(485,1048986000,17),(485,1067130000,16),(485,1080435600,17),(485,1099184400,16),(485,1111885200,17),(485,1130634000,16),(485,1143334800,17),(485,1162083600,16),(485,1174784400,17),(485,1193533200,16),(485,1206838800,17),(485,1224982800,16),(485,1238288400,17),(485,1256432400,16),(485,1269738000,17),(485,1288486800,16),(485,1301187600,17),(485,1319936400,16),(485,1332637200,17),(485,1351386000,16),(485,1364691600,17),(485,1382835600,16),(485,1396141200,17),(485,1414285200,16),(485,1427590800,17),(485,1445734800,16),(485,1459040400,17),(485,1477789200,16),(485,1490490000,17),(485,1509238800,16),(485,1521939600,17),(485,1540688400,16),(485,1553994000,17),(485,1572138000,16),(485,1585443600,17),(485,1603587600,16),(485,1616893200,17),(485,1635642000,16),(485,1648342800,17),(485,1667091600,16),(485,1679792400,17),(485,1698541200,16),(485,1711846800,17),(485,1729990800,16),(485,1743296400,17),(485,1761440400,16),(485,1774746000,17),(485,1792890000,16),(485,1806195600,17),(485,1824944400,16),(485,1837645200,17),(485,1856394000,16),(485,1869094800,17),(485,1887843600,16),(485,1901149200,17),(485,1919293200,16),(485,1932598800,17),(485,1950742800,16),(485,1964048400,17),(485,1982797200,16),(485,1995498000,17),(485,2014246800,16),(485,2026947600,17),(485,2045696400,16),(485,2058397200,17),(485,2077146000,16),(485,2090451600,17),(485,2108595600,16),(485,2121901200,17),(485,2140045200,16),(486,-2147483648,0),(486,-1577761060,1),(486,-1247540400,2),(486,354916800,3),(486,370724400,2),(486,386452800,3),(486,402260400,2),(486,417988800,3),(486,433796400,2),(486,449611200,3),(486,465343200,4),(486,481068000,5),(486,496792800,4),(486,512517600,5),(486,528242400,4),(486,543967200,5),(486,559692000,4),(486,575416800,6),(486,591145200,7),(486,606870000,6),(486,622594800,7),(486,638319600,6),(486,654649200,7),(486,670374000,4),(486,701820000,6),(486,717548400,7),(486,733273200,6),(486,748998000,7),(486,764722800,6),(486,780447600,7),(486,796172400,6),(486,811897200,7),(486,828226800,6),(486,846370800,7),(486,859676400,6),(486,877820400,7),(486,891126000,6),(486,909270000,7),(486,922575600,6),(486,941324400,7),(486,954025200,6),(486,972774000,7),(486,985474800,6),(486,1004223600,7),(486,1017529200,6),(486,1035673200,7),(486,1048978800,6),(486,1067122800,7),(486,1080428400,6),(486,1099177200,7),(486,1111878000,6),(486,1130626800,7),(486,1143327600,6),(486,1162076400,7),(486,1174777200,6),(486,1193526000,7),(486,1206831600,6),(486,1224975600,7),(486,1238281200,6),(486,1256425200,7),(486,1269730800,6),(486,1288479600,7),(486,1301180400,8),(486,1414274400,7),(486,1540681200,4),(486,1609020000,7),(487,-2147483648,1),(487,-1717032240,3),(487,-1693706400,2),(487,-1680483600,3),(487,-1663455600,4),(487,-1650150000,5),(487,-1632006000,4),(487,-1618700400,8),(487,-1600473600,6),(487,-1587168000,7),(487,-1501725600,3),(487,-931734000,2),(487,-857257200,5),(487,-844556400,4),(487,-828226800,5),(487,-812502000,4),(487,-796874400,2),(487,-796608000,3),(487,-778726800,2),(487,-762660000,3),(487,-748486800,4),(487,-733273200,5),(487,-715215600,4),(487,-701910000,5),(487,-684975600,4),(487,-670460400,5),(487,-654130800,4),(487,-639010800,5),(487,-397094400,4),(487,-386812800,5),(487,-371088000,4),(487,-355363200,5),(487,-334195200,4),(487,-323308800,5),(487,-307584000,4),(487,-291859200,5),(487,-271296000,4),(487,-260409600,5),(487,-239846400,4),(487,-228960000,5),(487,-208396800,4),(487,-197510400,5),(487,-176342400,4),(487,-166060800,5),(487,220921200,3),(487,228873600,4),(487,243993600,5),(487,260323200,4),(487,276048000,5),(487,291772800,4),(487,307497600,5),(487,323827200,4),(487,338947200,5),(487,354672000,4),(487,370396800,5),(487,386121600,4),(487,401846400,5),(487,417571200,4),(487,433296000,5),(487,449020800,4),(487,465350400,5),(487,481075200,4),(487,496800000,5),(487,512524800,4),(487,528249600,5),(487,543974400,4),(487,559699200,5),(487,567990000,3),(487,575427600,9),(487,591152400,10),(487,606877200,9),(487,622602000,10),(487,638326800,9),(487,654656400,10),(487,670381200,9),(487,686106000,10),(487,701830800,9),(487,717555600,10),(487,733280400,9),(487,749005200,10),(487,764730000,9),(487,780454800,10),(487,796179600,9),(487,811904400,10),(487,828234000,9),(487,846378000,10),(487,859683600,9),(487,877827600,10),(487,891133200,9),(487,909277200,10),(487,922582800,9),(487,941331600,10),(487,954032400,9),(487,972781200,10),(487,985482000,9),(487,1004230800,10),(487,1017536400,9),(487,1035680400,10),(487,1048986000,9),(487,1067130000,10),(487,1080435600,9),(487,1099184400,10),(487,1111885200,9),(487,1130634000,10),(487,1143334800,9),(487,1162083600,10),(487,1174784400,9),(487,1193533200,10),(487,1206838800,9),(487,1224982800,10),(487,1238288400,9),(487,1256432400,10),(487,1269738000,9),(487,1288486800,10),(487,1301187600,9),(487,1319936400,10),(487,1332637200,9),(487,1351386000,10),(487,1364691600,9),(487,1382835600,10),(487,1396141200,9),(487,1414285200,10),(487,1427590800,9),(487,1445734800,10),(487,1459040400,9),(487,1477789200,10),(487,1490490000,9),(487,1509238800,10),(487,1521939600,9),(487,1540688400,10),(487,1553994000,9),(487,1572138000,10),(487,1585443600,9),(487,1603587600,10),(487,1616893200,9),(487,1635642000,10),(487,1648342800,9),(487,1667091600,10),(487,1679792400,9),(487,1698541200,10),(487,1711846800,9),(487,1729990800,10),(487,1743296400,9),(487,1761440400,10),(487,1774746000,9),(487,1792890000,10),(487,1806195600,9),(487,1824944400,10),(487,1837645200,9),(487,1856394000,10),(487,1869094800,9),(487,1887843600,10),(487,1901149200,9),(487,1919293200,10),(487,1932598800,9),(487,1950742800,10),(487,1964048400,9),(487,1982797200,10),(487,1995498000,9),(487,2014246800,10),(487,2026947600,9),(487,2045696400,10),(487,2058397200,9),(487,2077146000,10),(487,2090451600,9),(487,2108595600,10),(487,2121901200,9),(487,2140045200,10),(488,-2147483648,1),(488,-905824800,4),(488,-857257200,2),(488,-844556400,3),(488,-828226800,2),(488,-812502000,3),(488,-796777200,2),(488,-788922000,1),(488,-777942000,3),(488,-766623600,2),(488,407199600,1),(488,417574800,5),(488,433299600,6),(488,449024400,5),(488,465354000,6),(488,481078800,5),(488,496803600,6),(488,512528400,5),(488,528253200,6),(488,543978000,5),(488,559702800,6),(488,575427600,5),(488,591152400,6),(488,606877200,5),(488,622602000,6),(488,638326800,5),(488,654656400,6),(488,670381200,5),(488,686106000,6),(488,701830800,5),(488,717555600,6),(488,733280400,5),(488,749005200,6),(488,764730000,5),(488,780454800,6),(488,796179600,5),(488,811904400,6),(488,828234000,5),(488,846378000,6),(488,859683600,5),(488,877827600,6),(488,891133200,5),(488,909277200,6),(488,922582800,5),(488,941331600,6),(488,954032400,5),(488,972781200,6),(488,985482000,5),(488,1004230800,6),(488,1017536400,5),(488,1035680400,6),(488,1048986000,5),(488,1067130000,6),(488,1080435600,5),(488,1099184400,6),(488,1111885200,5),(488,1130634000,6),(488,1143334800,5),(488,1162083600,6),(488,1174784400,5),(488,1193533200,6),(488,1206838800,5),(488,1224982800,6),(488,1238288400,5),(488,1256432400,6),(488,1269738000,5),(488,1288486800,6),(488,1301187600,5),(488,1319936400,6),(488,1332637200,5),(488,1351386000,6),(488,1364691600,5),(488,1382835600,6),(488,1396141200,5),(488,1414285200,6),(488,1427590800,5),(488,1445734800,6),(488,1459040400,5),(488,1477789200,6),(488,1490490000,5),(488,1509238800,6),(488,1521939600,5),(488,1540688400,6),(488,1553994000,5),(488,1572138000,6),(488,1585443600,5),(488,1603587600,6),(488,1616893200,5),(488,1635642000,6),(488,1648342800,5),(488,1667091600,6),(488,1679792400,5),(488,1698541200,6),(488,1711846800,5),(488,1729990800,6),(488,1743296400,5),(488,1761440400,6),(488,1774746000,5),(488,1792890000,6),(488,1806195600,5),(488,1824944400,6),(488,1837645200,5),(488,1856394000,6),(488,1869094800,5),(488,1887843600,6),(488,1901149200,5),(488,1919293200,6),(488,1932598800,5),(488,1950742800,6),(488,1964048400,5),(488,1982797200,6),(488,1995498000,5),(488,2014246800,6),(488,2026947600,5),(488,2045696400,6),(488,2058397200,5),(488,2077146000,6),(488,2090451600,5),(488,2108595600,6),(488,2121901200,5),(488,2140045200,6),(489,-2147483648,1),(489,-1441159324,2),(489,-1247536800,3),(489,-892522800,6),(489,-857257200,4),(489,-844556400,5),(489,-828226800,4),(489,-825382800,3),(489,354920400,7),(489,370728000,3),(489,386456400,7),(489,402264000,3),(489,417992400,7),(489,433800000,3),(489,449614800,7),(489,465346800,8),(489,481071600,9),(489,496796400,8),(489,512521200,9),(489,528246000,8),(489,543970800,9),(489,559695600,8),(489,575420400,9),(489,591145200,8),(489,606870000,9),(489,622594800,8),(489,638319600,9),(489,646783200,10),(489,686102400,11),(489,701827200,12),(489,717552000,11),(489,733276800,12),(489,749001600,11),(489,764726400,12),(489,780451200,11),(489,796176000,12),(489,811900800,11),(489,828230400,12),(489,831934800,10),(489,846378000,13),(489,859683600,14),(489,877827600,13),(489,891133200,14),(489,909277200,13),(489,922582800,14),(489,941331600,13),(489,954032400,14),(489,972781200,13),(489,985482000,14),(489,1004230800,13),(489,1017536400,14),(489,1035680400,13),(489,1048986000,14),(489,1067130000,13),(489,1080435600,14),(489,1099184400,13),(489,1111885200,14),(489,1130634000,13),(489,1143334800,14),(489,1162083600,13),(489,1174784400,14),(489,1193533200,13),(489,1206838800,14),(489,1224982800,13),(489,1238288400,14),(489,1256432400,13),(489,1269738000,14),(489,1288486800,13),(489,1301187600,14),(489,1319936400,13),(489,1332637200,14),(489,1351386000,13),(489,1364691600,14),(489,1382835600,13),(489,1396141200,14),(489,1414285200,13),(489,1427590800,14),(489,1445734800,13),(489,1459040400,14),(489,1477789200,13),(489,1490490000,14),(489,1509238800,13),(489,1521939600,14),(489,1540688400,13),(489,1553994000,14),(489,1572138000,13),(489,1585443600,14),(489,1603587600,13),(489,1616893200,14),(489,1635642000,13),(489,1648342800,14),(489,1667091600,13),(489,1679792400,14),(489,1698541200,13),(489,1711846800,14),(489,1729990800,13),(489,1743296400,14),(489,1761440400,13),(489,1774746000,14),(489,1792890000,13),(489,1806195600,14),(489,1824944400,13),(489,1837645200,14),(489,1856394000,13),(489,1869094800,14),(489,1887843600,13),(489,1901149200,14),(489,1919293200,13),(489,1932598800,14),(489,1950742800,13),(489,1964048400,14),(489,1982797200,13),(489,1995498000,14),(489,2014246800,13),(489,2026947600,14),(489,2045696400,13),(489,2058397200,14),(489,2077146000,13),(489,2090451600,14),(489,2108595600,13),(489,2121901200,14),(489,2140045200,13),(490,-2147483648,2),(490,-904435200,1),(490,-891129600,2),(490,-872985600,1),(490,-859680000,2),(490,354675600,3),(490,370400400,4),(490,386125200,3),(490,401850000,4),(490,417574800,3),(490,433299600,4),(490,449024400,3),(490,465354000,4),(490,481078800,3),(490,496803600,4),(490,512528400,3),(490,528253200,4),(490,543978000,3),(490,559702800,4),(490,575427600,3),(490,591152400,4),(490,606877200,3),(490,622602000,4),(490,638326800,3),(490,654656400,4),(490,670381200,3),(490,686106000,4),(490,701830800,3),(490,717555600,4),(490,733280400,3),(490,749005200,4),(490,764730000,3),(490,780454800,4),(490,796179600,3),(490,811904400,4),(490,828234000,3),(490,846378000,4),(490,859683600,3),(490,877827600,4),(490,891133200,3),(490,909277200,4),(490,922582800,3),(490,941331600,4),(490,954032400,3),(490,972781200,4),(490,985482000,3),(490,1004230800,4),(490,1017536400,3),(490,1035680400,4),(490,1048986000,3),(490,1067130000,4),(490,1080435600,3),(490,1099184400,4),(490,1111885200,3),(490,1130634000,4),(490,1143334800,3),(490,1162083600,4),(490,1174784400,3),(490,1193533200,4),(490,1206838800,3),(490,1224982800,4),(490,1238288400,3),(490,1256432400,4),(490,1269738000,3),(490,1288486800,4),(490,1301187600,3),(490,1319936400,4),(490,1332637200,3),(490,1351386000,4),(490,1364691600,3),(490,1382835600,4),(490,1396141200,3),(490,1414285200,4),(490,1427590800,3),(490,1445734800,4),(490,1459040400,3),(490,1477789200,4),(490,1490490000,3),(490,1509238800,4),(490,1521939600,3),(490,1540688400,4),(490,1553994000,3),(490,1572138000,4),(490,1585443600,3),(490,1603587600,4),(490,1616893200,3),(490,1635642000,4),(490,1648342800,3),(490,1667091600,4),(490,1679792400,3),(490,1698541200,4),(490,1711846800,3),(490,1729990800,4),(490,1743296400,3),(490,1761440400,4),(490,1774746000,3),(490,1792890000,4),(490,1806195600,3),(490,1824944400,4),(490,1837645200,3),(490,1856394000,4),(490,1869094800,3),(490,1887843600,4),(490,1901149200,3),(490,1919293200,4),(490,1932598800,3),(490,1950742800,4),(490,1964048400,3),(490,1982797200,4),(490,1995498000,3),(490,2014246800,4),(490,2026947600,3),(490,2045696400,4),(490,2058397200,3),(490,2077146000,4),(490,2090451600,3),(490,2108595600,4),(490,2121901200,3),(490,2140045200,4),(491,-2147483648,4),(491,-1691964000,1),(491,-1680472800,2),(491,-1664143200,1),(491,-1650146400,2),(491,-1633903200,1),(491,-1617487200,2),(491,-1601848800,1),(491,-1586037600,2),(491,-1570399200,1),(491,-1552168800,2),(491,-1538344800,1),(491,-1522533600,2),(491,-1507500000,1),(491,-1490565600,2),(491,-1473631200,1),(491,-1460930400,2),(491,-1442786400,1),(491,-1428876000,2),(491,-1410732000,1),(491,-1396216800,2),(491,-1379282400,1),(491,-1364767200,2),(491,-1348437600,1),(491,-1333317600,2),(491,-1315778400,1),(491,-1301263200,2),(491,-1284328800,1),(491,-1269813600,2),(491,-1253484000,1),(491,-1238364000,2),(491,-1221429600,1),(491,-1206914400,2),(491,-1189980000,1),(491,-1175464800,2),(491,-1159135200,1),(491,-1143410400,2),(491,-1126476000,1),(491,-1111960800,2),(491,-1095631200,1),(491,-1080511200,2),(491,-1063576800,1),(491,-1049061600,2),(491,-1032127200,1),(491,-1017612000,2),(491,-1001282400,1),(491,-986162400,2),(491,-969228000,1),(491,-950479200,2),(491,-942012000,1),(491,-904518000,3),(491,-896050800,1),(491,-875487600,3),(491,-864601200,1),(491,-844038000,3),(491,-832546800,1),(491,-812588400,3),(491,-798073200,1),(491,-781052400,3),(491,-772066800,1),(491,-764805600,2),(491,-748476000,1),(491,-733356000,2),(491,-719445600,1),(491,-717030000,3),(491,-706748400,1),(491,-699487200,2),(491,-687996000,1),(491,-668037600,2),(491,-654732000,1),(491,-636588000,2),(491,-622072800,1),(491,-605743200,2),(491,-590623200,1),(491,-574293600,2),(491,-558568800,1),(491,-542239200,2),(491,-527119200,1),(491,-512604000,2),(491,-496274400,1),(491,-481154400,2),(491,-464220000,1),(491,-449704800,2),(491,-432165600,1),(491,-417650400,2),(491,-401320800,1),(491,-386200800,2),(491,-369266400,1),(491,-354751200,2),(491,-337816800,1),(491,-323301600,2),(491,-306972000,1),(491,-291852000,2),(491,-276732000,1),(491,-257983200,2),(491,-245282400,1),(491,-226533600,2),(491,-213228000,1),(491,-195084000,2),(491,-182383200,1),(491,-163634400,2),(491,-150933600,1),(491,-132184800,2),(491,-119484000,1),(491,-100735200,2),(491,-88034400,1),(491,-68680800,2),(491,-59004000,1),(491,-37242000,5),(491,57722400,7),(491,69818400,1),(491,89172000,2),(491,101268000,1),(491,120621600,2),(491,132717600,1),(491,152071200,2),(491,164167200,1),(491,183520800,2),(491,196221600,1),(491,214970400,2),(491,227671200,1),(491,246420000,2),(491,259120800,1),(491,278474400,2),(491,290570400,1),(491,309924000,2),(491,322020000,1),(491,341373600,2),(491,354675600,6),(491,372819600,7),(491,386125200,6),(491,404269200,7),(491,417574800,6),(491,435718800,7),(491,449024400,6),(491,467773200,7),(491,481078800,6),(491,499222800,7),(491,512528400,6),(491,530672400,7),(491,543978000,6),(491,562122000,7),(491,575427600,6),(491,593571600,7),(491,606877200,6),(491,625626000,7),(491,638326800,6),(491,657075600,7),(491,670381200,6),(491,688525200,7),(491,701830800,6),(491,719974800,7),(491,733280400,6),(491,751424400,7),(491,764730000,6),(491,782874000,7),(491,796179600,6),(491,814323600,7),(491,820454400,4),(491,828234000,6),(491,846378000,7),(491,859683600,6),(491,877827600,7),(491,891133200,6),(491,909277200,7),(491,922582800,6),(491,941331600,7),(491,954032400,6),(491,972781200,7),(491,985482000,6),(491,1004230800,7),(491,1017536400,6),(491,1035680400,7),(491,1048986000,6),(491,1067130000,7),(491,1080435600,6),(491,1099184400,7),(491,1111885200,6),(491,1130634000,7),(491,1143334800,6),(491,1162083600,7),(491,1174784400,6),(491,1193533200,7),(491,1206838800,6),(491,1224982800,7),(491,1238288400,6),(491,1256432400,7),(491,1269738000,6),(491,1288486800,7),(491,1301187600,6),(491,1319936400,7),(491,1332637200,6),(491,1351386000,7),(491,1364691600,6),(491,1382835600,7),(491,1396141200,6),(491,1414285200,7),(491,1427590800,6),(491,1445734800,7),(491,1459040400,6),(491,1477789200,7),(491,1490490000,6),(491,1509238800,7),(491,1521939600,6),(491,1540688400,7),(491,1553994000,6),(491,1572138000,7),(491,1585443600,6),(491,1603587600,7),(491,1616893200,6),(491,1635642000,7),(491,1648342800,6),(491,1667091600,7),(491,1679792400,6),(491,1698541200,7),(491,1711846800,6),(491,1729990800,7),(491,1743296400,6),(491,1761440400,7),(491,1774746000,6),(491,1792890000,7),(491,1806195600,6),(491,1824944400,7),(491,1837645200,6),(491,1856394000,7),(491,1869094800,6),(491,1887843600,7),(491,1901149200,6),(491,1919293200,7),(491,1932598800,6),(491,1950742800,7),(491,1964048400,6),(491,1982797200,7),(491,1995498000,6),(491,2014246800,7),(491,2026947600,6),(491,2045696400,7),(491,2058397200,6),(491,2077146000,7),(491,2090451600,6),(491,2108595600,7),(491,2121901200,6),(491,2140045200,7),(492,-2147483648,4),(492,-1691964000,1),(492,-1680472800,2),(492,-1664143200,1),(492,-1650146400,2),(492,-1633903200,1),(492,-1617487200,2),(492,-1601848800,1),(492,-1586037600,2),(492,-1570399200,1),(492,-1552168800,2),(492,-1538344800,1),(492,-1522533600,2),(492,-1507500000,1),(492,-1490565600,2),(492,-1473631200,1),(492,-1460930400,2),(492,-1442786400,1),(492,-1428876000,2),(492,-1410732000,1),(492,-1396216800,2),(492,-1379282400,1),(492,-1364767200,2),(492,-1348437600,1),(492,-1333317600,2),(492,-1315778400,1),(492,-1301263200,2),(492,-1284328800,1),(492,-1269813600,2),(492,-1253484000,1),(492,-1238364000,2),(492,-1221429600,1),(492,-1206914400,2),(492,-1189980000,1),(492,-1175464800,2),(492,-1159135200,1),(492,-1143410400,2),(492,-1126476000,1),(492,-1111960800,2),(492,-1095631200,1),(492,-1080511200,2),(492,-1063576800,1),(492,-1049061600,2),(492,-1032127200,1),(492,-1017612000,2),(492,-1001282400,1),(492,-986162400,2),(492,-969228000,1),(492,-950479200,2),(492,-942012000,1),(492,-904518000,3),(492,-896050800,1),(492,-875487600,3),(492,-864601200,1),(492,-844038000,3),(492,-832546800,1),(492,-812588400,3),(492,-798073200,1),(492,-781052400,3),(492,-772066800,1),(492,-764805600,2),(492,-748476000,1),(492,-733356000,2),(492,-719445600,1),(492,-717030000,3),(492,-706748400,1),(492,-699487200,2),(492,-687996000,1),(492,-668037600,2),(492,-654732000,1),(492,-636588000,2),(492,-622072800,1),(492,-605743200,2),(492,-590623200,1),(492,-574293600,2),(492,-558568800,1),(492,-542239200,2),(492,-527119200,1),(492,-512604000,2),(492,-496274400,1),(492,-481154400,2),(492,-464220000,1),(492,-449704800,2),(492,-432165600,1),(492,-417650400,2),(492,-401320800,1),(492,-386200800,2),(492,-369266400,1),(492,-354751200,2),(492,-337816800,1),(492,-323301600,2),(492,-306972000,1),(492,-291852000,2),(492,-276732000,1),(492,-257983200,2),(492,-245282400,1),(492,-226533600,2),(492,-213228000,1),(492,-195084000,2),(492,-182383200,1),(492,-163634400,2),(492,-150933600,1),(492,-132184800,2),(492,-119484000,1),(492,-100735200,2),(492,-88034400,1),(492,-68680800,2),(492,-59004000,1),(492,-37242000,5),(492,57722400,7),(492,69818400,1),(492,89172000,2),(492,101268000,1),(492,120621600,2),(492,132717600,1),(492,152071200,2),(492,164167200,1),(492,183520800,2),(492,196221600,1),(492,214970400,2),(492,227671200,1),(492,246420000,2),(492,259120800,1),(492,278474400,2),(492,290570400,1),(492,309924000,2),(492,322020000,1),(492,341373600,2),(492,354675600,6),(492,372819600,7),(492,386125200,6),(492,404269200,7),(492,417574800,6),(492,435718800,7),(492,449024400,6),(492,467773200,7),(492,481078800,6),(492,499222800,7),(492,512528400,6),(492,530672400,7),(492,543978000,6),(492,562122000,7),(492,575427600,6),(492,593571600,7),(492,606877200,6),(492,625626000,7),(492,638326800,6),(492,657075600,7),(492,670381200,6),(492,688525200,7),(492,701830800,6),(492,719974800,7),(492,733280400,6),(492,751424400,7),(492,764730000,6),(492,782874000,7),(492,796179600,6),(492,814323600,7),(492,820454400,4),(492,828234000,6),(492,846378000,7),(492,859683600,6),(492,877827600,7),(492,891133200,6),(492,909277200,7),(492,922582800,6),(492,941331600,7),(492,954032400,6),(492,972781200,7),(492,985482000,6),(492,1004230800,7),(492,1017536400,6),(492,1035680400,7),(492,1048986000,6),(492,1067130000,7),(492,1080435600,6),(492,1099184400,7),(492,1111885200,6),(492,1130634000,7),(492,1143334800,6),(492,1162083600,7),(492,1174784400,6),(492,1193533200,7),(492,1206838800,6),(492,1224982800,7),(492,1238288400,6),(492,1256432400,7),(492,1269738000,6),(492,1288486800,7),(492,1301187600,6),(492,1319936400,7),(492,1332637200,6),(492,1351386000,7),(492,1364691600,6),(492,1382835600,7),(492,1396141200,6),(492,1414285200,7),(492,1427590800,6),(492,1445734800,7),(492,1459040400,6),(492,1477789200,7),(492,1490490000,6),(492,1509238800,7),(492,1521939600,6),(492,1540688400,7),(492,1553994000,6),(492,1572138000,7),(492,1585443600,6),(492,1603587600,7),(492,1616893200,6),(492,1635642000,7),(492,1648342800,6),(492,1667091600,7),(492,1679792400,6),(492,1698541200,7),(492,1711846800,6),(492,1729990800,7),(492,1743296400,6),(492,1761440400,7),(492,1774746000,6),(492,1792890000,7),(492,1806195600,6),(492,1824944400,7),(492,1837645200,6),(492,1856394000,7),(492,1869094800,6),(492,1887843600,7),(492,1901149200,6),(492,1919293200,7),(492,1932598800,6),(492,1950742800,7),(492,1964048400,6),(492,1982797200,7),(492,1995498000,6),(492,2014246800,7),(492,2026947600,6),(492,2045696400,7),(492,2058397200,6),(492,2077146000,7),(492,2090451600,6),(492,2108595600,7),(492,2121901200,6),(492,2140045200,7),(499,-2147483648,0),(499,-2056690800,1),(499,-900910800,2),(499,-891579600,3),(499,-884248200,4),(499,-761209200,7),(499,-747907200,2),(499,-728541000,5),(499,-717049800,6),(499,-697091400,5),(499,-683785800,6),(499,-668061000,5),(499,-654755400,2),(499,-636611400,5),(499,-623305800,2),(499,-605161800,5),(499,-591856200,2),(499,-573712200,5),(499,-559801800,2),(499,-541657800,5),(499,-528352200,2),(499,-510211800,7),(499,-498112200,2),(499,-478762200,7),(499,-466662600,2),(499,-446707800,7),(499,-435213000,2),(499,-415258200,7),(499,-403158600,2),(499,-383808600,7),(499,-371709000,2),(499,-352359000,7),(499,-340259400,2),(499,-320909400,7),(499,-308809800,2),(499,-288855000,7),(499,-277360200,2),(499,-257405400,7),(499,-245910600,2),(499,-225955800,7),(499,-213856200,2),(499,-194506200,7),(499,-182406600,2),(499,-163056600,7),(499,-148537800,2),(499,-132816600,7),(499,-117088200,2),(499,-101367000,7),(499,-85638600,2),(499,-69312600,7),(499,-53584200,2),(499,-37863000,7),(499,-22134600,2),(499,-6413400,7),(499,9315000,2),(499,25036200,7),(499,40764600,2),(499,56485800,7),(499,72214200,2),(499,88540200,7),(499,104268600,2),(499,119989800,7),(499,126041400,2),(499,151439400,7),(499,167167800,2),(499,182889000,7),(499,198617400,2),(499,214338600,7),(499,295385400,2),(499,309292200,7),(500,-2147483648,0),(500,-1830383032,1),(501,-2147483648,0),(501,-1946168836,1),(501,-1309746600,2),(501,-1261969200,1),(501,-1041388200,3),(501,-865305900,2),(502,-2147483648,0),(502,-1988167780,1),(502,820436400,2),(502,2147483647,2),(503,-2147483648,1),(503,-1570084924,2),(503,2147483647,2),(504,-2147483648,1),(504,-1577946287,2),(504,-873268200,3),(504,-778410000,2),(504,2147483647,2),(505,-2147483648,0),(505,-1946168836,1),(505,-1309746600,2),(505,-1261969200,1),(505,-1041388200,3),(505,-865305900,2),(506,-2147483648,1),(506,-315636840,2),(506,2147483647,2),(507,-2147483648,0),(507,-1577936472,1),(507,2147483647,1),(508,-2147483648,1),(508,-315636840,2),(508,2147483647,2),(509,-2147483648,0),(509,-1988164200,2),(509,403041600,1),(509,417034800,2),(509,1224972000,1),(509,1238274000,2),(509,2147483647,2),(510,-2147483648,0),(510,-1946168836,1),(510,-1309746600,2),(510,-1261969200,1),(510,-1041388200,3),(510,-865305900,2),(511,-2147483648,0),(511,-1577936472,1),(511,2147483647,1),(512,-2147483648,0),(512,-1704165944,1),(512,-1090466744,3),(512,227820600,2),(512,246223800,5),(512,259617600,4),(512,271108800,5),(512,283982400,3),(512,296598600,2),(512,306531000,3),(512,322432200,2),(512,338499000,3),(512,673216200,2),(512,685481400,3),(512,701209800,2),(512,717103800,3),(512,732745800,2),(512,748639800,3),(512,764281800,2),(512,780175800,3),(512,795817800,2),(512,811711800,3),(512,827353800,2),(512,843247800,3),(512,858976200,2),(512,874870200,3),(512,890512200,2),(512,906406200,3),(512,922048200,2),(512,937942200,3),(512,953584200,2),(512,969478200,3),(512,985206600,2),(512,1001100600,3),(512,1016742600,2),(512,1032636600,3),(512,1048278600,2),(512,1064172600,3),(512,1079814600,2),(512,1095708600,3),(512,1111437000,2),(512,1127331000,3),(512,1206045000,2),(512,1221939000,3),(512,1237667400,2),(512,1253561400,3),(512,1269203400,2),(512,1285097400,3),(512,1300739400,2),(512,1316633400,3),(512,1332275400,2),(512,1348169400,3),(512,1363897800,2),(512,1379791800,3),(512,1395433800,2),(512,1411327800,3),(512,1426969800,2),(512,1442863800,3),(512,1458505800,2),(512,1474399800,3),(512,1490128200,2),(512,1506022200,3),(512,1521664200,2),(512,1537558200,3),(512,1553200200,2),(512,1569094200,3),(512,1584736200,2),(512,1600630200,3),(512,1616358600,2),(512,1632252600,3),(512,1647894600,2),(512,1663788600,3),(512,2147483647,3),(513,-2147483648,1),(513,-1641003640,6),(513,-933638400,2),(513,-923097600,3),(513,-919036800,2),(513,-857347200,3),(513,-844300800,2),(513,-825811200,3),(513,-812678400,2),(513,-794188800,3),(513,-779846400,2),(513,-762652800,3),(513,-748310400,2),(513,-731116800,3),(513,-681955200,4),(513,-673228800,2),(513,-667958400,3),(513,-652320000,2),(513,-636422400,3),(513,-622080000,2),(513,-608947200,3),(513,-591840000,2),(513,-572486400,3),(513,-558576000,2),(513,-542851200,3),(513,-527731200,2),(513,-514425600,3),(513,-490838400,2),(513,-482976000,3),(513,-459388800,2),(513,-451526400,3),(513,-428544000,2),(513,-418262400,3),(513,-400118400,2),(513,-387417600,3),(513,142380000,5),(513,150843600,6),(513,167176800,5),(513,178664400,6),(513,334101600,7),(513,337730400,8),(513,452642400,7),(513,462319200,8),(513,482277600,5),(513,494370000,6),(513,516751200,5),(513,526424400,6),(513,545436000,5),(513,558478800,6),(513,576626400,5),(513,589323600,6),(513,609890400,5),(513,620773200,6),(513,638316000,5),(513,651618000,6),(513,669765600,5),(513,683672400,6),(513,701820000,5),(513,715726800,6),(513,733701600,5),(513,747176400,6),(513,765151200,5),(513,778021200,6),(513,796600800,5),(513,810075600,6),(513,826840800,5),(513,842821200,6),(513,858895200,5),(513,874184400,6),(513,890344800,5),(513,905029200,6),(513,923011200,5),(513,936313200,6),(513,955670400,5),(513,970783200,6),(513,986770800,5),(513,1001282400,6),(513,1017356400,5),(513,1033941600,6),(513,1048806000,5),(513,1065132000,6),(513,1081292400,5),(513,1095804000,6),(513,1112313600,5),(513,1128812400,6),(513,1143763200,5),(513,1159657200,6),(513,1175212800,5),(513,1189897200,6),(513,1206662400,5),(513,1223161200,6),(513,1238112000,5),(513,1254006000,6),(513,1269561600,5),(513,1284246000,6),(513,1301616000,5),(513,1317510000,6),(513,1333065600,5),(513,1348354800,6),(513,1364515200,5),(513,1382828400,6),(513,1395964800,5),(513,1414278000,6),(513,1427414400,5),(513,1445727600,6),(513,1458864000,5),(513,1477782000,6),(513,1490313600,5),(513,1509231600,6),(513,1521763200,5),(513,1540681200,6),(513,1553817600,5),(513,1572130800,6),(513,1585267200,5),(513,1603580400,6),(513,1616716800,5),(513,1635634800,6),(513,1648166400,5),(513,1667084400,6),(513,1679616000,5),(513,1698534000,6),(513,1711670400,5),(513,1729983600,6),(513,1743120000,5),(513,1761433200,6),(513,1774569600,5),(513,1792882800,6),(513,1806019200,5),(513,1824937200,6),(513,1837468800,5),(513,1856386800,6),(513,1868918400,5),(513,1887836400,6),(513,1900972800,5),(513,1919286000,6),(513,1932422400,5),(513,1950735600,6),(513,1963872000,5),(513,1982790000,6),(513,1995321600,5),(513,2014239600,6),(513,2026771200,5),(513,2045689200,6),(513,2058220800,5),(513,2077138800,6),(513,2090275200,5),(513,2108588400,6),(513,2121724800,5),(513,2140038000,6),(514,-2147483648,1),(514,-1827687170,2),(514,126687600,3),(514,152085600,2),(514,162370800,3),(514,183535200,2),(514,199263600,3),(514,215589600,2),(514,230713200,3),(514,247039200,2),(514,262767600,3),(514,278488800,2),(514,294217200,3),(514,309938400,2),(514,325666800,3),(514,341388000,2),(514,357116400,3),(514,372837600,2),(514,388566000,3),(514,404892000,2),(514,420015600,3),(514,436341600,2),(515,-2147483648,3),(515,-683802000,1),(515,-672310800,2),(515,-654771600,1),(515,-640861200,2),(515,-620298000,1),(515,-609411600,2),(515,-588848400,1),(515,-577962000,2),(516,-2147483648,1),(516,-1041418800,2),(516,-907408800,3),(516,-817462800,1),(516,-7988400,4),(516,745934400,5),(516,2147483647,5),(517,-2147483648,0),(517,-1577926364,2),(517,-574902000,1),(517,-568087200,2),(517,-512175600,1),(517,-504928800,2),(517,-449888400,1),(517,-441856800,2),(517,-347158800,3),(517,378684000,2),(517,386463600,1),(517,402271200,2),(517,417999600,1),(517,433807200,2),(517,449622000,1),(517,465429600,2),(517,481590000,1),(517,496965600,2),(517,512953200,1),(517,528674400,2),(517,544230000,1),(517,560037600,2),(517,575852400,1),(517,591660000,2),(517,607388400,1),(517,623196000,2),(517,641775600,3),(517,844034400,2),(517,860108400,1),(517,875916000,3),(517,1352505600,2),(517,1364515200,1),(517,1382659200,3),(518,-1693706400,0),(518,-1680483600,1),(518,-1663455600,2),(518,-1650150000,3),(518,-1632006000,2),(518,-1618700400,3),(518,-938905200,2),(518,-857257200,3),(518,-844556400,2),(518,-828226800,3),(518,-812502000,2),(518,-796777200,3),(518,-781052400,2),(518,-766623600,3),(518,228877200,2),(518,243997200,3),(518,260326800,2),(518,276051600,3),(518,291776400,2),(518,307501200,3),(518,323830800,2),(518,338950800,3),(518,354675600,2),(518,370400400,3),(518,386125200,2),(518,401850000,3),(518,417574800,2),(518,433299600,3),(518,449024400,2),(518,465354000,3),(518,481078800,2),(518,496803600,3),(518,512528400,2),(518,528253200,3),(518,543978000,2),(518,559702800,3),(518,575427600,2),(518,591152400,3),(518,606877200,2),(518,622602000,3),(518,638326800,2),(518,654656400,3),(518,670381200,2),(518,686106000,3),(518,701830800,2),(518,717555600,3),(518,733280400,2),(518,749005200,3),(518,764730000,2),(518,780454800,3),(518,796179600,2),(518,811904400,3),(518,828234000,2),(518,846378000,3),(518,859683600,2),(518,877827600,3),(518,891133200,2),(518,909277200,3),(518,922582800,2),(518,941331600,3),(518,954032400,2),(518,972781200,3),(518,985482000,2),(518,1004230800,3),(518,1017536400,2),(518,1035680400,3),(518,1048986000,2),(518,1067130000,3),(518,1080435600,2),(518,1099184400,3),(518,1111885200,2),(518,1130634000,3),(518,1143334800,2),(518,1162083600,3),(518,1174784400,2),(518,1193533200,3),(518,1206838800,2),(518,1224982800,3),(518,1238288400,2),(518,1256432400,3),(518,1269738000,2),(518,1288486800,3),(518,1301187600,2),(518,1319936400,3),(518,1332637200,2),(518,1351386000,3),(518,1364691600,2),(518,1382835600,3),(518,1396141200,2),(518,1414285200,3),(518,1427590800,2),(518,1445734800,3),(518,1459040400,2),(518,1477789200,3),(518,1490490000,2),(518,1509238800,3),(518,1521939600,2),(518,1540688400,3),(518,1553994000,2),(518,1572138000,3),(518,1585443600,2),(518,1603587600,3),(518,1616893200,2),(518,1635642000,3),(518,1648342800,2),(518,1667091600,3),(518,1679792400,2),(518,1698541200,3),(518,1711846800,2),(518,1729990800,3),(518,1743296400,2),(518,1761440400,3),(518,1774746000,2),(518,1792890000,3),(518,1806195600,2),(518,1824944400,3),(518,1837645200,2),(518,1856394000,3),(518,1869094800,2),(518,1887843600,3),(518,1901149200,2),(518,1919293200,3),(518,1932598800,2),(518,1950742800,3),(518,1964048400,2),(518,1982797200,3),(518,1995498000,2),(518,2014246800,3),(518,2026947600,2),(518,2045696400,3),(518,2058397200,2),(518,2077146000,3),(518,2090451600,2),(518,2108595600,3),(518,2121901200,2),(518,2140045200,3),(520,-1633273200,0),(520,-1615132800,1),(520,-1601823600,0),(520,-1583683200,1),(520,-880210800,2),(520,-769395600,3),(520,-765388800,1),(520,-84380400,0),(520,-68659200,1),(520,-52930800,0),(520,-37209600,1),(520,-21481200,0),(520,-5760000,1),(520,9968400,0),(520,25689600,1),(520,41418000,0),(520,57744000,1),(520,73472400,0),(520,89193600,1),(520,104922000,0),(520,120643200,1),(520,126694800,0),(520,152092800,1),(520,162378000,0),(520,183542400,1),(520,199270800,0),(520,215596800,1),(520,230720400,0),(520,247046400,1),(520,262774800,0),(520,278496000,1),(520,294224400,0),(520,309945600,1),(520,325674000,0),(520,341395200,1),(520,357123600,0),(520,372844800,1),(520,388573200,0),(520,404899200,1),(520,420022800,0),(520,436348800,1),(520,452077200,0),(520,467798400,1),(520,483526800,0),(520,499248000,1),(520,514976400,0),(520,530697600,1),(520,544611600,0),(520,562147200,1),(520,576061200,0),(520,594201600,1),(520,607510800,0),(520,625651200,1),(520,638960400,0),(520,657100800,1),(520,671014800,0),(520,688550400,1),(520,702464400,0),(520,720000000,1),(520,733914000,0),(520,752054400,1),(520,765363600,0),(520,783504000,1),(520,796813200,0),(520,814953600,1),(520,828867600,0),(520,846403200,1),(520,860317200,0),(520,877852800,1),(520,891766800,0),(520,909302400,1),(520,923216400,0),(520,941356800,1),(520,954666000,0),(520,972806400,1),(520,986115600,0),(520,1004256000,1),(520,1018170000,0),(520,1035705600,1),(520,1049619600,0),(520,1067155200,1),(520,1081069200,0),(520,1099209600,1),(520,1112518800,0),(520,1130659200,1),(520,1143968400,0),(520,1162108800,1),(520,1173603600,0),(520,1194163200,1),(520,1205053200,0),(520,1225612800,1),(520,1236502800,0),(520,1257062400,1),(520,1268557200,0),(520,1289116800,1),(520,1300006800,0),(520,1320566400,1),(520,1331456400,0),(520,1352016000,1),(520,1362906000,0),(520,1383465600,1),(520,1394355600,0),(520,1414915200,1),(520,1425805200,0),(520,1446364800,1),(520,1457859600,0),(520,1478419200,1),(520,1489309200,0),(520,1509868800,1),(520,1520758800,0),(520,1541318400,1),(520,1552208400,0),(520,1572768000,1),(520,1583658000,0),(520,1604217600,1),(520,1615712400,0),(520,1636272000,1),(520,1647162000,0),(520,1667721600,1),(520,1678611600,0),(520,1699171200,1),(520,1710061200,0),(520,1730620800,1),(520,1741510800,0),(520,1762070400,1),(520,1772960400,0),(520,1793520000,1),(520,1805014800,0),(520,1825574400,1),(520,1836464400,0),(520,1857024000,1),(520,1867914000,0),(520,1888473600,1),(520,1899363600,0),(520,1919923200,1),(520,1930813200,0),(520,1951372800,1),(520,1962867600,0),(520,1983427200,1),(520,1994317200,0),(520,2014876800,1),(520,2025766800,0),(520,2046326400,1),(520,2057216400,0),(520,2077776000,1),(520,2088666000,0),(520,2109225600,1),(520,2120115600,0),(520,2140675200,1),(521,-2147483648,0),(521,-1514739600,1),(521,-1451667600,2),(521,-1343062800,3),(521,-1234803600,2),(521,-1222963200,4),(521,-1207242000,2),(521,-873820800,5),(521,-769395600,6),(521,-761677200,2),(521,-686073600,4),(521,-661539600,2),(521,-495039600,4),(521,-481734000,2),(521,-463590000,4),(521,-450284400,2),(521,-431535600,4),(521,-418230000,2),(521,-400086000,4),(521,-386780400,2),(521,-368636400,4),(521,-355330800,2),(521,-337186800,4),(521,-323881200,2),(521,-305737200,4),(521,-292431600,2),(521,199274400,4),(521,215600400,2),(521,230724000,4),(521,247050000,2),(521,262778400,4),(521,278499600,2),(521,294228000,4),(521,309949200,2),(521,325677600,4),(521,341398800,2),(521,357127200,4),(521,372848400,2),(521,388576800,4),(521,404902800,2),(521,420026400,4),(521,436352400,2),(521,452080800,4),(521,467802000,2),(521,483530400,4),(521,499251600,2),(521,514980000,4),(521,530701200,2),(521,544615200,4),(521,562150800,2),(521,576064800,4),(521,594205200,2),(521,607514400,4),(521,625654800,2),(521,638964000,4),(521,657104400,2),(521,671018400,4),(521,688554000,2),(521,702468000,4),(521,720003600,2),(521,733917600,4),(521,752058000,2),(521,765367200,4),(521,783507600,2),(521,796816800,4),(521,814957200,2),(521,828871200,4),(521,846406800,2),(521,860320800,4),(521,877856400,2),(521,891770400,4),(521,909306000,2),(521,923220000,4),(521,941360400,2),(521,954669600,4),(521,972810000,2),(521,986119200,4),(521,1004259600,2),(521,1018173600,4),(521,1035709200,2),(521,1049623200,4),(521,1067158800,2),(521,1081072800,4),(521,1099213200,2),(521,1112522400,4),(521,1130662800,2),(521,1143972000,4),(521,1162112400,2),(521,1175421600,4),(521,1193562000,2),(521,1207476000,4),(521,1225011600,2),(521,1238925600,4),(521,1256461200,2),(521,1268560800,4),(521,1289120400,2),(521,1300010400,4),(521,1320570000,2),(521,1331460000,4),(521,1352019600,2),(521,1362909600,4),(521,1383469200,2),(521,1394359200,4),(521,1414918800,2),(521,1425808800,4),(521,1446368400,2),(521,1457863200,4),(521,1478422800,2),(521,1489312800,4),(521,1509872400,2),(521,1520762400,4),(521,1541322000,2),(521,1552212000,4),(521,1572771600,2),(521,1583661600,4),(521,1604221200,2),(521,1615716000,4),(521,1636275600,2),(521,1647165600,4),(521,1667725200,2),(521,1678615200,4),(521,1699174800,2),(521,1710064800,4),(521,1730624400,2),(521,1741514400,4),(521,1762074000,2),(521,1772964000,4),(521,1793523600,2),(521,1805018400,4),(521,1825578000,2),(521,1836468000,4),(521,1857027600,2),(521,1867917600,4),(521,1888477200,2),(521,1899367200,4),(521,1919926800,2),(521,1930816800,4),(521,1951376400,2),(521,1962871200,4),(521,1983430800,2),(521,1994320800,4),(521,2014880400,2),(521,2025770400,4),(521,2046330000,2),(521,2057220000,4),(521,2077779600,2),(521,2088669600,4),(521,2109229200,2),(521,2120119200,4),(521,2140678800,2),(522,-2147483648,0),(522,-1514739600,1),(522,-1343066400,2),(522,-1234807200,4),(522,-1220292000,3),(522,-1207159200,4),(522,-1191344400,2),(522,-873828000,4),(522,-661539600,5),(522,28800,4),(522,828867600,3),(522,846403200,4),(522,860317200,3),(522,877852800,4),(522,891766800,3),(522,909302400,4),(522,923216400,3),(522,941356800,4),(522,954666000,3),(522,972806400,4),(522,989139600,3),(522,1001836800,4),(522,1018170000,3),(522,1035705600,4),(522,1049619600,3),(522,1067155200,4),(522,1081069200,3),(522,1099209600,4),(522,1112518800,3),(522,1130659200,4),(522,1143968400,3),(522,1162108800,4),(522,1175418000,3),(522,1193558400,4),(522,1207472400,3),(522,1225008000,4),(522,1238922000,3),(522,1256457600,4),(522,1270371600,3),(522,1288512000,4),(522,1301821200,3),(522,1319961600,4),(522,1333270800,3),(522,1351411200,4),(522,1365325200,3),(522,1382860800,4),(522,1396774800,3),(522,1414310400,4),(522,1428224400,3),(522,1445760000,4),(522,1459674000,3),(522,1477814400,4),(522,1491123600,3),(522,1509264000,4),(522,1522573200,3),(522,1540713600,4),(522,1554627600,3),(522,1572163200,4),(522,1586077200,3),(522,1603612800,4),(522,1617526800,3),(522,1635667200,4),(522,1648976400,3),(522,1667116800,4),(523,-2147483648,0),(523,-1514739600,1),(523,-1343066400,2),(523,-1234807200,4),(523,-1220292000,3),(523,-1207159200,4),(523,-1191344400,2),(523,-975261600,5),(523,-963169200,2),(523,-917114400,5),(523,-907354800,2),(523,-821901600,6),(523,-810068400,2),(523,-627501600,5),(523,-612990000,2),(523,828864000,5),(523,846399600,2),(523,860313600,5),(523,877849200,2),(523,891763200,5),(523,909298800,2),(523,923212800,5),(523,941353200,2),(523,954662400,5),(523,972802800,2),(523,989136000,5),(523,1001833200,2),(523,1018166400,5),(523,1035702000,2),(523,1049616000,5),(523,1067151600,2),(523,1081065600,5),(523,1099206000,2),(523,1112515200,5),(523,1130655600,2),(523,1143964800,5),(523,1162105200,2),(523,1175414400,5),(523,1193554800,2),(523,1207468800,5),(523,1225004400,2),(523,1238918400,5),(523,1256454000,2),(523,1270368000,5),(523,1288508400,2),(523,1301817600,5),(523,1319958000,2),(523,1333267200,5),(523,1351407600,2),(523,1365321600,5),(523,1382857200,2),(523,1396771200,5),(523,1414306800,2),(523,1428220800,5),(523,1445756400,2),(523,1459670400,5),(523,1477810800,2),(523,1491120000,5),(523,1509260400,2),(523,1522569600,5),(523,1540710000,2),(523,1554624000,5),(523,1572159600,2),(523,1586073600,5),(523,1603609200,2),(523,1617523200,5),(523,1635663600,2),(523,1648972800,5),(523,1667113200,2),(524,-2147483648,2),(524,-1330335000,1),(524,-1320057000,2),(524,-1300699800,3),(524,-1287396000,2),(524,-1269250200,3),(524,-1255946400,2),(524,-1237800600,3),(524,-1224496800,2),(524,-1206351000,3),(524,-1192442400,2),(524,-1174901400,3),(524,-1160992800,2),(524,-1143451800,3),(524,-1125914400,2),(524,-1112607000,3),(524,-1094464800,2),(524,-1081157400,3),(524,-1063015200,2),(524,-1049707800,3),(524,-1031565600,2),(524,-1018258200,3),(524,-1000116000,2),(524,-986808600,3),(524,-968061600,2),(524,-955359000,3),(524,-936612000,2),(524,-923304600,3),(524,-757425600,6),(524,152632800,4),(524,162309600,5),(524,183477600,4),(524,194968800,5),(524,215532000,4),(524,226418400,5),(524,246981600,4),(524,257868000,5),(524,278431200,4),(524,289317600,5),(524,309880800,4),(524,320767200,5),(524,341330400,4),(524,352216800,5),(524,372780000,4),(524,384271200,5),(524,404834400,4),(524,415720800,5),(524,436284000,4),(524,447170400,5),(524,467733600,4),(524,478620000,5),(524,499183200,4),(524,510069600,5),(524,530632800,4),(524,541519200,5),(524,562082400,4),(524,573573600,5),(524,594136800,4),(524,605023200,5),(524,623772000,4),(524,637682400,5),(524,655221600,4),(524,669132000,5),(524,686671200,4),(524,700581600,5),(524,718120800,4),(524,732636000,5),(524,749570400,4),(524,764085600,5),(524,781020000,4),(524,795535200,5),(524,812469600,4),(524,826984800,5),(524,844524000,4),(524,858434400,5),(524,875973600,4),(524,889884000,5),(524,907423200,4),(524,921938400,5),(524,938872800,4),(524,953388000,5),(524,970322400,4),(524,984837600,5),(524,1002376800,4),(524,1016287200,5),(524,1033826400,4),(524,1047736800,5),(524,1065276000,4),(524,1079791200,5),(524,1096725600,4),(524,1111240800,5),(524,1128175200,4),(524,1142690400,5),(524,1159624800,4),(524,1174140000,5),(524,1191074400,4),(524,1207404000,5),(524,1222524000,4),(524,1238853600,5),(524,1253973600,4),(524,1270303200,5),(524,1285423200,4),(524,1301752800,5),(524,1316872800,4),(524,1333202400,5),(524,1348927200,4),(524,1365256800,5),(524,1380376800,4),(524,1396706400,5),(524,1411826400,4),(524,1428156000,5),(524,1443276000,4),(524,1459605600,5),(524,1474725600,4),(524,1491055200,5),(524,1506175200,4),(524,1522504800,5),(524,1538229600,4),(524,1554559200,5),(524,1569679200,4),(524,1586008800,5),(524,1601128800,4),(524,1617458400,5),(524,1632578400,4),(524,1648908000,5),(524,1664028000,4),(524,1680357600,5),(524,1695477600,4),(524,1712412000,5),(524,1727532000,4),(524,1743861600,5),(524,1758981600,4),(524,1775311200,5),(524,1790431200,4),(524,1806760800,5),(524,1821880800,4),(524,1838210400,5),(524,1853330400,4),(524,1869660000,5),(524,1885384800,4),(524,1901714400,5),(524,1916834400,4),(524,1933164000,5),(524,1948284000,4),(524,1964613600,5),(524,1979733600,4),(524,1996063200,5),(524,2011183200,4),(524,2027512800,5),(524,2042632800,4),(524,2058962400,5),(524,2074687200,4),(524,2091016800,5),(524,2106136800,4),(524,2122466400,5),(524,2137586400,4),(525,-2147483648,1),(525,-757426500,4),(525,152632800,2),(525,162309600,3),(525,183477600,2),(525,194968800,3),(525,215532000,2),(525,226418400,3),(525,246981600,2),(525,257868000,3),(525,278431200,2),(525,289317600,3),(525,309880800,2),(525,320767200,3),(525,341330400,2),(525,352216800,3),(525,372780000,2),(525,384271200,3),(525,404834400,2),(525,415720800,3),(525,436284000,2),(525,447170400,3),(525,467733600,2),(525,478620000,3),(525,499183200,2),(525,510069600,3),(525,530632800,2),(525,541519200,3),(525,562082400,2),(525,573573600,3),(525,594136800,2),(525,605023200,3),(525,623772000,2),(525,637682400,3),(525,655221600,2),(525,669132000,3),(525,686671200,2),(525,700581600,3),(525,718120800,2),(525,732636000,3),(525,749570400,2),(525,764085600,3),(525,781020000,2),(525,795535200,3),(525,812469600,2),(525,826984800,3),(525,844524000,2),(525,858434400,3),(525,875973600,2),(525,889884000,3),(525,907423200,2),(525,921938400,3),(525,938872800,2),(525,953388000,3),(525,970322400,2),(525,984837600,3),(525,1002376800,2),(525,1016287200,3),(525,1033826400,2),(525,1047736800,3),(525,1065276000,2),(525,1079791200,3),(525,1096725600,2),(525,1111240800,3),(525,1128175200,2),(525,1142690400,3),(525,1159624800,2),(525,1174140000,3),(525,1191074400,2),(525,1207404000,3),(525,1222524000,2),(525,1238853600,3),(525,1253973600,2),(525,1270303200,3),(525,1285423200,2),(525,1301752800,3),(525,1316872800,2),(525,1333202400,3),(525,1348927200,2),(525,1365256800,3),(525,1380376800,2),(525,1396706400,3),(525,1411826400,2),(525,1428156000,3),(525,1443276000,2),(525,1459605600,3),(525,1474725600,2),(525,1491055200,3),(525,1506175200,2),(525,1522504800,3),(525,1538229600,2),(525,1554559200,3),(525,1569679200,2),(525,1586008800,3),(525,1601128800,2),(525,1617458400,3),(525,1632578400,2),(525,1648908000,3),(525,1664028000,2),(525,1680357600,3),(525,1695477600,2),(525,1712412000,3),(525,1727532000,2),(525,1743861600,3),(525,1758981600,2),(525,1775311200,3),(525,1790431200,2),(525,1806760800,3),(525,1821880800,2),(525,1838210400,3),(525,1853330400,2),(525,1869660000,3),(525,1885384800,2),(525,1901714400,3),(525,1916834400,2),(525,1933164000,3),(525,1948284000,2),(525,1964613600,3),(525,1979733600,2),(525,1996063200,3),(525,2011183200,2),(525,2027512800,3),(525,2042632800,2),(525,2058962400,3),(525,2074687200,2),(525,2091016800,3),(525,2106136800,2),(525,2122466400,3),(525,2137586400,2),(525,2147483647,2),(526,-2147483648,3),(526,-1633273200,1),(526,-1615132800,2),(526,-1601823600,1),(526,-1583683200,2),(526,-1570374000,1),(526,-1551628800,2),(526,-1538924400,1),(526,-1534089600,2),(526,-880210800,4),(526,-769395600,5),(526,-765388800,2),(526,-147884400,1),(526,-131558400,2),(526,-116434800,1),(526,-100108800,2),(526,-84380400,1),(526,-68659200,2),(526,-52930800,1),(526,-37209600,2),(526,-21481200,1),(526,-5760000,2),(526,9968400,1),(526,25689600,2),(526,41418000,1),(526,57744000,2),(526,73472400,1),(526,89193600,2),(526,104922000,1),(526,120643200,2),(526,126694800,1),(526,152092800,2),(526,162378000,1),(526,183542400,2),(526,199270800,1),(526,215596800,2),(526,230720400,1),(526,247046400,2),(526,262774800,1),(526,278496000,2),(526,294224400,1),(526,309945600,2),(526,325674000,1),(526,341395200,2),(526,357123600,1),(526,372844800,2),(526,388573200,1),(526,404899200,2),(526,420022800,1),(526,436348800,2),(526,452077200,1),(526,467798400,2),(526,483526800,1),(526,499248000,2),(526,514976400,1),(526,530697600,2),(526,544611600,1),(526,562147200,2),(526,576061200,1),(526,594201600,2),(526,607510800,1),(526,625651200,2),(526,638960400,1),(526,657100800,2),(526,671014800,1),(526,688550400,2),(526,702464400,1),(526,720000000,2),(526,733914000,1),(526,752054400,2),(526,765363600,1),(526,783504000,2),(526,796813200,1),(526,814953600,2),(526,828867600,1),(526,846403200,2),(526,860317200,1),(526,877852800,2),(526,891766800,1),(526,909302400,2),(526,923216400,1),(526,941356800,2),(526,954666000,1),(526,972806400,2),(526,986115600,1),(526,1004256000,2),(526,1018170000,1),(526,1035705600,2),(526,1049619600,1),(526,1067155200,2),(526,1081069200,1),(526,1099209600,2),(526,1112518800,1),(526,1130659200,2),(526,1143968400,1),(526,1162108800,2),(526,1173603600,1),(526,1194163200,2),(526,1205053200,1),(526,1225612800,2),(526,1236502800,1),(526,1257062400,2),(526,1268557200,1),(526,1289116800,2),(526,1300006800,1),(526,1320566400,2),(526,1331456400,1),(526,1352016000,2),(526,1362906000,1),(526,1383465600,2),(526,1394355600,1),(526,1414915200,2),(526,1425805200,1),(526,1446364800,2),(526,1457859600,1),(526,1478419200,2),(526,1489309200,1),(526,1509868800,2),(526,1520758800,1),(526,1541318400,2),(526,1552208400,1),(526,1572768000,2),(526,1583658000,1),(526,1604217600,2),(526,1615712400,1),(526,1636272000,2),(526,1647162000,1),(526,1667721600,2),(526,1678611600,1),(526,1699171200,2),(526,1710061200,1),(526,1730620800,2),(526,1741510800,1),(526,1762070400,2),(526,1772960400,1),(526,1793520000,2),(526,1805014800,1),(526,1825574400,2),(526,1836464400,1),(526,1857024000,2),(526,1867914000,1),(526,1888473600,2),(526,1899363600,1),(526,1919923200,2),(526,1930813200,1),(526,1951372800,2),(526,1962867600,1),(526,1983427200,2),(526,1994317200,1),(526,2014876800,2),(526,2025766800,1),(526,2046326400,2),(526,2057216400,1),(526,2077776000,2),(526,2088666000,1),(526,2109225600,2),(526,2120115600,1),(526,2140675200,2),(527,-2147483648,2),(527,-1600675200,1),(527,-1585904400,2),(527,-933667200,1),(527,-922093200,2),(527,-908870400,1),(527,-888829200,2),(527,-881049600,1),(527,-767869200,2),(527,-745833600,1),(527,-733827600,2),(527,-716889600,1),(527,-699613200,2),(527,-683884800,1),(527,-670669200,2),(527,-652348800,1),(527,-650019600,2),(527,515527200,1),(527,527014800,2),(527,545162400,1),(527,558464400,2),(527,577216800,1),(527,589914000,2),(527,608666400,1),(527,621968400,2),(527,640116000,1),(527,653418000,2),(527,671565600,1),(527,684867600,2),(528,-1633269600,0),(528,-1615129200,1),(528,-1601820000,0),(528,-1583679600,1),(528,-880207200,2),(528,-769395600,3),(528,-765385200,1),(528,-84376800,0),(528,-68655600,1),(528,-52927200,0),(528,-37206000,1),(528,-21477600,0),(528,-5756400,1),(528,9972000,0),(528,25693200,1),(528,41421600,0),(528,57747600,1),(528,73476000,0),(528,89197200,1),(528,104925600,0),(528,120646800,1),(528,126698400,0),(528,152096400,1),(528,162381600,0),(528,183546000,1),(528,199274400,0),(528,215600400,1),(528,230724000,0),(528,247050000,1),(528,262778400,0),(528,278499600,1),(528,294228000,0),(528,309949200,1),(528,325677600,0),(528,341398800,1),(528,357127200,0),(528,372848400,1),(528,388576800,0),(528,404902800,1),(528,420026400,0),(528,436352400,1),(528,452080800,0),(528,467802000,1),(528,483530400,0),(528,499251600,1),(528,514980000,0),(528,530701200,1),(528,544615200,0),(528,562150800,1),(528,576064800,0),(528,594205200,1),(528,607514400,0),(528,625654800,1),(528,638964000,0),(528,657104400,1),(528,671018400,0),(528,688554000,1),(528,702468000,0),(528,720003600,1),(528,733917600,0),(528,752058000,1),(528,765367200,0),(528,783507600,1),(528,796816800,0),(528,814957200,1),(528,828871200,0),(528,846406800,1),(528,860320800,0),(528,877856400,1),(528,891770400,0),(528,909306000,1),(528,923220000,0),(528,941360400,1),(528,954669600,0),(528,972810000,1),(528,986119200,0),(528,1004259600,1),(528,1018173600,0),(528,1035709200,1),(528,1049623200,0),(528,1067158800,1),(528,1081072800,0),(528,1099213200,1),(528,1112522400,0),(528,1130662800,1),(528,1143972000,0),(528,1162112400,1),(528,1173607200,0),(528,1194166800,1),(528,1205056800,0),(528,1225616400,1),(528,1236506400,0),(528,1257066000,1),(528,1268560800,0),(528,1289120400,1),(528,1300010400,0),(528,1320570000,1),(528,1331460000,0),(528,1352019600,1),(528,1362909600,0),(528,1383469200,1),(528,1394359200,0),(528,1414918800,1),(528,1425808800,0),(528,1446368400,1),(528,1457863200,0),(528,1478422800,1),(528,1489312800,0),(528,1509872400,1),(528,1520762400,0),(528,1541322000,1),(528,1552212000,0),(528,1572771600,1),(528,1583661600,0),(528,1604221200,1),(528,1615716000,0),(528,1636275600,1),(528,1647165600,0),(528,1667725200,1),(528,1678615200,0),(528,1699174800,1),(528,1710064800,0),(528,1730624400,1),(528,1741514400,0),(528,1762074000,1),(528,1772964000,0),(528,1793523600,1),(528,1805018400,0),(528,1825578000,1),(528,1836468000,0),(528,1857027600,1),(528,1867917600,0),(528,1888477200,1),(528,1899367200,0),(528,1919926800,1),(528,1930816800,0),(528,1951376400,1),(528,1962871200,0),(528,1983430800,1),(528,1994320800,0),(528,2014880400,1),(528,2025770400,0),(528,2046330000,1),(528,2057220000,0),(528,2077779600,1),(528,2088669600,0),(528,2109229200,1),(528,2120119200,0),(528,2140678800,1),(529,-2147483648,1),(529,-1861878784,2),(529,-631110600,4),(529,1285498800,3),(529,1301752800,4),(529,1316872800,3),(529,1325239200,6),(529,1333202400,5),(529,1348927200,6),(529,1365256800,5),(529,1380376800,6),(529,1396706400,5),(529,1411826400,6),(529,1428156000,5),(529,1443276000,6),(529,1459605600,5),(529,1474725600,6),(529,1491055200,5),(529,1506175200,6),(529,1522504800,5),(529,1538229600,6),(529,1554559200,5),(529,1569679200,6),(529,1586008800,5),(529,1601128800,6),(529,1617458400,5),(529,2147483647,5),(530,-2147483648,2),(530,-1330335000,1),(530,-1320057000,2),(530,-1300699800,3),(530,-1287396000,2),(530,-1269250200,3),(530,-1255946400,2),(530,-1237800600,3),(530,-1224496800,2),(530,-1206351000,3),(530,-1192442400,2),(530,-1174901400,3),(530,-1160992800,2),(530,-1143451800,3),(530,-1125914400,2),(530,-1112607000,3),(530,-1094464800,2),(530,-1081157400,3),(530,-1063015200,2),(530,-1049707800,3),(530,-1031565600,2),(530,-1018258200,3),(530,-1000116000,2),(530,-986808600,3),(530,-968061600,2),(530,-955359000,3),(530,-936612000,2),(530,-923304600,3),(530,-757425600,6),(530,152632800,4),(530,162309600,5),(530,183477600,4),(530,194968800,5),(530,215532000,4),(530,226418400,5),(530,246981600,4),(530,257868000,5),(530,278431200,4),(530,289317600,5),(530,309880800,4),(530,320767200,5),(530,341330400,4),(530,352216800,5),(530,372780000,4),(530,384271200,5),(530,404834400,4),(530,415720800,5),(530,436284000,4),(530,447170400,5),(530,467733600,4),(530,478620000,5),(530,499183200,4),(530,510069600,5),(530,530632800,4),(530,541519200,5),(530,562082400,4),(530,573573600,5),(530,594136800,4),(530,605023200,5),(530,623772000,4),(530,637682400,5),(530,655221600,4),(530,669132000,5),(530,686671200,4),(530,700581600,5),(530,718120800,4),(530,732636000,5),(530,749570400,4),(530,764085600,5),(530,781020000,4),(530,795535200,5),(530,812469600,4),(530,826984800,5),(530,844524000,4),(530,858434400,5),(530,875973600,4),(530,889884000,5),(530,907423200,4),(530,921938400,5),(530,938872800,4),(530,953388000,5),(530,970322400,4),(530,984837600,5),(530,1002376800,4),(530,1016287200,5),(530,1033826400,4),(530,1047736800,5),(530,1065276000,4),(530,1079791200,5),(530,1096725600,4),(530,1111240800,5),(530,1128175200,4),(530,1142690400,5),(530,1159624800,4),(530,1174140000,5),(530,1191074400,4),(530,1207404000,5),(530,1222524000,4),(530,1238853600,5),(530,1253973600,4),(530,1270303200,5),(530,1285423200,4),(530,1301752800,5),(530,1316872800,4),(530,1333202400,5),(530,1348927200,4),(530,1365256800,5),(530,1380376800,4),(530,1396706400,5),(530,1411826400,4),(530,1428156000,5),(530,1443276000,4),(530,1459605600,5),(530,1474725600,4),(530,1491055200,5),(530,1506175200,4),(530,1522504800,5),(530,1538229600,4),(530,1554559200,5),(530,1569679200,4),(530,1586008800,5),(530,1601128800,4),(530,1617458400,5),(530,1632578400,4),(530,1648908000,5),(530,1664028000,4),(530,1680357600,5),(530,1695477600,4),(530,1712412000,5),(530,1727532000,4),(530,1743861600,5),(530,1758981600,4),(530,1775311200,5),(530,1790431200,4),(530,1806760800,5),(530,1821880800,4),(530,1838210400,5),(530,1853330400,4),(530,1869660000,5),(530,1885384800,4),(530,1901714400,5),(530,1916834400,4),(530,1933164000,5),(530,1948284000,4),(530,1964613600,5),(530,1979733600,4),(530,1996063200,5),(530,2011183200,4),(530,2027512800,5),(530,2042632800,4),(530,2058962400,5),(530,2074687200,4),(530,2091016800,5),(530,2106136800,4),(530,2122466400,5),(530,2137586400,4),(531,-2147483648,1),(531,-868010400,2),(531,-768906000,1),(531,1419696000,3),(531,2147483647,3),(532,-2147483648,1),(532,-757426500,4),(532,152632800,2),(532,162309600,3),(532,183477600,2),(532,194968800,3),(532,215532000,2),(532,226418400,3),(532,246981600,2),(532,257868000,3),(532,278431200,2),(532,289317600,3),(532,309880800,2),(532,320767200,3),(532,341330400,2),(532,352216800,3),(532,372780000,2),(532,384271200,3),(532,404834400,2),(532,415720800,3),(532,436284000,2),(532,447170400,3),(532,467733600,2),(532,478620000,3),(532,499183200,2),(532,510069600,3),(532,530632800,2),(532,541519200,3),(532,562082400,2),(532,573573600,3),(532,594136800,2),(532,605023200,3),(532,623772000,2),(532,637682400,3),(532,655221600,2),(532,669132000,3),(532,686671200,2),(532,700581600,3),(532,718120800,2),(532,732636000,3),(532,749570400,2),(532,764085600,3),(532,781020000,2),(532,795535200,3),(532,812469600,2),(532,826984800,3),(532,844524000,2),(532,858434400,3),(532,875973600,2),(532,889884000,3),(532,907423200,2),(532,921938400,3),(532,938872800,2),(532,953388000,3),(532,970322400,2),(532,984837600,3),(532,1002376800,2),(532,1016287200,3),(532,1033826400,2),(532,1047736800,3),(532,1065276000,2),(532,1079791200,3),(532,1096725600,2),(532,1111240800,3),(532,1128175200,2),(532,1142690400,3),(532,1159624800,2),(532,1174140000,3),(532,1191074400,2),(532,1207404000,3),(532,1222524000,2),(532,1238853600,3),(532,1253973600,2),(532,1270303200,3),(532,1285423200,2),(532,1301752800,3),(532,1316872800,2),(532,1333202400,3),(532,1348927200,2),(532,1365256800,3),(532,1380376800,2),(532,1396706400,3),(532,1411826400,2),(532,1428156000,3),(532,1443276000,2),(532,1459605600,3),(532,1474725600,2),(532,1491055200,3),(532,1506175200,2),(532,1522504800,3),(532,1538229600,2),(532,1554559200,3),(532,1569679200,2),(532,1586008800,3),(532,1601128800,2),(532,1617458400,3),(532,1632578400,2),(532,1648908000,3),(532,1664028000,2),(532,1680357600,3),(532,1695477600,2),(532,1712412000,3),(532,1727532000,2),(532,1743861600,3),(532,1758981600,2),(532,1775311200,3),(532,1790431200,2),(532,1806760800,3),(532,1821880800,2),(532,1838210400,3),(532,1853330400,2),(532,1869660000,3),(532,1885384800,2),(532,1901714400,3),(532,1916834400,2),(532,1933164000,3),(532,1948284000,2),(532,1964613600,3),(532,1979733600,2),(532,1996063200,3),(532,2011183200,2),(532,2027512800,3),(532,2042632800,2),(532,2058962400,3),(532,2074687200,2),(532,2091016800,3),(532,2106136800,2),(532,2122466400,3),(532,2137586400,2),(532,2147483647,2),(533,-2147483648,1),(533,2147483647,1),(534,-2147483648,1),(534,-1178124152,4),(534,-36619200,2),(534,-23922000,3),(534,-3355200,2),(534,7527600,3),(534,24465600,2),(534,37767600,3),(534,55915200,2),(534,69217200,3),(534,87969600,2),(534,100666800,3),(534,118209600,2),(534,132116400,3),(534,150868800,2),(534,163566000,3),(534,182318400,2),(534,195620400,3),(534,213768000,2),(534,227070000,3),(534,245217600,2),(534,258519600,3),(534,277272000,2),(534,289969200,3),(534,308721600,2),(534,321418800,3),(534,340171200,2),(534,353473200,3),(534,371620800,2),(534,384922800,5),(534,403070400,6),(534,416372400,5),(534,434520000,6),(534,447822000,5),(534,466574400,6),(534,479271600,5),(534,498024000,6),(534,510721200,5),(534,529473600,6),(534,545194800,5),(534,560923200,6),(534,574225200,5),(534,592372800,6),(534,605674800,5),(534,624427200,6),(534,637124400,5),(534,653457600,6),(534,668574000,5),(534,687326400,6),(534,700628400,5),(534,718776000,6),(534,732078000,5),(534,750225600,6),(534,763527600,5),(534,781675200,6),(534,794977200,5),(534,813729600,6),(534,826426800,5),(534,845179200,6),(534,859690800,5),(534,876628800,6),(534,889930800,5),(534,906868800,6),(534,923194800,5),(534,939528000,6),(534,952830000,5),(534,971582400,6),(534,984279600,5),(534,1003032000,6),(534,1015729200,5),(534,1034481600,6),(534,1047178800,5),(534,1065931200,6),(534,1079233200,5),(534,1097380800,6),(534,1110682800,5),(534,1128830400,6),(534,1142132400,5),(534,1160884800,6),(534,1173582000,5),(534,1192334400,6),(534,1206846000,5),(534,1223784000,6),(534,1237086000,5),(534,1255233600,6),(534,1270350000,5),(534,1286683200,6),(534,1304823600,5),(534,1313899200,6),(534,1335668400,5),(534,1346558400,6),(534,1367118000,5),(534,1378612800,6),(534,1398567600,5),(534,1410062400,6),(534,1463281200,5),(534,1471147200,6),(534,1494730800,5),(534,1502596800,6),(534,1526180400,5),(534,1534046400,6),(534,1554606000,5),(534,1567915200,6),(534,1586055600,5),(534,1599364800,6),(534,1617505200,5),(534,1630814400,6),(534,1648954800,5),(534,1662868800,6),(534,1680404400,5),(534,1693713600,6),(534,1712458800,5),(534,1725768000,6),(534,1743908400,5),(534,1757217600,6),(534,1775358000,5),(534,1788667200,6),(534,1806807600,5),(534,1820116800,6),(534,1838257200,5),(534,1851566400,6),(534,1870311600,5),(534,1883016000,6),(534,1901761200,5),(534,1915070400,6),(534,1933210800,5),(534,1946520000,6),(534,1964660400,5),(534,1977969600,6),(534,1996110000,5),(534,2009419200,6),(534,2027559600,5),(534,2040868800,6),(534,2059614000,5),(534,2072318400,6),(534,2091063600,5),(534,2104372800,6),(534,2122513200,5),(534,2135822400,6),(534,2147483647,6),(535,-2147483648,0),(535,-1829387596,4),(535,125409600,1),(535,133876800,2),(535,433256400,3),(535,448977600,4),(535,464706000,3),(535,480427200,4),(535,496760400,3),(535,511876800,4),(535,528210000,3),(535,543931200,4),(535,559659600,3),(535,575380800,4),(535,591109200,3),(535,606830400,4),(535,622558800,3),(535,638280000,4),(535,654008400,3),(535,669729600,4),(535,686062800,3),(535,696340800,4),(535,719931600,3),(535,727790400,4),(535,2147483647,4),(536,-2147483648,0),(536,-1020470400,1),(536,307627200,2),(536,788871600,3),(536,2147483647,3),(537,-2147483648,1),(537,1325242800,2),(537,2147483647,2),(538,-2147483648,0),(538,-1709985344,2),(538,909842400,1),(538,920124000,2),(538,941896800,1),(538,951573600,2),(538,1259416800,1),(538,1269698400,2),(538,1287842400,1),(538,1299333600,2),(538,1319292000,1),(538,1327154400,2),(538,1350741600,1),(538,1358604000,2),(538,1382796000,1),(538,1390050000,2),(538,1414850400,1),(538,1421503200,2),(538,1446300000,1),(538,1452952800,2),(538,1478354400,1),(538,1484402400,2),(538,1509804000,1),(538,1515852000,2),(538,1541253600,1),(538,1547301600,2),(538,1573308000,1),(538,1578751200,2),(538,1608386400,1),(538,1610805600,2),(538,2147483647,2),(539,-2147483648,1),(539,2147483647,1),(540,-2147483648,0),(540,-1230746496,1),(540,504939600,3),(540,722930400,2),(540,728888400,3),(540,2147483647,3),(541,-2147483648,0),(541,-1806678012,1),(541,2147483647,1),(542,-2147483648,0),(542,-1806748788,1),(542,2147483647,1),(543,-2147483648,1),(543,-885549600,2),(543,-802256400,1),(543,-331891200,3),(543,-281610000,1),(543,-73728000,3),(543,-29415540,1),(543,-16704000,3),(543,-10659600,1),(543,9907200,3),(543,21394800,1),(543,41356800,3),(543,52844400,1),(543,124819200,3),(543,130863600,1),(543,201888000,3),(543,209487660,1),(543,230659200,3),(543,241542000,1),(543,977493600,4),(544,-2147483648,1),(544,-1157283000,2),(544,-1155436200,1),(544,-880198200,3),(544,-769395600,4),(544,-765376200,1),(544,-712150200,5),(545,-2147483648,1),(545,-1157283000,2),(545,-1155436200,1),(545,-880198200,3),(545,-769395600,4),(545,-765376200,1),(545,-712150200,5),(546,-2147483648,0),(546,-1020470400,1),(546,307627200,2),(546,788871600,3),(546,2147483647,3),(547,-2147483648,1),(547,307622400,2),(547,788868000,3),(547,2147483647,3),(548,-2147483648,1),(548,-1743678000,2),(548,-1606813200,1),(548,-1041418800,3),(548,-907408800,2),(548,-770634000,1),(548,-7988400,4),(548,915105600,1),(548,2147483647,1),(549,-2147483648,1),(549,-1041418800,2),(549,-907408800,3),(549,-817462800,1),(549,-7988400,4),(549,745934400,5),(549,2147483647,5),(550,-2147483648,1),(550,2147483647,1),(551,-2147483648,0),(551,-1806676920,1),(551,2147483647,1),(552,-2147483648,1),(552,-1861879032,2),(553,-2147483648,0),(553,-1545131260,1),(553,-862918200,2),(553,-767350800,1),(553,287418600,3),(553,2147483647,3),(554,-2147483648,0),(554,-543069620,1),(554,-173623200,2),(554,2147483647,2),(555,-2147483648,1),(555,-599656320,2),(555,152029800,3),(555,162916200,4),(555,1443882600,5),(555,1561899600,7),(555,1570287600,6),(555,1586012400,5),(555,1601737200,6),(555,1617462000,5),(555,1633186800,6),(555,1648911600,5),(555,1664636400,6),(555,1680361200,5),(555,1696086000,6),(555,1712415600,5),(555,1728140400,6),(555,1743865200,5),(555,1759590000,6),(555,1775314800,5),(555,1791039600,6),(555,1806764400,5),(555,1822489200,6),(555,1838214000,5),(555,1853938800,6),(555,1869663600,5),(555,1885993200,6),(555,1901718000,5),(555,1917442800,6),(555,1933167600,5),(555,1948892400,6),(555,1964617200,5),(555,1980342000,6),(555,1996066800,5),(555,2011791600,6),(555,2027516400,5),(555,2043241200,6),(555,2058966000,5),(555,2075295600,6),(555,2091020400,5),(555,2106745200,6),(555,2122470000,5),(555,2138194800,6),(555,2147483647,6),(556,-2147483648,0),(556,-1829387148,2),(556,250002000,1),(556,257342400,2),(556,281451600,1),(556,288878400,2),(556,849366000,3),(556,857228400,4),(556,2147483647,4),(557,-2147483648,1),(557,-1861879032,2),(558,-2147483648,1),(558,2147483647,1),(559,-2147483648,1),(559,893665800,2),(559,2147483647,2),(560,-2147483648,0),(560,-1806748788,1),(560,2147483647,1),(561,-2147483648,0),(561,-1806748788,1),(561,2147483647,1),(562,-2147483648,1),(562,2147483647,1),(563,-2147483648,1),(563,-543072056,2),(563,279714600,4),(563,289387800,3),(563,309952800,4),(563,320837400,3),(563,341402400,4),(563,352287000,3),(563,372852000,4),(563,384341400,3),(563,404906400,4),(563,415791000,3),(563,436356000,4),(563,447240600,3),(563,467805600,4),(563,478690200,3),(563,499255200,4),(563,510139800,3),(563,530704800,4),(563,541589400,3),(563,562154400,4),(563,573643800,3),(563,594208800,4),(563,605093400,3),(563,625658400,4),(563,636543000,3),(563,657108000,4),(563,667992600,3),(563,2147483647,3),(564,-2147483648,1),(564,-885549600,2),(564,-802256400,1),(564,-331891200,3),(564,-281610000,1),(564,-73728000,3),(564,-29415540,1),(564,-16704000,3),(564,-10659600,1),(564,9907200,3),(564,21394800,1),(564,41356800,3),(564,52844400,1),(564,124819200,3),(564,130863600,1),(564,201888000,3),(564,209487660,1),(564,230659200,3),(564,241542000,1),(564,977493600,4),(565,-2147483648,1),(565,-1861879032,2),(566,-2147483648,0),(566,-1806674504,1),(566,2147483647,1),(567,-2147483648,1),(567,2147483647,1),(568,-2147483648,0),(568,-767189952,1),(568,-284041200,2),(568,939214800,3),(568,953384400,4),(568,973342800,5),(568,980596800,2),(568,1004792400,5),(568,1012046400,2),(568,1478350800,5),(568,1484398800,2),(568,2147483647,2),(569,-2147483648,1),(569,2147483647,1),(570,-2147483648,1),(570,2147483647,1),(571,-2147483648,1),(571,2147483647,1),(572,-2147483648,1),(572,2147483647,1),(573,-2147483648,1),(573,-1717032240,3),(573,-1693706400,2),(573,-1680483600,3),(573,-1663455600,4),(573,-1650150000,5),(573,-1632006000,4),(573,-1618700400,8),(573,-1600473600,6),(573,-1587168000,7),(573,-1501725600,3),(573,-931734000,2),(573,-857257200,5),(573,-844556400,4),(573,-828226800,5),(573,-812502000,4),(573,-796874400,2),(573,-796608000,3),(573,-778726800,2),(573,-762660000,3),(573,-748486800,4),(573,-733273200,5),(573,-715215600,4),(573,-701910000,5),(573,-684975600,4),(573,-670460400,5),(573,-654130800,4),(573,-639010800,5),(573,-397094400,4),(573,-386812800,5),(573,-371088000,4),(573,-355363200,5),(573,-334195200,4),(573,-323308800,5),(573,-307584000,4),(573,-291859200,5),(573,-271296000,4),(573,-260409600,5),(573,-239846400,4),(573,-228960000,5),(573,-208396800,4),(573,-197510400,5),(573,-176342400,4),(573,-166060800,5),(573,220921200,3),(573,228873600,4),(573,243993600,5),(573,260323200,4),(573,276048000,5),(573,291772800,4),(573,307497600,5),(573,323827200,4),(573,338947200,5),(573,354672000,4),(573,370396800,5),(573,386121600,4),(573,401846400,5),(573,417571200,4),(573,433296000,5),(573,449020800,4),(573,465350400,5),(573,481075200,4),(573,496800000,5),(573,512524800,4),(573,528249600,5),(573,543974400,4),(573,559699200,5),(573,567990000,3),(573,575427600,9),(573,591152400,10),(573,606877200,9),(573,622602000,10),(573,638326800,9),(573,654656400,10),(573,670381200,9),(573,686106000,10),(573,701830800,9),(573,717555600,10),(573,733280400,9),(573,749005200,10),(573,764730000,9),(573,780454800,10),(573,796179600,9),(573,811904400,10),(573,828234000,9),(573,846378000,10),(573,859683600,9),(573,877827600,10),(573,891133200,9),(573,909277200,10),(573,922582800,9),(573,941331600,10),(573,954032400,9),(573,972781200,10),(573,985482000,9),(573,1004230800,10),(573,1017536400,9),(573,1035680400,10),(573,1048986000,9),(573,1067130000,10),(573,1080435600,9),(573,1099184400,10),(573,1111885200,9),(573,1130634000,10),(573,1143334800,9),(573,1162083600,10),(573,1174784400,9),(573,1193533200,10),(573,1206838800,9),(573,1224982800,10),(573,1238288400,9),(573,1256432400,10),(573,1269738000,9),(573,1288486800,10),(573,1301187600,9),(573,1319936400,10),(573,1332637200,9),(573,1351386000,10),(573,1364691600,9),(573,1382835600,10),(573,1396141200,9),(573,1414285200,10),(573,1427590800,9),(573,1445734800,10),(573,1459040400,9),(573,1477789200,10),(573,1490490000,9),(573,1509238800,10),(573,1521939600,9),(573,1540688400,10),(573,1553994000,9),(573,1572138000,10),(573,1585443600,9),(573,1603587600,10),(573,1616893200,9),(573,1635642000,10),(573,1648342800,9),(573,1667091600,10),(573,1679792400,9),(573,1698541200,10),(573,1711846800,9),(573,1729990800,10),(573,1743296400,9),(573,1761440400,10),(573,1774746000,9),(573,1792890000,10),(573,1806195600,9),(573,1824944400,10),(573,1837645200,9),(573,1856394000,10),(573,1869094800,9),(573,1887843600,10),(573,1901149200,9),(573,1919293200,10),(573,1932598800,9),(573,1950742800,10),(573,1964048400,9),(573,1982797200,10),(573,1995498000,9),(573,2014246800,10),(573,2026947600,9),(573,2045696400,10),(573,2058397200,9),(573,2077146000,10),(573,2090451600,9),(573,2108595600,10),(573,2121901200,9),(573,2140045200,10),(574,-2147483648,0),(574,-1830384000,6),(574,-1689555600,1),(574,-1677801600,2),(574,-1667437200,3),(574,-1647738000,4),(574,-1635814800,3),(574,-1616202000,4),(574,-1604365200,3),(574,-1584666000,4),(574,-1572742800,3),(574,-1553043600,4),(574,-1541206800,3),(574,-1521507600,4),(574,-1442451600,3),(574,-1426813200,4),(574,-1379293200,3),(574,-1364778000,4),(574,-1348448400,3),(574,-1333328400,4),(574,-1316394000,3),(574,-1301274000,4),(574,-1284339600,3),(574,-1269824400,4),(574,-1221440400,3),(574,-1206925200,4),(574,-1191200400,3),(574,-1175475600,4),(574,-1127696400,3),(574,-1111971600,4),(574,-1096851600,3),(574,-1080522000,4),(574,-1063587600,3),(574,-1049072400,4),(574,-1033347600,3),(574,-1017622800,4),(574,-1002502800,3),(574,-986173200,4),(574,-969238800,3),(574,-950490000,4),(574,-942022800,3),(574,-922669200,4),(574,-906944400,3),(574,-891133200,4),(574,-877309200,3),(574,-873684000,5),(574,-864007200,3),(574,-857955600,4),(574,-845859600,3),(574,-842839200,5),(574,-831348000,3),(574,-825901200,4),(574,-814410000,3),(574,-810784800,5),(574,-799898400,3),(574,-794451600,4),(574,-782960400,3),(574,-779335200,5),(574,-768448800,3),(574,-763002000,4),(574,-749091600,3),(574,-733366800,4),(574,-717631200,3),(574,-701906400,4),(574,-686181600,3),(574,-670456800,4),(574,-654732000,3),(574,-639007200,4),(574,-623282400,3),(574,-607557600,4),(574,-591832800,3),(574,-575503200,4),(574,-559778400,3),(574,-544053600,4),(574,-528328800,3),(574,-512604000,4),(574,-496879200,3),(574,-481154400,4),(574,-465429600,3),(574,-449704800,4),(574,-433980000,3),(574,-417650400,4),(574,-401925600,3),(574,-386200800,4),(574,-370476000,3),(574,-354751200,4),(574,-339026400,3),(574,-323301600,4),(574,-307576800,3),(574,-291852000,4),(574,-276127200,3),(574,-260402400,4),(574,-244677600,3),(574,-228348000,4),(574,-212623200,3),(574,-196898400,4),(574,-181173600,3),(574,-165448800,4),(574,-149724000,3),(574,-133999200,4),(574,-118274400,7),(574,212544000,2),(574,228268800,3),(574,243993600,4),(574,260323200,3),(574,276048000,4),(574,291772800,3),(574,307501200,4),(574,323222400,3),(574,338950800,4),(574,354675600,3),(574,370400400,4),(574,386125200,3),(574,401850000,4),(574,417578400,3),(574,433299600,4),(574,449024400,3),(574,465354000,4),(574,481078800,3),(574,496803600,4),(574,512528400,3),(574,528253200,4),(574,543978000,3),(574,559702800,4),(574,575427600,3),(574,591152400,4),(574,606877200,3),(574,622602000,4),(574,638326800,3),(574,654656400,4),(574,670381200,3),(574,686106000,4),(574,701830800,3),(574,717555600,8),(574,733280400,9),(574,749005200,8),(574,764730000,9),(574,780454800,8),(574,796179600,9),(574,811904400,8),(574,828234000,10),(574,846378000,6),(574,859683600,10),(574,877827600,6),(574,891133200,10),(574,909277200,6),(574,922582800,10),(574,941331600,6),(574,954032400,10),(574,972781200,6),(574,985482000,10),(574,1004230800,6),(574,1017536400,10),(574,1035680400,6),(574,1048986000,10),(574,1067130000,6),(574,1080435600,10),(574,1099184400,6),(574,1111885200,10),(574,1130634000,6),(574,1143334800,10),(574,1162083600,6),(574,1174784400,10),(574,1193533200,6),(574,1206838800,10),(574,1224982800,6),(574,1238288400,10),(574,1256432400,6),(574,1269738000,10),(574,1288486800,6),(574,1301187600,10),(574,1319936400,6),(574,1332637200,10),(574,1351386000,6),(574,1364691600,10),(574,1382835600,6),(574,1396141200,10),(574,1414285200,6),(574,1427590800,10),(574,1445734800,6),(574,1459040400,10),(574,1477789200,6),(574,1490490000,10),(574,1509238800,6),(574,1521939600,10),(574,1540688400,6),(574,1553994000,10),(574,1572138000,6),(574,1585443600,10),(574,1603587600,6),(574,1616893200,10),(574,1635642000,6),(574,1648342800,10),(574,1667091600,6),(574,1679792400,10),(574,1698541200,6),(574,1711846800,10),(574,1729990800,6),(574,1743296400,10),(574,1761440400,6),(574,1774746000,10),(574,1792890000,6),(574,1806195600,10),(574,1824944400,6),(574,1837645200,10),(574,1856394000,6),(574,1869094800,10),(574,1887843600,6),(574,1901149200,10),(574,1919293200,6),(574,1932598800,10),(574,1950742800,6),(574,1964048400,10),(574,1982797200,6),(574,1995498000,10),(574,2014246800,6),(574,2026947600,10),(574,2045696400,6),(574,2058397200,10),(574,2077146000,6),(574,2090451600,10),(574,2108595600,6),(574,2121901200,10),(574,2140045200,6),(575,-2147483648,1),(575,-1017820800,2),(575,-766224000,1),(575,-745833600,3),(575,-733827600,1),(575,-716889600,3),(575,-699613200,1),(575,-683884800,3),(575,-670669200,1),(575,-652348800,3),(575,-639133200,1),(575,-620812800,3),(575,-607597200,1),(575,-589276800,3),(575,-576061200,1),(575,-562924800,3),(575,-541760400,1),(575,-528710400,3),(575,-510224400,1),(575,-497174400,3),(575,-478688400,1),(575,-465638400,3),(575,-449830800,1),(575,-434016000,3),(575,-418208400,1),(575,-402480000,3),(575,-386672400,1),(575,-370944000,3),(575,-355136400,1),(575,-339408000,3),(575,-323600400,1),(575,-302515200,3),(575,-291978000,1),(575,-270979200,3),(575,-260442000,1),(575,133977600,3),(575,149785200,1),(575,165513600,3),(575,181321200,1),(575,299606400,3),(575,307551600,1),(576,-2147483648,0),(576,-1948782472,1),(576,-1830414600,2),(576,-767350800,4),(576,-681210000,3),(576,-672228000,4),(576,-654771600,3),(576,-640864800,4),(576,-623408400,3),(576,-609415200,4),(576,-588848400,3),(576,-577965600,4),(576,-498128400,1),(576,-462702600,5),(576,-451733400,1),(576,-429784200,5),(576,-418296600,1),(576,-399544200,5),(576,-387451800,1),(576,-368094600,5),(576,-356002200,1),(576,-336645000,5),(576,-324552600,1),(576,-305195400,5),(576,-293103000,1),(576,-264933000,4),(576,547578000,3),(576,560883600,4),(576,579027600,3),(576,592333200,4),(577,-2147483648,1),(577,-2038200925,2),(577,-1167634800,3),(577,-1073028000,4),(577,-894180000,5),(577,-879665400,6),(577,-767005200,5),(577,378662400,7),(577,2147483647,7),(578,-2147483648,1),(578,-1869875816,3),(578,-1693706400,2),(578,-1680490800,3),(578,-1570413600,2),(578,-1552186800,3),(578,-1538359200,2),(578,-1522551600,3),(578,-1507514400,2),(578,-1490583600,3),(578,-1440208800,2),(578,-1428030000,3),(578,-1409709600,2),(578,-1396494000,3),(578,-931053600,2),(578,-922676400,3),(578,-917834400,2),(578,-892436400,3),(578,-875844000,2),(578,-764737200,3),(578,-744343200,2),(578,-733806000,3),(578,-716436000,2),(578,-701924400,3),(578,-684986400,2),(578,-670474800,3),(578,-654141600,2),(578,-639025200,3),(578,-622087200,2),(578,-606970800,3),(578,-590032800,2),(578,-575521200,3),(578,-235620000,2),(578,-194842800,3),(578,-177732000,2),(578,-165726000,3),(578,107910000,2),(578,121215600,3),(578,133920000,2),(578,152665200,3),(578,164678400,2),(578,184114800,3),(578,196214400,2),(578,215564400,3),(578,228873600,2),(578,245804400,3),(578,260323200,2),(578,267915600,4),(578,428454000,5),(578,433893600,4),(578,468111600,3),(578,482799600,6),(578,496710000,7),(578,512521200,6),(578,528246000,7),(578,543970800,6),(578,559695600,7),(578,575420400,6),(578,591145200,7),(578,606870000,6),(578,622594800,7),(578,638319600,6),(578,654649200,7),(578,670374000,6),(578,686098800,7),(578,701823600,6),(578,717548400,7),(578,733273200,6),(578,748998000,7),(578,764118000,6),(578,780447600,7),(578,796172400,6),(578,811897200,7),(578,828226800,6),(578,846370800,7),(578,859676400,6),(578,877820400,7),(578,891126000,6),(578,909270000,7),(578,922575600,6),(578,941324400,7),(578,954025200,6),(578,972774000,7),(578,985474800,6),(578,1004223600,7),(578,1017529200,6),(578,1035673200,7),(578,1048978800,6),(578,1067122800,7),(578,1080428400,6),(578,1099177200,7),(578,1111878000,6),(578,1130626800,7),(578,1143327600,6),(578,1162076400,7),(578,1167602400,3),(578,1174784400,8),(578,1193533200,9),(578,1206838800,8),(578,1224982800,9),(578,1238288400,8),(578,1256432400,9),(578,1269738000,8),(578,1288486800,9),(578,1301274000,8),(578,1319936400,9),(578,1332637200,8),(578,1351386000,9),(578,1364691600,8),(578,1382835600,9),(578,1396227600,8),(578,1414285200,9),(578,1427590800,8),(578,1446944400,9),(578,1459040400,8),(578,1473195600,4),(578,2147483647,4),(580,-2147483648,1),(580,-880200000,2),(580,-769395600,3),(580,-765378000,1),(580,-86882400,4),(580,-21470400,5),(580,-5749200,4),(580,9979200,5),(580,25700400,4),(580,41428800,5),(580,57754800,4),(580,73483200,5),(580,89204400,4),(580,104932800,5),(580,120654000,4),(580,126705600,5),(580,152103600,4),(580,162388800,5),(580,183553200,4),(580,199281600,5),(580,215607600,4),(580,230731200,5),(580,247057200,4),(580,262785600,5),(580,278506800,4),(580,294235200,5),(580,309956400,4),(580,325684800,5),(580,341406000,4),(580,357134400,5),(580,372855600,4),(580,388584000,5),(580,404910000,4),(580,420033600,5),(580,436359600,6),(580,439030800,8),(580,452084400,7),(580,467805600,8),(580,483534000,7),(580,499255200,8),(580,514983600,7),(580,530704800,8),(580,544618800,7),(580,562154400,8),(580,576068400,7),(580,594208800,8),(580,607518000,7),(580,625658400,8),(580,638967600,7),(580,657108000,8),(580,671022000,7),(580,688557600,8),(580,702471600,7),(580,720007200,8),(580,733921200,7),(580,752061600,8),(580,765370800,7),(580,783511200,8),(580,796820400,7),(580,814960800,8),(580,828874800,7),(580,846410400,8),(580,860324400,7),(580,877860000,8),(580,891774000,7),(580,909309600,8),(580,923223600,7),(580,941364000,8),(580,954673200,7),(580,972813600,8),(580,986122800,7),(580,1004263200,8),(580,1018177200,7),(580,1035712800,8),(580,1049626800,7),(580,1067162400,8),(580,1081076400,7),(580,1099216800,8),(580,1112526000,7),(580,1130666400,8),(580,1143975600,7),(580,1162116000,8),(580,1173610800,7),(580,1194170400,8),(580,1205060400,7),(580,1225620000,8),(580,1236510000,7),(580,1257069600,8),(580,1268564400,7),(580,1289124000,8),(580,1300014000,7),(580,1320573600,8),(580,1331463600,7),(580,1352023200,8),(580,1362913200,7),(580,1383472800,8),(580,1394362800,7),(580,1414922400,8),(580,1425812400,7),(580,1446372000,8),(580,1457866800,7),(580,1478426400,8),(580,1489316400,7),(580,1509876000,8),(580,1520766000,7),(580,1541325600,8),(580,1552215600,7),(580,1572775200,8),(580,1583665200,7),(580,1604224800,8),(580,1615719600,7),(580,1636279200,8),(580,1647169200,7),(580,1667728800,8),(580,1678618800,7),(580,1699178400,8),(580,1710068400,7),(580,1730628000,8),(580,1741518000,7),(580,1762077600,8),(580,1772967600,7),(580,1793527200,8),(580,1805022000,7),(580,1825581600,8),(580,1836471600,7),(580,1857031200,8),(580,1867921200,7),(580,1888480800,8),(580,1899370800,7),(580,1919930400,8),(580,1930820400,7),(580,1951380000,8),(580,1962874800,7),(580,1983434400,8),(580,1994324400,7),(580,2014884000,8),(580,2025774000,7),(580,2046333600,8),(580,2057223600,7),(580,2077783200,8),(580,2088673200,7),(580,2109232800,8),(580,2120122800,7),(580,2140682400,8),(581,-2147483648,1),(581,-880196400,2),(581,-769395600,3),(581,-765374400,1),(581,-86878800,4),(581,-21466800,5),(581,-5745600,4),(581,9982800,5),(581,25704000,4),(581,41432400,5),(581,57758400,4),(581,73486800,5),(581,89208000,4),(581,104936400,5),(581,120657600,4),(581,126709200,5),(581,152107200,4),(581,162392400,5),(581,183556800,4),(581,199285200,5),(581,215611200,4),(581,230734800,5),(581,247060800,4),(581,262789200,5),(581,278510400,4),(581,294238800,5),(581,309960000,4),(581,325688400,5),(581,341409600,4),(581,357138000,5),(581,372859200,4),(581,388587600,5),(581,404913600,4),(581,420037200,5),(581,436363200,6),(581,439034400,8),(581,452088000,7),(581,467809200,8),(581,483537600,7),(581,499258800,8),(581,514987200,7),(581,530708400,8),(581,544622400,7),(581,562158000,8),(581,576072000,7),(581,594212400,8),(581,607521600,7),(581,625662000,8),(581,638971200,7),(581,657111600,8),(581,671025600,7),(581,688561200,8),(581,702475200,7),(581,720010800,8),(581,733924800,7),(581,752065200,8),(581,765374400,7),(581,783514800,8),(581,796824000,7),(581,814964400,8),(581,828878400,7),(581,846414000,8),(581,860328000,7),(581,877863600,8),(581,891777600,7),(581,909313200,8),(581,923227200,7),(581,941367600,8),(581,954676800,7),(581,972817200,8),(581,986126400,7),(581,1004266800,8),(581,1018180800,7),(581,1035716400,8),(581,1049630400,7),(581,1067166000,8),(581,1081080000,7),(581,1099220400,8),(581,1112529600,7),(581,1130670000,8),(581,1143979200,7),(581,1162119600,8),(581,1173614400,7),(581,1194174000,8),(581,1205064000,7),(581,1225623600,8),(581,1236513600,7),(581,1257073200,8),(581,1268568000,7),(581,1289127600,8),(581,1300017600,7),(581,1320577200,8),(581,1331467200,7),(581,1352026800,8),(581,1362916800,7),(581,1383476400,8),(581,1394366400,7),(581,1414926000,8),(581,1425816000,7),(581,1446375600,8),(581,1457870400,7),(581,1478430000,8),(581,1489320000,7),(581,1509879600,8),(581,1520769600,7),(581,1541329200,8),(581,1552219200,7),(581,1572778800,8),(581,1583668800,7),(581,1604228400,8),(581,1615723200,7),(581,1636282800,8),(581,1647172800,7),(581,1667732400,8),(581,1678622400,7),(581,1699182000,8),(581,1710072000,7),(581,1730631600,8),(581,1741521600,7),(581,1762081200,8),(581,1772971200,7),(581,1793530800,8),(581,1805025600,7),(581,1825585200,8),(581,1836475200,7),(581,1857034800,8),(581,1867924800,7),(581,1888484400,8),(581,1899374400,7),(581,1919934000,8),(581,1930824000,7),(581,1951383600,8),(581,1962878400,7),(581,1983438000,8),(581,1994328000,7),(581,2014887600,8),(581,2025777600,7),(581,2046337200,8),(581,2057227200,7),(581,2077786800,8),(581,2088676800,7),(581,2109236400,8),(581,2120126400,7),(581,2140686000,8),(582,-2147483648,4),(582,-1633273200,1),(582,-1615132800,2),(582,-1601823600,1),(582,-1583683200,2),(582,-880210800,3),(582,-820519140,2),(582,-812653140,3),(582,-796845540,2),(582,-84380400,1),(582,-68659200,2),(583,-2147483648,3),(583,-1633276800,1),(583,-1615136400,2),(583,-1601827200,1),(583,-1583686800,2),(583,-1563724800,1),(583,-1551632400,2),(583,-1538928000,1),(583,-1520182800,2),(583,-1504454400,1),(583,-1491757200,2),(583,-1473004800,1),(583,-1459702800,2),(583,-1441555200,1),(583,-1428253200,2),(583,-1410105600,1),(583,-1396803600,2),(583,-1378656000,1),(583,-1365354000,2),(583,-1347206400,1),(583,-1333904400,2),(583,-1315152000,1),(583,-1301850000,2),(583,-1283702400,1),(583,-1270400400,2),(583,-1252252800,1),(583,-1238950800,2),(583,-1220803200,1),(583,-1207501200,2),(583,-1189353600,1),(583,-1176051600,2),(583,-1157299200,1),(583,-1144602000,2),(583,-1125849600,1),(583,-1112547600,2),(583,-1094400000,1),(583,-1081098000,2),(583,-1067788800,4),(583,-1045414800,2),(583,-1031500800,1),(583,-1018198800,2),(583,-1000051200,1),(583,-986749200,2),(583,-967996800,1),(583,-955299600,2),(583,-936547200,1),(583,-923245200,2),(583,-905097600,1),(583,-891795600,2),(583,-880214400,5),(583,-769395600,6),(583,-765392400,2),(583,-747244800,1),(583,-733942800,2),(583,-715795200,1),(583,-702493200,2),(583,-684345600,1),(583,-671043600,2),(583,-652896000,1),(583,-639594000,2),(583,-620841600,1),(583,-608144400,2),(583,-589392000,1),(583,-576090000,2),(583,-557942400,1),(583,-544640400,2),(583,-526492800,1),(583,-513190800,2),(583,-495043200,1),(583,-481741200,2),(583,-463593600,1),(583,-447267600,2),(583,-431539200,1),(583,-415818000,2),(583,-400089600,1),(583,-384368400,2),(583,-368640000,1),(583,-352918800,2),(583,-337190400,1),(583,-321469200,2),(583,-305740800,1),(583,-289414800,2),(583,-273686400,1),(583,-257965200,2),(583,-242236800,1),(583,-226515600,2),(583,-210787200,1),(583,-195066000,2),(583,-179337600,1),(583,-163616400,2),(583,-147888000,1),(583,-131562000,2),(583,-116438400,1),(583,-100112400,2),(583,-84384000,1),(583,-68662800,2),(583,-52934400,1),(583,-37213200,2),(583,-21484800,1),(583,-5763600,2),(583,9964800,1),(583,25686000,2),(583,41414400,1),(583,57740400,2),(583,73468800,1),(583,89190000,2),(583,104918400,1),(583,120639600,2),(583,126691200,1),(583,152089200,2),(583,162374400,1),(583,183538800,2),(583,199267200,1),(583,215593200,2),(583,230716800,1),(583,247042800,2),(583,262771200,1),(583,278492400,2),(583,294220800,1),(583,309942000,2),(583,325670400,1),(583,341391600,2),(583,357120000,1),(583,372841200,2),(583,388569600,1),(583,404895600,2),(583,420019200,1),(583,436345200,2),(583,452073600,1),(583,467794800,2),(583,483523200,1),(583,499244400,2),(583,514972800,1),(583,530694000,2),(583,544608000,1),(583,562143600,2),(583,576057600,1),(583,594198000,2),(583,607507200,1),(583,625647600,2),(583,638956800,1),(583,657097200,2),(583,671011200,1),(583,688546800,2),(583,702460800,1),(583,719996400,2),(583,733910400,1),(583,752050800,2),(583,765360000,1),(583,783500400,2),(583,796809600,1),(583,814950000,2),(583,828864000,1),(583,846399600,2),(583,860313600,1),(583,877849200,2),(583,891763200,1),(583,909298800,2),(583,923212800,1),(583,941353200,2),(583,954662400,1),(583,972802800,2),(583,986112000,1),(583,1004252400,2),(583,1018166400,1),(583,1035702000,2),(583,1049616000,1),(583,1067151600,2),(583,1081065600,1),(583,1099206000,2),(583,1112515200,1),(583,1130655600,2),(583,1143964800,1),(583,1162105200,2),(583,1173600000,1),(583,1194159600,2),(583,1205049600,1),(583,1225609200,2),(583,1236499200,1),(583,1257058800,2),(583,1268553600,1),(583,1289113200,2),(583,1300003200,1),(583,1320562800,2),(583,1331452800,1),(583,1352012400,2),(583,1362902400,1),(583,1383462000,2),(583,1394352000,1),(583,1414911600,2),(583,1425801600,1),(583,1446361200,2),(583,1457856000,1),(583,1478415600,2),(583,1489305600,1),(583,1509865200,2),(583,1520755200,1),(583,1541314800,2),(583,1552204800,1),(583,1572764400,2),(583,1583654400,1),(583,1604214000,2),(583,1615708800,1),(583,1636268400,2),(583,1647158400,1),(583,1667718000,2),(583,1678608000,1),(583,1699167600,2),(583,1710057600,1),(583,1730617200,2),(583,1741507200,1),(583,1762066800,2),(583,1772956800,1),(583,1793516400,2),(583,1805011200,1),(583,1825570800,2),(583,1836460800,1),(583,1857020400,2),(583,1867910400,1),(583,1888470000,2),(583,1899360000,1),(583,1919919600,2),(583,1930809600,1),(583,1951369200,2),(583,1962864000,1),(583,1983423600,2),(583,1994313600,1),(583,2014873200,2),(583,2025763200,1),(583,2046322800,2),(583,2057212800,1),(583,2077772400,2),(583,2088662400,1),(583,2109222000,2),(583,2120112000,1),(583,2140671600,2),(584,-2147483648,3),(584,-1633276800,1),(584,-1615136400,2),(584,-1601827200,1),(584,-1583686800,2),(584,-900259200,1),(584,-891795600,2),(584,-880214400,4),(584,-769395600,5),(584,-765392400,2),(584,-747244800,1),(584,-733942800,2),(584,-715795200,1),(584,-702493200,2),(584,-684345600,1),(584,-671043600,2),(584,-652896000,1),(584,-639594000,2),(584,-620841600,1),(584,-608144400,2),(584,-589392000,1),(584,-576090000,2),(584,-557942400,1),(584,-544640400,2),(584,-526492800,1),(584,-513190800,2),(584,-495043200,1),(584,-481741200,2),(584,-463593600,6),(584,-386787600,2),(584,-368640000,6),(584,-21488400,7),(584,-5767200,6),(584,9961200,7),(584,25682400,6),(584,1143961200,7),(584,1162101600,6),(584,1173596400,7),(584,1194156000,6),(584,1205046000,7),(584,1225605600,6),(584,1236495600,7),(584,1257055200,6),(584,1268550000,7),(584,1289109600,6),(584,1299999600,7),(584,1320559200,6),(584,1331449200,7),(584,1352008800,6),(584,1362898800,7),(584,1383458400,6),(584,1394348400,7),(584,1414908000,6),(584,1425798000,7),(584,1446357600,6),(584,1457852400,7),(584,1478412000,6),(584,1489302000,7),(584,1509861600,6),(584,1520751600,7),(584,1541311200,6),(584,1552201200,7),(584,1572760800,6),(584,1583650800,7),(584,1604210400,6),(584,1615705200,7),(584,1636264800,6),(584,1647154800,7),(584,1667714400,6),(584,1678604400,7),(584,1699164000,6),(584,1710054000,7),(584,1730613600,6),(584,1741503600,7),(584,1762063200,6),(584,1772953200,7),(584,1793512800,6),(584,1805007600,7),(584,1825567200,6),(584,1836457200,7),(584,1857016800,6),(584,1867906800,7),(584,1888466400,6),(584,1899356400,7),(584,1919916000,6),(584,1930806000,7),(584,1951365600,6),(584,1962860400,7),(584,1983420000,6),(584,1994310000,7),(584,2014869600,6),(584,2025759600,7),(584,2046319200,6),(584,2057209200,7),(584,2077768800,6),(584,2088658800,7),(584,2109218400,6),(584,2120108400,7),(584,2140668000,6),(585,-2147483648,3),(585,-1633280400,1),(585,-1615140000,2),(585,-1601830800,1),(585,-1583690400,2),(585,-1570381200,1),(585,-1551636000,2),(585,-1536512400,1),(585,-1523210400,2),(585,-1504458000,1),(585,-1491760800,2),(585,-1473008400,1),(585,-1459706400,2),(585,-1441558800,1),(585,-1428256800,2),(585,-1410109200,1),(585,-1396807200,2),(585,-1378659600,1),(585,-1365357600,2),(585,-1347210000,1),(585,-1333908000,2),(585,-1315155600,1),(585,-1301853600,2),(585,-1283706000,1),(585,-1270404000,2),(585,-1252256400,1),(585,-1238954400,2),(585,-1220806800,1),(585,-1207504800,2),(585,-1189357200,1),(585,-1176055200,2),(585,-1157302800,1),(585,-1144605600,2),(585,-1125853200,1),(585,-1112551200,2),(585,-1094403600,1),(585,-1081101600,2),(585,-1062954000,1),(585,-1049652000,2),(585,-1031504400,1),(585,-1018202400,2),(585,-1000054800,1),(585,-986752800,2),(585,-968000400,1),(585,-955303200,2),(585,-936550800,1),(585,-923248800,2),(585,-905101200,1),(585,-891799200,2),(585,-880218000,4),(585,-769395600,5),(585,-765396000,2),(585,-747248400,1),(585,-733946400,2),(585,-715798800,1),(585,-702496800,2),(585,-684349200,1),(585,-671047200,2),(585,-652899600,1),(585,-639597600,2),(585,-620845200,1),(585,-608148000,2),(585,-589395600,1),(585,-576093600,2),(585,-557946000,1),(585,-544644000,2),(585,-526496400,1),(585,-513194400,2),(585,-495046800,1),(585,-481744800,2),(585,-463597200,1),(585,-447271200,2),(585,-431542800,1),(585,-415821600,2),(585,-400093200,1),(585,-384372000,2),(585,-368643600,1),(585,-352922400,2),(585,-337194000,1),(585,-321472800,2),(585,-305744400,1),(585,-289418400,2),(585,-273690000,1),(585,-257968800,2),(585,-242240400,1),(585,-226519200,2),(585,-210790800,1),(585,-195069600,2),(585,-179341200,1),(585,-163620000,2),(585,-147891600,1),(585,-131565600,2),(585,-116442000,1),(585,-100116000,2),(585,-84387600,1),(585,-68666400,2),(585,-52938000,1),(585,-37216800,2),(585,-21488400,1),(585,-5767200,2),(585,9961200,1),(585,25682400,2),(585,41410800,1),(585,57736800,2),(585,73465200,1),(585,89186400,2),(585,104914800,1),(585,120636000,2),(585,126687600,1),(585,152085600,2),(585,162370800,1),(585,183535200,2),(585,199263600,1),(585,215589600,2),(585,230713200,1),(585,247039200,2),(585,262767600,1),(585,278488800,2),(585,294217200,1),(585,309938400,2),(585,325666800,1),(585,341388000,2),(585,357116400,1),(585,372837600,2),(585,388566000,1),(585,404892000,2),(585,420015600,1),(585,436341600,2),(585,452070000,1),(585,467791200,2),(585,483519600,1),(585,499240800,2),(585,514969200,1),(585,530690400,2),(585,544604400,1),(585,562140000,2),(585,576054000,1),(585,594194400,2),(585,607503600,1),(585,625644000,2),(585,638953200,1),(585,657093600,2),(585,671007600,1),(585,688543200,2),(585,702457200,1),(585,719992800,2),(585,733906800,1),(585,752047200,2),(585,765356400,1),(585,783496800,2),(585,796806000,1),(585,814946400,2),(585,828860400,1),(585,846396000,2),(585,860310000,1),(585,877845600,2),(585,891759600,1),(585,909295200,2),(585,923209200,1),(585,941349600,2),(585,954658800,1),(585,972799200,2),(585,986108400,1),(585,1004248800,2),(585,1018162800,1),(585,1035698400,2),(585,1049612400,1),(585,1067148000,2),(585,1081062000,1),(585,1099202400,2),(585,1112511600,1),(585,1130652000,2),(585,1143961200,1),(585,1162101600,2),(585,1173596400,1),(585,1194156000,2),(585,1205046000,1),(585,1225605600,2),(585,1236495600,1),(585,1257055200,2),(585,1268550000,1),(585,1289109600,2),(585,1299999600,1),(585,1320559200,2),(585,1331449200,1),(585,1352008800,2),(585,1362898800,1),(585,1383458400,2),(585,1394348400,1),(585,1414908000,2),(585,1425798000,1),(585,1446357600,2),(585,1457852400,1),(585,1478412000,2),(585,1489302000,1),(585,1509861600,2),(585,1520751600,1),(585,1541311200,2),(585,1552201200,1),(585,1572760800,2),(585,1583650800,1),(585,1604210400,2),(585,1615705200,1),(585,1636264800,2),(585,1647154800,1),(585,1667714400,2),(585,1678604400,1),(585,1699164000,2),(585,1710054000,1),(585,1730613600,2),(585,1741503600,1),(585,1762063200,2),(585,1772953200,1),(585,1793512800,2),(585,1805007600,1),(585,1825567200,2),(585,1836457200,1),(585,1857016800,2),(585,1867906800,1),(585,1888466400,2),(585,1899356400,1),(585,1919916000,2),(585,1930806000,1),(585,1951365600,2),(585,1962860400,1),(585,1983420000,2),(585,1994310000,1),(585,2014869600,2),(585,2025759600,1),(585,2046319200,2),(585,2057209200,1),(585,2077768800,2),(585,2088658800,1),(585,2109218400,2),(585,2120108400,1),(585,2140668000,2),(586,-2147483648,1),(586,-1157283000,2),(586,-1155436200,1),(586,-880198200,3),(586,-769395600,4),(586,-765376200,1),(586,-712150200,5),(587,-2147483648,5),(587,-1633276800,1),(587,-1615136400,2),(587,-1601827200,1),(587,-1583686800,2),(587,-880214400,3),(587,-769395600,4),(587,-765392400,2),(587,-715795200,1),(587,-702493200,2),(587,-684345600,1),(587,-671043600,2),(587,-652896000,1),(587,-639594000,2),(587,-620841600,1),(587,-608144400,2),(587,-589392000,1),(587,-576090000,2),(587,-557942400,1),(587,-544640400,2),(587,-526492800,1),(587,-513190800,2),(587,-495043200,1),(587,-481741200,2),(587,-463593600,1),(587,-447267600,2),(587,-431539200,1),(587,-415818000,2),(587,-400089600,1),(587,-386787600,2),(587,-368640000,1),(587,-355338000,2),(587,-337190400,1),(587,-321469200,2),(587,-305740800,1),(587,-289414800,2),(587,-273686400,1),(587,-257965200,2),(587,-242236800,6),(587,-195066000,2),(587,-84384000,1),(587,-68662800,2),(587,-52934400,1),(587,-37213200,2),(587,-21484800,1),(587,-5763600,2),(587,9964800,1),(587,25686000,2),(587,41414400,1),(587,57740400,2),(587,73468800,1),(587,89190000,2),(587,104918400,1),(587,120639600,2),(587,126691200,1),(587,152089200,2),(587,162374400,1),(587,183538800,2),(587,199267200,1),(587,215593200,2),(587,230716800,1),(587,247042800,2),(587,262771200,1),(587,278492400,2),(587,294220800,1),(587,309942000,2),(587,325670400,1),(587,341391600,2),(587,357120000,1),(587,372841200,2),(587,388569600,1),(587,404895600,2),(587,420019200,1),(587,436345200,2),(587,452073600,1),(587,467794800,2),(587,483523200,1),(587,499244400,2),(587,514972800,1),(587,530694000,2),(587,544608000,1),(587,562143600,2),(587,576057600,1),(587,594198000,2),(587,607507200,1),(587,625647600,2),(587,638956800,1),(587,657097200,2),(587,671011200,1),(587,688546800,6),(587,1143961200,1),(587,1162105200,2),(587,1173600000,1),(587,1194159600,2),(587,1205049600,1),(587,1225609200,2),(587,1236499200,1),(587,1257058800,2),(587,1268553600,1),(587,1289113200,2),(587,1300003200,1),(587,1320562800,2),(587,1331452800,1),(587,1352012400,2),(587,1362902400,1),(587,1383462000,2),(587,1394352000,1),(587,1414911600,2),(587,1425801600,1),(587,1446361200,2),(587,1457856000,1),(587,1478415600,2),(587,1489305600,1),(587,1509865200,2),(587,1520755200,1),(587,1541314800,2),(587,1552204800,1),(587,1572764400,2),(587,1583654400,1),(587,1604214000,2),(587,1615708800,1),(587,1636268400,2),(587,1647158400,1),(587,1667718000,2),(587,1678608000,1),(587,1699167600,2),(587,1710057600,1),(587,1730617200,2),(587,1741507200,1),(587,1762066800,2),(587,1772956800,1),(587,1793516400,2),(587,1805011200,1),(587,1825570800,2),(587,1836460800,1),(587,1857020400,2),(587,1867910400,1),(587,1888470000,2),(587,1899360000,1),(587,1919919600,2),(587,1930809600,1),(587,1951369200,2),(587,1962864000,1),(587,1983423600,2),(587,1994313600,1),(587,2014873200,2),(587,2025763200,1),(587,2046322800,2),(587,2057212800,1),(587,2077772400,2),(587,2088662400,1),(587,2109222000,2),(587,2120112000,1),(587,2140671600,2),(588,-2147483648,0),(588,-2051202469,1),(588,-1724083200,2),(588,-880218000,3),(588,-769395600,4),(588,-765396000,2),(588,-684349200,5),(588,-671047200,2),(588,-80506740,5),(588,-68666400,2),(588,-52938000,5),(588,-37216800,2),(588,104914800,5),(588,120636000,2),(588,126687600,5),(588,152085600,2),(588,167814000,5),(588,183535200,2),(588,199263600,5),(588,215589600,2),(588,230713200,5),(588,247039200,2),(588,262767600,5),(588,278488800,2),(588,294217200,5),(588,309938400,2),(588,325666800,5),(588,341388000,2),(588,357116400,5),(588,372837600,2),(588,388566000,5),(588,404892000,2),(588,420015600,5),(588,436341600,2),(588,452070000,5),(588,467791200,2),(588,483519600,5),(588,499240800,2),(588,514969200,5),(588,530690400,2),(588,544604400,5),(588,562140000,2),(588,576054000,5),(588,594194400,2),(588,607503600,5),(588,625644000,2),(588,638953200,5),(588,657093600,2),(588,671007600,5),(588,688543200,2),(588,702457200,5),(588,719992800,2),(588,733906800,5),(588,752047200,2),(588,765356400,5),(588,783496800,2),(588,796806000,5),(588,814946400,2),(588,828860400,5),(588,846396000,2),(588,860310000,5),(588,877845600,2),(588,891759600,5),(588,909295200,2),(588,923209200,5),(588,941349600,2),(588,954658800,5),(588,972799200,2),(588,986108400,5),(588,1004248800,2),(588,1018162800,5),(588,1035698400,2),(588,1049612400,5),(588,1067148000,2),(588,1081062000,5),(588,1099202400,2),(588,1112511600,5),(588,1130652000,2),(588,1143961200,5),(588,1162101600,2),(588,1173596400,5),(588,1194156000,2),(588,1205046000,5),(588,1225605600,2),(588,1236495600,5),(588,1257055200,2),(588,1268550000,5),(588,1289109600,2),(588,1299999600,5),(588,1320559200,2),(588,1331449200,5),(588,1352008800,2),(588,1362898800,5),(588,1383458400,2),(588,1394348400,5),(588,1414908000,2),(588,1425798000,5),(588,1446357600,2),(588,1457852400,5),(588,1478412000,2),(588,1489302000,5),(588,1509861600,2),(588,1520751600,5),(588,1541311200,2),(588,1552201200,5),(588,1572760800,2),(588,1583650800,5),(588,1604210400,2),(588,1615705200,5),(588,1636264800,2),(588,1647154800,5),(588,1667714400,2),(588,1678604400,5),(588,1699164000,2),(588,1710054000,5),(588,1730613600,2),(588,1741503600,5),(588,1762063200,2),(588,1772953200,5),(588,1793512800,2),(588,1805007600,5),(588,1825567200,2),(588,1836457200,5),(588,1857016800,2),(588,1867906800,5),(588,1888466400,2),(588,1899356400,5),(588,1919916000,2),(588,1930806000,5),(588,1951365600,2),(588,1962860400,5),(588,1983420000,2),(588,1994310000,5),(588,2014869600,2),(588,2025759600,5),(588,2046319200,2),(588,2057209200,5),(588,2077768800,2),(588,2088658800,5),(588,2109218400,2),(588,2120108400,5),(588,2140668000,2),(589,-2147483648,3),(589,-1633273200,1),(589,-1615132800,2),(589,-1601823600,1),(589,-1583683200,2),(589,-1570374000,1),(589,-1551628800,2),(589,-1538924400,1),(589,-1534089600,2),(589,-880210800,4),(589,-769395600,5),(589,-765388800,2),(589,-147884400,1),(589,-131558400,2),(589,-116434800,1),(589,-100108800,2),(589,-84380400,1),(589,-68659200,2),(589,-52930800,1),(589,-37209600,2),(589,-21481200,1),(589,-5760000,2),(589,9968400,1),(589,25689600,2),(589,41418000,1),(589,57744000,2),(589,73472400,1),(589,89193600,2),(589,104922000,1),(589,120643200,2),(589,126694800,1),(589,152092800,2),(589,162378000,1),(589,183542400,2),(589,199270800,1),(589,215596800,2),(589,230720400,1),(589,247046400,2),(589,262774800,1),(589,278496000,2),(589,294224400,1),(589,309945600,2),(589,325674000,1),(589,341395200,2),(589,357123600,1),(589,372844800,2),(589,388573200,1),(589,404899200,2),(589,420022800,1),(589,436348800,2),(589,452077200,1),(589,467798400,2),(589,483526800,1),(589,499248000,2),(589,514976400,1),(589,530697600,2),(589,544611600,1),(589,562147200,2),(589,576061200,1),(589,594201600,2),(589,607510800,1),(589,625651200,2),(589,638960400,1),(589,657100800,2),(589,671014800,1),(589,688550400,2),(589,702464400,1),(589,720000000,2),(589,733914000,1),(589,752054400,2),(589,765363600,1),(589,783504000,2),(589,796813200,1),(589,814953600,2),(589,828867600,1),(589,846403200,2),(589,860317200,1),(589,877852800,2),(589,891766800,1),(589,909302400,2),(589,923216400,1),(589,941356800,2),(589,954666000,1),(589,972806400,2),(589,986115600,1),(589,1004256000,2),(589,1018170000,1),(589,1035705600,2),(589,1049619600,1),(589,1067155200,2),(589,1081069200,1),(589,1099209600,2),(589,1112518800,1),(589,1130659200,2),(589,1143968400,1),(589,1162108800,2),(589,1173603600,1),(589,1194163200,2),(589,1205053200,1),(589,1225612800,2),(589,1236502800,1),(589,1257062400,2),(589,1268557200,1),(589,1289116800,2),(589,1300006800,1),(589,1320566400,2),(589,1331456400,1),(589,1352016000,2),(589,1362906000,1),(589,1383465600,2),(589,1394355600,1),(589,1414915200,2),(589,1425805200,1),(589,1446364800,2),(589,1457859600,1),(589,1478419200,2),(589,1489309200,1),(589,1509868800,2),(589,1520758800,1),(589,1541318400,2),(589,1552208400,1),(589,1572768000,2),(589,1583658000,1),(589,1604217600,2),(589,1615712400,1),(589,1636272000,2),(589,1647162000,1),(589,1667721600,2),(589,1678611600,1),(589,1699171200,2),(589,1710061200,1),(589,1730620800,2),(589,1741510800,1),(589,1762070400,2),(589,1772960400,1),(589,1793520000,2),(589,1805014800,1),(589,1825574400,2),(589,1836464400,1),(589,1857024000,2),(589,1867914000,1),(589,1888473600,2),(589,1899363600,1),(589,1919923200,2),(589,1930813200,1),(589,1951372800,2),(589,1962867600,1),(589,1983427200,2),(589,1994317200,1),(589,2014876800,2),(589,2025766800,1),(589,2046326400,2),(589,2057216400,1),(589,2077776000,2),(589,2088666000,1),(589,2109225600,2),(589,2120115600,1),(589,2140675200,2),(590,-2147483648,5),(590,-1633269600,1),(590,-1615129200,2),(590,-1601820000,1),(590,-1583679600,2),(590,-880207200,3),(590,-769395600,4),(590,-765385200,2),(590,-687967140,1),(590,-662655600,2),(590,-620838000,1),(590,-608137200,2),(590,-589388400,1),(590,-576082800,2),(590,-557938800,1),(590,-544633200,2),(590,-526489200,1),(590,-513183600,2),(590,-495039600,1),(590,-481734000,2),(590,-463590000,1),(590,-450284400,2),(590,-431535600,1),(590,-418230000,2),(590,-400086000,1),(590,-386780400,2),(590,-368636400,1),(590,-355330800,2),(590,-337186800,1),(590,-323881200,2),(590,-305737200,1),(590,-292431600,2),(590,-273682800,1),(590,-260982000,2),(590,-242233200,1),(590,-226508400,2),(590,-210783600,1),(590,-195058800,2),(590,-179334000,1),(590,-163609200,2),(590,-147884400,1),(590,-131554800,2),(590,-116434800,1),(590,-100105200,2),(590,-84376800,1),(590,-68655600,2),(590,-52927200,1),(590,-37206000,2),(590,-21477600,1),(590,-5756400,2),(590,9972000,1),(590,25693200,2),(590,41421600,1),(590,57747600,2),(590,73476000,1),(590,89197200,2),(590,104925600,1),(590,120646800,2),(590,126698400,1),(590,152096400,2),(590,162381600,1),(590,183546000,2),(590,199274400,1),(590,215600400,2),(590,230724000,1),(590,247050000,2),(590,262778400,1),(590,278499600,2),(590,294228000,1),(590,309949200,2),(590,325677600,1),(590,341398800,2),(590,357127200,1),(590,372848400,2),(590,388576800,1),(590,404902800,2),(590,420026400,1),(590,436352400,2),(590,452080800,1),(590,467802000,2),(590,483530400,1),(590,499251600,2),(590,514980000,1),(590,530701200,2),(590,544615200,1),(590,562150800,2),(590,576064800,1),(590,594205200,2),(590,607514400,1),(590,625654800,2),(590,638964000,1),(590,657104400,2),(590,671018400,1),(590,688554000,2),(590,702468000,1),(590,720003600,2),(590,733917600,1),(590,752058000,2),(590,765367200,1),(590,783507600,2),(590,796816800,1),(590,814957200,2),(590,828871200,1),(590,846406800,2),(590,860320800,1),(590,877856400,2),(590,891770400,1),(590,909306000,2),(590,923220000,1),(590,941360400,2),(590,954669600,1),(590,972810000,2),(590,986119200,1),(590,1004259600,2),(590,1018173600,1),(590,1035709200,2),(590,1049623200,1),(590,1067158800,2),(590,1081072800,1),(590,1099213200,2),(590,1112522400,1),(590,1130662800,2),(590,1143972000,1),(590,1162112400,2),(590,1173607200,1),(590,1194166800,2),(590,1205056800,1),(590,1225616400,2),(590,1236506400,1),(590,1257066000,2),(590,1268560800,1),(590,1289120400,2),(590,1300010400,1),(590,1320570000,2),(590,1331460000,1),(590,1352019600,2),(590,1362909600,1),(590,1383469200,2),(590,1394359200,1),(590,1414918800,2),(590,1425808800,1),(590,1446368400,2),(590,1457863200,1),(590,1478422800,2),(590,1489312800,1),(590,1509872400,2),(590,1520762400,1),(590,1541322000,2),(590,1552212000,1),(590,1572771600,2),(590,1583661600,1),(590,1604221200,2),(590,1615716000,1),(590,1636275600,2),(590,1647165600,1),(590,1667725200,2),(590,1678615200,1),(590,1699174800,2),(590,1710064800,1),(590,1730624400,2),(590,1741514400,1),(590,1762074000,2),(590,1772964000,1),(590,1793523600,2),(590,1805018400,1),(590,1825578000,2),(590,1836468000,1),(590,1857027600,2),(590,1867917600,1),(590,1888477200,2),(590,1899367200,1),(590,1919926800,2),(590,1930816800,1),(590,1951376400,2),(590,1962871200,1),(590,1983430800,2),(590,1994320800,1),(590,2014880400,2),(590,2025770400,1),(590,2046330000,2),(590,2057220000,1),(590,2077779600,2),(590,2088669600,1),(590,2109229200,2),(590,2120119200,1),(590,2140678800,2),(591,-2147483648,1),(591,-1861879032,2),(594,-2147483648,1),(594,-1688265017,3),(594,-1656819079,2),(594,-1641353479,3),(594,-1627965079,4),(594,-1618716679,2),(594,-1596429079,4),(594,-1593820800,5),(594,-1589860800,6),(594,-1542427200,7),(594,-1539493200,8),(594,-1525323600,7),(594,-1522728000,6),(594,-1491188400,9),(594,-1247536800,6),(594,354920400,7),(594,370728000,6),(594,386456400,7),(594,402264000,6),(594,417992400,7),(594,433800000,6),(594,449614800,7),(594,465346800,10),(594,481071600,11),(594,496796400,10),(594,512521200,11),(594,528246000,10),(594,543970800,11),(594,559695600,10),(594,575420400,11),(594,591145200,10),(594,606870000,11),(594,622594800,10),(594,638319600,11),(594,654649200,10),(594,670374000,12),(594,686102400,13),(594,695779200,10),(594,701823600,11),(594,717548400,10),(594,733273200,11),(594,748998000,10),(594,764722800,11),(594,780447600,10),(594,796172400,11),(594,811897200,10),(594,828226800,11),(594,846370800,10),(594,859676400,11),(594,877820400,10),(594,891126000,11),(594,909270000,10),(594,922575600,11),(594,941324400,10),(594,954025200,11),(594,972774000,10),(594,985474800,11),(594,1004223600,10),(594,1017529200,11),(594,1035673200,10),(594,1048978800,11),(594,1067122800,10),(594,1080428400,11),(594,1099177200,10),(594,1111878000,11),(594,1130626800,10),(594,1143327600,11),(594,1162076400,10),(594,1174777200,11),(594,1193526000,10),(594,1206831600,11),(594,1224975600,10),(594,1238281200,11),(594,1256425200,10),(594,1269730800,11),(594,1288479600,10),(594,1301180400,14),(594,1414274400,10),(595,228877200,0),(595,243997200,1),(595,260326800,0),(595,276051600,1),(595,291776400,0),(595,307501200,1),(595,323830800,0),(595,338950800,1),(595,354675600,0),(595,370400400,1),(595,386125200,0),(595,401850000,1),(595,417574800,0),(595,433299600,1),(595,449024400,0),(595,465354000,1),(595,481078800,0),(595,496803600,1),(595,512528400,0),(595,528253200,1),(595,543978000,0),(595,559702800,1),(595,575427600,0),(595,591152400,1),(595,606877200,0),(595,622602000,1),(595,638326800,0),(595,654656400,1),(595,670381200,0),(595,686106000,1),(595,701830800,0),(595,717555600,1),(595,733280400,0),(595,749005200,1),(595,764730000,0),(595,780454800,1),(595,796179600,0),(595,811904400,1),(595,828234000,0),(595,846378000,1),(595,859683600,0),(595,877827600,1),(595,891133200,0),(595,909277200,1),(595,922582800,0),(595,941331600,1),(595,954032400,0),(595,972781200,1),(595,985482000,0),(595,1004230800,1),(595,1017536400,0),(595,1035680400,1),(595,1048986000,0),(595,1067130000,1),(595,1080435600,0),(595,1099184400,1),(595,1111885200,0),(595,1130634000,1),(595,1143334800,0),(595,1162083600,1),(595,1174784400,0),(595,1193533200,1),(595,1206838800,0),(595,1224982800,1),(595,1238288400,0),(595,1256432400,1),(595,1269738000,0),(595,1288486800,1),(595,1301187600,0),(595,1319936400,1),(595,1332637200,0),(595,1351386000,1),(595,1364691600,0),(595,1382835600,1),(595,1396141200,0),(595,1414285200,1),(595,1427590800,0),(595,1445734800,1),(595,1459040400,0),(595,1477789200,1),(595,1490490000,0),(595,1509238800,1),(595,1521939600,0),(595,1540688400,1),(595,1553994000,0),(595,1572138000,1),(595,1585443600,0),(595,1603587600,1),(595,1616893200,0),(595,1635642000,1),(595,1648342800,0),(595,1667091600,1),(595,1679792400,0),(595,1698541200,1),(595,1711846800,0),(595,1729990800,1),(595,1743296400,0),(595,1761440400,1),(595,1774746000,0),(595,1792890000,1),(595,1806195600,0),(595,1824944400,1),(595,1837645200,0),(595,1856394000,1),(595,1869094800,0),(595,1887843600,1),(595,1901149200,0),(595,1919293200,1),(595,1932598800,0),(595,1950742800,1),(595,1964048400,0),(595,1982797200,1),(595,1995498000,0),(595,2014246800,1),(595,2026947600,0),(595,2045696400,1),(595,2058397200,0),(595,2077146000,1),(595,2090451600,0),(595,2108595600,1),(595,2121901200,0),(595,2140045200,1),(597,-2147483648,0),(597,-1830383032,1),(598,-2147483648,0),(598,-1830383032,1),(599,-2147483648,0),(599,-1946168836,1),(599,-1309746600,2),(599,-1261969200,1),(599,-1041388200,3),(599,-865305900,2),(600,-2147483648,1),(600,-1855958961,4),(600,-1689814800,2),(600,-1680397200,3),(600,-1665363600,2),(600,-1648342800,3),(600,-1635123600,2),(600,-1616893200,3),(600,-1604278800,2),(600,-1585443600,3),(600,-1574038800,2),(600,-1552266000,3),(600,-1539997200,2),(600,-1531443600,3),(600,-956365200,2),(600,-950486400,4),(600,-942012000,6),(600,-812502000,5),(600,-796262400,6),(600,-781052400,5),(600,-766630800,6),(600,-733280400,4),(600,-439430400,6),(600,-212029200,4),(600,41468400,2),(600,54774000,3),(600,231724800,7),(600,246236400,6),(600,259545600,5),(600,275274000,6),(600,309740400,4),(600,325468800,7),(600,341802000,4),(600,357523200,6),(601,-2147483648,0),(601,-1946168836,1),(601,-1309746600,2),(601,-1261969200,1),(601,-1041388200,3),(601,-865305900,2),(602,-2147483648,0),(602,-1946168836,1),(602,-1309746600,2),(602,-1261969200,1),(602,-1041388200,3),(602,-865305900,2),(603,-2147483648,0),(603,-1830383032,1),(604,-2147483648,0),(604,-2035584815,1),(604,-1940889600,0),(604,-1767226415,2),(604,-1588465800,3),(605,-2147483648,0),(605,-1830383032,1),(606,-2147483648,0),(606,-1830380400,1),(606,157770000,2),(607,-2147483648,0),(607,-2109291020,1),(608,-2147483648,0),(608,-2035584815,1),(608,-1940889600,0),(608,-1767226415,2),(608,-1588465800,3),(609,-2147483648,0),(609,-2109291020,1),(610,-2147483648,2),(610,-929844000,1),(610,-923108400,2),(610,-906170400,1),(610,-892868400,2),(610,-875844000,1),(610,-857790000,2),(610,-844308000,1),(610,-825822000,2),(610,-812685600,1),(610,-794199600,2),(610,-779853600,1),(610,-762663600,2),(610,-399088800,1),(610,-386650800,2),(610,-368330400,1),(610,-355114800,2),(610,-336790800,1),(610,-323654400,2),(610,-305168400,1),(610,-292032000,2),(610,-273632400,1),(610,-260496000,2),(610,-242096400,1),(610,-228960000,2),(610,-210560400,1),(610,-197424000,2),(610,-178938000,1),(610,-165801600,2),(610,-147402000,1),(610,-134265600,2),(610,-115866000,1),(610,-102643200,2),(610,-84330000,1),(610,-71107200,2),(610,-52707600,1),(610,-39484800,2),(610,-21171600,1),(610,-7948800,2),(610,10364400,1),(610,23587200,2),(610,41900400,1),(610,55123200,2),(610,73522800,1),(610,86745600,2),(610,105058800,1),(610,118281600,2),(610,136594800,1),(610,149817600,2),(610,168130800,1),(610,181353600,2),(610,199753200,1),(610,212976000,2),(610,231289200,1),(610,244512000,2),(610,262825200,1),(610,276048000,2),(610,294361200,1),(610,307584000,2),(610,325983600,1),(610,339206400,2),(610,357519600,1),(610,370742400,2),(610,396399600,1),(610,402278400,2),(610,426812400,1),(610,433814400,2),(610,452214000,1),(610,465436800,2),(610,483750000,1),(610,496972800,2),(610,515286000,1),(610,528508800,2),(610,546822000,1),(610,560044800,2),(610,578444400,1),(610,591667200,2),(610,610412400,1),(610,623203200,2),(610,641516400,1),(610,654739200,2),(610,673052400,1),(610,686275200,2),(610,704674800,1),(610,717897600,2),(610,736210800,1),(610,749433600,2),(610,767746800,1),(610,780969600,2),(610,799020000,3),(610,812322000,2),(610,830469600,3),(610,843771600,2),(610,861919200,3),(610,875221200,2),(610,893368800,3),(610,906670800,2),(610,925423200,3),(610,938725200,2),(610,956872800,3),(610,970174800,2),(610,988322400,3),(610,1001624400,2),(610,1019772000,3),(610,1033074000,2),(610,1051221600,3),(610,1064523600,2),(610,1083276000,3),(610,1096578000,2),(610,1114725600,3),(610,1128027600,2),(610,1146175200,3),(610,1158872400,2),(610,1177624800,3),(610,1189112400,2),(610,1209074400,3),(610,1219957200,2),(610,1240524000,3),(610,1250802000,2),(610,1272578400,3),(610,1281474000,2),(610,1284069600,1),(610,1285880400,2),(610,1400191200,1),(610,1403816400,2),(610,1406844000,1),(610,1411678800,2),(610,1682632800,1),(610,1698354000,2),(610,1714082400,1),(610,1730408400,2),(610,1745532000,1),(610,1761858000,2),(610,1776981600,1),(610,1793307600,2),(610,1809036000,1),(610,1824757200,2),(610,1840485600,1),(610,1856206800,2),(610,1871935200,1),(610,1887656400,2),(610,1903384800,1),(610,1919710800,2),(610,1934834400,1),(610,1951160400,2),(610,1966888800,1),(610,1982610000,2),(610,1998338400,1),(610,2014059600,2),(610,2029788000,1),(610,2045509200,2),(610,2061237600,1),(610,2076958800,2),(610,2092687200,1),(610,2109013200,2),(610,2124136800,1),(610,2140462800,2),(611,-2147483648,0),(611,-1773012580,2),(611,-956361600,1),(611,-950490000,2),(611,-942019200,1),(611,-761187600,2),(611,-617241600,1),(611,-605149200,2),(611,-81432000,1),(611,-71110800,2),(611,141264000,1),(611,147222000,2),(611,199756800,1),(611,207702000,2),(611,231292800,1),(611,244249200,2),(611,265507200,1),(611,271033200,2),(611,448243200,3),(611,504918000,2),(611,1212278400,1),(611,1220223600,2),(611,1243814400,1),(611,1250809200,2),(611,1272758400,1),(611,1281222000,2),(611,1301788800,1),(611,1312066800,2),(611,1335664800,1),(611,1342749600,2),(611,1345428000,1),(611,1348970400,2),(611,1367114400,1),(611,1373162400,2),(611,1376100000,1),(611,1382839200,2),(611,1396144800,1),(611,1403920800,2),(611,1406944800,1),(611,1414288800,2),(611,1427594400,1),(611,1434247200,2),(611,1437271200,1),(611,1445738400,2),(611,1459044000,1),(611,1465092000,2),(611,1468116000,1),(611,1477792800,2),(611,1490493600,1),(611,1495332000,2),(611,1498960800,1),(611,1509242400,2),(611,1521943200,1),(611,1526176800,2),(611,1529200800,1),(611,1557021600,2),(611,1560045600,1),(611,1587261600,2),(611,1590890400,1),(611,1618106400,2),(611,1621130400,1),(611,1648346400,2),(611,1651975200,1),(611,1679191200,2),(611,1682215200,1),(611,1710036000,2),(611,1713060000,1),(611,1740276000,2),(611,1743904800,1),(611,1771120800,2),(611,1774144800,1),(611,1801965600,2),(611,1804989600,1),(611,1832205600,2),(611,1835834400,1),(611,1863050400,2),(611,1866074400,1),(611,1893290400,2),(611,1896919200,1),(611,1924135200,2),(611,1927159200,1),(611,1954980000,2),(611,1958004000,1),(611,1985220000,2),(611,1988848800,1),(611,2016064800,2),(611,2019088800,1),(611,2046304800,2),(611,2049933600,1),(611,2077149600,2),(611,2080778400,1),(611,2107994400,2),(611,2111018400,1),(611,2138234400,2),(611,2141863200,1),(612,-2147483648,1),(612,-1630112400,2),(612,-1616810400,3),(612,-1442451600,2),(612,-1427673600,4),(612,-1379293200,2),(612,-1364774400,4),(612,-1348448400,2),(612,-1333324800,4),(612,-1316390400,2),(612,-1301270400,4),(612,-1293840000,3),(612,-81432000,2),(612,-71110800,3),(612,141264000,2),(612,147222000,3),(612,199756800,2),(612,207702000,3),(612,231292800,2),(612,244249200,3),(612,265507200,2),(612,271033200,3),(612,448243200,5),(612,512528400,6),(612,528253200,7),(612,543978000,6),(612,559702800,7),(612,575427600,6),(612,591152400,7),(612,606877200,6),(612,622602000,7),(612,638326800,6),(612,654656400,7),(612,670381200,6),(612,686106000,7),(612,701830800,6),(612,717555600,7),(612,733280400,6),(612,749005200,7),(612,764730000,6),(612,780454800,7),(612,796179600,6),(612,811904400,7),(612,828234000,6),(612,846378000,7),(612,859683600,6),(612,877827600,7),(612,891133200,6),(612,909277200,7),(612,922582800,6),(612,941331600,7),(612,954032400,6),(612,972781200,7),(612,985482000,6),(612,1004230800,7),(612,1017536400,6),(612,1035680400,7),(612,1048986000,6),(612,1067130000,7),(612,1080435600,6),(612,1099184400,7),(612,1111885200,6),(612,1130634000,7),(612,1143334800,6),(612,1162083600,7),(612,1174784400,6),(612,1193533200,7),(612,1206838800,6),(612,1224982800,7),(612,1238288400,6),(612,1256432400,7),(612,1269738000,6),(612,1288486800,7),(612,1301187600,6),(612,1319936400,7),(612,1332637200,6),(612,1351386000,7),(612,1364691600,6),(612,1382835600,7),(612,1396141200,6),(612,1414285200,7),(612,1427590800,6),(612,1445734800,7),(612,1459040400,6),(612,1477789200,7),(612,1490490000,6),(612,1509238800,7),(612,1521939600,6),(612,1540688400,7),(612,1553994000,6),(612,1572138000,7),(612,1585443600,6),(612,1603587600,7),(612,1616893200,6),(612,1635642000,7),(612,1648342800,6),(612,1667091600,7),(612,1679792400,6),(612,1698541200,7),(612,1711846800,6),(612,1729990800,7),(612,1743296400,6),(612,1761440400,7),(612,1774746000,6),(612,1792890000,7),(612,1806195600,6),(612,1824944400,7),(612,1837645200,6),(612,1856394000,7),(612,1869094800,6),(612,1887843600,7),(612,1901149200,6),(612,1919293200,7),(612,1932598800,6),(612,1950742800,7),(612,1964048400,6),(612,1982797200,7),(612,1995498000,6),(612,2014246800,7),(612,2026947600,6),(612,2045696400,7),(612,2058397200,6),(612,2077146000,7),(612,2090451600,6),(612,2108595600,7),(612,2121901200,6),(612,2140045200,7),(613,-2147483648,0),(613,-1830383032,1),(614,-2147483648,0),(614,-1830383032,1),(615,-2147483648,0),(615,-1946168836,1),(615,-1309746600,2),(615,-1261969200,1),(615,-1041388200,3),(615,-865305900,2),(616,-2147483648,0),(616,-1946168836,1),(616,-1309746600,2),(616,-1261969200,1),(616,-1041388200,3),(616,-865305900,2),(617,-2147483648,0),(617,-2035584815,1),(617,-1940889600,0),(617,-1767226415,2),(617,-1588465800,3),(618,-2147483648,0),(618,-1136070432,1),(618,198291600,3),(618,199756800,2),(618,207702000,3),(618,231292800,2),(618,244249200,3),(618,265507200,2),(618,271033200,3),(618,1212278400,2),(618,1220223600,3),(618,1243814400,2),(618,1250809200,3),(618,1272758400,2),(618,1281222000,3),(618,1301788800,2),(618,1312066800,3),(618,1335664800,2),(618,1342749600,3),(618,1345428000,2),(618,1348970400,3),(618,1367114400,2),(618,1373162400,3),(618,1376100000,2),(618,1382839200,3),(618,1396144800,2),(618,1403920800,3),(618,1406944800,2),(618,1414288800,3),(618,1427594400,2),(618,1434247200,3),(618,1437271200,2),(618,1445738400,3),(618,1459044000,2),(618,1465092000,3),(618,1468116000,2),(618,1477792800,3),(618,1490493600,2),(618,1495332000,3),(618,1498960800,2),(618,1509242400,3),(618,1521943200,2),(618,1526176800,3),(618,1529200800,2),(618,1557021600,3),(618,1560045600,2),(618,1587261600,3),(618,1590890400,2),(618,1618106400,3),(618,1621130400,2),(618,1648346400,3),(618,1651975200,2),(618,1679191200,3),(618,1682215200,2),(618,1710036000,3),(618,1713060000,2),(618,1740276000,3),(618,1743904800,2),(618,1771120800,3),(618,1774144800,2),(618,1801965600,3),(618,1804989600,2),(618,1832205600,3),(618,1835834400,2),(618,1863050400,3),(618,1866074400,2),(618,1893290400,3),(618,1896919200,2),(618,1924135200,3),(618,1927159200,2),(618,1954980000,3),(618,1958004000,2),(618,1985220000,3),(618,1988848800,2),(618,2016064800,3),(618,2019088800,2),(618,2046304800,3),(618,2049933600,2),(618,2077149600,3),(618,2080778400,2),(618,2107994400,3),(618,2111018400,2),(618,2138234400,3),(618,2141863200,2),(619,-2147483648,0),(619,-1830383032,1),(620,-2147483648,0),(620,-2109291020,1),(621,-2147483648,0),(621,-2109291020,1),(622,-2147483648,1),(622,-2109288600,3),(622,-860976000,2),(622,-845254800,3),(622,-829526400,2),(622,-813805200,3),(623,-2147483648,0),(623,-1230775588,2),(623,10360800,1),(623,24786000,2),(623,41810400,1),(623,56322000,2),(623,73432800,1),(623,87944400,2),(623,104882400,1),(623,119480400,2),(623,136332000,1),(623,151016400,2),(623,167781600,1),(623,182552400,2),(623,199231200,1),(623,214174800,2),(623,230680800,1),(623,245710800,2),(623,262735200,1),(623,277246800,2),(623,294184800,1),(623,308782800,2),(623,325634400,1),(623,340405200,2),(623,357084000,1),(623,371941200,2),(623,388533600,1),(623,403477200,2),(623,419983200,1),(623,435013200,2),(623,452037600,1),(623,466635600,2),(623,483487200,1),(623,498171600,2),(623,947930400,3),(623,1612126800,2),(624,-2147483648,0),(624,-1946168836,1),(624,-1309746600,2),(624,-1261969200,1),(624,-1041388200,3),(624,-865305900,2),(625,-2147483648,0),(625,-1230775808,2),(625,10360800,1),(625,24786000,2),(625,41810400,1),(625,56322000,2),(625,73432800,1),(625,87944400,2),(625,104882400,1),(625,119480400,2),(625,136332000,1),(625,151016400,2),(625,167781600,1),(625,182552400,2),(625,199231200,1),(625,214174800,2),(625,230680800,1),(625,245710800,2),(625,262735200,1),(625,277246800,2),(625,294184800,1),(625,308782800,2),(625,325634400,1),(625,340405200,2),(625,357084000,1),(625,371941200,2),(625,388533600,1),(625,403477200,2),(625,419983200,1),(625,435013200,2),(625,452037600,1),(625,466635600,2),(625,483487200,1),(625,498171600,2),(625,947930400,3),(625,1509483600,2),(626,-2147483648,0),(626,-2109291020,1),(627,-2147483648,0),(627,-2035584815,1),(627,-1940889600,0),(627,-1767226415,2),(627,-1588465800,3),(628,-2147483648,0),(628,-2035584815,1),(628,-1940889600,0),(628,-1767226415,2),(628,-1588465800,3),(629,-2147483648,0),(629,-2035584815,1),(629,-1940889600,0),(629,-1767226415,2),(629,-1588465800,3),(630,-2147483648,0),(630,-1830383032,1),(631,-2147483648,0),(631,-2035584815,1),(631,-1940889600,0),(631,-1767226415,2),(631,-1588465800,3),(632,-2147483648,0),(632,-2109291020,1),(633,-2147483648,0),(633,-2109291020,1),(634,-2147483648,0),(634,-2035584815,1),(634,-1940889600,0),(634,-1767226415,2),(634,-1588465800,3),(635,-2147483648,0),(635,-2109291020,1),(636,-2147483648,1),(636,-2109288600,3),(636,-860976000,2),(636,-845254800,3),(636,-829526400,2),(636,-813805200,3),(637,-2147483648,1),(637,-2109288600,3),(637,-860976000,2),(637,-845254800,3),(637,-829526400,2),(637,-813805200,3),(638,-2147483648,0),(638,-1946168836,1),(638,-1309746600,2),(638,-1261969200,1),(638,-1041388200,3),(638,-865305900,2),(639,-2147483648,1),(639,-1604359012,2),(639,63593070,3),(640,-2147483648,0),(640,-1946168836,1),(640,-1309746600,2),(640,-1261969200,1),(640,-1041388200,3),(640,-865305900,2),(641,-2147483648,0),(641,-1830387612,1),(641,308703600,2),(641,321314400,1),(642,-2147483648,0),(642,-2035584815,1),(642,-1940889600,0),(642,-1767226415,2),(642,-1588465800,3),(643,-2147483648,0),(643,-1830383032,1),(644,-2147483648,0),(644,-1830383032,1),(645,-2147483648,0),(645,-2035584815,1),(645,-1940889600,0),(645,-1767226415,2),(645,-1588465800,3),(646,-2147483648,1),(646,-1830384000,2),(646,1514768400,3),(646,1546304400,4),(647,-2147483648,0),(647,-1830383032,1),(648,-2147483648,0),(648,-1577926364,2),(648,-574902000,1),(648,-568087200,2),(648,-512175600,1),(648,-504928800,2),(648,-449888400,1),(648,-441856800,2),(648,-347158800,3),(648,378684000,2),(648,386463600,1),(648,402271200,2),(648,417999600,1),(648,433807200,2),(648,449622000,1),(648,465429600,2),(648,481590000,1),(648,496965600,2),(648,512953200,1),(648,528674400,2),(648,544230000,1),(648,560037600,2),(648,575852400,1),(648,591660000,2),(648,607388400,1),(648,623196000,2),(648,641775600,3),(648,844034400,2),(648,860108400,1),(648,875916000,3),(648,1352505600,2),(648,1364515200,1),(648,1382659200,3),(649,-2147483648,1),(649,-1855958961,4),(649,-969242400,2),(649,-950493600,3),(649,-941940000,2),(649,-891136800,4),(649,-877827600,5),(649,-857257200,4),(649,-844556400,5),(649,-842918400,4),(649,-842223600,5),(649,-828230400,4),(649,-812502000,5),(649,-796269600,4),(649,-781052400,5),(649,-766634400,4),(649,231202800,2),(649,243903600,3),(649,262825200,2),(649,276044400,3),(649,581122800,2),(649,591145200,3),(649,606870000,2),(649,622594800,3),(649,641516400,2),(649,654649200,3),(649,1114902000,2),(649,1128038400,3),(649,1143334800,2),(649,1162083600,3),(649,1174784400,2),(649,1193533200,3),(649,1206838800,2),(649,1224982800,3),(650,-2147483648,1),(650,-2109288600,2),(650,-860976000,3),(650,-845254800,2),(650,637970400,4),(650,764200800,5),(650,778640400,6),(650,796780800,5),(650,810090000,6),(650,828835200,5),(650,841539600,6),(650,860284800,5),(650,873594000,6),(650,891734400,5),(650,905043600,6),(650,923184000,5),(650,936493200,6),(650,954633600,5),(650,967942800,6),(650,986083200,5),(650,999392400,6),(650,1018137600,5),(650,1030842000,6),(650,1049587200,5),(650,1062896400,6),(650,1081036800,5),(650,1094346000,6),(650,1112486400,5),(650,1125795600,6),(650,1143936000,5),(650,1157245200,6),(650,1175385600,5),(650,1188694800,6),(650,1207440000,5),(650,1220749200,6),(650,1238889600,5),(650,1252198800,6),(650,1270339200,5),(650,1283648400,6),(650,1301788800,5),(650,1315098000,6),(650,1333238400,5),(650,1346547600,6),(650,1365292800,5),(650,1377997200,6),(650,1396742400,5),(650,1410051600,6),(650,1428192000,5),(650,1441501200,6),(650,1459641600,5),(650,1472950800,6),(650,1491091200,5),(650,1504400400,6),(650,1508796000,4),(651,-2147483648,1),(651,-880196400,2),(651,-769395600,3),(651,-765374400,1),(651,-86878800,4),(651,-21466800,5),(651,-5745600,4),(651,9982800,5),(651,25704000,4),(651,41432400,5),(651,57758400,4),(651,73486800,5),(651,89208000,4),(651,104936400,5),(651,120657600,4),(651,126709200,5),(651,152107200,4),(651,162392400,5),(651,183556800,4),(651,199285200,5),(651,215611200,4),(651,230734800,5),(651,247060800,4),(651,262789200,5),(651,278510400,4),(651,294238800,5),(651,309960000,4),(651,325688400,5),(651,341409600,4),(651,357138000,5),(651,372859200,4),(651,388587600,5),(651,404913600,4),(651,420037200,5),(651,436363200,6),(651,439034400,8),(651,452088000,7),(651,467809200,8),(651,483537600,7),(651,499258800,8),(651,514987200,7),(651,530708400,8),(651,544622400,7),(651,562158000,8),(651,576072000,7),(651,594212400,8),(651,607521600,7),(651,625662000,8),(651,638971200,7),(651,657111600,8),(651,671025600,7),(651,688561200,8),(651,702475200,7),(651,720010800,8),(651,733924800,7),(651,752065200,8),(651,765374400,7),(651,783514800,8),(651,796824000,7),(651,814964400,8),(651,828878400,7),(651,846414000,8),(651,860328000,7),(651,877863600,8),(651,891777600,7),(651,909313200,8),(651,923227200,7),(651,941367600,8),(651,954676800,7),(651,972817200,8),(651,986126400,7),(651,1004266800,8),(651,1018180800,7),(651,1035716400,8),(651,1049630400,7),(651,1067166000,8),(651,1081080000,7),(651,1099220400,8),(651,1112529600,7),(651,1130670000,8),(651,1143979200,7),(651,1162119600,8),(651,1173614400,7),(651,1194174000,8),(651,1205064000,7),(651,1225623600,8),(651,1236513600,7),(651,1257073200,8),(651,1268568000,7),(651,1289127600,8),(651,1300017600,7),(651,1320577200,8),(651,1331467200,7),(651,1352026800,8),(651,1362916800,7),(651,1383476400,8),(651,1394366400,7),(651,1414926000,8),(651,1425816000,7),(651,1446375600,8),(651,1457870400,7),(651,1478430000,8),(651,1489320000,7),(651,1509879600,8),(651,1520769600,7),(651,1541329200,8),(651,1552219200,7),(651,1572778800,8),(651,1583668800,7),(651,1604228400,8),(651,1615723200,7),(651,1636282800,8),(651,1647172800,7),(651,1667732400,8),(651,1678622400,7),(651,1699182000,8),(651,1710072000,7),(651,1730631600,8),(651,1741521600,7),(651,1762081200,8),(651,1772971200,7),(651,1793530800,8),(651,1805025600,7),(651,1825585200,8),(651,1836475200,7),(651,1857034800,8),(651,1867924800,7),(651,1888484400,8),(651,1899374400,7),(651,1919934000,8),(651,1930824000,7),(651,1951383600,8),(651,1962878400,7),(651,1983438000,8),(651,1994328000,7),(651,2014887600,8),(651,2025777600,7),(651,2046337200,8),(651,2057227200,7),(651,2077786800,8),(651,2088676800,7),(651,2109236400,8),(651,2120126400,7),(651,2140686000,8),(652,-2147483648,1),(652,-880200000,2),(652,-769395600,3),(652,-765378000,1),(652,-86882400,4),(652,-21470400,5),(652,-5749200,4),(652,9979200,5),(652,25700400,4),(652,41428800,5),(652,57754800,4),(652,73483200,5),(652,89204400,4),(652,104932800,5),(652,120654000,4),(652,126705600,5),(652,152103600,4),(652,162388800,5),(652,183553200,4),(652,199281600,5),(652,215607600,4),(652,230731200,5),(652,247057200,4),(652,262785600,5),(652,278506800,4),(652,294235200,5),(652,309956400,4),(652,325684800,5),(652,341406000,4),(652,357134400,5),(652,372855600,4),(652,388584000,5),(652,404910000,4),(652,420033600,5),(652,436359600,6),(652,439030800,8),(652,452084400,7),(652,467805600,8),(652,483534000,7),(652,499255200,8),(652,514983600,7),(652,530704800,8),(652,544618800,7),(652,562154400,8),(652,576068400,7),(652,594208800,8),(652,607518000,7),(652,625658400,8),(652,638967600,7),(652,657108000,8),(652,671022000,7),(652,688557600,8),(652,702471600,7),(652,720007200,8),(652,733921200,7),(652,752061600,8),(652,765370800,7),(652,783511200,8),(652,796820400,7),(652,814960800,8),(652,828874800,7),(652,846410400,8),(652,860324400,7),(652,877860000,8),(652,891774000,7),(652,909309600,8),(652,923223600,7),(652,941364000,8),(652,954673200,7),(652,972813600,8),(652,986122800,7),(652,1004263200,8),(652,1018177200,7),(652,1035712800,8),(652,1049626800,7),(652,1067162400,8),(652,1081076400,7),(652,1099216800,8),(652,1112526000,7),(652,1130666400,8),(652,1143975600,7),(652,1162116000,8),(652,1173610800,7),(652,1194170400,8),(652,1205060400,7),(652,1225620000,8),(652,1236510000,7),(652,1257069600,8),(652,1268564400,7),(652,1289124000,8),(652,1300014000,7),(652,1320573600,8),(652,1331463600,7),(652,1352023200,8),(652,1362913200,7),(652,1383472800,8),(652,1394362800,7),(652,1414922400,8),(652,1425812400,7),(652,1446372000,8),(652,1457866800,7),(652,1478426400,8),(652,1489316400,7),(652,1509876000,8),(652,1520766000,7),(652,1541325600,8),(652,1552215600,7),(652,1572775200,8),(652,1583665200,7),(652,1604224800,8),(652,1615719600,7),(652,1636279200,8),(652,1647169200,7),(652,1667728800,8),(652,1678618800,7),(652,1699178400,8),(652,1710068400,7),(652,1730628000,8),(652,1741518000,7),(652,1762077600,8),(652,1772967600,7),(652,1793527200,8),(652,1805022000,7),(652,1825581600,8),(652,1836471600,7),(652,1857031200,8),(652,1867921200,7),(652,1888480800,8),(652,1899370800,7),(652,1919930400,8),(652,1930820400,7),(652,1951380000,8),(652,1962874800,7),(652,1983434400,8),(652,1994324400,7),(652,2014884000,8),(652,2025774000,7),(652,2046333600,8),(652,2057223600,7),(652,2077783200,8),(652,2088673200,7),(652,2109232800,8),(652,2120122800,7),(652,2140682400,8),(653,-2147483648,1),(653,-873057600,3),(653,-769395600,2),(653,-765399600,1),(654,-2147483648,1),(654,-873057600,3),(654,-769395600,2),(654,-765399600,1),(655,-2147483648,0),(655,-1767214032,2),(655,-1206957600,1),(655,-1191362400,2),(655,-1175374800,1),(655,-1159826400,2),(655,-633819600,1),(655,-622069200,2),(655,-602283600,1),(655,-591832800,2),(655,-570747600,1),(655,-560210400,2),(655,-539125200,1),(655,-531352800,2),(655,-191365200,1),(655,-184197600,2),(655,-155163600,1),(655,-150069600,2),(655,-128898000,1),(655,-121125600,2),(655,-99954000,1),(655,-89589600,2),(655,-68418000,1),(655,-57967200,2),(655,499748400,1),(655,511236000,2),(655,530593200,1),(655,540266400,2),(655,562129200,1),(655,571197600,2),(655,592974000,1),(655,602042400,2),(655,624423600,1),(655,634701600,2),(655,813726000,1),(655,824004000,2),(655,844570800,1),(655,856058400,2),(655,876106800,1),(655,888717600,2),(655,908074800,1),(655,919562400,2),(655,938919600,1),(655,951616800,2),(655,970974000,1),(655,982461600,2),(655,1003028400,1),(655,1013911200,2),(655,1036292400,1),(655,1045360800,2),(655,1350788400,1),(655,1361066400,2),(655,2147483647,2),(656,-2147483648,1),(656,-1567453392,2),(656,-1233432000,3),(656,-1222981200,2),(656,-1205956800,3),(656,-1194037200,2),(656,-1172865600,3),(656,-1162501200,2),(656,-1141329600,3),(656,-1130965200,2),(656,-1109793600,3),(656,-1099429200,2),(656,-1078257600,3),(656,-1067806800,2),(656,-1046635200,3),(656,-1036270800,2),(656,-1015099200,3),(656,-1004734800,2),(656,-983563200,3),(656,-973198800,2),(656,-952027200,3),(656,-941576400,2),(656,-931032000,3),(656,-900882000,2),(656,-890337600,3),(656,-833749200,2),(656,-827265600,3),(656,-752274000,2),(656,-733780800,3),(656,-197326800,2),(656,-190843200,3),(656,-184194000,2),(656,-164491200,3),(656,-152658000,2),(656,-132955200,3),(656,-121122000,2),(656,-101419200,3),(656,-86821200,2),(656,-71092800,3),(656,-54766800,2),(656,-39038400,3),(656,-23317200,2),(656,-7588800,5),(656,128142000,4),(656,136605600,5),(656,596948400,4),(656,605066400,5),(656,624423600,4),(656,636516000,5),(656,656478000,4),(656,667965600,5),(656,687927600,4),(656,699415200,5),(656,719377200,4),(656,731469600,5),(656,938919600,3),(656,952052400,5),(656,1198983600,4),(656,1205632800,5),(656,1224385200,4),(656,1237082400,5),(656,2147483647,5),(657,-2147483648,1),(657,-1567453392,2),(657,-1233432000,3),(657,-1222981200,2),(657,-1205956800,3),(657,-1194037200,2),(657,-1172865600,3),(657,-1162501200,2),(657,-1141329600,3),(657,-1130965200,2),(657,-1109793600,3),(657,-1099429200,2),(657,-1078257600,3),(657,-1067806800,2),(657,-1046635200,3),(657,-1036270800,2),(657,-1015099200,3),(657,-1004734800,2),(657,-983563200,3),(657,-973198800,2),(657,-952027200,3),(657,-941576400,2),(657,-931032000,3),(657,-900882000,2),(657,-890337600,3),(657,-833749200,2),(657,-827265600,3),(657,-752274000,2),(657,-733780800,3),(657,-197326800,2),(657,-190843200,3),(657,-184194000,2),(657,-164491200,3),(657,-152658000,2),(657,-132955200,3),(657,-121122000,2),(657,-101419200,3),(657,-86821200,2),(657,-71092800,3),(657,-54766800,2),(657,-39038400,3),(657,-23317200,2),(657,-7588800,5),(657,128142000,4),(657,136605600,5),(657,596948400,4),(657,605066400,5),(657,624423600,4),(657,636516000,5),(657,656478000,4),(657,667965600,2),(657,687931200,4),(657,699415200,5),(657,719377200,4),(657,731469600,5),(657,938919600,3),(657,952052400,5),(657,1086058800,2),(657,1087704000,5),(657,1198983600,4),(657,1205632800,5),(657,2147483647,5),(658,-2147483648,1),(658,-1567453392,2),(658,-1233432000,3),(658,-1222981200,2),(658,-1205956800,3),(658,-1194037200,2),(658,-1172865600,3),(658,-1162501200,2),(658,-1141329600,3),(658,-1130965200,2),(658,-1109793600,3),(658,-1099429200,2),(658,-1078257600,3),(658,-1067806800,2),(658,-1046635200,3),(658,-1036270800,2),(658,-1015099200,3),(658,-1004734800,2),(658,-983563200,3),(658,-973198800,2),(658,-952027200,3),(658,-941576400,2),(658,-931032000,3),(658,-900882000,2),(658,-890337600,3),(658,-833749200,2),(658,-827265600,3),(658,-752274000,2),(658,-733780800,3),(658,-197326800,2),(658,-190843200,3),(658,-184194000,2),(658,-164491200,3),(658,-152658000,2),(658,-132955200,3),(658,-121122000,2),(658,-101419200,3),(658,-86821200,2),(658,-71092800,3),(658,-54766800,2),(658,-39038400,3),(658,-23317200,2),(658,-7588800,5),(658,128142000,4),(658,136605600,5),(658,596948400,4),(658,605066400,5),(658,624423600,4),(658,636516000,5),(658,656478000,4),(658,667965600,2),(658,687931200,4),(658,699415200,5),(658,719377200,4),(658,731469600,5),(658,938919600,3),(658,952052400,5),(658,1086058800,2),(658,1087704000,5),(658,1198983600,4),(658,1205632800,5),(658,2147483647,5),(659,-2147483648,1),(659,-1567453392,2),(659,-1233432000,3),(659,-1222981200,2),(659,-1205956800,3),(659,-1194037200,2),(659,-1172865600,3),(659,-1162501200,2),(659,-1141329600,3),(659,-1130965200,2),(659,-1109793600,3),(659,-1099429200,2),(659,-1078257600,3),(659,-1067806800,2),(659,-1046635200,3),(659,-1036270800,2),(659,-1015099200,3),(659,-1004734800,2),(659,-983563200,3),(659,-973198800,2),(659,-952027200,3),(659,-941576400,2),(659,-931032000,3),(659,-900882000,2),(659,-890337600,3),(659,-833749200,2),(659,-827265600,3),(659,-752274000,2),(659,-733780800,3),(659,-197326800,2),(659,-190843200,3),(659,-184194000,2),(659,-164491200,3),(659,-152658000,2),(659,-132955200,3),(659,-121122000,2),(659,-101419200,3),(659,-86821200,2),(659,-71092800,3),(659,-54766800,2),(659,-39038400,3),(659,-23317200,2),(659,-7588800,5),(659,128142000,4),(659,136605600,5),(659,596948400,4),(659,605066400,5),(659,624423600,4),(659,636516000,5),(659,656478000,4),(659,667965600,2),(659,687931200,4),(659,699415200,5),(659,719377200,4),(659,731469600,5),(659,938919600,3),(659,952052400,5),(659,1198983600,4),(659,1205632800,5),(659,1224385200,4),(659,1237082400,5),(659,2147483647,5),(660,-2147483648,1),(660,-1567453392,2),(660,-1233432000,3),(660,-1222981200,2),(660,-1205956800,3),(660,-1194037200,2),(660,-1172865600,3),(660,-1162501200,2),(660,-1141329600,3),(660,-1130965200,2),(660,-1109793600,3),(660,-1099429200,2),(660,-1078257600,3),(660,-1067806800,2),(660,-1046635200,3),(660,-1036270800,2),(660,-1015099200,3),(660,-1004734800,2),(660,-983563200,3),(660,-973198800,2),(660,-952027200,3),(660,-941576400,2),(660,-931032000,3),(660,-900882000,2),(660,-890337600,3),(660,-833749200,2),(660,-827265600,3),(660,-752274000,2),(660,-733780800,3),(660,-197326800,2),(660,-190843200,3),(660,-184194000,2),(660,-164491200,3),(660,-152658000,2),(660,-132955200,3),(660,-121122000,2),(660,-101419200,3),(660,-86821200,2),(660,-71092800,3),(660,-54766800,2),(660,-39038400,3),(660,-23317200,2),(660,-7588800,5),(660,128142000,4),(660,136605600,5),(660,596948400,4),(660,605066400,5),(660,624423600,4),(660,636516000,2),(660,657086400,3),(660,669178800,2),(660,686721600,4),(660,699415200,5),(660,719377200,4),(660,731469600,5),(660,938919600,3),(660,952052400,5),(660,1198983600,4),(660,1205632800,5),(660,2147483647,5),(661,-2147483648,1),(661,-1567453392,2),(661,-1233432000,3),(661,-1222981200,2),(661,-1205956800,3),(661,-1194037200,2),(661,-1172865600,3),(661,-1162501200,2),(661,-1141329600,3),(661,-1130965200,2),(661,-1109793600,3),(661,-1099429200,2),(661,-1078257600,3),(661,-1067806800,2),(661,-1046635200,3),(661,-1036270800,2),(661,-1015099200,3),(661,-1004734800,2),(661,-983563200,3),(661,-973198800,2),(661,-952027200,3),(661,-941576400,2),(661,-931032000,3),(661,-900882000,2),(661,-890337600,3),(661,-833749200,2),(661,-827265600,3),(661,-752274000,2),(661,-733780800,3),(661,-197326800,2),(661,-190843200,3),(661,-184194000,2),(661,-164491200,3),(661,-152658000,2),(661,-132955200,3),(661,-121122000,2),(661,-101419200,3),(661,-86821200,2),(661,-71092800,3),(661,-54766800,2),(661,-39038400,3),(661,-23317200,2),(661,-7588800,5),(661,128142000,4),(661,136605600,5),(661,596948400,4),(661,605066400,5),(661,624423600,4),(661,636516000,5),(661,656478000,4),(661,667792800,2),(661,673588800,5),(661,687927600,4),(661,699415200,5),(661,719377200,4),(661,731469600,5),(661,938919600,3),(661,952052400,5),(661,1086058800,2),(661,1087704000,5),(661,1198983600,4),(661,1205632800,5),(661,2147483647,5),(662,-2147483648,1),(662,-1567453392,2),(662,-1233432000,3),(662,-1222981200,2),(662,-1205956800,3),(662,-1194037200,2),(662,-1172865600,3),(662,-1162501200,2),(662,-1141329600,3),(662,-1130965200,2),(662,-1109793600,3),(662,-1099429200,2),(662,-1078257600,3),(662,-1067806800,2),(662,-1046635200,3),(662,-1036270800,2),(662,-1015099200,3),(662,-1004734800,2),(662,-983563200,3),(662,-973198800,2),(662,-952027200,3),(662,-941576400,2),(662,-931032000,3),(662,-900882000,2),(662,-890337600,3),(662,-833749200,2),(662,-827265600,3),(662,-752274000,2),(662,-733780800,3),(662,-197326800,2),(662,-190843200,3),(662,-184194000,2),(662,-164491200,3),(662,-152658000,2),(662,-132955200,3),(662,-121122000,2),(662,-101419200,3),(662,-86821200,2),(662,-71092800,3),(662,-54766800,2),(662,-39038400,3),(662,-23317200,2),(662,-7588800,5),(662,128142000,4),(662,136605600,5),(662,596948400,4),(662,605066400,5),(662,624423600,4),(662,636516000,2),(662,655963200,3),(662,667796400,2),(662,687499200,3),(662,699418800,2),(662,719380800,4),(662,731469600,5),(662,938919600,3),(662,952052400,5),(662,1085281200,2),(662,1096171200,5),(662,1198983600,4),(662,1205632800,5),(662,2147483647,5),(663,-2147483648,1),(663,-1567453392,2),(663,-1233432000,3),(663,-1222981200,2),(663,-1205956800,3),(663,-1194037200,2),(663,-1172865600,3),(663,-1162501200,2),(663,-1141329600,3),(663,-1130965200,2),(663,-1109793600,3),(663,-1099429200,2),(663,-1078257600,3),(663,-1067806800,2),(663,-1046635200,3),(663,-1036270800,2),(663,-1015099200,3),(663,-1004734800,2),(663,-983563200,3),(663,-973198800,2),(663,-952027200,3),(663,-941576400,2),(663,-931032000,3),(663,-900882000,2),(663,-890337600,3),(663,-833749200,2),(663,-827265600,3),(663,-752274000,2),(663,-733780800,3),(663,-197326800,2),(663,-190843200,3),(663,-184194000,2),(663,-164491200,3),(663,-152658000,2),(663,-132955200,3),(663,-121122000,2),(663,-101419200,3),(663,-86821200,2),(663,-71092800,3),(663,-54766800,2),(663,-39038400,3),(663,-23317200,2),(663,-7588800,5),(663,128142000,4),(663,136605600,5),(663,596948400,4),(663,605066400,5),(663,624423600,4),(663,636516000,5),(663,656478000,4),(663,667965600,5),(663,687927600,4),(663,699415200,5),(663,719377200,4),(663,731469600,5),(663,938919600,3),(663,952052400,5),(663,1086058800,2),(663,1087704000,5),(663,1198983600,4),(663,1205632800,5),(663,2147483647,5),(664,-2147483648,1),(664,-1567453392,2),(664,-1233432000,3),(664,-1222981200,2),(664,-1205956800,3),(664,-1194037200,2),(664,-1172865600,3),(664,-1162501200,2),(664,-1141329600,3),(664,-1130965200,2),(664,-1109793600,3),(664,-1099429200,2),(664,-1078257600,3),(664,-1067806800,2),(664,-1046635200,3),(664,-1036270800,2),(664,-1015099200,3),(664,-1004734800,2),(664,-983563200,3),(664,-973198800,2),(664,-952027200,3),(664,-941576400,2),(664,-931032000,3),(664,-900882000,2),(664,-890337600,3),(664,-833749200,2),(664,-827265600,3),(664,-752274000,2),(664,-733780800,3),(664,-197326800,2),(664,-190843200,3),(664,-184194000,2),(664,-164491200,3),(664,-152658000,2),(664,-132955200,3),(664,-121122000,2),(664,-101419200,3),(664,-86821200,2),(664,-71092800,3),(664,-54766800,2),(664,-39038400,3),(664,-23317200,2),(664,-7588800,5),(664,128142000,4),(664,136605600,5),(664,596948400,4),(664,605066400,5),(664,624423600,4),(664,636516000,5),(664,656478000,4),(664,667965600,2),(664,687931200,4),(664,699415200,5),(664,719377200,4),(664,731469600,5),(664,938919600,3),(664,952052400,5),(664,1198983600,4),(664,1205632800,5),(664,2147483647,5),(665,-2147483648,1),(665,-1567453392,2),(665,-1233432000,3),(665,-1222981200,2),(665,-1205956800,3),(665,-1194037200,2),(665,-1172865600,3),(665,-1162501200,2),(665,-1141329600,3),(665,-1130965200,2),(665,-1109793600,3),(665,-1099429200,2),(665,-1078257600,3),(665,-1067806800,2),(665,-1046635200,3),(665,-1036270800,2),(665,-1015099200,3),(665,-1004734800,2),(665,-983563200,3),(665,-973198800,2),(665,-952027200,3),(665,-941576400,2),(665,-931032000,3),(665,-900882000,2),(665,-890337600,3),(665,-833749200,2),(665,-827265600,3),(665,-752274000,2),(665,-733780800,3),(665,-197326800,2),(665,-190843200,3),(665,-184194000,2),(665,-164491200,3),(665,-152658000,2),(665,-132955200,3),(665,-121122000,2),(665,-101419200,3),(665,-86821200,2),(665,-71092800,3),(665,-54766800,2),(665,-39038400,3),(665,-23317200,2),(665,-7588800,5),(665,128142000,4),(665,136605600,5),(665,596948400,4),(665,605066400,5),(665,624423600,4),(665,636516000,5),(665,656478000,4),(665,667792800,2),(665,673588800,5),(665,687927600,4),(665,699415200,5),(665,719377200,4),(665,731469600,5),(665,938919600,3),(665,952052400,5),(665,1085972400,2),(665,1090728000,5),(665,1198983600,4),(665,1205632800,5),(665,2147483647,5),(666,-2147483648,1),(666,-1567453392,2),(666,-1233432000,3),(666,-1222981200,2),(666,-1205956800,3),(666,-1194037200,2),(666,-1172865600,3),(666,-1162501200,2),(666,-1141329600,3),(666,-1130965200,2),(666,-1109793600,3),(666,-1099429200,2),(666,-1078257600,3),(666,-1067806800,2),(666,-1046635200,3),(666,-1036270800,2),(666,-1015099200,3),(666,-1004734800,2),(666,-983563200,3),(666,-973198800,2),(666,-952027200,3),(666,-941576400,2),(666,-931032000,3),(666,-900882000,2),(666,-890337600,3),(666,-833749200,2),(666,-827265600,3),(666,-752274000,2),(666,-733780800,3),(666,-197326800,2),(666,-190843200,3),(666,-184194000,2),(666,-164491200,3),(666,-152658000,2),(666,-132955200,3),(666,-121122000,2),(666,-101419200,3),(666,-86821200,2),(666,-71092800,3),(666,-54766800,2),(666,-39038400,3),(666,-23317200,2),(666,-7588800,5),(666,128142000,4),(666,136605600,5),(666,596948400,4),(666,605066400,5),(666,624423600,4),(666,637380000,2),(666,655963200,3),(666,667796400,2),(666,675748800,5),(666,938919600,3),(666,952052400,5),(666,1085972400,2),(666,1090728000,5),(666,1198983600,4),(666,1200880800,3),(666,1205031600,2),(666,1223784000,3),(666,1236481200,2),(666,1255233600,5),(666,2147483647,5),(667,-2147483648,1),(667,-1567453392,2),(667,-1233432000,3),(667,-1222981200,2),(667,-1205956800,3),(667,-1194037200,2),(667,-1172865600,3),(667,-1162501200,2),(667,-1141329600,3),(667,-1130965200,2),(667,-1109793600,3),(667,-1099429200,2),(667,-1078257600,3),(667,-1067806800,2),(667,-1046635200,3),(667,-1036270800,2),(667,-1015099200,3),(667,-1004734800,2),(667,-983563200,3),(667,-973198800,2),(667,-952027200,3),(667,-941576400,2),(667,-931032000,3),(667,-900882000,2),(667,-890337600,3),(667,-833749200,2),(667,-827265600,3),(667,-752274000,2),(667,-733780800,3),(667,-197326800,2),(667,-190843200,3),(667,-184194000,2),(667,-164491200,3),(667,-152658000,2),(667,-132955200,3),(667,-121122000,2),(667,-101419200,3),(667,-86821200,2),(667,-71092800,3),(667,-54766800,2),(667,-39038400,3),(667,-23317200,2),(667,-7588800,5),(667,128142000,4),(667,136605600,5),(667,596948400,4),(667,605066400,5),(667,624423600,4),(667,636516000,5),(667,656478000,4),(667,667965600,2),(667,687931200,4),(667,699415200,5),(667,719377200,4),(667,731469600,5),(667,938919600,3),(667,952052400,5),(667,1086058800,2),(667,1087099200,5),(667,1198983600,4),(667,1205632800,5),(667,1224385200,4),(667,1237082400,5),(667,2147483647,5),(668,-2147483648,1),(668,-1567453392,2),(668,-1233432000,3),(668,-1222981200,2),(668,-1205956800,3),(668,-1194037200,2),(668,-1172865600,3),(668,-1162501200,2),(668,-1141329600,3),(668,-1130965200,2),(668,-1109793600,3),(668,-1099429200,2),(668,-1078257600,3),(668,-1067806800,2),(668,-1046635200,3),(668,-1036270800,2),(668,-1015099200,3),(668,-1004734800,2),(668,-983563200,3),(668,-973198800,2),(668,-952027200,3),(668,-941576400,2),(668,-931032000,3),(668,-900882000,2),(668,-890337600,3),(668,-833749200,2),(668,-827265600,3),(668,-752274000,2),(668,-733780800,3),(668,-197326800,2),(668,-190843200,3),(668,-184194000,2),(668,-164491200,3),(668,-152658000,2),(668,-132955200,3),(668,-121122000,2),(668,-101419200,3),(668,-86821200,2),(668,-71092800,3),(668,-54766800,2),(668,-39038400,3),(668,-23317200,2),(668,-7588800,5),(668,128142000,4),(668,136605600,5),(668,596948400,4),(668,605066400,5),(668,624423600,4),(668,636516000,5),(668,656478000,4),(668,667965600,5),(668,687927600,4),(668,699415200,5),(668,719377200,4),(668,731469600,5),(668,938919600,3),(668,952052400,5),(668,1085886000,2),(668,1087704000,5),(668,1198983600,4),(668,1205632800,5),(668,2147483647,5),(669,-2147483648,1),(669,-873057600,3),(669,-769395600,2),(669,-765399600,1),(670,-2147483648,1),(670,-1206389360,2),(670,86760000,3),(670,134017200,2),(670,181368000,4),(670,194497200,2),(670,212990400,4),(670,226033200,2),(670,244526400,4),(670,257569200,2),(670,276062400,4),(670,291783600,2),(670,307598400,4),(670,323406000,2),(670,339220800,4),(670,354942000,2),(670,370756800,4),(670,386478000,2),(670,402292800,4),(670,418014000,2),(670,433828800,4),(670,449636400,2),(670,465451200,4),(670,481172400,2),(670,496987200,4),(670,512708400,2),(670,528523200,4),(670,544244400,2),(670,560059200,4),(670,575866800,2),(670,591681600,4),(670,607402800,2),(670,625032000,4),(670,638938800,2),(670,654753600,4),(670,670474800,2),(670,686721600,4),(670,699418800,2),(670,718257600,4),(670,733546800,2),(670,749448000,4),(670,762318000,2),(670,780984000,4),(670,793767600,2),(670,812520000,4),(670,825649200,2),(670,844574400,4),(670,856666800,2),(670,876024000,4),(670,888721200,2),(670,907473600,4),(670,920775600,2),(670,938923200,4),(670,952225200,2),(670,970372800,4),(670,983674800,2),(670,1002427200,4),(670,1018148400,2),(670,1030852800,4),(670,1049598000,2),(670,1062907200,4),(670,1081047600,2),(670,1097985600,4),(670,1110682800,2),(670,1129435200,4),(670,1142132400,2),(670,1160884800,4),(670,1173582000,2),(670,1192939200,4),(670,1205031600,2),(670,1224388800,4),(670,1236481200,2),(670,1255838400,4),(670,1270954800,2),(670,1286078400,4),(670,1302404400,2),(670,1317528000,4),(670,1333854000,2),(670,1349582400,4),(670,1364094000,2),(670,1381032000,4),(670,1395543600,2),(670,1412481600,4),(670,1426993200,2),(670,1443931200,4),(670,1459047600,2),(670,1475380800,4),(670,1490497200,2),(670,1506830400,4),(670,1521946800,2),(670,1538884800,4),(670,1553396400,2),(670,1570334400,4),(670,1584846000,2),(670,1601784000,4),(670,1616900400,2),(670,1633233600,4),(670,1648350000,2),(670,1664683200,4),(670,1679799600,2),(670,1696132800,4),(670,1711249200,2),(670,1728187200,4),(670,1742698800,2),(670,1759636800,4),(670,1774148400,2),(670,1791086400,4),(670,1806202800,2),(670,1822536000,4),(670,1837652400,2),(670,1853985600,4),(670,1869102000,2),(670,1886040000,4),(670,1900551600,2),(670,1917489600,4),(670,1932001200,2),(670,1948939200,4),(670,1964055600,2),(670,1980388800,4),(670,1995505200,2),(670,2011838400,4),(670,2026954800,2),(670,2043288000,4),(670,2058404400,2),(670,2075342400,4),(670,2089854000,2),(670,2106792000,4),(670,2121303600,2),(670,2138241600,4),(670,2147483647,4),(671,-2147483648,1),(671,-1946918424,2),(672,-2147483648,1),(672,-880196400,2),(672,-769395600,3),(672,-765374400,1),(672,-86878800,4),(672,-21466800,5),(672,-5745600,4),(672,9982800,5),(672,25704000,4),(672,41432400,5),(672,57758400,4),(672,73486800,5),(672,89208000,4),(672,104936400,5),(672,120657600,4),(672,126709200,5),(672,152107200,4),(672,162392400,5),(672,183556800,4),(672,199285200,5),(672,215611200,4),(672,230734800,5),(672,247060800,4),(672,262789200,5),(672,278510400,4),(672,294238800,5),(672,309960000,4),(672,325688400,5),(672,341409600,4),(672,357138000,5),(672,372859200,4),(672,388587600,5),(672,404913600,4),(672,420037200,5),(672,436363200,6),(672,439034400,8),(672,452088000,7),(672,467809200,8),(672,483537600,7),(672,499258800,8),(672,514987200,7),(672,530708400,8),(672,544622400,7),(672,562158000,8),(672,576072000,7),(672,594212400,8),(672,607521600,7),(672,625662000,8),(672,638971200,7),(672,657111600,8),(672,671025600,7),(672,688561200,8),(672,702475200,7),(672,720010800,8),(672,733924800,7),(672,752065200,8),(672,765374400,7),(672,783514800,8),(672,796824000,7),(672,814964400,8),(672,828878400,7),(672,846414000,8),(672,860328000,7),(672,877863600,8),(672,891777600,7),(672,909313200,8),(672,923227200,7),(672,941367600,8),(672,954676800,7),(672,972817200,8),(672,986126400,7),(672,1004266800,8),(672,1018180800,7),(672,1035716400,8),(672,1049630400,7),(672,1067166000,8),(672,1081080000,7),(672,1099220400,8),(672,1112529600,7),(672,1130670000,8),(672,1143979200,7),(672,1162119600,8),(672,1173614400,7),(672,1194174000,8),(672,1205064000,7),(672,1225623600,8),(672,1236513600,7),(672,1257073200,8),(672,1268568000,7),(672,1289127600,8),(672,1300017600,7),(672,1320577200,8),(672,1331467200,7),(672,1352026800,8),(672,1362916800,7),(672,1383476400,8),(672,1394366400,7),(672,1414926000,8),(672,1425816000,7),(672,1446375600,8),(672,1457870400,7),(672,1478430000,8),(672,1489320000,7),(672,1509879600,8),(672,1520769600,7),(672,1541329200,8),(672,1552219200,7),(672,1572778800,8),(672,1583668800,7),(672,1604228400,8),(672,1615723200,7),(672,1636282800,8),(672,1647172800,7),(672,1667732400,8),(672,1678622400,7),(672,1699182000,8),(672,1710072000,7),(672,1730631600,8),(672,1741521600,7),(672,1762081200,8),(672,1772971200,7),(672,1793530800,8),(672,1805025600,7),(672,1825585200,8),(672,1836475200,7),(672,1857034800,8),(672,1867924800,7),(672,1888484400,8),(672,1899374400,7),(672,1919934000,8),(672,1930824000,7),(672,1951383600,8),(672,1962878400,7),(672,1983438000,8),(672,1994328000,7),(672,2014887600,8),(672,2025777600,7),(672,2046337200,8),(672,2057227200,7),(672,2077786800,8),(672,2088676800,7),(672,2109236400,8),(672,2120126400,7),(672,2140686000,8),(673,-2147483648,0),(673,-1767216356,2),(673,-1206957600,1),(673,-1191362400,2),(673,-1175374800,1),(673,-1159826400,2),(673,-633819600,1),(673,-622069200,2),(673,-602283600,1),(673,-591832800,2),(673,-570747600,1),(673,-560210400,2),(673,-539125200,1),(673,-531352800,2),(673,-191365200,1),(673,-184197600,2),(673,-155163600,1),(673,-150069600,2),(673,-128898000,1),(673,-121125600,2),(673,-99954000,1),(673,-89589600,2),(673,-68418000,1),(673,-57967200,2),(673,499748400,1),(673,511236000,2),(673,530593200,1),(673,540266400,2),(673,562129200,1),(673,571197600,2),(673,592974000,1),(673,602042400,2),(673,624423600,1),(673,634701600,2),(673,656478000,1),(673,666756000,2),(673,687927600,1),(673,697600800,2),(673,719982000,1),(673,728445600,2),(673,750826800,1),(673,761709600,2),(673,782276400,1),(673,793159200,2),(673,813726000,1),(673,824004000,2),(673,844570800,1),(673,856058400,2),(673,876106800,1),(673,888717600,2),(673,908074800,1),(673,919562400,2),(673,938919600,1),(673,951616800,2),(673,970974000,1),(673,982461600,2),(673,1003028400,1),(673,1013911200,2),(673,1036292400,1),(673,1045360800,2),(673,1318734000,1),(673,1330221600,2),(673,2147483647,2),(674,-2147483648,0),(674,-1514739600,1),(674,-1343066400,2),(674,-1234807200,4),(674,-1220292000,3),(674,-1207159200,4),(674,-1191344400,2),(674,-873828000,4),(674,-661539600,5),(674,28800,4),(674,828867600,3),(674,846403200,4),(674,860317200,3),(674,877852800,4),(674,891766800,3),(674,909302400,4),(674,923216400,3),(674,941356800,4),(674,954666000,3),(674,972806400,4),(674,989139600,3),(674,1001836800,4),(674,1018170000,3),(674,1035705600,4),(674,1049619600,3),(674,1067155200,4),(674,1081069200,3),(674,1099209600,4),(674,1112518800,3),(674,1130659200,4),(674,1143968400,3),(674,1162108800,4),(674,1175418000,3),(674,1193558400,4),(674,1207472400,3),(674,1225008000,4),(674,1238922000,3),(674,1256457600,4),(674,1270371600,6),(674,1288508400,2),(674,1301817600,6),(674,1319958000,2),(674,1333267200,6),(674,1351407600,2),(674,1365321600,6),(674,1382857200,2),(674,1396771200,6),(674,1414306800,2),(674,1428220800,6),(674,1445756400,2),(674,1459670400,6),(674,1477810800,2),(674,1491120000,6),(674,1509260400,2),(674,1522569600,6),(674,1540710000,2),(674,1554624000,6),(674,1572159600,2),(674,1586073600,6),(674,1603609200,2),(674,1617523200,6),(674,1635663600,2),(674,1648972800,6),(674,1667113200,2),(675,-2147483648,0),(675,-1841256091,3),(675,-874263600,1),(675,-862682400,2),(675,-841604400,1),(675,-830714400,2),(675,-820526400,3),(675,-811882800,4),(675,-798660000,2),(675,-788904000,3),(675,234943200,5),(675,244616400,3),(675,261554400,5),(675,276066000,3),(675,293004000,5),(675,307515600,3),(675,325058400,5),(675,338706000,3),(676,-2147483648,0),(676,-1767213964,2),(676,-1206957600,1),(676,-1191362400,2),(676,-1175374800,1),(676,-1159826400,2),(676,-633819600,1),(676,-622069200,2),(676,-602283600,1),(676,-591832800,2),(676,-570747600,1),(676,-560210400,2),(676,-539125200,1),(676,-531352800,2),(676,-191365200,1),(676,-184197600,2),(676,-155163600,1),(676,-150069600,2),(676,-128898000,1),(676,-121125600,2),(676,-99954000,1),(676,-89589600,2),(676,-68418000,1),(676,-57967200,2),(676,499748400,1),(676,511236000,2),(676,530593200,1),(676,540266400,2),(676,562129200,1),(676,571197600,2),(676,2147483647,2),(677,-2147483648,0),(677,-1822500432,2),(677,-1616954400,1),(677,-1606069800,2),(677,-1585504800,1),(677,-1574015400,2),(677,-1554055200,1),(677,-1542565800,2),(677,-1522605600,1),(677,-1511116200,2),(677,-1490551200,1),(677,-1479666600,2),(677,-1459101600,1),(677,-1448217000,2),(677,-1427652000,1),(677,-1416162600,2),(677,-1396202400,1),(677,-1384713000,2),(677,-1364752800,1),(677,-1353263400,2),(677,-1333303200,1),(677,-1321813800,2),(677,-1301248800,1),(677,-1290364200,2),(677,-1269799200,1),(677,-1258914600,2),(677,-1238349600,1),(677,-1226860200,2),(677,-1206900000,1),(677,-1195410600,2),(677,-1175450400,1),(677,-1163961000,2),(677,-1143396000,1),(677,-1132511400,2),(677,-1111946400,1),(677,-1101061800,2),(677,-1080496800,1),(677,-1069612200,2),(677,-1049047200,1),(677,-1037557800,2),(677,-1017597600,1),(677,-1006108200,2),(677,-986148000,1),(677,-974658600,2),(677,-954093600,1),(677,-943209000,2),(677,-922644000,1),(677,-911759400,2),(677,-891194400,1),(677,-879705000,2),(677,-868212000,3),(677,-769395600,4),(677,-758746800,2),(677,-701892000,1),(677,-690402600,2),(677,-670442400,1),(677,-658953000,2),(677,-638992800,1),(677,-627503400,2),(677,-606938400,1),(677,-596053800,2),(677,-575488800,1),(677,-564604200,2),(677,-544039200,1),(677,-532549800,2),(677,-512589600,1),(677,-501100200,2),(677,-481140000,1),(677,-469650600,2),(677,-449690400,1),(677,-438201000,2),(677,-417636000,1),(677,-406751400,2),(677,-386186400,1),(677,-375301800,2),(677,-354736800,1),(677,-343247400,2),(677,-323287200,1),(677,-311797800,2),(677,-291837600,1),(677,-280348200,2),(677,-259783200,1),(677,-248898600,2),(677,-228333600,1),(677,-217449000,2),(677,-196884000,1),(677,-185999400,2),(677,-165434400,1),(677,-153945000,2),(677,-133984800,1),(677,-122495400,2),(677,-102535200,1),(677,-91045800,2),(677,-70480800,1),(677,-59596200,2),(677,123919200,5),(677,129618000,2),(677,409039200,5),(677,413874000,2),(678,-2147483648,1),(678,-873057600,3),(678,-769395600,2),(678,-765399600,1),(679,-2147483648,0),(679,-1767211040,2),(679,-1206954000,1),(679,-1191358800,2),(679,-1175371200,1),(679,-1159822800,2),(679,-633816000,1),(679,-622065600,2),(679,-602280000,1),(679,-591829200,2),(679,-570744000,1),(679,-560206800,2),(679,-539121600,1),(679,-531349200,2),(679,-191361600,1),(679,-184194000,2),(679,-155160000,1),(679,-150066000,2),(679,-128894400,1),(679,-121122000,2),(679,-99950400,1),(679,-89586000,2),(679,-68414400,1),(679,-57963600,2),(679,499752000,1),(679,511239600,2),(679,530596800,1),(679,540270000,2),(679,562132800,1),(679,571201200,2),(679,938923200,1),(679,951620400,2),(679,970977600,1),(679,971578800,2),(679,2147483647,2),(680,-2147483648,1),(680,-1739041424,3),(680,704869200,2),(680,729057600,3),(680,2147483647,3),(681,-2147483648,3),(681,-1633269600,1),(681,-1615129200,2),(681,-1601820000,1),(681,-1583679600,2),(681,-1471788000,6),(681,-880210800,4),(681,-769395600,5),(681,-765388800,6),(681,-84380400,7),(681,-68659200,6),(681,-52930800,7),(681,-37209600,6),(681,-21481200,7),(681,-5760000,6),(681,9968400,7),(681,25689600,6),(681,41418000,7),(681,57744000,6),(681,73472400,7),(681,89193600,6),(681,104922000,7),(681,120643200,6),(681,129114000,7),(681,152092800,6),(681,162378000,7),(681,183542400,6),(681,199270800,7),(681,215596800,6),(681,230720400,7),(681,247046400,6),(681,262774800,7),(681,278496000,6),(681,294224400,7),(681,309945600,6),(681,325674000,7),(681,341395200,6),(681,357123600,7),(681,372844800,6),(681,388573200,7),(681,404899200,6),(681,420022800,7),(681,436348800,6),(681,452077200,7),(681,467798400,6),(681,483526800,7),(681,499248000,6),(681,514976400,7),(681,530697600,6),(681,544611600,7),(681,562147200,6),(681,576061200,7),(681,594201600,6),(681,607510800,7),(681,625651200,6),(681,638960400,7),(681,657100800,6),(681,671014800,7),(681,688550400,6),(681,702464400,7),(681,720000000,6),(681,733914000,7),(681,752054400,6),(681,765363600,7),(681,783504000,6),(681,796813200,7),(681,814953600,6),(681,828867600,7),(681,846403200,6),(681,860317200,7),(681,877852800,6),(681,891766800,7),(681,909302400,6),(681,923216400,7),(681,941356800,6),(681,954666000,7),(681,972806400,6),(681,986115600,7),(681,1004256000,6),(681,1018170000,7),(681,1035705600,6),(681,1049619600,7),(681,1067155200,6),(681,1081069200,7),(681,1099209600,6),(681,1112518800,7),(681,1130659200,6),(681,1143968400,7),(681,1162108800,6),(681,1173603600,7),(681,1194163200,6),(681,1205053200,7),(681,1225612800,6),(681,1236502800,7),(681,1257062400,6),(681,1268557200,7),(681,1289116800,6),(681,1300006800,7),(681,1320566400,6),(681,1331456400,7),(681,1352016000,6),(681,1362906000,7),(681,1383465600,6),(681,1394355600,7),(681,1414915200,6),(681,1425805200,7),(681,1446364800,6),(681,1457859600,7),(681,1478419200,6),(681,1489309200,7),(681,1509868800,6),(681,1520758800,7),(681,1541318400,6),(681,1552208400,7),(681,1572768000,6),(681,1583658000,7),(681,1604217600,6),(681,1615712400,7),(681,1636272000,6),(681,1647162000,7),(681,1667721600,6),(681,1678611600,7),(681,1699171200,6),(681,1710061200,7),(681,1730620800,6),(681,1741510800,7),(681,1762070400,6),(681,1772960400,7),(681,1793520000,6),(681,1805014800,7),(681,1825574400,6),(681,1836464400,7),(681,1857024000,6),(681,1867914000,7),(681,1888473600,6),(681,1899363600,7),(681,1919923200,6),(681,1930813200,7),(681,1951372800,6),(681,1962867600,7),(681,1983427200,6),(681,1994317200,7),(681,2014876800,6),(681,2025766800,7),(681,2046326400,6),(681,2057216400,7),(681,2077776000,6),(681,2088666000,7),(681,2109225600,6),(681,2120115600,7),(681,2140675200,6),(682,-2147483648,1),(682,-1567453392,2),(682,-1233432000,3),(682,-1222981200,2),(682,-1205956800,3),(682,-1194037200,2),(682,-1172865600,3),(682,-1162501200,2),(682,-1141329600,3),(682,-1130965200,2),(682,-1109793600,3),(682,-1099429200,2),(682,-1078257600,3),(682,-1067806800,2),(682,-1046635200,3),(682,-1036270800,2),(682,-1015099200,3),(682,-1004734800,2),(682,-983563200,3),(682,-973198800,2),(682,-952027200,3),(682,-941576400,2),(682,-931032000,3),(682,-900882000,2),(682,-890337600,3),(682,-833749200,2),(682,-827265600,3),(682,-752274000,2),(682,-733780800,3),(682,-197326800,2),(682,-190843200,3),(682,-184194000,2),(682,-164491200,3),(682,-152658000,2),(682,-132955200,3),(682,-121122000,2),(682,-101419200,3),(682,-86821200,2),(682,-71092800,3),(682,-54766800,2),(682,-39038400,3),(682,-23317200,2),(682,-7588800,5),(682,128142000,4),(682,136605600,5),(682,596948400,4),(682,605066400,5),(682,624423600,4),(682,636516000,5),(682,656478000,4),(682,667965600,5),(682,687927600,4),(682,699415200,5),(682,719377200,4),(682,731469600,5),(682,938919600,3),(682,952052400,5),(682,1198983600,4),(682,1205632800,5),(682,1224385200,4),(682,1237082400,5),(682,2147483647,5),(683,-2147483648,0),(683,-1577923200,3),(683,-880210800,1),(683,-769395600,2),(683,-765388800,3),(683,73472400,4),(683,89193600,3),(683,104922000,4),(683,120643200,3),(683,136371600,4),(683,152092800,3),(683,167821200,4),(683,183542400,3),(683,199270800,4),(683,215596800,3),(683,230720400,4),(683,247046400,3),(683,262774800,4),(683,278496000,3),(683,294224400,4),(683,309945600,3),(683,325674000,4),(683,341395200,3),(683,357123600,4),(683,372844800,3),(683,388573200,4),(683,404899200,3),(683,420022800,4),(683,436348800,3),(683,452077200,4),(683,467798400,3),(683,483526800,4),(683,499248000,3),(683,514976400,4),(683,530697600,3),(683,544611600,4),(683,562147200,3),(683,576061200,4),(683,594201600,3),(683,607510800,4),(683,625651200,3),(683,638960400,4),(683,657100800,3),(683,671014800,4),(683,688550400,3),(683,702464400,4),(683,720000000,3),(683,733914000,4),(683,752054400,3),(683,765363600,4),(683,783504000,3),(683,796813200,4),(683,814953600,3),(683,828867600,4),(683,846403200,3),(683,860317200,4),(683,877852800,3),(683,891766800,4),(683,909302400,3),(683,923216400,4),(683,941356800,6),(683,954662400,5),(683,972802800,7),(683,973400400,6),(683,986115600,4),(683,1004256000,3),(683,1018170000,4),(683,1035705600,3),(683,1049619600,4),(683,1067155200,3),(683,1081069200,4),(683,1099209600,3),(683,1112518800,4),(683,1130659200,3),(683,1143968400,4),(683,1162108800,3),(683,1173603600,4),(683,1194163200,3),(683,1205053200,4),(683,1225612800,3),(683,1236502800,4),(683,1257062400,3),(683,1268557200,4),(683,1289116800,3),(683,1300006800,4),(683,1320566400,3),(683,1331456400,4),(683,1352016000,3),(683,1362906000,4),(683,1383465600,3),(683,1394355600,4),(683,1414915200,3),(683,1425805200,4),(683,1446364800,3),(683,1457859600,4),(683,1478419200,3),(683,1489309200,4),(683,1509868800,3),(683,1520758800,4),(683,1541318400,3),(683,1552208400,4),(683,1572768000,3),(683,1583658000,4),(683,1604217600,3),(683,1615712400,4),(683,1636272000,3),(683,1647162000,4),(683,1667721600,3),(683,1678611600,4),(683,1699171200,3),(683,1710061200,4),(683,1730620800,3),(683,1741510800,4),(683,1762070400,3),(683,1772960400,4),(683,1793520000,3),(683,1805014800,4),(683,1825574400,3),(683,1836464400,4),(683,1857024000,3),(683,1867914000,4),(683,1888473600,3),(683,1899363600,4),(683,1919923200,3),(683,1930813200,4),(683,1951372800,3),(683,1962867600,4),(683,1983427200,3),(683,1994317200,4),(683,2014876800,3),(683,2025766800,4),(683,2046326400,3),(683,2057216400,4),(683,2077776000,3),(683,2088666000,4),(683,2109225600,3),(683,2120115600,4),(683,2140675200,3),(684,-2147483648,0),(684,-1767212492,2),(684,-1206954000,1),(684,-1191358800,2),(684,-1175371200,1),(684,-1159822800,2),(684,-633816000,1),(684,-622065600,2),(684,-602280000,1),(684,-591829200,2),(684,-570744000,1),(684,-560206800,2),(684,-539121600,1),(684,-531349200,2),(684,-191361600,1),(684,-184194000,2),(684,-155160000,1),(684,-150066000,2),(684,-128894400,1),(684,-121122000,2),(684,-99950400,1),(684,-89586000,2),(684,-68414400,1),(684,-57963600,2),(684,499752000,1),(684,511239600,2),(684,530596800,1),(684,540270000,2),(684,562132800,1),(684,571201200,2),(684,592977600,1),(684,602046000,2),(684,624427200,1),(684,634705200,2),(684,656481600,1),(684,666759600,2),(684,687931200,1),(684,697604400,2),(684,719985600,1),(684,728449200,2),(684,750830400,1),(684,761713200,2),(684,782280000,1),(684,793162800,2),(684,813729600,1),(684,824007600,2),(684,844574400,1),(684,856062000,2),(684,876110400,1),(684,888721200,2),(684,908078400,1),(684,919566000,2),(684,938923200,1),(684,951620400,2),(684,970977600,1),(684,982465200,2),(684,1003032000,1),(684,1013914800,2),(684,1036296000,1),(684,1045364400,2),(684,1066536000,1),(684,1076814000,2),(684,1099368000,1),(684,1108868400,2),(684,1129435200,1),(684,1140318000,2),(684,1162699200,1),(684,1172372400,2),(684,1192334400,1),(684,1203217200,2),(684,1224388800,1),(684,1234666800,2),(684,1255838400,1),(684,1266721200,2),(684,1287288000,1),(684,1298170800,2),(684,1318737600,1),(684,1330225200,2),(684,1350792000,1),(684,1361070000,2),(684,1382241600,1),(684,1392519600,2),(684,1413691200,1),(684,1424574000,2),(684,1445140800,1),(684,1456023600,2),(684,1476590400,1),(684,1487473200,2),(684,1508040000,1),(684,1518922800,2),(684,1541304000,1),(684,1550372400,2),(684,2147483647,2),(685,-2147483648,0),(685,-1514743200,1),(685,377935200,3),(685,828860400,2),(685,846396000,3),(685,860310000,2),(685,877845600,3),(685,891759600,2),(685,902037600,5),(685,909298800,4),(685,923212800,5),(685,941353200,4),(685,954662400,5),(685,972802800,4),(685,989136000,5),(685,1001833200,4),(685,1018166400,5),(685,1035702000,4),(685,1049616000,5),(685,1067151600,4),(685,1081065600,5),(685,1099206000,4),(685,1112515200,5),(685,1130655600,4),(685,1143964800,5),(685,1162105200,4),(685,1175414400,5),(685,1193554800,4),(685,1207468800,5),(685,1225004400,4),(685,1238918400,5),(685,1256454000,4),(685,1270368000,5),(685,1288508400,4),(685,1301817600,5),(685,1319958000,4),(685,1333267200,5),(685,1351407600,4),(685,1365321600,5),(685,1382857200,4),(685,1396771200,5),(685,1414306800,4),(685,1422777600,3),(686,-2147483648,1),(686,-1826739140,2),(686,-157750200,3),(686,1197183600,2),(686,1462086000,3),(686,2147483647,3),(687,-2147483648,1),(687,-1567453392,2),(687,-1233432000,3),(687,-1222981200,2),(687,-1205956800,3),(687,-1194037200,2),(687,-1172865600,3),(687,-1162501200,2),(687,-1141329600,3),(687,-1130965200,2),(687,-1109793600,3),(687,-1099429200,2),(687,-1078257600,3),(687,-1067806800,2),(687,-1046635200,3),(687,-1036270800,2),(687,-1015099200,3),(687,-1004734800,2),(687,-983563200,3),(687,-973198800,2),(687,-952027200,3),(687,-941576400,2),(687,-931032000,3),(687,-900882000,2),(687,-890337600,3),(687,-833749200,2),(687,-827265600,3),(687,-752274000,2),(687,-733780800,3),(687,-197326800,2),(687,-190843200,3),(687,-184194000,2),(687,-164491200,3),(687,-152658000,2),(687,-132955200,3),(687,-121122000,2),(687,-101419200,3),(687,-86821200,2),(687,-71092800,3),(687,-54766800,2),(687,-39038400,3),(687,-23317200,2),(687,-7588800,5),(687,128142000,4),(687,136605600,5),(687,596948400,4),(687,605066400,5),(687,624423600,4),(687,636516000,5),(687,656478000,4),(687,667965600,2),(687,687931200,4),(687,699415200,5),(687,719377200,4),(687,731469600,5),(687,938919600,3),(687,952052400,5),(687,1086058800,2),(687,1087704000,5),(687,1198983600,4),(687,1205632800,5),(687,2147483647,5),(688,-2147483648,0),(688,-1846269040,1),(688,-71092800,2),(688,2147483647,2),(689,-2147483648,1),(689,-1946918424,2),(690,-2147483648,3),(690,-1633276800,1),(690,-1615136400,2),(690,-1601827200,1),(690,-1583686800,2),(690,-1563724800,1),(690,-1551632400,2),(690,-1538928000,1),(690,-1520182800,2),(690,-1504454400,1),(690,-1491757200,2),(690,-1473004800,1),(690,-1459702800,2),(690,-1441555200,1),(690,-1428253200,2),(690,-1410105600,1),(690,-1396803600,2),(690,-1378656000,1),(690,-1365354000,2),(690,-1347206400,1),(690,-1333904400,2),(690,-1315152000,1),(690,-1301850000,2),(690,-1283702400,1),(690,-1270400400,2),(690,-1252252800,1),(690,-1238950800,2),(690,-1220803200,1),(690,-1207501200,2),(690,-1189353600,1),(690,-1176051600,2),(690,-1157299200,1),(690,-1144602000,2),(690,-1125849600,1),(690,-1112547600,2),(690,-1094400000,1),(690,-1081098000,2),(690,-1067788800,4),(690,-1045414800,2),(690,-1031500800,1),(690,-1018198800,2),(690,-1000051200,1),(690,-986749200,2),(690,-967996800,1),(690,-955299600,2),(690,-936547200,1),(690,-923245200,2),(690,-905097600,1),(690,-891795600,2),(690,-880214400,5),(690,-769395600,6),(690,-765392400,2),(690,-747244800,1),(690,-733942800,2),(690,-715795200,1),(690,-702493200,2),(690,-684345600,1),(690,-671043600,2),(690,-652896000,1),(690,-639594000,2),(690,-620841600,1),(690,-608144400,2),(690,-589392000,1),(690,-576090000,2),(690,-557942400,1),(690,-544640400,2),(690,-526492800,1),(690,-513190800,2),(690,-495043200,1),(690,-481741200,2),(690,-463593600,1),(690,-447267600,2),(690,-431539200,1),(690,-415818000,2),(690,-400089600,1),(690,-384368400,2),(690,-368640000,1),(690,-352918800,2),(690,-337190400,1),(690,-321469200,2),(690,-305740800,1),(690,-289414800,2),(690,-273686400,1),(690,-257965200,2),(690,-242236800,1),(690,-226515600,2),(690,-210787200,1),(690,-195066000,2),(690,-179337600,1),(690,-163616400,2),(690,-147888000,1),(690,-131562000,2),(690,-116438400,1),(690,-100112400,2),(690,-84384000,1),(690,-68662800,2),(690,-52934400,1),(690,-37213200,2),(690,-21484800,1),(690,-5763600,2),(690,9964800,1),(690,25686000,2),(690,41414400,1),(690,57740400,2),(690,73468800,1),(690,89190000,2),(690,104918400,1),(690,120639600,2),(690,126691200,1),(690,152089200,2),(690,162374400,1),(690,183538800,2),(690,199267200,1),(690,215593200,2),(690,230716800,1),(690,247042800,2),(690,262771200,1),(690,278492400,2),(690,294220800,1),(690,309942000,2),(690,325670400,1),(690,341391600,2),(690,357120000,1),(690,372841200,2),(690,388569600,1),(690,404895600,2),(690,420019200,1),(690,436345200,2),(690,452073600,1),(690,467794800,2),(690,483523200,1),(690,499244400,2),(690,514972800,1),(690,530694000,2),(690,544608000,1),(690,562143600,2),(690,576057600,1),(690,594198000,2),(690,607507200,1),(690,625647600,2),(690,638956800,1),(690,657097200,2),(690,671011200,1),(690,688546800,2),(690,702460800,1),(690,719996400,2),(690,733910400,1),(690,752050800,2),(690,765360000,1),(690,783500400,2),(690,796809600,1),(690,814950000,2),(690,828864000,1),(690,846399600,2),(690,860313600,1),(690,877849200,2),(690,891763200,1),(690,909298800,2),(690,923212800,1),(690,941353200,2),(690,954662400,1),(690,972802800,2),(690,986112000,1),(690,1004252400,2),(690,1018166400,1),(690,1035702000,2),(690,1049616000,1),(690,1067151600,2),(690,1081065600,1),(690,1099206000,2),(690,1112515200,1),(690,1130655600,2),(690,1143964800,1),(690,1162105200,2),(690,1173600000,1),(690,1194159600,2),(690,1205049600,1),(690,1225609200,2),(690,1236499200,1),(690,1257058800,2),(690,1268553600,1),(690,1289113200,2),(690,1300003200,1),(690,1320562800,2),(690,1331452800,1),(690,1352012400,2),(690,1362902400,1),(690,1383462000,2),(690,1394352000,1),(690,1414911600,2),(690,1425801600,1),(690,1446361200,2),(690,1457856000,1),(690,1478415600,2),(690,1489305600,1),(690,1509865200,2),(690,1520755200,1),(690,1541314800,2),(690,1552204800,1),(690,1572764400,2),(690,1583654400,1),(690,1604214000,2),(690,1615708800,1),(690,1636268400,2),(690,1647158400,1),(690,1667718000,2),(690,1678608000,1),(690,1699167600,2),(690,1710057600,1),(690,1730617200,2),(690,1741507200,1),(690,1762066800,2),(690,1772956800,1),(690,1793516400,2),(690,1805011200,1),(690,1825570800,2),(690,1836460800,1),(690,1857020400,2),(690,1867910400,1),(690,1888470000,2),(690,1899360000,1),(690,1919919600,2),(690,1930809600,1),(690,1951369200,2),(690,1962864000,1),(690,1983423600,2),(690,1994313600,1),(690,2014873200,2),(690,2025763200,1),(690,2046322800,2),(690,2057212800,1),(690,2077772400,2),(690,2088662400,1),(690,2109222000,2),(690,2120112000,1),(690,2140671600,2),(691,-2147483648,0),(691,-1514739600,1),(691,-1343066400,2),(691,-1234807200,4),(691,-1220292000,3),(691,-1207159200,4),(691,-1191344400,2),(691,828864000,5),(691,846399600,2),(691,860313600,5),(691,877849200,2),(691,891766800,3),(691,909302400,4),(691,923216400,3),(691,941356800,4),(691,954666000,3),(691,972806400,4),(691,989139600,3),(691,1001836800,4),(691,1018170000,3),(691,1035705600,4),(691,1049619600,3),(691,1067155200,4),(691,1081069200,3),(691,1099209600,4),(691,1112518800,3),(691,1130659200,4),(691,1143968400,3),(691,1162108800,4),(691,1175418000,3),(691,1193558400,4),(691,1207472400,3),(691,1225008000,4),(691,1238922000,3),(691,1256457600,4),(691,1270371600,3),(691,1288512000,4),(691,1301821200,3),(691,1319961600,4),(691,1333270800,3),(691,1351411200,4),(691,1365325200,3),(691,1382860800,4),(691,1396774800,3),(691,1414310400,4),(691,1428224400,3),(691,1445760000,4),(691,1459674000,3),(691,1477814400,4),(691,1491123600,3),(691,1509264000,4),(691,1522573200,3),(691,1540713600,4),(691,1554627600,3),(691,1572163200,4),(691,1586077200,3),(691,1603612800,4),(691,1617526800,3),(691,1635667200,4),(691,1648976400,3),(691,1667116800,2),(692,-2147483648,0),(692,-1514739600,1),(692,-1343066400,2),(692,-1234807200,4),(692,-1220292000,3),(692,-1207159200,4),(692,-1191344400,2),(692,828864000,5),(692,846399600,2),(692,860313600,5),(692,877849200,2),(692,891766800,3),(692,909302400,4),(692,923216400,3),(692,941356800,4),(692,954666000,3),(692,972806400,4),(692,989139600,3),(692,1001836800,4),(692,1018170000,3),(692,1035705600,4),(692,1049619600,3),(692,1067155200,4),(692,1081069200,3),(692,1099209600,4),(692,1112518800,3),(692,1130659200,4),(692,1143968400,3),(692,1162108800,4),(692,1175418000,3),(692,1193558400,4),(692,1207472400,3),(692,1225008000,4),(692,1238922000,3),(692,1256457600,4),(692,1268557200,3),(692,1289116800,4),(692,1300006800,3),(692,1320566400,4),(692,1331456400,3),(692,1352016000,4),(692,1362906000,3),(692,1383465600,4),(692,1394355600,3),(692,1414915200,4),(692,1425805200,3),(692,1446364800,4),(692,1457859600,3),(692,1478419200,4),(692,1489309200,3),(692,1509868800,4),(692,1520758800,3),(692,1541318400,4),(692,1552208400,3),(692,1572768000,4),(692,1583658000,3),(692,1604217600,4),(692,1615712400,3),(692,1636272000,4),(692,1647162000,3),(692,1667116800,2),(692,1669788000,4),(692,1678611600,3),(692,1699171200,4),(692,1710061200,3),(692,1730620800,4),(692,1741510800,3),(692,1762070400,4),(692,1772960400,3),(692,1793520000,4),(692,1805014800,3),(692,1825574400,4),(692,1836464400,3),(692,1857024000,4),(692,1867914000,3),(692,1888473600,4),(692,1899363600,3),(692,1919923200,4),(692,1930813200,3),(692,1951372800,4),(692,1962867600,3),(692,1983427200,4),(692,1994317200,3),(692,2014876800,4),(692,2025766800,3),(692,2046326400,4),(692,2057216400,3),(692,2077776000,4),(692,2088666000,3),(692,2109225600,4),(692,2120115600,3),(692,2140675200,4),(693,-2147483648,1),(693,-1946918424,2),(694,-2147483648,1),(694,-1567453392,2),(694,-1233432000,3),(694,-1222981200,2),(694,-1205956800,3),(694,-1194037200,2),(694,-1172865600,3),(694,-1162501200,2),(694,-1141329600,3),(694,-1130965200,2),(694,-1109793600,3),(694,-1099429200,2),(694,-1078257600,3),(694,-1067806800,2),(694,-1046635200,3),(694,-1036270800,2),(694,-1015099200,3),(694,-1004734800,2),(694,-983563200,3),(694,-973198800,2),(694,-952027200,3),(694,-941576400,2),(694,-931032000,3),(694,-900882000,2),(694,-890337600,3),(694,-833749200,2),(694,-827265600,3),(694,-752274000,2),(694,-733780800,3),(694,-197326800,2),(694,-190843200,3),(694,-184194000,2),(694,-164491200,3),(694,-152658000,2),(694,-132955200,3),(694,-121122000,2),(694,-101419200,3),(694,-86821200,2),(694,-71092800,3),(694,-54766800,2),(694,-39038400,3),(694,-23317200,2),(694,-7588800,5),(694,128142000,4),(694,136605600,5),(694,596948400,4),(694,605066400,5),(694,624423600,4),(694,636516000,5),(694,656478000,4),(694,667965600,2),(694,687931200,4),(694,699415200,5),(694,719377200,4),(694,731469600,5),(694,938919600,3),(694,952052400,5),(694,1198983600,4),(694,1205632800,5),(694,1224385200,4),(694,1237082400,5),(694,2147483647,5),(695,-2147483648,1),(695,-1545071027,3),(695,288770400,2),(695,297234000,3),(695,320220000,2),(695,328683600,3),(695,664264800,2),(695,678344400,3),(695,695714400,2),(695,700635600,3),(696,-2147483648,4),(696,-1633273200,1),(696,-1615132800,2),(696,-1601823600,1),(696,-1583683200,2),(696,-880210800,3),(696,-820519140,2),(696,-812653140,3),(696,-796845540,2),(696,-84380400,1),(696,-68659200,2),(697,-2147483648,0),(697,-1767212140,2),(697,-1206954000,1),(697,-1191358800,2),(697,-1175371200,1),(697,-1159822800,2),(697,-633816000,1),(697,-622065600,2),(697,-602280000,1),(697,-591829200,2),(697,-570744000,1),(697,-560206800,2),(697,-539121600,1),(697,-531349200,2),(697,-191361600,1),(697,-184194000,2),(697,-155160000,1),(697,-150066000,2),(697,-128894400,1),(697,-121122000,2),(697,-99950400,1),(697,-89586000,2),(697,-68414400,1),(697,-57963600,2),(697,499752000,1),(697,511239600,2),(697,530596800,1),(697,540270000,2),(697,562132800,1),(697,571201200,2),(697,592977600,1),(697,602046000,2),(697,624427200,1),(697,634705200,2),(697,656481600,1),(697,666759600,2),(697,687931200,1),(697,697604400,2),(697,719985600,1),(697,728449200,2),(697,750830400,1),(697,761713200,2),(697,782280000,1),(697,793162800,2),(697,813729600,1),(697,824007600,2),(697,844574400,1),(697,856062000,2),(697,876110400,1),(697,888721200,2),(697,908078400,1),(697,919566000,2),(697,938923200,1),(697,951620400,2),(697,970977600,1),(697,982465200,2),(697,1003032000,1),(697,1013914800,2),(697,1036296000,1),(697,1045364400,2),(697,1099368000,1),(697,1108868400,2),(697,1129435200,1),(697,1140318000,2),(697,1162699200,1),(697,1172372400,2),(697,1192334400,1),(697,1203217200,2),(697,1224388800,1),(697,1234666800,2),(697,1255838400,1),(697,1266721200,2),(697,1287288000,1),(697,1298170800,2),(697,1318737600,1),(697,1330225200,2),(697,1350792000,1),(697,1361070000,2),(697,1382241600,1),(697,1392519600,2),(697,1413691200,1),(697,1424574000,2),(697,1445140800,1),(697,1456023600,2),(697,1476590400,1),(697,1487473200,2),(697,1508040000,1),(697,1518922800,2),(697,1541304000,1),(697,1550372400,2),(697,2147483647,2),(698,-2147483648,1),(698,-873057600,3),(698,-769395600,2),(698,-765399600,1),(699,-2147483648,0),(699,-1686091520,1),(699,323845200,4),(699,338950800,2),(699,354675600,3),(699,370400400,2),(699,386125200,3),(699,401850000,2),(699,417574800,3),(699,433299600,2),(699,449024400,3),(699,465354000,2),(699,481078800,3),(699,496803600,2),(699,512528400,3),(699,528253200,2),(699,543978000,3),(699,559702800,2),(699,575427600,3),(699,591152400,2),(699,606877200,3),(699,622602000,2),(699,638326800,3),(699,654656400,2),(699,670381200,3),(699,686106000,2),(699,701830800,3),(699,717555600,2),(699,733280400,3),(699,749005200,2),(699,764730000,3),(699,780454800,2),(699,796179600,3),(699,811904400,2),(699,820465200,5),(700,-2147483648,2),(700,-1632056400,1),(700,-1615125600,2),(700,-1596978000,1),(700,-1583164800,2),(700,-880203600,3),(700,-769395600,4),(700,-765381600,2),(700,-147884400,5),(700,-131554800,2),(700,120646800,6),(700,325677600,7),(700,341398800,6),(700,357127200,7),(700,372848400,6),(700,388576800,7),(700,404902800,6),(700,420026400,7),(700,436352400,6),(700,452080800,7),(700,467802000,6),(700,483530400,7),(700,499251600,6),(700,514980000,7),(700,530701200,6),(700,544615200,7),(700,562150800,6),(700,576064800,7),(700,594205200,6),(700,607514400,7),(700,625654800,6),(700,638964000,7),(700,657104400,6),(700,671018400,7),(700,688554000,6),(700,702468000,7),(700,720003600,6),(700,733917600,7),(700,752058000,6),(700,765367200,7),(700,783507600,6),(700,796816800,7),(700,814957200,6),(700,828871200,7),(700,846406800,6),(700,860320800,7),(700,877856400,6),(700,891770400,7),(700,909306000,6),(700,923220000,7),(700,941360400,6),(700,954669600,7),(700,972810000,6),(700,986119200,7),(700,1004259600,6),(700,1018173600,7),(700,1035709200,6),(700,1049623200,7),(700,1067158800,6),(700,1081072800,7),(700,1099213200,6),(700,1112522400,7),(700,1130662800,6),(700,1143972000,7),(700,1162112400,6),(700,1173607200,7),(700,1194166800,6),(700,1205056800,7),(700,1225616400,6),(700,1236506400,7),(700,1257066000,6),(700,1268560800,7),(700,1289120400,6),(700,1300010400,7),(700,1320570000,6),(700,1331460000,7),(700,1352019600,6),(700,1362909600,7),(700,1383469200,6),(700,1394359200,7),(700,1414918800,6),(700,1425808800,7),(700,1446368400,6),(700,1457863200,7),(700,1478422800,6),(700,1489312800,7),(700,1509872400,6),(700,1520762400,7),(700,1541322000,6),(700,1552212000,7),(700,1572771600,6),(700,1583661600,7),(700,1604214000,8),(701,-2147483648,2),(701,-1632060000,1),(701,-1615129200,2),(701,-880207200,3),(701,-769395600,4),(701,-765385200,2),(701,-715788000,1),(701,-702486000,2),(701,-684338400,1),(701,-671036400,2),(701,-652888800,1),(701,-639586800,2),(701,-620834400,1),(701,-608137200,2),(701,-589384800,1),(701,-576082800,2),(701,-557935200,1),(701,-544633200,2),(701,-526485600,1),(701,-513183600,2),(701,-495036000,1),(701,-481734000,2),(701,-463586400,1),(701,-450284400,2),(701,-431532000,1),(701,-418230000,2),(701,-400082400,1),(701,-386780400,2),(701,-368632800,1),(701,-355330800,2),(701,-337183200,1),(701,-323881200,2),(701,-305733600,1),(701,-292431600,2),(701,-273679200,1),(701,-260982000,2),(701,-242229600,1),(701,-226508400,2),(701,-210780000,1),(701,-195058800,2),(701,-179330400,1),(701,-163609200,2),(701,-147880800,1),(701,-131554800,2),(701,-116431200,1),(701,-100105200,2),(701,-84376800,1),(701,-68655600,2),(701,-52927200,1),(701,-37206000,2),(701,-21477600,1),(701,-5756400,2),(701,9972000,1),(701,25693200,2),(701,41421600,1),(701,57747600,2),(701,73476000,1),(701,84013200,5),(702,-2147483648,3),(702,-1633273200,1),(702,-1615132800,2),(702,-1601823600,1),(702,-1583683200,2),(702,-1570374000,1),(702,-1551628800,2),(702,-1538924400,1),(702,-1534089600,2),(702,-880210800,4),(702,-769395600,5),(702,-765388800,2),(702,-147884400,1),(702,-131558400,2),(702,-116434800,1),(702,-100108800,2),(702,-84380400,1),(702,-68659200,2),(702,-52930800,1),(702,-37209600,2),(702,-21481200,1),(702,-5760000,2),(702,9968400,1),(702,25689600,2),(702,41418000,1),(702,57744000,2),(702,73472400,1),(702,89193600,2),(702,104922000,1),(702,120643200,2),(702,126694800,1),(702,152092800,2),(702,162378000,1),(702,183542400,2),(702,199270800,1),(702,215596800,2),(702,230720400,1),(702,247046400,2),(702,262774800,1),(702,278496000,2),(702,294224400,1),(702,309945600,2),(702,325674000,1),(702,341395200,2),(702,357123600,1),(702,372844800,2),(702,388573200,1),(702,404899200,2),(702,420022800,1),(702,436348800,2),(702,452077200,1),(702,467798400,2),(702,483526800,1),(702,499248000,2),(702,514976400,1),(702,530697600,2),(702,544611600,1),(702,562147200,2),(702,576061200,1),(702,594201600,2),(702,607510800,1),(702,625651200,2),(702,638960400,1),(702,657100800,2),(702,671014800,1),(702,688550400,2),(702,702464400,1),(702,720000000,2),(702,733914000,1),(702,752054400,2),(702,765363600,1),(702,783504000,2),(702,796813200,1),(702,814953600,2),(702,828867600,1),(702,846403200,2),(702,860317200,1),(702,877852800,2),(702,891766800,1),(702,909302400,2),(702,923216400,1),(702,941356800,2),(702,954666000,1),(702,972806400,2),(702,986115600,1),(702,1004256000,2),(702,1018170000,1),(702,1035705600,2),(702,1049619600,1),(702,1067155200,2),(702,1081069200,1),(702,1099209600,2),(702,1112518800,1),(702,1130659200,2),(702,1143968400,1),(702,1162108800,2),(702,1173603600,1),(702,1194163200,2),(702,1205053200,1),(702,1225612800,2),(702,1236502800,1),(702,1257062400,2),(702,1268557200,1),(702,1289116800,2),(702,1300006800,1),(702,1320566400,2),(702,1331456400,1),(702,1352016000,2),(702,1362906000,1),(702,1383465600,2),(702,1394355600,1),(702,1414915200,2),(702,1425805200,1),(702,1446364800,2),(702,1457859600,1),(702,1478419200,2),(702,1489309200,1),(702,1509868800,2),(702,1520758800,1),(702,1541318400,2),(702,1552208400,1),(702,1572768000,2),(702,1583658000,1),(702,1604217600,2),(702,1615712400,1),(702,1636272000,2),(702,1647162000,1),(702,1667721600,2),(702,1678611600,1),(702,1699171200,2),(702,1710061200,1),(702,1730620800,2),(702,1741510800,1),(702,1762070400,2),(702,1772960400,1),(702,1793520000,2),(702,1805014800,1),(702,1825574400,2),(702,1836464400,1),(702,1857024000,2),(702,1867914000,1),(702,1888473600,2),(702,1899363600,1),(702,1919923200,2),(702,1930813200,1),(702,1951372800,2),(702,1962867600,1),(702,1983427200,2),(702,1994317200,1),(702,2014876800,2),(702,2025766800,1),(702,2046326400,2),(702,2057216400,1),(702,2077776000,2),(702,2088666000,1),(702,2109225600,2),(702,2120115600,1),(702,2140675200,2),(703,-2147483648,0),(703,-2051202469,1),(703,-1724083200,2),(703,-880218000,3),(703,-769395600,4),(703,-765396000,2),(703,-684349200,5),(703,-671047200,2),(703,-80506740,5),(703,-68666400,2),(703,-52938000,5),(703,-37216800,2),(703,104914800,5),(703,120636000,2),(703,126687600,5),(703,152085600,2),(703,167814000,5),(703,183535200,2),(703,199263600,5),(703,215589600,2),(703,230713200,5),(703,247039200,2),(703,262767600,5),(703,278488800,2),(703,294217200,5),(703,309938400,2),(703,325666800,5),(703,341388000,2),(703,357116400,5),(703,372837600,2),(703,388566000,5),(703,404892000,2),(703,420015600,5),(703,436341600,2),(703,452070000,5),(703,467791200,2),(703,483519600,5),(703,499240800,2),(703,514969200,5),(703,530690400,2),(703,544604400,5),(703,562140000,2),(703,576054000,5),(703,594194400,2),(703,607503600,5),(703,625644000,2),(703,638953200,5),(703,657093600,2),(703,671007600,5),(703,688543200,2),(703,702457200,5),(703,719992800,2),(703,733906800,5),(703,752047200,2),(703,765356400,5),(703,783496800,2),(703,796806000,5),(703,814946400,2),(703,828860400,5),(703,846396000,2),(703,860310000,5),(703,877845600,2),(703,891759600,5),(703,909295200,2),(703,923209200,5),(703,941349600,2),(703,954658800,5),(703,972799200,2),(703,986108400,5),(703,1004248800,2),(703,1018162800,5),(703,1035698400,2),(703,1049612400,5),(703,1067148000,2),(703,1081062000,5),(703,1099202400,2),(703,1112511600,5),(703,1130652000,2),(703,1143961200,5),(703,1162101600,2),(703,1173596400,5),(703,1194156000,2),(703,1205046000,5),(703,1225605600,2),(703,1236495600,5),(703,1257055200,2),(703,1268550000,5),(703,1289109600,2),(703,1299999600,5),(703,1320559200,2),(703,1331449200,5),(703,1352008800,2),(703,1362898800,5),(703,1383458400,2),(703,1394348400,5),(703,1414908000,2),(703,1425798000,5),(703,1446357600,2),(703,1457852400,5),(703,1478412000,2),(703,1489302000,5),(703,1509861600,2),(703,1520751600,5),(703,1541311200,2),(703,1552201200,5),(703,1572760800,2),(703,1583650800,5),(703,1604210400,2),(703,1615705200,5),(703,1636264800,2),(703,1647154800,5),(703,1667714400,2),(703,1678604400,5),(703,1699164000,2),(703,1710054000,5),(703,1730613600,2),(703,1741503600,5),(703,1762063200,2),(703,1772953200,5),(703,1793512800,2),(703,1805007600,5),(703,1825567200,2),(703,1836457200,5),(703,1857016800,2),(703,1867906800,5),(703,1888466400,2),(703,1899356400,5),(703,1919916000,2),(703,1930806000,5),(703,1951365600,2),(703,1962860400,5),(703,1983420000,2),(703,1994310000,5),(703,2014869600,2),(703,2025759600,5),(703,2046319200,2),(703,2057209200,5),(703,2077768800,2),(703,2088658800,5),(703,2109218400,2),(703,2120108400,5),(703,2140668000,2),(704,-2147483648,1),(704,-873057600,3),(704,-769395600,2),(704,-765399600,1),(705,-2147483648,0),(705,-1998663968,2),(705,-1632063600,1),(705,-1615132800,2),(705,-1600614000,1),(705,-1596816000,2),(705,-1567954800,1),(705,-1551628800,2),(705,-1536505200,1),(705,-1523203200,2),(705,-1504450800,1),(705,-1491753600,2),(705,-1473001200,1),(705,-1459699200,2),(705,-880210800,3),(705,-769395600,4),(705,-765388800,2),(705,-715791600,1),(705,-702489600,2),(705,73472400,1),(705,89193600,2),(705,104922000,1),(705,120643200,2),(705,136371600,1),(705,152092800,2),(705,167821200,1),(705,183542400,2),(705,199270800,1),(705,215596800,2),(705,230720400,1),(705,247046400,2),(705,262774800,1),(705,278496000,2),(705,294224400,1),(705,309945600,2),(705,325674000,1),(705,341395200,2),(705,357123600,1),(705,372844800,2),(705,388573200,1),(705,404899200,2),(705,420022800,1),(705,436348800,2),(705,452077200,1),(705,467798400,2),(705,483526800,1),(705,499248000,2),(705,514976400,1),(705,530697600,2),(705,544611600,1),(705,562147200,2),(705,576061200,1),(705,594201600,2),(705,607510800,1),(705,625651200,2),(705,638960400,1),(705,657100800,2),(705,671014800,1),(705,688550400,2),(705,702464400,1),(705,720000000,2),(705,733914000,1),(705,752054400,2),(705,765363600,1),(705,783504000,2),(705,796813200,1),(705,814953600,2),(705,828867600,1),(705,846403200,2),(705,860317200,1),(705,877852800,2),(705,891766800,1),(705,909302400,2),(705,923216400,1),(705,941356800,2),(705,954666000,1),(705,972806400,2),(705,986115600,1),(705,1004256000,2),(705,1018170000,1),(705,1035705600,2),(705,1049619600,1),(705,1067155200,2),(705,1081069200,1),(705,1099209600,2),(705,1112518800,1),(705,1130659200,2),(705,1143968400,1),(705,1162108800,2),(705,1173603600,1),(705,1194163200,2),(705,1205053200,1),(705,1225612800,2),(705,1236502800,1),(705,1257062400,2),(705,1268557200,1),(705,1289116800,2),(705,1300006800,1),(705,1320566400,2),(705,1331456400,1),(705,1352016000,2),(705,1362906000,1),(705,1383465600,2),(705,1394355600,1),(705,1414915200,2),(705,1425805200,1),(705,1446364800,2),(705,1457859600,1),(705,1478419200,2),(705,1489309200,1),(705,1509868800,2),(705,1520758800,1),(705,1541318400,2),(705,1552208400,1),(705,1572768000,2),(705,1583658000,1),(705,1604217600,2),(705,1615712400,1),(705,1636272000,2),(705,1647162000,1),(705,1667721600,2),(705,1678611600,1),(705,1699171200,2),(705,1710061200,1),(705,1730620800,2),(705,1741510800,1),(705,1762070400,2),(705,1772960400,1),(705,1793520000,2),(705,1805014800,1),(705,1825574400,2),(705,1836464400,1),(705,1857024000,2),(705,1867914000,1),(705,1888473600,2),(705,1899363600,1),(705,1919923200,2),(705,1930813200,1),(705,1951372800,2),(705,1962867600,1),(705,1983427200,2),(705,1994317200,1),(705,2014876800,2),(705,2025766800,1),(705,2046326400,2),(705,2057216400,1),(705,2077776000,2),(705,2088666000,1),(705,2109225600,2),(705,2120115600,1),(705,2140675200,2),(706,-2147483648,0),(706,-1767208832,2),(706,-1206950400,1),(706,-1191355200,2),(706,-1175367600,1),(706,-1159819200,2),(706,-633812400,1),(706,-622062000,2),(706,-602276400,1),(706,-591825600,2),(706,-570740400,1),(706,-560203200,2),(706,-539118000,1),(706,-531345600,2),(706,-191358000,1),(706,-184190400,2),(706,-155156400,1),(706,-150062400,2),(706,-128890800,1),(706,-121118400,2),(706,-99946800,1),(706,-89582400,2),(706,-68410800,1),(706,-57960000,2),(706,499755600,1),(706,511243200,2),(706,530600400,1),(706,540273600,2),(706,562136400,1),(706,571204800,2),(706,750834000,1),(706,761716800,2),(706,1214283600,3),(706,1384056000,2),(706,2147483647,2),(707,-2147483648,0),(707,-1546279392,2),(707,547020000,1),(707,559717200,2),(707,578469600,1),(707,591166800,2),(708,-2147483648,0),(708,-1514739600,1),(708,-1451667600,2),(708,-1343062800,3),(708,-1234803600,2),(708,-1222963200,4),(708,-1207242000,2),(708,-873820800,5),(708,-769395600,6),(708,-761677200,2),(708,-686073600,4),(708,-661539600,2),(708,-495039600,4),(708,-481734000,2),(708,-463590000,4),(708,-450284400,2),(708,-431535600,4),(708,-418230000,2),(708,-400086000,4),(708,-386780400,2),(708,-368636400,4),(708,-355330800,2),(708,-337186800,4),(708,-323881200,2),(708,-305737200,4),(708,-292431600,2),(708,199274400,4),(708,215600400,2),(708,230724000,4),(708,247050000,2),(708,262778400,4),(708,278499600,2),(708,294228000,4),(708,309949200,2),(708,325677600,4),(708,341398800,2),(708,357127200,4),(708,372848400,2),(708,388576800,4),(708,404902800,2),(708,420026400,4),(708,436352400,2),(708,452080800,4),(708,467802000,2),(708,483530400,4),(708,499251600,2),(708,514980000,4),(708,530701200,2),(708,544615200,4),(708,562150800,2),(708,576064800,4),(708,594205200,2),(708,607514400,4),(708,625654800,2),(708,638964000,4),(708,657104400,2),(708,671018400,4),(708,688554000,2),(708,702468000,4),(708,720003600,2),(708,733917600,4),(708,752058000,2),(708,765367200,4),(708,783507600,2),(708,796816800,4),(708,814957200,2),(708,828871200,4),(708,846406800,2),(708,860320800,4),(708,877856400,2),(708,891770400,4),(708,909306000,2),(708,923220000,4),(708,941360400,2),(708,954669600,4),(708,972810000,2),(708,986119200,4),(708,1004259600,2),(708,1018173600,4),(708,1035709200,2),(708,1049623200,4),(708,1067158800,2),(708,1081072800,4),(708,1099213200,2),(708,1112522400,4),(708,1130662800,2),(708,1143972000,4),(708,1162112400,2),(708,1175421600,4),(708,1193562000,2),(708,1207476000,4),(708,1225011600,2),(708,1238925600,4),(708,1256461200,2),(708,1268560800,4),(708,1289120400,2),(708,1300010400,4),(708,1320570000,2),(708,1331460000,4),(708,1352019600,2),(708,1362909600,4),(708,1383469200,2),(708,1394359200,4),(708,1414918800,2),(708,1425808800,4),(708,1446368400,2),(708,1457863200,4),(708,1478422800,2),(708,1489312800,4),(708,1509872400,2),(708,1520762400,4),(708,1541322000,2),(708,1552212000,4),(708,1572771600,2),(708,1583661600,4),(708,1604221200,2),(708,1615716000,4),(708,1636275600,2),(708,1647165600,4),(708,1667725200,2),(708,1678615200,4),(708,1699174800,2),(708,1710064800,4),(708,1730624400,2),(708,1741514400,4),(708,1762074000,2),(708,1772964000,4),(708,1793523600,2),(708,1805018400,4),(708,1825578000,2),(708,1836468000,4),(708,1857027600,2),(708,1867917600,4),(708,1888477200,2),(708,1899367200,4),(708,1919926800,2),(708,1930816800,4),(708,1951376400,2),(708,1962871200,4),(708,1983430800,2),(708,1994320800,4),(708,2014880400,2),(708,2025770400,4),(708,2046330000,2),(708,2057220000,4),(708,2077779600,2),(708,2088669600,4),(708,2109229200,2),(708,2120119200,4),(708,2140678800,2),(709,-2147483648,2),(709,-1632060000,1),(709,-1615129200,2),(709,-880207200,3),(709,-769395600,4),(709,-765385200,2),(709,-715788000,1),(709,-702486000,2),(709,-684338400,1),(709,-671036400,2),(709,-652888800,1),(709,-639586800,2),(709,-620834400,1),(709,-608137200,2),(709,-589384800,1),(709,-576082800,2),(709,-557935200,1),(709,-544633200,2),(709,-526485600,1),(709,-513183600,2),(709,-495036000,1),(709,-481734000,2),(709,-463586400,1),(709,-450284400,2),(709,-431532000,1),(709,-418230000,2),(709,-400082400,1),(709,-386780400,2),(709,-368632800,1),(709,-355330800,2),(709,-337183200,1),(709,-323881200,2),(709,-305733600,1),(709,-292431600,2),(709,-273679200,1),(709,-260982000,2),(709,-242229600,1),(709,-226508400,2),(709,-210780000,1),(709,-195058800,2),(709,-179330400,1),(709,-163609200,2),(709,-147880800,1),(709,-131554800,2),(709,-116431200,1),(709,-100105200,2),(709,-84376800,1),(709,-68655600,2),(709,-52927200,1),(709,-37206000,2),(709,-21477600,1),(709,-5756400,2),(709,9972000,1),(709,25693200,2),(709,41421600,1),(709,57747600,2),(709,73476000,1),(709,89197200,2),(709,104925600,1),(709,120646800,2),(709,136375200,1),(709,152096400,2),(709,167824800,1),(709,183546000,2),(709,199274400,1),(709,215600400,2),(709,230724000,1),(709,247050000,2),(709,262778400,1),(709,278499600,2),(709,294228000,1),(709,309949200,2),(709,325677600,1),(709,341398800,2),(709,357127200,1),(709,372848400,2),(709,388576800,1),(709,404902800,2),(709,420026400,1),(709,436352400,2),(709,452080800,1),(709,467802000,2),(709,483530400,1),(709,499251600,2),(709,514980000,1),(709,530701200,2),(709,544615200,1),(709,562150800,2),(709,576064800,1),(709,594205200,2),(709,607514400,1),(709,625654800,2),(709,638964000,1),(709,657104400,2),(709,671018400,1),(709,688554000,2),(709,702468000,1),(709,720003600,2),(709,733917600,1),(709,752058000,2),(709,765367200,1),(709,783507600,2),(709,796816800,1),(709,814957200,2),(709,828871200,1),(709,846406800,2),(709,860320800,1),(709,877856400,2),(709,891770400,1),(709,909306000,2),(709,923220000,1),(709,941360400,2),(709,954669600,1),(709,972810000,2),(709,986119200,1),(709,1004259600,2),(709,1018173600,1),(709,1035709200,2),(709,1049623200,1),(709,1067158800,2),(709,1081072800,1),(709,1099213200,2),(709,1112522400,1),(709,1130662800,2),(709,1143972000,1),(709,1162112400,2),(709,1173607200,1),(709,1194166800,2),(709,1205056800,1),(709,1225616400,2),(709,1236506400,1),(709,1257066000,2),(709,1268560800,1),(709,1289120400,2),(709,1300010400,1),(709,1320570000,2),(709,1331460000,1),(709,1352019600,2),(709,1362909600,1),(709,1383469200,2),(709,1394359200,1),(709,1414918800,2),(709,1425808800,5),(710,-2147483648,3),(710,-1633276800,1),(710,-1615136400,2),(710,-1601827200,1),(710,-1583686800,2),(710,-900259200,1),(710,-891795600,2),(710,-880214400,4),(710,-769395600,5),(710,-765392400,2),(710,-747244800,1),(710,-733942800,2),(710,-715795200,1),(710,-702493200,2),(710,-684345600,1),(710,-671043600,2),(710,-652896000,1),(710,-639594000,2),(710,-620841600,1),(710,-608144400,2),(710,-589392000,1),(710,-576090000,2),(710,-557942400,1),(710,-544640400,2),(710,-526492800,1),(710,-513190800,2),(710,-495043200,1),(710,-481741200,2),(710,-463593600,6),(710,-386787600,2),(710,-368640000,6),(710,-21488400,7),(710,-5767200,6),(710,9961200,7),(710,25682400,6),(710,1143961200,7),(710,1162101600,6),(710,1173596400,7),(710,1194156000,6),(710,1205046000,7),(710,1225605600,6),(710,1236495600,7),(710,1257055200,6),(710,1268550000,7),(710,1289109600,6),(710,1299999600,7),(710,1320559200,6),(710,1331449200,7),(710,1352008800,6),(710,1362898800,7),(710,1383458400,6),(710,1394348400,7),(710,1414908000,6),(710,1425798000,7),(710,1446357600,6),(710,1457852400,7),(710,1478412000,6),(710,1489302000,7),(710,1509861600,6),(710,1520751600,7),(710,1541311200,6),(710,1552201200,7),(710,1572760800,6),(710,1583650800,7),(710,1604210400,6),(710,1615705200,7),(710,1636264800,6),(710,1647154800,7),(710,1667714400,6),(710,1678604400,7),(710,1699164000,6),(710,1710054000,7),(710,1730613600,6),(710,1741503600,7),(710,1762063200,6),(710,1772953200,7),(710,1793512800,6),(710,1805007600,7),(710,1825567200,6),(710,1836457200,7),(710,1857016800,6),(710,1867906800,7),(710,1888466400,6),(710,1899356400,7),(710,1919916000,6),(710,1930806000,7),(710,1951365600,6),(710,1962860400,7),(710,1983420000,6),(710,1994310000,7),(710,2014869600,6),(710,2025759600,7),(710,2046319200,6),(710,2057209200,7),(710,2077768800,6),(710,2088658800,7),(710,2109218400,6),(710,2120108400,7),(710,2140668000,6),(711,-2147483648,0),(711,-1767216360,2),(711,-1206957600,1),(711,-1191362400,2),(711,-1175374800,1),(711,-1159826400,2),(711,-633819600,1),(711,-622069200,2),(711,-602283600,1),(711,-591832800,2),(711,-570747600,1),(711,-560210400,2),(711,-539125200,1),(711,-531352800,2),(711,-191365200,1),(711,-184197600,2),(711,-155163600,1),(711,-150069600,2),(711,-128898000,1),(711,-121125600,2),(711,-99954000,1),(711,-89589600,2),(711,-68418000,1),(711,-57967200,2),(711,499748400,1),(711,511236000,2),(711,530593200,1),(711,540266400,2),(711,562129200,1),(711,571197600,2),(711,592974000,1),(711,602042400,2),(711,624423600,1),(711,634701600,2),(711,938919600,1),(711,951616800,2),(711,970974000,1),(711,972180000,2),(711,1003028400,1),(711,1013911200,2),(711,2147483647,2),(712,-2147483648,0),(712,-2131646412,2),(712,-1632074400,1),(712,-1615143600,2),(712,-880221600,3),(712,-769395600,4),(712,-765399600,2),(712,-526500000,1),(712,-513198000,2),(712,73461600,1),(712,89182800,2),(712,104911200,1),(712,120632400,2),(712,136360800,1),(712,152082000,2),(712,167810400,1),(712,183531600,2),(712,199260000,1),(712,215586000,2),(712,230709600,1),(712,247035600,2),(712,262764000,1),(712,278485200,2),(712,294213600,1),(712,309934800,2),(712,325663200,1),(712,341384400,2),(712,357112800,1),(712,372834000,2),(712,388562400,1),(712,404888400,2),(712,420012000,1),(712,436338000,2),(712,452066400,1),(712,467787600,2),(712,483516000,1),(712,499237200,2),(712,514965600,1),(712,530686800,2),(712,544600800,1),(712,562136400,2),(712,576050400,1),(712,594190800,2),(712,607500000,1),(712,625640400,2),(712,638949600,1),(712,657090000,2),(712,671004000,1),(712,688539600,2),(712,702453600,1),(712,719989200,2),(712,733903200,1),(712,752043600,2),(712,765352800,1),(712,783493200,2),(712,796802400,1),(712,814942800,2),(712,828856800,1),(712,846392400,2),(712,860306400,1),(712,877842000,2),(712,891756000,1),(712,909291600,2),(712,923205600,1),(712,941346000,2),(712,954655200,1),(712,972795600,2),(712,986104800,1),(712,1004245200,2),(712,1018159200,1),(712,1035694800,2),(712,1049608800,1),(712,1067144400,2),(712,1081058400,1),(712,1099198800,2),(712,1112508000,1),(712,1130648400,2),(712,1143957600,1),(712,1162098000,2),(712,1173592800,1),(712,1194152400,2),(712,1205042400,1),(712,1225602000,2),(712,1236492000,1),(712,1257051600,2),(712,1268546400,1),(712,1289106000,2),(712,1299996000,1),(712,1320555600,2),(712,1331445600,1),(712,1352005200,2),(712,1362895200,1),(712,1383454800,2),(712,1394344800,1),(712,1414904400,2),(712,1425794400,1),(712,1446354000,2),(712,1457848800,1),(712,1478408400,2),(712,1489298400,1),(712,1509858000,2),(712,1520748000,1),(712,1541307600,2),(712,1552197600,1),(712,1572757200,2),(712,1583647200,1),(712,1604206800,2),(712,1615701600,1),(712,1636261200,2),(712,1647151200,1),(712,1667710800,2),(712,1678600800,1),(712,1699160400,2),(712,1710050400,1),(712,1730610000,2),(712,1741500000,1),(712,1762059600,2),(712,1772949600,1),(712,1793509200,2),(712,1805004000,1),(712,1825563600,2),(712,1836453600,1),(712,1857013200,2),(712,1867903200,1),(712,1888462800,2),(712,1899352800,1),(712,1919912400,2),(712,1930802400,1),(712,1951362000,2),(712,1962856800,1),(712,1983416400,2),(712,1994306400,1),(712,2014866000,2),(712,2025756000,1),(712,2046315600,2),(712,2057205600,1),(712,2077765200,2),(712,2088655200,1),(712,2109214800,2),(712,2120104800,1),(712,2140664400,2),(713,-2147483648,0),(713,-1686083584,1),(713,323845200,4),(713,338950800,2),(713,354675600,3),(713,370400400,2),(713,386125200,3),(713,401850000,2),(713,417574800,3),(713,433299600,2),(713,449024400,3),(713,465354000,2),(713,481078800,3),(713,496803600,2),(713,512528400,3),(713,528253200,2),(713,543978000,3),(713,559702800,2),(713,575427600,3),(713,591152400,2),(713,606877200,3),(713,622602000,2),(713,638326800,3),(713,654656400,2),(713,670381200,3),(713,686106000,2),(713,701830800,3),(713,717555600,2),(713,733280400,3),(713,749005200,2),(713,764730000,3),(713,780454800,2),(713,796179600,3),(713,811904400,2),(713,828234000,3),(713,846378000,2),(713,859683600,3),(713,877827600,2),(713,891133200,3),(713,909277200,2),(713,922582800,3),(713,941331600,2),(713,954032400,3),(713,972781200,2),(713,985482000,3),(713,1004230800,2),(713,1017536400,3),(713,1035680400,2),(713,1048986000,3),(713,1067130000,2),(713,1080435600,3),(713,1099184400,2),(713,1111885200,3),(713,1130634000,2),(713,1143334800,3),(713,1162083600,2),(713,1174784400,3),(713,1193533200,2),(713,1206838800,3),(713,1224982800,2),(713,1238288400,3),(713,1256432400,2),(713,1269738000,3),(713,1288486800,2),(713,1301187600,3),(713,1319936400,2),(713,1332637200,3),(713,1351386000,2),(713,1364691600,3),(713,1382835600,2),(713,1396141200,3),(713,1414285200,2),(713,1427590800,3),(713,1445734800,2),(713,1459040400,3),(713,1477789200,2),(713,1490490000,3),(713,1509238800,2),(713,1521939600,3),(713,1540688400,2),(713,1553994000,3),(713,1572138000,2),(713,1585443600,3),(713,1603587600,2),(713,1616893200,3),(713,1635642000,2),(713,1648342800,3),(713,1667091600,2),(713,1679792400,3),(713,1698541200,5),(713,1711846800,6),(713,1729990800,5),(713,1743296400,6),(713,1761440400,5),(713,1774746000,6),(713,1792890000,5),(713,1806195600,6),(713,1824944400,5),(713,1837645200,6),(713,1856394000,5),(713,1869094800,6),(713,1887843600,5),(713,1901149200,6),(713,1919293200,5),(713,1932598800,6),(713,1950742800,5),(713,1964048400,6),(713,1982797200,5),(713,1995498000,6),(713,2014246800,5),(713,2026947600,6),(713,2045696400,5),(713,2058397200,6),(713,2077146000,5),(713,2090451600,6),(713,2108595600,5),(713,2121901200,6),(713,2140045200,5),(713,2147483647,5),(714,-2147483648,1),(714,-1632076148,2),(714,-1615145348,1),(714,-1096921748,3),(714,-1061670600,4),(714,-1048973400,3),(714,-1030221000,4),(714,-1017523800,3),(714,-998771400,4),(714,-986074200,3),(714,-966717000,4),(714,-954624600,3),(714,-935267400,4),(714,-922570200,3),(714,-903817800,4),(714,-891120600,3),(714,-872368200,6),(714,-769395600,5),(714,-765401400,3),(714,-746044200,4),(714,-733347000,3),(714,-714594600,4),(714,-701897400,3),(714,-683145000,4),(714,-670447800,3),(714,-651695400,4),(714,-638998200,3),(714,-619641000,4),(714,-606943800,3),(714,-589401000,4),(714,-576099000,3),(714,-557951400,4),(714,-544649400,3),(714,-526501800,4),(714,-513199800,3),(714,-495052200,4),(714,-481750200,3),(714,-463602600,4),(714,-450300600,3),(714,-431548200,4),(714,-418246200,3),(714,-400098600,4),(714,-386796600,3),(714,-368649000,4),(714,-355347000,3),(714,-337199400,4),(714,-323897400,3),(714,-305749800,4),(714,-289423800,3),(714,-273695400,4),(714,-257974200,3),(714,-242245800,4),(714,-226524600,3),(714,-210796200,4),(714,-195075000,3),(714,-179346600,4),(714,-163625400,3),(714,-147897000,4),(714,-131571000,3),(714,-119903400,8),(714,-116445600,7),(714,-100119600,8),(714,-84391200,7),(714,-68670000,8),(714,-52941600,7),(714,-37220400,8),(714,-21492000,7),(714,-5770800,8),(714,9957600,7),(714,25678800,8),(714,41407200,7),(714,57733200,8),(714,73461600,7),(714,89182800,8),(714,104911200,7),(714,120632400,8),(714,136360800,7),(714,152082000,8),(714,167810400,7),(714,183531600,8),(714,199260000,7),(714,215586000,8),(714,230709600,7),(714,247035600,8),(714,262764000,7),(714,278485200,8),(714,294213600,7),(714,309934800,8),(714,325663200,7),(714,341384400,8),(714,357112800,7),(714,372834000,8),(714,388562400,7),(714,404888400,8),(714,420012000,7),(714,436338000,8),(714,452066400,7),(714,467787600,8),(714,483516000,7),(714,499237200,8),(714,514965600,7),(714,530686800,8),(714,544593660,7),(714,562129260,8),(714,576043260,9),(714,594180060,8),(714,607492860,7),(714,625633260,8),(714,638942460,7),(714,657082860,8),(714,670996860,7),(714,688532460,8),(714,702446460,7),(714,719982060,8),(714,733896060,7),(714,752036460,8),(714,765345660,7),(714,783486060,8),(714,796795260,7),(714,814935660,8),(714,828849660,7),(714,846385260,8),(714,860299260,7),(714,877834860,8),(714,891748860,7),(714,909284460,8),(714,923198460,7),(714,941338860,8),(714,954648060,7),(714,972788460,8),(714,986097660,7),(714,1004238060,8),(714,1018152060,7),(714,1035687660,8),(714,1049601660,7),(714,1067137260,8),(714,1081051260,7),(714,1099191660,8),(714,1112500860,7),(714,1130641260,8),(714,1143950460,7),(714,1162090860,8),(714,1173585660,7),(714,1194145260,8),(714,1205035260,7),(714,1225594860,8),(714,1236484860,7),(714,1257044460,8),(714,1268539260,7),(714,1289098860,8),(714,1299988860,7),(714,1320555600,8),(714,1331445600,7),(714,1352005200,8),(714,1362895200,7),(714,1383454800,8),(714,1394344800,7),(714,1414904400,8),(714,1425794400,7),(714,1446354000,8),(714,1457848800,7),(714,1478408400,8),(714,1489298400,7),(714,1509858000,8),(714,1520748000,7),(714,1541307600,8),(714,1552197600,7),(714,1572757200,8),(714,1583647200,7),(714,1604206800,8),(714,1615701600,7),(714,1636261200,8),(714,1647151200,7),(714,1667710800,8),(714,1678600800,7),(714,1699160400,8),(714,1710050400,7),(714,1730610000,8),(714,1741500000,7),(714,1762059600,8),(714,1772949600,7),(714,1793509200,8),(714,1805004000,7),(714,1825563600,8),(714,1836453600,7),(714,1857013200,8),(714,1867903200,7),(714,1888462800,8),(714,1899352800,7),(714,1919912400,8),(714,1930802400,7),(714,1951362000,8),(714,1962856800,7),(714,1983416400,8),(714,1994306400,7),(714,2014866000,8),(714,2025756000,7),(714,2046315600,8),(714,2057205600,7),(714,2077765200,8),(714,2088655200,7),(714,2109214800,8),(714,2120104800,7),(714,2140664400,8),(715,-2147483648,1),(715,-1827687170,2),(715,294217200,3),(715,309938400,2),(715,325666800,3),(715,341388000,2),(715,357116400,3),(715,372837600,2),(715,388566000,3),(715,404892000,2),(715,420015600,3),(715,436341600,2),(715,452070000,3),(715,467791200,2),(715,483519600,3),(715,499240800,2),(715,514969200,3),(715,530690400,2),(715,544604400,3),(715,562140000,2),(715,576054000,3),(715,594194400,2),(715,607503600,3),(715,625644000,2),(715,638953200,3),(715,657093600,2),(715,671007600,3),(715,688543200,2),(715,702457200,3),(715,719992800,2),(715,733906800,3),(715,752047200,2),(715,765356400,3),(715,783496800,2),(715,796806000,3),(715,814946400,2),(715,828860400,3),(715,846396000,2),(715,860310000,3),(715,877845600,2),(715,891759600,3),(715,909295200,2),(715,923209200,3),(715,941349600,2),(715,954658800,3),(715,972799200,2),(715,986108400,3),(715,1004248800,2),(715,1018162800,3),(715,1035698400,2),(715,1049612400,3),(715,1067148000,2),(715,1081062000,3),(715,1099202400,2),(715,1112511600,3),(715,1130652000,2),(715,1143961200,3),(715,1162101600,2),(715,1173596400,3),(715,1194156000,2),(715,1205046000,3),(715,1225605600,2),(715,1236495600,3),(715,1257055200,2),(715,1268550000,3),(715,1289109600,2),(715,1299999600,3),(715,1320559200,2),(715,1331449200,3),(715,1352008800,2),(715,1362898800,3),(715,1383458400,2),(715,1394348400,3),(715,1414908000,2),(715,1425798000,4),(715,1520751600,3),(715,1541311200,2),(715,1552201200,3),(715,1572760800,2),(715,1583650800,3),(715,1604210400,2),(715,1615705200,3),(715,1636264800,2),(715,1647154800,3),(715,1667714400,2),(715,1678604400,3),(715,1699164000,2),(715,1710054000,3),(715,1730613600,2),(715,1741503600,3),(715,1762063200,2),(715,1772953200,3),(715,1793512800,2),(715,1805007600,3),(715,1825567200,2),(715,1836457200,3),(715,1857016800,2),(715,1867906800,3),(715,1888466400,2),(715,1899356400,3),(715,1919916000,2),(715,1930806000,3),(715,1951365600,2),(715,1962860400,3),(715,1983420000,2),(715,1994310000,3),(715,2014869600,2),(715,2025759600,3),(715,2046319200,2),(715,2057209200,3),(715,2077768800,2),(715,2088658800,3),(715,2109218400,2),(715,2120108400,3),(715,2140668000,2),(716,-2147483648,1),(716,-873057600,3),(716,-769395600,2),(716,-765399600,1),(717,-2147483648,1),(717,-873057600,3),(717,-769395600,2),(717,-765399600,1),(718,-2147483648,0),(718,-1617040676,2),(718,123055200,1),(718,130914000,2),(718,422344800,1),(718,433054800,2),(718,669708000,1),(718,684219600,2),(718,1146376800,1),(718,1159678800,2),(719,-2147483648,1),(719,-1230749160,3),(719,722926800,2),(719,728884800,3),(719,2147483647,3),(720,-2147483648,0),(720,-1843589241,1),(720,-1730577600,2),(720,176096700,3),(720,701841600,1),(720,2147483647,1),(721,-2147483648,0),(721,-2131645536,2),(721,-1696276800,1),(721,-1680469200,2),(721,-1632074400,1),(721,-1615143600,2),(721,-1566763200,1),(721,-1557090000,2),(721,-1535486400,1),(721,-1524949200,2),(721,-1504468800,1),(721,-1493413200,2),(721,-1472414400,1),(721,-1461963600,2),(721,-1440964800,1),(721,-1429390800,2),(721,-1409515200,1),(721,-1396731600,2),(721,-1376856000,1),(721,-1366491600,2),(721,-1346616000,1),(721,-1333832400,2),(721,-1313956800,1),(721,-1303678800,2),(721,-1282507200,1),(721,-1272661200,2),(721,-1251057600,1),(721,-1240088400,2),(721,-1219608000,1),(721,-1207429200,2),(721,-1188763200,1),(721,-1175979600,2),(721,-1157313600,1),(721,-1143925200,2),(721,-1124049600,1),(721,-1113771600,2),(721,-1091390400,1),(721,-1081026000,2),(721,-1059854400,1),(721,-1050786000,2),(721,-1030910400,1),(721,-1018126800,2),(721,-999460800,1),(721,-986677200,2),(721,-965592000,1),(721,-955227600,2),(721,-935956800,1),(721,-923173200,2),(721,-904507200,1),(721,-891723600,2),(721,-880221600,3),(721,-769395600,4),(721,-765399600,2),(721,-747252000,1),(721,-733950000,2),(721,-715802400,1),(721,-702500400,2),(721,-684352800,1),(721,-671050800,2),(721,-652903200,1),(721,-639601200,2),(721,-589399200,1),(721,-576097200,2),(721,-557949600,1),(721,-544647600,2),(721,-526500000,1),(721,-513198000,2),(721,-495050400,1),(721,-481748400,2),(721,-431546400,1),(721,-418244400,2),(721,-400096800,1),(721,-386794800,2),(721,-368647200,1),(721,-355345200,2),(721,-337197600,1),(721,-323895600,2),(721,-242244000,1),(721,-226522800,2),(721,-210794400,1),(721,-195073200,2),(721,-179344800,1),(721,-163623600,2),(721,-147895200,1),(721,-131569200,2),(721,-116445600,1),(721,-100119600,2),(721,-84391200,1),(721,-68670000,2),(721,-52941600,1),(721,-37220400,2),(721,-21492000,1),(721,-5770800,2),(721,9957600,1),(721,25678800,2),(721,41407200,1),(721,57733200,2),(721,73461600,1),(721,89182800,2),(721,104911200,1),(721,120632400,2),(721,136360800,1),(721,152082000,2),(721,167810400,1),(721,183531600,2),(721,199260000,1),(721,215586000,2),(721,230709600,1),(721,247035600,2),(721,262764000,1),(721,278485200,2),(721,294213600,1),(721,309934800,2),(721,325663200,1),(721,341384400,2),(721,357112800,1),(721,372834000,2),(721,388562400,1),(721,404888400,2),(721,420012000,1),(721,436338000,2),(721,452066400,1),(721,467787600,2),(721,483516000,1),(721,499237200,2),(721,514965600,1),(721,530686800,2),(721,544600800,1),(721,562136400,2),(721,576050400,1),(721,594190800,2),(721,607500000,1),(721,625640400,2),(721,638949600,1),(721,657090000,2),(721,671004000,1),(721,688539600,2),(721,702453600,1),(721,719989200,2),(721,733903200,1),(721,752043600,2),(721,765352800,1),(721,783493200,2),(721,796802400,1),(721,814942800,2),(721,828856800,1),(721,846392400,2),(721,860306400,1),(721,877842000,2),(721,891756000,1),(721,909291600,2),(721,923205600,1),(721,941346000,2),(721,954655200,1),(721,972795600,2),(721,986104800,1),(721,1004245200,2),(721,1018159200,1),(721,1035694800,2),(721,1049608800,1),(721,1067144400,2),(721,1081058400,1),(721,1099198800,2),(721,1112508000,1),(721,1130648400,2),(721,1143957600,1),(721,1162098000,2),(721,1173592800,1),(721,1194152400,2),(721,1205042400,1),(721,1225602000,2),(721,1236492000,1),(721,1257051600,2),(721,1268546400,1),(721,1289106000,2),(721,1299996000,1),(721,1320555600,2),(721,1331445600,1),(721,1352005200,2),(721,1362895200,1),(721,1383454800,2),(721,1394344800,1),(721,1414904400,2),(721,1425794400,1),(721,1446354000,2),(721,1457848800,1),(721,1478408400,2),(721,1489298400,1),(721,1509858000,2),(721,1520748000,1),(721,1541307600,2),(721,1552197600,1),(721,1572757200,2),(721,1583647200,1),(721,1604206800,2),(721,1615701600,1),(721,1636261200,2),(721,1647151200,1),(721,1667710800,2),(721,1678600800,1),(721,1699160400,2),(721,1710050400,1),(721,1730610000,2),(721,1741500000,1),(721,1762059600,2),(721,1772949600,1),(721,1793509200,2),(721,1805004000,1),(721,1825563600,2),(721,1836453600,1),(721,1857013200,2),(721,1867903200,1),(721,1888462800,2),(721,1899352800,1),(721,1919912400,2),(721,1930802400,1),(721,1951362000,2),(721,1962856800,1),(721,1983416400,2),(721,1994306400,1),(721,2014866000,2),(721,2025756000,1),(721,2046315600,2),(721,2057205600,1),(721,2077765200,2),(721,2088655200,1),(721,2109214800,2),(721,2120104800,1),(721,2140664400,2),(722,-2147483648,1),(722,-1402813824,3),(722,-1311534000,2),(722,-1300996800,3),(722,-933534000,2),(722,-925675200,3),(722,-902084400,2),(722,-893620800,3),(722,-870030000,2),(722,-862171200,3),(722,-775681200,2),(722,-767822400,3),(722,-744231600,2),(722,-736372800,3),(722,-144702000,2),(722,-134251200,3),(722,-113425200,2),(722,-102542400,3),(722,-86295600,2),(722,-72907200,3),(722,-54154800,2),(722,-41457600,3),(722,-21495600,2),(722,-5774400,3),(722,9954000,2),(722,25675200,3),(722,41403600,2),(722,57729600,3),(722,73458000,2),(722,87364800,3),(722,104907600,2),(722,118900800,3),(722,136357200,2),(722,150436800,3),(722,167806800,2),(722,183528000,3),(722,199256400,2),(722,215582400,3),(722,230706000,2),(722,247032000,3),(722,263365200,2),(722,276667200,3),(722,290581200,2),(722,308721600,3),(722,322030800,2),(722,340171200,3),(722,358318800,2),(722,371620800,3),(722,389768400,2),(722,403070400,3),(722,421218000,2),(722,434520000,3),(722,452667600,2),(722,466574400,3),(722,484117200,2),(722,498024000,3),(722,511333200,2),(722,529473600,3),(722,542782800,2),(722,560923200,3),(722,574837200,2),(722,592372800,3),(722,606286800,2),(722,623822400,3),(722,638946000,2),(722,655876800,3),(722,671000400,2),(722,687330000,4),(722,702450000,2),(722,718779600,4),(722,733899600,2),(722,750229200,4),(722,765349200,2),(722,781678800,4),(722,796798800,2),(722,813128400,4),(722,828853200,2),(722,844578000,4),(722,860302800,2),(722,876632400,4),(722,891147600,5),(722,909291600,4),(722,922597200,5),(722,941346000,4),(722,954651600,5),(722,972795600,4),(722,986101200,5),(722,1004245200,4),(722,1018155600,5),(722,1035694800,4),(722,1049605200,5),(722,1067144400,4),(722,1080450000,5),(722,1162098000,4),(722,1173589200,5),(722,1193547600,4),(722,1205643600,5),(722,1224997200,4),(722,1236488400,5),(722,1256446800,4),(722,1268542800,5),(722,1288501200,4),(722,1300597200,5),(722,1321160400,4),(722,1333256400,5),(722,1352005200,4),(722,1362891600,5),(722,1383454800,4),(722,1394341200,5),(722,1414904400,4),(722,1425790800,5),(722,1446354000,4),(722,1457845200,5),(722,1478408400,4),(722,1489294800,5),(722,1509858000,4),(722,1520744400,5),(722,1541307600,4),(722,1552194000,5),(722,1572757200,4),(722,1583643600,5),(722,1604206800,4),(722,1615698000,5),(722,1636261200,4),(722,1647147600,5),(722,1667710800,4),(722,1678597200,5),(722,1699160400,4),(722,1710046800,5),(722,1730610000,4),(722,1741496400,5),(722,1762059600,4),(722,1772946000,5),(722,1793509200,4),(722,1805000400,5),(722,1825563600,4),(722,1836450000,5),(722,1857013200,4),(722,1867899600,5),(722,1888462800,4),(722,1899349200,5),(722,1919912400,4),(722,1930798800,5),(722,1951362000,4),(722,1962853200,5),(722,1983416400,4),(722,1994302800,5),(722,2014866000,4),(722,2025752400,5),(722,2046315600,4),(722,2057202000,5),(722,2077765200,4),(722,2088651600,5),(722,2109214800,4),(722,2120101200,5),(722,2140664400,4),(723,-2147483648,0),(723,-1514739600,1),(723,-1343066400,2),(723,-1234807200,4),(723,-1220292000,3),(723,-1207159200,4),(723,-1191344400,2),(723,-873828000,4),(723,-661539600,5),(723,28800,4),(723,828867600,3),(723,846403200,4),(723,860317200,3),(723,877852800,4),(723,891766800,3),(723,909302400,4),(724,-2147483648,3),(724,-1633276800,1),(724,-1615136400,2),(724,-1601827200,1),(724,-1583686800,2),(724,-900259200,1),(724,-891795600,2),(724,-880214400,4),(724,-769395600,5),(724,-765392400,2),(724,-747244800,1),(724,-733942800,2),(724,-715795200,1),(724,-702493200,2),(724,-684345600,1),(724,-671043600,2),(724,-652896000,1),(724,-639594000,2),(724,-620841600,1),(724,-608144400,2),(724,-589392000,1),(724,-576090000,2),(724,-557942400,1),(724,-544640400,2),(724,-526492800,1),(724,-513190800,2),(724,-495043200,1),(724,-481741200,2),(724,-463593600,6),(724,-386787600,2),(724,-368640000,6),(724,-21488400,7),(724,-5767200,6),(724,9961200,7),(724,25682400,6),(724,1143961200,7),(724,1162101600,6),(724,1173596400,7),(724,1194156000,6),(724,1205046000,7),(724,1225605600,6),(724,1236495600,7),(724,1257055200,6),(724,1268550000,7),(724,1289109600,6),(724,1299999600,7),(724,1320559200,6),(724,1331449200,7),(724,1352008800,6),(724,1362898800,7),(724,1383458400,6),(724,1394348400,7),(724,1414908000,6),(724,1425798000,7),(724,1446357600,6),(724,1457852400,7),(724,1478412000,6),(724,1489302000,7),(724,1509861600,6),(724,1520751600,7),(724,1541311200,6),(724,1552201200,7),(724,1572760800,6),(724,1583650800,7),(724,1604210400,6),(724,1615705200,7),(724,1636264800,6),(724,1647154800,7),(724,1667714400,6),(724,1678604400,7),(724,1699164000,6),(724,1710054000,7),(724,1730613600,6),(724,1741503600,7),(724,1762063200,6),(724,1772953200,7),(724,1793512800,6),(724,1805007600,7),(724,1825567200,6),(724,1836457200,7),(724,1857016800,6),(724,1867906800,7),(724,1888466400,6),(724,1899356400,7),(724,1919916000,6),(724,1930806000,7),(724,1951365600,6),(724,1962860400,7),(724,1983420000,6),(724,1994310000,7),(724,2014869600,6),(724,2025759600,7),(724,2046319200,6),(724,2057209200,7),(724,2077768800,6),(724,2088658800,7),(724,2109218400,6),(724,2120108400,7),(724,2140668000,6),(725,-2147483648,5),(725,-1633276800,1),(725,-1615136400,2),(725,-1601827200,1),(725,-1583686800,2),(725,-880214400,3),(725,-769395600,4),(725,-765392400,2),(725,-715795200,1),(725,-702493200,2),(725,-684345600,1),(725,-671043600,2),(725,-652896000,1),(725,-639594000,2),(725,-620841600,1),(725,-608144400,2),(725,-589392000,1),(725,-576090000,2),(725,-557942400,1),(725,-544640400,2),(725,-526492800,1),(725,-513190800,2),(725,-495043200,1),(725,-481741200,2),(725,-463593600,1),(725,-447267600,2),(725,-431539200,1),(725,-415818000,2),(725,-400089600,1),(725,-386787600,2),(725,-368640000,1),(725,-355338000,2),(725,-337190400,1),(725,-321469200,2),(725,-305740800,1),(725,-289414800,2),(725,-273686400,1),(725,-257965200,2),(725,-242236800,6),(725,-195066000,2),(725,-84384000,1),(725,-68662800,2),(725,-52934400,1),(725,-37213200,2),(725,-21484800,1),(725,-5763600,2),(725,9964800,1),(725,25686000,2),(725,41414400,1),(725,57740400,2),(725,73468800,1),(725,89190000,2),(725,104918400,1),(725,120639600,2),(725,126691200,1),(725,152089200,2),(725,162374400,1),(725,183538800,2),(725,199267200,1),(725,215593200,2),(725,230716800,1),(725,247042800,2),(725,262771200,1),(725,278492400,2),(725,294220800,1),(725,309942000,2),(725,325670400,1),(725,341391600,2),(725,357120000,1),(725,372841200,2),(725,388569600,1),(725,404895600,2),(725,420019200,1),(725,436345200,2),(725,452073600,1),(725,467794800,2),(725,483523200,1),(725,499244400,2),(725,514972800,1),(725,530694000,2),(725,544608000,1),(725,562143600,2),(725,576057600,1),(725,594198000,2),(725,607507200,1),(725,625647600,2),(725,638956800,1),(725,657097200,2),(725,671011200,1),(725,688546800,6),(725,1143961200,1),(725,1162105200,2),(725,1173600000,1),(725,1194159600,2),(725,1205049600,1),(725,1225609200,2),(725,1236499200,1),(725,1257058800,2),(725,1268553600,1),(725,1289113200,2),(725,1300003200,1),(725,1320562800,2),(725,1331452800,1),(725,1352012400,2),(725,1362902400,1),(725,1383462000,2),(725,1394352000,1),(725,1414911600,2),(725,1425801600,1),(725,1446361200,2),(725,1457856000,1),(725,1478415600,2),(725,1489305600,1),(725,1509865200,2),(725,1520755200,1),(725,1541314800,2),(725,1552204800,1),(725,1572764400,2),(725,1583654400,1),(725,1604214000,2),(725,1615708800,1),(725,1636268400,2),(725,1647158400,1),(725,1667718000,2),(725,1678608000,1),(725,1699167600,2),(725,1710057600,1),(725,1730617200,2),(725,1741507200,1),(725,1762066800,2),(725,1772956800,1),(725,1793516400,2),(725,1805011200,1),(725,1825570800,2),(725,1836460800,1),(725,1857020400,2),(725,1867910400,1),(725,1888470000,2),(725,1899360000,1),(725,1919919600,2),(725,1930809600,1),(725,1951369200,2),(725,1962864000,1),(725,1983423600,2),(725,1994313600,1),(725,2014873200,2),(725,2025763200,1),(725,2046322800,2),(725,2057212800,1),(725,2077772400,2),(725,2088662400,1),(725,2109222000,2),(725,2120112000,1),(725,2140671600,2),(726,-2147483648,5),(726,-1633276800,1),(726,-1615136400,2),(726,-1601827200,1),(726,-1583686800,2),(726,-880214400,3),(726,-769395600,4),(726,-765392400,2),(726,-589392000,1),(726,-576090000,2),(726,-495043200,1),(726,-481741200,2),(726,-463593600,1),(726,-450291600,2),(726,-431539200,1),(726,-418237200,2),(726,-400089600,1),(726,-386787600,2),(726,-368640000,1),(726,-355338000,2),(726,-337190400,1),(726,-323888400,2),(726,-305740800,1),(726,-292438800,2),(726,-273686400,6),(726,-21488400,7),(726,-5767200,6),(726,9961200,7),(726,25682400,6),(726,41410800,7),(726,57736800,6),(726,73465200,7),(726,89186400,6),(726,104914800,7),(726,120636000,6),(726,126687600,1),(726,152089200,6),(726,162370800,7),(726,183535200,6),(726,1143961200,7),(726,1162101600,6),(726,1173596400,7),(726,1194156000,6),(726,1205046000,7),(726,1225605600,6),(726,1236495600,7),(726,1257055200,6),(726,1268550000,7),(726,1289109600,6),(726,1299999600,7),(726,1320559200,6),(726,1331449200,7),(726,1352008800,6),(726,1362898800,7),(726,1383458400,6),(726,1394348400,7),(726,1414908000,6),(726,1425798000,7),(726,1446357600,6),(726,1457852400,7),(726,1478412000,6),(726,1489302000,7),(726,1509861600,6),(726,1520751600,7),(726,1541311200,6),(726,1552201200,7),(726,1572760800,6),(726,1583650800,7),(726,1604210400,6),(726,1615705200,7),(726,1636264800,6),(726,1647154800,7),(726,1667714400,6),(726,1678604400,7),(726,1699164000,6),(726,1710054000,7),(726,1730613600,6),(726,1741503600,7),(726,1762063200,6),(726,1772953200,7),(726,1793512800,6),(726,1805007600,7),(726,1825567200,6),(726,1836457200,7),(726,1857016800,6),(726,1867906800,7),(726,1888466400,6),(726,1899356400,7),(726,1919916000,6),(726,1930806000,7),(726,1951365600,6),(726,1962860400,7),(726,1983420000,6),(726,1994310000,7),(726,2014869600,6),(726,2025759600,7),(726,2046319200,6),(726,2057209200,7),(726,2077768800,6),(726,2088658800,7),(726,2109218400,6),(726,2120108400,7),(726,2140668000,6),(727,-2147483648,5),(727,-1633276800,1),(727,-1615136400,2),(727,-1601827200,1),(727,-1583686800,2),(727,-880214400,3),(727,-769395600,4),(727,-765392400,2),(727,-462996000,1),(727,-450291600,2),(727,-431539200,1),(727,-418237200,2),(727,-400089600,1),(727,-386787600,2),(727,-368640000,1),(727,-355338000,2),(727,-337190400,1),(727,-323888400,2),(727,-305740800,1),(727,-292438800,2),(727,-273686400,1),(727,-257965200,2),(727,-242236800,1),(727,-226515600,2),(727,-210787200,1),(727,-195066000,2),(727,-179337600,1),(727,-163616400,2),(727,-147888000,6),(727,-100112400,2),(727,-84384000,1),(727,-68662800,2),(727,-52934400,1),(727,-37213200,2),(727,-21484800,1),(727,-5763600,2),(727,9964800,1),(727,25686000,2),(727,41414400,1),(727,57740400,2),(727,73468800,1),(727,89190000,2),(727,104918400,1),(727,120639600,2),(727,126691200,1),(727,152089200,2),(727,162374400,1),(727,183538800,2),(727,199267200,1),(727,215593200,2),(727,230716800,1),(727,247042800,6),(727,1143961200,1),(727,1162105200,2),(727,1173600000,1),(727,1194159600,6),(727,1205046000,7),(727,1225605600,6),(727,1236495600,7),(727,1257055200,6),(727,1268550000,7),(727,1289109600,6),(727,1299999600,7),(727,1320559200,6),(727,1331449200,7),(727,1352008800,6),(727,1362898800,7),(727,1383458400,6),(727,1394348400,7),(727,1414908000,6),(727,1425798000,7),(727,1446357600,6),(727,1457852400,7),(727,1478412000,6),(727,1489302000,7),(727,1509861600,6),(727,1520751600,7),(727,1541311200,6),(727,1552201200,7),(727,1572760800,6),(727,1583650800,7),(727,1604210400,6),(727,1615705200,7),(727,1636264800,6),(727,1647154800,7),(727,1667714400,6),(727,1678604400,7),(727,1699164000,6),(727,1710054000,7),(727,1730613600,6),(727,1741503600,7),(727,1762063200,6),(727,1772953200,7),(727,1793512800,6),(727,1805007600,7),(727,1825567200,6),(727,1836457200,7),(727,1857016800,6),(727,1867906800,7),(727,1888466400,6),(727,1899356400,7),(727,1919916000,6),(727,1930806000,7),(727,1951365600,6),(727,1962860400,7),(727,1983420000,6),(727,1994310000,7),(727,2014869600,6),(727,2025759600,7),(727,2046319200,6),(727,2057209200,7),(727,2077768800,6),(727,2088658800,7),(727,2109218400,6),(727,2120108400,7),(727,2140668000,6),(728,-2147483648,5),(728,-1633276800,1),(728,-1615136400,2),(728,-1601827200,1),(728,-1583686800,2),(728,-880214400,3),(728,-769395600,4),(728,-765392400,2),(728,-462996000,1),(728,-450291600,2),(728,-431539200,1),(728,-418237200,2),(728,-400089600,1),(728,-386787600,2),(728,-368640000,1),(728,-355338000,2),(728,-337190400,1),(728,-323888400,2),(728,-305740800,1),(728,-292438800,2),(728,-273686400,1),(728,-257965200,2),(728,-242236800,1),(728,-226515600,2),(728,-210787200,1),(728,-195066000,2),(728,-179337600,6),(728,-68662800,2),(728,-52934400,1),(728,-37213200,2),(728,-21484800,7),(728,-5767200,6),(728,9961200,7),(728,25682400,6),(728,1143961200,1),(728,1162105200,2),(728,1173600000,1),(728,1194159600,2),(728,1205049600,1),(728,1225609200,2),(728,1236499200,1),(728,1257058800,2),(728,1268553600,1),(728,1289113200,2),(728,1300003200,1),(728,1320562800,2),(728,1331452800,1),(728,1352012400,2),(728,1362902400,1),(728,1383462000,2),(728,1394352000,1),(728,1414911600,2),(728,1425801600,1),(728,1446361200,2),(728,1457856000,1),(728,1478415600,2),(728,1489305600,1),(728,1509865200,2),(728,1520755200,1),(728,1541314800,2),(728,1552204800,1),(728,1572764400,2),(728,1583654400,1),(728,1604214000,2),(728,1615708800,1),(728,1636268400,2),(728,1647158400,1),(728,1667718000,2),(728,1678608000,1),(728,1699167600,2),(728,1710057600,1),(728,1730617200,2),(728,1741507200,1),(728,1762066800,2),(728,1772956800,1),(728,1793516400,2),(728,1805011200,1),(728,1825570800,2),(728,1836460800,1),(728,1857020400,2),(728,1867910400,1),(728,1888470000,2),(728,1899360000,1),(728,1919919600,2),(728,1930809600,1),(728,1951369200,2),(728,1962864000,1),(728,1983423600,2),(728,1994313600,1),(728,2014873200,2),(728,2025763200,1),(728,2046322800,2),(728,2057212800,1),(728,2077772400,2),(728,2088662400,1),(728,2109222000,2),(728,2120112000,1),(728,2140671600,2),(729,-2147483648,5),(729,-1633276800,1),(729,-1615136400,2),(729,-1601827200,1),(729,-1583686800,2),(729,-880214400,3),(729,-769395600,4),(729,-765392400,2),(729,-495043200,6),(729,-21488400,7),(729,-5767200,6),(729,9961200,7),(729,25682400,6),(729,41410800,7),(729,57736800,6),(729,73465200,7),(729,89186400,6),(729,1143961200,7),(729,1162101600,6),(729,1173596400,7),(729,1194156000,6),(729,1205046000,7),(729,1225605600,6),(729,1236495600,7),(729,1257055200,6),(729,1268550000,7),(729,1289109600,6),(729,1299999600,7),(729,1320559200,6),(729,1331449200,7),(729,1352008800,6),(729,1362898800,7),(729,1383458400,6),(729,1394348400,7),(729,1414908000,6),(729,1425798000,7),(729,1446357600,6),(729,1457852400,7),(729,1478412000,6),(729,1489302000,7),(729,1509861600,6),(729,1520751600,7),(729,1541311200,6),(729,1552201200,7),(729,1572760800,6),(729,1583650800,7),(729,1604210400,6),(729,1615705200,7),(729,1636264800,6),(729,1647154800,7),(729,1667714400,6),(729,1678604400,7),(729,1699164000,6),(729,1710054000,7),(729,1730613600,6),(729,1741503600,7),(729,1762063200,6),(729,1772953200,7),(729,1793512800,6),(729,1805007600,7),(729,1825567200,6),(729,1836457200,7),(729,1857016800,6),(729,1867906800,7),(729,1888466400,6),(729,1899356400,7),(729,1919916000,6),(729,1930806000,7),(729,1951365600,6),(729,1962860400,7),(729,1983420000,6),(729,1994310000,7),(729,2014869600,6),(729,2025759600,7),(729,2046319200,6),(729,2057209200,7),(729,2077768800,6),(729,2088658800,7),(729,2109218400,6),(729,2120108400,7),(729,2140668000,6),(730,-2147483648,5),(730,-1633276800,1),(730,-1615136400,2),(730,-1601827200,1),(730,-1583686800,2),(730,-880214400,3),(730,-769395600,4),(730,-765392400,2),(730,-747244800,1),(730,-733942800,2),(730,-526492800,1),(730,-513190800,2),(730,-495043200,1),(730,-481741200,2),(730,-462996000,1),(730,-450291600,2),(730,-431539200,1),(730,-418237200,2),(730,-400089600,1),(730,-386787600,2),(730,-368640000,1),(730,-355338000,2),(730,-337190400,1),(730,-323888400,2),(730,-305740800,1),(730,-289414800,2),(730,-273686400,1),(730,-260989200,2),(730,-242236800,1),(730,-226515600,2),(730,-210787200,1),(730,-195066000,2),(730,-179337600,6),(730,-21488400,7),(730,-5767200,6),(730,9961200,7),(730,25682400,6),(730,1143961200,1),(730,1162105200,2),(730,1173600000,1),(730,1194159600,6),(730,1205046000,7),(730,1225605600,6),(730,1236495600,7),(730,1257055200,6),(730,1268550000,7),(730,1289109600,6),(730,1299999600,7),(730,1320559200,6),(730,1331449200,7),(730,1352008800,6),(730,1362898800,7),(730,1383458400,6),(730,1394348400,7),(730,1414908000,6),(730,1425798000,7),(730,1446357600,6),(730,1457852400,7),(730,1478412000,6),(730,1489302000,7),(730,1509861600,6),(730,1520751600,7),(730,1541311200,6),(730,1552201200,7),(730,1572760800,6),(730,1583650800,7),(730,1604210400,6),(730,1615705200,7),(730,1636264800,6),(730,1647154800,7),(730,1667714400,6),(730,1678604400,7),(730,1699164000,6),(730,1710054000,7),(730,1730613600,6),(730,1741503600,7),(730,1762063200,6),(730,1772953200,7),(730,1793512800,6),(730,1805007600,7),(730,1825567200,6),(730,1836457200,7),(730,1857016800,6),(730,1867906800,7),(730,1888466400,6),(730,1899356400,7),(730,1919916000,6),(730,1930806000,7),(730,1951365600,6),(730,1962860400,7),(730,1983420000,6),(730,1994310000,7),(730,2014869600,6),(730,2025759600,7),(730,2046319200,6),(730,2057209200,7),(730,2077768800,6),(730,2088658800,7),(730,2109218400,6),(730,2120108400,7),(730,2140668000,6),(731,-2147483648,5),(731,-1633276800,1),(731,-1615136400,2),(731,-1601827200,1),(731,-1583686800,2),(731,-880214400,3),(731,-769395600,4),(731,-765392400,2),(731,-747244800,1),(731,-733942800,2),(731,-715795200,1),(731,-702493200,2),(731,-684345600,1),(731,-671043600,2),(731,-652896000,1),(731,-639594000,2),(731,-620841600,1),(731,-608144400,2),(731,-589392000,1),(731,-576090000,2),(731,-557942400,1),(731,-544640400,2),(731,-526492800,1),(731,-513190800,2),(731,-495043200,1),(731,-481741200,2),(731,-463593600,1),(731,-447267600,2),(731,-431539200,1),(731,-415818000,2),(731,-400089600,1),(731,-386787600,2),(731,-368640000,1),(731,-355338000,2),(731,-337190400,1),(731,-323888400,2),(731,-305740800,1),(731,-292438800,2),(731,-273686400,6),(731,-21488400,7),(731,-5767200,6),(731,9961200,7),(731,25682400,6),(731,1143961200,1),(731,1162105200,2),(731,1173600000,7),(731,1194156000,6),(731,1205046000,7),(731,1225605600,6),(731,1236495600,7),(731,1257055200,6),(731,1268550000,7),(731,1289109600,6),(731,1299999600,7),(731,1320559200,6),(731,1331449200,7),(731,1352008800,6),(731,1362898800,7),(731,1383458400,6),(731,1394348400,7),(731,1414908000,6),(731,1425798000,7),(731,1446357600,6),(731,1457852400,7),(731,1478412000,6),(731,1489302000,7),(731,1509861600,6),(731,1520751600,7),(731,1541311200,6),(731,1552201200,7),(731,1572760800,6),(731,1583650800,7),(731,1604210400,6),(731,1615705200,7),(731,1636264800,6),(731,1647154800,7),(731,1667714400,6),(731,1678604400,7),(731,1699164000,6),(731,1710054000,7),(731,1730613600,6),(731,1741503600,7),(731,1762063200,6),(731,1772953200,7),(731,1793512800,6),(731,1805007600,7),(731,1825567200,6),(731,1836457200,7),(731,1857016800,6),(731,1867906800,7),(731,1888466400,6),(731,1899356400,7),(731,1919916000,6),(731,1930806000,7),(731,1951365600,6),(731,1962860400,7),(731,1983420000,6),(731,1994310000,7),(731,2014869600,6),(731,2025759600,7),(731,2046319200,6),(731,2057209200,7),(731,2077768800,6),(731,2088658800,7),(731,2109218400,6),(731,2120108400,7),(731,2140668000,6),(732,-2147483648,3),(732,-1633276800,1),(732,-1615136400,2),(732,-1601827200,1),(732,-1583686800,2),(732,-900259200,1),(732,-891795600,2),(732,-880214400,4),(732,-769395600,5),(732,-765392400,2),(732,-747244800,1),(732,-733942800,2),(732,-715795200,1),(732,-702493200,2),(732,-684345600,1),(732,-671043600,2),(732,-652896000,1),(732,-639594000,2),(732,-620841600,1),(732,-608144400,2),(732,-589392000,1),(732,-576090000,2),(732,-557942400,1),(732,-544640400,2),(732,-526492800,1),(732,-513190800,2),(732,-495043200,1),(732,-481741200,2),(732,-463593600,6),(732,-386787600,2),(732,-368640000,6),(732,-21488400,7),(732,-5767200,6),(732,9961200,7),(732,25682400,6),(732,1143961200,7),(732,1162101600,6),(732,1173596400,7),(732,1194156000,6),(732,1205046000,7),(732,1225605600,6),(732,1236495600,7),(732,1257055200,6),(732,1268550000,7),(732,1289109600,6),(732,1299999600,7),(732,1320559200,6),(732,1331449200,7),(732,1352008800,6),(732,1362898800,7),(732,1383458400,6),(732,1394348400,7),(732,1414908000,6),(732,1425798000,7),(732,1446357600,6),(732,1457852400,7),(732,1478412000,6),(732,1489302000,7),(732,1509861600,6),(732,1520751600,7),(732,1541311200,6),(732,1552201200,7),(732,1572760800,6),(732,1583650800,7),(732,1604210400,6),(732,1615705200,7),(732,1636264800,6),(732,1647154800,7),(732,1667714400,6),(732,1678604400,7),(732,1699164000,6),(732,1710054000,7),(732,1730613600,6),(732,1741503600,7),(732,1762063200,6),(732,1772953200,7),(732,1793512800,6),(732,1805007600,7),(732,1825567200,6),(732,1836457200,7),(732,1857016800,6),(732,1867906800,7),(732,1888466400,6),(732,1899356400,7),(732,1919916000,6),(732,1930806000,7),(732,1951365600,6),(732,1962860400,7),(732,1983420000,6),(732,1994310000,7),(732,2014869600,6),(732,2025759600,7),(732,2046319200,6),(732,2057209200,7),(732,2077768800,6),(732,2088658800,7),(732,2109218400,6),(732,2120108400,7),(732,2140668000,6),(733,-2147483648,0),(733,-536457600,2),(733,73476000,1),(733,89197200,2),(733,104925600,1),(733,120646800,2),(733,136375200,1),(733,152096400,2),(733,167824800,1),(733,183546000,2),(733,199274400,1),(733,215600400,2),(733,230724000,1),(733,247050000,2),(733,262778400,1),(733,278499600,2),(733,294228000,4),(733,309945600,3),(733,325674000,4),(733,341395200,3),(733,357123600,4),(733,372844800,3),(733,388573200,4),(733,404899200,3),(733,420022800,4),(733,436348800,3),(733,452077200,4),(733,467798400,3),(733,483526800,4),(733,499248000,3),(733,514976400,4),(733,530697600,3),(733,544611600,4),(733,562147200,3),(733,576061200,4),(733,594201600,3),(733,607510800,4),(733,625651200,3),(733,638960400,4),(733,657100800,3),(733,671014800,4),(733,688550400,3),(733,702464400,4),(733,720000000,3),(733,733914000,4),(733,752054400,3),(733,765363600,4),(733,783504000,3),(733,796813200,4),(733,814953600,3),(733,828867600,4),(733,846403200,3),(733,860317200,4),(733,877852800,3),(733,891766800,4),(733,909302400,3),(733,923216400,4),(733,941356800,3),(733,954666000,4),(733,972806400,3),(733,986115600,4),(733,1004256000,3),(733,1018170000,4),(733,1035705600,3),(733,1049619600,4),(733,1067155200,3),(733,1081069200,4),(733,1099209600,3),(733,1112518800,4),(733,1130659200,3),(733,1143968400,4),(733,1162108800,3),(733,1173603600,4),(733,1194163200,3),(733,1205053200,4),(733,1225612800,3),(733,1236502800,4),(733,1257062400,3),(733,1268557200,4),(733,1289116800,3),(733,1300006800,4),(733,1320566400,3),(733,1331456400,4),(733,1352016000,3),(733,1362906000,4),(733,1383465600,3),(733,1394355600,4),(733,1414915200,3),(733,1425805200,4),(733,1446364800,3),(733,1457859600,4),(733,1478419200,3),(733,1489309200,4),(733,1509868800,3),(733,1520758800,4),(733,1541318400,3),(733,1552208400,4),(733,1572768000,3),(733,1583658000,4),(733,1604217600,3),(733,1615712400,4),(733,1636272000,3),(733,1647162000,4),(733,1667721600,3),(733,1678611600,4),(733,1699171200,3),(733,1710061200,4),(733,1730620800,3),(733,1741510800,4),(733,1762070400,3),(733,1772960400,4),(733,1793520000,3),(733,1805014800,4),(733,1825574400,3),(733,1836464400,4),(733,1857024000,3),(733,1867914000,4),(733,1888473600,3),(733,1899363600,4),(733,1919923200,3),(733,1930813200,4),(733,1951372800,3),(733,1962867600,4),(733,1983427200,3),(733,1994317200,4),(733,2014876800,3),(733,2025766800,4),(733,2046326400,3),(733,2057216400,4),(733,2077776000,3),(733,2088666000,4),(733,2109225600,3),(733,2120115600,4),(733,2140675200,3),(734,-2147483648,0),(734,-865296000,4),(734,-769395600,1),(734,-765396000,2),(734,73465200,3),(734,89186400,2),(734,104914800,3),(734,120636000,2),(734,136364400,3),(734,152085600,2),(734,167814000,3),(734,183535200,2),(734,199263600,3),(734,215589600,2),(734,230713200,3),(734,247039200,2),(734,262767600,3),(734,278488800,2),(734,294217200,3),(734,309938400,2),(734,325666800,3),(734,341388000,2),(734,357116400,3),(734,372837600,2),(734,388566000,3),(734,404892000,2),(734,420015600,3),(734,436341600,2),(734,452070000,3),(734,467791200,2),(734,483519600,3),(734,499240800,2),(734,514969200,3),(734,530690400,2),(734,544604400,3),(734,562140000,2),(734,576054000,3),(734,594194400,2),(734,607503600,3),(734,625644000,2),(734,638953200,3),(734,657093600,2),(734,671007600,3),(734,688543200,2),(734,702457200,3),(734,719992800,2),(734,733906800,3),(734,752047200,2),(734,765356400,3),(734,783496800,2),(734,796806000,3),(734,814946400,2),(734,828860400,3),(734,846396000,2),(734,860310000,3),(734,877845600,2),(734,891759600,3),(734,909295200,2),(734,923209200,3),(734,941349600,5),(734,954662400,6),(734,972802800,2),(734,986108400,3),(734,1004248800,2),(734,1018162800,3),(734,1035698400,2),(734,1049612400,3),(734,1067148000,2),(734,1081062000,3),(734,1099202400,2),(734,1112511600,3),(734,1130652000,2),(734,1143961200,3),(734,1162101600,2),(734,1173596400,3),(734,1194156000,2),(734,1205046000,3),(734,1225605600,2),(734,1236495600,3),(734,1257055200,2),(734,1268550000,3),(734,1289109600,2),(734,1299999600,3),(734,1320559200,2),(734,1331449200,3),(734,1352008800,2),(734,1362898800,3),(734,1383458400,2),(734,1394348400,3),(734,1414908000,2),(734,1425798000,3),(734,1446357600,2),(734,1457852400,3),(734,1478412000,2),(734,1489302000,3),(734,1509861600,2),(734,1520751600,3),(734,1541311200,2),(734,1552201200,3),(734,1572760800,2),(734,1583650800,3),(734,1604210400,2),(734,1615705200,3),(734,1636264800,2),(734,1647154800,3),(734,1667714400,2),(734,1678604400,3),(734,1699164000,2),(734,1710054000,3),(734,1730613600,2),(734,1741503600,3),(734,1762063200,2),(734,1772953200,3),(734,1793512800,2),(734,1805007600,3),(734,1825567200,2),(734,1836457200,3),(734,1857016800,2),(734,1867906800,3),(734,1888466400,2),(734,1899356400,3),(734,1919916000,2),(734,1930806000,3),(734,1951365600,2),(734,1962860400,3),(734,1983420000,2),(734,1994310000,3),(734,2014869600,2),(734,2025759600,3),(734,2046319200,2),(734,2057209200,3),(734,2077768800,2),(734,2088658800,3),(734,2109218400,2),(734,2120108400,3),(734,2140668000,2),(735,-2147483648,1),(735,-1827687170,2),(735,126687600,3),(735,152085600,2),(735,162370800,3),(735,183535200,2),(735,199263600,3),(735,215589600,2),(735,230713200,3),(735,247039200,2),(735,262767600,3),(735,278488800,2),(735,294217200,3),(735,309938400,2),(735,325666800,3),(735,341388000,2),(735,357116400,3),(735,372837600,2),(735,388566000,3),(735,404892000,2),(735,420015600,3),(735,436341600,2),(736,-2147483648,1),(736,-1567453392,2),(736,-1233432000,3),(736,-1222981200,2),(736,-1205956800,3),(736,-1194037200,2),(736,-1172865600,3),(736,-1162501200,2),(736,-1141329600,3),(736,-1130965200,2),(736,-1109793600,3),(736,-1099429200,2),(736,-1078257600,3),(736,-1067806800,2),(736,-1046635200,3),(736,-1036270800,2),(736,-1015099200,3),(736,-1004734800,2),(736,-983563200,3),(736,-973198800,2),(736,-952027200,3),(736,-941576400,2),(736,-931032000,3),(736,-900882000,2),(736,-890337600,3),(736,-833749200,2),(736,-827265600,3),(736,-752274000,2),(736,-733780800,3),(736,-197326800,2),(736,-190843200,3),(736,-184194000,2),(736,-164491200,3),(736,-152658000,2),(736,-132955200,3),(736,-121122000,2),(736,-101419200,3),(736,-86821200,2),(736,-71092800,3),(736,-54766800,2),(736,-39038400,3),(736,-23317200,2),(736,-7588800,5),(736,128142000,4),(736,136605600,5),(736,596948400,4),(736,605066400,5),(736,624423600,4),(736,636516000,2),(736,657086400,3),(736,669178800,2),(736,686721600,4),(736,699415200,5),(736,719377200,4),(736,731469600,5),(736,938919600,3),(736,952052400,5),(736,1198983600,4),(736,1205632800,5),(736,2147483647,5),(737,-2147483648,1),(737,-880207200,2),(737,-769395600,3),(737,-765385200,1),(737,-21477600,4),(737,-5756400,1),(737,9972000,4),(737,25693200,1),(737,41421600,4),(737,57747600,1),(737,73476000,4),(737,89197200,1),(737,104925600,4),(737,120646800,1),(737,126698400,4),(737,152096400,1),(737,162381600,4),(737,183546000,1),(737,199274400,4),(737,215600400,1),(737,230724000,4),(737,247050000,1),(737,262778400,4),(737,278499600,1),(737,294228000,4),(737,309949200,1),(737,325677600,5),(737,341402400,1),(737,357127200,4),(737,372848400,1),(737,388576800,4),(737,404902800,1),(737,420026400,4),(737,436352400,6),(737,439030800,8),(737,452084400,7),(737,467805600,8),(737,483534000,7),(737,499255200,8),(737,514983600,7),(737,530704800,8),(737,544618800,7),(737,562154400,8),(737,576068400,7),(737,594208800,8),(737,607518000,7),(737,625658400,8),(737,638967600,7),(737,657108000,8),(737,671022000,7),(737,688557600,8),(737,702471600,7),(737,720007200,8),(737,733921200,7),(737,752061600,8),(737,765370800,7),(737,783511200,8),(737,796820400,7),(737,814960800,8),(737,828874800,7),(737,846410400,8),(737,860324400,7),(737,877860000,8),(737,891774000,7),(737,909309600,8),(737,923223600,7),(737,941364000,8),(737,954673200,7),(737,972813600,8),(737,986122800,7),(737,1004263200,8),(737,1018177200,7),(737,1035712800,8),(737,1049626800,7),(737,1067162400,8),(737,1081076400,7),(737,1099216800,8),(737,1112526000,7),(737,1130666400,8),(737,1143975600,7),(737,1162116000,8),(737,1173610800,7),(737,1194170400,8),(737,1205060400,7),(737,1225620000,8),(737,1236510000,7),(737,1257069600,8),(737,1268564400,7),(737,1289124000,8),(737,1300014000,7),(737,1320573600,8),(737,1331463600,7),(737,1352023200,8),(737,1362913200,7),(737,1383472800,8),(737,1394362800,7),(737,1414922400,8),(737,1425812400,7),(737,1446372000,8),(737,1457866800,7),(737,1478426400,8),(737,1489316400,7),(737,1509876000,8),(737,1520766000,7),(737,1541325600,8),(737,1552215600,7),(737,1572775200,8),(737,1583665200,7),(737,1604224800,8),(737,1615719600,7),(737,1636279200,8),(737,1647169200,7),(737,1667728800,8),(737,1678618800,7),(737,1699178400,8),(737,1710068400,7),(737,1730628000,8),(737,1741518000,7),(737,1762077600,8),(737,1772967600,7),(737,1793527200,8),(737,1805022000,7),(737,1825581600,8),(737,1836471600,7),(737,1857031200,8),(737,1867921200,7),(737,1888480800,8),(737,1899370800,7),(737,1919930400,8),(737,1930820400,7),(737,1951380000,8),(737,1962874800,7),(737,1983434400,8),(737,1994324400,7),(737,2014884000,8),(737,2025774000,7),(737,2046333600,8),(737,2057223600,7),(737,2077783200,8),(737,2088673200,7),(737,2109232800,8),(737,2120122800,7),(737,2140682400,8),(738,-2147483648,3),(738,-1633276800,1),(738,-1615136400,2),(738,-1601827200,1),(738,-1583686800,2),(738,-1535904000,1),(738,-1525280400,2),(738,-905097600,1),(738,-891795600,2),(738,-880214400,4),(738,-769395600,5),(738,-765392400,2),(738,-747251940,1),(738,-744224400,2),(738,-620841600,1),(738,-608144400,2),(738,-589392000,1),(738,-576090000,2),(738,-557942400,1),(738,-544640400,2),(738,-526492800,1),(738,-513190800,2),(738,-495043200,1),(738,-481741200,2),(738,-463593600,1),(738,-450291600,2),(738,-431539200,1),(738,-415818000,2),(738,-400089600,1),(738,-384368400,2),(738,-368640000,1),(738,-352918800,2),(738,-337190400,1),(738,-321469200,2),(738,-305740800,1),(738,-289414800,2),(738,-273686400,1),(738,-266432400,6),(738,-52938000,7),(738,-37216800,6),(738,-21488400,7),(738,-5767200,6),(738,9961200,7),(738,25682400,6),(738,41410800,7),(738,57736800,6),(738,73465200,7),(738,89186400,6),(738,104914800,7),(738,120636000,6),(738,126687600,1),(738,152089200,6),(738,162370800,7),(738,183535200,6),(738,199263600,7),(738,215589600,6),(738,230713200,7),(738,247039200,6),(738,262767600,7),(738,278488800,6),(738,294217200,7),(738,309938400,6),(738,325666800,7),(738,341388000,6),(738,357116400,7),(738,372837600,6),(738,388566000,7),(738,404892000,6),(738,420015600,7),(738,436341600,6),(738,452070000,7),(738,467791200,6),(738,483519600,7),(738,499240800,6),(738,514969200,7),(738,530690400,6),(738,544604400,7),(738,562140000,6),(738,576054000,7),(738,594194400,6),(738,607503600,7),(738,625644000,6),(738,638953200,7),(738,657093600,6),(738,671007600,7),(738,688543200,6),(738,702457200,7),(738,719992800,6),(738,733906800,7),(738,752047200,6),(738,765356400,7),(738,783496800,6),(738,796806000,7),(738,814946400,6),(738,828860400,7),(738,846396000,6),(738,860310000,7),(738,877845600,6),(738,891759600,7),(738,909295200,6),(738,923209200,7),(738,941349600,6),(738,954658800,7),(738,972799200,6),(738,986108400,7),(738,1004248800,6),(738,1018162800,7),(738,1035698400,6),(738,1049612400,7),(738,1067148000,6),(738,1081062000,7),(738,1099202400,6),(738,1112511600,7),(738,1130652000,6),(738,1143961200,7),(738,1162101600,6),(738,1173596400,7),(738,1194156000,6),(738,1205046000,7),(738,1225605600,6),(738,1236495600,7),(738,1257055200,6),(738,1268550000,7),(738,1289109600,6),(738,1299999600,7),(738,1320559200,6),(738,1331449200,7),(738,1352008800,6),(738,1362898800,7),(738,1383458400,6),(738,1394348400,7),(738,1414908000,6),(738,1425798000,7),(738,1446357600,6),(738,1457852400,7),(738,1478412000,6),(738,1489302000,7),(738,1509861600,6),(738,1520751600,7),(738,1541311200,6),(738,1552201200,7),(738,1572760800,6),(738,1583650800,7),(738,1604210400,6),(738,1615705200,7),(738,1636264800,6),(738,1647154800,7),(738,1667714400,6),(738,1678604400,7),(738,1699164000,6),(738,1710054000,7),(738,1730613600,6),(738,1741503600,7),(738,1762063200,6),(738,1772953200,7),(738,1793512800,6),(738,1805007600,7),(738,1825567200,6),(738,1836457200,7),(738,1857016800,6),(738,1867906800,7),(738,1888466400,6),(738,1899356400,7),(738,1919916000,6),(738,1930806000,7),(738,1951365600,6),(738,1962860400,7),(738,1983420000,6),(738,1994310000,7),(738,2014869600,6),(738,2025759600,7),(738,2046319200,6),(738,2057209200,7),(738,2077768800,6),(738,2088658800,7),(738,2109218400,6),(738,2120108400,7),(738,2140668000,6),(739,-2147483648,5),(739,-1633276800,1),(739,-1615136400,2),(739,-1601827200,1),(739,-1583686800,2),(739,-880214400,3),(739,-769395600,4),(739,-765392400,2),(739,-52934400,1),(739,-37213200,2),(739,-21484800,1),(739,-5763600,2),(739,9964800,1),(739,25686000,2),(739,41414400,1),(739,57740400,2),(739,73468800,1),(739,89190000,2),(739,104918400,1),(739,120639600,2),(739,126691200,1),(739,152089200,2),(739,162374400,1),(739,183538800,2),(739,199267200,1),(739,215593200,2),(739,230716800,1),(739,247042800,2),(739,262771200,1),(739,278492400,2),(739,294220800,1),(739,309942000,2),(739,325670400,1),(739,341391600,2),(739,357120000,1),(739,372841200,2),(739,388569600,1),(739,404895600,2),(739,420019200,1),(739,436345200,2),(739,452073600,1),(739,467794800,2),(739,483523200,1),(739,499244400,2),(739,514972800,1),(739,530694000,2),(739,544608000,1),(739,562143600,2),(739,576057600,1),(739,594198000,2),(739,607507200,1),(739,625647600,2),(739,638956800,1),(739,657097200,2),(739,671011200,1),(739,688546800,2),(739,702460800,1),(739,719996400,2),(739,733910400,1),(739,752050800,2),(739,765360000,1),(739,783500400,2),(739,796809600,1),(739,814950000,2),(739,828864000,1),(739,846399600,2),(739,860313600,1),(739,877849200,2),(739,891763200,1),(739,909298800,2),(739,923212800,1),(739,941353200,2),(739,954662400,1),(739,972802800,7),(739,986108400,6),(739,1004248800,7),(739,1018162800,6),(739,1035698400,7),(739,1049612400,6),(739,1067148000,7),(739,1081062000,6),(739,1099202400,7),(739,1112511600,6),(739,1130652000,7),(739,1143961200,6),(739,1162101600,7),(739,1173596400,6),(739,1194156000,7),(739,1205046000,6),(739,1225605600,7),(739,1236495600,6),(739,1257055200,7),(739,1268550000,6),(739,1289109600,7),(739,1299999600,6),(739,1320559200,7),(739,1331449200,6),(739,1352008800,7),(739,1362898800,6),(739,1383458400,7),(739,1394348400,6),(739,1414908000,7),(739,1425798000,6),(739,1446357600,7),(739,1457852400,6),(739,1478412000,7),(739,1489302000,6),(739,1509861600,7),(739,1520751600,6),(739,1541311200,7),(739,1552201200,6),(739,1572760800,7),(739,1583650800,6),(739,1604210400,7),(739,1615705200,6),(739,1636264800,7),(739,1647154800,6),(739,1667714400,7),(739,1678604400,6),(739,1699164000,7),(739,1710054000,6),(739,1730613600,7),(739,1741503600,6),(739,1762063200,7),(739,1772953200,6),(739,1793512800,7),(739,1805007600,6),(739,1825567200,7),(739,1836457200,6),(739,1857016800,7),(739,1867906800,6),(739,1888466400,7),(739,1899356400,6),(739,1919916000,7),(739,1930806000,6),(739,1951365600,7),(739,1962860400,6),(739,1983420000,7),(739,1994310000,6),(739,2014869600,7),(739,2025759600,6),(739,2046319200,7),(739,2057209200,6),(739,2077768800,7),(739,2088658800,6),(739,2109218400,7),(739,2120108400,6),(739,2140668000,7),(740,-2147483648,5),(740,-1633276800,1),(740,-1615136400,2),(740,-1601827200,1),(740,-1583686800,2),(740,-880214400,3),(740,-769395600,4),(740,-765392400,2),(740,-715795200,1),(740,-702493200,2),(740,-684345600,1),(740,-671043600,2),(740,-652896000,1),(740,-639594000,2),(740,-620841600,1),(740,-608144400,2),(740,-589392000,1),(740,-576090000,2),(740,-557942400,1),(740,-544640400,2),(740,-526492800,1),(740,-513190800,2),(740,-495043200,1),(740,-481741200,2),(740,-463593600,1),(740,-447267600,2),(740,-431539200,1),(740,-415818000,2),(740,-400089600,1),(740,-386787600,2),(740,-368640000,1),(740,-355338000,2),(740,-337190400,1),(740,-321469200,2),(740,-305740800,1),(740,-289414800,2),(740,-273686400,1),(740,-257965200,2),(740,-242236800,6),(740,-195066000,2),(740,-84384000,1),(740,-68662800,2),(740,-52934400,1),(740,-37213200,2),(740,-21484800,1),(740,-5763600,2),(740,9964800,1),(740,25686000,2),(740,41414400,1),(740,57740400,2),(740,73468800,1),(740,89190000,2),(740,104918400,1),(740,120639600,2),(740,126691200,1),(740,152089200,2),(740,162374400,1),(740,183538800,2),(740,199267200,1),(740,215593200,2),(740,230716800,1),(740,247042800,2),(740,262771200,1),(740,278492400,2),(740,294220800,1),(740,309942000,2),(740,325670400,1),(740,341391600,2),(740,357120000,1),(740,372841200,2),(740,388569600,1),(740,404895600,2),(740,420019200,1),(740,436345200,2),(740,452073600,1),(740,467794800,2),(740,483523200,1),(740,499244400,2),(740,514972800,1),(740,530694000,2),(740,544608000,1),(740,562143600,2),(740,576057600,1),(740,594198000,2),(740,607507200,1),(740,625647600,2),(740,638956800,1),(740,657097200,2),(740,671011200,1),(740,688546800,6),(740,1143961200,1),(740,1162105200,2),(740,1173600000,1),(740,1194159600,2),(740,1205049600,1),(740,1225609200,2),(740,1236499200,1),(740,1257058800,2),(740,1268553600,1),(740,1289113200,2),(740,1300003200,1),(740,1320562800,2),(740,1331452800,1),(740,1352012400,2),(740,1362902400,1),(740,1383462000,2),(740,1394352000,1),(740,1414911600,2),(740,1425801600,1),(740,1446361200,2),(740,1457856000,1),(740,1478415600,2),(740,1489305600,1),(740,1509865200,2),(740,1520755200,1),(740,1541314800,2),(740,1552204800,1),(740,1572764400,2),(740,1583654400,1),(740,1604214000,2),(740,1615708800,1),(740,1636268400,2),(740,1647158400,1),(740,1667718000,2),(740,1678608000,1),(740,1699167600,2),(740,1710057600,1),(740,1730617200,2),(740,1741507200,1),(740,1762066800,2),(740,1772956800,1),(740,1793516400,2),(740,1805011200,1),(740,1825570800,2),(740,1836460800,1),(740,1857020400,2),(740,1867910400,1),(740,1888470000,2),(740,1899360000,1),(740,1919919600,2),(740,1930809600,1),(740,1951369200,2),(740,1962864000,1),(740,1983423600,2),(740,1994313600,1),(740,2014873200,2),(740,2025763200,1),(740,2046322800,2),(740,2057212800,1),(740,2077772400,2),(740,2088662400,1),(740,2109222000,2),(740,2120112000,1),(740,2140671600,2),(741,-2147483648,1),(741,-873057600,3),(741,-769395600,2),(741,-765399600,1),(742,-2147483648,1),(742,-1205954844,2),(742,-1192307244,3),(742,2147483647,3),(743,-2147483648,1),(743,-1938538284,3),(743,-1009825200,2),(743,-1002052800,3),(743,-986756400,2),(743,-971035200,3),(743,-955306800,2),(743,-939585600,3),(743,504939600,2),(743,512712000,3),(743,536475600,2),(743,544248000,3),(743,631170000,2),(743,638942400,3),(743,757400400,2),(743,765172800,3),(743,2147483647,3),(744,-2147483648,5),(744,-1633269600,1),(744,-1615129200,2),(744,-1601820000,1),(744,-1583679600,2),(744,-880207200,3),(744,-769395600,4),(744,-765385200,2),(744,-687967140,1),(744,-662655600,2),(744,-620838000,1),(744,-608137200,2),(744,-589388400,1),(744,-576082800,2),(744,-557938800,1),(744,-544633200,2),(744,-526489200,1),(744,-513183600,2),(744,-495039600,1),(744,-481734000,2),(744,-463590000,1),(744,-450284400,2),(744,-431535600,1),(744,-418230000,2),(744,-400086000,1),(744,-386780400,2),(744,-368636400,1),(744,-355330800,2),(744,-337186800,1),(744,-323881200,2),(744,-305737200,1),(744,-292431600,2),(744,-273682800,1),(744,-260982000,2),(744,-242233200,1),(744,-226508400,2),(744,-210783600,1),(744,-195058800,2),(744,-179334000,1),(744,-163609200,2),(744,-147884400,1),(744,-131554800,2),(744,-116434800,1),(744,-100105200,2),(744,-84376800,1),(744,-68655600,2),(744,-52927200,1),(744,-37206000,2),(744,-21477600,1),(744,-5756400,2),(744,9972000,1),(744,25693200,2),(744,41421600,1),(744,57747600,2),(744,73476000,1),(744,89197200,2),(744,104925600,1),(744,120646800,2),(744,126698400,1),(744,152096400,2),(744,162381600,1),(744,183546000,2),(744,199274400,1),(744,215600400,2),(744,230724000,1),(744,247050000,2),(744,262778400,1),(744,278499600,2),(744,294228000,1),(744,309949200,2),(744,325677600,1),(744,341398800,2),(744,357127200,1),(744,372848400,2),(744,388576800,1),(744,404902800,2),(744,420026400,1),(744,436352400,2),(744,452080800,1),(744,467802000,2),(744,483530400,1),(744,499251600,2),(744,514980000,1),(744,530701200,2),(744,544615200,1),(744,562150800,2),(744,576064800,1),(744,594205200,2),(744,607514400,1),(744,625654800,2),(744,638964000,1),(744,657104400,2),(744,671018400,1),(744,688554000,2),(744,702468000,1),(744,720003600,2),(744,733917600,1),(744,752058000,2),(744,765367200,1),(744,783507600,2),(744,796816800,1),(744,814957200,2),(744,828871200,1),(744,846406800,2),(744,860320800,1),(744,877856400,2),(744,891770400,1),(744,909306000,2),(744,923220000,1),(744,941360400,2),(744,954669600,1),(744,972810000,2),(744,986119200,1),(744,1004259600,2),(744,1018173600,1),(744,1035709200,2),(744,1049623200,1),(744,1067158800,2),(744,1081072800,1),(744,1099213200,2),(744,1112522400,1),(744,1130662800,2),(744,1143972000,1),(744,1162112400,2),(744,1173607200,1),(744,1194166800,2),(744,1205056800,1),(744,1225616400,2),(744,1236506400,1),(744,1257066000,2),(744,1268560800,1),(744,1289120400,2),(744,1300010400,1),(744,1320570000,2),(744,1331460000,1),(744,1352019600,2),(744,1362909600,1),(744,1383469200,2),(744,1394359200,1),(744,1414918800,2),(744,1425808800,1),(744,1446368400,2),(744,1457863200,1),(744,1478422800,2),(744,1489312800,1),(744,1509872400,2),(744,1520762400,1),(744,1541322000,2),(744,1552212000,1),(744,1572771600,2),(744,1583661600,1),(744,1604221200,2),(744,1615716000,1),(744,1636275600,2),(744,1647165600,1),(744,1667725200,2),(744,1678615200,1),(744,1699174800,2),(744,1710064800,1),(744,1730624400,2),(744,1741514400,1),(744,1762074000,2),(744,1772964000,1),(744,1793523600,2),(744,1805018400,1),(744,1825578000,2),(744,1836468000,1),(744,1857027600,2),(744,1867917600,1),(744,1888477200,2),(744,1899367200,1),(744,1919926800,2),(744,1930816800,1),(744,1951376400,2),(744,1962871200,1),(744,1983430800,2),(744,1994320800,1),(744,2014880400,2),(744,2025770400,1),(744,2046330000,2),(744,2057220000,1),(744,2077779600,2),(744,2088669600,1),(744,2109229200,2),(744,2120119200,1),(744,2140678800,2),(745,-2147483648,3),(745,-1633276800,1),(745,-1615136400,2),(745,-1601827200,1),(745,-1583686800,2),(745,-1535904000,1),(745,-1525280400,2),(745,-905097600,1),(745,-891795600,2),(745,-880214400,4),(745,-769395600,5),(745,-765392400,2),(745,-747251940,1),(745,-744224400,2),(745,-620841600,1),(745,-608144400,2),(745,-589392000,1),(745,-576090000,2),(745,-557942400,1),(745,-544640400,2),(745,-526492800,1),(745,-513190800,2),(745,-495043200,1),(745,-481741200,2),(745,-463593600,1),(745,-450291600,2),(745,-431539200,1),(745,-415818000,2),(745,-400089600,1),(745,-384368400,2),(745,-368640000,1),(745,-352918800,2),(745,-337190400,1),(745,-321469200,2),(745,-305740800,1),(745,-289414800,2),(745,-273686400,1),(745,-266432400,6),(745,-52938000,7),(745,-37216800,6),(745,-21488400,7),(745,-5767200,6),(745,9961200,7),(745,25682400,6),(745,41410800,7),(745,57736800,6),(745,73465200,7),(745,89186400,6),(745,104914800,7),(745,120636000,6),(745,126687600,1),(745,152089200,6),(745,162370800,7),(745,183535200,6),(745,199263600,7),(745,215589600,6),(745,230713200,7),(745,247039200,6),(745,262767600,7),(745,278488800,6),(745,294217200,7),(745,309938400,6),(745,325666800,7),(745,341388000,6),(745,357116400,7),(745,372837600,6),(745,388566000,7),(745,404892000,6),(745,420015600,7),(745,436341600,6),(745,452070000,7),(745,467791200,6),(745,483519600,7),(745,499240800,6),(745,514969200,7),(745,530690400,6),(745,544604400,7),(745,562140000,6),(745,576054000,7),(745,594194400,6),(745,607503600,7),(745,625644000,6),(745,638953200,7),(745,657093600,6),(745,671007600,7),(745,688543200,6),(745,702457200,7),(745,719992800,6),(745,733906800,7),(745,752047200,6),(745,765356400,7),(745,783496800,6),(745,796806000,7),(745,814946400,6),(745,828860400,7),(745,846396000,6),(745,860310000,7),(745,877845600,6),(745,891759600,7),(745,909295200,6),(745,923209200,7),(745,941349600,6),(745,954658800,7),(745,972799200,6),(745,986108400,7),(745,1004248800,6),(745,1018162800,7),(745,1035698400,6),(745,1049612400,7),(745,1067148000,6),(745,1081062000,7),(745,1099202400,6),(745,1112511600,7),(745,1130652000,6),(745,1143961200,7),(745,1162101600,6),(745,1173596400,7),(745,1194156000,6),(745,1205046000,7),(745,1225605600,6),(745,1236495600,7),(745,1257055200,6),(745,1268550000,7),(745,1289109600,6),(745,1299999600,7),(745,1320559200,6),(745,1331449200,7),(745,1352008800,6),(745,1362898800,7),(745,1383458400,6),(745,1394348400,7),(745,1414908000,6),(745,1425798000,7),(745,1446357600,6),(745,1457852400,7),(745,1478412000,6),(745,1489302000,7),(745,1509861600,6),(745,1520751600,7),(745,1541311200,6),(745,1552201200,7),(745,1572760800,6),(745,1583650800,7),(745,1604210400,6),(745,1615705200,7),(745,1636264800,6),(745,1647154800,7),(745,1667714400,6),(745,1678604400,7),(745,1699164000,6),(745,1710054000,7),(745,1730613600,6),(745,1741503600,7),(745,1762063200,6),(745,1772953200,7),(745,1793512800,6),(745,1805007600,7),(745,1825567200,6),(745,1836457200,7),(745,1857016800,6),(745,1867906800,7),(745,1888466400,6),(745,1899356400,7),(745,1919916000,6),(745,1930806000,7),(745,1951365600,6),(745,1962860400,7),(745,1983420000,6),(745,1994310000,7),(745,2014869600,6),(745,2025759600,7),(745,2046319200,6),(745,2057209200,7),(745,2077768800,6),(745,2088658800,7),(745,2109218400,6),(745,2120108400,7),(745,2140668000,6),(746,-2147483648,1),(746,-873057600,3),(746,-769395600,2),(746,-765399600,1),(747,-2147483648,0),(747,-1767217028,2),(747,-1206957600,1),(747,-1191362400,2),(747,-1175374800,1),(747,-1159826400,2),(747,-633819600,1),(747,-622069200,2),(747,-602283600,1),(747,-591832800,2),(747,-570747600,1),(747,-560210400,2),(747,-539125200,1),(747,-531352800,2),(747,-191365200,1),(747,-184197600,2),(747,-155163600,1),(747,-150069600,2),(747,-128898000,1),(747,-121125600,2),(747,-99954000,1),(747,-89589600,2),(747,-68418000,1),(747,-57967200,2),(747,499748400,1),(747,511236000,2),(747,530593200,1),(747,540266400,2),(747,562129200,1),(747,571197600,2),(747,592974000,1),(747,602042400,2),(747,624423600,1),(747,634701600,2),(747,813726000,1),(747,824004000,2),(747,938919600,1),(747,951616800,2),(747,970974000,1),(747,972180000,2),(747,1003028400,1),(747,1013911200,2),(747,2147483647,2),(748,-2147483648,1),(748,-1121105688,2),(748,105084000,3),(748,161758800,2),(748,290584800,4),(748,299134800,2),(748,322034400,4),(748,330584400,2),(748,694260000,3),(748,717310800,2),(748,725868000,3),(748,852094800,2),(748,1113112800,4),(748,1128229200,2),(748,1146384000,4),(748,1159682400,2),(749,-2147483648,0),(749,-1767211196,2),(749,-1206954000,1),(749,-1191358800,2),(749,-1175371200,1),(749,-1159822800,2),(749,-633816000,1),(749,-622065600,2),(749,-602280000,1),(749,-591829200,2),(749,-570744000,1),(749,-560206800,2),(749,-539121600,1),(749,-531349200,2),(749,-191361600,1),(749,-184194000,2),(749,-155160000,1),(749,-150066000,2),(749,-128894400,1),(749,-121122000,2),(749,-99950400,1),(749,-89586000,2),(749,-68414400,1),(749,-57963600,2),(749,499752000,1),(749,511239600,2),(749,530596800,1),(749,540270000,2),(749,562132800,1),(749,571201200,2),(749,750830400,1),(749,761713200,2),(749,2147483647,2),(750,-2147483648,1),(750,-873057600,3),(750,-769395600,2),(750,-765399600,1),(751,-2147483648,1),(751,-1851537340,2),(751,323841600,3),(751,338958000,2),(752,-2147483648,0),(752,-1514743200,1),(752,568015200,3),(752,576057600,2),(752,594198000,3),(752,828864000,2),(752,846399600,3),(752,860313600,2),(752,877849200,3),(752,891763200,2),(752,909298800,3),(752,923212800,2),(752,941353200,3),(752,954662400,2),(752,972802800,3),(752,989136000,2),(752,1001833200,3),(752,1018166400,2),(752,1035702000,3),(752,1049616000,2),(752,1067151600,3),(752,1081065600,2),(752,1099206000,3),(752,1112515200,2),(752,1130655600,3),(752,1143964800,2),(752,1162105200,3),(752,1175414400,2),(752,1193554800,3),(752,1207468800,2),(752,1225004400,3),(752,1238918400,2),(752,1256454000,3),(752,1268553600,2),(752,1289113200,3),(752,1300003200,2),(752,1320562800,3),(752,1331452800,2),(752,1352012400,3),(752,1362902400,2),(752,1383462000,3),(752,1394352000,2),(752,1414911600,3),(752,1425801600,2),(752,1446361200,3),(752,1457856000,2),(752,1478415600,3),(752,1489305600,2),(752,1509865200,3),(752,1520755200,2),(752,1541314800,3),(752,1552204800,2),(752,1572764400,3),(752,1583654400,2),(752,1604214000,3),(752,1615708800,2),(752,1636268400,3),(752,1647158400,2),(752,1667718000,3),(752,1678608000,2),(752,1699167600,3),(752,1710057600,2),(752,1730617200,3),(752,1741507200,2),(752,1762066800,3),(752,1772956800,2),(752,1793516400,3),(752,1805011200,2),(752,1825570800,3),(752,1836460800,2),(752,1857020400,3),(752,1867910400,2),(752,1888470000,3),(752,1899360000,2),(752,1919919600,3),(752,1930809600,2),(752,1951369200,3),(752,1962864000,2),(752,1983423600,3),(752,1994313600,2),(752,2014873200,3),(752,2025763200,2),(752,2046322800,3),(752,2057212800,2),(752,2077772400,3),(752,2088662400,2),(752,2109222000,3),(752,2120112000,2),(752,2140671600,3),(753,-2147483648,0),(753,-1514739600,1),(753,-1343066400,2),(753,-1234807200,4),(753,-1220292000,3),(753,-1207159200,4),(753,-1191344400,2),(753,-873828000,4),(753,-661539600,5),(753,28800,4),(753,828867600,3),(753,846403200,4),(753,860317200,3),(753,877852800,4),(753,891766800,3),(753,909302400,4),(753,923216400,3),(753,941356800,4),(753,954666000,3),(753,972806400,4),(753,989139600,3),(753,1001836800,4),(753,1018170000,3),(753,1035705600,4),(753,1049619600,3),(753,1067155200,4),(753,1081069200,3),(753,1099209600,4),(753,1112518800,3),(753,1130659200,4),(753,1143968400,3),(753,1162108800,4),(753,1175418000,3),(753,1193558400,4),(753,1207472400,3),(753,1225008000,4),(753,1238922000,3),(753,1256457600,4),(753,1270371600,3),(753,1288512000,4),(753,1301821200,3),(753,1319961600,4),(753,1333270800,3),(753,1351411200,4),(753,1365325200,3),(753,1382860800,4),(753,1396774800,3),(753,1414310400,4),(753,1428224400,3),(753,1445760000,4),(753,1459674000,3),(753,1477814400,4),(753,1491123600,3),(753,1509264000,4),(753,1522573200,3),(753,1540713600,4),(753,1554627600,3),(753,1572163200,4),(753,1586077200,3),(753,1603612800,4),(753,1617526800,3),(753,1635667200,4),(753,1648976400,3),(753,1667116800,4),(754,-2147483648,1),(754,-1567453392,2),(754,-1233432000,3),(754,-1222981200,2),(754,-1205956800,3),(754,-1194037200,2),(754,-1172865600,3),(754,-1162501200,2),(754,-1141329600,3),(754,-1130965200,2),(754,-1109793600,3),(754,-1099429200,2),(754,-1078257600,3),(754,-1067806800,2),(754,-1046635200,3),(754,-1036270800,2),(754,-1015099200,3),(754,-1004734800,2),(754,-983563200,3),(754,-973198800,2),(754,-952027200,3),(754,-941576400,2),(754,-931032000,3),(754,-900882000,2),(754,-890337600,3),(754,-833749200,2),(754,-827265600,3),(754,-752274000,2),(754,-733780800,3),(754,-197326800,2),(754,-190843200,3),(754,-184194000,2),(754,-164491200,3),(754,-152658000,2),(754,-132955200,3),(754,-121122000,2),(754,-101419200,3),(754,-86821200,2),(754,-71092800,3),(754,-54766800,2),(754,-39038400,3),(754,-23317200,2),(754,-7588800,5),(754,128142000,4),(754,136605600,5),(754,596948400,4),(754,605066400,5),(754,624423600,4),(754,636516000,2),(754,655963200,3),(754,667796400,2),(754,687499200,3),(754,699418800,2),(754,719380800,4),(754,731469600,5),(754,938919600,3),(754,952052400,5),(754,1085281200,2),(754,1096171200,5),(754,1198983600,4),(754,1205632800,5),(754,2147483647,5),(755,-2147483648,2),(755,-1633276800,1),(755,-1615136400,2),(755,-1601827200,1),(755,-1583686800,2),(755,-880214400,3),(755,-769395600,4),(755,-765392400,2),(755,-747244800,1),(755,-733942800,2),(755,-116438400,1),(755,-100112400,2),(755,-21484800,5),(755,104914800,1),(755,120639600,2),(755,126691200,1),(755,152089200,2),(755,162374400,1),(755,183538800,2),(755,199267200,1),(755,215593200,2),(755,230716800,1),(755,247042800,2),(755,262771200,1),(755,278492400,2),(755,294220800,1),(755,309942000,2),(755,325670400,1),(755,341391600,2),(755,357120000,1),(755,372841200,2),(755,388569600,1),(755,404895600,2),(755,420019200,1),(755,436345200,2),(755,452073600,1),(755,467794800,2),(755,483523200,1),(755,499244400,2),(755,514972800,1),(755,530694000,2),(755,544608000,1),(755,562143600,2),(755,576057600,1),(755,594198000,2),(755,607507200,1),(755,625647600,2),(755,638956800,1),(755,657097200,2),(755,671011200,1),(755,688546800,2),(755,702460800,1),(755,719996400,2),(755,733910400,1),(755,752050800,2),(755,765360000,1),(755,783500400,2),(755,796809600,1),(755,814950000,2),(755,828864000,1),(755,846399600,2),(755,860313600,1),(755,877849200,2),(755,891763200,1),(755,909298800,2),(755,923212800,1),(755,941353200,2),(755,954662400,1),(755,972802800,2),(755,986112000,1),(755,1004252400,2),(755,1018166400,1),(755,1035702000,2),(755,1049616000,1),(755,1067151600,2),(755,1081065600,1),(755,1099206000,2),(755,1112515200,1),(755,1130655600,2),(755,1143964800,1),(755,1162105200,2),(755,1173600000,1),(755,1194159600,2),(755,1205049600,1),(755,1225609200,2),(755,1236499200,1),(755,1257058800,2),(755,1268553600,1),(755,1289113200,2),(755,1300003200,1),(755,1320562800,2),(755,1331452800,1),(755,1352012400,2),(755,1362902400,1),(755,1383462000,2),(755,1394352000,1),(755,1414911600,2),(755,1425801600,1),(755,1446361200,2),(755,1457856000,1),(755,1478415600,2),(755,1489305600,1),(755,1509865200,2),(755,1520755200,1),(755,1541314800,2),(755,1552204800,1),(755,1572764400,2),(755,1583654400,1),(755,1604214000,2),(755,1615708800,1),(755,1636268400,2),(755,1647158400,1),(755,1667718000,2),(755,1678608000,1),(755,1699167600,2),(755,1710057600,1),(755,1730617200,2),(755,1741507200,1),(755,1762066800,2),(755,1772956800,1),(755,1793516400,2),(755,1805011200,1),(755,1825570800,2),(755,1836460800,1),(755,1857020400,2),(755,1867910400,1),(755,1888470000,2),(755,1899360000,1),(755,1919919600,2),(755,1930809600,1),(755,1951369200,2),(755,1962864000,1),(755,1983423600,2),(755,1994313600,1),(755,2014873200,2),(755,2025763200,1),(755,2046322800,2),(755,2057212800,1),(755,2077772400,2),(755,2088662400,1),(755,2109222000,2),(755,2120112000,1),(755,2140671600,2),(756,-2147483648,0),(756,-1514743200,1),(756,377935200,2),(756,407653200,4),(756,828864000,3),(756,846399600,4),(756,860313600,3),(756,877849200,4),(756,891763200,3),(756,909298800,4),(756,923212800,3),(756,941353200,4),(756,954662400,3),(756,972802800,4),(756,989136000,3),(756,1001833200,4),(756,1018166400,3),(756,1035702000,4),(756,1049616000,3),(756,1067151600,4),(756,1081065600,3),(756,1099206000,4),(756,1112515200,3),(756,1130655600,4),(756,1143964800,3),(756,1162105200,4),(756,1175414400,3),(756,1193554800,4),(756,1207468800,3),(756,1225004400,4),(756,1238918400,3),(756,1256454000,4),(756,1270368000,3),(756,1288508400,4),(756,1301817600,3),(756,1319958000,4),(756,1333267200,3),(756,1351407600,4),(756,1365321600,3),(756,1382857200,4),(756,1396771200,3),(756,1414306800,4),(756,1428220800,3),(756,1445756400,4),(756,1459670400,3),(756,1477810800,4),(756,1491120000,3),(756,1509260400,4),(756,1522569600,3),(756,1540710000,4),(756,1554624000,3),(756,1572159600,4),(756,1586073600,3),(756,1603609200,4),(756,1617523200,3),(756,1635663600,4),(756,1648972800,3),(756,1667113200,4),(757,-2147483648,1),(757,-880207200,2),(757,-769395600,3),(757,-765385200,1),(757,-21477600,4),(757,-5756400,1),(757,9972000,4),(757,25693200,1),(757,41421600,4),(757,57747600,1),(757,73476000,4),(757,89197200,1),(757,104925600,4),(757,120646800,1),(757,126698400,4),(757,152096400,1),(757,162381600,4),(757,183546000,1),(757,199274400,4),(757,215600400,1),(757,230724000,4),(757,247050000,1),(757,262778400,4),(757,278499600,1),(757,294228000,4),(757,309949200,1),(757,325677600,4),(757,341398800,1),(757,357127200,4),(757,372848400,1),(757,388576800,4),(757,404902800,1),(757,420026400,4),(757,436352400,1),(757,1446372000,5),(757,1457866800,6),(757,1478426400,5),(757,1489316400,6),(757,1509876000,5),(757,1520766000,6),(757,1541325600,1),(757,1547978400,5),(757,1552215600,6),(757,1572775200,5),(757,1583665200,6),(757,1604224800,5),(757,1615719600,6),(757,1636279200,5),(757,1647169200,6),(757,1667728800,5),(757,1678618800,6),(757,1699178400,5),(757,1710068400,6),(757,1730628000,5),(757,1741518000,6),(757,1762077600,5),(757,1772967600,6),(757,1793527200,5),(757,1805022000,6),(757,1825581600,5),(757,1836471600,6),(757,1857031200,5),(757,1867921200,6),(757,1888480800,5),(757,1899370800,6),(757,1919930400,5),(757,1930820400,6),(757,1951380000,5),(757,1962874800,6),(757,1983434400,5),(757,1994324400,6),(757,2014884000,5),(757,2025774000,6),(757,2046333600,5),(757,2057223600,6),(757,2077783200,5),(757,2088673200,6),(757,2109232800,5),(757,2120122800,6),(757,2140682400,5),(758,-2147483648,0),(758,-1514739600,1),(758,-1343066400,2),(758,-1234807200,4),(758,-1220292000,3),(758,-1207159200,4),(758,-1191344400,2),(758,-975261600,5),(758,-963169200,2),(758,-917114400,5),(758,-907354800,2),(758,-821901600,6),(758,-810068400,2),(758,-627501600,5),(758,-612990000,2),(758,828864000,5),(758,846399600,2),(758,860313600,5),(758,877849200,2),(758,891763200,5),(758,909298800,2),(758,923212800,5),(758,941353200,2),(758,954662400,5),(758,972802800,2),(758,989136000,5),(758,1001833200,2),(758,1018166400,5),(758,1035702000,2),(758,1049616000,5),(758,1067151600,2),(758,1081065600,5),(758,1099206000,2),(758,1112515200,5),(758,1130655600,2),(758,1143964800,5),(758,1162105200,2),(758,1175414400,5),(758,1193554800,2),(758,1207468800,5),(758,1225004400,2),(758,1238918400,5),(758,1256454000,2),(758,1270368000,5),(758,1288508400,2),(758,1301817600,5),(758,1319958000,2),(758,1333267200,5),(758,1351407600,2),(758,1365321600,5),(758,1382857200,2),(758,1396771200,5),(758,1414306800,2),(758,1428220800,5),(758,1445756400,2),(758,1459670400,5),(758,1477810800,2),(758,1491120000,5),(758,1509260400,2),(758,1522569600,5),(758,1540710000,2),(758,1554624000,5),(758,1572159600,2),(758,1586073600,5),(758,1603609200,2),(758,1617523200,5),(758,1635663600,2),(758,1648972800,5),(758,1667113200,2),(759,-2147483648,0),(759,-1850328920,1),(759,326001600,2),(759,544597200,3),(759,562132800,2),(759,576046800,3),(759,594187200,2),(759,607496400,3),(759,625636800,2),(759,638946000,3),(759,657086400,2),(759,671000400,3),(759,688536000,2),(759,702450000,3),(759,719985600,2),(759,733899600,3),(759,752040000,2),(759,765349200,3),(759,783489600,2),(759,796798800,3),(759,814939200,2),(759,828853200,3),(759,846388800,2),(759,860302800,3),(759,877838400,2),(759,891752400,3),(759,909288000,2),(759,923202000,3),(759,941342400,2),(759,954651600,3),(759,972792000,2),(759,986101200,3),(759,1004241600,2),(759,1018155600,3),(759,1035691200,2),(759,1049605200,3),(759,1067140800,2),(759,1081054800,3),(759,1099195200,2),(759,1112504400,3),(759,1130644800,2),(759,1143954000,3),(759,1162094400,2),(759,1173589200,3),(759,1194148800,2),(759,1205038800,3),(759,1225598400,2),(759,1236488400,3),(759,1257048000,2),(759,1268542800,3),(759,1289102400,2),(759,1299992400,3),(759,1320552000,2),(759,1331442000,3),(759,1352001600,2),(759,1362891600,3),(759,1383451200,2),(759,1394341200,3),(759,1414900800,2),(759,1425790800,3),(759,1446350400,2),(759,1457845200,3),(759,1478404800,2),(759,1489294800,3),(759,1509854400,2),(759,1520744400,3),(759,1541304000,2),(759,1552194000,3),(759,1572753600,2),(759,1583643600,3),(759,1604203200,2),(759,1615698000,3),(759,1636257600,2),(759,1647147600,3),(759,1667707200,2),(759,1678597200,3),(759,1699156800,2),(759,1710046800,3),(759,1730606400,2),(759,1741496400,3),(759,1762056000,2),(759,1772946000,3),(759,1793505600,2),(759,1805000400,3),(759,1825560000,2),(759,1836450000,3),(759,1857009600,2),(759,1867899600,3),(759,1888459200,2),(759,1899349200,3),(759,1919908800,2),(759,1930798800,3),(759,1951358400,2),(759,1962853200,3),(759,1983412800,2),(759,1994302800,3),(759,2014862400,2),(759,2025752400,3),(759,2046312000,2),(759,2057202000,3),(759,2077761600,2),(759,2088651600,3),(759,2109211200,2),(759,2120101200,3),(759,2140660800,2),(759,2147483647,2),(760,-2147483648,1),(760,-2131642800,3),(760,-1632074400,2),(760,-1615143600,3),(760,-1153681200,2),(760,-1145822400,3),(760,-1122231600,2),(760,-1114372800,3),(760,-1090782000,2),(760,-1082923200,3),(760,-1059332400,2),(760,-1051473600,3),(760,-1027882800,2),(760,-1020024000,3),(760,-996433200,2),(760,-988574400,3),(760,-965674800,2),(760,-955396800,3),(760,-934743600,2),(760,-923947200,3),(760,-904503600,2),(760,-891892800,3),(760,-880221600,4),(760,-769395600,5),(760,-765399600,3),(760,-747252000,2),(760,-733950000,3),(760,-715802400,2),(760,-702500400,3),(760,-684352800,2),(760,-671050800,3),(760,-652903200,2),(760,-639601200,3),(760,-620848800,2),(760,-608151600,3),(760,-589399200,2),(760,-576097200,3),(760,-557949600,2),(760,-544647600,3),(760,-526500000,2),(760,-513198000,3),(760,-495050400,2),(760,-481748400,3),(760,-463600800,2),(760,-450298800,3),(760,-431546400,2),(760,-418244400,3),(760,-400096800,2),(760,-384375600,3),(760,-368647200,2),(760,-352926000,3),(760,-337197600,2),(760,-321476400,3),(760,-305748000,2),(760,-289422000,3),(760,-273693600,2),(760,-257972400,3),(760,-242244000,2),(760,-226522800,3),(760,-210794400,2),(760,-195073200,3),(760,-179344800,2),(760,-163623600,3),(760,-147895200,2),(760,-131569200,3),(760,-116445600,2),(760,-100119600,3),(760,-84391200,2),(760,-68670000,3),(760,-52941600,2),(760,-37220400,3),(760,-21492000,2),(760,-5770800,3),(760,9957600,2),(760,25678800,3),(760,41407200,2),(760,57733200,3),(760,73461600,2),(760,89182800,3),(760,136360800,2),(760,152082000,3),(760,167810400,2),(760,183531600,3),(760,199260000,2),(760,215586000,3),(760,230709600,2),(760,247035600,3),(760,262764000,2),(760,278485200,3),(760,294213600,2),(760,309934800,3),(760,325663200,2),(760,341384400,3),(760,357112800,2),(760,372834000,3),(760,388562400,2),(760,404888400,3),(760,420012000,2),(760,436338000,3),(760,452066400,2),(760,467787600,3),(760,483516000,2),(760,499237200,3),(760,514965600,2),(760,530686800,3),(760,544600800,2),(760,562136400,3),(760,576050400,2),(760,594190800,3),(760,607500000,2),(760,625640400,3),(760,638949600,2),(760,657090000,3),(760,671004000,2),(760,688539600,3),(760,702453600,2),(760,719989200,3),(760,733896060,2),(760,752036460,3),(760,765345660,2),(760,783486060,3),(760,796795260,2),(760,814935660,3),(760,828849660,2),(760,846385260,3),(760,860299260,2),(760,877834860,3),(760,891748860,2),(760,909284460,3),(760,923198460,2),(760,941338860,3),(760,954648060,2),(760,972788460,3),(760,986097660,2),(760,1004238060,3),(760,1018152060,2),(760,1035687660,3),(760,1049601660,2),(760,1067137260,3),(760,1081051260,2),(760,1099191660,3),(760,1112500860,2),(760,1130641260,3),(760,1143950460,2),(760,1162090860,3),(760,1173592800,2),(760,1194152400,3),(760,1205042400,2),(760,1225602000,3),(760,1236492000,2),(760,1257051600,3),(760,1268546400,2),(760,1289106000,3),(760,1299996000,2),(760,1320555600,3),(760,1331445600,2),(760,1352005200,3),(760,1362895200,2),(760,1383454800,3),(760,1394344800,2),(760,1414904400,3),(760,1425794400,2),(760,1446354000,3),(760,1457848800,2),(760,1478408400,3),(760,1489298400,2),(760,1509858000,3),(760,1520748000,2),(760,1541307600,3),(760,1552197600,2),(760,1572757200,3),(760,1583647200,2),(760,1604206800,3),(760,1615701600,2),(760,1636261200,3),(760,1647151200,2),(760,1667710800,3),(760,1678600800,2),(760,1699160400,3),(760,1710050400,2),(760,1730610000,3),(760,1741500000,2),(760,1762059600,3),(760,1772949600,2),(760,1793509200,3),(760,1805004000,2),(760,1825563600,3),(760,1836453600,2),(760,1857013200,3),(760,1867903200,2),(760,1888462800,3),(760,1899352800,2),(760,1919912400,3),(760,1930802400,2),(760,1951362000,3),(760,1962856800,2),(760,1983416400,3),(760,1994306400,2),(760,2014866000,3),(760,2025756000,2),(760,2046315600,3),(760,2057205600,2),(760,2077765200,3),(760,2088655200,2),(760,2109214800,3),(760,2120104800,2),(760,2140664400,3),(761,-2147483648,0),(761,-1514743200,1),(761,568015200,3),(761,576057600,2),(761,594198000,3),(761,828864000,2),(761,846399600,3),(761,860313600,2),(761,877849200,3),(761,891763200,2),(761,909298800,3),(761,923212800,2),(761,941353200,3),(761,954662400,2),(761,972802800,3),(761,989136000,2),(761,1001833200,3),(761,1018166400,2),(761,1035702000,3),(761,1049616000,2),(761,1067151600,3),(761,1081065600,2),(761,1099206000,3),(761,1112515200,2),(761,1130655600,3),(761,1143964800,2),(761,1162105200,3),(761,1175414400,2),(761,1193554800,3),(761,1207468800,2),(761,1225004400,3),(761,1238918400,2),(761,1256454000,3),(761,1270368000,2),(761,1288508400,3),(761,1301817600,2),(761,1319958000,3),(761,1333267200,2),(761,1351407600,3),(761,1365321600,2),(761,1382857200,3),(761,1396771200,2),(761,1414306800,3),(761,1428220800,2),(761,1445756400,3),(761,1459670400,2),(761,1477810800,3),(761,1491120000,2),(761,1509260400,3),(761,1522569600,2),(761,1540710000,3),(761,1554624000,2),(761,1572159600,3),(761,1586073600,2),(761,1603609200,3),(761,1617523200,2),(761,1635663600,3),(761,1648972800,2),(761,1667113200,3),(762,-2147483648,0),(762,-1942690509,1),(762,-1567455309,2),(762,-1459627200,4),(762,-1443819600,3),(762,-1428006600,4),(762,-1412283600,3),(762,-1396470600,4),(762,-1380747600,3),(762,-1141590600,4),(762,-1128286800,3),(762,-1110141000,4),(762,-1096837200,3),(762,-1078691400,4),(762,-1065387600,3),(762,-1047241800,4),(762,-1033938000,3),(762,-1015187400,4),(762,-1002488400,3),(762,-983737800,4),(762,-971038800,3),(762,-954707400,4),(762,-938984400,3),(762,-920838600,4),(762,-907534800,3),(762,-896819400,4),(762,-853621200,6),(762,-845847000,5),(762,-334789200,6),(762,-319671000,5),(762,-314226000,7),(762,-309996000,5),(762,-149720400,7),(762,-134604000,5),(762,-50446800,6),(762,-34205400,5),(762,9860400,7),(762,14176800,5),(762,72846000,7),(762,80100000,5),(762,127278000,8),(762,132111000,6),(762,147234600,5),(762,156913200,7),(762,165376800,5),(762,219812400,7),(762,226461600,5),(762,250052400,7),(762,257911200,5),(762,282711600,7),(762,289360800,5),(762,294202800,7),(762,322020000,5),(762,566449200,7),(762,573012000,5),(762,597812400,7),(762,605066400,5),(762,625633200,7),(762,635911200,5),(762,656478000,7),(762,667965600,5),(762,688532400,7),(762,699415200,5),(762,719377200,7),(762,730864800,5),(762,1095562800,7),(762,1111896000,5),(762,1128834000,7),(762,1142136000,5),(762,1159678800,7),(762,1173585600,5),(762,1191733200,7),(762,1205035200,5),(762,1223182800,7),(762,1236484800,5),(762,1254632400,7),(762,1268539200,5),(762,1286082000,7),(762,1299988800,5),(762,1317531600,7),(762,1331438400,5),(762,1349586000,7),(762,1362888000,5),(762,1381035600,7),(762,1394337600,5),(762,1412485200,7),(762,1425787200,5),(762,2147483647,5),(763,-2147483648,2),(763,-1632070800,1),(763,-1615140000,2),(763,-1601753400,1),(763,-1583697600,2),(763,-1567357200,1),(763,-1554667200,2),(763,-1534698000,1),(763,-1524074400,2),(763,-1503248400,1),(763,-1492365600,2),(763,-1471798800,1),(763,-1460916000,2),(763,-1440954000,1),(763,-1428861600,2),(763,-1409504400,1),(763,-1397412000,2),(763,-1378054800,1),(763,-1365962400,2),(763,-1346605200,1),(763,-1333908000,2),(763,-1315155600,1),(763,-1301853600,2),(763,-1283706000,1),(763,-1270404000,2),(763,-1252256400,1),(763,-1238954400,2),(763,-1220806800,1),(763,-1207504800,2),(763,-1188752400,1),(763,-1176055200,2),(763,-1157302800,1),(763,-1144000800,2),(763,-1125853200,1),(763,-1112551200,2),(763,-1094403600,1),(763,-1081101600,2),(763,-1062954000,1),(763,-1049652000,2),(763,-1031504400,1),(763,-1018202400,2),(763,-1000054800,1),(763,-986752800,2),(763,-968000400,1),(763,-955303200,2),(763,-936550800,1),(763,-880218000,3),(763,-769395600,4),(763,-765396000,2),(763,-747248400,1),(763,-733946400,2),(763,-715806000,1),(763,-702504000,2),(763,-684356400,1),(763,-671054400,2),(763,-652906800,1),(763,-634161600,2),(763,-620845200,1),(763,-602704800,2),(763,-589395600,1),(763,-576093600,2),(763,-557946000,1),(763,-544644000,2),(763,-526496400,1),(763,-513194400,2),(763,-495046800,1),(763,-481744800,2),(763,-463597200,1),(763,-450295200,2),(763,-431542800,1),(763,-418240800,2),(763,-400093200,1),(763,-384372000,2),(763,-368643600,1),(763,-352922400,2),(763,-337194000,1),(763,-321472800,2),(763,-305744400,1),(763,-289418400,2),(763,-273690000,1),(763,-257968800,2),(763,-242240400,1),(763,-226519200,2),(763,-210790800,1),(763,-195069600,2),(763,-179341200,1),(763,-163620000,2),(763,-147891600,1),(763,-131565600,2),(763,-116442000,1),(763,-100116000,2),(763,-84387600,1),(763,-68666400,2),(763,-52938000,1),(763,-37216800,2),(763,-21488400,1),(763,-5767200,2),(763,9961200,1),(763,25682400,2),(763,41410800,1),(763,57736800,2),(763,73465200,1),(763,89186400,2),(763,104914800,1),(763,120636000,2),(763,136364400,1),(763,152085600,2),(763,167814000,1),(763,183535200,2),(763,199263600,1),(763,215589600,2),(763,230713200,1),(763,247039200,2),(763,262767600,1),(763,278488800,2),(763,294217200,1),(763,309938400,2),(763,325666800,1),(763,341388000,2),(763,357116400,1),(763,372837600,2),(763,388566000,1),(763,404892000,2),(763,420015600,1),(763,436341600,2),(763,452070000,1),(763,467791200,2),(763,483519600,1),(763,499240800,2),(763,514969200,1),(763,530690400,2),(763,544604400,1),(763,562140000,2),(763,576054000,1),(763,594194400,2),(763,607503600,1),(763,625644000,2),(763,638953200,1),(763,657093600,2),(763,671007600,1),(763,688543200,2),(763,702457200,1),(763,719992800,2),(763,733906800,1),(763,752047200,2),(763,765356400,1),(763,783496800,2),(763,796806000,1),(763,814946400,2),(763,828860400,1),(763,846396000,2),(763,860310000,1),(763,877845600,2),(763,891759600,1),(763,909295200,2),(763,923209200,1),(763,941349600,2),(763,954658800,1),(763,972799200,2),(763,986108400,1),(763,1004248800,2),(763,1018162800,1),(763,1035698400,2),(763,1049612400,1),(763,1067148000,2),(763,1081062000,1),(763,1099202400,2),(763,1112511600,1),(763,1130652000,2),(763,1143961200,1),(763,1162101600,2),(763,1173596400,1),(763,1194156000,2),(763,1205046000,1),(763,1225605600,2),(763,1236495600,1),(763,1257055200,2),(763,1268550000,1),(763,1289109600,2),(763,1299999600,1),(763,1320559200,2),(763,1331449200,1),(763,1352008800,2),(763,1362898800,1),(763,1383458400,2),(763,1394348400,1),(763,1414908000,2),(763,1425798000,1),(763,1446357600,2),(763,1457852400,1),(763,1478412000,2),(763,1489302000,1),(763,1509861600,2),(763,1520751600,1),(763,1541311200,2),(763,1552201200,1),(763,1572760800,2),(763,1583650800,1),(763,1604210400,2),(763,1615705200,1),(763,1636264800,2),(763,1647154800,1),(763,1667714400,2),(763,1678604400,1),(763,1699164000,2),(763,1710054000,1),(763,1730613600,2),(763,1741503600,1),(763,1762063200,2),(763,1772953200,1),(763,1793512800,2),(763,1805007600,1),(763,1825567200,2),(763,1836457200,1),(763,1857016800,2),(763,1867906800,1),(763,1888466400,2),(763,1899356400,1),(763,1919916000,2),(763,1930806000,1),(763,1951365600,2),(763,1962860400,1),(763,1983420000,2),(763,1994310000,1),(763,2014869600,2),(763,2025759600,1),(763,2046319200,2),(763,2057209200,1),(763,2077768800,2),(763,2088658800,1),(763,2109218400,2),(763,2120108400,1),(763,2140668000,2),(764,-2147483648,1),(764,-873057600,3),(764,-769395600,2),(764,-765399600,1),(765,-2147483648,2),(765,-1632070800,1),(765,-1615140000,2),(765,-1601753400,1),(765,-1583697600,2),(765,-1567357200,1),(765,-1554667200,2),(765,-1534698000,1),(765,-1524074400,2),(765,-1503248400,1),(765,-1492365600,2),(765,-1471798800,1),(765,-1460916000,2),(765,-1440954000,1),(765,-1428861600,2),(765,-1409504400,1),(765,-1397412000,2),(765,-1378054800,1),(765,-1365962400,2),(765,-1346605200,1),(765,-1333908000,2),(765,-1315155600,1),(765,-1301853600,2),(765,-1283706000,1),(765,-1270404000,2),(765,-1252256400,1),(765,-1238954400,2),(765,-1220806800,1),(765,-1207504800,2),(765,-1188752400,1),(765,-1176055200,2),(765,-1157302800,1),(765,-1144000800,2),(765,-1125853200,1),(765,-1112551200,2),(765,-1094403600,1),(765,-1081101600,2),(765,-1062954000,1),(765,-1049652000,2),(765,-1031504400,1),(765,-1018202400,2),(765,-1000054800,1),(765,-986752800,2),(765,-968000400,1),(765,-955303200,2),(765,-936550800,1),(765,-880218000,3),(765,-769395600,4),(765,-765396000,2),(765,-747248400,1),(765,-733946400,2),(765,-715806000,1),(765,-702504000,2),(765,-684356400,1),(765,-671054400,2),(765,-652906800,1),(765,-634161600,2),(765,-620845200,1),(765,-602704800,2),(765,-589395600,1),(765,-576093600,2),(765,-557946000,1),(765,-544644000,2),(765,-526496400,1),(765,-513194400,2),(765,-495046800,1),(765,-481744800,2),(765,-463597200,1),(765,-450295200,2),(765,-431542800,1),(765,-418240800,2),(765,-400093200,1),(765,-384372000,2),(765,-368643600,1),(765,-352922400,2),(765,-337194000,1),(765,-321472800,2),(765,-305744400,1),(765,-289418400,2),(765,-273690000,1),(765,-257968800,2),(765,-242240400,1),(765,-226519200,2),(765,-210790800,1),(765,-195069600,2),(765,-179341200,1),(765,-163620000,2),(765,-147891600,1),(765,-131565600,2),(765,-116442000,1),(765,-100116000,2),(765,-84387600,1),(765,-68666400,2),(765,-52938000,1),(765,-37216800,2),(765,-21488400,1),(765,-5767200,2),(765,9961200,1),(765,25682400,2),(765,41410800,1),(765,57736800,2),(765,73465200,1),(765,89186400,2),(765,104914800,1),(765,120636000,2),(765,136364400,1),(765,152085600,2),(765,167814000,1),(765,183535200,2),(765,199263600,1),(765,215589600,2),(765,230713200,1),(765,247039200,2),(765,262767600,1),(765,278488800,2),(765,294217200,1),(765,309938400,2),(765,325666800,1),(765,341388000,2),(765,357116400,1),(765,372837600,2),(765,388566000,1),(765,404892000,2),(765,420015600,1),(765,436341600,2),(765,452070000,1),(765,467791200,2),(765,483519600,1),(765,499240800,2),(765,514969200,1),(765,530690400,2),(765,544604400,1),(765,562140000,2),(765,576054000,1),(765,594194400,2),(765,607503600,1),(765,625644000,2),(765,638953200,1),(765,657093600,2),(765,671007600,1),(765,688543200,2),(765,702457200,1),(765,719992800,2),(765,733906800,1),(765,752047200,2),(765,765356400,1),(765,783496800,2),(765,796806000,1),(765,814946400,2),(765,828860400,1),(765,846396000,2),(765,860310000,1),(765,877845600,2),(765,891759600,1),(765,909295200,2),(765,923209200,1),(765,941349600,2),(765,954658800,1),(765,972799200,2),(765,986108400,1),(765,1004248800,2),(765,1018162800,1),(765,1035698400,2),(765,1049612400,1),(765,1067148000,2),(765,1081062000,1),(765,1099202400,2),(765,1112511600,1),(765,1130652000,2),(765,1143961200,1),(765,1162101600,2),(765,1173596400,1),(765,1194156000,2),(765,1205046000,1),(765,1225605600,2),(765,1236495600,1),(765,1257055200,2),(765,1268550000,1),(765,1289109600,2),(765,1299999600,1),(765,1320559200,2),(765,1331449200,1),(765,1352008800,2),(765,1362898800,1),(765,1383458400,2),(765,1394348400,1),(765,1414908000,2),(765,1425798000,1),(765,1446357600,2),(765,1457852400,1),(765,1478412000,2),(765,1489302000,1),(765,1509861600,2),(765,1520751600,1),(765,1541311200,2),(765,1552201200,1),(765,1572760800,2),(765,1583650800,1),(765,1604210400,2),(765,1615705200,1),(765,1636264800,2),(765,1647154800,1),(765,1667714400,2),(765,1678604400,1),(765,1699164000,2),(765,1710054000,1),(765,1730613600,2),(765,1741503600,1),(765,1762063200,2),(765,1772953200,1),(765,1793512800,2),(765,1805007600,1),(765,1825567200,2),(765,1836457200,1),(765,1857016800,2),(765,1867906800,1),(765,1888466400,2),(765,1899356400,1),(765,1919916000,2),(765,1930806000,1),(765,1951365600,2),(765,1962860400,1),(765,1983420000,2),(765,1994310000,1),(765,2014869600,2),(765,2025759600,1),(765,2046319200,2),(765,2057209200,1),(765,2077768800,2),(765,2088658800,1),(765,2109218400,2),(765,2120108400,1),(765,2140668000,2),(766,-2147483648,3),(766,-1633280400,1),(766,-1615140000,2),(766,-1601830800,1),(766,-1583690400,2),(766,-1570381200,1),(766,-1551636000,2),(766,-1536512400,1),(766,-1523210400,2),(766,-1504458000,1),(766,-1491760800,2),(766,-1473008400,1),(766,-1459706400,2),(766,-1441558800,1),(766,-1428256800,2),(766,-1410109200,1),(766,-1396807200,2),(766,-1378659600,1),(766,-1365357600,2),(766,-1347210000,1),(766,-1333908000,2),(766,-1315155600,1),(766,-1301853600,2),(766,-1283706000,1),(766,-1270404000,2),(766,-1252256400,1),(766,-1238954400,2),(766,-1220806800,1),(766,-1207504800,2),(766,-1189357200,1),(766,-1176055200,2),(766,-1157302800,1),(766,-1144605600,2),(766,-1125853200,1),(766,-1112551200,2),(766,-1094403600,1),(766,-1081101600,2),(766,-1062954000,1),(766,-1049652000,2),(766,-1031504400,1),(766,-1018202400,2),(766,-1000054800,1),(766,-986752800,2),(766,-968000400,1),(766,-955303200,2),(766,-936550800,1),(766,-923248800,2),(766,-905101200,1),(766,-891799200,2),(766,-880218000,4),(766,-769395600,5),(766,-765396000,2),(766,-747248400,1),(766,-733946400,2),(766,-715798800,1),(766,-702496800,2),(766,-684349200,1),(766,-671047200,2),(766,-652899600,1),(766,-639597600,2),(766,-620845200,1),(766,-608148000,2),(766,-589395600,1),(766,-576093600,2),(766,-557946000,1),(766,-544644000,2),(766,-526496400,1),(766,-513194400,2),(766,-495046800,1),(766,-481744800,2),(766,-463597200,1),(766,-447271200,2),(766,-431542800,1),(766,-415821600,2),(766,-400093200,1),(766,-384372000,2),(766,-368643600,1),(766,-352922400,2),(766,-337194000,1),(766,-321472800,2),(766,-305744400,1),(766,-289418400,2),(766,-273690000,1),(766,-257968800,2),(766,-242240400,1),(766,-226519200,2),(766,-210790800,1),(766,-195069600,2),(766,-179341200,1),(766,-163620000,2),(766,-147891600,1),(766,-131565600,2),(766,-116442000,1),(766,-100116000,2),(766,-84387600,1),(766,-68666400,2),(766,-52938000,1),(766,-37216800,2),(766,-21488400,1),(766,-5767200,2),(766,9961200,1),(766,25682400,2),(766,41410800,1),(766,57736800,2),(766,73465200,1),(766,89186400,2),(766,104914800,1),(766,120636000,2),(766,126687600,1),(766,152085600,2),(766,162370800,1),(766,183535200,2),(766,199263600,1),(766,215589600,2),(766,230713200,1),(766,247039200,2),(766,262767600,1),(766,278488800,2),(766,294217200,1),(766,309938400,2),(766,325666800,1),(766,341388000,2),(766,357116400,1),(766,372837600,2),(766,388566000,1),(766,404892000,2),(766,420015600,1),(766,436341600,2),(766,452070000,1),(766,467791200,2),(766,483519600,1),(766,499240800,2),(766,514969200,1),(766,530690400,2),(766,544604400,1),(766,562140000,2),(766,576054000,1),(766,594194400,2),(766,607503600,1),(766,625644000,2),(766,638953200,1),(766,657093600,2),(766,671007600,1),(766,688543200,2),(766,702457200,1),(766,719992800,2),(766,733906800,1),(766,752047200,2),(766,765356400,1),(766,783496800,2),(766,796806000,1),(766,814946400,2),(766,828860400,1),(766,846396000,2),(766,860310000,1),(766,877845600,2),(766,891759600,1),(766,909295200,2),(766,923209200,1),(766,941349600,2),(766,954658800,1),(766,972799200,2),(766,986108400,1),(766,1004248800,2),(766,1018162800,1),(766,1035698400,2),(766,1049612400,1),(766,1067148000,2),(766,1081062000,1),(766,1099202400,2),(766,1112511600,1),(766,1130652000,2),(766,1143961200,1),(766,1162101600,2),(766,1173596400,1),(766,1194156000,2),(766,1205046000,1),(766,1225605600,2),(766,1236495600,1),(766,1257055200,2),(766,1268550000,1),(766,1289109600,2),(766,1299999600,1),(766,1320559200,2),(766,1331449200,1),(766,1352008800,2),(766,1362898800,1),(766,1383458400,2),(766,1394348400,1),(766,1414908000,2),(766,1425798000,1),(766,1446357600,2),(766,1457852400,1),(766,1478412000,2),(766,1489302000,1),(766,1509861600,2),(766,1520751600,1),(766,1541311200,2),(766,1552201200,1),(766,1572760800,2),(766,1583650800,1),(766,1604210400,2),(766,1615705200,1),(766,1636264800,2),(766,1647154800,1),(766,1667714400,2),(766,1678604400,1),(766,1699164000,2),(766,1710054000,1),(766,1730613600,2),(766,1741503600,1),(766,1762063200,2),(766,1772953200,1),(766,1793512800,2),(766,1805007600,1),(766,1825567200,2),(766,1836457200,1),(766,1857016800,2),(766,1867906800,1),(766,1888466400,2),(766,1899356400,1),(766,1919916000,2),(766,1930806000,1),(766,1951365600,2),(766,1962860400,1),(766,1983420000,2),(766,1994310000,1),(766,2014869600,2),(766,2025759600,1),(766,2046319200,2),(766,2057209200,1),(766,2077768800,2),(766,2088658800,1),(766,2109218400,2),(766,2120108400,1),(766,2140668000,2),(767,-2147483648,2),(767,-1632070800,1),(767,-1615140000,2),(767,-1601753400,1),(767,-1583697600,2),(767,-1567357200,1),(767,-1554667200,2),(767,-1534698000,1),(767,-1524074400,2),(767,-1503248400,1),(767,-1492365600,2),(767,-1471798800,1),(767,-1460916000,2),(767,-1440954000,1),(767,-1428861600,2),(767,-1409504400,1),(767,-1397412000,2),(767,-1378054800,1),(767,-1365962400,2),(767,-1346605200,1),(767,-1333908000,2),(767,-1315155600,1),(767,-1301853600,2),(767,-1283706000,1),(767,-1270404000,2),(767,-1252256400,1),(767,-1238954400,2),(767,-1220806800,1),(767,-1207504800,2),(767,-1188752400,1),(767,-1176055200,2),(767,-1157302800,1),(767,-1144000800,2),(767,-1125853200,1),(767,-1112551200,2),(767,-1094403600,1),(767,-1081101600,2),(767,-1062954000,1),(767,-1049652000,2),(767,-1031504400,1),(767,-1018202400,2),(767,-1000054800,1),(767,-986752800,2),(767,-968000400,1),(767,-955303200,2),(767,-936550800,1),(767,-880218000,3),(767,-769395600,4),(767,-765396000,2),(767,-747248400,1),(767,-733946400,2),(767,-715806000,1),(767,-702504000,2),(767,-684356400,1),(767,-671054400,2),(767,-652906800,1),(767,-634161600,2),(767,-620845200,1),(767,-602704800,2),(767,-589395600,1),(767,-576093600,2),(767,-557946000,1),(767,-544644000,2),(767,-526496400,1),(767,-513194400,2),(767,-495046800,1),(767,-481744800,2),(767,-463597200,1),(767,-450295200,2),(767,-431542800,1),(767,-418240800,2),(767,-400093200,1),(767,-384372000,2),(767,-368643600,1),(767,-352922400,2),(767,-337194000,1),(767,-321472800,2),(767,-305744400,1),(767,-289418400,2),(767,-273690000,1),(767,-257968800,2),(767,-242240400,1),(767,-226519200,2),(767,-210790800,1),(767,-195069600,2),(767,-179341200,1),(767,-163620000,2),(767,-147891600,1),(767,-131565600,2),(767,-116442000,1),(767,-100116000,2),(767,-84387600,1),(767,-68666400,2),(767,-52938000,1),(767,-37216800,2),(767,-21488400,1),(767,-5767200,2),(767,9961200,1),(767,25682400,2),(767,41410800,1),(767,57736800,2),(767,73465200,1),(767,89186400,2),(767,104914800,1),(767,120636000,2),(767,136364400,1),(767,152085600,2),(767,167814000,1),(767,183535200,2),(767,199263600,1),(767,215589600,2),(767,230713200,1),(767,247039200,2),(767,262767600,1),(767,278488800,2),(767,294217200,1),(767,309938400,2),(767,325666800,1),(767,341388000,2),(767,357116400,1),(767,372837600,2),(767,388566000,1),(767,404892000,2),(767,420015600,1),(767,436341600,2),(767,452070000,1),(767,467791200,2),(767,483519600,1),(767,499240800,2),(767,514969200,1),(767,530690400,2),(767,544604400,1),(767,562140000,2),(767,576054000,1),(767,594194400,2),(767,607503600,1),(767,625644000,2),(767,638953200,1),(767,657093600,2),(767,671007600,1),(767,688543200,2),(767,702457200,1),(767,719992800,2),(767,733906800,1),(767,752047200,2),(767,765356400,1),(767,783496800,2),(767,796806000,1),(767,814946400,2),(767,828860400,1),(767,846396000,2),(767,860310000,1),(767,877845600,2),(767,891759600,1),(767,909295200,2),(767,923209200,1),(767,941349600,2),(767,954658800,1),(767,972799200,2),(767,986108400,1),(767,1004248800,2),(767,1018162800,1),(767,1035698400,2),(767,1049612400,1),(767,1067148000,2),(767,1081062000,1),(767,1099202400,2),(767,1112511600,1),(767,1130652000,2),(767,1143961200,1),(767,1162101600,2),(767,1173596400,1),(767,1194156000,2),(767,1205046000,1),(767,1225605600,2),(767,1236495600,1),(767,1257055200,2),(767,1268550000,1),(767,1289109600,2),(767,1299999600,1),(767,1320559200,2),(767,1331449200,1),(767,1352008800,2),(767,1362898800,1),(767,1383458400,2),(767,1394348400,1),(767,1414908000,2),(767,1425798000,1),(767,1446357600,2),(767,1457852400,1),(767,1478412000,2),(767,1489302000,1),(767,1509861600,2),(767,1520751600,1),(767,1541311200,2),(767,1552201200,1),(767,1572760800,2),(767,1583650800,1),(767,1604210400,2),(767,1615705200,1),(767,1636264800,2),(767,1647154800,1),(767,1667714400,2),(767,1678604400,1),(767,1699164000,2),(767,1710054000,1),(767,1730613600,2),(767,1741503600,1),(767,1762063200,2),(767,1772953200,1),(767,1793512800,2),(767,1805007600,1),(767,1825567200,2),(767,1836457200,1),(767,1857016800,2),(767,1867906800,1),(767,1888466400,2),(767,1899356400,1),(767,1919916000,2),(767,1930806000,1),(767,1951365600,2),(767,1962860400,1),(767,1983420000,2),(767,1994310000,1),(767,2014869600,2),(767,2025759600,1),(767,2046319200,2),(767,2057209200,1),(767,2077768800,2),(767,2088658800,1),(767,2109218400,2),(767,2120108400,1),(767,2140668000,2),(768,-2147483648,1),(768,-880196400,2),(768,-769395600,3),(768,-765374400,1),(768,-86878800,4),(768,-21466800,5),(768,-5745600,4),(768,9982800,5),(768,25704000,4),(768,41432400,5),(768,57758400,4),(768,73486800,5),(768,89208000,4),(768,104936400,5),(768,120657600,4),(768,126709200,5),(768,152107200,4),(768,162392400,5),(768,183556800,4),(768,199285200,5),(768,215611200,4),(768,230734800,5),(768,247060800,4),(768,262789200,5),(768,278510400,4),(768,294238800,5),(768,309960000,4),(768,325688400,5),(768,341409600,4),(768,357138000,5),(768,372859200,4),(768,388587600,5),(768,404913600,4),(768,420037200,5),(768,436363200,6),(768,439030800,8),(768,452084400,7),(768,467805600,8),(768,483534000,7),(768,499255200,8),(768,514983600,7),(768,530704800,8),(768,544618800,7),(768,562154400,8),(768,576068400,7),(768,594208800,8),(768,607518000,7),(768,625658400,8),(768,638967600,7),(768,657108000,8),(768,671022000,7),(768,688557600,8),(768,702471600,7),(768,720007200,8),(768,733921200,7),(768,752061600,8),(768,765370800,7),(768,783511200,8),(768,796820400,7),(768,814960800,8),(768,828874800,7),(768,846410400,8),(768,860324400,7),(768,877860000,8),(768,891774000,7),(768,909309600,8),(768,923223600,7),(768,941364000,8),(768,954673200,7),(768,972813600,8),(768,986122800,7),(768,1004263200,8),(768,1018177200,7),(768,1035712800,8),(768,1049626800,7),(768,1067162400,8),(768,1081076400,7),(768,1099216800,8),(768,1112526000,7),(768,1130666400,8),(768,1143975600,7),(768,1162116000,8),(768,1173610800,7),(768,1194170400,8),(768,1205060400,7),(768,1225620000,8),(768,1236510000,7),(768,1257069600,8),(768,1268564400,7),(768,1289124000,8),(768,1300014000,7),(768,1320573600,8),(768,1331463600,7),(768,1352023200,8),(768,1362913200,7),(768,1383472800,8),(768,1394362800,7),(768,1414922400,8),(768,1425812400,7),(768,1446372000,8),(768,1457866800,7),(768,1478426400,8),(768,1489316400,7),(768,1509876000,8),(768,1520766000,7),(768,1541325600,8),(768,1552215600,7),(768,1572775200,8),(768,1583665200,7),(768,1604224800,8),(768,1615719600,7),(768,1636279200,8),(768,1647169200,7),(768,1667728800,8),(768,1678618800,7),(768,1699178400,8),(768,1710068400,7),(768,1730628000,8),(768,1741518000,7),(768,1762077600,8),(768,1772967600,7),(768,1793527200,8),(768,1805022000,7),(768,1825581600,8),(768,1836471600,7),(768,1857031200,8),(768,1867921200,7),(768,1888480800,8),(768,1899370800,7),(768,1919930400,8),(768,1930820400,7),(768,1951380000,8),(768,1962874800,7),(768,1983434400,8),(768,1994324400,7),(768,2014884000,8),(768,2025774000,7),(768,2046333600,8),(768,2057223600,7),(768,2077783200,8),(768,2088673200,7),(768,2109232800,8),(768,2120122800,7),(768,2140682400,8),(769,-2147483648,0),(769,-1767217820,2),(769,-1206961200,1),(769,-1191366000,2),(769,-1175378400,1),(769,-1159830000,2),(769,-633823200,1),(769,-622072800,2),(769,-602287200,1),(769,-591836400,2),(769,-570751200,1),(769,-560214000,2),(769,-539128800,1),(769,-531356400,2),(769,-191368800,1),(769,-184201200,2),(769,-155167200,1),(769,-150073200,2),(769,-128901600,1),(769,-121129200,2),(769,-99957600,1),(769,-89593200,2),(769,-68421600,1),(769,-57970800,2),(769,499744800,1),(769,511232400,2),(769,530589600,1),(769,540262800,2),(769,562125600,1),(769,571194000,2),(769,592970400,1),(769,602038800,2),(769,624420000,1),(769,634698000,2),(769,938916000,1),(769,951613200,2),(769,970970400,1),(769,971571600,2),(769,1003024800,1),(769,1013907600,2),(769,2147483647,2),(770,-2147483648,5),(770,-1633273200,1),(770,-1615132800,2),(770,-1601823600,1),(770,-1583683200,2),(770,-880210800,3),(770,-769395600,4),(770,-765388800,2),(770,-84380400,1),(770,-68659200,2),(770,-52930800,1),(770,-37209600,2),(770,-21481200,1),(770,-5760000,2),(770,9968400,1),(770,25689600,2),(770,41418000,1),(770,57744000,2),(770,73472400,1),(770,89193600,2),(770,104922000,1),(770,120643200,2),(770,126694800,1),(770,152092800,2),(770,162378000,1),(770,183542400,2),(770,199270800,1),(770,215596800,2),(770,230720400,1),(770,247046400,2),(770,262774800,1),(770,278496000,2),(770,294224400,1),(770,309945600,2),(770,325674000,1),(770,341395200,2),(770,357123600,1),(770,372844800,2),(770,388573200,1),(770,404899200,2),(770,420022800,1),(770,436348800,2),(770,452077200,1),(770,467798400,2),(770,483526800,1),(770,499248000,2),(770,514976400,1),(770,530697600,2),(770,544611600,1),(770,562147200,2),(770,576061200,1),(770,594201600,2),(770,607510800,1),(770,625651200,2),(770,638960400,1),(770,657100800,2),(770,671014800,1),(770,688550400,2),(770,702464400,1),(770,720000000,2),(770,733914000,1),(770,752054400,2),(770,765363600,1),(770,783504000,2),(770,796813200,1),(770,814953600,2),(770,828867600,1),(770,846403200,2),(770,860317200,1),(770,877852800,2),(770,891766800,1),(770,909302400,2),(770,923216400,1),(770,941356800,2),(770,954666000,1),(770,972806400,2),(770,986115600,1),(770,1004256000,2),(770,1018170000,1),(770,1035705600,2),(770,1049619600,1),(770,1067155200,2),(770,1081069200,1),(770,1099209600,2),(770,1112518800,1),(770,1130659200,2),(770,1143968400,1),(770,1162108800,2),(770,1173603600,1),(770,1194163200,2),(770,1205053200,1),(770,1225612800,2),(770,1236502800,1),(770,1257062400,2),(770,1268557200,1),(770,1289116800,7),(770,1300003200,6),(770,1320562800,7),(770,1331452800,6),(770,1352012400,7),(770,1362902400,6),(770,1383462000,7),(770,1394352000,6),(770,1414911600,7),(770,1425801600,6),(770,1446361200,7),(770,1457856000,6),(770,1478415600,7),(770,1489305600,6),(770,1509865200,7),(770,1520755200,6),(770,1541314800,7),(770,1552204800,6),(770,1572764400,7),(770,1583654400,6),(770,1604214000,7),(770,1615708800,6),(770,1636268400,7),(770,1647158400,6),(770,1667718000,7),(770,1678608000,6),(770,1699167600,7),(770,1710057600,6),(770,1730617200,7),(770,1741507200,6),(770,1762066800,7),(770,1772956800,6),(770,1793516400,7),(770,1805011200,6),(770,1825570800,7),(770,1836460800,6),(770,1857020400,7),(770,1867910400,6),(770,1888470000,7),(770,1899360000,6),(770,1919919600,7),(770,1930809600,6),(770,1951369200,7),(770,1962864000,6),(770,1983423600,7),(770,1994313600,6),(770,2014873200,7),(770,2025763200,6),(770,2046322800,7),(770,2057212800,6),(770,2077772400,7),(770,2088662400,6),(770,2109222000,7),(770,2120112000,6),(770,2140671600,7),(771,-2147483648,5),(771,-1633273200,1),(771,-1615132800,2),(771,-1601823600,1),(771,-1583683200,2),(771,-880210800,3),(771,-769395600,4),(771,-765388800,2),(771,-84380400,1),(771,-68659200,2),(771,-52930800,1),(771,-37209600,2),(771,-21481200,1),(771,-5760000,2),(771,9968400,1),(771,25689600,2),(771,41418000,1),(771,57744000,2),(771,73472400,1),(771,89193600,2),(771,104922000,1),(771,120643200,2),(771,126694800,1),(771,152092800,2),(771,162378000,1),(771,183542400,2),(771,199270800,1),(771,215596800,2),(771,230720400,1),(771,247046400,2),(771,262774800,1),(771,278496000,2),(771,294224400,1),(771,309945600,2),(771,325674000,1),(771,341395200,2),(771,357123600,1),(771,372844800,2),(771,388573200,1),(771,404899200,2),(771,420022800,1),(771,436348800,2),(771,452077200,1),(771,467798400,2),(771,483526800,1),(771,499248000,2),(771,514976400,1),(771,530697600,2),(771,544611600,1),(771,562147200,2),(771,576061200,1),(771,594201600,2),(771,607510800,1),(771,625651200,2),(771,638960400,1),(771,657100800,2),(771,671014800,1),(771,688550400,2),(771,702464400,1),(771,720000000,7),(771,733910400,6),(771,752050800,7),(771,765360000,6),(771,783500400,7),(771,796809600,6),(771,814950000,7),(771,828864000,6),(771,846399600,7),(771,860313600,6),(771,877849200,7),(771,891763200,6),(771,909298800,7),(771,923212800,6),(771,941353200,7),(771,954662400,6),(771,972802800,7),(771,986112000,6),(771,1004252400,7),(771,1018166400,6),(771,1035702000,7),(771,1049616000,6),(771,1067151600,7),(771,1081065600,6),(771,1099206000,7),(771,1112515200,6),(771,1130655600,7),(771,1143964800,6),(771,1162105200,7),(771,1173600000,6),(771,1194159600,7),(771,1205049600,6),(771,1225609200,7),(771,1236499200,6),(771,1257058800,7),(771,1268553600,6),(771,1289113200,7),(771,1300003200,6),(771,1320562800,7),(771,1331452800,6),(771,1352012400,7),(771,1362902400,6),(771,1383462000,7),(771,1394352000,6),(771,1414911600,7),(771,1425801600,6),(771,1446361200,7),(771,1457856000,6),(771,1478415600,7),(771,1489305600,6),(771,1509865200,7),(771,1520755200,6),(771,1541314800,7),(771,1552204800,6),(771,1572764400,7),(771,1583654400,6),(771,1604214000,7),(771,1615708800,6),(771,1636268400,7),(771,1647158400,6),(771,1667718000,7),(771,1678608000,6),(771,1699167600,7),(771,1710057600,6),(771,1730617200,7),(771,1741507200,6),(771,1762066800,7),(771,1772956800,6),(771,1793516400,7),(771,1805011200,6),(771,1825570800,7),(771,1836460800,6),(771,1857020400,7),(771,1867910400,6),(771,1888470000,7),(771,1899360000,6),(771,1919919600,7),(771,1930809600,6),(771,1951369200,7),(771,1962864000,6),(771,1983423600,7),(771,1994313600,6),(771,2014873200,7),(771,2025763200,6),(771,2046322800,7),(771,2057212800,6),(771,2077772400,7),(771,2088662400,6),(771,2109222000,7),(771,2120112000,6),(771,2140671600,7),(772,-2147483648,5),(772,-1633273200,1),(772,-1615132800,2),(772,-1601823600,1),(772,-1583683200,2),(772,-880210800,3),(772,-769395600,4),(772,-765388800,2),(772,-84380400,1),(772,-68659200,2),(772,-52930800,1),(772,-37209600,2),(772,-21481200,1),(772,-5760000,2),(772,9968400,1),(772,25689600,2),(772,41418000,1),(772,57744000,2),(772,73472400,1),(772,89193600,2),(772,104922000,1),(772,120643200,2),(772,126694800,1),(772,152092800,2),(772,162378000,1),(772,183542400,2),(772,199270800,1),(772,215596800,2),(772,230720400,1),(772,247046400,2),(772,262774800,1),(772,278496000,2),(772,294224400,1),(772,309945600,2),(772,325674000,1),(772,341395200,2),(772,357123600,1),(772,372844800,2),(772,388573200,1),(772,404899200,2),(772,420022800,1),(772,436348800,2),(772,452077200,1),(772,467798400,2),(772,483526800,1),(772,499248000,2),(772,514976400,1),(772,530697600,2),(772,544611600,1),(772,562147200,2),(772,576061200,1),(772,594201600,2),(772,607510800,1),(772,625651200,2),(772,638960400,1),(772,657100800,2),(772,671014800,1),(772,688550400,2),(772,702464400,1),(772,720000000,2),(772,733914000,1),(772,752054400,2),(772,765363600,1),(772,783504000,2),(772,796813200,1),(772,814953600,2),(772,828867600,1),(772,846403200,2),(772,860317200,1),(772,877852800,2),(772,891766800,1),(772,909302400,2),(772,923216400,1),(772,941356800,2),(772,954666000,1),(772,972806400,2),(772,986115600,1),(772,1004256000,2),(772,1018170000,1),(772,1035705600,2),(772,1049619600,1),(772,1067155200,7),(772,1081065600,6),(772,1099206000,7),(772,1112515200,6),(772,1130655600,7),(772,1143964800,6),(772,1162105200,7),(772,1173600000,6),(772,1194159600,7),(772,1205049600,6),(772,1225609200,7),(772,1236499200,6),(772,1257058800,7),(772,1268553600,6),(772,1289113200,7),(772,1300003200,6),(772,1320562800,7),(772,1331452800,6),(772,1352012400,7),(772,1362902400,6),(772,1383462000,7),(772,1394352000,6),(772,1414911600,7),(772,1425801600,6),(772,1446361200,7),(772,1457856000,6),(772,1478415600,7),(772,1489305600,6),(772,1509865200,7),(772,1520755200,6),(772,1541314800,7),(772,1552204800,6),(772,1572764400,7),(772,1583654400,6),(772,1604214000,7),(772,1615708800,6),(772,1636268400,7),(772,1647158400,6),(772,1667718000,7),(772,1678608000,6),(772,1699167600,7),(772,1710057600,6),(772,1730617200,7),(772,1741507200,6),(772,1762066800,7),(772,1772956800,6),(772,1793516400,7),(772,1805011200,6),(772,1825570800,7),(772,1836460800,6),(772,1857020400,7),(772,1867910400,6),(772,1888470000,7),(772,1899360000,6),(772,1919919600,7),(772,1930809600,6),(772,1951369200,7),(772,1962864000,6),(772,1983423600,7),(772,1994313600,6),(772,2014873200,7),(772,2025763200,6),(772,2046322800,7),(772,2057212800,6),(772,2077772400,7),(772,2088662400,6),(772,2109222000,7),(772,2120112000,6),(772,2140671600,7),(773,-2147483648,0),(773,-1686083584,1),(773,323845200,4),(773,338950800,2),(773,354675600,3),(773,370400400,2),(773,386125200,3),(773,401850000,2),(773,417574800,3),(773,433299600,2),(773,449024400,3),(773,465354000,2),(773,481078800,3),(773,496803600,2),(773,512528400,3),(773,528253200,2),(773,543978000,3),(773,559702800,2),(773,575427600,3),(773,591152400,2),(773,606877200,3),(773,622602000,2),(773,638326800,3),(773,654656400,2),(773,670381200,3),(773,686106000,2),(773,701830800,3),(773,717555600,2),(773,733280400,3),(773,749005200,2),(773,764730000,3),(773,780454800,2),(773,796179600,3),(773,811904400,2),(773,828234000,3),(773,846378000,2),(773,859683600,3),(773,877827600,2),(773,891133200,3),(773,909277200,2),(773,922582800,3),(773,941331600,2),(773,954032400,3),(773,972781200,2),(773,985482000,3),(773,1004230800,2),(773,1017536400,3),(773,1035680400,2),(773,1048986000,3),(773,1067130000,2),(773,1080435600,3),(773,1099184400,2),(773,1111885200,3),(773,1130634000,2),(773,1143334800,3),(773,1162083600,2),(773,1174784400,3),(773,1193533200,2),(773,1206838800,3),(773,1224982800,2),(773,1238288400,3),(773,1256432400,2),(773,1269738000,3),(773,1288486800,2),(773,1301187600,3),(773,1319936400,2),(773,1332637200,3),(773,1351386000,2),(773,1364691600,3),(773,1382835600,2),(773,1396141200,3),(773,1414285200,2),(773,1427590800,3),(773,1445734800,2),(773,1459040400,3),(773,1477789200,2),(773,1490490000,3),(773,1509238800,2),(773,1521939600,3),(773,1540688400,2),(773,1553994000,3),(773,1572138000,2),(773,1585443600,3),(773,1603587600,2),(773,1616893200,3),(773,1635642000,2),(773,1648342800,3),(773,1667091600,2),(773,1679792400,3),(773,1698541200,5),(773,1711846800,6),(773,1729990800,5),(773,1743296400,6),(773,1761440400,5),(773,1774746000,6),(773,1792890000,5),(773,1806195600,6),(773,1824944400,5),(773,1837645200,6),(773,1856394000,5),(773,1869094800,6),(773,1887843600,5),(773,1901149200,6),(773,1919293200,5),(773,1932598800,6),(773,1950742800,5),(773,1964048400,6),(773,1982797200,5),(773,1995498000,6),(773,2014246800,5),(773,2026947600,6),(773,2045696400,5),(773,2058397200,6),(773,2077146000,5),(773,2090451600,6),(773,2108595600,5),(773,2121901200,6),(773,2140045200,5),(773,2147483647,5),(774,-2147483648,0),(774,-1514739600,1),(774,-1343066400,2),(774,-1234807200,4),(774,-1220292000,3),(774,-1207159200,4),(774,-1191344400,2),(774,828864000,5),(774,846399600,2),(774,860313600,5),(774,877849200,2),(774,891766800,3),(774,909302400,4),(774,923216400,3),(774,941356800,4),(774,954666000,3),(774,972806400,4),(774,989139600,3),(774,1001836800,4),(774,1018170000,3),(774,1035705600,4),(774,1049619600,3),(774,1067155200,4),(774,1081069200,3),(774,1099209600,4),(774,1112518800,3),(774,1130659200,4),(774,1143968400,3),(774,1162108800,4),(774,1175418000,3),(774,1193558400,4),(774,1207472400,3),(774,1225008000,4),(774,1238922000,3),(774,1256457600,4),(774,1268557200,3),(774,1289116800,4),(774,1300006800,3),(774,1320566400,4),(774,1331456400,3),(774,1352016000,4),(774,1362906000,3),(774,1383465600,4),(774,1394355600,3),(774,1414915200,4),(774,1425805200,3),(774,1446364800,4),(774,1457859600,3),(774,1478419200,4),(774,1489309200,3),(774,1509868800,4),(774,1520758800,3),(774,1541318400,4),(774,1552208400,3),(774,1572768000,4),(774,1583658000,3),(774,1604217600,4),(774,1615712400,3),(774,1636272000,4),(774,1647162000,3),(774,1667116800,2),(774,1678608000,5),(774,1699167600,2),(774,1710057600,5),(774,1730617200,2),(774,1741507200,5),(774,1762066800,2),(774,1772956800,5),(774,1793516400,2),(774,1805011200,5),(774,1825570800,2),(774,1836460800,5),(774,1857020400,2),(774,1867910400,5),(774,1888470000,2),(774,1899360000,5),(774,1919919600,2),(774,1930809600,5),(774,1951369200,2),(774,1962864000,5),(774,1983423600,2),(774,1994313600,5),(774,2014873200,2),(774,2025763200,5),(774,2046322800,2),(774,2057212800,5),(774,2077772400,2),(774,2088662400,5),(774,2109222000,2),(774,2120112000,5),(774,2140671600,2),(775,-2147483648,1),(775,-1946918424,2),(776,-2147483648,0),(776,-865296000,4),(776,-769395600,1),(776,-765396000,2),(776,73465200,3),(776,89186400,2),(776,104914800,3),(776,120636000,2),(776,136364400,3),(776,152085600,2),(776,167814000,3),(776,183535200,2),(776,199263600,3),(776,215589600,2),(776,230713200,3),(776,247039200,2),(776,262767600,3),(776,278488800,2),(776,294217200,3),(776,309938400,2),(776,325666800,3),(776,341388000,2),(776,357116400,3),(776,372837600,2),(776,388566000,3),(776,404892000,2),(776,420015600,3),(776,436341600,2),(776,452070000,3),(776,467791200,2),(776,483519600,3),(776,499240800,2),(776,514969200,3),(776,530690400,2),(776,544604400,3),(776,562140000,2),(776,576054000,3),(776,594194400,2),(776,607503600,3),(776,625644000,2),(776,638953200,3),(776,657093600,2),(776,671007600,3),(776,688543200,2),(776,702457200,3),(776,719992800,2),(776,733906800,3),(776,752047200,2),(776,765356400,3),(776,783496800,2),(776,796806000,3),(776,814946400,2),(776,828860400,3),(776,846396000,2),(776,860310000,3),(776,877845600,2),(776,891759600,3),(776,909295200,2),(776,923209200,3),(776,941349600,5),(776,954662400,6),(776,972802800,2),(776,986108400,3),(776,1004248800,2),(776,1018162800,3),(776,1035698400,2),(776,1049612400,3),(776,1067148000,2),(776,1081062000,3),(776,1099202400,2),(776,1112511600,3),(776,1130652000,2),(776,1143961200,3),(776,1162101600,2),(776,1173596400,3),(776,1194156000,2),(776,1205046000,3),(776,1225605600,2),(776,1236495600,3),(776,1257055200,2),(776,1268550000,3),(776,1289109600,2),(776,1299999600,3),(776,1320559200,2),(776,1331449200,3),(776,1352008800,2),(776,1362898800,3),(776,1383458400,2),(776,1394348400,3),(776,1414908000,2),(776,1425798000,3),(776,1446357600,2),(776,1457852400,3),(776,1478412000,2),(776,1489302000,3),(776,1509861600,2),(776,1520751600,3),(776,1541311200,2),(776,1552201200,3),(776,1572760800,2),(776,1583650800,3),(776,1604210400,2),(776,1615705200,3),(776,1636264800,2),(776,1647154800,3),(776,1667714400,2),(776,1678604400,3),(776,1699164000,2),(776,1710054000,3),(776,1730613600,2),(776,1741503600,3),(776,1762063200,2),(776,1772953200,3),(776,1793512800,2),(776,1805007600,3),(776,1825567200,2),(776,1836457200,3),(776,1857016800,2),(776,1867906800,3),(776,1888466400,2),(776,1899356400,3),(776,1919916000,2),(776,1930806000,3),(776,1951365600,2),(776,1962860400,3),(776,1983420000,2),(776,1994310000,3),(776,2014869600,2),(776,2025759600,3),(776,2046319200,2),(776,2057209200,3),(776,2077768800,2),(776,2088658800,3),(776,2109218400,2),(776,2120108400,3),(776,2140668000,2),(777,-2147483648,0),(777,-1861906760,1),(777,-1104524348,2),(777,-765317964,3),(777,465449400,4),(777,2147483647,4),(778,-2147483648,4),(778,-1633273200,1),(778,-1615132800,2),(778,-1601823600,1),(778,-1583683200,2),(778,-880210800,3),(778,-820519140,2),(778,-812653140,3),(778,-796845540,2),(778,-84380400,1),(778,-68659200,2),(779,-2147483648,1),(779,-1670483460,3),(779,421218000,2),(779,436334400,3),(779,452062800,2),(779,467784000,3),(779,483512400,2),(779,499233600,3),(779,514962000,2),(779,530683200,3),(779,546411600,2),(779,562132800,3),(779,576050400,4),(779,594194400,5),(779,607500000,4),(779,625644000,5),(779,638949600,4),(779,657093600,5),(779,671004000,4),(779,688543200,5),(779,702453600,4),(779,719992800,5),(779,733903200,4),(779,752047200,5),(779,765352800,4),(779,783496800,5),(779,796802400,4),(779,814946400,5),(779,828856800,4),(779,846396000,5),(779,860306400,4),(779,877845600,5),(779,1112504400,2),(779,1130644800,3),(779,1143954000,2),(779,1162094400,3),(779,1331449200,2),(779,1352008800,3),(779,1362898800,2),(779,1383458400,3),(779,1394348400,2),(779,1414908000,3),(779,1425798000,2),(779,1446357600,3),(779,1489302000,2),(779,1509861600,3),(779,1520751600,2),(779,1541311200,3),(779,1552201200,2),(779,1572760800,3),(779,1583650800,2),(779,1604210400,3),(779,1615705200,2),(779,1636264800,3),(779,1647154800,2),(779,1667714400,3),(779,1678604400,2),(779,1699164000,3),(779,1710054000,2),(779,1730613600,3),(779,1741503600,2),(779,1762063200,3),(779,1772953200,2),(779,1793512800,3),(779,1805007600,2),(779,1825567200,3),(779,1836457200,2),(779,1857016800,3),(779,1867906800,2),(779,1888466400,3),(779,1899356400,2),(779,1919916000,3),(779,1930806000,2),(779,1951365600,3),(779,1962860400,2),(779,1983420000,3),(779,1994310000,2),(779,2014869600,3),(779,2025759600,2),(779,2046319200,3),(779,2057209200,2),(779,2077768800,3),(779,2088658800,2),(779,2109218400,3),(779,2120108400,2),(779,2140668000,3),(780,-2147483648,1),(780,-873057600,3),(780,-769395600,2),(780,-765399600,1),(781,-2147483648,0),(781,-1767209328,2),(781,-1206950400,1),(781,-1191355200,2),(781,-1175367600,1),(781,-1159819200,2),(781,-633812400,1),(781,-622062000,2),(781,-602276400,1),(781,-591825600,2),(781,-570740400,1),(781,-560203200,2),(781,-539118000,1),(781,-531345600,2),(781,-191358000,1),(781,-184190400,2),(781,-155156400,1),(781,-150062400,2),(781,-128890800,1),(781,-121118400,2),(781,-99946800,1),(781,-89582400,2),(781,-68410800,1),(781,-57960000,2),(781,499755600,1),(781,511243200,2),(781,530600400,1),(781,540273600,2),(781,562136400,1),(781,571204800,2),(781,1214283600,3),(781,1384056000,2),(781,2147483647,2),(782,-2147483648,0),(782,-1767210264,2),(782,-1206954000,1),(782,-1191358800,2),(782,-1175371200,1),(782,-1159822800,2),(782,-633816000,1),(782,-622065600,2),(782,-602280000,1),(782,-591829200,2),(782,-570744000,1),(782,-560206800,2),(782,-539121600,1),(782,-531349200,2),(782,-191361600,1),(782,-184194000,2),(782,-155160000,1),(782,-150066000,2),(782,-128894400,1),(782,-121122000,2),(782,-99950400,1),(782,-89586000,2),(782,-68414400,1),(782,-57963600,2),(782,499752000,1),(782,511239600,2),(782,530596800,1),(782,540270000,2),(782,562132800,1),(782,571201200,2),(782,2147483647,2),(783,-2147483648,1),(783,-873057600,3),(783,-769395600,2),(783,-765399600,1),(784,-2147483648,1),(784,-1892661435,2),(784,-1688410800,1),(784,-1619205435,3),(784,-1593806400,1),(784,-1335986235,4),(784,-1317585600,2),(784,-1304362800,4),(784,-1286049600,2),(784,-1272826800,4),(784,-1254513600,2),(784,-1241290800,4),(784,-1222977600,2),(784,-1209754800,4),(784,-1191355200,2),(784,-1178132400,3),(784,-870552000,2),(784,-865278000,3),(784,-736632000,4),(784,-718056000,2),(784,-713649600,3),(784,-36619200,5),(784,-23922000,6),(784,-3355200,5),(784,7527600,6),(784,24465600,5),(784,37767600,6),(784,55915200,5),(784,69217200,6),(784,87969600,5),(784,100666800,6),(784,118209600,5),(784,132116400,6),(784,150868800,5),(784,163566000,6),(784,182318400,5),(784,195620400,6),(784,213768000,5),(784,227070000,6),(784,245217600,5),(784,258519600,6),(784,277272000,5),(784,289969200,6),(784,308721600,5),(784,321418800,6),(784,340171200,5),(784,353473200,6),(784,371620800,5),(784,384922800,6),(784,403070400,5),(784,416372400,6),(784,434520000,5),(784,447822000,6),(784,466574400,5),(784,479271600,6),(784,498024000,5),(784,510721200,6),(784,529473600,5),(784,545194800,6),(784,560923200,5),(784,574225200,6),(784,592372800,5),(784,605674800,6),(784,624427200,5),(784,637124400,6),(784,653457600,5),(784,668574000,6),(784,687326400,5),(784,700628400,6),(784,718776000,5),(784,732078000,6),(784,750225600,5),(784,763527600,6),(784,781675200,5),(784,794977200,6),(784,813729600,5),(784,826426800,6),(784,845179200,5),(784,859690800,6),(784,876628800,5),(784,889930800,6),(784,906868800,5),(784,923194800,6),(784,939528000,5),(784,952830000,6),(784,971582400,5),(784,984279600,6),(784,1003032000,5),(784,1015729200,6),(784,1034481600,5),(784,1047178800,6),(784,1065931200,5),(784,1079233200,6),(784,1097380800,5),(784,1110682800,6),(784,1128830400,5),(784,1142132400,6),(784,1160884800,5),(784,1173582000,6),(784,1192334400,5),(784,1206846000,6),(784,1223784000,5),(784,1237086000,6),(784,1255233600,5),(784,1270350000,6),(784,1286683200,5),(784,1304823600,6),(784,1313899200,5),(784,1335668400,6),(784,1346558400,5),(784,1367118000,6),(784,1378612800,5),(784,1398567600,6),(784,1410062400,5),(784,1463281200,6),(784,1471147200,5),(784,1480820400,7),(784,2147483647,7),(785,-2147483648,2),(785,-1694368800,1),(785,-1681671600,2),(785,-1632067200,1),(785,-1615136400,2),(785,-1029686400,1),(785,-1018198800,2),(785,-880214400,3),(785,-769395600,4),(785,-765392400,2),(785,-746035200,1),(785,-732733200,2),(785,-715795200,1),(785,-702493200,2),(785,-684345600,1),(785,-671043600,2),(785,-652896000,1),(785,-639594000,2),(785,-620755200,1),(785,-607626000,2),(785,-589392000,1),(785,-576090000,2),(785,-557942400,1),(785,-544640400,2),(785,-526492800,1),(785,-513190800,2),(785,-495043200,1),(785,-481741200,2),(785,-463593600,1),(785,-450291600,2),(785,-431539200,1),(785,-418237200,2),(785,-400089600,1),(785,-386787600,2),(785,-368640000,1),(785,-355338000,2),(785,-337190400,1),(785,-321469200,2),(785,-305740800,1),(785,-292438800,2),(785,-210787200,1),(785,-198090000,2),(785,-116438400,5),(785,-100108800,6),(785,-84384000,5),(785,-68659200,6),(785,-52934400,5),(785,-37209600,6),(785,-21484800,5),(785,-5760000,6),(785,9964800,5),(785,25689600,6),(785,41414400,5),(785,57744000,6),(785,73468800,5),(785,89193600,6),(785,104918400,5),(785,120643200,6),(785,136368000,5),(785,152092800,6),(785,167817600,5),(785,183542400,6),(785,199267200,5),(785,215596800,6),(785,230716800,5),(785,247046400,6),(785,262771200,5),(785,278496000,6),(785,294220800,5),(785,309945600,6),(785,325670400,5),(785,341395200,6),(785,357120000,5),(785,372844800,6),(785,388569600,5),(785,404899200,6),(785,420019200,5),(785,436348800,6),(785,452073600,5),(785,467798400,6),(785,483523200,5),(785,499248000,6),(785,514972800,5),(785,530697600,6),(785,544608000,5),(785,562147200,6),(785,576057600,5),(785,594201600,6),(785,607507200,5),(785,625651200,6),(785,638956800,5),(785,657100800,6),(785,671011200,5),(785,688550400,6),(785,702460800,5),(785,720000000,6),(785,733910400,5),(785,752054400,6),(785,765360000,5),(785,783504000,6),(785,796809600,5),(785,814953600,6),(785,828864000,5),(785,846403200,6),(785,860313600,5),(785,877852800,6),(785,891763200,5),(785,909302400,6),(785,923212800,5),(785,941356800,6),(785,954662400,5),(785,972806400,6),(785,986112000,5),(785,1004256000,6),(785,1018166400,5),(785,1035705600,6),(785,1049616000,5),(785,1067155200,6),(785,1081065600,5),(785,1099209600,6),(785,1112515200,5),(785,1130659200,6),(785,1136095200,2),(785,1143964800,1),(785,1162105200,2),(785,1173600000,1),(785,1194159600,2),(785,1205049600,1),(785,1225609200,2),(785,1236499200,1),(785,1257058800,2),(785,1268553600,1),(785,1289113200,2),(785,1300003200,1),(785,1320562800,2),(785,1331452800,1),(785,1352012400,2),(785,1362902400,1),(785,1383462000,2),(785,1394352000,1),(785,1414911600,2),(785,1425801600,1),(785,1446361200,2),(785,1457856000,1),(785,1478415600,2),(785,1489305600,1),(785,1509865200,2),(785,1520755200,1),(785,1541314800,2),(785,1552204800,1),(785,1572764400,2),(785,1583654400,1),(785,1604214000,2),(785,1615708800,1),(785,1636268400,2),(785,1647158400,1),(785,1667718000,2),(785,1678608000,1),(785,1699167600,2),(785,1710057600,1),(785,1730617200,2),(785,1741507200,1),(785,1762066800,2),(785,1772956800,1),(785,1793516400,2),(785,1805011200,1),(785,1825570800,2),(785,1836460800,1),(785,1857020400,2),(785,1867910400,1),(785,1888470000,2),(785,1899360000,1),(785,1919919600,2),(785,1930809600,1),(785,1951369200,2),(785,1962864000,1),(785,1983423600,2),(785,1994313600,1),(785,2014873200,2),(785,2025763200,1),(785,2046322800,2),(785,2057212800,1),(785,2077772400,2),(785,2088662400,1),(785,2109222000,2),(785,2120112000,1),(785,2140671600,2),(786,-2147483648,0),(786,-410227200,2),(786,73468800,1),(786,89190000,2),(786,104918400,1),(786,120639600,2),(786,136368000,1),(786,152089200,2),(786,167817600,1),(786,183538800,2),(786,199267200,1),(786,215593200,2),(786,230716800,1),(786,247042800,2),(786,262771200,1),(786,278492400,2),(786,294220800,1),(786,309942000,2),(786,325670400,1),(786,341391600,2),(786,357120000,1),(786,372841200,2),(786,388569600,1),(786,404895600,2),(786,420019200,1),(786,436345200,2),(786,452073600,1),(786,467794800,2),(786,483523200,1),(786,499244400,2),(786,514972800,1),(786,530694000,2),(786,544608000,1),(786,562143600,2),(786,576057600,1),(786,594198000,2),(786,607507200,1),(786,625647600,2),(786,638956800,1),(786,657097200,2),(786,671011200,1),(786,688546800,2),(786,702460800,1),(786,719996400,2),(786,733910400,1),(786,752050800,2),(786,765360000,1),(786,783500400,2),(786,796809600,1),(786,814950000,2),(786,828864000,1),(786,846399600,2),(786,860313600,1),(786,877849200,2),(786,891763200,1),(786,909298800,2),(786,923212800,1),(786,941353200,2),(786,954662400,1),(786,972802800,3),(786,986112000,1),(786,1004252400,2),(786,1018166400,1),(786,1035702000,2),(786,1049616000,1),(786,1067151600,2),(786,1081065600,1),(786,1099206000,2),(786,1112515200,1),(786,1130655600,2),(786,1143964800,1),(786,1162105200,2),(786,1173600000,1),(786,1194159600,2),(786,1205049600,1),(786,1225609200,2),(786,1236499200,1),(786,1257058800,2),(786,1268553600,1),(786,1289113200,2),(786,1300003200,1),(786,1320562800,2),(786,1331452800,1),(786,1352012400,2),(786,1362902400,1),(786,1383462000,2),(786,1394352000,1),(786,1414911600,2),(786,1425801600,1),(786,1446361200,2),(786,1457856000,1),(786,1478415600,2),(786,1489305600,1),(786,1509865200,2),(786,1520755200,1),(786,1541314800,2),(786,1552204800,1),(786,1572764400,2),(786,1583654400,1),(786,1604214000,2),(786,1615708800,1),(786,1636268400,2),(786,1647158400,1),(786,1667718000,2),(786,1678608000,1),(786,1699167600,2),(786,1710057600,1),(786,1730617200,2),(786,1741507200,1),(786,1762066800,2),(786,1772956800,1),(786,1793516400,2),(786,1805011200,1),(786,1825570800,2),(786,1836460800,1),(786,1857020400,2),(786,1867910400,1),(786,1888470000,2),(786,1899360000,1),(786,1919919600,2),(786,1930809600,1),(786,1951369200,2),(786,1962864000,1),(786,1983423600,2),(786,1994313600,1),(786,2014873200,2),(786,2025763200,1),(786,2046322800,2),(786,2057212800,1),(786,2077772400,2),(786,2088662400,1),(786,2109222000,2),(786,2120112000,1),(786,2140671600,2),(787,-2147483648,0),(787,-1767217224,2),(787,-1206957600,1),(787,-1191362400,2),(787,-1175374800,1),(787,-1159826400,2),(787,-633819600,1),(787,-622069200,2),(787,-602283600,1),(787,-591832800,2),(787,-570747600,1),(787,-560210400,2),(787,-539125200,1),(787,-531352800,2),(787,-191365200,1),(787,-184197600,2),(787,-155163600,1),(787,-150069600,2),(787,-128898000,1),(787,-121125600,2),(787,-99954000,1),(787,-89589600,2),(787,-68418000,1),(787,-57967200,2),(787,499748400,1),(787,511236000,2),(787,530593200,1),(787,540266400,2),(787,562129200,1),(787,571197600,2),(787,592974000,1),(787,602042400,2),(787,624423600,1),(787,634701600,2),(787,938919600,1),(787,951616800,2),(787,970974000,1),(787,971575200,2),(787,1003028400,1),(787,1013911200,2),(787,2147483647,2),(788,-2147483648,0),(788,-2030202084,2),(788,-1632063600,1),(788,-1615132800,2),(788,-1251651600,1),(788,-1238349600,2),(788,-1220202000,1),(788,-1206900000,2),(788,-1188752400,1),(788,-1175450400,2),(788,-1156698000,1),(788,-1144000800,2),(788,-1125248400,1),(788,-1111946400,2),(788,-1032714000,1),(788,-1016992800,2),(788,-1001264400,1),(788,-986148000,2),(788,-969814800,1),(788,-954093600,2),(788,-937760400,1),(788,-922039200,2),(788,-906310800,1),(788,-890589600,2),(788,-880210800,3),(788,-769395600,4),(788,-765388800,2),(788,-748450800,1),(788,-732729600,2),(788,-715791600,1),(788,-702489600,2),(788,-684342000,1),(788,-671040000,2),(788,-652892400,1),(788,-639590400,2),(788,-620838000,1),(788,-608140800,2),(788,-589388400,1),(788,-576086400,2),(788,-557938800,1),(788,-544636800,2),(788,-526489200,1),(788,-513187200,2),(788,-495039600,1),(788,-481737600,2),(788,-463590000,1),(788,-450288000,2),(788,-431535600,1),(788,-418233600,2),(788,-400086000,1),(788,-386784000,2),(788,-337186800,1),(788,-321465600,2),(788,-305737200,5),(789,-2147483648,0),(789,-704937600,2),(789,73468800,1),(789,89190000,2),(789,104918400,1),(789,120639600,2),(789,136368000,1),(789,152089200,2),(789,167817600,1),(789,183538800,2),(789,199267200,1),(789,215593200,2),(789,230716800,1),(789,247042800,2),(789,262771200,1),(789,278492400,2),(789,294220800,1),(789,309942000,2),(789,325670400,1),(789,341391600,2),(789,357120000,1),(789,372841200,2),(789,388569600,1),(789,404895600,2),(789,420019200,1),(789,436345200,2),(789,452073600,1),(789,467794800,2),(789,483523200,1),(789,499244400,2),(789,514972800,1),(789,530694000,2),(789,544608000,1),(789,562143600,2),(789,576057600,1),(789,594198000,2),(789,607507200,1),(789,625647600,2),(789,638956800,1),(789,657097200,2),(789,671011200,1),(789,688546800,2),(789,702460800,1),(789,719996400,2),(789,733910400,1),(789,752050800,2),(789,765360000,1),(789,783500400,2),(789,796809600,1),(789,814950000,2),(789,828864000,1),(789,846399600,2),(789,860313600,1),(789,877849200,2),(789,891763200,1),(789,909298800,2),(789,923212800,1),(789,941353200,2),(789,954662400,1),(789,972802800,3),(789,986112000,1),(789,1004252400,2),(789,1018166400,1),(789,1035702000,2),(789,1049616000,1),(789,1067151600,2),(789,1081065600,1),(789,1099206000,2),(789,1112515200,1),(789,1130655600,2),(789,1143964800,1),(789,1162105200,3),(789,1173600000,1),(789,1194159600,2),(789,1205049600,1),(789,1225609200,2),(789,1236499200,1),(789,1257058800,2),(789,1268553600,1),(789,1289113200,2),(789,1300003200,1),(789,1320562800,2),(789,1331452800,1),(789,1352012400,2),(789,1362902400,1),(789,1383462000,2),(789,1394352000,1),(789,1414911600,2),(789,1425801600,1),(789,1446361200,2),(789,1457856000,1),(789,1478415600,2),(789,1489305600,1),(789,1509865200,2),(789,1520755200,1),(789,1541314800,2),(789,1552204800,1),(789,1572764400,2),(789,1583654400,1),(789,1604214000,2),(789,1615708800,1),(789,1636268400,2),(789,1647158400,1),(789,1667718000,2),(789,1678608000,1),(789,1699167600,2),(789,1710057600,1),(789,1730617200,2),(789,1741507200,1),(789,1762066800,2),(789,1772956800,1),(789,1793516400,2),(789,1805011200,1),(789,1825570800,2),(789,1836460800,1),(789,1857020400,2),(789,1867910400,1),(789,1888470000,2),(789,1899360000,1),(789,1919919600,2),(789,1930809600,1),(789,1951369200,2),(789,1962864000,1),(789,1983423600,2),(789,1994313600,1),(789,2014873200,2),(789,2025763200,1),(789,2046322800,2),(789,2057212800,1),(789,2077772400,2),(789,2088662400,1),(789,2109222000,2),(789,2120112000,1),(789,2140671600,2),(790,-2147483648,0),(790,-1767209328,2),(790,-1206950400,1),(790,-1191355200,2),(790,-1175367600,1),(790,-1159819200,2),(790,-633812400,1),(790,-622062000,2),(790,-602276400,1),(790,-591825600,2),(790,-570740400,1),(790,-560203200,2),(790,-539118000,1),(790,-531345600,2),(790,-191358000,1),(790,-184190400,2),(790,-155156400,1),(790,-150062400,2),(790,-128890800,1),(790,-121118400,2),(790,-99946800,1),(790,-89582400,2),(790,-68410800,1),(790,-57960000,2),(790,499755600,1),(790,511243200,2),(790,530600400,1),(790,540273600,2),(790,562136400,1),(790,571204800,2),(790,1214283600,3),(790,1384056000,2),(790,2147483647,2),(791,-2147483648,1),(791,-1567453392,2),(791,-1233432000,3),(791,-1222981200,2),(791,-1205956800,3),(791,-1194037200,2),(791,-1172865600,3),(791,-1162501200,2),(791,-1141329600,3),(791,-1130965200,2),(791,-1109793600,3),(791,-1099429200,2),(791,-1078257600,3),(791,-1067806800,2),(791,-1046635200,3),(791,-1036270800,2),(791,-1015099200,3),(791,-1004734800,2),(791,-983563200,3),(791,-973198800,2),(791,-952027200,3),(791,-941576400,2),(791,-931032000,3),(791,-900882000,2),(791,-890337600,3),(791,-833749200,2),(791,-827265600,3),(791,-752274000,2),(791,-733780800,3),(791,-197326800,2),(791,-190843200,3),(791,-184194000,2),(791,-164491200,3),(791,-152658000,2),(791,-132955200,3),(791,-121122000,2),(791,-101419200,3),(791,-86821200,2),(791,-71092800,3),(791,-54766800,2),(791,-39038400,3),(791,-23317200,2),(791,-7588800,5),(791,128142000,4),(791,136605600,5),(791,596948400,4),(791,605066400,5),(791,624423600,4),(791,636516000,5),(791,656478000,4),(791,667965600,2),(791,687931200,4),(791,699415200,5),(791,719377200,4),(791,731469600,5),(791,938919600,3),(791,952052400,5),(791,1198983600,4),(791,1205632800,5),(791,1224385200,4),(791,1237082400,5),(791,2147483647,5),(792,-2147483648,0),(792,-1514739600,1),(792,-1451667600,2),(792,-1343062800,3),(792,-1234803600,2),(792,-1222963200,4),(792,-1207242000,2),(792,-873820800,5),(792,-769395600,6),(792,-761677200,2),(792,-686073600,4),(792,-661539600,2),(792,-495039600,4),(792,-481734000,2),(792,-463590000,4),(792,-450284400,2),(792,-431535600,4),(792,-418230000,2),(792,-400086000,4),(792,-386780400,2),(792,-368636400,4),(792,-355330800,2),(792,-337186800,4),(792,-323881200,2),(792,-305737200,4),(792,-292431600,2),(792,199274400,4),(792,215600400,2),(792,230724000,4),(792,247050000,2),(792,262778400,4),(792,278499600,2),(792,294228000,4),(792,309949200,2),(792,325677600,4),(792,341398800,2),(792,357127200,4),(792,372848400,2),(792,388576800,4),(792,404902800,2),(792,420026400,4),(792,436352400,2),(792,452080800,4),(792,467802000,2),(792,483530400,4),(792,499251600,2),(792,514980000,4),(792,530701200,2),(792,544615200,4),(792,562150800,2),(792,576064800,4),(792,594205200,2),(792,607514400,4),(792,625654800,2),(792,638964000,4),(792,657104400,2),(792,671018400,4),(792,688554000,2),(792,702468000,4),(792,720003600,2),(792,733917600,4),(792,752058000,2),(792,765367200,4),(792,783507600,2),(792,796816800,4),(792,814957200,2),(792,828871200,4),(792,846406800,2),(792,860320800,4),(792,877856400,2),(792,891770400,4),(792,909306000,2),(792,923220000,4),(792,941360400,2),(792,954669600,4),(792,972810000,2),(792,986119200,4),(792,1004259600,2),(792,1018173600,4),(792,1035709200,2),(792,1049623200,4),(792,1067158800,2),(792,1081072800,4),(792,1099213200,2),(792,1112522400,4),(792,1130662800,2),(792,1143972000,4),(792,1162112400,2),(792,1175421600,4),(792,1193562000,2),(792,1207476000,4),(792,1225011600,2),(792,1238925600,4),(792,1256461200,2),(792,1268560800,4),(792,1289120400,2),(792,1300010400,4),(792,1320570000,2),(792,1331460000,4),(792,1352019600,2),(792,1362909600,4),(792,1383469200,2),(792,1394359200,4),(792,1414918800,2),(792,1425808800,4),(792,1446368400,2),(792,1457863200,4),(792,1478422800,2),(792,1489312800,4),(792,1509872400,2),(792,1520762400,4),(792,1541322000,2),(792,1552212000,4),(792,1572771600,2),(792,1583661600,4),(792,1604221200,2),(792,1615716000,4),(792,1636275600,2),(792,1647165600,4),(792,1667725200,2),(792,1678615200,4),(792,1699174800,2),(792,1710064800,4),(792,1730624400,2),(792,1741514400,4),(792,1762074000,2),(792,1772964000,4),(792,1793523600,2),(792,1805018400,4),(792,1825578000,2),(792,1836468000,4),(792,1857027600,2),(792,1867917600,4),(792,1888477200,2),(792,1899367200,4),(792,1919926800,2),(792,1930816800,4),(792,1951376400,2),(792,1962871200,4),(792,1983430800,2),(792,1994320800,4),(792,2014880400,2),(792,2025770400,4),(792,2046330000,2),(792,2057220000,4),(792,2077779600,2),(792,2088669600,4),(792,2109229200,2),(792,2120119200,4),(792,2140678800,2),(793,-2147483648,0),(793,-1767212472,2),(793,-1206954000,1),(793,-1191358800,2),(793,-1175371200,1),(793,-1159822800,2),(793,-633816000,1),(793,-622065600,2),(793,-602280000,1),(793,-591829200,2),(793,-570744000,1),(793,-560206800,2),(793,-539121600,1),(793,-531349200,2),(793,-191361600,1),(793,-184194000,2),(793,-155160000,1),(793,-150066000,2),(793,-128894400,1),(793,-121122000,2),(793,-99950400,1),(793,-89586000,2),(793,-68414400,1),(793,-57963600,2),(793,499752000,1),(793,511239600,2),(793,530596800,1),(793,540270000,2),(793,562132800,1),(793,571201200,2),(793,1214280000,3),(793,2147483647,3),(794,-2147483648,1),(794,-1892661435,2),(794,-1688410800,1),(794,-1619205435,3),(794,-1593806400,1),(794,-1335986235,4),(794,-1317585600,2),(794,-1304362800,4),(794,-1286049600,2),(794,-1272826800,4),(794,-1254513600,2),(794,-1241290800,4),(794,-1222977600,2),(794,-1209754800,4),(794,-1191355200,2),(794,-1178132400,3),(794,-870552000,2),(794,-865278000,3),(794,-740520000,5),(794,-736635600,4),(794,-718056000,2),(794,-713649600,3),(794,-36619200,6),(794,-23922000,7),(794,-3355200,6),(794,7527600,7),(794,24465600,6),(794,37767600,7),(794,55915200,6),(794,69217200,7),(794,87969600,6),(794,100666800,7),(794,118209600,6),(794,132116400,7),(794,150868800,6),(794,163566000,7),(794,182318400,6),(794,195620400,7),(794,213768000,6),(794,227070000,7),(794,245217600,6),(794,258519600,7),(794,277272000,6),(794,289969200,7),(794,308721600,6),(794,321418800,7),(794,340171200,6),(794,353473200,7),(794,371620800,6),(794,384922800,7),(794,403070400,6),(794,416372400,7),(794,434520000,6),(794,447822000,7),(794,466574400,6),(794,479271600,7),(794,498024000,6),(794,510721200,7),(794,529473600,6),(794,545194800,7),(794,560923200,6),(794,574225200,7),(794,592372800,6),(794,605674800,7),(794,624427200,6),(794,637124400,7),(794,653457600,6),(794,668574000,7),(794,687326400,6),(794,700628400,7),(794,718776000,6),(794,732078000,7),(794,750225600,6),(794,763527600,7),(794,781675200,6),(794,794977200,7),(794,813729600,6),(794,826426800,7),(794,845179200,6),(794,859690800,7),(794,876628800,6),(794,889930800,7),(794,906868800,6),(794,923194800,7),(794,939528000,6),(794,952830000,7),(794,971582400,6),(794,984279600,7),(794,1003032000,6),(794,1015729200,7),(794,1034481600,6),(794,1047178800,7),(794,1065931200,6),(794,1079233200,7),(794,1097380800,6),(794,1110682800,7),(794,1128830400,6),(794,1142132400,7),(794,1160884800,6),(794,1173582000,7),(794,1192334400,6),(794,1206846000,7),(794,1223784000,6),(794,1237086000,7),(794,1255233600,6),(794,1270350000,7),(794,1286683200,6),(794,1304823600,7),(794,1313899200,6),(794,1335668400,7),(794,1346558400,6),(794,1367118000,7),(794,1378612800,6),(794,1398567600,7),(794,1410062400,6),(794,1463281200,7),(794,1471147200,6),(794,1494730800,7),(794,1502596800,6),(794,1526180400,7),(794,1534046400,6),(794,1554606000,7),(794,1567915200,6),(794,1586055600,7),(794,1599364800,6),(794,1617505200,7),(794,1630814400,6),(794,1648954800,7),(794,1662868800,6),(794,1680404400,7),(794,1693713600,6),(794,1712458800,7),(794,1725768000,6),(794,1743908400,7),(794,1757217600,6),(794,1775358000,7),(794,1788667200,6),(794,1806807600,7),(794,1820116800,6),(794,1838257200,7),(794,1851566400,6),(794,1870311600,7),(794,1883016000,6),(794,1901761200,7),(794,1915070400,6),(794,1933210800,7),(794,1946520000,6),(794,1964660400,7),(794,1977969600,6),(794,1996110000,7),(794,2009419200,6),(794,2027559600,7),(794,2040868800,6),(794,2059614000,7),(794,2072318400,6),(794,2091063600,7),(794,2104372800,6),(794,2122513200,7),(794,2135822400,6),(794,2147483647,6),(795,-2147483648,1),(795,-1159773600,3),(795,-100119600,2),(795,-89668800,3),(795,-5770800,4),(795,4422600,3),(795,25678800,4),(795,33193800,3),(795,57733200,4),(795,64816200,3),(795,89182800,4),(795,96438600,3),(795,120632400,4),(795,127974600,3),(795,152082000,5),(795,972799200,3),(795,975823200,5),(796,-2147483648,0),(796,-1767214412,2),(796,-1206957600,1),(796,-1191362400,2),(796,-1175374800,1),(796,-1159826400,2),(796,-633819600,1),(796,-622069200,2),(796,-602283600,1),(796,-591832800,2),(796,-570747600,1),(796,-560210400,2),(796,-539125200,1),(796,-531352800,2),(796,-195426000,1),(796,-184197600,2),(796,-155163600,1),(796,-150069600,2),(796,-128898000,1),(796,-121125600,2),(796,-99954000,1),(796,-89589600,2),(796,-68418000,1),(796,-57967200,2),(796,499748400,1),(796,511236000,2),(796,530593200,1),(796,540266400,2),(796,562129200,1),(796,571197600,2),(796,592974000,1),(796,602042400,2),(796,624423600,1),(796,634701600,2),(796,656478000,1),(796,666756000,2),(796,687927600,1),(796,697600800,2),(796,719982000,1),(796,728445600,2),(796,750826800,1),(796,761709600,2),(796,782276400,1),(796,793159200,2),(796,813726000,1),(796,824004000,2),(796,844570800,1),(796,856058400,2),(796,876106800,1),(796,888717600,2),(796,908074800,1),(796,919562400,2),(796,938919600,1),(796,951616800,2),(796,970974000,1),(796,982461600,2),(796,1003028400,1),(796,1013911200,2),(796,1036292400,1),(796,1045360800,2),(796,1066532400,1),(796,1076810400,2),(796,1099364400,1),(796,1108864800,2),(796,1129431600,1);
INSERT INTO `time_zone_transition` VALUES (796,1140314400,2),(796,1162695600,1),(796,1172368800,2),(796,1192330800,1),(796,1203213600,2),(796,1224385200,1),(796,1234663200,2),(796,1255834800,1),(796,1266717600,2),(796,1287284400,1),(796,1298167200,2),(796,1318734000,1),(796,1330221600,2),(796,1350788400,1),(796,1361066400,2),(796,1382238000,1),(796,1392516000,2),(796,1413687600,1),(796,1424570400,2),(796,1445137200,1),(796,1456020000,2),(796,1476586800,1),(796,1487469600,2),(796,1508036400,1),(796,1518919200,2),(796,1541300400,1),(796,1550368800,2),(796,2147483647,2),(797,-2147483648,0),(797,-1686090728,1),(797,323841600,2),(797,338961600,3),(797,354679200,6),(797,370400400,4),(797,386125200,5),(797,401850000,4),(797,417574800,5),(797,433299600,4),(797,449024400,5),(797,465354000,4),(797,481078800,5),(797,496803600,4),(797,512528400,5),(797,528253200,4),(797,543978000,5),(797,559702800,4),(797,575427600,5),(797,591152400,4),(797,606877200,5),(797,622602000,4),(797,638326800,5),(797,654656400,4),(797,670381200,5),(797,686106000,4),(797,701830800,5),(797,717555600,4),(797,733280400,5),(797,749005200,4),(797,764730000,5),(797,780454800,4),(797,796179600,5),(797,811904400,4),(797,828234000,5),(797,846378000,4),(797,859683600,5),(797,877827600,4),(797,891133200,5),(797,909277200,4),(797,922582800,5),(797,941331600,4),(797,954032400,5),(797,972781200,4),(797,985482000,5),(797,1004230800,4),(797,1017536400,5),(797,1035680400,4),(797,1048986000,5),(797,1067130000,4),(797,1080435600,5),(797,1099184400,4),(797,1111885200,5),(797,1130634000,4),(797,1143334800,5),(797,1162083600,4),(797,1174784400,5),(797,1193533200,4),(797,1206838800,5),(797,1224982800,4),(797,1238288400,5),(797,1256432400,4),(797,1269738000,5),(797,1288486800,4),(797,1301187600,5),(797,1319936400,4),(797,1332637200,5),(797,1351386000,4),(797,1364691600,5),(797,1382835600,4),(797,1396141200,5),(797,1414285200,4),(797,1427590800,5),(797,1445734800,4),(797,1459040400,5),(797,1477789200,4),(797,1490490000,5),(797,1509238800,4),(797,1521939600,5),(797,1540688400,4),(797,1553994000,5),(797,1572138000,4),(797,1585443600,5),(797,1603587600,4),(797,1616893200,5),(797,1635642000,4),(797,1648342800,5),(797,1667091600,4),(797,1679792400,5),(797,1698541200,4),(797,1711846800,5),(797,1729990800,4),(797,1743296400,5),(797,1761440400,4),(797,1774746000,5),(797,1792890000,4),(797,1806195600,5),(797,1824944400,4),(797,1837645200,5),(797,1856394000,4),(797,1869094800,5),(797,1887843600,4),(797,1901149200,5),(797,1919293200,4),(797,1932598800,5),(797,1950742800,4),(797,1964048400,5),(797,1982797200,4),(797,1995498000,5),(797,2014246800,4),(797,2026947600,5),(797,2045696400,4),(797,2058397200,5),(797,2077146000,4),(797,2090451600,5),(797,2108595600,4),(797,2121901200,5),(797,2140045200,4),(797,2147483647,4),(798,-2147483648,3),(798,-1633273200,1),(798,-1615132800,2),(798,-1601823600,1),(798,-1583683200,2),(798,-1570374000,1),(798,-1551628800,2),(798,-1538924400,1),(798,-1534089600,2),(798,-880210800,4),(798,-769395600,5),(798,-765388800,2),(798,-147884400,1),(798,-131558400,2),(798,-116434800,1),(798,-100108800,2),(798,-84380400,1),(798,-68659200,2),(798,-52930800,1),(798,-37209600,2),(798,-21481200,1),(798,-5760000,2),(798,9968400,1),(798,25689600,2),(798,41418000,1),(798,57744000,2),(798,73472400,1),(798,89193600,2),(798,104922000,1),(798,120643200,2),(798,126694800,1),(798,152092800,2),(798,162378000,1),(798,183542400,2),(798,199270800,1),(798,215596800,2),(798,230720400,1),(798,247046400,2),(798,262774800,1),(798,278496000,2),(798,294224400,1),(798,309945600,2),(798,325674000,1),(798,341395200,2),(798,357123600,1),(798,372844800,2),(798,388573200,1),(798,404899200,2),(798,420022800,1),(798,436348800,2),(798,452077200,1),(798,467798400,2),(798,483526800,1),(798,499248000,2),(798,514976400,1),(798,530697600,2),(798,544611600,1),(798,562147200,2),(798,576061200,1),(798,594201600,2),(798,607510800,1),(798,625651200,2),(798,638960400,1),(798,657100800,2),(798,671014800,1),(798,688550400,2),(798,702464400,1),(798,720000000,2),(798,733914000,1),(798,752054400,2),(798,765363600,1),(798,783504000,2),(798,796813200,1),(798,814953600,2),(798,828867600,1),(798,846403200,2),(798,860317200,1),(798,877852800,2),(798,891766800,1),(798,909302400,2),(798,923216400,1),(798,941356800,2),(798,954666000,1),(798,972806400,2),(798,986115600,1),(798,1004256000,2),(798,1018170000,1),(798,1035705600,2),(798,1049619600,1),(798,1067155200,2),(798,1081069200,1),(798,1099209600,2),(798,1112518800,1),(798,1130659200,2),(798,1143968400,1),(798,1162108800,2),(798,1173603600,1),(798,1194163200,2),(798,1205053200,1),(798,1225612800,2),(798,1236502800,1),(798,1257062400,2),(798,1268557200,1),(798,1289116800,2),(798,1300006800,1),(798,1320566400,2),(798,1331456400,1),(798,1352016000,2),(798,1362906000,1),(798,1383465600,2),(798,1394355600,1),(798,1414915200,2),(798,1425805200,1),(798,1446364800,2),(798,1457859600,1),(798,1478419200,2),(798,1489309200,1),(798,1509868800,2),(798,1520758800,1),(798,1541318400,2),(798,1552208400,1),(798,1572768000,2),(798,1583658000,1),(798,1604217600,2),(798,1615712400,1),(798,1636272000,2),(798,1647162000,1),(798,1667721600,2),(798,1678611600,1),(798,1699171200,2),(798,1710061200,1),(798,1730620800,2),(798,1741510800,1),(798,1762070400,2),(798,1772960400,1),(798,1793520000,2),(798,1805014800,1),(798,1825574400,2),(798,1836464400,1),(798,1857024000,2),(798,1867914000,1),(798,1888473600,2),(798,1899363600,1),(798,1919923200,2),(798,1930813200,1),(798,1951372800,2),(798,1962867600,1),(798,1983427200,2),(798,1994317200,1),(798,2014876800,2),(798,2025766800,1),(798,2046326400,2),(798,2057216400,1),(798,2077776000,2),(798,2088666000,1),(798,2109225600,2),(798,2120115600,1),(798,2140675200,2),(799,-2147483648,1),(799,-880207200,2),(799,-769395600,3),(799,-765385200,1),(799,-21477600,4),(799,-5756400,1),(799,9972000,4),(799,25693200,1),(799,41421600,4),(799,57747600,1),(799,73476000,4),(799,89197200,1),(799,104925600,4),(799,120646800,1),(799,126698400,4),(799,152096400,1),(799,162381600,4),(799,183546000,1),(799,199274400,4),(799,215600400,1),(799,230724000,4),(799,247050000,1),(799,262778400,4),(799,278499600,1),(799,294228000,4),(799,309949200,1),(799,325677600,4),(799,341398800,1),(799,357127200,4),(799,372848400,1),(799,388576800,4),(799,404902800,1),(799,420026400,4),(799,436352400,5),(799,439030800,7),(799,452084400,6),(799,467805600,7),(799,483534000,6),(799,499255200,7),(799,514983600,6),(799,530704800,7),(799,544618800,6),(799,562154400,7),(799,576068400,6),(799,594208800,7),(799,607518000,6),(799,625658400,7),(799,638967600,6),(799,657108000,7),(799,671022000,6),(799,688557600,7),(799,702471600,6),(799,720007200,7),(799,733921200,6),(799,752061600,7),(799,765370800,6),(799,783511200,7),(799,796820400,6),(799,814960800,7),(799,828874800,6),(799,846410400,7),(799,860324400,6),(799,877860000,7),(799,891774000,6),(799,909309600,7),(799,923223600,6),(799,941364000,7),(799,954673200,6),(799,972813600,7),(799,986122800,6),(799,1004263200,7),(799,1018177200,6),(799,1035712800,7),(799,1049626800,6),(799,1067162400,7),(799,1081076400,6),(799,1099216800,7),(799,1112526000,6),(799,1130666400,7),(799,1143975600,6),(799,1162116000,7),(799,1173610800,6),(799,1194170400,7),(799,1205060400,6),(799,1225620000,7),(799,1236510000,6),(799,1257069600,7),(799,1268564400,6),(799,1289124000,7),(799,1300014000,6),(799,1320573600,7),(799,1331463600,6),(799,1352023200,7),(799,1362913200,6),(799,1383472800,7),(799,1394362800,6),(799,1414922400,7),(799,1425812400,6),(799,1446372000,7),(799,1457866800,6),(799,1478426400,7),(799,1489316400,6),(799,1509876000,7),(799,1520766000,6),(799,1541325600,7),(799,1552215600,6),(799,1572775200,7),(799,1583665200,6),(799,1604224800,7),(799,1615719600,6),(799,1636279200,7),(799,1647169200,6),(799,1667728800,7),(799,1678618800,6),(799,1699178400,7),(799,1710068400,6),(799,1730628000,7),(799,1741518000,6),(799,1762077600,7),(799,1772967600,6),(799,1793527200,7),(799,1805022000,6),(799,1825581600,7),(799,1836471600,6),(799,1857031200,7),(799,1867921200,6),(799,1888480800,7),(799,1899370800,6),(799,1919930400,7),(799,1930820400,6),(799,1951380000,7),(799,1962874800,6),(799,1983434400,7),(799,1994324400,6),(799,2014884000,7),(799,2025774000,6),(799,2046333600,7),(799,2057223600,6),(799,2077783200,7),(799,2088673200,6),(799,2109232800,7),(799,2120122800,6),(799,2140682400,7),(800,-2147483648,1),(800,-873057600,3),(800,-769395600,2),(800,-765399600,1),(801,-2147483648,2),(801,-1664130548,1),(801,-1650137348,2),(801,-1632076148,1),(801,-1615145348,2),(801,-1598650148,1),(801,-1590100148,2),(801,-1567286948,1),(801,-1551565748,2),(801,-1535837348,1),(801,-1520116148,2),(801,-1503782948,1),(801,-1488666548,2),(801,-1472333348,1),(801,-1457216948,2),(801,-1440883748,1),(801,-1425767348,2),(801,-1409434148,1),(801,-1394317748,2),(801,-1377984548,1),(801,-1362263348,2),(801,-1346534948,1),(801,-1330813748,2),(801,-1314480548,1),(801,-1299364148,2),(801,-1283030948,1),(801,-1267914548,2),(801,-1251581348,1),(801,-1236464948,2),(801,-1220131748,1),(801,-1205015348,2),(801,-1188682148,1),(801,-1172960948,2),(801,-1156627748,1),(801,-1141511348,2),(801,-1125178148,1),(801,-1110061748,2),(801,-1096921748,4),(801,-1093728600,3),(801,-1078612200,4),(801,-1061670600,3),(801,-1048973400,4),(801,-1030221000,3),(801,-1017523800,4),(801,-998771400,3),(801,-986074200,4),(801,-966717000,3),(801,-954624600,4),(801,-935267400,3),(801,-922570200,4),(801,-903817800,3),(801,-891120600,4),(801,-872368200,6),(801,-769395600,5),(801,-765401400,4),(801,-746044200,3),(801,-733347000,4),(801,-714594600,3),(801,-701897400,4),(801,-683145000,3),(801,-670447800,4),(801,-651695400,3),(801,-638998200,4),(801,-619641000,3),(801,-606943800,4),(801,-589401000,3),(801,-576099000,4),(801,-557951400,3),(801,-544649400,4),(801,-526501800,3),(801,-513199800,4),(801,-495052200,3),(801,-481750200,4),(801,-463602600,3),(801,-450300600,4),(801,-431548200,3),(801,-418246200,4),(801,-400098600,3),(801,-386796600,4),(801,-368649000,3),(801,-355347000,4),(801,-337199400,3),(801,-323897400,4),(801,-305749800,3),(801,-289423800,4),(801,-273695400,3),(801,-257974200,4),(801,-242245800,3),(801,-226524600,4),(801,-210796200,3),(801,-195075000,4),(801,-179346600,3),(801,-163625400,4),(801,-147897000,3),(801,-131571000,4),(801,-116447400,3),(801,-100121400,4),(801,-84393000,3),(801,-68671800,4),(801,-52943400,3),(801,-37222200,4),(801,-21493800,3),(801,-5772600,4),(801,9955800,3),(801,25677000,4),(801,41405400,3),(801,57731400,4),(801,73459800,3),(801,89181000,4),(801,104909400,3),(801,120630600,4),(801,136359000,3),(801,152080200,4),(801,167808600,3),(801,183529800,4),(801,199258200,3),(801,215584200,4),(801,230707800,3),(801,247033800,4),(801,262762200,3),(801,278483400,4),(801,294211800,3),(801,309933000,4),(801,325661400,3),(801,341382600,4),(801,357111000,3),(801,372832200,4),(801,388560600,3),(801,404886600,4),(801,420010200,3),(801,436336200,4),(801,452064600,3),(801,467785800,4),(801,483514200,3),(801,499235400,4),(801,514963800,3),(801,530685000,4),(801,544591860,3),(801,562127460,4),(801,576041460,7),(801,594178260,4),(801,607491060,3),(801,625631460,4),(801,638940660,3),(801,657081060,4),(801,670995060,3),(801,688530660,4),(801,702444660,3),(801,719980260,4),(801,733894260,3),(801,752034660,4),(801,765343860,3),(801,783484260,4),(801,796793460,3),(801,814933860,4),(801,828847860,3),(801,846383460,4),(801,860297460,3),(801,877833060,4),(801,891747060,3),(801,909282660,4),(801,923196660,3),(801,941337060,4),(801,954646260,3),(801,972786660,4),(801,986095860,3),(801,1004236260,4),(801,1018150260,3),(801,1035685860,4),(801,1049599860,3),(801,1067135460,4),(801,1081049460,3),(801,1099189860,4),(801,1112499060,3),(801,1130639460,4),(801,1143948660,3),(801,1162089060,4),(801,1173583860,3),(801,1194143460,4),(801,1205033460,3),(801,1225593060,4),(801,1236483060,3),(801,1257042660,4),(801,1268537460,3),(801,1289097060,4),(801,1299987060,3),(801,1320553800,4),(801,1331443800,3),(801,1352003400,4),(801,1362893400,3),(801,1383453000,4),(801,1394343000,3),(801,1414902600,4),(801,1425792600,3),(801,1446352200,4),(801,1457847000,3),(801,1478406600,4),(801,1489296600,3),(801,1509856200,4),(801,1520746200,3),(801,1541305800,4),(801,1552195800,3),(801,1572755400,4),(801,1583645400,3),(801,1604205000,4),(801,1615699800,3),(801,1636259400,4),(801,1647149400,3),(801,1667709000,4),(801,1678599000,3),(801,1699158600,4),(801,1710048600,3),(801,1730608200,4),(801,1741498200,3),(801,1762057800,4),(801,1772947800,3),(801,1793507400,4),(801,1805002200,3),(801,1825561800,4),(801,1836451800,3),(801,1857011400,4),(801,1867901400,3),(801,1888461000,4),(801,1899351000,3),(801,1919910600,4),(801,1930800600,3),(801,1951360200,4),(801,1962855000,3),(801,1983414600,4),(801,1994304600,3),(801,2014864200,4),(801,2025754200,3),(801,2046313800,4),(801,2057203800,3),(801,2077763400,4),(801,2088653400,3),(801,2109213000,4),(801,2120103000,3),(801,2140662600,4),(802,-2147483648,1),(802,-873057600,3),(802,-769395600,2),(802,-765399600,1),(803,-2147483648,1),(803,-873057600,3),(803,-769395600,2),(803,-765399600,1),(804,-2147483648,1),(804,-873057600,3),(804,-769395600,2),(804,-765399600,1),(805,-2147483648,1),(805,-873057600,3),(805,-769395600,2),(805,-765399600,1),(806,-2147483648,0),(806,-2030201320,2),(806,-1632063600,1),(806,-1615132800,2),(806,-880210800,3),(806,-769395600,4),(806,-765388800,2),(806,-747241200,1),(806,-732729600,2),(806,-715791600,1),(806,-702489600,2),(806,-684342000,1),(806,-671040000,2),(806,-652892400,1),(806,-639590400,2),(806,-400086000,1),(806,-384364800,2),(806,-337186800,1),(806,-321465600,2),(806,-305737200,1),(806,-292435200,2),(806,-273682800,1),(806,-260985600,2),(806,73472400,5),(807,-2147483648,0),(807,-1538503868,2),(807,547020000,1),(807,559717200,2),(807,578469600,1),(807,591166800,2),(807,1146981600,1),(807,1154926800,2),(808,-2147483648,0),(808,-1686079492,2),(808,670399200,1),(808,686120400,2),(808,701848800,1),(808,717570000,2),(808,733903200,1),(808,752043600,2),(808,765352800,1),(808,783493200,2),(808,796802400,1),(808,814942800,2),(808,828856800,1),(808,846392400,2),(808,860306400,1),(808,877842000,2),(808,891756000,1),(808,909291600,2),(808,923205600,1),(808,941346000,2),(808,954655200,1),(808,972795600,2),(808,986104800,1),(808,1004245200,2),(808,1018159200,1),(808,1035694800,2),(808,1049608800,1),(808,1067144400,2),(808,1081058400,1),(808,1099198800,2),(808,1112508000,1),(808,1130648400,2),(808,1143957600,1),(808,1162098000,2),(808,1173592800,1),(808,1194152400,2),(808,1205042400,1),(808,1225602000,2),(808,1236492000,1),(808,1257051600,2),(808,1268546400,1),(808,1289106000,2),(808,1299996000,1),(808,1320555600,2),(808,1331445600,1),(808,1352005200,2),(808,1362895200,1),(808,1383454800,2),(808,1394344800,1),(808,1414904400,2),(808,1425794400,1),(808,1446354000,2),(808,1457848800,1),(808,1478408400,2),(808,1489298400,1),(808,1509858000,2),(808,1520748000,1),(808,1541307600,2),(808,1552197600,1),(808,1572757200,2),(808,1583647200,1),(808,1604206800,2),(808,1615701600,1),(808,1636261200,2),(808,1647151200,1),(808,1667710800,2),(808,1678600800,1),(808,1699160400,2),(808,1710050400,1),(808,1730610000,2),(808,1741500000,1),(808,1762059600,2),(808,1772949600,1),(808,1793509200,2),(808,1805004000,1),(808,1825563600,2),(808,1836453600,1),(808,1857013200,2),(808,1867903200,1),(808,1888462800,2),(808,1899352800,1),(808,1919912400,2),(808,1930802400,1),(808,1951362000,2),(808,1962856800,1),(808,1983416400,2),(808,1994306400,1),(808,2014866000,2),(808,2025756000,1),(808,2046315600,2),(808,2057205600,1),(808,2077765200,2),(808,2088655200,1),(808,2109214800,2),(808,2120104800,1),(808,2140664400,2),(809,-2147483648,2),(809,-1632070800,1),(809,-1615140000,2),(809,-1601753400,1),(809,-1583697600,2),(809,-1567357200,1),(809,-1554667200,2),(809,-1534698000,1),(809,-1524074400,2),(809,-1503248400,1),(809,-1492365600,2),(809,-1471798800,1),(809,-1460916000,2),(809,-1440954000,1),(809,-1428861600,2),(809,-1409504400,1),(809,-1397412000,2),(809,-1378054800,1),(809,-1365962400,2),(809,-1346605200,1),(809,-1333908000,2),(809,-1315155600,1),(809,-1301853600,2),(809,-1283706000,1),(809,-1270404000,2),(809,-1252256400,1),(809,-1238954400,2),(809,-1220806800,1),(809,-1207504800,2),(809,-1188752400,1),(809,-1176055200,2),(809,-1157302800,1),(809,-1144000800,2),(809,-1125853200,1),(809,-1112551200,2),(809,-1094403600,1),(809,-1081101600,2),(809,-1062954000,1),(809,-1049652000,2),(809,-1031504400,1),(809,-1018202400,2),(809,-1000054800,1),(809,-986752800,2),(809,-968000400,1),(809,-955303200,2),(809,-936550800,1),(809,-880218000,3),(809,-769395600,4),(809,-765396000,2),(809,-747248400,1),(809,-733946400,2),(809,-715806000,1),(809,-702504000,2),(809,-684356400,1),(809,-671054400,2),(809,-652906800,1),(809,-634161600,2),(809,-620845200,1),(809,-602704800,2),(809,-589395600,1),(809,-576093600,2),(809,-557946000,1),(809,-544644000,2),(809,-526496400,1),(809,-513194400,2),(809,-495046800,1),(809,-481744800,2),(809,-463597200,1),(809,-450295200,2),(809,-431542800,1),(809,-418240800,2),(809,-400093200,1),(809,-384372000,2),(809,-368643600,1),(809,-352922400,2),(809,-337194000,1),(809,-321472800,2),(809,-305744400,1),(809,-289418400,2),(809,-273690000,1),(809,-257968800,2),(809,-242240400,1),(809,-226519200,2),(809,-210790800,1),(809,-195069600,2),(809,-179341200,1),(809,-163620000,2),(809,-147891600,1),(809,-131565600,2),(809,-116442000,1),(809,-100116000,2),(809,-84387600,1),(809,-68666400,2),(809,-52938000,1),(809,-37216800,2),(809,-21488400,1),(809,-5767200,2),(809,9961200,1),(809,25682400,2),(809,41410800,1),(809,57736800,2),(809,73465200,1),(809,89186400,2),(809,104914800,1),(809,120636000,2),(809,136364400,1),(809,152085600,2),(809,167814000,1),(809,183535200,2),(809,199263600,1),(809,215589600,2),(809,230713200,1),(809,247039200,2),(809,262767600,1),(809,278488800,2),(809,294217200,1),(809,309938400,2),(809,325666800,1),(809,341388000,2),(809,357116400,1),(809,372837600,2),(809,388566000,1),(809,404892000,2),(809,420015600,1),(809,436341600,2),(809,452070000,1),(809,467791200,2),(809,483519600,1),(809,499240800,2),(809,514969200,1),(809,530690400,2),(809,544604400,1),(809,562140000,2),(809,576054000,1),(809,594194400,2),(809,607503600,1),(809,625644000,2),(809,638953200,1),(809,657093600,2),(809,671007600,1),(809,688543200,2),(809,702457200,1),(809,719992800,2),(809,733906800,1),(809,752047200,2),(809,765356400,1),(809,783496800,2),(809,796806000,1),(809,814946400,2),(809,828860400,1),(809,846396000,2),(809,860310000,1),(809,877845600,2),(809,891759600,1),(809,909295200,2),(809,923209200,1),(809,941349600,2),(809,954658800,1),(809,972799200,2),(809,986108400,1),(809,1004248800,2),(809,1018162800,1),(809,1035698400,2),(809,1049612400,1),(809,1067148000,2),(809,1081062000,1),(809,1099202400,2),(809,1112511600,1),(809,1130652000,2),(809,1143961200,1),(809,1162101600,2),(809,1173596400,1),(809,1194156000,2),(809,1205046000,1),(809,1225605600,2),(809,1236495600,1),(809,1257055200,2),(809,1268550000,1),(809,1289109600,2),(809,1299999600,1),(809,1320559200,2),(809,1331449200,1),(809,1352008800,2),(809,1362898800,1),(809,1383458400,2),(809,1394348400,1),(809,1414908000,2),(809,1425798000,1),(809,1446357600,2),(809,1457852400,1),(809,1478412000,2),(809,1489302000,1),(809,1509861600,2),(809,1520751600,1),(809,1541311200,2),(809,1552201200,1),(809,1572760800,2),(809,1583650800,1),(809,1604210400,2),(809,1615705200,1),(809,1636264800,2),(809,1647154800,1),(809,1667714400,2),(809,1678604400,1),(809,1699164000,2),(809,1710054000,1),(809,1730613600,2),(809,1741503600,1),(809,1762063200,2),(809,1772953200,1),(809,1793512800,2),(809,1805007600,1),(809,1825567200,2),(809,1836457200,1),(809,1857016800,2),(809,1867906800,1),(809,1888466400,2),(809,1899356400,1),(809,1919916000,2),(809,1930806000,1),(809,1951365600,2),(809,1962860400,1),(809,1983420000,2),(809,1994310000,1),(809,2014869600,2),(809,2025759600,1),(809,2046319200,2),(809,2057209200,1),(809,2077768800,2),(809,2088658800,1),(809,2109218400,2),(809,2120108400,1),(809,2140668000,2),(810,-2147483648,0),(810,-1514739600,1),(810,-1451667600,2),(810,-1343062800,3),(810,-1234803600,2),(810,-1222963200,4),(810,-1207242000,2),(810,-873820800,5),(810,-769395600,6),(810,-761677200,2),(810,-686073600,4),(810,-661539600,2),(810,-495039600,4),(810,-481734000,2),(810,-463590000,4),(810,-450284400,2),(810,-431535600,4),(810,-418230000,2),(810,-400086000,4),(810,-386780400,2),(810,-368636400,4),(810,-355330800,2),(810,-337186800,4),(810,-323881200,2),(810,-305737200,4),(810,-292431600,2),(810,199274400,4),(810,215600400,2),(810,230724000,4),(810,247050000,2),(810,262778400,4),(810,278499600,2),(810,294228000,4),(810,309949200,2),(810,325677600,4),(810,341398800,2),(810,357127200,4),(810,372848400,2),(810,388576800,4),(810,404902800,2),(810,420026400,4),(810,436352400,2),(810,452080800,4),(810,467802000,2),(810,483530400,4),(810,499251600,2),(810,514980000,4),(810,530701200,2),(810,544615200,4),(810,562150800,2),(810,576064800,4),(810,594205200,2),(810,607514400,4),(810,625654800,2),(810,638964000,4),(810,657104400,2),(810,671018400,4),(810,688554000,2),(810,702468000,4),(810,720003600,2),(810,733917600,4),(810,752058000,2),(810,765367200,4),(810,783507600,2),(810,796816800,4),(810,814957200,2),(810,828871200,4),(810,846406800,2),(810,860320800,4),(810,877856400,2),(810,891770400,4),(810,909306000,2),(810,923220000,4),(810,941360400,2),(810,954669600,4),(810,972810000,2),(810,986119200,4),(810,1004259600,2),(810,1018173600,4),(810,1035709200,2),(810,1049623200,4),(810,1067158800,2),(810,1081072800,4),(810,1099213200,2),(810,1112522400,4),(810,1130662800,2),(810,1143972000,4),(810,1162112400,2),(810,1175421600,4),(810,1193562000,2),(810,1207476000,4),(810,1225011600,2),(810,1238925600,4),(810,1256461200,2),(810,1268560800,4),(810,1289120400,2),(810,1300010400,4),(810,1320570000,2),(810,1331460000,4),(810,1352019600,2),(810,1362909600,4),(810,1383469200,2),(810,1394359200,4),(810,1414918800,2),(810,1425808800,4),(810,1446368400,2),(810,1457863200,4),(810,1478422800,2),(810,1489312800,4),(810,1509872400,2),(810,1520762400,4),(810,1541322000,2),(810,1552212000,4),(810,1572771600,2),(810,1583661600,4),(810,1604221200,2),(810,1615716000,4),(810,1636275600,2),(810,1647165600,4),(810,1667725200,2),(810,1678615200,4),(810,1699174800,2),(810,1710064800,4),(810,1730624400,2),(810,1741514400,4),(810,1762074000,2),(810,1772964000,4),(810,1793523600,2),(810,1805018400,4),(810,1825578000,2),(810,1836468000,4),(810,1857027600,2),(810,1867917600,4),(810,1888477200,2),(810,1899367200,4),(810,1919926800,2),(810,1930816800,4),(810,1951376400,2),(810,1962871200,4),(810,1983430800,2),(810,1994320800,4),(810,2014880400,2),(810,2025770400,4),(810,2046330000,2),(810,2057220000,4),(810,2077779600,2),(810,2088669600,4),(810,2109229200,2),(810,2120119200,4),(810,2140678800,2),(811,-2147483648,2),(811,-1632070800,1),(811,-1615140000,2),(811,-1601753400,1),(811,-1583697600,2),(811,-1567357200,1),(811,-1554667200,2),(811,-1534698000,1),(811,-1524074400,2),(811,-1503248400,1),(811,-1492365600,2),(811,-1471798800,1),(811,-1460916000,2),(811,-1440954000,1),(811,-1428861600,2),(811,-1409504400,1),(811,-1397412000,2),(811,-1378054800,1),(811,-1365962400,2),(811,-1346605200,1),(811,-1333908000,2),(811,-1315155600,1),(811,-1301853600,2),(811,-1283706000,1),(811,-1270404000,2),(811,-1252256400,1),(811,-1238954400,2),(811,-1220806800,1),(811,-1207504800,2),(811,-1188752400,1),(811,-1176055200,2),(811,-1157302800,1),(811,-1144000800,2),(811,-1125853200,1),(811,-1112551200,2),(811,-1094403600,1),(811,-1081101600,2),(811,-1062954000,1),(811,-1049652000,2),(811,-1031504400,1),(811,-1018202400,2),(811,-1000054800,1),(811,-986752800,2),(811,-968000400,1),(811,-955303200,2),(811,-936550800,1),(811,-880218000,3),(811,-769395600,4),(811,-765396000,2),(811,-747248400,1),(811,-733946400,2),(811,-715806000,1),(811,-702504000,2),(811,-684356400,1),(811,-671054400,2),(811,-652906800,1),(811,-634161600,2),(811,-620845200,1),(811,-602704800,2),(811,-589395600,1),(811,-576093600,2),(811,-557946000,1),(811,-544644000,2),(811,-526496400,1),(811,-513194400,2),(811,-495046800,1),(811,-481744800,2),(811,-463597200,1),(811,-450295200,2),(811,-431542800,1),(811,-418240800,2),(811,-400093200,1),(811,-384372000,2),(811,-368643600,1),(811,-352922400,2),(811,-337194000,1),(811,-321472800,2),(811,-305744400,1),(811,-289418400,2),(811,-273690000,1),(811,-257968800,2),(811,-242240400,1),(811,-226519200,2),(811,-210790800,1),(811,-195069600,2),(811,-179341200,1),(811,-163620000,2),(811,-147891600,1),(811,-131565600,2),(811,-116442000,1),(811,-100116000,2),(811,-84387600,1),(811,-68666400,2),(811,-52938000,1),(811,-37216800,2),(811,-21488400,1),(811,-5767200,2),(811,9961200,1),(811,25682400,2),(811,41410800,1),(811,57736800,2),(811,73465200,1),(811,89186400,2),(811,104914800,1),(811,120636000,2),(811,136364400,1),(811,152085600,2),(811,167814000,1),(811,183535200,2),(811,199263600,1),(811,215589600,2),(811,230713200,1),(811,247039200,2),(811,262767600,1),(811,278488800,2),(811,294217200,1),(811,309938400,2),(811,325666800,1),(811,341388000,2),(811,357116400,1),(811,372837600,2),(811,388566000,1),(811,404892000,2),(811,420015600,1),(811,436341600,2),(811,452070000,1),(811,467791200,2),(811,483519600,1),(811,499240800,2),(811,514969200,1),(811,530690400,2),(811,544604400,1),(811,562140000,2),(811,576054000,1),(811,594194400,2),(811,607503600,1),(811,625644000,2),(811,638953200,1),(811,657093600,2),(811,671007600,1),(811,688543200,2),(811,702457200,1),(811,719992800,2),(811,733906800,1),(811,752047200,2),(811,765356400,1),(811,783496800,2),(811,796806000,1),(811,814946400,2),(811,828860400,1),(811,846396000,2),(811,860310000,1),(811,877845600,2),(811,891759600,1),(811,909295200,2),(811,923209200,1),(811,941349600,2),(811,954658800,1),(811,972799200,2),(811,986108400,1),(811,1004248800,2),(811,1018162800,1),(811,1035698400,2),(811,1049612400,1),(811,1067148000,2),(811,1081062000,1),(811,1099202400,2),(811,1112511600,1),(811,1130652000,2),(811,1143961200,1),(811,1162101600,2),(811,1173596400,1),(811,1194156000,2),(811,1205046000,1),(811,1225605600,2),(811,1236495600,1),(811,1257055200,2),(811,1268550000,1),(811,1289109600,2),(811,1299999600,1),(811,1320559200,2),(811,1331449200,1),(811,1352008800,2),(811,1362898800,1),(811,1383458400,2),(811,1394348400,1),(811,1414908000,2),(811,1425798000,1),(811,1446357600,2),(811,1457852400,1),(811,1478412000,2),(811,1489302000,1),(811,1509861600,2),(811,1520751600,1),(811,1541311200,2),(811,1552201200,1),(811,1572760800,2),(811,1583650800,1),(811,1604210400,2),(811,1615705200,1),(811,1636264800,2),(811,1647154800,1),(811,1667714400,2),(811,1678604400,1),(811,1699164000,2),(811,1710054000,1),(811,1730613600,2),(811,1741503600,1),(811,1762063200,2),(811,1772953200,1),(811,1793512800,2),(811,1805007600,1),(811,1825567200,2),(811,1836457200,1),(811,1857016800,2),(811,1867906800,1),(811,1888466400,2),(811,1899356400,1),(811,1919916000,2),(811,1930806000,1),(811,1951365600,2),(811,1962860400,1),(811,1983420000,2),(811,1994310000,1),(811,2014869600,2),(811,2025759600,1),(811,2046319200,2),(811,2057209200,1),(811,2077768800,2),(811,2088658800,1),(811,2109218400,2),(811,2120108400,1),(811,2140668000,2),(812,-2147483648,1),(812,-873057600,3),(812,-769395600,2),(812,-765399600,1),(813,-2147483648,2),(813,-1632060000,1),(813,-1615129200,2),(813,-880207200,3),(813,-769395600,4),(813,-765385200,2),(813,-747237600,1),(813,-733935600,2),(813,-715788000,1),(813,-702486000,2),(813,-684338400,1),(813,-671036400,2),(813,-652888800,1),(813,-639586800,2),(813,-620834400,1),(813,-608137200,2),(813,-589384800,1),(813,-576082800,2),(813,-557935200,1),(813,-544633200,2),(813,-526485600,1),(813,-513183600,2),(813,-495036000,1),(813,-481734000,2),(813,-463586400,1),(813,-450284400,2),(813,-431532000,1),(813,-418230000,2),(813,-400082400,1),(813,-386780400,2),(813,-368632800,1),(813,-355330800,2),(813,-337183200,1),(813,-323881200,2),(813,-305733600,1),(813,-292431600,2),(813,-273679200,1),(813,-260982000,2),(813,-242229600,1),(813,-226508400,2),(813,-210780000,1),(813,-195058800,2),(813,-179330400,1),(813,-163609200,2),(813,-147880800,1),(813,-131554800,2),(813,-116431200,1),(813,-100105200,2),(813,-84376800,1),(813,-68655600,2),(813,-52927200,1),(813,-37206000,2),(813,-21477600,1),(813,-5756400,2),(813,9972000,1),(813,25693200,2),(813,41421600,1),(813,57747600,2),(813,73476000,1),(813,89197200,2),(813,104925600,1),(813,120646800,2),(813,136375200,1),(813,152096400,2),(813,167824800,1),(813,183546000,2),(813,199274400,1),(813,215600400,2),(813,230724000,1),(813,247050000,2),(813,262778400,1),(813,278499600,2),(813,294228000,1),(813,309949200,2),(813,325677600,1),(813,341398800,2),(813,357127200,1),(813,372848400,2),(813,388576800,1),(813,404902800,2),(813,420026400,1),(813,436352400,2),(813,452080800,1),(813,467802000,2),(813,483530400,1),(813,499251600,2),(813,514980000,1),(813,530701200,2),(813,544615200,1),(813,562150800,2),(813,576064800,1),(813,594205200,2),(813,607514400,1),(813,625654800,2),(813,638964000,1),(813,657104400,2),(813,671018400,1),(813,688554000,2),(813,702468000,1),(813,720003600,2),(813,733917600,1),(813,752058000,2),(813,765367200,1),(813,783507600,2),(813,796816800,1),(813,814957200,2),(813,828871200,1),(813,846406800,2),(813,860320800,1),(813,877856400,2),(813,891770400,1),(813,909306000,2),(813,923220000,1),(813,941360400,2),(813,954669600,1),(813,972810000,2),(813,986119200,1),(813,1004259600,2),(813,1018173600,1),(813,1035709200,2),(813,1049623200,1),(813,1067158800,2),(813,1081072800,1),(813,1099213200,2),(813,1112522400,1),(813,1130662800,2),(813,1143972000,1),(813,1162112400,2),(813,1173607200,1),(813,1194166800,2),(813,1205056800,1),(813,1225616400,2),(813,1236506400,1),(813,1257066000,2),(813,1268560800,1),(813,1289120400,2),(813,1300010400,1),(813,1320570000,2),(813,1331460000,1),(813,1352019600,2),(813,1362909600,1),(813,1383469200,2),(813,1394359200,1),(813,1414918800,2),(813,1425808800,1),(813,1446368400,2),(813,1457863200,1),(813,1478422800,2),(813,1489312800,1),(813,1509872400,2),(813,1520762400,1),(813,1541322000,2),(813,1552212000,1),(813,1572771600,2),(813,1583661600,1),(813,1604221200,2),(813,1615716000,1),(813,1636275600,2),(813,1647165600,1),(813,1667725200,2),(813,1678615200,1),(813,1699174800,2),(813,1710064800,1),(813,1730624400,2),(813,1741514400,1),(813,1762074000,2),(813,1772964000,1),(813,1793523600,2),(813,1805018400,1),(813,1825578000,2),(813,1836468000,1),(813,1857027600,2),(813,1867917600,1),(813,1888477200,2),(813,1899367200,1),(813,1919926800,2),(813,1930816800,1),(813,1951376400,2),(813,1962871200,1),(813,1983430800,2),(813,1994320800,1),(813,2014880400,2),(813,2025770400,1),(813,2046330000,2),(813,2057220000,1),(813,2077779600,2),(813,2088669600,1),(813,2109229200,2),(813,2120119200,1),(813,2140678800,2),(814,-2147483648,1),(814,-873057600,3),(814,-769395600,2),(814,-765399600,1),(815,-2147483648,2),(815,-1632056400,1),(815,-1615125600,2),(815,-1596978000,1),(815,-1583164800,2),(815,-880203600,3),(815,-769395600,4),(815,-765381600,2),(815,-147884400,5),(815,-131554800,2),(815,-121273200,6),(815,325677600,7),(815,341398800,6),(815,357127200,7),(815,372848400,6),(815,388576800,7),(815,404902800,6),(815,420026400,7),(815,436352400,6),(815,452080800,7),(815,467802000,6),(815,483530400,7),(815,499251600,6),(815,514980000,7),(815,530701200,6),(815,544615200,7),(815,562150800,6),(815,576064800,7),(815,594205200,6),(815,607514400,7),(815,625654800,6),(815,638964000,7),(815,657104400,6),(815,671018400,7),(815,688554000,6),(815,702468000,7),(815,720003600,6),(815,733917600,7),(815,752058000,6),(815,765367200,7),(815,783507600,6),(815,796816800,7),(815,814957200,6),(815,828871200,7),(815,846406800,6),(815,860320800,7),(815,877856400,6),(815,891770400,7),(815,909306000,6),(815,923220000,7),(815,941360400,6),(815,954669600,7),(815,972810000,6),(815,986119200,7),(815,1004259600,6),(815,1018173600,7),(815,1035709200,6),(815,1049623200,7),(815,1067158800,6),(815,1081072800,7),(815,1099213200,6),(815,1112522400,7),(815,1130662800,6),(815,1143972000,7),(815,1162112400,6),(815,1173607200,7),(815,1194166800,6),(815,1205056800,7),(815,1225616400,6),(815,1236506400,7),(815,1257066000,6),(815,1268560800,7),(815,1289120400,6),(815,1300010400,7),(815,1320570000,6),(815,1331460000,7),(815,1352019600,6),(815,1362909600,7),(815,1383469200,6),(815,1394359200,7),(815,1414918800,6),(815,1425808800,7),(815,1446368400,6),(815,1457863200,7),(815,1478422800,6),(815,1489312800,7),(815,1509872400,6),(815,1520762400,7),(815,1541322000,6),(815,1552212000,7),(815,1572771600,6),(815,1583661600,7),(815,1604214000,8),(816,-2147483648,2),(816,-1694368800,1),(816,-1681671600,2),(816,-1632067200,1),(816,-1615136400,2),(816,-1029686400,1),(816,-1018198800,2),(816,-880214400,3),(816,-769395600,4),(816,-765392400,2),(816,-746035200,1),(816,-732733200,2),(816,-715795200,1),(816,-702493200,2),(816,-684345600,1),(816,-671043600,2),(816,-652896000,1),(816,-639594000,2),(816,-620755200,1),(816,-607626000,2),(816,-589392000,1),(816,-576090000,2),(816,-557942400,1),(816,-544640400,2),(816,-526492800,1),(816,-513190800,2),(816,-495043200,1),(816,-481741200,2),(816,-463593600,1),(816,-450291600,2),(816,-431539200,1),(816,-418237200,2),(816,-400089600,1),(816,-386787600,2),(816,-368640000,1),(816,-355338000,2),(816,-337190400,1),(816,-321469200,2),(816,-305740800,1),(816,-292438800,2),(816,-210787200,1),(816,-198090000,2),(816,-116438400,5),(816,-100108800,6),(816,-84384000,5),(816,-68659200,6),(816,-52934400,5),(816,-37209600,6),(816,-21484800,5),(816,-5760000,6),(816,9964800,5),(816,25689600,6),(816,41414400,5),(816,57744000,6),(816,73468800,5),(816,89193600,6),(816,104918400,5),(816,120643200,6),(816,136368000,5),(816,152092800,6),(816,167817600,5),(816,183542400,6),(816,199267200,5),(816,215596800,6),(816,230716800,5),(816,247046400,6),(816,262771200,5),(816,278496000,6),(816,294220800,5),(816,309945600,6),(816,325670400,5),(816,341395200,6),(816,357120000,5),(816,372844800,6),(816,388569600,5),(816,404899200,6),(816,420019200,5),(816,436348800,6),(816,452073600,5),(816,467798400,6),(816,483523200,5),(816,499248000,6),(816,514972800,5),(816,530697600,6),(816,544608000,5),(816,562147200,6),(816,576057600,5),(816,594201600,6),(816,607507200,5),(816,625651200,6),(816,638956800,5),(816,657100800,6),(816,671011200,5),(816,688550400,6),(816,702460800,5),(816,720000000,6),(816,733910400,5),(816,752054400,6),(816,765360000,5),(816,783504000,6),(816,796809600,5),(816,814953600,6),(816,828864000,5),(816,846403200,6),(816,860313600,5),(816,877852800,6),(816,891763200,5),(816,909302400,6),(816,923212800,5),(816,941356800,6),(816,954662400,5),(816,972806400,6),(816,986112000,5),(816,1004256000,6),(816,1018166400,5),(816,1035705600,6),(816,1049616000,5),(816,1067155200,6),(816,1081065600,5),(816,1099209600,6),(816,1112515200,5),(816,1130659200,6),(816,1136095200,2),(816,1143964800,1),(816,1162105200,2),(816,1173600000,1),(816,1194159600,2),(816,1205049600,1),(816,1225609200,2),(816,1236499200,1),(816,1257058800,2),(816,1268553600,1),(816,1289113200,2),(816,1300003200,1),(816,1320562800,2),(816,1331452800,1),(816,1352012400,2),(816,1362902400,1),(816,1383462000,2),(816,1394352000,1),(816,1414911600,2),(816,1425801600,1),(816,1446361200,2),(816,1457856000,1),(816,1478415600,2),(816,1489305600,1),(816,1509865200,2),(816,1520755200,1),(816,1541314800,2),(816,1552204800,1),(816,1572764400,2),(816,1583654400,1),(816,1604214000,2),(816,1615708800,1),(816,1636268400,2),(816,1647158400,1),(816,1667718000,2),(816,1678608000,1),(816,1699167600,2),(816,1710057600,1),(816,1730617200,2),(816,1741507200,1),(816,1762066800,2),(816,1772956800,1),(816,1793516400,2),(816,1805011200,1),(816,1825570800,2),(816,1836460800,1),(816,1857020400,2),(816,1867910400,1),(816,1888470000,2),(816,1899360000,1),(816,1919919600,2),(816,1930809600,1),(816,1951369200,2),(816,1962864000,1),(816,1983423600,2),(816,1994313600,1),(816,2014873200,2),(816,2025763200,1),(816,2046322800,2),(816,2057212800,1),(816,2077772400,2),(816,2088662400,1),(816,2109222000,2),(816,2120112000,1),(816,2140671600,2),(817,-2147483648,1),(817,-880203600,2),(817,-769395600,3),(817,-765381600,1),(817,-21474000,4),(817,-5752800,1),(817,9975600,4),(817,25696800,1),(817,41425200,4),(817,57751200,1),(817,73479600,4),(817,89200800,1),(817,104929200,4),(817,120650400,1),(817,126702000,4),(817,152100000,1),(817,162385200,4),(817,183549600,1),(817,199278000,4),(817,215604000,1),(817,230727600,4),(817,247053600,1),(817,262782000,4),(817,278503200,1),(817,294231600,4),(817,309952800,1),(817,325681200,4),(817,341402400,1),(817,357130800,4),(817,372852000,1),(817,388580400,4),(817,404906400,1),(817,420030000,4),(817,436356000,1),(817,439030800,6),(817,452084400,5),(817,467805600,6),(817,483534000,5),(817,499255200,6),(817,514983600,5),(817,530704800,6),(817,544618800,5),(817,562154400,6),(817,576068400,5),(817,594208800,6),(817,607518000,5),(817,625658400,6),(817,638967600,5),(817,657108000,6),(817,671022000,5),(817,688557600,6),(817,702471600,5),(817,720007200,6),(817,733921200,5),(817,752061600,6),(817,765370800,5),(817,783511200,6),(817,796820400,5),(817,814960800,6),(817,828874800,5),(817,846410400,6),(817,860324400,5),(817,877860000,6),(817,891774000,5),(817,909309600,6),(817,923223600,5),(817,941364000,6),(817,954673200,5),(817,972813600,6),(817,986122800,5),(817,1004263200,6),(817,1018177200,5),(817,1035712800,6),(817,1049626800,5),(817,1067162400,6),(817,1081076400,5),(817,1099216800,6),(817,1112526000,5),(817,1130666400,6),(817,1143975600,5),(817,1162116000,6),(817,1173610800,5),(817,1194170400,6),(817,1205060400,5),(817,1225620000,6),(817,1236510000,5),(817,1257069600,6),(817,1268564400,5),(817,1289124000,6),(817,1300014000,5),(817,1320573600,6),(817,1331463600,5),(817,1352023200,6),(817,1362913200,5),(817,1383472800,6),(817,1394362800,5),(817,1414922400,6),(817,1425812400,5),(817,1446372000,6),(817,1457866800,5),(817,1478426400,6),(817,1489316400,5),(817,1509876000,6),(817,1520766000,5),(817,1541325600,6),(817,1552215600,5),(817,1572775200,6),(817,1583665200,5),(817,1604224800,6),(817,1615719600,5),(817,1636279200,6),(817,1647169200,5),(817,1667728800,6),(817,1678618800,5),(817,1699178400,6),(817,1710068400,5),(817,1730628000,6),(817,1741518000,5),(817,1762077600,6),(817,1772967600,5),(817,1793527200,6),(817,1805022000,5),(817,1825581600,6),(817,1836471600,5),(817,1857031200,6),(817,1867921200,5),(817,1888480800,6),(817,1899370800,5),(817,1919930400,6),(817,1930820400,5),(817,1951380000,6),(817,1962874800,5),(817,1983434400,6),(817,1994324400,5),(817,2014884000,6),(817,2025774000,5),(817,2046333600,6),(817,2057223600,5),(817,2077783200,6),(817,2088673200,5),(817,2109232800,6),(817,2120122800,5),(817,2140682400,6),(818,-2147483648,0),(818,-1998663968,2),(818,-1632063600,1),(818,-1615132800,2),(818,-1600614000,1),(818,-1596816000,2),(818,-1567954800,1),(818,-1551628800,2),(818,-1536505200,1),(818,-1523203200,2),(818,-1504450800,1),(818,-1491753600,2),(818,-1473001200,1),(818,-1459699200,2),(818,-880210800,3),(818,-769395600,4),(818,-765388800,2),(818,-715791600,1),(818,-702489600,2),(818,73472400,1),(818,89193600,2),(818,104922000,1),(818,120643200,2),(818,136371600,1),(818,152092800,2),(818,167821200,1),(818,183542400,2),(818,199270800,1),(818,215596800,2),(818,230720400,1),(818,247046400,2),(818,262774800,1),(818,278496000,2),(818,294224400,1),(818,309945600,2),(818,325674000,1),(818,341395200,2),(818,357123600,1),(818,372844800,2),(818,388573200,1),(818,404899200,2),(818,420022800,1),(818,436348800,2),(818,452077200,1),(818,467798400,2),(818,483526800,1),(818,499248000,2),(818,514976400,1),(818,530697600,2),(818,544611600,1),(818,562147200,2),(818,576061200,1),(818,594201600,2),(818,607510800,1),(818,625651200,2),(818,638960400,1),(818,657100800,2),(818,671014800,1),(818,688550400,2),(818,702464400,1),(818,720000000,2),(818,733914000,1),(818,752054400,2),(818,765363600,1),(818,783504000,2),(818,796813200,1),(818,814953600,2),(818,828867600,1),(818,846403200,2),(818,860317200,1),(818,877852800,2),(818,891766800,1),(818,909302400,2),(818,923216400,1),(818,941356800,2),(818,954666000,1),(818,972806400,2),(818,986115600,1),(818,1004256000,2),(818,1018170000,1),(818,1035705600,2),(818,1049619600,1),(818,1067155200,2),(818,1081069200,1),(818,1099209600,2),(818,1112518800,1),(818,1130659200,2),(818,1143968400,1),(818,1162108800,2),(818,1173603600,1),(818,1194163200,2),(818,1205053200,1),(818,1225612800,2),(818,1236502800,1),(818,1257062400,2),(818,1268557200,1),(818,1289116800,2),(818,1300006800,1),(818,1320566400,2),(818,1331456400,1),(818,1352016000,2),(818,1362906000,1),(818,1383465600,2),(818,1394355600,1),(818,1414915200,2),(818,1425805200,1),(818,1446364800,2),(818,1457859600,1),(818,1478419200,2),(818,1489309200,1),(818,1509868800,2),(818,1520758800,1),(818,1541318400,2),(818,1552208400,1),(818,1572768000,2),(818,1583658000,1),(818,1604217600,2),(818,1615712400,1),(818,1636272000,2),(818,1647162000,1),(818,1667721600,2),(818,1678611600,1),(818,1699171200,2),(818,1710061200,1),(818,1730620800,2),(818,1741510800,1),(818,1762070400,2),(818,1772960400,1),(818,1793520000,2),(818,1805014800,1),(818,1825574400,2),(818,1836464400,1),(818,1857024000,2),(818,1867914000,1),(818,1888473600,2),(818,1899363600,1),(818,1919923200,2),(818,1930813200,1),(818,1951372800,2),(818,1962867600,1),(818,1983427200,2),(818,1994317200,1),(818,2014876800,2),(818,2025766800,1),(818,2046326400,2),(818,2057216400,1),(818,2077776000,2),(818,2088666000,1),(818,2109225600,2),(818,2120115600,1),(818,2140675200,2),(819,-2147483648,0),(819,-31536000,1),(819,1255802400,2),(819,1267714800,1),(819,1319738400,2),(819,1329843600,3),(819,1477065600,2),(819,1520701200,1),(819,1538856000,2),(819,1552752000,1),(819,1570129200,2),(819,1583596800,1),(819,1601740860,2),(819,2147483647,2),(820,-2147483648,0),(820,-409190400,1),(820,-163062000,0),(820,-28857600,1),(820,1255806000,2),(820,1268251200,3),(820,1319742000,2),(820,1329854400,3),(820,2147483647,3),(821,-2147483648,1),(821,2147483647,1),(822,-2147483648,1),(822,-1680508800,2),(822,-1665388800,3),(822,-1601719200,4),(822,-687052800,1),(822,-71136000,5),(822,-55411200,3),(822,-37267200,5),(822,-25776000,3),(822,-5817600,5),(822,5673600,3),(822,25632000,5),(822,37728000,3),(822,57686400,5),(822,67968000,3),(822,89136000,5),(822,100022400,3),(822,120585600,5),(822,131472000,3),(822,152035200,5),(822,162921600,3),(822,183484800,5),(822,194976000,3),(822,215539200,5),(822,226425600,3),(822,246988800,5),(822,257875200,3),(822,278438400,5),(822,289324800,3),(822,309888000,5),(822,320774400,3),(822,341337600,5),(822,352224000,3),(822,372787200,5),(822,386092800,3),(822,404841600,5),(822,417542400,3),(822,436291200,5),(822,447177600,3),(822,467740800,5),(822,478627200,3),(822,499190400,5),(822,510076800,3),(822,530035200,5),(822,542736000,3),(822,562089600,5),(822,574790400,3),(822,594144000,5),(822,606240000,3),(822,625593600,5),(822,637689600,3),(822,657043200,5),(822,670348800,3),(822,686678400,5),(822,701798400,3),(822,718128000,5),(822,733248000,3),(822,749577600,5),(822,764697600,3),(822,781027200,5),(822,796147200,3),(822,812476800,5),(822,828201600,3),(822,844531200,5),(822,859651200,3),(822,875980800,5),(822,891100800,3),(822,907430400,5),(822,922550400,3),(822,938880000,5),(822,954000000,3),(822,967305600,5),(822,985449600,3),(822,1002384000,5),(822,1017504000,3),(822,1033833600,5),(822,1048953600,3),(822,1065283200,5),(822,1080403200,3),(822,1096732800,5),(822,1111852800,3),(822,1128182400,5),(822,1143907200,3),(822,1159632000,5),(822,1174752000,3),(822,1191686400,5),(822,1207411200,3),(822,1223136000,5),(822,1238860800,3),(822,1254585600,5),(822,1262264400,2),(822,1301760000,3),(822,1317484800,5),(822,1333209600,3),(822,1349539200,5),(822,1365264000,3),(822,1380988800,5),(822,1396713600,3),(822,1412438400,5),(822,1428163200,3),(822,1443888000,5),(822,1459612800,3),(822,1475337600,5),(822,1491062400,3),(822,1506787200,5),(822,1522512000,3),(822,1538841600,5),(822,1554566400,3),(822,1570291200,5),(822,1586016000,3),(822,1601740800,5),(822,1617465600,3),(822,1633190400,5),(822,1648915200,3),(822,1664640000,5),(822,1680364800,3),(822,1696089600,5),(822,1712419200,3),(822,1728144000,5),(822,1743868800,3),(822,1759593600,5),(822,1775318400,3),(822,1791043200,5),(822,1806768000,3),(822,1822492800,5),(822,1838217600,3),(822,1853942400,5),(822,1869667200,3),(822,1885996800,5),(822,1901721600,3),(822,1917446400,5),(822,1933171200,3),(822,1948896000,5),(822,1964620800,3),(822,1980345600,5),(822,1996070400,3),(822,2011795200,5),(822,2027520000,3),(822,2043244800,5),(822,2058969600,3),(822,2075299200,5),(822,2091024000,3),(822,2106748800,5),(822,2122473600,3),(822,2138198400,5),(823,-2147483648,0),(823,-501206400,1),(823,1255809600,2),(823,2147483647,2),(824,-2147483648,2),(824,-1330335000,1),(824,-1320057000,2),(824,-1300699800,3),(824,-1287396000,2),(824,-1269250200,3),(824,-1255946400,2),(824,-1237800600,3),(824,-1224496800,2),(824,-1206351000,3),(824,-1192442400,2),(824,-1174901400,3),(824,-1160992800,2),(824,-1143451800,3),(824,-1125914400,2),(824,-1112607000,3),(824,-1094464800,2),(824,-1081157400,3),(824,-1063015200,2),(824,-1049707800,3),(824,-1031565600,2),(824,-1018258200,3),(824,-1000116000,2),(824,-986808600,3),(824,-968061600,2),(824,-955359000,3),(824,-936612000,2),(824,-923304600,3),(824,-757425600,6),(824,152632800,4),(824,162309600,5),(824,183477600,4),(824,194968800,5),(824,215532000,4),(824,226418400,5),(824,246981600,4),(824,257868000,5),(824,278431200,4),(824,289317600,5),(824,309880800,4),(824,320767200,5),(824,341330400,4),(824,352216800,5),(824,372780000,4),(824,384271200,5),(824,404834400,4),(824,415720800,5),(824,436284000,4),(824,447170400,5),(824,467733600,4),(824,478620000,5),(824,499183200,4),(824,510069600,5),(824,530632800,4),(824,541519200,5),(824,562082400,4),(824,573573600,5),(824,594136800,4),(824,605023200,5),(824,623772000,4),(824,637682400,5),(824,655221600,4),(824,669132000,5),(824,686671200,4),(824,700581600,5),(824,718120800,4),(824,732636000,5),(824,749570400,4),(824,764085600,5),(824,781020000,4),(824,795535200,5),(824,812469600,4),(824,826984800,5),(824,844524000,4),(824,858434400,5),(824,875973600,4),(824,889884000,5),(824,907423200,4),(824,921938400,5),(824,938872800,4),(824,953388000,5),(824,970322400,4),(824,984837600,5),(824,1002376800,4),(824,1016287200,5),(824,1033826400,4),(824,1047736800,5),(824,1065276000,4),(824,1079791200,5),(824,1096725600,4),(824,1111240800,5),(824,1128175200,4),(824,1142690400,5),(824,1159624800,4),(824,1174140000,5),(824,1191074400,4),(824,1207404000,5),(824,1222524000,4),(824,1238853600,5),(824,1253973600,4),(824,1270303200,5),(824,1285423200,4),(824,1301752800,5),(824,1316872800,4),(824,1333202400,5),(824,1348927200,4),(824,1365256800,5),(824,1380376800,4),(824,1396706400,5),(824,1411826400,4),(824,1428156000,5),(824,1443276000,4),(824,1459605600,5),(824,1474725600,4),(824,1491055200,5),(824,1506175200,4),(824,1522504800,5),(824,1538229600,4),(824,1554559200,5),(824,1569679200,4),(824,1586008800,5),(824,1601128800,4),(824,1617458400,5),(824,1632578400,4),(824,1648908000,5),(824,1664028000,4),(824,1680357600,5),(824,1695477600,4),(824,1712412000,5),(824,1727532000,4),(824,1743861600,5),(824,1758981600,4),(824,1775311200,5),(824,1790431200,4),(824,1806760800,5),(824,1821880800,4),(824,1838210400,5),(824,1853330400,4),(824,1869660000,5),(824,1885384800,4),(824,1901714400,5),(824,1916834400,4),(824,1933164000,5),(824,1948284000,4),(824,1964613600,5),(824,1979733600,4),(824,1996063200,5),(824,2011183200,4),(824,2027512800,5),(824,2042632800,4),(824,2058962400,5),(824,2074687200,4),(824,2091016800,5),(824,2106136800,4),(824,2122466400,5),(824,2137586400,4),(825,-2147483648,0),(825,-157766400,2),(825,-152658000,1),(825,-132955200,2),(825,-121122000,1),(825,-101419200,2),(825,-86821200,1),(825,-71092800,2),(825,-54766800,1),(825,-39038400,2),(825,-23317200,1),(825,-7588800,4),(825,128142000,3),(825,136605600,4),(825,389070000,1),(825,403070400,5),(825,416372400,6),(825,434520000,5),(825,447822000,6),(825,466574400,5),(825,479271600,6),(825,498024000,5),(825,510721200,6),(825,529473600,5),(825,545194800,6),(825,560923200,5),(825,574225200,6),(825,592372800,5),(825,605674800,6),(825,624427200,5),(825,637124400,6),(825,653457600,5),(825,668574000,6),(825,687326400,5),(825,700628400,6),(825,718776000,5),(825,732078000,6),(825,750225600,5),(825,763527600,6),(825,781675200,5),(825,794977200,6),(825,813729600,5),(825,826426800,6),(825,845179200,5),(825,859690800,6),(825,876628800,5),(825,889930800,6),(825,906868800,5),(825,923194800,6),(825,939528000,5),(825,952830000,6),(825,971582400,5),(825,984279600,6),(825,1003032000,5),(825,1015729200,6),(825,1034481600,5),(825,1047178800,6),(825,1065931200,5),(825,1079233200,6),(825,1097380800,5),(825,1110682800,6),(825,1128830400,5),(825,1142132400,6),(825,1160884800,5),(825,1173582000,6),(825,1192334400,5),(825,1206846000,6),(825,1223784000,5),(825,1237086000,6),(825,1255233600,5),(825,1270350000,6),(825,1286683200,5),(825,1304823600,6),(825,1313899200,5),(825,1335668400,6),(825,1346558400,5),(825,1367118000,6),(825,1378612800,5),(825,1398567600,6),(825,1410062400,5),(825,1463281200,6),(825,1471147200,5),(825,1480820400,4),(825,2147483647,4),(826,-2147483648,0),(826,218246400,1),(826,2147483647,1),(827,-2147483648,2),(827,-1330335000,1),(827,-1320057000,2),(827,-1300699800,3),(827,-1287396000,2),(827,-1269250200,3),(827,-1255946400,2),(827,-1237800600,3),(827,-1224496800,2),(827,-1206351000,3),(827,-1192442400,2),(827,-1174901400,3),(827,-1160992800,2),(827,-1143451800,3),(827,-1125914400,2),(827,-1112607000,3),(827,-1094464800,2),(827,-1081157400,3),(827,-1063015200,2),(827,-1049707800,3),(827,-1031565600,2),(827,-1018258200,3),(827,-1000116000,2),(827,-986808600,3),(827,-968061600,2),(827,-955359000,3),(827,-936612000,2),(827,-923304600,3),(827,-757425600,6),(827,152632800,4),(827,162309600,5),(827,183477600,4),(827,194968800,5),(827,215532000,4),(827,226418400,5),(827,246981600,4),(827,257868000,5),(827,278431200,4),(827,289317600,5),(827,309880800,4),(827,320767200,5),(827,341330400,4),(827,352216800,5),(827,372780000,4),(827,384271200,5),(827,404834400,4),(827,415720800,5),(827,436284000,4),(827,447170400,5),(827,467733600,4),(827,478620000,5),(827,499183200,4),(827,510069600,5),(827,530632800,4),(827,541519200,5),(827,562082400,4),(827,573573600,5),(827,594136800,4),(827,605023200,5),(827,623772000,4),(827,637682400,5),(827,655221600,4),(827,669132000,5),(827,686671200,4),(827,700581600,5),(827,718120800,4),(827,732636000,5),(827,749570400,4),(827,764085600,5),(827,781020000,4),(827,795535200,5),(827,812469600,4),(827,826984800,5),(827,844524000,4),(827,858434400,5),(827,875973600,4),(827,889884000,5),(827,907423200,4),(827,921938400,5),(827,938872800,4),(827,953388000,5),(827,970322400,4),(827,984837600,5),(827,1002376800,4),(827,1016287200,5),(827,1033826400,4),(827,1047736800,5),(827,1065276000,4),(827,1079791200,5),(827,1096725600,4),(827,1111240800,5),(827,1128175200,4),(827,1142690400,5),(827,1159624800,4),(827,1174140000,5),(827,1191074400,4),(827,1207404000,5),(827,1222524000,4),(827,1238853600,5),(827,1253973600,4),(827,1270303200,5),(827,1285423200,4),(827,1301752800,5),(827,1316872800,4),(827,1333202400,5),(827,1348927200,4),(827,1365256800,5),(827,1380376800,4),(827,1396706400,5),(827,1411826400,4),(827,1428156000,5),(827,1443276000,4),(827,1459605600,5),(827,1474725600,4),(827,1491055200,5),(827,1506175200,4),(827,1522504800,5),(827,1538229600,4),(827,1554559200,5),(827,1569679200,4),(827,1586008800,5),(827,1601128800,4),(827,1617458400,5),(827,1632578400,4),(827,1648908000,5),(827,1664028000,4),(827,1680357600,5),(827,1695477600,4),(827,1712412000,5),(827,1727532000,4),(827,1743861600,5),(827,1758981600,4),(827,1775311200,5),(827,1790431200,4),(827,1806760800,5),(827,1821880800,4),(827,1838210400,5),(827,1853330400,4),(827,1869660000,5),(827,1885384800,4),(827,1901714400,5),(827,1916834400,4),(827,1933164000,5),(827,1948284000,4),(827,1964613600,5),(827,1979733600,4),(827,1996063200,5),(827,2011183200,4),(827,2027512800,5),(827,2042632800,4),(827,2058962400,5),(827,2074687200,4),(827,2091016800,5),(827,2106136800,4),(827,2122466400,5),(827,2137586400,4),(828,-2147483648,0),(828,-719636812,1),(828,2147483647,1),(829,-2147483648,0),(829,1108166400,3),(829,1111885200,1),(829,1130634000,2),(829,1143334800,1),(829,1162083600,2),(829,1174784400,1),(829,1193533200,2),(829,1206838800,1),(829,1224982800,2),(829,1238288400,1),(829,1256432400,2),(829,1269738000,1),(829,1288486800,2),(829,1301187600,1),(829,1319936400,2),(829,1332637200,1),(829,1351386000,2),(829,1364691600,1),(829,1382835600,2),(829,1396141200,1),(829,1414285200,2),(829,1427590800,1),(829,1445734800,2),(829,1459040400,1),(829,1477789200,2),(829,1490490000,1),(829,1509238800,2),(829,1521939600,1),(829,1540688400,2),(829,1553994000,1),(829,1572138000,2),(829,1585443600,1),(829,1603587600,2),(829,1616893200,1),(829,1635642000,2),(829,1648342800,1),(829,1667091600,2),(829,1679792400,1),(829,1698541200,2),(829,1711846800,1),(829,1729990800,2),(829,1743296400,1),(829,1761440400,2),(829,1774746000,1),(829,1792890000,2),(829,1806195600,1),(829,1824944400,2),(829,1837645200,1),(829,1856394000,2),(829,1869094800,1),(829,1887843600,2),(829,1901149200,1),(829,1919293200,2),(829,1932598800,1),(829,1950742800,2),(829,1964048400,1),(829,1982797200,2),(829,1995498000,1),(829,2014246800,2),(829,2026947600,1),(829,2045696400,2),(829,2058397200,1),(829,2077146000,2),(829,2090451600,1),(829,2108595600,2),(829,2121901200,1),(829,2140045200,2),(829,2147483647,2),(830,-2147483648,0),(830,-1325483420,1),(830,2147483647,1),(831,-2147483648,2),(831,-1693706400,1),(831,-1680483600,2),(831,-1663455600,3),(831,-1650150000,4),(831,-1632006000,3),(831,-1618700400,4),(831,-938905200,3),(831,-857257200,4),(831,-844556400,3),(831,-828226800,4),(831,-812502000,3),(831,-796777200,4),(831,-781052400,3),(831,-776563200,5),(831,-765936000,1),(831,-761180400,4),(831,-757386000,2),(831,-748479600,3),(831,-733273200,4),(831,-717631200,3),(831,-714610800,6),(831,-710380800,1),(831,-701910000,4),(831,-684975600,3),(831,-670460400,4),(831,-654130800,3),(831,-639010800,4),(831,315529200,2),(831,323830800,7),(831,338950800,8),(831,354675600,7),(831,370400400,8),(831,386125200,7),(831,401850000,8),(831,417574800,7),(831,433299600,8),(831,449024400,7),(831,465354000,8),(831,481078800,7),(831,496803600,8),(831,512528400,7),(831,528253200,8),(831,543978000,7),(831,559702800,8),(831,575427600,7),(831,591152400,8),(831,606877200,7),(831,622602000,8),(831,638326800,7),(831,654656400,8),(831,670381200,7),(831,686106000,8),(831,701830800,7),(831,717555600,8),(831,733280400,7),(831,749005200,8),(831,764730000,7),(831,780454800,8),(831,796179600,7),(831,811904400,8),(831,828234000,7),(831,846378000,8),(831,859683600,7),(831,877827600,8),(831,891133200,7),(831,909277200,8),(831,922582800,7),(831,941331600,8),(831,954032400,7),(831,972781200,8),(831,985482000,7),(831,1004230800,8),(831,1017536400,7),(831,1035680400,8),(831,1048986000,7),(831,1067130000,8),(831,1080435600,7),(831,1099184400,8),(831,1111885200,7),(831,1130634000,8),(831,1143334800,7),(831,1162083600,8),(831,1174784400,7),(831,1193533200,8),(831,1206838800,7),(831,1224982800,8),(831,1238288400,7),(831,1256432400,8),(831,1269738000,7),(831,1288486800,8),(831,1301187600,7),(831,1319936400,8),(831,1332637200,7),(831,1351386000,8),(831,1364691600,7),(831,1382835600,8),(831,1396141200,7),(831,1414285200,8),(831,1427590800,7),(831,1445734800,8),(831,1459040400,7),(831,1477789200,8),(831,1490490000,7),(831,1509238800,8),(831,1521939600,7),(831,1540688400,8),(831,1553994000,7),(831,1572138000,8),(831,1585443600,7),(831,1603587600,8),(831,1616893200,7),(831,1635642000,8),(831,1648342800,7),(831,1667091600,8),(831,1679792400,7),(831,1698541200,8),(831,1711846800,7),(831,1729990800,8),(831,1743296400,7),(831,1761440400,8),(831,1774746000,7),(831,1792890000,8),(831,1806195600,7),(831,1824944400,8),(831,1837645200,7),(831,1856394000,8),(831,1869094800,7),(831,1887843600,8),(831,1901149200,7),(831,1919293200,8),(831,1932598800,7),(831,1950742800,8),(831,1964048400,7),(831,1982797200,8),(831,1995498000,7),(831,2014246800,8),(831,2026947600,7),(831,2045696400,8),(831,2058397200,7),(831,2077146000,8),(831,2090451600,7),(831,2108595600,8),(831,2121901200,7),(831,2140045200,8),(832,-2147483648,0),(832,-719636812,1),(832,2147483647,1),(833,-2147483648,0),(833,-1441170468,1),(833,-1247547600,3),(833,354909600,2),(833,370717200,3),(833,386445600,2),(833,402253200,3),(833,417981600,2),(833,433789200,3),(833,449604000,2),(833,465336000,4),(833,481060800,5),(833,496785600,4),(833,512510400,5),(833,528235200,4),(833,543960000,5),(833,559684800,4),(833,575409600,5),(833,591134400,4),(833,606859200,5),(833,622584000,4),(833,638308800,5),(833,654638400,4),(833,670363200,6),(833,686091600,7),(833,695768400,4),(833,701812800,5),(833,717537600,4),(833,733262400,5),(833,748987200,4),(833,764712000,5),(833,780436800,4),(833,796161600,5),(833,811886400,4),(833,828216000,5),(833,846360000,4),(833,859665600,5),(833,877809600,4),(833,891115200,5),(833,909259200,4),(833,922564800,5),(833,941313600,4),(833,954014400,5),(833,972763200,4),(833,985464000,5),(833,1004212800,4),(833,1017518400,5),(833,1035662400,4),(833,1048968000,5),(833,1067112000,4),(833,1080417600,5),(833,1099166400,4),(833,2147483647,4),(834,-2147483648,0),(834,-1230776624,2),(834,108165600,1),(834,118270800,2),(834,136591200,1),(834,149806800,2),(834,168127200,1),(834,181342800,2),(834,199749600,1),(834,215643600,2),(834,231285600,1),(834,244501200,2),(834,262735200,1),(834,275950800,2),(834,481154400,1),(834,496962000,2),(834,512949600,1),(834,528670800,2),(834,544399200,1),(834,560120400,2),(834,575848800,1),(834,592174800,2),(834,610581600,1),(834,623624400,2),(834,641167200,1),(834,655074000,2),(834,671839200,1),(834,685918800,2),(834,702856800,1),(834,717973200,2),(834,733701600,1),(834,749422800,2),(834,765151200,1),(834,779662800,2),(834,797205600,1),(834,811116000,3),(834,828655200,1),(834,843170400,3),(834,860104800,1),(834,874620000,3),(834,891554400,1),(834,906069600,3),(834,930780000,4),(834,938124000,3),(834,954367200,4),(834,970178400,3),(834,985816800,4),(834,1001628000,3),(834,1017352800,1),(834,1033077600,3),(834,1048802400,1),(834,1066946400,3),(834,1080252000,1),(834,1097791200,3),(834,1112306400,1),(834,1128031200,3),(834,1143756000,1),(834,1161900000,3),(834,1175205600,1),(834,1193349600,3),(834,1206655200,1),(834,1225404000,3),(834,1238104800,1),(834,1256853600,3),(834,1269554400,1),(834,1288303200,3),(834,1301608800,1),(834,1319752800,3),(834,1333058400,1),(834,1387486800,2),(834,1395957600,1),(834,1414706400,3),(834,1427407200,1),(834,1446156000,3),(834,1459461600,1),(834,1477605600,3),(834,1490911200,1),(834,1509055200,3),(834,1522360800,1),(834,1540504800,3),(834,1553810400,1),(834,1571954400,3),(834,1585260000,1),(834,1604008800,3),(834,1616709600,1),(834,1635458400,3),(834,1645740000,1),(834,1666908000,5),(834,2147483647,5),(835,-2147483648,0),(835,-1441194596,1),(835,-1247572800,3),(835,354884400,2),(835,370692000,3),(835,386420400,4),(835,402231600,1),(835,417960000,4),(835,433767600,1),(835,449582400,4),(835,465314400,5),(835,481039200,6),(835,496764000,5),(835,512488800,6),(835,528213600,5),(835,543938400,6),(835,559663200,5),(835,575388000,6),(835,591112800,5),(835,606837600,6),(835,622562400,5),(835,638287200,6),(835,654616800,5),(835,670341600,7),(835,686070000,8),(835,695746800,5),(835,701791200,6),(835,717516000,5),(835,733240800,6),(835,748965600,5),(835,764690400,6),(835,780415200,5),(835,796140000,6),(835,811864800,5),(835,828194400,6),(835,846338400,5),(835,859644000,6),(835,877788000,5),(835,891093600,6),(835,909237600,5),(835,922543200,6),(835,941292000,5),(835,953992800,6),(835,972741600,5),(835,985442400,6),(835,1004191200,5),(835,1017496800,6),(835,1035640800,5),(835,1048946400,6),(835,1067090400,5),(835,1080396000,6),(835,1099144800,5),(835,1111845600,6),(835,1130594400,5),(835,1143295200,6),(835,1162044000,5),(835,1174744800,6),(835,1193493600,5),(835,1206799200,6),(835,1224943200,5),(835,1238248800,6),(835,1256392800,5),(835,1269698400,7),(835,1288450800,8),(835,1301151600,5),(835,2147483647,5),(836,-2147483648,0),(836,-1441164064,1),(836,-1247544000,2),(836,370724400,3),(836,386445600,4),(836,402256800,2),(836,417985200,4),(836,433792800,2),(836,449607600,4),(836,465339600,5),(836,481064400,6),(836,496789200,5),(836,512514000,6),(836,528238800,5),(836,543963600,6),(836,559688400,5),(836,575413200,6),(836,591138000,5),(836,606862800,6),(836,622587600,5),(836,638312400,6),(836,654642000,5),(836,670366800,7),(836,686095200,8),(836,695772000,5),(836,701816400,6),(836,717541200,5),(836,733266000,6),(836,748990800,5),(836,764715600,6),(836,780440400,8),(836,796168800,7),(836,811893600,8),(836,828223200,7),(836,846367200,8),(836,859672800,7),(836,877816800,8),(836,891122400,7),(836,909266400,8),(836,922572000,7),(836,941320800,8),(836,954021600,7),(836,972770400,8),(836,985471200,7),(836,1004220000,8),(836,1017525600,7),(836,1035669600,8),(836,1048975200,7),(836,1067119200,8),(836,1080424800,7),(836,1099173600,5),(836,2147483647,5),(837,-2147483648,0),(837,-1441165720,1),(837,-1247544000,2),(837,354913200,3),(837,370720800,4),(837,386445600,3),(837,402256800,2),(837,417985200,3),(837,433792800,2),(837,449607600,3),(837,465339600,5),(837,481064400,6),(837,496789200,5),(837,512514000,6),(837,528238800,5),(837,543963600,6),(837,559688400,5),(837,575413200,6),(837,591138000,5),(837,606862800,6),(837,622587600,5),(837,638312400,6),(837,654642000,5),(837,670366800,7),(837,686095200,8),(837,695772000,5),(837,701816400,6),(837,717541200,5),(837,733266000,6),(837,748990800,5),(837,764715600,6),(837,780440400,5),(837,796165200,6),(837,811890000,5),(837,828219600,6),(837,846363600,5),(837,859669200,6),(837,877813200,5),(837,891118800,6),(837,909262800,5),(837,922568400,6),(837,941317200,5),(837,954018000,6),(837,972766800,5),(837,985467600,6),(837,1004216400,5),(837,1017522000,6),(837,1035666000,5),(837,1048971600,6),(837,1067115600,5),(837,1080421200,6),(837,1099170000,5),(837,2147483647,5),(838,-2147483648,0),(838,-1441166012,1),(838,-1247544000,3),(838,354913200,2),(838,370720800,3),(838,386449200,2),(838,402256800,3),(838,417985200,2),(838,433792800,3),(838,449607600,2),(838,465339600,4),(838,481064400,5),(838,496789200,4),(838,512514000,5),(838,528238800,4),(838,543963600,5),(838,559688400,4),(838,575413200,5),(838,591138000,4),(838,606862800,5),(838,622587600,4),(838,638312400,5),(838,654642000,4),(838,670366800,6),(838,686095200,7),(838,695772000,3),(838,2147483647,3),(839,-2147483648,0),(839,-1441166012,1),(839,-1247544000,3),(839,354913200,2),(839,370720800,3),(839,386449200,2),(839,402256800,3),(839,417985200,2),(839,433792800,3),(839,449607600,2),(839,465339600,4),(839,481064400,5),(839,496789200,4),(839,512514000,5),(839,528238800,4),(839,543963600,5),(839,559688400,4),(839,575413200,5),(839,591138000,4),(839,606862800,5),(839,622587600,4),(839,638312400,5),(839,654642000,4),(839,670366800,6),(839,686095200,7),(839,695772000,3),(839,2147483647,3),(840,-2147483648,0),(840,-1441164464,1),(840,-1247540400,2),(840,370724400,3),(840,386445600,4),(840,402256800,2),(840,417985200,4),(840,433792800,2),(840,449607600,4),(840,465339600,5),(840,481064400,6),(840,496789200,5),(840,512514000,6),(840,528238800,5),(840,543963600,6),(840,559688400,5),(840,575413200,6),(840,591138000,5),(840,606862800,6),(840,622587600,5),(840,638312400,6),(840,654642000,5),(840,670366800,7),(840,686095200,8),(840,695772000,5),(840,701816400,6),(840,717541200,5),(840,733266000,6),(840,748990800,5),(840,764715600,6),(840,780440400,5),(840,796165200,6),(840,811890000,5),(840,828219600,6),(840,846363600,5),(840,859669200,6),(840,877813200,5),(840,891118800,6),(840,909262800,5),(840,922568400,7),(840,941320800,8),(840,954021600,7),(840,972770400,8),(840,985471200,7),(840,1004220000,8),(840,1017525600,7),(840,1035669600,8),(840,1048975200,7),(840,1067119200,8),(840,1080424800,7),(840,1099173600,5),(840,2147483647,5),(841,-2147483648,1),(841,-1641005856,2),(841,389048400,3),(841,402264000,2),(841,417906000,3),(841,433800000,2),(841,449614800,3),(841,465422400,2),(841,481150800,3),(841,496792800,4),(841,512517600,5),(841,528242400,4),(841,543967200,5),(841,559692000,4),(841,575416800,5),(841,591141600,4),(841,606866400,5),(841,622591200,4),(841,638316000,5),(841,654645600,4),(841,670464000,5),(841,686275200,4),(841,702086400,5),(841,717897600,4),(841,733622400,5),(841,749433600,4),(841,765158400,5),(841,780969600,4),(841,796694400,5),(841,812505600,4),(841,828316800,5),(841,844128000,4),(841,859852800,5),(841,875664000,4),(841,891388800,5),(841,907200000,4),(841,922924800,5),(841,938736000,4),(841,954547200,5),(841,970358400,4),(841,986083200,5),(841,1001894400,4),(841,1017619200,5),(841,1033430400,4),(841,1049155200,5),(841,1064966400,4),(841,1080777600,5),(841,1096588800,4),(841,1112313600,5),(841,1128124800,4),(841,1143849600,5),(841,1159660800,4),(841,1175385600,5),(841,1191196800,4),(841,2147483647,4),(842,-2147483648,0),(842,-1577935568,1),(842,76190400,2),(842,2147483647,2),(843,-2147483648,0),(843,-1441163964,1),(843,-405140400,3),(843,354916800,2),(843,370724400,3),(843,386452800,2),(843,402260400,3),(843,417988800,2),(843,433796400,3),(843,449611200,2),(843,465343200,4),(843,481068000,5),(843,496792800,4),(843,512517600,5),(843,528242400,4),(843,543967200,5),(843,559692000,4),(843,575416800,5),(843,591141600,4),(843,606866400,5),(843,622591200,4),(843,638316000,5),(843,654645600,4),(843,670370400,6),(843,686098800,7),(843,701823600,6),(843,717548400,4),(843,820440000,3),(843,828234000,8),(843,846378000,9),(843,852062400,3),(843,859680000,2),(843,877824000,3),(843,891129600,2),(843,909273600,3),(843,922579200,2),(843,941328000,3),(843,954028800,2),(843,972777600,3),(843,985478400,2),(843,1004227200,3),(843,1017532800,2),(843,1035676800,3),(843,1048982400,2),(843,1067126400,3),(843,1080432000,2),(843,1099180800,3),(843,1111881600,2),(843,1130630400,3),(843,1143331200,2),(843,1162080000,3),(843,1174780800,2),(843,1193529600,3),(843,1206835200,2),(843,1224979200,3),(843,1238284800,2),(843,1256428800,3),(843,1269734400,2),(843,1288483200,3),(843,1301184000,2),(843,1319932800,3),(843,1332633600,2),(843,1351382400,3),(843,1364688000,2),(843,1382832000,3),(843,1396137600,2),(843,1414281600,3),(843,1427587200,2),(843,1445731200,3),(843,2147483647,3),(844,-2147483648,1),(844,-1570084924,2),(844,2147483647,2),(845,-2147483648,0),(845,-1579844100,1),(845,-1247551200,3),(845,354906000,2),(845,370713600,3),(845,386442000,2),(845,402249600,3),(845,417978000,2),(845,433785600,3),(845,449600400,2),(845,465332400,4),(845,481057200,5),(845,496782000,4),(845,512506800,5),(845,528231600,4),(845,543956400,5),(845,559681200,4),(845,575406000,5),(845,591130800,4),(845,606855600,5),(845,622580400,4),(845,638305200,5),(845,654634800,4),(845,670359600,6),(845,686088000,7),(845,695764800,4),(845,701809200,5),(845,717534000,4),(845,733258800,5),(845,748983600,4),(845,764708400,5),(845,780433200,4),(845,796158000,5),(845,801590400,8),(845,811886400,7),(845,828216000,6),(845,846360000,7),(845,859665600,6),(845,877809600,7),(845,891115200,6),(845,909259200,7),(845,922564800,6),(845,941313600,7),(845,954014400,6),(845,972763200,7),(845,985464000,6),(845,1004212800,7),(845,1017518400,6),(845,1035662400,7),(845,1048968000,6),(845,1067112000,7),(845,1080417600,6),(845,1099166400,7),(845,1111867200,6),(845,1130616000,7),(845,1143316800,6),(845,1162065600,7),(845,1174766400,6),(845,1193515200,7),(845,1206820800,6),(845,1224964800,7),(845,1238270400,6),(845,1256414400,7),(845,1269720000,6),(845,1288468800,7),(845,1301169600,4),(845,1414263600,7),(845,1459022400,4),(845,2147483647,4),(846,-2147483648,2),(846,-1570413600,1),(846,-1552186800,2),(846,-1538359200,1),(846,-1522551600,2),(846,-1507514400,1),(846,-1490583600,2),(846,-1473645600,1),(846,-1460948400,2),(846,-399866400,1),(846,-386650800,2),(846,-368330400,1),(846,-355114800,2),(846,-336794400,1),(846,-323578800,2),(846,-305172000,1),(846,-291956400,2),(846,-273636000,1),(846,-260420400,2),(846,78012000,1),(846,86734800,2),(846,105055200,1),(846,118270800,2),(846,136591200,1),(846,149806800,2),(846,168127200,1),(846,181342800,2),(846,199749600,1),(846,212965200,2),(846,231285600,1),(846,244501200,2),(846,262735200,1),(846,275950800,2),(846,452210400,1),(846,466722000,2),(846,483746400,1),(846,498258000,2),(846,515282400,1),(846,529794000,2),(846,546818400,1),(846,561330000,2),(846,581119200,1),(846,592952400,2),(846,610754400,1),(846,624488400,2),(846,641512800,1),(846,656024400,2),(846,673048800,1),(846,687560400,2),(846,704671200,1),(846,718146000,2),(846,733269600,1),(846,748990800,2),(846,764719200,1),(846,780440400,2),(846,796168800,1),(846,811890000,2),(846,828223200,1),(846,843944400,2),(846,859672800,1),(846,875394000,2),(846,891122400,1),(846,906843600,2),(846,922572000,1),(846,941317200,2),(846,954021600,1),(846,972766800,2),(846,985471200,1),(846,1004216400,2),(846,1017525600,1),(846,1035666000,2),(846,1048975200,1),(846,1067115600,2),(846,1080424800,1),(846,1099170000,2),(846,1111874400,1),(846,1130619600,2),(846,1143324000,1),(846,1162069200,2),(846,1174773600,1),(846,1193518800,2),(846,1206828000,1),(846,1224968400,2),(846,1238277600,1),(846,1256418000,2),(846,1269727200,1),(846,1288472400,2),(846,1301176800,1),(846,1319922000,2),(846,1332626400,1),(846,1351371600,2),(846,1364680800,1),(846,1382821200,2),(846,1396130400,1),(846,1414270800,2),(846,1427580000,1),(846,1445720400,2),(846,1459029600,1),(846,1477774800,2),(846,1490479200,1),(846,1509224400,2),(846,1521928800,1),(846,1540674000,2),(846,1553983200,1),(846,1572123600,2),(846,1585432800,1),(846,1603573200,2),(846,1616882400,1),(846,1635627600,2),(846,1648332000,1),(846,1667077200,2),(846,1679781600,1),(846,1698526800,2),(846,1711836000,1),(846,1729976400,2),(846,1743285600,1),(846,1761426000,2),(846,1774735200,1),(846,1792875600,2),(846,1806184800,1),(846,1824930000,2),(846,1837634400,1),(846,1856379600,2),(846,1869084000,1),(846,1887829200,2),(846,1901138400,1),(846,1919278800,2),(846,1932588000,1),(846,1950728400,2),(846,1964037600,1),(846,1982782800,2),(846,1995487200,1),(846,2014232400,2),(846,2026936800,1),(846,2045682000,2),(846,2058386400,1),(846,2077131600,2),(846,2090440800,1),(846,2108581200,2),(846,2121890400,1),(846,2140030800,2),(847,-2147483648,0),(847,-1441169904,1),(847,-1247547600,3),(847,354909600,2),(847,370717200,3),(847,386445600,2),(847,402253200,3),(847,417981600,2),(847,433789200,3),(847,449604000,2),(847,465336000,4),(847,481060800,5),(847,496785600,4),(847,512510400,5),(847,528235200,4),(847,543960000,5),(847,559684800,4),(847,575409600,5),(847,591134400,4),(847,606859200,5),(847,622584000,4),(847,638308800,5),(847,654638400,4),(847,670363200,6),(847,683582400,1),(847,703018800,6),(847,717530400,1),(847,734468400,6),(847,748980000,1),(847,765918000,6),(847,780429600,1),(847,797367600,6),(847,811879200,1),(847,828817200,6),(847,843933600,1),(847,859671000,8),(847,877811400,1),(847,891120600,8),(847,909261000,1),(847,922570200,8),(847,941315400,1),(847,954019800,8),(847,972765000,1),(847,985469400,8),(847,1004214600,1),(847,1017523800,8),(847,1035664200,1),(847,1048973400,8),(847,1067113800,1),(847,1080423000,8),(847,1099168200,1),(847,1111872600,8),(847,1123783200,3),(847,2147483647,3),(848,-2147483648,0),(848,-1383463280,1),(848,-1167636600,3),(848,-1082448000,2),(848,-1074586800,3),(848,-1050825600,2),(848,-1042964400,3),(848,-1019289600,2),(848,-1011428400,3),(848,-987753600,2),(848,-979892400,3),(848,-956217600,2),(848,-948356400,3),(848,-924595200,2),(848,-916734000,3),(848,-893059200,2),(848,-885198000,3),(848,-879667200,4),(848,-767005200,3),(848,2147483647,3),(849,-2147483648,1),(849,-2019705670,2),(849,-891581400,3),(849,-872058600,2),(849,-862637400,3),(849,-764145000,2),(850,-2147483648,0),(850,-1579419232,1),(850,-1247558400,3),(850,354898800,2),(850,370706400,3),(850,386434800,2),(850,402242400,3),(850,417970800,2),(850,433778400,3),(850,449593200,2),(850,465325200,4),(850,481050000,5),(850,496774800,4),(850,512499600,5),(850,528224400,4),(850,543949200,5),(850,559674000,4),(850,575398800,5),(850,591123600,4),(850,606848400,5),(850,622573200,4),(850,638298000,5),(850,654627600,4),(850,670352400,6),(850,686080800,7),(850,695757600,4),(850,701802000,5),(850,717526800,4),(850,733251600,5),(850,748976400,4),(850,764701200,5),(850,780426000,4),(850,796150800,5),(850,811875600,4),(850,828205200,5),(850,846349200,4),(850,859654800,5),(850,877798800,4),(850,891104400,5),(850,909248400,4),(850,922554000,5),(850,941302800,4),(850,954003600,5),(850,972752400,4),(850,985453200,5),(850,1004202000,4),(850,1017507600,5),(850,1035651600,4),(850,1048957200,5),(850,1067101200,4),(850,1080406800,5),(850,1099155600,4),(850,1111856400,5),(850,1130605200,4),(850,1143306000,5),(850,1162054800,4),(850,1174755600,5),(850,1193504400,4),(850,1206810000,5),(850,1224954000,4),(850,1238259600,5),(850,1256403600,4),(850,1269709200,5),(850,1288458000,4),(850,1301158800,8),(850,1414252800,7),(850,1459015200,3),(850,2147483647,3),(851,-2147483648,0),(851,-2032933080,1),(851,252435600,2),(851,417974400,4),(851,433778400,3),(851,449593200,4),(851,465314400,3),(851,481042800,4),(851,496764000,3),(851,512492400,4),(851,528213600,3),(851,543942000,4),(851,559663200,3),(851,575391600,4),(851,591112800,3),(851,606841200,4),(851,622562400,3),(851,638290800,4),(851,654616800,3),(851,670345200,4),(851,686066400,3),(851,701794800,4),(851,717516000,3),(851,733244400,4),(851,748965600,3),(851,764694000,4),(851,780415200,3),(851,796143600,4),(851,811864800,3),(851,828198000,4),(851,843919200,3),(851,859647600,4),(851,875368800,3),(851,891097200,4),(851,906818400,3),(851,988390800,4),(851,1001692800,3),(851,1017421200,4),(851,1033142400,3),(851,1048870800,4),(851,1064592000,3),(851,1080320400,4),(851,1096041600,3),(851,1111770000,4),(851,1127491200,3),(851,1143219600,4),(851,1159545600,3),(851,1206889200,2),(851,1427479200,5),(851,1443193200,2),(851,1458928800,5),(851,1474642800,2),(851,2147483647,2),(852,-2147483648,2),(852,-1600675200,1),(852,-1585904400,2),(852,-933667200,1),(852,-922093200,2),(852,-908870400,1),(852,-888829200,2),(852,-881049600,1),(852,-767869200,2),(852,-745833600,1),(852,-733827600,2),(852,-716889600,1),(852,-699613200,2),(852,-683884800,1),(852,-670669200,2),(852,-652348800,1),(852,-650019600,2),(852,515527200,1),(852,527014800,2),(852,545162400,1),(852,558464400,2),(852,577216800,1),(852,589914000,2),(852,608666400,1),(852,621968400,2),(852,640116000,1),(852,653418000,2),(852,671565600,1),(852,684867600,2),(853,-2147483648,2),(853,-1600675200,1),(853,-1585904400,2),(853,-933667200,1),(853,-922093200,2),(853,-908870400,1),(853,-888829200,2),(853,-881049600,1),(853,-767869200,2),(853,-745833600,1),(853,-733827600,2),(853,-716889600,1),(853,-699613200,2),(853,-683884800,1),(853,-670669200,2),(853,-652348800,1),(853,-650019600,2),(853,515527200,1),(853,527014800,2),(853,545162400,1),(853,558464400,2),(853,577216800,1),(853,589914000,2),(853,608666400,1),(853,621968400,2),(853,640116000,1),(853,653418000,2),(853,671565600,1),(853,684867600,2),(854,-2147483648,1),(854,-2019705572,2),(854,-883287000,3),(854,-862639200,4),(854,-764051400,2),(854,832962600,5),(854,846266400,6),(854,1145039400,2),(854,2147483647,2),(855,-2147483648,1),(855,-891582800,2),(855,-872058600,3),(855,-862637400,2),(855,-576138600,4),(855,1245430800,5),(855,1262278800,4),(855,2147483647,4),(856,-2147483648,0),(856,-1577931912,2),(856,-1568592000,1),(856,-1554080400,2),(856,-1537142400,1),(856,-1522630800,2),(856,-1505692800,1),(856,-1491181200,2),(856,-1474243200,1),(856,-1459126800,2),(856,-242265600,1),(856,-228877200,2),(856,-210556800,1),(856,-197427600,2),(856,-178934400,1),(856,-165718800,2),(856,-147398400,1),(856,-134269200,2),(856,-116467200,1),(856,-102646800,2),(856,-84326400,1),(856,-71110800,2),(856,-52704000,1),(856,-39488400,2),(856,-21168000,1),(856,-7952400,2),(856,10368000,1),(856,23583600,2),(856,41904000,1),(856,55119600,2),(856,73526400,1),(856,86742000,2),(856,105062400,1),(856,118278000,2),(856,136598400,1),(856,149814000,2),(856,168134400,1),(856,181350000,2),(856,199756800,1),(856,212972400,2),(856,231292800,1),(856,241916400,2),(856,262828800,1),(856,273452400,2),(856,418694400,1),(856,433810800,2),(856,450316800,1),(856,465433200,2),(856,508896000,1),(856,529196400,2),(856,541555200,1),(856,562633200,2),(856,574387200,1),(856,594255600,2),(856,607305600,1),(856,623199600,2),(856,638928000,1),(856,654649200,2),(856,670456800,1),(856,686264400,2),(856,702684000,1),(856,717886800,2),(856,733096800,1),(856,748904400,2),(856,765151200,1),(856,780958800,2),(856,796687200,1),(856,812494800,2),(856,828309600,1),(856,844117200,2),(856,859759200,1),(856,875653200,2),(856,891208800,1),(856,907189200,2),(856,922917600,1),(856,938725200,2),(856,954540000,1),(856,970347600,2),(856,986076000,1),(856,1001883600,2),(856,1017612000,1),(856,1033419600,2),(856,1049148000,1),(856,1064955600,2),(856,1080770400,1),(856,1096578000,2),(856,1112306400,1),(856,1128114000,2),(856,1143842400,1),(856,1158872400,2),(856,1175205600,1),(856,1193950800,2),(856,1207260000,1),(856,1225486800,2),(856,1238104800,1),(856,1256850000,2),(856,1270159200,1),(856,1288299600,2),(856,1301608800,1),(856,1319749200,2),(856,1333058400,1),(856,1351198800,2),(856,1364508000,1),(856,1382648400,2),(856,1395957600,1),(856,1414702800,2),(856,1427407200,1),(856,1446152400,2),(856,1458856800,1),(856,1477602000,2),(856,1490911200,1),(856,1509051600,2),(856,1522360800,1),(856,1540501200,2),(856,1553810400,1),(856,1571950800,2),(856,1585260000,1),(856,1604005200,2),(856,1616709600,1),(856,1635454800,2),(856,1648159200,1),(856,1666904400,3),(856,2147483647,3),(857,-2147483648,1),(857,-891582800,2),(857,-872058600,3),(857,-862637400,2),(857,-576138600,4),(857,1245430800,5),(857,1262278800,4),(857,2147483647,4),(858,-2147483648,0),(858,-1830414140,1),(858,-879152400,2),(858,199897200,1),(858,969120000,2),(858,2147483647,2),(859,-2147483648,0),(859,-1577936472,1),(859,2147483647,1),(860,-2147483648,0),(860,-1441168512,1),(860,-1247547600,3),(860,354909600,2),(860,370717200,3),(860,386445600,2),(860,402253200,3),(860,417981600,2),(860,433789200,3),(860,449604000,2),(860,465336000,4),(860,481060800,5),(860,496785600,4),(860,512510400,5),(860,528235200,4),(860,543960000,5),(860,559684800,4),(860,575409600,5),(860,591134400,4),(860,606859200,5),(860,622584000,4),(860,638308800,5),(860,654638400,4),(860,670363200,6),(860,684363600,7),(860,2147483647,7),(861,-2147483648,0),(861,-1518920148,2),(861,166572000,1),(861,182293200,2),(861,200959200,1),(861,213829200,2),(861,228866400,1),(861,243982800,2),(861,260316000,1),(861,276123600,2),(861,291765600,1),(861,307486800,2),(861,323820000,1),(861,338936400,2),(861,354664800,1),(861,370386000,2),(861,386114400,1),(861,401835600,2),(861,417564000,1),(861,433285200,2),(861,449013600,1),(861,465339600,2),(861,481068000,1),(861,496789200,2),(861,512517600,1),(861,528238800,2),(861,543967200,1),(861,559688400,2),(861,575416800,1),(861,591138000,2),(861,606866400,1),(861,622587600,2),(861,638316000,1),(861,654642000,2),(861,670370400,1),(861,686091600,2),(861,701820000,1),(861,717541200,2),(861,733269600,1),(861,748990800,2),(861,764719200,1),(861,780440400,2),(861,796168800,1),(861,811890000,2),(861,828223200,1),(861,843944400,2),(861,859672800,1),(861,875394000,2),(861,891122400,1),(861,909277200,3),(861,922582800,4),(861,941331600,3),(861,954032400,4),(861,972781200,3),(861,985482000,4),(861,1004230800,3),(861,1017536400,4),(861,1035680400,3),(861,1048986000,4),(861,1067130000,3),(861,1080435600,4),(861,1099184400,3),(861,1111885200,4),(861,1130634000,3),(861,1143334800,4),(861,1162083600,3),(861,1174784400,4),(861,1193533200,3),(861,1206838800,4),(861,1224982800,3),(861,1238288400,4),(861,1256432400,3),(861,1269738000,4),(861,1288486800,3),(861,1301187600,4),(861,1319936400,3),(861,1332637200,4),(861,1351386000,3),(861,1364691600,4),(861,1382835600,3),(861,1396141200,4),(861,1414285200,3),(861,1427590800,4),(861,1445734800,3),(861,1459040400,4),(861,1473282000,5),(861,1509238800,3),(861,1521939600,4),(861,1540688400,3),(861,1553994000,4),(861,1572138000,3),(861,1585443600,4),(861,1603587600,3),(861,1616893200,4),(861,1635642000,3),(861,1648342800,4),(861,1667091600,3),(861,1679792400,4),(861,1698541200,3),(861,1711846800,4),(861,1729990800,3),(861,1743296400,4),(861,1761440400,3),(861,1774746000,4),(861,1792890000,3),(861,1806195600,4),(861,1824944400,3),(861,1837645200,4),(861,1856394000,3),(861,1869094800,4),(861,1887843600,3),(861,1901149200,4),(861,1919293200,3),(861,1932598800,4),(861,1950742800,3),(861,1964048400,4),(861,1982797200,3),(861,1995498000,4),(861,2014246800,3),(861,2026947600,4),(861,2045696400,3),(861,2058397200,4),(861,2077146000,3),(861,2090451600,4),(861,2108595600,3),(861,2121901200,4),(861,2140045200,3),(862,-2147483648,3),(862,-933638400,1),(862,-923097600,2),(862,-919036800,1),(862,-857347200,2),(862,-844300800,1),(862,-825811200,2),(862,-812678400,1),(862,-794188800,2),(862,-779846400,1),(862,-762652800,2),(862,-748310400,1),(862,-731116800,2),(862,-682653600,3),(862,-399088800,4),(862,-386650800,3),(862,-368330400,4),(862,-355114800,3),(862,-336790800,4),(862,-323654400,3),(862,-305168400,4),(862,-292032000,3),(862,-273632400,4),(862,-260496000,3),(862,-242096400,4),(862,-228960000,3),(862,-210560400,4),(862,-197424000,3),(862,-178938000,4),(862,-165801600,3),(862,-147402000,4),(862,-134265600,3),(862,-115866000,4),(862,-102643200,3),(862,-84330000,4),(862,-81313200,6),(862,142380000,5),(862,150843600,6),(862,167176800,5),(862,178664400,6),(862,334101600,7),(862,337730400,8),(862,452642400,7),(862,462319200,8),(862,482277600,5),(862,494370000,6),(862,516751200,5),(862,526424400,6),(862,545436000,5),(862,558478800,6),(862,576626400,5),(862,589323600,6),(862,609890400,5),(862,620773200,6),(862,638316000,5),(862,651618000,6),(862,669765600,5),(862,683672400,6),(862,701820000,5),(862,715726800,6),(862,733701600,5),(862,747176400,6),(862,765151200,5),(862,778021200,6),(862,796600800,5),(862,810075600,6),(862,820447200,3),(862,828655200,4),(862,843170400,9),(862,860104800,4),(862,874620000,9),(862,891554400,4),(862,906069600,9),(862,915141600,3),(862,924213600,4),(862,939934800,3),(862,956268000,4),(862,971989200,3),(862,987717600,4),(862,1003438800,3),(862,1019167200,4),(862,1034888400,3),(862,1050616800,4),(862,1066338000,3),(862,1082066400,4),(862,1096581600,3),(862,1113516000,4),(862,1128380400,3),(862,1143842400,4),(862,1158872400,3),(862,1175378400,4),(862,1189638000,3),(862,1206655200,4),(862,1219957200,3),(862,1238104800,4),(862,1252015200,3),(862,1269640860,4),(862,1281474000,3),(862,1301608860,4),(862,1312146000,3),(862,1333058400,4),(862,1348178400,3),(862,1364508000,4),(862,1380229200,3),(862,1395957600,4),(862,1414098000,3),(862,1427493600,4),(862,1445551200,3),(862,1458946800,4),(862,1477692000,3),(862,1490396400,4),(862,1509141600,3),(862,1521846000,4),(862,1540591200,3),(862,1553810400,4),(862,1572037200,3),(862,1585346400,4),(862,1603490400,3),(862,1616796000,4),(862,1635458400,3),(862,1648332000,4),(862,1666998000,3),(862,1682726400,4),(862,1698447600,3),(862,1712966400,4),(862,1729897200,3),(862,1743811200,4),(862,1761346800,3),(862,1774656000,4),(862,1792796400,3),(862,1806105600,4),(862,1824850800,3),(862,1837555200,4),(862,1856300400,3),(862,1869004800,4),(862,1887750000,3),(862,1901059200,4),(862,1919199600,3),(862,1932508800,4),(862,1950649200,3),(862,1963958400,4),(862,1982703600,3),(862,1995408000,4),(862,2014153200,3),(862,2026857600,4),(862,2045602800,3),(862,2058307200,4),(862,2077052400,3),(862,2090361600,4),(862,2107897200,3),(862,2121811200,4),(862,2138742000,3),(863,-2147483648,2),(863,-1600675200,1),(863,-1585904400,2),(863,-933667200,1),(863,-922093200,2),(863,-908870400,1),(863,-888829200,2),(863,-881049600,1),(863,-767869200,2),(863,-745833600,1),(863,-733827600,2),(863,-716889600,1),(863,-699613200,2),(863,-683884800,1),(863,-670669200,2),(863,-652348800,1),(863,-650019600,2),(863,515527200,1),(863,527014800,2),(863,545162400,1),(863,558464400,2),(863,577216800,1),(863,589914000,2),(863,608666400,1),(863,621968400,2),(863,640116000,1),(863,653418000,2),(863,671565600,1),(863,684867600,2),(864,-2147483648,3),(864,-933638400,1),(864,-923097600,2),(864,-919036800,1),(864,-857347200,2),(864,-844300800,1),(864,-825811200,2),(864,-812678400,1),(864,-794188800,2),(864,-779846400,1),(864,-762652800,2),(864,-748310400,1),(864,-731116800,2),(864,-682653600,3),(864,-399088800,4),(864,-386650800,3),(864,-368330400,4),(864,-355114800,3),(864,-336790800,4),(864,-323654400,3),(864,-305168400,4),(864,-292032000,3),(864,-273632400,4),(864,-260496000,3),(864,-242096400,4),(864,-228960000,3),(864,-210560400,4),(864,-197424000,3),(864,-178938000,4),(864,-165801600,3),(864,-147402000,4),(864,-134265600,3),(864,-115866000,4),(864,-102643200,3),(864,-84330000,4),(864,-81313200,6),(864,142380000,5),(864,150843600,6),(864,167176800,5),(864,178664400,6),(864,334101600,7),(864,337730400,8),(864,452642400,7),(864,462319200,8),(864,482277600,5),(864,494370000,6),(864,516751200,5),(864,526424400,6),(864,545436000,5),(864,558478800,6),(864,576626400,5),(864,589323600,6),(864,609890400,5),(864,620773200,6),(864,638316000,5),(864,651618000,6),(864,669765600,5),(864,683672400,6),(864,701820000,5),(864,715726800,6),(864,733701600,5),(864,747176400,6),(864,765151200,5),(864,778021200,6),(864,796600800,5),(864,810075600,6),(864,820447200,3),(864,828655200,4),(864,843170400,9),(864,860104800,4),(864,874620000,9),(864,891554400,4),(864,906069600,9),(864,915141600,3),(864,924213600,4),(864,939934800,3),(864,956268000,4),(864,971989200,3),(864,987717600,4),(864,1003438800,3),(864,1019167200,4),(864,1034888400,3),(864,1050616800,4),(864,1066338000,3),(864,1082066400,4),(864,1096581600,3),(864,1113516000,4),(864,1128380400,3),(864,1143842400,4),(864,1158872400,3),(864,1175378400,4),(864,1189638000,3),(864,1206655200,4),(864,1220216400,3),(864,1238104800,4),(864,1252015200,3),(864,1269554400,4),(864,1281474000,3),(864,1301608860,4),(864,1312146000,3),(864,1314655200,4),(864,1317330000,3),(864,1333058400,4),(864,1348178400,3),(864,1364508000,4),(864,1380229200,3),(864,1395957600,4),(864,1414098000,3),(864,1427493600,4),(864,1445551200,3),(864,1458946800,4),(864,1477692000,3),(864,1490396400,4),(864,1509141600,3),(864,1521846000,4),(864,1540591200,3),(864,1553810400,4),(864,1572037200,3),(864,1585346400,4),(864,1603490400,3),(864,1616796000,4),(864,1635458400,3),(864,1648332000,4),(864,1666998000,3),(864,1682726400,4),(864,1698447600,3),(864,1712966400,4),(864,1729897200,3),(864,1743811200,4),(864,1761346800,3),(864,1774656000,4),(864,1792796400,3),(864,1806105600,4),(864,1824850800,3),(864,1837555200,4),(864,1856300400,3),(864,1869004800,4),(864,1887750000,3),(864,1901059200,4),(864,1919199600,3),(864,1932508800,4),(864,1950649200,3),(864,1963958400,4),(864,1982703600,3),(864,1995408000,4),(864,2014153200,3),(864,2026857600,4),(864,2045602800,3),(864,2058307200,4),(864,2077052400,3),(864,2090361600,4),(864,2107897200,3),(864,2121811200,4),(864,2138742000,3),(865,-2147483648,0),(865,-2004073590,1),(865,-1851577590,2),(865,-852105600,3),(865,-782643600,4),(865,-767869200,2),(865,-718095600,3),(865,-457776000,2),(865,-315648000,3),(865,171820800,2),(865,2147483647,2),(866,-2147483648,0),(866,-2056690800,1),(866,-900910800,2),(866,-891579600,3),(866,-884248200,4),(866,-761209200,7),(866,-747907200,2),(866,-728541000,5),(866,-717049800,6),(866,-697091400,5),(866,-683785800,6),(866,-668061000,5),(866,-654755400,2),(866,-636611400,5),(866,-623305800,2),(866,-605161800,5),(866,-591856200,2),(866,-573712200,5),(866,-559801800,2),(866,-541657800,5),(866,-528352200,2),(866,-510211800,7),(866,-498112200,2),(866,-478762200,7),(866,-466662600,2),(866,-446707800,7),(866,-435213000,2),(866,-415258200,7),(866,-403158600,2),(866,-383808600,7),(866,-371709000,2),(866,-352359000,7),(866,-340259400,2),(866,-320909400,7),(866,-308809800,2),(866,-288855000,7),(866,-277360200,2),(866,-257405400,7),(866,-245910600,2),(866,-225955800,7),(866,-213856200,2),(866,-194506200,7),(866,-182406600,2),(866,-163056600,7),(866,-148537800,2),(866,-132816600,7),(866,-117088200,2),(866,-101367000,7),(866,-85638600,2),(866,-69312600,7),(866,-53584200,2),(866,-37863000,7),(866,-22134600,2),(866,-6413400,7),(866,9315000,2),(866,25036200,7),(866,40764600,2),(866,56485800,7),(866,72214200,2),(866,88540200,7),(866,104268600,2),(866,119989800,7),(866,126041400,2),(866,151439400,7),(866,167167800,2),(866,182889000,7),(866,198617400,2),(866,214338600,7),(866,295385400,2),(866,309292200,7),(867,-2147483648,0),(867,-2032927596,1),(867,252439200,3),(867,417978000,2),(867,433785600,3),(867,449600400,2),(867,465321600,3),(867,481050000,2),(867,496771200,3),(867,512499600,2),(867,528220800,3),(867,543949200,2),(867,559670400,3),(867,575398800,2),(867,591120000,3),(867,606848400,2),(867,622569600,3),(867,638298000,2),(867,654624000,3),(867,670352400,2),(867,686073600,3),(867,701802000,2),(867,717523200,3),(867,733251600,2),(867,748972800,3),(867,764701200,2),(867,780422400,3),(867,796150800,2),(867,811872000,3),(867,828205200,2),(867,843926400,3),(867,859654800,2),(867,875376000,3),(867,891104400,2),(867,906825600,3),(867,988398000,2),(867,1001700000,3),(867,1017428400,2),(867,1033149600,3),(867,1048878000,2),(867,1064599200,3),(867,1080327600,2),(867,1096048800,3),(867,1111777200,2),(867,1127498400,3),(867,1143226800,2),(867,1159552800,3),(867,1427482800,2),(867,1443196800,3),(867,1458932400,2),(867,1474646400,3),(867,2147483647,3),(868,-2147483648,1),(868,-1575874625,2),(868,-1247554800,4),(868,354902400,3),(868,370710000,4),(868,386438400,3),(868,402246000,4),(868,417974400,3),(868,433782000,4),(868,449596800,3),(868,465328800,5),(868,481053600,6),(868,496778400,5),(868,512503200,6),(868,528228000,5),(868,543952800,6),(868,559677600,5),(868,575402400,6),(868,591127200,5),(868,606852000,6),(868,622576800,5),(868,638301600,6),(868,654631200,5),(868,670356000,7),(868,686084400,8),(868,695761200,5),(868,701805600,6),(868,717530400,5),(868,733255200,6),(868,748980000,5),(868,764704800,6),(868,780429600,5),(868,796154400,6),(868,811879200,5),(868,828208800,6),(868,846352800,5),(868,859658400,6),(868,877802400,5),(868,891108000,6),(868,909252000,5),(868,922557600,6),(868,941306400,5),(868,954007200,6),(868,972756000,5),(868,985456800,6),(868,1004205600,5),(868,1017511200,6),(868,1035655200,5),(868,1048960800,6),(868,1067104800,5),(868,1080410400,6),(868,1099159200,5),(868,1111860000,6),(868,1130608800,5),(868,1143309600,6),(868,1162058400,5),(868,1174759200,6),(868,1193508000,5),(868,1206813600,6),(868,1224957600,5),(868,1238263200,6),(868,1256407200,5),(868,1269712800,6),(868,1288461600,5),(868,1301162400,9),(868,1414256400,5),(868,2147483647,5),(869,-2147483648,1),(869,-1869875816,3),(869,-1693706400,2),(869,-1680490800,3),(869,-1570413600,2),(869,-1552186800,3),(869,-1538359200,2),(869,-1522551600,3),(869,-1507514400,2),(869,-1490583600,3),(869,-1440208800,2),(869,-1428030000,3),(869,-1409709600,2),(869,-1396494000,3),(869,-931053600,2),(869,-922676400,3),(869,-917834400,2),(869,-892436400,3),(869,-875844000,2),(869,-764737200,3),(869,-744343200,2),(869,-733806000,3),(869,-716436000,2),(869,-701924400,3),(869,-684986400,2),(869,-670474800,3),(869,-654141600,2),(869,-639025200,3),(869,-622087200,2),(869,-606970800,3),(869,-590032800,2),(869,-575521200,3),(869,-235620000,2),(869,-194842800,3),(869,-177732000,2),(869,-165726000,3),(869,107910000,2),(869,121215600,3),(869,133920000,2),(869,152665200,3),(869,164678400,2),(869,184114800,3),(869,196214400,2),(869,215564400,3),(869,228873600,2),(869,245804400,3),(869,260323200,2),(869,267915600,4),(869,428454000,5),(869,433893600,4),(869,468111600,3),(869,482799600,6),(869,496710000,7),(869,512521200,6),(869,528246000,7),(869,543970800,6),(869,559695600,7),(869,575420400,6),(869,591145200,7),(869,606870000,6),(869,622594800,7),(869,638319600,6),(869,654649200,7),(869,670374000,6),(869,686098800,7),(869,701823600,6),(869,717548400,7),(869,733273200,6),(869,748998000,7),(869,764118000,6),(869,780447600,7),(869,796172400,6),(869,811897200,7),(869,828226800,6),(869,846370800,7),(869,859676400,6),(869,877820400,7),(869,891126000,6),(869,909270000,7),(869,922575600,6),(869,941324400,7),(869,954025200,6),(869,972774000,7),(869,985474800,6),(869,1004223600,7),(869,1017529200,6),(869,1035673200,7),(869,1048978800,6),(869,1067122800,7),(869,1080428400,6),(869,1099177200,7),(869,1111878000,6),(869,1130626800,7),(869,1143327600,6),(869,1162076400,7),(869,1167602400,3),(869,1174784400,8),(869,1193533200,9),(869,1206838800,8),(869,1224982800,9),(869,1238288400,8),(869,1256432400,9),(869,1269738000,8),(869,1288486800,9),(869,1301274000,8),(869,1319936400,9),(869,1332637200,8),(869,1351386000,9),(869,1364691600,8),(869,1382835600,9),(869,1396227600,8),(869,1414285200,9),(869,1427590800,8),(869,1446944400,9),(869,1459040400,8),(869,1473195600,4),(869,2147483647,4),(870,-2147483648,1),(870,-1451719200,2),(870,-1172906400,3),(870,-876641400,4),(870,-766054800,3),(870,-683883000,5),(870,-620812800,3),(870,-189415800,6),(871,-2147483648,0),(871,-1172913768,1),(871,-799491600,2),(871,-189423000,3),(872,-2147483648,1),(872,-1641003640,6),(872,-933638400,2),(872,-923097600,3),(872,-919036800,2),(872,-857347200,3),(872,-844300800,2),(872,-825811200,3),(872,-812678400,2),(872,-794188800,3),(872,-779846400,2),(872,-762652800,3),(872,-748310400,2),(872,-731116800,3),(872,-681955200,4),(872,-673228800,2),(872,-667958400,3),(872,-652320000,2),(872,-636422400,3),(872,-622080000,2),(872,-608947200,3),(872,-591840000,2),(872,-572486400,3),(872,-558576000,2),(872,-542851200,3),(872,-527731200,2),(872,-514425600,3),(872,-490838400,2),(872,-482976000,3),(872,-459388800,2),(872,-451526400,3),(872,-428544000,2),(872,-418262400,3),(872,-400118400,2),(872,-387417600,3),(872,142380000,5),(872,150843600,6),(872,167176800,5),(872,178664400,6),(872,334101600,7),(872,337730400,8),(872,452642400,7),(872,462319200,8),(872,482277600,5),(872,494370000,6),(872,516751200,5),(872,526424400,6),(872,545436000,5),(872,558478800,6),(872,576626400,5),(872,589323600,6),(872,609890400,5),(872,620773200,6),(872,638316000,5),(872,651618000,6),(872,669765600,5),(872,683672400,6),(872,701820000,5),(872,715726800,6),(872,733701600,5),(872,747176400,6),(872,765151200,5),(872,778021200,6),(872,796600800,5),(872,810075600,6),(872,826840800,5),(872,842821200,6),(872,858895200,5),(872,874184400,6),(872,890344800,5),(872,905029200,6),(872,923011200,5),(872,936313200,6),(872,955670400,5),(872,970783200,6),(872,986770800,5),(872,1001282400,6),(872,1017356400,5),(872,1033941600,6),(872,1048806000,5),(872,1065132000,6),(872,1081292400,5),(872,1095804000,6),(872,1112313600,5),(872,1128812400,6),(872,1143763200,5),(872,1159657200,6),(872,1175212800,5),(872,1189897200,6),(872,1206662400,5),(872,1223161200,6),(872,1238112000,5),(872,1254006000,6),(872,1269561600,5),(872,1284246000,6),(872,1301616000,5),(872,1317510000,6),(872,1333065600,5),(872,1348354800,6),(872,1364515200,5),(872,1382828400,6),(872,1395964800,5),(872,1414278000,6),(872,1427414400,5),(872,1445727600,6),(872,1458864000,5),(872,1477782000,6),(872,1490313600,5),(872,1509231600,6),(872,1521763200,5),(872,1540681200,6),(872,1553817600,5),(872,1572130800,6),(872,1585267200,5),(872,1603580400,6),(872,1616716800,5),(872,1635634800,6),(872,1648166400,5),(872,1667084400,6),(872,1679616000,5),(872,1698534000,6),(872,1711670400,5),(872,1729983600,6),(872,1743120000,5),(872,1761433200,6),(872,1774569600,5),(872,1792882800,6),(872,1806019200,5),(872,1824937200,6),(872,1837468800,5),(872,1856386800,6),(872,1868918400,5),(872,1887836400,6),(872,1900972800,5),(872,1919286000,6),(872,1932422400,5),(872,1950735600,6),(872,1963872000,5),(872,1982790000,6),(872,1995321600,5),(872,2014239600,6),(872,2026771200,5),(872,2045689200,6),(872,2058220800,5),(872,2077138800,6),(872,2090275200,5),(872,2108588400,6),(872,2121724800,5),(872,2140038000,6),(873,-2147483648,1),(873,-788932800,2),(873,2147483647,2),(874,-2147483648,0),(874,-1487759676,1),(874,-1247569200,3),(874,354888000,2),(874,370695600,3),(874,386424000,2),(874,402231600,3),(874,417960000,2),(874,433767600,3),(874,449582400,2),(874,465314400,4),(874,481039200,5),(874,496764000,4),(874,512488800,5),(874,528213600,4),(874,543938400,5),(874,559663200,4),(874,575388000,5),(874,591112800,4),(874,606837600,5),(874,622562400,4),(874,638287200,5),(874,654616800,4),(874,670341600,6),(874,686070000,7),(874,695746800,4),(874,701791200,5),(874,717516000,4),(874,733240800,5),(874,748965600,4),(874,764690400,5),(874,780415200,4),(874,796140000,5),(874,811864800,4),(874,828194400,5),(874,846338400,4),(874,859644000,5),(874,877788000,4),(874,891093600,5),(874,909237600,4),(874,922543200,5),(874,941292000,4),(874,953992800,5),(874,972741600,4),(874,985442400,5),(874,1004191200,4),(874,1017496800,5),(874,1035640800,4),(874,1048946400,5),(874,1067090400,4),(874,1080396000,5),(874,1099144800,4),(874,1111845600,5),(874,1130594400,4),(874,1143295200,5),(874,1162044000,4),(874,1174744800,5),(874,1193493600,4),(874,1206799200,5),(874,1224943200,4),(874,1238248800,5),(874,1256392800,4),(874,1269698400,6),(874,1288450800,7),(874,1301151600,4),(874,2147483647,4),(875,-2147483648,0),(875,-1988166492,1),(875,-862637400,2),(875,-764145000,1),(875,-576135000,3),(875,38775600,5),(875,1018119600,4),(875,1033840800,5),(875,1212260400,4),(875,1225476000,5),(875,1239735600,4),(875,1257012000,5),(876,-2147483648,0),(876,-1325483420,1),(876,2147483647,1),(877,-2147483648,0),(877,-1577943676,1),(877,504901800,2),(877,2147483647,2),(878,-2147483648,0),(878,-1577943676,1),(878,504901800,2),(878,2147483647,2),(879,-2147483648,0),(879,-1579424533,1),(879,-1247558400,3),(879,354898800,2),(879,370706400,3),(879,386434800,2),(879,402242400,3),(879,417970800,2),(879,433778400,3),(879,449593200,2),(879,465325200,4),(879,481050000,5),(879,496774800,4),(879,512499600,5),(879,528224400,4),(879,543949200,5),(879,559674000,4),(879,575398800,5),(879,591123600,4),(879,606848400,5),(879,622573200,4),(879,638298000,5),(879,654627600,4),(879,670352400,6),(879,686080800,7),(879,695757600,4),(879,701802000,5),(879,717526800,4),(879,733251600,5),(879,748976400,4),(879,764701200,5),(879,780426000,4),(879,796150800,5),(879,811875600,4),(879,828205200,5),(879,846349200,4),(879,859654800,5),(879,877798800,4),(879,891104400,5),(879,909248400,4),(879,922554000,5),(879,941302800,4),(879,954003600,5),(879,972752400,4),(879,985453200,5),(879,1004202000,4),(879,1017507600,5),(879,1035651600,4),(879,1048957200,5),(879,1067101200,4),(879,1072882800,10),(879,1080403200,8),(879,1099152000,9),(879,1111852800,8),(879,1130601600,9),(879,1143302400,8),(879,1162051200,9),(879,1174752000,8),(879,1193500800,9),(879,1206806400,8),(879,1224950400,9),(879,1238256000,8),(879,1256400000,9),(879,1269705600,8),(879,1288454400,9),(879,1301155200,11),(879,1315832400,9),(879,1414252800,4),(879,2147483647,4),(880,-2147483648,1),(880,-2019705670,2),(880,-891581400,3),(880,-872058600,2),(880,-862637400,3),(880,-764145000,2),(881,-2147483648,0),(881,-1577513486,1),(881,-1247551200,3),(881,354906000,2),(881,370713600,3),(881,386442000,2),(881,402249600,3),(881,417978000,2),(881,433785600,3),(881,449600400,2),(881,465332400,4),(881,481057200,5),(881,496782000,4),(881,512506800,5),(881,528231600,4),(881,543956400,5),(881,559681200,4),(881,575406000,5),(881,591130800,4),(881,606855600,5),(881,622580400,4),(881,638305200,5),(881,654634800,4),(881,670359600,6),(881,686088000,7),(881,695764800,4),(881,701809200,5),(881,717534000,4),(881,733258800,5),(881,748983600,4),(881,764708400,5),(881,780433200,4),(881,796158000,5),(881,811882800,4),(881,828212400,5),(881,846356400,4),(881,859662000,5),(881,877806000,4),(881,891111600,5),(881,909255600,4),(881,922561200,5),(881,941310000,4),(881,954010800,5),(881,972759600,4),(881,985460400,5),(881,1004209200,4),(881,1017514800,5),(881,1035658800,4),(881,1048964400,5),(881,1067108400,4),(881,1080414000,5),(881,1099162800,4),(881,1111863600,5),(881,1130612400,4),(881,1143313200,5),(881,1162062000,4),(881,1174762800,5),(881,1193511600,4),(881,1206817200,5),(881,1224961200,4),(881,1238266800,5),(881,1256410800,4),(881,1269716400,5),(881,1288465200,4),(881,1301166000,8),(881,1414260000,4),(881,2147483647,4),(882,-2147483648,1),(882,-2038200925,2),(882,-1167634800,3),(882,-1073028000,4),(882,-894180000,5),(882,-879665400,6),(882,-767005200,5),(882,378662400,7),(882,2147483647,7),(883,-2147483648,0),(883,-1383463280,1),(883,-1167636600,3),(883,-1082448000,2),(883,-1074586800,3),(883,-1050825600,2),(883,-1042964400,3),(883,-1019289600,2),(883,-1011428400,3),(883,-987753600,2),(883,-979892400,3),(883,-956217600,2),(883,-948356400,3),(883,-924595200,2),(883,-916734000,3),(883,-893059200,2),(883,-885198000,3),(883,-879667200,4),(883,-767005200,3),(883,2147483647,3),(884,-2147483648,0),(884,-719636812,1),(884,2147483647,1),(885,-2147483648,0),(885,-2056692850,1),(885,-884509200,3),(885,-873280800,2),(885,-855918000,3),(885,-841744800,2),(885,-828529200,3),(885,-765363600,1),(885,-747046800,4),(885,-733827600,5),(885,-716461200,4),(885,-697021200,5),(885,-683715600,4),(885,-667990800,5),(885,-654771600,4),(885,-636627600,5),(885,-623322000,4),(885,-605178000,5),(885,-591872400,4),(885,-573642000,5),(885,-559818000,4),(885,-541674000,5),(885,-528368400,4),(885,-510224400,5),(885,-498128400,4),(885,-478774800,5),(885,-466678800,4),(885,-446720400,5),(885,-435229200,4),(885,-415258200,1),(885,-403158600,6),(885,-383808600,1),(885,-371709000,6),(885,-352359000,1),(885,-340259400,6),(885,-320909400,1),(885,-308809800,6),(885,-288855000,1),(885,-277360200,6),(885,-257405400,1),(885,-245910600,6),(885,-225955800,1),(885,-213856200,6),(885,-194506200,1),(885,-182406600,6),(885,-163056600,1),(885,-148537800,6),(885,-132820200,1),(885,-117088200,6),(885,-101370600,1),(885,-85638600,6),(885,-69312600,1),(885,-53584200,6),(885,-37863000,1),(885,-22134600,6),(885,-6413400,1),(885,9315000,6),(885,25036200,1),(885,40764600,6),(885,56485800,1),(885,72214200,6),(885,88540200,1),(885,104268600,6),(885,119989800,1),(885,126041400,6),(885,151439400,1),(885,167167800,6),(885,182889000,1),(885,198617400,6),(885,214338600,1),(885,295385400,6),(885,309292200,1),(886,-2147483648,0),(886,-2056692850,1),(886,-884509200,3),(886,-873280800,2),(886,-855918000,3),(886,-841744800,2),(886,-828529200,3),(886,-765363600,1),(886,-747046800,4),(886,-733827600,5),(886,-716461200,4),(886,-697021200,5),(886,-683715600,4),(886,-667990800,5),(886,-654771600,4),(886,-636627600,5),(886,-623322000,4),(886,-605178000,5),(886,-591872400,4),(886,-573642000,5),(886,-559818000,4),(886,-541674000,5),(886,-528368400,4),(886,-510224400,5),(886,-498128400,4),(886,-478774800,5),(886,-466678800,4),(886,-446720400,5),(886,-435229200,4),(886,-415258200,1),(886,-403158600,6),(886,-383808600,1),(886,-371709000,6),(886,-352359000,1),(886,-340259400,6),(886,-320909400,1),(886,-308809800,6),(886,-288855000,1),(886,-277360200,6),(886,-257405400,1),(886,-245910600,6),(886,-225955800,1),(886,-213856200,6),(886,-194506200,1),(886,-182406600,6),(886,-163056600,1),(886,-148537800,6),(886,-132820200,1),(886,-117088200,6),(886,-101370600,1),(886,-85638600,6),(886,-69312600,1),(886,-53584200,6),(886,-37863000,1),(886,-22134600,6),(886,-6413400,1),(886,9315000,6),(886,25036200,1),(886,40764600,6),(886,56485800,1),(886,72214200,6),(886,88540200,1),(886,104268600,6),(886,119989800,1),(886,126041400,6),(886,151439400,1),(886,167167800,6),(886,182889000,1),(886,198617400,6),(886,214338600,1),(886,295385400,6),(886,309292200,1),(887,-2147483648,0),(887,-1441188192,1),(887,-1247565600,3),(887,354891600,2),(887,370699200,3),(887,386427600,2),(887,402235200,3),(887,417963600,2),(887,433771200,3),(887,449586000,2),(887,465318000,4),(887,481042800,5),(887,496767600,4),(887,512492400,5),(887,528217200,4),(887,543942000,5),(887,559666800,4),(887,575391600,5),(887,591116400,4),(887,606841200,5),(887,622566000,4),(887,638290800,5),(887,654620400,4),(887,670345200,6),(887,686073600,7),(887,695750400,4),(887,701794800,5),(887,717519600,4),(887,733244400,5),(887,748969200,4),(887,764694000,5),(887,780418800,4),(887,796143600,5),(887,811868400,4),(887,828198000,5),(887,846342000,4),(887,859647600,5),(887,877791600,4),(887,891097200,5),(887,909241200,4),(887,922546800,5),(887,941295600,4),(887,953996400,5),(887,972745200,4),(887,985446000,5),(887,1004194800,4),(887,1017500400,5),(887,1035644400,4),(887,1048950000,5),(887,1067094000,4),(887,1080399600,5),(887,1099148400,4),(887,1111849200,5),(887,1130598000,4),(887,1143298800,5),(887,1162047600,4),(887,1174748400,5),(887,1193497200,4),(887,1206802800,5),(887,1224946800,4),(887,1238252400,5),(887,1256396400,4),(887,1269702000,5),(887,1288450800,4),(887,1301151600,8),(887,1414245600,7),(887,1461427200,4),(887,2147483647,4),(888,-2147483648,0),(888,-1577951856,1),(888,-1172908656,2),(888,-880272000,3),(888,-766054800,4),(889,-2147483648,2),(889,-1046678400,1),(889,-1038733200,2),(889,-873273600,3),(889,-794221200,2),(889,-496224000,1),(889,-489315600,2),(889,259344000,1),(889,275151600,2),(890,-2147483648,0),(890,-1577936472,1),(890,2147483647,1),(891,-2147483648,0),(891,-1518920008,2),(891,166572000,1),(891,182293200,2),(891,200959200,1),(891,213829200,2),(891,228866400,1),(891,243982800,2),(891,260316000,1),(891,276123600,2),(891,291765600,1),(891,307486800,2),(891,323820000,1),(891,338936400,2),(891,354664800,1),(891,370386000,2),(891,386114400,1),(891,401835600,2),(891,417564000,1),(891,433285200,2),(891,449013600,1),(891,465339600,2),(891,481068000,1),(891,496789200,2),(891,512517600,1),(891,528238800,2),(891,543967200,1),(891,559688400,2),(891,575416800,1),(891,591138000,2),(891,606866400,1),(891,622587600,2),(891,638316000,1),(891,654642000,2),(891,670370400,1),(891,686091600,2),(891,701820000,1),(891,717541200,2),(891,733269600,1),(891,748990800,2),(891,764719200,1),(891,780440400,2),(891,796168800,1),(891,811890000,2),(891,828223200,1),(891,843944400,2),(891,859672800,1),(891,875394000,2),(891,891122400,1),(891,909277200,3),(891,922582800,4),(891,941331600,3),(891,954032400,4),(891,972781200,3),(891,985482000,4),(891,1004230800,3),(891,1017536400,4),(891,1035680400,3),(891,1048986000,4),(891,1067130000,3),(891,1080435600,4),(891,1099184400,3),(891,1111885200,4),(891,1130634000,3),(891,1143334800,4),(891,1162083600,3),(891,1174784400,4),(891,1193533200,3),(891,1206838800,4),(891,1224982800,3),(891,1238288400,4),(891,1256432400,3),(891,1269738000,4),(891,1288486800,3),(891,1301187600,4),(891,1319936400,3),(891,1332637200,4),(891,1351386000,3),(891,1364691600,4),(891,1382835600,3),(891,1396141200,4),(891,1414285200,3),(891,1427590800,4),(891,1445734800,3),(891,1459040400,4),(891,1477789200,3),(891,1490490000,4),(891,1509238800,3),(891,1521939600,4),(891,1540688400,3),(891,1553994000,4),(891,1572138000,3),(891,1585443600,4),(891,1603587600,3),(891,1616893200,4),(891,1635642000,3),(891,1648342800,4),(891,1667091600,3),(891,1679792400,4),(891,1698541200,3),(891,1711846800,4),(891,1729990800,3),(891,1743296400,4),(891,1761440400,3),(891,1774746000,4),(891,1792890000,3),(891,1806195600,4),(891,1824944400,3),(891,1837645200,4),(891,1856394000,3),(891,1869094800,4),(891,1887843600,3),(891,1901149200,4),(891,1919293200,3),(891,1932598800,4),(891,1950742800,3),(891,1964048400,4),(891,1982797200,3),(891,1995498000,4),(891,2014246800,3),(891,2026947600,4),(891,2045696400,3),(891,2058397200,4),(891,2077146000,3),(891,2090451600,4),(891,2108595600,3),(891,2121901200,4),(891,2140045200,3),(892,-2147483648,0),(892,-1441259328,1),(892,-1247551200,3),(892,354906000,2),(892,370713600,3),(892,386442000,2),(892,402249600,3),(892,417978000,2),(892,433785600,3),(892,449600400,2),(892,465332400,4),(892,481057200,5),(892,496782000,4),(892,512506800,5),(892,528231600,4),(892,543956400,5),(892,559681200,4),(892,575406000,5),(892,591130800,4),(892,606855600,5),(892,622580400,4),(892,638305200,5),(892,654634800,4),(892,670359600,6),(892,686088000,7),(892,695764800,4),(892,701809200,5),(892,717534000,4),(892,733258800,5),(892,748983600,4),(892,764708400,5),(892,780433200,4),(892,796158000,5),(892,811882800,4),(892,828212400,5),(892,846356400,4),(892,859662000,5),(892,877806000,4),(892,891111600,5),(892,909255600,4),(892,922561200,5),(892,941310000,4),(892,954010800,5),(892,972759600,4),(892,985460400,5),(892,1004209200,4),(892,1017514800,5),(892,1035658800,4),(892,1048964400,5),(892,1067108400,4),(892,1080414000,5),(892,1099162800,4),(892,1111863600,5),(892,1130612400,4),(892,1143313200,5),(892,1162062000,4),(892,1174762800,5),(892,1193511600,4),(892,1206817200,5),(892,1224961200,4),(892,1238266800,5),(892,1256410800,4),(892,1269716400,6),(892,1288468800,7),(892,1301169600,4),(892,2147483647,4),(893,-2147483648,0),(893,-1579476700,1),(893,-1247551200,3),(893,354906000,2),(893,370713600,3),(893,386442000,2),(893,402249600,3),(893,417978000,2),(893,433785600,3),(893,449600400,2),(893,465332400,4),(893,481057200,5),(893,496782000,4),(893,512506800,5),(893,528231600,4),(893,543956400,5),(893,559681200,4),(893,575406000,5),(893,591130800,4),(893,606855600,5),(893,622580400,4),(893,638305200,5),(893,654634800,4),(893,670359600,6),(893,686088000,7),(893,695764800,4),(893,701809200,5),(893,717534000,4),(893,733258800,5),(893,738086400,8),(893,748987200,7),(893,764712000,6),(893,780436800,7),(893,796161600,6),(893,811886400,7),(893,828216000,6),(893,846360000,7),(893,859665600,6),(893,877809600,7),(893,891115200,6),(893,909259200,7),(893,922564800,6),(893,941313600,7),(893,954014400,6),(893,972763200,7),(893,985464000,6),(893,1004212800,7),(893,1017518400,6),(893,1035662400,7),(893,1048968000,6),(893,1067112000,7),(893,1080417600,6),(893,1099166400,7),(893,1111867200,6),(893,1130616000,7),(893,1143316800,6),(893,1162065600,7),(893,1174766400,6),(893,1193515200,7),(893,1206820800,6),(893,1224964800,7),(893,1238270400,6),(893,1256414400,7),(893,1269720000,6),(893,1288468800,7),(893,1301169600,4),(893,1414263600,7),(893,1469304000,4),(893,2147483647,4),(894,-2147483648,0),(894,-1582088010,1),(894,-1247547600,3),(894,354909600,2),(894,370717200,3),(894,386445600,2),(894,402253200,3),(894,417981600,2),(894,433789200,3),(894,449604000,2),(894,465336000,4),(894,481060800,5),(894,496785600,4),(894,512510400,5),(894,528235200,4),(894,543960000,5),(894,559684800,4),(894,575409600,5),(894,591134400,4),(894,606859200,5),(894,622584000,4),(894,638308800,5),(894,654638400,4),(894,670363200,6),(894,686091600,7),(894,695768400,4),(894,701812800,5),(894,717537600,4),(894,733262400,5),(894,748987200,4),(894,764712000,5),(894,780436800,4),(894,796161600,5),(894,811886400,4),(894,828216000,5),(894,846360000,4),(894,859665600,5),(894,877809600,4),(894,891115200,5),(894,909259200,4),(894,922564800,5),(894,941313600,4),(894,954014400,5),(894,972763200,4),(894,985464000,5),(894,1004212800,4),(894,1017518400,5),(894,1035662400,4),(894,1048968000,5),(894,1067112000,4),(894,1080417600,5),(894,1099166400,4),(894,1111867200,5),(894,1130616000,4),(894,1143316800,5),(894,1162065600,4),(894,1174766400,5),(894,1193515200,4),(894,1206820800,5),(894,1224964800,4),(894,1238270400,5),(894,1256414400,4),(894,1269720000,5),(894,1288468800,4),(894,1301169600,8),(894,1414263600,4),(894,2147483647,4),(895,-2147483648,0),(895,-1441164324,1),(895,-1247540400,2),(895,354913200,3),(895,370720800,4),(895,386445600,3),(895,402256800,2),(895,417985200,3),(895,433792800,2),(895,449607600,3),(895,465339600,5),(895,481064400,6),(895,496789200,5),(895,512514000,6),(895,528238800,5),(895,543963600,6),(895,559688400,5),(895,575413200,6),(895,591138000,5),(895,606862800,7),(895,622591200,8),(895,638316000,7),(895,654645600,8),(895,670370400,7),(895,686095200,8),(895,695772000,5),(895,701816400,7),(895,717544800,8),(895,733269600,7),(895,748994400,8),(895,764719200,7),(895,780444000,8),(895,796168800,7),(895,811893600,8),(895,828223200,7),(895,846367200,8),(895,859672800,7),(895,877816800,8),(895,891122400,7),(895,909266400,8),(895,922572000,7),(895,941320800,8),(895,954021600,7),(895,972770400,8),(895,985471200,7),(895,1004220000,8),(895,1017525600,7),(895,1035669600,8),(895,1048975200,7),(895,1067119200,8),(895,1080424800,7),(895,1099173600,5),(895,2147483647,5),(896,-2147483648,1),(896,-1570084924,2),(896,2147483647,2),(897,-2147483648,0),(897,-1946186240,1),(897,-1172906240,2),(897,-881220600,3),(897,-766054800,2),(897,-683883000,4),(897,-620812800,2),(897,-189415800,5),(897,567964800,6),(898,-2147483648,0),(898,-1948782180,1),(898,-1830414600,2),(898,-768646800,3),(898,1439564400,1),(898,1525446000,3),(899,-2147483648,0),(899,-1577935568,1),(899,76190400,2),(899,2147483647,2),(900,-2147483648,0),(900,-1441167268,1),(900,-1247544000,2),(900,354913200,3),(900,370720800,4),(900,386445600,3),(900,402256800,2),(900,417985200,3),(900,433792800,2),(900,449607600,3),(900,465339600,5),(900,481064400,6),(900,496789200,5),(900,512514000,6),(900,528238800,5),(900,543963600,6),(900,559688400,5),(900,575413200,6),(900,591138000,5),(900,606862800,6),(900,622587600,5),(900,638312400,6),(900,654642000,5),(900,670366800,7),(900,686095200,8),(900,695772000,5),(900,701816400,6),(900,717541200,5),(900,733266000,6),(900,748990800,5),(900,764715600,6),(900,780440400,5),(900,796165200,6),(900,811890000,5),(900,828219600,6),(900,846363600,5),(900,859669200,6),(900,877813200,5),(900,891118800,6),(900,909262800,5),(900,922568400,6),(900,941317200,5),(900,954018000,6),(900,972766800,5),(900,985467600,6),(900,1004216400,5),(900,1017522000,6),(900,1035666000,5),(900,1048971600,6),(900,1067115600,5),(900,1080421200,6),(900,1099170000,9),(900,2147483647,9),(901,-2147483648,0),(901,-1441167712,1),(901,-1247544000,2),(901,354913200,3),(901,370720800,4),(901,386445600,3),(901,402256800,2),(901,417985200,3),(901,433792800,2),(901,449607600,3),(901,465339600,5),(901,481064400,6),(901,496789200,5),(901,512514000,6),(901,528238800,5),(901,543963600,6),(901,559688400,5),(901,575413200,6),(901,591138000,5),(901,606862800,6),(901,622587600,5),(901,638312400,6),(901,654642000,5),(901,670366800,7),(901,686095200,5),(901,695768400,9),(901,701812800,6),(901,717541200,5),(901,733266000,6),(901,748990800,5),(901,764715600,6),(901,780440400,5),(901,796165200,6),(901,811890000,5),(901,828219600,6),(901,846363600,5),(901,859669200,6),(901,877813200,5),(901,891118800,6),(901,909262800,5),(901,922568400,6),(901,941317200,5),(901,954018000,6),(901,972766800,5),(901,985467600,6),(901,1004216400,5),(901,1017522000,6),(901,1035666000,5),(901,1048971600,6),(901,1067115600,5),(901,1080421200,6),(901,1099170000,9),(901,1545328800,2),(901,2147483647,2),(902,-2147483648,1),(902,-1577946287,2),(902,-873268200,3),(902,-778410000,2),(902,2147483647,2),(903,-2147483648,0),(903,-719636812,1),(903,2147483647,1),(904,-2147483648,0),(904,-2004073590,1),(904,-1851577590,2),(904,-852105600,3),(904,-782643600,4),(904,-767869200,2),(904,-718095600,3),(904,-457776000,2),(904,-315648000,3),(904,171820800,2),(904,2147483647,2),(905,-2147483648,0),(905,-2031039048,1),(905,-768560400,3),(905,354891600,2),(905,370699200,3),(905,386427600,2),(905,402235200,3),(905,417963600,2),(905,433771200,3),(905,449586000,2),(905,465318000,4),(905,481042800,5),(905,496767600,4),(905,512492400,5),(905,528217200,4),(905,543942000,5),(905,559666800,4),(905,575391600,5),(905,591116400,4),(905,606841200,5),(905,622566000,4),(905,638290800,5),(905,654620400,4),(905,670345200,6),(905,686073600,7),(905,695750400,4),(905,701794800,5),(905,717519600,4),(905,733244400,5),(905,748969200,4),(905,764694000,5),(905,780418800,4),(905,796143600,5),(905,811868400,4),(905,828198000,5),(905,846342000,4),(905,859647600,6),(905,877795200,7),(905,891100800,6),(905,909244800,7),(905,922550400,6),(905,941299200,7),(905,954000000,6),(905,972748800,7),(905,985449600,6),(905,1004198400,7),(905,1017504000,6),(905,1035648000,7),(905,1048953600,6),(905,1067097600,7),(905,1080403200,6),(905,1099152000,7),(905,1111852800,6),(905,1130601600,7),(905,1143302400,6),(905,1162051200,7),(905,1174752000,6),(905,1193500800,7),(905,1206806400,6),(905,1224950400,7),(905,1238256000,6),(905,1256400000,7),(905,1269705600,6),(905,1288454400,7),(905,1301155200,4),(905,1414249200,7),(905,1459008000,4),(905,2147483647,4),(906,-2147483648,0),(906,-1441168073,1),(906,-1247544000,2),(906,354913200,3),(906,370720800,4),(906,386445600,3),(906,402256800,2),(906,417985200,3),(906,433792800,2),(906,449607600,3),(906,465339600,5),(906,481064400,6),(906,496789200,5),(906,512514000,6),(906,528238800,5),(906,543963600,6),(906,559688400,5),(906,575413200,6),(906,591138000,5),(906,606862800,6),(906,622587600,5),(906,638312400,6),(906,654642000,5),(906,670366800,6),(906,686091600,5),(906,694206000,2),(906,2147483647,2),(907,-2147483648,0),(907,-1948782472,1),(907,-1830414600,2),(907,-767350800,4),(907,-681210000,3),(907,-672228000,4),(907,-654771600,3),(907,-640864800,4),(907,-623408400,3),(907,-609415200,4),(907,-588848400,3),(907,-577965600,4),(907,-498128400,1),(907,-462702600,5),(907,-451733400,1),(907,-429784200,5),(907,-418296600,1),(907,-399544200,5),(907,-387451800,1),(907,-368094600,5),(907,-356002200,1),(907,-336645000,5),(907,-324552600,1),(907,-305195400,5),(907,-293103000,1),(907,-264933000,4),(907,547578000,3),(907,560883600,4),(907,579027600,3),(907,592333200,4),(908,-2147483648,2),(908,-1600675200,1),(908,-1585904400,2),(908,-933667200,1),(908,-922093200,2),(908,-908870400,1),(908,-888829200,2),(908,-881049600,1),(908,-767869200,2),(908,-745833600,1),(908,-733827600,2),(908,-716889600,1),(908,-699613200,2),(908,-683884800,1),(908,-670669200,2),(908,-652348800,1),(908,-650019600,2),(908,515527200,1),(908,527014800,2),(908,545162400,1),(908,558464400,2),(908,577216800,1),(908,589914000,2),(908,608666400,1),(908,621968400,2),(908,640116000,1),(908,653418000,2),(908,671565600,1),(908,684867600,2),(909,-2147483648,1),(909,-2038200925,2),(909,-1167634800,3),(909,-1073028000,4),(909,-894180000,5),(909,-879665400,6),(909,-767005200,5),(909,378662400,7),(909,2147483647,7),(910,-2147483648,0),(910,-1441188892,1),(910,-1247565600,3),(910,354891600,2),(910,370699200,3),(910,386427600,2),(910,402235200,3),(910,417963600,2),(910,433771200,3),(910,449586000,2),(910,465318000,4),(910,481042800,5),(910,496767600,4),(910,512492400,5),(910,528217200,4),(910,543942000,5),(910,559666800,4),(910,575391600,5),(910,591116400,4),(910,606841200,5),(910,622566000,4),(910,638290800,5),(910,654620400,4),(910,670345200,6),(910,686073600,7),(910,695750400,4),(910,701794800,5),(910,717519600,4),(910,733244400,5),(910,748969200,4),(910,764694000,5),(910,780418800,4),(910,796143600,5),(910,811868400,4),(910,828198000,5),(910,846342000,4),(910,859647600,5),(910,877791600,4),(910,891097200,5),(910,909241200,4),(910,922546800,5),(910,941295600,4),(910,953996400,5),(910,972745200,4),(910,985446000,5),(910,1004194800,4),(910,1017500400,5),(910,1035644400,4),(910,1048950000,5),(910,1067094000,4),(910,1080399600,5),(910,1099148400,4),(910,1111849200,5),(910,1130598000,4),(910,1143298800,5),(910,1162047600,4),(910,1174748400,5),(910,1193497200,4),(910,1206802800,5),(910,1224946800,4),(910,1238252400,5),(910,1256396400,4),(910,1269702000,5),(910,1288450800,4),(910,1301151600,8),(910,1414245600,4),(910,2147483647,4),(911,-2147483648,1),(911,-1017820800,2),(911,-766224000,1),(911,-745833600,3),(911,-733827600,1),(911,-716889600,3),(911,-699613200,1),(911,-683884800,3),(911,-670669200,1),(911,-652348800,3),(911,-639133200,1),(911,-620812800,3),(911,-607597200,1),(911,-589276800,3),(911,-576061200,1),(911,-562924800,3),(911,-541760400,1),(911,-528710400,3),(911,-510224400,1),(911,-497174400,3),(911,-478688400,1),(911,-465638400,3),(911,-449830800,1),(911,-434016000,3),(911,-418208400,1),(911,-402480000,3),(911,-386672400,1),(911,-370944000,3),(911,-355136400,1),(911,-339408000,3),(911,-323600400,1),(911,-302515200,3),(911,-291978000,1),(911,-270979200,3),(911,-260442000,1),(911,133977600,3),(911,149785200,1),(911,165513600,3),(911,181321200,1),(911,299606400,3),(911,307551600,1),(912,-2147483648,0),(912,-1441168631,1),(912,-1247547600,3),(912,354909600,2),(912,370717200,3),(912,386445600,2),(912,402253200,3),(912,417981600,2),(912,433789200,3),(912,449604000,2),(912,465336000,4),(912,481060800,5),(912,496785600,4),(912,512510400,5),(912,528235200,4),(912,543960000,5),(912,559684800,4),(912,575409600,5),(912,591134400,4),(912,606859200,5),(912,622584000,4),(912,638308800,5),(912,654638400,4),(912,670363200,6),(912,686091600,7),(912,694206000,1),(912,2147483647,1),(913,-2147483648,1),(913,-1441162751,2),(913,-405140400,4),(913,354916800,3),(913,370724400,4),(913,386452800,3),(913,402260400,4),(913,417988800,3),(913,433796400,4),(913,449611200,3),(913,465343200,5),(913,481068000,6),(913,496792800,5),(913,512517600,6),(913,528242400,5),(913,543967200,6),(913,559692000,5),(913,575416800,6),(913,591141600,5),(913,606866400,6),(913,622591200,5),(913,638316000,6),(913,654645600,5),(913,670370400,7),(913,686098800,8),(913,694213200,2),(913,701816400,9),(913,717537600,2),(913,733266000,9),(913,748987200,2),(913,764715600,9),(913,780436800,4),(913,796161600,3),(913,811882800,4),(913,828216000,3),(913,859662000,3),(913,877806000,4),(913,891115200,3),(913,909255600,4),(913,922564800,3),(913,941310000,4),(913,954014400,3),(913,972759600,4),(913,985464000,3),(913,1004209200,4),(913,1017518400,3),(913,1035658800,4),(913,1048968000,3),(913,1067108400,4),(913,1080417600,3),(913,1088276400,9),(913,1099177200,8),(913,1111878000,4),(913,2147483647,4),(914,-2147483648,0),(914,-1704165944,1),(914,-1090466744,3),(914,227820600,2),(914,246223800,5),(914,259617600,4),(914,271108800,5),(914,283982400,3),(914,296598600,2),(914,306531000,3),(914,322432200,2),(914,338499000,3),(914,673216200,2),(914,685481400,3),(914,701209800,2),(914,717103800,3),(914,732745800,2),(914,748639800,3),(914,764281800,2),(914,780175800,3),(914,795817800,2),(914,811711800,3),(914,827353800,2),(914,843247800,3),(914,858976200,2),(914,874870200,3),(914,890512200,2),(914,906406200,3),(914,922048200,2),(914,937942200,3),(914,953584200,2),(914,969478200,3),(914,985206600,2),(914,1001100600,3),(914,1016742600,2),(914,1032636600,3),(914,1048278600,2),(914,1064172600,3),(914,1079814600,2),(914,1095708600,3),(914,1111437000,2),(914,1127331000,3),(914,1206045000,2),(914,1221939000,3),(914,1237667400,2),(914,1253561400,3),(914,1269203400,2),(914,1285097400,3),(914,1300739400,2),(914,1316633400,3),(914,1332275400,2),(914,1348169400,3),(914,1363897800,2),(914,1379791800,3),(914,1395433800,2),(914,1411327800,3),(914,1426969800,2),(914,1442863800,3),(914,1458505800,2),(914,1474399800,3),(914,1490128200,2),(914,1506022200,3),(914,1521664200,2),(914,1537558200,3),(914,1553200200,2),(914,1569094200,3),(914,1584736200,2),(914,1600630200,3),(914,1616358600,2),(914,1632252600,3),(914,1647894600,2),(914,1663788600,3),(914,2147483647,3),(915,-2147483648,1),(915,-1641003640,6),(915,-933638400,2),(915,-923097600,3),(915,-919036800,2),(915,-857347200,3),(915,-844300800,2),(915,-825811200,3),(915,-812678400,2),(915,-794188800,3),(915,-779846400,2),(915,-762652800,3),(915,-748310400,2),(915,-731116800,3),(915,-681955200,4),(915,-673228800,2),(915,-667958400,3),(915,-652320000,2),(915,-636422400,3),(915,-622080000,2),(915,-608947200,3),(915,-591840000,2),(915,-572486400,3),(915,-558576000,2),(915,-542851200,3),(915,-527731200,2),(915,-514425600,3),(915,-490838400,2),(915,-482976000,3),(915,-459388800,2),(915,-451526400,3),(915,-428544000,2),(915,-418262400,3),(915,-400118400,2),(915,-387417600,3),(915,142380000,5),(915,150843600,6),(915,167176800,5),(915,178664400,6),(915,334101600,7),(915,337730400,8),(915,452642400,7),(915,462319200,8),(915,482277600,5),(915,494370000,6),(915,516751200,5),(915,526424400,6),(915,545436000,5),(915,558478800,6),(915,576626400,5),(915,589323600,6),(915,609890400,5),(915,620773200,6),(915,638316000,5),(915,651618000,6),(915,669765600,5),(915,683672400,6),(915,701820000,5),(915,715726800,6),(915,733701600,5),(915,747176400,6),(915,765151200,5),(915,778021200,6),(915,796600800,5),(915,810075600,6),(915,826840800,5),(915,842821200,6),(915,858895200,5),(915,874184400,6),(915,890344800,5),(915,905029200,6),(915,923011200,5),(915,936313200,6),(915,955670400,5),(915,970783200,6),(915,986770800,5),(915,1001282400,6),(915,1017356400,5),(915,1033941600,6),(915,1048806000,5),(915,1065132000,6),(915,1081292400,5),(915,1095804000,6),(915,1112313600,5),(915,1128812400,6),(915,1143763200,5),(915,1159657200,6),(915,1175212800,5),(915,1189897200,6),(915,1206662400,5),(915,1223161200,6),(915,1238112000,5),(915,1254006000,6),(915,1269561600,5),(915,1284246000,6),(915,1301616000,5),(915,1317510000,6),(915,1333065600,5),(915,1348354800,6),(915,1364515200,5),(915,1382828400,6),(915,1395964800,5),(915,1414278000,6),(915,1427414400,5),(915,1445727600,6),(915,1458864000,5),(915,1477782000,6),(915,1490313600,5),(915,1509231600,6),(915,1521763200,5),(915,1540681200,6),(915,1553817600,5),(915,1572130800,6),(915,1585267200,5),(915,1603580400,6),(915,1616716800,5),(915,1635634800,6),(915,1648166400,5),(915,1667084400,6),(915,1679616000,5),(915,1698534000,6),(915,1711670400,5),(915,1729983600,6),(915,1743120000,5),(915,1761433200,6),(915,1774569600,5),(915,1792882800,6),(915,1806019200,5),(915,1824937200,6),(915,1837468800,5),(915,1856386800,6),(915,1868918400,5),(915,1887836400,6),(915,1900972800,5),(915,1919286000,6),(915,1932422400,5),(915,1950735600,6),(915,1963872000,5),(915,1982790000,6),(915,1995321600,5),(915,2014239600,6),(915,2026771200,5),(915,2045689200,6),(915,2058220800,5),(915,2077138800,6),(915,2090275200,5),(915,2108588400,6),(915,2121724800,5),(915,2140038000,6),(916,-2147483648,0),(916,-706341516,1),(916,560025000,2),(916,2147483647,2),(917,-2147483648,0),(917,-706341516,1),(917,560025000,2),(917,2147483647,2),(918,-2147483648,3),(918,-683802000,1),(918,-672310800,2),(918,-654771600,1),(918,-640861200,2),(918,-620298000,1),(918,-609411600,2),(918,-588848400,1),(918,-577962000,2),(919,-2147483648,0),(919,-1578807591,1),(919,-1247551200,3),(919,354906000,2),(919,370713600,3),(919,386442000,2),(919,402249600,3),(919,417978000,2),(919,433785600,3),(919,449600400,2),(919,465332400,4),(919,481057200,5),(919,496782000,4),(919,512506800,5),(919,528231600,4),(919,543956400,5),(919,559681200,4),(919,575406000,5),(919,591130800,4),(919,606855600,5),(919,622580400,4),(919,638305200,5),(919,654634800,4),(919,670359600,6),(919,686088000,7),(919,695764800,4),(919,701809200,5),(919,717534000,4),(919,733258800,5),(919,748983600,4),(919,764708400,5),(919,780433200,4),(919,796158000,5),(919,811882800,4),(919,828212400,5),(919,846356400,4),(919,859662000,5),(919,877806000,4),(919,891111600,5),(919,909255600,4),(919,922561200,5),(919,941310000,4),(919,954010800,5),(919,972759600,4),(919,985460400,5),(919,1004209200,4),(919,1017514800,5),(919,1020193200,8),(919,1035662400,7),(919,1048968000,6),(919,1067112000,7),(919,1080417600,6),(919,1099166400,7),(919,1111867200,6),(919,1130616000,7),(919,1143316800,6),(919,1162065600,7),(919,1174766400,6),(919,1193515200,7),(919,1206820800,6),(919,1224964800,7),(919,1238270400,6),(919,1256414400,7),(919,1269720000,6),(919,1288468800,7),(919,1301169600,4),(919,1414263600,7),(919,1464465600,4),(919,2147483647,4),(920,-2147483648,0),(920,-1577951856,1),(920,-1172908656,2),(920,-880272000,3),(920,-766054800,4),(921,-2147483648,0),(921,-2032931252,1),(921,252435600,3),(921,417974400,2),(921,433782000,3),(921,449596800,2),(921,465318000,3),(921,481046400,2),(921,496767600,3),(921,512496000,2),(921,528217200,3),(921,543945600,2),(921,559666800,3),(921,575395200,2),(921,591116400,3),(921,606844800,2),(921,622566000,3),(921,638294400,2),(921,654620400,3),(921,670348800,2),(921,686070000,3),(921,701798400,2),(921,717519600,3),(921,733248000,2),(921,748969200,3),(921,764697600,2),(921,780418800,3),(921,796147200,2),(921,811868400,3),(921,828201600,2),(921,843922800,3),(921,859651200,2),(921,875372400,3),(921,891100800,2),(921,906822000,3),(921,988394400,2),(921,1001696400,3),(921,1017424800,2),(921,1033146000,3),(921,1048874400,2),(921,1064595600,3),(921,1080324000,2),(921,1096045200,3),(921,1111773600,2),(921,1127494800,3),(921,1143223200,2),(921,1159549200,3),(921,1427479200,2),(921,1443193200,3),(921,1458928800,2),(921,1474642800,3),(921,2147483647,3),(922,-2147483648,0),(922,-2032931252,1),(922,252435600,3),(922,417974400,2),(922,433782000,3),(922,449596800,2),(922,465318000,3),(922,481046400,2),(922,496767600,3),(922,512496000,2),(922,528217200,3),(922,543945600,2),(922,559666800,3),(922,575395200,2),(922,591116400,3),(922,606844800,2),(922,622566000,3),(922,638294400,2),(922,654620400,3),(922,670348800,2),(922,686070000,3),(922,701798400,2),(922,717519600,3),(922,733248000,2),(922,748969200,3),(922,764697600,2),(922,780418800,3),(922,796147200,2),(922,811868400,3),(922,828201600,2),(922,843922800,3),(922,859651200,2),(922,875372400,3),(922,891100800,2),(922,906822000,3),(922,988394400,2),(922,1001696400,3),(922,1017424800,2),(922,1033146000,3),(922,1048874400,2),(922,1064595600,3),(922,1080324000,2),(922,1096045200,3),(922,1111773600,2),(922,1127494800,3),(922,1143223200,2),(922,1159549200,3),(922,1427479200,2),(922,1443193200,3),(922,1458928800,2),(922,1474642800,3),(922,2147483647,3),(923,-2147483648,0),(923,-1325483420,1),(923,2147483647,1),(924,-2147483648,0),(924,-1579426374,1),(924,-1247558400,2),(924,354898800,4),(924,370699200,3),(924,386427600,4),(924,402235200,3),(924,417963600,4),(924,433771200,3),(924,449586000,4),(924,465318000,5),(924,481042800,6),(924,496767600,5),(924,512492400,6),(924,528217200,5),(924,543942000,6),(924,559666800,5),(924,575391600,6),(924,591116400,5),(924,606841200,6),(924,622566000,5),(924,638290800,6),(924,654620400,5),(924,670345200,7),(924,686073600,8),(924,695750400,5),(924,701794800,6),(924,717519600,5),(924,733244400,6),(924,748969200,5),(924,764694000,6),(924,780418800,5),(924,796143600,6),(924,811868400,5),(924,828198000,6),(924,846342000,5),(924,859647600,6),(924,877791600,5),(924,891097200,6),(924,909241200,5),(924,922546800,6),(924,941295600,5),(924,953996400,6),(924,972745200,5),(924,985446000,6),(924,1004194800,5),(924,1017500400,6),(924,1035644400,5),(924,1048950000,6),(924,1067094000,5),(924,1080399600,6),(924,1099148400,5),(924,1111849200,6),(924,1130598000,5),(924,1143298800,6),(924,1162047600,5),(924,1174748400,6),(924,1193497200,5),(924,1206802800,6),(924,1224946800,5),(924,1238252400,6),(924,1256396400,5),(924,1269702000,6),(924,1288450800,5),(924,1301151600,9),(924,1315828800,5),(924,1414249200,8),(924,2147483647,8),(925,-2147483648,1),(925,-1570084924,2),(925,2147483647,2),(926,-2147483648,0),(926,-1487321251,1),(926,-1247562000,3),(926,354895200,2),(926,370702800,3),(926,386431200,2),(926,402238800,3),(926,417967200,2),(926,433774800,3),(926,449589600,2),(926,465321600,4),(926,481046400,5),(926,496771200,4),(926,512496000,5),(926,528220800,4),(926,543945600,5),(926,559670400,4),(926,575395200,5),(926,591120000,4),(926,606844800,5),(926,622569600,4),(926,638294400,5),(926,654624000,4),(926,670348800,6),(926,686077200,7),(926,695754000,4),(926,701798400,5),(926,717523200,4),(926,733248000,5),(926,748972800,4),(926,764697600,5),(926,780422400,4),(926,796147200,5),(926,811872000,4),(926,828201600,5),(926,846345600,4),(926,859651200,5),(926,877795200,4),(926,891100800,5),(926,909244800,4),(926,922550400,5),(926,941299200,4),(926,954000000,5),(926,972748800,4),(926,985449600,5),(926,1004198400,4),(926,1017504000,5),(926,1035648000,4),(926,1048953600,5),(926,1067097600,4),(926,1080403200,5),(926,1099152000,4),(926,1111852800,5),(926,1130601600,4),(926,1143302400,5),(926,1162051200,4),(926,1174752000,5),(926,1193500800,4),(926,1206806400,5),(926,1224950400,4),(926,1238256000,5),(926,1256400000,4),(926,1269705600,5),(926,1288454400,4),(926,1301155200,8),(926,1414249200,4),(926,2147483647,4),(927,-2147483648,0),(927,-1579423138,1),(927,-1247558400,3),(927,354898800,2),(927,370706400,3),(927,386434800,2),(927,402242400,3),(927,417970800,2),(927,433778400,3),(927,449593200,2),(927,465325200,4),(927,481050000,5),(927,496774800,4),(927,512499600,5),(927,528224400,4),(927,543949200,5),(927,559674000,4),(927,575398800,5),(927,591123600,4),(927,606848400,5),(927,622573200,4),(927,638298000,5),(927,654627600,4),(927,670352400,6),(927,686080800,7),(927,695757600,4),(927,701802000,5),(927,717526800,4),(927,733251600,5),(927,748976400,4),(927,764701200,5),(927,780426000,4),(927,796150800,5),(927,811875600,4),(927,828205200,5),(927,846349200,4),(927,859654800,5),(927,877798800,4),(927,891104400,5),(927,909248400,4),(927,922554000,5),(927,941302800,4),(927,954003600,5),(927,972752400,4),(927,985453200,5),(927,1004202000,4),(927,1017507600,5),(927,1035651600,4),(927,1048957200,5),(927,1067101200,4),(927,1080406800,5),(927,1099155600,4),(927,1111856400,5),(927,1130605200,4),(927,1143306000,5),(927,1162054800,4),(927,1174755600,5),(927,1193504400,4),(927,1206810000,5),(927,1224954000,4),(927,1238259600,5),(927,1256403600,4),(927,1269709200,5),(927,1288458000,4),(927,1301158800,8),(927,1414252800,4),(927,2147483647,4),(928,-2147483648,1),(928,-1577946287,2),(928,-873268200,3),(928,-778410000,2),(928,2147483647,2),(929,-2147483648,0),(929,-1688270553,1),(929,-1592610305,2),(929,-1247544000,4),(929,354913200,3),(929,370720800,4),(929,386449200,3),(929,402256800,4),(929,417985200,3),(929,433792800,4),(929,449607600,3),(929,465339600,5),(929,481064400,6),(929,496789200,5),(929,512514000,6),(929,528238800,5),(929,543963600,6),(929,559688400,5),(929,575413200,6),(929,591138000,5),(929,606862800,6),(929,622587600,5),(929,638312400,6),(929,654642000,5),(929,670366800,7),(929,686095200,8),(929,695772000,5),(929,701816400,6),(929,717541200,5),(929,733266000,6),(929,748990800,5),(929,764715600,6),(929,780440400,5),(929,796165200,6),(929,811890000,5),(929,828219600,6),(929,846363600,5),(929,859669200,6),(929,877813200,5),(929,891118800,6),(929,909262800,5),(929,922568400,6),(929,941317200,5),(929,954018000,6),(929,972766800,5),(929,985467600,6),(929,1004216400,5),(929,1017522000,6),(929,1035666000,5),(929,1048971600,6),(929,1067115600,5),(929,1080421200,6),(929,1099170000,5),(929,1111870800,6),(929,1130619600,5),(929,1143320400,6),(929,1162069200,5),(929,1174770000,6),(929,1193518800,5),(929,1206824400,6),(929,1224968400,5),(929,1238274000,6),(929,1256418000,5),(929,1269723600,6),(929,1288472400,5),(929,1301173200,9),(929,1414267200,5),(929,2147483647,5),(930,-2147483648,0),(930,-1441162680,1),(930,-405140400,3),(930,354916800,2),(930,370724400,3),(930,386452800,2),(930,402260400,3),(930,417988800,2),(930,433796400,3),(930,449611200,2),(930,465343200,4),(930,481068000,5),(930,496792800,4),(930,512517600,5),(930,528242400,4),(930,543967200,5),(930,559692000,4),(930,575416800,5),(930,591141600,4),(930,606866400,5),(930,622591200,4),(930,638316000,5),(930,654645600,4),(930,670370400,6),(930,686098800,7),(930,701823600,6),(930,717548400,7),(930,733273200,6),(930,748998000,7),(930,764722800,6),(930,780447600,7),(930,796172400,6),(930,811897200,4),(930,852062400,3),(930,859672800,5),(930,877816800,4),(930,891122400,5),(930,909266400,4),(930,922572000,5),(930,941320800,4),(930,954021600,5),(930,972770400,4),(930,985471200,5),(930,1004220000,4),(930,1017525600,5),(930,1035669600,4),(930,1048975200,5),(930,1067119200,4),(930,1080424800,5),(930,1099173600,4),(930,1111874400,5),(930,1130623200,4),(930,1143324000,5),(930,1162072800,4),(930,1174773600,5),(930,1193522400,4),(930,1206828000,5),(930,1224972000,4),(930,1238277600,5),(930,1256421600,4),(930,1269727200,5),(930,1288476000,4),(930,1293825600,3),(930,1301176800,5),(930,1319925600,4),(930,2147483647,4),(931,-2147483648,1),(931,-1830376800,6),(931,-1689548400,2),(931,-1677794400,3),(931,-1667430000,4),(931,-1647730800,5),(931,-1635807600,4),(931,-1616194800,5),(931,-1604358000,4),(931,-1584658800,5),(931,-1572735600,4),(931,-1553036400,5),(931,-1541199600,4),(931,-1521500400,5),(931,-1442444400,4),(931,-1426806000,5),(931,-1379286000,4),(931,-1364770800,5),(931,-1348441200,4),(931,-1333321200,5),(931,-1316386800,4),(931,-1301266800,5),(931,-1284332400,4),(931,-1269817200,5),(931,-1221433200,4),(931,-1206918000,5),(931,-1191193200,4),(931,-1175468400,5),(931,-1127689200,4),(931,-1111964400,5),(931,-1096844400,4),(931,-1080514800,5),(931,-1063580400,4),(931,-1049065200,5),(931,-1033340400,4),(931,-1017615600,5),(931,-1002495600,4),(931,-986166000,5),(931,-969231600,4),(931,-950482800,5),(931,-942015600,4),(931,-922662000,5),(931,-906937200,4),(931,-891126000,5),(931,-877302000,4),(931,-873676800,7),(931,-864000000,4),(931,-857948400,5),(931,-845852400,4),(931,-842832000,7),(931,-831340800,4),(931,-825894000,5),(931,-814402800,4),(931,-810777600,7),(931,-799891200,4),(931,-794444400,5),(931,-782953200,4),(931,-779328000,7),(931,-768441600,4),(931,-762994800,5),(931,-749084400,4),(931,-733359600,5),(931,-717624000,4),(931,-701899200,5),(931,-686174400,4),(931,-670449600,5),(931,-654724800,4),(931,-639000000,5),(931,-623275200,4),(931,-607550400,5),(931,-591825600,4),(931,-575496000,5),(931,-559771200,4),(931,-544046400,5),(931,-528321600,4),(931,-512596800,5),(931,-496872000,4),(931,-481147200,5),(931,-465422400,4),(931,-449697600,5),(931,-433972800,4),(931,-417643200,5),(931,-401918400,4),(931,-386193600,5),(931,-370468800,4),(931,-354744000,5),(931,-339019200,4),(931,-323294400,5),(931,-307569600,4),(931,-291844800,5),(931,-276120000,4),(931,-260395200,5),(931,-244670400,4),(931,-228340800,5),(931,-212616000,4),(931,-196891200,5),(931,-181166400,4),(931,-165441600,5),(931,-149716800,4),(931,-133992000,5),(931,-118267200,9),(931,228272400,7),(931,243997200,8),(931,260326800,7),(931,276051600,8),(931,291776400,7),(931,307504800,8),(931,323226000,7),(931,338954400,8),(931,354679200,7),(931,370404000,8),(931,386128800,7),(931,401853600,8),(931,417582000,7),(931,433303200,8),(931,449028000,7),(931,465357600,8),(931,481082400,7),(931,496807200,8),(931,512532000,7),(931,528256800,8),(931,543981600,7),(931,559706400,8),(931,575431200,7),(931,591156000,8),(931,606880800,7),(931,622605600,8),(931,638330400,7),(931,654660000,8),(931,670384800,7),(931,686109600,8),(931,701834400,7),(931,717559200,10),(931,733280400,11),(931,749005200,12),(931,764730000,11),(931,780454800,12),(931,796179600,11),(931,811904400,12),(931,828234000,11),(931,846378000,12),(931,859683600,11),(931,877827600,12),(931,891133200,11),(931,909277200,12),(931,922582800,11),(931,941331600,12),(931,954032400,11),(931,972781200,12),(931,985482000,11),(931,1004230800,12),(931,1017536400,11),(931,1035680400,12),(931,1048986000,11),(931,1067130000,12),(931,1080435600,11),(931,1099184400,12),(931,1111885200,11),(931,1130634000,12),(931,1143334800,11),(931,1162083600,12),(931,1174784400,11),(931,1193533200,12),(931,1206838800,11),(931,1224982800,12),(931,1238288400,11),(931,1256432400,12),(931,1269738000,11),(931,1288486800,12),(931,1301187600,11),(931,1319936400,12),(931,1332637200,11),(931,1351386000,12),(931,1364691600,11),(931,1382835600,12),(931,1396141200,11),(931,1414285200,12),(931,1427590800,11),(931,1445734800,12),(931,1459040400,11),(931,1477789200,12),(931,1490490000,11),(931,1509238800,12),(931,1521939600,11),(931,1540688400,12),(931,1553994000,11),(931,1572138000,12),(931,1585443600,11),(931,1603587600,12),(931,1616893200,11),(931,1635642000,12),(931,1648342800,11),(931,1667091600,12),(931,1679792400,11),(931,1698541200,12),(931,1711846800,11),(931,1729990800,12),(931,1743296400,11),(931,1761440400,12),(931,1774746000,11),(931,1792890000,12),(931,1806195600,11),(931,1824944400,12),(931,1837645200,11),(931,1856394000,12),(931,1869094800,11),(931,1887843600,12),(931,1901149200,11),(931,1919293200,12),(931,1932598800,11),(931,1950742800,12),(931,1964048400,11),(931,1982797200,12),(931,1995498000,11),(931,2014246800,12),(931,2026947600,11),(931,2045696400,12),(931,2058397200,11),(931,2077146000,12),(931,2090451600,11),(931,2108595600,12),(931,2121901200,11),(931,2140045200,12),(931,2147483647,12),(932,-2147483648,2),(932,-1664307642,1),(932,-1648932042,2),(932,-1632080442,1),(932,-1618692042,2),(932,-1262281242,4),(932,-882727200,3),(932,-858538800,4),(932,-845229600,3),(932,-825879600,4),(932,-814384800,3),(932,-793825200,4),(932,-782935200,3),(932,-762375600,4),(932,-713988000,3),(932,-703710000,4),(932,-681933600,3),(932,-672865200,4),(932,-650484000,3),(932,-641415600,4),(932,-618429600,3),(932,-609966000,4),(932,-586980000,3),(932,-578516400,4),(932,-555530400,3),(932,-546462000,4),(932,-429127200,3),(932,-415825200,4),(932,136360800,3),(932,152082000,4),(932,167810400,3),(932,183531600,4),(932,199260000,3),(932,215586000,4),(932,230709600,3),(932,247035600,4),(932,262764000,3),(932,278485200,4),(932,294213600,3),(932,309934800,4),(932,325663200,3),(932,341384400,4),(932,357112800,3),(932,372834000,4),(932,388562400,3),(932,404888400,4),(932,420012000,3),(932,436338000,4),(932,452066400,3),(932,467787600,4),(932,483516000,3),(932,499237200,4),(932,514965600,3),(932,530686800,4),(932,544600800,3),(932,562136400,4),(932,576050400,3),(932,594190800,4),(932,607500000,3),(932,625640400,4),(932,638949600,3),(932,657090000,4),(932,671004000,3),(932,688539600,4),(932,702453600,3),(932,719989200,4),(932,733903200,3),(932,752043600,4),(932,765352800,3),(932,783493200,4),(932,796802400,3),(932,814942800,4),(932,828856800,3),(932,846392400,4),(932,860306400,3),(932,877842000,4),(932,891756000,3),(932,909291600,4),(932,923205600,3),(932,941346000,4),(932,954655200,3),(932,972795600,4),(932,986104800,3),(932,1004245200,4),(932,1018159200,3),(932,1035694800,4),(932,1049608800,3),(932,1067144400,4),(932,1081058400,3),(932,1099198800,4),(932,1112508000,3),(932,1130648400,4),(932,1143957600,3),(932,1162098000,4),(932,1173592800,3),(932,1194152400,4),(932,1205042400,3),(932,1225602000,4),(932,1236492000,3),(932,1257051600,4),(932,1268546400,3),(932,1289106000,4),(932,1299996000,3),(932,1320555600,4),(932,1331445600,3),(932,1352005200,4),(932,1362895200,3),(932,1383454800,4),(932,1394344800,3),(932,1414904400,4),(932,1425794400,3),(932,1446354000,4),(932,1457848800,3),(932,1478408400,4),(932,1489298400,3),(932,1509858000,4),(932,1520748000,3),(932,1541307600,4),(932,1552197600,3),(932,1572757200,4),(932,1583647200,3),(932,1604206800,4),(932,1615701600,3),(932,1636261200,4),(932,1647151200,3),(932,1667710800,4),(932,1678600800,3),(932,1699160400,4),(932,1710050400,3),(932,1730610000,4),(932,1741500000,3),(932,1762059600,4),(932,1772949600,3),(932,1793509200,4),(932,1805004000,3),(932,1825563600,4),(932,1836453600,3),(932,1857013200,4),(932,1867903200,3),(932,1888462800,4),(932,1899352800,3),(932,1919912400,4),(932,1930802400,3),(932,1951362000,4),(932,1962856800,3),(932,1983416400,4),(932,1994306400,3),(932,2014866000,4),(932,2025756000,3),(932,2046315600,4),(932,2057205600,3),(932,2077765200,4),(932,2088655200,3),(932,2109214800,4),(932,2120104800,3),(932,2140664400,4),(933,-2147483648,0),(933,-1509663504,1),(933,-733874400,2),(933,323827200,3),(933,338950800,4),(933,354675600,5),(933,370400400,4),(933,386125200,5),(933,401850000,4),(933,417574800,5),(933,433299600,4),(933,449024400,5),(933,465354000,4),(933,481078800,5),(933,496803600,4),(933,512528400,5),(933,528253200,4),(933,543978000,5),(933,559702800,4),(933,575427600,5),(933,591152400,4),(933,606877200,5),(933,622602000,4),(933,638326800,5),(933,654656400,4),(933,670381200,5),(933,686106000,4),(933,701830800,5),(933,717555600,4),(933,733280400,5),(933,749005200,4),(933,764730000,5),(933,780454800,4),(933,796179600,5),(933,811904400,4),(933,828234000,5),(933,846378000,4),(933,859683600,5),(933,877827600,4),(933,891133200,5),(933,909277200,4),(933,922582800,5),(933,941331600,4),(933,954032400,5),(933,972781200,4),(933,985482000,5),(933,1004230800,4),(933,1017536400,5),(933,1035680400,4),(933,1048986000,5),(933,1067130000,4),(933,1080435600,5),(933,1099184400,4),(933,1111885200,5),(933,1130634000,4),(933,1143334800,5),(933,1162083600,4),(933,1174784400,5),(933,1193533200,4),(933,1206838800,5),(933,1224982800,4),(933,1238288400,5),(933,1256432400,4),(933,1269738000,5),(933,1288486800,4),(933,1301187600,5),(933,1319936400,4),(933,1332637200,5),(933,1351386000,4),(933,1364691600,5),(933,1382835600,4),(933,1396141200,5),(933,1414285200,4),(933,1427590800,5),(933,1445734800,4),(933,1459040400,5),(933,1477789200,4),(933,1490490000,5),(933,1509238800,4),(933,1521939600,5),(933,1540688400,4),(933,1553994000,5),(933,1572138000,4),(933,1585443600,5),(933,1603587600,4),(933,1616893200,5),(933,1635642000,4),(933,1648342800,5),(933,1667091600,4),(933,1679792400,5),(933,1698541200,4),(933,1711846800,5),(933,1729990800,4),(933,1743296400,5),(933,1761440400,4),(933,1774746000,5),(933,1792890000,4),(933,1806195600,5),(933,1824944400,4),(933,1837645200,5),(933,1856394000,4),(933,1869094800,5),(933,1887843600,4),(933,1901149200,5),(933,1919293200,4),(933,1932598800,5),(933,1950742800,4),(933,1964048400,5),(933,1982797200,4),(933,1995498000,5),(933,2014246800,4),(933,2026947600,5),(933,2045696400,4),(933,2058397200,5),(933,2077146000,4),(933,2090451600,5),(933,2108595600,4),(933,2121901200,5),(933,2140045200,4),(934,-2147483648,0),(934,-1830376800,1),(934,-862610400,2),(934,-764118000,3),(934,186120000,4),(934,2147483647,4),(935,-2147483648,0),(935,-1955748776,1),(935,354675600,2),(935,370400400,3),(935,386125200,2),(935,401850000,3),(935,417574800,2),(935,433299600,3),(935,449024400,2),(935,465354000,3),(935,481078800,2),(935,496803600,3),(935,512528400,2),(935,528253200,3),(935,543978000,2),(935,559702800,3),(935,575427600,2),(935,591152400,3),(935,606877200,2),(935,622602000,3),(935,638326800,2),(935,654656400,3),(935,670381200,2),(935,686106000,3),(935,701830800,2),(935,717555600,3),(935,733280400,2),(935,749005200,3),(935,764730000,2),(935,780454800,3),(935,796179600,2),(935,811904400,3),(935,828234000,2),(935,846378000,3),(935,859683600,2),(935,877827600,3),(935,891133200,2),(935,909277200,3),(935,922582800,2),(935,941331600,3),(935,954032400,2),(935,972781200,3),(935,985482000,2),(935,1004230800,3),(935,1017536400,2),(935,1035680400,3),(935,1048986000,2),(935,1067130000,3),(935,1080435600,2),(935,1099184400,3),(935,1111885200,2),(935,1130634000,3),(935,1143334800,2),(935,1162083600,3),(935,1174784400,2),(935,1193533200,3),(935,1206838800,2),(935,1224982800,3),(935,1238288400,2),(935,1256432400,3),(935,1269738000,2),(935,1288486800,3),(935,1301187600,2),(935,1319936400,3),(935,1332637200,2),(935,1351386000,3),(935,1364691600,2),(935,1382835600,3),(935,1396141200,2),(935,1414285200,3),(935,1427590800,2),(935,1445734800,3),(935,1459040400,2),(935,1477789200,3),(935,1490490000,2),(935,1509238800,3),(935,1521939600,2),(935,1540688400,3),(935,1553994000,2),(935,1572138000,3),(935,1585443600,2),(935,1603587600,3),(935,1616893200,2),(935,1635642000,3),(935,1648342800,2),(935,1667091600,3),(935,1679792400,2),(935,1698541200,3),(935,1711846800,2),(935,1729990800,3),(935,1743296400,2),(935,1761440400,3),(935,1774746000,2),(935,1792890000,3),(935,1806195600,2),(935,1824944400,3),(935,1837645200,2),(935,1856394000,3),(935,1869094800,2),(935,1887843600,3),(935,1901149200,2),(935,1919293200,3),(935,1932598800,2),(935,1950742800,3),(935,1964048400,2),(935,1982797200,3),(935,1995498000,2),(935,2014246800,3),(935,2026947600,2),(935,2045696400,3),(935,2058397200,2),(935,2077146000,3),(935,2090451600,2),(935,2108595600,3),(935,2121901200,2),(935,2140045200,3),(936,-2147483648,0),(936,-1955748776,1),(936,354675600,2),(936,370400400,3),(936,386125200,2),(936,401850000,3),(936,417574800,2),(936,433299600,3),(936,449024400,2),(936,465354000,3),(936,481078800,2),(936,496803600,3),(936,512528400,2),(936,528253200,3),(936,543978000,2),(936,559702800,3),(936,575427600,2),(936,591152400,3),(936,606877200,2),(936,622602000,3),(936,638326800,2),(936,654656400,3),(936,670381200,2),(936,686106000,3),(936,701830800,2),(936,717555600,3),(936,733280400,2),(936,749005200,3),(936,764730000,2),(936,780454800,3),(936,796179600,2),(936,811904400,3),(936,828234000,2),(936,846378000,3),(936,859683600,2),(936,877827600,3),(936,891133200,2),(936,909277200,3),(936,922582800,2),(936,941331600,3),(936,954032400,2),(936,972781200,3),(936,985482000,2),(936,1004230800,3),(936,1017536400,2),(936,1035680400,3),(936,1048986000,2),(936,1067130000,3),(936,1080435600,2),(936,1099184400,3),(936,1111885200,2),(936,1130634000,3),(936,1143334800,2),(936,1162083600,3),(936,1174784400,2),(936,1193533200,3),(936,1206838800,2),(936,1224982800,3),(936,1238288400,2),(936,1256432400,3),(936,1269738000,2),(936,1288486800,3),(936,1301187600,2),(936,1319936400,3),(936,1332637200,2),(936,1351386000,3),(936,1364691600,2),(936,1382835600,3),(936,1396141200,2),(936,1414285200,3),(936,1427590800,2),(936,1445734800,3),(936,1459040400,2),(936,1477789200,3),(936,1490490000,2),(936,1509238800,3),(936,1521939600,2),(936,1540688400,3),(936,1553994000,2),(936,1572138000,3),(936,1585443600,2),(936,1603587600,3),(936,1616893200,2),(936,1635642000,3),(936,1648342800,2),(936,1667091600,3),(936,1679792400,2),(936,1698541200,3),(936,1711846800,2),(936,1729990800,3),(936,1743296400,2),(936,1761440400,3),(936,1774746000,2),(936,1792890000,3),(936,1806195600,2),(936,1824944400,3),(936,1837645200,2),(936,1856394000,3),(936,1869094800,2),(936,1887843600,3),(936,1901149200,2),(936,1919293200,3),(936,1932598800,2),(936,1950742800,3),(936,1964048400,2),(936,1982797200,3),(936,1995498000,2),(936,2014246800,3),(936,2026947600,2),(936,2045696400,3),(936,2058397200,2),(936,2077146000,3),(936,2090451600,2),(936,2108595600,3),(936,2121901200,2),(936,2140045200,3),(937,-2147483648,2),(937,-1693706400,1),(937,-1680483600,2),(937,-1663455600,3),(937,-1650150000,4),(937,-1632006000,3),(937,-1618700400,4),(937,-938905200,3),(937,-857257200,4),(937,-844556400,3),(937,-828226800,4),(937,-812502000,3),(937,-796777200,4),(937,-781052400,3),(937,-776563200,5),(937,-765936000,1),(937,-761180400,4),(937,-757386000,2),(937,-748479600,3),(937,-733273200,4),(937,-717631200,3),(937,-714610800,6),(937,-710380800,1),(937,-701910000,4),(937,-684975600,3),(937,-670460400,4),(937,-654130800,3),(937,-639010800,4),(937,315529200,2),(937,323830800,7),(937,338950800,8),(937,354675600,7),(937,370400400,8),(937,386125200,7),(937,401850000,8),(937,417574800,7),(937,433299600,8),(937,449024400,7),(937,465354000,8),(937,481078800,7),(937,496803600,8),(937,512528400,7),(937,528253200,8),(937,543978000,7),(937,559702800,8),(937,575427600,7),(937,591152400,8),(937,606877200,7),(937,622602000,8),(937,638326800,7),(937,654656400,8),(937,670381200,7),(937,686106000,8),(937,701830800,7),(937,717555600,8),(937,733280400,7),(937,749005200,8),(937,764730000,7),(937,780454800,8),(937,796179600,7),(937,811904400,8),(937,828234000,7),(937,846378000,8),(937,859683600,7),(937,877827600,8),(937,891133200,7),(937,909277200,8),(937,922582800,7),(937,941331600,8),(937,954032400,7),(937,972781200,8),(937,985482000,7),(937,1004230800,8),(937,1017536400,7),(937,1035680400,8),(937,1048986000,7),(937,1067130000,8),(937,1080435600,7),(937,1099184400,8),(937,1111885200,7),(937,1130634000,8),(937,1143334800,7),(937,1162083600,8),(937,1174784400,7),(937,1193533200,8),(937,1206838800,7),(937,1224982800,8),(937,1238288400,7),(937,1256432400,8),(937,1269738000,7),(937,1288486800,8),(937,1301187600,7),(937,1319936400,8),(937,1332637200,7),(937,1351386000,8),(937,1364691600,7),(937,1382835600,8),(937,1396141200,7),(937,1414285200,8),(937,1427590800,7),(937,1445734800,8),(937,1459040400,7),(937,1477789200,8),(937,1490490000,7),(937,1509238800,8),(937,1521939600,7),(937,1540688400,8),(937,1553994000,7),(937,1572138000,8),(937,1585443600,7),(937,1603587600,8),(937,1616893200,7),(937,1635642000,8),(937,1648342800,7),(937,1667091600,8),(937,1679792400,7),(937,1698541200,8),(937,1711846800,7),(937,1729990800,8),(937,1743296400,7),(937,1761440400,8),(937,1774746000,7),(937,1792890000,8),(937,1806195600,7),(937,1824944400,8),(937,1837645200,7),(937,1856394000,8),(937,1869094800,7),(937,1887843600,8),(937,1901149200,7),(937,1919293200,8),(937,1932598800,7),(937,1950742800,8),(937,1964048400,7),(937,1982797200,8),(937,1995498000,7),(937,2014246800,8),(937,2026947600,7),(937,2045696400,8),(937,2058397200,7),(937,2077146000,8),(937,2090451600,7),(937,2108595600,8),(937,2121901200,7),(937,2140045200,8),(938,-2147483648,1),(938,-1830380400,6),(938,-1689552000,2),(938,-1677798000,3),(938,-1667433600,4),(938,-1647734400,5),(938,-1635811200,4),(938,-1616198400,5),(938,-1604361600,4),(938,-1584662400,5),(938,-1572739200,4),(938,-1553040000,5),(938,-1541203200,4),(938,-1521504000,5),(938,-1442448000,4),(938,-1426809600,5),(938,-1379289600,4),(938,-1364774400,5),(938,-1348444800,4),(938,-1333324800,5),(938,-1316390400,4),(938,-1301270400,5),(938,-1284336000,4),(938,-1269820800,5),(938,-1221436800,4),(938,-1206921600,5),(938,-1191196800,4),(938,-1175472000,5),(938,-1127692800,4),(938,-1111968000,5),(938,-1096848000,4),(938,-1080518400,5),(938,-1063584000,4),(938,-1049068800,5),(938,-1033344000,4),(938,-1017619200,5),(938,-1002499200,4),(938,-986169600,5),(938,-969235200,4),(938,-950486400,5),(938,-942019200,4),(938,-922665600,5),(938,-906940800,4),(938,-891129600,5),(938,-877305600,4),(938,-873680400,7),(938,-864003600,4),(938,-857952000,5),(938,-845856000,4),(938,-842835600,7),(938,-831344400,4),(938,-825897600,5),(938,-814406400,4),(938,-810781200,7),(938,-799894800,4),(938,-794448000,5),(938,-782956800,4),(938,-779331600,7),(938,-768445200,4),(938,-762998400,5),(938,-749088000,4),(938,-733363200,5),(938,-717627600,4),(938,-701902800,5),(938,-686178000,4),(938,-670453200,5),(938,-654728400,4),(938,-639003600,5),(938,-623278800,4),(938,-607554000,5),(938,-591829200,4),(938,-575499600,5),(938,-559774800,4),(938,-544050000,5),(938,-528325200,4),(938,-512600400,5),(938,-496875600,4),(938,-481150800,5),(938,-465426000,4),(938,-449701200,5),(938,-433976400,4),(938,-417646800,5),(938,-401922000,4),(938,-386197200,5),(938,-370472400,4),(938,-354747600,5),(938,-339022800,4),(938,-323298000,5),(938,-307573200,4),(938,-291848400,5),(938,-276123600,4),(938,-260398800,5),(938,-244674000,4),(938,-228344400,5),(938,-212619600,4),(938,-196894800,5),(938,-181170000,4),(938,-165445200,5),(938,-149720400,4),(938,-133995600,5),(938,-118270800,10),(938,228268800,8),(938,243993600,9),(938,260323200,8),(938,276048000,9),(938,291772800,8),(938,307501200,9),(938,323222400,8),(938,338950800,9),(938,354675600,8),(938,370400400,9),(938,386125200,8),(938,401850000,9),(938,417578400,8),(938,433299600,11),(938,449024400,12),(938,465354000,11),(938,481078800,12),(938,496803600,11),(938,512528400,12),(938,528253200,11),(938,543978000,12),(938,559702800,11),(938,575427600,12),(938,591152400,11),(938,606877200,12),(938,622602000,11),(938,638326800,12),(938,654656400,11),(938,670381200,12),(938,686106000,11),(938,701830800,12),(938,717555600,11),(938,733280400,12),(938,749005200,11),(938,764730000,12),(938,780454800,11),(938,796179600,12),(938,811904400,11),(938,828234000,12),(938,846378000,11),(938,859683600,12),(938,877827600,11),(938,891133200,12),(938,909277200,11),(938,922582800,12),(938,941331600,11),(938,954032400,12),(938,972781200,11),(938,985482000,12),(938,1004230800,11),(938,1017536400,12),(938,1035680400,11),(938,1048986000,12),(938,1067130000,11),(938,1080435600,12),(938,1099184400,11),(938,1111885200,12),(938,1130634000,11),(938,1143334800,12),(938,1162083600,11),(938,1174784400,12),(938,1193533200,11),(938,1206838800,12),(938,1224982800,11),(938,1238288400,12),(938,1256432400,11),(938,1269738000,12),(938,1288486800,11),(938,1301187600,12),(938,1319936400,11),(938,1332637200,12),(938,1351386000,11),(938,1364691600,12),(938,1382835600,11),(938,1396141200,12),(938,1414285200,11),(938,1427590800,12),(938,1445734800,11),(938,1459040400,12),(938,1477789200,11),(938,1490490000,12),(938,1509238800,11),(938,1521939600,12),(938,1540688400,11),(938,1553994000,12),(938,1572138000,11),(938,1585443600,12),(938,1603587600,11),(938,1616893200,12),(938,1635642000,11),(938,1648342800,12),(938,1667091600,11),(938,1679792400,12),(938,1698541200,11),(938,1711846800,12),(938,1729990800,11),(938,1743296400,12),(938,1761440400,11),(938,1774746000,12),(938,1792890000,11),(938,1806195600,12),(938,1824944400,11),(938,1837645200,12),(938,1856394000,11),(938,1869094800,12),(938,1887843600,11),(938,1901149200,12),(938,1919293200,11),(938,1932598800,12),(938,1950742800,11),(938,1964048400,12),(938,1982797200,11),(938,1995498000,12),(938,2014246800,11),(938,2026947600,12),(938,2045696400,11),(938,2058397200,12),(938,2077146000,11),(938,2090451600,12),(938,2108595600,11),(938,2121901200,12),(938,2140045200,11),(939,-2147483648,0),(939,-1830383032,1),(940,-2147483648,1),(940,2147483647,1),(941,-2147483648,0),(941,-1830383032,1),(942,-2147483648,1),(942,-1824235716,3),(942,-1018209600,2),(942,-1003093200,3),(942,-986760000,2),(942,-971643600,3),(942,-954705600,2),(942,-939589200,3),(942,-923256000,2),(942,-908139600,3),(942,-891806400,2),(942,-876690000,3),(942,-860356800,2),(942,-852066000,3),(942,420609600,5),(942,433306800,4),(942,452052000,5),(942,464151600,4),(942,483501600,5),(942,495601200,2),(942,514350000,3),(942,527054400,2),(942,545799600,3),(942,558504000,2),(942,577249200,3),(942,589953600,2),(942,608698800,3),(942,621403200,2),(942,640753200,3),(942,652852800,2),(942,672202800,3),(942,684907200,2),(942,703652400,3),(942,716356800,2),(942,735102000,3),(942,747806400,2),(942,766551600,3),(942,779256000,2),(942,798001200,3),(942,810705600,2),(942,830055600,3),(942,842760000,2),(942,861505200,3),(942,874209600,2),(942,892954800,3),(942,905659200,2),(942,924404400,3),(942,937108800,2),(942,955854000,3),(942,968558400,2),(942,987310800,3),(942,999410400,2),(942,1019365200,3),(942,1030860000,2),(942,1050814800,3),(942,1062914400,2),(942,1082264400,3),(942,1094364000,2),(942,1113714000,3),(942,1125813600,2),(942,1145163600,3),(942,1157263200,2),(942,1176613200,3),(942,1188712800,2),(942,1208667600,3),(942,1220767200,2),(942,1240117200,3),(942,1252216800,2),(942,1271566800,3),(942,1283666400,5),(942,2147483647,5),(943,-2147483648,3),(943,-1672560000,1),(943,-1665388800,2),(943,-883641600,1),(943,-876124800,2),(943,-860400000,1),(943,-844675200,2),(943,-828345600,1),(943,-813225600,2),(943,31500000,3),(943,57686400,1),(943,67968000,2),(943,89136000,1),(943,100022400,2),(943,120585600,1),(943,131472000,2),(943,152035200,1),(943,162921600,2),(943,183484800,1),(943,194976000,2),(943,215539200,1),(943,226425600,2),(943,246988800,1),(943,257875200,2),(943,278438400,1),(943,289324800,2),(943,309888000,1),(943,320774400,2),(943,341337600,1),(943,352224000,2),(943,372787200,1),(943,386697600,2),(943,404841600,1),(943,415728000,2),(943,436291200,1),(943,447177600,2),(943,467740800,1),(943,478627200,2),(943,499190400,1),(943,511286400,2),(943,530035200,1),(943,542736000,2),(943,562089600,1),(943,574790400,2),(943,594144000,1),(943,606240000,2),(943,625593600,1),(943,636480000,2),(943,657043200,1),(943,667929600,2),(943,688492800,1),(943,699379200,2),(943,719942400,1),(943,731433600,2),(943,751996800,1),(943,762883200,2),(943,783446400,1),(943,794332800,2),(943,814896000,1),(943,828201600,2),(943,846345600,1),(943,859651200,2),(943,877795200,1),(943,891100800,2),(943,909244800,1),(943,922550400,2),(943,941299200,1),(943,954000000,2),(943,967305600,1),(943,985449600,2),(943,1004198400,1),(943,1017504000,2),(943,1035648000,1),(943,1048953600,2),(943,1067097600,1),(943,1080403200,2),(943,1099152000,1),(943,1111852800,2),(943,1130601600,1),(943,1143907200,2),(943,1162051200,1),(943,1174752000,2),(943,1193500800,1),(943,1207411200,2),(943,1223136000,1),(943,1238860800,2),(943,1254585600,1),(943,1270310400,2),(943,1286035200,1),(943,1301760000,2),(943,1317484800,1),(943,1333209600,2),(943,1349539200,1),(943,1365264000,2),(943,1380988800,1),(943,1396713600,2),(943,1412438400,1),(943,1428163200,2),(943,1443888000,1),(943,1459612800,2),(943,1475337600,1),(943,1491062400,2),(943,1506787200,1),(943,1522512000,2),(943,1538841600,1),(943,1554566400,2),(943,1570291200,1),(943,1586016000,2),(943,1601740800,1),(943,1617465600,2),(943,1633190400,1),(943,1648915200,2),(943,1664640000,1),(943,1680364800,2),(943,1696089600,1),(943,1712419200,2),(943,1728144000,1),(943,1743868800,2),(943,1759593600,1),(943,1775318400,2),(943,1791043200,1),(943,1806768000,2),(943,1822492800,1),(943,1838217600,2),(943,1853942400,1),(943,1869667200,2),(943,1885996800,1),(943,1901721600,2),(943,1917446400,1),(943,1933171200,2),(943,1948896000,1),(943,1964620800,2),(943,1980345600,1),(943,1996070400,2),(943,2011795200,1),(943,2027520000,2),(943,2043244800,1),(943,2058969600,2),(943,2075299200,1),(943,2091024000,2),(943,2106748800,1),(943,2122473600,2),(943,2138198400,1),(944,-2147483648,3),(944,-1672558200,1),(944,-1665387000,2),(944,-883639800,1),(944,-876123000,2),(944,-860398200,1),(944,-844673400,2),(944,-828343800,1),(944,-813223800,2),(944,31501800,3),(944,57688200,1),(944,67969800,2),(944,89137800,1),(944,100024200,2),(944,120587400,1),(944,131473800,2),(944,152037000,1),(944,162923400,2),(944,183486600,1),(944,194977800,2),(944,215541000,1),(944,226427400,2),(944,246990600,1),(944,257877000,2),(944,278440200,1),(944,289326600,2),(944,309889800,1),(944,320776200,2),(944,341339400,1),(944,352225800,2),(944,372789000,1),(944,384280200,2),(944,404843400,1),(944,415729800,2),(944,436293000,1),(944,447179400,2),(944,467742600,1),(944,478629000,2),(944,499192200,1),(944,511288200,2),(944,530037000,1),(944,542737800,2),(944,562091400,1),(944,574792200,2),(944,594145800,1),(944,606241800,2),(944,625595400,1),(944,637691400,2),(944,657045000,1),(944,667931400,2),(944,688494600,1),(944,701195400,2),(944,719944200,1),(944,731435400,2),(944,751998600,1),(944,764094600,2),(944,783448200,1),(944,796149000,2),(944,814897800,1),(944,828203400,2),(944,846347400,1),(944,859653000,2),(944,877797000,1),(944,891102600,2),(944,909246600,1),(944,922552200,2),(944,941301000,1),(944,954001800,2),(944,972750600,1),(944,985451400,2),(944,1004200200,1),(944,1017505800,2),(944,1035649800,1),(944,1048955400,2),(944,1067099400,1),(944,1080405000,2),(944,1099153800,1),(944,1111854600,2),(944,1130603400,1),(944,1143909000,2),(944,1162053000,1),(944,1174753800,2),(944,1193502600,1),(944,1207413000,2),(944,1223137800,1),(944,1238862600,2),(944,1254587400,1),(944,1270312200,2),(944,1286037000,1),(944,1301761800,2),(944,1317486600,1),(944,1333211400,2),(944,1349541000,1),(944,1365265800,2),(944,1380990600,1),(944,1396715400,2),(944,1412440200,1),(944,1428165000,2),(944,1443889800,1),(944,1459614600,2),(944,1475339400,1),(944,1491064200,2),(944,1506789000,1),(944,1522513800,2),(944,1538843400,1),(944,1554568200,2),(944,1570293000,1),(944,1586017800,2),(944,1601742600,1),(944,1617467400,2),(944,1633192200,1),(944,1648917000,2),(944,1664641800,1),(944,1680366600,2),(944,1696091400,1),(944,1712421000,2),(944,1728145800,1),(944,1743870600,2),(944,1759595400,1),(944,1775320200,2),(944,1791045000,1),(944,1806769800,2),(944,1822494600,1),(944,1838219400,2),(944,1853944200,1),(944,1869669000,2),(944,1885998600,1),(944,1901723400,2),(944,1917448200,1),(944,1933173000,2),(944,1948897800,1),(944,1964622600,2),(944,1980347400,1),(944,1996072200,2),(944,2011797000,1),(944,2027521800,2),(944,2043246600,1),(944,2058971400,2),(944,2075301000,1),(944,2091025800,2),(944,2106750600,1),(944,2122475400,2),(944,2138200200,1),(945,-2147483648,3),(945,-1672560000,1),(945,-1665388800,2),(945,-883641600,1),(945,-876124800,2),(945,-860400000,1),(945,-844675200,2),(945,-828345600,1),(945,-813225600,2),(945,31500000,3),(945,57686400,1),(945,67968000,2),(945,625593600,1),(945,636480000,2),(945,657043200,1),(945,667929600,2),(945,688492800,1),(945,699379200,2),(946,-2147483648,3),(946,-1672558200,1),(946,-1665387000,2),(946,-883639800,1),(946,-876123000,2),(946,-860398200,1),(946,-844673400,2),(946,-828343800,1),(946,-813223800,2),(946,31501800,3),(946,57688200,1),(946,67969800,2),(946,89137800,1),(946,100024200,2),(946,120587400,1),(946,131473800,2),(946,152037000,1),(946,162923400,2),(946,183486600,1),(946,194977800,2),(946,215541000,1),(946,226427400,2),(946,246990600,1),(946,257877000,2),(946,278440200,1),(946,289326600,2),(946,309889800,1),(946,320776200,2),(946,341339400,1),(946,352225800,2),(946,372789000,1),(946,386699400,2),(946,404843400,1),(946,415729800,2),(946,436293000,1),(946,447179400,2),(946,467742600,1),(946,478629000,2),(946,499192200,1),(946,511288200,2),(946,530037000,1),(946,542737800,2),(946,562091400,1),(946,574792200,2),(946,594145800,1),(946,606241800,2),(946,625595400,1),(946,636481800,2),(946,657045000,1),(946,667931400,2),(946,688494600,1),(946,699381000,2),(946,719944200,1),(946,731435400,2),(946,751998600,1),(946,762885000,2),(946,783448200,1),(946,794334600,2),(946,814897800,1),(946,828203400,2),(946,846347400,1),(946,859653000,2),(946,877797000,1),(946,891102600,2),(946,909246600,1),(946,922552200,2),(946,941301000,1),(946,946647000,4),(946,954001800,2),(946,972750600,1),(946,985451400,2),(946,1004200200,1),(946,1017505800,2),(946,1035649800,1),(946,1048955400,2),(946,1067099400,1),(946,1080405000,2),(946,1099153800,1),(946,1111854600,2),(946,1130603400,1),(946,1143909000,2),(946,1162053000,1),(946,1174753800,2),(946,1193502600,1),(946,1207413000,2),(946,1223137800,1),(946,1238862600,2),(946,1254587400,1),(946,1270312200,2),(946,1286037000,1),(946,1301761800,2),(946,1317486600,1),(946,1333211400,2),(946,1349541000,1),(946,1365265800,2),(946,1380990600,1),(946,1396715400,2),(946,1412440200,1),(946,1428165000,2),(946,1443889800,1),(946,1459614600,2),(946,1475339400,1),(946,1491064200,2),(946,1506789000,1),(946,1522513800,2),(946,1538843400,1),(946,1554568200,2),(946,1570293000,1),(946,1586017800,2),(946,1601742600,1),(946,1617467400,2),(946,1633192200,1),(946,1648917000,2),(946,1664641800,1),(946,1680366600,2),(946,1696091400,1),(946,1712421000,2),(946,1728145800,1),(946,1743870600,2),(946,1759595400,1),(946,1775320200,2),(946,1791045000,1),(946,1806769800,2),(946,1822494600,1),(946,1838219400,2),(946,1853944200,1),(946,1869669000,2),(946,1885998600,1),(946,1901723400,2),(946,1917448200,1),(946,1933173000,2),(946,1948897800,1),(946,1964622600,2),(946,1980347400,1),(946,1996072200,2),(946,2011797000,1),(946,2027521800,2),(946,2043246600,1),(946,2058971400,2),(946,2075301000,1),(946,2091025800,2),(946,2106750600,1),(946,2122475400,2),(946,2138200200,1),(947,-2147483648,3),(947,-1672560000,1),(947,-1665388800,2),(947,-883641600,1),(947,-876124800,2),(947,-860400000,1),(947,-844675200,2),(947,-828345600,1),(947,-813225600,2),(947,31500000,3),(947,57686400,1),(947,67968000,2),(947,89136000,1),(947,100022400,2),(947,120585600,1),(947,131472000,2),(947,152035200,1),(947,162921600,2),(947,183484800,1),(947,194976000,2),(947,215539200,1),(947,226425600,2),(947,246988800,1),(947,257875200,2),(947,278438400,1),(947,289324800,2),(947,309888000,1),(947,320774400,2),(947,341337600,1),(947,352224000,2),(947,372787200,1),(947,386697600,2),(947,404841600,1),(947,415728000,2),(947,436291200,1),(947,447177600,2),(947,467740800,1),(947,478627200,2),(947,499190400,1),(947,511286400,2),(947,530035200,1),(947,542736000,2),(947,562089600,1),(947,574790400,2),(947,594144000,1),(947,606240000,2),(947,625593600,1),(947,636480000,2),(947,657043200,1),(947,667929600,2),(947,688492800,1),(947,699379200,2),(947,719942400,1),(947,731433600,2),(947,751996800,1),(947,762883200,2),(947,783446400,1),(947,794332800,2),(947,814896000,1),(947,828201600,2),(947,846345600,1),(947,859651200,2),(947,877795200,1),(947,891100800,2),(947,909244800,1),(947,922550400,2),(947,941299200,1),(947,954000000,2),(947,967305600,1),(947,985449600,2),(947,1004198400,1),(947,1017504000,2),(947,1035648000,1),(947,1048953600,2),(947,1067097600,1),(947,1080403200,2),(947,1099152000,1),(947,1111852800,2),(947,1130601600,1),(947,1143907200,2),(947,1162051200,1),(947,1174752000,2),(947,1193500800,1),(947,1207411200,2),(947,1223136000,1),(947,1238860800,2),(947,1254585600,1),(947,1270310400,2),(947,1286035200,1),(947,1301760000,2),(947,1317484800,1),(947,1333209600,2),(947,1349539200,1),(947,1365264000,2),(947,1380988800,1),(947,1396713600,2),(947,1412438400,1),(947,1428163200,2),(947,1443888000,1),(947,1459612800,2),(947,1475337600,1),(947,1491062400,2),(947,1506787200,1),(947,1522512000,2),(947,1538841600,1),(947,1554566400,2),(947,1570291200,1),(947,1586016000,2),(947,1601740800,1),(947,1617465600,2),(947,1633190400,1),(947,1648915200,2),(947,1664640000,1),(947,1680364800,2),(947,1696089600,1),(947,1712419200,2),(947,1728144000,1),(947,1743868800,2),(947,1759593600,1),(947,1775318400,2),(947,1791043200,1),(947,1806768000,2),(947,1822492800,1),(947,1838217600,2),(947,1853942400,1),(947,1869667200,2),(947,1885996800,1),(947,1901721600,2),(947,1917446400,1),(947,1933171200,2),(947,1948896000,1),(947,1964620800,2),(947,1980345600,1),(947,1996070400,2),(947,2011795200,1),(947,2027520000,2),(947,2043244800,1),(947,2058969600,2),(947,2075299200,1),(947,2091024000,2),(947,2106748800,1),(947,2122473600,2),(947,2138198400,1),(948,-2147483648,3),(948,-1680508800,1),(948,-1665388800,2),(948,-1646640000,1),(948,-1635753600,2),(948,-1615190400,1),(948,-1604304000,2),(948,-1583920800,3),(948,-883641600,1),(948,-876124800,2),(948,-860400000,1),(948,-844675200,2),(948,-828345600,1),(948,-813225600,2),(948,-94730400,3),(948,-71136000,1),(948,-55411200,2),(948,-37267200,1),(948,-25776000,2),(948,-5817600,1),(948,5673600,2),(948,25632000,1),(948,37728000,2),(948,57686400,1),(948,67968000,2),(948,89136000,1),(948,100022400,2),(948,120585600,1),(948,131472000,2),(948,152035200,1),(948,162921600,2),(948,183484800,1),(948,194976000,2),(948,215539200,1),(948,226425600,2),(948,246988800,1),(948,257875200,2),(948,278438400,1),(948,289324800,2),(948,309888000,1),(948,320774400,2),(948,341337600,1),(948,352224000,2),(948,372787200,1),(948,386092800,2),(948,404841600,1),(948,417542400,2),(948,436291200,1),(948,447177600,2),(948,467740800,1),(948,478627200,2),(948,499190400,1),(948,510076800,2),(948,530035200,1),(948,542736000,2),(948,562089600,1),(948,574790400,2),(948,594144000,1),(948,606240000,2),(948,625593600,1),(948,637689600,2),(948,657043200,1),(948,670348800,2),(948,686678400,1),(948,701798400,2),(948,718128000,1),(948,733248000,2),(948,749577600,1),(948,764697600,2),(948,781027200,1),(948,796147200,2),(948,812476800,1),(948,828201600,2),(948,844531200,1),(948,859651200,2),(948,875980800,1),(948,891100800,2),(948,907430400,1),(948,922550400,2),(948,938880000,1),(948,954000000,2),(948,967305600,1),(948,985449600,2),(948,1002384000,1),(948,1017504000,2),(948,1033833600,1),(948,1048953600,2),(948,1065283200,1),(948,1080403200,2),(948,1096732800,1),(948,1111852800,2),(948,1128182400,1),(948,1143907200,2),(948,1159632000,1),(948,1174752000,2),(948,1191686400,1),(948,1207411200,2),(948,1223136000,1),(948,1238860800,2),(948,1254585600,1),(948,1270310400,2),(948,1286035200,1),(948,1301760000,2),(948,1317484800,1),(948,1333209600,2),(948,1349539200,1),(948,1365264000,2),(948,1380988800,1),(948,1396713600,2),(948,1412438400,1),(948,1428163200,2),(948,1443888000,1),(948,1459612800,2),(948,1475337600,1),(948,1491062400,2),(948,1506787200,1),(948,1522512000,2),(948,1538841600,1),(948,1554566400,2),(948,1570291200,1),(948,1586016000,2),(948,1601740800,1),(948,1617465600,2),(948,1633190400,1),(948,1648915200,2),(948,1664640000,1),(948,1680364800,2),(948,1696089600,1),(948,1712419200,2),(948,1728144000,1),(948,1743868800,2),(948,1759593600,1),(948,1775318400,2),(948,1791043200,1),(948,1806768000,2),(948,1822492800,1),(948,1838217600,2),(948,1853942400,1),(948,1869667200,2),(948,1885996800,1),(948,1901721600,2),(948,1917446400,1),(948,1933171200,2),(948,1948896000,1),(948,1964620800,2),(948,1980345600,1),(948,1996070400,2),(948,2011795200,1),(948,2027520000,2),(948,2043244800,1),(948,2058969600,2),(948,2075299200,1),(948,2091024000,2),(948,2106748800,1),(948,2122473600,2),(948,2138198400,1),(949,-2147483648,3),(949,-1672558200,1),(949,-1665387000,2),(949,-883639800,1),(949,-876123000,2),(949,-860398200,1),(949,-844673400,2),(949,-828343800,1),(949,-813223800,2),(950,-2147483648,3),(950,-1672555500,1),(950,-1665384300,2),(950,-883637100,1),(950,-876120300,2),(950,-860395500,1),(950,-844670700,2),(950,-836469900,3),(950,152039700,1),(950,162926100,2),(950,436295700,1),(950,447182100,2),(950,690311700,1),(950,699383700,2),(950,1165079700,1),(950,1174756500,2),(950,1193505300,1),(950,1206810900,2),(950,1224954900,1),(950,1238260500,2),(950,2147483647,2),(951,-2147483648,3),(951,-1680508800,1),(951,-1665388800,2),(951,-1646640000,1),(951,-1635753600,2),(951,-1615190400,1),(951,-1604304000,2),(951,-1583920800,3),(951,-883641600,1),(951,-876124800,2),(951,-860400000,1),(951,-844675200,2),(951,-828345600,1),(951,-813225600,2),(951,-94730400,3),(951,-71136000,1),(951,-55411200,2),(951,-37267200,1),(951,-25776000,2),(951,-5817600,1),(951,5673600,2),(951,25632000,1),(951,37728000,2),(951,57686400,1),(951,67968000,2),(951,89136000,1),(951,100022400,2),(951,120585600,1),(951,131472000,2),(951,152035200,1),(951,162921600,2),(951,183484800,1),(951,194976000,2),(951,215539200,1),(951,226425600,2),(951,246988800,1),(951,257875200,2),(951,278438400,1),(951,289324800,2),(951,309888000,1),(951,320774400,2),(951,341337600,1),(951,352224000,2),(951,372787200,1),(951,386092800,2),(951,404841600,1),(951,417542400,2),(951,436291200,1),(951,447177600,2),(951,467740800,1),(951,478627200,2),(951,499190400,1),(951,510076800,2),(951,530035200,1),(951,542736000,2),(951,562089600,1),(951,574790400,2),(951,594144000,1),(951,606240000,2),(951,625593600,1),(951,637689600,2),(951,657043200,1),(951,670348800,2),(951,686678400,1),(951,701798400,2),(951,718128000,1),(951,733248000,2),(951,749577600,1),(951,764697600,2),(951,781027200,1),(951,796147200,2),(951,812476800,1),(951,828201600,2),(951,844531200,1),(951,859651200,2),(951,875980800,1),(951,891100800,2),(951,907430400,1),(951,922550400,2),(951,938880000,1),(951,954000000,2),(951,967305600,1),(951,985449600,2),(951,1002384000,1),(951,1017504000,2),(951,1033833600,1),(951,1048953600,2),(951,1065283200,1),(951,1080403200,2),(951,1096732800,1),(951,1111852800,2),(951,1128182400,1),(951,1143907200,2),(951,1159632000,1),(951,1174752000,2),(951,1191686400,1),(951,1207411200,2),(951,1223136000,1),(951,1238860800,2),(951,1254585600,1),(951,1270310400,2),(951,1286035200,1),(951,1301760000,2),(951,1317484800,1),(951,1333209600,2),(951,1349539200,1),(951,1365264000,2),(951,1380988800,1),(951,1396713600,2),(951,1412438400,1),(951,1428163200,2),(951,1443888000,1),(951,1459612800,2),(951,1475337600,1),(951,1491062400,2),(951,1506787200,1),(951,1522512000,2),(951,1538841600,1),(951,1554566400,2),(951,1570291200,1),(951,1586016000,2),(951,1601740800,1),(951,1617465600,2),(951,1633190400,1),(951,1648915200,2),(951,1664640000,1),(951,1680364800,2),(951,1696089600,1),(951,1712419200,2),(951,1728144000,1),(951,1743868800,2),(951,1759593600,1),(951,1775318400,2),(951,1791043200,1),(951,1806768000,2),(951,1822492800,1),(951,1838217600,2),(951,1853942400,1),(951,1869667200,2),(951,1885996800,1),(951,1901721600,2),(951,1917446400,1),(951,1933171200,2),(951,1948896000,1),(951,1964620800,2),(951,1980345600,1),(951,1996070400,2),(951,2011795200,1),(951,2027520000,2),(951,2043244800,1),(951,2058969600,2),(951,2075299200,1),(951,2091024000,2),(951,2106748800,1),(951,2122473600,2),(951,2138198400,1),(952,-2147483648,1),(952,352216800,3),(952,372785400,2),(952,384273000,3),(952,404839800,2),(952,415722600,3),(952,436289400,2),(952,447172200,3),(952,467739000,2),(952,478621800,3),(952,499188600,4),(952,511282800,3),(952,530033400,4),(952,542732400,3),(952,562087800,4),(952,574786800,3),(952,594142200,4),(952,606236400,3),(952,625591800,4),(952,636476400,3),(952,657041400,4),(952,667926000,3),(952,688491000,4),(952,699375600,3),(952,719940600,4),(952,731430000,3),(952,751995000,4),(952,762879600,3),(952,783444600,4),(952,794329200,3),(952,814894200,4),(952,828198000,3),(952,846343800,4),(952,859647600,3),(952,877793400,4),(952,891097200,3),(952,909243000,4),(952,922546800,3),(952,941297400,4),(952,953996400,3),(952,967303800,4),(952,985446000,3),(952,1004196600,4),(952,1017500400,3),(952,1035646200,4),(952,1048950000,3),(952,1067095800,4),(952,1080399600,3),(952,1099150200,4),(952,1111849200,3),(952,1130599800,4),(952,1143903600,3),(952,1162049400,4),(952,1174748400,3),(952,1193499000,4),(952,1207407600,3),(952,1223134200,4),(952,1238857200,3),(952,1254583800,4),(952,1270306800,3),(952,1286033400,4),(952,1301756400,3),(952,1317483000,4),(952,1333206000,3),(952,1349537400,4),(952,1365260400,3),(952,1380987000,4),(952,1396710000,3),(952,1412436600,4),(952,1428159600,3),(952,1443886200,4),(952,1459609200,3),(952,1475335800,4),(952,1491058800,3),(952,1506785400,4),(952,1522508400,3),(952,1538839800,4),(952,1554562800,3),(952,1570289400,4),(952,1586012400,3),(952,1601739000,4),(952,1617462000,3),(952,1633188600,4),(952,1648911600,3),(952,1664638200,4),(952,1680361200,3),(952,1696087800,4),(952,1712415600,3),(952,1728142200,4),(952,1743865200,3),(952,1759591800,4),(952,1775314800,3),(952,1791041400,4),(952,1806764400,3),(952,1822491000,4),(952,1838214000,3),(952,1853940600,4),(952,1869663600,3),(952,1885995000,4),(952,1901718000,3),(952,1917444600,4),(952,1933167600,3),(952,1948894200,4),(952,1964617200,3),(952,1980343800,4),(952,1996066800,3),(952,2011793400,4),(952,2027516400,3),(952,2043243000,4),(952,2058966000,3),(952,2075297400,4),(952,2091020400,3),(952,2106747000,4),(952,2122470000,3),(952,2138196600,4),(952,2147483647,4),(953,-2147483648,3),(953,-1672560000,1),(953,-1665388800,2),(953,-883641600,1),(953,-876124800,2),(953,-860400000,1),(953,-844675200,2),(953,-828345600,1),(953,-813225600,2),(953,31500000,3),(953,57686400,1),(953,67968000,2),(953,625593600,1),(953,636480000,2),(953,657043200,1),(953,667929600,2),(953,688492800,1),(953,699379200,2),(953,709912800,3),(953,719942400,1),(953,731433600,2),(953,751996800,1),(953,762883200,2),(954,-2147483648,1),(954,352216800,3),(954,372785400,2),(954,384273000,3),(954,404839800,2),(954,415722600,3),(954,436289400,2),(954,447172200,3),(954,467739000,2),(954,478621800,3),(954,499188600,4),(954,511282800,3),(954,530033400,4),(954,542732400,3),(954,562087800,4),(954,574786800,3),(954,594142200,4),(954,606236400,3),(954,625591800,4),(954,636476400,3),(954,657041400,4),(954,667926000,3),(954,688491000,4),(954,699375600,3),(954,719940600,4),(954,731430000,3),(954,751995000,4),(954,762879600,3),(954,783444600,4),(954,794329200,3),(954,814894200,4),(954,828198000,3),(954,846343800,4),(954,859647600,3),(954,877793400,4),(954,891097200,3),(954,909243000,4),(954,922546800,3),(954,941297400,4),(954,953996400,3),(954,967303800,4),(954,985446000,3),(954,1004196600,4),(954,1017500400,3),(954,1035646200,4),(954,1048950000,3),(954,1067095800,4),(954,1080399600,3),(954,1099150200,4),(954,1111849200,3),(954,1130599800,4),(954,1143903600,3),(954,1162049400,4),(954,1174748400,3),(954,1193499000,4),(954,1207407600,3),(954,1223134200,4),(954,1238857200,3),(954,1254583800,4),(954,1270306800,3),(954,1286033400,4),(954,1301756400,3),(954,1317483000,4),(954,1333206000,3),(954,1349537400,4),(954,1365260400,3),(954,1380987000,4),(954,1396710000,3),(954,1412436600,4),(954,1428159600,3),(954,1443886200,4),(954,1459609200,3),(954,1475335800,4),(954,1491058800,3),(954,1506785400,4),(954,1522508400,3),(954,1538839800,4),(954,1554562800,3),(954,1570289400,4),(954,1586012400,3),(954,1601739000,4),(954,1617462000,3),(954,1633188600,4),(954,1648911600,3),(954,1664638200,4),(954,1680361200,3),(954,1696087800,4),(954,1712415600,3),(954,1728142200,4),(954,1743865200,3),(954,1759591800,4),(954,1775314800,3),(954,1791041400,4),(954,1806764400,3),(954,1822491000,4),(954,1838214000,3),(954,1853940600,4),(954,1869663600,3),(954,1885995000,4),(954,1901718000,3),(954,1917444600,4),(954,1933167600,3),(954,1948894200,4),(954,1964617200,3),(954,1980343800,4),(954,1996066800,3),(954,2011793400,4),(954,2027516400,3),(954,2043243000,4),(954,2058966000,3),(954,2075297400,4),(954,2091020400,3),(954,2106747000,4),(954,2122470000,3),(954,2138196600,4),(954,2147483647,4),(955,-2147483648,3),(955,-1672560000,1),(955,-1665388800,2),(955,-883641600,1),(955,-876124800,2),(955,-860400000,1),(955,-844675200,2),(955,-828345600,1),(955,-813225600,2),(955,31500000,3),(955,57686400,1),(955,67968000,2),(955,89136000,1),(955,100022400,2),(955,120585600,1),(955,131472000,2),(955,152035200,1),(955,162921600,2),(955,183484800,1),(955,194976000,2),(955,215539200,1),(955,226425600,2),(955,246988800,1),(955,257875200,2),(955,278438400,1),(955,289324800,2),(955,309888000,1),(955,320774400,2),(955,341337600,1),(955,352224000,2),(955,372787200,1),(955,384278400,2),(955,404841600,1),(955,415728000,2),(955,436291200,1),(955,447177600,2),(955,467740800,1),(955,478627200,2),(955,499190400,1),(955,511286400,2),(955,530035200,1),(955,542736000,2),(955,561484800,1),(955,574790400,2),(955,594144000,1),(955,606240000,2),(955,625593600,1),(955,637689600,2),(955,657043200,1),(955,667929600,2),(955,688492800,1),(955,699379200,2),(955,719942400,1),(955,731433600,2),(955,751996800,1),(955,762883200,2),(955,783446400,1),(955,796147200,2),(955,814896000,1),(955,828201600,2),(955,846345600,1),(955,859651200,2),(955,877795200,1),(955,891100800,2),(955,909244800,1),(955,922550400,2),(955,941299200,1),(955,954000000,2),(955,967305600,1),(955,985449600,2),(955,1004198400,1),(955,1017504000,2),(955,1035648000,1),(955,1048953600,2),(955,1067097600,1),(955,1080403200,2),(955,1099152000,1),(955,1111852800,2),(955,1130601600,1),(955,1143907200,2),(955,1162051200,1),(955,1174752000,2),(955,1193500800,1),(955,1207411200,2),(955,1223136000,1),(955,1238860800,2),(955,1254585600,1),(955,1270310400,2),(955,1286035200,1),(955,1301760000,2),(955,1317484800,1),(955,1333209600,2),(955,1349539200,1),(955,1365264000,2),(955,1380988800,1),(955,1396713600,2),(955,1412438400,1),(955,1428163200,2),(955,1443888000,1),(955,1459612800,2),(955,1475337600,1),(955,1491062400,2),(955,1506787200,1),(955,1522512000,2),(955,1538841600,1),(955,1554566400,2),(955,1570291200,1),(955,1586016000,2),(955,1601740800,1),(955,1617465600,2),(955,1633190400,1),(955,1648915200,2),(955,1664640000,1),(955,1680364800,2),(955,1696089600,1),(955,1712419200,2),(955,1728144000,1),(955,1743868800,2),(955,1759593600,1),(955,1775318400,2),(955,1791043200,1),(955,1806768000,2),(955,1822492800,1),(955,1838217600,2),(955,1853942400,1),(955,1869667200,2),(955,1885996800,1),(955,1901721600,2),(955,1917446400,1),(955,1933171200,2),(955,1948896000,1),(955,1964620800,2),(955,1980345600,1),(955,1996070400,2),(955,2011795200,1),(955,2027520000,2),(955,2043244800,1),(955,2058969600,2),(955,2075299200,1),(955,2091024000,2),(955,2106748800,1),(955,2122473600,2),(955,2138198400,1),(956,-2147483648,3),(956,-1672560000,1),(956,-1665388800,2),(956,-883641600,1),(956,-876124800,2),(956,-860400000,1),(956,-844675200,2),(956,-828345600,1),(956,-813225600,2),(956,31500000,3),(956,57686400,1),(956,67968000,2),(956,89136000,1),(956,100022400,2),(956,120585600,1),(956,131472000,2),(956,152035200,1),(956,162921600,2),(956,183484800,1),(956,194976000,2),(956,215539200,1),(956,226425600,2),(956,246988800,1),(956,257875200,2),(956,278438400,1),(956,289324800,2),(956,309888000,1),(956,320774400,2),(956,341337600,1),(956,352224000,2),(956,372787200,1),(956,386697600,2),(956,404841600,1),(956,415728000,2),(956,436291200,1),(956,447177600,2),(956,467740800,1),(956,478627200,2),(956,499190400,1),(956,511286400,2),(956,530035200,1),(956,542736000,2),(956,562089600,1),(956,574790400,2),(956,594144000,1),(956,606240000,2),(956,625593600,1),(956,636480000,2),(956,657043200,1),(956,667929600,2),(956,688492800,1),(956,699379200,2),(956,719942400,1),(956,731433600,2),(956,751996800,1),(956,762883200,2),(956,783446400,1),(956,794332800,2),(956,814896000,1),(956,828201600,2),(956,846345600,1),(956,859651200,2),(956,877795200,1),(956,891100800,2),(956,909244800,1),(956,922550400,2),(956,941299200,1),(956,954000000,2),(956,967305600,1),(956,985449600,2),(956,1004198400,1),(956,1017504000,2),(956,1035648000,1),(956,1048953600,2),(956,1067097600,1),(956,1080403200,2),(956,1099152000,1),(956,1111852800,2),(956,1130601600,1),(956,1143907200,2),(956,1162051200,1),(956,1174752000,2),(956,1193500800,1),(956,1207411200,2),(956,1223136000,1),(956,1238860800,2),(956,1254585600,1),(956,1270310400,2),(956,1286035200,1),(956,1301760000,2),(956,1317484800,1),(956,1333209600,2),(956,1349539200,1),(956,1365264000,2),(956,1380988800,1),(956,1396713600,2),(956,1412438400,1),(956,1428163200,2),(956,1443888000,1),(956,1459612800,2),(956,1475337600,1),(956,1491062400,2),(956,1506787200,1),(956,1522512000,2),(956,1538841600,1),(956,1554566400,2),(956,1570291200,1),(956,1586016000,2),(956,1601740800,1),(956,1617465600,2),(956,1633190400,1),(956,1648915200,2),(956,1664640000,1),(956,1680364800,2),(956,1696089600,1),(956,1712419200,2),(956,1728144000,1),(956,1743868800,2),(956,1759593600,1),(956,1775318400,2),(956,1791043200,1),(956,1806768000,2),(956,1822492800,1),(956,1838217600,2),(956,1853942400,1),(956,1869667200,2),(956,1885996800,1),(956,1901721600,2),(956,1917446400,1),(956,1933171200,2),(956,1948896000,1),(956,1964620800,2),(956,1980345600,1),(956,1996070400,2),(956,2011795200,1),(956,2027520000,2),(956,2043244800,1),(956,2058969600,2),(956,2075299200,1),(956,2091024000,2),(956,2106748800,1),(956,2122473600,2),(956,2138198400,1),(957,-2147483648,3),(957,-1672558200,1),(957,-1665387000,2),(957,-883639800,1),(957,-876123000,2),(957,-860398200,1),(957,-844673400,2),(957,-828343800,1),(957,-813223800,2),(958,-2147483648,3),(958,-1672552800,1),(958,-1665381600,2),(958,-883634400,1),(958,-876117600,2),(958,-860392800,1),(958,-844668000,2),(958,-836467200,3),(958,152042400,1),(958,162928800,2),(958,436298400,1),(958,447184800,2),(958,690314400,1),(958,699386400,2),(958,1165082400,1),(958,1174759200,2),(958,1193508000,1),(958,1206813600,2),(958,1224957600,1),(958,1238263200,2),(959,-2147483648,3),(959,-1672560000,1),(959,-1665388800,2),(959,-883641600,1),(959,-876124800,2),(959,-860400000,1),(959,-844675200,2),(959,-828345600,1),(959,-813225600,2),(959,31500000,3),(959,57686400,1),(959,67968000,2),(959,625593600,1),(959,636480000,2),(959,657043200,1),(959,667929600,2),(959,688492800,1),(959,699379200,2),(960,-2147483648,3),(960,-1672558200,1),(960,-1665387000,2),(960,-883639800,1),(960,-876123000,2),(960,-860398200,1),(960,-844673400,2),(960,-828343800,1),(960,-813223800,2),(960,31501800,3),(960,57688200,1),(960,67969800,2),(960,89137800,1),(960,100024200,2),(960,120587400,1),(960,131473800,2),(960,152037000,1),(960,162923400,2),(960,183486600,1),(960,194977800,2),(960,215541000,1),(960,226427400,2),(960,246990600,1),(960,257877000,2),(960,278440200,1),(960,289326600,2),(960,309889800,1),(960,320776200,2),(960,341339400,1),(960,352225800,2),(960,372789000,1),(960,384280200,2),(960,404843400,1),(960,415729800,2),(960,436293000,1),(960,447179400,2),(960,467742600,1),(960,478629000,2),(960,499192200,1),(960,511288200,2),(960,530037000,1),(960,542737800,2),(960,562091400,1),(960,574792200,2),(960,594145800,1),(960,606241800,2),(960,625595400,1),(960,637691400,2),(960,657045000,1),(960,667931400,2),(960,688494600,1),(960,701195400,2),(960,719944200,1),(960,731435400,2),(960,751998600,1),(960,764094600,2),(960,783448200,1),(960,796149000,2),(960,814897800,1),(960,828203400,2),(960,846347400,1),(960,859653000,2),(960,877797000,1),(960,891102600,2),(960,909246600,1),(960,922552200,2),(960,941301000,1),(960,954001800,2),(960,972750600,1),(960,985451400,2),(960,1004200200,1),(960,1017505800,2),(960,1035649800,1),(960,1048955400,2),(960,1067099400,1),(960,1080405000,2),(960,1099153800,1),(960,1111854600,2),(960,1130603400,1),(960,1143909000,2),(960,1162053000,1),(960,1174753800,2),(960,1193502600,1),(960,1207413000,2),(960,1223137800,1),(960,1238862600,2),(960,1254587400,1),(960,1270312200,2),(960,1286037000,1),(960,1301761800,2),(960,1317486600,1),(960,1333211400,2),(960,1349541000,1),(960,1365265800,2),(960,1380990600,1),(960,1396715400,2),(960,1412440200,1),(960,1428165000,2),(960,1443889800,1),(960,1459614600,2),(960,1475339400,1),(960,1491064200,2),(960,1506789000,1),(960,1522513800,2),(960,1538843400,1),(960,1554568200,2),(960,1570293000,1),(960,1586017800,2),(960,1601742600,1),(960,1617467400,2),(960,1633192200,1),(960,1648917000,2),(960,1664641800,1),(960,1680366600,2),(960,1696091400,1),(960,1712421000,2),(960,1728145800,1),(960,1743870600,2),(960,1759595400,1),(960,1775320200,2),(960,1791045000,1),(960,1806769800,2),(960,1822494600,1),(960,1838219400,2),(960,1853944200,1),(960,1869669000,2),(960,1885998600,1),(960,1901723400,2),(960,1917448200,1),(960,1933173000,2),(960,1948897800,1),(960,1964622600,2),(960,1980347400,1),(960,1996072200,2),(960,2011797000,1),(960,2027521800,2),(960,2043246600,1),(960,2058971400,2),(960,2075301000,1),(960,2091025800,2),(960,2106750600,1),(960,2122475400,2),(960,2138200200,1),(961,-2147483648,3),(961,-1672560000,1),(961,-1665388800,2),(961,-883641600,1),(961,-876124800,2),(961,-860400000,1),(961,-844675200,2),(961,-828345600,1),(961,-813225600,2),(961,31500000,3),(961,57686400,1),(961,67968000,2),(961,89136000,1),(961,100022400,2),(961,120585600,1),(961,131472000,2),(961,152035200,1),(961,162921600,2),(961,183484800,1),(961,194976000,2),(961,215539200,1),(961,226425600,2),(961,246988800,1),(961,257875200,2),(961,278438400,1),(961,289324800,2),(961,309888000,1),(961,320774400,2),(961,341337600,1),(961,352224000,2),(961,372787200,1),(961,386697600,2),(961,404841600,1),(961,415728000,2),(961,436291200,1),(961,447177600,2),(961,467740800,1),(961,478627200,2),(961,499190400,1),(961,511286400,2),(961,530035200,1),(961,542736000,2),(961,562089600,1),(961,574790400,2),(961,594144000,1),(961,606240000,2),(961,625593600,1),(961,636480000,2),(961,657043200,1),(961,667929600,2),(961,688492800,1),(961,699379200,2),(961,719942400,1),(961,731433600,2),(961,751996800,1),(961,762883200,2),(961,783446400,1),(961,794332800,2),(961,814896000,1),(961,828201600,2),(961,846345600,1),(961,859651200,2),(961,877795200,1),(961,891100800,2),(961,909244800,1),(961,922550400,2),(961,941299200,1),(961,954000000,2),(961,967305600,1),(961,985449600,2),(961,1004198400,1),(961,1017504000,2),(961,1035648000,1),(961,1048953600,2),(961,1067097600,1),(961,1080403200,2),(961,1099152000,1),(961,1111852800,2),(961,1130601600,1),(961,1143907200,2),(961,1162051200,1),(961,1174752000,2),(961,1193500800,1),(961,1207411200,2),(961,1223136000,1),(961,1238860800,2),(961,1254585600,1),(961,1270310400,2),(961,1286035200,1),(961,1301760000,2),(961,1317484800,1),(961,1333209600,2),(961,1349539200,1),(961,1365264000,2),(961,1380988800,1),(961,1396713600,2),(961,1412438400,1),(961,1428163200,2),(961,1443888000,1),(961,1459612800,2),(961,1475337600,1),(961,1491062400,2),(961,1506787200,1),(961,1522512000,2),(961,1538841600,1),(961,1554566400,2),(961,1570291200,1),(961,1586016000,2),(961,1601740800,1),(961,1617465600,2),(961,1633190400,1),(961,1648915200,2),(961,1664640000,1),(961,1680364800,2),(961,1696089600,1),(961,1712419200,2),(961,1728144000,1),(961,1743868800,2),(961,1759593600,1),(961,1775318400,2),(961,1791043200,1),(961,1806768000,2),(961,1822492800,1),(961,1838217600,2),(961,1853942400,1),(961,1869667200,2),(961,1885996800,1),(961,1901721600,2),(961,1917446400,1),(961,1933171200,2),(961,1948896000,1),(961,1964620800,2),(961,1980345600,1),(961,1996070400,2),(961,2011795200,1),(961,2027520000,2),(961,2043244800,1),(961,2058969600,2),(961,2075299200,1),(961,2091024000,2),(961,2106748800,1),(961,2122473600,2),(961,2138198400,1),(962,-2147483648,3),(962,-1680508800,1),(962,-1665388800,2),(962,-1646640000,1),(962,-1635753600,2),(962,-1615190400,1),(962,-1604304000,2),(962,-1583920800,3),(962,-883641600,1),(962,-876124800,2),(962,-860400000,1),(962,-844675200,2),(962,-828345600,1),(962,-813225600,2),(962,-94730400,3),(962,-71136000,1),(962,-55411200,2),(962,-37267200,1),(962,-25776000,2),(962,-5817600,1),(962,5673600,2),(962,25632000,1),(962,37728000,2),(962,57686400,1),(962,67968000,2),(962,89136000,1),(962,100022400,2),(962,120585600,1),(962,131472000,2),(962,152035200,1),(962,162921600,2),(962,183484800,1),(962,194976000,2),(962,215539200,1),(962,226425600,2),(962,246988800,1),(962,257875200,2),(962,278438400,1),(962,289324800,2),(962,309888000,1),(962,320774400,2),(962,341337600,1),(962,352224000,2),(962,372787200,1),(962,386092800,2),(962,404841600,1),(962,417542400,2),(962,436291200,1),(962,447177600,2),(962,467740800,1),(962,478627200,2),(962,499190400,1),(962,510076800,2),(962,530035200,1),(962,542736000,2),(962,562089600,1),(962,574790400,2),(962,594144000,1),(962,606240000,2),(962,625593600,1),(962,637689600,2),(962,657043200,1),(962,670348800,2),(962,686678400,1),(962,701798400,2),(962,718128000,1),(962,733248000,2),(962,749577600,1),(962,764697600,2),(962,781027200,1),(962,796147200,2),(962,812476800,1),(962,828201600,2),(962,844531200,1),(962,859651200,2),(962,875980800,1),(962,891100800,2),(962,907430400,1),(962,922550400,2),(962,938880000,1),(962,954000000,2),(962,967305600,1),(962,985449600,2),(962,1002384000,1),(962,1017504000,2),(962,1033833600,1),(962,1048953600,2),(962,1065283200,1),(962,1080403200,2),(962,1096732800,1),(962,1111852800,2),(962,1128182400,1),(962,1143907200,2),(962,1159632000,1),(962,1174752000,2),(962,1191686400,1),(962,1207411200,2),(962,1223136000,1),(962,1238860800,2),(962,1254585600,1),(962,1270310400,2),(962,1286035200,1),(962,1301760000,2),(962,1317484800,1),(962,1333209600,2),(962,1349539200,1),(962,1365264000,2),(962,1380988800,1),(962,1396713600,2),(962,1412438400,1),(962,1428163200,2),(962,1443888000,1),(962,1459612800,2),(962,1475337600,1),(962,1491062400,2),(962,1506787200,1),(962,1522512000,2),(962,1538841600,1),(962,1554566400,2),(962,1570291200,1),(962,1586016000,2),(962,1601740800,1),(962,1617465600,2),(962,1633190400,1),(962,1648915200,2),(962,1664640000,1),(962,1680364800,2),(962,1696089600,1),(962,1712419200,2),(962,1728144000,1),(962,1743868800,2),(962,1759593600,1),(962,1775318400,2),(962,1791043200,1),(962,1806768000,2),(962,1822492800,1),(962,1838217600,2),(962,1853942400,1),(962,1869667200,2),(962,1885996800,1),(962,1901721600,2),(962,1917446400,1),(962,1933171200,2),(962,1948896000,1),(962,1964620800,2),(962,1980345600,1),(962,1996070400,2),(962,2011795200,1),(962,2027520000,2),(962,2043244800,1),(962,2058969600,2),(962,2075299200,1),(962,2091024000,2),(962,2106748800,1),(962,2122473600,2),(962,2138198400,1),(963,-2147483648,3),(963,-1672560000,1),(963,-1665388800,2),(963,-883641600,1),(963,-876124800,2),(963,-860400000,1),(963,-844675200,2),(963,-828345600,1),(963,-813225600,2),(963,31500000,3),(963,57686400,1),(963,67968000,2),(963,89136000,1),(963,100022400,2),(963,120585600,1),(963,131472000,2),(963,152035200,1),(963,162921600,2),(963,183484800,1),(963,194976000,2),(963,215539200,1),(963,226425600,2),(963,246988800,1),(963,257875200,2),(963,278438400,1),(963,289324800,2),(963,309888000,1),(963,320774400,2),(963,341337600,1),(963,352224000,2),(963,372787200,1),(963,384278400,2),(963,404841600,1),(963,415728000,2),(963,436291200,1),(963,447177600,2),(963,467740800,1),(963,478627200,2),(963,499190400,1),(963,511286400,2),(963,530035200,1),(963,542736000,2),(963,561484800,1),(963,574790400,2),(963,594144000,1),(963,606240000,2),(963,625593600,1),(963,637689600,2),(963,657043200,1),(963,667929600,2),(963,688492800,1),(963,699379200,2),(963,719942400,1),(963,731433600,2),(963,751996800,1),(963,762883200,2),(963,783446400,1),(963,796147200,2),(963,814896000,1),(963,828201600,2),(963,846345600,1),(963,859651200,2),(963,877795200,1),(963,891100800,2),(963,909244800,1),(963,922550400,2),(963,941299200,1),(963,954000000,2),(963,967305600,1),(963,985449600,2),(963,1004198400,1),(963,1017504000,2),(963,1035648000,1),(963,1048953600,2),(963,1067097600,1),(963,1080403200,2),(963,1099152000,1),(963,1111852800,2),(963,1130601600,1),(963,1143907200,2),(963,1162051200,1),(963,1174752000,2),(963,1193500800,1),(963,1207411200,2),(963,1223136000,1),(963,1238860800,2),(963,1254585600,1),(963,1270310400,2),(963,1286035200,1),(963,1301760000,2),(963,1317484800,1),(963,1333209600,2),(963,1349539200,1),(963,1365264000,2),(963,1380988800,1),(963,1396713600,2),(963,1412438400,1),(963,1428163200,2),(963,1443888000,1),(963,1459612800,2),(963,1475337600,1),(963,1491062400,2),(963,1506787200,1),(963,1522512000,2),(963,1538841600,1),(963,1554566400,2),(963,1570291200,1),(963,1586016000,2),(963,1601740800,1),(963,1617465600,2),(963,1633190400,1),(963,1648915200,2),(963,1664640000,1),(963,1680364800,2),(963,1696089600,1),(963,1712419200,2),(963,1728144000,1),(963,1743868800,2),(963,1759593600,1),(963,1775318400,2),(963,1791043200,1),(963,1806768000,2),(963,1822492800,1),(963,1838217600,2),(963,1853942400,1),(963,1869667200,2),(963,1885996800,1),(963,1901721600,2),(963,1917446400,1),(963,1933171200,2),(963,1948896000,1),(963,1964620800,2),(963,1980345600,1),(963,1996070400,2),(963,2011795200,1),(963,2027520000,2),(963,2043244800,1),(963,2058969600,2),(963,2075299200,1),(963,2091024000,2),(963,2106748800,1),(963,2122473600,2),(963,2138198400,1),(964,-2147483648,3),(964,-1672552800,1),(964,-1665381600,2),(964,-883634400,1),(964,-876117600,2),(964,-860392800,1),(964,-844668000,2),(964,-836467200,3),(964,152042400,1),(964,162928800,2),(964,436298400,1),(964,447184800,2),(964,690314400,1),(964,699386400,2),(964,1165082400,1),(964,1174759200,2),(964,1193508000,1),(964,1206813600,2),(964,1224957600,1),(964,1238263200,2),(965,-2147483648,3),(965,-1672558200,1),(965,-1665387000,2),(965,-883639800,1),(965,-876123000,2),(965,-860398200,1),(965,-844673400,2),(965,-828343800,1),(965,-813223800,2),(965,31501800,3),(965,57688200,1),(965,67969800,2),(965,89137800,1),(965,100024200,2),(965,120587400,1),(965,131473800,2),(965,152037000,1),(965,162923400,2),(965,183486600,1),(965,194977800,2),(965,215541000,1),(965,226427400,2),(965,246990600,1),(965,257877000,2),(965,278440200,1),(965,289326600,2),(965,309889800,1),(965,320776200,2),(965,341339400,1),(965,352225800,2),(965,372789000,1),(965,386699400,2),(965,404843400,1),(965,415729800,2),(965,436293000,1),(965,447179400,2),(965,467742600,1),(965,478629000,2),(965,499192200,1),(965,511288200,2),(965,530037000,1),(965,542737800,2),(965,562091400,1),(965,574792200,2),(965,594145800,1),(965,606241800,2),(965,625595400,1),(965,636481800,2),(965,657045000,1),(965,667931400,2),(965,688494600,1),(965,699381000,2),(965,719944200,1),(965,731435400,2),(965,751998600,1),(965,762885000,2),(965,783448200,1),(965,794334600,2),(965,814897800,1),(965,828203400,2),(965,846347400,1),(965,859653000,2),(965,877797000,1),(965,891102600,2),(965,909246600,1),(965,922552200,2),(965,941301000,1),(965,946647000,4),(965,954001800,2),(965,972750600,1),(965,985451400,2),(965,1004200200,1),(965,1017505800,2),(965,1035649800,1),(965,1048955400,2),(965,1067099400,1),(965,1080405000,2),(965,1099153800,1),(965,1111854600,2),(965,1130603400,1),(965,1143909000,2),(965,1162053000,1),(965,1174753800,2),(965,1193502600,1),(965,1207413000,2),(965,1223137800,1),(965,1238862600,2),(965,1254587400,1),(965,1270312200,2),(965,1286037000,1),(965,1301761800,2),(965,1317486600,1),(965,1333211400,2),(965,1349541000,1),(965,1365265800,2),(965,1380990600,1),(965,1396715400,2),(965,1412440200,1),(965,1428165000,2),(965,1443889800,1),(965,1459614600,2),(965,1475339400,1),(965,1491064200,2),(965,1506789000,1),(965,1522513800,2),(965,1538843400,1),(965,1554568200,2),(965,1570293000,1),(965,1586017800,2),(965,1601742600,1),(965,1617467400,2),(965,1633192200,1),(965,1648917000,2),(965,1664641800,1),(965,1680366600,2),(965,1696091400,1),(965,1712421000,2),(965,1728145800,1),(965,1743870600,2),(965,1759595400,1),(965,1775320200,2),(965,1791045000,1),(965,1806769800,2),(965,1822494600,1),(965,1838219400,2),(965,1853944200,1),(965,1869669000,2),(965,1885998600,1),(965,1901723400,2),(965,1917448200,1),(965,1933173000,2),(965,1948897800,1),(965,1964622600,2),(965,1980347400,1),(965,1996072200,2),(965,2011797000,1),(965,2027521800,2),(965,2043246600,1),(965,2058971400,2),(965,2075301000,1),(965,2091025800,2),(965,2106750600,1),(965,2122475400,2),(965,2138200200,1),(966,-2147483648,0),(966,-1767209328,2),(966,-1206950400,1),(966,-1191355200,2),(966,-1175367600,1),(966,-1159819200,2),(966,-633812400,1),(966,-622062000,2),(966,-602276400,1),(966,-591825600,2),(966,-570740400,1),(966,-560203200,2),(966,-539118000,1),(966,-531345600,2),(966,-191358000,1),(966,-184190400,2),(966,-155156400,1),(966,-150062400,2),(966,-128890800,1),(966,-121118400,2),(966,-99946800,1),(966,-89582400,2),(966,-68410800,1),(966,-57960000,2),(966,499755600,1),(966,511243200,2),(966,530600400,1),(966,540273600,2),(966,562136400,1),(966,571204800,2),(966,1214283600,3),(966,1384056000,2),(966,2147483647,2),(967,-2147483648,0),(967,-1767217820,2),(967,-1206961200,1),(967,-1191366000,2),(967,-1175378400,1),(967,-1159830000,2),(967,-633823200,1),(967,-622072800,2),(967,-602287200,1),(967,-591836400,2),(967,-570751200,1),(967,-560214000,2),(967,-539128800,1),(967,-531356400,2),(967,-191368800,1),(967,-184201200,2),(967,-155167200,1),(967,-150073200,2),(967,-128901600,1),(967,-121129200,2),(967,-99957600,1),(967,-89593200,2),(967,-68421600,1),(967,-57970800,2),(967,499744800,1),(967,511232400,2),(967,530589600,1),(967,540262800,2),(967,562125600,1),(967,571194000,2),(967,592970400,1),(967,602038800,2),(967,624420000,1),(967,634698000,2),(967,938916000,1),(967,951613200,2),(967,970970400,1),(967,971571600,2),(967,1003024800,1),(967,1013907600,2),(967,2147483647,2),(968,-2147483648,0),(968,-1767214412,2),(968,-1206957600,1),(968,-1191362400,2),(968,-1175374800,1),(968,-1159826400,2),(968,-633819600,1),(968,-622069200,2),(968,-602283600,1),(968,-591832800,2),(968,-570747600,1),(968,-560210400,2),(968,-539125200,1),(968,-531352800,2),(968,-195426000,1),(968,-184197600,2),(968,-155163600,1),(968,-150069600,2),(968,-128898000,1),(968,-121125600,2),(968,-99954000,1),(968,-89589600,2),(968,-68418000,1),(968,-57967200,2),(968,499748400,1),(968,511236000,2),(968,530593200,1),(968,540266400,2),(968,562129200,1),(968,571197600,2),(968,592974000,1),(968,602042400,2),(968,624423600,1),(968,634701600,2),(968,656478000,1),(968,666756000,2),(968,687927600,1),(968,697600800,2),(968,719982000,1),(968,728445600,2),(968,750826800,1),(968,761709600,2),(968,782276400,1),(968,793159200,2),(968,813726000,1),(968,824004000,2),(968,844570800,1),(968,856058400,2),(968,876106800,1),(968,888717600,2),(968,908074800,1),(968,919562400,2),(968,938919600,1),(968,951616800,2),(968,970974000,1),(968,982461600,2),(968,1003028400,1),(968,1013911200,2),(968,1036292400,1),(968,1045360800,2),(968,1066532400,1),(968,1076810400,2),(968,1099364400,1),(968,1108864800,2),(968,1129431600,1),(968,1140314400,2),(968,1162695600,1),(968,1172368800,2),(968,1192330800,1),(968,1203213600,2),(968,1224385200,1),(968,1234663200,2),(968,1255834800,1),(968,1266717600,2),(968,1287284400,1),(968,1298167200,2),(968,1318734000,1),(968,1330221600,2),(968,1350788400,1),(968,1361066400,2),(968,1382238000,1),(968,1392516000,2),(968,1413687600,1),(968,1424570400,2),(968,1445137200,1),(968,1456020000,2),(968,1476586800,1),(968,1487469600,2),(968,1508036400,1),(968,1518919200,2),(968,1541300400,1),(968,1550368800,2),(968,2147483647,2),(969,-2147483648,0),(969,-1767211196,2),(969,-1206954000,1),(969,-1191358800,2),(969,-1175371200,1),(969,-1159822800,2),(969,-633816000,1),(969,-622065600,2),(969,-602280000,1),(969,-591829200,2),(969,-570744000,1),(969,-560206800,2),(969,-539121600,1),(969,-531349200,2),(969,-191361600,1),(969,-184194000,2),(969,-155160000,1),(969,-150066000,2),(969,-128894400,1),(969,-121122000,2),(969,-99950400,1),(969,-89586000,2),(969,-68414400,1),(969,-57963600,2),(969,499752000,1),(969,511239600,2),(969,530596800,1),(969,540270000,2),(969,562132800,1),(969,571201200,2),(969,750830400,1),(969,761713200,2),(969,2147483647,2),(970,-1693706400,0),(970,-1680483600,1),(970,-1663455600,2),(970,-1650150000,3),(970,-1632006000,2),(970,-1618700400,3),(970,-938905200,2),(970,-857257200,3),(970,-844556400,2),(970,-828226800,3),(970,-812502000,2),(970,-796777200,3),(970,-781052400,2),(970,-766623600,3),(970,228877200,2),(970,243997200,3),(970,260326800,2),(970,276051600,3),(970,291776400,2),(970,307501200,3),(970,323830800,2),(970,338950800,3),(970,354675600,2),(970,370400400,3),(970,386125200,2),(970,401850000,3),(970,417574800,2),(970,433299600,3),(970,449024400,2),(970,465354000,3),(970,481078800,2),(970,496803600,3),(970,512528400,2),(970,528253200,3),(970,543978000,2),(970,559702800,3),(970,575427600,2),(970,591152400,3),(970,606877200,2),(970,622602000,3),(970,638326800,2),(970,654656400,3),(970,670381200,2),(970,686106000,3),(970,701830800,2),(970,717555600,3),(970,733280400,2),(970,749005200,3),(970,764730000,2),(970,780454800,3),(970,796179600,2),(970,811904400,3),(970,828234000,2),(970,846378000,3),(970,859683600,2),(970,877827600,3),(970,891133200,2),(970,909277200,3),(970,922582800,2),(970,941331600,3),(970,954032400,2),(970,972781200,3),(970,985482000,2),(970,1004230800,3),(970,1017536400,2),(970,1035680400,3),(970,1048986000,2),(970,1067130000,3),(970,1080435600,2),(970,1099184400,3),(970,1111885200,2),(970,1130634000,3),(970,1143334800,2),(970,1162083600,3),(970,1174784400,2),(970,1193533200,3),(970,1206838800,2),(970,1224982800,3),(970,1238288400,2),(970,1256432400,3),(970,1269738000,2),(970,1288486800,3),(970,1301187600,2),(970,1319936400,3),(970,1332637200,2),(970,1351386000,3),(970,1364691600,2),(970,1382835600,3),(970,1396141200,2),(970,1414285200,3),(970,1427590800,2),(970,1445734800,3),(970,1459040400,2),(970,1477789200,3),(970,1490490000,2),(970,1509238800,3),(970,1521939600,2),(970,1540688400,3),(970,1553994000,2),(970,1572138000,3),(970,1585443600,2),(970,1603587600,3),(970,1616893200,2),(970,1635642000,3),(970,1648342800,2),(970,1667091600,3),(970,1679792400,2),(970,1698541200,3),(970,1711846800,2),(970,1729990800,3),(970,1743296400,2),(970,1761440400,3),(970,1774746000,2),(970,1792890000,3),(970,1806195600,2),(970,1824944400,3),(970,1837645200,2),(970,1856394000,3),(970,1869094800,2),(970,1887843600,3),(970,1901149200,2),(970,1919293200,3),(970,1932598800,2),(970,1950742800,3),(970,1964048400,2),(970,1982797200,3),(970,1995498000,2),(970,2014246800,3),(970,2026947600,2),(970,2045696400,3),(970,2058397200,2),(970,2077146000,3),(970,2090451600,2),(970,2108595600,3),(970,2121901200,2),(970,2140045200,3),(971,-1633276800,0),(971,-1615136400,1),(971,-1601827200,0),(971,-1583686800,1),(971,-880214400,2),(971,-769395600,3),(971,-765392400,1),(971,-84384000,0),(971,-68662800,1),(971,-52934400,0),(971,-37213200,1),(971,-21484800,0),(971,-5763600,1),(971,9964800,0),(971,25686000,1),(971,41414400,0),(971,57740400,1),(971,73468800,0),(971,89190000,1),(971,104918400,0),(971,120639600,1),(971,126691200,0),(971,152089200,1),(971,162374400,0),(971,183538800,1),(971,199267200,0),(971,215593200,1),(971,230716800,0),(971,247042800,1),(971,262771200,0),(971,278492400,1),(971,294220800,0),(971,309942000,1),(971,325670400,0),(971,341391600,1),(971,357120000,0),(971,372841200,1),(971,388569600,0),(971,404895600,1),(971,420019200,0),(971,436345200,1),(971,452073600,0),(971,467794800,1),(971,483523200,0),(971,499244400,1),(971,514972800,0),(971,530694000,1),(971,544608000,0),(971,562143600,1),(971,576057600,0),(971,594198000,1),(971,607507200,0),(971,625647600,1),(971,638956800,0),(971,657097200,1),(971,671011200,0),(971,688546800,1),(971,702460800,0),(971,719996400,1),(971,733910400,0),(971,752050800,1),(971,765360000,0),(971,783500400,1),(971,796809600,0),(971,814950000,1),(971,828864000,0),(971,846399600,1),(971,860313600,0),(971,877849200,1),(971,891763200,0),(971,909298800,1),(971,923212800,0),(971,941353200,1),(971,954662400,0),(971,972802800,1),(971,986112000,0),(971,1004252400,1),(971,1018166400,0),(971,1035702000,1),(971,1049616000,0),(971,1067151600,1),(971,1081065600,0),(971,1099206000,1),(971,1112515200,0),(971,1130655600,1),(971,1143964800,0),(971,1162105200,1),(971,1173600000,0),(971,1194159600,1),(971,1205049600,0),(971,1225609200,1),(971,1236499200,0),(971,1257058800,1),(971,1268553600,0),(971,1289113200,1),(971,1300003200,0),(971,1320562800,1),(971,1331452800,0),(971,1352012400,1),(971,1362902400,0),(971,1383462000,1),(971,1394352000,0),(971,1414911600,1),(971,1425801600,0),(971,1446361200,1),(971,1457856000,0),(971,1478415600,1),(971,1489305600,0),(971,1509865200,1),(971,1520755200,0),(971,1541314800,1),(971,1552204800,0),(971,1572764400,1),(971,1583654400,0),(971,1604214000,1),(971,1615708800,0),(971,1636268400,1),(971,1647158400,0),(971,1667718000,1),(971,1678608000,0),(971,1699167600,1),(971,1710057600,0),(971,1730617200,1),(971,1741507200,0),(971,1762066800,1),(971,1772956800,0),(971,1793516400,1),(971,1805011200,0),(971,1825570800,1),(971,1836460800,0),(971,1857020400,1),(971,1867910400,0),(971,1888470000,1),(971,1899360000,0),(971,1919919600,1),(971,1930809600,0),(971,1951369200,1),(971,1962864000,0),(971,1983423600,1),(971,1994313600,0),(971,2014873200,1),(971,2025763200,0),(971,2046322800,1),(971,2057212800,0),(971,2077772400,1),(971,2088662400,0),(971,2109222000,1),(971,2120112000,0),(971,2140671600,1),(972,-2147483648,0),(972,-2131645536,2),(972,-1696276800,1),(972,-1680469200,2),(972,-1632074400,1),(972,-1615143600,2),(972,-1566763200,1),(972,-1557090000,2),(972,-1535486400,1),(972,-1524949200,2),(972,-1504468800,1),(972,-1493413200,2),(972,-1472414400,1),(972,-1461963600,2),(972,-1440964800,1),(972,-1429390800,2),(972,-1409515200,1),(972,-1396731600,2),(972,-1376856000,1),(972,-1366491600,2),(972,-1346616000,1),(972,-1333832400,2),(972,-1313956800,1),(972,-1303678800,2),(972,-1282507200,1),(972,-1272661200,2),(972,-1251057600,1),(972,-1240088400,2),(972,-1219608000,1),(972,-1207429200,2),(972,-1188763200,1),(972,-1175979600,2),(972,-1157313600,1),(972,-1143925200,2),(972,-1124049600,1),(972,-1113771600,2),(972,-1091390400,1),(972,-1081026000,2),(972,-1059854400,1),(972,-1050786000,2),(972,-1030910400,1),(972,-1018126800,2),(972,-999460800,1),(972,-986677200,2),(972,-965592000,1),(972,-955227600,2),(972,-935956800,1),(972,-923173200,2),(972,-904507200,1),(972,-891723600,2),(972,-880221600,3),(972,-769395600,4),(972,-765399600,2),(972,-747252000,1),(972,-733950000,2),(972,-715802400,1),(972,-702500400,2),(972,-684352800,1),(972,-671050800,2),(972,-652903200,1),(972,-639601200,2),(972,-589399200,1),(972,-576097200,2),(972,-557949600,1),(972,-544647600,2),(972,-526500000,1),(972,-513198000,2),(972,-495050400,1),(972,-481748400,2),(972,-431546400,1),(972,-418244400,2),(972,-400096800,1),(972,-386794800,2),(972,-368647200,1),(972,-355345200,2),(972,-337197600,1),(972,-323895600,2),(972,-242244000,1),(972,-226522800,2),(972,-210794400,1),(972,-195073200,2),(972,-179344800,1),(972,-163623600,2),(972,-147895200,1),(972,-131569200,2),(972,-116445600,1),(972,-100119600,2),(972,-84391200,1),(972,-68670000,2),(972,-52941600,1),(972,-37220400,2),(972,-21492000,1),(972,-5770800,2),(972,9957600,1),(972,25678800,2),(972,41407200,1),(972,57733200,2),(972,73461600,1),(972,89182800,2),(972,104911200,1),(972,120632400,2),(972,136360800,1),(972,152082000,2),(972,167810400,1),(972,183531600,2),(972,199260000,1),(972,215586000,2),(972,230709600,1),(972,247035600,2),(972,262764000,1),(972,278485200,2),(972,294213600,1),(972,309934800,2),(972,325663200,1),(972,341384400,2),(972,357112800,1),(972,372834000,2),(972,388562400,1),(972,404888400,2),(972,420012000,1),(972,436338000,2),(972,452066400,1),(972,467787600,2),(972,483516000,1),(972,499237200,2),(972,514965600,1),(972,530686800,2),(972,544600800,1),(972,562136400,2),(972,576050400,1),(972,594190800,2),(972,607500000,1),(972,625640400,2),(972,638949600,1),(972,657090000,2),(972,671004000,1),(972,688539600,2),(972,702453600,1),(972,719989200,2),(972,733903200,1),(972,752043600,2),(972,765352800,1),(972,783493200,2),(972,796802400,1),(972,814942800,2),(972,828856800,1),(972,846392400,2),(972,860306400,1),(972,877842000,2),(972,891756000,1),(972,909291600,2),(972,923205600,1),(972,941346000,2),(972,954655200,1),(972,972795600,2),(972,986104800,1),(972,1004245200,2),(972,1018159200,1),(972,1035694800,2),(972,1049608800,1),(972,1067144400,2),(972,1081058400,1),(972,1099198800,2),(972,1112508000,1),(972,1130648400,2),(972,1143957600,1),(972,1162098000,2),(972,1173592800,1),(972,1194152400,2),(972,1205042400,1),(972,1225602000,2),(972,1236492000,1),(972,1257051600,2),(972,1268546400,1),(972,1289106000,2),(972,1299996000,1),(972,1320555600,2),(972,1331445600,1),(972,1352005200,2),(972,1362895200,1),(972,1383454800,2),(972,1394344800,1),(972,1414904400,2),(972,1425794400,1),(972,1446354000,2),(972,1457848800,1),(972,1478408400,2),(972,1489298400,1),(972,1509858000,2),(972,1520748000,1),(972,1541307600,2),(972,1552197600,1),(972,1572757200,2),(972,1583647200,1),(972,1604206800,2),(972,1615701600,1),(972,1636261200,2),(972,1647151200,1),(972,1667710800,2),(972,1678600800,1),(972,1699160400,2),(972,1710050400,1),(972,1730610000,2),(972,1741500000,1),(972,1762059600,2),(972,1772949600,1),(972,1793509200,2),(972,1805004000,1),(972,1825563600,2),(972,1836453600,1),(972,1857013200,2),(972,1867903200,1),(972,1888462800,2),(972,1899352800,1),(972,1919912400,2),(972,1930802400,1),(972,1951362000,2),(972,1962856800,1),(972,1983416400,2),(972,1994306400,1),(972,2014866000,2),(972,2025756000,1),(972,2046315600,2),(972,2057205600,1),(972,2077765200,2),(972,2088655200,1),(972,2109214800,2),(972,2120104800,1),(972,2140664400,2),(973,-2147483648,2),(973,-1694368800,1),(973,-1681671600,2),(973,-1632067200,1),(973,-1615136400,2),(973,-1029686400,1),(973,-1018198800,2),(973,-880214400,3),(973,-769395600,4),(973,-765392400,2),(973,-746035200,1),(973,-732733200,2),(973,-715795200,1),(973,-702493200,2),(973,-684345600,1),(973,-671043600,2),(973,-652896000,1),(973,-639594000,2),(973,-620755200,1),(973,-607626000,2),(973,-589392000,1),(973,-576090000,2),(973,-557942400,1),(973,-544640400,2),(973,-526492800,1),(973,-513190800,2),(973,-495043200,1),(973,-481741200,2),(973,-463593600,1),(973,-450291600,2),(973,-431539200,1),(973,-418237200,2),(973,-400089600,1),(973,-386787600,2),(973,-368640000,1),(973,-355338000,2),(973,-337190400,1),(973,-321469200,2),(973,-305740800,1),(973,-292438800,2),(973,-210787200,1),(973,-198090000,2),(973,-116438400,5),(973,-100108800,6),(973,-84384000,5),(973,-68659200,6),(973,-52934400,5),(973,-37209600,6),(973,-21484800,5),(973,-5760000,6),(973,9964800,5),(973,25689600,6),(973,41414400,5),(973,57744000,6),(973,73468800,5),(973,89193600,6),(973,104918400,5),(973,120643200,6),(973,136368000,5),(973,152092800,6),(973,167817600,5),(973,183542400,6),(973,199267200,5),(973,215596800,6),(973,230716800,5),(973,247046400,6),(973,262771200,5),(973,278496000,6),(973,294220800,5),(973,309945600,6),(973,325670400,5),(973,341395200,6),(973,357120000,5),(973,372844800,6),(973,388569600,5),(973,404899200,6),(973,420019200,5),(973,436348800,6),(973,452073600,5),(973,467798400,6),(973,483523200,5),(973,499248000,6),(973,514972800,5),(973,530697600,6),(973,544608000,5),(973,562147200,6),(973,576057600,5),(973,594201600,6),(973,607507200,5),(973,625651200,6),(973,638956800,5),(973,657100800,6),(973,671011200,5),(973,688550400,6),(973,702460800,5),(973,720000000,6),(973,733910400,5),(973,752054400,6),(973,765360000,5),(973,783504000,6),(973,796809600,5),(973,814953600,6),(973,828864000,5),(973,846403200,6),(973,860313600,5),(973,877852800,6),(973,891763200,5),(973,909302400,6),(973,923212800,5),(973,941356800,6),(973,954662400,5),(973,972806400,6),(973,986112000,5),(973,1004256000,6),(973,1018166400,5),(973,1035705600,6),(973,1049616000,5),(973,1067155200,6),(973,1081065600,5),(973,1099209600,6),(973,1112515200,5),(973,1130659200,6),(973,1136095200,2),(973,1143964800,1),(973,1162105200,2),(973,1173600000,1),(973,1194159600,2),(973,1205049600,1),(973,1225609200,2),(973,1236499200,1),(973,1257058800,2),(973,1268553600,1),(973,1289113200,2),(973,1300003200,1),(973,1320562800,2),(973,1331452800,1),(973,1352012400,2),(973,1362902400,1),(973,1383462000,2),(973,1394352000,1),(973,1414911600,2),(973,1425801600,1),(973,1446361200,2),(973,1457856000,1),(973,1478415600,2),(973,1489305600,1),(973,1509865200,2),(973,1520755200,1),(973,1541314800,2),(973,1552204800,1),(973,1572764400,2),(973,1583654400,1),(973,1604214000,2),(973,1615708800,1),(973,1636268400,2),(973,1647158400,1),(973,1667718000,2),(973,1678608000,1),(973,1699167600,2),(973,1710057600,1),(973,1730617200,2),(973,1741507200,1),(973,1762066800,2),(973,1772956800,1),(973,1793516400,2),(973,1805011200,1),(973,1825570800,2),(973,1836460800,1),(973,1857020400,2),(973,1867910400,1),(973,1888470000,2),(973,1899360000,1),(973,1919919600,2),(973,1930809600,1),(973,1951369200,2),(973,1962864000,1),(973,1983423600,2),(973,1994313600,1),(973,2014873200,2),(973,2025763200,1),(973,2046322800,2),(973,2057212800,1),(973,2077772400,2),(973,2088662400,1),(973,2109222000,2),(973,2120112000,1),(973,2140671600,2),(974,-2147483648,2),(974,-1632070800,1),(974,-1615140000,2),(974,-1601753400,1),(974,-1583697600,2),(974,-1567357200,1),(974,-1554667200,2),(974,-1534698000,1),(974,-1524074400,2),(974,-1503248400,1),(974,-1492365600,2),(974,-1471798800,1),(974,-1460916000,2),(974,-1440954000,1),(974,-1428861600,2),(974,-1409504400,1),(974,-1397412000,2),(974,-1378054800,1),(974,-1365962400,2),(974,-1346605200,1),(974,-1333908000,2),(974,-1315155600,1),(974,-1301853600,2),(974,-1283706000,1),(974,-1270404000,2),(974,-1252256400,1),(974,-1238954400,2),(974,-1220806800,1),(974,-1207504800,2),(974,-1188752400,1),(974,-1176055200,2),(974,-1157302800,1),(974,-1144000800,2),(974,-1125853200,1),(974,-1112551200,2),(974,-1094403600,1),(974,-1081101600,2),(974,-1062954000,1),(974,-1049652000,2),(974,-1031504400,1),(974,-1018202400,2),(974,-1000054800,1),(974,-986752800,2),(974,-968000400,1),(974,-955303200,2),(974,-936550800,1),(974,-880218000,3),(974,-769395600,4),(974,-765396000,2),(974,-747248400,1),(974,-733946400,2),(974,-715806000,1),(974,-702504000,2),(974,-684356400,1),(974,-671054400,2),(974,-652906800,1),(974,-634161600,2),(974,-620845200,1),(974,-602704800,2),(974,-589395600,1),(974,-576093600,2),(974,-557946000,1),(974,-544644000,2),(974,-526496400,1),(974,-513194400,2),(974,-495046800,1),(974,-481744800,2),(974,-463597200,1),(974,-450295200,2),(974,-431542800,1),(974,-418240800,2),(974,-400093200,1),(974,-384372000,2),(974,-368643600,1),(974,-352922400,2),(974,-337194000,1),(974,-321472800,2),(974,-305744400,1),(974,-289418400,2),(974,-273690000,1),(974,-257968800,2),(974,-242240400,1),(974,-226519200,2),(974,-210790800,1),(974,-195069600,2),(974,-179341200,1),(974,-163620000,2),(974,-147891600,1),(974,-131565600,2),(974,-116442000,1),(974,-100116000,2),(974,-84387600,1),(974,-68666400,2),(974,-52938000,1),(974,-37216800,2),(974,-21488400,1),(974,-5767200,2),(974,9961200,1),(974,25682400,2),(974,41410800,1),(974,57736800,2),(974,73465200,1),(974,89186400,2),(974,104914800,1),(974,120636000,2),(974,136364400,1),(974,152085600,2),(974,167814000,1),(974,183535200,2),(974,199263600,1),(974,215589600,2),(974,230713200,1),(974,247039200,2),(974,262767600,1),(974,278488800,2),(974,294217200,1),(974,309938400,2),(974,325666800,1),(974,341388000,2),(974,357116400,1),(974,372837600,2),(974,388566000,1),(974,404892000,2),(974,420015600,1),(974,436341600,2),(974,452070000,1),(974,467791200,2),(974,483519600,1),(974,499240800,2),(974,514969200,1),(974,530690400,2),(974,544604400,1),(974,562140000,2),(974,576054000,1),(974,594194400,2),(974,607503600,1),(974,625644000,2),(974,638953200,1),(974,657093600,2),(974,671007600,1),(974,688543200,2),(974,702457200,1),(974,719992800,2),(974,733906800,1),(974,752047200,2),(974,765356400,1),(974,783496800,2),(974,796806000,1),(974,814946400,2),(974,828860400,1),(974,846396000,2),(974,860310000,1),(974,877845600,2),(974,891759600,1),(974,909295200,2),(974,923209200,1),(974,941349600,2),(974,954658800,1),(974,972799200,2),(974,986108400,1),(974,1004248800,2),(974,1018162800,1),(974,1035698400,2),(974,1049612400,1),(974,1067148000,2),(974,1081062000,1),(974,1099202400,2),(974,1112511600,1),(974,1130652000,2),(974,1143961200,1),(974,1162101600,2),(974,1173596400,1),(974,1194156000,2),(974,1205046000,1),(974,1225605600,2),(974,1236495600,1),(974,1257055200,2),(974,1268550000,1),(974,1289109600,2),(974,1299999600,1),(974,1320559200,2),(974,1331449200,1),(974,1352008800,2),(974,1362898800,1),(974,1383458400,2),(974,1394348400,1),(974,1414908000,2),(974,1425798000,1),(974,1446357600,2),(974,1457852400,1),(974,1478412000,2),(974,1489302000,1),(974,1509861600,2),(974,1520751600,1),(974,1541311200,2),(974,1552201200,1),(974,1572760800,2),(974,1583650800,1),(974,1604210400,2),(974,1615705200,1),(974,1636264800,2),(974,1647154800,1),(974,1667714400,2),(974,1678604400,1),(974,1699164000,2),(974,1710054000,1),(974,1730613600,2),(974,1741503600,1),(974,1762063200,2),(974,1772953200,1),(974,1793512800,2),(974,1805007600,1),(974,1825567200,2),(974,1836457200,1),(974,1857016800,2),(974,1867906800,1),(974,1888466400,2),(974,1899356400,1),(974,1919916000,2),(974,1930806000,1),(974,1951365600,2),(974,1962860400,1),(974,1983420000,2),(974,1994310000,1),(974,2014869600,2),(974,2025759600,1),(974,2046319200,2),(974,2057209200,1),(974,2077768800,2),(974,2088658800,1),(974,2109218400,2),(974,2120108400,1),(974,2140668000,2),(975,-2147483648,0),(975,-1998663968,2),(975,-1632063600,1),(975,-1615132800,2),(975,-1600614000,1),(975,-1596816000,2),(975,-1567954800,1),(975,-1551628800,2),(975,-1536505200,1),(975,-1523203200,2),(975,-1504450800,1),(975,-1491753600,2),(975,-1473001200,1),(975,-1459699200,2),(975,-880210800,3),(975,-769395600,4),(975,-765388800,2),(975,-715791600,1),(975,-702489600,2),(975,73472400,1),(975,89193600,2),(975,104922000,1),(975,120643200,2),(975,136371600,1),(975,152092800,2),(975,167821200,1),(975,183542400,2),(975,199270800,1),(975,215596800,2),(975,230720400,1),(975,247046400,2),(975,262774800,1),(975,278496000,2),(975,294224400,1),(975,309945600,2),(975,325674000,1),(975,341395200,2),(975,357123600,1),(975,372844800,2),(975,388573200,1),(975,404899200,2),(975,420022800,1),(975,436348800,2),(975,452077200,1),(975,467798400,2),(975,483526800,1),(975,499248000,2),(975,514976400,1),(975,530697600,2),(975,544611600,1),(975,562147200,2),(975,576061200,1),(975,594201600,2),(975,607510800,1),(975,625651200,2),(975,638960400,1),(975,657100800,2),(975,671014800,1),(975,688550400,2),(975,702464400,1),(975,720000000,2),(975,733914000,1),(975,752054400,2),(975,765363600,1),(975,783504000,2),(975,796813200,1),(975,814953600,2),(975,828867600,1),(975,846403200,2),(975,860317200,1),(975,877852800,2),(975,891766800,1),(975,909302400,2),(975,923216400,1),(975,941356800,2),(975,954666000,1),(975,972806400,2),(975,986115600,1),(975,1004256000,2),(975,1018170000,1),(975,1035705600,2),(975,1049619600,1),(975,1067155200,2),(975,1081069200,1),(975,1099209600,2),(975,1112518800,1),(975,1130659200,2),(975,1143968400,1),(975,1162108800,2),(975,1173603600,1),(975,1194163200,2),(975,1205053200,1),(975,1225612800,2),(975,1236502800,1),(975,1257062400,2),(975,1268557200,1),(975,1289116800,2),(975,1300006800,1),(975,1320566400,2),(975,1331456400,1),(975,1352016000,2),(975,1362906000,1),(975,1383465600,2),(975,1394355600,1),(975,1414915200,2),(975,1425805200,1),(975,1446364800,2),(975,1457859600,1),(975,1478419200,2),(975,1489309200,1),(975,1509868800,2),(975,1520758800,1),(975,1541318400,2),(975,1552208400,1),(975,1572768000,2),(975,1583658000,1),(975,1604217600,2),(975,1615712400,1),(975,1636272000,2),(975,1647162000,1),(975,1667721600,2),(975,1678611600,1),(975,1699171200,2),(975,1710061200,1),(975,1730620800,2),(975,1741510800,1),(975,1762070400,2),(975,1772960400,1),(975,1793520000,2),(975,1805014800,1),(975,1825574400,2),(975,1836464400,1),(975,1857024000,2),(975,1867914000,1),(975,1888473600,2),(975,1899363600,1),(975,1919923200,2),(975,1930813200,1),(975,1951372800,2),(975,1962867600,1),(975,1983427200,2),(975,1994317200,1),(975,2014876800,2),(975,2025766800,1),(975,2046326400,2),(975,2057216400,1),(975,2077776000,2),(975,2088666000,1),(975,2109225600,2),(975,2120115600,1),(975,2140675200,2),(976,-2147483648,2),(976,-1664130548,1),(976,-1650137348,2),(976,-1632076148,1),(976,-1615145348,2),(976,-1598650148,1),(976,-1590100148,2),(976,-1567286948,1),(976,-1551565748,2),(976,-1535837348,1),(976,-1520116148,2),(976,-1503782948,1),(976,-1488666548,2),(976,-1472333348,1),(976,-1457216948,2),(976,-1440883748,1),(976,-1425767348,2),(976,-1409434148,1),(976,-1394317748,2),(976,-1377984548,1),(976,-1362263348,2),(976,-1346534948,1),(976,-1330813748,2),(976,-1314480548,1),(976,-1299364148,2),(976,-1283030948,1),(976,-1267914548,2),(976,-1251581348,1),(976,-1236464948,2),(976,-1220131748,1),(976,-1205015348,2),(976,-1188682148,1),(976,-1172960948,2),(976,-1156627748,1),(976,-1141511348,2),(976,-1125178148,1),(976,-1110061748,2),(976,-1096921748,4),(976,-1093728600,3),(976,-1078612200,4),(976,-1061670600,3),(976,-1048973400,4),(976,-1030221000,3),(976,-1017523800,4),(976,-998771400,3),(976,-986074200,4),(976,-966717000,3),(976,-954624600,4),(976,-935267400,3),(976,-922570200,4),(976,-903817800,3),(976,-891120600,4),(976,-872368200,6),(976,-769395600,5),(976,-765401400,4),(976,-746044200,3),(976,-733347000,4),(976,-714594600,3),(976,-701897400,4),(976,-683145000,3),(976,-670447800,4),(976,-651695400,3),(976,-638998200,4),(976,-619641000,3),(976,-606943800,4),(976,-589401000,3),(976,-576099000,4),(976,-557951400,3),(976,-544649400,4),(976,-526501800,3),(976,-513199800,4),(976,-495052200,3),(976,-481750200,4),(976,-463602600,3),(976,-450300600,4),(976,-431548200,3),(976,-418246200,4),(976,-400098600,3),(976,-386796600,4),(976,-368649000,3),(976,-355347000,4),(976,-337199400,3),(976,-323897400,4),(976,-305749800,3),(976,-289423800,4),(976,-273695400,3),(976,-257974200,4),(976,-242245800,3),(976,-226524600,4),(976,-210796200,3),(976,-195075000,4),(976,-179346600,3),(976,-163625400,4),(976,-147897000,3),(976,-131571000,4),(976,-116447400,3),(976,-100121400,4),(976,-84393000,3),(976,-68671800,4),(976,-52943400,3),(976,-37222200,4),(976,-21493800,3),(976,-5772600,4),(976,9955800,3),(976,25677000,4),(976,41405400,3),(976,57731400,4),(976,73459800,3),(976,89181000,4),(976,104909400,3),(976,120630600,4),(976,136359000,3),(976,152080200,4),(976,167808600,3),(976,183529800,4),(976,199258200,3),(976,215584200,4),(976,230707800,3),(976,247033800,4),(976,262762200,3),(976,278483400,4),(976,294211800,3),(976,309933000,4),(976,325661400,3),(976,341382600,4),(976,357111000,3),(976,372832200,4),(976,388560600,3),(976,404886600,4),(976,420010200,3),(976,436336200,4),(976,452064600,3),(976,467785800,4),(976,483514200,3),(976,499235400,4),(976,514963800,3),(976,530685000,4),(976,544591860,3),(976,562127460,4),(976,576041460,7),(976,594178260,4),(976,607491060,3),(976,625631460,4),(976,638940660,3),(976,657081060,4),(976,670995060,3),(976,688530660,4),(976,702444660,3),(976,719980260,4),(976,733894260,3),(976,752034660,4),(976,765343860,3),(976,783484260,4),(976,796793460,3),(976,814933860,4),(976,828847860,3),(976,846383460,4),(976,860297460,3),(976,877833060,4),(976,891747060,3),(976,909282660,4),(976,923196660,3),(976,941337060,4),(976,954646260,3),(976,972786660,4),(976,986095860,3),(976,1004236260,4),(976,1018150260,3),(976,1035685860,4),(976,1049599860,3),(976,1067135460,4),(976,1081049460,3),(976,1099189860,4),(976,1112499060,3),(976,1130639460,4),(976,1143948660,3),(976,1162089060,4),(976,1173583860,3),(976,1194143460,4),(976,1205033460,3),(976,1225593060,4),(976,1236483060,3),(976,1257042660,4),(976,1268537460,3),(976,1289097060,4),(976,1299987060,3),(976,1320553800,4),(976,1331443800,3),(976,1352003400,4),(976,1362893400,3),(976,1383453000,4),(976,1394343000,3),(976,1414902600,4),(976,1425792600,3),(976,1446352200,4),(976,1457847000,3),(976,1478406600,4),(976,1489296600,3),(976,1509856200,4),(976,1520746200,3),(976,1541305800,4),(976,1552195800,3),(976,1572755400,4),(976,1583645400,3),(976,1604205000,4),(976,1615699800,3),(976,1636259400,4),(976,1647149400,3),(976,1667709000,4),(976,1678599000,3),(976,1699158600,4),(976,1710048600,3),(976,1730608200,4),(976,1741498200,3),(976,1762057800,4),(976,1772947800,3),(976,1793507400,4),(976,1805002200,3),(976,1825561800,4),(976,1836451800,3),(976,1857011400,4),(976,1867901400,3),(976,1888461000,4),(976,1899351000,3),(976,1919910600,4),(976,1930800600,3),(976,1951360200,4),(976,1962855000,3),(976,1983414600,4),(976,1994304600,3),(976,2014864200,4),(976,2025754200,3),(976,2046313800,4),(976,2057203800,3),(976,2077763400,4),(976,2088653400,3),(976,2109213000,4),(976,2120103000,3),(976,2140662600,4),(977,-2147483648,2),(977,-1632060000,1),(977,-1615129200,2),(977,-880207200,3),(977,-769395600,4),(977,-765385200,2),(977,-747237600,1),(977,-733935600,2),(977,-715788000,1),(977,-702486000,2),(977,-684338400,1),(977,-671036400,2),(977,-652888800,1),(977,-639586800,2),(977,-620834400,1),(977,-608137200,2),(977,-589384800,1),(977,-576082800,2),(977,-557935200,1),(977,-544633200,2),(977,-526485600,1),(977,-513183600,2),(977,-495036000,1),(977,-481734000,2),(977,-463586400,1),(977,-450284400,2),(977,-431532000,1),(977,-418230000,2),(977,-400082400,1),(977,-386780400,2),(977,-368632800,1),(977,-355330800,2),(977,-337183200,1),(977,-323881200,2),(977,-305733600,1),(977,-292431600,2),(977,-273679200,1),(977,-260982000,2),(977,-242229600,1),(977,-226508400,2),(977,-210780000,1),(977,-195058800,2),(977,-179330400,1),(977,-163609200,2),(977,-147880800,1),(977,-131554800,2),(977,-116431200,1),(977,-100105200,2),(977,-84376800,1),(977,-68655600,2),(977,-52927200,1),(977,-37206000,2),(977,-21477600,1),(977,-5756400,2),(977,9972000,1),(977,25693200,2),(977,41421600,1),(977,57747600,2),(977,73476000,1),(977,89197200,2),(977,104925600,1),(977,120646800,2),(977,136375200,1),(977,152096400,2),(977,167824800,1),(977,183546000,2),(977,199274400,1),(977,215600400,2),(977,230724000,1),(977,247050000,2),(977,262778400,1),(977,278499600,2),(977,294228000,1),(977,309949200,2),(977,325677600,1),(977,341398800,2),(977,357127200,1),(977,372848400,2),(977,388576800,1),(977,404902800,2),(977,420026400,1),(977,436352400,2),(977,452080800,1),(977,467802000,2),(977,483530400,1),(977,499251600,2),(977,514980000,1),(977,530701200,2),(977,544615200,1),(977,562150800,2),(977,576064800,1),(977,594205200,2),(977,607514400,1),(977,625654800,2),(977,638964000,1),(977,657104400,2),(977,671018400,1),(977,688554000,2),(977,702468000,1),(977,720003600,2),(977,733917600,1),(977,752058000,2),(977,765367200,1),(977,783507600,2),(977,796816800,1),(977,814957200,2),(977,828871200,1),(977,846406800,2),(977,860320800,1),(977,877856400,2),(977,891770400,1),(977,909306000,2),(977,923220000,1),(977,941360400,2),(977,954669600,1),(977,972810000,2),(977,986119200,1),(977,1004259600,2),(977,1018173600,1),(977,1035709200,2),(977,1049623200,1),(977,1067158800,2),(977,1081072800,1),(977,1099213200,2),(977,1112522400,1),(977,1130662800,2),(977,1143972000,1),(977,1162112400,2),(977,1173607200,1),(977,1194166800,2),(977,1205056800,1),(977,1225616400,2),(977,1236506400,1),(977,1257066000,2),(977,1268560800,1),(977,1289120400,2),(977,1300010400,1),(977,1320570000,2),(977,1331460000,1),(977,1352019600,2),(977,1362909600,1),(977,1383469200,2),(977,1394359200,1),(977,1414918800,2),(977,1425808800,1),(977,1446368400,2),(977,1457863200,1),(977,1478422800,2),(977,1489312800,1),(977,1509872400,2),(977,1520762400,1),(977,1541322000,2),(977,1552212000,1),(977,1572771600,2),(977,1583661600,1),(977,1604221200,2),(977,1615716000,1),(977,1636275600,2),(977,1647165600,1),(977,1667725200,2),(977,1678615200,1),(977,1699174800,2),(977,1710064800,1),(977,1730624400,2),(977,1741514400,1),(977,1762074000,2),(977,1772964000,1),(977,1793523600,2),(977,1805018400,1),(977,1825578000,2),(977,1836468000,1),(977,1857027600,2),(977,1867917600,1),(977,1888477200,2),(977,1899367200,1),(977,1919926800,2),(977,1930816800,1),(977,1951376400,2),(977,1962871200,1),(977,1983430800,2),(977,1994320800,1),(977,2014880400,2),(977,2025770400,1),(977,2046330000,2),(977,2057220000,1),(977,2077779600,2),(977,2088669600,1),(977,2109229200,2),(977,2120119200,1),(977,2140678800,2),(978,-2147483648,0),(978,-2030202084,2),(978,-1632063600,1),(978,-1615132800,2),(978,-1251651600,1),(978,-1238349600,2),(978,-1220202000,1),(978,-1206900000,2),(978,-1188752400,1),(978,-1175450400,2),(978,-1156698000,1),(978,-1144000800,2),(978,-1125248400,1),(978,-1111946400,2),(978,-1032714000,1),(978,-1016992800,2),(978,-1001264400,1),(978,-986148000,2),(978,-969814800,1),(978,-954093600,2),(978,-937760400,1),(978,-922039200,2),(978,-906310800,1),(978,-890589600,2),(978,-880210800,3),(978,-769395600,4),(978,-765388800,2),(978,-748450800,1),(978,-732729600,2),(978,-715791600,1),(978,-702489600,2),(978,-684342000,1),(978,-671040000,2),(978,-652892400,1),(978,-639590400,2),(978,-620838000,1),(978,-608140800,2),(978,-589388400,1),(978,-576086400,2),(978,-557938800,1),(978,-544636800,2),(978,-526489200,1),(978,-513187200,2),(978,-495039600,1),(978,-481737600,2),(978,-463590000,1),(978,-450288000,2),(978,-431535600,1),(978,-418233600,2),(978,-400086000,1),(978,-386784000,2),(978,-337186800,1),(978,-321465600,2),(978,-305737200,5),(979,-2147483648,2),(979,-1632056400,1),(979,-1615125600,2),(979,-1596978000,1),(979,-1583164800,2),(979,-880203600,3),(979,-769395600,4),(979,-765381600,2),(979,-147884400,5),(979,-131554800,2),(979,-121273200,6),(979,325677600,7),(979,341398800,6),(979,357127200,7),(979,372848400,6),(979,388576800,7),(979,404902800,6),(979,420026400,7),(979,436352400,6),(979,452080800,7),(979,467802000,6),(979,483530400,7),(979,499251600,6),(979,514980000,7),(979,530701200,6),(979,544615200,7),(979,562150800,6),(979,576064800,7),(979,594205200,6),(979,607514400,7),(979,625654800,6),(979,638964000,7),(979,657104400,6),(979,671018400,7),(979,688554000,6),(979,702468000,7),(979,720003600,6),(979,733917600,7),(979,752058000,6),(979,765367200,7),(979,783507600,6),(979,796816800,7),(979,814957200,6),(979,828871200,7),(979,846406800,6),(979,860320800,7),(979,877856400,6),(979,891770400,7),(979,909306000,6),(979,923220000,7),(979,941360400,6),(979,954669600,7),(979,972810000,6),(979,986119200,7),(979,1004259600,6),(979,1018173600,7),(979,1035709200,6),(979,1049623200,7),(979,1067158800,6),(979,1081072800,7),(979,1099213200,6),(979,1112522400,7),(979,1130662800,6),(979,1143972000,7),(979,1162112400,6),(979,1173607200,7),(979,1194166800,6),(979,1205056800,7),(979,1225616400,6),(979,1236506400,7),(979,1257066000,6),(979,1268560800,7),(979,1289120400,6),(979,1300010400,7),(979,1320570000,6),(979,1331460000,7),(979,1352019600,6),(979,1362909600,7),(979,1383469200,6),(979,1394359200,7),(979,1414918800,6),(979,1425808800,7),(979,1446368400,6),(979,1457863200,7),(979,1478422800,6),(979,1489312800,7),(979,1509872400,6),(979,1520762400,7),(979,1541322000,6),(979,1552212000,7),(979,1572771600,6),(979,1583661600,7),(979,1604214000,8),(980,-2147483648,1),(980,-1892661435,2),(980,-1688410800,1),(980,-1619205435,3),(980,-1593806400,1),(980,-1335986235,4),(980,-1317585600,2),(980,-1304362800,4),(980,-1286049600,2),(980,-1272826800,4),(980,-1254513600,2),(980,-1241290800,4),(980,-1222977600,2),(980,-1209754800,4),(980,-1191355200,2),(980,-1178132400,3),(980,-870552000,2),(980,-865278000,3),(980,-740520000,5),(980,-736635600,4),(980,-718056000,2),(980,-713649600,3),(980,-36619200,6),(980,-23922000,7),(980,-3355200,6),(980,7527600,7),(980,24465600,6),(980,37767600,7),(980,55915200,6),(980,69217200,7),(980,87969600,6),(980,100666800,7),(980,118209600,6),(980,132116400,7),(980,150868800,6),(980,163566000,7),(980,182318400,6),(980,195620400,7),(980,213768000,6),(980,227070000,7),(980,245217600,6),(980,258519600,7),(980,277272000,6),(980,289969200,7),(980,308721600,6),(980,321418800,7),(980,340171200,6),(980,353473200,7),(980,371620800,6),(980,384922800,7),(980,403070400,6),(980,416372400,7),(980,434520000,6),(980,447822000,7),(980,466574400,6),(980,479271600,7),(980,498024000,6),(980,510721200,7),(980,529473600,6),(980,545194800,7),(980,560923200,6),(980,574225200,7),(980,592372800,6),(980,605674800,7),(980,624427200,6),(980,637124400,7),(980,653457600,6),(980,668574000,7),(980,687326400,6),(980,700628400,7),(980,718776000,6),(980,732078000,7),(980,750225600,6),(980,763527600,7),(980,781675200,6),(980,794977200,7),(980,813729600,6),(980,826426800,7),(980,845179200,6),(980,859690800,7),(980,876628800,6),(980,889930800,7),(980,906868800,6),(980,923194800,7),(980,939528000,6),(980,952830000,7),(980,971582400,6),(980,984279600,7),(980,1003032000,6),(980,1015729200,7),(980,1034481600,6),(980,1047178800,7),(980,1065931200,6),(980,1079233200,7),(980,1097380800,6),(980,1110682800,7),(980,1128830400,6),(980,1142132400,7),(980,1160884800,6),(980,1173582000,7),(980,1192334400,6),(980,1206846000,7),(980,1223784000,6),(980,1237086000,7),(980,1255233600,6),(980,1270350000,7),(980,1286683200,6),(980,1304823600,7),(980,1313899200,6),(980,1335668400,7),(980,1346558400,6),(980,1367118000,7),(980,1378612800,6),(980,1398567600,7),(980,1410062400,6),(980,1463281200,7),(980,1471147200,6),(980,1494730800,7),(980,1502596800,6),(980,1526180400,7),(980,1534046400,6),(980,1554606000,7),(980,1567915200,6),(980,1586055600,7),(980,1599364800,6),(980,1617505200,7),(980,1630814400,6),(980,1648954800,7),(980,1662868800,6),(980,1680404400,7),(980,1693713600,6),(980,1712458800,7),(980,1725768000,6),(980,1743908400,7),(980,1757217600,6),(980,1775358000,7),(980,1788667200,6),(980,1806807600,7),(980,1820116800,6),(980,1838257200,7),(980,1851566400,6),(980,1870311600,7),(980,1883016000,6),(980,1901761200,7),(980,1915070400,6),(980,1933210800,7),(980,1946520000,6),(980,1964660400,7),(980,1977969600,6),(980,1996110000,7),(980,2009419200,6),(980,2027559600,7),(980,2040868800,6),(980,2059614000,7),(980,2072318400,6),(980,2091063600,7),(980,2104372800,6),(980,2122513200,7),(980,2135822400,6),(980,2147483647,6),(981,-2147483648,1),(981,-1178124152,4),(981,-36619200,2),(981,-23922000,3),(981,-3355200,2),(981,7527600,3),(981,24465600,2),(981,37767600,3),(981,55915200,2),(981,69217200,3),(981,87969600,2),(981,100666800,3),(981,118209600,2),(981,132116400,3),(981,150868800,2),(981,163566000,3),(981,182318400,2),(981,195620400,3),(981,213768000,2),(981,227070000,3),(981,245217600,2),(981,258519600,3),(981,277272000,2),(981,289969200,3),(981,308721600,2),(981,321418800,3),(981,340171200,2),(981,353473200,3),(981,371620800,2),(981,384922800,5),(981,403070400,6),(981,416372400,5),(981,434520000,6),(981,447822000,5),(981,466574400,6),(981,479271600,5),(981,498024000,6),(981,510721200,5),(981,529473600,6),(981,545194800,5),(981,560923200,6),(981,574225200,5),(981,592372800,6),(981,605674800,5),(981,624427200,6),(981,637124400,5),(981,653457600,6),(981,668574000,5),(981,687326400,6),(981,700628400,5),(981,718776000,6),(981,732078000,5),(981,750225600,6),(981,763527600,5),(981,781675200,6),(981,794977200,5),(981,813729600,6),(981,826426800,5),(981,845179200,6),(981,859690800,5),(981,876628800,6),(981,889930800,5),(981,906868800,6),(981,923194800,5),(981,939528000,6),(981,952830000,5),(981,971582400,6),(981,984279600,5),(981,1003032000,6),(981,1015729200,5),(981,1034481600,6),(981,1047178800,5),(981,1065931200,6),(981,1079233200,5),(981,1097380800,6),(981,1110682800,5),(981,1128830400,6),(981,1142132400,5),(981,1160884800,6),(981,1173582000,5),(981,1192334400,6),(981,1206846000,5),(981,1223784000,6),(981,1237086000,5),(981,1255233600,6),(981,1270350000,5),(981,1286683200,6),(981,1304823600,5),(981,1313899200,6),(981,1335668400,5),(981,1346558400,6),(981,1367118000,5),(981,1378612800,6),(981,1398567600,5),(981,1410062400,6),(981,1463281200,5),(981,1471147200,6),(981,1494730800,5),(981,1502596800,6),(981,1526180400,5),(981,1534046400,6),(981,1554606000,5),(981,1567915200,6),(981,1586055600,5),(981,1599364800,6),(981,1617505200,5),(981,1630814400,6),(981,1648954800,5),(981,1662868800,6),(981,1680404400,5),(981,1693713600,6),(981,1712458800,5),(981,1725768000,6),(981,1743908400,5),(981,1757217600,6),(981,1775358000,5),(981,1788667200,6),(981,1806807600,5),(981,1820116800,6),(981,1838257200,5),(981,1851566400,6),(981,1870311600,5),(981,1883016000,6),(981,1901761200,5),(981,1915070400,6),(981,1933210800,5),(981,1946520000,6),(981,1964660400,5),(981,1977969600,6),(981,1996110000,5),(981,2009419200,6),(981,2027559600,5),(981,2040868800,6),(981,2059614000,5),(981,2072318400,6),(981,2091063600,5),(981,2104372800,6),(981,2122513200,5),(981,2135822400,6),(981,2147483647,6),(982,-2147483648,1),(982,-1402813824,3),(982,-1311534000,2),(982,-1300996800,3),(982,-933534000,2),(982,-925675200,3),(982,-902084400,2),(982,-893620800,3),(982,-870030000,2),(982,-862171200,3),(982,-775681200,2),(982,-767822400,3),(982,-744231600,2),(982,-736372800,3),(982,-144702000,2),(982,-134251200,3),(982,-113425200,2),(982,-102542400,3),(982,-86295600,2),(982,-72907200,3),(982,-54154800,2),(982,-41457600,3),(982,-21495600,2),(982,-5774400,3),(982,9954000,2),(982,25675200,3),(982,41403600,2),(982,57729600,3),(982,73458000,2),(982,87364800,3),(982,104907600,2),(982,118900800,3),(982,136357200,2),(982,150436800,3),(982,167806800,2),(982,183528000,3),(982,199256400,2),(982,215582400,3),(982,230706000,2),(982,247032000,3),(982,263365200,2),(982,276667200,3),(982,290581200,2),(982,308721600,3),(982,322030800,2),(982,340171200,3),(982,358318800,2),(982,371620800,3),(982,389768400,2),(982,403070400,3),(982,421218000,2),(982,434520000,3),(982,452667600,2),(982,466574400,3),(982,484117200,2),(982,498024000,3),(982,511333200,2),(982,529473600,3),(982,542782800,2),(982,560923200,3),(982,574837200,2),(982,592372800,3),(982,606286800,2),(982,623822400,3),(982,638946000,2),(982,655876800,3),(982,671000400,2),(982,687330000,4),(982,702450000,2),(982,718779600,4),(982,733899600,2),(982,750229200,4),(982,765349200,2),(982,781678800,4),(982,796798800,2),(982,813128400,4),(982,828853200,2),(982,844578000,4),(982,860302800,2),(982,876632400,4),(982,891147600,5),(982,909291600,4),(982,922597200,5),(982,941346000,4),(982,954651600,5),(982,972795600,4),(982,986101200,5),(982,1004245200,4),(982,1018155600,5),(982,1035694800,4),(982,1049605200,5),(982,1067144400,4),(982,1080450000,5),(982,1162098000,4),(982,1173589200,5),(982,1193547600,4),(982,1205643600,5),(982,1224997200,4),(982,1236488400,5),(982,1256446800,4),(982,1268542800,5),(982,1288501200,4),(982,1300597200,5),(982,1321160400,4),(982,1333256400,5),(982,1352005200,4),(982,1362891600,5),(982,1383454800,4),(982,1394341200,5),(982,1414904400,4),(982,1425790800,5),(982,1446354000,4),(982,1457845200,5),(982,1478408400,4),(982,1489294800,5),(982,1509858000,4),(982,1520744400,5),(982,1541307600,4),(982,1552194000,5),(982,1572757200,4),(982,1583643600,5),(982,1604206800,4),(982,1615698000,5),(982,1636261200,4),(982,1647147600,5),(982,1667710800,4),(982,1678597200,5),(982,1699160400,4),(982,1710046800,5),(982,1730610000,4),(982,1741496400,5),(982,1762059600,4),(982,1772946000,5),(982,1793509200,4),(982,1805000400,5),(982,1825563600,4),(982,1836450000,5),(982,1857013200,4),(982,1867899600,5),(982,1888462800,4),(982,1899349200,5),(982,1919912400,4),(982,1930798800,5),(982,1951362000,4),(982,1962853200,5),(982,1983416400,4),(982,1994302800,5),(982,2014866000,4),(982,2025752400,5),(982,2046315600,4),(982,2057202000,5),(982,2077765200,4),(982,2088651600,5),(982,2109214800,4),(982,2120101200,5),(982,2140664400,4),(983,228877200,0),(983,243997200,1),(983,260326800,0),(983,276051600,1),(983,291776400,0),(983,307501200,1),(983,323830800,0),(983,338950800,1),(983,354675600,0),(983,370400400,1),(983,386125200,0),(983,401850000,1),(983,417574800,0),(983,433299600,1),(983,449024400,0),(983,465354000,1),(983,481078800,0),(983,496803600,1),(983,512528400,0),(983,528253200,1),(983,543978000,0),(983,559702800,1),(983,575427600,0),(983,591152400,1),(983,606877200,0),(983,622602000,1),(983,638326800,0),(983,654656400,1),(983,670381200,0),(983,686106000,1),(983,701830800,0),(983,717555600,1),(983,733280400,0),(983,749005200,1),(983,764730000,0),(983,780454800,1),(983,796179600,0),(983,811904400,1),(983,828234000,0),(983,846378000,1),(983,859683600,0),(983,877827600,1),(983,891133200,0),(983,909277200,1),(983,922582800,0),(983,941331600,1),(983,954032400,0),(983,972781200,1),(983,985482000,0),(983,1004230800,1),(983,1017536400,0),(983,1035680400,1),(983,1048986000,0),(983,1067130000,1),(983,1080435600,0),(983,1099184400,1),(983,1111885200,0),(983,1130634000,1),(983,1143334800,0),(983,1162083600,1),(983,1174784400,0),(983,1193533200,1),(983,1206838800,0),(983,1224982800,1),(983,1238288400,0),(983,1256432400,1),(983,1269738000,0),(983,1288486800,1),(983,1301187600,0),(983,1319936400,1),(983,1332637200,0),(983,1351386000,1),(983,1364691600,0),(983,1382835600,1),(983,1396141200,0),(983,1414285200,1),(983,1427590800,0),(983,1445734800,1),(983,1459040400,0),(983,1477789200,1),(983,1490490000,0),(983,1509238800,1),(983,1521939600,0),(983,1540688400,1),(983,1553994000,0),(983,1572138000,1),(983,1585443600,0),(983,1603587600,1),(983,1616893200,0),(983,1635642000,1),(983,1648342800,0),(983,1667091600,1),(983,1679792400,0),(983,1698541200,1),(983,1711846800,0),(983,1729990800,1),(983,1743296400,0),(983,1761440400,1),(983,1774746000,0),(983,1792890000,1),(983,1806195600,0),(983,1824944400,1),(983,1837645200,0),(983,1856394000,1),(983,1869094800,0),(983,1887843600,1),(983,1901149200,0),(983,1919293200,1),(983,1932598800,0),(983,1950742800,1),(983,1964048400,0),(983,1982797200,1),(983,1995498000,0),(983,2014246800,1),(983,2026947600,0),(983,2045696400,1),(983,2058397200,0),(983,2077146000,1),(983,2090451600,0),(983,2108595600,1),(983,2121901200,0),(983,2140045200,1),(985,-1633280400,0),(985,-1615140000,1),(985,-1601830800,0),(985,-1583690400,1),(985,-880218000,2),(985,-769395600,3),(985,-765396000,1),(985,-84387600,0),(985,-68666400,1),(985,-52938000,0),(985,-37216800,1),(985,-21488400,0),(985,-5767200,1),(985,9961200,0),(985,25682400,1),(985,41410800,0),(985,57736800,1),(985,73465200,0),(985,89186400,1),(985,104914800,0),(985,120636000,1),(985,126687600,0),(985,152085600,1),(985,162370800,0),(985,183535200,1),(985,199263600,0),(985,215589600,1),(985,230713200,0),(985,247039200,1),(985,262767600,0),(985,278488800,1),(985,294217200,0),(985,309938400,1),(985,325666800,0),(985,341388000,1),(985,357116400,0),(985,372837600,1),(985,388566000,0),(985,404892000,1),(985,420015600,0),(985,436341600,1),(985,452070000,0),(985,467791200,1),(985,483519600,0),(985,499240800,1),(985,514969200,0),(985,530690400,1),(985,544604400,0),(985,562140000,1),(985,576054000,0),(985,594194400,1),(985,607503600,0),(985,625644000,1),(985,638953200,0),(985,657093600,1),(985,671007600,0),(985,688543200,1),(985,702457200,0),(985,719992800,1),(985,733906800,0),(985,752047200,1),(985,765356400,0),(985,783496800,1),(985,796806000,0),(985,814946400,1),(985,828860400,0),(985,846396000,1),(985,860310000,0),(985,877845600,1),(985,891759600,0),(985,909295200,1),(985,923209200,0),(985,941349600,1),(985,954658800,0),(985,972799200,1),(985,986108400,0),(985,1004248800,1),(985,1018162800,0),(985,1035698400,1),(985,1049612400,0),(985,1067148000,1),(985,1081062000,0),(985,1099202400,1),(985,1112511600,0),(985,1130652000,1),(985,1143961200,0),(985,1162101600,1),(985,1173596400,0),(985,1194156000,1),(985,1205046000,0),(985,1225605600,1),(985,1236495600,0),(985,1257055200,1),(985,1268550000,0),(985,1289109600,1),(985,1299999600,0),(985,1320559200,1),(985,1331449200,0),(985,1352008800,1),(985,1362898800,0),(985,1383458400,1),(985,1394348400,0),(985,1414908000,1),(985,1425798000,0),(985,1446357600,1),(985,1457852400,0),(985,1478412000,1),(985,1489302000,0),(985,1509861600,1),(985,1520751600,0),(985,1541311200,1),(985,1552201200,0),(985,1572760800,1),(985,1583650800,0),(985,1604210400,1),(985,1615705200,0),(985,1636264800,1),(985,1647154800,0),(985,1667714400,1),(985,1678604400,0),(985,1699164000,1),(985,1710054000,0),(985,1730613600,1),(985,1741503600,0),(985,1762063200,1),(985,1772953200,0),(985,1793512800,1),(985,1805007600,0),(985,1825567200,1),(985,1836457200,0),(985,1857016800,1),(985,1867906800,0),(985,1888466400,1),(985,1899356400,0),(985,1919916000,1),(985,1930806000,0),(985,1951365600,1),(985,1962860400,0),(985,1983420000,1),(985,1994310000,0),(985,2014869600,1),(985,2025759600,0),(985,2046319200,1),(985,2057209200,0),(985,2077768800,1),(985,2088658800,0),(985,2109218400,1),(985,2120108400,0),(985,2140668000,1),(986,-2147483648,2),(986,-929844000,1),(986,-923108400,2),(986,-906170400,1),(986,-892868400,2),(986,-875844000,1),(986,-857790000,2),(986,-844308000,1),(986,-825822000,2),(986,-812685600,1),(986,-794199600,2),(986,-779853600,1),(986,-762663600,2),(986,-399088800,1),(986,-386650800,2),(986,-368330400,1),(986,-355114800,2),(986,-336790800,1),(986,-323654400,2),(986,-305168400,1),(986,-292032000,2),(986,-273632400,1),(986,-260496000,2),(986,-242096400,1),(986,-228960000,2),(986,-210560400,1),(986,-197424000,2),(986,-178938000,1),(986,-165801600,2),(986,-147402000,1),(986,-134265600,2),(986,-115866000,1),(986,-102643200,2),(986,-84330000,1),(986,-71107200,2),(986,-52707600,1),(986,-39484800,2),(986,-21171600,1),(986,-7948800,2),(986,10364400,1),(986,23587200,2),(986,41900400,1),(986,55123200,2),(986,73522800,1),(986,86745600,2),(986,105058800,1),(986,118281600,2),(986,136594800,1),(986,149817600,2),(986,168130800,1),(986,181353600,2),(986,199753200,1),(986,212976000,2),(986,231289200,1),(986,244512000,2),(986,262825200,1),(986,276048000,2),(986,294361200,1),(986,307584000,2),(986,325983600,1),(986,339206400,2),(986,357519600,1),(986,370742400,2),(986,396399600,1),(986,402278400,2),(986,426812400,1),(986,433814400,2),(986,452214000,1),(986,465436800,2),(986,483750000,1),(986,496972800,2),(986,515286000,1),(986,528508800,2),(986,546822000,1),(986,560044800,2),(986,578444400,1),(986,591667200,2),(986,610412400,1),(986,623203200,2),(986,641516400,1),(986,654739200,2),(986,673052400,1),(986,686275200,2),(986,704674800,1),(986,717897600,2),(986,736210800,1),(986,749433600,2),(986,767746800,1),(986,780969600,2),(986,799020000,3),(986,812322000,2),(986,830469600,3),(986,843771600,2),(986,861919200,3),(986,875221200,2),(986,893368800,3),(986,906670800,2),(986,925423200,3),(986,938725200,2),(986,956872800,3),(986,970174800,2),(986,988322400,3),(986,1001624400,2),(986,1019772000,3),(986,1033074000,2),(986,1051221600,3),(986,1064523600,2),(986,1083276000,3),(986,1096578000,2),(986,1114725600,3),(986,1128027600,2),(986,1146175200,3),(986,1158872400,2),(986,1177624800,3),(986,1189112400,2),(986,1209074400,3),(986,1219957200,2),(986,1240524000,3),(986,1250802000,2),(986,1272578400,3),(986,1281474000,2),(986,1284069600,1),(986,1285880400,2),(986,1400191200,1),(986,1403816400,2),(986,1406844000,1),(986,1411678800,2),(986,1682632800,1),(986,1698354000,2),(986,1714082400,1),(986,1730408400,2),(986,1745532000,1),(986,1761858000,2),(986,1776981600,1),(986,1793307600,2),(986,1809036000,1),(986,1824757200,2),(986,1840485600,1),(986,1856206800,2),(986,1871935200,1),(986,1887656400,2),(986,1903384800,1),(986,1919710800,2),(986,1934834400,1),(986,1951160400,2),(986,1966888800,1),(986,1982610000,2),(986,1998338400,1),(986,2014059600,2),(986,2029788000,1),(986,2045509200,2),(986,2061237600,1),(986,2076958800,2),(986,2092687200,1),(986,2109013200,2),(986,2124136800,1),(986,2140462800,2),(987,-2147483648,1),(987,-1691962479,2),(987,-1680471279,4),(987,-1664143200,3),(987,-1650146400,4),(987,-1633903200,3),(987,-1617487200,4),(987,-1601848800,3),(987,-1586037600,4),(987,-1570399200,3),(987,-1552168800,4),(987,-1538344800,3),(987,-1522533600,4),(987,-1517011200,6),(987,-1507500000,5),(987,-1490565600,4),(987,-1473631200,5),(987,-1460930400,4),(987,-1442786400,5),(987,-1428876000,4),(987,-1410732000,5),(987,-1396216800,4),(987,-1379282400,5),(987,-1364767200,4),(987,-1348437600,5),(987,-1333317600,4),(987,-1315778400,5),(987,-1301263200,4),(987,-1284328800,5),(987,-1269813600,4),(987,-1253484000,5),(987,-1238364000,4),(987,-1221429600,5),(987,-1206914400,4),(987,-1189980000,5),(987,-1175464800,4),(987,-1159135200,5),(987,-1143410400,4),(987,-1126476000,5),(987,-1111960800,4),(987,-1095631200,5),(987,-1080511200,4),(987,-1063576800,5),(987,-1049061600,4),(987,-1032127200,5),(987,-1017612000,4),(987,-1001282400,5),(987,-986162400,4),(987,-969228000,5),(987,-950479200,4),(987,-942012000,5),(987,-733356000,4),(987,-719445600,5),(987,-699487200,4),(987,-684972000,5),(987,-668037600,4),(987,-654732000,5),(987,-636588000,4),(987,-622072800,5),(987,-605743200,4),(987,-590623200,5),(987,-574293600,4),(987,-558568800,5),(987,-542239200,4),(987,-527119200,5),(987,-512604000,4),(987,-496274400,5),(987,-481154400,4),(987,-464220000,5),(987,-449704800,4),(987,-432165600,5),(987,-417650400,4),(987,-401320800,5),(987,-386200800,4),(987,-369266400,5),(987,-354751200,4),(987,-337816800,5),(987,-323301600,4),(987,-306972000,5),(987,-291852000,4),(987,-276732000,5),(987,-257983200,4),(987,-245282400,5),(987,-226533600,4),(987,-213228000,5),(987,-195084000,4),(987,-182383200,5),(987,-163634400,4),(987,-150933600,5),(987,-132184800,4),(987,-119484000,5),(987,-100735200,4),(987,-88034400,5),(987,-68680800,4),(987,-59004000,5),(987,-37242000,7),(987,57722400,9),(987,69818400,5),(987,89172000,4),(987,101268000,5),(987,120621600,4),(987,132717600,5),(987,152071200,4),(987,164167200,5),(987,183520800,4),(987,196221600,5),(987,214970400,4),(987,227671200,5),(987,246420000,4),(987,259120800,5),(987,278474400,4),(987,290570400,5),(987,309924000,4),(987,322020000,5),(987,341373600,4),(987,354675600,8),(987,372819600,9),(987,386125200,8),(987,404269200,9),(987,417574800,8),(987,435718800,9),(987,449024400,8),(987,467773200,9),(987,481078800,8),(987,499222800,9),(987,512528400,8),(987,530672400,9),(987,543978000,8),(987,562122000,9),(987,575427600,8),(987,593571600,9),(987,606877200,8),(987,625626000,9),(987,638326800,8),(987,657075600,9),(987,670381200,8),(987,688525200,9),(987,701830800,8),(987,719974800,9),(987,733280400,8),(987,751424400,9),(987,764730000,8),(987,782874000,9),(987,796179600,8),(987,814323600,9),(987,820454400,6),(987,828234000,8),(987,846378000,9),(987,859683600,8),(987,877827600,9),(987,891133200,8),(987,909277200,9),(987,922582800,8),(987,941331600,9),(987,954032400,8),(987,972781200,9),(987,985482000,8),(987,1004230800,9),(987,1017536400,8),(987,1035680400,9),(987,1048986000,8),(987,1067130000,9),(987,1080435600,8),(987,1099184400,9),(987,1111885200,8),(987,1130634000,9),(987,1143334800,8),(987,1162083600,9),(987,1174784400,8),(987,1193533200,9),(987,1206838800,8),(987,1224982800,9),(987,1238288400,8),(987,1256432400,9),(987,1269738000,8),(987,1288486800,9),(987,1301187600,8),(987,1319936400,9),(987,1332637200,8),(987,1351386000,9),(987,1364691600,8),(987,1382835600,9),(987,1396141200,8),(987,1414285200,9),(987,1427590800,8),(987,1445734800,9),(987,1459040400,8),(987,1477789200,9),(987,1490490000,8),(987,1509238800,9),(987,1521939600,8),(987,1540688400,9),(987,1553994000,8),(987,1572138000,9),(987,1585443600,8),(987,1603587600,9),(987,1616893200,8),(987,1635642000,9),(987,1648342800,8),(987,1667091600,9),(987,1679792400,8),(987,1698541200,9),(987,1711846800,8),(987,1729990800,9),(987,1743296400,8),(987,1761440400,9),(987,1774746000,8),(987,1792890000,9),(987,1806195600,8),(987,1824944400,9),(987,1837645200,8),(987,1856394000,9),(987,1869094800,8),(987,1887843600,9),(987,1901149200,8),(987,1919293200,9),(987,1932598800,8),(987,1950742800,9),(987,1964048400,8),(987,1982797200,9),(987,1995498000,8),(987,2014246800,9),(987,2026947600,8),(987,2045696400,9),(987,2058397200,8),(987,2077146000,9),(987,2090451600,8),(987,2108595600,9),(987,2121901200,8),(987,2140045200,9),(990,-2147483648,0),(990,2147483647,0),(991,-2147483648,0),(991,2147483647,0),(992,-2147483648,0),(992,2147483647,0),(993,-2147483648,0),(993,2147483647,0),(994,-2147483648,0),(994,2147483647,0),(995,-2147483648,0),(995,2147483647,0),(996,-2147483648,0),(996,2147483647,0),(997,-2147483648,0),(997,2147483647,0),(998,-2147483648,0),(998,2147483647,0),(999,-2147483648,0),(999,2147483647,0),(1000,-2147483648,0),(1000,2147483647,0),(1001,-2147483648,0),(1001,2147483647,0),(1003,-2147483648,0),(1003,2147483647,0),(1004,-2147483648,0),(1004,2147483647,0),(1005,-2147483648,0),(1005,2147483647,0),(1006,-2147483648,0),(1006,2147483647,0),(1007,-2147483648,0),(1007,2147483647,0),(1008,-2147483648,0),(1008,2147483647,0),(1009,-2147483648,0),(1009,2147483647,0),(1010,-2147483648,0),(1010,2147483647,0),(1011,-2147483648,0),(1011,2147483647,0),(1012,-2147483648,0),(1012,2147483647,0),(1013,-2147483648,0),(1013,2147483647,0),(1014,-2147483648,0),(1014,2147483647,0),(1015,-2147483648,0),(1015,2147483647,0),(1016,-2147483648,0),(1016,2147483647,0),(1023,-2147483648,1),(1023,-1740355200,2),(1023,-1693702800,5),(1023,-1680483600,2),(1023,-1663455600,3),(1023,-1650150000,4),(1023,-1632006000,3),(1023,-1618700400,4),(1023,-1613826000,8),(1023,-1604278800,6),(1023,-1585530000,7),(1023,-1574038800,6),(1023,-1552266000,7),(1023,-1539997200,6),(1023,-1520557200,7),(1023,-1507510800,6),(1023,-1490576400,7),(1023,-1473642000,6),(1023,-1459126800,7),(1023,-1444006800,6),(1023,-1427677200,7),(1023,-1411952400,6),(1023,-1396227600,7),(1023,-1379293200,6),(1023,-1364778000,7),(1023,-1348448400,6),(1023,-1333328400,7),(1023,-1316394000,6),(1023,-1301263200,7),(1023,-1284328800,6),(1023,-1269813600,7),(1023,-1253484000,6),(1023,-1238364000,7),(1023,-1221429600,6),(1023,-1206914400,7),(1023,-1191189600,6),(1023,-1175464800,7),(1023,-1160344800,6),(1023,-1143410400,7),(1023,-1127685600,6),(1023,-1111960800,7),(1023,-1096840800,6),(1023,-1080511200,7),(1023,-1063576800,6),(1023,-1049061600,7),(1023,-1033336800,6),(1023,-1017612000,7),(1023,-1002492000,6),(1023,-986162400,7),(1023,-969228000,6),(1023,-950479200,7),(1023,-942012000,6),(1023,-934668000,3),(1023,-857257200,4),(1023,-844556400,3),(1023,-828226800,4),(1023,-812502000,3),(1023,-799293600,5),(1023,-798073200,4),(1023,-781052400,3),(1023,-766623600,4),(1023,-745455600,3),(1023,-733273200,4),(1023,220921200,2),(1023,228877200,9),(1023,243997200,10),(1023,260326800,9),(1023,276051600,10),(1023,291776400,9),(1023,307501200,10),(1023,323830800,9),(1023,338950800,10),(1023,354675600,9),(1023,370400400,10),(1023,386125200,9),(1023,401850000,10),(1023,417574800,9),(1023,433299600,10),(1023,449024400,9),(1023,465354000,10),(1023,481078800,9),(1023,496803600,10),(1023,512528400,9),(1023,528253200,10),(1023,543978000,9),(1023,559702800,10),(1023,575427600,9),(1023,591152400,10),(1023,606877200,9),(1023,622602000,10),(1023,638326800,9),(1023,654656400,10),(1023,670381200,9),(1023,686106000,10),(1023,701830800,9),(1023,717555600,10),(1023,733280400,9),(1023,749005200,10),(1023,764730000,9),(1023,780454800,10),(1023,796179600,9),(1023,811904400,10),(1023,828234000,9),(1023,846378000,10),(1023,859683600,9),(1023,877827600,10),(1023,891133200,9),(1023,909277200,10),(1023,922582800,9),(1023,941331600,10),(1023,954032400,9),(1023,972781200,10),(1023,985482000,9),(1023,1004230800,10),(1023,1017536400,9),(1023,1035680400,10),(1023,1048986000,9),(1023,1067130000,10),(1023,1080435600,9),(1023,1099184400,10),(1023,1111885200,9),(1023,1130634000,10),(1023,1143334800,9),(1023,1162083600,10),(1023,1174784400,9),(1023,1193533200,10),(1023,1206838800,9),(1023,1224982800,10),(1023,1238288400,9),(1023,1256432400,10),(1023,1269738000,9),(1023,1288486800,10),(1023,1301187600,9),(1023,1319936400,10),(1023,1332637200,9),(1023,1351386000,10),(1023,1364691600,9),(1023,1382835600,10),(1023,1396141200,9),(1023,1414285200,10),(1023,1427590800,9),(1023,1445734800,10),(1023,1459040400,9),(1023,1477789200,10),(1023,1490490000,9),(1023,1509238800,10),(1023,1521939600,9),(1023,1540688400,10),(1023,1553994000,9),(1023,1572138000,10),(1023,1585443600,9),(1023,1603587600,10),(1023,1616893200,9),(1023,1635642000,10),(1023,1648342800,9),(1023,1667091600,10),(1023,1679792400,9),(1023,1698541200,10),(1023,1711846800,9),(1023,1729990800,10),(1023,1743296400,9),(1023,1761440400,10),(1023,1774746000,9),(1023,1792890000,10),(1023,1806195600,9),(1023,1824944400,10),(1023,1837645200,9),(1023,1856394000,10),(1023,1869094800,9),(1023,1887843600,10),(1023,1901149200,9),(1023,1919293200,10),(1023,1932598800,9),(1023,1950742800,10),(1023,1964048400,9),(1023,1982797200,10),(1023,1995498000,9),(1023,2014246800,10),(1023,2026947600,9),(1023,2045696400,10),(1023,2058397200,9),(1023,2077146000,10),(1023,2090451600,9),(1023,2108595600,10),(1023,2121901200,9),(1023,2140045200,10),(1024,-2147483648,1),(1024,-733881600,2),(1024,481078800,3),(1024,496803600,4),(1024,512528400,3),(1024,528253200,4),(1024,543978000,3),(1024,559702800,4),(1024,575427600,3),(1024,591152400,4),(1024,606877200,3),(1024,622602000,4),(1024,638326800,3),(1024,654656400,4),(1024,670381200,3),(1024,686106000,4),(1024,701830800,3),(1024,717555600,4),(1024,733280400,3),(1024,749005200,4),(1024,764730000,3),(1024,780454800,4),(1024,796179600,3),(1024,811904400,4),(1024,828234000,3),(1024,846378000,4),(1024,859683600,3),(1024,877827600,4),(1024,891133200,3),(1024,909277200,4),(1024,922582800,3),(1024,941331600,4),(1024,954032400,3),(1024,972781200,4),(1024,985482000,3),(1024,1004230800,4),(1024,1017536400,3),(1024,1035680400,4),(1024,1048986000,3),(1024,1067130000,4),(1024,1080435600,3),(1024,1099184400,4),(1024,1111885200,3),(1024,1130634000,4),(1024,1143334800,3),(1024,1162083600,4),(1024,1174784400,3),(1024,1193533200,4),(1024,1206838800,3),(1024,1224982800,4),(1024,1238288400,3),(1024,1256432400,4),(1024,1269738000,3),(1024,1288486800,4),(1024,1301187600,3),(1024,1319936400,4),(1024,1332637200,3),(1024,1351386000,4),(1024,1364691600,3),(1024,1382835600,4),(1024,1396141200,3),(1024,1414285200,4),(1024,1427590800,3),(1024,1445734800,4),(1024,1459040400,3),(1024,1477789200,4),(1024,1490490000,3),(1024,1509238800,4),(1024,1521939600,3),(1024,1540688400,4),(1024,1553994000,3),(1024,1572138000,4),(1024,1585443600,3),(1024,1603587600,4),(1024,1616893200,3),(1024,1635642000,4),(1024,1648342800,3),(1024,1667091600,4),(1024,1679792400,3),(1024,1698541200,4),(1024,1711846800,3),(1024,1729990800,4),(1024,1743296400,3),(1024,1761440400,4),(1024,1774746000,3),(1024,1792890000,4),(1024,1806195600,3),(1024,1824944400,4),(1024,1837645200,3),(1024,1856394000,4),(1024,1869094800,3),(1024,1887843600,4),(1024,1901149200,3),(1024,1919293200,4),(1024,1932598800,3),(1024,1950742800,4),(1024,1964048400,3),(1024,1982797200,4),(1024,1995498000,3),(1024,2014246800,4),(1024,2026947600,3),(1024,2045696400,4),(1024,2058397200,3),(1024,2077146000,4),(1024,2090451600,3),(1024,2108595600,4),(1024,2121901200,3),(1024,2140045200,4),(1025,-2147483648,0),(1025,-1441249932,1),(1025,-1247540400,3),(1025,354916800,2),(1025,370724400,3),(1025,386452800,2),(1025,402260400,3),(1025,417988800,2),(1025,433796400,3),(1025,449611200,2),(1025,465343200,4),(1025,481068000,5),(1025,496792800,4),(1025,512517600,5),(1025,528242400,4),(1025,543967200,5),(1025,559692000,4),(1025,575416800,5),(1025,591141600,4),(1025,606866400,6),(1025,622594800,7),(1025,638319600,6),(1025,654649200,7),(1025,670374000,4),(1025,701820000,6),(1025,717548400,7),(1025,733273200,6),(1025,748998000,7),(1025,764722800,6),(1025,780447600,7),(1025,796172400,6),(1025,811897200,7),(1025,828226800,6),(1025,846370800,7),(1025,859676400,6),(1025,877820400,7),(1025,891126000,6),(1025,909270000,7),(1025,922575600,6),(1025,941324400,7),(1025,954025200,6),(1025,972774000,7),(1025,985474800,6),(1025,1004223600,7),(1025,1017529200,6),(1025,1035673200,7),(1025,1048978800,6),(1025,1067122800,7),(1025,1080428400,6),(1025,1099177200,7),(1025,1111878000,6),(1025,1130626800,7),(1025,1143327600,6),(1025,1162076400,7),(1025,1174777200,6),(1025,1193526000,7),(1025,1206831600,6),(1025,1224975600,7),(1025,1238281200,6),(1025,1256425200,7),(1025,1269730800,6),(1025,1288479600,7),(1025,1301180400,4),(1025,1414274400,7),(1025,1459033200,4),(1025,2147483647,4),(1026,-2147483648,1),(1026,-1686101632,3),(1026,-1182996000,2),(1026,-1178161200,3),(1026,-906861600,2),(1026,-904878000,5),(1026,-857257200,4),(1026,-844477200,5),(1026,-828237600,4),(1026,-812422800,3),(1026,-552362400,2),(1026,-541652400,3),(1026,166485600,6),(1026,186184800,7),(1026,198028800,6),(1026,213753600,7),(1026,228873600,6),(1026,244080000,7),(1026,260323200,6),(1026,275446800,3),(1026,291798000,2),(1026,307407600,3),(1026,323388000,2),(1026,338936400,3),(1026,354675600,8),(1026,370400400,9),(1026,386125200,8),(1026,401850000,9),(1026,417574800,8),(1026,433299600,9),(1026,449024400,8),(1026,465354000,9),(1026,481078800,8),(1026,496803600,9),(1026,512528400,8),(1026,528253200,9),(1026,543978000,8),(1026,559702800,9),(1026,575427600,8),(1026,591152400,9),(1026,606877200,8),(1026,622602000,9),(1026,638326800,8),(1026,654656400,9),(1026,670381200,8),(1026,686106000,9),(1026,701830800,8),(1026,717555600,9),(1026,733280400,8),(1026,749005200,9),(1026,764730000,8),(1026,780454800,9),(1026,796179600,8),(1026,811904400,9),(1026,828234000,8),(1026,846378000,9),(1026,859683600,8),(1026,877827600,9),(1026,891133200,8),(1026,909277200,9),(1026,922582800,8),(1026,941331600,9),(1026,954032400,8),(1026,972781200,9),(1026,985482000,8),(1026,1004230800,9),(1026,1017536400,8),(1026,1035680400,9),(1026,1048986000,8),(1026,1067130000,9),(1026,1080435600,8),(1026,1099184400,9),(1026,1111885200,8),(1026,1130634000,9),(1026,1143334800,8),(1026,1162083600,9),(1026,1174784400,8),(1026,1193533200,9),(1026,1206838800,8),(1026,1224982800,9),(1026,1238288400,8),(1026,1256432400,9),(1026,1269738000,8),(1026,1288486800,9),(1026,1301187600,8),(1026,1319936400,9),(1026,1332637200,8),(1026,1351386000,9),(1026,1364691600,8),(1026,1382835600,9),(1026,1396141200,8),(1026,1414285200,9),(1026,1427590800,8),(1026,1445734800,9),(1026,1459040400,8),(1026,1477789200,9),(1026,1490490000,8),(1026,1509238800,9),(1026,1521939600,8),(1026,1540688400,9),(1026,1553994000,8),(1026,1572138000,9),(1026,1585443600,8),(1026,1603587600,9),(1026,1616893200,8),(1026,1635642000,9),(1026,1648342800,8),(1026,1667091600,9),(1026,1679792400,8),(1026,1698541200,9),(1026,1711846800,8),(1026,1729990800,9),(1026,1743296400,8),(1026,1761440400,9),(1026,1774746000,8),(1026,1792890000,9),(1026,1806195600,8),(1026,1824944400,9),(1026,1837645200,8),(1026,1856394000,9),(1026,1869094800,8),(1026,1887843600,9),(1026,1901149200,8),(1026,1919293200,9),(1026,1932598800,8),(1026,1950742800,9),(1026,1964048400,8),(1026,1982797200,9),(1026,1995498000,8),(1026,2014246800,9),(1026,2026947600,8),(1026,2045696400,9),(1026,2058397200,8),(1026,2077146000,9),(1026,2090451600,8),(1026,2108595600,9),(1026,2121901200,8),(1026,2140045200,9),(1027,-2147483648,4),(1027,-1691964000,1),(1027,-1680472800,2),(1027,-1664143200,1),(1027,-1650146400,2),(1027,-1633903200,1),(1027,-1617487200,2),(1027,-1601848800,1),(1027,-1586037600,2),(1027,-1570399200,1),(1027,-1552168800,2),(1027,-1538344800,1),(1027,-1522533600,2),(1027,-1507500000,1),(1027,-1490565600,2),(1027,-1473631200,1),(1027,-1460930400,2),(1027,-1442786400,1),(1027,-1428876000,2),(1027,-1410732000,1),(1027,-1396216800,2),(1027,-1379282400,1),(1027,-1364767200,2),(1027,-1348437600,1),(1027,-1333317600,2),(1027,-1315778400,1),(1027,-1301263200,2),(1027,-1284328800,1),(1027,-1269813600,2),(1027,-1253484000,1),(1027,-1238364000,2),(1027,-1221429600,1),(1027,-1206914400,2),(1027,-1189980000,1),(1027,-1175464800,2),(1027,-1159135200,1),(1027,-1143410400,2),(1027,-1126476000,1),(1027,-1111960800,2),(1027,-1095631200,1),(1027,-1080511200,2),(1027,-1063576800,1),(1027,-1049061600,2),(1027,-1032127200,1),(1027,-1017612000,2),(1027,-1001282400,1),(1027,-986162400,2),(1027,-969228000,1),(1027,-950479200,2),(1027,-942012000,1),(1027,-904518000,3),(1027,-896050800,1),(1027,-875487600,3),(1027,-864601200,1),(1027,-844038000,3),(1027,-832546800,1),(1027,-812588400,3),(1027,-798073200,1),(1027,-781052400,3),(1027,-772066800,1),(1027,-764805600,2),(1027,-748476000,1),(1027,-733356000,2),(1027,-719445600,1),(1027,-717030000,3),(1027,-706748400,1),(1027,-699487200,2),(1027,-687996000,1),(1027,-668037600,2),(1027,-654732000,1),(1027,-636588000,2),(1027,-622072800,1),(1027,-605743200,2),(1027,-590623200,1),(1027,-574293600,2),(1027,-558568800,1),(1027,-542239200,2),(1027,-527119200,1),(1027,-512604000,2),(1027,-496274400,1),(1027,-481154400,2),(1027,-464220000,1),(1027,-449704800,2),(1027,-432165600,1),(1027,-417650400,2),(1027,-401320800,1),(1027,-386200800,2),(1027,-369266400,1),(1027,-354751200,2),(1027,-337816800,1),(1027,-323301600,2),(1027,-306972000,1),(1027,-291852000,2),(1027,-276732000,1),(1027,-257983200,2),(1027,-245282400,1),(1027,-226533600,2),(1027,-213228000,1),(1027,-195084000,2),(1027,-182383200,1),(1027,-163634400,2),(1027,-150933600,1),(1027,-132184800,2),(1027,-119484000,1),(1027,-100735200,2),(1027,-88034400,1),(1027,-68680800,2),(1027,-59004000,1),(1027,-37242000,5),(1027,57722400,7),(1027,69818400,1),(1027,89172000,2),(1027,101268000,1),(1027,120621600,2),(1027,132717600,1),(1027,152071200,2),(1027,164167200,1),(1027,183520800,2),(1027,196221600,1),(1027,214970400,2),(1027,227671200,1),(1027,246420000,2),(1027,259120800,1),(1027,278474400,2),(1027,290570400,1),(1027,309924000,2),(1027,322020000,1),(1027,341373600,2),(1027,354675600,6),(1027,372819600,7),(1027,386125200,6),(1027,404269200,7),(1027,417574800,6),(1027,435718800,7),(1027,449024400,6),(1027,467773200,7),(1027,481078800,6),(1027,499222800,7),(1027,512528400,6),(1027,530672400,7),(1027,543978000,6),(1027,562122000,7),(1027,575427600,6),(1027,593571600,7),(1027,606877200,6),(1027,625626000,7),(1027,638326800,6),(1027,657075600,7),(1027,670381200,6),(1027,688525200,7),(1027,701830800,6),(1027,719974800,7),(1027,733280400,6),(1027,751424400,7),(1027,764730000,6),(1027,782874000,7),(1027,796179600,6),(1027,814323600,7),(1027,820454400,4),(1027,828234000,6),(1027,846378000,7),(1027,859683600,6),(1027,877827600,7),(1027,891133200,6),(1027,909277200,7),(1027,922582800,6),(1027,941331600,7),(1027,954032400,6),(1027,972781200,7),(1027,985482000,6),(1027,1004230800,7),(1027,1017536400,6),(1027,1035680400,7),(1027,1048986000,6),(1027,1067130000,7),(1027,1080435600,6),(1027,1099184400,7),(1027,1111885200,6),(1027,1130634000,7),(1027,1143334800,6),(1027,1162083600,7),(1027,1174784400,6),(1027,1193533200,7),(1027,1206838800,6),(1027,1224982800,7),(1027,1238288400,6),(1027,1256432400,7),(1027,1269738000,6),(1027,1288486800,7),(1027,1301187600,6),(1027,1319936400,7),(1027,1332637200,6),(1027,1351386000,7),(1027,1364691600,6),(1027,1382835600,7),(1027,1396141200,6),(1027,1414285200,7),(1027,1427590800,6),(1027,1445734800,7),(1027,1459040400,6),(1027,1477789200,7),(1027,1490490000,6),(1027,1509238800,7),(1027,1521939600,6),(1027,1540688400,7),(1027,1553994000,6),(1027,1572138000,7),(1027,1585443600,6),(1027,1603587600,7),(1027,1616893200,6),(1027,1635642000,7),(1027,1648342800,6),(1027,1667091600,7),(1027,1679792400,6),(1027,1698541200,7),(1027,1711846800,6),(1027,1729990800,7),(1027,1743296400,6),(1027,1761440400,7),(1027,1774746000,6),(1027,1792890000,7),(1027,1806195600,6),(1027,1824944400,7),(1027,1837645200,6),(1027,1856394000,7),(1027,1869094800,6),(1027,1887843600,7),(1027,1901149200,6),(1027,1919293200,7),(1027,1932598800,6),(1027,1950742800,7),(1027,1964048400,6),(1027,1982797200,7),(1027,1995498000,6),(1027,2014246800,7),(1027,2026947600,6),(1027,2045696400,7),(1027,2058397200,6),(1027,2077146000,7),(1027,2090451600,6),(1027,2108595600,7),(1027,2121901200,6),(1027,2140045200,7),(1028,-2147483648,1),(1028,-905824800,4),(1028,-857257200,2),(1028,-844556400,3),(1028,-828226800,2),(1028,-812502000,3),(1028,-796777200,2),(1028,-788922000,1),(1028,-777942000,3),(1028,-766623600,2),(1028,407199600,1),(1028,417574800,5),(1028,433299600,6),(1028,449024400,5),(1028,465354000,6),(1028,481078800,5),(1028,496803600,6),(1028,512528400,5),(1028,528253200,6),(1028,543978000,5),(1028,559702800,6),(1028,575427600,5),(1028,591152400,6),(1028,606877200,5),(1028,622602000,6),(1028,638326800,5),(1028,654656400,6),(1028,670381200,5),(1028,686106000,6),(1028,701830800,5),(1028,717555600,6),(1028,733280400,5),(1028,749005200,6),(1028,764730000,5),(1028,780454800,6),(1028,796179600,5),(1028,811904400,6),(1028,828234000,5),(1028,846378000,6),(1028,859683600,5),(1028,877827600,6),(1028,891133200,5),(1028,909277200,6),(1028,922582800,5),(1028,941331600,6),(1028,954032400,5),(1028,972781200,6),(1028,985482000,5),(1028,1004230800,6),(1028,1017536400,5),(1028,1035680400,6),(1028,1048986000,5),(1028,1067130000,6),(1028,1080435600,5),(1028,1099184400,6),(1028,1111885200,5),(1028,1130634000,6),(1028,1143334800,5),(1028,1162083600,6),(1028,1174784400,5),(1028,1193533200,6),(1028,1206838800,5),(1028,1224982800,6),(1028,1238288400,5),(1028,1256432400,6),(1028,1269738000,5),(1028,1288486800,6),(1028,1301187600,5),(1028,1319936400,6),(1028,1332637200,5),(1028,1351386000,6),(1028,1364691600,5),(1028,1382835600,6),(1028,1396141200,5),(1028,1414285200,6),(1028,1427590800,5),(1028,1445734800,6),(1028,1459040400,5),(1028,1477789200,6),(1028,1490490000,5),(1028,1509238800,6),(1028,1521939600,5),(1028,1540688400,6),(1028,1553994000,5),(1028,1572138000,6),(1028,1585443600,5),(1028,1603587600,6),(1028,1616893200,5),(1028,1635642000,6),(1028,1648342800,5),(1028,1667091600,6),(1028,1679792400,5),(1028,1698541200,6),(1028,1711846800,5),(1028,1729990800,6),(1028,1743296400,5),(1028,1761440400,6),(1028,1774746000,5),(1028,1792890000,6),(1028,1806195600,5),(1028,1824944400,6),(1028,1837645200,5),(1028,1856394000,6),(1028,1869094800,5),(1028,1887843600,6),(1028,1901149200,5),(1028,1919293200,6),(1028,1932598800,5),(1028,1950742800,6),(1028,1964048400,5),(1028,1982797200,6),(1028,1995498000,5),(1028,2014246800,6),(1028,2026947600,5),(1028,2045696400,6),(1028,2058397200,5),(1028,2077146000,6),(1028,2090451600,5),(1028,2108595600,6),(1028,2121901200,5),(1028,2140045200,6),(1029,-2147483648,2),(1029,-1693706400,1),(1029,-1680483600,2),(1029,-1663455600,3),(1029,-1650150000,4),(1029,-1632006000,3),(1029,-1618700400,4),(1029,-938905200,3),(1029,-857257200,4),(1029,-844556400,3),(1029,-828226800,4),(1029,-812502000,3),(1029,-796777200,4),(1029,-781052400,3),(1029,-776563200,5),(1029,-765936000,1),(1029,-761180400,4),(1029,-757386000,2),(1029,-748479600,3),(1029,-733273200,4),(1029,-717631200,3),(1029,-714610800,6),(1029,-710380800,1),(1029,-701910000,4),(1029,-684975600,3),(1029,-670460400,4),(1029,-654130800,3),(1029,-639010800,4),(1029,315529200,2),(1029,323830800,7),(1029,338950800,8),(1029,354675600,7),(1029,370400400,8),(1029,386125200,7),(1029,401850000,8),(1029,417574800,7),(1029,433299600,8),(1029,449024400,7),(1029,465354000,8),(1029,481078800,7),(1029,496803600,8),(1029,512528400,7),(1029,528253200,8),(1029,543978000,7),(1029,559702800,8),(1029,575427600,7),(1029,591152400,8),(1029,606877200,7),(1029,622602000,8),(1029,638326800,7),(1029,654656400,8),(1029,670381200,7),(1029,686106000,8),(1029,701830800,7),(1029,717555600,8),(1029,733280400,7),(1029,749005200,8),(1029,764730000,7),(1029,780454800,8),(1029,796179600,7),(1029,811904400,8),(1029,828234000,7),(1029,846378000,8),(1029,859683600,7),(1029,877827600,8),(1029,891133200,7),(1029,909277200,8),(1029,922582800,7),(1029,941331600,8),(1029,954032400,7),(1029,972781200,8),(1029,985482000,7),(1029,1004230800,8),(1029,1017536400,7),(1029,1035680400,8),(1029,1048986000,7),(1029,1067130000,8),(1029,1080435600,7),(1029,1099184400,8),(1029,1111885200,7),(1029,1130634000,8),(1029,1143334800,7),(1029,1162083600,8),(1029,1174784400,7),(1029,1193533200,8),(1029,1206838800,7),(1029,1224982800,8),(1029,1238288400,7),(1029,1256432400,8),(1029,1269738000,7),(1029,1288486800,8),(1029,1301187600,7),(1029,1319936400,8),(1029,1332637200,7),(1029,1351386000,8),(1029,1364691600,7),(1029,1382835600,8),(1029,1396141200,7),(1029,1414285200,8),(1029,1427590800,7),(1029,1445734800,8),(1029,1459040400,7),(1029,1477789200,8),(1029,1490490000,7),(1029,1509238800,8),(1029,1521939600,7),(1029,1540688400,8),(1029,1553994000,7),(1029,1572138000,8),(1029,1585443600,7),(1029,1603587600,8),(1029,1616893200,7),(1029,1635642000,8),(1029,1648342800,7),(1029,1667091600,8),(1029,1679792400,7),(1029,1698541200,8),(1029,1711846800,7),(1029,1729990800,8),(1029,1743296400,7),(1029,1761440400,8),(1029,1774746000,7),(1029,1792890000,8),(1029,1806195600,7),(1029,1824944400,8),(1029,1837645200,7),(1029,1856394000,8),(1029,1869094800,7),(1029,1887843600,8),(1029,1901149200,7),(1029,1919293200,8),(1029,1932598800,7),(1029,1950742800,8),(1029,1964048400,7),(1029,1982797200,8),(1029,1995498000,7),(1029,2014246800,8),(1029,2026947600,7),(1029,2045696400,8),(1029,2058397200,7),(1029,2077146000,8),(1029,2090451600,7),(1029,2108595600,8),(1029,2121901200,7),(1029,2140045200,8),(1030,-2147483648,2),(1030,-1693706400,1),(1030,-1680483600,2),(1030,-1663455600,3),(1030,-1650150000,4),(1030,-1632006000,3),(1030,-1618700400,4),(1030,-938905200,3),(1030,-857257200,4),(1030,-844556400,3),(1030,-828226800,4),(1030,-812502000,3),(1030,-796777200,4),(1030,-781052400,3),(1030,-777866400,1),(1030,-765327600,4),(1030,-746578800,3),(1030,-733359600,4),(1030,-728517600,5),(1030,-721260000,2),(1030,-716425200,3),(1030,-701910000,4),(1030,-684975600,3),(1030,-670460400,4),(1030,-654217200,3),(1030,-639010800,4),(1030,283993200,2),(1030,291776400,6),(1030,307501200,7),(1030,323830800,6),(1030,338950800,7),(1030,354675600,6),(1030,370400400,7),(1030,386125200,6),(1030,401850000,7),(1030,417574800,6),(1030,433299600,7),(1030,449024400,6),(1030,465354000,7),(1030,481078800,6),(1030,496803600,7),(1030,512528400,6),(1030,528253200,7),(1030,543978000,6),(1030,559702800,7),(1030,575427600,6),(1030,591152400,7),(1030,606877200,6),(1030,622602000,7),(1030,638326800,6),(1030,654656400,7),(1030,670381200,6),(1030,686106000,7),(1030,701830800,6),(1030,717555600,7),(1030,733280400,6),(1030,749005200,7),(1030,764730000,6),(1030,780454800,7),(1030,796179600,6),(1030,811904400,7),(1030,828234000,6),(1030,846378000,7),(1030,859683600,6),(1030,877827600,7),(1030,891133200,6),(1030,909277200,7),(1030,922582800,6),(1030,941331600,7),(1030,954032400,6),(1030,972781200,7),(1030,985482000,6),(1030,1004230800,7),(1030,1017536400,6),(1030,1035680400,7),(1030,1048986000,6),(1030,1067130000,7),(1030,1080435600,6),(1030,1099184400,7),(1030,1111885200,6),(1030,1130634000,7),(1030,1143334800,6),(1030,1162083600,7),(1030,1174784400,6),(1030,1193533200,7),(1030,1206838800,6),(1030,1224982800,7),(1030,1238288400,6),(1030,1256432400,7),(1030,1269738000,6),(1030,1288486800,7),(1030,1301187600,6),(1030,1319936400,7),(1030,1332637200,6),(1030,1351386000,7),(1030,1364691600,6),(1030,1382835600,7),(1030,1396141200,6),(1030,1414285200,7),(1030,1427590800,6),(1030,1445734800,7),(1030,1459040400,6),(1030,1477789200,7),(1030,1490490000,6),(1030,1509238800,7),(1030,1521939600,6),(1030,1540688400,7),(1030,1553994000,6),(1030,1572138000,7),(1030,1585443600,6),(1030,1603587600,7),(1030,1616893200,6),(1030,1635642000,7),(1030,1648342800,6),(1030,1667091600,7),(1030,1679792400,6),(1030,1698541200,7),(1030,1711846800,6),(1030,1729990800,7),(1030,1743296400,6),(1030,1761440400,7),(1030,1774746000,6),(1030,1792890000,7),(1030,1806195600,6),(1030,1824944400,7),(1030,1837645200,6),(1030,1856394000,7),(1030,1869094800,6),(1030,1887843600,7),(1030,1901149200,6),(1030,1919293200,7),(1030,1932598800,6),(1030,1950742800,7),(1030,1964048400,6),(1030,1982797200,7),(1030,1995498000,6),(1030,2014246800,7),(1030,2026947600,6),(1030,2045696400,7),(1030,2058397200,6),(1030,2077146000,7),(1030,2090451600,6),(1030,2108595600,7),(1030,2121901200,6),(1030,2140045200,7),(1031,-2147483648,1),(1031,-1740355200,2),(1031,-1693702800,5),(1031,-1680483600,2),(1031,-1663455600,3),(1031,-1650150000,4),(1031,-1632006000,3),(1031,-1618700400,4),(1031,-1613826000,8),(1031,-1604278800,6),(1031,-1585530000,7),(1031,-1574038800,6),(1031,-1552266000,7),(1031,-1539997200,6),(1031,-1520557200,7),(1031,-1507510800,6),(1031,-1490576400,7),(1031,-1473642000,6),(1031,-1459126800,7),(1031,-1444006800,6),(1031,-1427677200,7),(1031,-1411952400,6),(1031,-1396227600,7),(1031,-1379293200,6),(1031,-1364778000,7),(1031,-1348448400,6),(1031,-1333328400,7),(1031,-1316394000,6),(1031,-1301263200,7),(1031,-1284328800,6),(1031,-1269813600,7),(1031,-1253484000,6),(1031,-1238364000,7),(1031,-1221429600,6),(1031,-1206914400,7),(1031,-1191189600,6),(1031,-1175464800,7),(1031,-1160344800,6),(1031,-1143410400,7),(1031,-1127685600,6),(1031,-1111960800,7),(1031,-1096840800,6),(1031,-1080511200,7),(1031,-1063576800,6),(1031,-1049061600,7),(1031,-1033336800,6),(1031,-1017612000,7),(1031,-1002492000,6),(1031,-986162400,7),(1031,-969228000,6),(1031,-950479200,7),(1031,-942012000,6),(1031,-934668000,3),(1031,-857257200,4),(1031,-844556400,3),(1031,-828226800,4),(1031,-812502000,3),(1031,-799293600,5),(1031,-798073200,4),(1031,-781052400,3),(1031,-766623600,4),(1031,-745455600,3),(1031,-733273200,4),(1031,220921200,2),(1031,228877200,9),(1031,243997200,10),(1031,260326800,9),(1031,276051600,10),(1031,291776400,9),(1031,307501200,10),(1031,323830800,9),(1031,338950800,10),(1031,354675600,9),(1031,370400400,10),(1031,386125200,9),(1031,401850000,10),(1031,417574800,9),(1031,433299600,10),(1031,449024400,9),(1031,465354000,10),(1031,481078800,9),(1031,496803600,10),(1031,512528400,9),(1031,528253200,10),(1031,543978000,9),(1031,559702800,10),(1031,575427600,9),(1031,591152400,10),(1031,606877200,9),(1031,622602000,10),(1031,638326800,9),(1031,654656400,10),(1031,670381200,9),(1031,686106000,10),(1031,701830800,9),(1031,717555600,10),(1031,733280400,9),(1031,749005200,10),(1031,764730000,9),(1031,780454800,10),(1031,796179600,9),(1031,811904400,10),(1031,828234000,9),(1031,846378000,10),(1031,859683600,9),(1031,877827600,10),(1031,891133200,9),(1031,909277200,10),(1031,922582800,9),(1031,941331600,10),(1031,954032400,9),(1031,972781200,10),(1031,985482000,9),(1031,1004230800,10),(1031,1017536400,9),(1031,1035680400,10),(1031,1048986000,9),(1031,1067130000,10),(1031,1080435600,9),(1031,1099184400,10),(1031,1111885200,9),(1031,1130634000,10),(1031,1143334800,9),(1031,1162083600,10),(1031,1174784400,9),(1031,1193533200,10),(1031,1206838800,9),(1031,1224982800,10),(1031,1238288400,9),(1031,1256432400,10),(1031,1269738000,9),(1031,1288486800,10),(1031,1301187600,9),(1031,1319936400,10),(1031,1332637200,9),(1031,1351386000,10),(1031,1364691600,9),(1031,1382835600,10),(1031,1396141200,9),(1031,1414285200,10),(1031,1427590800,9),(1031,1445734800,10),(1031,1459040400,9),(1031,1477789200,10),(1031,1490490000,9),(1031,1509238800,10),(1031,1521939600,9),(1031,1540688400,10),(1031,1553994000,9),(1031,1572138000,10),(1031,1585443600,9),(1031,1603587600,10),(1031,1616893200,9),(1031,1635642000,10),(1031,1648342800,9),(1031,1667091600,10),(1031,1679792400,9),(1031,1698541200,10),(1031,1711846800,9),(1031,1729990800,10),(1031,1743296400,9),(1031,1761440400,10),(1031,1774746000,9),(1031,1792890000,10),(1031,1806195600,9),(1031,1824944400,10),(1031,1837645200,9),(1031,1856394000,10),(1031,1869094800,9),(1031,1887843600,10),(1031,1901149200,9),(1031,1919293200,10),(1031,1932598800,9),(1031,1950742800,10),(1031,1964048400,9),(1031,1982797200,10),(1031,1995498000,9),(1031,2014246800,10),(1031,2026947600,9),(1031,2045696400,10),(1031,2058397200,9),(1031,2077146000,10),(1031,2090451600,9),(1031,2108595600,10),(1031,2121901200,9),(1031,2140045200,10),(1032,-2147483648,1),(1032,-1213148664,5),(1032,-1187056800,2),(1032,-1175479200,3),(1032,-1159754400,2),(1032,-1144029600,3),(1032,-1127700000,2),(1032,-1111975200,3),(1032,-1096250400,2),(1032,-1080525600,3),(1032,-1064800800,2),(1032,-1049076000,3),(1032,-1033351200,2),(1032,-1017626400,3),(1032,-1001901600,2),(1032,-986176800,3),(1032,-970452000,2),(1032,-954727200,3),(1032,296604000,4),(1032,307486800,5),(1032,323816400,4),(1032,338940000,5),(1032,354672000,2),(1032,370396800,3),(1032,386121600,2),(1032,401846400,3),(1032,417571200,2),(1032,433296000,3),(1032,449020800,2),(1032,465350400,3),(1032,481075200,2),(1032,496800000,3),(1032,512524800,2),(1032,528249600,3),(1032,543974400,2),(1032,559699200,3),(1032,575424000,2),(1032,591148800,3),(1032,606873600,2),(1032,622598400,3),(1032,638323200,2),(1032,654652800,3),(1032,662680800,5),(1032,670370400,2),(1032,686095200,3),(1032,701820000,2),(1032,717544800,3),(1032,733269600,2),(1032,748994400,3),(1032,757375200,5),(1032,764719200,4),(1032,780440400,5),(1032,796168800,4),(1032,811890000,5),(1032,828223200,4),(1032,846363600,5),(1032,859683600,6),(1032,877827600,7),(1032,891133200,6),(1032,909277200,7),(1032,922582800,6),(1032,941331600,7),(1032,954032400,6),(1032,972781200,7),(1032,985482000,6),(1032,1004230800,7),(1032,1017536400,6),(1032,1035680400,7),(1032,1048986000,6),(1032,1067130000,7),(1032,1080435600,6),(1032,1099184400,7),(1032,1111885200,6),(1032,1130634000,7),(1032,1143334800,6),(1032,1162083600,7),(1032,1174784400,6),(1032,1193533200,7),(1032,1206838800,6),(1032,1224982800,7),(1032,1238288400,6),(1032,1256432400,7),(1032,1269738000,6),(1032,1288486800,7),(1032,1301187600,6),(1032,1319936400,7),(1032,1332637200,6),(1032,1351386000,7),(1032,1364691600,6),(1032,1382835600,7),(1032,1396141200,6),(1032,1414285200,7),(1032,1427590800,6),(1032,1445734800,7),(1032,1459040400,6),(1032,1477789200,7),(1032,1490490000,6),(1032,1509238800,7),(1032,1521939600,6),(1032,1540688400,7),(1032,1553994000,6),(1032,1572138000,7),(1032,1585443600,6),(1032,1603587600,7),(1032,1616893200,6),(1032,1635642000,7),(1032,1648342800,6),(1032,1667091600,7),(1032,1679792400,6),(1032,1698541200,7),(1032,1711846800,6),(1032,1729990800,7),(1032,1743296400,6),(1032,1761440400,7),(1032,1774746000,6),(1032,1792890000,7),(1032,1806195600,6),(1032,1824944400,7),(1032,1837645200,6),(1032,1856394000,7),(1032,1869094800,6),(1032,1887843600,7),(1032,1901149200,6),(1032,1919293200,7),(1032,1932598800,6),(1032,1950742800,7),(1032,1964048400,6),(1032,1982797200,7),(1032,1995498000,6),(1032,2014246800,7),(1032,2026947600,6),(1032,2045696400,7),(1032,2058397200,6),(1032,2077146000,7),(1032,2090451600,6),(1032,2108595600,7),(1032,2121901200,6),(1032,2140045200,7),(1033,-2147483648,2),(1033,-1693706400,1),(1033,-1680483600,2),(1033,-1663455600,3),(1033,-1650150000,4),(1033,-1640998800,2),(1033,-1632006000,1),(1033,-1618700400,2),(1033,-1600470000,1),(1033,-1587250800,2),(1033,-1569711600,1),(1033,-1555196400,2),(1033,-906775200,1),(1033,-857257200,4),(1033,-844556400,3),(1033,-828226800,4),(1033,-812502000,3),(1033,-796777200,4),(1033,-788922000,2),(1033,-778471200,1),(1033,-762656400,2),(1033,-749689200,3),(1033,-733276800,2),(1033,-717634800,3),(1033,-701910000,4),(1033,-686185200,3),(1033,-670460400,4),(1033,-654130800,3),(1033,-639010800,4),(1033,-492656400,1),(1033,-481168800,2),(1033,-461199600,1),(1033,-449708400,2),(1033,-428540400,1),(1033,-418258800,2),(1033,-397090800,1),(1033,-386809200,2),(1033,323823600,1),(1033,338943600,2),(1033,354668400,1),(1033,370393200,2),(1033,386118000,1),(1033,401842800,2),(1033,417567600,1),(1033,433292400,2),(1033,449024400,5),(1033,465354000,6),(1033,481078800,5),(1033,496803600,6),(1033,512528400,5),(1033,528253200,6),(1033,543978000,5),(1033,559702800,6),(1033,575427600,5),(1033,591152400,6),(1033,606877200,5),(1033,622602000,6),(1033,638326800,5),(1033,654656400,6),(1033,670381200,5),(1033,686106000,6),(1033,701830800,5),(1033,717555600,6),(1033,733280400,5),(1033,749005200,6),(1033,764730000,5),(1033,780454800,6),(1033,796179600,5),(1033,811904400,6),(1033,828234000,5),(1033,846378000,6),(1033,859683600,5),(1033,877827600,6),(1033,891133200,5),(1033,909277200,6),(1033,922582800,5),(1033,941331600,6),(1033,954032400,5),(1033,972781200,6),(1033,985482000,5),(1033,1004230800,6),(1033,1017536400,5),(1033,1035680400,6),(1033,1048986000,5),(1033,1067130000,6),(1033,1080435600,5),(1033,1099184400,6),(1033,1111885200,5),(1033,1130634000,6),(1033,1143334800,5),(1033,1162083600,6),(1033,1174784400,5),(1033,1193533200,6),(1033,1206838800,5),(1033,1224982800,6),(1033,1238288400,5),(1033,1256432400,6),(1033,1269738000,5),(1033,1288486800,6),(1033,1301187600,5),(1033,1319936400,6),(1033,1332637200,5),(1033,1351386000,6),(1033,1364691600,5),(1033,1382835600,6),(1033,1396141200,5),(1033,1414285200,6),(1033,1427590800,5),(1033,1445734800,6),(1033,1459040400,5),(1033,1477789200,6),(1033,1490490000,5),(1033,1509238800,6),(1033,1521939600,5),(1033,1540688400,6),(1033,1553994000,5),(1033,1572138000,6),(1033,1585443600,5),(1033,1603587600,6),(1033,1616893200,5),(1033,1635642000,6),(1033,1648342800,5),(1033,1667091600,6),(1033,1679792400,5),(1033,1698541200,6),(1033,1711846800,5),(1033,1729990800,6),(1033,1743296400,5),(1033,1761440400,6),(1033,1774746000,5),(1033,1792890000,6),(1033,1806195600,5),(1033,1824944400,6),(1033,1837645200,5),(1033,1856394000,6),(1033,1869094800,5),(1033,1887843600,6),(1033,1901149200,5),(1033,1919293200,6),(1033,1932598800,5),(1033,1950742800,6),(1033,1964048400,5),(1033,1982797200,6),(1033,1995498000,5),(1033,2014246800,6),(1033,2026947600,5),(1033,2045696400,6),(1033,2058397200,5),(1033,2077146000,6),(1033,2090451600,5),(1033,2108595600,6),(1033,2121901200,5),(1033,2140045200,6),(1034,-2147483648,2),(1034,-904435200,1),(1034,-891129600,2),(1034,-872985600,1),(1034,-859680000,2),(1034,354675600,3),(1034,370400400,4),(1034,386125200,3),(1034,401850000,4),(1034,417574800,3),(1034,433299600,4),(1034,449024400,3),(1034,465354000,4),(1034,481078800,3),(1034,496803600,4),(1034,512528400,3),(1034,528253200,4),(1034,543978000,3),(1034,559702800,4),(1034,575427600,3),(1034,591152400,4),(1034,606877200,3),(1034,622602000,4),(1034,638326800,3),(1034,654656400,4),(1034,670381200,3),(1034,686106000,4),(1034,701830800,3),(1034,717555600,4),(1034,733280400,3),(1034,749005200,4),(1034,764730000,3),(1034,780454800,4),(1034,796179600,3),(1034,811904400,4),(1034,828234000,3),(1034,846378000,4),(1034,859683600,3),(1034,877827600,4),(1034,891133200,3),(1034,909277200,4),(1034,922582800,3),(1034,941331600,4),(1034,954032400,3),(1034,972781200,4),(1034,985482000,3),(1034,1004230800,4),(1034,1017536400,3),(1034,1035680400,4),(1034,1048986000,3),(1034,1067130000,4),(1034,1080435600,3),(1034,1099184400,4),(1034,1111885200,3),(1034,1130634000,4),(1034,1143334800,3),(1034,1162083600,4),(1034,1174784400,3),(1034,1193533200,4),(1034,1206838800,3),(1034,1224982800,4),(1034,1238288400,3),(1034,1256432400,4),(1034,1269738000,3),(1034,1288486800,4),(1034,1301187600,3),(1034,1319936400,4),(1034,1332637200,3),(1034,1351386000,4),(1034,1364691600,3),(1034,1382835600,4),(1034,1396141200,3),(1034,1414285200,4),(1034,1427590800,3),(1034,1445734800,4),(1034,1459040400,3),(1034,1477789200,4),(1034,1490490000,3),(1034,1509238800,4),(1034,1521939600,3),(1034,1540688400,4),(1034,1553994000,3),(1034,1572138000,4),(1034,1585443600,3),(1034,1603587600,4),(1034,1616893200,3),(1034,1635642000,4),(1034,1648342800,3),(1034,1667091600,4),(1034,1679792400,3),(1034,1698541200,4),(1034,1711846800,3),(1034,1729990800,4),(1034,1743296400,3),(1034,1761440400,4),(1034,1774746000,3),(1034,1792890000,4),(1034,1806195600,3),(1034,1824944400,4),(1034,1837645200,3),(1034,1856394000,4),(1034,1869094800,3),(1034,1887843600,4),(1034,1901149200,3),(1034,1919293200,4),(1034,1932598800,3),(1034,1950742800,4),(1034,1964048400,3),(1034,1982797200,4),(1034,1995498000,3),(1034,2014246800,4),(1034,2026947600,3),(1034,2045696400,4),(1034,2058397200,3),(1034,2077146000,4),(1034,2090451600,3),(1034,2108595600,4),(1034,2121901200,3),(1034,2140045200,4),(1035,-2147483648,1),(1035,-1637114100,2),(1035,-1213148664,5),(1035,-1187056800,3),(1035,-1175479200,4),(1035,-1159754400,3),(1035,-1144029600,4),(1035,-1127700000,3),(1035,-1111975200,4),(1035,-1096250400,3),(1035,-1080525600,4),(1035,-1064800800,3),(1035,-1049076000,4),(1035,-1033351200,3),(1035,-1017626400,4),(1035,-1001901600,3),(1035,-986176800,4),(1035,-970452000,3),(1035,-954727200,4),(1035,-927165600,6),(1035,-898138800,9),(1035,-857257200,7),(1035,-844556400,8),(1035,-828226800,7),(1035,-812502000,8),(1035,-800157600,11),(1035,354920400,10),(1035,370728000,11),(1035,386456400,10),(1035,402264000,11),(1035,417992400,10),(1035,433800000,11),(1035,449614800,10),(1035,465346800,12),(1035,481071600,13),(1035,496796400,12),(1035,512521200,13),(1035,528246000,12),(1035,543970800,13),(1035,559695600,12),(1035,575420400,13),(1035,591145200,12),(1035,606870000,13),(1035,622594800,12),(1035,638319600,13),(1035,641944800,6),(1035,654652800,4),(1035,670377600,3),(1035,686102400,4),(1035,694216800,5),(1035,701820000,6),(1035,717541200,5),(1035,733269600,6),(1035,748990800,5),(1035,764719200,6),(1035,780440400,5),(1035,796168800,6),(1035,811890000,5),(1035,828223200,6),(1035,846363600,5),(1035,859680000,6),(1035,877824000,5),(1035,891129600,6),(1035,909273600,5),(1035,922579200,6),(1035,941328000,5),(1035,954028800,6),(1035,972777600,5),(1035,985478400,6),(1035,1004227200,5),(1035,1017532800,6),(1035,1035676800,5),(1035,1048982400,6),(1035,1067126400,5),(1035,1080432000,6),(1035,1099180800,5),(1035,1111881600,6),(1035,1130630400,5),(1035,1143331200,6),(1035,1162080000,5),(1035,1174780800,6),(1035,1193529600,5),(1035,1206835200,6),(1035,1224979200,5),(1035,1238284800,6),(1035,1256428800,5),(1035,1269734400,6),(1035,1288483200,5),(1035,1301184000,6),(1035,1319932800,5),(1035,1332633600,6),(1035,1351382400,5),(1035,1364688000,6),(1035,1382832000,5),(1035,1396137600,6),(1035,1414281600,5),(1035,1427587200,6),(1035,1445731200,5),(1035,1459036800,6),(1035,1477785600,5),(1035,1490486400,6),(1035,1509235200,5),(1035,1521936000,6),(1035,1540684800,5),(1035,1553990400,6),(1035,1572134400,5),(1035,1585440000,6),(1035,1603584000,5),(1035,1616889600,6),(1035,1635638400,5),(1035,1648339200,6),(1035,1667088000,5),(1035,1679788800,6),(1035,1698537600,5),(1035,1711843200,6),(1035,1729987200,5),(1035,1743292800,6),(1035,1761436800,5),(1035,1774742400,6),(1035,1792886400,5),(1035,1806192000,6),(1035,1824940800,5),(1035,1837641600,6),(1035,1856390400,5),(1035,1869091200,6),(1035,1887840000,5),(1035,1901145600,6),(1035,1919289600,5),(1035,1932595200,6),(1035,1950739200,5),(1035,1964044800,6),(1035,1982793600,5),(1035,1995494400,6),(1035,2014243200,5),(1035,2026944000,6),(1035,2045692800,5),(1035,2058393600,6),(1035,2077142400,5),(1035,2090448000,6),(1035,2108592000,5),(1035,2121897600,6),(1035,2140041600,5),(1036,-2147483648,2),(1036,-1693706400,1),(1036,-1680483600,2),(1036,-1663455600,3),(1036,-1650150000,4),(1036,-1632006000,3),(1036,-1618700400,4),(1036,-938905200,3),(1036,-857257200,4),(1036,-844556400,3),(1036,-828226800,4),(1036,-812502000,3),(1036,-796777200,4),(1036,-781052400,3),(1036,-776563200,5),(1036,-765936000,1),(1036,-761180400,4),(1036,-757386000,2),(1036,-748479600,3),(1036,-733273200,4),(1036,-717631200,3),(1036,-714610800,6),(1036,-710380800,1),(1036,-701910000,4),(1036,-684975600,3),(1036,-670460400,4),(1036,-654130800,3),(1036,-639010800,4),(1036,315529200,2),(1036,323830800,7),(1036,338950800,8),(1036,354675600,7),(1036,370400400,8),(1036,386125200,7),(1036,401850000,8),(1036,417574800,7),(1036,433299600,8),(1036,449024400,7),(1036,465354000,8),(1036,481078800,7),(1036,496803600,8),(1036,512528400,7),(1036,528253200,8),(1036,543978000,7),(1036,559702800,8),(1036,575427600,7),(1036,591152400,8),(1036,606877200,7),(1036,622602000,8),(1036,638326800,7),(1036,654656400,8),(1036,670381200,7),(1036,686106000,8),(1036,701830800,7),(1036,717555600,8),(1036,733280400,7),(1036,749005200,8),(1036,764730000,7),(1036,780454800,8),(1036,796179600,7),(1036,811904400,8),(1036,828234000,7),(1036,846378000,8),(1036,859683600,7),(1036,877827600,8),(1036,891133200,7),(1036,909277200,8),(1036,922582800,7),(1036,941331600,8),(1036,954032400,7),(1036,972781200,8),(1036,985482000,7),(1036,1004230800,8),(1036,1017536400,7),(1036,1035680400,8),(1036,1048986000,7),(1036,1067130000,8),(1036,1080435600,7),(1036,1099184400,8),(1036,1111885200,7),(1036,1130634000,8),(1036,1143334800,7),(1036,1162083600,8),(1036,1174784400,7),(1036,1193533200,8),(1036,1206838800,7),(1036,1224982800,8),(1036,1238288400,7),(1036,1256432400,8),(1036,1269738000,7),(1036,1288486800,8),(1036,1301187600,7),(1036,1319936400,8),(1036,1332637200,7),(1036,1351386000,8),(1036,1364691600,7),(1036,1382835600,8),(1036,1396141200,7),(1036,1414285200,8),(1036,1427590800,7),(1036,1445734800,8),(1036,1459040400,7),(1036,1477789200,8),(1036,1490490000,7),(1036,1509238800,8),(1036,1521939600,7),(1036,1540688400,8),(1036,1553994000,7),(1036,1572138000,8),(1036,1585443600,7),(1036,1603587600,8),(1036,1616893200,7),(1036,1635642000,8),(1036,1648342800,7),(1036,1667091600,8),(1036,1679792400,7),(1036,1698541200,8),(1036,1711846800,7),(1036,1729990800,8),(1036,1743296400,7),(1036,1761440400,8),(1036,1774746000,7),(1036,1792890000,8),(1036,1806195600,7),(1036,1824944400,8),(1036,1837645200,7),(1036,1856394000,8),(1036,1869094800,7),(1036,1887843600,8),(1036,1901149200,7),(1036,1919293200,8),(1036,1932598800,7),(1036,1950742800,8),(1036,1964048400,7),(1036,1982797200,8),(1036,1995498000,7),(1036,2014246800,8),(1036,2026947600,7),(1036,2045696400,8),(1036,2058397200,7),(1036,2077146000,8),(1036,2090451600,7),(1036,2108595600,8),(1036,2121901200,7),(1036,2140045200,8),(1037,-2147483648,1),(1037,-1691962479,2),(1037,-1680471279,4),(1037,-1664143200,3),(1037,-1650146400,4),(1037,-1633903200,3),(1037,-1617487200,4),(1037,-1601848800,3),(1037,-1586037600,4),(1037,-1570399200,3),(1037,-1552168800,4),(1037,-1538344800,3),(1037,-1522533600,4),(1037,-1517011200,6),(1037,-1507500000,5),(1037,-1490565600,4),(1037,-1473631200,5),(1037,-1460930400,4),(1037,-1442786400,5),(1037,-1428876000,4),(1037,-1410732000,5),(1037,-1396216800,4),(1037,-1379282400,5),(1037,-1364767200,4),(1037,-1348437600,5),(1037,-1333317600,4),(1037,-1315778400,5),(1037,-1301263200,4),(1037,-1284328800,5),(1037,-1269813600,4),(1037,-1253484000,5),(1037,-1238364000,4),(1037,-1221429600,5),(1037,-1206914400,4),(1037,-1189980000,5),(1037,-1175464800,4),(1037,-1159135200,5),(1037,-1143410400,4),(1037,-1126476000,5),(1037,-1111960800,4),(1037,-1095631200,5),(1037,-1080511200,4),(1037,-1063576800,5),(1037,-1049061600,4),(1037,-1032127200,5),(1037,-1017612000,4),(1037,-1001282400,5),(1037,-986162400,4),(1037,-969228000,5),(1037,-950479200,4),(1037,-942012000,5),(1037,-733356000,4),(1037,-719445600,5),(1037,-699487200,4),(1037,-684972000,5),(1037,-668037600,4),(1037,-654732000,5),(1037,-636588000,4),(1037,-622072800,5),(1037,-605743200,4),(1037,-590623200,5),(1037,-574293600,4),(1037,-558568800,5),(1037,-542239200,4),(1037,-527119200,5),(1037,-512604000,4),(1037,-496274400,5),(1037,-481154400,4),(1037,-464220000,5),(1037,-449704800,4),(1037,-432165600,5),(1037,-417650400,4),(1037,-401320800,5),(1037,-386200800,4),(1037,-369266400,5),(1037,-354751200,4),(1037,-337816800,5),(1037,-323301600,4),(1037,-306972000,5),(1037,-291852000,4),(1037,-276732000,5),(1037,-257983200,4),(1037,-245282400,5),(1037,-226533600,4),(1037,-213228000,5),(1037,-195084000,4),(1037,-182383200,5),(1037,-163634400,4),(1037,-150933600,5),(1037,-132184800,4),(1037,-119484000,5),(1037,-100735200,4),(1037,-88034400,5),(1037,-68680800,4),(1037,-59004000,5),(1037,-37242000,7),(1037,57722400,9),(1037,69818400,5),(1037,89172000,4),(1037,101268000,5),(1037,120621600,4),(1037,132717600,5),(1037,152071200,4),(1037,164167200,5),(1037,183520800,4),(1037,196221600,5),(1037,214970400,4),(1037,227671200,5),(1037,246420000,4),(1037,259120800,5),(1037,278474400,4),(1037,290570400,5),(1037,309924000,4),(1037,322020000,5),(1037,341373600,4),(1037,354675600,8),(1037,372819600,9),(1037,386125200,8),(1037,404269200,9),(1037,417574800,8),(1037,435718800,9),(1037,449024400,8),(1037,467773200,9),(1037,481078800,8),(1037,499222800,9),(1037,512528400,8),(1037,530672400,9),(1037,543978000,8),(1037,562122000,9),(1037,575427600,8),(1037,593571600,9),(1037,606877200,8),(1037,625626000,9),(1037,638326800,8),(1037,657075600,9),(1037,670381200,8),(1037,688525200,9),(1037,701830800,8),(1037,719974800,9),(1037,733280400,8),(1037,751424400,9),(1037,764730000,8),(1037,782874000,9),(1037,796179600,8),(1037,814323600,9),(1037,820454400,6),(1037,828234000,8),(1037,846378000,9),(1037,859683600,8),(1037,877827600,9),(1037,891133200,8),(1037,909277200,9),(1037,922582800,8),(1037,941331600,9),(1037,954032400,8),(1037,972781200,9),(1037,985482000,8),(1037,1004230800,9),(1037,1017536400,8),(1037,1035680400,9),(1037,1048986000,8),(1037,1067130000,9),(1037,1080435600,8),(1037,1099184400,9),(1037,1111885200,8),(1037,1130634000,9),(1037,1143334800,8),(1037,1162083600,9),(1037,1174784400,8),(1037,1193533200,9),(1037,1206838800,8),(1037,1224982800,9),(1037,1238288400,8),(1037,1256432400,9),(1037,1269738000,8),(1037,1288486800,9),(1037,1301187600,8),(1037,1319936400,9),(1037,1332637200,8),(1037,1351386000,9),(1037,1364691600,8),(1037,1382835600,9),(1037,1396141200,8),(1037,1414285200,9),(1037,1427590800,8),(1037,1445734800,9),(1037,1459040400,8),(1037,1477789200,9),(1037,1490490000,8),(1037,1509238800,9),(1037,1521939600,8),(1037,1540688400,9),(1037,1553994000,8),(1037,1572138000,9),(1037,1585443600,8),(1037,1603587600,9),(1037,1616893200,8),(1037,1635642000,9),(1037,1648342800,8),(1037,1667091600,9),(1037,1679792400,8),(1037,1698541200,9),(1037,1711846800,8),(1037,1729990800,9),(1037,1743296400,8),(1037,1761440400,9),(1037,1774746000,8),(1037,1792890000,9),(1037,1806195600,8),(1037,1824944400,9),(1037,1837645200,8),(1037,1856394000,9),(1037,1869094800,8),(1037,1887843600,9),(1037,1901149200,8),(1037,1919293200,9),(1037,1932598800,8),(1037,1950742800,9),(1037,1964048400,8),(1037,1982797200,9),(1037,1995498000,8),(1037,2014246800,9),(1037,2026947600,8),(1037,2045696400,9),(1037,2058397200,8),(1037,2077146000,9),(1037,2090451600,8),(1037,2108595600,9),(1037,2121901200,8),(1037,2140045200,9),(1038,-2147483648,4),(1038,-1691964000,1),(1038,-1680472800,2),(1038,-1664143200,1),(1038,-1650146400,2),(1038,-1633903200,1),(1038,-1617487200,2),(1038,-1601848800,1),(1038,-1586037600,2),(1038,-1570399200,1),(1038,-1552168800,2),(1038,-1538344800,1),(1038,-1522533600,2),(1038,-1507500000,1),(1038,-1490565600,2),(1038,-1473631200,1),(1038,-1460930400,2),(1038,-1442786400,1),(1038,-1428876000,2),(1038,-1410732000,1),(1038,-1396216800,2),(1038,-1379282400,1),(1038,-1364767200,2),(1038,-1348437600,1),(1038,-1333317600,2),(1038,-1315778400,1),(1038,-1301263200,2),(1038,-1284328800,1),(1038,-1269813600,2),(1038,-1253484000,1),(1038,-1238364000,2),(1038,-1221429600,1),(1038,-1206914400,2),(1038,-1189980000,1),(1038,-1175464800,2),(1038,-1159135200,1),(1038,-1143410400,2),(1038,-1126476000,1),(1038,-1111960800,2),(1038,-1095631200,1),(1038,-1080511200,2),(1038,-1063576800,1),(1038,-1049061600,2),(1038,-1032127200,1),(1038,-1017612000,2),(1038,-1001282400,1),(1038,-986162400,2),(1038,-969228000,1),(1038,-950479200,2),(1038,-942012000,1),(1038,-904518000,3),(1038,-896050800,1),(1038,-875487600,3),(1038,-864601200,1),(1038,-844038000,3),(1038,-832546800,1),(1038,-812588400,3),(1038,-798073200,1),(1038,-781052400,3),(1038,-772066800,1),(1038,-764805600,2),(1038,-748476000,1),(1038,-733356000,2),(1038,-719445600,1),(1038,-717030000,3),(1038,-706748400,1),(1038,-699487200,2),(1038,-687996000,1),(1038,-668037600,2),(1038,-654732000,1),(1038,-636588000,2),(1038,-622072800,1),(1038,-605743200,2),(1038,-590623200,1),(1038,-574293600,2),(1038,-558568800,1),(1038,-542239200,2),(1038,-527119200,1),(1038,-512604000,2),(1038,-496274400,1),(1038,-481154400,2),(1038,-464220000,1),(1038,-449704800,2),(1038,-432165600,1),(1038,-417650400,2),(1038,-401320800,5),(1038,386125200,6),(1038,401850000,7),(1038,417574800,6),(1038,433299600,7),(1038,449024400,6),(1038,465354000,7),(1038,481078800,6),(1038,496803600,7),(1038,512528400,6),(1038,528253200,7),(1038,543978000,6),(1038,559702800,7),(1038,575427600,6),(1038,591152400,7),(1038,606877200,6),(1038,622602000,7),(1038,638326800,6),(1038,654656400,7),(1038,670381200,6),(1038,686106000,7),(1038,701830800,6),(1038,717555600,7),(1038,733280400,6),(1038,749005200,7),(1038,764730000,6),(1038,780454800,7),(1038,796179600,6),(1038,811904400,7),(1038,828234000,6),(1038,846378000,7),(1038,859683600,6),(1038,877827600,7),(1038,891133200,6),(1038,909277200,7),(1038,922582800,6),(1038,941331600,7),(1038,954032400,6),(1038,972781200,7),(1038,985482000,6),(1038,1004230800,7),(1038,1017536400,6),(1038,1035680400,7),(1038,1048986000,6),(1038,1067130000,7),(1038,1080435600,6),(1038,1099184400,7),(1038,1111885200,6),(1038,1130634000,7),(1038,1143334800,6),(1038,1162083600,7),(1038,1174784400,6),(1038,1193533200,7),(1038,1206838800,6),(1038,1224982800,7),(1038,1238288400,6),(1038,1256432400,7),(1038,1269738000,6),(1038,1288486800,7),(1038,1301187600,6),(1038,1319936400,7),(1038,1332637200,6),(1038,1351386000,7),(1038,1364691600,6),(1038,1382835600,7),(1038,1396141200,6),(1038,1414285200,7),(1038,1427590800,6),(1038,1445734800,7),(1038,1459040400,6),(1038,1477789200,7),(1038,1490490000,6),(1038,1509238800,7),(1038,1521939600,6),(1038,1540688400,7),(1038,1553994000,6),(1038,1572138000,7),(1038,1585443600,6),(1038,1603587600,7),(1038,1616893200,6),(1038,1635642000,7),(1038,1648342800,6),(1038,1667091600,7),(1038,1679792400,6),(1038,1698541200,7),(1038,1711846800,6),(1038,1729990800,7),(1038,1743296400,6),(1038,1761440400,7),(1038,1774746000,6),(1038,1792890000,7),(1038,1806195600,6),(1038,1824944400,7),(1038,1837645200,6),(1038,1856394000,7),(1038,1869094800,6),(1038,1887843600,7),(1038,1901149200,6),(1038,1919293200,7),(1038,1932598800,6),(1038,1950742800,7),(1038,1964048400,6),(1038,1982797200,7),(1038,1995498000,6),(1038,2014246800,7),(1038,2026947600,6),(1038,2045696400,7),(1038,2058397200,6),(1038,2077146000,7),(1038,2090451600,6),(1038,2108595600,7),(1038,2121901200,6),(1038,2140045200,7),(1039,-2147483648,4),(1039,-1691964000,1),(1039,-1680472800,2),(1039,-1664143200,1),(1039,-1650146400,2),(1039,-1633903200,1),(1039,-1617487200,2),(1039,-1601848800,1),(1039,-1586037600,2),(1039,-1570399200,1),(1039,-1552168800,2),(1039,-1538344800,1),(1039,-1522533600,2),(1039,-1507500000,1),(1039,-1490565600,2),(1039,-1473631200,1),(1039,-1460930400,2),(1039,-1442786400,1),(1039,-1428876000,2),(1039,-1410732000,1),(1039,-1396216800,2),(1039,-1379282400,1),(1039,-1364767200,2),(1039,-1348437600,1),(1039,-1333317600,2),(1039,-1315778400,1),(1039,-1301263200,2),(1039,-1284328800,1),(1039,-1269813600,2),(1039,-1253484000,1),(1039,-1238364000,2),(1039,-1221429600,1),(1039,-1206914400,2),(1039,-1189980000,1),(1039,-1175464800,2),(1039,-1159135200,1),(1039,-1143410400,2),(1039,-1126476000,1),(1039,-1111960800,2),(1039,-1095631200,1),(1039,-1080511200,2),(1039,-1063576800,1),(1039,-1049061600,2),(1039,-1032127200,1),(1039,-1017612000,2),(1039,-1001282400,1),(1039,-986162400,2),(1039,-969228000,1),(1039,-950479200,2),(1039,-942012000,1),(1039,-904518000,3),(1039,-896050800,1),(1039,-875487600,3),(1039,-864601200,1),(1039,-844038000,3),(1039,-832546800,1),(1039,-812588400,3),(1039,-798073200,1),(1039,-781052400,3),(1039,-772066800,1),(1039,-764805600,2),(1039,-748476000,1),(1039,-733356000,2),(1039,-719445600,1),(1039,-717030000,3),(1039,-706748400,1),(1039,-699487200,2),(1039,-687996000,1),(1039,-668037600,2),(1039,-654732000,1),(1039,-636588000,2),(1039,-622072800,1),(1039,-605743200,2),(1039,-590623200,1),(1039,-574293600,2),(1039,-558568800,1),(1039,-542239200,2),(1039,-527119200,1),(1039,-512604000,2),(1039,-496274400,1),(1039,-481154400,2),(1039,-464220000,1),(1039,-449704800,2),(1039,-432165600,1),(1039,-417650400,2),(1039,-401320800,1),(1039,-386200800,2),(1039,-369266400,1),(1039,-354751200,2),(1039,-337816800,1),(1039,-323301600,2),(1039,-306972000,1),(1039,-291852000,2),(1039,-276732000,1),(1039,-257983200,2),(1039,-245282400,1),(1039,-226533600,2),(1039,-213228000,1),(1039,-195084000,2),(1039,-182383200,1),(1039,-163634400,2),(1039,-150933600,1),(1039,-132184800,2),(1039,-119484000,1),(1039,-100735200,2),(1039,-88034400,1),(1039,-68680800,2),(1039,-59004000,1),(1039,-37242000,5),(1039,57722400,7),(1039,69818400,1),(1039,89172000,2),(1039,101268000,1),(1039,120621600,2),(1039,132717600,1),(1039,152071200,2),(1039,164167200,1),(1039,183520800,2),(1039,196221600,1),(1039,214970400,2),(1039,227671200,1),(1039,246420000,2),(1039,259120800,1),(1039,278474400,2),(1039,290570400,1),(1039,309924000,2),(1039,322020000,1),(1039,341373600,2),(1039,354675600,6),(1039,372819600,7),(1039,386125200,6),(1039,404269200,7),(1039,417574800,6),(1039,435718800,7),(1039,449024400,6),(1039,467773200,7),(1039,481078800,6),(1039,499222800,7),(1039,512528400,6),(1039,530672400,7),(1039,543978000,6),(1039,562122000,7),(1039,575427600,6),(1039,593571600,7),(1039,606877200,6),(1039,625626000,7),(1039,638326800,6),(1039,657075600,7),(1039,670381200,6),(1039,688525200,7),(1039,701830800,6),(1039,719974800,7),(1039,733280400,6),(1039,751424400,7),(1039,764730000,6),(1039,782874000,7),(1039,796179600,6),(1039,814323600,7),(1039,820454400,4),(1039,828234000,6),(1039,846378000,7),(1039,859683600,6),(1039,877827600,7),(1039,891133200,6),(1039,909277200,7),(1039,922582800,6),(1039,941331600,7),(1039,954032400,6),(1039,972781200,7),(1039,985482000,6),(1039,1004230800,7),(1039,1017536400,6),(1039,1035680400,7),(1039,1048986000,6),(1039,1067130000,7),(1039,1080435600,6),(1039,1099184400,7),(1039,1111885200,6),(1039,1130634000,7),(1039,1143334800,6),(1039,1162083600,7),(1039,1174784400,6),(1039,1193533200,7),(1039,1206838800,6),(1039,1224982800,7),(1039,1238288400,6),(1039,1256432400,7),(1039,1269738000,6),(1039,1288486800,7),(1039,1301187600,6),(1039,1319936400,7),(1039,1332637200,6),(1039,1351386000,7),(1039,1364691600,6),(1039,1382835600,7),(1039,1396141200,6),(1039,1414285200,7),(1039,1427590800,6),(1039,1445734800,7),(1039,1459040400,6),(1039,1477789200,7),(1039,1490490000,6),(1039,1509238800,7),(1039,1521939600,6),(1039,1540688400,7),(1039,1553994000,6),(1039,1572138000,7),(1039,1585443600,6),(1039,1603587600,7),(1039,1616893200,6),(1039,1635642000,7),(1039,1648342800,6),(1039,1667091600,7),(1039,1679792400,6),(1039,1698541200,7),(1039,1711846800,6),(1039,1729990800,7),(1039,1743296400,6),(1039,1761440400,7),(1039,1774746000,6),(1039,1792890000,7),(1039,1806195600,6),(1039,1824944400,7),(1039,1837645200,6),(1039,1856394000,7),(1039,1869094800,6),(1039,1887843600,7),(1039,1901149200,6),(1039,1919293200,7),(1039,1932598800,6),(1039,1950742800,7),(1039,1964048400,6),(1039,1982797200,7),(1039,1995498000,6),(1039,2014246800,7),(1039,2026947600,6),(1039,2045696400,7),(1039,2058397200,6),(1039,2077146000,7),(1039,2090451600,6),(1039,2108595600,7),(1039,2121901200,6),(1039,2140045200,7),(1040,-2147483648,1),(1040,-1535938789,3),(1040,-875671200,2),(1040,-859773600,3),(1040,354672000,2),(1040,370396800,3),(1040,386121600,2),(1040,401846400,3),(1040,417574800,4),(1040,433299600,5),(1040,449024400,4),(1040,465354000,5),(1040,481078800,4),(1040,496803600,5),(1040,512528400,4),(1040,528253200,5),(1040,543978000,4),(1040,559702800,5),(1040,575427600,4),(1040,591152400,5),(1040,606877200,4),(1040,622602000,5),(1040,638326800,4),(1040,654656400,5),(1040,670381200,4),(1040,686106000,5),(1040,701830800,4),(1040,717555600,5),(1040,733280400,4),(1040,749005200,5),(1040,764730000,4),(1040,780454800,5),(1040,796179600,4),(1040,811904400,5),(1040,828234000,4),(1040,846378000,5),(1040,859683600,4),(1040,877827600,5),(1040,891133200,4),(1040,909277200,5),(1040,922582800,4),(1040,941331600,5),(1040,954032400,4),(1040,972781200,5),(1040,985482000,4),(1040,1004230800,5),(1040,1017536400,4),(1040,1035680400,5),(1040,1048986000,4),(1040,1067130000,5),(1040,1080435600,4),(1040,1099184400,5),(1040,1111885200,4),(1040,1130634000,5),(1040,1143334800,4),(1040,1162083600,5),(1040,1174784400,4),(1040,1193533200,5),(1040,1206838800,4),(1040,1224982800,5),(1040,1238288400,4),(1040,1256432400,5),(1040,1269738000,4),(1040,1288486800,5),(1040,1301187600,4),(1040,1319936400,5),(1040,1332637200,4),(1040,1351386000,5),(1040,1364691600,4),(1040,1382835600,5),(1040,1396141200,4),(1040,1414285200,5),(1040,1427590800,4),(1040,1445734800,5),(1040,1459040400,4),(1040,1477789200,5),(1040,1490490000,4),(1040,1509238800,5),(1040,1521939600,4),(1040,1540688400,5),(1040,1553994000,4),(1040,1572138000,5),(1040,1585443600,4),(1040,1603587600,5),(1040,1616893200,4),(1040,1635642000,5),(1040,1648342800,4),(1040,1667091600,5),(1040,1679792400,4),(1040,1698541200,5),(1040,1711846800,4),(1040,1729990800,5),(1040,1743296400,4),(1040,1761440400,5),(1040,1774746000,4),(1040,1792890000,5),(1040,1806195600,4),(1040,1824944400,5),(1040,1837645200,4),(1040,1856394000,5),(1040,1869094800,4),(1040,1887843600,5),(1040,1901149200,4),(1040,1919293200,5),(1040,1932598800,4),(1040,1950742800,5),(1040,1964048400,4),(1040,1982797200,5),(1040,1995498000,4),(1040,2014246800,5),(1040,2026947600,4),(1040,2045696400,5),(1040,2058397200,4),(1040,2077146000,5),(1040,2090451600,4),(1040,2108595600,5),(1040,2121901200,4),(1040,2140045200,5),(1041,-2147483648,4),(1041,-1691964000,1),(1041,-1680472800,2),(1041,-1664143200,1),(1041,-1650146400,2),(1041,-1633903200,1),(1041,-1617487200,2),(1041,-1601848800,1),(1041,-1586037600,2),(1041,-1570399200,1),(1041,-1552168800,2),(1041,-1538344800,1),(1041,-1522533600,2),(1041,-1507500000,1),(1041,-1490565600,2),(1041,-1473631200,1),(1041,-1460930400,2),(1041,-1442786400,1),(1041,-1428876000,2),(1041,-1410732000,1),(1041,-1396216800,2),(1041,-1379282400,1),(1041,-1364767200,2),(1041,-1348437600,1),(1041,-1333317600,2),(1041,-1315778400,1),(1041,-1301263200,2),(1041,-1284328800,1),(1041,-1269813600,2),(1041,-1253484000,1),(1041,-1238364000,2),(1041,-1221429600,1),(1041,-1206914400,2),(1041,-1189980000,1),(1041,-1175464800,2),(1041,-1159135200,1),(1041,-1143410400,2),(1041,-1126476000,1),(1041,-1111960800,2),(1041,-1095631200,1),(1041,-1080511200,2),(1041,-1063576800,1),(1041,-1049061600,2),(1041,-1032127200,1),(1041,-1017612000,2),(1041,-1001282400,1),(1041,-986162400,2),(1041,-969228000,1),(1041,-950479200,2),(1041,-942012000,1),(1041,-904518000,3),(1041,-896050800,1),(1041,-875487600,3),(1041,-864601200,1),(1041,-844038000,3),(1041,-832546800,1),(1041,-812588400,3),(1041,-798073200,1),(1041,-781052400,3),(1041,-772066800,1),(1041,-764805600,2),(1041,-748476000,1),(1041,-733356000,2),(1041,-719445600,1),(1041,-717030000,3),(1041,-706748400,1),(1041,-699487200,2),(1041,-687996000,1),(1041,-668037600,2),(1041,-654732000,1),(1041,-636588000,2),(1041,-622072800,1),(1041,-605743200,2),(1041,-590623200,1),(1041,-574293600,2),(1041,-558568800,1),(1041,-542239200,2),(1041,-527119200,1),(1041,-512604000,2),(1041,-496274400,1),(1041,-481154400,2),(1041,-464220000,1),(1041,-449704800,2),(1041,-432165600,1),(1041,-417650400,2),(1041,-401320800,1),(1041,-386200800,2),(1041,-369266400,1),(1041,-354751200,2),(1041,-337816800,1),(1041,-323301600,2),(1041,-306972000,1),(1041,-291852000,2),(1041,-276732000,1),(1041,-257983200,2),(1041,-245282400,1),(1041,-226533600,2),(1041,-213228000,1),(1041,-195084000,2),(1041,-182383200,1),(1041,-163634400,2),(1041,-150933600,1),(1041,-132184800,2),(1041,-119484000,1),(1041,-100735200,2),(1041,-88034400,1),(1041,-68680800,2),(1041,-59004000,1),(1041,-37242000,5),(1041,57722400,7),(1041,69818400,1),(1041,89172000,2),(1041,101268000,1),(1041,120621600,2),(1041,132717600,1),(1041,152071200,2),(1041,164167200,1),(1041,183520800,2),(1041,196221600,1),(1041,214970400,2),(1041,227671200,1),(1041,246420000,2),(1041,259120800,1),(1041,278474400,2),(1041,290570400,1),(1041,309924000,2),(1041,322020000,1),(1041,341373600,2),(1041,354675600,6),(1041,372819600,7),(1041,386125200,6),(1041,404269200,7),(1041,417574800,6),(1041,435718800,7),(1041,449024400,6),(1041,467773200,7),(1041,481078800,6),(1041,499222800,7),(1041,512528400,6),(1041,530672400,7),(1041,543978000,6),(1041,562122000,7),(1041,575427600,6),(1041,593571600,7),(1041,606877200,6),(1041,625626000,7),(1041,638326800,6),(1041,657075600,7),(1041,670381200,6),(1041,688525200,7),(1041,701830800,6),(1041,719974800,7),(1041,733280400,6),(1041,751424400,7),(1041,764730000,6),(1041,782874000,7),(1041,796179600,6),(1041,814323600,7),(1041,820454400,4),(1041,828234000,6),(1041,846378000,7),(1041,859683600,6),(1041,877827600,7),(1041,891133200,6),(1041,909277200,7),(1041,922582800,6),(1041,941331600,7),(1041,954032400,6),(1041,972781200,7),(1041,985482000,6),(1041,1004230800,7),(1041,1017536400,6),(1041,1035680400,7),(1041,1048986000,6),(1041,1067130000,7),(1041,1080435600,6),(1041,1099184400,7),(1041,1111885200,6),(1041,1130634000,7),(1041,1143334800,6),(1041,1162083600,7),(1041,1174784400,6),(1041,1193533200,7),(1041,1206838800,6),(1041,1224982800,7),(1041,1238288400,6),(1041,1256432400,7),(1041,1269738000,6),(1041,1288486800,7),(1041,1301187600,6),(1041,1319936400,7),(1041,1332637200,6),(1041,1351386000,7),(1041,1364691600,6),(1041,1382835600,7),(1041,1396141200,6),(1041,1414285200,7),(1041,1427590800,6),(1041,1445734800,7),(1041,1459040400,6),(1041,1477789200,7),(1041,1490490000,6),(1041,1509238800,7),(1041,1521939600,6),(1041,1540688400,7),(1041,1553994000,6),(1041,1572138000,7),(1041,1585443600,6),(1041,1603587600,7),(1041,1616893200,6),(1041,1635642000,7),(1041,1648342800,6),(1041,1667091600,7),(1041,1679792400,6),(1041,1698541200,7),(1041,1711846800,6),(1041,1729990800,7),(1041,1743296400,6),(1041,1761440400,7),(1041,1774746000,6),(1041,1792890000,7),(1041,1806195600,6),(1041,1824944400,7),(1041,1837645200,6),(1041,1856394000,7),(1041,1869094800,6),(1041,1887843600,7),(1041,1901149200,6),(1041,1919293200,7),(1041,1932598800,6),(1041,1950742800,7),(1041,1964048400,6),(1041,1982797200,7),(1041,1995498000,6),(1041,2014246800,7),(1041,2026947600,6),(1041,2045696400,7),(1041,2058397200,6),(1041,2077146000,7),(1041,2090451600,6),(1041,2108595600,7),(1041,2121901200,6),(1041,2140045200,7),(1042,-2147483648,1),(1042,-1869875816,3),(1042,-1693706400,2),(1042,-1680490800,3),(1042,-1570413600,2),(1042,-1552186800,3),(1042,-1538359200,2),(1042,-1522551600,3),(1042,-1507514400,2),(1042,-1490583600,3),(1042,-1440208800,2),(1042,-1428030000,3),(1042,-1409709600,2),(1042,-1396494000,3),(1042,-931053600,2),(1042,-922676400,3),(1042,-917834400,2),(1042,-892436400,3),(1042,-875844000,2),(1042,-764737200,3),(1042,-744343200,2),(1042,-733806000,3),(1042,-716436000,2),(1042,-701924400,3),(1042,-684986400,2),(1042,-670474800,3),(1042,-654141600,2),(1042,-639025200,3),(1042,-622087200,2),(1042,-606970800,3),(1042,-590032800,2),(1042,-575521200,3),(1042,-235620000,2),(1042,-194842800,3),(1042,-177732000,2),(1042,-165726000,3),(1042,107910000,2),(1042,121215600,3),(1042,133920000,2),(1042,152665200,3),(1042,164678400,2),(1042,184114800,3),(1042,196214400,2),(1042,215564400,3),(1042,228873600,2),(1042,245804400,3),(1042,260323200,2),(1042,267915600,4),(1042,428454000,5),(1042,433893600,4),(1042,468111600,3),(1042,482799600,6),(1042,496710000,7),(1042,512521200,6),(1042,528246000,7),(1042,543970800,6),(1042,559695600,7),(1042,575420400,6),(1042,591145200,7),(1042,606870000,6),(1042,622594800,7),(1042,638319600,6),(1042,654649200,7),(1042,670374000,6),(1042,686098800,7),(1042,701823600,6),(1042,717548400,7),(1042,733273200,6),(1042,748998000,7),(1042,764118000,6),(1042,780447600,7),(1042,796172400,6),(1042,811897200,7),(1042,828226800,6),(1042,846370800,7),(1042,859676400,6),(1042,877820400,7),(1042,891126000,6),(1042,909270000,7),(1042,922575600,6),(1042,941324400,7),(1042,954025200,6),(1042,972774000,7),(1042,985474800,6),(1042,1004223600,7),(1042,1017529200,6),(1042,1035673200,7),(1042,1048978800,6),(1042,1067122800,7),(1042,1080428400,6),(1042,1099177200,7),(1042,1111878000,6),(1042,1130626800,7),(1042,1143327600,6),(1042,1162076400,7),(1042,1167602400,3),(1042,1174784400,8),(1042,1193533200,9),(1042,1206838800,8),(1042,1224982800,9),(1042,1238288400,8),(1042,1256432400,9),(1042,1269738000,8),(1042,1288486800,9),(1042,1301274000,8),(1042,1319936400,9),(1042,1332637200,8),(1042,1351386000,9),(1042,1364691600,8),(1042,1382835600,9),(1042,1396227600,8),(1042,1414285200,9),(1042,1427590800,8),(1042,1446944400,9),(1042,1459040400,8),(1042,1473195600,4),(1042,2147483647,4),(1043,-2147483648,4),(1043,-1691964000,1),(1043,-1680472800,2),(1043,-1664143200,1),(1043,-1650146400,2),(1043,-1633903200,1),(1043,-1617487200,2),(1043,-1601848800,1),(1043,-1586037600,2),(1043,-1570399200,1),(1043,-1552168800,2),(1043,-1538344800,1),(1043,-1522533600,2),(1043,-1507500000,1),(1043,-1490565600,2),(1043,-1473631200,1),(1043,-1460930400,2),(1043,-1442786400,1),(1043,-1428876000,2),(1043,-1410732000,1),(1043,-1396216800,2),(1043,-1379282400,1),(1043,-1364767200,2),(1043,-1348437600,1),(1043,-1333317600,2),(1043,-1315778400,1),(1043,-1301263200,2),(1043,-1284328800,1),(1043,-1269813600,2),(1043,-1253484000,1),(1043,-1238364000,2),(1043,-1221429600,1),(1043,-1206914400,2),(1043,-1189980000,1),(1043,-1175464800,2),(1043,-1159135200,1),(1043,-1143410400,2),(1043,-1126476000,1),(1043,-1111960800,2),(1043,-1095631200,1),(1043,-1080511200,2),(1043,-1063576800,1),(1043,-1049061600,2),(1043,-1032127200,1),(1043,-1017612000,2),(1043,-1001282400,1),(1043,-986162400,2),(1043,-969228000,1),(1043,-950479200,2),(1043,-942012000,1),(1043,-904518000,3),(1043,-896050800,1),(1043,-875487600,3),(1043,-864601200,1),(1043,-844038000,3),(1043,-832546800,1),(1043,-812588400,3),(1043,-798073200,1),(1043,-781052400,3),(1043,-772066800,1),(1043,-764805600,2),(1043,-748476000,1),(1043,-733356000,2),(1043,-719445600,1),(1043,-717030000,3),(1043,-706748400,1),(1043,-699487200,2),(1043,-687996000,1),(1043,-668037600,2),(1043,-654732000,1),(1043,-636588000,2),(1043,-622072800,1),(1043,-605743200,2),(1043,-590623200,1),(1043,-574293600,2),(1043,-558568800,1),(1043,-542239200,2),(1043,-527119200,1),(1043,-512604000,2),(1043,-496274400,1),(1043,-481154400,2),(1043,-464220000,1),(1043,-449704800,2),(1043,-432165600,1),(1043,-417650400,2),(1043,-401320800,1),(1043,-386200800,2),(1043,-369266400,1),(1043,-354751200,2),(1043,-337816800,1),(1043,-323301600,2),(1043,-306972000,1),(1043,-291852000,2),(1043,-276732000,1),(1043,-257983200,2),(1043,-245282400,1),(1043,-226533600,2),(1043,-213228000,1),(1043,-195084000,2),(1043,-182383200,1),(1043,-163634400,2),(1043,-150933600,1),(1043,-132184800,2),(1043,-119484000,1),(1043,-100735200,2),(1043,-88034400,1),(1043,-68680800,2),(1043,-59004000,1),(1043,-37242000,5),(1043,57722400,7),(1043,69818400,1),(1043,89172000,2),(1043,101268000,1),(1043,120621600,2),(1043,132717600,1),(1043,152071200,2),(1043,164167200,1),(1043,183520800,2),(1043,196221600,1),(1043,214970400,2),(1043,227671200,1),(1043,246420000,2),(1043,259120800,1),(1043,278474400,2),(1043,290570400,1),(1043,309924000,2),(1043,322020000,1),(1043,341373600,2),(1043,354675600,6),(1043,372819600,7),(1043,386125200,6),(1043,404269200,7),(1043,417574800,6),(1043,435718800,7),(1043,449024400,6),(1043,467773200,7),(1043,481078800,6),(1043,499222800,7),(1043,512528400,6),(1043,530672400,7),(1043,543978000,6),(1043,562122000,7),(1043,575427600,6),(1043,593571600,7),(1043,606877200,6),(1043,625626000,7),(1043,638326800,6),(1043,657075600,7),(1043,670381200,6),(1043,688525200,7),(1043,701830800,6),(1043,719974800,7),(1043,733280400,6),(1043,751424400,7),(1043,764730000,6),(1043,782874000,7),(1043,796179600,6),(1043,814323600,7),(1043,820454400,4),(1043,828234000,6),(1043,846378000,7),(1043,859683600,6),(1043,877827600,7),(1043,891133200,6),(1043,909277200,7),(1043,922582800,6),(1043,941331600,7),(1043,954032400,6),(1043,972781200,7),(1043,985482000,6),(1043,1004230800,7),(1043,1017536400,6),(1043,1035680400,7),(1043,1048986000,6),(1043,1067130000,7),(1043,1080435600,6),(1043,1099184400,7),(1043,1111885200,6),(1043,1130634000,7),(1043,1143334800,6),(1043,1162083600,7),(1043,1174784400,6),(1043,1193533200,7),(1043,1206838800,6),(1043,1224982800,7),(1043,1238288400,6),(1043,1256432400,7),(1043,1269738000,6),(1043,1288486800,7),(1043,1301187600,6),(1043,1319936400,7),(1043,1332637200,6),(1043,1351386000,7),(1043,1364691600,6),(1043,1382835600,7),(1043,1396141200,6),(1043,1414285200,7),(1043,1427590800,6),(1043,1445734800,7),(1043,1459040400,6),(1043,1477789200,7),(1043,1490490000,6),(1043,1509238800,7),(1043,1521939600,6),(1043,1540688400,7),(1043,1553994000,6),(1043,1572138000,7),(1043,1585443600,6),(1043,1603587600,7),(1043,1616893200,6),(1043,1635642000,7),(1043,1648342800,6),(1043,1667091600,7),(1043,1679792400,6),(1043,1698541200,7),(1043,1711846800,6),(1043,1729990800,7),(1043,1743296400,6),(1043,1761440400,7),(1043,1774746000,6),(1043,1792890000,7),(1043,1806195600,6),(1043,1824944400,7),(1043,1837645200,6),(1043,1856394000,7),(1043,1869094800,6),(1043,1887843600,7),(1043,1901149200,6),(1043,1919293200,7),(1043,1932598800,6),(1043,1950742800,7),(1043,1964048400,6),(1043,1982797200,7),(1043,1995498000,6),(1043,2014246800,7),(1043,2026947600,6),(1043,2045696400,7),(1043,2058397200,6),(1043,2077146000,7),(1043,2090451600,6),(1043,2108595600,7),(1043,2121901200,6),(1043,2140045200,7),(1044,-2147483648,2),(1044,-1693706400,1),(1044,-1680483600,2),(1044,-1663455600,3),(1044,-1650150000,4),(1044,-1632006000,3),(1044,-1618700400,4),(1044,-938905200,3),(1044,-857257200,4),(1044,-844556400,3),(1044,-828226800,4),(1044,-812502000,3),(1044,-796777200,4),(1044,-781052400,3),(1044,-780372000,6),(1044,-778730400,5),(1044,-762663600,6),(1044,-749095200,8),(1044,354920400,7),(1044,370728000,8),(1044,386456400,7),(1044,402264000,8),(1044,417992400,7),(1044,433800000,8),(1044,449614800,7),(1044,465346800,9),(1044,481071600,10),(1044,496796400,9),(1044,512521200,10),(1044,528246000,9),(1044,543970800,10),(1044,559695600,9),(1044,575420400,10),(1044,591145200,9),(1044,606870000,11),(1044,622598400,12),(1044,638323200,11),(1044,654652800,12),(1044,670377600,11),(1044,686102400,12),(1044,701827200,11),(1044,717552000,12),(1044,733276800,11),(1044,749001600,12),(1044,764726400,11),(1044,780451200,12),(1044,796176000,11),(1044,811900800,12),(1044,828230400,11),(1044,846374400,12),(1044,859680000,11),(1044,877824000,12),(1044,891129600,11),(1044,909273600,12),(1044,922579200,11),(1044,941328000,12),(1044,954028800,11),(1044,972777600,12),(1044,985478400,11),(1044,1004227200,12),(1044,1017532800,11),(1044,1035676800,12),(1044,1048982400,11),(1044,1067126400,12),(1044,1080432000,11),(1044,1099180800,12),(1044,1111881600,11),(1044,1130630400,12),(1044,1143331200,11),(1044,1162080000,12),(1044,1174780800,11),(1044,1193529600,12),(1044,1206835200,11),(1044,1224979200,12),(1044,1238284800,11),(1044,1256428800,12),(1044,1269734400,11),(1044,1288483200,12),(1044,1301184000,13),(1044,1414278000,12),(1045,-2147483648,1),(1045,-1441159324,2),(1045,-1247536800,3),(1045,-892522800,6),(1045,-857257200,4),(1045,-844556400,5),(1045,-828226800,4),(1045,-825382800,3),(1045,354920400,7),(1045,370728000,3),(1045,386456400,7),(1045,402264000,3),(1045,417992400,7),(1045,433800000,3),(1045,449614800,7),(1045,465346800,8),(1045,481071600,9),(1045,496796400,8),(1045,512521200,9),(1045,528246000,8),(1045,543970800,9),(1045,559695600,8),(1045,575420400,9),(1045,591145200,8),(1045,606870000,9),(1045,622594800,8),(1045,638319600,9),(1045,646783200,10),(1045,686102400,11),(1045,701827200,12),(1045,717552000,11),(1045,733276800,12),(1045,749001600,11),(1045,764726400,12),(1045,780451200,11),(1045,796176000,12),(1045,811900800,11),(1045,828230400,12),(1045,831934800,10),(1045,846378000,13),(1045,859683600,14),(1045,877827600,13),(1045,891133200,14),(1045,909277200,13),(1045,922582800,14),(1045,941331600,13),(1045,954032400,14),(1045,972781200,13),(1045,985482000,14),(1045,1004230800,13),(1045,1017536400,14),(1045,1035680400,13),(1045,1048986000,14),(1045,1067130000,13),(1045,1080435600,14),(1045,1099184400,13),(1045,1111885200,14),(1045,1130634000,13),(1045,1143334800,14),(1045,1162083600,13),(1045,1174784400,14),(1045,1193533200,13),(1045,1206838800,14),(1045,1224982800,13),(1045,1238288400,14),(1045,1256432400,13),(1045,1269738000,14),(1045,1288486800,13),(1045,1301187600,14),(1045,1319936400,13),(1045,1332637200,14),(1045,1351386000,13),(1045,1364691600,14),(1045,1382835600,13),(1045,1396141200,14),(1045,1414285200,13),(1045,1427590800,14),(1045,1445734800,13),(1045,1459040400,14),(1045,1477789200,13),(1045,1490490000,14),(1045,1509238800,13),(1045,1521939600,14),(1045,1540688400,13),(1045,1553994000,14),(1045,1572138000,13),(1045,1585443600,14),(1045,1603587600,13),(1045,1616893200,14),(1045,1635642000,13),(1045,1648342800,14),(1045,1667091600,13),(1045,1679792400,14),(1045,1698541200,13),(1045,1711846800,14),(1045,1729990800,13),(1045,1743296400,14),(1045,1761440400,13),(1045,1774746000,14),(1045,1792890000,13),(1045,1806195600,14),(1045,1824944400,13),(1045,1837645200,14),(1045,1856394000,13),(1045,1869094800,14),(1045,1887843600,13),(1045,1901149200,14),(1045,1919293200,13),(1045,1932598800,14),(1045,1950742800,13),(1045,1964048400,14),(1045,1982797200,13),(1045,1995498000,14),(1045,2014246800,13),(1045,2026947600,14),(1045,2045696400,13),(1045,2058397200,14),(1045,2077146000,13),(1045,2090451600,14),(1045,2108595600,13),(1045,2121901200,14),(1045,2140045200,13),(1046,-2147483648,0),(1046,-1593820800,1),(1046,-1247540400,3),(1046,354916800,2),(1046,370724400,3),(1046,386452800,2),(1046,402260400,3),(1046,417988800,2),(1046,433796400,3),(1046,449611200,2),(1046,465343200,4),(1046,481068000,5),(1046,496792800,4),(1046,512517600,5),(1046,528242400,4),(1046,543967200,5),(1046,559692000,4),(1046,575416800,5),(1046,591141600,4),(1046,606866400,6),(1046,622594800,7),(1046,638319600,6),(1046,654649200,7),(1046,670374000,4),(1046,701820000,6),(1046,717548400,7),(1046,733273200,6),(1046,748998000,7),(1046,764722800,6),(1046,780447600,7),(1046,796172400,6),(1046,811897200,7),(1046,828226800,6),(1046,846370800,7),(1046,859676400,6),(1046,877820400,7),(1046,891126000,6),(1046,909270000,7),(1046,922575600,6),(1046,941324400,7),(1046,954025200,6),(1046,972774000,7),(1046,985474800,6),(1046,1004223600,7),(1046,1017529200,6),(1046,1035673200,7),(1046,1048978800,6),(1046,1067122800,7),(1046,1080428400,6),(1046,1099177200,7),(1046,1111878000,6),(1046,1130626800,7),(1046,1143327600,6),(1046,1162076400,7),(1046,1174777200,6),(1046,1193526000,7),(1046,1206831600,6),(1046,1224975600,7),(1046,1238281200,6),(1046,1256425200,7),(1046,1269730800,6),(1046,1288479600,7),(1046,1301180400,8),(1046,1414274400,7),(1047,-2147483648,1),(1047,-1441159324,2),(1047,-1247536800,3),(1047,-892522800,6),(1047,-857257200,4),(1047,-844556400,5),(1047,-828226800,4),(1047,-825382800,3),(1047,354920400,7),(1047,370728000,3),(1047,386456400,7),(1047,402264000,3),(1047,417992400,7),(1047,433800000,3),(1047,449614800,7),(1047,465346800,8),(1047,481071600,9),(1047,496796400,8),(1047,512521200,9),(1047,528246000,8),(1047,543970800,9),(1047,559695600,8),(1047,575420400,9),(1047,591145200,8),(1047,606870000,9),(1047,622594800,8),(1047,638319600,9),(1047,646783200,10),(1047,686102400,11),(1047,701827200,12),(1047,717552000,11),(1047,733276800,12),(1047,749001600,11),(1047,764726400,12),(1047,780451200,11),(1047,796176000,12),(1047,811900800,11),(1047,828230400,12),(1047,831934800,10),(1047,846378000,13),(1047,859683600,14),(1047,877827600,13),(1047,891133200,14),(1047,909277200,13),(1047,922582800,14),(1047,941331600,13),(1047,954032400,14),(1047,972781200,13),(1047,985482000,14),(1047,1004230800,13),(1047,1017536400,14),(1047,1035680400,13),(1047,1048986000,14),(1047,1067130000,13),(1047,1080435600,14),(1047,1099184400,13),(1047,1111885200,14),(1047,1130634000,13),(1047,1143334800,14),(1047,1162083600,13),(1047,1174784400,14),(1047,1193533200,13),(1047,1206838800,14),(1047,1224982800,13),(1047,1238288400,14),(1047,1256432400,13),(1047,1269738000,14),(1047,1288486800,13),(1047,1301187600,14),(1047,1319936400,13),(1047,1332637200,14),(1047,1351386000,13),(1047,1364691600,14),(1047,1382835600,13),(1047,1396141200,14),(1047,1414285200,13),(1047,1427590800,14),(1047,1445734800,13),(1047,1459040400,14),(1047,1477789200,13),(1047,1490490000,14),(1047,1509238800,13),(1047,1521939600,14),(1047,1540688400,13),(1047,1553994000,14),(1047,1572138000,13),(1047,1585443600,14),(1047,1603587600,13),(1047,1616893200,14),(1047,1635642000,13),(1047,1648342800,14),(1047,1667091600,13),(1047,1679792400,14),(1047,1698541200,13),(1047,1711846800,14),(1047,1729990800,13),(1047,1743296400,14),(1047,1761440400,13),(1047,1774746000,14),(1047,1792890000,13),(1047,1806195600,14),(1047,1824944400,13),(1047,1837645200,14),(1047,1856394000,13),(1047,1869094800,14),(1047,1887843600,13),(1047,1901149200,14),(1047,1919293200,13),(1047,1932598800,14),(1047,1950742800,13),(1047,1964048400,14),(1047,1982797200,13),(1047,1995498000,14),(1047,2014246800,13),(1047,2026947600,14),(1047,2045696400,13),(1047,2058397200,14),(1047,2077146000,13),(1047,2090451600,14),(1047,2108595600,13),(1047,2121901200,14),(1047,2140045200,13),(1048,-2147483648,0),(1048,-1830384000,6),(1048,-1689555600,1),(1048,-1677801600,2),(1048,-1667437200,3),(1048,-1647738000,4),(1048,-1635814800,3),(1048,-1616202000,4),(1048,-1604365200,3),(1048,-1584666000,4),(1048,-1572742800,3),(1048,-1553043600,4),(1048,-1541206800,3),(1048,-1521507600,4),(1048,-1442451600,3),(1048,-1426813200,4),(1048,-1379293200,3),(1048,-1364778000,4),(1048,-1348448400,3),(1048,-1333328400,4),(1048,-1316394000,3),(1048,-1301274000,4),(1048,-1284339600,3),(1048,-1269824400,4),(1048,-1221440400,3),(1048,-1206925200,4),(1048,-1191200400,3),(1048,-1175475600,4),(1048,-1127696400,3),(1048,-1111971600,4),(1048,-1096851600,3),(1048,-1080522000,4),(1048,-1063587600,3),(1048,-1049072400,4),(1048,-1033347600,3),(1048,-1017622800,4),(1048,-1002502800,3),(1048,-986173200,4),(1048,-969238800,3),(1048,-950490000,4),(1048,-942022800,3),(1048,-922669200,4),(1048,-906944400,3),(1048,-891133200,4),(1048,-877309200,3),(1048,-873684000,5),(1048,-864007200,3),(1048,-857955600,4),(1048,-845859600,3),(1048,-842839200,5),(1048,-831348000,3),(1048,-825901200,4),(1048,-814410000,3),(1048,-810784800,5),(1048,-799898400,3),(1048,-794451600,4),(1048,-782960400,3),(1048,-779335200,5),(1048,-768448800,3),(1048,-763002000,4),(1048,-749091600,3),(1048,-733366800,4),(1048,-717631200,3),(1048,-701906400,4),(1048,-686181600,3),(1048,-670456800,4),(1048,-654732000,3),(1048,-639007200,4),(1048,-623282400,3),(1048,-607557600,4),(1048,-591832800,3),(1048,-575503200,4),(1048,-559778400,3),(1048,-544053600,4),(1048,-528328800,3),(1048,-512604000,4),(1048,-496879200,3),(1048,-481154400,4),(1048,-465429600,3),(1048,-449704800,4),(1048,-433980000,3),(1048,-417650400,4),(1048,-401925600,3),(1048,-386200800,4),(1048,-370476000,3),(1048,-354751200,4),(1048,-339026400,3),(1048,-323301600,4),(1048,-307576800,3),(1048,-291852000,4),(1048,-276127200,3),(1048,-260402400,4),(1048,-244677600,3),(1048,-228348000,4),(1048,-212623200,3),(1048,-196898400,4),(1048,-181173600,3),(1048,-165448800,4),(1048,-149724000,3),(1048,-133999200,4),(1048,-118274400,7),(1048,212544000,2),(1048,228268800,3),(1048,243993600,4),(1048,260323200,3),(1048,276048000,4),(1048,291772800,3),(1048,307501200,4),(1048,323222400,3),(1048,338950800,4),(1048,354675600,3),(1048,370400400,4),(1048,386125200,3),(1048,401850000,4),(1048,417578400,3),(1048,433299600,4),(1048,449024400,3),(1048,465354000,4),(1048,481078800,3),(1048,496803600,4),(1048,512528400,3),(1048,528253200,4),(1048,543978000,3),(1048,559702800,4),(1048,575427600,3),(1048,591152400,4),(1048,606877200,3),(1048,622602000,4),(1048,638326800,3),(1048,654656400,4),(1048,670381200,3),(1048,686106000,4),(1048,701830800,3),(1048,717555600,8),(1048,733280400,9),(1048,749005200,8),(1048,764730000,9),(1048,780454800,8),(1048,796179600,9),(1048,811904400,8),(1048,828234000,10),(1048,846378000,6),(1048,859683600,10),(1048,877827600,6),(1048,891133200,10),(1048,909277200,6),(1048,922582800,10),(1048,941331600,6),(1048,954032400,10),(1048,972781200,6),(1048,985482000,10),(1048,1004230800,6),(1048,1017536400,10),(1048,1035680400,6),(1048,1048986000,10),(1048,1067130000,6),(1048,1080435600,10),(1048,1099184400,6),(1048,1111885200,10),(1048,1130634000,6),(1048,1143334800,10),(1048,1162083600,6),(1048,1174784400,10),(1048,1193533200,6),(1048,1206838800,10),(1048,1224982800,6),(1048,1238288400,10),(1048,1256432400,6),(1048,1269738000,10),(1048,1288486800,6),(1048,1301187600,10),(1048,1319936400,6),(1048,1332637200,10),(1048,1351386000,6),(1048,1364691600,10),(1048,1382835600,6),(1048,1396141200,10),(1048,1414285200,6),(1048,1427590800,10),(1048,1445734800,6),(1048,1459040400,10),(1048,1477789200,6),(1048,1490490000,10),(1048,1509238800,6),(1048,1521939600,10),(1048,1540688400,6),(1048,1553994000,10),(1048,1572138000,6),(1048,1585443600,10),(1048,1603587600,6),(1048,1616893200,10),(1048,1635642000,6),(1048,1648342800,10),(1048,1667091600,6),(1048,1679792400,10),(1048,1698541200,6),(1048,1711846800,10),(1048,1729990800,6),(1048,1743296400,10),(1048,1761440400,6),(1048,1774746000,10),(1048,1792890000,6),(1048,1806195600,10),(1048,1824944400,6),(1048,1837645200,10),(1048,1856394000,6),(1048,1869094800,10),(1048,1887843600,6),(1048,1901149200,10),(1048,1919293200,6),(1048,1932598800,10),(1048,1950742800,6),(1048,1964048400,10),(1048,1982797200,6),(1048,1995498000,10),(1048,2014246800,6),(1048,2026947600,10),(1048,2045696400,6),(1048,2058397200,10),(1048,2077146000,6),(1048,2090451600,10),(1048,2108595600,6),(1048,2121901200,10),(1048,2140045200,6),(1049,-2147483648,1),(1049,-905824800,4),(1049,-857257200,2),(1049,-844556400,3),(1049,-828226800,2),(1049,-812502000,3),(1049,-796777200,2),(1049,-788922000,1),(1049,-777942000,3),(1049,-766623600,2),(1049,407199600,1),(1049,417574800,5),(1049,433299600,6),(1049,449024400,5),(1049,465354000,6),(1049,481078800,5),(1049,496803600,6),(1049,512528400,5),(1049,528253200,6),(1049,543978000,5),(1049,559702800,6),(1049,575427600,5),(1049,591152400,6),(1049,606877200,5),(1049,622602000,6),(1049,638326800,5),(1049,654656400,6),(1049,670381200,5),(1049,686106000,6),(1049,701830800,5),(1049,717555600,6),(1049,733280400,5),(1049,749005200,6),(1049,764730000,5),(1049,780454800,6),(1049,796179600,5),(1049,811904400,6),(1049,828234000,5),(1049,846378000,6),(1049,859683600,5),(1049,877827600,6),(1049,891133200,5),(1049,909277200,6),(1049,922582800,5),(1049,941331600,6),(1049,954032400,5),(1049,972781200,6),(1049,985482000,5),(1049,1004230800,6),(1049,1017536400,5),(1049,1035680400,6),(1049,1048986000,5),(1049,1067130000,6),(1049,1080435600,5),(1049,1099184400,6),(1049,1111885200,5),(1049,1130634000,6),(1049,1143334800,5),(1049,1162083600,6),(1049,1174784400,5),(1049,1193533200,6),(1049,1206838800,5),(1049,1224982800,6),(1049,1238288400,5),(1049,1256432400,6),(1049,1269738000,5),(1049,1288486800,6),(1049,1301187600,5),(1049,1319936400,6),(1049,1332637200,5),(1049,1351386000,6),(1049,1364691600,5),(1049,1382835600,6),(1049,1396141200,5),(1049,1414285200,6),(1049,1427590800,5),(1049,1445734800,6),(1049,1459040400,5),(1049,1477789200,6),(1049,1490490000,5),(1049,1509238800,6),(1049,1521939600,5),(1049,1540688400,6),(1049,1553994000,5),(1049,1572138000,6),(1049,1585443600,5),(1049,1603587600,6),(1049,1616893200,5),(1049,1635642000,6),(1049,1648342800,5),(1049,1667091600,6),(1049,1679792400,5),(1049,1698541200,6),(1049,1711846800,5),(1049,1729990800,6),(1049,1743296400,5),(1049,1761440400,6),(1049,1774746000,5),(1049,1792890000,6),(1049,1806195600,5),(1049,1824944400,6),(1049,1837645200,5),(1049,1856394000,6),(1049,1869094800,5),(1049,1887843600,6),(1049,1901149200,5),(1049,1919293200,6),(1049,1932598800,5),(1049,1950742800,6),(1049,1964048400,5),(1049,1982797200,6),(1049,1995498000,5),(1049,2014246800,6),(1049,2026947600,5),(1049,2045696400,6),(1049,2058397200,5),(1049,2077146000,6),(1049,2090451600,5),(1049,2108595600,6),(1049,2121901200,5),(1049,2140045200,6),(1050,-2147483648,4),(1050,-1691964000,1),(1050,-1680472800,2),(1050,-1664143200,1),(1050,-1650146400,2),(1050,-1633903200,1),(1050,-1617487200,2),(1050,-1601848800,1),(1050,-1586037600,2),(1050,-1570399200,1),(1050,-1552168800,2),(1050,-1538344800,1),(1050,-1522533600,2),(1050,-1507500000,1),(1050,-1490565600,2),(1050,-1473631200,1),(1050,-1460930400,2),(1050,-1442786400,1),(1050,-1428876000,2),(1050,-1410732000,1),(1050,-1396216800,2),(1050,-1379282400,1),(1050,-1364767200,2),(1050,-1348437600,1),(1050,-1333317600,2),(1050,-1315778400,1),(1050,-1301263200,2),(1050,-1284328800,1),(1050,-1269813600,2),(1050,-1253484000,1),(1050,-1238364000,2),(1050,-1221429600,1),(1050,-1206914400,2),(1050,-1189980000,1),(1050,-1175464800,2),(1050,-1159135200,1),(1050,-1143410400,2),(1050,-1126476000,1),(1050,-1111960800,2),(1050,-1095631200,1),(1050,-1080511200,2),(1050,-1063576800,1),(1050,-1049061600,2),(1050,-1032127200,1),(1050,-1017612000,2),(1050,-1001282400,1),(1050,-986162400,2),(1050,-969228000,1),(1050,-950479200,2),(1050,-942012000,1),(1050,-904518000,3),(1050,-896050800,1),(1050,-875487600,3),(1050,-864601200,1),(1050,-844038000,3),(1050,-832546800,1),(1050,-812588400,3),(1050,-798073200,1),(1050,-781052400,3),(1050,-772066800,1),(1050,-764805600,2),(1050,-748476000,1),(1050,-733356000,2),(1050,-719445600,1),(1050,-717030000,3),(1050,-706748400,1),(1050,-699487200,2),(1050,-687996000,1),(1050,-668037600,2),(1050,-654732000,1),(1050,-636588000,2),(1050,-622072800,1),(1050,-605743200,2),(1050,-590623200,1),(1050,-574293600,2),(1050,-558568800,1),(1050,-542239200,2),(1050,-527119200,1),(1050,-512604000,2),(1050,-496274400,1),(1050,-481154400,2),(1050,-464220000,1),(1050,-449704800,2),(1050,-432165600,1),(1050,-417650400,2),(1050,-401320800,1),(1050,-386200800,2),(1050,-369266400,1),(1050,-354751200,2),(1050,-337816800,1),(1050,-323301600,2),(1050,-306972000,1),(1050,-291852000,2),(1050,-276732000,1),(1050,-257983200,2),(1050,-245282400,1),(1050,-226533600,2),(1050,-213228000,1),(1050,-195084000,2),(1050,-182383200,1),(1050,-163634400,2),(1050,-150933600,1),(1050,-132184800,2),(1050,-119484000,1),(1050,-100735200,2),(1050,-88034400,1),(1050,-68680800,2),(1050,-59004000,1),(1050,-37242000,5),(1050,57722400,7),(1050,69818400,1),(1050,89172000,2),(1050,101268000,1),(1050,120621600,2),(1050,132717600,1),(1050,152071200,2),(1050,164167200,1),(1050,183520800,2),(1050,196221600,1),(1050,214970400,2),(1050,227671200,1),(1050,246420000,2),(1050,259120800,1),(1050,278474400,2),(1050,290570400,1),(1050,309924000,2),(1050,322020000,1),(1050,341373600,2),(1050,354675600,6),(1050,372819600,7),(1050,386125200,6),(1050,404269200,7),(1050,417574800,6),(1050,435718800,7),(1050,449024400,6),(1050,467773200,7),(1050,481078800,6),(1050,499222800,7),(1050,512528400,6),(1050,530672400,7),(1050,543978000,6),(1050,562122000,7),(1050,575427600,6),(1050,593571600,7),(1050,606877200,6),(1050,625626000,7),(1050,638326800,6),(1050,657075600,7),(1050,670381200,6),(1050,688525200,7),(1050,701830800,6),(1050,719974800,7),(1050,733280400,6),(1050,751424400,7),(1050,764730000,6),(1050,782874000,7),(1050,796179600,6),(1050,814323600,7),(1050,820454400,4),(1050,828234000,6),(1050,846378000,7),(1050,859683600,6),(1050,877827600,7),(1050,891133200,6),(1050,909277200,7),(1050,922582800,6),(1050,941331600,7),(1050,954032400,6),(1050,972781200,7),(1050,985482000,6),(1050,1004230800,7),(1050,1017536400,6),(1050,1035680400,7),(1050,1048986000,6),(1050,1067130000,7),(1050,1080435600,6),(1050,1099184400,7),(1050,1111885200,6),(1050,1130634000,7),(1050,1143334800,6),(1050,1162083600,7),(1050,1174784400,6),(1050,1193533200,7),(1050,1206838800,6),(1050,1224982800,7),(1050,1238288400,6),(1050,1256432400,7),(1050,1269738000,6),(1050,1288486800,7),(1050,1301187600,6),(1050,1319936400,7),(1050,1332637200,6),(1050,1351386000,7),(1050,1364691600,6),(1050,1382835600,7),(1050,1396141200,6),(1050,1414285200,7),(1050,1427590800,6),(1050,1445734800,7),(1050,1459040400,6),(1050,1477789200,7),(1050,1490490000,6),(1050,1509238800,7),(1050,1521939600,6),(1050,1540688400,7),(1050,1553994000,6),(1050,1572138000,7),(1050,1585443600,6),(1050,1603587600,7),(1050,1616893200,6),(1050,1635642000,7),(1050,1648342800,6),(1050,1667091600,7),(1050,1679792400,6),(1050,1698541200,7),(1050,1711846800,6),(1050,1729990800,7),(1050,1743296400,6),(1050,1761440400,7),(1050,1774746000,6),(1050,1792890000,7),(1050,1806195600,6),(1050,1824944400,7),(1050,1837645200,6),(1050,1856394000,7),(1050,1869094800,6),(1050,1887843600,7),(1050,1901149200,6),(1050,1919293200,7),(1050,1932598800,6),(1050,1950742800,7),(1050,1964048400,6),(1050,1982797200,7),(1050,1995498000,6),(1050,2014246800,7),(1050,2026947600,6),(1050,2045696400,7),(1050,2058397200,6),(1050,2077146000,7),(1050,2090451600,6),(1050,2108595600,7),(1050,2121901200,6),(1050,2140045200,7),(1051,-2147483648,1),(1051,-1740355200,2),(1051,-1693702800,5),(1051,-1680483600,2),(1051,-1663455600,3),(1051,-1650150000,4),(1051,-1632006000,3),(1051,-1618700400,4),(1051,-1613826000,8),(1051,-1604278800,6),(1051,-1585530000,7),(1051,-1574038800,6),(1051,-1552266000,7),(1051,-1539997200,6),(1051,-1520557200,7),(1051,-1507510800,6),(1051,-1490576400,7),(1051,-1473642000,6),(1051,-1459126800,7),(1051,-1444006800,6),(1051,-1427677200,7),(1051,-1411952400,6),(1051,-1396227600,7),(1051,-1379293200,6),(1051,-1364778000,7),(1051,-1348448400,6),(1051,-1333328400,7),(1051,-1316394000,6),(1051,-1301263200,7),(1051,-1284328800,6),(1051,-1269813600,7),(1051,-1253484000,6),(1051,-1238364000,7),(1051,-1221429600,6),(1051,-1206914400,7),(1051,-1191189600,6),(1051,-1175464800,7),(1051,-1160344800,6),(1051,-1143410400,7),(1051,-1127685600,6),(1051,-1111960800,7),(1051,-1096840800,6),(1051,-1080511200,7),(1051,-1063576800,6),(1051,-1049061600,7),(1051,-1033336800,6),(1051,-1017612000,7),(1051,-1002492000,6),(1051,-986162400,7),(1051,-969228000,6),(1051,-950479200,7),(1051,-942012000,6),(1051,-934668000,3),(1051,-857257200,4),(1051,-844556400,3),(1051,-828226800,4),(1051,-812502000,3),(1051,-799293600,5),(1051,-798073200,4),(1051,-781052400,3),(1051,-766623600,4),(1051,-745455600,3),(1051,-733273200,4),(1051,220921200,2),(1051,228877200,9),(1051,243997200,10),(1051,260326800,9),(1051,276051600,10),(1051,291776400,9),(1051,307501200,10),(1051,323830800,9),(1051,338950800,10),(1051,354675600,9),(1051,370400400,10),(1051,386125200,9),(1051,401850000,10),(1051,417574800,9),(1051,433299600,10),(1051,449024400,9),(1051,465354000,10),(1051,481078800,9),(1051,496803600,10),(1051,512528400,9),(1051,528253200,10),(1051,543978000,9),(1051,559702800,10),(1051,575427600,9),(1051,591152400,10),(1051,606877200,9),(1051,622602000,10),(1051,638326800,9),(1051,654656400,10),(1051,670381200,9),(1051,686106000,10),(1051,701830800,9),(1051,717555600,10),(1051,733280400,9),(1051,749005200,10),(1051,764730000,9),(1051,780454800,10),(1051,796179600,9),(1051,811904400,10),(1051,828234000,9),(1051,846378000,10),(1051,859683600,9),(1051,877827600,10),(1051,891133200,9),(1051,909277200,10),(1051,922582800,9),(1051,941331600,10),(1051,954032400,9),(1051,972781200,10),(1051,985482000,9),(1051,1004230800,10),(1051,1017536400,9),(1051,1035680400,10),(1051,1048986000,9),(1051,1067130000,10),(1051,1080435600,9),(1051,1099184400,10),(1051,1111885200,9),(1051,1130634000,10),(1051,1143334800,9),(1051,1162083600,10),(1051,1174784400,9),(1051,1193533200,10),(1051,1206838800,9),(1051,1224982800,10),(1051,1238288400,9),(1051,1256432400,10),(1051,1269738000,9),(1051,1288486800,10),(1051,1301187600,9),(1051,1319936400,10),(1051,1332637200,9),(1051,1351386000,10),(1051,1364691600,9),(1051,1382835600,10),(1051,1396141200,9),(1051,1414285200,10),(1051,1427590800,9),(1051,1445734800,10),(1051,1459040400,9),(1051,1477789200,10),(1051,1490490000,9),(1051,1509238800,10),(1051,1521939600,9),(1051,1540688400,10),(1051,1553994000,9),(1051,1572138000,10),(1051,1585443600,9),(1051,1603587600,10),(1051,1616893200,9),(1051,1635642000,10),(1051,1648342800,9),(1051,1667091600,10),(1051,1679792400,9),(1051,1698541200,10),(1051,1711846800,9),(1051,1729990800,10),(1051,1743296400,9),(1051,1761440400,10),(1051,1774746000,9),(1051,1792890000,10),(1051,1806195600,9),(1051,1824944400,10),(1051,1837645200,9),(1051,1856394000,10),(1051,1869094800,9),(1051,1887843600,10),(1051,1901149200,9),(1051,1919293200,10),(1051,1932598800,9),(1051,1950742800,10),(1051,1964048400,9),(1051,1982797200,10),(1051,1995498000,9),(1051,2014246800,10),(1051,2026947600,9),(1051,2045696400,10),(1051,2058397200,9),(1051,2077146000,10),(1051,2090451600,9),(1051,2108595600,10),(1051,2121901200,9),(1051,2140045200,10),(1052,-2147483648,4),(1052,-1631926800,1),(1052,-1616889600,2),(1052,-1601168400,1),(1052,-1585353600,2),(1052,-1442451600,1),(1052,-1427673600,2),(1052,-1379293200,1),(1052,-1364774400,2),(1052,-1348448400,1),(1052,-1333324800,2),(1052,-1316390400,1),(1052,-1301270400,2),(1052,-1284339600,1),(1052,-1269820800,2),(1052,-1026954000,1),(1052,-1017619200,2),(1052,-1001898000,1),(1052,-999482400,3),(1052,-986090400,1),(1052,-954115200,2),(1052,-940208400,6),(1052,-873079200,5),(1052,-862621200,6),(1052,-842839200,5),(1052,-828320400,6),(1052,-811389600,5),(1052,-796870800,6),(1052,-779940000,5),(1052,-765421200,6),(1052,-748490400,5),(1052,-733971600,6),(1052,-652327200,5),(1052,-639018000,6),(1052,135122400,5),(1052,150246000,6),(1052,166572000,5),(1052,181695600,6),(1052,196812000,5),(1052,212540400,6),(1052,228866400,5),(1052,243990000,6),(1052,260326800,7),(1052,276051600,8),(1052,283993200,6),(1052,291776400,9),(1052,307501200,10),(1052,323830800,9),(1052,338950800,10),(1052,354675600,9),(1052,370400400,10),(1052,386125200,9),(1052,401850000,10),(1052,417574800,9),(1052,433299600,10),(1052,449024400,9),(1052,465354000,10),(1052,481078800,9),(1052,496803600,10),(1052,512528400,9),(1052,528253200,10),(1052,543978000,9),(1052,559702800,10),(1052,575427600,9),(1052,591152400,10),(1052,606877200,9),(1052,622602000,10),(1052,638326800,9),(1052,654656400,10),(1052,670381200,9),(1052,686106000,10),(1052,701830800,9),(1052,717555600,10),(1052,733280400,9),(1052,749005200,10),(1052,764730000,9),(1052,780454800,10),(1052,796179600,9),(1052,811904400,10),(1052,828234000,9),(1052,846378000,10),(1052,859683600,9),(1052,877827600,10),(1052,891133200,9),(1052,909277200,10),(1052,922582800,9),(1052,941331600,10),(1052,954032400,9),(1052,972781200,10),(1052,985482000,9),(1052,1004230800,10),(1052,1017536400,9),(1052,1035680400,10),(1052,1048986000,9),(1052,1067130000,10),(1052,1080435600,9),(1052,1099184400,10),(1052,1111885200,9),(1052,1130634000,10),(1052,1143334800,9),(1052,1162083600,10),(1052,1174784400,9),(1052,1193533200,10),(1052,1206838800,9),(1052,1224982800,10),(1052,1238288400,9),(1052,1256432400,10),(1052,1269738000,9),(1052,1288486800,10),(1052,1301187600,9),(1052,1319936400,10),(1052,1332637200,9),(1052,1351386000,10),(1052,1364691600,9),(1052,1382835600,10),(1052,1396141200,9),(1052,1414285200,10),(1052,1427590800,9),(1052,1445734800,10),(1052,1459040400,9),(1052,1477789200,10),(1052,1490490000,9),(1052,1509238800,10),(1052,1521939600,9),(1052,1540688400,10),(1052,1553994000,9),(1052,1572138000,10),(1052,1585443600,9),(1052,1603587600,10),(1052,1616893200,9),(1052,1635642000,10),(1052,1648342800,9),(1052,1667091600,10),(1052,1679792400,9),(1052,1698541200,10),(1052,1711846800,9),(1052,1729990800,10),(1052,1743296400,9),(1052,1761440400,10),(1052,1774746000,9),(1052,1792890000,10),(1052,1806195600,9),(1052,1824944400,10),(1052,1837645200,9),(1052,1856394000,10),(1052,1869094800,9),(1052,1887843600,10),(1052,1901149200,9),(1052,1919293200,10),(1052,1932598800,9),(1052,1950742800,10),(1052,1964048400,9),(1052,1982797200,10),(1052,1995498000,9),(1052,2014246800,10),(1052,2026947600,9),(1052,2045696400,10),(1052,2058397200,9),(1052,2077146000,10),(1052,2090451600,9),(1052,2108595600,10),(1052,2121901200,9),(1052,2140045200,10),(1053,-2147483648,2),(1053,-1690765200,1),(1053,-1680487200,2),(1053,-1664758800,1),(1053,-1648951200,2),(1053,-1635123600,1),(1053,-1616896800,2),(1053,-1604278800,1),(1053,-1585533600,2),(1053,-1571014800,1),(1053,-1555293600,2),(1053,-932432400,1),(1053,-857257200,3),(1053,-844556400,4),(1053,-828226800,3),(1053,-812588400,4),(1053,-798073200,3),(1053,-781052400,1),(1053,-766717200,2),(1053,-750898800,4),(1053,-733359600,3),(1053,-719456400,4),(1053,-701917200,3),(1053,-689209200,4),(1053,-670460400,3),(1053,-114051600,4),(1053,-103168800,2),(1053,-81997200,4),(1053,-71715600,3),(1053,-50547600,4),(1053,-40266000,3),(1053,-18493200,4),(1053,-8211600,3),(1053,12956400,4),(1053,23238000,3),(1053,43801200,4),(1053,54687600,3),(1053,75855600,4),(1053,86742000,3),(1053,102380400,4),(1053,118105200,3),(1053,135730800,4),(1053,148518000,3),(1053,167187600,1),(1053,180489600,2),(1053,198637200,1),(1053,211939200,2),(1053,230086800,1),(1053,243388800,2),(1053,261536400,1),(1053,274838400,2),(1053,292986000,1),(1053,306288000,2),(1053,323312400,1),(1053,338342400,2),(1053,354675600,5),(1053,370400400,6),(1053,386125200,5),(1053,401850000,6),(1053,417574800,5),(1053,433299600,6),(1053,449024400,5),(1053,465354000,6),(1053,481078800,5),(1053,496803600,6),(1053,512528400,5),(1053,528253200,6),(1053,543978000,5),(1053,559702800,6),(1053,575427600,5),(1053,591152400,6),(1053,606877200,5),(1053,622602000,6),(1053,638326800,5),(1053,654656400,6),(1053,670381200,5),(1053,686106000,6),(1053,701830800,5),(1053,717555600,6),(1053,733280400,5),(1053,749005200,6),(1053,764730000,5),(1053,780454800,6),(1053,796179600,5),(1053,811904400,6),(1053,828234000,5),(1053,846378000,6),(1053,859683600,5),(1053,877827600,6),(1053,891133200,5),(1053,909277200,6),(1053,922582800,5),(1053,941331600,6),(1053,954032400,5),(1053,972781200,6),(1053,985482000,5),(1053,1004230800,6),(1053,1017536400,5),(1053,1035680400,6),(1053,1048986000,5),(1053,1067130000,6),(1053,1080435600,5),(1053,1099184400,6),(1053,1111885200,5),(1053,1130634000,6),(1053,1143334800,5),(1053,1162083600,6),(1053,1174784400,5),(1053,1193533200,6),(1053,1206838800,5),(1053,1224982800,6),(1053,1238288400,5),(1053,1256432400,6),(1053,1269738000,5),(1053,1288486800,6),(1053,1301187600,5),(1053,1319936400,6),(1053,1332637200,5),(1053,1351386000,6),(1053,1364691600,5),(1053,1382835600,6),(1053,1396141200,5),(1053,1414285200,6),(1053,1427590800,5),(1053,1445734800,6),(1053,1459040400,5),(1053,1477789200,6),(1053,1490490000,5),(1053,1509238800,6),(1053,1521939600,5),(1053,1540688400,6),(1053,1553994000,5),(1053,1572138000,6),(1053,1585443600,5),(1053,1603587600,6),(1053,1616893200,5),(1053,1635642000,6),(1053,1648342800,5),(1053,1667091600,6),(1053,1679792400,5),(1053,1698541200,6),(1053,1711846800,5),(1053,1729990800,6),(1053,1743296400,5),(1053,1761440400,6),(1053,1774746000,5),(1053,1792890000,6),(1053,1806195600,5),(1053,1824944400,6),(1053,1837645200,5),(1053,1856394000,6),(1053,1869094800,5),(1053,1887843600,6),(1053,1901149200,5),(1053,1919293200,6),(1053,1932598800,5),(1053,1950742800,6),(1053,1964048400,5),(1053,1982797200,6),(1053,1995498000,5),(1053,2014246800,6),(1053,2026947600,5),(1053,2045696400,6),(1053,2058397200,5),(1053,2077146000,6),(1053,2090451600,5),(1053,2108595600,6),(1053,2121901200,5),(1053,2140045200,6),(1054,-2147483648,1),(1054,-1535938789,3),(1054,-875671200,2),(1054,-859773600,3),(1054,354672000,2),(1054,370396800,3),(1054,386121600,2),(1054,401846400,3),(1054,417574800,4),(1054,433299600,5),(1054,449024400,4),(1054,465354000,5),(1054,481078800,4),(1054,496803600,5),(1054,512528400,4),(1054,528253200,5),(1054,543978000,4),(1054,559702800,5),(1054,575427600,4),(1054,591152400,5),(1054,606877200,4),(1054,622602000,5),(1054,638326800,4),(1054,654656400,5),(1054,670381200,4),(1054,686106000,5),(1054,701830800,4),(1054,717555600,5),(1054,733280400,4),(1054,749005200,5),(1054,764730000,4),(1054,780454800,5),(1054,796179600,4),(1054,811904400,5),(1054,828234000,4),(1054,846378000,5),(1054,859683600,4),(1054,877827600,5),(1054,891133200,4),(1054,909277200,5),(1054,922582800,4),(1054,941331600,5),(1054,954032400,4),(1054,972781200,5),(1054,985482000,4),(1054,1004230800,5),(1054,1017536400,4),(1054,1035680400,5),(1054,1048986000,4),(1054,1067130000,5),(1054,1080435600,4),(1054,1099184400,5),(1054,1111885200,4),(1054,1130634000,5),(1054,1143334800,4),(1054,1162083600,5),(1054,1174784400,4),(1054,1193533200,5),(1054,1206838800,4),(1054,1224982800,5),(1054,1238288400,4),(1054,1256432400,5),(1054,1269738000,4),(1054,1288486800,5),(1054,1301187600,4),(1054,1319936400,5),(1054,1332637200,4),(1054,1351386000,5),(1054,1364691600,4),(1054,1382835600,5),(1054,1396141200,4),(1054,1414285200,5),(1054,1427590800,4),(1054,1445734800,5),(1054,1459040400,4),(1054,1477789200,5),(1054,1490490000,4),(1054,1509238800,5),(1054,1521939600,4),(1054,1540688400,5),(1054,1553994000,4),(1054,1572138000,5),(1054,1585443600,4),(1054,1603587600,5),(1054,1616893200,4),(1054,1635642000,5),(1054,1648342800,4),(1054,1667091600,5),(1054,1679792400,4),(1054,1698541200,5),(1054,1711846800,4),(1054,1729990800,5),(1054,1743296400,4),(1054,1761440400,5),(1054,1774746000,4),(1054,1792890000,5),(1054,1806195600,4),(1054,1824944400,5),(1054,1837645200,4),(1054,1856394000,5),(1054,1869094800,4),(1054,1887843600,5),(1054,1901149200,4),(1054,1919293200,5),(1054,1932598800,4),(1054,1950742800,5),(1054,1964048400,4),(1054,1982797200,5),(1054,1995498000,4),(1054,2014246800,5),(1054,2026947600,4),(1054,2045696400,5),(1054,2058397200,4),(1054,2077146000,5),(1054,2090451600,4),(1054,2108595600,5),(1054,2121901200,4),(1054,2140045200,5),(1055,-2147483648,1),(1055,-1441158600,2),(1055,-1247536800,3),(1055,-899780400,6),(1055,-857257200,4),(1055,-844556400,5),(1055,-828226800,4),(1055,-812502000,5),(1055,-804650400,3),(1055,354920400,7),(1055,370728000,3),(1055,386456400,7),(1055,402264000,3),(1055,417992400,7),(1055,433800000,3),(1055,449614800,7),(1055,465346800,8),(1055,481071600,9),(1055,496796400,8),(1055,512521200,9),(1055,528246000,8),(1055,543970800,9),(1055,559695600,8),(1055,575420400,9),(1055,591145200,8),(1055,606870000,9),(1055,622594800,8),(1055,631141200,3),(1055,670374000,10),(1055,686102400,11),(1055,701827200,10),(1055,717552000,11),(1055,733276800,10),(1055,749001600,11),(1055,764726400,10),(1055,780451200,11),(1055,796176000,10),(1055,811900800,11),(1055,828230400,10),(1055,846374400,11),(1055,859680000,10),(1055,877824000,11),(1055,891129600,10),(1055,909273600,11),(1055,922579200,10),(1055,941328000,11),(1055,954028800,10),(1055,972777600,11),(1055,985478400,10),(1055,1004227200,11),(1055,1017532800,10),(1055,1035676800,11),(1055,1048982400,10),(1055,1067126400,11),(1055,1080432000,10),(1055,1099180800,11),(1055,1111881600,10),(1055,1130630400,11),(1055,1143331200,10),(1055,1162080000,11),(1055,1174780800,10),(1055,1193529600,11),(1055,1206835200,10),(1055,1224979200,11),(1055,1238284800,10),(1055,1256428800,11),(1055,1269734400,10),(1055,1288483200,11),(1055,1301184000,12),(1055,2147483647,12),(1056,-2147483648,1),(1056,-1855958961,5),(1056,-1689814800,2),(1056,-1680397200,3),(1056,-1665363600,2),(1056,-1648342800,3),(1056,-1635123600,2),(1056,-1616893200,3),(1056,-1604278800,2),(1056,-1585443600,3),(1056,-1574038800,2),(1056,-1552266000,3),(1056,-1539997200,2),(1056,-1520557200,3),(1056,-1507510800,2),(1056,-1490576400,3),(1056,-1470618000,2),(1056,-1459126800,3),(1056,-1444006800,2),(1056,-1427677200,3),(1056,-1411952400,2),(1056,-1396227600,3),(1056,-1379293200,2),(1056,-1364778000,3),(1056,-1348448400,2),(1056,-1333328400,3),(1056,-1316394000,2),(1056,-1301274000,3),(1056,-1284339600,2),(1056,-1269824400,3),(1056,-1253494800,2),(1056,-1238374800,3),(1056,-1221440400,2),(1056,-1206925200,3),(1056,-1191200400,2),(1056,-1175475600,3),(1056,-1160355600,2),(1056,-1143421200,3),(1056,-1127696400,2),(1056,-1111971600,3),(1056,-1096851600,2),(1056,-1080522000,3),(1056,-1063587600,2),(1056,-1049072400,3),(1056,-1033347600,2),(1056,-1017622800,3),(1056,-1002502800,2),(1056,-986173200,3),(1056,-969238800,2),(1056,-950490000,3),(1056,-942012000,4),(1056,-932436000,8),(1056,-857257200,6),(1056,-844556400,7),(1056,-828226800,6),(1056,-812502000,7),(1056,-800071200,9),(1056,-796266000,4),(1056,-781052400,9),(1056,-766623600,10),(1056,196819200,8),(1056,212540400,10),(1056,228877200,11),(1056,243997200,12),(1056,260326800,11),(1056,276051600,12),(1056,291776400,11),(1056,307501200,12),(1056,323830800,11),(1056,338950800,12),(1056,354675600,11),(1056,370400400,12),(1056,386125200,11),(1056,401850000,12),(1056,417574800,11),(1056,433299600,12),(1056,449024400,11),(1056,465354000,12),(1056,481078800,11),(1056,496803600,12),(1056,512528400,11),(1056,528253200,12),(1056,543978000,11),(1056,559702800,12),(1056,575427600,11),(1056,591152400,12),(1056,606877200,11),(1056,622602000,12),(1056,638326800,11),(1056,654656400,12),(1056,670381200,11),(1056,686106000,12),(1056,701830800,11),(1056,717555600,12),(1056,733280400,11),(1056,749005200,12),(1056,764730000,11),(1056,780454800,12),(1056,796179600,11),(1056,811904400,12),(1056,828234000,11),(1056,846378000,12),(1056,859683600,11),(1056,877827600,12),(1056,891133200,11),(1056,909277200,12),(1056,922582800,11),(1056,941331600,12),(1056,954032400,11),(1056,972781200,12),(1056,985482000,11),(1056,1004230800,12),(1056,1017536400,11),(1056,1035680400,12),(1056,1048986000,11),(1056,1067130000,12),(1056,1080435600,11),(1056,1099184400,12),(1056,1111885200,11),(1056,1130634000,12),(1056,1143334800,11),(1056,1162083600,12),(1056,1174784400,11),(1056,1193533200,12),(1056,1206838800,11),(1056,1224982800,12),(1056,1238288400,11),(1056,1256432400,12),(1056,1269738000,11),(1056,1288486800,12),(1056,1301187600,11),(1056,1319936400,12),(1056,1332637200,11),(1056,1351386000,12),(1056,1364691600,11),(1056,1382835600,12),(1056,1396141200,11),(1056,1414285200,12),(1056,1427590800,11),(1056,1445734800,12),(1056,1459040400,11),(1056,1477789200,12),(1056,1490490000,11),(1056,1509238800,12),(1056,1521939600,11),(1056,1540688400,12),(1056,1553994000,11),(1056,1572138000,12),(1056,1585443600,11),(1056,1603587600,12),(1056,1616893200,11),(1056,1635642000,12),(1056,1648342800,11),(1056,1667091600,12),(1056,1679792400,11),(1056,1698541200,12),(1056,1711846800,11),(1056,1729990800,12),(1056,1743296400,11),(1056,1761440400,12),(1056,1774746000,11),(1056,1792890000,12),(1056,1806195600,11),(1056,1824944400,12),(1056,1837645200,11),(1056,1856394000,12),(1056,1869094800,11),(1056,1887843600,12),(1056,1901149200,11),(1056,1919293200,12),(1056,1932598800,11),(1056,1950742800,12),(1056,1964048400,11),(1056,1982797200,12),(1056,1995498000,11),(1056,2014246800,12),(1056,2026947600,11),(1056,2045696400,12),(1056,2058397200,11),(1056,2077146000,12),(1056,2090451600,11),(1056,2108595600,12),(1056,2121901200,11),(1056,2140045200,12),(1057,-2147483648,1),(1057,-1688265017,3),(1057,-1656819079,2),(1057,-1641353479,3),(1057,-1627965079,4),(1057,-1618716679,2),(1057,-1596429079,4),(1057,-1593820800,5),(1057,-1589860800,6),(1057,-1542427200,7),(1057,-1539493200,8),(1057,-1525323600,7),(1057,-1522728000,6),(1057,-1491188400,9),(1057,-1247536800,6),(1057,354920400,7),(1057,370728000,6),(1057,386456400,7),(1057,402264000,6),(1057,417992400,7),(1057,433800000,6),(1057,449614800,7),(1057,465346800,10),(1057,481071600,11),(1057,496796400,10),(1057,512521200,11),(1057,528246000,10),(1057,543970800,11),(1057,559695600,10),(1057,575420400,11),(1057,591145200,10),(1057,606870000,11),(1057,622594800,10),(1057,638319600,11),(1057,654649200,10),(1057,670374000,12),(1057,686102400,13),(1057,695779200,10),(1057,701823600,11),(1057,717548400,10),(1057,733273200,11),(1057,748998000,10),(1057,764722800,11),(1057,780447600,10),(1057,796172400,11),(1057,811897200,10),(1057,828226800,11),(1057,846370800,10),(1057,859676400,11),(1057,877820400,10),(1057,891126000,11),(1057,909270000,10),(1057,922575600,11),(1057,941324400,10),(1057,954025200,11),(1057,972774000,10),(1057,985474800,11),(1057,1004223600,10),(1057,1017529200,11),(1057,1035673200,10),(1057,1048978800,11),(1057,1067122800,10),(1057,1080428400,11),(1057,1099177200,10),(1057,1111878000,11),(1057,1130626800,10),(1057,1143327600,11),(1057,1162076400,10),(1057,1174777200,11),(1057,1193526000,10),(1057,1206831600,11),(1057,1224975600,10),(1057,1238281200,11),(1057,1256425200,10),(1057,1269730800,11),(1057,1288479600,10),(1057,1301180400,14),(1057,1414274400,10),(1058,-2147483648,0),(1058,-1518920008,2),(1058,166572000,1),(1058,182293200,2),(1058,200959200,1),(1058,213829200,2),(1058,228866400,1),(1058,243982800,2),(1058,260316000,1),(1058,276123600,2),(1058,291765600,1),(1058,307486800,2),(1058,323820000,1),(1058,338936400,2),(1058,354664800,1),(1058,370386000,2),(1058,386114400,1),(1058,401835600,2),(1058,417564000,1),(1058,433285200,2),(1058,449013600,1),(1058,465339600,2),(1058,481068000,1),(1058,496789200,2),(1058,512517600,1),(1058,528238800,2),(1058,543967200,1),(1058,559688400,2),(1058,575416800,1),(1058,591138000,2),(1058,606866400,1),(1058,622587600,2),(1058,638316000,1),(1058,654642000,2),(1058,670370400,1),(1058,686091600,2),(1058,701820000,1),(1058,717541200,2),(1058,733269600,1),(1058,748990800,2),(1058,764719200,1),(1058,780440400,2),(1058,796168800,1),(1058,811890000,2),(1058,828223200,1),(1058,843944400,2),(1058,859672800,1),(1058,875394000,2),(1058,891122400,1),(1058,909277200,3),(1058,922582800,4),(1058,941331600,3),(1058,954032400,4),(1058,972781200,3),(1058,985482000,4),(1058,1004230800,3),(1058,1017536400,4),(1058,1035680400,3),(1058,1048986000,4),(1058,1067130000,3),(1058,1080435600,4),(1058,1099184400,3),(1058,1111885200,4),(1058,1130634000,3),(1058,1143334800,4),(1058,1162083600,3),(1058,1174784400,4),(1058,1193533200,3),(1058,1206838800,4),(1058,1224982800,3),(1058,1238288400,4),(1058,1256432400,3),(1058,1269738000,4),(1058,1288486800,3),(1058,1301187600,4),(1058,1319936400,3),(1058,1332637200,4),(1058,1351386000,3),(1058,1364691600,4),(1058,1382835600,3),(1058,1396141200,4),(1058,1414285200,3),(1058,1427590800,4),(1058,1445734800,3),(1058,1459040400,4),(1058,1477789200,3),(1058,1490490000,4),(1058,1509238800,3),(1058,1521939600,4),(1058,1540688400,3),(1058,1553994000,4),(1058,1572138000,3),(1058,1585443600,4),(1058,1603587600,3),(1058,1616893200,4),(1058,1635642000,3),(1058,1648342800,4),(1058,1667091600,3),(1058,1679792400,4),(1058,1698541200,3),(1058,1711846800,4),(1058,1729990800,3),(1058,1743296400,4),(1058,1761440400,3),(1058,1774746000,4),(1058,1792890000,3),(1058,1806195600,4),(1058,1824944400,3),(1058,1837645200,4),(1058,1856394000,3),(1058,1869094800,4),(1058,1887843600,3),(1058,1901149200,4),(1058,1919293200,3),(1058,1932598800,4),(1058,1950742800,3),(1058,1964048400,4),(1058,1982797200,3),(1058,1995498000,4),(1058,2014246800,3),(1058,2026947600,4),(1058,2045696400,3),(1058,2058397200,4),(1058,2077146000,3),(1058,2090451600,4),(1058,2108595600,3),(1058,2121901200,4),(1058,2140045200,3),(1059,-2147483648,2),(1059,-1693706400,1),(1059,-1680483600,2),(1059,-1663455600,3),(1059,-1650150000,4),(1059,-1632006000,3),(1059,-1618700400,4),(1059,-938905200,3),(1059,-857257200,4),(1059,-844556400,3),(1059,-828226800,4),(1059,-812502000,3),(1059,-796777200,4),(1059,-781052400,3),(1059,-776563200,5),(1059,-765936000,1),(1059,-761180400,4),(1059,-757386000,2),(1059,-748479600,3),(1059,-733273200,4),(1059,-717631200,3),(1059,-714610800,6),(1059,-710380800,1),(1059,-701910000,4),(1059,-684975600,3),(1059,-670460400,4),(1059,-654130800,3),(1059,-639010800,4),(1059,315529200,2),(1059,323830800,7),(1059,338950800,8),(1059,354675600,7),(1059,370400400,8),(1059,386125200,7),(1059,401850000,8),(1059,417574800,7),(1059,433299600,8),(1059,449024400,7),(1059,465354000,8),(1059,481078800,7),(1059,496803600,8),(1059,512528400,7),(1059,528253200,8),(1059,543978000,7),(1059,559702800,8),(1059,575427600,7),(1059,591152400,8),(1059,606877200,7),(1059,622602000,8),(1059,638326800,7),(1059,654656400,8),(1059,670381200,7),(1059,686106000,8),(1059,701830800,7),(1059,717555600,8),(1059,733280400,7),(1059,749005200,8),(1059,764730000,7),(1059,780454800,8),(1059,796179600,7),(1059,811904400,8),(1059,828234000,7),(1059,846378000,8),(1059,859683600,7),(1059,877827600,8),(1059,891133200,7),(1059,909277200,8),(1059,922582800,7),(1059,941331600,8),(1059,954032400,7),(1059,972781200,8),(1059,985482000,7),(1059,1004230800,8),(1059,1017536400,7),(1059,1035680400,8),(1059,1048986000,7),(1059,1067130000,8),(1059,1080435600,7),(1059,1099184400,8),(1059,1111885200,7),(1059,1130634000,8),(1059,1143334800,7),(1059,1162083600,8),(1059,1174784400,7),(1059,1193533200,8),(1059,1206838800,7),(1059,1224982800,8),(1059,1238288400,7),(1059,1256432400,8),(1059,1269738000,7),(1059,1288486800,8),(1059,1301187600,7),(1059,1319936400,8),(1059,1332637200,7),(1059,1351386000,8),(1059,1364691600,7),(1059,1382835600,8),(1059,1396141200,7),(1059,1414285200,8),(1059,1427590800,7),(1059,1445734800,8),(1059,1459040400,7),(1059,1477789200,8),(1059,1490490000,7),(1059,1509238800,8),(1059,1521939600,7),(1059,1540688400,8),(1059,1553994000,7),(1059,1572138000,8),(1059,1585443600,7),(1059,1603587600,8),(1059,1616893200,7),(1059,1635642000,8),(1059,1648342800,7),(1059,1667091600,8),(1059,1679792400,7),(1059,1698541200,8),(1059,1711846800,7),(1059,1729990800,8),(1059,1743296400,7),(1059,1761440400,8),(1059,1774746000,7),(1059,1792890000,8),(1059,1806195600,7),(1059,1824944400,8),(1059,1837645200,7),(1059,1856394000,8),(1059,1869094800,7),(1059,1887843600,8),(1059,1901149200,7),(1059,1919293200,8),(1059,1932598800,7),(1059,1950742800,8),(1059,1964048400,7),(1059,1982797200,8),(1059,1995498000,7),(1059,2014246800,8),(1059,2026947600,7),(1059,2045696400,8),(1059,2058397200,7),(1059,2077146000,8),(1059,2090451600,7),(1059,2108595600,8),(1059,2121901200,7),(1059,2140045200,8),(1060,-2147483648,1),(1060,-1855958961,5),(1060,-1689814800,2),(1060,-1680397200,3),(1060,-1665363600,2),(1060,-1648342800,3),(1060,-1635123600,2),(1060,-1616893200,3),(1060,-1604278800,2),(1060,-1585443600,3),(1060,-1574038800,2),(1060,-1552266000,3),(1060,-1539997200,2),(1060,-1520557200,3),(1060,-1507510800,2),(1060,-1490576400,3),(1060,-1470618000,2),(1060,-1459126800,3),(1060,-1444006800,2),(1060,-1427677200,3),(1060,-1411952400,2),(1060,-1396227600,3),(1060,-1379293200,2),(1060,-1364778000,3),(1060,-1348448400,2),(1060,-1333328400,3),(1060,-1316394000,2),(1060,-1301274000,3),(1060,-1284339600,2),(1060,-1269824400,3),(1060,-1253494800,2),(1060,-1238374800,3),(1060,-1221440400,2),(1060,-1206925200,3),(1060,-1191200400,2),(1060,-1175475600,3),(1060,-1160355600,2),(1060,-1143421200,3),(1060,-1127696400,2),(1060,-1111971600,3),(1060,-1096851600,2),(1060,-1080522000,3),(1060,-1063587600,2),(1060,-1049072400,3),(1060,-1033347600,2),(1060,-1017622800,3),(1060,-1002502800,2),(1060,-986173200,3),(1060,-969238800,2),(1060,-950490000,3),(1060,-942012000,4),(1060,-932436000,8),(1060,-857257200,6),(1060,-844556400,7),(1060,-828226800,6),(1060,-812502000,7),(1060,-800071200,9),(1060,-796266000,4),(1060,-781052400,9),(1060,-766623600,10),(1060,196819200,8),(1060,212540400,10),(1060,228877200,11),(1060,243997200,12),(1060,260326800,11),(1060,276051600,12),(1060,291776400,11),(1060,307501200,12),(1060,323830800,11),(1060,338950800,12),(1060,354675600,11),(1060,370400400,12),(1060,386125200,11),(1060,401850000,12),(1060,417574800,11),(1060,433299600,12),(1060,449024400,11),(1060,465354000,12),(1060,481078800,11),(1060,496803600,12),(1060,512528400,11),(1060,528253200,12),(1060,543978000,11),(1060,559702800,12),(1060,575427600,11),(1060,591152400,12),(1060,606877200,11),(1060,622602000,12),(1060,638326800,11),(1060,654656400,12),(1060,670381200,11),(1060,686106000,12),(1060,701830800,11),(1060,717555600,12),(1060,733280400,11),(1060,749005200,12),(1060,764730000,11),(1060,780454800,12),(1060,796179600,11),(1060,811904400,12),(1060,828234000,11),(1060,846378000,12),(1060,859683600,11),(1060,877827600,12),(1060,891133200,11),(1060,909277200,12),(1060,922582800,11),(1060,941331600,12),(1060,954032400,11),(1060,972781200,12),(1060,985482000,11),(1060,1004230800,12),(1060,1017536400,11),(1060,1035680400,12),(1060,1048986000,11),(1060,1067130000,12),(1060,1080435600,11),(1060,1099184400,12),(1060,1111885200,11),(1060,1130634000,12),(1060,1143334800,11),(1060,1162083600,12),(1060,1174784400,11),(1060,1193533200,12),(1060,1206838800,11),(1060,1224982800,12),(1060,1238288400,11),(1060,1256432400,12),(1060,1269738000,11),(1060,1288486800,12),(1060,1301187600,11),(1060,1319936400,12),(1060,1332637200,11),(1060,1351386000,12),(1060,1364691600,11),(1060,1382835600,12),(1060,1396141200,11),(1060,1414285200,12),(1060,1427590800,11),(1060,1445734800,12),(1060,1459040400,11),(1060,1477789200,12),(1060,1490490000,11),(1060,1509238800,12),(1060,1521939600,11),(1060,1540688400,12),(1060,1553994000,11),(1060,1572138000,12),(1060,1585443600,11),(1060,1603587600,12),(1060,1616893200,11),(1060,1635642000,12),(1060,1648342800,11),(1060,1667091600,12),(1060,1679792400,11),(1060,1698541200,12),(1060,1711846800,11),(1060,1729990800,12),(1060,1743296400,11),(1060,1761440400,12),(1060,1774746000,11),(1060,1792890000,12),(1060,1806195600,11),(1060,1824944400,12),(1060,1837645200,11),(1060,1856394000,12),(1060,1869094800,11),(1060,1887843600,12),(1060,1901149200,11),(1060,1919293200,12),(1060,1932598800,11),(1060,1950742800,12),(1060,1964048400,11),(1060,1982797200,12),(1060,1995498000,11),(1060,2014246800,12),(1060,2026947600,11),(1060,2045696400,12),(1060,2058397200,11),(1060,2077146000,12),(1060,2090451600,11),(1060,2108595600,12),(1060,2121901200,11),(1060,2140045200,12),(1061,-2147483648,1),(1061,-905824800,4),(1061,-857257200,2),(1061,-844556400,3),(1061,-828226800,2),(1061,-812502000,3),(1061,-796777200,2),(1061,-788922000,1),(1061,-777942000,3),(1061,-766623600,2),(1061,407199600,1),(1061,417574800,5),(1061,433299600,6),(1061,449024400,5),(1061,465354000,6),(1061,481078800,5),(1061,496803600,6),(1061,512528400,5),(1061,528253200,6),(1061,543978000,5),(1061,559702800,6),(1061,575427600,5),(1061,591152400,6),(1061,606877200,5),(1061,622602000,6),(1061,638326800,5),(1061,654656400,6),(1061,670381200,5),(1061,686106000,6),(1061,701830800,5),(1061,717555600,6),(1061,733280400,5),(1061,749005200,6),(1061,764730000,5),(1061,780454800,6),(1061,796179600,5),(1061,811904400,6),(1061,828234000,5),(1061,846378000,6),(1061,859683600,5),(1061,877827600,6),(1061,891133200,5),(1061,909277200,6),(1061,922582800,5),(1061,941331600,6),(1061,954032400,5),(1061,972781200,6),(1061,985482000,5),(1061,1004230800,6),(1061,1017536400,5),(1061,1035680400,6),(1061,1048986000,5),(1061,1067130000,6),(1061,1080435600,5),(1061,1099184400,6),(1061,1111885200,5),(1061,1130634000,6),(1061,1143334800,5),(1061,1162083600,6),(1061,1174784400,5),(1061,1193533200,6),(1061,1206838800,5),(1061,1224982800,6),(1061,1238288400,5),(1061,1256432400,6),(1061,1269738000,5),(1061,1288486800,6),(1061,1301187600,5),(1061,1319936400,6),(1061,1332637200,5),(1061,1351386000,6),(1061,1364691600,5),(1061,1382835600,6),(1061,1396141200,5),(1061,1414285200,6),(1061,1427590800,5),(1061,1445734800,6),(1061,1459040400,5),(1061,1477789200,6),(1061,1490490000,5),(1061,1509238800,6),(1061,1521939600,5),(1061,1540688400,6),(1061,1553994000,5),(1061,1572138000,6),(1061,1585443600,5),(1061,1603587600,6),(1061,1616893200,5),(1061,1635642000,6),(1061,1648342800,5),(1061,1667091600,6),(1061,1679792400,5),(1061,1698541200,6),(1061,1711846800,5),(1061,1729990800,6),(1061,1743296400,5),(1061,1761440400,6),(1061,1774746000,5),(1061,1792890000,6),(1061,1806195600,5),(1061,1824944400,6),(1061,1837645200,5),(1061,1856394000,6),(1061,1869094800,5),(1061,1887843600,6),(1061,1901149200,5),(1061,1919293200,6),(1061,1932598800,5),(1061,1950742800,6),(1061,1964048400,5),(1061,1982797200,6),(1061,1995498000,5),(1061,2014246800,6),(1061,2026947600,5),(1061,2045696400,6),(1061,2058397200,5),(1061,2077146000,6),(1061,2090451600,5),(1061,2108595600,6),(1061,2121901200,5),(1061,2140045200,6),(1062,-2147483648,2),(1062,-1693706400,1),(1062,-1680483600,2),(1062,-1663455600,3),(1062,-1650150000,4),(1062,-1632006000,3),(1062,-1618700400,4),(1062,-938905200,3),(1062,-857257200,4),(1062,-844556400,3),(1062,-828226800,4),(1062,-812502000,3),(1062,-796777200,4),(1062,-781052400,3),(1062,-777866400,1),(1062,-765327600,4),(1062,-746578800,3),(1062,-733359600,4),(1062,-728517600,5),(1062,-721260000,2),(1062,-716425200,3),(1062,-701910000,4),(1062,-684975600,3),(1062,-670460400,4),(1062,-654217200,3),(1062,-639010800,4),(1062,283993200,2),(1062,291776400,6),(1062,307501200,7),(1062,323830800,6),(1062,338950800,7),(1062,354675600,6),(1062,370400400,7),(1062,386125200,6),(1062,401850000,7),(1062,417574800,6),(1062,433299600,7),(1062,449024400,6),(1062,465354000,7),(1062,481078800,6),(1062,496803600,7),(1062,512528400,6),(1062,528253200,7),(1062,543978000,6),(1062,559702800,7),(1062,575427600,6),(1062,591152400,7),(1062,606877200,6),(1062,622602000,7),(1062,638326800,6),(1062,654656400,7),(1062,670381200,6),(1062,686106000,7),(1062,701830800,6),(1062,717555600,7),(1062,733280400,6),(1062,749005200,7),(1062,764730000,6),(1062,780454800,7),(1062,796179600,6),(1062,811904400,7),(1062,828234000,6),(1062,846378000,7),(1062,859683600,6),(1062,877827600,7),(1062,891133200,6),(1062,909277200,7),(1062,922582800,6),(1062,941331600,7),(1062,954032400,6),(1062,972781200,7),(1062,985482000,6),(1062,1004230800,7),(1062,1017536400,6),(1062,1035680400,7),(1062,1048986000,6),(1062,1067130000,7),(1062,1080435600,6),(1062,1099184400,7),(1062,1111885200,6),(1062,1130634000,7),(1062,1143334800,6),(1062,1162083600,7),(1062,1174784400,6),(1062,1193533200,7),(1062,1206838800,6),(1062,1224982800,7),(1062,1238288400,6),(1062,1256432400,7),(1062,1269738000,6),(1062,1288486800,7),(1062,1301187600,6),(1062,1319936400,7),(1062,1332637200,6),(1062,1351386000,7),(1062,1364691600,6),(1062,1382835600,7),(1062,1396141200,6),(1062,1414285200,7),(1062,1427590800,6),(1062,1445734800,7),(1062,1459040400,6),(1062,1477789200,7),(1062,1490490000,6),(1062,1509238800,7),(1062,1521939600,6),(1062,1540688400,7),(1062,1553994000,6),(1062,1572138000,7),(1062,1585443600,6),(1062,1603587600,7),(1062,1616893200,6),(1062,1635642000,7),(1062,1648342800,6),(1062,1667091600,7),(1062,1679792400,6),(1062,1698541200,7),(1062,1711846800,6),(1062,1729990800,7),(1062,1743296400,6),(1062,1761440400,7),(1062,1774746000,6),(1062,1792890000,7),(1062,1806195600,6),(1062,1824944400,7),(1062,1837645200,6),(1062,1856394000,7),(1062,1869094800,6),(1062,1887843600,7),(1062,1901149200,6),(1062,1919293200,7),(1062,1932598800,6),(1062,1950742800,7),(1062,1964048400,6),(1062,1982797200,7),(1062,1995498000,6),(1062,2014246800,7),(1062,2026947600,6),(1062,2045696400,7),(1062,2058397200,6),(1062,2077146000,7),(1062,2090451600,6),(1062,2108595600,7),(1062,2121901200,6),(1062,2140045200,7),(1063,-2147483648,1),(1063,-1632008194,2),(1063,-1618702594,1),(1063,-1601681794,2),(1063,-1597275394,1),(1063,-1377308194,3),(1063,-928029600,4),(1063,-899521200,7),(1063,-857257200,5),(1063,-844556400,6),(1063,-828226800,5),(1063,-812502000,6),(1063,-796777200,5),(1063,-795834000,4),(1063,354920400,8),(1063,370728000,4),(1063,386456400,8),(1063,402264000,4),(1063,417992400,8),(1063,433800000,4),(1063,449614800,8),(1063,465346800,9),(1063,481071600,10),(1063,496796400,9),(1063,512521200,10),(1063,528246000,9),(1063,543970800,10),(1063,559695600,9),(1063,575420400,10),(1063,591145200,9),(1063,606870000,11),(1063,622598400,12),(1063,638323200,11),(1063,654652800,12),(1063,670377600,11),(1063,686102400,12),(1063,701827200,11),(1063,717552000,12),(1063,733276800,11),(1063,749001600,12),(1063,764726400,11),(1063,780451200,12),(1063,796176000,11),(1063,811900800,12),(1063,828230400,11),(1063,843955200,12),(1063,853797600,3),(1063,859683600,13),(1063,877827600,14),(1063,891133200,13),(1063,909277200,14),(1063,922582800,13),(1063,941331600,14),(1063,951775200,3),(1063,985482000,13),(1063,1004230800,14),(1063,1017536400,13),(1063,1035680400,14),(1063,1048986000,13),(1063,1067130000,14),(1063,1080435600,13),(1063,1099184400,14),(1063,1111885200,13),(1063,1130634000,14),(1063,1143334800,13),(1063,1162083600,14),(1063,1174784400,13),(1063,1193533200,14),(1063,1206838800,13),(1063,1224982800,14),(1063,1238288400,13),(1063,1256432400,14),(1063,1269738000,13),(1063,1288486800,14),(1063,1301187600,13),(1063,1319936400,14),(1063,1332637200,13),(1063,1351386000,14),(1063,1364691600,13),(1063,1382835600,14),(1063,1396141200,13),(1063,1414285200,14),(1063,1427590800,13),(1063,1445734800,14),(1063,1459040400,13),(1063,1477789200,14),(1063,1490490000,13),(1063,1509238800,14),(1063,1521939600,13),(1063,1540688400,14),(1063,1553994000,13),(1063,1572138000,14),(1063,1585443600,13),(1063,1603587600,14),(1063,1616893200,13),(1063,1635642000,14),(1063,1648342800,13),(1063,1667091600,14),(1063,1679792400,13),(1063,1698541200,14),(1063,1711846800,13),(1063,1729990800,14),(1063,1743296400,13),(1063,1761440400,14),(1063,1774746000,13),(1063,1792890000,14),(1063,1806195600,13),(1063,1824944400,14),(1063,1837645200,13),(1063,1856394000,14),(1063,1869094800,13),(1063,1887843600,14),(1063,1901149200,13),(1063,1919293200,14),(1063,1932598800,13),(1063,1950742800,14),(1063,1964048400,13),(1063,1982797200,14),(1063,1995498000,13),(1063,2014246800,14),(1063,2026947600,13),(1063,2045696400,14),(1063,2058397200,13),(1063,2077146000,14),(1063,2090451600,13),(1063,2108595600,14),(1063,2121901200,13),(1063,2140045200,14),(1064,-2147483648,5),(1064,-1690765200,1),(1064,-1680487200,2),(1064,-1664758800,1),(1064,-1648951200,2),(1064,-1635123600,1),(1064,-1616896800,2),(1064,-1604278800,1),(1064,-1585533600,2),(1064,-1571014800,1),(1064,-1555293600,2),(1064,-932432400,1),(1064,-857257200,3),(1064,-844556400,4),(1064,-830311200,1),(1064,-828226800,3),(1064,-812502000,4),(1064,-807156000,1),(1064,-798073200,3),(1064,-781052400,1),(1064,-766717200,2),(1064,-750898800,4),(1064,-733359600,3),(1064,-719456400,4),(1064,-701917200,3),(1064,-689209200,4),(1064,-670460400,3),(1064,-114051600,4),(1064,-103168800,2),(1064,-81997200,4),(1064,-71715600,3),(1064,-50547600,4),(1064,-40266000,3),(1064,-18493200,4),(1064,-8211600,3),(1064,12956400,4),(1064,23238000,3),(1064,43801200,4),(1064,54687600,3),(1064,75855600,4),(1064,86742000,3),(1064,107910000,4),(1064,118191600,3),(1064,138754800,4),(1064,149641200,3),(1064,170809200,4),(1064,181090800,3),(1064,202258800,4),(1064,212540400,3),(1064,233103600,4),(1064,243990000,3),(1064,265158000,4),(1064,276044400,3),(1064,296607600,4),(1064,307494000,3),(1064,315529200,2),(1064,323830800,6),(1064,338950800,5),(1064,354675600,6),(1064,370400400,5),(1064,386125200,6),(1064,401850000,5),(1064,417574800,6),(1064,433299600,5),(1064,449024400,6),(1064,465354000,5),(1064,481078800,6),(1064,496803600,5),(1064,512528400,6),(1064,528253200,5),(1064,543978000,6),(1064,559702800,5),(1064,575427600,6),(1064,591152400,5),(1064,606877200,6),(1064,622602000,5),(1064,638326800,6),(1064,654656400,5),(1064,670381200,6),(1064,686106000,5),(1064,701830800,6),(1064,717555600,5),(1064,733280400,6),(1064,749005200,5),(1064,764730000,6),(1064,780454800,5),(1064,796179600,6),(1064,811904400,5),(1064,828234000,6),(1064,846378000,5),(1064,859683600,6),(1064,877827600,5),(1064,891133200,6),(1064,909277200,5),(1064,922582800,6),(1064,941331600,5),(1064,954032400,6),(1064,972781200,5),(1064,985482000,6),(1064,1004230800,5),(1064,1017536400,6),(1064,1035680400,5),(1064,1048986000,6),(1064,1067130000,5),(1064,1080435600,6),(1064,1099184400,5),(1064,1111885200,6),(1064,1130634000,5),(1064,1143334800,6),(1064,1162083600,5),(1064,1174784400,6),(1064,1193533200,5),(1064,1206838800,6),(1064,1224982800,5),(1064,1238288400,6),(1064,1256432400,5),(1064,1269738000,6),(1064,1288486800,5),(1064,1301187600,6),(1064,1319936400,5),(1064,1332637200,6),(1064,1351386000,5),(1064,1364691600,6),(1064,1382835600,5),(1064,1396141200,6),(1064,1414285200,5),(1064,1427590800,6),(1064,1445734800,5),(1064,1459040400,6),(1064,1477789200,5),(1064,1490490000,6),(1064,1509238800,5),(1064,1521939600,6),(1064,1540688400,5),(1064,1553994000,6),(1064,1572138000,5),(1064,1585443600,6),(1064,1603587600,5),(1064,1616893200,6),(1064,1635642000,5),(1064,1648342800,6),(1064,1667091600,5),(1064,1679792400,6),(1064,1698541200,5),(1064,1711846800,6),(1064,1729990800,5),(1064,1743296400,6),(1064,1761440400,5),(1064,1774746000,6),(1064,1792890000,5),(1064,1806195600,6),(1064,1824944400,5),(1064,1837645200,6),(1064,1856394000,5),(1064,1869094800,6),(1064,1887843600,5),(1064,1901149200,6),(1064,1919293200,5),(1064,1932598800,6),(1064,1950742800,5),(1064,1964048400,6),(1064,1982797200,5),(1064,1995498000,6),(1064,2014246800,5),(1064,2026947600,6),(1064,2045696400,5),(1064,2058397200,6),(1064,2077146000,5),(1064,2090451600,6),(1064,2108595600,5),(1064,2121901200,6),(1064,2140045200,5),(1065,-2147483648,0),(1065,-1593820800,1),(1065,-1247540400,2),(1065,354916800,3),(1065,370724400,2),(1065,386452800,3),(1065,402260400,2),(1065,417988800,3),(1065,433796400,2),(1065,449611200,3),(1065,465343200,4),(1065,481068000,5),(1065,496792800,4),(1065,512517600,5),(1065,528242400,4),(1065,543967200,5),(1065,559692000,4),(1065,575416800,5),(1065,591141600,4),(1065,606866400,6),(1065,622594800,7),(1065,638319600,6),(1065,654649200,7),(1065,670374000,8),(1065,686102400,7),(1065,687916800,2),(1065,701820000,5),(1065,717544800,4),(1065,733269600,5),(1065,748994400,4),(1065,764719200,5),(1065,780444000,4),(1065,796168800,5),(1065,811893600,4),(1065,828223200,5),(1065,846367200,4),(1065,859672800,5),(1065,877816800,4),(1065,891122400,5),(1065,909266400,4),(1065,922572000,5),(1065,941320800,4),(1065,954021600,5),(1065,972770400,4),(1065,985471200,5),(1065,1004220000,4),(1065,1017525600,5),(1065,1035669600,4),(1065,1048975200,5),(1065,1067119200,4),(1065,1080424800,5),(1065,1099173600,4),(1065,1111874400,5),(1065,1130623200,4),(1065,1143324000,5),(1065,1162072800,4),(1065,1174773600,5),(1065,1193522400,4),(1065,1206828000,5),(1065,1224972000,4),(1065,1238277600,5),(1065,1256421600,4),(1065,1269727200,6),(1065,1288479600,7),(1065,1301180400,4),(1065,2147483647,4),(1066,-2147483648,5),(1066,-1690765200,1),(1066,-1680487200,2),(1066,-1664758800,1),(1066,-1648951200,2),(1066,-1635123600,1),(1066,-1616896800,2),(1066,-1604278800,1),(1066,-1585533600,2),(1066,-1571014800,1),(1066,-1555293600,2),(1066,-932432400,1),(1066,-857257200,3),(1066,-844556400,4),(1066,-830311200,1),(1066,-828226800,3),(1066,-812502000,4),(1066,-807156000,1),(1066,-798073200,3),(1066,-781052400,1),(1066,-766717200,2),(1066,-750898800,4),(1066,-733359600,3),(1066,-719456400,4),(1066,-701917200,3),(1066,-689209200,4),(1066,-670460400,3),(1066,-114051600,4),(1066,-103168800,2),(1066,-81997200,4),(1066,-71715600,3),(1066,-50547600,4),(1066,-40266000,3),(1066,-18493200,4),(1066,-8211600,3),(1066,12956400,4),(1066,23238000,3),(1066,43801200,4),(1066,54687600,3),(1066,75855600,4),(1066,86742000,3),(1066,107910000,4),(1066,118191600,3),(1066,138754800,4),(1066,149641200,3),(1066,170809200,4),(1066,181090800,3),(1066,202258800,4),(1066,212540400,3),(1066,233103600,4),(1066,243990000,3),(1066,265158000,4),(1066,276044400,3),(1066,296607600,4),(1066,307494000,3),(1066,315529200,2),(1066,323830800,6),(1066,338950800,5),(1066,354675600,6),(1066,370400400,5),(1066,386125200,6),(1066,401850000,5),(1066,417574800,6),(1066,433299600,5),(1066,449024400,6),(1066,465354000,5),(1066,481078800,6),(1066,496803600,5),(1066,512528400,6),(1066,528253200,5),(1066,543978000,6),(1066,559702800,5),(1066,575427600,6),(1066,591152400,5),(1066,606877200,6),(1066,622602000,5),(1066,638326800,6),(1066,654656400,5),(1066,670381200,6),(1066,686106000,5),(1066,701830800,6),(1066,717555600,5),(1066,733280400,6),(1066,749005200,5),(1066,764730000,6),(1066,780454800,5),(1066,796179600,6),(1066,811904400,5),(1066,828234000,6),(1066,846378000,5),(1066,859683600,6),(1066,877827600,5),(1066,891133200,6),(1066,909277200,5),(1066,922582800,6),(1066,941331600,5),(1066,954032400,6),(1066,972781200,5),(1066,985482000,6),(1066,1004230800,5),(1066,1017536400,6),(1066,1035680400,5),(1066,1048986000,6),(1066,1067130000,5),(1066,1080435600,6),(1066,1099184400,5),(1066,1111885200,6),(1066,1130634000,5),(1066,1143334800,6),(1066,1162083600,5),(1066,1174784400,6),(1066,1193533200,5),(1066,1206838800,6),(1066,1224982800,5),(1066,1238288400,6),(1066,1256432400,5),(1066,1269738000,6),(1066,1288486800,5),(1066,1301187600,6),(1066,1319936400,5),(1066,1332637200,6),(1066,1351386000,5),(1066,1364691600,6),(1066,1382835600,5),(1066,1396141200,6),(1066,1414285200,5),(1066,1427590800,6),(1066,1445734800,5),(1066,1459040400,6),(1066,1477789200,5),(1066,1490490000,6),(1066,1509238800,5),(1066,1521939600,6),(1066,1540688400,5),(1066,1553994000,6),(1066,1572138000,5),(1066,1585443600,6),(1066,1603587600,5),(1066,1616893200,6),(1066,1635642000,5),(1066,1648342800,6),(1066,1667091600,5),(1066,1679792400,6),(1066,1698541200,5),(1066,1711846800,6),(1066,1729990800,5),(1066,1743296400,6),(1066,1761440400,5),(1066,1774746000,6),(1066,1792890000,5),(1066,1806195600,6),(1066,1824944400,5),(1066,1837645200,6),(1066,1856394000,5),(1066,1869094800,6),(1066,1887843600,5),(1066,1901149200,6),(1066,1919293200,5),(1066,1932598800,6),(1066,1950742800,5),(1066,1964048400,6),(1066,1982797200,5),(1066,1995498000,6),(1066,2014246800,5),(1066,2026947600,6),(1066,2045696400,5),(1066,2058397200,6),(1066,2077146000,5),(1066,2090451600,6),(1066,2108595600,5),(1066,2121901200,6),(1066,2140045200,5),(1067,-2147483648,1),(1067,-905824800,4),(1067,-857257200,2),(1067,-844556400,3),(1067,-828226800,2),(1067,-812502000,3),(1067,-796777200,2),(1067,-788922000,1),(1067,-777942000,3),(1067,-766623600,2),(1067,407199600,1),(1067,417574800,5),(1067,433299600,6),(1067,449024400,5),(1067,465354000,6),(1067,481078800,5),(1067,496803600,6),(1067,512528400,5),(1067,528253200,6),(1067,543978000,5),(1067,559702800,6),(1067,575427600,5),(1067,591152400,6),(1067,606877200,5),(1067,622602000,6),(1067,638326800,5),(1067,654656400,6),(1067,670381200,5),(1067,686106000,6),(1067,701830800,5),(1067,717555600,6),(1067,733280400,5),(1067,749005200,6),(1067,764730000,5),(1067,780454800,6),(1067,796179600,5),(1067,811904400,6),(1067,828234000,5),(1067,846378000,6),(1067,859683600,5),(1067,877827600,6),(1067,891133200,5),(1067,909277200,6),(1067,922582800,5),(1067,941331600,6),(1067,954032400,5),(1067,972781200,6),(1067,985482000,5),(1067,1004230800,6),(1067,1017536400,5),(1067,1035680400,6),(1067,1048986000,5),(1067,1067130000,6),(1067,1080435600,5),(1067,1099184400,6),(1067,1111885200,5),(1067,1130634000,6),(1067,1143334800,5),(1067,1162083600,6),(1067,1174784400,5),(1067,1193533200,6),(1067,1206838800,5),(1067,1224982800,6),(1067,1238288400,5),(1067,1256432400,6),(1067,1269738000,5),(1067,1288486800,6),(1067,1301187600,5),(1067,1319936400,6),(1067,1332637200,5),(1067,1351386000,6),(1067,1364691600,5),(1067,1382835600,6),(1067,1396141200,5),(1067,1414285200,6),(1067,1427590800,5),(1067,1445734800,6),(1067,1459040400,5),(1067,1477789200,6),(1067,1490490000,5),(1067,1509238800,6),(1067,1521939600,5),(1067,1540688400,6),(1067,1553994000,5),(1067,1572138000,6),(1067,1585443600,5),(1067,1603587600,6),(1067,1616893200,5),(1067,1635642000,6),(1067,1648342800,5),(1067,1667091600,6),(1067,1679792400,5),(1067,1698541200,6),(1067,1711846800,5),(1067,1729990800,6),(1067,1743296400,5),(1067,1761440400,6),(1067,1774746000,5),(1067,1792890000,6),(1067,1806195600,5),(1067,1824944400,6),(1067,1837645200,5),(1067,1856394000,6),(1067,1869094800,5),(1067,1887843600,6),(1067,1901149200,5),(1067,1919293200,6),(1067,1932598800,5),(1067,1950742800,6),(1067,1964048400,5),(1067,1982797200,6),(1067,1995498000,5),(1067,2014246800,6),(1067,2026947600,5),(1067,2045696400,6),(1067,2058397200,5),(1067,2077146000,6),(1067,2090451600,5),(1067,2108595600,6),(1067,2121901200,5),(1067,2140045200,6),(1068,-2147483648,0),(1068,-1593820800,1),(1068,-1247540400,3),(1068,354916800,2),(1068,370724400,3),(1068,386452800,2),(1068,402260400,3),(1068,417988800,2),(1068,433796400,3),(1068,449611200,2),(1068,465343200,4),(1068,481068000,5),(1068,496792800,4),(1068,512517600,5),(1068,528242400,4),(1068,543967200,5),(1068,559692000,4),(1068,575416800,6),(1068,591145200,7),(1068,606870000,6),(1068,622594800,7),(1068,638319600,6),(1068,654649200,7),(1068,670374000,4),(1068,701820000,6),(1068,717548400,7),(1068,733273200,6),(1068,748998000,7),(1068,764722800,6),(1068,780447600,7),(1068,796172400,6),(1068,811897200,7),(1068,828226800,6),(1068,846370800,7),(1068,859676400,6),(1068,877820400,7),(1068,891126000,6),(1068,909270000,7),(1068,922575600,6),(1068,941324400,7),(1068,954025200,6),(1068,972774000,7),(1068,985474800,6),(1068,1004223600,7),(1068,1017529200,6),(1068,1035673200,7),(1068,1048978800,6),(1068,1067122800,7),(1068,1080428400,6),(1068,1099177200,7),(1068,1111878000,6),(1068,1130626800,7),(1068,1143327600,6),(1068,1162076400,7),(1068,1174777200,6),(1068,1193526000,7),(1068,1206831600,6),(1068,1224975600,7),(1068,1238281200,6),(1068,1256425200,7),(1068,1269730800,6),(1068,1288479600,7),(1068,1301180400,4),(1068,1414274400,7),(1068,1480806000,4),(1068,2147483647,4),(1069,-2147483648,1),(1069,-1441160160,2),(1069,-1247536800,3),(1069,-888894000,6),(1069,-857257200,4),(1069,-844556400,5),(1069,-828226800,4),(1069,-812502000,5),(1069,-811648800,3),(1069,354920400,7),(1069,370728000,3),(1069,386456400,7),(1069,402264000,3),(1069,417992400,7),(1069,433800000,3),(1069,449614800,7),(1069,465346800,8),(1069,481071600,9),(1069,496796400,8),(1069,512521200,9),(1069,528246000,8),(1069,543970800,9),(1069,559695600,8),(1069,575420400,9),(1069,591145200,8),(1069,606870000,9),(1069,622594800,8),(1069,631141200,3),(1069,646786800,2),(1069,701827200,10),(1069,717552000,11),(1069,733276800,10),(1069,749001600,11),(1069,764726400,10),(1069,767739600,7),(1069,780447600,8),(1069,796172400,9),(1069,811897200,8),(1069,828219600,9),(1069,846374400,8),(1069,859683600,12),(1069,877827600,13),(1069,891133200,12),(1069,909277200,13),(1069,922582800,12),(1069,941331600,13),(1069,954032400,12),(1069,972781200,13),(1069,985482000,12),(1069,1004230800,13),(1069,1017536400,12),(1069,1035680400,13),(1069,1048986000,12),(1069,1067130000,13),(1069,1080435600,12),(1069,1099184400,13),(1069,1111885200,12),(1069,1130634000,13),(1069,1143334800,12),(1069,1162083600,13),(1069,1174784400,12),(1069,1193533200,13),(1069,1206838800,12),(1069,1224982800,13),(1069,1238288400,12),(1069,1256432400,13),(1069,1269738000,12),(1069,1288486800,13),(1069,1301187600,12),(1069,1319936400,13),(1069,1332637200,12),(1069,1351386000,13),(1069,1364691600,12),(1069,1382835600,13),(1069,1396137600,14),(1069,1414274400,8),(1070,-2147483648,1),(1070,-905824800,4),(1070,-857257200,2),(1070,-844556400,3),(1070,-828226800,2),(1070,-812502000,3),(1070,-796777200,2),(1070,-788922000,1),(1070,-777942000,3),(1070,-766623600,2),(1070,407199600,1),(1070,417574800,5),(1070,433299600,6),(1070,449024400,5),(1070,465354000,6),(1070,481078800,5),(1070,496803600,6),(1070,512528400,5),(1070,528253200,6),(1070,543978000,5),(1070,559702800,6),(1070,575427600,5),(1070,591152400,6),(1070,606877200,5),(1070,622602000,6),(1070,638326800,5),(1070,654656400,6),(1070,670381200,5),(1070,686106000,6),(1070,701830800,5),(1070,717555600,6),(1070,733280400,5),(1070,749005200,6),(1070,764730000,5),(1070,780454800,6),(1070,796179600,5),(1070,811904400,6),(1070,828234000,5),(1070,846378000,6),(1070,859683600,5),(1070,877827600,6),(1070,891133200,5),(1070,909277200,6),(1070,922582800,5),(1070,941331600,6),(1070,954032400,5),(1070,972781200,6),(1070,985482000,5),(1070,1004230800,6),(1070,1017536400,5),(1070,1035680400,6),(1070,1048986000,5),(1070,1067130000,6),(1070,1080435600,5),(1070,1099184400,6),(1070,1111885200,5),(1070,1130634000,6),(1070,1143334800,5),(1070,1162083600,6),(1070,1174784400,5),(1070,1193533200,6),(1070,1206838800,5),(1070,1224982800,6),(1070,1238288400,5),(1070,1256432400,6),(1070,1269738000,5),(1070,1288486800,6),(1070,1301187600,5),(1070,1319936400,6),(1070,1332637200,5),(1070,1351386000,6),(1070,1364691600,5),(1070,1382835600,6),(1070,1396141200,5),(1070,1414285200,6),(1070,1427590800,5),(1070,1445734800,6),(1070,1459040400,5),(1070,1477789200,6),(1070,1490490000,5),(1070,1509238800,6),(1070,1521939600,5),(1070,1540688400,6),(1070,1553994000,5),(1070,1572138000,6),(1070,1585443600,5),(1070,1603587600,6),(1070,1616893200,5),(1070,1635642000,6),(1070,1648342800,5),(1070,1667091600,6),(1070,1679792400,5),(1070,1698541200,6),(1070,1711846800,5),(1070,1729990800,6),(1070,1743296400,5),(1070,1761440400,6),(1070,1774746000,5),(1070,1792890000,6),(1070,1806195600,5),(1070,1824944400,6),(1070,1837645200,5),(1070,1856394000,6),(1070,1869094800,5),(1070,1887843600,6),(1070,1901149200,5),(1070,1919293200,6),(1070,1932598800,5),(1070,1950742800,6),(1070,1964048400,5),(1070,1982797200,6),(1070,1995498000,5),(1070,2014246800,6),(1070,2026947600,5),(1070,2045696400,6),(1070,2058397200,5),(1070,2077146000,6),(1070,2090451600,5),(1070,2108595600,6),(1070,2121901200,5),(1070,2140045200,6),(1071,-2147483648,1),(1071,-857257200,2),(1071,-844556400,3),(1071,-828226800,2),(1071,-812502000,3),(1071,-796777200,2),(1071,-788922000,4),(1071,-781048800,1),(1071,291762000,5),(1071,307576800,1),(1071,323816400,5),(1071,339026400,1),(1071,355266000,5),(1071,370393200,1),(1071,386715600,5),(1071,401846400,6),(1071,417571200,7),(1071,433296000,6),(1071,449020800,7),(1071,465350400,6),(1071,481075200,7),(1071,496800000,6),(1071,512524800,7),(1071,528249600,6),(1071,543974400,7),(1071,559699200,6),(1071,575424000,7),(1071,591148800,6),(1071,606873600,7),(1071,622598400,6),(1071,638323200,7),(1071,654652800,6),(1071,662680800,1),(1071,670370400,5),(1071,686091600,1),(1071,701820000,5),(1071,717541200,1),(1071,733269600,5),(1071,748990800,1),(1071,764719200,5),(1071,780440400,1),(1071,796168800,5),(1071,811890000,1),(1071,828223200,5),(1071,846363600,1),(1071,859683600,8),(1071,877827600,9),(1071,891133200,8),(1071,909277200,9),(1071,922582800,8),(1071,941331600,9),(1071,954032400,8),(1071,972781200,9),(1071,985482000,8),(1071,1004230800,9),(1071,1017536400,8),(1071,1035680400,9),(1071,1048986000,8),(1071,1067130000,9),(1071,1080435600,8),(1071,1099184400,9),(1071,1111885200,8),(1071,1130634000,9),(1071,1143334800,8),(1071,1162083600,9),(1071,1174784400,8),(1071,1193533200,9),(1071,1206838800,8),(1071,1224982800,9),(1071,1238288400,8),(1071,1256432400,9),(1071,1269738000,8),(1071,1288486800,9),(1071,1301187600,8),(1071,1319936400,9),(1071,1332637200,8),(1071,1351386000,9),(1071,1364691600,8),(1071,1382835600,9),(1071,1396141200,8),(1071,1414285200,9),(1071,1427590800,8),(1071,1445734800,9),(1071,1459040400,8),(1071,1477789200,9),(1071,1490490000,8),(1071,1509238800,9),(1071,1521939600,8),(1071,1540688400,9),(1071,1553994000,8),(1071,1572138000,9),(1071,1585443600,8),(1071,1603587600,9),(1071,1616893200,8),(1071,1635642000,9),(1071,1648342800,8),(1071,1667091600,9),(1071,1679792400,8),(1071,1698541200,9),(1071,1711846800,8),(1071,1729990800,9),(1071,1743296400,8),(1071,1761440400,9),(1071,1774746000,8),(1071,1792890000,9),(1071,1806195600,8),(1071,1824944400,9),(1071,1837645200,8),(1071,1856394000,9),(1071,1869094800,8),(1071,1887843600,9),(1071,1901149200,8),(1071,1919293200,9),(1071,1932598800,8),(1071,1950742800,9),(1071,1964048400,8),(1071,1982797200,9),(1071,1995498000,8),(1071,2014246800,9),(1071,2026947600,8),(1071,2045696400,9),(1071,2058397200,8),(1071,2077146000,9),(1071,2090451600,8),(1071,2108595600,9),(1071,2121901200,8),(1071,2140045200,9),(1072,-2147483648,2),(1072,-1693706400,1),(1072,-1680483600,2),(1072,-1663455600,3),(1072,-1650150000,4),(1072,-1632006000,3),(1072,-1618700400,4),(1072,-938905200,3),(1072,-857257200,4),(1072,-844556400,3),(1072,-828226800,4),(1072,-812502000,3),(1072,-796777200,4),(1072,-781052400,3),(1072,-776563200,5),(1072,-765936000,1),(1072,-761180400,4),(1072,-757386000,2),(1072,-748479600,3),(1072,-733273200,4),(1072,-717631200,3),(1072,-714610800,6),(1072,-710380800,1),(1072,-701910000,4),(1072,-684975600,3),(1072,-670460400,4),(1072,-654130800,3),(1072,-639010800,4),(1072,315529200,2),(1072,323830800,7),(1072,338950800,8),(1072,354675600,7),(1072,370400400,8),(1072,386125200,7),(1072,401850000,8),(1072,417574800,7),(1072,433299600,8),(1072,449024400,7),(1072,465354000,8),(1072,481078800,7),(1072,496803600,8),(1072,512528400,7),(1072,528253200,8),(1072,543978000,7),(1072,559702800,8),(1072,575427600,7),(1072,591152400,8),(1072,606877200,7),(1072,622602000,8),(1072,638326800,7),(1072,654656400,8),(1072,670381200,7),(1072,686106000,8),(1072,701830800,7),(1072,717555600,8),(1072,733280400,7),(1072,749005200,8),(1072,764730000,7),(1072,780454800,8),(1072,796179600,7),(1072,811904400,8),(1072,828234000,7),(1072,846378000,8),(1072,859683600,7),(1072,877827600,8),(1072,891133200,7),(1072,909277200,8),(1072,922582800,7),(1072,941331600,8),(1072,954032400,7),(1072,972781200,8),(1072,985482000,7),(1072,1004230800,8),(1072,1017536400,7),(1072,1035680400,8),(1072,1048986000,7),(1072,1067130000,8),(1072,1080435600,7),(1072,1099184400,8),(1072,1111885200,7),(1072,1130634000,8),(1072,1143334800,7),(1072,1162083600,8),(1072,1174784400,7),(1072,1193533200,8),(1072,1206838800,7),(1072,1224982800,8),(1072,1238288400,7),(1072,1256432400,8),(1072,1269738000,7),(1072,1288486800,8),(1072,1301187600,7),(1072,1319936400,8),(1072,1332637200,7),(1072,1351386000,8),(1072,1364691600,7),(1072,1382835600,8),(1072,1396141200,7),(1072,1414285200,8),(1072,1427590800,7),(1072,1445734800,8),(1072,1459040400,7),(1072,1477789200,8),(1072,1490490000,7),(1072,1509238800,8),(1072,1521939600,7),(1072,1540688400,8),(1072,1553994000,7),(1072,1572138000,8),(1072,1585443600,7),(1072,1603587600,8),(1072,1616893200,7),(1072,1635642000,8),(1072,1648342800,7),(1072,1667091600,8),(1072,1679792400,7),(1072,1698541200,8),(1072,1711846800,7),(1072,1729990800,8),(1072,1743296400,7),(1072,1761440400,8),(1072,1774746000,7),(1072,1792890000,8),(1072,1806195600,7),(1072,1824944400,8),(1072,1837645200,7),(1072,1856394000,8),(1072,1869094800,7),(1072,1887843600,8),(1072,1901149200,7),(1072,1919293200,8),(1072,1932598800,7),(1072,1950742800,8),(1072,1964048400,7),(1072,1982797200,8),(1072,1995498000,7),(1072,2014246800,8),(1072,2026947600,7),(1072,2045696400,8),(1072,2058397200,7),(1072,2077146000,8),(1072,2090451600,7),(1072,2108595600,8),(1072,2121901200,7),(1072,2140045200,8),(1073,-2147483648,1),(1073,-1638322740,4),(1073,-1632006000,2),(1073,-1618700400,3),(1073,-1593824400,1),(1073,-1535938740,5),(1073,-927943200,6),(1073,-892954800,7),(1073,-857257200,3),(1073,-844556400,2),(1073,-828226800,3),(1073,-812502000,2),(1073,-797652000,6),(1073,354920400,8),(1073,370728000,6),(1073,386456400,8),(1073,402264000,6),(1073,417992400,8),(1073,433800000,6),(1073,449614800,8),(1073,465346800,9),(1073,481071600,10),(1073,496796400,9),(1073,512521200,10),(1073,528246000,9),(1073,543970800,10),(1073,559695600,9),(1073,575420400,10),(1073,591145200,9),(1073,606870000,11),(1073,622598400,12),(1073,638323200,11),(1073,654652800,12),(1073,670377600,11),(1073,686102400,12),(1073,701827200,11),(1073,717552000,12),(1073,733276800,11),(1073,749001600,12),(1073,764726400,11),(1073,780451200,12),(1073,796176000,11),(1073,811900800,12),(1073,828230400,11),(1073,846374400,12),(1073,859680000,11),(1073,877824000,12),(1073,891129600,11),(1073,906411600,15),(1073,909277200,13),(1073,922582800,14),(1073,941331600,5),(1073,1017536400,14),(1073,1035680400,13),(1073,1048986000,14),(1073,1067130000,13),(1073,1080435600,14),(1073,1099184400,13),(1073,1111885200,14),(1073,1130634000,13),(1073,1143334800,14),(1073,1162083600,13),(1073,1174784400,14),(1073,1193533200,13),(1073,1206838800,14),(1073,1224982800,13),(1073,1238288400,14),(1073,1256432400,13),(1073,1269738000,14),(1073,1288486800,13),(1073,1301187600,14),(1073,1319936400,13),(1073,1332637200,14),(1073,1351386000,13),(1073,1364691600,14),(1073,1382835600,13),(1073,1396141200,14),(1073,1414285200,13),(1073,1427590800,14),(1073,1445734800,13),(1073,1459040400,14),(1073,1477789200,13),(1073,1490490000,14),(1073,1509238800,13),(1073,1521939600,14),(1073,1540688400,13),(1073,1553994000,14),(1073,1572138000,13),(1073,1585443600,14),(1073,1603587600,13),(1073,1616893200,14),(1073,1635642000,13),(1073,1648342800,14),(1073,1667091600,13),(1073,1679792400,14),(1073,1698541200,13),(1073,1711846800,14),(1073,1729990800,13),(1073,1743296400,14),(1073,1761440400,13),(1073,1774746000,14),(1073,1792890000,13),(1073,1806195600,14),(1073,1824944400,13),(1073,1837645200,14),(1073,1856394000,13),(1073,1869094800,14),(1073,1887843600,13),(1073,1901149200,14),(1073,1919293200,13),(1073,1932598800,14),(1073,1950742800,13),(1073,1964048400,14),(1073,1982797200,13),(1073,1995498000,14),(1073,2014246800,13),(1073,2026947600,14),(1073,2045696400,13),(1073,2058397200,14),(1073,2077146000,13),(1073,2090451600,14),(1073,2108595600,13),(1073,2121901200,14),(1073,2140045200,13),(1074,-2147483648,0),(1074,-1767230360,1),(1074,-932346000,2),(1074,-857257200,1),(1074,-844556400,2),(1074,-843519600,1),(1074,136854000,2),(1074,149896800,1),(1074,168130800,2),(1074,181432800,1),(1074,199839600,2),(1074,213141600,1),(1074,231894000,2),(1074,244591200,1),(1074,263257200,2),(1074,276040800,1),(1074,294706800,2),(1074,307490400,1),(1074,326156400,2),(1074,339458400,1),(1074,357087600,2),(1074,370389600,1),(1074,389142000,2),(1074,402444000,1),(1074,419468400,2),(1074,433807200,1),(1074,449622000,2),(1074,465354000,3),(1074,481078800,4),(1074,496803600,3),(1074,512528400,4),(1074,528253200,3),(1074,543978000,4),(1074,559702800,3),(1074,575427600,4),(1074,591152400,3),(1074,606877200,4),(1074,622602000,3),(1074,638326800,4),(1074,654656400,3),(1074,670381200,4),(1074,686106000,3),(1074,701830800,4),(1074,717555600,3),(1074,733280400,4),(1074,749005200,3),(1074,764730000,4),(1074,780454800,3),(1074,796179600,4),(1074,811904400,3),(1074,828234000,4),(1074,846378000,3),(1074,859683600,4),(1074,877827600,3),(1074,891133200,4),(1074,909277200,3),(1074,922582800,4),(1074,941331600,3),(1074,954032400,4),(1074,972781200,3),(1074,985482000,4),(1074,1004230800,3),(1074,1017536400,4),(1074,1035680400,3),(1074,1048986000,4),(1074,1067130000,3),(1074,1080435600,4),(1074,1099184400,3),(1074,1111885200,4),(1074,1130634000,3),(1074,1143334800,4),(1074,1162083600,3),(1074,1174784400,4),(1074,1193533200,3),(1074,1206838800,4),(1074,1224982800,3),(1074,1238288400,4),(1074,1256432400,3),(1074,1269738000,4),(1074,1288486800,3),(1074,1301187600,4),(1074,1319936400,3),(1074,1332637200,4),(1074,1351386000,3),(1074,1364691600,4),(1074,1382835600,3),(1074,1396141200,4),(1074,1414285200,3),(1074,1427590800,4),(1074,1445734800,3),(1074,1459040400,4),(1074,1477789200,3),(1074,1490490000,4),(1074,1509238800,3),(1074,1521939600,4),(1074,1540688400,3),(1074,1553994000,4),(1074,1572138000,3),(1074,1585443600,4),(1074,1603587600,3),(1074,1616893200,4),(1074,1635642000,3),(1074,1648342800,4),(1074,1667091600,3),(1074,1679792400,4),(1074,1698541200,3),(1074,1711846800,4),(1074,1729990800,3),(1074,1743296400,4),(1074,1761440400,3),(1074,1774746000,4),(1074,1792890000,3),(1074,1806195600,4),(1074,1824944400,3),(1074,1837645200,4),(1074,1856394000,3),(1074,1869094800,4),(1074,1887843600,3),(1074,1901149200,4),(1074,1919293200,3),(1074,1932598800,4),(1074,1950742800,3),(1074,1964048400,4),(1074,1982797200,3),(1074,1995498000,4),(1074,2014246800,3),(1074,2026947600,4),(1074,2045696400,3),(1074,2058397200,4),(1074,2077146000,3),(1074,2090451600,4),(1074,2108595600,3),(1074,2121901200,4),(1074,2140045200,3),(1075,-2147483648,1),(1075,-1637114100,2),(1075,-1213148664,5),(1075,-1187056800,3),(1075,-1175479200,4),(1075,-1159754400,3),(1075,-1144029600,4),(1075,-1127700000,3),(1075,-1111975200,4),(1075,-1096250400,3),(1075,-1080525600,4),(1075,-1064800800,3),(1075,-1049076000,4),(1075,-1033351200,3),(1075,-1017626400,4),(1075,-1001901600,3),(1075,-986176800,4),(1075,-970452000,3),(1075,-954727200,4),(1075,-927165600,6),(1075,-898138800,9),(1075,-857257200,7),(1075,-844556400,8),(1075,-828226800,7),(1075,-812502000,8),(1075,-800157600,11),(1075,354920400,10),(1075,370728000,11),(1075,386456400,10),(1075,402264000,11),(1075,417992400,10),(1075,433800000,11),(1075,449614800,10),(1075,465346800,12),(1075,481071600,13),(1075,496796400,12),(1075,512521200,13),(1075,528246000,12),(1075,543970800,13),(1075,559695600,12),(1075,575420400,13),(1075,591145200,12),(1075,606870000,13),(1075,622594800,12),(1075,638319600,13),(1075,641944800,6),(1075,654652800,4),(1075,670377600,3),(1075,686102400,4),(1075,694216800,5),(1075,701820000,6),(1075,717541200,5),(1075,733269600,6),(1075,748990800,5),(1075,764719200,6),(1075,780440400,5),(1075,796168800,6),(1075,811890000,5),(1075,828223200,6),(1075,846363600,5),(1075,859680000,6),(1075,877824000,5),(1075,891129600,6),(1075,909273600,5),(1075,922579200,6),(1075,941328000,5),(1075,954028800,6),(1075,972777600,5),(1075,985478400,6),(1075,1004227200,5),(1075,1017532800,6),(1075,1035676800,5),(1075,1048982400,6),(1075,1067126400,5),(1075,1080432000,6),(1075,1099180800,5),(1075,1111881600,6),(1075,1130630400,5),(1075,1143331200,6),(1075,1162080000,5),(1075,1174780800,6),(1075,1193529600,5),(1075,1206835200,6),(1075,1224979200,5),(1075,1238284800,6),(1075,1256428800,5),(1075,1269734400,6),(1075,1288483200,5),(1075,1301184000,6),(1075,1319932800,5),(1075,1332633600,6),(1075,1351382400,5),(1075,1364688000,6),(1075,1382832000,5),(1075,1396137600,6),(1075,1414281600,5),(1075,1427587200,6),(1075,1445731200,5),(1075,1459036800,6),(1075,1477785600,5),(1075,1490486400,6),(1075,1509235200,5),(1075,1521936000,6),(1075,1540684800,5),(1075,1553990400,6),(1075,1572134400,5),(1075,1585440000,6),(1075,1603584000,5),(1075,1616889600,6),(1075,1635638400,5),(1075,1648339200,6),(1075,1667088000,5),(1075,1679788800,6),(1075,1698537600,5),(1075,1711843200,6),(1075,1729987200,5),(1075,1743292800,6),(1075,1761436800,5),(1075,1774742400,6),(1075,1792886400,5),(1075,1806192000,6),(1075,1824940800,5),(1075,1837641600,6),(1075,1856390400,5),(1075,1869091200,6),(1075,1887840000,5),(1075,1901145600,6),(1075,1919289600,5),(1075,1932595200,6),(1075,1950739200,5),(1075,1964044800,6),(1075,1982793600,5),(1075,1995494400,6),(1075,2014243200,5),(1075,2026944000,6),(1075,2045692800,5),(1075,2058393600,6),(1075,2077142400,5),(1075,2090448000,6),(1075,2108592000,5),(1075,2121897600,6),(1075,2140041600,5),(1076,-2147483648,0),(1076,-1593820800,1),(1076,-1247540400,3),(1076,354916800,2),(1076,370724400,3),(1076,386452800,2),(1076,402260400,3),(1076,417988800,2),(1076,433796400,3),(1076,449611200,2),(1076,465343200,4),(1076,481068000,5),(1076,496792800,4),(1076,512517600,5),(1076,528242400,4),(1076,543967200,5),(1076,559692000,4),(1076,575416800,5),(1076,591141600,4),(1076,606866400,6),(1076,622594800,7),(1076,638319600,6),(1076,654649200,7),(1076,670374000,8),(1076,686102400,9),(1076,695779200,7),(1076,701823600,6),(1076,717548400,7),(1076,733273200,6),(1076,748998000,7),(1076,764722800,6),(1076,780447600,7),(1076,796172400,6),(1076,811897200,7),(1076,828226800,6),(1076,846370800,7),(1076,859676400,6),(1076,877820400,7),(1076,891126000,6),(1076,909270000,7),(1076,922575600,6),(1076,941324400,7),(1076,954025200,6),(1076,972774000,7),(1076,985474800,6),(1076,1004223600,7),(1076,1017529200,6),(1076,1035673200,7),(1076,1048978800,6),(1076,1067122800,7),(1076,1080428400,6),(1076,1099177200,7),(1076,1111878000,6),(1076,1130626800,7),(1076,1143327600,6),(1076,1162076400,7),(1076,1174777200,6),(1076,1193526000,7),(1076,1206831600,6),(1076,1224975600,7),(1076,1238281200,6),(1076,1256425200,7),(1076,1269730800,6),(1076,1288479600,7),(1076,1301180400,4),(1076,1414274400,7),(1076,1459033200,4),(1076,2147483647,4),(1077,-2147483648,1),(1077,-1441159324,2),(1077,-1247536800,3),(1077,-892522800,6),(1077,-857257200,4),(1077,-844556400,5),(1077,-828226800,4),(1077,-825382800,3),(1077,354920400,7),(1077,370728000,3),(1077,386456400,7),(1077,402264000,3),(1077,417992400,7),(1077,433800000,3),(1077,449614800,7),(1077,465346800,8),(1077,481071600,9),(1077,496796400,8),(1077,512521200,9),(1077,528246000,8),(1077,543970800,9),(1077,559695600,8),(1077,575420400,9),(1077,591145200,8),(1077,606870000,9),(1077,622594800,8),(1077,638319600,9),(1077,646783200,10),(1077,686102400,11),(1077,701827200,12),(1077,717552000,11),(1077,733276800,12),(1077,749001600,11),(1077,764726400,12),(1077,780451200,11),(1077,796176000,12),(1077,811900800,11),(1077,828230400,12),(1077,831934800,10),(1077,846378000,13),(1077,859683600,14),(1077,877827600,13),(1077,891133200,14),(1077,909277200,13),(1077,922582800,14),(1077,941331600,13),(1077,954032400,14),(1077,972781200,13),(1077,985482000,14),(1077,1004230800,13),(1077,1017536400,14),(1077,1035680400,13),(1077,1048986000,14),(1077,1067130000,13),(1077,1080435600,14),(1077,1099184400,13),(1077,1111885200,14),(1077,1130634000,13),(1077,1143334800,14),(1077,1162083600,13),(1077,1174784400,14),(1077,1193533200,13),(1077,1206838800,14),(1077,1224982800,13),(1077,1238288400,14),(1077,1256432400,13),(1077,1269738000,14),(1077,1288486800,13),(1077,1301187600,14),(1077,1319936400,13),(1077,1332637200,14),(1077,1351386000,13),(1077,1364691600,14),(1077,1382835600,13),(1077,1396141200,14),(1077,1414285200,13),(1077,1427590800,14),(1077,1445734800,13),(1077,1459040400,14),(1077,1477789200,13),(1077,1490490000,14),(1077,1509238800,13),(1077,1521939600,14),(1077,1540688400,13),(1077,1553994000,14),(1077,1572138000,13),(1077,1585443600,14),(1077,1603587600,13),(1077,1616893200,14),(1077,1635642000,13),(1077,1648342800,14),(1077,1667091600,13),(1077,1679792400,14),(1077,1698541200,13),(1077,1711846800,14),(1077,1729990800,13),(1077,1743296400,14),(1077,1761440400,13),(1077,1774746000,14),(1077,1792890000,13),(1077,1806195600,14),(1077,1824944400,13),(1077,1837645200,14),(1077,1856394000,13),(1077,1869094800,14),(1077,1887843600,13),(1077,1901149200,14),(1077,1919293200,13),(1077,1932598800,14),(1077,1950742800,13),(1077,1964048400,14),(1077,1982797200,13),(1077,1995498000,14),(1077,2014246800,13),(1077,2026947600,14),(1077,2045696400,13),(1077,2058397200,14),(1077,2077146000,13),(1077,2090451600,14),(1077,2108595600,13),(1077,2121901200,14),(1077,2140045200,13),(1078,-2147483648,2),(1078,-904435200,1),(1078,-891129600,2),(1078,-872985600,1),(1078,-859680000,2),(1078,354675600,3),(1078,370400400,4),(1078,386125200,3),(1078,401850000,4),(1078,417574800,3),(1078,433299600,4),(1078,449024400,3),(1078,465354000,4),(1078,481078800,3),(1078,496803600,4),(1078,512528400,3),(1078,528253200,4),(1078,543978000,3),(1078,559702800,4),(1078,575427600,3),(1078,591152400,4),(1078,606877200,3),(1078,622602000,4),(1078,638326800,3),(1078,654656400,4),(1078,670381200,3),(1078,686106000,4),(1078,701830800,3),(1078,717555600,4),(1078,733280400,3),(1078,749005200,4),(1078,764730000,3),(1078,780454800,4),(1078,796179600,3),(1078,811904400,4),(1078,828234000,3),(1078,846378000,4),(1078,859683600,3),(1078,877827600,4),(1078,891133200,3),(1078,909277200,4),(1078,922582800,3),(1078,941331600,4),(1078,954032400,3),(1078,972781200,4),(1078,985482000,3),(1078,1004230800,4),(1078,1017536400,3),(1078,1035680400,4),(1078,1048986000,3),(1078,1067130000,4),(1078,1080435600,3),(1078,1099184400,4),(1078,1111885200,3),(1078,1130634000,4),(1078,1143334800,3),(1078,1162083600,4),(1078,1174784400,3),(1078,1193533200,4),(1078,1206838800,3),(1078,1224982800,4),(1078,1238288400,3),(1078,1256432400,4),(1078,1269738000,3),(1078,1288486800,4),(1078,1301187600,3),(1078,1319936400,4),(1078,1332637200,3),(1078,1351386000,4),(1078,1364691600,3),(1078,1382835600,4),(1078,1396141200,3),(1078,1414285200,4),(1078,1427590800,3),(1078,1445734800,4),(1078,1459040400,3),(1078,1477789200,4),(1078,1490490000,3),(1078,1509238800,4),(1078,1521939600,3),(1078,1540688400,4),(1078,1553994000,3),(1078,1572138000,4),(1078,1585443600,3),(1078,1603587600,4),(1078,1616893200,3),(1078,1635642000,4),(1078,1648342800,3),(1078,1667091600,4),(1078,1679792400,3),(1078,1698541200,4),(1078,1711846800,3),(1078,1729990800,4),(1078,1743296400,3),(1078,1761440400,4),(1078,1774746000,3),(1078,1792890000,4),(1078,1806195600,3),(1078,1824944400,4),(1078,1837645200,3),(1078,1856394000,4),(1078,1869094800,3),(1078,1887843600,4),(1078,1901149200,3),(1078,1919293200,4),(1078,1932598800,3),(1078,1950742800,4),(1078,1964048400,3),(1078,1982797200,4),(1078,1995498000,3),(1078,2014246800,4),(1078,2026947600,3),(1078,2045696400,4),(1078,2058397200,3),(1078,2077146000,4),(1078,2090451600,3),(1078,2108595600,4),(1078,2121901200,3),(1078,2140045200,4),(1079,-2147483648,5),(1079,-1690765200,1),(1079,-1680487200,2),(1079,-1664758800,1),(1079,-1648951200,2),(1079,-1635123600,1),(1079,-1616896800,2),(1079,-1604278800,1),(1079,-1585533600,2),(1079,-1571014800,1),(1079,-1555293600,2),(1079,-932432400,1),(1079,-857257200,3),(1079,-844556400,4),(1079,-830311200,1),(1079,-828226800,3),(1079,-812502000,4),(1079,-807156000,1),(1079,-798073200,3),(1079,-781052400,1),(1079,-766717200,2),(1079,-750898800,4),(1079,-733359600,3),(1079,-719456400,4),(1079,-701917200,3),(1079,-689209200,4),(1079,-670460400,3),(1079,-114051600,4),(1079,-103168800,2),(1079,-81997200,4),(1079,-71715600,3),(1079,-50547600,4),(1079,-40266000,3),(1079,-18493200,4),(1079,-8211600,3),(1079,12956400,4),(1079,23238000,3),(1079,43801200,4),(1079,54687600,3),(1079,75855600,4),(1079,86742000,3),(1079,107910000,4),(1079,118191600,3),(1079,138754800,4),(1079,149641200,3),(1079,170809200,4),(1079,181090800,3),(1079,202258800,4),(1079,212540400,3),(1079,233103600,4),(1079,243990000,3),(1079,265158000,4),(1079,276044400,3),(1079,296607600,4),(1079,307494000,3),(1079,315529200,2),(1079,323830800,6),(1079,338950800,5),(1079,354675600,6),(1079,370400400,5),(1079,386125200,6),(1079,401850000,5),(1079,417574800,6),(1079,433299600,5),(1079,449024400,6),(1079,465354000,5),(1079,481078800,6),(1079,496803600,5),(1079,512528400,6),(1079,528253200,5),(1079,543978000,6),(1079,559702800,5),(1079,575427600,6),(1079,591152400,5),(1079,606877200,6),(1079,622602000,5),(1079,638326800,6),(1079,654656400,5),(1079,670381200,6),(1079,686106000,5),(1079,701830800,6),(1079,717555600,5),(1079,733280400,6),(1079,749005200,5),(1079,764730000,6),(1079,780454800,5),(1079,796179600,6),(1079,811904400,5),(1079,828234000,6),(1079,846378000,5),(1079,859683600,6),(1079,877827600,5),(1079,891133200,6),(1079,909277200,5),(1079,922582800,6),(1079,941331600,5),(1079,954032400,6),(1079,972781200,5),(1079,985482000,6),(1079,1004230800,5),(1079,1017536400,6),(1079,1035680400,5),(1079,1048986000,6),(1079,1067130000,5),(1079,1080435600,6),(1079,1099184400,5),(1079,1111885200,6),(1079,1130634000,5),(1079,1143334800,6),(1079,1162083600,5),(1079,1174784400,6),(1079,1193533200,5),(1079,1206838800,6),(1079,1224982800,5),(1079,1238288400,6),(1079,1256432400,5),(1079,1269738000,6),(1079,1288486800,5),(1079,1301187600,6),(1079,1319936400,5),(1079,1332637200,6),(1079,1351386000,5),(1079,1364691600,6),(1079,1382835600,5),(1079,1396141200,6),(1079,1414285200,5),(1079,1427590800,6),(1079,1445734800,5),(1079,1459040400,6),(1079,1477789200,5),(1079,1490490000,6),(1079,1509238800,5),(1079,1521939600,6),(1079,1540688400,5),(1079,1553994000,6),(1079,1572138000,5),(1079,1585443600,6),(1079,1603587600,5),(1079,1616893200,6),(1079,1635642000,5),(1079,1648342800,6),(1079,1667091600,5),(1079,1679792400,6),(1079,1698541200,5),(1079,1711846800,6),(1079,1729990800,5),(1079,1743296400,6),(1079,1761440400,5),(1079,1774746000,6),(1079,1792890000,5),(1079,1806195600,6),(1079,1824944400,5),(1079,1837645200,6),(1079,1856394000,5),(1079,1869094800,6),(1079,1887843600,5),(1079,1901149200,6),(1079,1919293200,5),(1079,1932598800,6),(1079,1950742800,5),(1079,1964048400,6),(1079,1982797200,5),(1079,1995498000,6),(1079,2014246800,5),(1079,2026947600,6),(1079,2045696400,5),(1079,2058397200,6),(1079,2077146000,5),(1079,2090451600,6),(1079,2108595600,5),(1079,2121901200,6),(1079,2140045200,5),(1080,-2147483648,2),(1080,-1693706400,1),(1080,-1680483600,2),(1080,-1663455600,3),(1080,-1650150000,4),(1080,-1632006000,3),(1080,-1618700400,4),(1080,-1577926800,2),(1080,-1569711600,3),(1080,-1555801200,4),(1080,-938905200,3),(1080,-857257200,4),(1080,-844556400,3),(1080,-828226800,4),(1080,-812502000,3),(1080,-796777200,4),(1080,-781052400,3),(1080,-780188400,4),(1080,-757386000,2),(1080,-748479600,3),(1080,-733273200,4),(1080,-717634800,3),(1080,-701910000,4),(1080,-684975600,3),(1080,-670460400,4),(1080,323823600,1),(1080,338940000,2),(1080,354675600,5),(1080,370400400,6),(1080,386125200,5),(1080,401850000,6),(1080,417574800,5),(1080,433299600,6),(1080,449024400,5),(1080,465354000,6),(1080,481078800,5),(1080,496803600,6),(1080,512528400,5),(1080,528253200,6),(1080,543978000,5),(1080,559702800,6),(1080,575427600,5),(1080,591152400,6),(1080,606877200,5),(1080,622602000,6),(1080,638326800,5),(1080,654656400,6),(1080,670381200,5),(1080,686106000,6),(1080,701830800,5),(1080,717555600,6),(1080,733280400,5),(1080,749005200,6),(1080,764730000,5),(1080,780454800,6),(1080,796179600,5),(1080,811904400,6),(1080,828234000,5),(1080,846378000,6),(1080,859683600,5),(1080,877827600,6),(1080,891133200,5),(1080,909277200,6),(1080,922582800,5),(1080,941331600,6),(1080,954032400,5),(1080,972781200,6),(1080,985482000,5),(1080,1004230800,6),(1080,1017536400,5),(1080,1035680400,6),(1080,1048986000,5),(1080,1067130000,6),(1080,1080435600,5),(1080,1099184400,6),(1080,1111885200,5),(1080,1130634000,6),(1080,1143334800,5),(1080,1162083600,6),(1080,1174784400,5),(1080,1193533200,6),(1080,1206838800,5),(1080,1224982800,6),(1080,1238288400,5),(1080,1256432400,6),(1080,1269738000,5),(1080,1288486800,6),(1080,1301187600,5),(1080,1319936400,6),(1080,1332637200,5),(1080,1351386000,6),(1080,1364691600,5),(1080,1382835600,6),(1080,1396141200,5),(1080,1414285200,6),(1080,1427590800,5),(1080,1445734800,6),(1080,1459040400,5),(1080,1477789200,6),(1080,1490490000,5),(1080,1509238800,6),(1080,1521939600,5),(1080,1540688400,6),(1080,1553994000,5),(1080,1572138000,6),(1080,1585443600,5),(1080,1603587600,6),(1080,1616893200,5),(1080,1635642000,6),(1080,1648342800,5),(1080,1667091600,6),(1080,1679792400,5),(1080,1698541200,6),(1080,1711846800,5),(1080,1729990800,6),(1080,1743296400,5),(1080,1761440400,6),(1080,1774746000,5),(1080,1792890000,6),(1080,1806195600,5),(1080,1824944400,6),(1080,1837645200,5),(1080,1856394000,6),(1080,1869094800,5),(1080,1887843600,6),(1080,1901149200,5),(1080,1919293200,6),(1080,1932598800,5),(1080,1950742800,6),(1080,1964048400,5),(1080,1982797200,6),(1080,1995498000,5),(1080,2014246800,6),(1080,2026947600,5),(1080,2045696400,6),(1080,2058397200,5),(1080,2077146000,6),(1080,2090451600,5),(1080,2108595600,6),(1080,2121901200,5),(1080,2140045200,6),(1081,-2147483648,1),(1081,-1672536240,2),(1081,-1585100136,3),(1081,-1561251600,4),(1081,-1553565600,3),(1081,-928198800,5),(1081,-900126000,8),(1081,-857257200,6),(1081,-844556400,7),(1081,-828226800,6),(1081,-812502000,7),(1081,-802144800,5),(1081,354920400,9),(1081,370728000,5),(1081,386456400,9),(1081,402264000,5),(1081,417992400,9),(1081,433800000,5),(1081,449614800,9),(1081,465346800,10),(1081,481071600,11),(1081,496796400,10),(1081,512521200,11),(1081,528246000,10),(1081,543970800,11),(1081,559695600,10),(1081,575420400,11),(1081,591145200,10),(1081,606870000,12),(1081,622598400,13),(1081,638323200,12),(1081,654652800,13),(1081,670377600,12),(1081,686102400,13),(1081,701827200,12),(1081,717552000,13),(1081,733276800,12),(1081,749001600,13),(1081,764726400,12),(1081,780451200,13),(1081,796176000,12),(1081,811900800,13),(1081,828230400,12),(1081,846374400,13),(1081,859680000,12),(1081,877824000,13),(1081,883605600,4),(1081,891133200,14),(1081,909277200,15),(1081,922582800,14),(1081,941331600,16),(1081,1041372000,4),(1081,1048986000,17),(1081,1067130000,16),(1081,1080435600,17),(1081,1099184400,16),(1081,1111885200,17),(1081,1130634000,16),(1081,1143334800,17),(1081,1162083600,16),(1081,1174784400,17),(1081,1193533200,16),(1081,1206838800,17),(1081,1224982800,16),(1081,1238288400,17),(1081,1256432400,16),(1081,1269738000,17),(1081,1288486800,16),(1081,1301187600,17),(1081,1319936400,16),(1081,1332637200,17),(1081,1351386000,16),(1081,1364691600,17),(1081,1382835600,16),(1081,1396141200,17),(1081,1414285200,16),(1081,1427590800,17),(1081,1445734800,16),(1081,1459040400,17),(1081,1477789200,16),(1081,1490490000,17),(1081,1509238800,16),(1081,1521939600,17),(1081,1540688400,16),(1081,1553994000,17),(1081,1572138000,16),(1081,1585443600,17),(1081,1603587600,16),(1081,1616893200,17),(1081,1635642000,16),(1081,1648342800,17),(1081,1667091600,16),(1081,1679792400,17),(1081,1698541200,16),(1081,1711846800,17),(1081,1729990800,16),(1081,1743296400,17),(1081,1761440400,16),(1081,1774746000,17),(1081,1792890000,16),(1081,1806195600,17),(1081,1824944400,16),(1081,1837645200,17),(1081,1856394000,16),(1081,1869094800,17),(1081,1887843600,16),(1081,1901149200,17),(1081,1919293200,16),(1081,1932598800,17),(1081,1950742800,16),(1081,1964048400,17),(1081,1982797200,16),(1081,1995498000,17),(1081,2014246800,16),(1081,2026947600,17),(1081,2045696400,16),(1081,2058397200,17),(1081,2077146000,16),(1081,2090451600,17),(1081,2108595600,16),(1081,2121901200,17),(1081,2140045200,16),(1082,-2147483648,0),(1082,-1577761060,1),(1082,-1247540400,2),(1082,354916800,3),(1082,370724400,2),(1082,386452800,3),(1082,402260400,2),(1082,417988800,3),(1082,433796400,2),(1082,449611200,3),(1082,465343200,4),(1082,481068000,5),(1082,496792800,4),(1082,512517600,5),(1082,528242400,4),(1082,543967200,5),(1082,559692000,4),(1082,575416800,6),(1082,591145200,7),(1082,606870000,6),(1082,622594800,7),(1082,638319600,6),(1082,654649200,7),(1082,670374000,4),(1082,701820000,6),(1082,717548400,7),(1082,733273200,6),(1082,748998000,7),(1082,764722800,6),(1082,780447600,7),(1082,796172400,6),(1082,811897200,7),(1082,828226800,6),(1082,846370800,7),(1082,859676400,6),(1082,877820400,7),(1082,891126000,6),(1082,909270000,7),(1082,922575600,6),(1082,941324400,7),(1082,954025200,6),(1082,972774000,7),(1082,985474800,6),(1082,1004223600,7),(1082,1017529200,6),(1082,1035673200,7),(1082,1048978800,6),(1082,1067122800,7),(1082,1080428400,6),(1082,1099177200,7),(1082,1111878000,6),(1082,1130626800,7),(1082,1143327600,6),(1082,1162076400,7),(1082,1174777200,6),(1082,1193526000,7),(1082,1206831600,6),(1082,1224975600,7),(1082,1238281200,6),(1082,1256425200,7),(1082,1269730800,6),(1082,1288479600,7),(1082,1301180400,8),(1082,1414274400,7),(1082,1540681200,4),(1082,1609020000,7),(1083,-2147483648,1),(1083,-1717032240,3),(1083,-1693706400,2),(1083,-1680483600,3),(1083,-1663455600,4),(1083,-1650150000,5),(1083,-1632006000,4),(1083,-1618700400,8),(1083,-1600473600,6),(1083,-1587168000,7),(1083,-1501725600,3),(1083,-931734000,2),(1083,-857257200,5),(1083,-844556400,4),(1083,-828226800,5),(1083,-812502000,4),(1083,-796874400,2),(1083,-796608000,3),(1083,-778726800,2),(1083,-762660000,3),(1083,-748486800,4),(1083,-733273200,5),(1083,-715215600,4),(1083,-701910000,5),(1083,-684975600,4),(1083,-670460400,5),(1083,-654130800,4),(1083,-639010800,5),(1083,-397094400,4),(1083,-386812800,5),(1083,-371088000,4),(1083,-355363200,5),(1083,-334195200,4),(1083,-323308800,5),(1083,-307584000,4),(1083,-291859200,5),(1083,-271296000,4),(1083,-260409600,5),(1083,-239846400,4),(1083,-228960000,5),(1083,-208396800,4),(1083,-197510400,5),(1083,-176342400,4),(1083,-166060800,5),(1083,220921200,3),(1083,228873600,4),(1083,243993600,5),(1083,260323200,4),(1083,276048000,5),(1083,291772800,4),(1083,307497600,5),(1083,323827200,4),(1083,338947200,5),(1083,354672000,4),(1083,370396800,5),(1083,386121600,4),(1083,401846400,5),(1083,417571200,4),(1083,433296000,5),(1083,449020800,4),(1083,465350400,5),(1083,481075200,4),(1083,496800000,5),(1083,512524800,4),(1083,528249600,5),(1083,543974400,4),(1083,559699200,5),(1083,567990000,3),(1083,575427600,9),(1083,591152400,10),(1083,606877200,9),(1083,622602000,10),(1083,638326800,9),(1083,654656400,10),(1083,670381200,9),(1083,686106000,10),(1083,701830800,9),(1083,717555600,10),(1083,733280400,9),(1083,749005200,10),(1083,764730000,9),(1083,780454800,10),(1083,796179600,9),(1083,811904400,10),(1083,828234000,9),(1083,846378000,10),(1083,859683600,9),(1083,877827600,10),(1083,891133200,9),(1083,909277200,10),(1083,922582800,9),(1083,941331600,10),(1083,954032400,9),(1083,972781200,10),(1083,985482000,9),(1083,1004230800,10),(1083,1017536400,9),(1083,1035680400,10),(1083,1048986000,9),(1083,1067130000,10),(1083,1080435600,9),(1083,1099184400,10),(1083,1111885200,9),(1083,1130634000,10),(1083,1143334800,9),(1083,1162083600,10),(1083,1174784400,9),(1083,1193533200,10),(1083,1206838800,9),(1083,1224982800,10),(1083,1238288400,9),(1083,1256432400,10),(1083,1269738000,9),(1083,1288486800,10),(1083,1301187600,9),(1083,1319936400,10),(1083,1332637200,9),(1083,1351386000,10),(1083,1364691600,9),(1083,1382835600,10),(1083,1396141200,9),(1083,1414285200,10),(1083,1427590800,9),(1083,1445734800,10),(1083,1459040400,9),(1083,1477789200,10),(1083,1490490000,9),(1083,1509238800,10),(1083,1521939600,9),(1083,1540688400,10),(1083,1553994000,9),(1083,1572138000,10),(1083,1585443600,9),(1083,1603587600,10),(1083,1616893200,9),(1083,1635642000,10),(1083,1648342800,9),(1083,1667091600,10),(1083,1679792400,9),(1083,1698541200,10),(1083,1711846800,9),(1083,1729990800,10),(1083,1743296400,9),(1083,1761440400,10),(1083,1774746000,9),(1083,1792890000,10),(1083,1806195600,9),(1083,1824944400,10),(1083,1837645200,9),(1083,1856394000,10),(1083,1869094800,9),(1083,1887843600,10),(1083,1901149200,9),(1083,1919293200,10),(1083,1932598800,9),(1083,1950742800,10),(1083,1964048400,9),(1083,1982797200,10),(1083,1995498000,9),(1083,2014246800,10),(1083,2026947600,9),(1083,2045696400,10),(1083,2058397200,9),(1083,2077146000,10),(1083,2090451600,9),(1083,2108595600,10),(1083,2121901200,9),(1083,2140045200,10),(1084,-2147483648,1),(1084,-905824800,4),(1084,-857257200,2),(1084,-844556400,3),(1084,-828226800,2),(1084,-812502000,3),(1084,-796777200,2),(1084,-788922000,1),(1084,-777942000,3),(1084,-766623600,2),(1084,407199600,1),(1084,417574800,5),(1084,433299600,6),(1084,449024400,5),(1084,465354000,6),(1084,481078800,5),(1084,496803600,6),(1084,512528400,5),(1084,528253200,6),(1084,543978000,5),(1084,559702800,6),(1084,575427600,5),(1084,591152400,6),(1084,606877200,5),(1084,622602000,6),(1084,638326800,5),(1084,654656400,6),(1084,670381200,5),(1084,686106000,6),(1084,701830800,5),(1084,717555600,6),(1084,733280400,5),(1084,749005200,6),(1084,764730000,5),(1084,780454800,6),(1084,796179600,5),(1084,811904400,6),(1084,828234000,5),(1084,846378000,6),(1084,859683600,5),(1084,877827600,6),(1084,891133200,5),(1084,909277200,6),(1084,922582800,5),(1084,941331600,6),(1084,954032400,5),(1084,972781200,6),(1084,985482000,5),(1084,1004230800,6),(1084,1017536400,5),(1084,1035680400,6),(1084,1048986000,5),(1084,1067130000,6),(1084,1080435600,5),(1084,1099184400,6),(1084,1111885200,5),(1084,1130634000,6),(1084,1143334800,5),(1084,1162083600,6),(1084,1174784400,5),(1084,1193533200,6),(1084,1206838800,5),(1084,1224982800,6),(1084,1238288400,5),(1084,1256432400,6),(1084,1269738000,5),(1084,1288486800,6),(1084,1301187600,5),(1084,1319936400,6),(1084,1332637200,5),(1084,1351386000,6),(1084,1364691600,5),(1084,1382835600,6),(1084,1396141200,5),(1084,1414285200,6),(1084,1427590800,5),(1084,1445734800,6),(1084,1459040400,5),(1084,1477789200,6),(1084,1490490000,5),(1084,1509238800,6),(1084,1521939600,5),(1084,1540688400,6),(1084,1553994000,5),(1084,1572138000,6),(1084,1585443600,5),(1084,1603587600,6),(1084,1616893200,5),(1084,1635642000,6),(1084,1648342800,5),(1084,1667091600,6),(1084,1679792400,5),(1084,1698541200,6),(1084,1711846800,5),(1084,1729990800,6),(1084,1743296400,5),(1084,1761440400,6),(1084,1774746000,5),(1084,1792890000,6),(1084,1806195600,5),(1084,1824944400,6),(1084,1837645200,5),(1084,1856394000,6),(1084,1869094800,5),(1084,1887843600,6),(1084,1901149200,5),(1084,1919293200,6),(1084,1932598800,5),(1084,1950742800,6),(1084,1964048400,5),(1084,1982797200,6),(1084,1995498000,5),(1084,2014246800,6),(1084,2026947600,5),(1084,2045696400,6),(1084,2058397200,5),(1084,2077146000,6),(1084,2090451600,5),(1084,2108595600,6),(1084,2121901200,5),(1084,2140045200,6),(1085,-2147483648,1),(1085,-1441159324,2),(1085,-1247536800,3),(1085,-892522800,6),(1085,-857257200,4),(1085,-844556400,5),(1085,-828226800,4),(1085,-825382800,3),(1085,354920400,7),(1085,370728000,3),(1085,386456400,7),(1085,402264000,3),(1085,417992400,7),(1085,433800000,3),(1085,449614800,7),(1085,465346800,8),(1085,481071600,9),(1085,496796400,8),(1085,512521200,9),(1085,528246000,8),(1085,543970800,9),(1085,559695600,8),(1085,575420400,9),(1085,591145200,8),(1085,606870000,9),(1085,622594800,8),(1085,638319600,9),(1085,646783200,10),(1085,686102400,11),(1085,701827200,12),(1085,717552000,11),(1085,733276800,12),(1085,749001600,11),(1085,764726400,12),(1085,780451200,11),(1085,796176000,12),(1085,811900800,11),(1085,828230400,12),(1085,831934800,10),(1085,846378000,13),(1085,859683600,14),(1085,877827600,13),(1085,891133200,14),(1085,909277200,13),(1085,922582800,14),(1085,941331600,13),(1085,954032400,14),(1085,972781200,13),(1085,985482000,14),(1085,1004230800,13),(1085,1017536400,14),(1085,1035680400,13),(1085,1048986000,14),(1085,1067130000,13),(1085,1080435600,14),(1085,1099184400,13),(1085,1111885200,14),(1085,1130634000,13),(1085,1143334800,14),(1085,1162083600,13),(1085,1174784400,14),(1085,1193533200,13),(1085,1206838800,14),(1085,1224982800,13),(1085,1238288400,14),(1085,1256432400,13),(1085,1269738000,14),(1085,1288486800,13),(1085,1301187600,14),(1085,1319936400,13),(1085,1332637200,14),(1085,1351386000,13),(1085,1364691600,14),(1085,1382835600,13),(1085,1396141200,14),(1085,1414285200,13),(1085,1427590800,14),(1085,1445734800,13),(1085,1459040400,14),(1085,1477789200,13),(1085,1490490000,14),(1085,1509238800,13),(1085,1521939600,14),(1085,1540688400,13),(1085,1553994000,14),(1085,1572138000,13),(1085,1585443600,14),(1085,1603587600,13),(1085,1616893200,14),(1085,1635642000,13),(1085,1648342800,14),(1085,1667091600,13),(1085,1679792400,14),(1085,1698541200,13),(1085,1711846800,14),(1085,1729990800,13),(1085,1743296400,14),(1085,1761440400,13),(1085,1774746000,14),(1085,1792890000,13),(1085,1806195600,14),(1085,1824944400,13),(1085,1837645200,14),(1085,1856394000,13),(1085,1869094800,14),(1085,1887843600,13),(1085,1901149200,14),(1085,1919293200,13),(1085,1932598800,14),(1085,1950742800,13),(1085,1964048400,14),(1085,1982797200,13),(1085,1995498000,14),(1085,2014246800,13),(1085,2026947600,14),(1085,2045696400,13),(1085,2058397200,14),(1085,2077146000,13),(1085,2090451600,14),(1085,2108595600,13),(1085,2121901200,14),(1085,2140045200,13),(1086,-2147483648,2),(1086,-904435200,1),(1086,-891129600,2),(1086,-872985600,1),(1086,-859680000,2),(1086,354675600,3),(1086,370400400,4),(1086,386125200,3),(1086,401850000,4),(1086,417574800,3),(1086,433299600,4),(1086,449024400,3),(1086,465354000,4),(1086,481078800,3),(1086,496803600,4),(1086,512528400,3),(1086,528253200,4),(1086,543978000,3),(1086,559702800,4),(1086,575427600,3),(1086,591152400,4),(1086,606877200,3),(1086,622602000,4),(1086,638326800,3),(1086,654656400,4),(1086,670381200,3),(1086,686106000,4),(1086,701830800,3),(1086,717555600,4),(1086,733280400,3),(1086,749005200,4),(1086,764730000,3),(1086,780454800,4),(1086,796179600,3),(1086,811904400,4),(1086,828234000,3),(1086,846378000,4),(1086,859683600,3),(1086,877827600,4),(1086,891133200,3),(1086,909277200,4),(1086,922582800,3),(1086,941331600,4),(1086,954032400,3),(1086,972781200,4),(1086,985482000,3),(1086,1004230800,4),(1086,1017536400,3),(1086,1035680400,4),(1086,1048986000,3),(1086,1067130000,4),(1086,1080435600,3),(1086,1099184400,4),(1086,1111885200,3),(1086,1130634000,4),(1086,1143334800,3),(1086,1162083600,4),(1086,1174784400,3),(1086,1193533200,4),(1086,1206838800,3),(1086,1224982800,4),(1086,1238288400,3),(1086,1256432400,4),(1086,1269738000,3),(1086,1288486800,4),(1086,1301187600,3),(1086,1319936400,4),(1086,1332637200,3),(1086,1351386000,4),(1086,1364691600,3),(1086,1382835600,4),(1086,1396141200,3),(1086,1414285200,4),(1086,1427590800,3),(1086,1445734800,4),(1086,1459040400,3),(1086,1477789200,4),(1086,1490490000,3),(1086,1509238800,4),(1086,1521939600,3),(1086,1540688400,4),(1086,1553994000,3),(1086,1572138000,4),(1086,1585443600,3),(1086,1603587600,4),(1086,1616893200,3),(1086,1635642000,4),(1086,1648342800,3),(1086,1667091600,4),(1086,1679792400,3),(1086,1698541200,4),(1086,1711846800,3),(1086,1729990800,4),(1086,1743296400,3),(1086,1761440400,4),(1086,1774746000,3),(1086,1792890000,4),(1086,1806195600,3),(1086,1824944400,4),(1086,1837645200,3),(1086,1856394000,4),(1086,1869094800,3),(1086,1887843600,4),(1086,1901149200,3),(1086,1919293200,4),(1086,1932598800,3),(1086,1950742800,4),(1086,1964048400,3),(1086,1982797200,4),(1086,1995498000,3),(1086,2014246800,4),(1086,2026947600,3),(1086,2045696400,4),(1086,2058397200,3),(1086,2077146000,4),(1086,2090451600,3),(1086,2108595600,4),(1086,2121901200,3),(1086,2140045200,4),(1087,-2147483648,4),(1087,-1691964000,1),(1087,-1680472800,2),(1087,-1664143200,1),(1087,-1650146400,2),(1087,-1633903200,1),(1087,-1617487200,2),(1087,-1601848800,1),(1087,-1586037600,2),(1087,-1570399200,1),(1087,-1552168800,2),(1087,-1538344800,1),(1087,-1522533600,2),(1087,-1507500000,1),(1087,-1490565600,2),(1087,-1473631200,1),(1087,-1460930400,2),(1087,-1442786400,1),(1087,-1428876000,2),(1087,-1410732000,1),(1087,-1396216800,2),(1087,-1379282400,1),(1087,-1364767200,2),(1087,-1348437600,1),(1087,-1333317600,2),(1087,-1315778400,1),(1087,-1301263200,2),(1087,-1284328800,1),(1087,-1269813600,2),(1087,-1253484000,1),(1087,-1238364000,2),(1087,-1221429600,1),(1087,-1206914400,2),(1087,-1189980000,1),(1087,-1175464800,2),(1087,-1159135200,1),(1087,-1143410400,2),(1087,-1126476000,1),(1087,-1111960800,2),(1087,-1095631200,1),(1087,-1080511200,2),(1087,-1063576800,1),(1087,-1049061600,2),(1087,-1032127200,1),(1087,-1017612000,2),(1087,-1001282400,1),(1087,-986162400,2),(1087,-969228000,1),(1087,-950479200,2),(1087,-942012000,1),(1087,-904518000,3),(1087,-896050800,1),(1087,-875487600,3),(1087,-864601200,1),(1087,-844038000,3),(1087,-832546800,1),(1087,-812588400,3),(1087,-798073200,1),(1087,-781052400,3),(1087,-772066800,1),(1087,-764805600,2),(1087,-748476000,1),(1087,-733356000,2),(1087,-719445600,1),(1087,-717030000,3),(1087,-706748400,1),(1087,-699487200,2),(1087,-687996000,1),(1087,-668037600,2),(1087,-654732000,1),(1087,-636588000,2),(1087,-622072800,1),(1087,-605743200,2),(1087,-590623200,1),(1087,-574293600,2),(1087,-558568800,1),(1087,-542239200,2),(1087,-527119200,1),(1087,-512604000,2),(1087,-496274400,1),(1087,-481154400,2),(1087,-464220000,1),(1087,-449704800,2),(1087,-432165600,1),(1087,-417650400,2),(1087,-401320800,1),(1087,-386200800,2),(1087,-369266400,1),(1087,-354751200,2),(1087,-337816800,1),(1087,-323301600,2),(1087,-306972000,1),(1087,-291852000,2),(1087,-276732000,1),(1087,-257983200,2),(1087,-245282400,1),(1087,-226533600,2),(1087,-213228000,1),(1087,-195084000,2),(1087,-182383200,1),(1087,-163634400,2),(1087,-150933600,1),(1087,-132184800,2),(1087,-119484000,1),(1087,-100735200,2),(1087,-88034400,1),(1087,-68680800,2),(1087,-59004000,1),(1087,-37242000,5),(1087,57722400,7),(1087,69818400,1),(1087,89172000,2),(1087,101268000,1),(1087,120621600,2),(1087,132717600,1),(1087,152071200,2),(1087,164167200,1),(1087,183520800,2),(1087,196221600,1),(1087,214970400,2),(1087,227671200,1),(1087,246420000,2),(1087,259120800,1),(1087,278474400,2),(1087,290570400,1),(1087,309924000,2),(1087,322020000,1),(1087,341373600,2),(1087,354675600,6),(1087,372819600,7),(1087,386125200,6),(1087,404269200,7),(1087,417574800,6),(1087,435718800,7),(1087,449024400,6),(1087,467773200,7),(1087,481078800,6),(1087,499222800,7),(1087,512528400,6),(1087,530672400,7),(1087,543978000,6),(1087,562122000,7),(1087,575427600,6),(1087,593571600,7),(1087,606877200,6),(1087,625626000,7),(1087,638326800,6),(1087,657075600,7),(1087,670381200,6),(1087,688525200,7),(1087,701830800,6),(1087,719974800,7),(1087,733280400,6),(1087,751424400,7),(1087,764730000,6),(1087,782874000,7),(1087,796179600,6),(1087,814323600,7),(1087,820454400,4),(1087,828234000,6),(1087,846378000,7),(1087,859683600,6),(1087,877827600,7),(1087,891133200,6),(1087,909277200,7),(1087,922582800,6),(1087,941331600,7),(1087,954032400,6),(1087,972781200,7),(1087,985482000,6),(1087,1004230800,7),(1087,1017536400,6),(1087,1035680400,7),(1087,1048986000,6),(1087,1067130000,7),(1087,1080435600,6),(1087,1099184400,7),(1087,1111885200,6),(1087,1130634000,7),(1087,1143334800,6),(1087,1162083600,7),(1087,1174784400,6),(1087,1193533200,7),(1087,1206838800,6),(1087,1224982800,7),(1087,1238288400,6),(1087,1256432400,7),(1087,1269738000,6),(1087,1288486800,7),(1087,1301187600,6),(1087,1319936400,7),(1087,1332637200,6),(1087,1351386000,7),(1087,1364691600,6),(1087,1382835600,7),(1087,1396141200,6),(1087,1414285200,7),(1087,1427590800,6),(1087,1445734800,7),(1087,1459040400,6),(1087,1477789200,7),(1087,1490490000,6),(1087,1509238800,7),(1087,1521939600,6),(1087,1540688400,7),(1087,1553994000,6),(1087,1572138000,7),(1087,1585443600,6),(1087,1603587600,7),(1087,1616893200,6),(1087,1635642000,7),(1087,1648342800,6),(1087,1667091600,7),(1087,1679792400,6),(1087,1698541200,7),(1087,1711846800,6),(1087,1729990800,7),(1087,1743296400,6),(1087,1761440400,7),(1087,1774746000,6),(1087,1792890000,7),(1087,1806195600,6),(1087,1824944400,7),(1087,1837645200,6),(1087,1856394000,7),(1087,1869094800,6),(1087,1887843600,7),(1087,1901149200,6),(1087,1919293200,7),(1087,1932598800,6),(1087,1950742800,7),(1087,1964048400,6),(1087,1982797200,7),(1087,1995498000,6),(1087,2014246800,7),(1087,2026947600,6),(1087,2045696400,7),(1087,2058397200,6),(1087,2077146000,7),(1087,2090451600,6),(1087,2108595600,7),(1087,2121901200,6),(1087,2140045200,7),(1088,-2147483648,4),(1088,-1691964000,1),(1088,-1680472800,2),(1088,-1664143200,1),(1088,-1650146400,2),(1088,-1633903200,1),(1088,-1617487200,2),(1088,-1601848800,1),(1088,-1586037600,2),(1088,-1570399200,1),(1088,-1552168800,2),(1088,-1538344800,1),(1088,-1522533600,2),(1088,-1507500000,1),(1088,-1490565600,2),(1088,-1473631200,1),(1088,-1460930400,2),(1088,-1442786400,1),(1088,-1428876000,2),(1088,-1410732000,1),(1088,-1396216800,2),(1088,-1379282400,1),(1088,-1364767200,2),(1088,-1348437600,1),(1088,-1333317600,2),(1088,-1315778400,1),(1088,-1301263200,2),(1088,-1284328800,1),(1088,-1269813600,2),(1088,-1253484000,1),(1088,-1238364000,2),(1088,-1221429600,1),(1088,-1206914400,2),(1088,-1189980000,1),(1088,-1175464800,2),(1088,-1159135200,1),(1088,-1143410400,2),(1088,-1126476000,1),(1088,-1111960800,2),(1088,-1095631200,1),(1088,-1080511200,2),(1088,-1063576800,1),(1088,-1049061600,2),(1088,-1032127200,1),(1088,-1017612000,2),(1088,-1001282400,1),(1088,-986162400,2),(1088,-969228000,1),(1088,-950479200,2),(1088,-942012000,1),(1088,-904518000,3),(1088,-896050800,1),(1088,-875487600,3),(1088,-864601200,1),(1088,-844038000,3),(1088,-832546800,1),(1088,-812588400,3),(1088,-798073200,1),(1088,-781052400,3),(1088,-772066800,1),(1088,-764805600,2),(1088,-748476000,1),(1088,-733356000,2),(1088,-719445600,1),(1088,-717030000,3),(1088,-706748400,1),(1088,-699487200,2),(1088,-687996000,1),(1088,-668037600,2),(1088,-654732000,1),(1088,-636588000,2),(1088,-622072800,1),(1088,-605743200,2),(1088,-590623200,1),(1088,-574293600,2),(1088,-558568800,1),(1088,-542239200,2),(1088,-527119200,1),(1088,-512604000,2),(1088,-496274400,1),(1088,-481154400,2),(1088,-464220000,1),(1088,-449704800,2),(1088,-432165600,1),(1088,-417650400,2),(1088,-401320800,1),(1088,-386200800,2),(1088,-369266400,1),(1088,-354751200,2),(1088,-337816800,1),(1088,-323301600,2),(1088,-306972000,1),(1088,-291852000,2),(1088,-276732000,1),(1088,-257983200,2),(1088,-245282400,1),(1088,-226533600,2),(1088,-213228000,1),(1088,-195084000,2),(1088,-182383200,1),(1088,-163634400,2),(1088,-150933600,1),(1088,-132184800,2),(1088,-119484000,1),(1088,-100735200,2),(1088,-88034400,1),(1088,-68680800,2),(1088,-59004000,1),(1088,-37242000,5),(1088,57722400,7),(1088,69818400,1),(1088,89172000,2),(1088,101268000,1),(1088,120621600,2),(1088,132717600,1),(1088,152071200,2),(1088,164167200,1),(1088,183520800,2),(1088,196221600,1),(1088,214970400,2),(1088,227671200,1),(1088,246420000,2),(1088,259120800,1),(1088,278474400,2),(1088,290570400,1),(1088,309924000,2),(1088,322020000,1),(1088,341373600,2),(1088,354675600,6),(1088,372819600,7),(1088,386125200,6),(1088,404269200,7),(1088,417574800,6),(1088,435718800,7),(1088,449024400,6),(1088,467773200,7),(1088,481078800,6),(1088,499222800,7),(1088,512528400,6),(1088,530672400,7),(1088,543978000,6),(1088,562122000,7),(1088,575427600,6),(1088,593571600,7),(1088,606877200,6),(1088,625626000,7),(1088,638326800,6),(1088,657075600,7),(1088,670381200,6),(1088,688525200,7),(1088,701830800,6),(1088,719974800,7),(1088,733280400,6),(1088,751424400,7),(1088,764730000,6),(1088,782874000,7),(1088,796179600,6),(1088,814323600,7),(1088,820454400,4),(1088,828234000,6),(1088,846378000,7),(1088,859683600,6),(1088,877827600,7),(1088,891133200,6),(1088,909277200,7),(1088,922582800,6),(1088,941331600,7),(1088,954032400,6),(1088,972781200,7),(1088,985482000,6),(1088,1004230800,7),(1088,1017536400,6),(1088,1035680400,7),(1088,1048986000,6),(1088,1067130000,7),(1088,1080435600,6),(1088,1099184400,7),(1088,1111885200,6),(1088,1130634000,7),(1088,1143334800,6),(1088,1162083600,7),(1088,1174784400,6),(1088,1193533200,7),(1088,1206838800,6),(1088,1224982800,7),(1088,1238288400,6),(1088,1256432400,7),(1088,1269738000,6),(1088,1288486800,7),(1088,1301187600,6),(1088,1319936400,7),(1088,1332637200,6),(1088,1351386000,7),(1088,1364691600,6),(1088,1382835600,7),(1088,1396141200,6),(1088,1414285200,7),(1088,1427590800,6),(1088,1445734800,7),(1088,1459040400,6),(1088,1477789200,7),(1088,1490490000,6),(1088,1509238800,7),(1088,1521939600,6),(1088,1540688400,7),(1088,1553994000,6),(1088,1572138000,7),(1088,1585443600,6),(1088,1603587600,7),(1088,1616893200,6),(1088,1635642000,7),(1088,1648342800,6),(1088,1667091600,7),(1088,1679792400,6),(1088,1698541200,7),(1088,1711846800,6),(1088,1729990800,7),(1088,1743296400,6),(1088,1761440400,7),(1088,1774746000,6),(1088,1792890000,7),(1088,1806195600,6),(1088,1824944400,7),(1088,1837645200,6),(1088,1856394000,7),(1088,1869094800,6),(1088,1887843600,7),(1088,1901149200,6),(1088,1919293200,7),(1088,1932598800,6),(1088,1950742800,7),(1088,1964048400,6),(1088,1982797200,7),(1088,1995498000,6),(1088,2014246800,7),(1088,2026947600,6),(1088,2045696400,7),(1088,2058397200,6),(1088,2077146000,7),(1088,2090451600,6),(1088,2108595600,7),(1088,2121901200,6),(1088,2140045200,7),(1095,-2147483648,0),(1095,-2056690800,1),(1095,-900910800,2),(1095,-891579600,3),(1095,-884248200,4),(1095,-761209200,7),(1095,-747907200,2),(1095,-728541000,5),(1095,-717049800,6),(1095,-697091400,5),(1095,-683785800,6),(1095,-668061000,5),(1095,-654755400,2),(1095,-636611400,5),(1095,-623305800,2),(1095,-605161800,5),(1095,-591856200,2),(1095,-573712200,5),(1095,-559801800,2),(1095,-541657800,5),(1095,-528352200,2),(1095,-510211800,7),(1095,-498112200,2),(1095,-478762200,7),(1095,-466662600,2),(1095,-446707800,7),(1095,-435213000,2),(1095,-415258200,7),(1095,-403158600,2),(1095,-383808600,7),(1095,-371709000,2),(1095,-352359000,7),(1095,-340259400,2),(1095,-320909400,7),(1095,-308809800,2),(1095,-288855000,7),(1095,-277360200,2),(1095,-257405400,7),(1095,-245910600,2),(1095,-225955800,7),(1095,-213856200,2),(1095,-194506200,7),(1095,-182406600,2),(1095,-163056600,7),(1095,-148537800,2),(1095,-132816600,7),(1095,-117088200,2),(1095,-101367000,7),(1095,-85638600,2),(1095,-69312600,7),(1095,-53584200,2),(1095,-37863000,7),(1095,-22134600,2),(1095,-6413400,7),(1095,9315000,2),(1095,25036200,7),(1095,40764600,2),(1095,56485800,7),(1095,72214200,2),(1095,88540200,7),(1095,104268600,2),(1095,119989800,7),(1095,126041400,2),(1095,151439400,7),(1095,167167800,2),(1095,182889000,7),(1095,198617400,2),(1095,214338600,7),(1095,295385400,2),(1095,309292200,7),(1096,-2147483648,0),(1096,-1830383032,1),(1097,-2147483648,0),(1097,-1946168836,1),(1097,-1309746600,2),(1097,-1261969200,1),(1097,-1041388200,3),(1097,-865305900,2),(1098,-2147483648,0),(1098,-1988167780,1),(1098,820436400,2),(1098,2147483647,2),(1099,-2147483648,1),(1099,-1570084924,2),(1099,2147483647,2),(1100,-2147483648,1),(1100,-1577946287,2),(1100,-873268200,3),(1100,-778410000,2),(1100,2147483647,2),(1101,-2147483648,0),(1101,-1946168836,1),(1101,-1309746600,2),(1101,-1261969200,1),(1101,-1041388200,3),(1101,-865305900,2),(1102,-2147483648,1),(1102,-315636840,2),(1102,2147483647,2),(1103,-2147483648,0),(1103,-1577936472,1),(1103,2147483647,1),(1104,-2147483648,1),(1104,-315636840,2),(1104,2147483647,2),(1105,-2147483648,0),(1105,-1988164200,2),(1105,403041600,1),(1105,417034800,2),(1105,1224972000,1),(1105,1238274000,2),(1105,2147483647,2),(1106,-2147483648,0),(1106,-1946168836,1),(1106,-1309746600,2),(1106,-1261969200,1),(1106,-1041388200,3),(1106,-865305900,2),(1107,-2147483648,0),(1107,-1577936472,1),(1107,2147483647,1),(1108,-2147483648,0),(1108,-1704165944,1),(1108,-1090466744,3),(1108,227820600,2),(1108,246223800,5),(1108,259617600,4),(1108,271108800,5),(1108,283982400,3),(1108,296598600,2),(1108,306531000,3),(1108,322432200,2),(1108,338499000,3),(1108,673216200,2),(1108,685481400,3),(1108,701209800,2),(1108,717103800,3),(1108,732745800,2),(1108,748639800,3),(1108,764281800,2),(1108,780175800,3),(1108,795817800,2),(1108,811711800,3),(1108,827353800,2),(1108,843247800,3),(1108,858976200,2),(1108,874870200,3),(1108,890512200,2),(1108,906406200,3),(1108,922048200,2),(1108,937942200,3),(1108,953584200,2),(1108,969478200,3),(1108,985206600,2),(1108,1001100600,3),(1108,1016742600,2),(1108,1032636600,3),(1108,1048278600,2),(1108,1064172600,3),(1108,1079814600,2),(1108,1095708600,3),(1108,1111437000,2),(1108,1127331000,3),(1108,1206045000,2),(1108,1221939000,3),(1108,1237667400,2),(1108,1253561400,3),(1108,1269203400,2),(1108,1285097400,3),(1108,1300739400,2),(1108,1316633400,3),(1108,1332275400,2),(1108,1348169400,3),(1108,1363897800,2),(1108,1379791800,3),(1108,1395433800,2),(1108,1411327800,3),(1108,1426969800,2),(1108,1442863800,3),(1108,1458505800,2),(1108,1474399800,3),(1108,1490128200,2),(1108,1506022200,3),(1108,1521664200,2),(1108,1537558200,3),(1108,1553200200,2),(1108,1569094200,3),(1108,1584736200,2),(1108,1600630200,3),(1108,1616358600,2),(1108,1632252600,3),(1108,1647894600,2),(1108,1663788600,3),(1108,2147483647,3),(1109,-2147483648,1),(1109,-1641003640,6),(1109,-933638400,2),(1109,-923097600,3),(1109,-919036800,2),(1109,-857347200,3),(1109,-844300800,2),(1109,-825811200,3),(1109,-812678400,2),(1109,-794188800,3),(1109,-779846400,2),(1109,-762652800,3),(1109,-748310400,2),(1109,-731116800,3),(1109,-681955200,4),(1109,-673228800,2),(1109,-667958400,3),(1109,-652320000,2),(1109,-636422400,3),(1109,-622080000,2),(1109,-608947200,3),(1109,-591840000,2),(1109,-572486400,3),(1109,-558576000,2),(1109,-542851200,3),(1109,-527731200,2),(1109,-514425600,3),(1109,-490838400,2),(1109,-482976000,3),(1109,-459388800,2),(1109,-451526400,3),(1109,-428544000,2),(1109,-418262400,3),(1109,-400118400,2),(1109,-387417600,3),(1109,142380000,5),(1109,150843600,6),(1109,167176800,5),(1109,178664400,6),(1109,334101600,7),(1109,337730400,8),(1109,452642400,7),(1109,462319200,8),(1109,482277600,5),(1109,494370000,6),(1109,516751200,5),(1109,526424400,6),(1109,545436000,5),(1109,558478800,6),(1109,576626400,5),(1109,589323600,6),(1109,609890400,5),(1109,620773200,6),(1109,638316000,5),(1109,651618000,6),(1109,669765600,5),(1109,683672400,6),(1109,701820000,5),(1109,715726800,6),(1109,733701600,5),(1109,747176400,6),(1109,765151200,5),(1109,778021200,6),(1109,796600800,5),(1109,810075600,6),(1109,826840800,5),(1109,842821200,6),(1109,858895200,5),(1109,874184400,6),(1109,890344800,5),(1109,905029200,6),(1109,923011200,5),(1109,936313200,6),(1109,955670400,5),(1109,970783200,6),(1109,986770800,5),(1109,1001282400,6),(1109,1017356400,5),(1109,1033941600,6),(1109,1048806000,5),(1109,1065132000,6),(1109,1081292400,5),(1109,1095804000,6),(1109,1112313600,5),(1109,1128812400,6),(1109,1143763200,5),(1109,1159657200,6),(1109,1175212800,5),(1109,1189897200,6),(1109,1206662400,5),(1109,1223161200,6),(1109,1238112000,5),(1109,1254006000,6),(1109,1269561600,5),(1109,1284246000,6),(1109,1301616000,5),(1109,1317510000,6),(1109,1333065600,5),(1109,1348354800,6),(1109,1364515200,5),(1109,1382828400,6),(1109,1395964800,5),(1109,1414278000,6),(1109,1427414400,5),(1109,1445727600,6),(1109,1458864000,5),(1109,1477782000,6),(1109,1490313600,5),(1109,1509231600,6),(1109,1521763200,5),(1109,1540681200,6),(1109,1553817600,5),(1109,1572130800,6),(1109,1585267200,5),(1109,1603580400,6),(1109,1616716800,5),(1109,1635634800,6),(1109,1648166400,5),(1109,1667084400,6),(1109,1679616000,5),(1109,1698534000,6),(1109,1711670400,5),(1109,1729983600,6),(1109,1743120000,5),(1109,1761433200,6),(1109,1774569600,5),(1109,1792882800,6),(1109,1806019200,5),(1109,1824937200,6),(1109,1837468800,5),(1109,1856386800,6),(1109,1868918400,5),(1109,1887836400,6),(1109,1900972800,5),(1109,1919286000,6),(1109,1932422400,5),(1109,1950735600,6),(1109,1963872000,5),(1109,1982790000,6),(1109,1995321600,5),(1109,2014239600,6),(1109,2026771200,5),(1109,2045689200,6),(1109,2058220800,5),(1109,2077138800,6),(1109,2090275200,5),(1109,2108588400,6),(1109,2121724800,5),(1109,2140038000,6),(1110,-2147483648,1),(1110,-1827687170,2),(1110,126687600,3),(1110,152085600,2),(1110,162370800,3),(1110,183535200,2),(1110,199263600,3),(1110,215589600,2),(1110,230713200,3),(1110,247039200,2),(1110,262767600,3),(1110,278488800,2),(1110,294217200,3),(1110,309938400,2),(1110,325666800,3),(1110,341388000,2),(1110,357116400,3),(1110,372837600,2),(1110,388566000,3),(1110,404892000,2),(1110,420015600,3),(1110,436341600,2),(1111,-2147483648,3),(1111,-683802000,1),(1111,-672310800,2),(1111,-654771600,1),(1111,-640861200,2),(1111,-620298000,1),(1111,-609411600,2),(1111,-588848400,1),(1111,-577962000,2),(1112,-2147483648,1),(1112,-1041418800,2),(1112,-907408800,3),(1112,-817462800,1),(1112,-7988400,4),(1112,745934400,5),(1112,2147483647,5),(1113,-2147483648,0),(1113,-1577926364,2),(1113,-574902000,1),(1113,-568087200,2),(1113,-512175600,1),(1113,-504928800,2),(1113,-449888400,1),(1113,-441856800,2),(1113,-347158800,3),(1113,378684000,2),(1113,386463600,1),(1113,402271200,2),(1113,417999600,1),(1113,433807200,2),(1113,449622000,1),(1113,465429600,2),(1113,481590000,1),(1113,496965600,2),(1113,512953200,1),(1113,528674400,2),(1113,544230000,1),(1113,560037600,2),(1113,575852400,1),(1113,591660000,2),(1113,607388400,1),(1113,623196000,2),(1113,641775600,3),(1113,844034400,2),(1113,860108400,1),(1113,875916000,3),(1113,1352505600,2),(1113,1364515200,1),(1113,1382659200,3),(1114,-1693706400,0),(1114,-1680483600,1),(1114,-1663455600,2),(1114,-1650150000,3),(1114,-1632006000,2),(1114,-1618700400,3),(1114,-938905200,2),(1114,-857257200,3),(1114,-844556400,2),(1114,-828226800,3),(1114,-812502000,2),(1114,-796777200,3),(1114,-781052400,2),(1114,-766623600,3),(1114,228877200,2),(1114,243997200,3),(1114,260326800,2),(1114,276051600,3),(1114,291776400,2),(1114,307501200,3),(1114,323830800,2),(1114,338950800,3),(1114,354675600,2),(1114,370400400,3),(1114,386125200,2),(1114,401850000,3),(1114,417574800,2),(1114,433299600,3),(1114,449024400,2),(1114,465354000,3),(1114,481078800,2),(1114,496803600,3),(1114,512528400,2),(1114,528253200,3),(1114,543978000,2),(1114,559702800,3),(1114,575427600,2),(1114,591152400,3),(1114,606877200,2),(1114,622602000,3),(1114,638326800,2),(1114,654656400,3),(1114,670381200,2),(1114,686106000,3),(1114,701830800,2),(1114,717555600,3),(1114,733280400,2),(1114,749005200,3),(1114,764730000,2),(1114,780454800,3),(1114,796179600,2),(1114,811904400,3),(1114,828234000,2),(1114,846378000,3),(1114,859683600,2),(1114,877827600,3),(1114,891133200,2),(1114,909277200,3),(1114,922582800,2),(1114,941331600,3),(1114,954032400,2),(1114,972781200,3),(1114,985482000,2),(1114,1004230800,3),(1114,1017536400,2),(1114,1035680400,3),(1114,1048986000,2),(1114,1067130000,3),(1114,1080435600,2),(1114,1099184400,3),(1114,1111885200,2),(1114,1130634000,3),(1114,1143334800,2),(1114,1162083600,3),(1114,1174784400,2),(1114,1193533200,3),(1114,1206838800,2),(1114,1224982800,3),(1114,1238288400,2),(1114,1256432400,3),(1114,1269738000,2),(1114,1288486800,3),(1114,1301187600,2),(1114,1319936400,3),(1114,1332637200,2),(1114,1351386000,3),(1114,1364691600,2),(1114,1382835600,3),(1114,1396141200,2),(1114,1414285200,3),(1114,1427590800,2),(1114,1445734800,3),(1114,1459040400,2),(1114,1477789200,3),(1114,1490490000,2),(1114,1509238800,3),(1114,1521939600,2),(1114,1540688400,3),(1114,1553994000,2),(1114,1572138000,3),(1114,1585443600,2),(1114,1603587600,3),(1114,1616893200,2),(1114,1635642000,3),(1114,1648342800,2),(1114,1667091600,3),(1114,1679792400,2),(1114,1698541200,3),(1114,1711846800,2),(1114,1729990800,3),(1114,1743296400,2),(1114,1761440400,3),(1114,1774746000,2),(1114,1792890000,3),(1114,1806195600,2),(1114,1824944400,3),(1114,1837645200,2),(1114,1856394000,3),(1114,1869094800,2),(1114,1887843600,3),(1114,1901149200,2),(1114,1919293200,3),(1114,1932598800,2),(1114,1950742800,3),(1114,1964048400,2),(1114,1982797200,3),(1114,1995498000,2),(1114,2014246800,3),(1114,2026947600,2),(1114,2045696400,3),(1114,2058397200,2),(1114,2077146000,3),(1114,2090451600,2),(1114,2108595600,3),(1114,2121901200,2),(1114,2140045200,3),(1116,-1633273200,0),(1116,-1615132800,1),(1116,-1601823600,0),(1116,-1583683200,1),(1116,-880210800,2),(1116,-769395600,3),(1116,-765388800,1),(1116,-84380400,0),(1116,-68659200,1),(1116,-52930800,0),(1116,-37209600,1),(1116,-21481200,0),(1116,-5760000,1),(1116,9968400,0),(1116,25689600,1),(1116,41418000,0),(1116,57744000,1),(1116,73472400,0),(1116,89193600,1),(1116,104922000,0),(1116,120643200,1),(1116,126694800,0),(1116,152092800,1),(1116,162378000,0),(1116,183542400,1),(1116,199270800,0),(1116,215596800,1),(1116,230720400,0),(1116,247046400,1),(1116,262774800,0),(1116,278496000,1),(1116,294224400,0),(1116,309945600,1),(1116,325674000,0),(1116,341395200,1),(1116,357123600,0),(1116,372844800,1),(1116,388573200,0),(1116,404899200,1),(1116,420022800,0),(1116,436348800,1),(1116,452077200,0),(1116,467798400,1),(1116,483526800,0),(1116,499248000,1),(1116,514976400,0),(1116,530697600,1),(1116,544611600,0),(1116,562147200,1),(1116,576061200,0),(1116,594201600,1),(1116,607510800,0),(1116,625651200,1),(1116,638960400,0),(1116,657100800,1),(1116,671014800,0),(1116,688550400,1),(1116,702464400,0),(1116,720000000,1),(1116,733914000,0),(1116,752054400,1),(1116,765363600,0),(1116,783504000,1),(1116,796813200,0),(1116,814953600,1),(1116,828867600,0),(1116,846403200,1),(1116,860317200,0),(1116,877852800,1),(1116,891766800,0),(1116,909302400,1),(1116,923216400,0),(1116,941356800,1),(1116,954666000,0),(1116,972806400,1),(1116,986115600,0),(1116,1004256000,1),(1116,1018170000,0),(1116,1035705600,1),(1116,1049619600,0),(1116,1067155200,1),(1116,1081069200,0),(1116,1099209600,1),(1116,1112518800,0),(1116,1130659200,1),(1116,1143968400,0),(1116,1162108800,1),(1116,1173603600,0),(1116,1194163200,1),(1116,1205053200,0),(1116,1225612800,1),(1116,1236502800,0),(1116,1257062400,1),(1116,1268557200,0),(1116,1289116800,1),(1116,1300006800,0),(1116,1320566400,1),(1116,1331456400,0),(1116,1352016000,1),(1116,1362906000,0),(1116,1383465600,1),(1116,1394355600,0),(1116,1414915200,1),(1116,1425805200,0),(1116,1446364800,1),(1116,1457859600,0),(1116,1478419200,1),(1116,1489309200,0),(1116,1509868800,1),(1116,1520758800,0),(1116,1541318400,1),(1116,1552208400,0),(1116,1572768000,1),(1116,1583658000,0),(1116,1604217600,1),(1116,1615712400,0),(1116,1636272000,1),(1116,1647162000,0),(1116,1667721600,1),(1116,1678611600,0),(1116,1699171200,1),(1116,1710061200,0),(1116,1730620800,1),(1116,1741510800,0),(1116,1762070400,1),(1116,1772960400,0),(1116,1793520000,1),(1116,1805014800,0),(1116,1825574400,1),(1116,1836464400,0),(1116,1857024000,1),(1116,1867914000,0),(1116,1888473600,1),(1116,1899363600,0),(1116,1919923200,1),(1116,1930813200,0),(1116,1951372800,1),(1116,1962867600,0),(1116,1983427200,1),(1116,1994317200,0),(1116,2014876800,1),(1116,2025766800,0),(1116,2046326400,1),(1116,2057216400,0),(1116,2077776000,1),(1116,2088666000,0),(1116,2109225600,1),(1116,2120115600,0),(1116,2140675200,1),(1117,-2147483648,0),(1117,-1514739600,1),(1117,-1451667600,2),(1117,-1343062800,3),(1117,-1234803600,2),(1117,-1222963200,4),(1117,-1207242000,2),(1117,-873820800,5),(1117,-769395600,6),(1117,-761677200,2),(1117,-686073600,4),(1117,-661539600,2),(1117,-495039600,4),(1117,-481734000,2),(1117,-463590000,4),(1117,-450284400,2),(1117,-431535600,4),(1117,-418230000,2),(1117,-400086000,4),(1117,-386780400,2),(1117,-368636400,4),(1117,-355330800,2),(1117,-337186800,4),(1117,-323881200,2),(1117,-305737200,4),(1117,-292431600,2),(1117,199274400,4),(1117,215600400,2),(1117,230724000,4),(1117,247050000,2),(1117,262778400,4),(1117,278499600,2),(1117,294228000,4),(1117,309949200,2),(1117,325677600,4),(1117,341398800,2),(1117,357127200,4),(1117,372848400,2),(1117,388576800,4),(1117,404902800,2),(1117,420026400,4),(1117,436352400,2),(1117,452080800,4),(1117,467802000,2),(1117,483530400,4),(1117,499251600,2),(1117,514980000,4),(1117,530701200,2),(1117,544615200,4),(1117,562150800,2),(1117,576064800,4),(1117,594205200,2),(1117,607514400,4),(1117,625654800,2),(1117,638964000,4),(1117,657104400,2),(1117,671018400,4),(1117,688554000,2),(1117,702468000,4),(1117,720003600,2),(1117,733917600,4),(1117,752058000,2),(1117,765367200,4),(1117,783507600,2),(1117,796816800,4),(1117,814957200,2),(1117,828871200,4),(1117,846406800,2),(1117,860320800,4),(1117,877856400,2),(1117,891770400,4),(1117,909306000,2),(1117,923220000,4),(1117,941360400,2),(1117,954669600,4),(1117,972810000,2),(1117,986119200,4),(1117,1004259600,2),(1117,1018173600,4),(1117,1035709200,2),(1117,1049623200,4),(1117,1067158800,2),(1117,1081072800,4),(1117,1099213200,2),(1117,1112522400,4),(1117,1130662800,2),(1117,1143972000,4),(1117,1162112400,2),(1117,1175421600,4),(1117,1193562000,2),(1117,1207476000,4),(1117,1225011600,2),(1117,1238925600,4),(1117,1256461200,2),(1117,1268560800,4),(1117,1289120400,2),(1117,1300010400,4),(1117,1320570000,2),(1117,1331460000,4),(1117,1352019600,2),(1117,1362909600,4),(1117,1383469200,2),(1117,1394359200,4),(1117,1414918800,2),(1117,1425808800,4),(1117,1446368400,2),(1117,1457863200,4),(1117,1478422800,2),(1117,1489312800,4),(1117,1509872400,2),(1117,1520762400,4),(1117,1541322000,2),(1117,1552212000,4),(1117,1572771600,2),(1117,1583661600,4),(1117,1604221200,2),(1117,1615716000,4),(1117,1636275600,2),(1117,1647165600,4),(1117,1667725200,2),(1117,1678615200,4),(1117,1699174800,2),(1117,1710064800,4),(1117,1730624400,2),(1117,1741514400,4),(1117,1762074000,2),(1117,1772964000,4),(1117,1793523600,2),(1117,1805018400,4),(1117,1825578000,2),(1117,1836468000,4),(1117,1857027600,2),(1117,1867917600,4),(1117,1888477200,2),(1117,1899367200,4),(1117,1919926800,2),(1117,1930816800,4),(1117,1951376400,2),(1117,1962871200,4),(1117,1983430800,2),(1117,1994320800,4),(1117,2014880400,2),(1117,2025770400,4),(1117,2046330000,2),(1117,2057220000,4),(1117,2077779600,2),(1117,2088669600,4),(1117,2109229200,2),(1117,2120119200,4),(1117,2140678800,2),(1118,-2147483648,0),(1118,-1514739600,1),(1118,-1343066400,2),(1118,-1234807200,4),(1118,-1220292000,3),(1118,-1207159200,4),(1118,-1191344400,2),(1118,-873828000,4),(1118,-661539600,5),(1118,28800,4),(1118,828867600,3),(1118,846403200,4),(1118,860317200,3),(1118,877852800,4),(1118,891766800,3),(1118,909302400,4),(1118,923216400,3),(1118,941356800,4),(1118,954666000,3),(1118,972806400,4),(1118,989139600,3),(1118,1001836800,4),(1118,1018170000,3),(1118,1035705600,4),(1118,1049619600,3),(1118,1067155200,4),(1118,1081069200,3),(1118,1099209600,4),(1118,1112518800,3),(1118,1130659200,4),(1118,1143968400,3),(1118,1162108800,4),(1118,1175418000,3),(1118,1193558400,4),(1118,1207472400,3),(1118,1225008000,4),(1118,1238922000,3),(1118,1256457600,4),(1118,1270371600,3),(1118,1288512000,4),(1118,1301821200,3),(1118,1319961600,4),(1118,1333270800,3),(1118,1351411200,4),(1118,1365325200,3),(1118,1382860800,4),(1118,1396774800,3),(1118,1414310400,4),(1118,1428224400,3),(1118,1445760000,4),(1118,1459674000,3),(1118,1477814400,4),(1118,1491123600,3),(1118,1509264000,4),(1118,1522573200,3),(1118,1540713600,4),(1118,1554627600,3),(1118,1572163200,4),(1118,1586077200,3),(1118,1603612800,4),(1118,1617526800,3),(1118,1635667200,4),(1118,1648976400,3),(1118,1667116800,4),(1119,-2147483648,0),(1119,-1514739600,1),(1119,-1343066400,2),(1119,-1234807200,4),(1119,-1220292000,3),(1119,-1207159200,4),(1119,-1191344400,2),(1119,-975261600,5),(1119,-963169200,2),(1119,-917114400,5),(1119,-907354800,2),(1119,-821901600,6),(1119,-810068400,2),(1119,-627501600,5),(1119,-612990000,2),(1119,828864000,5),(1119,846399600,2),(1119,860313600,5),(1119,877849200,2),(1119,891763200,5),(1119,909298800,2),(1119,923212800,5),(1119,941353200,2),(1119,954662400,5),(1119,972802800,2),(1119,989136000,5),(1119,1001833200,2),(1119,1018166400,5),(1119,1035702000,2),(1119,1049616000,5),(1119,1067151600,2),(1119,1081065600,5),(1119,1099206000,2),(1119,1112515200,5),(1119,1130655600,2),(1119,1143964800,5),(1119,1162105200,2),(1119,1175414400,5),(1119,1193554800,2),(1119,1207468800,5),(1119,1225004400,2),(1119,1238918400,5),(1119,1256454000,2),(1119,1270368000,5),(1119,1288508400,2),(1119,1301817600,5),(1119,1319958000,2),(1119,1333267200,5),(1119,1351407600,2),(1119,1365321600,5),(1119,1382857200,2),(1119,1396771200,5),(1119,1414306800,2),(1119,1428220800,5),(1119,1445756400,2),(1119,1459670400,5),(1119,1477810800,2),(1119,1491120000,5),(1119,1509260400,2),(1119,1522569600,5),(1119,1540710000,2),(1119,1554624000,5),(1119,1572159600,2),(1119,1586073600,5),(1119,1603609200,2),(1119,1617523200,5),(1119,1635663600,2),(1119,1648972800,5),(1119,1667113200,2),(1120,-2147483648,2),(1120,-1330335000,1),(1120,-1320057000,2),(1120,-1300699800,3),(1120,-1287396000,2),(1120,-1269250200,3),(1120,-1255946400,2),(1120,-1237800600,3),(1120,-1224496800,2),(1120,-1206351000,3),(1120,-1192442400,2),(1120,-1174901400,3),(1120,-1160992800,2),(1120,-1143451800,3),(1120,-1125914400,2),(1120,-1112607000,3),(1120,-1094464800,2),(1120,-1081157400,3),(1120,-1063015200,2),(1120,-1049707800,3),(1120,-1031565600,2),(1120,-1018258200,3),(1120,-1000116000,2),(1120,-986808600,3),(1120,-968061600,2),(1120,-955359000,3),(1120,-936612000,2),(1120,-923304600,3),(1120,-757425600,6),(1120,152632800,4),(1120,162309600,5),(1120,183477600,4),(1120,194968800,5),(1120,215532000,4),(1120,226418400,5),(1120,246981600,4),(1120,257868000,5),(1120,278431200,4),(1120,289317600,5),(1120,309880800,4),(1120,320767200,5),(1120,341330400,4),(1120,352216800,5),(1120,372780000,4),(1120,384271200,5),(1120,404834400,4),(1120,415720800,5),(1120,436284000,4),(1120,447170400,5),(1120,467733600,4),(1120,478620000,5),(1120,499183200,4),(1120,510069600,5),(1120,530632800,4),(1120,541519200,5),(1120,562082400,4),(1120,573573600,5),(1120,594136800,4),(1120,605023200,5),(1120,623772000,4),(1120,637682400,5),(1120,655221600,4),(1120,669132000,5),(1120,686671200,4),(1120,700581600,5),(1120,718120800,4),(1120,732636000,5),(1120,749570400,4),(1120,764085600,5),(1120,781020000,4),(1120,795535200,5),(1120,812469600,4),(1120,826984800,5),(1120,844524000,4),(1120,858434400,5),(1120,875973600,4),(1120,889884000,5),(1120,907423200,4),(1120,921938400,5),(1120,938872800,4),(1120,953388000,5),(1120,970322400,4),(1120,984837600,5),(1120,1002376800,4),(1120,1016287200,5),(1120,1033826400,4),(1120,1047736800,5),(1120,1065276000,4),(1120,1079791200,5),(1120,1096725600,4),(1120,1111240800,5),(1120,1128175200,4),(1120,1142690400,5),(1120,1159624800,4),(1120,1174140000,5),(1120,1191074400,4),(1120,1207404000,5),(1120,1222524000,4),(1120,1238853600,5),(1120,1253973600,4),(1120,1270303200,5),(1120,1285423200,4),(1120,1301752800,5),(1120,1316872800,4),(1120,1333202400,5),(1120,1348927200,4),(1120,1365256800,5),(1120,1380376800,4),(1120,1396706400,5),(1120,1411826400,4),(1120,1428156000,5),(1120,1443276000,4),(1120,1459605600,5),(1120,1474725600,4),(1120,1491055200,5),(1120,1506175200,4),(1120,1522504800,5),(1120,1538229600,4),(1120,1554559200,5),(1120,1569679200,4),(1120,1586008800,5),(1120,1601128800,4),(1120,1617458400,5),(1120,1632578400,4),(1120,1648908000,5),(1120,1664028000,4),(1120,1680357600,5),(1120,1695477600,4),(1120,1712412000,5),(1120,1727532000,4),(1120,1743861600,5),(1120,1758981600,4),(1120,1775311200,5),(1120,1790431200,4),(1120,1806760800,5),(1120,1821880800,4),(1120,1838210400,5),(1120,1853330400,4),(1120,1869660000,5),(1120,1885384800,4),(1120,1901714400,5),(1120,1916834400,4),(1120,1933164000,5),(1120,1948284000,4),(1120,1964613600,5),(1120,1979733600,4),(1120,1996063200,5),(1120,2011183200,4),(1120,2027512800,5),(1120,2042632800,4),(1120,2058962400,5),(1120,2074687200,4),(1120,2091016800,5),(1120,2106136800,4),(1120,2122466400,5),(1120,2137586400,4),(1121,-2147483648,1),(1121,-757426500,4),(1121,152632800,2),(1121,162309600,3),(1121,183477600,2),(1121,194968800,3),(1121,215532000,2),(1121,226418400,3),(1121,246981600,2),(1121,257868000,3),(1121,278431200,2),(1121,289317600,3),(1121,309880800,2),(1121,320767200,3),(1121,341330400,2),(1121,352216800,3),(1121,372780000,2),(1121,384271200,3),(1121,404834400,2),(1121,415720800,3),(1121,436284000,2),(1121,447170400,3),(1121,467733600,2),(1121,478620000,3),(1121,499183200,2),(1121,510069600,3),(1121,530632800,2),(1121,541519200,3),(1121,562082400,2),(1121,573573600,3),(1121,594136800,2),(1121,605023200,3),(1121,623772000,2),(1121,637682400,3),(1121,655221600,2),(1121,669132000,3),(1121,686671200,2),(1121,700581600,3),(1121,718120800,2),(1121,732636000,3),(1121,749570400,2),(1121,764085600,3),(1121,781020000,2),(1121,795535200,3),(1121,812469600,2),(1121,826984800,3),(1121,844524000,2),(1121,858434400,3),(1121,875973600,2),(1121,889884000,3),(1121,907423200,2),(1121,921938400,3),(1121,938872800,2),(1121,953388000,3),(1121,970322400,2),(1121,984837600,3),(1121,1002376800,2),(1121,1016287200,3),(1121,1033826400,2),(1121,1047736800,3),(1121,1065276000,2),(1121,1079791200,3),(1121,1096725600,2),(1121,1111240800,3),(1121,1128175200,2),(1121,1142690400,3),(1121,1159624800,2),(1121,1174140000,3),(1121,1191074400,2),(1121,1207404000,3),(1121,1222524000,2),(1121,1238853600,3),(1121,1253973600,2),(1121,1270303200,3),(1121,1285423200,2),(1121,1301752800,3),(1121,1316872800,2),(1121,1333202400,3),(1121,1348927200,2),(1121,1365256800,3),(1121,1380376800,2),(1121,1396706400,3),(1121,1411826400,2),(1121,1428156000,3),(1121,1443276000,2),(1121,1459605600,3),(1121,1474725600,2),(1121,1491055200,3),(1121,1506175200,2),(1121,1522504800,3),(1121,1538229600,2),(1121,1554559200,3),(1121,1569679200,2),(1121,1586008800,3),(1121,1601128800,2),(1121,1617458400,3),(1121,1632578400,2),(1121,1648908000,3),(1121,1664028000,2),(1121,1680357600,3),(1121,1695477600,2),(1121,1712412000,3),(1121,1727532000,2),(1121,1743861600,3),(1121,1758981600,2),(1121,1775311200,3),(1121,1790431200,2),(1121,1806760800,3),(1121,1821880800,2),(1121,1838210400,3),(1121,1853330400,2),(1121,1869660000,3),(1121,1885384800,2),(1121,1901714400,3),(1121,1916834400,2),(1121,1933164000,3),(1121,1948284000,2),(1121,1964613600,3),(1121,1979733600,2),(1121,1996063200,3),(1121,2011183200,2),(1121,2027512800,3),(1121,2042632800,2),(1121,2058962400,3),(1121,2074687200,2),(1121,2091016800,3),(1121,2106136800,2),(1121,2122466400,3),(1121,2137586400,2),(1121,2147483647,2),(1122,-2147483648,3),(1122,-1633273200,1),(1122,-1615132800,2),(1122,-1601823600,1),(1122,-1583683200,2),(1122,-1570374000,1),(1122,-1551628800,2),(1122,-1538924400,1),(1122,-1534089600,2),(1122,-880210800,4),(1122,-769395600,5),(1122,-765388800,2),(1122,-147884400,1),(1122,-131558400,2),(1122,-116434800,1),(1122,-100108800,2),(1122,-84380400,1),(1122,-68659200,2),(1122,-52930800,1),(1122,-37209600,2),(1122,-21481200,1),(1122,-5760000,2),(1122,9968400,1),(1122,25689600,2),(1122,41418000,1),(1122,57744000,2),(1122,73472400,1),(1122,89193600,2),(1122,104922000,1),(1122,120643200,2),(1122,126694800,1),(1122,152092800,2),(1122,162378000,1),(1122,183542400,2),(1122,199270800,1),(1122,215596800,2),(1122,230720400,1),(1122,247046400,2),(1122,262774800,1),(1122,278496000,2),(1122,294224400,1),(1122,309945600,2),(1122,325674000,1),(1122,341395200,2),(1122,357123600,1),(1122,372844800,2),(1122,388573200,1),(1122,404899200,2),(1122,420022800,1),(1122,436348800,2),(1122,452077200,1),(1122,467798400,2),(1122,483526800,1),(1122,499248000,2),(1122,514976400,1),(1122,530697600,2),(1122,544611600,1),(1122,562147200,2),(1122,576061200,1),(1122,594201600,2),(1122,607510800,1),(1122,625651200,2),(1122,638960400,1),(1122,657100800,2),(1122,671014800,1),(1122,688550400,2),(1122,702464400,1),(1122,720000000,2),(1122,733914000,1),(1122,752054400,2),(1122,765363600,1),(1122,783504000,2),(1122,796813200,1),(1122,814953600,2),(1122,828867600,1),(1122,846403200,2),(1122,860317200,1),(1122,877852800,2),(1122,891766800,1),(1122,909302400,2),(1122,923216400,1),(1122,941356800,2),(1122,954666000,1),(1122,972806400,2),(1122,986115600,1),(1122,1004256000,2),(1122,1018170000,1),(1122,1035705600,2),(1122,1049619600,1),(1122,1067155200,2),(1122,1081069200,1),(1122,1099209600,2),(1122,1112518800,1),(1122,1130659200,2),(1122,1143968400,1),(1122,1162108800,2),(1122,1173603600,1),(1122,1194163200,2),(1122,1205053200,1),(1122,1225612800,2),(1122,1236502800,1),(1122,1257062400,2),(1122,1268557200,1),(1122,1289116800,2),(1122,1300006800,1),(1122,1320566400,2),(1122,1331456400,1),(1122,1352016000,2),(1122,1362906000,1),(1122,1383465600,2),(1122,1394355600,1),(1122,1414915200,2),(1122,1425805200,1),(1122,1446364800,2),(1122,1457859600,1),(1122,1478419200,2),(1122,1489309200,1),(1122,1509868800,2),(1122,1520758800,1),(1122,1541318400,2),(1122,1552208400,1),(1122,1572768000,2),(1122,1583658000,1),(1122,1604217600,2),(1122,1615712400,1),(1122,1636272000,2),(1122,1647162000,1),(1122,1667721600,2),(1122,1678611600,1),(1122,1699171200,2),(1122,1710061200,1),(1122,1730620800,2),(1122,1741510800,1),(1122,1762070400,2),(1122,1772960400,1),(1122,1793520000,2),(1122,1805014800,1),(1122,1825574400,2),(1122,1836464400,1),(1122,1857024000,2),(1122,1867914000,1),(1122,1888473600,2),(1122,1899363600,1),(1122,1919923200,2),(1122,1930813200,1),(1122,1951372800,2),(1122,1962867600,1),(1122,1983427200,2),(1122,1994317200,1),(1122,2014876800,2),(1122,2025766800,1),(1122,2046326400,2),(1122,2057216400,1),(1122,2077776000,2),(1122,2088666000,1),(1122,2109225600,2),(1122,2120115600,1),(1122,2140675200,2),(1123,-2147483648,2),(1123,-1600675200,1),(1123,-1585904400,2),(1123,-933667200,1),(1123,-922093200,2),(1123,-908870400,1),(1123,-888829200,2),(1123,-881049600,1),(1123,-767869200,2),(1123,-745833600,1),(1123,-733827600,2),(1123,-716889600,1),(1123,-699613200,2),(1123,-683884800,1),(1123,-670669200,2),(1123,-652348800,1),(1123,-650019600,2),(1123,515527200,1),(1123,527014800,2),(1123,545162400,1),(1123,558464400,2),(1123,577216800,1),(1123,589914000,2),(1123,608666400,1),(1123,621968400,2),(1123,640116000,1),(1123,653418000,2),(1123,671565600,1),(1123,684867600,2),(1124,-1633269600,0),(1124,-1615129200,1),(1124,-1601820000,0),(1124,-1583679600,1),(1124,-880207200,2),(1124,-769395600,3),(1124,-765385200,1),(1124,-84376800,0),(1124,-68655600,1),(1124,-52927200,0),(1124,-37206000,1),(1124,-21477600,0),(1124,-5756400,1),(1124,9972000,0),(1124,25693200,1),(1124,41421600,0),(1124,57747600,1),(1124,73476000,0),(1124,89197200,1),(1124,104925600,0),(1124,120646800,1),(1124,126698400,0),(1124,152096400,1),(1124,162381600,0),(1124,183546000,1),(1124,199274400,0),(1124,215600400,1),(1124,230724000,0),(1124,247050000,1),(1124,262778400,0),(1124,278499600,1),(1124,294228000,0),(1124,309949200,1),(1124,325677600,0),(1124,341398800,1),(1124,357127200,0),(1124,372848400,1),(1124,388576800,0),(1124,404902800,1),(1124,420026400,0),(1124,436352400,1),(1124,452080800,0),(1124,467802000,1),(1124,483530400,0),(1124,499251600,1),(1124,514980000,0),(1124,530701200,1),(1124,544615200,0),(1124,562150800,1),(1124,576064800,0),(1124,594205200,1),(1124,607514400,0),(1124,625654800,1),(1124,638964000,0),(1124,657104400,1),(1124,671018400,0),(1124,688554000,1),(1124,702468000,0),(1124,720003600,1),(1124,733917600,0),(1124,752058000,1),(1124,765367200,0),(1124,783507600,1),(1124,796816800,0),(1124,814957200,1),(1124,828871200,0),(1124,846406800,1),(1124,860320800,0),(1124,877856400,1),(1124,891770400,0),(1124,909306000,1),(1124,923220000,0),(1124,941360400,1),(1124,954669600,0),(1124,972810000,1),(1124,986119200,0),(1124,1004259600,1),(1124,1018173600,0),(1124,1035709200,1),(1124,1049623200,0),(1124,1067158800,1),(1124,1081072800,0),(1124,1099213200,1),(1124,1112522400,0),(1124,1130662800,1),(1124,1143972000,0),(1124,1162112400,1),(1124,1173607200,0),(1124,1194166800,1),(1124,1205056800,0),(1124,1225616400,1),(1124,1236506400,0),(1124,1257066000,1),(1124,1268560800,0),(1124,1289120400,1),(1124,1300010400,0),(1124,1320570000,1),(1124,1331460000,0),(1124,1352019600,1),(1124,1362909600,0),(1124,1383469200,1),(1124,1394359200,0),(1124,1414918800,1),(1124,1425808800,0),(1124,1446368400,1),(1124,1457863200,0),(1124,1478422800,1),(1124,1489312800,0),(1124,1509872400,1),(1124,1520762400,0),(1124,1541322000,1),(1124,1552212000,0),(1124,1572771600,1),(1124,1583661600,0),(1124,1604221200,1),(1124,1615716000,0),(1124,1636275600,1),(1124,1647165600,0),(1124,1667725200,1),(1124,1678615200,0),(1124,1699174800,1),(1124,1710064800,0),(1124,1730624400,1),(1124,1741514400,0),(1124,1762074000,1),(1124,1772964000,0),(1124,1793523600,1),(1124,1805018400,0),(1124,1825578000,1),(1124,1836468000,0),(1124,1857027600,1),(1124,1867917600,0),(1124,1888477200,1),(1124,1899367200,0),(1124,1919926800,1),(1124,1930816800,0),(1124,1951376400,1),(1124,1962871200,0),(1124,1983430800,1),(1124,1994320800,0),(1124,2014880400,1),(1124,2025770400,0),(1124,2046330000,1),(1124,2057220000,0),(1124,2077779600,1),(1124,2088669600,0),(1124,2109229200,1),(1124,2120119200,0),(1124,2140678800,1),(1125,-2147483648,1),(1125,-1861878784,2),(1125,-631110600,4),(1125,1285498800,3),(1125,1301752800,4),(1125,1316872800,3),(1125,1325239200,6),(1125,1333202400,5),(1125,1348927200,6),(1125,1365256800,5),(1125,1380376800,6),(1125,1396706400,5),(1125,1411826400,6),(1125,1428156000,5),(1125,1443276000,6),(1125,1459605600,5),(1125,1474725600,6),(1125,1491055200,5),(1125,1506175200,6),(1125,1522504800,5),(1125,1538229600,6),(1125,1554559200,5),(1125,1569679200,6),(1125,1586008800,5),(1125,1601128800,6),(1125,1617458400,5),(1125,2147483647,5),(1126,-2147483648,2),(1126,-1330335000,1),(1126,-1320057000,2),(1126,-1300699800,3),(1126,-1287396000,2),(1126,-1269250200,3),(1126,-1255946400,2),(1126,-1237800600,3),(1126,-1224496800,2),(1126,-1206351000,3),(1126,-1192442400,2),(1126,-1174901400,3),(1126,-1160992800,2),(1126,-1143451800,3),(1126,-1125914400,2),(1126,-1112607000,3),(1126,-1094464800,2),(1126,-1081157400,3),(1126,-1063015200,2),(1126,-1049707800,3),(1126,-1031565600,2),(1126,-1018258200,3),(1126,-1000116000,2),(1126,-986808600,3),(1126,-968061600,2),(1126,-955359000,3),(1126,-936612000,2),(1126,-923304600,3),(1126,-757425600,6),(1126,152632800,4),(1126,162309600,5),(1126,183477600,4),(1126,194968800,5),(1126,215532000,4),(1126,226418400,5),(1126,246981600,4),(1126,257868000,5),(1126,278431200,4),(1126,289317600,5),(1126,309880800,4),(1126,320767200,5),(1126,341330400,4),(1126,352216800,5),(1126,372780000,4),(1126,384271200,5),(1126,404834400,4),(1126,415720800,5),(1126,436284000,4),(1126,447170400,5),(1126,467733600,4),(1126,478620000,5),(1126,499183200,4),(1126,510069600,5),(1126,530632800,4),(1126,541519200,5),(1126,562082400,4),(1126,573573600,5),(1126,594136800,4),(1126,605023200,5),(1126,623772000,4),(1126,637682400,5),(1126,655221600,4),(1126,669132000,5),(1126,686671200,4),(1126,700581600,5),(1126,718120800,4),(1126,732636000,5),(1126,749570400,4),(1126,764085600,5),(1126,781020000,4),(1126,795535200,5),(1126,812469600,4),(1126,826984800,5),(1126,844524000,4),(1126,858434400,5),(1126,875973600,4),(1126,889884000,5),(1126,907423200,4),(1126,921938400,5),(1126,938872800,4),(1126,953388000,5),(1126,970322400,4),(1126,984837600,5),(1126,1002376800,4),(1126,1016287200,5),(1126,1033826400,4),(1126,1047736800,5),(1126,1065276000,4),(1126,1079791200,5),(1126,1096725600,4),(1126,1111240800,5),(1126,1128175200,4),(1126,1142690400,5),(1126,1159624800,4),(1126,1174140000,5),(1126,1191074400,4),(1126,1207404000,5),(1126,1222524000,4),(1126,1238853600,5),(1126,1253973600,4),(1126,1270303200,5),(1126,1285423200,4),(1126,1301752800,5),(1126,1316872800,4),(1126,1333202400,5),(1126,1348927200,4),(1126,1365256800,5),(1126,1380376800,4),(1126,1396706400,5),(1126,1411826400,4),(1126,1428156000,5),(1126,1443276000,4),(1126,1459605600,5),(1126,1474725600,4),(1126,1491055200,5),(1126,1506175200,4),(1126,1522504800,5),(1126,1538229600,4),(1126,1554559200,5),(1126,1569679200,4),(1126,1586008800,5),(1126,1601128800,4),(1126,1617458400,5),(1126,1632578400,4),(1126,1648908000,5),(1126,1664028000,4),(1126,1680357600,5),(1126,1695477600,4),(1126,1712412000,5),(1126,1727532000,4),(1126,1743861600,5),(1126,1758981600,4),(1126,1775311200,5),(1126,1790431200,4),(1126,1806760800,5),(1126,1821880800,4),(1126,1838210400,5),(1126,1853330400,4),(1126,1869660000,5),(1126,1885384800,4),(1126,1901714400,5),(1126,1916834400,4),(1126,1933164000,5),(1126,1948284000,4),(1126,1964613600,5),(1126,1979733600,4),(1126,1996063200,5),(1126,2011183200,4),(1126,2027512800,5),(1126,2042632800,4),(1126,2058962400,5),(1126,2074687200,4),(1126,2091016800,5),(1126,2106136800,4),(1126,2122466400,5),(1126,2137586400,4),(1127,-2147483648,1),(1127,-868010400,2),(1127,-768906000,1),(1127,1419696000,3),(1127,2147483647,3),(1128,-2147483648,1),(1128,-757426500,4),(1128,152632800,2),(1128,162309600,3),(1128,183477600,2),(1128,194968800,3),(1128,215532000,2),(1128,226418400,3),(1128,246981600,2),(1128,257868000,3),(1128,278431200,2),(1128,289317600,3),(1128,309880800,2),(1128,320767200,3),(1128,341330400,2),(1128,352216800,3),(1128,372780000,2),(1128,384271200,3),(1128,404834400,2),(1128,415720800,3),(1128,436284000,2),(1128,447170400,3),(1128,467733600,2),(1128,478620000,3),(1128,499183200,2),(1128,510069600,3),(1128,530632800,2),(1128,541519200,3),(1128,562082400,2),(1128,573573600,3),(1128,594136800,2),(1128,605023200,3),(1128,623772000,2),(1128,637682400,3),(1128,655221600,2),(1128,669132000,3),(1128,686671200,2),(1128,700581600,3),(1128,718120800,2),(1128,732636000,3),(1128,749570400,2),(1128,764085600,3),(1128,781020000,2),(1128,795535200,3),(1128,812469600,2),(1128,826984800,3),(1128,844524000,2),(1128,858434400,3),(1128,875973600,2),(1128,889884000,3),(1128,907423200,2),(1128,921938400,3),(1128,938872800,2),(1128,953388000,3),(1128,970322400,2),(1128,984837600,3),(1128,1002376800,2),(1128,1016287200,3),(1128,1033826400,2),(1128,1047736800,3),(1128,1065276000,2),(1128,1079791200,3),(1128,1096725600,2),(1128,1111240800,3),(1128,1128175200,2),(1128,1142690400,3),(1128,1159624800,2),(1128,1174140000,3),(1128,1191074400,2),(1128,1207404000,3),(1128,1222524000,2),(1128,1238853600,3),(1128,1253973600,2),(1128,1270303200,3),(1128,1285423200,2),(1128,1301752800,3),(1128,1316872800,2),(1128,1333202400,3),(1128,1348927200,2),(1128,1365256800,3),(1128,1380376800,2),(1128,1396706400,3),(1128,1411826400,2),(1128,1428156000,3),(1128,1443276000,2),(1128,1459605600,3),(1128,1474725600,2),(1128,1491055200,3),(1128,1506175200,2),(1128,1522504800,3),(1128,1538229600,2),(1128,1554559200,3),(1128,1569679200,2),(1128,1586008800,3),(1128,1601128800,2),(1128,1617458400,3),(1128,1632578400,2),(1128,1648908000,3),(1128,1664028000,2),(1128,1680357600,3),(1128,1695477600,2),(1128,1712412000,3),(1128,1727532000,2),(1128,1743861600,3),(1128,1758981600,2),(1128,1775311200,3),(1128,1790431200,2),(1128,1806760800,3),(1128,1821880800,2),(1128,1838210400,3),(1128,1853330400,2),(1128,1869660000,3),(1128,1885384800,2),(1128,1901714400,3),(1128,1916834400,2),(1128,1933164000,3),(1128,1948284000,2),(1128,1964613600,3),(1128,1979733600,2),(1128,1996063200,3),(1128,2011183200,2),(1128,2027512800,3),(1128,2042632800,2),(1128,2058962400,3),(1128,2074687200,2),(1128,2091016800,3),(1128,2106136800,2),(1128,2122466400,3),(1128,2137586400,2),(1128,2147483647,2),(1129,-2147483648,1),(1129,2147483647,1),(1130,-2147483648,1),(1130,-1178124152,4),(1130,-36619200,2),(1130,-23922000,3),(1130,-3355200,2),(1130,7527600,3),(1130,24465600,2),(1130,37767600,3),(1130,55915200,2),(1130,69217200,3),(1130,87969600,2),(1130,100666800,3),(1130,118209600,2),(1130,132116400,3),(1130,150868800,2),(1130,163566000,3),(1130,182318400,2),(1130,195620400,3),(1130,213768000,2),(1130,227070000,3),(1130,245217600,2),(1130,258519600,3),(1130,277272000,2),(1130,289969200,3),(1130,308721600,2),(1130,321418800,3),(1130,340171200,2),(1130,353473200,3),(1130,371620800,2),(1130,384922800,5),(1130,403070400,6),(1130,416372400,5),(1130,434520000,6),(1130,447822000,5),(1130,466574400,6),(1130,479271600,5),(1130,498024000,6),(1130,510721200,5),(1130,529473600,6),(1130,545194800,5),(1130,560923200,6),(1130,574225200,5),(1130,592372800,6),(1130,605674800,5),(1130,624427200,6),(1130,637124400,5),(1130,653457600,6),(1130,668574000,5),(1130,687326400,6),(1130,700628400,5),(1130,718776000,6),(1130,732078000,5),(1130,750225600,6),(1130,763527600,5),(1130,781675200,6),(1130,794977200,5),(1130,813729600,6),(1130,826426800,5),(1130,845179200,6),(1130,859690800,5),(1130,876628800,6),(1130,889930800,5),(1130,906868800,6),(1130,923194800,5),(1130,939528000,6),(1130,952830000,5),(1130,971582400,6),(1130,984279600,5),(1130,1003032000,6),(1130,1015729200,5),(1130,1034481600,6),(1130,1047178800,5),(1130,1065931200,6),(1130,1079233200,5),(1130,1097380800,6),(1130,1110682800,5),(1130,1128830400,6),(1130,1142132400,5),(1130,1160884800,6),(1130,1173582000,5),(1130,1192334400,6),(1130,1206846000,5),(1130,1223784000,6),(1130,1237086000,5),(1130,1255233600,6),(1130,1270350000,5),(1130,1286683200,6),(1130,1304823600,5),(1130,1313899200,6),(1130,1335668400,5),(1130,1346558400,6),(1130,1367118000,5),(1130,1378612800,6),(1130,1398567600,5),(1130,1410062400,6),(1130,1463281200,5),(1130,1471147200,6),(1130,1494730800,5),(1130,1502596800,6),(1130,1526180400,5),(1130,1534046400,6),(1130,1554606000,5),(1130,1567915200,6),(1130,1586055600,5),(1130,1599364800,6),(1130,1617505200,5),(1130,1630814400,6),(1130,1648954800,5),(1130,1662868800,6),(1130,1680404400,5),(1130,1693713600,6),(1130,1712458800,5),(1130,1725768000,6),(1130,1743908400,5),(1130,1757217600,6),(1130,1775358000,5),(1130,1788667200,6),(1130,1806807600,5),(1130,1820116800,6),(1130,1838257200,5),(1130,1851566400,6),(1130,1870311600,5),(1130,1883016000,6),(1130,1901761200,5),(1130,1915070400,6),(1130,1933210800,5),(1130,1946520000,6),(1130,1964660400,5),(1130,1977969600,6),(1130,1996110000,5),(1130,2009419200,6),(1130,2027559600,5),(1130,2040868800,6),(1130,2059614000,5),(1130,2072318400,6),(1130,2091063600,5),(1130,2104372800,6),(1130,2122513200,5),(1130,2135822400,6),(1130,2147483647,6),(1131,-2147483648,0),(1131,-1829387596,4),(1131,125409600,1),(1131,133876800,2),(1131,433256400,3),(1131,448977600,4),(1131,464706000,3),(1131,480427200,4),(1131,496760400,3),(1131,511876800,4),(1131,528210000,3),(1131,543931200,4),(1131,559659600,3),(1131,575380800,4),(1131,591109200,3),(1131,606830400,4),(1131,622558800,3),(1131,638280000,4),(1131,654008400,3),(1131,669729600,4),(1131,686062800,3),(1131,696340800,4),(1131,719931600,3),(1131,727790400,4),(1131,2147483647,4),(1132,-2147483648,0),(1132,-1020470400,1),(1132,307627200,2),(1132,788871600,3),(1132,2147483647,3),(1133,-2147483648,1),(1133,1325242800,2),(1133,2147483647,2),(1134,-2147483648,0),(1134,-1709985344,2),(1134,909842400,1),(1134,920124000,2),(1134,941896800,1),(1134,951573600,2),(1134,1259416800,1),(1134,1269698400,2),(1134,1287842400,1),(1134,1299333600,2),(1134,1319292000,1),(1134,1327154400,2),(1134,1350741600,1),(1134,1358604000,2),(1134,1382796000,1),(1134,1390050000,2),(1134,1414850400,1),(1134,1421503200,2),(1134,1446300000,1),(1134,1452952800,2),(1134,1478354400,1),(1134,1484402400,2),(1134,1509804000,1),(1134,1515852000,2),(1134,1541253600,1),(1134,1547301600,2),(1134,1573308000,1),(1134,1578751200,2),(1134,1608386400,1),(1134,1610805600,2),(1134,2147483647,2),(1135,-2147483648,1),(1135,2147483647,1),(1136,-2147483648,0),(1136,-1230746496,1),(1136,504939600,3),(1136,722930400,2),(1136,728888400,3),(1136,2147483647,3),(1137,-2147483648,0),(1137,-1806678012,1),(1137,2147483647,1),(1138,-2147483648,0),(1138,-1806748788,1),(1138,2147483647,1),(1139,-2147483648,1),(1139,-885549600,2),(1139,-802256400,1),(1139,-331891200,3),(1139,-281610000,1),(1139,-73728000,3),(1139,-29415540,1),(1139,-16704000,3),(1139,-10659600,1),(1139,9907200,3),(1139,21394800,1),(1139,41356800,3),(1139,52844400,1),(1139,124819200,3),(1139,130863600,1),(1139,201888000,3),(1139,209487660,1),(1139,230659200,3),(1139,241542000,1),(1139,977493600,4),(1140,-2147483648,1),(1140,-1157283000,2),(1140,-1155436200,1),(1140,-880198200,3),(1140,-769395600,4),(1140,-765376200,1),(1140,-712150200,5),(1141,-2147483648,1),(1141,-1157283000,2),(1141,-1155436200,1),(1141,-880198200,3),(1141,-769395600,4),(1141,-765376200,1),(1141,-712150200,5),(1142,-2147483648,0),(1142,-1020470400,1),(1142,307627200,2),(1142,788871600,3),(1142,2147483647,3),(1143,-2147483648,1),(1143,307622400,2),(1143,788868000,3),(1143,2147483647,3),(1144,-2147483648,1),(1144,-1743678000,2),(1144,-1606813200,1),(1144,-1041418800,3),(1144,-907408800,2),(1144,-770634000,1),(1144,-7988400,4),(1144,915105600,1),(1144,2147483647,1),(1145,-2147483648,1),(1145,-1041418800,2),(1145,-907408800,3),(1145,-817462800,1),(1145,-7988400,4),(1145,745934400,5),(1145,2147483647,5),(1146,-2147483648,1),(1146,2147483647,1),(1147,-2147483648,0),(1147,-1806676920,1),(1147,2147483647,1),(1148,-2147483648,1),(1148,-1861879032,2),(1149,-2147483648,0),(1149,-1545131260,1),(1149,-862918200,2),(1149,-767350800,1),(1149,287418600,3),(1149,2147483647,3),(1150,-2147483648,0),(1150,-543069620,1),(1150,-173623200,2),(1150,2147483647,2),(1151,-2147483648,1),(1151,-599656320,2),(1151,152029800,3),(1151,162916200,4),(1151,1443882600,5),(1151,1561899600,7),(1151,1570287600,6),(1151,1586012400,5),(1151,1601737200,6),(1151,1617462000,5),(1151,1633186800,6),(1151,1648911600,5),(1151,1664636400,6),(1151,1680361200,5),(1151,1696086000,6),(1151,1712415600,5),(1151,1728140400,6),(1151,1743865200,5),(1151,1759590000,6),(1151,1775314800,5),(1151,1791039600,6),(1151,1806764400,5),(1151,1822489200,6),(1151,1838214000,5),(1151,1853938800,6),(1151,1869663600,5),(1151,1885993200,6),(1151,1901718000,5),(1151,1917442800,6),(1151,1933167600,5),(1151,1948892400,6),(1151,1964617200,5),(1151,1980342000,6),(1151,1996066800,5),(1151,2011791600,6),(1151,2027516400,5),(1151,2043241200,6),(1151,2058966000,5),(1151,2075295600,6),(1151,2091020400,5),(1151,2106745200,6),(1151,2122470000,5),(1151,2138194800,6),(1151,2147483647,6),(1152,-2147483648,0),(1152,-1829387148,2),(1152,250002000,1),(1152,257342400,2),(1152,281451600,1),(1152,288878400,2),(1152,849366000,3),(1152,857228400,4),(1152,2147483647,4),(1153,-2147483648,1),(1153,-1861879032,2),(1154,-2147483648,1),(1154,2147483647,1),(1155,-2147483648,1),(1155,893665800,2),(1155,2147483647,2),(1156,-2147483648,0),(1156,-1806748788,1),(1156,2147483647,1),(1157,-2147483648,0),(1157,-1806748788,1),(1157,2147483647,1),(1158,-2147483648,1),(1158,2147483647,1),(1159,-2147483648,1),(1159,-543072056,2),(1159,279714600,4),(1159,289387800,3),(1159,309952800,4),(1159,320837400,3),(1159,341402400,4),(1159,352287000,3),(1159,372852000,4),(1159,384341400,3),(1159,404906400,4),(1159,415791000,3),(1159,436356000,4),(1159,447240600,3),(1159,467805600,4),(1159,478690200,3),(1159,499255200,4),(1159,510139800,3),(1159,530704800,4),(1159,541589400,3),(1159,562154400,4),(1159,573643800,3),(1159,594208800,4),(1159,605093400,3),(1159,625658400,4),(1159,636543000,3),(1159,657108000,4),(1159,667992600,3),(1159,2147483647,3),(1160,-2147483648,1),(1160,-885549600,2),(1160,-802256400,1),(1160,-331891200,3),(1160,-281610000,1),(1160,-73728000,3),(1160,-29415540,1),(1160,-16704000,3),(1160,-10659600,1),(1160,9907200,3),(1160,21394800,1),(1160,41356800,3),(1160,52844400,1),(1160,124819200,3),(1160,130863600,1),(1160,201888000,3),(1160,209487660,1),(1160,230659200,3),(1160,241542000,1),(1160,977493600,4),(1161,-2147483648,1),(1161,-1861879032,2),(1162,-2147483648,0),(1162,-1806674504,1),(1162,2147483647,1),(1163,-2147483648,1),(1163,2147483647,1),(1164,-2147483648,0),(1164,-767189952,1),(1164,-284041200,2),(1164,939214800,3),(1164,953384400,4),(1164,973342800,5),(1164,980596800,2),(1164,1004792400,5),(1164,1012046400,2),(1164,1478350800,5),(1164,1484398800,2),(1164,2147483647,2),(1165,-2147483648,1),(1165,2147483647,1),(1166,-2147483648,1),(1166,2147483647,1),(1167,-2147483648,1),(1167,2147483647,1),(1168,-2147483648,1),(1168,2147483647,1),(1169,-2147483648,1),(1169,-1717032240,3),(1169,-1693706400,2),(1169,-1680483600,3),(1169,-1663455600,4),(1169,-1650150000,5),(1169,-1632006000,4),(1169,-1618700400,8),(1169,-1600473600,6),(1169,-1587168000,7),(1169,-1501725600,3),(1169,-931734000,2),(1169,-857257200,5),(1169,-844556400,4),(1169,-828226800,5),(1169,-812502000,4),(1169,-796874400,2),(1169,-796608000,3),(1169,-778726800,2),(1169,-762660000,3),(1169,-748486800,4),(1169,-733273200,5),(1169,-715215600,4),(1169,-701910000,5),(1169,-684975600,4),(1169,-670460400,5),(1169,-654130800,4),(1169,-639010800,5),(1169,-397094400,4),(1169,-386812800,5),(1169,-371088000,4),(1169,-355363200,5),(1169,-334195200,4),(1169,-323308800,5),(1169,-307584000,4),(1169,-291859200,5),(1169,-271296000,4),(1169,-260409600,5),(1169,-239846400,4),(1169,-228960000,5),(1169,-208396800,4),(1169,-197510400,5),(1169,-176342400,4),(1169,-166060800,5),(1169,220921200,3),(1169,228873600,4),(1169,243993600,5),(1169,260323200,4),(1169,276048000,5),(1169,291772800,4),(1169,307497600,5),(1169,323827200,4),(1169,338947200,5),(1169,354672000,4),(1169,370396800,5),(1169,386121600,4),(1169,401846400,5),(1169,417571200,4),(1169,433296000,5),(1169,449020800,4),(1169,465350400,5),(1169,481075200,4),(1169,496800000,5),(1169,512524800,4),(1169,528249600,5),(1169,543974400,4),(1169,559699200,5),(1169,567990000,3),(1169,575427600,9),(1169,591152400,10),(1169,606877200,9),(1169,622602000,10),(1169,638326800,9),(1169,654656400,10),(1169,670381200,9),(1169,686106000,10),(1169,701830800,9),(1169,717555600,10),(1169,733280400,9),(1169,749005200,10),(1169,764730000,9),(1169,780454800,10),(1169,796179600,9),(1169,811904400,10),(1169,828234000,9),(1169,846378000,10),(1169,859683600,9),(1169,877827600,10),(1169,891133200,9),(1169,909277200,10),(1169,922582800,9),(1169,941331600,10),(1169,954032400,9),(1169,972781200,10),(1169,985482000,9),(1169,1004230800,10),(1169,1017536400,9),(1169,1035680400,10),(1169,1048986000,9),(1169,1067130000,10),(1169,1080435600,9),(1169,1099184400,10),(1169,1111885200,9),(1169,1130634000,10),(1169,1143334800,9),(1169,1162083600,10),(1169,1174784400,9),(1169,1193533200,10),(1169,1206838800,9),(1169,1224982800,10),(1169,1238288400,9),(1169,1256432400,10),(1169,1269738000,9),(1169,1288486800,10),(1169,1301187600,9),(1169,1319936400,10),(1169,1332637200,9),(1169,1351386000,10),(1169,1364691600,9),(1169,1382835600,10),(1169,1396141200,9),(1169,1414285200,10),(1169,1427590800,9),(1169,1445734800,10),(1169,1459040400,9),(1169,1477789200,10),(1169,1490490000,9),(1169,1509238800,10),(1169,1521939600,9),(1169,1540688400,10),(1169,1553994000,9),(1169,1572138000,10),(1169,1585443600,9),(1169,1603587600,10),(1169,1616893200,9),(1169,1635642000,10),(1169,1648342800,9),(1169,1667091600,10),(1169,1679792400,9),(1169,1698541200,10),(1169,1711846800,9),(1169,1729990800,10),(1169,1743296400,9),(1169,1761440400,10),(1169,1774746000,9),(1169,1792890000,10),(1169,1806195600,9),(1169,1824944400,10),(1169,1837645200,9),(1169,1856394000,10),(1169,1869094800,9),(1169,1887843600,10),(1169,1901149200,9),(1169,1919293200,10),(1169,1932598800,9),(1169,1950742800,10),(1169,1964048400,9),(1169,1982797200,10),(1169,1995498000,9),(1169,2014246800,10),(1169,2026947600,9),(1169,2045696400,10),(1169,2058397200,9),(1169,2077146000,10),(1169,2090451600,9),(1169,2108595600,10),(1169,2121901200,9),(1169,2140045200,10),(1170,-2147483648,0),(1170,-1830384000,6),(1170,-1689555600,1),(1170,-1677801600,2),(1170,-1667437200,3),(1170,-1647738000,4),(1170,-1635814800,3),(1170,-1616202000,4),(1170,-1604365200,3),(1170,-1584666000,4),(1170,-1572742800,3),(1170,-1553043600,4),(1170,-1541206800,3),(1170,-1521507600,4),(1170,-1442451600,3),(1170,-1426813200,4),(1170,-1379293200,3),(1170,-1364778000,4),(1170,-1348448400,3),(1170,-1333328400,4),(1170,-1316394000,3),(1170,-1301274000,4),(1170,-1284339600,3),(1170,-1269824400,4),(1170,-1221440400,3),(1170,-1206925200,4),(1170,-1191200400,3),(1170,-1175475600,4),(1170,-1127696400,3),(1170,-1111971600,4),(1170,-1096851600,3),(1170,-1080522000,4),(1170,-1063587600,3),(1170,-1049072400,4),(1170,-1033347600,3),(1170,-1017622800,4),(1170,-1002502800,3),(1170,-986173200,4),(1170,-969238800,3),(1170,-950490000,4),(1170,-942022800,3),(1170,-922669200,4),(1170,-906944400,3),(1170,-891133200,4),(1170,-877309200,3),(1170,-873684000,5),(1170,-864007200,3),(1170,-857955600,4),(1170,-845859600,3),(1170,-842839200,5),(1170,-831348000,3),(1170,-825901200,4),(1170,-814410000,3),(1170,-810784800,5),(1170,-799898400,3),(1170,-794451600,4),(1170,-782960400,3),(1170,-779335200,5),(1170,-768448800,3),(1170,-763002000,4),(1170,-749091600,3),(1170,-733366800,4),(1170,-717631200,3),(1170,-701906400,4),(1170,-686181600,3),(1170,-670456800,4),(1170,-654732000,3),(1170,-639007200,4),(1170,-623282400,3),(1170,-607557600,4),(1170,-591832800,3),(1170,-575503200,4),(1170,-559778400,3),(1170,-544053600,4),(1170,-528328800,3),(1170,-512604000,4),(1170,-496879200,3),(1170,-481154400,4),(1170,-465429600,3),(1170,-449704800,4),(1170,-433980000,3),(1170,-417650400,4),(1170,-401925600,3),(1170,-386200800,4),(1170,-370476000,3),(1170,-354751200,4),(1170,-339026400,3),(1170,-323301600,4),(1170,-307576800,3),(1170,-291852000,4),(1170,-276127200,3),(1170,-260402400,4),(1170,-244677600,3),(1170,-228348000,4),(1170,-212623200,3),(1170,-196898400,4),(1170,-181173600,3),(1170,-165448800,4),(1170,-149724000,3),(1170,-133999200,4),(1170,-118274400,7),(1170,212544000,2),(1170,228268800,3),(1170,243993600,4),(1170,260323200,3),(1170,276048000,4),(1170,291772800,3),(1170,307501200,4),(1170,323222400,3),(1170,338950800,4),(1170,354675600,3),(1170,370400400,4),(1170,386125200,3),(1170,401850000,4),(1170,417578400,3),(1170,433299600,4),(1170,449024400,3),(1170,465354000,4),(1170,481078800,3),(1170,496803600,4),(1170,512528400,3),(1170,528253200,4),(1170,543978000,3),(1170,559702800,4),(1170,575427600,3),(1170,591152400,4),(1170,606877200,3),(1170,622602000,4),(1170,638326800,3),(1170,654656400,4),(1170,670381200,3),(1170,686106000,4),(1170,701830800,3),(1170,717555600,8),(1170,733280400,9),(1170,749005200,8),(1170,764730000,9),(1170,780454800,8),(1170,796179600,9),(1170,811904400,8),(1170,828234000,10),(1170,846378000,6),(1170,859683600,10),(1170,877827600,6),(1170,891133200,10),(1170,909277200,6),(1170,922582800,10),(1170,941331600,6),(1170,954032400,10),(1170,972781200,6),(1170,985482000,10),(1170,1004230800,6),(1170,1017536400,10),(1170,1035680400,6),(1170,1048986000,10),(1170,1067130000,6),(1170,1080435600,10),(1170,1099184400,6),(1170,1111885200,10),(1170,1130634000,6),(1170,1143334800,10),(1170,1162083600,6),(1170,1174784400,10),(1170,1193533200,6),(1170,1206838800,10),(1170,1224982800,6),(1170,1238288400,10),(1170,1256432400,6),(1170,1269738000,10),(1170,1288486800,6),(1170,1301187600,10),(1170,1319936400,6),(1170,1332637200,10),(1170,1351386000,6),(1170,1364691600,10),(1170,1382835600,6),(1170,1396141200,10),(1170,1414285200,6),(1170,1427590800,10),(1170,1445734800,6),(1170,1459040400,10),(1170,1477789200,6),(1170,1490490000,10),(1170,1509238800,6),(1170,1521939600,10),(1170,1540688400,6),(1170,1553994000,10),(1170,1572138000,6),(1170,1585443600,10),(1170,1603587600,6),(1170,1616893200,10),(1170,1635642000,6),(1170,1648342800,10),(1170,1667091600,6),(1170,1679792400,10),(1170,1698541200,6),(1170,1711846800,10),(1170,1729990800,6),(1170,1743296400,10),(1170,1761440400,6),(1170,1774746000,10),(1170,1792890000,6),(1170,1806195600,10),(1170,1824944400,6),(1170,1837645200,10),(1170,1856394000,6),(1170,1869094800,10),(1170,1887843600,6),(1170,1901149200,10),(1170,1919293200,6),(1170,1932598800,10),(1170,1950742800,6),(1170,1964048400,10),(1170,1982797200,6),(1170,1995498000,10),(1170,2014246800,6),(1170,2026947600,10),(1170,2045696400,6),(1170,2058397200,10),(1170,2077146000,6),(1170,2090451600,10),(1170,2108595600,6),(1170,2121901200,10),(1170,2140045200,6),(1171,-2147483648,1),(1171,-1017820800,2),(1171,-766224000,1),(1171,-745833600,3),(1171,-733827600,1),(1171,-716889600,3),(1171,-699613200,1),(1171,-683884800,3),(1171,-670669200,1),(1171,-652348800,3),(1171,-639133200,1),(1171,-620812800,3),(1171,-607597200,1),(1171,-589276800,3),(1171,-576061200,1),(1171,-562924800,3),(1171,-541760400,1),(1171,-528710400,3),(1171,-510224400,1),(1171,-497174400,3),(1171,-478688400,1),(1171,-465638400,3),(1171,-449830800,1),(1171,-434016000,3),(1171,-418208400,1),(1171,-402480000,3),(1171,-386672400,1),(1171,-370944000,3),(1171,-355136400,1),(1171,-339408000,3),(1171,-323600400,1),(1171,-302515200,3),(1171,-291978000,1),(1171,-270979200,3),(1171,-260442000,1),(1171,133977600,3),(1171,149785200,1),(1171,165513600,3),(1171,181321200,1),(1171,299606400,3),(1171,307551600,1),(1172,-2147483648,0),(1172,-1948782472,1),(1172,-1830414600,2),(1172,-767350800,4),(1172,-681210000,3),(1172,-672228000,4),(1172,-654771600,3),(1172,-640864800,4),(1172,-623408400,3),(1172,-609415200,4),(1172,-588848400,3),(1172,-577965600,4),(1172,-498128400,1),(1172,-462702600,5),(1172,-451733400,1),(1172,-429784200,5),(1172,-418296600,1),(1172,-399544200,5),(1172,-387451800,1),(1172,-368094600,5),(1172,-356002200,1),(1172,-336645000,5),(1172,-324552600,1),(1172,-305195400,5),(1172,-293103000,1),(1172,-264933000,4),(1172,547578000,3),(1172,560883600,4),(1172,579027600,3),(1172,592333200,4),(1173,-2147483648,1),(1173,-2038200925,2),(1173,-1167634800,3),(1173,-1073028000,4),(1173,-894180000,5),(1173,-879665400,6),(1173,-767005200,5),(1173,378662400,7),(1173,2147483647,7),(1174,-2147483648,1),(1174,-1869875816,3),(1174,-1693706400,2),(1174,-1680490800,3),(1174,-1570413600,2),(1174,-1552186800,3),(1174,-1538359200,2),(1174,-1522551600,3),(1174,-1507514400,2),(1174,-1490583600,3),(1174,-1440208800,2),(1174,-1428030000,3),(1174,-1409709600,2),(1174,-1396494000,3),(1174,-931053600,2),(1174,-922676400,3),(1174,-917834400,2),(1174,-892436400,3),(1174,-875844000,2),(1174,-764737200,3),(1174,-744343200,2),(1174,-733806000,3),(1174,-716436000,2),(1174,-701924400,3),(1174,-684986400,2),(1174,-670474800,3),(1174,-654141600,2),(1174,-639025200,3),(1174,-622087200,2),(1174,-606970800,3),(1174,-590032800,2),(1174,-575521200,3),(1174,-235620000,2),(1174,-194842800,3),(1174,-177732000,2),(1174,-165726000,3),(1174,107910000,2),(1174,121215600,3),(1174,133920000,2),(1174,152665200,3),(1174,164678400,2),(1174,184114800,3),(1174,196214400,2),(1174,215564400,3),(1174,228873600,2),(1174,245804400,3),(1174,260323200,2),(1174,267915600,4),(1174,428454000,5),(1174,433893600,4),(1174,468111600,3),(1174,482799600,6),(1174,496710000,7),(1174,512521200,6),(1174,528246000,7),(1174,543970800,6),(1174,559695600,7),(1174,575420400,6),(1174,591145200,7),(1174,606870000,6),(1174,622594800,7),(1174,638319600,6),(1174,654649200,7),(1174,670374000,6),(1174,686098800,7),(1174,701823600,6),(1174,717548400,7),(1174,733273200,6),(1174,748998000,7),(1174,764118000,6),(1174,780447600,7),(1174,796172400,6),(1174,811897200,7),(1174,828226800,6),(1174,846370800,7),(1174,859676400,6),(1174,877820400,7),(1174,891126000,6),(1174,909270000,7),(1174,922575600,6),(1174,941324400,7),(1174,954025200,6),(1174,972774000,7),(1174,985474800,6),(1174,1004223600,7),(1174,1017529200,6),(1174,1035673200,7),(1174,1048978800,6),(1174,1067122800,7),(1174,1080428400,6),(1174,1099177200,7),(1174,1111878000,6),(1174,1130626800,7),(1174,1143327600,6),(1174,1162076400,7),(1174,1167602400,3),(1174,1174784400,8),(1174,1193533200,9),(1174,1206838800,8),(1174,1224982800,9),(1174,1238288400,8),(1174,1256432400,9),(1174,1269738000,8),(1174,1288486800,9),(1174,1301274000,8),(1174,1319936400,9),(1174,1332637200,8),(1174,1351386000,9),(1174,1364691600,8),(1174,1382835600,9),(1174,1396227600,8),(1174,1414285200,9),(1174,1427590800,8),(1174,1446944400,9),(1174,1459040400,8),(1174,1473195600,4),(1174,2147483647,4),(1176,-2147483648,1),(1176,-880200000,2),(1176,-769395600,3),(1176,-765378000,1),(1176,-86882400,4),(1176,-21470400,5),(1176,-5749200,4),(1176,9979200,5),(1176,25700400,4),(1176,41428800,5),(1176,57754800,4),(1176,73483200,5),(1176,89204400,4),(1176,104932800,5),(1176,120654000,4),(1176,126705600,5),(1176,152103600,4),(1176,162388800,5),(1176,183553200,4),(1176,199281600,5),(1176,215607600,4),(1176,230731200,5),(1176,247057200,4),(1176,262785600,5),(1176,278506800,4),(1176,294235200,5),(1176,309956400,4),(1176,325684800,5),(1176,341406000,4),(1176,357134400,5),(1176,372855600,4),(1176,388584000,5),(1176,404910000,4),(1176,420033600,5),(1176,436359600,6),(1176,439030800,8),(1176,452084400,7),(1176,467805600,8),(1176,483534000,7),(1176,499255200,8),(1176,514983600,7),(1176,530704800,8),(1176,544618800,7),(1176,562154400,8),(1176,576068400,7),(1176,594208800,8),(1176,607518000,7),(1176,625658400,8),(1176,638967600,7),(1176,657108000,8),(1176,671022000,7),(1176,688557600,8),(1176,702471600,7),(1176,720007200,8),(1176,733921200,7),(1176,752061600,8),(1176,765370800,7),(1176,783511200,8),(1176,796820400,7),(1176,814960800,8),(1176,828874800,7),(1176,846410400,8),(1176,860324400,7),(1176,877860000,8),(1176,891774000,7),(1176,909309600,8),(1176,923223600,7),(1176,941364000,8),(1176,954673200,7),(1176,972813600,8),(1176,986122800,7),(1176,1004263200,8),(1176,1018177200,7),(1176,1035712800,8),(1176,1049626800,7),(1176,1067162400,8),(1176,1081076400,7),(1176,1099216800,8),(1176,1112526000,7),(1176,1130666400,8),(1176,1143975600,7),(1176,1162116000,8),(1176,1173610800,7),(1176,1194170400,8),(1176,1205060400,7),(1176,1225620000,8),(1176,1236510000,7),(1176,1257069600,8),(1176,1268564400,7),(1176,1289124000,8),(1176,1300014000,7),(1176,1320573600,8),(1176,1331463600,7),(1176,1352023200,8),(1176,1362913200,7),(1176,1383472800,8),(1176,1394362800,7),(1176,1414922400,8),(1176,1425812400,7),(1176,1446372000,8),(1176,1457866800,7),(1176,1478426400,8),(1176,1489316400,7),(1176,1509876000,8),(1176,1520766000,7),(1176,1541325600,8),(1176,1552215600,7),(1176,1572775200,8),(1176,1583665200,7),(1176,1604224800,8),(1176,1615719600,7),(1176,1636279200,8),(1176,1647169200,7),(1176,1667728800,8),(1176,1678618800,7),(1176,1699178400,8),(1176,1710068400,7),(1176,1730628000,8),(1176,1741518000,7),(1176,1762077600,8),(1176,1772967600,7),(1176,1793527200,8),(1176,1805022000,7),(1176,1825581600,8),(1176,1836471600,7),(1176,1857031200,8),(1176,1867921200,7),(1176,1888480800,8),(1176,1899370800,7),(1176,1919930400,8),(1176,1930820400,7),(1176,1951380000,8),(1176,1962874800,7),(1176,1983434400,8),(1176,1994324400,7),(1176,2014884000,8),(1176,2025774000,7),(1176,2046333600,8),(1176,2057223600,7),(1176,2077783200,8),(1176,2088673200,7),(1176,2109232800,8),(1176,2120122800,7),(1176,2140682400,8),(1177,-2147483648,1),(1177,-880196400,2),(1177,-769395600,3),(1177,-765374400,1),(1177,-86878800,4),(1177,-21466800,5),(1177,-5745600,4),(1177,9982800,5),(1177,25704000,4),(1177,41432400,5),(1177,57758400,4),(1177,73486800,5),(1177,89208000,4),(1177,104936400,5),(1177,120657600,4),(1177,126709200,5),(1177,152107200,4),(1177,162392400,5),(1177,183556800,4),(1177,199285200,5),(1177,215611200,4),(1177,230734800,5),(1177,247060800,4),(1177,262789200,5),(1177,278510400,4),(1177,294238800,5),(1177,309960000,4),(1177,325688400,5),(1177,341409600,4),(1177,357138000,5),(1177,372859200,4),(1177,388587600,5),(1177,404913600,4),(1177,420037200,5),(1177,436363200,6),(1177,439034400,8),(1177,452088000,7),(1177,467809200,8),(1177,483537600,7),(1177,499258800,8),(1177,514987200,7),(1177,530708400,8),(1177,544622400,7),(1177,562158000,8),(1177,576072000,7),(1177,594212400,8),(1177,607521600,7),(1177,625662000,8),(1177,638971200,7),(1177,657111600,8),(1177,671025600,7),(1177,688561200,8),(1177,702475200,7),(1177,720010800,8),(1177,733924800,7),(1177,752065200,8),(1177,765374400,7),(1177,783514800,8),(1177,796824000,7),(1177,814964400,8),(1177,828878400,7),(1177,846414000,8),(1177,860328000,7),(1177,877863600,8),(1177,891777600,7),(1177,909313200,8),(1177,923227200,7),(1177,941367600,8),(1177,954676800,7),(1177,972817200,8),(1177,986126400,7),(1177,1004266800,8),(1177,1018180800,7),(1177,1035716400,8),(1177,1049630400,7),(1177,1067166000,8),(1177,1081080000,7),(1177,1099220400,8),(1177,1112529600,7),(1177,1130670000,8),(1177,1143979200,7),(1177,1162119600,8),(1177,1173614400,7),(1177,1194174000,8),(1177,1205064000,7),(1177,1225623600,8),(1177,1236513600,7),(1177,1257073200,8),(1177,1268568000,7),(1177,1289127600,8),(1177,1300017600,7),(1177,1320577200,8),(1177,1331467200,7),(1177,1352026800,8),(1177,1362916800,7),(1177,1383476400,8),(1177,1394366400,7),(1177,1414926000,8),(1177,1425816000,7),(1177,1446375600,8),(1177,1457870400,7),(1177,1478430000,8),(1177,1489320000,7),(1177,1509879600,8),(1177,1520769600,7),(1177,1541329200,8),(1177,1552219200,7),(1177,1572778800,8),(1177,1583668800,7),(1177,1604228400,8),(1177,1615723200,7),(1177,1636282800,8),(1177,1647172800,7),(1177,1667732400,8),(1177,1678622400,7),(1177,1699182000,8),(1177,1710072000,7),(1177,1730631600,8),(1177,1741521600,7),(1177,1762081200,8),(1177,1772971200,7),(1177,1793530800,8),(1177,1805025600,7),(1177,1825585200,8),(1177,1836475200,7),(1177,1857034800,8),(1177,1867924800,7),(1177,1888484400,8),(1177,1899374400,7),(1177,1919934000,8),(1177,1930824000,7),(1177,1951383600,8),(1177,1962878400,7),(1177,1983438000,8),(1177,1994328000,7),(1177,2014887600,8),(1177,2025777600,7),(1177,2046337200,8),(1177,2057227200,7),(1177,2077786800,8),(1177,2088676800,7),(1177,2109236400,8),(1177,2120126400,7),(1177,2140686000,8),(1178,-2147483648,4),(1178,-1633273200,1),(1178,-1615132800,2),(1178,-1601823600,1),(1178,-1583683200,2),(1178,-880210800,3),(1178,-820519140,2),(1178,-812653140,3),(1178,-796845540,2),(1178,-84380400,1),(1178,-68659200,2),(1179,-2147483648,3),(1179,-1633276800,1),(1179,-1615136400,2),(1179,-1601827200,1),(1179,-1583686800,2),(1179,-1563724800,1),(1179,-1551632400,2),(1179,-1538928000,1),(1179,-1520182800,2),(1179,-1504454400,1),(1179,-1491757200,2),(1179,-1473004800,1),(1179,-1459702800,2),(1179,-1441555200,1),(1179,-1428253200,2),(1179,-1410105600,1),(1179,-1396803600,2),(1179,-1378656000,1),(1179,-1365354000,2),(1179,-1347206400,1),(1179,-1333904400,2),(1179,-1315152000,1),(1179,-1301850000,2),(1179,-1283702400,1),(1179,-1270400400,2),(1179,-1252252800,1),(1179,-1238950800,2),(1179,-1220803200,1),(1179,-1207501200,2),(1179,-1189353600,1),(1179,-1176051600,2),(1179,-1157299200,1),(1179,-1144602000,2),(1179,-1125849600,1),(1179,-1112547600,2),(1179,-1094400000,1),(1179,-1081098000,2),(1179,-1067788800,4),(1179,-1045414800,2),(1179,-1031500800,1),(1179,-1018198800,2),(1179,-1000051200,1),(1179,-986749200,2),(1179,-967996800,1),(1179,-955299600,2),(1179,-936547200,1),(1179,-923245200,2),(1179,-905097600,1),(1179,-891795600,2),(1179,-880214400,5),(1179,-769395600,6),(1179,-765392400,2),(1179,-747244800,1),(1179,-733942800,2),(1179,-715795200,1),(1179,-702493200,2),(1179,-684345600,1),(1179,-671043600,2),(1179,-652896000,1),(1179,-639594000,2),(1179,-620841600,1),(1179,-608144400,2),(1179,-589392000,1),(1179,-576090000,2),(1179,-557942400,1),(1179,-544640400,2),(1179,-526492800,1),(1179,-513190800,2),(1179,-495043200,1),(1179,-481741200,2),(1179,-463593600,1),(1179,-447267600,2),(1179,-431539200,1),(1179,-415818000,2),(1179,-400089600,1),(1179,-384368400,2),(1179,-368640000,1),(1179,-352918800,2),(1179,-337190400,1),(1179,-321469200,2),(1179,-305740800,1),(1179,-289414800,2),(1179,-273686400,1),(1179,-257965200,2),(1179,-242236800,1),(1179,-226515600,2),(1179,-210787200,1),(1179,-195066000,2),(1179,-179337600,1),(1179,-163616400,2),(1179,-147888000,1),(1179,-131562000,2),(1179,-116438400,1),(1179,-100112400,2),(1179,-84384000,1),(1179,-68662800,2),(1179,-52934400,1),(1179,-37213200,2),(1179,-21484800,1),(1179,-5763600,2),(1179,9964800,1),(1179,25686000,2),(1179,41414400,1),(1179,57740400,2),(1179,73468800,1),(1179,89190000,2),(1179,104918400,1),(1179,120639600,2),(1179,126691200,1),(1179,152089200,2),(1179,162374400,1),(1179,183538800,2),(1179,199267200,1),(1179,215593200,2),(1179,230716800,1),(1179,247042800,2),(1179,262771200,1),(1179,278492400,2),(1179,294220800,1),(1179,309942000,2),(1179,325670400,1),(1179,341391600,2),(1179,357120000,1),(1179,372841200,2),(1179,388569600,1),(1179,404895600,2),(1179,420019200,1),(1179,436345200,2),(1179,452073600,1),(1179,467794800,2),(1179,483523200,1),(1179,499244400,2),(1179,514972800,1),(1179,530694000,2),(1179,544608000,1),(1179,562143600,2),(1179,576057600,1),(1179,594198000,2),(1179,607507200,1),(1179,625647600,2),(1179,638956800,1),(1179,657097200,2),(1179,671011200,1),(1179,688546800,2),(1179,702460800,1),(1179,719996400,2),(1179,733910400,1),(1179,752050800,2),(1179,765360000,1),(1179,783500400,2),(1179,796809600,1),(1179,814950000,2),(1179,828864000,1),(1179,846399600,2),(1179,860313600,1),(1179,877849200,2),(1179,891763200,1),(1179,909298800,2),(1179,923212800,1),(1179,941353200,2),(1179,954662400,1),(1179,972802800,2),(1179,986112000,1),(1179,1004252400,2),(1179,1018166400,1),(1179,1035702000,2),(1179,1049616000,1),(1179,1067151600,2),(1179,1081065600,1),(1179,1099206000,2),(1179,1112515200,1),(1179,1130655600,2),(1179,1143964800,1),(1179,1162105200,2),(1179,1173600000,1),(1179,1194159600,2),(1179,1205049600,1),(1179,1225609200,2),(1179,1236499200,1),(1179,1257058800,2),(1179,1268553600,1),(1179,1289113200,2),(1179,1300003200,1),(1179,1320562800,2),(1179,1331452800,1),(1179,1352012400,2),(1179,1362902400,1),(1179,1383462000,2),(1179,1394352000,1),(1179,1414911600,2),(1179,1425801600,1),(1179,1446361200,2),(1179,1457856000,1),(1179,1478415600,2),(1179,1489305600,1),(1179,1509865200,2),(1179,1520755200,1),(1179,1541314800,2),(1179,1552204800,1),(1179,1572764400,2),(1179,1583654400,1),(1179,1604214000,2),(1179,1615708800,1),(1179,1636268400,2),(1179,1647158400,1),(1179,1667718000,2),(1179,1678608000,1),(1179,1699167600,2),(1179,1710057600,1),(1179,1730617200,2),(1179,1741507200,1),(1179,1762066800,2),(1179,1772956800,1),(1179,1793516400,2),(1179,1805011200,1),(1179,1825570800,2),(1179,1836460800,1),(1179,1857020400,2),(1179,1867910400,1),(1179,1888470000,2),(1179,1899360000,1),(1179,1919919600,2),(1179,1930809600,1),(1179,1951369200,2),(1179,1962864000,1),(1179,1983423600,2),(1179,1994313600,1),(1179,2014873200,2),(1179,2025763200,1),(1179,2046322800,2),(1179,2057212800,1),(1179,2077772400,2),(1179,2088662400,1),(1179,2109222000,2),(1179,2120112000,1),(1179,2140671600,2),(1180,-2147483648,3),(1180,-1633276800,1),(1180,-1615136400,2),(1180,-1601827200,1),(1180,-1583686800,2),(1180,-900259200,1),(1180,-891795600,2),(1180,-880214400,4),(1180,-769395600,5),(1180,-765392400,2),(1180,-747244800,1),(1180,-733942800,2),(1180,-715795200,1),(1180,-702493200,2),(1180,-684345600,1),(1180,-671043600,2),(1180,-652896000,1),(1180,-639594000,2),(1180,-620841600,1),(1180,-608144400,2),(1180,-589392000,1),(1180,-576090000,2),(1180,-557942400,1),(1180,-544640400,2),(1180,-526492800,1),(1180,-513190800,2),(1180,-495043200,1),(1180,-481741200,2),(1180,-463593600,6),(1180,-386787600,2),(1180,-368640000,6),(1180,-21488400,7),(1180,-5767200,6),(1180,9961200,7),(1180,25682400,6),(1180,1143961200,7),(1180,1162101600,6),(1180,1173596400,7),(1180,1194156000,6),(1180,1205046000,7),(1180,1225605600,6),(1180,1236495600,7),(1180,1257055200,6),(1180,1268550000,7),(1180,1289109600,6),(1180,1299999600,7),(1180,1320559200,6),(1180,1331449200,7),(1180,1352008800,6),(1180,1362898800,7),(1180,1383458400,6),(1180,1394348400,7),(1180,1414908000,6),(1180,1425798000,7),(1180,1446357600,6),(1180,1457852400,7),(1180,1478412000,6),(1180,1489302000,7),(1180,1509861600,6),(1180,1520751600,7),(1180,1541311200,6),(1180,1552201200,7),(1180,1572760800,6),(1180,1583650800,7),(1180,1604210400,6),(1180,1615705200,7),(1180,1636264800,6),(1180,1647154800,7),(1180,1667714400,6),(1180,1678604400,7),(1180,1699164000,6),(1180,1710054000,7),(1180,1730613600,6),(1180,1741503600,7),(1180,1762063200,6),(1180,1772953200,7),(1180,1793512800,6),(1180,1805007600,7),(1180,1825567200,6),(1180,1836457200,7),(1180,1857016800,6),(1180,1867906800,7),(1180,1888466400,6),(1180,1899356400,7),(1180,1919916000,6),(1180,1930806000,7),(1180,1951365600,6),(1180,1962860400,7),(1180,1983420000,6),(1180,1994310000,7),(1180,2014869600,6),(1180,2025759600,7),(1180,2046319200,6),(1180,2057209200,7),(1180,2077768800,6),(1180,2088658800,7),(1180,2109218400,6),(1180,2120108400,7),(1180,2140668000,6),(1181,-2147483648,3),(1181,-1633280400,1),(1181,-1615140000,2),(1181,-1601830800,1),(1181,-1583690400,2),(1181,-1570381200,1),(1181,-1551636000,2),(1181,-1536512400,1),(1181,-1523210400,2),(1181,-1504458000,1),(1181,-1491760800,2),(1181,-1473008400,1),(1181,-1459706400,2),(1181,-1441558800,1),(1181,-1428256800,2),(1181,-1410109200,1),(1181,-1396807200,2),(1181,-1378659600,1),(1181,-1365357600,2),(1181,-1347210000,1),(1181,-1333908000,2),(1181,-1315155600,1),(1181,-1301853600,2),(1181,-1283706000,1),(1181,-1270404000,2),(1181,-1252256400,1),(1181,-1238954400,2),(1181,-1220806800,1),(1181,-1207504800,2),(1181,-1189357200,1),(1181,-1176055200,2),(1181,-1157302800,1),(1181,-1144605600,2),(1181,-1125853200,1),(1181,-1112551200,2),(1181,-1094403600,1),(1181,-1081101600,2),(1181,-1062954000,1),(1181,-1049652000,2),(1181,-1031504400,1),(1181,-1018202400,2),(1181,-1000054800,1),(1181,-986752800,2),(1181,-968000400,1),(1181,-955303200,2),(1181,-936550800,1),(1181,-923248800,2),(1181,-905101200,1),(1181,-891799200,2),(1181,-880218000,4),(1181,-769395600,5),(1181,-765396000,2),(1181,-747248400,1),(1181,-733946400,2),(1181,-715798800,1),(1181,-702496800,2),(1181,-684349200,1),(1181,-671047200,2),(1181,-652899600,1),(1181,-639597600,2),(1181,-620845200,1),(1181,-608148000,2),(1181,-589395600,1),(1181,-576093600,2),(1181,-557946000,1),(1181,-544644000,2),(1181,-526496400,1),(1181,-513194400,2),(1181,-495046800,1),(1181,-481744800,2),(1181,-463597200,1),(1181,-447271200,2),(1181,-431542800,1),(1181,-415821600,2),(1181,-400093200,1),(1181,-384372000,2),(1181,-368643600,1),(1181,-352922400,2),(1181,-337194000,1),(1181,-321472800,2),(1181,-305744400,1),(1181,-289418400,2),(1181,-273690000,1),(1181,-257968800,2),(1181,-242240400,1),(1181,-226519200,2),(1181,-210790800,1),(1181,-195069600,2),(1181,-179341200,1),(1181,-163620000,2),(1181,-147891600,1),(1181,-131565600,2),(1181,-116442000,1),(1181,-100116000,2),(1181,-84387600,1),(1181,-68666400,2),(1181,-52938000,1),(1181,-37216800,2),(1181,-21488400,1),(1181,-5767200,2),(1181,9961200,1),(1181,25682400,2),(1181,41410800,1),(1181,57736800,2),(1181,73465200,1),(1181,89186400,2),(1181,104914800,1),(1181,120636000,2),(1181,126687600,1),(1181,152085600,2),(1181,162370800,1),(1181,183535200,2),(1181,199263600,1),(1181,215589600,2),(1181,230713200,1),(1181,247039200,2),(1181,262767600,1),(1181,278488800,2),(1181,294217200,1),(1181,309938400,2),(1181,325666800,1),(1181,341388000,2),(1181,357116400,1),(1181,372837600,2),(1181,388566000,1),(1181,404892000,2),(1181,420015600,1),(1181,436341600,2),(1181,452070000,1),(1181,467791200,2),(1181,483519600,1),(1181,499240800,2),(1181,514969200,1),(1181,530690400,2),(1181,544604400,1),(1181,562140000,2),(1181,576054000,1),(1181,594194400,2),(1181,607503600,1),(1181,625644000,2),(1181,638953200,1),(1181,657093600,2),(1181,671007600,1),(1181,688543200,2),(1181,702457200,1),(1181,719992800,2),(1181,733906800,1),(1181,752047200,2),(1181,765356400,1),(1181,783496800,2),(1181,796806000,1),(1181,814946400,2),(1181,828860400,1),(1181,846396000,2),(1181,860310000,1),(1181,877845600,2),(1181,891759600,1),(1181,909295200,2),(1181,923209200,1),(1181,941349600,2),(1181,954658800,1),(1181,972799200,2),(1181,986108400,1),(1181,1004248800,2),(1181,1018162800,1),(1181,1035698400,2),(1181,1049612400,1),(1181,1067148000,2),(1181,1081062000,1),(1181,1099202400,2),(1181,1112511600,1),(1181,1130652000,2),(1181,1143961200,1),(1181,1162101600,2),(1181,1173596400,1),(1181,1194156000,2),(1181,1205046000,1),(1181,1225605600,2),(1181,1236495600,1),(1181,1257055200,2),(1181,1268550000,1),(1181,1289109600,2),(1181,1299999600,1),(1181,1320559200,2),(1181,1331449200,1),(1181,1352008800,2),(1181,1362898800,1),(1181,1383458400,2),(1181,1394348400,1),(1181,1414908000,2),(1181,1425798000,1),(1181,1446357600,2),(1181,1457852400,1),(1181,1478412000,2),(1181,1489302000,1),(1181,1509861600,2),(1181,1520751600,1),(1181,1541311200,2),(1181,1552201200,1),(1181,1572760800,2),(1181,1583650800,1),(1181,1604210400,2),(1181,1615705200,1),(1181,1636264800,2),(1181,1647154800,1),(1181,1667714400,2),(1181,1678604400,1),(1181,1699164000,2),(1181,1710054000,1),(1181,1730613600,2),(1181,1741503600,1),(1181,1762063200,2),(1181,1772953200,1),(1181,1793512800,2),(1181,1805007600,1),(1181,1825567200,2),(1181,1836457200,1),(1181,1857016800,2),(1181,1867906800,1),(1181,1888466400,2),(1181,1899356400,1),(1181,1919916000,2),(1181,1930806000,1),(1181,1951365600,2),(1181,1962860400,1),(1181,1983420000,2),(1181,1994310000,1),(1181,2014869600,2),(1181,2025759600,1),(1181,2046319200,2),(1181,2057209200,1),(1181,2077768800,2),(1181,2088658800,1),(1181,2109218400,2),(1181,2120108400,1),(1181,2140668000,2),(1182,-2147483648,1),(1182,-1157283000,2),(1182,-1155436200,1),(1182,-880198200,3),(1182,-769395600,4),(1182,-765376200,1),(1182,-712150200,5),(1183,-2147483648,5),(1183,-1633276800,1),(1183,-1615136400,2),(1183,-1601827200,1),(1183,-1583686800,2),(1183,-880214400,3),(1183,-769395600,4),(1183,-765392400,2),(1183,-715795200,1),(1183,-702493200,2),(1183,-684345600,1),(1183,-671043600,2),(1183,-652896000,1),(1183,-639594000,2),(1183,-620841600,1),(1183,-608144400,2),(1183,-589392000,1),(1183,-576090000,2),(1183,-557942400,1),(1183,-544640400,2),(1183,-526492800,1),(1183,-513190800,2),(1183,-495043200,1),(1183,-481741200,2),(1183,-463593600,1),(1183,-447267600,2),(1183,-431539200,1),(1183,-415818000,2),(1183,-400089600,1),(1183,-386787600,2),(1183,-368640000,1),(1183,-355338000,2),(1183,-337190400,1),(1183,-321469200,2),(1183,-305740800,1),(1183,-289414800,2),(1183,-273686400,1),(1183,-257965200,2),(1183,-242236800,6),(1183,-195066000,2),(1183,-84384000,1),(1183,-68662800,2),(1183,-52934400,1),(1183,-37213200,2),(1183,-21484800,1),(1183,-5763600,2),(1183,9964800,1),(1183,25686000,2),(1183,41414400,1),(1183,57740400,2),(1183,73468800,1),(1183,89190000,2),(1183,104918400,1),(1183,120639600,2),(1183,126691200,1),(1183,152089200,2),(1183,162374400,1),(1183,183538800,2),(1183,199267200,1),(1183,215593200,2),(1183,230716800,1),(1183,247042800,2),(1183,262771200,1),(1183,278492400,2),(1183,294220800,1),(1183,309942000,2),(1183,325670400,1),(1183,341391600,2),(1183,357120000,1),(1183,372841200,2),(1183,388569600,1),(1183,404895600,2),(1183,420019200,1),(1183,436345200,2),(1183,452073600,1),(1183,467794800,2),(1183,483523200,1),(1183,499244400,2),(1183,514972800,1),(1183,530694000,2),(1183,544608000,1),(1183,562143600,2),(1183,576057600,1),(1183,594198000,2),(1183,607507200,1),(1183,625647600,2),(1183,638956800,1),(1183,657097200,2),(1183,671011200,1),(1183,688546800,6),(1183,1143961200,1),(1183,1162105200,2),(1183,1173600000,1),(1183,1194159600,2),(1183,1205049600,1),(1183,1225609200,2),(1183,1236499200,1),(1183,1257058800,2),(1183,1268553600,1),(1183,1289113200,2),(1183,1300003200,1),(1183,1320562800,2),(1183,1331452800,1),(1183,1352012400,2),(1183,1362902400,1),(1183,1383462000,2),(1183,1394352000,1),(1183,1414911600,2),(1183,1425801600,1),(1183,1446361200,2),(1183,1457856000,1),(1183,1478415600,2),(1183,1489305600,1),(1183,1509865200,2),(1183,1520755200,1),(1183,1541314800,2),(1183,1552204800,1),(1183,1572764400,2),(1183,1583654400,1),(1183,1604214000,2),(1183,1615708800,1),(1183,1636268400,2),(1183,1647158400,1),(1183,1667718000,2),(1183,1678608000,1),(1183,1699167600,2),(1183,1710057600,1),(1183,1730617200,2),(1183,1741507200,1),(1183,1762066800,2),(1183,1772956800,1),(1183,1793516400,2),(1183,1805011200,1),(1183,1825570800,2),(1183,1836460800,1),(1183,1857020400,2),(1183,1867910400,1),(1183,1888470000,2),(1183,1899360000,1),(1183,1919919600,2),(1183,1930809600,1),(1183,1951369200,2),(1183,1962864000,1),(1183,1983423600,2),(1183,1994313600,1),(1183,2014873200,2),(1183,2025763200,1),(1183,2046322800,2),(1183,2057212800,1),(1183,2077772400,2),(1183,2088662400,1),(1183,2109222000,2),(1183,2120112000,1),(1183,2140671600,2),(1184,-2147483648,0),(1184,-2051202469,1),(1184,-1724083200,2),(1184,-880218000,3),(1184,-769395600,4),(1184,-765396000,2),(1184,-684349200,5),(1184,-671047200,2),(1184,-80506740,5),(1184,-68666400,2),(1184,-52938000,5),(1184,-37216800,2),(1184,104914800,5),(1184,120636000,2),(1184,126687600,5),(1184,152085600,2),(1184,167814000,5),(1184,183535200,2),(1184,199263600,5),(1184,215589600,2),(1184,230713200,5),(1184,247039200,2),(1184,262767600,5),(1184,278488800,2),(1184,294217200,5),(1184,309938400,2),(1184,325666800,5),(1184,341388000,2),(1184,357116400,5),(1184,372837600,2),(1184,388566000,5),(1184,404892000,2),(1184,420015600,5),(1184,436341600,2),(1184,452070000,5),(1184,467791200,2),(1184,483519600,5),(1184,499240800,2),(1184,514969200,5),(1184,530690400,2),(1184,544604400,5),(1184,562140000,2),(1184,576054000,5),(1184,594194400,2),(1184,607503600,5),(1184,625644000,2),(1184,638953200,5),(1184,657093600,2),(1184,671007600,5),(1184,688543200,2),(1184,702457200,5),(1184,719992800,2),(1184,733906800,5),(1184,752047200,2),(1184,765356400,5),(1184,783496800,2),(1184,796806000,5),(1184,814946400,2),(1184,828860400,5),(1184,846396000,2),(1184,860310000,5),(1184,877845600,2),(1184,891759600,5),(1184,909295200,2),(1184,923209200,5),(1184,941349600,2),(1184,954658800,5),(1184,972799200,2),(1184,986108400,5),(1184,1004248800,2),(1184,1018162800,5),(1184,1035698400,2),(1184,1049612400,5),(1184,1067148000,2),(1184,1081062000,5),(1184,1099202400,2),(1184,1112511600,5),(1184,1130652000,2),(1184,1143961200,5),(1184,1162101600,2),(1184,1173596400,5),(1184,1194156000,2),(1184,1205046000,5),(1184,1225605600,2),(1184,1236495600,5),(1184,1257055200,2),(1184,1268550000,5),(1184,1289109600,2),(1184,1299999600,5),(1184,1320559200,2),(1184,1331449200,5),(1184,1352008800,2),(1184,1362898800,5),(1184,1383458400,2),(1184,1394348400,5),(1184,1414908000,2),(1184,1425798000,5),(1184,1446357600,2),(1184,1457852400,5),(1184,1478412000,2),(1184,1489302000,5),(1184,1509861600,2),(1184,1520751600,5),(1184,1541311200,2),(1184,1552201200,5),(1184,1572760800,2),(1184,1583650800,5),(1184,1604210400,2),(1184,1615705200,5),(1184,1636264800,2),(1184,1647154800,5),(1184,1667714400,2),(1184,1678604400,5),(1184,1699164000,2),(1184,1710054000,5),(1184,1730613600,2),(1184,1741503600,5),(1184,1762063200,2),(1184,1772953200,5),(1184,1793512800,2),(1184,1805007600,5),(1184,1825567200,2),(1184,1836457200,5),(1184,1857016800,2),(1184,1867906800,5),(1184,1888466400,2),(1184,1899356400,5),(1184,1919916000,2),(1184,1930806000,5),(1184,1951365600,2),(1184,1962860400,5),(1184,1983420000,2),(1184,1994310000,5),(1184,2014869600,2),(1184,2025759600,5),(1184,2046319200,2),(1184,2057209200,5),(1184,2077768800,2),(1184,2088658800,5),(1184,2109218400,2),(1184,2120108400,5),(1184,2140668000,2),(1185,-2147483648,3),(1185,-1633273200,1),(1185,-1615132800,2),(1185,-1601823600,1),(1185,-1583683200,2),(1185,-1570374000,1),(1185,-1551628800,2),(1185,-1538924400,1),(1185,-1534089600,2),(1185,-880210800,4),(1185,-769395600,5),(1185,-765388800,2),(1185,-147884400,1),(1185,-131558400,2),(1185,-116434800,1),(1185,-100108800,2),(1185,-84380400,1),(1185,-68659200,2),(1185,-52930800,1),(1185,-37209600,2),(1185,-21481200,1),(1185,-5760000,2),(1185,9968400,1),(1185,25689600,2),(1185,41418000,1),(1185,57744000,2),(1185,73472400,1),(1185,89193600,2),(1185,104922000,1),(1185,120643200,2),(1185,126694800,1),(1185,152092800,2),(1185,162378000,1),(1185,183542400,2),(1185,199270800,1),(1185,215596800,2),(1185,230720400,1),(1185,247046400,2),(1185,262774800,1),(1185,278496000,2),(1185,294224400,1),(1185,309945600,2),(1185,325674000,1),(1185,341395200,2),(1185,357123600,1),(1185,372844800,2),(1185,388573200,1),(1185,404899200,2),(1185,420022800,1),(1185,436348800,2),(1185,452077200,1),(1185,467798400,2),(1185,483526800,1),(1185,499248000,2),(1185,514976400,1),(1185,530697600,2),(1185,544611600,1),(1185,562147200,2),(1185,576061200,1),(1185,594201600,2),(1185,607510800,1),(1185,625651200,2),(1185,638960400,1),(1185,657100800,2),(1185,671014800,1),(1185,688550400,2),(1185,702464400,1),(1185,720000000,2),(1185,733914000,1),(1185,752054400,2),(1185,765363600,1),(1185,783504000,2),(1185,796813200,1),(1185,814953600,2),(1185,828867600,1),(1185,846403200,2),(1185,860317200,1),(1185,877852800,2),(1185,891766800,1),(1185,909302400,2),(1185,923216400,1),(1185,941356800,2),(1185,954666000,1),(1185,972806400,2),(1185,986115600,1),(1185,1004256000,2),(1185,1018170000,1),(1185,1035705600,2),(1185,1049619600,1),(1185,1067155200,2),(1185,1081069200,1),(1185,1099209600,2),(1185,1112518800,1),(1185,1130659200,2),(1185,1143968400,1),(1185,1162108800,2),(1185,1173603600,1),(1185,1194163200,2),(1185,1205053200,1),(1185,1225612800,2),(1185,1236502800,1),(1185,1257062400,2),(1185,1268557200,1),(1185,1289116800,2),(1185,1300006800,1),(1185,1320566400,2),(1185,1331456400,1),(1185,1352016000,2),(1185,1362906000,1),(1185,1383465600,2),(1185,1394355600,1),(1185,1414915200,2),(1185,1425805200,1),(1185,1446364800,2),(1185,1457859600,1),(1185,1478419200,2),(1185,1489309200,1),(1185,1509868800,2),(1185,1520758800,1),(1185,1541318400,2),(1185,1552208400,1),(1185,1572768000,2),(1185,1583658000,1),(1185,1604217600,2),(1185,1615712400,1),(1185,1636272000,2),(1185,1647162000,1),(1185,1667721600,2),(1185,1678611600,1),(1185,1699171200,2),(1185,1710061200,1),(1185,1730620800,2),(1185,1741510800,1),(1185,1762070400,2),(1185,1772960400,1),(1185,1793520000,2),(1185,1805014800,1),(1185,1825574400,2),(1185,1836464400,1),(1185,1857024000,2),(1185,1867914000,1),(1185,1888473600,2),(1185,1899363600,1),(1185,1919923200,2),(1185,1930813200,1),(1185,1951372800,2),(1185,1962867600,1),(1185,1983427200,2),(1185,1994317200,1),(1185,2014876800,2),(1185,2025766800,1),(1185,2046326400,2),(1185,2057216400,1),(1185,2077776000,2),(1185,2088666000,1),(1185,2109225600,2),(1185,2120115600,1),(1185,2140675200,2),(1186,-2147483648,5),(1186,-1633269600,1),(1186,-1615129200,2),(1186,-1601820000,1),(1186,-1583679600,2),(1186,-880207200,3),(1186,-769395600,4),(1186,-765385200,2),(1186,-687967140,1),(1186,-662655600,2),(1186,-620838000,1),(1186,-608137200,2),(1186,-589388400,1),(1186,-576082800,2),(1186,-557938800,1),(1186,-544633200,2),(1186,-526489200,1),(1186,-513183600,2),(1186,-495039600,1),(1186,-481734000,2),(1186,-463590000,1),(1186,-450284400,2),(1186,-431535600,1),(1186,-418230000,2),(1186,-400086000,1),(1186,-386780400,2),(1186,-368636400,1),(1186,-355330800,2),(1186,-337186800,1),(1186,-323881200,2),(1186,-305737200,1),(1186,-292431600,2),(1186,-273682800,1),(1186,-260982000,2),(1186,-242233200,1),(1186,-226508400,2),(1186,-210783600,1),(1186,-195058800,2),(1186,-179334000,1),(1186,-163609200,2),(1186,-147884400,1),(1186,-131554800,2),(1186,-116434800,1),(1186,-100105200,2),(1186,-84376800,1),(1186,-68655600,2),(1186,-52927200,1),(1186,-37206000,2),(1186,-21477600,1),(1186,-5756400,2),(1186,9972000,1),(1186,25693200,2),(1186,41421600,1),(1186,57747600,2),(1186,73476000,1),(1186,89197200,2),(1186,104925600,1),(1186,120646800,2),(1186,126698400,1),(1186,152096400,2),(1186,162381600,1),(1186,183546000,2),(1186,199274400,1),(1186,215600400,2),(1186,230724000,1),(1186,247050000,2),(1186,262778400,1),(1186,278499600,2),(1186,294228000,1),(1186,309949200,2),(1186,325677600,1),(1186,341398800,2),(1186,357127200,1),(1186,372848400,2),(1186,388576800,1),(1186,404902800,2),(1186,420026400,1),(1186,436352400,2),(1186,452080800,1),(1186,467802000,2),(1186,483530400,1),(1186,499251600,2),(1186,514980000,1),(1186,530701200,2),(1186,544615200,1),(1186,562150800,2),(1186,576064800,1),(1186,594205200,2),(1186,607514400,1),(1186,625654800,2),(1186,638964000,1),(1186,657104400,2),(1186,671018400,1),(1186,688554000,2),(1186,702468000,1),(1186,720003600,2),(1186,733917600,1),(1186,752058000,2),(1186,765367200,1),(1186,783507600,2),(1186,796816800,1),(1186,814957200,2),(1186,828871200,1),(1186,846406800,2),(1186,860320800,1),(1186,877856400,2),(1186,891770400,1),(1186,909306000,2),(1186,923220000,1),(1186,941360400,2),(1186,954669600,1),(1186,972810000,2),(1186,986119200,1),(1186,1004259600,2),(1186,1018173600,1),(1186,1035709200,2),(1186,1049623200,1),(1186,1067158800,2),(1186,1081072800,1),(1186,1099213200,2),(1186,1112522400,1),(1186,1130662800,2),(1186,1143972000,1),(1186,1162112400,2),(1186,1173607200,1),(1186,1194166800,2),(1186,1205056800,1),(1186,1225616400,2),(1186,1236506400,1),(1186,1257066000,2),(1186,1268560800,1),(1186,1289120400,2),(1186,1300010400,1),(1186,1320570000,2),(1186,1331460000,1),(1186,1352019600,2),(1186,1362909600,1),(1186,1383469200,2),(1186,1394359200,1),(1186,1414918800,2),(1186,1425808800,1),(1186,1446368400,2),(1186,1457863200,1),(1186,1478422800,2),(1186,1489312800,1),(1186,1509872400,2),(1186,1520762400,1),(1186,1541322000,2),(1186,1552212000,1),(1186,1572771600,2),(1186,1583661600,1),(1186,1604221200,2),(1186,1615716000,1),(1186,1636275600,2),(1186,1647165600,1),(1186,1667725200,2),(1186,1678615200,1),(1186,1699174800,2),(1186,1710064800,1),(1186,1730624400,2),(1186,1741514400,1),(1186,1762074000,2),(1186,1772964000,1),(1186,1793523600,2),(1186,1805018400,1),(1186,1825578000,2),(1186,1836468000,1),(1186,1857027600,2),(1186,1867917600,1),(1186,1888477200,2),(1186,1899367200,1),(1186,1919926800,2),(1186,1930816800,1),(1186,1951376400,2),(1186,1962871200,1),(1186,1983430800,2),(1186,1994320800,1),(1186,2014880400,2),(1186,2025770400,1),(1186,2046330000,2),(1186,2057220000,1),(1186,2077779600,2),(1186,2088669600,1),(1186,2109229200,2),(1186,2120119200,1),(1186,2140678800,2),(1187,-2147483648,1),(1187,-1861879032,2),(1190,-2147483648,1),(1190,-1688265017,3),(1190,-1656819079,2),(1190,-1641353479,3),(1190,-1627965079,4),(1190,-1618716679,2),(1190,-1596429079,4),(1190,-1593820800,5),(1190,-1589860800,6),(1190,-1542427200,7),(1190,-1539493200,8),(1190,-1525323600,7),(1190,-1522728000,6),(1190,-1491188400,9),(1190,-1247536800,6),(1190,354920400,7),(1190,370728000,6),(1190,386456400,7),(1190,402264000,6),(1190,417992400,7),(1190,433800000,6),(1190,449614800,7),(1190,465346800,10),(1190,481071600,11),(1190,496796400,10),(1190,512521200,11),(1190,528246000,10),(1190,543970800,11),(1190,559695600,10),(1190,575420400,11),(1190,591145200,10),(1190,606870000,11),(1190,622594800,10),(1190,638319600,11),(1190,654649200,10),(1190,670374000,12),(1190,686102400,13),(1190,695779200,10),(1190,701823600,11),(1190,717548400,10),(1190,733273200,11),(1190,748998000,10),(1190,764722800,11),(1190,780447600,10),(1190,796172400,11),(1190,811897200,10),(1190,828226800,11),(1190,846370800,10),(1190,859676400,11),(1190,877820400,10),(1190,891126000,11),(1190,909270000,10),(1190,922575600,11),(1190,941324400,10),(1190,954025200,11),(1190,972774000,10),(1190,985474800,11),(1190,1004223600,10),(1190,1017529200,11),(1190,1035673200,10),(1190,1048978800,11),(1190,1067122800,10),(1190,1080428400,11),(1190,1099177200,10),(1190,1111878000,11),(1190,1130626800,10),(1190,1143327600,11),(1190,1162076400,10),(1190,1174777200,11),(1190,1193526000,10),(1190,1206831600,11),(1190,1224975600,10),(1190,1238281200,11),(1190,1256425200,10),(1190,1269730800,11),(1190,1288479600,10),(1190,1301180400,14),(1190,1414274400,10),(1191,228877200,0),(1191,243997200,1),(1191,260326800,0),(1191,276051600,1),(1191,291776400,0),(1191,307501200,1),(1191,323830800,0),(1191,338950800,1),(1191,354675600,0),(1191,370400400,1),(1191,386125200,0),(1191,401850000,1),(1191,417574800,0),(1191,433299600,1),(1191,449024400,0),(1191,465354000,1),(1191,481078800,0),(1191,496803600,1),(1191,512528400,0),(1191,528253200,1),(1191,543978000,0),(1191,559702800,1),(1191,575427600,0),(1191,591152400,1),(1191,606877200,0),(1191,622602000,1),(1191,638326800,0),(1191,654656400,1),(1191,670381200,0),(1191,686106000,1),(1191,701830800,0),(1191,717555600,1),(1191,733280400,0),(1191,749005200,1),(1191,764730000,0),(1191,780454800,1),(1191,796179600,0),(1191,811904400,1),(1191,828234000,0),(1191,846378000,1),(1191,859683600,0),(1191,877827600,1),(1191,891133200,0),(1191,909277200,1),(1191,922582800,0),(1191,941331600,1),(1191,954032400,0),(1191,972781200,1),(1191,985482000,0),(1191,1004230800,1),(1191,1017536400,0),(1191,1035680400,1),(1191,1048986000,0),(1191,1067130000,1),(1191,1080435600,0),(1191,1099184400,1),(1191,1111885200,0),(1191,1130634000,1),(1191,1143334800,0),(1191,1162083600,1),(1191,1174784400,0),(1191,1193533200,1),(1191,1206838800,0),(1191,1224982800,1),(1191,1238288400,0),(1191,1256432400,1),(1191,1269738000,0),(1191,1288486800,1),(1191,1301187600,0),(1191,1319936400,1),(1191,1332637200,0),(1191,1351386000,1),(1191,1364691600,0),(1191,1382835600,1),(1191,1396141200,0),(1191,1414285200,1),(1191,1427590800,0),(1191,1445734800,1),(1191,1459040400,0),(1191,1477789200,1),(1191,1490490000,0),(1191,1509238800,1),(1191,1521939600,0),(1191,1540688400,1),(1191,1553994000,0),(1191,1572138000,1),(1191,1585443600,0),(1191,1603587600,1),(1191,1616893200,0),(1191,1635642000,1),(1191,1648342800,0),(1191,1667091600,1),(1191,1679792400,0),(1191,1698541200,1),(1191,1711846800,0),(1191,1729990800,1),(1191,1743296400,0),(1191,1761440400,1),(1191,1774746000,0),(1191,1792890000,1),(1191,1806195600,0),(1191,1824944400,1),(1191,1837645200,0),(1191,1856394000,1),(1191,1869094800,0),(1191,1887843600,1),(1191,1901149200,0),(1191,1919293200,1),(1191,1932598800,0),(1191,1950742800,1),(1191,1964048400,0),(1191,1982797200,1),(1191,1995498000,0),(1191,2014246800,1),(1191,2026947600,0),(1191,2045696400,1),(1191,2058397200,0),(1191,2077146000,1),(1191,2090451600,0),(1191,2108595600,1),(1191,2121901200,0),(1191,2140045200,1),(1193,-2147483648,3),(1193,-1633280400,1),(1193,-1615140000,2),(1193,-1601830800,1),(1193,-1583690400,2),(1193,-1570381200,1),(1193,-1551636000,2),(1193,-1536512400,1),(1193,-1523210400,2),(1193,-1504458000,1),(1193,-1491760800,2),(1193,-1473008400,1),(1193,-1459706400,2),(1193,-1441558800,1),(1193,-1428256800,2),(1193,-1410109200,1),(1193,-1396807200,2),(1193,-1378659600,1),(1193,-1365357600,2),(1193,-1347210000,1),(1193,-1333908000,2),(1193,-1315155600,1),(1193,-1301853600,2),(1193,-1283706000,1),(1193,-1270404000,2),(1193,-1252256400,1),(1193,-1238954400,2),(1193,-1220806800,1),(1193,-1207504800,2),(1193,-1189357200,1),(1193,-1176055200,2),(1193,-1157302800,1),(1193,-1144605600,2),(1193,-1125853200,1),(1193,-1112551200,2),(1193,-1094403600,1),(1193,-1081101600,2),(1193,-1062954000,1),(1193,-1049652000,2),(1193,-1031504400,1),(1193,-1018202400,2),(1193,-1000054800,1),(1193,-986752800,2),(1193,-968000400,1),(1193,-955303200,2),(1193,-936550800,1),(1193,-923248800,2),(1193,-905101200,1),(1193,-891799200,2),(1193,-880218000,4),(1193,-769395600,5),(1193,-765396000,2),(1193,-747248400,1),(1193,-733946400,2),(1193,-715798800,1),(1193,-702496800,2),(1193,-684349200,1),(1193,-671047200,2),(1193,-652899600,1),(1193,-639597600,2),(1193,-620845200,1),(1193,-608148000,2),(1193,-589395600,1),(1193,-576093600,2),(1193,-557946000,1),(1193,-544644000,2),(1193,-526496400,1),(1193,-513194400,2),(1193,-495046800,1),(1193,-481744800,2),(1193,-463597200,1),(1193,-447271200,2),(1193,-431542800,1),(1193,-415821600,2),(1193,-400093200,1),(1193,-384372000,2),(1193,-368643600,1),(1193,-352922400,2),(1193,-337194000,1),(1193,-321472800,2),(1193,-305744400,1),(1193,-289418400,2),(1193,-273690000,1),(1193,-257968800,2),(1193,-242240400,1),(1193,-226519200,2),(1193,-210790800,1),(1193,-195069600,2),(1193,-179341200,1),(1193,-163620000,2),(1193,-147891600,1),(1193,-131565600,2),(1193,-116442000,1),(1193,-100116000,2),(1193,-84387600,1),(1193,-68666400,2),(1193,-52938000,1),(1193,-37216800,2),(1193,-21488400,1),(1193,-5767200,2),(1193,9961200,1),(1193,25682400,2),(1193,41410800,1),(1193,57736800,2),(1193,73465200,1),(1193,89186400,2),(1193,104914800,1),(1193,120636000,2),(1193,126687600,1),(1193,152085600,2),(1193,162370800,1),(1193,183535200,2),(1193,199263600,1),(1193,215589600,2),(1193,230713200,1),(1193,247039200,2),(1193,262767600,1),(1193,278488800,2),(1193,294217200,1),(1193,309938400,2),(1193,325666800,1),(1193,341388000,2),(1193,357116400,1),(1193,372837600,2),(1193,388566000,1),(1193,404892000,2),(1193,420015600,1),(1193,436341600,2),(1193,452070000,1),(1193,467791200,2),(1193,483519600,1),(1193,499240800,2),(1193,514969200,1),(1193,530690400,2),(1193,544604400,1),(1193,562140000,2),(1193,576054000,1),(1193,594194400,2),(1193,607503600,1),(1193,625644000,2),(1193,638953200,1),(1193,657093600,2),(1193,671007600,1),(1193,688543200,2),(1193,702457200,1),(1193,719992800,2),(1193,733906800,1),(1193,752047200,2),(1193,765356400,1),(1193,783496800,2),(1193,796806000,1),(1193,814946400,2),(1193,828860400,1),(1193,846396000,2),(1193,860310000,1),(1193,877845600,2),(1193,891759600,1),(1193,909295200,2),(1193,923209200,1),(1193,941349600,2),(1193,954658800,1),(1193,972799200,2),(1193,986108400,1),(1193,1004248800,2),(1193,1018162800,1),(1193,1035698400,2),(1193,1049612400,1),(1193,1067148000,2),(1193,1081062000,1),(1193,1099202400,2),(1193,1112511600,1),(1193,1130652000,2),(1193,1143961200,1),(1193,1162101600,2),(1193,1173596400,1),(1193,1194156000,2),(1193,1205046000,1),(1193,1225605600,2),(1193,1236495600,1),(1193,1257055200,2),(1193,1268550000,1),(1193,1289109600,2),(1193,1299999600,1),(1193,1320559200,2),(1193,1331449200,1),(1193,1352008800,2),(1193,1362898800,1),(1193,1383458400,2),(1193,1394348400,1),(1193,1414908000,2),(1193,1425798000,1),(1193,1446357600,2),(1193,1457852400,1),(1193,1478412000,2),(1193,1489302000,1),(1193,1509861600,2),(1193,1520751600,1),(1193,1541311200,2),(1193,1552201200,1),(1193,1572760800,2),(1193,1583650800,1),(1193,1604210400,2),(1193,1615705200,1),(1193,1636264800,2),(1193,1647154800,1),(1193,1667714400,2),(1193,1678604400,1),(1193,1699164000,2),(1193,1710054000,1),(1193,1730613600,2),(1193,1741503600,1),(1193,1762063200,2),(1193,1772953200,1),(1193,1793512800,2),(1193,1805007600,1),(1193,1825567200,2),(1193,1836457200,1),(1193,1857016800,2),(1193,1867906800,1),(1193,1888466400,2),(1193,1899356400,1),(1193,1919916000,2),(1193,1930806000,1),(1193,1951365600,2),(1193,1962860400,1),(1193,1983420000,2),(1193,1994310000,1),(1193,2014869600,2),(1193,2025759600,1),(1193,2046319200,2),(1193,2057209200,1),(1193,2077768800,2),(1193,2088658800,1),(1193,2109218400,2),(1193,2120108400,1),(1193,2140668000,2),(1194,-2147483648,0),(1194,-1830383032,1),(1195,-2147483648,0),(1195,-1830383032,1),(1196,-2147483648,0),(1196,-1946168836,1),(1196,-1309746600,2),(1196,-1261969200,1),(1196,-1041388200,3),(1196,-865305900,2),(1197,-2147483648,1),(1197,-1855958961,4),(1197,-1689814800,2),(1197,-1680397200,3),(1197,-1665363600,2),(1197,-1648342800,3),(1197,-1635123600,2),(1197,-1616893200,3),(1197,-1604278800,2),(1197,-1585443600,3),(1197,-1574038800,2),(1197,-1552266000,3),(1197,-1539997200,2),(1197,-1531443600,3),(1197,-956365200,2),(1197,-950486400,4),(1197,-942012000,6),(1197,-812502000,5),(1197,-796262400,6),(1197,-781052400,5),(1197,-766630800,6),(1197,-733280400,4),(1197,-439430400,6),(1197,-212029200,4),(1197,41468400,2),(1197,54774000,3),(1197,231724806,7),(1197,246236406,6),(1197,259545607,5),(1197,275274007,6),(1197,309740408,4),(1197,325468809,7),(1197,341802009,4),(1197,357523209,6),(1198,-2147483648,0),(1198,-1946168836,1),(1198,-1309746600,2),(1198,-1261969200,1),(1198,-1041388200,3),(1198,-865305900,2),(1199,-2147483648,0),(1199,-1946168836,1),(1199,-1309746600,2),(1199,-1261969200,1),(1199,-1041388200,3),(1199,-865305900,2),(1200,-2147483648,0),(1200,-1830383032,1),(1201,-2147483648,0),(1201,-2035584815,1),(1201,-1940889600,0),(1201,-1767226415,2),(1201,-1588465800,3),(1202,-2147483648,0),(1202,-1830383032,1),(1203,-2147483648,0),(1203,-1830380400,1),(1203,157770004,2),(1204,-2147483648,0),(1204,-2109291020,1),(1205,-2147483648,0),(1205,-2035584815,1),(1205,-1940889600,0),(1205,-1767226415,2),(1205,-1588465800,3),(1206,-2147483648,0),(1206,-2109291020,1),(1207,-2147483648,2),(1207,-929844000,1),(1207,-923108400,2),(1207,-906170400,1),(1207,-892868400,2),(1207,-875844000,1),(1207,-857790000,2),(1207,-844308000,1),(1207,-825822000,2),(1207,-812685600,1),(1207,-794199600,2),(1207,-779853600,1),(1207,-762663600,2),(1207,-399088800,1),(1207,-386650800,2),(1207,-368330400,1),(1207,-355114800,2),(1207,-336790800,1),(1207,-323654400,2),(1207,-305168400,1),(1207,-292032000,2),(1207,-273632400,1),(1207,-260496000,2),(1207,-242096400,1),(1207,-228960000,2),(1207,-210560400,1),(1207,-197424000,2),(1207,-178938000,1),(1207,-165801600,2),(1207,-147402000,1),(1207,-134265600,2),(1207,-115866000,1),(1207,-102643200,2),(1207,-84330000,1),(1207,-71107200,2),(1207,-52707600,1),(1207,-39484800,2),(1207,-21171600,1),(1207,-7948800,2),(1207,10364400,1),(1207,23587200,2),(1207,41900400,1),(1207,55123200,2),(1207,73522800,1),(1207,86745601,2),(1207,105058802,1),(1207,118281602,2),(1207,136594803,1),(1207,149817603,2),(1207,168130804,1),(1207,181353604,2),(1207,199753205,1),(1207,212976005,2),(1207,231289206,1),(1207,244512006,2),(1207,262825207,1),(1207,276048007,2),(1207,294361208,1),(1207,307584008,2),(1207,325983609,1),(1207,339206409,2),(1207,357519609,1),(1207,370742410,2),(1207,396399611,1),(1207,402278411,2),(1207,426812412,1),(1207,433814412,2),(1207,452214012,1),(1207,465436812,2),(1207,483750012,1),(1207,496972813,2),(1207,515286013,1),(1207,528508813,2),(1207,546822013,1),(1207,560044813,2),(1207,578444414,1),(1207,591667214,2),(1207,610412414,1),(1207,623203214,2),(1207,641516415,1),(1207,654739215,2),(1207,673052416,1),(1207,686275216,2),(1207,704674816,1),(1207,717897617,2),(1207,736210817,1),(1207,749433618,2),(1207,767746818,1),(1207,780969619,2),(1207,799020019,3),(1207,812322019,2),(1207,830469620,3),(1207,843771620,2),(1207,861919220,3),(1207,875221221,2),(1207,893368821,3),(1207,906670821,2),(1207,925423222,3),(1207,938725222,2),(1207,956872822,3),(1207,970174822,2),(1207,988322422,3),(1207,1001624422,2),(1207,1019772022,3),(1207,1033074022,2),(1207,1051221622,3),(1207,1064523622,2),(1207,1083276022,3),(1207,1096578022,2),(1207,1114725622,3),(1207,1128027622,2),(1207,1146175223,3),(1207,1158872423,2),(1207,1177624823,3),(1207,1189112423,2),(1207,1209074423,3),(1207,1219957223,2),(1207,1240524024,3),(1207,1250802024,2),(1207,1272578424,3),(1207,1281474024,2),(1207,1284069624,1),(1207,1285880424,2),(1207,1400191225,1),(1207,1403816425,2),(1207,1406844025,1),(1207,1411678825,2),(1207,1682632827,1),(1207,1698354027,2),(1207,1714082427,1),(1207,1730408427,2),(1207,1745532027,1),(1207,1761858027,2),(1207,1776981627,1),(1207,1793307627,2),(1207,1809036027,1),(1207,1824757227,2),(1207,1840485627,1),(1207,1856206827,2),(1207,1871935227,1),(1207,1887656427,2),(1207,1903384827,1),(1207,1919710827,2),(1207,1934834427,1),(1207,1951160427,2),(1207,1966888827,1),(1207,1982610027,2),(1207,1998338427,1),(1207,2014059627,2),(1207,2029788027,1),(1207,2045509227,2),(1207,2061237627,1),(1207,2076958827,2),(1207,2092687227,1),(1207,2109013227,2),(1207,2124136827,1),(1207,2140462827,2),(1208,-2147483648,0),(1208,-1773012580,2),(1208,-956361600,1),(1208,-950490000,2),(1208,-942019200,1),(1208,-761187600,2),(1208,-617241600,1),(1208,-605149200,2),(1208,-81432000,1),(1208,-71110800,2),(1208,141264003,1),(1208,147222003,2),(1208,199756805,1),(1208,207702005,2),(1208,231292806,1),(1208,244249206,2),(1208,265507207,1),(1208,271033207,2),(1208,448243212,3),(1208,504918013,2),(1208,1212278423,1),(1208,1220223623,2),(1208,1243814424,1),(1208,1250809224,2),(1208,1272758424,1),(1208,1281222024,2),(1208,1301788824,1),(1208,1312066824,2),(1208,1335664824,1),(1208,1342749625,2),(1208,1345428025,1),(1208,1348970425,2),(1208,1367114425,1),(1208,1373162425,2),(1208,1376100025,1),(1208,1382839225,2),(1208,1396144825,1),(1208,1403920825,2),(1208,1406944825,1),(1208,1414288825,2),(1208,1427594425,1),(1208,1434247225,2),(1208,1437271226,1),(1208,1445738426,2),(1208,1459044026,1),(1208,1465092026,2),(1208,1468116026,1),(1208,1477792826,2),(1208,1490493627,1),(1208,1495332027,2),(1208,1498960827,1),(1208,1509242427,2),(1208,1521943227,1),(1208,1526176827,2),(1208,1529200827,1),(1208,1557021627,2),(1208,1560045627,1),(1208,1587261627,2),(1208,1590890427,1),(1208,1618106427,2),(1208,1621130427,1),(1208,1648346427,2),(1208,1651975227,1),(1208,1679191227,2),(1208,1682215227,1),(1208,1710036027,2),(1208,1713060027,1),(1208,1740276027,2),(1208,1743904827,1),(1208,1771120827,2),(1208,1774144827,1),(1208,1801965627,2),(1208,1804989627,1),(1208,1832205627,2),(1208,1835834427,1),(1208,1863050427,2),(1208,1866074427,1),(1208,1893290427,2),(1208,1896919227,1),(1208,1924135227,2),(1208,1927159227,1),(1208,1954980027,2),(1208,1958004027,1),(1208,1985220027,2),(1208,1988848827,1),(1208,2016064827,2),(1208,2019088827,1),(1208,2046304827,2),(1208,2049933627,1),(1208,2077149627,2),(1208,2080778427,1),(1208,2107994427,2),(1208,2111018427,1),(1208,2138234427,2),(1208,2141863227,1),(1209,-2147483648,1),(1209,-1630112400,2),(1209,-1616810400,3),(1209,-1442451600,2),(1209,-1427673600,4),(1209,-1379293200,2),(1209,-1364774400,4),(1209,-1348448400,2),(1209,-1333324800,4),(1209,-1316390400,2),(1209,-1301270400,4),(1209,-1293840000,3),(1209,-81432000,2),(1209,-71110800,3),(1209,141264003,2),(1209,147222003,3),(1209,199756805,2),(1209,207702005,3),(1209,231292806,2),(1209,244249206,3),(1209,265507207,2),(1209,271033207,3),(1209,448243212,5),(1209,512528413,6),(1209,528253213,7),(1209,543978013,6),(1209,559702813,7),(1209,575427614,6),(1209,591152414,7),(1209,606877214,6),(1209,622602014,7),(1209,638326815,6),(1209,654656415,7),(1209,670381216,6),(1209,686106016,7),(1209,701830816,6),(1209,717555617,7),(1209,733280417,6),(1209,749005218,7),(1209,764730018,6),(1209,780454819,7),(1209,796179619,6),(1209,811904419,7),(1209,828234020,6),(1209,846378020,7),(1209,859683620,6),(1209,877827621,7),(1209,891133221,6),(1209,909277221,7),(1209,922582822,6),(1209,941331622,7),(1209,954032422,6),(1209,972781222,7),(1209,985482022,6),(1209,1004230822,7),(1209,1017536422,6),(1209,1035680422,7),(1209,1048986022,6),(1209,1067130022,7),(1209,1080435622,6),(1209,1099184422,7),(1209,1111885222,6),(1209,1130634022,7),(1209,1143334823,6),(1209,1162083623,7),(1209,1174784423,6),(1209,1193533223,7),(1209,1206838823,6),(1209,1224982823,7),(1209,1238288424,6),(1209,1256432424,7),(1209,1269738024,6),(1209,1288486824,7),(1209,1301187624,6),(1209,1319936424,7),(1209,1332637224,6),(1209,1351386025,7),(1209,1364691625,6),(1209,1382835625,7),(1209,1396141225,6),(1209,1414285225,7),(1209,1427590825,6),(1209,1445734826,7),(1209,1459040426,6),(1209,1477789226,7),(1209,1490490027,6),(1209,1509238827,7),(1209,1521939627,6),(1209,1540688427,7),(1209,1553994027,6),(1209,1572138027,7),(1209,1585443627,6),(1209,1603587627,7),(1209,1616893227,6),(1209,1635642027,7),(1209,1648342827,6),(1209,1667091627,7),(1209,1679792427,6),(1209,1698541227,7),(1209,1711846827,6),(1209,1729990827,7),(1209,1743296427,6),(1209,1761440427,7),(1209,1774746027,6),(1209,1792890027,7),(1209,1806195627,6),(1209,1824944427,7),(1209,1837645227,6),(1209,1856394027,7),(1209,1869094827,6),(1209,1887843627,7),(1209,1901149227,6),(1209,1919293227,7),(1209,1932598827,6),(1209,1950742827,7),(1209,1964048427,6),(1209,1982797227,7),(1209,1995498027,6),(1209,2014246827,7),(1209,2026947627,6),(1209,2045696427,7),(1209,2058397227,6),(1209,2077146027,7),(1209,2090451627,6),(1209,2108595627,7),(1209,2121901227,6),(1209,2140045227,7),(1210,-2147483648,0),(1210,-1830383032,1),(1211,-2147483648,0),(1211,-1830383032,1),(1212,-2147483648,0),(1212,-1946168836,1),(1212,-1309746600,2),(1212,-1261969200,1),(1212,-1041388200,3),(1212,-865305900,2),(1213,-2147483648,0),(1213,-1946168836,1),(1213,-1309746600,2),(1213,-1261969200,1),(1213,-1041388200,3),(1213,-865305900,2),(1214,-2147483648,0),(1214,-2035584815,1),(1214,-1940889600,0),(1214,-1767226415,2),(1214,-1588465800,3),(1215,-2147483648,0),(1215,-1136070432,1),(1215,198291605,3),(1215,199756805,2),(1215,207702005,3),(1215,231292806,2),(1215,244249206,3),(1215,265507207,2),(1215,271033207,3),(1215,1212278423,2),(1215,1220223623,3),(1215,1243814424,2),(1215,1250809224,3),(1215,1272758424,2),(1215,1281222024,3),(1215,1301788824,2),(1215,1312066824,3),(1215,1335664824,2),(1215,1342749625,3),(1215,1345428025,2),(1215,1348970425,3),(1215,1367114425,2),(1215,1373162425,3),(1215,1376100025,2),(1215,1382839225,3),(1215,1396144825,2),(1215,1403920825,3),(1215,1406944825,2),(1215,1414288825,3),(1215,1427594425,2),(1215,1434247225,3),(1215,1437271226,2),(1215,1445738426,3),(1215,1459044026,2),(1215,1465092026,3),(1215,1468116026,2),(1215,1477792826,3),(1215,1490493627,2),(1215,1495332027,3),(1215,1498960827,2),(1215,1509242427,3),(1215,1521943227,2),(1215,1526176827,3),(1215,1529200827,2),(1215,1557021627,3),(1215,1560045627,2),(1215,1587261627,3),(1215,1590890427,2),(1215,1618106427,3),(1215,1621130427,2),(1215,1648346427,3),(1215,1651975227,2),(1215,1679191227,3),(1215,1682215227,2),(1215,1710036027,3),(1215,1713060027,2),(1215,1740276027,3),(1215,1743904827,2),(1215,1771120827,3),(1215,1774144827,2),(1215,1801965627,3),(1215,1804989627,2),(1215,1832205627,3),(1215,1835834427,2),(1215,1863050427,3),(1215,1866074427,2),(1215,1893290427,3),(1215,1896919227,2),(1215,1924135227,3),(1215,1927159227,2),(1215,1954980027,3),(1215,1958004027,2),(1215,1985220027,3),(1215,1988848827,2),(1215,2016064827,3),(1215,2019088827,2),(1215,2046304827,3),(1215,2049933627,2),(1215,2077149627,3),(1215,2080778427,2),(1215,2107994427,3),(1215,2111018427,2),(1215,2138234427,3),(1215,2141863227,2),(1216,-2147483648,0),(1216,-1830383032,1),(1217,-2147483648,0),(1217,-2109291020,1),(1218,-2147483648,0),(1218,-2109291020,1),(1219,-2147483648,1),(1219,-2109288600,3),(1219,-860976000,2),(1219,-845254800,3),(1219,-829526400,2),(1219,-813805200,3),(1220,-2147483648,0),(1220,-1230775588,2),(1220,10360800,1),(1220,24786000,2),(1220,41810400,1),(1220,56322000,2),(1220,73432800,1),(1220,87944401,2),(1220,104882402,1),(1220,119480402,2),(1220,136332003,1),(1220,151016403,2),(1220,167781604,1),(1220,182552404,2),(1220,199231205,1),(1220,214174805,2),(1220,230680806,1),(1220,245710806,2),(1220,262735207,1),(1220,277246807,2),(1220,294184808,1),(1220,308782808,2),(1220,325634409,1),(1220,340405209,2),(1220,357084009,1),(1220,371941210,2),(1220,388533610,1),(1220,403477211,2),(1220,419983211,1),(1220,435013212,2),(1220,452037612,1),(1220,466635612,2),(1220,483487212,1),(1220,498171613,2),(1220,947930422,3),(1220,1612126827,2),(1221,-2147483648,0),(1221,-1946168836,1),(1221,-1309746600,2),(1221,-1261969200,1),(1221,-1041388200,3),(1221,-865305900,2),(1222,-2147483648,0),(1222,-1230775808,2),(1222,10360800,1),(1222,24786000,2),(1222,41810400,1),(1222,56322000,2),(1222,73432800,1),(1222,87944401,2),(1222,104882402,1),(1222,119480402,2),(1222,136332003,1),(1222,151016403,2),(1222,167781604,1),(1222,182552404,2),(1222,199231205,1),(1222,214174805,2),(1222,230680806,1),(1222,245710806,2),(1222,262735207,1),(1222,277246807,2),(1222,294184808,1),(1222,308782808,2),(1222,325634409,1),(1222,340405209,2),(1222,357084009,1),(1222,371941210,2),(1222,388533610,1),(1222,403477211,2),(1222,419983211,1),(1222,435013212,2),(1222,452037612,1),(1222,466635612,2),(1222,483487212,1),(1222,498171613,2),(1222,947930422,3),(1222,1509483627,2),(1223,-2147483648,0),(1223,-2109291020,1),(1224,-2147483648,0),(1224,-2035584815,1),(1224,-1940889600,0),(1224,-1767226415,2),(1224,-1588465800,3),(1225,-2147483648,0),(1225,-2035584815,1),(1225,-1940889600,0),(1225,-1767226415,2),(1225,-1588465800,3),(1226,-2147483648,0),(1226,-2035584815,1),(1226,-1940889600,0),(1226,-1767226415,2),(1226,-1588465800,3),(1227,-2147483648,0),(1227,-1830383032,1),(1228,-2147483648,0),(1228,-2035584815,1),(1228,-1940889600,0),(1228,-1767226415,2),(1228,-1588465800,3),(1229,-2147483648,0),(1229,-2109291020,1),(1230,-2147483648,0),(1230,-2109291020,1),(1231,-2147483648,0),(1231,-2035584815,1),(1231,-1940889600,0),(1231,-1767226415,2),(1231,-1588465800,3),(1232,-2147483648,0),(1232,-2109291020,1),(1233,-2147483648,1),(1233,-2109288600,3),(1233,-860976000,2),(1233,-845254800,3),(1233,-829526400,2),(1233,-813805200,3),(1234,-2147483648,1),(1234,-2109288600,3),(1234,-860976000,2),(1234,-845254800,3),(1234,-829526400,2),(1234,-813805200,3),(1235,-2147483648,0),(1235,-1946168836,1),(1235,-1309746600,2),(1235,-1261969200,1),(1235,-1041388200,3),(1235,-865305900,2),(1236,-2147483648,1),(1236,-1604359012,2),(1236,63593070,3),(1237,-2147483648,0),(1237,-1946168836,1),(1237,-1309746600,2),(1237,-1261969200,1),(1237,-1041388200,3),(1237,-865305900,2),(1238,-2147483648,0),(1238,-1830387612,1),(1238,308703608,2),(1238,321314409,1),(1239,-2147483648,0),(1239,-2035584815,1),(1239,-1940889600,0),(1239,-1767226415,2),(1239,-1588465800,3),(1240,-2147483648,0),(1240,-1830383032,1),(1241,-2147483648,0),(1241,-1830383032,1),(1242,-2147483648,0),(1242,-2035584815,1),(1242,-1940889600,0),(1242,-1767226415,2),(1242,-1588465800,3),(1243,-2147483648,1),(1243,-1830384000,2),(1243,1514768427,3),(1243,1546304427,4),(1244,-2147483648,0),(1244,-1830383032,1),(1245,-2147483648,0),(1245,-1577926364,2),(1245,-574902000,1),(1245,-568087200,2),(1245,-512175600,1),(1245,-504928800,2),(1245,-449888400,1),(1245,-441856800,2),(1245,-347158800,3),(1245,378684010,2),(1245,386463610,1),(1245,402271211,2),(1245,417999611,1),(1245,433807212,2),(1245,449622012,1),(1245,465429612,2),(1245,481590012,1),(1245,496965613,2),(1245,512953213,1),(1245,528674413,2),(1245,544230013,1),(1245,560037613,2),(1245,575852414,1),(1245,591660014,2),(1245,607388414,1),(1245,623196014,2),(1245,641775615,3),(1245,844034420,2),(1245,860108420,1),(1245,875916021,3),(1245,1352505625,2),(1245,1364515225,1),(1245,1382659225,3),(1246,-2147483648,1),(1246,-1855958961,4),(1246,-969242400,2),(1246,-950493600,3),(1246,-941940000,2),(1246,-891136800,4),(1246,-877827600,5),(1246,-857257200,4),(1246,-844556400,5),(1246,-842918400,4),(1246,-842223600,5),(1246,-828230400,4),(1246,-812502000,5),(1246,-796269600,4),(1246,-781052400,5),(1246,-766634400,4),(1246,231202806,2),(1246,243903606,3),(1246,262825207,2),(1246,276044407,3),(1246,581122814,2),(1246,591145214,3),(1246,606870014,2),(1246,622594814,3),(1246,641516415,2),(1246,654649215,3),(1246,1114902022,2),(1246,1128038422,3),(1246,1143334823,2),(1246,1162083623,3),(1246,1174784423,2),(1246,1193533223,3),(1246,1206838823,2),(1246,1224982823,3),(1247,-2147483648,1),(1247,-2109288600,2),(1247,-860976000,3),(1247,-845254800,2),(1247,637970415,4),(1247,764200818,5),(1247,778640419,6),(1247,796780819,5),(1247,810090019,6),(1247,828835220,5),(1247,841539620,6),(1247,860284820,5),(1247,873594021,6),(1247,891734421,5),(1247,905043621,6),(1247,923184022,5),(1247,936493222,6),(1247,954633622,5),(1247,967942822,6),(1247,986083222,5),(1247,999392422,6),(1247,1018137622,5),(1247,1030842022,6),(1247,1049587222,5),(1247,1062896422,6),(1247,1081036822,5),(1247,1094346022,6),(1247,1112486422,5),(1247,1125795622,6),(1247,1143936023,5),(1247,1157245223,6),(1247,1175385623,5),(1247,1188694823,6),(1247,1207440023,5),(1247,1220749223,6),(1247,1238889624,5),(1247,1252198824,6),(1247,1270339224,5),(1247,1283648424,6),(1247,1301788824,5),(1247,1315098024,6),(1247,1333238424,5),(1247,1346547625,6),(1247,1365292825,5),(1247,1377997225,6),(1247,1396742425,5),(1247,1410051625,6),(1247,1428192025,5),(1247,1441501226,6),(1247,1459641626,5),(1247,1472950826,6),(1247,1491091227,5),(1247,1504400427,6),(1247,1508796027,4),(1248,-2147483648,1),(1248,-880196400,2),(1248,-769395600,3),(1248,-765374400,1),(1248,-86878800,4),(1248,-21466800,5),(1248,-5745600,4),(1248,9982800,5),(1248,25704000,4),(1248,41432400,5),(1248,57758400,4),(1248,73486800,5),(1248,89208001,4),(1248,104936402,5),(1248,120657602,4),(1248,126709203,5),(1248,152107203,4),(1248,162392404,5),(1248,183556804,4),(1248,199285205,5),(1248,215611205,4),(1248,230734806,5),(1248,247060806,4),(1248,262789207,5),(1248,278510407,4),(1248,294238808,5),(1248,309960008,4),(1248,325688409,5),(1248,341409609,4),(1248,357138009,5),(1248,372859210,4),(1248,388587610,5),(1248,404913611,4),(1248,420037211,5),(1248,436363212,6),(1248,439034412,8),(1248,452088012,7),(1248,467809212,8),(1248,483537612,7),(1248,499258813,8),(1248,514987213,7),(1248,530708413,8),(1248,544622413,7),(1248,562158013,8),(1248,576072014,7),(1248,594212414,8),(1248,607521614,7),(1248,625662014,8),(1248,638971215,7),(1248,657111615,8),(1248,671025616,7),(1248,688561216,8),(1248,702475216,7),(1248,720010817,8),(1248,733924817,7),(1248,752065218,8),(1248,765374418,7),(1248,783514819,8),(1248,796824019,7),(1248,814964419,8),(1248,828878420,7),(1248,846414020,8),(1248,860328020,7),(1248,877863621,8),(1248,891777621,7),(1248,909313221,8),(1248,923227222,7),(1248,941367622,8),(1248,954676822,7),(1248,972817222,8),(1248,986126422,7),(1248,1004266822,8),(1248,1018180822,7),(1248,1035716422,8),(1248,1049630422,7),(1248,1067166022,8),(1248,1081080022,7),(1248,1099220422,8),(1248,1112529622,7),(1248,1130670022,8),(1248,1143979223,7),(1248,1162119623,8),(1248,1173614423,7),(1248,1194174023,8),(1248,1205064023,7),(1248,1225623623,8),(1248,1236513624,7),(1248,1257073224,8),(1248,1268568024,7),(1248,1289127624,8),(1248,1300017624,7),(1248,1320577224,8),(1248,1331467224,7),(1248,1352026825,8),(1248,1362916825,7),(1248,1383476425,8),(1248,1394366425,7),(1248,1414926025,8),(1248,1425816025,7),(1248,1446375626,8),(1248,1457870426,7),(1248,1478430026,8),(1248,1489320027,7),(1248,1509879627,8),(1248,1520769627,7),(1248,1541329227,8),(1248,1552219227,7),(1248,1572778827,8),(1248,1583668827,7),(1248,1604228427,8),(1248,1615723227,7),(1248,1636282827,8),(1248,1647172827,7),(1248,1667732427,8),(1248,1678622427,7),(1248,1699182027,8),(1248,1710072027,7),(1248,1730631627,8),(1248,1741521627,7),(1248,1762081227,8),(1248,1772971227,7),(1248,1793530827,8),(1248,1805025627,7),(1248,1825585227,8),(1248,1836475227,7),(1248,1857034827,8),(1248,1867924827,7),(1248,1888484427,8),(1248,1899374427,7),(1248,1919934027,8),(1248,1930824027,7),(1248,1951383627,8),(1248,1962878427,7),(1248,1983438027,8),(1248,1994328027,7),(1248,2014887627,8),(1248,2025777627,7),(1248,2046337227,8),(1248,2057227227,7),(1248,2077786827,8),(1248,2088676827,7),(1248,2109236427,8),(1248,2120126427,7),(1248,2140686027,8),(1249,-2147483648,1),(1249,-880200000,2),(1249,-769395600,3),(1249,-765378000,1),(1249,-86882400,4),(1249,-21470400,5),(1249,-5749200,4),(1249,9979200,5),(1249,25700400,4),(1249,41428800,5),(1249,57754800,4),(1249,73483200,5),(1249,89204401,4),(1249,104932802,5),(1249,120654002,4),(1249,126705603,5),(1249,152103603,4),(1249,162388804,5),(1249,183553204,4),(1249,199281605,5),(1249,215607605,4),(1249,230731206,5),(1249,247057206,4),(1249,262785607,5),(1249,278506807,4),(1249,294235208,5),(1249,309956408,4),(1249,325684809,5),(1249,341406009,4),(1249,357134409,5),(1249,372855610,4),(1249,388584010,5),(1249,404910011,4),(1249,420033611,5),(1249,436359612,6),(1249,439030812,8),(1249,452084412,7),(1249,467805612,8),(1249,483534012,7),(1249,499255213,8),(1249,514983613,7),(1249,530704813,8),(1249,544618813,7),(1249,562154413,8),(1249,576068414,7),(1249,594208814,8),(1249,607518014,7),(1249,625658414,8),(1249,638967615,7),(1249,657108015,8),(1249,671022016,7),(1249,688557616,8),(1249,702471616,7),(1249,720007217,8),(1249,733921217,7),(1249,752061618,8),(1249,765370818,7),(1249,783511219,8),(1249,796820419,7),(1249,814960819,8),(1249,828874820,7),(1249,846410420,8),(1249,860324420,7),(1249,877860021,8),(1249,891774021,7),(1249,909309621,8),(1249,923223622,7),(1249,941364022,8),(1249,954673222,7),(1249,972813622,8),(1249,986122822,7),(1249,1004263222,8),(1249,1018177222,7),(1249,1035712822,8),(1249,1049626822,7),(1249,1067162422,8),(1249,1081076422,7),(1249,1099216822,8),(1249,1112526022,7),(1249,1130666422,8),(1249,1143975623,7),(1249,1162116023,8),(1249,1173610823,7),(1249,1194170423,8),(1249,1205060423,7),(1249,1225620023,8),(1249,1236510024,7),(1249,1257069624,8),(1249,1268564424,7),(1249,1289124024,8),(1249,1300014024,7),(1249,1320573624,8),(1249,1331463624,7),(1249,1352023225,8),(1249,1362913225,7),(1249,1383472825,8),(1249,1394362825,7),(1249,1414922425,8),(1249,1425812425,7),(1249,1446372026,8),(1249,1457866826,7),(1249,1478426426,8),(1249,1489316427,7),(1249,1509876027,8),(1249,1520766027,7),(1249,1541325627,8),(1249,1552215627,7),(1249,1572775227,8),(1249,1583665227,7),(1249,1604224827,8),(1249,1615719627,7),(1249,1636279227,8),(1249,1647169227,7),(1249,1667728827,8),(1249,1678618827,7),(1249,1699178427,8),(1249,1710068427,7),(1249,1730628027,8),(1249,1741518027,7),(1249,1762077627,8),(1249,1772967627,7),(1249,1793527227,8),(1249,1805022027,7),(1249,1825581627,8),(1249,1836471627,7),(1249,1857031227,8),(1249,1867921227,7),(1249,1888480827,8),(1249,1899370827,7),(1249,1919930427,8),(1249,1930820427,7),(1249,1951380027,8),(1249,1962874827,7),(1249,1983434427,8),(1249,1994324427,7),(1249,2014884027,8),(1249,2025774027,7),(1249,2046333627,8),(1249,2057223627,7),(1249,2077783227,8),(1249,2088673227,7),(1249,2109232827,8),(1249,2120122827,7),(1249,2140682427,8),(1250,-2147483648,1),(1250,-873057600,3),(1250,-769395600,2),(1250,-765399600,1),(1251,-2147483648,1),(1251,-873057600,3),(1251,-769395600,2),(1251,-765399600,1),(1252,-2147483648,0),(1252,-1767214032,2),(1252,-1206957600,1),(1252,-1191362400,2),(1252,-1175374800,1),(1252,-1159826400,2),(1252,-633819600,1),(1252,-622069200,2),(1252,-602283600,1),(1252,-591832800,2),(1252,-570747600,1),(1252,-560210400,2),(1252,-539125200,1),(1252,-531352800,2),(1252,-191365200,1),(1252,-184197600,2),(1252,-155163600,1),(1252,-150069600,2),(1252,-128898000,1),(1252,-121125600,2),(1252,-99954000,1),(1252,-89589600,2),(1252,-68418000,1),(1252,-57967200,2),(1252,499748413,1),(1252,511236013,2),(1252,530593213,1),(1252,540266413,2),(1252,562129213,1),(1252,571197614,2),(1252,592974014,1),(1252,602042414,2),(1252,624423614,1),(1252,634701615,2),(1252,813726019,1),(1252,824004020,2),(1252,844570820,1),(1252,856058420,2),(1252,876106821,1),(1252,888717621,2),(1252,908074821,1),(1252,919562422,2),(1252,938919622,1),(1252,951616822,2),(1252,970974022,1),(1252,982461622,2),(1252,1003028422,1),(1252,1013911222,2),(1252,1036292422,1),(1252,1045360822,2),(1252,1350788425,1),(1252,1361066425,2),(1253,-2147483648,1),(1253,-1567453392,2),(1253,-1233432000,3),(1253,-1222981200,2),(1253,-1205956800,3),(1253,-1194037200,2),(1253,-1172865600,3),(1253,-1162501200,2),(1253,-1141329600,3),(1253,-1130965200,2),(1253,-1109793600,3),(1253,-1099429200,2),(1253,-1078257600,3),(1253,-1067806800,2),(1253,-1046635200,3),(1253,-1036270800,2),(1253,-1015099200,3),(1253,-1004734800,2),(1253,-983563200,3),(1253,-973198800,2),(1253,-952027200,3),(1253,-941576400,2),(1253,-931032000,3),(1253,-900882000,2),(1253,-890337600,3),(1253,-833749200,2),(1253,-827265600,3),(1253,-752274000,2),(1253,-733780800,3),(1253,-197326800,2),(1253,-190843200,3),(1253,-184194000,2),(1253,-164491200,3),(1253,-152658000,2),(1253,-132955200,3),(1253,-121122000,2),(1253,-101419200,3),(1253,-86821200,2),(1253,-71092800,3),(1253,-54766800,2),(1253,-39038400,3),(1253,-23317200,2),(1253,-7588800,5),(1253,128142003,4),(1253,136605603,5),(1253,596948414,4),(1253,605066414,5),(1253,624423614,4),(1253,636516015,5),(1253,656478015,4),(1253,667965616,5),(1253,687927616,4),(1253,699415216,5),(1253,719377217,4),(1253,731469617,5),(1253,938919622,3),(1253,952052422,5),(1253,1198983623,4),(1253,1205632823,5),(1253,1224385223,4),(1253,1237082424,5),(1254,-2147483648,1),(1254,-1567453392,2),(1254,-1233432000,3),(1254,-1222981200,2),(1254,-1205956800,3),(1254,-1194037200,2),(1254,-1172865600,3),(1254,-1162501200,2),(1254,-1141329600,3),(1254,-1130965200,2),(1254,-1109793600,3),(1254,-1099429200,2),(1254,-1078257600,3),(1254,-1067806800,2),(1254,-1046635200,3),(1254,-1036270800,2),(1254,-1015099200,3),(1254,-1004734800,2),(1254,-983563200,3),(1254,-973198800,2),(1254,-952027200,3),(1254,-941576400,2),(1254,-931032000,3),(1254,-900882000,2),(1254,-890337600,3),(1254,-833749200,2),(1254,-827265600,3),(1254,-752274000,2),(1254,-733780800,3),(1254,-197326800,2),(1254,-190843200,3),(1254,-184194000,2),(1254,-164491200,3),(1254,-152658000,2),(1254,-132955200,3),(1254,-121122000,2),(1254,-101419200,3),(1254,-86821200,2),(1254,-71092800,3),(1254,-54766800,2),(1254,-39038400,3),(1254,-23317200,2),(1254,-7588800,5),(1254,128142003,4),(1254,136605603,5),(1254,596948414,4),(1254,605066414,5),(1254,624423614,4),(1254,636516015,5),(1254,656478015,4),(1254,667965616,2),(1254,687931216,4),(1254,699415216,5),(1254,719377217,4),(1254,731469617,5),(1254,938919622,3),(1254,952052422,5),(1254,1086058822,2),(1254,1087704022,5),(1254,1198983623,4),(1254,1205632823,5),(1255,-2147483648,1),(1255,-1567453392,2),(1255,-1233432000,3),(1255,-1222981200,2),(1255,-1205956800,3),(1255,-1194037200,2),(1255,-1172865600,3),(1255,-1162501200,2),(1255,-1141329600,3),(1255,-1130965200,2),(1255,-1109793600,3),(1255,-1099429200,2),(1255,-1078257600,3),(1255,-1067806800,2),(1255,-1046635200,3),(1255,-1036270800,2),(1255,-1015099200,3),(1255,-1004734800,2),(1255,-983563200,3),(1255,-973198800,2),(1255,-952027200,3),(1255,-941576400,2),(1255,-931032000,3),(1255,-900882000,2),(1255,-890337600,3),(1255,-833749200,2),(1255,-827265600,3),(1255,-752274000,2),(1255,-733780800,3),(1255,-197326800,2),(1255,-190843200,3),(1255,-184194000,2),(1255,-164491200,3),(1255,-152658000,2),(1255,-132955200,3),(1255,-121122000,2),(1255,-101419200,3),(1255,-86821200,2),(1255,-71092800,3),(1255,-54766800,2),(1255,-39038400,3),(1255,-23317200,2),(1255,-7588800,5),(1255,128142003,4),(1255,136605603,5),(1255,596948414,4),(1255,605066414,5),(1255,624423614,4),(1255,636516015,5),(1255,656478015,4),(1255,667965616,2),(1255,687931216,4),(1255,699415216,5),(1255,719377217,4),(1255,731469617,5),(1255,938919622,3),(1255,952052422,5),(1255,1086058822,2),(1255,1087704022,5),(1255,1198983623,4),(1255,1205632823,5),(1256,-2147483648,1),(1256,-1567453392,2),(1256,-1233432000,3),(1256,-1222981200,2),(1256,-1205956800,3),(1256,-1194037200,2),(1256,-1172865600,3),(1256,-1162501200,2),(1256,-1141329600,3),(1256,-1130965200,2),(1256,-1109793600,3),(1256,-1099429200,2),(1256,-1078257600,3),(1256,-1067806800,2),(1256,-1046635200,3),(1256,-1036270800,2),(1256,-1015099200,3),(1256,-1004734800,2),(1256,-983563200,3),(1256,-973198800,2),(1256,-952027200,3),(1256,-941576400,2),(1256,-931032000,3),(1256,-900882000,2),(1256,-890337600,3),(1256,-833749200,2),(1256,-827265600,3),(1256,-752274000,2),(1256,-733780800,3),(1256,-197326800,2),(1256,-190843200,3),(1256,-184194000,2),(1256,-164491200,3),(1256,-152658000,2),(1256,-132955200,3),(1256,-121122000,2),(1256,-101419200,3),(1256,-86821200,2),(1256,-71092800,3),(1256,-54766800,2),(1256,-39038400,3),(1256,-23317200,2),(1256,-7588800,5),(1256,128142003,4),(1256,136605603,5),(1256,596948414,4),(1256,605066414,5),(1256,624423614,4),(1256,636516015,5),(1256,656478015,4),(1256,667965616,2),(1256,687931216,4),(1256,699415216,5),(1256,719377217,4),(1256,731469617,5),(1256,938919622,3),(1256,952052422,5),(1256,1198983623,4),(1256,1205632823,5),(1256,1224385223,4),(1256,1237082424,5),(1257,-2147483648,1),(1257,-1567453392,2),(1257,-1233432000,3),(1257,-1222981200,2),(1257,-1205956800,3),(1257,-1194037200,2),(1257,-1172865600,3),(1257,-1162501200,2),(1257,-1141329600,3),(1257,-1130965200,2),(1257,-1109793600,3),(1257,-1099429200,2),(1257,-1078257600,3),(1257,-1067806800,2),(1257,-1046635200,3),(1257,-1036270800,2),(1257,-1015099200,3),(1257,-1004734800,2),(1257,-983563200,3),(1257,-973198800,2),(1257,-952027200,3),(1257,-941576400,2),(1257,-931032000,3),(1257,-900882000,2),(1257,-890337600,3),(1257,-833749200,2),(1257,-827265600,3),(1257,-752274000,2),(1257,-733780800,3),(1257,-197326800,2),(1257,-190843200,3),(1257,-184194000,2),(1257,-164491200,3),(1257,-152658000,2),(1257,-132955200,3),(1257,-121122000,2),(1257,-101419200,3),(1257,-86821200,2),(1257,-71092800,3),(1257,-54766800,2),(1257,-39038400,3),(1257,-23317200,2),(1257,-7588800,5),(1257,128142003,4),(1257,136605603,5),(1257,596948414,4),(1257,605066414,5),(1257,624423614,4),(1257,636516015,2),(1257,657086415,3),(1257,669178816,2),(1257,686721616,4),(1257,699415216,5),(1257,719377217,4),(1257,731469617,5),(1257,938919622,3),(1257,952052422,5),(1257,1198983623,4),(1257,1205632823,5),(1258,-2147483648,1),(1258,-1567453392,2),(1258,-1233432000,3),(1258,-1222981200,2),(1258,-1205956800,3),(1258,-1194037200,2),(1258,-1172865600,3),(1258,-1162501200,2),(1258,-1141329600,3),(1258,-1130965200,2),(1258,-1109793600,3),(1258,-1099429200,2),(1258,-1078257600,3),(1258,-1067806800,2),(1258,-1046635200,3),(1258,-1036270800,2),(1258,-1015099200,3),(1258,-1004734800,2),(1258,-983563200,3),(1258,-973198800,2),(1258,-952027200,3),(1258,-941576400,2),(1258,-931032000,3),(1258,-900882000,2),(1258,-890337600,3),(1258,-833749200,2),(1258,-827265600,3),(1258,-752274000,2),(1258,-733780800,3),(1258,-197326800,2),(1258,-190843200,3),(1258,-184194000,2),(1258,-164491200,3),(1258,-152658000,2),(1258,-132955200,3),(1258,-121122000,2),(1258,-101419200,3),(1258,-86821200,2),(1258,-71092800,3),(1258,-54766800,2),(1258,-39038400,3),(1258,-23317200,2),(1258,-7588800,5),(1258,128142003,4),(1258,136605603,5),(1258,596948414,4),(1258,605066414,5),(1258,624423614,4),(1258,636516015,5),(1258,656478015,4),(1258,667792816,2),(1258,673588816,5),(1258,687927616,4),(1258,699415216,5),(1258,719377217,4),(1258,731469617,5),(1258,938919622,3),(1258,952052422,5),(1258,1086058822,2),(1258,1087704022,5),(1258,1198983623,4),(1258,1205632823,5),(1259,-2147483648,1),(1259,-1567453392,2),(1259,-1233432000,3),(1259,-1222981200,2),(1259,-1205956800,3),(1259,-1194037200,2),(1259,-1172865600,3),(1259,-1162501200,2),(1259,-1141329600,3),(1259,-1130965200,2),(1259,-1109793600,3),(1259,-1099429200,2),(1259,-1078257600,3),(1259,-1067806800,2),(1259,-1046635200,3),(1259,-1036270800,2),(1259,-1015099200,3),(1259,-1004734800,2),(1259,-983563200,3),(1259,-973198800,2),(1259,-952027200,3),(1259,-941576400,2),(1259,-931032000,3),(1259,-900882000,2),(1259,-890337600,3),(1259,-833749200,2),(1259,-827265600,3),(1259,-752274000,2),(1259,-733780800,3),(1259,-197326800,2),(1259,-190843200,3),(1259,-184194000,2),(1259,-164491200,3),(1259,-152658000,2),(1259,-132955200,3),(1259,-121122000,2),(1259,-101419200,3),(1259,-86821200,2),(1259,-71092800,3),(1259,-54766800,2),(1259,-39038400,3),(1259,-23317200,2),(1259,-7588800,5),(1259,128142003,4),(1259,136605603,5),(1259,596948414,4),(1259,605066414,5),(1259,624423614,4),(1259,636516015,2),(1259,655963215,3),(1259,667796416,2),(1259,687499216,3),(1259,699418816,2),(1259,719380817,4),(1259,731469617,5),(1259,938919622,3),(1259,952052422,5),(1259,1085281222,2),(1259,1096171222,5),(1259,1198983623,4),(1259,1205632823,5),(1260,-2147483648,1),(1260,-1567453392,2),(1260,-1233432000,3),(1260,-1222981200,2),(1260,-1205956800,3),(1260,-1194037200,2),(1260,-1172865600,3),(1260,-1162501200,2),(1260,-1141329600,3),(1260,-1130965200,2),(1260,-1109793600,3),(1260,-1099429200,2),(1260,-1078257600,3),(1260,-1067806800,2),(1260,-1046635200,3),(1260,-1036270800,2),(1260,-1015099200,3),(1260,-1004734800,2),(1260,-983563200,3),(1260,-973198800,2),(1260,-952027200,3),(1260,-941576400,2),(1260,-931032000,3),(1260,-900882000,2),(1260,-890337600,3),(1260,-833749200,2),(1260,-827265600,3),(1260,-752274000,2),(1260,-733780800,3),(1260,-197326800,2),(1260,-190843200,3),(1260,-184194000,2),(1260,-164491200,3),(1260,-152658000,2),(1260,-132955200,3),(1260,-121122000,2),(1260,-101419200,3),(1260,-86821200,2),(1260,-71092800,3),(1260,-54766800,2),(1260,-39038400,3),(1260,-23317200,2),(1260,-7588800,5),(1260,128142003,4),(1260,136605603,5),(1260,596948414,4),(1260,605066414,5),(1260,624423614,4),(1260,636516015,5),(1260,656478015,4),(1260,667965616,5),(1260,687927616,4),(1260,699415216,5),(1260,719377217,4),(1260,731469617,5),(1260,938919622,3),(1260,952052422,5),(1260,1086058822,2),(1260,1087704022,5),(1260,1198983623,4),(1260,1205632823,5),(1261,-2147483648,1),(1261,-1567453392,2),(1261,-1233432000,3),(1261,-1222981200,2),(1261,-1205956800,3),(1261,-1194037200,2),(1261,-1172865600,3),(1261,-1162501200,2),(1261,-1141329600,3),(1261,-1130965200,2),(1261,-1109793600,3),(1261,-1099429200,2),(1261,-1078257600,3),(1261,-1067806800,2),(1261,-1046635200,3),(1261,-1036270800,2),(1261,-1015099200,3),(1261,-1004734800,2),(1261,-983563200,3),(1261,-973198800,2),(1261,-952027200,3),(1261,-941576400,2),(1261,-931032000,3),(1261,-900882000,2),(1261,-890337600,3),(1261,-833749200,2),(1261,-827265600,3),(1261,-752274000,2),(1261,-733780800,3),(1261,-197326800,2),(1261,-190843200,3),(1261,-184194000,2),(1261,-164491200,3),(1261,-152658000,2),(1261,-132955200,3),(1261,-121122000,2),(1261,-101419200,3),(1261,-86821200,2),(1261,-71092800,3),(1261,-54766800,2),(1261,-39038400,3),(1261,-23317200,2),(1261,-7588800,5),(1261,128142003,4),(1261,136605603,5),(1261,596948414,4),(1261,605066414,5),(1261,624423614,4),(1261,636516015,5),(1261,656478015,4),(1261,667965616,2),(1261,687931216,4),(1261,699415216,5),(1261,719377217,4),(1261,731469617,5),(1261,938919622,3),(1261,952052422,5),(1261,1198983623,4),(1261,1205632823,5),(1262,-2147483648,1),(1262,-1567453392,2),(1262,-1233432000,3),(1262,-1222981200,2),(1262,-1205956800,3),(1262,-1194037200,2),(1262,-1172865600,3),(1262,-1162501200,2),(1262,-1141329600,3),(1262,-1130965200,2),(1262,-1109793600,3),(1262,-1099429200,2),(1262,-1078257600,3),(1262,-1067806800,2),(1262,-1046635200,3),(1262,-1036270800,2),(1262,-1015099200,3),(1262,-1004734800,2),(1262,-983563200,3),(1262,-973198800,2),(1262,-952027200,3),(1262,-941576400,2),(1262,-931032000,3),(1262,-900882000,2),(1262,-890337600,3),(1262,-833749200,2),(1262,-827265600,3),(1262,-752274000,2),(1262,-733780800,3),(1262,-197326800,2),(1262,-190843200,3),(1262,-184194000,2),(1262,-164491200,3),(1262,-152658000,2),(1262,-132955200,3),(1262,-121122000,2),(1262,-101419200,3),(1262,-86821200,2),(1262,-71092800,3),(1262,-54766800,2),(1262,-39038400,3),(1262,-23317200,2),(1262,-7588800,5),(1262,128142003,4),(1262,136605603,5),(1262,596948414,4),(1262,605066414,5),(1262,624423614,4),(1262,636516015,5),(1262,656478015,4),(1262,667792816,2),(1262,673588816,5),(1262,687927616,4),(1262,699415216,5),(1262,719377217,4),(1262,731469617,5),(1262,938919622,3),(1262,952052422,5),(1262,1085972422,2),(1262,1090728022,5),(1262,1198983623,4),(1262,1205632823,5),(1263,-2147483648,1),(1263,-1567453392,2),(1263,-1233432000,3),(1263,-1222981200,2),(1263,-1205956800,3),(1263,-1194037200,2),(1263,-1172865600,3),(1263,-1162501200,2),(1263,-1141329600,3),(1263,-1130965200,2),(1263,-1109793600,3),(1263,-1099429200,2),(1263,-1078257600,3),(1263,-1067806800,2),(1263,-1046635200,3),(1263,-1036270800,2),(1263,-1015099200,3),(1263,-1004734800,2),(1263,-983563200,3),(1263,-973198800,2),(1263,-952027200,3),(1263,-941576400,2),(1263,-931032000,3),(1263,-900882000,2),(1263,-890337600,3),(1263,-833749200,2),(1263,-827265600,3),(1263,-752274000,2),(1263,-733780800,3),(1263,-197326800,2),(1263,-190843200,3),(1263,-184194000,2),(1263,-164491200,3),(1263,-152658000,2),(1263,-132955200,3),(1263,-121122000,2),(1263,-101419200,3),(1263,-86821200,2),(1263,-71092800,3),(1263,-54766800,2),(1263,-39038400,3),(1263,-23317200,2),(1263,-7588800,5),(1263,128142003,4),(1263,136605603,5),(1263,596948414,4),(1263,605066414,5),(1263,624423614,4),(1263,637380015,2),(1263,655963215,3),(1263,667796416,2),(1263,675748816,5),(1263,938919622,3),(1263,952052422,5),(1263,1085972422,2),(1263,1090728022,5),(1263,1198983623,4),(1263,1200880823,3),(1263,1205031623,2),(1263,1223784023,3),(1263,1236481224,2),(1263,1255233624,5),(1264,-2147483648,1),(1264,-1567453392,2),(1264,-1233432000,3),(1264,-1222981200,2),(1264,-1205956800,3),(1264,-1194037200,2),(1264,-1172865600,3),(1264,-1162501200,2),(1264,-1141329600,3),(1264,-1130965200,2),(1264,-1109793600,3),(1264,-1099429200,2),(1264,-1078257600,3),(1264,-1067806800,2),(1264,-1046635200,3),(1264,-1036270800,2),(1264,-1015099200,3),(1264,-1004734800,2),(1264,-983563200,3),(1264,-973198800,2),(1264,-952027200,3),(1264,-941576400,2),(1264,-931032000,3),(1264,-900882000,2),(1264,-890337600,3),(1264,-833749200,2),(1264,-827265600,3),(1264,-752274000,2),(1264,-733780800,3),(1264,-197326800,2),(1264,-190843200,3),(1264,-184194000,2),(1264,-164491200,3),(1264,-152658000,2),(1264,-132955200,3),(1264,-121122000,2),(1264,-101419200,3),(1264,-86821200,2),(1264,-71092800,3),(1264,-54766800,2),(1264,-39038400,3),(1264,-23317200,2),(1264,-7588800,5),(1264,128142003,4),(1264,136605603,5),(1264,596948414,4),(1264,605066414,5),(1264,624423614,4),(1264,636516015,5),(1264,656478015,4),(1264,667965616,2),(1264,687931216,4),(1264,699415216,5),(1264,719377217,4),(1264,731469617,5),(1264,938919622,3),(1264,952052422,5),(1264,1086058822,2),(1264,1087099222,5),(1264,1198983623,4),(1264,1205632823,5),(1264,1224385223,4),(1264,1237082424,5),(1265,-2147483648,1),(1265,-1567453392,2),(1265,-1233432000,3),(1265,-1222981200,2),(1265,-1205956800,3),(1265,-1194037200,2),(1265,-1172865600,3),(1265,-1162501200,2),(1265,-1141329600,3),(1265,-1130965200,2),(1265,-1109793600,3),(1265,-1099429200,2),(1265,-1078257600,3),(1265,-1067806800,2),(1265,-1046635200,3),(1265,-1036270800,2),(1265,-1015099200,3),(1265,-1004734800,2),(1265,-983563200,3),(1265,-973198800,2),(1265,-952027200,3),(1265,-941576400,2),(1265,-931032000,3),(1265,-900882000,2),(1265,-890337600,3),(1265,-833749200,2),(1265,-827265600,3),(1265,-752274000,2),(1265,-733780800,3),(1265,-197326800,2),(1265,-190843200,3),(1265,-184194000,2),(1265,-164491200,3),(1265,-152658000,2),(1265,-132955200,3),(1265,-121122000,2),(1265,-101419200,3),(1265,-86821200,2),(1265,-71092800,3),(1265,-54766800,2),(1265,-39038400,3),(1265,-23317200,2),(1265,-7588800,5),(1265,128142003,4),(1265,136605603,5),(1265,596948414,4),(1265,605066414,5),(1265,624423614,4),(1265,636516015,5),(1265,656478015,4),(1265,667965616,5),(1265,687927616,4),(1265,699415216,5),(1265,719377217,4),(1265,731469617,5),(1265,938919622,3),(1265,952052422,5),(1265,1085886022,2),(1265,1087704022,5),(1265,1198983623,4),(1265,1205632823,5),(1266,-2147483648,1),(1266,-873057600,3),(1266,-769395600,2),(1266,-765399600,1),(1267,-2147483648,1),(1267,-1206389360,2),(1267,86760001,3),(1267,134017203,2),(1267,181368004,4),(1267,194497205,2),(1267,212990405,4),(1267,226033206,2),(1267,244526406,4),(1267,257569207,2),(1267,276062407,4),(1267,291783608,2),(1267,307598408,4),(1267,323406009,2),(1267,339220809,4),(1267,354942009,2),(1267,370756810,4),(1267,386478010,2),(1267,402292811,4),(1267,418014011,2),(1267,433828812,4),(1267,449636412,2),(1267,465451212,4),(1267,481172412,2),(1267,496987213,4),(1267,512708413,2),(1267,528523213,4),(1267,544244413,2),(1267,560059213,4),(1267,575866814,2),(1267,591681614,4),(1267,607402814,2),(1267,625032014,4),(1267,638938815,2),(1267,654753615,4),(1267,670474816,2),(1267,686721616,4),(1267,699418816,2),(1267,718257617,4),(1267,733546817,2),(1267,749448018,4),(1267,762318018,2),(1267,780984019,4),(1267,793767619,2),(1267,812520019,4),(1267,825649220,2),(1267,844574420,4),(1267,856666820,2),(1267,876024021,4),(1267,888721221,2),(1267,907473621,4),(1267,920775622,2),(1267,938923222,4),(1267,952225222,2),(1267,970372822,4),(1267,983674822,2),(1267,1002427222,4),(1267,1018148422,2),(1267,1030852822,4),(1267,1049598022,2),(1267,1062907222,4),(1267,1081047622,2),(1267,1097985622,4),(1267,1110682822,2),(1267,1129435222,4),(1267,1142132423,2),(1267,1160884823,4),(1267,1173582023,2),(1267,1192939223,4),(1267,1205031623,2),(1267,1224388823,4),(1267,1236481224,2),(1267,1255838424,4),(1267,1270954824,2),(1267,1286078424,4),(1267,1302404424,2),(1267,1317528024,4),(1267,1333854024,2),(1267,1349582425,4),(1267,1364094025,2),(1267,1381032025,4),(1267,1395543625,2),(1267,1412481625,4),(1267,1426993225,2),(1267,1443931226,4),(1267,1459047626,2),(1267,1475380826,4),(1267,1490497227,2),(1267,1506830427,4),(1267,1521946827,2),(1267,1538884827,4),(1267,1553396427,2),(1267,1570334427,4),(1267,1584846027,2),(1267,1601784027,4),(1267,1616900427,2),(1267,1633233627,4),(1267,1648350027,2),(1267,1664683227,4),(1267,1679799627,2),(1267,1696132827,4),(1267,1711249227,2),(1267,1728187227,4),(1267,1742698827,2),(1267,1759636827,4),(1267,1774148427,2),(1267,1791086427,4),(1267,1806202827,2),(1267,1822536027,4),(1267,1837652427,2),(1267,1853985627,4),(1267,1869102027,2),(1267,1886040027,4),(1267,1900551627,2),(1267,1917489627,4),(1267,1932001227,2),(1267,1948939227,4),(1267,1964055627,2),(1267,1980388827,4),(1267,1995505227,2),(1267,2011838427,4),(1267,2026954827,2),(1267,2043288027,4),(1267,2058404427,2),(1267,2075342427,4),(1267,2089854027,2),(1267,2106792027,4),(1267,2121303627,2),(1267,2138241627,4),(1268,-2147483648,1),(1268,-1946918424,2),(1269,-2147483648,1),(1269,-880196400,2),(1269,-769395600,3),(1269,-765374400,1),(1269,-86878800,4),(1269,-21466800,5),(1269,-5745600,4),(1269,9982800,5),(1269,25704000,4),(1269,41432400,5),(1269,57758400,4),(1269,73486800,5),(1269,89208001,4),(1269,104936402,5),(1269,120657602,4),(1269,126709203,5),(1269,152107203,4),(1269,162392404,5),(1269,183556804,4),(1269,199285205,5),(1269,215611205,4),(1269,230734806,5),(1269,247060806,4),(1269,262789207,5),(1269,278510407,4),(1269,294238808,5),(1269,309960008,4),(1269,325688409,5),(1269,341409609,4),(1269,357138009,5),(1269,372859210,4),(1269,388587610,5),(1269,404913611,4),(1269,420037211,5),(1269,436363212,6),(1269,439034412,8),(1269,452088012,7),(1269,467809212,8),(1269,483537612,7),(1269,499258813,8),(1269,514987213,7),(1269,530708413,8),(1269,544622413,7),(1269,562158013,8),(1269,576072014,7),(1269,594212414,8),(1269,607521614,7),(1269,625662014,8),(1269,638971215,7),(1269,657111615,8),(1269,671025616,7),(1269,688561216,8),(1269,702475216,7),(1269,720010817,8),(1269,733924817,7),(1269,752065218,8),(1269,765374418,7),(1269,783514819,8),(1269,796824019,7),(1269,814964419,8),(1269,828878420,7),(1269,846414020,8),(1269,860328020,7),(1269,877863621,8),(1269,891777621,7),(1269,909313221,8),(1269,923227222,7),(1269,941367622,8),(1269,954676822,7),(1269,972817222,8),(1269,986126422,7),(1269,1004266822,8),(1269,1018180822,7),(1269,1035716422,8),(1269,1049630422,7),(1269,1067166022,8),(1269,1081080022,7),(1269,1099220422,8),(1269,1112529622,7),(1269,1130670022,8),(1269,1143979223,7),(1269,1162119623,8),(1269,1173614423,7),(1269,1194174023,8),(1269,1205064023,7),(1269,1225623623,8),(1269,1236513624,7),(1269,1257073224,8),(1269,1268568024,7),(1269,1289127624,8),(1269,1300017624,7),(1269,1320577224,8),(1269,1331467224,7),(1269,1352026825,8),(1269,1362916825,7),(1269,1383476425,8),(1269,1394366425,7),(1269,1414926025,8),(1269,1425816025,7),(1269,1446375626,8),(1269,1457870426,7),(1269,1478430026,8),(1269,1489320027,7),(1269,1509879627,8),(1269,1520769627,7),(1269,1541329227,8),(1269,1552219227,7),(1269,1572778827,8),(1269,1583668827,7),(1269,1604228427,8),(1269,1615723227,7),(1269,1636282827,8),(1269,1647172827,7),(1269,1667732427,8),(1269,1678622427,7),(1269,1699182027,8),(1269,1710072027,7),(1269,1730631627,8),(1269,1741521627,7),(1269,1762081227,8),(1269,1772971227,7),(1269,1793530827,8),(1269,1805025627,7),(1269,1825585227,8),(1269,1836475227,7),(1269,1857034827,8),(1269,1867924827,7),(1269,1888484427,8),(1269,1899374427,7),(1269,1919934027,8),(1269,1930824027,7),(1269,1951383627,8),(1269,1962878427,7),(1269,1983438027,8),(1269,1994328027,7),(1269,2014887627,8),(1269,2025777627,7),(1269,2046337227,8),(1269,2057227227,7),(1269,2077786827,8),(1269,2088676827,7),(1269,2109236427,8),(1269,2120126427,7),(1269,2140686027,8),(1270,-2147483648,0),(1270,-1767216356,2),(1270,-1206957600,1),(1270,-1191362400,2),(1270,-1175374800,1),(1270,-1159826400,2),(1270,-633819600,1),(1270,-622069200,2),(1270,-602283600,1),(1270,-591832800,2),(1270,-570747600,1),(1270,-560210400,2),(1270,-539125200,1),(1270,-531352800,2),(1270,-191365200,1),(1270,-184197600,2),(1270,-155163600,1),(1270,-150069600,2),(1270,-128898000,1),(1270,-121125600,2),(1270,-99954000,1),(1270,-89589600,2),(1270,-68418000,1),(1270,-57967200,2),(1270,499748413,1),(1270,511236013,2),(1270,530593213,1),(1270,540266413,2),(1270,562129213,1),(1270,571197614,2),(1270,592974014,1),(1270,602042414,2),(1270,624423614,1),(1270,634701615,2),(1270,656478015,1),(1270,666756016,2),(1270,687927616,1),(1270,697600816,2),(1270,719982017,1),(1270,728445617,2),(1270,750826818,1),(1270,761709618,2),(1270,782276419,1),(1270,793159219,2),(1270,813726019,1),(1270,824004020,2),(1270,844570820,1),(1270,856058420,2),(1270,876106821,1),(1270,888717621,2),(1270,908074821,1),(1270,919562422,2),(1270,938919622,1),(1270,951616822,2),(1270,970974022,1),(1270,982461622,2),(1270,1003028422,1),(1270,1013911222,2),(1270,1036292422,1),(1270,1045360822,2),(1270,1318734024,1),(1270,1330221624,2),(1271,-2147483648,0),(1271,-1514739600,1),(1271,-1343066400,2),(1271,-1234807200,4),(1271,-1220292000,3),(1271,-1207159200,4),(1271,-1191344400,2),(1271,-873828000,4),(1271,-661539600,5),(1271,28800,4),(1271,828867620,3),(1271,846403220,4),(1271,860317220,3),(1271,877852821,4),(1271,891766821,3),(1271,909302421,4),(1271,923216422,3),(1271,941356822,4),(1271,954666022,3),(1271,972806422,4),(1271,989139622,3),(1271,1001836822,4),(1271,1018170022,3),(1271,1035705622,4),(1271,1049619622,3),(1271,1067155222,4),(1271,1081069222,3),(1271,1099209622,4),(1271,1112518822,3),(1271,1130659222,4),(1271,1143968423,3),(1271,1162108823,4),(1271,1175418023,3),(1271,1193558423,4),(1271,1207472423,3),(1271,1225008023,4),(1271,1238922024,3),(1271,1256457624,4),(1271,1270371624,6),(1271,1288508424,2),(1271,1301817624,6),(1271,1319958024,2),(1271,1333267224,6),(1271,1351407625,2),(1271,1365321625,6),(1271,1382857225,2),(1271,1396771225,6),(1271,1414306825,2),(1271,1428220825,6),(1271,1445756426,2),(1271,1459670426,6),(1271,1477810826,2),(1271,1491120027,6),(1271,1509260427,2),(1271,1522569627,6),(1271,1540710027,2),(1271,1554624027,6),(1271,1572159627,2),(1271,1586073627,6),(1271,1603609227,2),(1271,1617523227,6),(1271,1635663627,2),(1271,1648972827,6),(1271,1667113227,2),(1272,-2147483648,0),(1272,-1841256091,3),(1272,-874263600,1),(1272,-862682400,2),(1272,-841604400,1),(1272,-830714400,2),(1272,-820526400,3),(1272,-811882800,4),(1272,-798660000,2),(1272,-788904000,3),(1272,234943206,5),(1272,244616406,3),(1272,261554407,5),(1272,276066007,3),(1272,293004008,5),(1272,307515608,3),(1272,325058409,5),(1272,338706009,3),(1273,-2147483648,0),(1273,-1767213964,2),(1273,-1206957600,1),(1273,-1191362400,2),(1273,-1175374800,1),(1273,-1159826400,2),(1273,-633819600,1),(1273,-622069200,2),(1273,-602283600,1),(1273,-591832800,2),(1273,-570747600,1),(1273,-560210400,2),(1273,-539125200,1),(1273,-531352800,2),(1273,-191365200,1),(1273,-184197600,2),(1273,-155163600,1),(1273,-150069600,2),(1273,-128898000,1),(1273,-121125600,2),(1273,-99954000,1),(1273,-89589600,2),(1273,-68418000,1),(1273,-57967200,2),(1273,499748413,1),(1273,511236013,2),(1273,530593213,1),(1273,540266413,2),(1273,562129213,1),(1273,571197614,2),(1274,-2147483648,0),(1274,-1822500432,2),(1274,-1616954400,1),(1274,-1606069800,2),(1274,-1585504800,1),(1274,-1574015400,2),(1274,-1554055200,1),(1274,-1542565800,2),(1274,-1522605600,1),(1274,-1511116200,2),(1274,-1490551200,1),(1274,-1479666600,2),(1274,-1459101600,1),(1274,-1448217000,2),(1274,-1427652000,1),(1274,-1416162600,2),(1274,-1396202400,1),(1274,-1384713000,2),(1274,-1364752800,1),(1274,-1353263400,2),(1274,-1333303200,1),(1274,-1321813800,2),(1274,-1301248800,1),(1274,-1290364200,2),(1274,-1269799200,1),(1274,-1258914600,2),(1274,-1238349600,1),(1274,-1226860200,2),(1274,-1206900000,1),(1274,-1195410600,2),(1274,-1175450400,1),(1274,-1163961000,2),(1274,-1143396000,1),(1274,-1132511400,2),(1274,-1111946400,1),(1274,-1101061800,2),(1274,-1080496800,1),(1274,-1069612200,2),(1274,-1049047200,1),(1274,-1037557800,2),(1274,-1017597600,1),(1274,-1006108200,2),(1274,-986148000,1),(1274,-974658600,2),(1274,-954093600,1),(1274,-943209000,2),(1274,-922644000,1),(1274,-911759400,2),(1274,-891194400,1),(1274,-879705000,2),(1274,-868212000,3),(1274,-769395600,4),(1274,-758746800,2),(1274,-701892000,1),(1274,-690402600,2),(1274,-670442400,1),(1274,-658953000,2),(1274,-638992800,1),(1274,-627503400,2),(1274,-606938400,1),(1274,-596053800,2),(1274,-575488800,1),(1274,-564604200,2),(1274,-544039200,1),(1274,-532549800,2),(1274,-512589600,1),(1274,-501100200,2),(1274,-481140000,1),(1274,-469650600,2),(1274,-449690400,1),(1274,-438201000,2),(1274,-417636000,1),(1274,-406751400,2),(1274,-386186400,1),(1274,-375301800,2),(1274,-354736800,1),(1274,-343247400,2),(1274,-323287200,1),(1274,-311797800,2),(1274,-291837600,1),(1274,-280348200,2),(1274,-259783200,1),(1274,-248898600,2),(1274,-228333600,1),(1274,-217449000,2),(1274,-196884000,1),(1274,-185999400,2),(1274,-165434400,1),(1274,-153945000,2),(1274,-133984800,1),(1274,-122495400,2),(1274,-102535200,1),(1274,-91045800,2),(1274,-70480800,1),(1274,-59596200,2),(1274,123919202,5),(1274,129618003,2),(1274,409039211,5),(1274,413874011,2),(1275,-2147483648,1),(1275,-873057600,3),(1275,-769395600,2),(1275,-765399600,1),(1276,-2147483648,0),(1276,-1767211040,2),(1276,-1206954000,1),(1276,-1191358800,2),(1276,-1175371200,1),(1276,-1159822800,2),(1276,-633816000,1),(1276,-622065600,2),(1276,-602280000,1),(1276,-591829200,2),(1276,-570744000,1),(1276,-560206800,2),(1276,-539121600,1),(1276,-531349200,2),(1276,-191361600,1),(1276,-184194000,2),(1276,-155160000,1),(1276,-150066000,2),(1276,-128894400,1),(1276,-121122000,2),(1276,-99950400,1),(1276,-89586000,2),(1276,-68414400,1),(1276,-57963600,2),(1276,499752013,1),(1276,511239613,2),(1276,530596813,1),(1276,540270013,2),(1276,562132813,1),(1276,571201214,2),(1276,938923222,1),(1276,951620422,2),(1276,970977622,1),(1276,971578822,2),(1277,-2147483648,1),(1277,-1739041424,3),(1277,704869216,2),(1277,729057617,3),(1278,-2147483648,3),(1278,-1633269600,1),(1278,-1615129200,2),(1278,-1601820000,1),(1278,-1583679600,2),(1278,-1471788000,6),(1278,-880210800,4),(1278,-769395600,5),(1278,-765388800,6),(1278,-84380400,7),(1278,-68659200,6),(1278,-52930800,7),(1278,-37209600,6),(1278,-21481200,7),(1278,-5760000,6),(1278,9968400,7),(1278,25689600,6),(1278,41418000,7),(1278,57744000,6),(1278,73472400,7),(1278,89193601,6),(1278,104922002,7),(1278,120643202,6),(1278,129114003,7),(1278,152092803,6),(1278,162378004,7),(1278,183542404,6),(1278,199270805,7),(1278,215596805,6),(1278,230720406,7),(1278,247046406,6),(1278,262774807,7),(1278,278496007,6),(1278,294224408,7),(1278,309945608,6),(1278,325674009,7),(1278,341395209,6),(1278,357123609,7),(1278,372844810,6),(1278,388573210,7),(1278,404899211,6),(1278,420022811,7),(1278,436348812,6),(1278,452077212,7),(1278,467798412,6),(1278,483526812,7),(1278,499248013,6),(1278,514976413,7),(1278,530697613,6),(1278,544611613,7),(1278,562147213,6),(1278,576061214,7),(1278,594201614,6),(1278,607510814,7),(1278,625651214,6),(1278,638960415,7),(1278,657100815,6),(1278,671014816,7),(1278,688550416,6),(1278,702464416,7),(1278,720000017,6),(1278,733914017,7),(1278,752054418,6),(1278,765363618,7),(1278,783504019,6),(1278,796813219,7),(1278,814953619,6),(1278,828867620,7),(1278,846403220,6),(1278,860317220,7),(1278,877852821,6),(1278,891766821,7),(1278,909302421,6),(1278,923216422,7),(1278,941356822,6),(1278,954666022,7),(1278,972806422,6),(1278,986115622,7),(1278,1004256022,6),(1278,1018170022,7),(1278,1035705622,6),(1278,1049619622,7),(1278,1067155222,6),(1278,1081069222,7),(1278,1099209622,6),(1278,1112518822,7),(1278,1130659222,6),(1278,1143968423,7),(1278,1162108823,6),(1278,1173603623,7),(1278,1194163223,6),(1278,1205053223,7),(1278,1225612823,6),(1278,1236502824,7),(1278,1257062424,6),(1278,1268557224,7),(1278,1289116824,6),(1278,1300006824,7),(1278,1320566424,6),(1278,1331456424,7),(1278,1352016025,6),(1278,1362906025,7),(1278,1383465625,6),(1278,1394355625,7),(1278,1414915225,6),(1278,1425805225,7),(1278,1446364826,6),(1278,1457859626,7),(1278,1478419226,6),(1278,1489309227,7),(1278,1509868827,6),(1278,1520758827,7),(1278,1541318427,6),(1278,1552208427,7),(1278,1572768027,6),(1278,1583658027,7),(1278,1604217627,6),(1278,1615712427,7),(1278,1636272027,6),(1278,1647162027,7),(1278,1667721627,6),(1278,1678611627,7),(1278,1699171227,6),(1278,1710061227,7),(1278,1730620827,6),(1278,1741510827,7),(1278,1762070427,6),(1278,1772960427,7),(1278,1793520027,6),(1278,1805014827,7),(1278,1825574427,6),(1278,1836464427,7),(1278,1857024027,6),(1278,1867914027,7),(1278,1888473627,6),(1278,1899363627,7),(1278,1919923227,6),(1278,1930813227,7),(1278,1951372827,6),(1278,1962867627,7),(1278,1983427227,6),(1278,1994317227,7),(1278,2014876827,6),(1278,2025766827,7),(1278,2046326427,6),(1278,2057216427,7),(1278,2077776027,6),(1278,2088666027,7),(1278,2109225627,6),(1278,2120115627,7),(1278,2140675227,6),(1279,-2147483648,1),(1279,-1567453392,2),(1279,-1233432000,3),(1279,-1222981200,2),(1279,-1205956800,3),(1279,-1194037200,2),(1279,-1172865600,3),(1279,-1162501200,2),(1279,-1141329600,3),(1279,-1130965200,2),(1279,-1109793600,3),(1279,-1099429200,2),(1279,-1078257600,3),(1279,-1067806800,2),(1279,-1046635200,3),(1279,-1036270800,2),(1279,-1015099200,3),(1279,-1004734800,2),(1279,-983563200,3),(1279,-973198800,2),(1279,-952027200,3),(1279,-941576400,2),(1279,-931032000,3),(1279,-900882000,2),(1279,-890337600,3),(1279,-833749200,2),(1279,-827265600,3),(1279,-752274000,2),(1279,-733780800,3),(1279,-197326800,2),(1279,-190843200,3),(1279,-184194000,2),(1279,-164491200,3),(1279,-152658000,2),(1279,-132955200,3),(1279,-121122000,2),(1279,-101419200,3),(1279,-86821200,2),(1279,-71092800,3),(1279,-54766800,2),(1279,-39038400,3),(1279,-23317200,2),(1279,-7588800,5),(1279,128142003,4),(1279,136605603,5),(1279,596948414,4),(1279,605066414,5),(1279,624423614,4),(1279,636516015,5),(1279,656478015,4),(1279,667965616,5),(1279,687927616,4),(1279,699415216,5),(1279,719377217,4),(1279,731469617,5),(1279,938919622,3),(1279,952052422,5),(1279,1198983623,4),(1279,1205632823,5),(1279,1224385223,4),(1279,1237082424,5),(1280,-2147483648,0),(1280,-1577923200,3),(1280,-880210800,1),(1280,-769395600,2),(1280,-765388800,3),(1280,73472400,4),(1280,89193601,3),(1280,104922002,4),(1280,120643202,3),(1280,136371603,4),(1280,152092803,3),(1280,167821204,4),(1280,183542404,3),(1280,199270805,4),(1280,215596805,3),(1280,230720406,4),(1280,247046406,3),(1280,262774807,4),(1280,278496007,3),(1280,294224408,4),(1280,309945608,3),(1280,325674009,4),(1280,341395209,3),(1280,357123609,4),(1280,372844810,3),(1280,388573210,4),(1280,404899211,3),(1280,420022811,4),(1280,436348812,3),(1280,452077212,4),(1280,467798412,3),(1280,483526812,4),(1280,499248013,3),(1280,514976413,4),(1280,530697613,3),(1280,544611613,4),(1280,562147213,3),(1280,576061214,4),(1280,594201614,3),(1280,607510814,4),(1280,625651214,3),(1280,638960415,4),(1280,657100815,3),(1280,671014816,4),(1280,688550416,3),(1280,702464416,4),(1280,720000017,3),(1280,733914017,4),(1280,752054418,3),(1280,765363618,4),(1280,783504019,3),(1280,796813219,4),(1280,814953619,3),(1280,828867620,4),(1280,846403220,3),(1280,860317220,4),(1280,877852821,3),(1280,891766821,4),(1280,909302421,3),(1280,923216422,4),(1280,941356822,6),(1280,954662422,5),(1280,972802822,7),(1280,973400422,6),(1280,986115622,4),(1280,1004256022,3),(1280,1018170022,4),(1280,1035705622,3),(1280,1049619622,4),(1280,1067155222,3),(1280,1081069222,4),(1280,1099209622,3),(1280,1112518822,4),(1280,1130659222,3),(1280,1143968423,4),(1280,1162108823,3),(1280,1173603623,4),(1280,1194163223,3),(1280,1205053223,4),(1280,1225612823,3),(1280,1236502824,4),(1280,1257062424,3),(1280,1268557224,4),(1280,1289116824,3),(1280,1300006824,4),(1280,1320566424,3),(1280,1331456424,4),(1280,1352016025,3),(1280,1362906025,4),(1280,1383465625,3),(1280,1394355625,4),(1280,1414915225,3),(1280,1425805225,4),(1280,1446364826,3),(1280,1457859626,4),(1280,1478419226,3),(1280,1489309227,4),(1280,1509868827,3),(1280,1520758827,4),(1280,1541318427,3),(1280,1552208427,4),(1280,1572768027,3),(1280,1583658027,4),(1280,1604217627,3),(1280,1615712427,4),(1280,1636272027,3),(1280,1647162027,4),(1280,1667721627,3),(1280,1678611627,4),(1280,1699171227,3),(1280,1710061227,4),(1280,1730620827,3),(1280,1741510827,4),(1280,1762070427,3),(1280,1772960427,4),(1280,1793520027,3),(1280,1805014827,4),(1280,1825574427,3),(1280,1836464427,4),(1280,1857024027,3),(1280,1867914027,4),(1280,1888473627,3),(1280,1899363627,4),(1280,1919923227,3),(1280,1930813227,4),(1280,1951372827,3),(1280,1962867627,4),(1280,1983427227,3),(1280,1994317227,4),(1280,2014876827,3),(1280,2025766827,4),(1280,2046326427,3),(1280,2057216427,4),(1280,2077776027,3),(1280,2088666027,4),(1280,2109225627,3),(1280,2120115627,4),(1280,2140675227,3),(1281,-2147483648,0),(1281,-1767212492,2),(1281,-1206954000,1),(1281,-1191358800,2),(1281,-1175371200,1),(1281,-1159822800,2),(1281,-633816000,1),(1281,-622065600,2),(1281,-602280000,1),(1281,-591829200,2),(1281,-570744000,1),(1281,-560206800,2),(1281,-539121600,1),(1281,-531349200,2),(1281,-191361600,1),(1281,-184194000,2),(1281,-155160000,1),(1281,-150066000,2),(1281,-128894400,1),(1281,-121122000,2),(1281,-99950400,1),(1281,-89586000,2),(1281,-68414400,1),(1281,-57963600,2),(1281,499752013,1),(1281,511239613,2),(1281,530596813,1),(1281,540270013,2),(1281,562132813,1),(1281,571201214,2),(1281,592977614,1),(1281,602046014,2),(1281,624427214,1),(1281,634705215,2),(1281,656481615,1),(1281,666759616,2),(1281,687931216,1),(1281,697604416,2),(1281,719985617,1),(1281,728449217,2),(1281,750830418,1),(1281,761713218,2),(1281,782280019,1),(1281,793162819,2),(1281,813729619,1),(1281,824007620,2),(1281,844574420,1),(1281,856062020,2),(1281,876110421,1),(1281,888721221,2),(1281,908078421,1),(1281,919566022,2),(1281,938923222,1),(1281,951620422,2),(1281,970977622,1),(1281,982465222,2),(1281,1003032022,1),(1281,1013914822,2),(1281,1036296022,1),(1281,1045364422,2),(1281,1066536022,1),(1281,1076814022,2),(1281,1099368022,1),(1281,1108868422,2),(1281,1129435222,1),(1281,1140318023,2),(1281,1162699223,1),(1281,1172372423,2),(1281,1192334423,1),(1281,1203217223,2),(1281,1224388823,1),(1281,1234666824,2),(1281,1255838424,1),(1281,1266721224,2),(1281,1287288024,1),(1281,1298170824,2),(1281,1318737624,1),(1281,1330225224,2),(1281,1350792025,1),(1281,1361070025,2),(1281,1382241625,1),(1281,1392519625,2),(1281,1413691225,1),(1281,1424574025,2),(1281,1445140826,1),(1281,1456023626,2),(1281,1476590426,1),(1281,1487473227,2),(1281,1508040027,1),(1281,1518922827,2),(1281,1541304027,1),(1281,1550372427,2),(1282,-2147483648,0),(1282,-1514743200,1),(1282,377935210,3),(1282,828860420,2),(1282,846396020,3),(1282,860310020,2),(1282,877845621,3),(1282,891759621,2),(1282,902037621,5),(1282,909298821,4),(1282,923212822,5),(1282,941353222,4),(1282,954662422,5),(1282,972802822,4),(1282,989136022,5),(1282,1001833222,4),(1282,1018166422,5),(1282,1035702022,4),(1282,1049616022,5),(1282,1067151622,4),(1282,1081065622,5),(1282,1099206022,4),(1282,1112515222,5),(1282,1130655622,4),(1282,1143964823,5),(1282,1162105223,4),(1282,1175414423,5),(1282,1193554823,4),(1282,1207468823,5),(1282,1225004423,4),(1282,1238918424,5),(1282,1256454024,4),(1282,1270368024,5),(1282,1288508424,4),(1282,1301817624,5),(1282,1319958024,4),(1282,1333267224,5),(1282,1351407625,4),(1282,1365321625,5),(1282,1382857225,4),(1282,1396771225,5),(1282,1414306825,4),(1282,1422777625,3),(1283,-2147483648,1),(1283,-1826739140,2),(1283,-157750200,3),(1283,1197183623,2),(1283,1462086026,3),(1284,-2147483648,1),(1284,-1567453392,2),(1284,-1233432000,3),(1284,-1222981200,2),(1284,-1205956800,3),(1284,-1194037200,2),(1284,-1172865600,3),(1284,-1162501200,2),(1284,-1141329600,3),(1284,-1130965200,2),(1284,-1109793600,3),(1284,-1099429200,2),(1284,-1078257600,3),(1284,-1067806800,2),(1284,-1046635200,3),(1284,-1036270800,2),(1284,-1015099200,3),(1284,-1004734800,2),(1284,-983563200,3),(1284,-973198800,2),(1284,-952027200,3),(1284,-941576400,2),(1284,-931032000,3),(1284,-900882000,2),(1284,-890337600,3),(1284,-833749200,2),(1284,-827265600,3),(1284,-752274000,2),(1284,-733780800,3),(1284,-197326800,2),(1284,-190843200,3),(1284,-184194000,2),(1284,-164491200,3),(1284,-152658000,2),(1284,-132955200,3),(1284,-121122000,2),(1284,-101419200,3),(1284,-86821200,2),(1284,-71092800,3),(1284,-54766800,2),(1284,-39038400,3),(1284,-23317200,2),(1284,-7588800,5),(1284,128142003,4),(1284,136605603,5),(1284,596948414,4),(1284,605066414,5),(1284,624423614,4),(1284,636516015,5),(1284,656478015,4),(1284,667965616,2),(1284,687931216,4),(1284,699415216,5),(1284,719377217,4),(1284,731469617,5),(1284,938919622,3),(1284,952052422,5),(1284,1086058822,2),(1284,1087704022,5),(1284,1198983623,4),(1284,1205632823,5),(1285,-2147483648,0),(1285,-1846269040,1),(1285,-71092800,2),(1286,-2147483648,1),(1286,-1946918424,2),(1287,-2147483648,3),(1287,-1633276800,1),(1287,-1615136400,2),(1287,-1601827200,1),(1287,-1583686800,2),(1287,-1563724800,1),(1287,-1551632400,2),(1287,-1538928000,1),(1287,-1520182800,2),(1287,-1504454400,1),(1287,-1491757200,2),(1287,-1473004800,1),(1287,-1459702800,2),(1287,-1441555200,1),(1287,-1428253200,2),(1287,-1410105600,1),(1287,-1396803600,2),(1287,-1378656000,1),(1287,-1365354000,2),(1287,-1347206400,1),(1287,-1333904400,2),(1287,-1315152000,1),(1287,-1301850000,2),(1287,-1283702400,1),(1287,-1270400400,2),(1287,-1252252800,1),(1287,-1238950800,2),(1287,-1220803200,1),(1287,-1207501200,2),(1287,-1189353600,1),(1287,-1176051600,2),(1287,-1157299200,1),(1287,-1144602000,2),(1287,-1125849600,1),(1287,-1112547600,2),(1287,-1094400000,1),(1287,-1081098000,2),(1287,-1067788800,4),(1287,-1045414800,2),(1287,-1031500800,1),(1287,-1018198800,2),(1287,-1000051200,1),(1287,-986749200,2),(1287,-967996800,1),(1287,-955299600,2),(1287,-936547200,1),(1287,-923245200,2),(1287,-905097600,1),(1287,-891795600,2),(1287,-880214400,5),(1287,-769395600,6),(1287,-765392400,2),(1287,-747244800,1),(1287,-733942800,2),(1287,-715795200,1),(1287,-702493200,2),(1287,-684345600,1),(1287,-671043600,2),(1287,-652896000,1),(1287,-639594000,2),(1287,-620841600,1),(1287,-608144400,2),(1287,-589392000,1),(1287,-576090000,2),(1287,-557942400,1),(1287,-544640400,2),(1287,-526492800,1),(1287,-513190800,2),(1287,-495043200,1),(1287,-481741200,2),(1287,-463593600,1),(1287,-447267600,2),(1287,-431539200,1),(1287,-415818000,2),(1287,-400089600,1),(1287,-384368400,2),(1287,-368640000,1),(1287,-352918800,2),(1287,-337190400,1),(1287,-321469200,2),(1287,-305740800,1),(1287,-289414800,2),(1287,-273686400,1),(1287,-257965200,2),(1287,-242236800,1),(1287,-226515600,2),(1287,-210787200,1),(1287,-195066000,2),(1287,-179337600,1),(1287,-163616400,2),(1287,-147888000,1),(1287,-131562000,2),(1287,-116438400,1),(1287,-100112400,2),(1287,-84384000,1),(1287,-68662800,2),(1287,-52934400,1),(1287,-37213200,2),(1287,-21484800,1),(1287,-5763600,2),(1287,9964800,1),(1287,25686000,2),(1287,41414400,1),(1287,57740400,2),(1287,73468800,1),(1287,89190001,2),(1287,104918402,1),(1287,120639602,2),(1287,126691203,1),(1287,152089203,2),(1287,162374404,1),(1287,183538804,2),(1287,199267205,1),(1287,215593205,2),(1287,230716806,1),(1287,247042806,2),(1287,262771207,1),(1287,278492407,2),(1287,294220808,1),(1287,309942008,2),(1287,325670409,1),(1287,341391609,2),(1287,357120009,1),(1287,372841210,2),(1287,388569610,1),(1287,404895611,2),(1287,420019211,1),(1287,436345212,2),(1287,452073612,1),(1287,467794812,2),(1287,483523212,1),(1287,499244413,2),(1287,514972813,1),(1287,530694013,2),(1287,544608013,1),(1287,562143613,2),(1287,576057614,1),(1287,594198014,2),(1287,607507214,1),(1287,625647614,2),(1287,638956815,1),(1287,657097215,2),(1287,671011216,1),(1287,688546816,2),(1287,702460816,1),(1287,719996417,2),(1287,733910417,1),(1287,752050818,2),(1287,765360018,1),(1287,783500419,2),(1287,796809619,1),(1287,814950019,2),(1287,828864020,1),(1287,846399620,2),(1287,860313620,1),(1287,877849221,2),(1287,891763221,1),(1287,909298821,2),(1287,923212822,1),(1287,941353222,2),(1287,954662422,1),(1287,972802822,2),(1287,986112022,1),(1287,1004252422,2),(1287,1018166422,1),(1287,1035702022,2),(1287,1049616022,1),(1287,1067151622,2),(1287,1081065622,1),(1287,1099206022,2),(1287,1112515222,1),(1287,1130655622,2),(1287,1143964823,1),(1287,1162105223,2),(1287,1173600023,1),(1287,1194159623,2),(1287,1205049623,1),(1287,1225609223,2),(1287,1236499224,1),(1287,1257058824,2),(1287,1268553624,1),(1287,1289113224,2),(1287,1300003224,1),(1287,1320562824,2),(1287,1331452824,1),(1287,1352012425,2),(1287,1362902425,1),(1287,1383462025,2),(1287,1394352025,1),(1287,1414911625,2),(1287,1425801625,1),(1287,1446361226,2),(1287,1457856026,1),(1287,1478415626,2),(1287,1489305627,1),(1287,1509865227,2),(1287,1520755227,1),(1287,1541314827,2),(1287,1552204827,1),(1287,1572764427,2),(1287,1583654427,1),(1287,1604214027,2),(1287,1615708827,1),(1287,1636268427,2),(1287,1647158427,1),(1287,1667718027,2),(1287,1678608027,1),(1287,1699167627,2),(1287,1710057627,1),(1287,1730617227,2),(1287,1741507227,1),(1287,1762066827,2),(1287,1772956827,1),(1287,1793516427,2),(1287,1805011227,1),(1287,1825570827,2),(1287,1836460827,1),(1287,1857020427,2),(1287,1867910427,1),(1287,1888470027,2),(1287,1899360027,1),(1287,1919919627,2),(1287,1930809627,1),(1287,1951369227,2),(1287,1962864027,1),(1287,1983423627,2),(1287,1994313627,1),(1287,2014873227,2),(1287,2025763227,1),(1287,2046322827,2),(1287,2057212827,1),(1287,2077772427,2),(1287,2088662427,1),(1287,2109222027,2),(1287,2120112027,1),(1287,2140671627,2),(1288,-2147483648,0),(1288,-1514739600,1),(1288,-1343066400,2),(1288,-1234807200,4),(1288,-1220292000,3),(1288,-1207159200,4),(1288,-1191344400,2),(1288,828864020,5),(1288,846399620,2),(1288,860313620,5),(1288,877849221,2),(1288,891766821,3),(1288,909302421,4),(1288,923216422,3),(1288,941356822,4),(1288,954666022,3),(1288,972806422,4),(1288,989139622,3),(1288,1001836822,4),(1288,1018170022,3),(1288,1035705622,4),(1288,1049619622,3),(1288,1067155222,4),(1288,1081069222,3),(1288,1099209622,4),(1288,1112518822,3),(1288,1130659222,4),(1288,1143968423,3),(1288,1162108823,4),(1288,1175418023,3),(1288,1193558423,4),(1288,1207472423,3),(1288,1225008023,4),(1288,1238922024,3),(1288,1256457624,4),(1288,1270371624,3),(1288,1288512024,4),(1288,1301821224,3),(1288,1319961624,4),(1288,1333270824,3),(1288,1351411225,4),(1288,1365325225,3),(1288,1382860825,4),(1288,1396774825,3),(1288,1414310425,4),(1288,1428224425,3),(1288,1445760026,4),(1288,1459674026,3),(1288,1477814426,4),(1288,1491123627,3),(1288,1509264027,4),(1288,1522573227,3),(1288,1540713627,4),(1288,1554627627,3),(1288,1572163227,4),(1288,1586077227,3),(1288,1603612827,4),(1288,1617526827,3),(1288,1635667227,4),(1288,1648976427,3),(1288,1667116827,2),(1289,-2147483648,0),(1289,-1514739600,1),(1289,-1343066400,2),(1289,-1234807200,4),(1289,-1220292000,3),(1289,-1207159200,4),(1289,-1191344400,2),(1289,828864020,5),(1289,846399620,2),(1289,860313620,5),(1289,877849221,2),(1289,891766821,3),(1289,909302421,4),(1289,923216422,3),(1289,941356822,4),(1289,954666022,3),(1289,972806422,4),(1289,989139622,3),(1289,1001836822,4),(1289,1018170022,3),(1289,1035705622,4),(1289,1049619622,3),(1289,1067155222,4),(1289,1081069222,3),(1289,1099209622,4),(1289,1112518822,3),(1289,1130659222,4),(1289,1143968423,3),(1289,1162108823,4),(1289,1175418023,3),(1289,1193558423,4),(1289,1207472423,3),(1289,1225008023,4),(1289,1238922024,3),(1289,1256457624,4),(1289,1268557224,3),(1289,1289116824,4),(1289,1300006824,3),(1289,1320566424,4),(1289,1331456424,3),(1289,1352016025,4),(1289,1362906025,3),(1289,1383465625,4),(1289,1394355625,3),(1289,1414915225,4),(1289,1425805225,3),(1289,1446364826,4),(1289,1457859626,3),(1289,1478419226,4),(1289,1489309227,3),(1289,1509868827,4),(1289,1520758827,3),(1289,1541318427,4),(1289,1552208427,3),(1289,1572768027,4),(1289,1583658027,3),(1289,1604217627,4),(1289,1615712427,3),(1289,1636272027,4),(1289,1647162027,3),(1289,1667116827,2),(1289,1669788027,4),(1289,1678611627,3),(1289,1699171227,4),(1289,1710061227,3),(1289,1730620827,4),(1289,1741510827,3),(1289,1762070427,4),(1289,1772960427,3),(1289,1793520027,4),(1289,1805014827,3),(1289,1825574427,4),(1289,1836464427,3),(1289,1857024027,4),(1289,1867914027,3),(1289,1888473627,4),(1289,1899363627,3),(1289,1919923227,4),(1289,1930813227,3),(1289,1951372827,4),(1289,1962867627,3),(1289,1983427227,4),(1289,1994317227,3),(1289,2014876827,4),(1289,2025766827,3),(1289,2046326427,4),(1289,2057216427,3),(1289,2077776027,4),(1289,2088666027,3),(1289,2109225627,4),(1289,2120115627,3),(1289,2140675227,4),(1290,-2147483648,1),(1290,-1946918424,2),(1291,-2147483648,1),(1291,-1567453392,2),(1291,-1233432000,3),(1291,-1222981200,2),(1291,-1205956800,3),(1291,-1194037200,2),(1291,-1172865600,3),(1291,-1162501200,2),(1291,-1141329600,3),(1291,-1130965200,2),(1291,-1109793600,3),(1291,-1099429200,2),(1291,-1078257600,3),(1291,-1067806800,2),(1291,-1046635200,3),(1291,-1036270800,2),(1291,-1015099200,3),(1291,-1004734800,2),(1291,-983563200,3),(1291,-973198800,2),(1291,-952027200,3),(1291,-941576400,2),(1291,-931032000,3),(1291,-900882000,2),(1291,-890337600,3),(1291,-833749200,2),(1291,-827265600,3),(1291,-752274000,2),(1291,-733780800,3),(1291,-197326800,2),(1291,-190843200,3),(1291,-184194000,2),(1291,-164491200,3),(1291,-152658000,2),(1291,-132955200,3),(1291,-121122000,2),(1291,-101419200,3),(1291,-86821200,2),(1291,-71092800,3),(1291,-54766800,2),(1291,-39038400,3),(1291,-23317200,2),(1291,-7588800,5),(1291,128142003,4),(1291,136605603,5),(1291,596948414,4),(1291,605066414,5),(1291,624423614,4),(1291,636516015,5),(1291,656478015,4),(1291,667965616,2),(1291,687931216,4),(1291,699415216,5),(1291,719377217,4),(1291,731469617,5),(1291,938919622,3),(1291,952052422,5),(1291,1198983623,4),(1291,1205632823,5),(1291,1224385223,4),(1291,1237082424,5),(1292,-2147483648,1),(1292,-1545071027,3),(1292,288770408,2),(1292,297234008,3),(1292,320220009,2),(1292,328683609,3),(1292,664264816,2),(1292,678344416,3),(1292,695714416,2),(1292,700635616,3),(1293,-2147483648,4),(1293,-1633273200,1),(1293,-1615132800,2),(1293,-1601823600,1),(1293,-1583683200,2),(1293,-880210800,3),(1293,-820519140,2),(1293,-812653140,3),(1293,-796845540,2),(1293,-84380400,1),(1293,-68659200,2),(1294,-2147483648,0),(1294,-1767212140,2),(1294,-1206954000,1),(1294,-1191358800,2),(1294,-1175371200,1),(1294,-1159822800,2),(1294,-633816000,1),(1294,-622065600,2),(1294,-602280000,1),(1294,-591829200,2),(1294,-570744000,1),(1294,-560206800,2),(1294,-539121600,1),(1294,-531349200,2),(1294,-191361600,1),(1294,-184194000,2),(1294,-155160000,1),(1294,-150066000,2),(1294,-128894400,1),(1294,-121122000,2),(1294,-99950400,1),(1294,-89586000,2),(1294,-68414400,1),(1294,-57963600,2),(1294,499752013,1),(1294,511239613,2),(1294,530596813,1),(1294,540270013,2),(1294,562132813,1),(1294,571201214,2),(1294,592977614,1),(1294,602046014,2),(1294,624427214,1),(1294,634705215,2),(1294,656481615,1),(1294,666759616,2),(1294,687931216,1),(1294,697604416,2),(1294,719985617,1),(1294,728449217,2),(1294,750830418,1),(1294,761713218,2),(1294,782280019,1),(1294,793162819,2),(1294,813729619,1),(1294,824007620,2),(1294,844574420,1),(1294,856062020,2),(1294,876110421,1),(1294,888721221,2),(1294,908078421,1),(1294,919566022,2),(1294,938923222,1),(1294,951620422,2),(1294,970977622,1),(1294,982465222,2),(1294,1003032022,1),(1294,1013914822,2),(1294,1036296022,1),(1294,1045364422,2),(1294,1099368022,1),(1294,1108868422,2),(1294,1129435222,1),(1294,1140318023,2),(1294,1162699223,1),(1294,1172372423,2),(1294,1192334423,1),(1294,1203217223,2),(1294,1224388823,1),(1294,1234666824,2),(1294,1255838424,1),(1294,1266721224,2),(1294,1287288024,1),(1294,1298170824,2),(1294,1318737624,1),(1294,1330225224,2),(1294,1350792025,1),(1294,1361070025,2),(1294,1382241625,1),(1294,1392519625,2),(1294,1413691225,1),(1294,1424574025,2),(1294,1445140826,1),(1294,1456023626,2),(1294,1476590426,1),(1294,1487473227,2),(1294,1508040027,1),(1294,1518922827,2),(1294,1541304027,1),(1294,1550372427,2),(1295,-2147483648,1),(1295,-873057600,3),(1295,-769395600,2),(1295,-765399600,1),(1296,-2147483648,0),(1296,-1686091520,1),(1296,323845209,4),(1296,338950809,2),(1296,354675609,3),(1296,370400410,2),(1296,386125210,3),(1296,401850011,2),(1296,417574811,3),(1296,433299612,2),(1296,449024412,3),(1296,465354012,2),(1296,481078812,3),(1296,496803613,2),(1296,512528413,3),(1296,528253213,2),(1296,543978013,3),(1296,559702813,2),(1296,575427614,3),(1296,591152414,2),(1296,606877214,3),(1296,622602014,2),(1296,638326815,3),(1296,654656415,2),(1296,670381216,3),(1296,686106016,2),(1296,701830816,3),(1296,717555617,2),(1296,733280417,3),(1296,749005218,2),(1296,764730018,3),(1296,780454819,2),(1296,796179619,3),(1296,811904419,2),(1296,820465220,5),(1297,-2147483648,2),(1297,-1632056400,1),(1297,-1615125600,2),(1297,-1596978000,1),(1297,-1583164800,2),(1297,-880203600,3),(1297,-769395600,4),(1297,-765381600,2),(1297,-147884400,5),(1297,-131554800,2),(1297,120646802,6),(1297,325677609,7),(1297,341398809,6),(1297,357127209,7),(1297,372848410,6),(1297,388576810,7),(1297,404902811,6),(1297,420026411,7),(1297,436352412,6),(1297,452080812,7),(1297,467802012,6),(1297,483530412,7),(1297,499251613,6),(1297,514980013,7),(1297,530701213,6),(1297,544615213,7),(1297,562150813,6),(1297,576064814,7),(1297,594205214,6),(1297,607514414,7),(1297,625654814,6),(1297,638964015,7),(1297,657104415,6),(1297,671018416,7),(1297,688554016,6),(1297,702468016,7),(1297,720003617,6),(1297,733917617,7),(1297,752058018,6),(1297,765367218,7),(1297,783507619,6),(1297,796816819,7),(1297,814957219,6),(1297,828871220,7),(1297,846406820,6),(1297,860320820,7),(1297,877856421,6),(1297,891770421,7),(1297,909306021,6),(1297,923220022,7),(1297,941360422,6),(1297,954669622,7),(1297,972810022,6),(1297,986119222,7),(1297,1004259622,6),(1297,1018173622,7),(1297,1035709222,6),(1297,1049623222,7),(1297,1067158822,6),(1297,1081072822,7),(1297,1099213222,6),(1297,1112522422,7),(1297,1130662822,6),(1297,1143972023,7),(1297,1162112423,6),(1297,1173607223,7),(1297,1194166823,6),(1297,1205056823,7),(1297,1225616423,6),(1297,1236506424,7),(1297,1257066024,6),(1297,1268560824,7),(1297,1289120424,6),(1297,1300010424,7),(1297,1320570024,6),(1297,1331460024,7),(1297,1352019625,6),(1297,1362909625,7),(1297,1383469225,6),(1297,1394359225,7),(1297,1414918825,6),(1297,1425808825,7),(1297,1446368426,6),(1297,1457863226,7),(1297,1478422826,6),(1297,1489312827,7),(1297,1509872427,6),(1297,1520762427,7),(1297,1541322027,6),(1297,1552212027,7),(1297,1572771627,6),(1297,1583661627,7),(1297,1604214027,8),(1298,-2147483648,2),(1298,-1632060000,1),(1298,-1615129200,2),(1298,-880207200,3),(1298,-769395600,4),(1298,-765385200,2),(1298,-715788000,1),(1298,-702486000,2),(1298,-684338400,1),(1298,-671036400,2),(1298,-652888800,1),(1298,-639586800,2),(1298,-620834400,1),(1298,-608137200,2),(1298,-589384800,1),(1298,-576082800,2),(1298,-557935200,1),(1298,-544633200,2),(1298,-526485600,1),(1298,-513183600,2),(1298,-495036000,1),(1298,-481734000,2),(1298,-463586400,1),(1298,-450284400,2),(1298,-431532000,1),(1298,-418230000,2),(1298,-400082400,1),(1298,-386780400,2),(1298,-368632800,1),(1298,-355330800,2),(1298,-337183200,1),(1298,-323881200,2),(1298,-305733600,1),(1298,-292431600,2),(1298,-273679200,1),(1298,-260982000,2),(1298,-242229600,1),(1298,-226508400,2),(1298,-210780000,1),(1298,-195058800,2),(1298,-179330400,1),(1298,-163609200,2),(1298,-147880800,1),(1298,-131554800,2),(1298,-116431200,1),(1298,-100105200,2),(1298,-84376800,1),(1298,-68655600,2),(1298,-52927200,1),(1298,-37206000,2),(1298,-21477600,1),(1298,-5756400,2),(1298,9972000,1),(1298,25693200,2),(1298,41421600,1),(1298,57747600,2),(1298,73476000,1),(1298,84013201,5),(1299,-2147483648,3),(1299,-1633273200,1),(1299,-1615132800,2),(1299,-1601823600,1),(1299,-1583683200,2),(1299,-1570374000,1),(1299,-1551628800,2),(1299,-1538924400,1),(1299,-1534089600,2),(1299,-880210800,4),(1299,-769395600,5),(1299,-765388800,2),(1299,-147884400,1),(1299,-131558400,2),(1299,-116434800,1),(1299,-100108800,2),(1299,-84380400,1),(1299,-68659200,2),(1299,-52930800,1),(1299,-37209600,2),(1299,-21481200,1),(1299,-5760000,2),(1299,9968400,1),(1299,25689600,2),(1299,41418000,1),(1299,57744000,2),(1299,73472400,1),(1299,89193601,2),(1299,104922002,1),(1299,120643202,2),(1299,126694803,1),(1299,152092803,2),(1299,162378004,1),(1299,183542404,2),(1299,199270805,1),(1299,215596805,2),(1299,230720406,1),(1299,247046406,2),(1299,262774807,1),(1299,278496007,2),(1299,294224408,1),(1299,309945608,2),(1299,325674009,1),(1299,341395209,2),(1299,357123609,1),(1299,372844810,2),(1299,388573210,1),(1299,404899211,2),(1299,420022811,1),(1299,436348812,2),(1299,452077212,1),(1299,467798412,2),(1299,483526812,1),(1299,499248013,2),(1299,514976413,1),(1299,530697613,2),(1299,544611613,1),(1299,562147213,2),(1299,576061214,1),(1299,594201614,2),(1299,607510814,1),(1299,625651214,2),(1299,638960415,1),(1299,657100815,2),(1299,671014816,1),(1299,688550416,2),(1299,702464416,1),(1299,720000017,2),(1299,733914017,1),(1299,752054418,2),(1299,765363618,1),(1299,783504019,2),(1299,796813219,1),(1299,814953619,2),(1299,828867620,1),(1299,846403220,2),(1299,860317220,1),(1299,877852821,2),(1299,891766821,1),(1299,909302421,2),(1299,923216422,1),(1299,941356822,2),(1299,954666022,1),(1299,972806422,2),(1299,986115622,1),(1299,1004256022,2),(1299,1018170022,1),(1299,1035705622,2),(1299,1049619622,1),(1299,1067155222,2),(1299,1081069222,1),(1299,1099209622,2),(1299,1112518822,1),(1299,1130659222,2),(1299,1143968423,1),(1299,1162108823,2),(1299,1173603623,1),(1299,1194163223,2),(1299,1205053223,1),(1299,1225612823,2),(1299,1236502824,1),(1299,1257062424,2),(1299,1268557224,1),(1299,1289116824,2),(1299,1300006824,1),(1299,1320566424,2),(1299,1331456424,1),(1299,1352016025,2),(1299,1362906025,1),(1299,1383465625,2),(1299,1394355625,1),(1299,1414915225,2),(1299,1425805225,1),(1299,1446364826,2),(1299,1457859626,1),(1299,1478419226,2),(1299,1489309227,1),(1299,1509868827,2),(1299,1520758827,1),(1299,1541318427,2),(1299,1552208427,1),(1299,1572768027,2),(1299,1583658027,1),(1299,1604217627,2),(1299,1615712427,1),(1299,1636272027,2),(1299,1647162027,1),(1299,1667721627,2),(1299,1678611627,1),(1299,1699171227,2),(1299,1710061227,1),(1299,1730620827,2),(1299,1741510827,1),(1299,1762070427,2),(1299,1772960427,1),(1299,1793520027,2),(1299,1805014827,1),(1299,1825574427,2),(1299,1836464427,1),(1299,1857024027,2),(1299,1867914027,1),(1299,1888473627,2),(1299,1899363627,1),(1299,1919923227,2),(1299,1930813227,1),(1299,1951372827,2),(1299,1962867627,1),(1299,1983427227,2),(1299,1994317227,1),(1299,2014876827,2),(1299,2025766827,1),(1299,2046326427,2),(1299,2057216427,1),(1299,2077776027,2),(1299,2088666027,1),(1299,2109225627,2),(1299,2120115627,1),(1299,2140675227,2),(1300,-2147483648,0),(1300,-2051202469,1),(1300,-1724083200,2),(1300,-880218000,3),(1300,-769395600,4),(1300,-765396000,2),(1300,-684349200,5),(1300,-671047200,2),(1300,-80506740,5),(1300,-68666400,2),(1300,-52938000,5),(1300,-37216800,2),(1300,104914802,5),(1300,120636002,2),(1300,126687603,5),(1300,152085603,2),(1300,167814004,5),(1300,183535204,2),(1300,199263605,5),(1300,215589605,2),(1300,230713206,5),(1300,247039206,2),(1300,262767607,5),(1300,278488807,2),(1300,294217208,5),(1300,309938408,2),(1300,325666809,5),(1300,341388009,2),(1300,357116409,5),(1300,372837610,2),(1300,388566010,5),(1300,404892011,2),(1300,420015611,5),(1300,436341612,2),(1300,452070012,5),(1300,467791212,2),(1300,483519612,5),(1300,499240813,2),(1300,514969213,5),(1300,530690413,2),(1300,544604413,5),(1300,562140013,2),(1300,576054014,5),(1300,594194414,2),(1300,607503614,5),(1300,625644014,2),(1300,638953215,5),(1300,657093615,2),(1300,671007616,5),(1300,688543216,2),(1300,702457216,5),(1300,719992817,2),(1300,733906817,5),(1300,752047218,2),(1300,765356418,5),(1300,783496819,2),(1300,796806019,5),(1300,814946419,2),(1300,828860420,5),(1300,846396020,2),(1300,860310020,5),(1300,877845621,2),(1300,891759621,5),(1300,909295221,2),(1300,923209222,5),(1300,941349622,2),(1300,954658822,5),(1300,972799222,2),(1300,986108422,5),(1300,1004248822,2),(1300,1018162822,5),(1300,1035698422,2),(1300,1049612422,5),(1300,1067148022,2),(1300,1081062022,5),(1300,1099202422,2),(1300,1112511622,5),(1300,1130652022,2),(1300,1143961223,5),(1300,1162101623,2),(1300,1173596423,5),(1300,1194156023,2),(1300,1205046023,5),(1300,1225605623,2),(1300,1236495624,5),(1300,1257055224,2),(1300,1268550024,5),(1300,1289109624,2),(1300,1299999624,5),(1300,1320559224,2),(1300,1331449224,5),(1300,1352008825,2),(1300,1362898825,5),(1300,1383458425,2),(1300,1394348425,5),(1300,1414908025,2),(1300,1425798025,5),(1300,1446357626,2),(1300,1457852426,5),(1300,1478412026,2),(1300,1489302027,5),(1300,1509861627,2),(1300,1520751627,5),(1300,1541311227,2),(1300,1552201227,5),(1300,1572760827,2),(1300,1583650827,5),(1300,1604210427,2),(1300,1615705227,5),(1300,1636264827,2),(1300,1647154827,5),(1300,1667714427,2),(1300,1678604427,5),(1300,1699164027,2),(1300,1710054027,5),(1300,1730613627,2),(1300,1741503627,5),(1300,1762063227,2),(1300,1772953227,5),(1300,1793512827,2),(1300,1805007627,5),(1300,1825567227,2),(1300,1836457227,5),(1300,1857016827,2),(1300,1867906827,5),(1300,1888466427,2),(1300,1899356427,5),(1300,1919916027,2),(1300,1930806027,5),(1300,1951365627,2),(1300,1962860427,5),(1300,1983420027,2),(1300,1994310027,5),(1300,2014869627,2),(1300,2025759627,5),(1300,2046319227,2),(1300,2057209227,5),(1300,2077768827,2),(1300,2088658827,5),(1300,2109218427,2),(1300,2120108427,5),(1300,2140668027,2),(1301,-2147483648,1),(1301,-873057600,3),(1301,-769395600,2),(1301,-765399600,1),(1302,-2147483648,0),(1302,-1998663968,2),(1302,-1632063600,1),(1302,-1615132800,2),(1302,-1600614000,1),(1302,-1596816000,2),(1302,-1567954800,1),(1302,-1551628800,2),(1302,-1536505200,1),(1302,-1523203200,2),(1302,-1504450800,1),(1302,-1491753600,2),(1302,-1473001200,1),(1302,-1459699200,2),(1302,-880210800,3),(1302,-769395600,4),(1302,-765388800,2),(1302,-715791600,1),(1302,-702489600,2),(1302,73472400,1),(1302,89193601,2),(1302,104922002,1),(1302,120643202,2),(1302,136371603,1),(1302,152092803,2),(1302,167821204,1),(1302,183542404,2),(1302,199270805,1),(1302,215596805,2),(1302,230720406,1),(1302,247046406,2),(1302,262774807,1),(1302,278496007,2),(1302,294224408,1),(1302,309945608,2),(1302,325674009,1),(1302,341395209,2),(1302,357123609,1),(1302,372844810,2),(1302,388573210,1),(1302,404899211,2),(1302,420022811,1),(1302,436348812,2),(1302,452077212,1),(1302,467798412,2),(1302,483526812,1),(1302,499248013,2),(1302,514976413,1),(1302,530697613,2),(1302,544611613,1),(1302,562147213,2),(1302,576061214,1),(1302,594201614,2),(1302,607510814,1),(1302,625651214,2),(1302,638960415,1),(1302,657100815,2),(1302,671014816,1),(1302,688550416,2),(1302,702464416,1),(1302,720000017,2),(1302,733914017,1),(1302,752054418,2),(1302,765363618,1),(1302,783504019,2),(1302,796813219,1),(1302,814953619,2),(1302,828867620,1),(1302,846403220,2),(1302,860317220,1),(1302,877852821,2),(1302,891766821,1),(1302,909302421,2),(1302,923216422,1),(1302,941356822,2),(1302,954666022,1),(1302,972806422,2),(1302,986115622,1),(1302,1004256022,2),(1302,1018170022,1),(1302,1035705622,2),(1302,1049619622,1),(1302,1067155222,2),(1302,1081069222,1),(1302,1099209622,2),(1302,1112518822,1),(1302,1130659222,2),(1302,1143968423,1),(1302,1162108823,2),(1302,1173603623,1),(1302,1194163223,2),(1302,1205053223,1),(1302,1225612823,2),(1302,1236502824,1),(1302,1257062424,2),(1302,1268557224,1),(1302,1289116824,2),(1302,1300006824,1),(1302,1320566424,2),(1302,1331456424,1),(1302,1352016025,2),(1302,1362906025,1),(1302,1383465625,2),(1302,1394355625,1),(1302,1414915225,2),(1302,1425805225,1),(1302,1446364826,2),(1302,1457859626,1),(1302,1478419226,2),(1302,1489309227,1),(1302,1509868827,2),(1302,1520758827,1),(1302,1541318427,2),(1302,1552208427,1),(1302,1572768027,2),(1302,1583658027,1),(1302,1604217627,2),(1302,1615712427,1),(1302,1636272027,2),(1302,1647162027,1),(1302,1667721627,2),(1302,1678611627,1),(1302,1699171227,2),(1302,1710061227,1),(1302,1730620827,2),(1302,1741510827,1),(1302,1762070427,2),(1302,1772960427,1),(1302,1793520027,2),(1302,1805014827,1),(1302,1825574427,2),(1302,1836464427,1),(1302,1857024027,2),(1302,1867914027,1),(1302,1888473627,2),(1302,1899363627,1),(1302,1919923227,2),(1302,1930813227,1),(1302,1951372827,2),(1302,1962867627,1),(1302,1983427227,2),(1302,1994317227,1),(1302,2014876827,2),(1302,2025766827,1),(1302,2046326427,2),(1302,2057216427,1),(1302,2077776027,2),(1302,2088666027,1),(1302,2109225627,2),(1302,2120115627,1),(1302,2140675227,2),(1303,-2147483648,0),(1303,-1767208832,2),(1303,-1206950400,1),(1303,-1191355200,2),(1303,-1175367600,1),(1303,-1159819200,2),(1303,-633812400,1),(1303,-622062000,2),(1303,-602276400,1),(1303,-591825600,2),(1303,-570740400,1),(1303,-560203200,2),(1303,-539118000,1),(1303,-531345600,2),(1303,-191358000,1),(1303,-184190400,2),(1303,-155156400,1),(1303,-150062400,2),(1303,-128890800,1),(1303,-121118400,2),(1303,-99946800,1),(1303,-89582400,2),(1303,-68410800,1),(1303,-57960000,2),(1303,499755613,1),(1303,511243213,2),(1303,530600413,1),(1303,540273613,2),(1303,562136413,1),(1303,571204814,2),(1303,750834018,1),(1303,761716818,2),(1303,1214283623,3),(1303,1384056025,2),(1304,-2147483648,0),(1304,-1546279392,2),(1304,547020013,1),(1304,559717213,2),(1304,578469614,1),(1304,591166814,2),(1305,-2147483648,0),(1305,-1514739600,1),(1305,-1451667600,2),(1305,-1343062800,3),(1305,-1234803600,2),(1305,-1222963200,4),(1305,-1207242000,2),(1305,-873820800,5),(1305,-769395600,6),(1305,-761677200,2),(1305,-686073600,4),(1305,-661539600,2),(1305,-495039600,4),(1305,-481734000,2),(1305,-463590000,4),(1305,-450284400,2),(1305,-431535600,4),(1305,-418230000,2),(1305,-400086000,4),(1305,-386780400,2),(1305,-368636400,4),(1305,-355330800,2),(1305,-337186800,4),(1305,-323881200,2),(1305,-305737200,4),(1305,-292431600,2),(1305,199274405,4),(1305,215600405,2),(1305,230724006,4),(1305,247050006,2),(1305,262778407,4),(1305,278499607,2),(1305,294228008,4),(1305,309949208,2),(1305,325677609,4),(1305,341398809,2),(1305,357127209,4),(1305,372848410,2),(1305,388576810,4),(1305,404902811,2),(1305,420026411,4),(1305,436352412,2),(1305,452080812,4),(1305,467802012,2),(1305,483530412,4),(1305,499251613,2),(1305,514980013,4),(1305,530701213,2),(1305,544615213,4),(1305,562150813,2),(1305,576064814,4),(1305,594205214,2),(1305,607514414,4),(1305,625654814,2),(1305,638964015,4),(1305,657104415,2),(1305,671018416,4),(1305,688554016,2),(1305,702468016,4),(1305,720003617,2),(1305,733917617,4),(1305,752058018,2),(1305,765367218,4),(1305,783507619,2),(1305,796816819,4),(1305,814957219,2),(1305,828871220,4),(1305,846406820,2),(1305,860320820,4),(1305,877856421,2),(1305,891770421,4),(1305,909306021,2),(1305,923220022,4),(1305,941360422,2),(1305,954669622,4),(1305,972810022,2),(1305,986119222,4),(1305,1004259622,2),(1305,1018173622,4),(1305,1035709222,2),(1305,1049623222,4),(1305,1067158822,2),(1305,1081072822,4),(1305,1099213222,2),(1305,1112522422,4),(1305,1130662822,2),(1305,1143972023,4),(1305,1162112423,2),(1305,1175421623,4),(1305,1193562023,2),(1305,1207476023,4),(1305,1225011623,2),(1305,1238925624,4),(1305,1256461224,2),(1305,1268560824,4),(1305,1289120424,2),(1305,1300010424,4),(1305,1320570024,2),(1305,1331460024,4),(1305,1352019625,2),(1305,1362909625,4),(1305,1383469225,2),(1305,1394359225,4),(1305,1414918825,2),(1305,1425808825,4),(1305,1446368426,2),(1305,1457863226,4),(1305,1478422826,2),(1305,1489312827,4),(1305,1509872427,2),(1305,1520762427,4),(1305,1541322027,2),(1305,1552212027,4),(1305,1572771627,2),(1305,1583661627,4),(1305,1604221227,2),(1305,1615716027,4),(1305,1636275627,2),(1305,1647165627,4),(1305,1667725227,2),(1305,1678615227,4),(1305,1699174827,2),(1305,1710064827,4),(1305,1730624427,2),(1305,1741514427,4),(1305,1762074027,2),(1305,1772964027,4),(1305,1793523627,2),(1305,1805018427,4),(1305,1825578027,2),(1305,1836468027,4),(1305,1857027627,2),(1305,1867917627,4),(1305,1888477227,2),(1305,1899367227,4),(1305,1919926827,2),(1305,1930816827,4),(1305,1951376427,2),(1305,1962871227,4),(1305,1983430827,2),(1305,1994320827,4),(1305,2014880427,2),(1305,2025770427,4),(1305,2046330027,2),(1305,2057220027,4),(1305,2077779627,2),(1305,2088669627,4),(1305,2109229227,2),(1305,2120119227,4),(1305,2140678827,2),(1306,-2147483648,2),(1306,-1632060000,1),(1306,-1615129200,2),(1306,-880207200,3),(1306,-769395600,4),(1306,-765385200,2),(1306,-715788000,1),(1306,-702486000,2),(1306,-684338400,1),(1306,-671036400,2),(1306,-652888800,1),(1306,-639586800,2),(1306,-620834400,1),(1306,-608137200,2),(1306,-589384800,1),(1306,-576082800,2),(1306,-557935200,1),(1306,-544633200,2),(1306,-526485600,1),(1306,-513183600,2),(1306,-495036000,1),(1306,-481734000,2),(1306,-463586400,1),(1306,-450284400,2),(1306,-431532000,1),(1306,-418230000,2),(1306,-400082400,1),(1306,-386780400,2),(1306,-368632800,1),(1306,-355330800,2),(1306,-337183200,1),(1306,-323881200,2),(1306,-305733600,1),(1306,-292431600,2),(1306,-273679200,1),(1306,-260982000,2),(1306,-242229600,1),(1306,-226508400,2),(1306,-210780000,1),(1306,-195058800,2),(1306,-179330400,1),(1306,-163609200,2),(1306,-147880800,1),(1306,-131554800,2),(1306,-116431200,1),(1306,-100105200,2),(1306,-84376800,1),(1306,-68655600,2),(1306,-52927200,1),(1306,-37206000,2),(1306,-21477600,1),(1306,-5756400,2),(1306,9972000,1),(1306,25693200,2),(1306,41421600,1),(1306,57747600,2),(1306,73476000,1),(1306,89197201,2),(1306,104925602,1),(1306,120646802,2),(1306,136375203,1),(1306,152096403,2),(1306,167824804,1),(1306,183546004,2),(1306,199274405,1),(1306,215600405,2),(1306,230724006,1),(1306,247050006,2),(1306,262778407,1),(1306,278499607,2),(1306,294228008,1),(1306,309949208,2),(1306,325677609,1),(1306,341398809,2),(1306,357127209,1),(1306,372848410,2),(1306,388576810,1),(1306,404902811,2),(1306,420026411,1),(1306,436352412,2),(1306,452080812,1),(1306,467802012,2),(1306,483530412,1),(1306,499251613,2),(1306,514980013,1),(1306,530701213,2),(1306,544615213,1),(1306,562150813,2),(1306,576064814,1),(1306,594205214,2),(1306,607514414,1),(1306,625654814,2),(1306,638964015,1),(1306,657104415,2),(1306,671018416,1),(1306,688554016,2),(1306,702468016,1),(1306,720003617,2),(1306,733917617,1),(1306,752058018,2),(1306,765367218,1),(1306,783507619,2),(1306,796816819,1),(1306,814957219,2),(1306,828871220,1),(1306,846406820,2),(1306,860320820,1),(1306,877856421,2),(1306,891770421,1),(1306,909306021,2),(1306,923220022,1),(1306,941360422,2),(1306,954669622,1),(1306,972810022,2),(1306,986119222,1),(1306,1004259622,2),(1306,1018173622,1),(1306,1035709222,2),(1306,1049623222,1),(1306,1067158822,2),(1306,1081072822,1),(1306,1099213222,2),(1306,1112522422,1),(1306,1130662822,2),(1306,1143972023,1),(1306,1162112423,2),(1306,1173607223,1),(1306,1194166823,2),(1306,1205056823,1),(1306,1225616423,2),(1306,1236506424,1),(1306,1257066024,2),(1306,1268560824,1),(1306,1289120424,2),(1306,1300010424,1),(1306,1320570024,2),(1306,1331460024,1),(1306,1352019625,2),(1306,1362909625,1),(1306,1383469225,2),(1306,1394359225,1),(1306,1414918825,2),(1306,1425808825,5),(1307,-2147483648,3),(1307,-1633276800,1),(1307,-1615136400,2),(1307,-1601827200,1),(1307,-1583686800,2),(1307,-900259200,1),(1307,-891795600,2),(1307,-880214400,4),(1307,-769395600,5),(1307,-765392400,2),(1307,-747244800,1),(1307,-733942800,2),(1307,-715795200,1),(1307,-702493200,2),(1307,-684345600,1),(1307,-671043600,2),(1307,-652896000,1),(1307,-639594000,2),(1307,-620841600,1),(1307,-608144400,2),(1307,-589392000,1),(1307,-576090000,2),(1307,-557942400,1),(1307,-544640400,2),(1307,-526492800,1),(1307,-513190800,2),(1307,-495043200,1),(1307,-481741200,2),(1307,-463593600,6),(1307,-386787600,2),(1307,-368640000,6),(1307,-21488400,7),(1307,-5767200,6),(1307,9961200,7),(1307,25682400,6),(1307,1143961223,7),(1307,1162101623,6),(1307,1173596423,7),(1307,1194156023,6),(1307,1205046023,7),(1307,1225605623,6),(1307,1236495624,7),(1307,1257055224,6),(1307,1268550024,7),(1307,1289109624,6),(1307,1299999624,7),(1307,1320559224,6),(1307,1331449224,7),(1307,1352008825,6),(1307,1362898825,7),(1307,1383458425,6),(1307,1394348425,7),(1307,1414908025,6),(1307,1425798025,7),(1307,1446357626,6),(1307,1457852426,7),(1307,1478412026,6),(1307,1489302027,7),(1307,1509861627,6),(1307,1520751627,7),(1307,1541311227,6),(1307,1552201227,7),(1307,1572760827,6),(1307,1583650827,7),(1307,1604210427,6),(1307,1615705227,7),(1307,1636264827,6),(1307,1647154827,7),(1307,1667714427,6),(1307,1678604427,7),(1307,1699164027,6),(1307,1710054027,7),(1307,1730613627,6),(1307,1741503627,7),(1307,1762063227,6),(1307,1772953227,7),(1307,1793512827,6),(1307,1805007627,7),(1307,1825567227,6),(1307,1836457227,7),(1307,1857016827,6),(1307,1867906827,7),(1307,1888466427,6),(1307,1899356427,7),(1307,1919916027,6),(1307,1930806027,7),(1307,1951365627,6),(1307,1962860427,7),(1307,1983420027,6),(1307,1994310027,7),(1307,2014869627,6),(1307,2025759627,7),(1307,2046319227,6),(1307,2057209227,7),(1307,2077768827,6),(1307,2088658827,7),(1307,2109218427,6),(1307,2120108427,7),(1307,2140668027,6),(1308,-2147483648,0),(1308,-1767216360,2),(1308,-1206957600,1),(1308,-1191362400,2),(1308,-1175374800,1),(1308,-1159826400,2),(1308,-633819600,1),(1308,-622069200,2),(1308,-602283600,1),(1308,-591832800,2),(1308,-570747600,1),(1308,-560210400,2),(1308,-539125200,1),(1308,-531352800,2),(1308,-191365200,1),(1308,-184197600,2),(1308,-155163600,1),(1308,-150069600,2),(1308,-128898000,1),(1308,-121125600,2),(1308,-99954000,1),(1308,-89589600,2),(1308,-68418000,1),(1308,-57967200,2),(1308,499748413,1),(1308,511236013,2),(1308,530593213,1),(1308,540266413,2),(1308,562129213,1),(1308,571197614,2),(1308,592974014,1),(1308,602042414,2),(1308,624423614,1),(1308,634701615,2),(1308,938919622,1),(1308,951616822,2),(1308,970974022,1),(1308,972180022,2),(1308,1003028422,1),(1308,1013911222,2),(1309,-2147483648,0),(1309,-2131646412,2),(1309,-1632074400,1),(1309,-1615143600,2),(1309,-880221600,3),(1309,-769395600,4),(1309,-765399600,2),(1309,-526500000,1),(1309,-513198000,2),(1309,73461600,1),(1309,89182801,2),(1309,104911202,1),(1309,120632402,2),(1309,136360803,1),(1309,152082003,2),(1309,167810404,1),(1309,183531604,2),(1309,199260005,1),(1309,215586005,2),(1309,230709606,1),(1309,247035606,2),(1309,262764007,1),(1309,278485207,2),(1309,294213608,1),(1309,309934808,2),(1309,325663209,1),(1309,341384409,2),(1309,357112809,1),(1309,372834010,2),(1309,388562410,1),(1309,404888411,2),(1309,420012011,1),(1309,436338012,2),(1309,452066412,1),(1309,467787612,2),(1309,483516012,1),(1309,499237213,2),(1309,514965613,1),(1309,530686813,2),(1309,544600813,1),(1309,562136413,2),(1309,576050414,1),(1309,594190814,2),(1309,607500014,1),(1309,625640414,2),(1309,638949615,1),(1309,657090015,2),(1309,671004016,1),(1309,688539616,2),(1309,702453616,1),(1309,719989217,2),(1309,733903217,1),(1309,752043618,2),(1309,765352818,1),(1309,783493219,2),(1309,796802419,1),(1309,814942819,2),(1309,828856820,1),(1309,846392420,2),(1309,860306420,1),(1309,877842021,2),(1309,891756021,1),(1309,909291621,2),(1309,923205622,1),(1309,941346022,2),(1309,954655222,1),(1309,972795622,2),(1309,986104822,1),(1309,1004245222,2),(1309,1018159222,1),(1309,1035694822,2),(1309,1049608822,1),(1309,1067144422,2),(1309,1081058422,1),(1309,1099198822,2),(1309,1112508022,1),(1309,1130648422,2),(1309,1143957623,1),(1309,1162098023,2),(1309,1173592823,1),(1309,1194152423,2),(1309,1205042423,1),(1309,1225602023,2),(1309,1236492024,1),(1309,1257051624,2),(1309,1268546424,1),(1309,1289106024,2),(1309,1299996024,1),(1309,1320555624,2),(1309,1331445624,1),(1309,1352005225,2),(1309,1362895225,1),(1309,1383454825,2),(1309,1394344825,1),(1309,1414904425,2),(1309,1425794425,1),(1309,1446354026,2),(1309,1457848826,1),(1309,1478408426,2),(1309,1489298427,1),(1309,1509858027,2),(1309,1520748027,1),(1309,1541307627,2),(1309,1552197627,1),(1309,1572757227,2),(1309,1583647227,1),(1309,1604206827,2),(1309,1615701627,1),(1309,1636261227,2),(1309,1647151227,1),(1309,1667710827,2),(1309,1678600827,1),(1309,1699160427,2),(1309,1710050427,1),(1309,1730610027,2),(1309,1741500027,1),(1309,1762059627,2),(1309,1772949627,1),(1309,1793509227,2),(1309,1805004027,1),(1309,1825563627,2),(1309,1836453627,1),(1309,1857013227,2),(1309,1867903227,1),(1309,1888462827,2),(1309,1899352827,1),(1309,1919912427,2),(1309,1930802427,1),(1309,1951362027,2),(1309,1962856827,1),(1309,1983416427,2),(1309,1994306427,1),(1309,2014866027,2),(1309,2025756027,1),(1309,2046315627,2),(1309,2057205627,1),(1309,2077765227,2),(1309,2088655227,1),(1309,2109214827,2),(1309,2120104827,1),(1309,2140664427,2),(1310,-2147483648,0),(1310,-1686083584,1),(1310,323845209,4),(1310,338950809,2),(1310,354675609,3),(1310,370400410,2),(1310,386125210,3),(1310,401850011,2),(1310,417574811,3),(1310,433299612,2),(1310,449024412,3),(1310,465354012,2),(1310,481078812,3),(1310,496803613,2),(1310,512528413,3),(1310,528253213,2),(1310,543978013,3),(1310,559702813,2),(1310,575427614,3),(1310,591152414,2),(1310,606877214,3),(1310,622602014,2),(1310,638326815,3),(1310,654656415,2),(1310,670381216,3),(1310,686106016,2),(1310,701830816,3),(1310,717555617,2),(1310,733280417,3),(1310,749005218,2),(1310,764730018,3),(1310,780454819,2),(1310,796179619,3),(1310,811904419,2),(1310,828234020,3),(1310,846378020,2),(1310,859683620,3),(1310,877827621,2),(1310,891133221,3),(1310,909277221,2),(1310,922582822,3),(1310,941331622,2),(1310,954032422,3),(1310,972781222,2),(1310,985482022,3),(1310,1004230822,2),(1310,1017536422,3),(1310,1035680422,2),(1310,1048986022,3),(1310,1067130022,2),(1310,1080435622,3),(1310,1099184422,2),(1310,1111885222,3),(1310,1130634022,2),(1310,1143334823,3),(1310,1162083623,2),(1310,1174784423,3),(1310,1193533223,2),(1310,1206838823,3),(1310,1224982823,2),(1310,1238288424,3),(1310,1256432424,2),(1310,1269738024,3),(1310,1288486824,2),(1310,1301187624,3),(1310,1319936424,2),(1310,1332637224,3),(1310,1351386025,2),(1310,1364691625,3),(1310,1382835625,2),(1310,1396141225,3),(1310,1414285225,2),(1310,1427590825,3),(1310,1445734826,2),(1310,1459040426,3),(1310,1477789226,2),(1310,1490490027,3),(1310,1509238827,2),(1310,1521939627,3),(1310,1540688427,2),(1310,1553994027,3),(1310,1572138027,2),(1310,1585443627,3),(1310,1603587627,2),(1310,1616893227,3),(1310,1635642027,2),(1310,1648342827,3),(1310,1667091627,2),(1310,1679792427,3),(1310,1698541227,5),(1310,1711846827,6),(1310,1729990827,5),(1310,1743296427,6),(1310,1761440427,5),(1310,1774746027,6),(1310,1792890027,5),(1310,1806195627,6),(1310,1824944427,5),(1310,1837645227,6),(1310,1856394027,5),(1310,1869094827,6),(1310,1887843627,5),(1310,1901149227,6),(1310,1919293227,5),(1310,1932598827,6),(1310,1950742827,5),(1310,1964048427,6),(1310,1982797227,5),(1310,1995498027,6),(1310,2014246827,5),(1310,2026947627,6),(1310,2045696427,5),(1310,2058397227,6),(1310,2077146027,5),(1310,2090451627,6),(1310,2108595627,5),(1310,2121901227,6),(1310,2140045227,5),(1311,-2147483648,1),(1311,-1632076148,2),(1311,-1615145348,1),(1311,-1096921748,3),(1311,-1061670600,4),(1311,-1048973400,3),(1311,-1030221000,4),(1311,-1017523800,3),(1311,-998771400,4),(1311,-986074200,3),(1311,-966717000,4),(1311,-954624600,3),(1311,-935267400,4),(1311,-922570200,3),(1311,-903817800,4),(1311,-891120600,3),(1311,-872368200,6),(1311,-769395600,5),(1311,-765401400,3),(1311,-746044200,4),(1311,-733347000,3),(1311,-714594600,4),(1311,-701897400,3),(1311,-683145000,4),(1311,-670447800,3),(1311,-651695400,4),(1311,-638998200,3),(1311,-619641000,4),(1311,-606943800,3),(1311,-589401000,4),(1311,-576099000,3),(1311,-557951400,4),(1311,-544649400,3),(1311,-526501800,4),(1311,-513199800,3),(1311,-495052200,4),(1311,-481750200,3),(1311,-463602600,4),(1311,-450300600,3),(1311,-431548200,4),(1311,-418246200,3),(1311,-400098600,4),(1311,-386796600,3),(1311,-368649000,4),(1311,-355347000,3),(1311,-337199400,4),(1311,-323897400,3),(1311,-305749800,4),(1311,-289423800,3),(1311,-273695400,4),(1311,-257974200,3),(1311,-242245800,4),(1311,-226524600,3),(1311,-210796200,4),(1311,-195075000,3),(1311,-179346600,4),(1311,-163625400,3),(1311,-147897000,4),(1311,-131571000,3),(1311,-119903400,8),(1311,-116445600,7),(1311,-100119600,8),(1311,-84391200,7),(1311,-68670000,8),(1311,-52941600,7),(1311,-37220400,8),(1311,-21492000,7),(1311,-5770800,8),(1311,9957600,7),(1311,25678800,8),(1311,41407200,7),(1311,57733200,8),(1311,73461600,7),(1311,89182801,8),(1311,104911202,7),(1311,120632402,8),(1311,136360803,7),(1311,152082003,8),(1311,167810404,7),(1311,183531604,8),(1311,199260005,7),(1311,215586005,8),(1311,230709606,7),(1311,247035606,8),(1311,262764007,7),(1311,278485207,8),(1311,294213608,7),(1311,309934808,8),(1311,325663209,7),(1311,341384409,8),(1311,357112809,7),(1311,372834010,8),(1311,388562410,7),(1311,404888411,8),(1311,420012011,7),(1311,436338012,8),(1311,452066412,7),(1311,467787612,8),(1311,483516012,7),(1311,499237213,8),(1311,514965613,7),(1311,530686813,8),(1311,544593673,7),(1311,562129273,8),(1311,576043274,9),(1311,594180074,8),(1311,607492874,7),(1311,625633274,8),(1311,638942475,7),(1311,657082875,8),(1311,670996876,7),(1311,688532476,8),(1311,702446476,7),(1311,719982077,8),(1311,733896077,7),(1311,752036478,8),(1311,765345678,7),(1311,783486079,8),(1311,796795279,7),(1311,814935679,8),(1311,828849680,7),(1311,846385280,8),(1311,860299280,7),(1311,877834881,8),(1311,891748881,7),(1311,909284481,8),(1311,923198482,7),(1311,941338882,8),(1311,954648082,7),(1311,972788482,8),(1311,986097682,7),(1311,1004238082,8),(1311,1018152082,7),(1311,1035687682,8),(1311,1049601682,7),(1311,1067137282,8),(1311,1081051282,7),(1311,1099191682,8),(1311,1112500882,7),(1311,1130641282,8),(1311,1143950483,7),(1311,1162090883,8),(1311,1173585683,7),(1311,1194145283,8),(1311,1205035283,7),(1311,1225594883,8),(1311,1236484884,7),(1311,1257044484,8),(1311,1268539284,7),(1311,1289098884,8),(1311,1299988884,7),(1311,1320555624,8),(1311,1331445624,7),(1311,1352005225,8),(1311,1362895225,7),(1311,1383454825,8),(1311,1394344825,7),(1311,1414904425,8),(1311,1425794425,7),(1311,1446354026,8),(1311,1457848826,7),(1311,1478408426,8),(1311,1489298427,7),(1311,1509858027,8),(1311,1520748027,7),(1311,1541307627,8),(1311,1552197627,7),(1311,1572757227,8),(1311,1583647227,7),(1311,1604206827,8),(1311,1615701627,7),(1311,1636261227,8),(1311,1647151227,7),(1311,1667710827,8),(1311,1678600827,7),(1311,1699160427,8),(1311,1710050427,7),(1311,1730610027,8),(1311,1741500027,7),(1311,1762059627,8),(1311,1772949627,7),(1311,1793509227,8),(1311,1805004027,7),(1311,1825563627,8),(1311,1836453627,7),(1311,1857013227,8),(1311,1867903227,7),(1311,1888462827,8),(1311,1899352827,7),(1311,1919912427,8),(1311,1930802427,7),(1311,1951362027,8),(1311,1962856827,7),(1311,1983416427,8),(1311,1994306427,7),(1311,2014866027,8),(1311,2025756027,7),(1311,2046315627,8),(1311,2057205627,7),(1311,2077765227,8),(1311,2088655227,7),(1311,2109214827,8),(1311,2120104827,7),(1311,2140664427,8),(1312,-2147483648,1),(1312,-1827687170,2),(1312,294217208,3),(1312,309938408,2),(1312,325666809,3),(1312,341388009,2),(1312,357116409,3),(1312,372837610,2),(1312,388566010,3),(1312,404892011,2),(1312,420015611,3),(1312,436341612,2),(1312,452070012,3),(1312,467791212,2),(1312,483519612,3),(1312,499240813,2),(1312,514969213,3),(1312,530690413,2),(1312,544604413,3),(1312,562140013,2),(1312,576054014,3),(1312,594194414,2),(1312,607503614,3),(1312,625644014,2),(1312,638953215,3),(1312,657093615,2),(1312,671007616,3),(1312,688543216,2),(1312,702457216,3),(1312,719992817,2),(1312,733906817,3),(1312,752047218,2),(1312,765356418,3),(1312,783496819,2),(1312,796806019,3),(1312,814946419,2),(1312,828860420,3),(1312,846396020,2),(1312,860310020,3),(1312,877845621,2),(1312,891759621,3),(1312,909295221,2),(1312,923209222,3),(1312,941349622,2),(1312,954658822,3),(1312,972799222,2),(1312,986108422,3),(1312,1004248822,2),(1312,1018162822,3),(1312,1035698422,2),(1312,1049612422,3),(1312,1067148022,2),(1312,1081062022,3),(1312,1099202422,2),(1312,1112511622,3),(1312,1130652022,2),(1312,1143961223,3),(1312,1162101623,2),(1312,1173596423,3),(1312,1194156023,2),(1312,1205046023,3),(1312,1225605623,2),(1312,1236495624,3),(1312,1257055224,2),(1312,1268550024,3),(1312,1289109624,2),(1312,1299999624,3),(1312,1320559224,2),(1312,1331449224,3),(1312,1352008825,2),(1312,1362898825,3),(1312,1383458425,2),(1312,1394348425,3),(1312,1414908025,2),(1312,1425798025,4),(1312,1520751627,3),(1312,1541311227,2),(1312,1552201227,3),(1312,1572760827,2),(1312,1583650827,3),(1312,1604210427,2),(1312,1615705227,3),(1312,1636264827,2),(1312,1647154827,3),(1312,1667714427,2),(1312,1678604427,3),(1312,1699164027,2),(1312,1710054027,3),(1312,1730613627,2),(1312,1741503627,3),(1312,1762063227,2),(1312,1772953227,3),(1312,1793512827,2),(1312,1805007627,3),(1312,1825567227,2),(1312,1836457227,3),(1312,1857016827,2),(1312,1867906827,3),(1312,1888466427,2),(1312,1899356427,3),(1312,1919916027,2),(1312,1930806027,3),(1312,1951365627,2),(1312,1962860427,3),(1312,1983420027,2),(1312,1994310027,3),(1312,2014869627,2),(1312,2025759627,3),(1312,2046319227,2),(1312,2057209227,3),(1312,2077768827,2),(1312,2088658827,3),(1312,2109218427,2),(1312,2120108427,3),(1312,2140668027,2),(1313,-2147483648,1),(1313,-873057600,3),(1313,-769395600,2),(1313,-765399600,1),(1314,-2147483648,1),(1314,-873057600,3),(1314,-769395600,2),(1314,-765399600,1),(1315,-2147483648,0),(1315,-1617040676,2),(1315,123055202,1),(1315,130914003,2),(1315,422344811,1),(1315,433054812,2),(1315,669708016,1),(1315,684219616,2),(1315,1146376823,1),(1315,1159678823,2),(1316,-2147483648,1),(1316,-1230749160,3),(1316,722926817,2),(1316,728884817,3),(1317,-2147483648,0),(1317,-1843589241,1),(1317,-1730577600,2),(1317,176096704,3),(1317,701841616,1),(1318,-2147483648,0),(1318,-2131645536,2),(1318,-1696276800,1),(1318,-1680469200,2),(1318,-1632074400,1),(1318,-1615143600,2),(1318,-1566763200,1),(1318,-1557090000,2),(1318,-1535486400,1),(1318,-1524949200,2),(1318,-1504468800,1),(1318,-1493413200,2),(1318,-1472414400,1),(1318,-1461963600,2),(1318,-1440964800,1),(1318,-1429390800,2),(1318,-1409515200,1),(1318,-1396731600,2),(1318,-1376856000,1),(1318,-1366491600,2),(1318,-1346616000,1),(1318,-1333832400,2),(1318,-1313956800,1),(1318,-1303678800,2),(1318,-1282507200,1),(1318,-1272661200,2),(1318,-1251057600,1),(1318,-1240088400,2),(1318,-1219608000,1),(1318,-1207429200,2),(1318,-1188763200,1),(1318,-1175979600,2),(1318,-1157313600,1),(1318,-1143925200,2),(1318,-1124049600,1),(1318,-1113771600,2),(1318,-1091390400,1),(1318,-1081026000,2),(1318,-1059854400,1),(1318,-1050786000,2),(1318,-1030910400,1),(1318,-1018126800,2),(1318,-999460800,1),(1318,-986677200,2),(1318,-965592000,1),(1318,-955227600,2),(1318,-935956800,1),(1318,-923173200,2),(1318,-904507200,1),(1318,-891723600,2),(1318,-880221600,3),(1318,-769395600,4),(1318,-765399600,2),(1318,-747252000,1),(1318,-733950000,2),(1318,-715802400,1),(1318,-702500400,2),(1318,-684352800,1),(1318,-671050800,2),(1318,-652903200,1),(1318,-639601200,2),(1318,-589399200,1),(1318,-576097200,2),(1318,-557949600,1),(1318,-544647600,2),(1318,-526500000,1),(1318,-513198000,2),(1318,-495050400,1),(1318,-481748400,2),(1318,-431546400,1),(1318,-418244400,2),(1318,-400096800,1),(1318,-386794800,2),(1318,-368647200,1),(1318,-355345200,2),(1318,-337197600,1),(1318,-323895600,2),(1318,-242244000,1),(1318,-226522800,2),(1318,-210794400,1),(1318,-195073200,2),(1318,-179344800,1),(1318,-163623600,2),(1318,-147895200,1),(1318,-131569200,2),(1318,-116445600,1),(1318,-100119600,2),(1318,-84391200,1),(1318,-68670000,2),(1318,-52941600,1),(1318,-37220400,2),(1318,-21492000,1),(1318,-5770800,2),(1318,9957600,1),(1318,25678800,2),(1318,41407200,1),(1318,57733200,2),(1318,73461600,1),(1318,89182801,2),(1318,104911202,1),(1318,120632402,2),(1318,136360803,1),(1318,152082003,2),(1318,167810404,1),(1318,183531604,2),(1318,199260005,1),(1318,215586005,2),(1318,230709606,1),(1318,247035606,2),(1318,262764007,1),(1318,278485207,2),(1318,294213608,1),(1318,309934808,2),(1318,325663209,1),(1318,341384409,2),(1318,357112809,1),(1318,372834010,2),(1318,388562410,1),(1318,404888411,2),(1318,420012011,1),(1318,436338012,2),(1318,452066412,1),(1318,467787612,2),(1318,483516012,1),(1318,499237213,2),(1318,514965613,1),(1318,530686813,2),(1318,544600813,1),(1318,562136413,2),(1318,576050414,1),(1318,594190814,2),(1318,607500014,1),(1318,625640414,2),(1318,638949615,1),(1318,657090015,2),(1318,671004016,1),(1318,688539616,2),(1318,702453616,1),(1318,719989217,2),(1318,733903217,1),(1318,752043618,2),(1318,765352818,1),(1318,783493219,2),(1318,796802419,1),(1318,814942819,2),(1318,828856820,1),(1318,846392420,2),(1318,860306420,1),(1318,877842021,2),(1318,891756021,1),(1318,909291621,2),(1318,923205622,1),(1318,941346022,2),(1318,954655222,1),(1318,972795622,2),(1318,986104822,1),(1318,1004245222,2),(1318,1018159222,1),(1318,1035694822,2),(1318,1049608822,1),(1318,1067144422,2),(1318,1081058422,1),(1318,1099198822,2),(1318,1112508022,1),(1318,1130648422,2),(1318,1143957623,1),(1318,1162098023,2),(1318,1173592823,1),(1318,1194152423,2),(1318,1205042423,1),(1318,1225602023,2),(1318,1236492024,1),(1318,1257051624,2),(1318,1268546424,1),(1318,1289106024,2),(1318,1299996024,1),(1318,1320555624,2),(1318,1331445624,1),(1318,1352005225,2),(1318,1362895225,1),(1318,1383454825,2),(1318,1394344825,1),(1318,1414904425,2),(1318,1425794425,1),(1318,1446354026,2),(1318,1457848826,1),(1318,1478408426,2),(1318,1489298427,1),(1318,1509858027,2),(1318,1520748027,1),(1318,1541307627,2),(1318,1552197627,1),(1318,1572757227,2),(1318,1583647227,1),(1318,1604206827,2),(1318,1615701627,1),(1318,1636261227,2),(1318,1647151227,1),(1318,1667710827,2),(1318,1678600827,1),(1318,1699160427,2),(1318,1710050427,1),(1318,1730610027,2),(1318,1741500027,1),(1318,1762059627,2),(1318,1772949627,1),(1318,1793509227,2),(1318,1805004027,1),(1318,1825563627,2),(1318,1836453627,1),(1318,1857013227,2),(1318,1867903227,1),(1318,1888462827,2),(1318,1899352827,1),(1318,1919912427,2),(1318,1930802427,1),(1318,1951362027,2),(1318,1962856827,1),(1318,1983416427,2),(1318,1994306427,1),(1318,2014866027,2),(1318,2025756027,1),(1318,2046315627,2),(1318,2057205627,1),(1318,2077765227,2),(1318,2088655227,1),(1318,2109214827,2),(1318,2120104827,1),(1318,2140664427,2),(1319,-2147483648,1),(1319,-1402813824,3),(1319,-1311534000,2),(1319,-1300996800,3),(1319,-933534000,2),(1319,-925675200,3),(1319,-902084400,2),(1319,-893620800,3),(1319,-870030000,2),(1319,-862171200,3),(1319,-775681200,2),(1319,-767822400,3),(1319,-744231600,2),(1319,-736372800,3),(1319,-144702000,2),(1319,-134251200,3),(1319,-113425200,2),(1319,-102542400,3),(1319,-86295600,2),(1319,-72907200,3),(1319,-54154800,2),(1319,-41457600,3),(1319,-21495600,2),(1319,-5774400,3),(1319,9954000,2),(1319,25675200,3),(1319,41403600,2),(1319,57729600,3),(1319,73458000,2),(1319,87364801,3),(1319,104907602,2),(1319,118900802,3),(1319,136357203,2),(1319,150436803,3),(1319,167806804,2),(1319,183528004,3),(1319,199256405,2),(1319,215582405,3),(1319,230706006,2),(1319,247032006,3),(1319,263365207,2),(1319,276667207,3),(1319,290581208,2),(1319,308721608,3),(1319,322030809,2),(1319,340171209,3),(1319,358318809,2),(1319,371620810,3),(1319,389768410,2),(1319,403070411,3),(1319,421218011,2),(1319,434520012,3),(1319,452667612,2),(1319,466574412,3),(1319,484117212,2),(1319,498024013,3),(1319,511333213,2),(1319,529473613,3),(1319,542782813,2),(1319,560923213,3),(1319,574837214,2),(1319,592372814,3),(1319,606286814,2),(1319,623822414,3),(1319,638946015,2),(1319,655876815,3),(1319,671000416,2),(1319,687330016,4),(1319,702450016,2),(1319,718779617,4),(1319,733899617,2),(1319,750229218,4),(1319,765349218,2),(1319,781678819,4),(1319,796798819,2),(1319,813128419,4),(1319,828853220,2),(1319,844578020,4),(1319,860302820,2),(1319,876632421,4),(1319,891147621,5),(1319,909291621,4),(1319,922597222,5),(1319,941346022,4),(1319,954651622,5),(1319,972795622,4),(1319,986101222,5),(1319,1004245222,4),(1319,1018155622,5),(1319,1035694822,4),(1319,1049605222,5),(1319,1067144422,4),(1319,1080450022,5),(1319,1162098023,4),(1319,1173589223,5),(1319,1193547623,4),(1319,1205643623,5),(1319,1224997223,4),(1319,1236488424,5),(1319,1256446824,4),(1319,1268542824,5),(1319,1288501224,4),(1319,1300597224,5),(1319,1321160424,4),(1319,1333256424,5),(1319,1352005225,4),(1319,1362891625,5),(1319,1383454825,4),(1319,1394341225,5),(1319,1414904425,4),(1319,1425790825,5),(1319,1446354026,4),(1319,1457845226,5),(1319,1478408426,4),(1319,1489294827,5),(1319,1509858027,4),(1319,1520744427,5),(1319,1541307627,4),(1319,1552194027,5),(1319,1572757227,4),(1319,1583643627,5),(1319,1604206827,4),(1319,1615698027,5),(1319,1636261227,4),(1319,1647147627,5),(1319,1667710827,4),(1319,1678597227,5),(1319,1699160427,4),(1319,1710046827,5),(1319,1730610027,4),(1319,1741496427,5),(1319,1762059627,4),(1319,1772946027,5),(1319,1793509227,4),(1319,1805000427,5),(1319,1825563627,4),(1319,1836450027,5),(1319,1857013227,4),(1319,1867899627,5),(1319,1888462827,4),(1319,1899349227,5),(1319,1919912427,4),(1319,1930798827,5),(1319,1951362027,4),(1319,1962853227,5),(1319,1983416427,4),(1319,1994302827,5),(1319,2014866027,4),(1319,2025752427,5),(1319,2046315627,4),(1319,2057202027,5),(1319,2077765227,4),(1319,2088651627,5),(1319,2109214827,4),(1319,2120101227,5),(1319,2140664427,4),(1320,-2147483648,0),(1320,-1514739600,1),(1320,-1343066400,2),(1320,-1234807200,4),(1320,-1220292000,3),(1320,-1207159200,4),(1320,-1191344400,2),(1320,-873828000,4),(1320,-661539600,5),(1320,28800,4),(1320,828867620,3),(1320,846403220,4),(1320,860317220,3),(1320,877852821,4),(1320,891766821,3),(1320,909302421,4),(1321,-2147483648,3),(1321,-1633276800,1),(1321,-1615136400,2),(1321,-1601827200,1),(1321,-1583686800,2),(1321,-900259200,1),(1321,-891795600,2),(1321,-880214400,4),(1321,-769395600,5),(1321,-765392400,2),(1321,-747244800,1),(1321,-733942800,2),(1321,-715795200,1),(1321,-702493200,2),(1321,-684345600,1),(1321,-671043600,2),(1321,-652896000,1),(1321,-639594000,2),(1321,-620841600,1),(1321,-608144400,2),(1321,-589392000,1),(1321,-576090000,2),(1321,-557942400,1),(1321,-544640400,2),(1321,-526492800,1),(1321,-513190800,2),(1321,-495043200,1),(1321,-481741200,2),(1321,-463593600,6),(1321,-386787600,2),(1321,-368640000,6),(1321,-21488400,7),(1321,-5767200,6),(1321,9961200,7),(1321,25682400,6),(1321,1143961223,7),(1321,1162101623,6),(1321,1173596423,7),(1321,1194156023,6),(1321,1205046023,7),(1321,1225605623,6),(1321,1236495624,7),(1321,1257055224,6),(1321,1268550024,7),(1321,1289109624,6),(1321,1299999624,7),(1321,1320559224,6),(1321,1331449224,7),(1321,1352008825,6),(1321,1362898825,7),(1321,1383458425,6),(1321,1394348425,7),(1321,1414908025,6),(1321,1425798025,7),(1321,1446357626,6),(1321,1457852426,7),(1321,1478412026,6),(1321,1489302027,7),(1321,1509861627,6),(1321,1520751627,7),(1321,1541311227,6),(1321,1552201227,7),(1321,1572760827,6),(1321,1583650827,7),(1321,1604210427,6),(1321,1615705227,7),(1321,1636264827,6),(1321,1647154827,7),(1321,1667714427,6),(1321,1678604427,7),(1321,1699164027,6),(1321,1710054027,7),(1321,1730613627,6),(1321,1741503627,7),(1321,1762063227,6),(1321,1772953227,7),(1321,1793512827,6),(1321,1805007627,7),(1321,1825567227,6),(1321,1836457227,7),(1321,1857016827,6),(1321,1867906827,7),(1321,1888466427,6),(1321,1899356427,7),(1321,1919916027,6),(1321,1930806027,7),(1321,1951365627,6),(1321,1962860427,7),(1321,1983420027,6),(1321,1994310027,7),(1321,2014869627,6),(1321,2025759627,7),(1321,2046319227,6),(1321,2057209227,7),(1321,2077768827,6),(1321,2088658827,7),(1321,2109218427,6),(1321,2120108427,7),(1321,2140668027,6),(1322,-2147483648,5),(1322,-1633276800,1),(1322,-1615136400,2),(1322,-1601827200,1),(1322,-1583686800,2),(1322,-880214400,3),(1322,-769395600,4),(1322,-765392400,2),(1322,-715795200,1),(1322,-702493200,2),(1322,-684345600,1),(1322,-671043600,2),(1322,-652896000,1),(1322,-639594000,2),(1322,-620841600,1),(1322,-608144400,2),(1322,-589392000,1),(1322,-576090000,2),(1322,-557942400,1),(1322,-544640400,2),(1322,-526492800,1),(1322,-513190800,2),(1322,-495043200,1),(1322,-481741200,2),(1322,-463593600,1),(1322,-447267600,2),(1322,-431539200,1),(1322,-415818000,2),(1322,-400089600,1),(1322,-386787600,2),(1322,-368640000,1),(1322,-355338000,2),(1322,-337190400,1),(1322,-321469200,2),(1322,-305740800,1),(1322,-289414800,2),(1322,-273686400,1),(1322,-257965200,2),(1322,-242236800,6),(1322,-195066000,2),(1322,-84384000,1),(1322,-68662800,2),(1322,-52934400,1),(1322,-37213200,2),(1322,-21484800,1),(1322,-5763600,2),(1322,9964800,1),(1322,25686000,2),(1322,41414400,1),(1322,57740400,2),(1322,73468800,1),(1322,89190001,2),(1322,104918402,1),(1322,120639602,2),(1322,126691203,1),(1322,152089203,2),(1322,162374404,1),(1322,183538804,2),(1322,199267205,1),(1322,215593205,2),(1322,230716806,1),(1322,247042806,2),(1322,262771207,1),(1322,278492407,2),(1322,294220808,1),(1322,309942008,2),(1322,325670409,1),(1322,341391609,2),(1322,357120009,1),(1322,372841210,2),(1322,388569610,1),(1322,404895611,2),(1322,420019211,1),(1322,436345212,2),(1322,452073612,1),(1322,467794812,2),(1322,483523212,1),(1322,499244413,2),(1322,514972813,1),(1322,530694013,2),(1322,544608013,1),(1322,562143613,2),(1322,576057614,1),(1322,594198014,2),(1322,607507214,1),(1322,625647614,2),(1322,638956815,1),(1322,657097215,2),(1322,671011216,1),(1322,688546816,6),(1322,1143961223,1),(1322,1162105223,2),(1322,1173600023,1),(1322,1194159623,2),(1322,1205049623,1),(1322,1225609223,2),(1322,1236499224,1),(1322,1257058824,2),(1322,1268553624,1),(1322,1289113224,2),(1322,1300003224,1),(1322,1320562824,2),(1322,1331452824,1),(1322,1352012425,2),(1322,1362902425,1),(1322,1383462025,2),(1322,1394352025,1),(1322,1414911625,2),(1322,1425801625,1),(1322,1446361226,2),(1322,1457856026,1),(1322,1478415626,2),(1322,1489305627,1),(1322,1509865227,2),(1322,1520755227,1),(1322,1541314827,2),(1322,1552204827,1),(1322,1572764427,2),(1322,1583654427,1),(1322,1604214027,2),(1322,1615708827,1),(1322,1636268427,2),(1322,1647158427,1),(1322,1667718027,2),(1322,1678608027,1),(1322,1699167627,2),(1322,1710057627,1),(1322,1730617227,2),(1322,1741507227,1),(1322,1762066827,2),(1322,1772956827,1),(1322,1793516427,2),(1322,1805011227,1),(1322,1825570827,2),(1322,1836460827,1),(1322,1857020427,2),(1322,1867910427,1),(1322,1888470027,2),(1322,1899360027,1),(1322,1919919627,2),(1322,1930809627,1),(1322,1951369227,2),(1322,1962864027,1),(1322,1983423627,2),(1322,1994313627,1),(1322,2014873227,2),(1322,2025763227,1),(1322,2046322827,2),(1322,2057212827,1),(1322,2077772427,2),(1322,2088662427,1),(1322,2109222027,2),(1322,2120112027,1),(1322,2140671627,2),(1323,-2147483648,5),(1323,-1633276800,1),(1323,-1615136400,2),(1323,-1601827200,1),(1323,-1583686800,2),(1323,-880214400,3),(1323,-769395600,4),(1323,-765392400,2),(1323,-589392000,1),(1323,-576090000,2),(1323,-495043200,1),(1323,-481741200,2),(1323,-463593600,1),(1323,-450291600,2),(1323,-431539200,1),(1323,-418237200,2),(1323,-400089600,1),(1323,-386787600,2),(1323,-368640000,1),(1323,-355338000,2),(1323,-337190400,1),(1323,-323888400,2),(1323,-305740800,1),(1323,-292438800,2),(1323,-273686400,6),(1323,-21488400,7),(1323,-5767200,6),(1323,9961200,7),(1323,25682400,6),(1323,41410800,7),(1323,57736800,6),(1323,73465200,7),(1323,89186401,6),(1323,104914802,7),(1323,120636002,6),(1323,126687603,1),(1323,152089203,6),(1323,162370804,7),(1323,183535204,6),(1323,1143961223,7),(1323,1162101623,6),(1323,1173596423,7),(1323,1194156023,6),(1323,1205046023,7),(1323,1225605623,6),(1323,1236495624,7),(1323,1257055224,6),(1323,1268550024,7),(1323,1289109624,6),(1323,1299999624,7),(1323,1320559224,6),(1323,1331449224,7),(1323,1352008825,6),(1323,1362898825,7),(1323,1383458425,6),(1323,1394348425,7),(1323,1414908025,6),(1323,1425798025,7),(1323,1446357626,6),(1323,1457852426,7),(1323,1478412026,6),(1323,1489302027,7),(1323,1509861627,6),(1323,1520751627,7),(1323,1541311227,6),(1323,1552201227,7),(1323,1572760827,6),(1323,1583650827,7),(1323,1604210427,6),(1323,1615705227,7),(1323,1636264827,6),(1323,1647154827,7),(1323,1667714427,6),(1323,1678604427,7),(1323,1699164027,6),(1323,1710054027,7),(1323,1730613627,6),(1323,1741503627,7),(1323,1762063227,6),(1323,1772953227,7),(1323,1793512827,6),(1323,1805007627,7),(1323,1825567227,6),(1323,1836457227,7),(1323,1857016827,6),(1323,1867906827,7),(1323,1888466427,6),(1323,1899356427,7),(1323,1919916027,6),(1323,1930806027,7),(1323,1951365627,6),(1323,1962860427,7),(1323,1983420027,6),(1323,1994310027,7),(1323,2014869627,6),(1323,2025759627,7),(1323,2046319227,6),(1323,2057209227,7),(1323,2077768827,6),(1323,2088658827,7),(1323,2109218427,6),(1323,2120108427,7),(1323,2140668027,6),(1324,-2147483648,5),(1324,-1633276800,1),(1324,-1615136400,2),(1324,-1601827200,1),(1324,-1583686800,2),(1324,-880214400,3),(1324,-769395600,4),(1324,-765392400,2),(1324,-462996000,1),(1324,-450291600,2),(1324,-431539200,1),(1324,-418237200,2),(1324,-400089600,1),(1324,-386787600,2),(1324,-368640000,1),(1324,-355338000,2),(1324,-337190400,1),(1324,-323888400,2),(1324,-305740800,1),(1324,-292438800,2),(1324,-273686400,1),(1324,-257965200,2),(1324,-242236800,1),(1324,-226515600,2),(1324,-210787200,1),(1324,-195066000,2),(1324,-179337600,1),(1324,-163616400,2),(1324,-147888000,6),(1324,-100112400,2),(1324,-84384000,1),(1324,-68662800,2),(1324,-52934400,1),(1324,-37213200,2),(1324,-21484800,1),(1324,-5763600,2),(1324,9964800,1),(1324,25686000,2),(1324,41414400,1),(1324,57740400,2),(1324,73468800,1),(1324,89190001,2),(1324,104918402,1),(1324,120639602,2),(1324,126691203,1),(1324,152089203,2),(1324,162374404,1),(1324,183538804,2),(1324,199267205,1),(1324,215593205,2),(1324,230716806,1),(1324,247042806,6),(1324,1143961223,1),(1324,1162105223,2),(1324,1173600023,1),(1324,1194159623,6),(1324,1205046023,7),(1324,1225605623,6),(1324,1236495624,7),(1324,1257055224,6),(1324,1268550024,7),(1324,1289109624,6),(1324,1299999624,7),(1324,1320559224,6),(1324,1331449224,7),(1324,1352008825,6),(1324,1362898825,7),(1324,1383458425,6),(1324,1394348425,7),(1324,1414908025,6),(1324,1425798025,7),(1324,1446357626,6),(1324,1457852426,7),(1324,1478412026,6),(1324,1489302027,7),(1324,1509861627,6),(1324,1520751627,7),(1324,1541311227,6),(1324,1552201227,7),(1324,1572760827,6),(1324,1583650827,7),(1324,1604210427,6),(1324,1615705227,7),(1324,1636264827,6),(1324,1647154827,7),(1324,1667714427,6),(1324,1678604427,7),(1324,1699164027,6),(1324,1710054027,7),(1324,1730613627,6),(1324,1741503627,7),(1324,1762063227,6),(1324,1772953227,7),(1324,1793512827,6),(1324,1805007627,7),(1324,1825567227,6),(1324,1836457227,7),(1324,1857016827,6),(1324,1867906827,7),(1324,1888466427,6),(1324,1899356427,7),(1324,1919916027,6),(1324,1930806027,7),(1324,1951365627,6),(1324,1962860427,7),(1324,1983420027,6),(1324,1994310027,7),(1324,2014869627,6),(1324,2025759627,7),(1324,2046319227,6),(1324,2057209227,7),(1324,2077768827,6),(1324,2088658827,7),(1324,2109218427,6),(1324,2120108427,7),(1324,2140668027,6),(1325,-2147483648,5),(1325,-1633276800,1),(1325,-1615136400,2),(1325,-1601827200,1),(1325,-1583686800,2),(1325,-880214400,3),(1325,-769395600,4),(1325,-765392400,2),(1325,-462996000,1),(1325,-450291600,2),(1325,-431539200,1),(1325,-418237200,2),(1325,-400089600,1),(1325,-386787600,2),(1325,-368640000,1),(1325,-355338000,2),(1325,-337190400,1),(1325,-323888400,2),(1325,-305740800,1),(1325,-292438800,2),(1325,-273686400,1),(1325,-257965200,2),(1325,-242236800,1),(1325,-226515600,2),(1325,-210787200,1),(1325,-195066000,2),(1325,-179337600,6),(1325,-68662800,2),(1325,-52934400,1),(1325,-37213200,2),(1325,-21484800,7),(1325,-5767200,6),(1325,9961200,7),(1325,25682400,6),(1325,1143961223,1),(1325,1162105223,2),(1325,1173600023,1),(1325,1194159623,2),(1325,1205049623,1),(1325,1225609223,2),(1325,1236499224,1),(1325,1257058824,2),(1325,1268553624,1),(1325,1289113224,2),(1325,1300003224,1),(1325,1320562824,2),(1325,1331452824,1),(1325,1352012425,2),(1325,1362902425,1),(1325,1383462025,2),(1325,1394352025,1),(1325,1414911625,2),(1325,1425801625,1),(1325,1446361226,2),(1325,1457856026,1),(1325,1478415626,2),(1325,1489305627,1),(1325,1509865227,2),(1325,1520755227,1),(1325,1541314827,2),(1325,1552204827,1),(1325,1572764427,2),(1325,1583654427,1),(1325,1604214027,2),(1325,1615708827,1),(1325,1636268427,2),(1325,1647158427,1),(1325,1667718027,2),(1325,1678608027,1),(1325,1699167627,2),(1325,1710057627,1),(1325,1730617227,2),(1325,1741507227,1),(1325,1762066827,2),(1325,1772956827,1),(1325,1793516427,2),(1325,1805011227,1),(1325,1825570827,2),(1325,1836460827,1),(1325,1857020427,2),(1325,1867910427,1),(1325,1888470027,2),(1325,1899360027,1),(1325,1919919627,2),(1325,1930809627,1),(1325,1951369227,2),(1325,1962864027,1),(1325,1983423627,2),(1325,1994313627,1),(1325,2014873227,2),(1325,2025763227,1),(1325,2046322827,2),(1325,2057212827,1),(1325,2077772427,2),(1325,2088662427,1),(1325,2109222027,2),(1325,2120112027,1),(1325,2140671627,2),(1326,-2147483648,5),(1326,-1633276800,1),(1326,-1615136400,2),(1326,-1601827200,1),(1326,-1583686800,2),(1326,-880214400,3),(1326,-769395600,4),(1326,-765392400,2),(1326,-495043200,6),(1326,-21488400,7),(1326,-5767200,6),(1326,9961200,7),(1326,25682400,6),(1326,41410800,7),(1326,57736800,6),(1326,73465200,7),(1326,89186401,6),(1326,1143961223,7),(1326,1162101623,6),(1326,1173596423,7),(1326,1194156023,6),(1326,1205046023,7),(1326,1225605623,6),(1326,1236495624,7),(1326,1257055224,6),(1326,1268550024,7),(1326,1289109624,6),(1326,1299999624,7),(1326,1320559224,6),(1326,1331449224,7),(1326,1352008825,6),(1326,1362898825,7),(1326,1383458425,6),(1326,1394348425,7),(1326,1414908025,6),(1326,1425798025,7),(1326,1446357626,6),(1326,1457852426,7),(1326,1478412026,6),(1326,1489302027,7),(1326,1509861627,6),(1326,1520751627,7),(1326,1541311227,6),(1326,1552201227,7),(1326,1572760827,6),(1326,1583650827,7),(1326,1604210427,6),(1326,1615705227,7),(1326,1636264827,6),(1326,1647154827,7),(1326,1667714427,6),(1326,1678604427,7),(1326,1699164027,6),(1326,1710054027,7),(1326,1730613627,6),(1326,1741503627,7),(1326,1762063227,6),(1326,1772953227,7),(1326,1793512827,6),(1326,1805007627,7),(1326,1825567227,6),(1326,1836457227,7),(1326,1857016827,6),(1326,1867906827,7),(1326,1888466427,6),(1326,1899356427,7),(1326,1919916027,6),(1326,1930806027,7),(1326,1951365627,6),(1326,1962860427,7),(1326,1983420027,6),(1326,1994310027,7),(1326,2014869627,6),(1326,2025759627,7),(1326,2046319227,6),(1326,2057209227,7),(1326,2077768827,6),(1326,2088658827,7),(1326,2109218427,6),(1326,2120108427,7),(1326,2140668027,6),(1327,-2147483648,5),(1327,-1633276800,1),(1327,-1615136400,2),(1327,-1601827200,1),(1327,-1583686800,2),(1327,-880214400,3),(1327,-769395600,4),(1327,-765392400,2),(1327,-747244800,1),(1327,-733942800,2),(1327,-526492800,1),(1327,-513190800,2),(1327,-495043200,1),(1327,-481741200,2),(1327,-462996000,1),(1327,-450291600,2),(1327,-431539200,1),(1327,-418237200,2),(1327,-400089600,1),(1327,-386787600,2),(1327,-368640000,1),(1327,-355338000,2),(1327,-337190400,1),(1327,-323888400,2),(1327,-305740800,1),(1327,-289414800,2),(1327,-273686400,1),(1327,-260989200,2),(1327,-242236800,1),(1327,-226515600,2),(1327,-210787200,1),(1327,-195066000,2),(1327,-179337600,6),(1327,-21488400,7),(1327,-5767200,6),(1327,9961200,7),(1327,25682400,6),(1327,1143961223,1),(1327,1162105223,2),(1327,1173600023,1),(1327,1194159623,6),(1327,1205046023,7),(1327,1225605623,6),(1327,1236495624,7),(1327,1257055224,6),(1327,1268550024,7),(1327,1289109624,6),(1327,1299999624,7),(1327,1320559224,6),(1327,1331449224,7),(1327,1352008825,6),(1327,1362898825,7),(1327,1383458425,6),(1327,1394348425,7),(1327,1414908025,6),(1327,1425798025,7),(1327,1446357626,6),(1327,1457852426,7),(1327,1478412026,6),(1327,1489302027,7),(1327,1509861627,6),(1327,1520751627,7),(1327,1541311227,6),(1327,1552201227,7),(1327,1572760827,6),(1327,1583650827,7),(1327,1604210427,6),(1327,1615705227,7),(1327,1636264827,6),(1327,1647154827,7),(1327,1667714427,6),(1327,1678604427,7),(1327,1699164027,6),(1327,1710054027,7),(1327,1730613627,6),(1327,1741503627,7),(1327,1762063227,6),(1327,1772953227,7),(1327,1793512827,6),(1327,1805007627,7),(1327,1825567227,6),(1327,1836457227,7),(1327,1857016827,6),(1327,1867906827,7),(1327,1888466427,6),(1327,1899356427,7),(1327,1919916027,6),(1327,1930806027,7),(1327,1951365627,6),(1327,1962860427,7),(1327,1983420027,6),(1327,1994310027,7),(1327,2014869627,6),(1327,2025759627,7),(1327,2046319227,6),(1327,2057209227,7),(1327,2077768827,6),(1327,2088658827,7),(1327,2109218427,6),(1327,2120108427,7),(1327,2140668027,6),(1328,-2147483648,5),(1328,-1633276800,1),(1328,-1615136400,2),(1328,-1601827200,1),(1328,-1583686800,2),(1328,-880214400,3),(1328,-769395600,4),(1328,-765392400,2),(1328,-747244800,1),(1328,-733942800,2),(1328,-715795200,1),(1328,-702493200,2),(1328,-684345600,1),(1328,-671043600,2),(1328,-652896000,1),(1328,-639594000,2),(1328,-620841600,1),(1328,-608144400,2),(1328,-589392000,1),(1328,-576090000,2),(1328,-557942400,1),(1328,-544640400,2),(1328,-526492800,1),(1328,-513190800,2),(1328,-495043200,1),(1328,-481741200,2),(1328,-463593600,1),(1328,-447267600,2),(1328,-431539200,1),(1328,-415818000,2),(1328,-400089600,1),(1328,-386787600,2),(1328,-368640000,1),(1328,-355338000,2),(1328,-337190400,1),(1328,-323888400,2),(1328,-305740800,1),(1328,-292438800,2),(1328,-273686400,6),(1328,-21488400,7),(1328,-5767200,6),(1328,9961200,7),(1328,25682400,6),(1328,1143961223,1),(1328,1162105223,2),(1328,1173600023,7),(1328,1194156023,6),(1328,1205046023,7),(1328,1225605623,6),(1328,1236495624,7),(1328,1257055224,6),(1328,1268550024,7),(1328,1289109624,6),(1328,1299999624,7),(1328,1320559224,6),(1328,1331449224,7),(1328,1352008825,6),(1328,1362898825,7),(1328,1383458425,6),(1328,1394348425,7),(1328,1414908025,6),(1328,1425798025,7),(1328,1446357626,6),(1328,1457852426,7),(1328,1478412026,6),(1328,1489302027,7),(1328,1509861627,6),(1328,1520751627,7),(1328,1541311227,6),(1328,1552201227,7),(1328,1572760827,6),(1328,1583650827,7),(1328,1604210427,6),(1328,1615705227,7),(1328,1636264827,6),(1328,1647154827,7),(1328,1667714427,6),(1328,1678604427,7),(1328,1699164027,6),(1328,1710054027,7),(1328,1730613627,6),(1328,1741503627,7),(1328,1762063227,6),(1328,1772953227,7),(1328,1793512827,6),(1328,1805007627,7),(1328,1825567227,6),(1328,1836457227,7),(1328,1857016827,6),(1328,1867906827,7),(1328,1888466427,6),(1328,1899356427,7),(1328,1919916027,6),(1328,1930806027,7),(1328,1951365627,6),(1328,1962860427,7),(1328,1983420027,6),(1328,1994310027,7),(1328,2014869627,6),(1328,2025759627,7),(1328,2046319227,6),(1328,2057209227,7),(1328,2077768827,6),(1328,2088658827,7),(1328,2109218427,6),(1328,2120108427,7),(1328,2140668027,6),(1329,-2147483648,3),(1329,-1633276800,1),(1329,-1615136400,2),(1329,-1601827200,1),(1329,-1583686800,2),(1329,-900259200,1),(1329,-891795600,2),(1329,-880214400,4),(1329,-769395600,5),(1329,-765392400,2),(1329,-747244800,1),(1329,-733942800,2),(1329,-715795200,1),(1329,-702493200,2),(1329,-684345600,1),(1329,-671043600,2),(1329,-652896000,1),(1329,-639594000,2),(1329,-620841600,1),(1329,-608144400,2),(1329,-589392000,1),(1329,-576090000,2),(1329,-557942400,1),(1329,-544640400,2),(1329,-526492800,1),(1329,-513190800,2),(1329,-495043200,1),(1329,-481741200,2),(1329,-463593600,6),(1329,-386787600,2),(1329,-368640000,6),(1329,-21488400,7),(1329,-5767200,6),(1329,9961200,7),(1329,25682400,6),(1329,1143961223,7),(1329,1162101623,6),(1329,1173596423,7),(1329,1194156023,6),(1329,1205046023,7),(1329,1225605623,6),(1329,1236495624,7),(1329,1257055224,6),(1329,1268550024,7),(1329,1289109624,6),(1329,1299999624,7),(1329,1320559224,6),(1329,1331449224,7),(1329,1352008825,6),(1329,1362898825,7),(1329,1383458425,6),(1329,1394348425,7),(1329,1414908025,6),(1329,1425798025,7),(1329,1446357626,6),(1329,1457852426,7),(1329,1478412026,6),(1329,1489302027,7),(1329,1509861627,6),(1329,1520751627,7),(1329,1541311227,6),(1329,1552201227,7),(1329,1572760827,6),(1329,1583650827,7),(1329,1604210427,6),(1329,1615705227,7),(1329,1636264827,6),(1329,1647154827,7),(1329,1667714427,6),(1329,1678604427,7),(1329,1699164027,6),(1329,1710054027,7),(1329,1730613627,6),(1329,1741503627,7),(1329,1762063227,6),(1329,1772953227,7),(1329,1793512827,6),(1329,1805007627,7),(1329,1825567227,6),(1329,1836457227,7),(1329,1857016827,6),(1329,1867906827,7),(1329,1888466427,6),(1329,1899356427,7),(1329,1919916027,6),(1329,1930806027,7),(1329,1951365627,6),(1329,1962860427,7),(1329,1983420027,6),(1329,1994310027,7),(1329,2014869627,6),(1329,2025759627,7),(1329,2046319227,6),(1329,2057209227,7),(1329,2077768827,6),(1329,2088658827,7),(1329,2109218427,6),(1329,2120108427,7),(1329,2140668027,6),(1330,-2147483648,0),(1330,-536457600,2),(1330,73476000,1),(1330,89197201,2),(1330,104925602,1),(1330,120646802,2),(1330,136375203,1),(1330,152096403,2),(1330,167824804,1),(1330,183546004,2),(1330,199274405,1),(1330,215600405,2),(1330,230724006,1),(1330,247050006,2),(1330,262778407,1),(1330,278499607,2),(1330,294228008,4),(1330,309945608,3),(1330,325674009,4),(1330,341395209,3),(1330,357123609,4),(1330,372844810,3),(1330,388573210,4),(1330,404899211,3),(1330,420022811,4),(1330,436348812,3),(1330,452077212,4),(1330,467798412,3),(1330,483526812,4),(1330,499248013,3),(1330,514976413,4),(1330,530697613,3),(1330,544611613,4),(1330,562147213,3),(1330,576061214,4),(1330,594201614,3),(1330,607510814,4),(1330,625651214,3),(1330,638960415,4),(1330,657100815,3),(1330,671014816,4),(1330,688550416,3),(1330,702464416,4),(1330,720000017,3),(1330,733914017,4),(1330,752054418,3),(1330,765363618,4),(1330,783504019,3),(1330,796813219,4),(1330,814953619,3),(1330,828867620,4),(1330,846403220,3),(1330,860317220,4),(1330,877852821,3),(1330,891766821,4),(1330,909302421,3),(1330,923216422,4),(1330,941356822,3),(1330,954666022,4),(1330,972806422,3),(1330,986115622,4),(1330,1004256022,3),(1330,1018170022,4),(1330,1035705622,3),(1330,1049619622,4),(1330,1067155222,3),(1330,1081069222,4),(1330,1099209622,3),(1330,1112518822,4),(1330,1130659222,3),(1330,1143968423,4),(1330,1162108823,3),(1330,1173603623,4),(1330,1194163223,3),(1330,1205053223,4),(1330,1225612823,3),(1330,1236502824,4),(1330,1257062424,3),(1330,1268557224,4),(1330,1289116824,3),(1330,1300006824,4),(1330,1320566424,3),(1330,1331456424,4),(1330,1352016025,3),(1330,1362906025,4),(1330,1383465625,3),(1330,1394355625,4),(1330,1414915225,3),(1330,1425805225,4),(1330,1446364826,3),(1330,1457859626,4),(1330,1478419226,3),(1330,1489309227,4),(1330,1509868827,3),(1330,1520758827,4),(1330,1541318427,3),(1330,1552208427,4),(1330,1572768027,3),(1330,1583658027,4),(1330,1604217627,3),(1330,1615712427,4),(1330,1636272027,3),(1330,1647162027,4),(1330,1667721627,3),(1330,1678611627,4),(1330,1699171227,3),(1330,1710061227,4),(1330,1730620827,3),(1330,1741510827,4),(1330,1762070427,3),(1330,1772960427,4),(1330,1793520027,3),(1330,1805014827,4),(1330,1825574427,3),(1330,1836464427,4),(1330,1857024027,3),(1330,1867914027,4),(1330,1888473627,3),(1330,1899363627,4),(1330,1919923227,3),(1330,1930813227,4),(1330,1951372827,3),(1330,1962867627,4),(1330,1983427227,3),(1330,1994317227,4),(1330,2014876827,3),(1330,2025766827,4),(1330,2046326427,3),(1330,2057216427,4),(1330,2077776027,3),(1330,2088666027,4),(1330,2109225627,3),(1330,2120115627,4),(1330,2140675227,3),(1331,-2147483648,0),(1331,-865296000,4),(1331,-769395600,1),(1331,-765396000,2),(1331,73465200,3),(1331,89186401,2),(1331,104914802,3),(1331,120636002,2),(1331,136364403,3),(1331,152085603,2),(1331,167814004,3),(1331,183535204,2),(1331,199263605,3),(1331,215589605,2),(1331,230713206,3),(1331,247039206,2),(1331,262767607,3),(1331,278488807,2),(1331,294217208,3),(1331,309938408,2),(1331,325666809,3),(1331,341388009,2),(1331,357116409,3),(1331,372837610,2),(1331,388566010,3),(1331,404892011,2),(1331,420015611,3),(1331,436341612,2),(1331,452070012,3),(1331,467791212,2),(1331,483519612,3),(1331,499240813,2),(1331,514969213,3),(1331,530690413,2),(1331,544604413,3),(1331,562140013,2),(1331,576054014,3),(1331,594194414,2),(1331,607503614,3),(1331,625644014,2),(1331,638953215,3),(1331,657093615,2),(1331,671007616,3),(1331,688543216,2),(1331,702457216,3),(1331,719992817,2),(1331,733906817,3),(1331,752047218,2),(1331,765356418,3),(1331,783496819,2),(1331,796806019,3),(1331,814946419,2),(1331,828860420,3),(1331,846396020,2),(1331,860310020,3),(1331,877845621,2),(1331,891759621,3),(1331,909295221,2),(1331,923209222,3),(1331,941349622,5),(1331,954662422,6),(1331,972802822,2),(1331,986108422,3),(1331,1004248822,2),(1331,1018162822,3),(1331,1035698422,2),(1331,1049612422,3),(1331,1067148022,2),(1331,1081062022,3),(1331,1099202422,2),(1331,1112511622,3),(1331,1130652022,2),(1331,1143961223,3),(1331,1162101623,2),(1331,1173596423,3),(1331,1194156023,2),(1331,1205046023,3),(1331,1225605623,2),(1331,1236495624,3),(1331,1257055224,2),(1331,1268550024,3),(1331,1289109624,2),(1331,1299999624,3),(1331,1320559224,2),(1331,1331449224,3),(1331,1352008825,2),(1331,1362898825,3),(1331,1383458425,2),(1331,1394348425,3),(1331,1414908025,2),(1331,1425798025,3),(1331,1446357626,2),(1331,1457852426,3),(1331,1478412026,2),(1331,1489302027,3),(1331,1509861627,2),(1331,1520751627,3),(1331,1541311227,2),(1331,1552201227,3),(1331,1572760827,2),(1331,1583650827,3),(1331,1604210427,2),(1331,1615705227,3),(1331,1636264827,2),(1331,1647154827,3),(1331,1667714427,2),(1331,1678604427,3),(1331,1699164027,2),(1331,1710054027,3),(1331,1730613627,2),(1331,1741503627,3),(1331,1762063227,2),(1331,1772953227,3),(1331,1793512827,2),(1331,1805007627,3),(1331,1825567227,2),(1331,1836457227,3),(1331,1857016827,2),(1331,1867906827,3),(1331,1888466427,2),(1331,1899356427,3),(1331,1919916027,2),(1331,1930806027,3),(1331,1951365627,2),(1331,1962860427,3),(1331,1983420027,2),(1331,1994310027,3),(1331,2014869627,2),(1331,2025759627,3),(1331,2046319227,2),(1331,2057209227,3),(1331,2077768827,2),(1331,2088658827,3),(1331,2109218427,2),(1331,2120108427,3),(1331,2140668027,2),(1332,-2147483648,1),(1332,-1827687170,2),(1332,126687603,3),(1332,152085603,2),(1332,162370804,3),(1332,183535204,2),(1332,199263605,3),(1332,215589605,2),(1332,230713206,3),(1332,247039206,2),(1332,262767607,3),(1332,278488807,2),(1332,294217208,3),(1332,309938408,2),(1332,325666809,3),(1332,341388009,2),(1332,357116409,3),(1332,372837610,2),(1332,388566010,3),(1332,404892011,2),(1332,420015611,3),(1332,436341612,2),(1333,-2147483648,1),(1333,-1567453392,2),(1333,-1233432000,3),(1333,-1222981200,2),(1333,-1205956800,3),(1333,-1194037200,2),(1333,-1172865600,3),(1333,-1162501200,2),(1333,-1141329600,3),(1333,-1130965200,2),(1333,-1109793600,3),(1333,-1099429200,2),(1333,-1078257600,3),(1333,-1067806800,2),(1333,-1046635200,3),(1333,-1036270800,2),(1333,-1015099200,3),(1333,-1004734800,2),(1333,-983563200,3),(1333,-973198800,2),(1333,-952027200,3),(1333,-941576400,2),(1333,-931032000,3),(1333,-900882000,2),(1333,-890337600,3),(1333,-833749200,2),(1333,-827265600,3),(1333,-752274000,2),(1333,-733780800,3),(1333,-197326800,2),(1333,-190843200,3),(1333,-184194000,2),(1333,-164491200,3),(1333,-152658000,2),(1333,-132955200,3),(1333,-121122000,2),(1333,-101419200,3),(1333,-86821200,2),(1333,-71092800,3),(1333,-54766800,2),(1333,-39038400,3),(1333,-23317200,2),(1333,-7588800,5),(1333,128142003,4),(1333,136605603,5),(1333,596948414,4),(1333,605066414,5),(1333,624423614,4),(1333,636516015,2),(1333,657086415,3),(1333,669178816,2),(1333,686721616,4),(1333,699415216,5),(1333,719377217,4),(1333,731469617,5),(1333,938919622,3),(1333,952052422,5),(1333,1198983623,4),(1333,1205632823,5),(1334,-2147483648,1),(1334,-880207200,2),(1334,-769395600,3),(1334,-765385200,1),(1334,-21477600,4),(1334,-5756400,1),(1334,9972000,4),(1334,25693200,1),(1334,41421600,4),(1334,57747600,1),(1334,73476000,4),(1334,89197201,1),(1334,104925602,4),(1334,120646802,1),(1334,126698403,4),(1334,152096403,1),(1334,162381604,4),(1334,183546004,1),(1334,199274405,4),(1334,215600405,1),(1334,230724006,4),(1334,247050006,1),(1334,262778407,4),(1334,278499607,1),(1334,294228008,4),(1334,309949208,1),(1334,325677609,5),(1334,341402409,1),(1334,357127209,4),(1334,372848410,1),(1334,388576810,4),(1334,404902811,1),(1334,420026411,4),(1334,436352412,6),(1334,439030812,8),(1334,452084412,7),(1334,467805612,8),(1334,483534012,7),(1334,499255213,8),(1334,514983613,7),(1334,530704813,8),(1334,544618813,7),(1334,562154413,8),(1334,576068414,7),(1334,594208814,8),(1334,607518014,7),(1334,625658414,8),(1334,638967615,7),(1334,657108015,8),(1334,671022016,7),(1334,688557616,8),(1334,702471616,7),(1334,720007217,8),(1334,733921217,7),(1334,752061618,8),(1334,765370818,7),(1334,783511219,8),(1334,796820419,7),(1334,814960819,8),(1334,828874820,7),(1334,846410420,8),(1334,860324420,7),(1334,877860021,8),(1334,891774021,7),(1334,909309621,8),(1334,923223622,7),(1334,941364022,8),(1334,954673222,7),(1334,972813622,8),(1334,986122822,7),(1334,1004263222,8),(1334,1018177222,7),(1334,1035712822,8),(1334,1049626822,7),(1334,1067162422,8),(1334,1081076422,7),(1334,1099216822,8),(1334,1112526022,7),(1334,1130666422,8),(1334,1143975623,7),(1334,1162116023,8),(1334,1173610823,7),(1334,1194170423,8),(1334,1205060423,7),(1334,1225620023,8),(1334,1236510024,7),(1334,1257069624,8),(1334,1268564424,7),(1334,1289124024,8),(1334,1300014024,7),(1334,1320573624,8),(1334,1331463624,7),(1334,1352023225,8),(1334,1362913225,7),(1334,1383472825,8),(1334,1394362825,7),(1334,1414922425,8),(1334,1425812425,7),(1334,1446372026,8),(1334,1457866826,7),(1334,1478426426,8),(1334,1489316427,7),(1334,1509876027,8),(1334,1520766027,7),(1334,1541325627,8),(1334,1552215627,7),(1334,1572775227,8),(1334,1583665227,7),(1334,1604224827,8),(1334,1615719627,7),(1334,1636279227,8),(1334,1647169227,7),(1334,1667728827,8),(1334,1678618827,7),(1334,1699178427,8),(1334,1710068427,7),(1334,1730628027,8),(1334,1741518027,7),(1334,1762077627,8),(1334,1772967627,7),(1334,1793527227,8),(1334,1805022027,7),(1334,1825581627,8),(1334,1836471627,7),(1334,1857031227,8),(1334,1867921227,7),(1334,1888480827,8),(1334,1899370827,7),(1334,1919930427,8),(1334,1930820427,7),(1334,1951380027,8),(1334,1962874827,7),(1334,1983434427,8),(1334,1994324427,7),(1334,2014884027,8),(1334,2025774027,7),(1334,2046333627,8),(1334,2057223627,7),(1334,2077783227,8),(1334,2088673227,7),(1334,2109232827,8),(1334,2120122827,7),(1334,2140682427,8),(1335,-2147483648,3),(1335,-1633276800,1),(1335,-1615136400,2),(1335,-1601827200,1),(1335,-1583686800,2),(1335,-1535904000,1),(1335,-1525280400,2),(1335,-905097600,1),(1335,-891795600,2),(1335,-880214400,4),(1335,-769395600,5),(1335,-765392400,2),(1335,-747251940,1),(1335,-744224400,2),(1335,-620841600,1),(1335,-608144400,2),(1335,-589392000,1),(1335,-576090000,2),(1335,-557942400,1),(1335,-544640400,2),(1335,-526492800,1),(1335,-513190800,2),(1335,-495043200,1),(1335,-481741200,2),(1335,-463593600,1),(1335,-450291600,2),(1335,-431539200,1),(1335,-415818000,2),(1335,-400089600,1),(1335,-384368400,2),(1335,-368640000,1),(1335,-352918800,2),(1335,-337190400,1),(1335,-321469200,2),(1335,-305740800,1),(1335,-289414800,2),(1335,-273686400,1),(1335,-266432400,6),(1335,-52938000,7),(1335,-37216800,6),(1335,-21488400,7),(1335,-5767200,6),(1335,9961200,7),(1335,25682400,6),(1335,41410800,7),(1335,57736800,6),(1335,73465200,7),(1335,89186401,6),(1335,104914802,7),(1335,120636002,6),(1335,126687603,1),(1335,152089203,6),(1335,162370804,7),(1335,183535204,6),(1335,199263605,7),(1335,215589605,6),(1335,230713206,7),(1335,247039206,6),(1335,262767607,7),(1335,278488807,6),(1335,294217208,7),(1335,309938408,6),(1335,325666809,7),(1335,341388009,6),(1335,357116409,7),(1335,372837610,6),(1335,388566010,7),(1335,404892011,6),(1335,420015611,7),(1335,436341612,6),(1335,452070012,7),(1335,467791212,6),(1335,483519612,7),(1335,499240813,6),(1335,514969213,7),(1335,530690413,6),(1335,544604413,7),(1335,562140013,6),(1335,576054014,7),(1335,594194414,6),(1335,607503614,7),(1335,625644014,6),(1335,638953215,7),(1335,657093615,6),(1335,671007616,7),(1335,688543216,6),(1335,702457216,7),(1335,719992817,6),(1335,733906817,7),(1335,752047218,6),(1335,765356418,7),(1335,783496819,6),(1335,796806019,7),(1335,814946419,6),(1335,828860420,7),(1335,846396020,6),(1335,860310020,7),(1335,877845621,6),(1335,891759621,7),(1335,909295221,6),(1335,923209222,7),(1335,941349622,6),(1335,954658822,7),(1335,972799222,6),(1335,986108422,7),(1335,1004248822,6),(1335,1018162822,7),(1335,1035698422,6),(1335,1049612422,7),(1335,1067148022,6),(1335,1081062022,7),(1335,1099202422,6),(1335,1112511622,7),(1335,1130652022,6),(1335,1143961223,7),(1335,1162101623,6),(1335,1173596423,7),(1335,1194156023,6),(1335,1205046023,7),(1335,1225605623,6),(1335,1236495624,7),(1335,1257055224,6),(1335,1268550024,7),(1335,1289109624,6),(1335,1299999624,7),(1335,1320559224,6),(1335,1331449224,7),(1335,1352008825,6),(1335,1362898825,7),(1335,1383458425,6),(1335,1394348425,7),(1335,1414908025,6),(1335,1425798025,7),(1335,1446357626,6),(1335,1457852426,7),(1335,1478412026,6),(1335,1489302027,7),(1335,1509861627,6),(1335,1520751627,7),(1335,1541311227,6),(1335,1552201227,7),(1335,1572760827,6),(1335,1583650827,7),(1335,1604210427,6),(1335,1615705227,7),(1335,1636264827,6),(1335,1647154827,7),(1335,1667714427,6),(1335,1678604427,7),(1335,1699164027,6),(1335,1710054027,7),(1335,1730613627,6),(1335,1741503627,7),(1335,1762063227,6),(1335,1772953227,7),(1335,1793512827,6),(1335,1805007627,7),(1335,1825567227,6),(1335,1836457227,7),(1335,1857016827,6),(1335,1867906827,7),(1335,1888466427,6),(1335,1899356427,7),(1335,1919916027,6),(1335,1930806027,7),(1335,1951365627,6),(1335,1962860427,7),(1335,1983420027,6),(1335,1994310027,7),(1335,2014869627,6),(1335,2025759627,7),(1335,2046319227,6),(1335,2057209227,7),(1335,2077768827,6),(1335,2088658827,7),(1335,2109218427,6),(1335,2120108427,7),(1335,2140668027,6),(1336,-2147483648,5),(1336,-1633276800,1),(1336,-1615136400,2),(1336,-1601827200,1),(1336,-1583686800,2),(1336,-880214400,3),(1336,-769395600,4),(1336,-765392400,2),(1336,-52934400,1),(1336,-37213200,2),(1336,-21484800,1),(1336,-5763600,2),(1336,9964800,1),(1336,25686000,2),(1336,41414400,1),(1336,57740400,2),(1336,73468800,1),(1336,89190001,2),(1336,104918402,1),(1336,120639602,2),(1336,126691203,1),(1336,152089203,2),(1336,162374404,1),(1336,183538804,2),(1336,199267205,1),(1336,215593205,2),(1336,230716806,1),(1336,247042806,2),(1336,262771207,1),(1336,278492407,2),(1336,294220808,1),(1336,309942008,2),(1336,325670409,1),(1336,341391609,2),(1336,357120009,1),(1336,372841210,2),(1336,388569610,1),(1336,404895611,2),(1336,420019211,1),(1336,436345212,2),(1336,452073612,1),(1336,467794812,2),(1336,483523212,1),(1336,499244413,2),(1336,514972813,1),(1336,530694013,2),(1336,544608013,1),(1336,562143613,2),(1336,576057614,1),(1336,594198014,2),(1336,607507214,1),(1336,625647614,2),(1336,638956815,1),(1336,657097215,2),(1336,671011216,1),(1336,688546816,2),(1336,702460816,1),(1336,719996417,2),(1336,733910417,1),(1336,752050818,2),(1336,765360018,1),(1336,783500419,2),(1336,796809619,1),(1336,814950019,2),(1336,828864020,1),(1336,846399620,2),(1336,860313620,1),(1336,877849221,2),(1336,891763221,1),(1336,909298821,2),(1336,923212822,1),(1336,941353222,2),(1336,954662422,1),(1336,972802822,7),(1336,986108422,6),(1336,1004248822,7),(1336,1018162822,6),(1336,1035698422,7),(1336,1049612422,6),(1336,1067148022,7),(1336,1081062022,6),(1336,1099202422,7),(1336,1112511622,6),(1336,1130652022,7),(1336,1143961223,6),(1336,1162101623,7),(1336,1173596423,6),(1336,1194156023,7),(1336,1205046023,6),(1336,1225605623,7),(1336,1236495624,6),(1336,1257055224,7),(1336,1268550024,6),(1336,1289109624,7),(1336,1299999624,6),(1336,1320559224,7),(1336,1331449224,6),(1336,1352008825,7),(1336,1362898825,6),(1336,1383458425,7),(1336,1394348425,6),(1336,1414908025,7),(1336,1425798025,6),(1336,1446357626,7),(1336,1457852426,6),(1336,1478412026,7),(1336,1489302027,6),(1336,1509861627,7),(1336,1520751627,6),(1336,1541311227,7),(1336,1552201227,6),(1336,1572760827,7),(1336,1583650827,6),(1336,1604210427,7),(1336,1615705227,6),(1336,1636264827,7),(1336,1647154827,6),(1336,1667714427,7),(1336,1678604427,6),(1336,1699164027,7),(1336,1710054027,6),(1336,1730613627,7),(1336,1741503627,6),(1336,1762063227,7),(1336,1772953227,6),(1336,1793512827,7),(1336,1805007627,6),(1336,1825567227,7),(1336,1836457227,6),(1336,1857016827,7),(1336,1867906827,6),(1336,1888466427,7),(1336,1899356427,6),(1336,1919916027,7),(1336,1930806027,6),(1336,1951365627,7),(1336,1962860427,6),(1336,1983420027,7),(1336,1994310027,6),(1336,2014869627,7),(1336,2025759627,6),(1336,2046319227,7),(1336,2057209227,6),(1336,2077768827,7),(1336,2088658827,6),(1336,2109218427,7),(1336,2120108427,6),(1336,2140668027,7),(1337,-2147483648,5),(1337,-1633276800,1),(1337,-1615136400,2),(1337,-1601827200,1),(1337,-1583686800,2),(1337,-880214400,3),(1337,-769395600,4),(1337,-765392400,2),(1337,-715795200,1),(1337,-702493200,2),(1337,-684345600,1),(1337,-671043600,2),(1337,-652896000,1),(1337,-639594000,2),(1337,-620841600,1),(1337,-608144400,2),(1337,-589392000,1),(1337,-576090000,2),(1337,-557942400,1),(1337,-544640400,2),(1337,-526492800,1),(1337,-513190800,2),(1337,-495043200,1),(1337,-481741200,2),(1337,-463593600,1),(1337,-447267600,2),(1337,-431539200,1),(1337,-415818000,2),(1337,-400089600,1),(1337,-386787600,2),(1337,-368640000,1),(1337,-355338000,2),(1337,-337190400,1),(1337,-321469200,2),(1337,-305740800,1),(1337,-289414800,2),(1337,-273686400,1),(1337,-257965200,2),(1337,-242236800,6),(1337,-195066000,2),(1337,-84384000,1),(1337,-68662800,2),(1337,-52934400,1),(1337,-37213200,2),(1337,-21484800,1),(1337,-5763600,2),(1337,9964800,1),(1337,25686000,2),(1337,41414400,1),(1337,57740400,2),(1337,73468800,1),(1337,89190001,2),(1337,104918402,1),(1337,120639602,2),(1337,126691203,1),(1337,152089203,2),(1337,162374404,1),(1337,183538804,2),(1337,199267205,1),(1337,215593205,2),(1337,230716806,1),(1337,247042806,2),(1337,262771207,1),(1337,278492407,2),(1337,294220808,1),(1337,309942008,2),(1337,325670409,1),(1337,341391609,2),(1337,357120009,1),(1337,372841210,2),(1337,388569610,1),(1337,404895611,2),(1337,420019211,1),(1337,436345212,2),(1337,452073612,1),(1337,467794812,2),(1337,483523212,1),(1337,499244413,2),(1337,514972813,1),(1337,530694013,2),(1337,544608013,1),(1337,562143613,2),(1337,576057614,1),(1337,594198014,2),(1337,607507214,1),(1337,625647614,2),(1337,638956815,1),(1337,657097215,2),(1337,671011216,1),(1337,688546816,6),(1337,1143961223,1),(1337,1162105223,2),(1337,1173600023,1),(1337,1194159623,2),(1337,1205049623,1),(1337,1225609223,2),(1337,1236499224,1),(1337,1257058824,2),(1337,1268553624,1),(1337,1289113224,2),(1337,1300003224,1),(1337,1320562824,2),(1337,1331452824,1),(1337,1352012425,2),(1337,1362902425,1),(1337,1383462025,2),(1337,1394352025,1),(1337,1414911625,2),(1337,1425801625,1),(1337,1446361226,2),(1337,1457856026,1),(1337,1478415626,2),(1337,1489305627,1),(1337,1509865227,2),(1337,1520755227,1),(1337,1541314827,2),(1337,1552204827,1),(1337,1572764427,2),(1337,1583654427,1),(1337,1604214027,2),(1337,1615708827,1),(1337,1636268427,2),(1337,1647158427,1),(1337,1667718027,2),(1337,1678608027,1),(1337,1699167627,2),(1337,1710057627,1),(1337,1730617227,2),(1337,1741507227,1),(1337,1762066827,2),(1337,1772956827,1),(1337,1793516427,2),(1337,1805011227,1),(1337,1825570827,2),(1337,1836460827,1),(1337,1857020427,2),(1337,1867910427,1),(1337,1888470027,2),(1337,1899360027,1),(1337,1919919627,2),(1337,1930809627,1),(1337,1951369227,2),(1337,1962864027,1),(1337,1983423627,2),(1337,1994313627,1),(1337,2014873227,2),(1337,2025763227,1),(1337,2046322827,2),(1337,2057212827,1),(1337,2077772427,2),(1337,2088662427,1),(1337,2109222027,2),(1337,2120112027,1),(1337,2140671627,2),(1338,-2147483648,1),(1338,-873057600,3),(1338,-769395600,2),(1338,-765399600,1),(1339,-2147483648,1),(1339,-1205954844,2),(1339,-1192307244,3),(1340,-2147483648,1),(1340,-1938538284,3),(1340,-1009825200,2),(1340,-1002052800,3),(1340,-986756400,2),(1340,-971035200,3),(1340,-955306800,2),(1340,-939585600,3),(1340,504939613,2),(1340,512712013,3),(1340,536475613,2),(1340,544248013,3),(1340,631170015,2),(1340,638942415,3),(1340,757400418,2),(1340,765172818,3),(1341,-2147483648,5),(1341,-1633269600,1),(1341,-1615129200,2),(1341,-1601820000,1),(1341,-1583679600,2),(1341,-880207200,3),(1341,-769395600,4),(1341,-765385200,2),(1341,-687967140,1),(1341,-662655600,2),(1341,-620838000,1),(1341,-608137200,2),(1341,-589388400,1),(1341,-576082800,2),(1341,-557938800,1),(1341,-544633200,2),(1341,-526489200,1),(1341,-513183600,2),(1341,-495039600,1),(1341,-481734000,2),(1341,-463590000,1),(1341,-450284400,2),(1341,-431535600,1),(1341,-418230000,2),(1341,-400086000,1),(1341,-386780400,2),(1341,-368636400,1),(1341,-355330800,2),(1341,-337186800,1),(1341,-323881200,2),(1341,-305737200,1),(1341,-292431600,2),(1341,-273682800,1),(1341,-260982000,2),(1341,-242233200,1),(1341,-226508400,2),(1341,-210783600,1),(1341,-195058800,2),(1341,-179334000,1),(1341,-163609200,2),(1341,-147884400,1),(1341,-131554800,2),(1341,-116434800,1),(1341,-100105200,2),(1341,-84376800,1),(1341,-68655600,2),(1341,-52927200,1),(1341,-37206000,2),(1341,-21477600,1),(1341,-5756400,2),(1341,9972000,1),(1341,25693200,2),(1341,41421600,1),(1341,57747600,2),(1341,73476000,1),(1341,89197201,2),(1341,104925602,1),(1341,120646802,2),(1341,126698403,1),(1341,152096403,2),(1341,162381604,1),(1341,183546004,2),(1341,199274405,1),(1341,215600405,2),(1341,230724006,1),(1341,247050006,2),(1341,262778407,1),(1341,278499607,2),(1341,294228008,1),(1341,309949208,2),(1341,325677609,1),(1341,341398809,2),(1341,357127209,1),(1341,372848410,2),(1341,388576810,1),(1341,404902811,2),(1341,420026411,1),(1341,436352412,2),(1341,452080812,1),(1341,467802012,2),(1341,483530412,1),(1341,499251613,2),(1341,514980013,1),(1341,530701213,2),(1341,544615213,1),(1341,562150813,2),(1341,576064814,1),(1341,594205214,2),(1341,607514414,1),(1341,625654814,2),(1341,638964015,1),(1341,657104415,2),(1341,671018416,1),(1341,688554016,2),(1341,702468016,1),(1341,720003617,2),(1341,733917617,1),(1341,752058018,2),(1341,765367218,1),(1341,783507619,2),(1341,796816819,1),(1341,814957219,2),(1341,828871220,1),(1341,846406820,2),(1341,860320820,1),(1341,877856421,2),(1341,891770421,1),(1341,909306021,2),(1341,923220022,1),(1341,941360422,2),(1341,954669622,1),(1341,972810022,2),(1341,986119222,1),(1341,1004259622,2),(1341,1018173622,1),(1341,1035709222,2),(1341,1049623222,1),(1341,1067158822,2),(1341,1081072822,1),(1341,1099213222,2),(1341,1112522422,1),(1341,1130662822,2),(1341,1143972023,1),(1341,1162112423,2),(1341,1173607223,1),(1341,1194166823,2),(1341,1205056823,1),(1341,1225616423,2),(1341,1236506424,1),(1341,1257066024,2),(1341,1268560824,1),(1341,1289120424,2),(1341,1300010424,1),(1341,1320570024,2),(1341,1331460024,1),(1341,1352019625,2),(1341,1362909625,1),(1341,1383469225,2),(1341,1394359225,1),(1341,1414918825,2),(1341,1425808825,1),(1341,1446368426,2),(1341,1457863226,1),(1341,1478422826,2),(1341,1489312827,1),(1341,1509872427,2),(1341,1520762427,1),(1341,1541322027,2),(1341,1552212027,1),(1341,1572771627,2),(1341,1583661627,1),(1341,1604221227,2),(1341,1615716027,1),(1341,1636275627,2),(1341,1647165627,1),(1341,1667725227,2),(1341,1678615227,1),(1341,1699174827,2),(1341,1710064827,1),(1341,1730624427,2),(1341,1741514427,1),(1341,1762074027,2),(1341,1772964027,1),(1341,1793523627,2),(1341,1805018427,1),(1341,1825578027,2),(1341,1836468027,1),(1341,1857027627,2),(1341,1867917627,1),(1341,1888477227,2),(1341,1899367227,1),(1341,1919926827,2),(1341,1930816827,1),(1341,1951376427,2),(1341,1962871227,1),(1341,1983430827,2),(1341,1994320827,1),(1341,2014880427,2),(1341,2025770427,1),(1341,2046330027,2),(1341,2057220027,1),(1341,2077779627,2),(1341,2088669627,1),(1341,2109229227,2),(1341,2120119227,1),(1341,2140678827,2),(1342,-2147483648,3),(1342,-1633276800,1),(1342,-1615136400,2),(1342,-1601827200,1),(1342,-1583686800,2),(1342,-1535904000,1),(1342,-1525280400,2),(1342,-905097600,1),(1342,-891795600,2),(1342,-880214400,4),(1342,-769395600,5),(1342,-765392400,2),(1342,-747251940,1),(1342,-744224400,2),(1342,-620841600,1),(1342,-608144400,2),(1342,-589392000,1),(1342,-576090000,2),(1342,-557942400,1),(1342,-544640400,2),(1342,-526492800,1),(1342,-513190800,2),(1342,-495043200,1),(1342,-481741200,2),(1342,-463593600,1),(1342,-450291600,2),(1342,-431539200,1),(1342,-415818000,2),(1342,-400089600,1),(1342,-384368400,2),(1342,-368640000,1),(1342,-352918800,2),(1342,-337190400,1),(1342,-321469200,2),(1342,-305740800,1),(1342,-289414800,2),(1342,-273686400,1),(1342,-266432400,6),(1342,-52938000,7),(1342,-37216800,6),(1342,-21488400,7),(1342,-5767200,6),(1342,9961200,7),(1342,25682400,6),(1342,41410800,7),(1342,57736800,6),(1342,73465200,7),(1342,89186401,6),(1342,104914802,7),(1342,120636002,6),(1342,126687603,1),(1342,152089203,6),(1342,162370804,7),(1342,183535204,6),(1342,199263605,7),(1342,215589605,6),(1342,230713206,7),(1342,247039206,6),(1342,262767607,7),(1342,278488807,6),(1342,294217208,7),(1342,309938408,6),(1342,325666809,7),(1342,341388009,6),(1342,357116409,7),(1342,372837610,6),(1342,388566010,7),(1342,404892011,6),(1342,420015611,7),(1342,436341612,6),(1342,452070012,7),(1342,467791212,6),(1342,483519612,7),(1342,499240813,6),(1342,514969213,7),(1342,530690413,6),(1342,544604413,7),(1342,562140013,6),(1342,576054014,7),(1342,594194414,6),(1342,607503614,7),(1342,625644014,6),(1342,638953215,7),(1342,657093615,6),(1342,671007616,7),(1342,688543216,6),(1342,702457216,7),(1342,719992817,6),(1342,733906817,7),(1342,752047218,6),(1342,765356418,7),(1342,783496819,6),(1342,796806019,7),(1342,814946419,6),(1342,828860420,7),(1342,846396020,6),(1342,860310020,7),(1342,877845621,6),(1342,891759621,7),(1342,909295221,6),(1342,923209222,7),(1342,941349622,6),(1342,954658822,7),(1342,972799222,6),(1342,986108422,7),(1342,1004248822,6),(1342,1018162822,7),(1342,1035698422,6),(1342,1049612422,7),(1342,1067148022,6),(1342,1081062022,7),(1342,1099202422,6),(1342,1112511622,7),(1342,1130652022,6),(1342,1143961223,7),(1342,1162101623,6),(1342,1173596423,7),(1342,1194156023,6),(1342,1205046023,7),(1342,1225605623,6),(1342,1236495624,7),(1342,1257055224,6),(1342,1268550024,7),(1342,1289109624,6),(1342,1299999624,7),(1342,1320559224,6),(1342,1331449224,7),(1342,1352008825,6),(1342,1362898825,7),(1342,1383458425,6),(1342,1394348425,7),(1342,1414908025,6),(1342,1425798025,7),(1342,1446357626,6),(1342,1457852426,7),(1342,1478412026,6),(1342,1489302027,7),(1342,1509861627,6),(1342,1520751627,7),(1342,1541311227,6),(1342,1552201227,7),(1342,1572760827,6),(1342,1583650827,7),(1342,1604210427,6),(1342,1615705227,7),(1342,1636264827,6),(1342,1647154827,7),(1342,1667714427,6),(1342,1678604427,7),(1342,1699164027,6),(1342,1710054027,7),(1342,1730613627,6),(1342,1741503627,7),(1342,1762063227,6),(1342,1772953227,7),(1342,1793512827,6),(1342,1805007627,7),(1342,1825567227,6),(1342,1836457227,7),(1342,1857016827,6),(1342,1867906827,7),(1342,1888466427,6),(1342,1899356427,7),(1342,1919916027,6),(1342,1930806027,7),(1342,1951365627,6),(1342,1962860427,7),(1342,1983420027,6),(1342,1994310027,7),(1342,2014869627,6),(1342,2025759627,7),(1342,2046319227,6),(1342,2057209227,7),(1342,2077768827,6),(1342,2088658827,7),(1342,2109218427,6),(1342,2120108427,7),(1342,2140668027,6),(1343,-2147483648,1),(1343,-873057600,3),(1343,-769395600,2),(1343,-765399600,1),(1344,-2147483648,0),(1344,-1767217028,2),(1344,-1206957600,1),(1344,-1191362400,2),(1344,-1175374800,1),(1344,-1159826400,2),(1344,-633819600,1),(1344,-622069200,2),(1344,-602283600,1),(1344,-591832800,2),(1344,-570747600,1),(1344,-560210400,2),(1344,-539125200,1),(1344,-531352800,2),(1344,-191365200,1),(1344,-184197600,2),(1344,-155163600,1),(1344,-150069600,2),(1344,-128898000,1),(1344,-121125600,2),(1344,-99954000,1),(1344,-89589600,2),(1344,-68418000,1),(1344,-57967200,2),(1344,499748413,1),(1344,511236013,2),(1344,530593213,1),(1344,540266413,2),(1344,562129213,1),(1344,571197614,2),(1344,592974014,1),(1344,602042414,2),(1344,624423614,1),(1344,634701615,2),(1344,813726019,1),(1344,824004020,2),(1344,938919622,1),(1344,951616822,2),(1344,970974022,1),(1344,972180022,2),(1344,1003028422,1),(1344,1013911222,2),(1345,-2147483648,1),(1345,-1121105688,2),(1345,105084002,3),(1345,161758804,2),(1345,290584808,4),(1345,299134808,2),(1345,322034409,4),(1345,330584409,2),(1345,694260016,3),(1345,717310817,2),(1345,725868017,3),(1345,852094820,2),(1345,1113112822,4),(1345,1128229222,2),(1345,1146384023,4),(1345,1159682423,2),(1346,-2147483648,0),(1346,-1767211196,2),(1346,-1206954000,1),(1346,-1191358800,2),(1346,-1175371200,1),(1346,-1159822800,2),(1346,-633816000,1),(1346,-622065600,2),(1346,-602280000,1),(1346,-591829200,2),(1346,-570744000,1),(1346,-560206800,2),(1346,-539121600,1),(1346,-531349200,2),(1346,-191361600,1),(1346,-184194000,2),(1346,-155160000,1),(1346,-150066000,2),(1346,-128894400,1),(1346,-121122000,2),(1346,-99950400,1),(1346,-89586000,2),(1346,-68414400,1),(1346,-57963600,2),(1346,499752013,1),(1346,511239613,2),(1346,530596813,1),(1346,540270013,2),(1346,562132813,1),(1346,571201214,2),(1346,750830418,1),(1346,761713218,2),(1347,-2147483648,1),(1347,-873057600,3),(1347,-769395600,2),(1347,-765399600,1),(1348,-2147483648,1),(1348,-1851537340,2),(1348,323841609,3),(1348,338958009,2),(1349,-2147483648,0),(1349,-1514743200,1),(1349,568015214,3),(1349,576057614,2),(1349,594198014,3),(1349,828864020,2),(1349,846399620,3),(1349,860313620,2),(1349,877849221,3),(1349,891763221,2),(1349,909298821,3),(1349,923212822,2),(1349,941353222,3),(1349,954662422,2),(1349,972802822,3),(1349,989136022,2),(1349,1001833222,3),(1349,1018166422,2),(1349,1035702022,3),(1349,1049616022,2),(1349,1067151622,3),(1349,1081065622,2),(1349,1099206022,3),(1349,1112515222,2),(1349,1130655622,3),(1349,1143964823,2),(1349,1162105223,3),(1349,1175414423,2),(1349,1193554823,3),(1349,1207468823,2),(1349,1225004423,3),(1349,1238918424,2),(1349,1256454024,3),(1349,1268553624,2),(1349,1289113224,3),(1349,1300003224,2),(1349,1320562824,3),(1349,1331452824,2),(1349,1352012425,3),(1349,1362902425,2),(1349,1383462025,3),(1349,1394352025,2),(1349,1414911625,3),(1349,1425801625,2),(1349,1446361226,3),(1349,1457856026,2),(1349,1478415626,3),(1349,1489305627,2),(1349,1509865227,3),(1349,1520755227,2),(1349,1541314827,3),(1349,1552204827,2),(1349,1572764427,3),(1349,1583654427,2),(1349,1604214027,3),(1349,1615708827,2),(1349,1636268427,3),(1349,1647158427,2),(1349,1667718027,3),(1349,1678608027,2),(1349,1699167627,3),(1349,1710057627,2),(1349,1730617227,3),(1349,1741507227,2),(1349,1762066827,3),(1349,1772956827,2),(1349,1793516427,3),(1349,1805011227,2),(1349,1825570827,3),(1349,1836460827,2),(1349,1857020427,3),(1349,1867910427,2),(1349,1888470027,3),(1349,1899360027,2),(1349,1919919627,3),(1349,1930809627,2),(1349,1951369227,3),(1349,1962864027,2),(1349,1983423627,3),(1349,1994313627,2),(1349,2014873227,3),(1349,2025763227,2),(1349,2046322827,3),(1349,2057212827,2),(1349,2077772427,3),(1349,2088662427,2),(1349,2109222027,3),(1349,2120112027,2),(1349,2140671627,3),(1350,-2147483648,0),(1350,-1514739600,1),(1350,-1343066400,2),(1350,-1234807200,4),(1350,-1220292000,3),(1350,-1207159200,4),(1350,-1191344400,2),(1350,-873828000,4),(1350,-661539600,5),(1350,28800,4),(1350,828867620,3),(1350,846403220,4),(1350,860317220,3),(1350,877852821,4),(1350,891766821,3),(1350,909302421,4),(1350,923216422,3),(1350,941356822,4),(1350,954666022,3),(1350,972806422,4),(1350,989139622,3),(1350,1001836822,4),(1350,1018170022,3),(1350,1035705622,4),(1350,1049619622,3),(1350,1067155222,4),(1350,1081069222,3),(1350,1099209622,4),(1350,1112518822,3),(1350,1130659222,4),(1350,1143968423,3),(1350,1162108823,4),(1350,1175418023,3),(1350,1193558423,4),(1350,1207472423,3),(1350,1225008023,4),(1350,1238922024,3),(1350,1256457624,4),(1350,1270371624,3),(1350,1288512024,4),(1350,1301821224,3),(1350,1319961624,4),(1350,1333270824,3),(1350,1351411225,4),(1350,1365325225,3),(1350,1382860825,4),(1350,1396774825,3),(1350,1414310425,4),(1350,1428224425,3),(1350,1445760026,4),(1350,1459674026,3),(1350,1477814426,4),(1350,1491123627,3),(1350,1509264027,4),(1350,1522573227,3),(1350,1540713627,4),(1350,1554627627,3),(1350,1572163227,4),(1350,1586077227,3),(1350,1603612827,4),(1350,1617526827,3),(1350,1635667227,4),(1350,1648976427,3),(1350,1667116827,4),(1351,-2147483648,1),(1351,-1567453392,2),(1351,-1233432000,3),(1351,-1222981200,2),(1351,-1205956800,3),(1351,-1194037200,2),(1351,-1172865600,3),(1351,-1162501200,2),(1351,-1141329600,3),(1351,-1130965200,2),(1351,-1109793600,3),(1351,-1099429200,2),(1351,-1078257600,3),(1351,-1067806800,2),(1351,-1046635200,3),(1351,-1036270800,2),(1351,-1015099200,3),(1351,-1004734800,2),(1351,-983563200,3),(1351,-973198800,2),(1351,-952027200,3),(1351,-941576400,2),(1351,-931032000,3),(1351,-900882000,2),(1351,-890337600,3),(1351,-833749200,2),(1351,-827265600,3),(1351,-752274000,2),(1351,-733780800,3),(1351,-197326800,2),(1351,-190843200,3),(1351,-184194000,2),(1351,-164491200,3),(1351,-152658000,2),(1351,-132955200,3),(1351,-121122000,2),(1351,-101419200,3),(1351,-86821200,2),(1351,-71092800,3),(1351,-54766800,2),(1351,-39038400,3),(1351,-23317200,2),(1351,-7588800,5),(1351,128142003,4),(1351,136605603,5),(1351,596948414,4),(1351,605066414,5),(1351,624423614,4),(1351,636516015,2),(1351,655963215,3),(1351,667796416,2),(1351,687499216,3),(1351,699418816,2),(1351,719380817,4),(1351,731469617,5),(1351,938919622,3),(1351,952052422,5),(1351,1085281222,2),(1351,1096171222,5),(1351,1198983623,4),(1351,1205632823,5),(1352,-2147483648,2),(1352,-1633276800,1),(1352,-1615136400,2),(1352,-1601827200,1),(1352,-1583686800,2),(1352,-880214400,3),(1352,-769395600,4),(1352,-765392400,2),(1352,-747244800,1),(1352,-733942800,2),(1352,-116438400,1),(1352,-100112400,2),(1352,-21484800,5),(1352,104914802,1),(1352,120639602,2),(1352,126691203,1),(1352,152089203,2),(1352,162374404,1),(1352,183538804,2),(1352,199267205,1),(1352,215593205,2),(1352,230716806,1),(1352,247042806,2),(1352,262771207,1),(1352,278492407,2),(1352,294220808,1),(1352,309942008,2),(1352,325670409,1),(1352,341391609,2),(1352,357120009,1),(1352,372841210,2),(1352,388569610,1),(1352,404895611,2),(1352,420019211,1),(1352,436345212,2),(1352,452073612,1),(1352,467794812,2),(1352,483523212,1),(1352,499244413,2),(1352,514972813,1),(1352,530694013,2),(1352,544608013,1),(1352,562143613,2),(1352,576057614,1),(1352,594198014,2),(1352,607507214,1),(1352,625647614,2),(1352,638956815,1),(1352,657097215,2),(1352,671011216,1),(1352,688546816,2),(1352,702460816,1),(1352,719996417,2),(1352,733910417,1),(1352,752050818,2),(1352,765360018,1),(1352,783500419,2),(1352,796809619,1),(1352,814950019,2),(1352,828864020,1),(1352,846399620,2),(1352,860313620,1),(1352,877849221,2),(1352,891763221,1),(1352,909298821,2),(1352,923212822,1),(1352,941353222,2),(1352,954662422,1),(1352,972802822,2),(1352,986112022,1),(1352,1004252422,2),(1352,1018166422,1),(1352,1035702022,2),(1352,1049616022,1),(1352,1067151622,2),(1352,1081065622,1),(1352,1099206022,2),(1352,1112515222,1),(1352,1130655622,2),(1352,1143964823,1),(1352,1162105223,2),(1352,1173600023,1),(1352,1194159623,2),(1352,1205049623,1),(1352,1225609223,2),(1352,1236499224,1),(1352,1257058824,2),(1352,1268553624,1),(1352,1289113224,2),(1352,1300003224,1),(1352,1320562824,2),(1352,1331452824,1),(1352,1352012425,2),(1352,1362902425,1),(1352,1383462025,2),(1352,1394352025,1),(1352,1414911625,2),(1352,1425801625,1),(1352,1446361226,2),(1352,1457856026,1),(1352,1478415626,2),(1352,1489305627,1),(1352,1509865227,2),(1352,1520755227,1),(1352,1541314827,2),(1352,1552204827,1),(1352,1572764427,2),(1352,1583654427,1),(1352,1604214027,2),(1352,1615708827,1),(1352,1636268427,2),(1352,1647158427,1),(1352,1667718027,2),(1352,1678608027,1),(1352,1699167627,2),(1352,1710057627,1),(1352,1730617227,2),(1352,1741507227,1),(1352,1762066827,2),(1352,1772956827,1),(1352,1793516427,2),(1352,1805011227,1),(1352,1825570827,2),(1352,1836460827,1),(1352,1857020427,2),(1352,1867910427,1),(1352,1888470027,2),(1352,1899360027,1),(1352,1919919627,2),(1352,1930809627,1),(1352,1951369227,2),(1352,1962864027,1),(1352,1983423627,2),(1352,1994313627,1),(1352,2014873227,2),(1352,2025763227,1),(1352,2046322827,2),(1352,2057212827,1),(1352,2077772427,2),(1352,2088662427,1),(1352,2109222027,2),(1352,2120112027,1),(1352,2140671627,2),(1353,-2147483648,0),(1353,-1514743200,1),(1353,377935210,2),(1353,407653211,4),(1353,828864020,3),(1353,846399620,4),(1353,860313620,3),(1353,877849221,4),(1353,891763221,3),(1353,909298821,4),(1353,923212822,3),(1353,941353222,4),(1353,954662422,3),(1353,972802822,4),(1353,989136022,3),(1353,1001833222,4),(1353,1018166422,3),(1353,1035702022,4),(1353,1049616022,3),(1353,1067151622,4),(1353,1081065622,3),(1353,1099206022,4),(1353,1112515222,3),(1353,1130655622,4),(1353,1143964823,3),(1353,1162105223,4),(1353,1175414423,3),(1353,1193554823,4),(1353,1207468823,3),(1353,1225004423,4),(1353,1238918424,3),(1353,1256454024,4),(1353,1270368024,3),(1353,1288508424,4),(1353,1301817624,3),(1353,1319958024,4),(1353,1333267224,3),(1353,1351407625,4),(1353,1365321625,3),(1353,1382857225,4),(1353,1396771225,3),(1353,1414306825,4),(1353,1428220825,3),(1353,1445756426,4),(1353,1459670426,3),(1353,1477810826,4),(1353,1491120027,3),(1353,1509260427,4),(1353,1522569627,3),(1353,1540710027,4),(1353,1554624027,3),(1353,1572159627,4),(1353,1586073627,3),(1353,1603609227,4),(1353,1617523227,3),(1353,1635663627,4),(1353,1648972827,3),(1353,1667113227,4),(1354,-2147483648,1),(1354,-880207200,2),(1354,-769395600,3),(1354,-765385200,1),(1354,-21477600,4),(1354,-5756400,1),(1354,9972000,4),(1354,25693200,1),(1354,41421600,4),(1354,57747600,1),(1354,73476000,4),(1354,89197201,1),(1354,104925602,4),(1354,120646802,1),(1354,126698403,4),(1354,152096403,1),(1354,162381604,4),(1354,183546004,1),(1354,199274405,4),(1354,215600405,1),(1354,230724006,4),(1354,247050006,1),(1354,262778407,4),(1354,278499607,1),(1354,294228008,4),(1354,309949208,1),(1354,325677609,4),(1354,341398809,1),(1354,357127209,4),(1354,372848410,1),(1354,388576810,4),(1354,404902811,1),(1354,420026411,4),(1354,436352412,1),(1354,1446372026,5),(1354,1457866826,6),(1354,1478426426,5),(1354,1489316427,6),(1354,1509876027,5),(1354,1520766027,6),(1354,1541325627,1),(1354,1547978427,5),(1354,1552215627,6),(1354,1572775227,5),(1354,1583665227,6),(1354,1604224827,5),(1354,1615719627,6),(1354,1636279227,5),(1354,1647169227,6),(1354,1667728827,5),(1354,1678618827,6),(1354,1699178427,5),(1354,1710068427,6),(1354,1730628027,5),(1354,1741518027,6),(1354,1762077627,5),(1354,1772967627,6),(1354,1793527227,5),(1354,1805022027,6),(1354,1825581627,5),(1354,1836471627,6),(1354,1857031227,5),(1354,1867921227,6),(1354,1888480827,5),(1354,1899370827,6),(1354,1919930427,5),(1354,1930820427,6),(1354,1951380027,5),(1354,1962874827,6),(1354,1983434427,5),(1354,1994324427,6),(1354,2014884027,5),(1354,2025774027,6),(1354,2046333627,5),(1354,2057223627,6),(1354,2077783227,5),(1354,2088673227,6),(1354,2109232827,5),(1354,2120122827,6),(1354,2140682427,5),(1355,-2147483648,0),(1355,-1514739600,1),(1355,-1343066400,2),(1355,-1234807200,4),(1355,-1220292000,3),(1355,-1207159200,4),(1355,-1191344400,2),(1355,-975261600,5),(1355,-963169200,2),(1355,-917114400,5),(1355,-907354800,2),(1355,-821901600,6),(1355,-810068400,2),(1355,-627501600,5),(1355,-612990000,2),(1355,828864020,5),(1355,846399620,2),(1355,860313620,5),(1355,877849221,2),(1355,891763221,5),(1355,909298821,2),(1355,923212822,5),(1355,941353222,2),(1355,954662422,5),(1355,972802822,2),(1355,989136022,5),(1355,1001833222,2),(1355,1018166422,5),(1355,1035702022,2),(1355,1049616022,5),(1355,1067151622,2),(1355,1081065622,5),(1355,1099206022,2),(1355,1112515222,5),(1355,1130655622,2),(1355,1143964823,5),(1355,1162105223,2),(1355,1175414423,5),(1355,1193554823,2),(1355,1207468823,5),(1355,1225004423,2),(1355,1238918424,5),(1355,1256454024,2),(1355,1270368024,5),(1355,1288508424,2),(1355,1301817624,5),(1355,1319958024,2),(1355,1333267224,5),(1355,1351407625,2),(1355,1365321625,5),(1355,1382857225,2),(1355,1396771225,5),(1355,1414306825,2),(1355,1428220825,5),(1355,1445756426,2),(1355,1459670426,5),(1355,1477810826,2),(1355,1491120027,5),(1355,1509260427,2),(1355,1522569627,5),(1355,1540710027,2),(1355,1554624027,5),(1355,1572159627,2),(1355,1586073627,5),(1355,1603609227,2),(1355,1617523227,5),(1355,1635663627,2),(1355,1648972827,5),(1355,1667113227,2),(1356,-2147483648,0),(1356,-1850328920,1),(1356,326001609,2),(1356,544597213,3),(1356,562132813,2),(1356,576046814,3),(1356,594187214,2),(1356,607496414,3),(1356,625636814,2),(1356,638946015,3),(1356,657086415,2),(1356,671000416,3),(1356,688536016,2),(1356,702450016,3),(1356,719985617,2),(1356,733899617,3),(1356,752040018,2),(1356,765349218,3),(1356,783489619,2),(1356,796798819,3),(1356,814939219,2),(1356,828853220,3),(1356,846388820,2),(1356,860302820,3),(1356,877838421,2),(1356,891752421,3),(1356,909288021,2),(1356,923202022,3),(1356,941342422,2),(1356,954651622,3),(1356,972792022,2),(1356,986101222,3),(1356,1004241622,2),(1356,1018155622,3),(1356,1035691222,2),(1356,1049605222,3),(1356,1067140822,2),(1356,1081054822,3),(1356,1099195222,2),(1356,1112504422,3),(1356,1130644822,2),(1356,1143954023,3),(1356,1162094423,2),(1356,1173589223,3),(1356,1194148823,2),(1356,1205038823,3),(1356,1225598423,2),(1356,1236488424,3),(1356,1257048024,2),(1356,1268542824,3),(1356,1289102424,2),(1356,1299992424,3),(1356,1320552024,2),(1356,1331442024,3),(1356,1352001625,2),(1356,1362891625,3),(1356,1383451225,2),(1356,1394341225,3),(1356,1414900825,2),(1356,1425790825,3),(1356,1446350426,2),(1356,1457845226,3),(1356,1478404826,2),(1356,1489294827,3),(1356,1509854427,2),(1356,1520744427,3),(1356,1541304027,2),(1356,1552194027,3),(1356,1572753627,2),(1356,1583643627,3),(1356,1604203227,2),(1356,1615698027,3),(1356,1636257627,2),(1356,1647147627,3),(1356,1667707227,2),(1356,1678597227,3),(1356,1699156827,2),(1356,1710046827,3),(1356,1730606427,2),(1356,1741496427,3),(1356,1762056027,2),(1356,1772946027,3),(1356,1793505627,2),(1356,1805000427,3),(1356,1825560027,2),(1356,1836450027,3),(1356,1857009627,2),(1356,1867899627,3),(1356,1888459227,2),(1356,1899349227,3),(1356,1919908827,2),(1356,1930798827,3),(1356,1951358427,2),(1356,1962853227,3),(1356,1983412827,2),(1356,1994302827,3),(1356,2014862427,2),(1356,2025752427,3),(1356,2046312027,2),(1356,2057202027,3),(1356,2077761627,2),(1356,2088651627,3),(1356,2109211227,2),(1356,2120101227,3),(1356,2140660827,2),(1357,-2147483648,1),(1357,-2131642800,3),(1357,-1632074400,2),(1357,-1615143600,3),(1357,-1153681200,2),(1357,-1145822400,3),(1357,-1122231600,2),(1357,-1114372800,3),(1357,-1090782000,2),(1357,-1082923200,3),(1357,-1059332400,2),(1357,-1051473600,3),(1357,-1027882800,2),(1357,-1020024000,3),(1357,-996433200,2),(1357,-988574400,3),(1357,-965674800,2),(1357,-955396800,3),(1357,-934743600,2),(1357,-923947200,3),(1357,-904503600,2),(1357,-891892800,3),(1357,-880221600,4),(1357,-769395600,5),(1357,-765399600,3),(1357,-747252000,2),(1357,-733950000,3),(1357,-715802400,2),(1357,-702500400,3),(1357,-684352800,2),(1357,-671050800,3),(1357,-652903200,2),(1357,-639601200,3),(1357,-620848800,2),(1357,-608151600,3),(1357,-589399200,2),(1357,-576097200,3),(1357,-557949600,2),(1357,-544647600,3),(1357,-526500000,2),(1357,-513198000,3),(1357,-495050400,2),(1357,-481748400,3),(1357,-463600800,2),(1357,-450298800,3),(1357,-431546400,2),(1357,-418244400,3),(1357,-400096800,2),(1357,-384375600,3),(1357,-368647200,2),(1357,-352926000,3),(1357,-337197600,2),(1357,-321476400,3),(1357,-305748000,2),(1357,-289422000,3),(1357,-273693600,2),(1357,-257972400,3),(1357,-242244000,2),(1357,-226522800,3),(1357,-210794400,2),(1357,-195073200,3),(1357,-179344800,2),(1357,-163623600,3),(1357,-147895200,2),(1357,-131569200,3),(1357,-116445600,2),(1357,-100119600,3),(1357,-84391200,2),(1357,-68670000,3),(1357,-52941600,2),(1357,-37220400,3),(1357,-21492000,2),(1357,-5770800,3),(1357,9957600,2),(1357,25678800,3),(1357,41407200,2),(1357,57733200,3),(1357,73461600,2),(1357,89182801,3),(1357,136360803,2),(1357,152082003,3),(1357,167810404,2),(1357,183531604,3),(1357,199260005,2),(1357,215586005,3),(1357,230709606,2),(1357,247035606,3),(1357,262764007,2),(1357,278485207,3),(1357,294213608,2),(1357,309934808,3),(1357,325663209,2),(1357,341384409,3),(1357,357112809,2),(1357,372834010,3),(1357,388562410,2),(1357,404888411,3),(1357,420012011,2),(1357,436338012,3),(1357,452066412,2),(1357,467787612,3),(1357,483516012,2),(1357,499237213,3),(1357,514965613,2),(1357,530686813,3),(1357,544600813,2),(1357,562136413,3),(1357,576050414,2),(1357,594190814,3),(1357,607500014,2),(1357,625640414,3),(1357,638949615,2),(1357,657090015,3),(1357,671004016,2),(1357,688539616,3),(1357,702453616,2),(1357,719989217,3),(1357,733896077,2),(1357,752036478,3),(1357,765345678,2),(1357,783486079,3),(1357,796795279,2),(1357,814935679,3),(1357,828849680,2),(1357,846385280,3),(1357,860299280,2),(1357,877834881,3),(1357,891748881,2),(1357,909284481,3),(1357,923198482,2),(1357,941338882,3),(1357,954648082,2),(1357,972788482,3),(1357,986097682,2),(1357,1004238082,3),(1357,1018152082,2),(1357,1035687682,3),(1357,1049601682,2),(1357,1067137282,3),(1357,1081051282,2),(1357,1099191682,3),(1357,1112500882,2),(1357,1130641282,3),(1357,1143950483,2),(1357,1162090883,3),(1357,1173592823,2),(1357,1194152423,3),(1357,1205042423,2),(1357,1225602023,3),(1357,1236492024,2),(1357,1257051624,3),(1357,1268546424,2),(1357,1289106024,3),(1357,1299996024,2),(1357,1320555624,3),(1357,1331445624,2),(1357,1352005225,3),(1357,1362895225,2),(1357,1383454825,3),(1357,1394344825,2),(1357,1414904425,3),(1357,1425794425,2),(1357,1446354026,3),(1357,1457848826,2),(1357,1478408426,3),(1357,1489298427,2),(1357,1509858027,3),(1357,1520748027,2),(1357,1541307627,3),(1357,1552197627,2),(1357,1572757227,3),(1357,1583647227,2),(1357,1604206827,3),(1357,1615701627,2),(1357,1636261227,3),(1357,1647151227,2),(1357,1667710827,3),(1357,1678600827,2),(1357,1699160427,3),(1357,1710050427,2),(1357,1730610027,3),(1357,1741500027,2),(1357,1762059627,3),(1357,1772949627,2),(1357,1793509227,3),(1357,1805004027,2),(1357,1825563627,3),(1357,1836453627,2),(1357,1857013227,3),(1357,1867903227,2),(1357,1888462827,3),(1357,1899352827,2),(1357,1919912427,3),(1357,1930802427,2),(1357,1951362027,3),(1357,1962856827,2),(1357,1983416427,3),(1357,1994306427,2),(1357,2014866027,3),(1357,2025756027,2),(1357,2046315627,3),(1357,2057205627,2),(1357,2077765227,3),(1357,2088655227,2),(1357,2109214827,3),(1357,2120104827,2),(1357,2140664427,3),(1358,-2147483648,0),(1358,-1514743200,1),(1358,568015214,3),(1358,576057614,2),(1358,594198014,3),(1358,828864020,2),(1358,846399620,3),(1358,860313620,2),(1358,877849221,3),(1358,891763221,2),(1358,909298821,3),(1358,923212822,2),(1358,941353222,3),(1358,954662422,2),(1358,972802822,3),(1358,989136022,2),(1358,1001833222,3),(1358,1018166422,2),(1358,1035702022,3),(1358,1049616022,2),(1358,1067151622,3),(1358,1081065622,2),(1358,1099206022,3),(1358,1112515222,2),(1358,1130655622,3),(1358,1143964823,2),(1358,1162105223,3),(1358,1175414423,2),(1358,1193554823,3),(1358,1207468823,2),(1358,1225004423,3),(1358,1238918424,2),(1358,1256454024,3),(1358,1270368024,2),(1358,1288508424,3),(1358,1301817624,2),(1358,1319958024,3),(1358,1333267224,2),(1358,1351407625,3),(1358,1365321625,2),(1358,1382857225,3),(1358,1396771225,2),(1358,1414306825,3),(1358,1428220825,2),(1358,1445756426,3),(1358,1459670426,2),(1358,1477810826,3),(1358,1491120027,2),(1358,1509260427,3),(1358,1522569627,2),(1358,1540710027,3),(1358,1554624027,2),(1358,1572159627,3),(1358,1586073627,2),(1358,1603609227,3),(1358,1617523227,2),(1358,1635663627,3),(1358,1648972827,2),(1358,1667113227,3),(1359,-2147483648,0),(1359,-1942690509,1),(1359,-1567455309,2),(1359,-1459627200,4),(1359,-1443819600,3),(1359,-1428006600,4),(1359,-1412283600,3),(1359,-1396470600,4),(1359,-1380747600,3),(1359,-1141590600,4),(1359,-1128286800,3),(1359,-1110141000,4),(1359,-1096837200,3),(1359,-1078691400,4),(1359,-1065387600,3),(1359,-1047241800,4),(1359,-1033938000,3),(1359,-1015187400,4),(1359,-1002488400,3),(1359,-983737800,4),(1359,-971038800,3),(1359,-954707400,4),(1359,-938984400,3),(1359,-920838600,4),(1359,-907534800,3),(1359,-896819400,4),(1359,-853621200,6),(1359,-845847000,5),(1359,-334789200,6),(1359,-319671000,5),(1359,-314226000,7),(1359,-309996000,5),(1359,-149720400,7),(1359,-134604000,5),(1359,-50446800,6),(1359,-34205400,5),(1359,9860400,7),(1359,14176800,5),(1359,72846000,7),(1359,80100001,5),(1359,127278003,8),(1359,132111003,6),(1359,147234603,5),(1359,156913203,7),(1359,165376804,5),(1359,219812405,7),(1359,226461606,5),(1359,250052406,7),(1359,257911207,5),(1359,282711607,7),(1359,289360808,5),(1359,294202808,7),(1359,322020009,5),(1359,566449213,7),(1359,573012014,5),(1359,597812414,7),(1359,605066414,5),(1359,625633214,7),(1359,635911215,5),(1359,656478015,7),(1359,667965616,5),(1359,688532416,7),(1359,699415216,5),(1359,719377217,7),(1359,730864817,5),(1359,1095562822,7),(1359,1111896022,5),(1359,1128834022,7),(1359,1142136023,5),(1359,1159678823,7),(1359,1173585623,5),(1359,1191733223,7),(1359,1205035223,5),(1359,1223182823,7),(1359,1236484824,5),(1359,1254632424,7),(1359,1268539224,5),(1359,1286082024,7),(1359,1299988824,5),(1359,1317531624,7),(1359,1331438424,5),(1359,1349586025,7),(1359,1362888025,5),(1359,1381035625,7),(1359,1394337625,5),(1359,1412485225,7),(1359,1425787225,5),(1360,-2147483648,2),(1360,-1632070800,1),(1360,-1615140000,2),(1360,-1601753400,1),(1360,-1583697600,2),(1360,-1567357200,1),(1360,-1554667200,2),(1360,-1534698000,1),(1360,-1524074400,2),(1360,-1503248400,1),(1360,-1492365600,2),(1360,-1471798800,1),(1360,-1460916000,2),(1360,-1440954000,1),(1360,-1428861600,2),(1360,-1409504400,1),(1360,-1397412000,2),(1360,-1378054800,1),(1360,-1365962400,2),(1360,-1346605200,1),(1360,-1333908000,2),(1360,-1315155600,1),(1360,-1301853600,2),(1360,-1283706000,1),(1360,-1270404000,2),(1360,-1252256400,1),(1360,-1238954400,2),(1360,-1220806800,1),(1360,-1207504800,2),(1360,-1188752400,1),(1360,-1176055200,2),(1360,-1157302800,1),(1360,-1144000800,2),(1360,-1125853200,1),(1360,-1112551200,2),(1360,-1094403600,1),(1360,-1081101600,2),(1360,-1062954000,1),(1360,-1049652000,2),(1360,-1031504400,1),(1360,-1018202400,2),(1360,-1000054800,1),(1360,-986752800,2),(1360,-968000400,1),(1360,-955303200,2),(1360,-936550800,1),(1360,-880218000,3),(1360,-769395600,4),(1360,-765396000,2),(1360,-747248400,1),(1360,-733946400,2),(1360,-715806000,1),(1360,-702504000,2),(1360,-684356400,1),(1360,-671054400,2),(1360,-652906800,1),(1360,-634161600,2),(1360,-620845200,1),(1360,-602704800,2),(1360,-589395600,1),(1360,-576093600,2),(1360,-557946000,1),(1360,-544644000,2),(1360,-526496400,1),(1360,-513194400,2),(1360,-495046800,1),(1360,-481744800,2),(1360,-463597200,1),(1360,-450295200,2),(1360,-431542800,1),(1360,-418240800,2),(1360,-400093200,1),(1360,-384372000,2),(1360,-368643600,1),(1360,-352922400,2),(1360,-337194000,1),(1360,-321472800,2),(1360,-305744400,1),(1360,-289418400,2),(1360,-273690000,1),(1360,-257968800,2),(1360,-242240400,1),(1360,-226519200,2),(1360,-210790800,1),(1360,-195069600,2),(1360,-179341200,1),(1360,-163620000,2),(1360,-147891600,1),(1360,-131565600,2),(1360,-116442000,1),(1360,-100116000,2),(1360,-84387600,1),(1360,-68666400,2),(1360,-52938000,1),(1360,-37216800,2),(1360,-21488400,1),(1360,-5767200,2),(1360,9961200,1),(1360,25682400,2),(1360,41410800,1),(1360,57736800,2),(1360,73465200,1),(1360,89186401,2),(1360,104914802,1),(1360,120636002,2),(1360,136364403,1),(1360,152085603,2),(1360,167814004,1),(1360,183535204,2),(1360,199263605,1),(1360,215589605,2),(1360,230713206,1),(1360,247039206,2),(1360,262767607,1),(1360,278488807,2),(1360,294217208,1),(1360,309938408,2),(1360,325666809,1),(1360,341388009,2),(1360,357116409,1),(1360,372837610,2),(1360,388566010,1),(1360,404892011,2),(1360,420015611,1),(1360,436341612,2),(1360,452070012,1),(1360,467791212,2),(1360,483519612,1),(1360,499240813,2),(1360,514969213,1),(1360,530690413,2),(1360,544604413,1),(1360,562140013,2),(1360,576054014,1),(1360,594194414,2),(1360,607503614,1),(1360,625644014,2),(1360,638953215,1),(1360,657093615,2),(1360,671007616,1),(1360,688543216,2),(1360,702457216,1),(1360,719992817,2),(1360,733906817,1),(1360,752047218,2),(1360,765356418,1),(1360,783496819,2),(1360,796806019,1),(1360,814946419,2),(1360,828860420,1),(1360,846396020,2),(1360,860310020,1),(1360,877845621,2),(1360,891759621,1),(1360,909295221,2),(1360,923209222,1),(1360,941349622,2),(1360,954658822,1),(1360,972799222,2),(1360,986108422,1),(1360,1004248822,2),(1360,1018162822,1),(1360,1035698422,2),(1360,1049612422,1),(1360,1067148022,2),(1360,1081062022,1),(1360,1099202422,2),(1360,1112511622,1),(1360,1130652022,2),(1360,1143961223,1),(1360,1162101623,2),(1360,1173596423,1),(1360,1194156023,2),(1360,1205046023,1),(1360,1225605623,2),(1360,1236495624,1),(1360,1257055224,2),(1360,1268550024,1),(1360,1289109624,2),(1360,1299999624,1),(1360,1320559224,2),(1360,1331449224,1),(1360,1352008825,2),(1360,1362898825,1),(1360,1383458425,2),(1360,1394348425,1),(1360,1414908025,2),(1360,1425798025,1),(1360,1446357626,2),(1360,1457852426,1),(1360,1478412026,2),(1360,1489302027,1),(1360,1509861627,2),(1360,1520751627,1),(1360,1541311227,2),(1360,1552201227,1),(1360,1572760827,2),(1360,1583650827,1),(1360,1604210427,2),(1360,1615705227,1),(1360,1636264827,2),(1360,1647154827,1),(1360,1667714427,2),(1360,1678604427,1),(1360,1699164027,2),(1360,1710054027,1),(1360,1730613627,2),(1360,1741503627,1),(1360,1762063227,2),(1360,1772953227,1),(1360,1793512827,2),(1360,1805007627,1),(1360,1825567227,2),(1360,1836457227,1),(1360,1857016827,2),(1360,1867906827,1),(1360,1888466427,2),(1360,1899356427,1),(1360,1919916027,2),(1360,1930806027,1),(1360,1951365627,2),(1360,1962860427,1),(1360,1983420027,2),(1360,1994310027,1),(1360,2014869627,2),(1360,2025759627,1),(1360,2046319227,2),(1360,2057209227,1),(1360,2077768827,2),(1360,2088658827,1),(1360,2109218427,2),(1360,2120108427,1),(1360,2140668027,2),(1361,-2147483648,1),(1361,-873057600,3),(1361,-769395600,2),(1361,-765399600,1),(1362,-2147483648,2),(1362,-1632070800,1),(1362,-1615140000,2),(1362,-1601753400,1),(1362,-1583697600,2),(1362,-1567357200,1),(1362,-1554667200,2),(1362,-1534698000,1),(1362,-1524074400,2),(1362,-1503248400,1),(1362,-1492365600,2),(1362,-1471798800,1),(1362,-1460916000,2),(1362,-1440954000,1),(1362,-1428861600,2),(1362,-1409504400,1),(1362,-1397412000,2),(1362,-1378054800,1),(1362,-1365962400,2),(1362,-1346605200,1),(1362,-1333908000,2),(1362,-1315155600,1),(1362,-1301853600,2),(1362,-1283706000,1),(1362,-1270404000,2),(1362,-1252256400,1),(1362,-1238954400,2),(1362,-1220806800,1),(1362,-1207504800,2),(1362,-1188752400,1),(1362,-1176055200,2),(1362,-1157302800,1),(1362,-1144000800,2),(1362,-1125853200,1),(1362,-1112551200,2),(1362,-1094403600,1),(1362,-1081101600,2),(1362,-1062954000,1),(1362,-1049652000,2),(1362,-1031504400,1),(1362,-1018202400,2),(1362,-1000054800,1),(1362,-986752800,2),(1362,-968000400,1),(1362,-955303200,2),(1362,-936550800,1),(1362,-880218000,3),(1362,-769395600,4),(1362,-765396000,2),(1362,-747248400,1),(1362,-733946400,2),(1362,-715806000,1),(1362,-702504000,2),(1362,-684356400,1),(1362,-671054400,2),(1362,-652906800,1),(1362,-634161600,2),(1362,-620845200,1),(1362,-602704800,2),(1362,-589395600,1),(1362,-576093600,2),(1362,-557946000,1),(1362,-544644000,2),(1362,-526496400,1),(1362,-513194400,2),(1362,-495046800,1),(1362,-481744800,2),(1362,-463597200,1),(1362,-450295200,2),(1362,-431542800,1),(1362,-418240800,2),(1362,-400093200,1),(1362,-384372000,2),(1362,-368643600,1),(1362,-352922400,2),(1362,-337194000,1),(1362,-321472800,2),(1362,-305744400,1),(1362,-289418400,2),(1362,-273690000,1),(1362,-257968800,2),(1362,-242240400,1),(1362,-226519200,2),(1362,-210790800,1),(1362,-195069600,2),(1362,-179341200,1),(1362,-163620000,2),(1362,-147891600,1),(1362,-131565600,2),(1362,-116442000,1),(1362,-100116000,2),(1362,-84387600,1),(1362,-68666400,2),(1362,-52938000,1),(1362,-37216800,2),(1362,-21488400,1),(1362,-5767200,2),(1362,9961200,1),(1362,25682400,2),(1362,41410800,1),(1362,57736800,2),(1362,73465200,1),(1362,89186401,2),(1362,104914802,1),(1362,120636002,2),(1362,136364403,1),(1362,152085603,2),(1362,167814004,1),(1362,183535204,2),(1362,199263605,1),(1362,215589605,2),(1362,230713206,1),(1362,247039206,2),(1362,262767607,1),(1362,278488807,2),(1362,294217208,1),(1362,309938408,2),(1362,325666809,1),(1362,341388009,2),(1362,357116409,1),(1362,372837610,2),(1362,388566010,1),(1362,404892011,2),(1362,420015611,1),(1362,436341612,2),(1362,452070012,1),(1362,467791212,2),(1362,483519612,1),(1362,499240813,2),(1362,514969213,1),(1362,530690413,2),(1362,544604413,1),(1362,562140013,2),(1362,576054014,1),(1362,594194414,2),(1362,607503614,1),(1362,625644014,2),(1362,638953215,1),(1362,657093615,2),(1362,671007616,1),(1362,688543216,2),(1362,702457216,1),(1362,719992817,2),(1362,733906817,1),(1362,752047218,2),(1362,765356418,1),(1362,783496819,2),(1362,796806019,1),(1362,814946419,2),(1362,828860420,1),(1362,846396020,2),(1362,860310020,1),(1362,877845621,2),(1362,891759621,1),(1362,909295221,2),(1362,923209222,1),(1362,941349622,2),(1362,954658822,1),(1362,972799222,2),(1362,986108422,1),(1362,1004248822,2),(1362,1018162822,1),(1362,1035698422,2),(1362,1049612422,1),(1362,1067148022,2),(1362,1081062022,1),(1362,1099202422,2),(1362,1112511622,1),(1362,1130652022,2),(1362,1143961223,1),(1362,1162101623,2),(1362,1173596423,1),(1362,1194156023,2),(1362,1205046023,1),(1362,1225605623,2),(1362,1236495624,1),(1362,1257055224,2),(1362,1268550024,1),(1362,1289109624,2),(1362,1299999624,1),(1362,1320559224,2),(1362,1331449224,1),(1362,1352008825,2),(1362,1362898825,1),(1362,1383458425,2),(1362,1394348425,1),(1362,1414908025,2),(1362,1425798025,1),(1362,1446357626,2),(1362,1457852426,1),(1362,1478412026,2),(1362,1489302027,1),(1362,1509861627,2),(1362,1520751627,1),(1362,1541311227,2),(1362,1552201227,1),(1362,1572760827,2),(1362,1583650827,1),(1362,1604210427,2),(1362,1615705227,1),(1362,1636264827,2),(1362,1647154827,1),(1362,1667714427,2),(1362,1678604427,1),(1362,1699164027,2),(1362,1710054027,1),(1362,1730613627,2),(1362,1741503627,1),(1362,1762063227,2),(1362,1772953227,1),(1362,1793512827,2),(1362,1805007627,1),(1362,1825567227,2),(1362,1836457227,1),(1362,1857016827,2),(1362,1867906827,1),(1362,1888466427,2),(1362,1899356427,1),(1362,1919916027,2),(1362,1930806027,1),(1362,1951365627,2),(1362,1962860427,1),(1362,1983420027,2),(1362,1994310027,1),(1362,2014869627,2),(1362,2025759627,1),(1362,2046319227,2),(1362,2057209227,1),(1362,2077768827,2),(1362,2088658827,1),(1362,2109218427,2),(1362,2120108427,1),(1362,2140668027,2),(1363,-2147483648,3),(1363,-1633280400,1),(1363,-1615140000,2),(1363,-1601830800,1),(1363,-1583690400,2),(1363,-1570381200,1),(1363,-1551636000,2),(1363,-1536512400,1),(1363,-1523210400,2),(1363,-1504458000,1),(1363,-1491760800,2),(1363,-1473008400,1),(1363,-1459706400,2),(1363,-1441558800,1),(1363,-1428256800,2),(1363,-1410109200,1),(1363,-1396807200,2),(1363,-1378659600,1),(1363,-1365357600,2),(1363,-1347210000,1),(1363,-1333908000,2),(1363,-1315155600,1),(1363,-1301853600,2),(1363,-1283706000,1),(1363,-1270404000,2),(1363,-1252256400,1),(1363,-1238954400,2),(1363,-1220806800,1),(1363,-1207504800,2),(1363,-1189357200,1),(1363,-1176055200,2),(1363,-1157302800,1),(1363,-1144605600,2),(1363,-1125853200,1),(1363,-1112551200,2),(1363,-1094403600,1),(1363,-1081101600,2),(1363,-1062954000,1),(1363,-1049652000,2),(1363,-1031504400,1),(1363,-1018202400,2),(1363,-1000054800,1),(1363,-986752800,2),(1363,-968000400,1),(1363,-955303200,2),(1363,-936550800,1),(1363,-923248800,2),(1363,-905101200,1),(1363,-891799200,2),(1363,-880218000,4),(1363,-769395600,5),(1363,-765396000,2),(1363,-747248400,1),(1363,-733946400,2),(1363,-715798800,1),(1363,-702496800,2),(1363,-684349200,1),(1363,-671047200,2),(1363,-652899600,1),(1363,-639597600,2),(1363,-620845200,1),(1363,-608148000,2),(1363,-589395600,1),(1363,-576093600,2),(1363,-557946000,1),(1363,-544644000,2),(1363,-526496400,1),(1363,-513194400,2),(1363,-495046800,1),(1363,-481744800,2),(1363,-463597200,1),(1363,-447271200,2),(1363,-431542800,1),(1363,-415821600,2),(1363,-400093200,1),(1363,-384372000,2),(1363,-368643600,1),(1363,-352922400,2),(1363,-337194000,1),(1363,-321472800,2),(1363,-305744400,1),(1363,-289418400,2),(1363,-273690000,1),(1363,-257968800,2),(1363,-242240400,1),(1363,-226519200,2),(1363,-210790800,1),(1363,-195069600,2),(1363,-179341200,1),(1363,-163620000,2),(1363,-147891600,1),(1363,-131565600,2),(1363,-116442000,1),(1363,-100116000,2),(1363,-84387600,1),(1363,-68666400,2),(1363,-52938000,1),(1363,-37216800,2),(1363,-21488400,1),(1363,-5767200,2),(1363,9961200,1),(1363,25682400,2),(1363,41410800,1),(1363,57736800,2),(1363,73465200,1),(1363,89186401,2),(1363,104914802,1),(1363,120636002,2),(1363,126687603,1),(1363,152085603,2),(1363,162370804,1),(1363,183535204,2),(1363,199263605,1),(1363,215589605,2),(1363,230713206,1),(1363,247039206,2),(1363,262767607,1),(1363,278488807,2),(1363,294217208,1),(1363,309938408,2),(1363,325666809,1),(1363,341388009,2),(1363,357116409,1),(1363,372837610,2),(1363,388566010,1),(1363,404892011,2),(1363,420015611,1),(1363,436341612,2),(1363,452070012,1),(1363,467791212,2),(1363,483519612,1),(1363,499240813,2),(1363,514969213,1),(1363,530690413,2),(1363,544604413,1),(1363,562140013,2),(1363,576054014,1),(1363,594194414,2),(1363,607503614,1),(1363,625644014,2),(1363,638953215,1),(1363,657093615,2),(1363,671007616,1),(1363,688543216,2),(1363,702457216,1),(1363,719992817,2),(1363,733906817,1),(1363,752047218,2),(1363,765356418,1),(1363,783496819,2),(1363,796806019,1),(1363,814946419,2),(1363,828860420,1),(1363,846396020,2),(1363,860310020,1),(1363,877845621,2),(1363,891759621,1),(1363,909295221,2),(1363,923209222,1),(1363,941349622,2),(1363,954658822,1),(1363,972799222,2),(1363,986108422,1),(1363,1004248822,2),(1363,1018162822,1),(1363,1035698422,2),(1363,1049612422,1),(1363,1067148022,2),(1363,1081062022,1),(1363,1099202422,2),(1363,1112511622,1),(1363,1130652022,2),(1363,1143961223,1),(1363,1162101623,2),(1363,1173596423,1),(1363,1194156023,2),(1363,1205046023,1),(1363,1225605623,2),(1363,1236495624,1),(1363,1257055224,2),(1363,1268550024,1),(1363,1289109624,2),(1363,1299999624,1),(1363,1320559224,2),(1363,1331449224,1),(1363,1352008825,2),(1363,1362898825,1),(1363,1383458425,2),(1363,1394348425,1),(1363,1414908025,2),(1363,1425798025,1),(1363,1446357626,2),(1363,1457852426,1),(1363,1478412026,2),(1363,1489302027,1),(1363,1509861627,2),(1363,1520751627,1),(1363,1541311227,2),(1363,1552201227,1),(1363,1572760827,2),(1363,1583650827,1),(1363,1604210427,2),(1363,1615705227,1),(1363,1636264827,2),(1363,1647154827,1),(1363,1667714427,2),(1363,1678604427,1),(1363,1699164027,2),(1363,1710054027,1),(1363,1730613627,2),(1363,1741503627,1),(1363,1762063227,2),(1363,1772953227,1),(1363,1793512827,2),(1363,1805007627,1),(1363,1825567227,2),(1363,1836457227,1),(1363,1857016827,2),(1363,1867906827,1),(1363,1888466427,2),(1363,1899356427,1),(1363,1919916027,2),(1363,1930806027,1),(1363,1951365627,2),(1363,1962860427,1),(1363,1983420027,2),(1363,1994310027,1),(1363,2014869627,2),(1363,2025759627,1),(1363,2046319227,2),(1363,2057209227,1),(1363,2077768827,2),(1363,2088658827,1),(1363,2109218427,2),(1363,2120108427,1),(1363,2140668027,2),(1364,-2147483648,2),(1364,-1632070800,1),(1364,-1615140000,2),(1364,-1601753400,1),(1364,-1583697600,2),(1364,-1567357200,1),(1364,-1554667200,2),(1364,-1534698000,1),(1364,-1524074400,2),(1364,-1503248400,1),(1364,-1492365600,2),(1364,-1471798800,1),(1364,-1460916000,2),(1364,-1440954000,1),(1364,-1428861600,2),(1364,-1409504400,1),(1364,-1397412000,2),(1364,-1378054800,1),(1364,-1365962400,2),(1364,-1346605200,1),(1364,-1333908000,2),(1364,-1315155600,1),(1364,-1301853600,2),(1364,-1283706000,1),(1364,-1270404000,2),(1364,-1252256400,1),(1364,-1238954400,2),(1364,-1220806800,1),(1364,-1207504800,2),(1364,-1188752400,1),(1364,-1176055200,2),(1364,-1157302800,1),(1364,-1144000800,2),(1364,-1125853200,1),(1364,-1112551200,2),(1364,-1094403600,1),(1364,-1081101600,2),(1364,-1062954000,1),(1364,-1049652000,2),(1364,-1031504400,1),(1364,-1018202400,2),(1364,-1000054800,1),(1364,-986752800,2),(1364,-968000400,1),(1364,-955303200,2),(1364,-936550800,1),(1364,-880218000,3),(1364,-769395600,4),(1364,-765396000,2),(1364,-747248400,1),(1364,-733946400,2),(1364,-715806000,1),(1364,-702504000,2),(1364,-684356400,1),(1364,-671054400,2),(1364,-652906800,1),(1364,-634161600,2),(1364,-620845200,1),(1364,-602704800,2),(1364,-589395600,1),(1364,-576093600,2),(1364,-557946000,1),(1364,-544644000,2),(1364,-526496400,1),(1364,-513194400,2),(1364,-495046800,1),(1364,-481744800,2),(1364,-463597200,1),(1364,-450295200,2),(1364,-431542800,1),(1364,-418240800,2),(1364,-400093200,1),(1364,-384372000,2),(1364,-368643600,1),(1364,-352922400,2),(1364,-337194000,1),(1364,-321472800,2),(1364,-305744400,1),(1364,-289418400,2),(1364,-273690000,1),(1364,-257968800,2),(1364,-242240400,1),(1364,-226519200,2),(1364,-210790800,1),(1364,-195069600,2),(1364,-179341200,1),(1364,-163620000,2),(1364,-147891600,1),(1364,-131565600,2),(1364,-116442000,1),(1364,-100116000,2),(1364,-84387600,1),(1364,-68666400,2),(1364,-52938000,1),(1364,-37216800,2),(1364,-21488400,1),(1364,-5767200,2),(1364,9961200,1),(1364,25682400,2),(1364,41410800,1),(1364,57736800,2),(1364,73465200,1),(1364,89186401,2),(1364,104914802,1),(1364,120636002,2),(1364,136364403,1),(1364,152085603,2),(1364,167814004,1),(1364,183535204,2),(1364,199263605,1),(1364,215589605,2),(1364,230713206,1),(1364,247039206,2),(1364,262767607,1),(1364,278488807,2),(1364,294217208,1),(1364,309938408,2),(1364,325666809,1),(1364,341388009,2),(1364,357116409,1),(1364,372837610,2),(1364,388566010,1),(1364,404892011,2),(1364,420015611,1),(1364,436341612,2),(1364,452070012,1),(1364,467791212,2),(1364,483519612,1),(1364,499240813,2),(1364,514969213,1),(1364,530690413,2),(1364,544604413,1),(1364,562140013,2),(1364,576054014,1),(1364,594194414,2),(1364,607503614,1),(1364,625644014,2),(1364,638953215,1),(1364,657093615,2),(1364,671007616,1),(1364,688543216,2),(1364,702457216,1),(1364,719992817,2),(1364,733906817,1),(1364,752047218,2),(1364,765356418,1),(1364,783496819,2),(1364,796806019,1),(1364,814946419,2),(1364,828860420,1),(1364,846396020,2),(1364,860310020,1),(1364,877845621,2),(1364,891759621,1),(1364,909295221,2),(1364,923209222,1),(1364,941349622,2),(1364,954658822,1),(1364,972799222,2),(1364,986108422,1),(1364,1004248822,2),(1364,1018162822,1),(1364,1035698422,2),(1364,1049612422,1),(1364,1067148022,2),(1364,1081062022,1),(1364,1099202422,2),(1364,1112511622,1),(1364,1130652022,2),(1364,1143961223,1),(1364,1162101623,2),(1364,1173596423,1),(1364,1194156023,2),(1364,1205046023,1),(1364,1225605623,2),(1364,1236495624,1),(1364,1257055224,2),(1364,1268550024,1),(1364,1289109624,2),(1364,1299999624,1),(1364,1320559224,2),(1364,1331449224,1),(1364,1352008825,2),(1364,1362898825,1),(1364,1383458425,2),(1364,1394348425,1),(1364,1414908025,2),(1364,1425798025,1),(1364,1446357626,2),(1364,1457852426,1),(1364,1478412026,2),(1364,1489302027,1),(1364,1509861627,2),(1364,1520751627,1),(1364,1541311227,2),(1364,1552201227,1),(1364,1572760827,2),(1364,1583650827,1),(1364,1604210427,2),(1364,1615705227,1),(1364,1636264827,2),(1364,1647154827,1),(1364,1667714427,2),(1364,1678604427,1),(1364,1699164027,2),(1364,1710054027,1),(1364,1730613627,2),(1364,1741503627,1),(1364,1762063227,2),(1364,1772953227,1),(1364,1793512827,2),(1364,1805007627,1),(1364,1825567227,2),(1364,1836457227,1),(1364,1857016827,2),(1364,1867906827,1),(1364,1888466427,2),(1364,1899356427,1),(1364,1919916027,2),(1364,1930806027,1),(1364,1951365627,2),(1364,1962860427,1),(1364,1983420027,2),(1364,1994310027,1),(1364,2014869627,2),(1364,2025759627,1),(1364,2046319227,2),(1364,2057209227,1),(1364,2077768827,2),(1364,2088658827,1),(1364,2109218427,2),(1364,2120108427,1),(1364,2140668027,2),(1365,-2147483648,1),(1365,-880196400,2),(1365,-769395600,3),(1365,-765374400,1),(1365,-86878800,4),(1365,-21466800,5),(1365,-5745600,4),(1365,9982800,5),(1365,25704000,4),(1365,41432400,5),(1365,57758400,4),(1365,73486800,5),(1365,89208001,4),(1365,104936402,5),(1365,120657602,4),(1365,126709203,5),(1365,152107203,4),(1365,162392404,5),(1365,183556804,4),(1365,199285205,5),(1365,215611205,4),(1365,230734806,5),(1365,247060806,4),(1365,262789207,5),(1365,278510407,4),(1365,294238808,5),(1365,309960008,4),(1365,325688409,5),(1365,341409609,4),(1365,357138009,5),(1365,372859210,4),(1365,388587610,5),(1365,404913611,4),(1365,420037211,5),(1365,436363212,6),(1365,439030812,8),(1365,452084412,7),(1365,467805612,8),(1365,483534012,7),(1365,499255213,8),(1365,514983613,7),(1365,530704813,8),(1365,544618813,7),(1365,562154413,8),(1365,576068414,7),(1365,594208814,8),(1365,607518014,7),(1365,625658414,8),(1365,638967615,7),(1365,657108015,8),(1365,671022016,7),(1365,688557616,8),(1365,702471616,7),(1365,720007217,8),(1365,733921217,7),(1365,752061618,8),(1365,765370818,7),(1365,783511219,8),(1365,796820419,7),(1365,814960819,8),(1365,828874820,7),(1365,846410420,8),(1365,860324420,7),(1365,877860021,8),(1365,891774021,7),(1365,909309621,8),(1365,923223622,7),(1365,941364022,8),(1365,954673222,7),(1365,972813622,8),(1365,986122822,7),(1365,1004263222,8),(1365,1018177222,7),(1365,1035712822,8),(1365,1049626822,7),(1365,1067162422,8),(1365,1081076422,7),(1365,1099216822,8),(1365,1112526022,7),(1365,1130666422,8),(1365,1143975623,7),(1365,1162116023,8),(1365,1173610823,7),(1365,1194170423,8),(1365,1205060423,7),(1365,1225620023,8),(1365,1236510024,7),(1365,1257069624,8),(1365,1268564424,7),(1365,1289124024,8),(1365,1300014024,7),(1365,1320573624,8),(1365,1331463624,7),(1365,1352023225,8),(1365,1362913225,7),(1365,1383472825,8),(1365,1394362825,7),(1365,1414922425,8),(1365,1425812425,7),(1365,1446372026,8),(1365,1457866826,7),(1365,1478426426,8),(1365,1489316427,7),(1365,1509876027,8),(1365,1520766027,7),(1365,1541325627,8),(1365,1552215627,7),(1365,1572775227,8),(1365,1583665227,7),(1365,1604224827,8),(1365,1615719627,7),(1365,1636279227,8),(1365,1647169227,7),(1365,1667728827,8),(1365,1678618827,7),(1365,1699178427,8),(1365,1710068427,7),(1365,1730628027,8),(1365,1741518027,7),(1365,1762077627,8),(1365,1772967627,7),(1365,1793527227,8),(1365,1805022027,7),(1365,1825581627,8),(1365,1836471627,7),(1365,1857031227,8),(1365,1867921227,7),(1365,1888480827,8),(1365,1899370827,7),(1365,1919930427,8),(1365,1930820427,7),(1365,1951380027,8),(1365,1962874827,7),(1365,1983434427,8),(1365,1994324427,7),(1365,2014884027,8),(1365,2025774027,7),(1365,2046333627,8),(1365,2057223627,7),(1365,2077783227,8),(1365,2088673227,7),(1365,2109232827,8),(1365,2120122827,7),(1365,2140682427,8),(1366,-2147483648,0),(1366,-1767217820,2),(1366,-1206961200,1),(1366,-1191366000,2),(1366,-1175378400,1),(1366,-1159830000,2),(1366,-633823200,1),(1366,-622072800,2),(1366,-602287200,1),(1366,-591836400,2),(1366,-570751200,1),(1366,-560214000,2),(1366,-539128800,1),(1366,-531356400,2),(1366,-191368800,1),(1366,-184201200,2),(1366,-155167200,1),(1366,-150073200,2),(1366,-128901600,1),(1366,-121129200,2),(1366,-99957600,1),(1366,-89593200,2),(1366,-68421600,1),(1366,-57970800,2),(1366,499744813,1),(1366,511232413,2),(1366,530589613,1),(1366,540262813,2),(1366,562125613,1),(1366,571194014,2),(1366,592970414,1),(1366,602038814,2),(1366,624420014,1),(1366,634698015,2),(1366,938916022,1),(1366,951613222,2),(1366,970970422,1),(1366,971571622,2),(1366,1003024822,1),(1366,1013907622,2),(1367,-2147483648,5),(1367,-1633273200,1),(1367,-1615132800,2),(1367,-1601823600,1),(1367,-1583683200,2),(1367,-880210800,3),(1367,-769395600,4),(1367,-765388800,2),(1367,-84380400,1),(1367,-68659200,2),(1367,-52930800,1),(1367,-37209600,2),(1367,-21481200,1),(1367,-5760000,2),(1367,9968400,1),(1367,25689600,2),(1367,41418000,1),(1367,57744000,2),(1367,73472400,1),(1367,89193601,2),(1367,104922002,1),(1367,120643202,2),(1367,126694803,1),(1367,152092803,2),(1367,162378004,1),(1367,183542404,2),(1367,199270805,1),(1367,215596805,2),(1367,230720406,1),(1367,247046406,2),(1367,262774807,1),(1367,278496007,2),(1367,294224408,1),(1367,309945608,2),(1367,325674009,1),(1367,341395209,2),(1367,357123609,1),(1367,372844810,2),(1367,388573210,1),(1367,404899211,2),(1367,420022811,1),(1367,436348812,2),(1367,452077212,1),(1367,467798412,2),(1367,483526812,1),(1367,499248013,2),(1367,514976413,1),(1367,530697613,2),(1367,544611613,1),(1367,562147213,2),(1367,576061214,1),(1367,594201614,2),(1367,607510814,1),(1367,625651214,2),(1367,638960415,1),(1367,657100815,2),(1367,671014816,1),(1367,688550416,2),(1367,702464416,1),(1367,720000017,2),(1367,733914017,1),(1367,752054418,2),(1367,765363618,1),(1367,783504019,2),(1367,796813219,1),(1367,814953619,2),(1367,828867620,1),(1367,846403220,2),(1367,860317220,1),(1367,877852821,2),(1367,891766821,1),(1367,909302421,2),(1367,923216422,1),(1367,941356822,2),(1367,954666022,1),(1367,972806422,2),(1367,986115622,1),(1367,1004256022,2),(1367,1018170022,1),(1367,1035705622,2),(1367,1049619622,1),(1367,1067155222,2),(1367,1081069222,1),(1367,1099209622,2),(1367,1112518822,1),(1367,1130659222,2),(1367,1143968423,1),(1367,1162108823,2),(1367,1173603623,1),(1367,1194163223,2),(1367,1205053223,1),(1367,1225612823,2),(1367,1236502824,1),(1367,1257062424,2),(1367,1268557224,1),(1367,1289116824,7),(1367,1300003224,6),(1367,1320562824,7),(1367,1331452824,6),(1367,1352012425,7),(1367,1362902425,6),(1367,1383462025,7),(1367,1394352025,6),(1367,1414911625,7),(1367,1425801625,6),(1367,1446361226,7),(1367,1457856026,6),(1367,1478415626,7),(1367,1489305627,6),(1367,1509865227,7),(1367,1520755227,6),(1367,1541314827,7),(1367,1552204827,6),(1367,1572764427,7),(1367,1583654427,6),(1367,1604214027,7),(1367,1615708827,6),(1367,1636268427,7),(1367,1647158427,6),(1367,1667718027,7),(1367,1678608027,6),(1367,1699167627,7),(1367,1710057627,6),(1367,1730617227,7),(1367,1741507227,6),(1367,1762066827,7),(1367,1772956827,6),(1367,1793516427,7),(1367,1805011227,6),(1367,1825570827,7),(1367,1836460827,6),(1367,1857020427,7),(1367,1867910427,6),(1367,1888470027,7),(1367,1899360027,6),(1367,1919919627,7),(1367,1930809627,6),(1367,1951369227,7),(1367,1962864027,6),(1367,1983423627,7),(1367,1994313627,6),(1367,2014873227,7),(1367,2025763227,6),(1367,2046322827,7),(1367,2057212827,6),(1367,2077772427,7),(1367,2088662427,6),(1367,2109222027,7),(1367,2120112027,6),(1367,2140671627,7),(1368,-2147483648,5),(1368,-1633273200,1),(1368,-1615132800,2),(1368,-1601823600,1),(1368,-1583683200,2),(1368,-880210800,3),(1368,-769395600,4),(1368,-765388800,2),(1368,-84380400,1),(1368,-68659200,2),(1368,-52930800,1),(1368,-37209600,2),(1368,-21481200,1),(1368,-5760000,2),(1368,9968400,1),(1368,25689600,2),(1368,41418000,1),(1368,57744000,2),(1368,73472400,1),(1368,89193601,2),(1368,104922002,1),(1368,120643202,2),(1368,126694803,1),(1368,152092803,2),(1368,162378004,1),(1368,183542404,2),(1368,199270805,1),(1368,215596805,2),(1368,230720406,1),(1368,247046406,2),(1368,262774807,1),(1368,278496007,2),(1368,294224408,1),(1368,309945608,2),(1368,325674009,1),(1368,341395209,2),(1368,357123609,1),(1368,372844810,2),(1368,388573210,1),(1368,404899211,2),(1368,420022811,1),(1368,436348812,2),(1368,452077212,1),(1368,467798412,2),(1368,483526812,1),(1368,499248013,2),(1368,514976413,1),(1368,530697613,2),(1368,544611613,1),(1368,562147213,2),(1368,576061214,1),(1368,594201614,2),(1368,607510814,1),(1368,625651214,2),(1368,638960415,1),(1368,657100815,2),(1368,671014816,1),(1368,688550416,2),(1368,702464416,1),(1368,720000017,7),(1368,733910417,6),(1368,752050818,7),(1368,765360018,6),(1368,783500419,7),(1368,796809619,6),(1368,814950019,7),(1368,828864020,6),(1368,846399620,7),(1368,860313620,6),(1368,877849221,7),(1368,891763221,6),(1368,909298821,7),(1368,923212822,6),(1368,941353222,7),(1368,954662422,6),(1368,972802822,7),(1368,986112022,6),(1368,1004252422,7),(1368,1018166422,6),(1368,1035702022,7),(1368,1049616022,6),(1368,1067151622,7),(1368,1081065622,6),(1368,1099206022,7),(1368,1112515222,6),(1368,1130655622,7),(1368,1143964823,6),(1368,1162105223,7),(1368,1173600023,6),(1368,1194159623,7),(1368,1205049623,6),(1368,1225609223,7),(1368,1236499224,6),(1368,1257058824,7),(1368,1268553624,6),(1368,1289113224,7),(1368,1300003224,6),(1368,1320562824,7),(1368,1331452824,6),(1368,1352012425,7),(1368,1362902425,6),(1368,1383462025,7),(1368,1394352025,6),(1368,1414911625,7),(1368,1425801625,6),(1368,1446361226,7),(1368,1457856026,6),(1368,1478415626,7),(1368,1489305627,6),(1368,1509865227,7),(1368,1520755227,6),(1368,1541314827,7),(1368,1552204827,6),(1368,1572764427,7),(1368,1583654427,6),(1368,1604214027,7),(1368,1615708827,6),(1368,1636268427,7),(1368,1647158427,6),(1368,1667718027,7),(1368,1678608027,6),(1368,1699167627,7),(1368,1710057627,6),(1368,1730617227,7),(1368,1741507227,6),(1368,1762066827,7),(1368,1772956827,6),(1368,1793516427,7),(1368,1805011227,6),(1368,1825570827,7),(1368,1836460827,6),(1368,1857020427,7),(1368,1867910427,6),(1368,1888470027,7),(1368,1899360027,6),(1368,1919919627,7),(1368,1930809627,6),(1368,1951369227,7),(1368,1962864027,6),(1368,1983423627,7),(1368,1994313627,6),(1368,2014873227,7),(1368,2025763227,6),(1368,2046322827,7),(1368,2057212827,6),(1368,2077772427,7),(1368,2088662427,6),(1368,2109222027,7),(1368,2120112027,6),(1368,2140671627,7),(1369,-2147483648,5),(1369,-1633273200,1),(1369,-1615132800,2),(1369,-1601823600,1),(1369,-1583683200,2),(1369,-880210800,3),(1369,-769395600,4),(1369,-765388800,2),(1369,-84380400,1),(1369,-68659200,2),(1369,-52930800,1),(1369,-37209600,2),(1369,-21481200,1),(1369,-5760000,2),(1369,9968400,1),(1369,25689600,2),(1369,41418000,1),(1369,57744000,2),(1369,73472400,1),(1369,89193601,2),(1369,104922002,1),(1369,120643202,2),(1369,126694803,1),(1369,152092803,2),(1369,162378004,1),(1369,183542404,2),(1369,199270805,1),(1369,215596805,2),(1369,230720406,1),(1369,247046406,2),(1369,262774807,1),(1369,278496007,2),(1369,294224408,1),(1369,309945608,2),(1369,325674009,1),(1369,341395209,2),(1369,357123609,1),(1369,372844810,2),(1369,388573210,1),(1369,404899211,2),(1369,420022811,1),(1369,436348812,2),(1369,452077212,1),(1369,467798412,2),(1369,483526812,1),(1369,499248013,2),(1369,514976413,1),(1369,530697613,2),(1369,544611613,1),(1369,562147213,2),(1369,576061214,1),(1369,594201614,2),(1369,607510814,1),(1369,625651214,2),(1369,638960415,1),(1369,657100815,2),(1369,671014816,1),(1369,688550416,2),(1369,702464416,1),(1369,720000017,2),(1369,733914017,1),(1369,752054418,2),(1369,765363618,1),(1369,783504019,2),(1369,796813219,1),(1369,814953619,2),(1369,828867620,1),(1369,846403220,2),(1369,860317220,1),(1369,877852821,2),(1369,891766821,1),(1369,909302421,2),(1369,923216422,1),(1369,941356822,2),(1369,954666022,1),(1369,972806422,2),(1369,986115622,1),(1369,1004256022,2),(1369,1018170022,1),(1369,1035705622,2),(1369,1049619622,1),(1369,1067155222,7),(1369,1081065622,6),(1369,1099206022,7),(1369,1112515222,6),(1369,1130655622,7),(1369,1143964823,6),(1369,1162105223,7),(1369,1173600023,6),(1369,1194159623,7),(1369,1205049623,6),(1369,1225609223,7),(1369,1236499224,6),(1369,1257058824,7),(1369,1268553624,6),(1369,1289113224,7),(1369,1300003224,6),(1369,1320562824,7),(1369,1331452824,6),(1369,1352012425,7),(1369,1362902425,6),(1369,1383462025,7),(1369,1394352025,6),(1369,1414911625,7),(1369,1425801625,6),(1369,1446361226,7),(1369,1457856026,6),(1369,1478415626,7),(1369,1489305627,6),(1369,1509865227,7),(1369,1520755227,6),(1369,1541314827,7),(1369,1552204827,6),(1369,1572764427,7),(1369,1583654427,6),(1369,1604214027,7),(1369,1615708827,6),(1369,1636268427,7),(1369,1647158427,6),(1369,1667718027,7),(1369,1678608027,6),(1369,1699167627,7),(1369,1710057627,6),(1369,1730617227,7),(1369,1741507227,6),(1369,1762066827,7),(1369,1772956827,6),(1369,1793516427,7),(1369,1805011227,6),(1369,1825570827,7),(1369,1836460827,6),(1369,1857020427,7),(1369,1867910427,6),(1369,1888470027,7),(1369,1899360027,6),(1369,1919919627,7),(1369,1930809627,6),(1369,1951369227,7),(1369,1962864027,6),(1369,1983423627,7),(1369,1994313627,6),(1369,2014873227,7),(1369,2025763227,6),(1369,2046322827,7),(1369,2057212827,6),(1369,2077772427,7),(1369,2088662427,6),(1369,2109222027,7),(1369,2120112027,6),(1369,2140671627,7),(1370,-2147483648,0),(1370,-1686083584,1),(1370,323845209,4),(1370,338950809,2),(1370,354675609,3),(1370,370400410,2),(1370,386125210,3),(1370,401850011,2),(1370,417574811,3),(1370,433299612,2),(1370,449024412,3),(1370,465354012,2),(1370,481078812,3),(1370,496803613,2),(1370,512528413,3),(1370,528253213,2),(1370,543978013,3),(1370,559702813,2),(1370,575427614,3),(1370,591152414,2),(1370,606877214,3),(1370,622602014,2),(1370,638326815,3),(1370,654656415,2),(1370,670381216,3),(1370,686106016,2),(1370,701830816,3),(1370,717555617,2),(1370,733280417,3),(1370,749005218,2),(1370,764730018,3),(1370,780454819,2),(1370,796179619,3),(1370,811904419,2),(1370,828234020,3),(1370,846378020,2),(1370,859683620,3),(1370,877827621,2),(1370,891133221,3),(1370,909277221,2),(1370,922582822,3),(1370,941331622,2),(1370,954032422,3),(1370,972781222,2),(1370,985482022,3),(1370,1004230822,2),(1370,1017536422,3),(1370,1035680422,2),(1370,1048986022,3),(1370,1067130022,2),(1370,1080435622,3),(1370,1099184422,2),(1370,1111885222,3),(1370,1130634022,2),(1370,1143334823,3),(1370,1162083623,2),(1370,1174784423,3),(1370,1193533223,2),(1370,1206838823,3),(1370,1224982823,2),(1370,1238288424,3),(1370,1256432424,2),(1370,1269738024,3),(1370,1288486824,2),(1370,1301187624,3),(1370,1319936424,2),(1370,1332637224,3),(1370,1351386025,2),(1370,1364691625,3),(1370,1382835625,2),(1370,1396141225,3),(1370,1414285225,2),(1370,1427590825,3),(1370,1445734826,2),(1370,1459040426,3),(1370,1477789226,2),(1370,1490490027,3),(1370,1509238827,2),(1370,1521939627,3),(1370,1540688427,2),(1370,1553994027,3),(1370,1572138027,2),(1370,1585443627,3),(1370,1603587627,2),(1370,1616893227,3),(1370,1635642027,2),(1370,1648342827,3),(1370,1667091627,2),(1370,1679792427,3),(1370,1698541227,5),(1370,1711846827,6),(1370,1729990827,5),(1370,1743296427,6),(1370,1761440427,5),(1370,1774746027,6),(1370,1792890027,5),(1370,1806195627,6),(1370,1824944427,5),(1370,1837645227,6),(1370,1856394027,5),(1370,1869094827,6),(1370,1887843627,5),(1370,1901149227,6),(1370,1919293227,5),(1370,1932598827,6),(1370,1950742827,5),(1370,1964048427,6),(1370,1982797227,5),(1370,1995498027,6),(1370,2014246827,5),(1370,2026947627,6),(1370,2045696427,5),(1370,2058397227,6),(1370,2077146027,5),(1370,2090451627,6),(1370,2108595627,5),(1370,2121901227,6),(1370,2140045227,5),(1371,-2147483648,0),(1371,-1514739600,1),(1371,-1343066400,2),(1371,-1234807200,4),(1371,-1220292000,3),(1371,-1207159200,4),(1371,-1191344400,2),(1371,828864020,5),(1371,846399620,2),(1371,860313620,5),(1371,877849221,2),(1371,891766821,3),(1371,909302421,4),(1371,923216422,3),(1371,941356822,4),(1371,954666022,3),(1371,972806422,4),(1371,989139622,3),(1371,1001836822,4),(1371,1018170022,3),(1371,1035705622,4),(1371,1049619622,3),(1371,1067155222,4),(1371,1081069222,3),(1371,1099209622,4),(1371,1112518822,3),(1371,1130659222,4),(1371,1143968423,3),(1371,1162108823,4),(1371,1175418023,3),(1371,1193558423,4),(1371,1207472423,3),(1371,1225008023,4),(1371,1238922024,3),(1371,1256457624,4),(1371,1268557224,3),(1371,1289116824,4),(1371,1300006824,3),(1371,1320566424,4),(1371,1331456424,3),(1371,1352016025,4),(1371,1362906025,3),(1371,1383465625,4),(1371,1394355625,3),(1371,1414915225,4),(1371,1425805225,3),(1371,1446364826,4),(1371,1457859626,3),(1371,1478419226,4),(1371,1489309227,3),(1371,1509868827,4),(1371,1520758827,3),(1371,1541318427,4),(1371,1552208427,3),(1371,1572768027,4),(1371,1583658027,3),(1371,1604217627,4),(1371,1615712427,3),(1371,1636272027,4),(1371,1647162027,3),(1371,1667116827,2),(1371,1678608027,5),(1371,1699167627,2),(1371,1710057627,5),(1371,1730617227,2),(1371,1741507227,5),(1371,1762066827,2),(1371,1772956827,5),(1371,1793516427,2),(1371,1805011227,5),(1371,1825570827,2),(1371,1836460827,5),(1371,1857020427,2),(1371,1867910427,5),(1371,1888470027,2),(1371,1899360027,5),(1371,1919919627,2),(1371,1930809627,5),(1371,1951369227,2),(1371,1962864027,5),(1371,1983423627,2),(1371,1994313627,5),(1371,2014873227,2),(1371,2025763227,5),(1371,2046322827,2),(1371,2057212827,5),(1371,2077772427,2),(1371,2088662427,5),(1371,2109222027,2),(1371,2120112027,5),(1371,2140671627,2),(1372,-2147483648,1),(1372,-1946918424,2),(1373,-2147483648,0),(1373,-865296000,4),(1373,-769395600,1),(1373,-765396000,2),(1373,73465200,3),(1373,89186401,2),(1373,104914802,3),(1373,120636002,2),(1373,136364403,3),(1373,152085603,2),(1373,167814004,3),(1373,183535204,2),(1373,199263605,3),(1373,215589605,2),(1373,230713206,3),(1373,247039206,2),(1373,262767607,3),(1373,278488807,2),(1373,294217208,3),(1373,309938408,2),(1373,325666809,3),(1373,341388009,2),(1373,357116409,3),(1373,372837610,2),(1373,388566010,3),(1373,404892011,2),(1373,420015611,3),(1373,436341612,2),(1373,452070012,3),(1373,467791212,2),(1373,483519612,3),(1373,499240813,2),(1373,514969213,3),(1373,530690413,2),(1373,544604413,3),(1373,562140013,2),(1373,576054014,3),(1373,594194414,2),(1373,607503614,3),(1373,625644014,2),(1373,638953215,3),(1373,657093615,2),(1373,671007616,3),(1373,688543216,2),(1373,702457216,3),(1373,719992817,2),(1373,733906817,3),(1373,752047218,2),(1373,765356418,3),(1373,783496819,2),(1373,796806019,3),(1373,814946419,2),(1373,828860420,3),(1373,846396020,2),(1373,860310020,3),(1373,877845621,2),(1373,891759621,3),(1373,909295221,2),(1373,923209222,3),(1373,941349622,5),(1373,954662422,6),(1373,972802822,2),(1373,986108422,3),(1373,1004248822,2),(1373,1018162822,3),(1373,1035698422,2),(1373,1049612422,3),(1373,1067148022,2),(1373,1081062022,3),(1373,1099202422,2),(1373,1112511622,3),(1373,1130652022,2),(1373,1143961223,3),(1373,1162101623,2),(1373,1173596423,3),(1373,1194156023,2),(1373,1205046023,3),(1373,1225605623,2),(1373,1236495624,3),(1373,1257055224,2),(1373,1268550024,3),(1373,1289109624,2),(1373,1299999624,3),(1373,1320559224,2),(1373,1331449224,3),(1373,1352008825,2),(1373,1362898825,3),(1373,1383458425,2),(1373,1394348425,3),(1373,1414908025,2),(1373,1425798025,3),(1373,1446357626,2),(1373,1457852426,3),(1373,1478412026,2),(1373,1489302027,3),(1373,1509861627,2),(1373,1520751627,3),(1373,1541311227,2),(1373,1552201227,3),(1373,1572760827,2),(1373,1583650827,3),(1373,1604210427,2),(1373,1615705227,3),(1373,1636264827,2),(1373,1647154827,3),(1373,1667714427,2),(1373,1678604427,3),(1373,1699164027,2),(1373,1710054027,3),(1373,1730613627,2),(1373,1741503627,3),(1373,1762063227,2),(1373,1772953227,3),(1373,1793512827,2),(1373,1805007627,3),(1373,1825567227,2),(1373,1836457227,3),(1373,1857016827,2),(1373,1867906827,3),(1373,1888466427,2),(1373,1899356427,3),(1373,1919916027,2),(1373,1930806027,3),(1373,1951365627,2),(1373,1962860427,3),(1373,1983420027,2),(1373,1994310027,3),(1373,2014869627,2),(1373,2025759627,3),(1373,2046319227,2),(1373,2057209227,3),(1373,2077768827,2),(1373,2088658827,3),(1373,2109218427,2),(1373,2120108427,3),(1373,2140668027,2),(1374,-2147483648,0),(1374,-1861906760,1),(1374,-1104524348,2),(1374,-765317964,3),(1374,465449412,4),(1375,-2147483648,4),(1375,-1633273200,1),(1375,-1615132800,2),(1375,-1601823600,1),(1375,-1583683200,2),(1375,-880210800,3),(1375,-820519140,2),(1375,-812653140,3),(1375,-796845540,2),(1375,-84380400,1),(1375,-68659200,2),(1376,-2147483648,1),(1376,-1670483460,3),(1376,421218011,2),(1376,436334412,3),(1376,452062812,2),(1376,467784012,3),(1376,483512412,2),(1376,499233613,3),(1376,514962013,2),(1376,530683213,3),(1376,546411613,2),(1376,562132813,3),(1376,576050414,4),(1376,594194414,5),(1376,607500014,4),(1376,625644014,5),(1376,638949615,4),(1376,657093615,5),(1376,671004016,4),(1376,688543216,5),(1376,702453616,4),(1376,719992817,5),(1376,733903217,4),(1376,752047218,5),(1376,765352818,4),(1376,783496819,5),(1376,796802419,4),(1376,814946419,5),(1376,828856820,4),(1376,846396020,5),(1376,860306420,4),(1376,877845621,5),(1376,1112504422,2),(1376,1130644822,3),(1376,1143954023,2),(1376,1162094423,3),(1376,1331449224,2),(1376,1352008825,3),(1376,1362898825,2),(1376,1383458425,3),(1376,1394348425,2),(1376,1414908025,3),(1376,1425798025,2),(1376,1446357626,3),(1376,1489302027,2),(1376,1509861627,3),(1376,1520751627,2),(1376,1541311227,3),(1376,1552201227,2),(1376,1572760827,3),(1376,1583650827,2),(1376,1604210427,3),(1376,1615705227,2),(1376,1636264827,3),(1376,1647154827,2),(1376,1667714427,3),(1376,1678604427,2),(1376,1699164027,3),(1376,1710054027,2),(1376,1730613627,3),(1376,1741503627,2),(1376,1762063227,3),(1376,1772953227,2),(1376,1793512827,3),(1376,1805007627,2),(1376,1825567227,3),(1376,1836457227,2),(1376,1857016827,3),(1376,1867906827,2),(1376,1888466427,3),(1376,1899356427,2),(1376,1919916027,3),(1376,1930806027,2),(1376,1951365627,3),(1376,1962860427,2),(1376,1983420027,3),(1376,1994310027,2),(1376,2014869627,3),(1376,2025759627,2),(1376,2046319227,3),(1376,2057209227,2),(1376,2077768827,3),(1376,2088658827,2),(1376,2109218427,3),(1376,2120108427,2),(1376,2140668027,3),(1377,-2147483648,1),(1377,-873057600,3),(1377,-769395600,2),(1377,-765399600,1),(1378,-2147483648,0),(1378,-1767209328,2),(1378,-1206950400,1),(1378,-1191355200,2),(1378,-1175367600,1),(1378,-1159819200,2),(1378,-633812400,1),(1378,-622062000,2),(1378,-602276400,1),(1378,-591825600,2),(1378,-570740400,1),(1378,-560203200,2),(1378,-539118000,1),(1378,-531345600,2),(1378,-191358000,1),(1378,-184190400,2),(1378,-155156400,1),(1378,-150062400,2),(1378,-128890800,1),(1378,-121118400,2),(1378,-99946800,1),(1378,-89582400,2),(1378,-68410800,1),(1378,-57960000,2),(1378,499755613,1),(1378,511243213,2),(1378,530600413,1),(1378,540273613,2),(1378,562136413,1),(1378,571204814,2),(1378,1214283623,3),(1378,1384056025,2),(1379,-2147483648,0),(1379,-1767210264,2),(1379,-1206954000,1),(1379,-1191358800,2),(1379,-1175371200,1),(1379,-1159822800,2),(1379,-633816000,1),(1379,-622065600,2),(1379,-602280000,1),(1379,-591829200,2),(1379,-570744000,1),(1379,-560206800,2),(1379,-539121600,1),(1379,-531349200,2),(1379,-191361600,1),(1379,-184194000,2),(1379,-155160000,1),(1379,-150066000,2),(1379,-128894400,1),(1379,-121122000,2),(1379,-99950400,1),(1379,-89586000,2),(1379,-68414400,1),(1379,-57963600,2),(1379,499752013,1),(1379,511239613,2),(1379,530596813,1),(1379,540270013,2),(1379,562132813,1),(1379,571201214,2),(1380,-2147483648,1),(1380,-873057600,3),(1380,-769395600,2),(1380,-765399600,1),(1381,-2147483648,1),(1381,-1892661435,2),(1381,-1688410800,1),(1381,-1619205435,3),(1381,-1593806400,1),(1381,-1335986235,4),(1381,-1317585600,2),(1381,-1304362800,4),(1381,-1286049600,2),(1381,-1272826800,4),(1381,-1254513600,2),(1381,-1241290800,4),(1381,-1222977600,2),(1381,-1209754800,4),(1381,-1191355200,2),(1381,-1178132400,3),(1381,-870552000,2),(1381,-865278000,3),(1381,-736632000,4),(1381,-718056000,2),(1381,-713649600,3),(1381,-36619200,5),(1381,-23922000,6),(1381,-3355200,5),(1381,7527600,6),(1381,24465600,5),(1381,37767600,6),(1381,55915200,5),(1381,69217200,6),(1381,87969601,5),(1381,100666802,6),(1381,118209602,5),(1381,132116403,6),(1381,150868803,5),(1381,163566004,6),(1381,182318404,5),(1381,195620405,6),(1381,213768005,5),(1381,227070006,6),(1381,245217606,5),(1381,258519607,6),(1381,277272007,5),(1381,289969208,6),(1381,308721608,5),(1381,321418809,6),(1381,340171209,5),(1381,353473209,6),(1381,371620810,5),(1381,384922810,6),(1381,403070411,5),(1381,416372411,6),(1381,434520012,5),(1381,447822012,6),(1381,466574412,5),(1381,479271612,6),(1381,498024013,5),(1381,510721213,6),(1381,529473613,5),(1381,545194813,6),(1381,560923213,5),(1381,574225214,6),(1381,592372814,5),(1381,605674814,6),(1381,624427214,5),(1381,637124415,6),(1381,653457615,5),(1381,668574016,6),(1381,687326416,5),(1381,700628416,6),(1381,718776017,5),(1381,732078017,6),(1381,750225618,5),(1381,763527618,6),(1381,781675219,5),(1381,794977219,6),(1381,813729619,5),(1381,826426820,6),(1381,845179220,5),(1381,859690820,6),(1381,876628821,5),(1381,889930821,6),(1381,906868821,5),(1381,923194822,6),(1381,939528022,5),(1381,952830022,6),(1381,971582422,5),(1381,984279622,6),(1381,1003032022,5),(1381,1015729222,6),(1381,1034481622,5),(1381,1047178822,6),(1381,1065931222,5),(1381,1079233222,6),(1381,1097380822,5),(1381,1110682822,6),(1381,1128830422,5),(1381,1142132423,6),(1381,1160884823,5),(1381,1173582023,6),(1381,1192334423,5),(1381,1206846023,6),(1381,1223784023,5),(1381,1237086024,6),(1381,1255233624,5),(1381,1270350024,6),(1381,1286683224,5),(1381,1304823624,6),(1381,1313899224,5),(1381,1335668424,6),(1381,1346558425,5),(1381,1367118025,6),(1381,1378612825,5),(1381,1398567625,6),(1381,1410062425,5),(1381,1463281226,6),(1381,1471147226,5),(1381,1480820426,7),(1382,-2147483648,2),(1382,-1694368800,1),(1382,-1681671600,2),(1382,-1632067200,1),(1382,-1615136400,2),(1382,-1029686400,1),(1382,-1018198800,2),(1382,-880214400,3),(1382,-769395600,4),(1382,-765392400,2),(1382,-746035200,1),(1382,-732733200,2),(1382,-715795200,1),(1382,-702493200,2),(1382,-684345600,1),(1382,-671043600,2),(1382,-652896000,1),(1382,-639594000,2),(1382,-620755200,1),(1382,-607626000,2),(1382,-589392000,1),(1382,-576090000,2),(1382,-557942400,1),(1382,-544640400,2),(1382,-526492800,1),(1382,-513190800,2),(1382,-495043200,1),(1382,-481741200,2),(1382,-463593600,1),(1382,-450291600,2),(1382,-431539200,1),(1382,-418237200,2),(1382,-400089600,1),(1382,-386787600,2),(1382,-368640000,1),(1382,-355338000,2),(1382,-337190400,1),(1382,-321469200,2),(1382,-305740800,1),(1382,-292438800,2),(1382,-210787200,1),(1382,-198090000,2),(1382,-116438400,5),(1382,-100108800,6),(1382,-84384000,5),(1382,-68659200,6),(1382,-52934400,5),(1382,-37209600,6),(1382,-21484800,5),(1382,-5760000,6),(1382,9964800,5),(1382,25689600,6),(1382,41414400,5),(1382,57744000,6),(1382,73468800,5),(1382,89193601,6),(1382,104918402,5),(1382,120643202,6),(1382,136368003,5),(1382,152092803,6),(1382,167817604,5),(1382,183542404,6),(1382,199267205,5),(1382,215596805,6),(1382,230716806,5),(1382,247046406,6),(1382,262771207,5),(1382,278496007,6),(1382,294220808,5),(1382,309945608,6),(1382,325670409,5),(1382,341395209,6),(1382,357120009,5),(1382,372844810,6),(1382,388569610,5),(1382,404899211,6),(1382,420019211,5),(1382,436348812,6),(1382,452073612,5),(1382,467798412,6),(1382,483523212,5),(1382,499248013,6),(1382,514972813,5),(1382,530697613,6),(1382,544608013,5),(1382,562147213,6),(1382,576057614,5),(1382,594201614,6),(1382,607507214,5),(1382,625651214,6),(1382,638956815,5),(1382,657100815,6),(1382,671011216,5),(1382,688550416,6),(1382,702460816,5),(1382,720000017,6),(1382,733910417,5),(1382,752054418,6),(1382,765360018,5),(1382,783504019,6),(1382,796809619,5),(1382,814953619,6),(1382,828864020,5),(1382,846403220,6),(1382,860313620,5),(1382,877852821,6),(1382,891763221,5),(1382,909302421,6),(1382,923212822,5),(1382,941356822,6),(1382,954662422,5),(1382,972806422,6),(1382,986112022,5),(1382,1004256022,6),(1382,1018166422,5),(1382,1035705622,6),(1382,1049616022,5),(1382,1067155222,6),(1382,1081065622,5),(1382,1099209622,6),(1382,1112515222,5),(1382,1130659222,6),(1382,1136095223,2),(1382,1143964823,1),(1382,1162105223,2),(1382,1173600023,1),(1382,1194159623,2),(1382,1205049623,1),(1382,1225609223,2),(1382,1236499224,1),(1382,1257058824,2),(1382,1268553624,1),(1382,1289113224,2),(1382,1300003224,1),(1382,1320562824,2),(1382,1331452824,1),(1382,1352012425,2),(1382,1362902425,1),(1382,1383462025,2),(1382,1394352025,1),(1382,1414911625,2),(1382,1425801625,1),(1382,1446361226,2),(1382,1457856026,1),(1382,1478415626,2),(1382,1489305627,1),(1382,1509865227,2),(1382,1520755227,1),(1382,1541314827,2),(1382,1552204827,1),(1382,1572764427,2),(1382,1583654427,1),(1382,1604214027,2),(1382,1615708827,1),(1382,1636268427,2),(1382,1647158427,1),(1382,1667718027,2),(1382,1678608027,1),(1382,1699167627,2),(1382,1710057627,1),(1382,1730617227,2),(1382,1741507227,1),(1382,1762066827,2),(1382,1772956827,1),(1382,1793516427,2),(1382,1805011227,1),(1382,1825570827,2),(1382,1836460827,1),(1382,1857020427,2),(1382,1867910427,1),(1382,1888470027,2),(1382,1899360027,1),(1382,1919919627,2),(1382,1930809627,1),(1382,1951369227,2),(1382,1962864027,1),(1382,1983423627,2),(1382,1994313627,1),(1382,2014873227,2),(1382,2025763227,1),(1382,2046322827,2),(1382,2057212827,1),(1382,2077772427,2),(1382,2088662427,1),(1382,2109222027,2),(1382,2120112027,1),(1382,2140671627,2),(1383,-2147483648,0),(1383,-410227200,2),(1383,73468800,1),(1383,89190001,2),(1383,104918402,1),(1383,120639602,2),(1383,136368003,1),(1383,152089203,2),(1383,167817604,1),(1383,183538804,2),(1383,199267205,1),(1383,215593205,2),(1383,230716806,1),(1383,247042806,2),(1383,262771207,1),(1383,278492407,2),(1383,294220808,1),(1383,309942008,2),(1383,325670409,1),(1383,341391609,2),(1383,357120009,1),(1383,372841210,2),(1383,388569610,1),(1383,404895611,2),(1383,420019211,1),(1383,436345212,2),(1383,452073612,1),(1383,467794812,2),(1383,483523212,1),(1383,499244413,2),(1383,514972813,1),(1383,530694013,2),(1383,544608013,1),(1383,562143613,2),(1383,576057614,1),(1383,594198014,2),(1383,607507214,1),(1383,625647614,2),(1383,638956815,1),(1383,657097215,2),(1383,671011216,1),(1383,688546816,2),(1383,702460816,1),(1383,719996417,2),(1383,733910417,1),(1383,752050818,2),(1383,765360018,1),(1383,783500419,2),(1383,796809619,1),(1383,814950019,2),(1383,828864020,1),(1383,846399620,2),(1383,860313620,1),(1383,877849221,2),(1383,891763221,1),(1383,909298821,2),(1383,923212822,1),(1383,941353222,2),(1383,954662422,1),(1383,972802822,3),(1383,986112022,1),(1383,1004252422,2),(1383,1018166422,1),(1383,1035702022,2),(1383,1049616022,1),(1383,1067151622,2),(1383,1081065622,1),(1383,1099206022,2),(1383,1112515222,1),(1383,1130655622,2),(1383,1143964823,1),(1383,1162105223,2),(1383,1173600023,1),(1383,1194159623,2),(1383,1205049623,1),(1383,1225609223,2),(1383,1236499224,1),(1383,1257058824,2),(1383,1268553624,1),(1383,1289113224,2),(1383,1300003224,1),(1383,1320562824,2),(1383,1331452824,1),(1383,1352012425,2),(1383,1362902425,1),(1383,1383462025,2),(1383,1394352025,1),(1383,1414911625,2),(1383,1425801625,1),(1383,1446361226,2),(1383,1457856026,1),(1383,1478415626,2),(1383,1489305627,1),(1383,1509865227,2),(1383,1520755227,1),(1383,1541314827,2),(1383,1552204827,1),(1383,1572764427,2),(1383,1583654427,1),(1383,1604214027,2),(1383,1615708827,1),(1383,1636268427,2),(1383,1647158427,1),(1383,1667718027,2),(1383,1678608027,1),(1383,1699167627,2),(1383,1710057627,1),(1383,1730617227,2),(1383,1741507227,1),(1383,1762066827,2),(1383,1772956827,1),(1383,1793516427,2),(1383,1805011227,1),(1383,1825570827,2),(1383,1836460827,1),(1383,1857020427,2),(1383,1867910427,1),(1383,1888470027,2),(1383,1899360027,1),(1383,1919919627,2),(1383,1930809627,1),(1383,1951369227,2),(1383,1962864027,1),(1383,1983423627,2),(1383,1994313627,1),(1383,2014873227,2),(1383,2025763227,1),(1383,2046322827,2),(1383,2057212827,1),(1383,2077772427,2),(1383,2088662427,1),(1383,2109222027,2),(1383,2120112027,1),(1383,2140671627,2),(1384,-2147483648,0),(1384,-1767217224,2),(1384,-1206957600,1),(1384,-1191362400,2),(1384,-1175374800,1),(1384,-1159826400,2),(1384,-633819600,1),(1384,-622069200,2),(1384,-602283600,1),(1384,-591832800,2),(1384,-570747600,1),(1384,-560210400,2),(1384,-539125200,1),(1384,-531352800,2),(1384,-191365200,1),(1384,-184197600,2),(1384,-155163600,1),(1384,-150069600,2),(1384,-128898000,1),(1384,-121125600,2),(1384,-99954000,1),(1384,-89589600,2),(1384,-68418000,1),(1384,-57967200,2),(1384,499748413,1),(1384,511236013,2),(1384,530593213,1),(1384,540266413,2),(1384,562129213,1),(1384,571197614,2),(1384,592974014,1),(1384,602042414,2),(1384,624423614,1),(1384,634701615,2),(1384,938919622,1),(1384,951616822,2),(1384,970974022,1),(1384,971575222,2),(1384,1003028422,1),(1384,1013911222,2),(1385,-2147483648,0),(1385,-2030202084,2),(1385,-1632063600,1),(1385,-1615132800,2),(1385,-1251651600,1),(1385,-1238349600,2),(1385,-1220202000,1),(1385,-1206900000,2),(1385,-1188752400,1),(1385,-1175450400,2),(1385,-1156698000,1),(1385,-1144000800,2),(1385,-1125248400,1),(1385,-1111946400,2),(1385,-1032714000,1),(1385,-1016992800,2),(1385,-1001264400,1),(1385,-986148000,2),(1385,-969814800,1),(1385,-954093600,2),(1385,-937760400,1),(1385,-922039200,2),(1385,-906310800,1),(1385,-890589600,2),(1385,-880210800,3),(1385,-769395600,4),(1385,-765388800,2),(1385,-748450800,1),(1385,-732729600,2),(1385,-715791600,1),(1385,-702489600,2),(1385,-684342000,1),(1385,-671040000,2),(1385,-652892400,1),(1385,-639590400,2),(1385,-620838000,1),(1385,-608140800,2),(1385,-589388400,1),(1385,-576086400,2),(1385,-557938800,1),(1385,-544636800,2),(1385,-526489200,1),(1385,-513187200,2),(1385,-495039600,1),(1385,-481737600,2),(1385,-463590000,1),(1385,-450288000,2),(1385,-431535600,1),(1385,-418233600,2),(1385,-400086000,1),(1385,-386784000,2),(1385,-337186800,1),(1385,-321465600,2),(1385,-305737200,5),(1386,-2147483648,0),(1386,-704937600,2),(1386,73468800,1),(1386,89190001,2),(1386,104918402,1),(1386,120639602,2),(1386,136368003,1),(1386,152089203,2),(1386,167817604,1),(1386,183538804,2),(1386,199267205,1),(1386,215593205,2),(1386,230716806,1),(1386,247042806,2),(1386,262771207,1),(1386,278492407,2),(1386,294220808,1),(1386,309942008,2),(1386,325670409,1),(1386,341391609,2),(1386,357120009,1),(1386,372841210,2),(1386,388569610,1),(1386,404895611,2),(1386,420019211,1),(1386,436345212,2),(1386,452073612,1),(1386,467794812,2),(1386,483523212,1),(1386,499244413,2),(1386,514972813,1),(1386,530694013,2),(1386,544608013,1),(1386,562143613,2),(1386,576057614,1),(1386,594198014,2),(1386,607507214,1),(1386,625647614,2),(1386,638956815,1),(1386,657097215,2),(1386,671011216,1),(1386,688546816,2),(1386,702460816,1),(1386,719996417,2),(1386,733910417,1),(1386,752050818,2),(1386,765360018,1),(1386,783500419,2),(1386,796809619,1),(1386,814950019,2),(1386,828864020,1),(1386,846399620,2),(1386,860313620,1),(1386,877849221,2),(1386,891763221,1),(1386,909298821,2),(1386,923212822,1),(1386,941353222,2),(1386,954662422,1),(1386,972802822,3),(1386,986112022,1),(1386,1004252422,2),(1386,1018166422,1),(1386,1035702022,2),(1386,1049616022,1),(1386,1067151622,2),(1386,1081065622,1),(1386,1099206022,2),(1386,1112515222,1),(1386,1130655622,2),(1386,1143964823,1),(1386,1162105223,3),(1386,1173600023,1),(1386,1194159623,2),(1386,1205049623,1),(1386,1225609223,2),(1386,1236499224,1),(1386,1257058824,2),(1386,1268553624,1),(1386,1289113224,2),(1386,1300003224,1),(1386,1320562824,2),(1386,1331452824,1),(1386,1352012425,2),(1386,1362902425,1),(1386,1383462025,2),(1386,1394352025,1),(1386,1414911625,2),(1386,1425801625,1),(1386,1446361226,2),(1386,1457856026,1),(1386,1478415626,2),(1386,1489305627,1),(1386,1509865227,2),(1386,1520755227,1),(1386,1541314827,2),(1386,1552204827,1),(1386,1572764427,2),(1386,1583654427,1),(1386,1604214027,2),(1386,1615708827,1),(1386,1636268427,2),(1386,1647158427,1),(1386,1667718027,2),(1386,1678608027,1),(1386,1699167627,2),(1386,1710057627,1),(1386,1730617227,2),(1386,1741507227,1),(1386,1762066827,2),(1386,1772956827,1),(1386,1793516427,2),(1386,1805011227,1),(1386,1825570827,2),(1386,1836460827,1),(1386,1857020427,2),(1386,1867910427,1),(1386,1888470027,2),(1386,1899360027,1),(1386,1919919627,2),(1386,1930809627,1),(1386,1951369227,2),(1386,1962864027,1),(1386,1983423627,2),(1386,1994313627,1),(1386,2014873227,2),(1386,2025763227,1),(1386,2046322827,2),(1386,2057212827,1),(1386,2077772427,2),(1386,2088662427,1),(1386,2109222027,2),(1386,2120112027,1),(1386,2140671627,2),(1387,-2147483648,0),(1387,-1767209328,2),(1387,-1206950400,1),(1387,-1191355200,2),(1387,-1175367600,1),(1387,-1159819200,2),(1387,-633812400,1),(1387,-622062000,2),(1387,-602276400,1),(1387,-591825600,2),(1387,-570740400,1),(1387,-560203200,2),(1387,-539118000,1),(1387,-531345600,2),(1387,-191358000,1),(1387,-184190400,2),(1387,-155156400,1),(1387,-150062400,2),(1387,-128890800,1),(1387,-121118400,2),(1387,-99946800,1),(1387,-89582400,2),(1387,-68410800,1),(1387,-57960000,2),(1387,499755613,1),(1387,511243213,2),(1387,530600413,1),(1387,540273613,2),(1387,562136413,1),(1387,571204814,2),(1387,1214283623,3),(1387,1384056025,2),(1388,-2147483648,1),(1388,-1567453392,2),(1388,-1233432000,3),(1388,-1222981200,2),(1388,-1205956800,3),(1388,-1194037200,2),(1388,-1172865600,3),(1388,-1162501200,2),(1388,-1141329600,3),(1388,-1130965200,2),(1388,-1109793600,3),(1388,-1099429200,2),(1388,-1078257600,3),(1388,-1067806800,2),(1388,-1046635200,3),(1388,-1036270800,2),(1388,-1015099200,3),(1388,-1004734800,2),(1388,-983563200,3),(1388,-973198800,2),(1388,-952027200,3),(1388,-941576400,2),(1388,-931032000,3),(1388,-900882000,2),(1388,-890337600,3),(1388,-833749200,2),(1388,-827265600,3),(1388,-752274000,2),(1388,-733780800,3),(1388,-197326800,2),(1388,-190843200,3),(1388,-184194000,2),(1388,-164491200,3),(1388,-152658000,2),(1388,-132955200,3),(1388,-121122000,2),(1388,-101419200,3),(1388,-86821200,2),(1388,-71092800,3),(1388,-54766800,2),(1388,-39038400,3),(1388,-23317200,2),(1388,-7588800,5),(1388,128142003,4),(1388,136605603,5),(1388,596948414,4),(1388,605066414,5),(1388,624423614,4),(1388,636516015,5),(1388,656478015,4),(1388,667965616,2),(1388,687931216,4),(1388,699415216,5),(1388,719377217,4),(1388,731469617,5),(1388,938919622,3),(1388,952052422,5),(1388,1198983623,4),(1388,1205632823,5),(1388,1224385223,4),(1388,1237082424,5),(1389,-2147483648,0),(1389,-1514739600,1),(1389,-1451667600,2),(1389,-1343062800,3),(1389,-1234803600,2),(1389,-1222963200,4),(1389,-1207242000,2),(1389,-873820800,5),(1389,-769395600,6),(1389,-761677200,2),(1389,-686073600,4),(1389,-661539600,2),(1389,-495039600,4),(1389,-481734000,2),(1389,-463590000,4),(1389,-450284400,2),(1389,-431535600,4),(1389,-418230000,2),(1389,-400086000,4),(1389,-386780400,2),(1389,-368636400,4),(1389,-355330800,2),(1389,-337186800,4),(1389,-323881200,2),(1389,-305737200,4),(1389,-292431600,2),(1389,199274405,4),(1389,215600405,2),(1389,230724006,4),(1389,247050006,2),(1389,262778407,4),(1389,278499607,2),(1389,294228008,4),(1389,309949208,2),(1389,325677609,4),(1389,341398809,2),(1389,357127209,4),(1389,372848410,2),(1389,388576810,4),(1389,404902811,2),(1389,420026411,4),(1389,436352412,2),(1389,452080812,4),(1389,467802012,2),(1389,483530412,4),(1389,499251613,2),(1389,514980013,4),(1389,530701213,2),(1389,544615213,4),(1389,562150813,2),(1389,576064814,4),(1389,594205214,2),(1389,607514414,4),(1389,625654814,2),(1389,638964015,4),(1389,657104415,2),(1389,671018416,4),(1389,688554016,2),(1389,702468016,4),(1389,720003617,2),(1389,733917617,4),(1389,752058018,2),(1389,765367218,4),(1389,783507619,2),(1389,796816819,4),(1389,814957219,2),(1389,828871220,4),(1389,846406820,2),(1389,860320820,4),(1389,877856421,2),(1389,891770421,4),(1389,909306021,2),(1389,923220022,4),(1389,941360422,2),(1389,954669622,4),(1389,972810022,2),(1389,986119222,4),(1389,1004259622,2),(1389,1018173622,4),(1389,1035709222,2),(1389,1049623222,4),(1389,1067158822,2),(1389,1081072822,4),(1389,1099213222,2),(1389,1112522422,4),(1389,1130662822,2),(1389,1143972023,4),(1389,1162112423,2),(1389,1175421623,4),(1389,1193562023,2),(1389,1207476023,4),(1389,1225011623,2),(1389,1238925624,4),(1389,1256461224,2),(1389,1268560824,4),(1389,1289120424,2),(1389,1300010424,4),(1389,1320570024,2),(1389,1331460024,4),(1389,1352019625,2),(1389,1362909625,4),(1389,1383469225,2),(1389,1394359225,4),(1389,1414918825,2),(1389,1425808825,4),(1389,1446368426,2),(1389,1457863226,4),(1389,1478422826,2),(1389,1489312827,4),(1389,1509872427,2),(1389,1520762427,4),(1389,1541322027,2),(1389,1552212027,4),(1389,1572771627,2),(1389,1583661627,4),(1389,1604221227,2),(1389,1615716027,4),(1389,1636275627,2),(1389,1647165627,4),(1389,1667725227,2),(1389,1678615227,4),(1389,1699174827,2),(1389,1710064827,4),(1389,1730624427,2),(1389,1741514427,4),(1389,1762074027,2),(1389,1772964027,4),(1389,1793523627,2),(1389,1805018427,4),(1389,1825578027,2),(1389,1836468027,4),(1389,1857027627,2),(1389,1867917627,4),(1389,1888477227,2),(1389,1899367227,4),(1389,1919926827,2),(1389,1930816827,4),(1389,1951376427,2),(1389,1962871227,4),(1389,1983430827,2),(1389,1994320827,4),(1389,2014880427,2),(1389,2025770427,4),(1389,2046330027,2),(1389,2057220027,4),(1389,2077779627,2),(1389,2088669627,4),(1389,2109229227,2),(1389,2120119227,4),(1389,2140678827,2),(1390,-2147483648,0),(1390,-1767212472,2),(1390,-1206954000,1),(1390,-1191358800,2),(1390,-1175371200,1),(1390,-1159822800,2),(1390,-633816000,1),(1390,-622065600,2),(1390,-602280000,1),(1390,-591829200,2),(1390,-570744000,1),(1390,-560206800,2),(1390,-539121600,1),(1390,-531349200,2),(1390,-191361600,1),(1390,-184194000,2),(1390,-155160000,1),(1390,-150066000,2),(1390,-128894400,1),(1390,-121122000,2),(1390,-99950400,1),(1390,-89586000,2),(1390,-68414400,1),(1390,-57963600,2),(1390,499752013,1),(1390,511239613,2),(1390,530596813,1),(1390,540270013,2),(1390,562132813,1),(1390,571201214,2),(1390,1214280023,3),(1391,-2147483648,1),(1391,-1892661435,2),(1391,-1688410800,1),(1391,-1619205435,3),(1391,-1593806400,1),(1391,-1335986235,4),(1391,-1317585600,2),(1391,-1304362800,4),(1391,-1286049600,2),(1391,-1272826800,4),(1391,-1254513600,2),(1391,-1241290800,4),(1391,-1222977600,2),(1391,-1209754800,4),(1391,-1191355200,2),(1391,-1178132400,3),(1391,-870552000,2),(1391,-865278000,3),(1391,-740520000,5),(1391,-736635600,4),(1391,-718056000,2),(1391,-713649600,3),(1391,-36619200,6),(1391,-23922000,7),(1391,-3355200,6),(1391,7527600,7),(1391,24465600,6),(1391,37767600,7),(1391,55915200,6),(1391,69217200,7),(1391,87969601,6),(1391,100666802,7),(1391,118209602,6),(1391,132116403,7),(1391,150868803,6),(1391,163566004,7),(1391,182318404,6),(1391,195620405,7),(1391,213768005,6),(1391,227070006,7),(1391,245217606,6),(1391,258519607,7),(1391,277272007,6),(1391,289969208,7),(1391,308721608,6),(1391,321418809,7),(1391,340171209,6),(1391,353473209,7),(1391,371620810,6),(1391,384922810,7),(1391,403070411,6),(1391,416372411,7),(1391,434520012,6),(1391,447822012,7),(1391,466574412,6),(1391,479271612,7),(1391,498024013,6),(1391,510721213,7),(1391,529473613,6),(1391,545194813,7),(1391,560923213,6),(1391,574225214,7),(1391,592372814,6),(1391,605674814,7),(1391,624427214,6),(1391,637124415,7),(1391,653457615,6),(1391,668574016,7),(1391,687326416,6),(1391,700628416,7),(1391,718776017,6),(1391,732078017,7),(1391,750225618,6),(1391,763527618,7),(1391,781675219,6),(1391,794977219,7),(1391,813729619,6),(1391,826426820,7),(1391,845179220,6),(1391,859690820,7),(1391,876628821,6),(1391,889930821,7),(1391,906868821,6),(1391,923194822,7),(1391,939528022,6),(1391,952830022,7),(1391,971582422,6),(1391,984279622,7),(1391,1003032022,6),(1391,1015729222,7),(1391,1034481622,6),(1391,1047178822,7),(1391,1065931222,6),(1391,1079233222,7),(1391,1097380822,6),(1391,1110682822,7),(1391,1128830422,6),(1391,1142132423,7),(1391,1160884823,6),(1391,1173582023,7),(1391,1192334423,6),(1391,1206846023,7),(1391,1223784023,6),(1391,1237086024,7),(1391,1255233624,6),(1391,1270350024,7),(1391,1286683224,6),(1391,1304823624,7),(1391,1313899224,6),(1391,1335668424,7),(1391,1346558425,6),(1391,1367118025,7),(1391,1378612825,6),(1391,1398567625,7),(1391,1410062425,6),(1391,1463281226,7),(1391,1471147226,6),(1391,1494730827,7),(1391,1502596827,6),(1391,1526180427,7),(1391,1534046427,6),(1391,1554606027,7),(1391,1567915227,6),(1391,1586055627,7),(1391,1599364827,6),(1391,1617505227,7),(1391,1630814427,6),(1391,1648954827,7),(1391,1662868827,6),(1391,1680404427,7),(1391,1693713627,6),(1391,1712458827,7),(1391,1725768027,6),(1391,1743908427,7),(1391,1757217627,6),(1391,1775358027,7),(1391,1788667227,6),(1391,1806807627,7),(1391,1820116827,6),(1391,1838257227,7),(1391,1851566427,6),(1391,1870311627,7),(1391,1883016027,6),(1391,1901761227,7),(1391,1915070427,6),(1391,1933210827,7),(1391,1946520027,6),(1391,1964660427,7),(1391,1977969627,6),(1391,1996110027,7),(1391,2009419227,6),(1391,2027559627,7),(1391,2040868827,6),(1391,2059614027,7),(1391,2072318427,6),(1391,2091063627,7),(1391,2104372827,6),(1391,2122513227,7),(1391,2135822427,6),(1392,-2147483648,1),(1392,-1159773600,3),(1392,-100119600,2),(1392,-89668800,3),(1392,-5770800,4),(1392,4422600,3),(1392,25678800,4),(1392,33193800,3),(1392,57733200,4),(1392,64816200,3),(1392,89182801,4),(1392,96438602,3),(1392,120632402,4),(1392,127974603,3),(1392,152082003,5),(1392,972799222,3),(1392,975823222,5),(1393,-2147483648,0),(1393,-1767214412,2),(1393,-1206957600,1),(1393,-1191362400,2),(1393,-1175374800,1),(1393,-1159826400,2),(1393,-633819600,1),(1393,-622069200,2),(1393,-602283600,1),(1393,-591832800,2),(1393,-570747600,1),(1393,-560210400,2),(1393,-539125200,1),(1393,-531352800,2),(1393,-195426000,1),(1393,-184197600,2),(1393,-155163600,1),(1393,-150069600,2),(1393,-128898000,1),(1393,-121125600,2),(1393,-99954000,1),(1393,-89589600,2),(1393,-68418000,1),(1393,-57967200,2),(1393,499748413,1),(1393,511236013,2),(1393,530593213,1),(1393,540266413,2),(1393,562129213,1),(1393,571197614,2),(1393,592974014,1),(1393,602042414,2),(1393,624423614,1),(1393,634701615,2),(1393,656478015,1),(1393,666756016,2),(1393,687927616,1),(1393,697600816,2),(1393,719982017,1),(1393,728445617,2),(1393,750826818,1),(1393,761709618,2),(1393,782276419,1),(1393,793159219,2),(1393,813726019,1),(1393,824004020,2),(1393,844570820,1),(1393,856058420,2),(1393,876106821,1),(1393,888717621,2),(1393,908074821,1),(1393,919562422,2),(1393,938919622,1),(1393,951616822,2),(1393,970974022,1),(1393,982461622,2),(1393,1003028422,1),(1393,1013911222,2),(1393,1036292422,1),(1393,1045360822,2),(1393,1066532422,1),(1393,1076810422,2),(1393,1099364422,1),(1393,1108864822,2),(1393,1129431622,1),(1393,1140314423,2),(1393,1162695623,1),(1393,1172368823,2),(1393,1192330823,1),(1393,1203213623,2),(1393,1224385223,1),(1393,1234663224,2),(1393,1255834824,1),(1393,1266717624,2),(1393,1287284424,1),(1393,1298167224,2),(1393,1318734024,1),(1393,1330221624,2),(1393,1350788425,1),(1393,1361066425,2),(1393,1382238025,1),(1393,1392516025,2),(1393,1413687625,1),(1393,1424570425,2),(1393,1445137226,1),(1393,1456020026,2),(1393,1476586826,1),(1393,1487469627,2),(1393,1508036427,1),(1393,1518919227,2),(1393,1541300427,1),(1393,1550368827,2),(1394,-2147483648,0),(1394,-1686090728,1),(1394,323841609,2),(1394,338961609,3),(1394,354679209,6),(1394,370400410,4),(1394,386125210,5),(1394,401850011,4),(1394,417574811,5),(1394,433299612,4),(1394,449024412,5),(1394,465354012,4),(1394,481078812,5),(1394,496803613,4),(1394,512528413,5),(1394,528253213,4),(1394,543978013,5),(1394,559702813,4),(1394,575427614,5),(1394,591152414,4),(1394,606877214,5),(1394,622602014,4),(1394,638326815,5),(1394,654656415,4),(1394,670381216,5),(1394,686106016,4),(1394,701830816,5),(1394,717555617,4),(1394,733280417,5),(1394,749005218,4),(1394,764730018,5),(1394,780454819,4),(1394,796179619,5),(1394,811904419,4),(1394,828234020,5),(1394,846378020,4),(1394,859683620,5),(1394,877827621,4),(1394,891133221,5),(1394,909277221,4),(1394,922582822,5),(1394,941331622,4),(1394,954032422,5),(1394,972781222,4),(1394,985482022,5),(1394,1004230822,4),(1394,1017536422,5),(1394,1035680422,4),(1394,1048986022,5),(1394,1067130022,4),(1394,1080435622,5),(1394,1099184422,4),(1394,1111885222,5),(1394,1130634022,4),(1394,1143334823,5),(1394,1162083623,4),(1394,1174784423,5),(1394,1193533223,4),(1394,1206838823,5),(1394,1224982823,4),(1394,1238288424,5),(1394,1256432424,4),(1394,1269738024,5),(1394,1288486824,4),(1394,1301187624,5),(1394,1319936424,4),(1394,1332637224,5),(1394,1351386025,4),(1394,1364691625,5),(1394,1382835625,4),(1394,1396141225,5),(1394,1414285225,4),(1394,1427590825,5),(1394,1445734826,4),(1394,1459040426,5),(1394,1477789226,4),(1394,1490490027,5),(1394,1509238827,4),(1394,1521939627,5),(1394,1540688427,4),(1394,1553994027,5),(1394,1572138027,4),(1394,1585443627,5),(1394,1603587627,4),(1394,1616893227,5),(1394,1635642027,4),(1394,1648342827,5),(1394,1667091627,4),(1394,1679792427,5),(1394,1698541227,4),(1394,1711846827,5),(1394,1729990827,4),(1394,1743296427,5),(1394,1761440427,4),(1394,1774746027,5),(1394,1792890027,4),(1394,1806195627,5),(1394,1824944427,4),(1394,1837645227,5),(1394,1856394027,4),(1394,1869094827,5),(1394,1887843627,4),(1394,1901149227,5),(1394,1919293227,4),(1394,1932598827,5),(1394,1950742827,4),(1394,1964048427,5),(1394,1982797227,4),(1394,1995498027,5),(1394,2014246827,4),(1394,2026947627,5),(1394,2045696427,4),(1394,2058397227,5),(1394,2077146027,4),(1394,2090451627,5),(1394,2108595627,4),(1394,2121901227,5),(1394,2140045227,4),(1395,-2147483648,3),(1395,-1633273200,1),(1395,-1615132800,2),(1395,-1601823600,1),(1395,-1583683200,2),(1395,-1570374000,1),(1395,-1551628800,2),(1395,-1538924400,1),(1395,-1534089600,2),(1395,-880210800,4),(1395,-769395600,5),(1395,-765388800,2),(1395,-147884400,1),(1395,-131558400,2),(1395,-116434800,1),(1395,-100108800,2),(1395,-84380400,1),(1395,-68659200,2),(1395,-52930800,1),(1395,-37209600,2),(1395,-21481200,1),(1395,-5760000,2),(1395,9968400,1),(1395,25689600,2),(1395,41418000,1),(1395,57744000,2),(1395,73472400,1),(1395,89193601,2),(1395,104922002,1),(1395,120643202,2),(1395,126694803,1),(1395,152092803,2),(1395,162378004,1),(1395,183542404,2),(1395,199270805,1),(1395,215596805,2),(1395,230720406,1),(1395,247046406,2),(1395,262774807,1),(1395,278496007,2),(1395,294224408,1),(1395,309945608,2),(1395,325674009,1),(1395,341395209,2),(1395,357123609,1),(1395,372844810,2),(1395,388573210,1),(1395,404899211,2),(1395,420022811,1),(1395,436348812,2),(1395,452077212,1),(1395,467798412,2),(1395,483526812,1),(1395,499248013,2),(1395,514976413,1),(1395,530697613,2),(1395,544611613,1),(1395,562147213,2),(1395,576061214,1),(1395,594201614,2),(1395,607510814,1),(1395,625651214,2),(1395,638960415,1),(1395,657100815,2),(1395,671014816,1),(1395,688550416,2),(1395,702464416,1),(1395,720000017,2),(1395,733914017,1),(1395,752054418,2),(1395,765363618,1),(1395,783504019,2),(1395,796813219,1),(1395,814953619,2),(1395,828867620,1),(1395,846403220,2),(1395,860317220,1),(1395,877852821,2),(1395,891766821,1),(1395,909302421,2),(1395,923216422,1),(1395,941356822,2),(1395,954666022,1),(1395,972806422,2),(1395,986115622,1),(1395,1004256022,2),(1395,1018170022,1),(1395,1035705622,2),(1395,1049619622,1),(1395,1067155222,2),(1395,1081069222,1),(1395,1099209622,2),(1395,1112518822,1),(1395,1130659222,2),(1395,1143968423,1),(1395,1162108823,2),(1395,1173603623,1),(1395,1194163223,2),(1395,1205053223,1),(1395,1225612823,2),(1395,1236502824,1),(1395,1257062424,2),(1395,1268557224,1),(1395,1289116824,2),(1395,1300006824,1),(1395,1320566424,2),(1395,1331456424,1),(1395,1352016025,2),(1395,1362906025,1),(1395,1383465625,2),(1395,1394355625,1),(1395,1414915225,2),(1395,1425805225,1),(1395,1446364826,2),(1395,1457859626,1),(1395,1478419226,2),(1395,1489309227,1),(1395,1509868827,2),(1395,1520758827,1),(1395,1541318427,2),(1395,1552208427,1),(1395,1572768027,2),(1395,1583658027,1),(1395,1604217627,2),(1395,1615712427,1),(1395,1636272027,2),(1395,1647162027,1),(1395,1667721627,2),(1395,1678611627,1),(1395,1699171227,2),(1395,1710061227,1),(1395,1730620827,2),(1395,1741510827,1),(1395,1762070427,2),(1395,1772960427,1),(1395,1793520027,2),(1395,1805014827,1),(1395,1825574427,2),(1395,1836464427,1),(1395,1857024027,2),(1395,1867914027,1),(1395,1888473627,2),(1395,1899363627,1),(1395,1919923227,2),(1395,1930813227,1),(1395,1951372827,2),(1395,1962867627,1),(1395,1983427227,2),(1395,1994317227,1),(1395,2014876827,2),(1395,2025766827,1),(1395,2046326427,2),(1395,2057216427,1),(1395,2077776027,2),(1395,2088666027,1),(1395,2109225627,2),(1395,2120115627,1),(1395,2140675227,2),(1396,-2147483648,1),(1396,-880207200,2),(1396,-769395600,3),(1396,-765385200,1),(1396,-21477600,4),(1396,-5756400,1),(1396,9972000,4),(1396,25693200,1),(1396,41421600,4),(1396,57747600,1),(1396,73476000,4),(1396,89197201,1),(1396,104925602,4),(1396,120646802,1),(1396,126698403,4),(1396,152096403,1),(1396,162381604,4),(1396,183546004,1),(1396,199274405,4),(1396,215600405,1),(1396,230724006,4),(1396,247050006,1),(1396,262778407,4),(1396,278499607,1),(1396,294228008,4),(1396,309949208,1),(1396,325677609,4),(1396,341398809,1),(1396,357127209,4),(1396,372848410,1),(1396,388576810,4),(1396,404902811,1),(1396,420026411,4),(1396,436352412,5),(1396,439030812,7),(1396,452084412,6),(1396,467805612,7),(1396,483534012,6),(1396,499255213,7),(1396,514983613,6),(1396,530704813,7),(1396,544618813,6),(1396,562154413,7),(1396,576068414,6),(1396,594208814,7),(1396,607518014,6),(1396,625658414,7),(1396,638967615,6),(1396,657108015,7),(1396,671022016,6),(1396,688557616,7),(1396,702471616,6),(1396,720007217,7),(1396,733921217,6),(1396,752061618,7),(1396,765370818,6),(1396,783511219,7),(1396,796820419,6),(1396,814960819,7),(1396,828874820,6),(1396,846410420,7),(1396,860324420,6),(1396,877860021,7),(1396,891774021,6),(1396,909309621,7),(1396,923223622,6),(1396,941364022,7),(1396,954673222,6),(1396,972813622,7),(1396,986122822,6),(1396,1004263222,7),(1396,1018177222,6),(1396,1035712822,7),(1396,1049626822,6),(1396,1067162422,7),(1396,1081076422,6),(1396,1099216822,7),(1396,1112526022,6),(1396,1130666422,7),(1396,1143975623,6),(1396,1162116023,7),(1396,1173610823,6),(1396,1194170423,7),(1396,1205060423,6),(1396,1225620023,7),(1396,1236510024,6),(1396,1257069624,7),(1396,1268564424,6),(1396,1289124024,7),(1396,1300014024,6),(1396,1320573624,7),(1396,1331463624,6),(1396,1352023225,7),(1396,1362913225,6),(1396,1383472825,7),(1396,1394362825,6),(1396,1414922425,7),(1396,1425812425,6),(1396,1446372026,7),(1396,1457866826,6),(1396,1478426426,7),(1396,1489316427,6),(1396,1509876027,7),(1396,1520766027,6),(1396,1541325627,7),(1396,1552215627,6),(1396,1572775227,7),(1396,1583665227,6),(1396,1604224827,7),(1396,1615719627,6),(1396,1636279227,7),(1396,1647169227,6),(1396,1667728827,7),(1396,1678618827,6),(1396,1699178427,7),(1396,1710068427,6),(1396,1730628027,7),(1396,1741518027,6),(1396,1762077627,7),(1396,1772967627,6),(1396,1793527227,7),(1396,1805022027,6),(1396,1825581627,7),(1396,1836471627,6),(1396,1857031227,7),(1396,1867921227,6),(1396,1888480827,7),(1396,1899370827,6),(1396,1919930427,7),(1396,1930820427,6),(1396,1951380027,7),(1396,1962874827,6),(1396,1983434427,7),(1396,1994324427,6),(1396,2014884027,7),(1396,2025774027,6),(1396,2046333627,7),(1396,2057223627,6),(1396,2077783227,7),(1396,2088673227,6),(1396,2109232827,7),(1396,2120122827,6),(1396,2140682427,7),(1397,-2147483648,1),(1397,-873057600,3),(1397,-769395600,2),(1397,-765399600,1),(1398,-2147483648,2),(1398,-1664130548,1),(1398,-1650137348,2),(1398,-1632076148,1),(1398,-1615145348,2),(1398,-1598650148,1),(1398,-1590100148,2),(1398,-1567286948,1),(1398,-1551565748,2),(1398,-1535837348,1),(1398,-1520116148,2),(1398,-1503782948,1),(1398,-1488666548,2),(1398,-1472333348,1),(1398,-1457216948,2),(1398,-1440883748,1),(1398,-1425767348,2),(1398,-1409434148,1),(1398,-1394317748,2),(1398,-1377984548,1),(1398,-1362263348,2),(1398,-1346534948,1),(1398,-1330813748,2),(1398,-1314480548,1),(1398,-1299364148,2),(1398,-1283030948,1),(1398,-1267914548,2),(1398,-1251581348,1),(1398,-1236464948,2),(1398,-1220131748,1),(1398,-1205015348,2),(1398,-1188682148,1),(1398,-1172960948,2),(1398,-1156627748,1),(1398,-1141511348,2),(1398,-1125178148,1),(1398,-1110061748,2),(1398,-1096921748,4),(1398,-1093728600,3),(1398,-1078612200,4),(1398,-1061670600,3),(1398,-1048973400,4),(1398,-1030221000,3),(1398,-1017523800,4),(1398,-998771400,3),(1398,-986074200,4),(1398,-966717000,3),(1398,-954624600,4),(1398,-935267400,3),(1398,-922570200,4),(1398,-903817800,3),(1398,-891120600,4),(1398,-872368200,6),(1398,-769395600,5),(1398,-765401400,4),(1398,-746044200,3),(1398,-733347000,4),(1398,-714594600,3),(1398,-701897400,4),(1398,-683145000,3),(1398,-670447800,4),(1398,-651695400,3),(1398,-638998200,4),(1398,-619641000,3),(1398,-606943800,4),(1398,-589401000,3),(1398,-576099000,4),(1398,-557951400,3),(1398,-544649400,4),(1398,-526501800,3),(1398,-513199800,4),(1398,-495052200,3),(1398,-481750200,4),(1398,-463602600,3),(1398,-450300600,4),(1398,-431548200,3),(1398,-418246200,4),(1398,-400098600,3),(1398,-386796600,4),(1398,-368649000,3),(1398,-355347000,4),(1398,-337199400,3),(1398,-323897400,4),(1398,-305749800,3),(1398,-289423800,4),(1398,-273695400,3),(1398,-257974200,4),(1398,-242245800,3),(1398,-226524600,4),(1398,-210796200,3),(1398,-195075000,4),(1398,-179346600,3),(1398,-163625400,4),(1398,-147897000,3),(1398,-131571000,4),(1398,-116447400,3),(1398,-100121400,4),(1398,-84393000,3),(1398,-68671800,4),(1398,-52943400,3),(1398,-37222200,4),(1398,-21493800,3),(1398,-5772600,4),(1398,9955800,3),(1398,25677000,4),(1398,41405400,3),(1398,57731400,4),(1398,73459800,3),(1398,89181001,4),(1398,104909402,3),(1398,120630602,4),(1398,136359003,3),(1398,152080203,4),(1398,167808604,3),(1398,183529804,4),(1398,199258205,3),(1398,215584205,4),(1398,230707806,3),(1398,247033806,4),(1398,262762207,3),(1398,278483407,4),(1398,294211808,3),(1398,309933008,4),(1398,325661409,3),(1398,341382609,4),(1398,357111009,3),(1398,372832210,4),(1398,388560610,3),(1398,404886611,4),(1398,420010211,3),(1398,436336212,4),(1398,452064612,3),(1398,467785812,4),(1398,483514212,3),(1398,499235413,4),(1398,514963813,3),(1398,530685013,4),(1398,544591873,3),(1398,562127473,4),(1398,576041474,7),(1398,594178274,4),(1398,607491074,3),(1398,625631474,4),(1398,638940675,3),(1398,657081075,4),(1398,670995076,3),(1398,688530676,4),(1398,702444676,3),(1398,719980277,4),(1398,733894277,3),(1398,752034678,4),(1398,765343878,3),(1398,783484279,4),(1398,796793479,3),(1398,814933879,4),(1398,828847880,3),(1398,846383480,4),(1398,860297480,3),(1398,877833081,4),(1398,891747081,3),(1398,909282681,4),(1398,923196682,3),(1398,941337082,4),(1398,954646282,3),(1398,972786682,4),(1398,986095882,3),(1398,1004236282,4),(1398,1018150282,3),(1398,1035685882,4),(1398,1049599882,3),(1398,1067135482,4),(1398,1081049482,3),(1398,1099189882,4),(1398,1112499082,3),(1398,1130639482,4),(1398,1143948683,3),(1398,1162089083,4),(1398,1173583883,3),(1398,1194143483,4),(1398,1205033483,3),(1398,1225593083,4),(1398,1236483084,3),(1398,1257042684,4),(1398,1268537484,3),(1398,1289097084,4),(1398,1299987084,3),(1398,1320553824,4),(1398,1331443824,3),(1398,1352003425,4),(1398,1362893425,3),(1398,1383453025,4),(1398,1394343025,3),(1398,1414902625,4),(1398,1425792625,3),(1398,1446352226,4),(1398,1457847026,3),(1398,1478406626,4),(1398,1489296627,3),(1398,1509856227,4),(1398,1520746227,3),(1398,1541305827,4),(1398,1552195827,3),(1398,1572755427,4),(1398,1583645427,3),(1398,1604205027,4),(1398,1615699827,3),(1398,1636259427,4),(1398,1647149427,3),(1398,1667709027,4),(1398,1678599027,3),(1398,1699158627,4),(1398,1710048627,3),(1398,1730608227,4),(1398,1741498227,3),(1398,1762057827,4),(1398,1772947827,3),(1398,1793507427,4),(1398,1805002227,3),(1398,1825561827,4),(1398,1836451827,3),(1398,1857011427,4),(1398,1867901427,3),(1398,1888461027,4),(1398,1899351027,3),(1398,1919910627,4),(1398,1930800627,3),(1398,1951360227,4),(1398,1962855027,3),(1398,1983414627,4),(1398,1994304627,3),(1398,2014864227,4),(1398,2025754227,3),(1398,2046313827,4),(1398,2057203827,3),(1398,2077763427,4),(1398,2088653427,3),(1398,2109213027,4),(1398,2120103027,3),(1398,2140662627,4),(1399,-2147483648,1),(1399,-873057600,3),(1399,-769395600,2),(1399,-765399600,1),(1400,-2147483648,1),(1400,-873057600,3),(1400,-769395600,2),(1400,-765399600,1),(1401,-2147483648,1),(1401,-873057600,3),(1401,-769395600,2),(1401,-765399600,1),(1402,-2147483648,1),(1402,-873057600,3),(1402,-769395600,2),(1402,-765399600,1),(1403,-2147483648,0),(1403,-2030201320,2),(1403,-1632063600,1),(1403,-1615132800,2),(1403,-880210800,3),(1403,-769395600,4),(1403,-765388800,2),(1403,-747241200,1),(1403,-732729600,2),(1403,-715791600,1),(1403,-702489600,2),(1403,-684342000,1),(1403,-671040000,2),(1403,-652892400,1),(1403,-639590400,2),(1403,-400086000,1),(1403,-384364800,2),(1403,-337186800,1),(1403,-321465600,2),(1403,-305737200,1),(1403,-292435200,2),(1403,-273682800,1),(1403,-260985600,2),(1403,73472400,5),(1404,-2147483648,0),(1404,-1538503868,2),(1404,547020013,1),(1404,559717213,2),(1404,578469614,1),(1404,591166814,2),(1404,1146981623,1),(1404,1154926823,2),(1405,-2147483648,0),(1405,-1686079492,2),(1405,670399216,1),(1405,686120416,2),(1405,701848816,1),(1405,717570017,2),(1405,733903217,1),(1405,752043618,2),(1405,765352818,1),(1405,783493219,2),(1405,796802419,1),(1405,814942819,2),(1405,828856820,1),(1405,846392420,2),(1405,860306420,1),(1405,877842021,2),(1405,891756021,1),(1405,909291621,2),(1405,923205622,1),(1405,941346022,2),(1405,954655222,1),(1405,972795622,2),(1405,986104822,1),(1405,1004245222,2),(1405,1018159222,1),(1405,1035694822,2),(1405,1049608822,1),(1405,1067144422,2),(1405,1081058422,1),(1405,1099198822,2),(1405,1112508022,1),(1405,1130648422,2),(1405,1143957623,1),(1405,1162098023,2),(1405,1173592823,1),(1405,1194152423,2),(1405,1205042423,1),(1405,1225602023,2),(1405,1236492024,1),(1405,1257051624,2),(1405,1268546424,1),(1405,1289106024,2),(1405,1299996024,1),(1405,1320555624,2),(1405,1331445624,1),(1405,1352005225,2),(1405,1362895225,1),(1405,1383454825,2),(1405,1394344825,1),(1405,1414904425,2),(1405,1425794425,1),(1405,1446354026,2),(1405,1457848826,1),(1405,1478408426,2),(1405,1489298427,1),(1405,1509858027,2),(1405,1520748027,1),(1405,1541307627,2),(1405,1552197627,1),(1405,1572757227,2),(1405,1583647227,1),(1405,1604206827,2),(1405,1615701627,1),(1405,1636261227,2),(1405,1647151227,1),(1405,1667710827,2),(1405,1678600827,1),(1405,1699160427,2),(1405,1710050427,1),(1405,1730610027,2),(1405,1741500027,1),(1405,1762059627,2),(1405,1772949627,1),(1405,1793509227,2),(1405,1805004027,1),(1405,1825563627,2),(1405,1836453627,1),(1405,1857013227,2),(1405,1867903227,1),(1405,1888462827,2),(1405,1899352827,1),(1405,1919912427,2),(1405,1930802427,1),(1405,1951362027,2),(1405,1962856827,1),(1405,1983416427,2),(1405,1994306427,1),(1405,2014866027,2),(1405,2025756027,1),(1405,2046315627,2),(1405,2057205627,1),(1405,2077765227,2),(1405,2088655227,1),(1405,2109214827,2),(1405,2120104827,1),(1405,2140664427,2),(1406,-2147483648,2),(1406,-1632070800,1),(1406,-1615140000,2),(1406,-1601753400,1),(1406,-1583697600,2),(1406,-1567357200,1),(1406,-1554667200,2),(1406,-1534698000,1),(1406,-1524074400,2),(1406,-1503248400,1),(1406,-1492365600,2),(1406,-1471798800,1),(1406,-1460916000,2),(1406,-1440954000,1),(1406,-1428861600,2),(1406,-1409504400,1),(1406,-1397412000,2),(1406,-1378054800,1),(1406,-1365962400,2),(1406,-1346605200,1),(1406,-1333908000,2),(1406,-1315155600,1),(1406,-1301853600,2),(1406,-1283706000,1),(1406,-1270404000,2),(1406,-1252256400,1),(1406,-1238954400,2),(1406,-1220806800,1),(1406,-1207504800,2),(1406,-1188752400,1),(1406,-1176055200,2),(1406,-1157302800,1),(1406,-1144000800,2),(1406,-1125853200,1),(1406,-1112551200,2),(1406,-1094403600,1),(1406,-1081101600,2),(1406,-1062954000,1),(1406,-1049652000,2),(1406,-1031504400,1),(1406,-1018202400,2),(1406,-1000054800,1),(1406,-986752800,2),(1406,-968000400,1),(1406,-955303200,2),(1406,-936550800,1),(1406,-880218000,3),(1406,-769395600,4),(1406,-765396000,2),(1406,-747248400,1),(1406,-733946400,2),(1406,-715806000,1),(1406,-702504000,2),(1406,-684356400,1),(1406,-671054400,2),(1406,-652906800,1),(1406,-634161600,2),(1406,-620845200,1),(1406,-602704800,2),(1406,-589395600,1),(1406,-576093600,2),(1406,-557946000,1),(1406,-544644000,2),(1406,-526496400,1),(1406,-513194400,2),(1406,-495046800,1),(1406,-481744800,2),(1406,-463597200,1),(1406,-450295200,2),(1406,-431542800,1),(1406,-418240800,2),(1406,-400093200,1),(1406,-384372000,2),(1406,-368643600,1),(1406,-352922400,2),(1406,-337194000,1),(1406,-321472800,2),(1406,-305744400,1),(1406,-289418400,2),(1406,-273690000,1),(1406,-257968800,2),(1406,-242240400,1),(1406,-226519200,2),(1406,-210790800,1),(1406,-195069600,2),(1406,-179341200,1),(1406,-163620000,2),(1406,-147891600,1),(1406,-131565600,2),(1406,-116442000,1),(1406,-100116000,2),(1406,-84387600,1),(1406,-68666400,2),(1406,-52938000,1),(1406,-37216800,2),(1406,-21488400,1),(1406,-5767200,2),(1406,9961200,1),(1406,25682400,2),(1406,41410800,1),(1406,57736800,2),(1406,73465200,1),(1406,89186401,2),(1406,104914802,1),(1406,120636002,2),(1406,136364403,1),(1406,152085603,2),(1406,167814004,1),(1406,183535204,2),(1406,199263605,1),(1406,215589605,2),(1406,230713206,1),(1406,247039206,2),(1406,262767607,1),(1406,278488807,2),(1406,294217208,1),(1406,309938408,2),(1406,325666809,1),(1406,341388009,2),(1406,357116409,1),(1406,372837610,2),(1406,388566010,1),(1406,404892011,2),(1406,420015611,1),(1406,436341612,2),(1406,452070012,1),(1406,467791212,2),(1406,483519612,1),(1406,499240813,2),(1406,514969213,1),(1406,530690413,2),(1406,544604413,1),(1406,562140013,2),(1406,576054014,1),(1406,594194414,2),(1406,607503614,1),(1406,625644014,2),(1406,638953215,1),(1406,657093615,2),(1406,671007616,1),(1406,688543216,2),(1406,702457216,1),(1406,719992817,2),(1406,733906817,1),(1406,752047218,2),(1406,765356418,1),(1406,783496819,2),(1406,796806019,1),(1406,814946419,2),(1406,828860420,1),(1406,846396020,2),(1406,860310020,1),(1406,877845621,2),(1406,891759621,1),(1406,909295221,2),(1406,923209222,1),(1406,941349622,2),(1406,954658822,1),(1406,972799222,2),(1406,986108422,1),(1406,1004248822,2),(1406,1018162822,1),(1406,1035698422,2),(1406,1049612422,1),(1406,1067148022,2),(1406,1081062022,1),(1406,1099202422,2),(1406,1112511622,1),(1406,1130652022,2),(1406,1143961223,1),(1406,1162101623,2),(1406,1173596423,1),(1406,1194156023,2),(1406,1205046023,1),(1406,1225605623,2),(1406,1236495624,1),(1406,1257055224,2),(1406,1268550024,1),(1406,1289109624,2),(1406,1299999624,1),(1406,1320559224,2),(1406,1331449224,1),(1406,1352008825,2),(1406,1362898825,1),(1406,1383458425,2),(1406,1394348425,1),(1406,1414908025,2),(1406,1425798025,1),(1406,1446357626,2),(1406,1457852426,1),(1406,1478412026,2),(1406,1489302027,1),(1406,1509861627,2),(1406,1520751627,1),(1406,1541311227,2),(1406,1552201227,1),(1406,1572760827,2),(1406,1583650827,1),(1406,1604210427,2),(1406,1615705227,1),(1406,1636264827,2),(1406,1647154827,1),(1406,1667714427,2),(1406,1678604427,1),(1406,1699164027,2),(1406,1710054027,1),(1406,1730613627,2),(1406,1741503627,1),(1406,1762063227,2),(1406,1772953227,1),(1406,1793512827,2),(1406,1805007627,1),(1406,1825567227,2),(1406,1836457227,1),(1406,1857016827,2),(1406,1867906827,1),(1406,1888466427,2),(1406,1899356427,1),(1406,1919916027,2),(1406,1930806027,1),(1406,1951365627,2),(1406,1962860427,1),(1406,1983420027,2),(1406,1994310027,1),(1406,2014869627,2),(1406,2025759627,1),(1406,2046319227,2),(1406,2057209227,1),(1406,2077768827,2),(1406,2088658827,1),(1406,2109218427,2),(1406,2120108427,1),(1406,2140668027,2),(1407,-2147483648,0),(1407,-1514739600,1),(1407,-1451667600,2),(1407,-1343062800,3),(1407,-1234803600,2),(1407,-1222963200,4),(1407,-1207242000,2),(1407,-873820800,5),(1407,-769395600,6),(1407,-761677200,2),(1407,-686073600,4),(1407,-661539600,2),(1407,-495039600,4),(1407,-481734000,2),(1407,-463590000,4),(1407,-450284400,2),(1407,-431535600,4),(1407,-418230000,2),(1407,-400086000,4),(1407,-386780400,2),(1407,-368636400,4),(1407,-355330800,2),(1407,-337186800,4),(1407,-323881200,2),(1407,-305737200,4),(1407,-292431600,2),(1407,199274405,4),(1407,215600405,2),(1407,230724006,4),(1407,247050006,2),(1407,262778407,4),(1407,278499607,2),(1407,294228008,4),(1407,309949208,2),(1407,325677609,4),(1407,341398809,2),(1407,357127209,4),(1407,372848410,2),(1407,388576810,4),(1407,404902811,2),(1407,420026411,4),(1407,436352412,2),(1407,452080812,4),(1407,467802012,2),(1407,483530412,4),(1407,499251613,2),(1407,514980013,4),(1407,530701213,2),(1407,544615213,4),(1407,562150813,2),(1407,576064814,4),(1407,594205214,2),(1407,607514414,4),(1407,625654814,2),(1407,638964015,4),(1407,657104415,2),(1407,671018416,4),(1407,688554016,2),(1407,702468016,4),(1407,720003617,2),(1407,733917617,4),(1407,752058018,2),(1407,765367218,4),(1407,783507619,2),(1407,796816819,4),(1407,814957219,2),(1407,828871220,4),(1407,846406820,2),(1407,860320820,4),(1407,877856421,2),(1407,891770421,4),(1407,909306021,2),(1407,923220022,4),(1407,941360422,2),(1407,954669622,4),(1407,972810022,2),(1407,986119222,4),(1407,1004259622,2),(1407,1018173622,4),(1407,1035709222,2),(1407,1049623222,4),(1407,1067158822,2),(1407,1081072822,4),(1407,1099213222,2),(1407,1112522422,4),(1407,1130662822,2),(1407,1143972023,4),(1407,1162112423,2),(1407,1175421623,4),(1407,1193562023,2),(1407,1207476023,4),(1407,1225011623,2),(1407,1238925624,4),(1407,1256461224,2),(1407,1268560824,4),(1407,1289120424,2),(1407,1300010424,4),(1407,1320570024,2),(1407,1331460024,4),(1407,1352019625,2),(1407,1362909625,4),(1407,1383469225,2),(1407,1394359225,4),(1407,1414918825,2),(1407,1425808825,4),(1407,1446368426,2),(1407,1457863226,4),(1407,1478422826,2),(1407,1489312827,4),(1407,1509872427,2),(1407,1520762427,4),(1407,1541322027,2),(1407,1552212027,4),(1407,1572771627,2),(1407,1583661627,4),(1407,1604221227,2),(1407,1615716027,4),(1407,1636275627,2),(1407,1647165627,4),(1407,1667725227,2),(1407,1678615227,4),(1407,1699174827,2),(1407,1710064827,4),(1407,1730624427,2),(1407,1741514427,4),(1407,1762074027,2),(1407,1772964027,4),(1407,1793523627,2),(1407,1805018427,4),(1407,1825578027,2),(1407,1836468027,4),(1407,1857027627,2),(1407,1867917627,4),(1407,1888477227,2),(1407,1899367227,4),(1407,1919926827,2),(1407,1930816827,4),(1407,1951376427,2),(1407,1962871227,4),(1407,1983430827,2),(1407,1994320827,4),(1407,2014880427,2),(1407,2025770427,4),(1407,2046330027,2),(1407,2057220027,4),(1407,2077779627,2),(1407,2088669627,4),(1407,2109229227,2),(1407,2120119227,4),(1407,2140678827,2),(1408,-2147483648,2),(1408,-1632070800,1),(1408,-1615140000,2),(1408,-1601753400,1),(1408,-1583697600,2),(1408,-1567357200,1),(1408,-1554667200,2),(1408,-1534698000,1),(1408,-1524074400,2),(1408,-1503248400,1),(1408,-1492365600,2),(1408,-1471798800,1),(1408,-1460916000,2),(1408,-1440954000,1),(1408,-1428861600,2),(1408,-1409504400,1),(1408,-1397412000,2),(1408,-1378054800,1),(1408,-1365962400,2),(1408,-1346605200,1),(1408,-1333908000,2),(1408,-1315155600,1),(1408,-1301853600,2),(1408,-1283706000,1),(1408,-1270404000,2),(1408,-1252256400,1),(1408,-1238954400,2),(1408,-1220806800,1),(1408,-1207504800,2),(1408,-1188752400,1),(1408,-1176055200,2),(1408,-1157302800,1),(1408,-1144000800,2),(1408,-1125853200,1),(1408,-1112551200,2),(1408,-1094403600,1),(1408,-1081101600,2),(1408,-1062954000,1),(1408,-1049652000,2),(1408,-1031504400,1),(1408,-1018202400,2),(1408,-1000054800,1),(1408,-986752800,2),(1408,-968000400,1),(1408,-955303200,2),(1408,-936550800,1),(1408,-880218000,3),(1408,-769395600,4),(1408,-765396000,2),(1408,-747248400,1),(1408,-733946400,2),(1408,-715806000,1),(1408,-702504000,2),(1408,-684356400,1),(1408,-671054400,2),(1408,-652906800,1),(1408,-634161600,2),(1408,-620845200,1),(1408,-602704800,2),(1408,-589395600,1),(1408,-576093600,2),(1408,-557946000,1),(1408,-544644000,2),(1408,-526496400,1),(1408,-513194400,2),(1408,-495046800,1),(1408,-481744800,2),(1408,-463597200,1),(1408,-450295200,2),(1408,-431542800,1),(1408,-418240800,2),(1408,-400093200,1),(1408,-384372000,2),(1408,-368643600,1),(1408,-352922400,2),(1408,-337194000,1),(1408,-321472800,2),(1408,-305744400,1),(1408,-289418400,2),(1408,-273690000,1),(1408,-257968800,2),(1408,-242240400,1),(1408,-226519200,2),(1408,-210790800,1),(1408,-195069600,2),(1408,-179341200,1),(1408,-163620000,2),(1408,-147891600,1),(1408,-131565600,2),(1408,-116442000,1),(1408,-100116000,2),(1408,-84387600,1),(1408,-68666400,2),(1408,-52938000,1),(1408,-37216800,2),(1408,-21488400,1),(1408,-5767200,2),(1408,9961200,1),(1408,25682400,2),(1408,41410800,1),(1408,57736800,2),(1408,73465200,1),(1408,89186401,2),(1408,104914802,1),(1408,120636002,2),(1408,136364403,1),(1408,152085603,2),(1408,167814004,1),(1408,183535204,2),(1408,199263605,1),(1408,215589605,2),(1408,230713206,1),(1408,247039206,2),(1408,262767607,1),(1408,278488807,2),(1408,294217208,1),(1408,309938408,2),(1408,325666809,1),(1408,341388009,2),(1408,357116409,1),(1408,372837610,2),(1408,388566010,1),(1408,404892011,2),(1408,420015611,1),(1408,436341612,2),(1408,452070012,1),(1408,467791212,2),(1408,483519612,1),(1408,499240813,2),(1408,514969213,1),(1408,530690413,2),(1408,544604413,1),(1408,562140013,2),(1408,576054014,1),(1408,594194414,2),(1408,607503614,1),(1408,625644014,2),(1408,638953215,1),(1408,657093615,2),(1408,671007616,1),(1408,688543216,2),(1408,702457216,1),(1408,719992817,2),(1408,733906817,1),(1408,752047218,2),(1408,765356418,1),(1408,783496819,2),(1408,796806019,1),(1408,814946419,2),(1408,828860420,1),(1408,846396020,2),(1408,860310020,1),(1408,877845621,2),(1408,891759621,1),(1408,909295221,2),(1408,923209222,1),(1408,941349622,2),(1408,954658822,1),(1408,972799222,2),(1408,986108422,1),(1408,1004248822,2),(1408,1018162822,1),(1408,1035698422,2),(1408,1049612422,1),(1408,1067148022,2),(1408,1081062022,1),(1408,1099202422,2),(1408,1112511622,1),(1408,1130652022,2),(1408,1143961223,1),(1408,1162101623,2),(1408,1173596423,1),(1408,1194156023,2),(1408,1205046023,1),(1408,1225605623,2),(1408,1236495624,1),(1408,1257055224,2),(1408,1268550024,1),(1408,1289109624,2),(1408,1299999624,1),(1408,1320559224,2),(1408,1331449224,1),(1408,1352008825,2),(1408,1362898825,1),(1408,1383458425,2),(1408,1394348425,1),(1408,1414908025,2),(1408,1425798025,1),(1408,1446357626,2),(1408,1457852426,1),(1408,1478412026,2),(1408,1489302027,1),(1408,1509861627,2),(1408,1520751627,1),(1408,1541311227,2),(1408,1552201227,1),(1408,1572760827,2),(1408,1583650827,1),(1408,1604210427,2),(1408,1615705227,1),(1408,1636264827,2),(1408,1647154827,1),(1408,1667714427,2),(1408,1678604427,1),(1408,1699164027,2),(1408,1710054027,1),(1408,1730613627,2),(1408,1741503627,1),(1408,1762063227,2),(1408,1772953227,1),(1408,1793512827,2),(1408,1805007627,1),(1408,1825567227,2),(1408,1836457227,1),(1408,1857016827,2),(1408,1867906827,1),(1408,1888466427,2),(1408,1899356427,1),(1408,1919916027,2),(1408,1930806027,1),(1408,1951365627,2),(1408,1962860427,1),(1408,1983420027,2),(1408,1994310027,1),(1408,2014869627,2),(1408,2025759627,1),(1408,2046319227,2),(1408,2057209227,1),(1408,2077768827,2),(1408,2088658827,1),(1408,2109218427,2),(1408,2120108427,1),(1408,2140668027,2),(1409,-2147483648,1),(1409,-873057600,3),(1409,-769395600,2),(1409,-765399600,1),(1410,-2147483648,2),(1410,-1632060000,1),(1410,-1615129200,2),(1410,-880207200,3),(1410,-769395600,4),(1410,-765385200,2),(1410,-747237600,1),(1410,-733935600,2),(1410,-715788000,1),(1410,-702486000,2),(1410,-684338400,1),(1410,-671036400,2),(1410,-652888800,1),(1410,-639586800,2),(1410,-620834400,1),(1410,-608137200,2),(1410,-589384800,1),(1410,-576082800,2),(1410,-557935200,1),(1410,-544633200,2),(1410,-526485600,1),(1410,-513183600,2),(1410,-495036000,1),(1410,-481734000,2),(1410,-463586400,1),(1410,-450284400,2),(1410,-431532000,1),(1410,-418230000,2),(1410,-400082400,1),(1410,-386780400,2),(1410,-368632800,1),(1410,-355330800,2),(1410,-337183200,1),(1410,-323881200,2),(1410,-305733600,1),(1410,-292431600,2),(1410,-273679200,1),(1410,-260982000,2),(1410,-242229600,1),(1410,-226508400,2),(1410,-210780000,1),(1410,-195058800,2),(1410,-179330400,1),(1410,-163609200,2),(1410,-147880800,1),(1410,-131554800,2),(1410,-116431200,1),(1410,-100105200,2),(1410,-84376800,1),(1410,-68655600,2),(1410,-52927200,1),(1410,-37206000,2),(1410,-21477600,1),(1410,-5756400,2),(1410,9972000,1),(1410,25693200,2),(1410,41421600,1),(1410,57747600,2),(1410,73476000,1),(1410,89197201,2),(1410,104925602,1),(1410,120646802,2),(1410,136375203,1),(1410,152096403,2),(1410,167824804,1),(1410,183546004,2),(1410,199274405,1),(1410,215600405,2),(1410,230724006,1),(1410,247050006,2),(1410,262778407,1),(1410,278499607,2),(1410,294228008,1),(1410,309949208,2),(1410,325677609,1),(1410,341398809,2),(1410,357127209,1),(1410,372848410,2),(1410,388576810,1),(1410,404902811,2),(1410,420026411,1),(1410,436352412,2),(1410,452080812,1),(1410,467802012,2),(1410,483530412,1),(1410,499251613,2),(1410,514980013,1),(1410,530701213,2),(1410,544615213,1),(1410,562150813,2),(1410,576064814,1),(1410,594205214,2),(1410,607514414,1),(1410,625654814,2),(1410,638964015,1),(1410,657104415,2),(1410,671018416,1),(1410,688554016,2),(1410,702468016,1),(1410,720003617,2),(1410,733917617,1),(1410,752058018,2),(1410,765367218,1),(1410,783507619,2),(1410,796816819,1),(1410,814957219,2),(1410,828871220,1),(1410,846406820,2),(1410,860320820,1),(1410,877856421,2),(1410,891770421,1),(1410,909306021,2),(1410,923220022,1),(1410,941360422,2),(1410,954669622,1),(1410,972810022,2),(1410,986119222,1),(1410,1004259622,2),(1410,1018173622,1),(1410,1035709222,2),(1410,1049623222,1),(1410,1067158822,2),(1410,1081072822,1),(1410,1099213222,2),(1410,1112522422,1),(1410,1130662822,2),(1410,1143972023,1),(1410,1162112423,2),(1410,1173607223,1),(1410,1194166823,2),(1410,1205056823,1),(1410,1225616423,2),(1410,1236506424,1),(1410,1257066024,2),(1410,1268560824,1),(1410,1289120424,2),(1410,1300010424,1),(1410,1320570024,2),(1410,1331460024,1),(1410,1352019625,2),(1410,1362909625,1),(1410,1383469225,2),(1410,1394359225,1),(1410,1414918825,2),(1410,1425808825,1),(1410,1446368426,2),(1410,1457863226,1),(1410,1478422826,2),(1410,1489312827,1),(1410,1509872427,2),(1410,1520762427,1),(1410,1541322027,2),(1410,1552212027,1),(1410,1572771627,2),(1410,1583661627,1),(1410,1604221227,2),(1410,1615716027,1),(1410,1636275627,2),(1410,1647165627,1),(1410,1667725227,2),(1410,1678615227,1),(1410,1699174827,2),(1410,1710064827,1),(1410,1730624427,2),(1410,1741514427,1),(1410,1762074027,2),(1410,1772964027,1),(1410,1793523627,2),(1410,1805018427,1),(1410,1825578027,2),(1410,1836468027,1),(1410,1857027627,2),(1410,1867917627,1),(1410,1888477227,2),(1410,1899367227,1),(1410,1919926827,2),(1410,1930816827,1),(1410,1951376427,2),(1410,1962871227,1),(1410,1983430827,2),(1410,1994320827,1),(1410,2014880427,2),(1410,2025770427,1),(1410,2046330027,2),(1410,2057220027,1),(1410,2077779627,2),(1410,2088669627,1),(1410,2109229227,2),(1410,2120119227,1),(1410,2140678827,2),(1411,-2147483648,1),(1411,-873057600,3),(1411,-769395600,2),(1411,-765399600,1),(1412,-2147483648,2),(1412,-1632056400,1),(1412,-1615125600,2),(1412,-1596978000,1),(1412,-1583164800,2),(1412,-880203600,3),(1412,-769395600,4),(1412,-765381600,2),(1412,-147884400,5),(1412,-131554800,2),(1412,-121273200,6),(1412,325677609,7),(1412,341398809,6),(1412,357127209,7),(1412,372848410,6),(1412,388576810,7),(1412,404902811,6),(1412,420026411,7),(1412,436352412,6),(1412,452080812,7),(1412,467802012,6),(1412,483530412,7),(1412,499251613,6),(1412,514980013,7),(1412,530701213,6),(1412,544615213,7),(1412,562150813,6),(1412,576064814,7),(1412,594205214,6),(1412,607514414,7),(1412,625654814,6),(1412,638964015,7),(1412,657104415,6),(1412,671018416,7),(1412,688554016,6),(1412,702468016,7),(1412,720003617,6),(1412,733917617,7),(1412,752058018,6),(1412,765367218,7),(1412,783507619,6),(1412,796816819,7),(1412,814957219,6),(1412,828871220,7),(1412,846406820,6),(1412,860320820,7),(1412,877856421,6),(1412,891770421,7),(1412,909306021,6),(1412,923220022,7),(1412,941360422,6),(1412,954669622,7),(1412,972810022,6),(1412,986119222,7),(1412,1004259622,6),(1412,1018173622,7),(1412,1035709222,6),(1412,1049623222,7),(1412,1067158822,6),(1412,1081072822,7),(1412,1099213222,6),(1412,1112522422,7),(1412,1130662822,6),(1412,1143972023,7),(1412,1162112423,6),(1412,1173607223,7),(1412,1194166823,6),(1412,1205056823,7),(1412,1225616423,6),(1412,1236506424,7),(1412,1257066024,6),(1412,1268560824,7),(1412,1289120424,6),(1412,1300010424,7),(1412,1320570024,6),(1412,1331460024,7),(1412,1352019625,6),(1412,1362909625,7),(1412,1383469225,6),(1412,1394359225,7),(1412,1414918825,6),(1412,1425808825,7),(1412,1446368426,6),(1412,1457863226,7),(1412,1478422826,6),(1412,1489312827,7),(1412,1509872427,6),(1412,1520762427,7),(1412,1541322027,6),(1412,1552212027,7),(1412,1572771627,6),(1412,1583661627,7),(1412,1604214027,8),(1413,-2147483648,2),(1413,-1694368800,1),(1413,-1681671600,2),(1413,-1632067200,1),(1413,-1615136400,2),(1413,-1029686400,1),(1413,-1018198800,2),(1413,-880214400,3),(1413,-769395600,4),(1413,-765392400,2),(1413,-746035200,1),(1413,-732733200,2),(1413,-715795200,1),(1413,-702493200,2),(1413,-684345600,1),(1413,-671043600,2),(1413,-652896000,1),(1413,-639594000,2),(1413,-620755200,1),(1413,-607626000,2),(1413,-589392000,1),(1413,-576090000,2),(1413,-557942400,1),(1413,-544640400,2),(1413,-526492800,1),(1413,-513190800,2),(1413,-495043200,1),(1413,-481741200,2),(1413,-463593600,1),(1413,-450291600,2),(1413,-431539200,1),(1413,-418237200,2),(1413,-400089600,1),(1413,-386787600,2),(1413,-368640000,1),(1413,-355338000,2),(1413,-337190400,1),(1413,-321469200,2),(1413,-305740800,1),(1413,-292438800,2),(1413,-210787200,1),(1413,-198090000,2),(1413,-116438400,5),(1413,-100108800,6),(1413,-84384000,5),(1413,-68659200,6),(1413,-52934400,5),(1413,-37209600,6),(1413,-21484800,5),(1413,-5760000,6),(1413,9964800,5),(1413,25689600,6),(1413,41414400,5),(1413,57744000,6),(1413,73468800,5),(1413,89193601,6),(1413,104918402,5),(1413,120643202,6),(1413,136368003,5),(1413,152092803,6),(1413,167817604,5),(1413,183542404,6),(1413,199267205,5),(1413,215596805,6),(1413,230716806,5),(1413,247046406,6),(1413,262771207,5),(1413,278496007,6),(1413,294220808,5),(1413,309945608,6),(1413,325670409,5),(1413,341395209,6),(1413,357120009,5),(1413,372844810,6),(1413,388569610,5),(1413,404899211,6),(1413,420019211,5),(1413,436348812,6),(1413,452073612,5),(1413,467798412,6),(1413,483523212,5),(1413,499248013,6),(1413,514972813,5),(1413,530697613,6),(1413,544608013,5),(1413,562147213,6),(1413,576057614,5),(1413,594201614,6),(1413,607507214,5),(1413,625651214,6),(1413,638956815,5),(1413,657100815,6),(1413,671011216,5),(1413,688550416,6),(1413,702460816,5),(1413,720000017,6),(1413,733910417,5),(1413,752054418,6),(1413,765360018,5),(1413,783504019,6),(1413,796809619,5),(1413,814953619,6),(1413,828864020,5),(1413,846403220,6),(1413,860313620,5),(1413,877852821,6),(1413,891763221,5),(1413,909302421,6),(1413,923212822,5),(1413,941356822,6),(1413,954662422,5),(1413,972806422,6),(1413,986112022,5),(1413,1004256022,6),(1413,1018166422,5),(1413,1035705622,6),(1413,1049616022,5),(1413,1067155222,6),(1413,1081065622,5),(1413,1099209622,6),(1413,1112515222,5),(1413,1130659222,6),(1413,1136095223,2),(1413,1143964823,1),(1413,1162105223,2),(1413,1173600023,1),(1413,1194159623,2),(1413,1205049623,1),(1413,1225609223,2),(1413,1236499224,1),(1413,1257058824,2),(1413,1268553624,1),(1413,1289113224,2),(1413,1300003224,1),(1413,1320562824,2),(1413,1331452824,1),(1413,1352012425,2),(1413,1362902425,1),(1413,1383462025,2),(1413,1394352025,1),(1413,1414911625,2),(1413,1425801625,1),(1413,1446361226,2),(1413,1457856026,1),(1413,1478415626,2),(1413,1489305627,1),(1413,1509865227,2),(1413,1520755227,1),(1413,1541314827,2),(1413,1552204827,1),(1413,1572764427,2),(1413,1583654427,1),(1413,1604214027,2),(1413,1615708827,1),(1413,1636268427,2),(1413,1647158427,1),(1413,1667718027,2),(1413,1678608027,1),(1413,1699167627,2),(1413,1710057627,1),(1413,1730617227,2),(1413,1741507227,1),(1413,1762066827,2),(1413,1772956827,1),(1413,1793516427,2),(1413,1805011227,1),(1413,1825570827,2),(1413,1836460827,1),(1413,1857020427,2),(1413,1867910427,1),(1413,1888470027,2),(1413,1899360027,1),(1413,1919919627,2),(1413,1930809627,1),(1413,1951369227,2),(1413,1962864027,1),(1413,1983423627,2),(1413,1994313627,1),(1413,2014873227,2),(1413,2025763227,1),(1413,2046322827,2),(1413,2057212827,1),(1413,2077772427,2),(1413,2088662427,1),(1413,2109222027,2),(1413,2120112027,1),(1413,2140671627,2),(1414,-2147483648,1),(1414,-880203600,2),(1414,-769395600,3),(1414,-765381600,1),(1414,-21474000,4),(1414,-5752800,1),(1414,9975600,4),(1414,25696800,1),(1414,41425200,4),(1414,57751200,1),(1414,73479600,4),(1414,89200801,1),(1414,104929202,4),(1414,120650402,1),(1414,126702003,4),(1414,152100003,1),(1414,162385204,4),(1414,183549604,1),(1414,199278005,4),(1414,215604005,1),(1414,230727606,4),(1414,247053606,1),(1414,262782007,4),(1414,278503207,1),(1414,294231608,4),(1414,309952808,1),(1414,325681209,4),(1414,341402409,1),(1414,357130809,4),(1414,372852010,1),(1414,388580410,4),(1414,404906411,1),(1414,420030011,4),(1414,436356012,1),(1414,439030812,6),(1414,452084412,5),(1414,467805612,6),(1414,483534012,5),(1414,499255213,6),(1414,514983613,5),(1414,530704813,6),(1414,544618813,5),(1414,562154413,6),(1414,576068414,5),(1414,594208814,6),(1414,607518014,5),(1414,625658414,6),(1414,638967615,5),(1414,657108015,6),(1414,671022016,5),(1414,688557616,6),(1414,702471616,5),(1414,720007217,6),(1414,733921217,5),(1414,752061618,6),(1414,765370818,5),(1414,783511219,6),(1414,796820419,5),(1414,814960819,6),(1414,828874820,5),(1414,846410420,6),(1414,860324420,5),(1414,877860021,6),(1414,891774021,5),(1414,909309621,6),(1414,923223622,5),(1414,941364022,6),(1414,954673222,5),(1414,972813622,6),(1414,986122822,5),(1414,1004263222,6),(1414,1018177222,5),(1414,1035712822,6),(1414,1049626822,5),(1414,1067162422,6),(1414,1081076422,5),(1414,1099216822,6),(1414,1112526022,5),(1414,1130666422,6),(1414,1143975623,5),(1414,1162116023,6),(1414,1173610823,5),(1414,1194170423,6),(1414,1205060423,5),(1414,1225620023,6),(1414,1236510024,5),(1414,1257069624,6),(1414,1268564424,5),(1414,1289124024,6),(1414,1300014024,5),(1414,1320573624,6),(1414,1331463624,5),(1414,1352023225,6),(1414,1362913225,5),(1414,1383472825,6),(1414,1394362825,5),(1414,1414922425,6),(1414,1425812425,5),(1414,1446372026,6),(1414,1457866826,5),(1414,1478426426,6),(1414,1489316427,5),(1414,1509876027,6),(1414,1520766027,5),(1414,1541325627,6),(1414,1552215627,5),(1414,1572775227,6),(1414,1583665227,5),(1414,1604224827,6),(1414,1615719627,5),(1414,1636279227,6),(1414,1647169227,5),(1414,1667728827,6),(1414,1678618827,5),(1414,1699178427,6),(1414,1710068427,5),(1414,1730628027,6),(1414,1741518027,5),(1414,1762077627,6),(1414,1772967627,5),(1414,1793527227,6),(1414,1805022027,5),(1414,1825581627,6),(1414,1836471627,5),(1414,1857031227,6),(1414,1867921227,5),(1414,1888480827,6),(1414,1899370827,5),(1414,1919930427,6),(1414,1930820427,5),(1414,1951380027,6),(1414,1962874827,5),(1414,1983434427,6),(1414,1994324427,5),(1414,2014884027,6),(1414,2025774027,5),(1414,2046333627,6),(1414,2057223627,5),(1414,2077783227,6),(1414,2088673227,5),(1414,2109232827,6),(1414,2120122827,5),(1414,2140682427,6),(1415,-2147483648,0),(1415,-1998663968,2),(1415,-1632063600,1),(1415,-1615132800,2),(1415,-1600614000,1),(1415,-1596816000,2),(1415,-1567954800,1),(1415,-1551628800,2),(1415,-1536505200,1),(1415,-1523203200,2),(1415,-1504450800,1),(1415,-1491753600,2),(1415,-1473001200,1),(1415,-1459699200,2),(1415,-880210800,3),(1415,-769395600,4),(1415,-765388800,2),(1415,-715791600,1),(1415,-702489600,2),(1415,73472400,1),(1415,89193601,2),(1415,104922002,1),(1415,120643202,2),(1415,136371603,1),(1415,152092803,2),(1415,167821204,1),(1415,183542404,2),(1415,199270805,1),(1415,215596805,2),(1415,230720406,1),(1415,247046406,2),(1415,262774807,1),(1415,278496007,2),(1415,294224408,1),(1415,309945608,2),(1415,325674009,1),(1415,341395209,2),(1415,357123609,1),(1415,372844810,2),(1415,388573210,1),(1415,404899211,2),(1415,420022811,1),(1415,436348812,2),(1415,452077212,1),(1415,467798412,2),(1415,483526812,1),(1415,499248013,2),(1415,514976413,1),(1415,530697613,2),(1415,544611613,1),(1415,562147213,2),(1415,576061214,1),(1415,594201614,2),(1415,607510814,1),(1415,625651214,2),(1415,638960415,1),(1415,657100815,2),(1415,671014816,1),(1415,688550416,2),(1415,702464416,1),(1415,720000017,2),(1415,733914017,1),(1415,752054418,2),(1415,765363618,1),(1415,783504019,2),(1415,796813219,1),(1415,814953619,2),(1415,828867620,1),(1415,846403220,2),(1415,860317220,1),(1415,877852821,2),(1415,891766821,1),(1415,909302421,2),(1415,923216422,1),(1415,941356822,2),(1415,954666022,1),(1415,972806422,2),(1415,986115622,1),(1415,1004256022,2),(1415,1018170022,1),(1415,1035705622,2),(1415,1049619622,1),(1415,1067155222,2),(1415,1081069222,1),(1415,1099209622,2),(1415,1112518822,1),(1415,1130659222,2),(1415,1143968423,1),(1415,1162108823,2),(1415,1173603623,1),(1415,1194163223,2),(1415,1205053223,1),(1415,1225612823,2),(1415,1236502824,1),(1415,1257062424,2),(1415,1268557224,1),(1415,1289116824,2),(1415,1300006824,1),(1415,1320566424,2),(1415,1331456424,1),(1415,1352016025,2),(1415,1362906025,1),(1415,1383465625,2),(1415,1394355625,1),(1415,1414915225,2),(1415,1425805225,1),(1415,1446364826,2),(1415,1457859626,1),(1415,1478419226,2),(1415,1489309227,1),(1415,1509868827,2),(1415,1520758827,1),(1415,1541318427,2),(1415,1552208427,1),(1415,1572768027,2),(1415,1583658027,1),(1415,1604217627,2),(1415,1615712427,1),(1415,1636272027,2),(1415,1647162027,1),(1415,1667721627,2),(1415,1678611627,1),(1415,1699171227,2),(1415,1710061227,1),(1415,1730620827,2),(1415,1741510827,1),(1415,1762070427,2),(1415,1772960427,1),(1415,1793520027,2),(1415,1805014827,1),(1415,1825574427,2),(1415,1836464427,1),(1415,1857024027,2),(1415,1867914027,1),(1415,1888473627,2),(1415,1899363627,1),(1415,1919923227,2),(1415,1930813227,1),(1415,1951372827,2),(1415,1962867627,1),(1415,1983427227,2),(1415,1994317227,1),(1415,2014876827,2),(1415,2025766827,1),(1415,2046326427,2),(1415,2057216427,1),(1415,2077776027,2),(1415,2088666027,1),(1415,2109225627,2),(1415,2120115627,1),(1415,2140675227,2),(1416,-2147483648,0),(1416,-31536000,1),(1416,1255802424,2),(1416,1267714824,1),(1416,1319738424,2),(1416,1329843624,3),(1416,1477065626,2),(1416,1520701227,1),(1416,1538856027,2),(1416,1552752027,1),(1416,1570129227,2),(1416,1583596827,1),(1416,1601740887,2),(1417,-2147483648,0),(1417,-409190400,1),(1417,-163062000,0),(1417,-28857600,1),(1417,1255806024,2),(1417,1268251224,3),(1417,1319742024,2),(1417,1329854424,3),(1419,-2147483648,1),(1419,-1680508800,2),(1419,-1665388800,3),(1419,-1601719200,4),(1419,-687052800,1),(1419,-71136000,5),(1419,-55411200,3),(1419,-37267200,5),(1419,-25776000,3),(1419,-5817600,5),(1419,5673600,3),(1419,25632000,5),(1419,37728000,3),(1419,57686400,5),(1419,67968000,3),(1419,89136001,5),(1419,100022402,3),(1419,120585602,5),(1419,131472003,3),(1419,152035203,5),(1419,162921604,3),(1419,183484804,5),(1419,194976005,3),(1419,215539205,5),(1419,226425606,3),(1419,246988806,5),(1419,257875207,3),(1419,278438407,5),(1419,289324808,3),(1419,309888008,5),(1419,320774409,3),(1419,341337609,5),(1419,352224009,3),(1419,372787210,5),(1419,386092810,3),(1419,404841611,5),(1419,417542411,3),(1419,436291212,5),(1419,447177612,3),(1419,467740812,5),(1419,478627212,3),(1419,499190413,5),(1419,510076813,3),(1419,530035213,5),(1419,542736013,3),(1419,562089613,5),(1419,574790414,3),(1419,594144014,5),(1419,606240014,3),(1419,625593614,5),(1419,637689615,3),(1419,657043215,5),(1419,670348816,3),(1419,686678416,5),(1419,701798416,3),(1419,718128017,5),(1419,733248017,3),(1419,749577618,5),(1419,764697618,3),(1419,781027219,5),(1419,796147219,3),(1419,812476819,5),(1419,828201620,3),(1419,844531220,5),(1419,859651220,3),(1419,875980821,5),(1419,891100821,3),(1419,907430421,5),(1419,922550422,3),(1419,938880022,5),(1419,954000022,3),(1419,967305622,5),(1419,985449622,3),(1419,1002384022,5),(1419,1017504022,3),(1419,1033833622,5),(1419,1048953622,3),(1419,1065283222,5),(1419,1080403222,3),(1419,1096732822,5),(1419,1111852822,3),(1419,1128182422,5),(1419,1143907223,3),(1419,1159632023,5),(1419,1174752023,3),(1419,1191686423,5),(1419,1207411223,3),(1419,1223136023,5),(1419,1238860824,3),(1419,1254585624,5),(1419,1262264424,2),(1419,1301760024,3),(1419,1317484824,5),(1419,1333209624,3),(1419,1349539225,5),(1419,1365264025,3),(1419,1380988825,5),(1419,1396713625,3),(1419,1412438425,5),(1419,1428163225,3),(1419,1443888026,5),(1419,1459612826,3),(1419,1475337626,5),(1419,1491062427,3),(1419,1506787227,5),(1419,1522512027,3),(1419,1538841627,5),(1419,1554566427,3),(1419,1570291227,5),(1419,1586016027,3),(1419,1601740827,5),(1419,1617465627,3),(1419,1633190427,5),(1419,1648915227,3),(1419,1664640027,5),(1419,1680364827,3),(1419,1696089627,5),(1419,1712419227,3),(1419,1728144027,5),(1419,1743868827,3),(1419,1759593627,5),(1419,1775318427,3),(1419,1791043227,5),(1419,1806768027,3),(1419,1822492827,5),(1419,1838217627,3),(1419,1853942427,5),(1419,1869667227,3),(1419,1885996827,5),(1419,1901721627,3),(1419,1917446427,5),(1419,1933171227,3),(1419,1948896027,5),(1419,1964620827,3),(1419,1980345627,5),(1419,1996070427,3),(1419,2011795227,5),(1419,2027520027,3),(1419,2043244827,5),(1419,2058969627,3),(1419,2075299227,5),(1419,2091024027,3),(1419,2106748827,5),(1419,2122473627,3),(1419,2138198427,5),(1420,-2147483648,0),(1420,-501206400,1),(1420,1255809624,2),(1421,-2147483648,2),(1421,-1330335000,1),(1421,-1320057000,2),(1421,-1300699800,3),(1421,-1287396000,2),(1421,-1269250200,3),(1421,-1255946400,2),(1421,-1237800600,3),(1421,-1224496800,2),(1421,-1206351000,3),(1421,-1192442400,2),(1421,-1174901400,3),(1421,-1160992800,2),(1421,-1143451800,3),(1421,-1125914400,2),(1421,-1112607000,3),(1421,-1094464800,2),(1421,-1081157400,3),(1421,-1063015200,2),(1421,-1049707800,3),(1421,-1031565600,2),(1421,-1018258200,3),(1421,-1000116000,2),(1421,-986808600,3),(1421,-968061600,2),(1421,-955359000,3),(1421,-936612000,2),(1421,-923304600,3),(1421,-757425600,6),(1421,152632803,4),(1421,162309604,5),(1421,183477604,4),(1421,194968805,5),(1421,215532005,4),(1421,226418406,5),(1421,246981606,4),(1421,257868007,5),(1421,278431207,4),(1421,289317608,5),(1421,309880808,4),(1421,320767209,5),(1421,341330409,4),(1421,352216809,5),(1421,372780010,4),(1421,384271210,5),(1421,404834411,4),(1421,415720811,5),(1421,436284012,4),(1421,447170412,5),(1421,467733612,4),(1421,478620012,5),(1421,499183213,4),(1421,510069613,5),(1421,530632813,4),(1421,541519213,5),(1421,562082413,4),(1421,573573614,5),(1421,594136814,4),(1421,605023214,5),(1421,623772014,4),(1421,637682415,5),(1421,655221615,4),(1421,669132016,5),(1421,686671216,4),(1421,700581616,5),(1421,718120817,4),(1421,732636017,5),(1421,749570418,4),(1421,764085618,5),(1421,781020019,4),(1421,795535219,5),(1421,812469619,4),(1421,826984820,5),(1421,844524020,4),(1421,858434420,5),(1421,875973621,4),(1421,889884021,5),(1421,907423221,4),(1421,921938422,5),(1421,938872822,4),(1421,953388022,5),(1421,970322422,4),(1421,984837622,5),(1421,1002376822,4),(1421,1016287222,5),(1421,1033826422,4),(1421,1047736822,5),(1421,1065276022,4),(1421,1079791222,5),(1421,1096725622,4),(1421,1111240822,5),(1421,1128175222,4),(1421,1142690423,5),(1421,1159624823,4),(1421,1174140023,5),(1421,1191074423,4),(1421,1207404023,5),(1421,1222524023,4),(1421,1238853624,5),(1421,1253973624,4),(1421,1270303224,5),(1421,1285423224,4),(1421,1301752824,5),(1421,1316872824,4),(1421,1333202424,5),(1421,1348927225,4),(1421,1365256825,5),(1421,1380376825,4),(1421,1396706425,5),(1421,1411826425,4),(1421,1428156025,5),(1421,1443276026,4),(1421,1459605626,5),(1421,1474725626,4),(1421,1491055227,5),(1421,1506175227,4),(1421,1522504827,5),(1421,1538229627,4),(1421,1554559227,5),(1421,1569679227,4),(1421,1586008827,5),(1421,1601128827,4),(1421,1617458427,5),(1421,1632578427,4),(1421,1648908027,5),(1421,1664028027,4),(1421,1680357627,5),(1421,1695477627,4),(1421,1712412027,5),(1421,1727532027,4),(1421,1743861627,5),(1421,1758981627,4),(1421,1775311227,5),(1421,1790431227,4),(1421,1806760827,5),(1421,1821880827,4),(1421,1838210427,5),(1421,1853330427,4),(1421,1869660027,5),(1421,1885384827,4),(1421,1901714427,5),(1421,1916834427,4),(1421,1933164027,5),(1421,1948284027,4),(1421,1964613627,5),(1421,1979733627,4),(1421,1996063227,5),(1421,2011183227,4),(1421,2027512827,5),(1421,2042632827,4),(1421,2058962427,5),(1421,2074687227,4),(1421,2091016827,5),(1421,2106136827,4),(1421,2122466427,5),(1421,2137586427,4),(1422,-2147483648,0),(1422,-157766400,2),(1422,-152658000,1),(1422,-132955200,2),(1422,-121122000,1),(1422,-101419200,2),(1422,-86821200,1),(1422,-71092800,2),(1422,-54766800,1),(1422,-39038400,2),(1422,-23317200,1),(1422,-7588800,4),(1422,128142003,3),(1422,136605603,4),(1422,389070010,1),(1422,403070411,5),(1422,416372411,6),(1422,434520012,5),(1422,447822012,6),(1422,466574412,5),(1422,479271612,6),(1422,498024013,5),(1422,510721213,6),(1422,529473613,5),(1422,545194813,6),(1422,560923213,5),(1422,574225214,6),(1422,592372814,5),(1422,605674814,6),(1422,624427214,5),(1422,637124415,6),(1422,653457615,5),(1422,668574016,6),(1422,687326416,5),(1422,700628416,6),(1422,718776017,5),(1422,732078017,6),(1422,750225618,5),(1422,763527618,6),(1422,781675219,5),(1422,794977219,6),(1422,813729619,5),(1422,826426820,6),(1422,845179220,5),(1422,859690820,6),(1422,876628821,5),(1422,889930821,6),(1422,906868821,5),(1422,923194822,6),(1422,939528022,5),(1422,952830022,6),(1422,971582422,5),(1422,984279622,6),(1422,1003032022,5),(1422,1015729222,6),(1422,1034481622,5),(1422,1047178822,6),(1422,1065931222,5),(1422,1079233222,6),(1422,1097380822,5),(1422,1110682822,6),(1422,1128830422,5),(1422,1142132423,6),(1422,1160884823,5),(1422,1173582023,6),(1422,1192334423,5),(1422,1206846023,6),(1422,1223784023,5),(1422,1237086024,6),(1422,1255233624,5),(1422,1270350024,6),(1422,1286683224,5),(1422,1304823624,6),(1422,1313899224,5),(1422,1335668424,6),(1422,1346558425,5),(1422,1367118025,6),(1422,1378612825,5),(1422,1398567625,6),(1422,1410062425,5),(1422,1463281226,6),(1422,1471147226,5),(1422,1480820426,4),(1423,-2147483648,0),(1423,218246405,1),(1424,-2147483648,2),(1424,-1330335000,1),(1424,-1320057000,2),(1424,-1300699800,3),(1424,-1287396000,2),(1424,-1269250200,3),(1424,-1255946400,2),(1424,-1237800600,3),(1424,-1224496800,2),(1424,-1206351000,3),(1424,-1192442400,2),(1424,-1174901400,3),(1424,-1160992800,2),(1424,-1143451800,3),(1424,-1125914400,2),(1424,-1112607000,3),(1424,-1094464800,2),(1424,-1081157400,3),(1424,-1063015200,2),(1424,-1049707800,3),(1424,-1031565600,2),(1424,-1018258200,3),(1424,-1000116000,2),(1424,-986808600,3),(1424,-968061600,2),(1424,-955359000,3),(1424,-936612000,2),(1424,-923304600,3),(1424,-757425600,6),(1424,152632803,4),(1424,162309604,5),(1424,183477604,4),(1424,194968805,5),(1424,215532005,4),(1424,226418406,5),(1424,246981606,4),(1424,257868007,5),(1424,278431207,4),(1424,289317608,5),(1424,309880808,4),(1424,320767209,5),(1424,341330409,4),(1424,352216809,5),(1424,372780010,4),(1424,384271210,5),(1424,404834411,4),(1424,415720811,5),(1424,436284012,4),(1424,447170412,5),(1424,467733612,4),(1424,478620012,5),(1424,499183213,4),(1424,510069613,5),(1424,530632813,4),(1424,541519213,5),(1424,562082413,4),(1424,573573614,5),(1424,594136814,4),(1424,605023214,5),(1424,623772014,4),(1424,637682415,5),(1424,655221615,4),(1424,669132016,5),(1424,686671216,4),(1424,700581616,5),(1424,718120817,4),(1424,732636017,5),(1424,749570418,4),(1424,764085618,5),(1424,781020019,4),(1424,795535219,5),(1424,812469619,4),(1424,826984820,5),(1424,844524020,4),(1424,858434420,5),(1424,875973621,4),(1424,889884021,5),(1424,907423221,4),(1424,921938422,5),(1424,938872822,4),(1424,953388022,5),(1424,970322422,4),(1424,984837622,5),(1424,1002376822,4),(1424,1016287222,5),(1424,1033826422,4),(1424,1047736822,5),(1424,1065276022,4),(1424,1079791222,5),(1424,1096725622,4),(1424,1111240822,5),(1424,1128175222,4),(1424,1142690423,5),(1424,1159624823,4),(1424,1174140023,5),(1424,1191074423,4),(1424,1207404023,5),(1424,1222524023,4),(1424,1238853624,5),(1424,1253973624,4),(1424,1270303224,5),(1424,1285423224,4),(1424,1301752824,5),(1424,1316872824,4),(1424,1333202424,5),(1424,1348927225,4),(1424,1365256825,5),(1424,1380376825,4),(1424,1396706425,5),(1424,1411826425,4),(1424,1428156025,5),(1424,1443276026,4),(1424,1459605626,5),(1424,1474725626,4),(1424,1491055227,5),(1424,1506175227,4),(1424,1522504827,5),(1424,1538229627,4),(1424,1554559227,5),(1424,1569679227,4),(1424,1586008827,5),(1424,1601128827,4),(1424,1617458427,5),(1424,1632578427,4),(1424,1648908027,5),(1424,1664028027,4),(1424,1680357627,5),(1424,1695477627,4),(1424,1712412027,5),(1424,1727532027,4),(1424,1743861627,5),(1424,1758981627,4),(1424,1775311227,5),(1424,1790431227,4),(1424,1806760827,5),(1424,1821880827,4),(1424,1838210427,5),(1424,1853330427,4),(1424,1869660027,5),(1424,1885384827,4),(1424,1901714427,5),(1424,1916834427,4),(1424,1933164027,5),(1424,1948284027,4),(1424,1964613627,5),(1424,1979733627,4),(1424,1996063227,5),(1424,2011183227,4),(1424,2027512827,5),(1424,2042632827,4),(1424,2058962427,5),(1424,2074687227,4),(1424,2091016827,5),(1424,2106136827,4),(1424,2122466427,5),(1424,2137586427,4),(1425,-2147483648,0),(1425,-719636812,1),(1426,-2147483648,0),(1426,1108166422,3),(1426,1111885222,1),(1426,1130634022,2),(1426,1143334823,1),(1426,1162083623,2),(1426,1174784423,1),(1426,1193533223,2),(1426,1206838823,1),(1426,1224982823,2),(1426,1238288424,1),(1426,1256432424,2),(1426,1269738024,1),(1426,1288486824,2),(1426,1301187624,1),(1426,1319936424,2),(1426,1332637224,1),(1426,1351386025,2),(1426,1364691625,1),(1426,1382835625,2),(1426,1396141225,1),(1426,1414285225,2),(1426,1427590825,1),(1426,1445734826,2),(1426,1459040426,1),(1426,1477789226,2),(1426,1490490027,1),(1426,1509238827,2),(1426,1521939627,1),(1426,1540688427,2),(1426,1553994027,1),(1426,1572138027,2),(1426,1585443627,1),(1426,1603587627,2),(1426,1616893227,1),(1426,1635642027,2),(1426,1648342827,1),(1426,1667091627,2),(1426,1679792427,1),(1426,1698541227,2),(1426,1711846827,1),(1426,1729990827,2),(1426,1743296427,1),(1426,1761440427,2),(1426,1774746027,1),(1426,1792890027,2),(1426,1806195627,1),(1426,1824944427,2),(1426,1837645227,1),(1426,1856394027,2),(1426,1869094827,1),(1426,1887843627,2),(1426,1901149227,1),(1426,1919293227,2),(1426,1932598827,1),(1426,1950742827,2),(1426,1964048427,1),(1426,1982797227,2),(1426,1995498027,1),(1426,2014246827,2),(1426,2026947627,1),(1426,2045696427,2),(1426,2058397227,1),(1426,2077146027,2),(1426,2090451627,1),(1426,2108595627,2),(1426,2121901227,1),(1426,2140045227,2),(1427,-2147483648,0),(1427,-1325483420,1),(1428,-2147483648,2),(1428,-1693706400,1),(1428,-1680483600,2),(1428,-1663455600,3),(1428,-1650150000,4),(1428,-1632006000,3),(1428,-1618700400,4),(1428,-938905200,3),(1428,-857257200,4),(1428,-844556400,3),(1428,-828226800,4),(1428,-812502000,3),(1428,-796777200,4),(1428,-781052400,3),(1428,-776563200,5),(1428,-765936000,1),(1428,-761180400,4),(1428,-757386000,2),(1428,-748479600,3),(1428,-733273200,4),(1428,-717631200,3),(1428,-714610800,6),(1428,-710380800,1),(1428,-701910000,4),(1428,-684975600,3),(1428,-670460400,4),(1428,-654130800,3),(1428,-639010800,4),(1428,315529208,2),(1428,323830809,7),(1428,338950809,8),(1428,354675609,7),(1428,370400410,8),(1428,386125210,7),(1428,401850011,8),(1428,417574811,7),(1428,433299612,8),(1428,449024412,7),(1428,465354012,8),(1428,481078812,7),(1428,496803613,8),(1428,512528413,7),(1428,528253213,8),(1428,543978013,7),(1428,559702813,8),(1428,575427614,7),(1428,591152414,8),(1428,606877214,7),(1428,622602014,8),(1428,638326815,7),(1428,654656415,8),(1428,670381216,7),(1428,686106016,8),(1428,701830816,7),(1428,717555617,8),(1428,733280417,7),(1428,749005218,8),(1428,764730018,7),(1428,780454819,8),(1428,796179619,7),(1428,811904419,8),(1428,828234020,7),(1428,846378020,8),(1428,859683620,7),(1428,877827621,8),(1428,891133221,7),(1428,909277221,8),(1428,922582822,7),(1428,941331622,8),(1428,954032422,7),(1428,972781222,8),(1428,985482022,7),(1428,1004230822,8),(1428,1017536422,7),(1428,1035680422,8),(1428,1048986022,7),(1428,1067130022,8),(1428,1080435622,7),(1428,1099184422,8),(1428,1111885222,7),(1428,1130634022,8),(1428,1143334823,7),(1428,1162083623,8),(1428,1174784423,7),(1428,1193533223,8),(1428,1206838823,7),(1428,1224982823,8),(1428,1238288424,7),(1428,1256432424,8),(1428,1269738024,7),(1428,1288486824,8),(1428,1301187624,7),(1428,1319936424,8),(1428,1332637224,7),(1428,1351386025,8),(1428,1364691625,7),(1428,1382835625,8),(1428,1396141225,7),(1428,1414285225,8),(1428,1427590825,7),(1428,1445734826,8),(1428,1459040426,7),(1428,1477789226,8),(1428,1490490027,7),(1428,1509238827,8),(1428,1521939627,7),(1428,1540688427,8),(1428,1553994027,7),(1428,1572138027,8),(1428,1585443627,7),(1428,1603587627,8),(1428,1616893227,7),(1428,1635642027,8),(1428,1648342827,7),(1428,1667091627,8),(1428,1679792427,7),(1428,1698541227,8),(1428,1711846827,7),(1428,1729990827,8),(1428,1743296427,7),(1428,1761440427,8),(1428,1774746027,7),(1428,1792890027,8),(1428,1806195627,7),(1428,1824944427,8),(1428,1837645227,7),(1428,1856394027,8),(1428,1869094827,7),(1428,1887843627,8),(1428,1901149227,7),(1428,1919293227,8),(1428,1932598827,7),(1428,1950742827,8),(1428,1964048427,7),(1428,1982797227,8),(1428,1995498027,7),(1428,2014246827,8),(1428,2026947627,7),(1428,2045696427,8),(1428,2058397227,7),(1428,2077146027,8),(1428,2090451627,7),(1428,2108595627,8),(1428,2121901227,7),(1428,2140045227,8),(1429,-2147483648,0),(1429,-719636812,1),(1430,-2147483648,0),(1430,-1441170468,1),(1430,-1247547600,3),(1430,354909609,2),(1430,370717210,3),(1430,386445610,2),(1430,402253211,3),(1430,417981611,2),(1430,433789212,3),(1430,449604012,2),(1430,465336012,4),(1430,481060812,5),(1430,496785613,4),(1430,512510413,5),(1430,528235213,4),(1430,543960013,5),(1430,559684813,4),(1430,575409614,5),(1430,591134414,4),(1430,606859214,5),(1430,622584014,4),(1430,638308815,5),(1430,654638415,4),(1430,670363216,6),(1430,686091616,7),(1430,695768416,4),(1430,701812816,5),(1430,717537617,4),(1430,733262417,5),(1430,748987218,4),(1430,764712018,5),(1430,780436819,4),(1430,796161619,5),(1430,811886419,4),(1430,828216020,5),(1430,846360020,4),(1430,859665620,5),(1430,877809621,4),(1430,891115221,5),(1430,909259221,4),(1430,922564822,5),(1430,941313622,4),(1430,954014422,5),(1430,972763222,4),(1430,985464022,5),(1430,1004212822,4),(1430,1017518422,5),(1430,1035662422,4),(1430,1048968022,5),(1430,1067112022,4),(1430,1080417622,5),(1430,1099166422,4),(1431,-2147483648,0),(1431,-1230776624,2),(1431,108165602,1),(1431,118270802,2),(1431,136591203,1),(1431,149806803,2),(1431,168127204,1),(1431,181342804,2),(1431,199749605,1),(1431,215643605,2),(1431,231285606,1),(1431,244501206,2),(1431,262735207,1),(1431,275950807,2),(1431,481154412,1),(1431,496962013,2),(1431,512949613,1),(1431,528670813,2),(1431,544399213,1),(1431,560120413,2),(1431,575848814,1),(1431,592174814,2),(1431,610581614,1),(1431,623624414,2),(1431,641167215,1),(1431,655074015,2),(1431,671839216,1),(1431,685918816,2),(1431,702856816,1),(1431,717973217,2),(1431,733701617,1),(1431,749422818,2),(1431,765151218,1),(1431,779662819,2),(1431,797205619,1),(1431,811116019,3),(1431,828655220,1),(1431,843170420,3),(1431,860104820,1),(1431,874620021,3),(1431,891554421,1),(1431,906069621,3),(1431,930780022,4),(1431,938124022,3),(1431,954367222,4),(1431,970178422,3),(1431,985816822,4),(1431,1001628022,3),(1431,1017352822,1),(1431,1033077622,3),(1431,1048802422,1),(1431,1066946422,3),(1431,1080252022,1),(1431,1097791222,3),(1431,1112306422,1),(1431,1128031222,3),(1431,1143756023,1),(1431,1161900023,3),(1431,1175205623,1),(1431,1193349623,3),(1431,1206655223,1),(1431,1225404023,3),(1431,1238104824,1),(1431,1256853624,3),(1431,1269554424,1),(1431,1288303224,3),(1431,1301608824,1),(1431,1319752824,3),(1431,1333058424,1),(1431,1387486825,2),(1431,1395957625,1),(1431,1414706425,3),(1431,1427407225,1),(1431,1446156026,3),(1431,1459461626,1),(1431,1477605626,3),(1431,1490911227,1),(1431,1509055227,3),(1431,1522360827,1),(1431,1540504827,3),(1431,1553810427,1),(1431,1571954427,3),(1431,1585260027,1),(1431,1604008827,3),(1431,1616709627,1),(1431,1635458427,3),(1431,1645740027,1),(1431,1666908027,5),(1432,-2147483648,0),(1432,-1441194596,1),(1432,-1247572800,3),(1432,354884409,2),(1432,370692010,3),(1432,386420410,4),(1432,402231611,1),(1432,417960011,4),(1432,433767612,1),(1432,449582412,4),(1432,465314412,5),(1432,481039212,6),(1432,496764013,5),(1432,512488813,6),(1432,528213613,5),(1432,543938413,6),(1432,559663213,5),(1432,575388014,6),(1432,591112814,5),(1432,606837614,6),(1432,622562414,5),(1432,638287215,6),(1432,654616815,5),(1432,670341616,7),(1432,686070016,8),(1432,695746816,5),(1432,701791216,6),(1432,717516017,5),(1432,733240817,6),(1432,748965618,5),(1432,764690418,6),(1432,780415219,5),(1432,796140019,6),(1432,811864819,5),(1432,828194420,6),(1432,846338420,5),(1432,859644020,6),(1432,877788021,5),(1432,891093621,6),(1432,909237621,5),(1432,922543222,6),(1432,941292022,5),(1432,953992822,6),(1432,972741622,5),(1432,985442422,6),(1432,1004191222,5),(1432,1017496822,6),(1432,1035640822,5),(1432,1048946422,6),(1432,1067090422,5),(1432,1080396022,6),(1432,1099144822,5),(1432,1111845622,6),(1432,1130594422,5),(1432,1143295223,6),(1432,1162044023,5),(1432,1174744823,6),(1432,1193493623,5),(1432,1206799223,6),(1432,1224943223,5),(1432,1238248824,6),(1432,1256392824,5),(1432,1269698424,7),(1432,1288450824,8),(1432,1301151624,5),(1433,-2147483648,0),(1433,-1441164064,1),(1433,-1247544000,2),(1433,370724410,3),(1433,386445610,4),(1433,402256811,2),(1433,417985211,4),(1433,433792812,2),(1433,449607612,4),(1433,465339612,5),(1433,481064412,6),(1433,496789213,5),(1433,512514013,6),(1433,528238813,5),(1433,543963613,6),(1433,559688413,5),(1433,575413214,6),(1433,591138014,5),(1433,606862814,6),(1433,622587614,5),(1433,638312415,6),(1433,654642015,5),(1433,670366816,7),(1433,686095216,8),(1433,695772016,5),(1433,701816416,6),(1433,717541217,5),(1433,733266017,6),(1433,748990818,5),(1433,764715618,6),(1433,780440419,8),(1433,796168819,7),(1433,811893619,8),(1433,828223220,7),(1433,846367220,8),(1433,859672820,7),(1433,877816821,8),(1433,891122421,7),(1433,909266421,8),(1433,922572022,7),(1433,941320822,8),(1433,954021622,7),(1433,972770422,8),(1433,985471222,7),(1433,1004220022,8),(1433,1017525622,7),(1433,1035669622,8),(1433,1048975222,7),(1433,1067119222,8),(1433,1080424822,7),(1433,1099173622,5),(1434,-2147483648,0),(1434,-1441165720,1),(1434,-1247544000,2),(1434,354913209,3),(1434,370720810,4),(1434,386445610,3),(1434,402256811,2),(1434,417985211,3),(1434,433792812,2),(1434,449607612,3),(1434,465339612,5),(1434,481064412,6),(1434,496789213,5),(1434,512514013,6),(1434,528238813,5),(1434,543963613,6),(1434,559688413,5),(1434,575413214,6),(1434,591138014,5),(1434,606862814,6),(1434,622587614,5),(1434,638312415,6),(1434,654642015,5),(1434,670366816,7),(1434,686095216,8),(1434,695772016,5),(1434,701816416,6),(1434,717541217,5),(1434,733266017,6),(1434,748990818,5),(1434,764715618,6),(1434,780440419,5),(1434,796165219,6),(1434,811890019,5),(1434,828219620,6),(1434,846363620,5),(1434,859669220,6),(1434,877813221,5),(1434,891118821,6),(1434,909262821,5),(1434,922568422,6),(1434,941317222,5),(1434,954018022,6),(1434,972766822,5),(1434,985467622,6),(1434,1004216422,5),(1434,1017522022,6),(1434,1035666022,5),(1434,1048971622,6),(1434,1067115622,5),(1434,1080421222,6),(1434,1099170022,5),(1435,-2147483648,0),(1435,-1441166012,1),(1435,-1247544000,3),(1435,354913209,2),(1435,370720810,3),(1435,386449210,2),(1435,402256811,3),(1435,417985211,2),(1435,433792812,3),(1435,449607612,2),(1435,465339612,4),(1435,481064412,5),(1435,496789213,4),(1435,512514013,5),(1435,528238813,4),(1435,543963613,5),(1435,559688413,4),(1435,575413214,5),(1435,591138014,4),(1435,606862814,5),(1435,622587614,4),(1435,638312415,5),(1435,654642015,4),(1435,670366816,6),(1435,686095216,7),(1435,695772016,3),(1436,-2147483648,0),(1436,-1441166012,1),(1436,-1247544000,3),(1436,354913209,2),(1436,370720810,3),(1436,386449210,2),(1436,402256811,3),(1436,417985211,2),(1436,433792812,3),(1436,449607612,2),(1436,465339612,4),(1436,481064412,5),(1436,496789213,4),(1436,512514013,5),(1436,528238813,4),(1436,543963613,5),(1436,559688413,4),(1436,575413214,5),(1436,591138014,4),(1436,606862814,5),(1436,622587614,4),(1436,638312415,5),(1436,654642015,4),(1436,670366816,6),(1436,686095216,7),(1436,695772016,3),(1437,-2147483648,0),(1437,-1441164464,1),(1437,-1247540400,2),(1437,370724410,3),(1437,386445610,4),(1437,402256811,2),(1437,417985211,4),(1437,433792812,2),(1437,449607612,4),(1437,465339612,5),(1437,481064412,6),(1437,496789213,5),(1437,512514013,6),(1437,528238813,5),(1437,543963613,6),(1437,559688413,5),(1437,575413214,6),(1437,591138014,5),(1437,606862814,6),(1437,622587614,5),(1437,638312415,6),(1437,654642015,5),(1437,670366816,7),(1437,686095216,8),(1437,695772016,5),(1437,701816416,6),(1437,717541217,5),(1437,733266017,6),(1437,748990818,5),(1437,764715618,6),(1437,780440419,5),(1437,796165219,6),(1437,811890019,5),(1437,828219620,6),(1437,846363620,5),(1437,859669220,6),(1437,877813221,5),(1437,891118821,6),(1437,909262821,5),(1437,922568422,7),(1437,941320822,8),(1437,954021622,7),(1437,972770422,8),(1437,985471222,7),(1437,1004220022,8),(1437,1017525622,7),(1437,1035669622,8),(1437,1048975222,7),(1437,1067119222,8),(1437,1080424822,7),(1437,1099173622,5),(1438,-2147483648,1),(1438,-1641005856,2),(1438,389048410,3),(1438,402264011,2),(1438,417906011,3),(1438,433800012,2),(1438,449614812,3),(1438,465422412,2),(1438,481150812,3),(1438,496792813,4),(1438,512517613,5),(1438,528242413,4),(1438,543967213,5),(1438,559692013,4),(1438,575416814,5),(1438,591141614,4),(1438,606866414,5),(1438,622591214,4),(1438,638316015,5),(1438,654645615,4),(1438,670464016,5),(1438,686275216,4),(1438,702086416,5),(1438,717897617,4),(1438,733622417,5),(1438,749433618,4),(1438,765158418,5),(1438,780969619,4),(1438,796694419,5),(1438,812505619,4),(1438,828316820,5),(1438,844128020,4),(1438,859852820,5),(1438,875664021,4),(1438,891388821,5),(1438,907200021,4),(1438,922924822,5),(1438,938736022,4),(1438,954547222,5),(1438,970358422,4),(1438,986083222,5),(1438,1001894422,4),(1438,1017619222,5),(1438,1033430422,4),(1438,1049155222,5),(1438,1064966422,4),(1438,1080777622,5),(1438,1096588822,4),(1438,1112313622,5),(1438,1128124822,4),(1438,1143849623,5),(1438,1159660823,4),(1438,1175385623,5),(1438,1191196823,4),(1439,-2147483648,0),(1439,-1577935568,1),(1439,76190400,2),(1440,-2147483648,0),(1440,-1441163964,1),(1440,-405140400,3),(1440,354916809,2),(1440,370724410,3),(1440,386452810,2),(1440,402260411,3),(1440,417988811,2),(1440,433796412,3),(1440,449611212,2),(1440,465343212,4),(1440,481068012,5),(1440,496792813,4),(1440,512517613,5),(1440,528242413,4),(1440,543967213,5),(1440,559692013,4),(1440,575416814,5),(1440,591141614,4),(1440,606866414,5),(1440,622591214,4),(1440,638316015,5),(1440,654645615,4),(1440,670370416,6),(1440,686098816,7),(1440,701823616,6),(1440,717548417,4),(1440,820440019,3),(1440,828234020,8),(1440,846378020,9),(1440,852062420,3),(1440,859680020,2),(1440,877824021,3),(1440,891129621,2),(1440,909273621,3),(1440,922579222,2),(1440,941328022,3),(1440,954028822,2),(1440,972777622,3),(1440,985478422,2),(1440,1004227222,3),(1440,1017532822,2),(1440,1035676822,3),(1440,1048982422,2),(1440,1067126422,3),(1440,1080432022,2),(1440,1099180822,3),(1440,1111881622,2),(1440,1130630422,3),(1440,1143331223,2),(1440,1162080023,3),(1440,1174780823,2),(1440,1193529623,3),(1440,1206835223,2),(1440,1224979223,3),(1440,1238284824,2),(1440,1256428824,3),(1440,1269734424,2),(1440,1288483224,3),(1440,1301184024,2),(1440,1319932824,3),(1440,1332633624,2),(1440,1351382425,3),(1440,1364688025,2),(1440,1382832025,3),(1440,1396137625,2),(1440,1414281625,3),(1440,1427587225,2),(1440,1445731226,3),(1441,-2147483648,1),(1441,-1570084924,2),(1442,-2147483648,0),(1442,-1579844100,1),(1442,-1247551200,3),(1442,354906009,2),(1442,370713610,3),(1442,386442010,2),(1442,402249611,3),(1442,417978011,2),(1442,433785612,3),(1442,449600412,2),(1442,465332412,4),(1442,481057212,5),(1442,496782013,4),(1442,512506813,5),(1442,528231613,4),(1442,543956413,5),(1442,559681213,4),(1442,575406014,5),(1442,591130814,4),(1442,606855614,5),(1442,622580414,4),(1442,638305215,5),(1442,654634815,4),(1442,670359616,6),(1442,686088016,7),(1442,695764816,4),(1442,701809216,5),(1442,717534017,4),(1442,733258817,5),(1442,748983618,4),(1442,764708418,5),(1442,780433219,4),(1442,796158019,5),(1442,801590419,8),(1442,811886419,7),(1442,828216020,6),(1442,846360020,7),(1442,859665620,6),(1442,877809621,7),(1442,891115221,6),(1442,909259221,7),(1442,922564822,6),(1442,941313622,7),(1442,954014422,6),(1442,972763222,7),(1442,985464022,6),(1442,1004212822,7),(1442,1017518422,6),(1442,1035662422,7),(1442,1048968022,6),(1442,1067112022,7),(1442,1080417622,6),(1442,1099166422,7),(1442,1111867222,6),(1442,1130616022,7),(1442,1143316823,6),(1442,1162065623,7),(1442,1174766423,6),(1442,1193515223,7),(1442,1206820823,6),(1442,1224964823,7),(1442,1238270424,6),(1442,1256414424,7),(1442,1269720024,6),(1442,1288468824,7),(1442,1301169624,4),(1442,1414263625,7),(1442,1459022426,4),(1443,-2147483648,2),(1443,-1570413600,1),(1443,-1552186800,2),(1443,-1538359200,1),(1443,-1522551600,2),(1443,-1507514400,1),(1443,-1490583600,2),(1443,-1473645600,1),(1443,-1460948400,2),(1443,-399866400,1),(1443,-386650800,2),(1443,-368330400,1),(1443,-355114800,2),(1443,-336794400,1),(1443,-323578800,2),(1443,-305172000,1),(1443,-291956400,2),(1443,-273636000,1),(1443,-260420400,2),(1443,78012000,1),(1443,86734801,2),(1443,105055202,1),(1443,118270802,2),(1443,136591203,1),(1443,149806803,2),(1443,168127204,1),(1443,181342804,2),(1443,199749605,1),(1443,212965205,2),(1443,231285606,1),(1443,244501206,2),(1443,262735207,1),(1443,275950807,2),(1443,452210412,1),(1443,466722012,2),(1443,483746412,1),(1443,498258013,2),(1443,515282413,1),(1443,529794013,2),(1443,546818413,1),(1443,561330013,2),(1443,581119214,1),(1443,592952414,2),(1443,610754414,1),(1443,624488414,2),(1443,641512815,1),(1443,656024415,2),(1443,673048816,1),(1443,687560416,2),(1443,704671216,1),(1443,718146017,2),(1443,733269617,1),(1443,748990818,2),(1443,764719218,1),(1443,780440419,2),(1443,796168819,1),(1443,811890019,2),(1443,828223220,1),(1443,843944420,2),(1443,859672820,1),(1443,875394021,2),(1443,891122421,1),(1443,906843621,2),(1443,922572022,1),(1443,941317222,2),(1443,954021622,1),(1443,972766822,2),(1443,985471222,1),(1443,1004216422,2),(1443,1017525622,1),(1443,1035666022,2),(1443,1048975222,1),(1443,1067115622,2),(1443,1080424822,1),(1443,1099170022,2),(1443,1111874422,1),(1443,1130619622,2),(1443,1143324023,1),(1443,1162069223,2),(1443,1174773623,1),(1443,1193518823,2),(1443,1206828023,1),(1443,1224968423,2),(1443,1238277624,1),(1443,1256418024,2),(1443,1269727224,1),(1443,1288472424,2),(1443,1301176824,1),(1443,1319922024,2),(1443,1332626424,1),(1443,1351371625,2),(1443,1364680825,1),(1443,1382821225,2),(1443,1396130425,1),(1443,1414270825,2),(1443,1427580025,1),(1443,1445720426,2),(1443,1459029626,1),(1443,1477774826,2),(1443,1490479227,1),(1443,1509224427,2),(1443,1521928827,1),(1443,1540674027,2),(1443,1553983227,1),(1443,1572123627,2),(1443,1585432827,1),(1443,1603573227,2),(1443,1616882427,1),(1443,1635627627,2),(1443,1648332027,1),(1443,1667077227,2),(1443,1679781627,1),(1443,1698526827,2),(1443,1711836027,1),(1443,1729976427,2),(1443,1743285627,1),(1443,1761426027,2),(1443,1774735227,1),(1443,1792875627,2),(1443,1806184827,1),(1443,1824930027,2),(1443,1837634427,1),(1443,1856379627,2),(1443,1869084027,1),(1443,1887829227,2),(1443,1901138427,1),(1443,1919278827,2),(1443,1932588027,1),(1443,1950728427,2),(1443,1964037627,1),(1443,1982782827,2),(1443,1995487227,1),(1443,2014232427,2),(1443,2026936827,1),(1443,2045682027,2),(1443,2058386427,1),(1443,2077131627,2),(1443,2090440827,1),(1443,2108581227,2),(1443,2121890427,1),(1443,2140030827,2),(1444,-2147483648,0),(1444,-1441169904,1),(1444,-1247547600,3),(1444,354909609,2),(1444,370717210,3),(1444,386445610,2),(1444,402253211,3),(1444,417981611,2),(1444,433789212,3),(1444,449604012,2),(1444,465336012,4),(1444,481060812,5),(1444,496785613,4),(1444,512510413,5),(1444,528235213,4),(1444,543960013,5),(1444,559684813,4),(1444,575409614,5),(1444,591134414,4),(1444,606859214,5),(1444,622584014,4),(1444,638308815,5),(1444,654638415,4),(1444,670363216,6),(1444,683582416,1),(1444,703018816,6),(1444,717530417,1),(1444,734468417,6),(1444,748980018,1),(1444,765918018,6),(1444,780429619,1),(1444,797367619,6),(1444,811879219,1),(1444,828817220,6),(1444,843933620,1),(1444,859671020,7),(1444,877811421,1),(1444,891120621,7),(1444,909261021,1),(1444,922570222,7),(1444,941315422,1),(1444,954019822,7),(1444,972765022,1),(1444,985469422,7),(1444,1004214622,1),(1444,1017523822,7),(1444,1035664222,1),(1444,1048973422,7),(1444,1067113822,1),(1444,1080423022,7),(1444,1099168222,1),(1444,1111872622,7),(1444,1123783222,3),(1445,-2147483648,0),(1445,-1383463280,1),(1445,-1167636600,3),(1445,-1082448000,2),(1445,-1074586800,3),(1445,-1050825600,2),(1445,-1042964400,3),(1445,-1019289600,2),(1445,-1011428400,3),(1445,-987753600,2),(1445,-979892400,3),(1445,-956217600,2),(1445,-948356400,3),(1445,-924595200,2),(1445,-916734000,3),(1445,-893059200,2),(1445,-885198000,3),(1445,-879667200,4),(1445,-767005200,3),(1446,-2147483648,1),(1446,-2019705670,2),(1446,-891581400,3),(1446,-872058600,2),(1446,-862637400,3),(1446,-764145000,2),(1447,-2147483648,0),(1447,-1579419232,1),(1447,-1247558400,3),(1447,354898809,2),(1447,370706410,3),(1447,386434810,2),(1447,402242411,3),(1447,417970811,2),(1447,433778412,3),(1447,449593212,2),(1447,465325212,4),(1447,481050012,5),(1447,496774813,4),(1447,512499613,5),(1447,528224413,4),(1447,543949213,5),(1447,559674013,4),(1447,575398814,5),(1447,591123614,4),(1447,606848414,5),(1447,622573214,4),(1447,638298015,5),(1447,654627615,4),(1447,670352416,6),(1447,686080816,7),(1447,695757616,4),(1447,701802016,5),(1447,717526817,4),(1447,733251617,5),(1447,748976418,4),(1447,764701218,5),(1447,780426019,4),(1447,796150819,5),(1447,811875619,4),(1447,828205220,5),(1447,846349220,4),(1447,859654820,5),(1447,877798821,4),(1447,891104421,5),(1447,909248421,4),(1447,922554022,5),(1447,941302822,4),(1447,954003622,5),(1447,972752422,4),(1447,985453222,5),(1447,1004202022,4),(1447,1017507622,5),(1447,1035651622,4),(1447,1048957222,5),(1447,1067101222,4),(1447,1080406822,5),(1447,1099155622,4),(1447,1111856422,5),(1447,1130605222,4),(1447,1143306023,5),(1447,1162054823,4),(1447,1174755623,5),(1447,1193504423,4),(1447,1206810023,5),(1447,1224954023,4),(1447,1238259624,5),(1447,1256403624,4),(1447,1269709224,5),(1447,1288458024,4),(1447,1301158824,8),(1447,1414252825,7),(1447,1459015226,3),(1448,-2147483648,0),(1448,-2032933080,1),(1448,252435606,2),(1448,417974411,4),(1448,433778412,3),(1448,449593212,4),(1448,465314412,3),(1448,481042812,4),(1448,496764013,3),(1448,512492413,4),(1448,528213613,3),(1448,543942013,4),(1448,559663213,3),(1448,575391614,4),(1448,591112814,3),(1448,606841214,4),(1448,622562414,3),(1448,638290815,4),(1448,654616815,3),(1448,670345216,4),(1448,686066416,3),(1448,701794816,4),(1448,717516017,3),(1448,733244417,4),(1448,748965618,3),(1448,764694018,4),(1448,780415219,3),(1448,796143619,4),(1448,811864819,3),(1448,828198020,4),(1448,843919220,3),(1448,859647620,4),(1448,875368821,3),(1448,891097221,4),(1448,906818421,3),(1448,988390822,4),(1448,1001692822,3),(1448,1017421222,4),(1448,1033142422,3),(1448,1048870822,4),(1448,1064592022,3),(1448,1080320422,4),(1448,1096041622,3),(1448,1111770022,4),(1448,1127491222,3),(1448,1143219623,4),(1448,1159545623,3),(1448,1206889223,2),(1448,1427479225,5),(1448,1443193226,2),(1448,1458928826,5),(1448,1474642826,2),(1449,-2147483648,2),(1449,-1600675200,1),(1449,-1585904400,2),(1449,-933667200,1),(1449,-922093200,2),(1449,-908870400,1),(1449,-888829200,2),(1449,-881049600,1),(1449,-767869200,2),(1449,-745833600,1),(1449,-733827600,2),(1449,-716889600,1),(1449,-699613200,2),(1449,-683884800,1),(1449,-670669200,2),(1449,-652348800,1),(1449,-650019600,2),(1449,515527213,1),(1449,527014813,2),(1449,545162413,1),(1449,558464413,2),(1449,577216814,1),(1449,589914014,2),(1449,608666414,1),(1449,621968414,2),(1449,640116015,1),(1449,653418015,2),(1449,671565616,1),(1449,684867616,2),(1450,-2147483648,2),(1450,-1600675200,1),(1450,-1585904400,2),(1450,-933667200,1),(1450,-922093200,2),(1450,-908870400,1),(1450,-888829200,2),(1450,-881049600,1),(1450,-767869200,2),(1450,-745833600,1),(1450,-733827600,2),(1450,-716889600,1),(1450,-699613200,2),(1450,-683884800,1),(1450,-670669200,2),(1450,-652348800,1),(1450,-650019600,2),(1450,515527213,1),(1450,527014813,2),(1450,545162413,1),(1450,558464413,2),(1450,577216814,1),(1450,589914014,2),(1450,608666414,1),(1450,621968414,2),(1450,640116015,1),(1450,653418015,2),(1450,671565616,1),(1450,684867616,2),(1451,-2147483648,1),(1451,-2019705572,2),(1451,-883287000,3),(1451,-862639200,4),(1451,-764051400,2),(1451,832962620,5),(1451,846266420,6),(1451,1145039423,2),(1452,-2147483648,1),(1452,-891582800,2),(1452,-872058600,3),(1452,-862637400,2),(1452,-576138600,4),(1452,1245430824,5),(1452,1262278824,4),(1453,-2147483648,0),(1453,-1577931912,2),(1453,-1568592000,1),(1453,-1554080400,2),(1453,-1537142400,1),(1453,-1522630800,2),(1453,-1505692800,1),(1453,-1491181200,2),(1453,-1474243200,1),(1453,-1459126800,2),(1453,-242265600,1),(1453,-228877200,2),(1453,-210556800,1),(1453,-197427600,2),(1453,-178934400,1),(1453,-165718800,2),(1453,-147398400,1),(1453,-134269200,2),(1453,-116467200,1),(1453,-102646800,2),(1453,-84326400,1),(1453,-71110800,2),(1453,-52704000,1),(1453,-39488400,2),(1453,-21168000,1),(1453,-7952400,2),(1453,10368000,1),(1453,23583600,2),(1453,41904000,1),(1453,55119600,2),(1453,73526400,1),(1453,86742001,2),(1453,105062402,1),(1453,118278002,2),(1453,136598403,1),(1453,149814003,2),(1453,168134404,1),(1453,181350004,2),(1453,199756805,1),(1453,212972405,2),(1453,231292806,1),(1453,241916406,2),(1453,262828807,1),(1453,273452407,2),(1453,418694411,1),(1453,433810812,2),(1453,450316812,1),(1453,465433212,2),(1453,508896013,1),(1453,529196413,2),(1453,541555213,1),(1453,562633213,2),(1453,574387214,1),(1453,594255614,2),(1453,607305614,1),(1453,623199614,2),(1453,638928015,1),(1453,654649215,2),(1453,670456816,1),(1453,686264416,2),(1453,702684016,1),(1453,717886817,2),(1453,733096817,1),(1453,748904418,2),(1453,765151218,1),(1453,780958819,2),(1453,796687219,1),(1453,812494819,2),(1453,828309620,1),(1453,844117220,2),(1453,859759220,1),(1453,875653221,2),(1453,891208821,1),(1453,907189221,2),(1453,922917622,1),(1453,938725222,2),(1453,954540022,1),(1453,970347622,2),(1453,986076022,1),(1453,1001883622,2),(1453,1017612022,1),(1453,1033419622,2),(1453,1049148022,1),(1453,1064955622,2),(1453,1080770422,1),(1453,1096578022,2),(1453,1112306422,1),(1453,1128114022,2),(1453,1143842423,1),(1453,1158872423,2),(1453,1175205623,1),(1453,1193950823,2),(1453,1207260023,1),(1453,1225486823,2),(1453,1238104824,1),(1453,1256850024,2),(1453,1270159224,1),(1453,1288299624,2),(1453,1301608824,1),(1453,1319749224,2),(1453,1333058424,1),(1453,1351198825,2),(1453,1364508025,1),(1453,1382648425,2),(1453,1395957625,1),(1453,1414702825,2),(1453,1427407225,1),(1453,1446152426,2),(1453,1458856826,1),(1453,1477602026,2),(1453,1490911227,1),(1453,1509051627,2),(1453,1522360827,1),(1453,1540501227,2),(1453,1553810427,1),(1453,1571950827,2),(1453,1585260027,1),(1453,1604005227,2),(1453,1616709627,1),(1453,1635454827,2),(1453,1648159227,1),(1453,1666904427,3),(1454,-2147483648,1),(1454,-891582800,2),(1454,-872058600,3),(1454,-862637400,2),(1454,-576138600,4),(1454,1245430824,5),(1454,1262278824,4),(1455,-2147483648,0),(1455,-1830414140,1),(1455,-879152400,2),(1455,199897205,1),(1455,969120022,2),(1456,-2147483648,0),(1456,-1577936472,1),(1457,-2147483648,0),(1457,-1441168512,1),(1457,-1247547600,3),(1457,354909609,2),(1457,370717210,3),(1457,386445610,2),(1457,402253211,3),(1457,417981611,2),(1457,433789212,3),(1457,449604012,2),(1457,465336012,4),(1457,481060812,5),(1457,496785613,4),(1457,512510413,5),(1457,528235213,4),(1457,543960013,5),(1457,559684813,4),(1457,575409614,5),(1457,591134414,4),(1457,606859214,5),(1457,622584014,4),(1457,638308815,5),(1457,654638415,4),(1457,670363216,6),(1457,684363616,7),(1458,-2147483648,0),(1458,-1518920148,2),(1458,166572004,1),(1458,182293204,2),(1458,200959205,1),(1458,213829205,2),(1458,228866406,1),(1458,243982806,2),(1458,260316007,1),(1458,276123607,2),(1458,291765608,1),(1458,307486808,2),(1458,323820009,1),(1458,338936409,2),(1458,354664809,1),(1458,370386010,2),(1458,386114410,1),(1458,401835611,2),(1458,417564011,1),(1458,433285212,2),(1458,449013612,1),(1458,465339612,2),(1458,481068012,1),(1458,496789213,2),(1458,512517613,1),(1458,528238813,2),(1458,543967213,1),(1458,559688413,2),(1458,575416814,1),(1458,591138014,2),(1458,606866414,1),(1458,622587614,2),(1458,638316015,1),(1458,654642015,2),(1458,670370416,1),(1458,686091616,2),(1458,701820016,1),(1458,717541217,2),(1458,733269617,1),(1458,748990818,2),(1458,764719218,1),(1458,780440419,2),(1458,796168819,1),(1458,811890019,2),(1458,828223220,1),(1458,843944420,2),(1458,859672820,1),(1458,875394021,2),(1458,891122421,1),(1458,909277221,3),(1458,922582822,4),(1458,941331622,3),(1458,954032422,4),(1458,972781222,3),(1458,985482022,4),(1458,1004230822,3),(1458,1017536422,4),(1458,1035680422,3),(1458,1048986022,4),(1458,1067130022,3),(1458,1080435622,4),(1458,1099184422,3),(1458,1111885222,4),(1458,1130634022,3),(1458,1143334823,4),(1458,1162083623,3),(1458,1174784423,4),(1458,1193533223,3),(1458,1206838823,4),(1458,1224982823,3),(1458,1238288424,4),(1458,1256432424,3),(1458,1269738024,4),(1458,1288486824,3),(1458,1301187624,4),(1458,1319936424,3),(1458,1332637224,4),(1458,1351386025,3),(1458,1364691625,4),(1458,1382835625,3),(1458,1396141225,4),(1458,1414285225,3),(1458,1427590825,4),(1458,1445734826,3),(1458,1459040426,4),(1458,1473282026,5),(1458,1509238827,3),(1458,1521939627,4),(1458,1540688427,3),(1458,1553994027,4),(1458,1572138027,3),(1458,1585443627,4),(1458,1603587627,3),(1458,1616893227,4),(1458,1635642027,3),(1458,1648342827,4),(1458,1667091627,3),(1458,1679792427,4),(1458,1698541227,3),(1458,1711846827,4),(1458,1729990827,3),(1458,1743296427,4),(1458,1761440427,3),(1458,1774746027,4),(1458,1792890027,3),(1458,1806195627,4),(1458,1824944427,3),(1458,1837645227,4),(1458,1856394027,3),(1458,1869094827,4),(1458,1887843627,3),(1458,1901149227,4),(1458,1919293227,3),(1458,1932598827,4),(1458,1950742827,3),(1458,1964048427,4),(1458,1982797227,3),(1458,1995498027,4),(1458,2014246827,3),(1458,2026947627,4),(1458,2045696427,3),(1458,2058397227,4),(1458,2077146027,3),(1458,2090451627,4),(1458,2108595627,3),(1458,2121901227,4),(1458,2140045227,3),(1459,-2147483648,3),(1459,-933638400,1),(1459,-923097600,2),(1459,-919036800,1),(1459,-857347200,2),(1459,-844300800,1),(1459,-825811200,2),(1459,-812678400,1),(1459,-794188800,2),(1459,-779846400,1),(1459,-762652800,2),(1459,-748310400,1),(1459,-731116800,2),(1459,-682653600,3),(1459,-399088800,4),(1459,-386650800,3),(1459,-368330400,4),(1459,-355114800,3),(1459,-336790800,4),(1459,-323654400,3),(1459,-305168400,4),(1459,-292032000,3),(1459,-273632400,4),(1459,-260496000,3),(1459,-242096400,4),(1459,-228960000,3),(1459,-210560400,4),(1459,-197424000,3),(1459,-178938000,4),(1459,-165801600,3),(1459,-147402000,4),(1459,-134265600,3),(1459,-115866000,4),(1459,-102643200,3),(1459,-84330000,4),(1459,-81313200,6),(1459,142380003,5),(1459,150843603,6),(1459,167176804,5),(1459,178664404,6),(1459,334101609,7),(1459,337730409,8),(1459,452642412,7),(1459,462319212,8),(1459,482277612,5),(1459,494370013,6),(1459,516751213,5),(1459,526424413,6),(1459,545436013,5),(1459,558478813,6),(1459,576626414,5),(1459,589323614,6),(1459,609890414,5),(1459,620773214,6),(1459,638316015,5),(1459,651618015,6),(1459,669765616,5),(1459,683672416,6),(1459,701820016,5),(1459,715726817,6),(1459,733701617,5),(1459,747176418,6),(1459,765151218,5),(1459,778021219,6),(1459,796600819,5),(1459,810075619,6),(1459,820447219,3),(1459,828655220,4),(1459,843170420,9),(1459,860104820,4),(1459,874620021,9),(1459,891554421,4),(1459,906069621,9),(1459,915141621,3),(1459,924213622,4),(1459,939934822,3),(1459,956268022,4),(1459,971989222,3),(1459,987717622,4),(1459,1003438822,3),(1459,1019167222,4),(1459,1034888422,3),(1459,1050616822,4),(1459,1066338022,3),(1459,1082066422,4),(1459,1096581622,3),(1459,1113516022,4),(1459,1128380422,3),(1459,1143842423,4),(1459,1158872423,3),(1459,1175378423,4),(1459,1189638023,3),(1459,1206655223,4),(1459,1219957223,3),(1459,1238104824,4),(1459,1252015224,3),(1459,1269640884,4),(1459,1281474024,3),(1459,1301608884,4),(1459,1312146024,3),(1459,1333058424,4),(1459,1348178425,3),(1459,1364508025,4),(1459,1380229225,3),(1459,1395957625,4),(1459,1414098025,3),(1459,1427493625,4),(1459,1445551226,3),(1459,1458946826,4),(1459,1477692026,3),(1459,1490396427,4),(1459,1509141627,3),(1459,1521846027,4),(1459,1540591227,3),(1459,1553810427,4),(1459,1572037227,3),(1459,1585346427,4),(1459,1603490427,3),(1459,1616796027,4),(1459,1635458427,3),(1459,1648332027,4),(1459,1666998027,3),(1459,1682726427,4),(1459,1698447627,3),(1459,1712966427,4),(1459,1729897227,3),(1459,1743811227,4),(1459,1761346827,3),(1459,1774656027,4),(1459,1792796427,3),(1459,1806105627,4),(1459,1824850827,3),(1459,1837555227,4),(1459,1856300427,3),(1459,1869004827,4),(1459,1887750027,3),(1459,1901059227,4),(1459,1919199627,3),(1459,1932508827,4),(1459,1950649227,3),(1459,1963958427,4),(1459,1982703627,3),(1459,1995408027,4),(1459,2014153227,3),(1459,2026857627,4),(1459,2045602827,3),(1459,2058307227,4),(1459,2077052427,3),(1459,2090361627,4),(1459,2107897227,3),(1459,2121811227,4),(1459,2138742027,3),(1460,-2147483648,2),(1460,-1600675200,1),(1460,-1585904400,2),(1460,-933667200,1),(1460,-922093200,2),(1460,-908870400,1),(1460,-888829200,2),(1460,-881049600,1),(1460,-767869200,2),(1460,-745833600,1),(1460,-733827600,2),(1460,-716889600,1),(1460,-699613200,2),(1460,-683884800,1),(1460,-670669200,2),(1460,-652348800,1),(1460,-650019600,2),(1460,515527213,1),(1460,527014813,2),(1460,545162413,1),(1460,558464413,2),(1460,577216814,1),(1460,589914014,2),(1460,608666414,1),(1460,621968414,2),(1460,640116015,1),(1460,653418015,2),(1460,671565616,1),(1460,684867616,2),(1461,-2147483648,3),(1461,-933638400,1),(1461,-923097600,2),(1461,-919036800,1),(1461,-857347200,2),(1461,-844300800,1),(1461,-825811200,2),(1461,-812678400,1),(1461,-794188800,2),(1461,-779846400,1),(1461,-762652800,2),(1461,-748310400,1),(1461,-731116800,2),(1461,-682653600,3),(1461,-399088800,4),(1461,-386650800,3),(1461,-368330400,4),(1461,-355114800,3),(1461,-336790800,4),(1461,-323654400,3),(1461,-305168400,4),(1461,-292032000,3),(1461,-273632400,4),(1461,-260496000,3),(1461,-242096400,4),(1461,-228960000,3),(1461,-210560400,4),(1461,-197424000,3),(1461,-178938000,4),(1461,-165801600,3),(1461,-147402000,4),(1461,-134265600,3),(1461,-115866000,4),(1461,-102643200,3),(1461,-84330000,4),(1461,-81313200,6),(1461,142380003,5),(1461,150843603,6),(1461,167176804,5),(1461,178664404,6),(1461,334101609,7),(1461,337730409,8),(1461,452642412,7),(1461,462319212,8),(1461,482277612,5),(1461,494370013,6),(1461,516751213,5),(1461,526424413,6),(1461,545436013,5),(1461,558478813,6),(1461,576626414,5),(1461,589323614,6),(1461,609890414,5),(1461,620773214,6),(1461,638316015,5),(1461,651618015,6),(1461,669765616,5),(1461,683672416,6),(1461,701820016,5),(1461,715726817,6),(1461,733701617,5),(1461,747176418,6),(1461,765151218,5),(1461,778021219,6),(1461,796600819,5),(1461,810075619,6),(1461,820447219,3),(1461,828655220,4),(1461,843170420,9),(1461,860104820,4),(1461,874620021,9),(1461,891554421,4),(1461,906069621,9),(1461,915141621,3),(1461,924213622,4),(1461,939934822,3),(1461,956268022,4),(1461,971989222,3),(1461,987717622,4),(1461,1003438822,3),(1461,1019167222,4),(1461,1034888422,3),(1461,1050616822,4),(1461,1066338022,3),(1461,1082066422,4),(1461,1096581622,3),(1461,1113516022,4),(1461,1128380422,3),(1461,1143842423,4),(1461,1158872423,3),(1461,1175378423,4),(1461,1189638023,3),(1461,1206655223,4),(1461,1220216423,3),(1461,1238104824,4),(1461,1252015224,3),(1461,1269554424,4),(1461,1281474024,3),(1461,1301608884,4),(1461,1312146024,3),(1461,1314655224,4),(1461,1317330024,3),(1461,1333058424,4),(1461,1348178425,3),(1461,1364508025,4),(1461,1380229225,3),(1461,1395957625,4),(1461,1414098025,3),(1461,1427493625,4),(1461,1445551226,3),(1461,1458946826,4),(1461,1477692026,3),(1461,1490396427,4),(1461,1509141627,3),(1461,1521846027,4),(1461,1540591227,3),(1461,1553810427,4),(1461,1572037227,3),(1461,1585346427,4),(1461,1603490427,3),(1461,1616796027,4),(1461,1635458427,3),(1461,1648332027,4),(1461,1666998027,3),(1461,1682726427,4),(1461,1698447627,3),(1461,1712966427,4),(1461,1729897227,3),(1461,1743811227,4),(1461,1761346827,3),(1461,1774656027,4),(1461,1792796427,3),(1461,1806105627,4),(1461,1824850827,3),(1461,1837555227,4),(1461,1856300427,3),(1461,1869004827,4),(1461,1887750027,3),(1461,1901059227,4),(1461,1919199627,3),(1461,1932508827,4),(1461,1950649227,3),(1461,1963958427,4),(1461,1982703627,3),(1461,1995408027,4),(1461,2014153227,3),(1461,2026857627,4),(1461,2045602827,3),(1461,2058307227,4),(1461,2077052427,3),(1461,2090361627,4),(1461,2107897227,3),(1461,2121811227,4),(1461,2138742027,3),(1462,-2147483648,0),(1462,-2004073590,1),(1462,-1851577590,2),(1462,-852105600,3),(1462,-782643600,4),(1462,-767869200,2),(1462,-718095600,3),(1462,-457776000,2),(1462,-315648000,3),(1462,171820804,2),(1463,-2147483648,0),(1463,-2056690800,1),(1463,-900910800,2),(1463,-891579600,3),(1463,-884248200,4),(1463,-761209200,7),(1463,-747907200,2),(1463,-728541000,5),(1463,-717049800,6),(1463,-697091400,5),(1463,-683785800,6),(1463,-668061000,5),(1463,-654755400,2),(1463,-636611400,5),(1463,-623305800,2),(1463,-605161800,5),(1463,-591856200,2),(1463,-573712200,5),(1463,-559801800,2),(1463,-541657800,5),(1463,-528352200,2),(1463,-510211800,7),(1463,-498112200,2),(1463,-478762200,7),(1463,-466662600,2),(1463,-446707800,7),(1463,-435213000,2),(1463,-415258200,7),(1463,-403158600,2),(1463,-383808600,7),(1463,-371709000,2),(1463,-352359000,7),(1463,-340259400,2),(1463,-320909400,7),(1463,-308809800,2),(1463,-288855000,7),(1463,-277360200,2),(1463,-257405400,7),(1463,-245910600,2),(1463,-225955800,7),(1463,-213856200,2),(1463,-194506200,7),(1463,-182406600,2),(1463,-163056600,7),(1463,-148537800,2),(1463,-132816600,7),(1463,-117088200,2),(1463,-101367000,7),(1463,-85638600,2),(1463,-69312600,7),(1463,-53584200,2),(1463,-37863000,7),(1463,-22134600,2),(1463,-6413400,7),(1463,9315000,2),(1463,25036200,7),(1463,40764600,2),(1463,56485800,7),(1463,72214200,2),(1463,88540201,7),(1463,104268602,2),(1463,119989802,7),(1463,126041402,2),(1463,151439403,7),(1463,167167804,2),(1463,182889004,7),(1463,198617405,2),(1463,214338605,7),(1463,295385408,2),(1463,309292208,7),(1464,-2147483648,0),(1464,-2032927596,1),(1464,252439206,3),(1464,417978011,2),(1464,433785612,3),(1464,449600412,2),(1464,465321612,3),(1464,481050012,2),(1464,496771213,3),(1464,512499613,2),(1464,528220813,3),(1464,543949213,2),(1464,559670413,3),(1464,575398814,2),(1464,591120014,3),(1464,606848414,2),(1464,622569614,3),(1464,638298015,2),(1464,654624015,3),(1464,670352416,2),(1464,686073616,3),(1464,701802016,2),(1464,717523217,3),(1464,733251617,2),(1464,748972818,3),(1464,764701218,2),(1464,780422419,3),(1464,796150819,2),(1464,811872019,3),(1464,828205220,2),(1464,843926420,3),(1464,859654820,2),(1464,875376021,3),(1464,891104421,2),(1464,906825621,3),(1464,988398022,2),(1464,1001700022,3),(1464,1017428422,2),(1464,1033149622,3),(1464,1048878022,2),(1464,1064599222,3),(1464,1080327622,2),(1464,1096048822,3),(1464,1111777222,2),(1464,1127498422,3),(1464,1143226823,2),(1464,1159552823,3),(1464,1427482825,2),(1464,1443196826,3),(1464,1458932426,2),(1464,1474646426,3),(1465,-2147483648,1),(1465,-1575874625,2),(1465,-1247554800,4),(1465,354902409,3),(1465,370710010,4),(1465,386438410,3),(1465,402246011,4),(1465,417974411,3),(1465,433782012,4),(1465,449596812,3),(1465,465328812,5),(1465,481053612,6),(1465,496778413,5),(1465,512503213,6),(1465,528228013,5),(1465,543952813,6),(1465,559677613,5),(1465,575402414,6),(1465,591127214,5),(1465,606852014,6),(1465,622576814,5),(1465,638301615,6),(1465,654631215,5),(1465,670356016,7),(1465,686084416,8),(1465,695761216,5),(1465,701805616,6),(1465,717530417,5),(1465,733255217,6),(1465,748980018,5),(1465,764704818,6),(1465,780429619,5),(1465,796154419,6),(1465,811879219,5),(1465,828208820,6),(1465,846352820,5),(1465,859658420,6),(1465,877802421,5),(1465,891108021,6),(1465,909252021,5),(1465,922557622,6),(1465,941306422,5),(1465,954007222,6),(1465,972756022,5),(1465,985456822,6),(1465,1004205622,5),(1465,1017511222,6),(1465,1035655222,5),(1465,1048960822,6),(1465,1067104822,5),(1465,1080410422,6),(1465,1099159222,5),(1465,1111860022,6),(1465,1130608822,5),(1465,1143309623,6),(1465,1162058423,5),(1465,1174759223,6),(1465,1193508023,5),(1465,1206813623,6),(1465,1224957623,5),(1465,1238263224,6),(1465,1256407224,5),(1465,1269712824,6),(1465,1288461624,5),(1465,1301162424,9),(1465,1414256425,5),(1466,-2147483648,1),(1466,-1869875816,3),(1466,-1693706400,2),(1466,-1680490800,3),(1466,-1570413600,2),(1466,-1552186800,3),(1466,-1538359200,2),(1466,-1522551600,3),(1466,-1507514400,2),(1466,-1490583600,3),(1466,-1440208800,2),(1466,-1428030000,3),(1466,-1409709600,2),(1466,-1396494000,3),(1466,-931053600,2),(1466,-922676400,3),(1466,-917834400,2),(1466,-892436400,3),(1466,-875844000,2),(1466,-764737200,3),(1466,-744343200,2),(1466,-733806000,3),(1466,-716436000,2),(1466,-701924400,3),(1466,-684986400,2),(1466,-670474800,3),(1466,-654141600,2),(1466,-639025200,3),(1466,-622087200,2),(1466,-606970800,3),(1466,-590032800,2),(1466,-575521200,3),(1466,-235620000,2),(1466,-194842800,3),(1466,-177732000,2),(1466,-165726000,3),(1466,107910002,2),(1466,121215602,3),(1466,133920003,2),(1466,152665203,3),(1466,164678404,2),(1466,184114804,3),(1466,196214405,2),(1466,215564405,3),(1466,228873606,2),(1466,245804406,3),(1466,260323207,2),(1466,267915607,4),(1466,428454012,5),(1466,433893612,4),(1466,468111612,3),(1466,482799612,6),(1466,496710013,7),(1466,512521213,6),(1466,528246013,7),(1466,543970813,6),(1466,559695613,7),(1466,575420414,6),(1466,591145214,7),(1466,606870014,6),(1466,622594814,7),(1466,638319615,6),(1466,654649215,7),(1466,670374016,6),(1466,686098816,7),(1466,701823616,6),(1466,717548417,7),(1466,733273217,6),(1466,748998018,7),(1466,764118018,6),(1466,780447619,7),(1466,796172419,6),(1466,811897219,7),(1466,828226820,6),(1466,846370820,7),(1466,859676420,6),(1466,877820421,7),(1466,891126021,6),(1466,909270021,7),(1466,922575622,6),(1466,941324422,7),(1466,954025222,6),(1466,972774022,7),(1466,985474822,6),(1466,1004223622,7),(1466,1017529222,6),(1466,1035673222,7),(1466,1048978822,6),(1466,1067122822,7),(1466,1080428422,6),(1466,1099177222,7),(1466,1111878022,6),(1466,1130626822,7),(1466,1143327623,6),(1466,1162076423,7),(1466,1167602423,3),(1466,1174784423,8),(1466,1193533223,9),(1466,1206838823,8),(1466,1224982823,9),(1466,1238288424,8),(1466,1256432424,9),(1466,1269738024,8),(1466,1288486824,9),(1466,1301274024,8),(1466,1319936424,9),(1466,1332637224,8),(1466,1351386025,9),(1466,1364691625,8),(1466,1382835625,9),(1466,1396227625,8),(1466,1414285225,9),(1466,1427590825,8),(1466,1446944426,9),(1466,1459040426,8),(1466,1473195626,4),(1467,-2147483648,1),(1467,-1451719200,2),(1467,-1172906400,3),(1467,-876641400,4),(1467,-766054800,3),(1467,-683883000,5),(1467,-620812800,3),(1467,-189415800,6),(1468,-2147483648,0),(1468,-1172913768,1),(1468,-799491600,2),(1468,-189423000,3),(1469,-2147483648,1),(1469,-1641003640,6),(1469,-933638400,2),(1469,-923097600,3),(1469,-919036800,2),(1469,-857347200,3),(1469,-844300800,2),(1469,-825811200,3),(1469,-812678400,2),(1469,-794188800,3),(1469,-779846400,2),(1469,-762652800,3),(1469,-748310400,2),(1469,-731116800,3),(1469,-681955200,4),(1469,-673228800,2),(1469,-667958400,3),(1469,-652320000,2),(1469,-636422400,3),(1469,-622080000,2),(1469,-608947200,3),(1469,-591840000,2),(1469,-572486400,3),(1469,-558576000,2),(1469,-542851200,3),(1469,-527731200,2),(1469,-514425600,3),(1469,-490838400,2),(1469,-482976000,3),(1469,-459388800,2),(1469,-451526400,3),(1469,-428544000,2),(1469,-418262400,3),(1469,-400118400,2),(1469,-387417600,3),(1469,142380003,5),(1469,150843603,6),(1469,167176804,5),(1469,178664404,6),(1469,334101609,7),(1469,337730409,8),(1469,452642412,7),(1469,462319212,8),(1469,482277612,5),(1469,494370013,6),(1469,516751213,5),(1469,526424413,6),(1469,545436013,5),(1469,558478813,6),(1469,576626414,5),(1469,589323614,6),(1469,609890414,5),(1469,620773214,6),(1469,638316015,5),(1469,651618015,6),(1469,669765616,5),(1469,683672416,6),(1469,701820016,5),(1469,715726817,6),(1469,733701617,5),(1469,747176418,6),(1469,765151218,5),(1469,778021219,6),(1469,796600819,5),(1469,810075619,6),(1469,826840820,5),(1469,842821220,6),(1469,858895220,5),(1469,874184421,6),(1469,890344821,5),(1469,905029221,6),(1469,923011222,5),(1469,936313222,6),(1469,955670422,5),(1469,970783222,6),(1469,986770822,5),(1469,1001282422,6),(1469,1017356422,5),(1469,1033941622,6),(1469,1048806022,5),(1469,1065132022,6),(1469,1081292422,5),(1469,1095804022,6),(1469,1112313622,5),(1469,1128812422,6),(1469,1143763223,5),(1469,1159657223,6),(1469,1175212823,5),(1469,1189897223,6),(1469,1206662423,5),(1469,1223161223,6),(1469,1238112024,5),(1469,1254006024,6),(1469,1269561624,5),(1469,1284246024,6),(1469,1301616024,5),(1469,1317510024,6),(1469,1333065624,5),(1469,1348354825,6),(1469,1364515225,5),(1469,1382828425,6),(1469,1395964825,5),(1469,1414278025,6),(1469,1427414425,5),(1469,1445727626,6),(1469,1458864026,5),(1469,1477782026,6),(1469,1490313627,5),(1469,1509231627,6),(1469,1521763227,5),(1469,1540681227,6),(1469,1553817627,5),(1469,1572130827,6),(1469,1585267227,5),(1469,1603580427,6),(1469,1616716827,5),(1469,1635634827,6),(1469,1648166427,5),(1469,1667084427,6),(1469,1679616027,5),(1469,1698534027,6),(1469,1711670427,5),(1469,1729983627,6),(1469,1743120027,5),(1469,1761433227,6),(1469,1774569627,5),(1469,1792882827,6),(1469,1806019227,5),(1469,1824937227,6),(1469,1837468827,5),(1469,1856386827,6),(1469,1868918427,5),(1469,1887836427,6),(1469,1900972827,5),(1469,1919286027,6),(1469,1932422427,5),(1469,1950735627,6),(1469,1963872027,5),(1469,1982790027,6),(1469,1995321627,5),(1469,2014239627,6),(1469,2026771227,5),(1469,2045689227,6),(1469,2058220827,5),(1469,2077138827,6),(1469,2090275227,5),(1469,2108588427,6),(1469,2121724827,5),(1469,2140038027,6),(1470,-2147483648,1),(1470,-788932800,2),(1471,-2147483648,0),(1471,-1487759676,1),(1471,-1247569200,3),(1471,354888009,2),(1471,370695610,3),(1471,386424010,2),(1471,402231611,3),(1471,417960011,2),(1471,433767612,3),(1471,449582412,2),(1471,465314412,4),(1471,481039212,5),(1471,496764013,4),(1471,512488813,5),(1471,528213613,4),(1471,543938413,5),(1471,559663213,4),(1471,575388014,5),(1471,591112814,4),(1471,606837614,5),(1471,622562414,4),(1471,638287215,5),(1471,654616815,4),(1471,670341616,6),(1471,686070016,7),(1471,695746816,4),(1471,701791216,5),(1471,717516017,4),(1471,733240817,5),(1471,748965618,4),(1471,764690418,5),(1471,780415219,4),(1471,796140019,5),(1471,811864819,4),(1471,828194420,5),(1471,846338420,4),(1471,859644020,5),(1471,877788021,4),(1471,891093621,5),(1471,909237621,4),(1471,922543222,5),(1471,941292022,4),(1471,953992822,5),(1471,972741622,4),(1471,985442422,5),(1471,1004191222,4),(1471,1017496822,5),(1471,1035640822,4),(1471,1048946422,5),(1471,1067090422,4),(1471,1080396022,5),(1471,1099144822,4),(1471,1111845622,5),(1471,1130594422,4),(1471,1143295223,5),(1471,1162044023,4),(1471,1174744823,5),(1471,1193493623,4),(1471,1206799223,5),(1471,1224943223,4),(1471,1238248824,5),(1471,1256392824,4),(1471,1269698424,6),(1471,1288450824,7),(1471,1301151624,4),(1472,-2147483648,0),(1472,-1988166492,1),(1472,-862637400,2),(1472,-764145000,1),(1472,-576135000,3),(1472,38775600,5),(1472,1018119622,4),(1472,1033840822,5),(1472,1212260423,4),(1472,1225476023,5),(1472,1239735624,4),(1472,1257012024,5),(1473,-2147483648,0),(1473,-1325483420,1),(1474,-2147483648,0),(1474,-1577943676,1),(1474,504901813,2),(1475,-2147483648,0),(1475,-1577943676,1),(1475,504901813,2),(1476,-2147483648,0),(1476,-1579424533,1),(1476,-1247558400,3),(1476,354898809,2),(1476,370706410,3),(1476,386434810,2),(1476,402242411,3),(1476,417970811,2),(1476,433778412,3),(1476,449593212,2),(1476,465325212,4),(1476,481050012,5),(1476,496774813,4),(1476,512499613,5),(1476,528224413,4),(1476,543949213,5),(1476,559674013,4),(1476,575398814,5),(1476,591123614,4),(1476,606848414,5),(1476,622573214,4),(1476,638298015,5),(1476,654627615,4),(1476,670352416,6),(1476,686080816,7),(1476,695757616,4),(1476,701802016,5),(1476,717526817,4),(1476,733251617,5),(1476,748976418,4),(1476,764701218,5),(1476,780426019,4),(1476,796150819,5),(1476,811875619,4),(1476,828205220,5),(1476,846349220,4),(1476,859654820,5),(1476,877798821,4),(1476,891104421,5),(1476,909248421,4),(1476,922554022,5),(1476,941302822,4),(1476,954003622,5),(1476,972752422,4),(1476,985453222,5),(1476,1004202022,4),(1476,1017507622,5),(1476,1035651622,4),(1476,1048957222,5),(1476,1067101222,4),(1476,1072882822,10),(1476,1080403222,8),(1476,1099152022,9),(1476,1111852822,8),(1476,1130601622,9),(1476,1143302423,8),(1476,1162051223,9),(1476,1174752023,8),(1476,1193500823,9),(1476,1206806423,8),(1476,1224950423,9),(1476,1238256024,8),(1476,1256400024,9),(1476,1269705624,8),(1476,1288454424,9),(1476,1301155224,11),(1476,1315832424,9),(1476,1414252825,4),(1477,-2147483648,1),(1477,-2019705670,2),(1477,-891581400,3),(1477,-872058600,2),(1477,-862637400,3),(1477,-764145000,2),(1478,-2147483648,0),(1478,-1577513486,1),(1478,-1247551200,3),(1478,354906009,2),(1478,370713610,3),(1478,386442010,2),(1478,402249611,3),(1478,417978011,2),(1478,433785612,3),(1478,449600412,2),(1478,465332412,4),(1478,481057212,5),(1478,496782013,4),(1478,512506813,5),(1478,528231613,4),(1478,543956413,5),(1478,559681213,4),(1478,575406014,5),(1478,591130814,4),(1478,606855614,5),(1478,622580414,4),(1478,638305215,5),(1478,654634815,4),(1478,670359616,6),(1478,686088016,7),(1478,695764816,4),(1478,701809216,5),(1478,717534017,4),(1478,733258817,5),(1478,748983618,4),(1478,764708418,5),(1478,780433219,4),(1478,796158019,5),(1478,811882819,4),(1478,828212420,5),(1478,846356420,4),(1478,859662020,5),(1478,877806021,4),(1478,891111621,5),(1478,909255621,4),(1478,922561222,5),(1478,941310022,4),(1478,954010822,5),(1478,972759622,4),(1478,985460422,5),(1478,1004209222,4),(1478,1017514822,5),(1478,1035658822,4),(1478,1048964422,5),(1478,1067108422,4),(1478,1080414022,5),(1478,1099162822,4),(1478,1111863622,5),(1478,1130612422,4),(1478,1143313223,5),(1478,1162062023,4),(1478,1174762823,5),(1478,1193511623,4),(1478,1206817223,5),(1478,1224961223,4),(1478,1238266824,5),(1478,1256410824,4),(1478,1269716424,5),(1478,1288465224,4),(1478,1301166024,8),(1478,1414260025,4),(1479,-2147483648,1),(1479,-2038200925,2),(1479,-1167634800,3),(1479,-1073028000,4),(1479,-894180000,5),(1479,-879665400,6),(1479,-767005200,5),(1479,378662410,7),(1480,-2147483648,0),(1480,-1383463280,1),(1480,-1167636600,3),(1480,-1082448000,2),(1480,-1074586800,3),(1480,-1050825600,2),(1480,-1042964400,3),(1480,-1019289600,2),(1480,-1011428400,3),(1480,-987753600,2),(1480,-979892400,3),(1480,-956217600,2),(1480,-948356400,3),(1480,-924595200,2),(1480,-916734000,3),(1480,-893059200,2),(1480,-885198000,3),(1480,-879667200,4),(1480,-767005200,3),(1481,-2147483648,0),(1481,-719636812,1),(1482,-2147483648,0),(1482,-2056692850,1),(1482,-884509200,3),(1482,-873280800,2),(1482,-855918000,3),(1482,-841744800,2),(1482,-828529200,3),(1482,-765363600,1),(1482,-747046800,4),(1482,-733827600,5),(1482,-716461200,4),(1482,-697021200,5),(1482,-683715600,4),(1482,-667990800,5),(1482,-654771600,4),(1482,-636627600,5),(1482,-623322000,4),(1482,-605178000,5),(1482,-591872400,4),(1482,-573642000,5),(1482,-559818000,4),(1482,-541674000,5),(1482,-528368400,4),(1482,-510224400,5),(1482,-498128400,4),(1482,-478774800,5),(1482,-466678800,4),(1482,-446720400,5),(1482,-435229200,4),(1482,-415258200,1),(1482,-403158600,6),(1482,-383808600,1),(1482,-371709000,6),(1482,-352359000,1),(1482,-340259400,6),(1482,-320909400,1),(1482,-308809800,6),(1482,-288855000,1),(1482,-277360200,6),(1482,-257405400,1),(1482,-245910600,6),(1482,-225955800,1),(1482,-213856200,6),(1482,-194506200,1),(1482,-182406600,6),(1482,-163056600,1),(1482,-148537800,6),(1482,-132820200,1),(1482,-117088200,6),(1482,-101370600,1),(1482,-85638600,6),(1482,-69312600,1),(1482,-53584200,6),(1482,-37863000,1),(1482,-22134600,6),(1482,-6413400,1),(1482,9315000,6),(1482,25036200,1),(1482,40764600,6),(1482,56485800,1),(1482,72214200,6),(1482,88540201,1),(1482,104268602,6),(1482,119989802,1),(1482,126041402,6),(1482,151439403,1),(1482,167167804,6),(1482,182889004,1),(1482,198617405,6),(1482,214338605,1),(1482,295385408,6),(1482,309292208,1),(1483,-2147483648,0),(1483,-2056692850,1),(1483,-884509200,3),(1483,-873280800,2),(1483,-855918000,3),(1483,-841744800,2),(1483,-828529200,3),(1483,-765363600,1),(1483,-747046800,4),(1483,-733827600,5),(1483,-716461200,4),(1483,-697021200,5),(1483,-683715600,4),(1483,-667990800,5),(1483,-654771600,4),(1483,-636627600,5),(1483,-623322000,4),(1483,-605178000,5),(1483,-591872400,4),(1483,-573642000,5),(1483,-559818000,4),(1483,-541674000,5),(1483,-528368400,4),(1483,-510224400,5),(1483,-498128400,4),(1483,-478774800,5),(1483,-466678800,4),(1483,-446720400,5),(1483,-435229200,4),(1483,-415258200,1),(1483,-403158600,6),(1483,-383808600,1),(1483,-371709000,6),(1483,-352359000,1),(1483,-340259400,6),(1483,-320909400,1),(1483,-308809800,6),(1483,-288855000,1),(1483,-277360200,6),(1483,-257405400,1),(1483,-245910600,6),(1483,-225955800,1),(1483,-213856200,6),(1483,-194506200,1),(1483,-182406600,6),(1483,-163056600,1),(1483,-148537800,6),(1483,-132820200,1),(1483,-117088200,6),(1483,-101370600,1),(1483,-85638600,6),(1483,-69312600,1),(1483,-53584200,6),(1483,-37863000,1),(1483,-22134600,6),(1483,-6413400,1),(1483,9315000,6),(1483,25036200,1),(1483,40764600,6),(1483,56485800,1),(1483,72214200,6),(1483,88540201,1),(1483,104268602,6),(1483,119989802,1),(1483,126041402,6),(1483,151439403,1),(1483,167167804,6),(1483,182889004,1),(1483,198617405,6),(1483,214338605,1),(1483,295385408,6),(1483,309292208,1),(1484,-2147483648,0),(1484,-1441188192,1),(1484,-1247565600,3),(1484,354891609,2),(1484,370699210,3),(1484,386427610,2),(1484,402235211,3),(1484,417963611,2),(1484,433771212,3),(1484,449586012,2),(1484,465318012,4),(1484,481042812,5),(1484,496767613,4),(1484,512492413,5),(1484,528217213,4),(1484,543942013,5),(1484,559666813,4),(1484,575391614,5),(1484,591116414,4),(1484,606841214,5),(1484,622566014,4),(1484,638290815,5),(1484,654620415,4),(1484,670345216,6),(1484,686073616,7),(1484,695750416,4),(1484,701794816,5),(1484,717519617,4),(1484,733244417,5),(1484,748969218,4),(1484,764694018,5),(1484,780418819,4),(1484,796143619,5),(1484,811868419,4),(1484,828198020,5),(1484,846342020,4),(1484,859647620,5),(1484,877791621,4),(1484,891097221,5),(1484,909241221,4),(1484,922546822,5),(1484,941295622,4),(1484,953996422,5),(1484,972745222,4),(1484,985446022,5),(1484,1004194822,4),(1484,1017500422,5),(1484,1035644422,4),(1484,1048950022,5),(1484,1067094022,4),(1484,1080399622,5),(1484,1099148422,4),(1484,1111849222,5),(1484,1130598022,4),(1484,1143298823,5),(1484,1162047623,4),(1484,1174748423,5),(1484,1193497223,4),(1484,1206802823,5),(1484,1224946823,4),(1484,1238252424,5),(1484,1256396424,4),(1484,1269702024,5),(1484,1288450824,4),(1484,1301151624,8),(1484,1414245625,7),(1484,1461427226,4),(1485,-2147483648,0),(1485,-1577951856,1),(1485,-1172908656,2),(1485,-880272000,3),(1485,-766054800,4),(1486,-2147483648,2),(1486,-1046678400,1),(1486,-1038733200,2),(1486,-873273600,3),(1486,-794221200,2),(1486,-496224000,1),(1486,-489315600,2),(1486,259344007,1),(1486,275151607,2),(1487,-2147483648,0),(1487,-1577936472,1),(1488,-2147483648,0),(1488,-1518920008,2),(1488,166572004,1),(1488,182293204,2),(1488,200959205,1),(1488,213829205,2),(1488,228866406,1),(1488,243982806,2),(1488,260316007,1),(1488,276123607,2),(1488,291765608,1),(1488,307486808,2),(1488,323820009,1),(1488,338936409,2),(1488,354664809,1),(1488,370386010,2),(1488,386114410,1),(1488,401835611,2),(1488,417564011,1),(1488,433285212,2),(1488,449013612,1),(1488,465339612,2),(1488,481068012,1),(1488,496789213,2),(1488,512517613,1),(1488,528238813,2),(1488,543967213,1),(1488,559688413,2),(1488,575416814,1),(1488,591138014,2),(1488,606866414,1),(1488,622587614,2),(1488,638316015,1),(1488,654642015,2),(1488,670370416,1),(1488,686091616,2),(1488,701820016,1),(1488,717541217,2),(1488,733269617,1),(1488,748990818,2),(1488,764719218,1),(1488,780440419,2),(1488,796168819,1),(1488,811890019,2),(1488,828223220,1),(1488,843944420,2),(1488,859672820,1),(1488,875394021,2),(1488,891122421,1),(1488,909277221,3),(1488,922582822,4),(1488,941331622,3),(1488,954032422,4),(1488,972781222,3),(1488,985482022,4),(1488,1004230822,3),(1488,1017536422,4),(1488,1035680422,3),(1488,1048986022,4),(1488,1067130022,3),(1488,1080435622,4),(1488,1099184422,3),(1488,1111885222,4),(1488,1130634022,3),(1488,1143334823,4),(1488,1162083623,3),(1488,1174784423,4),(1488,1193533223,3),(1488,1206838823,4),(1488,1224982823,3),(1488,1238288424,4),(1488,1256432424,3),(1488,1269738024,4),(1488,1288486824,3),(1488,1301187624,4),(1488,1319936424,3),(1488,1332637224,4),(1488,1351386025,3),(1488,1364691625,4),(1488,1382835625,3),(1488,1396141225,4),(1488,1414285225,3),(1488,1427590825,4),(1488,1445734826,3),(1488,1459040426,4),(1488,1477789226,3),(1488,1490490027,4),(1488,1509238827,3),(1488,1521939627,4),(1488,1540688427,3),(1488,1553994027,4),(1488,1572138027,3),(1488,1585443627,4),(1488,1603587627,3),(1488,1616893227,4),(1488,1635642027,3),(1488,1648342827,4),(1488,1667091627,3),(1488,1679792427,4),(1488,1698541227,3),(1488,1711846827,4),(1488,1729990827,3),(1488,1743296427,4),(1488,1761440427,3),(1488,1774746027,4),(1488,1792890027,3),(1488,1806195627,4),(1488,1824944427,3),(1488,1837645227,4),(1488,1856394027,3),(1488,1869094827,4),(1488,1887843627,3),(1488,1901149227,4),(1488,1919293227,3),(1488,1932598827,4),(1488,1950742827,3),(1488,1964048427,4),(1488,1982797227,3),(1488,1995498027,4),(1488,2014246827,3),(1488,2026947627,4),(1488,2045696427,3),(1488,2058397227,4),(1488,2077146027,3),(1488,2090451627,4),(1488,2108595627,3),(1488,2121901227,4),(1488,2140045227,3),(1489,-2147483648,0),(1489,-1441259328,1),(1489,-1247551200,3),(1489,354906009,2),(1489,370713610,3),(1489,386442010,2),(1489,402249611,3),(1489,417978011,2),(1489,433785612,3),(1489,449600412,2),(1489,465332412,4),(1489,481057212,5),(1489,496782013,4),(1489,512506813,5),(1489,528231613,4),(1489,543956413,5),(1489,559681213,4),(1489,575406014,5),(1489,591130814,4),(1489,606855614,5),(1489,622580414,4),(1489,638305215,5),(1489,654634815,4),(1489,670359616,6),(1489,686088016,7),(1489,695764816,4),(1489,701809216,5),(1489,717534017,4),(1489,733258817,5),(1489,748983618,4),(1489,764708418,5),(1489,780433219,4),(1489,796158019,5),(1489,811882819,4),(1489,828212420,5),(1489,846356420,4),(1489,859662020,5),(1489,877806021,4),(1489,891111621,5),(1489,909255621,4),(1489,922561222,5),(1489,941310022,4),(1489,954010822,5),(1489,972759622,4),(1489,985460422,5),(1489,1004209222,4),(1489,1017514822,5),(1489,1035658822,4),(1489,1048964422,5),(1489,1067108422,4),(1489,1080414022,5),(1489,1099162822,4),(1489,1111863622,5),(1489,1130612422,4),(1489,1143313223,5),(1489,1162062023,4),(1489,1174762823,5),(1489,1193511623,4),(1489,1206817223,5),(1489,1224961223,4),(1489,1238266824,5),(1489,1256410824,4),(1489,1269716424,6),(1489,1288468824,7),(1489,1301169624,4),(1490,-2147483648,0),(1490,-1579476700,1),(1490,-1247551200,3),(1490,354906009,2),(1490,370713610,3),(1490,386442010,2),(1490,402249611,3),(1490,417978011,2),(1490,433785612,3),(1490,449600412,2),(1490,465332412,4),(1490,481057212,5),(1490,496782013,4),(1490,512506813,5),(1490,528231613,4),(1490,543956413,5),(1490,559681213,4),(1490,575406014,5),(1490,591130814,4),(1490,606855614,5),(1490,622580414,4),(1490,638305215,5),(1490,654634815,4),(1490,670359616,6),(1490,686088016,7),(1490,695764816,4),(1490,701809216,5),(1490,717534017,4),(1490,733258817,5),(1490,738086417,8),(1490,748987218,7),(1490,764712018,6),(1490,780436819,7),(1490,796161619,6),(1490,811886419,7),(1490,828216020,6),(1490,846360020,7),(1490,859665620,6),(1490,877809621,7),(1490,891115221,6),(1490,909259221,7),(1490,922564822,6),(1490,941313622,7),(1490,954014422,6),(1490,972763222,7),(1490,985464022,6),(1490,1004212822,7),(1490,1017518422,6),(1490,1035662422,7),(1490,1048968022,6),(1490,1067112022,7),(1490,1080417622,6),(1490,1099166422,7),(1490,1111867222,6),(1490,1130616022,7),(1490,1143316823,6),(1490,1162065623,7),(1490,1174766423,6),(1490,1193515223,7),(1490,1206820823,6),(1490,1224964823,7),(1490,1238270424,6),(1490,1256414424,7),(1490,1269720024,6),(1490,1288468824,7),(1490,1301169624,4),(1490,1414263625,7),(1490,1469304026,4),(1491,-2147483648,0),(1491,-1582088010,1),(1491,-1247547600,3),(1491,354909609,2),(1491,370717210,3),(1491,386445610,2),(1491,402253211,3),(1491,417981611,2),(1491,433789212,3),(1491,449604012,2),(1491,465336012,4),(1491,481060812,5),(1491,496785613,4),(1491,512510413,5),(1491,528235213,4),(1491,543960013,5),(1491,559684813,4),(1491,575409614,5),(1491,591134414,4),(1491,606859214,5),(1491,622584014,4),(1491,638308815,5),(1491,654638415,4),(1491,670363216,6),(1491,686091616,7),(1491,695768416,4),(1491,701812816,5),(1491,717537617,4),(1491,733262417,5),(1491,748987218,4),(1491,764712018,5),(1491,780436819,4),(1491,796161619,5),(1491,811886419,4),(1491,828216020,5),(1491,846360020,4),(1491,859665620,5),(1491,877809621,4),(1491,891115221,5),(1491,909259221,4),(1491,922564822,5),(1491,941313622,4),(1491,954014422,5),(1491,972763222,4),(1491,985464022,5),(1491,1004212822,4),(1491,1017518422,5),(1491,1035662422,4),(1491,1048968022,5),(1491,1067112022,4),(1491,1080417622,5),(1491,1099166422,4),(1491,1111867222,5),(1491,1130616022,4),(1491,1143316823,5),(1491,1162065623,4),(1491,1174766423,5),(1491,1193515223,4),(1491,1206820823,5),(1491,1224964823,4),(1491,1238270424,5),(1491,1256414424,4),(1491,1269720024,5),(1491,1288468824,4),(1491,1301169624,8),(1491,1414263625,4),(1492,-2147483648,0),(1492,-1441164324,1),(1492,-1247540400,2),(1492,354913209,3),(1492,370720810,4),(1492,386445610,3),(1492,402256811,2),(1492,417985211,3),(1492,433792812,2),(1492,449607612,3),(1492,465339612,5),(1492,481064412,6),(1492,496789213,5),(1492,512514013,6),(1492,528238813,5),(1492,543963613,6),(1492,559688413,5),(1492,575413214,6),(1492,591138014,5),(1492,606862814,7),(1492,622591214,8),(1492,638316015,7),(1492,654645615,8),(1492,670370416,7),(1492,686095216,8),(1492,695772016,5),(1492,701816416,7),(1492,717544817,8),(1492,733269617,7),(1492,748994418,8),(1492,764719218,7),(1492,780444019,8),(1492,796168819,7),(1492,811893619,8),(1492,828223220,7),(1492,846367220,8),(1492,859672820,7),(1492,877816821,8),(1492,891122421,7),(1492,909266421,8),(1492,922572022,7),(1492,941320822,8),(1492,954021622,7),(1492,972770422,8),(1492,985471222,7),(1492,1004220022,8),(1492,1017525622,7),(1492,1035669622,8),(1492,1048975222,7),(1492,1067119222,8),(1492,1080424822,7),(1492,1099173622,5),(1493,-2147483648,1),(1493,-1570084924,2),(1494,-2147483648,0),(1494,-1946186240,1),(1494,-1172906240,2),(1494,-881220600,3),(1494,-766054800,2),(1494,-683883000,4),(1494,-620812800,2),(1494,-189415800,5),(1494,567964813,6),(1495,-2147483648,0),(1495,-1948782180,1),(1495,-1830414600,2),(1495,-768646800,3),(1495,1439564426,1),(1495,1525446027,3),(1496,-2147483648,0),(1496,-1577935568,1),(1496,76190400,2),(1497,-2147483648,0),(1497,-1441167268,1),(1497,-1247544000,2),(1497,354913209,3),(1497,370720810,4),(1497,386445610,3),(1497,402256811,2),(1497,417985211,3),(1497,433792812,2),(1497,449607612,3),(1497,465339612,5),(1497,481064412,6),(1497,496789213,5),(1497,512514013,6),(1497,528238813,5),(1497,543963613,6),(1497,559688413,5),(1497,575413214,6),(1497,591138014,5),(1497,606862814,6),(1497,622587614,5),(1497,638312415,6),(1497,654642015,5),(1497,670366816,7),(1497,686095216,8),(1497,695772016,5),(1497,701816416,6),(1497,717541217,5),(1497,733266017,6),(1497,748990818,5),(1497,764715618,6),(1497,780440419,5),(1497,796165219,6),(1497,811890019,5),(1497,828219620,6),(1497,846363620,5),(1497,859669220,6),(1497,877813221,5),(1497,891118821,6),(1497,909262821,5),(1497,922568422,6),(1497,941317222,5),(1497,954018022,6),(1497,972766822,5),(1497,985467622,6),(1497,1004216422,5),(1497,1017522022,6),(1497,1035666022,5),(1497,1048971622,6),(1497,1067115622,5),(1497,1080421222,6),(1497,1099170022,9),(1498,-2147483648,0),(1498,-1441167712,1),(1498,-1247544000,2),(1498,354913209,3),(1498,370720810,4),(1498,386445610,3),(1498,402256811,2),(1498,417985211,3),(1498,433792812,2),(1498,449607612,3),(1498,465339612,5),(1498,481064412,6),(1498,496789213,5),(1498,512514013,6),(1498,528238813,5),(1498,543963613,6),(1498,559688413,5),(1498,575413214,6),(1498,591138014,5),(1498,606862814,6),(1498,622587614,5),(1498,638312415,6),(1498,654642015,5),(1498,670366816,7),(1498,686095216,5),(1498,695768416,8),(1498,701812816,6),(1498,717541217,5),(1498,733266017,6),(1498,748990818,5),(1498,764715618,6),(1498,780440419,5),(1498,796165219,6),(1498,811890019,5),(1498,828219620,6),(1498,846363620,5),(1498,859669220,6),(1498,877813221,5),(1498,891118821,6),(1498,909262821,5),(1498,922568422,6),(1498,941317222,5),(1498,954018022,6),(1498,972766822,5),(1498,985467622,6),(1498,1004216422,5),(1498,1017522022,6),(1498,1035666022,5),(1498,1048971622,6),(1498,1067115622,5),(1498,1080421222,6),(1498,1099170022,8),(1498,1545328827,2),(1499,-2147483648,1),(1499,-1577946287,2),(1499,-873268200,3),(1499,-778410000,2),(1500,-2147483648,0),(1500,-719636812,1),(1501,-2147483648,0),(1501,-2004073590,1),(1501,-1851577590,2),(1501,-852105600,3),(1501,-782643600,4),(1501,-767869200,2),(1501,-718095600,3),(1501,-457776000,2),(1501,-315648000,3),(1501,171820804,2),(1502,-2147483648,0),(1502,-2031039048,1),(1502,-768560400,3),(1502,354891609,2),(1502,370699210,3),(1502,386427610,2),(1502,402235211,3),(1502,417963611,2),(1502,433771212,3),(1502,449586012,2),(1502,465318012,4),(1502,481042812,5),(1502,496767613,4),(1502,512492413,5),(1502,528217213,4),(1502,543942013,5),(1502,559666813,4),(1502,575391614,5),(1502,591116414,4),(1502,606841214,5),(1502,622566014,4),(1502,638290815,5),(1502,654620415,4),(1502,670345216,6),(1502,686073616,7),(1502,695750416,4),(1502,701794816,5),(1502,717519617,4),(1502,733244417,5),(1502,748969218,4),(1502,764694018,5),(1502,780418819,4),(1502,796143619,5),(1502,811868419,4),(1502,828198020,5),(1502,846342020,4),(1502,859647620,6),(1502,877795221,7),(1502,891100821,6),(1502,909244821,7),(1502,922550422,6),(1502,941299222,7),(1502,954000022,6),(1502,972748822,7),(1502,985449622,6),(1502,1004198422,7),(1502,1017504022,6),(1502,1035648022,7),(1502,1048953622,6),(1502,1067097622,7),(1502,1080403222,6),(1502,1099152022,7),(1502,1111852822,6),(1502,1130601622,7),(1502,1143302423,6),(1502,1162051223,7),(1502,1174752023,6),(1502,1193500823,7),(1502,1206806423,6),(1502,1224950423,7),(1502,1238256024,6),(1502,1256400024,7),(1502,1269705624,6),(1502,1288454424,7),(1502,1301155224,4),(1502,1414249225,7),(1502,1459008026,4),(1503,-2147483648,0),(1503,-1441168073,1),(1503,-1247544000,2),(1503,354913209,3),(1503,370720810,4),(1503,386445610,3),(1503,402256811,2),(1503,417985211,3),(1503,433792812,2),(1503,449607612,3),(1503,465339612,5),(1503,481064412,6),(1503,496789213,5),(1503,512514013,6),(1503,528238813,5),(1503,543963613,6),(1503,559688413,5),(1503,575413214,6),(1503,591138014,5),(1503,606862814,6),(1503,622587614,5),(1503,638312415,6),(1503,654642015,5),(1503,670366816,6),(1503,686091616,5),(1503,694206016,2),(1504,-2147483648,0),(1504,-1948782472,1),(1504,-1830414600,2),(1504,-767350800,4),(1504,-681210000,3),(1504,-672228000,4),(1504,-654771600,3),(1504,-640864800,4),(1504,-623408400,3),(1504,-609415200,4),(1504,-588848400,3),(1504,-577965600,4),(1504,-498128400,1),(1504,-462702600,5),(1504,-451733400,1),(1504,-429784200,5),(1504,-418296600,1),(1504,-399544200,5),(1504,-387451800,1),(1504,-368094600,5),(1504,-356002200,1),(1504,-336645000,5),(1504,-324552600,1),(1504,-305195400,5),(1504,-293103000,1),(1504,-264933000,4),(1504,547578013,3),(1504,560883613,4),(1504,579027614,3),(1504,592333214,4),(1505,-2147483648,2),(1505,-1600675200,1),(1505,-1585904400,2),(1505,-933667200,1),(1505,-922093200,2),(1505,-908870400,1),(1505,-888829200,2),(1505,-881049600,1),(1505,-767869200,2),(1505,-745833600,1),(1505,-733827600,2),(1505,-716889600,1),(1505,-699613200,2),(1505,-683884800,1),(1505,-670669200,2),(1505,-652348800,1),(1505,-650019600,2),(1505,515527213,1),(1505,527014813,2),(1505,545162413,1),(1505,558464413,2),(1505,577216814,1),(1505,589914014,2),(1505,608666414,1),(1505,621968414,2),(1505,640116015,1),(1505,653418015,2),(1505,671565616,1),(1505,684867616,2),(1506,-2147483648,1),(1506,-2038200925,2),(1506,-1167634800,3),(1506,-1073028000,4),(1506,-894180000,5),(1506,-879665400,6),(1506,-767005200,5),(1506,378662410,7),(1507,-2147483648,0),(1507,-1441188892,1),(1507,-1247565600,3),(1507,354891609,2),(1507,370699210,3),(1507,386427610,2),(1507,402235211,3),(1507,417963611,2),(1507,433771212,3),(1507,449586012,2),(1507,465318012,4),(1507,481042812,5),(1507,496767613,4),(1507,512492413,5),(1507,528217213,4),(1507,543942013,5),(1507,559666813,4),(1507,575391614,5),(1507,591116414,4),(1507,606841214,5),(1507,622566014,4),(1507,638290815,5),(1507,654620415,4),(1507,670345216,6),(1507,686073616,7),(1507,695750416,4),(1507,701794816,5),(1507,717519617,4),(1507,733244417,5),(1507,748969218,4),(1507,764694018,5),(1507,780418819,4),(1507,796143619,5),(1507,811868419,4),(1507,828198020,5),(1507,846342020,4),(1507,859647620,5),(1507,877791621,4),(1507,891097221,5),(1507,909241221,4),(1507,922546822,5),(1507,941295622,4),(1507,953996422,5),(1507,972745222,4),(1507,985446022,5),(1507,1004194822,4),(1507,1017500422,5),(1507,1035644422,4),(1507,1048950022,5),(1507,1067094022,4),(1507,1080399622,5),(1507,1099148422,4),(1507,1111849222,5),(1507,1130598022,4),(1507,1143298823,5),(1507,1162047623,4),(1507,1174748423,5),(1507,1193497223,4),(1507,1206802823,5),(1507,1224946823,4),(1507,1238252424,5),(1507,1256396424,4),(1507,1269702024,5),(1507,1288450824,4),(1507,1301151624,8),(1507,1414245625,4),(1508,-2147483648,1),(1508,-1017820800,2),(1508,-766224000,1),(1508,-745833600,3),(1508,-733827600,1),(1508,-716889600,3),(1508,-699613200,1),(1508,-683884800,3),(1508,-670669200,1),(1508,-652348800,3),(1508,-639133200,1),(1508,-620812800,3),(1508,-607597200,1),(1508,-589276800,3),(1508,-576061200,1),(1508,-562924800,3),(1508,-541760400,1),(1508,-528710400,3),(1508,-510224400,1),(1508,-497174400,3),(1508,-478688400,1),(1508,-465638400,3),(1508,-449830800,1),(1508,-434016000,3),(1508,-418208400,1),(1508,-402480000,3),(1508,-386672400,1),(1508,-370944000,3),(1508,-355136400,1),(1508,-339408000,3),(1508,-323600400,1),(1508,-302515200,3),(1508,-291978000,1),(1508,-270979200,3),(1508,-260442000,1),(1508,133977603,3),(1508,149785203,1),(1508,165513604,3),(1508,181321204,1),(1508,299606408,3),(1508,307551608,1),(1509,-2147483648,0),(1509,-1441168631,1),(1509,-1247547600,3),(1509,354909609,2),(1509,370717210,3),(1509,386445610,2),(1509,402253211,3),(1509,417981611,2),(1509,433789212,3),(1509,449604012,2),(1509,465336012,4),(1509,481060812,5),(1509,496785613,4),(1509,512510413,5),(1509,528235213,4),(1509,543960013,5),(1509,559684813,4),(1509,575409614,5),(1509,591134414,4),(1509,606859214,5),(1509,622584014,4),(1509,638308815,5),(1509,654638415,4),(1509,670363216,6),(1509,686091616,7),(1509,694206016,1),(1510,-2147483648,1),(1510,-1441162751,2),(1510,-405140400,4),(1510,354916809,3),(1510,370724410,4),(1510,386452810,3),(1510,402260411,4),(1510,417988811,3),(1510,433796412,4),(1510,449611212,3),(1510,465343212,5),(1510,481068012,6),(1510,496792813,5),(1510,512517613,6),(1510,528242413,5),(1510,543967213,6),(1510,559692013,5),(1510,575416814,6),(1510,591141614,5),(1510,606866414,6),(1510,622591214,5),(1510,638316015,6),(1510,654645615,5),(1510,670370416,7),(1510,686098816,8),(1510,694213216,2),(1510,701816416,9),(1510,717537617,2),(1510,733266017,9),(1510,748987218,2),(1510,764715618,9),(1510,780436819,4),(1510,796161619,3),(1510,811882819,4),(1510,828216020,3),(1510,859662020,3),(1510,877806021,4),(1510,891115221,3),(1510,909255621,4),(1510,922564822,3),(1510,941310022,4),(1510,954014422,3),(1510,972759622,4),(1510,985464022,3),(1510,1004209222,4),(1510,1017518422,3),(1510,1035658822,4),(1510,1048968022,3),(1510,1067108422,4),(1510,1080417622,3),(1510,1088276422,9),(1510,1099177222,8),(1510,1111878022,4),(1511,-2147483648,0),(1511,-1704165944,1),(1511,-1090466744,3),(1511,227820606,2),(1511,246223806,5),(1511,259617607,4),(1511,271108807,5),(1511,283982407,3),(1511,296598608,2),(1511,306531008,3),(1511,322432209,2),(1511,338499009,3),(1511,673216216,2),(1511,685481416,3),(1511,701209816,2),(1511,717103817,3),(1511,732745817,2),(1511,748639818,3),(1511,764281818,2),(1511,780175819,3),(1511,795817819,2),(1511,811711819,3),(1511,827353820,2),(1511,843247820,3),(1511,858976220,2),(1511,874870221,3),(1511,890512221,2),(1511,906406221,3),(1511,922048222,2),(1511,937942222,3),(1511,953584222,2),(1511,969478222,3),(1511,985206622,2),(1511,1001100622,3),(1511,1016742622,2),(1511,1032636622,3),(1511,1048278622,2),(1511,1064172622,3),(1511,1079814622,2),(1511,1095708622,3),(1511,1111437022,2),(1511,1127331022,3),(1511,1206045023,2),(1511,1221939023,3),(1511,1237667424,2),(1511,1253561424,3),(1511,1269203424,2),(1511,1285097424,3),(1511,1300739424,2),(1511,1316633424,3),(1511,1332275424,2),(1511,1348169425,3),(1511,1363897825,2),(1511,1379791825,3),(1511,1395433825,2),(1511,1411327825,3),(1511,1426969825,2),(1511,1442863826,3),(1511,1458505826,2),(1511,1474399826,3),(1511,1490128227,2),(1511,1506022227,3),(1511,1521664227,2),(1511,1537558227,3),(1511,1553200227,2),(1511,1569094227,3),(1511,1584736227,2),(1511,1600630227,3),(1511,1616358627,2),(1511,1632252627,3),(1511,1647894627,2),(1511,1663788627,3),(1512,-2147483648,1),(1512,-1641003640,6),(1512,-933638400,2),(1512,-923097600,3),(1512,-919036800,2),(1512,-857347200,3),(1512,-844300800,2),(1512,-825811200,3),(1512,-812678400,2),(1512,-794188800,3),(1512,-779846400,2),(1512,-762652800,3),(1512,-748310400,2),(1512,-731116800,3),(1512,-681955200,4),(1512,-673228800,2),(1512,-667958400,3),(1512,-652320000,2),(1512,-636422400,3),(1512,-622080000,2),(1512,-608947200,3),(1512,-591840000,2),(1512,-572486400,3),(1512,-558576000,2),(1512,-542851200,3),(1512,-527731200,2),(1512,-514425600,3),(1512,-490838400,2),(1512,-482976000,3),(1512,-459388800,2),(1512,-451526400,3),(1512,-428544000,2),(1512,-418262400,3),(1512,-400118400,2),(1512,-387417600,3),(1512,142380003,5),(1512,150843603,6),(1512,167176804,5),(1512,178664404,6),(1512,334101609,7),(1512,337730409,8),(1512,452642412,7),(1512,462319212,8),(1512,482277612,5),(1512,494370013,6),(1512,516751213,5),(1512,526424413,6),(1512,545436013,5),(1512,558478813,6),(1512,576626414,5),(1512,589323614,6),(1512,609890414,5),(1512,620773214,6),(1512,638316015,5),(1512,651618015,6),(1512,669765616,5),(1512,683672416,6),(1512,701820016,5),(1512,715726817,6),(1512,733701617,5),(1512,747176418,6),(1512,765151218,5),(1512,778021219,6),(1512,796600819,5),(1512,810075619,6),(1512,826840820,5),(1512,842821220,6),(1512,858895220,5),(1512,874184421,6),(1512,890344821,5),(1512,905029221,6),(1512,923011222,5),(1512,936313222,6),(1512,955670422,5),(1512,970783222,6),(1512,986770822,5),(1512,1001282422,6),(1512,1017356422,5),(1512,1033941622,6),(1512,1048806022,5),(1512,1065132022,6),(1512,1081292422,5),(1512,1095804022,6),(1512,1112313622,5),(1512,1128812422,6),(1512,1143763223,5),(1512,1159657223,6),(1512,1175212823,5),(1512,1189897223,6),(1512,1206662423,5),(1512,1223161223,6),(1512,1238112024,5),(1512,1254006024,6),(1512,1269561624,5),(1512,1284246024,6),(1512,1301616024,5),(1512,1317510024,6),(1512,1333065624,5),(1512,1348354825,6),(1512,1364515225,5),(1512,1382828425,6),(1512,1395964825,5),(1512,1414278025,6),(1512,1427414425,5),(1512,1445727626,6),(1512,1458864026,5),(1512,1477782026,6),(1512,1490313627,5),(1512,1509231627,6),(1512,1521763227,5),(1512,1540681227,6),(1512,1553817627,5),(1512,1572130827,6),(1512,1585267227,5),(1512,1603580427,6),(1512,1616716827,5),(1512,1635634827,6),(1512,1648166427,5),(1512,1667084427,6),(1512,1679616027,5),(1512,1698534027,6),(1512,1711670427,5),(1512,1729983627,6),(1512,1743120027,5),(1512,1761433227,6),(1512,1774569627,5),(1512,1792882827,6),(1512,1806019227,5),(1512,1824937227,6),(1512,1837468827,5),(1512,1856386827,6),(1512,1868918427,5),(1512,1887836427,6),(1512,1900972827,5),(1512,1919286027,6),(1512,1932422427,5),(1512,1950735627,6),(1512,1963872027,5),(1512,1982790027,6),(1512,1995321627,5),(1512,2014239627,6),(1512,2026771227,5),(1512,2045689227,6),(1512,2058220827,5),(1512,2077138827,6),(1512,2090275227,5),(1512,2108588427,6),(1512,2121724827,5),(1512,2140038027,6),(1513,-2147483648,0),(1513,-706341516,1),(1513,560025013,2),(1514,-2147483648,0),(1514,-706341516,1),(1514,560025013,2),(1515,-2147483648,3),(1515,-683802000,1),(1515,-672310800,2),(1515,-654771600,1),(1515,-640861200,2),(1515,-620298000,1),(1515,-609411600,2),(1515,-588848400,1),(1515,-577962000,2),(1516,-2147483648,0),(1516,-1578807591,1),(1516,-1247551200,3),(1516,354906009,2),(1516,370713610,3),(1516,386442010,2),(1516,402249611,3),(1516,417978011,2),(1516,433785612,3),(1516,449600412,2),(1516,465332412,4),(1516,481057212,5),(1516,496782013,4),(1516,512506813,5),(1516,528231613,4),(1516,543956413,5),(1516,559681213,4),(1516,575406014,5),(1516,591130814,4),(1516,606855614,5),(1516,622580414,4),(1516,638305215,5),(1516,654634815,4),(1516,670359616,6),(1516,686088016,7),(1516,695764816,4),(1516,701809216,5),(1516,717534017,4),(1516,733258817,5),(1516,748983618,4),(1516,764708418,5),(1516,780433219,4),(1516,796158019,5),(1516,811882819,4),(1516,828212420,5),(1516,846356420,4),(1516,859662020,5),(1516,877806021,4),(1516,891111621,5),(1516,909255621,4),(1516,922561222,5),(1516,941310022,4),(1516,954010822,5),(1516,972759622,4),(1516,985460422,5),(1516,1004209222,4),(1516,1017514822,5),(1516,1020193222,8),(1516,1035662422,7),(1516,1048968022,6),(1516,1067112022,7),(1516,1080417622,6),(1516,1099166422,7),(1516,1111867222,6),(1516,1130616022,7),(1516,1143316823,6),(1516,1162065623,7),(1516,1174766423,6),(1516,1193515223,7),(1516,1206820823,6),(1516,1224964823,7),(1516,1238270424,6),(1516,1256414424,7),(1516,1269720024,6),(1516,1288468824,7),(1516,1301169624,4),(1516,1414263625,7),(1516,1464465626,4),(1517,-2147483648,0),(1517,-1577951856,1),(1517,-1172908656,2),(1517,-880272000,3),(1517,-766054800,4),(1518,-2147483648,0),(1518,-2032931252,1),(1518,252435606,3),(1518,417974411,2),(1518,433782012,3),(1518,449596812,2),(1518,465318012,3),(1518,481046412,2),(1518,496767613,3),(1518,512496013,2),(1518,528217213,3),(1518,543945613,2),(1518,559666813,3),(1518,575395214,2),(1518,591116414,3),(1518,606844814,2),(1518,622566014,3),(1518,638294415,2),(1518,654620415,3),(1518,670348816,2),(1518,686070016,3),(1518,701798416,2),(1518,717519617,3),(1518,733248017,2),(1518,748969218,3),(1518,764697618,2),(1518,780418819,3),(1518,796147219,2),(1518,811868419,3),(1518,828201620,2),(1518,843922820,3),(1518,859651220,2),(1518,875372421,3),(1518,891100821,2),(1518,906822021,3),(1518,988394422,2),(1518,1001696422,3),(1518,1017424822,2),(1518,1033146022,3),(1518,1048874422,2),(1518,1064595622,3),(1518,1080324022,2),(1518,1096045222,3),(1518,1111773622,2),(1518,1127494822,3),(1518,1143223223,2),(1518,1159549223,3),(1518,1427479225,2),(1518,1443193226,3),(1518,1458928826,2),(1518,1474642826,3),(1519,-2147483648,0),(1519,-2032931252,1),(1519,252435606,3),(1519,417974411,2),(1519,433782012,3),(1519,449596812,2),(1519,465318012,3),(1519,481046412,2),(1519,496767613,3),(1519,512496013,2),(1519,528217213,3),(1519,543945613,2),(1519,559666813,3),(1519,575395214,2),(1519,591116414,3),(1519,606844814,2),(1519,622566014,3),(1519,638294415,2),(1519,654620415,3),(1519,670348816,2),(1519,686070016,3),(1519,701798416,2),(1519,717519617,3),(1519,733248017,2),(1519,748969218,3),(1519,764697618,2),(1519,780418819,3),(1519,796147219,2),(1519,811868419,3),(1519,828201620,2),(1519,843922820,3),(1519,859651220,2),(1519,875372421,3),(1519,891100821,2),(1519,906822021,3),(1519,988394422,2),(1519,1001696422,3),(1519,1017424822,2),(1519,1033146022,3),(1519,1048874422,2),(1519,1064595622,3),(1519,1080324022,2),(1519,1096045222,3),(1519,1111773622,2),(1519,1127494822,3),(1519,1143223223,2),(1519,1159549223,3),(1519,1427479225,2),(1519,1443193226,3),(1519,1458928826,2),(1519,1474642826,3),(1520,-2147483648,0),(1520,-1325483420,1),(1521,-2147483648,0),(1521,-1579426374,1),(1521,-1247558400,2),(1521,354898809,4),(1521,370699210,3),(1521,386427610,4),(1521,402235211,3),(1521,417963611,4),(1521,433771212,3),(1521,449586012,4),(1521,465318012,5),(1521,481042812,6),(1521,496767613,5),(1521,512492413,6),(1521,528217213,5),(1521,543942013,6),(1521,559666813,5),(1521,575391614,6),(1521,591116414,5),(1521,606841214,6),(1521,622566014,5),(1521,638290815,6),(1521,654620415,5),(1521,670345216,7),(1521,686073616,8),(1521,695750416,5),(1521,701794816,6),(1521,717519617,5),(1521,733244417,6),(1521,748969218,5),(1521,764694018,6),(1521,780418819,5),(1521,796143619,6),(1521,811868419,5),(1521,828198020,6),(1521,846342020,5),(1521,859647620,6),(1521,877791621,5),(1521,891097221,6),(1521,909241221,5),(1521,922546822,6),(1521,941295622,5),(1521,953996422,6),(1521,972745222,5),(1521,985446022,6),(1521,1004194822,5),(1521,1017500422,6),(1521,1035644422,5),(1521,1048950022,6),(1521,1067094022,5),(1521,1080399622,6),(1521,1099148422,5),(1521,1111849222,6),(1521,1130598022,5),(1521,1143298823,6),(1521,1162047623,5),(1521,1174748423,6),(1521,1193497223,5),(1521,1206802823,6),(1521,1224946823,5),(1521,1238252424,6),(1521,1256396424,5),(1521,1269702024,6),(1521,1288450824,5),(1521,1301151624,9),(1521,1315828824,5),(1521,1414249225,8),(1522,-2147483648,1),(1522,-1570084924,2),(1523,-2147483648,0),(1523,-1487321251,1),(1523,-1247562000,3),(1523,354895209,2),(1523,370702810,3),(1523,386431210,2),(1523,402238811,3),(1523,417967211,2),(1523,433774812,3),(1523,449589612,2),(1523,465321612,4),(1523,481046412,5),(1523,496771213,4),(1523,512496013,5),(1523,528220813,4),(1523,543945613,5),(1523,559670413,4),(1523,575395214,5),(1523,591120014,4),(1523,606844814,5),(1523,622569614,4),(1523,638294415,5),(1523,654624015,4),(1523,670348816,6),(1523,686077216,7),(1523,695754016,4),(1523,701798416,5),(1523,717523217,4),(1523,733248017,5),(1523,748972818,4),(1523,764697618,5),(1523,780422419,4),(1523,796147219,5),(1523,811872019,4),(1523,828201620,5),(1523,846345620,4),(1523,859651220,5),(1523,877795221,4),(1523,891100821,5),(1523,909244821,4),(1523,922550422,5),(1523,941299222,4),(1523,954000022,5),(1523,972748822,4),(1523,985449622,5),(1523,1004198422,4),(1523,1017504022,5),(1523,1035648022,4),(1523,1048953622,5),(1523,1067097622,4),(1523,1080403222,5),(1523,1099152022,4),(1523,1111852822,5),(1523,1130601622,4),(1523,1143302423,5),(1523,1162051223,4),(1523,1174752023,5),(1523,1193500823,4),(1523,1206806423,5),(1523,1224950423,4),(1523,1238256024,5),(1523,1256400024,4),(1523,1269705624,5),(1523,1288454424,4),(1523,1301155224,8),(1523,1414249225,4),(1524,-2147483648,0),(1524,-1579423138,1),(1524,-1247558400,3),(1524,354898809,2),(1524,370706410,3),(1524,386434810,2),(1524,402242411,3),(1524,417970811,2),(1524,433778412,3),(1524,449593212,2),(1524,465325212,4),(1524,481050012,5),(1524,496774813,4),(1524,512499613,5),(1524,528224413,4),(1524,543949213,5),(1524,559674013,4),(1524,575398814,5),(1524,591123614,4),(1524,606848414,5),(1524,622573214,4),(1524,638298015,5),(1524,654627615,4),(1524,670352416,6),(1524,686080816,7),(1524,695757616,4),(1524,701802016,5),(1524,717526817,4),(1524,733251617,5),(1524,748976418,4),(1524,764701218,5),(1524,780426019,4),(1524,796150819,5),(1524,811875619,4),(1524,828205220,5),(1524,846349220,4),(1524,859654820,5),(1524,877798821,4),(1524,891104421,5),(1524,909248421,4),(1524,922554022,5),(1524,941302822,4),(1524,954003622,5),(1524,972752422,4),(1524,985453222,5),(1524,1004202022,4),(1524,1017507622,5),(1524,1035651622,4),(1524,1048957222,5),(1524,1067101222,4),(1524,1080406822,5),(1524,1099155622,4),(1524,1111856422,5),(1524,1130605222,4),(1524,1143306023,5),(1524,1162054823,4),(1524,1174755623,5),(1524,1193504423,4),(1524,1206810023,5),(1524,1224954023,4),(1524,1238259624,5),(1524,1256403624,4),(1524,1269709224,5),(1524,1288458024,4),(1524,1301158824,8),(1524,1414252825,4),(1525,-2147483648,1),(1525,-1577946287,2),(1525,-873268200,3),(1525,-778410000,2),(1526,-2147483648,0),(1526,-1688270553,1),(1526,-1592610305,2),(1526,-1247544000,4),(1526,354913209,3),(1526,370720810,4),(1526,386449210,3),(1526,402256811,4),(1526,417985211,3),(1526,433792812,4),(1526,449607612,3),(1526,465339612,5),(1526,481064412,6),(1526,496789213,5),(1526,512514013,6),(1526,528238813,5),(1526,543963613,6),(1526,559688413,5),(1526,575413214,6),(1526,591138014,5),(1526,606862814,6),(1526,622587614,5),(1526,638312415,6),(1526,654642015,5),(1526,670366816,7),(1526,686095216,8),(1526,695772016,5),(1526,701816416,6),(1526,717541217,5),(1526,733266017,6),(1526,748990818,5),(1526,764715618,6),(1526,780440419,5),(1526,796165219,6),(1526,811890019,5),(1526,828219620,6),(1526,846363620,5),(1526,859669220,6),(1526,877813221,5),(1526,891118821,6),(1526,909262821,5),(1526,922568422,6),(1526,941317222,5),(1526,954018022,6),(1526,972766822,5),(1526,985467622,6),(1526,1004216422,5),(1526,1017522022,6),(1526,1035666022,5),(1526,1048971622,6),(1526,1067115622,5),(1526,1080421222,6),(1526,1099170022,5),(1526,1111870822,6),(1526,1130619622,5),(1526,1143320423,6),(1526,1162069223,5),(1526,1174770023,6),(1526,1193518823,5),(1526,1206824423,6),(1526,1224968423,5),(1526,1238274024,6),(1526,1256418024,5),(1526,1269723624,6),(1526,1288472424,5),(1526,1301173224,9),(1526,1414267225,5),(1527,-2147483648,0),(1527,-1441162680,1),(1527,-405140400,3),(1527,354916809,2),(1527,370724410,3),(1527,386452810,2),(1527,402260411,3),(1527,417988811,2),(1527,433796412,3),(1527,449611212,2),(1527,465343212,4),(1527,481068012,5),(1527,496792813,4),(1527,512517613,5),(1527,528242413,4),(1527,543967213,5),(1527,559692013,4),(1527,575416814,5),(1527,591141614,4),(1527,606866414,5),(1527,622591214,4),(1527,638316015,5),(1527,654645615,4),(1527,670370416,6),(1527,686098816,7),(1527,701823616,6),(1527,717548417,7),(1527,733273217,6),(1527,748998018,7),(1527,764722818,6),(1527,780447619,7),(1527,796172419,6),(1527,811897219,4),(1527,852062420,3),(1527,859672820,5),(1527,877816821,4),(1527,891122421,5),(1527,909266421,4),(1527,922572022,5),(1527,941320822,4),(1527,954021622,5),(1527,972770422,4),(1527,985471222,5),(1527,1004220022,4),(1527,1017525622,5),(1527,1035669622,4),(1527,1048975222,5),(1527,1067119222,4),(1527,1080424822,5),(1527,1099173622,4),(1527,1111874422,5),(1527,1130623222,4),(1527,1143324023,5),(1527,1162072823,4),(1527,1174773623,5),(1527,1193522423,4),(1527,1206828023,5),(1527,1224972023,4),(1527,1238277624,5),(1527,1256421624,4),(1527,1269727224,5),(1527,1288476024,4),(1527,1293825624,3),(1527,1301176824,5),(1527,1319925624,4),(1528,-2147483648,1),(1528,-1830376800,6),(1528,-1689548400,2),(1528,-1677794400,3),(1528,-1667430000,4),(1528,-1647730800,5),(1528,-1635807600,4),(1528,-1616194800,5),(1528,-1604358000,4),(1528,-1584658800,5),(1528,-1572735600,4),(1528,-1553036400,5),(1528,-1541199600,4),(1528,-1521500400,5),(1528,-1442444400,4),(1528,-1426806000,5),(1528,-1379286000,4),(1528,-1364770800,5),(1528,-1348441200,4),(1528,-1333321200,5),(1528,-1316386800,4),(1528,-1301266800,5),(1528,-1284332400,4),(1528,-1269817200,5),(1528,-1221433200,4),(1528,-1206918000,5),(1528,-1191193200,4),(1528,-1175468400,5),(1528,-1127689200,4),(1528,-1111964400,5),(1528,-1096844400,4),(1528,-1080514800,5),(1528,-1063580400,4),(1528,-1049065200,5),(1528,-1033340400,4),(1528,-1017615600,5),(1528,-1002495600,4),(1528,-986166000,5),(1528,-969231600,4),(1528,-950482800,5),(1528,-942015600,4),(1528,-922662000,5),(1528,-906937200,4),(1528,-891126000,5),(1528,-877302000,4),(1528,-873676800,7),(1528,-864000000,4),(1528,-857948400,5),(1528,-845852400,4),(1528,-842832000,7),(1528,-831340800,4),(1528,-825894000,5),(1528,-814402800,4),(1528,-810777600,7),(1528,-799891200,4),(1528,-794444400,5),(1528,-782953200,4),(1528,-779328000,7),(1528,-768441600,4),(1528,-762994800,5),(1528,-749084400,4),(1528,-733359600,5),(1528,-717624000,4),(1528,-701899200,5),(1528,-686174400,4),(1528,-670449600,5),(1528,-654724800,4),(1528,-639000000,5),(1528,-623275200,4),(1528,-607550400,5),(1528,-591825600,4),(1528,-575496000,5),(1528,-559771200,4),(1528,-544046400,5),(1528,-528321600,4),(1528,-512596800,5),(1528,-496872000,4),(1528,-481147200,5),(1528,-465422400,4),(1528,-449697600,5),(1528,-433972800,4),(1528,-417643200,5),(1528,-401918400,4),(1528,-386193600,5),(1528,-370468800,4),(1528,-354744000,5),(1528,-339019200,4),(1528,-323294400,5),(1528,-307569600,4),(1528,-291844800,5),(1528,-276120000,4),(1528,-260395200,5),(1528,-244670400,4),(1528,-228340800,5),(1528,-212616000,4),(1528,-196891200,5),(1528,-181166400,4),(1528,-165441600,5),(1528,-149716800,4),(1528,-133992000,5),(1528,-118267200,9),(1528,228272406,7),(1528,243997206,8),(1528,260326807,7),(1528,276051607,8),(1528,291776408,7),(1528,307504808,8),(1528,323226009,7),(1528,338954409,8),(1528,354679209,7),(1528,370404010,8),(1528,386128810,7),(1528,401853611,8),(1528,417582011,7),(1528,433303212,8),(1528,449028012,7),(1528,465357612,8),(1528,481082412,7),(1528,496807213,8),(1528,512532013,7),(1528,528256813,8),(1528,543981613,7),(1528,559706413,8),(1528,575431214,7),(1528,591156014,8),(1528,606880814,7),(1528,622605614,8),(1528,638330415,7),(1528,654660015,8),(1528,670384816,7),(1528,686109616,8),(1528,701834416,7),(1528,717559217,10),(1528,733280417,11),(1528,749005218,12),(1528,764730018,11),(1528,780454819,12),(1528,796179619,11),(1528,811904419,12),(1528,828234020,11),(1528,846378020,12),(1528,859683620,11),(1528,877827621,12),(1528,891133221,11),(1528,909277221,12),(1528,922582822,11),(1528,941331622,12),(1528,954032422,11),(1528,972781222,12),(1528,985482022,11),(1528,1004230822,12),(1528,1017536422,11),(1528,1035680422,12),(1528,1048986022,11),(1528,1067130022,12),(1528,1080435622,11),(1528,1099184422,12),(1528,1111885222,11),(1528,1130634022,12),(1528,1143334823,11),(1528,1162083623,12),(1528,1174784423,11),(1528,1193533223,12),(1528,1206838823,11),(1528,1224982823,12),(1528,1238288424,11),(1528,1256432424,12),(1528,1269738024,11),(1528,1288486824,12),(1528,1301187624,11),(1528,1319936424,12),(1528,1332637224,11),(1528,1351386025,12),(1528,1364691625,11),(1528,1382835625,12),(1528,1396141225,11),(1528,1414285225,12),(1528,1427590825,11),(1528,1445734826,12),(1528,1459040426,11),(1528,1477789226,12),(1528,1490490027,11),(1528,1509238827,12),(1528,1521939627,11),(1528,1540688427,12),(1528,1553994027,11),(1528,1572138027,12),(1528,1585443627,11),(1528,1603587627,12),(1528,1616893227,11),(1528,1635642027,12),(1528,1648342827,11),(1528,1667091627,12),(1528,1679792427,11),(1528,1698541227,12),(1528,1711846827,11),(1528,1729990827,12),(1528,1743296427,11),(1528,1761440427,12),(1528,1774746027,11),(1528,1792890027,12),(1528,1806195627,11),(1528,1824944427,12),(1528,1837645227,11),(1528,1856394027,12),(1528,1869094827,11),(1528,1887843627,12),(1528,1901149227,11),(1528,1919293227,12),(1528,1932598827,11),(1528,1950742827,12),(1528,1964048427,11),(1528,1982797227,12),(1528,1995498027,11),(1528,2014246827,12),(1528,2026947627,11),(1528,2045696427,12),(1528,2058397227,11),(1528,2077146027,12),(1528,2090451627,11),(1528,2108595627,12),(1528,2121901227,11),(1528,2140045227,12),(1529,-2147483648,2),(1529,-1664307642,1),(1529,-1648932042,2),(1529,-1632080442,1),(1529,-1618692042,2),(1529,-1262281242,4),(1529,-882727200,3),(1529,-858538800,4),(1529,-845229600,3),(1529,-825879600,4),(1529,-814384800,3),(1529,-793825200,4),(1529,-782935200,3),(1529,-762375600,4),(1529,-713988000,3),(1529,-703710000,4),(1529,-681933600,3),(1529,-672865200,4),(1529,-650484000,3),(1529,-641415600,4),(1529,-618429600,3),(1529,-609966000,4),(1529,-586980000,3),(1529,-578516400,4),(1529,-555530400,3),(1529,-546462000,4),(1529,-429127200,3),(1529,-415825200,4),(1529,136360803,3),(1529,152082003,4),(1529,167810404,3),(1529,183531604,4),(1529,199260005,3),(1529,215586005,4),(1529,230709606,3),(1529,247035606,4),(1529,262764007,3),(1529,278485207,4),(1529,294213608,3),(1529,309934808,4),(1529,325663209,3),(1529,341384409,4),(1529,357112809,3),(1529,372834010,4),(1529,388562410,3),(1529,404888411,4),(1529,420012011,3),(1529,436338012,4),(1529,452066412,3),(1529,467787612,4),(1529,483516012,3),(1529,499237213,4),(1529,514965613,3),(1529,530686813,4),(1529,544600813,3),(1529,562136413,4),(1529,576050414,3),(1529,594190814,4),(1529,607500014,3),(1529,625640414,4),(1529,638949615,3),(1529,657090015,4),(1529,671004016,3),(1529,688539616,4),(1529,702453616,3),(1529,719989217,4),(1529,733903217,3),(1529,752043618,4),(1529,765352818,3),(1529,783493219,4),(1529,796802419,3),(1529,814942819,4),(1529,828856820,3),(1529,846392420,4),(1529,860306420,3),(1529,877842021,4),(1529,891756021,3),(1529,909291621,4),(1529,923205622,3),(1529,941346022,4),(1529,954655222,3),(1529,972795622,4),(1529,986104822,3),(1529,1004245222,4),(1529,1018159222,3),(1529,1035694822,4),(1529,1049608822,3),(1529,1067144422,4),(1529,1081058422,3),(1529,1099198822,4),(1529,1112508022,3),(1529,1130648422,4),(1529,1143957623,3),(1529,1162098023,4),(1529,1173592823,3),(1529,1194152423,4),(1529,1205042423,3),(1529,1225602023,4),(1529,1236492024,3),(1529,1257051624,4),(1529,1268546424,3),(1529,1289106024,4),(1529,1299996024,3),(1529,1320555624,4),(1529,1331445624,3),(1529,1352005225,4),(1529,1362895225,3),(1529,1383454825,4),(1529,1394344825,3),(1529,1414904425,4),(1529,1425794425,3),(1529,1446354026,4),(1529,1457848826,3),(1529,1478408426,4),(1529,1489298427,3),(1529,1509858027,4),(1529,1520748027,3),(1529,1541307627,4),(1529,1552197627,3),(1529,1572757227,4),(1529,1583647227,3),(1529,1604206827,4),(1529,1615701627,3),(1529,1636261227,4),(1529,1647151227,3),(1529,1667710827,4),(1529,1678600827,3),(1529,1699160427,4),(1529,1710050427,3),(1529,1730610027,4),(1529,1741500027,3),(1529,1762059627,4),(1529,1772949627,3),(1529,1793509227,4),(1529,1805004027,3),(1529,1825563627,4),(1529,1836453627,3),(1529,1857013227,4),(1529,1867903227,3),(1529,1888462827,4),(1529,1899352827,3),(1529,1919912427,4),(1529,1930802427,3),(1529,1951362027,4),(1529,1962856827,3),(1529,1983416427,4),(1529,1994306427,3),(1529,2014866027,4),(1529,2025756027,3),(1529,2046315627,4),(1529,2057205627,3),(1529,2077765227,4),(1529,2088655227,3),(1529,2109214827,4),(1529,2120104827,3),(1529,2140664427,4),(1530,-2147483648,0),(1530,-1509663504,1),(1530,-733874400,2),(1530,323827209,3),(1530,338950809,4),(1530,354675609,5),(1530,370400410,4),(1530,386125210,5),(1530,401850011,4),(1530,417574811,5),(1530,433299612,4),(1530,449024412,5),(1530,465354012,4),(1530,481078812,5),(1530,496803613,4),(1530,512528413,5),(1530,528253213,4),(1530,543978013,5),(1530,559702813,4),(1530,575427614,5),(1530,591152414,4),(1530,606877214,5),(1530,622602014,4),(1530,638326815,5),(1530,654656415,4),(1530,670381216,5),(1530,686106016,4),(1530,701830816,5),(1530,717555617,4),(1530,733280417,5),(1530,749005218,4),(1530,764730018,5),(1530,780454819,4),(1530,796179619,5),(1530,811904419,4),(1530,828234020,5),(1530,846378020,4),(1530,859683620,5),(1530,877827621,4),(1530,891133221,5),(1530,909277221,4),(1530,922582822,5),(1530,941331622,4),(1530,954032422,5),(1530,972781222,4),(1530,985482022,5),(1530,1004230822,4),(1530,1017536422,5),(1530,1035680422,4),(1530,1048986022,5),(1530,1067130022,4),(1530,1080435622,5),(1530,1099184422,4),(1530,1111885222,5),(1530,1130634022,4),(1530,1143334823,5),(1530,1162083623,4),(1530,1174784423,5),(1530,1193533223,4),(1530,1206838823,5),(1530,1224982823,4),(1530,1238288424,5),(1530,1256432424,4),(1530,1269738024,5),(1530,1288486824,4),(1530,1301187624,5),(1530,1319936424,4),(1530,1332637224,5),(1530,1351386025,4),(1530,1364691625,5),(1530,1382835625,4),(1530,1396141225,5),(1530,1414285225,4),(1530,1427590825,5),(1530,1445734826,4),(1530,1459040426,5),(1530,1477789226,4),(1530,1490490027,5),(1530,1509238827,4),(1530,1521939627,5),(1530,1540688427,4),(1530,1553994027,5),(1530,1572138027,4),(1530,1585443627,5),(1530,1603587627,4),(1530,1616893227,5),(1530,1635642027,4),(1530,1648342827,5),(1530,1667091627,4),(1530,1679792427,5),(1530,1698541227,4),(1530,1711846827,5),(1530,1729990827,4),(1530,1743296427,5),(1530,1761440427,4),(1530,1774746027,5),(1530,1792890027,4),(1530,1806195627,5),(1530,1824944427,4),(1530,1837645227,5),(1530,1856394027,4),(1530,1869094827,5),(1530,1887843627,4),(1530,1901149227,5),(1530,1919293227,4),(1530,1932598827,5),(1530,1950742827,4),(1530,1964048427,5),(1530,1982797227,4),(1530,1995498027,5),(1530,2014246827,4),(1530,2026947627,5),(1530,2045696427,4),(1530,2058397227,5),(1530,2077146027,4),(1530,2090451627,5),(1530,2108595627,4),(1530,2121901227,5),(1530,2140045227,4),(1531,-2147483648,0),(1531,-1830376800,1),(1531,-862610400,2),(1531,-764118000,3),(1531,186120004,4),(1532,-2147483648,0),(1532,-1955748776,1),(1532,354675609,2),(1532,370400410,3),(1532,386125210,2),(1532,401850011,3),(1532,417574811,2),(1532,433299612,3),(1532,449024412,2),(1532,465354012,3),(1532,481078812,2),(1532,496803613,3),(1532,512528413,2),(1532,528253213,3),(1532,543978013,2),(1532,559702813,3),(1532,575427614,2),(1532,591152414,3),(1532,606877214,2),(1532,622602014,3),(1532,638326815,2),(1532,654656415,3),(1532,670381216,2),(1532,686106016,3),(1532,701830816,2),(1532,717555617,3),(1532,733280417,2),(1532,749005218,3),(1532,764730018,2),(1532,780454819,3),(1532,796179619,2),(1532,811904419,3),(1532,828234020,2),(1532,846378020,3),(1532,859683620,2),(1532,877827621,3),(1532,891133221,2),(1532,909277221,3),(1532,922582822,2),(1532,941331622,3),(1532,954032422,2),(1532,972781222,3),(1532,985482022,2),(1532,1004230822,3),(1532,1017536422,2),(1532,1035680422,3),(1532,1048986022,2),(1532,1067130022,3),(1532,1080435622,2),(1532,1099184422,3),(1532,1111885222,2),(1532,1130634022,3),(1532,1143334823,2),(1532,1162083623,3),(1532,1174784423,2),(1532,1193533223,3),(1532,1206838823,2),(1532,1224982823,3),(1532,1238288424,2),(1532,1256432424,3),(1532,1269738024,2),(1532,1288486824,3),(1532,1301187624,2),(1532,1319936424,3),(1532,1332637224,2),(1532,1351386025,3),(1532,1364691625,2),(1532,1382835625,3),(1532,1396141225,2),(1532,1414285225,3),(1532,1427590825,2),(1532,1445734826,3),(1532,1459040426,2),(1532,1477789226,3),(1532,1490490027,2),(1532,1509238827,3),(1532,1521939627,2),(1532,1540688427,3),(1532,1553994027,2),(1532,1572138027,3),(1532,1585443627,2),(1532,1603587627,3),(1532,1616893227,2),(1532,1635642027,3),(1532,1648342827,2),(1532,1667091627,3),(1532,1679792427,2),(1532,1698541227,3),(1532,1711846827,2),(1532,1729990827,3),(1532,1743296427,2),(1532,1761440427,3),(1532,1774746027,2),(1532,1792890027,3),(1532,1806195627,2),(1532,1824944427,3),(1532,1837645227,2),(1532,1856394027,3),(1532,1869094827,2),(1532,1887843627,3),(1532,1901149227,2),(1532,1919293227,3),(1532,1932598827,2),(1532,1950742827,3),(1532,1964048427,2),(1532,1982797227,3),(1532,1995498027,2),(1532,2014246827,3),(1532,2026947627,2),(1532,2045696427,3),(1532,2058397227,2),(1532,2077146027,3),(1532,2090451627,2),(1532,2108595627,3),(1532,2121901227,2),(1532,2140045227,3),(1533,-2147483648,0),(1533,-1955748776,1),(1533,354675609,2),(1533,370400410,3),(1533,386125210,2),(1533,401850011,3),(1533,417574811,2),(1533,433299612,3),(1533,449024412,2),(1533,465354012,3),(1533,481078812,2),(1533,496803613,3),(1533,512528413,2),(1533,528253213,3),(1533,543978013,2),(1533,559702813,3),(1533,575427614,2),(1533,591152414,3),(1533,606877214,2),(1533,622602014,3),(1533,638326815,2),(1533,654656415,3),(1533,670381216,2),(1533,686106016,3),(1533,701830816,2),(1533,717555617,3),(1533,733280417,2),(1533,749005218,3),(1533,764730018,2),(1533,780454819,3),(1533,796179619,2),(1533,811904419,3),(1533,828234020,2),(1533,846378020,3),(1533,859683620,2),(1533,877827621,3),(1533,891133221,2),(1533,909277221,3),(1533,922582822,2),(1533,941331622,3),(1533,954032422,2),(1533,972781222,3),(1533,985482022,2),(1533,1004230822,3),(1533,1017536422,2),(1533,1035680422,3),(1533,1048986022,2),(1533,1067130022,3),(1533,1080435622,2),(1533,1099184422,3),(1533,1111885222,2),(1533,1130634022,3),(1533,1143334823,2),(1533,1162083623,3),(1533,1174784423,2),(1533,1193533223,3),(1533,1206838823,2),(1533,1224982823,3),(1533,1238288424,2),(1533,1256432424,3),(1533,1269738024,2),(1533,1288486824,3),(1533,1301187624,2),(1533,1319936424,3),(1533,1332637224,2),(1533,1351386025,3),(1533,1364691625,2),(1533,1382835625,3),(1533,1396141225,2),(1533,1414285225,3),(1533,1427590825,2),(1533,1445734826,3),(1533,1459040426,2),(1533,1477789226,3),(1533,1490490027,2),(1533,1509238827,3),(1533,1521939627,2),(1533,1540688427,3),(1533,1553994027,2),(1533,1572138027,3),(1533,1585443627,2),(1533,1603587627,3),(1533,1616893227,2),(1533,1635642027,3),(1533,1648342827,2),(1533,1667091627,3),(1533,1679792427,2),(1533,1698541227,3),(1533,1711846827,2),(1533,1729990827,3),(1533,1743296427,2),(1533,1761440427,3),(1533,1774746027,2),(1533,1792890027,3),(1533,1806195627,2),(1533,1824944427,3),(1533,1837645227,2),(1533,1856394027,3),(1533,1869094827,2),(1533,1887843627,3),(1533,1901149227,2),(1533,1919293227,3),(1533,1932598827,2),(1533,1950742827,3),(1533,1964048427,2),(1533,1982797227,3),(1533,1995498027,2),(1533,2014246827,3),(1533,2026947627,2),(1533,2045696427,3),(1533,2058397227,2),(1533,2077146027,3),(1533,2090451627,2),(1533,2108595627,3),(1533,2121901227,2),(1533,2140045227,3),(1534,-2147483648,2),(1534,-1693706400,1),(1534,-1680483600,2),(1534,-1663455600,3),(1534,-1650150000,4),(1534,-1632006000,3),(1534,-1618700400,4),(1534,-938905200,3),(1534,-857257200,4),(1534,-844556400,3),(1534,-828226800,4),(1534,-812502000,3),(1534,-796777200,4),(1534,-781052400,3),(1534,-776563200,5),(1534,-765936000,1),(1534,-761180400,4),(1534,-757386000,2),(1534,-748479600,3),(1534,-733273200,4),(1534,-717631200,3),(1534,-714610800,6),(1534,-710380800,1),(1534,-701910000,4),(1534,-684975600,3),(1534,-670460400,4),(1534,-654130800,3),(1534,-639010800,4),(1534,315529208,2),(1534,323830809,7),(1534,338950809,8),(1534,354675609,7),(1534,370400410,8),(1534,386125210,7),(1534,401850011,8),(1534,417574811,7),(1534,433299612,8),(1534,449024412,7),(1534,465354012,8),(1534,481078812,7),(1534,496803613,8),(1534,512528413,7),(1534,528253213,8),(1534,543978013,7),(1534,559702813,8),(1534,575427614,7),(1534,591152414,8),(1534,606877214,7),(1534,622602014,8),(1534,638326815,7),(1534,654656415,8),(1534,670381216,7),(1534,686106016,8),(1534,701830816,7),(1534,717555617,8),(1534,733280417,7),(1534,749005218,8),(1534,764730018,7),(1534,780454819,8),(1534,796179619,7),(1534,811904419,8),(1534,828234020,7),(1534,846378020,8),(1534,859683620,7),(1534,877827621,8),(1534,891133221,7),(1534,909277221,8),(1534,922582822,7),(1534,941331622,8),(1534,954032422,7),(1534,972781222,8),(1534,985482022,7),(1534,1004230822,8),(1534,1017536422,7),(1534,1035680422,8),(1534,1048986022,7),(1534,1067130022,8),(1534,1080435622,7),(1534,1099184422,8),(1534,1111885222,7),(1534,1130634022,8),(1534,1143334823,7),(1534,1162083623,8),(1534,1174784423,7),(1534,1193533223,8),(1534,1206838823,7),(1534,1224982823,8),(1534,1238288424,7),(1534,1256432424,8),(1534,1269738024,7),(1534,1288486824,8),(1534,1301187624,7),(1534,1319936424,8),(1534,1332637224,7),(1534,1351386025,8),(1534,1364691625,7),(1534,1382835625,8),(1534,1396141225,7),(1534,1414285225,8),(1534,1427590825,7),(1534,1445734826,8),(1534,1459040426,7),(1534,1477789226,8),(1534,1490490027,7),(1534,1509238827,8),(1534,1521939627,7),(1534,1540688427,8),(1534,1553994027,7),(1534,1572138027,8),(1534,1585443627,7),(1534,1603587627,8),(1534,1616893227,7),(1534,1635642027,8),(1534,1648342827,7),(1534,1667091627,8),(1534,1679792427,7),(1534,1698541227,8),(1534,1711846827,7),(1534,1729990827,8),(1534,1743296427,7),(1534,1761440427,8),(1534,1774746027,7),(1534,1792890027,8),(1534,1806195627,7),(1534,1824944427,8),(1534,1837645227,7),(1534,1856394027,8),(1534,1869094827,7),(1534,1887843627,8),(1534,1901149227,7),(1534,1919293227,8),(1534,1932598827,7),(1534,1950742827,8),(1534,1964048427,7),(1534,1982797227,8),(1534,1995498027,7),(1534,2014246827,8),(1534,2026947627,7),(1534,2045696427,8),(1534,2058397227,7),(1534,2077146027,8),(1534,2090451627,7),(1534,2108595627,8),(1534,2121901227,7),(1534,2140045227,8),(1535,-2147483648,1),(1535,-1830380400,6),(1535,-1689552000,2),(1535,-1677798000,3),(1535,-1667433600,4),(1535,-1647734400,5),(1535,-1635811200,4),(1535,-1616198400,5),(1535,-1604361600,4),(1535,-1584662400,5),(1535,-1572739200,4),(1535,-1553040000,5),(1535,-1541203200,4),(1535,-1521504000,5),(1535,-1442448000,4),(1535,-1426809600,5),(1535,-1379289600,4),(1535,-1364774400,5),(1535,-1348444800,4),(1535,-1333324800,5),(1535,-1316390400,4),(1535,-1301270400,5),(1535,-1284336000,4),(1535,-1269820800,5),(1535,-1221436800,4),(1535,-1206921600,5),(1535,-1191196800,4),(1535,-1175472000,5),(1535,-1127692800,4),(1535,-1111968000,5),(1535,-1096848000,4),(1535,-1080518400,5),(1535,-1063584000,4),(1535,-1049068800,5),(1535,-1033344000,4),(1535,-1017619200,5),(1535,-1002499200,4),(1535,-986169600,5),(1535,-969235200,4),(1535,-950486400,5),(1535,-942019200,4),(1535,-922665600,5),(1535,-906940800,4),(1535,-891129600,5),(1535,-877305600,4),(1535,-873680400,7),(1535,-864003600,4),(1535,-857952000,5),(1535,-845856000,4),(1535,-842835600,7),(1535,-831344400,4),(1535,-825897600,5),(1535,-814406400,4),(1535,-810781200,7),(1535,-799894800,4),(1535,-794448000,5),(1535,-782956800,4),(1535,-779331600,7),(1535,-768445200,4),(1535,-762998400,5),(1535,-749088000,4),(1535,-733363200,5),(1535,-717627600,4),(1535,-701902800,5),(1535,-686178000,4),(1535,-670453200,5),(1535,-654728400,4),(1535,-639003600,5),(1535,-623278800,4),(1535,-607554000,5),(1535,-591829200,4),(1535,-575499600,5),(1535,-559774800,4),(1535,-544050000,5),(1535,-528325200,4),(1535,-512600400,5),(1535,-496875600,4),(1535,-481150800,5),(1535,-465426000,4),(1535,-449701200,5),(1535,-433976400,4),(1535,-417646800,5),(1535,-401922000,4),(1535,-386197200,5),(1535,-370472400,4),(1535,-354747600,5),(1535,-339022800,4),(1535,-323298000,5),(1535,-307573200,4),(1535,-291848400,5),(1535,-276123600,4),(1535,-260398800,5),(1535,-244674000,4),(1535,-228344400,5),(1535,-212619600,4),(1535,-196894800,5),(1535,-181170000,4),(1535,-165445200,5),(1535,-149720400,4),(1535,-133995600,5),(1535,-118270800,10),(1535,228268806,8),(1535,243993606,9),(1535,260323207,8),(1535,276048007,9),(1535,291772808,8),(1535,307501208,9),(1535,323222409,8),(1535,338950809,9),(1535,354675609,8),(1535,370400410,9),(1535,386125210,8),(1535,401850011,9),(1535,417578411,8),(1535,433299612,11),(1535,449024412,12),(1535,465354012,11),(1535,481078812,12),(1535,496803613,11),(1535,512528413,12),(1535,528253213,11),(1535,543978013,12),(1535,559702813,11),(1535,575427614,12),(1535,591152414,11),(1535,606877214,12),(1535,622602014,11),(1535,638326815,12),(1535,654656415,11),(1535,670381216,12),(1535,686106016,11),(1535,701830816,12),(1535,717555617,11),(1535,733280417,12),(1535,749005218,11),(1535,764730018,12),(1535,780454819,11),(1535,796179619,12),(1535,811904419,11),(1535,828234020,12),(1535,846378020,11),(1535,859683620,12),(1535,877827621,11),(1535,891133221,12),(1535,909277221,11),(1535,922582822,12),(1535,941331622,11),(1535,954032422,12),(1535,972781222,11),(1535,985482022,12),(1535,1004230822,11),(1535,1017536422,12),(1535,1035680422,11),(1535,1048986022,12),(1535,1067130022,11),(1535,1080435622,12),(1535,1099184422,11),(1535,1111885222,12),(1535,1130634022,11),(1535,1143334823,12),(1535,1162083623,11),(1535,1174784423,12),(1535,1193533223,11),(1535,1206838823,12),(1535,1224982823,11),(1535,1238288424,12),(1535,1256432424,11),(1535,1269738024,12),(1535,1288486824,11),(1535,1301187624,12),(1535,1319936424,11),(1535,1332637224,12),(1535,1351386025,11),(1535,1364691625,12),(1535,1382835625,11),(1535,1396141225,12),(1535,1414285225,11),(1535,1427590825,12),(1535,1445734826,11),(1535,1459040426,12),(1535,1477789226,11),(1535,1490490027,12),(1535,1509238827,11),(1535,1521939627,12),(1535,1540688427,11),(1535,1553994027,12),(1535,1572138027,11),(1535,1585443627,12),(1535,1603587627,11),(1535,1616893227,12),(1535,1635642027,11),(1535,1648342827,12),(1535,1667091627,11),(1535,1679792427,12),(1535,1698541227,11),(1535,1711846827,12),(1535,1729990827,11),(1535,1743296427,12),(1535,1761440427,11),(1535,1774746027,12),(1535,1792890027,11),(1535,1806195627,12),(1535,1824944427,11),(1535,1837645227,12),(1535,1856394027,11),(1535,1869094827,12),(1535,1887843627,11),(1535,1901149227,12),(1535,1919293227,11),(1535,1932598827,12),(1535,1950742827,11),(1535,1964048427,12),(1535,1982797227,11),(1535,1995498027,12),(1535,2014246827,11),(1535,2026947627,12),(1535,2045696427,11),(1535,2058397227,12),(1535,2077146027,11),(1535,2090451627,12),(1535,2108595627,11),(1535,2121901227,12),(1535,2140045227,11),(1536,-2147483648,0),(1536,-1830383032,1),(1538,-2147483648,0),(1538,-1830383032,1),(1539,-2147483648,1),(1539,-1824235716,3),(1539,-1018209600,2),(1539,-1003093200,3),(1539,-986760000,2),(1539,-971643600,3),(1539,-954705600,2),(1539,-939589200,3),(1539,-923256000,2),(1539,-908139600,3),(1539,-891806400,2),(1539,-876690000,3),(1539,-860356800,2),(1539,-852066000,3),(1539,420609611,5),(1539,433306812,4),(1539,452052012,5),(1539,464151612,4),(1539,483501612,5),(1539,495601213,2),(1539,514350013,3),(1539,527054413,2),(1539,545799613,3),(1539,558504013,2),(1539,577249214,3),(1539,589953614,2),(1539,608698814,3),(1539,621403214,2),(1539,640753215,3),(1539,652852815,2),(1539,672202816,3),(1539,684907216,2),(1539,703652416,3),(1539,716356817,2),(1539,735102017,3),(1539,747806418,2),(1539,766551618,3),(1539,779256019,2),(1539,798001219,3),(1539,810705619,2),(1539,830055620,3),(1539,842760020,2),(1539,861505220,3),(1539,874209621,2),(1539,892954821,3),(1539,905659221,2),(1539,924404422,3),(1539,937108822,2),(1539,955854022,3),(1539,968558422,2),(1539,987310822,3),(1539,999410422,2),(1539,1019365222,3),(1539,1030860022,2),(1539,1050814822,3),(1539,1062914422,2),(1539,1082264422,3),(1539,1094364022,2),(1539,1113714022,3),(1539,1125813622,2),(1539,1145163623,3),(1539,1157263223,2),(1539,1176613223,3),(1539,1188712823,2),(1539,1208667623,3),(1539,1220767223,2),(1539,1240117224,3),(1539,1252216824,2),(1539,1271566824,3),(1539,1283666424,5),(1540,-2147483648,3),(1540,-1672560000,1),(1540,-1665388800,2),(1540,-883641600,1),(1540,-876124800,2),(1540,-860400000,1),(1540,-844675200,2),(1540,-828345600,1),(1540,-813225600,2),(1540,31500000,3),(1540,57686400,1),(1540,67968000,2),(1540,89136001,1),(1540,100022402,2),(1540,120585602,1),(1540,131472003,2),(1540,152035203,1),(1540,162921604,2),(1540,183484804,1),(1540,194976005,2),(1540,215539205,1),(1540,226425606,2),(1540,246988806,1),(1540,257875207,2),(1540,278438407,1),(1540,289324808,2),(1540,309888008,1),(1540,320774409,2),(1540,341337609,1),(1540,352224009,2),(1540,372787210,1),(1540,386697610,2),(1540,404841611,1),(1540,415728011,2),(1540,436291212,1),(1540,447177612,2),(1540,467740812,1),(1540,478627212,2),(1540,499190413,1),(1540,511286413,2),(1540,530035213,1),(1540,542736013,2),(1540,562089613,1),(1540,574790414,2),(1540,594144014,1),(1540,606240014,2),(1540,625593614,1),(1540,636480015,2),(1540,657043215,1),(1540,667929616,2),(1540,688492816,1),(1540,699379216,2),(1540,719942417,1),(1540,731433617,2),(1540,751996818,1),(1540,762883218,2),(1540,783446419,1),(1540,794332819,2),(1540,814896019,1),(1540,828201620,2),(1540,846345620,1),(1540,859651220,2),(1540,877795221,1),(1540,891100821,2),(1540,909244821,1),(1540,922550422,2),(1540,941299222,1),(1540,954000022,2),(1540,967305622,1),(1540,985449622,2),(1540,1004198422,1),(1540,1017504022,2),(1540,1035648022,1),(1540,1048953622,2),(1540,1067097622,1),(1540,1080403222,2),(1540,1099152022,1),(1540,1111852822,2),(1540,1130601622,1),(1540,1143907223,2),(1540,1162051223,1),(1540,1174752023,2),(1540,1193500823,1),(1540,1207411223,2),(1540,1223136023,1),(1540,1238860824,2),(1540,1254585624,1),(1540,1270310424,2),(1540,1286035224,1),(1540,1301760024,2),(1540,1317484824,1),(1540,1333209624,2),(1540,1349539225,1),(1540,1365264025,2),(1540,1380988825,1),(1540,1396713625,2),(1540,1412438425,1),(1540,1428163225,2),(1540,1443888026,1),(1540,1459612826,2),(1540,1475337626,1),(1540,1491062427,2),(1540,1506787227,1),(1540,1522512027,2),(1540,1538841627,1),(1540,1554566427,2),(1540,1570291227,1),(1540,1586016027,2),(1540,1601740827,1),(1540,1617465627,2),(1540,1633190427,1),(1540,1648915227,2),(1540,1664640027,1),(1540,1680364827,2),(1540,1696089627,1),(1540,1712419227,2),(1540,1728144027,1),(1540,1743868827,2),(1540,1759593627,1),(1540,1775318427,2),(1540,1791043227,1),(1540,1806768027,2),(1540,1822492827,1),(1540,1838217627,2),(1540,1853942427,1),(1540,1869667227,2),(1540,1885996827,1),(1540,1901721627,2),(1540,1917446427,1),(1540,1933171227,2),(1540,1948896027,1),(1540,1964620827,2),(1540,1980345627,1),(1540,1996070427,2),(1540,2011795227,1),(1540,2027520027,2),(1540,2043244827,1),(1540,2058969627,2),(1540,2075299227,1),(1540,2091024027,2),(1540,2106748827,1),(1540,2122473627,2),(1540,2138198427,1),(1541,-2147483648,3),(1541,-1672558200,1),(1541,-1665387000,2),(1541,-883639800,1),(1541,-876123000,2),(1541,-860398200,1),(1541,-844673400,2),(1541,-828343800,1),(1541,-813223800,2),(1541,31501800,3),(1541,57688200,1),(1541,67969800,2),(1541,89137801,1),(1541,100024202,2),(1541,120587402,1),(1541,131473803,2),(1541,152037003,1),(1541,162923404,2),(1541,183486604,1),(1541,194977805,2),(1541,215541005,1),(1541,226427406,2),(1541,246990606,1),(1541,257877007,2),(1541,278440207,1),(1541,289326608,2),(1541,309889808,1),(1541,320776209,2),(1541,341339409,1),(1541,352225809,2),(1541,372789010,1),(1541,384280210,2),(1541,404843411,1),(1541,415729811,2),(1541,436293012,1),(1541,447179412,2),(1541,467742612,1),(1541,478629012,2),(1541,499192213,1),(1541,511288213,2),(1541,530037013,1),(1541,542737813,2),(1541,562091413,1),(1541,574792214,2),(1541,594145814,1),(1541,606241814,2),(1541,625595414,1),(1541,637691415,2),(1541,657045015,1),(1541,667931416,2),(1541,688494616,1),(1541,701195416,2),(1541,719944217,1),(1541,731435417,2),(1541,751998618,1),(1541,764094618,2),(1541,783448219,1),(1541,796149019,2),(1541,814897819,1),(1541,828203420,2),(1541,846347420,1),(1541,859653020,2),(1541,877797021,1),(1541,891102621,2),(1541,909246621,1),(1541,922552222,2),(1541,941301022,1),(1541,954001822,2),(1541,972750622,1),(1541,985451422,2),(1541,1004200222,1),(1541,1017505822,2),(1541,1035649822,1),(1541,1048955422,2),(1541,1067099422,1),(1541,1080405022,2),(1541,1099153822,1),(1541,1111854622,2),(1541,1130603422,1),(1541,1143909023,2),(1541,1162053023,1),(1541,1174753823,2),(1541,1193502623,1),(1541,1207413023,2),(1541,1223137823,1),(1541,1238862624,2),(1541,1254587424,1),(1541,1270312224,2),(1541,1286037024,1),(1541,1301761824,2),(1541,1317486624,1),(1541,1333211424,2),(1541,1349541025,1),(1541,1365265825,2),(1541,1380990625,1),(1541,1396715425,2),(1541,1412440225,1),(1541,1428165025,2),(1541,1443889826,1),(1541,1459614626,2),(1541,1475339426,1),(1541,1491064227,2),(1541,1506789027,1),(1541,1522513827,2),(1541,1538843427,1),(1541,1554568227,2),(1541,1570293027,1),(1541,1586017827,2),(1541,1601742627,1),(1541,1617467427,2),(1541,1633192227,1),(1541,1648917027,2),(1541,1664641827,1),(1541,1680366627,2),(1541,1696091427,1),(1541,1712421027,2),(1541,1728145827,1),(1541,1743870627,2),(1541,1759595427,1),(1541,1775320227,2),(1541,1791045027,1),(1541,1806769827,2),(1541,1822494627,1),(1541,1838219427,2),(1541,1853944227,1),(1541,1869669027,2),(1541,1885998627,1),(1541,1901723427,2),(1541,1917448227,1),(1541,1933173027,2),(1541,1948897827,1),(1541,1964622627,2),(1541,1980347427,1),(1541,1996072227,2),(1541,2011797027,1),(1541,2027521827,2),(1541,2043246627,1),(1541,2058971427,2),(1541,2075301027,1),(1541,2091025827,2),(1541,2106750627,1),(1541,2122475427,2),(1541,2138200227,1),(1542,-2147483648,3),(1542,-1672560000,1),(1542,-1665388800,2),(1542,-883641600,1),(1542,-876124800,2),(1542,-860400000,1),(1542,-844675200,2),(1542,-828345600,1),(1542,-813225600,2),(1542,31500000,3),(1542,57686400,1),(1542,67968000,2),(1542,625593614,1),(1542,636480015,2),(1542,657043215,1),(1542,667929616,2),(1542,688492816,1),(1542,699379216,2),(1543,-2147483648,3),(1543,-1672558200,1),(1543,-1665387000,2),(1543,-883639800,1),(1543,-876123000,2),(1543,-860398200,1),(1543,-844673400,2),(1543,-828343800,1),(1543,-813223800,2),(1543,31501800,3),(1543,57688200,1),(1543,67969800,2),(1543,89137801,1),(1543,100024202,2),(1543,120587402,1),(1543,131473803,2),(1543,152037003,1),(1543,162923404,2),(1543,183486604,1),(1543,194977805,2),(1543,215541005,1),(1543,226427406,2),(1543,246990606,1),(1543,257877007,2),(1543,278440207,1),(1543,289326608,2),(1543,309889808,1),(1543,320776209,2),(1543,341339409,1),(1543,352225809,2),(1543,372789010,1),(1543,386699410,2),(1543,404843411,1),(1543,415729811,2),(1543,436293012,1),(1543,447179412,2),(1543,467742612,1),(1543,478629012,2),(1543,499192213,1),(1543,511288213,2),(1543,530037013,1),(1543,542737813,2),(1543,562091413,1),(1543,574792214,2),(1543,594145814,1),(1543,606241814,2),(1543,625595414,1),(1543,636481815,2),(1543,657045015,1),(1543,667931416,2),(1543,688494616,1),(1543,699381016,2),(1543,719944217,1),(1543,731435417,2),(1543,751998618,1),(1543,762885018,2),(1543,783448219,1),(1543,794334619,2),(1543,814897819,1),(1543,828203420,2),(1543,846347420,1),(1543,859653020,2),(1543,877797021,1),(1543,891102621,2),(1543,909246621,1),(1543,922552222,2),(1543,941301022,1),(1543,946647022,4),(1543,954001822,2),(1543,972750622,1),(1543,985451422,2),(1543,1004200222,1),(1543,1017505822,2),(1543,1035649822,1),(1543,1048955422,2),(1543,1067099422,1),(1543,1080405022,2),(1543,1099153822,1),(1543,1111854622,2),(1543,1130603422,1),(1543,1143909023,2),(1543,1162053023,1),(1543,1174753823,2),(1543,1193502623,1),(1543,1207413023,2),(1543,1223137823,1),(1543,1238862624,2),(1543,1254587424,1),(1543,1270312224,2),(1543,1286037024,1),(1543,1301761824,2),(1543,1317486624,1),(1543,1333211424,2),(1543,1349541025,1),(1543,1365265825,2),(1543,1380990625,1),(1543,1396715425,2),(1543,1412440225,1),(1543,1428165025,2),(1543,1443889826,1),(1543,1459614626,2),(1543,1475339426,1),(1543,1491064227,2),(1543,1506789027,1),(1543,1522513827,2),(1543,1538843427,1),(1543,1554568227,2),(1543,1570293027,1),(1543,1586017827,2),(1543,1601742627,1),(1543,1617467427,2),(1543,1633192227,1),(1543,1648917027,2),(1543,1664641827,1),(1543,1680366627,2),(1543,1696091427,1),(1543,1712421027,2),(1543,1728145827,1),(1543,1743870627,2),(1543,1759595427,1),(1543,1775320227,2),(1543,1791045027,1),(1543,1806769827,2),(1543,1822494627,1),(1543,1838219427,2),(1543,1853944227,1),(1543,1869669027,2),(1543,1885998627,1),(1543,1901723427,2),(1543,1917448227,1),(1543,1933173027,2),(1543,1948897827,1),(1543,1964622627,2),(1543,1980347427,1),(1543,1996072227,2),(1543,2011797027,1),(1543,2027521827,2),(1543,2043246627,1),(1543,2058971427,2),(1543,2075301027,1),(1543,2091025827,2),(1543,2106750627,1),(1543,2122475427,2),(1543,2138200227,1),(1544,-2147483648,3),(1544,-1672560000,1),(1544,-1665388800,2),(1544,-883641600,1),(1544,-876124800,2),(1544,-860400000,1),(1544,-844675200,2),(1544,-828345600,1),(1544,-813225600,2),(1544,31500000,3),(1544,57686400,1),(1544,67968000,2),(1544,89136001,1),(1544,100022402,2),(1544,120585602,1),(1544,131472003,2),(1544,152035203,1),(1544,162921604,2),(1544,183484804,1),(1544,194976005,2),(1544,215539205,1),(1544,226425606,2),(1544,246988806,1),(1544,257875207,2),(1544,278438407,1),(1544,289324808,2),(1544,309888008,1),(1544,320774409,2),(1544,341337609,1),(1544,352224009,2),(1544,372787210,1),(1544,386697610,2),(1544,404841611,1),(1544,415728011,2),(1544,436291212,1),(1544,447177612,2),(1544,467740812,1),(1544,478627212,2),(1544,499190413,1),(1544,511286413,2),(1544,530035213,1),(1544,542736013,2),(1544,562089613,1),(1544,574790414,2),(1544,594144014,1),(1544,606240014,2),(1544,625593614,1),(1544,636480015,2),(1544,657043215,1),(1544,667929616,2),(1544,688492816,1),(1544,699379216,2),(1544,719942417,1),(1544,731433617,2),(1544,751996818,1),(1544,762883218,2),(1544,783446419,1),(1544,794332819,2),(1544,814896019,1),(1544,828201620,2),(1544,846345620,1),(1544,859651220,2),(1544,877795221,1),(1544,891100821,2),(1544,909244821,1),(1544,922550422,2),(1544,941299222,1),(1544,954000022,2),(1544,967305622,1),(1544,985449622,2),(1544,1004198422,1),(1544,1017504022,2),(1544,1035648022,1),(1544,1048953622,2),(1544,1067097622,1),(1544,1080403222,2),(1544,1099152022,1),(1544,1111852822,2),(1544,1130601622,1),(1544,1143907223,2),(1544,1162051223,1),(1544,1174752023,2),(1544,1193500823,1),(1544,1207411223,2),(1544,1223136023,1),(1544,1238860824,2),(1544,1254585624,1),(1544,1270310424,2),(1544,1286035224,1),(1544,1301760024,2),(1544,1317484824,1),(1544,1333209624,2),(1544,1349539225,1),(1544,1365264025,2),(1544,1380988825,1),(1544,1396713625,2),(1544,1412438425,1),(1544,1428163225,2),(1544,1443888026,1),(1544,1459612826,2),(1544,1475337626,1),(1544,1491062427,2),(1544,1506787227,1),(1544,1522512027,2),(1544,1538841627,1),(1544,1554566427,2),(1544,1570291227,1),(1544,1586016027,2),(1544,1601740827,1),(1544,1617465627,2),(1544,1633190427,1),(1544,1648915227,2),(1544,1664640027,1),(1544,1680364827,2),(1544,1696089627,1),(1544,1712419227,2),(1544,1728144027,1),(1544,1743868827,2),(1544,1759593627,1),(1544,1775318427,2),(1544,1791043227,1),(1544,1806768027,2),(1544,1822492827,1),(1544,1838217627,2),(1544,1853942427,1),(1544,1869667227,2),(1544,1885996827,1),(1544,1901721627,2),(1544,1917446427,1),(1544,1933171227,2),(1544,1948896027,1),(1544,1964620827,2),(1544,1980345627,1),(1544,1996070427,2),(1544,2011795227,1),(1544,2027520027,2),(1544,2043244827,1),(1544,2058969627,2),(1544,2075299227,1),(1544,2091024027,2),(1544,2106748827,1),(1544,2122473627,2),(1544,2138198427,1),(1545,-2147483648,3),(1545,-1680508800,1),(1545,-1665388800,2),(1545,-1646640000,1),(1545,-1635753600,2),(1545,-1615190400,1),(1545,-1604304000,2),(1545,-1583920800,3),(1545,-883641600,1),(1545,-876124800,2),(1545,-860400000,1),(1545,-844675200,2),(1545,-828345600,1),(1545,-813225600,2),(1545,-94730400,3),(1545,-71136000,1),(1545,-55411200,2),(1545,-37267200,1),(1545,-25776000,2),(1545,-5817600,1),(1545,5673600,2),(1545,25632000,1),(1545,37728000,2),(1545,57686400,1),(1545,67968000,2),(1545,89136001,1),(1545,100022402,2),(1545,120585602,1),(1545,131472003,2),(1545,152035203,1),(1545,162921604,2),(1545,183484804,1),(1545,194976005,2),(1545,215539205,1),(1545,226425606,2),(1545,246988806,1),(1545,257875207,2),(1545,278438407,1),(1545,289324808,2),(1545,309888008,1),(1545,320774409,2),(1545,341337609,1),(1545,352224009,2),(1545,372787210,1),(1545,386092810,2),(1545,404841611,1),(1545,417542411,2),(1545,436291212,1),(1545,447177612,2),(1545,467740812,1),(1545,478627212,2),(1545,499190413,1),(1545,510076813,2),(1545,530035213,1),(1545,542736013,2),(1545,562089613,1),(1545,574790414,2),(1545,594144014,1),(1545,606240014,2),(1545,625593614,1),(1545,637689615,2),(1545,657043215,1),(1545,670348816,2),(1545,686678416,1),(1545,701798416,2),(1545,718128017,1),(1545,733248017,2),(1545,749577618,1),(1545,764697618,2),(1545,781027219,1),(1545,796147219,2),(1545,812476819,1),(1545,828201620,2),(1545,844531220,1),(1545,859651220,2),(1545,875980821,1),(1545,891100821,2),(1545,907430421,1),(1545,922550422,2),(1545,938880022,1),(1545,954000022,2),(1545,967305622,1),(1545,985449622,2),(1545,1002384022,1),(1545,1017504022,2),(1545,1033833622,1),(1545,1048953622,2),(1545,1065283222,1),(1545,1080403222,2),(1545,1096732822,1),(1545,1111852822,2),(1545,1128182422,1),(1545,1143907223,2),(1545,1159632023,1),(1545,1174752023,2),(1545,1191686423,1),(1545,1207411223,2),(1545,1223136023,1),(1545,1238860824,2),(1545,1254585624,1),(1545,1270310424,2),(1545,1286035224,1),(1545,1301760024,2),(1545,1317484824,1),(1545,1333209624,2),(1545,1349539225,1),(1545,1365264025,2),(1545,1380988825,1),(1545,1396713625,2),(1545,1412438425,1),(1545,1428163225,2),(1545,1443888026,1),(1545,1459612826,2),(1545,1475337626,1),(1545,1491062427,2),(1545,1506787227,1),(1545,1522512027,2),(1545,1538841627,1),(1545,1554566427,2),(1545,1570291227,1),(1545,1586016027,2),(1545,1601740827,1),(1545,1617465627,2),(1545,1633190427,1),(1545,1648915227,2),(1545,1664640027,1),(1545,1680364827,2),(1545,1696089627,1),(1545,1712419227,2),(1545,1728144027,1),(1545,1743868827,2),(1545,1759593627,1),(1545,1775318427,2),(1545,1791043227,1),(1545,1806768027,2),(1545,1822492827,1),(1545,1838217627,2),(1545,1853942427,1),(1545,1869667227,2),(1545,1885996827,1),(1545,1901721627,2),(1545,1917446427,1),(1545,1933171227,2),(1545,1948896027,1),(1545,1964620827,2),(1545,1980345627,1),(1545,1996070427,2),(1545,2011795227,1),(1545,2027520027,2),(1545,2043244827,1),(1545,2058969627,2),(1545,2075299227,1),(1545,2091024027,2),(1545,2106748827,1),(1545,2122473627,2),(1545,2138198427,1),(1546,-2147483648,3),(1546,-1672558200,1),(1546,-1665387000,2),(1546,-883639800,1),(1546,-876123000,2),(1546,-860398200,1),(1546,-844673400,2),(1546,-828343800,1),(1546,-813223800,2),(1547,-2147483648,3),(1547,-1672555500,1),(1547,-1665384300,2),(1547,-883637100,1),(1547,-876120300,2),(1547,-860395500,1),(1547,-844670700,2),(1547,-836469900,3),(1547,152039703,1),(1547,162926104,2),(1547,436295712,1),(1547,447182112,2),(1547,690311716,1),(1547,699383716,2),(1547,1165079723,1),(1547,1174756523,2),(1547,1193505323,1),(1547,1206810923,2),(1547,1224954923,1),(1547,1238260524,2),(1548,-2147483648,3),(1548,-1680508800,1),(1548,-1665388800,2),(1548,-1646640000,1),(1548,-1635753600,2),(1548,-1615190400,1),(1548,-1604304000,2),(1548,-1583920800,3),(1548,-883641600,1),(1548,-876124800,2),(1548,-860400000,1),(1548,-844675200,2),(1548,-828345600,1),(1548,-813225600,2),(1548,-94730400,3),(1548,-71136000,1),(1548,-55411200,2),(1548,-37267200,1),(1548,-25776000,2),(1548,-5817600,1),(1548,5673600,2),(1548,25632000,1),(1548,37728000,2),(1548,57686400,1),(1548,67968000,2),(1548,89136001,1),(1548,100022402,2),(1548,120585602,1),(1548,131472003,2),(1548,152035203,1),(1548,162921604,2),(1548,183484804,1),(1548,194976005,2),(1548,215539205,1),(1548,226425606,2),(1548,246988806,1),(1548,257875207,2),(1548,278438407,1),(1548,289324808,2),(1548,309888008,1),(1548,320774409,2),(1548,341337609,1),(1548,352224009,2),(1548,372787210,1),(1548,386092810,2),(1548,404841611,1),(1548,417542411,2),(1548,436291212,1),(1548,447177612,2),(1548,467740812,1),(1548,478627212,2),(1548,499190413,1),(1548,510076813,2),(1548,530035213,1),(1548,542736013,2),(1548,562089613,1),(1548,574790414,2),(1548,594144014,1),(1548,606240014,2),(1548,625593614,1),(1548,637689615,2),(1548,657043215,1),(1548,670348816,2),(1548,686678416,1),(1548,701798416,2),(1548,718128017,1),(1548,733248017,2),(1548,749577618,1),(1548,764697618,2),(1548,781027219,1),(1548,796147219,2),(1548,812476819,1),(1548,828201620,2),(1548,844531220,1),(1548,859651220,2),(1548,875980821,1),(1548,891100821,2),(1548,907430421,1),(1548,922550422,2),(1548,938880022,1),(1548,954000022,2),(1548,967305622,1),(1548,985449622,2),(1548,1002384022,1),(1548,1017504022,2),(1548,1033833622,1),(1548,1048953622,2),(1548,1065283222,1),(1548,1080403222,2),(1548,1096732822,1),(1548,1111852822,2),(1548,1128182422,1),(1548,1143907223,2),(1548,1159632023,1),(1548,1174752023,2),(1548,1191686423,1),(1548,1207411223,2),(1548,1223136023,1),(1548,1238860824,2),(1548,1254585624,1),(1548,1270310424,2),(1548,1286035224,1),(1548,1301760024,2),(1548,1317484824,1),(1548,1333209624,2),(1548,1349539225,1),(1548,1365264025,2),(1548,1380988825,1),(1548,1396713625,2),(1548,1412438425,1),(1548,1428163225,2),(1548,1443888026,1),(1548,1459612826,2),(1548,1475337626,1),(1548,1491062427,2),(1548,1506787227,1),(1548,1522512027,2),(1548,1538841627,1),(1548,1554566427,2),(1548,1570291227,1),(1548,1586016027,2),(1548,1601740827,1),(1548,1617465627,2),(1548,1633190427,1),(1548,1648915227,2),(1548,1664640027,1),(1548,1680364827,2),(1548,1696089627,1),(1548,1712419227,2),(1548,1728144027,1),(1548,1743868827,2),(1548,1759593627,1),(1548,1775318427,2),(1548,1791043227,1),(1548,1806768027,2),(1548,1822492827,1),(1548,1838217627,2),(1548,1853942427,1),(1548,1869667227,2),(1548,1885996827,1),(1548,1901721627,2),(1548,1917446427,1),(1548,1933171227,2),(1548,1948896027,1),(1548,1964620827,2),(1548,1980345627,1),(1548,1996070427,2),(1548,2011795227,1),(1548,2027520027,2),(1548,2043244827,1),(1548,2058969627,2),(1548,2075299227,1),(1548,2091024027,2),(1548,2106748827,1),(1548,2122473627,2),(1548,2138198427,1),(1549,-2147483648,1),(1549,352216809,3),(1549,372785410,2),(1549,384273010,3),(1549,404839811,2),(1549,415722611,3),(1549,436289412,2),(1549,447172212,3),(1549,467739012,2),(1549,478621812,3),(1549,499188613,4),(1549,511282813,3),(1549,530033413,4),(1549,542732413,3),(1549,562087813,4),(1549,574786814,3),(1549,594142214,4),(1549,606236414,3),(1549,625591814,4),(1549,636476415,3),(1549,657041415,4),(1549,667926016,3),(1549,688491016,4),(1549,699375616,3),(1549,719940617,4),(1549,731430017,3),(1549,751995018,4),(1549,762879618,3),(1549,783444619,4),(1549,794329219,3),(1549,814894219,4),(1549,828198020,3),(1549,846343820,4),(1549,859647620,3),(1549,877793421,4),(1549,891097221,3),(1549,909243021,4),(1549,922546822,3),(1549,941297422,4),(1549,953996422,3),(1549,967303822,4),(1549,985446022,3),(1549,1004196622,4),(1549,1017500422,3),(1549,1035646222,4),(1549,1048950022,3),(1549,1067095822,4),(1549,1080399622,3),(1549,1099150222,4),(1549,1111849222,3),(1549,1130599822,4),(1549,1143903623,3),(1549,1162049423,4),(1549,1174748423,3),(1549,1193499023,4),(1549,1207407623,3),(1549,1223134223,4),(1549,1238857224,3),(1549,1254583824,4),(1549,1270306824,3),(1549,1286033424,4),(1549,1301756424,3),(1549,1317483024,4),(1549,1333206024,3),(1549,1349537425,4),(1549,1365260425,3),(1549,1380987025,4),(1549,1396710025,3),(1549,1412436625,4),(1549,1428159625,3),(1549,1443886226,4),(1549,1459609226,3),(1549,1475335826,4),(1549,1491058827,3),(1549,1506785427,4),(1549,1522508427,3),(1549,1538839827,4),(1549,1554562827,3),(1549,1570289427,4),(1549,1586012427,3),(1549,1601739027,4),(1549,1617462027,3),(1549,1633188627,4),(1549,1648911627,3),(1549,1664638227,4),(1549,1680361227,3),(1549,1696087827,4),(1549,1712415627,3),(1549,1728142227,4),(1549,1743865227,3),(1549,1759591827,4),(1549,1775314827,3),(1549,1791041427,4),(1549,1806764427,3),(1549,1822491027,4),(1549,1838214027,3),(1549,1853940627,4),(1549,1869663627,3),(1549,1885995027,4),(1549,1901718027,3),(1549,1917444627,4),(1549,1933167627,3),(1549,1948894227,4),(1549,1964617227,3),(1549,1980343827,4),(1549,1996066827,3),(1549,2011793427,4),(1549,2027516427,3),(1549,2043243027,4),(1549,2058966027,3),(1549,2075297427,4),(1549,2091020427,3),(1549,2106747027,4),(1549,2122470027,3),(1549,2138196627,4),(1550,-2147483648,3),(1550,-1672560000,1),(1550,-1665388800,2),(1550,-883641600,1),(1550,-876124800,2),(1550,-860400000,1),(1550,-844675200,2),(1550,-828345600,1),(1550,-813225600,2),(1550,31500000,3),(1550,57686400,1),(1550,67968000,2),(1550,625593614,1),(1550,636480015,2),(1550,657043215,1),(1550,667929616,2),(1550,688492816,1),(1550,699379216,2),(1550,709912816,3),(1550,719942417,1),(1550,731433617,2),(1550,751996818,1),(1550,762883218,2),(1551,-2147483648,1),(1551,352216809,3),(1551,372785410,2),(1551,384273010,3),(1551,404839811,2),(1551,415722611,3),(1551,436289412,2),(1551,447172212,3),(1551,467739012,2),(1551,478621812,3),(1551,499188613,4),(1551,511282813,3),(1551,530033413,4),(1551,542732413,3),(1551,562087813,4),(1551,574786814,3),(1551,594142214,4),(1551,606236414,3),(1551,625591814,4),(1551,636476415,3),(1551,657041415,4),(1551,667926016,3),(1551,688491016,4),(1551,699375616,3),(1551,719940617,4),(1551,731430017,3),(1551,751995018,4),(1551,762879618,3),(1551,783444619,4),(1551,794329219,3),(1551,814894219,4),(1551,828198020,3),(1551,846343820,4),(1551,859647620,3),(1551,877793421,4),(1551,891097221,3),(1551,909243021,4),(1551,922546822,3),(1551,941297422,4),(1551,953996422,3),(1551,967303822,4),(1551,985446022,3),(1551,1004196622,4),(1551,1017500422,3),(1551,1035646222,4),(1551,1048950022,3),(1551,1067095822,4),(1551,1080399622,3),(1551,1099150222,4),(1551,1111849222,3),(1551,1130599822,4),(1551,1143903623,3),(1551,1162049423,4),(1551,1174748423,3),(1551,1193499023,4),(1551,1207407623,3),(1551,1223134223,4),(1551,1238857224,3),(1551,1254583824,4),(1551,1270306824,3),(1551,1286033424,4),(1551,1301756424,3),(1551,1317483024,4),(1551,1333206024,3),(1551,1349537425,4),(1551,1365260425,3),(1551,1380987025,4),(1551,1396710025,3),(1551,1412436625,4),(1551,1428159625,3),(1551,1443886226,4),(1551,1459609226,3),(1551,1475335826,4),(1551,1491058827,3),(1551,1506785427,4),(1551,1522508427,3),(1551,1538839827,4),(1551,1554562827,3),(1551,1570289427,4),(1551,1586012427,3),(1551,1601739027,4),(1551,1617462027,3),(1551,1633188627,4),(1551,1648911627,3),(1551,1664638227,4),(1551,1680361227,3),(1551,1696087827,4),(1551,1712415627,3),(1551,1728142227,4),(1551,1743865227,3),(1551,1759591827,4),(1551,1775314827,3),(1551,1791041427,4),(1551,1806764427,3),(1551,1822491027,4),(1551,1838214027,3),(1551,1853940627,4),(1551,1869663627,3),(1551,1885995027,4),(1551,1901718027,3),(1551,1917444627,4),(1551,1933167627,3),(1551,1948894227,4),(1551,1964617227,3),(1551,1980343827,4),(1551,1996066827,3),(1551,2011793427,4),(1551,2027516427,3),(1551,2043243027,4),(1551,2058966027,3),(1551,2075297427,4),(1551,2091020427,3),(1551,2106747027,4),(1551,2122470027,3),(1551,2138196627,4),(1552,-2147483648,3),(1552,-1672560000,1),(1552,-1665388800,2),(1552,-883641600,1),(1552,-876124800,2),(1552,-860400000,1),(1552,-844675200,2),(1552,-828345600,1),(1552,-813225600,2),(1552,31500000,3),(1552,57686400,1),(1552,67968000,2),(1552,89136001,1),(1552,100022402,2),(1552,120585602,1),(1552,131472003,2),(1552,152035203,1),(1552,162921604,2),(1552,183484804,1),(1552,194976005,2),(1552,215539205,1),(1552,226425606,2),(1552,246988806,1),(1552,257875207,2),(1552,278438407,1),(1552,289324808,2),(1552,309888008,1),(1552,320774409,2),(1552,341337609,1),(1552,352224009,2),(1552,372787210,1),(1552,384278410,2),(1552,404841611,1),(1552,415728011,2),(1552,436291212,1),(1552,447177612,2),(1552,467740812,1),(1552,478627212,2),(1552,499190413,1),(1552,511286413,2),(1552,530035213,1),(1552,542736013,2),(1552,561484813,1),(1552,574790414,2),(1552,594144014,1),(1552,606240014,2),(1552,625593614,1),(1552,637689615,2),(1552,657043215,1),(1552,667929616,2),(1552,688492816,1),(1552,699379216,2),(1552,719942417,1),(1552,731433617,2),(1552,751996818,1),(1552,762883218,2),(1552,783446419,1),(1552,796147219,2),(1552,814896019,1),(1552,828201620,2),(1552,846345620,1),(1552,859651220,2),(1552,877795221,1),(1552,891100821,2),(1552,909244821,1),(1552,922550422,2),(1552,941299222,1),(1552,954000022,2),(1552,967305622,1),(1552,985449622,2),(1552,1004198422,1),(1552,1017504022,2),(1552,1035648022,1),(1552,1048953622,2),(1552,1067097622,1),(1552,1080403222,2),(1552,1099152022,1),(1552,1111852822,2),(1552,1130601622,1),(1552,1143907223,2),(1552,1162051223,1),(1552,1174752023,2),(1552,1193500823,1),(1552,1207411223,2),(1552,1223136023,1),(1552,1238860824,2),(1552,1254585624,1),(1552,1270310424,2),(1552,1286035224,1),(1552,1301760024,2),(1552,1317484824,1),(1552,1333209624,2),(1552,1349539225,1),(1552,1365264025,2),(1552,1380988825,1),(1552,1396713625,2),(1552,1412438425,1),(1552,1428163225,2),(1552,1443888026,1),(1552,1459612826,2),(1552,1475337626,1),(1552,1491062427,2),(1552,1506787227,1),(1552,1522512027,2),(1552,1538841627,1),(1552,1554566427,2),(1552,1570291227,1),(1552,1586016027,2),(1552,1601740827,1),(1552,1617465627,2),(1552,1633190427,1),(1552,1648915227,2),(1552,1664640027,1),(1552,1680364827,2),(1552,1696089627,1),(1552,1712419227,2),(1552,1728144027,1),(1552,1743868827,2),(1552,1759593627,1),(1552,1775318427,2),(1552,1791043227,1),(1552,1806768027,2),(1552,1822492827,1),(1552,1838217627,2),(1552,1853942427,1),(1552,1869667227,2),(1552,1885996827,1),(1552,1901721627,2),(1552,1917446427,1),(1552,1933171227,2),(1552,1948896027,1),(1552,1964620827,2),(1552,1980345627,1),(1552,1996070427,2),(1552,2011795227,1),(1552,2027520027,2),(1552,2043244827,1),(1552,2058969627,2),(1552,2075299227,1),(1552,2091024027,2),(1552,2106748827,1),(1552,2122473627,2),(1552,2138198427,1),(1553,-2147483648,3),(1553,-1672560000,1),(1553,-1665388800,2),(1553,-883641600,1),(1553,-876124800,2),(1553,-860400000,1),(1553,-844675200,2),(1553,-828345600,1),(1553,-813225600,2),(1553,31500000,3),(1553,57686400,1),(1553,67968000,2),(1553,89136001,1),(1553,100022402,2),(1553,120585602,1),(1553,131472003,2),(1553,152035203,1),(1553,162921604,2),(1553,183484804,1),(1553,194976005,2),(1553,215539205,1),(1553,226425606,2),(1553,246988806,1),(1553,257875207,2),(1553,278438407,1),(1553,289324808,2),(1553,309888008,1),(1553,320774409,2),(1553,341337609,1),(1553,352224009,2),(1553,372787210,1),(1553,386697610,2),(1553,404841611,1),(1553,415728011,2),(1553,436291212,1),(1553,447177612,2),(1553,467740812,1),(1553,478627212,2),(1553,499190413,1),(1553,511286413,2),(1553,530035213,1),(1553,542736013,2),(1553,562089613,1),(1553,574790414,2),(1553,594144014,1),(1553,606240014,2),(1553,625593614,1),(1553,636480015,2),(1553,657043215,1),(1553,667929616,2),(1553,688492816,1),(1553,699379216,2),(1553,719942417,1),(1553,731433617,2),(1553,751996818,1),(1553,762883218,2),(1553,783446419,1),(1553,794332819,2),(1553,814896019,1),(1553,828201620,2),(1553,846345620,1),(1553,859651220,2),(1553,877795221,1),(1553,891100821,2),(1553,909244821,1),(1553,922550422,2),(1553,941299222,1),(1553,954000022,2),(1553,967305622,1),(1553,985449622,2),(1553,1004198422,1),(1553,1017504022,2),(1553,1035648022,1),(1553,1048953622,2),(1553,1067097622,1),(1553,1080403222,2),(1553,1099152022,1),(1553,1111852822,2),(1553,1130601622,1),(1553,1143907223,2),(1553,1162051223,1),(1553,1174752023,2),(1553,1193500823,1),(1553,1207411223,2),(1553,1223136023,1),(1553,1238860824,2),(1553,1254585624,1),(1553,1270310424,2),(1553,1286035224,1),(1553,1301760024,2),(1553,1317484824,1),(1553,1333209624,2),(1553,1349539225,1),(1553,1365264025,2),(1553,1380988825,1),(1553,1396713625,2),(1553,1412438425,1),(1553,1428163225,2),(1553,1443888026,1),(1553,1459612826,2),(1553,1475337626,1),(1553,1491062427,2),(1553,1506787227,1),(1553,1522512027,2),(1553,1538841627,1),(1553,1554566427,2),(1553,1570291227,1),(1553,1586016027,2),(1553,1601740827,1),(1553,1617465627,2),(1553,1633190427,1),(1553,1648915227,2),(1553,1664640027,1),(1553,1680364827,2),(1553,1696089627,1),(1553,1712419227,2),(1553,1728144027,1),(1553,1743868827,2),(1553,1759593627,1),(1553,1775318427,2),(1553,1791043227,1),(1553,1806768027,2),(1553,1822492827,1),(1553,1838217627,2),(1553,1853942427,1),(1553,1869667227,2),(1553,1885996827,1),(1553,1901721627,2),(1553,1917446427,1),(1553,1933171227,2),(1553,1948896027,1),(1553,1964620827,2),(1553,1980345627,1),(1553,1996070427,2),(1553,2011795227,1),(1553,2027520027,2),(1553,2043244827,1),(1553,2058969627,2),(1553,2075299227,1),(1553,2091024027,2),(1553,2106748827,1),(1553,2122473627,2),(1553,2138198427,1),(1554,-2147483648,3),(1554,-1672558200,1),(1554,-1665387000,2),(1554,-883639800,1),(1554,-876123000,2),(1554,-860398200,1),(1554,-844673400,2),(1554,-828343800,1),(1554,-813223800,2),(1555,-2147483648,3),(1555,-1672552800,1),(1555,-1665381600,2),(1555,-883634400,1),(1555,-876117600,2),(1555,-860392800,1),(1555,-844668000,2),(1555,-836467200,3),(1555,152042403,1),(1555,162928804,2),(1555,436298412,1),(1555,447184812,2),(1555,690314416,1),(1555,699386416,2),(1555,1165082423,1),(1555,1174759223,2),(1555,1193508023,1),(1555,1206813623,2),(1555,1224957623,1),(1555,1238263224,2),(1556,-2147483648,3),(1556,-1672560000,1),(1556,-1665388800,2),(1556,-883641600,1),(1556,-876124800,2),(1556,-860400000,1),(1556,-844675200,2),(1556,-828345600,1),(1556,-813225600,2),(1556,31500000,3),(1556,57686400,1),(1556,67968000,2),(1556,625593614,1),(1556,636480015,2),(1556,657043215,1),(1556,667929616,2),(1556,688492816,1),(1556,699379216,2),(1557,-2147483648,3),(1557,-1672558200,1),(1557,-1665387000,2),(1557,-883639800,1),(1557,-876123000,2),(1557,-860398200,1),(1557,-844673400,2),(1557,-828343800,1),(1557,-813223800,2),(1557,31501800,3),(1557,57688200,1),(1557,67969800,2),(1557,89137801,1),(1557,100024202,2),(1557,120587402,1),(1557,131473803,2),(1557,152037003,1),(1557,162923404,2),(1557,183486604,1),(1557,194977805,2),(1557,215541005,1),(1557,226427406,2),(1557,246990606,1),(1557,257877007,2),(1557,278440207,1),(1557,289326608,2),(1557,309889808,1),(1557,320776209,2),(1557,341339409,1),(1557,352225809,2),(1557,372789010,1),(1557,384280210,2),(1557,404843411,1),(1557,415729811,2),(1557,436293012,1),(1557,447179412,2),(1557,467742612,1),(1557,478629012,2),(1557,499192213,1),(1557,511288213,2),(1557,530037013,1),(1557,542737813,2),(1557,562091413,1),(1557,574792214,2),(1557,594145814,1),(1557,606241814,2),(1557,625595414,1),(1557,637691415,2),(1557,657045015,1),(1557,667931416,2),(1557,688494616,1),(1557,701195416,2),(1557,719944217,1),(1557,731435417,2),(1557,751998618,1),(1557,764094618,2),(1557,783448219,1),(1557,796149019,2),(1557,814897819,1),(1557,828203420,2),(1557,846347420,1),(1557,859653020,2),(1557,877797021,1),(1557,891102621,2),(1557,909246621,1),(1557,922552222,2),(1557,941301022,1),(1557,954001822,2),(1557,972750622,1),(1557,985451422,2),(1557,1004200222,1),(1557,1017505822,2),(1557,1035649822,1),(1557,1048955422,2),(1557,1067099422,1),(1557,1080405022,2),(1557,1099153822,1),(1557,1111854622,2),(1557,1130603422,1),(1557,1143909023,2),(1557,1162053023,1),(1557,1174753823,2),(1557,1193502623,1),(1557,1207413023,2),(1557,1223137823,1),(1557,1238862624,2),(1557,1254587424,1),(1557,1270312224,2),(1557,1286037024,1),(1557,1301761824,2),(1557,1317486624,1),(1557,1333211424,2),(1557,1349541025,1),(1557,1365265825,2),(1557,1380990625,1),(1557,1396715425,2),(1557,1412440225,1),(1557,1428165025,2),(1557,1443889826,1),(1557,1459614626,2),(1557,1475339426,1),(1557,1491064227,2),(1557,1506789027,1),(1557,1522513827,2),(1557,1538843427,1),(1557,1554568227,2),(1557,1570293027,1),(1557,1586017827,2),(1557,1601742627,1),(1557,1617467427,2),(1557,1633192227,1),(1557,1648917027,2),(1557,1664641827,1),(1557,1680366627,2),(1557,1696091427,1),(1557,1712421027,2),(1557,1728145827,1),(1557,1743870627,2),(1557,1759595427,1),(1557,1775320227,2),(1557,1791045027,1),(1557,1806769827,2),(1557,1822494627,1),(1557,1838219427,2),(1557,1853944227,1),(1557,1869669027,2),(1557,1885998627,1),(1557,1901723427,2),(1557,1917448227,1),(1557,1933173027,2),(1557,1948897827,1),(1557,1964622627,2),(1557,1980347427,1),(1557,1996072227,2),(1557,2011797027,1),(1557,2027521827,2),(1557,2043246627,1),(1557,2058971427,2),(1557,2075301027,1),(1557,2091025827,2),(1557,2106750627,1),(1557,2122475427,2),(1557,2138200227,1),(1558,-2147483648,3),(1558,-1672560000,1),(1558,-1665388800,2),(1558,-883641600,1),(1558,-876124800,2),(1558,-860400000,1),(1558,-844675200,2),(1558,-828345600,1),(1558,-813225600,2),(1558,31500000,3),(1558,57686400,1),(1558,67968000,2),(1558,89136001,1),(1558,100022402,2),(1558,120585602,1),(1558,131472003,2),(1558,152035203,1),(1558,162921604,2),(1558,183484804,1),(1558,194976005,2),(1558,215539205,1),(1558,226425606,2),(1558,246988806,1),(1558,257875207,2),(1558,278438407,1),(1558,289324808,2),(1558,309888008,1),(1558,320774409,2),(1558,341337609,1),(1558,352224009,2),(1558,372787210,1),(1558,386697610,2),(1558,404841611,1),(1558,415728011,2),(1558,436291212,1),(1558,447177612,2),(1558,467740812,1),(1558,478627212,2),(1558,499190413,1),(1558,511286413,2),(1558,530035213,1),(1558,542736013,2),(1558,562089613,1),(1558,574790414,2),(1558,594144014,1),(1558,606240014,2),(1558,625593614,1),(1558,636480015,2),(1558,657043215,1),(1558,667929616,2),(1558,688492816,1),(1558,699379216,2),(1558,719942417,1),(1558,731433617,2),(1558,751996818,1),(1558,762883218,2),(1558,783446419,1),(1558,794332819,2),(1558,814896019,1),(1558,828201620,2),(1558,846345620,1),(1558,859651220,2),(1558,877795221,1),(1558,891100821,2),(1558,909244821,1),(1558,922550422,2),(1558,941299222,1),(1558,954000022,2),(1558,967305622,1),(1558,985449622,2),(1558,1004198422,1),(1558,1017504022,2),(1558,1035648022,1),(1558,1048953622,2),(1558,1067097622,1),(1558,1080403222,2),(1558,1099152022,1),(1558,1111852822,2),(1558,1130601622,1),(1558,1143907223,2),(1558,1162051223,1),(1558,1174752023,2),(1558,1193500823,1),(1558,1207411223,2),(1558,1223136023,1),(1558,1238860824,2),(1558,1254585624,1),(1558,1270310424,2),(1558,1286035224,1),(1558,1301760024,2),(1558,1317484824,1),(1558,1333209624,2),(1558,1349539225,1),(1558,1365264025,2),(1558,1380988825,1),(1558,1396713625,2),(1558,1412438425,1),(1558,1428163225,2),(1558,1443888026,1),(1558,1459612826,2),(1558,1475337626,1),(1558,1491062427,2),(1558,1506787227,1),(1558,1522512027,2),(1558,1538841627,1),(1558,1554566427,2),(1558,1570291227,1),(1558,1586016027,2),(1558,1601740827,1),(1558,1617465627,2),(1558,1633190427,1),(1558,1648915227,2),(1558,1664640027,1),(1558,1680364827,2),(1558,1696089627,1),(1558,1712419227,2),(1558,1728144027,1),(1558,1743868827,2),(1558,1759593627,1),(1558,1775318427,2),(1558,1791043227,1),(1558,1806768027,2),(1558,1822492827,1),(1558,1838217627,2),(1558,1853942427,1),(1558,1869667227,2),(1558,1885996827,1),(1558,1901721627,2),(1558,1917446427,1),(1558,1933171227,2),(1558,1948896027,1),(1558,1964620827,2),(1558,1980345627,1),(1558,1996070427,2),(1558,2011795227,1),(1558,2027520027,2),(1558,2043244827,1),(1558,2058969627,2),(1558,2075299227,1),(1558,2091024027,2),(1558,2106748827,1),(1558,2122473627,2),(1558,2138198427,1),(1559,-2147483648,3),(1559,-1680508800,1),(1559,-1665388800,2),(1559,-1646640000,1),(1559,-1635753600,2),(1559,-1615190400,1),(1559,-1604304000,2),(1559,-1583920800,3),(1559,-883641600,1),(1559,-876124800,2),(1559,-860400000,1),(1559,-844675200,2),(1559,-828345600,1),(1559,-813225600,2),(1559,-94730400,3),(1559,-71136000,1),(1559,-55411200,2),(1559,-37267200,1),(1559,-25776000,2),(1559,-5817600,1),(1559,5673600,2),(1559,25632000,1),(1559,37728000,2),(1559,57686400,1),(1559,67968000,2),(1559,89136001,1),(1559,100022402,2),(1559,120585602,1),(1559,131472003,2),(1559,152035203,1),(1559,162921604,2),(1559,183484804,1),(1559,194976005,2),(1559,215539205,1),(1559,226425606,2),(1559,246988806,1),(1559,257875207,2),(1559,278438407,1),(1559,289324808,2),(1559,309888008,1),(1559,320774409,2),(1559,341337609,1),(1559,352224009,2),(1559,372787210,1),(1559,386092810,2),(1559,404841611,1),(1559,417542411,2),(1559,436291212,1),(1559,447177612,2),(1559,467740812,1),(1559,478627212,2),(1559,499190413,1),(1559,510076813,2),(1559,530035213,1),(1559,542736013,2),(1559,562089613,1),(1559,574790414,2),(1559,594144014,1),(1559,606240014,2),(1559,625593614,1),(1559,637689615,2),(1559,657043215,1),(1559,670348816,2),(1559,686678416,1),(1559,701798416,2),(1559,718128017,1),(1559,733248017,2),(1559,749577618,1),(1559,764697618,2),(1559,781027219,1),(1559,796147219,2),(1559,812476819,1),(1559,828201620,2),(1559,844531220,1),(1559,859651220,2),(1559,875980821,1),(1559,891100821,2),(1559,907430421,1),(1559,922550422,2),(1559,938880022,1),(1559,954000022,2),(1559,967305622,1),(1559,985449622,2),(1559,1002384022,1),(1559,1017504022,2),(1559,1033833622,1),(1559,1048953622,2),(1559,1065283222,1),(1559,1080403222,2),(1559,1096732822,1),(1559,1111852822,2),(1559,1128182422,1),(1559,1143907223,2),(1559,1159632023,1),(1559,1174752023,2),(1559,1191686423,1),(1559,1207411223,2),(1559,1223136023,1),(1559,1238860824,2),(1559,1254585624,1),(1559,1270310424,2),(1559,1286035224,1),(1559,1301760024,2),(1559,1317484824,1),(1559,1333209624,2),(1559,1349539225,1),(1559,1365264025,2),(1559,1380988825,1),(1559,1396713625,2),(1559,1412438425,1),(1559,1428163225,2),(1559,1443888026,1),(1559,1459612826,2),(1559,1475337626,1),(1559,1491062427,2),(1559,1506787227,1),(1559,1522512027,2),(1559,1538841627,1),(1559,1554566427,2),(1559,1570291227,1),(1559,1586016027,2),(1559,1601740827,1),(1559,1617465627,2),(1559,1633190427,1),(1559,1648915227,2),(1559,1664640027,1),(1559,1680364827,2),(1559,1696089627,1),(1559,1712419227,2),(1559,1728144027,1),(1559,1743868827,2),(1559,1759593627,1),(1559,1775318427,2),(1559,1791043227,1),(1559,1806768027,2),(1559,1822492827,1),(1559,1838217627,2),(1559,1853942427,1),(1559,1869667227,2),(1559,1885996827,1),(1559,1901721627,2),(1559,1917446427,1),(1559,1933171227,2),(1559,1948896027,1),(1559,1964620827,2),(1559,1980345627,1),(1559,1996070427,2),(1559,2011795227,1),(1559,2027520027,2),(1559,2043244827,1),(1559,2058969627,2),(1559,2075299227,1),(1559,2091024027,2),(1559,2106748827,1),(1559,2122473627,2),(1559,2138198427,1),(1560,-2147483648,3),(1560,-1672560000,1),(1560,-1665388800,2),(1560,-883641600,1),(1560,-876124800,2),(1560,-860400000,1),(1560,-844675200,2),(1560,-828345600,1),(1560,-813225600,2),(1560,31500000,3),(1560,57686400,1),(1560,67968000,2),(1560,89136001,1),(1560,100022402,2),(1560,120585602,1),(1560,131472003,2),(1560,152035203,1),(1560,162921604,2),(1560,183484804,1),(1560,194976005,2),(1560,215539205,1),(1560,226425606,2);
INSERT INTO `time_zone_transition` VALUES (1560,246988806,1),(1560,257875207,2),(1560,278438407,1),(1560,289324808,2),(1560,309888008,1),(1560,320774409,2),(1560,341337609,1),(1560,352224009,2),(1560,372787210,1),(1560,384278410,2),(1560,404841611,1),(1560,415728011,2),(1560,436291212,1),(1560,447177612,2),(1560,467740812,1),(1560,478627212,2),(1560,499190413,1),(1560,511286413,2),(1560,530035213,1),(1560,542736013,2),(1560,561484813,1),(1560,574790414,2),(1560,594144014,1),(1560,606240014,2),(1560,625593614,1),(1560,637689615,2),(1560,657043215,1),(1560,667929616,2),(1560,688492816,1),(1560,699379216,2),(1560,719942417,1),(1560,731433617,2),(1560,751996818,1),(1560,762883218,2),(1560,783446419,1),(1560,796147219,2),(1560,814896019,1),(1560,828201620,2),(1560,846345620,1),(1560,859651220,2),(1560,877795221,1),(1560,891100821,2),(1560,909244821,1),(1560,922550422,2),(1560,941299222,1),(1560,954000022,2),(1560,967305622,1),(1560,985449622,2),(1560,1004198422,1),(1560,1017504022,2),(1560,1035648022,1),(1560,1048953622,2),(1560,1067097622,1),(1560,1080403222,2),(1560,1099152022,1),(1560,1111852822,2),(1560,1130601622,1),(1560,1143907223,2),(1560,1162051223,1),(1560,1174752023,2),(1560,1193500823,1),(1560,1207411223,2),(1560,1223136023,1),(1560,1238860824,2),(1560,1254585624,1),(1560,1270310424,2),(1560,1286035224,1),(1560,1301760024,2),(1560,1317484824,1),(1560,1333209624,2),(1560,1349539225,1),(1560,1365264025,2),(1560,1380988825,1),(1560,1396713625,2),(1560,1412438425,1),(1560,1428163225,2),(1560,1443888026,1),(1560,1459612826,2),(1560,1475337626,1),(1560,1491062427,2),(1560,1506787227,1),(1560,1522512027,2),(1560,1538841627,1),(1560,1554566427,2),(1560,1570291227,1),(1560,1586016027,2),(1560,1601740827,1),(1560,1617465627,2),(1560,1633190427,1),(1560,1648915227,2),(1560,1664640027,1),(1560,1680364827,2),(1560,1696089627,1),(1560,1712419227,2),(1560,1728144027,1),(1560,1743868827,2),(1560,1759593627,1),(1560,1775318427,2),(1560,1791043227,1),(1560,1806768027,2),(1560,1822492827,1),(1560,1838217627,2),(1560,1853942427,1),(1560,1869667227,2),(1560,1885996827,1),(1560,1901721627,2),(1560,1917446427,1),(1560,1933171227,2),(1560,1948896027,1),(1560,1964620827,2),(1560,1980345627,1),(1560,1996070427,2),(1560,2011795227,1),(1560,2027520027,2),(1560,2043244827,1),(1560,2058969627,2),(1560,2075299227,1),(1560,2091024027,2),(1560,2106748827,1),(1560,2122473627,2),(1560,2138198427,1),(1561,-2147483648,3),(1561,-1672552800,1),(1561,-1665381600,2),(1561,-883634400,1),(1561,-876117600,2),(1561,-860392800,1),(1561,-844668000,2),(1561,-836467200,3),(1561,152042403,1),(1561,162928804,2),(1561,436298412,1),(1561,447184812,2),(1561,690314416,1),(1561,699386416,2),(1561,1165082423,1),(1561,1174759223,2),(1561,1193508023,1),(1561,1206813623,2),(1561,1224957623,1),(1561,1238263224,2),(1562,-2147483648,3),(1562,-1672558200,1),(1562,-1665387000,2),(1562,-883639800,1),(1562,-876123000,2),(1562,-860398200,1),(1562,-844673400,2),(1562,-828343800,1),(1562,-813223800,2),(1562,31501800,3),(1562,57688200,1),(1562,67969800,2),(1562,89137801,1),(1562,100024202,2),(1562,120587402,1),(1562,131473803,2),(1562,152037003,1),(1562,162923404,2),(1562,183486604,1),(1562,194977805,2),(1562,215541005,1),(1562,226427406,2),(1562,246990606,1),(1562,257877007,2),(1562,278440207,1),(1562,289326608,2),(1562,309889808,1),(1562,320776209,2),(1562,341339409,1),(1562,352225809,2),(1562,372789010,1),(1562,386699410,2),(1562,404843411,1),(1562,415729811,2),(1562,436293012,1),(1562,447179412,2),(1562,467742612,1),(1562,478629012,2),(1562,499192213,1),(1562,511288213,2),(1562,530037013,1),(1562,542737813,2),(1562,562091413,1),(1562,574792214,2),(1562,594145814,1),(1562,606241814,2),(1562,625595414,1),(1562,636481815,2),(1562,657045015,1),(1562,667931416,2),(1562,688494616,1),(1562,699381016,2),(1562,719944217,1),(1562,731435417,2),(1562,751998618,1),(1562,762885018,2),(1562,783448219,1),(1562,794334619,2),(1562,814897819,1),(1562,828203420,2),(1562,846347420,1),(1562,859653020,2),(1562,877797021,1),(1562,891102621,2),(1562,909246621,1),(1562,922552222,2),(1562,941301022,1),(1562,946647022,4),(1562,954001822,2),(1562,972750622,1),(1562,985451422,2),(1562,1004200222,1),(1562,1017505822,2),(1562,1035649822,1),(1562,1048955422,2),(1562,1067099422,1),(1562,1080405022,2),(1562,1099153822,1),(1562,1111854622,2),(1562,1130603422,1),(1562,1143909023,2),(1562,1162053023,1),(1562,1174753823,2),(1562,1193502623,1),(1562,1207413023,2),(1562,1223137823,1),(1562,1238862624,2),(1562,1254587424,1),(1562,1270312224,2),(1562,1286037024,1),(1562,1301761824,2),(1562,1317486624,1),(1562,1333211424,2),(1562,1349541025,1),(1562,1365265825,2),(1562,1380990625,1),(1562,1396715425,2),(1562,1412440225,1),(1562,1428165025,2),(1562,1443889826,1),(1562,1459614626,2),(1562,1475339426,1),(1562,1491064227,2),(1562,1506789027,1),(1562,1522513827,2),(1562,1538843427,1),(1562,1554568227,2),(1562,1570293027,1),(1562,1586017827,2),(1562,1601742627,1),(1562,1617467427,2),(1562,1633192227,1),(1562,1648917027,2),(1562,1664641827,1),(1562,1680366627,2),(1562,1696091427,1),(1562,1712421027,2),(1562,1728145827,1),(1562,1743870627,2),(1562,1759595427,1),(1562,1775320227,2),(1562,1791045027,1),(1562,1806769827,2),(1562,1822494627,1),(1562,1838219427,2),(1562,1853944227,1),(1562,1869669027,2),(1562,1885998627,1),(1562,1901723427,2),(1562,1917448227,1),(1562,1933173027,2),(1562,1948897827,1),(1562,1964622627,2),(1562,1980347427,1),(1562,1996072227,2),(1562,2011797027,1),(1562,2027521827,2),(1562,2043246627,1),(1562,2058971427,2),(1562,2075301027,1),(1562,2091025827,2),(1562,2106750627,1),(1562,2122475427,2),(1562,2138200227,1),(1563,-2147483648,0),(1563,-1767209328,2),(1563,-1206950400,1),(1563,-1191355200,2),(1563,-1175367600,1),(1563,-1159819200,2),(1563,-633812400,1),(1563,-622062000,2),(1563,-602276400,1),(1563,-591825600,2),(1563,-570740400,1),(1563,-560203200,2),(1563,-539118000,1),(1563,-531345600,2),(1563,-191358000,1),(1563,-184190400,2),(1563,-155156400,1),(1563,-150062400,2),(1563,-128890800,1),(1563,-121118400,2),(1563,-99946800,1),(1563,-89582400,2),(1563,-68410800,1),(1563,-57960000,2),(1563,499755613,1),(1563,511243213,2),(1563,530600413,1),(1563,540273613,2),(1563,562136413,1),(1563,571204814,2),(1563,1214283623,3),(1563,1384056025,2),(1564,-2147483648,0),(1564,-1767217820,2),(1564,-1206961200,1),(1564,-1191366000,2),(1564,-1175378400,1),(1564,-1159830000,2),(1564,-633823200,1),(1564,-622072800,2),(1564,-602287200,1),(1564,-591836400,2),(1564,-570751200,1),(1564,-560214000,2),(1564,-539128800,1),(1564,-531356400,2),(1564,-191368800,1),(1564,-184201200,2),(1564,-155167200,1),(1564,-150073200,2),(1564,-128901600,1),(1564,-121129200,2),(1564,-99957600,1),(1564,-89593200,2),(1564,-68421600,1),(1564,-57970800,2),(1564,499744813,1),(1564,511232413,2),(1564,530589613,1),(1564,540262813,2),(1564,562125613,1),(1564,571194014,2),(1564,592970414,1),(1564,602038814,2),(1564,624420014,1),(1564,634698015,2),(1564,938916022,1),(1564,951613222,2),(1564,970970422,1),(1564,971571622,2),(1564,1003024822,1),(1564,1013907622,2),(1565,-2147483648,0),(1565,-1767214412,2),(1565,-1206957600,1),(1565,-1191362400,2),(1565,-1175374800,1),(1565,-1159826400,2),(1565,-633819600,1),(1565,-622069200,2),(1565,-602283600,1),(1565,-591832800,2),(1565,-570747600,1),(1565,-560210400,2),(1565,-539125200,1),(1565,-531352800,2),(1565,-195426000,1),(1565,-184197600,2),(1565,-155163600,1),(1565,-150069600,2),(1565,-128898000,1),(1565,-121125600,2),(1565,-99954000,1),(1565,-89589600,2),(1565,-68418000,1),(1565,-57967200,2),(1565,499748413,1),(1565,511236013,2),(1565,530593213,1),(1565,540266413,2),(1565,562129213,1),(1565,571197614,2),(1565,592974014,1),(1565,602042414,2),(1565,624423614,1),(1565,634701615,2),(1565,656478015,1),(1565,666756016,2),(1565,687927616,1),(1565,697600816,2),(1565,719982017,1),(1565,728445617,2),(1565,750826818,1),(1565,761709618,2),(1565,782276419,1),(1565,793159219,2),(1565,813726019,1),(1565,824004020,2),(1565,844570820,1),(1565,856058420,2),(1565,876106821,1),(1565,888717621,2),(1565,908074821,1),(1565,919562422,2),(1565,938919622,1),(1565,951616822,2),(1565,970974022,1),(1565,982461622,2),(1565,1003028422,1),(1565,1013911222,2),(1565,1036292422,1),(1565,1045360822,2),(1565,1066532422,1),(1565,1076810422,2),(1565,1099364422,1),(1565,1108864822,2),(1565,1129431622,1),(1565,1140314423,2),(1565,1162695623,1),(1565,1172368823,2),(1565,1192330823,1),(1565,1203213623,2),(1565,1224385223,1),(1565,1234663224,2),(1565,1255834824,1),(1565,1266717624,2),(1565,1287284424,1),(1565,1298167224,2),(1565,1318734024,1),(1565,1330221624,2),(1565,1350788425,1),(1565,1361066425,2),(1565,1382238025,1),(1565,1392516025,2),(1565,1413687625,1),(1565,1424570425,2),(1565,1445137226,1),(1565,1456020026,2),(1565,1476586826,1),(1565,1487469627,2),(1565,1508036427,1),(1565,1518919227,2),(1565,1541300427,1),(1565,1550368827,2),(1566,-2147483648,0),(1566,-1767211196,2),(1566,-1206954000,1),(1566,-1191358800,2),(1566,-1175371200,1),(1566,-1159822800,2),(1566,-633816000,1),(1566,-622065600,2),(1566,-602280000,1),(1566,-591829200,2),(1566,-570744000,1),(1566,-560206800,2),(1566,-539121600,1),(1566,-531349200,2),(1566,-191361600,1),(1566,-184194000,2),(1566,-155160000,1),(1566,-150066000,2),(1566,-128894400,1),(1566,-121122000,2),(1566,-99950400,1),(1566,-89586000,2),(1566,-68414400,1),(1566,-57963600,2),(1566,499752013,1),(1566,511239613,2),(1566,530596813,1),(1566,540270013,2),(1566,562132813,1),(1566,571201214,2),(1566,750830418,1),(1566,761713218,2),(1567,-1693706400,0),(1567,-1680483600,1),(1567,-1663455600,2),(1567,-1650150000,3),(1567,-1632006000,2),(1567,-1618700400,3),(1567,-938905200,2),(1567,-857257200,3),(1567,-844556400,2),(1567,-828226800,3),(1567,-812502000,2),(1567,-796777200,3),(1567,-781052400,2),(1567,-766623600,3),(1567,228877206,2),(1567,243997206,3),(1567,260326807,2),(1567,276051607,3),(1567,291776408,2),(1567,307501208,3),(1567,323830809,2),(1567,338950809,3),(1567,354675609,2),(1567,370400410,3),(1567,386125210,2),(1567,401850011,3),(1567,417574811,2),(1567,433299612,3),(1567,449024412,2),(1567,465354012,3),(1567,481078812,2),(1567,496803613,3),(1567,512528413,2),(1567,528253213,3),(1567,543978013,2),(1567,559702813,3),(1567,575427614,2),(1567,591152414,3),(1567,606877214,2),(1567,622602014,3),(1567,638326815,2),(1567,654656415,3),(1567,670381216,2),(1567,686106016,3),(1567,701830816,2),(1567,717555617,3),(1567,733280417,2),(1567,749005218,3),(1567,764730018,2),(1567,780454819,3),(1567,796179619,2),(1567,811904419,3),(1567,828234020,2),(1567,846378020,3),(1567,859683620,2),(1567,877827621,3),(1567,891133221,2),(1567,909277221,3),(1567,922582822,2),(1567,941331622,3),(1567,954032422,2),(1567,972781222,3),(1567,985482022,2),(1567,1004230822,3),(1567,1017536422,2),(1567,1035680422,3),(1567,1048986022,2),(1567,1067130022,3),(1567,1080435622,2),(1567,1099184422,3),(1567,1111885222,2),(1567,1130634022,3),(1567,1143334823,2),(1567,1162083623,3),(1567,1174784423,2),(1567,1193533223,3),(1567,1206838823,2),(1567,1224982823,3),(1567,1238288424,2),(1567,1256432424,3),(1567,1269738024,2),(1567,1288486824,3),(1567,1301187624,2),(1567,1319936424,3),(1567,1332637224,2),(1567,1351386025,3),(1567,1364691625,2),(1567,1382835625,3),(1567,1396141225,2),(1567,1414285225,3),(1567,1427590825,2),(1567,1445734826,3),(1567,1459040426,2),(1567,1477789226,3),(1567,1490490027,2),(1567,1509238827,3),(1567,1521939627,2),(1567,1540688427,3),(1567,1553994027,2),(1567,1572138027,3),(1567,1585443627,2),(1567,1603587627,3),(1567,1616893227,2),(1567,1635642027,3),(1567,1648342827,2),(1567,1667091627,3),(1567,1679792427,2),(1567,1698541227,3),(1567,1711846827,2),(1567,1729990827,3),(1567,1743296427,2),(1567,1761440427,3),(1567,1774746027,2),(1567,1792890027,3),(1567,1806195627,2),(1567,1824944427,3),(1567,1837645227,2),(1567,1856394027,3),(1567,1869094827,2),(1567,1887843627,3),(1567,1901149227,2),(1567,1919293227,3),(1567,1932598827,2),(1567,1950742827,3),(1567,1964048427,2),(1567,1982797227,3),(1567,1995498027,2),(1567,2014246827,3),(1567,2026947627,2),(1567,2045696427,3),(1567,2058397227,2),(1567,2077146027,3),(1567,2090451627,2),(1567,2108595627,3),(1567,2121901227,2),(1567,2140045227,3),(1568,-1633276800,0),(1568,-1615136400,1),(1568,-1601827200,0),(1568,-1583686800,1),(1568,-880214400,2),(1568,-769395600,3),(1568,-765392400,1),(1568,-84384000,0),(1568,-68662800,1),(1568,-52934400,0),(1568,-37213200,1),(1568,-21484800,0),(1568,-5763600,1),(1568,9964800,0),(1568,25686000,1),(1568,41414400,0),(1568,57740400,1),(1568,73468800,0),(1568,89190001,1),(1568,104918402,0),(1568,120639602,1),(1568,126691203,0),(1568,152089203,1),(1568,162374404,0),(1568,183538804,1),(1568,199267205,0),(1568,215593205,1),(1568,230716806,0),(1568,247042806,1),(1568,262771207,0),(1568,278492407,1),(1568,294220808,0),(1568,309942008,1),(1568,325670409,0),(1568,341391609,1),(1568,357120009,0),(1568,372841210,1),(1568,388569610,0),(1568,404895611,1),(1568,420019211,0),(1568,436345212,1),(1568,452073612,0),(1568,467794812,1),(1568,483523212,0),(1568,499244413,1),(1568,514972813,0),(1568,530694013,1),(1568,544608013,0),(1568,562143613,1),(1568,576057614,0),(1568,594198014,1),(1568,607507214,0),(1568,625647614,1),(1568,638956815,0),(1568,657097215,1),(1568,671011216,0),(1568,688546816,1),(1568,702460816,0),(1568,719996417,1),(1568,733910417,0),(1568,752050818,1),(1568,765360018,0),(1568,783500419,1),(1568,796809619,0),(1568,814950019,1),(1568,828864020,0),(1568,846399620,1),(1568,860313620,0),(1568,877849221,1),(1568,891763221,0),(1568,909298821,1),(1568,923212822,0),(1568,941353222,1),(1568,954662422,0),(1568,972802822,1),(1568,986112022,0),(1568,1004252422,1),(1568,1018166422,0),(1568,1035702022,1),(1568,1049616022,0),(1568,1067151622,1),(1568,1081065622,0),(1568,1099206022,1),(1568,1112515222,0),(1568,1130655622,1),(1568,1143964823,0),(1568,1162105223,1),(1568,1173600023,0),(1568,1194159623,1),(1568,1205049623,0),(1568,1225609223,1),(1568,1236499224,0),(1568,1257058824,1),(1568,1268553624,0),(1568,1289113224,1),(1568,1300003224,0),(1568,1320562824,1),(1568,1331452824,0),(1568,1352012425,1),(1568,1362902425,0),(1568,1383462025,1),(1568,1394352025,0),(1568,1414911625,1),(1568,1425801625,0),(1568,1446361226,1),(1568,1457856026,0),(1568,1478415626,1),(1568,1489305627,0),(1568,1509865227,1),(1568,1520755227,0),(1568,1541314827,1),(1568,1552204827,0),(1568,1572764427,1),(1568,1583654427,0),(1568,1604214027,1),(1568,1615708827,0),(1568,1636268427,1),(1568,1647158427,0),(1568,1667718027,1),(1568,1678608027,0),(1568,1699167627,1),(1568,1710057627,0),(1568,1730617227,1),(1568,1741507227,0),(1568,1762066827,1),(1568,1772956827,0),(1568,1793516427,1),(1568,1805011227,0),(1568,1825570827,1),(1568,1836460827,0),(1568,1857020427,1),(1568,1867910427,0),(1568,1888470027,1),(1568,1899360027,0),(1568,1919919627,1),(1568,1930809627,0),(1568,1951369227,1),(1568,1962864027,0),(1568,1983423627,1),(1568,1994313627,0),(1568,2014873227,1),(1568,2025763227,0),(1568,2046322827,1),(1568,2057212827,0),(1568,2077772427,1),(1568,2088662427,0),(1568,2109222027,1),(1568,2120112027,0),(1568,2140671627,1),(1569,-2147483648,0),(1569,-2131645536,2),(1569,-1696276800,1),(1569,-1680469200,2),(1569,-1632074400,1),(1569,-1615143600,2),(1569,-1566763200,1),(1569,-1557090000,2),(1569,-1535486400,1),(1569,-1524949200,2),(1569,-1504468800,1),(1569,-1493413200,2),(1569,-1472414400,1),(1569,-1461963600,2),(1569,-1440964800,1),(1569,-1429390800,2),(1569,-1409515200,1),(1569,-1396731600,2),(1569,-1376856000,1),(1569,-1366491600,2),(1569,-1346616000,1),(1569,-1333832400,2),(1569,-1313956800,1),(1569,-1303678800,2),(1569,-1282507200,1),(1569,-1272661200,2),(1569,-1251057600,1),(1569,-1240088400,2),(1569,-1219608000,1),(1569,-1207429200,2),(1569,-1188763200,1),(1569,-1175979600,2),(1569,-1157313600,1),(1569,-1143925200,2),(1569,-1124049600,1),(1569,-1113771600,2),(1569,-1091390400,1),(1569,-1081026000,2),(1569,-1059854400,1),(1569,-1050786000,2),(1569,-1030910400,1),(1569,-1018126800,2),(1569,-999460800,1),(1569,-986677200,2),(1569,-965592000,1),(1569,-955227600,2),(1569,-935956800,1),(1569,-923173200,2),(1569,-904507200,1),(1569,-891723600,2),(1569,-880221600,3),(1569,-769395600,4),(1569,-765399600,2),(1569,-747252000,1),(1569,-733950000,2),(1569,-715802400,1),(1569,-702500400,2),(1569,-684352800,1),(1569,-671050800,2),(1569,-652903200,1),(1569,-639601200,2),(1569,-589399200,1),(1569,-576097200,2),(1569,-557949600,1),(1569,-544647600,2),(1569,-526500000,1),(1569,-513198000,2),(1569,-495050400,1),(1569,-481748400,2),(1569,-431546400,1),(1569,-418244400,2),(1569,-400096800,1),(1569,-386794800,2),(1569,-368647200,1),(1569,-355345200,2),(1569,-337197600,1),(1569,-323895600,2),(1569,-242244000,1),(1569,-226522800,2),(1569,-210794400,1),(1569,-195073200,2),(1569,-179344800,1),(1569,-163623600,2),(1569,-147895200,1),(1569,-131569200,2),(1569,-116445600,1),(1569,-100119600,2),(1569,-84391200,1),(1569,-68670000,2),(1569,-52941600,1),(1569,-37220400,2),(1569,-21492000,1),(1569,-5770800,2),(1569,9957600,1),(1569,25678800,2),(1569,41407200,1),(1569,57733200,2),(1569,73461600,1),(1569,89182801,2),(1569,104911202,1),(1569,120632402,2),(1569,136360803,1),(1569,152082003,2),(1569,167810404,1),(1569,183531604,2),(1569,199260005,1),(1569,215586005,2),(1569,230709606,1),(1569,247035606,2),(1569,262764007,1),(1569,278485207,2),(1569,294213608,1),(1569,309934808,2),(1569,325663209,1),(1569,341384409,2),(1569,357112809,1),(1569,372834010,2),(1569,388562410,1),(1569,404888411,2),(1569,420012011,1),(1569,436338012,2),(1569,452066412,1),(1569,467787612,2),(1569,483516012,1),(1569,499237213,2),(1569,514965613,1),(1569,530686813,2),(1569,544600813,1),(1569,562136413,2),(1569,576050414,1),(1569,594190814,2),(1569,607500014,1),(1569,625640414,2),(1569,638949615,1),(1569,657090015,2),(1569,671004016,1),(1569,688539616,2),(1569,702453616,1),(1569,719989217,2),(1569,733903217,1),(1569,752043618,2),(1569,765352818,1),(1569,783493219,2),(1569,796802419,1),(1569,814942819,2),(1569,828856820,1),(1569,846392420,2),(1569,860306420,1),(1569,877842021,2),(1569,891756021,1),(1569,909291621,2),(1569,923205622,1),(1569,941346022,2),(1569,954655222,1),(1569,972795622,2),(1569,986104822,1),(1569,1004245222,2),(1569,1018159222,1),(1569,1035694822,2),(1569,1049608822,1),(1569,1067144422,2),(1569,1081058422,1),(1569,1099198822,2),(1569,1112508022,1),(1569,1130648422,2),(1569,1143957623,1),(1569,1162098023,2),(1569,1173592823,1),(1569,1194152423,2),(1569,1205042423,1),(1569,1225602023,2),(1569,1236492024,1),(1569,1257051624,2),(1569,1268546424,1),(1569,1289106024,2),(1569,1299996024,1),(1569,1320555624,2),(1569,1331445624,1),(1569,1352005225,2),(1569,1362895225,1),(1569,1383454825,2),(1569,1394344825,1),(1569,1414904425,2),(1569,1425794425,1),(1569,1446354026,2),(1569,1457848826,1),(1569,1478408426,2),(1569,1489298427,1),(1569,1509858027,2),(1569,1520748027,1),(1569,1541307627,2),(1569,1552197627,1),(1569,1572757227,2),(1569,1583647227,1),(1569,1604206827,2),(1569,1615701627,1),(1569,1636261227,2),(1569,1647151227,1),(1569,1667710827,2),(1569,1678600827,1),(1569,1699160427,2),(1569,1710050427,1),(1569,1730610027,2),(1569,1741500027,1),(1569,1762059627,2),(1569,1772949627,1),(1569,1793509227,2),(1569,1805004027,1),(1569,1825563627,2),(1569,1836453627,1),(1569,1857013227,2),(1569,1867903227,1),(1569,1888462827,2),(1569,1899352827,1),(1569,1919912427,2),(1569,1930802427,1),(1569,1951362027,2),(1569,1962856827,1),(1569,1983416427,2),(1569,1994306427,1),(1569,2014866027,2),(1569,2025756027,1),(1569,2046315627,2),(1569,2057205627,1),(1569,2077765227,2),(1569,2088655227,1),(1569,2109214827,2),(1569,2120104827,1),(1569,2140664427,2),(1570,-2147483648,2),(1570,-1694368800,1),(1570,-1681671600,2),(1570,-1632067200,1),(1570,-1615136400,2),(1570,-1029686400,1),(1570,-1018198800,2),(1570,-880214400,3),(1570,-769395600,4),(1570,-765392400,2),(1570,-746035200,1),(1570,-732733200,2),(1570,-715795200,1),(1570,-702493200,2),(1570,-684345600,1),(1570,-671043600,2),(1570,-652896000,1),(1570,-639594000,2),(1570,-620755200,1),(1570,-607626000,2),(1570,-589392000,1),(1570,-576090000,2),(1570,-557942400,1),(1570,-544640400,2),(1570,-526492800,1),(1570,-513190800,2),(1570,-495043200,1),(1570,-481741200,2),(1570,-463593600,1),(1570,-450291600,2),(1570,-431539200,1),(1570,-418237200,2),(1570,-400089600,1),(1570,-386787600,2),(1570,-368640000,1),(1570,-355338000,2),(1570,-337190400,1),(1570,-321469200,2),(1570,-305740800,1),(1570,-292438800,2),(1570,-210787200,1),(1570,-198090000,2),(1570,-116438400,5),(1570,-100108800,6),(1570,-84384000,5),(1570,-68659200,6),(1570,-52934400,5),(1570,-37209600,6),(1570,-21484800,5),(1570,-5760000,6),(1570,9964800,5),(1570,25689600,6),(1570,41414400,5),(1570,57744000,6),(1570,73468800,5),(1570,89193601,6),(1570,104918402,5),(1570,120643202,6),(1570,136368003,5),(1570,152092803,6),(1570,167817604,5),(1570,183542404,6),(1570,199267205,5),(1570,215596805,6),(1570,230716806,5),(1570,247046406,6),(1570,262771207,5),(1570,278496007,6),(1570,294220808,5),(1570,309945608,6),(1570,325670409,5),(1570,341395209,6),(1570,357120009,5),(1570,372844810,6),(1570,388569610,5),(1570,404899211,6),(1570,420019211,5),(1570,436348812,6),(1570,452073612,5),(1570,467798412,6),(1570,483523212,5),(1570,499248013,6),(1570,514972813,5),(1570,530697613,6),(1570,544608013,5),(1570,562147213,6),(1570,576057614,5),(1570,594201614,6),(1570,607507214,5),(1570,625651214,6),(1570,638956815,5),(1570,657100815,6),(1570,671011216,5),(1570,688550416,6),(1570,702460816,5),(1570,720000017,6),(1570,733910417,5),(1570,752054418,6),(1570,765360018,5),(1570,783504019,6),(1570,796809619,5),(1570,814953619,6),(1570,828864020,5),(1570,846403220,6),(1570,860313620,5),(1570,877852821,6),(1570,891763221,5),(1570,909302421,6),(1570,923212822,5),(1570,941356822,6),(1570,954662422,5),(1570,972806422,6),(1570,986112022,5),(1570,1004256022,6),(1570,1018166422,5),(1570,1035705622,6),(1570,1049616022,5),(1570,1067155222,6),(1570,1081065622,5),(1570,1099209622,6),(1570,1112515222,5),(1570,1130659222,6),(1570,1136095223,2),(1570,1143964823,1),(1570,1162105223,2),(1570,1173600023,1),(1570,1194159623,2),(1570,1205049623,1),(1570,1225609223,2),(1570,1236499224,1),(1570,1257058824,2),(1570,1268553624,1),(1570,1289113224,2),(1570,1300003224,1),(1570,1320562824,2),(1570,1331452824,1),(1570,1352012425,2),(1570,1362902425,1),(1570,1383462025,2),(1570,1394352025,1),(1570,1414911625,2),(1570,1425801625,1),(1570,1446361226,2),(1570,1457856026,1),(1570,1478415626,2),(1570,1489305627,1),(1570,1509865227,2),(1570,1520755227,1),(1570,1541314827,2),(1570,1552204827,1),(1570,1572764427,2),(1570,1583654427,1),(1570,1604214027,2),(1570,1615708827,1),(1570,1636268427,2),(1570,1647158427,1),(1570,1667718027,2),(1570,1678608027,1),(1570,1699167627,2),(1570,1710057627,1),(1570,1730617227,2),(1570,1741507227,1),(1570,1762066827,2),(1570,1772956827,1),(1570,1793516427,2),(1570,1805011227,1),(1570,1825570827,2),(1570,1836460827,1),(1570,1857020427,2),(1570,1867910427,1),(1570,1888470027,2),(1570,1899360027,1),(1570,1919919627,2),(1570,1930809627,1),(1570,1951369227,2),(1570,1962864027,1),(1570,1983423627,2),(1570,1994313627,1),(1570,2014873227,2),(1570,2025763227,1),(1570,2046322827,2),(1570,2057212827,1),(1570,2077772427,2),(1570,2088662427,1),(1570,2109222027,2),(1570,2120112027,1),(1570,2140671627,2),(1571,-2147483648,2),(1571,-1632070800,1),(1571,-1615140000,2),(1571,-1601753400,1),(1571,-1583697600,2),(1571,-1567357200,1),(1571,-1554667200,2),(1571,-1534698000,1),(1571,-1524074400,2),(1571,-1503248400,1),(1571,-1492365600,2),(1571,-1471798800,1),(1571,-1460916000,2),(1571,-1440954000,1),(1571,-1428861600,2),(1571,-1409504400,1),(1571,-1397412000,2),(1571,-1378054800,1),(1571,-1365962400,2),(1571,-1346605200,1),(1571,-1333908000,2),(1571,-1315155600,1),(1571,-1301853600,2),(1571,-1283706000,1),(1571,-1270404000,2),(1571,-1252256400,1),(1571,-1238954400,2),(1571,-1220806800,1),(1571,-1207504800,2),(1571,-1188752400,1),(1571,-1176055200,2),(1571,-1157302800,1),(1571,-1144000800,2),(1571,-1125853200,1),(1571,-1112551200,2),(1571,-1094403600,1),(1571,-1081101600,2),(1571,-1062954000,1),(1571,-1049652000,2),(1571,-1031504400,1),(1571,-1018202400,2),(1571,-1000054800,1),(1571,-986752800,2),(1571,-968000400,1),(1571,-955303200,2),(1571,-936550800,1),(1571,-880218000,3),(1571,-769395600,4),(1571,-765396000,2),(1571,-747248400,1),(1571,-733946400,2),(1571,-715806000,1),(1571,-702504000,2),(1571,-684356400,1),(1571,-671054400,2),(1571,-652906800,1),(1571,-634161600,2),(1571,-620845200,1),(1571,-602704800,2),(1571,-589395600,1),(1571,-576093600,2),(1571,-557946000,1),(1571,-544644000,2),(1571,-526496400,1),(1571,-513194400,2),(1571,-495046800,1),(1571,-481744800,2),(1571,-463597200,1),(1571,-450295200,2),(1571,-431542800,1),(1571,-418240800,2),(1571,-400093200,1),(1571,-384372000,2),(1571,-368643600,1),(1571,-352922400,2),(1571,-337194000,1),(1571,-321472800,2),(1571,-305744400,1),(1571,-289418400,2),(1571,-273690000,1),(1571,-257968800,2),(1571,-242240400,1),(1571,-226519200,2),(1571,-210790800,1),(1571,-195069600,2),(1571,-179341200,1),(1571,-163620000,2),(1571,-147891600,1),(1571,-131565600,2),(1571,-116442000,1),(1571,-100116000,2),(1571,-84387600,1),(1571,-68666400,2),(1571,-52938000,1),(1571,-37216800,2),(1571,-21488400,1),(1571,-5767200,2),(1571,9961200,1),(1571,25682400,2),(1571,41410800,1),(1571,57736800,2),(1571,73465200,1),(1571,89186401,2),(1571,104914802,1),(1571,120636002,2),(1571,136364403,1),(1571,152085603,2),(1571,167814004,1),(1571,183535204,2),(1571,199263605,1),(1571,215589605,2),(1571,230713206,1),(1571,247039206,2),(1571,262767607,1),(1571,278488807,2),(1571,294217208,1),(1571,309938408,2),(1571,325666809,1),(1571,341388009,2),(1571,357116409,1),(1571,372837610,2),(1571,388566010,1),(1571,404892011,2),(1571,420015611,1),(1571,436341612,2),(1571,452070012,1),(1571,467791212,2),(1571,483519612,1),(1571,499240813,2),(1571,514969213,1),(1571,530690413,2),(1571,544604413,1),(1571,562140013,2),(1571,576054014,1),(1571,594194414,2),(1571,607503614,1),(1571,625644014,2),(1571,638953215,1),(1571,657093615,2),(1571,671007616,1),(1571,688543216,2),(1571,702457216,1),(1571,719992817,2),(1571,733906817,1),(1571,752047218,2),(1571,765356418,1),(1571,783496819,2),(1571,796806019,1),(1571,814946419,2),(1571,828860420,1),(1571,846396020,2),(1571,860310020,1),(1571,877845621,2),(1571,891759621,1),(1571,909295221,2),(1571,923209222,1),(1571,941349622,2),(1571,954658822,1),(1571,972799222,2),(1571,986108422,1),(1571,1004248822,2),(1571,1018162822,1),(1571,1035698422,2),(1571,1049612422,1),(1571,1067148022,2),(1571,1081062022,1),(1571,1099202422,2),(1571,1112511622,1),(1571,1130652022,2),(1571,1143961223,1),(1571,1162101623,2),(1571,1173596423,1),(1571,1194156023,2),(1571,1205046023,1),(1571,1225605623,2),(1571,1236495624,1),(1571,1257055224,2),(1571,1268550024,1),(1571,1289109624,2),(1571,1299999624,1),(1571,1320559224,2),(1571,1331449224,1),(1571,1352008825,2),(1571,1362898825,1),(1571,1383458425,2),(1571,1394348425,1),(1571,1414908025,2),(1571,1425798025,1),(1571,1446357626,2),(1571,1457852426,1),(1571,1478412026,2),(1571,1489302027,1),(1571,1509861627,2),(1571,1520751627,1),(1571,1541311227,2),(1571,1552201227,1),(1571,1572760827,2),(1571,1583650827,1),(1571,1604210427,2),(1571,1615705227,1),(1571,1636264827,2),(1571,1647154827,1),(1571,1667714427,2),(1571,1678604427,1),(1571,1699164027,2),(1571,1710054027,1),(1571,1730613627,2),(1571,1741503627,1),(1571,1762063227,2),(1571,1772953227,1),(1571,1793512827,2),(1571,1805007627,1),(1571,1825567227,2),(1571,1836457227,1),(1571,1857016827,2),(1571,1867906827,1),(1571,1888466427,2),(1571,1899356427,1),(1571,1919916027,2),(1571,1930806027,1),(1571,1951365627,2),(1571,1962860427,1),(1571,1983420027,2),(1571,1994310027,1),(1571,2014869627,2),(1571,2025759627,1),(1571,2046319227,2),(1571,2057209227,1),(1571,2077768827,2),(1571,2088658827,1),(1571,2109218427,2),(1571,2120108427,1),(1571,2140668027,2),(1572,-2147483648,0),(1572,-1998663968,2),(1572,-1632063600,1),(1572,-1615132800,2),(1572,-1600614000,1),(1572,-1596816000,2),(1572,-1567954800,1),(1572,-1551628800,2),(1572,-1536505200,1),(1572,-1523203200,2),(1572,-1504450800,1),(1572,-1491753600,2),(1572,-1473001200,1),(1572,-1459699200,2),(1572,-880210800,3),(1572,-769395600,4),(1572,-765388800,2),(1572,-715791600,1),(1572,-702489600,2),(1572,73472400,1),(1572,89193601,2),(1572,104922002,1),(1572,120643202,2),(1572,136371603,1),(1572,152092803,2),(1572,167821204,1),(1572,183542404,2),(1572,199270805,1),(1572,215596805,2),(1572,230720406,1),(1572,247046406,2),(1572,262774807,1),(1572,278496007,2),(1572,294224408,1),(1572,309945608,2),(1572,325674009,1),(1572,341395209,2),(1572,357123609,1),(1572,372844810,2),(1572,388573210,1),(1572,404899211,2),(1572,420022811,1),(1572,436348812,2),(1572,452077212,1),(1572,467798412,2),(1572,483526812,1),(1572,499248013,2),(1572,514976413,1),(1572,530697613,2),(1572,544611613,1),(1572,562147213,2),(1572,576061214,1),(1572,594201614,2),(1572,607510814,1),(1572,625651214,2),(1572,638960415,1),(1572,657100815,2),(1572,671014816,1),(1572,688550416,2),(1572,702464416,1),(1572,720000017,2),(1572,733914017,1),(1572,752054418,2),(1572,765363618,1),(1572,783504019,2),(1572,796813219,1),(1572,814953619,2),(1572,828867620,1),(1572,846403220,2),(1572,860317220,1),(1572,877852821,2),(1572,891766821,1),(1572,909302421,2),(1572,923216422,1),(1572,941356822,2),(1572,954666022,1),(1572,972806422,2),(1572,986115622,1),(1572,1004256022,2),(1572,1018170022,1),(1572,1035705622,2),(1572,1049619622,1),(1572,1067155222,2),(1572,1081069222,1),(1572,1099209622,2),(1572,1112518822,1),(1572,1130659222,2),(1572,1143968423,1),(1572,1162108823,2),(1572,1173603623,1),(1572,1194163223,2),(1572,1205053223,1),(1572,1225612823,2),(1572,1236502824,1),(1572,1257062424,2),(1572,1268557224,1),(1572,1289116824,2),(1572,1300006824,1),(1572,1320566424,2),(1572,1331456424,1),(1572,1352016025,2),(1572,1362906025,1),(1572,1383465625,2),(1572,1394355625,1),(1572,1414915225,2),(1572,1425805225,1),(1572,1446364826,2),(1572,1457859626,1),(1572,1478419226,2),(1572,1489309227,1),(1572,1509868827,2),(1572,1520758827,1),(1572,1541318427,2),(1572,1552208427,1),(1572,1572768027,2),(1572,1583658027,1),(1572,1604217627,2),(1572,1615712427,1),(1572,1636272027,2),(1572,1647162027,1),(1572,1667721627,2),(1572,1678611627,1),(1572,1699171227,2),(1572,1710061227,1),(1572,1730620827,2),(1572,1741510827,1),(1572,1762070427,2),(1572,1772960427,1),(1572,1793520027,2),(1572,1805014827,1),(1572,1825574427,2),(1572,1836464427,1),(1572,1857024027,2),(1572,1867914027,1),(1572,1888473627,2),(1572,1899363627,1),(1572,1919923227,2),(1572,1930813227,1),(1572,1951372827,2),(1572,1962867627,1),(1572,1983427227,2),(1572,1994317227,1),(1572,2014876827,2),(1572,2025766827,1),(1572,2046326427,2),(1572,2057216427,1),(1572,2077776027,2),(1572,2088666027,1),(1572,2109225627,2),(1572,2120115627,1),(1572,2140675227,2),(1573,-2147483648,2),(1573,-1664130548,1),(1573,-1650137348,2),(1573,-1632076148,1),(1573,-1615145348,2),(1573,-1598650148,1),(1573,-1590100148,2),(1573,-1567286948,1),(1573,-1551565748,2),(1573,-1535837348,1),(1573,-1520116148,2),(1573,-1503782948,1),(1573,-1488666548,2),(1573,-1472333348,1),(1573,-1457216948,2),(1573,-1440883748,1),(1573,-1425767348,2),(1573,-1409434148,1),(1573,-1394317748,2),(1573,-1377984548,1),(1573,-1362263348,2),(1573,-1346534948,1),(1573,-1330813748,2),(1573,-1314480548,1),(1573,-1299364148,2),(1573,-1283030948,1),(1573,-1267914548,2),(1573,-1251581348,1),(1573,-1236464948,2),(1573,-1220131748,1),(1573,-1205015348,2),(1573,-1188682148,1),(1573,-1172960948,2),(1573,-1156627748,1),(1573,-1141511348,2),(1573,-1125178148,1),(1573,-1110061748,2),(1573,-1096921748,4),(1573,-1093728600,3),(1573,-1078612200,4),(1573,-1061670600,3),(1573,-1048973400,4),(1573,-1030221000,3),(1573,-1017523800,4),(1573,-998771400,3),(1573,-986074200,4),(1573,-966717000,3),(1573,-954624600,4),(1573,-935267400,3),(1573,-922570200,4),(1573,-903817800,3),(1573,-891120600,4),(1573,-872368200,6),(1573,-769395600,5),(1573,-765401400,4),(1573,-746044200,3),(1573,-733347000,4),(1573,-714594600,3),(1573,-701897400,4),(1573,-683145000,3),(1573,-670447800,4),(1573,-651695400,3),(1573,-638998200,4),(1573,-619641000,3),(1573,-606943800,4),(1573,-589401000,3),(1573,-576099000,4),(1573,-557951400,3),(1573,-544649400,4),(1573,-526501800,3),(1573,-513199800,4),(1573,-495052200,3),(1573,-481750200,4),(1573,-463602600,3),(1573,-450300600,4),(1573,-431548200,3),(1573,-418246200,4),(1573,-400098600,3),(1573,-386796600,4),(1573,-368649000,3),(1573,-355347000,4),(1573,-337199400,3),(1573,-323897400,4),(1573,-305749800,3),(1573,-289423800,4),(1573,-273695400,3),(1573,-257974200,4),(1573,-242245800,3),(1573,-226524600,4),(1573,-210796200,3),(1573,-195075000,4),(1573,-179346600,3),(1573,-163625400,4),(1573,-147897000,3),(1573,-131571000,4),(1573,-116447400,3),(1573,-100121400,4),(1573,-84393000,3),(1573,-68671800,4),(1573,-52943400,3),(1573,-37222200,4),(1573,-21493800,3),(1573,-5772600,4),(1573,9955800,3),(1573,25677000,4),(1573,41405400,3),(1573,57731400,4),(1573,73459800,3),(1573,89181001,4),(1573,104909402,3),(1573,120630602,4),(1573,136359003,3),(1573,152080203,4),(1573,167808604,3),(1573,183529804,4),(1573,199258205,3),(1573,215584205,4),(1573,230707806,3),(1573,247033806,4),(1573,262762207,3),(1573,278483407,4),(1573,294211808,3),(1573,309933008,4),(1573,325661409,3),(1573,341382609,4),(1573,357111009,3),(1573,372832210,4),(1573,388560610,3),(1573,404886611,4),(1573,420010211,3),(1573,436336212,4),(1573,452064612,3),(1573,467785812,4),(1573,483514212,3),(1573,499235413,4),(1573,514963813,3),(1573,530685013,4),(1573,544591873,3),(1573,562127473,4),(1573,576041474,7),(1573,594178274,4),(1573,607491074,3),(1573,625631474,4),(1573,638940675,3),(1573,657081075,4),(1573,670995076,3),(1573,688530676,4),(1573,702444676,3),(1573,719980277,4),(1573,733894277,3),(1573,752034678,4),(1573,765343878,3),(1573,783484279,4),(1573,796793479,3),(1573,814933879,4),(1573,828847880,3),(1573,846383480,4),(1573,860297480,3),(1573,877833081,4),(1573,891747081,3),(1573,909282681,4),(1573,923196682,3),(1573,941337082,4),(1573,954646282,3),(1573,972786682,4),(1573,986095882,3),(1573,1004236282,4),(1573,1018150282,3),(1573,1035685882,4),(1573,1049599882,3),(1573,1067135482,4),(1573,1081049482,3),(1573,1099189882,4),(1573,1112499082,3),(1573,1130639482,4),(1573,1143948683,3),(1573,1162089083,4),(1573,1173583883,3),(1573,1194143483,4),(1573,1205033483,3),(1573,1225593083,4),(1573,1236483084,3),(1573,1257042684,4),(1573,1268537484,3),(1573,1289097084,4),(1573,1299987084,3),(1573,1320553824,4),(1573,1331443824,3),(1573,1352003425,4),(1573,1362893425,3),(1573,1383453025,4),(1573,1394343025,3),(1573,1414902625,4),(1573,1425792625,3),(1573,1446352226,4),(1573,1457847026,3),(1573,1478406626,4),(1573,1489296627,3),(1573,1509856227,4),(1573,1520746227,3),(1573,1541305827,4),(1573,1552195827,3),(1573,1572755427,4),(1573,1583645427,3),(1573,1604205027,4),(1573,1615699827,3),(1573,1636259427,4),(1573,1647149427,3),(1573,1667709027,4),(1573,1678599027,3),(1573,1699158627,4),(1573,1710048627,3),(1573,1730608227,4),(1573,1741498227,3),(1573,1762057827,4),(1573,1772947827,3),(1573,1793507427,4),(1573,1805002227,3),(1573,1825561827,4),(1573,1836451827,3),(1573,1857011427,4),(1573,1867901427,3),(1573,1888461027,4),(1573,1899351027,3),(1573,1919910627,4),(1573,1930800627,3),(1573,1951360227,4),(1573,1962855027,3),(1573,1983414627,4),(1573,1994304627,3),(1573,2014864227,4),(1573,2025754227,3),(1573,2046313827,4),(1573,2057203827,3),(1573,2077763427,4),(1573,2088653427,3),(1573,2109213027,4),(1573,2120103027,3),(1573,2140662627,4),(1574,-2147483648,2),(1574,-1632060000,1),(1574,-1615129200,2),(1574,-880207200,3),(1574,-769395600,4),(1574,-765385200,2),(1574,-747237600,1),(1574,-733935600,2),(1574,-715788000,1),(1574,-702486000,2),(1574,-684338400,1),(1574,-671036400,2),(1574,-652888800,1),(1574,-639586800,2),(1574,-620834400,1),(1574,-608137200,2),(1574,-589384800,1),(1574,-576082800,2),(1574,-557935200,1),(1574,-544633200,2),(1574,-526485600,1),(1574,-513183600,2),(1574,-495036000,1),(1574,-481734000,2),(1574,-463586400,1),(1574,-450284400,2),(1574,-431532000,1),(1574,-418230000,2),(1574,-400082400,1),(1574,-386780400,2),(1574,-368632800,1),(1574,-355330800,2),(1574,-337183200,1),(1574,-323881200,2),(1574,-305733600,1),(1574,-292431600,2),(1574,-273679200,1),(1574,-260982000,2),(1574,-242229600,1),(1574,-226508400,2),(1574,-210780000,1),(1574,-195058800,2),(1574,-179330400,1),(1574,-163609200,2),(1574,-147880800,1),(1574,-131554800,2),(1574,-116431200,1),(1574,-100105200,2),(1574,-84376800,1),(1574,-68655600,2),(1574,-52927200,1),(1574,-37206000,2),(1574,-21477600,1),(1574,-5756400,2),(1574,9972000,1),(1574,25693200,2),(1574,41421600,1),(1574,57747600,2),(1574,73476000,1),(1574,89197201,2),(1574,104925602,1),(1574,120646802,2),(1574,136375203,1),(1574,152096403,2),(1574,167824804,1),(1574,183546004,2),(1574,199274405,1),(1574,215600405,2),(1574,230724006,1),(1574,247050006,2),(1574,262778407,1),(1574,278499607,2),(1574,294228008,1),(1574,309949208,2),(1574,325677609,1),(1574,341398809,2),(1574,357127209,1),(1574,372848410,2),(1574,388576810,1),(1574,404902811,2),(1574,420026411,1),(1574,436352412,2),(1574,452080812,1),(1574,467802012,2),(1574,483530412,1),(1574,499251613,2),(1574,514980013,1),(1574,530701213,2),(1574,544615213,1),(1574,562150813,2),(1574,576064814,1),(1574,594205214,2),(1574,607514414,1),(1574,625654814,2),(1574,638964015,1),(1574,657104415,2),(1574,671018416,1),(1574,688554016,2),(1574,702468016,1),(1574,720003617,2),(1574,733917617,1),(1574,752058018,2),(1574,765367218,1),(1574,783507619,2),(1574,796816819,1),(1574,814957219,2),(1574,828871220,1),(1574,846406820,2),(1574,860320820,1),(1574,877856421,2),(1574,891770421,1),(1574,909306021,2),(1574,923220022,1),(1574,941360422,2),(1574,954669622,1),(1574,972810022,2),(1574,986119222,1),(1574,1004259622,2),(1574,1018173622,1),(1574,1035709222,2),(1574,1049623222,1),(1574,1067158822,2),(1574,1081072822,1),(1574,1099213222,2),(1574,1112522422,1),(1574,1130662822,2),(1574,1143972023,1),(1574,1162112423,2),(1574,1173607223,1),(1574,1194166823,2),(1574,1205056823,1),(1574,1225616423,2),(1574,1236506424,1),(1574,1257066024,2),(1574,1268560824,1),(1574,1289120424,2),(1574,1300010424,1),(1574,1320570024,2),(1574,1331460024,1),(1574,1352019625,2),(1574,1362909625,1),(1574,1383469225,2),(1574,1394359225,1),(1574,1414918825,2),(1574,1425808825,1),(1574,1446368426,2),(1574,1457863226,1),(1574,1478422826,2),(1574,1489312827,1),(1574,1509872427,2),(1574,1520762427,1),(1574,1541322027,2),(1574,1552212027,1),(1574,1572771627,2),(1574,1583661627,1),(1574,1604221227,2),(1574,1615716027,1),(1574,1636275627,2),(1574,1647165627,1),(1574,1667725227,2),(1574,1678615227,1),(1574,1699174827,2),(1574,1710064827,1),(1574,1730624427,2),(1574,1741514427,1),(1574,1762074027,2),(1574,1772964027,1),(1574,1793523627,2),(1574,1805018427,1),(1574,1825578027,2),(1574,1836468027,1),(1574,1857027627,2),(1574,1867917627,1),(1574,1888477227,2),(1574,1899367227,1),(1574,1919926827,2),(1574,1930816827,1),(1574,1951376427,2),(1574,1962871227,1),(1574,1983430827,2),(1574,1994320827,1),(1574,2014880427,2),(1574,2025770427,1),(1574,2046330027,2),(1574,2057220027,1),(1574,2077779627,2),(1574,2088669627,1),(1574,2109229227,2),(1574,2120119227,1),(1574,2140678827,2),(1575,-2147483648,0),(1575,-2030202084,2),(1575,-1632063600,1),(1575,-1615132800,2),(1575,-1251651600,1),(1575,-1238349600,2),(1575,-1220202000,1),(1575,-1206900000,2),(1575,-1188752400,1),(1575,-1175450400,2),(1575,-1156698000,1),(1575,-1144000800,2),(1575,-1125248400,1),(1575,-1111946400,2),(1575,-1032714000,1),(1575,-1016992800,2),(1575,-1001264400,1),(1575,-986148000,2),(1575,-969814800,1),(1575,-954093600,2),(1575,-937760400,1),(1575,-922039200,2),(1575,-906310800,1),(1575,-890589600,2),(1575,-880210800,3),(1575,-769395600,4),(1575,-765388800,2),(1575,-748450800,1),(1575,-732729600,2),(1575,-715791600,1),(1575,-702489600,2),(1575,-684342000,1),(1575,-671040000,2),(1575,-652892400,1),(1575,-639590400,2),(1575,-620838000,1),(1575,-608140800,2),(1575,-589388400,1),(1575,-576086400,2),(1575,-557938800,1),(1575,-544636800,2),(1575,-526489200,1),(1575,-513187200,2),(1575,-495039600,1),(1575,-481737600,2),(1575,-463590000,1),(1575,-450288000,2),(1575,-431535600,1),(1575,-418233600,2),(1575,-400086000,1),(1575,-386784000,2),(1575,-337186800,1),(1575,-321465600,2),(1575,-305737200,5),(1576,-2147483648,2),(1576,-1632056400,1),(1576,-1615125600,2),(1576,-1596978000,1),(1576,-1583164800,2),(1576,-880203600,3),(1576,-769395600,4),(1576,-765381600,2),(1576,-147884400,5),(1576,-131554800,2),(1576,-121273200,6),(1576,325677609,7),(1576,341398809,6),(1576,357127209,7),(1576,372848410,6),(1576,388576810,7),(1576,404902811,6),(1576,420026411,7),(1576,436352412,6),(1576,452080812,7),(1576,467802012,6),(1576,483530412,7),(1576,499251613,6),(1576,514980013,7),(1576,530701213,6),(1576,544615213,7),(1576,562150813,6),(1576,576064814,7),(1576,594205214,6),(1576,607514414,7),(1576,625654814,6),(1576,638964015,7),(1576,657104415,6),(1576,671018416,7),(1576,688554016,6),(1576,702468016,7),(1576,720003617,6),(1576,733917617,7),(1576,752058018,6),(1576,765367218,7),(1576,783507619,6),(1576,796816819,7),(1576,814957219,6),(1576,828871220,7),(1576,846406820,6),(1576,860320820,7),(1576,877856421,6),(1576,891770421,7),(1576,909306021,6),(1576,923220022,7),(1576,941360422,6),(1576,954669622,7),(1576,972810022,6),(1576,986119222,7),(1576,1004259622,6),(1576,1018173622,7),(1576,1035709222,6),(1576,1049623222,7),(1576,1067158822,6),(1576,1081072822,7),(1576,1099213222,6),(1576,1112522422,7),(1576,1130662822,6),(1576,1143972023,7),(1576,1162112423,6),(1576,1173607223,7),(1576,1194166823,6),(1576,1205056823,7),(1576,1225616423,6),(1576,1236506424,7),(1576,1257066024,6),(1576,1268560824,7),(1576,1289120424,6),(1576,1300010424,7),(1576,1320570024,6),(1576,1331460024,7),(1576,1352019625,6),(1576,1362909625,7),(1576,1383469225,6),(1576,1394359225,7),(1576,1414918825,6),(1576,1425808825,7),(1576,1446368426,6),(1576,1457863226,7),(1576,1478422826,6),(1576,1489312827,7),(1576,1509872427,6),(1576,1520762427,7),(1576,1541322027,6),(1576,1552212027,7),(1576,1572771627,6),(1576,1583661627,7),(1576,1604214027,8),(1577,-2147483648,1),(1577,-1892661435,2),(1577,-1688410800,1),(1577,-1619205435,3),(1577,-1593806400,1),(1577,-1335986235,4),(1577,-1317585600,2),(1577,-1304362800,4),(1577,-1286049600,2),(1577,-1272826800,4),(1577,-1254513600,2),(1577,-1241290800,4),(1577,-1222977600,2),(1577,-1209754800,4),(1577,-1191355200,2),(1577,-1178132400,3),(1577,-870552000,2),(1577,-865278000,3),(1577,-740520000,5),(1577,-736635600,4),(1577,-718056000,2),(1577,-713649600,3),(1577,-36619200,6),(1577,-23922000,7),(1577,-3355200,6),(1577,7527600,7),(1577,24465600,6),(1577,37767600,7),(1577,55915200,6),(1577,69217200,7),(1577,87969601,6),(1577,100666802,7),(1577,118209602,6),(1577,132116403,7),(1577,150868803,6),(1577,163566004,7),(1577,182318404,6),(1577,195620405,7),(1577,213768005,6),(1577,227070006,7),(1577,245217606,6),(1577,258519607,7),(1577,277272007,6),(1577,289969208,7),(1577,308721608,6),(1577,321418809,7),(1577,340171209,6),(1577,353473209,7),(1577,371620810,6),(1577,384922810,7),(1577,403070411,6),(1577,416372411,7),(1577,434520012,6),(1577,447822012,7),(1577,466574412,6),(1577,479271612,7),(1577,498024013,6),(1577,510721213,7),(1577,529473613,6),(1577,545194813,7),(1577,560923213,6),(1577,574225214,7),(1577,592372814,6),(1577,605674814,7),(1577,624427214,6),(1577,637124415,7),(1577,653457615,6),(1577,668574016,7),(1577,687326416,6),(1577,700628416,7),(1577,718776017,6),(1577,732078017,7),(1577,750225618,6),(1577,763527618,7),(1577,781675219,6),(1577,794977219,7),(1577,813729619,6),(1577,826426820,7),(1577,845179220,6),(1577,859690820,7),(1577,876628821,6),(1577,889930821,7),(1577,906868821,6),(1577,923194822,7),(1577,939528022,6),(1577,952830022,7),(1577,971582422,6),(1577,984279622,7),(1577,1003032022,6),(1577,1015729222,7),(1577,1034481622,6),(1577,1047178822,7),(1577,1065931222,6),(1577,1079233222,7),(1577,1097380822,6),(1577,1110682822,7),(1577,1128830422,6),(1577,1142132423,7),(1577,1160884823,6),(1577,1173582023,7),(1577,1192334423,6),(1577,1206846023,7),(1577,1223784023,6),(1577,1237086024,7),(1577,1255233624,6),(1577,1270350024,7),(1577,1286683224,6),(1577,1304823624,7),(1577,1313899224,6),(1577,1335668424,7),(1577,1346558425,6),(1577,1367118025,7),(1577,1378612825,6),(1577,1398567625,7),(1577,1410062425,6),(1577,1463281226,7),(1577,1471147226,6),(1577,1494730827,7),(1577,1502596827,6),(1577,1526180427,7),(1577,1534046427,6),(1577,1554606027,7),(1577,1567915227,6),(1577,1586055627,7),(1577,1599364827,6),(1577,1617505227,7),(1577,1630814427,6),(1577,1648954827,7),(1577,1662868827,6),(1577,1680404427,7),(1577,1693713627,6),(1577,1712458827,7),(1577,1725768027,6),(1577,1743908427,7),(1577,1757217627,6),(1577,1775358027,7),(1577,1788667227,6),(1577,1806807627,7),(1577,1820116827,6),(1577,1838257227,7),(1577,1851566427,6),(1577,1870311627,7),(1577,1883016027,6),(1577,1901761227,7),(1577,1915070427,6),(1577,1933210827,7),(1577,1946520027,6),(1577,1964660427,7),(1577,1977969627,6),(1577,1996110027,7),(1577,2009419227,6),(1577,2027559627,7),(1577,2040868827,6),(1577,2059614027,7),(1577,2072318427,6),(1577,2091063627,7),(1577,2104372827,6),(1577,2122513227,7),(1577,2135822427,6),(1578,-2147483648,1),(1578,-1178124152,4),(1578,-36619200,2),(1578,-23922000,3),(1578,-3355200,2),(1578,7527600,3),(1578,24465600,2),(1578,37767600,3),(1578,55915200,2),(1578,69217200,3),(1578,87969601,2),(1578,100666802,3),(1578,118209602,2),(1578,132116403,3),(1578,150868803,2),(1578,163566004,3),(1578,182318404,2),(1578,195620405,3),(1578,213768005,2),(1578,227070006,3),(1578,245217606,2),(1578,258519607,3),(1578,277272007,2),(1578,289969208,3),(1578,308721608,2),(1578,321418809,3),(1578,340171209,2),(1578,353473209,3),(1578,371620810,2),(1578,384922810,5),(1578,403070411,6),(1578,416372411,5),(1578,434520012,6),(1578,447822012,5),(1578,466574412,6),(1578,479271612,5),(1578,498024013,6),(1578,510721213,5),(1578,529473613,6),(1578,545194813,5),(1578,560923213,6),(1578,574225214,5),(1578,592372814,6),(1578,605674814,5),(1578,624427214,6),(1578,637124415,5),(1578,653457615,6),(1578,668574016,5),(1578,687326416,6),(1578,700628416,5),(1578,718776017,6),(1578,732078017,5),(1578,750225618,6),(1578,763527618,5),(1578,781675219,6),(1578,794977219,5),(1578,813729619,6),(1578,826426820,5),(1578,845179220,6),(1578,859690820,5),(1578,876628821,6),(1578,889930821,5),(1578,906868821,6),(1578,923194822,5),(1578,939528022,6),(1578,952830022,5),(1578,971582422,6),(1578,984279622,5),(1578,1003032022,6),(1578,1015729222,5),(1578,1034481622,6),(1578,1047178822,5),(1578,1065931222,6),(1578,1079233222,5),(1578,1097380822,6),(1578,1110682822,5),(1578,1128830422,6),(1578,1142132423,5),(1578,1160884823,6),(1578,1173582023,5),(1578,1192334423,6),(1578,1206846023,5),(1578,1223784023,6),(1578,1237086024,5),(1578,1255233624,6),(1578,1270350024,5),(1578,1286683224,6),(1578,1304823624,5),(1578,1313899224,6),(1578,1335668424,5),(1578,1346558425,6),(1578,1367118025,5),(1578,1378612825,6),(1578,1398567625,5),(1578,1410062425,6),(1578,1463281226,5),(1578,1471147226,6),(1578,1494730827,5),(1578,1502596827,6),(1578,1526180427,5),(1578,1534046427,6),(1578,1554606027,5),(1578,1567915227,6),(1578,1586055627,5),(1578,1599364827,6),(1578,1617505227,5),(1578,1630814427,6),(1578,1648954827,5),(1578,1662868827,6),(1578,1680404427,5),(1578,1693713627,6),(1578,1712458827,5),(1578,1725768027,6),(1578,1743908427,5),(1578,1757217627,6),(1578,1775358027,5),(1578,1788667227,6),(1578,1806807627,5),(1578,1820116827,6),(1578,1838257227,5),(1578,1851566427,6),(1578,1870311627,5),(1578,1883016027,6),(1578,1901761227,5),(1578,1915070427,6),(1578,1933210827,5),(1578,1946520027,6),(1578,1964660427,5),(1578,1977969627,6),(1578,1996110027,5),(1578,2009419227,6),(1578,2027559627,5),(1578,2040868827,6),(1578,2059614027,5),(1578,2072318427,6),(1578,2091063627,5),(1578,2104372827,6),(1578,2122513227,5),(1578,2135822427,6),(1579,-2147483648,1),(1579,-1402813824,3),(1579,-1311534000,2),(1579,-1300996800,3),(1579,-933534000,2),(1579,-925675200,3),(1579,-902084400,2),(1579,-893620800,3),(1579,-870030000,2),(1579,-862171200,3),(1579,-775681200,2),(1579,-767822400,3),(1579,-744231600,2),(1579,-736372800,3),(1579,-144702000,2),(1579,-134251200,3),(1579,-113425200,2),(1579,-102542400,3),(1579,-86295600,2),(1579,-72907200,3),(1579,-54154800,2),(1579,-41457600,3),(1579,-21495600,2),(1579,-5774400,3),(1579,9954000,2),(1579,25675200,3),(1579,41403600,2),(1579,57729600,3),(1579,73458000,2),(1579,87364801,3),(1579,104907602,2),(1579,118900802,3),(1579,136357203,2),(1579,150436803,3),(1579,167806804,2),(1579,183528004,3),(1579,199256405,2),(1579,215582405,3),(1579,230706006,2),(1579,247032006,3),(1579,263365207,2),(1579,276667207,3),(1579,290581208,2),(1579,308721608,3),(1579,322030809,2),(1579,340171209,3),(1579,358318809,2),(1579,371620810,3),(1579,389768410,2),(1579,403070411,3),(1579,421218011,2),(1579,434520012,3),(1579,452667612,2),(1579,466574412,3),(1579,484117212,2),(1579,498024013,3),(1579,511333213,2),(1579,529473613,3),(1579,542782813,2),(1579,560923213,3),(1579,574837214,2),(1579,592372814,3),(1579,606286814,2),(1579,623822414,3),(1579,638946015,2),(1579,655876815,3),(1579,671000416,2),(1579,687330016,4),(1579,702450016,2),(1579,718779617,4),(1579,733899617,2),(1579,750229218,4),(1579,765349218,2),(1579,781678819,4),(1579,796798819,2),(1579,813128419,4),(1579,828853220,2),(1579,844578020,4),(1579,860302820,2),(1579,876632421,4),(1579,891147621,5),(1579,909291621,4),(1579,922597222,5),(1579,941346022,4),(1579,954651622,5),(1579,972795622,4),(1579,986101222,5),(1579,1004245222,4),(1579,1018155622,5),(1579,1035694822,4),(1579,1049605222,5),(1579,1067144422,4),(1579,1080450022,5),(1579,1162098023,4),(1579,1173589223,5),(1579,1193547623,4),(1579,1205643623,5),(1579,1224997223,4),(1579,1236488424,5),(1579,1256446824,4),(1579,1268542824,5),(1579,1288501224,4),(1579,1300597224,5),(1579,1321160424,4),(1579,1333256424,5),(1579,1352005225,4),(1579,1362891625,5),(1579,1383454825,4),(1579,1394341225,5),(1579,1414904425,4),(1579,1425790825,5),(1579,1446354026,4),(1579,1457845226,5),(1579,1478408426,4),(1579,1489294827,5),(1579,1509858027,4),(1579,1520744427,5),(1579,1541307627,4),(1579,1552194027,5),(1579,1572757227,4),(1579,1583643627,5),(1579,1604206827,4),(1579,1615698027,5),(1579,1636261227,4),(1579,1647147627,5),(1579,1667710827,4),(1579,1678597227,5),(1579,1699160427,4),(1579,1710046827,5),(1579,1730610027,4),(1579,1741496427,5),(1579,1762059627,4),(1579,1772946027,5),(1579,1793509227,4),(1579,1805000427,5),(1579,1825563627,4),(1579,1836450027,5),(1579,1857013227,4),(1579,1867899627,5),(1579,1888462827,4),(1579,1899349227,5),(1579,1919912427,4),(1579,1930798827,5),(1579,1951362027,4),(1579,1962853227,5),(1579,1983416427,4),(1579,1994302827,5),(1579,2014866027,4),(1579,2025752427,5),(1579,2046315627,4),(1579,2057202027,5),(1579,2077765227,4),(1579,2088651627,5),(1579,2109214827,4),(1579,2120101227,5),(1579,2140664427,4),(1580,228877206,0),(1580,243997206,1),(1580,260326807,0),(1580,276051607,1),(1580,291776408,0),(1580,307501208,1),(1580,323830809,0),(1580,338950809,1),(1580,354675609,0),(1580,370400410,1),(1580,386125210,0),(1580,401850011,1),(1580,417574811,0),(1580,433299612,1),(1580,449024412,0),(1580,465354012,1),(1580,481078812,0),(1580,496803613,1),(1580,512528413,0),(1580,528253213,1),(1580,543978013,0),(1580,559702813,1),(1580,575427614,0),(1580,591152414,1),(1580,606877214,0),(1580,622602014,1),(1580,638326815,0),(1580,654656415,1),(1580,670381216,0),(1580,686106016,1),(1580,701830816,0),(1580,717555617,1),(1580,733280417,0),(1580,749005218,1),(1580,764730018,0),(1580,780454819,1),(1580,796179619,0),(1580,811904419,1),(1580,828234020,0),(1580,846378020,1),(1580,859683620,0),(1580,877827621,1),(1580,891133221,0),(1580,909277221,1),(1580,922582822,0),(1580,941331622,1),(1580,954032422,0),(1580,972781222,1),(1580,985482022,0),(1580,1004230822,1),(1580,1017536422,0),(1580,1035680422,1),(1580,1048986022,0),(1580,1067130022,1),(1580,1080435622,0),(1580,1099184422,1),(1580,1111885222,0),(1580,1130634022,1),(1580,1143334823,0),(1580,1162083623,1),(1580,1174784423,0),(1580,1193533223,1),(1580,1206838823,0),(1580,1224982823,1),(1580,1238288424,0),(1580,1256432424,1),(1580,1269738024,0),(1580,1288486824,1),(1580,1301187624,0),(1580,1319936424,1),(1580,1332637224,0),(1580,1351386025,1),(1580,1364691625,0),(1580,1382835625,1),(1580,1396141225,0),(1580,1414285225,1),(1580,1427590825,0),(1580,1445734826,1),(1580,1459040426,0),(1580,1477789226,1),(1580,1490490027,0),(1580,1509238827,1),(1580,1521939627,0),(1580,1540688427,1),(1580,1553994027,0),(1580,1572138027,1),(1580,1585443627,0),(1580,1603587627,1),(1580,1616893227,0),(1580,1635642027,1),(1580,1648342827,0),(1580,1667091627,1),(1580,1679792427,0),(1580,1698541227,1),(1580,1711846827,0),(1580,1729990827,1),(1580,1743296427,0),(1580,1761440427,1),(1580,1774746027,0),(1580,1792890027,1),(1580,1806195627,0),(1580,1824944427,1),(1580,1837645227,0),(1580,1856394027,1),(1580,1869094827,0),(1580,1887843627,1),(1580,1901149227,0),(1580,1919293227,1),(1580,1932598827,0),(1580,1950742827,1),(1580,1964048427,0),(1580,1982797227,1),(1580,1995498027,0),(1580,2014246827,1),(1580,2026947627,0),(1580,2045696427,1),(1580,2058397227,0),(1580,2077146027,1),(1580,2090451627,0),(1580,2108595627,1),(1580,2121901227,0),(1580,2140045227,1),(1582,-1633280400,0),(1582,-1615140000,1),(1582,-1601830800,0),(1582,-1583690400,1),(1582,-880218000,2),(1582,-769395600,3),(1582,-765396000,1),(1582,-84387600,0),(1582,-68666400,1),(1582,-52938000,0),(1582,-37216800,1),(1582,-21488400,0),(1582,-5767200,1),(1582,9961200,0),(1582,25682400,1),(1582,41410800,0),(1582,57736800,1),(1582,73465200,0),(1582,89186401,1),(1582,104914802,0),(1582,120636002,1),(1582,126687603,0),(1582,152085603,1),(1582,162370804,0),(1582,183535204,1),(1582,199263605,0),(1582,215589605,1),(1582,230713206,0),(1582,247039206,1),(1582,262767607,0),(1582,278488807,1),(1582,294217208,0),(1582,309938408,1),(1582,325666809,0),(1582,341388009,1),(1582,357116409,0),(1582,372837610,1),(1582,388566010,0),(1582,404892011,1),(1582,420015611,0),(1582,436341612,1),(1582,452070012,0),(1582,467791212,1),(1582,483519612,0),(1582,499240813,1),(1582,514969213,0),(1582,530690413,1),(1582,544604413,0),(1582,562140013,1),(1582,576054014,0),(1582,594194414,1),(1582,607503614,0),(1582,625644014,1),(1582,638953215,0),(1582,657093615,1),(1582,671007616,0),(1582,688543216,1),(1582,702457216,0),(1582,719992817,1),(1582,733906817,0),(1582,752047218,1),(1582,765356418,0),(1582,783496819,1),(1582,796806019,0),(1582,814946419,1),(1582,828860420,0),(1582,846396020,1),(1582,860310020,0),(1582,877845621,1),(1582,891759621,0),(1582,909295221,1),(1582,923209222,0),(1582,941349622,1),(1582,954658822,0),(1582,972799222,1),(1582,986108422,0),(1582,1004248822,1),(1582,1018162822,0),(1582,1035698422,1),(1582,1049612422,0),(1582,1067148022,1),(1582,1081062022,0),(1582,1099202422,1),(1582,1112511622,0),(1582,1130652022,1),(1582,1143961223,0),(1582,1162101623,1),(1582,1173596423,0),(1582,1194156023,1),(1582,1205046023,0),(1582,1225605623,1),(1582,1236495624,0),(1582,1257055224,1),(1582,1268550024,0),(1582,1289109624,1),(1582,1299999624,0),(1582,1320559224,1),(1582,1331449224,0),(1582,1352008825,1),(1582,1362898825,0),(1582,1383458425,1),(1582,1394348425,0),(1582,1414908025,1),(1582,1425798025,0),(1582,1446357626,1),(1582,1457852426,0),(1582,1478412026,1),(1582,1489302027,0),(1582,1509861627,1),(1582,1520751627,0),(1582,1541311227,1),(1582,1552201227,0),(1582,1572760827,1),(1582,1583650827,0),(1582,1604210427,1),(1582,1615705227,0),(1582,1636264827,1),(1582,1647154827,0),(1582,1667714427,1),(1582,1678604427,0),(1582,1699164027,1),(1582,1710054027,0),(1582,1730613627,1),(1582,1741503627,0),(1582,1762063227,1),(1582,1772953227,0),(1582,1793512827,1),(1582,1805007627,0),(1582,1825567227,1),(1582,1836457227,0),(1582,1857016827,1),(1582,1867906827,0),(1582,1888466427,1),(1582,1899356427,0),(1582,1919916027,1),(1582,1930806027,0),(1582,1951365627,1),(1582,1962860427,0),(1582,1983420027,1),(1582,1994310027,0),(1582,2014869627,1),(1582,2025759627,0),(1582,2046319227,1),(1582,2057209227,0),(1582,2077768827,1),(1582,2088658827,0),(1582,2109218427,1),(1582,2120108427,0),(1582,2140668027,1),(1583,-2147483648,2),(1583,-929844000,1),(1583,-923108400,2),(1583,-906170400,1),(1583,-892868400,2),(1583,-875844000,1),(1583,-857790000,2),(1583,-844308000,1),(1583,-825822000,2),(1583,-812685600,1),(1583,-794199600,2),(1583,-779853600,1),(1583,-762663600,2),(1583,-399088800,1),(1583,-386650800,2),(1583,-368330400,1),(1583,-355114800,2),(1583,-336790800,1),(1583,-323654400,2),(1583,-305168400,1),(1583,-292032000,2),(1583,-273632400,1),(1583,-260496000,2),(1583,-242096400,1),(1583,-228960000,2),(1583,-210560400,1),(1583,-197424000,2),(1583,-178938000,1),(1583,-165801600,2),(1583,-147402000,1),(1583,-134265600,2),(1583,-115866000,1),(1583,-102643200,2),(1583,-84330000,1),(1583,-71107200,2),(1583,-52707600,1),(1583,-39484800,2),(1583,-21171600,1),(1583,-7948800,2),(1583,10364400,1),(1583,23587200,2),(1583,41900400,1),(1583,55123200,2),(1583,73522800,1),(1583,86745601,2),(1583,105058802,1),(1583,118281602,2),(1583,136594803,1),(1583,149817603,2),(1583,168130804,1),(1583,181353604,2),(1583,199753205,1),(1583,212976005,2),(1583,231289206,1),(1583,244512006,2),(1583,262825207,1),(1583,276048007,2),(1583,294361208,1),(1583,307584008,2),(1583,325983609,1),(1583,339206409,2),(1583,357519609,1),(1583,370742410,2),(1583,396399611,1),(1583,402278411,2),(1583,426812412,1),(1583,433814412,2),(1583,452214012,1),(1583,465436812,2),(1583,483750012,1),(1583,496972813,2),(1583,515286013,1),(1583,528508813,2),(1583,546822013,1),(1583,560044813,2),(1583,578444414,1),(1583,591667214,2),(1583,610412414,1),(1583,623203214,2),(1583,641516415,1),(1583,654739215,2),(1583,673052416,1),(1583,686275216,2),(1583,704674816,1),(1583,717897617,2),(1583,736210817,1),(1583,749433618,2),(1583,767746818,1),(1583,780969619,2),(1583,799020019,3),(1583,812322019,2),(1583,830469620,3),(1583,843771620,2),(1583,861919220,3),(1583,875221221,2),(1583,893368821,3),(1583,906670821,2),(1583,925423222,3),(1583,938725222,2),(1583,956872822,3),(1583,970174822,2),(1583,988322422,3),(1583,1001624422,2),(1583,1019772022,3),(1583,1033074022,2),(1583,1051221622,3),(1583,1064523622,2),(1583,1083276022,3),(1583,1096578022,2),(1583,1114725622,3),(1583,1128027622,2),(1583,1146175223,3),(1583,1158872423,2),(1583,1177624823,3),(1583,1189112423,2),(1583,1209074423,3),(1583,1219957223,2),(1583,1240524024,3),(1583,1250802024,2),(1583,1272578424,3),(1583,1281474024,2),(1583,1284069624,1),(1583,1285880424,2),(1583,1400191225,1),(1583,1403816425,2),(1583,1406844025,1),(1583,1411678825,2),(1583,1682632827,1),(1583,1698354027,2),(1583,1714082427,1),(1583,1730408427,2),(1583,1745532027,1),(1583,1761858027,2),(1583,1776981627,1),(1583,1793307627,2),(1583,1809036027,1),(1583,1824757227,2),(1583,1840485627,1),(1583,1856206827,2),(1583,1871935227,1),(1583,1887656427,2),(1583,1903384827,1),(1583,1919710827,2),(1583,1934834427,1),(1583,1951160427,2),(1583,1966888827,1),(1583,1982610027,2),(1583,1998338427,1),(1583,2014059627,2),(1583,2029788027,1),(1583,2045509227,2),(1583,2061237627,1),(1583,2076958827,2),(1583,2092687227,1),(1583,2109013227,2),(1583,2124136827,1),(1583,2140462827,2),(1584,-2147483648,1),(1584,-1691962479,2),(1584,-1680471279,4),(1584,-1664143200,3),(1584,-1650146400,4),(1584,-1633903200,3),(1584,-1617487200,4),(1584,-1601848800,3),(1584,-1586037600,4),(1584,-1570399200,3),(1584,-1552168800,4),(1584,-1538344800,3),(1584,-1522533600,4),(1584,-1517011200,6),(1584,-1507500000,5),(1584,-1490565600,4),(1584,-1473631200,5),(1584,-1460930400,4),(1584,-1442786400,5),(1584,-1428876000,4),(1584,-1410732000,5),(1584,-1396216800,4),(1584,-1379282400,5),(1584,-1364767200,4),(1584,-1348437600,5),(1584,-1333317600,4),(1584,-1315778400,5),(1584,-1301263200,4),(1584,-1284328800,5),(1584,-1269813600,4),(1584,-1253484000,5),(1584,-1238364000,4),(1584,-1221429600,5),(1584,-1206914400,4),(1584,-1189980000,5),(1584,-1175464800,4),(1584,-1159135200,5),(1584,-1143410400,4),(1584,-1126476000,5),(1584,-1111960800,4),(1584,-1095631200,5),(1584,-1080511200,4),(1584,-1063576800,5),(1584,-1049061600,4),(1584,-1032127200,5),(1584,-1017612000,4),(1584,-1001282400,5),(1584,-986162400,4),(1584,-969228000,5),(1584,-950479200,4),(1584,-942012000,5),(1584,-733356000,4),(1584,-719445600,5),(1584,-699487200,4),(1584,-684972000,5),(1584,-668037600,4),(1584,-654732000,5),(1584,-636588000,4),(1584,-622072800,5),(1584,-605743200,4),(1584,-590623200,5),(1584,-574293600,4),(1584,-558568800,5),(1584,-542239200,4),(1584,-527119200,5),(1584,-512604000,4),(1584,-496274400,5),(1584,-481154400,4),(1584,-464220000,5),(1584,-449704800,4),(1584,-432165600,5),(1584,-417650400,4),(1584,-401320800,5),(1584,-386200800,4),(1584,-369266400,5),(1584,-354751200,4),(1584,-337816800,5),(1584,-323301600,4),(1584,-306972000,5),(1584,-291852000,4),(1584,-276732000,5),(1584,-257983200,4),(1584,-245282400,5),(1584,-226533600,4),(1584,-213228000,5),(1584,-195084000,4),(1584,-182383200,5),(1584,-163634400,4),(1584,-150933600,5),(1584,-132184800,4),(1584,-119484000,5),(1584,-100735200,4),(1584,-88034400,5),(1584,-68680800,4),(1584,-59004000,5),(1584,-37242000,7),(1584,57722400,9),(1584,69818400,5),(1584,89172001,4),(1584,101268002,5),(1584,120621602,4),(1584,132717603,5),(1584,152071203,4),(1584,164167204,5),(1584,183520804,4),(1584,196221605,5),(1584,214970405,4),(1584,227671206,5),(1584,246420006,4),(1584,259120807,5),(1584,278474407,4),(1584,290570408,5),(1584,309924008,4),(1584,322020009,5),(1584,341373609,4),(1584,354675609,8),(1584,372819610,9),(1584,386125210,8),(1584,404269211,9),(1584,417574811,8),(1584,435718812,9),(1584,449024412,8),(1584,467773212,9),(1584,481078812,8),(1584,499222813,9),(1584,512528413,8),(1584,530672413,9),(1584,543978013,8),(1584,562122013,9),(1584,575427614,8),(1584,593571614,9),(1584,606877214,8),(1584,625626014,9),(1584,638326815,8),(1584,657075615,9),(1584,670381216,8),(1584,688525216,9),(1584,701830816,8),(1584,719974817,9),(1584,733280417,8),(1584,751424418,9),(1584,764730018,8),(1584,782874019,9),(1584,796179619,8),(1584,814323619,9),(1584,820454420,6),(1584,828234020,8),(1584,846378020,9),(1584,859683620,8),(1584,877827621,9),(1584,891133221,8),(1584,909277221,9),(1584,922582822,8),(1584,941331622,9),(1584,954032422,8),(1584,972781222,9),(1584,985482022,8),(1584,1004230822,9),(1584,1017536422,8),(1584,1035680422,9),(1584,1048986022,8),(1584,1067130022,9),(1584,1080435622,8),(1584,1099184422,9),(1584,1111885222,8),(1584,1130634022,9),(1584,1143334823,8),(1584,1162083623,9),(1584,1174784423,8),(1584,1193533223,9),(1584,1206838823,8),(1584,1224982823,9),(1584,1238288424,8),(1584,1256432424,9),(1584,1269738024,8),(1584,1288486824,9),(1584,1301187624,8),(1584,1319936424,9),(1584,1332637224,8),(1584,1351386025,9),(1584,1364691625,8),(1584,1382835625,9),(1584,1396141225,8),(1584,1414285225,9),(1584,1427590825,8),(1584,1445734826,9),(1584,1459040426,8),(1584,1477789226,9),(1584,1490490027,8),(1584,1509238827,9),(1584,1521939627,8),(1584,1540688427,9),(1584,1553994027,8),(1584,1572138027,9),(1584,1585443627,8),(1584,1603587627,9),(1584,1616893227,8),(1584,1635642027,9),(1584,1648342827,8),(1584,1667091627,9),(1584,1679792427,8),(1584,1698541227,9),(1584,1711846827,8),(1584,1729990827,9),(1584,1743296427,8),(1584,1761440427,9),(1584,1774746027,8),(1584,1792890027,9),(1584,1806195627,8),(1584,1824944427,9),(1584,1837645227,8),(1584,1856394027,9),(1584,1869094827,8),(1584,1887843627,9),(1584,1901149227,8),(1584,1919293227,9),(1584,1932598827,8),(1584,1950742827,9),(1584,1964048427,8),(1584,1982797227,9),(1584,1995498027,8),(1584,2014246827,9),(1584,2026947627,8),(1584,2045696427,9),(1584,2058397227,8),(1584,2077146027,9),(1584,2090451627,8),(1584,2108595627,9),(1584,2121901227,8),(1584,2140045227,9),(1620,-2147483648,1),(1620,-1740355200,2),(1620,-1693702800,5),(1620,-1680483600,2),(1620,-1663455600,3),(1620,-1650150000,4),(1620,-1632006000,3),(1620,-1618700400,4),(1620,-1613826000,8),(1620,-1604278800,6),(1620,-1585530000,7),(1620,-1574038800,6),(1620,-1552266000,7),(1620,-1539997200,6),(1620,-1520557200,7),(1620,-1507510800,6),(1620,-1490576400,7),(1620,-1473642000,6),(1620,-1459126800,7),(1620,-1444006800,6),(1620,-1427677200,7),(1620,-1411952400,6),(1620,-1396227600,7),(1620,-1379293200,6),(1620,-1364778000,7),(1620,-1348448400,6),(1620,-1333328400,7),(1620,-1316394000,6),(1620,-1301263200,7),(1620,-1284328800,6),(1620,-1269813600,7),(1620,-1253484000,6),(1620,-1238364000,7),(1620,-1221429600,6),(1620,-1206914400,7),(1620,-1191189600,6),(1620,-1175464800,7),(1620,-1160344800,6),(1620,-1143410400,7),(1620,-1127685600,6),(1620,-1111960800,7),(1620,-1096840800,6),(1620,-1080511200,7),(1620,-1063576800,6),(1620,-1049061600,7),(1620,-1033336800,6),(1620,-1017612000,7),(1620,-1002492000,6),(1620,-986162400,7),(1620,-969228000,6),(1620,-950479200,7),(1620,-942012000,6),(1620,-934668000,3),(1620,-857257200,4),(1620,-844556400,3),(1620,-828226800,4),(1620,-812502000,3),(1620,-799293600,5),(1620,-798073200,4),(1620,-781052400,3),(1620,-766623600,4),(1620,-745455600,3),(1620,-733273200,4),(1620,220921205,2),(1620,228877206,9),(1620,243997206,10),(1620,260326807,9),(1620,276051607,10),(1620,291776408,9),(1620,307501208,10),(1620,323830809,9),(1620,338950809,10),(1620,354675609,9),(1620,370400410,10),(1620,386125210,9),(1620,401850011,10),(1620,417574811,9),(1620,433299612,10),(1620,449024412,9),(1620,465354012,10),(1620,481078812,9),(1620,496803613,10),(1620,512528413,9),(1620,528253213,10),(1620,543978013,9),(1620,559702813,10),(1620,575427614,9),(1620,591152414,10),(1620,606877214,9),(1620,622602014,10),(1620,638326815,9),(1620,654656415,10),(1620,670381216,9),(1620,686106016,10),(1620,701830816,9),(1620,717555617,10),(1620,733280417,9),(1620,749005218,10),(1620,764730018,9),(1620,780454819,10),(1620,796179619,9),(1620,811904419,10),(1620,828234020,9),(1620,846378020,10),(1620,859683620,9),(1620,877827621,10),(1620,891133221,9),(1620,909277221,10),(1620,922582822,9),(1620,941331622,10),(1620,954032422,9),(1620,972781222,10),(1620,985482022,9),(1620,1004230822,10),(1620,1017536422,9),(1620,1035680422,10),(1620,1048986022,9),(1620,1067130022,10),(1620,1080435622,9),(1620,1099184422,10),(1620,1111885222,9),(1620,1130634022,10),(1620,1143334823,9),(1620,1162083623,10),(1620,1174784423,9),(1620,1193533223,10),(1620,1206838823,9),(1620,1224982823,10),(1620,1238288424,9),(1620,1256432424,10),(1620,1269738024,9),(1620,1288486824,10),(1620,1301187624,9),(1620,1319936424,10),(1620,1332637224,9),(1620,1351386025,10),(1620,1364691625,9),(1620,1382835625,10),(1620,1396141225,9),(1620,1414285225,10),(1620,1427590825,9),(1620,1445734826,10),(1620,1459040426,9),(1620,1477789226,10),(1620,1490490027,9),(1620,1509238827,10),(1620,1521939627,9),(1620,1540688427,10),(1620,1553994027,9),(1620,1572138027,10),(1620,1585443627,9),(1620,1603587627,10),(1620,1616893227,9),(1620,1635642027,10),(1620,1648342827,9),(1620,1667091627,10),(1620,1679792427,9),(1620,1698541227,10),(1620,1711846827,9),(1620,1729990827,10),(1620,1743296427,9),(1620,1761440427,10),(1620,1774746027,9),(1620,1792890027,10),(1620,1806195627,9),(1620,1824944427,10),(1620,1837645227,9),(1620,1856394027,10),(1620,1869094827,9),(1620,1887843627,10),(1620,1901149227,9),(1620,1919293227,10),(1620,1932598827,9),(1620,1950742827,10),(1620,1964048427,9),(1620,1982797227,10),(1620,1995498027,9),(1620,2014246827,10),(1620,2026947627,9),(1620,2045696427,10),(1620,2058397227,9),(1620,2077146027,10),(1620,2090451627,9),(1620,2108595627,10),(1620,2121901227,9),(1620,2140045227,10),(1621,-2147483648,1),(1621,-733881600,2),(1621,481078812,3),(1621,496803613,4),(1621,512528413,3),(1621,528253213,4),(1621,543978013,3),(1621,559702813,4),(1621,575427614,3),(1621,591152414,4),(1621,606877214,3),(1621,622602014,4),(1621,638326815,3),(1621,654656415,4),(1621,670381216,3),(1621,686106016,4),(1621,701830816,3),(1621,717555617,4),(1621,733280417,3),(1621,749005218,4),(1621,764730018,3),(1621,780454819,4),(1621,796179619,3),(1621,811904419,4),(1621,828234020,3),(1621,846378020,4),(1621,859683620,3),(1621,877827621,4),(1621,891133221,3),(1621,909277221,4),(1621,922582822,3),(1621,941331622,4),(1621,954032422,3),(1621,972781222,4),(1621,985482022,3),(1621,1004230822,4),(1621,1017536422,3),(1621,1035680422,4),(1621,1048986022,3),(1621,1067130022,4),(1621,1080435622,3),(1621,1099184422,4),(1621,1111885222,3),(1621,1130634022,4),(1621,1143334823,3),(1621,1162083623,4),(1621,1174784423,3),(1621,1193533223,4),(1621,1206838823,3),(1621,1224982823,4),(1621,1238288424,3),(1621,1256432424,4),(1621,1269738024,3),(1621,1288486824,4),(1621,1301187624,3),(1621,1319936424,4),(1621,1332637224,3),(1621,1351386025,4),(1621,1364691625,3),(1621,1382835625,4),(1621,1396141225,3),(1621,1414285225,4),(1621,1427590825,3),(1621,1445734826,4),(1621,1459040426,3),(1621,1477789226,4),(1621,1490490027,3),(1621,1509238827,4),(1621,1521939627,3),(1621,1540688427,4),(1621,1553994027,3),(1621,1572138027,4),(1621,1585443627,3),(1621,1603587627,4),(1621,1616893227,3),(1621,1635642027,4),(1621,1648342827,3),(1621,1667091627,4),(1621,1679792427,3),(1621,1698541227,4),(1621,1711846827,3),(1621,1729990827,4),(1621,1743296427,3),(1621,1761440427,4),(1621,1774746027,3),(1621,1792890027,4),(1621,1806195627,3),(1621,1824944427,4),(1621,1837645227,3),(1621,1856394027,4),(1621,1869094827,3),(1621,1887843627,4),(1621,1901149227,3),(1621,1919293227,4),(1621,1932598827,3),(1621,1950742827,4),(1621,1964048427,3),(1621,1982797227,4),(1621,1995498027,3),(1621,2014246827,4),(1621,2026947627,3),(1621,2045696427,4),(1621,2058397227,3),(1621,2077146027,4),(1621,2090451627,3),(1621,2108595627,4),(1621,2121901227,3),(1621,2140045227,4),(1622,-2147483648,0),(1622,-1441249932,1),(1622,-1247540400,3),(1622,354916809,2),(1622,370724410,3),(1622,386452810,2),(1622,402260411,3),(1622,417988811,2),(1622,433796412,3),(1622,449611212,2),(1622,465343212,4),(1622,481068012,5),(1622,496792813,4),(1622,512517613,5),(1622,528242413,4),(1622,543967213,5),(1622,559692013,4),(1622,575416814,5),(1622,591141614,4),(1622,606866414,6),(1622,622594814,7),(1622,638319615,6),(1622,654649215,7),(1622,670374016,4),(1622,701820016,6),(1622,717548417,7),(1622,733273217,6),(1622,748998018,7),(1622,764722818,6),(1622,780447619,7),(1622,796172419,6),(1622,811897219,7),(1622,828226820,6),(1622,846370820,7),(1622,859676420,6),(1622,877820421,7),(1622,891126021,6),(1622,909270021,7),(1622,922575622,6),(1622,941324422,7),(1622,954025222,6),(1622,972774022,7),(1622,985474822,6),(1622,1004223622,7),(1622,1017529222,6),(1622,1035673222,7),(1622,1048978822,6),(1622,1067122822,7),(1622,1080428422,6),(1622,1099177222,7),(1622,1111878022,6),(1622,1130626822,7),(1622,1143327623,6),(1622,1162076423,7),(1622,1174777223,6),(1622,1193526023,7),(1622,1206831623,6),(1622,1224975623,7),(1622,1238281224,6),(1622,1256425224,7),(1622,1269730824,6),(1622,1288479624,7),(1622,1301180424,4),(1622,1414274425,7),(1622,1459033226,4),(1623,-2147483648,1),(1623,-1686101632,3),(1623,-1182996000,2),(1623,-1178161200,3),(1623,-906861600,2),(1623,-904878000,5),(1623,-857257200,4),(1623,-844477200,5),(1623,-828237600,4),(1623,-812422800,3),(1623,-552362400,2),(1623,-541652400,3),(1623,166485604,6),(1623,186184804,7),(1623,198028805,6),(1623,213753605,7),(1623,228873606,6),(1623,244080006,7),(1623,260323207,6),(1623,275446807,3),(1623,291798008,2),(1623,307407608,3),(1623,323388009,2),(1623,338936409,3),(1623,354675609,8),(1623,370400410,9),(1623,386125210,8),(1623,401850011,9),(1623,417574811,8),(1623,433299612,9),(1623,449024412,8),(1623,465354012,9),(1623,481078812,8),(1623,496803613,9),(1623,512528413,8),(1623,528253213,9),(1623,543978013,8),(1623,559702813,9),(1623,575427614,8),(1623,591152414,9),(1623,606877214,8),(1623,622602014,9),(1623,638326815,8),(1623,654656415,9),(1623,670381216,8),(1623,686106016,9),(1623,701830816,8),(1623,717555617,9),(1623,733280417,8),(1623,749005218,9),(1623,764730018,8),(1623,780454819,9),(1623,796179619,8),(1623,811904419,9),(1623,828234020,8),(1623,846378020,9),(1623,859683620,8),(1623,877827621,9),(1623,891133221,8),(1623,909277221,9),(1623,922582822,8),(1623,941331622,9),(1623,954032422,8),(1623,972781222,9),(1623,985482022,8),(1623,1004230822,9),(1623,1017536422,8),(1623,1035680422,9),(1623,1048986022,8),(1623,1067130022,9),(1623,1080435622,8),(1623,1099184422,9),(1623,1111885222,8),(1623,1130634022,9),(1623,1143334823,8),(1623,1162083623,9),(1623,1174784423,8),(1623,1193533223,9),(1623,1206838823,8),(1623,1224982823,9),(1623,1238288424,8),(1623,1256432424,9),(1623,1269738024,8),(1623,1288486824,9),(1623,1301187624,8),(1623,1319936424,9),(1623,1332637224,8),(1623,1351386025,9),(1623,1364691625,8),(1623,1382835625,9),(1623,1396141225,8),(1623,1414285225,9),(1623,1427590825,8),(1623,1445734826,9),(1623,1459040426,8),(1623,1477789226,9),(1623,1490490027,8),(1623,1509238827,9),(1623,1521939627,8),(1623,1540688427,9),(1623,1553994027,8),(1623,1572138027,9),(1623,1585443627,8),(1623,1603587627,9),(1623,1616893227,8),(1623,1635642027,9),(1623,1648342827,8),(1623,1667091627,9),(1623,1679792427,8),(1623,1698541227,9),(1623,1711846827,8),(1623,1729990827,9),(1623,1743296427,8),(1623,1761440427,9),(1623,1774746027,8),(1623,1792890027,9),(1623,1806195627,8),(1623,1824944427,9),(1623,1837645227,8),(1623,1856394027,9),(1623,1869094827,8),(1623,1887843627,9),(1623,1901149227,8),(1623,1919293227,9),(1623,1932598827,8),(1623,1950742827,9),(1623,1964048427,8),(1623,1982797227,9),(1623,1995498027,8),(1623,2014246827,9),(1623,2026947627,8),(1623,2045696427,9),(1623,2058397227,8),(1623,2077146027,9),(1623,2090451627,8),(1623,2108595627,9),(1623,2121901227,8),(1623,2140045227,9),(1624,-2147483648,4),(1624,-1691964000,1),(1624,-1680472800,2),(1624,-1664143200,1),(1624,-1650146400,2),(1624,-1633903200,1),(1624,-1617487200,2),(1624,-1601848800,1),(1624,-1586037600,2),(1624,-1570399200,1),(1624,-1552168800,2),(1624,-1538344800,1),(1624,-1522533600,2),(1624,-1507500000,1),(1624,-1490565600,2),(1624,-1473631200,1),(1624,-1460930400,2),(1624,-1442786400,1),(1624,-1428876000,2),(1624,-1410732000,1),(1624,-1396216800,2),(1624,-1379282400,1),(1624,-1364767200,2),(1624,-1348437600,1),(1624,-1333317600,2),(1624,-1315778400,1),(1624,-1301263200,2),(1624,-1284328800,1),(1624,-1269813600,2),(1624,-1253484000,1),(1624,-1238364000,2),(1624,-1221429600,1),(1624,-1206914400,2),(1624,-1189980000,1),(1624,-1175464800,2),(1624,-1159135200,1),(1624,-1143410400,2),(1624,-1126476000,1),(1624,-1111960800,2),(1624,-1095631200,1),(1624,-1080511200,2),(1624,-1063576800,1),(1624,-1049061600,2),(1624,-1032127200,1),(1624,-1017612000,2),(1624,-1001282400,1),(1624,-986162400,2),(1624,-969228000,1),(1624,-950479200,2),(1624,-942012000,1),(1624,-904518000,3),(1624,-896050800,1),(1624,-875487600,3),(1624,-864601200,1),(1624,-844038000,3),(1624,-832546800,1),(1624,-812588400,3),(1624,-798073200,1),(1624,-781052400,3),(1624,-772066800,1),(1624,-764805600,2),(1624,-748476000,1),(1624,-733356000,2),(1624,-719445600,1),(1624,-717030000,3),(1624,-706748400,1),(1624,-699487200,2),(1624,-687996000,1),(1624,-668037600,2),(1624,-654732000,1),(1624,-636588000,2),(1624,-622072800,1),(1624,-605743200,2),(1624,-590623200,1),(1624,-574293600,2),(1624,-558568800,1),(1624,-542239200,2),(1624,-527119200,1),(1624,-512604000,2),(1624,-496274400,1),(1624,-481154400,2),(1624,-464220000,1),(1624,-449704800,2),(1624,-432165600,1),(1624,-417650400,2),(1624,-401320800,1),(1624,-386200800,2),(1624,-369266400,1),(1624,-354751200,2),(1624,-337816800,1),(1624,-323301600,2),(1624,-306972000,1),(1624,-291852000,2),(1624,-276732000,1),(1624,-257983200,2),(1624,-245282400,1),(1624,-226533600,2),(1624,-213228000,1),(1624,-195084000,2),(1624,-182383200,1),(1624,-163634400,2),(1624,-150933600,1),(1624,-132184800,2),(1624,-119484000,1),(1624,-100735200,2),(1624,-88034400,1),(1624,-68680800,2),(1624,-59004000,1),(1624,-37242000,5),(1624,57722400,7),(1624,69818400,1),(1624,89172001,2),(1624,101268002,1),(1624,120621602,2),(1624,132717603,1),(1624,152071203,2),(1624,164167204,1),(1624,183520804,2),(1624,196221605,1),(1624,214970405,2),(1624,227671206,1),(1624,246420006,2),(1624,259120807,1),(1624,278474407,2),(1624,290570408,1),(1624,309924008,2),(1624,322020009,1),(1624,341373609,2),(1624,354675609,6),(1624,372819610,7),(1624,386125210,6),(1624,404269211,7),(1624,417574811,6),(1624,435718812,7),(1624,449024412,6),(1624,467773212,7),(1624,481078812,6),(1624,499222813,7),(1624,512528413,6),(1624,530672413,7),(1624,543978013,6),(1624,562122013,7),(1624,575427614,6),(1624,593571614,7),(1624,606877214,6),(1624,625626014,7),(1624,638326815,6),(1624,657075615,7),(1624,670381216,6),(1624,688525216,7),(1624,701830816,6),(1624,719974817,7),(1624,733280417,6),(1624,751424418,7),(1624,764730018,6),(1624,782874019,7),(1624,796179619,6),(1624,814323619,7),(1624,820454420,4),(1624,828234020,6),(1624,846378020,7),(1624,859683620,6),(1624,877827621,7),(1624,891133221,6),(1624,909277221,7),(1624,922582822,6),(1624,941331622,7),(1624,954032422,6),(1624,972781222,7),(1624,985482022,6),(1624,1004230822,7),(1624,1017536422,6),(1624,1035680422,7),(1624,1048986022,6),(1624,1067130022,7),(1624,1080435622,6),(1624,1099184422,7),(1624,1111885222,6),(1624,1130634022,7),(1624,1143334823,6),(1624,1162083623,7),(1624,1174784423,6),(1624,1193533223,7),(1624,1206838823,6),(1624,1224982823,7),(1624,1238288424,6),(1624,1256432424,7),(1624,1269738024,6),(1624,1288486824,7),(1624,1301187624,6),(1624,1319936424,7),(1624,1332637224,6),(1624,1351386025,7),(1624,1364691625,6),(1624,1382835625,7),(1624,1396141225,6),(1624,1414285225,7),(1624,1427590825,6),(1624,1445734826,7),(1624,1459040426,6),(1624,1477789226,7),(1624,1490490027,6),(1624,1509238827,7),(1624,1521939627,6),(1624,1540688427,7),(1624,1553994027,6),(1624,1572138027,7),(1624,1585443627,6),(1624,1603587627,7),(1624,1616893227,6),(1624,1635642027,7),(1624,1648342827,6),(1624,1667091627,7),(1624,1679792427,6),(1624,1698541227,7),(1624,1711846827,6),(1624,1729990827,7),(1624,1743296427,6),(1624,1761440427,7),(1624,1774746027,6),(1624,1792890027,7),(1624,1806195627,6),(1624,1824944427,7),(1624,1837645227,6),(1624,1856394027,7),(1624,1869094827,6),(1624,1887843627,7),(1624,1901149227,6),(1624,1919293227,7),(1624,1932598827,6),(1624,1950742827,7),(1624,1964048427,6),(1624,1982797227,7),(1624,1995498027,6),(1624,2014246827,7),(1624,2026947627,6),(1624,2045696427,7),(1624,2058397227,6),(1624,2077146027,7),(1624,2090451627,6),(1624,2108595627,7),(1624,2121901227,6),(1624,2140045227,7),(1625,-2147483648,1),(1625,-905824800,4),(1625,-857257200,2),(1625,-844556400,3),(1625,-828226800,2),(1625,-812502000,3),(1625,-796777200,2),(1625,-788922000,1),(1625,-777942000,3),(1625,-766623600,2),(1625,407199611,1),(1625,417574811,5),(1625,433299612,6),(1625,449024412,5),(1625,465354012,6),(1625,481078812,5),(1625,496803613,6),(1625,512528413,5),(1625,528253213,6),(1625,543978013,5),(1625,559702813,6),(1625,575427614,5),(1625,591152414,6),(1625,606877214,5),(1625,622602014,6),(1625,638326815,5),(1625,654656415,6),(1625,670381216,5),(1625,686106016,6),(1625,701830816,5),(1625,717555617,6),(1625,733280417,5),(1625,749005218,6),(1625,764730018,5),(1625,780454819,6),(1625,796179619,5),(1625,811904419,6),(1625,828234020,5),(1625,846378020,6),(1625,859683620,5),(1625,877827621,6),(1625,891133221,5),(1625,909277221,6),(1625,922582822,5),(1625,941331622,6),(1625,954032422,5),(1625,972781222,6),(1625,985482022,5),(1625,1004230822,6),(1625,1017536422,5),(1625,1035680422,6),(1625,1048986022,5),(1625,1067130022,6),(1625,1080435622,5),(1625,1099184422,6),(1625,1111885222,5),(1625,1130634022,6),(1625,1143334823,5),(1625,1162083623,6),(1625,1174784423,5),(1625,1193533223,6),(1625,1206838823,5),(1625,1224982823,6),(1625,1238288424,5),(1625,1256432424,6),(1625,1269738024,5),(1625,1288486824,6),(1625,1301187624,5),(1625,1319936424,6),(1625,1332637224,5),(1625,1351386025,6),(1625,1364691625,5),(1625,1382835625,6),(1625,1396141225,5),(1625,1414285225,6),(1625,1427590825,5),(1625,1445734826,6),(1625,1459040426,5),(1625,1477789226,6),(1625,1490490027,5),(1625,1509238827,6),(1625,1521939627,5),(1625,1540688427,6),(1625,1553994027,5),(1625,1572138027,6),(1625,1585443627,5),(1625,1603587627,6),(1625,1616893227,5),(1625,1635642027,6),(1625,1648342827,5),(1625,1667091627,6),(1625,1679792427,5),(1625,1698541227,6),(1625,1711846827,5),(1625,1729990827,6),(1625,1743296427,5),(1625,1761440427,6),(1625,1774746027,5),(1625,1792890027,6),(1625,1806195627,5),(1625,1824944427,6),(1625,1837645227,5),(1625,1856394027,6),(1625,1869094827,5),(1625,1887843627,6),(1625,1901149227,5),(1625,1919293227,6),(1625,1932598827,5),(1625,1950742827,6),(1625,1964048427,5),(1625,1982797227,6),(1625,1995498027,5),(1625,2014246827,6),(1625,2026947627,5),(1625,2045696427,6),(1625,2058397227,5),(1625,2077146027,6),(1625,2090451627,5),(1625,2108595627,6),(1625,2121901227,5),(1625,2140045227,6),(1626,-2147483648,2),(1626,-1693706400,1),(1626,-1680483600,2),(1626,-1663455600,3),(1626,-1650150000,4),(1626,-1632006000,3),(1626,-1618700400,4),(1626,-938905200,3),(1626,-857257200,4),(1626,-844556400,3),(1626,-828226800,4),(1626,-812502000,3),(1626,-796777200,4),(1626,-781052400,3),(1626,-776563200,5),(1626,-765936000,1),(1626,-761180400,4),(1626,-757386000,2),(1626,-748479600,3),(1626,-733273200,4),(1626,-717631200,3),(1626,-714610800,6),(1626,-710380800,1),(1626,-701910000,4),(1626,-684975600,3),(1626,-670460400,4),(1626,-654130800,3),(1626,-639010800,4),(1626,315529208,2),(1626,323830809,7),(1626,338950809,8),(1626,354675609,7),(1626,370400410,8),(1626,386125210,7),(1626,401850011,8),(1626,417574811,7),(1626,433299612,8),(1626,449024412,7),(1626,465354012,8),(1626,481078812,7),(1626,496803613,8),(1626,512528413,7),(1626,528253213,8),(1626,543978013,7),(1626,559702813,8),(1626,575427614,7),(1626,591152414,8),(1626,606877214,7),(1626,622602014,8),(1626,638326815,7),(1626,654656415,8),(1626,670381216,7),(1626,686106016,8),(1626,701830816,7),(1626,717555617,8),(1626,733280417,7),(1626,749005218,8),(1626,764730018,7),(1626,780454819,8),(1626,796179619,7),(1626,811904419,8),(1626,828234020,7),(1626,846378020,8),(1626,859683620,7),(1626,877827621,8),(1626,891133221,7),(1626,909277221,8),(1626,922582822,7),(1626,941331622,8),(1626,954032422,7),(1626,972781222,8),(1626,985482022,7),(1626,1004230822,8),(1626,1017536422,7),(1626,1035680422,8),(1626,1048986022,7),(1626,1067130022,8),(1626,1080435622,7),(1626,1099184422,8),(1626,1111885222,7),(1626,1130634022,8),(1626,1143334823,7),(1626,1162083623,8),(1626,1174784423,7),(1626,1193533223,8),(1626,1206838823,7),(1626,1224982823,8),(1626,1238288424,7),(1626,1256432424,8),(1626,1269738024,7),(1626,1288486824,8),(1626,1301187624,7),(1626,1319936424,8),(1626,1332637224,7),(1626,1351386025,8),(1626,1364691625,7),(1626,1382835625,8),(1626,1396141225,7),(1626,1414285225,8),(1626,1427590825,7),(1626,1445734826,8),(1626,1459040426,7),(1626,1477789226,8),(1626,1490490027,7),(1626,1509238827,8),(1626,1521939627,7),(1626,1540688427,8),(1626,1553994027,7),(1626,1572138027,8),(1626,1585443627,7),(1626,1603587627,8),(1626,1616893227,7),(1626,1635642027,8),(1626,1648342827,7),(1626,1667091627,8),(1626,1679792427,7),(1626,1698541227,8),(1626,1711846827,7),(1626,1729990827,8),(1626,1743296427,7),(1626,1761440427,8),(1626,1774746027,7),(1626,1792890027,8),(1626,1806195627,7),(1626,1824944427,8),(1626,1837645227,7),(1626,1856394027,8),(1626,1869094827,7),(1626,1887843627,8),(1626,1901149227,7),(1626,1919293227,8),(1626,1932598827,7),(1626,1950742827,8),(1626,1964048427,7),(1626,1982797227,8),(1626,1995498027,7),(1626,2014246827,8),(1626,2026947627,7),(1626,2045696427,8),(1626,2058397227,7),(1626,2077146027,8),(1626,2090451627,7),(1626,2108595627,8),(1626,2121901227,7),(1626,2140045227,8),(1627,-2147483648,2),(1627,-1693706400,1),(1627,-1680483600,2),(1627,-1663455600,3),(1627,-1650150000,4),(1627,-1632006000,3),(1627,-1618700400,4),(1627,-938905200,3),(1627,-857257200,4),(1627,-844556400,3),(1627,-828226800,4),(1627,-812502000,3),(1627,-796777200,4),(1627,-781052400,3),(1627,-777866400,1),(1627,-765327600,4),(1627,-746578800,3),(1627,-733359600,4),(1627,-728517600,5),(1627,-721260000,2),(1627,-716425200,3),(1627,-701910000,4),(1627,-684975600,3),(1627,-670460400,4),(1627,-654217200,3),(1627,-639010800,4),(1627,283993207,2),(1627,291776408,6),(1627,307501208,7),(1627,323830809,6),(1627,338950809,7),(1627,354675609,6),(1627,370400410,7),(1627,386125210,6),(1627,401850011,7),(1627,417574811,6),(1627,433299612,7),(1627,449024412,6),(1627,465354012,7),(1627,481078812,6),(1627,496803613,7),(1627,512528413,6),(1627,528253213,7),(1627,543978013,6),(1627,559702813,7),(1627,575427614,6),(1627,591152414,7),(1627,606877214,6),(1627,622602014,7),(1627,638326815,6),(1627,654656415,7),(1627,670381216,6),(1627,686106016,7),(1627,701830816,6),(1627,717555617,7),(1627,733280417,6),(1627,749005218,7),(1627,764730018,6),(1627,780454819,7),(1627,796179619,6),(1627,811904419,7),(1627,828234020,6),(1627,846378020,7),(1627,859683620,6),(1627,877827621,7),(1627,891133221,6),(1627,909277221,7),(1627,922582822,6),(1627,941331622,7),(1627,954032422,6),(1627,972781222,7),(1627,985482022,6),(1627,1004230822,7),(1627,1017536422,6),(1627,1035680422,7),(1627,1048986022,6),(1627,1067130022,7),(1627,1080435622,6),(1627,1099184422,7),(1627,1111885222,6),(1627,1130634022,7),(1627,1143334823,6),(1627,1162083623,7),(1627,1174784423,6),(1627,1193533223,7),(1627,1206838823,6),(1627,1224982823,7),(1627,1238288424,6),(1627,1256432424,7),(1627,1269738024,6),(1627,1288486824,7),(1627,1301187624,6),(1627,1319936424,7),(1627,1332637224,6),(1627,1351386025,7),(1627,1364691625,6),(1627,1382835625,7),(1627,1396141225,6),(1627,1414285225,7),(1627,1427590825,6),(1627,1445734826,7),(1627,1459040426,6),(1627,1477789226,7),(1627,1490490027,6),(1627,1509238827,7),(1627,1521939627,6),(1627,1540688427,7),(1627,1553994027,6),(1627,1572138027,7),(1627,1585443627,6),(1627,1603587627,7),(1627,1616893227,6),(1627,1635642027,7),(1627,1648342827,6),(1627,1667091627,7),(1627,1679792427,6),(1627,1698541227,7),(1627,1711846827,6),(1627,1729990827,7),(1627,1743296427,6),(1627,1761440427,7),(1627,1774746027,6),(1627,1792890027,7),(1627,1806195627,6),(1627,1824944427,7),(1627,1837645227,6),(1627,1856394027,7),(1627,1869094827,6),(1627,1887843627,7),(1627,1901149227,6),(1627,1919293227,7),(1627,1932598827,6),(1627,1950742827,7),(1627,1964048427,6),(1627,1982797227,7),(1627,1995498027,6),(1627,2014246827,7),(1627,2026947627,6),(1627,2045696427,7),(1627,2058397227,6),(1627,2077146027,7),(1627,2090451627,6),(1627,2108595627,7),(1627,2121901227,6),(1627,2140045227,7),(1628,-2147483648,1),(1628,-1740355200,2),(1628,-1693702800,5),(1628,-1680483600,2),(1628,-1663455600,3),(1628,-1650150000,4),(1628,-1632006000,3),(1628,-1618700400,4),(1628,-1613826000,8),(1628,-1604278800,6),(1628,-1585530000,7),(1628,-1574038800,6),(1628,-1552266000,7),(1628,-1539997200,6),(1628,-1520557200,7),(1628,-1507510800,6),(1628,-1490576400,7),(1628,-1473642000,6),(1628,-1459126800,7),(1628,-1444006800,6),(1628,-1427677200,7),(1628,-1411952400,6),(1628,-1396227600,7),(1628,-1379293200,6),(1628,-1364778000,7),(1628,-1348448400,6),(1628,-1333328400,7),(1628,-1316394000,6),(1628,-1301263200,7),(1628,-1284328800,6),(1628,-1269813600,7),(1628,-1253484000,6),(1628,-1238364000,7),(1628,-1221429600,6),(1628,-1206914400,7),(1628,-1191189600,6),(1628,-1175464800,7),(1628,-1160344800,6),(1628,-1143410400,7),(1628,-1127685600,6),(1628,-1111960800,7),(1628,-1096840800,6),(1628,-1080511200,7),(1628,-1063576800,6),(1628,-1049061600,7),(1628,-1033336800,6),(1628,-1017612000,7),(1628,-1002492000,6),(1628,-986162400,7),(1628,-969228000,6),(1628,-950479200,7),(1628,-942012000,6),(1628,-934668000,3),(1628,-857257200,4),(1628,-844556400,3),(1628,-828226800,4),(1628,-812502000,3),(1628,-799293600,5),(1628,-798073200,4),(1628,-781052400,3),(1628,-766623600,4),(1628,-745455600,3),(1628,-733273200,4),(1628,220921205,2),(1628,228877206,9),(1628,243997206,10),(1628,260326807,9),(1628,276051607,10),(1628,291776408,9),(1628,307501208,10),(1628,323830809,9),(1628,338950809,10),(1628,354675609,9),(1628,370400410,10),(1628,386125210,9),(1628,401850011,10),(1628,417574811,9),(1628,433299612,10),(1628,449024412,9),(1628,465354012,10),(1628,481078812,9),(1628,496803613,10),(1628,512528413,9),(1628,528253213,10),(1628,543978013,9),(1628,559702813,10),(1628,575427614,9),(1628,591152414,10),(1628,606877214,9),(1628,622602014,10),(1628,638326815,9),(1628,654656415,10),(1628,670381216,9),(1628,686106016,10),(1628,701830816,9),(1628,717555617,10),(1628,733280417,9),(1628,749005218,10),(1628,764730018,9),(1628,780454819,10),(1628,796179619,9),(1628,811904419,10),(1628,828234020,9),(1628,846378020,10),(1628,859683620,9),(1628,877827621,10),(1628,891133221,9),(1628,909277221,10),(1628,922582822,9),(1628,941331622,10),(1628,954032422,9),(1628,972781222,10),(1628,985482022,9),(1628,1004230822,10),(1628,1017536422,9),(1628,1035680422,10),(1628,1048986022,9),(1628,1067130022,10),(1628,1080435622,9),(1628,1099184422,10),(1628,1111885222,9),(1628,1130634022,10),(1628,1143334823,9),(1628,1162083623,10),(1628,1174784423,9),(1628,1193533223,10),(1628,1206838823,9),(1628,1224982823,10),(1628,1238288424,9),(1628,1256432424,10),(1628,1269738024,9),(1628,1288486824,10),(1628,1301187624,9),(1628,1319936424,10),(1628,1332637224,9),(1628,1351386025,10),(1628,1364691625,9),(1628,1382835625,10),(1628,1396141225,9),(1628,1414285225,10),(1628,1427590825,9),(1628,1445734826,10),(1628,1459040426,9),(1628,1477789226,10),(1628,1490490027,9),(1628,1509238827,10),(1628,1521939627,9),(1628,1540688427,10),(1628,1553994027,9),(1628,1572138027,10),(1628,1585443627,9),(1628,1603587627,10),(1628,1616893227,9),(1628,1635642027,10),(1628,1648342827,9),(1628,1667091627,10),(1628,1679792427,9),(1628,1698541227,10),(1628,1711846827,9),(1628,1729990827,10),(1628,1743296427,9),(1628,1761440427,10),(1628,1774746027,9),(1628,1792890027,10),(1628,1806195627,9),(1628,1824944427,10),(1628,1837645227,9),(1628,1856394027,10),(1628,1869094827,9),(1628,1887843627,10),(1628,1901149227,9),(1628,1919293227,10),(1628,1932598827,9),(1628,1950742827,10),(1628,1964048427,9),(1628,1982797227,10),(1628,1995498027,9),(1628,2014246827,10),(1628,2026947627,9),(1628,2045696427,10),(1628,2058397227,9),(1628,2077146027,10),(1628,2090451627,9),(1628,2108595627,10),(1628,2121901227,9),(1628,2140045227,10),(1629,-2147483648,1),(1629,-1213148664,5),(1629,-1187056800,2),(1629,-1175479200,3),(1629,-1159754400,2),(1629,-1144029600,3),(1629,-1127700000,2),(1629,-1111975200,3),(1629,-1096250400,2),(1629,-1080525600,3),(1629,-1064800800,2),(1629,-1049076000,3),(1629,-1033351200,2),(1629,-1017626400,3),(1629,-1001901600,2),(1629,-986176800,3),(1629,-970452000,2),(1629,-954727200,3),(1629,296604008,4),(1629,307486808,5),(1629,323816409,4),(1629,338940009,5),(1629,354672009,2),(1629,370396810,3),(1629,386121610,2),(1629,401846411,3),(1629,417571211,2),(1629,433296012,3),(1629,449020812,2),(1629,465350412,3),(1629,481075212,2),(1629,496800013,3),(1629,512524813,2),(1629,528249613,3),(1629,543974413,2),(1629,559699213,3),(1629,575424014,2),(1629,591148814,3),(1629,606873614,2),(1629,622598414,3),(1629,638323215,2),(1629,654652815,3),(1629,662680815,5),(1629,670370416,2),(1629,686095216,3),(1629,701820016,2),(1629,717544817,3),(1629,733269617,2),(1629,748994418,3),(1629,757375218,5),(1629,764719218,4),(1629,780440419,5),(1629,796168819,4),(1629,811890019,5),(1629,828223220,4),(1629,846363620,5),(1629,859683620,6),(1629,877827621,7),(1629,891133221,6),(1629,909277221,7),(1629,922582822,6),(1629,941331622,7),(1629,954032422,6),(1629,972781222,7),(1629,985482022,6),(1629,1004230822,7),(1629,1017536422,6),(1629,1035680422,7),(1629,1048986022,6),(1629,1067130022,7),(1629,1080435622,6),(1629,1099184422,7),(1629,1111885222,6),(1629,1130634022,7),(1629,1143334823,6),(1629,1162083623,7),(1629,1174784423,6),(1629,1193533223,7),(1629,1206838823,6),(1629,1224982823,7),(1629,1238288424,6),(1629,1256432424,7),(1629,1269738024,6),(1629,1288486824,7),(1629,1301187624,6),(1629,1319936424,7),(1629,1332637224,6),(1629,1351386025,7),(1629,1364691625,6),(1629,1382835625,7),(1629,1396141225,6),(1629,1414285225,7),(1629,1427590825,6),(1629,1445734826,7),(1629,1459040426,6),(1629,1477789226,7),(1629,1490490027,6),(1629,1509238827,7),(1629,1521939627,6),(1629,1540688427,7),(1629,1553994027,6),(1629,1572138027,7),(1629,1585443627,6),(1629,1603587627,7),(1629,1616893227,6),(1629,1635642027,7),(1629,1648342827,6),(1629,1667091627,7),(1629,1679792427,6),(1629,1698541227,7),(1629,1711846827,6),(1629,1729990827,7),(1629,1743296427,6),(1629,1761440427,7),(1629,1774746027,6),(1629,1792890027,7),(1629,1806195627,6),(1629,1824944427,7),(1629,1837645227,6),(1629,1856394027,7),(1629,1869094827,6),(1629,1887843627,7),(1629,1901149227,6),(1629,1919293227,7),(1629,1932598827,6),(1629,1950742827,7),(1629,1964048427,6),(1629,1982797227,7),(1629,1995498027,6),(1629,2014246827,7),(1629,2026947627,6),(1629,2045696427,7),(1629,2058397227,6),(1629,2077146027,7),(1629,2090451627,6),(1629,2108595627,7),(1629,2121901227,6),(1629,2140045227,7),(1630,-2147483648,2),(1630,-1693706400,1),(1630,-1680483600,2),(1630,-1663455600,3),(1630,-1650150000,4),(1630,-1640998800,2),(1630,-1632006000,1),(1630,-1618700400,2),(1630,-1600470000,1),(1630,-1587250800,2),(1630,-1569711600,1),(1630,-1555196400,2),(1630,-906775200,1),(1630,-857257200,4),(1630,-844556400,3),(1630,-828226800,4),(1630,-812502000,3),(1630,-796777200,4),(1630,-788922000,2),(1630,-778471200,1),(1630,-762656400,2),(1630,-749689200,3),(1630,-733276800,2),(1630,-717634800,3),(1630,-701910000,4),(1630,-686185200,3),(1630,-670460400,4),(1630,-654130800,3),(1630,-639010800,4),(1630,-492656400,1),(1630,-481168800,2),(1630,-461199600,1),(1630,-449708400,2),(1630,-428540400,1),(1630,-418258800,2),(1630,-397090800,1),(1630,-386809200,2),(1630,323823609,1),(1630,338943609,2),(1630,354668409,1),(1630,370393210,2),(1630,386118010,1),(1630,401842811,2),(1630,417567611,1),(1630,433292412,2),(1630,449024412,5),(1630,465354012,6),(1630,481078812,5),(1630,496803613,6),(1630,512528413,5),(1630,528253213,6),(1630,543978013,5),(1630,559702813,6),(1630,575427614,5),(1630,591152414,6),(1630,606877214,5),(1630,622602014,6),(1630,638326815,5),(1630,654656415,6),(1630,670381216,5),(1630,686106016,6),(1630,701830816,5),(1630,717555617,6),(1630,733280417,5),(1630,749005218,6),(1630,764730018,5),(1630,780454819,6),(1630,796179619,5),(1630,811904419,6),(1630,828234020,5),(1630,846378020,6),(1630,859683620,5),(1630,877827621,6),(1630,891133221,5),(1630,909277221,6),(1630,922582822,5),(1630,941331622,6),(1630,954032422,5),(1630,972781222,6),(1630,985482022,5),(1630,1004230822,6),(1630,1017536422,5),(1630,1035680422,6),(1630,1048986022,5),(1630,1067130022,6),(1630,1080435622,5),(1630,1099184422,6),(1630,1111885222,5),(1630,1130634022,6),(1630,1143334823,5),(1630,1162083623,6),(1630,1174784423,5),(1630,1193533223,6),(1630,1206838823,5),(1630,1224982823,6),(1630,1238288424,5),(1630,1256432424,6),(1630,1269738024,5),(1630,1288486824,6),(1630,1301187624,5),(1630,1319936424,6),(1630,1332637224,5),(1630,1351386025,6),(1630,1364691625,5),(1630,1382835625,6),(1630,1396141225,5),(1630,1414285225,6),(1630,1427590825,5),(1630,1445734826,6),(1630,1459040426,5),(1630,1477789226,6),(1630,1490490027,5),(1630,1509238827,6),(1630,1521939627,5),(1630,1540688427,6),(1630,1553994027,5),(1630,1572138027,6),(1630,1585443627,5),(1630,1603587627,6),(1630,1616893227,5),(1630,1635642027,6),(1630,1648342827,5),(1630,1667091627,6),(1630,1679792427,5),(1630,1698541227,6),(1630,1711846827,5),(1630,1729990827,6),(1630,1743296427,5),(1630,1761440427,6),(1630,1774746027,5),(1630,1792890027,6),(1630,1806195627,5),(1630,1824944427,6),(1630,1837645227,5),(1630,1856394027,6),(1630,1869094827,5),(1630,1887843627,6),(1630,1901149227,5),(1630,1919293227,6),(1630,1932598827,5),(1630,1950742827,6),(1630,1964048427,5),(1630,1982797227,6),(1630,1995498027,5),(1630,2014246827,6),(1630,2026947627,5),(1630,2045696427,6),(1630,2058397227,5),(1630,2077146027,6),(1630,2090451627,5),(1630,2108595627,6),(1630,2121901227,5),(1630,2140045227,6),(1631,-2147483648,2),(1631,-904435200,1),(1631,-891129600,2),(1631,-872985600,1),(1631,-859680000,2),(1631,354675609,3),(1631,370400410,4),(1631,386125210,3),(1631,401850011,4),(1631,417574811,3),(1631,433299612,4),(1631,449024412,3),(1631,465354012,4),(1631,481078812,3),(1631,496803613,4),(1631,512528413,3),(1631,528253213,4),(1631,543978013,3),(1631,559702813,4),(1631,575427614,3),(1631,591152414,4),(1631,606877214,3),(1631,622602014,4),(1631,638326815,3),(1631,654656415,4),(1631,670381216,3),(1631,686106016,4),(1631,701830816,3),(1631,717555617,4),(1631,733280417,3),(1631,749005218,4),(1631,764730018,3),(1631,780454819,4),(1631,796179619,3),(1631,811904419,4),(1631,828234020,3),(1631,846378020,4),(1631,859683620,3),(1631,877827621,4),(1631,891133221,3),(1631,909277221,4),(1631,922582822,3),(1631,941331622,4),(1631,954032422,3),(1631,972781222,4),(1631,985482022,3),(1631,1004230822,4),(1631,1017536422,3),(1631,1035680422,4),(1631,1048986022,3),(1631,1067130022,4),(1631,1080435622,3),(1631,1099184422,4),(1631,1111885222,3),(1631,1130634022,4),(1631,1143334823,3),(1631,1162083623,4),(1631,1174784423,3),(1631,1193533223,4),(1631,1206838823,3),(1631,1224982823,4),(1631,1238288424,3),(1631,1256432424,4),(1631,1269738024,3),(1631,1288486824,4),(1631,1301187624,3),(1631,1319936424,4),(1631,1332637224,3),(1631,1351386025,4),(1631,1364691625,3),(1631,1382835625,4),(1631,1396141225,3),(1631,1414285225,4),(1631,1427590825,3),(1631,1445734826,4),(1631,1459040426,3),(1631,1477789226,4),(1631,1490490027,3),(1631,1509238827,4),(1631,1521939627,3),(1631,1540688427,4),(1631,1553994027,3),(1631,1572138027,4),(1631,1585443627,3),(1631,1603587627,4),(1631,1616893227,3),(1631,1635642027,4),(1631,1648342827,3),(1631,1667091627,4),(1631,1679792427,3),(1631,1698541227,4),(1631,1711846827,3),(1631,1729990827,4),(1631,1743296427,3),(1631,1761440427,4),(1631,1774746027,3),(1631,1792890027,4),(1631,1806195627,3),(1631,1824944427,4),(1631,1837645227,3),(1631,1856394027,4),(1631,1869094827,3),(1631,1887843627,4),(1631,1901149227,3),(1631,1919293227,4),(1631,1932598827,3),(1631,1950742827,4),(1631,1964048427,3),(1631,1982797227,4),(1631,1995498027,3),(1631,2014246827,4),(1631,2026947627,3),(1631,2045696427,4),(1631,2058397227,3),(1631,2077146027,4),(1631,2090451627,3),(1631,2108595627,4),(1631,2121901227,3),(1631,2140045227,4),(1632,-2147483648,1),(1632,-1637114100,2),(1632,-1213148664,5),(1632,-1187056800,3),(1632,-1175479200,4),(1632,-1159754400,3),(1632,-1144029600,4),(1632,-1127700000,3),(1632,-1111975200,4),(1632,-1096250400,3),(1632,-1080525600,4),(1632,-1064800800,3),(1632,-1049076000,4),(1632,-1033351200,3),(1632,-1017626400,4),(1632,-1001901600,3),(1632,-986176800,4),(1632,-970452000,3),(1632,-954727200,4),(1632,-927165600,6),(1632,-898138800,9),(1632,-857257200,7),(1632,-844556400,8),(1632,-828226800,7),(1632,-812502000,8),(1632,-800157600,11),(1632,354920409,10),(1632,370728010,11),(1632,386456410,10),(1632,402264011,11),(1632,417992411,10),(1632,433800012,11),(1632,449614812,10),(1632,465346812,12),(1632,481071612,13),(1632,496796413,12),(1632,512521213,13),(1632,528246013,12),(1632,543970813,13),(1632,559695613,12),(1632,575420414,13),(1632,591145214,12),(1632,606870014,13),(1632,622594814,12),(1632,638319615,13),(1632,641944815,6),(1632,654652815,4),(1632,670377616,3),(1632,686102416,4),(1632,694216816,5),(1632,701820016,6),(1632,717541217,5),(1632,733269617,6),(1632,748990818,5),(1632,764719218,6),(1632,780440419,5),(1632,796168819,6),(1632,811890019,5),(1632,828223220,6),(1632,846363620,5),(1632,859680020,6),(1632,877824021,5),(1632,891129621,6),(1632,909273621,5),(1632,922579222,6),(1632,941328022,5),(1632,954028822,6),(1632,972777622,5),(1632,985478422,6),(1632,1004227222,5),(1632,1017532822,6),(1632,1035676822,5),(1632,1048982422,6),(1632,1067126422,5),(1632,1080432022,6),(1632,1099180822,5),(1632,1111881622,6),(1632,1130630422,5),(1632,1143331223,6),(1632,1162080023,5),(1632,1174780823,6),(1632,1193529623,5),(1632,1206835223,6),(1632,1224979223,5),(1632,1238284824,6),(1632,1256428824,5),(1632,1269734424,6),(1632,1288483224,5),(1632,1301184024,6),(1632,1319932824,5),(1632,1332633624,6),(1632,1351382425,5),(1632,1364688025,6),(1632,1382832025,5),(1632,1396137625,6),(1632,1414281625,5),(1632,1427587225,6),(1632,1445731226,5),(1632,1459036826,6),(1632,1477785626,5),(1632,1490486427,6),(1632,1509235227,5),(1632,1521936027,6),(1632,1540684827,5),(1632,1553990427,6),(1632,1572134427,5),(1632,1585440027,6),(1632,1603584027,5),(1632,1616889627,6),(1632,1635638427,5),(1632,1648339227,6),(1632,1667088027,5),(1632,1679788827,6),(1632,1698537627,5),(1632,1711843227,6),(1632,1729987227,5),(1632,1743292827,6),(1632,1761436827,5),(1632,1774742427,6),(1632,1792886427,5),(1632,1806192027,6),(1632,1824940827,5),(1632,1837641627,6),(1632,1856390427,5),(1632,1869091227,6),(1632,1887840027,5),(1632,1901145627,6),(1632,1919289627,5),(1632,1932595227,6),(1632,1950739227,5),(1632,1964044827,6),(1632,1982793627,5),(1632,1995494427,6),(1632,2014243227,5),(1632,2026944027,6),(1632,2045692827,5),(1632,2058393627,6),(1632,2077142427,5),(1632,2090448027,6),(1632,2108592027,5),(1632,2121897627,6),(1632,2140041627,5),(1633,-2147483648,2),(1633,-1693706400,1),(1633,-1680483600,2),(1633,-1663455600,3),(1633,-1650150000,4),(1633,-1632006000,3),(1633,-1618700400,4),(1633,-938905200,3),(1633,-857257200,4),(1633,-844556400,3),(1633,-828226800,4),(1633,-812502000,3),(1633,-796777200,4),(1633,-781052400,3),(1633,-776563200,5),(1633,-765936000,1),(1633,-761180400,4),(1633,-757386000,2),(1633,-748479600,3),(1633,-733273200,4),(1633,-717631200,3),(1633,-714610800,6),(1633,-710380800,1),(1633,-701910000,4),(1633,-684975600,3),(1633,-670460400,4),(1633,-654130800,3),(1633,-639010800,4),(1633,315529208,2),(1633,323830809,7),(1633,338950809,8),(1633,354675609,7),(1633,370400410,8),(1633,386125210,7),(1633,401850011,8),(1633,417574811,7),(1633,433299612,8),(1633,449024412,7),(1633,465354012,8),(1633,481078812,7),(1633,496803613,8),(1633,512528413,7),(1633,528253213,8),(1633,543978013,7),(1633,559702813,8),(1633,575427614,7),(1633,591152414,8),(1633,606877214,7),(1633,622602014,8),(1633,638326815,7),(1633,654656415,8),(1633,670381216,7),(1633,686106016,8),(1633,701830816,7),(1633,717555617,8),(1633,733280417,7),(1633,749005218,8),(1633,764730018,7),(1633,780454819,8),(1633,796179619,7),(1633,811904419,8),(1633,828234020,7),(1633,846378020,8),(1633,859683620,7),(1633,877827621,8),(1633,891133221,7),(1633,909277221,8),(1633,922582822,7),(1633,941331622,8),(1633,954032422,7),(1633,972781222,8),(1633,985482022,7),(1633,1004230822,8),(1633,1017536422,7),(1633,1035680422,8),(1633,1048986022,7),(1633,1067130022,8),(1633,1080435622,7),(1633,1099184422,8),(1633,1111885222,7),(1633,1130634022,8),(1633,1143334823,7),(1633,1162083623,8),(1633,1174784423,7),(1633,1193533223,8),(1633,1206838823,7),(1633,1224982823,8),(1633,1238288424,7),(1633,1256432424,8),(1633,1269738024,7),(1633,1288486824,8),(1633,1301187624,7),(1633,1319936424,8),(1633,1332637224,7),(1633,1351386025,8),(1633,1364691625,7),(1633,1382835625,8),(1633,1396141225,7),(1633,1414285225,8),(1633,1427590825,7),(1633,1445734826,8),(1633,1459040426,7),(1633,1477789226,8),(1633,1490490027,7),(1633,1509238827,8),(1633,1521939627,7),(1633,1540688427,8),(1633,1553994027,7),(1633,1572138027,8),(1633,1585443627,7),(1633,1603587627,8),(1633,1616893227,7),(1633,1635642027,8),(1633,1648342827,7),(1633,1667091627,8),(1633,1679792427,7),(1633,1698541227,8),(1633,1711846827,7),(1633,1729990827,8),(1633,1743296427,7),(1633,1761440427,8),(1633,1774746027,7),(1633,1792890027,8),(1633,1806195627,7),(1633,1824944427,8),(1633,1837645227,7),(1633,1856394027,8),(1633,1869094827,7),(1633,1887843627,8),(1633,1901149227,7),(1633,1919293227,8),(1633,1932598827,7),(1633,1950742827,8),(1633,1964048427,7),(1633,1982797227,8),(1633,1995498027,7),(1633,2014246827,8),(1633,2026947627,7),(1633,2045696427,8),(1633,2058397227,7),(1633,2077146027,8),(1633,2090451627,7),(1633,2108595627,8),(1633,2121901227,7),(1633,2140045227,8),(1634,-2147483648,1),(1634,-1691962479,2),(1634,-1680471279,4),(1634,-1664143200,3),(1634,-1650146400,4),(1634,-1633903200,3),(1634,-1617487200,4),(1634,-1601848800,3),(1634,-1586037600,4),(1634,-1570399200,3),(1634,-1552168800,4),(1634,-1538344800,3),(1634,-1522533600,4),(1634,-1517011200,6),(1634,-1507500000,5),(1634,-1490565600,4),(1634,-1473631200,5),(1634,-1460930400,4),(1634,-1442786400,5),(1634,-1428876000,4),(1634,-1410732000,5),(1634,-1396216800,4),(1634,-1379282400,5),(1634,-1364767200,4),(1634,-1348437600,5),(1634,-1333317600,4),(1634,-1315778400,5),(1634,-1301263200,4),(1634,-1284328800,5),(1634,-1269813600,4),(1634,-1253484000,5),(1634,-1238364000,4),(1634,-1221429600,5),(1634,-1206914400,4),(1634,-1189980000,5),(1634,-1175464800,4),(1634,-1159135200,5),(1634,-1143410400,4),(1634,-1126476000,5),(1634,-1111960800,4),(1634,-1095631200,5),(1634,-1080511200,4),(1634,-1063576800,5),(1634,-1049061600,4),(1634,-1032127200,5),(1634,-1017612000,4),(1634,-1001282400,5),(1634,-986162400,4),(1634,-969228000,5),(1634,-950479200,4),(1634,-942012000,5),(1634,-733356000,4),(1634,-719445600,5),(1634,-699487200,4),(1634,-684972000,5),(1634,-668037600,4),(1634,-654732000,5),(1634,-636588000,4),(1634,-622072800,5),(1634,-605743200,4),(1634,-590623200,5),(1634,-574293600,4),(1634,-558568800,5),(1634,-542239200,4),(1634,-527119200,5),(1634,-512604000,4),(1634,-496274400,5),(1634,-481154400,4),(1634,-464220000,5),(1634,-449704800,4),(1634,-432165600,5),(1634,-417650400,4),(1634,-401320800,5),(1634,-386200800,4),(1634,-369266400,5),(1634,-354751200,4),(1634,-337816800,5),(1634,-323301600,4),(1634,-306972000,5),(1634,-291852000,4),(1634,-276732000,5),(1634,-257983200,4),(1634,-245282400,5),(1634,-226533600,4),(1634,-213228000,5),(1634,-195084000,4),(1634,-182383200,5),(1634,-163634400,4),(1634,-150933600,5),(1634,-132184800,4),(1634,-119484000,5),(1634,-100735200,4),(1634,-88034400,5),(1634,-68680800,4),(1634,-59004000,5),(1634,-37242000,7),(1634,57722400,9),(1634,69818400,5),(1634,89172001,4),(1634,101268002,5),(1634,120621602,4),(1634,132717603,5),(1634,152071203,4),(1634,164167204,5),(1634,183520804,4),(1634,196221605,5),(1634,214970405,4),(1634,227671206,5),(1634,246420006,4),(1634,259120807,5),(1634,278474407,4),(1634,290570408,5),(1634,309924008,4),(1634,322020009,5),(1634,341373609,4),(1634,354675609,8),(1634,372819610,9),(1634,386125210,8),(1634,404269211,9),(1634,417574811,8),(1634,435718812,9),(1634,449024412,8),(1634,467773212,9),(1634,481078812,8),(1634,499222813,9),(1634,512528413,8),(1634,530672413,9),(1634,543978013,8),(1634,562122013,9),(1634,575427614,8),(1634,593571614,9),(1634,606877214,8),(1634,625626014,9),(1634,638326815,8),(1634,657075615,9),(1634,670381216,8),(1634,688525216,9),(1634,701830816,8),(1634,719974817,9),(1634,733280417,8),(1634,751424418,9),(1634,764730018,8),(1634,782874019,9),(1634,796179619,8),(1634,814323619,9),(1634,820454420,6),(1634,828234020,8),(1634,846378020,9),(1634,859683620,8),(1634,877827621,9),(1634,891133221,8),(1634,909277221,9),(1634,922582822,8),(1634,941331622,9),(1634,954032422,8),(1634,972781222,9),(1634,985482022,8),(1634,1004230822,9),(1634,1017536422,8),(1634,1035680422,9),(1634,1048986022,8),(1634,1067130022,9),(1634,1080435622,8),(1634,1099184422,9),(1634,1111885222,8),(1634,1130634022,9),(1634,1143334823,8),(1634,1162083623,9),(1634,1174784423,8),(1634,1193533223,9),(1634,1206838823,8),(1634,1224982823,9),(1634,1238288424,8),(1634,1256432424,9),(1634,1269738024,8),(1634,1288486824,9),(1634,1301187624,8),(1634,1319936424,9),(1634,1332637224,8),(1634,1351386025,9),(1634,1364691625,8),(1634,1382835625,9),(1634,1396141225,8),(1634,1414285225,9),(1634,1427590825,8),(1634,1445734826,9),(1634,1459040426,8),(1634,1477789226,9),(1634,1490490027,8),(1634,1509238827,9),(1634,1521939627,8),(1634,1540688427,9),(1634,1553994027,8),(1634,1572138027,9),(1634,1585443627,8),(1634,1603587627,9),(1634,1616893227,8),(1634,1635642027,9),(1634,1648342827,8),(1634,1667091627,9),(1634,1679792427,8),(1634,1698541227,9),(1634,1711846827,8),(1634,1729990827,9),(1634,1743296427,8),(1634,1761440427,9),(1634,1774746027,8),(1634,1792890027,9),(1634,1806195627,8),(1634,1824944427,9),(1634,1837645227,8),(1634,1856394027,9),(1634,1869094827,8),(1634,1887843627,9),(1634,1901149227,8),(1634,1919293227,9),(1634,1932598827,8),(1634,1950742827,9),(1634,1964048427,8),(1634,1982797227,9),(1634,1995498027,8),(1634,2014246827,9),(1634,2026947627,8),(1634,2045696427,9),(1634,2058397227,8),(1634,2077146027,9),(1634,2090451627,8),(1634,2108595627,9),(1634,2121901227,8),(1634,2140045227,9),(1635,-2147483648,4),(1635,-1691964000,1),(1635,-1680472800,2),(1635,-1664143200,1),(1635,-1650146400,2),(1635,-1633903200,1),(1635,-1617487200,2),(1635,-1601848800,1),(1635,-1586037600,2),(1635,-1570399200,1),(1635,-1552168800,2),(1635,-1538344800,1),(1635,-1522533600,2),(1635,-1507500000,1),(1635,-1490565600,2),(1635,-1473631200,1),(1635,-1460930400,2),(1635,-1442786400,1),(1635,-1428876000,2),(1635,-1410732000,1),(1635,-1396216800,2),(1635,-1379282400,1),(1635,-1364767200,2),(1635,-1348437600,1),(1635,-1333317600,2),(1635,-1315778400,1),(1635,-1301263200,2),(1635,-1284328800,1),(1635,-1269813600,2),(1635,-1253484000,1),(1635,-1238364000,2),(1635,-1221429600,1),(1635,-1206914400,2),(1635,-1189980000,1),(1635,-1175464800,2),(1635,-1159135200,1),(1635,-1143410400,2),(1635,-1126476000,1),(1635,-1111960800,2),(1635,-1095631200,1),(1635,-1080511200,2),(1635,-1063576800,1),(1635,-1049061600,2),(1635,-1032127200,1),(1635,-1017612000,2),(1635,-1001282400,1),(1635,-986162400,2),(1635,-969228000,1),(1635,-950479200,2),(1635,-942012000,1),(1635,-904518000,3),(1635,-896050800,1),(1635,-875487600,3),(1635,-864601200,1),(1635,-844038000,3),(1635,-832546800,1),(1635,-812588400,3),(1635,-798073200,1),(1635,-781052400,3),(1635,-772066800,1),(1635,-764805600,2),(1635,-748476000,1),(1635,-733356000,2),(1635,-719445600,1),(1635,-717030000,3),(1635,-706748400,1),(1635,-699487200,2),(1635,-687996000,1),(1635,-668037600,2),(1635,-654732000,1),(1635,-636588000,2),(1635,-622072800,1),(1635,-605743200,2),(1635,-590623200,1),(1635,-574293600,2),(1635,-558568800,1),(1635,-542239200,2),(1635,-527119200,1),(1635,-512604000,2),(1635,-496274400,1),(1635,-481154400,2),(1635,-464220000,1),(1635,-449704800,2),(1635,-432165600,1),(1635,-417650400,2),(1635,-401320800,5),(1635,386125210,6),(1635,401850011,7),(1635,417574811,6),(1635,433299612,7),(1635,449024412,6),(1635,465354012,7),(1635,481078812,6),(1635,496803613,7),(1635,512528413,6),(1635,528253213,7),(1635,543978013,6),(1635,559702813,7),(1635,575427614,6),(1635,591152414,7),(1635,606877214,6),(1635,622602014,7),(1635,638326815,6),(1635,654656415,7),(1635,670381216,6),(1635,686106016,7),(1635,701830816,6),(1635,717555617,7),(1635,733280417,6),(1635,749005218,7),(1635,764730018,6),(1635,780454819,7),(1635,796179619,6),(1635,811904419,7),(1635,828234020,6),(1635,846378020,7),(1635,859683620,6),(1635,877827621,7),(1635,891133221,6),(1635,909277221,7),(1635,922582822,6),(1635,941331622,7),(1635,954032422,6),(1635,972781222,7),(1635,985482022,6),(1635,1004230822,7),(1635,1017536422,6),(1635,1035680422,7),(1635,1048986022,6),(1635,1067130022,7),(1635,1080435622,6),(1635,1099184422,7),(1635,1111885222,6),(1635,1130634022,7),(1635,1143334823,6),(1635,1162083623,7),(1635,1174784423,6),(1635,1193533223,7),(1635,1206838823,6),(1635,1224982823,7),(1635,1238288424,6),(1635,1256432424,7),(1635,1269738024,6),(1635,1288486824,7),(1635,1301187624,6),(1635,1319936424,7),(1635,1332637224,6),(1635,1351386025,7),(1635,1364691625,6),(1635,1382835625,7),(1635,1396141225,6),(1635,1414285225,7),(1635,1427590825,6),(1635,1445734826,7),(1635,1459040426,6),(1635,1477789226,7),(1635,1490490027,6),(1635,1509238827,7),(1635,1521939627,6),(1635,1540688427,7),(1635,1553994027,6),(1635,1572138027,7),(1635,1585443627,6),(1635,1603587627,7),(1635,1616893227,6),(1635,1635642027,7),(1635,1648342827,6),(1635,1667091627,7),(1635,1679792427,6),(1635,1698541227,7),(1635,1711846827,6),(1635,1729990827,7),(1635,1743296427,6),(1635,1761440427,7),(1635,1774746027,6),(1635,1792890027,7),(1635,1806195627,6),(1635,1824944427,7),(1635,1837645227,6),(1635,1856394027,7),(1635,1869094827,6),(1635,1887843627,7),(1635,1901149227,6),(1635,1919293227,7),(1635,1932598827,6),(1635,1950742827,7),(1635,1964048427,6),(1635,1982797227,7),(1635,1995498027,6),(1635,2014246827,7),(1635,2026947627,6),(1635,2045696427,7),(1635,2058397227,6),(1635,2077146027,7),(1635,2090451627,6),(1635,2108595627,7),(1635,2121901227,6),(1635,2140045227,7),(1636,-2147483648,4),(1636,-1691964000,1),(1636,-1680472800,2),(1636,-1664143200,1),(1636,-1650146400,2),(1636,-1633903200,1),(1636,-1617487200,2),(1636,-1601848800,1),(1636,-1586037600,2),(1636,-1570399200,1),(1636,-1552168800,2),(1636,-1538344800,1),(1636,-1522533600,2),(1636,-1507500000,1),(1636,-1490565600,2),(1636,-1473631200,1),(1636,-1460930400,2),(1636,-1442786400,1),(1636,-1428876000,2),(1636,-1410732000,1),(1636,-1396216800,2),(1636,-1379282400,1),(1636,-1364767200,2),(1636,-1348437600,1),(1636,-1333317600,2),(1636,-1315778400,1),(1636,-1301263200,2),(1636,-1284328800,1),(1636,-1269813600,2),(1636,-1253484000,1),(1636,-1238364000,2),(1636,-1221429600,1),(1636,-1206914400,2),(1636,-1189980000,1),(1636,-1175464800,2),(1636,-1159135200,1),(1636,-1143410400,2),(1636,-1126476000,1),(1636,-1111960800,2),(1636,-1095631200,1),(1636,-1080511200,2),(1636,-1063576800,1),(1636,-1049061600,2),(1636,-1032127200,1),(1636,-1017612000,2),(1636,-1001282400,1),(1636,-986162400,2),(1636,-969228000,1),(1636,-950479200,2),(1636,-942012000,1),(1636,-904518000,3),(1636,-896050800,1),(1636,-875487600,3),(1636,-864601200,1),(1636,-844038000,3),(1636,-832546800,1),(1636,-812588400,3),(1636,-798073200,1),(1636,-781052400,3),(1636,-772066800,1),(1636,-764805600,2),(1636,-748476000,1),(1636,-733356000,2),(1636,-719445600,1),(1636,-717030000,3),(1636,-706748400,1),(1636,-699487200,2),(1636,-687996000,1),(1636,-668037600,2),(1636,-654732000,1),(1636,-636588000,2),(1636,-622072800,1),(1636,-605743200,2),(1636,-590623200,1),(1636,-574293600,2),(1636,-558568800,1),(1636,-542239200,2),(1636,-527119200,1),(1636,-512604000,2),(1636,-496274400,1),(1636,-481154400,2),(1636,-464220000,1),(1636,-449704800,2),(1636,-432165600,1),(1636,-417650400,2),(1636,-401320800,1),(1636,-386200800,2),(1636,-369266400,1),(1636,-354751200,2),(1636,-337816800,1),(1636,-323301600,2),(1636,-306972000,1),(1636,-291852000,2),(1636,-276732000,1),(1636,-257983200,2),(1636,-245282400,1),(1636,-226533600,2),(1636,-213228000,1),(1636,-195084000,2),(1636,-182383200,1),(1636,-163634400,2),(1636,-150933600,1),(1636,-132184800,2),(1636,-119484000,1),(1636,-100735200,2),(1636,-88034400,1),(1636,-68680800,2),(1636,-59004000,1),(1636,-37242000,5),(1636,57722400,7),(1636,69818400,1),(1636,89172001,2),(1636,101268002,1),(1636,120621602,2),(1636,132717603,1),(1636,152071203,2),(1636,164167204,1),(1636,183520804,2),(1636,196221605,1),(1636,214970405,2),(1636,227671206,1),(1636,246420006,2),(1636,259120807,1),(1636,278474407,2),(1636,290570408,1),(1636,309924008,2),(1636,322020009,1),(1636,341373609,2),(1636,354675609,6),(1636,372819610,7),(1636,386125210,6),(1636,404269211,7),(1636,417574811,6),(1636,435718812,7),(1636,449024412,6),(1636,467773212,7),(1636,481078812,6),(1636,499222813,7),(1636,512528413,6),(1636,530672413,7),(1636,543978013,6),(1636,562122013,7),(1636,575427614,6),(1636,593571614,7),(1636,606877214,6),(1636,625626014,7),(1636,638326815,6),(1636,657075615,7),(1636,670381216,6),(1636,688525216,7),(1636,701830816,6),(1636,719974817,7),(1636,733280417,6),(1636,751424418,7),(1636,764730018,6),(1636,782874019,7),(1636,796179619,6),(1636,814323619,7),(1636,820454420,4),(1636,828234020,6),(1636,846378020,7),(1636,859683620,6),(1636,877827621,7),(1636,891133221,6),(1636,909277221,7),(1636,922582822,6),(1636,941331622,7),(1636,954032422,6),(1636,972781222,7),(1636,985482022,6),(1636,1004230822,7),(1636,1017536422,6),(1636,1035680422,7),(1636,1048986022,6),(1636,1067130022,7),(1636,1080435622,6),(1636,1099184422,7),(1636,1111885222,6),(1636,1130634022,7),(1636,1143334823,6),(1636,1162083623,7),(1636,1174784423,6),(1636,1193533223,7),(1636,1206838823,6),(1636,1224982823,7),(1636,1238288424,6),(1636,1256432424,7),(1636,1269738024,6),(1636,1288486824,7),(1636,1301187624,6),(1636,1319936424,7),(1636,1332637224,6),(1636,1351386025,7),(1636,1364691625,6),(1636,1382835625,7),(1636,1396141225,6),(1636,1414285225,7),(1636,1427590825,6),(1636,1445734826,7),(1636,1459040426,6),(1636,1477789226,7),(1636,1490490027,6),(1636,1509238827,7),(1636,1521939627,6),(1636,1540688427,7),(1636,1553994027,6),(1636,1572138027,7),(1636,1585443627,6),(1636,1603587627,7),(1636,1616893227,6),(1636,1635642027,7),(1636,1648342827,6),(1636,1667091627,7),(1636,1679792427,6),(1636,1698541227,7),(1636,1711846827,6),(1636,1729990827,7),(1636,1743296427,6),(1636,1761440427,7),(1636,1774746027,6),(1636,1792890027,7),(1636,1806195627,6),(1636,1824944427,7),(1636,1837645227,6),(1636,1856394027,7),(1636,1869094827,6),(1636,1887843627,7),(1636,1901149227,6),(1636,1919293227,7),(1636,1932598827,6),(1636,1950742827,7),(1636,1964048427,6),(1636,1982797227,7),(1636,1995498027,6),(1636,2014246827,7),(1636,2026947627,6),(1636,2045696427,7),(1636,2058397227,6),(1636,2077146027,7),(1636,2090451627,6),(1636,2108595627,7),(1636,2121901227,6),(1636,2140045227,7),(1637,-2147483648,1),(1637,-1535938789,3),(1637,-875671200,2),(1637,-859773600,3),(1637,354672009,2),(1637,370396810,3),(1637,386121610,2),(1637,401846411,3),(1637,417574811,4),(1637,433299612,5),(1637,449024412,4),(1637,465354012,5),(1637,481078812,4),(1637,496803613,5),(1637,512528413,4),(1637,528253213,5),(1637,543978013,4),(1637,559702813,5),(1637,575427614,4),(1637,591152414,5),(1637,606877214,4),(1637,622602014,5),(1637,638326815,4),(1637,654656415,5),(1637,670381216,4),(1637,686106016,5),(1637,701830816,4),(1637,717555617,5),(1637,733280417,4),(1637,749005218,5),(1637,764730018,4),(1637,780454819,5),(1637,796179619,4),(1637,811904419,5),(1637,828234020,4),(1637,846378020,5),(1637,859683620,4),(1637,877827621,5),(1637,891133221,4),(1637,909277221,5),(1637,922582822,4),(1637,941331622,5),(1637,954032422,4),(1637,972781222,5),(1637,985482022,4),(1637,1004230822,5),(1637,1017536422,4),(1637,1035680422,5),(1637,1048986022,4),(1637,1067130022,5),(1637,1080435622,4),(1637,1099184422,5),(1637,1111885222,4),(1637,1130634022,5),(1637,1143334823,4),(1637,1162083623,5),(1637,1174784423,4),(1637,1193533223,5),(1637,1206838823,4),(1637,1224982823,5),(1637,1238288424,4),(1637,1256432424,5),(1637,1269738024,4),(1637,1288486824,5),(1637,1301187624,4),(1637,1319936424,5),(1637,1332637224,4),(1637,1351386025,5),(1637,1364691625,4),(1637,1382835625,5),(1637,1396141225,4),(1637,1414285225,5),(1637,1427590825,4),(1637,1445734826,5),(1637,1459040426,4),(1637,1477789226,5),(1637,1490490027,4),(1637,1509238827,5),(1637,1521939627,4),(1637,1540688427,5),(1637,1553994027,4),(1637,1572138027,5),(1637,1585443627,4),(1637,1603587627,5),(1637,1616893227,4),(1637,1635642027,5),(1637,1648342827,4),(1637,1667091627,5),(1637,1679792427,4),(1637,1698541227,5),(1637,1711846827,4),(1637,1729990827,5),(1637,1743296427,4),(1637,1761440427,5),(1637,1774746027,4),(1637,1792890027,5),(1637,1806195627,4),(1637,1824944427,5),(1637,1837645227,4),(1637,1856394027,5),(1637,1869094827,4),(1637,1887843627,5),(1637,1901149227,4),(1637,1919293227,5),(1637,1932598827,4),(1637,1950742827,5),(1637,1964048427,4),(1637,1982797227,5),(1637,1995498027,4),(1637,2014246827,5),(1637,2026947627,4),(1637,2045696427,5),(1637,2058397227,4),(1637,2077146027,5),(1637,2090451627,4),(1637,2108595627,5),(1637,2121901227,4),(1637,2140045227,5),(1638,-2147483648,4),(1638,-1691964000,1),(1638,-1680472800,2),(1638,-1664143200,1),(1638,-1650146400,2),(1638,-1633903200,1),(1638,-1617487200,2),(1638,-1601848800,1),(1638,-1586037600,2),(1638,-1570399200,1),(1638,-1552168800,2),(1638,-1538344800,1),(1638,-1522533600,2),(1638,-1507500000,1),(1638,-1490565600,2),(1638,-1473631200,1),(1638,-1460930400,2),(1638,-1442786400,1),(1638,-1428876000,2),(1638,-1410732000,1),(1638,-1396216800,2),(1638,-1379282400,1),(1638,-1364767200,2),(1638,-1348437600,1),(1638,-1333317600,2),(1638,-1315778400,1),(1638,-1301263200,2),(1638,-1284328800,1),(1638,-1269813600,2),(1638,-1253484000,1),(1638,-1238364000,2),(1638,-1221429600,1),(1638,-1206914400,2),(1638,-1189980000,1),(1638,-1175464800,2),(1638,-1159135200,1),(1638,-1143410400,2),(1638,-1126476000,1),(1638,-1111960800,2),(1638,-1095631200,1),(1638,-1080511200,2),(1638,-1063576800,1),(1638,-1049061600,2),(1638,-1032127200,1),(1638,-1017612000,2),(1638,-1001282400,1),(1638,-986162400,2),(1638,-969228000,1),(1638,-950479200,2),(1638,-942012000,1),(1638,-904518000,3),(1638,-896050800,1),(1638,-875487600,3),(1638,-864601200,1),(1638,-844038000,3),(1638,-832546800,1),(1638,-812588400,3),(1638,-798073200,1),(1638,-781052400,3),(1638,-772066800,1),(1638,-764805600,2),(1638,-748476000,1),(1638,-733356000,2),(1638,-719445600,1),(1638,-717030000,3),(1638,-706748400,1),(1638,-699487200,2),(1638,-687996000,1),(1638,-668037600,2),(1638,-654732000,1),(1638,-636588000,2),(1638,-622072800,1),(1638,-605743200,2),(1638,-590623200,1),(1638,-574293600,2),(1638,-558568800,1),(1638,-542239200,2),(1638,-527119200,1),(1638,-512604000,2),(1638,-496274400,1),(1638,-481154400,2),(1638,-464220000,1),(1638,-449704800,2),(1638,-432165600,1),(1638,-417650400,2),(1638,-401320800,1),(1638,-386200800,2),(1638,-369266400,1),(1638,-354751200,2),(1638,-337816800,1),(1638,-323301600,2),(1638,-306972000,1),(1638,-291852000,2),(1638,-276732000,1),(1638,-257983200,2),(1638,-245282400,1),(1638,-226533600,2),(1638,-213228000,1),(1638,-195084000,2),(1638,-182383200,1),(1638,-163634400,2),(1638,-150933600,1),(1638,-132184800,2),(1638,-119484000,1),(1638,-100735200,2),(1638,-88034400,1),(1638,-68680800,2),(1638,-59004000,1),(1638,-37242000,5),(1638,57722400,7),(1638,69818400,1),(1638,89172001,2),(1638,101268002,1),(1638,120621602,2),(1638,132717603,1),(1638,152071203,2),(1638,164167204,1),(1638,183520804,2),(1638,196221605,1),(1638,214970405,2),(1638,227671206,1),(1638,246420006,2),(1638,259120807,1),(1638,278474407,2),(1638,290570408,1),(1638,309924008,2),(1638,322020009,1),(1638,341373609,2),(1638,354675609,6),(1638,372819610,7),(1638,386125210,6),(1638,404269211,7),(1638,417574811,6),(1638,435718812,7),(1638,449024412,6),(1638,467773212,7),(1638,481078812,6),(1638,499222813,7),(1638,512528413,6),(1638,530672413,7),(1638,543978013,6),(1638,562122013,7),(1638,575427614,6),(1638,593571614,7),(1638,606877214,6),(1638,625626014,7),(1638,638326815,6),(1638,657075615,7),(1638,670381216,6),(1638,688525216,7),(1638,701830816,6),(1638,719974817,7),(1638,733280417,6),(1638,751424418,7),(1638,764730018,6),(1638,782874019,7),(1638,796179619,6),(1638,814323619,7),(1638,820454420,4),(1638,828234020,6),(1638,846378020,7),(1638,859683620,6),(1638,877827621,7),(1638,891133221,6),(1638,909277221,7),(1638,922582822,6),(1638,941331622,7),(1638,954032422,6),(1638,972781222,7),(1638,985482022,6),(1638,1004230822,7),(1638,1017536422,6),(1638,1035680422,7),(1638,1048986022,6),(1638,1067130022,7),(1638,1080435622,6),(1638,1099184422,7),(1638,1111885222,6),(1638,1130634022,7),(1638,1143334823,6),(1638,1162083623,7),(1638,1174784423,6),(1638,1193533223,7),(1638,1206838823,6),(1638,1224982823,7),(1638,1238288424,6),(1638,1256432424,7),(1638,1269738024,6),(1638,1288486824,7),(1638,1301187624,6),(1638,1319936424,7),(1638,1332637224,6),(1638,1351386025,7),(1638,1364691625,6),(1638,1382835625,7),(1638,1396141225,6),(1638,1414285225,7),(1638,1427590825,6),(1638,1445734826,7),(1638,1459040426,6),(1638,1477789226,7),(1638,1490490027,6),(1638,1509238827,7),(1638,1521939627,6),(1638,1540688427,7),(1638,1553994027,6),(1638,1572138027,7),(1638,1585443627,6),(1638,1603587627,7),(1638,1616893227,6),(1638,1635642027,7),(1638,1648342827,6),(1638,1667091627,7),(1638,1679792427,6),(1638,1698541227,7),(1638,1711846827,6),(1638,1729990827,7),(1638,1743296427,6),(1638,1761440427,7),(1638,1774746027,6),(1638,1792890027,7),(1638,1806195627,6),(1638,1824944427,7),(1638,1837645227,6),(1638,1856394027,7),(1638,1869094827,6),(1638,1887843627,7),(1638,1901149227,6),(1638,1919293227,7),(1638,1932598827,6),(1638,1950742827,7),(1638,1964048427,6),(1638,1982797227,7),(1638,1995498027,6),(1638,2014246827,7),(1638,2026947627,6),(1638,2045696427,7),(1638,2058397227,6),(1638,2077146027,7),(1638,2090451627,6),(1638,2108595627,7),(1638,2121901227,6),(1638,2140045227,7),(1639,-2147483648,1),(1639,-1869875816,3),(1639,-1693706400,2),(1639,-1680490800,3),(1639,-1570413600,2),(1639,-1552186800,3),(1639,-1538359200,2),(1639,-1522551600,3),(1639,-1507514400,2),(1639,-1490583600,3),(1639,-1440208800,2),(1639,-1428030000,3),(1639,-1409709600,2),(1639,-1396494000,3),(1639,-931053600,2),(1639,-922676400,3),(1639,-917834400,2),(1639,-892436400,3),(1639,-875844000,2),(1639,-764737200,3),(1639,-744343200,2),(1639,-733806000,3),(1639,-716436000,2),(1639,-701924400,3),(1639,-684986400,2),(1639,-670474800,3),(1639,-654141600,2),(1639,-639025200,3),(1639,-622087200,2),(1639,-606970800,3),(1639,-590032800,2),(1639,-575521200,3),(1639,-235620000,2),(1639,-194842800,3),(1639,-177732000,2),(1639,-165726000,3),(1639,107910002,2),(1639,121215602,3),(1639,133920003,2),(1639,152665203,3),(1639,164678404,2),(1639,184114804,3),(1639,196214405,2),(1639,215564405,3),(1639,228873606,2),(1639,245804406,3),(1639,260323207,2),(1639,267915607,4),(1639,428454012,5),(1639,433893612,4),(1639,468111612,3),(1639,482799612,6),(1639,496710013,7),(1639,512521213,6),(1639,528246013,7),(1639,543970813,6),(1639,559695613,7),(1639,575420414,6),(1639,591145214,7),(1639,606870014,6),(1639,622594814,7),(1639,638319615,6),(1639,654649215,7),(1639,670374016,6),(1639,686098816,7),(1639,701823616,6),(1639,717548417,7),(1639,733273217,6),(1639,748998018,7),(1639,764118018,6),(1639,780447619,7),(1639,796172419,6),(1639,811897219,7),(1639,828226820,6),(1639,846370820,7),(1639,859676420,6),(1639,877820421,7),(1639,891126021,6),(1639,909270021,7),(1639,922575622,6),(1639,941324422,7),(1639,954025222,6),(1639,972774022,7),(1639,985474822,6),(1639,1004223622,7),(1639,1017529222,6),(1639,1035673222,7),(1639,1048978822,6),(1639,1067122822,7),(1639,1080428422,6),(1639,1099177222,7),(1639,1111878022,6),(1639,1130626822,7),(1639,1143327623,6),(1639,1162076423,7),(1639,1167602423,3),(1639,1174784423,8),(1639,1193533223,9),(1639,1206838823,8),(1639,1224982823,9),(1639,1238288424,8),(1639,1256432424,9),(1639,1269738024,8),(1639,1288486824,9),(1639,1301274024,8),(1639,1319936424,9),(1639,1332637224,8),(1639,1351386025,9),(1639,1364691625,8),(1639,1382835625,9),(1639,1396227625,8),(1639,1414285225,9),(1639,1427590825,8),(1639,1446944426,9),(1639,1459040426,8),(1639,1473195626,4),(1640,-2147483648,4),(1640,-1691964000,1),(1640,-1680472800,2),(1640,-1664143200,1),(1640,-1650146400,2),(1640,-1633903200,1),(1640,-1617487200,2),(1640,-1601848800,1),(1640,-1586037600,2),(1640,-1570399200,1),(1640,-1552168800,2),(1640,-1538344800,1),(1640,-1522533600,2),(1640,-1507500000,1),(1640,-1490565600,2),(1640,-1473631200,1),(1640,-1460930400,2),(1640,-1442786400,1),(1640,-1428876000,2),(1640,-1410732000,1),(1640,-1396216800,2),(1640,-1379282400,1),(1640,-1364767200,2),(1640,-1348437600,1),(1640,-1333317600,2),(1640,-1315778400,1),(1640,-1301263200,2),(1640,-1284328800,1),(1640,-1269813600,2),(1640,-1253484000,1),(1640,-1238364000,2),(1640,-1221429600,1),(1640,-1206914400,2),(1640,-1189980000,1),(1640,-1175464800,2),(1640,-1159135200,1),(1640,-1143410400,2),(1640,-1126476000,1),(1640,-1111960800,2),(1640,-1095631200,1),(1640,-1080511200,2),(1640,-1063576800,1),(1640,-1049061600,2),(1640,-1032127200,1),(1640,-1017612000,2),(1640,-1001282400,1),(1640,-986162400,2),(1640,-969228000,1),(1640,-950479200,2),(1640,-942012000,1),(1640,-904518000,3),(1640,-896050800,1),(1640,-875487600,3),(1640,-864601200,1),(1640,-844038000,3),(1640,-832546800,1),(1640,-812588400,3),(1640,-798073200,1),(1640,-781052400,3),(1640,-772066800,1),(1640,-764805600,2),(1640,-748476000,1),(1640,-733356000,2),(1640,-719445600,1),(1640,-717030000,3),(1640,-706748400,1),(1640,-699487200,2),(1640,-687996000,1),(1640,-668037600,2),(1640,-654732000,1),(1640,-636588000,2),(1640,-622072800,1),(1640,-605743200,2),(1640,-590623200,1),(1640,-574293600,2),(1640,-558568800,1),(1640,-542239200,2),(1640,-527119200,1),(1640,-512604000,2),(1640,-496274400,1),(1640,-481154400,2),(1640,-464220000,1),(1640,-449704800,2),(1640,-432165600,1),(1640,-417650400,2),(1640,-401320800,1),(1640,-386200800,2),(1640,-369266400,1),(1640,-354751200,2),(1640,-337816800,1),(1640,-323301600,2),(1640,-306972000,1),(1640,-291852000,2),(1640,-276732000,1),(1640,-257983200,2),(1640,-245282400,1),(1640,-226533600,2),(1640,-213228000,1),(1640,-195084000,2),(1640,-182383200,1),(1640,-163634400,2),(1640,-150933600,1),(1640,-132184800,2),(1640,-119484000,1),(1640,-100735200,2),(1640,-88034400,1),(1640,-68680800,2),(1640,-59004000,1),(1640,-37242000,5),(1640,57722400,7),(1640,69818400,1),(1640,89172001,2),(1640,101268002,1),(1640,120621602,2),(1640,132717603,1),(1640,152071203,2),(1640,164167204,1),(1640,183520804,2),(1640,196221605,1),(1640,214970405,2),(1640,227671206,1),(1640,246420006,2),(1640,259120807,1),(1640,278474407,2),(1640,290570408,1),(1640,309924008,2),(1640,322020009,1),(1640,341373609,2),(1640,354675609,6),(1640,372819610,7),(1640,386125210,6),(1640,404269211,7),(1640,417574811,6),(1640,435718812,7),(1640,449024412,6),(1640,467773212,7),(1640,481078812,6),(1640,499222813,7),(1640,512528413,6),(1640,530672413,7),(1640,543978013,6),(1640,562122013,7),(1640,575427614,6),(1640,593571614,7),(1640,606877214,6),(1640,625626014,7),(1640,638326815,6),(1640,657075615,7),(1640,670381216,6),(1640,688525216,7),(1640,701830816,6),(1640,719974817,7),(1640,733280417,6),(1640,751424418,7),(1640,764730018,6),(1640,782874019,7),(1640,796179619,6),(1640,814323619,7),(1640,820454420,4),(1640,828234020,6),(1640,846378020,7),(1640,859683620,6),(1640,877827621,7),(1640,891133221,6),(1640,909277221,7),(1640,922582822,6),(1640,941331622,7),(1640,954032422,6),(1640,972781222,7),(1640,985482022,6),(1640,1004230822,7),(1640,1017536422,6),(1640,1035680422,7),(1640,1048986022,6),(1640,1067130022,7),(1640,1080435622,6),(1640,1099184422,7),(1640,1111885222,6),(1640,1130634022,7),(1640,1143334823,6),(1640,1162083623,7),(1640,1174784423,6),(1640,1193533223,7),(1640,1206838823,6),(1640,1224982823,7),(1640,1238288424,6),(1640,1256432424,7),(1640,1269738024,6),(1640,1288486824,7),(1640,1301187624,6),(1640,1319936424,7),(1640,1332637224,6),(1640,1351386025,7),(1640,1364691625,6),(1640,1382835625,7),(1640,1396141225,6),(1640,1414285225,7),(1640,1427590825,6),(1640,1445734826,7),(1640,1459040426,6),(1640,1477789226,7),(1640,1490490027,6),(1640,1509238827,7),(1640,1521939627,6),(1640,1540688427,7),(1640,1553994027,6),(1640,1572138027,7),(1640,1585443627,6),(1640,1603587627,7),(1640,1616893227,6),(1640,1635642027,7),(1640,1648342827,6),(1640,1667091627,7),(1640,1679792427,6),(1640,1698541227,7),(1640,1711846827,6),(1640,1729990827,7),(1640,1743296427,6),(1640,1761440427,7),(1640,1774746027,6),(1640,1792890027,7),(1640,1806195627,6),(1640,1824944427,7),(1640,1837645227,6),(1640,1856394027,7),(1640,1869094827,6),(1640,1887843627,7),(1640,1901149227,6),(1640,1919293227,7),(1640,1932598827,6),(1640,1950742827,7),(1640,1964048427,6),(1640,1982797227,7),(1640,1995498027,6),(1640,2014246827,7),(1640,2026947627,6),(1640,2045696427,7),(1640,2058397227,6),(1640,2077146027,7),(1640,2090451627,6),(1640,2108595627,7),(1640,2121901227,6),(1640,2140045227,7),(1641,-2147483648,2),(1641,-1693706400,1),(1641,-1680483600,2),(1641,-1663455600,3),(1641,-1650150000,4),(1641,-1632006000,3),(1641,-1618700400,4),(1641,-938905200,3),(1641,-857257200,4),(1641,-844556400,3),(1641,-828226800,4),(1641,-812502000,3),(1641,-796777200,4),(1641,-781052400,3),(1641,-780372000,6),(1641,-778730400,5),(1641,-762663600,6),(1641,-749095200,8),(1641,354920409,7),(1641,370728010,8),(1641,386456410,7),(1641,402264011,8),(1641,417992411,7),(1641,433800012,8),(1641,449614812,7),(1641,465346812,9),(1641,481071612,10),(1641,496796413,9),(1641,512521213,10),(1641,528246013,9),(1641,543970813,10),(1641,559695613,9),(1641,575420414,10),(1641,591145214,9),(1641,606870014,11),(1641,622598414,12),(1641,638323215,11),(1641,654652815,12),(1641,670377616,11),(1641,686102416,12),(1641,701827216,11),(1641,717552017,12),(1641,733276817,11),(1641,749001618,12),(1641,764726418,11),(1641,780451219,12),(1641,796176019,11),(1641,811900819,12),(1641,828230420,11),(1641,846374420,12),(1641,859680020,11),(1641,877824021,12),(1641,891129621,11),(1641,909273621,12),(1641,922579222,11),(1641,941328022,12),(1641,954028822,11),(1641,972777622,12),(1641,985478422,11),(1641,1004227222,12),(1641,1017532822,11),(1641,1035676822,12),(1641,1048982422,11),(1641,1067126422,12),(1641,1080432022,11),(1641,1099180822,12),(1641,1111881622,11),(1641,1130630422,12),(1641,1143331223,11),(1641,1162080023,12),(1641,1174780823,11),(1641,1193529623,12),(1641,1206835223,11),(1641,1224979223,12),(1641,1238284824,11),(1641,1256428824,12),(1641,1269734424,11),(1641,1288483224,12),(1641,1301184024,13),(1641,1414278025,12),(1642,-2147483648,1),(1642,-1441159324,2),(1642,-1247536800,3),(1642,-892522800,6),(1642,-857257200,4),(1642,-844556400,5),(1642,-828226800,4),(1642,-825382800,3),(1642,354920409,7),(1642,370728010,3),(1642,386456410,7),(1642,402264011,3),(1642,417992411,7),(1642,433800012,3),(1642,449614812,7),(1642,465346812,8),(1642,481071612,9),(1642,496796413,8),(1642,512521213,9),(1642,528246013,8),(1642,543970813,9),(1642,559695613,8),(1642,575420414,9),(1642,591145214,8),(1642,606870014,9),(1642,622594814,8),(1642,638319615,9),(1642,646783215,10),(1642,686102416,11),(1642,701827216,12),(1642,717552017,11),(1642,733276817,12),(1642,749001618,11),(1642,764726418,12),(1642,780451219,11),(1642,796176019,12),(1642,811900819,11),(1642,828230420,12),(1642,831934820,10),(1642,846378020,13),(1642,859683620,14),(1642,877827621,13),(1642,891133221,14),(1642,909277221,13),(1642,922582822,14),(1642,941331622,13),(1642,954032422,14),(1642,972781222,13),(1642,985482022,14),(1642,1004230822,13),(1642,1017536422,14),(1642,1035680422,13),(1642,1048986022,14),(1642,1067130022,13),(1642,1080435622,14),(1642,1099184422,13),(1642,1111885222,14),(1642,1130634022,13),(1642,1143334823,14),(1642,1162083623,13),(1642,1174784423,14),(1642,1193533223,13),(1642,1206838823,14),(1642,1224982823,13),(1642,1238288424,14),(1642,1256432424,13),(1642,1269738024,14),(1642,1288486824,13),(1642,1301187624,14),(1642,1319936424,13),(1642,1332637224,14),(1642,1351386025,13),(1642,1364691625,14),(1642,1382835625,13),(1642,1396141225,14),(1642,1414285225,13),(1642,1427590825,14),(1642,1445734826,13),(1642,1459040426,14),(1642,1477789226,13),(1642,1490490027,14),(1642,1509238827,13),(1642,1521939627,14),(1642,1540688427,13),(1642,1553994027,14),(1642,1572138027,13),(1642,1585443627,14),(1642,1603587627,13),(1642,1616893227,14),(1642,1635642027,13),(1642,1648342827,14),(1642,1667091627,13),(1642,1679792427,14),(1642,1698541227,13),(1642,1711846827,14),(1642,1729990827,13),(1642,1743296427,14),(1642,1761440427,13),(1642,1774746027,14),(1642,1792890027,13),(1642,1806195627,14),(1642,1824944427,13),(1642,1837645227,14),(1642,1856394027,13),(1642,1869094827,14),(1642,1887843627,13),(1642,1901149227,14),(1642,1919293227,13),(1642,1932598827,14),(1642,1950742827,13),(1642,1964048427,14),(1642,1982797227,13),(1642,1995498027,14),(1642,2014246827,13),(1642,2026947627,14),(1642,2045696427,13),(1642,2058397227,14),(1642,2077146027,13),(1642,2090451627,14),(1642,2108595627,13),(1642,2121901227,14),(1642,2140045227,13),(1643,-2147483648,0),(1643,-1593820800,1),(1643,-1247540400,3),(1643,354916809,2),(1643,370724410,3),(1643,386452810,2),(1643,402260411,3),(1643,417988811,2),(1643,433796412,3),(1643,449611212,2),(1643,465343212,4),(1643,481068012,5),(1643,496792813,4),(1643,512517613,5),(1643,528242413,4),(1643,543967213,5),(1643,559692013,4),(1643,575416814,5),(1643,591141614,4),(1643,606866414,6),(1643,622594814,7),(1643,638319615,6),(1643,654649215,7),(1643,670374016,4),(1643,701820016,6),(1643,717548417,7),(1643,733273217,6),(1643,748998018,7),(1643,764722818,6),(1643,780447619,7),(1643,796172419,6),(1643,811897219,7),(1643,828226820,6),(1643,846370820,7),(1643,859676420,6),(1643,877820421,7),(1643,891126021,6),(1643,909270021,7),(1643,922575622,6),(1643,941324422,7),(1643,954025222,6),(1643,972774022,7),(1643,985474822,6),(1643,1004223622,7),(1643,1017529222,6),(1643,1035673222,7),(1643,1048978822,6),(1643,1067122822,7),(1643,1080428422,6),(1643,1099177222,7),(1643,1111878022,6),(1643,1130626822,7),(1643,1143327623,6),(1643,1162076423,7),(1643,1174777223,6),(1643,1193526023,7),(1643,1206831623,6),(1643,1224975623,7),(1643,1238281224,6),(1643,1256425224,7),(1643,1269730824,6),(1643,1288479624,7),(1643,1301180424,8),(1643,1414274425,7),(1644,-2147483648,1),(1644,-1441159324,2),(1644,-1247536800,3),(1644,-892522800,6),(1644,-857257200,4),(1644,-844556400,5),(1644,-828226800,4),(1644,-825382800,3),(1644,354920409,7),(1644,370728010,3),(1644,386456410,7),(1644,402264011,3),(1644,417992411,7),(1644,433800012,3),(1644,449614812,7),(1644,465346812,8),(1644,481071612,9),(1644,496796413,8),(1644,512521213,9),(1644,528246013,8),(1644,543970813,9),(1644,559695613,8),(1644,575420414,9),(1644,591145214,8),(1644,606870014,9),(1644,622594814,8),(1644,638319615,9),(1644,646783215,10),(1644,686102416,11),(1644,701827216,12),(1644,717552017,11),(1644,733276817,12),(1644,749001618,11),(1644,764726418,12),(1644,780451219,11),(1644,796176019,12),(1644,811900819,11),(1644,828230420,12),(1644,831934820,10),(1644,846378020,13),(1644,859683620,14),(1644,877827621,13),(1644,891133221,14),(1644,909277221,13),(1644,922582822,14),(1644,941331622,13),(1644,954032422,14),(1644,972781222,13),(1644,985482022,14),(1644,1004230822,13),(1644,1017536422,14),(1644,1035680422,13),(1644,1048986022,14),(1644,1067130022,13),(1644,1080435622,14),(1644,1099184422,13),(1644,1111885222,14),(1644,1130634022,13),(1644,1143334823,14),(1644,1162083623,13),(1644,1174784423,14),(1644,1193533223,13),(1644,1206838823,14),(1644,1224982823,13),(1644,1238288424,14),(1644,1256432424,13),(1644,1269738024,14),(1644,1288486824,13),(1644,1301187624,14),(1644,1319936424,13),(1644,1332637224,14),(1644,1351386025,13),(1644,1364691625,14),(1644,1382835625,13),(1644,1396141225,14),(1644,1414285225,13),(1644,1427590825,14),(1644,1445734826,13),(1644,1459040426,14),(1644,1477789226,13),(1644,1490490027,14),(1644,1509238827,13),(1644,1521939627,14),(1644,1540688427,13),(1644,1553994027,14),(1644,1572138027,13),(1644,1585443627,14),(1644,1603587627,13),(1644,1616893227,14),(1644,1635642027,13),(1644,1648342827,14),(1644,1667091627,13),(1644,1679792427,14),(1644,1698541227,13),(1644,1711846827,14),(1644,1729990827,13),(1644,1743296427,14),(1644,1761440427,13),(1644,1774746027,14),(1644,1792890027,13),(1644,1806195627,14),(1644,1824944427,13),(1644,1837645227,14),(1644,1856394027,13),(1644,1869094827,14),(1644,1887843627,13),(1644,1901149227,14),(1644,1919293227,13),(1644,1932598827,14),(1644,1950742827,13),(1644,1964048427,14),(1644,1982797227,13),(1644,1995498027,14),(1644,2014246827,13),(1644,2026947627,14),(1644,2045696427,13),(1644,2058397227,14),(1644,2077146027,13),(1644,2090451627,14),(1644,2108595627,13),(1644,2121901227,14),(1644,2140045227,13),(1645,-2147483648,0),(1645,-1830384000,6),(1645,-1689555600,1),(1645,-1677801600,2),(1645,-1667437200,3),(1645,-1647738000,4),(1645,-1635814800,3),(1645,-1616202000,4),(1645,-1604365200,3),(1645,-1584666000,4),(1645,-1572742800,3),(1645,-1553043600,4),(1645,-1541206800,3),(1645,-1521507600,4),(1645,-1442451600,3),(1645,-1426813200,4),(1645,-1379293200,3),(1645,-1364778000,4),(1645,-1348448400,3),(1645,-1333328400,4),(1645,-1316394000,3),(1645,-1301274000,4),(1645,-1284339600,3),(1645,-1269824400,4),(1645,-1221440400,3),(1645,-1206925200,4),(1645,-1191200400,3),(1645,-1175475600,4),(1645,-1127696400,3),(1645,-1111971600,4),(1645,-1096851600,3),(1645,-1080522000,4),(1645,-1063587600,3),(1645,-1049072400,4),(1645,-1033347600,3),(1645,-1017622800,4),(1645,-1002502800,3),(1645,-986173200,4),(1645,-969238800,3),(1645,-950490000,4),(1645,-942022800,3),(1645,-922669200,4),(1645,-906944400,3),(1645,-891133200,4),(1645,-877309200,3),(1645,-873684000,5),(1645,-864007200,3),(1645,-857955600,4),(1645,-845859600,3),(1645,-842839200,5),(1645,-831348000,3),(1645,-825901200,4),(1645,-814410000,3),(1645,-810784800,5),(1645,-799898400,3),(1645,-794451600,4),(1645,-782960400,3),(1645,-779335200,5),(1645,-768448800,3),(1645,-763002000,4),(1645,-749091600,3),(1645,-733366800,4),(1645,-717631200,3),(1645,-701906400,4),(1645,-686181600,3),(1645,-670456800,4),(1645,-654732000,3),(1645,-639007200,4),(1645,-623282400,3),(1645,-607557600,4),(1645,-591832800,3),(1645,-575503200,4),(1645,-559778400,3),(1645,-544053600,4),(1645,-528328800,3),(1645,-512604000,4),(1645,-496879200,3),(1645,-481154400,4),(1645,-465429600,3),(1645,-449704800,4),(1645,-433980000,3),(1645,-417650400,4),(1645,-401925600,3),(1645,-386200800,4),(1645,-370476000,3),(1645,-354751200,4),(1645,-339026400,3),(1645,-323301600,4),(1645,-307576800,3),(1645,-291852000,4),(1645,-276127200,3),(1645,-260402400,4),(1645,-244677600,3),(1645,-228348000,4),(1645,-212623200,3),(1645,-196898400,4),(1645,-181173600,3),(1645,-165448800,4),(1645,-149724000,3),(1645,-133999200,4),(1645,-118274400,7),(1645,212544005,2),(1645,228268806,3),(1645,243993606,4),(1645,260323207,3),(1645,276048007,4),(1645,291772808,3),(1645,307501208,4),(1645,323222409,3),(1645,338950809,4),(1645,354675609,3),(1645,370400410,4),(1645,386125210,3),(1645,401850011,4),(1645,417578411,3),(1645,433299612,4),(1645,449024412,3),(1645,465354012,4),(1645,481078812,3),(1645,496803613,4),(1645,512528413,3),(1645,528253213,4),(1645,543978013,3),(1645,559702813,4),(1645,575427614,3),(1645,591152414,4),(1645,606877214,3),(1645,622602014,4),(1645,638326815,3),(1645,654656415,4),(1645,670381216,3),(1645,686106016,4),(1645,701830816,3),(1645,717555617,8),(1645,733280417,9),(1645,749005218,8),(1645,764730018,9),(1645,780454819,8),(1645,796179619,9),(1645,811904419,8),(1645,828234020,10),(1645,846378020,6),(1645,859683620,10),(1645,877827621,6),(1645,891133221,10),(1645,909277221,6),(1645,922582822,10),(1645,941331622,6),(1645,954032422,10),(1645,972781222,6),(1645,985482022,10),(1645,1004230822,6),(1645,1017536422,10),(1645,1035680422,6),(1645,1048986022,10),(1645,1067130022,6),(1645,1080435622,10),(1645,1099184422,6),(1645,1111885222,10),(1645,1130634022,6),(1645,1143334823,10),(1645,1162083623,6),(1645,1174784423,10),(1645,1193533223,6),(1645,1206838823,10),(1645,1224982823,6),(1645,1238288424,10),(1645,1256432424,6),(1645,1269738024,10),(1645,1288486824,6),(1645,1301187624,10),(1645,1319936424,6),(1645,1332637224,10),(1645,1351386025,6),(1645,1364691625,10),(1645,1382835625,6),(1645,1396141225,10),(1645,1414285225,6),(1645,1427590825,10),(1645,1445734826,6),(1645,1459040426,10),(1645,1477789226,6),(1645,1490490027,10),(1645,1509238827,6),(1645,1521939627,10),(1645,1540688427,6),(1645,1553994027,10),(1645,1572138027,6),(1645,1585443627,10),(1645,1603587627,6),(1645,1616893227,10),(1645,1635642027,6),(1645,1648342827,10),(1645,1667091627,6),(1645,1679792427,10),(1645,1698541227,6),(1645,1711846827,10),(1645,1729990827,6),(1645,1743296427,10),(1645,1761440427,6),(1645,1774746027,10),(1645,1792890027,6),(1645,1806195627,10),(1645,1824944427,6),(1645,1837645227,10),(1645,1856394027,6),(1645,1869094827,10),(1645,1887843627,6),(1645,1901149227,10),(1645,1919293227,6),(1645,1932598827,10),(1645,1950742827,6),(1645,1964048427,10),(1645,1982797227,6),(1645,1995498027,10),(1645,2014246827,6),(1645,2026947627,10),(1645,2045696427,6),(1645,2058397227,10),(1645,2077146027,6),(1645,2090451627,10),(1645,2108595627,6),(1645,2121901227,10),(1645,2140045227,6),(1646,-2147483648,1),(1646,-905824800,4),(1646,-857257200,2),(1646,-844556400,3),(1646,-828226800,2),(1646,-812502000,3),(1646,-796777200,2),(1646,-788922000,1),(1646,-777942000,3),(1646,-766623600,2),(1646,407199611,1),(1646,417574811,5),(1646,433299612,6),(1646,449024412,5),(1646,465354012,6),(1646,481078812,5),(1646,496803613,6),(1646,512528413,5),(1646,528253213,6),(1646,543978013,5),(1646,559702813,6),(1646,575427614,5),(1646,591152414,6),(1646,606877214,5),(1646,622602014,6),(1646,638326815,5),(1646,654656415,6),(1646,670381216,5),(1646,686106016,6),(1646,701830816,5),(1646,717555617,6),(1646,733280417,5),(1646,749005218,6),(1646,764730018,5),(1646,780454819,6),(1646,796179619,5),(1646,811904419,6),(1646,828234020,5),(1646,846378020,6),(1646,859683620,5),(1646,877827621,6),(1646,891133221,5),(1646,909277221,6),(1646,922582822,5),(1646,941331622,6),(1646,954032422,5),(1646,972781222,6),(1646,985482022,5),(1646,1004230822,6),(1646,1017536422,5),(1646,1035680422,6),(1646,1048986022,5),(1646,1067130022,6),(1646,1080435622,5),(1646,1099184422,6),(1646,1111885222,5),(1646,1130634022,6),(1646,1143334823,5),(1646,1162083623,6),(1646,1174784423,5),(1646,1193533223,6),(1646,1206838823,5),(1646,1224982823,6),(1646,1238288424,5),(1646,1256432424,6),(1646,1269738024,5),(1646,1288486824,6),(1646,1301187624,5),(1646,1319936424,6),(1646,1332637224,5),(1646,1351386025,6),(1646,1364691625,5),(1646,1382835625,6),(1646,1396141225,5),(1646,1414285225,6),(1646,1427590825,5),(1646,1445734826,6),(1646,1459040426,5),(1646,1477789226,6),(1646,1490490027,5),(1646,1509238827,6),(1646,1521939627,5),(1646,1540688427,6),(1646,1553994027,5),(1646,1572138027,6),(1646,1585443627,5),(1646,1603587627,6),(1646,1616893227,5),(1646,1635642027,6),(1646,1648342827,5),(1646,1667091627,6),(1646,1679792427,5),(1646,1698541227,6),(1646,1711846827,5),(1646,1729990827,6),(1646,1743296427,5),(1646,1761440427,6),(1646,1774746027,5),(1646,1792890027,6),(1646,1806195627,5),(1646,1824944427,6),(1646,1837645227,5),(1646,1856394027,6),(1646,1869094827,5),(1646,1887843627,6),(1646,1901149227,5),(1646,1919293227,6),(1646,1932598827,5),(1646,1950742827,6),(1646,1964048427,5),(1646,1982797227,6),(1646,1995498027,5),(1646,2014246827,6),(1646,2026947627,5),(1646,2045696427,6),(1646,2058397227,5),(1646,2077146027,6),(1646,2090451627,5),(1646,2108595627,6),(1646,2121901227,5),(1646,2140045227,6),(1647,-2147483648,4),(1647,-1691964000,1),(1647,-1680472800,2),(1647,-1664143200,1),(1647,-1650146400,2),(1647,-1633903200,1),(1647,-1617487200,2),(1647,-1601848800,1),(1647,-1586037600,2),(1647,-1570399200,1),(1647,-1552168800,2),(1647,-1538344800,1),(1647,-1522533600,2),(1647,-1507500000,1),(1647,-1490565600,2),(1647,-1473631200,1),(1647,-1460930400,2),(1647,-1442786400,1),(1647,-1428876000,2),(1647,-1410732000,1),(1647,-1396216800,2),(1647,-1379282400,1),(1647,-1364767200,2),(1647,-1348437600,1),(1647,-1333317600,2),(1647,-1315778400,1),(1647,-1301263200,2),(1647,-1284328800,1),(1647,-1269813600,2),(1647,-1253484000,1),(1647,-1238364000,2),(1647,-1221429600,1),(1647,-1206914400,2),(1647,-1189980000,1),(1647,-1175464800,2),(1647,-1159135200,1),(1647,-1143410400,2),(1647,-1126476000,1),(1647,-1111960800,2),(1647,-1095631200,1),(1647,-1080511200,2),(1647,-1063576800,1),(1647,-1049061600,2),(1647,-1032127200,1),(1647,-1017612000,2),(1647,-1001282400,1),(1647,-986162400,2),(1647,-969228000,1),(1647,-950479200,2),(1647,-942012000,1),(1647,-904518000,3),(1647,-896050800,1),(1647,-875487600,3),(1647,-864601200,1),(1647,-844038000,3),(1647,-832546800,1),(1647,-812588400,3),(1647,-798073200,1),(1647,-781052400,3),(1647,-772066800,1),(1647,-764805600,2),(1647,-748476000,1),(1647,-733356000,2),(1647,-719445600,1),(1647,-717030000,3),(1647,-706748400,1),(1647,-699487200,2),(1647,-687996000,1),(1647,-668037600,2),(1647,-654732000,1),(1647,-636588000,2),(1647,-622072800,1),(1647,-605743200,2),(1647,-590623200,1),(1647,-574293600,2),(1647,-558568800,1),(1647,-542239200,2),(1647,-527119200,1),(1647,-512604000,2),(1647,-496274400,1),(1647,-481154400,2),(1647,-464220000,1),(1647,-449704800,2),(1647,-432165600,1),(1647,-417650400,2),(1647,-401320800,1),(1647,-386200800,2),(1647,-369266400,1),(1647,-354751200,2),(1647,-337816800,1),(1647,-323301600,2),(1647,-306972000,1),(1647,-291852000,2),(1647,-276732000,1),(1647,-257983200,2),(1647,-245282400,1),(1647,-226533600,2),(1647,-213228000,1),(1647,-195084000,2),(1647,-182383200,1),(1647,-163634400,2),(1647,-150933600,1),(1647,-132184800,2),(1647,-119484000,1),(1647,-100735200,2),(1647,-88034400,1),(1647,-68680800,2),(1647,-59004000,1),(1647,-37242000,5),(1647,57722400,7),(1647,69818400,1),(1647,89172001,2),(1647,101268002,1),(1647,120621602,2),(1647,132717603,1),(1647,152071203,2),(1647,164167204,1),(1647,183520804,2),(1647,196221605,1),(1647,214970405,2),(1647,227671206,1),(1647,246420006,2),(1647,259120807,1),(1647,278474407,2),(1647,290570408,1),(1647,309924008,2),(1647,322020009,1),(1647,341373609,2),(1647,354675609,6),(1647,372819610,7),(1647,386125210,6),(1647,404269211,7),(1647,417574811,6),(1647,435718812,7),(1647,449024412,6),(1647,467773212,7),(1647,481078812,6),(1647,499222813,7),(1647,512528413,6),(1647,530672413,7),(1647,543978013,6),(1647,562122013,7),(1647,575427614,6),(1647,593571614,7),(1647,606877214,6),(1647,625626014,7),(1647,638326815,6),(1647,657075615,7),(1647,670381216,6),(1647,688525216,7),(1647,701830816,6),(1647,719974817,7),(1647,733280417,6),(1647,751424418,7),(1647,764730018,6),(1647,782874019,7),(1647,796179619,6),(1647,814323619,7),(1647,820454420,4),(1647,828234020,6),(1647,846378020,7),(1647,859683620,6),(1647,877827621,7),(1647,891133221,6),(1647,909277221,7),(1647,922582822,6),(1647,941331622,7),(1647,954032422,6),(1647,972781222,7),(1647,985482022,6),(1647,1004230822,7),(1647,1017536422,6),(1647,1035680422,7),(1647,1048986022,6),(1647,1067130022,7),(1647,1080435622,6),(1647,1099184422,7),(1647,1111885222,6),(1647,1130634022,7),(1647,1143334823,6),(1647,1162083623,7),(1647,1174784423,6),(1647,1193533223,7),(1647,1206838823,6),(1647,1224982823,7),(1647,1238288424,6),(1647,1256432424,7),(1647,1269738024,6),(1647,1288486824,7),(1647,1301187624,6),(1647,1319936424,7),(1647,1332637224,6),(1647,1351386025,7),(1647,1364691625,6),(1647,1382835625,7),(1647,1396141225,6),(1647,1414285225,7),(1647,1427590825,6),(1647,1445734826,7),(1647,1459040426,6),(1647,1477789226,7),(1647,1490490027,6),(1647,1509238827,7),(1647,1521939627,6),(1647,1540688427,7),(1647,1553994027,6),(1647,1572138027,7),(1647,1585443627,6),(1647,1603587627,7),(1647,1616893227,6),(1647,1635642027,7),(1647,1648342827,6),(1647,1667091627,7),(1647,1679792427,6),(1647,1698541227,7),(1647,1711846827,6),(1647,1729990827,7),(1647,1743296427,6),(1647,1761440427,7),(1647,1774746027,6),(1647,1792890027,7),(1647,1806195627,6),(1647,1824944427,7),(1647,1837645227,6),(1647,1856394027,7),(1647,1869094827,6),(1647,1887843627,7),(1647,1901149227,6),(1647,1919293227,7),(1647,1932598827,6),(1647,1950742827,7),(1647,1964048427,6),(1647,1982797227,7),(1647,1995498027,6),(1647,2014246827,7),(1647,2026947627,6),(1647,2045696427,7),(1647,2058397227,6),(1647,2077146027,7),(1647,2090451627,6),(1647,2108595627,7),(1647,2121901227,6),(1647,2140045227,7),(1648,-2147483648,1),(1648,-1740355200,2),(1648,-1693702800,5),(1648,-1680483600,2),(1648,-1663455600,3),(1648,-1650150000,4),(1648,-1632006000,3),(1648,-1618700400,4),(1648,-1613826000,8),(1648,-1604278800,6),(1648,-1585530000,7),(1648,-1574038800,6),(1648,-1552266000,7),(1648,-1539997200,6),(1648,-1520557200,7),(1648,-1507510800,6),(1648,-1490576400,7),(1648,-1473642000,6),(1648,-1459126800,7),(1648,-1444006800,6),(1648,-1427677200,7),(1648,-1411952400,6),(1648,-1396227600,7),(1648,-1379293200,6),(1648,-1364778000,7),(1648,-1348448400,6),(1648,-1333328400,7),(1648,-1316394000,6),(1648,-1301263200,7),(1648,-1284328800,6),(1648,-1269813600,7),(1648,-1253484000,6),(1648,-1238364000,7),(1648,-1221429600,6),(1648,-1206914400,7),(1648,-1191189600,6),(1648,-1175464800,7),(1648,-1160344800,6),(1648,-1143410400,7),(1648,-1127685600,6),(1648,-1111960800,7),(1648,-1096840800,6),(1648,-1080511200,7),(1648,-1063576800,6),(1648,-1049061600,7),(1648,-1033336800,6),(1648,-1017612000,7),(1648,-1002492000,6),(1648,-986162400,7),(1648,-969228000,6),(1648,-950479200,7),(1648,-942012000,6),(1648,-934668000,3),(1648,-857257200,4),(1648,-844556400,3),(1648,-828226800,4),(1648,-812502000,3),(1648,-799293600,5),(1648,-798073200,4),(1648,-781052400,3),(1648,-766623600,4),(1648,-745455600,3),(1648,-733273200,4),(1648,220921205,2),(1648,228877206,9),(1648,243997206,10),(1648,260326807,9),(1648,276051607,10),(1648,291776408,9),(1648,307501208,10),(1648,323830809,9),(1648,338950809,10),(1648,354675609,9),(1648,370400410,10),(1648,386125210,9),(1648,401850011,10),(1648,417574811,9),(1648,433299612,10),(1648,449024412,9),(1648,465354012,10),(1648,481078812,9),(1648,496803613,10),(1648,512528413,9),(1648,528253213,10),(1648,543978013,9),(1648,559702813,10),(1648,575427614,9),(1648,591152414,10),(1648,606877214,9),(1648,622602014,10),(1648,638326815,9),(1648,654656415,10),(1648,670381216,9),(1648,686106016,10),(1648,701830816,9),(1648,717555617,10),(1648,733280417,9),(1648,749005218,10),(1648,764730018,9),(1648,780454819,10),(1648,796179619,9),(1648,811904419,10),(1648,828234020,9),(1648,846378020,10),(1648,859683620,9),(1648,877827621,10),(1648,891133221,9),(1648,909277221,10),(1648,922582822,9),(1648,941331622,10),(1648,954032422,9),(1648,972781222,10),(1648,985482022,9),(1648,1004230822,10),(1648,1017536422,9),(1648,1035680422,10),(1648,1048986022,9),(1648,1067130022,10),(1648,1080435622,9),(1648,1099184422,10),(1648,1111885222,9),(1648,1130634022,10),(1648,1143334823,9),(1648,1162083623,10),(1648,1174784423,9),(1648,1193533223,10),(1648,1206838823,9),(1648,1224982823,10),(1648,1238288424,9),(1648,1256432424,10),(1648,1269738024,9),(1648,1288486824,10),(1648,1301187624,9),(1648,1319936424,10),(1648,1332637224,9),(1648,1351386025,10),(1648,1364691625,9),(1648,1382835625,10),(1648,1396141225,9),(1648,1414285225,10),(1648,1427590825,9),(1648,1445734826,10),(1648,1459040426,9),(1648,1477789226,10),(1648,1490490027,9),(1648,1509238827,10),(1648,1521939627,9),(1648,1540688427,10),(1648,1553994027,9),(1648,1572138027,10),(1648,1585443627,9),(1648,1603587627,10),(1648,1616893227,9),(1648,1635642027,10),(1648,1648342827,9),(1648,1667091627,10),(1648,1679792427,9),(1648,1698541227,10),(1648,1711846827,9),(1648,1729990827,10),(1648,1743296427,9),(1648,1761440427,10),(1648,1774746027,9),(1648,1792890027,10),(1648,1806195627,9),(1648,1824944427,10),(1648,1837645227,9),(1648,1856394027,10),(1648,1869094827,9),(1648,1887843627,10),(1648,1901149227,9),(1648,1919293227,10),(1648,1932598827,9),(1648,1950742827,10),(1648,1964048427,9),(1648,1982797227,10),(1648,1995498027,9),(1648,2014246827,10),(1648,2026947627,9),(1648,2045696427,10),(1648,2058397227,9),(1648,2077146027,10),(1648,2090451627,9),(1648,2108595627,10),(1648,2121901227,9),(1648,2140045227,10),(1649,-2147483648,4),(1649,-1631926800,1),(1649,-1616889600,2),(1649,-1601168400,1),(1649,-1585353600,2),(1649,-1442451600,1),(1649,-1427673600,2),(1649,-1379293200,1),(1649,-1364774400,2),(1649,-1348448400,1),(1649,-1333324800,2),(1649,-1316390400,1),(1649,-1301270400,2),(1649,-1284339600,1),(1649,-1269820800,2),(1649,-1026954000,1),(1649,-1017619200,2),(1649,-1001898000,1),(1649,-999482400,3),(1649,-986090400,1),(1649,-954115200,2),(1649,-940208400,6),(1649,-873079200,5),(1649,-862621200,6),(1649,-842839200,5),(1649,-828320400,6),(1649,-811389600,5),(1649,-796870800,6),(1649,-779940000,5),(1649,-765421200,6),(1649,-748490400,5),(1649,-733971600,6),(1649,-652327200,5),(1649,-639018000,6),(1649,135122403,5),(1649,150246003,6),(1649,166572004,5),(1649,181695604,6),(1649,196812005,5),(1649,212540405,6),(1649,228866406,5),(1649,243990006,6),(1649,260326807,7),(1649,276051607,8),(1649,283993207,6),(1649,291776408,9),(1649,307501208,10),(1649,323830809,9),(1649,338950809,10),(1649,354675609,9),(1649,370400410,10),(1649,386125210,9),(1649,401850011,10),(1649,417574811,9),(1649,433299612,10),(1649,449024412,9),(1649,465354012,10),(1649,481078812,9),(1649,496803613,10),(1649,512528413,9),(1649,528253213,10),(1649,543978013,9),(1649,559702813,10),(1649,575427614,9),(1649,591152414,10),(1649,606877214,9),(1649,622602014,10),(1649,638326815,9),(1649,654656415,10),(1649,670381216,9),(1649,686106016,10),(1649,701830816,9),(1649,717555617,10),(1649,733280417,9),(1649,749005218,10),(1649,764730018,9),(1649,780454819,10),(1649,796179619,9),(1649,811904419,10),(1649,828234020,9),(1649,846378020,10),(1649,859683620,9),(1649,877827621,10),(1649,891133221,9),(1649,909277221,10),(1649,922582822,9),(1649,941331622,10),(1649,954032422,9),(1649,972781222,10),(1649,985482022,9),(1649,1004230822,10),(1649,1017536422,9),(1649,1035680422,10),(1649,1048986022,9),(1649,1067130022,10),(1649,1080435622,9),(1649,1099184422,10),(1649,1111885222,9),(1649,1130634022,10),(1649,1143334823,9),(1649,1162083623,10),(1649,1174784423,9),(1649,1193533223,10),(1649,1206838823,9),(1649,1224982823,10),(1649,1238288424,9),(1649,1256432424,10),(1649,1269738024,9),(1649,1288486824,10),(1649,1301187624,9),(1649,1319936424,10),(1649,1332637224,9),(1649,1351386025,10),(1649,1364691625,9),(1649,1382835625,10),(1649,1396141225,9),(1649,1414285225,10),(1649,1427590825,9),(1649,1445734826,10),(1649,1459040426,9),(1649,1477789226,10),(1649,1490490027,9),(1649,1509238827,10),(1649,1521939627,9),(1649,1540688427,10),(1649,1553994027,9),(1649,1572138027,10),(1649,1585443627,9),(1649,1603587627,10),(1649,1616893227,9),(1649,1635642027,10),(1649,1648342827,9),(1649,1667091627,10),(1649,1679792427,9),(1649,1698541227,10),(1649,1711846827,9),(1649,1729990827,10),(1649,1743296427,9),(1649,1761440427,10),(1649,1774746027,9),(1649,1792890027,10),(1649,1806195627,9),(1649,1824944427,10),(1649,1837645227,9),(1649,1856394027,10),(1649,1869094827,9),(1649,1887843627,10),(1649,1901149227,9),(1649,1919293227,10),(1649,1932598827,9),(1649,1950742827,10),(1649,1964048427,9),(1649,1982797227,10),(1649,1995498027,9),(1649,2014246827,10),(1649,2026947627,9),(1649,2045696427,10),(1649,2058397227,9),(1649,2077146027,10),(1649,2090451627,9),(1649,2108595627,10),(1649,2121901227,9),(1649,2140045227,10),(1650,-2147483648,2),(1650,-1690765200,1),(1650,-1680487200,2),(1650,-1664758800,1),(1650,-1648951200,2),(1650,-1635123600,1),(1650,-1616896800,2),(1650,-1604278800,1),(1650,-1585533600,2),(1650,-1571014800,1),(1650,-1555293600,2),(1650,-932432400,1),(1650,-857257200,3),(1650,-844556400,4),(1650,-828226800,3),(1650,-812588400,4),(1650,-798073200,3),(1650,-781052400,1),(1650,-766717200,2),(1650,-750898800,4),(1650,-733359600,3),(1650,-719456400,4),(1650,-701917200,3),(1650,-689209200,4),(1650,-670460400,3),(1650,-114051600,4),(1650,-103168800,2),(1650,-81997200,4),(1650,-71715600,3),(1650,-50547600,4),(1650,-40266000,3),(1650,-18493200,4),(1650,-8211600,3),(1650,12956400,4),(1650,23238000,3),(1650,43801200,4),(1650,54687600,3),(1650,75855600,4),(1650,86742001,3),(1650,102380402,4),(1650,118105202,3),(1650,135730803,4),(1650,148518003,3),(1650,167187604,1),(1650,180489604,2),(1650,198637205,1),(1650,211939205,2),(1650,230086806,1),(1650,243388806,2),(1650,261536407,1),(1650,274838407,2),(1650,292986008,1),(1650,306288008,2),(1650,323312409,1),(1650,338342409,2),(1650,354675609,5),(1650,370400410,6),(1650,386125210,5),(1650,401850011,6),(1650,417574811,5),(1650,433299612,6),(1650,449024412,5),(1650,465354012,6),(1650,481078812,5),(1650,496803613,6),(1650,512528413,5),(1650,528253213,6),(1650,543978013,5),(1650,559702813,6),(1650,575427614,5),(1650,591152414,6),(1650,606877214,5),(1650,622602014,6),(1650,638326815,5),(1650,654656415,6),(1650,670381216,5),(1650,686106016,6),(1650,701830816,5),(1650,717555617,6),(1650,733280417,5),(1650,749005218,6),(1650,764730018,5),(1650,780454819,6),(1650,796179619,5),(1650,811904419,6),(1650,828234020,5),(1650,846378020,6),(1650,859683620,5),(1650,877827621,6),(1650,891133221,5),(1650,909277221,6),(1650,922582822,5),(1650,941331622,6),(1650,954032422,5),(1650,972781222,6),(1650,985482022,5),(1650,1004230822,6),(1650,1017536422,5),(1650,1035680422,6),(1650,1048986022,5),(1650,1067130022,6),(1650,1080435622,5),(1650,1099184422,6),(1650,1111885222,5),(1650,1130634022,6),(1650,1143334823,5),(1650,1162083623,6),(1650,1174784423,5),(1650,1193533223,6),(1650,1206838823,5),(1650,1224982823,6),(1650,1238288424,5),(1650,1256432424,6),(1650,1269738024,5),(1650,1288486824,6),(1650,1301187624,5),(1650,1319936424,6),(1650,1332637224,5),(1650,1351386025,6),(1650,1364691625,5),(1650,1382835625,6),(1650,1396141225,5),(1650,1414285225,6),(1650,1427590825,5),(1650,1445734826,6),(1650,1459040426,5),(1650,1477789226,6),(1650,1490490027,5),(1650,1509238827,6),(1650,1521939627,5),(1650,1540688427,6),(1650,1553994027,5),(1650,1572138027,6),(1650,1585443627,5),(1650,1603587627,6),(1650,1616893227,5),(1650,1635642027,6),(1650,1648342827,5),(1650,1667091627,6),(1650,1679792427,5),(1650,1698541227,6),(1650,1711846827,5),(1650,1729990827,6),(1650,1743296427,5),(1650,1761440427,6),(1650,1774746027,5),(1650,1792890027,6),(1650,1806195627,5),(1650,1824944427,6),(1650,1837645227,5),(1650,1856394027,6),(1650,1869094827,5),(1650,1887843627,6),(1650,1901149227,5),(1650,1919293227,6),(1650,1932598827,5),(1650,1950742827,6),(1650,1964048427,5),(1650,1982797227,6),(1650,1995498027,5),(1650,2014246827,6),(1650,2026947627,5),(1650,2045696427,6),(1650,2058397227,5),(1650,2077146027,6),(1650,2090451627,5),(1650,2108595627,6),(1650,2121901227,5),(1650,2140045227,6),(1651,-2147483648,1),(1651,-1535938789,3),(1651,-875671200,2),(1651,-859773600,3),(1651,354672009,2),(1651,370396810,3),(1651,386121610,2),(1651,401846411,3),(1651,417574811,4),(1651,433299612,5),(1651,449024412,4),(1651,465354012,5),(1651,481078812,4),(1651,496803613,5),(1651,512528413,4),(1651,528253213,5),(1651,543978013,4),(1651,559702813,5),(1651,575427614,4),(1651,591152414,5),(1651,606877214,4),(1651,622602014,5),(1651,638326815,4),(1651,654656415,5),(1651,670381216,4),(1651,686106016,5),(1651,701830816,4),(1651,717555617,5),(1651,733280417,4),(1651,749005218,5),(1651,764730018,4),(1651,780454819,5),(1651,796179619,4),(1651,811904419,5),(1651,828234020,4),(1651,846378020,5),(1651,859683620,4),(1651,877827621,5),(1651,891133221,4),(1651,909277221,5),(1651,922582822,4),(1651,941331622,5),(1651,954032422,4),(1651,972781222,5),(1651,985482022,4),(1651,1004230822,5),(1651,1017536422,4),(1651,1035680422,5),(1651,1048986022,4),(1651,1067130022,5),(1651,1080435622,4),(1651,1099184422,5),(1651,1111885222,4),(1651,1130634022,5),(1651,1143334823,4),(1651,1162083623,5),(1651,1174784423,4),(1651,1193533223,5),(1651,1206838823,4),(1651,1224982823,5),(1651,1238288424,4),(1651,1256432424,5),(1651,1269738024,4),(1651,1288486824,5),(1651,1301187624,4),(1651,1319936424,5),(1651,1332637224,4),(1651,1351386025,5),(1651,1364691625,4),(1651,1382835625,5),(1651,1396141225,4),(1651,1414285225,5),(1651,1427590825,4),(1651,1445734826,5),(1651,1459040426,4),(1651,1477789226,5),(1651,1490490027,4),(1651,1509238827,5),(1651,1521939627,4),(1651,1540688427,5),(1651,1553994027,4),(1651,1572138027,5),(1651,1585443627,4),(1651,1603587627,5),(1651,1616893227,4),(1651,1635642027,5),(1651,1648342827,4),(1651,1667091627,5),(1651,1679792427,4),(1651,1698541227,5),(1651,1711846827,4),(1651,1729990827,5),(1651,1743296427,4),(1651,1761440427,5),(1651,1774746027,4),(1651,1792890027,5),(1651,1806195627,4),(1651,1824944427,5),(1651,1837645227,4),(1651,1856394027,5),(1651,1869094827,4),(1651,1887843627,5),(1651,1901149227,4),(1651,1919293227,5),(1651,1932598827,4),(1651,1950742827,5),(1651,1964048427,4),(1651,1982797227,5),(1651,1995498027,4),(1651,2014246827,5),(1651,2026947627,4),(1651,2045696427,5),(1651,2058397227,4),(1651,2077146027,5),(1651,2090451627,4),(1651,2108595627,5),(1651,2121901227,4),(1651,2140045227,5),(1652,-2147483648,1),(1652,-1441158600,2),(1652,-1247536800,3),(1652,-899780400,6),(1652,-857257200,4),(1652,-844556400,5),(1652,-828226800,4),(1652,-812502000,5),(1652,-804650400,3),(1652,354920409,7),(1652,370728010,3),(1652,386456410,7),(1652,402264011,3),(1652,417992411,7),(1652,433800012,3),(1652,449614812,7),(1652,465346812,8),(1652,481071612,9),(1652,496796413,8),(1652,512521213,9),(1652,528246013,8),(1652,543970813,9),(1652,559695613,8),(1652,575420414,9),(1652,591145214,8),(1652,606870014,9),(1652,622594814,8),(1652,631141214,3),(1652,670374016,10),(1652,686102416,11),(1652,701827216,10),(1652,717552017,11),(1652,733276817,10),(1652,749001618,11),(1652,764726418,10),(1652,780451219,11),(1652,796176019,10),(1652,811900819,11),(1652,828230420,10),(1652,846374420,11),(1652,859680020,10),(1652,877824021,11),(1652,891129621,10),(1652,909273621,11),(1652,922579222,10),(1652,941328022,11),(1652,954028822,10),(1652,972777622,11),(1652,985478422,10),(1652,1004227222,11),(1652,1017532822,10),(1652,1035676822,11),(1652,1048982422,10),(1652,1067126422,11),(1652,1080432022,10),(1652,1099180822,11),(1652,1111881622,10),(1652,1130630422,11),(1652,1143331223,10),(1652,1162080023,11),(1652,1174780823,10),(1652,1193529623,11),(1652,1206835223,10),(1652,1224979223,11),(1652,1238284824,10),(1652,1256428824,11),(1652,1269734424,10),(1652,1288483224,11),(1652,1301184024,12),(1653,-2147483648,1),(1653,-1855958961,5),(1653,-1689814800,2),(1653,-1680397200,3),(1653,-1665363600,2),(1653,-1648342800,3),(1653,-1635123600,2),(1653,-1616893200,3),(1653,-1604278800,2),(1653,-1585443600,3),(1653,-1574038800,2),(1653,-1552266000,3),(1653,-1539997200,2),(1653,-1520557200,3),(1653,-1507510800,2),(1653,-1490576400,3),(1653,-1470618000,2),(1653,-1459126800,3),(1653,-1444006800,2),(1653,-1427677200,3),(1653,-1411952400,2),(1653,-1396227600,3),(1653,-1379293200,2),(1653,-1364778000,3),(1653,-1348448400,2),(1653,-1333328400,3),(1653,-1316394000,2),(1653,-1301274000,3),(1653,-1284339600,2),(1653,-1269824400,3),(1653,-1253494800,2),(1653,-1238374800,3),(1653,-1221440400,2),(1653,-1206925200,3),(1653,-1191200400,2),(1653,-1175475600,3),(1653,-1160355600,2),(1653,-1143421200,3),(1653,-1127696400,2),(1653,-1111971600,3),(1653,-1096851600,2),(1653,-1080522000,3),(1653,-1063587600,2),(1653,-1049072400,3),(1653,-1033347600,2),(1653,-1017622800,3),(1653,-1002502800,2),(1653,-986173200,3),(1653,-969238800,2),(1653,-950490000,3),(1653,-942012000,4),(1653,-932436000,8),(1653,-857257200,6),(1653,-844556400,7),(1653,-828226800,6),(1653,-812502000,7),(1653,-800071200,9),(1653,-796266000,4),(1653,-781052400,9),(1653,-766623600,10),(1653,196819205,8),(1653,212540405,10),(1653,228877206,11),(1653,243997206,12),(1653,260326807,11),(1653,276051607,12),(1653,291776408,11),(1653,307501208,12),(1653,323830809,11),(1653,338950809,12),(1653,354675609,11),(1653,370400410,12),(1653,386125210,11),(1653,401850011,12),(1653,417574811,11),(1653,433299612,12),(1653,449024412,11),(1653,465354012,12),(1653,481078812,11),(1653,496803613,12),(1653,512528413,11),(1653,528253213,12),(1653,543978013,11),(1653,559702813,12),(1653,575427614,11),(1653,591152414,12),(1653,606877214,11),(1653,622602014,12),(1653,638326815,11),(1653,654656415,12),(1653,670381216,11),(1653,686106016,12),(1653,701830816,11),(1653,717555617,12),(1653,733280417,11),(1653,749005218,12),(1653,764730018,11),(1653,780454819,12),(1653,796179619,11),(1653,811904419,12),(1653,828234020,11),(1653,846378020,12),(1653,859683620,11),(1653,877827621,12),(1653,891133221,11),(1653,909277221,12),(1653,922582822,11),(1653,941331622,12),(1653,954032422,11),(1653,972781222,12),(1653,985482022,11),(1653,1004230822,12),(1653,1017536422,11),(1653,1035680422,12),(1653,1048986022,11),(1653,1067130022,12),(1653,1080435622,11),(1653,1099184422,12),(1653,1111885222,11),(1653,1130634022,12),(1653,1143334823,11),(1653,1162083623,12),(1653,1174784423,11),(1653,1193533223,12),(1653,1206838823,11),(1653,1224982823,12),(1653,1238288424,11),(1653,1256432424,12),(1653,1269738024,11),(1653,1288486824,12),(1653,1301187624,11),(1653,1319936424,12),(1653,1332637224,11),(1653,1351386025,12),(1653,1364691625,11),(1653,1382835625,12),(1653,1396141225,11),(1653,1414285225,12),(1653,1427590825,11),(1653,1445734826,12),(1653,1459040426,11),(1653,1477789226,12),(1653,1490490027,11),(1653,1509238827,12),(1653,1521939627,11),(1653,1540688427,12),(1653,1553994027,11),(1653,1572138027,12),(1653,1585443627,11),(1653,1603587627,12),(1653,1616893227,11),(1653,1635642027,12),(1653,1648342827,11),(1653,1667091627,12),(1653,1679792427,11),(1653,1698541227,12),(1653,1711846827,11),(1653,1729990827,12),(1653,1743296427,11),(1653,1761440427,12),(1653,1774746027,11),(1653,1792890027,12),(1653,1806195627,11),(1653,1824944427,12),(1653,1837645227,11),(1653,1856394027,12),(1653,1869094827,11),(1653,1887843627,12),(1653,1901149227,11),(1653,1919293227,12),(1653,1932598827,11),(1653,1950742827,12),(1653,1964048427,11),(1653,1982797227,12),(1653,1995498027,11),(1653,2014246827,12),(1653,2026947627,11),(1653,2045696427,12),(1653,2058397227,11),(1653,2077146027,12),(1653,2090451627,11),(1653,2108595627,12),(1653,2121901227,11),(1653,2140045227,12),(1654,-2147483648,1),(1654,-1688265017,3),(1654,-1656819079,2),(1654,-1641353479,3),(1654,-1627965079,4),(1654,-1618716679,2),(1654,-1596429079,4),(1654,-1593820800,5),(1654,-1589860800,6),(1654,-1542427200,7),(1654,-1539493200,8),(1654,-1525323600,7),(1654,-1522728000,6),(1654,-1491188400,9),(1654,-1247536800,6),(1654,354920409,7),(1654,370728010,6),(1654,386456410,7),(1654,402264011,6),(1654,417992411,7),(1654,433800012,6),(1654,449614812,7),(1654,465346812,10),(1654,481071612,11),(1654,496796413,10),(1654,512521213,11),(1654,528246013,10),(1654,543970813,11),(1654,559695613,10),(1654,575420414,11),(1654,591145214,10),(1654,606870014,11),(1654,622594814,10),(1654,638319615,11),(1654,654649215,10),(1654,670374016,12),(1654,686102416,13),(1654,695779216,10),(1654,701823616,11),(1654,717548417,10),(1654,733273217,11),(1654,748998018,10),(1654,764722818,11),(1654,780447619,10),(1654,796172419,11),(1654,811897219,10),(1654,828226820,11),(1654,846370820,10),(1654,859676420,11),(1654,877820421,10),(1654,891126021,11),(1654,909270021,10),(1654,922575622,11),(1654,941324422,10),(1654,954025222,11),(1654,972774022,10),(1654,985474822,11),(1654,1004223622,10),(1654,1017529222,11),(1654,1035673222,10),(1654,1048978822,11),(1654,1067122822,10),(1654,1080428422,11),(1654,1099177222,10),(1654,1111878022,11),(1654,1130626822,10),(1654,1143327623,11),(1654,1162076423,10),(1654,1174777223,11),(1654,1193526023,10),(1654,1206831623,11),(1654,1224975623,10),(1654,1238281224,11),(1654,1256425224,10),(1654,1269730824,11),(1654,1288479624,10),(1654,1301180424,14),(1654,1414274425,10),(1655,-2147483648,0),(1655,-1518920008,2),(1655,166572004,1),(1655,182293204,2),(1655,200959205,1),(1655,213829205,2),(1655,228866406,1),(1655,243982806,2),(1655,260316007,1),(1655,276123607,2),(1655,291765608,1),(1655,307486808,2),(1655,323820009,1),(1655,338936409,2),(1655,354664809,1),(1655,370386010,2),(1655,386114410,1),(1655,401835611,2),(1655,417564011,1),(1655,433285212,2),(1655,449013612,1),(1655,465339612,2),(1655,481068012,1),(1655,496789213,2),(1655,512517613,1),(1655,528238813,2),(1655,543967213,1),(1655,559688413,2),(1655,575416814,1),(1655,591138014,2),(1655,606866414,1),(1655,622587614,2),(1655,638316015,1),(1655,654642015,2),(1655,670370416,1),(1655,686091616,2),(1655,701820016,1),(1655,717541217,2),(1655,733269617,1),(1655,748990818,2),(1655,764719218,1),(1655,780440419,2),(1655,796168819,1),(1655,811890019,2),(1655,828223220,1),(1655,843944420,2),(1655,859672820,1),(1655,875394021,2),(1655,891122421,1),(1655,909277221,3),(1655,922582822,4),(1655,941331622,3),(1655,954032422,4),(1655,972781222,3),(1655,985482022,4),(1655,1004230822,3),(1655,1017536422,4),(1655,1035680422,3),(1655,1048986022,4),(1655,1067130022,3),(1655,1080435622,4),(1655,1099184422,3),(1655,1111885222,4),(1655,1130634022,3),(1655,1143334823,4),(1655,1162083623,3),(1655,1174784423,4),(1655,1193533223,3),(1655,1206838823,4),(1655,1224982823,3),(1655,1238288424,4),(1655,1256432424,3),(1655,1269738024,4),(1655,1288486824,3),(1655,1301187624,4),(1655,1319936424,3),(1655,1332637224,4),(1655,1351386025,3),(1655,1364691625,4),(1655,1382835625,3),(1655,1396141225,4),(1655,1414285225,3),(1655,1427590825,4),(1655,1445734826,3),(1655,1459040426,4),(1655,1477789226,3),(1655,1490490027,4),(1655,1509238827,3),(1655,1521939627,4),(1655,1540688427,3),(1655,1553994027,4),(1655,1572138027,3),(1655,1585443627,4),(1655,1603587627,3),(1655,1616893227,4),(1655,1635642027,3),(1655,1648342827,4),(1655,1667091627,3),(1655,1679792427,4),(1655,1698541227,3),(1655,1711846827,4),(1655,1729990827,3),(1655,1743296427,4),(1655,1761440427,3),(1655,1774746027,4),(1655,1792890027,3),(1655,1806195627,4),(1655,1824944427,3),(1655,1837645227,4),(1655,1856394027,3),(1655,1869094827,4),(1655,1887843627,3),(1655,1901149227,4),(1655,1919293227,3),(1655,1932598827,4),(1655,1950742827,3),(1655,1964048427,4),(1655,1982797227,3),(1655,1995498027,4),(1655,2014246827,3),(1655,2026947627,4),(1655,2045696427,3),(1655,2058397227,4),(1655,2077146027,3),(1655,2090451627,4),(1655,2108595627,3),(1655,2121901227,4),(1655,2140045227,3),(1656,-2147483648,2),(1656,-1693706400,1),(1656,-1680483600,2),(1656,-1663455600,3),(1656,-1650150000,4),(1656,-1632006000,3),(1656,-1618700400,4),(1656,-938905200,3),(1656,-857257200,4),(1656,-844556400,3),(1656,-828226800,4),(1656,-812502000,3),(1656,-796777200,4),(1656,-781052400,3),(1656,-776563200,5),(1656,-765936000,1),(1656,-761180400,4),(1656,-757386000,2),(1656,-748479600,3),(1656,-733273200,4),(1656,-717631200,3),(1656,-714610800,6),(1656,-710380800,1),(1656,-701910000,4),(1656,-684975600,3),(1656,-670460400,4),(1656,-654130800,3),(1656,-639010800,4),(1656,315529208,2),(1656,323830809,7),(1656,338950809,8),(1656,354675609,7),(1656,370400410,8),(1656,386125210,7),(1656,401850011,8),(1656,417574811,7),(1656,433299612,8),(1656,449024412,7),(1656,465354012,8),(1656,481078812,7),(1656,496803613,8),(1656,512528413,7),(1656,528253213,8),(1656,543978013,7),(1656,559702813,8),(1656,575427614,7),(1656,591152414,8),(1656,606877214,7),(1656,622602014,8),(1656,638326815,7),(1656,654656415,8),(1656,670381216,7),(1656,686106016,8),(1656,701830816,7),(1656,717555617,8),(1656,733280417,7),(1656,749005218,8),(1656,764730018,7),(1656,780454819,8),(1656,796179619,7),(1656,811904419,8),(1656,828234020,7),(1656,846378020,8),(1656,859683620,7),(1656,877827621,8),(1656,891133221,7),(1656,909277221,8),(1656,922582822,7),(1656,941331622,8),(1656,954032422,7),(1656,972781222,8),(1656,985482022,7),(1656,1004230822,8),(1656,1017536422,7),(1656,1035680422,8),(1656,1048986022,7),(1656,1067130022,8),(1656,1080435622,7),(1656,1099184422,8),(1656,1111885222,7),(1656,1130634022,8),(1656,1143334823,7),(1656,1162083623,8),(1656,1174784423,7),(1656,1193533223,8),(1656,1206838823,7),(1656,1224982823,8),(1656,1238288424,7),(1656,1256432424,8),(1656,1269738024,7),(1656,1288486824,8),(1656,1301187624,7),(1656,1319936424,8),(1656,1332637224,7),(1656,1351386025,8),(1656,1364691625,7),(1656,1382835625,8),(1656,1396141225,7),(1656,1414285225,8),(1656,1427590825,7),(1656,1445734826,8),(1656,1459040426,7),(1656,1477789226,8),(1656,1490490027,7),(1656,1509238827,8),(1656,1521939627,7),(1656,1540688427,8),(1656,1553994027,7),(1656,1572138027,8),(1656,1585443627,7),(1656,1603587627,8),(1656,1616893227,7),(1656,1635642027,8),(1656,1648342827,7),(1656,1667091627,8),(1656,1679792427,7),(1656,1698541227,8),(1656,1711846827,7),(1656,1729990827,8),(1656,1743296427,7),(1656,1761440427,8),(1656,1774746027,7),(1656,1792890027,8),(1656,1806195627,7),(1656,1824944427,8),(1656,1837645227,7),(1656,1856394027,8),(1656,1869094827,7),(1656,1887843627,8),(1656,1901149227,7),(1656,1919293227,8),(1656,1932598827,7),(1656,1950742827,8),(1656,1964048427,7),(1656,1982797227,8),(1656,1995498027,7),(1656,2014246827,8),(1656,2026947627,7),(1656,2045696427,8),(1656,2058397227,7),(1656,2077146027,8),(1656,2090451627,7),(1656,2108595627,8),(1656,2121901227,7),(1656,2140045227,8),(1657,-2147483648,1),(1657,-1855958961,5),(1657,-1689814800,2),(1657,-1680397200,3),(1657,-1665363600,2),(1657,-1648342800,3),(1657,-1635123600,2),(1657,-1616893200,3),(1657,-1604278800,2),(1657,-1585443600,3),(1657,-1574038800,2),(1657,-1552266000,3),(1657,-1539997200,2),(1657,-1520557200,3),(1657,-1507510800,2),(1657,-1490576400,3),(1657,-1470618000,2),(1657,-1459126800,3),(1657,-1444006800,2),(1657,-1427677200,3),(1657,-1411952400,2),(1657,-1396227600,3),(1657,-1379293200,2),(1657,-1364778000,3),(1657,-1348448400,2),(1657,-1333328400,3),(1657,-1316394000,2),(1657,-1301274000,3),(1657,-1284339600,2),(1657,-1269824400,3),(1657,-1253494800,2),(1657,-1238374800,3),(1657,-1221440400,2),(1657,-1206925200,3),(1657,-1191200400,2),(1657,-1175475600,3),(1657,-1160355600,2),(1657,-1143421200,3),(1657,-1127696400,2),(1657,-1111971600,3),(1657,-1096851600,2),(1657,-1080522000,3),(1657,-1063587600,2),(1657,-1049072400,3),(1657,-1033347600,2),(1657,-1017622800,3),(1657,-1002502800,2),(1657,-986173200,3),(1657,-969238800,2),(1657,-950490000,3),(1657,-942012000,4),(1657,-932436000,8),(1657,-857257200,6),(1657,-844556400,7),(1657,-828226800,6),(1657,-812502000,7),(1657,-800071200,9),(1657,-796266000,4),(1657,-781052400,9),(1657,-766623600,10),(1657,196819205,8),(1657,212540405,10),(1657,228877206,11),(1657,243997206,12),(1657,260326807,11),(1657,276051607,12),(1657,291776408,11),(1657,307501208,12),(1657,323830809,11),(1657,338950809,12),(1657,354675609,11),(1657,370400410,12),(1657,386125210,11),(1657,401850011,12),(1657,417574811,11),(1657,433299612,12),(1657,449024412,11),(1657,465354012,12),(1657,481078812,11),(1657,496803613,12),(1657,512528413,11),(1657,528253213,12),(1657,543978013,11),(1657,559702813,12),(1657,575427614,11),(1657,591152414,12),(1657,606877214,11),(1657,622602014,12),(1657,638326815,11),(1657,654656415,12),(1657,670381216,11),(1657,686106016,12),(1657,701830816,11),(1657,717555617,12),(1657,733280417,11),(1657,749005218,12),(1657,764730018,11),(1657,780454819,12),(1657,796179619,11),(1657,811904419,12),(1657,828234020,11),(1657,846378020,12),(1657,859683620,11),(1657,877827621,12),(1657,891133221,11),(1657,909277221,12),(1657,922582822,11),(1657,941331622,12),(1657,954032422,11),(1657,972781222,12),(1657,985482022,11),(1657,1004230822,12),(1657,1017536422,11),(1657,1035680422,12),(1657,1048986022,11),(1657,1067130022,12),(1657,1080435622,11),(1657,1099184422,12),(1657,1111885222,11),(1657,1130634022,12),(1657,1143334823,11),(1657,1162083623,12),(1657,1174784423,11),(1657,1193533223,12),(1657,1206838823,11),(1657,1224982823,12),(1657,1238288424,11),(1657,1256432424,12),(1657,1269738024,11),(1657,1288486824,12),(1657,1301187624,11),(1657,1319936424,12),(1657,1332637224,11),(1657,1351386025,12),(1657,1364691625,11),(1657,1382835625,12),(1657,1396141225,11),(1657,1414285225,12),(1657,1427590825,11),(1657,1445734826,12),(1657,1459040426,11),(1657,1477789226,12),(1657,1490490027,11),(1657,1509238827,12),(1657,1521939627,11),(1657,1540688427,12),(1657,1553994027,11),(1657,1572138027,12),(1657,1585443627,11),(1657,1603587627,12),(1657,1616893227,11),(1657,1635642027,12),(1657,1648342827,11),(1657,1667091627,12),(1657,1679792427,11),(1657,1698541227,12),(1657,1711846827,11),(1657,1729990827,12),(1657,1743296427,11),(1657,1761440427,12),(1657,1774746027,11),(1657,1792890027,12),(1657,1806195627,11),(1657,1824944427,12),(1657,1837645227,11),(1657,1856394027,12),(1657,1869094827,11),(1657,1887843627,12),(1657,1901149227,11),(1657,1919293227,12),(1657,1932598827,11),(1657,1950742827,12),(1657,1964048427,11),(1657,1982797227,12),(1657,1995498027,11),(1657,2014246827,12),(1657,2026947627,11),(1657,2045696427,12),(1657,2058397227,11),(1657,2077146027,12),(1657,2090451627,11),(1657,2108595627,12),(1657,2121901227,11),(1657,2140045227,12),(1658,-2147483648,1),(1658,-905824800,4),(1658,-857257200,2),(1658,-844556400,3),(1658,-828226800,2),(1658,-812502000,3),(1658,-796777200,2),(1658,-788922000,1),(1658,-777942000,3),(1658,-766623600,2),(1658,407199611,1),(1658,417574811,5),(1658,433299612,6),(1658,449024412,5),(1658,465354012,6),(1658,481078812,5),(1658,496803613,6),(1658,512528413,5),(1658,528253213,6),(1658,543978013,5),(1658,559702813,6),(1658,575427614,5),(1658,591152414,6),(1658,606877214,5),(1658,622602014,6),(1658,638326815,5),(1658,654656415,6),(1658,670381216,5),(1658,686106016,6),(1658,701830816,5),(1658,717555617,6),(1658,733280417,5),(1658,749005218,6),(1658,764730018,5),(1658,780454819,6),(1658,796179619,5),(1658,811904419,6),(1658,828234020,5),(1658,846378020,6),(1658,859683620,5),(1658,877827621,6),(1658,891133221,5),(1658,909277221,6),(1658,922582822,5),(1658,941331622,6),(1658,954032422,5),(1658,972781222,6),(1658,985482022,5),(1658,1004230822,6),(1658,1017536422,5),(1658,1035680422,6),(1658,1048986022,5),(1658,1067130022,6),(1658,1080435622,5),(1658,1099184422,6),(1658,1111885222,5),(1658,1130634022,6),(1658,1143334823,5),(1658,1162083623,6),(1658,1174784423,5),(1658,1193533223,6),(1658,1206838823,5),(1658,1224982823,6),(1658,1238288424,5),(1658,1256432424,6),(1658,1269738024,5),(1658,1288486824,6),(1658,1301187624,5),(1658,1319936424,6),(1658,1332637224,5),(1658,1351386025,6),(1658,1364691625,5),(1658,1382835625,6),(1658,1396141225,5),(1658,1414285225,6),(1658,1427590825,5),(1658,1445734826,6),(1658,1459040426,5),(1658,1477789226,6),(1658,1490490027,5),(1658,1509238827,6),(1658,1521939627,5),(1658,1540688427,6),(1658,1553994027,5),(1658,1572138027,6),(1658,1585443627,5),(1658,1603587627,6),(1658,1616893227,5),(1658,1635642027,6),(1658,1648342827,5),(1658,1667091627,6),(1658,1679792427,5),(1658,1698541227,6),(1658,1711846827,5),(1658,1729990827,6),(1658,1743296427,5),(1658,1761440427,6),(1658,1774746027,5),(1658,1792890027,6),(1658,1806195627,5),(1658,1824944427,6),(1658,1837645227,5),(1658,1856394027,6),(1658,1869094827,5),(1658,1887843627,6),(1658,1901149227,5),(1658,1919293227,6),(1658,1932598827,5),(1658,1950742827,6),(1658,1964048427,5),(1658,1982797227,6),(1658,1995498027,5),(1658,2014246827,6),(1658,2026947627,5),(1658,2045696427,6),(1658,2058397227,5),(1658,2077146027,6),(1658,2090451627,5),(1658,2108595627,6),(1658,2121901227,5),(1658,2140045227,6),(1659,-2147483648,2),(1659,-1693706400,1),(1659,-1680483600,2),(1659,-1663455600,3),(1659,-1650150000,4),(1659,-1632006000,3),(1659,-1618700400,4),(1659,-938905200,3),(1659,-857257200,4),(1659,-844556400,3),(1659,-828226800,4),(1659,-812502000,3),(1659,-796777200,4),(1659,-781052400,3),(1659,-777866400,1),(1659,-765327600,4),(1659,-746578800,3),(1659,-733359600,4),(1659,-728517600,5),(1659,-721260000,2),(1659,-716425200,3),(1659,-701910000,4),(1659,-684975600,3),(1659,-670460400,4),(1659,-654217200,3),(1659,-639010800,4),(1659,283993207,2),(1659,291776408,6),(1659,307501208,7),(1659,323830809,6),(1659,338950809,7),(1659,354675609,6),(1659,370400410,7),(1659,386125210,6),(1659,401850011,7),(1659,417574811,6),(1659,433299612,7),(1659,449024412,6),(1659,465354012,7),(1659,481078812,6),(1659,496803613,7),(1659,512528413,6),(1659,528253213,7),(1659,543978013,6),(1659,559702813,7),(1659,575427614,6),(1659,591152414,7),(1659,606877214,6),(1659,622602014,7),(1659,638326815,6),(1659,654656415,7),(1659,670381216,6),(1659,686106016,7),(1659,701830816,6),(1659,717555617,7),(1659,733280417,6),(1659,749005218,7),(1659,764730018,6),(1659,780454819,7),(1659,796179619,6),(1659,811904419,7),(1659,828234020,6),(1659,846378020,7),(1659,859683620,6),(1659,877827621,7),(1659,891133221,6),(1659,909277221,7),(1659,922582822,6),(1659,941331622,7),(1659,954032422,6),(1659,972781222,7),(1659,985482022,6),(1659,1004230822,7),(1659,1017536422,6),(1659,1035680422,7),(1659,1048986022,6),(1659,1067130022,7),(1659,1080435622,6),(1659,1099184422,7),(1659,1111885222,6),(1659,1130634022,7),(1659,1143334823,6),(1659,1162083623,7),(1659,1174784423,6),(1659,1193533223,7),(1659,1206838823,6),(1659,1224982823,7),(1659,1238288424,6),(1659,1256432424,7),(1659,1269738024,6),(1659,1288486824,7),(1659,1301187624,6),(1659,1319936424,7),(1659,1332637224,6),(1659,1351386025,7),(1659,1364691625,6),(1659,1382835625,7),(1659,1396141225,6),(1659,1414285225,7),(1659,1427590825,6),(1659,1445734826,7),(1659,1459040426,6),(1659,1477789226,7),(1659,1490490027,6),(1659,1509238827,7),(1659,1521939627,6),(1659,1540688427,7),(1659,1553994027,6),(1659,1572138027,7),(1659,1585443627,6),(1659,1603587627,7),(1659,1616893227,6),(1659,1635642027,7),(1659,1648342827,6),(1659,1667091627,7),(1659,1679792427,6),(1659,1698541227,7),(1659,1711846827,6),(1659,1729990827,7),(1659,1743296427,6),(1659,1761440427,7),(1659,1774746027,6),(1659,1792890027,7),(1659,1806195627,6),(1659,1824944427,7),(1659,1837645227,6),(1659,1856394027,7),(1659,1869094827,6),(1659,1887843627,7),(1659,1901149227,6),(1659,1919293227,7),(1659,1932598827,6),(1659,1950742827,7),(1659,1964048427,6),(1659,1982797227,7),(1659,1995498027,6),(1659,2014246827,7),(1659,2026947627,6),(1659,2045696427,7),(1659,2058397227,6),(1659,2077146027,7),(1659,2090451627,6),(1659,2108595627,7),(1659,2121901227,6),(1659,2140045227,7),(1660,-2147483648,1),(1660,-1632008194,2),(1660,-1618702594,1),(1660,-1601681794,2),(1660,-1597275394,1),(1660,-1377308194,3),(1660,-928029600,4),(1660,-899521200,7),(1660,-857257200,5),(1660,-844556400,6),(1660,-828226800,5),(1660,-812502000,6),(1660,-796777200,5),(1660,-795834000,4),(1660,354920409,8),(1660,370728010,4),(1660,386456410,8),(1660,402264011,4),(1660,417992411,8),(1660,433800012,4),(1660,449614812,8),(1660,465346812,9),(1660,481071612,10),(1660,496796413,9),(1660,512521213,10),(1660,528246013,9),(1660,543970813,10),(1660,559695613,9),(1660,575420414,10),(1660,591145214,9),(1660,606870014,11),(1660,622598414,12),(1660,638323215,11),(1660,654652815,12),(1660,670377616,11),(1660,686102416,12),(1660,701827216,11),(1660,717552017,12),(1660,733276817,11),(1660,749001618,12),(1660,764726418,11),(1660,780451219,12),(1660,796176019,11),(1660,811900819,12),(1660,828230420,11),(1660,843955220,12),(1660,853797620,3),(1660,859683620,13),(1660,877827621,14),(1660,891133221,13),(1660,909277221,14),(1660,922582822,13),(1660,941331622,14),(1660,951775222,3),(1660,985482022,13),(1660,1004230822,14),(1660,1017536422,13),(1660,1035680422,14),(1660,1048986022,13),(1660,1067130022,14),(1660,1080435622,13),(1660,1099184422,14),(1660,1111885222,13),(1660,1130634022,14),(1660,1143334823,13),(1660,1162083623,14),(1660,1174784423,13),(1660,1193533223,14),(1660,1206838823,13),(1660,1224982823,14),(1660,1238288424,13),(1660,1256432424,14),(1660,1269738024,13),(1660,1288486824,14),(1660,1301187624,13),(1660,1319936424,14),(1660,1332637224,13),(1660,1351386025,14),(1660,1364691625,13),(1660,1382835625,14),(1660,1396141225,13),(1660,1414285225,14),(1660,1427590825,13),(1660,1445734826,14),(1660,1459040426,13),(1660,1477789226,14),(1660,1490490027,13),(1660,1509238827,14),(1660,1521939627,13),(1660,1540688427,14),(1660,1553994027,13),(1660,1572138027,14),(1660,1585443627,13),(1660,1603587627,14),(1660,1616893227,13),(1660,1635642027,14),(1660,1648342827,13),(1660,1667091627,14),(1660,1679792427,13),(1660,1698541227,14),(1660,1711846827,13),(1660,1729990827,14),(1660,1743296427,13),(1660,1761440427,14),(1660,1774746027,13),(1660,1792890027,14),(1660,1806195627,13),(1660,1824944427,14),(1660,1837645227,13),(1660,1856394027,14),(1660,1869094827,13),(1660,1887843627,14),(1660,1901149227,13),(1660,1919293227,14),(1660,1932598827,13),(1660,1950742827,14),(1660,1964048427,13),(1660,1982797227,14),(1660,1995498027,13),(1660,2014246827,14),(1660,2026947627,13),(1660,2045696427,14),(1660,2058397227,13),(1660,2077146027,14),(1660,2090451627,13),(1660,2108595627,14),(1660,2121901227,13),(1660,2140045227,14),(1661,-2147483648,5),(1661,-1690765200,1),(1661,-1680487200,2),(1661,-1664758800,1),(1661,-1648951200,2),(1661,-1635123600,1),(1661,-1616896800,2),(1661,-1604278800,1),(1661,-1585533600,2),(1661,-1571014800,1),(1661,-1555293600,2),(1661,-932432400,1),(1661,-857257200,3),(1661,-844556400,4),(1661,-830311200,1),(1661,-828226800,3),(1661,-812502000,4),(1661,-807156000,1),(1661,-798073200,3),(1661,-781052400,1),(1661,-766717200,2),(1661,-750898800,4),(1661,-733359600,3),(1661,-719456400,4),(1661,-701917200,3),(1661,-689209200,4),(1661,-670460400,3),(1661,-114051600,4),(1661,-103168800,2),(1661,-81997200,4),(1661,-71715600,3),(1661,-50547600,4),(1661,-40266000,3),(1661,-18493200,4),(1661,-8211600,3),(1661,12956400,4),(1661,23238000,3),(1661,43801200,4),(1661,54687600,3),(1661,75855600,4),(1661,86742001,3),(1661,107910002,4),(1661,118191602,3),(1661,138754803,4),(1661,149641203,3),(1661,170809204,4),(1661,181090804,3),(1661,202258805,4),(1661,212540405,3),(1661,233103606,4),(1661,243990006,3),(1661,265158007,4),(1661,276044407,3),(1661,296607608,4),(1661,307494008,3),(1661,315529208,2),(1661,323830809,6),(1661,338950809,5),(1661,354675609,6),(1661,370400410,5),(1661,386125210,6),(1661,401850011,5),(1661,417574811,6),(1661,433299612,5),(1661,449024412,6),(1661,465354012,5),(1661,481078812,6),(1661,496803613,5),(1661,512528413,6),(1661,528253213,5),(1661,543978013,6),(1661,559702813,5),(1661,575427614,6),(1661,591152414,5),(1661,606877214,6),(1661,622602014,5),(1661,638326815,6),(1661,654656415,5),(1661,670381216,6),(1661,686106016,5),(1661,701830816,6),(1661,717555617,5),(1661,733280417,6),(1661,749005218,5),(1661,764730018,6),(1661,780454819,5),(1661,796179619,6),(1661,811904419,5),(1661,828234020,6),(1661,846378020,5),(1661,859683620,6),(1661,877827621,5),(1661,891133221,6),(1661,909277221,5),(1661,922582822,6),(1661,941331622,5),(1661,954032422,6),(1661,972781222,5),(1661,985482022,6),(1661,1004230822,5),(1661,1017536422,6),(1661,1035680422,5),(1661,1048986022,6),(1661,1067130022,5),(1661,1080435622,6),(1661,1099184422,5),(1661,1111885222,6),(1661,1130634022,5),(1661,1143334823,6),(1661,1162083623,5),(1661,1174784423,6),(1661,1193533223,5),(1661,1206838823,6),(1661,1224982823,5),(1661,1238288424,6),(1661,1256432424,5),(1661,1269738024,6),(1661,1288486824,5),(1661,1301187624,6),(1661,1319936424,5),(1661,1332637224,6),(1661,1351386025,5),(1661,1364691625,6),(1661,1382835625,5),(1661,1396141225,6),(1661,1414285225,5),(1661,1427590825,6),(1661,1445734826,5),(1661,1459040426,6),(1661,1477789226,5),(1661,1490490027,6),(1661,1509238827,5),(1661,1521939627,6),(1661,1540688427,5),(1661,1553994027,6),(1661,1572138027,5),(1661,1585443627,6),(1661,1603587627,5),(1661,1616893227,6),(1661,1635642027,5),(1661,1648342827,6),(1661,1667091627,5),(1661,1679792427,6),(1661,1698541227,5),(1661,1711846827,6),(1661,1729990827,5),(1661,1743296427,6),(1661,1761440427,5),(1661,1774746027,6),(1661,1792890027,5),(1661,1806195627,6),(1661,1824944427,5),(1661,1837645227,6),(1661,1856394027,5),(1661,1869094827,6),(1661,1887843627,5),(1661,1901149227,6),(1661,1919293227,5),(1661,1932598827,6),(1661,1950742827,5),(1661,1964048427,6),(1661,1982797227,5),(1661,1995498027,6),(1661,2014246827,5),(1661,2026947627,6),(1661,2045696427,5),(1661,2058397227,6),(1661,2077146027,5),(1661,2090451627,6),(1661,2108595627,5),(1661,2121901227,6),(1661,2140045227,5),(1662,-2147483648,0),(1662,-1593820800,1),(1662,-1247540400,2),(1662,354916809,3),(1662,370724410,2),(1662,386452810,3),(1662,402260411,2),(1662,417988811,3),(1662,433796412,2),(1662,449611212,3),(1662,465343212,4),(1662,481068012,5),(1662,496792813,4),(1662,512517613,5),(1662,528242413,4),(1662,543967213,5),(1662,559692013,4),(1662,575416814,5),(1662,591141614,4),(1662,606866414,6),(1662,622594814,7),(1662,638319615,6),(1662,654649215,7),(1662,670374016,8),(1662,686102416,7),(1662,687916816,2),(1662,701820016,5),(1662,717544817,4),(1662,733269617,5),(1662,748994418,4),(1662,764719218,5),(1662,780444019,4),(1662,796168819,5),(1662,811893619,4),(1662,828223220,5),(1662,846367220,4),(1662,859672820,5),(1662,877816821,4),(1662,891122421,5),(1662,909266421,4),(1662,922572022,5),(1662,941320822,4),(1662,954021622,5),(1662,972770422,4),(1662,985471222,5),(1662,1004220022,4),(1662,1017525622,5),(1662,1035669622,4),(1662,1048975222,5),(1662,1067119222,4),(1662,1080424822,5),(1662,1099173622,4),(1662,1111874422,5),(1662,1130623222,4),(1662,1143324023,5),(1662,1162072823,4),(1662,1174773623,5),(1662,1193522423,4),(1662,1206828023,5),(1662,1224972023,4),(1662,1238277624,5),(1662,1256421624,4),(1662,1269727224,6),(1662,1288479624,7),(1662,1301180424,4),(1663,-2147483648,5),(1663,-1690765200,1),(1663,-1680487200,2),(1663,-1664758800,1),(1663,-1648951200,2),(1663,-1635123600,1),(1663,-1616896800,2),(1663,-1604278800,1),(1663,-1585533600,2),(1663,-1571014800,1),(1663,-1555293600,2),(1663,-932432400,1),(1663,-857257200,3),(1663,-844556400,4),(1663,-830311200,1),(1663,-828226800,3),(1663,-812502000,4),(1663,-807156000,1),(1663,-798073200,3),(1663,-781052400,1),(1663,-766717200,2),(1663,-750898800,4),(1663,-733359600,3),(1663,-719456400,4),(1663,-701917200,3),(1663,-689209200,4),(1663,-670460400,3),(1663,-114051600,4),(1663,-103168800,2),(1663,-81997200,4),(1663,-71715600,3),(1663,-50547600,4),(1663,-40266000,3),(1663,-18493200,4),(1663,-8211600,3),(1663,12956400,4),(1663,23238000,3),(1663,43801200,4),(1663,54687600,3),(1663,75855600,4),(1663,86742001,3),(1663,107910002,4),(1663,118191602,3),(1663,138754803,4),(1663,149641203,3),(1663,170809204,4),(1663,181090804,3),(1663,202258805,4),(1663,212540405,3),(1663,233103606,4),(1663,243990006,3),(1663,265158007,4),(1663,276044407,3),(1663,296607608,4),(1663,307494008,3),(1663,315529208,2),(1663,323830809,6),(1663,338950809,5),(1663,354675609,6),(1663,370400410,5),(1663,386125210,6),(1663,401850011,5),(1663,417574811,6),(1663,433299612,5),(1663,449024412,6),(1663,465354012,5),(1663,481078812,6),(1663,496803613,5),(1663,512528413,6),(1663,528253213,5),(1663,543978013,6),(1663,559702813,5),(1663,575427614,6),(1663,591152414,5),(1663,606877214,6),(1663,622602014,5),(1663,638326815,6),(1663,654656415,5),(1663,670381216,6),(1663,686106016,5),(1663,701830816,6),(1663,717555617,5),(1663,733280417,6),(1663,749005218,5),(1663,764730018,6),(1663,780454819,5),(1663,796179619,6),(1663,811904419,5),(1663,828234020,6),(1663,846378020,5),(1663,859683620,6),(1663,877827621,5),(1663,891133221,6),(1663,909277221,5),(1663,922582822,6),(1663,941331622,5),(1663,954032422,6),(1663,972781222,5),(1663,985482022,6),(1663,1004230822,5),(1663,1017536422,6),(1663,1035680422,5),(1663,1048986022,6),(1663,1067130022,5),(1663,1080435622,6),(1663,1099184422,5),(1663,1111885222,6),(1663,1130634022,5),(1663,1143334823,6),(1663,1162083623,5),(1663,1174784423,6),(1663,1193533223,5),(1663,1206838823,6),(1663,1224982823,5),(1663,1238288424,6),(1663,1256432424,5),(1663,1269738024,6),(1663,1288486824,5),(1663,1301187624,6),(1663,1319936424,5),(1663,1332637224,6),(1663,1351386025,5),(1663,1364691625,6),(1663,1382835625,5),(1663,1396141225,6),(1663,1414285225,5),(1663,1427590825,6),(1663,1445734826,5),(1663,1459040426,6),(1663,1477789226,5),(1663,1490490027,6),(1663,1509238827,5),(1663,1521939627,6),(1663,1540688427,5),(1663,1553994027,6),(1663,1572138027,5),(1663,1585443627,6),(1663,1603587627,5),(1663,1616893227,6),(1663,1635642027,5),(1663,1648342827,6),(1663,1667091627,5),(1663,1679792427,6),(1663,1698541227,5),(1663,1711846827,6),(1663,1729990827,5),(1663,1743296427,6),(1663,1761440427,5),(1663,1774746027,6),(1663,1792890027,5),(1663,1806195627,6),(1663,1824944427,5),(1663,1837645227,6),(1663,1856394027,5),(1663,1869094827,6),(1663,1887843627,5),(1663,1901149227,6),(1663,1919293227,5),(1663,1932598827,6),(1663,1950742827,5),(1663,1964048427,6),(1663,1982797227,5),(1663,1995498027,6),(1663,2014246827,5),(1663,2026947627,6),(1663,2045696427,5),(1663,2058397227,6),(1663,2077146027,5),(1663,2090451627,6),(1663,2108595627,5),(1663,2121901227,6),(1663,2140045227,5),(1664,-2147483648,1),(1664,-905824800,4),(1664,-857257200,2),(1664,-844556400,3),(1664,-828226800,2),(1664,-812502000,3),(1664,-796777200,2),(1664,-788922000,1),(1664,-777942000,3),(1664,-766623600,2),(1664,407199611,1),(1664,417574811,5),(1664,433299612,6),(1664,449024412,5),(1664,465354012,6),(1664,481078812,5),(1664,496803613,6),(1664,512528413,5),(1664,528253213,6),(1664,543978013,5),(1664,559702813,6),(1664,575427614,5),(1664,591152414,6),(1664,606877214,5),(1664,622602014,6),(1664,638326815,5),(1664,654656415,6),(1664,670381216,5),(1664,686106016,6),(1664,701830816,5),(1664,717555617,6),(1664,733280417,5),(1664,749005218,6),(1664,764730018,5),(1664,780454819,6),(1664,796179619,5),(1664,811904419,6),(1664,828234020,5),(1664,846378020,6),(1664,859683620,5),(1664,877827621,6),(1664,891133221,5),(1664,909277221,6),(1664,922582822,5),(1664,941331622,6),(1664,954032422,5),(1664,972781222,6),(1664,985482022,5),(1664,1004230822,6),(1664,1017536422,5),(1664,1035680422,6),(1664,1048986022,5),(1664,1067130022,6),(1664,1080435622,5),(1664,1099184422,6),(1664,1111885222,5),(1664,1130634022,6),(1664,1143334823,5),(1664,1162083623,6),(1664,1174784423,5),(1664,1193533223,6),(1664,1206838823,5),(1664,1224982823,6),(1664,1238288424,5),(1664,1256432424,6),(1664,1269738024,5),(1664,1288486824,6),(1664,1301187624,5),(1664,1319936424,6),(1664,1332637224,5),(1664,1351386025,6),(1664,1364691625,5),(1664,1382835625,6),(1664,1396141225,5),(1664,1414285225,6),(1664,1427590825,5),(1664,1445734826,6),(1664,1459040426,5),(1664,1477789226,6),(1664,1490490027,5),(1664,1509238827,6),(1664,1521939627,5),(1664,1540688427,6),(1664,1553994027,5),(1664,1572138027,6),(1664,1585443627,5),(1664,1603587627,6),(1664,1616893227,5),(1664,1635642027,6),(1664,1648342827,5),(1664,1667091627,6),(1664,1679792427,5),(1664,1698541227,6),(1664,1711846827,5),(1664,1729990827,6),(1664,1743296427,5),(1664,1761440427,6),(1664,1774746027,5),(1664,1792890027,6),(1664,1806195627,5),(1664,1824944427,6),(1664,1837645227,5),(1664,1856394027,6),(1664,1869094827,5),(1664,1887843627,6),(1664,1901149227,5),(1664,1919293227,6),(1664,1932598827,5),(1664,1950742827,6),(1664,1964048427,5),(1664,1982797227,6),(1664,1995498027,5),(1664,2014246827,6),(1664,2026947627,5),(1664,2045696427,6),(1664,2058397227,5),(1664,2077146027,6),(1664,2090451627,5),(1664,2108595627,6),(1664,2121901227,5),(1664,2140045227,6),(1665,-2147483648,0),(1665,-1593820800,1),(1665,-1247540400,3),(1665,354916809,2),(1665,370724410,3),(1665,386452810,2),(1665,402260411,3),(1665,417988811,2),(1665,433796412,3),(1665,449611212,2),(1665,465343212,4),(1665,481068012,5),(1665,496792813,4),(1665,512517613,5),(1665,528242413,4),(1665,543967213,5),(1665,559692013,4),(1665,575416814,6),(1665,591145214,7),(1665,606870014,6),(1665,622594814,7),(1665,638319615,6),(1665,654649215,7),(1665,670374016,4),(1665,701820016,6),(1665,717548417,7),(1665,733273217,6),(1665,748998018,7),(1665,764722818,6),(1665,780447619,7),(1665,796172419,6),(1665,811897219,7),(1665,828226820,6),(1665,846370820,7),(1665,859676420,6),(1665,877820421,7),(1665,891126021,6),(1665,909270021,7),(1665,922575622,6),(1665,941324422,7),(1665,954025222,6),(1665,972774022,7),(1665,985474822,6),(1665,1004223622,7),(1665,1017529222,6),(1665,1035673222,7),(1665,1048978822,6),(1665,1067122822,7),(1665,1080428422,6),(1665,1099177222,7),(1665,1111878022,6),(1665,1130626822,7),(1665,1143327623,6),(1665,1162076423,7),(1665,1174777223,6),(1665,1193526023,7),(1665,1206831623,6),(1665,1224975623,7),(1665,1238281224,6),(1665,1256425224,7),(1665,1269730824,6),(1665,1288479624,7),(1665,1301180424,4),(1665,1414274425,7),(1665,1480806026,4),(1666,-2147483648,1),(1666,-1441160160,2),(1666,-1247536800,3),(1666,-888894000,6),(1666,-857257200,4),(1666,-844556400,5),(1666,-828226800,4),(1666,-812502000,5),(1666,-811648800,3),(1666,354920409,7),(1666,370728010,3),(1666,386456410,7),(1666,402264011,3),(1666,417992411,7),(1666,433800012,3),(1666,449614812,7),(1666,465346812,8),(1666,481071612,9),(1666,496796413,8),(1666,512521213,9),(1666,528246013,8),(1666,543970813,9),(1666,559695613,8),(1666,575420414,9),(1666,591145214,8),(1666,606870014,9),(1666,622594814,8),(1666,631141214,3),(1666,646786815,2),(1666,701827216,10),(1666,717552017,11),(1666,733276817,10),(1666,749001618,11),(1666,764726418,10),(1666,767739618,7),(1666,780447619,8),(1666,796172419,9),(1666,811897219,8),(1666,828219620,9),(1666,846374420,8),(1666,859683620,12),(1666,877827621,13),(1666,891133221,12),(1666,909277221,13),(1666,922582822,12),(1666,941331622,13),(1666,954032422,12),(1666,972781222,13),(1666,985482022,12),(1666,1004230822,13),(1666,1017536422,12),(1666,1035680422,13),(1666,1048986022,12),(1666,1067130022,13),(1666,1080435622,12),(1666,1099184422,13),(1666,1111885222,12),(1666,1130634022,13),(1666,1143334823,12),(1666,1162083623,13),(1666,1174784423,12),(1666,1193533223,13),(1666,1206838823,12),(1666,1224982823,13),(1666,1238288424,12),(1666,1256432424,13),(1666,1269738024,12),(1666,1288486824,13),(1666,1301187624,12),(1666,1319936424,13),(1666,1332637224,12),(1666,1351386025,13),(1666,1364691625,12),(1666,1382835625,13),(1666,1396137625,14),(1666,1414274425,8),(1667,-2147483648,1),(1667,-905824800,4),(1667,-857257200,2),(1667,-844556400,3),(1667,-828226800,2),(1667,-812502000,3),(1667,-796777200,2),(1667,-788922000,1),(1667,-777942000,3),(1667,-766623600,2),(1667,407199611,1),(1667,417574811,5),(1667,433299612,6),(1667,449024412,5),(1667,465354012,6),(1667,481078812,5),(1667,496803613,6),(1667,512528413,5),(1667,528253213,6),(1667,543978013,5),(1667,559702813,6),(1667,575427614,5),(1667,591152414,6),(1667,606877214,5),(1667,622602014,6),(1667,638326815,5),(1667,654656415,6),(1667,670381216,5),(1667,686106016,6),(1667,701830816,5),(1667,717555617,6),(1667,733280417,5),(1667,749005218,6),(1667,764730018,5),(1667,780454819,6),(1667,796179619,5),(1667,811904419,6),(1667,828234020,5),(1667,846378020,6),(1667,859683620,5),(1667,877827621,6),(1667,891133221,5),(1667,909277221,6),(1667,922582822,5),(1667,941331622,6),(1667,954032422,5),(1667,972781222,6),(1667,985482022,5),(1667,1004230822,6),(1667,1017536422,5),(1667,1035680422,6),(1667,1048986022,5),(1667,1067130022,6),(1667,1080435622,5),(1667,1099184422,6),(1667,1111885222,5),(1667,1130634022,6),(1667,1143334823,5),(1667,1162083623,6),(1667,1174784423,5),(1667,1193533223,6),(1667,1206838823,5),(1667,1224982823,6),(1667,1238288424,5),(1667,1256432424,6),(1667,1269738024,5),(1667,1288486824,6),(1667,1301187624,5),(1667,1319936424,6),(1667,1332637224,5),(1667,1351386025,6),(1667,1364691625,5),(1667,1382835625,6),(1667,1396141225,5),(1667,1414285225,6),(1667,1427590825,5),(1667,1445734826,6),(1667,1459040426,5),(1667,1477789226,6),(1667,1490490027,5),(1667,1509238827,6),(1667,1521939627,5),(1667,1540688427,6),(1667,1553994027,5),(1667,1572138027,6),(1667,1585443627,5),(1667,1603587627,6),(1667,1616893227,5),(1667,1635642027,6),(1667,1648342827,5),(1667,1667091627,6),(1667,1679792427,5),(1667,1698541227,6),(1667,1711846827,5),(1667,1729990827,6),(1667,1743296427,5),(1667,1761440427,6),(1667,1774746027,5),(1667,1792890027,6),(1667,1806195627,5),(1667,1824944427,6),(1667,1837645227,5),(1667,1856394027,6),(1667,1869094827,5),(1667,1887843627,6),(1667,1901149227,5),(1667,1919293227,6),(1667,1932598827,5),(1667,1950742827,6),(1667,1964048427,5),(1667,1982797227,6),(1667,1995498027,5),(1667,2014246827,6),(1667,2026947627,5),(1667,2045696427,6),(1667,2058397227,5),(1667,2077146027,6),(1667,2090451627,5),(1667,2108595627,6),(1667,2121901227,5),(1667,2140045227,6),(1668,-2147483648,1),(1668,-857257200,2),(1668,-844556400,3),(1668,-828226800,2),(1668,-812502000,3),(1668,-796777200,2),(1668,-788922000,4),(1668,-781048800,1),(1668,291762008,5),(1668,307576808,1),(1668,323816409,5),(1668,339026409,1),(1668,355266009,5),(1668,370393210,1),(1668,386715610,5),(1668,401846411,6),(1668,417571211,7),(1668,433296012,6),(1668,449020812,7),(1668,465350412,6),(1668,481075212,7),(1668,496800013,6),(1668,512524813,7),(1668,528249613,6),(1668,543974413,7),(1668,559699213,6),(1668,575424014,7),(1668,591148814,6),(1668,606873614,7),(1668,622598414,6),(1668,638323215,7),(1668,654652815,6),(1668,662680815,1),(1668,670370416,5),(1668,686091616,1),(1668,701820016,5),(1668,717541217,1),(1668,733269617,5),(1668,748990818,1),(1668,764719218,5),(1668,780440419,1),(1668,796168819,5),(1668,811890019,1),(1668,828223220,5),(1668,846363620,1),(1668,859683620,8),(1668,877827621,9),(1668,891133221,8),(1668,909277221,9),(1668,922582822,8),(1668,941331622,9),(1668,954032422,8),(1668,972781222,9),(1668,985482022,8),(1668,1004230822,9),(1668,1017536422,8),(1668,1035680422,9),(1668,1048986022,8),(1668,1067130022,9),(1668,1080435622,8),(1668,1099184422,9),(1668,1111885222,8),(1668,1130634022,9),(1668,1143334823,8),(1668,1162083623,9),(1668,1174784423,8),(1668,1193533223,9),(1668,1206838823,8),(1668,1224982823,9),(1668,1238288424,8),(1668,1256432424,9),(1668,1269738024,8),(1668,1288486824,9),(1668,1301187624,8),(1668,1319936424,9),(1668,1332637224,8),(1668,1351386025,9),(1668,1364691625,8),(1668,1382835625,9),(1668,1396141225,8),(1668,1414285225,9),(1668,1427590825,8),(1668,1445734826,9),(1668,1459040426,8),(1668,1477789226,9),(1668,1490490027,8),(1668,1509238827,9),(1668,1521939627,8),(1668,1540688427,9),(1668,1553994027,8),(1668,1572138027,9),(1668,1585443627,8),(1668,1603587627,9),(1668,1616893227,8),(1668,1635642027,9),(1668,1648342827,8),(1668,1667091627,9),(1668,1679792427,8),(1668,1698541227,9),(1668,1711846827,8),(1668,1729990827,9),(1668,1743296427,8),(1668,1761440427,9),(1668,1774746027,8),(1668,1792890027,9),(1668,1806195627,8),(1668,1824944427,9),(1668,1837645227,8),(1668,1856394027,9),(1668,1869094827,8),(1668,1887843627,9),(1668,1901149227,8),(1668,1919293227,9),(1668,1932598827,8),(1668,1950742827,9),(1668,1964048427,8),(1668,1982797227,9),(1668,1995498027,8),(1668,2014246827,9),(1668,2026947627,8),(1668,2045696427,9),(1668,2058397227,8),(1668,2077146027,9),(1668,2090451627,8),(1668,2108595627,9),(1668,2121901227,8),(1668,2140045227,9),(1669,-2147483648,2),(1669,-1693706400,1),(1669,-1680483600,2),(1669,-1663455600,3),(1669,-1650150000,4),(1669,-1632006000,3),(1669,-1618700400,4),(1669,-938905200,3),(1669,-857257200,4),(1669,-844556400,3),(1669,-828226800,4),(1669,-812502000,3),(1669,-796777200,4),(1669,-781052400,3),(1669,-776563200,5),(1669,-765936000,1),(1669,-761180400,4),(1669,-757386000,2),(1669,-748479600,3),(1669,-733273200,4),(1669,-717631200,3),(1669,-714610800,6),(1669,-710380800,1),(1669,-701910000,4),(1669,-684975600,3),(1669,-670460400,4),(1669,-654130800,3),(1669,-639010800,4),(1669,315529208,2),(1669,323830809,7),(1669,338950809,8),(1669,354675609,7),(1669,370400410,8),(1669,386125210,7),(1669,401850011,8),(1669,417574811,7),(1669,433299612,8),(1669,449024412,7),(1669,465354012,8),(1669,481078812,7),(1669,496803613,8),(1669,512528413,7),(1669,528253213,8),(1669,543978013,7),(1669,559702813,8),(1669,575427614,7),(1669,591152414,8),(1669,606877214,7),(1669,622602014,8),(1669,638326815,7),(1669,654656415,8),(1669,670381216,7),(1669,686106016,8),(1669,701830816,7),(1669,717555617,8),(1669,733280417,7),(1669,749005218,8),(1669,764730018,7),(1669,780454819,8),(1669,796179619,7),(1669,811904419,8),(1669,828234020,7),(1669,846378020,8),(1669,859683620,7),(1669,877827621,8),(1669,891133221,7),(1669,909277221,8),(1669,922582822,7),(1669,941331622,8),(1669,954032422,7),(1669,972781222,8),(1669,985482022,7),(1669,1004230822,8),(1669,1017536422,7),(1669,1035680422,8),(1669,1048986022,7),(1669,1067130022,8),(1669,1080435622,7),(1669,1099184422,8),(1669,1111885222,7),(1669,1130634022,8),(1669,1143334823,7),(1669,1162083623,8),(1669,1174784423,7),(1669,1193533223,8),(1669,1206838823,7),(1669,1224982823,8),(1669,1238288424,7),(1669,1256432424,8),(1669,1269738024,7),(1669,1288486824,8),(1669,1301187624,7),(1669,1319936424,8),(1669,1332637224,7),(1669,1351386025,8),(1669,1364691625,7),(1669,1382835625,8),(1669,1396141225,7),(1669,1414285225,8),(1669,1427590825,7),(1669,1445734826,8),(1669,1459040426,7),(1669,1477789226,8),(1669,1490490027,7),(1669,1509238827,8),(1669,1521939627,7),(1669,1540688427,8),(1669,1553994027,7),(1669,1572138027,8),(1669,1585443627,7),(1669,1603587627,8),(1669,1616893227,7),(1669,1635642027,8),(1669,1648342827,7),(1669,1667091627,8),(1669,1679792427,7),(1669,1698541227,8),(1669,1711846827,7),(1669,1729990827,8),(1669,1743296427,7),(1669,1761440427,8),(1669,1774746027,7),(1669,1792890027,8),(1669,1806195627,7),(1669,1824944427,8),(1669,1837645227,7),(1669,1856394027,8),(1669,1869094827,7),(1669,1887843627,8),(1669,1901149227,7),(1669,1919293227,8),(1669,1932598827,7),(1669,1950742827,8),(1669,1964048427,7),(1669,1982797227,8),(1669,1995498027,7),(1669,2014246827,8),(1669,2026947627,7),(1669,2045696427,8),(1669,2058397227,7),(1669,2077146027,8),(1669,2090451627,7),(1669,2108595627,8),(1669,2121901227,7),(1669,2140045227,8),(1670,-2147483648,1),(1670,-1638322740,4),(1670,-1632006000,2),(1670,-1618700400,3),(1670,-1593824400,1),(1670,-1535938740,5),(1670,-927943200,6),(1670,-892954800,7),(1670,-857257200,3),(1670,-844556400,2),(1670,-828226800,3),(1670,-812502000,2),(1670,-797652000,6),(1670,354920409,8),(1670,370728010,6),(1670,386456410,8),(1670,402264011,6),(1670,417992411,8),(1670,433800012,6),(1670,449614812,8),(1670,465346812,9),(1670,481071612,10),(1670,496796413,9),(1670,512521213,10),(1670,528246013,9),(1670,543970813,10),(1670,559695613,9),(1670,575420414,10),(1670,591145214,9),(1670,606870014,11),(1670,622598414,12),(1670,638323215,11),(1670,654652815,12),(1670,670377616,11),(1670,686102416,12),(1670,701827216,11),(1670,717552017,12),(1670,733276817,11),(1670,749001618,12),(1670,764726418,11),(1670,780451219,12),(1670,796176019,11),(1670,811900819,12),(1670,828230420,11),(1670,846374420,12),(1670,859680020,11),(1670,877824021,12),(1670,891129621,11),(1670,906411621,15),(1670,909277221,13),(1670,922582822,14),(1670,941331622,5),(1670,1017536422,14),(1670,1035680422,13),(1670,1048986022,14),(1670,1067130022,13),(1670,1080435622,14),(1670,1099184422,13),(1670,1111885222,14),(1670,1130634022,13),(1670,1143334823,14),(1670,1162083623,13),(1670,1174784423,14),(1670,1193533223,13),(1670,1206838823,14),(1670,1224982823,13),(1670,1238288424,14),(1670,1256432424,13),(1670,1269738024,14),(1670,1288486824,13),(1670,1301187624,14),(1670,1319936424,13),(1670,1332637224,14),(1670,1351386025,13),(1670,1364691625,14),(1670,1382835625,13),(1670,1396141225,14),(1670,1414285225,13),(1670,1427590825,14),(1670,1445734826,13),(1670,1459040426,14),(1670,1477789226,13),(1670,1490490027,14),(1670,1509238827,13),(1670,1521939627,14),(1670,1540688427,13),(1670,1553994027,14),(1670,1572138027,13),(1670,1585443627,14),(1670,1603587627,13),(1670,1616893227,14),(1670,1635642027,13),(1670,1648342827,14),(1670,1667091627,13),(1670,1679792427,14),(1670,1698541227,13),(1670,1711846827,14),(1670,1729990827,13),(1670,1743296427,14),(1670,1761440427,13),(1670,1774746027,14),(1670,1792890027,13),(1670,1806195627,14),(1670,1824944427,13),(1670,1837645227,14),(1670,1856394027,13),(1670,1869094827,14),(1670,1887843627,13),(1670,1901149227,14),(1670,1919293227,13),(1670,1932598827,14),(1670,1950742827,13),(1670,1964048427,14),(1670,1982797227,13),(1670,1995498027,14),(1670,2014246827,13),(1670,2026947627,14),(1670,2045696427,13),(1670,2058397227,14),(1670,2077146027,13),(1670,2090451627,14),(1670,2108595627,13),(1670,2121901227,14),(1670,2140045227,13),(1671,-2147483648,0),(1671,-1767230360,1),(1671,-932346000,2),(1671,-857257200,1),(1671,-844556400,2),(1671,-843519600,1),(1671,136854003,2),(1671,149896803,1),(1671,168130804,2),(1671,181432804,1),(1671,199839605,2),(1671,213141605,1),(1671,231894006,2),(1671,244591206,1),(1671,263257207,2),(1671,276040807,1),(1671,294706808,2),(1671,307490408,1),(1671,326156409,2),(1671,339458409,1),(1671,357087609,2),(1671,370389610,1),(1671,389142010,2),(1671,402444011,1),(1671,419468411,2),(1671,433807212,1),(1671,449622012,2),(1671,465354012,3),(1671,481078812,4),(1671,496803613,3),(1671,512528413,4),(1671,528253213,3),(1671,543978013,4),(1671,559702813,3),(1671,575427614,4),(1671,591152414,3),(1671,606877214,4),(1671,622602014,3),(1671,638326815,4),(1671,654656415,3),(1671,670381216,4),(1671,686106016,3),(1671,701830816,4),(1671,717555617,3),(1671,733280417,4),(1671,749005218,3),(1671,764730018,4),(1671,780454819,3),(1671,796179619,4),(1671,811904419,3),(1671,828234020,4),(1671,846378020,3),(1671,859683620,4),(1671,877827621,3),(1671,891133221,4),(1671,909277221,3),(1671,922582822,4),(1671,941331622,3),(1671,954032422,4),(1671,972781222,3),(1671,985482022,4),(1671,1004230822,3),(1671,1017536422,4),(1671,1035680422,3),(1671,1048986022,4),(1671,1067130022,3),(1671,1080435622,4),(1671,1099184422,3),(1671,1111885222,4),(1671,1130634022,3),(1671,1143334823,4),(1671,1162083623,3),(1671,1174784423,4),(1671,1193533223,3),(1671,1206838823,4),(1671,1224982823,3),(1671,1238288424,4),(1671,1256432424,3),(1671,1269738024,4),(1671,1288486824,3),(1671,1301187624,4),(1671,1319936424,3),(1671,1332637224,4),(1671,1351386025,3),(1671,1364691625,4),(1671,1382835625,3),(1671,1396141225,4),(1671,1414285225,3),(1671,1427590825,4),(1671,1445734826,3),(1671,1459040426,4),(1671,1477789226,3),(1671,1490490027,4),(1671,1509238827,3),(1671,1521939627,4),(1671,1540688427,3),(1671,1553994027,4),(1671,1572138027,3),(1671,1585443627,4),(1671,1603587627,3),(1671,1616893227,4),(1671,1635642027,3),(1671,1648342827,4),(1671,1667091627,3),(1671,1679792427,4),(1671,1698541227,3),(1671,1711846827,4),(1671,1729990827,3),(1671,1743296427,4),(1671,1761440427,3),(1671,1774746027,4),(1671,1792890027,3),(1671,1806195627,4),(1671,1824944427,3),(1671,1837645227,4),(1671,1856394027,3),(1671,1869094827,4),(1671,1887843627,3),(1671,1901149227,4),(1671,1919293227,3),(1671,1932598827,4),(1671,1950742827,3),(1671,1964048427,4),(1671,1982797227,3),(1671,1995498027,4),(1671,2014246827,3),(1671,2026947627,4),(1671,2045696427,3),(1671,2058397227,4),(1671,2077146027,3),(1671,2090451627,4),(1671,2108595627,3),(1671,2121901227,4),(1671,2140045227,3),(1672,-2147483648,1),(1672,-1637114100,2),(1672,-1213148664,5),(1672,-1187056800,3),(1672,-1175479200,4),(1672,-1159754400,3),(1672,-1144029600,4),(1672,-1127700000,3),(1672,-1111975200,4),(1672,-1096250400,3),(1672,-1080525600,4),(1672,-1064800800,3),(1672,-1049076000,4),(1672,-1033351200,3),(1672,-1017626400,4),(1672,-1001901600,3),(1672,-986176800,4),(1672,-970452000,3),(1672,-954727200,4),(1672,-927165600,6),(1672,-898138800,9),(1672,-857257200,7),(1672,-844556400,8),(1672,-828226800,7),(1672,-812502000,8),(1672,-800157600,11),(1672,354920409,10),(1672,370728010,11),(1672,386456410,10),(1672,402264011,11),(1672,417992411,10),(1672,433800012,11),(1672,449614812,10),(1672,465346812,12),(1672,481071612,13),(1672,496796413,12),(1672,512521213,13),(1672,528246013,12),(1672,543970813,13),(1672,559695613,12),(1672,575420414,13),(1672,591145214,12),(1672,606870014,13),(1672,622594814,12),(1672,638319615,13),(1672,641944815,6),(1672,654652815,4),(1672,670377616,3),(1672,686102416,4),(1672,694216816,5),(1672,701820016,6),(1672,717541217,5),(1672,733269617,6),(1672,748990818,5),(1672,764719218,6),(1672,780440419,5),(1672,796168819,6),(1672,811890019,5),(1672,828223220,6),(1672,846363620,5),(1672,859680020,6),(1672,877824021,5),(1672,891129621,6),(1672,909273621,5),(1672,922579222,6),(1672,941328022,5),(1672,954028822,6),(1672,972777622,5),(1672,985478422,6),(1672,1004227222,5),(1672,1017532822,6),(1672,1035676822,5),(1672,1048982422,6),(1672,1067126422,5),(1672,1080432022,6),(1672,1099180822,5),(1672,1111881622,6),(1672,1130630422,5),(1672,1143331223,6),(1672,1162080023,5),(1672,1174780823,6),(1672,1193529623,5),(1672,1206835223,6),(1672,1224979223,5),(1672,1238284824,6),(1672,1256428824,5),(1672,1269734424,6),(1672,1288483224,5),(1672,1301184024,6),(1672,1319932824,5),(1672,1332633624,6),(1672,1351382425,5),(1672,1364688025,6),(1672,1382832025,5),(1672,1396137625,6),(1672,1414281625,5),(1672,1427587225,6),(1672,1445731226,5),(1672,1459036826,6),(1672,1477785626,5),(1672,1490486427,6),(1672,1509235227,5),(1672,1521936027,6),(1672,1540684827,5),(1672,1553990427,6),(1672,1572134427,5),(1672,1585440027,6),(1672,1603584027,5),(1672,1616889627,6),(1672,1635638427,5),(1672,1648339227,6),(1672,1667088027,5),(1672,1679788827,6),(1672,1698537627,5),(1672,1711843227,6),(1672,1729987227,5),(1672,1743292827,6),(1672,1761436827,5),(1672,1774742427,6),(1672,1792886427,5),(1672,1806192027,6),(1672,1824940827,5),(1672,1837641627,6),(1672,1856390427,5),(1672,1869091227,6),(1672,1887840027,5),(1672,1901145627,6),(1672,1919289627,5),(1672,1932595227,6),(1672,1950739227,5),(1672,1964044827,6),(1672,1982793627,5),(1672,1995494427,6),(1672,2014243227,5),(1672,2026944027,6),(1672,2045692827,5),(1672,2058393627,6),(1672,2077142427,5),(1672,2090448027,6),(1672,2108592027,5),(1672,2121897627,6),(1672,2140041627,5),(1673,-2147483648,0),(1673,-1593820800,1),(1673,-1247540400,3),(1673,354916809,2),(1673,370724410,3),(1673,386452810,2),(1673,402260411,3),(1673,417988811,2),(1673,433796412,3),(1673,449611212,2),(1673,465343212,4),(1673,481068012,5),(1673,496792813,4),(1673,512517613,5),(1673,528242413,4),(1673,543967213,5),(1673,559692013,4),(1673,575416814,5),(1673,591141614,4),(1673,606866414,6),(1673,622594814,7),(1673,638319615,6),(1673,654649215,7),(1673,670374016,8),(1673,686102416,9),(1673,695779216,7),(1673,701823616,6),(1673,717548417,7),(1673,733273217,6),(1673,748998018,7),(1673,764722818,6),(1673,780447619,7),(1673,796172419,6),(1673,811897219,7),(1673,828226820,6),(1673,846370820,7),(1673,859676420,6),(1673,877820421,7),(1673,891126021,6),(1673,909270021,7),(1673,922575622,6),(1673,941324422,7),(1673,954025222,6),(1673,972774022,7),(1673,985474822,6),(1673,1004223622,7),(1673,1017529222,6),(1673,1035673222,7),(1673,1048978822,6),(1673,1067122822,7),(1673,1080428422,6),(1673,1099177222,7),(1673,1111878022,6),(1673,1130626822,7),(1673,1143327623,6),(1673,1162076423,7),(1673,1174777223,6),(1673,1193526023,7),(1673,1206831623,6),(1673,1224975623,7),(1673,1238281224,6),(1673,1256425224,7),(1673,1269730824,6),(1673,1288479624,7),(1673,1301180424,4),(1673,1414274425,7),(1673,1459033226,4),(1674,-2147483648,1),(1674,-1441159324,2),(1674,-1247536800,3),(1674,-892522800,6),(1674,-857257200,4),(1674,-844556400,5),(1674,-828226800,4),(1674,-825382800,3),(1674,354920409,7),(1674,370728010,3),(1674,386456410,7),(1674,402264011,3),(1674,417992411,7),(1674,433800012,3),(1674,449614812,7),(1674,465346812,8),(1674,481071612,9),(1674,496796413,8),(1674,512521213,9),(1674,528246013,8),(1674,543970813,9),(1674,559695613,8),(1674,575420414,9),(1674,591145214,8),(1674,606870014,9),(1674,622594814,8),(1674,638319615,9),(1674,646783215,10),(1674,686102416,11),(1674,701827216,12),(1674,717552017,11),(1674,733276817,12),(1674,749001618,11),(1674,764726418,12),(1674,780451219,11),(1674,796176019,12),(1674,811900819,11),(1674,828230420,12),(1674,831934820,10),(1674,846378020,13),(1674,859683620,14),(1674,877827621,13),(1674,891133221,14),(1674,909277221,13),(1674,922582822,14),(1674,941331622,13),(1674,954032422,14),(1674,972781222,13),(1674,985482022,14),(1674,1004230822,13),(1674,1017536422,14),(1674,1035680422,13),(1674,1048986022,14),(1674,1067130022,13),(1674,1080435622,14),(1674,1099184422,13),(1674,1111885222,14),(1674,1130634022,13),(1674,1143334823,14),(1674,1162083623,13),(1674,1174784423,14),(1674,1193533223,13),(1674,1206838823,14),(1674,1224982823,13),(1674,1238288424,14),(1674,1256432424,13),(1674,1269738024,14),(1674,1288486824,13),(1674,1301187624,14),(1674,1319936424,13),(1674,1332637224,14),(1674,1351386025,13),(1674,1364691625,14),(1674,1382835625,13),(1674,1396141225,14),(1674,1414285225,13),(1674,1427590825,14),(1674,1445734826,13),(1674,1459040426,14),(1674,1477789226,13),(1674,1490490027,14),(1674,1509238827,13),(1674,1521939627,14),(1674,1540688427,13),(1674,1553994027,14),(1674,1572138027,13),(1674,1585443627,14),(1674,1603587627,13),(1674,1616893227,14),(1674,1635642027,13),(1674,1648342827,14),(1674,1667091627,13),(1674,1679792427,14),(1674,1698541227,13),(1674,1711846827,14),(1674,1729990827,13),(1674,1743296427,14),(1674,1761440427,13),(1674,1774746027,14),(1674,1792890027,13),(1674,1806195627,14),(1674,1824944427,13),(1674,1837645227,14),(1674,1856394027,13),(1674,1869094827,14),(1674,1887843627,13),(1674,1901149227,14),(1674,1919293227,13),(1674,1932598827,14),(1674,1950742827,13),(1674,1964048427,14),(1674,1982797227,13),(1674,1995498027,14),(1674,2014246827,13),(1674,2026947627,14),(1674,2045696427,13),(1674,2058397227,14),(1674,2077146027,13),(1674,2090451627,14),(1674,2108595627,13),(1674,2121901227,14),(1674,2140045227,13),(1675,-2147483648,2),(1675,-904435200,1),(1675,-891129600,2),(1675,-872985600,1),(1675,-859680000,2),(1675,354675609,3),(1675,370400410,4),(1675,386125210,3),(1675,401850011,4),(1675,417574811,3),(1675,433299612,4),(1675,449024412,3),(1675,465354012,4),(1675,481078812,3),(1675,496803613,4),(1675,512528413,3),(1675,528253213,4),(1675,543978013,3),(1675,559702813,4),(1675,575427614,3),(1675,591152414,4),(1675,606877214,3),(1675,622602014,4),(1675,638326815,3),(1675,654656415,4),(1675,670381216,3),(1675,686106016,4),(1675,701830816,3),(1675,717555617,4),(1675,733280417,3),(1675,749005218,4),(1675,764730018,3),(1675,780454819,4),(1675,796179619,3),(1675,811904419,4),(1675,828234020,3),(1675,846378020,4),(1675,859683620,3),(1675,877827621,4),(1675,891133221,3),(1675,909277221,4),(1675,922582822,3),(1675,941331622,4),(1675,954032422,3),(1675,972781222,4),(1675,985482022,3),(1675,1004230822,4),(1675,1017536422,3),(1675,1035680422,4),(1675,1048986022,3),(1675,1067130022,4),(1675,1080435622,3),(1675,1099184422,4),(1675,1111885222,3),(1675,1130634022,4),(1675,1143334823,3),(1675,1162083623,4),(1675,1174784423,3),(1675,1193533223,4),(1675,1206838823,3),(1675,1224982823,4),(1675,1238288424,3),(1675,1256432424,4),(1675,1269738024,3),(1675,1288486824,4),(1675,1301187624,3),(1675,1319936424,4),(1675,1332637224,3),(1675,1351386025,4),(1675,1364691625,3),(1675,1382835625,4),(1675,1396141225,3),(1675,1414285225,4),(1675,1427590825,3),(1675,1445734826,4),(1675,1459040426,3),(1675,1477789226,4),(1675,1490490027,3),(1675,1509238827,4),(1675,1521939627,3),(1675,1540688427,4),(1675,1553994027,3),(1675,1572138027,4),(1675,1585443627,3),(1675,1603587627,4),(1675,1616893227,3),(1675,1635642027,4),(1675,1648342827,3),(1675,1667091627,4),(1675,1679792427,3),(1675,1698541227,4),(1675,1711846827,3),(1675,1729990827,4),(1675,1743296427,3),(1675,1761440427,4),(1675,1774746027,3),(1675,1792890027,4),(1675,1806195627,3),(1675,1824944427,4),(1675,1837645227,3),(1675,1856394027,4),(1675,1869094827,3),(1675,1887843627,4),(1675,1901149227,3),(1675,1919293227,4),(1675,1932598827,3),(1675,1950742827,4),(1675,1964048427,3),(1675,1982797227,4),(1675,1995498027,3),(1675,2014246827,4),(1675,2026947627,3),(1675,2045696427,4),(1675,2058397227,3),(1675,2077146027,4),(1675,2090451627,3),(1675,2108595627,4),(1675,2121901227,3),(1675,2140045227,4),(1676,-2147483648,5),(1676,-1690765200,1),(1676,-1680487200,2),(1676,-1664758800,1),(1676,-1648951200,2),(1676,-1635123600,1),(1676,-1616896800,2),(1676,-1604278800,1),(1676,-1585533600,2),(1676,-1571014800,1),(1676,-1555293600,2),(1676,-932432400,1),(1676,-857257200,3),(1676,-844556400,4),(1676,-830311200,1),(1676,-828226800,3),(1676,-812502000,4),(1676,-807156000,1),(1676,-798073200,3),(1676,-781052400,1),(1676,-766717200,2),(1676,-750898800,4),(1676,-733359600,3),(1676,-719456400,4),(1676,-701917200,3),(1676,-689209200,4),(1676,-670460400,3),(1676,-114051600,4),(1676,-103168800,2),(1676,-81997200,4),(1676,-71715600,3),(1676,-50547600,4),(1676,-40266000,3),(1676,-18493200,4),(1676,-8211600,3),(1676,12956400,4),(1676,23238000,3),(1676,43801200,4),(1676,54687600,3),(1676,75855600,4),(1676,86742001,3),(1676,107910002,4),(1676,118191602,3),(1676,138754803,4),(1676,149641203,3),(1676,170809204,4),(1676,181090804,3),(1676,202258805,4),(1676,212540405,3),(1676,233103606,4),(1676,243990006,3),(1676,265158007,4),(1676,276044407,3),(1676,296607608,4),(1676,307494008,3),(1676,315529208,2),(1676,323830809,6),(1676,338950809,5),(1676,354675609,6),(1676,370400410,5),(1676,386125210,6),(1676,401850011,5),(1676,417574811,6),(1676,433299612,5),(1676,449024412,6),(1676,465354012,5),(1676,481078812,6),(1676,496803613,5),(1676,512528413,6),(1676,528253213,5),(1676,543978013,6),(1676,559702813,5),(1676,575427614,6),(1676,591152414,5),(1676,606877214,6),(1676,622602014,5),(1676,638326815,6),(1676,654656415,5),(1676,670381216,6),(1676,686106016,5),(1676,701830816,6),(1676,717555617,5),(1676,733280417,6),(1676,749005218,5),(1676,764730018,6),(1676,780454819,5),(1676,796179619,6),(1676,811904419,5),(1676,828234020,6),(1676,846378020,5),(1676,859683620,6),(1676,877827621,5),(1676,891133221,6),(1676,909277221,5),(1676,922582822,6),(1676,941331622,5),(1676,954032422,6),(1676,972781222,5),(1676,985482022,6),(1676,1004230822,5),(1676,1017536422,6),(1676,1035680422,5),(1676,1048986022,6),(1676,1067130022,5),(1676,1080435622,6),(1676,1099184422,5),(1676,1111885222,6),(1676,1130634022,5),(1676,1143334823,6),(1676,1162083623,5),(1676,1174784423,6),(1676,1193533223,5),(1676,1206838823,6),(1676,1224982823,5),(1676,1238288424,6),(1676,1256432424,5),(1676,1269738024,6),(1676,1288486824,5),(1676,1301187624,6),(1676,1319936424,5),(1676,1332637224,6),(1676,1351386025,5),(1676,1364691625,6),(1676,1382835625,5),(1676,1396141225,6),(1676,1414285225,5),(1676,1427590825,6),(1676,1445734826,5),(1676,1459040426,6),(1676,1477789226,5),(1676,1490490027,6),(1676,1509238827,5),(1676,1521939627,6),(1676,1540688427,5),(1676,1553994027,6),(1676,1572138027,5),(1676,1585443627,6),(1676,1603587627,5),(1676,1616893227,6),(1676,1635642027,5),(1676,1648342827,6),(1676,1667091627,5),(1676,1679792427,6),(1676,1698541227,5),(1676,1711846827,6),(1676,1729990827,5),(1676,1743296427,6),(1676,1761440427,5),(1676,1774746027,6),(1676,1792890027,5),(1676,1806195627,6),(1676,1824944427,5),(1676,1837645227,6),(1676,1856394027,5),(1676,1869094827,6),(1676,1887843627,5),(1676,1901149227,6),(1676,1919293227,5),(1676,1932598827,6),(1676,1950742827,5),(1676,1964048427,6),(1676,1982797227,5),(1676,1995498027,6),(1676,2014246827,5),(1676,2026947627,6),(1676,2045696427,5),(1676,2058397227,6),(1676,2077146027,5),(1676,2090451627,6),(1676,2108595627,5),(1676,2121901227,6),(1676,2140045227,5),(1677,-2147483648,2),(1677,-1693706400,1),(1677,-1680483600,2),(1677,-1663455600,3),(1677,-1650150000,4),(1677,-1632006000,3),(1677,-1618700400,4),(1677,-1577926800,2),(1677,-1569711600,3),(1677,-1555801200,4),(1677,-938905200,3),(1677,-857257200,4),(1677,-844556400,3),(1677,-828226800,4),(1677,-812502000,3),(1677,-796777200,4),(1677,-781052400,3),(1677,-780188400,4),(1677,-757386000,2),(1677,-748479600,3),(1677,-733273200,4),(1677,-717634800,3),(1677,-701910000,4),(1677,-684975600,3),(1677,-670460400,4),(1677,323823609,1),(1677,338940009,2),(1677,354675609,5),(1677,370400410,6),(1677,386125210,5),(1677,401850011,6),(1677,417574811,5),(1677,433299612,6),(1677,449024412,5),(1677,465354012,6),(1677,481078812,5),(1677,496803613,6),(1677,512528413,5),(1677,528253213,6),(1677,543978013,5),(1677,559702813,6),(1677,575427614,5),(1677,591152414,6),(1677,606877214,5),(1677,622602014,6),(1677,638326815,5),(1677,654656415,6),(1677,670381216,5),(1677,686106016,6),(1677,701830816,5),(1677,717555617,6),(1677,733280417,5),(1677,749005218,6),(1677,764730018,5),(1677,780454819,6),(1677,796179619,5),(1677,811904419,6),(1677,828234020,5),(1677,846378020,6),(1677,859683620,5),(1677,877827621,6),(1677,891133221,5),(1677,909277221,6),(1677,922582822,5),(1677,941331622,6),(1677,954032422,5),(1677,972781222,6),(1677,985482022,5),(1677,1004230822,6),(1677,1017536422,5),(1677,1035680422,6),(1677,1048986022,5),(1677,1067130022,6),(1677,1080435622,5),(1677,1099184422,6),(1677,1111885222,5),(1677,1130634022,6),(1677,1143334823,5),(1677,1162083623,6),(1677,1174784423,5),(1677,1193533223,6),(1677,1206838823,5),(1677,1224982823,6),(1677,1238288424,5),(1677,1256432424,6),(1677,1269738024,5),(1677,1288486824,6),(1677,1301187624,5),(1677,1319936424,6),(1677,1332637224,5),(1677,1351386025,6),(1677,1364691625,5),(1677,1382835625,6),(1677,1396141225,5),(1677,1414285225,6),(1677,1427590825,5),(1677,1445734826,6),(1677,1459040426,5),(1677,1477789226,6),(1677,1490490027,5),(1677,1509238827,6),(1677,1521939627,5),(1677,1540688427,6),(1677,1553994027,5),(1677,1572138027,6),(1677,1585443627,5),(1677,1603587627,6),(1677,1616893227,5),(1677,1635642027,6),(1677,1648342827,5),(1677,1667091627,6),(1677,1679792427,5),(1677,1698541227,6),(1677,1711846827,5),(1677,1729990827,6),(1677,1743296427,5),(1677,1761440427,6),(1677,1774746027,5),(1677,1792890027,6),(1677,1806195627,5),(1677,1824944427,6),(1677,1837645227,5),(1677,1856394027,6),(1677,1869094827,5),(1677,1887843627,6),(1677,1901149227,5),(1677,1919293227,6),(1677,1932598827,5),(1677,1950742827,6),(1677,1964048427,5),(1677,1982797227,6),(1677,1995498027,5),(1677,2014246827,6),(1677,2026947627,5),(1677,2045696427,6),(1677,2058397227,5),(1677,2077146027,6),(1677,2090451627,5),(1677,2108595627,6),(1677,2121901227,5),(1677,2140045227,6),(1678,-2147483648,1),(1678,-1672536240,2),(1678,-1585100136,3),(1678,-1561251600,4),(1678,-1553565600,3),(1678,-928198800,5),(1678,-900126000,8),(1678,-857257200,6),(1678,-844556400,7),(1678,-828226800,6),(1678,-812502000,7),(1678,-802144800,5),(1678,354920409,9),(1678,370728010,5),(1678,386456410,9),(1678,402264011,5),(1678,417992411,9),(1678,433800012,5),(1678,449614812,9),(1678,465346812,10),(1678,481071612,11),(1678,496796413,10),(1678,512521213,11),(1678,528246013,10),(1678,543970813,11),(1678,559695613,10),(1678,575420414,11),(1678,591145214,10),(1678,606870014,12),(1678,622598414,13),(1678,638323215,12),(1678,654652815,13),(1678,670377616,12),(1678,686102416,13),(1678,701827216,12),(1678,717552017,13),(1678,733276817,12),(1678,749001618,13),(1678,764726418,12),(1678,780451219,13),(1678,796176019,12),(1678,811900819,13),(1678,828230420,12),(1678,846374420,13),(1678,859680020,12),(1678,877824021,13),(1678,883605621,4),(1678,891133221,14),(1678,909277221,15),(1678,922582822,14),(1678,941331622,16),(1678,1041372022,4),(1678,1048986022,17),(1678,1067130022,16),(1678,1080435622,17),(1678,1099184422,16),(1678,1111885222,17),(1678,1130634022,16),(1678,1143334823,17),(1678,1162083623,16),(1678,1174784423,17),(1678,1193533223,16),(1678,1206838823,17),(1678,1224982823,16),(1678,1238288424,17),(1678,1256432424,16),(1678,1269738024,17),(1678,1288486824,16),(1678,1301187624,17),(1678,1319936424,16),(1678,1332637224,17),(1678,1351386025,16),(1678,1364691625,17),(1678,1382835625,16),(1678,1396141225,17),(1678,1414285225,16),(1678,1427590825,17),(1678,1445734826,16),(1678,1459040426,17),(1678,1477789226,16),(1678,1490490027,17),(1678,1509238827,16),(1678,1521939627,17),(1678,1540688427,16),(1678,1553994027,17),(1678,1572138027,16),(1678,1585443627,17),(1678,1603587627,16),(1678,1616893227,17),(1678,1635642027,16),(1678,1648342827,17),(1678,1667091627,16),(1678,1679792427,17),(1678,1698541227,16),(1678,1711846827,17),(1678,1729990827,16),(1678,1743296427,17),(1678,1761440427,16),(1678,1774746027,17),(1678,1792890027,16),(1678,1806195627,17),(1678,1824944427,16),(1678,1837645227,17),(1678,1856394027,16),(1678,1869094827,17),(1678,1887843627,16),(1678,1901149227,17),(1678,1919293227,16),(1678,1932598827,17),(1678,1950742827,16),(1678,1964048427,17),(1678,1982797227,16),(1678,1995498027,17),(1678,2014246827,16),(1678,2026947627,17),(1678,2045696427,16),(1678,2058397227,17),(1678,2077146027,16),(1678,2090451627,17),(1678,2108595627,16),(1678,2121901227,17),(1678,2140045227,16),(1679,-2147483648,0),(1679,-1577761060,1),(1679,-1247540400,2),(1679,354916809,3),(1679,370724410,2),(1679,386452810,3),(1679,402260411,2),(1679,417988811,3),(1679,433796412,2),(1679,449611212,3),(1679,465343212,4),(1679,481068012,5),(1679,496792813,4),(1679,512517613,5),(1679,528242413,4),(1679,543967213,5),(1679,559692013,4),(1679,575416814,6),(1679,591145214,7),(1679,606870014,6),(1679,622594814,7),(1679,638319615,6),(1679,654649215,7),(1679,670374016,4),(1679,701820016,6),(1679,717548417,7),(1679,733273217,6),(1679,748998018,7),(1679,764722818,6),(1679,780447619,7),(1679,796172419,6),(1679,811897219,7),(1679,828226820,6),(1679,846370820,7),(1679,859676420,6),(1679,877820421,7),(1679,891126021,6),(1679,909270021,7),(1679,922575622,6),(1679,941324422,7),(1679,954025222,6),(1679,972774022,7),(1679,985474822,6),(1679,1004223622,7),(1679,1017529222,6),(1679,1035673222,7),(1679,1048978822,6),(1679,1067122822,7),(1679,1080428422,6),(1679,1099177222,7),(1679,1111878022,6),(1679,1130626822,7),(1679,1143327623,6),(1679,1162076423,7),(1679,1174777223,6),(1679,1193526023,7),(1679,1206831623,6),(1679,1224975623,7),(1679,1238281224,6),(1679,1256425224,7),(1679,1269730824,6),(1679,1288479624,7),(1679,1301180424,8),(1679,1414274425,7),(1679,1540681227,4),(1679,1609020027,7),(1680,-2147483648,1),(1680,-1717032240,3),(1680,-1693706400,2),(1680,-1680483600,3),(1680,-1663455600,4),(1680,-1650150000,5),(1680,-1632006000,4),(1680,-1618700400,8),(1680,-1600473600,6),(1680,-1587168000,7),(1680,-1501725600,3),(1680,-931734000,2),(1680,-857257200,5),(1680,-844556400,4),(1680,-828226800,5),(1680,-812502000,4),(1680,-796874400,2),(1680,-796608000,3),(1680,-778726800,2),(1680,-762660000,3),(1680,-748486800,4),(1680,-733273200,5),(1680,-715215600,4),(1680,-701910000,5),(1680,-684975600,4),(1680,-670460400,5),(1680,-654130800,4),(1680,-639010800,5),(1680,-397094400,4),(1680,-386812800,5),(1680,-371088000,4),(1680,-355363200,5),(1680,-334195200,4),(1680,-323308800,5),(1680,-307584000,4),(1680,-291859200,5),(1680,-271296000,4),(1680,-260409600,5),(1680,-239846400,4),(1680,-228960000,5),(1680,-208396800,4),(1680,-197510400,5),(1680,-176342400,4),(1680,-166060800,5),(1680,220921205,3),(1680,228873606,4),(1680,243993606,5),(1680,260323207,4),(1680,276048007,5),(1680,291772808,4),(1680,307497608,5),(1680,323827209,4),(1680,338947209,5),(1680,354672009,4),(1680,370396810,5),(1680,386121610,4),(1680,401846411,5),(1680,417571211,4),(1680,433296012,5),(1680,449020812,4),(1680,465350412,5),(1680,481075212,4),(1680,496800013,5),(1680,512524813,4),(1680,528249613,5),(1680,543974413,4),(1680,559699213,5),(1680,567990013,3),(1680,575427614,9),(1680,591152414,10),(1680,606877214,9),(1680,622602014,10),(1680,638326815,9),(1680,654656415,10),(1680,670381216,9),(1680,686106016,10),(1680,701830816,9),(1680,717555617,10),(1680,733280417,9),(1680,749005218,10),(1680,764730018,9),(1680,780454819,10),(1680,796179619,9),(1680,811904419,10),(1680,828234020,9),(1680,846378020,10),(1680,859683620,9),(1680,877827621,10),(1680,891133221,9),(1680,909277221,10),(1680,922582822,9),(1680,941331622,10),(1680,954032422,9),(1680,972781222,10),(1680,985482022,9),(1680,1004230822,10),(1680,1017536422,9),(1680,1035680422,10),(1680,1048986022,9),(1680,1067130022,10),(1680,1080435622,9),(1680,1099184422,10),(1680,1111885222,9),(1680,1130634022,10),(1680,1143334823,9),(1680,1162083623,10),(1680,1174784423,9),(1680,1193533223,10),(1680,1206838823,9),(1680,1224982823,10),(1680,1238288424,9),(1680,1256432424,10),(1680,1269738024,9),(1680,1288486824,10),(1680,1301187624,9),(1680,1319936424,10),(1680,1332637224,9),(1680,1351386025,10),(1680,1364691625,9),(1680,1382835625,10),(1680,1396141225,9),(1680,1414285225,10),(1680,1427590825,9),(1680,1445734826,10),(1680,1459040426,9),(1680,1477789226,10),(1680,1490490027,9),(1680,1509238827,10),(1680,1521939627,9),(1680,1540688427,10),(1680,1553994027,9),(1680,1572138027,10),(1680,1585443627,9),(1680,1603587627,10),(1680,1616893227,9),(1680,1635642027,10),(1680,1648342827,9),(1680,1667091627,10),(1680,1679792427,9),(1680,1698541227,10),(1680,1711846827,9),(1680,1729990827,10),(1680,1743296427,9),(1680,1761440427,10),(1680,1774746027,9),(1680,1792890027,10),(1680,1806195627,9),(1680,1824944427,10),(1680,1837645227,9),(1680,1856394027,10),(1680,1869094827,9),(1680,1887843627,10),(1680,1901149227,9),(1680,1919293227,10),(1680,1932598827,9),(1680,1950742827,10),(1680,1964048427,9),(1680,1982797227,10),(1680,1995498027,9),(1680,2014246827,10),(1680,2026947627,9),(1680,2045696427,10),(1680,2058397227,9),(1680,2077146027,10),(1680,2090451627,9),(1680,2108595627,10),(1680,2121901227,9),(1680,2140045227,10),(1681,-2147483648,1),(1681,-905824800,4),(1681,-857257200,2),(1681,-844556400,3),(1681,-828226800,2),(1681,-812502000,3),(1681,-796777200,2),(1681,-788922000,1),(1681,-777942000,3),(1681,-766623600,2),(1681,407199611,1),(1681,417574811,5),(1681,433299612,6),(1681,449024412,5),(1681,465354012,6),(1681,481078812,5),(1681,496803613,6),(1681,512528413,5),(1681,528253213,6),(1681,543978013,5),(1681,559702813,6),(1681,575427614,5),(1681,591152414,6),(1681,606877214,5),(1681,622602014,6),(1681,638326815,5),(1681,654656415,6),(1681,670381216,5),(1681,686106016,6),(1681,701830816,5),(1681,717555617,6),(1681,733280417,5),(1681,749005218,6),(1681,764730018,5),(1681,780454819,6),(1681,796179619,5),(1681,811904419,6),(1681,828234020,5),(1681,846378020,6),(1681,859683620,5),(1681,877827621,6),(1681,891133221,5),(1681,909277221,6),(1681,922582822,5),(1681,941331622,6),(1681,954032422,5),(1681,972781222,6),(1681,985482022,5),(1681,1004230822,6),(1681,1017536422,5),(1681,1035680422,6),(1681,1048986022,5),(1681,1067130022,6),(1681,1080435622,5),(1681,1099184422,6),(1681,1111885222,5),(1681,1130634022,6),(1681,1143334823,5),(1681,1162083623,6),(1681,1174784423,5),(1681,1193533223,6),(1681,1206838823,5),(1681,1224982823,6),(1681,1238288424,5),(1681,1256432424,6),(1681,1269738024,5),(1681,1288486824,6),(1681,1301187624,5),(1681,1319936424,6),(1681,1332637224,5),(1681,1351386025,6),(1681,1364691625,5),(1681,1382835625,6),(1681,1396141225,5),(1681,1414285225,6),(1681,1427590825,5),(1681,1445734826,6),(1681,1459040426,5),(1681,1477789226,6),(1681,1490490027,5),(1681,1509238827,6),(1681,1521939627,5),(1681,1540688427,6),(1681,1553994027,5),(1681,1572138027,6),(1681,1585443627,5),(1681,1603587627,6),(1681,1616893227,5),(1681,1635642027,6),(1681,1648342827,5),(1681,1667091627,6),(1681,1679792427,5),(1681,1698541227,6),(1681,1711846827,5),(1681,1729990827,6),(1681,1743296427,5),(1681,1761440427,6),(1681,1774746027,5),(1681,1792890027,6),(1681,1806195627,5),(1681,1824944427,6),(1681,1837645227,5),(1681,1856394027,6),(1681,1869094827,5),(1681,1887843627,6),(1681,1901149227,5),(1681,1919293227,6),(1681,1932598827,5),(1681,1950742827,6),(1681,1964048427,5),(1681,1982797227,6),(1681,1995498027,5),(1681,2014246827,6),(1681,2026947627,5),(1681,2045696427,6),(1681,2058397227,5),(1681,2077146027,6),(1681,2090451627,5),(1681,2108595627,6),(1681,2121901227,5),(1681,2140045227,6),(1682,-2147483648,1),(1682,-1441159324,2),(1682,-1247536800,3),(1682,-892522800,6),(1682,-857257200,4),(1682,-844556400,5),(1682,-828226800,4),(1682,-825382800,3),(1682,354920409,7),(1682,370728010,3),(1682,386456410,7),(1682,402264011,3),(1682,417992411,7),(1682,433800012,3),(1682,449614812,7),(1682,465346812,8),(1682,481071612,9),(1682,496796413,8),(1682,512521213,9),(1682,528246013,8),(1682,543970813,9),(1682,559695613,8),(1682,575420414,9),(1682,591145214,8),(1682,606870014,9),(1682,622594814,8),(1682,638319615,9),(1682,646783215,10),(1682,686102416,11),(1682,701827216,12),(1682,717552017,11),(1682,733276817,12),(1682,749001618,11),(1682,764726418,12),(1682,780451219,11),(1682,796176019,12),(1682,811900819,11),(1682,828230420,12),(1682,831934820,10),(1682,846378020,13),(1682,859683620,14),(1682,877827621,13),(1682,891133221,14),(1682,909277221,13),(1682,922582822,14),(1682,941331622,13),(1682,954032422,14),(1682,972781222,13),(1682,985482022,14),(1682,1004230822,13),(1682,1017536422,14),(1682,1035680422,13),(1682,1048986022,14),(1682,1067130022,13),(1682,1080435622,14),(1682,1099184422,13),(1682,1111885222,14),(1682,1130634022,13),(1682,1143334823,14),(1682,1162083623,13),(1682,1174784423,14),(1682,1193533223,13),(1682,1206838823,14),(1682,1224982823,13),(1682,1238288424,14),(1682,1256432424,13),(1682,1269738024,14),(1682,1288486824,13),(1682,1301187624,14),(1682,1319936424,13),(1682,1332637224,14),(1682,1351386025,13),(1682,1364691625,14),(1682,1382835625,13),(1682,1396141225,14),(1682,1414285225,13),(1682,1427590825,14),(1682,1445734826,13),(1682,1459040426,14),(1682,1477789226,13),(1682,1490490027,14),(1682,1509238827,13),(1682,1521939627,14),(1682,1540688427,13),(1682,1553994027,14),(1682,1572138027,13),(1682,1585443627,14),(1682,1603587627,13),(1682,1616893227,14),(1682,1635642027,13),(1682,1648342827,14),(1682,1667091627,13),(1682,1679792427,14),(1682,1698541227,13),(1682,1711846827,14),(1682,1729990827,13),(1682,1743296427,14),(1682,1761440427,13),(1682,1774746027,14),(1682,1792890027,13),(1682,1806195627,14),(1682,1824944427,13),(1682,1837645227,14),(1682,1856394027,13),(1682,1869094827,14),(1682,1887843627,13),(1682,1901149227,14),(1682,1919293227,13),(1682,1932598827,14),(1682,1950742827,13),(1682,1964048427,14),(1682,1982797227,13),(1682,1995498027,14),(1682,2014246827,13),(1682,2026947627,14),(1682,2045696427,13),(1682,2058397227,14),(1682,2077146027,13),(1682,2090451627,14),(1682,2108595627,13),(1682,2121901227,14),(1682,2140045227,13),(1683,-2147483648,2),(1683,-904435200,1),(1683,-891129600,2),(1683,-872985600,1),(1683,-859680000,2),(1683,354675609,3),(1683,370400410,4),(1683,386125210,3),(1683,401850011,4),(1683,417574811,3),(1683,433299612,4),(1683,449024412,3),(1683,465354012,4),(1683,481078812,3),(1683,496803613,4),(1683,512528413,3),(1683,528253213,4),(1683,543978013,3),(1683,559702813,4),(1683,575427614,3),(1683,591152414,4),(1683,606877214,3),(1683,622602014,4),(1683,638326815,3),(1683,654656415,4),(1683,670381216,3),(1683,686106016,4),(1683,701830816,3),(1683,717555617,4),(1683,733280417,3),(1683,749005218,4),(1683,764730018,3),(1683,780454819,4),(1683,796179619,3),(1683,811904419,4),(1683,828234020,3),(1683,846378020,4),(1683,859683620,3),(1683,877827621,4),(1683,891133221,3),(1683,909277221,4),(1683,922582822,3),(1683,941331622,4),(1683,954032422,3),(1683,972781222,4),(1683,985482022,3),(1683,1004230822,4),(1683,1017536422,3),(1683,1035680422,4),(1683,1048986022,3),(1683,1067130022,4),(1683,1080435622,3),(1683,1099184422,4),(1683,1111885222,3),(1683,1130634022,4),(1683,1143334823,3),(1683,1162083623,4),(1683,1174784423,3),(1683,1193533223,4),(1683,1206838823,3),(1683,1224982823,4),(1683,1238288424,3),(1683,1256432424,4),(1683,1269738024,3),(1683,1288486824,4),(1683,1301187624,3),(1683,1319936424,4),(1683,1332637224,3),(1683,1351386025,4),(1683,1364691625,3),(1683,1382835625,4),(1683,1396141225,3),(1683,1414285225,4),(1683,1427590825,3),(1683,1445734826,4),(1683,1459040426,3),(1683,1477789226,4),(1683,1490490027,3),(1683,1509238827,4),(1683,1521939627,3),(1683,1540688427,4),(1683,1553994027,3),(1683,1572138027,4),(1683,1585443627,3),(1683,1603587627,4),(1683,1616893227,3),(1683,1635642027,4),(1683,1648342827,3),(1683,1667091627,4),(1683,1679792427,3),(1683,1698541227,4),(1683,1711846827,3),(1683,1729990827,4),(1683,1743296427,3),(1683,1761440427,4),(1683,1774746027,3),(1683,1792890027,4),(1683,1806195627,3),(1683,1824944427,4),(1683,1837645227,3),(1683,1856394027,4),(1683,1869094827,3),(1683,1887843627,4),(1683,1901149227,3),(1683,1919293227,4),(1683,1932598827,3),(1683,1950742827,4),(1683,1964048427,3),(1683,1982797227,4),(1683,1995498027,3),(1683,2014246827,4),(1683,2026947627,3),(1683,2045696427,4),(1683,2058397227,3),(1683,2077146027,4),(1683,2090451627,3),(1683,2108595627,4),(1683,2121901227,3),(1683,2140045227,4),(1684,-2147483648,4),(1684,-1691964000,1),(1684,-1680472800,2),(1684,-1664143200,1),(1684,-1650146400,2),(1684,-1633903200,1),(1684,-1617487200,2),(1684,-1601848800,1),(1684,-1586037600,2),(1684,-1570399200,1),(1684,-1552168800,2),(1684,-1538344800,1),(1684,-1522533600,2),(1684,-1507500000,1),(1684,-1490565600,2),(1684,-1473631200,1),(1684,-1460930400,2),(1684,-1442786400,1),(1684,-1428876000,2),(1684,-1410732000,1),(1684,-1396216800,2),(1684,-1379282400,1),(1684,-1364767200,2),(1684,-1348437600,1),(1684,-1333317600,2),(1684,-1315778400,1),(1684,-1301263200,2),(1684,-1284328800,1),(1684,-1269813600,2),(1684,-1253484000,1),(1684,-1238364000,2),(1684,-1221429600,1),(1684,-1206914400,2),(1684,-1189980000,1),(1684,-1175464800,2),(1684,-1159135200,1),(1684,-1143410400,2),(1684,-1126476000,1),(1684,-1111960800,2),(1684,-1095631200,1),(1684,-1080511200,2),(1684,-1063576800,1),(1684,-1049061600,2),(1684,-1032127200,1),(1684,-1017612000,2),(1684,-1001282400,1),(1684,-986162400,2),(1684,-969228000,1),(1684,-950479200,2),(1684,-942012000,1),(1684,-904518000,3),(1684,-896050800,1),(1684,-875487600,3),(1684,-864601200,1),(1684,-844038000,3),(1684,-832546800,1),(1684,-812588400,3),(1684,-798073200,1),(1684,-781052400,3),(1684,-772066800,1),(1684,-764805600,2),(1684,-748476000,1),(1684,-733356000,2),(1684,-719445600,1),(1684,-717030000,3),(1684,-706748400,1),(1684,-699487200,2),(1684,-687996000,1),(1684,-668037600,2),(1684,-654732000,1),(1684,-636588000,2),(1684,-622072800,1),(1684,-605743200,2),(1684,-590623200,1),(1684,-574293600,2),(1684,-558568800,1),(1684,-542239200,2),(1684,-527119200,1),(1684,-512604000,2),(1684,-496274400,1),(1684,-481154400,2),(1684,-464220000,1),(1684,-449704800,2),(1684,-432165600,1),(1684,-417650400,2),(1684,-401320800,1),(1684,-386200800,2),(1684,-369266400,1),(1684,-354751200,2),(1684,-337816800,1),(1684,-323301600,2),(1684,-306972000,1),(1684,-291852000,2),(1684,-276732000,1),(1684,-257983200,2),(1684,-245282400,1),(1684,-226533600,2),(1684,-213228000,1),(1684,-195084000,2),(1684,-182383200,1),(1684,-163634400,2),(1684,-150933600,1),(1684,-132184800,2),(1684,-119484000,1),(1684,-100735200,2),(1684,-88034400,1),(1684,-68680800,2),(1684,-59004000,1),(1684,-37242000,5),(1684,57722400,7),(1684,69818400,1),(1684,89172001,2),(1684,101268002,1),(1684,120621602,2),(1684,132717603,1),(1684,152071203,2),(1684,164167204,1),(1684,183520804,2),(1684,196221605,1),(1684,214970405,2),(1684,227671206,1),(1684,246420006,2),(1684,259120807,1),(1684,278474407,2),(1684,290570408,1),(1684,309924008,2),(1684,322020009,1),(1684,341373609,2),(1684,354675609,6),(1684,372819610,7),(1684,386125210,6),(1684,404269211,7),(1684,417574811,6),(1684,435718812,7),(1684,449024412,6),(1684,467773212,7),(1684,481078812,6),(1684,499222813,7),(1684,512528413,6),(1684,530672413,7),(1684,543978013,6),(1684,562122013,7),(1684,575427614,6),(1684,593571614,7),(1684,606877214,6),(1684,625626014,7),(1684,638326815,6),(1684,657075615,7),(1684,670381216,6),(1684,688525216,7),(1684,701830816,6),(1684,719974817,7),(1684,733280417,6),(1684,751424418,7),(1684,764730018,6),(1684,782874019,7),(1684,796179619,6),(1684,814323619,7),(1684,820454420,4),(1684,828234020,6),(1684,846378020,7),(1684,859683620,6),(1684,877827621,7),(1684,891133221,6),(1684,909277221,7),(1684,922582822,6),(1684,941331622,7),(1684,954032422,6),(1684,972781222,7),(1684,985482022,6),(1684,1004230822,7),(1684,1017536422,6),(1684,1035680422,7),(1684,1048986022,6),(1684,1067130022,7),(1684,1080435622,6),(1684,1099184422,7),(1684,1111885222,6),(1684,1130634022,7),(1684,1143334823,6),(1684,1162083623,7),(1684,1174784423,6),(1684,1193533223,7),(1684,1206838823,6),(1684,1224982823,7),(1684,1238288424,6),(1684,1256432424,7),(1684,1269738024,6),(1684,1288486824,7),(1684,1301187624,6),(1684,1319936424,7),(1684,1332637224,6),(1684,1351386025,7),(1684,1364691625,6),(1684,1382835625,7),(1684,1396141225,6),(1684,1414285225,7),(1684,1427590825,6),(1684,1445734826,7),(1684,1459040426,6),(1684,1477789226,7),(1684,1490490027,6),(1684,1509238827,7),(1684,1521939627,6),(1684,1540688427,7),(1684,1553994027,6),(1684,1572138027,7),(1684,1585443627,6),(1684,1603587627,7),(1684,1616893227,6),(1684,1635642027,7),(1684,1648342827,6),(1684,1667091627,7),(1684,1679792427,6),(1684,1698541227,7),(1684,1711846827,6),(1684,1729990827,7),(1684,1743296427,6),(1684,1761440427,7),(1684,1774746027,6),(1684,1792890027,7),(1684,1806195627,6),(1684,1824944427,7),(1684,1837645227,6),(1684,1856394027,7),(1684,1869094827,6),(1684,1887843627,7),(1684,1901149227,6),(1684,1919293227,7),(1684,1932598827,6),(1684,1950742827,7),(1684,1964048427,6),(1684,1982797227,7),(1684,1995498027,6),(1684,2014246827,7),(1684,2026947627,6),(1684,2045696427,7),(1684,2058397227,6),(1684,2077146027,7),(1684,2090451627,6),(1684,2108595627,7),(1684,2121901227,6),(1684,2140045227,7),(1685,-2147483648,4),(1685,-1691964000,1),(1685,-1680472800,2),(1685,-1664143200,1),(1685,-1650146400,2),(1685,-1633903200,1),(1685,-1617487200,2),(1685,-1601848800,1),(1685,-1586037600,2),(1685,-1570399200,1),(1685,-1552168800,2),(1685,-1538344800,1),(1685,-1522533600,2),(1685,-1507500000,1),(1685,-1490565600,2),(1685,-1473631200,1),(1685,-1460930400,2),(1685,-1442786400,1),(1685,-1428876000,2),(1685,-1410732000,1),(1685,-1396216800,2),(1685,-1379282400,1),(1685,-1364767200,2),(1685,-1348437600,1),(1685,-1333317600,2),(1685,-1315778400,1),(1685,-1301263200,2),(1685,-1284328800,1),(1685,-1269813600,2),(1685,-1253484000,1),(1685,-1238364000,2),(1685,-1221429600,1),(1685,-1206914400,2),(1685,-1189980000,1),(1685,-1175464800,2),(1685,-1159135200,1),(1685,-1143410400,2),(1685,-1126476000,1),(1685,-1111960800,2),(1685,-1095631200,1),(1685,-1080511200,2),(1685,-1063576800,1),(1685,-1049061600,2),(1685,-1032127200,1),(1685,-1017612000,2),(1685,-1001282400,1),(1685,-986162400,2),(1685,-969228000,1),(1685,-950479200,2),(1685,-942012000,1),(1685,-904518000,3),(1685,-896050800,1),(1685,-875487600,3),(1685,-864601200,1),(1685,-844038000,3),(1685,-832546800,1),(1685,-812588400,3),(1685,-798073200,1),(1685,-781052400,3),(1685,-772066800,1),(1685,-764805600,2),(1685,-748476000,1),(1685,-733356000,2),(1685,-719445600,1),(1685,-717030000,3),(1685,-706748400,1),(1685,-699487200,2),(1685,-687996000,1),(1685,-668037600,2),(1685,-654732000,1),(1685,-636588000,2),(1685,-622072800,1),(1685,-605743200,2),(1685,-590623200,1),(1685,-574293600,2),(1685,-558568800,1),(1685,-542239200,2),(1685,-527119200,1),(1685,-512604000,2),(1685,-496274400,1),(1685,-481154400,2),(1685,-464220000,1),(1685,-449704800,2),(1685,-432165600,1),(1685,-417650400,2),(1685,-401320800,1),(1685,-386200800,2),(1685,-369266400,1),(1685,-354751200,2),(1685,-337816800,1),(1685,-323301600,2),(1685,-306972000,1),(1685,-291852000,2),(1685,-276732000,1),(1685,-257983200,2),(1685,-245282400,1),(1685,-226533600,2),(1685,-213228000,1),(1685,-195084000,2),(1685,-182383200,1),(1685,-163634400,2),(1685,-150933600,1),(1685,-132184800,2),(1685,-119484000,1),(1685,-100735200,2),(1685,-88034400,1),(1685,-68680800,2),(1685,-59004000,1),(1685,-37242000,5),(1685,57722400,7),(1685,69818400,1),(1685,89172001,2),(1685,101268002,1),(1685,120621602,2),(1685,132717603,1),(1685,152071203,2),(1685,164167204,1),(1685,183520804,2),(1685,196221605,1),(1685,214970405,2),(1685,227671206,1),(1685,246420006,2),(1685,259120807,1),(1685,278474407,2),(1685,290570408,1),(1685,309924008,2),(1685,322020009,1),(1685,341373609,2),(1685,354675609,6),(1685,372819610,7),(1685,386125210,6),(1685,404269211,7),(1685,417574811,6),(1685,435718812,7),(1685,449024412,6),(1685,467773212,7),(1685,481078812,6),(1685,499222813,7),(1685,512528413,6),(1685,530672413,7),(1685,543978013,6),(1685,562122013,7),(1685,575427614,6),(1685,593571614,7),(1685,606877214,6),(1685,625626014,7),(1685,638326815,6),(1685,657075615,7),(1685,670381216,6),(1685,688525216,7),(1685,701830816,6),(1685,719974817,7),(1685,733280417,6),(1685,751424418,7),(1685,764730018,6),(1685,782874019,7),(1685,796179619,6),(1685,814323619,7),(1685,820454420,4),(1685,828234020,6),(1685,846378020,7),(1685,859683620,6),(1685,877827621,7),(1685,891133221,6),(1685,909277221,7),(1685,922582822,6),(1685,941331622,7),(1685,954032422,6),(1685,972781222,7),(1685,985482022,6),(1685,1004230822,7),(1685,1017536422,6),(1685,1035680422,7),(1685,1048986022,6),(1685,1067130022,7),(1685,1080435622,6),(1685,1099184422,7),(1685,1111885222,6),(1685,1130634022,7),(1685,1143334823,6),(1685,1162083623,7),(1685,1174784423,6),(1685,1193533223,7),(1685,1206838823,6),(1685,1224982823,7),(1685,1238288424,6),(1685,1256432424,7),(1685,1269738024,6),(1685,1288486824,7),(1685,1301187624,6),(1685,1319936424,7),(1685,1332637224,6),(1685,1351386025,7),(1685,1364691625,6),(1685,1382835625,7),(1685,1396141225,6),(1685,1414285225,7),(1685,1427590825,6),(1685,1445734826,7),(1685,1459040426,6),(1685,1477789226,7),(1685,1490490027,6),(1685,1509238827,7),(1685,1521939627,6),(1685,1540688427,7),(1685,1553994027,6),(1685,1572138027,7),(1685,1585443627,6),(1685,1603587627,7),(1685,1616893227,6),(1685,1635642027,7),(1685,1648342827,6),(1685,1667091627,7),(1685,1679792427,6),(1685,1698541227,7),(1685,1711846827,6),(1685,1729990827,7),(1685,1743296427,6),(1685,1761440427,7),(1685,1774746027,6),(1685,1792890027,7),(1685,1806195627,6),(1685,1824944427,7),(1685,1837645227,6),(1685,1856394027,7),(1685,1869094827,6),(1685,1887843627,7),(1685,1901149227,6),(1685,1919293227,7),(1685,1932598827,6),(1685,1950742827,7),(1685,1964048427,6),(1685,1982797227,7),(1685,1995498027,6),(1685,2014246827,7),(1685,2026947627,6),(1685,2045696427,7),(1685,2058397227,6),(1685,2077146027,7),(1685,2090451627,6),(1685,2108595627,7),(1685,2121901227,6),(1685,2140045227,7),(1692,-2147483648,0),(1692,-2056690800,1),(1692,-900910800,2),(1692,-891579600,3),(1692,-884248200,4),(1692,-761209200,7),(1692,-747907200,2),(1692,-728541000,5),(1692,-717049800,6),(1692,-697091400,5),(1692,-683785800,6),(1692,-668061000,5),(1692,-654755400,2),(1692,-636611400,5),(1692,-623305800,2),(1692,-605161800,5),(1692,-591856200,2),(1692,-573712200,5),(1692,-559801800,2),(1692,-541657800,5),(1692,-528352200,2),(1692,-510211800,7),(1692,-498112200,2),(1692,-478762200,7),(1692,-466662600,2),(1692,-446707800,7),(1692,-435213000,2),(1692,-415258200,7),(1692,-403158600,2),(1692,-383808600,7),(1692,-371709000,2),(1692,-352359000,7),(1692,-340259400,2),(1692,-320909400,7),(1692,-308809800,2),(1692,-288855000,7),(1692,-277360200,2),(1692,-257405400,7),(1692,-245910600,2),(1692,-225955800,7),(1692,-213856200,2),(1692,-194506200,7),(1692,-182406600,2),(1692,-163056600,7),(1692,-148537800,2),(1692,-132816600,7),(1692,-117088200,2),(1692,-101367000,7),(1692,-85638600,2),(1692,-69312600,7),(1692,-53584200,2),(1692,-37863000,7),(1692,-22134600,2),(1692,-6413400,7),(1692,9315000,2),(1692,25036200,7),(1692,40764600,2),(1692,56485800,7),(1692,72214200,2),(1692,88540201,7),(1692,104268602,2),(1692,119989802,7),(1692,126041402,2),(1692,151439403,7),(1692,167167804,2),(1692,182889004,7),(1692,198617405,2),(1692,214338605,7),(1692,295385408,2),(1692,309292208,7),(1693,-2147483648,0),(1693,-1830383032,1),(1694,-2147483648,0),(1694,-1946168836,1),(1694,-1309746600,2),(1694,-1261969200,1),(1694,-1041388200,3),(1694,-865305900,2),(1695,-2147483648,0),(1695,-1988167780,1),(1695,820436419,2),(1696,-2147483648,1),(1696,-1570084924,2),(1697,-2147483648,1),(1697,-1577946287,2),(1697,-873268200,3),(1697,-778410000,2),(1698,-2147483648,0),(1698,-1946168836,1),(1698,-1309746600,2),(1698,-1261969200,1),(1698,-1041388200,3),(1698,-865305900,2),(1699,-2147483648,1),(1699,-315636840,2),(1700,-2147483648,0),(1700,-1577936472,1),(1701,-2147483648,1),(1701,-315636840,2),(1702,-2147483648,0),(1702,-1988164200,2),(1702,403041611,1),(1702,417034811,2),(1702,1224972023,1),(1702,1238274024,2),(1703,-2147483648,0),(1703,-1946168836,1),(1703,-1309746600,2),(1703,-1261969200,1),(1703,-1041388200,3),(1703,-865305900,2),(1704,-2147483648,0),(1704,-1577936472,1),(1705,-2147483648,0),(1705,-1704165944,1),(1705,-1090466744,3),(1705,227820606,2),(1705,246223806,5),(1705,259617607,4),(1705,271108807,5),(1705,283982407,3),(1705,296598608,2),(1705,306531008,3),(1705,322432209,2),(1705,338499009,3),(1705,673216216,2),(1705,685481416,3),(1705,701209816,2),(1705,717103817,3),(1705,732745817,2),(1705,748639818,3),(1705,764281818,2),(1705,780175819,3),(1705,795817819,2),(1705,811711819,3),(1705,827353820,2),(1705,843247820,3),(1705,858976220,2),(1705,874870221,3),(1705,890512221,2),(1705,906406221,3),(1705,922048222,2),(1705,937942222,3),(1705,953584222,2),(1705,969478222,3),(1705,985206622,2),(1705,1001100622,3),(1705,1016742622,2),(1705,1032636622,3),(1705,1048278622,2),(1705,1064172622,3),(1705,1079814622,2),(1705,1095708622,3),(1705,1111437022,2),(1705,1127331022,3),(1705,1206045023,2),(1705,1221939023,3),(1705,1237667424,2),(1705,1253561424,3),(1705,1269203424,2),(1705,1285097424,3),(1705,1300739424,2),(1705,1316633424,3),(1705,1332275424,2),(1705,1348169425,3),(1705,1363897825,2),(1705,1379791825,3),(1705,1395433825,2),(1705,1411327825,3),(1705,1426969825,2),(1705,1442863826,3),(1705,1458505826,2),(1705,1474399826,3),(1705,1490128227,2),(1705,1506022227,3),(1705,1521664227,2),(1705,1537558227,3),(1705,1553200227,2),(1705,1569094227,3),(1705,1584736227,2),(1705,1600630227,3),(1705,1616358627,2),(1705,1632252627,3),(1705,1647894627,2),(1705,1663788627,3),(1706,-2147483648,1),(1706,-1641003640,6),(1706,-933638400,2),(1706,-923097600,3),(1706,-919036800,2),(1706,-857347200,3),(1706,-844300800,2),(1706,-825811200,3),(1706,-812678400,2),(1706,-794188800,3),(1706,-779846400,2),(1706,-762652800,3),(1706,-748310400,2),(1706,-731116800,3),(1706,-681955200,4),(1706,-673228800,2),(1706,-667958400,3),(1706,-652320000,2),(1706,-636422400,3),(1706,-622080000,2),(1706,-608947200,3),(1706,-591840000,2),(1706,-572486400,3),(1706,-558576000,2),(1706,-542851200,3),(1706,-527731200,2),(1706,-514425600,3),(1706,-490838400,2),(1706,-482976000,3),(1706,-459388800,2),(1706,-451526400,3),(1706,-428544000,2),(1706,-418262400,3),(1706,-400118400,2),(1706,-387417600,3),(1706,142380003,5),(1706,150843603,6),(1706,167176804,5),(1706,178664404,6),(1706,334101609,7),(1706,337730409,8),(1706,452642412,7),(1706,462319212,8),(1706,482277612,5),(1706,494370013,6),(1706,516751213,5),(1706,526424413,6),(1706,545436013,5),(1706,558478813,6),(1706,576626414,5),(1706,589323614,6),(1706,609890414,5),(1706,620773214,6),(1706,638316015,5),(1706,651618015,6),(1706,669765616,5),(1706,683672416,6),(1706,701820016,5),(1706,715726817,6),(1706,733701617,5),(1706,747176418,6),(1706,765151218,5),(1706,778021219,6),(1706,796600819,5),(1706,810075619,6),(1706,826840820,5),(1706,842821220,6),(1706,858895220,5),(1706,874184421,6),(1706,890344821,5),(1706,905029221,6),(1706,923011222,5),(1706,936313222,6),(1706,955670422,5),(1706,970783222,6),(1706,986770822,5),(1706,1001282422,6),(1706,1017356422,5),(1706,1033941622,6),(1706,1048806022,5),(1706,1065132022,6),(1706,1081292422,5),(1706,1095804022,6),(1706,1112313622,5),(1706,1128812422,6),(1706,1143763223,5),(1706,1159657223,6),(1706,1175212823,5),(1706,1189897223,6),(1706,1206662423,5),(1706,1223161223,6),(1706,1238112024,5),(1706,1254006024,6),(1706,1269561624,5),(1706,1284246024,6),(1706,1301616024,5),(1706,1317510024,6),(1706,1333065624,5),(1706,1348354825,6),(1706,1364515225,5),(1706,1382828425,6),(1706,1395964825,5),(1706,1414278025,6),(1706,1427414425,5),(1706,1445727626,6),(1706,1458864026,5),(1706,1477782026,6),(1706,1490313627,5),(1706,1509231627,6),(1706,1521763227,5),(1706,1540681227,6),(1706,1553817627,5),(1706,1572130827,6),(1706,1585267227,5),(1706,1603580427,6),(1706,1616716827,5),(1706,1635634827,6),(1706,1648166427,5),(1706,1667084427,6),(1706,1679616027,5),(1706,1698534027,6),(1706,1711670427,5),(1706,1729983627,6),(1706,1743120027,5),(1706,1761433227,6),(1706,1774569627,5),(1706,1792882827,6),(1706,1806019227,5),(1706,1824937227,6),(1706,1837468827,5),(1706,1856386827,6),(1706,1868918427,5),(1706,1887836427,6),(1706,1900972827,5),(1706,1919286027,6),(1706,1932422427,5),(1706,1950735627,6),(1706,1963872027,5),(1706,1982790027,6),(1706,1995321627,5),(1706,2014239627,6),(1706,2026771227,5),(1706,2045689227,6),(1706,2058220827,5),(1706,2077138827,6),(1706,2090275227,5),(1706,2108588427,6),(1706,2121724827,5),(1706,2140038027,6),(1707,-2147483648,1),(1707,-1827687170,2),(1707,126687603,3),(1707,152085603,2),(1707,162370804,3),(1707,183535204,2),(1707,199263605,3),(1707,215589605,2),(1707,230713206,3),(1707,247039206,2),(1707,262767607,3),(1707,278488807,2),(1707,294217208,3),(1707,309938408,2),(1707,325666809,3),(1707,341388009,2),(1707,357116409,3),(1707,372837610,2),(1707,388566010,3),(1707,404892011,2),(1707,420015611,3),(1707,436341612,2),(1708,-2147483648,3),(1708,-683802000,1),(1708,-672310800,2),(1708,-654771600,1),(1708,-640861200,2),(1708,-620298000,1),(1708,-609411600,2),(1708,-588848400,1),(1708,-577962000,2),(1709,-2147483648,1),(1709,-1041418800,2),(1709,-907408800,3),(1709,-817462800,1),(1709,-7988400,4),(1709,745934418,5),(1710,-2147483648,0),(1710,-1577926364,2),(1710,-574902000,1),(1710,-568087200,2),(1710,-512175600,1),(1710,-504928800,2),(1710,-449888400,1),(1710,-441856800,2),(1710,-347158800,3),(1710,378684010,2),(1710,386463610,1),(1710,402271211,2),(1710,417999611,1),(1710,433807212,2),(1710,449622012,1),(1710,465429612,2),(1710,481590012,1),(1710,496965613,2),(1710,512953213,1),(1710,528674413,2),(1710,544230013,1),(1710,560037613,2),(1710,575852414,1),(1710,591660014,2),(1710,607388414,1),(1710,623196014,2),(1710,641775615,3),(1710,844034420,2),(1710,860108420,1),(1710,875916021,3),(1710,1352505625,2),(1710,1364515225,1),(1710,1382659225,3),(1711,-1693706400,0),(1711,-1680483600,1),(1711,-1663455600,2),(1711,-1650150000,3),(1711,-1632006000,2),(1711,-1618700400,3),(1711,-938905200,2),(1711,-857257200,3),(1711,-844556400,2),(1711,-828226800,3),(1711,-812502000,2),(1711,-796777200,3),(1711,-781052400,2),(1711,-766623600,3),(1711,228877206,2),(1711,243997206,3),(1711,260326807,2),(1711,276051607,3),(1711,291776408,2),(1711,307501208,3),(1711,323830809,2),(1711,338950809,3),(1711,354675609,2),(1711,370400410,3),(1711,386125210,2),(1711,401850011,3),(1711,417574811,2),(1711,433299612,3),(1711,449024412,2),(1711,465354012,3),(1711,481078812,2),(1711,496803613,3),(1711,512528413,2),(1711,528253213,3),(1711,543978013,2),(1711,559702813,3),(1711,575427614,2),(1711,591152414,3),(1711,606877214,2),(1711,622602014,3),(1711,638326815,2),(1711,654656415,3),(1711,670381216,2),(1711,686106016,3),(1711,701830816,2),(1711,717555617,3),(1711,733280417,2),(1711,749005218,3),(1711,764730018,2),(1711,780454819,3),(1711,796179619,2),(1711,811904419,3),(1711,828234020,2),(1711,846378020,3),(1711,859683620,2),(1711,877827621,3),(1711,891133221,2),(1711,909277221,3),(1711,922582822,2),(1711,941331622,3),(1711,954032422,2),(1711,972781222,3),(1711,985482022,2),(1711,1004230822,3),(1711,1017536422,2),(1711,1035680422,3),(1711,1048986022,2),(1711,1067130022,3),(1711,1080435622,2),(1711,1099184422,3),(1711,1111885222,2),(1711,1130634022,3),(1711,1143334823,2),(1711,1162083623,3),(1711,1174784423,2),(1711,1193533223,3),(1711,1206838823,2),(1711,1224982823,3),(1711,1238288424,2),(1711,1256432424,3),(1711,1269738024,2),(1711,1288486824,3),(1711,1301187624,2),(1711,1319936424,3),(1711,1332637224,2),(1711,1351386025,3),(1711,1364691625,2),(1711,1382835625,3),(1711,1396141225,2),(1711,1414285225,3),(1711,1427590825,2),(1711,1445734826,3),(1711,1459040426,2),(1711,1477789226,3),(1711,1490490027,2),(1711,1509238827,3),(1711,1521939627,2),(1711,1540688427,3),(1711,1553994027,2),(1711,1572138027,3),(1711,1585443627,2),(1711,1603587627,3),(1711,1616893227,2),(1711,1635642027,3),(1711,1648342827,2),(1711,1667091627,3),(1711,1679792427,2),(1711,1698541227,3),(1711,1711846827,2),(1711,1729990827,3),(1711,1743296427,2),(1711,1761440427,3),(1711,1774746027,2),(1711,1792890027,3),(1711,1806195627,2),(1711,1824944427,3),(1711,1837645227,2),(1711,1856394027,3),(1711,1869094827,2),(1711,1887843627,3),(1711,1901149227,2),(1711,1919293227,3),(1711,1932598827,2),(1711,1950742827,3),(1711,1964048427,2),(1711,1982797227,3),(1711,1995498027,2),(1711,2014246827,3),(1711,2026947627,2),(1711,2045696427,3),(1711,2058397227,2),(1711,2077146027,3),(1711,2090451627,2),(1711,2108595627,3),(1711,2121901227,2),(1711,2140045227,3),(1713,-1633273200,0),(1713,-1615132800,1),(1713,-1601823600,0),(1713,-1583683200,1),(1713,-880210800,2),(1713,-769395600,3),(1713,-765388800,1),(1713,-84380400,0),(1713,-68659200,1),(1713,-52930800,0),(1713,-37209600,1),(1713,-21481200,0),(1713,-5760000,1),(1713,9968400,0),(1713,25689600,1),(1713,41418000,0),(1713,57744000,1),(1713,73472400,0),(1713,89193601,1),(1713,104922002,0),(1713,120643202,1),(1713,126694803,0),(1713,152092803,1),(1713,162378004,0),(1713,183542404,1),(1713,199270805,0),(1713,215596805,1),(1713,230720406,0),(1713,247046406,1),(1713,262774807,0),(1713,278496007,1),(1713,294224408,0),(1713,309945608,1),(1713,325674009,0),(1713,341395209,1),(1713,357123609,0),(1713,372844810,1),(1713,388573210,0),(1713,404899211,1),(1713,420022811,0),(1713,436348812,1),(1713,452077212,0),(1713,467798412,1),(1713,483526812,0),(1713,499248013,1),(1713,514976413,0),(1713,530697613,1),(1713,544611613,0),(1713,562147213,1),(1713,576061214,0),(1713,594201614,1),(1713,607510814,0),(1713,625651214,1),(1713,638960415,0),(1713,657100815,1),(1713,671014816,0),(1713,688550416,1),(1713,702464416,0),(1713,720000017,1),(1713,733914017,0),(1713,752054418,1),(1713,765363618,0),(1713,783504019,1),(1713,796813219,0),(1713,814953619,1),(1713,828867620,0),(1713,846403220,1),(1713,860317220,0),(1713,877852821,1),(1713,891766821,0),(1713,909302421,1),(1713,923216422,0),(1713,941356822,1),(1713,954666022,0),(1713,972806422,1),(1713,986115622,0),(1713,1004256022,1),(1713,1018170022,0),(1713,1035705622,1),(1713,1049619622,0),(1713,1067155222,1),(1713,1081069222,0),(1713,1099209622,1),(1713,1112518822,0),(1713,1130659222,1),(1713,1143968423,0),(1713,1162108823,1),(1713,1173603623,0),(1713,1194163223,1),(1713,1205053223,0),(1713,1225612823,1),(1713,1236502824,0),(1713,1257062424,1),(1713,1268557224,0),(1713,1289116824,1),(1713,1300006824,0),(1713,1320566424,1),(1713,1331456424,0),(1713,1352016025,1),(1713,1362906025,0),(1713,1383465625,1),(1713,1394355625,0),(1713,1414915225,1),(1713,1425805225,0),(1713,1446364826,1),(1713,1457859626,0),(1713,1478419226,1),(1713,1489309227,0),(1713,1509868827,1),(1713,1520758827,0),(1713,1541318427,1),(1713,1552208427,0),(1713,1572768027,1),(1713,1583658027,0),(1713,1604217627,1),(1713,1615712427,0),(1713,1636272027,1),(1713,1647162027,0),(1713,1667721627,1),(1713,1678611627,0),(1713,1699171227,1),(1713,1710061227,0),(1713,1730620827,1),(1713,1741510827,0),(1713,1762070427,1),(1713,1772960427,0),(1713,1793520027,1),(1713,1805014827,0),(1713,1825574427,1),(1713,1836464427,0),(1713,1857024027,1),(1713,1867914027,0),(1713,1888473627,1),(1713,1899363627,0),(1713,1919923227,1),(1713,1930813227,0),(1713,1951372827,1),(1713,1962867627,0),(1713,1983427227,1),(1713,1994317227,0),(1713,2014876827,1),(1713,2025766827,0),(1713,2046326427,1),(1713,2057216427,0),(1713,2077776027,1),(1713,2088666027,0),(1713,2109225627,1),(1713,2120115627,0),(1713,2140675227,1),(1714,-2147483648,0),(1714,-1514739600,1),(1714,-1451667600,2),(1714,-1343062800,3),(1714,-1234803600,2),(1714,-1222963200,4),(1714,-1207242000,2),(1714,-873820800,5),(1714,-769395600,6),(1714,-761677200,2),(1714,-686073600,4),(1714,-661539600,2),(1714,-495039600,4),(1714,-481734000,2),(1714,-463590000,4),(1714,-450284400,2),(1714,-431535600,4),(1714,-418230000,2),(1714,-400086000,4),(1714,-386780400,2),(1714,-368636400,4),(1714,-355330800,2),(1714,-337186800,4),(1714,-323881200,2),(1714,-305737200,4),(1714,-292431600,2),(1714,199274405,4),(1714,215600405,2),(1714,230724006,4),(1714,247050006,2),(1714,262778407,4),(1714,278499607,2),(1714,294228008,4),(1714,309949208,2),(1714,325677609,4),(1714,341398809,2),(1714,357127209,4),(1714,372848410,2),(1714,388576810,4),(1714,404902811,2),(1714,420026411,4),(1714,436352412,2),(1714,452080812,4),(1714,467802012,2),(1714,483530412,4),(1714,499251613,2),(1714,514980013,4),(1714,530701213,2),(1714,544615213,4),(1714,562150813,2),(1714,576064814,4),(1714,594205214,2),(1714,607514414,4),(1714,625654814,2),(1714,638964015,4),(1714,657104415,2),(1714,671018416,4),(1714,688554016,2),(1714,702468016,4),(1714,720003617,2),(1714,733917617,4),(1714,752058018,2),(1714,765367218,4),(1714,783507619,2),(1714,796816819,4),(1714,814957219,2),(1714,828871220,4),(1714,846406820,2),(1714,860320820,4),(1714,877856421,2),(1714,891770421,4),(1714,909306021,2),(1714,923220022,4),(1714,941360422,2),(1714,954669622,4),(1714,972810022,2),(1714,986119222,4),(1714,1004259622,2),(1714,1018173622,4),(1714,1035709222,2),(1714,1049623222,4),(1714,1067158822,2),(1714,1081072822,4),(1714,1099213222,2),(1714,1112522422,4),(1714,1130662822,2),(1714,1143972023,4),(1714,1162112423,2),(1714,1175421623,4),(1714,1193562023,2),(1714,1207476023,4),(1714,1225011623,2),(1714,1238925624,4),(1714,1256461224,2),(1714,1268560824,4),(1714,1289120424,2),(1714,1300010424,4),(1714,1320570024,2),(1714,1331460024,4),(1714,1352019625,2),(1714,1362909625,4),(1714,1383469225,2),(1714,1394359225,4),(1714,1414918825,2),(1714,1425808825,4),(1714,1446368426,2),(1714,1457863226,4),(1714,1478422826,2),(1714,1489312827,4),(1714,1509872427,2),(1714,1520762427,4),(1714,1541322027,2),(1714,1552212027,4),(1714,1572771627,2),(1714,1583661627,4),(1714,1604221227,2),(1714,1615716027,4),(1714,1636275627,2),(1714,1647165627,4),(1714,1667725227,2),(1714,1678615227,4),(1714,1699174827,2),(1714,1710064827,4),(1714,1730624427,2),(1714,1741514427,4),(1714,1762074027,2),(1714,1772964027,4),(1714,1793523627,2),(1714,1805018427,4),(1714,1825578027,2),(1714,1836468027,4),(1714,1857027627,2),(1714,1867917627,4),(1714,1888477227,2),(1714,1899367227,4),(1714,1919926827,2),(1714,1930816827,4),(1714,1951376427,2),(1714,1962871227,4),(1714,1983430827,2),(1714,1994320827,4),(1714,2014880427,2),(1714,2025770427,4),(1714,2046330027,2),(1714,2057220027,4),(1714,2077779627,2),(1714,2088669627,4),(1714,2109229227,2),(1714,2120119227,4),(1714,2140678827,2),(1715,-2147483648,0),(1715,-1514739600,1),(1715,-1343066400,2),(1715,-1234807200,4),(1715,-1220292000,3),(1715,-1207159200,4),(1715,-1191344400,2),(1715,-873828000,4),(1715,-661539600,5),(1715,28800,4),(1715,828867620,3),(1715,846403220,4),(1715,860317220,3),(1715,877852821,4),(1715,891766821,3),(1715,909302421,4),(1715,923216422,3),(1715,941356822,4),(1715,954666022,3),(1715,972806422,4),(1715,989139622,3),(1715,1001836822,4),(1715,1018170022,3),(1715,1035705622,4),(1715,1049619622,3),(1715,1067155222,4),(1715,1081069222,3),(1715,1099209622,4),(1715,1112518822,3),(1715,1130659222,4),(1715,1143968423,3),(1715,1162108823,4),(1715,1175418023,3),(1715,1193558423,4),(1715,1207472423,3),(1715,1225008023,4),(1715,1238922024,3),(1715,1256457624,4),(1715,1270371624,3),(1715,1288512024,4),(1715,1301821224,3),(1715,1319961624,4),(1715,1333270824,3),(1715,1351411225,4),(1715,1365325225,3),(1715,1382860825,4),(1715,1396774825,3),(1715,1414310425,4),(1715,1428224425,3),(1715,1445760026,4),(1715,1459674026,3),(1715,1477814426,4),(1715,1491123627,3),(1715,1509264027,4),(1715,1522573227,3),(1715,1540713627,4),(1715,1554627627,3),(1715,1572163227,4),(1715,1586077227,3),(1715,1603612827,4),(1715,1617526827,3),(1715,1635667227,4),(1715,1648976427,3),(1715,1667116827,4),(1716,-2147483648,0),(1716,-1514739600,1),(1716,-1343066400,2),(1716,-1234807200,4),(1716,-1220292000,3),(1716,-1207159200,4),(1716,-1191344400,2),(1716,-975261600,5),(1716,-963169200,2),(1716,-917114400,5),(1716,-907354800,2),(1716,-821901600,6),(1716,-810068400,2),(1716,-627501600,5),(1716,-612990000,2),(1716,828864020,5),(1716,846399620,2),(1716,860313620,5),(1716,877849221,2),(1716,891763221,5),(1716,909298821,2),(1716,923212822,5),(1716,941353222,2),(1716,954662422,5),(1716,972802822,2),(1716,989136022,5),(1716,1001833222,2),(1716,1018166422,5),(1716,1035702022,2),(1716,1049616022,5),(1716,1067151622,2),(1716,1081065622,5),(1716,1099206022,2),(1716,1112515222,5),(1716,1130655622,2),(1716,1143964823,5),(1716,1162105223,2),(1716,1175414423,5),(1716,1193554823,2),(1716,1207468823,5),(1716,1225004423,2),(1716,1238918424,5),(1716,1256454024,2),(1716,1270368024,5),(1716,1288508424,2),(1716,1301817624,5),(1716,1319958024,2),(1716,1333267224,5),(1716,1351407625,2),(1716,1365321625,5),(1716,1382857225,2),(1716,1396771225,5),(1716,1414306825,2),(1716,1428220825,5),(1716,1445756426,2),(1716,1459670426,5),(1716,1477810826,2),(1716,1491120027,5),(1716,1509260427,2),(1716,1522569627,5),(1716,1540710027,2),(1716,1554624027,5),(1716,1572159627,2),(1716,1586073627,5),(1716,1603609227,2),(1716,1617523227,5),(1716,1635663627,2),(1716,1648972827,5),(1716,1667113227,2),(1717,-2147483648,2),(1717,-1330335000,1),(1717,-1320057000,2),(1717,-1300699800,3),(1717,-1287396000,2),(1717,-1269250200,3),(1717,-1255946400,2),(1717,-1237800600,3),(1717,-1224496800,2),(1717,-1206351000,3),(1717,-1192442400,2),(1717,-1174901400,3),(1717,-1160992800,2),(1717,-1143451800,3),(1717,-1125914400,2),(1717,-1112607000,3),(1717,-1094464800,2),(1717,-1081157400,3),(1717,-1063015200,2),(1717,-1049707800,3),(1717,-1031565600,2),(1717,-1018258200,3),(1717,-1000116000,2),(1717,-986808600,3),(1717,-968061600,2),(1717,-955359000,3),(1717,-936612000,2),(1717,-923304600,3),(1717,-757425600,6),(1717,152632803,4),(1717,162309604,5),(1717,183477604,4),(1717,194968805,5),(1717,215532005,4),(1717,226418406,5),(1717,246981606,4),(1717,257868007,5),(1717,278431207,4),(1717,289317608,5),(1717,309880808,4),(1717,320767209,5),(1717,341330409,4),(1717,352216809,5),(1717,372780010,4),(1717,384271210,5),(1717,404834411,4),(1717,415720811,5),(1717,436284012,4),(1717,447170412,5),(1717,467733612,4),(1717,478620012,5),(1717,499183213,4),(1717,510069613,5),(1717,530632813,4),(1717,541519213,5),(1717,562082413,4),(1717,573573614,5),(1717,594136814,4),(1717,605023214,5),(1717,623772014,4),(1717,637682415,5),(1717,655221615,4),(1717,669132016,5),(1717,686671216,4),(1717,700581616,5),(1717,718120817,4),(1717,732636017,5),(1717,749570418,4),(1717,764085618,5),(1717,781020019,4),(1717,795535219,5),(1717,812469619,4),(1717,826984820,5),(1717,844524020,4),(1717,858434420,5),(1717,875973621,4),(1717,889884021,5),(1717,907423221,4),(1717,921938422,5),(1717,938872822,4),(1717,953388022,5),(1717,970322422,4),(1717,984837622,5),(1717,1002376822,4),(1717,1016287222,5),(1717,1033826422,4),(1717,1047736822,5),(1717,1065276022,4),(1717,1079791222,5),(1717,1096725622,4),(1717,1111240822,5),(1717,1128175222,4),(1717,1142690423,5),(1717,1159624823,4),(1717,1174140023,5),(1717,1191074423,4),(1717,1207404023,5),(1717,1222524023,4),(1717,1238853624,5),(1717,1253973624,4),(1717,1270303224,5),(1717,1285423224,4),(1717,1301752824,5),(1717,1316872824,4),(1717,1333202424,5),(1717,1348927225,4),(1717,1365256825,5),(1717,1380376825,4),(1717,1396706425,5),(1717,1411826425,4),(1717,1428156025,5),(1717,1443276026,4),(1717,1459605626,5),(1717,1474725626,4),(1717,1491055227,5),(1717,1506175227,4),(1717,1522504827,5),(1717,1538229627,4),(1717,1554559227,5),(1717,1569679227,4),(1717,1586008827,5),(1717,1601128827,4),(1717,1617458427,5),(1717,1632578427,4),(1717,1648908027,5),(1717,1664028027,4),(1717,1680357627,5),(1717,1695477627,4),(1717,1712412027,5),(1717,1727532027,4),(1717,1743861627,5),(1717,1758981627,4),(1717,1775311227,5),(1717,1790431227,4),(1717,1806760827,5),(1717,1821880827,4),(1717,1838210427,5),(1717,1853330427,4),(1717,1869660027,5),(1717,1885384827,4),(1717,1901714427,5),(1717,1916834427,4),(1717,1933164027,5),(1717,1948284027,4),(1717,1964613627,5),(1717,1979733627,4),(1717,1996063227,5),(1717,2011183227,4),(1717,2027512827,5),(1717,2042632827,4),(1717,2058962427,5),(1717,2074687227,4),(1717,2091016827,5),(1717,2106136827,4),(1717,2122466427,5),(1717,2137586427,4),(1718,-2147483648,1),(1718,-757426500,4),(1718,152632803,2),(1718,162309604,3),(1718,183477604,2),(1718,194968805,3),(1718,215532005,2),(1718,226418406,3),(1718,246981606,2),(1718,257868007,3),(1718,278431207,2),(1718,289317608,3),(1718,309880808,2),(1718,320767209,3),(1718,341330409,2),(1718,352216809,3),(1718,372780010,2),(1718,384271210,3),(1718,404834411,2),(1718,415720811,3),(1718,436284012,2),(1718,447170412,3),(1718,467733612,2),(1718,478620012,3),(1718,499183213,2),(1718,510069613,3),(1718,530632813,2),(1718,541519213,3),(1718,562082413,2),(1718,573573614,3),(1718,594136814,2),(1718,605023214,3),(1718,623772014,2),(1718,637682415,3),(1718,655221615,2),(1718,669132016,3),(1718,686671216,2),(1718,700581616,3),(1718,718120817,2),(1718,732636017,3),(1718,749570418,2),(1718,764085618,3),(1718,781020019,2),(1718,795535219,3),(1718,812469619,2),(1718,826984820,3),(1718,844524020,2),(1718,858434420,3),(1718,875973621,2),(1718,889884021,3),(1718,907423221,2),(1718,921938422,3),(1718,938872822,2),(1718,953388022,3),(1718,970322422,2),(1718,984837622,3),(1718,1002376822,2),(1718,1016287222,3),(1718,1033826422,2),(1718,1047736822,3),(1718,1065276022,2),(1718,1079791222,3),(1718,1096725622,2),(1718,1111240822,3),(1718,1128175222,2),(1718,1142690423,3),(1718,1159624823,2),(1718,1174140023,3),(1718,1191074423,2),(1718,1207404023,3),(1718,1222524023,2),(1718,1238853624,3),(1718,1253973624,2),(1718,1270303224,3),(1718,1285423224,2),(1718,1301752824,3),(1718,1316872824,2),(1718,1333202424,3),(1718,1348927225,2),(1718,1365256825,3),(1718,1380376825,2),(1718,1396706425,3),(1718,1411826425,2),(1718,1428156025,3),(1718,1443276026,2),(1718,1459605626,3),(1718,1474725626,2),(1718,1491055227,3),(1718,1506175227,2),(1718,1522504827,3),(1718,1538229627,2),(1718,1554559227,3),(1718,1569679227,2),(1718,1586008827,3),(1718,1601128827,2),(1718,1617458427,3),(1718,1632578427,2),(1718,1648908027,3),(1718,1664028027,2),(1718,1680357627,3),(1718,1695477627,2),(1718,1712412027,3),(1718,1727532027,2),(1718,1743861627,3),(1718,1758981627,2),(1718,1775311227,3),(1718,1790431227,2),(1718,1806760827,3),(1718,1821880827,2),(1718,1838210427,3),(1718,1853330427,2),(1718,1869660027,3),(1718,1885384827,2),(1718,1901714427,3),(1718,1916834427,2),(1718,1933164027,3),(1718,1948284027,2),(1718,1964613627,3),(1718,1979733627,2),(1718,1996063227,3),(1718,2011183227,2),(1718,2027512827,3),(1718,2042632827,2),(1718,2058962427,3),(1718,2074687227,2),(1718,2091016827,3),(1718,2106136827,2),(1718,2122466427,3),(1718,2137586427,2),(1719,-2147483648,3),(1719,-1633273200,1),(1719,-1615132800,2),(1719,-1601823600,1),(1719,-1583683200,2),(1719,-1570374000,1),(1719,-1551628800,2),(1719,-1538924400,1),(1719,-1534089600,2),(1719,-880210800,4),(1719,-769395600,5),(1719,-765388800,2),(1719,-147884400,1),(1719,-131558400,2),(1719,-116434800,1),(1719,-100108800,2),(1719,-84380400,1),(1719,-68659200,2),(1719,-52930800,1),(1719,-37209600,2),(1719,-21481200,1),(1719,-5760000,2),(1719,9968400,1),(1719,25689600,2),(1719,41418000,1),(1719,57744000,2),(1719,73472400,1),(1719,89193601,2),(1719,104922002,1),(1719,120643202,2),(1719,126694803,1),(1719,152092803,2),(1719,162378004,1),(1719,183542404,2),(1719,199270805,1),(1719,215596805,2),(1719,230720406,1),(1719,247046406,2),(1719,262774807,1),(1719,278496007,2),(1719,294224408,1),(1719,309945608,2),(1719,325674009,1),(1719,341395209,2),(1719,357123609,1),(1719,372844810,2),(1719,388573210,1),(1719,404899211,2),(1719,420022811,1),(1719,436348812,2),(1719,452077212,1),(1719,467798412,2),(1719,483526812,1),(1719,499248013,2),(1719,514976413,1),(1719,530697613,2),(1719,544611613,1),(1719,562147213,2),(1719,576061214,1),(1719,594201614,2),(1719,607510814,1),(1719,625651214,2),(1719,638960415,1),(1719,657100815,2),(1719,671014816,1),(1719,688550416,2),(1719,702464416,1),(1719,720000017,2),(1719,733914017,1),(1719,752054418,2),(1719,765363618,1),(1719,783504019,2),(1719,796813219,1),(1719,814953619,2),(1719,828867620,1),(1719,846403220,2),(1719,860317220,1),(1719,877852821,2),(1719,891766821,1),(1719,909302421,2),(1719,923216422,1),(1719,941356822,2),(1719,954666022,1),(1719,972806422,2),(1719,986115622,1),(1719,1004256022,2),(1719,1018170022,1),(1719,1035705622,2),(1719,1049619622,1),(1719,1067155222,2),(1719,1081069222,1),(1719,1099209622,2),(1719,1112518822,1),(1719,1130659222,2),(1719,1143968423,1),(1719,1162108823,2),(1719,1173603623,1),(1719,1194163223,2),(1719,1205053223,1),(1719,1225612823,2),(1719,1236502824,1),(1719,1257062424,2),(1719,1268557224,1),(1719,1289116824,2),(1719,1300006824,1),(1719,1320566424,2),(1719,1331456424,1),(1719,1352016025,2),(1719,1362906025,1),(1719,1383465625,2),(1719,1394355625,1),(1719,1414915225,2),(1719,1425805225,1),(1719,1446364826,2),(1719,1457859626,1),(1719,1478419226,2),(1719,1489309227,1),(1719,1509868827,2),(1719,1520758827,1),(1719,1541318427,2),(1719,1552208427,1),(1719,1572768027,2),(1719,1583658027,1),(1719,1604217627,2),(1719,1615712427,1),(1719,1636272027,2),(1719,1647162027,1),(1719,1667721627,2),(1719,1678611627,1),(1719,1699171227,2),(1719,1710061227,1),(1719,1730620827,2),(1719,1741510827,1),(1719,1762070427,2),(1719,1772960427,1),(1719,1793520027,2),(1719,1805014827,1),(1719,1825574427,2),(1719,1836464427,1),(1719,1857024027,2),(1719,1867914027,1),(1719,1888473627,2),(1719,1899363627,1),(1719,1919923227,2),(1719,1930813227,1),(1719,1951372827,2),(1719,1962867627,1),(1719,1983427227,2),(1719,1994317227,1),(1719,2014876827,2),(1719,2025766827,1),(1719,2046326427,2),(1719,2057216427,1),(1719,2077776027,2),(1719,2088666027,1),(1719,2109225627,2),(1719,2120115627,1),(1719,2140675227,2),(1720,-2147483648,2),(1720,-1600675200,1),(1720,-1585904400,2),(1720,-933667200,1),(1720,-922093200,2),(1720,-908870400,1),(1720,-888829200,2),(1720,-881049600,1),(1720,-767869200,2),(1720,-745833600,1),(1720,-733827600,2),(1720,-716889600,1),(1720,-699613200,2),(1720,-683884800,1),(1720,-670669200,2),(1720,-652348800,1),(1720,-650019600,2),(1720,515527213,1),(1720,527014813,2),(1720,545162413,1),(1720,558464413,2),(1720,577216814,1),(1720,589914014,2),(1720,608666414,1),(1720,621968414,2),(1720,640116015,1),(1720,653418015,2),(1720,671565616,1),(1720,684867616,2),(1721,-1633269600,0),(1721,-1615129200,1),(1721,-1601820000,0),(1721,-1583679600,1),(1721,-880207200,2),(1721,-769395600,3),(1721,-765385200,1),(1721,-84376800,0),(1721,-68655600,1),(1721,-52927200,0),(1721,-37206000,1),(1721,-21477600,0),(1721,-5756400,1),(1721,9972000,0),(1721,25693200,1),(1721,41421600,0),(1721,57747600,1),(1721,73476000,0),(1721,89197201,1),(1721,104925602,0),(1721,120646802,1),(1721,126698403,0),(1721,152096403,1),(1721,162381604,0),(1721,183546004,1),(1721,199274405,0),(1721,215600405,1),(1721,230724006,0),(1721,247050006,1),(1721,262778407,0),(1721,278499607,1),(1721,294228008,0),(1721,309949208,1),(1721,325677609,0),(1721,341398809,1),(1721,357127209,0),(1721,372848410,1),(1721,388576810,0),(1721,404902811,1),(1721,420026411,0),(1721,436352412,1),(1721,452080812,0),(1721,467802012,1),(1721,483530412,0),(1721,499251613,1),(1721,514980013,0),(1721,530701213,1),(1721,544615213,0),(1721,562150813,1),(1721,576064814,0),(1721,594205214,1),(1721,607514414,0),(1721,625654814,1),(1721,638964015,0),(1721,657104415,1),(1721,671018416,0),(1721,688554016,1),(1721,702468016,0),(1721,720003617,1),(1721,733917617,0),(1721,752058018,1),(1721,765367218,0),(1721,783507619,1),(1721,796816819,0),(1721,814957219,1),(1721,828871220,0),(1721,846406820,1),(1721,860320820,0),(1721,877856421,1),(1721,891770421,0),(1721,909306021,1),(1721,923220022,0),(1721,941360422,1),(1721,954669622,0),(1721,972810022,1),(1721,986119222,0),(1721,1004259622,1),(1721,1018173622,0),(1721,1035709222,1),(1721,1049623222,0),(1721,1067158822,1),(1721,1081072822,0),(1721,1099213222,1),(1721,1112522422,0),(1721,1130662822,1),(1721,1143972023,0),(1721,1162112423,1),(1721,1173607223,0),(1721,1194166823,1),(1721,1205056823,0),(1721,1225616423,1),(1721,1236506424,0),(1721,1257066024,1),(1721,1268560824,0),(1721,1289120424,1),(1721,1300010424,0),(1721,1320570024,1),(1721,1331460024,0),(1721,1352019625,1),(1721,1362909625,0),(1721,1383469225,1),(1721,1394359225,0),(1721,1414918825,1),(1721,1425808825,0),(1721,1446368426,1),(1721,1457863226,0),(1721,1478422826,1),(1721,1489312827,0),(1721,1509872427,1),(1721,1520762427,0),(1721,1541322027,1),(1721,1552212027,0),(1721,1572771627,1),(1721,1583661627,0),(1721,1604221227,1),(1721,1615716027,0),(1721,1636275627,1),(1721,1647165627,0),(1721,1667725227,1),(1721,1678615227,0),(1721,1699174827,1),(1721,1710064827,0),(1721,1730624427,1),(1721,1741514427,0),(1721,1762074027,1),(1721,1772964027,0),(1721,1793523627,1),(1721,1805018427,0),(1721,1825578027,1),(1721,1836468027,0),(1721,1857027627,1),(1721,1867917627,0),(1721,1888477227,1),(1721,1899367227,0),(1721,1919926827,1),(1721,1930816827,0),(1721,1951376427,1),(1721,1962871227,0),(1721,1983430827,1),(1721,1994320827,0),(1721,2014880427,1),(1721,2025770427,0),(1721,2046330027,1),(1721,2057220027,0),(1721,2077779627,1),(1721,2088669627,0),(1721,2109229227,1),(1721,2120119227,0),(1721,2140678827,1),(1722,-2147483648,1),(1722,-1861878784,2),(1722,-631110600,4),(1722,1285498824,3),(1722,1301752824,4),(1722,1316872824,3),(1722,1325239224,6),(1722,1333202424,5),(1722,1348927225,6),(1722,1365256825,5),(1722,1380376825,6),(1722,1396706425,5),(1722,1411826425,6),(1722,1428156025,5),(1722,1443276026,6),(1722,1459605626,5),(1722,1474725626,6),(1722,1491055227,5),(1722,1506175227,6),(1722,1522504827,5),(1722,1538229627,6),(1722,1554559227,5),(1722,1569679227,6),(1722,1586008827,5),(1722,1601128827,6),(1722,1617458427,5),(1723,-2147483648,2),(1723,-1330335000,1),(1723,-1320057000,2),(1723,-1300699800,3),(1723,-1287396000,2),(1723,-1269250200,3),(1723,-1255946400,2),(1723,-1237800600,3),(1723,-1224496800,2),(1723,-1206351000,3),(1723,-1192442400,2),(1723,-1174901400,3),(1723,-1160992800,2),(1723,-1143451800,3),(1723,-1125914400,2),(1723,-1112607000,3),(1723,-1094464800,2),(1723,-1081157400,3),(1723,-1063015200,2),(1723,-1049707800,3),(1723,-1031565600,2),(1723,-1018258200,3),(1723,-1000116000,2),(1723,-986808600,3),(1723,-968061600,2),(1723,-955359000,3),(1723,-936612000,2),(1723,-923304600,3),(1723,-757425600,6),(1723,152632803,4),(1723,162309604,5),(1723,183477604,4),(1723,194968805,5),(1723,215532005,4),(1723,226418406,5),(1723,246981606,4),(1723,257868007,5),(1723,278431207,4),(1723,289317608,5),(1723,309880808,4),(1723,320767209,5),(1723,341330409,4),(1723,352216809,5),(1723,372780010,4),(1723,384271210,5),(1723,404834411,4),(1723,415720811,5),(1723,436284012,4),(1723,447170412,5),(1723,467733612,4),(1723,478620012,5),(1723,499183213,4),(1723,510069613,5),(1723,530632813,4),(1723,541519213,5),(1723,562082413,4),(1723,573573614,5),(1723,594136814,4),(1723,605023214,5),(1723,623772014,4),(1723,637682415,5),(1723,655221615,4),(1723,669132016,5),(1723,686671216,4),(1723,700581616,5),(1723,718120817,4),(1723,732636017,5),(1723,749570418,4),(1723,764085618,5),(1723,781020019,4),(1723,795535219,5),(1723,812469619,4),(1723,826984820,5),(1723,844524020,4),(1723,858434420,5),(1723,875973621,4),(1723,889884021,5),(1723,907423221,4),(1723,921938422,5),(1723,938872822,4),(1723,953388022,5),(1723,970322422,4),(1723,984837622,5),(1723,1002376822,4),(1723,1016287222,5),(1723,1033826422,4),(1723,1047736822,5),(1723,1065276022,4),(1723,1079791222,5),(1723,1096725622,4),(1723,1111240822,5),(1723,1128175222,4),(1723,1142690423,5),(1723,1159624823,4),(1723,1174140023,5),(1723,1191074423,4),(1723,1207404023,5),(1723,1222524023,4),(1723,1238853624,5),(1723,1253973624,4),(1723,1270303224,5),(1723,1285423224,4),(1723,1301752824,5),(1723,1316872824,4),(1723,1333202424,5),(1723,1348927225,4),(1723,1365256825,5),(1723,1380376825,4),(1723,1396706425,5),(1723,1411826425,4),(1723,1428156025,5),(1723,1443276026,4),(1723,1459605626,5),(1723,1474725626,4),(1723,1491055227,5),(1723,1506175227,4),(1723,1522504827,5),(1723,1538229627,4),(1723,1554559227,5),(1723,1569679227,4),(1723,1586008827,5),(1723,1601128827,4),(1723,1617458427,5),(1723,1632578427,4),(1723,1648908027,5),(1723,1664028027,4),(1723,1680357627,5),(1723,1695477627,4),(1723,1712412027,5),(1723,1727532027,4),(1723,1743861627,5),(1723,1758981627,4),(1723,1775311227,5),(1723,1790431227,4),(1723,1806760827,5),(1723,1821880827,4),(1723,1838210427,5),(1723,1853330427,4),(1723,1869660027,5),(1723,1885384827,4),(1723,1901714427,5),(1723,1916834427,4),(1723,1933164027,5),(1723,1948284027,4),(1723,1964613627,5),(1723,1979733627,4),(1723,1996063227,5),(1723,2011183227,4),(1723,2027512827,5),(1723,2042632827,4),(1723,2058962427,5),(1723,2074687227,4),(1723,2091016827,5),(1723,2106136827,4),(1723,2122466427,5),(1723,2137586427,4),(1724,-2147483648,1),(1724,-868010400,2),(1724,-768906000,1),(1724,1419696025,3),(1725,-2147483648,1),(1725,-757426500,4),(1725,152632803,2),(1725,162309604,3),(1725,183477604,2),(1725,194968805,3),(1725,215532005,2),(1725,226418406,3),(1725,246981606,2),(1725,257868007,3),(1725,278431207,2),(1725,289317608,3),(1725,309880808,2),(1725,320767209,3),(1725,341330409,2),(1725,352216809,3),(1725,372780010,2),(1725,384271210,3),(1725,404834411,2),(1725,415720811,3),(1725,436284012,2),(1725,447170412,3),(1725,467733612,2),(1725,478620012,3),(1725,499183213,2),(1725,510069613,3),(1725,530632813,2),(1725,541519213,3),(1725,562082413,2),(1725,573573614,3),(1725,594136814,2),(1725,605023214,3),(1725,623772014,2),(1725,637682415,3),(1725,655221615,2),(1725,669132016,3),(1725,686671216,2),(1725,700581616,3),(1725,718120817,2),(1725,732636017,3),(1725,749570418,2),(1725,764085618,3),(1725,781020019,2),(1725,795535219,3),(1725,812469619,2),(1725,826984820,3),(1725,844524020,2),(1725,858434420,3),(1725,875973621,2),(1725,889884021,3),(1725,907423221,2),(1725,921938422,3),(1725,938872822,2),(1725,953388022,3),(1725,970322422,2),(1725,984837622,3),(1725,1002376822,2),(1725,1016287222,3),(1725,1033826422,2),(1725,1047736822,3),(1725,1065276022,2),(1725,1079791222,3),(1725,1096725622,2),(1725,1111240822,3),(1725,1128175222,2),(1725,1142690423,3),(1725,1159624823,2),(1725,1174140023,3),(1725,1191074423,2),(1725,1207404023,3),(1725,1222524023,2),(1725,1238853624,3),(1725,1253973624,2),(1725,1270303224,3),(1725,1285423224,2),(1725,1301752824,3),(1725,1316872824,2),(1725,1333202424,3),(1725,1348927225,2),(1725,1365256825,3),(1725,1380376825,2),(1725,1396706425,3),(1725,1411826425,2),(1725,1428156025,3),(1725,1443276026,2),(1725,1459605626,3),(1725,1474725626,2),(1725,1491055227,3),(1725,1506175227,2),(1725,1522504827,3),(1725,1538229627,2),(1725,1554559227,3),(1725,1569679227,2),(1725,1586008827,3),(1725,1601128827,2),(1725,1617458427,3),(1725,1632578427,2),(1725,1648908027,3),(1725,1664028027,2),(1725,1680357627,3),(1725,1695477627,2),(1725,1712412027,3),(1725,1727532027,2),(1725,1743861627,3),(1725,1758981627,2),(1725,1775311227,3),(1725,1790431227,2),(1725,1806760827,3),(1725,1821880827,2),(1725,1838210427,3),(1725,1853330427,2),(1725,1869660027,3),(1725,1885384827,2),(1725,1901714427,3),(1725,1916834427,2),(1725,1933164027,3),(1725,1948284027,2),(1725,1964613627,3),(1725,1979733627,2),(1725,1996063227,3),(1725,2011183227,2),(1725,2027512827,3),(1725,2042632827,2),(1725,2058962427,3),(1725,2074687227,2),(1725,2091016827,3),(1725,2106136827,2),(1725,2122466427,3),(1725,2137586427,2),(1727,-2147483648,1),(1727,-1178124152,4),(1727,-36619200,2),(1727,-23922000,3),(1727,-3355200,2),(1727,7527600,3),(1727,24465600,2),(1727,37767600,3),(1727,55915200,2),(1727,69217200,3),(1727,87969601,2),(1727,100666802,3),(1727,118209602,2),(1727,132116403,3),(1727,150868803,2),(1727,163566004,3),(1727,182318404,2),(1727,195620405,3),(1727,213768005,2),(1727,227070006,3),(1727,245217606,2),(1727,258519607,3),(1727,277272007,2),(1727,289969208,3),(1727,308721608,2),(1727,321418809,3),(1727,340171209,2),(1727,353473209,3),(1727,371620810,2),(1727,384922810,5),(1727,403070411,6),(1727,416372411,5),(1727,434520012,6),(1727,447822012,5),(1727,466574412,6),(1727,479271612,5),(1727,498024013,6),(1727,510721213,5),(1727,529473613,6),(1727,545194813,5),(1727,560923213,6),(1727,574225214,5),(1727,592372814,6),(1727,605674814,5),(1727,624427214,6),(1727,637124415,5),(1727,653457615,6),(1727,668574016,5),(1727,687326416,6),(1727,700628416,5),(1727,718776017,6),(1727,732078017,5),(1727,750225618,6),(1727,763527618,5),(1727,781675219,6),(1727,794977219,5),(1727,813729619,6),(1727,826426820,5),(1727,845179220,6),(1727,859690820,5),(1727,876628821,6),(1727,889930821,5),(1727,906868821,6),(1727,923194822,5),(1727,939528022,6),(1727,952830022,5),(1727,971582422,6),(1727,984279622,5),(1727,1003032022,6),(1727,1015729222,5),(1727,1034481622,6),(1727,1047178822,5),(1727,1065931222,6),(1727,1079233222,5),(1727,1097380822,6),(1727,1110682822,5),(1727,1128830422,6),(1727,1142132423,5),(1727,1160884823,6),(1727,1173582023,5),(1727,1192334423,6),(1727,1206846023,5),(1727,1223784023,6),(1727,1237086024,5),(1727,1255233624,6),(1727,1270350024,5),(1727,1286683224,6),(1727,1304823624,5),(1727,1313899224,6),(1727,1335668424,5),(1727,1346558425,6),(1727,1367118025,5),(1727,1378612825,6),(1727,1398567625,5),(1727,1410062425,6),(1727,1463281226,5),(1727,1471147226,6),(1727,1494730827,5),(1727,1502596827,6),(1727,1526180427,5),(1727,1534046427,6),(1727,1554606027,5),(1727,1567915227,6),(1727,1586055627,5),(1727,1599364827,6),(1727,1617505227,5),(1727,1630814427,6),(1727,1648954827,5),(1727,1662868827,6),(1727,1680404427,5),(1727,1693713627,6),(1727,1712458827,5),(1727,1725768027,6),(1727,1743908427,5),(1727,1757217627,6),(1727,1775358027,5),(1727,1788667227,6),(1727,1806807627,5),(1727,1820116827,6),(1727,1838257227,5),(1727,1851566427,6),(1727,1870311627,5),(1727,1883016027,6),(1727,1901761227,5),(1727,1915070427,6),(1727,1933210827,5),(1727,1946520027,6),(1727,1964660427,5),(1727,1977969627,6),(1727,1996110027,5),(1727,2009419227,6),(1727,2027559627,5),(1727,2040868827,6),(1727,2059614027,5),(1727,2072318427,6),(1727,2091063627,5),(1727,2104372827,6),(1727,2122513227,5),(1727,2135822427,6),(1728,-2147483648,0),(1728,-1829387596,4),(1728,125409602,1),(1728,133876803,2),(1728,433256412,3),(1728,448977612,4),(1728,464706012,3),(1728,480427212,4),(1728,496760413,3),(1728,511876813,4),(1728,528210013,3),(1728,543931213,4),(1728,559659613,3),(1728,575380814,4),(1728,591109214,3),(1728,606830414,4),(1728,622558814,3),(1728,638280015,4),(1728,654008415,3),(1728,669729616,4),(1728,686062816,3),(1728,696340816,4),(1728,719931617,3),(1728,727790417,4),(1729,-2147483648,0),(1729,-1020470400,1),(1729,307627208,2),(1729,788871619,3),(1730,-2147483648,1),(1730,1325242824,2),(1731,-2147483648,0),(1731,-1709985344,2),(1731,909842421,1),(1731,920124022,2),(1731,941896822,1),(1731,951573622,2),(1731,1259416824,1),(1731,1269698424,2),(1731,1287842424,1),(1731,1299333624,2),(1731,1319292024,1),(1731,1327154424,2),(1731,1350741625,1),(1731,1358604025,2),(1731,1382796025,1),(1731,1390050025,2),(1731,1414850425,1),(1731,1421503225,2),(1731,1446300026,1),(1731,1452952826,2),(1731,1478354426,1),(1731,1484402427,2),(1731,1509804027,1),(1731,1515852027,2),(1731,1541253627,1),(1731,1547301627,2),(1731,1573308027,1),(1731,1578751227,2),(1731,1608386427,1),(1731,1610805627,2),(1733,-2147483648,0),(1733,-1230746496,1),(1733,504939613,3),(1733,722930417,2),(1733,728888417,3),(1734,-2147483648,0),(1734,-1806678012,1),(1735,-2147483648,0),(1735,-1806748788,1),(1736,-2147483648,1),(1736,-885549600,2),(1736,-802256400,1),(1736,-331891200,3),(1736,-281610000,1),(1736,-73728000,3),(1736,-29415540,1),(1736,-16704000,3),(1736,-10659600,1),(1736,9907200,3),(1736,21394800,1),(1736,41356800,3),(1736,52844400,1),(1736,124819202,3),(1736,130863603,1),(1736,201888005,3),(1736,209487665,1),(1736,230659206,3),(1736,241542006,1),(1736,977493622,4),(1737,-2147483648,1),(1737,-1157283000,2),(1737,-1155436200,1),(1737,-880198200,3),(1737,-769395600,4),(1737,-765376200,1),(1737,-712150200,5),(1738,-2147483648,1),(1738,-1157283000,2),(1738,-1155436200,1),(1738,-880198200,3),(1738,-769395600,4),(1738,-765376200,1),(1738,-712150200,5),(1739,-2147483648,0),(1739,-1020470400,1),(1739,307627208,2),(1739,788871619,3),(1740,-2147483648,1),(1740,307622408,2),(1740,788868019,3),(1741,-2147483648,1),(1741,-1743678000,2),(1741,-1606813200,1),(1741,-1041418800,3),(1741,-907408800,2),(1741,-770634000,1),(1741,-7988400,4),(1741,915105621,1),(1742,-2147483648,1),(1742,-1041418800,2),(1742,-907408800,3),(1742,-817462800,1),(1742,-7988400,4),(1742,745934418,5),(1744,-2147483648,0),(1744,-1806676920,1),(1745,-2147483648,1),(1745,-1861879032,2),(1746,-2147483648,0),(1746,-1545131260,1),(1746,-862918200,2),(1746,-767350800,1),(1746,287418608,3),(1747,-2147483648,0),(1747,-543069620,1),(1747,-173623200,2),(1748,-2147483648,1),(1748,-599656320,2),(1748,152029803,3),(1748,162916204,4),(1748,1443882626,5),(1748,1561899627,7),(1748,1570287627,6),(1748,1586012427,5),(1748,1601737227,6),(1748,1617462027,5),(1748,1633186827,6),(1748,1648911627,5),(1748,1664636427,6),(1748,1680361227,5),(1748,1696086027,6),(1748,1712415627,5),(1748,1728140427,6),(1748,1743865227,5),(1748,1759590027,6),(1748,1775314827,5),(1748,1791039627,6),(1748,1806764427,5),(1748,1822489227,6),(1748,1838214027,5),(1748,1853938827,6),(1748,1869663627,5),(1748,1885993227,6),(1748,1901718027,5),(1748,1917442827,6),(1748,1933167627,5),(1748,1948892427,6),(1748,1964617227,5),(1748,1980342027,6),(1748,1996066827,5),(1748,2011791627,6),(1748,2027516427,5),(1748,2043241227,6),(1748,2058966027,5),(1748,2075295627,6),(1748,2091020427,5),(1748,2106745227,6),(1748,2122470027,5),(1748,2138194827,6),(1749,-2147483648,0),(1749,-1829387148,2),(1749,250002006,1),(1749,257342407,2),(1749,281451607,1),(1749,288878408,2),(1749,849366020,3),(1749,857228420,4),(1750,-2147483648,1),(1750,-1861879032,2),(1752,-2147483648,1),(1752,893665821,2),(1753,-2147483648,0),(1753,-1806748788,1),(1754,-2147483648,0),(1754,-1806748788,1),(1756,-2147483648,1),(1756,-543072056,2),(1756,279714607,4),(1756,289387808,3),(1756,309952808,4),(1756,320837409,3),(1756,341402409,4),(1756,352287009,3),(1756,372852010,4),(1756,384341410,3),(1756,404906411,4),(1756,415791011,3),(1756,436356012,4),(1756,447240612,3),(1756,467805612,4),(1756,478690212,3),(1756,499255213,4),(1756,510139813,3),(1756,530704813,4),(1756,541589413,3),(1756,562154413,4),(1756,573643814,3),(1756,594208814,4),(1756,605093414,3),(1756,625658414,4),(1756,636543015,3),(1756,657108015,4),(1756,667992616,3),(1757,-2147483648,1),(1757,-885549600,2),(1757,-802256400,1),(1757,-331891200,3),(1757,-281610000,1),(1757,-73728000,3),(1757,-29415540,1),(1757,-16704000,3),(1757,-10659600,1),(1757,9907200,3),(1757,21394800,1),(1757,41356800,3),(1757,52844400,1),(1757,124819202,3),(1757,130863603,1),(1757,201888005,3),(1757,209487665,1),(1757,230659206,3),(1757,241542006,1),(1757,977493622,4),(1758,-2147483648,1),(1758,-1861879032,2),(1759,-2147483648,0),(1759,-1806674504,1),(1761,-2147483648,0),(1761,-767189952,1),(1761,-284041200,2),(1761,939214822,3),(1761,953384422,4),(1761,973342822,5),(1761,980596822,2),(1761,1004792422,5),(1761,1012046422,2),(1761,1478350826,5),(1761,1484398827,2),(1766,-2147483648,1),(1766,-1717032240,3),(1766,-1693706400,2),(1766,-1680483600,3),(1766,-1663455600,4),(1766,-1650150000,5),(1766,-1632006000,4),(1766,-1618700400,8),(1766,-1600473600,6),(1766,-1587168000,7),(1766,-1501725600,3),(1766,-931734000,2),(1766,-857257200,5),(1766,-844556400,4),(1766,-828226800,5),(1766,-812502000,4),(1766,-796874400,2),(1766,-796608000,3),(1766,-778726800,2),(1766,-762660000,3),(1766,-748486800,4),(1766,-733273200,5),(1766,-715215600,4),(1766,-701910000,5),(1766,-684975600,4),(1766,-670460400,5),(1766,-654130800,4),(1766,-639010800,5),(1766,-397094400,4),(1766,-386812800,5),(1766,-371088000,4),(1766,-355363200,5),(1766,-334195200,4),(1766,-323308800,5),(1766,-307584000,4),(1766,-291859200,5),(1766,-271296000,4),(1766,-260409600,5),(1766,-239846400,4),(1766,-228960000,5),(1766,-208396800,4),(1766,-197510400,5),(1766,-176342400,4),(1766,-166060800,5),(1766,220921205,3),(1766,228873606,4),(1766,243993606,5),(1766,260323207,4),(1766,276048007,5),(1766,291772808,4),(1766,307497608,5),(1766,323827209,4),(1766,338947209,5),(1766,354672009,4),(1766,370396810,5),(1766,386121610,4),(1766,401846411,5),(1766,417571211,4),(1766,433296012,5),(1766,449020812,4),(1766,465350412,5),(1766,481075212,4),(1766,496800013,5),(1766,512524813,4),(1766,528249613,5),(1766,543974413,4),(1766,559699213,5),(1766,567990013,3),(1766,575427614,9),(1766,591152414,10),(1766,606877214,9),(1766,622602014,10),(1766,638326815,9),(1766,654656415,10),(1766,670381216,9),(1766,686106016,10),(1766,701830816,9),(1766,717555617,10),(1766,733280417,9),(1766,749005218,10),(1766,764730018,9),(1766,780454819,10),(1766,796179619,9),(1766,811904419,10),(1766,828234020,9),(1766,846378020,10),(1766,859683620,9),(1766,877827621,10),(1766,891133221,9),(1766,909277221,10),(1766,922582822,9),(1766,941331622,10),(1766,954032422,9),(1766,972781222,10),(1766,985482022,9),(1766,1004230822,10),(1766,1017536422,9),(1766,1035680422,10),(1766,1048986022,9),(1766,1067130022,10),(1766,1080435622,9),(1766,1099184422,10),(1766,1111885222,9),(1766,1130634022,10),(1766,1143334823,9),(1766,1162083623,10),(1766,1174784423,9),(1766,1193533223,10),(1766,1206838823,9),(1766,1224982823,10),(1766,1238288424,9),(1766,1256432424,10),(1766,1269738024,9),(1766,1288486824,10),(1766,1301187624,9),(1766,1319936424,10),(1766,1332637224,9),(1766,1351386025,10),(1766,1364691625,9),(1766,1382835625,10),(1766,1396141225,9),(1766,1414285225,10),(1766,1427590825,9),(1766,1445734826,10),(1766,1459040426,9),(1766,1477789226,10),(1766,1490490027,9),(1766,1509238827,10),(1766,1521939627,9),(1766,1540688427,10),(1766,1553994027,9),(1766,1572138027,10),(1766,1585443627,9),(1766,1603587627,10),(1766,1616893227,9),(1766,1635642027,10),(1766,1648342827,9),(1766,1667091627,10),(1766,1679792427,9),(1766,1698541227,10),(1766,1711846827,9),(1766,1729990827,10),(1766,1743296427,9),(1766,1761440427,10),(1766,1774746027,9),(1766,1792890027,10),(1766,1806195627,9),(1766,1824944427,10),(1766,1837645227,9),(1766,1856394027,10),(1766,1869094827,9),(1766,1887843627,10),(1766,1901149227,9),(1766,1919293227,10),(1766,1932598827,9),(1766,1950742827,10),(1766,1964048427,9),(1766,1982797227,10),(1766,1995498027,9),(1766,2014246827,10),(1766,2026947627,9),(1766,2045696427,10),(1766,2058397227,9),(1766,2077146027,10),(1766,2090451627,9),(1766,2108595627,10),(1766,2121901227,9),(1766,2140045227,10),(1767,-2147483648,0),(1767,-1830384000,6),(1767,-1689555600,1),(1767,-1677801600,2),(1767,-1667437200,3),(1767,-1647738000,4),(1767,-1635814800,3),(1767,-1616202000,4),(1767,-1604365200,3),(1767,-1584666000,4),(1767,-1572742800,3),(1767,-1553043600,4),(1767,-1541206800,3),(1767,-1521507600,4),(1767,-1442451600,3),(1767,-1426813200,4),(1767,-1379293200,3),(1767,-1364778000,4),(1767,-1348448400,3),(1767,-1333328400,4),(1767,-1316394000,3),(1767,-1301274000,4),(1767,-1284339600,3),(1767,-1269824400,4),(1767,-1221440400,3),(1767,-1206925200,4),(1767,-1191200400,3),(1767,-1175475600,4),(1767,-1127696400,3),(1767,-1111971600,4),(1767,-1096851600,3),(1767,-1080522000,4),(1767,-1063587600,3),(1767,-1049072400,4),(1767,-1033347600,3),(1767,-1017622800,4),(1767,-1002502800,3),(1767,-986173200,4),(1767,-969238800,3),(1767,-950490000,4),(1767,-942022800,3),(1767,-922669200,4),(1767,-906944400,3),(1767,-891133200,4),(1767,-877309200,3),(1767,-873684000,5),(1767,-864007200,3),(1767,-857955600,4),(1767,-845859600,3),(1767,-842839200,5),(1767,-831348000,3),(1767,-825901200,4),(1767,-814410000,3),(1767,-810784800,5),(1767,-799898400,3),(1767,-794451600,4),(1767,-782960400,3),(1767,-779335200,5),(1767,-768448800,3),(1767,-763002000,4),(1767,-749091600,3),(1767,-733366800,4),(1767,-717631200,3),(1767,-701906400,4),(1767,-686181600,3),(1767,-670456800,4),(1767,-654732000,3),(1767,-639007200,4),(1767,-623282400,3),(1767,-607557600,4),(1767,-591832800,3),(1767,-575503200,4),(1767,-559778400,3),(1767,-544053600,4),(1767,-528328800,3),(1767,-512604000,4),(1767,-496879200,3),(1767,-481154400,4),(1767,-465429600,3),(1767,-449704800,4),(1767,-433980000,3),(1767,-417650400,4),(1767,-401925600,3),(1767,-386200800,4),(1767,-370476000,3),(1767,-354751200,4),(1767,-339026400,3),(1767,-323301600,4),(1767,-307576800,3),(1767,-291852000,4),(1767,-276127200,3),(1767,-260402400,4),(1767,-244677600,3),(1767,-228348000,4),(1767,-212623200,3),(1767,-196898400,4),(1767,-181173600,3),(1767,-165448800,4),(1767,-149724000,3),(1767,-133999200,4),(1767,-118274400,7),(1767,212544005,2),(1767,228268806,3),(1767,243993606,4),(1767,260323207,3),(1767,276048007,4),(1767,291772808,3),(1767,307501208,4),(1767,323222409,3),(1767,338950809,4),(1767,354675609,3),(1767,370400410,4),(1767,386125210,3),(1767,401850011,4),(1767,417578411,3),(1767,433299612,4),(1767,449024412,3),(1767,465354012,4),(1767,481078812,3),(1767,496803613,4),(1767,512528413,3),(1767,528253213,4),(1767,543978013,3),(1767,559702813,4),(1767,575427614,3),(1767,591152414,4),(1767,606877214,3),(1767,622602014,4),(1767,638326815,3),(1767,654656415,4),(1767,670381216,3),(1767,686106016,4),(1767,701830816,3),(1767,717555617,8),(1767,733280417,9),(1767,749005218,8),(1767,764730018,9),(1767,780454819,8),(1767,796179619,9),(1767,811904419,8),(1767,828234020,10),(1767,846378020,6),(1767,859683620,10),(1767,877827621,6),(1767,891133221,10),(1767,909277221,6),(1767,922582822,10),(1767,941331622,6),(1767,954032422,10),(1767,972781222,6),(1767,985482022,10),(1767,1004230822,6),(1767,1017536422,10),(1767,1035680422,6),(1767,1048986022,10),(1767,1067130022,6),(1767,1080435622,10),(1767,1099184422,6),(1767,1111885222,10),(1767,1130634022,6),(1767,1143334823,10),(1767,1162083623,6),(1767,1174784423,10),(1767,1193533223,6),(1767,1206838823,10),(1767,1224982823,6),(1767,1238288424,10),(1767,1256432424,6),(1767,1269738024,10),(1767,1288486824,6),(1767,1301187624,10),(1767,1319936424,6),(1767,1332637224,10),(1767,1351386025,6),(1767,1364691625,10),(1767,1382835625,6),(1767,1396141225,10),(1767,1414285225,6),(1767,1427590825,10),(1767,1445734826,6),(1767,1459040426,10),(1767,1477789226,6),(1767,1490490027,10),(1767,1509238827,6),(1767,1521939627,10),(1767,1540688427,6),(1767,1553994027,10),(1767,1572138027,6),(1767,1585443627,10),(1767,1603587627,6),(1767,1616893227,10),(1767,1635642027,6),(1767,1648342827,10),(1767,1667091627,6),(1767,1679792427,10),(1767,1698541227,6),(1767,1711846827,10),(1767,1729990827,6),(1767,1743296427,10),(1767,1761440427,6),(1767,1774746027,10),(1767,1792890027,6),(1767,1806195627,10),(1767,1824944427,6),(1767,1837645227,10),(1767,1856394027,6),(1767,1869094827,10),(1767,1887843627,6),(1767,1901149227,10),(1767,1919293227,6),(1767,1932598827,10),(1767,1950742827,6),(1767,1964048427,10),(1767,1982797227,6),(1767,1995498027,10),(1767,2014246827,6),(1767,2026947627,10),(1767,2045696427,6),(1767,2058397227,10),(1767,2077146027,6),(1767,2090451627,10),(1767,2108595627,6),(1767,2121901227,10),(1767,2140045227,6),(1768,-2147483648,1),(1768,-1017820800,2),(1768,-766224000,1),(1768,-745833600,3),(1768,-733827600,1),(1768,-716889600,3),(1768,-699613200,1),(1768,-683884800,3),(1768,-670669200,1),(1768,-652348800,3),(1768,-639133200,1),(1768,-620812800,3),(1768,-607597200,1),(1768,-589276800,3),(1768,-576061200,1),(1768,-562924800,3),(1768,-541760400,1),(1768,-528710400,3),(1768,-510224400,1),(1768,-497174400,3),(1768,-478688400,1),(1768,-465638400,3),(1768,-449830800,1),(1768,-434016000,3),(1768,-418208400,1),(1768,-402480000,3),(1768,-386672400,1),(1768,-370944000,3),(1768,-355136400,1),(1768,-339408000,3),(1768,-323600400,1),(1768,-302515200,3),(1768,-291978000,1),(1768,-270979200,3),(1768,-260442000,1),(1768,133977603,3),(1768,149785203,1),(1768,165513604,3),(1768,181321204,1),(1768,299606408,3),(1768,307551608,1),(1769,-2147483648,0),(1769,-1948782472,1),(1769,-1830414600,2),(1769,-767350800,4),(1769,-681210000,3),(1769,-672228000,4),(1769,-654771600,3),(1769,-640864800,4),(1769,-623408400,3),(1769,-609415200,4),(1769,-588848400,3),(1769,-577965600,4),(1769,-498128400,1),(1769,-462702600,5),(1769,-451733400,1),(1769,-429784200,5),(1769,-418296600,1),(1769,-399544200,5),(1769,-387451800,1),(1769,-368094600,5),(1769,-356002200,1),(1769,-336645000,5),(1769,-324552600,1),(1769,-305195400,5),(1769,-293103000,1),(1769,-264933000,4),(1769,547578013,3),(1769,560883613,4),(1769,579027614,3),(1769,592333214,4),(1770,-2147483648,1),(1770,-2038200925,2),(1770,-1167634800,3),(1770,-1073028000,4),(1770,-894180000,5),(1770,-879665400,6),(1770,-767005200,5),(1770,378662410,7),(1771,-2147483648,1),(1771,-1869875816,3),(1771,-1693706400,2),(1771,-1680490800,3),(1771,-1570413600,2),(1771,-1552186800,3),(1771,-1538359200,2),(1771,-1522551600,3),(1771,-1507514400,2),(1771,-1490583600,3),(1771,-1440208800,2),(1771,-1428030000,3),(1771,-1409709600,2),(1771,-1396494000,3),(1771,-931053600,2),(1771,-922676400,3),(1771,-917834400,2),(1771,-892436400,3),(1771,-875844000,2),(1771,-764737200,3),(1771,-744343200,2),(1771,-733806000,3),(1771,-716436000,2),(1771,-701924400,3),(1771,-684986400,2),(1771,-670474800,3),(1771,-654141600,2),(1771,-639025200,3),(1771,-622087200,2),(1771,-606970800,3),(1771,-590032800,2),(1771,-575521200,3),(1771,-235620000,2),(1771,-194842800,3),(1771,-177732000,2),(1771,-165726000,3),(1771,107910002,2),(1771,121215602,3),(1771,133920003,2),(1771,152665203,3),(1771,164678404,2),(1771,184114804,3),(1771,196214405,2),(1771,215564405,3),(1771,228873606,2),(1771,245804406,3),(1771,260323207,2),(1771,267915607,4),(1771,428454012,5),(1771,433893612,4),(1771,468111612,3),(1771,482799612,6),(1771,496710013,7),(1771,512521213,6),(1771,528246013,7),(1771,543970813,6),(1771,559695613,7),(1771,575420414,6),(1771,591145214,7),(1771,606870014,6),(1771,622594814,7),(1771,638319615,6),(1771,654649215,7),(1771,670374016,6),(1771,686098816,7),(1771,701823616,6),(1771,717548417,7),(1771,733273217,6),(1771,748998018,7),(1771,764118018,6),(1771,780447619,7),(1771,796172419,6),(1771,811897219,7),(1771,828226820,6),(1771,846370820,7),(1771,859676420,6),(1771,877820421,7),(1771,891126021,6),(1771,909270021,7),(1771,922575622,6),(1771,941324422,7),(1771,954025222,6),(1771,972774022,7),(1771,985474822,6),(1771,1004223622,7),(1771,1017529222,6),(1771,1035673222,7),(1771,1048978822,6),(1771,1067122822,7),(1771,1080428422,6),(1771,1099177222,7),(1771,1111878022,6),(1771,1130626822,7),(1771,1143327623,6),(1771,1162076423,7),(1771,1167602423,3),(1771,1174784423,8),(1771,1193533223,9),(1771,1206838823,8),(1771,1224982823,9),(1771,1238288424,8),(1771,1256432424,9),(1771,1269738024,8),(1771,1288486824,9),(1771,1301274024,8),(1771,1319936424,9),(1771,1332637224,8),(1771,1351386025,9),(1771,1364691625,8),(1771,1382835625,9),(1771,1396227625,8),(1771,1414285225,9),(1771,1427590825,8),(1771,1446944426,9),(1771,1459040426,8),(1771,1473195626,4),(1773,-2147483648,1),(1773,-880200000,2),(1773,-769395600,3),(1773,-765378000,1),(1773,-86882400,4),(1773,-21470400,5),(1773,-5749200,4),(1773,9979200,5),(1773,25700400,4),(1773,41428800,5),(1773,57754800,4),(1773,73483200,5),(1773,89204401,4),(1773,104932802,5),(1773,120654002,4),(1773,126705603,5),(1773,152103603,4),(1773,162388804,5),(1773,183553204,4),(1773,199281605,5),(1773,215607605,4),(1773,230731206,5),(1773,247057206,4),(1773,262785607,5),(1773,278506807,4),(1773,294235208,5),(1773,309956408,4),(1773,325684809,5),(1773,341406009,4),(1773,357134409,5),(1773,372855610,4),(1773,388584010,5),(1773,404910011,4),(1773,420033611,5),(1773,436359612,6),(1773,439030812,8),(1773,452084412,7),(1773,467805612,8),(1773,483534012,7),(1773,499255213,8),(1773,514983613,7),(1773,530704813,8),(1773,544618813,7),(1773,562154413,8),(1773,576068414,7),(1773,594208814,8),(1773,607518014,7),(1773,625658414,8),(1773,638967615,7),(1773,657108015,8),(1773,671022016,7),(1773,688557616,8),(1773,702471616,7),(1773,720007217,8),(1773,733921217,7),(1773,752061618,8),(1773,765370818,7),(1773,783511219,8),(1773,796820419,7),(1773,814960819,8),(1773,828874820,7),(1773,846410420,8),(1773,860324420,7),(1773,877860021,8),(1773,891774021,7),(1773,909309621,8),(1773,923223622,7),(1773,941364022,8),(1773,954673222,7),(1773,972813622,8),(1773,986122822,7),(1773,1004263222,8),(1773,1018177222,7),(1773,1035712822,8),(1773,1049626822,7),(1773,1067162422,8),(1773,1081076422,7),(1773,1099216822,8),(1773,1112526022,7),(1773,1130666422,8),(1773,1143975623,7),(1773,1162116023,8),(1773,1173610823,7),(1773,1194170423,8),(1773,1205060423,7),(1773,1225620023,8),(1773,1236510024,7),(1773,1257069624,8),(1773,1268564424,7),(1773,1289124024,8),(1773,1300014024,7),(1773,1320573624,8),(1773,1331463624,7),(1773,1352023225,8),(1773,1362913225,7),(1773,1383472825,8),(1773,1394362825,7),(1773,1414922425,8),(1773,1425812425,7),(1773,1446372026,8),(1773,1457866826,7),(1773,1478426426,8),(1773,1489316427,7),(1773,1509876027,8),(1773,1520766027,7),(1773,1541325627,8),(1773,1552215627,7),(1773,1572775227,8),(1773,1583665227,7),(1773,1604224827,8),(1773,1615719627,7),(1773,1636279227,8),(1773,1647169227,7),(1773,1667728827,8),(1773,1678618827,7),(1773,1699178427,8),(1773,1710068427,7),(1773,1730628027,8),(1773,1741518027,7),(1773,1762077627,8),(1773,1772967627,7),(1773,1793527227,8),(1773,1805022027,7),(1773,1825581627,8),(1773,1836471627,7),(1773,1857031227,8),(1773,1867921227,7),(1773,1888480827,8),(1773,1899370827,7),(1773,1919930427,8),(1773,1930820427,7),(1773,1951380027,8),(1773,1962874827,7),(1773,1983434427,8),(1773,1994324427,7),(1773,2014884027,8),(1773,2025774027,7),(1773,2046333627,8),(1773,2057223627,7),(1773,2077783227,8),(1773,2088673227,7),(1773,2109232827,8),(1773,2120122827,7),(1773,2140682427,8),(1774,-2147483648,1),(1774,-880196400,2),(1774,-769395600,3),(1774,-765374400,1),(1774,-86878800,4),(1774,-21466800,5),(1774,-5745600,4),(1774,9982800,5),(1774,25704000,4),(1774,41432400,5),(1774,57758400,4),(1774,73486800,5),(1774,89208001,4),(1774,104936402,5),(1774,120657602,4),(1774,126709203,5),(1774,152107203,4),(1774,162392404,5),(1774,183556804,4),(1774,199285205,5),(1774,215611205,4),(1774,230734806,5),(1774,247060806,4),(1774,262789207,5),(1774,278510407,4),(1774,294238808,5),(1774,309960008,4),(1774,325688409,5),(1774,341409609,4),(1774,357138009,5),(1774,372859210,4),(1774,388587610,5),(1774,404913611,4),(1774,420037211,5),(1774,436363212,6),(1774,439034412,8),(1774,452088012,7),(1774,467809212,8),(1774,483537612,7),(1774,499258813,8),(1774,514987213,7),(1774,530708413,8),(1774,544622413,7),(1774,562158013,8),(1774,576072014,7),(1774,594212414,8),(1774,607521614,7),(1774,625662014,8),(1774,638971215,7),(1774,657111615,8),(1774,671025616,7),(1774,688561216,8),(1774,702475216,7),(1774,720010817,8),(1774,733924817,7),(1774,752065218,8),(1774,765374418,7),(1774,783514819,8),(1774,796824019,7),(1774,814964419,8),(1774,828878420,7),(1774,846414020,8),(1774,860328020,7),(1774,877863621,8),(1774,891777621,7),(1774,909313221,8),(1774,923227222,7),(1774,941367622,8),(1774,954676822,7),(1774,972817222,8),(1774,986126422,7),(1774,1004266822,8),(1774,1018180822,7),(1774,1035716422,8),(1774,1049630422,7),(1774,1067166022,8),(1774,1081080022,7),(1774,1099220422,8),(1774,1112529622,7),(1774,1130670022,8),(1774,1143979223,7),(1774,1162119623,8),(1774,1173614423,7),(1774,1194174023,8),(1774,1205064023,7),(1774,1225623623,8),(1774,1236513624,7),(1774,1257073224,8),(1774,1268568024,7),(1774,1289127624,8),(1774,1300017624,7),(1774,1320577224,8),(1774,1331467224,7),(1774,1352026825,8),(1774,1362916825,7),(1774,1383476425,8),(1774,1394366425,7),(1774,1414926025,8),(1774,1425816025,7),(1774,1446375626,8),(1774,1457870426,7),(1774,1478430026,8),(1774,1489320027,7),(1774,1509879627,8),(1774,1520769627,7),(1774,1541329227,8),(1774,1552219227,7),(1774,1572778827,8),(1774,1583668827,7),(1774,1604228427,8),(1774,1615723227,7),(1774,1636282827,8),(1774,1647172827,7),(1774,1667732427,8),(1774,1678622427,7),(1774,1699182027,8),(1774,1710072027,7),(1774,1730631627,8),(1774,1741521627,7),(1774,1762081227,8),(1774,1772971227,7),(1774,1793530827,8),(1774,1805025627,7),(1774,1825585227,8),(1774,1836475227,7),(1774,1857034827,8),(1774,1867924827,7),(1774,1888484427,8),(1774,1899374427,7),(1774,1919934027,8),(1774,1930824027,7),(1774,1951383627,8),(1774,1962878427,7),(1774,1983438027,8),(1774,1994328027,7),(1774,2014887627,8),(1774,2025777627,7),(1774,2046337227,8),(1774,2057227227,7),(1774,2077786827,8),(1774,2088676827,7),(1774,2109236427,8),(1774,2120126427,7),(1774,2140686027,8),(1775,-2147483648,4),(1775,-1633273200,1),(1775,-1615132800,2),(1775,-1601823600,1),(1775,-1583683200,2),(1775,-880210800,3),(1775,-820519140,2),(1775,-812653140,3),(1775,-796845540,2),(1775,-84380400,1),(1775,-68659200,2),(1776,-2147483648,3),(1776,-1633276800,1),(1776,-1615136400,2),(1776,-1601827200,1),(1776,-1583686800,2),(1776,-1563724800,1),(1776,-1551632400,2),(1776,-1538928000,1),(1776,-1520182800,2),(1776,-1504454400,1),(1776,-1491757200,2),(1776,-1473004800,1),(1776,-1459702800,2),(1776,-1441555200,1),(1776,-1428253200,2),(1776,-1410105600,1),(1776,-1396803600,2),(1776,-1378656000,1),(1776,-1365354000,2),(1776,-1347206400,1),(1776,-1333904400,2),(1776,-1315152000,1),(1776,-1301850000,2),(1776,-1283702400,1),(1776,-1270400400,2),(1776,-1252252800,1),(1776,-1238950800,2),(1776,-1220803200,1),(1776,-1207501200,2),(1776,-1189353600,1),(1776,-1176051600,2),(1776,-1157299200,1),(1776,-1144602000,2),(1776,-1125849600,1),(1776,-1112547600,2),(1776,-1094400000,1),(1776,-1081098000,2),(1776,-1067788800,4),(1776,-1045414800,2),(1776,-1031500800,1),(1776,-1018198800,2),(1776,-1000051200,1),(1776,-986749200,2),(1776,-967996800,1),(1776,-955299600,2),(1776,-936547200,1),(1776,-923245200,2),(1776,-905097600,1),(1776,-891795600,2),(1776,-880214400,5),(1776,-769395600,6),(1776,-765392400,2),(1776,-747244800,1),(1776,-733942800,2),(1776,-715795200,1),(1776,-702493200,2),(1776,-684345600,1),(1776,-671043600,2),(1776,-652896000,1),(1776,-639594000,2),(1776,-620841600,1),(1776,-608144400,2),(1776,-589392000,1),(1776,-576090000,2),(1776,-557942400,1),(1776,-544640400,2),(1776,-526492800,1),(1776,-513190800,2),(1776,-495043200,1),(1776,-481741200,2),(1776,-463593600,1),(1776,-447267600,2),(1776,-431539200,1),(1776,-415818000,2),(1776,-400089600,1),(1776,-384368400,2),(1776,-368640000,1),(1776,-352918800,2),(1776,-337190400,1),(1776,-321469200,2),(1776,-305740800,1),(1776,-289414800,2),(1776,-273686400,1),(1776,-257965200,2),(1776,-242236800,1),(1776,-226515600,2),(1776,-210787200,1),(1776,-195066000,2),(1776,-179337600,1),(1776,-163616400,2),(1776,-147888000,1),(1776,-131562000,2),(1776,-116438400,1),(1776,-100112400,2),(1776,-84384000,1),(1776,-68662800,2),(1776,-52934400,1),(1776,-37213200,2),(1776,-21484800,1),(1776,-5763600,2),(1776,9964800,1),(1776,25686000,2),(1776,41414400,1),(1776,57740400,2),(1776,73468800,1),(1776,89190001,2),(1776,104918402,1),(1776,120639602,2),(1776,126691203,1),(1776,152089203,2),(1776,162374404,1),(1776,183538804,2),(1776,199267205,1),(1776,215593205,2),(1776,230716806,1),(1776,247042806,2),(1776,262771207,1),(1776,278492407,2),(1776,294220808,1),(1776,309942008,2),(1776,325670409,1),(1776,341391609,2),(1776,357120009,1),(1776,372841210,2),(1776,388569610,1),(1776,404895611,2),(1776,420019211,1),(1776,436345212,2),(1776,452073612,1),(1776,467794812,2),(1776,483523212,1),(1776,499244413,2),(1776,514972813,1),(1776,530694013,2),(1776,544608013,1),(1776,562143613,2),(1776,576057614,1),(1776,594198014,2),(1776,607507214,1),(1776,625647614,2),(1776,638956815,1),(1776,657097215,2),(1776,671011216,1),(1776,688546816,2),(1776,702460816,1),(1776,719996417,2),(1776,733910417,1),(1776,752050818,2),(1776,765360018,1),(1776,783500419,2),(1776,796809619,1),(1776,814950019,2),(1776,828864020,1),(1776,846399620,2),(1776,860313620,1),(1776,877849221,2),(1776,891763221,1),(1776,909298821,2),(1776,923212822,1),(1776,941353222,2),(1776,954662422,1),(1776,972802822,2),(1776,986112022,1),(1776,1004252422,2),(1776,1018166422,1),(1776,1035702022,2),(1776,1049616022,1),(1776,1067151622,2),(1776,1081065622,1),(1776,1099206022,2),(1776,1112515222,1),(1776,1130655622,2),(1776,1143964823,1),(1776,1162105223,2),(1776,1173600023,1),(1776,1194159623,2),(1776,1205049623,1),(1776,1225609223,2),(1776,1236499224,1),(1776,1257058824,2),(1776,1268553624,1),(1776,1289113224,2),(1776,1300003224,1),(1776,1320562824,2),(1776,1331452824,1),(1776,1352012425,2),(1776,1362902425,1),(1776,1383462025,2),(1776,1394352025,1),(1776,1414911625,2),(1776,1425801625,1),(1776,1446361226,2),(1776,1457856026,1),(1776,1478415626,2),(1776,1489305627,1),(1776,1509865227,2),(1776,1520755227,1),(1776,1541314827,2),(1776,1552204827,1),(1776,1572764427,2),(1776,1583654427,1),(1776,1604214027,2),(1776,1615708827,1),(1776,1636268427,2),(1776,1647158427,1),(1776,1667718027,2),(1776,1678608027,1),(1776,1699167627,2),(1776,1710057627,1),(1776,1730617227,2),(1776,1741507227,1),(1776,1762066827,2),(1776,1772956827,1),(1776,1793516427,2),(1776,1805011227,1),(1776,1825570827,2),(1776,1836460827,1),(1776,1857020427,2),(1776,1867910427,1),(1776,1888470027,2),(1776,1899360027,1),(1776,1919919627,2),(1776,1930809627,1),(1776,1951369227,2),(1776,1962864027,1),(1776,1983423627,2),(1776,1994313627,1),(1776,2014873227,2),(1776,2025763227,1),(1776,2046322827,2),(1776,2057212827,1),(1776,2077772427,2),(1776,2088662427,1),(1776,2109222027,2),(1776,2120112027,1),(1776,2140671627,2),(1777,-2147483648,3),(1777,-1633276800,1),(1777,-1615136400,2),(1777,-1601827200,1),(1777,-1583686800,2),(1777,-900259200,1),(1777,-891795600,2),(1777,-880214400,4),(1777,-769395600,5),(1777,-765392400,2),(1777,-747244800,1),(1777,-733942800,2),(1777,-715795200,1),(1777,-702493200,2),(1777,-684345600,1),(1777,-671043600,2),(1777,-652896000,1),(1777,-639594000,2),(1777,-620841600,1),(1777,-608144400,2),(1777,-589392000,1),(1777,-576090000,2),(1777,-557942400,1),(1777,-544640400,2),(1777,-526492800,1),(1777,-513190800,2),(1777,-495043200,1),(1777,-481741200,2),(1777,-463593600,6),(1777,-386787600,2),(1777,-368640000,6),(1777,-21488400,7),(1777,-5767200,6),(1777,9961200,7),(1777,25682400,6),(1777,1143961223,7),(1777,1162101623,6),(1777,1173596423,7),(1777,1194156023,6),(1777,1205046023,7),(1777,1225605623,6),(1777,1236495624,7),(1777,1257055224,6),(1777,1268550024,7),(1777,1289109624,6),(1777,1299999624,7),(1777,1320559224,6),(1777,1331449224,7),(1777,1352008825,6),(1777,1362898825,7),(1777,1383458425,6),(1777,1394348425,7),(1777,1414908025,6),(1777,1425798025,7),(1777,1446357626,6),(1777,1457852426,7),(1777,1478412026,6),(1777,1489302027,7),(1777,1509861627,6),(1777,1520751627,7),(1777,1541311227,6),(1777,1552201227,7),(1777,1572760827,6),(1777,1583650827,7),(1777,1604210427,6),(1777,1615705227,7),(1777,1636264827,6),(1777,1647154827,7),(1777,1667714427,6),(1777,1678604427,7),(1777,1699164027,6),(1777,1710054027,7),(1777,1730613627,6),(1777,1741503627,7),(1777,1762063227,6),(1777,1772953227,7),(1777,1793512827,6),(1777,1805007627,7),(1777,1825567227,6),(1777,1836457227,7),(1777,1857016827,6),(1777,1867906827,7),(1777,1888466427,6),(1777,1899356427,7),(1777,1919916027,6),(1777,1930806027,7),(1777,1951365627,6),(1777,1962860427,7),(1777,1983420027,6),(1777,1994310027,7),(1777,2014869627,6),(1777,2025759627,7),(1777,2046319227,6),(1777,2057209227,7),(1777,2077768827,6),(1777,2088658827,7),(1777,2109218427,6),(1777,2120108427,7),(1777,2140668027,6),(1778,-2147483648,3),(1778,-1633280400,1),(1778,-1615140000,2),(1778,-1601830800,1),(1778,-1583690400,2),(1778,-1570381200,1),(1778,-1551636000,2),(1778,-1536512400,1),(1778,-1523210400,2),(1778,-1504458000,1),(1778,-1491760800,2),(1778,-1473008400,1),(1778,-1459706400,2),(1778,-1441558800,1),(1778,-1428256800,2),(1778,-1410109200,1),(1778,-1396807200,2),(1778,-1378659600,1),(1778,-1365357600,2),(1778,-1347210000,1),(1778,-1333908000,2),(1778,-1315155600,1),(1778,-1301853600,2),(1778,-1283706000,1),(1778,-1270404000,2),(1778,-1252256400,1),(1778,-1238954400,2),(1778,-1220806800,1),(1778,-1207504800,2),(1778,-1189357200,1),(1778,-1176055200,2),(1778,-1157302800,1),(1778,-1144605600,2),(1778,-1125853200,1),(1778,-1112551200,2),(1778,-1094403600,1),(1778,-1081101600,2),(1778,-1062954000,1),(1778,-1049652000,2),(1778,-1031504400,1),(1778,-1018202400,2),(1778,-1000054800,1),(1778,-986752800,2),(1778,-968000400,1),(1778,-955303200,2),(1778,-936550800,1),(1778,-923248800,2),(1778,-905101200,1),(1778,-891799200,2),(1778,-880218000,4),(1778,-769395600,5),(1778,-765396000,2),(1778,-747248400,1),(1778,-733946400,2),(1778,-715798800,1),(1778,-702496800,2),(1778,-684349200,1),(1778,-671047200,2),(1778,-652899600,1),(1778,-639597600,2),(1778,-620845200,1),(1778,-608148000,2),(1778,-589395600,1),(1778,-576093600,2),(1778,-557946000,1),(1778,-544644000,2),(1778,-526496400,1),(1778,-513194400,2),(1778,-495046800,1),(1778,-481744800,2),(1778,-463597200,1),(1778,-447271200,2),(1778,-431542800,1),(1778,-415821600,2),(1778,-400093200,1),(1778,-384372000,2),(1778,-368643600,1),(1778,-352922400,2),(1778,-337194000,1),(1778,-321472800,2),(1778,-305744400,1),(1778,-289418400,2),(1778,-273690000,1),(1778,-257968800,2),(1778,-242240400,1),(1778,-226519200,2),(1778,-210790800,1),(1778,-195069600,2),(1778,-179341200,1),(1778,-163620000,2),(1778,-147891600,1),(1778,-131565600,2),(1778,-116442000,1),(1778,-100116000,2),(1778,-84387600,1),(1778,-68666400,2),(1778,-52938000,1),(1778,-37216800,2),(1778,-21488400,1),(1778,-5767200,2),(1778,9961200,1),(1778,25682400,2),(1778,41410800,1),(1778,57736800,2),(1778,73465200,1),(1778,89186401,2),(1778,104914802,1),(1778,120636002,2),(1778,126687603,1),(1778,152085603,2),(1778,162370804,1),(1778,183535204,2),(1778,199263605,1),(1778,215589605,2),(1778,230713206,1),(1778,247039206,2),(1778,262767607,1),(1778,278488807,2),(1778,294217208,1),(1778,309938408,2),(1778,325666809,1),(1778,341388009,2),(1778,357116409,1),(1778,372837610,2),(1778,388566010,1),(1778,404892011,2),(1778,420015611,1),(1778,436341612,2),(1778,452070012,1),(1778,467791212,2),(1778,483519612,1),(1778,499240813,2),(1778,514969213,1),(1778,530690413,2),(1778,544604413,1),(1778,562140013,2),(1778,576054014,1),(1778,594194414,2),(1778,607503614,1),(1778,625644014,2),(1778,638953215,1),(1778,657093615,2),(1778,671007616,1),(1778,688543216,2),(1778,702457216,1),(1778,719992817,2),(1778,733906817,1),(1778,752047218,2),(1778,765356418,1),(1778,783496819,2),(1778,796806019,1),(1778,814946419,2),(1778,828860420,1),(1778,846396020,2),(1778,860310020,1),(1778,877845621,2),(1778,891759621,1),(1778,909295221,2),(1778,923209222,1),(1778,941349622,2),(1778,954658822,1),(1778,972799222,2),(1778,986108422,1),(1778,1004248822,2),(1778,1018162822,1),(1778,1035698422,2),(1778,1049612422,1),(1778,1067148022,2),(1778,1081062022,1),(1778,1099202422,2),(1778,1112511622,1),(1778,1130652022,2),(1778,1143961223,1),(1778,1162101623,2),(1778,1173596423,1),(1778,1194156023,2),(1778,1205046023,1),(1778,1225605623,2),(1778,1236495624,1),(1778,1257055224,2),(1778,1268550024,1),(1778,1289109624,2),(1778,1299999624,1),(1778,1320559224,2),(1778,1331449224,1),(1778,1352008825,2),(1778,1362898825,1),(1778,1383458425,2),(1778,1394348425,1),(1778,1414908025,2),(1778,1425798025,1),(1778,1446357626,2),(1778,1457852426,1),(1778,1478412026,2),(1778,1489302027,1),(1778,1509861627,2),(1778,1520751627,1),(1778,1541311227,2),(1778,1552201227,1),(1778,1572760827,2),(1778,1583650827,1),(1778,1604210427,2),(1778,1615705227,1),(1778,1636264827,2),(1778,1647154827,1),(1778,1667714427,2),(1778,1678604427,1),(1778,1699164027,2),(1778,1710054027,1),(1778,1730613627,2),(1778,1741503627,1),(1778,1762063227,2),(1778,1772953227,1),(1778,1793512827,2),(1778,1805007627,1),(1778,1825567227,2),(1778,1836457227,1),(1778,1857016827,2),(1778,1867906827,1),(1778,1888466427,2),(1778,1899356427,1),(1778,1919916027,2),(1778,1930806027,1),(1778,1951365627,2),(1778,1962860427,1),(1778,1983420027,2),(1778,1994310027,1),(1778,2014869627,2),(1778,2025759627,1),(1778,2046319227,2),(1778,2057209227,1),(1778,2077768827,2),(1778,2088658827,1),(1778,2109218427,2),(1778,2120108427,1),(1778,2140668027,2),(1779,-2147483648,1),(1779,-1157283000,2),(1779,-1155436200,1),(1779,-880198200,3),(1779,-769395600,4),(1779,-765376200,1),(1779,-712150200,5),(1780,-2147483648,5),(1780,-1633276800,1),(1780,-1615136400,2),(1780,-1601827200,1),(1780,-1583686800,2),(1780,-880214400,3),(1780,-769395600,4),(1780,-765392400,2),(1780,-715795200,1),(1780,-702493200,2),(1780,-684345600,1),(1780,-671043600,2),(1780,-652896000,1),(1780,-639594000,2),(1780,-620841600,1),(1780,-608144400,2),(1780,-589392000,1),(1780,-576090000,2),(1780,-557942400,1),(1780,-544640400,2),(1780,-526492800,1),(1780,-513190800,2),(1780,-495043200,1),(1780,-481741200,2),(1780,-463593600,1),(1780,-447267600,2),(1780,-431539200,1),(1780,-415818000,2),(1780,-400089600,1),(1780,-386787600,2),(1780,-368640000,1),(1780,-355338000,2),(1780,-337190400,1),(1780,-321469200,2),(1780,-305740800,1),(1780,-289414800,2),(1780,-273686400,1),(1780,-257965200,2),(1780,-242236800,6),(1780,-195066000,2),(1780,-84384000,1),(1780,-68662800,2),(1780,-52934400,1),(1780,-37213200,2),(1780,-21484800,1),(1780,-5763600,2),(1780,9964800,1),(1780,25686000,2),(1780,41414400,1),(1780,57740400,2),(1780,73468800,1),(1780,89190001,2),(1780,104918402,1),(1780,120639602,2),(1780,126691203,1),(1780,152089203,2),(1780,162374404,1),(1780,183538804,2),(1780,199267205,1),(1780,215593205,2),(1780,230716806,1),(1780,247042806,2),(1780,262771207,1),(1780,278492407,2),(1780,294220808,1),(1780,309942008,2),(1780,325670409,1),(1780,341391609,2),(1780,357120009,1),(1780,372841210,2),(1780,388569610,1),(1780,404895611,2),(1780,420019211,1),(1780,436345212,2),(1780,452073612,1),(1780,467794812,2),(1780,483523212,1),(1780,499244413,2),(1780,514972813,1),(1780,530694013,2),(1780,544608013,1),(1780,562143613,2),(1780,576057614,1),(1780,594198014,2),(1780,607507214,1),(1780,625647614,2),(1780,638956815,1),(1780,657097215,2),(1780,671011216,1),(1780,688546816,6),(1780,1143961223,1),(1780,1162105223,2),(1780,1173600023,1),(1780,1194159623,2),(1780,1205049623,1),(1780,1225609223,2),(1780,1236499224,1),(1780,1257058824,2),(1780,1268553624,1),(1780,1289113224,2),(1780,1300003224,1),(1780,1320562824,2),(1780,1331452824,1),(1780,1352012425,2),(1780,1362902425,1),(1780,1383462025,2),(1780,1394352025,1),(1780,1414911625,2),(1780,1425801625,1),(1780,1446361226,2),(1780,1457856026,1),(1780,1478415626,2),(1780,1489305627,1),(1780,1509865227,2),(1780,1520755227,1),(1780,1541314827,2),(1780,1552204827,1),(1780,1572764427,2),(1780,1583654427,1),(1780,1604214027,2),(1780,1615708827,1),(1780,1636268427,2),(1780,1647158427,1),(1780,1667718027,2),(1780,1678608027,1),(1780,1699167627,2),(1780,1710057627,1),(1780,1730617227,2),(1780,1741507227,1),(1780,1762066827,2),(1780,1772956827,1),(1780,1793516427,2),(1780,1805011227,1),(1780,1825570827,2),(1780,1836460827,1),(1780,1857020427,2),(1780,1867910427,1),(1780,1888470027,2),(1780,1899360027,1),(1780,1919919627,2),(1780,1930809627,1),(1780,1951369227,2),(1780,1962864027,1),(1780,1983423627,2),(1780,1994313627,1),(1780,2014873227,2),(1780,2025763227,1),(1780,2046322827,2),(1780,2057212827,1),(1780,2077772427,2),(1780,2088662427,1),(1780,2109222027,2),(1780,2120112027,1),(1780,2140671627,2),(1781,-2147483648,0),(1781,-2051202469,1),(1781,-1724083200,2),(1781,-880218000,3),(1781,-769395600,4),(1781,-765396000,2),(1781,-684349200,5),(1781,-671047200,2),(1781,-80506740,5),(1781,-68666400,2),(1781,-52938000,5),(1781,-37216800,2),(1781,104914802,5),(1781,120636002,2),(1781,126687603,5),(1781,152085603,2),(1781,167814004,5),(1781,183535204,2),(1781,199263605,5),(1781,215589605,2),(1781,230713206,5),(1781,247039206,2),(1781,262767607,5),(1781,278488807,2),(1781,294217208,5),(1781,309938408,2),(1781,325666809,5),(1781,341388009,2),(1781,357116409,5),(1781,372837610,2),(1781,388566010,5),(1781,404892011,2),(1781,420015611,5),(1781,436341612,2),(1781,452070012,5),(1781,467791212,2),(1781,483519612,5),(1781,499240813,2),(1781,514969213,5),(1781,530690413,2),(1781,544604413,5),(1781,562140013,2),(1781,576054014,5),(1781,594194414,2),(1781,607503614,5),(1781,625644014,2),(1781,638953215,5),(1781,657093615,2),(1781,671007616,5),(1781,688543216,2),(1781,702457216,5),(1781,719992817,2),(1781,733906817,5),(1781,752047218,2),(1781,765356418,5),(1781,783496819,2),(1781,796806019,5),(1781,814946419,2),(1781,828860420,5),(1781,846396020,2),(1781,860310020,5),(1781,877845621,2),(1781,891759621,5),(1781,909295221,2),(1781,923209222,5),(1781,941349622,2),(1781,954658822,5),(1781,972799222,2),(1781,986108422,5),(1781,1004248822,2),(1781,1018162822,5),(1781,1035698422,2),(1781,1049612422,5),(1781,1067148022,2),(1781,1081062022,5),(1781,1099202422,2),(1781,1112511622,5),(1781,1130652022,2),(1781,1143961223,5),(1781,1162101623,2),(1781,1173596423,5),(1781,1194156023,2),(1781,1205046023,5),(1781,1225605623,2),(1781,1236495624,5),(1781,1257055224,2),(1781,1268550024,5),(1781,1289109624,2),(1781,1299999624,5),(1781,1320559224,2),(1781,1331449224,5),(1781,1352008825,2),(1781,1362898825,5),(1781,1383458425,2),(1781,1394348425,5),(1781,1414908025,2),(1781,1425798025,5),(1781,1446357626,2),(1781,1457852426,5),(1781,1478412026,2),(1781,1489302027,5),(1781,1509861627,2),(1781,1520751627,5),(1781,1541311227,2),(1781,1552201227,5),(1781,1572760827,2),(1781,1583650827,5),(1781,1604210427,2),(1781,1615705227,5),(1781,1636264827,2),(1781,1647154827,5),(1781,1667714427,2),(1781,1678604427,5),(1781,1699164027,2),(1781,1710054027,5),(1781,1730613627,2),(1781,1741503627,5),(1781,1762063227,2),(1781,1772953227,5),(1781,1793512827,2),(1781,1805007627,5),(1781,1825567227,2),(1781,1836457227,5),(1781,1857016827,2),(1781,1867906827,5),(1781,1888466427,2),(1781,1899356427,5),(1781,1919916027,2),(1781,1930806027,5),(1781,1951365627,2),(1781,1962860427,5),(1781,1983420027,2),(1781,1994310027,5),(1781,2014869627,2),(1781,2025759627,5),(1781,2046319227,2),(1781,2057209227,5),(1781,2077768827,2),(1781,2088658827,5),(1781,2109218427,2),(1781,2120108427,5),(1781,2140668027,2),(1782,-2147483648,3),(1782,-1633273200,1),(1782,-1615132800,2),(1782,-1601823600,1),(1782,-1583683200,2),(1782,-1570374000,1),(1782,-1551628800,2),(1782,-1538924400,1),(1782,-1534089600,2),(1782,-880210800,4),(1782,-769395600,5),(1782,-765388800,2),(1782,-147884400,1),(1782,-131558400,2),(1782,-116434800,1),(1782,-100108800,2),(1782,-84380400,1),(1782,-68659200,2),(1782,-52930800,1),(1782,-37209600,2),(1782,-21481200,1),(1782,-5760000,2),(1782,9968400,1),(1782,25689600,2),(1782,41418000,1),(1782,57744000,2),(1782,73472400,1),(1782,89193601,2),(1782,104922002,1),(1782,120643202,2),(1782,126694803,1),(1782,152092803,2),(1782,162378004,1),(1782,183542404,2),(1782,199270805,1),(1782,215596805,2),(1782,230720406,1),(1782,247046406,2),(1782,262774807,1),(1782,278496007,2),(1782,294224408,1),(1782,309945608,2),(1782,325674009,1),(1782,341395209,2),(1782,357123609,1),(1782,372844810,2),(1782,388573210,1),(1782,404899211,2),(1782,420022811,1),(1782,436348812,2),(1782,452077212,1),(1782,467798412,2),(1782,483526812,1),(1782,499248013,2),(1782,514976413,1),(1782,530697613,2),(1782,544611613,1),(1782,562147213,2),(1782,576061214,1),(1782,594201614,2),(1782,607510814,1),(1782,625651214,2),(1782,638960415,1),(1782,657100815,2),(1782,671014816,1),(1782,688550416,2),(1782,702464416,1),(1782,720000017,2),(1782,733914017,1),(1782,752054418,2),(1782,765363618,1),(1782,783504019,2),(1782,796813219,1),(1782,814953619,2),(1782,828867620,1),(1782,846403220,2),(1782,860317220,1),(1782,877852821,2),(1782,891766821,1),(1782,909302421,2),(1782,923216422,1),(1782,941356822,2),(1782,954666022,1),(1782,972806422,2),(1782,986115622,1),(1782,1004256022,2),(1782,1018170022,1),(1782,1035705622,2),(1782,1049619622,1),(1782,1067155222,2),(1782,1081069222,1),(1782,1099209622,2),(1782,1112518822,1),(1782,1130659222,2),(1782,1143968423,1),(1782,1162108823,2),(1782,1173603623,1),(1782,1194163223,2),(1782,1205053223,1),(1782,1225612823,2),(1782,1236502824,1),(1782,1257062424,2),(1782,1268557224,1),(1782,1289116824,2),(1782,1300006824,1),(1782,1320566424,2),(1782,1331456424,1),(1782,1352016025,2),(1782,1362906025,1),(1782,1383465625,2),(1782,1394355625,1),(1782,1414915225,2),(1782,1425805225,1),(1782,1446364826,2),(1782,1457859626,1),(1782,1478419226,2),(1782,1489309227,1),(1782,1509868827,2),(1782,1520758827,1),(1782,1541318427,2),(1782,1552208427,1),(1782,1572768027,2),(1782,1583658027,1),(1782,1604217627,2),(1782,1615712427,1),(1782,1636272027,2),(1782,1647162027,1),(1782,1667721627,2),(1782,1678611627,1),(1782,1699171227,2),(1782,1710061227,1),(1782,1730620827,2),(1782,1741510827,1),(1782,1762070427,2),(1782,1772960427,1),(1782,1793520027,2),(1782,1805014827,1),(1782,1825574427,2),(1782,1836464427,1),(1782,1857024027,2),(1782,1867914027,1),(1782,1888473627,2),(1782,1899363627,1),(1782,1919923227,2),(1782,1930813227,1),(1782,1951372827,2),(1782,1962867627,1),(1782,1983427227,2),(1782,1994317227,1),(1782,2014876827,2),(1782,2025766827,1),(1782,2046326427,2),(1782,2057216427,1),(1782,2077776027,2),(1782,2088666027,1),(1782,2109225627,2),(1782,2120115627,1),(1782,2140675227,2),(1783,-2147483648,5),(1783,-1633269600,1),(1783,-1615129200,2),(1783,-1601820000,1),(1783,-1583679600,2),(1783,-880207200,3),(1783,-769395600,4),(1783,-765385200,2),(1783,-687967140,1),(1783,-662655600,2),(1783,-620838000,1),(1783,-608137200,2),(1783,-589388400,1),(1783,-576082800,2),(1783,-557938800,1),(1783,-544633200,2),(1783,-526489200,1),(1783,-513183600,2),(1783,-495039600,1),(1783,-481734000,2),(1783,-463590000,1),(1783,-450284400,2),(1783,-431535600,1),(1783,-418230000,2),(1783,-400086000,1),(1783,-386780400,2),(1783,-368636400,1),(1783,-355330800,2),(1783,-337186800,1),(1783,-323881200,2),(1783,-305737200,1),(1783,-292431600,2),(1783,-273682800,1),(1783,-260982000,2),(1783,-242233200,1),(1783,-226508400,2),(1783,-210783600,1),(1783,-195058800,2),(1783,-179334000,1),(1783,-163609200,2),(1783,-147884400,1),(1783,-131554800,2),(1783,-116434800,1),(1783,-100105200,2),(1783,-84376800,1),(1783,-68655600,2),(1783,-52927200,1),(1783,-37206000,2),(1783,-21477600,1),(1783,-5756400,2),(1783,9972000,1),(1783,25693200,2),(1783,41421600,1),(1783,57747600,2),(1783,73476000,1),(1783,89197201,2),(1783,104925602,1),(1783,120646802,2),(1783,126698403,1),(1783,152096403,2),(1783,162381604,1),(1783,183546004,2),(1783,199274405,1),(1783,215600405,2),(1783,230724006,1),(1783,247050006,2),(1783,262778407,1),(1783,278499607,2),(1783,294228008,1),(1783,309949208,2),(1783,325677609,1),(1783,341398809,2),(1783,357127209,1),(1783,372848410,2),(1783,388576810,1),(1783,404902811,2),(1783,420026411,1),(1783,436352412,2),(1783,452080812,1),(1783,467802012,2),(1783,483530412,1),(1783,499251613,2),(1783,514980013,1),(1783,530701213,2),(1783,544615213,1),(1783,562150813,2),(1783,576064814,1),(1783,594205214,2),(1783,607514414,1),(1783,625654814,2),(1783,638964015,1),(1783,657104415,2),(1783,671018416,1),(1783,688554016,2),(1783,702468016,1),(1783,720003617,2),(1783,733917617,1),(1783,752058018,2),(1783,765367218,1),(1783,783507619,2),(1783,796816819,1),(1783,814957219,2),(1783,828871220,1),(1783,846406820,2),(1783,860320820,1),(1783,877856421,2),(1783,891770421,1),(1783,909306021,2),(1783,923220022,1),(1783,941360422,2),(1783,954669622,1),(1783,972810022,2),(1783,986119222,1),(1783,1004259622,2),(1783,1018173622,1),(1783,1035709222,2),(1783,1049623222,1),(1783,1067158822,2),(1783,1081072822,1),(1783,1099213222,2),(1783,1112522422,1),(1783,1130662822,2),(1783,1143972023,1),(1783,1162112423,2),(1783,1173607223,1),(1783,1194166823,2),(1783,1205056823,1),(1783,1225616423,2),(1783,1236506424,1),(1783,1257066024,2),(1783,1268560824,1),(1783,1289120424,2),(1783,1300010424,1),(1783,1320570024,2),(1783,1331460024,1),(1783,1352019625,2),(1783,1362909625,1),(1783,1383469225,2),(1783,1394359225,1),(1783,1414918825,2),(1783,1425808825,1),(1783,1446368426,2),(1783,1457863226,1),(1783,1478422826,2),(1783,1489312827,1),(1783,1509872427,2),(1783,1520762427,1),(1783,1541322027,2),(1783,1552212027,1),(1783,1572771627,2),(1783,1583661627,1),(1783,1604221227,2),(1783,1615716027,1),(1783,1636275627,2),(1783,1647165627,1),(1783,1667725227,2),(1783,1678615227,1),(1783,1699174827,2),(1783,1710064827,1),(1783,1730624427,2),(1783,1741514427,1),(1783,1762074027,2),(1783,1772964027,1),(1783,1793523627,2),(1783,1805018427,1),(1783,1825578027,2),(1783,1836468027,1),(1783,1857027627,2),(1783,1867917627,1),(1783,1888477227,2),(1783,1899367227,1),(1783,1919926827,2),(1783,1930816827,1),(1783,1951376427,2),(1783,1962871227,1),(1783,1983430827,2),(1783,1994320827,1),(1783,2014880427,2),(1783,2025770427,1),(1783,2046330027,2),(1783,2057220027,1),(1783,2077779627,2),(1783,2088669627,1),(1783,2109229227,2),(1783,2120119227,1),(1783,2140678827,2),(1784,-2147483648,1),(1784,-1861879032,2),(1787,-2147483648,1),(1787,-1688265017,3),(1787,-1656819079,2),(1787,-1641353479,3),(1787,-1627965079,4),(1787,-1618716679,2),(1787,-1596429079,4),(1787,-1593820800,5),(1787,-1589860800,6),(1787,-1542427200,7),(1787,-1539493200,8),(1787,-1525323600,7),(1787,-1522728000,6),(1787,-1491188400,9),(1787,-1247536800,6),(1787,354920409,7),(1787,370728010,6),(1787,386456410,7),(1787,402264011,6),(1787,417992411,7),(1787,433800012,6),(1787,449614812,7),(1787,465346812,10),(1787,481071612,11),(1787,496796413,10),(1787,512521213,11),(1787,528246013,10),(1787,543970813,11),(1787,559695613,10),(1787,575420414,11),(1787,591145214,10),(1787,606870014,11),(1787,622594814,10),(1787,638319615,11),(1787,654649215,10),(1787,670374016,12),(1787,686102416,13),(1787,695779216,10),(1787,701823616,11),(1787,717548417,10),(1787,733273217,11),(1787,748998018,10),(1787,764722818,11),(1787,780447619,10),(1787,796172419,11),(1787,811897219,10),(1787,828226820,11),(1787,846370820,10),(1787,859676420,11),(1787,877820421,10),(1787,891126021,11),(1787,909270021,10),(1787,922575622,11),(1787,941324422,10),(1787,954025222,11),(1787,972774022,10),(1787,985474822,11),(1787,1004223622,10),(1787,1017529222,11),(1787,1035673222,10),(1787,1048978822,11),(1787,1067122822,10),(1787,1080428422,11),(1787,1099177222,10),(1787,1111878022,11),(1787,1130626822,10),(1787,1143327623,11),(1787,1162076423,10),(1787,1174777223,11),(1787,1193526023,10),(1787,1206831623,11),(1787,1224975623,10),(1787,1238281224,11),(1787,1256425224,10),(1787,1269730824,11),(1787,1288479624,10),(1787,1301180424,14),(1787,1414274425,10),(1788,228877206,0),(1788,243997206,1),(1788,260326807,0),(1788,276051607,1),(1788,291776408,0),(1788,307501208,1),(1788,323830809,0),(1788,338950809,1),(1788,354675609,0),(1788,370400410,1),(1788,386125210,0),(1788,401850011,1),(1788,417574811,0),(1788,433299612,1),(1788,449024412,0),(1788,465354012,1),(1788,481078812,0),(1788,496803613,1),(1788,512528413,0),(1788,528253213,1),(1788,543978013,0),(1788,559702813,1),(1788,575427614,0),(1788,591152414,1),(1788,606877214,0),(1788,622602014,1),(1788,638326815,0),(1788,654656415,1),(1788,670381216,0),(1788,686106016,1),(1788,701830816,0),(1788,717555617,1),(1788,733280417,0),(1788,749005218,1),(1788,764730018,0),(1788,780454819,1),(1788,796179619,0),(1788,811904419,1),(1788,828234020,0),(1788,846378020,1),(1788,859683620,0),(1788,877827621,1),(1788,891133221,0),(1788,909277221,1),(1788,922582822,0),(1788,941331622,1),(1788,954032422,0),(1788,972781222,1),(1788,985482022,0),(1788,1004230822,1),(1788,1017536422,0),(1788,1035680422,1),(1788,1048986022,0),(1788,1067130022,1),(1788,1080435622,0),(1788,1099184422,1),(1788,1111885222,0),(1788,1130634022,1),(1788,1143334823,0),(1788,1162083623,1),(1788,1174784423,0),(1788,1193533223,1),(1788,1206838823,0),(1788,1224982823,1),(1788,1238288424,0),(1788,1256432424,1),(1788,1269738024,0),(1788,1288486824,1),(1788,1301187624,0),(1788,1319936424,1),(1788,1332637224,0),(1788,1351386025,1),(1788,1364691625,0),(1788,1382835625,1),(1788,1396141225,0),(1788,1414285225,1),(1788,1427590825,0),(1788,1445734826,1),(1788,1459040426,0),(1788,1477789226,1),(1788,1490490027,0),(1788,1509238827,1),(1788,1521939627,0),(1788,1540688427,1),(1788,1553994027,0),(1788,1572138027,1),(1788,1585443627,0),(1788,1603587627,1),(1788,1616893227,0),(1788,1635642027,1),(1788,1648342827,0),(1788,1667091627,1),(1788,1679792427,0),(1788,1698541227,1),(1788,1711846827,0),(1788,1729990827,1),(1788,1743296427,0),(1788,1761440427,1),(1788,1774746027,0),(1788,1792890027,1),(1788,1806195627,0),(1788,1824944427,1),(1788,1837645227,0),(1788,1856394027,1),(1788,1869094827,0),(1788,1887843627,1),(1788,1901149227,0),(1788,1919293227,1),(1788,1932598827,0),(1788,1950742827,1),(1788,1964048427,0),(1788,1982797227,1),(1788,1995498027,0),(1788,2014246827,1),(1788,2026947627,0),(1788,2045696427,1),(1788,2058397227,0),(1788,2077146027,1),(1788,2090451627,0),(1788,2108595627,1),(1788,2121901227,0),(1788,2140045227,1);
/*!40000 ALTER TABLE `time_zone_transition` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `time_zone_transition_type`
--

DROP TABLE IF EXISTS `time_zone_transition_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `time_zone_transition_type` (
  `Time_zone_id` int unsigned NOT NULL,
  `Transition_type_id` int unsigned NOT NULL,
  `Offset` int NOT NULL DEFAULT '0',
  `Is_DST` tinyint unsigned NOT NULL DEFAULT '0',
  `Abbreviation` char(8) NOT NULL DEFAULT '',
  PRIMARY KEY (`Time_zone_id`,`Transition_type_id`)
) /*!50100 TABLESPACE `mysql` */ ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 STATS_PERSISTENT=0 ROW_FORMAT=DYNAMIC COMMENT='Time zone transition types';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `time_zone_transition_type`
--

LOCK TABLES `time_zone_transition_type` WRITE;
/*!40000 ALTER TABLE `time_zone_transition_type` DISABLE KEYS */;
INSERT INTO `time_zone_transition_type` VALUES (1,0,-968,0,'LMT'),(1,1,0,0,'GMT'),(2,0,-968,0,'LMT'),(2,1,0,0,'GMT'),(3,0,8836,0,'LMT'),(3,1,9000,0,'+0230'),(3,2,10800,0,'EAT'),(3,3,9900,0,'+0245'),(3,4,10800,0,'EAT'),(4,0,732,0,'LMT'),(4,1,561,0,'PMT'),(4,2,3600,1,'WEST'),(4,3,0,0,'WET'),(4,4,0,0,'WET'),(4,5,7200,1,'CEST'),(4,6,3600,0,'CET'),(4,7,3600,1,'WEST'),(5,0,8836,0,'LMT'),(5,1,9000,0,'+0230'),(5,2,10800,0,'EAT'),(5,3,9900,0,'+0245'),(5,4,10800,0,'EAT'),(6,0,8836,0,'LMT'),(6,1,9000,0,'+0230'),(6,2,10800,0,'EAT'),(6,3,9900,0,'+0245'),(6,4,10800,0,'EAT'),(7,0,-968,0,'LMT'),(7,1,0,0,'GMT'),(8,0,815,0,'LMT'),(8,1,0,0,'GMT'),(8,2,1800,0,'+0030'),(8,3,3600,0,'WAT'),(9,0,-968,0,'LMT'),(9,1,0,0,'GMT'),(10,0,-3740,0,'LMT'),(10,1,-3600,0,'-01'),(10,2,0,0,'GMT'),(11,0,7820,0,'LMT'),(11,1,7200,0,'CAT'),(12,0,815,0,'LMT'),(12,1,0,0,'GMT'),(12,2,1800,0,'+0030'),(12,3,3600,0,'WAT'),(13,0,7820,0,'LMT'),(13,1,7200,0,'CAT'),(14,0,7509,0,'LMT'),(14,1,10800,1,'EEST'),(14,2,7200,0,'EET'),(14,3,10800,1,'EEST'),(15,0,-1820,0,'LMT'),(15,1,3600,1,'+01'),(15,2,0,0,'+00'),(15,3,3600,0,'+01'),(15,4,0,0,'+00'),(16,0,-1276,0,'LMT'),(16,1,0,0,'WET'),(16,2,3600,1,'WEST'),(16,3,0,0,'WET'),(16,4,0,0,'WET'),(16,5,3600,0,'CET'),(16,6,7200,1,'CEST'),(16,7,3600,0,'CET'),(17,0,-968,0,'LMT'),(17,1,0,0,'GMT'),(18,0,-968,0,'LMT'),(18,1,0,0,'GMT'),(19,0,8836,0,'LMT'),(19,1,9000,0,'+0230'),(19,2,10800,0,'EAT'),(19,3,9900,0,'+0245'),(19,4,10800,0,'EAT'),(20,0,8836,0,'LMT'),(20,1,9000,0,'+0230'),(20,2,10800,0,'EAT'),(20,3,9900,0,'+0245'),(20,4,10800,0,'EAT'),(21,0,815,0,'LMT'),(21,1,0,0,'GMT'),(21,2,1800,0,'+0030'),(21,3,3600,0,'WAT'),(22,0,-3168,0,'LMT'),(22,1,-3600,0,'-01'),(22,2,3600,1,'+01'),(22,3,0,0,'+00'),(23,0,-968,0,'LMT'),(23,1,0,0,'GMT'),(24,0,7820,0,'LMT'),(24,1,7200,0,'CAT'),(25,0,7820,0,'LMT'),(25,1,7200,0,'CAT'),(26,0,6720,0,'LMT'),(26,1,5400,0,'SAST'),(26,2,10800,1,'SAST'),(26,3,7200,0,'SAST'),(27,0,7588,0,'LMT'),(27,1,10800,1,'CAST'),(27,2,7200,0,'CAT'),(27,3,10800,0,'EAT'),(27,4,7200,0,'CAT'),(28,0,8836,0,'LMT'),(28,1,9000,0,'+0230'),(28,2,10800,0,'EAT'),(28,3,9900,0,'+0245'),(28,4,10800,0,'EAT'),(29,0,7808,0,'LMT'),(29,1,10800,1,'CAST'),(29,2,7200,0,'CAT'),(29,3,10800,0,'EAT'),(29,4,7200,0,'CAT'),(30,0,7820,0,'LMT'),(30,1,7200,0,'CAT'),(31,0,815,0,'LMT'),(31,1,0,0,'GMT'),(31,2,1800,0,'+0030'),(31,3,3600,0,'WAT'),(32,0,815,0,'LMT'),(32,1,0,0,'GMT'),(32,2,1800,0,'+0030'),(32,3,3600,0,'WAT'),(33,0,815,0,'LMT'),(33,1,0,0,'GMT'),(33,2,1800,0,'+0030'),(33,3,3600,0,'WAT'),(34,0,-968,0,'LMT'),(34,1,0,0,'GMT'),(35,0,815,0,'LMT'),(35,1,0,0,'GMT'),(35,2,1800,0,'+0030'),(35,3,3600,0,'WAT'),(36,0,7820,0,'LMT'),(36,1,7200,0,'CAT'),(37,0,7820,0,'LMT'),(37,1,7200,0,'CAT'),(38,0,815,0,'LMT'),(38,1,0,0,'GMT'),(38,2,1800,0,'+0030'),(38,3,3600,0,'WAT'),(39,0,7820,0,'LMT'),(39,1,7200,0,'CAT'),(40,0,6720,0,'LMT'),(40,1,5400,0,'SAST'),(40,2,10800,1,'SAST'),(40,3,7200,0,'SAST'),(41,0,6720,0,'LMT'),(41,1,5400,0,'SAST'),(41,2,10800,1,'SAST'),(41,3,7200,0,'SAST'),(42,0,8836,0,'LMT'),(42,1,9000,0,'+0230'),(42,2,10800,0,'EAT'),(42,3,9900,0,'+0245'),(42,4,10800,0,'EAT'),(43,0,-2588,0,'LMT'),(43,1,-2588,0,'MMT'),(43,2,-2670,0,'MMT'),(43,3,0,0,'GMT'),(44,0,8836,0,'LMT'),(44,1,9000,0,'+0230'),(44,2,10800,0,'EAT'),(44,3,9900,0,'+0245'),(44,4,10800,0,'EAT'),(45,0,3612,0,'LMT'),(45,1,3600,0,'WAT'),(45,2,7200,1,'WAST'),(46,0,815,0,'LMT'),(46,1,0,0,'GMT'),(46,2,1800,0,'+0030'),(46,3,3600,0,'WAT'),(47,0,-968,0,'LMT'),(47,1,0,0,'GMT'),(48,0,-968,0,'LMT'),(48,1,0,0,'GMT'),(49,0,815,0,'LMT'),(49,1,0,0,'GMT'),(49,2,1800,0,'+0030'),(49,3,3600,0,'WAT'),(50,0,1616,0,'LMT'),(50,1,-2205,0,'LMT'),(50,2,0,0,'GMT'),(50,3,3600,0,'WAT'),(50,4,0,0,'GMT'),(51,0,-968,0,'LMT'),(51,1,0,0,'GMT'),(52,0,3164,0,'LMT'),(52,1,7200,1,'CEST'),(52,2,3600,0,'CET'),(52,3,7200,0,'EET'),(53,0,2444,0,'LMT'),(53,1,561,0,'PMT'),(53,2,7200,1,'CEST'),(53,3,3600,0,'CET'),(53,4,3600,0,'CET'),(53,5,7200,1,'CEST'),(54,0,4104,0,'LMT'),(54,1,5400,0,'+0130'),(54,2,7200,0,'SAST'),(54,3,10800,1,'SAST'),(54,4,7200,0,'CAT'),(54,5,3600,0,'WAT'),(54,6,7200,1,'CAT'),(54,7,7200,0,'CAT'),(55,0,-42398,0,'LMT'),(55,1,-39600,0,'NST'),(55,2,-36000,1,'NWT'),(55,3,-36000,1,'NPT'),(55,4,-39600,0,'BST'),(55,5,-36000,1,'BDT'),(55,6,-36000,0,'AHST'),(55,7,-32400,1,'HDT'),(55,8,-36000,0,'HST'),(56,0,-35976,0,'LMT'),(56,1,-36000,0,'AST'),(56,2,-32400,1,'AWT'),(56,3,-32400,1,'APT'),(56,4,-36000,0,'AHST'),(56,5,-32400,1,'AHDT'),(56,6,-32400,0,'YST'),(56,7,-28800,1,'AKDT'),(56,8,-32400,0,'AKST'),(57,0,-15865,0,'LMT'),(57,1,-14400,0,'AST'),(57,2,-10800,1,'APT'),(57,3,-10800,1,'AWT'),(58,0,-15865,0,'LMT'),(58,1,-14400,0,'AST'),(58,2,-10800,1,'APT'),(58,3,-10800,1,'AWT'),(59,0,-11568,0,'LMT'),(59,1,-7200,1,'-02'),(59,2,-10800,0,'-03'),(60,0,-14028,0,'LMT'),(60,1,-15408,0,'CMT'),(60,2,-14400,0,'-04'),(60,3,-10800,1,'-03'),(60,4,-7200,1,'-02'),(60,5,-10800,0,'-03'),(61,0,-15788,0,'LMT'),(61,1,-15408,0,'CMT'),(61,2,-14400,0,'-04'),(61,3,-10800,1,'-03'),(61,4,-7200,1,'-02'),(61,5,-10800,0,'-03'),(62,0,-15788,0,'LMT'),(62,1,-15408,0,'CMT'),(62,2,-14400,0,'-04'),(62,3,-10800,1,'-03'),(62,4,-7200,1,'-02'),(62,5,-10800,0,'-03'),(63,0,-15408,0,'LMT'),(63,1,-15408,0,'CMT'),(63,2,-14400,0,'-04'),(63,3,-10800,1,'-03'),(63,4,-7200,1,'-02'),(63,5,-10800,0,'-03'),(64,0,-15672,0,'LMT'),(64,1,-15408,0,'CMT'),(64,2,-14400,0,'-04'),(64,3,-10800,1,'-03'),(64,4,-7200,1,'-02'),(64,5,-10800,0,'-03'),(65,0,-16044,0,'LMT'),(65,1,-15408,0,'CMT'),(65,2,-14400,0,'-04'),(65,3,-10800,1,'-03'),(65,4,-7200,1,'-02'),(65,5,-10800,0,'-03'),(66,0,-16516,0,'LMT'),(66,1,-15408,0,'CMT'),(66,2,-14400,0,'-04'),(66,3,-10800,1,'-03'),(66,4,-7200,1,'-02'),(66,5,-10800,0,'-03'),(67,0,-16612,0,'LMT'),(67,1,-15408,0,'CMT'),(67,2,-14400,0,'-04'),(67,3,-10800,1,'-03'),(67,4,-7200,1,'-02'),(67,5,-10800,0,'-03'),(68,0,-15700,0,'LMT'),(68,1,-15408,0,'CMT'),(68,2,-14400,0,'-04'),(68,3,-10800,1,'-03'),(68,4,-7200,1,'-02'),(68,5,-10800,0,'-03'),(69,0,-16444,0,'LMT'),(69,1,-15408,0,'CMT'),(69,2,-14400,0,'-04'),(69,3,-10800,1,'-03'),(69,4,-7200,1,'-02'),(69,5,-10800,0,'-03'),(70,0,-15924,0,'LMT'),(70,1,-15408,0,'CMT'),(70,2,-14400,0,'-04'),(70,3,-10800,1,'-03'),(70,4,-7200,1,'-02'),(70,5,-10800,0,'-03'),(70,6,-10800,1,'-03'),(71,0,-15652,0,'LMT'),(71,1,-15408,0,'CMT'),(71,2,-14400,0,'-04'),(71,3,-10800,1,'-03'),(71,4,-7200,1,'-02'),(71,5,-10800,0,'-03'),(72,0,-16392,0,'LMT'),(72,1,-15408,0,'CMT'),(72,2,-14400,0,'-04'),(72,3,-10800,1,'-03'),(72,4,-7200,1,'-02'),(72,5,-10800,0,'-03'),(73,0,-15865,0,'LMT'),(73,1,-14400,0,'AST'),(73,2,-10800,1,'APT'),(73,3,-10800,1,'AWT'),(74,0,-13840,0,'LMT'),(74,1,-13840,0,'AMT'),(74,2,-14400,0,'-04'),(74,3,-10800,0,'-03'),(74,4,-10800,1,'-03'),(74,5,-14400,0,'-04'),(75,0,-19088,0,'LMT'),(75,1,-19176,0,'CMT'),(75,2,-18000,0,'EST'),(76,0,-42398,0,'LMT'),(76,1,-39600,0,'NST'),(76,2,-36000,1,'NWT'),(76,3,-36000,1,'NPT'),(76,4,-39600,0,'BST'),(76,5,-36000,1,'BDT'),(76,6,-36000,0,'AHST'),(76,7,-32400,1,'HDT'),(76,8,-36000,0,'HST'),(77,0,-9244,0,'LMT'),(77,1,-7200,1,'-02'),(77,2,-10800,0,'-03'),(78,0,-25260,0,'LMT'),(78,1,-25200,0,'MST'),(78,2,-21600,0,'CST'),(78,3,-21600,1,'MDT'),(78,4,-25200,0,'MST'),(78,5,-28800,0,'PST'),(78,6,-18000,1,'CDT'),(78,7,-21600,0,'CST'),(79,0,-14309,0,'LMT'),(79,1,-10800,1,'ADT'),(79,2,-14400,0,'AST'),(79,3,-14400,0,'AST'),(79,4,-12600,1,'-0330'),(79,5,-10800,1,'ADT'),(80,0,-11636,0,'LMT'),(80,1,-7200,1,'-02'),(80,2,-10800,0,'-03'),(81,0,-21168,0,'LMT'),(81,1,-19800,1,'-0530'),(81,2,-21600,0,'CST'),(81,3,-18000,1,'CWT'),(81,4,-18000,1,'CPT'),(81,5,-18000,1,'CDT'),(82,0,-15865,0,'LMT'),(82,1,-14400,0,'AST'),(82,2,-10800,1,'APT'),(82,3,-10800,1,'AWT'),(83,0,-14560,0,'LMT'),(83,1,-10800,1,'-03'),(83,2,-14400,0,'-04'),(84,0,-17776,0,'LMT'),(84,1,-17776,0,'BMT'),(84,2,-14400,1,'-04'),(84,3,-18000,0,'-05'),(85,0,-27889,0,'LMT'),(85,1,-25200,1,'PDT'),(85,2,-28800,0,'PST'),(85,3,-28800,0,'PST'),(85,4,-21600,1,'MWT'),(85,5,-21600,1,'MPT'),(85,6,-25200,0,'MST'),(85,7,-21600,1,'MDT'),(86,0,-14028,0,'LMT'),(86,1,-15408,0,'CMT'),(86,2,-14400,0,'-04'),(86,3,-10800,1,'-03'),(86,4,-7200,1,'-02'),(86,5,-10800,0,'-03'),(87,0,0,0,'-00'),(87,1,-21600,1,'MWT'),(87,2,-21600,1,'MPT'),(87,3,-25200,0,'MST'),(87,4,-21600,1,'MDT'),(87,5,-18000,1,'CDT'),(87,6,-21600,0,'CST'),(87,7,-18000,0,'EST'),(87,8,-21600,1,'MDT'),(87,9,-25200,0,'MST'),(88,0,-13108,0,'LMT'),(88,1,-10800,1,'-03'),(88,2,-14400,0,'-04'),(89,0,-20824,0,'LMT'),(89,1,-21600,0,'CST'),(89,2,-14400,1,'EDT'),(89,3,-18000,0,'EST'),(89,4,-21600,0,'CST'),(89,5,-18000,1,'CDT'),(89,6,-18000,0,'EST'),(90,0,-16064,0,'LMT'),(90,1,-16060,0,'CMT'),(90,2,-16200,0,'-0430'),(90,3,-14400,0,'-04'),(91,0,-15788,0,'LMT'),(91,1,-15408,0,'CMT'),(91,2,-14400,0,'-04'),(91,3,-10800,1,'-03'),(91,4,-7200,1,'-02'),(91,5,-10800,0,'-03'),(92,0,-12560,0,'LMT'),(92,1,-14400,0,'-04'),(92,2,-10800,0,'-03'),(93,0,-19088,0,'LMT'),(93,1,-19176,0,'CMT'),(93,2,-18000,0,'EST'),(94,0,-21036,0,'LMT'),(94,1,-18000,1,'CDT'),(94,2,-21600,0,'CST'),(94,3,-21600,0,'CST'),(94,4,-18000,0,'EST'),(94,5,-18000,1,'CWT'),(94,6,-18000,1,'CPT'),(94,7,-21600,0,'CST'),(95,0,-25460,0,'LMT'),(95,1,-25200,0,'MST'),(95,2,-21600,0,'CST'),(95,3,-21600,1,'MDT'),(95,4,-25200,0,'MST'),(95,5,-18000,1,'CDT'),(95,6,-21600,1,'MDT'),(95,7,-21600,0,'CST'),(96,0,-25556,0,'LMT'),(96,1,-25200,0,'MST'),(96,2,-21600,0,'CST'),(96,3,-21600,1,'MDT'),(96,4,-25200,0,'MST'),(96,5,-18000,1,'CDT'),(96,6,-21600,1,'MDT'),(97,0,-19088,0,'LMT'),(97,1,-19176,0,'CMT'),(97,2,-18000,0,'EST'),(98,0,-15408,0,'LMT'),(98,1,-15408,0,'CMT'),(98,2,-14400,0,'-04'),(98,3,-10800,1,'-03'),(98,4,-7200,1,'-02'),(98,5,-10800,0,'-03'),(99,0,-20173,0,'LMT'),(99,1,-20173,0,'SJMT'),(99,2,-18000,1,'CDT'),(99,3,-21600,0,'CST'),(100,0,-26898,0,'LMT'),(100,1,-21600,1,'MDT'),(100,2,-25200,0,'MST'),(100,3,-21600,1,'MWT'),(100,4,-25200,0,'MST'),(101,0,-13460,0,'LMT'),(101,1,-10800,1,'-03'),(101,2,-14400,0,'-04'),(102,0,-15865,0,'LMT'),(102,1,-14400,0,'AST'),(102,2,-10800,1,'APT'),(102,3,-10800,1,'AWT'),(103,0,-4480,0,'LMT'),(103,1,-10800,0,'-03'),(103,2,-10800,0,'-03'),(103,3,-7200,1,'-02'),(103,4,-7200,1,'-02'),(103,5,0,0,'GMT'),(104,0,-33460,0,'LMT'),(104,1,-28800,1,'YDT'),(104,2,-32400,0,'YST'),(104,3,-28800,1,'YWT'),(104,4,-28800,1,'YPT'),(104,5,-25200,1,'YDDT'),(104,6,-28800,0,'PST'),(104,7,-25200,1,'PDT'),(104,8,-25200,0,'MST'),(105,0,-28856,0,'LMT'),(105,1,-25200,1,'PDT'),(105,2,-28800,0,'PST'),(105,3,-25200,1,'PWT'),(105,4,-25200,1,'PPT'),(105,5,-25200,0,'MST'),(106,0,-25196,0,'LMT'),(106,1,-21600,1,'MDT'),(106,2,-25200,0,'MST'),(106,3,-25200,0,'MST'),(106,4,-21600,1,'MWT'),(106,5,-21600,1,'MPT'),(107,0,-19931,0,'LMT'),(107,1,-21600,0,'CST'),(107,2,-18000,0,'EST'),(107,3,-14400,1,'EWT'),(107,4,-14400,1,'EPT'),(107,5,-14400,1,'EDT'),(108,0,-15865,0,'LMT'),(108,1,-14400,0,'AST'),(108,2,-10800,1,'APT'),(108,3,-10800,1,'AWT'),(109,0,-27232,0,'LMT'),(109,1,-21600,1,'MDT'),(109,2,-25200,0,'MST'),(109,3,-21600,1,'MWT'),(109,4,-21600,1,'MPT'),(110,0,-16768,0,'LMT'),(110,1,-14400,1,'-04'),(110,2,-18000,0,'-05'),(110,3,-14400,0,'-04'),(110,4,-18000,0,'-05'),(111,0,-21408,0,'LMT'),(111,1,-18000,1,'CDT'),(111,2,-21600,0,'CST'),(112,0,-28084,0,'LMT'),(112,1,-25200,0,'MST'),(112,2,-28800,0,'PST'),(112,3,-25200,0,'MST'),(112,4,-25200,1,'PDT'),(112,5,-25200,1,'PWT'),(112,6,-25200,1,'PPT'),(112,7,-28800,0,'PST'),(113,0,-29447,0,'LMT'),(113,1,-25200,1,'PDT'),(113,2,-28800,0,'PST'),(113,3,-25200,1,'PWT'),(113,4,-25200,1,'PPT'),(113,5,-25200,0,'MST'),(114,0,-20678,0,'LMT'),(114,1,-18000,1,'CDT'),(114,2,-21600,0,'CST'),(114,3,-21600,0,'CST'),(114,4,-18000,1,'CWT'),(114,5,-18000,1,'CPT'),(114,6,-18000,0,'EST'),(114,7,-14400,1,'EDT'),(115,0,-9240,0,'LMT'),(115,1,-7200,1,'-02'),(115,2,-10800,0,'-03'),(116,0,-14388,0,'LMT'),(116,1,-10800,1,'ADT'),(116,2,-14400,0,'AST'),(116,3,-10800,1,'AWT'),(116,4,-10800,1,'APT'),(117,0,-12416,0,'LMT'),(117,1,-10800,0,'-03'),(117,2,-10800,0,'-03'),(117,3,-7200,1,'-02'),(117,4,-7200,1,'-02'),(117,5,-7200,0,'-02'),(117,6,-3600,1,'-01'),(118,0,-14500,0,'LMT'),(118,1,-12652,0,'NST'),(118,2,-9052,1,'NDT'),(118,3,-12600,0,'NST'),(118,4,-9000,1,'NDT'),(118,5,-9000,1,'NPT'),(118,6,-9000,1,'NWT'),(118,7,-10800,1,'ADT'),(118,8,-14400,0,'AST'),(118,9,-7200,1,'ADDT'),(118,10,-10800,1,'ADT'),(119,0,-17072,0,'LMT'),(119,1,-18430,0,'KMT'),(119,2,-18000,0,'EST'),(119,3,-14400,1,'EDT'),(119,4,-14400,0,'AST'),(119,5,-18000,0,'EST'),(120,0,-15865,0,'LMT'),(120,1,-14400,0,'AST'),(120,2,-10800,1,'APT'),(120,3,-10800,1,'AWT'),(121,0,-15865,0,'LMT'),(121,1,-14400,0,'AST'),(121,2,-10800,1,'APT'),(121,3,-10800,1,'AWT'),(122,0,-21724,0,'LMT'),(122,1,-18000,1,'CDT'),(122,2,-21600,0,'CST'),(123,0,-19160,0,'LMT'),(123,1,-18840,0,'QMT'),(123,2,-14400,1,'-04'),(123,3,-18000,0,'-05'),(124,0,-13959,0,'LMT'),(124,1,-14400,0,'-04'),(124,2,-13500,0,'-0345'),(124,3,-10800,0,'-03'),(124,4,-14400,0,'-04'),(125,0,-15264,0,'LMT'),(125,1,-10800,1,'ADT'),(125,2,-14400,0,'AST'),(125,3,-10800,1,'AWT'),(125,4,-10800,1,'APT'),(126,0,-19768,0,'LMT'),(126,1,-19776,0,'HMT'),(126,2,-14400,1,'CDT'),(126,3,-18000,0,'CST'),(126,4,-18000,0,'CST'),(126,5,-14400,1,'CDT'),(127,0,-26632,0,'LMT'),(127,1,-25200,0,'MST'),(127,2,-21600,0,'CST'),(127,3,-21600,1,'MDT'),(127,4,-25200,0,'MST'),(127,5,-28800,0,'PST'),(127,6,-25200,0,'MST'),(128,0,-20678,0,'LMT'),(128,1,-18000,1,'CDT'),(128,2,-21600,0,'CST'),(128,3,-21600,0,'CST'),(128,4,-18000,1,'CWT'),(128,5,-18000,1,'CPT'),(128,6,-18000,0,'EST'),(128,7,-14400,1,'EDT'),(129,0,-20790,0,'LMT'),(129,1,-18000,1,'CDT'),(129,2,-21600,0,'CST'),(129,3,-18000,1,'CWT'),(129,4,-18000,1,'CPT'),(129,5,-21600,0,'CST'),(129,6,-18000,0,'EST'),(129,7,-21600,0,'CST'),(130,0,-20723,0,'LMT'),(130,1,-18000,1,'CDT'),(130,2,-21600,0,'CST'),(130,3,-18000,1,'CWT'),(130,4,-18000,1,'CPT'),(130,5,-21600,0,'CST'),(130,6,-18000,0,'EST'),(130,7,-14400,1,'EDT'),(131,0,-20947,0,'LMT'),(131,1,-18000,1,'CDT'),(131,2,-21600,0,'CST'),(131,3,-18000,1,'CWT'),(131,4,-18000,1,'CPT'),(131,5,-21600,0,'CST'),(131,6,-18000,0,'EST'),(131,7,-14400,1,'EDT'),(132,0,-20823,0,'LMT'),(132,1,-18000,1,'CDT'),(132,2,-21600,0,'CST'),(132,3,-18000,1,'CWT'),(132,4,-18000,1,'CPT'),(132,5,-21600,0,'CST'),(132,6,-18000,0,'EST'),(132,7,-14400,1,'EDT'),(132,8,-18000,1,'CDT'),(132,9,-21600,0,'CST'),(133,0,-20416,0,'LMT'),(133,1,-18000,1,'CDT'),(133,2,-21600,0,'CST'),(133,3,-18000,1,'CWT'),(133,4,-18000,1,'CPT'),(133,5,-21600,0,'CST'),(133,6,-18000,0,'EST'),(133,7,-14400,1,'EDT'),(134,0,-21007,0,'LMT'),(134,1,-18000,1,'CDT'),(134,2,-21600,0,'CST'),(134,3,-18000,1,'CWT'),(134,4,-18000,1,'CPT'),(134,5,-21600,0,'CST'),(134,6,-18000,0,'EST'),(134,7,-14400,1,'EDT'),(135,0,-20785,0,'LMT'),(135,1,-18000,1,'CDT'),(135,2,-21600,0,'CST'),(135,3,-18000,1,'CWT'),(135,4,-18000,1,'CPT'),(135,5,-21600,0,'CST'),(135,6,-18000,0,'EST'),(135,7,-14400,1,'EDT'),(136,0,-20678,0,'LMT'),(136,1,-18000,1,'CDT'),(136,2,-21600,0,'CST'),(136,3,-21600,0,'CST'),(136,4,-18000,1,'CWT'),(136,5,-18000,1,'CPT'),(136,6,-18000,0,'EST'),(136,7,-14400,1,'EDT'),(137,0,0,0,'-00'),(137,1,-25200,1,'PDT'),(137,2,-28800,0,'PST'),(137,3,-25200,0,'MST'),(137,4,-21600,1,'MDT'),(138,0,0,0,'-00'),(138,1,-14400,1,'EPT'),(138,2,-18000,0,'EST'),(138,3,-14400,1,'EDT'),(138,4,-14400,1,'EWT'),(138,5,-21600,0,'CST'),(138,6,-18000,1,'CDT'),(138,7,-14400,1,'EDT'),(138,8,-18000,0,'EST'),(139,0,-18430,0,'LMT'),(139,1,-18430,0,'KMT'),(139,2,-18000,0,'EST'),(139,3,-14400,1,'EDT'),(140,0,-15672,0,'LMT'),(140,1,-15408,0,'CMT'),(140,2,-14400,0,'-04'),(140,3,-10800,1,'-03'),(140,4,-7200,1,'-02'),(140,5,-10800,0,'-03'),(141,0,-32261,0,'LMT'),(141,1,-28800,0,'PST'),(141,2,-25200,1,'PWT'),(141,3,-25200,1,'PPT'),(141,4,-25200,1,'PDT'),(141,5,-28800,1,'YDT'),(141,6,-32400,0,'YST'),(141,7,-28800,1,'AKDT'),(141,8,-32400,0,'AKST'),(142,0,-20582,0,'LMT'),(142,1,-18000,1,'CDT'),(142,2,-21600,0,'CST'),(142,3,-21600,0,'CST'),(142,4,-18000,1,'CWT'),(142,5,-18000,1,'CPT'),(142,6,-18000,0,'EST'),(142,7,-14400,1,'EDT'),(143,0,-20364,0,'LMT'),(143,1,-18000,1,'CDT'),(143,2,-21600,0,'CST'),(143,3,-18000,1,'CWT'),(143,4,-18000,1,'CPT'),(143,5,-21600,0,'CST'),(143,6,-14400,1,'EDT'),(143,7,-18000,0,'EST'),(144,0,-20790,0,'LMT'),(144,1,-18000,1,'CDT'),(144,2,-21600,0,'CST'),(144,3,-18000,1,'CWT'),(144,4,-18000,1,'CPT'),(144,5,-21600,0,'CST'),(144,6,-18000,0,'EST'),(144,7,-21600,0,'CST'),(145,0,-15865,0,'LMT'),(145,1,-14400,0,'AST'),(145,2,-10800,1,'APT'),(145,3,-10800,1,'AWT'),(146,0,-16356,0,'LMT'),(146,1,-16356,0,'CMT'),(146,2,-12756,1,'BST'),(146,3,-14400,0,'-04'),(147,0,-18492,0,'LMT'),(147,1,-18516,0,'LMT'),(147,2,-14400,1,'-04'),(147,3,-18000,0,'-05'),(148,0,-28378,0,'LMT'),(148,1,-25200,1,'PDT'),(148,2,-28800,0,'PST'),(148,3,-25200,1,'PWT'),(148,4,-25200,1,'PPT'),(148,5,-28800,0,'PST'),(149,0,-20582,0,'LMT'),(149,1,-18000,1,'CDT'),(149,2,-21600,0,'CST'),(149,3,-21600,0,'CST'),(149,4,-18000,1,'CWT'),(149,5,-18000,1,'CPT'),(149,6,-18000,0,'EST'),(149,7,-14400,1,'EDT'),(150,0,-15865,0,'LMT'),(150,1,-14400,0,'AST'),(150,2,-10800,1,'APT'),(150,3,-10800,1,'AWT'),(151,0,-8572,0,'LMT'),(151,1,-7200,1,'-02'),(151,2,-10800,0,'-03'),(152,0,-20708,0,'LMT'),(152,1,-20712,0,'MMT'),(152,2,-21600,0,'CST'),(152,3,-18000,0,'EST'),(152,4,-18000,1,'CDT'),(152,5,-21600,0,'CST'),(153,0,-14404,0,'LMT'),(153,1,-10800,1,'-03'),(153,2,-14400,0,'-04'),(154,0,-15865,0,'LMT'),(154,1,-14400,0,'AST'),(154,2,-10800,1,'APT'),(154,3,-10800,1,'AWT'),(155,0,-14660,0,'LMT'),(155,1,-14660,0,'FFMT'),(155,2,-14400,0,'AST'),(155,3,-10800,1,'ADT'),(156,0,-23400,0,'LMT'),(156,1,-21600,0,'CST'),(156,2,-18000,1,'CDT'),(156,3,-21600,0,'CST'),(157,0,-25540,0,'LMT'),(157,1,-25200,0,'MST'),(157,2,-21600,0,'CST'),(157,3,-21600,1,'MDT'),(157,4,-25200,0,'MST'),(157,5,-28800,0,'PST'),(157,6,-25200,0,'MST'),(158,0,-16516,0,'LMT'),(158,1,-15408,0,'CMT'),(158,2,-14400,0,'-04'),(158,3,-10800,1,'-03'),(158,4,-7200,1,'-02'),(158,5,-10800,0,'-03'),(159,0,-21027,0,'LMT'),(159,1,-18000,1,'CDT'),(159,2,-21600,0,'CST'),(159,3,-18000,1,'CWT'),(159,4,-18000,1,'CPT'),(159,5,-18000,0,'EST'),(159,6,-21600,0,'CST'),(160,0,-21508,0,'LMT'),(160,1,-21600,0,'CST'),(160,2,-18000,0,'EST'),(160,3,-18000,1,'CDT'),(160,4,-21600,0,'CST'),(161,0,-31578,0,'LMT'),(161,1,-28800,0,'PST'),(161,2,-25200,1,'PWT'),(161,3,-25200,1,'PPT'),(161,4,-25200,1,'PDT'),(161,5,-32400,0,'AKST'),(161,6,-28800,1,'AKDT'),(162,0,-23796,0,'LMT'),(162,1,-25200,0,'MST'),(162,2,-21600,0,'CST'),(162,3,-21600,1,'MDT'),(162,4,-25200,0,'MST'),(162,5,-18000,1,'CDT'),(162,6,-18000,1,'CWT'),(162,7,-21600,0,'CST'),(163,0,-13480,0,'LMT'),(163,1,-14400,0,'AST'),(163,2,-10800,0,'-03'),(163,3,-7200,1,'-02'),(164,0,-15548,0,'LMT'),(164,1,-18000,0,'EST'),(164,2,-10800,1,'ADT'),(164,3,-14400,0,'AST'),(164,4,-10800,1,'AWT'),(164,5,-10800,1,'APT'),(165,0,-24076,0,'LMT'),(165,1,-21600,0,'CST'),(165,2,-18000,1,'CDT'),(165,3,-21600,0,'CST'),(166,0,-13491,0,'LMT'),(166,1,-13491,0,'MMT'),(166,2,-14400,0,'-04'),(166,3,-12600,0,'-0330'),(166,4,-10800,1,'-03'),(166,5,-10800,0,'-03'),(166,6,-9000,1,'-0230'),(166,7,-7200,1,'-02'),(166,8,-5400,1,'-0130'),(166,9,-7200,1,'-02'),(167,0,-19052,0,'LMT'),(167,1,-14400,1,'EDT'),(167,2,-18000,0,'EST'),(167,3,-14400,1,'EWT'),(167,4,-14400,1,'EPT'),(168,0,-15865,0,'LMT'),(168,1,-14400,0,'AST'),(168,2,-10800,1,'APT'),(168,3,-10800,1,'AWT'),(169,0,-19052,0,'LMT'),(169,1,-14400,1,'EDT'),(169,2,-18000,0,'EST'),(169,3,-14400,1,'EWT'),(169,4,-14400,1,'EPT'),(170,0,-17762,0,'LMT'),(170,1,-14400,1,'EDT'),(170,2,-18000,0,'EST'),(170,3,-18000,0,'EST'),(170,4,-14400,1,'EWT'),(170,5,-14400,1,'EPT'),(171,0,-19052,0,'LMT'),(171,1,-14400,1,'EDT'),(171,2,-18000,0,'EST'),(171,3,-14400,1,'EWT'),(171,4,-14400,1,'EPT'),(172,0,-39698,0,'LMT'),(172,1,-39600,0,'NST'),(172,2,-36000,1,'NWT'),(172,3,-36000,1,'NPT'),(172,4,-39600,0,'BST'),(172,5,-36000,1,'BDT'),(172,6,-32400,0,'YST'),(172,7,-28800,1,'AKDT'),(172,8,-32400,0,'AKST'),(173,0,-7780,0,'LMT'),(173,1,-3600,1,'-01'),(173,2,-7200,0,'-02'),(174,0,-24427,0,'LMT'),(174,1,-21600,1,'MDT'),(174,2,-25200,0,'MST'),(174,3,-21600,1,'MWT'),(174,4,-21600,1,'MPT'),(174,5,-25200,0,'MST'),(174,6,-18000,1,'CDT'),(174,7,-21600,0,'CST'),(175,0,-24312,0,'LMT'),(175,1,-21600,1,'MDT'),(175,2,-25200,0,'MST'),(175,3,-21600,1,'MWT'),(175,4,-21600,1,'MPT'),(175,5,-25200,0,'MST'),(175,6,-18000,1,'CDT'),(175,7,-21600,0,'CST'),(176,0,-24339,0,'LMT'),(176,1,-21600,1,'MDT'),(176,2,-25200,0,'MST'),(176,3,-21600,1,'MWT'),(176,4,-21600,1,'MPT'),(176,5,-25200,0,'MST'),(176,6,-18000,1,'CDT'),(176,7,-21600,0,'CST'),(177,0,-12416,0,'LMT'),(177,1,-10800,0,'-03'),(177,2,-10800,0,'-03'),(177,3,-7200,1,'-02'),(177,4,-7200,1,'-02'),(177,5,-7200,0,'-02'),(177,6,-3600,1,'-01'),(178,0,-25060,0,'LMT'),(178,1,-25200,0,'MST'),(178,2,-21600,0,'CST'),(178,3,-21600,1,'MDT'),(178,4,-25200,0,'MST'),(178,5,-18000,1,'CDT'),(178,6,-21600,0,'CST'),(179,0,-19088,0,'LMT'),(179,1,-19176,0,'CMT'),(179,2,-18000,0,'EST'),(180,0,0,0,'-00'),(180,1,-14400,1,'EPT'),(180,2,-18000,0,'EST'),(180,3,-14400,1,'EDT'),(180,4,-14400,1,'EWT'),(180,5,-21600,0,'CST'),(180,6,-18000,1,'CDT'),(180,7,-14400,1,'EDT'),(180,8,-18000,0,'EST'),(181,0,-13240,0,'LMT'),(181,1,-13252,0,'PMT'),(181,2,-13236,0,'PMT'),(181,3,-12600,0,'-0330'),(181,4,-10800,0,'-03'),(182,0,-26898,0,'LMT'),(182,1,-21600,1,'MDT'),(182,2,-25200,0,'MST'),(182,3,-21600,1,'MWT'),(182,4,-25200,0,'MST'),(183,0,-17360,0,'LMT'),(183,1,-17340,0,'PPMT'),(183,2,-14400,1,'EDT'),(183,3,-18000,0,'EST'),(183,4,-14400,1,'EDT'),(183,5,-18000,0,'EST'),(184,0,-15865,0,'LMT'),(184,1,-14400,0,'AST'),(184,2,-10800,1,'APT'),(184,3,-10800,1,'AWT'),(185,0,-16272,0,'LMT'),(185,1,-14400,1,'-04'),(185,2,-18000,0,'-05'),(185,3,-14400,0,'-04'),(185,4,-18000,0,'-05'),(186,0,-15336,0,'LMT'),(186,1,-10800,1,'-03'),(186,2,-14400,0,'-04'),(187,0,-15865,0,'LMT'),(187,1,-14400,0,'AST'),(187,2,-10800,1,'APT'),(187,3,-10800,1,'AWT'),(188,0,-17020,0,'LMT'),(188,1,-16965,0,'SMT'),(188,2,-18000,0,'-05'),(188,3,-14400,0,'-04'),(188,4,-14400,1,'-04'),(188,5,-10800,1,'-03'),(188,6,-14400,0,'-04'),(188,7,-10800,0,'-03'),(189,0,-23316,0,'LMT'),(189,1,-18000,1,'CDT'),(189,2,-21600,0,'CST'),(189,3,-18000,1,'CWT'),(189,4,-18000,1,'CPT'),(189,5,-18000,1,'CDT'),(189,6,-21600,0,'CST'),(190,0,0,0,'-00'),(190,1,-18000,1,'CDT'),(190,2,-21600,0,'CST'),(190,3,-18000,0,'EST'),(190,4,-21600,0,'CST'),(191,0,-8376,0,'LMT'),(191,1,-7200,1,'-02'),(191,2,-10800,0,'-03'),(192,0,-25116,0,'LMT'),(192,1,-21600,1,'MDT'),(192,2,-25200,0,'MST'),(192,3,-21600,1,'MWT'),(192,4,-21600,1,'MPT'),(192,5,-21600,0,'CST'),(193,0,0,0,'-00'),(193,1,-18000,1,'CDT'),(193,2,-21600,0,'CST'),(193,3,-18000,0,'EST'),(193,4,-21600,0,'CST'),(194,0,-16272,0,'LMT'),(194,1,-14400,1,'-04'),(194,2,-18000,0,'-05'),(194,3,-14400,0,'-04'),(194,4,-18000,0,'-05'),(195,0,-15408,0,'LMT'),(195,1,-15408,0,'CMT'),(195,2,-14400,0,'-04'),(195,3,-10800,1,'-03'),(195,4,-7200,1,'-02'),(195,5,-10800,0,'-03'),(196,0,-28084,0,'LMT'),(196,1,-25200,0,'MST'),(196,2,-28800,0,'PST'),(196,3,-25200,0,'MST'),(196,4,-25200,1,'PDT'),(196,5,-25200,1,'PWT'),(196,6,-25200,1,'PPT'),(196,7,-28800,0,'PST'),(197,0,-13128,0,'LMT'),(197,1,-10800,1,'-03'),(197,2,-14400,0,'-04'),(197,3,-10800,0,'-03'),(198,0,-16965,0,'LMT'),(198,1,-16965,0,'SMT'),(198,2,-18000,0,'-05'),(198,3,-14400,0,'-04'),(198,4,-14400,1,'-04'),(198,5,-10800,1,'-03'),(198,6,-10800,1,'-03'),(198,7,-14400,0,'-04'),(199,0,-16776,0,'LMT'),(199,1,-16800,0,'SDMT'),(199,2,-14400,1,'EDT'),(199,3,-18000,0,'EST'),(199,4,-16200,1,'-0430'),(199,5,-14400,0,'AST'),(200,0,-11188,0,'LMT'),(200,1,-7200,1,'-02'),(200,2,-10800,0,'-03'),(201,0,-5272,0,'LMT'),(201,1,-7200,0,'-02'),(201,2,-3600,1,'-01'),(201,3,-7200,0,'-02'),(201,4,-3600,0,'-01'),(201,5,0,1,'+00'),(201,6,0,1,'+00'),(202,0,-25196,0,'LMT'),(202,1,-21600,1,'MDT'),(202,2,-25200,0,'MST'),(202,3,-25200,0,'MST'),(202,4,-21600,1,'MWT'),(202,5,-21600,1,'MPT'),(203,0,-32473,0,'LMT'),(203,1,-28800,0,'PST'),(203,2,-25200,1,'PWT'),(203,3,-25200,1,'PPT'),(203,4,-25200,1,'PDT'),(203,5,-32400,0,'YST'),(203,6,-28800,1,'AKDT'),(203,7,-32400,0,'AKST'),(204,0,-15865,0,'LMT'),(204,1,-14400,0,'AST'),(204,2,-10800,1,'APT'),(204,3,-10800,1,'AWT'),(205,0,-12652,0,'LMT'),(205,1,-9052,1,'NDT'),(205,2,-12652,0,'NST'),(205,3,-9000,1,'NDT'),(205,4,-12600,0,'NST'),(205,5,-9000,1,'NPT'),(205,6,-9000,1,'NWT'),(205,7,-5400,1,'NDDT'),(205,8,-9000,1,'NDT'),(206,0,-15865,0,'LMT'),(206,1,-14400,0,'AST'),(206,2,-10800,1,'APT'),(206,3,-10800,1,'AWT'),(207,0,-15865,0,'LMT'),(207,1,-14400,0,'AST'),(207,2,-10800,1,'APT'),(207,3,-10800,1,'AWT'),(208,0,-15865,0,'LMT'),(208,1,-14400,0,'AST'),(208,2,-10800,1,'APT'),(208,3,-10800,1,'AWT'),(209,0,-15865,0,'LMT'),(209,1,-14400,0,'AST'),(209,2,-10800,1,'APT'),(209,3,-10800,1,'AWT'),(210,0,-25880,0,'LMT'),(210,1,-21600,1,'MDT'),(210,2,-25200,0,'MST'),(210,3,-21600,1,'MWT'),(210,4,-21600,1,'MPT'),(210,5,-21600,0,'CST'),(211,0,-20932,0,'LMT'),(211,1,-18000,1,'CDT'),(211,2,-21600,0,'CST'),(212,0,-16508,0,'LMT'),(212,1,-10800,1,'ADT'),(212,2,-14400,0,'AST'),(213,0,-19052,0,'LMT'),(213,1,-14400,1,'EDT'),(213,2,-18000,0,'EST'),(213,3,-14400,1,'EWT'),(213,4,-14400,1,'EPT'),(214,0,-28084,0,'LMT'),(214,1,-25200,0,'MST'),(214,2,-28800,0,'PST'),(214,3,-25200,0,'MST'),(214,4,-25200,1,'PDT'),(214,5,-25200,1,'PWT'),(214,6,-25200,1,'PPT'),(214,7,-28800,0,'PST'),(215,0,-19052,0,'LMT'),(215,1,-14400,1,'EDT'),(215,2,-18000,0,'EST'),(215,3,-14400,1,'EWT'),(215,4,-14400,1,'EPT'),(216,0,-15865,0,'LMT'),(216,1,-14400,0,'AST'),(216,2,-10800,1,'APT'),(216,3,-10800,1,'AWT'),(217,0,-29548,0,'LMT'),(217,1,-25200,1,'PDT'),(217,2,-28800,0,'PST'),(217,3,-25200,1,'PWT'),(217,4,-25200,1,'PPT'),(218,0,-15865,0,'LMT'),(218,1,-14400,0,'AST'),(218,2,-10800,1,'APT'),(218,3,-10800,1,'AWT'),(219,0,-32412,0,'LMT'),(219,1,-28800,1,'YDT'),(219,2,-32400,0,'YST'),(219,3,-28800,1,'YWT'),(219,4,-28800,1,'YPT'),(219,5,-25200,1,'YDDT'),(219,6,-28800,0,'PST'),(219,7,-25200,1,'PDT'),(219,8,-25200,0,'MST'),(220,0,-23316,0,'LMT'),(220,1,-18000,1,'CDT'),(220,2,-21600,0,'CST'),(220,3,-18000,1,'CWT'),(220,4,-18000,1,'CPT'),(220,5,-18000,1,'CDT'),(220,6,-21600,0,'CST'),(221,0,-33535,0,'LMT'),(221,1,-32400,0,'YST'),(221,2,-28800,1,'YWT'),(221,3,-28800,1,'YPT'),(221,4,-28800,1,'YDT'),(221,5,-28800,1,'AKDT'),(221,6,-32400,0,'AKST'),(222,0,-27232,0,'LMT'),(222,1,-21600,1,'MDT'),(222,2,-25200,0,'MST'),(222,3,-21600,1,'MWT'),(222,4,-21600,1,'MPT'),(223,0,0,0,'-00'),(223,1,28800,0,'+08'),(223,2,39600,0,'+11'),(223,3,28800,0,'+08'),(223,4,39600,0,'+11'),(224,0,0,0,'-00'),(224,1,25200,0,'+07'),(224,2,18000,0,'+05'),(224,3,25200,0,'+07'),(225,0,35312,0,'PMMT'),(225,1,36000,0,'+10'),(226,0,0,0,'-00'),(226,1,36000,0,'AEST'),(226,2,39600,1,'AEDT'),(226,3,36000,0,'AEST'),(226,4,0,0,'-00'),(226,5,39600,1,'AEDT'),(226,6,36000,0,'AEST'),(227,0,0,0,'-00'),(227,1,21600,0,'+06'),(227,2,18000,0,'+05'),(228,0,41944,0,'LMT'),(228,1,45000,1,'NZST'),(228,2,41400,0,'NZMT'),(228,3,43200,1,'NZST'),(228,4,46800,1,'NZDT'),(228,5,43200,0,'NZST'),(228,6,43200,0,'NZST'),(229,0,0,0,'-00'),(229,1,-14400,0,'-04'),(229,2,-10800,1,'-03'),(229,3,-7200,1,'-02'),(229,4,-10800,0,'-03'),(229,5,-10800,1,'-03'),(229,6,-14400,0,'-04'),(229,7,-10800,0,'-03'),(230,0,0,0,'-00'),(230,1,-10800,0,'-03'),(231,0,41944,0,'LMT'),(231,1,45000,1,'NZST'),(231,2,41400,0,'NZMT'),(231,3,43200,1,'NZST'),(231,4,46800,1,'NZDT'),(231,5,43200,0,'NZST'),(231,6,43200,0,'NZST'),(232,0,11212,0,'LMT'),(232,1,10800,0,'+03'),(233,0,0,0,'-00'),(233,1,7200,1,'+02'),(233,2,0,0,'+00'),(233,3,0,0,'+00'),(234,0,21020,0,'LMT'),(234,1,21600,0,'+06'),(235,0,3208,0,'LMT'),(235,1,7200,1,'CEST'),(235,2,3600,0,'CET'),(235,3,7200,1,'CEST'),(235,4,3600,0,'CET'),(235,5,10800,1,'CEMT'),(235,6,10800,1,'CEMT'),(235,7,7200,1,'CEST'),(235,8,3600,0,'CET'),(236,0,11212,0,'LMT'),(236,1,10800,0,'+03'),(237,0,18468,0,'LMT'),(237,1,18000,0,'+05'),(237,2,25200,1,'+07'),(237,3,21600,0,'+06'),(237,4,21600,0,'+06'),(237,5,25200,1,'+07'),(237,6,21600,1,'+06'),(237,7,18000,0,'+05'),(237,8,25200,1,'+07'),(237,9,21600,0,'+06'),(238,0,8624,0,'LMT'),(238,1,10800,1,'EEST'),(238,2,7200,0,'EET'),(238,3,7200,0,'EET'),(238,4,10800,1,'EEST'),(238,5,10800,0,'+03'),(239,0,42596,0,'LMT'),(239,1,43200,0,'+12'),(239,2,50400,1,'+14'),(239,3,46800,0,'+13'),(239,4,46800,1,'+13'),(239,5,43200,0,'+12'),(239,6,46800,1,'+13'),(239,7,43200,1,'+12'),(239,8,39600,0,'+11'),(239,9,43200,0,'+12'),(240,0,12064,0,'LMT'),(240,1,14400,0,'+04'),(240,2,18000,0,'+05'),(240,3,21600,0,'+06'),(240,4,21600,1,'+06'),(240,5,18000,0,'+05'),(240,6,21600,1,'+06'),(240,7,18000,1,'+05'),(240,8,14400,0,'+04'),(240,9,18000,0,'+05'),(241,0,13720,0,'LMT'),(241,1,14400,0,'+04'),(241,2,18000,0,'+05'),(241,3,21600,1,'+06'),(241,4,21600,0,'+06'),(241,5,18000,0,'+05'),(241,6,21600,1,'+06'),(241,7,18000,1,'+05'),(241,8,14400,0,'+04'),(241,9,21600,1,'+06'),(241,10,18000,0,'+05'),(242,0,14012,0,'LMT'),(242,1,14400,0,'+04'),(242,2,21600,1,'+06'),(242,3,18000,0,'+05'),(242,4,18000,0,'+05'),(242,5,21600,1,'+06'),(242,6,18000,1,'+05'),(242,7,14400,0,'+04'),(242,8,18000,0,'+05'),(243,0,14012,0,'LMT'),(243,1,14400,0,'+04'),(243,2,21600,1,'+06'),(243,3,18000,0,'+05'),(243,4,18000,0,'+05'),(243,5,21600,1,'+06'),(243,6,18000,1,'+05'),(243,7,14400,0,'+04'),(243,8,18000,0,'+05'),(244,0,12464,0,'LMT'),(244,1,10800,0,'+03'),(244,2,18000,0,'+05'),(244,3,21600,0,'+06'),(244,4,21600,1,'+06'),(244,5,18000,0,'+05'),(244,6,21600,1,'+06'),(244,7,18000,1,'+05'),(244,8,14400,0,'+04'),(244,9,18000,0,'+05'),(245,0,10660,0,'LMT'),(245,1,10656,0,'BMT'),(245,2,10800,0,'+03'),(245,3,14400,1,'+04'),(245,4,10800,0,'+03'),(245,5,14400,1,'+04'),(246,0,12368,0,'LMT'),(246,1,14400,0,'+04'),(246,2,10800,0,'+03'),(247,0,11964,0,'LMT'),(247,1,10800,0,'+03'),(247,2,18000,1,'+05'),(247,3,14400,0,'+04'),(247,4,14400,0,'+04'),(247,5,18000,1,'+05'),(247,6,14400,1,'+04'),(247,7,10800,0,'+03'),(247,8,18000,1,'+05'),(247,9,14400,0,'+04'),(248,0,24124,0,'LMT'),(248,1,24124,0,'BMT'),(248,2,25200,0,'+07'),(249,0,20100,0,'LMT'),(249,1,21600,0,'+06'),(249,2,28800,1,'+08'),(249,3,25200,0,'+07'),(249,4,25200,0,'+07'),(249,5,28800,1,'+08'),(249,6,25200,1,'+07'),(249,7,21600,0,'+06'),(249,8,25200,1,'+07'),(249,9,25200,0,'+07'),(250,0,8520,0,'LMT'),(250,1,10800,1,'EEST'),(250,2,7200,0,'EET'),(251,0,17904,0,'LMT'),(251,1,18000,0,'+05'),(251,2,25200,1,'+07'),(251,3,21600,0,'+06'),(251,4,21600,0,'+06'),(251,5,25200,1,'+07'),(251,6,21600,1,'+06'),(251,7,18000,0,'+05'),(251,8,21600,1,'+06'),(251,9,21600,0,'+06'),(252,0,26480,0,'LMT'),(252,1,27000,0,'+0730'),(252,2,30000,1,'+0820'),(252,3,28800,0,'+08'),(252,4,32400,0,'+09'),(252,5,28800,0,'+08'),(253,0,21200,0,'HMT'),(253,1,19270,0,'MMT'),(253,2,19800,0,'IST'),(253,3,23400,1,'+0630'),(254,0,27232,0,'LMT'),(254,1,28800,0,'+08'),(254,2,36000,1,'+10'),(254,3,32400,0,'+09'),(254,4,32400,0,'+09'),(254,5,36000,1,'+10'),(254,6,32400,1,'+09'),(254,7,28800,0,'+08'),(254,8,36000,0,'+10'),(254,9,36000,1,'+10'),(254,10,32400,0,'+09'),(255,0,27480,0,'LMT'),(255,1,25200,0,'+07'),(255,2,28800,0,'+08'),(255,3,32400,0,'+09'),(255,4,36000,1,'+10'),(255,5,32400,1,'+09'),(255,6,28800,0,'+08'),(256,0,29143,0,'LMT'),(256,1,32400,1,'CDT'),(256,2,28800,0,'CST'),(257,0,29143,0,'LMT'),(257,1,32400,1,'CDT'),(257,2,28800,0,'CST'),(258,0,19164,0,'LMT'),(258,1,19172,0,'MMT'),(258,2,19800,0,'+0530'),(258,3,21600,1,'+06'),(258,4,23400,1,'+0630'),(258,5,23400,0,'+0630'),(258,6,21600,0,'+06'),(258,7,19800,0,'+0530'),(259,0,21700,0,'LMT'),(259,1,21200,0,'HMT'),(259,2,23400,0,'+0630'),(259,3,19800,0,'+0530'),(259,4,21600,0,'+06'),(259,5,25200,1,'+07'),(260,0,8712,0,'LMT'),(260,1,10800,1,'EEST'),(260,2,7200,0,'EET'),(260,3,10800,0,'+03'),(261,0,21700,0,'LMT'),(261,1,21200,0,'HMT'),(261,2,23400,0,'+0630'),(261,3,19800,0,'+0530'),(261,4,21600,0,'+06'),(261,5,25200,1,'+07'),(262,0,30140,0,'LMT'),(262,1,28800,0,'+08'),(262,2,32400,0,'+09'),(263,0,13272,0,'LMT'),(263,1,14400,0,'+04'),(264,0,16512,0,'LMT'),(264,1,18000,0,'+05'),(264,2,25200,1,'+07'),(264,3,21600,0,'+06'),(264,4,21600,0,'+06'),(264,5,25200,1,'+07'),(264,6,21600,1,'+06'),(264,7,18000,0,'+05'),(265,0,8148,0,'LMT'),(265,1,10800,1,'EEST'),(265,2,7200,0,'EET'),(265,3,7200,0,'EET'),(265,4,10800,1,'EEST'),(265,5,10800,0,'+03'),(265,6,7200,0,'EET'),(266,0,8272,0,'LMT'),(266,1,10800,1,'EEST'),(266,2,7200,0,'EET'),(266,3,7200,0,'EET'),(266,4,10800,1,'EEST'),(266,5,10800,1,'IDT'),(266,6,7200,0,'IST'),(266,7,10800,1,'IDT'),(266,8,7200,0,'IST'),(266,9,7200,0,'EET'),(267,0,29143,0,'LMT'),(267,1,32400,1,'CDT'),(267,2,28800,0,'CST'),(268,0,8423,0,'LMT'),(268,1,10800,1,'EEST'),(268,2,7200,0,'EET'),(268,3,7200,0,'EET'),(268,4,10800,1,'EEST'),(268,5,10800,1,'IDT'),(268,6,7200,0,'IST'),(268,7,10800,1,'IDT'),(268,8,7200,0,'IST'),(268,9,7200,0,'EET'),(269,0,25590,0,'LMT'),(269,1,25590,0,'PLMT'),(269,2,25200,0,'+07'),(269,3,28800,0,'+08'),(269,4,32400,0,'+09'),(269,5,25200,0,'+07'),(270,0,27402,0,'LMT'),(270,1,28800,0,'HKT'),(270,2,32400,1,'HKST'),(270,3,30600,1,'HKWT'),(270,4,32400,0,'JST'),(270,5,28800,0,'HKT'),(270,6,32400,1,'HKST'),(270,7,28800,0,'HKT'),(271,0,21996,0,'LMT'),(271,1,21600,0,'+06'),(271,2,28800,1,'+08'),(271,3,25200,0,'+07'),(272,0,25025,0,'LMT'),(272,1,25025,0,'IMT'),(272,2,25200,0,'+07'),(272,3,32400,1,'+09'),(272,4,28800,0,'+08'),(272,5,28800,0,'+08'),(272,6,32400,1,'+09'),(272,7,28800,1,'+08'),(272,8,25200,0,'+07'),(272,9,32400,0,'+09'),(272,10,32400,1,'+09'),(272,11,28800,0,'+08'),(273,0,6952,0,'LMT'),(273,1,7016,0,'IMT'),(273,2,10800,1,'EEST'),(273,3,7200,0,'EET'),(273,4,10800,0,'+03'),(273,5,14400,1,'+04'),(273,6,10800,1,'EEST'),(273,7,7200,0,'EET'),(273,8,10800,1,'EEST'),(273,9,7200,0,'EET'),(273,10,10800,0,'+03'),(274,0,25632,0,'LMT'),(274,1,25632,0,'BMT'),(274,2,26400,0,'+0720'),(274,3,27000,0,'+0730'),(274,4,32400,0,'+09'),(274,5,28800,0,'+08'),(274,6,25200,0,'WIB'),(275,0,33768,0,'LMT'),(275,1,32400,0,'+09'),(275,2,34200,0,'+0930'),(275,3,32400,0,'WIT'),(276,0,8454,0,'LMT'),(276,1,8440,0,'JMT'),(276,2,10800,1,'IDT'),(276,3,7200,0,'IST'),(276,4,14400,1,'IDDT'),(276,5,10800,1,'IDT'),(276,6,7200,0,'IST'),(276,7,10800,1,'IDT'),(276,8,7200,0,'IST'),(277,0,16608,0,'LMT'),(277,1,14400,0,'+04'),(277,2,16200,0,'+0430'),(278,0,38076,0,'LMT'),(278,1,39600,0,'+11'),(278,2,46800,1,'+13'),(278,3,43200,0,'+12'),(278,4,43200,0,'+12'),(278,5,46800,1,'+13'),(278,6,43200,1,'+12'),(278,7,39600,0,'+11'),(278,8,43200,0,'+12'),(279,0,16092,0,'LMT'),(279,1,19800,0,'+0530'),(279,2,23400,1,'+0630'),(279,3,18000,0,'+05'),(279,4,21600,1,'PKST'),(279,5,18000,0,'PKT'),(280,0,21020,0,'LMT'),(280,1,21600,0,'+06'),(281,0,20476,0,'LMT'),(281,1,19800,0,'+0530'),(281,2,20700,0,'+0545'),(282,0,20476,0,'LMT'),(282,1,19800,0,'+0530'),(282,2,20700,0,'+0545'),(283,0,32533,0,'LMT'),(283,1,28800,0,'+08'),(283,2,36000,1,'+10'),(283,3,32400,0,'+09'),(283,4,32400,0,'+09'),(283,5,36000,1,'+10'),(283,6,32400,1,'+09'),(283,7,28800,0,'+08'),(283,8,39600,1,'+11'),(283,9,36000,0,'+10'),(283,10,36000,0,'+10'),(283,11,39600,0,'+11'),(283,12,32400,0,'+09'),(284,0,21200,0,'HMT'),(284,1,19270,0,'MMT'),(284,2,19800,0,'IST'),(284,3,23400,1,'+0630'),(285,0,22286,0,'LMT'),(285,1,21600,0,'+06'),(285,2,28800,1,'+08'),(285,3,25200,0,'+07'),(285,4,25200,0,'+07'),(285,5,28800,1,'+08'),(285,6,25200,1,'+07'),(285,7,21600,0,'+06'),(285,8,28800,0,'+08'),(285,9,28800,1,'+08'),(285,10,25200,0,'+07'),(286,0,24925,0,'LMT'),(286,1,24925,0,'SMT'),(286,2,25200,0,'+07'),(286,3,26400,1,'+0720'),(286,4,26400,0,'+0720'),(286,5,27000,0,'+0730'),(286,6,32400,0,'+09'),(286,7,28800,0,'+08'),(287,0,26480,0,'LMT'),(287,1,27000,0,'+0730'),(287,2,30000,1,'+0820'),(287,3,28800,0,'+08'),(287,4,32400,0,'+09'),(287,5,28800,0,'+08'),(288,0,11212,0,'LMT'),(288,1,10800,0,'+03'),(289,0,27250,0,'LMT'),(289,1,28800,0,'CST'),(289,2,36000,1,'+10'),(289,3,32400,0,'+09'),(289,4,32400,1,'CDT'),(289,5,28800,0,'CST'),(289,6,32400,1,'CDT'),(290,0,27250,0,'LMT'),(290,1,28800,0,'CST'),(290,2,36000,1,'+10'),(290,3,32400,0,'+09'),(290,4,32400,1,'CDT'),(290,5,28800,0,'CST'),(290,6,32400,1,'CDT'),(291,0,36192,0,'LMT'),(291,1,36000,0,'+10'),(291,2,43200,1,'+12'),(291,3,39600,0,'+11'),(291,4,39600,0,'+11'),(291,5,43200,1,'+12'),(291,6,39600,1,'+11'),(291,7,36000,0,'+10'),(291,8,43200,0,'+12'),(291,9,43200,1,'+12'),(291,10,39600,0,'+11'),(292,0,28656,0,'LMT'),(292,1,28656,0,'MMT'),(292,2,28800,0,'+08'),(292,3,32400,0,'+09'),(292,4,28800,0,'WITA'),(293,0,29040,0,'LMT'),(293,1,32400,1,'PDT'),(293,2,28800,0,'PST'),(293,3,32400,0,'JST'),(293,4,28800,0,'PST'),(294,0,13272,0,'LMT'),(294,1,14400,0,'+04'),(295,0,8008,0,'LMT'),(295,1,10800,1,'EEST'),(295,2,7200,0,'EET'),(295,3,7200,0,'EET'),(295,4,10800,1,'EEST'),(296,0,20928,0,'LMT'),(296,1,21600,0,'+06'),(296,2,28800,1,'+08'),(296,3,25200,0,'+07'),(296,4,25200,0,'+07'),(296,5,28800,1,'+08'),(296,6,25200,1,'+07'),(296,7,21600,0,'+06'),(296,8,25200,0,'+07'),(297,0,19900,0,'LMT'),(297,1,21600,0,'+06'),(297,2,28800,1,'+08'),(297,3,25200,0,'+07'),(297,4,25200,0,'+07'),(297,5,28800,1,'+08'),(297,6,25200,1,'+07'),(297,7,21600,0,'+06'),(297,8,25200,1,'+07'),(297,9,25200,0,'+07'),(298,0,17610,0,'LMT'),(298,1,18000,0,'+05'),(298,2,25200,1,'+07'),(298,3,21600,0,'+06'),(298,4,21600,0,'+06'),(298,5,25200,1,'+07'),(298,6,21600,1,'+06'),(298,7,18000,0,'+05'),(298,8,25200,0,'+07'),(298,9,25200,1,'+07'),(298,10,21600,0,'+06'),(299,0,12324,0,'LMT'),(299,1,10800,0,'+03'),(299,2,18000,0,'+05'),(299,3,21600,1,'+06'),(299,4,21600,0,'+06'),(299,5,18000,0,'+05'),(299,6,21600,1,'+06'),(299,7,18000,1,'+05'),(299,8,14400,0,'+04'),(299,9,18000,0,'+05'),(300,0,24124,0,'LMT'),(300,1,24124,0,'BMT'),(300,2,25200,0,'+07'),(301,0,26240,0,'LMT'),(301,1,26240,0,'PMT'),(301,2,27000,0,'+0730'),(301,3,32400,0,'+09'),(301,4,28800,0,'+08'),(301,5,28800,0,'WITA'),(301,6,25200,0,'WIB'),(302,0,30180,0,'LMT'),(302,1,30600,0,'KST'),(302,2,32400,0,'JST'),(302,3,32400,0,'KST'),(303,0,12368,0,'LMT'),(303,1,14400,0,'+04'),(303,2,10800,0,'+03'),(304,0,15268,0,'LMT'),(304,1,14400,0,'+04'),(304,2,18000,0,'+05'),(304,3,21600,1,'+06'),(304,4,21600,0,'+06'),(304,5,18000,0,'+05'),(304,6,21600,1,'+06'),(304,7,18000,1,'+05'),(304,8,14400,0,'+04'),(304,9,21600,0,'+06'),(304,10,21600,1,'+06'),(305,0,15712,0,'LMT'),(305,1,14400,0,'+04'),(305,2,18000,0,'+05'),(305,3,21600,1,'+06'),(305,4,21600,0,'+06'),(305,5,18000,0,'+05'),(305,6,21600,1,'+06'),(305,7,18000,1,'+05'),(305,8,14400,0,'+04'),(305,9,21600,0,'+06'),(305,10,21600,1,'+06'),(305,11,18000,0,'+05'),(306,0,23087,0,'LMT'),(306,1,23087,0,'RMT'),(306,2,23400,0,'+0630'),(306,3,32400,0,'+09'),(306,4,23400,0,'+0630'),(307,0,11212,0,'LMT'),(307,1,10800,0,'+03'),(308,0,25590,0,'LMT'),(308,1,25590,0,'PLMT'),(308,2,25200,0,'+07'),(308,3,28800,0,'+08'),(308,4,32400,0,'+09'),(308,5,25200,0,'+07'),(309,0,34248,0,'LMT'),(309,1,32400,0,'+09'),(309,2,43200,1,'+12'),(309,3,39600,0,'+11'),(309,4,39600,0,'+11'),(309,5,43200,1,'+12'),(309,6,39600,1,'+11'),(309,7,36000,0,'+10'),(309,8,39600,0,'+11'),(310,0,16073,0,'LMT'),(310,1,14400,0,'+04'),(310,2,18000,0,'+05'),(310,3,21600,1,'+06'),(310,4,21600,0,'+06'),(310,5,18000,0,'+05'),(310,6,21600,1,'+06'),(311,0,30472,0,'LMT'),(311,1,30600,0,'KST'),(311,2,32400,0,'JST'),(311,3,36000,1,'KDT'),(311,4,32400,0,'KST'),(311,5,34200,1,'KDT'),(311,6,36000,1,'KDT'),(312,0,29143,0,'LMT'),(312,1,32400,1,'CDT'),(312,2,28800,0,'CST'),(313,0,24925,0,'LMT'),(313,1,24925,0,'SMT'),(313,2,25200,0,'+07'),(313,3,26400,1,'+0720'),(313,4,26400,0,'+0720'),(313,5,27000,0,'+0730'),(313,6,32400,0,'+09'),(313,7,28800,0,'+08'),(314,0,36892,0,'LMT'),(314,1,36000,0,'+10'),(314,2,43200,1,'+12'),(314,3,39600,0,'+11'),(314,4,39600,0,'+11'),(314,5,43200,1,'+12'),(314,6,39600,1,'+11'),(314,7,36000,0,'+10'),(314,8,43200,0,'+12'),(314,9,43200,1,'+12'),(314,10,39600,0,'+11'),(315,0,29160,0,'LMT'),(315,1,28800,0,'CST'),(315,2,32400,0,'JST'),(315,3,32400,1,'CDT'),(315,4,28800,0,'CST'),(316,0,16631,0,'LMT'),(316,1,18000,0,'+05'),(316,2,25200,1,'+07'),(316,3,21600,0,'+06'),(316,4,21600,0,'+06'),(316,5,25200,1,'+07'),(316,6,21600,1,'+06'),(316,7,18000,0,'+05'),(317,0,10751,0,'LMT'),(317,1,10751,0,'TBMT'),(317,2,10800,0,'+03'),(317,3,18000,1,'+05'),(317,4,14400,0,'+04'),(317,5,14400,0,'+04'),(317,6,18000,1,'+05'),(317,7,14400,1,'+04'),(317,8,10800,0,'+03'),(317,9,14400,1,'+04'),(317,10,14400,0,'+04'),(318,0,12344,0,'LMT'),(318,1,12344,0,'TMT'),(318,2,16200,1,'+0430'),(318,3,12600,0,'+0330'),(318,4,18000,1,'+05'),(318,5,14400,0,'+04'),(318,6,16200,1,'+0430'),(318,7,12600,0,'+0330'),(319,0,8454,0,'LMT'),(319,1,8440,0,'JMT'),(319,2,10800,1,'IDT'),(319,3,7200,0,'IST'),(319,4,14400,1,'IDDT'),(319,5,10800,1,'IDT'),(319,6,7200,0,'IST'),(319,7,10800,1,'IDT'),(319,8,7200,0,'IST'),(320,0,21516,0,'LMT'),(320,1,19800,0,'+0530'),(320,2,21600,0,'+06'),(321,0,21516,0,'LMT'),(321,1,19800,0,'+0530'),(321,2,21600,0,'+06'),(322,0,33539,0,'LMT'),(322,1,36000,1,'JDT'),(322,2,32400,0,'JST'),(322,3,32400,0,'JST'),(323,0,20391,0,'LMT'),(323,1,21600,0,'+06'),(323,2,28800,1,'+08'),(323,3,25200,0,'+07'),(323,4,25200,0,'+07'),(323,5,28800,1,'+08'),(323,6,25200,1,'+07'),(323,7,21600,0,'+06'),(323,8,25200,1,'+07'),(323,9,25200,0,'+07'),(324,0,28656,0,'LMT'),(324,1,28656,0,'MMT'),(324,2,28800,0,'+08'),(324,3,32400,0,'+09'),(324,4,28800,0,'WITA'),(325,0,25652,0,'LMT'),(325,1,25200,0,'+07'),(325,2,32400,1,'+09'),(325,3,28800,0,'+08'),(326,0,25652,0,'LMT'),(326,1,25200,0,'+07'),(326,2,32400,1,'+09'),(326,3,28800,0,'+08'),(327,0,21020,0,'LMT'),(327,1,21600,0,'+06'),(328,0,34374,0,'LMT'),(328,1,28800,0,'+08'),(328,2,32400,0,'+09'),(328,3,39600,0,'+11'),(328,4,43200,1,'+12'),(328,5,39600,0,'+11'),(328,6,43200,1,'+12'),(328,7,39600,1,'+11'),(328,8,36000,0,'+10'),(328,9,43200,0,'+12'),(328,10,43200,1,'+12'),(328,11,36000,0,'+10'),(329,0,24124,0,'LMT'),(329,1,24124,0,'BMT'),(329,2,25200,0,'+07'),(330,0,31651,0,'LMT'),(330,1,32400,0,'+09'),(330,2,39600,1,'+11'),(330,3,36000,0,'+10'),(330,4,36000,0,'+10'),(330,5,39600,1,'+11'),(330,6,36000,1,'+10'),(330,7,32400,0,'+09'),(330,8,39600,0,'+11'),(330,9,39600,1,'+11'),(330,10,36000,0,'+10'),(331,0,31138,0,'LMT'),(331,1,28800,0,'+08'),(331,2,36000,1,'+10'),(331,3,32400,0,'+09'),(331,4,32400,0,'+09'),(331,5,36000,1,'+10'),(331,6,32400,1,'+09'),(331,7,28800,0,'+08'),(331,8,36000,0,'+10'),(331,9,36000,1,'+10'),(331,10,32400,0,'+09'),(332,0,23087,0,'LMT'),(332,1,23087,0,'RMT'),(332,2,23400,0,'+0630'),(332,3,32400,0,'+09'),(332,4,23400,0,'+0630'),(333,0,14553,0,'LMT'),(333,1,13505,0,'PMT'),(333,2,14400,0,'+04'),(333,3,21600,1,'+06'),(333,4,18000,0,'+05'),(333,5,18000,0,'+05'),(333,6,21600,1,'+06'),(333,7,18000,1,'+05'),(333,8,14400,0,'+04'),(333,9,21600,0,'+06'),(333,10,21600,1,'+06'),(333,11,18000,0,'+05'),(334,0,10680,0,'LMT'),(334,1,10800,0,'+03'),(334,2,18000,1,'+05'),(334,3,14400,0,'+04'),(334,4,14400,0,'+04'),(334,5,18000,1,'+05'),(334,6,14400,1,'+04'),(334,7,10800,0,'+03'),(334,8,18000,1,'+05'),(334,9,14400,0,'+04'),(335,0,-6160,0,'LMT'),(335,1,-6872,0,'HMT'),(335,2,-3600,1,'-01'),(335,3,-7200,0,'-02'),(335,4,-3600,1,'-01'),(335,5,-7200,0,'-02'),(335,6,-7200,0,'-02'),(335,7,0,1,'+00'),(335,8,-3600,0,'-01'),(335,9,-3600,0,'-01'),(335,10,0,0,'WET'),(335,11,0,1,'+00'),(335,12,-3600,0,'-01'),(336,0,-15558,0,'LMT'),(336,1,-11958,1,'BST'),(336,2,-15558,0,'BMT'),(336,3,-10800,1,'ADT'),(336,4,-14400,0,'AST'),(337,0,-3696,0,'LMT'),(337,1,-3600,0,'-01'),(337,2,0,0,'WET'),(337,3,3600,1,'WEST'),(337,4,0,0,'WET'),(337,5,3600,1,'WEST'),(338,0,-5644,0,'LMT'),(338,1,-7200,0,'-02'),(338,2,-3600,1,'-01'),(338,3,-7200,0,'-02'),(338,4,-3600,0,'-01'),(339,0,-1624,0,'LMT'),(339,1,0,0,'WET'),(339,2,3600,1,'WEST'),(339,3,0,0,'WET'),(340,0,-1624,0,'LMT'),(340,1,0,0,'WET'),(340,2,3600,1,'WEST'),(340,3,0,0,'WET'),(341,0,3208,0,'LMT'),(341,1,7200,1,'CEST'),(341,2,3600,0,'CET'),(341,3,7200,1,'CEST'),(341,4,3600,0,'CET'),(341,5,10800,1,'CEMT'),(341,6,10800,1,'CEMT'),(341,7,7200,1,'CEST'),(341,8,3600,0,'CET'),(342,0,-4056,0,'LMT'),(342,1,-4056,0,'FMT'),(342,2,0,1,'+00'),(342,3,-3600,0,'-01'),(342,4,0,1,'+00'),(342,5,-3600,0,'-01'),(342,6,-3600,0,'-01'),(342,7,3600,1,'+01'),(342,8,3600,1,'WEST'),(342,9,0,0,'WET'),(342,10,0,0,'WET'),(342,11,0,0,'WET'),(342,12,3600,1,'WEST'),(343,0,-968,0,'LMT'),(343,1,0,0,'GMT'),(344,0,-8768,0,'LMT'),(344,1,-7200,0,'-02'),(345,0,-968,0,'LMT'),(345,1,0,0,'GMT'),(346,0,-13884,0,'LMT'),(346,1,-13884,0,'SMT'),(346,2,-10800,1,'-03'),(346,3,-14400,0,'-04'),(346,4,-7200,1,'-02'),(346,5,-10800,0,'-03'),(346,6,-10800,1,'-03'),(347,0,36292,0,'LMT'),(347,1,39600,1,'AEDT'),(347,2,36000,0,'AEST'),(347,3,36000,0,'AEST'),(348,0,32400,0,'ACST'),(348,1,37800,1,'ACDT'),(348,2,34200,0,'ACST'),(348,3,34200,0,'ACST'),(349,0,36728,0,'LMT'),(349,1,39600,1,'AEDT'),(349,2,36000,0,'AEST'),(349,3,36000,0,'AEST'),(350,0,32400,0,'ACST'),(350,1,37800,1,'ACDT'),(350,2,34200,0,'ACST'),(350,3,34200,0,'ACST'),(350,4,37800,1,'ACDT'),(351,0,36292,0,'LMT'),(351,1,39600,1,'AEDT'),(351,2,36000,0,'AEST'),(351,3,36000,0,'AEST'),(352,0,35356,0,'LMT'),(352,1,39600,1,'AEDT'),(352,2,36000,0,'AEST'),(352,3,36000,0,'AEST'),(353,0,32400,0,'ACST'),(353,1,37800,1,'ACDT'),(353,2,34200,0,'ACST'),(353,3,34200,0,'ACST'),(354,0,30928,0,'LMT'),(354,1,35100,1,'+0945'),(354,2,31500,0,'+0845'),(354,3,31500,0,'+0845'),(355,0,35356,0,'LMT'),(355,1,39600,1,'AEDT'),(355,2,36000,0,'AEST'),(355,3,36000,0,'AEST'),(356,0,38180,0,'LMT'),(356,1,36000,0,'AEST'),(356,2,41400,1,'+1130'),(356,3,37800,0,'+1030'),(356,4,39600,1,'+11'),(357,0,35756,0,'LMT'),(357,1,39600,1,'AEDT'),(357,2,36000,0,'AEST'),(357,3,36000,0,'AEST'),(358,0,38180,0,'LMT'),(358,1,36000,0,'AEST'),(358,2,41400,1,'+1130'),(358,3,37800,0,'+1030'),(358,4,39600,1,'+11'),(359,0,34792,0,'LMT'),(359,1,39600,1,'AEDT'),(359,2,36000,0,'AEST'),(359,3,36000,0,'AEST'),(360,0,36292,0,'LMT'),(360,1,39600,1,'AEDT'),(360,2,36000,0,'AEST'),(360,3,36000,0,'AEST'),(361,0,32400,0,'ACST'),(361,1,37800,1,'ACDT'),(361,2,34200,0,'ACST'),(361,3,34200,0,'ACST'),(362,0,27804,0,'LMT'),(362,1,32400,1,'AWDT'),(362,2,28800,0,'AWST'),(362,3,28800,0,'AWST'),(363,0,36728,0,'LMT'),(363,1,39600,1,'AEDT'),(363,2,36000,0,'AEST'),(363,3,36000,0,'AEST'),(364,0,32400,0,'ACST'),(364,1,37800,1,'ACDT'),(364,2,34200,0,'ACST'),(364,3,34200,0,'ACST'),(365,0,36292,0,'LMT'),(365,1,39600,1,'AEDT'),(365,2,36000,0,'AEST'),(365,3,36000,0,'AEST'),(366,0,35356,0,'LMT'),(366,1,39600,1,'AEDT'),(366,2,36000,0,'AEST'),(366,3,36000,0,'AEST'),(367,0,34792,0,'LMT'),(367,1,39600,1,'AEDT'),(367,2,36000,0,'AEST'),(367,3,36000,0,'AEST'),(368,0,27804,0,'LMT'),(368,1,32400,1,'AWDT'),(368,2,28800,0,'AWST'),(368,3,28800,0,'AWST'),(369,0,32400,0,'ACST'),(369,1,37800,1,'ACDT'),(369,2,34200,0,'ACST'),(369,3,34200,0,'ACST'),(369,4,37800,1,'ACDT'),(370,0,-16272,0,'LMT'),(370,1,-14400,1,'-04'),(370,2,-18000,0,'-05'),(370,3,-14400,0,'-04'),(370,4,-18000,0,'-05'),(371,0,-7780,0,'LMT'),(371,1,-3600,1,'-01'),(371,2,-7200,0,'-02'),(372,0,-11188,0,'LMT'),(372,1,-7200,1,'-02'),(372,2,-10800,0,'-03'),(373,0,-14404,0,'LMT'),(373,1,-10800,1,'-03'),(373,2,-14400,0,'-04'),(374,0,7200,1,'CEST'),(374,1,3600,0,'CET'),(374,2,7200,1,'CEST'),(374,3,3600,0,'CET'),(375,0,-18000,1,'CDT'),(375,1,-21600,0,'CST'),(375,2,-18000,1,'CWT'),(375,3,-18000,1,'CPT'),(376,0,-15264,0,'LMT'),(376,1,-10800,1,'ADT'),(376,2,-14400,0,'AST'),(376,3,-10800,1,'AWT'),(376,4,-10800,1,'APT'),(377,0,-23316,0,'LMT'),(377,1,-18000,1,'CDT'),(377,2,-21600,0,'CST'),(377,3,-18000,1,'CWT'),(377,4,-18000,1,'CPT'),(377,5,-18000,1,'CDT'),(377,6,-21600,0,'CST'),(378,0,-19052,0,'LMT'),(378,1,-14400,1,'EDT'),(378,2,-18000,0,'EST'),(378,3,-14400,1,'EWT'),(378,4,-14400,1,'EPT'),(379,0,-27232,0,'LMT'),(379,1,-21600,1,'MDT'),(379,2,-25200,0,'MST'),(379,3,-21600,1,'MWT'),(379,4,-21600,1,'MPT'),(380,0,-12652,0,'LMT'),(380,1,-9052,1,'NDT'),(380,2,-12652,0,'NST'),(380,3,-9000,1,'NDT'),(380,4,-12600,0,'NST'),(380,5,-9000,1,'NPT'),(380,6,-9000,1,'NWT'),(380,7,-5400,1,'NDDT'),(380,8,-9000,1,'NDT'),(381,0,-29548,0,'LMT'),(381,1,-25200,1,'PDT'),(381,2,-28800,0,'PST'),(381,3,-25200,1,'PWT'),(381,4,-25200,1,'PPT'),(382,0,-25116,0,'LMT'),(382,1,-21600,1,'MDT'),(382,2,-25200,0,'MST'),(382,3,-21600,1,'MWT'),(382,4,-21600,1,'MPT'),(382,5,-21600,0,'CST'),(383,0,-32412,0,'LMT'),(383,1,-28800,1,'YDT'),(383,2,-32400,0,'YST'),(383,3,-28800,1,'YWT'),(383,4,-28800,1,'YPT'),(383,5,-25200,1,'YDDT'),(383,6,-28800,0,'PST'),(383,7,-25200,1,'PDT'),(383,8,-25200,0,'MST'),(384,0,-16965,0,'LMT'),(384,1,-16965,0,'SMT'),(384,2,-18000,0,'-05'),(384,3,-14400,0,'-04'),(384,4,-14400,1,'-04'),(384,5,-10800,1,'-03'),(384,6,-10800,1,'-03'),(384,7,-14400,0,'-04'),(385,0,-26248,0,'LMT'),(385,1,-26248,0,'EMT'),(385,2,-21600,1,'-06'),(385,3,-25200,0,'-07'),(385,4,-25200,0,'-07'),(385,5,-21600,0,'-06'),(385,6,-18000,1,'-05'),(386,0,-19768,0,'LMT'),(386,1,-19776,0,'HMT'),(386,2,-14400,1,'CDT'),(386,3,-18000,0,'CST'),(386,4,-18000,0,'CST'),(386,5,-14400,1,'CDT'),(387,0,10800,1,'EEST'),(387,1,7200,0,'EET'),(388,0,-18000,0,'EST'),(389,0,-14400,1,'EDT'),(389,1,-18000,0,'EST'),(389,2,-14400,1,'EWT'),(389,3,-14400,1,'EPT'),(390,0,7509,0,'LMT'),(390,1,10800,1,'EEST'),(390,2,7200,0,'EET'),(390,3,10800,1,'EEST'),(391,0,-1521,0,'LMT'),(391,1,-1521,0,'DMT'),(391,2,2079,1,'IST'),(391,3,3600,1,'BST'),(391,4,0,0,'GMT'),(391,5,3600,1,'IST'),(391,6,0,0,'GMT'),(391,7,3600,0,'IST'),(391,8,3600,1,'IST'),(391,9,0,0,'GMT'),(392,0,0,0,'GMT'),(393,0,0,0,'GMT'),(394,0,-3600,0,'-01'),(395,0,-36000,0,'-10'),(396,0,-39600,0,'-11'),(397,0,-43200,0,'-12'),(398,0,-7200,0,'-02'),(399,0,-10800,0,'-03'),(400,0,-14400,0,'-04'),(401,0,-18000,0,'-05'),(402,0,-21600,0,'-06'),(403,0,-25200,0,'-07'),(404,0,-28800,0,'-08'),(405,0,-32400,0,'-09'),(406,0,0,0,'GMT'),(407,0,3600,0,'+01'),(408,0,36000,0,'+10'),(409,0,39600,0,'+11'),(410,0,43200,0,'+12'),(411,0,46800,0,'+13'),(412,0,50400,0,'+14'),(413,0,7200,0,'+02'),(414,0,10800,0,'+03'),(415,0,14400,0,'+04'),(416,0,18000,0,'+05'),(417,0,21600,0,'+06'),(418,0,25200,0,'+07'),(419,0,28800,0,'+08'),(420,0,32400,0,'+09'),(421,0,0,0,'GMT'),(422,0,0,0,'GMT'),(423,0,0,0,'UTC'),(424,0,0,0,'UTC'),(425,0,0,0,'UTC'),(426,0,0,0,'UTC'),(427,0,1050,0,'BMT'),(427,1,0,0,'WET'),(427,2,3600,0,'CET'),(427,3,7200,1,'CEST'),(427,4,3600,0,'CET'),(427,5,7200,1,'CEST'),(427,6,3600,1,'WEST'),(427,7,0,0,'WET'),(427,8,0,0,'WET'),(427,9,7200,1,'CEST'),(427,10,3600,0,'CET'),(428,0,364,0,'LMT'),(428,1,0,0,'WET'),(428,2,3600,0,'CET'),(428,3,7200,1,'CEST'),(428,4,3600,0,'CET'),(429,0,11532,0,'LMT'),(429,1,10800,0,'+03'),(429,2,18000,1,'+05'),(429,3,14400,0,'+04'),(429,4,14400,0,'+04'),(429,5,18000,1,'+05'),(429,6,14400,1,'+04'),(429,7,10800,0,'+03'),(429,8,14400,0,'+04'),(430,0,5692,0,'LMT'),(430,1,5692,0,'AMT'),(430,2,10800,1,'EEST'),(430,3,7200,0,'EET'),(430,4,3600,0,'CET'),(430,5,7200,1,'CEST'),(430,6,10800,1,'EEST'),(430,7,7200,0,'EET'),(430,8,10800,1,'EEST'),(430,9,7200,0,'EET'),(431,0,-75,0,'LMT'),(431,1,3600,1,'BST'),(431,2,0,0,'GMT'),(431,3,7200,1,'BDST'),(431,4,0,0,'GMT'),(431,5,3600,0,'BST'),(431,6,3600,1,'BST'),(431,7,0,0,'GMT'),(432,0,4920,0,'LMT'),(432,1,3600,0,'CET'),(432,2,3600,0,'CET'),(432,3,7200,1,'CEST'),(432,4,7200,1,'CEST'),(432,5,7200,1,'CEST'),(432,6,3600,0,'CET'),(433,0,3208,0,'LMT'),(433,1,7200,1,'CEST'),(433,2,3600,0,'CET'),(433,3,7200,1,'CEST'),(433,4,3600,0,'CET'),(433,5,10800,1,'CEMT'),(433,6,10800,1,'CEMT'),(433,7,7200,1,'CEST'),(433,8,3600,0,'CET'),(434,0,3464,0,'PMT'),(434,1,7200,1,'CEST'),(434,2,3600,0,'CET'),(434,3,7200,1,'CEST'),(434,4,3600,0,'CET'),(434,5,0,0,'GMT'),(434,6,7200,1,'CEST'),(434,7,3600,0,'CET'),(435,0,1050,0,'BMT'),(435,1,0,0,'WET'),(435,2,3600,0,'CET'),(435,3,7200,1,'CEST'),(435,4,3600,0,'CET'),(435,5,7200,1,'CEST'),(435,6,3600,1,'WEST'),(435,7,0,0,'WET'),(435,8,0,0,'WET'),(435,9,7200,1,'CEST'),(435,10,3600,0,'CET'),(436,0,6264,0,'LMT'),(436,1,6264,0,'BMT'),(436,2,10800,1,'EEST'),(436,3,7200,0,'EET'),(436,4,10800,1,'EEST'),(436,5,7200,0,'EET'),(436,6,10800,1,'EEST'),(436,7,7200,0,'EET'),(437,0,4580,0,'LMT'),(437,1,7200,1,'CEST'),(437,2,3600,0,'CET'),(437,3,7200,1,'CEST'),(437,4,3600,0,'CET'),(437,5,7200,1,'CEST'),(437,6,3600,0,'CET'),(438,0,1786,0,'BMT'),(438,1,7200,1,'CEST'),(438,2,3600,0,'CET'),(438,3,7200,1,'CEST'),(438,4,3600,0,'CET'),(439,0,6920,0,'LMT'),(439,1,6900,0,'CMT'),(439,2,6264,0,'BMT'),(439,3,10800,1,'EEST'),(439,4,7200,0,'EET'),(439,5,7200,0,'EET'),(439,6,10800,1,'EEST'),(439,7,3600,0,'CET'),(439,8,7200,1,'CEST'),(439,9,7200,1,'CEST'),(439,10,14400,1,'MSD'),(439,11,10800,0,'MSK'),(439,12,10800,0,'MSK'),(439,13,14400,1,'MSD'),(439,14,10800,1,'EEST'),(439,15,7200,0,'EET'),(440,0,3208,0,'LMT'),(440,1,7200,1,'CEST'),(440,2,3600,0,'CET'),(440,3,7200,1,'CEST'),(440,4,3600,0,'CET'),(440,5,10800,1,'CEMT'),(440,6,10800,1,'CEMT'),(440,7,7200,1,'CEST'),(440,8,3600,0,'CET'),(441,0,-1521,0,'LMT'),(441,1,-1521,0,'DMT'),(441,2,2079,1,'IST'),(441,3,3600,1,'BST'),(441,4,0,0,'GMT'),(441,5,3600,1,'IST'),(441,6,0,0,'GMT'),(441,7,3600,0,'IST'),(441,8,3600,1,'IST'),(441,9,0,0,'GMT'),(442,0,-1284,0,'LMT'),(442,1,3600,1,'BST'),(442,2,0,0,'GMT'),(442,3,7200,1,'BDST'),(442,4,0,0,'GMT'),(442,5,3600,0,'CET'),(442,6,7200,1,'CEST'),(442,7,3600,0,'CET'),(443,0,-75,0,'LMT'),(443,1,3600,1,'BST'),(443,2,0,0,'GMT'),(443,3,7200,1,'BDST'),(443,4,0,0,'GMT'),(443,5,3600,0,'BST'),(443,6,3600,1,'BST'),(443,7,0,0,'GMT'),(444,0,5989,0,'LMT'),(444,1,5989,0,'HMT'),(444,2,10800,1,'EEST'),(444,3,7200,0,'EET'),(444,4,10800,1,'EEST'),(444,5,7200,0,'EET'),(445,0,-75,0,'LMT'),(445,1,3600,1,'BST'),(445,2,0,0,'GMT'),(445,3,7200,1,'BDST'),(445,4,0,0,'GMT'),(445,5,3600,0,'BST'),(445,6,3600,1,'BST'),(445,7,0,0,'GMT'),(446,0,6952,0,'LMT'),(446,1,7016,0,'IMT'),(446,2,10800,1,'EEST'),(446,3,7200,0,'EET'),(446,4,10800,0,'+03'),(446,5,14400,1,'+04'),(446,6,10800,1,'EEST'),(446,7,7200,0,'EET'),(446,8,10800,1,'EEST'),(446,9,7200,0,'EET'),(446,10,10800,0,'+03'),(447,0,-75,0,'LMT'),(447,1,3600,1,'BST'),(447,2,0,0,'GMT'),(447,3,7200,1,'BDST'),(447,4,0,0,'GMT'),(447,5,3600,0,'BST'),(447,6,3600,1,'BST'),(447,7,0,0,'GMT'),(448,0,4920,0,'LMT'),(448,1,7200,1,'CEST'),(448,2,3600,0,'CET'),(448,3,7200,1,'CEST'),(448,4,3600,0,'CET'),(448,5,10800,1,'EEST'),(448,6,7200,0,'EET'),(448,7,14400,1,'MSD'),(448,8,10800,0,'MSK'),(448,9,10800,0,'MSK'),(448,10,14400,1,'MSD'),(448,11,10800,1,'EEST'),(448,12,7200,0,'EET'),(448,13,10800,0,'+03'),(448,14,7200,0,'EET'),(449,0,7324,0,'LMT'),(449,1,7324,0,'KMT'),(449,2,7200,0,'EET'),(449,3,10800,0,'MSK'),(449,4,3600,0,'CET'),(449,5,7200,1,'CEST'),(449,6,7200,1,'CEST'),(449,7,14400,1,'MSD'),(449,8,10800,0,'MSK'),(449,9,14400,1,'MSD'),(449,10,10800,1,'EEST'),(449,11,7200,0,'EET'),(449,12,10800,1,'EEST'),(449,13,7200,0,'EET'),(449,14,10800,1,'EEST'),(450,0,11928,0,'LMT'),(450,1,10800,0,'+03'),(450,2,18000,1,'+05'),(450,3,14400,0,'+04'),(450,4,14400,0,'+04'),(450,5,18000,1,'+05'),(450,6,14400,1,'MSD'),(450,7,10800,0,'MSK'),(450,8,14400,0,'MSK'),(450,9,10800,0,'MSK'),(451,0,7324,0,'LMT'),(451,1,7324,0,'KMT'),(451,2,7200,0,'EET'),(451,3,10800,0,'MSK'),(451,4,3600,0,'CET'),(451,5,7200,1,'CEST'),(451,6,7200,1,'CEST'),(451,7,14400,1,'MSD'),(451,8,10800,0,'MSK'),(451,9,14400,1,'MSD'),(451,10,10800,1,'EEST'),(451,11,7200,0,'EET'),(451,12,10800,1,'EEST'),(451,13,7200,0,'EET'),(451,14,10800,1,'EEST'),(452,0,-2205,0,'LMT'),(452,1,3600,1,'WEST'),(452,2,0,0,'WET'),(452,3,3600,1,'WEST'),(452,4,0,0,'WET'),(452,5,7200,1,'WEMT'),(452,6,0,0,'WET'),(452,7,3600,0,'CET'),(452,8,3600,0,'CET'),(452,9,7200,1,'CEST'),(452,10,3600,1,'WEST'),(452,11,0,0,'WET'),(453,0,4920,0,'LMT'),(453,1,3600,0,'CET'),(453,2,3600,0,'CET'),(453,3,7200,1,'CEST'),(453,4,7200,1,'CEST'),(453,5,7200,1,'CEST'),(453,6,3600,0,'CET'),(454,0,-75,0,'LMT'),(454,1,3600,1,'BST'),(454,2,0,0,'GMT'),(454,3,7200,1,'BDST'),(454,4,0,0,'GMT'),(454,5,3600,0,'BST'),(454,6,3600,1,'BST'),(454,7,0,0,'GMT'),(455,0,1050,0,'BMT'),(455,1,0,0,'WET'),(455,2,3600,0,'CET'),(455,3,7200,1,'CEST'),(455,4,3600,0,'CET'),(455,5,7200,1,'CEST'),(455,6,3600,1,'WEST'),(455,7,0,0,'WET'),(455,8,0,0,'WET'),(455,9,7200,1,'CEST'),(455,10,3600,0,'CET'),(456,0,-884,0,'LMT'),(456,1,3600,1,'WEST'),(456,2,0,0,'WET'),(456,3,7200,1,'WEMT'),(456,4,0,0,'WET'),(456,5,7200,1,'CEST'),(456,6,3600,0,'CET'),(456,7,7200,1,'CEST'),(456,8,3600,0,'CET'),(456,9,7200,1,'CEST'),(456,10,3600,0,'CET'),(457,0,3484,0,'LMT'),(457,1,7200,1,'CEST'),(457,2,3600,0,'CET'),(457,3,3600,0,'CET'),(457,4,7200,1,'CEST'),(457,5,7200,1,'CEST'),(457,6,3600,0,'CET'),(458,0,5989,0,'LMT'),(458,1,5989,0,'HMT'),(458,2,10800,1,'EEST'),(458,3,7200,0,'EET'),(458,4,10800,1,'EEST'),(458,5,7200,0,'EET'),(459,0,6616,0,'LMT'),(459,1,6600,0,'MMT'),(459,2,7200,0,'EET'),(459,3,10800,0,'MSK'),(459,4,3600,0,'CET'),(459,5,7200,1,'CEST'),(459,6,7200,1,'CEST'),(459,7,14400,1,'MSD'),(459,8,10800,0,'MSK'),(459,9,14400,1,'MSD'),(459,10,10800,1,'EEST'),(459,11,7200,0,'EET'),(459,12,10800,0,'+03'),(460,0,561,0,'LMT'),(460,1,561,0,'PMT'),(460,2,3600,1,'WEST'),(460,3,0,0,'WET'),(460,4,3600,1,'WEST'),(460,5,0,0,'WET'),(460,6,3600,0,'CET'),(460,7,7200,1,'CEST'),(460,8,7200,1,'CEST'),(460,9,7200,1,'WEMT'),(460,10,3600,0,'CET'),(460,11,7200,1,'CEST'),(460,12,3600,0,'CET'),(461,0,9017,0,'LMT'),(461,1,9017,0,'MMT'),(461,2,12679,1,'MST'),(461,3,9079,0,'MMT'),(461,4,16279,1,'MDST'),(461,5,14400,1,'MSD'),(461,6,10800,0,'MSK'),(461,7,14400,1,'MSD'),(461,8,18000,1,'+05'),(461,9,7200,0,'EET'),(461,10,10800,0,'MSK'),(461,11,14400,1,'MSD'),(461,12,10800,1,'EEST'),(461,13,7200,0,'EET'),(461,14,14400,0,'MSK'),(461,15,14400,1,'MSD'),(461,16,10800,0,'MSK'),(462,0,8008,0,'LMT'),(462,1,10800,1,'EEST'),(462,2,7200,0,'EET'),(462,3,7200,0,'EET'),(462,4,10800,1,'EEST'),(463,0,3208,0,'LMT'),(463,1,7200,1,'CEST'),(463,2,3600,0,'CET'),(463,3,7200,1,'CEST'),(463,4,3600,0,'CET'),(463,5,10800,1,'CEMT'),(463,6,10800,1,'CEMT'),(463,7,7200,1,'CEST'),(463,8,3600,0,'CET'),(464,0,561,0,'LMT'),(464,1,561,0,'PMT'),(464,2,3600,1,'WEST'),(464,3,0,0,'WET'),(464,4,3600,1,'WEST'),(464,5,0,0,'WET'),(464,6,3600,0,'CET'),(464,7,7200,1,'CEST'),(464,8,7200,1,'CEST'),(464,9,7200,1,'WEMT'),(464,10,3600,0,'CET'),(464,11,7200,1,'CEST'),(464,12,3600,0,'CET'),(465,0,4920,0,'LMT'),(465,1,3600,0,'CET'),(465,2,3600,0,'CET'),(465,3,7200,1,'CEST'),(465,4,7200,1,'CEST'),(465,5,7200,1,'CEST'),(465,6,3600,0,'CET'),(466,0,3464,0,'PMT'),(466,1,7200,1,'CEST'),(466,2,3600,0,'CET'),(466,3,7200,1,'CEST'),(466,4,3600,0,'CET'),(466,5,0,0,'GMT'),(466,6,7200,1,'CEST'),(466,7,3600,0,'CET'),(467,0,5794,0,'LMT'),(467,1,5794,0,'RMT'),(467,2,9394,1,'LST'),(467,3,7200,0,'EET'),(467,4,10800,0,'MSK'),(467,5,3600,0,'CET'),(467,6,7200,1,'CEST'),(467,7,7200,1,'CEST'),(467,8,14400,1,'MSD'),(467,9,10800,0,'MSK'),(467,10,14400,1,'MSD'),(467,11,10800,1,'EEST'),(467,12,7200,0,'EET'),(467,13,10800,1,'EEST'),(467,14,7200,0,'EET'),(468,0,2996,0,'RMT'),(468,1,7200,1,'CEST'),(468,2,3600,0,'CET'),(468,3,3600,0,'CET'),(468,4,7200,1,'CEST'),(468,5,3600,0,'CET'),(468,6,7200,1,'CEST'),(469,0,12020,0,'LMT'),(469,1,10800,0,'+03'),(469,2,14400,0,'+04'),(469,3,18000,1,'+05'),(469,4,14400,0,'+04'),(469,5,18000,1,'+05'),(469,6,14400,1,'+04'),(469,7,10800,0,'+03'),(469,8,10800,1,'+03'),(469,9,7200,0,'+02'),(469,10,14400,1,'+04'),(469,11,14400,0,'+04'),(470,0,2996,0,'RMT'),(470,1,7200,1,'CEST'),(470,2,3600,0,'CET'),(470,3,3600,0,'CET'),(470,4,7200,1,'CEST'),(470,5,3600,0,'CET'),(470,6,7200,1,'CEST'),(471,0,4920,0,'LMT'),(471,1,3600,0,'CET'),(471,2,3600,0,'CET'),(471,3,7200,1,'CEST'),(471,4,7200,1,'CEST'),(471,5,7200,1,'CEST'),(471,6,3600,0,'CET'),(472,0,11058,0,'LMT'),(472,1,10800,0,'+03'),(472,2,18000,1,'+05'),(472,3,14400,0,'+04'),(472,4,14400,0,'+04'),(472,5,18000,1,'+05'),(472,6,14400,1,'+04'),(472,7,10800,0,'+03'),(472,8,14400,0,'+04'),(473,0,8184,0,'LMT'),(473,1,8160,0,'SMT'),(473,2,7200,0,'EET'),(473,3,10800,0,'MSK'),(473,4,3600,0,'CET'),(473,5,7200,1,'CEST'),(473,6,7200,1,'CEST'),(473,7,14400,1,'MSD'),(473,8,10800,0,'MSK'),(473,9,14400,1,'MSD'),(473,10,10800,1,'EEST'),(473,11,7200,0,'EET'),(473,12,10800,1,'EEST'),(473,13,7200,0,'EET'),(473,14,14400,0,'MSK'),(473,15,10800,0,'MSK'),(474,0,4920,0,'LMT'),(474,1,3600,0,'CET'),(474,2,3600,0,'CET'),(474,3,7200,1,'CEST'),(474,4,7200,1,'CEST'),(474,5,7200,1,'CEST'),(474,6,3600,0,'CET'),(475,0,7016,0,'IMT'),(475,1,7200,0,'EET'),(475,2,3600,0,'CET'),(475,3,7200,1,'CEST'),(475,4,3600,0,'CET'),(475,5,10800,1,'EEST'),(475,6,7200,0,'EET'),(475,7,10800,1,'EEST'),(475,8,10800,1,'EEST'),(475,9,7200,0,'EET'),(476,0,3208,0,'LMT'),(476,1,7200,1,'CEST'),(476,2,3600,0,'CET'),(476,3,7200,1,'CEST'),(476,4,3600,0,'CET'),(476,5,10800,1,'CEMT'),(476,6,10800,1,'CEMT'),(476,7,7200,1,'CEST'),(476,8,3600,0,'CET'),(477,0,5940,0,'LMT'),(477,1,5940,0,'TMT'),(477,2,7200,1,'CEST'),(477,3,3600,0,'CET'),(477,4,3600,0,'CET'),(477,5,7200,0,'EET'),(477,6,10800,0,'MSK'),(477,7,7200,1,'CEST'),(477,8,14400,1,'MSD'),(477,9,10800,0,'MSK'),(477,10,14400,1,'MSD'),(477,11,10800,1,'EEST'),(477,12,7200,0,'EET'),(477,13,7200,0,'EET'),(477,14,10800,1,'EEST'),(477,15,10800,1,'EEST'),(478,0,4760,0,'LMT'),(478,1,3600,0,'CET'),(478,2,7200,1,'CEST'),(478,3,3600,0,'CET'),(478,4,7200,1,'CEST'),(479,0,6920,0,'LMT'),(479,1,6900,0,'CMT'),(479,2,6264,0,'BMT'),(479,3,10800,1,'EEST'),(479,4,7200,0,'EET'),(479,5,7200,0,'EET'),(479,6,10800,1,'EEST'),(479,7,3600,0,'CET'),(479,8,7200,1,'CEST'),(479,9,7200,1,'CEST'),(479,10,14400,1,'MSD'),(479,11,10800,0,'MSK'),(479,12,10800,0,'MSK'),(479,13,14400,1,'MSD'),(479,14,10800,1,'EEST'),(479,15,7200,0,'EET'),(480,0,11616,0,'LMT'),(480,1,10800,0,'+03'),(480,2,18000,1,'+05'),(480,3,14400,0,'+04'),(480,4,14400,0,'+04'),(480,5,18000,1,'+05'),(480,6,14400,1,'+04'),(480,7,10800,0,'+03'),(480,8,10800,1,'+03'),(480,9,7200,0,'+02'),(480,10,14400,1,'+04'),(480,11,14400,0,'+04'),(481,0,7324,0,'LMT'),(481,1,7324,0,'KMT'),(481,2,7200,0,'EET'),(481,3,10800,0,'MSK'),(481,4,3600,0,'CET'),(481,5,7200,1,'CEST'),(481,6,7200,1,'CEST'),(481,7,14400,1,'MSD'),(481,8,10800,0,'MSK'),(481,9,14400,1,'MSD'),(481,10,10800,1,'EEST'),(481,11,7200,0,'EET'),(481,12,10800,1,'EEST'),(481,13,7200,0,'EET'),(481,14,10800,1,'EEST'),(482,0,1786,0,'BMT'),(482,1,7200,1,'CEST'),(482,2,3600,0,'CET'),(482,3,7200,1,'CEST'),(482,4,3600,0,'CET'),(483,0,2996,0,'RMT'),(483,1,7200,1,'CEST'),(483,2,3600,0,'CET'),(483,3,3600,0,'CET'),(483,4,7200,1,'CEST'),(483,5,3600,0,'CET'),(483,6,7200,1,'CEST'),(484,0,3921,0,'LMT'),(484,1,7200,1,'CEST'),(484,2,3600,0,'CET'),(484,3,7200,1,'CEST'),(484,4,3600,0,'CET'),(484,5,7200,1,'CEST'),(484,6,3600,0,'CET'),(485,0,6076,0,'LMT'),(485,1,5040,0,'WMT'),(485,2,5736,0,'KMT'),(485,3,3600,0,'CET'),(485,4,7200,0,'EET'),(485,5,10800,0,'MSK'),(485,6,3600,0,'CET'),(485,7,7200,1,'CEST'),(485,8,7200,1,'CEST'),(485,9,14400,1,'MSD'),(485,10,10800,0,'MSK'),(485,11,14400,1,'MSD'),(485,12,10800,1,'EEST'),(485,13,7200,0,'EET'),(485,14,7200,1,'CEST'),(485,15,3600,0,'CET'),(485,16,7200,0,'EET'),(485,17,10800,1,'EEST'),(486,0,10660,0,'LMT'),(486,1,10800,0,'+03'),(486,2,14400,0,'+04'),(486,3,18000,1,'+05'),(486,4,14400,0,'+04'),(486,5,18000,1,'+05'),(486,6,14400,1,'MSD'),(486,7,10800,0,'MSK'),(486,8,14400,0,'MSK'),(486,9,10800,0,'MSK'),(487,0,5040,0,'LMT'),(487,1,5040,0,'WMT'),(487,2,7200,1,'CEST'),(487,3,3600,0,'CET'),(487,4,7200,1,'CEST'),(487,5,3600,0,'CET'),(487,6,10800,1,'EEST'),(487,7,7200,0,'EET'),(487,8,7200,0,'EET'),(487,9,7200,1,'CEST'),(487,10,3600,0,'CET'),(488,0,4920,0,'LMT'),(488,1,3600,0,'CET'),(488,2,3600,0,'CET'),(488,3,7200,1,'CEST'),(488,4,7200,1,'CEST'),(488,5,7200,1,'CEST'),(488,6,3600,0,'CET'),(489,0,7324,0,'LMT'),(489,1,7324,0,'KMT'),(489,2,7200,0,'EET'),(489,3,10800,0,'MSK'),(489,4,3600,0,'CET'),(489,5,7200,1,'CEST'),(489,6,7200,1,'CEST'),(489,7,14400,1,'MSD'),(489,8,10800,0,'MSK'),(489,9,14400,1,'MSD'),(489,10,10800,1,'EEST'),(489,11,7200,0,'EET'),(489,12,10800,1,'EEST'),(489,13,7200,0,'EET'),(489,14,10800,1,'EEST'),(490,0,1786,0,'BMT'),(490,1,7200,1,'CEST'),(490,2,3600,0,'CET'),(490,3,7200,1,'CEST'),(490,4,3600,0,'CET'),(491,0,-75,0,'LMT'),(491,1,3600,1,'BST'),(491,2,0,0,'GMT'),(491,3,7200,1,'BDST'),(491,4,0,0,'GMT'),(491,5,3600,0,'BST'),(491,6,3600,1,'BST'),(491,7,0,0,'GMT'),(492,0,-75,0,'LMT'),(492,1,3600,1,'BST'),(492,2,0,0,'GMT'),(492,3,7200,1,'BDST'),(492,4,0,0,'GMT'),(492,5,3600,0,'BST'),(492,6,3600,1,'BST'),(492,7,0,0,'GMT'),(493,0,0,0,'GMT'),(494,0,0,0,'GMT'),(495,0,0,0,'GMT'),(496,0,0,0,'GMT'),(497,0,0,0,'GMT'),(498,0,-36000,0,'HST'),(499,0,27402,0,'LMT'),(499,1,28800,0,'HKT'),(499,2,32400,1,'HKST'),(499,3,30600,1,'HKWT'),(499,4,32400,0,'JST'),(499,5,28800,0,'HKT'),(499,6,32400,1,'HKST'),(499,7,28800,0,'HKT'),(500,0,-968,0,'LMT'),(500,1,0,0,'GMT'),(501,0,8836,0,'LMT'),(501,1,9000,0,'+0230'),(501,2,10800,0,'EAT'),(501,3,9900,0,'+0245'),(501,4,10800,0,'EAT'),(502,0,17380,0,'LMT'),(502,1,18000,0,'+05'),(502,2,21600,0,'+06'),(503,0,24124,0,'LMT'),(503,1,24124,0,'BMT'),(503,2,25200,0,'+07'),(504,0,23087,0,'LMT'),(504,1,23087,0,'RMT'),(504,2,23400,0,'+0630'),(504,3,32400,0,'+09'),(504,4,23400,0,'+0630'),(505,0,8836,0,'LMT'),(505,1,9000,0,'+0230'),(505,2,10800,0,'EAT'),(505,3,9900,0,'+0245'),(505,4,10800,0,'EAT'),(506,0,17640,0,'LMT'),(506,1,17640,0,'MMT'),(506,2,18000,0,'+05'),(507,0,13272,0,'LMT'),(507,1,14400,0,'+04'),(508,0,17640,0,'LMT'),(508,1,17640,0,'MMT'),(508,2,18000,0,'+05'),(509,0,13800,0,'LMT'),(509,1,18000,1,'+05'),(509,2,14400,0,'+04'),(510,0,8836,0,'LMT'),(510,1,9000,0,'+0230'),(510,2,10800,0,'EAT'),(510,3,9900,0,'+0245'),(510,4,10800,0,'EAT'),(511,0,13272,0,'LMT'),(511,1,14400,0,'+04'),(512,0,12344,0,'LMT'),(512,1,12344,0,'TMT'),(512,2,16200,1,'+0430'),(512,3,12600,0,'+0330'),(512,4,18000,1,'+05'),(512,5,14400,0,'+04'),(512,6,16200,1,'+0430'),(512,7,12600,0,'+0330'),(513,0,8454,0,'LMT'),(513,1,8440,0,'JMT'),(513,2,10800,1,'IDT'),(513,3,7200,0,'IST'),(513,4,14400,1,'IDDT'),(513,5,10800,1,'IDT'),(513,6,7200,0,'IST'),(513,7,10800,1,'IDT'),(513,8,7200,0,'IST'),(514,0,-18430,0,'LMT'),(514,1,-18430,0,'KMT'),(514,2,-18000,0,'EST'),(514,3,-14400,1,'EDT'),(515,0,33539,0,'LMT'),(515,1,36000,1,'JDT'),(515,2,32400,0,'JST'),(515,3,32400,0,'JST'),(516,0,40160,0,'LMT'),(516,1,39600,0,'+11'),(516,2,36000,0,'+10'),(516,3,32400,0,'+09'),(516,4,-43200,0,'-12'),(516,5,43200,0,'+12'),(517,0,3164,0,'LMT'),(517,1,7200,1,'CEST'),(517,2,3600,0,'CET'),(517,3,7200,0,'EET'),(518,0,7200,1,'MEST'),(518,1,3600,0,'MET'),(518,2,7200,1,'MEST'),(518,3,3600,0,'MET'),(519,0,-25200,0,'MST'),(520,0,-21600,1,'MDT'),(520,1,-25200,0,'MST'),(520,2,-21600,1,'MWT'),(520,3,-21600,1,'MPT'),(521,0,-28084,0,'LMT'),(521,1,-25200,0,'MST'),(521,2,-28800,0,'PST'),(521,3,-25200,0,'MST'),(521,4,-25200,1,'PDT'),(521,5,-25200,1,'PWT'),(521,6,-25200,1,'PPT'),(521,7,-28800,0,'PST'),(522,0,-25540,0,'LMT'),(522,1,-25200,0,'MST'),(522,2,-21600,0,'CST'),(522,3,-21600,1,'MDT'),(522,4,-25200,0,'MST'),(522,5,-28800,0,'PST'),(522,6,-25200,0,'MST'),(523,0,-23796,0,'LMT'),(523,1,-25200,0,'MST'),(523,2,-21600,0,'CST'),(523,3,-21600,1,'MDT'),(523,4,-25200,0,'MST'),(523,5,-18000,1,'CDT'),(523,6,-18000,1,'CWT'),(523,7,-21600,0,'CST'),(524,0,41944,0,'LMT'),(524,1,45000,1,'NZST'),(524,2,41400,0,'NZMT'),(524,3,43200,1,'NZST'),(524,4,46800,1,'NZDT'),(524,5,43200,0,'NZST'),(524,6,43200,0,'NZST'),(525,0,44028,0,'LMT'),(525,1,44100,0,'+1215'),(525,2,49500,1,'+1345'),(525,3,45900,0,'+1245'),(525,4,45900,0,'+1245'),(526,0,-25196,0,'LMT'),(526,1,-21600,1,'MDT'),(526,2,-25200,0,'MST'),(526,3,-25200,0,'MST'),(526,4,-21600,1,'MWT'),(526,5,-21600,1,'MPT'),(527,0,29143,0,'LMT'),(527,1,32400,1,'CDT'),(527,2,28800,0,'CST'),(528,0,-25200,1,'PDT'),(528,1,-28800,0,'PST'),(528,2,-25200,1,'PWT'),(528,3,-25200,1,'PPT'),(529,0,45184,0,'LMT'),(529,1,-41216,0,'LMT'),(529,2,-41400,0,'-1130'),(529,3,-36000,1,'-10'),(529,4,-39600,0,'-11'),(529,5,46800,0,'+13'),(529,6,50400,1,'+14'),(530,0,41944,0,'LMT'),(530,1,45000,1,'NZST'),(530,2,41400,0,'NZMT'),(530,3,43200,1,'NZST'),(530,4,46800,1,'NZDT'),(530,5,43200,0,'NZST'),(530,6,43200,0,'NZST'),(531,0,35312,0,'PMMT'),(531,1,36000,0,'+10'),(531,2,32400,0,'+09'),(531,3,39600,0,'+11'),(532,0,44028,0,'LMT'),(532,1,44100,0,'+1215'),(532,2,49500,1,'+1345'),(532,3,45900,0,'+1245'),(532,4,45900,0,'+1245'),(533,0,35312,0,'PMMT'),(533,1,36000,0,'+10'),(534,0,-26248,0,'LMT'),(534,1,-26248,0,'EMT'),(534,2,-21600,1,'-06'),(534,3,-25200,0,'-07'),(534,4,-25200,0,'-07'),(534,5,-21600,0,'-06'),(534,6,-18000,1,'-05'),(535,0,40396,0,'LMT'),(535,1,43200,1,'+12'),(535,2,39600,0,'+11'),(535,3,43200,1,'+12'),(535,4,39600,0,'+11'),(536,0,0,0,'-00'),(536,1,-43200,0,'-12'),(536,2,-39600,0,'-11'),(536,3,46800,0,'+13'),(537,0,-41096,0,'LMT'),(537,1,-39600,0,'-11'),(537,2,46800,0,'+13'),(538,0,42944,0,'LMT'),(538,1,46800,1,'+13'),(538,2,43200,0,'+12'),(539,0,41524,0,'LMT'),(539,1,43200,0,'+12'),(540,0,-21504,0,'LMT'),(540,1,-18000,0,'-05'),(540,2,-18000,1,'-05'),(540,3,-21600,0,'-06'),(541,0,-32388,0,'LMT'),(541,1,-32400,0,'-09'),(542,0,38388,0,'LMT'),(542,1,39600,0,'+11'),(543,0,34740,0,'LMT'),(543,1,36000,0,'GST'),(543,2,32400,0,'+09'),(543,3,39600,1,'GDT'),(543,4,36000,0,'ChST'),(544,0,-37886,0,'LMT'),(544,1,-37800,0,'HST'),(544,2,-34200,1,'HDT'),(544,3,-34200,1,'HWT'),(544,4,-34200,1,'HPT'),(544,5,-36000,0,'HST'),(545,0,-37886,0,'LMT'),(545,1,-37800,0,'HST'),(545,2,-34200,1,'HDT'),(545,3,-34200,1,'HWT'),(545,4,-34200,1,'HPT'),(545,5,-36000,0,'HST'),(546,0,0,0,'-00'),(546,1,-43200,0,'-12'),(546,2,-39600,0,'-11'),(546,3,46800,0,'+13'),(547,0,-37760,0,'LMT'),(547,1,-38400,0,'-1040'),(547,2,-36000,0,'-10'),(547,3,50400,0,'+14'),(548,0,39116,0,'LMT'),(548,1,39600,0,'+11'),(548,2,32400,0,'+09'),(548,3,36000,0,'+10'),(548,4,43200,0,'+12'),(548,5,39600,0,'+11'),(549,0,40160,0,'LMT'),(549,1,39600,0,'+11'),(549,2,36000,0,'+10'),(549,3,32400,0,'+09'),(549,4,-43200,0,'-12'),(549,5,43200,0,'+12'),(550,0,41524,0,'LMT'),(550,1,43200,0,'+12'),(551,0,-33480,0,'LMT'),(551,1,-34200,0,'-0930'),(552,0,45432,0,'LMT'),(552,1,-40968,0,'LMT'),(552,2,-39600,0,'SST'),(553,0,40060,0,'LMT'),(553,1,41400,0,'+1130'),(553,2,32400,0,'+09'),(553,3,43200,0,'+12'),(554,0,-40780,0,'LMT'),(554,1,-40800,0,'-1120'),(554,2,-39600,0,'-11'),(555,0,40312,0,'LMT'),(555,1,40320,0,'+1112'),(555,2,41400,0,'+1130'),(555,3,45000,1,'+1230'),(555,4,41400,0,'+1130'),(555,5,39600,0,'+11'),(555,6,43200,1,'+12'),(555,7,39600,0,'+11'),(556,0,39948,0,'LMT'),(556,1,43200,1,'+12'),(556,2,39600,0,'+11'),(556,3,43200,1,'+12'),(556,4,39600,0,'+11'),(557,0,45432,0,'LMT'),(557,1,-40968,0,'LMT'),(557,2,-39600,0,'SST'),(558,0,32276,0,'LMT'),(558,1,32400,0,'+09'),(559,0,-31220,0,'LMT'),(559,1,-30600,0,'-0830'),(559,2,-28800,0,'-08'),(560,0,38388,0,'LMT'),(560,1,39600,0,'+11'),(561,0,38388,0,'LMT'),(561,1,39600,0,'+11'),(562,0,35312,0,'PMMT'),(562,1,36000,0,'+10'),(563,0,48056,0,'LMT'),(563,1,-38344,0,'LMT'),(563,2,-37800,0,'-1030'),(563,3,-36000,0,'-10'),(563,4,-34200,1,'-0930'),(564,0,34740,0,'LMT'),(564,1,36000,0,'GST'),(564,2,32400,0,'+09'),(564,3,39600,1,'GDT'),(564,4,36000,0,'ChST'),(565,0,45432,0,'LMT'),(565,1,-40968,0,'LMT'),(565,2,-39600,0,'SST'),(566,0,-35896,0,'LMT'),(566,1,-36000,0,'-10'),(567,0,41524,0,'LMT'),(567,1,43200,0,'+12'),(568,0,44352,0,'LMT'),(568,1,44400,0,'+1220'),(568,2,46800,0,'+13'),(568,3,50400,1,'+14'),(568,4,46800,0,'+13'),(568,5,50400,1,'+14'),(569,0,35312,0,'PMMT'),(569,1,36000,0,'+10'),(570,0,41524,0,'LMT'),(570,1,43200,0,'+12'),(571,0,41524,0,'LMT'),(571,1,43200,0,'+12'),(572,0,35312,0,'PMMT'),(572,1,36000,0,'+10'),(573,0,5040,0,'LMT'),(573,1,5040,0,'WMT'),(573,2,7200,1,'CEST'),(573,3,3600,0,'CET'),(573,4,7200,1,'CEST'),(573,5,3600,0,'CET'),(573,6,10800,1,'EEST'),(573,7,7200,0,'EET'),(573,8,7200,0,'EET'),(573,9,7200,1,'CEST'),(573,10,3600,0,'CET'),(574,0,-2205,0,'LMT'),(574,1,3600,1,'WEST'),(574,2,0,0,'WET'),(574,3,3600,1,'WEST'),(574,4,0,0,'WET'),(574,5,7200,1,'WEMT'),(574,6,0,0,'WET'),(574,7,3600,0,'CET'),(574,8,3600,0,'CET'),(574,9,7200,1,'CEST'),(574,10,3600,1,'WEST'),(574,11,0,0,'WET'),(575,0,29160,0,'LMT'),(575,1,28800,0,'CST'),(575,2,32400,0,'JST'),(575,3,32400,1,'CDT'),(575,4,28800,0,'CST'),(576,0,30472,0,'LMT'),(576,1,30600,0,'KST'),(576,2,32400,0,'JST'),(576,3,36000,1,'KDT'),(576,4,32400,0,'KST'),(576,5,34200,1,'KDT'),(576,6,36000,1,'KDT'),(577,0,24925,0,'LMT'),(577,1,24925,0,'SMT'),(577,2,25200,0,'+07'),(577,3,26400,1,'+0720'),(577,4,26400,0,'+0720'),(577,5,27000,0,'+0730'),(577,6,32400,0,'+09'),(577,7,28800,0,'+08'),(578,0,6952,0,'LMT'),(578,1,7016,0,'IMT'),(578,2,10800,1,'EEST'),(578,3,7200,0,'EET'),(578,4,10800,0,'+03'),(578,5,14400,1,'+04'),(578,6,10800,1,'EEST'),(578,7,7200,0,'EET'),(578,8,10800,1,'EEST'),(578,9,7200,0,'EET'),(578,10,10800,0,'+03'),(579,0,0,0,'UTC'),(580,0,-35976,0,'LMT'),(580,1,-36000,0,'AST'),(580,2,-32400,1,'AWT'),(580,3,-32400,1,'APT'),(580,4,-36000,0,'AHST'),(580,5,-32400,1,'AHDT'),(580,6,-32400,0,'YST'),(580,7,-28800,1,'AKDT'),(580,8,-32400,0,'AKST'),(581,0,-42398,0,'LMT'),(581,1,-39600,0,'NST'),(581,2,-36000,1,'NWT'),(581,3,-36000,1,'NPT'),(581,4,-39600,0,'BST'),(581,5,-36000,1,'BDT'),(581,6,-36000,0,'AHST'),(581,7,-32400,1,'HDT'),(581,8,-36000,0,'HST'),(582,0,-26898,0,'LMT'),(582,1,-21600,1,'MDT'),(582,2,-25200,0,'MST'),(582,3,-21600,1,'MWT'),(582,4,-25200,0,'MST'),(583,0,-21036,0,'LMT'),(583,1,-18000,1,'CDT'),(583,2,-21600,0,'CST'),(583,3,-21600,0,'CST'),(583,4,-18000,0,'EST'),(583,5,-18000,1,'CWT'),(583,6,-18000,1,'CPT'),(583,7,-21600,0,'CST'),(584,0,-20678,0,'LMT'),(584,1,-18000,1,'CDT'),(584,2,-21600,0,'CST'),(584,3,-21600,0,'CST'),(584,4,-18000,1,'CWT'),(584,5,-18000,1,'CPT'),(584,6,-18000,0,'EST'),(584,7,-14400,1,'EDT'),(585,0,-17762,0,'LMT'),(585,1,-14400,1,'EDT'),(585,2,-18000,0,'EST'),(585,3,-18000,0,'EST'),(585,4,-14400,1,'EWT'),(585,5,-14400,1,'EPT'),(586,0,-37886,0,'LMT'),(586,1,-37800,0,'HST'),(586,2,-34200,1,'HDT'),(586,3,-34200,1,'HWT'),(586,4,-34200,1,'HPT'),(586,5,-36000,0,'HST'),(587,0,-20790,0,'LMT'),(587,1,-18000,1,'CDT'),(587,2,-21600,0,'CST'),(587,3,-18000,1,'CWT'),(587,4,-18000,1,'CPT'),(587,5,-21600,0,'CST'),(587,6,-18000,0,'EST'),(587,7,-21600,0,'CST'),(588,0,-19931,0,'LMT'),(588,1,-21600,0,'CST'),(588,2,-18000,0,'EST'),(588,3,-14400,1,'EWT'),(588,4,-14400,1,'EPT'),(588,5,-14400,1,'EDT'),(589,0,-25196,0,'LMT'),(589,1,-21600,1,'MDT'),(589,2,-25200,0,'MST'),(589,3,-25200,0,'MST'),(589,4,-21600,1,'MWT'),(589,5,-21600,1,'MPT'),(590,0,-28378,0,'LMT'),(590,1,-25200,1,'PDT'),(590,2,-28800,0,'PST'),(590,3,-25200,1,'PWT'),(590,4,-25200,1,'PPT'),(590,5,-28800,0,'PST'),(591,0,45432,0,'LMT'),(591,1,-40968,0,'LMT'),(591,2,-39600,0,'SST'),(592,0,0,0,'UTC'),(593,0,0,0,'UTC'),(594,0,9017,0,'LMT'),(594,1,9017,0,'MMT'),(594,2,12679,1,'MST'),(594,3,9079,0,'MMT'),(594,4,16279,1,'MDST'),(594,5,14400,1,'MSD'),(594,6,10800,0,'MSK'),(594,7,14400,1,'MSD'),(594,8,18000,1,'+05'),(594,9,7200,0,'EET'),(594,10,10800,0,'MSK'),(594,11,14400,1,'MSD'),(594,12,10800,1,'EEST'),(594,13,7200,0,'EET'),(594,14,14400,0,'MSK'),(594,15,14400,1,'MSD'),(594,16,10800,0,'MSK'),(595,0,3600,1,'WEST'),(595,1,0,0,'WET'),(596,0,0,0,'UTC'),(597,0,-968,0,'LMT'),(597,1,0,0,'GMT'),(598,0,-968,0,'LMT'),(598,1,0,0,'GMT'),(599,0,8836,0,'LMT'),(599,1,9000,0,'+0230'),(599,2,10800,0,'EAT'),(599,3,9900,0,'+0245'),(599,4,10800,0,'EAT'),(600,0,732,0,'LMT'),(600,1,561,0,'PMT'),(600,2,3600,1,'WEST'),(600,3,0,0,'WET'),(600,4,0,0,'WET'),(600,5,7200,1,'CEST'),(600,6,3600,0,'CET'),(600,7,3600,1,'WEST'),(601,0,8836,0,'LMT'),(601,1,9000,0,'+0230'),(601,2,10800,0,'EAT'),(601,3,9900,0,'+0245'),(601,4,10800,0,'EAT'),(602,0,8836,0,'LMT'),(602,1,9000,0,'+0230'),(602,2,10800,0,'EAT'),(602,3,9900,0,'+0245'),(602,4,10800,0,'EAT'),(603,0,-968,0,'LMT'),(603,1,0,0,'GMT'),(604,0,815,0,'LMT'),(604,1,0,0,'GMT'),(604,2,1800,0,'+0030'),(604,3,3600,0,'WAT'),(605,0,-968,0,'LMT'),(605,1,0,0,'GMT'),(606,0,-3740,0,'LMT'),(606,1,-3600,0,'-01'),(606,2,0,0,'GMT'),(607,0,7820,0,'LMT'),(607,1,7200,0,'CAT'),(608,0,815,0,'LMT'),(608,1,0,0,'GMT'),(608,2,1800,0,'+0030'),(608,3,3600,0,'WAT'),(609,0,7820,0,'LMT'),(609,1,7200,0,'CAT'),(610,0,7509,0,'LMT'),(610,1,10800,1,'EEST'),(610,2,7200,0,'EET'),(610,3,10800,1,'EEST'),(611,0,-1820,0,'LMT'),(611,1,3600,1,'+01'),(611,2,0,0,'+00'),(611,3,3600,0,'+01'),(611,4,0,0,'+00'),(612,0,-1276,0,'LMT'),(612,1,0,0,'WET'),(612,2,3600,1,'WEST'),(612,3,0,0,'WET'),(612,4,0,0,'WET'),(612,5,3600,0,'CET'),(612,6,7200,1,'CEST'),(612,7,3600,0,'CET'),(613,0,-968,0,'LMT'),(613,1,0,0,'GMT'),(614,0,-968,0,'LMT'),(614,1,0,0,'GMT'),(615,0,8836,0,'LMT'),(615,1,9000,0,'+0230'),(615,2,10800,0,'EAT'),(615,3,9900,0,'+0245'),(615,4,10800,0,'EAT'),(616,0,8836,0,'LMT'),(616,1,9000,0,'+0230'),(616,2,10800,0,'EAT'),(616,3,9900,0,'+0245'),(616,4,10800,0,'EAT'),(617,0,815,0,'LMT'),(617,1,0,0,'GMT'),(617,2,1800,0,'+0030'),(617,3,3600,0,'WAT'),(618,0,-3168,0,'LMT'),(618,1,-3600,0,'-01'),(618,2,3600,1,'+01'),(618,3,0,0,'+00'),(619,0,-968,0,'LMT'),(619,1,0,0,'GMT'),(620,0,7820,0,'LMT'),(620,1,7200,0,'CAT'),(621,0,7820,0,'LMT'),(621,1,7200,0,'CAT'),(622,0,6720,0,'LMT'),(622,1,5400,0,'SAST'),(622,2,10800,1,'SAST'),(622,3,7200,0,'SAST'),(623,0,7588,0,'LMT'),(623,1,10800,1,'CAST'),(623,2,7200,0,'CAT'),(623,3,10800,0,'EAT'),(623,4,7200,0,'CAT'),(624,0,8836,0,'LMT'),(624,1,9000,0,'+0230'),(624,2,10800,0,'EAT'),(624,3,9900,0,'+0245'),(624,4,10800,0,'EAT'),(625,0,7808,0,'LMT'),(625,1,10800,1,'CAST'),(625,2,7200,0,'CAT'),(625,3,10800,0,'EAT'),(625,4,7200,0,'CAT'),(626,0,7820,0,'LMT'),(626,1,7200,0,'CAT'),(627,0,815,0,'LMT'),(627,1,0,0,'GMT'),(627,2,1800,0,'+0030'),(627,3,3600,0,'WAT'),(628,0,815,0,'LMT'),(628,1,0,0,'GMT'),(628,2,1800,0,'+0030'),(628,3,3600,0,'WAT'),(629,0,815,0,'LMT'),(629,1,0,0,'GMT'),(629,2,1800,0,'+0030'),(629,3,3600,0,'WAT'),(630,0,-968,0,'LMT'),(630,1,0,0,'GMT'),(631,0,815,0,'LMT'),(631,1,0,0,'GMT'),(631,2,1800,0,'+0030'),(631,3,3600,0,'WAT'),(632,0,7820,0,'LMT'),(632,1,7200,0,'CAT'),(633,0,7820,0,'LMT'),(633,1,7200,0,'CAT'),(634,0,815,0,'LMT'),(634,1,0,0,'GMT'),(634,2,1800,0,'+0030'),(634,3,3600,0,'WAT'),(635,0,7820,0,'LMT'),(635,1,7200,0,'CAT'),(636,0,6720,0,'LMT'),(636,1,5400,0,'SAST'),(636,2,10800,1,'SAST'),(636,3,7200,0,'SAST'),(637,0,6720,0,'LMT'),(637,1,5400,0,'SAST'),(637,2,10800,1,'SAST'),(637,3,7200,0,'SAST'),(638,0,8836,0,'LMT'),(638,1,9000,0,'+0230'),(638,2,10800,0,'EAT'),(638,3,9900,0,'+0245'),(638,4,10800,0,'EAT'),(639,0,-2588,0,'LMT'),(639,1,-2588,0,'MMT'),(639,2,-2670,0,'MMT'),(639,3,0,0,'GMT'),(640,0,8836,0,'LMT'),(640,1,9000,0,'+0230'),(640,2,10800,0,'EAT'),(640,3,9900,0,'+0245'),(640,4,10800,0,'EAT'),(641,0,3612,0,'LMT'),(641,1,3600,0,'WAT'),(641,2,7200,1,'WAST'),(642,0,815,0,'LMT'),(642,1,0,0,'GMT'),(642,2,1800,0,'+0030'),(642,3,3600,0,'WAT'),(643,0,-968,0,'LMT'),(643,1,0,0,'GMT'),(644,0,-968,0,'LMT'),(644,1,0,0,'GMT'),(645,0,815,0,'LMT'),(645,1,0,0,'GMT'),(645,2,1800,0,'+0030'),(645,3,3600,0,'WAT'),(646,0,1616,0,'LMT'),(646,1,-2205,0,'LMT'),(646,2,0,0,'GMT'),(646,3,3600,0,'WAT'),(646,4,0,0,'GMT'),(647,0,-968,0,'LMT'),(647,1,0,0,'GMT'),(648,0,3164,0,'LMT'),(648,1,7200,1,'CEST'),(648,2,3600,0,'CET'),(648,3,7200,0,'EET'),(649,0,2444,0,'LMT'),(649,1,561,0,'PMT'),(649,2,7200,1,'CEST'),(649,3,3600,0,'CET'),(649,4,3600,0,'CET'),(649,5,7200,1,'CEST'),(650,0,4104,0,'LMT'),(650,1,5400,0,'+0130'),(650,2,7200,0,'SAST'),(650,3,10800,1,'SAST'),(650,4,7200,0,'CAT'),(650,5,3600,0,'WAT'),(650,6,7200,1,'CAT'),(650,7,7200,0,'CAT'),(651,0,-42398,0,'LMT'),(651,1,-39600,0,'NST'),(651,2,-36000,1,'NWT'),(651,3,-36000,1,'NPT'),(651,4,-39600,0,'BST'),(651,5,-36000,1,'BDT'),(651,6,-36000,0,'AHST'),(651,7,-32400,1,'HDT'),(651,8,-36000,0,'HST'),(652,0,-35976,0,'LMT'),(652,1,-36000,0,'AST'),(652,2,-32400,1,'AWT'),(652,3,-32400,1,'APT'),(652,4,-36000,0,'AHST'),(652,5,-32400,1,'AHDT'),(652,6,-32400,0,'YST'),(652,7,-28800,1,'AKDT'),(652,8,-32400,0,'AKST'),(653,0,-15865,0,'LMT'),(653,1,-14400,0,'AST'),(653,2,-10800,1,'APT'),(653,3,-10800,1,'AWT'),(654,0,-15865,0,'LMT'),(654,1,-14400,0,'AST'),(654,2,-10800,1,'APT'),(654,3,-10800,1,'AWT'),(655,0,-11568,0,'LMT'),(655,1,-7200,1,'-02'),(655,2,-10800,0,'-03'),(656,0,-14028,0,'LMT'),(656,1,-15408,0,'CMT'),(656,2,-14400,0,'-04'),(656,3,-10800,1,'-03'),(656,4,-7200,1,'-02'),(656,5,-10800,0,'-03'),(657,0,-15788,0,'LMT'),(657,1,-15408,0,'CMT'),(657,2,-14400,0,'-04'),(657,3,-10800,1,'-03'),(657,4,-7200,1,'-02'),(657,5,-10800,0,'-03'),(658,0,-15788,0,'LMT'),(658,1,-15408,0,'CMT'),(658,2,-14400,0,'-04'),(658,3,-10800,1,'-03'),(658,4,-7200,1,'-02'),(658,5,-10800,0,'-03'),(659,0,-15408,0,'LMT'),(659,1,-15408,0,'CMT'),(659,2,-14400,0,'-04'),(659,3,-10800,1,'-03'),(659,4,-7200,1,'-02'),(659,5,-10800,0,'-03'),(660,0,-15672,0,'LMT'),(660,1,-15408,0,'CMT'),(660,2,-14400,0,'-04'),(660,3,-10800,1,'-03'),(660,4,-7200,1,'-02'),(660,5,-10800,0,'-03'),(661,0,-16044,0,'LMT'),(661,1,-15408,0,'CMT'),(661,2,-14400,0,'-04'),(661,3,-10800,1,'-03'),(661,4,-7200,1,'-02'),(661,5,-10800,0,'-03'),(662,0,-16516,0,'LMT'),(662,1,-15408,0,'CMT'),(662,2,-14400,0,'-04'),(662,3,-10800,1,'-03'),(662,4,-7200,1,'-02'),(662,5,-10800,0,'-03'),(663,0,-16612,0,'LMT'),(663,1,-15408,0,'CMT'),(663,2,-14400,0,'-04'),(663,3,-10800,1,'-03'),(663,4,-7200,1,'-02'),(663,5,-10800,0,'-03'),(664,0,-15700,0,'LMT'),(664,1,-15408,0,'CMT'),(664,2,-14400,0,'-04'),(664,3,-10800,1,'-03'),(664,4,-7200,1,'-02'),(664,5,-10800,0,'-03'),(665,0,-16444,0,'LMT'),(665,1,-15408,0,'CMT'),(665,2,-14400,0,'-04'),(665,3,-10800,1,'-03'),(665,4,-7200,1,'-02'),(665,5,-10800,0,'-03'),(666,0,-15924,0,'LMT'),(666,1,-15408,0,'CMT'),(666,2,-14400,0,'-04'),(666,3,-10800,1,'-03'),(666,4,-7200,1,'-02'),(666,5,-10800,0,'-03'),(666,6,-10800,1,'-03'),(667,0,-15652,0,'LMT'),(667,1,-15408,0,'CMT'),(667,2,-14400,0,'-04'),(667,3,-10800,1,'-03'),(667,4,-7200,1,'-02'),(667,5,-10800,0,'-03'),(668,0,-16392,0,'LMT'),(668,1,-15408,0,'CMT'),(668,2,-14400,0,'-04'),(668,3,-10800,1,'-03'),(668,4,-7200,1,'-02'),(668,5,-10800,0,'-03'),(669,0,-15865,0,'LMT'),(669,1,-14400,0,'AST'),(669,2,-10800,1,'APT'),(669,3,-10800,1,'AWT'),(670,0,-13840,0,'LMT'),(670,1,-13840,0,'AMT'),(670,2,-14400,0,'-04'),(670,3,-10800,0,'-03'),(670,4,-10800,1,'-03'),(670,5,-14400,0,'-04'),(671,0,-19088,0,'LMT'),(671,1,-19176,0,'CMT'),(671,2,-18000,0,'EST'),(672,0,-42398,0,'LMT'),(672,1,-39600,0,'NST'),(672,2,-36000,1,'NWT'),(672,3,-36000,1,'NPT'),(672,4,-39600,0,'BST'),(672,5,-36000,1,'BDT'),(672,6,-36000,0,'AHST'),(672,7,-32400,1,'HDT'),(672,8,-36000,0,'HST'),(673,0,-9244,0,'LMT'),(673,1,-7200,1,'-02'),(673,2,-10800,0,'-03'),(674,0,-25260,0,'LMT'),(674,1,-25200,0,'MST'),(674,2,-21600,0,'CST'),(674,3,-21600,1,'MDT'),(674,4,-25200,0,'MST'),(674,5,-28800,0,'PST'),(674,6,-18000,1,'CDT'),(674,7,-21600,0,'CST'),(675,0,-14309,0,'LMT'),(675,1,-10800,1,'ADT'),(675,2,-14400,0,'AST'),(675,3,-14400,0,'AST'),(675,4,-12600,1,'-0330'),(675,5,-10800,1,'ADT'),(676,0,-11636,0,'LMT'),(676,1,-7200,1,'-02'),(676,2,-10800,0,'-03'),(677,0,-21168,0,'LMT'),(677,1,-19800,1,'-0530'),(677,2,-21600,0,'CST'),(677,3,-18000,1,'CWT'),(677,4,-18000,1,'CPT'),(677,5,-18000,1,'CDT'),(678,0,-15865,0,'LMT'),(678,1,-14400,0,'AST'),(678,2,-10800,1,'APT'),(678,3,-10800,1,'AWT'),(679,0,-14560,0,'LMT'),(679,1,-10800,1,'-03'),(679,2,-14400,0,'-04'),(680,0,-17776,0,'LMT'),(680,1,-17776,0,'BMT'),(680,2,-14400,1,'-04'),(680,3,-18000,0,'-05'),(681,0,-27889,0,'LMT'),(681,1,-25200,1,'PDT'),(681,2,-28800,0,'PST'),(681,3,-28800,0,'PST'),(681,4,-21600,1,'MWT'),(681,5,-21600,1,'MPT'),(681,6,-25200,0,'MST'),(681,7,-21600,1,'MDT'),(682,0,-14028,0,'LMT'),(682,1,-15408,0,'CMT'),(682,2,-14400,0,'-04'),(682,3,-10800,1,'-03'),(682,4,-7200,1,'-02'),(682,5,-10800,0,'-03'),(683,0,0,0,'-00'),(683,1,-21600,1,'MWT'),(683,2,-21600,1,'MPT'),(683,3,-25200,0,'MST'),(683,4,-21600,1,'MDT'),(683,5,-18000,1,'CDT'),(683,6,-21600,0,'CST'),(683,7,-18000,0,'EST'),(683,8,-21600,1,'MDT'),(683,9,-25200,0,'MST'),(684,0,-13108,0,'LMT'),(684,1,-10800,1,'-03'),(684,2,-14400,0,'-04'),(685,0,-20824,0,'LMT'),(685,1,-21600,0,'CST'),(685,2,-14400,1,'EDT'),(685,3,-18000,0,'EST'),(685,4,-21600,0,'CST'),(685,5,-18000,1,'CDT'),(685,6,-18000,0,'EST'),(686,0,-16064,0,'LMT'),(686,1,-16060,0,'CMT'),(686,2,-16200,0,'-0430'),(686,3,-14400,0,'-04'),(687,0,-15788,0,'LMT'),(687,1,-15408,0,'CMT'),(687,2,-14400,0,'-04'),(687,3,-10800,1,'-03'),(687,4,-7200,1,'-02'),(687,5,-10800,0,'-03'),(688,0,-12560,0,'LMT'),(688,1,-14400,0,'-04'),(688,2,-10800,0,'-03'),(689,0,-19088,0,'LMT'),(689,1,-19176,0,'CMT'),(689,2,-18000,0,'EST'),(690,0,-21036,0,'LMT'),(690,1,-18000,1,'CDT'),(690,2,-21600,0,'CST'),(690,3,-21600,0,'CST'),(690,4,-18000,0,'EST'),(690,5,-18000,1,'CWT'),(690,6,-18000,1,'CPT'),(690,7,-21600,0,'CST'),(691,0,-25460,0,'LMT'),(691,1,-25200,0,'MST'),(691,2,-21600,0,'CST'),(691,3,-21600,1,'MDT'),(691,4,-25200,0,'MST'),(691,5,-18000,1,'CDT'),(691,6,-21600,1,'MDT'),(691,7,-21600,0,'CST'),(692,0,-25556,0,'LMT'),(692,1,-25200,0,'MST'),(692,2,-21600,0,'CST'),(692,3,-21600,1,'MDT'),(692,4,-25200,0,'MST'),(692,5,-18000,1,'CDT'),(692,6,-21600,1,'MDT'),(693,0,-19088,0,'LMT'),(693,1,-19176,0,'CMT'),(693,2,-18000,0,'EST'),(694,0,-15408,0,'LMT'),(694,1,-15408,0,'CMT'),(694,2,-14400,0,'-04'),(694,3,-10800,1,'-03'),(694,4,-7200,1,'-02'),(694,5,-10800,0,'-03'),(695,0,-20173,0,'LMT'),(695,1,-20173,0,'SJMT'),(695,2,-18000,1,'CDT'),(695,3,-21600,0,'CST'),(696,0,-26898,0,'LMT'),(696,1,-21600,1,'MDT'),(696,2,-25200,0,'MST'),(696,3,-21600,1,'MWT'),(696,4,-25200,0,'MST'),(697,0,-13460,0,'LMT'),(697,1,-10800,1,'-03'),(697,2,-14400,0,'-04'),(698,0,-15865,0,'LMT'),(698,1,-14400,0,'AST'),(698,2,-10800,1,'APT'),(698,3,-10800,1,'AWT'),(699,0,-4480,0,'LMT'),(699,1,-10800,0,'-03'),(699,2,-10800,0,'-03'),(699,3,-7200,1,'-02'),(699,4,-7200,1,'-02'),(699,5,0,0,'GMT'),(700,0,-33460,0,'LMT'),(700,1,-28800,1,'YDT'),(700,2,-32400,0,'YST'),(700,3,-28800,1,'YWT'),(700,4,-28800,1,'YPT'),(700,5,-25200,1,'YDDT'),(700,6,-28800,0,'PST'),(700,7,-25200,1,'PDT'),(700,8,-25200,0,'MST'),(701,0,-28856,0,'LMT'),(701,1,-25200,1,'PDT'),(701,2,-28800,0,'PST'),(701,3,-25200,1,'PWT'),(701,4,-25200,1,'PPT'),(701,5,-25200,0,'MST'),(702,0,-25196,0,'LMT'),(702,1,-21600,1,'MDT'),(702,2,-25200,0,'MST'),(702,3,-25200,0,'MST'),(702,4,-21600,1,'MWT'),(702,5,-21600,1,'MPT'),(703,0,-19931,0,'LMT'),(703,1,-21600,0,'CST'),(703,2,-18000,0,'EST'),(703,3,-14400,1,'EWT'),(703,4,-14400,1,'EPT'),(703,5,-14400,1,'EDT'),(704,0,-15865,0,'LMT'),(704,1,-14400,0,'AST'),(704,2,-10800,1,'APT'),(704,3,-10800,1,'AWT'),(705,0,-27232,0,'LMT'),(705,1,-21600,1,'MDT'),(705,2,-25200,0,'MST'),(705,3,-21600,1,'MWT'),(705,4,-21600,1,'MPT'),(706,0,-16768,0,'LMT'),(706,1,-14400,1,'-04'),(706,2,-18000,0,'-05'),(706,3,-14400,0,'-04'),(706,4,-18000,0,'-05'),(707,0,-21408,0,'LMT'),(707,1,-18000,1,'CDT'),(707,2,-21600,0,'CST'),(708,0,-28084,0,'LMT'),(708,1,-25200,0,'MST'),(708,2,-28800,0,'PST'),(708,3,-25200,0,'MST'),(708,4,-25200,1,'PDT'),(708,5,-25200,1,'PWT'),(708,6,-25200,1,'PPT'),(708,7,-28800,0,'PST'),(709,0,-29447,0,'LMT'),(709,1,-25200,1,'PDT'),(709,2,-28800,0,'PST'),(709,3,-25200,1,'PWT'),(709,4,-25200,1,'PPT'),(709,5,-25200,0,'MST'),(710,0,-20678,0,'LMT'),(710,1,-18000,1,'CDT'),(710,2,-21600,0,'CST'),(710,3,-21600,0,'CST'),(710,4,-18000,1,'CWT'),(710,5,-18000,1,'CPT'),(710,6,-18000,0,'EST'),(710,7,-14400,1,'EDT'),(711,0,-9240,0,'LMT'),(711,1,-7200,1,'-02'),(711,2,-10800,0,'-03'),(712,0,-14388,0,'LMT'),(712,1,-10800,1,'ADT'),(712,2,-14400,0,'AST'),(712,3,-10800,1,'AWT'),(712,4,-10800,1,'APT'),(713,0,-12416,0,'LMT'),(713,1,-10800,0,'-03'),(713,2,-10800,0,'-03'),(713,3,-7200,1,'-02'),(713,4,-7200,1,'-02'),(713,5,-7200,0,'-02'),(713,6,-3600,1,'-01'),(714,0,-14500,0,'LMT'),(714,1,-12652,0,'NST'),(714,2,-9052,1,'NDT'),(714,3,-12600,0,'NST'),(714,4,-9000,1,'NDT'),(714,5,-9000,1,'NPT'),(714,6,-9000,1,'NWT'),(714,7,-10800,1,'ADT'),(714,8,-14400,0,'AST'),(714,9,-7200,1,'ADDT'),(714,10,-10800,1,'ADT'),(715,0,-17072,0,'LMT'),(715,1,-18430,0,'KMT'),(715,2,-18000,0,'EST'),(715,3,-14400,1,'EDT'),(715,4,-14400,0,'AST'),(715,5,-18000,0,'EST'),(716,0,-15865,0,'LMT'),(716,1,-14400,0,'AST'),(716,2,-10800,1,'APT'),(716,3,-10800,1,'AWT'),(717,0,-15865,0,'LMT'),(717,1,-14400,0,'AST'),(717,2,-10800,1,'APT'),(717,3,-10800,1,'AWT'),(718,0,-21724,0,'LMT'),(718,1,-18000,1,'CDT'),(718,2,-21600,0,'CST'),(719,0,-19160,0,'LMT'),(719,1,-18840,0,'QMT'),(719,2,-14400,1,'-04'),(719,3,-18000,0,'-05'),(720,0,-13959,0,'LMT'),(720,1,-14400,0,'-04'),(720,2,-13500,0,'-0345'),(720,3,-10800,0,'-03'),(720,4,-14400,0,'-04'),(721,0,-15264,0,'LMT'),(721,1,-10800,1,'ADT'),(721,2,-14400,0,'AST'),(721,3,-10800,1,'AWT'),(721,4,-10800,1,'APT'),(722,0,-19768,0,'LMT'),(722,1,-19776,0,'HMT'),(722,2,-14400,1,'CDT'),(722,3,-18000,0,'CST'),(722,4,-18000,0,'CST'),(722,5,-14400,1,'CDT'),(723,0,-26632,0,'LMT'),(723,1,-25200,0,'MST'),(723,2,-21600,0,'CST'),(723,3,-21600,1,'MDT'),(723,4,-25200,0,'MST'),(723,5,-28800,0,'PST'),(723,6,-25200,0,'MST'),(724,0,-20678,0,'LMT'),(724,1,-18000,1,'CDT'),(724,2,-21600,0,'CST'),(724,3,-21600,0,'CST'),(724,4,-18000,1,'CWT'),(724,5,-18000,1,'CPT'),(724,6,-18000,0,'EST'),(724,7,-14400,1,'EDT'),(725,0,-20790,0,'LMT'),(725,1,-18000,1,'CDT'),(725,2,-21600,0,'CST'),(725,3,-18000,1,'CWT'),(725,4,-18000,1,'CPT'),(725,5,-21600,0,'CST'),(725,6,-18000,0,'EST'),(725,7,-21600,0,'CST'),(726,0,-20723,0,'LMT'),(726,1,-18000,1,'CDT'),(726,2,-21600,0,'CST'),(726,3,-18000,1,'CWT'),(726,4,-18000,1,'CPT'),(726,5,-21600,0,'CST'),(726,6,-18000,0,'EST'),(726,7,-14400,1,'EDT'),(727,0,-20947,0,'LMT'),(727,1,-18000,1,'CDT'),(727,2,-21600,0,'CST'),(727,3,-18000,1,'CWT'),(727,4,-18000,1,'CPT'),(727,5,-21600,0,'CST'),(727,6,-18000,0,'EST'),(727,7,-14400,1,'EDT'),(728,0,-20823,0,'LMT'),(728,1,-18000,1,'CDT'),(728,2,-21600,0,'CST'),(728,3,-18000,1,'CWT'),(728,4,-18000,1,'CPT'),(728,5,-21600,0,'CST'),(728,6,-18000,0,'EST'),(728,7,-14400,1,'EDT'),(728,8,-18000,1,'CDT'),(728,9,-21600,0,'CST'),(729,0,-20416,0,'LMT'),(729,1,-18000,1,'CDT'),(729,2,-21600,0,'CST'),(729,3,-18000,1,'CWT'),(729,4,-18000,1,'CPT'),(729,5,-21600,0,'CST'),(729,6,-18000,0,'EST'),(729,7,-14400,1,'EDT'),(730,0,-21007,0,'LMT'),(730,1,-18000,1,'CDT'),(730,2,-21600,0,'CST'),(730,3,-18000,1,'CWT'),(730,4,-18000,1,'CPT'),(730,5,-21600,0,'CST'),(730,6,-18000,0,'EST'),(730,7,-14400,1,'EDT'),(731,0,-20785,0,'LMT'),(731,1,-18000,1,'CDT'),(731,2,-21600,0,'CST'),(731,3,-18000,1,'CWT'),(731,4,-18000,1,'CPT'),(731,5,-21600,0,'CST'),(731,6,-18000,0,'EST'),(731,7,-14400,1,'EDT'),(732,0,-20678,0,'LMT'),(732,1,-18000,1,'CDT'),(732,2,-21600,0,'CST'),(732,3,-21600,0,'CST'),(732,4,-18000,1,'CWT'),(732,5,-18000,1,'CPT'),(732,6,-18000,0,'EST'),(732,7,-14400,1,'EDT'),(733,0,0,0,'-00'),(733,1,-25200,1,'PDT'),(733,2,-28800,0,'PST'),(733,3,-25200,0,'MST'),(733,4,-21600,1,'MDT'),(734,0,0,0,'-00'),(734,1,-14400,1,'EPT'),(734,2,-18000,0,'EST'),(734,3,-14400,1,'EDT'),(734,4,-14400,1,'EWT'),(734,5,-21600,0,'CST'),(734,6,-18000,1,'CDT'),(734,7,-14400,1,'EDT'),(734,8,-18000,0,'EST'),(735,0,-18430,0,'LMT'),(735,1,-18430,0,'KMT'),(735,2,-18000,0,'EST'),(735,3,-14400,1,'EDT'),(736,0,-15672,0,'LMT'),(736,1,-15408,0,'CMT'),(736,2,-14400,0,'-04'),(736,3,-10800,1,'-03'),(736,4,-7200,1,'-02'),(736,5,-10800,0,'-03'),(737,0,-32261,0,'LMT'),(737,1,-28800,0,'PST'),(737,2,-25200,1,'PWT'),(737,3,-25200,1,'PPT'),(737,4,-25200,1,'PDT'),(737,5,-28800,1,'YDT'),(737,6,-32400,0,'YST'),(737,7,-28800,1,'AKDT'),(737,8,-32400,0,'AKST'),(738,0,-20582,0,'LMT'),(738,1,-18000,1,'CDT'),(738,2,-21600,0,'CST'),(738,3,-21600,0,'CST'),(738,4,-18000,1,'CWT'),(738,5,-18000,1,'CPT'),(738,6,-18000,0,'EST'),(738,7,-14400,1,'EDT'),(739,0,-20364,0,'LMT'),(739,1,-18000,1,'CDT'),(739,2,-21600,0,'CST'),(739,3,-18000,1,'CWT'),(739,4,-18000,1,'CPT'),(739,5,-21600,0,'CST'),(739,6,-14400,1,'EDT'),(739,7,-18000,0,'EST'),(740,0,-20790,0,'LMT'),(740,1,-18000,1,'CDT'),(740,2,-21600,0,'CST'),(740,3,-18000,1,'CWT'),(740,4,-18000,1,'CPT'),(740,5,-21600,0,'CST'),(740,6,-18000,0,'EST'),(740,7,-21600,0,'CST'),(741,0,-15865,0,'LMT'),(741,1,-14400,0,'AST'),(741,2,-10800,1,'APT'),(741,3,-10800,1,'AWT'),(742,0,-16356,0,'LMT'),(742,1,-16356,0,'CMT'),(742,2,-12756,1,'BST'),(742,3,-14400,0,'-04'),(743,0,-18492,0,'LMT'),(743,1,-18516,0,'LMT'),(743,2,-14400,1,'-04'),(743,3,-18000,0,'-05'),(744,0,-28378,0,'LMT'),(744,1,-25200,1,'PDT'),(744,2,-28800,0,'PST'),(744,3,-25200,1,'PWT'),(744,4,-25200,1,'PPT'),(744,5,-28800,0,'PST'),(745,0,-20582,0,'LMT'),(745,1,-18000,1,'CDT'),(745,2,-21600,0,'CST'),(745,3,-21600,0,'CST'),(745,4,-18000,1,'CWT'),(745,5,-18000,1,'CPT'),(745,6,-18000,0,'EST'),(745,7,-14400,1,'EDT'),(746,0,-15865,0,'LMT'),(746,1,-14400,0,'AST'),(746,2,-10800,1,'APT'),(746,3,-10800,1,'AWT'),(747,0,-8572,0,'LMT'),(747,1,-7200,1,'-02'),(747,2,-10800,0,'-03'),(748,0,-20708,0,'LMT'),(748,1,-20712,0,'MMT'),(748,2,-21600,0,'CST'),(748,3,-18000,0,'EST'),(748,4,-18000,1,'CDT'),(748,5,-21600,0,'CST'),(749,0,-14404,0,'LMT'),(749,1,-10800,1,'-03'),(749,2,-14400,0,'-04'),(750,0,-15865,0,'LMT'),(750,1,-14400,0,'AST'),(750,2,-10800,1,'APT'),(750,3,-10800,1,'AWT'),(751,0,-14660,0,'LMT'),(751,1,-14660,0,'FFMT'),(751,2,-14400,0,'AST'),(751,3,-10800,1,'ADT'),(752,0,-23400,0,'LMT'),(752,1,-21600,0,'CST'),(752,2,-18000,1,'CDT'),(752,3,-21600,0,'CST'),(753,0,-25540,0,'LMT'),(753,1,-25200,0,'MST'),(753,2,-21600,0,'CST'),(753,3,-21600,1,'MDT'),(753,4,-25200,0,'MST'),(753,5,-28800,0,'PST'),(753,6,-25200,0,'MST'),(754,0,-16516,0,'LMT'),(754,1,-15408,0,'CMT'),(754,2,-14400,0,'-04'),(754,3,-10800,1,'-03'),(754,4,-7200,1,'-02'),(754,5,-10800,0,'-03'),(755,0,-21027,0,'LMT'),(755,1,-18000,1,'CDT'),(755,2,-21600,0,'CST'),(755,3,-18000,1,'CWT'),(755,4,-18000,1,'CPT'),(755,5,-18000,0,'EST'),(755,6,-21600,0,'CST'),(756,0,-21508,0,'LMT'),(756,1,-21600,0,'CST'),(756,2,-18000,0,'EST'),(756,3,-18000,1,'CDT'),(756,4,-21600,0,'CST'),(757,0,-31578,0,'LMT'),(757,1,-28800,0,'PST'),(757,2,-25200,1,'PWT'),(757,3,-25200,1,'PPT'),(757,4,-25200,1,'PDT'),(757,5,-32400,0,'AKST'),(757,6,-28800,1,'AKDT'),(758,0,-23796,0,'LMT'),(758,1,-25200,0,'MST'),(758,2,-21600,0,'CST'),(758,3,-21600,1,'MDT'),(758,4,-25200,0,'MST'),(758,5,-18000,1,'CDT'),(758,6,-18000,1,'CWT'),(758,7,-21600,0,'CST'),(759,0,-13480,0,'LMT'),(759,1,-14400,0,'AST'),(759,2,-10800,0,'-03'),(759,3,-7200,1,'-02'),(760,0,-15548,0,'LMT'),(760,1,-18000,0,'EST'),(760,2,-10800,1,'ADT'),(760,3,-14400,0,'AST'),(760,4,-10800,1,'AWT'),(760,5,-10800,1,'APT'),(761,0,-24076,0,'LMT'),(761,1,-21600,0,'CST'),(761,2,-18000,1,'CDT'),(761,3,-21600,0,'CST'),(762,0,-13491,0,'LMT'),(762,1,-13491,0,'MMT'),(762,2,-14400,0,'-04'),(762,3,-12600,0,'-0330'),(762,4,-10800,1,'-03'),(762,5,-10800,0,'-03'),(762,6,-9000,1,'-0230'),(762,7,-7200,1,'-02'),(762,8,-5400,1,'-0130'),(762,9,-7200,1,'-02'),(763,0,-19052,0,'LMT'),(763,1,-14400,1,'EDT'),(763,2,-18000,0,'EST'),(763,3,-14400,1,'EWT'),(763,4,-14400,1,'EPT'),(764,0,-15865,0,'LMT'),(764,1,-14400,0,'AST'),(764,2,-10800,1,'APT'),(764,3,-10800,1,'AWT'),(765,0,-19052,0,'LMT'),(765,1,-14400,1,'EDT'),(765,2,-18000,0,'EST'),(765,3,-14400,1,'EWT'),(765,4,-14400,1,'EPT'),(766,0,-17762,0,'LMT'),(766,1,-14400,1,'EDT'),(766,2,-18000,0,'EST'),(766,3,-18000,0,'EST'),(766,4,-14400,1,'EWT'),(766,5,-14400,1,'EPT'),(767,0,-19052,0,'LMT'),(767,1,-14400,1,'EDT'),(767,2,-18000,0,'EST'),(767,3,-14400,1,'EWT'),(767,4,-14400,1,'EPT'),(768,0,-39698,0,'LMT'),(768,1,-39600,0,'NST'),(768,2,-36000,1,'NWT'),(768,3,-36000,1,'NPT'),(768,4,-39600,0,'BST'),(768,5,-36000,1,'BDT'),(768,6,-32400,0,'YST'),(768,7,-28800,1,'AKDT'),(768,8,-32400,0,'AKST'),(769,0,-7780,0,'LMT'),(769,1,-3600,1,'-01'),(769,2,-7200,0,'-02'),(770,0,-24427,0,'LMT'),(770,1,-21600,1,'MDT'),(770,2,-25200,0,'MST'),(770,3,-21600,1,'MWT'),(770,4,-21600,1,'MPT'),(770,5,-25200,0,'MST'),(770,6,-18000,1,'CDT'),(770,7,-21600,0,'CST'),(771,0,-24312,0,'LMT'),(771,1,-21600,1,'MDT'),(771,2,-25200,0,'MST'),(771,3,-21600,1,'MWT'),(771,4,-21600,1,'MPT'),(771,5,-25200,0,'MST'),(771,6,-18000,1,'CDT'),(771,7,-21600,0,'CST'),(772,0,-24339,0,'LMT'),(772,1,-21600,1,'MDT'),(772,2,-25200,0,'MST'),(772,3,-21600,1,'MWT'),(772,4,-21600,1,'MPT'),(772,5,-25200,0,'MST'),(772,6,-18000,1,'CDT'),(772,7,-21600,0,'CST'),(773,0,-12416,0,'LMT'),(773,1,-10800,0,'-03'),(773,2,-10800,0,'-03'),(773,3,-7200,1,'-02'),(773,4,-7200,1,'-02'),(773,5,-7200,0,'-02'),(773,6,-3600,1,'-01'),(774,0,-25060,0,'LMT'),(774,1,-25200,0,'MST'),(774,2,-21600,0,'CST'),(774,3,-21600,1,'MDT'),(774,4,-25200,0,'MST'),(774,5,-18000,1,'CDT'),(774,6,-21600,0,'CST'),(775,0,-19088,0,'LMT'),(775,1,-19176,0,'CMT'),(775,2,-18000,0,'EST'),(776,0,0,0,'-00'),(776,1,-14400,1,'EPT'),(776,2,-18000,0,'EST'),(776,3,-14400,1,'EDT'),(776,4,-14400,1,'EWT'),(776,5,-21600,0,'CST'),(776,6,-18000,1,'CDT'),(776,7,-14400,1,'EDT'),(776,8,-18000,0,'EST'),(777,0,-13240,0,'LMT'),(777,1,-13252,0,'PMT'),(777,2,-13236,0,'PMT'),(777,3,-12600,0,'-0330'),(777,4,-10800,0,'-03'),(778,0,-26898,0,'LMT'),(778,1,-21600,1,'MDT'),(778,2,-25200,0,'MST'),(778,3,-21600,1,'MWT'),(778,4,-25200,0,'MST'),(779,0,-17360,0,'LMT'),(779,1,-17340,0,'PPMT'),(779,2,-14400,1,'EDT'),(779,3,-18000,0,'EST'),(779,4,-14400,1,'EDT'),(779,5,-18000,0,'EST'),(780,0,-15865,0,'LMT'),(780,1,-14400,0,'AST'),(780,2,-10800,1,'APT'),(780,3,-10800,1,'AWT'),(781,0,-16272,0,'LMT'),(781,1,-14400,1,'-04'),(781,2,-18000,0,'-05'),(781,3,-14400,0,'-04'),(781,4,-18000,0,'-05'),(782,0,-15336,0,'LMT'),(782,1,-10800,1,'-03'),(782,2,-14400,0,'-04'),(783,0,-15865,0,'LMT'),(783,1,-14400,0,'AST'),(783,2,-10800,1,'APT'),(783,3,-10800,1,'AWT'),(784,0,-17020,0,'LMT'),(784,1,-16965,0,'SMT'),(784,2,-18000,0,'-05'),(784,3,-14400,0,'-04'),(784,4,-14400,1,'-04'),(784,5,-10800,1,'-03'),(784,6,-14400,0,'-04'),(784,7,-10800,0,'-03'),(785,0,-23316,0,'LMT'),(785,1,-18000,1,'CDT'),(785,2,-21600,0,'CST'),(785,3,-18000,1,'CWT'),(785,4,-18000,1,'CPT'),(785,5,-18000,1,'CDT'),(785,6,-21600,0,'CST'),(786,0,0,0,'-00'),(786,1,-18000,1,'CDT'),(786,2,-21600,0,'CST'),(786,3,-18000,0,'EST'),(786,4,-21600,0,'CST'),(787,0,-8376,0,'LMT'),(787,1,-7200,1,'-02'),(787,2,-10800,0,'-03'),(788,0,-25116,0,'LMT'),(788,1,-21600,1,'MDT'),(788,2,-25200,0,'MST'),(788,3,-21600,1,'MWT'),(788,4,-21600,1,'MPT'),(788,5,-21600,0,'CST'),(789,0,0,0,'-00'),(789,1,-18000,1,'CDT'),(789,2,-21600,0,'CST'),(789,3,-18000,0,'EST'),(789,4,-21600,0,'CST'),(790,0,-16272,0,'LMT'),(790,1,-14400,1,'-04'),(790,2,-18000,0,'-05'),(790,3,-14400,0,'-04'),(790,4,-18000,0,'-05'),(791,0,-15408,0,'LMT'),(791,1,-15408,0,'CMT'),(791,2,-14400,0,'-04'),(791,3,-10800,1,'-03'),(791,4,-7200,1,'-02'),(791,5,-10800,0,'-03'),(792,0,-28084,0,'LMT'),(792,1,-25200,0,'MST'),(792,2,-28800,0,'PST'),(792,3,-25200,0,'MST'),(792,4,-25200,1,'PDT'),(792,5,-25200,1,'PWT'),(792,6,-25200,1,'PPT'),(792,7,-28800,0,'PST'),(793,0,-13128,0,'LMT'),(793,1,-10800,1,'-03'),(793,2,-14400,0,'-04'),(793,3,-10800,0,'-03'),(794,0,-16965,0,'LMT'),(794,1,-16965,0,'SMT'),(794,2,-18000,0,'-05'),(794,3,-14400,0,'-04'),(794,4,-14400,1,'-04'),(794,5,-10800,1,'-03'),(794,6,-10800,1,'-03'),(794,7,-14400,0,'-04'),(795,0,-16776,0,'LMT'),(795,1,-16800,0,'SDMT'),(795,2,-14400,1,'EDT'),(795,3,-18000,0,'EST'),(795,4,-16200,1,'-0430'),(795,5,-14400,0,'AST'),(796,0,-11188,0,'LMT'),(796,1,-7200,1,'-02'),(796,2,-10800,0,'-03'),(797,0,-5272,0,'LMT'),(797,1,-7200,0,'-02'),(797,2,-3600,1,'-01'),(797,3,-7200,0,'-02'),(797,4,-3600,0,'-01'),(797,5,0,1,'+00'),(797,6,0,1,'+00'),(798,0,-25196,0,'LMT'),(798,1,-21600,1,'MDT'),(798,2,-25200,0,'MST'),(798,3,-25200,0,'MST'),(798,4,-21600,1,'MWT'),(798,5,-21600,1,'MPT'),(799,0,-32473,0,'LMT'),(799,1,-28800,0,'PST'),(799,2,-25200,1,'PWT'),(799,3,-25200,1,'PPT'),(799,4,-25200,1,'PDT'),(799,5,-32400,0,'YST'),(799,6,-28800,1,'AKDT'),(799,7,-32400,0,'AKST'),(800,0,-15865,0,'LMT'),(800,1,-14400,0,'AST'),(800,2,-10800,1,'APT'),(800,3,-10800,1,'AWT'),(801,0,-12652,0,'LMT'),(801,1,-9052,1,'NDT'),(801,2,-12652,0,'NST'),(801,3,-9000,1,'NDT'),(801,4,-12600,0,'NST'),(801,5,-9000,1,'NPT'),(801,6,-9000,1,'NWT'),(801,7,-5400,1,'NDDT'),(801,8,-9000,1,'NDT'),(802,0,-15865,0,'LMT'),(802,1,-14400,0,'AST'),(802,2,-10800,1,'APT'),(802,3,-10800,1,'AWT'),(803,0,-15865,0,'LMT'),(803,1,-14400,0,'AST'),(803,2,-10800,1,'APT'),(803,3,-10800,1,'AWT'),(804,0,-15865,0,'LMT'),(804,1,-14400,0,'AST'),(804,2,-10800,1,'APT'),(804,3,-10800,1,'AWT'),(805,0,-15865,0,'LMT'),(805,1,-14400,0,'AST'),(805,2,-10800,1,'APT'),(805,3,-10800,1,'AWT'),(806,0,-25880,0,'LMT'),(806,1,-21600,1,'MDT'),(806,2,-25200,0,'MST'),(806,3,-21600,1,'MWT'),(806,4,-21600,1,'MPT'),(806,5,-21600,0,'CST'),(807,0,-20932,0,'LMT'),(807,1,-18000,1,'CDT'),(807,2,-21600,0,'CST'),(808,0,-16508,0,'LMT'),(808,1,-10800,1,'ADT'),(808,2,-14400,0,'AST'),(809,0,-19052,0,'LMT'),(809,1,-14400,1,'EDT'),(809,2,-18000,0,'EST'),(809,3,-14400,1,'EWT'),(809,4,-14400,1,'EPT'),(810,0,-28084,0,'LMT'),(810,1,-25200,0,'MST'),(810,2,-28800,0,'PST'),(810,3,-25200,0,'MST'),(810,4,-25200,1,'PDT'),(810,5,-25200,1,'PWT'),(810,6,-25200,1,'PPT'),(810,7,-28800,0,'PST'),(811,0,-19052,0,'LMT'),(811,1,-14400,1,'EDT'),(811,2,-18000,0,'EST'),(811,3,-14400,1,'EWT'),(811,4,-14400,1,'EPT'),(812,0,-15865,0,'LMT'),(812,1,-14400,0,'AST'),(812,2,-10800,1,'APT'),(812,3,-10800,1,'AWT'),(813,0,-29548,0,'LMT'),(813,1,-25200,1,'PDT'),(813,2,-28800,0,'PST'),(813,3,-25200,1,'PWT'),(813,4,-25200,1,'PPT'),(814,0,-15865,0,'LMT'),(814,1,-14400,0,'AST'),(814,2,-10800,1,'APT'),(814,3,-10800,1,'AWT'),(815,0,-32412,0,'LMT'),(815,1,-28800,1,'YDT'),(815,2,-32400,0,'YST'),(815,3,-28800,1,'YWT'),(815,4,-28800,1,'YPT'),(815,5,-25200,1,'YDDT'),(815,6,-28800,0,'PST'),(815,7,-25200,1,'PDT'),(815,8,-25200,0,'MST'),(816,0,-23316,0,'LMT'),(816,1,-18000,1,'CDT'),(816,2,-21600,0,'CST'),(816,3,-18000,1,'CWT'),(816,4,-18000,1,'CPT'),(816,5,-18000,1,'CDT'),(816,6,-21600,0,'CST'),(817,0,-33535,0,'LMT'),(817,1,-32400,0,'YST'),(817,2,-28800,1,'YWT'),(817,3,-28800,1,'YPT'),(817,4,-28800,1,'YDT'),(817,5,-28800,1,'AKDT'),(817,6,-32400,0,'AKST'),(818,0,-27232,0,'LMT'),(818,1,-21600,1,'MDT'),(818,2,-25200,0,'MST'),(818,3,-21600,1,'MWT'),(818,4,-21600,1,'MPT'),(819,0,0,0,'-00'),(819,1,28800,0,'+08'),(819,2,39600,0,'+11'),(819,3,28800,0,'+08'),(819,4,39600,0,'+11'),(820,0,0,0,'-00'),(820,1,25200,0,'+07'),(820,2,18000,0,'+05'),(820,3,25200,0,'+07'),(821,0,35312,0,'PMMT'),(821,1,36000,0,'+10'),(822,0,0,0,'-00'),(822,1,36000,0,'AEST'),(822,2,39600,1,'AEDT'),(822,3,36000,0,'AEST'),(822,4,0,0,'-00'),(822,5,39600,1,'AEDT'),(822,6,36000,0,'AEST'),(823,0,0,0,'-00'),(823,1,21600,0,'+06'),(823,2,18000,0,'+05'),(824,0,41944,0,'LMT'),(824,1,45000,1,'NZST'),(824,2,41400,0,'NZMT'),(824,3,43200,1,'NZST'),(824,4,46800,1,'NZDT'),(824,5,43200,0,'NZST'),(824,6,43200,0,'NZST'),(825,0,0,0,'-00'),(825,1,-14400,0,'-04'),(825,2,-10800,1,'-03'),(825,3,-7200,1,'-02'),(825,4,-10800,0,'-03'),(825,5,-10800,1,'-03'),(825,6,-14400,0,'-04'),(825,7,-10800,0,'-03'),(826,0,0,0,'-00'),(826,1,-10800,0,'-03'),(827,0,41944,0,'LMT'),(827,1,45000,1,'NZST'),(827,2,41400,0,'NZMT'),(827,3,43200,1,'NZST'),(827,4,46800,1,'NZDT'),(827,5,43200,0,'NZST'),(827,6,43200,0,'NZST'),(828,0,11212,0,'LMT'),(828,1,10800,0,'+03'),(829,0,0,0,'-00'),(829,1,7200,1,'+02'),(829,2,0,0,'+00'),(829,3,0,0,'+00'),(830,0,21020,0,'LMT'),(830,1,21600,0,'+06'),(831,0,3208,0,'LMT'),(831,1,7200,1,'CEST'),(831,2,3600,0,'CET'),(831,3,7200,1,'CEST'),(831,4,3600,0,'CET'),(831,5,10800,1,'CEMT'),(831,6,10800,1,'CEMT'),(831,7,7200,1,'CEST'),(831,8,3600,0,'CET'),(832,0,11212,0,'LMT'),(832,1,10800,0,'+03'),(833,0,18468,0,'LMT'),(833,1,18000,0,'+05'),(833,2,25200,1,'+07'),(833,3,21600,0,'+06'),(833,4,21600,0,'+06'),(833,5,25200,1,'+07'),(833,6,21600,1,'+06'),(833,7,18000,0,'+05'),(833,8,25200,1,'+07'),(833,9,21600,0,'+06'),(834,0,8624,0,'LMT'),(834,1,10800,1,'EEST'),(834,2,7200,0,'EET'),(834,3,7200,0,'EET'),(834,4,10800,1,'EEST'),(834,5,10800,0,'+03'),(835,0,42596,0,'LMT'),(835,1,43200,0,'+12'),(835,2,50400,1,'+14'),(835,3,46800,0,'+13'),(835,4,46800,1,'+13'),(835,5,43200,0,'+12'),(835,6,46800,1,'+13'),(835,7,43200,1,'+12'),(835,8,39600,0,'+11'),(835,9,43200,0,'+12'),(836,0,12064,0,'LMT'),(836,1,14400,0,'+04'),(836,2,18000,0,'+05'),(836,3,21600,0,'+06'),(836,4,21600,1,'+06'),(836,5,18000,0,'+05'),(836,6,21600,1,'+06'),(836,7,18000,1,'+05'),(836,8,14400,0,'+04'),(836,9,18000,0,'+05'),(837,0,13720,0,'LMT'),(837,1,14400,0,'+04'),(837,2,18000,0,'+05'),(837,3,21600,1,'+06'),(837,4,21600,0,'+06'),(837,5,18000,0,'+05'),(837,6,21600,1,'+06'),(837,7,18000,1,'+05'),(837,8,14400,0,'+04'),(837,9,21600,1,'+06'),(837,10,18000,0,'+05'),(838,0,14012,0,'LMT'),(838,1,14400,0,'+04'),(838,2,21600,1,'+06'),(838,3,18000,0,'+05'),(838,4,18000,0,'+05'),(838,5,21600,1,'+06'),(838,6,18000,1,'+05'),(838,7,14400,0,'+04'),(838,8,18000,0,'+05'),(839,0,14012,0,'LMT'),(839,1,14400,0,'+04'),(839,2,21600,1,'+06'),(839,3,18000,0,'+05'),(839,4,18000,0,'+05'),(839,5,21600,1,'+06'),(839,6,18000,1,'+05'),(839,7,14400,0,'+04'),(839,8,18000,0,'+05'),(840,0,12464,0,'LMT'),(840,1,10800,0,'+03'),(840,2,18000,0,'+05'),(840,3,21600,0,'+06'),(840,4,21600,1,'+06'),(840,5,18000,0,'+05'),(840,6,21600,1,'+06'),(840,7,18000,1,'+05'),(840,8,14400,0,'+04'),(840,9,18000,0,'+05'),(841,0,10660,0,'LMT'),(841,1,10656,0,'BMT'),(841,2,10800,0,'+03'),(841,3,14400,1,'+04'),(841,4,10800,0,'+03'),(841,5,14400,1,'+04'),(842,0,12368,0,'LMT'),(842,1,14400,0,'+04'),(842,2,10800,0,'+03'),(843,0,11964,0,'LMT'),(843,1,10800,0,'+03'),(843,2,18000,1,'+05'),(843,3,14400,0,'+04'),(843,4,14400,0,'+04'),(843,5,18000,1,'+05'),(843,6,14400,1,'+04'),(843,7,10800,0,'+03'),(843,8,18000,1,'+05'),(843,9,14400,0,'+04'),(844,0,24124,0,'LMT'),(844,1,24124,0,'BMT'),(844,2,25200,0,'+07'),(845,0,20100,0,'LMT'),(845,1,21600,0,'+06'),(845,2,28800,1,'+08'),(845,3,25200,0,'+07'),(845,4,25200,0,'+07'),(845,5,28800,1,'+08'),(845,6,25200,1,'+07'),(845,7,21600,0,'+06'),(845,8,25200,1,'+07'),(845,9,25200,0,'+07'),(846,0,8520,0,'LMT'),(846,1,10800,1,'EEST'),(846,2,7200,0,'EET'),(847,0,17904,0,'LMT'),(847,1,18000,0,'+05'),(847,2,25200,1,'+07'),(847,3,21600,0,'+06'),(847,4,21600,0,'+06'),(847,5,25200,1,'+07'),(847,6,21600,1,'+06'),(847,7,18000,0,'+05'),(847,8,21600,1,'+06'),(847,9,21600,0,'+06'),(848,0,26480,0,'LMT'),(848,1,27000,0,'+0730'),(848,2,30000,1,'+0820'),(848,3,28800,0,'+08'),(848,4,32400,0,'+09'),(848,5,28800,0,'+08'),(849,0,21200,0,'HMT'),(849,1,19270,0,'MMT'),(849,2,19800,0,'IST'),(849,3,23400,1,'+0630'),(850,0,27232,0,'LMT'),(850,1,28800,0,'+08'),(850,2,36000,1,'+10'),(850,3,32400,0,'+09'),(850,4,32400,0,'+09'),(850,5,36000,1,'+10'),(850,6,32400,1,'+09'),(850,7,28800,0,'+08'),(850,8,36000,0,'+10'),(850,9,36000,1,'+10'),(850,10,32400,0,'+09'),(851,0,27480,0,'LMT'),(851,1,25200,0,'+07'),(851,2,28800,0,'+08'),(851,3,32400,0,'+09'),(851,4,36000,1,'+10'),(851,5,32400,1,'+09'),(851,6,28800,0,'+08'),(852,0,29143,0,'LMT'),(852,1,32400,1,'CDT'),(852,2,28800,0,'CST'),(853,0,29143,0,'LMT'),(853,1,32400,1,'CDT'),(853,2,28800,0,'CST'),(854,0,19164,0,'LMT'),(854,1,19172,0,'MMT'),(854,2,19800,0,'+0530'),(854,3,21600,1,'+06'),(854,4,23400,1,'+0630'),(854,5,23400,0,'+0630'),(854,6,21600,0,'+06'),(854,7,19800,0,'+0530'),(855,0,21700,0,'LMT'),(855,1,21200,0,'HMT'),(855,2,23400,0,'+0630'),(855,3,19800,0,'+0530'),(855,4,21600,0,'+06'),(855,5,25200,1,'+07'),(856,0,8712,0,'LMT'),(856,1,10800,1,'EEST'),(856,2,7200,0,'EET'),(856,3,10800,0,'+03'),(857,0,21700,0,'LMT'),(857,1,21200,0,'HMT'),(857,2,23400,0,'+0630'),(857,3,19800,0,'+0530'),(857,4,21600,0,'+06'),(857,5,25200,1,'+07'),(858,0,30140,0,'LMT'),(858,1,28800,0,'+08'),(858,2,32400,0,'+09'),(859,0,13272,0,'LMT'),(859,1,14400,0,'+04'),(860,0,16512,0,'LMT'),(860,1,18000,0,'+05'),(860,2,25200,1,'+07'),(860,3,21600,0,'+06'),(860,4,21600,0,'+06'),(860,5,25200,1,'+07'),(860,6,21600,1,'+06'),(860,7,18000,0,'+05'),(861,0,8148,0,'LMT'),(861,1,10800,1,'EEST'),(861,2,7200,0,'EET'),(861,3,7200,0,'EET'),(861,4,10800,1,'EEST'),(861,5,10800,0,'+03'),(861,6,7200,0,'EET'),(862,0,8272,0,'LMT'),(862,1,10800,1,'EEST'),(862,2,7200,0,'EET'),(862,3,7200,0,'EET'),(862,4,10800,1,'EEST'),(862,5,10800,1,'IDT'),(862,6,7200,0,'IST'),(862,7,10800,1,'IDT'),(862,8,7200,0,'IST'),(862,9,7200,0,'EET'),(863,0,29143,0,'LMT'),(863,1,32400,1,'CDT'),(863,2,28800,0,'CST'),(864,0,8423,0,'LMT'),(864,1,10800,1,'EEST'),(864,2,7200,0,'EET'),(864,3,7200,0,'EET'),(864,4,10800,1,'EEST'),(864,5,10800,1,'IDT'),(864,6,7200,0,'IST'),(864,7,10800,1,'IDT'),(864,8,7200,0,'IST'),(864,9,7200,0,'EET'),(865,0,25590,0,'LMT'),(865,1,25590,0,'PLMT'),(865,2,25200,0,'+07'),(865,3,28800,0,'+08'),(865,4,32400,0,'+09'),(865,5,25200,0,'+07'),(866,0,27402,0,'LMT'),(866,1,28800,0,'HKT'),(866,2,32400,1,'HKST'),(866,3,30600,1,'HKWT'),(866,4,32400,0,'JST'),(866,5,28800,0,'HKT'),(866,6,32400,1,'HKST'),(866,7,28800,0,'HKT'),(867,0,21996,0,'LMT'),(867,1,21600,0,'+06'),(867,2,28800,1,'+08'),(867,3,25200,0,'+07'),(868,0,25025,0,'LMT'),(868,1,25025,0,'IMT'),(868,2,25200,0,'+07'),(868,3,32400,1,'+09'),(868,4,28800,0,'+08'),(868,5,28800,0,'+08'),(868,6,32400,1,'+09'),(868,7,28800,1,'+08'),(868,8,25200,0,'+07'),(868,9,32400,0,'+09'),(868,10,32400,1,'+09'),(868,11,28800,0,'+08'),(869,0,6952,0,'LMT'),(869,1,7016,0,'IMT'),(869,2,10800,1,'EEST'),(869,3,7200,0,'EET'),(869,4,10800,0,'+03'),(869,5,14400,1,'+04'),(869,6,10800,1,'EEST'),(869,7,7200,0,'EET'),(869,8,10800,1,'EEST'),(869,9,7200,0,'EET'),(869,10,10800,0,'+03'),(870,0,25632,0,'LMT'),(870,1,25632,0,'BMT'),(870,2,26400,0,'+0720'),(870,3,27000,0,'+0730'),(870,4,32400,0,'+09'),(870,5,28800,0,'+08'),(870,6,25200,0,'WIB'),(871,0,33768,0,'LMT'),(871,1,32400,0,'+09'),(871,2,34200,0,'+0930'),(871,3,32400,0,'WIT'),(872,0,8454,0,'LMT'),(872,1,8440,0,'JMT'),(872,2,10800,1,'IDT'),(872,3,7200,0,'IST'),(872,4,14400,1,'IDDT'),(872,5,10800,1,'IDT'),(872,6,7200,0,'IST'),(872,7,10800,1,'IDT'),(872,8,7200,0,'IST'),(873,0,16608,0,'LMT'),(873,1,14400,0,'+04'),(873,2,16200,0,'+0430'),(874,0,38076,0,'LMT'),(874,1,39600,0,'+11'),(874,2,46800,1,'+13'),(874,3,43200,0,'+12'),(874,4,43200,0,'+12'),(874,5,46800,1,'+13'),(874,6,43200,1,'+12'),(874,7,39600,0,'+11'),(874,8,43200,0,'+12'),(875,0,16092,0,'LMT'),(875,1,19800,0,'+0530'),(875,2,23400,1,'+0630'),(875,3,18000,0,'+05'),(875,4,21600,1,'PKST'),(875,5,18000,0,'PKT'),(876,0,21020,0,'LMT'),(876,1,21600,0,'+06'),(877,0,20476,0,'LMT'),(877,1,19800,0,'+0530'),(877,2,20700,0,'+0545'),(878,0,20476,0,'LMT'),(878,1,19800,0,'+0530'),(878,2,20700,0,'+0545'),(879,0,32533,0,'LMT'),(879,1,28800,0,'+08'),(879,2,36000,1,'+10'),(879,3,32400,0,'+09'),(879,4,32400,0,'+09'),(879,5,36000,1,'+10'),(879,6,32400,1,'+09'),(879,7,28800,0,'+08'),(879,8,39600,1,'+11'),(879,9,36000,0,'+10'),(879,10,36000,0,'+10'),(879,11,39600,0,'+11'),(879,12,32400,0,'+09'),(880,0,21200,0,'HMT'),(880,1,19270,0,'MMT'),(880,2,19800,0,'IST'),(880,3,23400,1,'+0630'),(881,0,22286,0,'LMT'),(881,1,21600,0,'+06'),(881,2,28800,1,'+08'),(881,3,25200,0,'+07'),(881,4,25200,0,'+07'),(881,5,28800,1,'+08'),(881,6,25200,1,'+07'),(881,7,21600,0,'+06'),(881,8,28800,0,'+08'),(881,9,28800,1,'+08'),(881,10,25200,0,'+07'),(882,0,24925,0,'LMT'),(882,1,24925,0,'SMT'),(882,2,25200,0,'+07'),(882,3,26400,1,'+0720'),(882,4,26400,0,'+0720'),(882,5,27000,0,'+0730'),(882,6,32400,0,'+09'),(882,7,28800,0,'+08'),(883,0,26480,0,'LMT'),(883,1,27000,0,'+0730'),(883,2,30000,1,'+0820'),(883,3,28800,0,'+08'),(883,4,32400,0,'+09'),(883,5,28800,0,'+08'),(884,0,11212,0,'LMT'),(884,1,10800,0,'+03'),(885,0,27250,0,'LMT'),(885,1,28800,0,'CST'),(885,2,36000,1,'+10'),(885,3,32400,0,'+09'),(885,4,32400,1,'CDT'),(885,5,28800,0,'CST'),(885,6,32400,1,'CDT'),(886,0,27250,0,'LMT'),(886,1,28800,0,'CST'),(886,2,36000,1,'+10'),(886,3,32400,0,'+09'),(886,4,32400,1,'CDT'),(886,5,28800,0,'CST'),(886,6,32400,1,'CDT'),(887,0,36192,0,'LMT'),(887,1,36000,0,'+10'),(887,2,43200,1,'+12'),(887,3,39600,0,'+11'),(887,4,39600,0,'+11'),(887,5,43200,1,'+12'),(887,6,39600,1,'+11'),(887,7,36000,0,'+10'),(887,8,43200,0,'+12'),(887,9,43200,1,'+12'),(887,10,39600,0,'+11'),(888,0,28656,0,'LMT'),(888,1,28656,0,'MMT'),(888,2,28800,0,'+08'),(888,3,32400,0,'+09'),(888,4,28800,0,'WITA'),(889,0,29040,0,'LMT'),(889,1,32400,1,'PDT'),(889,2,28800,0,'PST'),(889,3,32400,0,'JST'),(889,4,28800,0,'PST'),(890,0,13272,0,'LMT'),(890,1,14400,0,'+04'),(891,0,8008,0,'LMT'),(891,1,10800,1,'EEST'),(891,2,7200,0,'EET'),(891,3,7200,0,'EET'),(891,4,10800,1,'EEST'),(892,0,20928,0,'LMT'),(892,1,21600,0,'+06'),(892,2,28800,1,'+08'),(892,3,25200,0,'+07'),(892,4,25200,0,'+07'),(892,5,28800,1,'+08'),(892,6,25200,1,'+07'),(892,7,21600,0,'+06'),(892,8,25200,0,'+07'),(893,0,19900,0,'LMT'),(893,1,21600,0,'+06'),(893,2,28800,1,'+08'),(893,3,25200,0,'+07'),(893,4,25200,0,'+07'),(893,5,28800,1,'+08'),(893,6,25200,1,'+07'),(893,7,21600,0,'+06'),(893,8,25200,1,'+07'),(893,9,25200,0,'+07'),(894,0,17610,0,'LMT'),(894,1,18000,0,'+05'),(894,2,25200,1,'+07'),(894,3,21600,0,'+06'),(894,4,21600,0,'+06'),(894,5,25200,1,'+07'),(894,6,21600,1,'+06'),(894,7,18000,0,'+05'),(894,8,25200,0,'+07'),(894,9,25200,1,'+07'),(894,10,21600,0,'+06'),(895,0,12324,0,'LMT'),(895,1,10800,0,'+03'),(895,2,18000,0,'+05'),(895,3,21600,1,'+06'),(895,4,21600,0,'+06'),(895,5,18000,0,'+05'),(895,6,21600,1,'+06'),(895,7,18000,1,'+05'),(895,8,14400,0,'+04'),(895,9,18000,0,'+05'),(896,0,24124,0,'LMT'),(896,1,24124,0,'BMT'),(896,2,25200,0,'+07'),(897,0,26240,0,'LMT'),(897,1,26240,0,'PMT'),(897,2,27000,0,'+0730'),(897,3,32400,0,'+09'),(897,4,28800,0,'+08'),(897,5,28800,0,'WITA'),(897,6,25200,0,'WIB'),(898,0,30180,0,'LMT'),(898,1,30600,0,'KST'),(898,2,32400,0,'JST'),(898,3,32400,0,'KST'),(899,0,12368,0,'LMT'),(899,1,14400,0,'+04'),(899,2,10800,0,'+03'),(900,0,15268,0,'LMT'),(900,1,14400,0,'+04'),(900,2,18000,0,'+05'),(900,3,21600,1,'+06'),(900,4,21600,0,'+06'),(900,5,18000,0,'+05'),(900,6,21600,1,'+06'),(900,7,18000,1,'+05'),(900,8,14400,0,'+04'),(900,9,21600,0,'+06'),(900,10,21600,1,'+06'),(901,0,15712,0,'LMT'),(901,1,14400,0,'+04'),(901,2,18000,0,'+05'),(901,3,21600,1,'+06'),(901,4,21600,0,'+06'),(901,5,18000,0,'+05'),(901,6,21600,1,'+06'),(901,7,18000,1,'+05'),(901,8,14400,0,'+04'),(901,9,21600,0,'+06'),(901,10,21600,1,'+06'),(901,11,18000,0,'+05'),(902,0,23087,0,'LMT'),(902,1,23087,0,'RMT'),(902,2,23400,0,'+0630'),(902,3,32400,0,'+09'),(902,4,23400,0,'+0630'),(903,0,11212,0,'LMT'),(903,1,10800,0,'+03'),(904,0,25590,0,'LMT'),(904,1,25590,0,'PLMT'),(904,2,25200,0,'+07'),(904,3,28800,0,'+08'),(904,4,32400,0,'+09'),(904,5,25200,0,'+07'),(905,0,34248,0,'LMT'),(905,1,32400,0,'+09'),(905,2,43200,1,'+12'),(905,3,39600,0,'+11'),(905,4,39600,0,'+11'),(905,5,43200,1,'+12'),(905,6,39600,1,'+11'),(905,7,36000,0,'+10'),(905,8,39600,0,'+11'),(906,0,16073,0,'LMT'),(906,1,14400,0,'+04'),(906,2,18000,0,'+05'),(906,3,21600,1,'+06'),(906,4,21600,0,'+06'),(906,5,18000,0,'+05'),(906,6,21600,1,'+06'),(907,0,30472,0,'LMT'),(907,1,30600,0,'KST'),(907,2,32400,0,'JST'),(907,3,36000,1,'KDT'),(907,4,32400,0,'KST'),(907,5,34200,1,'KDT'),(907,6,36000,1,'KDT'),(908,0,29143,0,'LMT'),(908,1,32400,1,'CDT'),(908,2,28800,0,'CST'),(909,0,24925,0,'LMT'),(909,1,24925,0,'SMT'),(909,2,25200,0,'+07'),(909,3,26400,1,'+0720'),(909,4,26400,0,'+0720'),(909,5,27000,0,'+0730'),(909,6,32400,0,'+09'),(909,7,28800,0,'+08'),(910,0,36892,0,'LMT'),(910,1,36000,0,'+10'),(910,2,43200,1,'+12'),(910,3,39600,0,'+11'),(910,4,39600,0,'+11'),(910,5,43200,1,'+12'),(910,6,39600,1,'+11'),(910,7,36000,0,'+10'),(910,8,43200,0,'+12'),(910,9,43200,1,'+12'),(910,10,39600,0,'+11'),(911,0,29160,0,'LMT'),(911,1,28800,0,'CST'),(911,2,32400,0,'JST'),(911,3,32400,1,'CDT'),(911,4,28800,0,'CST'),(912,0,16631,0,'LMT'),(912,1,18000,0,'+05'),(912,2,25200,1,'+07'),(912,3,21600,0,'+06'),(912,4,21600,0,'+06'),(912,5,25200,1,'+07'),(912,6,21600,1,'+06'),(912,7,18000,0,'+05'),(913,0,10751,0,'LMT'),(913,1,10751,0,'TBMT'),(913,2,10800,0,'+03'),(913,3,18000,1,'+05'),(913,4,14400,0,'+04'),(913,5,14400,0,'+04'),(913,6,18000,1,'+05'),(913,7,14400,1,'+04'),(913,8,10800,0,'+03'),(913,9,14400,1,'+04'),(913,10,14400,0,'+04'),(914,0,12344,0,'LMT'),(914,1,12344,0,'TMT'),(914,2,16200,1,'+0430'),(914,3,12600,0,'+0330'),(914,4,18000,1,'+05'),(914,5,14400,0,'+04'),(914,6,16200,1,'+0430'),(914,7,12600,0,'+0330'),(915,0,8454,0,'LMT'),(915,1,8440,0,'JMT'),(915,2,10800,1,'IDT'),(915,3,7200,0,'IST'),(915,4,14400,1,'IDDT'),(915,5,10800,1,'IDT'),(915,6,7200,0,'IST'),(915,7,10800,1,'IDT'),(915,8,7200,0,'IST'),(916,0,21516,0,'LMT'),(916,1,19800,0,'+0530'),(916,2,21600,0,'+06'),(917,0,21516,0,'LMT'),(917,1,19800,0,'+0530'),(917,2,21600,0,'+06'),(918,0,33539,0,'LMT'),(918,1,36000,1,'JDT'),(918,2,32400,0,'JST'),(918,3,32400,0,'JST'),(919,0,20391,0,'LMT'),(919,1,21600,0,'+06'),(919,2,28800,1,'+08'),(919,3,25200,0,'+07'),(919,4,25200,0,'+07'),(919,5,28800,1,'+08'),(919,6,25200,1,'+07'),(919,7,21600,0,'+06'),(919,8,25200,1,'+07'),(919,9,25200,0,'+07'),(920,0,28656,0,'LMT'),(920,1,28656,0,'MMT'),(920,2,28800,0,'+08'),(920,3,32400,0,'+09'),(920,4,28800,0,'WITA'),(921,0,25652,0,'LMT'),(921,1,25200,0,'+07'),(921,2,32400,1,'+09'),(921,3,28800,0,'+08'),(922,0,25652,0,'LMT'),(922,1,25200,0,'+07'),(922,2,32400,1,'+09'),(922,3,28800,0,'+08'),(923,0,21020,0,'LMT'),(923,1,21600,0,'+06'),(924,0,34374,0,'LMT'),(924,1,28800,0,'+08'),(924,2,32400,0,'+09'),(924,3,39600,0,'+11'),(924,4,43200,1,'+12'),(924,5,39600,0,'+11'),(924,6,43200,1,'+12'),(924,7,39600,1,'+11'),(924,8,36000,0,'+10'),(924,9,43200,0,'+12'),(924,10,43200,1,'+12'),(924,11,36000,0,'+10'),(925,0,24124,0,'LMT'),(925,1,24124,0,'BMT'),(925,2,25200,0,'+07'),(926,0,31651,0,'LMT'),(926,1,32400,0,'+09'),(926,2,39600,1,'+11'),(926,3,36000,0,'+10'),(926,4,36000,0,'+10'),(926,5,39600,1,'+11'),(926,6,36000,1,'+10'),(926,7,32400,0,'+09'),(926,8,39600,0,'+11'),(926,9,39600,1,'+11'),(926,10,36000,0,'+10'),(927,0,31138,0,'LMT'),(927,1,28800,0,'+08'),(927,2,36000,1,'+10'),(927,3,32400,0,'+09'),(927,4,32400,0,'+09'),(927,5,36000,1,'+10'),(927,6,32400,1,'+09'),(927,7,28800,0,'+08'),(927,8,36000,0,'+10'),(927,9,36000,1,'+10'),(927,10,32400,0,'+09'),(928,0,23087,0,'LMT'),(928,1,23087,0,'RMT'),(928,2,23400,0,'+0630'),(928,3,32400,0,'+09'),(928,4,23400,0,'+0630'),(929,0,14553,0,'LMT'),(929,1,13505,0,'PMT'),(929,2,14400,0,'+04'),(929,3,21600,1,'+06'),(929,4,18000,0,'+05'),(929,5,18000,0,'+05'),(929,6,21600,1,'+06'),(929,7,18000,1,'+05'),(929,8,14400,0,'+04'),(929,9,21600,0,'+06'),(929,10,21600,1,'+06'),(929,11,18000,0,'+05'),(930,0,10680,0,'LMT'),(930,1,10800,0,'+03'),(930,2,18000,1,'+05'),(930,3,14400,0,'+04'),(930,4,14400,0,'+04'),(930,5,18000,1,'+05'),(930,6,14400,1,'+04'),(930,7,10800,0,'+03'),(930,8,18000,1,'+05'),(930,9,14400,0,'+04'),(931,0,-6160,0,'LMT'),(931,1,-6872,0,'HMT'),(931,2,-3600,1,'-01'),(931,3,-7200,0,'-02'),(931,4,-3600,1,'-01'),(931,5,-7200,0,'-02'),(931,6,-7200,0,'-02'),(931,7,0,1,'+00'),(931,8,-3600,0,'-01'),(931,9,-3600,0,'-01'),(931,10,0,0,'WET'),(931,11,0,1,'+00'),(931,12,-3600,0,'-01'),(932,0,-15558,0,'LMT'),(932,1,-11958,1,'BST'),(932,2,-15558,0,'BMT'),(932,3,-10800,1,'ADT'),(932,4,-14400,0,'AST'),(933,0,-3696,0,'LMT'),(933,1,-3600,0,'-01'),(933,2,0,0,'WET'),(933,3,3600,1,'WEST'),(933,4,0,0,'WET'),(933,5,3600,1,'WEST'),(934,0,-5644,0,'LMT'),(934,1,-7200,0,'-02'),(934,2,-3600,1,'-01'),(934,3,-7200,0,'-02'),(934,4,-3600,0,'-01'),(935,0,-1624,0,'LMT'),(935,1,0,0,'WET'),(935,2,3600,1,'WEST'),(935,3,0,0,'WET'),(936,0,-1624,0,'LMT'),(936,1,0,0,'WET'),(936,2,3600,1,'WEST'),(936,3,0,0,'WET'),(937,0,3208,0,'LMT'),(937,1,7200,1,'CEST'),(937,2,3600,0,'CET'),(937,3,7200,1,'CEST'),(937,4,3600,0,'CET'),(937,5,10800,1,'CEMT'),(937,6,10800,1,'CEMT'),(937,7,7200,1,'CEST'),(937,8,3600,0,'CET'),(938,0,-4056,0,'LMT'),(938,1,-4056,0,'FMT'),(938,2,0,1,'+00'),(938,3,-3600,0,'-01'),(938,4,0,1,'+00'),(938,5,-3600,0,'-01'),(938,6,-3600,0,'-01'),(938,7,3600,1,'+01'),(938,8,3600,1,'WEST'),(938,9,0,0,'WET'),(938,10,0,0,'WET'),(938,11,0,0,'WET'),(938,12,3600,1,'WEST'),(939,0,-968,0,'LMT'),(939,1,0,0,'GMT'),(940,0,-8768,0,'LMT'),(940,1,-7200,0,'-02'),(941,0,-968,0,'LMT'),(941,1,0,0,'GMT'),(942,0,-13884,0,'LMT'),(942,1,-13884,0,'SMT'),(942,2,-10800,1,'-03'),(942,3,-14400,0,'-04'),(942,4,-7200,1,'-02'),(942,5,-10800,0,'-03'),(942,6,-10800,1,'-03'),(943,0,36292,0,'LMT'),(943,1,39600,1,'AEDT'),(943,2,36000,0,'AEST'),(943,3,36000,0,'AEST'),(944,0,32400,0,'ACST'),(944,1,37800,1,'ACDT'),(944,2,34200,0,'ACST'),(944,3,34200,0,'ACST'),(945,0,36728,0,'LMT'),(945,1,39600,1,'AEDT'),(945,2,36000,0,'AEST'),(945,3,36000,0,'AEST'),(946,0,32400,0,'ACST'),(946,1,37800,1,'ACDT'),(946,2,34200,0,'ACST'),(946,3,34200,0,'ACST'),(946,4,37800,1,'ACDT'),(947,0,36292,0,'LMT'),(947,1,39600,1,'AEDT'),(947,2,36000,0,'AEST'),(947,3,36000,0,'AEST'),(948,0,35356,0,'LMT'),(948,1,39600,1,'AEDT'),(948,2,36000,0,'AEST'),(948,3,36000,0,'AEST'),(949,0,32400,0,'ACST'),(949,1,37800,1,'ACDT'),(949,2,34200,0,'ACST'),(949,3,34200,0,'ACST'),(950,0,30928,0,'LMT'),(950,1,35100,1,'+0945'),(950,2,31500,0,'+0845'),(950,3,31500,0,'+0845'),(951,0,35356,0,'LMT'),(951,1,39600,1,'AEDT'),(951,2,36000,0,'AEST'),(951,3,36000,0,'AEST'),(952,0,38180,0,'LMT'),(952,1,36000,0,'AEST'),(952,2,41400,1,'+1130'),(952,3,37800,0,'+1030'),(952,4,39600,1,'+11'),(953,0,35756,0,'LMT'),(953,1,39600,1,'AEDT'),(953,2,36000,0,'AEST'),(953,3,36000,0,'AEST'),(954,0,38180,0,'LMT'),(954,1,36000,0,'AEST'),(954,2,41400,1,'+1130'),(954,3,37800,0,'+1030'),(954,4,39600,1,'+11'),(955,0,34792,0,'LMT'),(955,1,39600,1,'AEDT'),(955,2,36000,0,'AEST'),(955,3,36000,0,'AEST'),(956,0,36292,0,'LMT'),(956,1,39600,1,'AEDT'),(956,2,36000,0,'AEST'),(956,3,36000,0,'AEST'),(957,0,32400,0,'ACST'),(957,1,37800,1,'ACDT'),(957,2,34200,0,'ACST'),(957,3,34200,0,'ACST'),(958,0,27804,0,'LMT'),(958,1,32400,1,'AWDT'),(958,2,28800,0,'AWST'),(958,3,28800,0,'AWST'),(959,0,36728,0,'LMT'),(959,1,39600,1,'AEDT'),(959,2,36000,0,'AEST'),(959,3,36000,0,'AEST'),(960,0,32400,0,'ACST'),(960,1,37800,1,'ACDT'),(960,2,34200,0,'ACST'),(960,3,34200,0,'ACST'),(961,0,36292,0,'LMT'),(961,1,39600,1,'AEDT'),(961,2,36000,0,'AEST'),(961,3,36000,0,'AEST'),(962,0,35356,0,'LMT'),(962,1,39600,1,'AEDT'),(962,2,36000,0,'AEST'),(962,3,36000,0,'AEST'),(963,0,34792,0,'LMT'),(963,1,39600,1,'AEDT'),(963,2,36000,0,'AEST'),(963,3,36000,0,'AEST'),(964,0,27804,0,'LMT'),(964,1,32400,1,'AWDT'),(964,2,28800,0,'AWST'),(964,3,28800,0,'AWST'),(965,0,32400,0,'ACST'),(965,1,37800,1,'ACDT'),(965,2,34200,0,'ACST'),(965,3,34200,0,'ACST'),(965,4,37800,1,'ACDT'),(966,0,-16272,0,'LMT'),(966,1,-14400,1,'-04'),(966,2,-18000,0,'-05'),(966,3,-14400,0,'-04'),(966,4,-18000,0,'-05'),(967,0,-7780,0,'LMT'),(967,1,-3600,1,'-01'),(967,2,-7200,0,'-02'),(968,0,-11188,0,'LMT'),(968,1,-7200,1,'-02'),(968,2,-10800,0,'-03'),(969,0,-14404,0,'LMT'),(969,1,-10800,1,'-03'),(969,2,-14400,0,'-04'),(970,0,7200,1,'CEST'),(970,1,3600,0,'CET'),(970,2,7200,1,'CEST'),(970,3,3600,0,'CET'),(971,0,-18000,1,'CDT'),(971,1,-21600,0,'CST'),(971,2,-18000,1,'CWT'),(971,3,-18000,1,'CPT'),(972,0,-15264,0,'LMT'),(972,1,-10800,1,'ADT'),(972,2,-14400,0,'AST'),(972,3,-10800,1,'AWT'),(972,4,-10800,1,'APT'),(973,0,-23316,0,'LMT'),(973,1,-18000,1,'CDT'),(973,2,-21600,0,'CST'),(973,3,-18000,1,'CWT'),(973,4,-18000,1,'CPT'),(973,5,-18000,1,'CDT'),(973,6,-21600,0,'CST'),(974,0,-19052,0,'LMT'),(974,1,-14400,1,'EDT'),(974,2,-18000,0,'EST'),(974,3,-14400,1,'EWT'),(974,4,-14400,1,'EPT'),(975,0,-27232,0,'LMT'),(975,1,-21600,1,'MDT'),(975,2,-25200,0,'MST'),(975,3,-21600,1,'MWT'),(975,4,-21600,1,'MPT'),(976,0,-12652,0,'LMT'),(976,1,-9052,1,'NDT'),(976,2,-12652,0,'NST'),(976,3,-9000,1,'NDT'),(976,4,-12600,0,'NST'),(976,5,-9000,1,'NPT'),(976,6,-9000,1,'NWT'),(976,7,-5400,1,'NDDT'),(976,8,-9000,1,'NDT'),(977,0,-29548,0,'LMT'),(977,1,-25200,1,'PDT'),(977,2,-28800,0,'PST'),(977,3,-25200,1,'PWT'),(977,4,-25200,1,'PPT'),(978,0,-25116,0,'LMT'),(978,1,-21600,1,'MDT'),(978,2,-25200,0,'MST'),(978,3,-21600,1,'MWT'),(978,4,-21600,1,'MPT'),(978,5,-21600,0,'CST'),(979,0,-32412,0,'LMT'),(979,1,-28800,1,'YDT'),(979,2,-32400,0,'YST'),(979,3,-28800,1,'YWT'),(979,4,-28800,1,'YPT'),(979,5,-25200,1,'YDDT'),(979,6,-28800,0,'PST'),(979,7,-25200,1,'PDT'),(979,8,-25200,0,'MST'),(980,0,-16965,0,'LMT'),(980,1,-16965,0,'SMT'),(980,2,-18000,0,'-05'),(980,3,-14400,0,'-04'),(980,4,-14400,1,'-04'),(980,5,-10800,1,'-03'),(980,6,-10800,1,'-03'),(980,7,-14400,0,'-04'),(981,0,-26248,0,'LMT'),(981,1,-26248,0,'EMT'),(981,2,-21600,1,'-06'),(981,3,-25200,0,'-07'),(981,4,-25200,0,'-07'),(981,5,-21600,0,'-06'),(981,6,-18000,1,'-05'),(982,0,-19768,0,'LMT'),(982,1,-19776,0,'HMT'),(982,2,-14400,1,'CDT'),(982,3,-18000,0,'CST'),(982,4,-18000,0,'CST'),(982,5,-14400,1,'CDT'),(983,0,10800,1,'EEST'),(983,1,7200,0,'EET'),(984,0,-18000,0,'EST'),(985,0,-14400,1,'EDT'),(985,1,-18000,0,'EST'),(985,2,-14400,1,'EWT'),(985,3,-14400,1,'EPT'),(986,0,7509,0,'LMT'),(986,1,10800,1,'EEST'),(986,2,7200,0,'EET'),(986,3,10800,1,'EEST'),(987,0,-1521,0,'LMT'),(987,1,-1521,0,'DMT'),(987,2,2079,1,'IST'),(987,3,3600,1,'BST'),(987,4,0,0,'GMT'),(987,5,3600,1,'IST'),(987,6,0,0,'GMT'),(987,7,3600,0,'IST'),(987,8,3600,1,'IST'),(987,9,0,0,'GMT'),(988,0,0,0,'GMT'),(989,0,0,0,'GMT'),(990,0,-3600,0,'-01'),(991,0,-36000,0,'-10'),(992,0,-39600,0,'-11'),(993,0,-43200,0,'-12'),(994,0,-7200,0,'-02'),(995,0,-10800,0,'-03'),(996,0,-14400,0,'-04'),(997,0,-18000,0,'-05'),(998,0,-21600,0,'-06'),(999,0,-25200,0,'-07'),(1000,0,-28800,0,'-08'),(1001,0,-32400,0,'-09'),(1002,0,0,0,'GMT'),(1003,0,3600,0,'+01'),(1004,0,36000,0,'+10'),(1005,0,39600,0,'+11'),(1006,0,43200,0,'+12'),(1007,0,46800,0,'+13'),(1008,0,50400,0,'+14'),(1009,0,7200,0,'+02'),(1010,0,10800,0,'+03'),(1011,0,14400,0,'+04'),(1012,0,18000,0,'+05'),(1013,0,21600,0,'+06'),(1014,0,25200,0,'+07'),(1015,0,28800,0,'+08'),(1016,0,32400,0,'+09'),(1017,0,0,0,'GMT'),(1018,0,0,0,'GMT'),(1019,0,0,0,'UTC'),(1020,0,0,0,'UTC'),(1021,0,0,0,'UTC'),(1022,0,0,0,'UTC'),(1023,0,1050,0,'BMT'),(1023,1,0,0,'WET'),(1023,2,3600,0,'CET'),(1023,3,7200,1,'CEST'),(1023,4,3600,0,'CET'),(1023,5,7200,1,'CEST'),(1023,6,3600,1,'WEST'),(1023,7,0,0,'WET'),(1023,8,0,0,'WET'),(1023,9,7200,1,'CEST'),(1023,10,3600,0,'CET'),(1024,0,364,0,'LMT'),(1024,1,0,0,'WET'),(1024,2,3600,0,'CET'),(1024,3,7200,1,'CEST'),(1024,4,3600,0,'CET'),(1025,0,11532,0,'LMT'),(1025,1,10800,0,'+03'),(1025,2,18000,1,'+05'),(1025,3,14400,0,'+04'),(1025,4,14400,0,'+04'),(1025,5,18000,1,'+05'),(1025,6,14400,1,'+04'),(1025,7,10800,0,'+03'),(1025,8,14400,0,'+04'),(1026,0,5692,0,'LMT'),(1026,1,5692,0,'AMT'),(1026,2,10800,1,'EEST'),(1026,3,7200,0,'EET'),(1026,4,3600,0,'CET'),(1026,5,7200,1,'CEST'),(1026,6,10800,1,'EEST'),(1026,7,7200,0,'EET'),(1026,8,10800,1,'EEST'),(1026,9,7200,0,'EET'),(1027,0,-75,0,'LMT'),(1027,1,3600,1,'BST'),(1027,2,0,0,'GMT'),(1027,3,7200,1,'BDST'),(1027,4,0,0,'GMT'),(1027,5,3600,0,'BST'),(1027,6,3600,1,'BST'),(1027,7,0,0,'GMT'),(1028,0,4920,0,'LMT'),(1028,1,3600,0,'CET'),(1028,2,3600,0,'CET'),(1028,3,7200,1,'CEST'),(1028,4,7200,1,'CEST'),(1028,5,7200,1,'CEST'),(1028,6,3600,0,'CET'),(1029,0,3208,0,'LMT'),(1029,1,7200,1,'CEST'),(1029,2,3600,0,'CET'),(1029,3,7200,1,'CEST'),(1029,4,3600,0,'CET'),(1029,5,10800,1,'CEMT'),(1029,6,10800,1,'CEMT'),(1029,7,7200,1,'CEST'),(1029,8,3600,0,'CET'),(1030,0,3464,0,'PMT'),(1030,1,7200,1,'CEST'),(1030,2,3600,0,'CET'),(1030,3,7200,1,'CEST'),(1030,4,3600,0,'CET'),(1030,5,0,0,'GMT'),(1030,6,7200,1,'CEST'),(1030,7,3600,0,'CET'),(1031,0,1050,0,'BMT'),(1031,1,0,0,'WET'),(1031,2,3600,0,'CET'),(1031,3,7200,1,'CEST'),(1031,4,3600,0,'CET'),(1031,5,7200,1,'CEST'),(1031,6,3600,1,'WEST'),(1031,7,0,0,'WET'),(1031,8,0,0,'WET'),(1031,9,7200,1,'CEST'),(1031,10,3600,0,'CET'),(1032,0,6264,0,'LMT'),(1032,1,6264,0,'BMT'),(1032,2,10800,1,'EEST'),(1032,3,7200,0,'EET'),(1032,4,10800,1,'EEST'),(1032,5,7200,0,'EET'),(1032,6,10800,1,'EEST'),(1032,7,7200,0,'EET'),(1033,0,4580,0,'LMT'),(1033,1,7200,1,'CEST'),(1033,2,3600,0,'CET'),(1033,3,7200,1,'CEST'),(1033,4,3600,0,'CET'),(1033,5,7200,1,'CEST'),(1033,6,3600,0,'CET'),(1034,0,1786,0,'BMT'),(1034,1,7200,1,'CEST'),(1034,2,3600,0,'CET'),(1034,3,7200,1,'CEST'),(1034,4,3600,0,'CET'),(1035,0,6920,0,'LMT'),(1035,1,6900,0,'CMT'),(1035,2,6264,0,'BMT'),(1035,3,10800,1,'EEST'),(1035,4,7200,0,'EET'),(1035,5,7200,0,'EET'),(1035,6,10800,1,'EEST'),(1035,7,3600,0,'CET'),(1035,8,7200,1,'CEST'),(1035,9,7200,1,'CEST'),(1035,10,14400,1,'MSD'),(1035,11,10800,0,'MSK'),(1035,12,10800,0,'MSK'),(1035,13,14400,1,'MSD'),(1035,14,10800,1,'EEST'),(1035,15,7200,0,'EET'),(1036,0,3208,0,'LMT'),(1036,1,7200,1,'CEST'),(1036,2,3600,0,'CET'),(1036,3,7200,1,'CEST'),(1036,4,3600,0,'CET'),(1036,5,10800,1,'CEMT'),(1036,6,10800,1,'CEMT'),(1036,7,7200,1,'CEST'),(1036,8,3600,0,'CET'),(1037,0,-1521,0,'LMT'),(1037,1,-1521,0,'DMT'),(1037,2,2079,1,'IST'),(1037,3,3600,1,'BST'),(1037,4,0,0,'GMT'),(1037,5,3600,1,'IST'),(1037,6,0,0,'GMT'),(1037,7,3600,0,'IST'),(1037,8,3600,1,'IST'),(1037,9,0,0,'GMT'),(1038,0,-1284,0,'LMT'),(1038,1,3600,1,'BST'),(1038,2,0,0,'GMT'),(1038,3,7200,1,'BDST'),(1038,4,0,0,'GMT'),(1038,5,3600,0,'CET'),(1038,6,7200,1,'CEST'),(1038,7,3600,0,'CET'),(1039,0,-75,0,'LMT'),(1039,1,3600,1,'BST'),(1039,2,0,0,'GMT'),(1039,3,7200,1,'BDST'),(1039,4,0,0,'GMT'),(1039,5,3600,0,'BST'),(1039,6,3600,1,'BST'),(1039,7,0,0,'GMT'),(1040,0,5989,0,'LMT'),(1040,1,5989,0,'HMT'),(1040,2,10800,1,'EEST'),(1040,3,7200,0,'EET'),(1040,4,10800,1,'EEST'),(1040,5,7200,0,'EET'),(1041,0,-75,0,'LMT'),(1041,1,3600,1,'BST'),(1041,2,0,0,'GMT'),(1041,3,7200,1,'BDST'),(1041,4,0,0,'GMT'),(1041,5,3600,0,'BST'),(1041,6,3600,1,'BST'),(1041,7,0,0,'GMT'),(1042,0,6952,0,'LMT'),(1042,1,7016,0,'IMT'),(1042,2,10800,1,'EEST'),(1042,3,7200,0,'EET'),(1042,4,10800,0,'+03'),(1042,5,14400,1,'+04'),(1042,6,10800,1,'EEST'),(1042,7,7200,0,'EET'),(1042,8,10800,1,'EEST'),(1042,9,7200,0,'EET'),(1042,10,10800,0,'+03'),(1043,0,-75,0,'LMT'),(1043,1,3600,1,'BST'),(1043,2,0,0,'GMT'),(1043,3,7200,1,'BDST'),(1043,4,0,0,'GMT'),(1043,5,3600,0,'BST'),(1043,6,3600,1,'BST'),(1043,7,0,0,'GMT'),(1044,0,4920,0,'LMT'),(1044,1,7200,1,'CEST'),(1044,2,3600,0,'CET'),(1044,3,7200,1,'CEST'),(1044,4,3600,0,'CET'),(1044,5,10800,1,'EEST'),(1044,6,7200,0,'EET'),(1044,7,14400,1,'MSD'),(1044,8,10800,0,'MSK'),(1044,9,10800,0,'MSK'),(1044,10,14400,1,'MSD'),(1044,11,10800,1,'EEST'),(1044,12,7200,0,'EET'),(1044,13,10800,0,'+03'),(1044,14,7200,0,'EET'),(1045,0,7324,0,'LMT'),(1045,1,7324,0,'KMT'),(1045,2,7200,0,'EET'),(1045,3,10800,0,'MSK'),(1045,4,3600,0,'CET'),(1045,5,7200,1,'CEST'),(1045,6,7200,1,'CEST'),(1045,7,14400,1,'MSD'),(1045,8,10800,0,'MSK'),(1045,9,14400,1,'MSD'),(1045,10,10800,1,'EEST'),(1045,11,7200,0,'EET'),(1045,12,10800,1,'EEST'),(1045,13,7200,0,'EET'),(1045,14,10800,1,'EEST'),(1046,0,11928,0,'LMT'),(1046,1,10800,0,'+03'),(1046,2,18000,1,'+05'),(1046,3,14400,0,'+04'),(1046,4,14400,0,'+04'),(1046,5,18000,1,'+05'),(1046,6,14400,1,'MSD'),(1046,7,10800,0,'MSK'),(1046,8,14400,0,'MSK'),(1046,9,10800,0,'MSK'),(1047,0,7324,0,'LMT'),(1047,1,7324,0,'KMT'),(1047,2,7200,0,'EET'),(1047,3,10800,0,'MSK'),(1047,4,3600,0,'CET'),(1047,5,7200,1,'CEST'),(1047,6,7200,1,'CEST'),(1047,7,14400,1,'MSD'),(1047,8,10800,0,'MSK'),(1047,9,14400,1,'MSD'),(1047,10,10800,1,'EEST'),(1047,11,7200,0,'EET'),(1047,12,10800,1,'EEST'),(1047,13,7200,0,'EET'),(1047,14,10800,1,'EEST'),(1048,0,-2205,0,'LMT'),(1048,1,3600,1,'WEST'),(1048,2,0,0,'WET'),(1048,3,3600,1,'WEST'),(1048,4,0,0,'WET'),(1048,5,7200,1,'WEMT'),(1048,6,0,0,'WET'),(1048,7,3600,0,'CET'),(1048,8,3600,0,'CET'),(1048,9,7200,1,'CEST'),(1048,10,3600,1,'WEST'),(1048,11,0,0,'WET'),(1049,0,4920,0,'LMT'),(1049,1,3600,0,'CET'),(1049,2,3600,0,'CET'),(1049,3,7200,1,'CEST'),(1049,4,7200,1,'CEST'),(1049,5,7200,1,'CEST'),(1049,6,3600,0,'CET'),(1050,0,-75,0,'LMT'),(1050,1,3600,1,'BST'),(1050,2,0,0,'GMT'),(1050,3,7200,1,'BDST'),(1050,4,0,0,'GMT'),(1050,5,3600,0,'BST'),(1050,6,3600,1,'BST'),(1050,7,0,0,'GMT'),(1051,0,1050,0,'BMT'),(1051,1,0,0,'WET'),(1051,2,3600,0,'CET'),(1051,3,7200,1,'CEST'),(1051,4,3600,0,'CET'),(1051,5,7200,1,'CEST'),(1051,6,3600,1,'WEST'),(1051,7,0,0,'WET'),(1051,8,0,0,'WET'),(1051,9,7200,1,'CEST'),(1051,10,3600,0,'CET'),(1052,0,-884,0,'LMT'),(1052,1,3600,1,'WEST'),(1052,2,0,0,'WET'),(1052,3,7200,1,'WEMT'),(1052,4,0,0,'WET'),(1052,5,7200,1,'CEST'),(1052,6,3600,0,'CET'),(1052,7,7200,1,'CEST'),(1052,8,3600,0,'CET'),(1052,9,7200,1,'CEST'),(1052,10,3600,0,'CET'),(1053,0,3484,0,'LMT'),(1053,1,7200,1,'CEST'),(1053,2,3600,0,'CET'),(1053,3,3600,0,'CET'),(1053,4,7200,1,'CEST'),(1053,5,7200,1,'CEST'),(1053,6,3600,0,'CET'),(1054,0,5989,0,'LMT'),(1054,1,5989,0,'HMT'),(1054,2,10800,1,'EEST'),(1054,3,7200,0,'EET'),(1054,4,10800,1,'EEST'),(1054,5,7200,0,'EET'),(1055,0,6616,0,'LMT'),(1055,1,6600,0,'MMT'),(1055,2,7200,0,'EET'),(1055,3,10800,0,'MSK'),(1055,4,3600,0,'CET'),(1055,5,7200,1,'CEST'),(1055,6,7200,1,'CEST'),(1055,7,14400,1,'MSD'),(1055,8,10800,0,'MSK'),(1055,9,14400,1,'MSD'),(1055,10,10800,1,'EEST'),(1055,11,7200,0,'EET'),(1055,12,10800,0,'+03'),(1056,0,561,0,'LMT'),(1056,1,561,0,'PMT'),(1056,2,3600,1,'WEST'),(1056,3,0,0,'WET'),(1056,4,3600,1,'WEST'),(1056,5,0,0,'WET'),(1056,6,3600,0,'CET'),(1056,7,7200,1,'CEST'),(1056,8,7200,1,'CEST'),(1056,9,7200,1,'WEMT'),(1056,10,3600,0,'CET'),(1056,11,7200,1,'CEST'),(1056,12,3600,0,'CET'),(1057,0,9017,0,'LMT'),(1057,1,9017,0,'MMT'),(1057,2,12679,1,'MST'),(1057,3,9079,0,'MMT'),(1057,4,16279,1,'MDST'),(1057,5,14400,1,'MSD'),(1057,6,10800,0,'MSK'),(1057,7,14400,1,'MSD'),(1057,8,18000,1,'+05'),(1057,9,7200,0,'EET'),(1057,10,10800,0,'MSK'),(1057,11,14400,1,'MSD'),(1057,12,10800,1,'EEST'),(1057,13,7200,0,'EET'),(1057,14,14400,0,'MSK'),(1057,15,14400,1,'MSD'),(1057,16,10800,0,'MSK'),(1058,0,8008,0,'LMT'),(1058,1,10800,1,'EEST'),(1058,2,7200,0,'EET'),(1058,3,7200,0,'EET'),(1058,4,10800,1,'EEST'),(1059,0,3208,0,'LMT'),(1059,1,7200,1,'CEST'),(1059,2,3600,0,'CET'),(1059,3,7200,1,'CEST'),(1059,4,3600,0,'CET'),(1059,5,10800,1,'CEMT'),(1059,6,10800,1,'CEMT'),(1059,7,7200,1,'CEST'),(1059,8,3600,0,'CET'),(1060,0,561,0,'LMT'),(1060,1,561,0,'PMT'),(1060,2,3600,1,'WEST'),(1060,3,0,0,'WET'),(1060,4,3600,1,'WEST'),(1060,5,0,0,'WET'),(1060,6,3600,0,'CET'),(1060,7,7200,1,'CEST'),(1060,8,7200,1,'CEST'),(1060,9,7200,1,'WEMT'),(1060,10,3600,0,'CET'),(1060,11,7200,1,'CEST'),(1060,12,3600,0,'CET'),(1061,0,4920,0,'LMT'),(1061,1,3600,0,'CET'),(1061,2,3600,0,'CET'),(1061,3,7200,1,'CEST'),(1061,4,7200,1,'CEST'),(1061,5,7200,1,'CEST'),(1061,6,3600,0,'CET'),(1062,0,3464,0,'PMT'),(1062,1,7200,1,'CEST'),(1062,2,3600,0,'CET'),(1062,3,7200,1,'CEST'),(1062,4,3600,0,'CET'),(1062,5,0,0,'GMT'),(1062,6,7200,1,'CEST'),(1062,7,3600,0,'CET'),(1063,0,5794,0,'LMT'),(1063,1,5794,0,'RMT'),(1063,2,9394,1,'LST'),(1063,3,7200,0,'EET'),(1063,4,10800,0,'MSK'),(1063,5,3600,0,'CET'),(1063,6,7200,1,'CEST'),(1063,7,7200,1,'CEST'),(1063,8,14400,1,'MSD'),(1063,9,10800,0,'MSK'),(1063,10,14400,1,'MSD'),(1063,11,10800,1,'EEST'),(1063,12,7200,0,'EET'),(1063,13,10800,1,'EEST'),(1063,14,7200,0,'EET'),(1064,0,2996,0,'RMT'),(1064,1,7200,1,'CEST'),(1064,2,3600,0,'CET'),(1064,3,3600,0,'CET'),(1064,4,7200,1,'CEST'),(1064,5,3600,0,'CET'),(1064,6,7200,1,'CEST'),(1065,0,12020,0,'LMT'),(1065,1,10800,0,'+03'),(1065,2,14400,0,'+04'),(1065,3,18000,1,'+05'),(1065,4,14400,0,'+04'),(1065,5,18000,1,'+05'),(1065,6,14400,1,'+04'),(1065,7,10800,0,'+03'),(1065,8,10800,1,'+03'),(1065,9,7200,0,'+02'),(1065,10,14400,1,'+04'),(1065,11,14400,0,'+04'),(1066,0,2996,0,'RMT'),(1066,1,7200,1,'CEST'),(1066,2,3600,0,'CET'),(1066,3,3600,0,'CET'),(1066,4,7200,1,'CEST'),(1066,5,3600,0,'CET'),(1066,6,7200,1,'CEST'),(1067,0,4920,0,'LMT'),(1067,1,3600,0,'CET'),(1067,2,3600,0,'CET'),(1067,3,7200,1,'CEST'),(1067,4,7200,1,'CEST'),(1067,5,7200,1,'CEST'),(1067,6,3600,0,'CET'),(1068,0,11058,0,'LMT'),(1068,1,10800,0,'+03'),(1068,2,18000,1,'+05'),(1068,3,14400,0,'+04'),(1068,4,14400,0,'+04'),(1068,5,18000,1,'+05'),(1068,6,14400,1,'+04'),(1068,7,10800,0,'+03'),(1068,8,14400,0,'+04'),(1069,0,8184,0,'LMT'),(1069,1,8160,0,'SMT'),(1069,2,7200,0,'EET'),(1069,3,10800,0,'MSK'),(1069,4,3600,0,'CET'),(1069,5,7200,1,'CEST'),(1069,6,7200,1,'CEST'),(1069,7,14400,1,'MSD'),(1069,8,10800,0,'MSK'),(1069,9,14400,1,'MSD'),(1069,10,10800,1,'EEST'),(1069,11,7200,0,'EET'),(1069,12,10800,1,'EEST'),(1069,13,7200,0,'EET'),(1069,14,14400,0,'MSK'),(1069,15,10800,0,'MSK'),(1070,0,4920,0,'LMT'),(1070,1,3600,0,'CET'),(1070,2,3600,0,'CET'),(1070,3,7200,1,'CEST'),(1070,4,7200,1,'CEST'),(1070,5,7200,1,'CEST'),(1070,6,3600,0,'CET'),(1071,0,7016,0,'IMT'),(1071,1,7200,0,'EET'),(1071,2,3600,0,'CET'),(1071,3,7200,1,'CEST'),(1071,4,3600,0,'CET'),(1071,5,10800,1,'EEST'),(1071,6,7200,0,'EET'),(1071,7,10800,1,'EEST'),(1071,8,10800,1,'EEST'),(1071,9,7200,0,'EET'),(1072,0,3208,0,'LMT'),(1072,1,7200,1,'CEST'),(1072,2,3600,0,'CET'),(1072,3,7200,1,'CEST'),(1072,4,3600,0,'CET'),(1072,5,10800,1,'CEMT'),(1072,6,10800,1,'CEMT'),(1072,7,7200,1,'CEST'),(1072,8,3600,0,'CET'),(1073,0,5940,0,'LMT'),(1073,1,5940,0,'TMT'),(1073,2,7200,1,'CEST'),(1073,3,3600,0,'CET'),(1073,4,3600,0,'CET'),(1073,5,7200,0,'EET'),(1073,6,10800,0,'MSK'),(1073,7,7200,1,'CEST'),(1073,8,14400,1,'MSD'),(1073,9,10800,0,'MSK'),(1073,10,14400,1,'MSD'),(1073,11,10800,1,'EEST'),(1073,12,7200,0,'EET'),(1073,13,7200,0,'EET'),(1073,14,10800,1,'EEST'),(1073,15,10800,1,'EEST'),(1074,0,4760,0,'LMT'),(1074,1,3600,0,'CET'),(1074,2,7200,1,'CEST'),(1074,3,3600,0,'CET'),(1074,4,7200,1,'CEST'),(1075,0,6920,0,'LMT'),(1075,1,6900,0,'CMT'),(1075,2,6264,0,'BMT'),(1075,3,10800,1,'EEST'),(1075,4,7200,0,'EET'),(1075,5,7200,0,'EET'),(1075,6,10800,1,'EEST'),(1075,7,3600,0,'CET'),(1075,8,7200,1,'CEST'),(1075,9,7200,1,'CEST'),(1075,10,14400,1,'MSD'),(1075,11,10800,0,'MSK'),(1075,12,10800,0,'MSK'),(1075,13,14400,1,'MSD'),(1075,14,10800,1,'EEST'),(1075,15,7200,0,'EET'),(1076,0,11616,0,'LMT'),(1076,1,10800,0,'+03'),(1076,2,18000,1,'+05'),(1076,3,14400,0,'+04'),(1076,4,14400,0,'+04'),(1076,5,18000,1,'+05'),(1076,6,14400,1,'+04'),(1076,7,10800,0,'+03'),(1076,8,10800,1,'+03'),(1076,9,7200,0,'+02'),(1076,10,14400,1,'+04'),(1076,11,14400,0,'+04'),(1077,0,7324,0,'LMT'),(1077,1,7324,0,'KMT'),(1077,2,7200,0,'EET'),(1077,3,10800,0,'MSK'),(1077,4,3600,0,'CET'),(1077,5,7200,1,'CEST'),(1077,6,7200,1,'CEST'),(1077,7,14400,1,'MSD'),(1077,8,10800,0,'MSK'),(1077,9,14400,1,'MSD'),(1077,10,10800,1,'EEST'),(1077,11,7200,0,'EET'),(1077,12,10800,1,'EEST'),(1077,13,7200,0,'EET'),(1077,14,10800,1,'EEST'),(1078,0,1786,0,'BMT'),(1078,1,7200,1,'CEST'),(1078,2,3600,0,'CET'),(1078,3,7200,1,'CEST'),(1078,4,3600,0,'CET'),(1079,0,2996,0,'RMT'),(1079,1,7200,1,'CEST'),(1079,2,3600,0,'CET'),(1079,3,3600,0,'CET'),(1079,4,7200,1,'CEST'),(1079,5,3600,0,'CET'),(1079,6,7200,1,'CEST'),(1080,0,3921,0,'LMT'),(1080,1,7200,1,'CEST'),(1080,2,3600,0,'CET'),(1080,3,7200,1,'CEST'),(1080,4,3600,0,'CET'),(1080,5,7200,1,'CEST'),(1080,6,3600,0,'CET'),(1081,0,6076,0,'LMT'),(1081,1,5040,0,'WMT'),(1081,2,5736,0,'KMT'),(1081,3,3600,0,'CET'),(1081,4,7200,0,'EET'),(1081,5,10800,0,'MSK'),(1081,6,3600,0,'CET'),(1081,7,7200,1,'CEST'),(1081,8,7200,1,'CEST'),(1081,9,14400,1,'MSD'),(1081,10,10800,0,'MSK'),(1081,11,14400,1,'MSD'),(1081,12,10800,1,'EEST'),(1081,13,7200,0,'EET'),(1081,14,7200,1,'CEST'),(1081,15,3600,0,'CET'),(1081,16,7200,0,'EET'),(1081,17,10800,1,'EEST'),(1082,0,10660,0,'LMT'),(1082,1,10800,0,'+03'),(1082,2,14400,0,'+04'),(1082,3,18000,1,'+05'),(1082,4,14400,0,'+04'),(1082,5,18000,1,'+05'),(1082,6,14400,1,'MSD'),(1082,7,10800,0,'MSK'),(1082,8,14400,0,'MSK'),(1082,9,10800,0,'MSK'),(1083,0,5040,0,'LMT'),(1083,1,5040,0,'WMT'),(1083,2,7200,1,'CEST'),(1083,3,3600,0,'CET'),(1083,4,7200,1,'CEST'),(1083,5,3600,0,'CET'),(1083,6,10800,1,'EEST'),(1083,7,7200,0,'EET'),(1083,8,7200,0,'EET'),(1083,9,7200,1,'CEST'),(1083,10,3600,0,'CET'),(1084,0,4920,0,'LMT'),(1084,1,3600,0,'CET'),(1084,2,3600,0,'CET'),(1084,3,7200,1,'CEST'),(1084,4,7200,1,'CEST'),(1084,5,7200,1,'CEST'),(1084,6,3600,0,'CET'),(1085,0,7324,0,'LMT'),(1085,1,7324,0,'KMT'),(1085,2,7200,0,'EET'),(1085,3,10800,0,'MSK'),(1085,4,3600,0,'CET'),(1085,5,7200,1,'CEST'),(1085,6,7200,1,'CEST'),(1085,7,14400,1,'MSD'),(1085,8,10800,0,'MSK'),(1085,9,14400,1,'MSD'),(1085,10,10800,1,'EEST'),(1085,11,7200,0,'EET'),(1085,12,10800,1,'EEST'),(1085,13,7200,0,'EET'),(1085,14,10800,1,'EEST'),(1086,0,1786,0,'BMT'),(1086,1,7200,1,'CEST'),(1086,2,3600,0,'CET'),(1086,3,7200,1,'CEST'),(1086,4,3600,0,'CET'),(1087,0,-75,0,'LMT'),(1087,1,3600,1,'BST'),(1087,2,0,0,'GMT'),(1087,3,7200,1,'BDST'),(1087,4,0,0,'GMT'),(1087,5,3600,0,'BST'),(1087,6,3600,1,'BST'),(1087,7,0,0,'GMT'),(1088,0,-75,0,'LMT'),(1088,1,3600,1,'BST'),(1088,2,0,0,'GMT'),(1088,3,7200,1,'BDST'),(1088,4,0,0,'GMT'),(1088,5,3600,0,'BST'),(1088,6,3600,1,'BST'),(1088,7,0,0,'GMT'),(1089,0,0,0,'GMT'),(1090,0,0,0,'GMT'),(1091,0,0,0,'GMT'),(1092,0,0,0,'GMT'),(1093,0,0,0,'GMT'),(1094,0,-36000,0,'HST'),(1095,0,27402,0,'LMT'),(1095,1,28800,0,'HKT'),(1095,2,32400,1,'HKST'),(1095,3,30600,1,'HKWT'),(1095,4,32400,0,'JST'),(1095,5,28800,0,'HKT'),(1095,6,32400,1,'HKST'),(1095,7,28800,0,'HKT'),(1096,0,-968,0,'LMT'),(1096,1,0,0,'GMT'),(1097,0,8836,0,'LMT'),(1097,1,9000,0,'+0230'),(1097,2,10800,0,'EAT'),(1097,3,9900,0,'+0245'),(1097,4,10800,0,'EAT'),(1098,0,17380,0,'LMT'),(1098,1,18000,0,'+05'),(1098,2,21600,0,'+06'),(1099,0,24124,0,'LMT'),(1099,1,24124,0,'BMT'),(1099,2,25200,0,'+07'),(1100,0,23087,0,'LMT'),(1100,1,23087,0,'RMT'),(1100,2,23400,0,'+0630'),(1100,3,32400,0,'+09'),(1100,4,23400,0,'+0630'),(1101,0,8836,0,'LMT'),(1101,1,9000,0,'+0230'),(1101,2,10800,0,'EAT'),(1101,3,9900,0,'+0245'),(1101,4,10800,0,'EAT'),(1102,0,17640,0,'LMT'),(1102,1,17640,0,'MMT'),(1102,2,18000,0,'+05'),(1103,0,13272,0,'LMT'),(1103,1,14400,0,'+04'),(1104,0,17640,0,'LMT'),(1104,1,17640,0,'MMT'),(1104,2,18000,0,'+05'),(1105,0,13800,0,'LMT'),(1105,1,18000,1,'+05'),(1105,2,14400,0,'+04'),(1106,0,8836,0,'LMT'),(1106,1,9000,0,'+0230'),(1106,2,10800,0,'EAT'),(1106,3,9900,0,'+0245'),(1106,4,10800,0,'EAT'),(1107,0,13272,0,'LMT'),(1107,1,14400,0,'+04'),(1108,0,12344,0,'LMT'),(1108,1,12344,0,'TMT'),(1108,2,16200,1,'+0430'),(1108,3,12600,0,'+0330'),(1108,4,18000,1,'+05'),(1108,5,14400,0,'+04'),(1108,6,16200,1,'+0430'),(1108,7,12600,0,'+0330'),(1109,0,8454,0,'LMT'),(1109,1,8440,0,'JMT'),(1109,2,10800,1,'IDT'),(1109,3,7200,0,'IST'),(1109,4,14400,1,'IDDT'),(1109,5,10800,1,'IDT'),(1109,6,7200,0,'IST'),(1109,7,10800,1,'IDT'),(1109,8,7200,0,'IST'),(1110,0,-18430,0,'LMT'),(1110,1,-18430,0,'KMT'),(1110,2,-18000,0,'EST'),(1110,3,-14400,1,'EDT'),(1111,0,33539,0,'LMT'),(1111,1,36000,1,'JDT'),(1111,2,32400,0,'JST'),(1111,3,32400,0,'JST'),(1112,0,40160,0,'LMT'),(1112,1,39600,0,'+11'),(1112,2,36000,0,'+10'),(1112,3,32400,0,'+09'),(1112,4,-43200,0,'-12'),(1112,5,43200,0,'+12'),(1113,0,3164,0,'LMT'),(1113,1,7200,1,'CEST'),(1113,2,3600,0,'CET'),(1113,3,7200,0,'EET'),(1114,0,7200,1,'MEST'),(1114,1,3600,0,'MET'),(1114,2,7200,1,'MEST'),(1114,3,3600,0,'MET'),(1115,0,-25200,0,'MST'),(1116,0,-21600,1,'MDT'),(1116,1,-25200,0,'MST'),(1116,2,-21600,1,'MWT'),(1116,3,-21600,1,'MPT'),(1117,0,-28084,0,'LMT'),(1117,1,-25200,0,'MST'),(1117,2,-28800,0,'PST'),(1117,3,-25200,0,'MST'),(1117,4,-25200,1,'PDT'),(1117,5,-25200,1,'PWT'),(1117,6,-25200,1,'PPT'),(1117,7,-28800,0,'PST'),(1118,0,-25540,0,'LMT'),(1118,1,-25200,0,'MST'),(1118,2,-21600,0,'CST'),(1118,3,-21600,1,'MDT'),(1118,4,-25200,0,'MST'),(1118,5,-28800,0,'PST'),(1118,6,-25200,0,'MST'),(1119,0,-23796,0,'LMT'),(1119,1,-25200,0,'MST'),(1119,2,-21600,0,'CST'),(1119,3,-21600,1,'MDT'),(1119,4,-25200,0,'MST'),(1119,5,-18000,1,'CDT'),(1119,6,-18000,1,'CWT'),(1119,7,-21600,0,'CST'),(1120,0,41944,0,'LMT'),(1120,1,45000,1,'NZST'),(1120,2,41400,0,'NZMT'),(1120,3,43200,1,'NZST'),(1120,4,46800,1,'NZDT'),(1120,5,43200,0,'NZST'),(1120,6,43200,0,'NZST'),(1121,0,44028,0,'LMT'),(1121,1,44100,0,'+1215'),(1121,2,49500,1,'+1345'),(1121,3,45900,0,'+1245'),(1121,4,45900,0,'+1245'),(1122,0,-25196,0,'LMT'),(1122,1,-21600,1,'MDT'),(1122,2,-25200,0,'MST'),(1122,3,-25200,0,'MST'),(1122,4,-21600,1,'MWT'),(1122,5,-21600,1,'MPT'),(1123,0,29143,0,'LMT'),(1123,1,32400,1,'CDT'),(1123,2,28800,0,'CST'),(1124,0,-25200,1,'PDT'),(1124,1,-28800,0,'PST'),(1124,2,-25200,1,'PWT'),(1124,3,-25200,1,'PPT'),(1125,0,45184,0,'LMT'),(1125,1,-41216,0,'LMT'),(1125,2,-41400,0,'-1130'),(1125,3,-36000,1,'-10'),(1125,4,-39600,0,'-11'),(1125,5,46800,0,'+13'),(1125,6,50400,1,'+14'),(1126,0,41944,0,'LMT'),(1126,1,45000,1,'NZST'),(1126,2,41400,0,'NZMT'),(1126,3,43200,1,'NZST'),(1126,4,46800,1,'NZDT'),(1126,5,43200,0,'NZST'),(1126,6,43200,0,'NZST'),(1127,0,35312,0,'PMMT'),(1127,1,36000,0,'+10'),(1127,2,32400,0,'+09'),(1127,3,39600,0,'+11'),(1128,0,44028,0,'LMT'),(1128,1,44100,0,'+1215'),(1128,2,49500,1,'+1345'),(1128,3,45900,0,'+1245'),(1128,4,45900,0,'+1245'),(1129,0,35312,0,'PMMT'),(1129,1,36000,0,'+10'),(1130,0,-26248,0,'LMT'),(1130,1,-26248,0,'EMT'),(1130,2,-21600,1,'-06'),(1130,3,-25200,0,'-07'),(1130,4,-25200,0,'-07'),(1130,5,-21600,0,'-06'),(1130,6,-18000,1,'-05'),(1131,0,40396,0,'LMT'),(1131,1,43200,1,'+12'),(1131,2,39600,0,'+11'),(1131,3,43200,1,'+12'),(1131,4,39600,0,'+11'),(1132,0,0,0,'-00'),(1132,1,-43200,0,'-12'),(1132,2,-39600,0,'-11'),(1132,3,46800,0,'+13'),(1133,0,-41096,0,'LMT'),(1133,1,-39600,0,'-11'),(1133,2,46800,0,'+13'),(1134,0,42944,0,'LMT'),(1134,1,46800,1,'+13'),(1134,2,43200,0,'+12'),(1135,0,41524,0,'LMT'),(1135,1,43200,0,'+12'),(1136,0,-21504,0,'LMT'),(1136,1,-18000,0,'-05'),(1136,2,-18000,1,'-05'),(1136,3,-21600,0,'-06'),(1137,0,-32388,0,'LMT'),(1137,1,-32400,0,'-09'),(1138,0,38388,0,'LMT'),(1138,1,39600,0,'+11'),(1139,0,34740,0,'LMT'),(1139,1,36000,0,'GST'),(1139,2,32400,0,'+09'),(1139,3,39600,1,'GDT'),(1139,4,36000,0,'ChST'),(1140,0,-37886,0,'LMT'),(1140,1,-37800,0,'HST'),(1140,2,-34200,1,'HDT'),(1140,3,-34200,1,'HWT'),(1140,4,-34200,1,'HPT'),(1140,5,-36000,0,'HST'),(1141,0,-37886,0,'LMT'),(1141,1,-37800,0,'HST'),(1141,2,-34200,1,'HDT'),(1141,3,-34200,1,'HWT'),(1141,4,-34200,1,'HPT'),(1141,5,-36000,0,'HST'),(1142,0,0,0,'-00'),(1142,1,-43200,0,'-12'),(1142,2,-39600,0,'-11'),(1142,3,46800,0,'+13'),(1143,0,-37760,0,'LMT'),(1143,1,-38400,0,'-1040'),(1143,2,-36000,0,'-10'),(1143,3,50400,0,'+14'),(1144,0,39116,0,'LMT'),(1144,1,39600,0,'+11'),(1144,2,32400,0,'+09'),(1144,3,36000,0,'+10'),(1144,4,43200,0,'+12'),(1144,5,39600,0,'+11'),(1145,0,40160,0,'LMT'),(1145,1,39600,0,'+11'),(1145,2,36000,0,'+10'),(1145,3,32400,0,'+09'),(1145,4,-43200,0,'-12'),(1145,5,43200,0,'+12'),(1146,0,41524,0,'LMT'),(1146,1,43200,0,'+12'),(1147,0,-33480,0,'LMT'),(1147,1,-34200,0,'-0930'),(1148,0,45432,0,'LMT'),(1148,1,-40968,0,'LMT'),(1148,2,-39600,0,'SST'),(1149,0,40060,0,'LMT'),(1149,1,41400,0,'+1130'),(1149,2,32400,0,'+09'),(1149,3,43200,0,'+12'),(1150,0,-40780,0,'LMT'),(1150,1,-40800,0,'-1120'),(1150,2,-39600,0,'-11'),(1151,0,40312,0,'LMT'),(1151,1,40320,0,'+1112'),(1151,2,41400,0,'+1130'),(1151,3,45000,1,'+1230'),(1151,4,41400,0,'+1130'),(1151,5,39600,0,'+11'),(1151,6,43200,1,'+12'),(1151,7,39600,0,'+11'),(1152,0,39948,0,'LMT'),(1152,1,43200,1,'+12'),(1152,2,39600,0,'+11'),(1152,3,43200,1,'+12'),(1152,4,39600,0,'+11'),(1153,0,45432,0,'LMT'),(1153,1,-40968,0,'LMT'),(1153,2,-39600,0,'SST'),(1154,0,32276,0,'LMT'),(1154,1,32400,0,'+09'),(1155,0,-31220,0,'LMT'),(1155,1,-30600,0,'-0830'),(1155,2,-28800,0,'-08'),(1156,0,38388,0,'LMT'),(1156,1,39600,0,'+11'),(1157,0,38388,0,'LMT'),(1157,1,39600,0,'+11'),(1158,0,35312,0,'PMMT'),(1158,1,36000,0,'+10'),(1159,0,48056,0,'LMT'),(1159,1,-38344,0,'LMT'),(1159,2,-37800,0,'-1030'),(1159,3,-36000,0,'-10'),(1159,4,-34200,1,'-0930'),(1160,0,34740,0,'LMT'),(1160,1,36000,0,'GST'),(1160,2,32400,0,'+09'),(1160,3,39600,1,'GDT'),(1160,4,36000,0,'ChST'),(1161,0,45432,0,'LMT'),(1161,1,-40968,0,'LMT'),(1161,2,-39600,0,'SST'),(1162,0,-35896,0,'LMT'),(1162,1,-36000,0,'-10'),(1163,0,41524,0,'LMT'),(1163,1,43200,0,'+12'),(1164,0,44352,0,'LMT'),(1164,1,44400,0,'+1220'),(1164,2,46800,0,'+13'),(1164,3,50400,1,'+14'),(1164,4,46800,0,'+13'),(1164,5,50400,1,'+14'),(1165,0,35312,0,'PMMT'),(1165,1,36000,0,'+10'),(1166,0,41524,0,'LMT'),(1166,1,43200,0,'+12'),(1167,0,41524,0,'LMT'),(1167,1,43200,0,'+12'),(1168,0,35312,0,'PMMT'),(1168,1,36000,0,'+10'),(1169,0,5040,0,'LMT'),(1169,1,5040,0,'WMT'),(1169,2,7200,1,'CEST'),(1169,3,3600,0,'CET'),(1169,4,7200,1,'CEST'),(1169,5,3600,0,'CET'),(1169,6,10800,1,'EEST'),(1169,7,7200,0,'EET'),(1169,8,7200,0,'EET'),(1169,9,7200,1,'CEST'),(1169,10,3600,0,'CET'),(1170,0,-2205,0,'LMT'),(1170,1,3600,1,'WEST'),(1170,2,0,0,'WET'),(1170,3,3600,1,'WEST'),(1170,4,0,0,'WET'),(1170,5,7200,1,'WEMT'),(1170,6,0,0,'WET'),(1170,7,3600,0,'CET'),(1170,8,3600,0,'CET'),(1170,9,7200,1,'CEST'),(1170,10,3600,1,'WEST'),(1170,11,0,0,'WET'),(1171,0,29160,0,'LMT'),(1171,1,28800,0,'CST'),(1171,2,32400,0,'JST'),(1171,3,32400,1,'CDT'),(1171,4,28800,0,'CST'),(1172,0,30472,0,'LMT'),(1172,1,30600,0,'KST'),(1172,2,32400,0,'JST'),(1172,3,36000,1,'KDT'),(1172,4,32400,0,'KST'),(1172,5,34200,1,'KDT'),(1172,6,36000,1,'KDT'),(1173,0,24925,0,'LMT'),(1173,1,24925,0,'SMT'),(1173,2,25200,0,'+07'),(1173,3,26400,1,'+0720'),(1173,4,26400,0,'+0720'),(1173,5,27000,0,'+0730'),(1173,6,32400,0,'+09'),(1173,7,28800,0,'+08'),(1174,0,6952,0,'LMT'),(1174,1,7016,0,'IMT'),(1174,2,10800,1,'EEST'),(1174,3,7200,0,'EET'),(1174,4,10800,0,'+03'),(1174,5,14400,1,'+04'),(1174,6,10800,1,'EEST'),(1174,7,7200,0,'EET'),(1174,8,10800,1,'EEST'),(1174,9,7200,0,'EET'),(1174,10,10800,0,'+03'),(1175,0,0,0,'UTC'),(1176,0,-35976,0,'LMT'),(1176,1,-36000,0,'AST'),(1176,2,-32400,1,'AWT'),(1176,3,-32400,1,'APT'),(1176,4,-36000,0,'AHST'),(1176,5,-32400,1,'AHDT'),(1176,6,-32400,0,'YST'),(1176,7,-28800,1,'AKDT'),(1176,8,-32400,0,'AKST'),(1177,0,-42398,0,'LMT'),(1177,1,-39600,0,'NST'),(1177,2,-36000,1,'NWT'),(1177,3,-36000,1,'NPT'),(1177,4,-39600,0,'BST'),(1177,5,-36000,1,'BDT'),(1177,6,-36000,0,'AHST'),(1177,7,-32400,1,'HDT'),(1177,8,-36000,0,'HST'),(1178,0,-26898,0,'LMT'),(1178,1,-21600,1,'MDT'),(1178,2,-25200,0,'MST'),(1178,3,-21600,1,'MWT'),(1178,4,-25200,0,'MST'),(1179,0,-21036,0,'LMT'),(1179,1,-18000,1,'CDT'),(1179,2,-21600,0,'CST'),(1179,3,-21600,0,'CST'),(1179,4,-18000,0,'EST'),(1179,5,-18000,1,'CWT'),(1179,6,-18000,1,'CPT'),(1179,7,-21600,0,'CST'),(1180,0,-20678,0,'LMT'),(1180,1,-18000,1,'CDT'),(1180,2,-21600,0,'CST'),(1180,3,-21600,0,'CST'),(1180,4,-18000,1,'CWT'),(1180,5,-18000,1,'CPT'),(1180,6,-18000,0,'EST'),(1180,7,-14400,1,'EDT'),(1181,0,-17762,0,'LMT'),(1181,1,-14400,1,'EDT'),(1181,2,-18000,0,'EST'),(1181,3,-18000,0,'EST'),(1181,4,-14400,1,'EWT'),(1181,5,-14400,1,'EPT'),(1182,0,-37886,0,'LMT'),(1182,1,-37800,0,'HST'),(1182,2,-34200,1,'HDT'),(1182,3,-34200,1,'HWT'),(1182,4,-34200,1,'HPT'),(1182,5,-36000,0,'HST'),(1183,0,-20790,0,'LMT'),(1183,1,-18000,1,'CDT'),(1183,2,-21600,0,'CST'),(1183,3,-18000,1,'CWT'),(1183,4,-18000,1,'CPT'),(1183,5,-21600,0,'CST'),(1183,6,-18000,0,'EST'),(1183,7,-21600,0,'CST'),(1184,0,-19931,0,'LMT'),(1184,1,-21600,0,'CST'),(1184,2,-18000,0,'EST'),(1184,3,-14400,1,'EWT'),(1184,4,-14400,1,'EPT'),(1184,5,-14400,1,'EDT'),(1185,0,-25196,0,'LMT'),(1185,1,-21600,1,'MDT'),(1185,2,-25200,0,'MST'),(1185,3,-25200,0,'MST'),(1185,4,-21600,1,'MWT'),(1185,5,-21600,1,'MPT'),(1186,0,-28378,0,'LMT'),(1186,1,-25200,1,'PDT'),(1186,2,-28800,0,'PST'),(1186,3,-25200,1,'PWT'),(1186,4,-25200,1,'PPT'),(1186,5,-28800,0,'PST'),(1187,0,45432,0,'LMT'),(1187,1,-40968,0,'LMT'),(1187,2,-39600,0,'SST'),(1188,0,0,0,'UTC'),(1189,0,0,0,'UTC'),(1190,0,9017,0,'LMT'),(1190,1,9017,0,'MMT'),(1190,2,12679,1,'MST'),(1190,3,9079,0,'MMT'),(1190,4,16279,1,'MDST'),(1190,5,14400,1,'MSD'),(1190,6,10800,0,'MSK'),(1190,7,14400,1,'MSD'),(1190,8,18000,1,'+05'),(1190,9,7200,0,'EET'),(1190,10,10800,0,'MSK'),(1190,11,14400,1,'MSD'),(1190,12,10800,1,'EEST'),(1190,13,7200,0,'EET'),(1190,14,14400,0,'MSK'),(1190,15,14400,1,'MSD'),(1190,16,10800,0,'MSK'),(1191,0,3600,1,'WEST'),(1191,1,0,0,'WET'),(1192,0,0,0,'UTC'),(1193,0,-17762,0,'LMT'),(1193,1,-14400,1,'EDT'),(1193,2,-18000,0,'EST'),(1193,3,-18000,0,'EST'),(1193,4,-14400,1,'EWT'),(1193,5,-14400,1,'EPT'),(1194,0,-968,0,'LMT'),(1194,1,0,0,'GMT'),(1195,0,-968,0,'LMT'),(1195,1,0,0,'GMT'),(1196,0,8836,0,'LMT'),(1196,1,9000,0,'+0230'),(1196,2,10800,0,'EAT'),(1196,3,9900,0,'+0245'),(1196,4,10800,0,'EAT'),(1197,0,732,0,'LMT'),(1197,1,561,0,'PMT'),(1197,2,3600,1,'WEST'),(1197,3,0,0,'WET'),(1197,4,0,0,'WET'),(1197,5,7200,1,'CEST'),(1197,6,3600,0,'CET'),(1197,7,3600,1,'WEST'),(1198,0,8836,0,'LMT'),(1198,1,9000,0,'+0230'),(1198,2,10800,0,'EAT'),(1198,3,9900,0,'+0245'),(1198,4,10800,0,'EAT'),(1199,0,8836,0,'LMT'),(1199,1,9000,0,'+0230'),(1199,2,10800,0,'EAT'),(1199,3,9900,0,'+0245'),(1199,4,10800,0,'EAT'),(1200,0,-968,0,'LMT'),(1200,1,0,0,'GMT'),(1201,0,815,0,'LMT'),(1201,1,0,0,'GMT'),(1201,2,1800,0,'+0030'),(1201,3,3600,0,'WAT'),(1202,0,-968,0,'LMT'),(1202,1,0,0,'GMT'),(1203,0,-3740,0,'LMT'),(1203,1,-3600,0,'-01'),(1203,2,0,0,'GMT'),(1204,0,7820,0,'LMT'),(1204,1,7200,0,'CAT'),(1205,0,815,0,'LMT'),(1205,1,0,0,'GMT'),(1205,2,1800,0,'+0030'),(1205,3,3600,0,'WAT'),(1206,0,7820,0,'LMT'),(1206,1,7200,0,'CAT'),(1207,0,7509,0,'LMT'),(1207,1,10800,1,'EEST'),(1207,2,7200,0,'EET'),(1207,3,10800,1,'EEST'),(1208,0,-1820,0,'LMT'),(1208,1,3600,1,'+01'),(1208,2,0,0,'+00'),(1208,3,3600,0,'+01'),(1208,4,0,0,'+00'),(1209,0,-1276,0,'LMT'),(1209,1,0,0,'WET'),(1209,2,3600,1,'WEST'),(1209,3,0,0,'WET'),(1209,4,0,0,'WET'),(1209,5,3600,0,'CET'),(1209,6,7200,1,'CEST'),(1209,7,3600,0,'CET'),(1210,0,-968,0,'LMT'),(1210,1,0,0,'GMT'),(1211,0,-968,0,'LMT'),(1211,1,0,0,'GMT'),(1212,0,8836,0,'LMT'),(1212,1,9000,0,'+0230'),(1212,2,10800,0,'EAT'),(1212,3,9900,0,'+0245'),(1212,4,10800,0,'EAT'),(1213,0,8836,0,'LMT'),(1213,1,9000,0,'+0230'),(1213,2,10800,0,'EAT'),(1213,3,9900,0,'+0245'),(1213,4,10800,0,'EAT'),(1214,0,815,0,'LMT'),(1214,1,0,0,'GMT'),(1214,2,1800,0,'+0030'),(1214,3,3600,0,'WAT'),(1215,0,-3168,0,'LMT'),(1215,1,-3600,0,'-01'),(1215,2,3600,1,'+01'),(1215,3,0,0,'+00'),(1216,0,-968,0,'LMT'),(1216,1,0,0,'GMT'),(1217,0,7820,0,'LMT'),(1217,1,7200,0,'CAT'),(1218,0,7820,0,'LMT'),(1218,1,7200,0,'CAT'),(1219,0,6720,0,'LMT'),(1219,1,5400,0,'SAST'),(1219,2,10800,1,'SAST'),(1219,3,7200,0,'SAST'),(1220,0,7588,0,'LMT'),(1220,1,10800,1,'CAST'),(1220,2,7200,0,'CAT'),(1220,3,10800,0,'EAT'),(1220,4,7200,0,'CAT'),(1221,0,8836,0,'LMT'),(1221,1,9000,0,'+0230'),(1221,2,10800,0,'EAT'),(1221,3,9900,0,'+0245'),(1221,4,10800,0,'EAT'),(1222,0,7808,0,'LMT'),(1222,1,10800,1,'CAST'),(1222,2,7200,0,'CAT'),(1222,3,10800,0,'EAT'),(1222,4,7200,0,'CAT'),(1223,0,7820,0,'LMT'),(1223,1,7200,0,'CAT'),(1224,0,815,0,'LMT'),(1224,1,0,0,'GMT'),(1224,2,1800,0,'+0030'),(1224,3,3600,0,'WAT'),(1225,0,815,0,'LMT'),(1225,1,0,0,'GMT'),(1225,2,1800,0,'+0030'),(1225,3,3600,0,'WAT'),(1226,0,815,0,'LMT'),(1226,1,0,0,'GMT'),(1226,2,1800,0,'+0030'),(1226,3,3600,0,'WAT'),(1227,0,-968,0,'LMT'),(1227,1,0,0,'GMT'),(1228,0,815,0,'LMT'),(1228,1,0,0,'GMT'),(1228,2,1800,0,'+0030'),(1228,3,3600,0,'WAT'),(1229,0,7820,0,'LMT'),(1229,1,7200,0,'CAT'),(1230,0,7820,0,'LMT'),(1230,1,7200,0,'CAT'),(1231,0,815,0,'LMT'),(1231,1,0,0,'GMT'),(1231,2,1800,0,'+0030'),(1231,3,3600,0,'WAT'),(1232,0,7820,0,'LMT'),(1232,1,7200,0,'CAT'),(1233,0,6720,0,'LMT'),(1233,1,5400,0,'SAST'),(1233,2,10800,1,'SAST'),(1233,3,7200,0,'SAST'),(1234,0,6720,0,'LMT'),(1234,1,5400,0,'SAST'),(1234,2,10800,1,'SAST'),(1234,3,7200,0,'SAST'),(1235,0,8836,0,'LMT'),(1235,1,9000,0,'+0230'),(1235,2,10800,0,'EAT'),(1235,3,9900,0,'+0245'),(1235,4,10800,0,'EAT'),(1236,0,-2588,0,'LMT'),(1236,1,-2588,0,'MMT'),(1236,2,-2670,0,'MMT'),(1236,3,0,0,'GMT'),(1237,0,8836,0,'LMT'),(1237,1,9000,0,'+0230'),(1237,2,10800,0,'EAT'),(1237,3,9900,0,'+0245'),(1237,4,10800,0,'EAT'),(1238,0,3612,0,'LMT'),(1238,1,3600,0,'WAT'),(1238,2,7200,1,'WAST'),(1239,0,815,0,'LMT'),(1239,1,0,0,'GMT'),(1239,2,1800,0,'+0030'),(1239,3,3600,0,'WAT'),(1240,0,-968,0,'LMT'),(1240,1,0,0,'GMT'),(1241,0,-968,0,'LMT'),(1241,1,0,0,'GMT'),(1242,0,815,0,'LMT'),(1242,1,0,0,'GMT'),(1242,2,1800,0,'+0030'),(1242,3,3600,0,'WAT'),(1243,0,1616,0,'LMT'),(1243,1,-2205,0,'LMT'),(1243,2,0,0,'GMT'),(1243,3,3600,0,'WAT'),(1243,4,0,0,'GMT'),(1244,0,-968,0,'LMT'),(1244,1,0,0,'GMT'),(1245,0,3164,0,'LMT'),(1245,1,7200,1,'CEST'),(1245,2,3600,0,'CET'),(1245,3,7200,0,'EET'),(1246,0,2444,0,'LMT'),(1246,1,561,0,'PMT'),(1246,2,7200,1,'CEST'),(1246,3,3600,0,'CET'),(1246,4,3600,0,'CET'),(1246,5,7200,1,'CEST'),(1247,0,4104,0,'LMT'),(1247,1,5400,0,'+0130'),(1247,2,7200,0,'SAST'),(1247,3,10800,1,'SAST'),(1247,4,7200,0,'CAT'),(1247,5,3600,0,'WAT'),(1247,6,7200,1,'CAT'),(1247,7,7200,0,'CAT'),(1248,0,-42398,0,'LMT'),(1248,1,-39600,0,'NST'),(1248,2,-36000,1,'NWT'),(1248,3,-36000,1,'NPT'),(1248,4,-39600,0,'BST'),(1248,5,-36000,1,'BDT'),(1248,6,-36000,0,'AHST'),(1248,7,-32400,1,'HDT'),(1248,8,-36000,0,'HST'),(1249,0,-35976,0,'LMT'),(1249,1,-36000,0,'AST'),(1249,2,-32400,1,'AWT'),(1249,3,-32400,1,'APT'),(1249,4,-36000,0,'AHST'),(1249,5,-32400,1,'AHDT'),(1249,6,-32400,0,'YST'),(1249,7,-28800,1,'AKDT'),(1249,8,-32400,0,'AKST'),(1250,0,-15865,0,'LMT'),(1250,1,-14400,0,'AST'),(1250,2,-10800,1,'APT'),(1250,3,-10800,1,'AWT'),(1251,0,-15865,0,'LMT'),(1251,1,-14400,0,'AST'),(1251,2,-10800,1,'APT'),(1251,3,-10800,1,'AWT'),(1252,0,-11568,0,'LMT'),(1252,1,-7200,1,'-02'),(1252,2,-10800,0,'-03'),(1253,0,-14028,0,'LMT'),(1253,1,-15408,0,'CMT'),(1253,2,-14400,0,'-04'),(1253,3,-10800,1,'-03'),(1253,4,-7200,1,'-02'),(1253,5,-10800,0,'-03'),(1254,0,-15788,0,'LMT'),(1254,1,-15408,0,'CMT'),(1254,2,-14400,0,'-04'),(1254,3,-10800,1,'-03'),(1254,4,-7200,1,'-02'),(1254,5,-10800,0,'-03'),(1255,0,-15788,0,'LMT'),(1255,1,-15408,0,'CMT'),(1255,2,-14400,0,'-04'),(1255,3,-10800,1,'-03'),(1255,4,-7200,1,'-02'),(1255,5,-10800,0,'-03'),(1256,0,-15408,0,'LMT'),(1256,1,-15408,0,'CMT'),(1256,2,-14400,0,'-04'),(1256,3,-10800,1,'-03'),(1256,4,-7200,1,'-02'),(1256,5,-10800,0,'-03'),(1257,0,-15672,0,'LMT'),(1257,1,-15408,0,'CMT'),(1257,2,-14400,0,'-04'),(1257,3,-10800,1,'-03'),(1257,4,-7200,1,'-02'),(1257,5,-10800,0,'-03'),(1258,0,-16044,0,'LMT'),(1258,1,-15408,0,'CMT'),(1258,2,-14400,0,'-04'),(1258,3,-10800,1,'-03'),(1258,4,-7200,1,'-02'),(1258,5,-10800,0,'-03'),(1259,0,-16516,0,'LMT'),(1259,1,-15408,0,'CMT'),(1259,2,-14400,0,'-04'),(1259,3,-10800,1,'-03'),(1259,4,-7200,1,'-02'),(1259,5,-10800,0,'-03'),(1260,0,-16612,0,'LMT'),(1260,1,-15408,0,'CMT'),(1260,2,-14400,0,'-04'),(1260,3,-10800,1,'-03'),(1260,4,-7200,1,'-02'),(1260,5,-10800,0,'-03'),(1261,0,-15700,0,'LMT'),(1261,1,-15408,0,'CMT'),(1261,2,-14400,0,'-04'),(1261,3,-10800,1,'-03'),(1261,4,-7200,1,'-02'),(1261,5,-10800,0,'-03'),(1262,0,-16444,0,'LMT'),(1262,1,-15408,0,'CMT'),(1262,2,-14400,0,'-04'),(1262,3,-10800,1,'-03'),(1262,4,-7200,1,'-02'),(1262,5,-10800,0,'-03'),(1263,0,-15924,0,'LMT'),(1263,1,-15408,0,'CMT'),(1263,2,-14400,0,'-04'),(1263,3,-10800,1,'-03'),(1263,4,-7200,1,'-02'),(1263,5,-10800,0,'-03'),(1263,6,-10800,1,'-03'),(1264,0,-15652,0,'LMT'),(1264,1,-15408,0,'CMT'),(1264,2,-14400,0,'-04'),(1264,3,-10800,1,'-03'),(1264,4,-7200,1,'-02'),(1264,5,-10800,0,'-03'),(1265,0,-16392,0,'LMT'),(1265,1,-15408,0,'CMT'),(1265,2,-14400,0,'-04'),(1265,3,-10800,1,'-03'),(1265,4,-7200,1,'-02'),(1265,5,-10800,0,'-03'),(1266,0,-15865,0,'LMT'),(1266,1,-14400,0,'AST'),(1266,2,-10800,1,'APT'),(1266,3,-10800,1,'AWT'),(1267,0,-13840,0,'LMT'),(1267,1,-13840,0,'AMT'),(1267,2,-14400,0,'-04'),(1267,3,-10800,0,'-03'),(1267,4,-10800,1,'-03'),(1267,5,-14400,0,'-04'),(1268,0,-19088,0,'LMT'),(1268,1,-19176,0,'CMT'),(1268,2,-18000,0,'EST'),(1269,0,-42398,0,'LMT'),(1269,1,-39600,0,'NST'),(1269,2,-36000,1,'NWT'),(1269,3,-36000,1,'NPT'),(1269,4,-39600,0,'BST'),(1269,5,-36000,1,'BDT'),(1269,6,-36000,0,'AHST'),(1269,7,-32400,1,'HDT'),(1269,8,-36000,0,'HST'),(1270,0,-9244,0,'LMT'),(1270,1,-7200,1,'-02'),(1270,2,-10800,0,'-03'),(1271,0,-25260,0,'LMT'),(1271,1,-25200,0,'MST'),(1271,2,-21600,0,'CST'),(1271,3,-21600,1,'MDT'),(1271,4,-25200,0,'MST'),(1271,5,-28800,0,'PST'),(1271,6,-18000,1,'CDT'),(1271,7,-21600,0,'CST'),(1272,0,-14309,0,'LMT'),(1272,1,-10800,1,'ADT'),(1272,2,-14400,0,'AST'),(1272,3,-14400,0,'AST'),(1272,4,-12600,1,'-0330'),(1272,5,-10800,1,'ADT'),(1273,0,-11636,0,'LMT'),(1273,1,-7200,1,'-02'),(1273,2,-10800,0,'-03'),(1274,0,-21168,0,'LMT'),(1274,1,-19800,1,'-0530'),(1274,2,-21600,0,'CST'),(1274,3,-18000,1,'CWT'),(1274,4,-18000,1,'CPT'),(1274,5,-18000,1,'CDT'),(1275,0,-15865,0,'LMT'),(1275,1,-14400,0,'AST'),(1275,2,-10800,1,'APT'),(1275,3,-10800,1,'AWT'),(1276,0,-14560,0,'LMT'),(1276,1,-10800,1,'-03'),(1276,2,-14400,0,'-04'),(1277,0,-17776,0,'LMT'),(1277,1,-17776,0,'BMT'),(1277,2,-14400,1,'-04'),(1277,3,-18000,0,'-05'),(1278,0,-27889,0,'LMT'),(1278,1,-25200,1,'PDT'),(1278,2,-28800,0,'PST'),(1278,3,-28800,0,'PST'),(1278,4,-21600,1,'MWT'),(1278,5,-21600,1,'MPT'),(1278,6,-25200,0,'MST'),(1278,7,-21600,1,'MDT'),(1279,0,-14028,0,'LMT'),(1279,1,-15408,0,'CMT'),(1279,2,-14400,0,'-04'),(1279,3,-10800,1,'-03'),(1279,4,-7200,1,'-02'),(1279,5,-10800,0,'-03'),(1280,0,0,0,'-00'),(1280,1,-21600,1,'MWT'),(1280,2,-21600,1,'MPT'),(1280,3,-25200,0,'MST'),(1280,4,-21600,1,'MDT'),(1280,5,-18000,1,'CDT'),(1280,6,-21600,0,'CST'),(1280,7,-18000,0,'EST'),(1280,8,-21600,1,'MDT'),(1280,9,-25200,0,'MST'),(1281,0,-13108,0,'LMT'),(1281,1,-10800,1,'-03'),(1281,2,-14400,0,'-04'),(1282,0,-20824,0,'LMT'),(1282,1,-21600,0,'CST'),(1282,2,-14400,1,'EDT'),(1282,3,-18000,0,'EST'),(1282,4,-21600,0,'CST'),(1282,5,-18000,1,'CDT'),(1282,6,-18000,0,'EST'),(1283,0,-16064,0,'LMT'),(1283,1,-16060,0,'CMT'),(1283,2,-16200,0,'-0430'),(1283,3,-14400,0,'-04'),(1284,0,-15788,0,'LMT'),(1284,1,-15408,0,'CMT'),(1284,2,-14400,0,'-04'),(1284,3,-10800,1,'-03'),(1284,4,-7200,1,'-02'),(1284,5,-10800,0,'-03'),(1285,0,-12560,0,'LMT'),(1285,1,-14400,0,'-04'),(1285,2,-10800,0,'-03'),(1286,0,-19088,0,'LMT'),(1286,1,-19176,0,'CMT'),(1286,2,-18000,0,'EST'),(1287,0,-21036,0,'LMT'),(1287,1,-18000,1,'CDT'),(1287,2,-21600,0,'CST'),(1287,3,-21600,0,'CST'),(1287,4,-18000,0,'EST'),(1287,5,-18000,1,'CWT'),(1287,6,-18000,1,'CPT'),(1287,7,-21600,0,'CST'),(1288,0,-25460,0,'LMT'),(1288,1,-25200,0,'MST'),(1288,2,-21600,0,'CST'),(1288,3,-21600,1,'MDT'),(1288,4,-25200,0,'MST'),(1288,5,-18000,1,'CDT'),(1288,6,-21600,1,'MDT'),(1288,7,-21600,0,'CST'),(1289,0,-25556,0,'LMT'),(1289,1,-25200,0,'MST'),(1289,2,-21600,0,'CST'),(1289,3,-21600,1,'MDT'),(1289,4,-25200,0,'MST'),(1289,5,-18000,1,'CDT'),(1289,6,-21600,1,'MDT'),(1290,0,-19088,0,'LMT'),(1290,1,-19176,0,'CMT'),(1290,2,-18000,0,'EST'),(1291,0,-15408,0,'LMT'),(1291,1,-15408,0,'CMT'),(1291,2,-14400,0,'-04'),(1291,3,-10800,1,'-03'),(1291,4,-7200,1,'-02'),(1291,5,-10800,0,'-03'),(1292,0,-20173,0,'LMT'),(1292,1,-20173,0,'SJMT'),(1292,2,-18000,1,'CDT'),(1292,3,-21600,0,'CST'),(1293,0,-26898,0,'LMT'),(1293,1,-21600,1,'MDT'),(1293,2,-25200,0,'MST'),(1293,3,-21600,1,'MWT'),(1293,4,-25200,0,'MST'),(1294,0,-13460,0,'LMT'),(1294,1,-10800,1,'-03'),(1294,2,-14400,0,'-04'),(1295,0,-15865,0,'LMT'),(1295,1,-14400,0,'AST'),(1295,2,-10800,1,'APT'),(1295,3,-10800,1,'AWT'),(1296,0,-4480,0,'LMT'),(1296,1,-10800,0,'-03'),(1296,2,-10800,0,'-03'),(1296,3,-7200,1,'-02'),(1296,4,-7200,1,'-02'),(1296,5,0,0,'GMT'),(1297,0,-33460,0,'LMT'),(1297,1,-28800,1,'YDT'),(1297,2,-32400,0,'YST'),(1297,3,-28800,1,'YWT'),(1297,4,-28800,1,'YPT'),(1297,5,-25200,1,'YDDT'),(1297,6,-28800,0,'PST'),(1297,7,-25200,1,'PDT'),(1297,8,-25200,0,'MST'),(1298,0,-28856,0,'LMT'),(1298,1,-25200,1,'PDT'),(1298,2,-28800,0,'PST'),(1298,3,-25200,1,'PWT'),(1298,4,-25200,1,'PPT'),(1298,5,-25200,0,'MST'),(1299,0,-25196,0,'LMT'),(1299,1,-21600,1,'MDT'),(1299,2,-25200,0,'MST'),(1299,3,-25200,0,'MST'),(1299,4,-21600,1,'MWT'),(1299,5,-21600,1,'MPT'),(1300,0,-19931,0,'LMT'),(1300,1,-21600,0,'CST'),(1300,2,-18000,0,'EST'),(1300,3,-14400,1,'EWT'),(1300,4,-14400,1,'EPT'),(1300,5,-14400,1,'EDT'),(1301,0,-15865,0,'LMT'),(1301,1,-14400,0,'AST'),(1301,2,-10800,1,'APT'),(1301,3,-10800,1,'AWT'),(1302,0,-27232,0,'LMT'),(1302,1,-21600,1,'MDT'),(1302,2,-25200,0,'MST'),(1302,3,-21600,1,'MWT'),(1302,4,-21600,1,'MPT'),(1303,0,-16768,0,'LMT'),(1303,1,-14400,1,'-04'),(1303,2,-18000,0,'-05'),(1303,3,-14400,0,'-04'),(1303,4,-18000,0,'-05'),(1304,0,-21408,0,'LMT'),(1304,1,-18000,1,'CDT'),(1304,2,-21600,0,'CST'),(1305,0,-28084,0,'LMT'),(1305,1,-25200,0,'MST'),(1305,2,-28800,0,'PST'),(1305,3,-25200,0,'MST'),(1305,4,-25200,1,'PDT'),(1305,5,-25200,1,'PWT'),(1305,6,-25200,1,'PPT'),(1305,7,-28800,0,'PST'),(1306,0,-29447,0,'LMT'),(1306,1,-25200,1,'PDT'),(1306,2,-28800,0,'PST'),(1306,3,-25200,1,'PWT'),(1306,4,-25200,1,'PPT'),(1306,5,-25200,0,'MST'),(1307,0,-20678,0,'LMT'),(1307,1,-18000,1,'CDT'),(1307,2,-21600,0,'CST'),(1307,3,-21600,0,'CST'),(1307,4,-18000,1,'CWT'),(1307,5,-18000,1,'CPT'),(1307,6,-18000,0,'EST'),(1307,7,-14400,1,'EDT'),(1308,0,-9240,0,'LMT'),(1308,1,-7200,1,'-02'),(1308,2,-10800,0,'-03'),(1309,0,-14388,0,'LMT'),(1309,1,-10800,1,'ADT'),(1309,2,-14400,0,'AST'),(1309,3,-10800,1,'AWT'),(1309,4,-10800,1,'APT'),(1310,0,-12416,0,'LMT'),(1310,1,-10800,0,'-03'),(1310,2,-10800,0,'-03'),(1310,3,-7200,1,'-02'),(1310,4,-7200,1,'-02'),(1310,5,-7200,0,'-02'),(1310,6,-3600,1,'-01'),(1311,0,-14500,0,'LMT'),(1311,1,-12652,0,'NST'),(1311,2,-9052,1,'NDT'),(1311,3,-12600,0,'NST'),(1311,4,-9000,1,'NDT'),(1311,5,-9000,1,'NPT'),(1311,6,-9000,1,'NWT'),(1311,7,-10800,1,'ADT'),(1311,8,-14400,0,'AST'),(1311,9,-7200,1,'ADDT'),(1311,10,-10800,1,'ADT'),(1312,0,-17072,0,'LMT'),(1312,1,-18430,0,'KMT'),(1312,2,-18000,0,'EST'),(1312,3,-14400,1,'EDT'),(1312,4,-14400,0,'AST'),(1312,5,-18000,0,'EST'),(1313,0,-15865,0,'LMT'),(1313,1,-14400,0,'AST'),(1313,2,-10800,1,'APT'),(1313,3,-10800,1,'AWT'),(1314,0,-15865,0,'LMT'),(1314,1,-14400,0,'AST'),(1314,2,-10800,1,'APT'),(1314,3,-10800,1,'AWT'),(1315,0,-21724,0,'LMT'),(1315,1,-18000,1,'CDT'),(1315,2,-21600,0,'CST'),(1316,0,-19160,0,'LMT'),(1316,1,-18840,0,'QMT'),(1316,2,-14400,1,'-04'),(1316,3,-18000,0,'-05'),(1317,0,-13959,0,'LMT'),(1317,1,-14400,0,'-04'),(1317,2,-13500,0,'-0345'),(1317,3,-10800,0,'-03'),(1317,4,-14400,0,'-04'),(1318,0,-15264,0,'LMT'),(1318,1,-10800,1,'ADT'),(1318,2,-14400,0,'AST'),(1318,3,-10800,1,'AWT'),(1318,4,-10800,1,'APT'),(1319,0,-19768,0,'LMT'),(1319,1,-19776,0,'HMT'),(1319,2,-14400,1,'CDT'),(1319,3,-18000,0,'CST'),(1319,4,-18000,0,'CST'),(1319,5,-14400,1,'CDT'),(1320,0,-26632,0,'LMT'),(1320,1,-25200,0,'MST'),(1320,2,-21600,0,'CST'),(1320,3,-21600,1,'MDT'),(1320,4,-25200,0,'MST'),(1320,5,-28800,0,'PST'),(1320,6,-25200,0,'MST'),(1321,0,-20678,0,'LMT'),(1321,1,-18000,1,'CDT'),(1321,2,-21600,0,'CST'),(1321,3,-21600,0,'CST'),(1321,4,-18000,1,'CWT'),(1321,5,-18000,1,'CPT'),(1321,6,-18000,0,'EST'),(1321,7,-14400,1,'EDT'),(1322,0,-20790,0,'LMT'),(1322,1,-18000,1,'CDT'),(1322,2,-21600,0,'CST'),(1322,3,-18000,1,'CWT'),(1322,4,-18000,1,'CPT'),(1322,5,-21600,0,'CST'),(1322,6,-18000,0,'EST'),(1322,7,-21600,0,'CST'),(1323,0,-20723,0,'LMT'),(1323,1,-18000,1,'CDT'),(1323,2,-21600,0,'CST'),(1323,3,-18000,1,'CWT'),(1323,4,-18000,1,'CPT'),(1323,5,-21600,0,'CST'),(1323,6,-18000,0,'EST'),(1323,7,-14400,1,'EDT'),(1324,0,-20947,0,'LMT'),(1324,1,-18000,1,'CDT'),(1324,2,-21600,0,'CST'),(1324,3,-18000,1,'CWT'),(1324,4,-18000,1,'CPT'),(1324,5,-21600,0,'CST'),(1324,6,-18000,0,'EST'),(1324,7,-14400,1,'EDT'),(1325,0,-20823,0,'LMT'),(1325,1,-18000,1,'CDT'),(1325,2,-21600,0,'CST'),(1325,3,-18000,1,'CWT'),(1325,4,-18000,1,'CPT'),(1325,5,-21600,0,'CST'),(1325,6,-18000,0,'EST'),(1325,7,-14400,1,'EDT'),(1325,8,-18000,1,'CDT'),(1325,9,-21600,0,'CST'),(1326,0,-20416,0,'LMT'),(1326,1,-18000,1,'CDT'),(1326,2,-21600,0,'CST'),(1326,3,-18000,1,'CWT'),(1326,4,-18000,1,'CPT'),(1326,5,-21600,0,'CST'),(1326,6,-18000,0,'EST'),(1326,7,-14400,1,'EDT'),(1327,0,-21007,0,'LMT'),(1327,1,-18000,1,'CDT'),(1327,2,-21600,0,'CST'),(1327,3,-18000,1,'CWT'),(1327,4,-18000,1,'CPT'),(1327,5,-21600,0,'CST'),(1327,6,-18000,0,'EST'),(1327,7,-14400,1,'EDT'),(1328,0,-20785,0,'LMT'),(1328,1,-18000,1,'CDT'),(1328,2,-21600,0,'CST'),(1328,3,-18000,1,'CWT'),(1328,4,-18000,1,'CPT'),(1328,5,-21600,0,'CST'),(1328,6,-18000,0,'EST'),(1328,7,-14400,1,'EDT'),(1329,0,-20678,0,'LMT'),(1329,1,-18000,1,'CDT'),(1329,2,-21600,0,'CST'),(1329,3,-21600,0,'CST'),(1329,4,-18000,1,'CWT'),(1329,5,-18000,1,'CPT'),(1329,6,-18000,0,'EST'),(1329,7,-14400,1,'EDT'),(1330,0,0,0,'-00'),(1330,1,-25200,1,'PDT'),(1330,2,-28800,0,'PST'),(1330,3,-25200,0,'MST'),(1330,4,-21600,1,'MDT'),(1331,0,0,0,'-00'),(1331,1,-14400,1,'EPT'),(1331,2,-18000,0,'EST'),(1331,3,-14400,1,'EDT'),(1331,4,-14400,1,'EWT'),(1331,5,-21600,0,'CST'),(1331,6,-18000,1,'CDT'),(1331,7,-14400,1,'EDT'),(1331,8,-18000,0,'EST'),(1332,0,-18430,0,'LMT'),(1332,1,-18430,0,'KMT'),(1332,2,-18000,0,'EST'),(1332,3,-14400,1,'EDT'),(1333,0,-15672,0,'LMT'),(1333,1,-15408,0,'CMT'),(1333,2,-14400,0,'-04'),(1333,3,-10800,1,'-03'),(1333,4,-7200,1,'-02'),(1333,5,-10800,0,'-03'),(1334,0,-32261,0,'LMT'),(1334,1,-28800,0,'PST'),(1334,2,-25200,1,'PWT'),(1334,3,-25200,1,'PPT'),(1334,4,-25200,1,'PDT'),(1334,5,-28800,1,'YDT'),(1334,6,-32400,0,'YST'),(1334,7,-28800,1,'AKDT'),(1334,8,-32400,0,'AKST'),(1335,0,-20582,0,'LMT'),(1335,1,-18000,1,'CDT'),(1335,2,-21600,0,'CST'),(1335,3,-21600,0,'CST'),(1335,4,-18000,1,'CWT'),(1335,5,-18000,1,'CPT'),(1335,6,-18000,0,'EST'),(1335,7,-14400,1,'EDT'),(1336,0,-20364,0,'LMT'),(1336,1,-18000,1,'CDT'),(1336,2,-21600,0,'CST'),(1336,3,-18000,1,'CWT'),(1336,4,-18000,1,'CPT'),(1336,5,-21600,0,'CST'),(1336,6,-14400,1,'EDT'),(1336,7,-18000,0,'EST'),(1337,0,-20790,0,'LMT'),(1337,1,-18000,1,'CDT'),(1337,2,-21600,0,'CST'),(1337,3,-18000,1,'CWT'),(1337,4,-18000,1,'CPT'),(1337,5,-21600,0,'CST'),(1337,6,-18000,0,'EST'),(1337,7,-21600,0,'CST'),(1338,0,-15865,0,'LMT'),(1338,1,-14400,0,'AST'),(1338,2,-10800,1,'APT'),(1338,3,-10800,1,'AWT'),(1339,0,-16356,0,'LMT'),(1339,1,-16356,0,'CMT'),(1339,2,-12756,1,'BST'),(1339,3,-14400,0,'-04'),(1340,0,-18492,0,'LMT'),(1340,1,-18516,0,'LMT'),(1340,2,-14400,1,'-04'),(1340,3,-18000,0,'-05'),(1341,0,-28378,0,'LMT'),(1341,1,-25200,1,'PDT'),(1341,2,-28800,0,'PST'),(1341,3,-25200,1,'PWT'),(1341,4,-25200,1,'PPT'),(1341,5,-28800,0,'PST'),(1342,0,-20582,0,'LMT'),(1342,1,-18000,1,'CDT'),(1342,2,-21600,0,'CST'),(1342,3,-21600,0,'CST'),(1342,4,-18000,1,'CWT'),(1342,5,-18000,1,'CPT'),(1342,6,-18000,0,'EST'),(1342,7,-14400,1,'EDT'),(1343,0,-15865,0,'LMT'),(1343,1,-14400,0,'AST'),(1343,2,-10800,1,'APT'),(1343,3,-10800,1,'AWT'),(1344,0,-8572,0,'LMT'),(1344,1,-7200,1,'-02'),(1344,2,-10800,0,'-03'),(1345,0,-20708,0,'LMT'),(1345,1,-20712,0,'MMT'),(1345,2,-21600,0,'CST'),(1345,3,-18000,0,'EST'),(1345,4,-18000,1,'CDT'),(1345,5,-21600,0,'CST'),(1346,0,-14404,0,'LMT'),(1346,1,-10800,1,'-03'),(1346,2,-14400,0,'-04'),(1347,0,-15865,0,'LMT'),(1347,1,-14400,0,'AST'),(1347,2,-10800,1,'APT'),(1347,3,-10800,1,'AWT'),(1348,0,-14660,0,'LMT'),(1348,1,-14660,0,'FFMT'),(1348,2,-14400,0,'AST'),(1348,3,-10800,1,'ADT'),(1349,0,-23400,0,'LMT'),(1349,1,-21600,0,'CST'),(1349,2,-18000,1,'CDT'),(1349,3,-21600,0,'CST'),(1350,0,-25540,0,'LMT'),(1350,1,-25200,0,'MST'),(1350,2,-21600,0,'CST'),(1350,3,-21600,1,'MDT'),(1350,4,-25200,0,'MST'),(1350,5,-28800,0,'PST'),(1350,6,-25200,0,'MST'),(1351,0,-16516,0,'LMT'),(1351,1,-15408,0,'CMT'),(1351,2,-14400,0,'-04'),(1351,3,-10800,1,'-03'),(1351,4,-7200,1,'-02'),(1351,5,-10800,0,'-03'),(1352,0,-21027,0,'LMT'),(1352,1,-18000,1,'CDT'),(1352,2,-21600,0,'CST'),(1352,3,-18000,1,'CWT'),(1352,4,-18000,1,'CPT'),(1352,5,-18000,0,'EST'),(1352,6,-21600,0,'CST'),(1353,0,-21508,0,'LMT'),(1353,1,-21600,0,'CST'),(1353,2,-18000,0,'EST'),(1353,3,-18000,1,'CDT'),(1353,4,-21600,0,'CST'),(1354,0,-31578,0,'LMT'),(1354,1,-28800,0,'PST'),(1354,2,-25200,1,'PWT'),(1354,3,-25200,1,'PPT'),(1354,4,-25200,1,'PDT'),(1354,5,-32400,0,'AKST'),(1354,6,-28800,1,'AKDT'),(1355,0,-23796,0,'LMT'),(1355,1,-25200,0,'MST'),(1355,2,-21600,0,'CST'),(1355,3,-21600,1,'MDT'),(1355,4,-25200,0,'MST'),(1355,5,-18000,1,'CDT'),(1355,6,-18000,1,'CWT'),(1355,7,-21600,0,'CST'),(1356,0,-13480,0,'LMT'),(1356,1,-14400,0,'AST'),(1356,2,-10800,0,'-03'),(1356,3,-7200,1,'-02'),(1357,0,-15548,0,'LMT'),(1357,1,-18000,0,'EST'),(1357,2,-10800,1,'ADT'),(1357,3,-14400,0,'AST'),(1357,4,-10800,1,'AWT'),(1357,5,-10800,1,'APT'),(1358,0,-24076,0,'LMT'),(1358,1,-21600,0,'CST'),(1358,2,-18000,1,'CDT'),(1358,3,-21600,0,'CST'),(1359,0,-13491,0,'LMT'),(1359,1,-13491,0,'MMT'),(1359,2,-14400,0,'-04'),(1359,3,-12600,0,'-0330'),(1359,4,-10800,1,'-03'),(1359,5,-10800,0,'-03'),(1359,6,-9000,1,'-0230'),(1359,7,-7200,1,'-02'),(1359,8,-5400,1,'-0130'),(1359,9,-7200,1,'-02'),(1360,0,-19052,0,'LMT'),(1360,1,-14400,1,'EDT'),(1360,2,-18000,0,'EST'),(1360,3,-14400,1,'EWT'),(1360,4,-14400,1,'EPT'),(1361,0,-15865,0,'LMT'),(1361,1,-14400,0,'AST'),(1361,2,-10800,1,'APT'),(1361,3,-10800,1,'AWT'),(1362,0,-19052,0,'LMT'),(1362,1,-14400,1,'EDT'),(1362,2,-18000,0,'EST'),(1362,3,-14400,1,'EWT'),(1362,4,-14400,1,'EPT'),(1363,0,-17762,0,'LMT'),(1363,1,-14400,1,'EDT'),(1363,2,-18000,0,'EST'),(1363,3,-18000,0,'EST'),(1363,4,-14400,1,'EWT'),(1363,5,-14400,1,'EPT'),(1364,0,-19052,0,'LMT'),(1364,1,-14400,1,'EDT'),(1364,2,-18000,0,'EST'),(1364,3,-14400,1,'EWT'),(1364,4,-14400,1,'EPT'),(1365,0,-39698,0,'LMT'),(1365,1,-39600,0,'NST'),(1365,2,-36000,1,'NWT'),(1365,3,-36000,1,'NPT'),(1365,4,-39600,0,'BST'),(1365,5,-36000,1,'BDT'),(1365,6,-32400,0,'YST'),(1365,7,-28800,1,'AKDT'),(1365,8,-32400,0,'AKST'),(1366,0,-7780,0,'LMT'),(1366,1,-3600,1,'-01'),(1366,2,-7200,0,'-02'),(1367,0,-24427,0,'LMT'),(1367,1,-21600,1,'MDT'),(1367,2,-25200,0,'MST'),(1367,3,-21600,1,'MWT'),(1367,4,-21600,1,'MPT'),(1367,5,-25200,0,'MST'),(1367,6,-18000,1,'CDT'),(1367,7,-21600,0,'CST'),(1368,0,-24312,0,'LMT'),(1368,1,-21600,1,'MDT'),(1368,2,-25200,0,'MST'),(1368,3,-21600,1,'MWT'),(1368,4,-21600,1,'MPT'),(1368,5,-25200,0,'MST'),(1368,6,-18000,1,'CDT'),(1368,7,-21600,0,'CST'),(1369,0,-24339,0,'LMT'),(1369,1,-21600,1,'MDT'),(1369,2,-25200,0,'MST'),(1369,3,-21600,1,'MWT'),(1369,4,-21600,1,'MPT'),(1369,5,-25200,0,'MST'),(1369,6,-18000,1,'CDT'),(1369,7,-21600,0,'CST'),(1370,0,-12416,0,'LMT'),(1370,1,-10800,0,'-03'),(1370,2,-10800,0,'-03'),(1370,3,-7200,1,'-02'),(1370,4,-7200,1,'-02'),(1370,5,-7200,0,'-02'),(1370,6,-3600,1,'-01'),(1371,0,-25060,0,'LMT'),(1371,1,-25200,0,'MST'),(1371,2,-21600,0,'CST'),(1371,3,-21600,1,'MDT'),(1371,4,-25200,0,'MST'),(1371,5,-18000,1,'CDT'),(1371,6,-21600,0,'CST'),(1372,0,-19088,0,'LMT'),(1372,1,-19176,0,'CMT'),(1372,2,-18000,0,'EST'),(1373,0,0,0,'-00'),(1373,1,-14400,1,'EPT'),(1373,2,-18000,0,'EST'),(1373,3,-14400,1,'EDT'),(1373,4,-14400,1,'EWT'),(1373,5,-21600,0,'CST'),(1373,6,-18000,1,'CDT'),(1373,7,-14400,1,'EDT'),(1373,8,-18000,0,'EST'),(1374,0,-13240,0,'LMT'),(1374,1,-13252,0,'PMT'),(1374,2,-13236,0,'PMT'),(1374,3,-12600,0,'-0330'),(1374,4,-10800,0,'-03'),(1375,0,-26898,0,'LMT'),(1375,1,-21600,1,'MDT'),(1375,2,-25200,0,'MST'),(1375,3,-21600,1,'MWT'),(1375,4,-25200,0,'MST'),(1376,0,-17360,0,'LMT'),(1376,1,-17340,0,'PPMT'),(1376,2,-14400,1,'EDT'),(1376,3,-18000,0,'EST'),(1376,4,-14400,1,'EDT'),(1376,5,-18000,0,'EST'),(1377,0,-15865,0,'LMT'),(1377,1,-14400,0,'AST'),(1377,2,-10800,1,'APT'),(1377,3,-10800,1,'AWT'),(1378,0,-16272,0,'LMT'),(1378,1,-14400,1,'-04'),(1378,2,-18000,0,'-05'),(1378,3,-14400,0,'-04'),(1378,4,-18000,0,'-05'),(1379,0,-15336,0,'LMT'),(1379,1,-10800,1,'-03'),(1379,2,-14400,0,'-04'),(1380,0,-15865,0,'LMT'),(1380,1,-14400,0,'AST'),(1380,2,-10800,1,'APT'),(1380,3,-10800,1,'AWT'),(1381,0,-17020,0,'LMT'),(1381,1,-16965,0,'SMT'),(1381,2,-18000,0,'-05'),(1381,3,-14400,0,'-04'),(1381,4,-14400,1,'-04'),(1381,5,-10800,1,'-03'),(1381,6,-14400,0,'-04'),(1381,7,-10800,0,'-03'),(1382,0,-23316,0,'LMT'),(1382,1,-18000,1,'CDT'),(1382,2,-21600,0,'CST'),(1382,3,-18000,1,'CWT'),(1382,4,-18000,1,'CPT'),(1382,5,-18000,1,'CDT'),(1382,6,-21600,0,'CST'),(1383,0,0,0,'-00'),(1383,1,-18000,1,'CDT'),(1383,2,-21600,0,'CST'),(1383,3,-18000,0,'EST'),(1383,4,-21600,0,'CST'),(1384,0,-8376,0,'LMT'),(1384,1,-7200,1,'-02'),(1384,2,-10800,0,'-03'),(1385,0,-25116,0,'LMT'),(1385,1,-21600,1,'MDT'),(1385,2,-25200,0,'MST'),(1385,3,-21600,1,'MWT'),(1385,4,-21600,1,'MPT'),(1385,5,-21600,0,'CST'),(1386,0,0,0,'-00'),(1386,1,-18000,1,'CDT'),(1386,2,-21600,0,'CST'),(1386,3,-18000,0,'EST'),(1386,4,-21600,0,'CST'),(1387,0,-16272,0,'LMT'),(1387,1,-14400,1,'-04'),(1387,2,-18000,0,'-05'),(1387,3,-14400,0,'-04'),(1387,4,-18000,0,'-05'),(1388,0,-15408,0,'LMT'),(1388,1,-15408,0,'CMT'),(1388,2,-14400,0,'-04'),(1388,3,-10800,1,'-03'),(1388,4,-7200,1,'-02'),(1388,5,-10800,0,'-03'),(1389,0,-28084,0,'LMT'),(1389,1,-25200,0,'MST'),(1389,2,-28800,0,'PST'),(1389,3,-25200,0,'MST'),(1389,4,-25200,1,'PDT'),(1389,5,-25200,1,'PWT'),(1389,6,-25200,1,'PPT'),(1389,7,-28800,0,'PST'),(1390,0,-13128,0,'LMT'),(1390,1,-10800,1,'-03'),(1390,2,-14400,0,'-04'),(1390,3,-10800,0,'-03'),(1391,0,-16965,0,'LMT'),(1391,1,-16965,0,'SMT'),(1391,2,-18000,0,'-05'),(1391,3,-14400,0,'-04'),(1391,4,-14400,1,'-04'),(1391,5,-10800,1,'-03'),(1391,6,-10800,1,'-03'),(1391,7,-14400,0,'-04'),(1392,0,-16776,0,'LMT'),(1392,1,-16800,0,'SDMT'),(1392,2,-14400,1,'EDT'),(1392,3,-18000,0,'EST'),(1392,4,-16200,1,'-0430'),(1392,5,-14400,0,'AST'),(1393,0,-11188,0,'LMT'),(1393,1,-7200,1,'-02'),(1393,2,-10800,0,'-03'),(1394,0,-5272,0,'LMT'),(1394,1,-7200,0,'-02'),(1394,2,-3600,1,'-01'),(1394,3,-7200,0,'-02'),(1394,4,-3600,0,'-01'),(1394,5,0,1,'+00'),(1394,6,0,1,'+00'),(1395,0,-25196,0,'LMT'),(1395,1,-21600,1,'MDT'),(1395,2,-25200,0,'MST'),(1395,3,-25200,0,'MST'),(1395,4,-21600,1,'MWT'),(1395,5,-21600,1,'MPT'),(1396,0,-32473,0,'LMT'),(1396,1,-28800,0,'PST'),(1396,2,-25200,1,'PWT'),(1396,3,-25200,1,'PPT'),(1396,4,-25200,1,'PDT'),(1396,5,-32400,0,'YST'),(1396,6,-28800,1,'AKDT'),(1396,7,-32400,0,'AKST'),(1397,0,-15865,0,'LMT'),(1397,1,-14400,0,'AST'),(1397,2,-10800,1,'APT'),(1397,3,-10800,1,'AWT'),(1398,0,-12652,0,'LMT'),(1398,1,-9052,1,'NDT'),(1398,2,-12652,0,'NST'),(1398,3,-9000,1,'NDT'),(1398,4,-12600,0,'NST'),(1398,5,-9000,1,'NPT'),(1398,6,-9000,1,'NWT'),(1398,7,-5400,1,'NDDT'),(1398,8,-9000,1,'NDT'),(1399,0,-15865,0,'LMT'),(1399,1,-14400,0,'AST'),(1399,2,-10800,1,'APT'),(1399,3,-10800,1,'AWT'),(1400,0,-15865,0,'LMT'),(1400,1,-14400,0,'AST'),(1400,2,-10800,1,'APT'),(1400,3,-10800,1,'AWT'),(1401,0,-15865,0,'LMT'),(1401,1,-14400,0,'AST'),(1401,2,-10800,1,'APT'),(1401,3,-10800,1,'AWT'),(1402,0,-15865,0,'LMT'),(1402,1,-14400,0,'AST'),(1402,2,-10800,1,'APT'),(1402,3,-10800,1,'AWT'),(1403,0,-25880,0,'LMT'),(1403,1,-21600,1,'MDT'),(1403,2,-25200,0,'MST'),(1403,3,-21600,1,'MWT'),(1403,4,-21600,1,'MPT'),(1403,5,-21600,0,'CST'),(1404,0,-20932,0,'LMT'),(1404,1,-18000,1,'CDT'),(1404,2,-21600,0,'CST'),(1405,0,-16508,0,'LMT'),(1405,1,-10800,1,'ADT'),(1405,2,-14400,0,'AST'),(1406,0,-19052,0,'LMT'),(1406,1,-14400,1,'EDT'),(1406,2,-18000,0,'EST'),(1406,3,-14400,1,'EWT'),(1406,4,-14400,1,'EPT'),(1407,0,-28084,0,'LMT'),(1407,1,-25200,0,'MST'),(1407,2,-28800,0,'PST'),(1407,3,-25200,0,'MST'),(1407,4,-25200,1,'PDT'),(1407,5,-25200,1,'PWT'),(1407,6,-25200,1,'PPT'),(1407,7,-28800,0,'PST'),(1408,0,-19052,0,'LMT'),(1408,1,-14400,1,'EDT'),(1408,2,-18000,0,'EST'),(1408,3,-14400,1,'EWT'),(1408,4,-14400,1,'EPT'),(1409,0,-15865,0,'LMT'),(1409,1,-14400,0,'AST'),(1409,2,-10800,1,'APT'),(1409,3,-10800,1,'AWT'),(1410,0,-29548,0,'LMT'),(1410,1,-25200,1,'PDT'),(1410,2,-28800,0,'PST'),(1410,3,-25200,1,'PWT'),(1410,4,-25200,1,'PPT'),(1411,0,-15865,0,'LMT'),(1411,1,-14400,0,'AST'),(1411,2,-10800,1,'APT'),(1411,3,-10800,1,'AWT'),(1412,0,-32412,0,'LMT'),(1412,1,-28800,1,'YDT'),(1412,2,-32400,0,'YST'),(1412,3,-28800,1,'YWT'),(1412,4,-28800,1,'YPT'),(1412,5,-25200,1,'YDDT'),(1412,6,-28800,0,'PST'),(1412,7,-25200,1,'PDT'),(1412,8,-25200,0,'MST'),(1413,0,-23316,0,'LMT'),(1413,1,-18000,1,'CDT'),(1413,2,-21600,0,'CST'),(1413,3,-18000,1,'CWT'),(1413,4,-18000,1,'CPT'),(1413,5,-18000,1,'CDT'),(1413,6,-21600,0,'CST'),(1414,0,-33535,0,'LMT'),(1414,1,-32400,0,'YST'),(1414,2,-28800,1,'YWT'),(1414,3,-28800,1,'YPT'),(1414,4,-28800,1,'YDT'),(1414,5,-28800,1,'AKDT'),(1414,6,-32400,0,'AKST'),(1415,0,-27232,0,'LMT'),(1415,1,-21600,1,'MDT'),(1415,2,-25200,0,'MST'),(1415,3,-21600,1,'MWT'),(1415,4,-21600,1,'MPT'),(1416,0,0,0,'-00'),(1416,1,28800,0,'+08'),(1416,2,39600,0,'+11'),(1416,3,28800,0,'+08'),(1416,4,39600,0,'+11'),(1417,0,0,0,'-00'),(1417,1,25200,0,'+07'),(1417,2,18000,0,'+05'),(1417,3,25200,0,'+07'),(1418,0,36000,0,'+10'),(1419,0,0,0,'-00'),(1419,1,36000,0,'AEST'),(1419,2,39600,1,'AEDT'),(1419,3,36000,0,'AEST'),(1419,4,0,0,'-00'),(1419,5,39600,1,'AEDT'),(1419,6,36000,0,'AEST'),(1420,0,0,0,'-00'),(1420,1,21600,0,'+06'),(1420,2,18000,0,'+05'),(1421,0,41944,0,'LMT'),(1421,1,45000,1,'NZST'),(1421,2,41400,0,'NZMT'),(1421,3,43200,1,'NZST'),(1421,4,46800,1,'NZDT'),(1421,5,43200,0,'NZST'),(1421,6,43200,0,'NZST'),(1422,0,0,0,'-00'),(1422,1,-14400,0,'-04'),(1422,2,-10800,1,'-03'),(1422,3,-7200,1,'-02'),(1422,4,-10800,0,'-03'),(1422,5,-10800,1,'-03'),(1422,6,-14400,0,'-04'),(1422,7,-10800,0,'-03'),(1423,0,0,0,'-00'),(1423,1,-10800,0,'-03'),(1424,0,41944,0,'LMT'),(1424,1,45000,1,'NZST'),(1424,2,41400,0,'NZMT'),(1424,3,43200,1,'NZST'),(1424,4,46800,1,'NZDT'),(1424,5,43200,0,'NZST'),(1424,6,43200,0,'NZST'),(1425,0,11212,0,'LMT'),(1425,1,10800,0,'+03'),(1426,0,0,0,'-00'),(1426,1,7200,1,'+02'),(1426,2,0,0,'+00'),(1426,3,0,0,'+00'),(1427,0,21020,0,'LMT'),(1427,1,21600,0,'+06'),(1428,0,3208,0,'LMT'),(1428,1,7200,1,'CEST'),(1428,2,3600,0,'CET'),(1428,3,7200,1,'CEST'),(1428,4,3600,0,'CET'),(1428,5,10800,1,'CEMT'),(1428,6,10800,1,'CEMT'),(1428,7,7200,1,'CEST'),(1428,8,3600,0,'CET'),(1429,0,11212,0,'LMT'),(1429,1,10800,0,'+03'),(1430,0,18468,0,'LMT'),(1430,1,18000,0,'+05'),(1430,2,25200,1,'+07'),(1430,3,21600,0,'+06'),(1430,4,21600,0,'+06'),(1430,5,25200,1,'+07'),(1430,6,21600,1,'+06'),(1430,7,18000,0,'+05'),(1430,8,25200,1,'+07'),(1430,9,21600,0,'+06'),(1431,0,8624,0,'LMT'),(1431,1,10800,1,'EEST'),(1431,2,7200,0,'EET'),(1431,3,7200,0,'EET'),(1431,4,10800,1,'EEST'),(1431,5,10800,0,'+03'),(1432,0,42596,0,'LMT'),(1432,1,43200,0,'+12'),(1432,2,50400,1,'+14'),(1432,3,46800,0,'+13'),(1432,4,46800,1,'+13'),(1432,5,43200,0,'+12'),(1432,6,46800,1,'+13'),(1432,7,43200,1,'+12'),(1432,8,39600,0,'+11'),(1432,9,43200,0,'+12'),(1433,0,12064,0,'LMT'),(1433,1,14400,0,'+04'),(1433,2,18000,0,'+05'),(1433,3,21600,0,'+06'),(1433,4,21600,1,'+06'),(1433,5,18000,0,'+05'),(1433,6,21600,1,'+06'),(1433,7,18000,1,'+05'),(1433,8,14400,0,'+04'),(1433,9,18000,0,'+05'),(1434,0,13720,0,'LMT'),(1434,1,14400,0,'+04'),(1434,2,18000,0,'+05'),(1434,3,21600,1,'+06'),(1434,4,21600,0,'+06'),(1434,5,18000,0,'+05'),(1434,6,21600,1,'+06'),(1434,7,18000,1,'+05'),(1434,8,14400,0,'+04'),(1434,9,21600,1,'+06'),(1434,10,18000,0,'+05'),(1435,0,14012,0,'LMT'),(1435,1,14400,0,'+04'),(1435,2,21600,1,'+06'),(1435,3,18000,0,'+05'),(1435,4,18000,0,'+05'),(1435,5,21600,1,'+06'),(1435,6,18000,1,'+05'),(1435,7,14400,0,'+04'),(1435,8,18000,0,'+05'),(1436,0,14012,0,'LMT'),(1436,1,14400,0,'+04'),(1436,2,21600,1,'+06'),(1436,3,18000,0,'+05'),(1436,4,18000,0,'+05'),(1436,5,21600,1,'+06'),(1436,6,18000,1,'+05'),(1436,7,14400,0,'+04'),(1436,8,18000,0,'+05'),(1437,0,12464,0,'LMT'),(1437,1,10800,0,'+03'),(1437,2,18000,0,'+05'),(1437,3,21600,0,'+06'),(1437,4,21600,1,'+06'),(1437,5,18000,0,'+05'),(1437,6,21600,1,'+06'),(1437,7,18000,1,'+05'),(1437,8,14400,0,'+04'),(1437,9,18000,0,'+05'),(1438,0,10660,0,'LMT'),(1438,1,10656,0,'BMT'),(1438,2,10800,0,'+03'),(1438,3,14400,1,'+04'),(1438,4,10800,0,'+03'),(1438,5,14400,1,'+04'),(1439,0,12368,0,'LMT'),(1439,1,14400,0,'+04'),(1439,2,10800,0,'+03'),(1440,0,11964,0,'LMT'),(1440,1,10800,0,'+03'),(1440,2,18000,1,'+05'),(1440,3,14400,0,'+04'),(1440,4,14400,0,'+04'),(1440,5,18000,1,'+05'),(1440,6,14400,1,'+04'),(1440,7,10800,0,'+03'),(1440,8,18000,1,'+05'),(1440,9,14400,0,'+04'),(1441,0,24124,0,'LMT'),(1441,1,24124,0,'BMT'),(1441,2,25200,0,'+07'),(1442,0,20100,0,'LMT'),(1442,1,21600,0,'+06'),(1442,2,28800,1,'+08'),(1442,3,25200,0,'+07'),(1442,4,25200,0,'+07'),(1442,5,28800,1,'+08'),(1442,6,25200,1,'+07'),(1442,7,21600,0,'+06'),(1442,8,25200,1,'+07'),(1442,9,25200,0,'+07'),(1443,0,8520,0,'LMT'),(1443,1,10800,1,'EEST'),(1443,2,7200,0,'EET'),(1444,0,17904,0,'LMT'),(1444,1,18000,0,'+05'),(1444,2,25200,1,'+07'),(1444,3,21600,0,'+06'),(1444,4,21600,0,'+06'),(1444,5,25200,1,'+07'),(1444,6,21600,1,'+06'),(1444,7,21600,1,'+06'),(1445,0,26480,0,'LMT'),(1445,1,27000,0,'+0730'),(1445,2,30000,1,'+0820'),(1445,3,28800,0,'+08'),(1445,4,32400,0,'+09'),(1445,5,28800,0,'+08'),(1446,0,21200,0,'HMT'),(1446,1,19270,0,'MMT'),(1446,2,19800,0,'IST'),(1446,3,23400,1,'+0630'),(1447,0,27232,0,'LMT'),(1447,1,28800,0,'+08'),(1447,2,36000,1,'+10'),(1447,3,32400,0,'+09'),(1447,4,32400,0,'+09'),(1447,5,36000,1,'+10'),(1447,6,32400,1,'+09'),(1447,7,28800,0,'+08'),(1447,8,36000,0,'+10'),(1447,9,36000,1,'+10'),(1447,10,32400,0,'+09'),(1448,0,27480,0,'LMT'),(1448,1,25200,0,'+07'),(1448,2,28800,0,'+08'),(1448,3,32400,0,'+09'),(1448,4,36000,1,'+10'),(1448,5,32400,1,'+09'),(1448,6,28800,0,'+08'),(1449,0,29143,0,'LMT'),(1449,1,32400,1,'CDT'),(1449,2,28800,0,'CST'),(1450,0,29143,0,'LMT'),(1450,1,32400,1,'CDT'),(1450,2,28800,0,'CST'),(1451,0,19164,0,'LMT'),(1451,1,19172,0,'MMT'),(1451,2,19800,0,'+0530'),(1451,3,21600,1,'+06'),(1451,4,23400,1,'+0630'),(1451,5,23400,0,'+0630'),(1451,6,21600,0,'+06'),(1451,7,19800,0,'+0530'),(1452,0,21700,0,'LMT'),(1452,1,21200,0,'HMT'),(1452,2,23400,0,'+0630'),(1452,3,19800,0,'+0530'),(1452,4,21600,0,'+06'),(1452,5,25200,1,'+07'),(1453,0,8712,0,'LMT'),(1453,1,10800,1,'EEST'),(1453,2,7200,0,'EET'),(1453,3,10800,0,'+03'),(1454,0,21700,0,'LMT'),(1454,1,21200,0,'HMT'),(1454,2,23400,0,'+0630'),(1454,3,19800,0,'+0530'),(1454,4,21600,0,'+06'),(1454,5,25200,1,'+07'),(1455,0,30140,0,'LMT'),(1455,1,28800,0,'+08'),(1455,2,32400,0,'+09'),(1456,0,13272,0,'LMT'),(1456,1,14400,0,'+04'),(1457,0,16512,0,'LMT'),(1457,1,18000,0,'+05'),(1457,2,25200,1,'+07'),(1457,3,21600,0,'+06'),(1457,4,21600,0,'+06'),(1457,5,25200,1,'+07'),(1457,6,21600,1,'+06'),(1457,7,18000,0,'+05'),(1458,0,8148,0,'LMT'),(1458,1,10800,1,'EEST'),(1458,2,7200,0,'EET'),(1458,3,7200,0,'EET'),(1458,4,10800,1,'EEST'),(1458,5,10800,0,'+03'),(1458,6,7200,0,'EET'),(1459,0,8272,0,'LMT'),(1459,1,10800,1,'EEST'),(1459,2,7200,0,'EET'),(1459,3,7200,0,'EET'),(1459,4,10800,1,'EEST'),(1459,5,10800,1,'IDT'),(1459,6,7200,0,'IST'),(1459,7,10800,1,'IDT'),(1459,8,7200,0,'IST'),(1459,9,7200,0,'EET'),(1460,0,29143,0,'LMT'),(1460,1,32400,1,'CDT'),(1460,2,28800,0,'CST'),(1461,0,8423,0,'LMT'),(1461,1,10800,1,'EEST'),(1461,2,7200,0,'EET'),(1461,3,7200,0,'EET'),(1461,4,10800,1,'EEST'),(1461,5,10800,1,'IDT'),(1461,6,7200,0,'IST'),(1461,7,10800,1,'IDT'),(1461,8,7200,0,'IST'),(1461,9,7200,0,'EET'),(1462,0,25590,0,'LMT'),(1462,1,25590,0,'PLMT'),(1462,2,25200,0,'+07'),(1462,3,28800,0,'+08'),(1462,4,32400,0,'+09'),(1462,5,25200,0,'+07'),(1463,0,27402,0,'LMT'),(1463,1,28800,0,'HKT'),(1463,2,32400,1,'HKST'),(1463,3,30600,1,'HKWT'),(1463,4,32400,0,'JST'),(1463,5,28800,0,'HKT'),(1463,6,32400,1,'HKST'),(1463,7,28800,0,'HKT'),(1464,0,21996,0,'LMT'),(1464,1,21600,0,'+06'),(1464,2,28800,1,'+08'),(1464,3,25200,0,'+07'),(1465,0,25025,0,'LMT'),(1465,1,25025,0,'IMT'),(1465,2,25200,0,'+07'),(1465,3,32400,1,'+09'),(1465,4,28800,0,'+08'),(1465,5,28800,0,'+08'),(1465,6,32400,1,'+09'),(1465,7,28800,1,'+08'),(1465,8,25200,0,'+07'),(1465,9,32400,0,'+09'),(1465,10,32400,1,'+09'),(1465,11,28800,0,'+08'),(1466,0,6952,0,'LMT'),(1466,1,7016,0,'IMT'),(1466,2,10800,1,'EEST'),(1466,3,7200,0,'EET'),(1466,4,10800,0,'+03'),(1466,5,14400,1,'+04'),(1466,6,10800,1,'EEST'),(1466,7,7200,0,'EET'),(1466,8,10800,1,'EEST'),(1466,9,7200,0,'EET'),(1466,10,10800,0,'+03'),(1467,0,25632,0,'LMT'),(1467,1,25632,0,'BMT'),(1467,2,26400,0,'+0720'),(1467,3,27000,0,'+0730'),(1467,4,32400,0,'+09'),(1467,5,28800,0,'+08'),(1467,6,25200,0,'WIB'),(1468,0,33768,0,'LMT'),(1468,1,32400,0,'+09'),(1468,2,34200,0,'+0930'),(1468,3,32400,0,'WIT'),(1469,0,8454,0,'LMT'),(1469,1,8440,0,'JMT'),(1469,2,10800,1,'IDT'),(1469,3,7200,0,'IST'),(1469,4,14400,1,'IDDT'),(1469,5,10800,1,'IDT'),(1469,6,7200,0,'IST'),(1469,7,10800,1,'IDT'),(1469,8,7200,0,'IST'),(1470,0,16608,0,'LMT'),(1470,1,14400,0,'+04'),(1470,2,16200,0,'+0430'),(1471,0,38076,0,'LMT'),(1471,1,39600,0,'+11'),(1471,2,46800,1,'+13'),(1471,3,43200,0,'+12'),(1471,4,43200,0,'+12'),(1471,5,46800,1,'+13'),(1471,6,43200,1,'+12'),(1471,7,39600,0,'+11'),(1471,8,43200,0,'+12'),(1472,0,16092,0,'LMT'),(1472,1,19800,0,'+0530'),(1472,2,23400,1,'+0630'),(1472,3,18000,0,'+05'),(1472,4,21600,1,'PKST'),(1472,5,18000,0,'PKT'),(1473,0,21020,0,'LMT'),(1473,1,21600,0,'+06'),(1474,0,20476,0,'LMT'),(1474,1,19800,0,'+0530'),(1474,2,20700,0,'+0545'),(1475,0,20476,0,'LMT'),(1475,1,19800,0,'+0530'),(1475,2,20700,0,'+0545'),(1476,0,32533,0,'LMT'),(1476,1,28800,0,'+08'),(1476,2,36000,1,'+10'),(1476,3,32400,0,'+09'),(1476,4,32400,0,'+09'),(1476,5,36000,1,'+10'),(1476,6,32400,1,'+09'),(1476,7,28800,0,'+08'),(1476,8,39600,1,'+11'),(1476,9,36000,0,'+10'),(1476,10,36000,0,'+10'),(1476,11,39600,0,'+11'),(1476,12,32400,0,'+09'),(1477,0,21200,0,'HMT'),(1477,1,19270,0,'MMT'),(1477,2,19800,0,'IST'),(1477,3,23400,1,'+0630'),(1478,0,22286,0,'LMT'),(1478,1,21600,0,'+06'),(1478,2,28800,1,'+08'),(1478,3,25200,0,'+07'),(1478,4,25200,0,'+07'),(1478,5,28800,1,'+08'),(1478,6,25200,1,'+07'),(1478,7,21600,0,'+06'),(1478,8,28800,0,'+08'),(1478,9,28800,1,'+08'),(1478,10,25200,0,'+07'),(1479,0,24925,0,'LMT'),(1479,1,24925,0,'SMT'),(1479,2,25200,0,'+07'),(1479,3,26400,1,'+0720'),(1479,4,26400,0,'+0720'),(1479,5,27000,0,'+0730'),(1479,6,32400,0,'+09'),(1479,7,28800,0,'+08'),(1480,0,26480,0,'LMT'),(1480,1,27000,0,'+0730'),(1480,2,30000,1,'+0820'),(1480,3,28800,0,'+08'),(1480,4,32400,0,'+09'),(1480,5,28800,0,'+08'),(1481,0,11212,0,'LMT'),(1481,1,10800,0,'+03'),(1482,0,27250,0,'LMT'),(1482,1,28800,0,'CST'),(1482,2,36000,1,'+10'),(1482,3,32400,0,'+09'),(1482,4,32400,1,'CDT'),(1482,5,28800,0,'CST'),(1482,6,32400,1,'CDT'),(1483,0,27250,0,'LMT'),(1483,1,28800,0,'CST'),(1483,2,36000,1,'+10'),(1483,3,32400,0,'+09'),(1483,4,32400,1,'CDT'),(1483,5,28800,0,'CST'),(1483,6,32400,1,'CDT'),(1484,0,36192,0,'LMT'),(1484,1,36000,0,'+10'),(1484,2,43200,1,'+12'),(1484,3,39600,0,'+11'),(1484,4,39600,0,'+11'),(1484,5,43200,1,'+12'),(1484,6,39600,1,'+11'),(1484,7,36000,0,'+10'),(1484,8,43200,0,'+12'),(1484,9,43200,1,'+12'),(1484,10,39600,0,'+11'),(1485,0,28656,0,'LMT'),(1485,1,28656,0,'MMT'),(1485,2,28800,0,'+08'),(1485,3,32400,0,'+09'),(1485,4,28800,0,'WITA'),(1486,0,29040,0,'LMT'),(1486,1,32400,1,'PDT'),(1486,2,28800,0,'PST'),(1486,3,32400,0,'JST'),(1486,4,28800,0,'PST'),(1487,0,13272,0,'LMT'),(1487,1,14400,0,'+04'),(1488,0,8008,0,'LMT'),(1488,1,10800,1,'EEST'),(1488,2,7200,0,'EET'),(1488,3,7200,0,'EET'),(1488,4,10800,1,'EEST'),(1489,0,20928,0,'LMT'),(1489,1,21600,0,'+06'),(1489,2,28800,1,'+08'),(1489,3,25200,0,'+07'),(1489,4,25200,0,'+07'),(1489,5,28800,1,'+08'),(1489,6,25200,1,'+07'),(1489,7,21600,0,'+06'),(1489,8,25200,0,'+07'),(1490,0,19900,0,'LMT'),(1490,1,21600,0,'+06'),(1490,2,28800,1,'+08'),(1490,3,25200,0,'+07'),(1490,4,25200,0,'+07'),(1490,5,28800,1,'+08'),(1490,6,25200,1,'+07'),(1490,7,21600,0,'+06'),(1490,8,25200,1,'+07'),(1490,9,25200,0,'+07'),(1491,0,17610,0,'LMT'),(1491,1,18000,0,'+05'),(1491,2,25200,1,'+07'),(1491,3,21600,0,'+06'),(1491,4,21600,0,'+06'),(1491,5,25200,1,'+07'),(1491,6,21600,1,'+06'),(1491,7,18000,0,'+05'),(1491,8,25200,0,'+07'),(1491,9,25200,1,'+07'),(1491,10,21600,0,'+06'),(1492,0,12324,0,'LMT'),(1492,1,10800,0,'+03'),(1492,2,18000,0,'+05'),(1492,3,21600,1,'+06'),(1492,4,21600,0,'+06'),(1492,5,18000,0,'+05'),(1492,6,21600,1,'+06'),(1492,7,18000,1,'+05'),(1492,8,14400,0,'+04'),(1492,9,18000,0,'+05'),(1493,0,24124,0,'LMT'),(1493,1,24124,0,'BMT'),(1493,2,25200,0,'+07'),(1494,0,26240,0,'LMT'),(1494,1,26240,0,'PMT'),(1494,2,27000,0,'+0730'),(1494,3,32400,0,'+09'),(1494,4,28800,0,'+08'),(1494,5,28800,0,'WITA'),(1494,6,25200,0,'WIB'),(1495,0,30180,0,'LMT'),(1495,1,30600,0,'KST'),(1495,2,32400,0,'JST'),(1495,3,32400,0,'KST'),(1496,0,12368,0,'LMT'),(1496,1,14400,0,'+04'),(1496,2,10800,0,'+03'),(1497,0,15268,0,'LMT'),(1497,1,14400,0,'+04'),(1497,2,18000,0,'+05'),(1497,3,21600,1,'+06'),(1497,4,21600,0,'+06'),(1497,5,18000,0,'+05'),(1497,6,21600,1,'+06'),(1497,7,18000,1,'+05'),(1497,8,14400,0,'+04'),(1497,9,21600,0,'+06'),(1497,10,21600,1,'+06'),(1498,0,15712,0,'LMT'),(1498,1,14400,0,'+04'),(1498,2,18000,0,'+05'),(1498,3,21600,1,'+06'),(1498,4,21600,0,'+06'),(1498,5,18000,0,'+05'),(1498,6,21600,1,'+06'),(1498,7,18000,1,'+05'),(1498,8,21600,0,'+06'),(1498,9,21600,1,'+06'),(1498,10,18000,0,'+05'),(1499,0,23087,0,'LMT'),(1499,1,23087,0,'RMT'),(1499,2,23400,0,'+0630'),(1499,3,32400,0,'+09'),(1499,4,23400,0,'+0630'),(1500,0,11212,0,'LMT'),(1500,1,10800,0,'+03'),(1501,0,25590,0,'LMT'),(1501,1,25590,0,'PLMT'),(1501,2,25200,0,'+07'),(1501,3,28800,0,'+08'),(1501,4,32400,0,'+09'),(1501,5,25200,0,'+07'),(1502,0,34248,0,'LMT'),(1502,1,32400,0,'+09'),(1502,2,43200,1,'+12'),(1502,3,39600,0,'+11'),(1502,4,39600,0,'+11'),(1502,5,43200,1,'+12'),(1502,6,39600,1,'+11'),(1502,7,36000,0,'+10'),(1502,8,39600,0,'+11'),(1503,0,16073,0,'LMT'),(1503,1,14400,0,'+04'),(1503,2,18000,0,'+05'),(1503,3,21600,1,'+06'),(1503,4,21600,0,'+06'),(1503,5,18000,0,'+05'),(1503,6,21600,1,'+06'),(1504,0,30472,0,'LMT'),(1504,1,30600,0,'KST'),(1504,2,32400,0,'JST'),(1504,3,36000,1,'KDT'),(1504,4,32400,0,'KST'),(1504,5,34200,1,'KDT'),(1504,6,36000,1,'KDT'),(1505,0,29143,0,'LMT'),(1505,1,32400,1,'CDT'),(1505,2,28800,0,'CST'),(1506,0,24925,0,'LMT'),(1506,1,24925,0,'SMT'),(1506,2,25200,0,'+07'),(1506,3,26400,1,'+0720'),(1506,4,26400,0,'+0720'),(1506,5,27000,0,'+0730'),(1506,6,32400,0,'+09'),(1506,7,28800,0,'+08'),(1507,0,36892,0,'LMT'),(1507,1,36000,0,'+10'),(1507,2,43200,1,'+12'),(1507,3,39600,0,'+11'),(1507,4,39600,0,'+11'),(1507,5,43200,1,'+12'),(1507,6,39600,1,'+11'),(1507,7,36000,0,'+10'),(1507,8,43200,0,'+12'),(1507,9,43200,1,'+12'),(1507,10,39600,0,'+11'),(1508,0,29160,0,'LMT'),(1508,1,28800,0,'CST'),(1508,2,32400,0,'JST'),(1508,3,32400,1,'CDT'),(1508,4,28800,0,'CST'),(1509,0,16631,0,'LMT'),(1509,1,18000,0,'+05'),(1509,2,25200,1,'+07'),(1509,3,21600,0,'+06'),(1509,4,21600,0,'+06'),(1509,5,25200,1,'+07'),(1509,6,21600,1,'+06'),(1509,7,18000,0,'+05'),(1510,0,10751,0,'LMT'),(1510,1,10751,0,'TBMT'),(1510,2,10800,0,'+03'),(1510,3,18000,1,'+05'),(1510,4,14400,0,'+04'),(1510,5,14400,0,'+04'),(1510,6,18000,1,'+05'),(1510,7,14400,1,'+04'),(1510,8,10800,0,'+03'),(1510,9,14400,1,'+04'),(1510,10,14400,0,'+04'),(1511,0,12344,0,'LMT'),(1511,1,12344,0,'TMT'),(1511,2,16200,1,'+0430'),(1511,3,12600,0,'+0330'),(1511,4,18000,1,'+05'),(1511,5,14400,0,'+04'),(1511,6,16200,1,'+0430'),(1511,7,12600,0,'+0330'),(1512,0,8454,0,'LMT'),(1512,1,8440,0,'JMT'),(1512,2,10800,1,'IDT'),(1512,3,7200,0,'IST'),(1512,4,14400,1,'IDDT'),(1512,5,10800,1,'IDT'),(1512,6,7200,0,'IST'),(1512,7,10800,1,'IDT'),(1512,8,7200,0,'IST'),(1513,0,21516,0,'LMT'),(1513,1,19800,0,'+0530'),(1513,2,21600,0,'+06'),(1514,0,21516,0,'LMT'),(1514,1,19800,0,'+0530'),(1514,2,21600,0,'+06'),(1515,0,33539,0,'LMT'),(1515,1,36000,1,'JDT'),(1515,2,32400,0,'JST'),(1515,3,32400,0,'JST'),(1516,0,20391,0,'LMT'),(1516,1,21600,0,'+06'),(1516,2,28800,1,'+08'),(1516,3,25200,0,'+07'),(1516,4,25200,0,'+07'),(1516,5,28800,1,'+08'),(1516,6,25200,1,'+07'),(1516,7,21600,0,'+06'),(1516,8,25200,1,'+07'),(1516,9,25200,0,'+07'),(1517,0,28656,0,'LMT'),(1517,1,28656,0,'MMT'),(1517,2,28800,0,'+08'),(1517,3,32400,0,'+09'),(1517,4,28800,0,'WITA'),(1518,0,25652,0,'LMT'),(1518,1,25200,0,'+07'),(1518,2,32400,1,'+09'),(1518,3,28800,0,'+08'),(1519,0,25652,0,'LMT'),(1519,1,25200,0,'+07'),(1519,2,32400,1,'+09'),(1519,3,28800,0,'+08'),(1520,0,21020,0,'LMT'),(1520,1,21600,0,'+06'),(1521,0,34374,0,'LMT'),(1521,1,28800,0,'+08'),(1521,2,32400,0,'+09'),(1521,3,39600,0,'+11'),(1521,4,43200,1,'+12'),(1521,5,39600,0,'+11'),(1521,6,43200,1,'+12'),(1521,7,39600,1,'+11'),(1521,8,36000,0,'+10'),(1521,9,43200,0,'+12'),(1521,10,43200,1,'+12'),(1521,11,36000,0,'+10'),(1522,0,24124,0,'LMT'),(1522,1,24124,0,'BMT'),(1522,2,25200,0,'+07'),(1523,0,31651,0,'LMT'),(1523,1,32400,0,'+09'),(1523,2,39600,1,'+11'),(1523,3,36000,0,'+10'),(1523,4,36000,0,'+10'),(1523,5,39600,1,'+11'),(1523,6,36000,1,'+10'),(1523,7,32400,0,'+09'),(1523,8,39600,0,'+11'),(1523,9,39600,1,'+11'),(1523,10,36000,0,'+10'),(1524,0,31138,0,'LMT'),(1524,1,28800,0,'+08'),(1524,2,36000,1,'+10'),(1524,3,32400,0,'+09'),(1524,4,32400,0,'+09'),(1524,5,36000,1,'+10'),(1524,6,32400,1,'+09'),(1524,7,28800,0,'+08'),(1524,8,36000,0,'+10'),(1524,9,36000,1,'+10'),(1524,10,32400,0,'+09'),(1525,0,23087,0,'LMT'),(1525,1,23087,0,'RMT'),(1525,2,23400,0,'+0630'),(1525,3,32400,0,'+09'),(1525,4,23400,0,'+0630'),(1526,0,14553,0,'LMT'),(1526,1,13505,0,'PMT'),(1526,2,14400,0,'+04'),(1526,3,21600,1,'+06'),(1526,4,18000,0,'+05'),(1526,5,18000,0,'+05'),(1526,6,21600,1,'+06'),(1526,7,18000,1,'+05'),(1526,8,14400,0,'+04'),(1526,9,21600,0,'+06'),(1526,10,21600,1,'+06'),(1526,11,18000,0,'+05'),(1527,0,10680,0,'LMT'),(1527,1,10800,0,'+03'),(1527,2,18000,1,'+05'),(1527,3,14400,0,'+04'),(1527,4,14400,0,'+04'),(1527,5,18000,1,'+05'),(1527,6,14400,1,'+04'),(1527,7,10800,0,'+03'),(1527,8,18000,1,'+05'),(1527,9,14400,0,'+04'),(1528,0,-6160,0,'LMT'),(1528,1,-6872,0,'HMT'),(1528,2,-3600,1,'-01'),(1528,3,-7200,0,'-02'),(1528,4,-3600,1,'-01'),(1528,5,-7200,0,'-02'),(1528,6,-7200,0,'-02'),(1528,7,0,1,'+00'),(1528,8,-3600,0,'-01'),(1528,9,-3600,0,'-01'),(1528,10,0,0,'WET'),(1528,11,0,1,'+00'),(1528,12,-3600,0,'-01'),(1529,0,-15558,0,'LMT'),(1529,1,-11958,1,'BST'),(1529,2,-15558,0,'BMT'),(1529,3,-10800,1,'ADT'),(1529,4,-14400,0,'AST'),(1530,0,-3696,0,'LMT'),(1530,1,-3600,0,'-01'),(1530,2,0,0,'WET'),(1530,3,3600,1,'WEST'),(1530,4,0,0,'WET'),(1530,5,3600,1,'WEST'),(1531,0,-5644,0,'LMT'),(1531,1,-7200,0,'-02'),(1531,2,-3600,1,'-01'),(1531,3,-7200,0,'-02'),(1531,4,-3600,0,'-01'),(1532,0,-1624,0,'LMT'),(1532,1,0,0,'WET'),(1532,2,3600,1,'WEST'),(1532,3,0,0,'WET'),(1533,0,-1624,0,'LMT'),(1533,1,0,0,'WET'),(1533,2,3600,1,'WEST'),(1533,3,0,0,'WET'),(1534,0,3208,0,'LMT'),(1534,1,7200,1,'CEST'),(1534,2,3600,0,'CET'),(1534,3,7200,1,'CEST'),(1534,4,3600,0,'CET'),(1534,5,10800,1,'CEMT'),(1534,6,10800,1,'CEMT'),(1534,7,7200,1,'CEST'),(1534,8,3600,0,'CET'),(1535,0,-4056,0,'LMT'),(1535,1,-4056,0,'FMT'),(1535,2,0,1,'+00'),(1535,3,-3600,0,'-01'),(1535,4,0,1,'+00'),(1535,5,-3600,0,'-01'),(1535,6,-3600,0,'-01'),(1535,7,3600,1,'+01'),(1535,8,3600,1,'WEST'),(1535,9,0,0,'WET'),(1535,10,0,0,'WET'),(1535,11,0,0,'WET'),(1535,12,3600,1,'WEST'),(1536,0,-968,0,'LMT'),(1536,1,0,0,'GMT'),(1537,0,-7200,0,'-02'),(1538,0,-968,0,'LMT'),(1538,1,0,0,'GMT'),(1539,0,-13884,0,'LMT'),(1539,1,-13884,0,'SMT'),(1539,2,-10800,1,'-03'),(1539,3,-14400,0,'-04'),(1539,4,-7200,1,'-02'),(1539,5,-10800,0,'-03'),(1539,6,-10800,1,'-03'),(1540,0,36292,0,'LMT'),(1540,1,39600,1,'AEDT'),(1540,2,36000,0,'AEST'),(1540,3,36000,0,'AEST'),(1541,0,32400,0,'ACST'),(1541,1,37800,1,'ACDT'),(1541,2,34200,0,'ACST'),(1541,3,34200,0,'ACST'),(1542,0,36728,0,'LMT'),(1542,1,39600,1,'AEDT'),(1542,2,36000,0,'AEST'),(1542,3,36000,0,'AEST'),(1543,0,32400,0,'ACST'),(1543,1,37800,1,'ACDT'),(1543,2,34200,0,'ACST'),(1543,3,34200,0,'ACST'),(1543,4,37800,1,'ACDT'),(1544,0,36292,0,'LMT'),(1544,1,39600,1,'AEDT'),(1544,2,36000,0,'AEST'),(1544,3,36000,0,'AEST'),(1545,0,35356,0,'LMT'),(1545,1,39600,1,'AEDT'),(1545,2,36000,0,'AEST'),(1545,3,36000,0,'AEST'),(1546,0,32400,0,'ACST'),(1546,1,37800,1,'ACDT'),(1546,2,34200,0,'ACST'),(1546,3,34200,0,'ACST'),(1547,0,30928,0,'LMT'),(1547,1,35100,1,'+0945'),(1547,2,31500,0,'+0845'),(1547,3,31500,0,'+0845'),(1548,0,35356,0,'LMT'),(1548,1,39600,1,'AEDT'),(1548,2,36000,0,'AEST'),(1548,3,36000,0,'AEST'),(1549,0,38180,0,'LMT'),(1549,1,36000,0,'AEST'),(1549,2,41400,1,'+1130'),(1549,3,37800,0,'+1030'),(1549,4,39600,1,'+11'),(1550,0,35756,0,'LMT'),(1550,1,39600,1,'AEDT'),(1550,2,36000,0,'AEST'),(1550,3,36000,0,'AEST'),(1551,0,38180,0,'LMT'),(1551,1,36000,0,'AEST'),(1551,2,41400,1,'+1130'),(1551,3,37800,0,'+1030'),(1551,4,39600,1,'+11'),(1552,0,34792,0,'LMT'),(1552,1,39600,1,'AEDT'),(1552,2,36000,0,'AEST'),(1552,3,36000,0,'AEST'),(1553,0,36292,0,'LMT'),(1553,1,39600,1,'AEDT'),(1553,2,36000,0,'AEST'),(1553,3,36000,0,'AEST'),(1554,0,32400,0,'ACST'),(1554,1,37800,1,'ACDT'),(1554,2,34200,0,'ACST'),(1554,3,34200,0,'ACST'),(1555,0,27804,0,'LMT'),(1555,1,32400,1,'AWDT'),(1555,2,28800,0,'AWST'),(1555,3,28800,0,'AWST'),(1556,0,36728,0,'LMT'),(1556,1,39600,1,'AEDT'),(1556,2,36000,0,'AEST'),(1556,3,36000,0,'AEST'),(1557,0,32400,0,'ACST'),(1557,1,37800,1,'ACDT'),(1557,2,34200,0,'ACST'),(1557,3,34200,0,'ACST'),(1558,0,36292,0,'LMT'),(1558,1,39600,1,'AEDT'),(1558,2,36000,0,'AEST'),(1558,3,36000,0,'AEST'),(1559,0,35356,0,'LMT'),(1559,1,39600,1,'AEDT'),(1559,2,36000,0,'AEST'),(1559,3,36000,0,'AEST'),(1560,0,34792,0,'LMT'),(1560,1,39600,1,'AEDT'),(1560,2,36000,0,'AEST'),(1560,3,36000,0,'AEST'),(1561,0,27804,0,'LMT'),(1561,1,32400,1,'AWDT'),(1561,2,28800,0,'AWST'),(1561,3,28800,0,'AWST'),(1562,0,32400,0,'ACST'),(1562,1,37800,1,'ACDT'),(1562,2,34200,0,'ACST'),(1562,3,34200,0,'ACST'),(1562,4,37800,1,'ACDT'),(1563,0,-16272,0,'LMT'),(1563,1,-14400,1,'-04'),(1563,2,-18000,0,'-05'),(1563,3,-14400,0,'-04'),(1563,4,-18000,0,'-05'),(1564,0,-7780,0,'LMT'),(1564,1,-3600,1,'-01'),(1564,2,-7200,0,'-02'),(1565,0,-11188,0,'LMT'),(1565,1,-7200,1,'-02'),(1565,2,-10800,0,'-03'),(1566,0,-14404,0,'LMT'),(1566,1,-10800,1,'-03'),(1566,2,-14400,0,'-04'),(1567,0,7200,1,'CEST'),(1567,1,3600,0,'CET'),(1567,2,7200,1,'CEST'),(1567,3,3600,0,'CET'),(1568,0,-18000,1,'CDT'),(1568,1,-21600,0,'CST'),(1568,2,-18000,1,'CWT'),(1568,3,-18000,1,'CPT'),(1569,0,-15264,0,'LMT'),(1569,1,-10800,1,'ADT'),(1569,2,-14400,0,'AST'),(1569,3,-10800,1,'AWT'),(1569,4,-10800,1,'APT'),(1570,0,-23316,0,'LMT'),(1570,1,-18000,1,'CDT'),(1570,2,-21600,0,'CST'),(1570,3,-18000,1,'CWT'),(1570,4,-18000,1,'CPT'),(1570,5,-18000,1,'CDT'),(1570,6,-21600,0,'CST'),(1571,0,-19052,0,'LMT'),(1571,1,-14400,1,'EDT'),(1571,2,-18000,0,'EST'),(1571,3,-14400,1,'EWT'),(1571,4,-14400,1,'EPT'),(1572,0,-27232,0,'LMT'),(1572,1,-21600,1,'MDT'),(1572,2,-25200,0,'MST'),(1572,3,-21600,1,'MWT'),(1572,4,-21600,1,'MPT'),(1573,0,-12652,0,'LMT'),(1573,1,-9052,1,'NDT'),(1573,2,-12652,0,'NST'),(1573,3,-9000,1,'NDT'),(1573,4,-12600,0,'NST'),(1573,5,-9000,1,'NPT'),(1573,6,-9000,1,'NWT'),(1573,7,-5400,1,'NDDT'),(1573,8,-9000,1,'NDT'),(1574,0,-29548,0,'LMT'),(1574,1,-25200,1,'PDT'),(1574,2,-28800,0,'PST'),(1574,3,-25200,1,'PWT'),(1574,4,-25200,1,'PPT'),(1575,0,-25116,0,'LMT'),(1575,1,-21600,1,'MDT'),(1575,2,-25200,0,'MST'),(1575,3,-21600,1,'MWT'),(1575,4,-21600,1,'MPT'),(1575,5,-21600,0,'CST'),(1576,0,-32412,0,'LMT'),(1576,1,-28800,1,'YDT'),(1576,2,-32400,0,'YST'),(1576,3,-28800,1,'YWT'),(1576,4,-28800,1,'YPT'),(1576,5,-25200,1,'YDDT'),(1576,6,-28800,0,'PST'),(1576,7,-25200,1,'PDT'),(1576,8,-25200,0,'MST'),(1577,0,-16965,0,'LMT'),(1577,1,-16965,0,'SMT'),(1577,2,-18000,0,'-05'),(1577,3,-14400,0,'-04'),(1577,4,-14400,1,'-04'),(1577,5,-10800,1,'-03'),(1577,6,-10800,1,'-03'),(1577,7,-14400,0,'-04'),(1578,0,-26248,0,'LMT'),(1578,1,-26248,0,'EMT'),(1578,2,-21600,1,'-06'),(1578,3,-25200,0,'-07'),(1578,4,-25200,0,'-07'),(1578,5,-21600,0,'-06'),(1578,6,-18000,1,'-05'),(1579,0,-19768,0,'LMT'),(1579,1,-19776,0,'HMT'),(1579,2,-14400,1,'CDT'),(1579,3,-18000,0,'CST'),(1579,4,-18000,0,'CST'),(1579,5,-14400,1,'CDT'),(1580,0,10800,1,'EEST'),(1580,1,7200,0,'EET'),(1581,0,-18000,0,'EST'),(1582,0,-14400,1,'EDT'),(1582,1,-18000,0,'EST'),(1582,2,-14400,1,'EWT'),(1582,3,-14400,1,'EPT'),(1583,0,7509,0,'LMT'),(1583,1,10800,1,'EEST'),(1583,2,7200,0,'EET'),(1583,3,10800,1,'EEST'),(1584,0,-1521,0,'LMT'),(1584,1,-1521,0,'DMT'),(1584,2,2079,1,'IST'),(1584,3,3600,1,'BST'),(1584,4,0,0,'GMT'),(1584,5,3600,1,'IST'),(1584,6,0,0,'GMT'),(1584,7,3600,0,'IST'),(1584,8,3600,1,'IST'),(1584,9,0,0,'GMT'),(1585,0,0,0,'GMT'),(1586,0,0,0,'GMT'),(1587,0,-3600,0,'-01'),(1588,0,-36000,0,'-10'),(1589,0,-39600,0,'-11'),(1590,0,-43200,0,'-12'),(1591,0,-7200,0,'-02'),(1592,0,-10800,0,'-03'),(1593,0,-14400,0,'-04'),(1594,0,-18000,0,'-05'),(1595,0,-21600,0,'-06'),(1596,0,-25200,0,'-07'),(1597,0,-28800,0,'-08'),(1598,0,-32400,0,'-09'),(1599,0,0,0,'GMT'),(1600,0,3600,0,'+01'),(1601,0,36000,0,'+10'),(1602,0,39600,0,'+11'),(1603,0,43200,0,'+12'),(1604,0,46800,0,'+13'),(1605,0,50400,0,'+14'),(1606,0,7200,0,'+02'),(1607,0,10800,0,'+03'),(1608,0,14400,0,'+04'),(1609,0,18000,0,'+05'),(1610,0,21600,0,'+06'),(1611,0,25200,0,'+07'),(1612,0,28800,0,'+08'),(1613,0,32400,0,'+09'),(1614,0,0,0,'GMT'),(1615,0,0,0,'GMT'),(1616,0,0,0,'UTC'),(1617,0,0,0,'UTC'),(1618,0,0,0,'UTC'),(1619,0,0,0,'UTC'),(1620,0,1050,0,'BMT'),(1620,1,0,0,'WET'),(1620,2,3600,0,'CET'),(1620,3,7200,1,'CEST'),(1620,4,3600,0,'CET'),(1620,5,7200,1,'CEST'),(1620,6,3600,1,'WEST'),(1620,7,0,0,'WET'),(1620,8,0,0,'WET'),(1620,9,7200,1,'CEST'),(1620,10,3600,0,'CET'),(1621,0,364,0,'LMT'),(1621,1,0,0,'WET'),(1621,2,3600,0,'CET'),(1621,3,7200,1,'CEST'),(1621,4,3600,0,'CET'),(1622,0,11532,0,'LMT'),(1622,1,10800,0,'+03'),(1622,2,18000,1,'+05'),(1622,3,14400,0,'+04'),(1622,4,14400,0,'+04'),(1622,5,18000,1,'+05'),(1622,6,14400,1,'+04'),(1622,7,10800,0,'+03'),(1622,8,14400,0,'+04'),(1623,0,5692,0,'LMT'),(1623,1,5692,0,'AMT'),(1623,2,10800,1,'EEST'),(1623,3,7200,0,'EET'),(1623,4,3600,0,'CET'),(1623,5,7200,1,'CEST'),(1623,6,10800,1,'EEST'),(1623,7,7200,0,'EET'),(1623,8,10800,1,'EEST'),(1623,9,7200,0,'EET'),(1624,0,-75,0,'LMT'),(1624,1,3600,1,'BST'),(1624,2,0,0,'GMT'),(1624,3,7200,1,'BDST'),(1624,4,0,0,'GMT'),(1624,5,3600,0,'BST'),(1624,6,3600,1,'BST'),(1624,7,0,0,'GMT'),(1625,0,4920,0,'LMT'),(1625,1,3600,0,'CET'),(1625,2,3600,0,'CET'),(1625,3,7200,1,'CEST'),(1625,4,7200,1,'CEST'),(1625,5,7200,1,'CEST'),(1625,6,3600,0,'CET'),(1626,0,3208,0,'LMT'),(1626,1,7200,1,'CEST'),(1626,2,3600,0,'CET'),(1626,3,7200,1,'CEST'),(1626,4,3600,0,'CET'),(1626,5,10800,1,'CEMT'),(1626,6,10800,1,'CEMT'),(1626,7,7200,1,'CEST'),(1626,8,3600,0,'CET'),(1627,0,3464,0,'PMT'),(1627,1,7200,1,'CEST'),(1627,2,3600,0,'CET'),(1627,3,7200,1,'CEST'),(1627,4,3600,0,'CET'),(1627,5,0,0,'GMT'),(1627,6,7200,1,'CEST'),(1627,7,3600,0,'CET'),(1628,0,1050,0,'BMT'),(1628,1,0,0,'WET'),(1628,2,3600,0,'CET'),(1628,3,7200,1,'CEST'),(1628,4,3600,0,'CET'),(1628,5,7200,1,'CEST'),(1628,6,3600,1,'WEST'),(1628,7,0,0,'WET'),(1628,8,0,0,'WET'),(1628,9,7200,1,'CEST'),(1628,10,3600,0,'CET'),(1629,0,6264,0,'LMT'),(1629,1,6264,0,'BMT'),(1629,2,10800,1,'EEST'),(1629,3,7200,0,'EET'),(1629,4,10800,1,'EEST'),(1629,5,7200,0,'EET'),(1629,6,10800,1,'EEST'),(1629,7,7200,0,'EET'),(1630,0,4580,0,'LMT'),(1630,1,7200,1,'CEST'),(1630,2,3600,0,'CET'),(1630,3,7200,1,'CEST'),(1630,4,3600,0,'CET'),(1630,5,7200,1,'CEST'),(1630,6,3600,0,'CET'),(1631,0,1786,0,'BMT'),(1631,1,7200,1,'CEST'),(1631,2,3600,0,'CET'),(1631,3,7200,1,'CEST'),(1631,4,3600,0,'CET'),(1632,0,6920,0,'LMT'),(1632,1,6900,0,'CMT'),(1632,2,6264,0,'BMT'),(1632,3,10800,1,'EEST'),(1632,4,7200,0,'EET'),(1632,5,7200,0,'EET'),(1632,6,10800,1,'EEST'),(1632,7,3600,0,'CET'),(1632,8,7200,1,'CEST'),(1632,9,7200,1,'CEST'),(1632,10,14400,1,'MSD'),(1632,11,10800,0,'MSK'),(1632,12,10800,0,'MSK'),(1632,13,14400,1,'MSD'),(1632,14,10800,1,'EEST'),(1632,15,7200,0,'EET'),(1633,0,3208,0,'LMT'),(1633,1,7200,1,'CEST'),(1633,2,3600,0,'CET'),(1633,3,7200,1,'CEST'),(1633,4,3600,0,'CET'),(1633,5,10800,1,'CEMT'),(1633,6,10800,1,'CEMT'),(1633,7,7200,1,'CEST'),(1633,8,3600,0,'CET'),(1634,0,-1521,0,'LMT'),(1634,1,-1521,0,'DMT'),(1634,2,2079,1,'IST'),(1634,3,3600,1,'BST'),(1634,4,0,0,'GMT'),(1634,5,3600,1,'IST'),(1634,6,0,0,'GMT'),(1634,7,3600,0,'IST'),(1634,8,3600,1,'IST'),(1634,9,0,0,'GMT'),(1635,0,-1284,0,'LMT'),(1635,1,3600,1,'BST'),(1635,2,0,0,'GMT'),(1635,3,7200,1,'BDST'),(1635,4,0,0,'GMT'),(1635,5,3600,0,'CET'),(1635,6,7200,1,'CEST'),(1635,7,3600,0,'CET'),(1636,0,-75,0,'LMT'),(1636,1,3600,1,'BST'),(1636,2,0,0,'GMT'),(1636,3,7200,1,'BDST'),(1636,4,0,0,'GMT'),(1636,5,3600,0,'BST'),(1636,6,3600,1,'BST'),(1636,7,0,0,'GMT'),(1637,0,5989,0,'LMT'),(1637,1,5989,0,'HMT'),(1637,2,10800,1,'EEST'),(1637,3,7200,0,'EET'),(1637,4,10800,1,'EEST'),(1637,5,7200,0,'EET'),(1638,0,-75,0,'LMT'),(1638,1,3600,1,'BST'),(1638,2,0,0,'GMT'),(1638,3,7200,1,'BDST'),(1638,4,0,0,'GMT'),(1638,5,3600,0,'BST'),(1638,6,3600,1,'BST'),(1638,7,0,0,'GMT'),(1639,0,6952,0,'LMT'),(1639,1,7016,0,'IMT'),(1639,2,10800,1,'EEST'),(1639,3,7200,0,'EET'),(1639,4,10800,0,'+03'),(1639,5,14400,1,'+04'),(1639,6,10800,1,'EEST'),(1639,7,7200,0,'EET'),(1639,8,10800,1,'EEST'),(1639,9,7200,0,'EET'),(1639,10,10800,0,'+03'),(1640,0,-75,0,'LMT'),(1640,1,3600,1,'BST'),(1640,2,0,0,'GMT'),(1640,3,7200,1,'BDST'),(1640,4,0,0,'GMT'),(1640,5,3600,0,'BST'),(1640,6,3600,1,'BST'),(1640,7,0,0,'GMT'),(1641,0,4920,0,'LMT'),(1641,1,7200,1,'CEST'),(1641,2,3600,0,'CET'),(1641,3,7200,1,'CEST'),(1641,4,3600,0,'CET'),(1641,5,10800,1,'EEST'),(1641,6,7200,0,'EET'),(1641,7,14400,1,'MSD'),(1641,8,10800,0,'MSK'),(1641,9,10800,0,'MSK'),(1641,10,14400,1,'MSD'),(1641,11,10800,1,'EEST'),(1641,12,7200,0,'EET'),(1641,13,10800,0,'+03'),(1641,14,7200,0,'EET'),(1642,0,7324,0,'LMT'),(1642,1,7324,0,'KMT'),(1642,2,7200,0,'EET'),(1642,3,10800,0,'MSK'),(1642,4,3600,0,'CET'),(1642,5,7200,1,'CEST'),(1642,6,7200,1,'CEST'),(1642,7,14400,1,'MSD'),(1642,8,10800,0,'MSK'),(1642,9,14400,1,'MSD'),(1642,10,10800,1,'EEST'),(1642,11,7200,0,'EET'),(1642,12,10800,1,'EEST'),(1642,13,7200,0,'EET'),(1642,14,10800,1,'EEST'),(1643,0,11928,0,'LMT'),(1643,1,10800,0,'+03'),(1643,2,18000,1,'+05'),(1643,3,14400,0,'+04'),(1643,4,14400,0,'+04'),(1643,5,18000,1,'+05'),(1643,6,14400,1,'MSD'),(1643,7,10800,0,'MSK'),(1643,8,14400,0,'MSK'),(1643,9,10800,0,'MSK'),(1644,0,7324,0,'LMT'),(1644,1,7324,0,'KMT'),(1644,2,7200,0,'EET'),(1644,3,10800,0,'MSK'),(1644,4,3600,0,'CET'),(1644,5,7200,1,'CEST'),(1644,6,7200,1,'CEST'),(1644,7,14400,1,'MSD'),(1644,8,10800,0,'MSK'),(1644,9,14400,1,'MSD'),(1644,10,10800,1,'EEST'),(1644,11,7200,0,'EET'),(1644,12,10800,1,'EEST'),(1644,13,7200,0,'EET'),(1644,14,10800,1,'EEST'),(1645,0,-2205,0,'LMT'),(1645,1,3600,1,'WEST'),(1645,2,0,0,'WET'),(1645,3,3600,1,'WEST'),(1645,4,0,0,'WET'),(1645,5,7200,1,'WEMT'),(1645,6,0,0,'WET'),(1645,7,3600,0,'CET'),(1645,8,3600,0,'CET'),(1645,9,7200,1,'CEST'),(1645,10,3600,1,'WEST'),(1645,11,0,0,'WET'),(1646,0,4920,0,'LMT'),(1646,1,3600,0,'CET'),(1646,2,3600,0,'CET'),(1646,3,7200,1,'CEST'),(1646,4,7200,1,'CEST'),(1646,5,7200,1,'CEST'),(1646,6,3600,0,'CET'),(1647,0,-75,0,'LMT'),(1647,1,3600,1,'BST'),(1647,2,0,0,'GMT'),(1647,3,7200,1,'BDST'),(1647,4,0,0,'GMT'),(1647,5,3600,0,'BST'),(1647,6,3600,1,'BST'),(1647,7,0,0,'GMT'),(1648,0,1050,0,'BMT'),(1648,1,0,0,'WET'),(1648,2,3600,0,'CET'),(1648,3,7200,1,'CEST'),(1648,4,3600,0,'CET'),(1648,5,7200,1,'CEST'),(1648,6,3600,1,'WEST'),(1648,7,0,0,'WET'),(1648,8,0,0,'WET'),(1648,9,7200,1,'CEST'),(1648,10,3600,0,'CET'),(1649,0,-884,0,'LMT'),(1649,1,3600,1,'WEST'),(1649,2,0,0,'WET'),(1649,3,7200,1,'WEMT'),(1649,4,0,0,'WET'),(1649,5,7200,1,'CEST'),(1649,6,3600,0,'CET'),(1649,7,7200,1,'CEST'),(1649,8,3600,0,'CET'),(1649,9,7200,1,'CEST'),(1649,10,3600,0,'CET'),(1650,0,3484,0,'LMT'),(1650,1,7200,1,'CEST'),(1650,2,3600,0,'CET'),(1650,3,3600,0,'CET'),(1650,4,7200,1,'CEST'),(1650,5,7200,1,'CEST'),(1650,6,3600,0,'CET'),(1651,0,5989,0,'LMT'),(1651,1,5989,0,'HMT'),(1651,2,10800,1,'EEST'),(1651,3,7200,0,'EET'),(1651,4,10800,1,'EEST'),(1651,5,7200,0,'EET'),(1652,0,6616,0,'LMT'),(1652,1,6600,0,'MMT'),(1652,2,7200,0,'EET'),(1652,3,10800,0,'MSK'),(1652,4,3600,0,'CET'),(1652,5,7200,1,'CEST'),(1652,6,7200,1,'CEST'),(1652,7,14400,1,'MSD'),(1652,8,10800,0,'MSK'),(1652,9,14400,1,'MSD'),(1652,10,10800,1,'EEST'),(1652,11,7200,0,'EET'),(1652,12,10800,0,'+03'),(1653,0,561,0,'LMT'),(1653,1,561,0,'PMT'),(1653,2,3600,1,'WEST'),(1653,3,0,0,'WET'),(1653,4,3600,1,'WEST'),(1653,5,0,0,'WET'),(1653,6,3600,0,'CET'),(1653,7,7200,1,'CEST'),(1653,8,7200,1,'CEST'),(1653,9,7200,1,'WEMT'),(1653,10,3600,0,'CET'),(1653,11,7200,1,'CEST'),(1653,12,3600,0,'CET'),(1654,0,9017,0,'LMT'),(1654,1,9017,0,'MMT'),(1654,2,12679,1,'MST'),(1654,3,9079,0,'MMT'),(1654,4,16279,1,'MDST'),(1654,5,14400,1,'MSD'),(1654,6,10800,0,'MSK'),(1654,7,14400,1,'MSD'),(1654,8,18000,1,'+05'),(1654,9,7200,0,'EET'),(1654,10,10800,0,'MSK'),(1654,11,14400,1,'MSD'),(1654,12,10800,1,'EEST'),(1654,13,7200,0,'EET'),(1654,14,14400,0,'MSK'),(1654,15,14400,1,'MSD'),(1654,16,10800,0,'MSK'),(1655,0,8008,0,'LMT'),(1655,1,10800,1,'EEST'),(1655,2,7200,0,'EET'),(1655,3,7200,0,'EET'),(1655,4,10800,1,'EEST'),(1656,0,3208,0,'LMT'),(1656,1,7200,1,'CEST'),(1656,2,3600,0,'CET'),(1656,3,7200,1,'CEST'),(1656,4,3600,0,'CET'),(1656,5,10800,1,'CEMT'),(1656,6,10800,1,'CEMT'),(1656,7,7200,1,'CEST'),(1656,8,3600,0,'CET'),(1657,0,561,0,'LMT'),(1657,1,561,0,'PMT'),(1657,2,3600,1,'WEST'),(1657,3,0,0,'WET'),(1657,4,3600,1,'WEST'),(1657,5,0,0,'WET'),(1657,6,3600,0,'CET'),(1657,7,7200,1,'CEST'),(1657,8,7200,1,'CEST'),(1657,9,7200,1,'WEMT'),(1657,10,3600,0,'CET'),(1657,11,7200,1,'CEST'),(1657,12,3600,0,'CET'),(1658,0,4920,0,'LMT'),(1658,1,3600,0,'CET'),(1658,2,3600,0,'CET'),(1658,3,7200,1,'CEST'),(1658,4,7200,1,'CEST'),(1658,5,7200,1,'CEST'),(1658,6,3600,0,'CET'),(1659,0,3464,0,'PMT'),(1659,1,7200,1,'CEST'),(1659,2,3600,0,'CET'),(1659,3,7200,1,'CEST'),(1659,4,3600,0,'CET'),(1659,5,0,0,'GMT'),(1659,6,7200,1,'CEST'),(1659,7,3600,0,'CET'),(1660,0,5794,0,'LMT'),(1660,1,5794,0,'RMT'),(1660,2,9394,1,'LST'),(1660,3,7200,0,'EET'),(1660,4,10800,0,'MSK'),(1660,5,3600,0,'CET'),(1660,6,7200,1,'CEST'),(1660,7,7200,1,'CEST'),(1660,8,14400,1,'MSD'),(1660,9,10800,0,'MSK'),(1660,10,14400,1,'MSD'),(1660,11,10800,1,'EEST'),(1660,12,7200,0,'EET'),(1660,13,10800,1,'EEST'),(1660,14,7200,0,'EET'),(1661,0,2996,0,'RMT'),(1661,1,7200,1,'CEST'),(1661,2,3600,0,'CET'),(1661,3,3600,0,'CET'),(1661,4,7200,1,'CEST'),(1661,5,3600,0,'CET'),(1661,6,7200,1,'CEST'),(1662,0,12020,0,'LMT'),(1662,1,10800,0,'+03'),(1662,2,14400,0,'+04'),(1662,3,18000,1,'+05'),(1662,4,14400,0,'+04'),(1662,5,18000,1,'+05'),(1662,6,14400,1,'+04'),(1662,7,10800,0,'+03'),(1662,8,10800,1,'+03'),(1662,9,14400,1,'+04'),(1662,10,14400,0,'+04'),(1663,0,2996,0,'RMT'),(1663,1,7200,1,'CEST'),(1663,2,3600,0,'CET'),(1663,3,3600,0,'CET'),(1663,4,7200,1,'CEST'),(1663,5,3600,0,'CET'),(1663,6,7200,1,'CEST'),(1664,0,4920,0,'LMT'),(1664,1,3600,0,'CET'),(1664,2,3600,0,'CET'),(1664,3,7200,1,'CEST'),(1664,4,7200,1,'CEST'),(1664,5,7200,1,'CEST'),(1664,6,3600,0,'CET'),(1665,0,11058,0,'LMT'),(1665,1,10800,0,'+03'),(1665,2,18000,1,'+05'),(1665,3,14400,0,'+04'),(1665,4,14400,0,'+04'),(1665,5,18000,1,'+05'),(1665,6,14400,1,'+04'),(1665,7,10800,0,'+03'),(1665,8,14400,0,'+04'),(1666,0,8184,0,'LMT'),(1666,1,8160,0,'SMT'),(1666,2,7200,0,'EET'),(1666,3,10800,0,'MSK'),(1666,4,3600,0,'CET'),(1666,5,7200,1,'CEST'),(1666,6,7200,1,'CEST'),(1666,7,14400,1,'MSD'),(1666,8,10800,0,'MSK'),(1666,9,14400,1,'MSD'),(1666,10,10800,1,'EEST'),(1666,11,7200,0,'EET'),(1666,12,10800,1,'EEST'),(1666,13,7200,0,'EET'),(1666,14,14400,0,'MSK'),(1666,15,10800,0,'MSK'),(1667,0,4920,0,'LMT'),(1667,1,3600,0,'CET'),(1667,2,3600,0,'CET'),(1667,3,7200,1,'CEST'),(1667,4,7200,1,'CEST'),(1667,5,7200,1,'CEST'),(1667,6,3600,0,'CET'),(1668,0,7016,0,'IMT'),(1668,1,7200,0,'EET'),(1668,2,3600,0,'CET'),(1668,3,7200,1,'CEST'),(1668,4,3600,0,'CET'),(1668,5,10800,1,'EEST'),(1668,6,7200,0,'EET'),(1668,7,10800,1,'EEST'),(1668,8,10800,1,'EEST'),(1668,9,7200,0,'EET'),(1669,0,3208,0,'LMT'),(1669,1,7200,1,'CEST'),(1669,2,3600,0,'CET'),(1669,3,7200,1,'CEST'),(1669,4,3600,0,'CET'),(1669,5,10800,1,'CEMT'),(1669,6,10800,1,'CEMT'),(1669,7,7200,1,'CEST'),(1669,8,3600,0,'CET'),(1670,0,5940,0,'LMT'),(1670,1,5940,0,'TMT'),(1670,2,7200,1,'CEST'),(1670,3,3600,0,'CET'),(1670,4,3600,0,'CET'),(1670,5,7200,0,'EET'),(1670,6,10800,0,'MSK'),(1670,7,7200,1,'CEST'),(1670,8,14400,1,'MSD'),(1670,9,10800,0,'MSK'),(1670,10,14400,1,'MSD'),(1670,11,10800,1,'EEST'),(1670,12,7200,0,'EET'),(1670,13,7200,0,'EET'),(1670,14,10800,1,'EEST'),(1670,15,10800,1,'EEST'),(1671,0,4760,0,'LMT'),(1671,1,3600,0,'CET'),(1671,2,7200,1,'CEST'),(1671,3,3600,0,'CET'),(1671,4,7200,1,'CEST'),(1672,0,6920,0,'LMT'),(1672,1,6900,0,'CMT'),(1672,2,6264,0,'BMT'),(1672,3,10800,1,'EEST'),(1672,4,7200,0,'EET'),(1672,5,7200,0,'EET'),(1672,6,10800,1,'EEST'),(1672,7,3600,0,'CET'),(1672,8,7200,1,'CEST'),(1672,9,7200,1,'CEST'),(1672,10,14400,1,'MSD'),(1672,11,10800,0,'MSK'),(1672,12,10800,0,'MSK'),(1672,13,14400,1,'MSD'),(1672,14,10800,1,'EEST'),(1672,15,7200,0,'EET'),(1673,0,11616,0,'LMT'),(1673,1,10800,0,'+03'),(1673,2,18000,1,'+05'),(1673,3,14400,0,'+04'),(1673,4,14400,0,'+04'),(1673,5,18000,1,'+05'),(1673,6,14400,1,'+04'),(1673,7,10800,0,'+03'),(1673,8,10800,1,'+03'),(1673,9,7200,0,'+02'),(1673,10,14400,1,'+04'),(1673,11,14400,0,'+04'),(1674,0,7324,0,'LMT'),(1674,1,7324,0,'KMT'),(1674,2,7200,0,'EET'),(1674,3,10800,0,'MSK'),(1674,4,3600,0,'CET'),(1674,5,7200,1,'CEST'),(1674,6,7200,1,'CEST'),(1674,7,14400,1,'MSD'),(1674,8,10800,0,'MSK'),(1674,9,14400,1,'MSD'),(1674,10,10800,1,'EEST'),(1674,11,7200,0,'EET'),(1674,12,10800,1,'EEST'),(1674,13,7200,0,'EET'),(1674,14,10800,1,'EEST'),(1675,0,1786,0,'BMT'),(1675,1,7200,1,'CEST'),(1675,2,3600,0,'CET'),(1675,3,7200,1,'CEST'),(1675,4,3600,0,'CET'),(1676,0,2996,0,'RMT'),(1676,1,7200,1,'CEST'),(1676,2,3600,0,'CET'),(1676,3,3600,0,'CET'),(1676,4,7200,1,'CEST'),(1676,5,3600,0,'CET'),(1676,6,7200,1,'CEST'),(1677,0,3921,0,'LMT'),(1677,1,7200,1,'CEST'),(1677,2,3600,0,'CET'),(1677,3,7200,1,'CEST'),(1677,4,3600,0,'CET'),(1677,5,7200,1,'CEST'),(1677,6,3600,0,'CET'),(1678,0,6076,0,'LMT'),(1678,1,5040,0,'WMT'),(1678,2,5736,0,'KMT'),(1678,3,3600,0,'CET'),(1678,4,7200,0,'EET'),(1678,5,10800,0,'MSK'),(1678,6,3600,0,'CET'),(1678,7,7200,1,'CEST'),(1678,8,7200,1,'CEST'),(1678,9,14400,1,'MSD'),(1678,10,10800,0,'MSK'),(1678,11,14400,1,'MSD'),(1678,12,10800,1,'EEST'),(1678,13,7200,0,'EET'),(1678,14,7200,1,'CEST'),(1678,15,3600,0,'CET'),(1678,16,7200,0,'EET'),(1678,17,10800,1,'EEST'),(1679,0,10660,0,'LMT'),(1679,1,10800,0,'+03'),(1679,2,14400,0,'+04'),(1679,3,18000,1,'+05'),(1679,4,14400,0,'+04'),(1679,5,18000,1,'+05'),(1679,6,14400,1,'MSD'),(1679,7,10800,0,'MSK'),(1679,8,14400,0,'MSK'),(1679,9,10800,0,'MSK'),(1680,0,5040,0,'LMT'),(1680,1,5040,0,'WMT'),(1680,2,7200,1,'CEST'),(1680,3,3600,0,'CET'),(1680,4,7200,1,'CEST'),(1680,5,3600,0,'CET'),(1680,6,10800,1,'EEST'),(1680,7,7200,0,'EET'),(1680,8,7200,0,'EET'),(1680,9,7200,1,'CEST'),(1680,10,3600,0,'CET'),(1681,0,4920,0,'LMT'),(1681,1,3600,0,'CET'),(1681,2,3600,0,'CET'),(1681,3,7200,1,'CEST'),(1681,4,7200,1,'CEST'),(1681,5,7200,1,'CEST'),(1681,6,3600,0,'CET'),(1682,0,7324,0,'LMT'),(1682,1,7324,0,'KMT'),(1682,2,7200,0,'EET'),(1682,3,10800,0,'MSK'),(1682,4,3600,0,'CET'),(1682,5,7200,1,'CEST'),(1682,6,7200,1,'CEST'),(1682,7,14400,1,'MSD'),(1682,8,10800,0,'MSK'),(1682,9,14400,1,'MSD'),(1682,10,10800,1,'EEST'),(1682,11,7200,0,'EET'),(1682,12,10800,1,'EEST'),(1682,13,7200,0,'EET'),(1682,14,10800,1,'EEST'),(1683,0,1786,0,'BMT'),(1683,1,7200,1,'CEST'),(1683,2,3600,0,'CET'),(1683,3,7200,1,'CEST'),(1683,4,3600,0,'CET'),(1684,0,-75,0,'LMT'),(1684,1,3600,1,'BST'),(1684,2,0,0,'GMT'),(1684,3,7200,1,'BDST'),(1684,4,0,0,'GMT'),(1684,5,3600,0,'BST'),(1684,6,3600,1,'BST'),(1684,7,0,0,'GMT'),(1685,0,-75,0,'LMT'),(1685,1,3600,1,'BST'),(1685,2,0,0,'GMT'),(1685,3,7200,1,'BDST'),(1685,4,0,0,'GMT'),(1685,5,3600,0,'BST'),(1685,6,3600,1,'BST'),(1685,7,0,0,'GMT'),(1686,0,0,0,'GMT'),(1687,0,0,0,'GMT'),(1688,0,0,0,'GMT'),(1689,0,0,0,'GMT'),(1690,0,0,0,'GMT'),(1691,0,-36000,0,'HST'),(1692,0,27402,0,'LMT'),(1692,1,28800,0,'HKT'),(1692,2,32400,1,'HKST'),(1692,3,30600,1,'HKWT'),(1692,4,32400,0,'JST'),(1692,5,28800,0,'HKT'),(1692,6,32400,1,'HKST'),(1692,7,28800,0,'HKT'),(1693,0,-968,0,'LMT'),(1693,1,0,0,'GMT'),(1694,0,8836,0,'LMT'),(1694,1,9000,0,'+0230'),(1694,2,10800,0,'EAT'),(1694,3,9900,0,'+0245'),(1694,4,10800,0,'EAT'),(1695,0,17380,0,'LMT'),(1695,1,18000,0,'+05'),(1695,2,21600,0,'+06'),(1696,0,24124,0,'LMT'),(1696,1,24124,0,'BMT'),(1696,2,25200,0,'+07'),(1697,0,23087,0,'LMT'),(1697,1,23087,0,'RMT'),(1697,2,23400,0,'+0630'),(1697,3,32400,0,'+09'),(1697,4,23400,0,'+0630'),(1698,0,8836,0,'LMT'),(1698,1,9000,0,'+0230'),(1698,2,10800,0,'EAT'),(1698,3,9900,0,'+0245'),(1698,4,10800,0,'EAT'),(1699,0,17640,0,'LMT'),(1699,1,17640,0,'MMT'),(1699,2,18000,0,'+05'),(1700,0,13272,0,'LMT'),(1700,1,14400,0,'+04'),(1701,0,17640,0,'LMT'),(1701,1,17640,0,'MMT'),(1701,2,18000,0,'+05'),(1702,0,13800,0,'LMT'),(1702,1,18000,1,'+05'),(1702,2,14400,0,'+04'),(1703,0,8836,0,'LMT'),(1703,1,9000,0,'+0230'),(1703,2,10800,0,'EAT'),(1703,3,9900,0,'+0245'),(1703,4,10800,0,'EAT'),(1704,0,13272,0,'LMT'),(1704,1,14400,0,'+04'),(1705,0,12344,0,'LMT'),(1705,1,12344,0,'TMT'),(1705,2,16200,1,'+0430'),(1705,3,12600,0,'+0330'),(1705,4,18000,1,'+05'),(1705,5,14400,0,'+04'),(1705,6,16200,1,'+0430'),(1705,7,12600,0,'+0330'),(1706,0,8454,0,'LMT'),(1706,1,8440,0,'JMT'),(1706,2,10800,1,'IDT'),(1706,3,7200,0,'IST'),(1706,4,14400,1,'IDDT'),(1706,5,10800,1,'IDT'),(1706,6,7200,0,'IST'),(1706,7,10800,1,'IDT'),(1706,8,7200,0,'IST'),(1707,0,-18430,0,'LMT'),(1707,1,-18430,0,'KMT'),(1707,2,-18000,0,'EST'),(1707,3,-14400,1,'EDT'),(1708,0,33539,0,'LMT'),(1708,1,36000,1,'JDT'),(1708,2,32400,0,'JST'),(1708,3,32400,0,'JST'),(1709,0,40160,0,'LMT'),(1709,1,39600,0,'+11'),(1709,2,36000,0,'+10'),(1709,3,32400,0,'+09'),(1709,4,-43200,0,'-12'),(1709,5,43200,0,'+12'),(1710,0,3164,0,'LMT'),(1710,1,7200,1,'CEST'),(1710,2,3600,0,'CET'),(1710,3,7200,0,'EET'),(1711,0,7200,1,'MEST'),(1711,1,3600,0,'MET'),(1711,2,7200,1,'MEST'),(1711,3,3600,0,'MET'),(1712,0,-25200,0,'MST'),(1713,0,-21600,1,'MDT'),(1713,1,-25200,0,'MST'),(1713,2,-21600,1,'MWT'),(1713,3,-21600,1,'MPT'),(1714,0,-28084,0,'LMT'),(1714,1,-25200,0,'MST'),(1714,2,-28800,0,'PST'),(1714,3,-25200,0,'MST'),(1714,4,-25200,1,'PDT'),(1714,5,-25200,1,'PWT'),(1714,6,-25200,1,'PPT'),(1714,7,-28800,0,'PST'),(1715,0,-25540,0,'LMT'),(1715,1,-25200,0,'MST'),(1715,2,-21600,0,'CST'),(1715,3,-21600,1,'MDT'),(1715,4,-25200,0,'MST'),(1715,5,-28800,0,'PST'),(1715,6,-25200,0,'MST'),(1716,0,-23796,0,'LMT'),(1716,1,-25200,0,'MST'),(1716,2,-21600,0,'CST'),(1716,3,-21600,1,'MDT'),(1716,4,-25200,0,'MST'),(1716,5,-18000,1,'CDT'),(1716,6,-18000,1,'CWT'),(1716,7,-21600,0,'CST'),(1717,0,41944,0,'LMT'),(1717,1,45000,1,'NZST'),(1717,2,41400,0,'NZMT'),(1717,3,43200,1,'NZST'),(1717,4,46800,1,'NZDT'),(1717,5,43200,0,'NZST'),(1717,6,43200,0,'NZST'),(1718,0,44028,0,'LMT'),(1718,1,44100,0,'+1215'),(1718,2,49500,1,'+1345'),(1718,3,45900,0,'+1245'),(1718,4,45900,0,'+1245'),(1719,0,-25196,0,'LMT'),(1719,1,-21600,1,'MDT'),(1719,2,-25200,0,'MST'),(1719,3,-25200,0,'MST'),(1719,4,-21600,1,'MWT'),(1719,5,-21600,1,'MPT'),(1720,0,29143,0,'LMT'),(1720,1,32400,1,'CDT'),(1720,2,28800,0,'CST'),(1721,0,-25200,1,'PDT'),(1721,1,-28800,0,'PST'),(1721,2,-25200,1,'PWT'),(1721,3,-25200,1,'PPT'),(1722,0,45184,0,'LMT'),(1722,1,-41216,0,'LMT'),(1722,2,-41400,0,'-1130'),(1722,3,-36000,1,'-10'),(1722,4,-39600,0,'-11'),(1722,5,46800,0,'+13'),(1722,6,50400,1,'+14'),(1723,0,41944,0,'LMT'),(1723,1,45000,1,'NZST'),(1723,2,41400,0,'NZMT'),(1723,3,43200,1,'NZST'),(1723,4,46800,1,'NZDT'),(1723,5,43200,0,'NZST'),(1723,6,43200,0,'NZST'),(1724,0,35312,0,'PMMT'),(1724,1,36000,0,'+10'),(1724,2,32400,0,'+09'),(1724,3,39600,0,'+11'),(1725,0,44028,0,'LMT'),(1725,1,44100,0,'+1215'),(1725,2,49500,1,'+1345'),(1725,3,45900,0,'+1245'),(1725,4,45900,0,'+1245'),(1726,0,36000,0,'+10'),(1727,0,-26248,0,'LMT'),(1727,1,-26248,0,'EMT'),(1727,2,-21600,1,'-06'),(1727,3,-25200,0,'-07'),(1727,4,-25200,0,'-07'),(1727,5,-21600,0,'-06'),(1727,6,-18000,1,'-05'),(1728,0,40396,0,'LMT'),(1728,1,43200,1,'+12'),(1728,2,39600,0,'+11'),(1728,3,43200,1,'+12'),(1728,4,39600,0,'+11'),(1729,0,0,0,'-00'),(1729,1,-43200,0,'-12'),(1729,2,-39600,0,'-11'),(1729,3,46800,0,'+13'),(1730,0,-41096,0,'LMT'),(1730,1,-39600,0,'-11'),(1730,2,46800,0,'+13'),(1731,0,42944,0,'LMT'),(1731,1,46800,1,'+13'),(1731,2,43200,0,'+12'),(1732,0,43200,0,'+12'),(1733,0,-21504,0,'LMT'),(1733,1,-18000,0,'-05'),(1733,2,-18000,1,'-05'),(1733,3,-21600,0,'-06'),(1734,0,-32388,0,'LMT'),(1734,1,-32400,0,'-09'),(1735,0,38388,0,'LMT'),(1735,1,39600,0,'+11'),(1736,0,34740,0,'LMT'),(1736,1,36000,0,'GST'),(1736,2,32400,0,'+09'),(1736,3,39600,1,'GDT'),(1736,4,36000,0,'ChST'),(1737,0,-37886,0,'LMT'),(1737,1,-37800,0,'HST'),(1737,2,-34200,1,'HDT'),(1737,3,-34200,1,'HWT'),(1737,4,-34200,1,'HPT'),(1737,5,-36000,0,'HST'),(1738,0,-37886,0,'LMT'),(1738,1,-37800,0,'HST'),(1738,2,-34200,1,'HDT'),(1738,3,-34200,1,'HWT'),(1738,4,-34200,1,'HPT'),(1738,5,-36000,0,'HST'),(1739,0,0,0,'-00'),(1739,1,-43200,0,'-12'),(1739,2,-39600,0,'-11'),(1739,3,46800,0,'+13'),(1740,0,-37760,0,'LMT'),(1740,1,-38400,0,'-1040'),(1740,2,-36000,0,'-10'),(1740,3,50400,0,'+14'),(1741,0,39116,0,'LMT'),(1741,1,39600,0,'+11'),(1741,2,32400,0,'+09'),(1741,3,36000,0,'+10'),(1741,4,43200,0,'+12'),(1741,5,39600,0,'+11'),(1742,0,40160,0,'LMT'),(1742,1,39600,0,'+11'),(1742,2,36000,0,'+10'),(1742,3,32400,0,'+09'),(1742,4,-43200,0,'-12'),(1742,5,43200,0,'+12'),(1743,0,43200,0,'+12'),(1744,0,-33480,0,'LMT'),(1744,1,-34200,0,'-0930'),(1745,0,45432,0,'LMT'),(1745,1,-40968,0,'LMT'),(1745,2,-39600,0,'SST'),(1746,0,40060,0,'LMT'),(1746,1,41400,0,'+1130'),(1746,2,32400,0,'+09'),(1746,3,43200,0,'+12'),(1747,0,-40780,0,'LMT'),(1747,1,-40800,0,'-1120'),(1747,2,-39600,0,'-11'),(1748,0,40312,0,'LMT'),(1748,1,40320,0,'+1112'),(1748,2,41400,0,'+1130'),(1748,3,45000,1,'+1230'),(1748,4,41400,0,'+1130'),(1748,5,39600,0,'+11'),(1748,6,43200,1,'+12'),(1748,7,39600,0,'+11'),(1749,0,39948,0,'LMT'),(1749,1,43200,1,'+12'),(1749,2,39600,0,'+11'),(1749,3,43200,1,'+12'),(1749,4,39600,0,'+11'),(1750,0,45432,0,'LMT'),(1750,1,-40968,0,'LMT'),(1750,2,-39600,0,'SST'),(1751,0,32400,0,'+09'),(1752,0,-31220,0,'LMT'),(1752,1,-30600,0,'-0830'),(1752,2,-28800,0,'-08'),(1753,0,38388,0,'LMT'),(1753,1,39600,0,'+11'),(1754,0,38388,0,'LMT'),(1754,1,39600,0,'+11'),(1755,0,36000,0,'+10'),(1756,0,48056,0,'LMT'),(1756,1,-38344,0,'LMT'),(1756,2,-37800,0,'-1030'),(1756,3,-36000,0,'-10'),(1756,4,-34200,1,'-0930'),(1757,0,34740,0,'LMT'),(1757,1,36000,0,'GST'),(1757,2,32400,0,'+09'),(1757,3,39600,1,'GDT'),(1757,4,36000,0,'ChST'),(1758,0,45432,0,'LMT'),(1758,1,-40968,0,'LMT'),(1758,2,-39600,0,'SST'),(1759,0,-35896,0,'LMT'),(1759,1,-36000,0,'-10'),(1760,0,43200,0,'+12'),(1761,0,44352,0,'LMT'),(1761,1,44400,0,'+1220'),(1761,2,46800,0,'+13'),(1761,3,50400,1,'+14'),(1761,4,46800,0,'+13'),(1761,5,50400,1,'+14'),(1762,0,36000,0,'+10'),(1763,0,43200,0,'+12'),(1764,0,43200,0,'+12'),(1765,0,36000,0,'+10'),(1766,0,5040,0,'LMT'),(1766,1,5040,0,'WMT'),(1766,2,7200,1,'CEST'),(1766,3,3600,0,'CET'),(1766,4,7200,1,'CEST'),(1766,5,3600,0,'CET'),(1766,6,10800,1,'EEST'),(1766,7,7200,0,'EET'),(1766,8,7200,0,'EET'),(1766,9,7200,1,'CEST'),(1766,10,3600,0,'CET'),(1767,0,-2205,0,'LMT'),(1767,1,3600,1,'WEST'),(1767,2,0,0,'WET'),(1767,3,3600,1,'WEST'),(1767,4,0,0,'WET'),(1767,5,7200,1,'WEMT'),(1767,6,0,0,'WET'),(1767,7,3600,0,'CET'),(1767,8,3600,0,'CET'),(1767,9,7200,1,'CEST'),(1767,10,3600,1,'WEST'),(1767,11,0,0,'WET'),(1768,0,29160,0,'LMT'),(1768,1,28800,0,'CST'),(1768,2,32400,0,'JST'),(1768,3,32400,1,'CDT'),(1768,4,28800,0,'CST'),(1769,0,30472,0,'LMT'),(1769,1,30600,0,'KST'),(1769,2,32400,0,'JST'),(1769,3,36000,1,'KDT'),(1769,4,32400,0,'KST'),(1769,5,34200,1,'KDT'),(1769,6,36000,1,'KDT'),(1770,0,24925,0,'LMT'),(1770,1,24925,0,'SMT'),(1770,2,25200,0,'+07'),(1770,3,26400,1,'+0720'),(1770,4,26400,0,'+0720'),(1770,5,27000,0,'+0730'),(1770,6,32400,0,'+09'),(1770,7,28800,0,'+08'),(1771,0,6952,0,'LMT'),(1771,1,7016,0,'IMT'),(1771,2,10800,1,'EEST'),(1771,3,7200,0,'EET'),(1771,4,10800,0,'+03'),(1771,5,14400,1,'+04'),(1771,6,10800,1,'EEST'),(1771,7,7200,0,'EET'),(1771,8,10800,1,'EEST'),(1771,9,7200,0,'EET'),(1771,10,10800,0,'+03'),(1772,0,0,0,'UTC'),(1773,0,-35976,0,'LMT'),(1773,1,-36000,0,'AST'),(1773,2,-32400,1,'AWT'),(1773,3,-32400,1,'APT'),(1773,4,-36000,0,'AHST'),(1773,5,-32400,1,'AHDT'),(1773,6,-32400,0,'YST'),(1773,7,-28800,1,'AKDT'),(1773,8,-32400,0,'AKST'),(1774,0,-42398,0,'LMT'),(1774,1,-39600,0,'NST'),(1774,2,-36000,1,'NWT'),(1774,3,-36000,1,'NPT'),(1774,4,-39600,0,'BST'),(1774,5,-36000,1,'BDT'),(1774,6,-36000,0,'AHST'),(1774,7,-32400,1,'HDT'),(1774,8,-36000,0,'HST'),(1775,0,-26898,0,'LMT'),(1775,1,-21600,1,'MDT'),(1775,2,-25200,0,'MST'),(1775,3,-21600,1,'MWT'),(1775,4,-25200,0,'MST'),(1776,0,-21036,0,'LMT'),(1776,1,-18000,1,'CDT'),(1776,2,-21600,0,'CST'),(1776,3,-21600,0,'CST'),(1776,4,-18000,0,'EST'),(1776,5,-18000,1,'CWT'),(1776,6,-18000,1,'CPT'),(1776,7,-21600,0,'CST'),(1777,0,-20678,0,'LMT'),(1777,1,-18000,1,'CDT'),(1777,2,-21600,0,'CST'),(1777,3,-21600,0,'CST'),(1777,4,-18000,1,'CWT'),(1777,5,-18000,1,'CPT'),(1777,6,-18000,0,'EST'),(1777,7,-14400,1,'EDT'),(1778,0,-17762,0,'LMT'),(1778,1,-14400,1,'EDT'),(1778,2,-18000,0,'EST'),(1778,3,-18000,0,'EST'),(1778,4,-14400,1,'EWT'),(1778,5,-14400,1,'EPT'),(1779,0,-37886,0,'LMT'),(1779,1,-37800,0,'HST'),(1779,2,-34200,1,'HDT'),(1779,3,-34200,1,'HWT'),(1779,4,-34200,1,'HPT'),(1779,5,-36000,0,'HST'),(1780,0,-20790,0,'LMT'),(1780,1,-18000,1,'CDT'),(1780,2,-21600,0,'CST'),(1780,3,-18000,1,'CWT'),(1780,4,-18000,1,'CPT'),(1780,5,-21600,0,'CST'),(1780,6,-18000,0,'EST'),(1780,7,-21600,0,'CST'),(1781,0,-19931,0,'LMT'),(1781,1,-21600,0,'CST'),(1781,2,-18000,0,'EST'),(1781,3,-14400,1,'EWT'),(1781,4,-14400,1,'EPT'),(1781,5,-14400,1,'EDT'),(1782,0,-25196,0,'LMT'),(1782,1,-21600,1,'MDT'),(1782,2,-25200,0,'MST'),(1782,3,-25200,0,'MST'),(1782,4,-21600,1,'MWT'),(1782,5,-21600,1,'MPT'),(1783,0,-28378,0,'LMT'),(1783,1,-25200,1,'PDT'),(1783,2,-28800,0,'PST'),(1783,3,-25200,1,'PWT'),(1783,4,-25200,1,'PPT'),(1783,5,-28800,0,'PST'),(1784,0,45432,0,'LMT'),(1784,1,-40968,0,'LMT'),(1784,2,-39600,0,'SST'),(1785,0,0,0,'UTC'),(1786,0,0,0,'UTC'),(1787,0,9017,0,'LMT'),(1787,1,9017,0,'MMT'),(1787,2,12679,1,'MST'),(1787,3,9079,0,'MMT'),(1787,4,16279,1,'MDST'),(1787,5,14400,1,'MSD'),(1787,6,10800,0,'MSK'),(1787,7,14400,1,'MSD'),(1787,8,18000,1,'+05'),(1787,9,7200,0,'EET'),(1787,10,10800,0,'MSK'),(1787,11,14400,1,'MSD'),(1787,12,10800,1,'EEST'),(1787,13,7200,0,'EET'),(1787,14,14400,0,'MSK'),(1787,15,14400,1,'MSD'),(1787,16,10800,0,'MSK'),(1788,0,3600,1,'WEST'),(1788,1,0,0,'WET'),(1789,0,0,0,'UTC');
/*!40000 ALTER TABLE `time_zone_transition_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `user`
--

DROP TABLE IF EXISTS `user`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `user` (
  `Host` char(255) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL DEFAULT '',
  `User` char(32) COLLATE utf8mb3_bin NOT NULL DEFAULT '',
  `Select_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Insert_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Update_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Delete_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Create_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Drop_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Reload_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Shutdown_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Process_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `File_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Grant_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `References_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Index_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Alter_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Show_db_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Super_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Create_tmp_table_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Lock_tables_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Execute_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Repl_slave_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Repl_client_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Create_view_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Show_view_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Create_routine_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Alter_routine_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Create_user_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Event_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Trigger_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Create_tablespace_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `ssl_type` enum('','ANY','X509','SPECIFIED') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT '',
  `ssl_cipher` blob NOT NULL,
  `x509_issuer` blob NOT NULL,
  `x509_subject` blob NOT NULL,
  `max_questions` int unsigned NOT NULL DEFAULT '0',
  `max_updates` int unsigned NOT NULL DEFAULT '0',
  `max_connections` int unsigned NOT NULL DEFAULT '0',
  `max_user_connections` int unsigned NOT NULL DEFAULT '0',
  `plugin` char(64) COLLATE utf8mb3_bin NOT NULL DEFAULT 'caching_sha2_password',
  `authentication_string` text COLLATE utf8mb3_bin,
  `password_expired` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `password_last_changed` timestamp NULL DEFAULT NULL,
  `password_lifetime` smallint unsigned DEFAULT NULL,
  `account_locked` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Create_role_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Drop_role_priv` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT 'N',
  `Password_reuse_history` smallint unsigned DEFAULT NULL,
  `Password_reuse_time` smallint unsigned DEFAULT NULL,
  `Password_require_current` enum('N','Y') CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci DEFAULT NULL,
  `User_attributes` json DEFAULT NULL,
  PRIMARY KEY (`Host`,`User`)
) /*!50100 TABLESPACE `mysql` */ ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_bin STATS_PERSISTENT=0 ROW_FORMAT=DYNAMIC COMMENT='Users and global privileges';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `user`
--

LOCK TABLES `user` WRITE;
/*!40000 ALTER TABLE `user` DISABLE KEYS */;
INSERT INTO `user` VALUES ('%','root','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','','','','',0,0,0,0,'caching_sha2_password','$A$005${b&Ka(\n\'Z\Z!aoi.%CrShCqoN1sOJFvtkT6s3rR4W0wnswmgKcGn3.ISaBM7','N','2023-07-24 15:20:31',NULL,'N','Y','Y',NULL,NULL,NULL,NULL),('%','wordpress','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','','','','',0,0,0,0,'caching_sha2_password','$A$005$HMTiY&&Y\"-5)t,LlEYmKe1.Kl8HXuNCtysVvK7wRqkejbQPKDGcEPyGI2wu6','N','2023-07-24 15:20:32',NULL,'N','N','N',NULL,NULL,NULL,NULL),('localhost','mysql.infoschema','Y','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','','','','',0,0,0,0,'caching_sha2_password','$A$005$THISISACOMBINATIONOFINVALIDSALTANDPASSWORDTHATMUSTNEVERBRBEUSED','N','2023-07-24 15:20:00',NULL,'Y','N','N',NULL,NULL,NULL,NULL),('localhost','mysql.session','N','N','N','N','N','N','N','Y','N','N','N','N','N','N','N','Y','N','N','N','N','N','N','N','N','N','N','N','N','N','','','','',0,0,0,0,'caching_sha2_password','$A$005$THISISACOMBINATIONOFINVALIDSALTANDPASSWORDTHATMUSTNEVERBRBEUSED','N','2023-07-24 15:19:59',NULL,'Y','N','N',NULL,NULL,NULL,NULL),('localhost','mysql.sys','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','','','','',0,0,0,0,'caching_sha2_password','$A$005$THISISACOMBINATIONOFINVALIDSALTANDPASSWORDTHATMUSTNEVERBRBEUSED','N','2023-07-24 15:20:00',NULL,'Y','N','N',NULL,NULL,NULL,NULL),('localhost','root','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','','','','',0,0,0,0,'caching_sha2_password','$A$005$4 (}p8*.mEL67{ _\Z.Lyn6R/vtAaYGjyW0teZ/2JGm4hKWlCYrJHcw5v5Upw9','N','2023-07-24 15:20:31',NULL,'N','Y','Y',NULL,NULL,NULL,NULL);
/*!40000 ALTER TABLE `user` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `general_log`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `general_log` (
  `event_time` timestamp(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6) ON UPDATE CURRENT_TIMESTAMP(6),
  `user_host` mediumtext NOT NULL,
  `thread_id` bigint unsigned NOT NULL,
  `server_id` int unsigned NOT NULL,
  `command_type` varchar(64) NOT NULL,
  `argument` mediumblob NOT NULL
) ENGINE=CSV DEFAULT CHARSET=utf8mb3 COMMENT='General log';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `slow_log`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `slow_log` (
  `start_time` timestamp(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6) ON UPDATE CURRENT_TIMESTAMP(6),
  `user_host` mediumtext NOT NULL,
  `query_time` time(6) NOT NULL,
  `lock_time` time(6) NOT NULL,
  `rows_sent` int NOT NULL,
  `rows_examined` int NOT NULL,
  `db` varchar(512) NOT NULL,
  `last_insert_id` int NOT NULL,
  `insert_id` int NOT NULL,
  `server_id` int unsigned NOT NULL,
  `sql_text` mediumblob NOT NULL,
  `thread_id` bigint unsigned NOT NULL
) ENGINE=CSV DEFAULT CHARSET=utf8mb3 COMMENT='Slow log';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Current Database: `wordpress`
--

CREATE DATABASE /*!32312 IF NOT EXISTS*/ `wordpress` /*!40100 DEFAULT CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci */ /*!80016 DEFAULT ENCRYPTION='N' */;

USE `wordpress`;

--
-- Table structure for table `wp_commentmeta`
--

DROP TABLE IF EXISTS `wp_commentmeta`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `wp_commentmeta` (
  `meta_id` bigint unsigned NOT NULL AUTO_INCREMENT,
  `comment_id` bigint unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`meta_id`),
  KEY `comment_id` (`comment_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `wp_commentmeta`
--

LOCK TABLES `wp_commentmeta` WRITE;
/*!40000 ALTER TABLE `wp_commentmeta` DISABLE KEYS */;
/*!40000 ALTER TABLE `wp_commentmeta` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `wp_comments`
--

DROP TABLE IF EXISTS `wp_comments`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `wp_comments` (
  `comment_ID` bigint unsigned NOT NULL AUTO_INCREMENT,
  `comment_post_ID` bigint unsigned NOT NULL DEFAULT '0',
  `comment_author` tinytext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `comment_author_email` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_author_url` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_author_IP` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_content` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `comment_karma` int NOT NULL DEFAULT '0',
  `comment_approved` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '1',
  `comment_agent` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_type` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'comment',
  `comment_parent` bigint unsigned NOT NULL DEFAULT '0',
  `user_id` bigint unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`comment_ID`),
  KEY `comment_post_ID` (`comment_post_ID`),
  KEY `comment_approved_date_gmt` (`comment_approved`,`comment_date_gmt`),
  KEY `comment_date_gmt` (`comment_date_gmt`),
  KEY `comment_parent` (`comment_parent`),
  KEY `comment_author_email` (`comment_author_email`(10))
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `wp_comments`
--

LOCK TABLES `wp_comments` WRITE;
/*!40000 ALTER TABLE `wp_comments` DISABLE KEYS */;
INSERT INTO `wp_comments` VALUES (1,1,'A WordPress Commenter','wapuu@wordpress.example','https://wordpress.org/','','2023-07-24 15:22:13','2023-07-24 15:22:13','Hi, this is a comment.\nTo get started with moderating, editing, and deleting comments, please visit the Comments screen in the dashboard.\nCommenter avatars come from <a href=\"https://en.gravatar.com/\">Gravatar</a>.',0,'1','','comment',0,0);
/*!40000 ALTER TABLE `wp_comments` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `wp_links`
--

DROP TABLE IF EXISTS `wp_links`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `wp_links` (
  `link_id` bigint unsigned NOT NULL AUTO_INCREMENT,
  `link_url` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_name` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_image` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_target` varchar(25) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_description` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_visible` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'Y',
  `link_owner` bigint unsigned NOT NULL DEFAULT '1',
  `link_rating` int NOT NULL DEFAULT '0',
  `link_updated` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `link_rel` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_notes` mediumtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `link_rss` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`link_id`),
  KEY `link_visible` (`link_visible`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `wp_links`
--

LOCK TABLES `wp_links` WRITE;
/*!40000 ALTER TABLE `wp_links` DISABLE KEYS */;
/*!40000 ALTER TABLE `wp_links` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `wp_options`
--

DROP TABLE IF EXISTS `wp_options`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `wp_options` (
  `option_id` bigint unsigned NOT NULL AUTO_INCREMENT,
  `option_name` varchar(191) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `option_value` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `autoload` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'yes',
  PRIMARY KEY (`option_id`),
  UNIQUE KEY `option_name` (`option_name`),
  KEY `autoload` (`autoload`)
) ENGINE=InnoDB AUTO_INCREMENT=134 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `wp_options`
--

LOCK TABLES `wp_options` WRITE;
/*!40000 ALTER TABLE `wp_options` DISABLE KEYS */;
INSERT INTO `wp_options` VALUES (1,'siteurl','http://10.10.16.63','yes'),(2,'home','http://10.10.16.63','yes'),(3,'blogname','Test','yes'),(4,'blogdescription','','yes'),(5,'users_can_register','0','yes'),(6,'admin_email','test@mail.com','yes'),(7,'start_of_week','1','yes'),(8,'use_balanceTags','0','yes'),(9,'use_smilies','1','yes'),(10,'require_name_email','1','yes'),(11,'comments_notify','1','yes'),(12,'posts_per_rss','10','yes'),(13,'rss_use_excerpt','0','yes'),(14,'mailserver_url','mail.example.com','yes'),(15,'mailserver_login','login@example.com','yes'),(16,'mailserver_pass','password','yes'),(17,'mailserver_port','110','yes'),(18,'default_category','1','yes'),(19,'default_comment_status','open','yes'),(20,'default_ping_status','open','yes'),(21,'default_pingback_flag','1','yes'),(22,'posts_per_page','10','yes'),(23,'date_format','F j, Y','yes'),(24,'time_format','g:i a','yes'),(25,'links_updated_date_format','F j, Y g:i a','yes'),(26,'comment_moderation','0','yes'),(27,'moderation_notify','1','yes'),(28,'permalink_structure','/%year%/%monthnum%/%day%/%postname%/','yes'),(29,'rewrite_rules','a:81:{s:11:\"^wp-json/?$\";s:22:\"index.php?rest_route=/\";s:14:\"^wp-json/(.*)?\";s:33:\"index.php?rest_route=/$matches[1]\";s:21:\"^index.php/wp-json/?$\";s:22:\"index.php?rest_route=/\";s:24:\"^index.php/wp-json/(.*)?\";s:33:\"index.php?rest_route=/$matches[1]\";s:17:\"^wp-sitemap\\.xml$\";s:23:\"index.php?sitemap=index\";s:17:\"^wp-sitemap\\.xsl$\";s:36:\"index.php?sitemap-stylesheet=sitemap\";s:23:\"^wp-sitemap-index\\.xsl$\";s:34:\"index.php?sitemap-stylesheet=index\";s:48:\"^wp-sitemap-([a-z]+?)-([a-z\\d_-]+?)-(\\d+?)\\.xml$\";s:75:\"index.php?sitemap=$matches[1]&sitemap-subtype=$matches[2]&paged=$matches[3]\";s:34:\"^wp-sitemap-([a-z]+?)-(\\d+?)\\.xml$\";s:47:\"index.php?sitemap=$matches[1]&paged=$matches[2]\";s:12:\"robots\\.txt$\";s:18:\"index.php?robots=1\";s:13:\"favicon\\.ico$\";s:19:\"index.php?favicon=1\";s:48:\".*wp-(atom|rdf|rss|rss2|feed|commentsrss2)\\.php$\";s:18:\"index.php?feed=old\";s:20:\".*wp-app\\.php(/.*)?$\";s:19:\"index.php?error=403\";s:18:\".*wp-register.php$\";s:23:\"index.php?register=true\";s:32:\"feed/(feed|rdf|rss|rss2|atom)/?$\";s:27:\"index.php?&feed=$matches[1]\";s:27:\"(feed|rdf|rss|rss2|atom)/?$\";s:27:\"index.php?&feed=$matches[1]\";s:8:\"embed/?$\";s:21:\"index.php?&embed=true\";s:20:\"page/?([0-9]{1,})/?$\";s:28:\"index.php?&paged=$matches[1]\";s:41:\"comments/feed/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?&feed=$matches[1]&withcomments=1\";s:36:\"comments/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?&feed=$matches[1]&withcomments=1\";s:17:\"comments/embed/?$\";s:21:\"index.php?&embed=true\";s:44:\"search/(.+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:40:\"index.php?s=$matches[1]&feed=$matches[2]\";s:39:\"search/(.+)/(feed|rdf|rss|rss2|atom)/?$\";s:40:\"index.php?s=$matches[1]&feed=$matches[2]\";s:20:\"search/(.+)/embed/?$\";s:34:\"index.php?s=$matches[1]&embed=true\";s:32:\"search/(.+)/page/?([0-9]{1,})/?$\";s:41:\"index.php?s=$matches[1]&paged=$matches[2]\";s:14:\"search/(.+)/?$\";s:23:\"index.php?s=$matches[1]\";s:47:\"author/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?author_name=$matches[1]&feed=$matches[2]\";s:42:\"author/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?author_name=$matches[1]&feed=$matches[2]\";s:23:\"author/([^/]+)/embed/?$\";s:44:\"index.php?author_name=$matches[1]&embed=true\";s:35:\"author/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?author_name=$matches[1]&paged=$matches[2]\";s:17:\"author/([^/]+)/?$\";s:33:\"index.php?author_name=$matches[1]\";s:69:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:80:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&feed=$matches[4]\";s:64:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/(feed|rdf|rss|rss2|atom)/?$\";s:80:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&feed=$matches[4]\";s:45:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/embed/?$\";s:74:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&embed=true\";s:57:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/page/?([0-9]{1,})/?$\";s:81:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&paged=$matches[4]\";s:39:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/?$\";s:63:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]\";s:56:\"([0-9]{4})/([0-9]{1,2})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:64:\"index.php?year=$matches[1]&monthnum=$matches[2]&feed=$matches[3]\";s:51:\"([0-9]{4})/([0-9]{1,2})/(feed|rdf|rss|rss2|atom)/?$\";s:64:\"index.php?year=$matches[1]&monthnum=$matches[2]&feed=$matches[3]\";s:32:\"([0-9]{4})/([0-9]{1,2})/embed/?$\";s:58:\"index.php?year=$matches[1]&monthnum=$matches[2]&embed=true\";s:44:\"([0-9]{4})/([0-9]{1,2})/page/?([0-9]{1,})/?$\";s:65:\"index.php?year=$matches[1]&monthnum=$matches[2]&paged=$matches[3]\";s:26:\"([0-9]{4})/([0-9]{1,2})/?$\";s:47:\"index.php?year=$matches[1]&monthnum=$matches[2]\";s:43:\"([0-9]{4})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?year=$matches[1]&feed=$matches[2]\";s:38:\"([0-9]{4})/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?year=$matches[1]&feed=$matches[2]\";s:19:\"([0-9]{4})/embed/?$\";s:37:\"index.php?year=$matches[1]&embed=true\";s:31:\"([0-9]{4})/page/?([0-9]{1,})/?$\";s:44:\"index.php?year=$matches[1]&paged=$matches[2]\";s:13:\"([0-9]{4})/?$\";s:26:\"index.php?year=$matches[1]\";s:58:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:68:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:88:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:83:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:83:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:64:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:53:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/embed/?$\";s:91:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&embed=true\";s:57:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/trackback/?$\";s:85:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&tb=1\";s:77:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:97:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&feed=$matches[5]\";s:72:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:97:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&feed=$matches[5]\";s:65:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/page/?([0-9]{1,})/?$\";s:98:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&paged=$matches[5]\";s:72:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/comment-page-([0-9]{1,})/?$\";s:98:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&cpage=$matches[5]\";s:61:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)(?:/([0-9]+))?/?$\";s:97:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&page=$matches[5]\";s:47:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:57:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:77:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:72:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:72:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:53:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:64:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/comment-page-([0-9]{1,})/?$\";s:81:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&cpage=$matches[4]\";s:51:\"([0-9]{4})/([0-9]{1,2})/comment-page-([0-9]{1,})/?$\";s:65:\"index.php?year=$matches[1]&monthnum=$matches[2]&cpage=$matches[3]\";s:38:\"([0-9]{4})/comment-page-([0-9]{1,})/?$\";s:44:\"index.php?year=$matches[1]&cpage=$matches[2]\";s:27:\".?.+?/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:37:\".?.+?/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:57:\".?.+?/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\".?.+?/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\".?.+?/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:33:\".?.+?/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:16:\"(.?.+?)/embed/?$\";s:41:\"index.php?pagename=$matches[1]&embed=true\";s:20:\"(.?.+?)/trackback/?$\";s:35:\"index.php?pagename=$matches[1]&tb=1\";s:40:\"(.?.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:35:\"(.?.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:28:\"(.?.+?)/page/?([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&paged=$matches[2]\";s:35:\"(.?.+?)/comment-page-([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&cpage=$matches[2]\";s:24:\"(.?.+?)(?:/([0-9]+))?/?$\";s:47:\"index.php?pagename=$matches[1]&page=$matches[2]\";}','yes'),(30,'hack_file','0','yes'),(31,'blog_charset','UTF-8','yes'),(32,'moderation_keys','','no'),(33,'active_plugins','a:0:{}','yes'),(34,'category_base','','yes'),(35,'ping_sites','http://rpc.pingomatic.com/','yes'),(36,'comment_max_links','2','yes'),(37,'gmt_offset','0','yes'),(38,'default_email_category','1','yes'),(39,'recently_edited','','no'),(40,'template','twentytwentythree','yes'),(41,'stylesheet','twentytwentythree','yes'),(42,'comment_registration','0','yes'),(43,'html_type','text/html','yes'),(44,'use_trackback','0','yes'),(45,'default_role','subscriber','yes'),(46,'db_version','53496','yes'),(47,'uploads_use_yearmonth_folders','1','yes'),(48,'upload_path','','yes'),(49,'blog_public','1','yes'),(50,'default_link_category','2','yes'),(51,'show_on_front','posts','yes'),(52,'tag_base','','yes'),(53,'show_avatars','1','yes'),(54,'avatar_rating','G','yes'),(55,'upload_url_path','','yes'),(56,'thumbnail_size_w','150','yes'),(57,'thumbnail_size_h','150','yes'),(58,'thumbnail_crop','1','yes'),(59,'medium_size_w','300','yes'),(60,'medium_size_h','300','yes'),(61,'avatar_default','mystery','yes'),(62,'large_size_w','1024','yes'),(63,'large_size_h','1024','yes'),(64,'image_default_link_type','none','yes'),(65,'image_default_size','','yes'),(66,'image_default_align','','yes'),(67,'close_comments_for_old_posts','0','yes'),(68,'close_comments_days_old','14','yes'),(69,'thread_comments','1','yes'),(70,'thread_comments_depth','5','yes'),(71,'page_comments','0','yes'),(72,'comments_per_page','50','yes'),(73,'default_comments_page','newest','yes'),(74,'comment_order','asc','yes'),(75,'sticky_posts','a:0:{}','yes'),(76,'widget_categories','a:0:{}','yes'),(77,'widget_text','a:0:{}','yes'),(78,'widget_rss','a:0:{}','yes'),(79,'uninstall_plugins','a:0:{}','no'),(80,'timezone_string','','yes'),(81,'page_for_posts','0','yes'),(82,'page_on_front','0','yes'),(83,'default_post_format','0','yes'),(84,'link_manager_enabled','0','yes'),(85,'finished_splitting_shared_terms','1','yes'),(86,'site_icon','0','yes'),(87,'medium_large_size_w','768','yes'),(88,'medium_large_size_h','0','yes'),(89,'wp_page_for_privacy_policy','3','yes'),(90,'show_comments_cookies_opt_in','1','yes'),(91,'admin_email_lifespan','1705764120','yes'),(92,'disallowed_keys','','no'),(93,'comment_previously_approved','1','yes'),(94,'auto_plugin_theme_update_emails','a:0:{}','no'),(95,'auto_update_core_dev','enabled','yes'),(96,'auto_update_core_minor','enabled','yes'),(97,'auto_update_core_major','enabled','yes'),(98,'wp_force_deactivated_plugins','a:0:{}','yes'),(99,'initial_db_version','53496','yes'),(100,'wp_user_roles','a:5:{s:13:\"administrator\";a:2:{s:4:\"name\";s:13:\"Administrator\";s:12:\"capabilities\";a:61:{s:13:\"switch_themes\";b:1;s:11:\"edit_themes\";b:1;s:16:\"activate_plugins\";b:1;s:12:\"edit_plugins\";b:1;s:10:\"edit_users\";b:1;s:10:\"edit_files\";b:1;s:14:\"manage_options\";b:1;s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:6:\"import\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:8:\"level_10\";b:1;s:7:\"level_9\";b:1;s:7:\"level_8\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;s:12:\"delete_users\";b:1;s:12:\"create_users\";b:1;s:17:\"unfiltered_upload\";b:1;s:14:\"edit_dashboard\";b:1;s:14:\"update_plugins\";b:1;s:14:\"delete_plugins\";b:1;s:15:\"install_plugins\";b:1;s:13:\"update_themes\";b:1;s:14:\"install_themes\";b:1;s:11:\"update_core\";b:1;s:10:\"list_users\";b:1;s:12:\"remove_users\";b:1;s:13:\"promote_users\";b:1;s:18:\"edit_theme_options\";b:1;s:13:\"delete_themes\";b:1;s:6:\"export\";b:1;}}s:6:\"editor\";a:2:{s:4:\"name\";s:6:\"Editor\";s:12:\"capabilities\";a:34:{s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;}}s:6:\"author\";a:2:{s:4:\"name\";s:6:\"Author\";s:12:\"capabilities\";a:10:{s:12:\"upload_files\";b:1;s:10:\"edit_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;s:22:\"delete_published_posts\";b:1;}}s:11:\"contributor\";a:2:{s:4:\"name\";s:11:\"Contributor\";s:12:\"capabilities\";a:5:{s:10:\"edit_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;}}s:10:\"subscriber\";a:2:{s:4:\"name\";s:10:\"Subscriber\";s:12:\"capabilities\";a:2:{s:4:\"read\";b:1;s:7:\"level_0\";b:1;}}}','yes'),(101,'cron','a:4:{i:1690215725;a:1:{s:34:\"wp_privacy_delete_old_export_files\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"hourly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:3600;}}}i:1690255325;a:4:{s:18:\"wp_https_detection\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:16:\"wp_version_check\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:17:\"wp_update_plugins\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:16:\"wp_update_themes\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1690298523;a:2:{s:30:\"wp_site_health_scheduled_check\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"weekly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:604800;}}s:32:\"recovery_mode_clean_expired_keys\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}s:7:\"version\";i:2;}','yes'),(102,'widget_pages','a:1:{s:12:\"_multiwidget\";i:1;}','yes'),(103,'widget_calendar','a:1:{s:12:\"_multiwidget\";i:1;}','yes'),(104,'widget_archives','a:1:{s:12:\"_multiwidget\";i:1;}','yes'),(105,'widget_media_audio','a:1:{s:12:\"_multiwidget\";i:1;}','yes'),(106,'widget_media_image','a:1:{s:12:\"_multiwidget\";i:1;}','yes'),(107,'widget_media_gallery','a:1:{s:12:\"_multiwidget\";i:1;}','yes'),(108,'widget_media_video','a:1:{s:12:\"_multiwidget\";i:1;}','yes'),(109,'widget_meta','a:1:{s:12:\"_multiwidget\";i:1;}','yes'),(110,'widget_search','a:1:{s:12:\"_multiwidget\";i:1;}','yes'),(111,'widget_recent-posts','a:1:{s:12:\"_multiwidget\";i:1;}','yes'),(112,'widget_recent-comments','a:1:{s:12:\"_multiwidget\";i:1;}','yes'),(113,'widget_tag_cloud','a:1:{s:12:\"_multiwidget\";i:1;}','yes'),(114,'widget_nav_menu','a:1:{s:12:\"_multiwidget\";i:1;}','yes'),(115,'widget_custom_html','a:1:{s:12:\"_multiwidget\";i:1;}','yes'),(116,'widget_block','a:6:{i:2;a:1:{s:7:\"content\";s:19:\"<!-- wp:search /-->\";}i:3;a:1:{s:7:\"content\";s:154:\"<!-- wp:group --><div class=\"wp-block-group\"><!-- wp:heading --><h2>Recent Posts</h2><!-- /wp:heading --><!-- wp:latest-posts /--></div><!-- /wp:group -->\";}i:4;a:1:{s:7:\"content\";s:227:\"<!-- wp:group --><div class=\"wp-block-group\"><!-- wp:heading --><h2>Recent Comments</h2><!-- /wp:heading --><!-- wp:latest-comments {\"displayAvatar\":false,\"displayDate\":false,\"displayExcerpt\":false} /--></div><!-- /wp:group -->\";}i:5;a:1:{s:7:\"content\";s:146:\"<!-- wp:group --><div class=\"wp-block-group\"><!-- wp:heading --><h2>Archives</h2><!-- /wp:heading --><!-- wp:archives /--></div><!-- /wp:group -->\";}i:6;a:1:{s:7:\"content\";s:150:\"<!-- wp:group --><div class=\"wp-block-group\"><!-- wp:heading --><h2>Categories</h2><!-- /wp:heading --><!-- wp:categories /--></div><!-- /wp:group -->\";}s:12:\"_multiwidget\";i:1;}','yes'),(118,'recovery_keys','a:0:{}','yes'),(119,'https_detection_errors','a:1:{s:20:\"https_request_failed\";a:1:{i:0;s:21:\"HTTPS request failed.\";}}','yes'),(120,'theme_mods_twentytwentythree','a:1:{s:18:\"custom_css_post_id\";i:-1;}','yes'),(124,'_site_transient_timeout_theme_roots','1690213928','no'),(125,'_site_transient_theme_roots','a:3:{s:15:\"twentytwentyone\";s:7:\"/themes\";s:17:\"twentytwentythree\";s:7:\"/themes\";s:15:\"twentytwentytwo\";s:7:\"/themes\";}','no'),(126,'_site_transient_update_themes','O:8:\"stdClass\":5:{s:12:\"last_checked\";i:1690212129;s:7:\"checked\";a:3:{s:15:\"twentytwentyone\";s:3:\"1.8\";s:17:\"twentytwentythree\";s:3:\"1.1\";s:15:\"twentytwentytwo\";s:3:\"1.4\";}s:8:\"response\";a:0:{}s:9:\"no_update\";a:3:{s:15:\"twentytwentyone\";a:6:{s:5:\"theme\";s:15:\"twentytwentyone\";s:11:\"new_version\";s:3:\"1.8\";s:3:\"url\";s:45:\"https://wordpress.org/themes/twentytwentyone/\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/theme/twentytwentyone.1.8.zip\";s:8:\"requires\";s:3:\"5.3\";s:12:\"requires_php\";s:3:\"5.6\";}s:17:\"twentytwentythree\";a:6:{s:5:\"theme\";s:17:\"twentytwentythree\";s:11:\"new_version\";s:3:\"1.1\";s:3:\"url\";s:47:\"https://wordpress.org/themes/twentytwentythree/\";s:7:\"package\";s:63:\"https://downloads.wordpress.org/theme/twentytwentythree.1.1.zip\";s:8:\"requires\";s:3:\"6.1\";s:12:\"requires_php\";s:3:\"5.6\";}s:15:\"twentytwentytwo\";a:6:{s:5:\"theme\";s:15:\"twentytwentytwo\";s:11:\"new_version\";s:3:\"1.4\";s:3:\"url\";s:45:\"https://wordpress.org/themes/twentytwentytwo/\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/theme/twentytwentytwo.1.4.zip\";s:8:\"requires\";s:3:\"5.9\";s:12:\"requires_php\";s:3:\"5.6\";}}s:12:\"translations\";a:0:{}}','no'),(128,'fresh_site','1','yes'),(129,'_site_transient_update_core','O:8:\"stdClass\":4:{s:7:\"updates\";a:1:{i:0;O:8:\"stdClass\":10:{s:8:\"response\";s:6:\"latest\";s:8:\"download\";s:59:\"https://downloads.wordpress.org/release/wordpress-6.2.2.zip\";s:6:\"locale\";s:5:\"en_US\";s:8:\"packages\";O:8:\"stdClass\":5:{s:4:\"full\";s:59:\"https://downloads.wordpress.org/release/wordpress-6.2.2.zip\";s:10:\"no_content\";s:70:\"https://downloads.wordpress.org/release/wordpress-6.2.2-no-content.zip\";s:11:\"new_bundled\";s:71:\"https://downloads.wordpress.org/release/wordpress-6.2.2-new-bundled.zip\";s:7:\"partial\";s:0:\"\";s:8:\"rollback\";s:0:\"\";}s:7:\"current\";s:5:\"6.2.2\";s:7:\"version\";s:5:\"6.2.2\";s:11:\"php_version\";s:6:\"5.6.20\";s:13:\"mysql_version\";s:3:\"5.0\";s:11:\"new_bundled\";s:3:\"6.1\";s:15:\"partial_version\";s:0:\"\";}}s:12:\"last_checked\";i:1690212132;s:15:\"version_checked\";s:5:\"6.2.2\";s:12:\"translations\";a:0:{}}','no'),(130,'_site_transient_update_plugins','O:8:\"stdClass\":5:{s:12:\"last_checked\";i:1690212133;s:8:\"response\";a:2:{s:19:\"akismet/akismet.php\";O:8:\"stdClass\":12:{s:2:\"id\";s:21:\"w.org/plugins/akismet\";s:4:\"slug\";s:7:\"akismet\";s:6:\"plugin\";s:19:\"akismet/akismet.php\";s:11:\"new_version\";s:3:\"5.2\";s:3:\"url\";s:38:\"https://wordpress.org/plugins/akismet/\";s:7:\"package\";s:54:\"https://downloads.wordpress.org/plugin/akismet.5.2.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:60:\"https://ps.w.org/akismet/assets/icon-256x256.png?rev=2818463\";s:2:\"1x\";s:60:\"https://ps.w.org/akismet/assets/icon-128x128.png?rev=2818463\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:63:\"https://ps.w.org/akismet/assets/banner-1544x500.png?rev=2900731\";s:2:\"1x\";s:62:\"https://ps.w.org/akismet/assets/banner-772x250.png?rev=2900731\";}s:11:\"banners_rtl\";a:0:{}s:8:\"requires\";s:3:\"5.8\";s:6:\"tested\";s:5:\"6.2.2\";s:12:\"requires_php\";s:6:\"5.6.20\";}s:36:\"contact-form-7/wp-contact-form-7.php\";O:8:\"stdClass\":12:{s:2:\"id\";s:28:\"w.org/plugins/contact-form-7\";s:4:\"slug\";s:14:\"contact-form-7\";s:6:\"plugin\";s:36:\"contact-form-7/wp-contact-form-7.php\";s:11:\"new_version\";s:5:\"5.7.7\";s:3:\"url\";s:45:\"https://wordpress.org/plugins/contact-form-7/\";s:7:\"package\";s:63:\"https://downloads.wordpress.org/plugin/contact-form-7.5.7.7.zip\";s:5:\"icons\";a:2:{s:2:\"1x\";s:59:\"https://ps.w.org/contact-form-7/assets/icon.svg?rev=2339255\";s:3:\"svg\";s:59:\"https://ps.w.org/contact-form-7/assets/icon.svg?rev=2339255\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:69:\"https://ps.w.org/contact-form-7/assets/banner-1544x500.png?rev=860901\";s:2:\"1x\";s:68:\"https://ps.w.org/contact-form-7/assets/banner-772x250.png?rev=880427\";}s:11:\"banners_rtl\";a:0:{}s:8:\"requires\";s:3:\"6.0\";s:6:\"tested\";s:5:\"6.2.2\";s:12:\"requires_php\";b:0;}}s:12:\"translations\";a:0:{}s:9:\"no_update\";a:1:{s:9:\"hello.php\";O:8:\"stdClass\":10:{s:2:\"id\";s:25:\"w.org/plugins/hello-dolly\";s:4:\"slug\";s:11:\"hello-dolly\";s:6:\"plugin\";s:9:\"hello.php\";s:11:\"new_version\";s:5:\"1.7.2\";s:3:\"url\";s:42:\"https://wordpress.org/plugins/hello-dolly/\";s:7:\"package\";s:60:\"https://downloads.wordpress.org/plugin/hello-dolly.1.7.2.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:64:\"https://ps.w.org/hello-dolly/assets/icon-256x256.jpg?rev=2052855\";s:2:\"1x\";s:64:\"https://ps.w.org/hello-dolly/assets/icon-128x128.jpg?rev=2052855\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:67:\"https://ps.w.org/hello-dolly/assets/banner-1544x500.jpg?rev=2645582\";s:2:\"1x\";s:66:\"https://ps.w.org/hello-dolly/assets/banner-772x250.jpg?rev=2052855\";}s:11:\"banners_rtl\";a:0:{}s:8:\"requires\";s:3:\"4.6\";}}s:7:\"checked\";a:3:{s:19:\"akismet/akismet.php\";s:3:\"5.1\";s:36:\"contact-form-7/wp-contact-form-7.php\";s:5:\"5.7.5\";s:9:\"hello.php\";s:5:\"1.7.2\";}}','no'),(131,'user_count','1','no'),(132,'auto_core_update_notified','a:4:{s:4:\"type\";s:7:\"success\";s:5:\"email\";s:13:\"test@mail.com\";s:7:\"version\";s:5:\"6.2.2\";s:9:\"timestamp\";i:1690212133;}','no'),(133,'sidebars_widgets','a:4:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:3:{i:0;s:7:\"block-2\";i:1;s:7:\"block-3\";i:2;s:7:\"block-4\";}s:9:\"sidebar-2\";a:2:{i:0;s:7:\"block-5\";i:1;s:7:\"block-6\";}s:13:\"array_version\";i:3;}','yes');
/*!40000 ALTER TABLE `wp_options` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `wp_postmeta`
--

DROP TABLE IF EXISTS `wp_postmeta`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `wp_postmeta` (
  `meta_id` bigint unsigned NOT NULL AUTO_INCREMENT,
  `post_id` bigint unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`meta_id`),
  KEY `post_id` (`post_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `wp_postmeta`
--

LOCK TABLES `wp_postmeta` WRITE;
/*!40000 ALTER TABLE `wp_postmeta` DISABLE KEYS */;
INSERT INTO `wp_postmeta` VALUES (1,2,'_wp_page_template','default'),(2,3,'_wp_page_template','default');
/*!40000 ALTER TABLE `wp_postmeta` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `wp_posts`
--

DROP TABLE IF EXISTS `wp_posts`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `wp_posts` (
  `ID` bigint unsigned NOT NULL AUTO_INCREMENT,
  `post_author` bigint unsigned NOT NULL DEFAULT '0',
  `post_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_title` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_excerpt` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_status` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'publish',
  `comment_status` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'open',
  `ping_status` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'open',
  `post_password` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `post_name` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `to_ping` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `pinged` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_modified_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content_filtered` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_parent` bigint unsigned NOT NULL DEFAULT '0',
  `guid` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `menu_order` int NOT NULL DEFAULT '0',
  `post_type` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'post',
  `post_mime_type` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_count` bigint NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`),
  KEY `post_name` (`post_name`(191)),
  KEY `type_status_date` (`post_type`,`post_status`,`post_date`,`ID`),
  KEY `post_parent` (`post_parent`),
  KEY `post_author` (`post_author`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `wp_posts`
--

LOCK TABLES `wp_posts` WRITE;
/*!40000 ALTER TABLE `wp_posts` DISABLE KEYS */;
INSERT INTO `wp_posts` VALUES (1,1,'2023-07-24 15:22:13','2023-07-24 15:22:13','<!-- wp:paragraph -->\n<p>Welcome to WordPress. This is your first post. Edit or delete it, then start writing!</p>\n<!-- /wp:paragraph -->','Hello world!','','publish','open','open','','hello-world','','','2023-07-24 15:22:13','2023-07-24 15:22:13','',0,'http://10.10.16.63/?p=1',0,'post','',1),(2,1,'2023-07-24 15:22:13','2023-07-24 15:22:13','<!-- wp:paragraph -->\n<p>This is an example page. It\'s different from a blog post because it will stay in one place and will show up in your site navigation (in most themes). Most people start with an About page that introduces them to potential site visitors. It might say something like this:</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:quote -->\n<blockquote class=\"wp-block-quote\"><p>Hi there! I\'m a bike messenger by day, aspiring actor by night, and this is my website. I live in Los Angeles, have a great dog named Jack, and I like pi&#241;a coladas. (And gettin\' caught in the rain.)</p></blockquote>\n<!-- /wp:quote -->\n\n<!-- wp:paragraph -->\n<p>...or something like this:</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:quote -->\n<blockquote class=\"wp-block-quote\"><p>The XYZ Doohickey Company was founded in 1971, and has been providing quality doohickeys to the public ever since. Located in Gotham City, XYZ employs over 2,000 people and does all kinds of awesome things for the Gotham community.</p></blockquote>\n<!-- /wp:quote -->\n\n<!-- wp:paragraph -->\n<p>As a new WordPress user, you should go to <a href=\"http://10.10.16.63/wp-admin/\">your dashboard</a> to delete this page and create new pages for your content. Have fun!</p>\n<!-- /wp:paragraph -->','Sample Page','','publish','closed','open','','sample-page','','','2023-07-24 15:22:13','2023-07-24 15:22:13','',0,'http://10.10.16.63/?page_id=2',0,'page','',0),(3,1,'2023-07-24 15:22:13','2023-07-24 15:22:13','<!-- wp:heading --><h2>Who we are</h2><!-- /wp:heading --><!-- wp:paragraph --><p><strong class=\"privacy-policy-tutorial\">Suggested text: </strong>Our website address is: http://10.10.16.63.</p><!-- /wp:paragraph --><!-- wp:heading --><h2>Comments</h2><!-- /wp:heading --><!-- wp:paragraph --><p><strong class=\"privacy-policy-tutorial\">Suggested text: </strong>When visitors leave comments on the site we collect the data shown in the comments form, and also the visitor&#8217;s IP address and browser user agent string to help spam detection.</p><!-- /wp:paragraph --><!-- wp:paragraph --><p>An anonymized string created from your email address (also called a hash) may be provided to the Gravatar service to see if you are using it. The Gravatar service privacy policy is available here: https://automattic.com/privacy/. After approval of your comment, your profile picture is visible to the public in the context of your comment.</p><!-- /wp:paragraph --><!-- wp:heading --><h2>Media</h2><!-- /wp:heading --><!-- wp:paragraph --><p><strong class=\"privacy-policy-tutorial\">Suggested text: </strong>If you upload images to the website, you should avoid uploading images with embedded location data (EXIF GPS) included. Visitors to the website can download and extract any location data from images on the website.</p><!-- /wp:paragraph --><!-- wp:heading --><h2>Cookies</h2><!-- /wp:heading --><!-- wp:paragraph --><p><strong class=\"privacy-policy-tutorial\">Suggested text: </strong>If you leave a comment on our site you may opt-in to saving your name, email address and website in cookies. These are for your convenience so that you do not have to fill in your details again when you leave another comment. These cookies will last for one year.</p><!-- /wp:paragraph --><!-- wp:paragraph --><p>If you visit our login page, we will set a temporary cookie to determine if your browser accepts cookies. This cookie contains no personal data and is discarded when you close your browser.</p><!-- /wp:paragraph --><!-- wp:paragraph --><p>When you log in, we will also set up several cookies to save your login information and your screen display choices. Login cookies last for two days, and screen options cookies last for a year. If you select &quot;Remember Me&quot;, your login will persist for two weeks. If you log out of your account, the login cookies will be removed.</p><!-- /wp:paragraph --><!-- wp:paragraph --><p>If you edit or publish an article, an additional cookie will be saved in your browser. This cookie includes no personal data and simply indicates the post ID of the article you just edited. It expires after 1 day.</p><!-- /wp:paragraph --><!-- wp:heading --><h2>Embedded content from other websites</h2><!-- /wp:heading --><!-- wp:paragraph --><p><strong class=\"privacy-policy-tutorial\">Suggested text: </strong>Articles on this site may include embedded content (e.g. videos, images, articles, etc.). Embedded content from other websites behaves in the exact same way as if the visitor has visited the other website.</p><!-- /wp:paragraph --><!-- wp:paragraph --><p>These websites may collect data about you, use cookies, embed additional third-party tracking, and monitor your interaction with that embedded content, including tracking your interaction with the embedded content if you have an account and are logged in to that website.</p><!-- /wp:paragraph --><!-- wp:heading --><h2>Who we share your data with</h2><!-- /wp:heading --><!-- wp:paragraph --><p><strong class=\"privacy-policy-tutorial\">Suggested text: </strong>If you request a password reset, your IP address will be included in the reset email.</p><!-- /wp:paragraph --><!-- wp:heading --><h2>How long we retain your data</h2><!-- /wp:heading --><!-- wp:paragraph --><p><strong class=\"privacy-policy-tutorial\">Suggested text: </strong>If you leave a comment, the comment and its metadata are retained indefinitely. This is so we can recognize and approve any follow-up comments automatically instead of holding them in a moderation queue.</p><!-- /wp:paragraph --><!-- wp:paragraph --><p>For users that register on our website (if any), we also store the personal information they provide in their user profile. All users can see, edit, or delete their personal information at any time (except they cannot change their username). Website administrators can also see and edit that information.</p><!-- /wp:paragraph --><!-- wp:heading --><h2>What rights you have over your data</h2><!-- /wp:heading --><!-- wp:paragraph --><p><strong class=\"privacy-policy-tutorial\">Suggested text: </strong>If you have an account on this site, or have left comments, you can request to receive an exported file of the personal data we hold about you, including any data you have provided to us. You can also request that we erase any personal data we hold about you. This does not include any data we are obliged to keep for administrative, legal, or security purposes.</p><!-- /wp:paragraph --><!-- wp:heading --><h2>Where your data is sent</h2><!-- /wp:heading --><!-- wp:paragraph --><p><strong class=\"privacy-policy-tutorial\">Suggested text: </strong>Visitor comments may be checked through an automated spam detection service.</p><!-- /wp:paragraph -->','Privacy Policy','','draft','closed','open','','privacy-policy','','','2023-07-24 15:22:13','2023-07-24 15:22:13','',0,'http://10.10.16.63/?page_id=3',0,'page','',0);
/*!40000 ALTER TABLE `wp_posts` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `wp_term_relationships`
--

DROP TABLE IF EXISTS `wp_term_relationships`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `wp_term_relationships` (
  `object_id` bigint unsigned NOT NULL DEFAULT '0',
  `term_taxonomy_id` bigint unsigned NOT NULL DEFAULT '0',
  `term_order` int NOT NULL DEFAULT '0',
  PRIMARY KEY (`object_id`,`term_taxonomy_id`),
  KEY `term_taxonomy_id` (`term_taxonomy_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `wp_term_relationships`
--

LOCK TABLES `wp_term_relationships` WRITE;
/*!40000 ALTER TABLE `wp_term_relationships` DISABLE KEYS */;
INSERT INTO `wp_term_relationships` VALUES (1,1,0);
/*!40000 ALTER TABLE `wp_term_relationships` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `wp_term_taxonomy`
--

DROP TABLE IF EXISTS `wp_term_taxonomy`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `wp_term_taxonomy` (
  `term_taxonomy_id` bigint unsigned NOT NULL AUTO_INCREMENT,
  `term_id` bigint unsigned NOT NULL DEFAULT '0',
  `taxonomy` varchar(32) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `description` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `parent` bigint unsigned NOT NULL DEFAULT '0',
  `count` bigint NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_taxonomy_id`),
  UNIQUE KEY `term_id_taxonomy` (`term_id`,`taxonomy`),
  KEY `taxonomy` (`taxonomy`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `wp_term_taxonomy`
--

LOCK TABLES `wp_term_taxonomy` WRITE;
/*!40000 ALTER TABLE `wp_term_taxonomy` DISABLE KEYS */;
INSERT INTO `wp_term_taxonomy` VALUES (1,1,'category','',0,1);
/*!40000 ALTER TABLE `wp_term_taxonomy` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `wp_termmeta`
--

DROP TABLE IF EXISTS `wp_termmeta`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `wp_termmeta` (
  `meta_id` bigint unsigned NOT NULL AUTO_INCREMENT,
  `term_id` bigint unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`meta_id`),
  KEY `term_id` (`term_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `wp_termmeta`
--

LOCK TABLES `wp_termmeta` WRITE;
/*!40000 ALTER TABLE `wp_termmeta` DISABLE KEYS */;
/*!40000 ALTER TABLE `wp_termmeta` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `wp_terms`
--

DROP TABLE IF EXISTS `wp_terms`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `wp_terms` (
  `term_id` bigint unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `slug` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `term_group` bigint NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_id`),
  KEY `slug` (`slug`(191)),
  KEY `name` (`name`(191))
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `wp_terms`
--

LOCK TABLES `wp_terms` WRITE;
/*!40000 ALTER TABLE `wp_terms` DISABLE KEYS */;
INSERT INTO `wp_terms` VALUES (1,'Uncategorized','uncategorized',0);
/*!40000 ALTER TABLE `wp_terms` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `wp_usermeta`
--

DROP TABLE IF EXISTS `wp_usermeta`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `wp_usermeta` (
  `umeta_id` bigint unsigned NOT NULL AUTO_INCREMENT,
  `user_id` bigint unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`umeta_id`),
  KEY `user_id` (`user_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB AUTO_INCREMENT=16 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `wp_usermeta`
--

LOCK TABLES `wp_usermeta` WRITE;
/*!40000 ALTER TABLE `wp_usermeta` DISABLE KEYS */;
INSERT INTO `wp_usermeta` VALUES (1,1,'nickname','wordpress'),(2,1,'first_name',''),(3,1,'last_name',''),(4,1,'description',''),(5,1,'rich_editing','true'),(6,1,'syntax_highlighting','true'),(7,1,'comment_shortcuts','false'),(8,1,'admin_color','fresh'),(9,1,'use_ssl','0'),(10,1,'show_admin_bar_front','true'),(11,1,'locale',''),(12,1,'wp_capabilities','a:1:{s:13:\"administrator\";b:1;}'),(13,1,'wp_user_level','10'),(14,1,'dismissed_wp_pointers',''),(15,1,'show_welcome_panel','1');
/*!40000 ALTER TABLE `wp_usermeta` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `wp_users`
--

DROP TABLE IF EXISTS `wp_users`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `wp_users` (
  `ID` bigint unsigned NOT NULL AUTO_INCREMENT,
  `user_login` varchar(60) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_pass` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_nicename` varchar(50) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_email` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_url` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_registered` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `user_activation_key` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_status` int NOT NULL DEFAULT '0',
  `display_name` varchar(250) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`),
  KEY `user_login_key` (`user_login`),
  KEY `user_nicename` (`user_nicename`),
  KEY `user_email` (`user_email`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `wp_users`
--

LOCK TABLES `wp_users` WRITE;
/*!40000 ALTER TABLE `wp_users` DISABLE KEYS */;
INSERT INTO `wp_users` VALUES (1,'wordpress','$P$BhNbRqABkd0kMlLHYF4eRgOPYh0BNG.','wordpress','test@mail.com','http://10.10.16.63','2023-07-24 15:22:11','',0,'wordpress');
/*!40000 ALTER TABLE `wp_users` ENABLE KEYS */;
UNLOCK TABLES;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;
/*!50606 SET GLOBAL INNODB_STATS_AUTO_RECALC=@OLD_INNODB_STATS_AUTO_RECALC */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2023-07-24 15:33:53
